"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.userHome = exports.commandsOffered = void 0;

/*
 * Copyright 2019 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
/**
 * Render the commands provided by a given plugin
 *
 * @param {string} [plugin] enumerate the commands offered by the
 * given plugin
 */


const commandsOffered = plugin => __awaiter(void 0, void 0, void 0, function* () {
  const commandsOffered = yield Promise.resolve().then(() => require('../plugins/commands'));
  return commandsOffered.default(plugin);
});
/**
 * Home for user-installed plugins
 *
 */


exports.commandsOffered = commandsOffered;

const userHome = () => __awaiter(void 0, void 0, void 0, function* () {
  const {
    userInstalledHome
  } = yield Promise.resolve().then(() => require('../plugins/plugins'));
  return userInstalledHome();
});

exports.userHome = userHome;