"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RevertFileButton;

var _react = _interopRequireDefault(require("react"));

var _core = require("@kui-shell/core");

var _Icons = _interopRequireDefault(require("../../spi/Icons"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Copyright 2020 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

const strings = (0, _core.i18n)('plugin-client-common', 'editor');
/**
 * Offer a Revert button
 *
 */

function RevertFileButton(editor, repl, response, onRevert) {
  return {
    mode: 'Revert',
    kind: 'view',
    label: strings('revert'),
    icon: _react.default.createElement(_Icons.default, {
      icon: "Revert"
    }),
    command: () => __awaiter(this, void 0, void 0, function* () {
      try {
        const stats = (yield repl.rexec(`vfs fstat ${repl.encodeComponent(response.spec.fullpath)} --with-data --enoent-ok`)).content;
        onRevert(true, stats.data);
      } catch (err) {
        onRevert(false);
      }
    })
  };
}