"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactCore = require("@patternfly/react-core");

var _needsMultiLine = _interopRequireDefault(require("./needs-multi-line"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Copyright 2020 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class PatternFlyCodeSnippet extends _react.default.PureComponent {
  render() {
    return _react.default.createElement(_reactCore.ClipboardCopy, {
      isReadOnly: true,
      isCode: true,
      isExpanded: this.props.value && (0, _needsMultiLine.default)(this.props.value),
      variant: _reactCore.ClipboardCopyVariant.expansion,
      onCopy: this.props.onCopy
    }, this.props.value);
  }

}

exports.default = PatternFlyCodeSnippet;