"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _flags = _interopRequireDefault(require("./flags"));

var _exec = require("./exec");

var _help = require("../../lib/util/help");

var _get = require("./get");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Copyright 2019 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

const verb = 'top';
/**
 * This is the main handler for `kubectl top`.
 *
 */

const doTop = command => function _doTop(args) {
  return __awaiter(this, void 0, void 0, function* () {
    if ((0, _help.isUsage)(args)) {
      return (0, _help.doHelp)(command, args);
    } else {
      // first, we do the raw exec of the given command
      const response = yield (0, _exec.exec)(args);
      return (0, _get.doGetAsTable)(command, args, response, verb);
    }
  });
};

var _default = commandTree => {
  commandTree.listen(`/kubectl/${verb}/node`, doTop('kubectl'), _flags.default);
  commandTree.listen(`/k/${verb}/node`, doTop('k'), _flags.default);
  commandTree.listen(`/kubectl/${verb}/pod`, doTop('kubectl'), _flags.default);
  commandTree.listen(`/k/${verb}/pod`, doTop('k'), _flags.default);
};

exports.default = _default;