"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SecretSummary;

var _Generic = require("./Generic");

/*
 * Copyright 2021 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Name: all-icr-io
 * Type: kubernetes.io/dockerconfigjson
 * Data: '1'
 * Age: 245d
 *
 */
function SecretSummary(secret) {
  const {
    metadata,
    type: Type,
    data: Data
  } = secret;
  return {
    Name: metadata.name,
    Type,
    Age: (0, _Generic.age)(secret),
    Data
  };
}