"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = open;
exports.filters = void 0;

var _notebooks = require("./notebooks");

/*
 * Copyright 2020 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

const filters = [{
  name: 'Kui snapshot',
  extensions: ['kui', 'json']
}];
/**
 * Open a file and replay its session.
 *
 */

exports.filters = filters;

function open(createWindow) {
  return __awaiter(this, void 0, void 0, function* () {
    const {
      app,
      dialog
    } = yield Promise.resolve().then(() => require('electron'));
    const resp = yield dialog.showOpenDialog({
      title: 'Select a Kui snapshot',
      filters
    });

    if (!resp.canceled) {
      resp.filePaths.forEach(filepath => {
        app.addRecentDocument(filepath);
        (0, _notebooks.replay)(filepath, createWindow);
      });
    }
  });
}