"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isXtermResponse = isXtermResponse;
exports.isXtermErrorResponse = isXtermErrorResponse;

/*
 * Copyright 2020 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function isXtermResponse(entity) {
  const response = entity;
  return response.apiVersion === 'kui-shell/v1' && response.kind === 'XtermResponse';
}

function isXtermErrorResponse(entity) {
  return isXtermResponse(entity) && entity.code !== undefined && entity.code !== 0;
}