"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.registerCapability = void 0;

var _debug = _interopRequireDefault(require("debug"));

var _core = require("@kui-shell/core");

var _tabState = _interopRequireDefault(require("./tab-state"));

var _catchall = require("./lib/cmds/catchall");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Copyright 2019 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

const debug = (0, _debug.default)('plugins/bash-like/preload');
debug('loading');

const registerCapability = registrar => __awaiter(void 0, void 0, void 0, function* () {
  if ((0, _core.inBrowser)()) {
    yield Promise.resolve().then(() => require('./pty/session')).then(({
      init
    }) => init(registrar));
  } else if (!(0, _core.isHeadless)() || (0, _core.inProxy)()) {
    try {
      const prefetchShellState = (yield Promise.resolve().then(() => require('./pty/prefetch'))).default;
      yield prefetchShellState();
      debug('done with state prefetch');
    } catch (err) {
      console.error('error in state prefetch', err);
    }
  }
});
/**
 * This is the module
 *
 */


exports.registerCapability = registerCapability;

var _default = registrar => __awaiter(void 0, void 0, void 0, function* () {
  (0, _tabState.default)();
  return (0, _catchall.preload)(registrar);
});

exports.default = _default;
debug('finished loading');