"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DirectReplEval = void 0;

/*
 * Copyright 2017 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Directly apply the given evaluator to the given arguments. This is
 * the default evaluator implementation.
 *
 */
class DirectReplEval {
  constructor() {
    this.name = 'DirectReplEval';
  }

  apply(commandUntrimmed, execOptions, evaluator, args) {
    return evaluator.eval(args);
  }

}

exports.DirectReplEval = DirectReplEval;