"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _carbonComponents = require("carbon-components");

var _iconsReact = require("@carbon/icons-react");

var _toggleClass = _interopRequireDefault(require("../../tools/toggleClass"));

var _Button = _interopRequireDefault(require("../Button"));

var _ButtonSet = _interopRequireDefault(require("../ButtonSet"));

var _deprecate = _interopRequireDefault(require("../../prop-types/deprecate"));

var _requiredIfGivenPropIsTruthy = _interopRequireDefault(require("../../prop-types/requiredIfGivenPropIsTruthy"));

var _wrapFocus = _interopRequireWildcard(require("../../internal/wrapFocus"));

var _setupGetInstanceId = _interopRequireDefault(require("../../tools/setupGetInstanceId"));

var _defineProperty2;

var _excluded = ["modalHeading", "modalLabel", "modalAriaLabel", "passiveModal", "hasForm", "secondaryButtonText", "primaryButtonText", "open", "onRequestClose", "onRequestSubmit", "onSecondarySubmit", "iconDescription", "primaryButtonDisabled", "danger", "alert", "secondaryButtons", "selectorPrimaryFocus", "selectorsFloatingMenus", "shouldSubmitOnEnter", "size", "hasScrollingContent", "closeButtonLabel", "preventCloseOnClickOutside"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _carbonComponents.settings.prefix;
var getInstanceId = (0, _setupGetInstanceId.default)();

var Modal = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Modal, _Component);

  var _super = _createSuper(Modal);

  function Modal() {
    var _this;

    (0, _classCallCheck2.default)(this, Modal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "button", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "secondaryButton", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "outerModal", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "innerModal", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "startTrap", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "endTrap", /*#__PURE__*/_react.default.createRef());
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "modalInstanceId", "modal-".concat(getInstanceId()));
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "modalLabelId", "".concat(prefix, "--modal-header__label--").concat(_this.modalInstanceId));
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "modalHeadingId", "".concat(prefix, "--modal-header__heading--").concat(_this.modalInstanceId));
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "modalBodyId", "".concat(prefix, "--modal-body--").concat(_this.modalInstanceId));
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "modalCloseButtonClass", "".concat(prefix, "--modal-close"));
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "isCloseButton", function (element) {
      return !_this.props.onSecondarySubmit && element === _this.secondaryButton.current || element.classList.contains(_this.modalCloseButtonClass);
    });
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "handleKeyDown", function (evt) {
      if (_this.props.open) {
        if (evt.which === 27) {
          _this.props.onRequestClose(evt);
        }

        if (evt.which === 13 && _this.props.shouldSubmitOnEnter && !_this.isCloseButton(evt.target)) {
          _this.props.onRequestSubmit(evt);
        }
      }
    });
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "handleMousedown", function (evt) {
      if (_this.innerModal.current && !_this.innerModal.current.contains(evt.target) && !(0, _wrapFocus.elementOrParentIsFloatingMenu)(evt.target, _this.props.selectorsFloatingMenus) && !_this.props.preventCloseOnClickOutside) {
        _this.props.onRequestClose(evt);
      }
    });
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "handleBlur", function (_ref) {
      var oldActiveNode = _ref.target,
          currentActiveNode = _ref.relatedTarget;
      var _this$props = _this.props,
          open = _this$props.open,
          selectorsFloatingMenus = _this$props.selectorsFloatingMenus;

      if (open && currentActiveNode && oldActiveNode) {
        var bodyNode = _this.innerModal.current;
        var startTrapNode = _this.startTrap.current;
        var endTrapNode = _this.endTrap.current;
        (0, _wrapFocus.default)({
          bodyNode: bodyNode,
          startTrapNode: startTrapNode,
          endTrapNode: endTrapNode,
          currentActiveNode: currentActiveNode,
          oldActiveNode: oldActiveNode,
          selectorsFloatingMenus: selectorsFloatingMenus
        });
      }
    });
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "initialFocus", function (focusContainerElement) {
      var containerElement = focusContainerElement || _this.innerModal.current;
      var primaryFocusElement = containerElement ? containerElement.querySelector(_this.props.selectorPrimaryFocus) : null;

      if (primaryFocusElement) {
        return primaryFocusElement;
      }

      return _this.button && _this.button.current;
    });
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "focusButton", function (focusContainerElement) {
      var target = _this.initialFocus(focusContainerElement);

      if (target) {
        target.focus();
      }
    });
    (0, _defineProperty3.default)((0, _assertThisInitialized2.default)(_this), "handleTransitionEnd", function (evt) {
      if (evt.target === evt.currentTarget && // Not to handle `onTransitionEnd` on child DOM nodes
      _this.outerModal.current && _this.outerModal.current.offsetWidth && _this.outerModal.current.offsetHeight && _this.beingOpen) {
        _this.focusButton(evt.currentTarget);

        _this.beingOpen = false;
      }
    });
    return _this;
  }

  (0, _createClass2.default)(Modal, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (!prevProps.open && this.props.open) {
        this.beingOpen = true;
      } else if (prevProps.open && !this.props.open) {
        this.beingOpen = false;
      }

      (0, _toggleClass.default)(document.body, "".concat(prefix, "--body--with-modal-open"), this.props.open);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _toggleClass.default)(document.body, "".concat(prefix, "--body--with-modal-open"), false);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _toggleClass.default)(document.body, "".concat(prefix, "--body--with-modal-open"), this.props.open);

      if (!this.props.open) {
        return;
      }

      this.focusButton(this.innerModal.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames, _classNames3;

      var _this$props2 = this.props,
          modalHeading = _this$props2.modalHeading,
          modalLabel = _this$props2.modalLabel,
          modalAriaLabel = _this$props2.modalAriaLabel,
          passiveModal = _this$props2.passiveModal,
          hasForm = _this$props2.hasForm,
          secondaryButtonText = _this$props2.secondaryButtonText,
          primaryButtonText = _this$props2.primaryButtonText,
          open = _this$props2.open,
          onRequestClose = _this$props2.onRequestClose,
          onRequestSubmit = _this$props2.onRequestSubmit,
          onSecondarySubmit = _this$props2.onSecondarySubmit,
          iconDescription = _this$props2.iconDescription,
          primaryButtonDisabled = _this$props2.primaryButtonDisabled,
          danger = _this$props2.danger,
          alert = _this$props2.alert,
          secondaryButtons = _this$props2.secondaryButtons,
          selectorPrimaryFocus = _this$props2.selectorPrimaryFocus,
          selectorsFloatingMenus = _this$props2.selectorsFloatingMenus,
          shouldSubmitOnEnter = _this$props2.shouldSubmitOnEnter,
          size = _this$props2.size,
          hasScrollingContent = _this$props2.hasScrollingContent,
          closeButtonLabel = _this$props2.closeButtonLabel,
          preventCloseOnClickOutside = _this$props2.preventCloseOnClickOutside,
          other = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
      var onSecondaryButtonClick = onSecondarySubmit ? onSecondarySubmit : onRequestClose;
      var modalClasses = (0, _classnames.default)((_classNames = {}, (0, _defineProperty3.default)(_classNames, "".concat(prefix, "--modal"), true), (0, _defineProperty3.default)(_classNames, "".concat(prefix, "--modal-tall"), !passiveModal), (0, _defineProperty3.default)(_classNames, 'is-visible', open), (0, _defineProperty3.default)(_classNames, "".concat(prefix, "--modal--danger"), this.props.danger), (0, _defineProperty3.default)(_classNames, this.props.className, this.props.className), _classNames));
      var containerClasses = (0, _classnames.default)("".concat(prefix, "--modal-container"), (0, _defineProperty3.default)({}, "".concat(prefix, "--modal-container--").concat(size), size));
      var contentClasses = (0, _classnames.default)("".concat(prefix, "--modal-content"), (_classNames3 = {}, (0, _defineProperty3.default)(_classNames3, "".concat(prefix, "--modal-content--with-form"), hasForm), (0, _defineProperty3.default)(_classNames3, "".concat(prefix, "--modal-scroll-content"), hasScrollingContent), _classNames3));
      var footerClasses = (0, _classnames.default)("".concat(prefix, "--modal-footer"), (0, _defineProperty3.default)({}, "".concat(prefix, "--modal-footer--three-button"), Array.isArray(secondaryButtons) && secondaryButtons.length === 2));

      var modalButton = /*#__PURE__*/_react.default.createElement("button", {
        className: this.modalCloseButtonClass,
        type: "button",
        onClick: onRequestClose,
        title: ariaLabel ? ariaLabel : iconDescription,
        "aria-label": closeButtonLabel ? closeButtonLabel : 'close',
        ref: this.button
      }, /*#__PURE__*/_react.default.createElement(_iconsReact.Close20, {
        "aria-hidden": "true",
        tabIndex: "-1",
        className: "".concat(this.modalCloseButtonClass, "__icon")
      }));

      var ariaLabel = modalLabel || this.props['aria-label'] || modalAriaLabel || modalHeading;
      var getAriaLabelledBy = modalLabel ? this.modalLabelId : this.modalHeadingId;
      var hasScrollingContentProps = hasScrollingContent ? {
        tabIndex: 0,
        role: 'region',
        'aria-label': ariaLabel,
        'aria-labelledby': getAriaLabelledBy
      } : {};
      var alertDialogProps = {};

      if (alert && passiveModal) {
        alertDialogProps.role = 'alert';
      }

      if (alert && !passiveModal) {
        alertDialogProps.role = 'alertdialog';
        alertDialogProps['aria-describedby'] = this.modalBodyId;
      }

      var modalBody = /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
        ref: this.innerModal,
        role: "dialog"
      }, alertDialogProps, {
        className: containerClasses,
        "aria-label": ariaLabel,
        "aria-modal": "true",
        tabIndex: "-1"
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "--modal-header")
      }, passiveModal && modalButton, modalLabel && /*#__PURE__*/_react.default.createElement("h2", {
        id: this.modalLabelId,
        className: "".concat(prefix, "--modal-header__label")
      }, modalLabel), /*#__PURE__*/_react.default.createElement("h3", {
        id: this.modalHeadingId,
        className: "".concat(prefix, "--modal-header__heading")
      }, modalHeading), !passiveModal && modalButton), /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
        id: this.modalBodyId,
        className: contentClasses
      }, hasScrollingContentProps, {
        "aria-labelledby": getAriaLabelledBy
      }), this.props.children), hasScrollingContent && /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "--modal-content--overflow-indicator")
      }), !passiveModal && /*#__PURE__*/_react.default.createElement(_ButtonSet.default, {
        className: footerClasses
      }, Array.isArray(secondaryButtons) && secondaryButtons.length <= 2 ? secondaryButtons.map(function (_ref2, i) {
        var buttonText = _ref2.buttonText,
            onButtonClick = _ref2.onClick;
        return /*#__PURE__*/_react.default.createElement(_Button.default, {
          key: "".concat(buttonText, "-").concat(i),
          kind: "secondary",
          onClick: onButtonClick
        }, buttonText);
      }) : secondaryButtonText && /*#__PURE__*/_react.default.createElement(_Button.default, {
        kind: "secondary",
        onClick: onSecondaryButtonClick,
        ref: this.secondaryButton
      }, secondaryButtonText), /*#__PURE__*/_react.default.createElement(_Button.default, {
        kind: danger ? 'danger' : 'primary',
        disabled: primaryButtonDisabled,
        onClick: onRequestSubmit,
        ref: this.button
      }, primaryButtonText)));

      return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, other, {
        onKeyDown: this.handleKeyDown,
        onMouseDown: this.handleMousedown,
        onBlur: this.handleBlur,
        className: modalClasses,
        role: "presentation",
        onTransitionEnd: this.props.open ? this.handleTransitionEnd : undefined,
        ref: this.outerModal
      }), /*#__PURE__*/_react.default.createElement("span", {
        ref: this.startTrap,
        tabIndex: "0",
        role: "link",
        className: "".concat(prefix, "--visually-hidden")
      }, "Focus sentinel"), modalBody, /*#__PURE__*/_react.default.createElement("span", {
        ref: this.endTrap,
        tabIndex: "0",
        role: "link",
        className: "".concat(prefix, "--visually-hidden")
      }, "Focus sentinel"));
    }
  }]);
  return Modal;
}(_react.Component);

exports.default = Modal;
(0, _defineProperty3.default)(Modal, "propTypes", (_defineProperty2 = {
  /**
   * Specify whether the Modal is displaying an alert, error or warning
   * Should go hand in hand with the danger prop.
   */
  alert: _propTypes.default.bool
}, (0, _defineProperty3.default)(_defineProperty2, 'aria-label', (0, _requiredIfGivenPropIsTruthy.default)('hasScrollingContent', _propTypes.default.string)), (0, _defineProperty3.default)(_defineProperty2, "children", _propTypes.default.node), (0, _defineProperty3.default)(_defineProperty2, "className", _propTypes.default.string), (0, _defineProperty3.default)(_defineProperty2, "closeButtonLabel", _propTypes.default.string), (0, _defineProperty3.default)(_defineProperty2, "danger", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "focusTrap", (0, _deprecate.default)(_propTypes.default.bool, "\nThe prop `focusTrap` for Modal has been deprecated, as the feature of `focusTrap` runs by default.")), (0, _defineProperty3.default)(_defineProperty2, "hasForm", (0, _deprecate.default)(_propTypes.default.bool, "\nThe prop `hasForm` for Modal has been deprecated, as the feature of `hasForm` runs by default.")), (0, _defineProperty3.default)(_defineProperty2, "hasScrollingContent", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "iconDescription", (0, _deprecate.default)(_propTypes.default.string, 'The iconDescription prop is no longer needed and can be safely removed. This prop will be removed in the next major release of Carbon.')), (0, _defineProperty3.default)(_defineProperty2, "id", _propTypes.default.string), (0, _defineProperty3.default)(_defineProperty2, "modalAriaLabel", _propTypes.default.string), (0, _defineProperty3.default)(_defineProperty2, "modalHeading", _propTypes.default.node), (0, _defineProperty3.default)(_defineProperty2, "modalLabel", _propTypes.default.node), (0, _defineProperty3.default)(_defineProperty2, "onKeyDown", _propTypes.default.func), (0, _defineProperty3.default)(_defineProperty2, "onRequestClose", _propTypes.default.func), (0, _defineProperty3.default)(_defineProperty2, "onRequestSubmit", _propTypes.default.func), (0, _defineProperty3.default)(_defineProperty2, "onSecondarySubmit", _propTypes.default.func), (0, _defineProperty3.default)(_defineProperty2, "open", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "passiveModal", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "preventCloseOnClickOutside", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "primaryButtonDisabled", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "primaryButtonText", _propTypes.default.node), (0, _defineProperty3.default)(_defineProperty2, "secondaryButtonText", _propTypes.default.node), (0, _defineProperty3.default)(_defineProperty2, "secondaryButtons", function secondaryButtons(props, propName, componentName) {
  if (props.secondaryButtons) {
    if (!Array.isArray(props.secondaryButtons) || props.secondaryButtons.length !== 2) {
      return new Error("".concat(propName, " needs to be an array of two button config objects"));
    }

    var shape = {
      buttonText: _propTypes.default.node,
      onClick: _propTypes.default.func
    };
    props[propName].forEach(function (secondaryButton) {
      _propTypes.default.checkPropTypes(shape, secondaryButton, propName, componentName);
    });
  }

  return null;
}), (0, _defineProperty3.default)(_defineProperty2, "selectorPrimaryFocus", _propTypes.default.string), (0, _defineProperty3.default)(_defineProperty2, "selectorsFloatingMenus", _propTypes.default.arrayOf(_propTypes.default.string)), (0, _defineProperty3.default)(_defineProperty2, "shouldSubmitOnEnter", _propTypes.default.bool), (0, _defineProperty3.default)(_defineProperty2, "size", _propTypes.default.oneOf(['xs', 'sm', 'md', 'lg'])), _defineProperty2));
(0, _defineProperty3.default)(Modal, "defaultProps", {
  onRequestClose: function onRequestClose() {},
  onRequestSubmit: function onRequestSubmit() {},
  primaryButtonDisabled: false,
  onKeyDown: function onKeyDown() {},
  passiveModal: false,
  modalHeading: '',
  modalLabel: '',
  preventCloseOnClickOutside: false,
  selectorPrimaryFocus: '[data-modal-primary-focus]',
  hasScrollingContent: false
});