import { Table } from '@kui-shell/core';
declare type FeatureFlags = {
    /** [Optional] disable table title? */
    disableTableTitle?: boolean;
    /** [Optional] when drilling down a table cell, open a new window to execute the comamnd?  */
    drilldownTo?: Table['drilldownTo'];
    /** [Optional] show sidecar name as breadcrumb or hero text, default: 'breadcrumb' */
    sidecarName?: 'breadcrumb' | 'heroText';
    /** [Optional] Enable Split Terminals? */
    splitTerminals?: boolean;
    /** [Optional] Show bottom status stripe? [default: true] */
    statusStripe?: boolean;
    /** Operate in popup mode? */
    isPopup?: boolean;
    /** [Optional] automatically pin watchable command ouptut to the WatchPane? */
    enableWatcherAutoPin?: boolean;
    /**
     * [Optional] maximum number of times to show `loadingDone` to users
     * if set to -1, always show welcome;
     * if not 0, not show welcome
     * default: -1
     *
     */
    showWelcomeMax?: number;
    /** [Optional] Should Tables NOT be presented within a Card/Tile UI? */
    lightweightTables?: boolean;
};
export default FeatureFlags;
