/*
 * Copyright 2020 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import React from 'react';
import { Badge } from '@patternfly/react-core';
export default function PatternFlyTag(props) {
    const color = props.type === 'ok'
        ? 'green-background'
        : props.type === 'error'
            ? 'red-background'
            : props.type === 'warning'
                ? 'yellow-background'
                : 'gray-background';
    return React.createElement(Badge, Object.assign({}, props, { className: ['kui--tag', color, props.spanclassname].join(' ') }));
}
//# sourceMappingURL=PatternFly.js.map