import { Arguments } from '@kui-shell/core';
import { KubeOptions } from '../options';
/**
 * A kubectl --watch will never issue a message for the final
 * termination of a resource. Hence, after seeing "Terminating", we
 * need to poll until we get a 404 back from the apiserver. This is
 * the best way we know, for now, of knowing "Terminated".
 *
 */
export default function pollUntil404(apiVersion: string, kind: string, name: string, namespace: string, offline: (rowKey: string) => void, { REPL }: Arguments<KubeOptions>, command: string): {
    abort: () => void;
};
