interface ErrorWithResultField {
    error: {
        response: {
            result: {
                error: string;
            };
        };
    };
}
interface ErrorWithNestedResultField {
    error: {
        response: {
            result: {
                error: {
                    error: string;
                };
            };
        };
    };
}
interface ErrorWithNestedErrorField {
    error: {
        error: string;
    };
}
interface ErrorWithErrorField {
    message?: string;
    error: string;
}
declare type ErrorLike = string | Error | ErrorWithResultField | ErrorWithNestedResultField | ErrorWithNestedErrorField | ErrorWithErrorField;
/**
 * Try to pull out some meaningful message from the given error
 *
 */
export declare const oopsMessage: (err: ErrorLike) => string;
export {};
