import { KubeResource } from '../model/resource';
/**
 * Separate the app and generated parts of a resource name
 *
 */
export default function extract(resource: KubeResource): {
    app: string;
    name: string;
    nameHash: string;
    version: string;
} | {
    name: string;
    nameHash: string;
    version: string;
    app?: undefined;
} | {
    app?: undefined;
    name?: undefined;
    nameHash?: undefined;
    version?: undefined;
};
