/*
 * Copyright 2018 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { strictEqual } from 'assert';
import { Selectors, Util } from '@kui-shell/test';
/** grab focus for the editor */
const grabFocus = (res) => __awaiter(void 0, void 0, void 0, function* () {
    const element = yield res.app.client.$(`${Selectors.SIDECAR(res.count)} .monaco-editor-wrapper .view-lines`);
    yield element.click();
    yield element.waitForEnabled();
});
/** set the monaco editor text */
export const setValue = (res, text) => __awaiter(void 0, void 0, void 0, function* () {
    const button = yield res.app.client.$(Selectors.SIDECAR_MODE_BUTTON(res.count, 'Clear'));
    yield button.waitForExist();
    yield button.click();
    const txt = yield Util.getValueFromMonaco(res);
    strictEqual(txt, '');
    yield grabFocus(res);
    yield res.app.client.keys(text);
    const txt2 = yield Util.getValueFromMonaco(res);
    strictEqual(txt2, text);
});
//# sourceMappingURL=common.js.map