"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _core = require("@kui-shell/core");

var _pluginKubectl = require("@kui-shell/plugin-kubectl");

/*
 * Copyright 2019 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var _default = registrar => __awaiter(void 0, void 0, void 0, function* () {
  if (!(0, _core.isHeadless)()) {
    const [{
      topContainer,
      topPod
    }, {
      topNode
    }] = yield Promise.all([Promise.resolve().then(() => require('./controller/get-pod-data')), Promise.resolve().then(() => require('./controller/get-node-data'))]); // works around a defect in the core's `override` function; if the
    // plugin-kubectl is loaded before us, our override is ignored

    const top = (yield registrar.find('/kubectl/top/node', 'plugin-kubectl')).$;
    registrar.listen('/kubectl/top/node-summary', args => __awaiter(void 0, void 0, void 0, function* () {
      args.command = args.command.replace(/node-summary/, 'node --summary');
      args.parsedOptions.summary = true;
      return topNode(args, top);
    }), _pluginKubectl.defaultFlags);
    registrar.override('/kubectl/top/node', 'plugin-kubectl', topNode, _pluginKubectl.defaultFlags);
    registrar.override('/k/top/node', 'plugin-kubectl', topNode, _pluginKubectl.defaultFlags);
    registrar.override('/kubectl/top/pod', 'plugin-kubectl', topPod, _pluginKubectl.defaultFlags);
    registrar.override('/k/top/pod', 'plugin-kubectl', topPod, _pluginKubectl.defaultFlags);
    registrar.listen('/kubectl/top/container', topContainer, _pluginKubectl.defaultFlags);
    registrar.listen('/k/top/container', topContainer, _pluginKubectl.defaultFlags);
  }
});

exports.default = _default;