(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@carbon/icon-helpers'), require('prop-types'), require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', '@carbon/icon-helpers', 'prop-types', 'react'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.CarbonIconsReact = {}, global.CarbonIconHelpers, global.PropTypes, global.React));
}(this, (function (exports, iconHelpers, PropTypes, React) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var PropTypes__default = /*#__PURE__*/_interopDefaultLegacy(PropTypes);
  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);

      if (enumerableOnly) {
        symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
      }

      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  var _excluded$v = ["className", "children", "tabIndex"],
      _excluded2$v = ["tabindex"];
  var Icon = /*#__PURE__*/React__default['default'].forwardRef(function Icon(_ref, ref) {
    var className = _ref.className,
        children = _ref.children,
        tabIndex = _ref.tabIndex,
        rest = _objectWithoutProperties(_ref, _excluded$v);

    var _getAttributes = iconHelpers.getAttributes(_objectSpread2(_objectSpread2({}, rest), {}, {
      tabindex: tabIndex
    })),
        tabindex = _getAttributes.tabindex,
        props = _objectWithoutProperties(_getAttributes, _excluded2$v);

    if (className) {
      props.className = className;
    }

    if (tabindex !== undefined && tabindex !== null) {
      props.tabIndex = tabindex;
    }

    if (ref) {
      props.ref = ref;
    }

    return /*#__PURE__*/React__default['default'].createElement('svg', props, children);
  });
  Icon.displayName = 'Icon';
  Icon.propTypes = {
    'aria-hidden': PropTypes__default['default'].string,
    'aria-label': PropTypes__default['default'].string,
    'aria-labelledby': PropTypes__default['default'].string,
    children: PropTypes__default['default'].node,
    className: PropTypes__default['default'].string,
    height: PropTypes__default['default'].oneOfType([PropTypes__default['default'].number, PropTypes__default['default'].string]),
    preserveAspectRatio: PropTypes__default['default'].string,
    tabIndex: PropTypes__default['default'].string,
    viewBox: PropTypes__default['default'].string,
    width: PropTypes__default['default'].oneOfType([PropTypes__default['default'].number, PropTypes__default['default'].string]),
    xmlns: PropTypes__default['default'].string
  };
  Icon.defaultProps = {
    xmlns: 'http://www.w3.org/2000/svg',
    preserveAspectRatio: 'xMidYMid meet'
  };

  var _path$u, _path2$u, _path3$u, _path4$u, _path5$u, _path6$u, _path7$u, _path8$u, _path9$u, _path10$u, _path11$u, _path12$u, _path13$u, _path14$u, _path15$u, _path16$u, _path17$u, _path18$u, _path19$u, _path20$u, _path21$u, _path22$u, _path23$u, _path24$u, _path25$u, _path26$u, _path27$u, _path28$u, _path29$u, _path30$u, _path31$u, _path32$u, _path33$u, _path34$u, _path35$u, _path36$u, _path37$u, _path38$u, _path39$u, _path40$u, _path41$u, _path42$u, _path43$u, _path44$u, _path45$u, _path46$u, _path47$u, _path48$u, _path49$u, _path50$u, _path51$u, _path52$u, _path53$u, _path54$u, _path55$u, _path56$u, _path57$u, _path58$u, _path59$u, _path60$u, _path61$u, _circle$t, _path62$u, _path63$u, _circle2$t, _path64$u, _path65$u, _circle3$t, _path66$u, _path67$u, _circle4$s, _path68$u, _path69$u, _path70$u, _path71$u, _path72$u, _path73$u, _path74$u, _path75$u, _path76$u, _path77$u, _path78$u, _path79$u, _path80$u, _path81$u, _path82$u, _circle5$r, _path83$u, _path84$u, _path85$u, _path86$u, _circle6$r, _path87$u, _path88$u, _path89$u, _path90$u, _circle7$r, _path91$u, _path92$u, _path93$u, _path94$u, _circle8$r, _path95$u, _path96$u, _path97$u, _path98$u, _path99$u, _path100$u, _path101$u, _path102$u, _path103$u, _path104$u, _path105$u, _path106$u, _path107$u, _path108$u, _path109$u, _path110$u, _path111$u, _path112$u, _path113$u, _path114$u, _path115$u, _path116$u, _path117$u, _path118$u, _path119$u, _path120$u, _path121$u, _path122$u, _path123$u, _path124$u, _path125$u, _path126$u, _path127$u, _path128$u, _path129$u, _path130$u, _path131$u, _path132$u, _path133$u, _path134$u, _path135$u, _path136$u, _path137$u, _path138$u, _path139$u, _path140$u, _path141$u, _path142$u, _path143$u, _path144$u, _path145$u, _path146$u, _path147$u, _path148$u, _path149$u, _path150$u, _path151$u, _path152$u, _path153$u, _path154$u, _path155$u, _path156$u, _path157$u, _path158$u, _path159$u, _path160$u, _path161$u, _path162$u, _path163$u, _path164$u, _path165$u, _path166$u, _path167$u, _path168$u, _path169$u, _path170$u, _path171$u, _path172$u, _path173$u, _path174$u, _path175$u, _path176$u, _path177$t, _path178$t, _path179$t, _path180$t, _path181$t, _path182$t, _path183$t, _path184$t, _path185$t, _path186$t, _path187$t, _path188$t, _path189$t, _path190$t, _path191$t, _path192$t, _path193$t, _path194$t, _path195$t, _path196$t, _path197$t, _path198$t, _path199$t, _path200$t, _path201$t, _path202$t, _path203$t, _path204$t, _path205$t, _path206$t, _path207$t, _path208$t, _path209$t, _circle9$r, _circle10$r, _circle11$q, _path210$t, _circle12$q, _circle13$q, _circle14$q, _path211$t, _circle15$q, _circle16$q, _circle17$n, _path212$t, _circle18$n, _circle19$n, _circle20$n, _path213$t, _path214$t, _path215$t, _path216$t, _path217$t, _path218$t, _path219$t, _path220$t, _path221$t, _path222$t, _path223$t, _path224$t, _path225$t, _path226$t, _path227$t, _path228$t, _path229$t, _path230$t, _path231$t, _path232$t, _path233$t, _path234$t, _path235$t, _path236$t, _path237$t, _path238$t, _path239$t, _path240$t, _path241$t, _path242$t, _path243$t, _path244$t, _path245$t, _path246$t, _path247$t, _path248$t, _path249$t, _path250$t, _path251$t, _path252$t, _path253$t, _path254$t, _path255$t, _path256$t, _path257$t, _path258$t, _path259$t, _path260$t, _path261$t, _path262$t, _path263$t, _path264$t, _path265$t, _path266$t, _path267$t, _path268$t, _path269$t, _path270$t, _path271$t, _path272$t, _path273$t, _path274$t, _path275$t, _path276$t, _path277$t, _path278$t, _path279$t, _path280$t, _path281$t, _path282$t, _path283$t, _path284$t, _path285$t, _path286$t, _path287$t, _path288$t, _path289$t, _path290$t, _path291$t, _path292$t, _path293$t, _path294$t, _path295$t, _path296$t, _path297$t, _path298$t, _path299$t, _path300$t, _path301$t, _path302$t, _path303$t, _path304$t, _path305$t, _path306$t, _path307$t, _path308$t, _path309$t, _path310$t, _path311$t, _path312$t, _path313$t, _path314$t, _path315$t, _path316$t, _path317$t, _path318$t, _path319$t, _path320$t, _path321$t, _path322$t, _path323$t, _path324$t, _path325$t, _path326$t, _path327$t, _path328$t, _path329$t, _path330$t, _path331$t, _path332$t, _path333$t, _path334$t, _path335$t, _path336$t, _path337$t, _path338$s, _path339$s, _path340$s, _path341$s, _path342$s, _path343$s, _path344$s, _path345$s, _path346$s, _path347$s, _path348$s, _path349$s, _path350$s, _path351$s, _path352$s, _path353$s, _path354$s, _path355$r, _path356$r, _path357$r, _path358$r, _path359$r, _path360$r, _path361$q, _path362$q, _path363$o, _path364$o, _path365$o, _path366$o, _path367$o, _path368$o, _path369$o, _path370$o, _path371$o, _path372$o, _path373$o, _path374$o, _path375$n, _path376$n, _path377$n, _path378$n, _path379$n, _path380$n, _path381$n, _path382$n, _path383$n, _path384$m, _path385$m, _path386$l, _path387$l, _path388$l, _path389$l, _path390$l, _path391$l, _path392$l, _path393$l, _path394$l, _path395$l, _path396$l, _path397$l, _path398$l, _path399$j, _path400$j, _path401$j, _path402$j, _path403$i, _path404$i, _path405$h, _path406$g;

  var _excluded$u = ["children"],
      _excluded2$u = ["children"],
      _excluded3$u = ["children"],
      _excluded4$u = ["children"],
      _excluded5$u = ["children"],
      _excluded6$u = ["children"],
      _excluded7$u = ["children"],
      _excluded8$u = ["children"],
      _excluded9$u = ["children"],
      _excluded10$u = ["children"],
      _excluded11$u = ["children"],
      _excluded12$u = ["children"],
      _excluded13$u = ["children"],
      _excluded14$u = ["children"],
      _excluded15$u = ["children"],
      _excluded16$u = ["children"],
      _excluded17$u = ["children"],
      _excluded18$u = ["children"],
      _excluded19$u = ["children"],
      _excluded20$u = ["children"],
      _excluded21$u = ["children"],
      _excluded22$u = ["children"],
      _excluded23$u = ["children"],
      _excluded24$u = ["children"],
      _excluded25$u = ["children"],
      _excluded26$u = ["children"],
      _excluded27$u = ["children"],
      _excluded28$u = ["children"],
      _excluded29$u = ["children"],
      _excluded30$u = ["children"],
      _excluded31$u = ["children"],
      _excluded32$u = ["children"],
      _excluded33$u = ["children"],
      _excluded34$u = ["children"],
      _excluded35$u = ["children"],
      _excluded36$u = ["children"],
      _excluded37$u = ["children"],
      _excluded38$u = ["children"],
      _excluded39$u = ["children"],
      _excluded40$u = ["children"],
      _excluded41$u = ["children"],
      _excluded42$u = ["children"],
      _excluded43$u = ["children"],
      _excluded44$u = ["children"],
      _excluded45$u = ["children"],
      _excluded46$u = ["children"],
      _excluded47$u = ["children"],
      _excluded48$u = ["children"],
      _excluded49$u = ["children"],
      _excluded50$u = ["children"],
      _excluded51$u = ["children"],
      _excluded52$u = ["children"],
      _excluded53$u = ["children"],
      _excluded54$u = ["children"],
      _excluded55$u = ["children"],
      _excluded56$u = ["children"],
      _excluded57$u = ["children"],
      _excluded58$u = ["children"],
      _excluded59$u = ["children"],
      _excluded60$u = ["children"],
      _excluded61$u = ["children"],
      _excluded62$u = ["children"],
      _excluded63$u = ["children"],
      _excluded64$u = ["children"],
      _excluded65$u = ["children"],
      _excluded66$u = ["children"],
      _excluded67$u = ["children"],
      _excluded68$u = ["children"],
      _excluded69$u = ["children"],
      _excluded70$u = ["children"],
      _excluded71$u = ["children"],
      _excluded72$u = ["children"],
      _excluded73$u = ["children"],
      _excluded74$u = ["children"],
      _excluded75$u = ["children"],
      _excluded76$u = ["children"],
      _excluded77$u = ["children"],
      _excluded78$u = ["children"],
      _excluded79$u = ["children"],
      _excluded80$u = ["children"],
      _excluded81$u = ["children"],
      _excluded82$u = ["children"],
      _excluded83$u = ["children"],
      _excluded84$u = ["children"],
      _excluded85$u = ["children"],
      _excluded86$u = ["children"],
      _excluded87$u = ["children"],
      _excluded88$u = ["children"],
      _excluded89$u = ["children"],
      _excluded90$u = ["children"],
      _excluded91$u = ["children"],
      _excluded92$u = ["children"],
      _excluded93$u = ["children"],
      _excluded94$u = ["children"],
      _excluded95$u = ["children"],
      _excluded96$u = ["children"],
      _excluded97$u = ["children"],
      _excluded98$u = ["children"],
      _excluded99$u = ["children"],
      _excluded100$u = ["children"],
      _excluded101$u = ["children"],
      _excluded102$u = ["children"],
      _excluded103$u = ["children"],
      _excluded104$u = ["children"],
      _excluded105$u = ["children"],
      _excluded106$u = ["children"],
      _excluded107$u = ["children"],
      _excluded108$u = ["children"],
      _excluded109$u = ["children"],
      _excluded110$u = ["children"],
      _excluded111$u = ["children"],
      _excluded112$u = ["children"],
      _excluded113$u = ["children"],
      _excluded114$u = ["children"],
      _excluded115$u = ["children"],
      _excluded116$u = ["children"],
      _excluded117$u = ["children"],
      _excluded118$u = ["children"],
      _excluded119$t = ["children"],
      _excluded120$t = ["children"],
      _excluded121$t = ["children"],
      _excluded122$t = ["children"],
      _excluded123$t = ["children"],
      _excluded124$t = ["children"],
      _excluded125$t = ["children"],
      _excluded126$t = ["children"],
      _excluded127$t = ["children"],
      _excluded128$t = ["children"],
      _excluded129$t = ["children"],
      _excluded130$t = ["children"],
      _excluded131$t = ["children"],
      _excluded132$t = ["children"],
      _excluded133$t = ["children"],
      _excluded134$t = ["children"],
      _excluded135$t = ["children"],
      _excluded136$t = ["children"],
      _excluded137$t = ["children"],
      _excluded138$t = ["children"],
      _excluded139$t = ["children"],
      _excluded140$t = ["children"],
      _excluded141$t = ["children"],
      _excluded142$t = ["children"],
      _excluded143$t = ["children"],
      _excluded144$t = ["children"],
      _excluded145$t = ["children"],
      _excluded146$t = ["children"],
      _excluded147$t = ["children"],
      _excluded148$t = ["children"],
      _excluded149$t = ["children"],
      _excluded150$t = ["children"],
      _excluded151$t = ["children"],
      _excluded152$t = ["children"],
      _excluded153$t = ["children"],
      _excluded154$t = ["children"],
      _excluded155$t = ["children"],
      _excluded156$t = ["children"],
      _excluded157$t = ["children"],
      _excluded158$t = ["children"],
      _excluded159$t = ["children"],
      _excluded160$t = ["children"],
      _excluded161$t = ["children"],
      _excluded162$t = ["children"],
      _excluded163$t = ["children"],
      _excluded164$t = ["children"],
      _excluded165$t = ["children"],
      _excluded166$t = ["children"],
      _excluded167$t = ["children"],
      _excluded168$t = ["children"],
      _excluded169$t = ["children"],
      _excluded170$t = ["children"],
      _excluded171$t = ["children"],
      _excluded172$t = ["children"],
      _excluded173$t = ["children"],
      _excluded174$t = ["children"],
      _excluded175$t = ["children"],
      _excluded176$t = ["children"],
      _excluded177$t = ["children"],
      _excluded178$t = ["children"],
      _excluded179$t = ["children"],
      _excluded180$t = ["children"],
      _excluded181$t = ["children"],
      _excluded182$t = ["children"],
      _excluded183$t = ["children"],
      _excluded184$t = ["children"],
      _excluded185$t = ["children"],
      _excluded186$t = ["children"],
      _excluded187$t = ["children"],
      _excluded188$t = ["children"],
      _excluded189$t = ["children"],
      _excluded190$t = ["children"],
      _excluded191$t = ["children"],
      _excluded192$t = ["children"],
      _excluded193$t = ["children"],
      _excluded194$t = ["children"],
      _excluded195$t = ["children"],
      _excluded196$t = ["children"],
      _excluded197$t = ["children"],
      _excluded198$t = ["children"],
      _excluded199$t = ["children"],
      _excluded200$t = ["children"],
      _excluded201$t = ["children"],
      _excluded202$t = ["children"],
      _excluded203$t = ["children"],
      _excluded204$t = ["children"],
      _excluded205$t = ["children"],
      _excluded206$t = ["children"],
      _excluded207$t = ["children"],
      _excluded208$t = ["children"],
      _excluded209$t = ["children"],
      _excluded210$t = ["children"],
      _excluded211$t = ["children"],
      _excluded212$t = ["children"],
      _excluded213$t = ["children"],
      _excluded214$t = ["children"],
      _excluded215$t = ["children"],
      _excluded216$t = ["children"],
      _excluded217$t = ["children"],
      _excluded218$t = ["children"],
      _excluded219$t = ["children"],
      _excluded220$t = ["children"],
      _excluded221$t = ["children"],
      _excluded222$t = ["children"],
      _excluded223$t = ["children"],
      _excluded224$t = ["children"],
      _excluded225$t = ["children"],
      _excluded226$t = ["children"],
      _excluded227$t = ["children"],
      _excluded228$t = ["children"],
      _excluded229$t = ["children"],
      _excluded230$t = ["children"],
      _excluded231$t = ["children"],
      _excluded232$t = ["children"],
      _excluded233$t = ["children"],
      _excluded234$t = ["children"],
      _excluded235$t = ["children"],
      _excluded236$t = ["children"],
      _excluded237$t = ["children"],
      _excluded238$t = ["children"],
      _excluded239$t = ["children"],
      _excluded240$t = ["children"],
      _excluded241$t = ["children"],
      _excluded242$t = ["children"],
      _excluded243$t = ["children"],
      _excluded244$t = ["children"],
      _excluded245$t = ["children"],
      _excluded246$t = ["children"],
      _excluded247$t = ["children"],
      _excluded248$t = ["children"],
      _excluded249$t = ["children"],
      _excluded250$t = ["children"];
  var WatsonHealth3DCursor32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursor32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$u || (_path$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 00-1 0l-9 5A1 1 0 0010 14V24a1 1 0 00.52.87l9 5A1 1 0 0020 30a1.05 1.05 0 00.49-.13l9-5A1 1 0 0030 24V14A1 1 0 0029.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"
    })), children);
  });
  var WatsonHealth3DCursor24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursor24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$u || (_path2$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 00-1 0l-9 5A1 1 0 0010 14V24a1 1 0 00.52.87l9 5A1 1 0 0020 30a1.05 1.05 0 00.49-.13l9-5A1 1 0 0030 24V14A1 1 0 0029.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"
    })), children);
  });
  var WatsonHealth3DCursor20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursor20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$u || (_path3$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 00-1 0l-9 5A1 1 0 0010 14V24a1 1 0 00.52.87l9 5A1 1 0 0020 30a1.05 1.05 0 00.49-.13l9-5A1 1 0 0030 24V14A1 1 0 0029.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"
    })), children);
  });
  var WatsonHealth3DCursor16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursor16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$u || (_path4$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 00-1 0l-9 5A1 1 0 0010 14V24a1 1 0 00.52.87l9 5A1 1 0 0020 30a1.05 1.05 0 00.49-.13l9-5A1 1 0 0030 24V14A1 1 0 0029.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"
    })), children);
  });
  var WatsonHealth3DCursorAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursorAlt32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$u || (_path5$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path6$u || (_path6$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"
    })), children);
  });
  var WatsonHealth3DCursorAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursorAlt24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$u || (_path7$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path8$u || (_path8$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"
    })), children);
  });
  var WatsonHealth3DCursorAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursorAlt20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$u || (_path9$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path10$u || (_path10$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"
    })), children);
  });
  var WatsonHealth3DCursorAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCursorAlt16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$u || (_path11$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path12$u || (_path12$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"
    })), children);
  });
  var WatsonHealth3DCurveAutoColon32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoColon32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$u || (_path13$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoColon24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoColon24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$u || (_path14$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoColon20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoColon20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$u || (_path15$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoColon16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoColon16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$u || (_path16$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoVessels32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoVessels32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$u || (_path17$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoVessels24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoVessels24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$u || (_path18$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoVessels20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoVessels20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$u || (_path19$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveAutoVessels16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveAutoVessels16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$u || (_path20$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"
    })), children);
  });
  var WatsonHealth3DCurveManual32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveManual32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$u || (_path21$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21a3 3 0 01-3 3h-.1a5 5 0 100 2H12a5 5 0 005-5zM7 28a3 3 0 113-3A3 3 0 017 28zM15 13H17V19H15zM25 2a5 5 0 00-4.9 4H20a5 5 0 00-5 5h2a3 3 0 013-3h.1A5 5 0 1025 2zm0 8a3 3 0 113-3A3 3 0 0125 10z"
    })), children);
  });
  var WatsonHealth3DCurveManual24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveManual24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$u || (_path22$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21a3 3 0 01-3 3h-.1a5 5 0 100 2H12a5 5 0 005-5zM7 28a3 3 0 113-3A3 3 0 017 28zM15 13H17V19H15zM25 2a5 5 0 00-4.9 4H20a5 5 0 00-5 5h2a3 3 0 013-3h.1A5 5 0 1025 2zm0 8a3 3 0 113-3A3 3 0 0125 10z"
    })), children);
  });
  var WatsonHealth3DCurveManual20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveManual20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$u || (_path23$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21a3 3 0 01-3 3h-.1a5 5 0 100 2H12a5 5 0 005-5zM7 28a3 3 0 113-3A3 3 0 017 28zM15 13H17V19H15zM25 2a5 5 0 00-4.9 4H20a5 5 0 00-5 5h2a3 3 0 013-3h.1A5 5 0 1025 2zm0 8a3 3 0 113-3A3 3 0 0125 10z"
    })), children);
  });
  var WatsonHealth3DCurveManual16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DCurveManual16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$u || (_path24$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21a3 3 0 01-3 3h-.1a5 5 0 100 2H12a5 5 0 005-5zM7 28a3 3 0 113-3A3 3 0 017 28zM15 13H17V19H15zM25 2a5 5 0 00-4.9 4H20a5 5 0 00-5 5h2a3 3 0 013-3h.1A5 5 0 1025 2zm0 8a3 3 0 113-3A3 3 0 0125 10z"
    })), children);
  });
  var WatsonHealth3DICa32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DICa32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$u || (_path25$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 14H10a2 2 0 01-2-2V4a2 2 0 01.59-1.42A3.57 3.57 0 0110 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 00-.9 0l-6 3A1 1 0 0014 20v7a1 1 0 00.55.89l6 3a1 1 0 00.9 0l6-3A1 1 0 0028 27V20A1 1 0 0027.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 00-2 2V14h2V10h4v4h2V4A2 2 0 0023 2zM19 8V4h4V8z"
    })), children);
  });
  var WatsonHealth3DICa24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DICa24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$u || (_path26$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 14H10a2 2 0 01-2-2V4a2 2 0 01.59-1.42A3.57 3.57 0 0110 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 00-.9 0l-6 3A1 1 0 0014 20v7a1 1 0 00.55.89l6 3a1 1 0 00.9 0l6-3A1 1 0 0028 27V20A1 1 0 0027.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 00-2 2V14h2V10h4v4h2V4A2 2 0 0023 2zM19 8V4h4V8z"
    })), children);
  });
  var WatsonHealth3DICa20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DICa20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$u || (_path27$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 14H10a2 2 0 01-2-2V4a2 2 0 01.59-1.42A3.57 3.57 0 0110 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 00-.9 0l-6 3A1 1 0 0014 20v7a1 1 0 00.55.89l6 3a1 1 0 00.9 0l6-3A1 1 0 0028 27V20A1 1 0 0027.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 00-2 2V14h2V10h4v4h2V4A2 2 0 0023 2zM19 8V4h4V8z"
    })), children);
  });
  var WatsonHealth3DICa16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DICa16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$u || (_path28$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 14H10a2 2 0 01-2-2V4a2 2 0 01.59-1.42A3.57 3.57 0 0110 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 00-.9 0l-6 3A1 1 0 0014 20v7a1 1 0 00.55.89l6 3a1 1 0 00.9 0l6-3A1 1 0 0028 27V20A1 1 0 0027.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 00-2 2V14h2V10h4v4h2V4A2 2 0 0023 2zM19 8V4h4V8z"
    })), children);
  });
  var WatsonHealth3DMprToggle32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DMprToggle32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$u || (_path29$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 00-1 0l-9 5A1 1 0 006 11V21a1 1 0 00.51.87l9 5a1 1 0 001 0l9-5A1 1 0 0026 21V11A1 1 0 0025.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"
    })), children);
  });
  var WatsonHealth3DMprToggle24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DMprToggle24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$u || (_path30$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 00-1 0l-9 5A1 1 0 006 11V21a1 1 0 00.51.87l9 5a1 1 0 001 0l9-5A1 1 0 0026 21V11A1 1 0 0025.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"
    })), children);
  });
  var WatsonHealth3DMprToggle20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DMprToggle20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$u || (_path31$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 00-1 0l-9 5A1 1 0 006 11V21a1 1 0 00.51.87l9 5a1 1 0 001 0l9-5A1 1 0 0026 21V11A1 1 0 0025.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"
    })), children);
  });
  var WatsonHealth3DMprToggle16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DMprToggle16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$u || (_path32$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 00-1 0l-9 5A1 1 0 006 11V21a1 1 0 00.51.87l9 5a1 1 0 001 0l9-5A1 1 0 0026 21V11A1 1 0 0025.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"
    })), children);
  });
  var WatsonHealth3DPrintMesh32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DPrintMesh32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$u || (_path33$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9761,15.7832l-2-9a.9992.9992,0,0,0-.4214-.6152l-6-4A1.0008,1.0008,0,0,0,21,2H11a1.0008,1.0008,0,0,0-.5547.168l-6,4a.9992.9992,0,0,0-.4214.6152l-2,9a1.0019,1.0019,0,0,0,.0181.5039l3,10a1,1,0,0,0,.6709.6709l10,3,.0051.0005a.9789.9789,0,0,0,.564,0l.0051-.0005,10-3a1,1,0,0,0,.6709-.6709l3-10A1.0019,1.0019,0,0,0,29.9761,15.7832Zm-19.05.833L7.0168,8.7974l7.2815,2.6479ZM16,12.4971,19.5889,18H12.4111ZM19.3818,20,16,26.7637,12.6182,20Zm-1.68-8.5547,7.2815-2.6479-3.91,7.8188ZM18.19,9.14l3.0961-4.747,3.5152,2.3432ZM16,8.8364,12.8459,4h6.3082Zm-2.19.3032L7.1992,6.7358l3.5152-2.3432Zm-4.8439,8.03-4.802-1.8007L5.3652,9.9668ZM14.07,27.377,7.5679,25.4263l3.1284-4.7969Zm7.2334-6.7476,3.1284,4.7969L17.93,27.377ZM26.6348,9.9668l1.2006,5.4019-4.802,1.8007ZM4.5374,17.6445l4.5944,1.7227L6.3391,23.65ZM25.6609,23.65l-2.7927-4.2827,4.5944-1.7227Z"
    })), children);
  });
  var WatsonHealth3DPrintMesh24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DPrintMesh24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$u || (_path34$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9761,15.7832l-2-9a.9992.9992,0,0,0-.4214-.6152l-6-4A1.0008,1.0008,0,0,0,21,2H11a1.0008,1.0008,0,0,0-.5547.168l-6,4a.9992.9992,0,0,0-.4214.6152l-2,9a1.0019,1.0019,0,0,0,.0181.5039l3,10a1,1,0,0,0,.6709.6709l10,3,.0051.0005a.9789.9789,0,0,0,.564,0l.0051-.0005,10-3a1,1,0,0,0,.6709-.6709l3-10A1.0019,1.0019,0,0,0,29.9761,15.7832Zm-19.05.833L7.0168,8.7974l7.2815,2.6479ZM16,12.4971,19.5889,18H12.4111ZM19.3818,20,16,26.7637,12.6182,20Zm-1.68-8.5547,7.2815-2.6479-3.91,7.8188ZM18.19,9.14l3.0961-4.747,3.5152,2.3432ZM16,8.8364,12.8459,4h6.3082Zm-2.19.3032L7.1992,6.7358l3.5152-2.3432Zm-4.8439,8.03-4.802-1.8007L5.3652,9.9668ZM14.07,27.377,7.5679,25.4263l3.1284-4.7969Zm7.2334-6.7476,3.1284,4.7969L17.93,27.377ZM26.6348,9.9668l1.2006,5.4019-4.802,1.8007ZM4.5374,17.6445l4.5944,1.7227L6.3391,23.65ZM25.6609,23.65l-2.7927-4.2827,4.5944-1.7227Z"
    })), children);
  });
  var WatsonHealth3DPrintMesh20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DPrintMesh20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$u || (_path35$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9761,15.7832l-2-9a.9992.9992,0,0,0-.4214-.6152l-6-4A1.0008,1.0008,0,0,0,21,2H11a1.0008,1.0008,0,0,0-.5547.168l-6,4a.9992.9992,0,0,0-.4214.6152l-2,9a1.0019,1.0019,0,0,0,.0181.5039l3,10a1,1,0,0,0,.6709.6709l10,3,.0051.0005a.9789.9789,0,0,0,.564,0l.0051-.0005,10-3a1,1,0,0,0,.6709-.6709l3-10A1.0019,1.0019,0,0,0,29.9761,15.7832Zm-19.05.833L7.0168,8.7974l7.2815,2.6479ZM16,12.4971,19.5889,18H12.4111ZM19.3818,20,16,26.7637,12.6182,20Zm-1.68-8.5547,7.2815-2.6479-3.91,7.8188ZM18.19,9.14l3.0961-4.747,3.5152,2.3432ZM16,8.8364,12.8459,4h6.3082Zm-2.19.3032L7.1992,6.7358l3.5152-2.3432Zm-4.8439,8.03-4.802-1.8007L5.3652,9.9668ZM14.07,27.377,7.5679,25.4263l3.1284-4.7969Zm7.2334-6.7476,3.1284,4.7969L17.93,27.377ZM26.6348,9.9668l1.2006,5.4019-4.802,1.8007ZM4.5374,17.6445l4.5944,1.7227L6.3391,23.65ZM25.6609,23.65l-2.7927-4.2827,4.5944-1.7227Z"
    })), children);
  });
  var WatsonHealth3DPrintMesh16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DPrintMesh16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$u || (_path36$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9761,15.7832l-2-9a.9992.9992,0,0,0-.4214-.6152l-6-4A1.0008,1.0008,0,0,0,21,2H11a1.0008,1.0008,0,0,0-.5547.168l-6,4a.9992.9992,0,0,0-.4214.6152l-2,9a1.0019,1.0019,0,0,0,.0181.5039l3,10a1,1,0,0,0,.6709.6709l10,3,.0051.0005a.9789.9789,0,0,0,.564,0l.0051-.0005,10-3a1,1,0,0,0,.6709-.6709l3-10A1.0019,1.0019,0,0,0,29.9761,15.7832Zm-19.05.833L7.0168,8.7974l7.2815,2.6479ZM16,12.4971,19.5889,18H12.4111ZM19.3818,20,16,26.7637,12.6182,20Zm-1.68-8.5547,7.2815-2.6479-3.91,7.8188ZM18.19,9.14l3.0961-4.747,3.5152,2.3432ZM16,8.8364,12.8459,4h6.3082Zm-2.19.3032L7.1992,6.7358l3.5152-2.3432Zm-4.8439,8.03-4.802-1.8007L5.3652,9.9668ZM14.07,27.377,7.5679,25.4263l3.1284-4.7969Zm7.2334-6.7476,3.1284,4.7969L17.93,27.377ZM26.6348,9.9668l1.2006,5.4019-4.802,1.8007ZM4.5374,17.6445l4.5944,1.7227L6.3391,23.65ZM25.6609,23.65l-2.7927-4.2827,4.5944-1.7227Z"
    })), children);
  });
  var WatsonHealth3DSoftware32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DSoftware32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$u || (_path37$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.49 13.1151l-9-5a1 1 0 00-1 0l-9 5A1.0078 1.0078 0 002 14v9.9951a1 1 0 00.52.87l9 5A1.0045 1.0045 0 0012 30a1.0559 1.0559 0 00.49-.1349l9-5A.9923.9923 0 0022 24V14A1.0079 1.0079 0 0021.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), children);
  });
  var WatsonHealth3DSoftware24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DSoftware24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$u || (_path38$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.49 13.1151l-9-5a1 1 0 00-1 0l-9 5A1.0078 1.0078 0 002 14v9.9951a1 1 0 00.52.87l9 5A1.0045 1.0045 0 0012 30a1.0559 1.0559 0 00.49-.1349l9-5A.9923.9923 0 0022 24V14A1.0079 1.0079 0 0021.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), children);
  });
  var WatsonHealth3DSoftware20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DSoftware20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$u || (_path39$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.49 13.1151l-9-5a1 1 0 00-1 0l-9 5A1.0078 1.0078 0 002 14v9.9951a1 1 0 00.52.87l9 5A1.0045 1.0045 0 0012 30a1.0559 1.0559 0 00.49-.1349l9-5A.9923.9923 0 0022 24V14A1.0079 1.0079 0 0021.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), children);
  });
  var WatsonHealth3DSoftware16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3DSoftware16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$u || (_path40$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.49 13.1151l-9-5a1 1 0 00-1 0l-9 5A1.0078 1.0078 0 002 14v9.9951a1 1 0 00.52.87l9 5A1.0045 1.0045 0 0012 30a1.0559 1.0559 0 00.49-.1349l9-5A.9923.9923 0 0022 24V14A1.0079 1.0079 0 0021.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), children);
  });
  var WatsonHealth3rdPartyConnected32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3rdPartyConnected32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$u || (_path41$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var WatsonHealth3rdPartyConnected24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3rdPartyConnected24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$u || (_path42$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var WatsonHealth3rdPartyConnected20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3rdPartyConnected20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$u || (_path43$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var WatsonHealth3rdPartyConnected16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealth3rdPartyConnected16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$u || (_path44$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var _4K32 = /*#__PURE__*/React__default['default'].forwardRef(function _4K32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$u || (_path45$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"
    })), _path46$u || (_path46$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var _4K24 = /*#__PURE__*/React__default['default'].forwardRef(function _4K24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$u || (_path47$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"
    })), _path48$u || (_path48$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var _4K20 = /*#__PURE__*/React__default['default'].forwardRef(function _4K20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$u || (_path49$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"
    })), _path50$u || (_path50$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var _4K16 = /*#__PURE__*/React__default['default'].forwardRef(function _4K16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$u || (_path51$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"
    })), _path52$u || (_path52$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var _4KFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function _4KFilled32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$u || (_path53$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"
    })), children);
  });
  var _4KFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function _4KFilled24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$u || (_path54$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"
    })), children);
  });
  var _4KFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function _4KFilled20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$u || (_path55$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"
    })), children);
  });
  var _4KFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function _4KFilled16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$u || (_path56$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"
    })), children);
  });
  var Accessibility32 = /*#__PURE__*/React__default['default'].forwardRef(function Accessibility32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$u || (_path57$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 01-2-2V13a2 2 0 014 0v4h7V15H19V13a4 4 0 00-8 0v1a9 9 0 108.77 11H17.71A7 7 0 1111 16v3a4 4 0 004 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1119 4.5 3.5 3.5 0 0115.5 8zm0-5A1.5 1.5 0 1017 4.5 1.5 1.5 0 0015.5 3z"
    })), children);
  });
  var Accessibility24 = /*#__PURE__*/React__default['default'].forwardRef(function Accessibility24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$u || (_path58$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 01-2-2V13a2 2 0 014 0v4h7V15H19V13a4 4 0 00-8 0v1a9 9 0 108.77 11H17.71A7 7 0 1111 16v3a4 4 0 004 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1119 4.5 3.5 3.5 0 0115.5 8zm0-5A1.5 1.5 0 1017 4.5 1.5 1.5 0 0015.5 3z"
    })), children);
  });
  var Accessibility20 = /*#__PURE__*/React__default['default'].forwardRef(function Accessibility20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$u || (_path59$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 01-2-2V13a2 2 0 014 0v4h7V15H19V13a4 4 0 00-8 0v1a9 9 0 108.77 11H17.71A7 7 0 1111 16v3a4 4 0 004 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1119 4.5 3.5 3.5 0 0115.5 8zm0-5A1.5 1.5 0 1017 4.5 1.5 1.5 0 0015.5 3z"
    })), children);
  });
  var Accessibility16 = /*#__PURE__*/React__default['default'].forwardRef(function Accessibility16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$u || (_path60$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 01-2-2V13a2 2 0 014 0v4h7V15H19V13a4 4 0 00-8 0v1a9 9 0 108.77 11H17.71A7 7 0 1111 16v3a4 4 0 004 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1119 4.5 3.5 3.5 0 0115.5 8zm0-5A1.5 1.5 0 1017 4.5 1.5 1.5 0 0015.5 3z"
    })), children);
  });
  var AccessibilityAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityAlt32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$u || (_path61$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"
    })), _circle$t || (_circle$t = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path62$u || (_path62$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityAlt24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$u || (_path63$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"
    })), _circle2$t || (_circle2$t = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path64$u || (_path64$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityAlt20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$u || (_path65$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"
    })), _circle3$t || (_circle3$t = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path66$u || (_path66$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityAlt16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$u || (_path67$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"
    })), _circle4$s || (_circle4$s = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path68$u || (_path68$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityColor32 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColor32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$u || (_path69$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path70$u || (_path70$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), _path71$u || (_path71$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityColor24 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColor24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$u || (_path72$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path73$u || (_path73$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), _path74$u || (_path74$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityColor20 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColor20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$u || (_path75$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path76$u || (_path76$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), _path77$u || (_path77$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityColor16 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColor16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$u || (_path78$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path79$u || (_path79$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), _path80$u || (_path80$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AccessibilityColorFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColorFilled32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$u || (_path81$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path82$u || (_path82$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"
    })), _circle5$r || (_circle5$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path83$u || (_path83$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path84$u || (_path84$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), children);
  });
  var AccessibilityColorFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColorFilled24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$u || (_path85$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path86$u || (_path86$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"
    })), _circle6$r || (_circle6$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path87$u || (_path87$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path88$u || (_path88$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), children);
  });
  var AccessibilityColorFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColorFilled20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$u || (_path89$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path90$u || (_path90$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"
    })), _circle7$r || (_circle7$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path91$u || (_path91$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path92$u || (_path92$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), children);
  });
  var AccessibilityColorFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function AccessibilityColorFilled16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$u || (_path93$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path94$u || (_path94$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"
    })), _circle8$r || (_circle8$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path95$u || (_path95$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path96$u || (_path96$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"
    })), children);
  });
  var Account32 = /*#__PURE__*/React__default['default'].forwardRef(function Account32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$u || (_path97$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,14H19v2H8Zm0,5H21v2H8Z"
    })), _path98$u || (_path98$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"
    })), children);
  });
  var Account24 = /*#__PURE__*/React__default['default'].forwardRef(function Account24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$u || (_path99$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,14H19v2H8Zm0,5H21v2H8Z"
    })), _path100$u || (_path100$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"
    })), children);
  });
  var Account20 = /*#__PURE__*/React__default['default'].forwardRef(function Account20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$u || (_path101$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,14H19v2H8Zm0,5H21v2H8Z"
    })), _path102$u || (_path102$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"
    })), children);
  });
  var Account16 = /*#__PURE__*/React__default['default'].forwardRef(function Account16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$u || (_path103$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,14H19v2H8Zm0,5H21v2H8Z"
    })), _path104$u || (_path104$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"
    })), children);
  });
  var AccumulationIce32 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationIce32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$u || (_path105$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8L22 16 23 18 24 16 24 8 22 8zM18 8L18 18 19 20 20 18 20 8 18 8z"
    })), _path106$u || (_path106$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h8v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationIce24 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationIce24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$u || (_path107$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8L22 16 23 18 24 16 24 8 22 8zM18 8L18 18 19 20 20 18 20 8 18 8z"
    })), _path108$u || (_path108$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h8v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationIce20 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationIce20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$u || (_path109$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8L22 16 23 18 24 16 24 8 22 8zM18 8L18 18 19 20 20 18 20 8 18 8z"
    })), _path110$u || (_path110$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h8v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationIce16 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationIce16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$u || (_path111$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8L22 16 23 18 24 16 24 8 22 8zM18 8L18 18 19 20 20 18 20 8 18 8z"
    })), _path112$u || (_path112$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h8v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationPrecipitation32 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationPrecipitation32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$u || (_path113$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16H18V18H16zM18 18H20V20H18zM20 20H22V22H20zM20 16H22V18H20zM16 20H18V22H16zM20 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L19.17 2.4141a1.0381 1.0381 0 011.6592 0L23.3154 6.11A3.9693 3.9693 0 0124 8.223 3.8978 3.8978 0 0120 12zm0-7.2368L18.3438 7.2257A1.89 1.89 0 0018 8.223 1.9 1.9 0 0020 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466z"
    })), _path114$u || (_path114$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V10H8v8l1,2,1-2V10h2v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationPrecipitation24 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationPrecipitation24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$u || (_path115$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16H18V18H16zM18 18H20V20H18zM20 20H22V22H20zM20 16H22V18H20zM16 20H18V22H16zM20 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L19.17 2.4141a1.0381 1.0381 0 011.6592 0L23.3154 6.11A3.9693 3.9693 0 0124 8.223 3.8978 3.8978 0 0120 12zm0-7.2368L18.3438 7.2257A1.89 1.89 0 0018 8.223 1.9 1.9 0 0020 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466z"
    })), _path116$u || (_path116$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V10H8v8l1,2,1-2V10h2v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationPrecipitation20 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationPrecipitation20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$u || (_path117$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16H18V18H16zM18 18H20V20H18zM20 20H22V22H20zM20 16H22V18H20zM16 20H18V22H16zM20 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L19.17 2.4141a1.0381 1.0381 0 011.6592 0L23.3154 6.11A3.9693 3.9693 0 0124 8.223 3.8978 3.8978 0 0120 12zm0-7.2368L18.3438 7.2257A1.89 1.89 0 0018 8.223 1.9 1.9 0 0020 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466z"
    })), _path118$u || (_path118$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V10H8v8l1,2,1-2V10h2v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationPrecipitation16 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationPrecipitation16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$u || (_path119$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16H18V18H16zM18 18H20V20H18zM20 20H22V22H20zM20 16H22V18H20zM16 20H18V22H16zM20 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L19.17 2.4141a1.0381 1.0381 0 011.6592 0L23.3154 6.11A3.9693 3.9693 0 0124 8.223 3.8978 3.8978 0 0120 12zm0-7.2368L18.3438 7.2257A1.89 1.89 0 0018 8.223 1.9 1.9 0 0020 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466z"
    })), _path120$u || (_path120$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V10H8v8l1,2,1-2V10h2v4l1,2,1-2V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationRain32 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationRain32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$u || (_path121$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V8H24a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,5a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,8a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,5a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4ZM6,26V22h4V20H6V16h4V14H6V10H8a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,10h2V26Z"
    })), children);
  });
  var AccumulationRain24 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationRain24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$u || (_path122$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V8H24a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,5a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,8a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,5a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4ZM6,26V22h4V20H6V16h4V14H6V10H8a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,10h2V26Z"
    })), children);
  });
  var AccumulationRain20 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationRain20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$u || (_path123$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V8H24a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,5a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,8a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,5a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4ZM6,26V22h4V20H6V16h4V14H6V10H8a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,10h2V26Z"
    })), children);
  });
  var AccumulationRain16 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationRain16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$u || (_path124$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V8H24a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,5a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,8a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,5a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4ZM6,26V22h4V20H6V16h4V14H6V10H8a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,10h2V26Z"
    })), children);
  });
  var AccumulationSnow32 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationSnow32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$u || (_path125$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 2H14V4H12zM14 4H16V6H14zM16 6H18V8H16zM16 2H18V4H16zM12 6H14V8H12zM14 18H16V20H14zM16 20H18V22H16zM18 22H20V24H18zM18 18H20V20H18zM14 22H16V24H14zM18 10H20V12H18zM20 12H22V14H20zM22 14H24V16H22zM22 10H24V12H22zM18 14H20V16H18z"
    })), _path126$u || (_path126$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h4V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationSnow24 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationSnow24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$u || (_path127$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 2H14V4H12zM14 4H16V6H14zM16 6H18V8H16zM16 2H18V4H16zM12 6H14V8H12zM14 18H16V20H14zM16 20H18V22H16zM18 22H20V24H18zM18 18H20V20H18zM14 22H16V24H14zM18 10H20V12H18zM20 12H22V14H20zM22 14H24V16H22zM22 10H24V12H22zM18 14H20V16H18z"
    })), _path128$u || (_path128$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h4V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationSnow20 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationSnow20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$u || (_path129$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 2H14V4H12zM14 4H16V6H14zM16 6H18V8H16zM16 2H18V4H16zM12 6H14V8H12zM14 18H16V20H14zM16 20H18V22H16zM18 22H20V24H18zM18 18H20V20H18zM14 22H16V24H14zM18 10H20V12H18zM20 12H22V14H20zM22 14H24V16H22zM22 10H24V12H22zM18 14H20V16H18z"
    })), _path130$u || (_path130$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h4V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var AccumulationSnow16 = /*#__PURE__*/React__default['default'].forwardRef(function AccumulationSnow16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$u || (_path131$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 2H14V4H12zM14 4H16V6H14zM16 6H18V8H16zM16 2H18V4H16zM12 6H14V8H12zM14 18H16V20H14zM16 20H18V22H16zM18 22H20V24H18zM18 18H20V20H18zM14 22H16V24H14zM18 10H20V12H18zM20 12H22V14H20zM22 14H24V16H22zM22 10H24V12H22zM18 14H20V16H18z"
    })), _path132$u || (_path132$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4a2.0023,2.0023,0,0,0-2,2V26H6V22h4V20H6V16h4V14H6V10h4V8H6V6A2.0023,2.0023,0,0,0,4,4H2V6H4V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6h2V4Z"
    })), children);
  });
  var Activity32 = /*#__PURE__*/React__default['default'].forwardRef(function Activity32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$u || (_path133$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"
    })), children);
  });
  var Activity24 = /*#__PURE__*/React__default['default'].forwardRef(function Activity24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$u || (_path134$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"
    })), children);
  });
  var Activity20 = /*#__PURE__*/React__default['default'].forwardRef(function Activity20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$u || (_path135$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"
    })), children);
  });
  var Activity16 = /*#__PURE__*/React__default['default'].forwardRef(function Activity16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$u || (_path136$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"
    })), children);
  });
  var Add32 = /*#__PURE__*/React__default['default'].forwardRef(function Add32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$u || (_path137$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15L17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17 24 15z"
    })), children);
  });
  var Add24 = /*#__PURE__*/React__default['default'].forwardRef(function Add24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$u || (_path138$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15L17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17 24 15z"
    })), children);
  });
  var Add20 = /*#__PURE__*/React__default['default'].forwardRef(function Add20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$u || (_path139$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15L17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17 24 15z"
    })), children);
  });
  var Add16 = /*#__PURE__*/React__default['default'].forwardRef(function Add16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$u || (_path140$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15L17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17 24 15z"
    })), children);
  });
  var AddAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function AddAlt32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$u || (_path141$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path142$u || (_path142$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 15L17 15 17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17z"
    })), children);
  });
  var AddAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function AddAlt24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$u || (_path143$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path144$u || (_path144$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 15L17 15 17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17z"
    })), children);
  });
  var AddAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function AddAlt20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$u || (_path145$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path146$u || (_path146$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 15L17 15 17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17z"
    })), children);
  });
  var AddAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function AddAlt16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$u || (_path147$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path148$u || (_path148$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 15L17 15 17 8 15 8 15 15 8 15 8 17 15 17 15 24 17 24 17 17 24 17z"
    })), children);
  });
  var AddFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function AddFilled32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$u || (_path149$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14.1725,14.1725,0,0,0,2,16,14.1725,14.1725,0,0,0,16,30,14.1725,14.1725,0,0,0,30,16,14.1725,14.1725,0,0,0,16,2Zm8,15H17v7H15V17H8V15h7V8h2v7h7Z"
    })), _path150$u || (_path150$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24 17L17 17 17 24 15 24 15 17 8 17 8 15 15 15 15 8 17 8 17 15 24 15 24 17z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var AddFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function AddFilled24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$u || (_path151$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14.1725,14.1725,0,0,0,2,16,14.1725,14.1725,0,0,0,16,30,14.1725,14.1725,0,0,0,30,16,14.1725,14.1725,0,0,0,16,2Zm8,15H17v7H15V17H8V15h7V8h2v7h7Z"
    })), _path152$u || (_path152$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24 17L17 17 17 24 15 24 15 17 8 17 8 15 15 15 15 8 17 8 17 15 24 15 24 17z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var AddFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function AddFilled20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$u || (_path153$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14.1725,14.1725,0,0,0,2,16,14.1725,14.1725,0,0,0,16,30,14.1725,14.1725,0,0,0,30,16,14.1725,14.1725,0,0,0,16,2Zm8,15H17v7H15V17H8V15h7V8h2v7h7Z"
    })), _path154$u || (_path154$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24 17L17 17 17 24 15 24 15 17 8 17 8 15 15 15 15 8 17 8 17 15 24 15 24 17z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var AddFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function AddFilled16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$u || (_path155$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14.1725,14.1725,0,0,0,2,16,14.1725,14.1725,0,0,0,16,30,14.1725,14.1725,0,0,0,30,16,14.1725,14.1725,0,0,0,16,2Zm8,15H17v7H15V17H8V15h7V8h2v7h7Z"
    })), _path156$u || (_path156$u = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24 17L17 17 17 24 15 24 15 17 8 17 8 15 15 15 15 8 17 8 17 15 24 15 24 17z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var AddComment32 = /*#__PURE__*/React__default['default'].forwardRef(function AddComment32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$u || (_path157$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path158$u || (_path158$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"
    })), children);
  });
  var AddComment24 = /*#__PURE__*/React__default['default'].forwardRef(function AddComment24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$u || (_path159$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path160$u || (_path160$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"
    })), children);
  });
  var AddComment20 = /*#__PURE__*/React__default['default'].forwardRef(function AddComment20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$u || (_path161$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path162$u || (_path162$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"
    })), children);
  });
  var AddComment16 = /*#__PURE__*/React__default['default'].forwardRef(function AddComment16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$u || (_path163$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path164$u || (_path164$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"
    })), children);
  });
  var AgricultureAnalytics32 = /*#__PURE__*/React__default['default'].forwardRef(function AgricultureAnalytics32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$u || (_path165$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.251 21.3691l2.1943 1.4629A1 1 0 0027.8 22.6l3-4-1.6-1.2-2.4326 3.2437L24.5547 19.168a1 1 0 00-1.3687.2509L20 23.8789V16H18V26a2.0023 2.0023 0 002 2H30V26H20.9434zM2 21H16V23H2zM2 26H16V28H2zM11 16V11h1a4.0046 4.0046 0 004-4V4H13a3.9782 3.9782 0 00-2.7468 1.1066A6.0033 6.0033 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.0019 2.0019 0 0113 6zM8 9A4.0046 4.0046 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var AgricultureAnalytics24 = /*#__PURE__*/React__default['default'].forwardRef(function AgricultureAnalytics24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$u || (_path166$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.251 21.3691l2.1943 1.4629A1 1 0 0027.8 22.6l3-4-1.6-1.2-2.4326 3.2437L24.5547 19.168a1 1 0 00-1.3687.2509L20 23.8789V16H18V26a2.0023 2.0023 0 002 2H30V26H20.9434zM2 21H16V23H2zM2 26H16V28H2zM11 16V11h1a4.0046 4.0046 0 004-4V4H13a3.9782 3.9782 0 00-2.7468 1.1066A6.0033 6.0033 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.0019 2.0019 0 0113 6zM8 9A4.0046 4.0046 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var AgricultureAnalytics20 = /*#__PURE__*/React__default['default'].forwardRef(function AgricultureAnalytics20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$u || (_path167$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.251 21.3691l2.1943 1.4629A1 1 0 0027.8 22.6l3-4-1.6-1.2-2.4326 3.2437L24.5547 19.168a1 1 0 00-1.3687.2509L20 23.8789V16H18V26a2.0023 2.0023 0 002 2H30V26H20.9434zM2 21H16V23H2zM2 26H16V28H2zM11 16V11h1a4.0046 4.0046 0 004-4V4H13a3.9782 3.9782 0 00-2.7468 1.1066A6.0033 6.0033 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.0019 2.0019 0 0113 6zM8 9A4.0046 4.0046 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var AgricultureAnalytics16 = /*#__PURE__*/React__default['default'].forwardRef(function AgricultureAnalytics16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$u || (_path168$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.251 21.3691l2.1943 1.4629A1 1 0 0027.8 22.6l3-4-1.6-1.2-2.4326 3.2437L24.5547 19.168a1 1 0 00-1.3687.2509L20 23.8789V16H18V26a2.0023 2.0023 0 002 2H30V26H20.9434zM2 21H16V23H2zM2 26H16V28H2zM11 16V11h1a4.0046 4.0046 0 004-4V4H13a3.9782 3.9782 0 00-2.7468 1.1066A6.0033 6.0033 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.0019 2.0019 0 0113 6zM8 9A4.0046 4.0046 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var WatsonHealthAiResults32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResults32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$u || (_path169$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8a5.9908 5.9908 0 009.4712 4.8853L28.586 16 30 14.586l-3.115-3.1148A5.997 5.997 0 1016 8zm2 0a4 4 0 114 4A4.0045 4.0045 0 0118 8zM11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0055 8.0055 0 016-7.7373L13.6138 2.3A10.0088 10.0088 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.0493 16a9.5991 9.5991 0 01-1.8716 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857a10.9664 10.9664 0 002.3686-2.8331z"
    })), children);
  });
  var WatsonHealthAiResults24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResults24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$u || (_path170$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8a5.9908 5.9908 0 009.4712 4.8853L28.586 16 30 14.586l-3.115-3.1148A5.997 5.997 0 1016 8zm2 0a4 4 0 114 4A4.0045 4.0045 0 0118 8zM11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0055 8.0055 0 016-7.7373L13.6138 2.3A10.0088 10.0088 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.0493 16a9.5991 9.5991 0 01-1.8716 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857a10.9664 10.9664 0 002.3686-2.8331z"
    })), children);
  });
  var WatsonHealthAiResults20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResults20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$u || (_path171$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8a5.9908 5.9908 0 009.4712 4.8853L28.586 16 30 14.586l-3.115-3.1148A5.997 5.997 0 1016 8zm2 0a4 4 0 114 4A4.0045 4.0045 0 0118 8zM11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0055 8.0055 0 016-7.7373L13.6138 2.3A10.0088 10.0088 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.0493 16a9.5991 9.5991 0 01-1.8716 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857a10.9664 10.9664 0 002.3686-2.8331z"
    })), children);
  });
  var WatsonHealthAiResults16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResults16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$u || (_path172$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8a5.9908 5.9908 0 009.4712 4.8853L28.586 16 30 14.586l-3.115-3.1148A5.997 5.997 0 1016 8zm2 0a4 4 0 114 4A4.0045 4.0045 0 0118 8zM11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0055 8.0055 0 016-7.7373L13.6138 2.3A10.0088 10.0088 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.0493 16a9.5991 9.5991 0 01-1.8716 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857a10.9664 10.9664 0 002.3686-2.8331z"
    })), children);
  });
  var WatsonHealthAiResultsHigh32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsHigh32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$u || (_path173$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.9279 7.9279 0 013.69.9106l.8958-1.791A9.99 9.99 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4zM29 14H19a1 1 0 01-.8945-1.4473l5-10a1 1 0 011.7888 0l5 10A1 1 0 0129 14zm-8.3818-2h6.7636L24 5.2361z"
    })), children);
  });
  var WatsonHealthAiResultsHigh24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsHigh24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$u || (_path174$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.9279 7.9279 0 013.69.9106l.8958-1.791A9.99 9.99 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4zM29 14H19a1 1 0 01-.8945-1.4473l5-10a1 1 0 011.7888 0l5 10A1 1 0 0129 14zm-8.3818-2h6.7636L24 5.2361z"
    })), children);
  });
  var WatsonHealthAiResultsHigh20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsHigh20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$u || (_path175$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.9279 7.9279 0 013.69.9106l.8958-1.791A9.99 9.99 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4zM29 14H19a1 1 0 01-.8945-1.4473l5-10a1 1 0 011.7888 0l5 10A1 1 0 0129 14zm-8.3818-2h6.7636L24 5.2361z"
    })), children);
  });
  var WatsonHealthAiResultsHigh16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsHigh16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$u || (_path176$u = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.9279 7.9279 0 013.69.9106l.8958-1.791A9.99 9.99 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4zM29 14H19a1 1 0 01-.8945-1.4473l5-10a1 1 0 011.7888 0l5 10A1 1 0 0129 14zm-8.3818-2h6.7636L24 5.2361z"
    })), children);
  });
  var WatsonHealthAiResultsLow32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsLow32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$t || (_path177$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM24 14a6 6 0 116-6A6.0067 6.0067 0 0124 14zM24 4a4 4 0 104 4A4.0045 4.0045 0 0024 4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsLow24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsLow24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$u);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$t || (_path178$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM24 14a6 6 0 116-6A6.0067 6.0067 0 0124 14zM24 4a4 4 0 104 4A4.0045 4.0045 0 0024 4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsLow20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsLow20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$t || (_path179$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM24 14a6 6 0 116-6A6.0067 6.0067 0 0124 14zM24 4a4 4 0 104 4A4.0045 4.0045 0 0024 4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsLow16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsLow16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$t || (_path180$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM24 14a6 6 0 116-6A6.0067 6.0067 0 0124 14zM24 4a4 4 0 104 4A4.0045 4.0045 0 0024 4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsMedium32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsMedium32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$t || (_path181$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM28 14H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM20 4v8h8V4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsMedium24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsMedium24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$t || (_path182$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM28 14H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM20 4v8h8V4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsMedium20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsMedium20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$t || (_path183$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM28 14H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM20 4v8h8V4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsMedium16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsMedium16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$t || (_path184$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM28 14H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM20 4v8h8V4zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsUrgent32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsUrgent32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$t || (_path185$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM20 2H22V9H20zM21 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0021 11zM26 2H28V9H26zM27 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0027 11zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsUrgent24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsUrgent24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$t || (_path186$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM20 2H22V9H20zM21 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0021 11zM26 2H28V9H26zM27 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0027 11zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsUrgent20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsUrgent20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$t || (_path187$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM20 2H22V9H20zM21 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0021 11zM26 2H28V9H26zM27 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0027 11zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsUrgent16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsUrgent16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$t || (_path188$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM20 2H22V9H20zM21 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0021 11zM26 2H28V9H26zM27 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0027 11zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16z"
    })), children);
  });
  var WatsonHealthAiResultsVeryHigh32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsVeryHigh32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$t || (_path189$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24zM25 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0025 11zM11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.94 7.94 0 014 1.0825V2.8408A9.9887 9.9887 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4z"
    })), children);
  });
  var WatsonHealthAiResultsVeryHigh24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsVeryHigh24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$t || (_path190$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24zM25 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0025 11zM11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.94 7.94 0 014 1.0825V2.8408A9.9887 9.9887 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4z"
    })), children);
  });
  var WatsonHealthAiResultsVeryHigh20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsVeryHigh20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$t || (_path191$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24zM25 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0025 11zM11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.94 7.94 0 014 1.0825V2.8408A9.9887 9.9887 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4z"
    })), children);
  });
  var WatsonHealthAiResultsVeryHigh16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiResultsVeryHigh16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$t || (_path192$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24zM25 11a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0025 11zM11 24H21V26H11zM13 28H19V30H13zM23.0488 16a9.6136 9.6136 0 01-1.8711 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9886 9.9886 0 0025.2815 16zM16 4a7.94 7.94 0 014 1.0825V2.8408A9.9887 9.9887 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2c0-1.84-1.1108-2.8662-2.1855-3.8594A7.1851 7.1851 0 018 12 8.0092 8.0092 0 0116 4z"
    })), children);
  });
  var WatsonHealthAiStatus32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatus32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$t || (_path193$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM20 14a1 1 0 01-.8945-.5527L17.3818 10H14V8h4a1 1 0 01.8945.5527L20 10.7639l3.1055-6.2112a1.0416 1.0416 0 011.789 0L26.6182 8H30v2H26a1 1 0 01-.8945-.5527L24 7.2361l-3.1055 6.2112A1 1 0 0120 14z"
    })), _path194$t || (_path194$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8145,18.1406A7.1851,7.1851,0,0,1,8,12a8.0092,8.0092,0,0,1,8-8V2A10.0111,10.0111,0,0,0,6,12a9.1793,9.1793,0,0,0,3.46,7.6162C10.4717,20.5508,11,21.0815,11,22h2C13,20.16,11.8892,19.1338,10.8145,18.1406Z"
    })), children);
  });
  var WatsonHealthAiStatus24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatus24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$t || (_path195$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM20 14a1 1 0 01-.8945-.5527L17.3818 10H14V8h4a1 1 0 01.8945.5527L20 10.7639l3.1055-6.2112a1.0416 1.0416 0 011.789 0L26.6182 8H30v2H26a1 1 0 01-.8945-.5527L24 7.2361l-3.1055 6.2112A1 1 0 0120 14z"
    })), _path196$t || (_path196$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8145,18.1406A7.1851,7.1851,0,0,1,8,12a8.0092,8.0092,0,0,1,8-8V2A10.0111,10.0111,0,0,0,6,12a9.1793,9.1793,0,0,0,3.46,7.6162C10.4717,20.5508,11,21.0815,11,22h2C13,20.16,11.8892,19.1338,10.8145,18.1406Z"
    })), children);
  });
  var WatsonHealthAiStatus20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatus20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$t || (_path197$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM20 14a1 1 0 01-.8945-.5527L17.3818 10H14V8h4a1 1 0 01.8945.5527L20 10.7639l3.1055-6.2112a1.0416 1.0416 0 011.789 0L26.6182 8H30v2H26a1 1 0 01-.8945-.5527L24 7.2361l-3.1055 6.2112A1 1 0 0120 14z"
    })), _path198$t || (_path198$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8145,18.1406A7.1851,7.1851,0,0,1,8,12a8.0092,8.0092,0,0,1,8-8V2A10.0111,10.0111,0,0,0,6,12a9.1793,9.1793,0,0,0,3.46,7.6162C10.4717,20.5508,11,21.0815,11,22h2C13,20.16,11.8892,19.1338,10.8145,18.1406Z"
    })), children);
  });
  var WatsonHealthAiStatus16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatus16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$t || (_path199$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM20 14a1 1 0 01-.8945-.5527L17.3818 10H14V8h4a1 1 0 01.8945.5527L20 10.7639l3.1055-6.2112a1.0416 1.0416 0 011.789 0L26.6182 8H30v2H26a1 1 0 01-.8945-.5527L24 7.2361l-3.1055 6.2112A1 1 0 0120 14z"
    })), _path200$t || (_path200$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8145,18.1406A7.1851,7.1851,0,0,1,8,12a8.0092,8.0092,0,0,1,8-8V2A10.0111,10.0111,0,0,0,6,12a9.1793,9.1793,0,0,0,3.46,7.6162C10.4717,20.5508,11,21.0815,11,22h2C13,20.16,11.8892,19.1338,10.8145,18.1406Z"
    })), children);
  });
  var WatsonHealthAiStatusComplete32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusComplete32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$t || (_path201$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21 9.59L17.41 6 16 7.41 21 12.41 30 3.41 28.59 2 21 9.59zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14z"
    })), children);
  });
  var WatsonHealthAiStatusComplete24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusComplete24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$t || (_path202$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21 9.59L17.41 6 16 7.41 21 12.41 30 3.41 28.59 2 21 9.59zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14z"
    })), children);
  });
  var WatsonHealthAiStatusComplete20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusComplete20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$t || (_path203$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21 9.59L17.41 6 16 7.41 21 12.41 30 3.41 28.59 2 21 9.59zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14z"
    })), children);
  });
  var WatsonHealthAiStatusComplete16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusComplete16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$t || (_path204$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21 9.59L17.41 6 16 7.41 21 12.41 30 3.41 28.59 2 21 9.59zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14z"
    })), children);
  });
  var WatsonHealthAiStatusFailed32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusFailed32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$t || (_path205$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), children);
  });
  var WatsonHealthAiStatusFailed24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusFailed24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$t || (_path206$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), children);
  });
  var WatsonHealthAiStatusFailed20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusFailed20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$t || (_path207$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), children);
  });
  var WatsonHealthAiStatusFailed16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusFailed16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$t || (_path208$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.8 14a7.28 7.28 0 01-2.6219 4.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.1426 9.1426 0 0025.8389 14zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), children);
  });
  var WatsonHealthAiStatusInProgress32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusInProgress32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$t || (_path209$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426z"
    })), _circle9$r || (_circle9$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.5",
      cy: "7.5",
      r: "1.5"
    })), _circle10$r || (_circle10$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.5",
      cy: "7.5",
      r: "1.5"
    })), _circle11$q || (_circle11$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.5",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var WatsonHealthAiStatusInProgress24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusInProgress24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$t || (_path210$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426z"
    })), _circle12$q || (_circle12$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.5",
      cy: "7.5",
      r: "1.5"
    })), _circle13$q || (_circle13$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.5",
      cy: "7.5",
      r: "1.5"
    })), _circle14$q || (_circle14$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.5",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var WatsonHealthAiStatusInProgress20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusInProgress20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$t || (_path211$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426z"
    })), _circle15$q || (_circle15$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.5",
      cy: "7.5",
      r: "1.5"
    })), _circle16$q || (_circle16$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.5",
      cy: "7.5",
      r: "1.5"
    })), _circle17$n || (_circle17$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.5",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var WatsonHealthAiStatusInProgress16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusInProgress16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$t || (_path212$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426z"
    })), _circle18$n || (_circle18$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.5",
      cy: "7.5",
      r: "1.5"
    })), _circle19$n || (_circle19$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.5",
      cy: "7.5",
      r: "1.5"
    })), _circle20$n || (_circle20$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.5",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var WatsonHealthAiStatusQueued32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusQueued32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$t || (_path213$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426zM18 6H28V8H18z"
    })), children);
  });
  var WatsonHealthAiStatusQueued24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusQueued24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$t || (_path214$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426zM18 6H28V8H18z"
    })), children);
  });
  var WatsonHealthAiStatusQueued20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusQueued20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$t || (_path215$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426zM18 6H28V8H18z"
    })), children);
  });
  var WatsonHealthAiStatusQueued16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusQueued16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$t || (_path216$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM21.1777 18.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12H24A7.2032 7.2032 0 0121.1777 18.1426zM18 6H28V8H18z"
    })), children);
  });
  var WatsonHealthAiStatusRejected32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusRejected32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$t || (_path217$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM30 8a6 6 0 10-6 6A6.0066 6.0066 0 0030 8zM28 8a3.9521 3.9521 0 01-.5669 2.019L21.981 4.5669A3.9529 3.9529 0 0124 4 4.0045 4.0045 0 0128 8zM20 8a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 12 4.0045 4.0045 0 0120 8z"
    })), children);
  });
  var WatsonHealthAiStatusRejected24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusRejected24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$t || (_path218$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM30 8a6 6 0 10-6 6A6.0066 6.0066 0 0030 8zM28 8a3.9521 3.9521 0 01-.5669 2.019L21.981 4.5669A3.9529 3.9529 0 0124 4 4.0045 4.0045 0 0128 8zM20 8a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 12 4.0045 4.0045 0 0120 8z"
    })), children);
  });
  var WatsonHealthAiStatusRejected20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusRejected20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$t || (_path219$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM30 8a6 6 0 10-6 6A6.0066 6.0066 0 0030 8zM28 8a3.9521 3.9521 0 01-.5669 2.019L21.981 4.5669A3.9529 3.9529 0 0124 4 4.0045 4.0045 0 0128 8zM20 8a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 12 4.0045 4.0045 0 0120 8z"
    })), children);
  });
  var WatsonHealthAiStatusRejected16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAiStatusRejected16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$t || (_path220$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM10.8145 18.1406A7.1851 7.1851 0 018 12a8.0092 8.0092 0 018-8V2A10.0111 10.0111 0 006 12a9.1793 9.1793 0 003.46 7.6162C10.4717 20.5508 11 21.0815 11 22h2C13 20.16 11.8892 19.1338 10.8145 18.1406zM23.04 16a9.4858 9.4858 0 01-1.8623 2.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.9838 9.9838 0 0025.2756 16zM30 8a6 6 0 10-6 6A6.0066 6.0066 0 0030 8zM28 8a3.9521 3.9521 0 01-.5669 2.019L21.981 4.5669A3.9529 3.9529 0 0124 4 4.0045 4.0045 0 0128 8zM20 8a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 12 4.0045 4.0045 0 0120 8z"
    })), children);
  });
  var AirlineDigitalGate32 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineDigitalGate32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$t || (_path221$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0058 5.0058 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM31.9658 11.7413a1.0007 1.0007 0 00-1.2246-.707l-3.0861.826L24 7l-1 .2676 1.4584 5.4483-2.7663.7405L20 11.2066l-1 .2676.9337 3.4883a.9993.9993 0 001.2246.707l10.1005-2.7036A1 1 0 0031.9658 11.7413z"
    })), children);
  });
  var AirlineDigitalGate24 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineDigitalGate24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$t || (_path222$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0058 5.0058 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM31.9658 11.7413a1.0007 1.0007 0 00-1.2246-.707l-3.0861.826L24 7l-1 .2676 1.4584 5.4483-2.7663.7405L20 11.2066l-1 .2676.9337 3.4883a.9993.9993 0 001.2246.707l10.1005-2.7036A1 1 0 0031.9658 11.7413z"
    })), children);
  });
  var AirlineDigitalGate20 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineDigitalGate20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$t || (_path223$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0058 5.0058 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM31.9658 11.7413a1.0007 1.0007 0 00-1.2246-.707l-3.0861.826L24 7l-1 .2676 1.4584 5.4483-2.7663.7405L20 11.2066l-1 .2676.9337 3.4883a.9993.9993 0 001.2246.707l10.1005-2.7036A1 1 0 0031.9658 11.7413z"
    })), children);
  });
  var AirlineDigitalGate16 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineDigitalGate16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$t || (_path224$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0058 5.0058 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM31.9658 11.7413a1.0007 1.0007 0 00-1.2246-.707l-3.0861.826L24 7l-1 .2676 1.4584 5.4483-2.7663.7405L20 11.2066l-1 .2676.9337 3.4883a.9993.9993 0 001.2246.707l10.1005-2.7036A1 1 0 0031.9658 11.7413z"
    })), children);
  });
  var AirlineManageGates32 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineManageGates32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$t || (_path225$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4z"
    })), children);
  });
  var AirlineManageGates24 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineManageGates24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$t || (_path226$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4z"
    })), children);
  });
  var AirlineManageGates20 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineManageGates20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$t || (_path227$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4z"
    })), children);
  });
  var AirlineManageGates16 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineManageGates16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$t || (_path228$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4z"
    })), children);
  });
  var AirlinePassengerCare32 = /*#__PURE__*/React__default['default'].forwardRef(function AirlinePassengerCare32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$t || (_path229$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM27.303 8a2.6616 2.6616 0 00-1.9079.8058L25 9.2112l-.3951-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25 17l4.2108-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 8z"
    })), children);
  });
  var AirlinePassengerCare24 = /*#__PURE__*/React__default['default'].forwardRef(function AirlinePassengerCare24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$t || (_path230$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM27.303 8a2.6616 2.6616 0 00-1.9079.8058L25 9.2112l-.3951-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25 17l4.2108-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 8z"
    })), children);
  });
  var AirlinePassengerCare20 = /*#__PURE__*/React__default['default'].forwardRef(function AirlinePassengerCare20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$t || (_path231$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM27.303 8a2.6616 2.6616 0 00-1.9079.8058L25 9.2112l-.3951-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25 17l4.2108-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 8z"
    })), children);
  });
  var AirlinePassengerCare16 = /*#__PURE__*/React__default['default'].forwardRef(function AirlinePassengerCare16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$t || (_path232$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM27.303 8a2.6616 2.6616 0 00-1.9079.8058L25 9.2112l-.3951-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25 17l4.2108-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 8z"
    })), children);
  });
  var AirlineRapidBoard32 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineRapidBoard32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$t || (_path233$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM30 8L28 8 28 6 26 6 26 4 30 4 30 8zM19 4L23 4 23 6 21 6 21 8 19 8 19 4zM28 13H30V15H28zM26 11H28V13H26zM19 11L21 11 21 13 23 13 23 15 19 15 19 11z"
    })), children);
  });
  var AirlineRapidBoard24 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineRapidBoard24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$t || (_path234$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM30 8L28 8 28 6 26 6 26 4 30 4 30 8zM19 4L23 4 23 6 21 6 21 8 19 8 19 4zM28 13H30V15H28zM26 11H28V13H26zM19 11L21 11 21 13 23 13 23 15 19 15 19 11z"
    })), children);
  });
  var AirlineRapidBoard20 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineRapidBoard20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$t || (_path235$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM30 8L28 8 28 6 26 6 26 4 30 4 30 8zM19 4L23 4 23 6 21 6 21 8 19 8 19 4zM28 13H30V15H28zM26 11H28V13H26zM19 11L21 11 21 13 23 13 23 15 19 15 19 11z"
    })), children);
  });
  var AirlineRapidBoard16 = /*#__PURE__*/React__default['default'].forwardRef(function AirlineRapidBoard16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$t || (_path236$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H16V21a3.0033 3.0033 0 00-3-3H9a3.0033 3.0033 0 00-3 3v2H4V21a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM11 6A3 3 0 118 9a3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0011 4zM2 26H30V28H2zM30 8L28 8 28 6 26 6 26 4 30 4 30 8zM19 4L23 4 23 6 21 6 21 8 19 8 19 4zM28 13H30V15H28zM26 11H28V13H26zM19 11L21 11 21 13 23 13 23 15 19 15 19 11z"
    })), children);
  });
  var Airplay32 = /*#__PURE__*/React__default['default'].forwardRef(function Airplay32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$t || (_path237$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30ZM10.92,28H21.08L16,20.7439Z"
    })), _path238$t || (_path238$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var Airplay24 = /*#__PURE__*/React__default['default'].forwardRef(function Airplay24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$t || (_path239$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30ZM10.92,28H21.08L16,20.7439Z"
    })), _path240$t || (_path240$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var Airplay20 = /*#__PURE__*/React__default['default'].forwardRef(function Airplay20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$t || (_path241$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30ZM10.92,28H21.08L16,20.7439Z"
    })), _path242$t || (_path242$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var Airplay16 = /*#__PURE__*/React__default['default'].forwardRef(function Airplay16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$t || (_path243$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30ZM10.92,28H21.08L16,20.7439Z"
    })), _path244$t || (_path244$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var AirplayFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function AirplayFilled32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$t || (_path245$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30Z"
    })), _path246$t || (_path246$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var AirplayFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function AirplayFilled24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$t || (_path247$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30Z"
    })), _path248$t || (_path248$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var AirplayFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function AirplayFilled20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$t || (_path249$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30Z"
    })), _path250$t || (_path250$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var AirplayFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function AirplayFilled16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$t || (_path251$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9961,30H9.0039a1.0022,1.0022,0,0,1-.821-1.5769l6.9977-9.9965a1,1,0,0,1,1.6388,0l6.9977,9.9965A1.0022,1.0022,0,0,1,22.9961,30Z"
    })), _path252$t || (_path252$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H24V22h4V6H4V22H8v2H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,28,24Z"
    })), children);
  });
  var Airport_0132 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0132(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$t || (_path253$t = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,14.5,23,17V15l-6-3V9a1,1,0,0,0-2,0v3L9,15v2l6-2.5V20l-3,2v1l4-1,4,1V22l-3-2Z"
    })), _path254$t || (_path254$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0124 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0124(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$t || (_path255$t = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,14.5,23,17V15l-6-3V9a1,1,0,0,0-2,0v3L9,15v2l6-2.5V20l-3,2v1l4-1,4,1V22l-3-2Z"
    })), _path256$t || (_path256$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0120 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0120(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$t || (_path257$t = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,14.5,23,17V15l-6-3V9a1,1,0,0,0-2,0v3L9,15v2l6-2.5V20l-3,2v1l4-1,4,1V22l-3-2Z"
    })), _path258$t || (_path258$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0116 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0116(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$t || (_path259$t = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,14.5,23,17V15l-6-3V9a1,1,0,0,0-2,0v3L9,15v2l6-2.5V20l-3,2v1l4-1,4,1V22l-3-2Z"
    })), _path260$t || (_path260$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0232 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0232(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$t || (_path261$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17H19.4141L16,13H14l2.5859,4H10.7207L9.5,15H8l1.0569,3.3046A1,1,0,0,0,10.0094,19H23a1,1,0,0,0,0-2Z"
    })), _path262$t || (_path262$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0224 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0224(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$t || (_path263$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17H19.4141L16,13H14l2.5859,4H10.7207L9.5,15H8l1.0569,3.3046A1,1,0,0,0,10.0094,19H23a1,1,0,0,0,0-2Z"
    })), _path264$t || (_path264$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0220 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0220(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$t || (_path265$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17H19.4141L16,13H14l2.5859,4H10.7207L9.5,15H8l1.0569,3.3046A1,1,0,0,0,10.0094,19H23a1,1,0,0,0,0-2Z"
    })), _path266$t || (_path266$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Airport_0216 = /*#__PURE__*/React__default['default'].forwardRef(function Airport_0216(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$t || (_path267$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17H19.4141L16,13H14l2.5859,4H10.7207L9.5,15H8l1.0569,3.3046A1,1,0,0,0,10.0094,19H23a1,1,0,0,0,0-2Z"
    })), _path268$t || (_path268$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var AirportLocation32 = /*#__PURE__*/React__default['default'].forwardRef(function AirportLocation32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$t || (_path269$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15h-6.07A8.0076,8.0076,0,0,0,17,8.0693V2H15V8.0693A8.0076,8.0076,0,0,0,8.07,15H2v2H8.07A8.0076,8.0076,0,0,0,15,23.9307V30h2V23.9307A8.0076,8.0076,0,0,0,23.9305,17H30ZM16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Z"
    })), children);
  });
  var AirportLocation24 = /*#__PURE__*/React__default['default'].forwardRef(function AirportLocation24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$t || (_path270$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15h-6.07A8.0076,8.0076,0,0,0,17,8.0693V2H15V8.0693A8.0076,8.0076,0,0,0,8.07,15H2v2H8.07A8.0076,8.0076,0,0,0,15,23.9307V30h2V23.9307A8.0076,8.0076,0,0,0,23.9305,17H30ZM16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Z"
    })), children);
  });
  var AirportLocation20 = /*#__PURE__*/React__default['default'].forwardRef(function AirportLocation20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$t || (_path271$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15h-6.07A8.0076,8.0076,0,0,0,17,8.0693V2H15V8.0693A8.0076,8.0076,0,0,0,8.07,15H2v2H8.07A8.0076,8.0076,0,0,0,15,23.9307V30h2V23.9307A8.0076,8.0076,0,0,0,23.9305,17H30ZM16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Z"
    })), children);
  });
  var AirportLocation16 = /*#__PURE__*/React__default['default'].forwardRef(function AirportLocation16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$t || (_path272$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15h-6.07A8.0076,8.0076,0,0,0,17,8.0693V2H15V8.0693A8.0076,8.0076,0,0,0,8.07,15H2v2H8.07A8.0076,8.0076,0,0,0,15,23.9307V30h2V23.9307A8.0076,8.0076,0,0,0,23.9305,17H30ZM16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Z"
    })), children);
  });
  var Alarm32 = /*#__PURE__*/React__default['default'].forwardRef(function Alarm32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$t || (_path273$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path274$t || (_path274$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"
    })), _path275$t || (_path275$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path276$t || (_path276$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), children);
  });
  var Alarm24 = /*#__PURE__*/React__default['default'].forwardRef(function Alarm24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$t || (_path277$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path278$t || (_path278$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"
    })), _path279$t || (_path279$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path280$t || (_path280$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), children);
  });
  var Alarm20 = /*#__PURE__*/React__default['default'].forwardRef(function Alarm20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$t || (_path281$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path282$t || (_path282$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"
    })), _path283$t || (_path283$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path284$t || (_path284$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), children);
  });
  var Alarm16 = /*#__PURE__*/React__default['default'].forwardRef(function Alarm16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$t || (_path285$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path286$t || (_path286$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"
    })), _path287$t || (_path287$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path288$t || (_path288$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), children);
  });
  var AlarmAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmAdd32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$t || (_path289$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path290$t || (_path290$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path291$t || (_path291$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path292$t || (_path292$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"
    })), children);
  });
  var AlarmAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmAdd24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$t || (_path293$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path294$t || (_path294$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path295$t || (_path295$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path296$t || (_path296$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"
    })), children);
  });
  var AlarmAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmAdd20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$t || (_path297$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path298$t || (_path298$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path299$t || (_path299$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path300$t || (_path300$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"
    })), children);
  });
  var AlarmAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmAdd16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$t || (_path301$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path302$t || (_path302$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path303$t || (_path303$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path304$t || (_path304$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"
    })), children);
  });
  var AlarmSubtract32 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmSubtract32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$t || (_path305$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path306$t || (_path306$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path307$t || (_path307$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path308$t || (_path308$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16H21V18H11z"
    })), children);
  });
  var AlarmSubtract24 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmSubtract24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$t || (_path309$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path310$t || (_path310$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path311$t || (_path311$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path312$t || (_path312$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16H21V18H11z"
    })), children);
  });
  var AlarmSubtract20 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmSubtract20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$t || (_path313$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path314$t || (_path314$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path315$t || (_path315$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path316$t || (_path316$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16H21V18H11z"
    })), children);
  });
  var AlarmSubtract16 = /*#__PURE__*/React__default['default'].forwardRef(function AlarmSubtract16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$t || (_path317$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"
    })), _path318$t || (_path318$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.96 5.5H9.030000000000001V7.5H3.96z",
      transform: "rotate(-45.06 6.502 6.497)"
    })), _path319$t || (_path319$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.96H26.5V9.030000000000001H24.5z",
      transform: "rotate(-44.94 25.5 6.498)"
    })), _path320$t || (_path320$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16H21V18H11z"
    })), children);
  });
  var AlignHorizontalCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalCenter32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$t || (_path321$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"
    })), children);
  });
  var AlignHorizontalCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalCenter24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$t || (_path322$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"
    })), children);
  });
  var AlignHorizontalCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalCenter20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$t || (_path323$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"
    })), children);
  });
  var AlignHorizontalCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalCenter16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$t || (_path324$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"
    })), children);
  });
  var AlignHorizontalLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalLeft32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$t || (_path325$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 26H11a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H26a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0126 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 01-2-2V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0118 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"
    })), children);
  });
  var AlignHorizontalLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalLeft24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$t || (_path326$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 26H11a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H26a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0126 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 01-2-2V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0118 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"
    })), children);
  });
  var AlignHorizontalLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalLeft20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$t || (_path327$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 26H11a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H26a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0126 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 01-2-2V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0118 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"
    })), children);
  });
  var AlignHorizontalLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalLeft16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$t || (_path328$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 26H11a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H26a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0126 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 01-2-2V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0118 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"
    })), children);
  });
  var AlignHorizontalRight32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalRight32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$t || (_path329$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24V20a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H6A2.0023 2.0023 0 014 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H14A2.0023 2.0023 0 0112 12zm2 0h7V8l-7-.0012z"
    })), _path330$t || (_path330$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H28V30H26z",
      transform: "rotate(-180 27 16)"
    })), children);
  });
  var AlignHorizontalRight24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalRight24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$t || (_path331$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24V20a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H6A2.0023 2.0023 0 014 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H14A2.0023 2.0023 0 0112 12zm2 0h7V8l-7-.0012z"
    })), _path332$t || (_path332$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H28V30H26z",
      transform: "rotate(-180 27 16)"
    })), children);
  });
  var AlignHorizontalRight20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalRight20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$t || (_path333$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24V20a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H6A2.0023 2.0023 0 014 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H14A2.0023 2.0023 0 0112 12zm2 0h7V8l-7-.0012z"
    })), _path334$t || (_path334$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H28V30H26z",
      transform: "rotate(-180 27 16)"
    })), children);
  });
  var AlignHorizontalRight16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignHorizontalRight16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$t || (_path335$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24V20a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H6A2.0023 2.0023 0 014 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 012-2h7a2.0023 2.0023 0 012 2v4a2.0023 2.0023 0 01-2 2H14A2.0023 2.0023 0 0112 12zm2 0h7V8l-7-.0012z"
    })), _path336$t || (_path336$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H28V30H26z",
      transform: "rotate(-180 27 16)"
    })), children);
  });
  var AlignVerticalBottom32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalBottom32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$t || (_path337$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 018 4h4a2.0023 2.0023 0 012 2V21A2.0023 2.0023 0 0112 23zM8 6V21h4.0012L12 6z"
    })), children);
  });
  var AlignVerticalBottom24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalBottom24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$s || (_path338$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 018 4h4a2.0023 2.0023 0 012 2V21A2.0023 2.0023 0 0112 23zM8 6V21h4.0012L12 6z"
    })), children);
  });
  var AlignVerticalBottom20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalBottom20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$s || (_path339$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 018 4h4a2.0023 2.0023 0 012 2V21A2.0023 2.0023 0 0112 23zM8 6V21h4.0012L12 6z"
    })), children);
  });
  var AlignVerticalBottom16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalBottom16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$s || (_path340$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 018 4h4a2.0023 2.0023 0 012 2V21A2.0023 2.0023 0 0112 23zM8 6V21h4.0012L12 6z"
    })), children);
  });
  var AlignVerticalCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalCenter32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$s || (_path341$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"
    })), children);
  });
  var AlignVerticalCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalCenter24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$s || (_path342$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"
    })), children);
  });
  var AlignVerticalCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalCenter20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$s || (_path343$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"
    })), children);
  });
  var AlignVerticalCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalCenter16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$s || (_path344$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"
    })), children);
  });
  var AlignVerticalTop32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalTop32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$s || (_path345$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 20H20a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 01-2-2V11A2.0023 2.0023 0 018 9h4a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"
    })), children);
  });
  var AlignVerticalTop24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalTop24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$s || (_path346$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 20H20a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 01-2-2V11A2.0023 2.0023 0 018 9h4a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"
    })), children);
  });
  var AlignVerticalTop20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalTop20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$s || (_path347$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 20H20a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 01-2-2V11A2.0023 2.0023 0 018 9h4a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"
    })), children);
  });
  var AlignVerticalTop16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignVerticalTop16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$s || (_path348$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 20H20a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2v7A2.0023 2.0023 0 0124 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 01-2-2V11A2.0023 2.0023 0 018 9h4a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"
    })), children);
  });
  var AlignBoxBottomCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomCenter32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$s || (_path349$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path350$s || (_path350$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H22V20H10z",
      transform: "rotate(-180 16 19)"
    })), _path351$s || (_path351$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 23H20V25H12z",
      transform: "rotate(-180 16 24)"
    })), children);
  });
  var AlignBoxBottomCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomCenter24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$s || (_path352$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path353$s || (_path353$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H22V20H10z",
      transform: "rotate(-180 16 19)"
    })), _path354$s || (_path354$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 23H20V25H12z",
      transform: "rotate(-180 16 24)"
    })), children);
  });
  var AlignBoxBottomCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomCenter20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$r || (_path355$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path356$r || (_path356$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H22V20H10z",
      transform: "rotate(-180 16 19)"
    })), _path357$r || (_path357$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 23H20V25H12z",
      transform: "rotate(-180 16 24)"
    })), children);
  });
  var AlignBoxBottomCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomCenter16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$r || (_path358$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path359$r || (_path359$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H22V20H10z",
      transform: "rotate(-180 16 19)"
    })), _path360$r || (_path360$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 23H20V25H12z",
      transform: "rotate(-180 16 24)"
    })), children);
  });
  var AlignBoxBottomLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomLeft32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$q || (_path361$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path362$q || (_path362$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 18H20V20H9zM9 23H16V25H9z"
    })), children);
  });
  var AlignBoxBottomLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomLeft24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$o || (_path363$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path364$o || (_path364$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 18H20V20H9zM9 23H16V25H9z"
    })), children);
  });
  var AlignBoxBottomLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomLeft20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$o || (_path365$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path366$o || (_path366$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 18H20V20H9zM9 23H16V25H9z"
    })), children);
  });
  var AlignBoxBottomLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomLeft16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$o || (_path367$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path368$o || (_path368$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 18H20V20H9zM9 23H16V25H9z"
    })), children);
  });
  var AlignBoxBottomRight32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomRight32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$o || (_path369$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path370$o || (_path370$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H23V20H12z",
      transform: "rotate(-180 17.5 19)"
    })), _path371$o || (_path371$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23H23V25H16z",
      transform: "rotate(-180 19.5 24)"
    })), children);
  });
  var AlignBoxBottomRight24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomRight24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$o || (_path372$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path373$o || (_path373$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H23V20H12z",
      transform: "rotate(-180 17.5 19)"
    })), _path374$o || (_path374$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23H23V25H16z",
      transform: "rotate(-180 19.5 24)"
    })), children);
  });
  var AlignBoxBottomRight20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomRight20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$n || (_path375$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path376$n || (_path376$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H23V20H12z",
      transform: "rotate(-180 17.5 19)"
    })), _path377$n || (_path377$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23H23V25H16z",
      transform: "rotate(-180 19.5 24)"
    })), children);
  });
  var AlignBoxBottomRight16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxBottomRight16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$n || (_path378$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path379$n || (_path379$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H23V20H12z",
      transform: "rotate(-180 17.5 19)"
    })), _path380$n || (_path380$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23H23V25H16z",
      transform: "rotate(-180 19.5 24)"
    })), children);
  });
  var AlignBoxMiddleCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleCenter32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$n || (_path381$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path382$n || (_path382$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10z",
      transform: "rotate(-180 16 14)"
    })), _path383$n || (_path383$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H20V20H12z",
      transform: "rotate(-180 16 19)"
    })), children);
  });
  var AlignBoxMiddleCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleCenter24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$m || (_path384$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path385$m || (_path385$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10z",
      transform: "rotate(-180 16 14)"
    })), _path386$l || (_path386$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H20V20H12z",
      transform: "rotate(-180 16 19)"
    })), children);
  });
  var AlignBoxMiddleCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleCenter20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$l || (_path387$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path388$l || (_path388$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10z",
      transform: "rotate(-180 16 14)"
    })), _path389$l || (_path389$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H20V20H12z",
      transform: "rotate(-180 16 19)"
    })), children);
  });
  var AlignBoxMiddleCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleCenter16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$l || (_path390$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path391$l || (_path391$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10z",
      transform: "rotate(-180 16 14)"
    })), _path392$l || (_path392$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 18H20V20H12z",
      transform: "rotate(-180 16 19)"
    })), children);
  });
  var AlignBoxMiddleLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleLeft32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$l || (_path393$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path394$l || (_path394$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 13H20V15H9zM9 18H16V20H9z"
    })), children);
  });
  var AlignBoxMiddleLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleLeft24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$l || (_path395$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path396$l || (_path396$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 13H20V15H9zM9 18H16V20H9z"
    })), children);
  });
  var AlignBoxMiddleLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleLeft20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$l || (_path397$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path398$l || (_path398$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 13H20V15H9zM9 18H16V20H9z"
    })), children);
  });
  var AlignBoxMiddleLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleLeft16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$j || (_path399$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path400$j || (_path400$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 13H20V15H9zM9 18H16V20H9z"
    })), children);
  });
  var AlignBoxMiddleRight32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleRight32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$j || (_path401$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path402$j || (_path402$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H23V15H12z",
      transform: "rotate(-180 17.5 14)"
    })), _path403$i || (_path403$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H23V20H16z",
      transform: "rotate(-180 19.5 19)"
    })), children);
  });
  var AlignBoxMiddleRight24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleRight24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$i || (_path404$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path405$h || (_path405$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H23V15H12z",
      transform: "rotate(-180 17.5 14)"
    })), _path406$g || (_path406$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H23V20H16z",
      transform: "rotate(-180 19.5 19)"
    })), children);
  });

  var _path$t, _path2$t, _path3$t, _path4$t, _path5$t, _path6$t, _path7$t, _path8$t, _path9$t, _path10$t, _path11$t, _path12$t, _path13$t, _path14$t, _path15$t, _path16$t, _path17$t, _path18$t, _path19$t, _path20$t, _path21$t, _path22$t, _path23$t, _path24$t, _path25$t, _path26$t, _path27$t, _path28$t, _path29$t, _path30$t, _path31$t, _path32$t, _path33$t, _path34$t, _path35$t, _path36$t, _path37$t, _path38$t, _path39$t, _path40$t, _path41$t, _path42$t, _path43$t, _path44$t, _path45$t, _path46$t, _path47$t, _path48$t, _path49$t, _path50$t, _path51$t, _path52$t, _path53$t, _path54$t, _path55$t, _path56$t, _path57$t, _path58$t, _path59$t, _path60$t, _path61$t, _path62$t, _path63$t, _path64$t, _path65$t, _path66$t, _path67$t, _path68$t, _path69$t, _path70$t, _path71$t, _path72$t, _path73$t, _path74$t, _path75$t, _path76$t, _path77$t, _path78$t, _path79$t, _path80$t, _path81$t, _path82$t, _path83$t, _path84$t, _path85$t, _path86$t, _path87$t, _path88$t, _path89$t, _path90$t, _path91$t, _path92$t, _path93$t, _path94$t, _path95$t, _path96$t, _path97$t, _path98$t, _path99$t, _path100$t, _path101$t, _path102$t, _path103$t, _circle$s, _path104$t, _path105$t, _circle2$s, _path106$t, _path107$t, _circle3$s, _path108$t, _path109$t, _circle4$r, _path110$t, _path111$t, _path112$t, _path113$t, _path114$t, _path115$t, _path116$t, _path117$t, _path118$t, _path119$t, _path120$t, _path121$t, _path122$t, _path123$t, _path124$t, _path125$t, _path126$t, _path127$t, _path128$t, _path129$t, _path130$t, _path131$t, _path132$t, _path133$t, _path134$t, _path135$t, _path136$t, _path137$t, _path138$t, _path139$t, _path140$t, _path141$t, _path142$t, _path143$t, _path144$t, _path145$t, _path146$t, _path147$t, _path148$t, _path149$t, _path150$t, _path151$t, _path152$t, _path153$t, _path154$t, _path155$t, _path156$t, _path157$t, _path158$t, _path159$t, _path160$t, _path161$t, _path162$t, _path163$t, _path164$t, _path165$t, _path166$t, _path167$t, _path168$t, _path169$t, _path170$t, _path171$t, _path172$t, _path173$t, _path174$t, _path175$t, _path176$t, _path177$s, _path178$s, _path179$s, _path180$s, _path181$s, _path182$s, _path183$s, _path184$s, _path185$s, _path186$s, _path187$s, _path188$s, _path189$s, _path190$s, _path191$s, _path192$s, _path193$s, _path194$s, _path195$s, _path196$s, _path197$s, _path198$s, _path199$s, _path200$s, _path201$s, _path202$s, _path203$s, _path204$s, _path205$s, _path206$s, _path207$s, _path208$s, _path209$s, _path210$s, _path211$s, _path212$s, _path213$s, _path214$s, _path215$s, _path216$s, _path217$s, _path218$s, _path219$s, _path220$s, _path221$s, _path222$s, _path223$s, _path224$s, _path225$s, _path226$s, _path227$s, _path228$s, _path229$s, _path230$s, _circle5$q, _path231$s, _circle6$q, _circle7$q, _circle8$q, _circle9$q, _circle10$q, _circle11$p, _circle12$p, _circle13$p, _circle14$p, _circle15$p, _circle16$p, _circle17$m, _circle18$m, _circle19$m, _circle20$m, _circle21$l, _circle22$l, _circle23$k, _circle24$k, _circle25$j, _circle26$j, _circle27$i, _circle28$i, _circle29$h, _circle30$h, _circle31$h, _circle32$h, _circle33$g, _circle34$f, _circle35$f, _circle36$f, _circle37$d, _circle38$d, _circle39$d, _circle40$d, _circle41$c, _circle42$c, _circle43$c, _circle44$c, _circle45$b, _circle46$b, _path232$s, _circle47$b, _circle48$b, _circle49$a, _circle50$9, _circle51$9, _circle52$9, _circle53$8, _circle54$8, _circle55$7, _circle56$7, _circle57$7, _circle58$7, _circle59$7, _circle60$7, _circle61$7, _circle62$7, _circle63$7, _circle64$7, _circle65$7, _circle66$7, _circle67$7, _circle68$7, _circle69$7, _circle70$7, _circle71$7, _circle72$7, _circle73$6, _circle74$6, _circle75$6, _circle76$6, _circle77$6, _circle78$6, _circle79$6, _circle80$6, _circle81$6, _circle82$6, _circle83$6, _circle84$6, _circle85$5, _circle86$5, _circle87$5, _path233$s, _circle88$5, _circle89$4, _circle90$4, _circle91$4, _circle92$4, _circle93$4, _circle94$4, _circle95$4, _circle96$4, _circle97$4, _circle98$4, _circle99$4, _circle100$4, _circle101$3, _circle102$3, _circle103$3, _circle104$3, _circle105$3, _circle106$3, _circle107$3, _circle108$3, _circle109$3, _circle110$3, _circle111$3, _circle112$3, _circle113$3, _circle114$3, _circle115$3, _circle116$3, _circle117$2, _circle118$2, _circle119$2, _circle120$2, _circle121$2, _circle122$1, _circle123$1, _circle124$1, _circle125$1, _circle126$1, _circle127$1, _circle128$1, _path234$s, _circle129$1, _circle130$1, _circle131$1, _circle132$1, _circle133$1, _circle134$1, _circle135$1, _circle136$1, _circle137, _circle138, _circle139, _circle140, _circle141, _circle142, _circle143, _circle144, _circle145, _circle146, _circle147, _circle148, _circle149, _circle150, _circle151, _circle152, _circle153, _circle154, _circle155, _circle156, _circle157, _circle158, _circle159, _circle160, _circle161, _circle162, _circle163, _circle164, _circle165, _circle166, _circle167, _circle168, _circle169, _path235$s, _path236$s, _circle170, _path237$s, _path238$s, _circle171, _path239$s, _path240$s, _circle172, _path241$s, _path242$s, _path243$s, _path244$s, _path245$s, _path246$s, _path247$s, _path248$s, _path249$s, _path250$s, _path251$s, _path252$s, _path253$s, _path254$s, _path255$s, _path256$s, _path257$s, _path258$s, _path259$s, _circle173, _path260$s, _path261$s, _circle174, _path262$s, _path263$s, _circle175, _path264$s, _path265$s, _circle176, _path266$s, _path267$s, _path268$s, _path269$s, _path270$s, _path271$s, _path272$s, _path273$s, _path274$s, _path275$s, _path276$s, _path277$s, _path278$s, _path279$s, _path280$s, _path281$s, _path282$s, _path283$s, _path284$s, _path285$s, _path286$s, _path287$s, _path288$s, _path289$s, _path290$s, _path291$s, _path292$s, _path293$s, _path294$s, _path295$s, _path296$s, _path297$s, _path298$s, _path299$s, _path300$s, _path301$s, _path302$s, _path303$s, _path304$s, _path305$s, _path306$s, _path307$s, _path308$s, _path309$s, _path310$s, _path311$s, _path312$s, _path313$s, _path314$s, _path315$s, _path316$s, _path317$s, _path318$s, _path319$s, _path320$s, _path321$s, _path322$s, _path323$s, _path324$s, _path325$s, _path326$s, _path327$s, _path328$s, _path329$s, _path330$s, _path331$s, _path332$s, _path333$s, _path334$s, _circle177, _path335$s, _path336$s, _circle178, _path337$s, _path338$r, _circle179, _path339$r, _path340$r, _circle180, _path341$r, _path342$r, _path343$r, _path344$r, _path345$r, _path346$r, _path347$r, _path348$r, _path349$r, _path350$r, _path351$r, _path352$r, _path353$r, _path354$r, _circle181, _path355$q, _circle182, _path356$q, _circle183, _path357$q, _circle184, _path358$q, _circle185, _path359$q, _circle186, _path360$q, _circle187, _path361$p, _circle188, _path362$p, _circle189, _path363$n, _circle190, _path364$n, _circle191, _path365$n, _circle192, _path366$n, _path367$n, _circle193, _path368$n, _path369$n, _circle194, _path370$n, _path371$n, _circle195, _path372$n, _path373$n, _circle196, _path374$n, _path375$m, _circle197, _path376$m, _circle198, _path377$m, _path378$m, _circle199, _path379$m, _circle200, _path380$m, _path381$m, _circle201, _path382$m, _circle202, _path383$m, _path384$l, _circle203, _path385$l, _circle204, _path386$k, _path387$k, _path388$k, _path389$k, _path390$k, _path391$k, _path392$k, _path393$k, _path394$k, _path395$k, _path396$k, _path397$k, _path398$k;

  var _excluded$t = ["children"],
      _excluded2$t = ["children"],
      _excluded3$t = ["children"],
      _excluded4$t = ["children"],
      _excluded5$t = ["children"],
      _excluded6$t = ["children"],
      _excluded7$t = ["children"],
      _excluded8$t = ["children"],
      _excluded9$t = ["children"],
      _excluded10$t = ["children"],
      _excluded11$t = ["children"],
      _excluded12$t = ["children"],
      _excluded13$t = ["children"],
      _excluded14$t = ["children"],
      _excluded15$t = ["children"],
      _excluded16$t = ["children"],
      _excluded17$t = ["children"],
      _excluded18$t = ["children"],
      _excluded19$t = ["children"],
      _excluded20$t = ["children"],
      _excluded21$t = ["children"],
      _excluded22$t = ["children"],
      _excluded23$t = ["children"],
      _excluded24$t = ["children"],
      _excluded25$t = ["children"],
      _excluded26$t = ["children"],
      _excluded27$t = ["children"],
      _excluded28$t = ["children"],
      _excluded29$t = ["children"],
      _excluded30$t = ["children"],
      _excluded31$t = ["children"],
      _excluded32$t = ["children"],
      _excluded33$t = ["children"],
      _excluded34$t = ["children"],
      _excluded35$t = ["children"],
      _excluded36$t = ["children"],
      _excluded37$t = ["children"],
      _excluded38$t = ["children"],
      _excluded39$t = ["children"],
      _excluded40$t = ["children"],
      _excluded41$t = ["children"],
      _excluded42$t = ["children"],
      _excluded43$t = ["children"],
      _excluded44$t = ["children"],
      _excluded45$t = ["children"],
      _excluded46$t = ["children"],
      _excluded47$t = ["children"],
      _excluded48$t = ["children"],
      _excluded49$t = ["children"],
      _excluded50$t = ["children"],
      _excluded51$t = ["children"],
      _excluded52$t = ["children"],
      _excluded53$t = ["children"],
      _excluded54$t = ["children"],
      _excluded55$t = ["children"],
      _excluded56$t = ["children"],
      _excluded57$t = ["children"],
      _excluded58$t = ["children"],
      _excluded59$t = ["children"],
      _excluded60$t = ["children"],
      _excluded61$t = ["children"],
      _excluded62$t = ["children"],
      _excluded63$t = ["children"],
      _excluded64$t = ["children"],
      _excluded65$t = ["children"],
      _excluded66$t = ["children"],
      _excluded67$t = ["children"],
      _excluded68$t = ["children"],
      _excluded69$t = ["children"],
      _excluded70$t = ["children"],
      _excluded71$t = ["children"],
      _excluded72$t = ["children"],
      _excluded73$t = ["children"],
      _excluded74$t = ["children"],
      _excluded75$t = ["children"],
      _excluded76$t = ["children"],
      _excluded77$t = ["children"],
      _excluded78$t = ["children"],
      _excluded79$t = ["children"],
      _excluded80$t = ["children"],
      _excluded81$t = ["children"],
      _excluded82$t = ["children"],
      _excluded83$t = ["children"],
      _excluded84$t = ["children"],
      _excluded85$t = ["children"],
      _excluded86$t = ["children"],
      _excluded87$t = ["children"],
      _excluded88$t = ["children"],
      _excluded89$t = ["children"],
      _excluded90$t = ["children"],
      _excluded91$t = ["children"],
      _excluded92$t = ["children"],
      _excluded93$t = ["children"],
      _excluded94$t = ["children"],
      _excluded95$t = ["children"],
      _excluded96$t = ["children"],
      _excluded97$t = ["children"],
      _excluded98$t = ["children"],
      _excluded99$t = ["children"],
      _excluded100$t = ["children"],
      _excluded101$t = ["children"],
      _excluded102$t = ["children"],
      _excluded103$t = ["children"],
      _excluded104$t = ["children"],
      _excluded105$t = ["children"],
      _excluded106$t = ["children"],
      _excluded107$t = ["children"],
      _excluded108$t = ["children"],
      _excluded109$t = ["children"],
      _excluded110$t = ["children"],
      _excluded111$t = ["children"],
      _excluded112$t = ["children"],
      _excluded113$t = ["children"],
      _excluded114$t = ["children"],
      _excluded115$t = ["children"],
      _excluded116$t = ["children"],
      _excluded117$t = ["children"],
      _excluded118$t = ["children"],
      _excluded119$s = ["children"],
      _excluded120$s = ["children"],
      _excluded121$s = ["children"],
      _excluded122$s = ["children"],
      _excluded123$s = ["children"],
      _excluded124$s = ["children"],
      _excluded125$s = ["children"],
      _excluded126$s = ["children"],
      _excluded127$s = ["children"],
      _excluded128$s = ["children"],
      _excluded129$s = ["children"],
      _excluded130$s = ["children"],
      _excluded131$s = ["children"],
      _excluded132$s = ["children"],
      _excluded133$s = ["children"],
      _excluded134$s = ["children"],
      _excluded135$s = ["children"],
      _excluded136$s = ["children"],
      _excluded137$s = ["children"],
      _excluded138$s = ["children"],
      _excluded139$s = ["children"],
      _excluded140$s = ["children"],
      _excluded141$s = ["children"],
      _excluded142$s = ["children"],
      _excluded143$s = ["children"],
      _excluded144$s = ["children"],
      _excluded145$s = ["children"],
      _excluded146$s = ["children"],
      _excluded147$s = ["children"],
      _excluded148$s = ["children"],
      _excluded149$s = ["children"],
      _excluded150$s = ["children"],
      _excluded151$s = ["children"],
      _excluded152$s = ["children"],
      _excluded153$s = ["children"],
      _excluded154$s = ["children"],
      _excluded155$s = ["children"],
      _excluded156$s = ["children"],
      _excluded157$s = ["children"],
      _excluded158$s = ["children"],
      _excluded159$s = ["children"],
      _excluded160$s = ["children"],
      _excluded161$s = ["children"],
      _excluded162$s = ["children"],
      _excluded163$s = ["children"],
      _excluded164$s = ["children"],
      _excluded165$s = ["children"],
      _excluded166$s = ["children"],
      _excluded167$s = ["children"],
      _excluded168$s = ["children"],
      _excluded169$s = ["children"],
      _excluded170$s = ["children"],
      _excluded171$s = ["children"],
      _excluded172$s = ["children"],
      _excluded173$s = ["children"],
      _excluded174$s = ["children"],
      _excluded175$s = ["children"],
      _excluded176$s = ["children"],
      _excluded177$s = ["children"],
      _excluded178$s = ["children"],
      _excluded179$s = ["children"],
      _excluded180$s = ["children"],
      _excluded181$s = ["children"],
      _excluded182$s = ["children"],
      _excluded183$s = ["children"],
      _excluded184$s = ["children"],
      _excluded185$s = ["children"],
      _excluded186$s = ["children"],
      _excluded187$s = ["children"],
      _excluded188$s = ["children"],
      _excluded189$s = ["children"],
      _excluded190$s = ["children"],
      _excluded191$s = ["children"],
      _excluded192$s = ["children"],
      _excluded193$s = ["children"],
      _excluded194$s = ["children"],
      _excluded195$s = ["children"],
      _excluded196$s = ["children"],
      _excluded197$s = ["children"],
      _excluded198$s = ["children"],
      _excluded199$s = ["children"],
      _excluded200$s = ["children"],
      _excluded201$s = ["children"],
      _excluded202$s = ["children"],
      _excluded203$s = ["children"],
      _excluded204$s = ["children"],
      _excluded205$s = ["children"],
      _excluded206$s = ["children"],
      _excluded207$s = ["children"],
      _excluded208$s = ["children"],
      _excluded209$s = ["children"],
      _excluded210$s = ["children"],
      _excluded211$s = ["children"],
      _excluded212$s = ["children"],
      _excluded213$s = ["children"],
      _excluded214$s = ["children"],
      _excluded215$s = ["children"],
      _excluded216$s = ["children"],
      _excluded217$s = ["children"],
      _excluded218$s = ["children"],
      _excluded219$s = ["children"],
      _excluded220$s = ["children"],
      _excluded221$s = ["children"],
      _excluded222$s = ["children"],
      _excluded223$s = ["children"],
      _excluded224$s = ["children"],
      _excluded225$s = ["children"],
      _excluded226$s = ["children"],
      _excluded227$s = ["children"],
      _excluded228$s = ["children"],
      _excluded229$s = ["children"],
      _excluded230$s = ["children"],
      _excluded231$s = ["children"],
      _excluded232$s = ["children"],
      _excluded233$s = ["children"],
      _excluded234$s = ["children"],
      _excluded235$s = ["children"],
      _excluded236$s = ["children"],
      _excluded237$s = ["children"],
      _excluded238$s = ["children"],
      _excluded239$s = ["children"],
      _excluded240$s = ["children"],
      _excluded241$s = ["children"],
      _excluded242$s = ["children"],
      _excluded243$s = ["children"],
      _excluded244$s = ["children"],
      _excluded245$s = ["children"],
      _excluded246$s = ["children"],
      _excluded247$s = ["children"],
      _excluded248$s = ["children"],
      _excluded249$s = ["children"],
      _excluded250$s = ["children"];
  var didWarnAboutDeprecation$b = {};
  var AlignBoxMiddleRight20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleRight20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$t || (_path$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path2$t || (_path2$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H23V15H12z",
      transform: "rotate(-180 17.5 14)"
    })), _path3$t || (_path3$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H23V20H16z",
      transform: "rotate(-180 19.5 19)"
    })), children);
  });
  var AlignBoxMiddleRight16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxMiddleRight16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$t || (_path4$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path5$t || (_path5$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H23V15H12z",
      transform: "rotate(-180 17.5 14)"
    })), _path6$t || (_path6$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H23V20H16z",
      transform: "rotate(-180 19.5 19)"
    })), children);
  });
  var AlignBoxTopCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopCenter32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$t || (_path7$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path8$t || (_path8$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 7H22V9H10z",
      transform: "rotate(-180 16 8)"
    })), _path9$t || (_path9$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V14H12z",
      transform: "rotate(-180 16 13)"
    })), children);
  });
  var AlignBoxTopCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopCenter24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$t || (_path10$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path11$t || (_path11$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 7H22V9H10z",
      transform: "rotate(-180 16 8)"
    })), _path12$t || (_path12$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V14H12z",
      transform: "rotate(-180 16 13)"
    })), children);
  });
  var AlignBoxTopCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopCenter20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$t || (_path13$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path14$t || (_path14$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 7H22V9H10z",
      transform: "rotate(-180 16 8)"
    })), _path15$t || (_path15$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V14H12z",
      transform: "rotate(-180 16 13)"
    })), children);
  });
  var AlignBoxTopCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopCenter16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$t || (_path16$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path17$t || (_path17$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 7H22V9H10z",
      transform: "rotate(-180 16 8)"
    })), _path18$t || (_path18$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V14H12z",
      transform: "rotate(-180 16 13)"
    })), children);
  });
  var AlignBoxTopLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopLeft32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$t || (_path19$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path20$t || (_path20$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 7H20V9H9zM9 12H16V14H9z"
    })), children);
  });
  var AlignBoxTopLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopLeft24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$t || (_path21$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path22$t || (_path22$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 7H20V9H9zM9 12H16V14H9z"
    })), children);
  });
  var AlignBoxTopLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopLeft20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$t || (_path23$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path24$t || (_path24$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 7H20V9H9zM9 12H16V14H9z"
    })), children);
  });
  var AlignBoxTopLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopLeft16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$t || (_path25$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path26$t || (_path26$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 7H20V9H9zM9 12H16V14H9z"
    })), children);
  });
  var AlignBoxTopRight32 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopRight32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$t || (_path27$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path28$t || (_path28$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 7H23V9H12z",
      transform: "rotate(-180 17.5 8)"
    })), _path29$t || (_path29$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12H23V14H16z",
      transform: "rotate(-180 19.5 13)"
    })), children);
  });
  var AlignBoxTopRight24 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopRight24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$t || (_path30$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path31$t || (_path31$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 7H23V9H12z",
      transform: "rotate(-180 17.5 8)"
    })), _path32$t || (_path32$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12H23V14H16z",
      transform: "rotate(-180 19.5 13)"
    })), children);
  });
  var AlignBoxTopRight20 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopRight20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$t || (_path33$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path34$t || (_path34$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 7H23V9H12z",
      transform: "rotate(-180 17.5 8)"
    })), _path35$t || (_path35$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12H23V14H16z",
      transform: "rotate(-180 19.5 13)"
    })), children);
  });
  var AlignBoxTopRight16 = /*#__PURE__*/React__default['default'].forwardRef(function AlignBoxTopRight16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$t || (_path36$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30ZM6,4V28H26V4Z"
    })), _path37$t || (_path37$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 7H23V9H12z",
      transform: "rotate(-180 17.5 8)"
    })), _path38$t || (_path38$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12H23V14H16z",
      transform: "rotate(-180 19.5 13)"
    })), children);
  });
  var Analytics32 = /*#__PURE__*/React__default['default'].forwardRef(function Analytics32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$t || (_path39$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"
    })), _path40$t || (_path40$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"
    })), children);
  });
  var Analytics24 = /*#__PURE__*/React__default['default'].forwardRef(function Analytics24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$t || (_path41$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"
    })), _path42$t || (_path42$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"
    })), children);
  });
  var Analytics20 = /*#__PURE__*/React__default['default'].forwardRef(function Analytics20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$t || (_path43$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"
    })), _path44$t || (_path44$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"
    })), children);
  });
  var Analytics16 = /*#__PURE__*/React__default['default'].forwardRef(function Analytics16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$t || (_path45$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"
    })), _path46$t || (_path46$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"
    })), children);
  });
  var AnalyticsReference32 = /*#__PURE__*/React__default['default'].forwardRef(function AnalyticsReference32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$t || (_path47$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 4H23V6h3.5859L19 13.5859 14.707 9.293a1 1 0 00-1.414 0L8 14.5858 9.4142 16 14 11.4141l4.293 4.2929a1 1 0 001.414 0L28 7.4141V11h2zM16 28H30V30H16zM2 2H4V16H2z"
    })), children);
  });
  var AnalyticsReference24 = /*#__PURE__*/React__default['default'].forwardRef(function AnalyticsReference24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$t || (_path48$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 4H23V6h3.5859L19 13.5859 14.707 9.293a1 1 0 00-1.414 0L8 14.5858 9.4142 16 14 11.4141l4.293 4.2929a1 1 0 001.414 0L28 7.4141V11h2zM16 28H30V30H16zM2 2H4V16H2z"
    })), children);
  });
  var AnalyticsReference20 = /*#__PURE__*/React__default['default'].forwardRef(function AnalyticsReference20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$t || (_path49$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 4H23V6h3.5859L19 13.5859 14.707 9.293a1 1 0 00-1.414 0L8 14.5858 9.4142 16 14 11.4141l4.293 4.2929a1 1 0 001.414 0L28 7.4141V11h2zM16 28H30V30H16zM2 2H4V16H2z"
    })), children);
  });
  var AnalyticsReference16 = /*#__PURE__*/React__default['default'].forwardRef(function AnalyticsReference16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$t || (_path50$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 4H23V6h3.5859L19 13.5859 14.707 9.293a1 1 0 00-1.414 0L8 14.5858 9.4142 16 14 11.4141l4.293 4.2929a1 1 0 001.414 0L28 7.4141V11h2zM16 28H30V30H16zM2 2H4V16H2z"
    })), children);
  });
  var WatsonHealthAngle32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAngle32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$t || (_path51$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"
    })), _path52$t || (_path52$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"
    })), children);
  });
  var WatsonHealthAngle24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAngle24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$t || (_path53$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"
    })), _path54$t || (_path54$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"
    })), children);
  });
  var WatsonHealthAngle20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAngle20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$t || (_path55$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"
    })), _path56$t || (_path56$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"
    })), children);
  });
  var WatsonHealthAngle16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAngle16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$t || (_path57$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"
    })), _path58$t || (_path58$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"
    })), children);
  });
  var WatsonHealthAnnotationVisibility32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAnnotationVisibility32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$t || (_path59$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"
    })), _path60$t || (_path60$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20H13a3.51 3.51 0 00-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 009.5 17a3.5 3.5 0 103.15 5H21zM9.5 22A1.5 1.5 0 1111 20.5 1.5 1.5 0 019.5 22zM19 8H26V10H19zM19 12H23V14H19z"
    })), children);
  });
  var WatsonHealthAnnotationVisibility24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAnnotationVisibility24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$t || (_path61$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"
    })), _path62$t || (_path62$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20H13a3.51 3.51 0 00-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 009.5 17a3.5 3.5 0 103.15 5H21zM9.5 22A1.5 1.5 0 1111 20.5 1.5 1.5 0 019.5 22zM19 8H26V10H19zM19 12H23V14H19z"
    })), children);
  });
  var WatsonHealthAnnotationVisibility20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAnnotationVisibility20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$t || (_path63$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"
    })), _path64$t || (_path64$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20H13a3.51 3.51 0 00-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 009.5 17a3.5 3.5 0 103.15 5H21zM9.5 22A1.5 1.5 0 1111 20.5 1.5 1.5 0 019.5 22zM19 8H26V10H19zM19 12H23V14H19z"
    })), children);
  });
  var WatsonHealthAnnotationVisibility16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAnnotationVisibility16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$t || (_path65$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"
    })), _path66$t || (_path66$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20H13a3.51 3.51 0 00-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 009.5 17a3.5 3.5 0 103.15 5H21zM9.5 22A1.5 1.5 0 1111 20.5 1.5 1.5 0 019.5 22zM19 8H26V10H19zM19 12H23V14H19z"
    })), children);
  });
  var Aperture32 = /*#__PURE__*/React__default['default'].forwardRef(function Aperture32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$t || (_path67$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"
    })), children);
  });
  var Aperture24 = /*#__PURE__*/React__default['default'].forwardRef(function Aperture24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$t || (_path68$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"
    })), children);
  });
  var Aperture20 = /*#__PURE__*/React__default['default'].forwardRef(function Aperture20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$t || (_path69$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"
    })), children);
  });
  var Aperture16 = /*#__PURE__*/React__default['default'].forwardRef(function Aperture16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$t || (_path70$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"
    })), children);
  });
  var Api32 = /*#__PURE__*/React__default['default'].forwardRef(function Api32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$t || (_path71$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Api24 = /*#__PURE__*/React__default['default'].forwardRef(function Api24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$t || (_path72$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Api20 = /*#__PURE__*/React__default['default'].forwardRef(function Api20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$t || (_path73$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Api16 = /*#__PURE__*/React__default['default'].forwardRef(function Api16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$t || (_path74$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Api_132 = /*#__PURE__*/React__default['default'].forwardRef(function Api_132(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$t || (_path75$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9H4a2 2 0 00-2 2V23H4V18H8v5h2V11A2 2 0 008 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14z"
    })), children);
  });
  var Api_124 = /*#__PURE__*/React__default['default'].forwardRef(function Api_124(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$t || (_path76$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9H4a2 2 0 00-2 2V23H4V18H8v5h2V11A2 2 0 008 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14z"
    })), children);
  });
  var Api_120 = /*#__PURE__*/React__default['default'].forwardRef(function Api_120(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$t || (_path77$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9H4a2 2 0 00-2 2V23H4V18H8v5h2V11A2 2 0 008 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14z"
    })), children);
  });
  var Api_116 = /*#__PURE__*/React__default['default'].forwardRef(function Api_116(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$t || (_path78$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9H4a2 2 0 00-2 2V23H4V18H8v5h2V11A2 2 0 008 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14z"
    })), children);
  });
  var App32 = /*#__PURE__*/React__default['default'].forwardRef(function App32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$t || (_path79$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H22V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0028 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0018 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V12A2.0023 2.0023 0 008 10zm0 8H4V16H8z"
    })), children);
  });
  var App24 = /*#__PURE__*/React__default['default'].forwardRef(function App24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$t || (_path80$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H22V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0028 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0018 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V12A2.0023 2.0023 0 008 10zm0 8H4V16H8z"
    })), children);
  });
  var App20 = /*#__PURE__*/React__default['default'].forwardRef(function App20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$t || (_path81$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H22V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0028 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0018 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V12A2.0023 2.0023 0 008 10zm0 8H4V16H8z"
    })), children);
  });
  var App16 = /*#__PURE__*/React__default['default'].forwardRef(function App16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$t || (_path82$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H22V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0028 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0018 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V12A2.0023 2.0023 0 008 10zm0 8H4V16H8z"
    })), children);
  });
  var AppConnectivity32 = /*#__PURE__*/React__default['default'].forwardRef(function AppConnectivity32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$t || (_path83$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14h8a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2H9A2.0023,2.0023,0,0,0,7,6v4H4a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H6v4a2.0023,2.0023,0,0,0,2,2H18a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V20a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2v6H8V22h4a2.0023,2.0023,0,0,0,2-2V12a2.0023,2.0023,0,0,0-2-2H9V6h9v6A2.0023,2.0023,0,0,0,20,14Zm0,14V24h8v4Zm8-8,0,2H20V20ZM4,20V16h8v4Zm8.0005-6H4V12h8ZM20,12V8h8v4Zm8-8,0,2H20V4Z"
    })), children);
  });
  var AppConnectivity24 = /*#__PURE__*/React__default['default'].forwardRef(function AppConnectivity24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$t || (_path84$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14h8a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2H9A2.0023,2.0023,0,0,0,7,6v4H4a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H6v4a2.0023,2.0023,0,0,0,2,2H18a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V20a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2v6H8V22h4a2.0023,2.0023,0,0,0,2-2V12a2.0023,2.0023,0,0,0-2-2H9V6h9v6A2.0023,2.0023,0,0,0,20,14Zm0,14V24h8v4Zm8-8,0,2H20V20ZM4,20V16h8v4Zm8.0005-6H4V12h8ZM20,12V8h8v4Zm8-8,0,2H20V4Z"
    })), children);
  });
  var AppConnectivity20 = /*#__PURE__*/React__default['default'].forwardRef(function AppConnectivity20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$t || (_path85$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14h8a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2H9A2.0023,2.0023,0,0,0,7,6v4H4a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H6v4a2.0023,2.0023,0,0,0,2,2H18a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V20a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2v6H8V22h4a2.0023,2.0023,0,0,0,2-2V12a2.0023,2.0023,0,0,0-2-2H9V6h9v6A2.0023,2.0023,0,0,0,20,14Zm0,14V24h8v4Zm8-8,0,2H20V20ZM4,20V16h8v4Zm8.0005-6H4V12h8ZM20,12V8h8v4Zm8-8,0,2H20V4Z"
    })), children);
  });
  var AppConnectivity16 = /*#__PURE__*/React__default['default'].forwardRef(function AppConnectivity16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$t || (_path86$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14h8a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2H9A2.0023,2.0023,0,0,0,7,6v4H4a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H6v4a2.0023,2.0023,0,0,0,2,2H18a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V20a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2v6H8V22h4a2.0023,2.0023,0,0,0,2-2V12a2.0023,2.0023,0,0,0-2-2H9V6h9v6A2.0023,2.0023,0,0,0,20,14Zm0,14V24h8v4Zm8-8,0,2H20V20ZM4,20V16h8v4Zm8.0005-6H4V12h8ZM20,12V8h8v4Zm8-8,0,2H20V4Z"
    })), children);
  });
  var AppSwitcher32 = /*#__PURE__*/React__default['default'].forwardRef(function AppSwitcher32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$t);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['AppSwitcher32']) {
        didWarnAboutDeprecation$b['AppSwitcher32'] = true;
        console.warn("The AppSwitcher32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$t || (_path87$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var AppSwitcher24 = /*#__PURE__*/React__default['default'].forwardRef(function AppSwitcher24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$t);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['AppSwitcher24']) {
        didWarnAboutDeprecation$b['AppSwitcher24'] = true;
        console.warn("The AppSwitcher24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$t || (_path88$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var AppSwitcher20 = /*#__PURE__*/React__default['default'].forwardRef(function AppSwitcher20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$t);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['AppSwitcher20']) {
        didWarnAboutDeprecation$b['AppSwitcher20'] = true;
        console.warn("The AppSwitcher20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$t || (_path89$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var AppSwitcher16 = /*#__PURE__*/React__default['default'].forwardRef(function AppSwitcher16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$t);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['AppSwitcher16']) {
        didWarnAboutDeprecation$b['AppSwitcher16'] = true;
        console.warn("The AppSwitcher16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$t || (_path90$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var Apple32 = /*#__PURE__*/React__default['default'].forwardRef(function Apple32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$t || (_path91$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"
    })), _path92$t || (_path92$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"
    })), children);
  });
  var Apple24 = /*#__PURE__*/React__default['default'].forwardRef(function Apple24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$t || (_path93$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"
    })), _path94$t || (_path94$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"
    })), children);
  });
  var Apple20 = /*#__PURE__*/React__default['default'].forwardRef(function Apple20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$t || (_path95$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"
    })), _path96$t || (_path96$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"
    })), children);
  });
  var Apple16 = /*#__PURE__*/React__default['default'].forwardRef(function Apple16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$t || (_path97$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"
    })), _path98$t || (_path98$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"
    })), children);
  });
  var Application32 = /*#__PURE__*/React__default['default'].forwardRef(function Application32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$t || (_path99$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H6a2 2 0 01-2-2V6A2 2 0 016 4H16a2 2 0 012 2V16A2 2 0 0116 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V12a2 2 0 00-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2z"
    })), children);
  });
  var Application24 = /*#__PURE__*/React__default['default'].forwardRef(function Application24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$t || (_path100$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H6a2 2 0 01-2-2V6A2 2 0 016 4H16a2 2 0 012 2V16A2 2 0 0116 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V12a2 2 0 00-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2z"
    })), children);
  });
  var Application20 = /*#__PURE__*/React__default['default'].forwardRef(function Application20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$t || (_path101$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H6a2 2 0 01-2-2V6A2 2 0 016 4H16a2 2 0 012 2V16A2 2 0 0116 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V12a2 2 0 00-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2z"
    })), children);
  });
  var Application16 = /*#__PURE__*/React__default['default'].forwardRef(function Application16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$t || (_path102$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18H6a2 2 0 01-2-2V6A2 2 0 016 4H16a2 2 0 012 2V16A2 2 0 0116 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V12a2 2 0 00-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 00-2 2v4a2 2 0 002 2h4a2 2 0 002-2V22a2 2 0 00-2-2z"
    })), children);
  });
  var ApplicationMobile32 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationMobile32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$t || (_path103$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 7H27V11H23zM23 13H27V17H23zM17 7H21V11H17zM17 13H21V17H17z"
    })), _circle$s || (_circle$s = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "24.5",
      r: "1.5"
    })), _path104$t || (_path104$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H21V4H8V28H21V20h2v8A2.0023,2.0023,0,0,1,21,30Z"
    })), children);
  });
  var ApplicationMobile24 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationMobile24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$t || (_path105$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 7H27V11H23zM23 13H27V17H23zM17 7H21V11H17zM17 13H21V17H17z"
    })), _circle2$s || (_circle2$s = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "24.5",
      r: "1.5"
    })), _path106$t || (_path106$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H21V4H8V28H21V20h2v8A2.0023,2.0023,0,0,1,21,30Z"
    })), children);
  });
  var ApplicationMobile20 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationMobile20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$t || (_path107$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 7H27V11H23zM23 13H27V17H23zM17 7H21V11H17zM17 13H21V17H17z"
    })), _circle3$s || (_circle3$s = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "24.5",
      r: "1.5"
    })), _path108$t || (_path108$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H21V4H8V28H21V20h2v8A2.0023,2.0023,0,0,1,21,30Z"
    })), children);
  });
  var ApplicationMobile16 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationMobile16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$t || (_path109$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 7H27V11H23zM23 13H27V17H23zM17 7H21V11H17zM17 13H21V17H17z"
    })), _circle4$r || (_circle4$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "24.5",
      r: "1.5"
    })), _path110$t || (_path110$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H21V4H8V28H21V20h2v8A2.0023,2.0023,0,0,1,21,30Z"
    })), children);
  });
  var ApplicationVirtual32 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationVirtual32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$t || (_path111$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19H21V23H17zM11 19H15V23H11zM17 25H21V29H17zM11 25H15V29H11z"
    })), _path112$t || (_path112$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var ApplicationVirtual24 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationVirtual24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$t || (_path113$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19H21V23H17zM11 19H15V23H11zM17 25H21V29H17zM11 25H15V29H11z"
    })), _path114$t || (_path114$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var ApplicationVirtual20 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationVirtual20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$t || (_path115$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19H21V23H17zM11 19H15V23H11zM17 25H21V29H17zM11 25H15V29H11z"
    })), _path116$t || (_path116$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var ApplicationVirtual16 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationVirtual16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$t || (_path117$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19H21V23H17zM11 19H15V23H11zM17 25H21V29H17zM11 25H15V29H11z"
    })), _path118$t || (_path118$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var ApplicationWeb32 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationWeb32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$t || (_path119$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20z"
    })), _path120$t || (_path120$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), children);
  });
  var ApplicationWeb24 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationWeb24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$t || (_path121$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20z"
    })), _path122$t || (_path122$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), children);
  });
  var ApplicationWeb20 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationWeb20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$t || (_path123$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20z"
    })), _path124$t || (_path124$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), children);
  });
  var ApplicationWeb16 = /*#__PURE__*/React__default['default'].forwardRef(function ApplicationWeb16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$t || (_path125$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20z"
    })), _path126$t || (_path126$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), children);
  });
  var Apps32 = /*#__PURE__*/React__default['default'].forwardRef(function Apps32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$t || (_path127$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,4V8H4V4Zm2-2H2v8h8Zm8,2V8H14V4Zm2-2H12v8h8Zm8,2V8H24V4Zm2-2H22v8h8ZM8,14v4H4V14Zm2-2H2v8h8Zm8,2v4H14V14Zm2-2H12v8h8Zm8,2v4H24V14Zm2-2H22v8h8ZM8,24v4H4V24Zm2-2H2v8h8Zm8,2v4H14V24Zm2-2H12v8h8Zm8,2v4H24V24Zm2-2H22v8h8Z"
    })), children);
  });
  var Apps24 = /*#__PURE__*/React__default['default'].forwardRef(function Apps24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$t || (_path128$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,4V8H4V4Zm2-2H2v8h8Zm8,2V8H14V4Zm2-2H12v8h8Zm8,2V8H24V4Zm2-2H22v8h8ZM8,14v4H4V14Zm2-2H2v8h8Zm8,2v4H14V14Zm2-2H12v8h8Zm8,2v4H24V14Zm2-2H22v8h8ZM8,24v4H4V24Zm2-2H2v8h8Zm8,2v4H14V24Zm2-2H12v8h8Zm8,2v4H24V24Zm2-2H22v8h8Z"
    })), children);
  });
  var Apps20 = /*#__PURE__*/React__default['default'].forwardRef(function Apps20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$t || (_path129$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,4V8H4V4Zm2-2H2v8h8Zm8,2V8H14V4Zm2-2H12v8h8Zm8,2V8H24V4Zm2-2H22v8h8ZM8,14v4H4V14Zm2-2H2v8h8Zm8,2v4H14V14Zm2-2H12v8h8Zm8,2v4H24V14Zm2-2H22v8h8ZM8,24v4H4V24Zm2-2H2v8h8Zm8,2v4H14V24Zm2-2H12v8h8Zm8,2v4H24V24Zm2-2H22v8h8Z"
    })), children);
  });
  var Apps16 = /*#__PURE__*/React__default['default'].forwardRef(function Apps16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$t || (_path130$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2v2H2V2h2zm1-1H1v4h4V1zM9 2v2H7V2h2zm1-1H6v4h4V1zM14 2v2h-2V2h2zm1-1h-4v4h4V1zM4 7v2H2V7h2zm1-1H1v4h4V6zM9 7v2H7V7h2zm1-1H6v4h4V6zM14 7v2h-2V7h2zm1-1h-4v4h4V6zM4 12v2H2v-2h2zm1-1H1v4h4v-4zM9 12v2H7v-2h2zm1-1H6v4h4v-4zM14 12v2h-2v-2h2zm1-1h-4v4h4v-4z"
    })), children);
  });
  var Archive32 = /*#__PURE__*/React__default['default'].forwardRef(function Archive32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$t || (_path131$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 19H18V21H14z"
    })), _path132$t || (_path132$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"
    })), children);
  });
  var Archive24 = /*#__PURE__*/React__default['default'].forwardRef(function Archive24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$t || (_path133$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 19H18V21H14z"
    })), _path134$t || (_path134$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"
    })), children);
  });
  var Archive20 = /*#__PURE__*/React__default['default'].forwardRef(function Archive20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$t || (_path135$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 19H18V21H14z"
    })), _path136$t || (_path136$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"
    })), children);
  });
  var Archive16 = /*#__PURE__*/React__default['default'].forwardRef(function Archive16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$t || (_path137$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 19H18V21H14z"
    })), _path138$t || (_path138$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"
    })), children);
  });
  var Area32 = /*#__PURE__*/React__default['default'].forwardRef(function Area32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$t || (_path139$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var Area24 = /*#__PURE__*/React__default['default'].forwardRef(function Area24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$t || (_path140$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var Area20 = /*#__PURE__*/React__default['default'].forwardRef(function Area20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$t || (_path141$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var Area16 = /*#__PURE__*/React__default['default'].forwardRef(function Area16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$t || (_path142$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var AreaCustom32 = /*#__PURE__*/React__default['default'].forwardRef(function AreaCustom32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$t || (_path143$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a3.9916,3.9916,0,0,0-7.9773-.2241L9.5864,8.2627A3.99,3.99,0,1,0,5,13.8579v8.2842A3.9915,3.9915,0,1,0,9.8579,27h8.2842a3.9912,3.9912,0,1,0,5.595-4.5864l2.487-12.4361A3.9945,3.9945,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,10a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,4,10ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm12.1421-3H9.8579A3.9942,3.9942,0,0,0,7,22.1421V13.8579a3.9871,3.9871,0,0,0,2.9773-3.6338L22.4136,7.7373a4.0053,4.0053,0,0,0,1.8493,1.8491l-2.487,12.4361A3.9874,3.9874,0,0,0,18.1421,25ZM22,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,22,28Z"
    })), children);
  });
  var AreaCustom24 = /*#__PURE__*/React__default['default'].forwardRef(function AreaCustom24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$t || (_path144$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a3.9916,3.9916,0,0,0-7.9773-.2241L9.5864,8.2627A3.99,3.99,0,1,0,5,13.8579v8.2842A3.9915,3.9915,0,1,0,9.8579,27h8.2842a3.9912,3.9912,0,1,0,5.595-4.5864l2.487-12.4361A3.9945,3.9945,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,10a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,4,10ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm12.1421-3H9.8579A3.9942,3.9942,0,0,0,7,22.1421V13.8579a3.9871,3.9871,0,0,0,2.9773-3.6338L22.4136,7.7373a4.0053,4.0053,0,0,0,1.8493,1.8491l-2.487,12.4361A3.9874,3.9874,0,0,0,18.1421,25ZM22,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,22,28Z"
    })), children);
  });
  var AreaCustom20 = /*#__PURE__*/React__default['default'].forwardRef(function AreaCustom20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$t || (_path145$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a3.9916,3.9916,0,0,0-7.9773-.2241L9.5864,8.2627A3.99,3.99,0,1,0,5,13.8579v8.2842A3.9915,3.9915,0,1,0,9.8579,27h8.2842a3.9912,3.9912,0,1,0,5.595-4.5864l2.487-12.4361A3.9945,3.9945,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,10a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,4,10ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm12.1421-3H9.8579A3.9942,3.9942,0,0,0,7,22.1421V13.8579a3.9871,3.9871,0,0,0,2.9773-3.6338L22.4136,7.7373a4.0053,4.0053,0,0,0,1.8493,1.8491l-2.487,12.4361A3.9874,3.9874,0,0,0,18.1421,25ZM22,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,22,28Z"
    })), children);
  });
  var AreaCustom16 = /*#__PURE__*/React__default['default'].forwardRef(function AreaCustom16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$t || (_path146$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a3.9916,3.9916,0,0,0-7.9773-.2241L9.5864,8.2627A3.99,3.99,0,1,0,5,13.8579v8.2842A3.9915,3.9915,0,1,0,9.8579,27h8.2842a3.9912,3.9912,0,1,0,5.595-4.5864l2.487-12.4361A3.9945,3.9945,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,10a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,4,10ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm12.1421-3H9.8579A3.9942,3.9942,0,0,0,7,22.1421V13.8579a3.9871,3.9871,0,0,0,2.9773-3.6338L22.4136,7.7373a4.0053,4.0053,0,0,0,1.8493,1.8491l-2.487,12.4361A3.9874,3.9874,0,0,0,18.1421,25ZM22,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,22,28Z"
    })), children);
  });
  var Arrival32 = /*#__PURE__*/React__default['default'].forwardRef(function Arrival32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$t || (_path147$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0127 20.62a1.88 1.88 0 01-1.37 1.52 2 2 0 01-1 0l-18.7-5a1.89 1.89 0 01-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 00-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 009 7L5.87 6.14a.94.94 0 00-.5 0 1 1 0 00-.68.68l-2 7.49a3.87 3.87 0 002.74 4.74l18.71 5A3.87 3.87 0 0029 21a4 4 0 00-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 00-.72-.85L16.73 3a1.06 1.06 0 00-.5 0z"
    })), children);
  });
  var Arrival24 = /*#__PURE__*/React__default['default'].forwardRef(function Arrival24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$t || (_path148$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0127 20.62a1.88 1.88 0 01-1.37 1.52 2 2 0 01-1 0l-18.7-5a1.89 1.89 0 01-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 00-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 009 7L5.87 6.14a.94.94 0 00-.5 0 1 1 0 00-.68.68l-2 7.49a3.87 3.87 0 002.74 4.74l18.71 5A3.87 3.87 0 0029 21a4 4 0 00-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 00-.72-.85L16.73 3a1.06 1.06 0 00-.5 0z"
    })), children);
  });
  var Arrival20 = /*#__PURE__*/React__default['default'].forwardRef(function Arrival20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$t || (_path149$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0127 20.62a1.88 1.88 0 01-1.37 1.52 2 2 0 01-1 0l-18.7-5a1.89 1.89 0 01-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 00-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 009 7L5.87 6.14a.94.94 0 00-.5 0 1 1 0 00-.68.68l-2 7.49a3.87 3.87 0 002.74 4.74l18.71 5A3.87 3.87 0 0029 21a4 4 0 00-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 00-.72-.85L16.73 3a1.06 1.06 0 00-.5 0z"
    })), children);
  });
  var Arrival16 = /*#__PURE__*/React__default['default'].forwardRef(function Arrival16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$t || (_path150$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0127 20.62a1.88 1.88 0 01-1.37 1.52 2 2 0 01-1 0l-18.7-5a1.89 1.89 0 01-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 00-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 009 7L5.87 6.14a.94.94 0 00-.5 0 1 1 0 00-.68.68l-2 7.49a3.87 3.87 0 002.74 4.74l18.71 5A3.87 3.87 0 0029 21a4 4 0 00-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 00-.72-.85L16.73 3a1.06 1.06 0 00-.5 0z"
    })), children);
  });
  var WatsonHealthArrowAnnotation32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthArrowAnnotation32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$t || (_path151$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 002 2H28a2 2 0 002-2V12A2 2 0 0028 10z"
    })), _path152$t || (_path152$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"
    })), children);
  });
  var WatsonHealthArrowAnnotation24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthArrowAnnotation24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$t || (_path153$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 002 2H28a2 2 0 002-2V12A2 2 0 0028 10z"
    })), _path154$t || (_path154$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"
    })), children);
  });
  var WatsonHealthArrowAnnotation20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthArrowAnnotation20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$t || (_path155$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 002 2H28a2 2 0 002-2V12A2 2 0 0028 10z"
    })), _path156$t || (_path156$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"
    })), children);
  });
  var WatsonHealthArrowAnnotation16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthArrowAnnotation16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$t || (_path157$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 002 2H28a2 2 0 002-2V12A2 2 0 0028 10z"
    })), _path158$t || (_path158$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"
    })), children);
  });
  var ArrowDown32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDown32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$t || (_path159$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.59 16.59L17 24.17 17 4 15 4 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"
    })), children);
  });
  var ArrowDown24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDown24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$t || (_path160$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.59 16.59L17 24.17 17 4 15 4 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"
    })), children);
  });
  var ArrowDown20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDown20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$t || (_path161$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.59 16.59L17 24.17 17 4 15 4 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"
    })), children);
  });
  var ArrowDown16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDown16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$t || (_path162$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.3 9.3L8.5 13.1 8.5 1 7.5 1 7.5 13.1 3.7 9.3 3 10 8 15 13 10z"
    })), children);
  });
  var ArrowDownLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownLeft32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$t || (_path163$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"
    })), children);
  });
  var ArrowDownLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownLeft24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$t || (_path164$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"
    })), children);
  });
  var ArrowDownLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownLeft20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$t || (_path165$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"
    })), children);
  });
  var ArrowDownLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownLeft16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$t || (_path166$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"
    })), children);
  });
  var ArrowDownRight32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownRight32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$t || (_path167$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"
    })), children);
  });
  var ArrowDownRight24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownRight24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$t || (_path168$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"
    })), children);
  });
  var ArrowDownRight20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownRight20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$t || (_path169$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"
    })), children);
  });
  var ArrowDownRight16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowDownRight16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$t || (_path170$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"
    })), children);
  });
  var ArrowLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowLeft32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$t || (_path171$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26L15.41 24.59 7.83 17 28 17 28 15 7.83 15 15.41 7.41 14 6 4 16 14 26z"
    })), children);
  });
  var ArrowLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowLeft24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$t || (_path172$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26L15.41 24.59 7.83 17 28 17 28 15 7.83 15 15.41 7.41 14 6 4 16 14 26z"
    })), children);
  });
  var ArrowLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowLeft20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$t || (_path173$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26L15.41 24.59 7.83 17 28 17 28 15 7.83 15 15.41 7.41 14 6 4 16 14 26z"
    })), children);
  });
  var ArrowLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowLeft16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$t || (_path174$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.7 12.3L2.9 8.5 15 8.5 15 7.5 2.9 7.5 6.7 3.7 6 3 1 8 6 13z"
    })), children);
  });
  var ArrowRight32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowRight32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$t || (_path175$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 6L16.57 7.393 24.15 15 4 15 4 17 24.15 17 16.57 24.573 18 26 28 16 18 6z"
    })), children);
  });
  var ArrowRight24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowRight24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$t || (_path176$t = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4L12.9 5.1 18.9 11.2 2 11.2 2 12.8 18.9 12.8 12.9 18.9 14 20 22 12z"
    })), children);
  });
  var ArrowRight20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowRight20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$s || (_path177$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8 2.8L10.8 3.8 16.2 9.3 1 9.3 1 10.7 16.2 10.7 10.8 16.2 11.8 17.2 19 10z"
    })), children);
  });
  var ArrowRight16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowRight16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$t);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$s || (_path178$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.3 3.7L13.1 7.5 1 7.5 1 8.5 13.1 8.5 9.3 12.3 10 13 15 8 10 3z"
    })), children);
  });
  var ArrowUp32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUp32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$s || (_path179$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L6 14 7.41 15.41 15 7.83 15 28 17 28 17 7.83 24.59 15.41 26 14 16 4z"
    })), children);
  });
  var ArrowUp24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUp24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$s || (_path180$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L6 14 7.41 15.41 15 7.83 15 28 17 28 17 7.83 24.59 15.41 26 14 16 4z"
    })), children);
  });
  var ArrowUp20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUp20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$s || (_path181$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L6 14 7.41 15.41 15 7.83 15 28 17 28 17 7.83 24.59 15.41 26 14 16 4z"
    })), children);
  });
  var ArrowUp16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUp16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$s || (_path182$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.7 6.7L7.5 2.9 7.5 15 8.5 15 8.5 2.9 12.3 6.7 13 6 8 1 3 6z"
    })), children);
  });
  var ArrowUpLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpLeft32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$s || (_path183$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"
    })), children);
  });
  var ArrowUpLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpLeft24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$s || (_path184$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"
    })), children);
  });
  var ArrowUpLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpLeft20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$s || (_path185$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"
    })), children);
  });
  var ArrowUpLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpLeft16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$s || (_path186$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"
    })), children);
  });
  var ArrowUpRight32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpRight32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$s || (_path187$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"
    })), children);
  });
  var ArrowUpRight24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpRight24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$s || (_path188$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"
    })), children);
  });
  var ArrowUpRight20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpRight20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$s || (_path189$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"
    })), children);
  });
  var ArrowUpRight16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowUpRight16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$s || (_path190$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"
    })), children);
  });
  var ArrowShiftDown32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowShiftDown32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$s || (_path191$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H21V6H11V18H6.4141Z"
    })), children);
  });
  var ArrowShiftDown24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowShiftDown24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$s || (_path192$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H21V6H11V18H6.4141Z"
    })), children);
  });
  var ArrowShiftDown20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowShiftDown20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$s || (_path193$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H21V6H11V18H6.4141Z"
    })), children);
  });
  var ArrowShiftDown16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowShiftDown16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$s || (_path194$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H21V6H11V18H6.4141Z"
    })), children);
  });
  var Arrows32 = /*#__PURE__*/React__default['default'].forwardRef(function Arrows32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['Arrows32']) {
        didWarnAboutDeprecation$b['Arrows32'] = true;
        console.warn("The Arrows32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$s || (_path195$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var Arrows24 = /*#__PURE__*/React__default['default'].forwardRef(function Arrows24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['Arrows24']) {
        didWarnAboutDeprecation$b['Arrows24'] = true;
        console.warn("The Arrows24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$s || (_path196$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var Arrows20 = /*#__PURE__*/React__default['default'].forwardRef(function Arrows20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['Arrows20']) {
        didWarnAboutDeprecation$b['Arrows20'] = true;
        console.warn("The Arrows20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$s || (_path197$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var Arrows16 = /*#__PURE__*/React__default['default'].forwardRef(function Arrows16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['Arrows16']) {
        didWarnAboutDeprecation$b['Arrows16'] = true;
        console.warn("The Arrows16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$s || (_path198$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var ArrowsHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsHorizontal32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$s || (_path199$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"
    })), children);
  });
  var ArrowsHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsHorizontal24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$s || (_path200$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"
    })), children);
  });
  var ArrowsHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsHorizontal20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$s || (_path201$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"
    })), children);
  });
  var ArrowsHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsHorizontal16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$s || (_path202$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"
    })), children);
  });
  var ArrowsVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsVertical32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$s || (_path203$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var ArrowsVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsVertical24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$s || (_path204$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var ArrowsVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsVertical20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$s || (_path205$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var ArrowsVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function ArrowsVertical16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$s || (_path206$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6 20.6L24 24.2 24 4 22 4 22 24.2 18.4 20.6 17 22 23 28 29 22zM9 4L3 10 4.4 11.4 8 7.8 8 28 10 28 10 7.8 13.6 11.4 15 10z"
    })), children);
  });
  var Asleep32 = /*#__PURE__*/React__default['default'].forwardRef(function Asleep32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$s || (_path207$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Asleep24 = /*#__PURE__*/React__default['default'].forwardRef(function Asleep24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$s || (_path208$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Asleep20 = /*#__PURE__*/React__default['default'].forwardRef(function Asleep20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$s || (_path209$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Asleep16 = /*#__PURE__*/React__default['default'].forwardRef(function Asleep16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$s || (_path210$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.2,2.3c-1,4.4,1.7,8.7,6.1,9.8c0.1,0,0.1,0,0.2,0c-1.1,1.2-2.7,1.8-4.3,1.8c-0.1,0-0.2,0-0.2,0C5.6,13.8,3,11,3.2,7.7\tC3.2,5.3,4.8,3.1,7.2,2.3 M8,1L8,1C4.1,1.6,1.5,5.3,2.1,9.1c0.6,3.3,3.4,5.8,6.8,5.9c0.1,0,0.2,0,0.3,0c2.3,0,4.4-1.1,5.8-3\tc0.2-0.2,0.1-0.6-0.1-0.7c-0.1-0.1-0.2-0.1-0.3-0.1c-3.9-0.3-6.7-3.8-6.4-7.6C8.3,3,8.4,2.4,8.6,1.8c0.1-0.3,0-0.6-0.3-0.7\tC8.1,1,8.1,1,8,1z"
    })), children);
  });
  var AsleepFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function AsleepFilled32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$s || (_path211$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var AsleepFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function AsleepFilled24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$s || (_path212$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var AsleepFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function AsleepFilled20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$s || (_path213$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var AsleepFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function AsleepFilled16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$s || (_path214$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Asset32 = /*#__PURE__*/React__default['default'].forwardRef(function Asset32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$s || (_path215$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12,18Z"
    })), _path216$s || (_path216$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"
    })), children);
  });
  var Asset24 = /*#__PURE__*/React__default['default'].forwardRef(function Asset24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$s || (_path217$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12,18Z"
    })), _path218$s || (_path218$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"
    })), children);
  });
  var Asset20 = /*#__PURE__*/React__default['default'].forwardRef(function Asset20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$s || (_path219$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12,18Z"
    })), _path220$s || (_path220$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"
    })), children);
  });
  var Asset16 = /*#__PURE__*/React__default['default'].forwardRef(function Asset16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$s || (_path221$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12,18Z"
    })), _path222$s || (_path222$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"
    })), children);
  });
  var AssetConfirm32 = /*#__PURE__*/React__default['default'].forwardRef(function AssetConfirm32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$s || (_path223$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 27.18L18.41 24.59 17 26 21 30 28 23 26.59 21.59 21 27.18zM12 24a4 4 0 114-4A4.0042 4.0042 0 0112 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0012 18z"
    })), _path224$s || (_path224$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30a9.3445,9.3445,0,0,0,2-.21V27.75A8.2289,8.2289,0,0,1,12,28a8,8,0,1,1,8-8,8.2656,8.2656,0,0,1-.06,1h2.78L29.56,7.79A3.9727,3.9727,0,0,0,26,2ZM21.86,18.34a10.0187,10.0187,0,0,0-8.22-8.19l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02ZM26,8a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetConfirm24 = /*#__PURE__*/React__default['default'].forwardRef(function AssetConfirm24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$s || (_path225$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 27.18L18.41 24.59 17 26 21 30 28 23 26.59 21.59 21 27.18zM12 24a4 4 0 114-4A4.0042 4.0042 0 0112 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0012 18z"
    })), _path226$s || (_path226$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30a9.3445,9.3445,0,0,0,2-.21V27.75A8.2289,8.2289,0,0,1,12,28a8,8,0,1,1,8-8,8.2656,8.2656,0,0,1-.06,1h2.78L29.56,7.79A3.9727,3.9727,0,0,0,26,2ZM21.86,18.34a10.0187,10.0187,0,0,0-8.22-8.19l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02ZM26,8a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetConfirm20 = /*#__PURE__*/React__default['default'].forwardRef(function AssetConfirm20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$s || (_path227$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 27.18L18.41 24.59 17 26 21 30 28 23 26.59 21.59 21 27.18zM12 24a4 4 0 114-4A4.0042 4.0042 0 0112 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0012 18z"
    })), _path228$s || (_path228$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30a9.3445,9.3445,0,0,0,2-.21V27.75A8.2289,8.2289,0,0,1,12,28a8,8,0,1,1,8-8,8.2656,8.2656,0,0,1-.06,1h2.78L29.56,7.79A3.9727,3.9727,0,0,0,26,2ZM21.86,18.34a10.0187,10.0187,0,0,0-8.22-8.19l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02ZM26,8a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetConfirm16 = /*#__PURE__*/React__default['default'].forwardRef(function AssetConfirm16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$s || (_path229$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 27.18L18.41 24.59 17 26 21 30 28 23 26.59 21.59 21 27.18zM12 24a4 4 0 114-4A4.0042 4.0042 0 0112 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0012 18z"
    })), _path230$s || (_path230$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30a9.3445,9.3445,0,0,0,2-.21V27.75A8.2289,8.2289,0,0,1,12,28a8,8,0,1,1,8-8,8.2656,8.2656,0,0,1-.06,1h2.78L29.56,7.79A3.9727,3.9727,0,0,0,26,2ZM21.86,18.34a10.0187,10.0187,0,0,0-8.22-8.19l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02ZM26,8a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetDigitalTwin32 = /*#__PURE__*/React__default['default'].forwardRef(function AssetDigitalTwin32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$q || (_circle5$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "2"
    })), _path231$s || (_path231$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,12,23Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,12,19Z"
    })), _circle6$q || (_circle6$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "14",
      r: "1"
    })), _circle7$q || (_circle7$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.909",
      cy: "5.705",
      r: "1"
    })), _circle8$q || (_circle8$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.787",
      cy: "9.907",
      r: "1"
    })), _circle9$q || (_circle9$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12.495",
      cy: "8.506",
      r: "1"
    })), _circle10$q || (_circle10$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.201",
      cy: "7.105",
      r: "1"
    })), _circle11$p || (_circle11$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.696",
      cy: "13.187",
      r: "1"
    })), _circle12$p || (_circle12$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.133",
      cy: "21.631",
      r: "1"
    })), _circle13$p || (_circle13$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3.079",
      cy: "24.516",
      r: "1"
    })), _circle14$p || (_circle14$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.848",
      cy: "26.982",
      r: "1"
    })), _circle15$p || (_circle15$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.272",
      cy: "28.81",
      r: "1"
    })), _circle16$p || (_circle16$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.098",
      cy: "18.596",
      r: "1"
    })), _circle17$m || (_circle17$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.979",
      cy: "15.691",
      r: "1"
    })), _circle18$m || (_circle18$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.081",
      cy: "11.308",
      r: "1"
    })), _circle19$m || (_circle19$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.616",
      cy: "4.304",
      r: "1"
    })), _circle20$m || (_circle20$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.323",
      cy: "2.903",
      r: "1"
    })), _circle21$l || (_circle21$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.988",
      cy: "8.89",
      r: "1"
    })), _circle22$l || (_circle22$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27.587",
      cy: "11.596",
      r: "1"
    })), _circle23$k || (_circle23$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.186",
      cy: "14.303",
      r: "1"
    })), _circle24$k || (_circle24$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.784",
      cy: "17.01",
      r: "1"
    })), _circle25$j || (_circle25$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.383",
      cy: "19.717",
      r: "1"
    })), _circle26$j || (_circle26$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.982",
      cy: "22.424",
      r: "1"
    })), _circle27$i || (_circle27$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.637",
      cy: "27.464",
      r: "1"
    })), _circle28$i || (_circle28$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.092",
      cy: "29.122",
      r: "1"
    })), _circle29$h || (_circle29$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.166",
      cy: "29.932",
      r: "1"
    })), _circle30$h || (_circle30$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.133",
      cy: "29.825",
      r: "1"
    })), _circle31$h || (_circle31$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.572",
      cy: "25.125",
      r: "1"
    })), _circle32$h || (_circle32$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.893",
      cy: "3.24",
      r: "1"
    })), _circle33$g || (_circle33$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.188",
      cy: "2.004",
      r: "1"
    })), _circle34$f || (_circle34$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "26",
      r: "1"
    })), _circle35$f || (_circle35$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle36$f || (_circle36$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "20",
      r: "1"
    })), _circle37$d || (_circle37$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "17",
      r: "1"
    })), _circle38$d || (_circle38$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "23",
      r: "1"
    })), _circle39$d || (_circle39$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25.196",
      r: "1"
    })), _circle40$d || (_circle40$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "14.804",
      r: "1"
    })), _circle41$c || (_circle41$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "14.804",
      r: "1"
    })), _circle42$c || (_circle42$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25.196",
      r: "1"
    })), _circle43$c || (_circle43$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "23",
      r: "1"
    })), _circle44$c || (_circle44$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "17",
      r: "1"
    })), _circle45$b || (_circle45$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "30",
      cy: "6.026",
      r: "1"
    })), children);
  });
  var AssetDigitalTwin24 = /*#__PURE__*/React__default['default'].forwardRef(function AssetDigitalTwin24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle46$b || (_circle46$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "2"
    })), _path232$s || (_path232$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,12,23Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,12,19Z"
    })), _circle47$b || (_circle47$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "14",
      r: "1"
    })), _circle48$b || (_circle48$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.909",
      cy: "5.705",
      r: "1"
    })), _circle49$a || (_circle49$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.787",
      cy: "9.907",
      r: "1"
    })), _circle50$9 || (_circle50$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12.495",
      cy: "8.506",
      r: "1"
    })), _circle51$9 || (_circle51$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.201",
      cy: "7.105",
      r: "1"
    })), _circle52$9 || (_circle52$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.696",
      cy: "13.187",
      r: "1"
    })), _circle53$8 || (_circle53$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.133",
      cy: "21.631",
      r: "1"
    })), _circle54$8 || (_circle54$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3.079",
      cy: "24.516",
      r: "1"
    })), _circle55$7 || (_circle55$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.848",
      cy: "26.982",
      r: "1"
    })), _circle56$7 || (_circle56$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.272",
      cy: "28.81",
      r: "1"
    })), _circle57$7 || (_circle57$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.098",
      cy: "18.596",
      r: "1"
    })), _circle58$7 || (_circle58$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.979",
      cy: "15.691",
      r: "1"
    })), _circle59$7 || (_circle59$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.081",
      cy: "11.308",
      r: "1"
    })), _circle60$7 || (_circle60$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.616",
      cy: "4.304",
      r: "1"
    })), _circle61$7 || (_circle61$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.323",
      cy: "2.903",
      r: "1"
    })), _circle62$7 || (_circle62$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.988",
      cy: "8.89",
      r: "1"
    })), _circle63$7 || (_circle63$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27.587",
      cy: "11.596",
      r: "1"
    })), _circle64$7 || (_circle64$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.186",
      cy: "14.303",
      r: "1"
    })), _circle65$7 || (_circle65$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.784",
      cy: "17.01",
      r: "1"
    })), _circle66$7 || (_circle66$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.383",
      cy: "19.717",
      r: "1"
    })), _circle67$7 || (_circle67$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.982",
      cy: "22.424",
      r: "1"
    })), _circle68$7 || (_circle68$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.637",
      cy: "27.464",
      r: "1"
    })), _circle69$7 || (_circle69$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.092",
      cy: "29.122",
      r: "1"
    })), _circle70$7 || (_circle70$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.166",
      cy: "29.932",
      r: "1"
    })), _circle71$7 || (_circle71$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.133",
      cy: "29.825",
      r: "1"
    })), _circle72$7 || (_circle72$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.572",
      cy: "25.125",
      r: "1"
    })), _circle73$6 || (_circle73$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.893",
      cy: "3.24",
      r: "1"
    })), _circle74$6 || (_circle74$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.188",
      cy: "2.004",
      r: "1"
    })), _circle75$6 || (_circle75$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "26",
      r: "1"
    })), _circle76$6 || (_circle76$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle77$6 || (_circle77$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "20",
      r: "1"
    })), _circle78$6 || (_circle78$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "17",
      r: "1"
    })), _circle79$6 || (_circle79$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "23",
      r: "1"
    })), _circle80$6 || (_circle80$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25.196",
      r: "1"
    })), _circle81$6 || (_circle81$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "14.804",
      r: "1"
    })), _circle82$6 || (_circle82$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "14.804",
      r: "1"
    })), _circle83$6 || (_circle83$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25.196",
      r: "1"
    })), _circle84$6 || (_circle84$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "23",
      r: "1"
    })), _circle85$5 || (_circle85$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "17",
      r: "1"
    })), _circle86$5 || (_circle86$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "30",
      cy: "6.026",
      r: "1"
    })), children);
  });
  var AssetDigitalTwin20 = /*#__PURE__*/React__default['default'].forwardRef(function AssetDigitalTwin20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle87$5 || (_circle87$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "2"
    })), _path233$s || (_path233$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,12,23Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,12,19Z"
    })), _circle88$5 || (_circle88$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "14",
      r: "1"
    })), _circle89$4 || (_circle89$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.909",
      cy: "5.705",
      r: "1"
    })), _circle90$4 || (_circle90$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.787",
      cy: "9.907",
      r: "1"
    })), _circle91$4 || (_circle91$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12.495",
      cy: "8.506",
      r: "1"
    })), _circle92$4 || (_circle92$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.201",
      cy: "7.105",
      r: "1"
    })), _circle93$4 || (_circle93$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.696",
      cy: "13.187",
      r: "1"
    })), _circle94$4 || (_circle94$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.133",
      cy: "21.631",
      r: "1"
    })), _circle95$4 || (_circle95$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3.079",
      cy: "24.516",
      r: "1"
    })), _circle96$4 || (_circle96$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.848",
      cy: "26.982",
      r: "1"
    })), _circle97$4 || (_circle97$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.272",
      cy: "28.81",
      r: "1"
    })), _circle98$4 || (_circle98$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.098",
      cy: "18.596",
      r: "1"
    })), _circle99$4 || (_circle99$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.979",
      cy: "15.691",
      r: "1"
    })), _circle100$4 || (_circle100$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.081",
      cy: "11.308",
      r: "1"
    })), _circle101$3 || (_circle101$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.616",
      cy: "4.304",
      r: "1"
    })), _circle102$3 || (_circle102$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.323",
      cy: "2.903",
      r: "1"
    })), _circle103$3 || (_circle103$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.988",
      cy: "8.89",
      r: "1"
    })), _circle104$3 || (_circle104$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27.587",
      cy: "11.596",
      r: "1"
    })), _circle105$3 || (_circle105$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.186",
      cy: "14.303",
      r: "1"
    })), _circle106$3 || (_circle106$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.784",
      cy: "17.01",
      r: "1"
    })), _circle107$3 || (_circle107$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.383",
      cy: "19.717",
      r: "1"
    })), _circle108$3 || (_circle108$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.982",
      cy: "22.424",
      r: "1"
    })), _circle109$3 || (_circle109$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.637",
      cy: "27.464",
      r: "1"
    })), _circle110$3 || (_circle110$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.092",
      cy: "29.122",
      r: "1"
    })), _circle111$3 || (_circle111$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.166",
      cy: "29.932",
      r: "1"
    })), _circle112$3 || (_circle112$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.133",
      cy: "29.825",
      r: "1"
    })), _circle113$3 || (_circle113$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.572",
      cy: "25.125",
      r: "1"
    })), _circle114$3 || (_circle114$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.893",
      cy: "3.24",
      r: "1"
    })), _circle115$3 || (_circle115$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.188",
      cy: "2.004",
      r: "1"
    })), _circle116$3 || (_circle116$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "26",
      r: "1"
    })), _circle117$2 || (_circle117$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle118$2 || (_circle118$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "20",
      r: "1"
    })), _circle119$2 || (_circle119$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "17",
      r: "1"
    })), _circle120$2 || (_circle120$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "23",
      r: "1"
    })), _circle121$2 || (_circle121$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25.196",
      r: "1"
    })), _circle122$1 || (_circle122$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "14.804",
      r: "1"
    })), _circle123$1 || (_circle123$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "14.804",
      r: "1"
    })), _circle124$1 || (_circle124$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25.196",
      r: "1"
    })), _circle125$1 || (_circle125$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "23",
      r: "1"
    })), _circle126$1 || (_circle126$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "17",
      r: "1"
    })), _circle127$1 || (_circle127$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "30",
      cy: "6.026",
      r: "1"
    })), children);
  });
  var AssetDigitalTwin16 = /*#__PURE__*/React__default['default'].forwardRef(function AssetDigitalTwin16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle128$1 || (_circle128$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "2"
    })), _path234$s || (_path234$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,12,23Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,12,19Z"
    })), _circle129$1 || (_circle129$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "14",
      r: "1"
    })), _circle130$1 || (_circle130$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.909",
      cy: "5.705",
      r: "1"
    })), _circle131$1 || (_circle131$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.787",
      cy: "9.907",
      r: "1"
    })), _circle132$1 || (_circle132$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12.495",
      cy: "8.506",
      r: "1"
    })), _circle133$1 || (_circle133$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.201",
      cy: "7.105",
      r: "1"
    })), _circle134$1 || (_circle134$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.696",
      cy: "13.187",
      r: "1"
    })), _circle135$1 || (_circle135$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.133",
      cy: "21.631",
      r: "1"
    })), _circle136$1 || (_circle136$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3.079",
      cy: "24.516",
      r: "1"
    })), _circle137 || (_circle137 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.848",
      cy: "26.982",
      r: "1"
    })), _circle138 || (_circle138 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.272",
      cy: "28.81",
      r: "1"
    })), _circle139 || (_circle139 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.098",
      cy: "18.596",
      r: "1"
    })), _circle140 || (_circle140 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "2.979",
      cy: "15.691",
      r: "1"
    })), _circle141 || (_circle141 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.081",
      cy: "11.308",
      r: "1"
    })), _circle142 || (_circle142 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.616",
      cy: "4.304",
      r: "1"
    })), _circle143 || (_circle143 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.323",
      cy: "2.903",
      r: "1"
    })), _circle144 || (_circle144 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.988",
      cy: "8.89",
      r: "1"
    })), _circle145 || (_circle145 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27.587",
      cy: "11.596",
      r: "1"
    })), _circle146 || (_circle146 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.186",
      cy: "14.303",
      r: "1"
    })), _circle147 || (_circle147 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.784",
      cy: "17.01",
      r: "1"
    })), _circle148 || (_circle148 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23.383",
      cy: "19.717",
      r: "1"
    })), _circle149 || (_circle149 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.982",
      cy: "22.424",
      r: "1"
    })), _circle150 || (_circle150 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18.637",
      cy: "27.464",
      r: "1"
    })), _circle151 || (_circle151 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.092",
      cy: "29.122",
      r: "1"
    })), _circle152 || (_circle152 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.166",
      cy: "29.932",
      r: "1"
    })), _circle153 || (_circle153 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.133",
      cy: "29.825",
      r: "1"
    })), _circle154 || (_circle154 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.572",
      cy: "25.125",
      r: "1"
    })), _circle155 || (_circle155 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28.893",
      cy: "3.24",
      r: "1"
    })), _circle156 || (_circle156 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26.188",
      cy: "2.004",
      r: "1"
    })), _circle157 || (_circle157 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "26",
      r: "1"
    })), _circle158 || (_circle158 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle159 || (_circle159 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "20",
      r: "1"
    })), _circle160 || (_circle160 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "17",
      r: "1"
    })), _circle161 || (_circle161 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "23",
      r: "1"
    })), _circle162 || (_circle162 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25.196",
      r: "1"
    })), _circle163 || (_circle163 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "14.804",
      r: "1"
    })), _circle164 || (_circle164 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "14.804",
      r: "1"
    })), _circle165 || (_circle165 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25.196",
      r: "1"
    })), _circle166 || (_circle166 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6.804",
      cy: "23",
      r: "1"
    })), _circle167 || (_circle167 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.196",
      cy: "17",
      r: "1"
    })), _circle168 || (_circle168 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "30",
      cy: "6.026",
      r: "1"
    })), children);
  });
  var AssetView32 = /*#__PURE__*/React__default['default'].forwardRef(function AssetView32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle169 || (_circle169 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path235$s || (_path235$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM12 24a4 4 0 112.981-6.667l-1.49 1.334A2 2 0 1012 22z"
    })), _path236$s || (_path236$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30V28a8,8,0,1,1,5.63-13.68l1.4-1.4a10.0059,10.0059,0,0,0-5.39-2.77l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02L23.07,16h2.24l4.25-8.21A3.9727,3.9727,0,0,0,26,2Zm0,6a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetView24 = /*#__PURE__*/React__default['default'].forwardRef(function AssetView24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle170 || (_circle170 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path237$s || (_path237$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM12 24a4 4 0 112.981-6.667l-1.49 1.334A2 2 0 1012 22z"
    })), _path238$s || (_path238$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30V28a8,8,0,1,1,5.63-13.68l1.4-1.4a10.0059,10.0059,0,0,0-5.39-2.77l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02L23.07,16h2.24l4.25-8.21A3.9727,3.9727,0,0,0,26,2Zm0,6a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetView20 = /*#__PURE__*/React__default['default'].forwardRef(function AssetView20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle171 || (_circle171 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path239$s || (_path239$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM12 24a4 4 0 112.981-6.667l-1.49 1.334A2 2 0 1012 22z"
    })), _path240$s || (_path240$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30V28a8,8,0,1,1,5.63-13.68l1.4-1.4a10.0059,10.0059,0,0,0-5.39-2.77l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02L23.07,16h2.24l4.25-8.21A3.9727,3.9727,0,0,0,26,2Zm0,6a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var AssetView16 = /*#__PURE__*/React__default['default'].forwardRef(function AssetView16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle172 || (_circle172 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path241$s || (_path241$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM12 24a4 4 0 112.981-6.667l-1.49 1.334A2 2 0 1012 22z"
    })), _path242$s || (_path242$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a3.86,3.86,0,0,0-1.85.48L7.76,10.96A9.99,9.99,0,0,0,12,30V28a8,8,0,1,1,5.63-13.68l1.4-1.4a10.0059,10.0059,0,0,0-5.39-2.77l8.38-4.34c0,.06-.02.12-.02.19a3.9989,3.9989,0,0,0,4,4c.06,0,.12-.02.19-.02L23.07,16h2.24l4.25-8.21A3.9727,3.9727,0,0,0,26,2Zm0,6a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,8Z"
    })), children);
  });
  var Asterisk32 = /*#__PURE__*/React__default['default'].forwardRef(function Asterisk32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$s || (_path243$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.316 13.949L27.684 12.051 17 15.612 17 4 15 4 15 15.612 4.316 12.051 3.684 13.949 14.368 17.51 7.2 27.066 8.8 28.267 16 18.667 23.2 28.267 24.8 27.066 17.632 17.51 28.316 13.949z"
    })), children);
  });
  var Asterisk24 = /*#__PURE__*/React__default['default'].forwardRef(function Asterisk24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$s || (_path244$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.316 13.949L27.684 12.051 17 15.612 17 4 15 4 15 15.612 4.316 12.051 3.684 13.949 14.368 17.51 7.2 27.066 8.8 28.267 16 18.667 23.2 28.267 24.8 27.066 17.632 17.51 28.316 13.949z"
    })), children);
  });
  var Asterisk20 = /*#__PURE__*/React__default['default'].forwardRef(function Asterisk20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$s || (_path245$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.316 13.949L27.684 12.051 17 15.612 17 4 15 4 15 15.612 4.316 12.051 3.684 13.949 14.368 17.51 7.2 27.066 8.8 28.267 16 18.667 23.2 28.267 24.8 27.066 17.632 17.51 28.316 13.949z"
    })), children);
  });
  var Asterisk16 = /*#__PURE__*/React__default['default'].forwardRef(function Asterisk16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$s || (_path246$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.316 13.949L27.684 12.051 17 15.612 17 4 15 4 15 15.612 4.316 12.051 3.684 13.949 14.368 17.51 7.2 27.066 8.8 28.267 16 18.667 23.2 28.267 24.8 27.066 17.632 17.51 28.316 13.949z"
    })), children);
  });
  var At32 = /*#__PURE__*/React__default['default'].forwardRef(function At32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$s || (_path247$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"
    })), children);
  });
  var At24 = /*#__PURE__*/React__default['default'].forwardRef(function At24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$s || (_path248$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"
    })), children);
  });
  var At20 = /*#__PURE__*/React__default['default'].forwardRef(function At20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$s || (_path249$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"
    })), children);
  });
  var At16 = /*#__PURE__*/React__default['default'].forwardRef(function At16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$s || (_path250$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"
    })), children);
  });
  var Attachment32 = /*#__PURE__*/React__default['default'].forwardRef(function Attachment32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$s || (_path251$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1,18.9L13.1,3.9c-2.5-2.6-6.6-2.6-9.2-0.1S1.3,10.5,3.9,13c0,0,0.1,0.1,0.1,0.1L6.8,16l1.4-1.4l-2.9-2.9\tC3.6,10,3.6,7.1,5.3,5.4s4.6-1.8,6.3-0.1c0,0,0,0,0.1,0.1l14.9,14.9c1.8,1.7,1.8,4.6,0.1,6.3c-1.7,1.8-4.6,1.8-6.3,0.1\tc0,0,0,0-0.1-0.1l-7.4-7.4c-1-1-0.9-2.6,0-3.5c1-0.9,2.5-0.9,3.5,0l4.1,4.1l1.4-1.4c0,0-4.2-4.2-4.2-4.2c-1.8-1.7-4.6-1.6-6.3,0.2\tc-1.6,1.7-1.6,4.4,0,6.2l7.5,7.5c2.5,2.6,6.6,2.6,9.2,0.1S30.7,21.5,28.1,18.9C28.1,19,28.1,18.9,28.1,18.9L28.1,18.9z"
    })), children);
  });
  var Attachment24 = /*#__PURE__*/React__default['default'].forwardRef(function Attachment24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$s || (_path252$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1,18.9L13.1,3.9c-2.5-2.6-6.6-2.6-9.2-0.1S1.3,10.5,3.9,13c0,0,0.1,0.1,0.1,0.1L6.8,16l1.4-1.4l-2.9-2.9\tC3.6,10,3.6,7.1,5.3,5.4s4.6-1.8,6.3-0.1c0,0,0,0,0.1,0.1l14.9,14.9c1.8,1.7,1.8,4.6,0.1,6.3c-1.7,1.8-4.6,1.8-6.3,0.1\tc0,0,0,0-0.1-0.1l-7.4-7.4c-1-1-0.9-2.6,0-3.5c1-0.9,2.5-0.9,3.5,0l4.1,4.1l1.4-1.4c0,0-4.2-4.2-4.2-4.2c-1.8-1.7-4.6-1.6-6.3,0.2\tc-1.6,1.7-1.6,4.4,0,6.2l7.5,7.5c2.5,2.6,6.6,2.6,9.2,0.1S30.7,21.5,28.1,18.9C28.1,19,28.1,18.9,28.1,18.9L28.1,18.9z"
    })), children);
  });
  var Attachment20 = /*#__PURE__*/React__default['default'].forwardRef(function Attachment20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$s || (_path253$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1,18.9L13.1,3.9c-2.5-2.6-6.6-2.6-9.2-0.1S1.3,10.5,3.9,13c0,0,0.1,0.1,0.1,0.1L6.8,16l1.4-1.4l-2.9-2.9\tC3.6,10,3.6,7.1,5.3,5.4s4.6-1.8,6.3-0.1c0,0,0,0,0.1,0.1l14.9,14.9c1.8,1.7,1.8,4.6,0.1,6.3c-1.7,1.8-4.6,1.8-6.3,0.1\tc0,0,0,0-0.1-0.1l-7.4-7.4c-1-1-0.9-2.6,0-3.5c1-0.9,2.5-0.9,3.5,0l4.1,4.1l1.4-1.4c0,0-4.2-4.2-4.2-4.2c-1.8-1.7-4.6-1.6-6.3,0.2\tc-1.6,1.7-1.6,4.4,0,6.2l7.5,7.5c2.5,2.6,6.6,2.6,9.2,0.1S30.7,21.5,28.1,18.9C28.1,19,28.1,18.9,28.1,18.9L28.1,18.9z"
    })), children);
  });
  var Attachment16 = /*#__PURE__*/React__default['default'].forwardRef(function Attachment16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$s || (_path254$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1,18.9L13.1,3.9c-2.5-2.6-6.6-2.6-9.2-0.1S1.3,10.5,3.9,13c0,0,0.1,0.1,0.1,0.1L6.8,16l1.4-1.4l-2.9-2.9\tC3.6,10,3.6,7.1,5.3,5.4s4.6-1.8,6.3-0.1c0,0,0,0,0.1,0.1l14.9,14.9c1.8,1.7,1.8,4.6,0.1,6.3c-1.7,1.8-4.6,1.8-6.3,0.1\tc0,0,0,0-0.1-0.1l-7.4-7.4c-1-1-0.9-2.6,0-3.5c1-0.9,2.5-0.9,3.5,0l4.1,4.1l1.4-1.4c0,0-4.2-4.2-4.2-4.2c-1.8-1.7-4.6-1.6-6.3,0.2\tc-1.6,1.7-1.6,4.4,0,6.2l7.5,7.5c2.5,2.6,6.6,2.6,9.2,0.1S30.7,21.5,28.1,18.9C28.1,19,28.1,18.9,28.1,18.9L28.1,18.9z"
    })), children);
  });
  var AudioConsole32 = /*#__PURE__*/React__default['default'].forwardRef(function AudioConsole32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$s || (_path255$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14H27V2H25V14H24a2.0019 2.0019 0 00-2 2v2a2.0023 2.0023 0 002 2h1V30h2V20h1a2.0027 2.0027 0 002-2V16A2.0023 2.0023 0 0028 14zm0 4H24V16h4zM18 6H17V2H15V6H14a2.0019 2.0019 0 00-2 2v2a2.0019 2.0019 0 002 2h1V30h2V12h1a2.002 2.002 0 002-2V8A2.002 2.002 0 0018 6zm0 4H14V8h4zM8 20H7V2H5V20H4a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2H5v4H7V26H8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 008 20zm0 4H4V22H8z",
      transform: "translate(0 .005)"
    })), children);
  });
  var AudioConsole24 = /*#__PURE__*/React__default['default'].forwardRef(function AudioConsole24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$s || (_path256$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14H27V2H25V14H24a2.0019 2.0019 0 00-2 2v2a2.0023 2.0023 0 002 2h1V30h2V20h1a2.0027 2.0027 0 002-2V16A2.0023 2.0023 0 0028 14zm0 4H24V16h4zM18 6H17V2H15V6H14a2.0019 2.0019 0 00-2 2v2a2.0019 2.0019 0 002 2h1V30h2V12h1a2.002 2.002 0 002-2V8A2.002 2.002 0 0018 6zm0 4H14V8h4zM8 20H7V2H5V20H4a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2H5v4H7V26H8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 008 20zm0 4H4V22H8z",
      transform: "translate(0 .005)"
    })), children);
  });
  var AudioConsole20 = /*#__PURE__*/React__default['default'].forwardRef(function AudioConsole20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$s || (_path257$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14H27V2H25V14H24a2.0019 2.0019 0 00-2 2v2a2.0023 2.0023 0 002 2h1V30h2V20h1a2.0027 2.0027 0 002-2V16A2.0023 2.0023 0 0028 14zm0 4H24V16h4zM18 6H17V2H15V6H14a2.0019 2.0019 0 00-2 2v2a2.0019 2.0019 0 002 2h1V30h2V12h1a2.002 2.002 0 002-2V8A2.002 2.002 0 0018 6zm0 4H14V8h4zM8 20H7V2H5V20H4a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2H5v4H7V26H8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 008 20zm0 4H4V22H8z",
      transform: "translate(0 .005)"
    })), children);
  });
  var AudioConsole16 = /*#__PURE__*/React__default['default'].forwardRef(function AudioConsole16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$s || (_path258$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14H27V2H25V14H24a2.0019 2.0019 0 00-2 2v2a2.0023 2.0023 0 002 2h1V30h2V20h1a2.0027 2.0027 0 002-2V16A2.0023 2.0023 0 0028 14zm0 4H24V16h4zM18 6H17V2H15V6H14a2.0019 2.0019 0 00-2 2v2a2.0019 2.0019 0 002 2h1V30h2V12h1a2.002 2.002 0 002-2V8A2.002 2.002 0 0018 6zm0 4H14V8h4zM8 20H7V2H5V20H4a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2H5v4H7V26H8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 008 20zm0 4H4V22H8z",
      transform: "translate(0 .005)"
    })), children);
  });
  var AugmentedReality32 = /*#__PURE__*/React__default['default'].forwardRef(function AugmentedReality32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$s || (_path259$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"
    })), _circle173 || (_circle173 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path260$s || (_path260$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var AugmentedReality24 = /*#__PURE__*/React__default['default'].forwardRef(function AugmentedReality24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$s || (_path261$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"
    })), _circle174 || (_circle174 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path262$s || (_path262$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var AugmentedReality20 = /*#__PURE__*/React__default['default'].forwardRef(function AugmentedReality20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$s || (_path263$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"
    })), _circle175 || (_circle175 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path264$s || (_path264$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var AugmentedReality16 = /*#__PURE__*/React__default['default'].forwardRef(function AugmentedReality16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$s || (_path265$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"
    })), _circle176 || (_circle176 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path266$s || (_path266$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var WatsonHealthAutoScroll32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAutoScroll32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$s || (_path267$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 16a4 4 0 104-4A4 4 0 0012 16zm6 0a2 2 0 11-2-2A2 2 0 0118 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"
    })), children);
  });
  var WatsonHealthAutoScroll24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAutoScroll24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$s || (_path268$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 16a4 4 0 104-4A4 4 0 0012 16zm6 0a2 2 0 11-2-2A2 2 0 0118 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"
    })), children);
  });
  var WatsonHealthAutoScroll20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAutoScroll20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$s || (_path269$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 16a4 4 0 104-4A4 4 0 0012 16zm6 0a2 2 0 11-2-2A2 2 0 0118 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"
    })), children);
  });
  var WatsonHealthAutoScroll16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthAutoScroll16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$s || (_path270$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 16a4 4 0 104-4A4 4 0 0012 16zm6 0a2 2 0 11-2-2A2 2 0 0118 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"
    })), children);
  });
  var Automatic32 = /*#__PURE__*/React__default['default'].forwardRef(function Automatic32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$s || (_path271$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16H22a2.002 2.002 0 00-2 2V30h2V25h4v5h2V18A2.002 2.002 0 0026 16zm-4 7V18h4v5zM16 27a10.9862 10.9862 0 01-9.2156-5H12V20H4v8H6V24.3149A13.0239 13.0239 0 0016 29zM20 10h5.2155A10.9973 10.9973 0 005 16H3A13.0048 13.0048 0 0126 7.6849V4h2v8H20z"
    })), children);
  });
  var Automatic24 = /*#__PURE__*/React__default['default'].forwardRef(function Automatic24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$s || (_path272$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16H22a2.002 2.002 0 00-2 2V30h2V25h4v5h2V18A2.002 2.002 0 0026 16zm-4 7V18h4v5zM16 27a10.9862 10.9862 0 01-9.2156-5H12V20H4v8H6V24.3149A13.0239 13.0239 0 0016 29zM20 10h5.2155A10.9973 10.9973 0 005 16H3A13.0048 13.0048 0 0126 7.6849V4h2v8H20z"
    })), children);
  });
  var Automatic20 = /*#__PURE__*/React__default['default'].forwardRef(function Automatic20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$s || (_path273$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16H22a2.002 2.002 0 00-2 2V30h2V25h4v5h2V18A2.002 2.002 0 0026 16zm-4 7V18h4v5zM16 27a10.9862 10.9862 0 01-9.2156-5H12V20H4v8H6V24.3149A13.0239 13.0239 0 0016 29zM20 10h5.2155A10.9973 10.9973 0 005 16H3A13.0048 13.0048 0 0126 7.6849V4h2v8H20z"
    })), children);
  });
  var Automatic16 = /*#__PURE__*/React__default['default'].forwardRef(function Automatic16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$s || (_path274$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16H22a2.002 2.002 0 00-2 2V30h2V25h4v5h2V18A2.002 2.002 0 0026 16zm-4 7V18h4v5zM16 27a10.9862 10.9862 0 01-9.2156-5H12V20H4v8H6V24.3149A13.0239 13.0239 0 0016 29zM20 10h5.2155A10.9973 10.9973 0 005 16H3A13.0048 13.0048 0 0126 7.6849V4h2v8H20z"
    })), children);
  });
  var Autoscaling32 = /*#__PURE__*/React__default['default'].forwardRef(function Autoscaling32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$s || (_path275$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H12V26H22V10H6V20H4V10A2.0021,2.0021,0,0,1,6,8H22a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,22,28Z"
    })), _path276$s || (_path276$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H26V20h2V4H12V6H10V4a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2V20A2.0021,2.0021,0,0,1,28,22Z"
    })), _path277$s || (_path277$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14L10 16 14.586 16 3 27.586 4.414 29 16 17.414 16 22 18 22 18 14 10 14z"
    })), children);
  });
  var Autoscaling24 = /*#__PURE__*/React__default['default'].forwardRef(function Autoscaling24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$s || (_path278$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H12V26H22V10H6V20H4V10A2.0021,2.0021,0,0,1,6,8H22a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,22,28Z"
    })), _path279$s || (_path279$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H26V20h2V4H12V6H10V4a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2V20A2.0021,2.0021,0,0,1,28,22Z"
    })), _path280$s || (_path280$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14L10 16 14.586 16 3 27.586 4.414 29 16 17.414 16 22 18 22 18 14 10 14z"
    })), children);
  });
  var Autoscaling20 = /*#__PURE__*/React__default['default'].forwardRef(function Autoscaling20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$s || (_path281$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H12V26H22V10H6V20H4V10A2.0021,2.0021,0,0,1,6,8H22a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,22,28Z"
    })), _path282$s || (_path282$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H26V20h2V4H12V6H10V4a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2V20A2.0021,2.0021,0,0,1,28,22Z"
    })), _path283$s || (_path283$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14L10 16 14.586 16 3 27.586 4.414 29 16 17.414 16 22 18 22 18 14 10 14z"
    })), children);
  });
  var Autoscaling16 = /*#__PURE__*/React__default['default'].forwardRef(function Autoscaling16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$s || (_path284$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H12V26H22V10H6V20H4V10A2.0021,2.0021,0,0,1,6,8H22a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,22,28Z"
    })), _path285$s || (_path285$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H26V20h2V4H12V6H10V4a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2V20A2.0021,2.0021,0,0,1,28,22Z"
    })), _path286$s || (_path286$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14L10 16 14.586 16 3 27.586 4.414 29 16 17.414 16 22 18 22 18 14 10 14z"
    })), children);
  });
  var Awake32 = /*#__PURE__*/React__default['default'].forwardRef(function Awake32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$s || (_path287$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V6.96H15z"
    })), _path288$s || (_path288$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.67 6.85H26.630000000000003V8.85H21.67z",
      transform: "rotate(-45 24.142 7.85)"
    })), _path289$s || (_path289$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.04 15H30V17H25.04z"
    })), _path290$s || (_path290$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.15 21.67H25.15V26.630000000000003H23.15z",
      transform: "rotate(-45 24.152 24.146)"
    })), _path291$s || (_path291$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.04H17V30H15z"
    })), _path292$s || (_path292$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.37 23.15H10.33V25.15H5.37z",
      transform: "rotate(-45 7.86 24.144)"
    })), _path293$s || (_path293$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H6.96V17H2z"
    })), _path294$s || (_path294$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.85 5.37H8.85V10.33H6.85z",
      transform: "rotate(-45 7.85 7.848)"
    })), _path295$s || (_path295$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Awake24 = /*#__PURE__*/React__default['default'].forwardRef(function Awake24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$s || (_path296$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V6.96H15z"
    })), _path297$s || (_path297$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.67 6.85H26.630000000000003V8.85H21.67z",
      transform: "rotate(-45 24.142 7.85)"
    })), _path298$s || (_path298$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.04 15H30V17H25.04z"
    })), _path299$s || (_path299$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.15 21.67H25.15V26.630000000000003H23.15z",
      transform: "rotate(-45 24.152 24.146)"
    })), _path300$s || (_path300$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.04H17V30H15z"
    })), _path301$s || (_path301$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.37 23.15H10.33V25.15H5.37z",
      transform: "rotate(-45 7.86 24.144)"
    })), _path302$s || (_path302$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H6.96V17H2z"
    })), _path303$s || (_path303$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.85 5.37H8.85V10.33H6.85z",
      transform: "rotate(-45 7.85 7.848)"
    })), _path304$s || (_path304$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Awake20 = /*#__PURE__*/React__default['default'].forwardRef(function Awake20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$s || (_path305$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V6.96H15z"
    })), _path306$s || (_path306$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.67 6.85H26.630000000000003V8.85H21.67z",
      transform: "rotate(-45 24.142 7.85)"
    })), _path307$s || (_path307$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.04 15H30V17H25.04z"
    })), _path308$s || (_path308$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.15 21.67H25.15V26.630000000000003H23.15z",
      transform: "rotate(-45 24.152 24.146)"
    })), _path309$s || (_path309$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.04H17V30H15z"
    })), _path310$s || (_path310$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.37 23.15H10.33V25.15H5.37z",
      transform: "rotate(-45 7.86 24.144)"
    })), _path311$s || (_path311$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H6.96V17H2z"
    })), _path312$s || (_path312$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.85 5.37H8.85V10.33H6.85z",
      transform: "rotate(-45 7.85 7.848)"
    })), _path313$s || (_path313$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Awake16 = /*#__PURE__*/React__default['default'].forwardRef(function Awake16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$s || (_path314$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 1H8.5V3.5H7.5z"
    })), _path315$s || (_path315$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8 3.4H13.3V4.4H10.8z",
      transform: "rotate(-45.001 12.074 3.922)"
    })), _path316$s || (_path316$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.5 7.5H15V8.5H12.5z"
    })), _path317$s || (_path317$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.6 10.8H12.6V13.3H11.6z",
      transform: "rotate(-45.001 12.077 12.075)"
    })), _path318$s || (_path318$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 12.5H8.5V15H7.5z"
    })), _path319$s || (_path319$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.7 11.6H5.2V12.6H2.7z",
      transform: "rotate(-45.001 3.929 12.078)"
    })), _path320$s || (_path320$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 7.5H3.5V8.5H1z"
    })), _path321$s || (_path321$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.4 2.7H4.4V5.2H3.4z",
      transform: "rotate(-45.001 3.926 3.925)"
    })), _path322$s || (_path322$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,6c1.1,0,2,0.9,2,2s-0.9,2-2,2S6,9.1,6,8S6.9,6,8,6 M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z"
    })), children);
  });
  var BackToTop32 = /*#__PURE__*/React__default['default'].forwardRef(function BackToTop32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['BackToTop32']) {
        didWarnAboutDeprecation$b['BackToTop32'] = true;
        console.warn("The BackToTop32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$s || (_path323$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var BackToTop24 = /*#__PURE__*/React__default['default'].forwardRef(function BackToTop24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['BackToTop24']) {
        didWarnAboutDeprecation$b['BackToTop24'] = true;
        console.warn("The BackToTop24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$s || (_path324$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var BackToTop20 = /*#__PURE__*/React__default['default'].forwardRef(function BackToTop20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['BackToTop20']) {
        didWarnAboutDeprecation$b['BackToTop20'] = true;
        console.warn("The BackToTop20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$s || (_path325$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var BackToTop16 = /*#__PURE__*/React__default['default'].forwardRef(function BackToTop16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$s);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$b['BackToTop16']) {
        didWarnAboutDeprecation$b['BackToTop16'] = true;
        console.warn("The BackToTop16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$s || (_path326$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var Badge32 = /*#__PURE__*/React__default['default'].forwardRef(function Badge32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$s || (_path327$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"
    })), _path328$s || (_path328$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"
    })), children);
  });
  var Badge24 = /*#__PURE__*/React__default['default'].forwardRef(function Badge24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$s || (_path329$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"
    })), _path330$s || (_path330$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"
    })), children);
  });
  var Badge20 = /*#__PURE__*/React__default['default'].forwardRef(function Badge20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$s || (_path331$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"
    })), _path332$s || (_path332$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"
    })), children);
  });
  var Badge16 = /*#__PURE__*/React__default['default'].forwardRef(function Badge16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$s || (_path333$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"
    })), _path334$s || (_path334$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"
    })), children);
  });
  var BaggageClaim32 = /*#__PURE__*/React__default['default'].forwardRef(function BaggageClaim32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle177 || (_circle177 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "2"
    })), _path335$s || (_path335$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H25V16a2.0023,2.0023,0,0,0-2-2H19a2.0023,2.0023,0,0,0-2,2v2H14a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18Zm-9-2h4v2H19Zm9,12H14V20H28Z"
    })), _path336$s || (_path336$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,6h4v6h2V6h4v6h2V6h4v6h2V6.0049A2.0047,2.0047,0,0,0,25.9951,4H4.0049A2.0047,2.0047,0,0,0,2,6.0049v13.99A2.0047,2.0047,0,0,0,4.0049,22H10ZM8,20H4V6H8Z"
    })), children);
  });
  var BaggageClaim24 = /*#__PURE__*/React__default['default'].forwardRef(function BaggageClaim24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle178 || (_circle178 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "2"
    })), _path337$s || (_path337$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H25V16a2.0023,2.0023,0,0,0-2-2H19a2.0023,2.0023,0,0,0-2,2v2H14a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18Zm-9-2h4v2H19Zm9,12H14V20H28Z"
    })), _path338$r || (_path338$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,6h4v6h2V6h4v6h2V6h4v6h2V6.0049A2.0047,2.0047,0,0,0,25.9951,4H4.0049A2.0047,2.0047,0,0,0,2,6.0049v13.99A2.0047,2.0047,0,0,0,4.0049,22H10ZM8,20H4V6H8Z"
    })), children);
  });
  var BaggageClaim20 = /*#__PURE__*/React__default['default'].forwardRef(function BaggageClaim20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle179 || (_circle179 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "2"
    })), _path339$r || (_path339$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H25V16a2.0023,2.0023,0,0,0-2-2H19a2.0023,2.0023,0,0,0-2,2v2H14a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18Zm-9-2h4v2H19Zm9,12H14V20H28Z"
    })), _path340$r || (_path340$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,6h4v6h2V6h4v6h2V6h4v6h2V6.0049A2.0047,2.0047,0,0,0,25.9951,4H4.0049A2.0047,2.0047,0,0,0,2,6.0049v13.99A2.0047,2.0047,0,0,0,4.0049,22H10ZM8,20H4V6H8Z"
    })), children);
  });
  var BaggageClaim16 = /*#__PURE__*/React__default['default'].forwardRef(function BaggageClaim16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle180 || (_circle180 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "2"
    })), _path341$r || (_path341$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H25V16a2.0023,2.0023,0,0,0-2-2H19a2.0023,2.0023,0,0,0-2,2v2H14a2.0023,2.0023,0,0,0-2,2v8a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18Zm-9-2h4v2H19Zm9,12H14V20H28Z"
    })), _path342$r || (_path342$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,6h4v6h2V6h4v6h2V6h4v6h2V6.0049A2.0047,2.0047,0,0,0,25.9951,4H4.0049A2.0047,2.0047,0,0,0,2,6.0049v13.99A2.0047,2.0047,0,0,0,4.0049,22H10ZM8,20H4V6H8Z"
    })), children);
  });
  var Bar32 = /*#__PURE__*/React__default['default'].forwardRef(function Bar32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$r || (_path343$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"
    })), _path344$r || (_path344$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"
    })), children);
  });
  var Bar24 = /*#__PURE__*/React__default['default'].forwardRef(function Bar24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$r || (_path345$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"
    })), _path346$r || (_path346$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"
    })), children);
  });
  var Bar20 = /*#__PURE__*/React__default['default'].forwardRef(function Bar20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$r || (_path347$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"
    })), _path348$r || (_path348$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"
    })), children);
  });
  var Bar16 = /*#__PURE__*/React__default['default'].forwardRef(function Bar16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$r || (_path349$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"
    })), _path350$r || (_path350$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"
    })), children);
  });
  var Barcode32 = /*#__PURE__*/React__default['default'].forwardRef(function Barcode32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$r || (_path351$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H4V28H2zM12 6H14V26H12zM6 6H10V26H6zM16 6H20V26H16zM22 6H26V26H22zM28 6H30V28H28z"
    })), children);
  });
  var Barcode24 = /*#__PURE__*/React__default['default'].forwardRef(function Barcode24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$r || (_path352$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H4V28H2zM12 6H14V26H12zM6 6H10V26H6zM16 6H20V26H16zM22 6H26V26H22zM28 6H30V28H28z"
    })), children);
  });
  var Barcode20 = /*#__PURE__*/React__default['default'].forwardRef(function Barcode20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$r || (_path353$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H4V28H2zM12 6H14V26H12zM6 6H10V26H6zM16 6H20V26H16zM22 6H26V26H22zM28 6H30V28H28z"
    })), children);
  });
  var Barcode16 = /*#__PURE__*/React__default['default'].forwardRef(function Barcode16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$r || (_path354$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H4V28H2zM12 6H14V26H12zM6 6H10V26H6zM16 6H20V26H16zM22 6H26V26H22zM28 6H30V28H28z"
    })), children);
  });
  var BareMetalServer32 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle181 || (_circle181 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path355$q || (_path355$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0021,2.0021,0,0,1,4,8V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V8A2.0021,2.0021,0,0,1,26,10ZM6,4V8H26V4Z"
    })), _circle182 || (_circle182 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path356$q || (_path356$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0021,2.0021,0,0,1-2-2V14a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle183 || (_circle183 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "26",
      r: "1"
    })), _path357$q || (_path357$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0021,2.0021,0,0,1-2-2V24a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,30ZM6,24v4H26V24Z"
    })), children);
  });
  var BareMetalServer24 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle184 || (_circle184 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path358$q || (_path358$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0021,2.0021,0,0,1,4,8V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V8A2.0021,2.0021,0,0,1,26,10ZM6,4V8H26V4Z"
    })), _circle185 || (_circle185 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path359$q || (_path359$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0021,2.0021,0,0,1-2-2V14a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle186 || (_circle186 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "26",
      r: "1"
    })), _path360$q || (_path360$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0021,2.0021,0,0,1-2-2V24a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,30ZM6,24v4H26V24Z"
    })), children);
  });
  var BareMetalServer20 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle187 || (_circle187 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path361$p || (_path361$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0021,2.0021,0,0,1,4,8V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V8A2.0021,2.0021,0,0,1,26,10ZM6,4V8H26V4Z"
    })), _circle188 || (_circle188 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path362$p || (_path362$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0021,2.0021,0,0,1-2-2V14a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle189 || (_circle189 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "26",
      r: "1"
    })), _path363$n || (_path363$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0021,2.0021,0,0,1-2-2V24a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,30ZM6,24v4H26V24Z"
    })), children);
  });
  var BareMetalServer16 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle190 || (_circle190 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path364$n || (_path364$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0021,2.0021,0,0,1,4,8V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V8A2.0021,2.0021,0,0,1,26,10ZM6,4V8H26V4Z"
    })), _circle191 || (_circle191 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path365$n || (_path365$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0021,2.0021,0,0,1-2-2V14a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle192 || (_circle192 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "26",
      r: "1"
    })), _path366$n || (_path366$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2.0021,2.0021,0,0,1-2-2V24a2.0021,2.0021,0,0,1,2-2H26a2.0021,2.0021,0,0,1,2,2v4A2.0021,2.0021,0,0,1,26,30ZM6,24v4H26V24Z"
    })), children);
  });
  var BareMetalServer_0132 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0132(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$n || (_path367$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle193 || (_circle193 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path368$n || (_path368$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), children);
  });
  var BareMetalServer_0124 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0124(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$n || (_path369$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle194 || (_circle194 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path370$n || (_path370$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), children);
  });
  var BareMetalServer_0120 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0120(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$n || (_path371$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle195 || (_circle195 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path372$n || (_path372$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), children);
  });
  var BareMetalServer_0116 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0116(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$n || (_path373$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle196 || (_circle196 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path374$n || (_path374$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), children);
  });
  var BareMetalServer_0232 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0232(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$m || (_path375$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle197 || (_circle197 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path376$m || (_path376$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle198 || (_circle198 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path377$m || (_path377$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0023,2.0023,0,0,1,4,8V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V8A2.0023,2.0023,0,0,1,26,10ZM6,4V8H26V4Z"
    })), children);
  });
  var BareMetalServer_0224 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0224(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$m || (_path378$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle199 || (_circle199 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path379$m || (_path379$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle200 || (_circle200 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path380$m || (_path380$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0023,2.0023,0,0,1,4,8V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V8A2.0023,2.0023,0,0,1,26,10ZM6,4V8H26V4Z"
    })), children);
  });
  var BareMetalServer_0220 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0220(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$m || (_path381$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle201 || (_circle201 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path382$m || (_path382$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle202 || (_circle202 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path383$m || (_path383$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0023,2.0023,0,0,1,4,8V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V8A2.0023,2.0023,0,0,1,26,10ZM6,4V8H26V4Z"
    })), children);
  });
  var BareMetalServer_0216 = /*#__PURE__*/React__default['default'].forwardRef(function BareMetalServer_0216(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$l || (_path384$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 28L17 22 15 22 15 28 5 28 5 30 27 30 27 28 17 28z"
    })), _circle203 || (_circle203 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "1"
    })), _path385$l || (_path385$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H6a2.0023,2.0023,0,0,1-2-2V14a2.0023,2.0023,0,0,1,2-2H26a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,26,20ZM6,14v4H26V14Z"
    })), _circle204 || (_circle204 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path386$k || (_path386$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H6A2.0023,2.0023,0,0,1,4,8V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2V8A2.0023,2.0023,0,0,1,26,10ZM6,4V8H26V4Z"
    })), children);
  });
  var QBarrier32 = /*#__PURE__*/React__default['default'].forwardRef(function QBarrier32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$k || (_path387$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"
    })), children);
  });
  var QBarrier24 = /*#__PURE__*/React__default['default'].forwardRef(function QBarrier24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$k || (_path388$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"
    })), children);
  });
  var QBarrier20 = /*#__PURE__*/React__default['default'].forwardRef(function QBarrier20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$k || (_path389$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"
    })), children);
  });
  var QBarrier16 = /*#__PURE__*/React__default['default'].forwardRef(function QBarrier16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$k || (_path390$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"
    })), children);
  });
  var Basketball32 = /*#__PURE__*/React__default['default'].forwardRef(function Basketball32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$k || (_path391$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"
    })), children);
  });
  var Basketball24 = /*#__PURE__*/React__default['default'].forwardRef(function Basketball24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$k || (_path392$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"
    })), children);
  });
  var Basketball20 = /*#__PURE__*/React__default['default'].forwardRef(function Basketball20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$k || (_path393$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"
    })), children);
  });
  var Basketball16 = /*#__PURE__*/React__default['default'].forwardRef(function Basketball16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$k || (_path394$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"
    })), children);
  });
  var BastionHost32 = /*#__PURE__*/React__default['default'].forwardRef(function BastionHost32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$k || (_path395$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5273,2.709A1.9955,1.9955,0,0,0,26,2H23.3091a1.5,1.5,0,0,0-1.3419.8294L21.3818,4H20V3.5A1.5,1.5,0,0,0,18.5,2h-5A1.5,1.5,0,0,0,12,3.5V4H10.6182l-.585-1.17A1.5017,1.5017,0,0,0,8.69,2H6A2,2,0,0,0,4.0283,4.333L4.7324,8.5A3,3,0,0,0,7.69,11H8V23a3.0033,3.0033,0,0,0-3,3v4H27V26a3.0033,3.0033,0,0,0-3-3V11h.31a3,3,0,0,0,2.9579-2.5l.7041-4.167A1.994,1.994,0,0,0,27.5273,2.709ZM25,26v2H7V26a1.0009,1.0009,0,0,1,1-1H24A1.0009,1.0009,0,0,1,25,26Zm-3-3H10V11H22ZM25.2959,8.167A.9976.9976,0,0,1,24.31,9H7.69a.9976.9976,0,0,1-.9863-.8335L6,4H8.3818l1,2H14V4h4V6h4.6172l1.001-2H26Z"
    })), children);
  });
  var BastionHost24 = /*#__PURE__*/React__default['default'].forwardRef(function BastionHost24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$k || (_path396$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5273,2.709A1.9955,1.9955,0,0,0,26,2H23.3091a1.5,1.5,0,0,0-1.3419.8294L21.3818,4H20V3.5A1.5,1.5,0,0,0,18.5,2h-5A1.5,1.5,0,0,0,12,3.5V4H10.6182l-.585-1.17A1.5017,1.5017,0,0,0,8.69,2H6A2,2,0,0,0,4.0283,4.333L4.7324,8.5A3,3,0,0,0,7.69,11H8V23a3.0033,3.0033,0,0,0-3,3v4H27V26a3.0033,3.0033,0,0,0-3-3V11h.31a3,3,0,0,0,2.9579-2.5l.7041-4.167A1.994,1.994,0,0,0,27.5273,2.709ZM25,26v2H7V26a1.0009,1.0009,0,0,1,1-1H24A1.0009,1.0009,0,0,1,25,26Zm-3-3H10V11H22ZM25.2959,8.167A.9976.9976,0,0,1,24.31,9H7.69a.9976.9976,0,0,1-.9863-.8335L6,4H8.3818l1,2H14V4h4V6h4.6172l1.001-2H26Z"
    })), children);
  });
  var BastionHost20 = /*#__PURE__*/React__default['default'].forwardRef(function BastionHost20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$k || (_path397$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5273,2.709A1.9955,1.9955,0,0,0,26,2H23.3091a1.5,1.5,0,0,0-1.3419.8294L21.3818,4H20V3.5A1.5,1.5,0,0,0,18.5,2h-5A1.5,1.5,0,0,0,12,3.5V4H10.6182l-.585-1.17A1.5017,1.5017,0,0,0,8.69,2H6A2,2,0,0,0,4.0283,4.333L4.7324,8.5A3,3,0,0,0,7.69,11H8V23a3.0033,3.0033,0,0,0-3,3v4H27V26a3.0033,3.0033,0,0,0-3-3V11h.31a3,3,0,0,0,2.9579-2.5l.7041-4.167A1.994,1.994,0,0,0,27.5273,2.709ZM25,26v2H7V26a1.0009,1.0009,0,0,1,1-1H24A1.0009,1.0009,0,0,1,25,26Zm-3-3H10V11H22ZM25.2959,8.167A.9976.9976,0,0,1,24.31,9H7.69a.9976.9976,0,0,1-.9863-.8335L6,4H8.3818l1,2H14V4h4V6h4.6172l1.001-2H26Z"
    })), children);
  });
  var BastionHost16 = /*#__PURE__*/React__default['default'].forwardRef(function BastionHost16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$k || (_path398$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5273,2.709A1.9955,1.9955,0,0,0,26,2H23.3091a1.5,1.5,0,0,0-1.3419.8294L21.3818,4H20V3.5A1.5,1.5,0,0,0,18.5,2h-5A1.5,1.5,0,0,0,12,3.5V4H10.6182l-.585-1.17A1.5017,1.5017,0,0,0,8.69,2H6A2,2,0,0,0,4.0283,4.333L4.7324,8.5A3,3,0,0,0,7.69,11H8V23a3.0033,3.0033,0,0,0-3,3v4H27V26a3.0033,3.0033,0,0,0-3-3V11h.31a3,3,0,0,0,2.9579-2.5l.7041-4.167A1.994,1.994,0,0,0,27.5273,2.709ZM25,26v2H7V26a1.0009,1.0009,0,0,1,1-1H24A1.0009,1.0009,0,0,1,25,26Zm-3-3H10V11H22ZM25.2959,8.167A.9976.9976,0,0,1,24.31,9H7.69a.9976.9976,0,0,1-.9863-.8335L6,4H8.3818l1,2H14V4h4V6h4.6172l1.001-2H26Z"
    })), children);
  });

  var _path$s, _path2$s, _path3$s, _path4$s, _path5$s, _path6$s, _path7$s, _path8$s, _path9$s, _path10$s, _path11$s, _path12$s, _path13$s, _path14$s, _path15$s, _path16$s, _path17$s, _path18$s, _path19$s, _path20$s, _path21$s, _path22$s, _path23$s, _path24$s, _path25$s, _path26$s, _path27$s, _path28$s, _path29$s, _path30$s, _path31$s, _path32$s, _path33$s, _path34$s, _path35$s, _path36$s, _path37$s, _path38$s, _path39$s, _path40$s, _path41$s, _path42$s, _path43$s, _path44$s, _path45$s, _path46$s, _path47$s, _path48$s, _path49$s, _path50$s, _path51$s, _path52$s, _circle$r, _circle2$r, _path53$s, _circle3$r, _circle4$q, _path54$s, _circle5$p, _circle6$p, _path55$s, _circle7$p, _circle8$p, _path56$s, _path57$s, _path58$s, _path59$s, _path60$s, _path61$s, _path62$s, _path63$s, _path64$s, _path65$s, _path66$s, _path67$s, _path68$s, _path69$s, _path70$s, _path71$s, _path72$s, _path73$s, _path74$s, _path75$s, _path76$s, _path77$s, _path78$s, _path79$s, _path80$s, _path81$s, _path82$s, _path83$s, _path84$s, _path85$s, _circle9$p, _path86$s, _path87$s, _circle10$p, _path88$s, _path89$s, _circle11$o, _path90$s, _path91$s, _circle12$o, _path92$s, _path93$s, _path94$s, _path95$s, _path96$s, _path97$s, _path98$s, _path99$s, _path100$s, _path101$s, _path102$s, _path103$s, _path104$s, _path105$s, _path106$s, _path107$s, _path108$s, _path109$s, _path110$s, _path111$s, _path112$s, _path113$s, _path114$s, _path115$s, _path116$s, _path117$s, _path118$s, _path119$s, _path120$s, _path121$s, _path122$s, _path123$s, _path124$s, _path125$s, _path126$s, _path127$s, _path128$s, _path129$s, _path130$s, _path131$s, _path132$s, _path133$s, _circle13$o, _path134$s, _circle14$o, _path135$s, _circle15$o, _path136$s, _circle16$o, _path137$s, _path138$s, _path139$s, _path140$s, _path141$s, _path142$s, _path143$s, _path144$s, _path145$s, _path146$s, _path147$s, _path148$s, _path149$s, _path150$s, _path151$s, _path152$s, _path153$s, _path154$s, _path155$s, _path156$s, _path157$s, _path158$s, _path159$s, _path160$s, _path161$s, _path162$s, _path163$s, _path164$s, _path165$s, _path166$s, _path167$s, _path168$s, _path169$s, _path170$s, _path171$s, _path172$s, _path173$s, _path174$s, _path175$s, _path176$s, _path177$r, _path178$r, _path179$r, _path180$r, _path181$r, _path182$r, _path183$r, _path184$r, _path185$r, _path186$r, _path187$r, _path188$r, _path189$r, _path190$r, _path191$r, _path192$r, _path193$r, _path194$r, _path195$r, _path196$r, _path197$r, _path198$r, _path199$r, _path200$r, _path201$r, _path202$r, _path203$r, _path204$r, _path205$r, _path206$r, _path207$r, _path208$r, _path209$r, _path210$r, _path211$r, _path212$r, _path213$r, _path214$r, _path215$r, _path216$r, _path217$r, _path218$r, _path219$r, _path220$r, _path221$r, _path222$r, _path223$r, _path224$r, _path225$r, _path226$r, _path227$r, _path228$r, _path229$r, _path230$r, _path231$r, _path232$r, _path233$r, _path234$r, _path235$r, _path236$r, _path237$r, _path238$r, _path239$r, _path240$r, _path241$r, _path242$r, _path243$r, _path244$r, _path245$r, _path246$r, _path247$r, _path248$r, _path249$r, _path250$r, _path251$r, _path252$r, _path253$r, _path254$r, _path255$r, _path256$r, _path257$r, _path258$r, _path259$r, _path260$r, _path261$r, _path262$r, _path263$r, _path264$r, _path265$r, _path266$r, _path267$r, _path268$r, _path269$r, _path270$r, _path271$r, _path272$r, _path273$r, _path274$r, _path275$r, _path276$r, _path277$r, _path278$r, _path279$r, _path280$r, _path281$r, _path282$r, _path283$r, _path284$r, _path285$r, _path286$r, _path287$r, _path288$r, _path289$r, _path290$r, _path291$r, _path292$r, _path293$r, _path294$r, _path295$r, _path296$r, _path297$r, _path298$r, _path299$r, _path300$r, _path301$r, _path302$r, _path303$r, _path304$r, _path305$r, _path306$r, _path307$r, _path308$r, _path309$r, _path310$r, _path311$r, _path312$r, _path313$r, _path314$r, _path315$r, _path316$r, _path317$r, _path318$r, _path319$r, _path320$r, _path321$r, _path322$r, _path323$r, _path324$r, _path325$r, _path326$r, _path327$r, _path328$r, _path329$r, _path330$r, _path331$r, _path332$r, _path333$r, _path334$r, _path335$r, _path336$r, _path337$r, _path338$q, _path339$q, _path340$q, _path341$q, _path342$q, _path343$q, _path344$q, _path345$q, _path346$q, _path347$q, _path348$q, _path349$q, _path350$q, _path351$q, _path352$q, _path353$q, _path354$q, _path355$p, _path356$p, _path357$p, _path358$p, _path359$p, _path360$p, _path361$o, _path362$o, _path363$m, _path364$m, _path365$m, _path366$m, _path367$m, _path368$m, _path369$m, _path370$m, _path371$m, _path372$m, _path373$m, _path374$m, _path375$l, _path376$l, _path377$l, _path378$l, _path379$l, _path380$l, _path381$l, _path382$l, _path383$l, _path384$k, _path385$k, _path386$j, _path387$j, _path388$j, _path389$j, _path390$j, _path391$j, _path392$j, _path393$j, _path394$j, _path395$j, _path396$j, _path397$j, _path398$j, _path399$i, _path400$i, _path401$i, _path402$i, _path403$h, _path404$h, _path405$g, _path406$f, _path407$e, _path408$d, _path409$d, _path410$c, _path411$c, _path412$c, _path413$c, _path414$c, _path415$b, _path416$9, _path417$9, _path418$8, _path419$7, _path420$7, _path421$7, _path422$7, _path423$6, _path424$6, _path425$5, _path426$5, _path427$4, _path428$4, _path429$4, _path430$4, _path431$4, _path432$4, _path433$4, _path434$4, _path435$4, _path436$4, _path437$4, _path438$4, _path439$3, _path440$3, _path441$3, _path442$3, _path443$3, _path444$3, _path445$3, _path446$3, _path447$3, _path448$3, _path449$3, _path450$3, _path451$3, _path452$3, _path453$3, _path454$3, _path455$2, _path456$2, _path457$2, _path458$2, _path459$2, _path460$2, _path461$2, _path462$2, _path463$2, _path464$2, _path465$2, _path466$2, _path467$2, _path468$2, _path469$2, _path470$2, _path471$2, _path472$2, _path473$2, _path474$2, _path475$2, _path476$2, _path477$2, _path478$2, _path479$2, _path480$2, _path481$2, _path482$2, _path483$2, _path484$2, _path485$2, _path486$2, _path487$2, _path488$2, _path489$2, _path490$2, _path491$2, _path492$2, _path493$2, _path494$2, _path495$2, _path496$2, _path497$2, _path498$2, _path499$2, _path500$2, _path501$2, _path502$2, _path503$2, _path504$2, _path505$2, _path506$2, _path507$2, _path508$2, _path509$2, _path510$2, _path511$2, _path512$2, _path513$2, _path514$2, _path515$2, _path516$2, _path517$2, _path518$2, _path519$2, _path520$2, _path521$2, _path522$2, _path523$2, _path524$2, _path525$2, _path526$1, _path527$1, _path528$1, _path529$1, _path530$1, _path531$1, _path532$1, _path533$1, _path534$1, _path535$1, _path536$1, _path537$1, _path538$1, _path539$1, _path540$1, _path541, _path542, _path543, _path544, _path545, _path546, _path547, _path548, _path549, _path550, _path551, _path552, _path553, _rect$4, _path554, _path555, _rect2$4, _path556, _path557, _rect3$4, _path558, _path559, _rect4$4, _path560, _path561, _path562, _path563, _path564, _path565, _path566, _path567, _path568, _path569, _path570, _path571, _path572, _path573, _path574, _path575, _path576, _path577, _path578, _path579, _path580, _path581, _path582, _path583, _path584, _path585, _path586, _path587, _path588, _path589, _path590, _path591, _path592, _path593, _path594, _path595, _path596, _path597, _path598, _path599, _path600, _path601, _path602, _path603, _path604, _path605, _path606;

  var _excluded$s = ["children"],
      _excluded2$s = ["children"],
      _excluded3$s = ["children"],
      _excluded4$s = ["children"],
      _excluded5$s = ["children"],
      _excluded6$s = ["children"],
      _excluded7$s = ["children"],
      _excluded8$s = ["children"],
      _excluded9$s = ["children"],
      _excluded10$s = ["children"],
      _excluded11$s = ["children"],
      _excluded12$s = ["children"],
      _excluded13$s = ["children"],
      _excluded14$s = ["children"],
      _excluded15$s = ["children"],
      _excluded16$s = ["children"],
      _excluded17$s = ["children"],
      _excluded18$s = ["children"],
      _excluded19$s = ["children"],
      _excluded20$s = ["children"],
      _excluded21$s = ["children"],
      _excluded22$s = ["children"],
      _excluded23$s = ["children"],
      _excluded24$s = ["children"],
      _excluded25$s = ["children"],
      _excluded26$s = ["children"],
      _excluded27$s = ["children"],
      _excluded28$s = ["children"],
      _excluded29$s = ["children"],
      _excluded30$s = ["children"],
      _excluded31$s = ["children"],
      _excluded32$s = ["children"],
      _excluded33$s = ["children"],
      _excluded34$s = ["children"],
      _excluded35$s = ["children"],
      _excluded36$s = ["children"],
      _excluded37$s = ["children"],
      _excluded38$s = ["children"],
      _excluded39$s = ["children"],
      _excluded40$s = ["children"],
      _excluded41$s = ["children"],
      _excluded42$s = ["children"],
      _excluded43$s = ["children"],
      _excluded44$s = ["children"],
      _excluded45$s = ["children"],
      _excluded46$s = ["children"],
      _excluded47$s = ["children"],
      _excluded48$s = ["children"],
      _excluded49$s = ["children"],
      _excluded50$s = ["children"],
      _excluded51$s = ["children"],
      _excluded52$s = ["children"],
      _excluded53$s = ["children"],
      _excluded54$s = ["children"],
      _excluded55$s = ["children"],
      _excluded56$s = ["children"],
      _excluded57$s = ["children"],
      _excluded58$s = ["children"],
      _excluded59$s = ["children"],
      _excluded60$s = ["children"],
      _excluded61$s = ["children"],
      _excluded62$s = ["children"],
      _excluded63$s = ["children"],
      _excluded64$s = ["children"],
      _excluded65$s = ["children"],
      _excluded66$s = ["children"],
      _excluded67$s = ["children"],
      _excluded68$s = ["children"],
      _excluded69$s = ["children"],
      _excluded70$s = ["children"],
      _excluded71$s = ["children"],
      _excluded72$s = ["children"],
      _excluded73$s = ["children"],
      _excluded74$s = ["children"],
      _excluded75$s = ["children"],
      _excluded76$s = ["children"],
      _excluded77$s = ["children"],
      _excluded78$s = ["children"],
      _excluded79$s = ["children"],
      _excluded80$s = ["children"],
      _excluded81$s = ["children"],
      _excluded82$s = ["children"],
      _excluded83$s = ["children"],
      _excluded84$s = ["children"],
      _excluded85$s = ["children"],
      _excluded86$s = ["children"],
      _excluded87$s = ["children"],
      _excluded88$s = ["children"],
      _excluded89$s = ["children"],
      _excluded90$s = ["children"],
      _excluded91$s = ["children"],
      _excluded92$s = ["children"],
      _excluded93$s = ["children"],
      _excluded94$s = ["children"],
      _excluded95$s = ["children"],
      _excluded96$s = ["children"],
      _excluded97$s = ["children"],
      _excluded98$s = ["children"],
      _excluded99$s = ["children"],
      _excluded100$s = ["children"],
      _excluded101$s = ["children"],
      _excluded102$s = ["children"],
      _excluded103$s = ["children"],
      _excluded104$s = ["children"],
      _excluded105$s = ["children"],
      _excluded106$s = ["children"],
      _excluded107$s = ["children"],
      _excluded108$s = ["children"],
      _excluded109$s = ["children"],
      _excluded110$s = ["children"],
      _excluded111$s = ["children"],
      _excluded112$s = ["children"],
      _excluded113$s = ["children"],
      _excluded114$s = ["children"],
      _excluded115$s = ["children"],
      _excluded116$s = ["children"],
      _excluded117$s = ["children"],
      _excluded118$s = ["children"],
      _excluded119$r = ["children"],
      _excluded120$r = ["children"],
      _excluded121$r = ["children"],
      _excluded122$r = ["children"],
      _excluded123$r = ["children"],
      _excluded124$r = ["children"],
      _excluded125$r = ["children"],
      _excluded126$r = ["children"],
      _excluded127$r = ["children"],
      _excluded128$r = ["children"],
      _excluded129$r = ["children"],
      _excluded130$r = ["children"],
      _excluded131$r = ["children"],
      _excluded132$r = ["children"],
      _excluded133$r = ["children"],
      _excluded134$r = ["children"],
      _excluded135$r = ["children"],
      _excluded136$r = ["children"],
      _excluded137$r = ["children"],
      _excluded138$r = ["children"],
      _excluded139$r = ["children"],
      _excluded140$r = ["children"],
      _excluded141$r = ["children"],
      _excluded142$r = ["children"],
      _excluded143$r = ["children"],
      _excluded144$r = ["children"],
      _excluded145$r = ["children"],
      _excluded146$r = ["children"],
      _excluded147$r = ["children"],
      _excluded148$r = ["children"],
      _excluded149$r = ["children"],
      _excluded150$r = ["children"],
      _excluded151$r = ["children"],
      _excluded152$r = ["children"],
      _excluded153$r = ["children"],
      _excluded154$r = ["children"],
      _excluded155$r = ["children"],
      _excluded156$r = ["children"],
      _excluded157$r = ["children"],
      _excluded158$r = ["children"],
      _excluded159$r = ["children"],
      _excluded160$r = ["children"],
      _excluded161$r = ["children"],
      _excluded162$r = ["children"],
      _excluded163$r = ["children"],
      _excluded164$r = ["children"],
      _excluded165$r = ["children"],
      _excluded166$r = ["children"],
      _excluded167$r = ["children"],
      _excluded168$r = ["children"],
      _excluded169$r = ["children"],
      _excluded170$r = ["children"],
      _excluded171$r = ["children"],
      _excluded172$r = ["children"],
      _excluded173$r = ["children"],
      _excluded174$r = ["children"],
      _excluded175$r = ["children"],
      _excluded176$r = ["children"],
      _excluded177$r = ["children"],
      _excluded178$r = ["children"],
      _excluded179$r = ["children"],
      _excluded180$r = ["children"],
      _excluded181$r = ["children"],
      _excluded182$r = ["children"],
      _excluded183$r = ["children"],
      _excluded184$r = ["children"],
      _excluded185$r = ["children"],
      _excluded186$r = ["children"],
      _excluded187$r = ["children"],
      _excluded188$r = ["children"],
      _excluded189$r = ["children"],
      _excluded190$r = ["children"],
      _excluded191$r = ["children"],
      _excluded192$r = ["children"],
      _excluded193$r = ["children"],
      _excluded194$r = ["children"],
      _excluded195$r = ["children"],
      _excluded196$r = ["children"],
      _excluded197$r = ["children"],
      _excluded198$r = ["children"],
      _excluded199$r = ["children"],
      _excluded200$r = ["children"],
      _excluded201$r = ["children"],
      _excluded202$r = ["children"],
      _excluded203$r = ["children"],
      _excluded204$r = ["children"],
      _excluded205$r = ["children"],
      _excluded206$r = ["children"],
      _excluded207$r = ["children"],
      _excluded208$r = ["children"],
      _excluded209$r = ["children"],
      _excluded210$r = ["children"],
      _excluded211$r = ["children"],
      _excluded212$r = ["children"],
      _excluded213$r = ["children"],
      _excluded214$r = ["children"],
      _excluded215$r = ["children"],
      _excluded216$r = ["children"],
      _excluded217$r = ["children"],
      _excluded218$r = ["children"],
      _excluded219$r = ["children"],
      _excluded220$r = ["children"],
      _excluded221$r = ["children"],
      _excluded222$r = ["children"],
      _excluded223$r = ["children"],
      _excluded224$r = ["children"],
      _excluded225$r = ["children"],
      _excluded226$r = ["children"],
      _excluded227$r = ["children"],
      _excluded228$r = ["children"],
      _excluded229$r = ["children"],
      _excluded230$r = ["children"],
      _excluded231$r = ["children"],
      _excluded232$r = ["children"],
      _excluded233$r = ["children"],
      _excluded234$r = ["children"],
      _excluded235$r = ["children"],
      _excluded236$r = ["children"],
      _excluded237$r = ["children"],
      _excluded238$r = ["children"],
      _excluded239$r = ["children"],
      _excluded240$r = ["children"],
      _excluded241$r = ["children"],
      _excluded242$r = ["children"],
      _excluded243$r = ["children"],
      _excluded244$r = ["children"],
      _excluded245$r = ["children"],
      _excluded246$r = ["children"],
      _excluded247$r = ["children"],
      _excluded248$r = ["children"],
      _excluded249$r = ["children"],
      _excluded250$r = ["children"];
  var Bat32 = /*#__PURE__*/React__default['default'].forwardRef(function Bat32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$s || (_path$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9093,6.584A1,1,0,0,0,31,6c-4.7683,0-8.2607.8887-11,2.8438V3H18V6H14V3H12V8.8438C9.2608,6.8887,5.7684,6,1,6A1,1,0,0,0,.2437,7.6543C1.9454,9.6221,3,11.7041,3,16a1,1,0,0,0,1,1c2.7678,0,6,1.31,6,5a1.004,1.004,0,0,0,.9341.998C11.35,23.0273,15,23.3872,15,27a1,1,0,0,0,2,0c0-3.6128,3.65-3.9727,4.0622-4.002A1,1,0,0,0,22,22c0-3.69,3.2321-5,6-5a1,1,0,0,0,1-1c0-4.2959,1.0547-6.3779,2.7564-8.3457A1,1,0,0,0,31.9093,6.584Zm-4.893,8.46c-3.3857.3081-6.5534,2.229-6.97,6.0786A6.552,6.552,0,0,0,16,23.6094a6.552,6.552,0,0,0-4.0461-2.4864c-.4168-3.85-3.5845-5.7705-6.97-6.0786a13.2017,13.2017,0,0,0-1.9387-6.98c4.1318.2724,7.0327,1.4277,9.248,3.6425A1,1,0,0,0,14,11V8h4v3a1,1,0,0,0,1.707.707c2.2153-2.2148,5.1162-3.37,9.248-3.6425A13.2017,13.2017,0,0,0,27.0163,15.0444Z"
    })), children);
  });
  var Bat24 = /*#__PURE__*/React__default['default'].forwardRef(function Bat24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$s || (_path2$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9093,6.584A1,1,0,0,0,31,6c-4.7683,0-8.2607.8887-11,2.8438V3H18V6H14V3H12V8.8438C9.2608,6.8887,5.7684,6,1,6A1,1,0,0,0,.2437,7.6543C1.9454,9.6221,3,11.7041,3,16a1,1,0,0,0,1,1c2.7678,0,6,1.31,6,5a1.004,1.004,0,0,0,.9341.998C11.35,23.0273,15,23.3872,15,27a1,1,0,0,0,2,0c0-3.6128,3.65-3.9727,4.0622-4.002A1,1,0,0,0,22,22c0-3.69,3.2321-5,6-5a1,1,0,0,0,1-1c0-4.2959,1.0547-6.3779,2.7564-8.3457A1,1,0,0,0,31.9093,6.584Zm-4.893,8.46c-3.3857.3081-6.5534,2.229-6.97,6.0786A6.552,6.552,0,0,0,16,23.6094a6.552,6.552,0,0,0-4.0461-2.4864c-.4168-3.85-3.5845-5.7705-6.97-6.0786a13.2017,13.2017,0,0,0-1.9387-6.98c4.1318.2724,7.0327,1.4277,9.248,3.6425A1,1,0,0,0,14,11V8h4v3a1,1,0,0,0,1.707.707c2.2153-2.2148,5.1162-3.37,9.248-3.6425A13.2017,13.2017,0,0,0,27.0163,15.0444Z"
    })), children);
  });
  var Bat20 = /*#__PURE__*/React__default['default'].forwardRef(function Bat20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$s || (_path3$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9093,6.584A1,1,0,0,0,31,6c-4.7683,0-8.2607.8887-11,2.8438V3H18V6H14V3H12V8.8438C9.2608,6.8887,5.7684,6,1,6A1,1,0,0,0,.2437,7.6543C1.9454,9.6221,3,11.7041,3,16a1,1,0,0,0,1,1c2.7678,0,6,1.31,6,5a1.004,1.004,0,0,0,.9341.998C11.35,23.0273,15,23.3872,15,27a1,1,0,0,0,2,0c0-3.6128,3.65-3.9727,4.0622-4.002A1,1,0,0,0,22,22c0-3.69,3.2321-5,6-5a1,1,0,0,0,1-1c0-4.2959,1.0547-6.3779,2.7564-8.3457A1,1,0,0,0,31.9093,6.584Zm-4.893,8.46c-3.3857.3081-6.5534,2.229-6.97,6.0786A6.552,6.552,0,0,0,16,23.6094a6.552,6.552,0,0,0-4.0461-2.4864c-.4168-3.85-3.5845-5.7705-6.97-6.0786a13.2017,13.2017,0,0,0-1.9387-6.98c4.1318.2724,7.0327,1.4277,9.248,3.6425A1,1,0,0,0,14,11V8h4v3a1,1,0,0,0,1.707.707c2.2153-2.2148,5.1162-3.37,9.248-3.6425A13.2017,13.2017,0,0,0,27.0163,15.0444Z"
    })), children);
  });
  var Bat16 = /*#__PURE__*/React__default['default'].forwardRef(function Bat16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$s || (_path4$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9093,6.584A1,1,0,0,0,31,6c-4.7683,0-8.2607.8887-11,2.8438V3H18V6H14V3H12V8.8438C9.2608,6.8887,5.7684,6,1,6A1,1,0,0,0,.2437,7.6543C1.9454,9.6221,3,11.7041,3,16a1,1,0,0,0,1,1c2.7678,0,6,1.31,6,5a1.004,1.004,0,0,0,.9341.998C11.35,23.0273,15,23.3872,15,27a1,1,0,0,0,2,0c0-3.6128,3.65-3.9727,4.0622-4.002A1,1,0,0,0,22,22c0-3.69,3.2321-5,6-5a1,1,0,0,0,1-1c0-4.2959,1.0547-6.3779,2.7564-8.3457A1,1,0,0,0,31.9093,6.584Zm-4.893,8.46c-3.3857.3081-6.5534,2.229-6.97,6.0786A6.552,6.552,0,0,0,16,23.6094a6.552,6.552,0,0,0-4.0461-2.4864c-.4168-3.85-3.5845-5.7705-6.97-6.0786a13.2017,13.2017,0,0,0-1.9387-6.98c4.1318.2724,7.0327,1.4277,9.248,3.6425A1,1,0,0,0,14,11V8h4v3a1,1,0,0,0,1.707.707c2.2153-2.2148,5.1162-3.37,9.248-3.6425A13.2017,13.2017,0,0,0,27.0163,15.0444Z"
    })), children);
  });
  var BatteryCharging32 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryCharging32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$s || (_path5$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H26V10a2 2 0 00-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 002-2V21h1a2 2 0 002-2V13A2 2 0 0027 11zM11 22H6V10h6V8H6a2 2 0 00-2 2V22a2 2 0 002 2h5z"
    })), _path6$s || (_path6$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"
    })), children);
  });
  var BatteryCharging24 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryCharging24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$s || (_path7$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H26V10a2 2 0 00-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 002-2V21h1a2 2 0 002-2V13A2 2 0 0027 11zM11 22H6V10h6V8H6a2 2 0 00-2 2V22a2 2 0 002 2h5z"
    })), _path8$s || (_path8$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"
    })), children);
  });
  var BatteryCharging20 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryCharging20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$s || (_path9$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H26V10a2 2 0 00-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 002-2V21h1a2 2 0 002-2V13A2 2 0 0027 11zM11 22H6V10h6V8H6a2 2 0 00-2 2V22a2 2 0 002 2h5z"
    })), _path10$s || (_path10$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"
    })), children);
  });
  var BatteryCharging16 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryCharging16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$s || (_path11$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H26V10a2 2 0 00-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 002-2V21h1a2 2 0 002-2V13A2 2 0 0027 11zM11 22H6V10h6V8H6a2 2 0 00-2 2V22a2 2 0 002 2h5z"
    })), _path12$s || (_path12$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"
    })), children);
  });
  var BatteryEmpty32 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryEmpty32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$s || (_path13$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), children);
  });
  var BatteryEmpty24 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryEmpty24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$s || (_path14$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), children);
  });
  var BatteryEmpty20 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryEmpty20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$s || (_path15$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), children);
  });
  var BatteryEmpty16 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryEmpty16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$s || (_path16$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), children);
  });
  var BatteryFull32 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryFull32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$s || (_path17$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path18$s || (_path18$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 9H19V23H11z",
      transform: "rotate(90 15 16)"
    })), children);
  });
  var BatteryFull24 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryFull24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$s || (_path19$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path20$s || (_path20$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 9H19V23H11z",
      transform: "rotate(90 15 16)"
    })), children);
  });
  var BatteryFull20 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryFull20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$s || (_path21$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path22$s || (_path22$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 9H19V23H11z",
      transform: "rotate(90 15 16)"
    })), children);
  });
  var BatteryFull16 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryFull16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$s || (_path23$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path24$s || (_path24$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 9H19V23H11z",
      transform: "rotate(90 15 16)"
    })), children);
  });
  var BatteryHalf32 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryHalf32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$s || (_path25$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path26$s || (_path26$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H16V20H8z",
      transform: "rotate(90 12 16)"
    })), children);
  });
  var BatteryHalf24 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryHalf24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$s || (_path27$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path28$s || (_path28$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H16V20H8z",
      transform: "rotate(90 12 16)"
    })), children);
  });
  var BatteryHalf20 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryHalf20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$s || (_path29$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path30$s || (_path30$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H16V20H8z",
      transform: "rotate(90 12 16)"
    })), children);
  });
  var BatteryHalf16 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryHalf16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$s || (_path31$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path32$s || (_path32$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H16V20H8z",
      transform: "rotate(90 12 16)"
    })), children);
  });
  var BatteryLow32 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryLow32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$s || (_path33$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path34$s || (_path34$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 15H13V17H5z",
      transform: "rotate(90 9 16)"
    })), children);
  });
  var BatteryLow24 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryLow24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$s || (_path35$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path36$s || (_path36$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 15H13V17H5z",
      transform: "rotate(90 9 16)"
    })), children);
  });
  var BatteryLow20 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryLow20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$s || (_path37$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path38$s || (_path38$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 15H13V17H5z",
      transform: "rotate(90 9 16)"
    })), children);
  });
  var BatteryLow16 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryLow16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$s || (_path39$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path40$s || (_path40$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 15H13V17H5z",
      transform: "rotate(90 9 16)"
    })), children);
  });
  var BatteryQuarter32 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryQuarter32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$s || (_path41$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path42$s || (_path42$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 14H14V18H6z",
      transform: "rotate(90 10 16)"
    })), children);
  });
  var BatteryQuarter24 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryQuarter24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$s || (_path43$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path44$s || (_path44$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 14H14V18H6z",
      transform: "rotate(90 10 16)"
    })), children);
  });
  var BatteryQuarter20 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryQuarter20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$s || (_path45$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path46$s || (_path46$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 14H14V18H6z",
      transform: "rotate(90 10 16)"
    })), children);
  });
  var BatteryQuarter16 = /*#__PURE__*/React__default['default'].forwardRef(function BatteryQuarter16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$s || (_path47$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"
    })), _path48$s || (_path48$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 14H14V18H6z",
      transform: "rotate(90 10 16)"
    })), children);
  });
  var Bee32 = /*#__PURE__*/React__default['default'].forwardRef(function Bee32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$s || (_path49$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10a6 6 0 00-6 6v8a6 6 0 0012 0V16A6 6 0 0016 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0111.75 24v-.13h8.5V24A4.27 4.27 0 0116 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 018.5 0zM30.66 19.21L24 13v9.1a4 4 0 008 0A3.83 3.83 0 0030.66 19.21zM28 24.35a2.25 2.25 0 01-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0130.2 22 2.25 2.25 0 0128 24.35zM0 22.1a4 4 0 008 0V13L1.34 19.21A3.88 3.88 0 000 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 01-4.5 0A2.05 2.05 0 012.48 20.54zM15 5.5A3.5 3.5 0 1011.5 9 3.5 3.5 0 0015 5.5zm-5.25 0A1.75 1.75 0 1111.5 7.25 1.77 1.77 0 019.75 5.5zM20.5 2A3.5 3.5 0 1024 5.5 3.5 3.5 0 0020.5 2zm0 5.25A1.75 1.75 0 1122.25 5.5 1.77 1.77 0 0120.5 7.25z"
    })), children);
  });
  var Bee24 = /*#__PURE__*/React__default['default'].forwardRef(function Bee24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$s || (_path50$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10a6 6 0 00-6 6v8a6 6 0 0012 0V16A6 6 0 0016 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0111.75 24v-.13h8.5V24A4.27 4.27 0 0116 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 018.5 0zM30.66 19.21L24 13v9.1a4 4 0 008 0A3.83 3.83 0 0030.66 19.21zM28 24.35a2.25 2.25 0 01-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0130.2 22 2.25 2.25 0 0128 24.35zM0 22.1a4 4 0 008 0V13L1.34 19.21A3.88 3.88 0 000 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 01-4.5 0A2.05 2.05 0 012.48 20.54zM15 5.5A3.5 3.5 0 1011.5 9 3.5 3.5 0 0015 5.5zm-5.25 0A1.75 1.75 0 1111.5 7.25 1.77 1.77 0 019.75 5.5zM20.5 2A3.5 3.5 0 1024 5.5 3.5 3.5 0 0020.5 2zm0 5.25A1.75 1.75 0 1122.25 5.5 1.77 1.77 0 0120.5 7.25z"
    })), children);
  });
  var Bee20 = /*#__PURE__*/React__default['default'].forwardRef(function Bee20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$s || (_path51$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10a6 6 0 00-6 6v8a6 6 0 0012 0V16A6 6 0 0016 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0111.75 24v-.13h8.5V24A4.27 4.27 0 0116 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 018.5 0zM30.66 19.21L24 13v9.1a4 4 0 008 0A3.83 3.83 0 0030.66 19.21zM28 24.35a2.25 2.25 0 01-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0130.2 22 2.25 2.25 0 0128 24.35zM0 22.1a4 4 0 008 0V13L1.34 19.21A3.88 3.88 0 000 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 01-4.5 0A2.05 2.05 0 012.48 20.54zM15 5.5A3.5 3.5 0 1011.5 9 3.5 3.5 0 0015 5.5zm-5.25 0A1.75 1.75 0 1111.5 7.25 1.77 1.77 0 019.75 5.5zM20.5 2A3.5 3.5 0 1024 5.5 3.5 3.5 0 0020.5 2zm0 5.25A1.75 1.75 0 1122.25 5.5 1.77 1.77 0 0120.5 7.25z"
    })), children);
  });
  var Bee16 = /*#__PURE__*/React__default['default'].forwardRef(function Bee16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$s || (_path52$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10a6 6 0 00-6 6v8a6 6 0 0012 0V16A6 6 0 0016 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0111.75 24v-.13h8.5V24A4.27 4.27 0 0116 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 018.5 0zM30.66 19.21L24 13v9.1a4 4 0 008 0A3.83 3.83 0 0030.66 19.21zM28 24.35a2.25 2.25 0 01-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0130.2 22 2.25 2.25 0 0128 24.35zM0 22.1a4 4 0 008 0V13L1.34 19.21A3.88 3.88 0 000 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 01-4.5 0A2.05 2.05 0 012.48 20.54zM15 5.5A3.5 3.5 0 1011.5 9 3.5 3.5 0 0015 5.5zm-5.25 0A1.75 1.75 0 1111.5 7.25 1.77 1.77 0 019.75 5.5zM20.5 2A3.5 3.5 0 1024 5.5 3.5 3.5 0 0020.5 2zm0 5.25A1.75 1.75 0 1122.25 5.5 1.77 1.77 0 0120.5 7.25z"
    })), children);
  });
  var BeeBat32 = /*#__PURE__*/React__default['default'].forwardRef(function BeeBat32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$r || (_circle$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "8",
      r: "2"
    })), _circle2$r || (_circle2$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "8",
      r: "2"
    })), _path53$s || (_path53$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.8083,8.665A.8745.8745,0,0,0,31,8.125H29c-4.21,0-7.721,2.002-9.1648,4.9014a4.8186,4.8186,0,0,0-7.67,0C10.721,10.127,7.21,8.125,3,8.125H1A.8749.8749,0,0,0,.3816,9.6191L.4834,9.72A5.3885,5.3885,0,0,1,2.1612,15.751.8751.8751,0,0,0,3,16.875a2.8966,2.8966,0,0,1,2.1587.7266c.9783.9814.9714,2.8872.9668,4.1479l0,.25A.875.875,0,0,0,7,22.875h4.125V23a4.875,4.875,0,0,0,9.75,0v-.125H25A.875.875,0,0,0,25.875,22l0-.25c-.0046-1.2607-.0115-3.1665.9668-4.1479A2.8966,2.8966,0,0,1,29,16.875a.8751.8751,0,0,0,.8388-1.124,5.3883,5.3883,0,0,1,1.6765-6.0293l.1033-.103A.875.875,0,0,0,31.8083,8.665ZM16,12.875A3.1286,3.1286,0,0,1,19.125,16v.125h-6.25V16A3.1286,3.1286,0,0,1,16,12.875Zm-3.125,5h6.25v3.25h-6.25Zm-5.0007,3.25c-.0178-1.459-.1839-3.4619-1.4761-4.7588a4.1876,4.1876,0,0,0-2.31-1.1518A6.657,6.657,0,0,0,2.9524,9.875H3c4.5562,0,8.125,2.69,8.125,6.125v5.125ZM19.125,23a3.125,3.125,0,0,1-6.25,0v-.125h6.25Zm8.7868-7.7856a4.1876,4.1876,0,0,0-2.31,1.1518c-1.2922,1.2969-1.4583,3.3-1.4761,4.7588H20.875V16c0-3.4346,3.5688-6.125,8.125-6.125h.0481A6.6561,6.6561,0,0,0,27.9118,15.2144Z"
    })), children);
  });
  var BeeBat24 = /*#__PURE__*/React__default['default'].forwardRef(function BeeBat24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$r || (_circle3$r = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "8",
      r: "2"
    })), _circle4$q || (_circle4$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "8",
      r: "2"
    })), _path54$s || (_path54$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.8083,8.665A.8745.8745,0,0,0,31,8.125H29c-4.21,0-7.721,2.002-9.1648,4.9014a4.8186,4.8186,0,0,0-7.67,0C10.721,10.127,7.21,8.125,3,8.125H1A.8749.8749,0,0,0,.3816,9.6191L.4834,9.72A5.3885,5.3885,0,0,1,2.1612,15.751.8751.8751,0,0,0,3,16.875a2.8966,2.8966,0,0,1,2.1587.7266c.9783.9814.9714,2.8872.9668,4.1479l0,.25A.875.875,0,0,0,7,22.875h4.125V23a4.875,4.875,0,0,0,9.75,0v-.125H25A.875.875,0,0,0,25.875,22l0-.25c-.0046-1.2607-.0115-3.1665.9668-4.1479A2.8966,2.8966,0,0,1,29,16.875a.8751.8751,0,0,0,.8388-1.124,5.3883,5.3883,0,0,1,1.6765-6.0293l.1033-.103A.875.875,0,0,0,31.8083,8.665ZM16,12.875A3.1286,3.1286,0,0,1,19.125,16v.125h-6.25V16A3.1286,3.1286,0,0,1,16,12.875Zm-3.125,5h6.25v3.25h-6.25Zm-5.0007,3.25c-.0178-1.459-.1839-3.4619-1.4761-4.7588a4.1876,4.1876,0,0,0-2.31-1.1518A6.657,6.657,0,0,0,2.9524,9.875H3c4.5562,0,8.125,2.69,8.125,6.125v5.125ZM19.125,23a3.125,3.125,0,0,1-6.25,0v-.125h6.25Zm8.7868-7.7856a4.1876,4.1876,0,0,0-2.31,1.1518c-1.2922,1.2969-1.4583,3.3-1.4761,4.7588H20.875V16c0-3.4346,3.5688-6.125,8.125-6.125h.0481A6.6561,6.6561,0,0,0,27.9118,15.2144Z"
    })), children);
  });
  var BeeBat20 = /*#__PURE__*/React__default['default'].forwardRef(function BeeBat20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$p || (_circle5$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "8",
      r: "2"
    })), _circle6$p || (_circle6$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "8",
      r: "2"
    })), _path55$s || (_path55$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.8083,8.665A.8745.8745,0,0,0,31,8.125H29c-4.21,0-7.721,2.002-9.1648,4.9014a4.8186,4.8186,0,0,0-7.67,0C10.721,10.127,7.21,8.125,3,8.125H1A.8749.8749,0,0,0,.3816,9.6191L.4834,9.72A5.3885,5.3885,0,0,1,2.1612,15.751.8751.8751,0,0,0,3,16.875a2.8966,2.8966,0,0,1,2.1587.7266c.9783.9814.9714,2.8872.9668,4.1479l0,.25A.875.875,0,0,0,7,22.875h4.125V23a4.875,4.875,0,0,0,9.75,0v-.125H25A.875.875,0,0,0,25.875,22l0-.25c-.0046-1.2607-.0115-3.1665.9668-4.1479A2.8966,2.8966,0,0,1,29,16.875a.8751.8751,0,0,0,.8388-1.124,5.3883,5.3883,0,0,1,1.6765-6.0293l.1033-.103A.875.875,0,0,0,31.8083,8.665ZM16,12.875A3.1286,3.1286,0,0,1,19.125,16v.125h-6.25V16A3.1286,3.1286,0,0,1,16,12.875Zm-3.125,5h6.25v3.25h-6.25Zm-5.0007,3.25c-.0178-1.459-.1839-3.4619-1.4761-4.7588a4.1876,4.1876,0,0,0-2.31-1.1518A6.657,6.657,0,0,0,2.9524,9.875H3c4.5562,0,8.125,2.69,8.125,6.125v5.125ZM19.125,23a3.125,3.125,0,0,1-6.25,0v-.125h6.25Zm8.7868-7.7856a4.1876,4.1876,0,0,0-2.31,1.1518c-1.2922,1.2969-1.4583,3.3-1.4761,4.7588H20.875V16c0-3.4346,3.5688-6.125,8.125-6.125h.0481A6.6561,6.6561,0,0,0,27.9118,15.2144Z"
    })), children);
  });
  var BeeBat16 = /*#__PURE__*/React__default['default'].forwardRef(function BeeBat16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$p || (_circle7$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "8",
      r: "2"
    })), _circle8$p || (_circle8$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "8",
      r: "2"
    })), _path56$s || (_path56$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.8083,8.665A.8745.8745,0,0,0,31,8.125H29c-4.21,0-7.721,2.002-9.1648,4.9014a4.8186,4.8186,0,0,0-7.67,0C10.721,10.127,7.21,8.125,3,8.125H1A.8749.8749,0,0,0,.3816,9.6191L.4834,9.72A5.3885,5.3885,0,0,1,2.1612,15.751.8751.8751,0,0,0,3,16.875a2.8966,2.8966,0,0,1,2.1587.7266c.9783.9814.9714,2.8872.9668,4.1479l0,.25A.875.875,0,0,0,7,22.875h4.125V23a4.875,4.875,0,0,0,9.75,0v-.125H25A.875.875,0,0,0,25.875,22l0-.25c-.0046-1.2607-.0115-3.1665.9668-4.1479A2.8966,2.8966,0,0,1,29,16.875a.8751.8751,0,0,0,.8388-1.124,5.3883,5.3883,0,0,1,1.6765-6.0293l.1033-.103A.875.875,0,0,0,31.8083,8.665ZM16,12.875A3.1286,3.1286,0,0,1,19.125,16v.125h-6.25V16A3.1286,3.1286,0,0,1,16,12.875Zm-3.125,5h6.25v3.25h-6.25Zm-5.0007,3.25c-.0178-1.459-.1839-3.4619-1.4761-4.7588a4.1876,4.1876,0,0,0-2.31-1.1518A6.657,6.657,0,0,0,2.9524,9.875H3c4.5562,0,8.125,2.69,8.125,6.125v5.125ZM19.125,23a3.125,3.125,0,0,1-6.25,0v-.125h6.25Zm8.7868-7.7856a4.1876,4.1876,0,0,0-2.31,1.1518c-1.2922,1.2969-1.4583,3.3-1.4761,4.7588H20.875V16c0-3.4346,3.5688-6.125,8.125-6.125h.0481A6.6561,6.6561,0,0,0,27.9118,15.2144Z"
    })), children);
  });
  var Beta32 = /*#__PURE__*/React__default['default'].forwardRef(function Beta32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$s || (_path57$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.7168,13.7705A5.9174,5.9174,0,0,0,23,9c0-3.5327-2.8784-6-7-6a6.627,6.627,0,0,0-7,7V31h2V25.1206a8.1261,8.1261,0,0,0,6,2.48A7.3833,7.3833,0,0,0,24.6528,20,6.6364,6.6364,0,0,0,20.7168,13.7705ZM17,25.6A5.6781,5.6781,0,0,1,11,20V10a4.6856,4.6856,0,0,1,5-5c3.0374,0,5,1.57,5,4a3.8732,3.8732,0,0,1-4,4v2c3.4341,0,5.6528,1.9629,5.6528,5A5.3907,5.3907,0,0,1,17,25.6Z"
    })), children);
  });
  var Beta24 = /*#__PURE__*/React__default['default'].forwardRef(function Beta24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$s || (_path58$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.7168,13.7705A5.9174,5.9174,0,0,0,23,9c0-3.5327-2.8784-6-7-6a6.627,6.627,0,0,0-7,7V31h2V25.1206a8.1261,8.1261,0,0,0,6,2.48A7.3833,7.3833,0,0,0,24.6528,20,6.6364,6.6364,0,0,0,20.7168,13.7705ZM17,25.6A5.6781,5.6781,0,0,1,11,20V10a4.6856,4.6856,0,0,1,5-5c3.0374,0,5,1.57,5,4a3.8732,3.8732,0,0,1-4,4v2c3.4341,0,5.6528,1.9629,5.6528,5A5.3907,5.3907,0,0,1,17,25.6Z"
    })), children);
  });
  var Beta20 = /*#__PURE__*/React__default['default'].forwardRef(function Beta20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$s || (_path59$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.7168,13.7705A5.9174,5.9174,0,0,0,23,9c0-3.5327-2.8784-6-7-6a6.627,6.627,0,0,0-7,7V31h2V25.1206a8.1261,8.1261,0,0,0,6,2.48A7.3833,7.3833,0,0,0,24.6528,20,6.6364,6.6364,0,0,0,20.7168,13.7705ZM17,25.6A5.6781,5.6781,0,0,1,11,20V10a4.6856,4.6856,0,0,1,5-5c3.0374,0,5,1.57,5,4a3.8732,3.8732,0,0,1-4,4v2c3.4341,0,5.6528,1.9629,5.6528,5A5.3907,5.3907,0,0,1,17,25.6Z"
    })), children);
  });
  var Beta16 = /*#__PURE__*/React__default['default'].forwardRef(function Beta16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$s || (_path60$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.7168,13.7705A5.9174,5.9174,0,0,0,23,9c0-3.5327-2.8784-6-7-6a6.627,6.627,0,0,0-7,7V31h2V25.1206a8.1261,8.1261,0,0,0,6,2.48A7.3833,7.3833,0,0,0,24.6528,20,6.6364,6.6364,0,0,0,20.7168,13.7705ZM17,25.6A5.6781,5.6781,0,0,1,11,20V10a4.6856,4.6856,0,0,1,5-5c3.0374,0,5,1.57,5,4a3.8732,3.8732,0,0,1-4,4v2c3.4341,0,5.6528,1.9629,5.6528,5A5.3907,5.3907,0,0,1,17,25.6Z"
    })), children);
  });
  var Bicycle32 = /*#__PURE__*/React__default['default'].forwardRef(function Bicycle32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$s || (_path61$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"
    })), children);
  });
  var Bicycle24 = /*#__PURE__*/React__default['default'].forwardRef(function Bicycle24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$s || (_path62$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"
    })), children);
  });
  var Bicycle20 = /*#__PURE__*/React__default['default'].forwardRef(function Bicycle20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$s || (_path63$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"
    })), children);
  });
  var Bicycle16 = /*#__PURE__*/React__default['default'].forwardRef(function Bicycle16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$s || (_path64$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"
    })), children);
  });
  var Binoculars32 = /*#__PURE__*/React__default['default'].forwardRef(function Binoculars32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$s || (_path65$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"
    })), children);
  });
  var Binoculars24 = /*#__PURE__*/React__default['default'].forwardRef(function Binoculars24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$s || (_path66$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"
    })), children);
  });
  var Binoculars20 = /*#__PURE__*/React__default['default'].forwardRef(function Binoculars20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$s || (_path67$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"
    })), children);
  });
  var Binoculars16 = /*#__PURE__*/React__default['default'].forwardRef(function Binoculars16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$s || (_path68$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"
    })), children);
  });
  var QBlochSphere32 = /*#__PURE__*/React__default['default'].forwardRef(function QBlochSphere32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$s || (_path69$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path70$s || (_path70$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var QBlochSphere24 = /*#__PURE__*/React__default['default'].forwardRef(function QBlochSphere24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$s || (_path71$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path72$s || (_path72$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var QBlochSphere20 = /*#__PURE__*/React__default['default'].forwardRef(function QBlochSphere20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$s || (_path73$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path74$s || (_path74$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var QBlochSphere16 = /*#__PURE__*/React__default['default'].forwardRef(function QBlochSphere16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$s || (_path75$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path76$s || (_path76$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var BlockStorage32 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorage32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$s || (_path77$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,12V10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V19H20v9H4V12"
    })), _path78$s || (_path78$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 12H14V4h8zM12 4v8a2 2 0 002 2h8a2 2 0 002-2V4a2 2 0 00-2-2H14A2 2 0 0012 4zM14 18v4H10V18h4M8 18v4a2 2 0 002 2h4a2 2 0 002-2V18a2 2 0 00-2-2H10A2 2 0 008 18zM28 17v2H26V17h2m-4-1v4a1 1 0 001 1h4a1 1 0 001-1V16a1 1 0 00-1-1H25A1 1 0 0024 16z"
    })), children);
  });
  var BlockStorage24 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorage24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$s || (_path79$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,12V10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V19H20v9H4V12"
    })), _path80$s || (_path80$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 12H14V4h8zM12 4v8a2 2 0 002 2h8a2 2 0 002-2V4a2 2 0 00-2-2H14A2 2 0 0012 4zM14 18v4H10V18h4M8 18v4a2 2 0 002 2h4a2 2 0 002-2V18a2 2 0 00-2-2H10A2 2 0 008 18zM28 17v2H26V17h2m-4-1v4a1 1 0 001 1h4a1 1 0 001-1V16a1 1 0 00-1-1H25A1 1 0 0024 16z"
    })), children);
  });
  var BlockStorage20 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorage20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$s || (_path81$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,12V10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V19H20v9H4V12"
    })), _path82$s || (_path82$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 12H14V4h8zM12 4v8a2 2 0 002 2h8a2 2 0 002-2V4a2 2 0 00-2-2H14A2 2 0 0012 4zM14 18v4H10V18h4M8 18v4a2 2 0 002 2h4a2 2 0 002-2V18a2 2 0 00-2-2H10A2 2 0 008 18zM28 17v2H26V17h2m-4-1v4a1 1 0 001 1h4a1 1 0 001-1V16a1 1 0 00-1-1H25A1 1 0 0024 16z"
    })), children);
  });
  var BlockStorage16 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorage16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$s || (_path83$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,12V10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V19H20v9H4V12"
    })), _path84$s || (_path84$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 12H14V4h8zM12 4v8a2 2 0 002 2h8a2 2 0 002-2V4a2 2 0 00-2-2H14A2 2 0 0012 4zM14 18v4H10V18h4M8 18v4a2 2 0 002 2h4a2 2 0 002-2V18a2 2 0 00-2-2H10A2 2 0 008 18zM28 17v2H26V17h2m-4-1v4a1 1 0 001 1h4a1 1 0 001-1V16a1 1 0 00-1-1H25A1 1 0 0024 16z"
    })), children);
  });
  var BlockStorageAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorageAlt32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$s || (_path85$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle9$p || (_circle9$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path86$s || (_path86$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H8V13h7zm-5-2h3V15H10zM24 20H17V13h7zm-5-2h3V15H19zM15 11H8V4h7zM10 9h3V6H10zM24 11H17V4h7zM19 9h3V6H19z"
    })), children);
  });
  var BlockStorageAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorageAlt24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$s || (_path87$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle10$p || (_circle10$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path88$s || (_path88$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H8V13h7zm-5-2h3V15H10zM24 20H17V13h7zm-5-2h3V15H19zM15 11H8V4h7zM10 9h3V6H10zM24 11H17V4h7zM19 9h3V6H19z"
    })), children);
  });
  var BlockStorageAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorageAlt20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$s || (_path89$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle11$o || (_circle11$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path90$s || (_path90$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H8V13h7zm-5-2h3V15H10zM24 20H17V13h7zm-5-2h3V15H19zM15 11H8V4h7zM10 9h3V6H10zM24 11H17V4h7zM19 9h3V6H19z"
    })), children);
  });
  var BlockStorageAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function BlockStorageAlt16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$s || (_path91$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle12$o || (_circle12$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path92$s || (_path92$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H8V13h7zm-5-2h3V15H10zM24 20H17V13h7zm-5-2h3V15H19zM15 11H8V4h7zM10 9h3V6H10zM24 11H17V4h7zM19 9h3V6H19z"
    })), children);
  });
  var Blockchain32 = /*#__PURE__*/React__default['default'].forwardRef(function Blockchain32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$s || (_path93$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"
    })), children);
  });
  var Blockchain24 = /*#__PURE__*/React__default['default'].forwardRef(function Blockchain24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$s || (_path94$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"
    })), children);
  });
  var Blockchain20 = /*#__PURE__*/React__default['default'].forwardRef(function Blockchain20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$s || (_path95$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"
    })), children);
  });
  var Blockchain16 = /*#__PURE__*/React__default['default'].forwardRef(function Blockchain16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$s || (_path96$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"
    })), children);
  });
  var Blog32 = /*#__PURE__*/React__default['default'].forwardRef(function Blog32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$s || (_path97$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2v6A2 2 0 0126 14zM6 6v6H26V6zM26 28H20a2 2 0 01-2-2V20a2 2 0 012-2h6a2 2 0 012 2v6A2 2 0 0126 28zm-6-8v6h6V20z"
    })), children);
  });
  var Blog24 = /*#__PURE__*/React__default['default'].forwardRef(function Blog24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$s || (_path98$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2v6A2 2 0 0126 14zM6 6v6H26V6zM26 28H20a2 2 0 01-2-2V20a2 2 0 012-2h6a2 2 0 012 2v6A2 2 0 0126 28zm-6-8v6h6V20z"
    })), children);
  });
  var Blog20 = /*#__PURE__*/React__default['default'].forwardRef(function Blog20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$s || (_path99$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2v6A2 2 0 0126 14zM6 6v6H26V6zM26 28H20a2 2 0 01-2-2V20a2 2 0 012-2h6a2 2 0 012 2v6A2 2 0 0126 28zm-6-8v6h6V20z"
    })), children);
  });
  var Blog16 = /*#__PURE__*/React__default['default'].forwardRef(function Blog16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$s || (_path100$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2v6A2 2 0 0126 14zM6 6v6H26V6zM26 28H20a2 2 0 01-2-2V20a2 2 0 012-2h6a2 2 0 012 2v6A2 2 0 0126 28zm-6-8v6h6V20z"
    })), children);
  });
  var Bluetooth32 = /*#__PURE__*/React__default['default'].forwardRef(function Bluetooth32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$s || (_path101$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"
    })), children);
  });
  var Bluetooth24 = /*#__PURE__*/React__default['default'].forwardRef(function Bluetooth24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$s || (_path102$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"
    })), children);
  });
  var Bluetooth20 = /*#__PURE__*/React__default['default'].forwardRef(function Bluetooth20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$s || (_path103$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"
    })), children);
  });
  var Bluetooth16 = /*#__PURE__*/React__default['default'].forwardRef(function Bluetooth16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$s || (_path104$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"
    })), children);
  });
  var BluetoothOff32 = /*#__PURE__*/React__default['default'].forwardRef(function BluetoothOff32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$s || (_path105$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 00.58.91A1.06 1.06 0 0016 30a1 1 0 00.65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0024 9a1 1 0 00-.35-.72l-7-6a1 1 0 00-1.07-.15A1 1 0 0015 3v7.75z"
    })), children);
  });
  var BluetoothOff24 = /*#__PURE__*/React__default['default'].forwardRef(function BluetoothOff24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$s || (_path106$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 00.58.91A1.06 1.06 0 0016 30a1 1 0 00.65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0024 9a1 1 0 00-.35-.72l-7-6a1 1 0 00-1.07-.15A1 1 0 0015 3v7.75z"
    })), children);
  });
  var BluetoothOff20 = /*#__PURE__*/React__default['default'].forwardRef(function BluetoothOff20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$s || (_path107$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 00.58.91A1.06 1.06 0 0016 30a1 1 0 00.65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0024 9a1 1 0 00-.35-.72l-7-6a1 1 0 00-1.07-.15A1 1 0 0015 3v7.75z"
    })), children);
  });
  var BluetoothOff16 = /*#__PURE__*/React__default['default'].forwardRef(function BluetoothOff16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$s || (_path108$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 00.58.91A1.06 1.06 0 0016 30a1 1 0 00.65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0024 9a1 1 0 00-.35-.72l-7-6a1 1 0 00-1.07-.15A1 1 0 0015 3v7.75z"
    })), children);
  });
  var Book32 = /*#__PURE__*/React__default['default'].forwardRef(function Book32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$s || (_path109$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19zM6 10H13V12H6zM6 15H13V17H6zM6 20H13V22H6z"
    })), _path110$s || (_path110$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.002,2.002,0,0,0,2,2H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28V25Z"
    })), children);
  });
  var Book24 = /*#__PURE__*/React__default['default'].forwardRef(function Book24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$s || (_path111$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19zM6 10H13V12H6zM6 15H13V17H6zM6 20H13V22H6z"
    })), _path112$s || (_path112$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.002,2.002,0,0,0,2,2H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28V25Z"
    })), children);
  });
  var Book20 = /*#__PURE__*/React__default['default'].forwardRef(function Book20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$s || (_path113$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19zM6 10H13V12H6zM6 15H13V17H6zM6 20H13V22H6z"
    })), _path114$s || (_path114$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.002,2.002,0,0,0,2,2H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28V25Z"
    })), children);
  });
  var Book16 = /*#__PURE__*/React__default['default'].forwardRef(function Book16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$s || (_path115$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19zM6 10H13V12H6zM6 15H13V17H6zM6 20H13V22H6z"
    })), _path116$s || (_path116$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.002,2.002,0,0,0,2,2H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28V25Z"
    })), children);
  });
  var Bookmark32 = /*#__PURE__*/React__default['default'].forwardRef(function Bookmark32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$s || (_path117$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var Bookmark24 = /*#__PURE__*/React__default['default'].forwardRef(function Bookmark24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$s || (_path118$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var Bookmark20 = /*#__PURE__*/React__default['default'].forwardRef(function Bookmark20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$s || (_path119$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var Bookmark16 = /*#__PURE__*/React__default['default'].forwardRef(function Bookmark16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$s || (_path120$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var BookmarkAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkAdd32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$s || (_path121$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16V26.7515l-7.0962-3.5894L16,22.7051l-.9009.456L8,26.748V4H18V2H8A2,2,0,0,0,6,4V30l10-5.0537L26,30V16Z"
    })), _path122$s || (_path122$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var BookmarkAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkAdd24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$s || (_path123$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16V26.7515l-7.0962-3.5894L16,22.7051l-.9009.456L8,26.748V4H18V2H8A2,2,0,0,0,6,4V30l10-5.0537L26,30V16Z"
    })), _path124$s || (_path124$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var BookmarkAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkAdd20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$s || (_path125$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16V26.7515l-7.0962-3.5894L16,22.7051l-.9009.456L8,26.748V4H18V2H8A2,2,0,0,0,6,4V30l10-5.0537L26,30V16Z"
    })), _path126$s || (_path126$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var BookmarkAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkAdd16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$s || (_path127$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16V26.7515l-7.0962-3.5894L16,22.7051l-.9009.456L8,26.748V4H18V2H8A2,2,0,0,0,6,4V30l10-5.0537L26,30V16Z"
    })), _path128$s || (_path128$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var BookmarkFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkFilled32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$s || (_path129$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V30l10-5.0538L26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var BookmarkFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkFilled24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$s || (_path130$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V30l10-5.0538L26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var BookmarkFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkFilled20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$s || (_path131$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V30l10-5.0538L26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var BookmarkFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function BookmarkFilled16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$s || (_path132$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V30l10-5.0538L26,30V4A2,2,0,0,0,24,2Z"
    })), children);
  });
  var Boolean32 = /*#__PURE__*/React__default['default'].forwardRef(function Boolean32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$s || (_path133$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,23Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,11Z"
    })), _circle13$o || (_circle13$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "7"
    })), children);
  });
  var Boolean24 = /*#__PURE__*/React__default['default'].forwardRef(function Boolean24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$s || (_path134$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,23Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,11Z"
    })), _circle14$o || (_circle14$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "7"
    })), children);
  });
  var Boolean20 = /*#__PURE__*/React__default['default'].forwardRef(function Boolean20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$s || (_path135$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,23Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,11Z"
    })), _circle15$o || (_circle15$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "7"
    })), children);
  });
  var Boolean16 = /*#__PURE__*/React__default['default'].forwardRef(function Boolean16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$s || (_path136$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,23Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,11Z"
    })), _circle16$o || (_circle16$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "7"
    })), children);
  });
  var Boot32 = /*#__PURE__*/React__default['default'].forwardRef(function Boot32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$s || (_path137$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,17H18a1.0008,1.0008,0,0,1-1-1V4a2.0025,2.0025,0,0,0-2-2H5A2.0025,2.0025,0,0,0,3,4V28a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V22A5.0057,5.0057,0,0,0,24,17Zm3,5v2H23V19h1A3.0033,3.0033,0,0,1,27,22ZM15,4V6H11V8h4v2H11v2h4v2H11v2h4a3.0033,3.0033,0,0,0,3,3h3v5H14.1624l-3-1H5V4ZM25,28V27H23v1H21V27H19v1H17V27H15v1H13V27H11v1H5V25h5.8376l3,1H27v2Z"
    })), children);
  });
  var Boot24 = /*#__PURE__*/React__default['default'].forwardRef(function Boot24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$s || (_path138$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,17H18a1.0008,1.0008,0,0,1-1-1V4a2.0025,2.0025,0,0,0-2-2H5A2.0025,2.0025,0,0,0,3,4V28a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V22A5.0057,5.0057,0,0,0,24,17Zm3,5v2H23V19h1A3.0033,3.0033,0,0,1,27,22ZM15,4V6H11V8h4v2H11v2h4v2H11v2h4a3.0033,3.0033,0,0,0,3,3h3v5H14.1624l-3-1H5V4ZM25,28V27H23v1H21V27H19v1H17V27H15v1H13V27H11v1H5V25h5.8376l3,1H27v2Z"
    })), children);
  });
  var Boot20 = /*#__PURE__*/React__default['default'].forwardRef(function Boot20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$s || (_path139$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,17H18a1.0008,1.0008,0,0,1-1-1V4a2.0025,2.0025,0,0,0-2-2H5A2.0025,2.0025,0,0,0,3,4V28a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V22A5.0057,5.0057,0,0,0,24,17Zm3,5v2H23V19h1A3.0033,3.0033,0,0,1,27,22ZM15,4V6H11V8h4v2H11v2h4v2H11v2h4a3.0033,3.0033,0,0,0,3,3h3v5H14.1624l-3-1H5V4ZM25,28V27H23v1H21V27H19v1H17V27H15v1H13V27H11v1H5V25h5.8376l3,1H27v2Z"
    })), children);
  });
  var Boot16 = /*#__PURE__*/React__default['default'].forwardRef(function Boot16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$s || (_path140$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,17H18a1.0008,1.0008,0,0,1-1-1V4a2.0025,2.0025,0,0,0-2-2H5A2.0025,2.0025,0,0,0,3,4V28a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V22A5.0057,5.0057,0,0,0,24,17Zm3,5v2H23V19h1A3.0033,3.0033,0,0,1,27,22ZM15,4V6H11V8h4v2H11v2h4v2H11v2h4a3.0033,3.0033,0,0,0,3,3h3v5H14.1624l-3-1H5V4ZM25,28V27H23v1H21V27H19v1H17V27H15v1H13V27H11v1H5V25h5.8376l3,1H27v2Z"
    })), children);
  });
  var BorderBottom32 = /*#__PURE__*/React__default['default'].forwardRef(function BorderBottom32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$s || (_path141$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H29V29H3z",
      transform: "rotate(180 16 28)"
    })), _path142$s || (_path142$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(180 28 24)"
    })), _path143$s || (_path143$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(180 28 20)"
    })), _path144$s || (_path144$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(180 28 16)"
    })), _path145$s || (_path145$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(180 28 12)"
    })), _path146$s || (_path146$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(180 28 8)"
    })), _path147$s || (_path147$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(180 28 4)"
    })), _path148$s || (_path148$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(180 24 4)"
    })), _path149$s || (_path149$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(180 20 4)"
    })), _path150$s || (_path150$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(180 16 4)"
    })), _path151$s || (_path151$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(180 8 4)"
    })), _path152$s || (_path152$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(180 12 4)"
    })), _path153$s || (_path153$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(180 4 24)"
    })), _path154$s || (_path154$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(180 4 20)"
    })), _path155$s || (_path155$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(180 4 16)"
    })), _path156$s || (_path156$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(180 4 12)"
    })), _path157$s || (_path157$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(180 4 8)"
    })), _path158$s || (_path158$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(180 4 4)"
    })), _path159$s || (_path159$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderBottom24 = /*#__PURE__*/React__default['default'].forwardRef(function BorderBottom24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$s || (_path160$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H29V29H3z",
      transform: "rotate(180 16 28)"
    })), _path161$s || (_path161$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(180 28 24)"
    })), _path162$s || (_path162$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(180 28 20)"
    })), _path163$s || (_path163$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(180 28 16)"
    })), _path164$s || (_path164$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(180 28 12)"
    })), _path165$s || (_path165$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(180 28 8)"
    })), _path166$s || (_path166$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(180 28 4)"
    })), _path167$s || (_path167$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(180 24 4)"
    })), _path168$s || (_path168$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(180 20 4)"
    })), _path169$s || (_path169$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(180 16 4)"
    })), _path170$s || (_path170$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(180 8 4)"
    })), _path171$s || (_path171$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(180 12 4)"
    })), _path172$s || (_path172$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(180 4 24)"
    })), _path173$s || (_path173$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(180 4 20)"
    })), _path174$s || (_path174$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(180 4 16)"
    })), _path175$s || (_path175$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(180 4 12)"
    })), _path176$s || (_path176$s = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(180 4 8)"
    })), _path177$r || (_path177$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(180 4 4)"
    })), _path178$r || (_path178$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderBottom20 = /*#__PURE__*/React__default['default'].forwardRef(function BorderBottom20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$r || (_path179$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H29V29H3z",
      transform: "rotate(180 16 28)"
    })), _path180$r || (_path180$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(180 28 24)"
    })), _path181$r || (_path181$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(180 28 20)"
    })), _path182$r || (_path182$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(180 28 16)"
    })), _path183$r || (_path183$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(180 28 12)"
    })), _path184$r || (_path184$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(180 28 8)"
    })), _path185$r || (_path185$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(180 28 4)"
    })), _path186$r || (_path186$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(180 24 4)"
    })), _path187$r || (_path187$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(180 20 4)"
    })), _path188$r || (_path188$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(180 16 4)"
    })), _path189$r || (_path189$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(180 8 4)"
    })), _path190$r || (_path190$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(180 12 4)"
    })), _path191$r || (_path191$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(180 4 24)"
    })), _path192$r || (_path192$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(180 4 20)"
    })), _path193$r || (_path193$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(180 4 16)"
    })), _path194$r || (_path194$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(180 4 12)"
    })), _path195$r || (_path195$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(180 4 8)"
    })), _path196$r || (_path196$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(180 4 4)"
    })), _path197$r || (_path197$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderBottom16 = /*#__PURE__*/React__default['default'].forwardRef(function BorderBottom16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$r || (_path198$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H29V29H3z",
      transform: "rotate(180 16 28)"
    })), _path199$r || (_path199$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(180 28 24)"
    })), _path200$r || (_path200$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(180 28 20)"
    })), _path201$r || (_path201$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(180 28 16)"
    })), _path202$r || (_path202$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(180 28 12)"
    })), _path203$r || (_path203$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(180 28 8)"
    })), _path204$r || (_path204$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(180 28 4)"
    })), _path205$r || (_path205$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(180 24 4)"
    })), _path206$r || (_path206$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(180 20 4)"
    })), _path207$r || (_path207$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(180 16 4)"
    })), _path208$r || (_path208$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(180 8 4)"
    })), _path209$r || (_path209$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(180 12 4)"
    })), _path210$r || (_path210$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(180 4 24)"
    })), _path211$r || (_path211$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(180 4 20)"
    })), _path212$r || (_path212$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(180 4 16)"
    })), _path213$r || (_path213$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(180 4 12)"
    })), _path214$r || (_path214$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(180 4 8)"
    })), _path215$r || (_path215$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(180 4 4)"
    })), _path216$r || (_path216$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderFull32 = /*#__PURE__*/React__default['default'].forwardRef(function BorderFull32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$r || (_path217$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), _path218$r || (_path218$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,29H3V3H29ZM5,27H27V5H5Z"
    })), children);
  });
  var BorderFull24 = /*#__PURE__*/React__default['default'].forwardRef(function BorderFull24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$r || (_path219$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), _path220$r || (_path220$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,29H3V3H29ZM5,27H27V5H5Z"
    })), children);
  });
  var BorderFull20 = /*#__PURE__*/React__default['default'].forwardRef(function BorderFull20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$r || (_path221$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), _path222$r || (_path222$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,29H3V3H29ZM5,27H27V5H5Z"
    })), children);
  });
  var BorderFull16 = /*#__PURE__*/React__default['default'].forwardRef(function BorderFull16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$r || (_path223$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), _path224$r || (_path224$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,29H3V3H29ZM5,27H27V5H5Z"
    })), children);
  });
  var BorderLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function BorderLeft32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$r || (_path225$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M-9 15H17V17H-9z",
      transform: "rotate(-90 4 16)"
    })), _path226$r || (_path226$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(-90 8 28)"
    })), _path227$r || (_path227$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(-90 12 28)"
    })), _path228$r || (_path228$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(-90 16 28)"
    })), _path229$r || (_path229$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(-90 20 28)"
    })), _path230$r || (_path230$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(-90 24 28)"
    })), _path231$r || (_path231$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 27H29V29H27z",
      transform: "rotate(-90 28 28)"
    })), _path232$r || (_path232$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(-90 28 24)"
    })), _path233$r || (_path233$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(-90 28 20)"
    })), _path234$r || (_path234$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(-90 28 16)"
    })), _path235$r || (_path235$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(-90 28 8)"
    })), _path236$r || (_path236$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(-90 28 12)"
    })), _path237$r || (_path237$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(-90 8 4)"
    })), _path238$r || (_path238$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(-90 12 4)"
    })), _path239$r || (_path239$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(-90 16 4)"
    })), _path240$r || (_path240$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(-90 20 4)"
    })), _path241$r || (_path241$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(-90 24 4)"
    })), _path242$r || (_path242$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(-90 28 4)"
    })), _path243$r || (_path243$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function BorderLeft24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$r || (_path244$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M-9 15H17V17H-9z",
      transform: "rotate(-90 4 16)"
    })), _path245$r || (_path245$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(-90 8 28)"
    })), _path246$r || (_path246$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(-90 12 28)"
    })), _path247$r || (_path247$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(-90 16 28)"
    })), _path248$r || (_path248$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(-90 20 28)"
    })), _path249$r || (_path249$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(-90 24 28)"
    })), _path250$r || (_path250$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 27H29V29H27z",
      transform: "rotate(-90 28 28)"
    })), _path251$r || (_path251$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(-90 28 24)"
    })), _path252$r || (_path252$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(-90 28 20)"
    })), _path253$r || (_path253$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(-90 28 16)"
    })), _path254$r || (_path254$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(-90 28 8)"
    })), _path255$r || (_path255$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(-90 28 12)"
    })), _path256$r || (_path256$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(-90 8 4)"
    })), _path257$r || (_path257$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(-90 12 4)"
    })), _path258$r || (_path258$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(-90 16 4)"
    })), _path259$r || (_path259$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(-90 20 4)"
    })), _path260$r || (_path260$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(-90 24 4)"
    })), _path261$r || (_path261$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(-90 28 4)"
    })), _path262$r || (_path262$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function BorderLeft20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$r || (_path263$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M-9 15H17V17H-9z",
      transform: "rotate(-90 4 16)"
    })), _path264$r || (_path264$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(-90 8 28)"
    })), _path265$r || (_path265$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(-90 12 28)"
    })), _path266$r || (_path266$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(-90 16 28)"
    })), _path267$r || (_path267$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(-90 20 28)"
    })), _path268$r || (_path268$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(-90 24 28)"
    })), _path269$r || (_path269$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 27H29V29H27z",
      transform: "rotate(-90 28 28)"
    })), _path270$r || (_path270$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(-90 28 24)"
    })), _path271$r || (_path271$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(-90 28 20)"
    })), _path272$r || (_path272$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(-90 28 16)"
    })), _path273$r || (_path273$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(-90 28 8)"
    })), _path274$r || (_path274$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(-90 28 12)"
    })), _path275$r || (_path275$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(-90 8 4)"
    })), _path276$r || (_path276$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(-90 12 4)"
    })), _path277$r || (_path277$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(-90 16 4)"
    })), _path278$r || (_path278$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(-90 20 4)"
    })), _path279$r || (_path279$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(-90 24 4)"
    })), _path280$r || (_path280$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(-90 28 4)"
    })), _path281$r || (_path281$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function BorderLeft16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$r || (_path282$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M-9 15H17V17H-9z",
      transform: "rotate(-90 4 16)"
    })), _path283$r || (_path283$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(-90 8 28)"
    })), _path284$r || (_path284$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(-90 12 28)"
    })), _path285$r || (_path285$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(-90 16 28)"
    })), _path286$r || (_path286$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(-90 20 28)"
    })), _path287$r || (_path287$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(-90 24 28)"
    })), _path288$r || (_path288$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 27H29V29H27z",
      transform: "rotate(-90 28 28)"
    })), _path289$r || (_path289$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 23H29V25H27z",
      transform: "rotate(-90 28 24)"
    })), _path290$r || (_path290$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 19H29V21H27z",
      transform: "rotate(-90 28 20)"
    })), _path291$r || (_path291$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H29V17H27z",
      transform: "rotate(-90 28 16)"
    })), _path292$r || (_path292$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 7H29V9H27z",
      transform: "rotate(-90 28 8)"
    })), _path293$r || (_path293$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27z",
      transform: "rotate(-90 28 12)"
    })), _path294$r || (_path294$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(-90 8 4)"
    })), _path295$r || (_path295$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(-90 12 4)"
    })), _path296$r || (_path296$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(-90 16 4)"
    })), _path297$r || (_path297$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(-90 20 4)"
    })), _path298$r || (_path298$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(-90 24 4)"
    })), _path299$r || (_path299$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 3H29V5H27z",
      transform: "rotate(-90 28 4)"
    })), _path300$r || (_path300$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderNone32 = /*#__PURE__*/React__default['default'].forwardRef(function BorderNone32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$r || (_path301$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3zM7 3H9V5H7zM11 3H13V5H11zM15 3H17V5H15zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderNone24 = /*#__PURE__*/React__default['default'].forwardRef(function BorderNone24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$r || (_path302$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3zM7 3H9V5H7zM11 3H13V5H11zM15 3H17V5H15zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderNone20 = /*#__PURE__*/React__default['default'].forwardRef(function BorderNone20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$r || (_path303$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3zM7 3H9V5H7zM11 3H13V5H11zM15 3H17V5H15zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderNone16 = /*#__PURE__*/React__default['default'].forwardRef(function BorderNone16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$r || (_path304$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3zM7 3H9V5H7zM11 3H13V5H11zM15 3H17V5H15zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderRight32 = /*#__PURE__*/React__default['default'].forwardRef(function BorderRight32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$r || (_path305$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H41V17H15z",
      transform: "rotate(90 28 16)"
    })), _path306$r || (_path306$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(90 24 4)"
    })), _path307$r || (_path307$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(90 20 4)"
    })), _path308$r || (_path308$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(90 16 4)"
    })), _path309$r || (_path309$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(90 12 4)"
    })), _path310$r || (_path310$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(90 8 4)"
    })), _path311$r || (_path311$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(90 4 4)"
    })), _path312$r || (_path312$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(90 4 8)"
    })), _path313$r || (_path313$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(90 4 12)"
    })), _path314$r || (_path314$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(90 4 16)"
    })), _path315$r || (_path315$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(90 4 24)"
    })), _path316$r || (_path316$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(90 4 20)"
    })), _path317$r || (_path317$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(90 24 28)"
    })), _path318$r || (_path318$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(90 20 28)"
    })), _path319$r || (_path319$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(90 16 28)"
    })), _path320$r || (_path320$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(90 12 28)"
    })), _path321$r || (_path321$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(90 8 28)"
    })), _path322$r || (_path322$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H5V29H3z",
      transform: "rotate(90 4 28)"
    })), _path323$r || (_path323$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderRight24 = /*#__PURE__*/React__default['default'].forwardRef(function BorderRight24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$s);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$r || (_path324$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H41V17H15z",
      transform: "rotate(90 28 16)"
    })), _path325$r || (_path325$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(90 24 4)"
    })), _path326$r || (_path326$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(90 20 4)"
    })), _path327$r || (_path327$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(90 16 4)"
    })), _path328$r || (_path328$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(90 12 4)"
    })), _path329$r || (_path329$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(90 8 4)"
    })), _path330$r || (_path330$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(90 4 4)"
    })), _path331$r || (_path331$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(90 4 8)"
    })), _path332$r || (_path332$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(90 4 12)"
    })), _path333$r || (_path333$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(90 4 16)"
    })), _path334$r || (_path334$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(90 4 24)"
    })), _path335$r || (_path335$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(90 4 20)"
    })), _path336$r || (_path336$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(90 24 28)"
    })), _path337$r || (_path337$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(90 20 28)"
    })), _path338$q || (_path338$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(90 16 28)"
    })), _path339$q || (_path339$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(90 12 28)"
    })), _path340$q || (_path340$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(90 8 28)"
    })), _path341$q || (_path341$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H5V29H3z",
      transform: "rotate(90 4 28)"
    })), _path342$q || (_path342$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderRight20 = /*#__PURE__*/React__default['default'].forwardRef(function BorderRight20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$q || (_path343$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H41V17H15z",
      transform: "rotate(90 28 16)"
    })), _path344$q || (_path344$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(90 24 4)"
    })), _path345$q || (_path345$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(90 20 4)"
    })), _path346$q || (_path346$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(90 16 4)"
    })), _path347$q || (_path347$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(90 12 4)"
    })), _path348$q || (_path348$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(90 8 4)"
    })), _path349$q || (_path349$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(90 4 4)"
    })), _path350$q || (_path350$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(90 4 8)"
    })), _path351$q || (_path351$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(90 4 12)"
    })), _path352$q || (_path352$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(90 4 16)"
    })), _path353$q || (_path353$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(90 4 24)"
    })), _path354$q || (_path354$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(90 4 20)"
    })), _path355$p || (_path355$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(90 24 28)"
    })), _path356$p || (_path356$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(90 20 28)"
    })), _path357$p || (_path357$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(90 16 28)"
    })), _path358$p || (_path358$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(90 12 28)"
    })), _path359$p || (_path359$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(90 8 28)"
    })), _path360$p || (_path360$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H5V29H3z",
      transform: "rotate(90 4 28)"
    })), _path361$o || (_path361$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderRight16 = /*#__PURE__*/React__default['default'].forwardRef(function BorderRight16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$o || (_path362$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H41V17H15z",
      transform: "rotate(90 28 16)"
    })), _path363$m || (_path363$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 3H25V5H23z",
      transform: "rotate(90 24 4)"
    })), _path364$m || (_path364$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 3H21V5H19z",
      transform: "rotate(90 20 4)"
    })), _path365$m || (_path365$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 3H17V5H15z",
      transform: "rotate(90 16 4)"
    })), _path366$m || (_path366$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 3H13V5H11z",
      transform: "rotate(90 12 4)"
    })), _path367$m || (_path367$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 3H9V5H7z",
      transform: "rotate(90 8 4)"
    })), _path368$m || (_path368$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H5V5H3z",
      transform: "rotate(90 4 4)"
    })), _path369$m || (_path369$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 7H5V9H3z",
      transform: "rotate(90 4 8)"
    })), _path370$m || (_path370$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11H5V13H3z",
      transform: "rotate(90 4 12)"
    })), _path371$m || (_path371$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 15H5V17H3z",
      transform: "rotate(90 4 16)"
    })), _path372$m || (_path372$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 23H5V25H3z",
      transform: "rotate(90 4 24)"
    })), _path373$m || (_path373$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 19H5V21H3z",
      transform: "rotate(90 4 20)"
    })), _path374$m || (_path374$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27H25V29H23z",
      transform: "rotate(90 24 28)"
    })), _path375$l || (_path375$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 27H21V29H19z",
      transform: "rotate(90 20 28)"
    })), _path376$l || (_path376$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 27H17V29H15z",
      transform: "rotate(90 16 28)"
    })), _path377$l || (_path377$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27H13V29H11z",
      transform: "rotate(90 12 28)"
    })), _path378$l || (_path378$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H9V29H7z",
      transform: "rotate(90 8 28)"
    })), _path379$l || (_path379$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 27H5V29H3z",
      transform: "rotate(90 4 28)"
    })), _path380$l || (_path380$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderTop32 = /*#__PURE__*/React__default['default'].forwardRef(function BorderTop32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$l || (_path381$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H29V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderTop24 = /*#__PURE__*/React__default['default'].forwardRef(function BorderTop24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$l || (_path382$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H29V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderTop20 = /*#__PURE__*/React__default['default'].forwardRef(function BorderTop20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$l || (_path383$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H29V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var BorderTop16 = /*#__PURE__*/React__default['default'].forwardRef(function BorderTop16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$k || (_path384$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H29V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3zM7 27H9V29H7zM11 27H13V29H11zM15 27H17V29H15zM23 27H25V29H23zM19 27H21V29H19zM27 7H29V9H27zM27 11H29V13H27zM27 15H29V17H27zM27 19H29V21H27zM27 23H29V25H27zM27 27H29V29H27zM8 10H18V12H8zM8 15H14V17H8z"
    })), children);
  });
  var Bot32 = /*#__PURE__*/React__default['default'].forwardRef(function Bot32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$k || (_path385$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 10H20V12H18zM12 10H14V12H12z"
    })), _path386$j || (_path386$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H21V18h1a2.0023,2.0023,0,0,0,2-2V12h2V10H24V8a2.0023,2.0023,0,0,0-2-2H20V2H18V6H14V2H12V6H10A2.0023,2.0023,0,0,0,8,8v2H6v2H8v4a2.0023,2.0023,0,0,0,2,2h1v2H6a2.0023,2.0023,0,0,0-2,2v8H6V22H26v8h2V22A2.0023,2.0023,0,0,0,26,20ZM10,8H22v8H10Zm3,10h6v2H13Z"
    })), children);
  });
  var Bot24 = /*#__PURE__*/React__default['default'].forwardRef(function Bot24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$j || (_path387$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 10H20V12H18zM12 10H14V12H12z"
    })), _path388$j || (_path388$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H21V18h1a2.0023,2.0023,0,0,0,2-2V12h2V10H24V8a2.0023,2.0023,0,0,0-2-2H20V2H18V6H14V2H12V6H10A2.0023,2.0023,0,0,0,8,8v2H6v2H8v4a2.0023,2.0023,0,0,0,2,2h1v2H6a2.0023,2.0023,0,0,0-2,2v8H6V22H26v8h2V22A2.0023,2.0023,0,0,0,26,20ZM10,8H22v8H10Zm3,10h6v2H13Z"
    })), children);
  });
  var Bot20 = /*#__PURE__*/React__default['default'].forwardRef(function Bot20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$j || (_path389$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 10H20V12H18zM12 10H14V12H12z"
    })), _path390$j || (_path390$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H21V18h1a2.0023,2.0023,0,0,0,2-2V12h2V10H24V8a2.0023,2.0023,0,0,0-2-2H20V2H18V6H14V2H12V6H10A2.0023,2.0023,0,0,0,8,8v2H6v2H8v4a2.0023,2.0023,0,0,0,2,2h1v2H6a2.0023,2.0023,0,0,0-2,2v8H6V22H26v8h2V22A2.0023,2.0023,0,0,0,26,20ZM10,8H22v8H10Zm3,10h6v2H13Z"
    })), children);
  });
  var Bot16 = /*#__PURE__*/React__default['default'].forwardRef(function Bot16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$j || (_path391$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 10H20V12H18zM12 10H14V12H12z"
    })), _path392$j || (_path392$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H21V18h1a2.0023,2.0023,0,0,0,2-2V12h2V10H24V8a2.0023,2.0023,0,0,0-2-2H20V2H18V6H14V2H12V6H10A2.0023,2.0023,0,0,0,8,8v2H6v2H8v4a2.0023,2.0023,0,0,0,2,2h1v2H6a2.0023,2.0023,0,0,0-2,2v8H6V22H26v8h2V22A2.0023,2.0023,0,0,0,26,20ZM10,8H22v8H10Zm3,10h6v2H13Z"
    })), children);
  });
  var Box32 = /*#__PURE__*/React__default['default'].forwardRef(function Box32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$j || (_path393$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"
    })), _path394$j || (_path394$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"
    })), children);
  });
  var Box24 = /*#__PURE__*/React__default['default'].forwardRef(function Box24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$j || (_path395$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"
    })), _path396$j || (_path396$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"
    })), children);
  });
  var Box20 = /*#__PURE__*/React__default['default'].forwardRef(function Box20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$j || (_path397$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"
    })), _path398$j || (_path398$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"
    })), children);
  });
  var Box16 = /*#__PURE__*/React__default['default'].forwardRef(function Box16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$i || (_path399$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"
    })), _path400$i || (_path400$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"
    })), children);
  });
  var BoxExtraLarge32 = /*#__PURE__*/React__default['default'].forwardRef(function BoxExtraLarge32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$i || (_path401$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path402$i || (_path402$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21L19 9 17 9 17 23 24 23 24 21 19 21zM16 9L14 9 12 15 10 9 8 9 10.752 16 8 23 10 23 12 17 14 23 16 23 13.245 16 16 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxExtraLarge24 = /*#__PURE__*/React__default['default'].forwardRef(function BoxExtraLarge24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$h || (_path403$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path404$h || (_path404$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21L19 9 17 9 17 23 24 23 24 21 19 21zM16 9L14 9 12 15 10 9 8 9 10.752 16 8 23 10 23 12 17 14 23 16 23 13.245 16 16 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxExtraLarge20 = /*#__PURE__*/React__default['default'].forwardRef(function BoxExtraLarge20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$g || (_path405$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path406$f || (_path406$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21L19 9 17 9 17 23 24 23 24 21 19 21zM16 9L14 9 12 15 10 9 8 9 10.752 16 8 23 10 23 12 17 14 23 16 23 13.245 16 16 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxExtraLarge16 = /*#__PURE__*/React__default['default'].forwardRef(function BoxExtraLarge16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$e || (_path407$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path408$d || (_path408$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21L19 9 17 9 17 23 24 23 24 21 19 21zM16 9L14 9 12 15 10 9 8 9 10.752 16 8 23 10 23 12 17 14 23 16 23 13.245 16 16 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxLarge32 = /*#__PURE__*/React__default['default'].forwardRef(function BoxLarge32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$d || (_path409$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path410$c || (_path410$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21L14 9 12 9 12 23 20 23 20 21 14 21zM4 4H28V6H4z"
    })), children);
  });
  var BoxLarge24 = /*#__PURE__*/React__default['default'].forwardRef(function BoxLarge24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$c || (_path411$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path412$c || (_path412$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21L14 9 12 9 12 23 20 23 20 21 14 21zM4 4H28V6H4z"
    })), children);
  });
  var BoxLarge20 = /*#__PURE__*/React__default['default'].forwardRef(function BoxLarge20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$c || (_path413$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path414$c || (_path414$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21L14 9 12 9 12 23 20 23 20 21 14 21zM4 4H28V6H4z"
    })), children);
  });
  var BoxLarge16 = /*#__PURE__*/React__default['default'].forwardRef(function BoxLarge16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$b || (_path415$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path416$9 || (_path416$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21L14 9 12 9 12 23 20 23 20 21 14 21zM4 4H28V6H4z"
    })), children);
  });
  var BoxMedium32 = /*#__PURE__*/React__default['default'].forwardRef(function BoxMedium32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$9 || (_path417$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path418$8 || (_path418$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L16.485 14 16 15.977 15.535 14 14 9 12 9 12 23 14 23 14 15 13.842 13.004 14.421 15 16 19.626 17.579 15 18.159 13 18 15 18 23 20 23 20 9 18 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxMedium24 = /*#__PURE__*/React__default['default'].forwardRef(function BoxMedium24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path419$7 || (_path419$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path420$7 || (_path420$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L16.485 14 16 15.977 15.535 14 14 9 12 9 12 23 14 23 14 15 13.842 13.004 14.421 15 16 19.626 17.579 15 18.159 13 18 15 18 23 20 23 20 9 18 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxMedium20 = /*#__PURE__*/React__default['default'].forwardRef(function BoxMedium20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$7 || (_path421$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path422$7 || (_path422$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L16.485 14 16 15.977 15.535 14 14 9 12 9 12 23 14 23 14 15 13.842 13.004 14.421 15 16 19.626 17.579 15 18.159 13 18 15 18 23 20 23 20 9 18 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxMedium16 = /*#__PURE__*/React__default['default'].forwardRef(function BoxMedium16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path423$6 || (_path423$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path424$6 || (_path424$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L16.485 14 16 15.977 15.535 14 14 9 12 9 12 23 14 23 14 15 13.842 13.004 14.421 15 16 19.626 17.579 15 18.159 13 18 15 18 23 20 23 20 9 18 9zM4 4H28V6H4z"
    })), children);
  });
  var BoxSmall32 = /*#__PURE__*/React__default['default'].forwardRef(function BoxSmall32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path425$5 || (_path425$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path426$5 || (_path426$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0118 23zM4 4H28V6H4z"
    })), children);
  });
  var BoxSmall24 = /*#__PURE__*/React__default['default'].forwardRef(function BoxSmall24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path427$4 || (_path427$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path428$4 || (_path428$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0118 23zM4 4H28V6H4z"
    })), children);
  });
  var BoxSmall20 = /*#__PURE__*/React__default['default'].forwardRef(function BoxSmall20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path429$4 || (_path429$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path430$4 || (_path430$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0118 23zM4 4H28V6H4z"
    })), children);
  });
  var BoxSmall16 = /*#__PURE__*/React__default['default'].forwardRef(function BoxSmall16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path431$4 || (_path431$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0021,2.0021,0,0,1-2-2V9H6V26H26V9h2V26A2.0021,2.0021,0,0,1,26,28Z"
    })), _path432$4 || (_path432$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0118 23zM4 4H28V6H4z"
    })), children);
  });
  var BoxPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function BoxPlot32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path433$4 || (_path433$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,6V4H12V6h4V8H12V20h4v2H12v2H22V22H18V20h4V8H18V6ZM14,18V15h6v3Zm6-5H14V10h6Z"
    })), _path434$4 || (_path434$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var BoxPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function BoxPlot24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path435$4 || (_path435$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,6V4H12V6h4V8H12V20h4v2H12v2H22V22H18V20h4V8H18V6ZM14,18V15h6v3Zm6-5H14V10h6Z"
    })), _path436$4 || (_path436$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var BoxPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function BoxPlot20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path437$4 || (_path437$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,6V4H12V6h4V8H12V20h4v2H12v2H22V22H18V20h4V8H18V6ZM14,18V15h6v3Zm6-5H14V10h6Z"
    })), _path438$4 || (_path438$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var BoxPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function BoxPlot16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path439$3 || (_path439$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,6V4H12V6h4V8H12V20h4v2H12v2H22V22H18V20h4V8H18V6ZM14,18V15h6v3Zm6-5H14V10h6Z"
    })), _path440$3 || (_path440$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var Branch32 = /*#__PURE__*/React__default['default'].forwardRef(function Branch32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path441$3 || (_path441$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"
    })), children);
  });
  var Branch24 = /*#__PURE__*/React__default['default'].forwardRef(function Branch24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path442$3 || (_path442$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"
    })), children);
  });
  var Branch20 = /*#__PURE__*/React__default['default'].forwardRef(function Branch20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path443$3 || (_path443$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"
    })), children);
  });
  var Branch16 = /*#__PURE__*/React__default['default'].forwardRef(function Branch16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path444$3 || (_path444$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"
    })), children);
  });
  var BreakingChange32 = /*#__PURE__*/React__default['default'].forwardRef(function BreakingChange32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path445$3 || (_path445$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 25a6 6 0 10-6 6A6.0066 6.0066 0 0031 25zm-2 0a3.9521 3.9521 0 01-.5669 2.019L22.981 21.5669A3.9529 3.9529 0 0125 21 4.0045 4.0045 0 0129 25zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0125 29 4.0045 4.0045 0 0121 25zM19.59 16L17 18.59 18.42 20 22.42 16 18.42 12 17 13.41 19.59 16zM10.41 16L13 13.41 11.58 12 7.58 16 11.58 20 13 18.59 10.41 16z"
    })), _path446$3 || (_path446$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,9H26v7h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H16V24H4ZM4,4H26V7H4Z"
    })), children);
  });
  var BreakingChange24 = /*#__PURE__*/React__default['default'].forwardRef(function BreakingChange24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path447$3 || (_path447$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 25a6 6 0 10-6 6A6.0066 6.0066 0 0031 25zm-2 0a3.9521 3.9521 0 01-.5669 2.019L22.981 21.5669A3.9529 3.9529 0 0125 21 4.0045 4.0045 0 0129 25zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0125 29 4.0045 4.0045 0 0121 25zM19.59 16L17 18.59 18.42 20 22.42 16 18.42 12 17 13.41 19.59 16zM10.41 16L13 13.41 11.58 12 7.58 16 11.58 20 13 18.59 10.41 16z"
    })), _path448$3 || (_path448$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,9H26v7h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H16V24H4ZM4,4H26V7H4Z"
    })), children);
  });
  var BreakingChange20 = /*#__PURE__*/React__default['default'].forwardRef(function BreakingChange20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path449$3 || (_path449$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 25a6 6 0 10-6 6A6.0066 6.0066 0 0031 25zm-2 0a3.9521 3.9521 0 01-.5669 2.019L22.981 21.5669A3.9529 3.9529 0 0125 21 4.0045 4.0045 0 0129 25zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0125 29 4.0045 4.0045 0 0121 25zM19.59 16L17 18.59 18.42 20 22.42 16 18.42 12 17 13.41 19.59 16zM10.41 16L13 13.41 11.58 12 7.58 16 11.58 20 13 18.59 10.41 16z"
    })), _path450$3 || (_path450$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,9H26v7h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H16V24H4ZM4,4H26V7H4Z"
    })), children);
  });
  var BreakingChange16 = /*#__PURE__*/React__default['default'].forwardRef(function BreakingChange16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path451$3 || (_path451$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 25a6 6 0 10-6 6A6.0066 6.0066 0 0031 25zm-2 0a3.9521 3.9521 0 01-.5669 2.019L22.981 21.5669A3.9529 3.9529 0 0125 21 4.0045 4.0045 0 0129 25zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0125 29 4.0045 4.0045 0 0121 25zM19.59 16L17 18.59 18.42 20 22.42 16 18.42 12 17 13.41 19.59 16zM10.41 16L13 13.41 11.58 12 7.58 16 11.58 20 13 18.59 10.41 16z"
    })), _path452$3 || (_path452$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,9H26v7h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H16V24H4ZM4,4H26V7H4Z"
    })), children);
  });
  var BrightnessContrast32 = /*#__PURE__*/React__default['default'].forwardRef(function BrightnessContrast32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path453$3 || (_path453$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path454$3 || (_path454$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.22 5.73H8.219999999999999V8.73H6.22z",
      transform: "rotate(-45 7.227 7.236)"
    })), _path455$2 || (_path455$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.27 6.23H26.27V8.23H23.27z",
      transform: "rotate(-45 24.766 7.232)"
    })), _path456$2 || (_path456$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.77 23.27H25.77V26.27H23.77z",
      transform: "rotate(-45 24.77 24.77)"
    })), _path457$2 || (_path457$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 108 8A8 8 0 0016 8zm0 14a6 6 0 010-12z"
    })), children);
  });
  var BrightnessContrast24 = /*#__PURE__*/React__default['default'].forwardRef(function BrightnessContrast24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path458$2 || (_path458$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path459$2 || (_path459$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.22 5.73H8.219999999999999V8.73H6.22z",
      transform: "rotate(-45 7.227 7.236)"
    })), _path460$2 || (_path460$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.27 6.23H26.27V8.23H23.27z",
      transform: "rotate(-45 24.766 7.232)"
    })), _path461$2 || (_path461$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.77 23.27H25.77V26.27H23.77z",
      transform: "rotate(-45 24.77 24.77)"
    })), _path462$2 || (_path462$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 108 8A8 8 0 0016 8zm0 14a6 6 0 010-12z"
    })), children);
  });
  var BrightnessContrast20 = /*#__PURE__*/React__default['default'].forwardRef(function BrightnessContrast20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path463$2 || (_path463$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path464$2 || (_path464$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.22 5.73H8.219999999999999V8.73H6.22z",
      transform: "rotate(-45 7.227 7.236)"
    })), _path465$2 || (_path465$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.27 6.23H26.27V8.23H23.27z",
      transform: "rotate(-45 24.766 7.232)"
    })), _path466$2 || (_path466$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.77 23.27H25.77V26.27H23.77z",
      transform: "rotate(-45 24.77 24.77)"
    })), _path467$2 || (_path467$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 108 8A8 8 0 0016 8zm0 14a6 6 0 010-12z"
    })), children);
  });
  var BrightnessContrast16 = /*#__PURE__*/React__default['default'].forwardRef(function BrightnessContrast16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path468$2 || (_path468$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path469$2 || (_path469$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.22 5.73H8.219999999999999V8.73H6.22z",
      transform: "rotate(-45 7.227 7.236)"
    })), _path470$2 || (_path470$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.27 6.23H26.27V8.23H23.27z",
      transform: "rotate(-45 24.766 7.232)"
    })), _path471$2 || (_path471$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.77 23.27H25.77V26.27H23.77z",
      transform: "rotate(-45 24.77 24.77)"
    })), _path472$2 || (_path472$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 108 8A8 8 0 0016 8zm0 14a6 6 0 010-12z"
    })), children);
  });
  var BringForward32 = /*#__PURE__*/React__default['default'].forwardRef(function BringForward32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path473$2 || (_path473$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H10V12a2.0023 2.0023 0 012-2h3v2H12zM15 30H12a2.0023 2.0023 0 01-2-2V25h2v3h3zM18 28H22V30H18zM28 30H25V28h3V25h2v3A2.0023 2.0023 0 0128 30zM10 18H12V22H10zM28 18H30V22H28zM30 15H28V12H25V10h3a2.0023 2.0023 0 012 2zM18 10H22V12H18z"
    })), _path474$2 || (_path474$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,22H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H20a2.0023,2.0023,0,0,1,2,2V8H20V4H4V20H8Z"
    })), children);
  });
  var BringForward24 = /*#__PURE__*/React__default['default'].forwardRef(function BringForward24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path475$2 || (_path475$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H10V12a2.0023 2.0023 0 012-2h3v2H12zM15 30H12a2.0023 2.0023 0 01-2-2V25h2v3h3zM18 28H22V30H18zM28 30H25V28h3V25h2v3A2.0023 2.0023 0 0128 30zM10 18H12V22H10zM28 18H30V22H28zM30 15H28V12H25V10h3a2.0023 2.0023 0 012 2zM18 10H22V12H18z"
    })), _path476$2 || (_path476$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,22H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H20a2.0023,2.0023,0,0,1,2,2V8H20V4H4V20H8Z"
    })), children);
  });
  var BringForward20 = /*#__PURE__*/React__default['default'].forwardRef(function BringForward20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path477$2 || (_path477$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H10V12a2.0023 2.0023 0 012-2h3v2H12zM15 30H12a2.0023 2.0023 0 01-2-2V25h2v3h3zM18 28H22V30H18zM28 30H25V28h3V25h2v3A2.0023 2.0023 0 0128 30zM10 18H12V22H10zM28 18H30V22H28zM30 15H28V12H25V10h3a2.0023 2.0023 0 012 2zM18 10H22V12H18z"
    })), _path478$2 || (_path478$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,22H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H20a2.0023,2.0023,0,0,1,2,2V8H20V4H4V20H8Z"
    })), children);
  });
  var BringForward16 = /*#__PURE__*/React__default['default'].forwardRef(function BringForward16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path479$2 || (_path479$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H10V12a2.0023 2.0023 0 012-2h3v2H12zM15 30H12a2.0023 2.0023 0 01-2-2V25h2v3h3zM18 28H22V30H18zM28 30H25V28h3V25h2v3A2.0023 2.0023 0 0128 30zM10 18H12V22H10zM28 18H30V22H28zM30 15H28V12H25V10h3a2.0023 2.0023 0 012 2zM18 10H22V12H18z"
    })), _path480$2 || (_path480$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,22H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H20a2.0023,2.0023,0,0,1,2,2V8H20V4H4V20H8Z"
    })), children);
  });
  var BringToFront32 = /*#__PURE__*/React__default['default'].forwardRef(function BringToFront32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path481$2 || (_path481$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V20a2.0023,2.0023,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,20,3.9985,4H20v6H12a2,2,0,0,0-2,2v8Z"
    })), children);
  });
  var BringToFront24 = /*#__PURE__*/React__default['default'].forwardRef(function BringToFront24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path482$2 || (_path482$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V20a2.0023,2.0023,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,20,3.9985,4H20v6H12a2,2,0,0,0-2,2v8Z"
    })), children);
  });
  var BringToFront20 = /*#__PURE__*/React__default['default'].forwardRef(function BringToFront20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path483$2 || (_path483$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V20a2.0023,2.0023,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,20,3.9985,4H20v6H12a2,2,0,0,0-2,2v8Z"
    })), children);
  });
  var BringToFront16 = /*#__PURE__*/React__default['default'].forwardRef(function BringToFront16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path484$2 || (_path484$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V20a2.0023,2.0023,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,20,3.9985,4H20v6H12a2,2,0,0,0-2,2v8Z"
    })), children);
  });
  var WatsonHealthBrushFreehand32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushFreehand32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path485$2 || (_path485$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM6.5 15A3.4994 3.4994 0 014.0249 9.026l3.5005-3.5a1.5019 1.5019 0 000-2.121 1.537 1.537 0 00-2.1216 0L3.415 5.3936 2 3.98 3.99 1.9915a3.5849 3.5849 0 014.95 0 3.5039 3.5039 0 010 4.949L5.439 10.44a1.5019 1.5019 0 000 2.121 1.5369 1.5369 0 002.1215 0l4.0249-4.0243L13 9.9507 8.9746 13.975A3.4754 3.4754 0 016.5 15z"
    })), children);
  });
  var WatsonHealthBrushFreehand24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushFreehand24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path486$2 || (_path486$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM6.5 15A3.4994 3.4994 0 014.0249 9.026l3.5005-3.5a1.5019 1.5019 0 000-2.121 1.537 1.537 0 00-2.1216 0L3.415 5.3936 2 3.98 3.99 1.9915a3.5849 3.5849 0 014.95 0 3.5039 3.5039 0 010 4.949L5.439 10.44a1.5019 1.5019 0 000 2.121 1.5369 1.5369 0 002.1215 0l4.0249-4.0243L13 9.9507 8.9746 13.975A3.4754 3.4754 0 016.5 15z"
    })), children);
  });
  var WatsonHealthBrushFreehand20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushFreehand20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path487$2 || (_path487$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM6.5 15A3.4994 3.4994 0 014.0249 9.026l3.5005-3.5a1.5019 1.5019 0 000-2.121 1.537 1.537 0 00-2.1216 0L3.415 5.3936 2 3.98 3.99 1.9915a3.5849 3.5849 0 014.95 0 3.5039 3.5039 0 010 4.949L5.439 10.44a1.5019 1.5019 0 000 2.121 1.5369 1.5369 0 002.1215 0l4.0249-4.0243L13 9.9507 8.9746 13.975A3.4754 3.4754 0 016.5 15z"
    })), children);
  });
  var WatsonHealthBrushFreehand16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushFreehand16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path488$2 || (_path488$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM6.5 15A3.4994 3.4994 0 014.0249 9.026l3.5005-3.5a1.5019 1.5019 0 000-2.121 1.537 1.537 0 00-2.1216 0L3.415 5.3936 2 3.98 3.99 1.9915a3.5849 3.5849 0 014.95 0 3.5039 3.5039 0 010 4.949L5.439 10.44a1.5019 1.5019 0 000 2.121 1.5369 1.5369 0 002.1215 0l4.0249-4.0243L13 9.9507 8.9746 13.975A3.4754 3.4754 0 016.5 15z"
    })), children);
  });
  var WatsonHealthBrushPolygon32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushPolygon32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path489$2 || (_path489$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM14 2a2.9948 2.9948 0 00-2.8157 2H7.8157A2.9925 2.9925 0 104 7.8154v3.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8157 6h3.3686A2.9947 2.9947 0 1014 2zM5 15a1 1 0 111-1A1.0008 1.0008 0 015 15zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zm9 0a1 1 0 111-1A1.0008 1.0008 0 0114 6z"
    })), children);
  });
  var WatsonHealthBrushPolygon24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushPolygon24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path490$2 || (_path490$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM14 2a2.9948 2.9948 0 00-2.8157 2H7.8157A2.9925 2.9925 0 104 7.8154v3.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8157 6h3.3686A2.9947 2.9947 0 1014 2zM5 15a1 1 0 111-1A1.0008 1.0008 0 015 15zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zm9 0a1 1 0 111-1A1.0008 1.0008 0 0114 6z"
    })), children);
  });
  var WatsonHealthBrushPolygon20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushPolygon20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path491$2 || (_path491$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM14 2a2.9948 2.9948 0 00-2.8157 2H7.8157A2.9925 2.9925 0 104 7.8154v3.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8157 6h3.3686A2.9947 2.9947 0 1014 2zM5 15a1 1 0 111-1A1.0008 1.0008 0 015 15zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zm9 0a1 1 0 111-1A1.0008 1.0008 0 0114 6z"
    })), children);
  });
  var WatsonHealthBrushPolygon16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthBrushPolygon16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path492$2 || (_path492$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 3.1719a4.0941 4.0941 0 00-5.6562 0L4.05 22.292A6.9537 6.9537 0 002 27.2412V30H4.7559a6.9523 6.9523 0 004.95-2.05L28.8281 8.8286a3.999 3.999 0 000-5.6567zM10.91 18.26l2.8286 2.8286L11.6172 23.21 8.7886 20.3818zM8.2915 26.5356A4.9665 4.9665 0 014.7559 28H4v-.7588a4.9669 4.9669 0 011.4644-3.5351l1.91-1.91 2.8286 2.8281zM27.4141 7.4141L15.1528 19.6748l-2.8286-2.8286 12.2617-12.26a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM14 2a2.9948 2.9948 0 00-2.8157 2H7.8157A2.9925 2.9925 0 104 7.8154v3.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8157 6h3.3686A2.9947 2.9947 0 1014 2zM5 15a1 1 0 111-1A1.0008 1.0008 0 015 15zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zm9 0a1 1 0 111-1A1.0008 1.0008 0 0114 6z"
    })), children);
  });
  var Building32 = /*#__PURE__*/React__default['default'].forwardRef(function Building32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path493$2 || (_path493$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path494$2 || (_path494$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"
    })), children);
  });
  var Building24 = /*#__PURE__*/React__default['default'].forwardRef(function Building24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path495$2 || (_path495$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path496$2 || (_path496$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"
    })), children);
  });
  var Building20 = /*#__PURE__*/React__default['default'].forwardRef(function Building20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path497$2 || (_path497$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path498$2 || (_path498$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"
    })), children);
  });
  var Building16 = /*#__PURE__*/React__default['default'].forwardRef(function Building16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path499$2 || (_path499$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path500$2 || (_path500$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"
    })), children);
  });
  var BuildingInsights_132 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_132(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path501$2 || (_path501$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path502$2 || (_path502$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 015-5V9A3.0033 3.0033 0 009 12zM4 12H2A10.0114 10.0114 0 0112 2V4A8.0092 8.0092 0 004 12z"
    })), children);
  });
  var BuildingInsights_124 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_124(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path503$2 || (_path503$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path504$2 || (_path504$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 015-5V9A3.0033 3.0033 0 009 12zM4 12H2A10.0114 10.0114 0 0112 2V4A8.0092 8.0092 0 004 12z"
    })), children);
  });
  var BuildingInsights_120 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_120(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path505$2 || (_path505$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path506$2 || (_path506$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 015-5V9A3.0033 3.0033 0 009 12zM4 12H2A10.0114 10.0114 0 0112 2V4A8.0092 8.0092 0 004 12z"
    })), children);
  });
  var BuildingInsights_116 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_116(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path507$2 || (_path507$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path508$2 || (_path508$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 015-5V9A3.0033 3.0033 0 009 12zM4 12H2A10.0114 10.0114 0 0112 2V4A8.0092 8.0092 0 004 12z"
    })), children);
  });
  var BuildingInsights_232 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_232(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path509$2 || (_path509$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path510$2 || (_path510$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 010-7h.627A4.0062 4.0062 0 0110 2h2V4L10 4A2.0023 2.0023 0 008 6V7H5.5a1.5 1.5 0 000 3H12v2z"
    })), children);
  });
  var BuildingInsights_224 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_224(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path511$2 || (_path511$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path512$2 || (_path512$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 010-7h.627A4.0062 4.0062 0 0110 2h2V4L10 4A2.0023 2.0023 0 008 6V7H5.5a1.5 1.5 0 000 3H12v2z"
    })), children);
  });
  var BuildingInsights_220 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_220(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path513$2 || (_path513$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path514$2 || (_path514$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 010-7h.627A4.0062 4.0062 0 0110 2h2V4L10 4A2.0023 2.0023 0 008 6V7H5.5a1.5 1.5 0 000 3H12v2z"
    })), children);
  });
  var BuildingInsights_216 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_216(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path515$2 || (_path515$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path516$2 || (_path516$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 010-7h.627A4.0062 4.0062 0 0110 2h2V4L10 4A2.0023 2.0023 0 008 6V7H5.5a1.5 1.5 0 000 3H12v2z"
    })), children);
  });
  var BuildingInsights_332 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_332(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path517$2 || (_path517$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path518$2 || (_path518$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"
    })), _path519$2 || (_path519$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.5 3.964H7.5V9.035H5.5z",
      transform: "rotate(-45 6.5 6.5)"
    })), children);
  });
  var BuildingInsights_324 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_324(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path520$2 || (_path520$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path521$2 || (_path521$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"
    })), _path522$2 || (_path522$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.5 3.964H7.5V9.035H5.5z",
      transform: "rotate(-45 6.5 6.5)"
    })), children);
  });
  var BuildingInsights_320 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_320(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path523$2 || (_path523$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path524$2 || (_path524$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"
    })), _path525$2 || (_path525$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.5 3.964H7.5V9.035H5.5z",
      transform: "rotate(-45 6.5 6.5)"
    })), children);
  });
  var BuildingInsights_316 = /*#__PURE__*/React__default['default'].forwardRef(function BuildingInsights_316(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path526$1 || (_path526$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"
    })), _path527$1 || (_path527$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"
    })), _path528$1 || (_path528$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.5 3.964H7.5V9.035H5.5z",
      transform: "rotate(-45 6.5 6.5)"
    })), children);
  });
  var Bullhorn32 = /*#__PURE__*/React__default['default'].forwardRef(function Bullhorn32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path529$1 || (_path529$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"
    })), children);
  });
  var Bullhorn24 = /*#__PURE__*/React__default['default'].forwardRef(function Bullhorn24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path530$1 || (_path530$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"
    })), children);
  });
  var Bullhorn20 = /*#__PURE__*/React__default['default'].forwardRef(function Bullhorn20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path531$1 || (_path531$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"
    })), children);
  });
  var Bullhorn16 = /*#__PURE__*/React__default['default'].forwardRef(function Bullhorn16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path532$1 || (_path532$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"
    })), children);
  });
  var Buoy32 = /*#__PURE__*/React__default['default'].forwardRef(function Buoy32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path533$1 || (_path533$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,20,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,16,19a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,12,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,8,19a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,4,22H2v2H4a4.9316,4.9316,0,0,0,4-1.9873,5.5965,5.5965,0,0,0,1,.9912,7,7,0,0,0,14,0,5.5965,5.5965,0,0,0,1-.9912A4.9316,4.9316,0,0,0,28,24h2V22ZM16,28a5.0021,5.0021,0,0,1-4.9075-4.0854A5.2252,5.2252,0,0,0,12,24a4.9316,4.9316,0,0,0,4-1.9873A4.9316,4.9316,0,0,0,20,24a5.2252,5.2252,0,0,0,.9075-.0854A5.0021,5.0021,0,0,1,16,28Z"
    })), _path534$1 || (_path534$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.07,7.8345A2.0116,2.0116,0,0,0,18.0771,6H17V2H15V6H13.9175a1.9949,1.9949,0,0,0-1.9859,1.7715L10.2805,19h2.021l.7346-5h5.9212l.7351,5h2.021ZM13.33,12l.5877-4,4.167.0625L18.6633,12Z"
    })), children);
  });
  var Buoy24 = /*#__PURE__*/React__default['default'].forwardRef(function Buoy24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path535$1 || (_path535$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,20,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,16,19a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,12,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,8,19a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,4,22H2v2H4a4.9316,4.9316,0,0,0,4-1.9873,5.5965,5.5965,0,0,0,1,.9912,7,7,0,0,0,14,0,5.5965,5.5965,0,0,0,1-.9912A4.9316,4.9316,0,0,0,28,24h2V22ZM16,28a5.0021,5.0021,0,0,1-4.9075-4.0854A5.2252,5.2252,0,0,0,12,24a4.9316,4.9316,0,0,0,4-1.9873A4.9316,4.9316,0,0,0,20,24a5.2252,5.2252,0,0,0,.9075-.0854A5.0021,5.0021,0,0,1,16,28Z"
    })), _path536$1 || (_path536$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.07,7.8345A2.0116,2.0116,0,0,0,18.0771,6H17V2H15V6H13.9175a1.9949,1.9949,0,0,0-1.9859,1.7715L10.2805,19h2.021l.7346-5h5.9212l.7351,5h2.021ZM13.33,12l.5877-4,4.167.0625L18.6633,12Z"
    })), children);
  });
  var Buoy20 = /*#__PURE__*/React__default['default'].forwardRef(function Buoy20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path537$1 || (_path537$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,20,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,16,19a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,12,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,8,19a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,4,22H2v2H4a4.9316,4.9316,0,0,0,4-1.9873,5.5965,5.5965,0,0,0,1,.9912,7,7,0,0,0,14,0,5.5965,5.5965,0,0,0,1-.9912A4.9316,4.9316,0,0,0,28,24h2V22ZM16,28a5.0021,5.0021,0,0,1-4.9075-4.0854A5.2252,5.2252,0,0,0,12,24a4.9316,4.9316,0,0,0,4-1.9873A4.9316,4.9316,0,0,0,20,24a5.2252,5.2252,0,0,0,.9075-.0854A5.0021,5.0021,0,0,1,16,28Z"
    })), _path538$1 || (_path538$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.07,7.8345A2.0116,2.0116,0,0,0,18.0771,6H17V2H15V6H13.9175a1.9949,1.9949,0,0,0-1.9859,1.7715L10.2805,19h2.021l.7346-5h5.9212l.7351,5h2.021ZM13.33,12l.5877-4,4.167.0625L18.6633,12Z"
    })), children);
  });
  var Buoy16 = /*#__PURE__*/React__default['default'].forwardRef(function Buoy16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path539$1 || (_path539$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,20,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,16,19a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,12,22a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,8,19a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,4,22H2v2H4a4.9316,4.9316,0,0,0,4-1.9873,5.5965,5.5965,0,0,0,1,.9912,7,7,0,0,0,14,0,5.5965,5.5965,0,0,0,1-.9912A4.9316,4.9316,0,0,0,28,24h2V22ZM16,28a5.0021,5.0021,0,0,1-4.9075-4.0854A5.2252,5.2252,0,0,0,12,24a4.9316,4.9316,0,0,0,4-1.9873A4.9316,4.9316,0,0,0,20,24a5.2252,5.2252,0,0,0,.9075-.0854A5.0021,5.0021,0,0,1,16,28Z"
    })), _path540$1 || (_path540$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.07,7.8345A2.0116,2.0116,0,0,0,18.0771,6H17V2H15V6H13.9175a1.9949,1.9949,0,0,0-1.9859,1.7715L10.2805,19h2.021l.7346-5h5.9212l.7351,5h2.021ZM13.33,12l.5877-4,4.167.0625L18.6633,12Z"
    })), children);
  });
  var Bus32 = /*#__PURE__*/React__default['default'].forwardRef(function Bus32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path541 || (_path541 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"
    })), _path542 || (_path542 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"
    })), children);
  });
  var Bus24 = /*#__PURE__*/React__default['default'].forwardRef(function Bus24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path543 || (_path543 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"
    })), _path544 || (_path544 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"
    })), children);
  });
  var Bus20 = /*#__PURE__*/React__default['default'].forwardRef(function Bus20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path545 || (_path545 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"
    })), _path546 || (_path546 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"
    })), children);
  });
  var Bus16 = /*#__PURE__*/React__default['default'].forwardRef(function Bus16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path547 || (_path547 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"
    })), _path548 || (_path548 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"
    })), children);
  });
  var CabinCare32 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCare32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path549 || (_path549 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3022 2a2.6617 2.6617 0 00-1.9079.8059l-.3931.4053-.397-.4053a2.6613 2.6613 0 00-3.8158 0 2.7992 2.7992 0 000 3.8963L25.0012 11 29.21 6.7022a2.7992 2.7992 0 000-3.8963A2.6613 2.6613 0 0027.3022 2zM23.8218 18H15.083L11.8643 5.9653a4 4 0 00-7.7276 2.07L8.5454 24.5168A2 2 0 0010.4775 26H19v2H4v2H19a2 2 0 002-2V26h3a4.0046 4.0046 0 003.98-4.4A4.1214 4.1214 0 0023.8218 18zM24 24H10.4776L6.0686 7.5181A2 2 0 119.9324 6.4829L13.5466 20H24a2 2 0 010 4z"
    })), children);
  });
  var CabinCare24 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCare24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path550 || (_path550 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3022 2a2.6617 2.6617 0 00-1.9079.8059l-.3931.4053-.397-.4053a2.6613 2.6613 0 00-3.8158 0 2.7992 2.7992 0 000 3.8963L25.0012 11 29.21 6.7022a2.7992 2.7992 0 000-3.8963A2.6613 2.6613 0 0027.3022 2zM23.8218 18H15.083L11.8643 5.9653a4 4 0 00-7.7276 2.07L8.5454 24.5168A2 2 0 0010.4775 26H19v2H4v2H19a2 2 0 002-2V26h3a4.0046 4.0046 0 003.98-4.4A4.1214 4.1214 0 0023.8218 18zM24 24H10.4776L6.0686 7.5181A2 2 0 119.9324 6.4829L13.5466 20H24a2 2 0 010 4z"
    })), children);
  });
  var CabinCare20 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCare20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path551 || (_path551 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3022 2a2.6617 2.6617 0 00-1.9079.8059l-.3931.4053-.397-.4053a2.6613 2.6613 0 00-3.8158 0 2.7992 2.7992 0 000 3.8963L25.0012 11 29.21 6.7022a2.7992 2.7992 0 000-3.8963A2.6613 2.6613 0 0027.3022 2zM23.8218 18H15.083L11.8643 5.9653a4 4 0 00-7.7276 2.07L8.5454 24.5168A2 2 0 0010.4775 26H19v2H4v2H19a2 2 0 002-2V26h3a4.0046 4.0046 0 003.98-4.4A4.1214 4.1214 0 0023.8218 18zM24 24H10.4776L6.0686 7.5181A2 2 0 119.9324 6.4829L13.5466 20H24a2 2 0 010 4z"
    })), children);
  });
  var CabinCare16 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCare16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path552 || (_path552 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3022 2a2.6617 2.6617 0 00-1.9079.8059l-.3931.4053-.397-.4053a2.6613 2.6613 0 00-3.8158 0 2.7992 2.7992 0 000 3.8963L25.0012 11 29.21 6.7022a2.7992 2.7992 0 000-3.8963A2.6613 2.6613 0 0027.3022 2zM23.8218 18H15.083L11.8643 5.9653a4 4 0 00-7.7276 2.07L8.5454 24.5168A2 2 0 0010.4775 26H19v2H4v2H19a2 2 0 002-2V26h3a4.0046 4.0046 0 003.98-4.4A4.1214 4.1214 0 0023.8218 18zM24 24H10.4776L6.0686 7.5181A2 2 0 119.9324 6.4829L13.5466 20H24a2 2 0 010 4z"
    })), children);
  });
  var CabinCareAlert32 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlert32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path553 || (_path553 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24z"
    })), _rect$4 || (_rect$4 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "3",
      height: "3",
      x: "23.5",
      y: "11",
      rx: "1.5"
    })), _path554 || (_path554 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.8218,18H15.083L11.8643,5.9653a4,4,0,0,0-7.7276,2.07L8.5454,24.5168A2,2,0,0,0,10.4775,26H19v2H4v2H19a2,2,0,0,0,2-2V26h3a4.0046,4.0046,0,0,0,3.98-4.4A4.1215,4.1215,0,0,0,23.8218,18ZM24,24H10.4775L6.0686,7.5181A2,2,0,1,1,9.9324,6.4829L13.5466,20H24a2,2,0,0,1,0,4Z"
    })), children);
  });
  var CabinCareAlert24 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlert24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path555 || (_path555 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24z"
    })), _rect2$4 || (_rect2$4 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "3",
      height: "3",
      x: "23.5",
      y: "11",
      rx: "1.5"
    })), _path556 || (_path556 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.8218,18H15.083L11.8643,5.9653a4,4,0,0,0-7.7276,2.07L8.5454,24.5168A2,2,0,0,0,10.4775,26H19v2H4v2H19a2,2,0,0,0,2-2V26h3a4.0046,4.0046,0,0,0,3.98-4.4A4.1215,4.1215,0,0,0,23.8218,18ZM24,24H10.4775L6.0686,7.5181A2,2,0,1,1,9.9324,6.4829L13.5466,20H24a2,2,0,0,1,0,4Z"
    })), children);
  });
  var CabinCareAlert20 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlert20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path557 || (_path557 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24z"
    })), _rect3$4 || (_rect3$4 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "3",
      height: "3",
      x: "23.5",
      y: "11",
      rx: "1.5"
    })), _path558 || (_path558 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.8218,18H15.083L11.8643,5.9653a4,4,0,0,0-7.7276,2.07L8.5454,24.5168A2,2,0,0,0,10.4775,26H19v2H4v2H19a2,2,0,0,0,2-2V26h3a4.0046,4.0046,0,0,0,3.98-4.4A4.1215,4.1215,0,0,0,23.8218,18ZM24,24H10.4775L6.0686,7.5181A2,2,0,1,1,9.9324,6.4829L13.5466,20H24a2,2,0,0,1,0,4Z"
    })), children);
  });
  var CabinCareAlert16 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlert16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path559 || (_path559 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H26V9H24z"
    })), _rect4$4 || (_rect4$4 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "3",
      height: "3",
      x: "23.5",
      y: "11",
      rx: "1.5"
    })), _path560 || (_path560 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.8218,18H15.083L11.8643,5.9653a4,4,0,0,0-7.7276,2.07L8.5454,24.5168A2,2,0,0,0,10.4775,26H19v2H4v2H19a2,2,0,0,0,2-2V26h3a4.0046,4.0046,0,0,0,3.98-4.4A4.1215,4.1215,0,0,0,23.8218,18ZM24,24H10.4775L6.0686,7.5181A2,2,0,1,1,9.9324,6.4829L13.5466,20H24a2,2,0,0,1,0,4Z"
    })), children);
  });
  var CabinCareAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlt32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path561 || (_path561 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25V23H20.7676l-.8-3H27V18H19.4348l-2.469-9.2578-1.9316.5156 3.8017 14.2568A2.0037 2.0037 0 0020.77 25H22v3H10V25h6V23H6.7676l-.8-3H13V18H5.4348L2.9658 8.7422l-1.9316.5156L4.8359 23.5146A2.0037 2.0037 0 006.77 25H8v3H2v2H30V28H24V25zM27.303 2a2.6613 2.6613 0 00-1.9079.8059L25 3.2112l-.3951-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25 11l4.2108-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2z"
    })), children);
  });
  var CabinCareAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlt24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path562 || (_path562 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25V23H20.7676l-.8-3H27V18H19.4348l-2.469-9.2578-1.9316.5156 3.8017 14.2568A2.0037 2.0037 0 0020.77 25H22v3H10V25h6V23H6.7676l-.8-3H13V18H5.4348L2.9658 8.7422l-1.9316.5156L4.8359 23.5146A2.0037 2.0037 0 006.77 25H8v3H2v2H30V28H24V25zM27.303 2a2.6613 2.6613 0 00-1.9079.8059L25 3.2112l-.3951-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25 11l4.2108-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2z"
    })), children);
  });
  var CabinCareAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlt20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path563 || (_path563 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25V23H20.7676l-.8-3H27V18H19.4348l-2.469-9.2578-1.9316.5156 3.8017 14.2568A2.0037 2.0037 0 0020.77 25H22v3H10V25h6V23H6.7676l-.8-3H13V18H5.4348L2.9658 8.7422l-1.9316.5156L4.8359 23.5146A2.0037 2.0037 0 006.77 25H8v3H2v2H30V28H24V25zM27.303 2a2.6613 2.6613 0 00-1.9079.8059L25 3.2112l-.3951-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25 11l4.2108-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2z"
    })), children);
  });
  var CabinCareAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function CabinCareAlt16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path564 || (_path564 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25V23H20.7676l-.8-3H27V18H19.4348l-2.469-9.2578-1.9316.5156 3.8017 14.2568A2.0037 2.0037 0 0020.77 25H22v3H10V25h6V23H6.7676l-.8-3H13V18H5.4348L2.9658 8.7422l-1.9316.5156L4.8359 23.5146A2.0037 2.0037 0 006.77 25H8v3H2v2H30V28H24V25zM27.303 2a2.6613 2.6613 0 00-1.9079.8059L25 3.2112l-.3951-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25 11l4.2108-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2z"
    })), children);
  });
  var Cad32 = /*#__PURE__*/React__default['default'].forwardRef(function Cad32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path565 || (_path565 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 014 4v6A4 4 0 0126 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H24zM10 23H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cad24 = /*#__PURE__*/React__default['default'].forwardRef(function Cad24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path566 || (_path566 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 014 4v6A4 4 0 0126 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H24zM10 23H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cad20 = /*#__PURE__*/React__default['default'].forwardRef(function Cad20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path567 || (_path567 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 014 4v6A4 4 0 0126 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H24zM10 23H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cad16 = /*#__PURE__*/React__default['default'].forwardRef(function Cad16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path568 || (_path568 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 014 4v6A4 4 0 0126 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H24zM10 23H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cafe32 = /*#__PURE__*/React__default['default'].forwardRef(function Cafe32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path569 || (_path569 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 00-2 2v8a5.0059 5.0059 0 005 5h8a5.0059 5.0059 0 005-5V20h.5a4.5 4.5 0 000-9zM22 21a3.0033 3.0033 0 01-3 3H11a3.0033 3.0033 0 01-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 010 5zM19 9H17V8.854a1.9883 1.9883 0 00-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0111 2.146V1h2V2.146a1.9892 1.9892 0 001.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0119 8.854z"
    })), children);
  });
  var Cafe24 = /*#__PURE__*/React__default['default'].forwardRef(function Cafe24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path570 || (_path570 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 00-2 2v8a5.0059 5.0059 0 005 5h8a5.0059 5.0059 0 005-5V20h.5a4.5 4.5 0 000-9zM22 21a3.0033 3.0033 0 01-3 3H11a3.0033 3.0033 0 01-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 010 5zM19 9H17V8.854a1.9883 1.9883 0 00-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0111 2.146V1h2V2.146a1.9892 1.9892 0 001.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0119 8.854z"
    })), children);
  });
  var Cafe20 = /*#__PURE__*/React__default['default'].forwardRef(function Cafe20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path571 || (_path571 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 00-2 2v8a5.0059 5.0059 0 005 5h8a5.0059 5.0059 0 005-5V20h.5a4.5 4.5 0 000-9zM22 21a3.0033 3.0033 0 01-3 3H11a3.0033 3.0033 0 01-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 010 5zM19 9H17V8.854a1.9883 1.9883 0 00-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0111 2.146V1h2V2.146a1.9892 1.9892 0 001.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0119 8.854z"
    })), children);
  });
  var Cafe16 = /*#__PURE__*/React__default['default'].forwardRef(function Cafe16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path572 || (_path572 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 00-2 2v8a5.0059 5.0059 0 005 5h8a5.0059 5.0059 0 005-5V20h.5a4.5 4.5 0 000-9zM22 21a3.0033 3.0033 0 01-3 3H11a3.0033 3.0033 0 01-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 010 5zM19 9H17V8.854a1.9883 1.9883 0 00-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0111 2.146V1h2V2.146a1.9892 1.9892 0 001.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0119 8.854z"
    })), children);
  });
  var Calculation32 = /*#__PURE__*/React__default['default'].forwardRef(function Calculation32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path573 || (_path573 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8L10 8 10 4 8 4 8 8 4 8 4 10 8 10 8 14 10 14 10 10 14 10 14 8zM4 19H14V21H4zM4 24H14V26H4zM18 8H28V10H18zM24.41 22L28 18.41 26.59 17 23 20.59 19.41 17 18 18.41 21.59 22 18 25.59 19.41 27 23 23.41 26.59 27 28 25.59 24.41 22z"
    })), children);
  });
  var Calculation24 = /*#__PURE__*/React__default['default'].forwardRef(function Calculation24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path574 || (_path574 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8L10 8 10 4 8 4 8 8 4 8 4 10 8 10 8 14 10 14 10 10 14 10 14 8zM4 19H14V21H4zM4 24H14V26H4zM18 8H28V10H18zM24.41 22L28 18.41 26.59 17 23 20.59 19.41 17 18 18.41 21.59 22 18 25.59 19.41 27 23 23.41 26.59 27 28 25.59 24.41 22z"
    })), children);
  });
  var Calculation20 = /*#__PURE__*/React__default['default'].forwardRef(function Calculation20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path575 || (_path575 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8L10 8 10 4 8 4 8 8 4 8 4 10 8 10 8 14 10 14 10 10 14 10 14 8zM4 19H14V21H4zM4 24H14V26H4zM18 8H28V10H18zM24.41 22L28 18.41 26.59 17 23 20.59 19.41 17 18 18.41 21.59 22 18 25.59 19.41 27 23 23.41 26.59 27 28 25.59 24.41 22z"
    })), children);
  });
  var Calculation16 = /*#__PURE__*/React__default['default'].forwardRef(function Calculation16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path576 || (_path576 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8L10 8 10 4 8 4 8 8 4 8 4 10 8 10 8 14 10 14 10 10 14 10 14 8zM4 19H14V21H4zM4 24H14V26H4zM18 8H28V10H18zM24.41 22L28 18.41 26.59 17 23 20.59 19.41 17 18 18.41 21.59 22 18 25.59 19.41 27 23 23.41 26.59 27 28 25.59 24.41 22z"
    })), children);
  });
  var CalculationAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function CalculationAlt32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path577 || (_path577 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H25V15H19zM13 21L11 21 11 19 9 19 9 21 7 21 7 23 9 23 9 25 11 25 11 23 13 23 13 21zM7 9H13V11H7zM19 17H25V19H19z"
    })), _path578 || (_path578 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM15,5V15H5V5ZM5,17H15V27H5ZM17,27V5H27V27Z"
    })), children);
  });
  var CalculationAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function CalculationAlt24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path579 || (_path579 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H25V15H19zM13 21L11 21 11 19 9 19 9 21 7 21 7 23 9 23 9 25 11 25 11 23 13 23 13 21zM7 9H13V11H7zM19 17H25V19H19z"
    })), _path580 || (_path580 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM15,5V15H5V5ZM5,17H15V27H5ZM17,27V5H27V27Z"
    })), children);
  });
  var CalculationAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function CalculationAlt20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path581 || (_path581 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H25V15H19zM13 21L11 21 11 19 9 19 9 21 7 21 7 23 9 23 9 25 11 25 11 23 13 23 13 21zM7 9H13V11H7zM19 17H25V19H19z"
    })), _path582 || (_path582 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM15,5V15H5V5ZM5,17H15V27H5ZM17,27V5H27V27Z"
    })), children);
  });
  var CalculationAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function CalculationAlt16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path583 || (_path583 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H25V15H19zM13 21L11 21 11 19 9 19 9 21 7 21 7 23 9 23 9 25 11 25 11 23 13 23 13 21zM7 9H13V11H7zM19 17H25V19H19z"
    })), _path584 || (_path584 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM15,5V15H5V5ZM5,17H15V27H5ZM17,27V5H27V27Z"
    })), children);
  });
  var Calculator32 = /*#__PURE__*/React__default['default'].forwardRef(function Calculator32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path585 || (_path585 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"
    })), _path586 || (_path586 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"
    })), children);
  });
  var Calculator24 = /*#__PURE__*/React__default['default'].forwardRef(function Calculator24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path587 || (_path587 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"
    })), _path588 || (_path588 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"
    })), children);
  });
  var Calculator20 = /*#__PURE__*/React__default['default'].forwardRef(function Calculator20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path589 || (_path589 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"
    })), _path590 || (_path590 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"
    })), children);
  });
  var Calculator16 = /*#__PURE__*/React__default['default'].forwardRef(function Calculator16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path591 || (_path591 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"
    })), _path592 || (_path592 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"
    })), children);
  });
  var CalculatorCheck32 = /*#__PURE__*/React__default['default'].forwardRef(function CalculatorCheck32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path593 || (_path593 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"
    })), _path594 || (_path594 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"
    })), children);
  });
  var CalculatorCheck24 = /*#__PURE__*/React__default['default'].forwardRef(function CalculatorCheck24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path595 || (_path595 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"
    })), _path596 || (_path596 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"
    })), children);
  });
  var CalculatorCheck20 = /*#__PURE__*/React__default['default'].forwardRef(function CalculatorCheck20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path597 || (_path597 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"
    })), _path598 || (_path598 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"
    })), children);
  });
  var CalculatorCheck16 = /*#__PURE__*/React__default['default'].forwardRef(function CalculatorCheck16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path599 || (_path599 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"
    })), _path600 || (_path600 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"
    })), children);
  });
  var Calendar32 = /*#__PURE__*/React__default['default'].forwardRef(function Calendar32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path601 || (_path601 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4h-4V2h-2v2h-8V2h-2v2H6C4.9,4,4,4.9,4,6v20c0,1.1,0.9,2,2,2h20c1.1,0,2-0.9,2-2V6C28,4.9,27.1,4,26,4z M26,26H6V12h20\tV26z M26,10H6V6h4v2h2V6h8v2h2V6h4V10z"
    })), children);
  });
  var Calendar24 = /*#__PURE__*/React__default['default'].forwardRef(function Calendar24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path602 || (_path602 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4h-4V2h-2v2h-8V2h-2v2H6C4.9,4,4,4.9,4,6v20c0,1.1,0.9,2,2,2h20c1.1,0,2-0.9,2-2V6C28,4.9,27.1,4,26,4z M26,26H6V12h20\tV26z M26,10H6V6h4v2h2V6h8v2h2V6h4V10z"
    })), children);
  });
  var Calendar20 = /*#__PURE__*/React__default['default'].forwardRef(function Calendar20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path603 || (_path603 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4h-4V2h-2v2h-8V2h-2v2H6C4.9,4,4,4.9,4,6v20c0,1.1,0.9,2,2,2h20c1.1,0,2-0.9,2-2V6C28,4.9,27.1,4,26,4z M26,26H6V12h20\tV26z M26,10H6V6h4v2h2V6h8v2h2V6h4V10z"
    })), children);
  });
  var Calendar16 = /*#__PURE__*/React__default['default'].forwardRef(function Calendar16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path604 || (_path604 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4h-4V2h-2v2h-8V2h-2v2H6C4.9,4,4,4.9,4,6v20c0,1.1,0.9,2,2,2h20c1.1,0,2-0.9,2-2V6C28,4.9,27.1,4,26,4z M26,26H6V12h20\tV26z M26,10H6V6h4v2h2V6h8v2h2V6h4V10z"
    })), children);
  });
  var CalendarHeatMap32 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarHeatMap32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path605 || (_path605 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,6h4V8h2V6h8V8h2V6h4l0,4H6Zm0,6h5v6H6ZM19,26H13V20h6Zm0-8H13V12h6Zm2,8V20h5l.0012,6Z"
    })), children);
  });
  var CalendarHeatMap24 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarHeatMap24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path606 || (_path606 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,6h4V8h2V6h8V8h2V6h4l0,4H6Zm0,6h5v6H6ZM19,26H13V20h6Zm0-8H13V12h6Zm2,8V20h5l.0012,6Z"
    })), children);
  });

  var _path$r, _path2$r, _path3$r, _path4$r, _path5$r, _path6$r, _path7$r, _path8$r, _path9$r, _path10$r, _path11$r, _path12$r, _path13$r, _path14$r, _path15$r, _path16$r, _path17$r, _path18$r, _path19$r, _path20$r, _path21$r, _path22$r, _path23$r, _path24$r, _path25$r, _path26$r, _path27$r, _path28$r, _path29$r, _path30$r, _path31$r, _path32$r, _path33$r, _circle$q, _path34$r, _path35$r, _path36$r, _circle2$q, _path37$r, _path38$r, _path39$r, _circle3$q, _path40$r, _path41$r, _path42$r, _circle4$p, _path43$r, _path44$r, _path45$r, _path46$r, _path47$r, _path48$r, _path49$r, _path50$r, _path51$r, _path52$r, _path53$r, _path54$r, _path55$r, _path56$r, _path57$r, _path58$r, _path59$r, _path60$r, _path61$r, _path62$r, _path63$r, _path64$r, _path65$r, _path66$r, _path67$r, _path68$r, _path69$r, _path70$r, _path71$r, _path72$r, _path73$r, _path74$r, _path75$r, _path76$r, _path77$r, _path78$r, _path79$r, _path80$r, _path81$r, _path82$r, _path83$r, _path84$r, _path85$r, _path86$r, _path87$r, _path88$r, _path89$r, _path90$r, _path91$r, _path92$r, _path93$r, _path94$r, _path95$r, _path96$r, _path97$r, _path98$r, _path99$r, _path100$r, _path101$r, _path102$r, _path103$r, _path104$r, _path105$r, _path106$r, _path107$r, _path108$r, _path109$r, _path110$r, _path111$r, _path112$r, _path113$r, _path114$r, _path115$r, _path116$r, _path117$r, _path118$r, _path119$r, _path120$r, _path121$r, _path122$r, _path123$r, _path124$r, _path125$r, _path126$r, _path127$r, _path128$r, _path129$r, _path130$r, _path131$r, _path132$r, _path133$r, _path134$r, _path135$r, _path136$r, _path137$r, _path138$r, _path139$r, _path140$r, _path141$r, _path142$r, _path143$r, _path144$r, _path145$r, _path146$r, _path147$r, _path148$r, _path149$r, _path150$r, _path151$r, _path152$r, _path153$r, _path154$r, _path155$r, _path156$r, _path157$r, _path158$r, _path159$r, _circle5$o, _path160$r, _path161$r, _circle6$o, _path162$r, _path163$r, _circle7$o, _path164$r, _path165$r, _circle8$o, _path166$r, _circle9$o, _path167$r, _path168$r, _path169$r, _circle10$o, _path170$r, _path171$r, _path172$r, _circle11$n, _path173$r, _path174$r, _path175$r, _circle12$n, _path176$r, _path177$q, _circle13$n, _path178$q, _path179$q, _circle14$n, _path180$q, _path181$q, _circle15$n, _path182$q, _path183$q, _circle16$n, _path184$q, _path185$q, _path186$q, _path187$q, _path188$q, _path189$q, _path190$q, _path191$q, _path192$q, _path193$q, _path194$q, _path195$q, _path196$q, _path197$q, _path198$q, _path199$q, _path200$q, _path201$q, _path202$q, _path203$q, _path204$q, _path205$q, _path206$q, _path207$q, _path208$q, _path209$q, _path210$q, _path211$q, _path212$q, _path213$q, _path214$q, _path215$q, _path216$q, _path217$q, _path218$q, _path219$q, _path220$q, _path221$q, _path222$q, _path223$q, _path224$q, _path225$q, _path226$q, _path227$q, _path228$q, _path229$q, _path230$q, _path231$q, _path232$q, _path233$q, _path234$q, _path235$q, _path236$q, _path237$q, _path238$q, _path239$q, _path240$q, _path241$q, _path242$q, _path243$q, _path244$q, _path245$q, _path246$q, _path247$q, _path248$q, _path249$q, _path250$q, _path251$q, _path252$q, _path253$q, _path254$q, _path255$q, _path256$q, _path257$q, _path258$q, _path259$q, _path260$q, _path261$q, _path262$q, _path263$q, _path264$q, _path265$q, _path266$q, _path267$q, _path268$q, _path269$q, _path270$q, _path271$q, _path272$q, _path273$q, _path274$q, _path275$q, _path276$q, _path277$q, _path278$q, _path279$q, _path280$q, _path281$q, _path282$q, _path283$q, _path284$q, _path285$q, _path286$q, _path287$q, _path288$q, _path289$q, _path290$q, _path291$q, _path292$q, _path293$q, _path294$q, _path295$q, _path296$q, _path297$q, _path298$q, _path299$q, _path300$q, _path301$q, _path302$q, _path303$q, _path304$q, _path305$q, _path306$q, _path307$q, _path308$q, _path309$q, _path310$q, _path311$q, _path312$q, _path313$q, _path314$q, _path315$q, _path316$q, _path317$q, _path318$q, _path319$q, _path320$q, _path321$q, _path322$q, _path323$q, _path324$q, _path325$q, _path326$q, _path327$q, _path328$q, _path329$q, _path330$q, _path331$q, _path332$q, _path333$q, _path334$q, _path335$q, _path336$q, _path337$q, _path338$p, _path339$p, _path340$p, _path341$p, _path342$p, _path343$p, _path344$p, _path345$p, _path346$p, _path347$p, _path348$p, _path349$p, _path350$p, _path351$p, _path352$p, _path353$p, _path354$p, _path355$o, _path356$o, _path357$o, _path358$o, _path359$o, _path360$o, _path361$n, _path362$n, _path363$l, _path364$l, _path365$l, _path366$l, _path367$l, _path368$l, _path369$l, _path370$l, _path371$l, _path372$l, _path373$l, _path374$l, _path375$k, _path376$k, _path377$k, _path378$k, _path379$k, _path380$k, _path381$k, _path382$k, _path383$k, _path384$j, _path385$j;

  var _excluded$r = ["children"],
      _excluded2$r = ["children"],
      _excluded3$r = ["children"],
      _excluded4$r = ["children"],
      _excluded5$r = ["children"],
      _excluded6$r = ["children"],
      _excluded7$r = ["children"],
      _excluded8$r = ["children"],
      _excluded9$r = ["children"],
      _excluded10$r = ["children"],
      _excluded11$r = ["children"],
      _excluded12$r = ["children"],
      _excluded13$r = ["children"],
      _excluded14$r = ["children"],
      _excluded15$r = ["children"],
      _excluded16$r = ["children"],
      _excluded17$r = ["children"],
      _excluded18$r = ["children"],
      _excluded19$r = ["children"],
      _excluded20$r = ["children"],
      _excluded21$r = ["children"],
      _excluded22$r = ["children"],
      _excluded23$r = ["children"],
      _excluded24$r = ["children"],
      _excluded25$r = ["children"],
      _excluded26$r = ["children"],
      _excluded27$r = ["children"],
      _excluded28$r = ["children"],
      _excluded29$r = ["children"],
      _excluded30$r = ["children"],
      _excluded31$r = ["children"],
      _excluded32$r = ["children"],
      _excluded33$r = ["children"],
      _excluded34$r = ["children"],
      _excluded35$r = ["children"],
      _excluded36$r = ["children"],
      _excluded37$r = ["children"],
      _excluded38$r = ["children"],
      _excluded39$r = ["children"],
      _excluded40$r = ["children"],
      _excluded41$r = ["children"],
      _excluded42$r = ["children"],
      _excluded43$r = ["children"],
      _excluded44$r = ["children"],
      _excluded45$r = ["children"],
      _excluded46$r = ["children"],
      _excluded47$r = ["children"],
      _excluded48$r = ["children"],
      _excluded49$r = ["children"],
      _excluded50$r = ["children"],
      _excluded51$r = ["children"],
      _excluded52$r = ["children"],
      _excluded53$r = ["children"],
      _excluded54$r = ["children"],
      _excluded55$r = ["children"],
      _excluded56$r = ["children"],
      _excluded57$r = ["children"],
      _excluded58$r = ["children"],
      _excluded59$r = ["children"],
      _excluded60$r = ["children"],
      _excluded61$r = ["children"],
      _excluded62$r = ["children"],
      _excluded63$r = ["children"],
      _excluded64$r = ["children"],
      _excluded65$r = ["children"],
      _excluded66$r = ["children"],
      _excluded67$r = ["children"],
      _excluded68$r = ["children"],
      _excluded69$r = ["children"],
      _excluded70$r = ["children"],
      _excluded71$r = ["children"],
      _excluded72$r = ["children"],
      _excluded73$r = ["children"],
      _excluded74$r = ["children"],
      _excluded75$r = ["children"],
      _excluded76$r = ["children"],
      _excluded77$r = ["children"],
      _excluded78$r = ["children"],
      _excluded79$r = ["children"],
      _excluded80$r = ["children"],
      _excluded81$r = ["children"],
      _excluded82$r = ["children"],
      _excluded83$r = ["children"],
      _excluded84$r = ["children"],
      _excluded85$r = ["children"],
      _excluded86$r = ["children"],
      _excluded87$r = ["children"],
      _excluded88$r = ["children"],
      _excluded89$r = ["children"],
      _excluded90$r = ["children"],
      _excluded91$r = ["children"],
      _excluded92$r = ["children"],
      _excluded93$r = ["children"],
      _excluded94$r = ["children"],
      _excluded95$r = ["children"],
      _excluded96$r = ["children"],
      _excluded97$r = ["children"],
      _excluded98$r = ["children"],
      _excluded99$r = ["children"],
      _excluded100$r = ["children"],
      _excluded101$r = ["children"],
      _excluded102$r = ["children"],
      _excluded103$r = ["children"],
      _excluded104$r = ["children"],
      _excluded105$r = ["children"],
      _excluded106$r = ["children"],
      _excluded107$r = ["children"],
      _excluded108$r = ["children"],
      _excluded109$r = ["children"],
      _excluded110$r = ["children"],
      _excluded111$r = ["children"],
      _excluded112$r = ["children"],
      _excluded113$r = ["children"],
      _excluded114$r = ["children"],
      _excluded115$r = ["children"],
      _excluded116$r = ["children"],
      _excluded117$r = ["children"],
      _excluded118$r = ["children"],
      _excluded119$q = ["children"],
      _excluded120$q = ["children"],
      _excluded121$q = ["children"],
      _excluded122$q = ["children"],
      _excluded123$q = ["children"],
      _excluded124$q = ["children"],
      _excluded125$q = ["children"],
      _excluded126$q = ["children"],
      _excluded127$q = ["children"],
      _excluded128$q = ["children"],
      _excluded129$q = ["children"],
      _excluded130$q = ["children"],
      _excluded131$q = ["children"],
      _excluded132$q = ["children"],
      _excluded133$q = ["children"],
      _excluded134$q = ["children"],
      _excluded135$q = ["children"],
      _excluded136$q = ["children"],
      _excluded137$q = ["children"],
      _excluded138$q = ["children"],
      _excluded139$q = ["children"],
      _excluded140$q = ["children"],
      _excluded141$q = ["children"],
      _excluded142$q = ["children"],
      _excluded143$q = ["children"],
      _excluded144$q = ["children"],
      _excluded145$q = ["children"],
      _excluded146$q = ["children"],
      _excluded147$q = ["children"],
      _excluded148$q = ["children"],
      _excluded149$q = ["children"],
      _excluded150$q = ["children"],
      _excluded151$q = ["children"],
      _excluded152$q = ["children"],
      _excluded153$q = ["children"],
      _excluded154$q = ["children"],
      _excluded155$q = ["children"],
      _excluded156$q = ["children"],
      _excluded157$q = ["children"],
      _excluded158$q = ["children"],
      _excluded159$q = ["children"],
      _excluded160$q = ["children"],
      _excluded161$q = ["children"],
      _excluded162$q = ["children"],
      _excluded163$q = ["children"],
      _excluded164$q = ["children"],
      _excluded165$q = ["children"],
      _excluded166$q = ["children"],
      _excluded167$q = ["children"],
      _excluded168$q = ["children"],
      _excluded169$q = ["children"],
      _excluded170$q = ["children"],
      _excluded171$q = ["children"],
      _excluded172$q = ["children"],
      _excluded173$q = ["children"],
      _excluded174$q = ["children"],
      _excluded175$q = ["children"],
      _excluded176$q = ["children"],
      _excluded177$q = ["children"],
      _excluded178$q = ["children"],
      _excluded179$q = ["children"],
      _excluded180$q = ["children"],
      _excluded181$q = ["children"],
      _excluded182$q = ["children"],
      _excluded183$q = ["children"],
      _excluded184$q = ["children"],
      _excluded185$q = ["children"],
      _excluded186$q = ["children"],
      _excluded187$q = ["children"],
      _excluded188$q = ["children"],
      _excluded189$q = ["children"],
      _excluded190$q = ["children"],
      _excluded191$q = ["children"],
      _excluded192$q = ["children"],
      _excluded193$q = ["children"],
      _excluded194$q = ["children"],
      _excluded195$q = ["children"],
      _excluded196$q = ["children"],
      _excluded197$q = ["children"],
      _excluded198$q = ["children"],
      _excluded199$q = ["children"],
      _excluded200$q = ["children"],
      _excluded201$q = ["children"],
      _excluded202$q = ["children"],
      _excluded203$q = ["children"],
      _excluded204$q = ["children"],
      _excluded205$q = ["children"],
      _excluded206$q = ["children"],
      _excluded207$q = ["children"],
      _excluded208$q = ["children"],
      _excluded209$q = ["children"],
      _excluded210$q = ["children"],
      _excluded211$q = ["children"],
      _excluded212$q = ["children"],
      _excluded213$q = ["children"],
      _excluded214$q = ["children"],
      _excluded215$q = ["children"],
      _excluded216$q = ["children"],
      _excluded217$q = ["children"],
      _excluded218$q = ["children"],
      _excluded219$q = ["children"],
      _excluded220$q = ["children"],
      _excluded221$q = ["children"],
      _excluded222$q = ["children"],
      _excluded223$q = ["children"],
      _excluded224$q = ["children"],
      _excluded225$q = ["children"],
      _excluded226$q = ["children"],
      _excluded227$q = ["children"],
      _excluded228$q = ["children"],
      _excluded229$q = ["children"],
      _excluded230$q = ["children"],
      _excluded231$q = ["children"],
      _excluded232$q = ["children"],
      _excluded233$q = ["children"],
      _excluded234$q = ["children"],
      _excluded235$q = ["children"],
      _excluded236$q = ["children"],
      _excluded237$q = ["children"],
      _excluded238$q = ["children"],
      _excluded239$q = ["children"],
      _excluded240$q = ["children"],
      _excluded241$q = ["children"],
      _excluded242$q = ["children"],
      _excluded243$q = ["children"],
      _excluded244$q = ["children"],
      _excluded245$q = ["children"],
      _excluded246$q = ["children"],
      _excluded247$q = ["children"],
      _excluded248$q = ["children"],
      _excluded249$q = ["children"],
      _excluded250$q = ["children"];
  var CalendarHeatMap20 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarHeatMap20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$r || (_path$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,6h4V8h2V6h8V8h2V6h4l0,4H6Zm0,6h5v6H6ZM19,26H13V20h6Zm0-8H13V12h6Zm2,8V20h5l.0012,6Z"
    })), children);
  });
  var CalendarHeatMap16 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarHeatMap16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$r || (_path2$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,6h4V8h2V6h8V8h2V6h4l0,4H6Zm0,6h5v6H6ZM19,26H13V20h6Zm0-8H13V12h6Zm2,8V20h5l.0012,6Z"
    })), children);
  });
  var CalendarSettings32 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarSettings32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$r || (_path3$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H27.91a5.9592,5.9592,0,0,0-1.0244-2.4707L28.364,17.05,26.95,15.6362l-1.4788,1.4785A5.9584,5.9584,0,0,0,23,16.09V14H21v2.09a5.9584,5.9584,0,0,0-2.4709,1.0244L17.05,15.6362,15.636,17.05l1.4787,1.479A5.9618,5.9618,0,0,0,16.09,21H14v2h2.09a5.9618,5.9618,0,0,0,1.0244,2.4707L15.636,26.95,17.05,28.3638l1.4788-1.4785A5.9584,5.9584,0,0,0,21,27.91V30h2V27.91a5.9584,5.9584,0,0,0,2.4709-1.0244L26.95,28.3638,28.364,26.95l-1.4787-1.479A5.9592,5.9592,0,0,0,27.91,23Zm-8,3a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,26Z"
    })), _path4$r || (_path4$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var CalendarSettings24 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarSettings24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$r || (_path5$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H27.91a5.9592,5.9592,0,0,0-1.0244-2.4707L28.364,17.05,26.95,15.6362l-1.4788,1.4785A5.9584,5.9584,0,0,0,23,16.09V14H21v2.09a5.9584,5.9584,0,0,0-2.4709,1.0244L17.05,15.6362,15.636,17.05l1.4787,1.479A5.9618,5.9618,0,0,0,16.09,21H14v2h2.09a5.9618,5.9618,0,0,0,1.0244,2.4707L15.636,26.95,17.05,28.3638l1.4788-1.4785A5.9584,5.9584,0,0,0,21,27.91V30h2V27.91a5.9584,5.9584,0,0,0,2.4709-1.0244L26.95,28.3638,28.364,26.95l-1.4787-1.479A5.9592,5.9592,0,0,0,27.91,23Zm-8,3a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,26Z"
    })), _path6$r || (_path6$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var CalendarSettings20 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarSettings20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$r || (_path7$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H27.91a5.9592,5.9592,0,0,0-1.0244-2.4707L28.364,17.05,26.95,15.6362l-1.4788,1.4785A5.9584,5.9584,0,0,0,23,16.09V14H21v2.09a5.9584,5.9584,0,0,0-2.4709,1.0244L17.05,15.6362,15.636,17.05l1.4787,1.479A5.9618,5.9618,0,0,0,16.09,21H14v2h2.09a5.9618,5.9618,0,0,0,1.0244,2.4707L15.636,26.95,17.05,28.3638l1.4788-1.4785A5.9584,5.9584,0,0,0,21,27.91V30h2V27.91a5.9584,5.9584,0,0,0,2.4709-1.0244L26.95,28.3638,28.364,26.95l-1.4787-1.479A5.9592,5.9592,0,0,0,27.91,23Zm-8,3a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,26Z"
    })), _path8$r || (_path8$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var CalendarSettings16 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarSettings16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$r || (_path9$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H27.91a5.9592,5.9592,0,0,0-1.0244-2.4707L28.364,17.05,26.95,15.6362l-1.4788,1.4785A5.9584,5.9584,0,0,0,23,16.09V14H21v2.09a5.9584,5.9584,0,0,0-2.4709,1.0244L17.05,15.6362,15.636,17.05l1.4787,1.479A5.9618,5.9618,0,0,0,16.09,21H14v2h2.09a5.9618,5.9618,0,0,0,1.0244,2.4707L15.636,26.95,17.05,28.3638l1.4788-1.4785A5.9584,5.9584,0,0,0,21,27.91V30h2V27.91a5.9584,5.9584,0,0,0,2.4709-1.0244L26.95,28.3638,28.364,26.95l-1.4787-1.479A5.9592,5.9592,0,0,0,27.91,23Zm-8,3a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,26Z"
    })), _path10$r || (_path10$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var CalendarTools32 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarTools32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$r || (_path11$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.981,24.4333A3.9549,3.9549,0,0,0,26,25a4.0045,4.0045,0,0,0,4-4,3.9427,3.9427,0,0,0-.1492-1.0228l-2.4367,2.4369-.0005-.0005a1.9991,1.9991,0,1,1-2.8272-2.8272l-.0005-.0005,2.4368-2.4368A3.95,3.95,0,0,0,26,17a4.0045,4.0045,0,0,0-4,4,3.9544,3.9544,0,0,0,.5669,2.0191L17,28.586,18.4141,30Z"
    })), _path12$r || (_path12$r = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h8V26H6V6h4V8h2V6h8V8h2V6h4v8h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var CalendarTools24 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarTools24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$r || (_path13$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.981,24.4333A3.9549,3.9549,0,0,0,26,25a4.0045,4.0045,0,0,0,4-4,3.9427,3.9427,0,0,0-.1492-1.0228l-2.4367,2.4369-.0005-.0005a1.9991,1.9991,0,1,1-2.8272-2.8272l-.0005-.0005,2.4368-2.4368A3.95,3.95,0,0,0,26,17a4.0045,4.0045,0,0,0-4,4,3.9544,3.9544,0,0,0,.5669,2.0191L17,28.586,18.4141,30Z"
    })), _path14$r || (_path14$r = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h8V26H6V6h4V8h2V6h8V8h2V6h4v8h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var CalendarTools20 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarTools20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$r || (_path15$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.981,24.4333A3.9549,3.9549,0,0,0,26,25a4.0045,4.0045,0,0,0,4-4,3.9427,3.9427,0,0,0-.1492-1.0228l-2.4367,2.4369-.0005-.0005a1.9991,1.9991,0,1,1-2.8272-2.8272l-.0005-.0005,2.4368-2.4368A3.95,3.95,0,0,0,26,17a4.0045,4.0045,0,0,0-4,4,3.9544,3.9544,0,0,0,.5669,2.0191L17,28.586,18.4141,30Z"
    })), _path16$r || (_path16$r = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h8V26H6V6h4V8h2V6h8V8h2V6h4v8h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var CalendarTools16 = /*#__PURE__*/React__default['default'].forwardRef(function CalendarTools16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$r || (_path17$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.981,24.4333A3.9549,3.9549,0,0,0,26,25a4.0045,4.0045,0,0,0,4-4,3.9427,3.9427,0,0,0-.1492-1.0228l-2.4367,2.4369-.0005-.0005a1.9991,1.9991,0,1,1-2.8272-2.8272l-.0005-.0005,2.4368-2.4368A3.95,3.95,0,0,0,26,17a4.0045,4.0045,0,0,0-4,4,3.9544,3.9544,0,0,0,.5669,2.0191L17,28.586,18.4141,30Z"
    })), _path18$r || (_path18$r = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h8V26H6V6h4V8h2V6h8V8h2V6h4v8h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var Calibrate32 = /*#__PURE__*/React__default['default'].forwardRef(function Calibrate32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$r || (_path19$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"
    })), children);
  });
  var Calibrate24 = /*#__PURE__*/React__default['default'].forwardRef(function Calibrate24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$r || (_path20$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"
    })), children);
  });
  var Calibrate20 = /*#__PURE__*/React__default['default'].forwardRef(function Calibrate20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$r || (_path21$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"
    })), children);
  });
  var Calibrate16 = /*#__PURE__*/React__default['default'].forwardRef(function Calibrate16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$r || (_path22$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"
    })), children);
  });
  var Camera32 = /*#__PURE__*/React__default['default'].forwardRef(function Camera32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$r || (_path23$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"
    })), _path24$r || (_path24$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), children);
  });
  var Camera24 = /*#__PURE__*/React__default['default'].forwardRef(function Camera24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$r || (_path25$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"
    })), _path26$r || (_path26$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), children);
  });
  var Camera20 = /*#__PURE__*/React__default['default'].forwardRef(function Camera20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$r || (_path27$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"
    })), _path28$r || (_path28$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), children);
  });
  var Camera16 = /*#__PURE__*/React__default['default'].forwardRef(function Camera16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$r || (_path29$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"
    })), _path30$r || (_path30$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), children);
  });
  var CameraAction32 = /*#__PURE__*/React__default['default'].forwardRef(function CameraAction32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$r || (_path31$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"
    })), _path32$r || (_path32$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"
    })), _path33$r || (_path33$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 9H26V11H19z"
    })), _circle$q || (_circle$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "17",
      r: "1"
    })), children);
  });
  var CameraAction24 = /*#__PURE__*/React__default['default'].forwardRef(function CameraAction24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$r || (_path34$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"
    })), _path35$r || (_path35$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"
    })), _path36$r || (_path36$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 9H26V11H19z"
    })), _circle2$q || (_circle2$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "17",
      r: "1"
    })), children);
  });
  var CameraAction20 = /*#__PURE__*/React__default['default'].forwardRef(function CameraAction20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$r || (_path37$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"
    })), _path38$r || (_path38$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"
    })), _path39$r || (_path39$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 9H26V11H19z"
    })), _circle3$q || (_circle3$q = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "17",
      r: "1"
    })), children);
  });
  var CameraAction16 = /*#__PURE__*/React__default['default'].forwardRef(function CameraAction16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$r || (_path40$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"
    })), _path41$r || (_path41$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"
    })), _path42$r || (_path42$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 9H26V11H19z"
    })), _circle4$p || (_circle4$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "12",
      cy: "17",
      r: "1"
    })), children);
  });
  var Campsite32 = /*#__PURE__*/React__default['default'].forwardRef(function Campsite32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$r || (_path43$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5618,26,17.17,8.9277,19.5361,5.04,17.8281,4,16,7.0049,14.17,4l-1.708,1.04,2.3665,3.8877L4.438,26H2v2H30V26ZM16,10.8506,25.2207,26H17V18H15v8H6.7791Z"
    })), children);
  });
  var Campsite24 = /*#__PURE__*/React__default['default'].forwardRef(function Campsite24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$r || (_path44$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5618,26,17.17,8.9277,19.5361,5.04,17.8281,4,16,7.0049,14.17,4l-1.708,1.04,2.3665,3.8877L4.438,26H2v2H30V26ZM16,10.8506,25.2207,26H17V18H15v8H6.7791Z"
    })), children);
  });
  var Campsite20 = /*#__PURE__*/React__default['default'].forwardRef(function Campsite20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$r || (_path45$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5618,26,17.17,8.9277,19.5361,5.04,17.8281,4,16,7.0049,14.17,4l-1.708,1.04,2.3665,3.8877L4.438,26H2v2H30V26ZM16,10.8506,25.2207,26H17V18H15v8H6.7791Z"
    })), children);
  });
  var Campsite16 = /*#__PURE__*/React__default['default'].forwardRef(function Campsite16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$r || (_path46$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5618,26,17.17,8.9277,19.5361,5.04,17.8281,4,16,7.0049,14.17,4l-1.708,1.04,2.3665,3.8877L4.438,26H2v2H30V26ZM16,10.8506,25.2207,26H17V18H15v8H6.7791Z"
    })), children);
  });
  var Car32 = /*#__PURE__*/React__default['default'].forwardRef(function Car32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$r || (_path47$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379,15.9336l-7.7324-2.7783L18.374,9.0967A2.99,2.99,0,0,0,16.0537,8H8.0576a2.9982,2.9982,0,0,0-2.48,1.3115L2.8662,13.2949A4.9884,4.9884,0,0,0,2,16.1074V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V16.875A1,1,0,0,0,29.3379,15.9336ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,23,26Zm5-3H26.8579a3.9806,3.9806,0,0,0-7.7158,0H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V16.1074A2.9977,2.9977,0,0,1,4.52,14.4189l2.711-3.9814A.9992.9992,0,0,1,8.0576,10h7.9961a.9928.9928,0,0,1,.7647.3545l3.3994,4.2685a1.0007,1.0007,0,0,0,.4443.3184L28,17.5781Z"
    })), children);
  });
  var Car24 = /*#__PURE__*/React__default['default'].forwardRef(function Car24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$r || (_path48$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379,15.9336l-7.7324-2.7783L18.374,9.0967A2.99,2.99,0,0,0,16.0537,8H8.0576a2.9982,2.9982,0,0,0-2.48,1.3115L2.8662,13.2949A4.9884,4.9884,0,0,0,2,16.1074V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V16.875A1,1,0,0,0,29.3379,15.9336ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,23,26Zm5-3H26.8579a3.9806,3.9806,0,0,0-7.7158,0H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V16.1074A2.9977,2.9977,0,0,1,4.52,14.4189l2.711-3.9814A.9992.9992,0,0,1,8.0576,10h7.9961a.9928.9928,0,0,1,.7647.3545l3.3994,4.2685a1.0007,1.0007,0,0,0,.4443.3184L28,17.5781Z"
    })), children);
  });
  var Car20 = /*#__PURE__*/React__default['default'].forwardRef(function Car20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$r || (_path49$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379,15.9336l-7.7324-2.7783L18.374,9.0967A2.99,2.99,0,0,0,16.0537,8H8.0576a2.9982,2.9982,0,0,0-2.48,1.3115L2.8662,13.2949A4.9884,4.9884,0,0,0,2,16.1074V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V16.875A1,1,0,0,0,29.3379,15.9336ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,23,26Zm5-3H26.8579a3.9806,3.9806,0,0,0-7.7158,0H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V16.1074A2.9977,2.9977,0,0,1,4.52,14.4189l2.711-3.9814A.9992.9992,0,0,1,8.0576,10h7.9961a.9928.9928,0,0,1,.7647.3545l3.3994,4.2685a1.0007,1.0007,0,0,0,.4443.3184L28,17.5781Z"
    })), children);
  });
  var Car16 = /*#__PURE__*/React__default['default'].forwardRef(function Car16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$r || (_path50$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379,15.9336l-7.7324-2.7783L18.374,9.0967A2.99,2.99,0,0,0,16.0537,8H8.0576a2.9982,2.9982,0,0,0-2.48,1.3115L2.8662,13.2949A4.9884,4.9884,0,0,0,2,16.1074V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V16.875A1,1,0,0,0,29.3379,15.9336ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,23,26Zm5-3H26.8579a3.9806,3.9806,0,0,0-7.7158,0H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V16.1074A2.9977,2.9977,0,0,1,4.52,14.4189l2.711-3.9814A.9992.9992,0,0,1,8.0576,10h7.9961a.9928.9928,0,0,1,.7647.3545l3.3994,4.2685a1.0007,1.0007,0,0,0,.4443.3184L28,17.5781Z"
    })), children);
  });
  var CarFront32 = /*#__PURE__*/React__default['default'].forwardRef(function CarFront32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$r || (_path51$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 19H19V21H13z"
    })), _path52$r || (_path52$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6v7a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"
    })), children);
  });
  var CarFront24 = /*#__PURE__*/React__default['default'].forwardRef(function CarFront24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$r || (_path53$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 19H19V21H13z"
    })), _path54$r || (_path54$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6v7a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"
    })), children);
  });
  var CarFront20 = /*#__PURE__*/React__default['default'].forwardRef(function CarFront20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$r || (_path55$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 19H19V21H13z"
    })), _path56$r || (_path56$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6v7a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"
    })), children);
  });
  var CarFront16 = /*#__PURE__*/React__default['default'].forwardRef(function CarFront16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$r || (_path57$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 19H19V21H13z"
    })), _path58$r || (_path58$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6v7a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"
    })), children);
  });
  var Carbon32 = /*#__PURE__*/React__default['default'].forwardRef(function Carbon32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$r || (_path59$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"
    })), _path60$r || (_path60$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"
    })), children);
  });
  var Carbon24 = /*#__PURE__*/React__default['default'].forwardRef(function Carbon24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$r || (_path61$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"
    })), _path62$r || (_path62$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"
    })), children);
  });
  var Carbon20 = /*#__PURE__*/React__default['default'].forwardRef(function Carbon20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$r || (_path63$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"
    })), _path64$r || (_path64$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"
    })), children);
  });
  var Carbon16 = /*#__PURE__*/React__default['default'].forwardRef(function Carbon16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$r || (_path65$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"
    })), _path66$r || (_path66$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"
    })), children);
  });
  var CarbonAccounting32 = /*#__PURE__*/React__default['default'].forwardRef(function CarbonAccounting32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$r || (_path67$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 26H23V22a2.002 2.002 0 012-2h2V18H23V16h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H25v2h4zM19 22H15a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V20A2.0023 2.0023 0 0119 22zM15 10V20h4V10zM11 22H5a2.0023 2.0023 0 01-2-2V10A2.002 2.002 0 015 8h6v2H5V20h6z"
    })), children);
  });
  var CarbonAccounting24 = /*#__PURE__*/React__default['default'].forwardRef(function CarbonAccounting24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$r || (_path68$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 26H23V22a2.002 2.002 0 012-2h2V18H23V16h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H25v2h4zM19 22H15a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V20A2.0023 2.0023 0 0119 22zM15 10V20h4V10zM11 22H5a2.0023 2.0023 0 01-2-2V10A2.002 2.002 0 015 8h6v2H5V20h6z"
    })), children);
  });
  var CarbonAccounting20 = /*#__PURE__*/React__default['default'].forwardRef(function CarbonAccounting20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$r || (_path69$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 26H23V22a2.002 2.002 0 012-2h2V18H23V16h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H25v2h4zM19 22H15a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V20A2.0023 2.0023 0 0119 22zM15 10V20h4V10zM11 22H5a2.0023 2.0023 0 01-2-2V10A2.002 2.002 0 015 8h6v2H5V20h6z"
    })), children);
  });
  var CarbonAccounting16 = /*#__PURE__*/React__default['default'].forwardRef(function CarbonAccounting16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$r || (_path70$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 26H23V22a2.002 2.002 0 012-2h2V18H23V16h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H25v2h4zM19 22H15a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V20A2.0023 2.0023 0 0119 22zM15 10V20h4V10zM11 22H5a2.0023 2.0023 0 01-2-2V10A2.002 2.002 0 015 8h6v2H5V20h6z"
    })), children);
  });
  var CaretDown32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretDown32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$r || (_path71$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12L16 22 8 12z"
    })), children);
  });
  var CaretDown24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretDown24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$r || (_path72$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12L16 22 8 12z"
    })), children);
  });
  var CaretDown20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretDown20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$r || (_path73$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12L16 22 8 12z"
    })), children);
  });
  var CaretDown16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretDown16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$r || (_path74$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12L16 22 8 12z"
    })), children);
  });
  var CaretDownGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CaretDownGlyph(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 8,
      height: 4,
      viewBox: "0 0 8 4",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$r || (_path75$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 0L4 4 0 0z"
    })), children);
  });
  var CaretLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretLeft32(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$r || (_path76$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24L10 16 20 8z"
    })), children);
  });
  var CaretLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretLeft24(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$r || (_path77$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24L10 16 20 8z"
    })), children);
  });
  var CaretLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretLeft20(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$r || (_path78$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24L10 16 20 8z"
    })), children);
  });
  var CaretLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretLeft16(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$r || (_path79$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24L10 16 20 8z"
    })), children);
  });
  var CaretLeftGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CaretLeftGlyph(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 5,
      height: 8,
      viewBox: "0 0 5 8",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$r || (_path80$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 8L0 4 5 0z"
    })), children);
  });
  var CaretRight32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretRight32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$r || (_path81$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8L22 16 12 24z"
    })), children);
  });
  var CaretRight24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretRight24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$r || (_path82$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8L22 16 12 24z"
    })), children);
  });
  var CaretRight20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretRight20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$r || (_path83$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8L22 16 12 24z"
    })), children);
  });
  var CaretRight16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretRight16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$r || (_path84$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8L22 16 12 24z"
    })), children);
  });
  var CaretRightGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CaretRightGlyph(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 5,
      height: 8,
      viewBox: "0 0 5 8",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$r || (_path85$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0 0L5 4 0 8z"
    })), children);
  });
  var CaretSort32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSort32(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$r || (_path86$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24zM8 8L16 0 24 8z"
    })), children);
  });
  var CaretSort24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSort24(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$r || (_path87$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24zM8 8L16 0 24 8z"
    })), children);
  });
  var CaretSort20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSort20(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$r || (_path88$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24zM8 8L16 0 24 8z"
    })), children);
  });
  var CaretSort16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSort16(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$r || (_path89$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24zM8 8L16 0 24 8z"
    })), children);
  });
  var CaretSortDown32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortDown32(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$r || (_path90$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24z"
    })), children);
  });
  var CaretSortDown24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortDown24(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$r || (_path91$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24z"
    })), children);
  });
  var CaretSortDown20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortDown20(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$r || (_path92$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24z"
    })), children);
  });
  var CaretSortDown16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortDown16(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$r || (_path93$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24L16 32 8 24z"
    })), children);
  });
  var CaretSortUp32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortUp32(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$r || (_path94$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8L16 0 24 8z"
    })), children);
  });
  var CaretSortUp24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortUp24(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$r || (_path95$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8L16 0 24 8z"
    })), children);
  });
  var CaretSortUp20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortUp20(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$r || (_path96$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8L16 0 24 8z"
    })), children);
  });
  var CaretSortUp16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretSortUp16(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$r || (_path97$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8L16 0 24 8z"
    })), children);
  });
  var CaretUp32 = /*#__PURE__*/React__default['default'].forwardRef(function CaretUp32(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$r || (_path98$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20L16 10 24 20z"
    })), children);
  });
  var CaretUp24 = /*#__PURE__*/React__default['default'].forwardRef(function CaretUp24(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$r || (_path99$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20L16 10 24 20z"
    })), children);
  });
  var CaretUp20 = /*#__PURE__*/React__default['default'].forwardRef(function CaretUp20(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$r || (_path100$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20L16 10 24 20z"
    })), children);
  });
  var CaretUp16 = /*#__PURE__*/React__default['default'].forwardRef(function CaretUp16(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$r || (_path101$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20L16 10 24 20z"
    })), children);
  });
  var CaretUpGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CaretUpGlyph(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 8,
      height: 4,
      viewBox: "0 0 8 4",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$r || (_path102$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0 4L4 0 8 4z"
    })), children);
  });
  var CarouselHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselHorizontal32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$r || (_path103$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H10a2 2 0 01-2-2V8a2 2 0 012-2H22a2 2 0 012 2V24A2 2 0 0122 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 012 2V22A2 2 0 014 24zM32 24H28a2 2 0 01-2-2V10a2 2 0 012-2h4v2H28V22h4z"
    })), children);
  });
  var CarouselHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselHorizontal24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$r || (_path104$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H10a2 2 0 01-2-2V8a2 2 0 012-2H22a2 2 0 012 2V24A2 2 0 0122 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 012 2V22A2 2 0 014 24zM32 24H28a2 2 0 01-2-2V10a2 2 0 012-2h4v2H28V22h4z"
    })), children);
  });
  var CarouselHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselHorizontal20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$r || (_path105$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H10a2 2 0 01-2-2V8a2 2 0 012-2H22a2 2 0 012 2V24A2 2 0 0122 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 012 2V22A2 2 0 014 24zM32 24H28a2 2 0 01-2-2V10a2 2 0 012-2h4v2H28V22h4z"
    })), children);
  });
  var CarouselHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselHorizontal16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$r || (_path106$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H10a2 2 0 01-2-2V8a2 2 0 012-2H22a2 2 0 012 2V24A2 2 0 0122 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 012 2V22A2 2 0 014 24zM32 24H28a2 2 0 01-2-2V10a2 2 0 012-2h4v2H28V22h4z"
    })), children);
  });
  var CarouselVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselVertical32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$r || (_path107$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10V22a2 2 0 01-2 2H8a2 2 0 01-2-2V10A2 2 0 018 8H24A2 2 0 0126 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 012-2H22A2 2 0 0124 28zM24 0V4a2 2 0 01-2 2H10A2 2 0 018 4V0h2V4H22V0z"
    })), children);
  });
  var CarouselVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselVertical24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$r || (_path108$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10V22a2 2 0 01-2 2H8a2 2 0 01-2-2V10A2 2 0 018 8H24A2 2 0 0126 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 012-2H22A2 2 0 0124 28zM24 0V4a2 2 0 01-2 2H10A2 2 0 018 4V0h2V4H22V0z"
    })), children);
  });
  var CarouselVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselVertical20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$r || (_path109$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10V22a2 2 0 01-2 2H8a2 2 0 01-2-2V10A2 2 0 018 8H24A2 2 0 0126 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 012-2H22A2 2 0 0124 28zM24 0V4a2 2 0 01-2 2H10A2 2 0 018 4V0h2V4H22V0z"
    })), children);
  });
  var CarouselVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function CarouselVertical16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$r || (_path110$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10V22a2 2 0 01-2 2H8a2 2 0 01-2-2V10A2 2 0 018 8H24A2 2 0 0126 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 012-2H22A2 2 0 0124 28zM24 0V4a2 2 0 01-2 2H10A2 2 0 018 4V0h2V4H22V0z"
    })), children);
  });
  var Catalog32 = /*#__PURE__*/React__default['default'].forwardRef(function Catalog32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$r || (_path111$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"
    })), _path112$r || (_path112$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"
    })), children);
  });
  var Catalog24 = /*#__PURE__*/React__default['default'].forwardRef(function Catalog24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$r || (_path113$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"
    })), _path114$r || (_path114$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"
    })), children);
  });
  var Catalog20 = /*#__PURE__*/React__default['default'].forwardRef(function Catalog20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$r || (_path115$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"
    })), _path116$r || (_path116$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"
    })), children);
  });
  var Catalog16 = /*#__PURE__*/React__default['default'].forwardRef(function Catalog16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$r || (_path117$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"
    })), _path118$r || (_path118$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"
    })), children);
  });
  var Categories32 = /*#__PURE__*/React__default['default'].forwardRef(function Categories32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$r || (_path119$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 002 5v9a1 1 0 001 1H13a1 1 0 001-1V7a1 1 0 00-1-1H9L8.28 4.55A1 1 0 007.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V7a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 00-1 1v9a1 1 0 001 1H13a1 1 0 001-1V20a1 1 0 00-1-1H9l-.72-1.45a1 1 0 00-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V20a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55z"
    })), children);
  });
  var Categories24 = /*#__PURE__*/React__default['default'].forwardRef(function Categories24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$r || (_path120$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 002 5v9a1 1 0 001 1H13a1 1 0 001-1V7a1 1 0 00-1-1H9L8.28 4.55A1 1 0 007.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V7a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 00-1 1v9a1 1 0 001 1H13a1 1 0 001-1V20a1 1 0 00-1-1H9l-.72-1.45a1 1 0 00-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V20a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55z"
    })), children);
  });
  var Categories20 = /*#__PURE__*/React__default['default'].forwardRef(function Categories20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$r || (_path121$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 002 5v9a1 1 0 001 1H13a1 1 0 001-1V7a1 1 0 00-1-1H9L8.28 4.55A1 1 0 007.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V7a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 00-1 1v9a1 1 0 001 1H13a1 1 0 001-1V20a1 1 0 00-1-1H9l-.72-1.45a1 1 0 00-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V20a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55z"
    })), children);
  });
  var Categories16 = /*#__PURE__*/React__default['default'].forwardRef(function Categories16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$r || (_path122$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 002 5v9a1 1 0 001 1H13a1 1 0 001-1V7a1 1 0 00-1-1H9L8.28 4.55A1 1 0 007.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V7a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 00-1 1v9a1 1 0 001 1H13a1 1 0 001-1V20a1 1 0 00-1-1H9l-.72-1.45a1 1 0 00-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 00-1 1v9a1 1 0 001 1H29a1 1 0 001-1V20a1 1 0 00-1-1H25l-.72-1.45a1 1 0 00-.9-.55z"
    })), children);
  });
  var Category32 = /*#__PURE__*/React__default['default'].forwardRef(function Category32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$r || (_path123$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var Category24 = /*#__PURE__*/React__default['default'].forwardRef(function Category24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$r || (_path124$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var Category20 = /*#__PURE__*/React__default['default'].forwardRef(function Category20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$r || (_path125$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var Category16 = /*#__PURE__*/React__default['default'].forwardRef(function Category16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$r || (_path126$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var CategoryAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAdd32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$r || (_path127$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"
    })), _path128$r || (_path128$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAdd24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$r || (_path129$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"
    })), _path130$r || (_path130$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAdd20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$r || (_path131$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"
    })), _path132$r || (_path132$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAdd16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$r || (_path133$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"
    })), _path134$r || (_path134$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryAnd32 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAnd32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$r || (_path135$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30V26H15v4h2V26H28v4h2V26a2 2 0 00-2-2H17V19H15v5H4a2 2 0 00-2 2v4zM20.6953 13.9858A10.08 10.08 0 0021.9463 10H23V8H20V9a9.2634 9.2634 0 01-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 002.1436-2.3694A3.2522 3.2522 0 0018.6062 3.81a3.38 3.38 0 00-2.2391-1.7056 3.4688 3.4688 0 00-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0011.06 13.1587 4.4526 4.4526 0 0015.4268 17h.0058a5.7844 5.7844 0 003.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0115.4141 4a2.41 2.41 0 01.5214.0581 1.4018 1.4018 0 01.9111.7022 1.2493 1.2493 0 01.0791 1.042A3.6871 3.6871 0 0115.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 01-2.3916-2.1509 2.8261 2.8261 0 011.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0115.4316 15z"
    })), children);
  });
  var CategoryAnd24 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAnd24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$r || (_path136$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30V26H15v4h2V26H28v4h2V26a2 2 0 00-2-2H17V19H15v5H4a2 2 0 00-2 2v4zM20.6953 13.9858A10.08 10.08 0 0021.9463 10H23V8H20V9a9.2634 9.2634 0 01-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 002.1436-2.3694A3.2522 3.2522 0 0018.6062 3.81a3.38 3.38 0 00-2.2391-1.7056 3.4688 3.4688 0 00-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0011.06 13.1587 4.4526 4.4526 0 0015.4268 17h.0058a5.7844 5.7844 0 003.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0115.4141 4a2.41 2.41 0 01.5214.0581 1.4018 1.4018 0 01.9111.7022 1.2493 1.2493 0 01.0791 1.042A3.6871 3.6871 0 0115.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 01-2.3916-2.1509 2.8261 2.8261 0 011.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0115.4316 15z"
    })), children);
  });
  var CategoryAnd20 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAnd20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$r || (_path137$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30V26H15v4h2V26H28v4h2V26a2 2 0 00-2-2H17V19H15v5H4a2 2 0 00-2 2v4zM20.6953 13.9858A10.08 10.08 0 0021.9463 10H23V8H20V9a9.2634 9.2634 0 01-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 002.1436-2.3694A3.2522 3.2522 0 0018.6062 3.81a3.38 3.38 0 00-2.2391-1.7056 3.4688 3.4688 0 00-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0011.06 13.1587 4.4526 4.4526 0 0015.4268 17h.0058a5.7844 5.7844 0 003.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0115.4141 4a2.41 2.41 0 01.5214.0581 1.4018 1.4018 0 01.9111.7022 1.2493 1.2493 0 01.0791 1.042A3.6871 3.6871 0 0115.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 01-2.3916-2.1509 2.8261 2.8261 0 011.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0115.4316 15z"
    })), children);
  });
  var CategoryAnd16 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryAnd16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$r || (_path138$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30V26H15v4h2V26H28v4h2V26a2 2 0 00-2-2H17V19H15v5H4a2 2 0 00-2 2v4zM20.6953 13.9858A10.08 10.08 0 0021.9463 10H23V8H20V9a9.2634 9.2634 0 01-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 002.1436-2.3694A3.2522 3.2522 0 0018.6062 3.81a3.38 3.38 0 00-2.2391-1.7056 3.4688 3.4688 0 00-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0011.06 13.1587 4.4526 4.4526 0 0015.4268 17h.0058a5.7844 5.7844 0 003.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0115.4141 4a2.41 2.41 0 01.5214.0581 1.4018 1.4018 0 01.9111.7022 1.2493 1.2493 0 01.0791 1.042A3.6871 3.6871 0 0115.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 01-2.3916-2.1509 2.8261 2.8261 0 011.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0115.4316 15z"
    })), children);
  });
  var CategoryNew32 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNew32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$r || (_path139$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path140$r || (_path140$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryNew24 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNew24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$r || (_path141$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path142$r || (_path142$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryNew20 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNew20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$r || (_path143$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path144$r || (_path144$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryNew16 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNew16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$r || (_path145$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path146$r || (_path146$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"
    })), children);
  });
  var CategoryNewEach32 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNewEach32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$r || (_path147$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H24v2h5v6H22v2h3v2.142a4 4 0 102 0V20h2a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0029 10zM28 26a2 2 0 11-2-2A2.0027 2.0027 0 0128 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 102 0V16h2a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0019 6zM18 26a2 2 0 11-2-2A2.0027 2.0027 0 0118 26zM9 2H3A2.002 2.002 0 001 4v6a2.002 2.002 0 002 2H5V22.142a4 4 0 102 0V12H9a2.002 2.002 0 002-2V4A2.002 2.002 0 009 2zM8 26a2 2 0 11-2-2A2.0023 2.0023 0 018 26zM3 10V4H9l.0015 6z"
    })), children);
  });
  var CategoryNewEach24 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNewEach24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$r || (_path148$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H24v2h5v6H22v2h3v2.142a4 4 0 102 0V20h2a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0029 10zM28 26a2 2 0 11-2-2A2.0027 2.0027 0 0128 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 102 0V16h2a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0019 6zM18 26a2 2 0 11-2-2A2.0027 2.0027 0 0118 26zM9 2H3A2.002 2.002 0 001 4v6a2.002 2.002 0 002 2H5V22.142a4 4 0 102 0V12H9a2.002 2.002 0 002-2V4A2.002 2.002 0 009 2zM8 26a2 2 0 11-2-2A2.0023 2.0023 0 018 26zM3 10V4H9l.0015 6z"
    })), children);
  });
  var CategoryNewEach20 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNewEach20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$r || (_path149$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H24v2h5v6H22v2h3v2.142a4 4 0 102 0V20h2a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0029 10zM28 26a2 2 0 11-2-2A2.0027 2.0027 0 0128 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 102 0V16h2a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0019 6zM18 26a2 2 0 11-2-2A2.0027 2.0027 0 0118 26zM9 2H3A2.002 2.002 0 001 4v6a2.002 2.002 0 002 2H5V22.142a4 4 0 102 0V12H9a2.002 2.002 0 002-2V4A2.002 2.002 0 009 2zM8 26a2 2 0 11-2-2A2.0023 2.0023 0 018 26zM3 10V4H9l.0015 6z"
    })), children);
  });
  var CategoryNewEach16 = /*#__PURE__*/React__default['default'].forwardRef(function CategoryNewEach16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$r || (_path150$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H24v2h5v6H22v2h3v2.142a4 4 0 102 0V20h2a2.0027 2.0027 0 002-2V12A2.0023 2.0023 0 0029 10zM28 26a2 2 0 11-2-2A2.0027 2.0027 0 0128 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 102 0V16h2a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0019 6zM18 26a2 2 0 11-2-2A2.0027 2.0027 0 0118 26zM9 2H3A2.002 2.002 0 001 4v6a2.002 2.002 0 002 2H5V22.142a4 4 0 102 0V12H9a2.002 2.002 0 002-2V4A2.002 2.002 0 009 2zM8 26a2 2 0 11-2-2A2.0023 2.0023 0 018 26zM3 10V4H9l.0015 6z"
    })), children);
  });
  var CautionGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CautionGlyph(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$r || (_path151$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.3154,12H3.6846L8,4.0884,12.3154,12M14,13,8,2,2,13Z"
    })), _path152$r || (_path152$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.315 12L3.685 12 8 4.088 12.315 12z"
    })), children);
  });
  var CautionInvertedGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CautionInvertedGlyph(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$r || (_path153$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14L2 3 14 3 8 14z"
    })), children);
  });
  var QCcX32 = /*#__PURE__*/React__default['default'].forwardRef(function QCcX32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$r || (_path154$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM19 23H14a2 2 0 01-2-2V15a2 2 0 012-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"
    })), children);
  });
  var QCcX24 = /*#__PURE__*/React__default['default'].forwardRef(function QCcX24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$r || (_path155$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM19 23H14a2 2 0 01-2-2V15a2 2 0 012-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"
    })), children);
  });
  var QCcX20 = /*#__PURE__*/React__default['default'].forwardRef(function QCcX20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$r || (_path156$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM19 23H14a2 2 0 01-2-2V15a2 2 0 012-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"
    })), children);
  });
  var QCcX16 = /*#__PURE__*/React__default['default'].forwardRef(function QCcX16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$r || (_path157$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM19 23H14a2 2 0 01-2-2V15a2 2 0 012-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"
    })), children);
  });
  var WatsonHealthCdArchive32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdArchive32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$r || (_path158$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"
    })), _path159$r || (_path159$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), _circle5$o || (_circle5$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var WatsonHealthCdArchive24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdArchive24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$r);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$r || (_path160$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"
    })), _path161$r || (_path161$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), _circle6$o || (_circle6$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var WatsonHealthCdArchive20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdArchive20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$r || (_path162$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"
    })), _path163$r || (_path163$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), _circle7$o || (_circle7$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var WatsonHealthCdArchive16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdArchive16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$r || (_path164$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"
    })), _path165$r || (_path165$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"
    })), _circle8$o || (_circle8$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var WatsonHealthCdCreateArchive32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateArchive32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$r || (_path166$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"
    })), _circle9$o || (_circle9$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path167$r || (_path167$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"
    })), _path168$r || (_path168$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"
    })), children);
  });
  var WatsonHealthCdCreateArchive24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateArchive24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$r || (_path169$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"
    })), _circle10$o || (_circle10$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path170$r || (_path170$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"
    })), _path171$r || (_path171$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"
    })), children);
  });
  var WatsonHealthCdCreateArchive20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateArchive20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$r || (_path172$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"
    })), _circle11$n || (_circle11$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path173$r || (_path173$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"
    })), _path174$r || (_path174$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"
    })), children);
  });
  var WatsonHealthCdCreateArchive16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateArchive16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$r || (_path175$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"
    })), _circle12$n || (_circle12$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path176$r || (_path176$r = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"
    })), _path177$q || (_path177$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"
    })), children);
  });
  var WatsonHealthCdCreateExchange32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateExchange32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$n || (_circle13$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path178$q || (_path178$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"
    })), _path179$q || (_path179$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 116-6A6 6 0 0114 20zm0-10a4 4 0 104 4A4 4 0 0014 10z"
    })), children);
  });
  var WatsonHealthCdCreateExchange24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateExchange24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$n || (_circle14$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path180$q || (_path180$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"
    })), _path181$q || (_path181$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 116-6A6 6 0 0114 20zm0-10a4 4 0 104 4A4 4 0 0014 10z"
    })), children);
  });
  var WatsonHealthCdCreateExchange20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateExchange20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$n || (_circle15$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path182$q || (_path182$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"
    })), _path183$q || (_path183$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 116-6A6 6 0 0114 20zm0-10a4 4 0 104 4A4 4 0 0014 10z"
    })), children);
  });
  var WatsonHealthCdCreateExchange16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCdCreateExchange16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$n || (_circle16$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path184$q || (_path184$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"
    })), _path185$q || (_path185$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 116-6A6 6 0 0114 20zm0-10a4 4 0 104 4A4 4 0 0014 10z"
    })), children);
  });
  var Cda32 = /*#__PURE__*/React__default['default'].forwardRef(function Cda32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$q || (_path186$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H24a2.002 2.002 0 00-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0028 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 014 4v6A4.0039 4.0039 0 0116 23zm-2-2h2a2.0027 2.0027 0 002-2V13a2.0023 2.0023 0 00-2-2H14zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cda24 = /*#__PURE__*/React__default['default'].forwardRef(function Cda24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$q || (_path187$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H24a2.002 2.002 0 00-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0028 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 014 4v6A4.0039 4.0039 0 0116 23zm-2-2h2a2.0027 2.0027 0 002-2V13a2.0023 2.0023 0 00-2-2H14zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cda20 = /*#__PURE__*/React__default['default'].forwardRef(function Cda20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$q || (_path188$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H24a2.002 2.002 0 00-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0028 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 014 4v6A4.0039 4.0039 0 0116 23zm-2-2h2a2.0027 2.0027 0 002-2V13a2.0023 2.0023 0 00-2-2H14zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Cda16 = /*#__PURE__*/React__default['default'].forwardRef(function Cda16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$q || (_path189$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H24a2.002 2.002 0 00-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0028 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 014 4v6A4.0039 4.0039 0 0116 23zm-2-2h2a2.0027 2.0027 0 002-2V13a2.0023 2.0023 0 00-2-2H14zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var CellTower32 = /*#__PURE__*/React__default['default'].forwardRef(function CellTower32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$q || (_path190$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 16 17 16 17 11 15 11 15 16 7 16 7 11 5 11 5 23 7 23 7 18 10 18 10 30 12 30 12 18 15 18 15 23 17 23 17 18 20 18 20 30 22 30 22 18 25 18 25 23 27 23 27 11zM16 6c-1.7 0-3.2.7-4.2 1.8l1.4 1.4C13.9 8.4 14.9 8 16 8s2.1.4 2.8 1.2l1.4-1.4C19.2 6.7 17.7 6 16 6z"
    })), _path191$q || (_path191$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9,4.9l1.4,1.4C11.8,4.9,13.8,4,16,4s4.2,0.9,5.7,2.3l1.4-1.4C21.3,3.1,18.8,2,16,2S10.7,3.1,8.9,4.9z"
    })), children);
  });
  var CellTower24 = /*#__PURE__*/React__default['default'].forwardRef(function CellTower24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$q || (_path192$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 16 17 16 17 11 15 11 15 16 7 16 7 11 5 11 5 23 7 23 7 18 10 18 10 30 12 30 12 18 15 18 15 23 17 23 17 18 20 18 20 30 22 30 22 18 25 18 25 23 27 23 27 11zM16 6c-1.7 0-3.2.7-4.2 1.8l1.4 1.4C13.9 8.4 14.9 8 16 8s2.1.4 2.8 1.2l1.4-1.4C19.2 6.7 17.7 6 16 6z"
    })), _path193$q || (_path193$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9,4.9l1.4,1.4C11.8,4.9,13.8,4,16,4s4.2,0.9,5.7,2.3l1.4-1.4C21.3,3.1,18.8,2,16,2S10.7,3.1,8.9,4.9z"
    })), children);
  });
  var CellTower20 = /*#__PURE__*/React__default['default'].forwardRef(function CellTower20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$q || (_path194$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 16 17 16 17 11 15 11 15 16 7 16 7 11 5 11 5 23 7 23 7 18 10 18 10 30 12 30 12 18 15 18 15 23 17 23 17 18 20 18 20 30 22 30 22 18 25 18 25 23 27 23 27 11zM16 6c-1.7 0-3.2.7-4.2 1.8l1.4 1.4C13.9 8.4 14.9 8 16 8s2.1.4 2.8 1.2l1.4-1.4C19.2 6.7 17.7 6 16 6z"
    })), _path195$q || (_path195$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9,4.9l1.4,1.4C11.8,4.9,13.8,4,16,4s4.2,0.9,5.7,2.3l1.4-1.4C21.3,3.1,18.8,2,16,2S10.7,3.1,8.9,4.9z"
    })), children);
  });
  var CellTower16 = /*#__PURE__*/React__default['default'].forwardRef(function CellTower16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$q || (_path196$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 16 17 16 17 11 15 11 15 16 7 16 7 11 5 11 5 23 7 23 7 18 10 18 10 30 12 30 12 18 15 18 15 23 17 23 17 18 20 18 20 30 22 30 22 18 25 18 25 23 27 23 27 11zM16 6c-1.7 0-3.2.7-4.2 1.8l1.4 1.4C13.9 8.4 14.9 8 16 8s2.1.4 2.8 1.2l1.4-1.4C19.2 6.7 17.7 6 16 6z"
    })), _path197$q || (_path197$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9,4.9l1.4,1.4C11.8,4.9,13.8,4,16,4s4.2,0.9,5.7,2.3l1.4-1.4C21.3,3.1,18.8,2,16,2S10.7,3.1,8.9,4.9z"
    })), children);
  });
  var CenterCircle32 = /*#__PURE__*/React__default['default'].forwardRef(function CenterCircle32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$q || (_path198$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V22H15v3.9492A10.0166,10.0166,0,0,1,6.0508,17H10V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V10h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H22v2h3.9492A10.0166,10.0166,0,0,1,17,25.9492Z"
    })), children);
  });
  var CenterCircle24 = /*#__PURE__*/React__default['default'].forwardRef(function CenterCircle24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$q || (_path199$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V22H15v3.9492A10.0166,10.0166,0,0,1,6.0508,17H10V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V10h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H22v2h3.9492A10.0166,10.0166,0,0,1,17,25.9492Z"
    })), children);
  });
  var CenterCircle20 = /*#__PURE__*/React__default['default'].forwardRef(function CenterCircle20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$q || (_path200$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V22H15v3.9492A10.0166,10.0166,0,0,1,6.0508,17H10V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V10h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H22v2h3.9492A10.0166,10.0166,0,0,1,17,25.9492Z"
    })), children);
  });
  var CenterCircle16 = /*#__PURE__*/React__default['default'].forwardRef(function CenterCircle16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$q || (_path201$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V22H15v3.9492A10.0166,10.0166,0,0,1,6.0508,17H10V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V10h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H22v2h3.9492A10.0166,10.0166,0,0,1,17,25.9492Z"
    })), children);
  });
  var CenterSquare32 = /*#__PURE__*/React__default['default'].forwardRef(function CenterSquare32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$q || (_path202$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12L4 12 4 4 12 4 12 6 6 6 6 12zM28 12L26 12 26 6 20 6 20 4 28 4 28 12zM12 28L4 28 4 20 6 20 6 26 12 26 12 28zM28 28L20 28 20 26 26 26 26 20 28 20 28 28zM15 10H17V14H15zM10 15H14V17H10zM18 15H22V17H18zM15 18H17V22H15z"
    })), children);
  });
  var CenterSquare24 = /*#__PURE__*/React__default['default'].forwardRef(function CenterSquare24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$q || (_path203$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12L4 12 4 4 12 4 12 6 6 6 6 12zM28 12L26 12 26 6 20 6 20 4 28 4 28 12zM12 28L4 28 4 20 6 20 6 26 12 26 12 28zM28 28L20 28 20 26 26 26 26 20 28 20 28 28zM15 10H17V14H15zM10 15H14V17H10zM18 15H22V17H18zM15 18H17V22H15z"
    })), children);
  });
  var CenterSquare20 = /*#__PURE__*/React__default['default'].forwardRef(function CenterSquare20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$q || (_path204$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12L4 12 4 4 12 4 12 6 6 6 6 12zM28 12L26 12 26 6 20 6 20 4 28 4 28 12zM12 28L4 28 4 20 6 20 6 26 12 26 12 28zM28 28L20 28 20 26 26 26 26 20 28 20 28 28zM15 10H17V14H15zM10 15H14V17H10zM18 15H22V17H18zM15 18H17V22H15z"
    })), children);
  });
  var CenterSquare16 = /*#__PURE__*/React__default['default'].forwardRef(function CenterSquare16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$q || (_path205$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12L4 12 4 4 12 4 12 6 6 6 6 12zM28 12L26 12 26 6 20 6 20 4 28 4 28 12zM12 28L4 28 4 20 6 20 6 26 12 26 12 28zM28 28L20 28 20 26 26 26 26 20 28 20 28 28zM15 10H17V14H15zM10 15H14V17H10zM18 15H22V17H18zM15 18H17V22H15z"
    })), children);
  });
  var CenterToFit32 = /*#__PURE__*/React__default['default'].forwardRef(function CenterToFit32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$q || (_path206$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 2L2 2 2 8 4 8 4 4 8 4 8 2zM24 2L30 2 30 8 28 8 28 4 24 4 24 2zM8 30L2 30 2 24 4 24 4 28 8 28 8 30zM24 30L30 30 30 24 28 24 28 28 24 28 24 30zM24 24H8a2.0023 2.0023 0 01-2-2V10A2.0023 2.0023 0 018 8H24a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0124 24zM8 10V22H24V10z"
    })), children);
  });
  var CenterToFit24 = /*#__PURE__*/React__default['default'].forwardRef(function CenterToFit24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$q || (_path207$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 2L2 2 2 8 4 8 4 4 8 4 8 2zM24 2L30 2 30 8 28 8 28 4 24 4 24 2zM8 30L2 30 2 24 4 24 4 28 8 28 8 30zM24 30L30 30 30 24 28 24 28 28 24 28 24 30zM24 24H8a2.0023 2.0023 0 01-2-2V10A2.0023 2.0023 0 018 8H24a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0124 24zM8 10V22H24V10z"
    })), children);
  });
  var CenterToFit20 = /*#__PURE__*/React__default['default'].forwardRef(function CenterToFit20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$q || (_path208$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 2L2 2 2 8 4 8 4 4 8 4 8 2zM24 2L30 2 30 8 28 8 28 4 24 4 24 2zM8 30L2 30 2 24 4 24 4 28 8 28 8 30zM24 30L30 30 30 24 28 24 28 28 24 28 24 30zM24 24H8a2.0023 2.0023 0 01-2-2V10A2.0023 2.0023 0 018 8H24a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0124 24zM8 10V22H24V10z"
    })), children);
  });
  var CenterToFit16 = /*#__PURE__*/React__default['default'].forwardRef(function CenterToFit16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$q || (_path209$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 2L2 2 2 8 4 8 4 4 8 4 8 2zM24 2L30 2 30 8 28 8 28 4 24 4 24 2zM8 30L2 30 2 24 4 24 4 28 8 28 8 30zM24 30L30 30 30 24 28 24 28 28 24 28 24 30zM24 24H8a2.0023 2.0023 0 01-2-2V10A2.0023 2.0023 0 018 8H24a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0124 24zM8 10V22H24V10z"
    })), children);
  });
  var Certificate32 = /*#__PURE__*/React__default['default'].forwardRef(function Certificate32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$q || (_path210$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path211$q || (_path211$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"
    })), children);
  });
  var Certificate24 = /*#__PURE__*/React__default['default'].forwardRef(function Certificate24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$q || (_path212$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path213$q || (_path213$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"
    })), children);
  });
  var Certificate20 = /*#__PURE__*/React__default['default'].forwardRef(function Certificate20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$q || (_path214$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path215$q || (_path215$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"
    })), children);
  });
  var Certificate16 = /*#__PURE__*/React__default['default'].forwardRef(function Certificate16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$q || (_path216$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path217$q || (_path217$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"
    })), children);
  });
  var CertificateCheck32 = /*#__PURE__*/React__default['default'].forwardRef(function CertificateCheck32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$q || (_path218$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path219$q || (_path219$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), _path220$q || (_path220$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"
    })), children);
  });
  var CertificateCheck24 = /*#__PURE__*/React__default['default'].forwardRef(function CertificateCheck24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$q || (_path221$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path222$q || (_path222$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), _path223$q || (_path223$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"
    })), children);
  });
  var CertificateCheck20 = /*#__PURE__*/React__default['default'].forwardRef(function CertificateCheck20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$q || (_path224$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path225$q || (_path225$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), _path226$q || (_path226$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"
    })), children);
  });
  var CertificateCheck16 = /*#__PURE__*/React__default['default'].forwardRef(function CertificateCheck16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$q || (_path227$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"
    })), _path228$q || (_path228$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), _path229$q || (_path229$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"
    })), children);
  });
  var ChangeCatalog32 = /*#__PURE__*/React__default['default'].forwardRef(function ChangeCatalog32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$q || (_path230$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24v2h2.4592A5.94 5.94 0 0122 28a6.0066 6.0066 0 01-6-6H14a7.9841 7.9841 0 0014 5.2651V30h2V24zM22 14a8.04 8.04 0 00-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0122 16a6.0066 6.0066 0 016 6h2A8.0092 8.0092 0 0022 14z"
    })), _path231$q || (_path231$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"
    })), children);
  });
  var ChangeCatalog24 = /*#__PURE__*/React__default['default'].forwardRef(function ChangeCatalog24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$q || (_path232$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24v2h2.4592A5.94 5.94 0 0122 28a6.0066 6.0066 0 01-6-6H14a7.9841 7.9841 0 0014 5.2651V30h2V24zM22 14a8.04 8.04 0 00-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0122 16a6.0066 6.0066 0 016 6h2A8.0092 8.0092 0 0022 14z"
    })), _path233$q || (_path233$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"
    })), children);
  });
  var ChangeCatalog20 = /*#__PURE__*/React__default['default'].forwardRef(function ChangeCatalog20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$q || (_path234$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24v2h2.4592A5.94 5.94 0 0122 28a6.0066 6.0066 0 01-6-6H14a7.9841 7.9841 0 0014 5.2651V30h2V24zM22 14a8.04 8.04 0 00-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0122 16a6.0066 6.0066 0 016 6h2A8.0092 8.0092 0 0022 14z"
    })), _path235$q || (_path235$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"
    })), children);
  });
  var ChangeCatalog16 = /*#__PURE__*/React__default['default'].forwardRef(function ChangeCatalog16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$q || (_path236$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 24v2h2.4592A5.94 5.94 0 0122 28a6.0066 6.0066 0 01-6-6H14a7.9841 7.9841 0 0014 5.2651V30h2V24zM22 14a8.04 8.04 0 00-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0122 16a6.0066 6.0066 0 016 6h2A8.0092 8.0092 0 0022 14z"
    })), _path237$q || (_path237$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"
    })), children);
  });
  var CharacterPatterns32 = /*#__PURE__*/React__default['default'].forwardRef(function CharacterPatterns32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$q || (_path238$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 016 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0126 6zM8 2H3V4H8V6H4A2 2 0 002 8v2a2 2 0 002 2h6V4A2.0023 2.0023 0 008 2zm0 8H4V8H8z"
    })), children);
  });
  var CharacterPatterns24 = /*#__PURE__*/React__default['default'].forwardRef(function CharacterPatterns24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$q || (_path239$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 016 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0126 6zM8 2H3V4H8V6H4A2 2 0 002 8v2a2 2 0 002 2h6V4A2.0023 2.0023 0 008 2zm0 8H4V8H8z"
    })), children);
  });
  var CharacterPatterns20 = /*#__PURE__*/React__default['default'].forwardRef(function CharacterPatterns20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$q || (_path240$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 016 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0126 6zM8 2H3V4H8V6H4A2 2 0 002 8v2a2 2 0 002 2h6V4A2.0023 2.0023 0 008 2zm0 8H4V8H8z"
    })), children);
  });
  var CharacterPatterns16 = /*#__PURE__*/React__default['default'].forwardRef(function CharacterPatterns16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$q || (_path241$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 016 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0126 6zM8 2H3V4H8V6H4A2 2 0 002 8v2a2 2 0 002 2h6V4A2.0023 2.0023 0 008 2zm0 8H4V8H8z"
    })), children);
  });
  var ChargingStation32 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStation32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$q || (_path242$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"
    })), _path243$q || (_path243$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"
    })), children);
  });
  var ChargingStation24 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStation24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$q || (_path244$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"
    })), _path245$q || (_path245$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"
    })), children);
  });
  var ChargingStation20 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStation20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$q || (_path246$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"
    })), _path247$q || (_path247$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"
    })), children);
  });
  var ChargingStation16 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStation16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$q || (_path248$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"
    })), _path249$q || (_path249$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"
    })), children);
  });
  var ChargingStationFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStationFilled32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$q || (_path250$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"
    })), _path251$q || (_path251$q = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var ChargingStationFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStationFilled24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$q || (_path252$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"
    })), _path253$q || (_path253$q = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var ChargingStationFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStationFilled20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$q || (_path254$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"
    })), _path255$q || (_path255$q = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var ChargingStationFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ChargingStationFilled16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$q || (_path256$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"
    })), _path257$q || (_path257$q = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var Chart_3D32 = /*#__PURE__*/React__default['default'].forwardRef(function Chart_3D32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$q || (_path258$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,23v3.5859l-5-5V15a1,1,0,0,0-.5527-.8945L17,11.3818V5.8281l2.5859,2.586L21,7,16,2,11,7l1.4141,1.4141L15,5.8281v5.5537L9.5527,14.1055A1,1,0,0,0,9,15v6.5859l-5,5V23H2v7H9V28H5.4141l4.7832-4.7832,5.3554,2.6777a1.001,1.001,0,0,0,.8946,0l5.3554-2.6777L26.5859,28H23v2h7V23Zm-13,.3818-4-2V16.6182l4,2Zm1-6.5L12.2363,15,16,13.1182,19.7637,15Zm5,4.5-4,2V18.6182l4-2Z"
    })), children);
  });
  var Chart_3D24 = /*#__PURE__*/React__default['default'].forwardRef(function Chart_3D24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$q || (_path259$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,23v3.5859l-5-5V15a1,1,0,0,0-.5527-.8945L17,11.3818V5.8281l2.5859,2.586L21,7,16,2,11,7l1.4141,1.4141L15,5.8281v5.5537L9.5527,14.1055A1,1,0,0,0,9,15v6.5859l-5,5V23H2v7H9V28H5.4141l4.7832-4.7832,5.3554,2.6777a1.001,1.001,0,0,0,.8946,0l5.3554-2.6777L26.5859,28H23v2h7V23Zm-13,.3818-4-2V16.6182l4,2Zm1-6.5L12.2363,15,16,13.1182,19.7637,15Zm5,4.5-4,2V18.6182l4-2Z"
    })), children);
  });
  var Chart_3D20 = /*#__PURE__*/React__default['default'].forwardRef(function Chart_3D20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$q || (_path260$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,23v3.5859l-5-5V15a1,1,0,0,0-.5527-.8945L17,11.3818V5.8281l2.5859,2.586L21,7,16,2,11,7l1.4141,1.4141L15,5.8281v5.5537L9.5527,14.1055A1,1,0,0,0,9,15v6.5859l-5,5V23H2v7H9V28H5.4141l4.7832-4.7832,5.3554,2.6777a1.001,1.001,0,0,0,.8946,0l5.3554-2.6777L26.5859,28H23v2h7V23Zm-13,.3818-4-2V16.6182l4,2Zm1-6.5L12.2363,15,16,13.1182,19.7637,15Zm5,4.5-4,2V18.6182l4-2Z"
    })), children);
  });
  var Chart_3D16 = /*#__PURE__*/React__default['default'].forwardRef(function Chart_3D16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$q || (_path261$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,23v3.5859l-5-5V15a1,1,0,0,0-.5527-.8945L17,11.3818V5.8281l2.5859,2.586L21,7,16,2,11,7l1.4141,1.4141L15,5.8281v5.5537L9.5527,14.1055A1,1,0,0,0,9,15v6.5859l-5,5V23H2v7H9V28H5.4141l4.7832-4.7832,5.3554,2.6777a1.001,1.001,0,0,0,.8946,0l5.3554-2.6777L26.5859,28H23v2h7V23Zm-13,.3818-4-2V16.6182l4,2Zm1-6.5L12.2363,15,16,13.1182,19.7637,15Zm5,4.5-4,2V18.6182l4-2Z"
    })), children);
  });
  var ChartArea32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartArea32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$q || (_path262$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4761,8.0151,13.4473,4.2109a2.0076,2.0076,0,0,0-2.1158.2051L4,10.001V2H2V28a2,2,0,0,0,2,2H30V5.7354ZM28,20.209l-7.62,1.8022-7.0288-2.8838a1.99,1.99,0,0,0-2.022.37L4,25.8359v-4.455l8.375-9.4,7.0186,5.62a2.0155,2.0155,0,0,0,2.0459.2119L28,14.6025ZM12.5239,5.9849l7.03,3.8042a2.012,2.012,0,0,0,1.3408.16L28,8.2646v4.1138L20.6187,16.02,13.6,10.4a1.99,1.99,0,0,0-2.6885.2642L4,18.3838v-5.87ZM4.5513,28,12.62,20.9888l7.0288,2.8838a1.9977,1.9977,0,0,0,1.147.0771L28,22.2612V28Z"
    })), children);
  });
  var ChartArea24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartArea24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$q || (_path263$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4761,8.0151,13.4473,4.2109a2.0076,2.0076,0,0,0-2.1158.2051L4,10.001V2H2V28a2,2,0,0,0,2,2H30V5.7354ZM28,20.209l-7.62,1.8022-7.0288-2.8838a1.99,1.99,0,0,0-2.022.37L4,25.8359v-4.455l8.375-9.4,7.0186,5.62a2.0155,2.0155,0,0,0,2.0459.2119L28,14.6025ZM12.5239,5.9849l7.03,3.8042a2.012,2.012,0,0,0,1.3408.16L28,8.2646v4.1138L20.6187,16.02,13.6,10.4a1.99,1.99,0,0,0-2.6885.2642L4,18.3838v-5.87ZM4.5513,28,12.62,20.9888l7.0288,2.8838a1.9977,1.9977,0,0,0,1.147.0771L28,22.2612V28Z"
    })), children);
  });
  var ChartArea20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartArea20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$q || (_path264$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4761,8.0151,13.4473,4.2109a2.0076,2.0076,0,0,0-2.1158.2051L4,10.001V2H2V28a2,2,0,0,0,2,2H30V5.7354ZM28,20.209l-7.62,1.8022-7.0288-2.8838a1.99,1.99,0,0,0-2.022.37L4,25.8359v-4.455l8.375-9.4,7.0186,5.62a2.0155,2.0155,0,0,0,2.0459.2119L28,14.6025ZM12.5239,5.9849l7.03,3.8042a2.012,2.012,0,0,0,1.3408.16L28,8.2646v4.1138L20.6187,16.02,13.6,10.4a1.99,1.99,0,0,0-2.6885.2642L4,18.3838v-5.87ZM4.5513,28,12.62,20.9888l7.0288,2.8838a1.9977,1.9977,0,0,0,1.147.0771L28,22.2612V28Z"
    })), children);
  });
  var ChartArea16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartArea16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$q || (_path265$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4761,8.0151,13.4473,4.2109a2.0076,2.0076,0,0,0-2.1158.2051L4,10.001V2H2V28a2,2,0,0,0,2,2H30V5.7354ZM28,20.209l-7.62,1.8022-7.0288-2.8838a1.99,1.99,0,0,0-2.022.37L4,25.8359v-4.455l8.375-9.4,7.0186,5.62a2.0155,2.0155,0,0,0,2.0459.2119L28,14.6025ZM12.5239,5.9849l7.03,3.8042a2.012,2.012,0,0,0,1.3408.16L28,8.2646v4.1138L20.6187,16.02,13.6,10.4a1.99,1.99,0,0,0-2.6885.2642L4,18.3838v-5.87ZM4.5513,28,12.62,20.9888l7.0288,2.8838a1.9977,1.9977,0,0,0,1.147.0771L28,22.2612V28Z"
    })), children);
  });
  var ChartAreaSmooth32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaSmooth32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$q || (_path266$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.6143l-1.3152.4365A20.9218,20.9218,0,0,1,23,8c-1.7344,0-3.3225-.9072-5.0039-1.8682C16.1621,5.084,14.2656,4,12,4,9.123,4,5.9146,6.2061,4,7.772V2H2V28a2.0025,2.0025,0,0,0,2,2H30ZM4,20.2944C5.874,17.3765,9.56,13,12,13c1.6379,0,2.96,1.1016,4.36,2.2686C17.8965,16.5488,19.6379,18,22,18a9.4686,9.4686,0,0,0,6-2.5288v4.9556A13.0026,13.0026,0,0,1,22,22a13.8619,13.8619,0,0,1-4.6838-.9487A15.682,15.682,0,0,0,12,20c-2.927,0-6.0676,2.959-8,5.1577ZM12,6c1.7344,0,3.3225.9072,5.0039,1.8682C18.8379,8.916,20.7344,10,23,10a21.432,21.432,0,0,0,5-.6782v3.3213C27.3167,13.4463,24.9155,16,22,16c-1.6379,0-2.96-1.1016-4.36-2.2686C16.1035,12.4512,14.3621,11,12,11c-2.9358,0-6.0632,3.3394-8,5.8447V10.4238C5.5461,8.9658,9.2588,6,12,6ZM4.249,28C5.8623,25.9087,9.41,22,12,22a13.8619,13.8619,0,0,1,4.6838.9487A15.682,15.682,0,0,0,22,24a14.7362,14.7362,0,0,0,6-1.34V28Z"
    })), children);
  });
  var ChartAreaSmooth24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaSmooth24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$q || (_path267$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.6143l-1.3152.4365A20.9218,20.9218,0,0,1,23,8c-1.7344,0-3.3225-.9072-5.0039-1.8682C16.1621,5.084,14.2656,4,12,4,9.123,4,5.9146,6.2061,4,7.772V2H2V28a2.0025,2.0025,0,0,0,2,2H30ZM4,20.2944C5.874,17.3765,9.56,13,12,13c1.6379,0,2.96,1.1016,4.36,2.2686C17.8965,16.5488,19.6379,18,22,18a9.4686,9.4686,0,0,0,6-2.5288v4.9556A13.0026,13.0026,0,0,1,22,22a13.8619,13.8619,0,0,1-4.6838-.9487A15.682,15.682,0,0,0,12,20c-2.927,0-6.0676,2.959-8,5.1577ZM12,6c1.7344,0,3.3225.9072,5.0039,1.8682C18.8379,8.916,20.7344,10,23,10a21.432,21.432,0,0,0,5-.6782v3.3213C27.3167,13.4463,24.9155,16,22,16c-1.6379,0-2.96-1.1016-4.36-2.2686C16.1035,12.4512,14.3621,11,12,11c-2.9358,0-6.0632,3.3394-8,5.8447V10.4238C5.5461,8.9658,9.2588,6,12,6ZM4.249,28C5.8623,25.9087,9.41,22,12,22a13.8619,13.8619,0,0,1,4.6838.9487A15.682,15.682,0,0,0,22,24a14.7362,14.7362,0,0,0,6-1.34V28Z"
    })), children);
  });
  var ChartAreaSmooth20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaSmooth20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$q || (_path268$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.6143l-1.3152.4365A20.9218,20.9218,0,0,1,23,8c-1.7344,0-3.3225-.9072-5.0039-1.8682C16.1621,5.084,14.2656,4,12,4,9.123,4,5.9146,6.2061,4,7.772V2H2V28a2.0025,2.0025,0,0,0,2,2H30ZM4,20.2944C5.874,17.3765,9.56,13,12,13c1.6379,0,2.96,1.1016,4.36,2.2686C17.8965,16.5488,19.6379,18,22,18a9.4686,9.4686,0,0,0,6-2.5288v4.9556A13.0026,13.0026,0,0,1,22,22a13.8619,13.8619,0,0,1-4.6838-.9487A15.682,15.682,0,0,0,12,20c-2.927,0-6.0676,2.959-8,5.1577ZM12,6c1.7344,0,3.3225.9072,5.0039,1.8682C18.8379,8.916,20.7344,10,23,10a21.432,21.432,0,0,0,5-.6782v3.3213C27.3167,13.4463,24.9155,16,22,16c-1.6379,0-2.96-1.1016-4.36-2.2686C16.1035,12.4512,14.3621,11,12,11c-2.9358,0-6.0632,3.3394-8,5.8447V10.4238C5.5461,8.9658,9.2588,6,12,6ZM4.249,28C5.8623,25.9087,9.41,22,12,22a13.8619,13.8619,0,0,1,4.6838.9487A15.682,15.682,0,0,0,22,24a14.7362,14.7362,0,0,0,6-1.34V28Z"
    })), children);
  });
  var ChartAreaSmooth16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaSmooth16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$q || (_path269$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.6143l-1.3152.4365A20.9218,20.9218,0,0,1,23,8c-1.7344,0-3.3225-.9072-5.0039-1.8682C16.1621,5.084,14.2656,4,12,4,9.123,4,5.9146,6.2061,4,7.772V2H2V28a2.0025,2.0025,0,0,0,2,2H30ZM4,20.2944C5.874,17.3765,9.56,13,12,13c1.6379,0,2.96,1.1016,4.36,2.2686C17.8965,16.5488,19.6379,18,22,18a9.4686,9.4686,0,0,0,6-2.5288v4.9556A13.0026,13.0026,0,0,1,22,22a13.8619,13.8619,0,0,1-4.6838-.9487A15.682,15.682,0,0,0,12,20c-2.927,0-6.0676,2.959-8,5.1577ZM12,6c1.7344,0,3.3225.9072,5.0039,1.8682C18.8379,8.916,20.7344,10,23,10a21.432,21.432,0,0,0,5-.6782v3.3213C27.3167,13.4463,24.9155,16,22,16c-1.6379,0-2.96-1.1016-4.36-2.2686C16.1035,12.4512,14.3621,11,12,11c-2.9358,0-6.0632,3.3394-8,5.8447V10.4238C5.5461,8.9658,9.2588,6,12,6ZM4.249,28C5.8623,25.9087,9.41,22,12,22a13.8619,13.8619,0,0,1,4.6838.9487A15.682,15.682,0,0,0,22,24a14.7362,14.7362,0,0,0,6-1.34V28Z"
    })), children);
  });
  var ChartAreaStepper32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaStepper32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$q || (_path270$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10V6H10v6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V10ZM12,14V8h8v4h8V22H22V16H12v6H4V14ZM4,28V24H14V18h6v6h8v4Z"
    })), children);
  });
  var ChartAreaStepper24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaStepper24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$q || (_path271$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10V6H10v6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V10ZM12,14V8h8v4h8V22H22V16H12v6H4V14ZM4,28V24H14V18h6v6h8v4Z"
    })), children);
  });
  var ChartAreaStepper20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaStepper20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$q || (_path272$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10V6H10v6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V10ZM12,14V8h8v4h8V22H22V16H12v6H4V14ZM4,28V24H14V18h6v6h8v4Z"
    })), children);
  });
  var ChartAreaStepper16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAreaStepper16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$q || (_path273$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10V6H10v6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V10ZM12,14V8h8v4h8V22H22V16H12v6H4V14ZM4,28V24H14V18h6v6h8v4Z"
    })), children);
  });
  var ChartAverage32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAverage32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$q || (_path274$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24c-3.5991,0-5.0293-4.1758-6.4126-8.2139C15.2764,11.9583,13.92,8,11,8a3.44,3.44,0,0,0-3.0532,2.3215L6.0513,9.6838C6.1016,9.5334,7.3218,6,11,6c4.3491,0,6.0122,4.8547,7.48,9.1379C19.6885,18.6667,20.83,22,23,22a3.44,3.44,0,0,0,3.0532-2.3215l1.8955.6377C27.8984,20.4666,26.6782,24,23,24Z"
    })), _path275$q || (_path275$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V17H6V15H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path276$q || (_path276$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H10V17H8zM12 15H14V17H12zM20 15H22V17H20zM24 15H26V17H24zM28 15H30V17H28z"
    })), children);
  });
  var ChartAverage24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAverage24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$q || (_path277$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24c-3.5991,0-5.0293-4.1758-6.4126-8.2139C15.2764,11.9583,13.92,8,11,8a3.44,3.44,0,0,0-3.0532,2.3215L6.0513,9.6838C6.1016,9.5334,7.3218,6,11,6c4.3491,0,6.0122,4.8547,7.48,9.1379C19.6885,18.6667,20.83,22,23,22a3.44,3.44,0,0,0,3.0532-2.3215l1.8955.6377C27.8984,20.4666,26.6782,24,23,24Z"
    })), _path278$q || (_path278$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V17H6V15H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path279$q || (_path279$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H10V17H8zM12 15H14V17H12zM20 15H22V17H20zM24 15H26V17H24zM28 15H30V17H28z"
    })), children);
  });
  var ChartAverage20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAverage20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path280$q || (_path280$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24c-3.5991,0-5.0293-4.1758-6.4126-8.2139C15.2764,11.9583,13.92,8,11,8a3.44,3.44,0,0,0-3.0532,2.3215L6.0513,9.6838C6.1016,9.5334,7.3218,6,11,6c4.3491,0,6.0122,4.8547,7.48,9.1379C19.6885,18.6667,20.83,22,23,22a3.44,3.44,0,0,0,3.0532-2.3215l1.8955.6377C27.8984,20.4666,26.6782,24,23,24Z"
    })), _path281$q || (_path281$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V17H6V15H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path282$q || (_path282$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H10V17H8zM12 15H14V17H12zM20 15H22V17H20zM24 15H26V17H24zM28 15H30V17H28z"
    })), children);
  });
  var ChartAverage16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartAverage16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$q || (_path283$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24c-3.5991,0-5.0293-4.1758-6.4126-8.2139C15.2764,11.9583,13.92,8,11,8a3.44,3.44,0,0,0-3.0532,2.3215L6.0513,9.6838C6.1016,9.5334,7.3218,6,11,6c4.3491,0,6.0122,4.8547,7.48,9.1379C19.6885,18.6667,20.83,22,23,22a3.44,3.44,0,0,0,3.0532-2.3215l1.8955.6377C27.8984,20.4666,26.6782,24,23,24Z"
    })), _path284$q || (_path284$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V17H6V15H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path285$q || (_path285$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H10V17H8zM12 15H14V17H12zM20 15H22V17H20zM24 15H26V17H24zM28 15H30V17H28z"
    })), children);
  });
  var ChartBar32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBar32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$q || (_path286$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBar24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBar24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$q || (_path287$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBar20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBar20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$q || (_path288$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBar16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBar16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$q || (_path289$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBarFloating32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarFloating32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$q || (_path290$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24H14V16H28zM16 22H26V18H16zM26 12H8V4H26zM10 10H24V6H10z"
    })), _path291$q || (_path291$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartBarFloating24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarFloating24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$q || (_path292$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24H14V16H28zM16 22H26V18H16zM26 12H8V4H26zM10 10H24V6H10z"
    })), _path293$q || (_path293$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartBarFloating20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarFloating20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$q || (_path294$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24H14V16H28zM16 22H26V18H16zM26 12H8V4H26zM10 10H24V6H10z"
    })), _path295$q || (_path295$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartBarFloating16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarFloating16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$q || (_path296$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24H14V16H28zM16 22H26V18H16zM26 12H8V4H26zM10 10H24V6H10z"
    })), _path297$q || (_path297$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartBarOverlay32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarOverlay32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$q || (_path298$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H26V16H4V14H18V4H4V2H2V28a2,2,0,0,0,2,2H30V28ZM24,18v6H4V22H20V20H4V18ZM16,6v6H4V10h8V8H4V6Z"
    })), children);
  });
  var ChartBarOverlay24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarOverlay24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$q || (_path299$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H26V16H4V14H18V4H4V2H2V28a2,2,0,0,0,2,2H30V28ZM24,18v6H4V22H20V20H4V18ZM16,6v6H4V10h8V8H4V6Z"
    })), children);
  });
  var ChartBarOverlay20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarOverlay20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$q || (_path300$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H26V16H4V14H18V4H4V2H2V28a2,2,0,0,0,2,2H30V28ZM24,18v6H4V22H20V20H4V18ZM16,6v6H4V10h8V8H4V6Z"
    })), children);
  });
  var ChartBarOverlay16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarOverlay16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$q || (_path301$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H26V16H4V14H18V4H4V2H2V28a2,2,0,0,0,2,2H30V28ZM24,18v6H4V22H20V20H4V18ZM16,6v6H4V10h8V8H4V6Z"
    })), children);
  });
  var ChartBarStacked32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarStacked32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$q || (_path302$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25H26V17H4V13H18V5H4V2H2V28a2,2,0,0,0,2,2H30V28Zm20-5H14V19H24ZM16,11H10V7h6Z"
    })), children);
  });
  var ChartBarStacked24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarStacked24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$q || (_path303$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25H26V17H4V13H18V5H4V2H2V28a2,2,0,0,0,2,2H30V28Zm20-5H14V19H24ZM16,11H10V7h6Z"
    })), children);
  });
  var ChartBarStacked20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarStacked20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$q || (_path304$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25H26V17H4V13H18V5H4V2H2V28a2,2,0,0,0,2,2H30V28Zm20-5H14V19H24ZM16,11H10V7h6Z"
    })), children);
  });
  var ChartBarStacked16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarStacked16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$q || (_path305$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25H26V17H4V13H18V5H4V2H2V28a2,2,0,0,0,2,2H30V28Zm20-5H14V19H24ZM16,11H10V7h6Z"
    })), children);
  });
  var ChartBarTarget32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarTarget32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$q || (_path306$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H30V25H28zM20 5H22V13H20z"
    })), _path307$q || (_path307$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBarTarget24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarTarget24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$q || (_path308$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H30V25H28zM20 5H22V13H20z"
    })), _path309$q || (_path309$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBarTarget20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarTarget20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$q || (_path310$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H30V25H28zM20 5H22V13H20z"
    })), _path311$q || (_path311$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBarTarget16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBarTarget16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$q || (_path312$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H30V25H28zM20 5H22V13H20z"
    })), _path313$q || (_path313$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2H2V28a2,2,0,0,0,2,2H30V28H4V25H26V17H4V13H18V5H4ZM24,19v4H4V19ZM16,7v4H4V7Z"
    })), children);
  });
  var ChartBubble32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubble32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$q || (_path314$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path315$q || (_path315$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4 4 4 0 00-4-4zM21 6a4 4 0 11-4 4 4 4 0 014-4m0-2a6 6 0 106 6 6 6 0 00-6-6zM24.5 21A1.5 1.5 0 1123 22.5 1.5 1.5 0 0124.5 21m0-2A3.5 3.5 0 1028 22.5 3.5 3.5 0 0024.5 19z"
    })), children);
  });
  var ChartBubble24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubble24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$q || (_path316$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path317$q || (_path317$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4 4 4 0 00-4-4zM21 6a4 4 0 11-4 4 4 4 0 014-4m0-2a6 6 0 106 6 6 6 0 00-6-6zM24.5 21A1.5 1.5 0 1123 22.5 1.5 1.5 0 0124.5 21m0-2A3.5 3.5 0 1028 22.5 3.5 3.5 0 0024.5 19z"
    })), children);
  });
  var ChartBubble20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubble20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$q || (_path318$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path319$q || (_path319$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4 4 4 0 00-4-4zM21 6a4 4 0 11-4 4 4 4 0 014-4m0-2a6 6 0 106 6 6 6 0 00-6-6zM24.5 21A1.5 1.5 0 1123 22.5 1.5 1.5 0 0124.5 21m0-2A3.5 3.5 0 1028 22.5 3.5 3.5 0 0024.5 19z"
    })), children);
  });
  var ChartBubble16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubble16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$q || (_path320$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path321$q || (_path321$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4 4 4 0 00-4-4zM21 6a4 4 0 11-4 4 4 4 0 014-4m0-2a6 6 0 106 6 6 6 0 00-6-6zM24.5 21A1.5 1.5 0 1123 22.5 1.5 1.5 0 0124.5 21m0-2A3.5 3.5 0 1028 22.5 3.5 3.5 0 0024.5 19z"
    })), children);
  });
  var ChartBubblePacked32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubblePacked32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$q || (_path322$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5322,17.1724A8.99,8.99,0,1,0,13.6074,5.88,5.9969,5.9969,0,1,0,5.051,13.2217a6.9967,6.9967,0,1,0,7.9942,11.4844A5.9981,5.9981,0,0,0,25,24c0-.1216-.011-.24-.0181-.3594a3.4873,3.4873,0,1,0,2.55-6.4682ZM21,4a7,7,0,1,1-7,7A7.0078,7.0078,0,0,1,21,4ZM8,4A4,4,0,1,1,4,8,4.0045,4.0045,0,0,1,8,4ZM19,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,28Z"
    })), children);
  });
  var ChartBubblePacked24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubblePacked24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$q || (_path323$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5322,17.1724A8.99,8.99,0,1,0,13.6074,5.88,5.9969,5.9969,0,1,0,5.051,13.2217a6.9967,6.9967,0,1,0,7.9942,11.4844A5.9981,5.9981,0,0,0,25,24c0-.1216-.011-.24-.0181-.3594a3.4873,3.4873,0,1,0,2.55-6.4682ZM21,4a7,7,0,1,1-7,7A7.0078,7.0078,0,0,1,21,4ZM8,4A4,4,0,1,1,4,8,4.0045,4.0045,0,0,1,8,4ZM19,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,28Z"
    })), children);
  });
  var ChartBubblePacked20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubblePacked20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$q || (_path324$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5322,17.1724A8.99,8.99,0,1,0,13.6074,5.88,5.9969,5.9969,0,1,0,5.051,13.2217a6.9967,6.9967,0,1,0,7.9942,11.4844A5.9981,5.9981,0,0,0,25,24c0-.1216-.011-.24-.0181-.3594a3.4873,3.4873,0,1,0,2.55-6.4682ZM21,4a7,7,0,1,1-7,7A7.0078,7.0078,0,0,1,21,4ZM8,4A4,4,0,1,1,4,8,4.0045,4.0045,0,0,1,8,4ZM19,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,28Z"
    })), children);
  });
  var ChartBubblePacked16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBubblePacked16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$q || (_path325$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.5322,17.1724A8.99,8.99,0,1,0,13.6074,5.88,5.9969,5.9969,0,1,0,5.051,13.2217a6.9967,6.9967,0,1,0,7.9942,11.4844A5.9981,5.9981,0,0,0,25,24c0-.1216-.011-.24-.0181-.3594a3.4873,3.4873,0,1,0,2.55-6.4682ZM21,4a7,7,0,1,1-7,7A7.0078,7.0078,0,0,1,21,4ZM8,4A4,4,0,1,1,4,8,4.0045,4.0045,0,0,1,8,4ZM19,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,28Z"
    })), children);
  });
  var ChartBullet32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBullet32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$q || (_path326$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 22H16V21H14v1H2v6H14v1h2V28H30zM4 26V24H14v2zm24 0H16V24H28zM30 13H24V12H22v1H2v6H22v1h2V19h6zM4 17V15H22v2zm24 0H24V15h4zM30 4H10V3H8V4H2v6H8v1h2V10H30zM4 8V6H8V8zM28 8H10V6H28z"
    })), children);
  });
  var ChartBullet24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBullet24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$q || (_path327$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 22H16V21H14v1H2v6H14v1h2V28H30zM4 26V24H14v2zm24 0H16V24H28zM30 13H24V12H22v1H2v6H22v1h2V19h6zM4 17V15H22v2zm24 0H24V15h4zM30 4H10V3H8V4H2v6H8v1h2V10H30zM4 8V6H8V8zM28 8H10V6H28z"
    })), children);
  });
  var ChartBullet20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBullet20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$q || (_path328$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 22H16V21H14v1H2v6H14v1h2V28H30zM4 26V24H14v2zm24 0H16V24H28zM30 13H24V12H22v1H2v6H22v1h2V19h6zM4 17V15H22v2zm24 0H24V15h4zM30 4H10V3H8V4H2v6H8v1h2V10H30zM4 8V6H8V8zM28 8H10V6H28z"
    })), children);
  });
  var ChartBullet16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartBullet16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$q || (_path329$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 22H16V21H14v1H2v6H14v1h2V28H30zM4 26V24H14v2zm24 0H16V24H28zM30 13H24V12H22v1H2v6H22v1h2V19h6zM4 17V15H22v2zm24 0H24V15h4zM30 4H10V3H8V4H2v6H8v1h2V10H30zM4 8V6H8V8zM28 8H10V6H28z"
    })), children);
  });
  var ChartCandlestick32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCandlestick32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$q || (_path330$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H24V6H22v4H20V22h2v4h2V22h2zM24 20H22V12h2zM14 8H12V4H10V8H8V18h2v4h2V18h2zm-2 8H10V10h2z"
    })), _path331$q || (_path331$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartCandlestick24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCandlestick24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$q || (_path332$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H24V6H22v4H20V22h2v4h2V22h2zM24 20H22V12h2zM14 8H12V4H10V8H8V18h2v4h2V18h2zm-2 8H10V10h2z"
    })), _path333$q || (_path333$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartCandlestick20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCandlestick20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$q || (_path334$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H24V6H22v4H20V22h2v4h2V22h2zM24 20H22V12h2zM14 8H12V4H10V8H8V18h2v4h2V18h2zm-2 8H10V10h2z"
    })), _path335$q || (_path335$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartCandlestick16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCandlestick16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$q || (_path336$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H24V6H22v4H20V22h2v4h2V22h2zM24 20H22V12h2zM14 8H12V4H10V8H8V18h2v4h2V18h2zm-2 8H10V10h2z"
    })), _path337$q || (_path337$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartClusterBar32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartClusterBar32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$p || (_path338$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path339$p || (_path339$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H12V26H10zM7 22H9V26H7zM26 8H28V26H26zM23 14H25V26H23z"
    })), _path340$p || (_path340$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V26H15z",
      transform: "rotate(-180 16 19)"
    })), _path341$p || (_path341$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 18H20V26H18z",
      transform: "rotate(-180 19 22)"
    })), children);
  });
  var ChartClusterBar24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartClusterBar24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$p || (_path342$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path343$p || (_path343$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H12V26H10zM7 22H9V26H7zM26 8H28V26H26zM23 14H25V26H23z"
    })), _path344$p || (_path344$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V26H15z",
      transform: "rotate(-180 16 19)"
    })), _path345$p || (_path345$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 18H20V26H18z",
      transform: "rotate(-180 19 22)"
    })), children);
  });
  var ChartClusterBar20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartClusterBar20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$p || (_path346$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path347$p || (_path347$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H12V26H10zM7 22H9V26H7zM26 8H28V26H26zM23 14H25V26H23z"
    })), _path348$p || (_path348$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V26H15z",
      transform: "rotate(-180 16 19)"
    })), _path349$p || (_path349$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 18H20V26H18z",
      transform: "rotate(-180 19 22)"
    })), children);
  });
  var ChartClusterBar16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartClusterBar16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$p || (_path350$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path351$p || (_path351$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H12V26H10zM7 22H9V26H7zM26 8H28V26H26zM23 14H25V26H23z"
    })), _path352$p || (_path352$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V26H15z",
      transform: "rotate(-180 16 19)"
    })), _path353$p || (_path353$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 18H20V26H18z",
      transform: "rotate(-180 19 22)"
    })), children);
  });
  var ChartColumn32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumn32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$p || (_path354$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"
    })), children);
  });
  var ChartColumn24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumn24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$o || (_path355$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"
    })), children);
  });
  var ChartColumn20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumn20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$o || (_path356$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"
    })), children);
  });
  var ChartColumn16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumn16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$o || (_path357$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"
    })), children);
  });
  var ChartColumnFloating32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnFloating32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$o || (_path358$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H20V4h8zm-6-2h4V6H22zM16 24H8V10h8zm-6-2h4V12H10z"
    })), _path359$o || (_path359$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0021,2.0021,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartColumnFloating24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnFloating24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$o || (_path360$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H20V4h8zm-6-2h4V6H22zM16 24H8V10h8zm-6-2h4V12H10z"
    })), _path361$n || (_path361$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0021,2.0021,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartColumnFloating20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnFloating20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$n || (_path362$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H20V4h8zm-6-2h4V6H22zM16 24H8V10h8zm-6-2h4V12H10z"
    })), _path363$l || (_path363$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0021,2.0021,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartColumnFloating16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnFloating16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$l || (_path364$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H20V4h8zm-6-2h4V6H22zM16 24H8V10h8zm-6-2h4V12H10z"
    })), _path365$l || (_path365$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0021,2.0021,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartColumnTarget32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnTarget32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$l || (_path366$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28V6H19V28H15V14H7V28H4V2H2V28a2 2 0 002 2H30V28zM13 28H9V16h4zm12 0H21V8h4zM19 2H27V4H19z"
    })), _path367$l || (_path367$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 10H15V12H7z"
    })), children);
  });
  var ChartColumnTarget24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnTarget24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$l || (_path368$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28V6H19V28H15V14H7V28H4V2H2V28a2 2 0 002 2H30V28zM13 28H9V16h4zm12 0H21V8h4zM19 2H27V4H19z"
    })), _path369$l || (_path369$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 10H15V12H7z"
    })), children);
  });
  var ChartColumnTarget20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnTarget20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$l || (_path370$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28V6H19V28H15V14H7V28H4V2H2V28a2 2 0 002 2H30V28zM13 28H9V16h4zm12 0H21V8h4zM19 2H27V4H19z"
    })), _path371$l || (_path371$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 10H15V12H7z"
    })), children);
  });
  var ChartColumnTarget16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartColumnTarget16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$l || (_path372$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28V6H19V28H15V14H7V28H4V2H2V28a2 2 0 002 2H30V28zM13 28H9V16h4zm12 0H21V8h4zM19 2H27V4H19z"
    })), _path373$l || (_path373$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 10H15V12H7z"
    })), children);
  });
  var ChartCombo32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCombo32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$l || (_path374$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V14h4Zm12,0H21V18h4Z"
    })), _path375$k || (_path375$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartCombo24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCombo24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$k || (_path376$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V14h4Zm12,0H21V18h4Z"
    })), _path377$k || (_path377$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartCombo20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCombo20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$k || (_path378$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V14h4Zm12,0H21V18h4Z"
    })), _path379$k || (_path379$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartCombo16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCombo16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$k || (_path380$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V14h4Zm12,0H21V18h4Z"
    })), _path381$k || (_path381$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartComboStacked32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartComboStacked32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$k || (_path382$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,14v6H9V14Zm12,4v6H21V18Z"
    })), _path383$k || (_path383$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartComboStacked24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartComboStacked24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$j || (_path384$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,14v6H9V14Zm12,4v6H21V18Z"
    })), _path385$j || (_path385$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });

  var _path$q, _path2$q, _path3$q, _path4$q, _path5$q, _path6$q, _path7$q, _path8$q, _path9$q, _path10$q, _path11$q, _path12$q, _path13$q, _path14$q, _path15$q, _path16$q, _path17$q, _path18$q, _path19$q, _path20$q, _path21$q, _path22$q, _path23$q, _path24$q, _path25$q, _path26$q, _path27$q, _path28$q, _path29$q, _path30$q, _path31$q, _path32$q, _path33$q, _path34$q, _path35$q, _path36$q, _path37$q, _path38$q, _path39$q, _path40$q, _path41$q, _path42$q, _path43$q, _path44$q, _path45$q, _path46$q, _path47$q, _path48$q, _path49$q, _path50$q, _path51$q, _path52$q, _path53$q, _path54$q, _path55$q, _path56$q, _path57$q, _path58$q, _path59$q, _path60$q, _path61$q, _path62$q, _path63$q, _path64$q, _path65$q, _path66$q, _path67$q, _path68$q, _path69$q, _path70$q, _path71$q, _path72$q, _path73$q, _path74$q, _path75$q, _path76$q, _path77$q, _path78$q, _path79$q, _path80$q, _path81$q, _path82$q, _path83$q, _path84$q, _path85$q, _path86$q, _path87$q, _path88$q, _path89$q, _path90$q, _path91$q, _path92$q, _path93$q, _path94$q, _path95$q, _path96$q, _path97$q, _path98$q, _path99$q, _path100$q, _path101$q, _path102$q, _path103$q, _path104$q, _path105$q, _path106$q, _path107$q, _path108$q, _path109$q, _path110$q, _path111$q, _path112$q, _path113$q, _path114$q, _path115$q, _path116$q, _path117$q, _path118$q, _path119$q, _path120$q, _path121$q, _circle$p, _circle2$p, _circle3$p, _circle4$o, _circle5$n, _path122$q, _circle6$n, _circle7$n, _circle8$n, _circle9$n, _circle10$n, _path123$q, _circle11$m, _circle12$m, _circle13$m, _circle14$m, _circle15$m, _path124$q, _circle16$m, _circle17$l, _circle18$l, _circle19$l, _circle20$l, _path125$q, _path126$q, _path127$q, _path128$q, _path129$q, _path130$q, _path131$q, _path132$q, _path133$q, _path134$q, _path135$q, _path136$q, _path137$q, _circle21$k, _circle22$k, _circle23$j, _path138$q, _circle24$j, _circle25$i, _path139$q, _path140$q, _circle26$i, _circle27$h, _circle28$h, _path141$q, _circle29$g, _circle30$g, _path142$q, _path143$q, _circle31$g, _circle32$g, _circle33$f, _path144$q, _circle34$e, _circle35$e, _path145$q, _path146$q, _circle36$e, _circle37$c, _circle38$c, _path147$q, _circle39$c, _circle40$c, _path148$q, _path149$q, _path150$q, _path151$q, _path152$q, _path153$q, _path154$q, _path155$q, _path156$q, _path157$q, _path158$q, _path159$q, _path160$q, _path161$q, _path162$q, _path163$q, _path164$q, _path165$q, _path166$q, _path167$q, _path168$q, _path169$q, _path170$q, _path171$q, _path172$q, _path173$q, _path174$q, _path175$q, _path176$q, _path177$p, _path178$p, _path179$p, _path180$p, _path181$p, _path182$p, _path183$p, _path184$p, _path185$p, _circle41$b, _circle42$b, _circle43$b, _circle44$b, _circle45$a, _path186$p, _circle46$a, _circle47$a, _circle48$a, _circle49$9, _circle50$8, _path187$p, _circle51$8, _circle52$8, _circle53$7, _circle54$7, _circle55$6, _path188$p, _circle56$6, _circle57$6, _circle58$6, _circle59$6, _circle60$6, _path189$p, _path190$p, _path191$p, _path192$p, _path193$p, _path194$p, _path195$p, _path196$p, _path197$p, _path198$p, _path199$p, _path200$p, _path201$p, _path202$p, _path203$p, _path204$p, _circle61$6, _circle62$6, _circle63$6, _circle64$6, _circle65$6, _circle66$6, _circle67$6, _circle68$6, _circle69$6, _circle70$6, _circle71$6, _circle72$6, _circle73$5, _circle74$5, _circle75$5, _circle76$5, _circle77$5, _circle78$5, _circle79$5, _circle80$5, _circle81$5, _circle82$5, _circle83$5, _circle84$5, _circle85$4, _circle86$4, _circle87$4, _circle88$4, _circle89$3, _circle90$3, _circle91$3, _circle92$3, _circle93$3, _circle94$3, _circle95$3, _circle96$3, _circle97$3, _circle98$3, _circle99$3, _circle100$3, _circle101$2, _circle102$2, _circle103$2, _circle104$2, _circle105$2, _circle106$2, _circle107$2, _circle108$2, _circle109$2, _circle110$2, _circle111$2, _circle112$2, _circle113$2, _circle114$2, _circle115$2, _circle116$2, _path205$p, _path206$p, _path207$p, _path208$p, _path209$p, _path210$p, _path211$p, _path212$p, _path213$p, _path214$p, _path215$p, _path216$p, _path217$p, _path218$p, _path219$p, _path220$p, _path221$p, _path222$p, _path223$p, _path224$p, _path225$p, _path226$p, _path227$p, _path228$p, _path229$p, _path230$p, _path231$p, _path232$p, _path233$p, _path234$p, _path235$p, _path236$p, _path237$p, _path238$p, _path239$p, _path240$p, _path241$p, _path242$p, _path243$p, _path244$p, _path245$p, _path246$p, _path247$p, _path248$p, _path249$p, _path250$p, _path251$p, _path252$p, _path253$p, _path254$p, _path255$p, _path256$p, _path257$p, _path258$p, _path259$p, _path260$p, _path261$p, _path262$p, _path263$p, _path264$p, _path265$p, _path266$p, _path267$p, _path268$p, _path269$p, _path270$p, _path271$p, _path272$p, _path273$p, _path274$p, _path275$p, _path276$p, _path277$p, _path278$p, _path279$p, _path280$p, _path281$p, _path282$p, _path283$p, _path284$p, _path285$p, _path286$p, _path287$p, _path288$p, _path289$p, _path290$p, _path291$p, _path292$p, _path293$p, _path294$p, _path295$p, _path296$p, _path297$p, _path298$p, _path299$p, _path300$p, _path301$p, _path302$p, _path303$p, _path304$p, _path305$p, _path306$p, _path307$p, _path308$p, _path309$p, _path310$p, _path311$p, _path312$p, _path313$p, _path314$p, _path315$p, _path316$p, _path317$p, _path318$p, _path319$p, _path320$p, _path321$p, _path322$p, _path323$p, _path324$p, _path325$p, _path326$p, _path327$p, _path328$p, _path329$p, _path330$p, _path331$p, _path332$p, _path333$p, _path334$p, _path335$p, _path336$p, _path337$p, _path338$o, _path339$o, _path340$o, _path341$o, _path342$o, _path343$o, _path344$o, _path345$o, _path346$o, _path347$o, _path348$o, _path349$o, _path350$o, _path351$o, _path352$o, _path353$o, _path354$o, _path355$n, _path356$n, _path357$n, _path358$n, _path359$n, _path360$n, _path361$m, _path362$m, _path363$k, _path364$k, _path365$k, _path366$k, _path367$k, _path368$k, _path369$k, _path370$k, _path371$k, _path372$k, _path373$k, _path374$k, _path375$j, _path376$j, _path377$j, _path378$j, _path379$j, _path380$j, _path381$j, _path382$j, _path383$j, _path384$i, _path385$i, _path386$i, _path387$i, _path388$i, _path389$i, _path390$i, _path391$i, _path392$i, _path393$i, _path394$i, _path395$i, _path396$i, _path397$i, _path398$i, _path399$h, _path400$h, _path401$h, _path402$h, _path403$g, _path404$g, _path405$f;

  var _excluded$q = ["children"],
      _excluded2$q = ["children"],
      _excluded3$q = ["children"],
      _excluded4$q = ["children"],
      _excluded5$q = ["children"],
      _excluded6$q = ["children"],
      _excluded7$q = ["children"],
      _excluded8$q = ["children"],
      _excluded9$q = ["children"],
      _excluded10$q = ["children"],
      _excluded11$q = ["children"],
      _excluded12$q = ["children"],
      _excluded13$q = ["children"],
      _excluded14$q = ["children"],
      _excluded15$q = ["children"],
      _excluded16$q = ["children"],
      _excluded17$q = ["children"],
      _excluded18$q = ["children"],
      _excluded19$q = ["children"],
      _excluded20$q = ["children"],
      _excluded21$q = ["children"],
      _excluded22$q = ["children"],
      _excluded23$q = ["children"],
      _excluded24$q = ["children"],
      _excluded25$q = ["children"],
      _excluded26$q = ["children"],
      _excluded27$q = ["children"],
      _excluded28$q = ["children"],
      _excluded29$q = ["children"],
      _excluded30$q = ["children"],
      _excluded31$q = ["children"],
      _excluded32$q = ["children"],
      _excluded33$q = ["children"],
      _excluded34$q = ["children"],
      _excluded35$q = ["children"],
      _excluded36$q = ["children"],
      _excluded37$q = ["children"],
      _excluded38$q = ["children"],
      _excluded39$q = ["children"],
      _excluded40$q = ["children"],
      _excluded41$q = ["children"],
      _excluded42$q = ["children"],
      _excluded43$q = ["children"],
      _excluded44$q = ["children"],
      _excluded45$q = ["children"],
      _excluded46$q = ["children"],
      _excluded47$q = ["children"],
      _excluded48$q = ["children"],
      _excluded49$q = ["children"],
      _excluded50$q = ["children"],
      _excluded51$q = ["children"],
      _excluded52$q = ["children"],
      _excluded53$q = ["children"],
      _excluded54$q = ["children"],
      _excluded55$q = ["children"],
      _excluded56$q = ["children"],
      _excluded57$q = ["children"],
      _excluded58$q = ["children"],
      _excluded59$q = ["children"],
      _excluded60$q = ["children"],
      _excluded61$q = ["children"],
      _excluded62$q = ["children"],
      _excluded63$q = ["children"],
      _excluded64$q = ["children"],
      _excluded65$q = ["children"],
      _excluded66$q = ["children"],
      _excluded67$q = ["children"],
      _excluded68$q = ["children"],
      _excluded69$q = ["children"],
      _excluded70$q = ["children"],
      _excluded71$q = ["children"],
      _excluded72$q = ["children"],
      _excluded73$q = ["children"],
      _excluded74$q = ["children"],
      _excluded75$q = ["children"],
      _excluded76$q = ["children"],
      _excluded77$q = ["children"],
      _excluded78$q = ["children"],
      _excluded79$q = ["children"],
      _excluded80$q = ["children"],
      _excluded81$q = ["children"],
      _excluded82$q = ["children"],
      _excluded83$q = ["children"],
      _excluded84$q = ["children"],
      _excluded85$q = ["children"],
      _excluded86$q = ["children"],
      _excluded87$q = ["children"],
      _excluded88$q = ["children"],
      _excluded89$q = ["children"],
      _excluded90$q = ["children"],
      _excluded91$q = ["children"],
      _excluded92$q = ["children"],
      _excluded93$q = ["children"],
      _excluded94$q = ["children"],
      _excluded95$q = ["children"],
      _excluded96$q = ["children"],
      _excluded97$q = ["children"],
      _excluded98$q = ["children"],
      _excluded99$q = ["children"],
      _excluded100$q = ["children"],
      _excluded101$q = ["children"],
      _excluded102$q = ["children"],
      _excluded103$q = ["children"],
      _excluded104$q = ["children"],
      _excluded105$q = ["children"],
      _excluded106$q = ["children"],
      _excluded107$q = ["children"],
      _excluded108$q = ["children"],
      _excluded109$q = ["children"],
      _excluded110$q = ["children"],
      _excluded111$q = ["children"],
      _excluded112$q = ["children"],
      _excluded113$q = ["children"],
      _excluded114$q = ["children"],
      _excluded115$q = ["children"],
      _excluded116$q = ["children"],
      _excluded117$q = ["children"],
      _excluded118$q = ["children"],
      _excluded119$p = ["children"],
      _excluded120$p = ["children"],
      _excluded121$p = ["children"],
      _excluded122$p = ["children"],
      _excluded123$p = ["children"],
      _excluded124$p = ["children"],
      _excluded125$p = ["children"],
      _excluded126$p = ["children"],
      _excluded127$p = ["children"],
      _excluded128$p = ["children"],
      _excluded129$p = ["children"],
      _excluded130$p = ["children"],
      _excluded131$p = ["children"],
      _excluded132$p = ["children"],
      _excluded133$p = ["children"],
      _excluded134$p = ["children"],
      _excluded135$p = ["children"],
      _excluded136$p = ["children"],
      _excluded137$p = ["children"],
      _excluded138$p = ["children"],
      _excluded139$p = ["children"],
      _excluded140$p = ["children"],
      _excluded141$p = ["children"],
      _excluded142$p = ["children"],
      _excluded143$p = ["children"],
      _excluded144$p = ["children"],
      _excluded145$p = ["children"],
      _excluded146$p = ["children"],
      _excluded147$p = ["children"],
      _excluded148$p = ["children"],
      _excluded149$p = ["children"],
      _excluded150$p = ["children"],
      _excluded151$p = ["children"],
      _excluded152$p = ["children"],
      _excluded153$p = ["children"],
      _excluded154$p = ["children"],
      _excluded155$p = ["children"],
      _excluded156$p = ["children"],
      _excluded157$p = ["children"],
      _excluded158$p = ["children"],
      _excluded159$p = ["children"],
      _excluded160$p = ["children"],
      _excluded161$p = ["children"],
      _excluded162$p = ["children"],
      _excluded163$p = ["children"],
      _excluded164$p = ["children"],
      _excluded165$p = ["children"],
      _excluded166$p = ["children"],
      _excluded167$p = ["children"],
      _excluded168$p = ["children"],
      _excluded169$p = ["children"],
      _excluded170$p = ["children"],
      _excluded171$p = ["children"],
      _excluded172$p = ["children"],
      _excluded173$p = ["children"],
      _excluded174$p = ["children"],
      _excluded175$p = ["children"],
      _excluded176$p = ["children"],
      _excluded177$p = ["children"],
      _excluded178$p = ["children"],
      _excluded179$p = ["children"],
      _excluded180$p = ["children"],
      _excluded181$p = ["children"],
      _excluded182$p = ["children"],
      _excluded183$p = ["children"],
      _excluded184$p = ["children"],
      _excluded185$p = ["children"],
      _excluded186$p = ["children"],
      _excluded187$p = ["children"],
      _excluded188$p = ["children"],
      _excluded189$p = ["children"],
      _excluded190$p = ["children"],
      _excluded191$p = ["children"],
      _excluded192$p = ["children"],
      _excluded193$p = ["children"],
      _excluded194$p = ["children"],
      _excluded195$p = ["children"],
      _excluded196$p = ["children"],
      _excluded197$p = ["children"],
      _excluded198$p = ["children"],
      _excluded199$p = ["children"],
      _excluded200$p = ["children"],
      _excluded201$p = ["children"],
      _excluded202$p = ["children"],
      _excluded203$p = ["children"],
      _excluded204$p = ["children"],
      _excluded205$p = ["children"],
      _excluded206$p = ["children"],
      _excluded207$p = ["children"],
      _excluded208$p = ["children"],
      _excluded209$p = ["children"],
      _excluded210$p = ["children"],
      _excluded211$p = ["children"],
      _excluded212$p = ["children"],
      _excluded213$p = ["children"],
      _excluded214$p = ["children"],
      _excluded215$p = ["children"],
      _excluded216$p = ["children"],
      _excluded217$p = ["children"],
      _excluded218$p = ["children"],
      _excluded219$p = ["children"],
      _excluded220$p = ["children"],
      _excluded221$p = ["children"],
      _excluded222$p = ["children"],
      _excluded223$p = ["children"],
      _excluded224$p = ["children"],
      _excluded225$p = ["children"],
      _excluded226$p = ["children"],
      _excluded227$p = ["children"],
      _excluded228$p = ["children"],
      _excluded229$p = ["children"],
      _excluded230$p = ["children"],
      _excluded231$p = ["children"],
      _excluded232$p = ["children"],
      _excluded233$p = ["children"],
      _excluded234$p = ["children"],
      _excluded235$p = ["children"],
      _excluded236$p = ["children"],
      _excluded237$p = ["children"],
      _excluded238$p = ["children"],
      _excluded239$p = ["children"],
      _excluded240$p = ["children"],
      _excluded241$p = ["children"],
      _excluded242$p = ["children"],
      _excluded243$p = ["children"],
      _excluded244$p = ["children"],
      _excluded245$p = ["children"],
      _excluded246$p = ["children"],
      _excluded247$p = ["children"],
      _excluded248$p = ["children"],
      _excluded249$p = ["children"],
      _excluded250$p = ["children"];
  var didWarnAboutDeprecation$a = {};
  var ChartComboStacked20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartComboStacked20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$q || (_path$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,14v6H9V14Zm12,4v6H21V18Z"
    })), _path2$q || (_path2$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartComboStacked16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartComboStacked16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$q || (_path3$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V16H19V28H15V12H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,14v6H9V14Zm12,4v6H21V18Z"
    })), _path4$q || (_path4$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7856,14a1.9877,1.9877,0,0,1-1.1787-.3865L11.2041,5.987,8.2419,10,6.6374,8.8065l2.9812-4a1.9978,1.9978,0,0,1,2.749-.446l10.4214,7.64,3.6045-4.8613L28,8.3306l-3.6045,4.8611A2.0014,2.0014,0,0,1,22.7856,14Z"
    })), children);
  });
  var ChartCustom32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCustom32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$q || (_path5$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,19.293l-3-3a.9994.9994,0,0,0-1.414,0L16,25.5859V30h4.4141l9.2929-9.293A.9994.9994,0,0,0,29.707,19.293ZM19.5859,28H18V26.4141l5-5L24.5859,23ZM26,21.5859,24.4141,20,26,18.4141,27.5859,20Z"
    })), _path6$q || (_path6$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15H21V17H17z",
      transform: "rotate(-90 19 16)"
    })), _path7$q || (_path7$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 14H18V16H12z",
      transform: "rotate(-90 15 15)"
    })), _path8$q || (_path8$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12H16V14H6z",
      transform: "rotate(-90 11 13)"
    })), _path9$q || (_path9$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var ChartCustom24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCustom24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$q || (_path10$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,19.293l-3-3a.9994.9994,0,0,0-1.414,0L16,25.5859V30h4.4141l9.2929-9.293A.9994.9994,0,0,0,29.707,19.293ZM19.5859,28H18V26.4141l5-5L24.5859,23ZM26,21.5859,24.4141,20,26,18.4141,27.5859,20Z"
    })), _path11$q || (_path11$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15H21V17H17z",
      transform: "rotate(-90 19 16)"
    })), _path12$q || (_path12$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 14H18V16H12z",
      transform: "rotate(-90 15 15)"
    })), _path13$q || (_path13$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12H16V14H6z",
      transform: "rotate(-90 11 13)"
    })), _path14$q || (_path14$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var ChartCustom20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCustom20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$q || (_path15$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,19.293l-3-3a.9994.9994,0,0,0-1.414,0L16,25.5859V30h4.4141l9.2929-9.293A.9994.9994,0,0,0,29.707,19.293ZM19.5859,28H18V26.4141l5-5L24.5859,23ZM26,21.5859,24.4141,20,26,18.4141,27.5859,20Z"
    })), _path16$q || (_path16$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15H21V17H17z",
      transform: "rotate(-90 19 16)"
    })), _path17$q || (_path17$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 14H18V16H12z",
      transform: "rotate(-90 15 15)"
    })), _path18$q || (_path18$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12H16V14H6z",
      transform: "rotate(-90 11 13)"
    })), _path19$q || (_path19$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var ChartCustom16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartCustom16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$q || (_path20$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,19.293l-3-3a.9994.9994,0,0,0-1.414,0L16,25.5859V30h4.4141l9.2929-9.293A.9994.9994,0,0,0,29.707,19.293ZM19.5859,28H18V26.4141l5-5L24.5859,23ZM26,21.5859,24.4141,20,26,18.4141,27.5859,20Z"
    })), _path21$q || (_path21$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 15H21V17H17z",
      transform: "rotate(-90 19 16)"
    })), _path22$q || (_path22$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 14H18V16H12z",
      transform: "rotate(-90 15 15)"
    })), _path23$q || (_path23$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 12H16V14H6z",
      transform: "rotate(-90 11 13)"
    })), _path24$q || (_path24$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var ChartErrorBar32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBar32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$q || (_path25$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28V12H18V8h2V6H14V8h2v4H12V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM14,14h2v4H14Zm6,14H14V20h6Zm0-10H18V14h2Z"
    })), children);
  });
  var ChartErrorBar24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBar24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$q || (_path26$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28V12H18V8h2V6H14V8h2v4H12V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM14,14h2v4H14Zm6,14H14V20h6Zm0-10H18V14h2Z"
    })), children);
  });
  var ChartErrorBar20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBar20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$q || (_path27$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28V12H18V8h2V6H14V8h2v4H12V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM14,14h2v4H14Zm6,14H14V20h6Zm0-10H18V14h2Z"
    })), children);
  });
  var ChartErrorBar16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBar16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$q || (_path28$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28V12H18V8h2V6H14V8h2v4H12V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM14,14h2v4H14Zm6,14H14V20h6Zm0-10H18V14h2Z"
    })), children);
  });
  var ChartErrorBarAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBarAlt32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$q || (_path29$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10V8H8v2h2v4.1836a2.983 2.983 0 000 5.6328V24H8v2h6V24H12V19.8164a2.983 2.983 0 000-5.6328V10zM26 6V4H20V6h2V8.1836a2.983 2.983 0 000 5.6328V18H20v2h6V18H24V13.8164a2.983 2.983 0 000-5.6328V6z"
    })), _path30$q || (_path30$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartErrorBarAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBarAlt24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$q || (_path31$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10V8H8v2h2v4.1836a2.983 2.983 0 000 5.6328V24H8v2h6V24H12V19.8164a2.983 2.983 0 000-5.6328V10zM26 6V4H20V6h2V8.1836a2.983 2.983 0 000 5.6328V18H20v2h6V18H24V13.8164a2.983 2.983 0 000-5.6328V6z"
    })), _path32$q || (_path32$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartErrorBarAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBarAlt20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$q || (_path33$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10V8H8v2h2v4.1836a2.983 2.983 0 000 5.6328V24H8v2h6V24H12V19.8164a2.983 2.983 0 000-5.6328V10zM26 6V4H20V6h2V8.1836a2.983 2.983 0 000 5.6328V18H20v2h6V18H24V13.8164a2.983 2.983 0 000-5.6328V6z"
    })), _path34$q || (_path34$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartErrorBarAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartErrorBarAlt16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$q || (_path35$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10V8H8v2h2v4.1836a2.983 2.983 0 000 5.6328V24H8v2h6V24H12V19.8164a2.983 2.983 0 000-5.6328V10zM26 6V4H20V6h2V8.1836a2.983 2.983 0 000 5.6328V18H20v2h6V18H24V13.8164a2.983 2.983 0 000-5.6328V6z"
    })), _path36$q || (_path36$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartEvaluation32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartEvaluation32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$q || (_path37$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.672 6.207H29.915V8.206H25.672z",
      transform: "rotate(-45.02 27.793 7.207)"
    })), _path38$q || (_path38$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20.5L11 15.539 12.59 13.969 16 17.349 23.41 10 25 11.579 16 20.5z"
    })), _path39$q || (_path39$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25.4131L10.4141,19,9,17.585l-5,5V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartEvaluation24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartEvaluation24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$q || (_path40$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.672 6.207H29.915V8.206H25.672z",
      transform: "rotate(-45.02 27.793 7.207)"
    })), _path41$q || (_path41$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20.5L11 15.539 12.59 13.969 16 17.349 23.41 10 25 11.579 16 20.5z"
    })), _path42$q || (_path42$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25.4131L10.4141,19,9,17.585l-5,5V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartEvaluation20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartEvaluation20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$q || (_path43$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.672 6.207H29.915V8.206H25.672z",
      transform: "rotate(-45.02 27.793 7.207)"
    })), _path44$q || (_path44$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20.5L11 15.539 12.59 13.969 16 17.349 23.41 10 25 11.579 16 20.5z"
    })), _path45$q || (_path45$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25.4131L10.4141,19,9,17.585l-5,5V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartEvaluation16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartEvaluation16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$q || (_path46$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.672 6.207H29.915V8.206H25.672z",
      transform: "rotate(-45.02 27.793 7.207)"
    })), _path47$q || (_path47$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20.5L11 15.539 12.59 13.969 16 17.349 23.41 10 25 11.579 16 20.5z"
    })), _path48$q || (_path48$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V25.4131L10.4141,19,9,17.585l-5,5V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartHighLow32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHighLow32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$q || (_path49$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8L12 8 12 6 10 6 10 20 7 20 7 22 10 22 10 24 12 24 12 10 15 10 15 8zM27 10L24 10 24 6 22 6 22 18 19 18 19 20 22 20 22 24 24 24 24 12 27 12 27 10z"
    })), _path50$q || (_path50$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartHighLow24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHighLow24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$q || (_path51$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8L12 8 12 6 10 6 10 20 7 20 7 22 10 22 10 24 12 24 12 10 15 10 15 8zM27 10L24 10 24 6 22 6 22 18 19 18 19 20 22 20 22 24 24 24 24 12 27 12 27 10z"
    })), _path52$q || (_path52$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartHighLow20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHighLow20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$q || (_path53$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8L12 8 12 6 10 6 10 20 7 20 7 22 10 22 10 24 12 24 12 10 15 10 15 8zM27 10L24 10 24 6 22 6 22 18 19 18 19 20 22 20 22 24 24 24 24 12 27 12 27 10z"
    })), _path54$q || (_path54$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartHighLow16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHighLow16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$q || (_path55$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8L12 8 12 6 10 6 10 20 7 20 7 22 10 22 10 24 12 24 12 10 15 10 15 8zM27 10L24 10 24 6 22 6 22 18 19 18 19 20 22 20 22 24 24 24 24 12 27 12 27 10z"
    })), _path56$q || (_path56$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), children);
  });
  var ChartHistogram32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHistogram32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$q || (_path57$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16c2.9727,0,4.2324-2.251,5.3447-4.2373C12.4741,9.7441,13.45,8,16,8s3.5259,1.7441,4.6553,3.7627C21.7676,13.749,23.0273,16,26,16h4V14H26c-1.7129,0-2.4834-1.2207-3.5991-3.2144C21.2075,8.6543,19.7231,6,16,6s-5.2075,2.6543-6.4009,4.7856C8.4834,12.7793,7.7129,14,6,14H4V2H2V28a2,2,0,0,0,2,2H30V28H28V22H26v6H21.9992L22,20H20v8H16V16H14V28H9.9992L10,20H8v8H4V16Z"
    })), children);
  });
  var ChartHistogram24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHistogram24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$q || (_path58$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16c2.9727,0,4.2324-2.251,5.3447-4.2373C12.4741,9.7441,13.45,8,16,8s3.5259,1.7441,4.6553,3.7627C21.7676,13.749,23.0273,16,26,16h4V14H26c-1.7129,0-2.4834-1.2207-3.5991-3.2144C21.2075,8.6543,19.7231,6,16,6s-5.2075,2.6543-6.4009,4.7856C8.4834,12.7793,7.7129,14,6,14H4V2H2V28a2,2,0,0,0,2,2H30V28H28V22H26v6H21.9992L22,20H20v8H16V16H14V28H9.9992L10,20H8v8H4V16Z"
    })), children);
  });
  var ChartHistogram20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHistogram20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$q || (_path59$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16c2.9727,0,4.2324-2.251,5.3447-4.2373C12.4741,9.7441,13.45,8,16,8s3.5259,1.7441,4.6553,3.7627C21.7676,13.749,23.0273,16,26,16h4V14H26c-1.7129,0-2.4834-1.2207-3.5991-3.2144C21.2075,8.6543,19.7231,6,16,6s-5.2075,2.6543-6.4009,4.7856C8.4834,12.7793,7.7129,14,6,14H4V2H2V28a2,2,0,0,0,2,2H30V28H28V22H26v6H21.9992L22,20H20v8H16V16H14V28H9.9992L10,20H8v8H4V16Z"
    })), children);
  });
  var ChartHistogram16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartHistogram16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$q || (_path60$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16c2.9727,0,4.2324-2.251,5.3447-4.2373C12.4741,9.7441,13.45,8,16,8s3.5259,1.7441,4.6553,3.7627C21.7676,13.749,23.0273,16,26,16h4V14H26c-1.7129,0-2.4834-1.2207-3.5991-3.2144C21.2075,8.6543,19.7231,6,16,6s-5.2075,2.6543-6.4009,4.7856C8.4834,12.7793,7.7129,14,6,14H4V2H2V28a2,2,0,0,0,2,2H30V28H28V22H26v6H21.9992L22,20H20v8H16V16H14V28H9.9992L10,20H8v8H4V16Z"
    })), children);
  });
  var ChartLine32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLine32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$q || (_path61$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartLine24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLine24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$q || (_path62$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartLine20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLine20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$q || (_path63$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartLine16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLine16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$q || (_path64$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartLineData32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineData32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$q || (_path65$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"
    })), children);
  });
  var ChartLineData24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineData24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$q || (_path66$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"
    })), children);
  });
  var ChartLineData20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineData20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$q || (_path67$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"
    })), children);
  });
  var ChartLineData16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineData16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$q || (_path68$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"
    })), children);
  });
  var ChartLineSmooth32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineSmooth32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$q || (_path69$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,15c1.4854,0,2.5544,1.4966,3.6863,3.0811C17.9983,19.918,19.4854,22,22,22c5.6709,0,7.78-10.79,8-12l-1.9678-.3584C27.55,12.2827,25.3938,20,22,20c-1.4854,0-2.5544-1.4966-3.6863-3.0811C17.0017,15.082,15.5146,13,13,13c-4.186,0-7.4448,7.4043-9,11.7617V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H5.0439C6.5544,22.8574,9.9634,15,13,15Z"
    })), children);
  });
  var ChartLineSmooth24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineSmooth24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$q || (_path70$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,15c1.4854,0,2.5544,1.4966,3.6863,3.0811C17.9983,19.918,19.4854,22,22,22c5.6709,0,7.78-10.79,8-12l-1.9678-.3584C27.55,12.2827,25.3938,20,22,20c-1.4854,0-2.5544-1.4966-3.6863-3.0811C17.0017,15.082,15.5146,13,13,13c-4.186,0-7.4448,7.4043-9,11.7617V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H5.0439C6.5544,22.8574,9.9634,15,13,15Z"
    })), children);
  });
  var ChartLineSmooth20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineSmooth20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$q || (_path71$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,15c1.4854,0,2.5544,1.4966,3.6863,3.0811C17.9983,19.918,19.4854,22,22,22c5.6709,0,7.78-10.79,8-12l-1.9678-.3584C27.55,12.2827,25.3938,20,22,20c-1.4854,0-2.5544-1.4966-3.6863-3.0811C17.0017,15.082,15.5146,13,13,13c-4.186,0-7.4448,7.4043-9,11.7617V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H5.0439C6.5544,22.8574,9.9634,15,13,15Z"
    })), children);
  });
  var ChartLineSmooth16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartLineSmooth16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$q || (_path72$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,15c1.4854,0,2.5544,1.4966,3.6863,3.0811C17.9983,19.918,19.4854,22,22,22c5.6709,0,7.78-10.79,8-12l-1.9678-.3584C27.55,12.2827,25.3938,20,22,20c-1.4854,0-2.5544-1.4966-3.6863-3.0811C17.0017,15.082,15.5146,13,13,13c-4.186,0-7.4448,7.4043-9,11.7617V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H5.0439C6.5544,22.8574,9.9634,15,13,15Z"
    })), children);
  });
  var ChartMarimekko32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMarimekko32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$q || (_path73$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,7H21V5h6ZM19,8H13V5h6Zm0,2v8H13V10ZM11,22H5V12h6Zm2-2h6v7H13Zm8-8h6v4H21ZM11,5v5H5V5ZM5,24h6v3H5Zm16,3V18h6v9Z"
    })), children);
  });
  var ChartMarimekko24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMarimekko24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$q || (_path74$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,7H21V5h6ZM19,8H13V5h6Zm0,2v8H13V10ZM11,22H5V12h6Zm2-2h6v7H13Zm8-8h6v4H21ZM11,5v5H5V5ZM5,24h6v3H5Zm16,3V18h6v9Z"
    })), children);
  });
  var ChartMarimekko20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMarimekko20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$q || (_path75$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,7H21V5h6ZM19,8H13V5h6Zm0,2v8H13V10ZM11,22H5V12h6Zm2-2h6v7H13Zm8-8h6v4H21ZM11,5v5H5V5ZM5,24h6v3H5Zm16,3V18h6v9Z"
    })), children);
  });
  var ChartMarimekko16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMarimekko16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$q || (_path76$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,7H21V5h6ZM19,8H13V5h6Zm0,2v8H13V10ZM11,22H5V12h6Zm2-2h6v7H13Zm8-8h6v4H21ZM11,5v5H5V5ZM5,24h6v3H5Zm16,3V18h6v9Z"
    })), children);
  });
  var ChartMaximum32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMaximum32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$q || (_path77$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H10V8H8zM12 6H14V8H12zM20 6H22V8H20zM24 6H26V8H24zM28 6H30V8H28z"
    })), _path78$q || (_path78$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.989,28l-.0271-.1631C26.5105,19.0742,24.0662,9.0894,18,8.0889V6H16V8.085c-6.084.978-8.533,10.9775-9.9863,19.7519L5.9866,28H4V8H6V6H4V2H2V28a2,2,0,0,0,2,2H30V28ZM8.0151,28c2.024-12.1084,4.959-18,8.9727-18s6.9487,5.8916,8.9726,18Z"
    })), children);
  });
  var ChartMaximum24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMaximum24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$q || (_path79$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H10V8H8zM12 6H14V8H12zM20 6H22V8H20zM24 6H26V8H24zM28 6H30V8H28z"
    })), _path80$q || (_path80$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.989,28l-.0271-.1631C26.5105,19.0742,24.0662,9.0894,18,8.0889V6H16V8.085c-6.084.978-8.533,10.9775-9.9863,19.7519L5.9866,28H4V8H6V6H4V2H2V28a2,2,0,0,0,2,2H30V28ZM8.0151,28c2.024-12.1084,4.959-18,8.9727-18s6.9487,5.8916,8.9726,18Z"
    })), children);
  });
  var ChartMaximum20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMaximum20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$q || (_path81$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H10V8H8zM12 6H14V8H12zM20 6H22V8H20zM24 6H26V8H24zM28 6H30V8H28z"
    })), _path82$q || (_path82$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.989,28l-.0271-.1631C26.5105,19.0742,24.0662,9.0894,18,8.0889V6H16V8.085c-6.084.978-8.533,10.9775-9.9863,19.7519L5.9866,28H4V8H6V6H4V2H2V28a2,2,0,0,0,2,2H30V28ZM8.0151,28c2.024-12.1084,4.959-18,8.9727-18s6.9487,5.8916,8.9726,18Z"
    })), children);
  });
  var ChartMaximum16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMaximum16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$q || (_path83$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H10V8H8zM12 6H14V8H12zM20 6H22V8H20zM24 6H26V8H24zM28 6H30V8H28z"
    })), _path84$q || (_path84$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.989,28l-.0271-.1631C26.5105,19.0742,24.0662,9.0894,18,8.0889V6H16V8.085c-6.084.978-8.533,10.9775-9.9863,19.7519L5.9866,28H4V8H6V6H4V2H2V28a2,2,0,0,0,2,2H30V28ZM8.0151,28c2.024-12.1084,4.959-18,8.9727-18s6.9487,5.8916,8.9726,18Z"
    })), children);
  });
  var ChartMedian32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMedian32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$q || (_path85$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H18V24H16z",
      transform: "rotate(-90 17 23)"
    })), _path86$q || (_path86$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26H16v2H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path87$q || (_path87$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0532,19.6787A3.44,3.44,0,0,1,23,22c-2.17,0-3.3115-3.333-4.52-6.8623-.3557-1.0386-.7239-2.1094-1.1382-3.1377H18V10H16.4221C15.2124,7.7148,13.5811,6,11,6,7.3218,6,6.1016,9.5332,6.0513,9.6836l1.8955.6377A3.44,3.44,0,0,1,11,8c2.92,0,4.2764,3.958,5.5874,7.7861.2544.7422.5105,1.4893.7813,2.2139H16v2h2.2019c1.0828,2.2886,2.4959,4,4.7981,4,3.6782,0,4.8984-3.5332,4.9487-3.6836Z"
    })), _path88$q || (_path88$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H18V8H16z",
      transform: "rotate(-90 17 7)"
    })), _path89$q || (_path89$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2H18V4H16z",
      transform: "rotate(-90 17 3)"
    })), children);
  });
  var ChartMedian24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMedian24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$q || (_path90$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H18V24H16z",
      transform: "rotate(-90 17 23)"
    })), _path91$q || (_path91$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26H16v2H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path92$q || (_path92$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0532,19.6787A3.44,3.44,0,0,1,23,22c-2.17,0-3.3115-3.333-4.52-6.8623-.3557-1.0386-.7239-2.1094-1.1382-3.1377H18V10H16.4221C15.2124,7.7148,13.5811,6,11,6,7.3218,6,6.1016,9.5332,6.0513,9.6836l1.8955.6377A3.44,3.44,0,0,1,11,8c2.92,0,4.2764,3.958,5.5874,7.7861.2544.7422.5105,1.4893.7813,2.2139H16v2h2.2019c1.0828,2.2886,2.4959,4,4.7981,4,3.6782,0,4.8984-3.5332,4.9487-3.6836Z"
    })), _path93$q || (_path93$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H18V8H16z",
      transform: "rotate(-90 17 7)"
    })), _path94$q || (_path94$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2H18V4H16z",
      transform: "rotate(-90 17 3)"
    })), children);
  });
  var ChartMedian20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMedian20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$q || (_path95$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H18V24H16z",
      transform: "rotate(-90 17 23)"
    })), _path96$q || (_path96$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26H16v2H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path97$q || (_path97$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0532,19.6787A3.44,3.44,0,0,1,23,22c-2.17,0-3.3115-3.333-4.52-6.8623-.3557-1.0386-.7239-2.1094-1.1382-3.1377H18V10H16.4221C15.2124,7.7148,13.5811,6,11,6,7.3218,6,6.1016,9.5332,6.0513,9.6836l1.8955.6377A3.44,3.44,0,0,1,11,8c2.92,0,4.2764,3.958,5.5874,7.7861.2544.7422.5105,1.4893.7813,2.2139H16v2h2.2019c1.0828,2.2886,2.4959,4,4.7981,4,3.6782,0,4.8984-3.5332,4.9487-3.6836Z"
    })), _path98$q || (_path98$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H18V8H16z",
      transform: "rotate(-90 17 7)"
    })), _path99$q || (_path99$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2H18V4H16z",
      transform: "rotate(-90 17 3)"
    })), children);
  });
  var ChartMedian16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMedian16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$q || (_path100$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H18V24H16z",
      transform: "rotate(-90 17 23)"
    })), _path101$q || (_path101$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26H16v2H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path102$q || (_path102$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0532,19.6787A3.44,3.44,0,0,1,23,22c-2.17,0-3.3115-3.333-4.52-6.8623-.3557-1.0386-.7239-2.1094-1.1382-3.1377H18V10H16.4221C15.2124,7.7148,13.5811,6,11,6,7.3218,6,6.1016,9.5332,6.0513,9.6836l1.8955.6377A3.44,3.44,0,0,1,11,8c2.92,0,4.2764,3.958,5.5874,7.7861.2544.7422.5105,1.4893.7813,2.2139H16v2h2.2019c1.0828,2.2886,2.4959,4,4.7981,4,3.6782,0,4.8984-3.5332,4.9487-3.6836Z"
    })), _path103$q || (_path103$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H18V8H16z",
      transform: "rotate(-90 17 7)"
    })), _path104$q || (_path104$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2H18V4H16z",
      transform: "rotate(-90 17 3)"
    })), children);
  });
  var ChartMinimum32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMinimum32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$q || (_path105$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H6V24H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path106$q || (_path106$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H10V26H8zM12 24H14V26H12zM20 24H22V26H20zM24 24H26V26H24zM28 24H30V26H28z"
    })), _path107$q || (_path107$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9463,4.3281,25.9727,4C23.9487,16.1084,21.0137,22,17,22S10.0513,16.1084,8.0271,4l-1.9734.3281C7.51,13.0566,9.9631,22.93,16,23.9131V26h2V23.9131C24.0371,22.93,26.4907,13.0566,27.9463,4.3281Z"
    })), children);
  });
  var ChartMinimum24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMinimum24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$q || (_path108$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H6V24H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path109$q || (_path109$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H10V26H8zM12 24H14V26H12zM20 24H22V26H20zM24 24H26V26H24zM28 24H30V26H28z"
    })), _path110$q || (_path110$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9463,4.3281,25.9727,4C23.9487,16.1084,21.0137,22,17,22S10.0513,16.1084,8.0271,4l-1.9734.3281C7.51,13.0566,9.9631,22.93,16,23.9131V26h2V23.9131C24.0371,22.93,26.4907,13.0566,27.9463,4.3281Z"
    })), children);
  });
  var ChartMinimum20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMinimum20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$q || (_path111$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H6V24H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path112$q || (_path112$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H10V26H8zM12 24H14V26H12zM20 24H22V26H20zM24 24H26V26H24zM28 24H30V26H28z"
    })), _path113$q || (_path113$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9463,4.3281,25.9727,4C23.9487,16.1084,21.0137,22,17,22S10.0513,16.1084,8.0271,4l-1.9734.3281C7.51,13.0566,9.9631,22.93,16,23.9131V26h2V23.9131C24.0371,22.93,26.4907,13.0566,27.9463,4.3281Z"
    })), children);
  });
  var ChartMinimum16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMinimum16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$q || (_path114$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,28V26H6V24H4V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), _path115$q || (_path115$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H10V26H8zM12 24H14V26H12zM20 24H22V26H20zM24 24H26V26H24zM28 24H30V26H28z"
    })), _path116$q || (_path116$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9463,4.3281,25.9727,4C23.9487,16.1084,21.0137,22,17,22S10.0513,16.1084,8.0271,4l-1.9734.3281C7.51,13.0566,9.9631,22.93,16,23.9131V26h2V23.9131C24.0371,22.93,26.4907,13.0566,27.9463,4.3281Z"
    })), children);
  });
  var ChartMultiLine32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultiLine32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$q || (_path117$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.5859,28l7.1783-5.998L19.7578,23.94a2.021,2.021,0,0,0,1.314-.1206L28,20.5811l-.8479-1.8121-6.9163,3.229L12.2422,20.06a2.0033,2.0033,0,0,0-1.74.3838L4,25.8818V20.49l7.7642-6.4877L19.7578,15.94a2.021,2.021,0,0,0,1.314-.1206l6.9287-3.2383-.8467-1.812-6.918,3.2285L12.2422,12.06a2.0049,2.0049,0,0,0-1.74.3838L4,17.8818V12.49L11.7642,6.002,19.7578,7.94a2.021,2.021,0,0,0,1.314-.1206L28,4.5859l-.8457-1.8115L20.2358,5.998,12.2422,4.06a2.0033,2.0033,0,0,0-1.74.3838L4,9.8818V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartMultiLine24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultiLine24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$q || (_path118$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.5859,28l7.1783-5.998L19.7578,23.94a2.021,2.021,0,0,0,1.314-.1206L28,20.5811l-.8479-1.8121-6.9163,3.229L12.2422,20.06a2.0033,2.0033,0,0,0-1.74.3838L4,25.8818V20.49l7.7642-6.4877L19.7578,15.94a2.021,2.021,0,0,0,1.314-.1206l6.9287-3.2383-.8467-1.812-6.918,3.2285L12.2422,12.06a2.0049,2.0049,0,0,0-1.74.3838L4,17.8818V12.49L11.7642,6.002,19.7578,7.94a2.021,2.021,0,0,0,1.314-.1206L28,4.5859l-.8457-1.8115L20.2358,5.998,12.2422,4.06a2.0033,2.0033,0,0,0-1.74.3838L4,9.8818V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartMultiLine20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultiLine20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$q || (_path119$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.5859,28l7.1783-5.998L19.7578,23.94a2.021,2.021,0,0,0,1.314-.1206L28,20.5811l-.8479-1.8121-6.9163,3.229L12.2422,20.06a2.0033,2.0033,0,0,0-1.74.3838L4,25.8818V20.49l7.7642-6.4877L19.7578,15.94a2.021,2.021,0,0,0,1.314-.1206l6.9287-3.2383-.8467-1.812-6.918,3.2285L12.2422,12.06a2.0049,2.0049,0,0,0-1.74.3838L4,17.8818V12.49L11.7642,6.002,19.7578,7.94a2.021,2.021,0,0,0,1.314-.1206L28,4.5859l-.8457-1.8115L20.2358,5.998,12.2422,4.06a2.0033,2.0033,0,0,0-1.74.3838L4,9.8818V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartMultiLine16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultiLine16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$q || (_path120$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.5859,28l7.1783-5.998L19.7578,23.94a2.021,2.021,0,0,0,1.314-.1206L28,20.5811l-.8479-1.8121-6.9163,3.229L12.2422,20.06a2.0033,2.0033,0,0,0-1.74.3838L4,25.8818V20.49l7.7642-6.4877L19.7578,15.94a2.021,2.021,0,0,0,1.314-.1206l6.9287-3.2383-.8467-1.812-6.918,3.2285L12.2422,12.06a2.0049,2.0049,0,0,0-1.74.3838L4,17.8818V12.49L11.7642,6.002,19.7578,7.94a2.021,2.021,0,0,0,1.314-.1206L28,4.5859l-.8457-1.8115L20.2358,5.998,12.2422,4.06a2.0033,2.0033,0,0,0-1.74.3838L4,9.8818V2H2V28a2,2,0,0,0,2,2H30V28Z"
    })), children);
  });
  var ChartMultitype32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultitype32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$q || (_path121$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H30V30H28zM24 18H26V30H24zM20 26H22V30H20zM9 16a7 7 0 107 7A7.0078 7.0078 0 009 16zm4.8989 6H10V18.1011A5.0145 5.0145 0 0113.8989 22zM9 28a5 5 0 01-1-9.8989V22a2 2 0 002 2h3.8989A5.0081 5.0081 0 019 28zM22.5352 12l4-6H30V4H25.4648l-4 6H18V2H16V14a2 2 0 002 2H30V14H18V12z"
    })), _circle$p || (_circle$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "1"
    })), _circle2$p || (_circle2$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _circle3$p || (_circle3$p = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "5",
      r: "1"
    })), _circle4$o || (_circle4$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "9",
      r: "1"
    })), _circle5$n || (_circle5$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "13",
      r: "1"
    })), children);
  });
  var ChartMultitype24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultitype24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$q || (_path122$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H30V30H28zM24 18H26V30H24zM20 26H22V30H20zM9 16a7 7 0 107 7A7.0078 7.0078 0 009 16zm4.8989 6H10V18.1011A5.0145 5.0145 0 0113.8989 22zM9 28a5 5 0 01-1-9.8989V22a2 2 0 002 2h3.8989A5.0081 5.0081 0 019 28zM22.5352 12l4-6H30V4H25.4648l-4 6H18V2H16V14a2 2 0 002 2H30V14H18V12z"
    })), _circle6$n || (_circle6$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "1"
    })), _circle7$n || (_circle7$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _circle8$n || (_circle8$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "5",
      r: "1"
    })), _circle9$n || (_circle9$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "9",
      r: "1"
    })), _circle10$n || (_circle10$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "13",
      r: "1"
    })), children);
  });
  var ChartMultitype20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultitype20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$q || (_path123$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H30V30H28zM24 18H26V30H24zM20 26H22V30H20zM9 16a7 7 0 107 7A7.0078 7.0078 0 009 16zm4.8989 6H10V18.1011A5.0145 5.0145 0 0113.8989 22zM9 28a5 5 0 01-1-9.8989V22a2 2 0 002 2h3.8989A5.0081 5.0081 0 019 28zM22.5352 12l4-6H30V4H25.4648l-4 6H18V2H16V14a2 2 0 002 2H30V14H18V12z"
    })), _circle11$m || (_circle11$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "1"
    })), _circle12$m || (_circle12$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _circle13$m || (_circle13$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "5",
      r: "1"
    })), _circle14$m || (_circle14$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "9",
      r: "1"
    })), _circle15$m || (_circle15$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "13",
      r: "1"
    })), children);
  });
  var ChartMultitype16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartMultitype16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$q || (_path124$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H30V30H28zM24 18H26V30H24zM20 26H22V30H20zM9 16a7 7 0 107 7A7.0078 7.0078 0 009 16zm4.8989 6H10V18.1011A5.0145 5.0145 0 0113.8989 22zM9 28a5 5 0 01-1-9.8989V22a2 2 0 002 2h3.8989A5.0081 5.0081 0 019 28zM22.5352 12l4-6H30V4H25.4648l-4 6H18V2H16V14a2 2 0 002 2H30V14H18V12z"
    })), _circle16$m || (_circle16$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "1"
    })), _circle17$l || (_circle17$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _circle18$l || (_circle18$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "5",
      r: "1"
    })), _circle19$l || (_circle19$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "9",
      r: "1"
    })), _circle20$l || (_circle20$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "13",
      r: "1"
    })), children);
  });
  var ChartNetwork32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartNetwork32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$q || (_path125$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"
    })), children);
  });
  var ChartNetwork24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartNetwork24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$q || (_path126$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"
    })), children);
  });
  var ChartNetwork20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartNetwork20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$q || (_path127$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"
    })), children);
  });
  var ChartNetwork16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartNetwork16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$q || (_path128$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"
    })), children);
  });
  var ChartParallel32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartParallel32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$q || (_path129$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V5.3071l-6,2.25V2H20V7.5229l-8-3.2V2H10V4.4458l-6,3.75V2H2V30H4V27.6182l6-3V30h2V24.3442l8,2.4V30h2V26.5542l6-3.75V30h2V2Zm0,5.4429V12.5L22,17V9.6929ZM20,9.6768v7.5571l-8-4.8V6.4771ZM10,6.8042v5.7417l-6,5.25V10.5542ZM4,25.3818V20.4541l6-5.25v7.1777Zm8-3.1259v-7.49l8,4.8v5.0894Zm10,1.94V19.5L28,15v5.4458Z"
    })), children);
  });
  var ChartParallel24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartParallel24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$q || (_path130$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V5.3071l-6,2.25V2H20V7.5229l-8-3.2V2H10V4.4458l-6,3.75V2H2V30H4V27.6182l6-3V30h2V24.3442l8,2.4V30h2V26.5542l6-3.75V30h2V2Zm0,5.4429V12.5L22,17V9.6929ZM20,9.6768v7.5571l-8-4.8V6.4771ZM10,6.8042v5.7417l-6,5.25V10.5542ZM4,25.3818V20.4541l6-5.25v7.1777Zm8-3.1259v-7.49l8,4.8v5.0894Zm10,1.94V19.5L28,15v5.4458Z"
    })), children);
  });
  var ChartParallel20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartParallel20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$q || (_path131$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V5.3071l-6,2.25V2H20V7.5229l-8-3.2V2H10V4.4458l-6,3.75V2H2V30H4V27.6182l6-3V30h2V24.3442l8,2.4V30h2V26.5542l6-3.75V30h2V2Zm0,5.4429V12.5L22,17V9.6929ZM20,9.6768v7.5571l-8-4.8V6.4771ZM10,6.8042v5.7417l-6,5.25V10.5542ZM4,25.3818V20.4541l6-5.25v7.1777Zm8-3.1259v-7.49l8,4.8v5.0894Zm10,1.94V19.5L28,15v5.4458Z"
    })), children);
  });
  var ChartParallel16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartParallel16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$q || (_path132$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V5.3071l-6,2.25V2H20V7.5229l-8-3.2V2H10V4.4458l-6,3.75V2H2V30H4V27.6182l6-3V30h2V24.3442l8,2.4V30h2V26.5542l6-3.75V30h2V2Zm0,5.4429V12.5L22,17V9.6929ZM20,9.6768v7.5571l-8-4.8V6.4771ZM10,6.8042v5.7417l-6,5.25V10.5542ZM4,25.3818V20.4541l6-5.25v7.1777Zm8-3.1259v-7.49l8,4.8v5.0894Zm10,1.94V19.5L28,15v5.4458Z"
    })), children);
  });
  var ChartPie32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPie32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$q || (_path133$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"
    })), children);
  });
  var ChartPie24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPie24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$q || (_path134$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"
    })), children);
  });
  var ChartPie20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPie20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$q || (_path135$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"
    })), children);
  });
  var ChartPie16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPie16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$q || (_path136$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"
    })), children);
  });
  var ChartPoint32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPoint32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$q || (_path137$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), _circle21$k || (_circle21$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "3"
    })), _circle22$k || (_circle22$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "22",
      r: "3"
    })), _circle23$j || (_circle23$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "14",
      r: "3"
    })), _path138$q || (_path138$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,17a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,9,17Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,9,13Z"
    })), _circle24$j || (_circle24$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "6",
      r: "3"
    })), _circle25$i || (_circle25$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "22",
      r: "3"
    })), _path139$q || (_path139$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 17a3 3 0 113-3A3.0033 3.0033 0 0127 17zm0-4a1 1 0 101 1A1.001 1.001 0 0027 13zM18 26a3 3 0 113-3A3.0033 3.0033 0 0118 26zm0-4a1 1 0 101 1A1.001 1.001 0 0018 22zM18 8a3 3 0 113-3A3.0033 3.0033 0 0118 8zm0-4a1 1 0 101 1A1.001 1.001 0 0018 4z"
    })), children);
  });
  var ChartPoint24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPoint24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$q || (_path140$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), _circle26$i || (_circle26$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "3"
    })), _circle27$h || (_circle27$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "22",
      r: "3"
    })), _circle28$h || (_circle28$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "14",
      r: "3"
    })), _path141$q || (_path141$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,17a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,9,17Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,9,13Z"
    })), _circle29$g || (_circle29$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "6",
      r: "3"
    })), _circle30$g || (_circle30$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "22",
      r: "3"
    })), _path142$q || (_path142$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 17a3 3 0 113-3A3.0033 3.0033 0 0127 17zm0-4a1 1 0 101 1A1.001 1.001 0 0027 13zM18 26a3 3 0 113-3A3.0033 3.0033 0 0118 26zm0-4a1 1 0 101 1A1.001 1.001 0 0018 22zM18 8a3 3 0 113-3A3.0033 3.0033 0 0118 8zm0-4a1 1 0 101 1A1.001 1.001 0 0018 4z"
    })), children);
  });
  var ChartPoint20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPoint20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$q || (_path143$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), _circle31$g || (_circle31$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "3"
    })), _circle32$g || (_circle32$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "22",
      r: "3"
    })), _circle33$f || (_circle33$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "14",
      r: "3"
    })), _path144$q || (_path144$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,17a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,9,17Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,9,13Z"
    })), _circle34$e || (_circle34$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "6",
      r: "3"
    })), _circle35$e || (_circle35$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "22",
      r: "3"
    })), _path145$q || (_path145$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 17a3 3 0 113-3A3.0033 3.0033 0 0127 17zm0-4a1 1 0 101 1A1.001 1.001 0 0027 13zM18 26a3 3 0 113-3A3.0033 3.0033 0 0118 26zm0-4a1 1 0 101 1A1.001 1.001 0 0018 22zM18 8a3 3 0 113-3A3.0033 3.0033 0 0118 8zm0-4a1 1 0 101 1A1.001 1.001 0 0018 4z"
    })), children);
  });
  var ChartPoint16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPoint16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$q || (_path146$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2.0023,2.0023,0,0,1-2-2V2H4V28H30Z"
    })), _circle36$e || (_circle36$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "3"
    })), _circle37$c || (_circle37$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "22",
      r: "3"
    })), _circle38$c || (_circle38$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "14",
      r: "3"
    })), _path147$q || (_path147$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,17a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,9,17Zm0-4a1,1,0,1,0,1,1A1.001,1.001,0,0,0,9,13Z"
    })), _circle39$c || (_circle39$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "6",
      r: "3"
    })), _circle40$c || (_circle40$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "22",
      r: "3"
    })), _path148$q || (_path148$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 17a3 3 0 113-3A3.0033 3.0033 0 0127 17zm0-4a1 1 0 101 1A1.001 1.001 0 0027 13zM18 26a3 3 0 113-3A3.0033 3.0033 0 0118 26zm0-4a1 1 0 101 1A1.001 1.001 0 0018 22zM18 8a3 3 0 113-3A3.0033 3.0033 0 0118 8zm0-4a1 1 0 101 1A1.001 1.001 0 0018 4z"
    })), children);
  });
  var ChartPopulation32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPopulation32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$q || (_path149$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H17V20h9V14H17V12h5V6H17V2H15V6H10v6h5v2H6v6h9v2H2v6H15v2h2V28H30ZM20,8v2H17V8Zm-8,2V8h3v2Zm12,6v2H17V16ZM8,18V16h7v2ZM4,26V24H15v2Zm24,0H17V24H28Z"
    })), children);
  });
  var ChartPopulation24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPopulation24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$q || (_path150$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H17V20h9V14H17V12h5V6H17V2H15V6H10v6h5v2H6v6h9v2H2v6H15v2h2V28H30ZM20,8v2H17V8Zm-8,2V8h3v2Zm12,6v2H17V16ZM8,18V16h7v2ZM4,26V24H15v2Zm24,0H17V24H28Z"
    })), children);
  });
  var ChartPopulation20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPopulation20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$q || (_path151$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H17V20h9V14H17V12h5V6H17V2H15V6H10v6h5v2H6v6h9v2H2v6H15v2h2V28H30ZM20,8v2H17V8Zm-8,2V8h3v2Zm12,6v2H17V16ZM8,18V16h7v2ZM4,26V24H15v2Zm24,0H17V24H28Z"
    })), children);
  });
  var ChartPopulation16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartPopulation16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$q || (_path152$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H17V20h9V14H17V12h5V6H17V2H15V6H10v6h5v2H6v6h9v2H2v6H15v2h2V28H30ZM20,8v2H17V8Zm-8,2V8h3v2Zm12,6v2H17V16ZM8,18V16h7v2ZM4,26V24H15v2Zm24,0H17V24H28Z"
    })), children);
  });
  var ChartRadar32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadar32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$q || (_path153$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2,2,13,8,30H24l6-17Zm2.5818,19.2651-5.9861,1.3306-1.4226-7.8252,4.91-4.209,5.4416,4.0816Zm.1977,2.0054L21.3264,28H10.6736l1.7912-3.3267ZM9.59,13.4937,5.74,12.605,15,5.3291V8.8569ZM17,8.75V5.3291l9.26,7.2759-3.15.727ZM4.6143,14.3979l4.6535,1.0738,1.4844,8.164-1.738,3.2281ZM22.9858,26.8638l-2.5766-4.7852,3.0063-6.7646,3.97-.9161Z"
    })), children);
  });
  var ChartRadar24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadar24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$q || (_path154$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2,2,13,8,30H24l6-17Zm2.5818,19.2651-5.9861,1.3306-1.4226-7.8252,4.91-4.209,5.4416,4.0816Zm.1977,2.0054L21.3264,28H10.6736l1.7912-3.3267ZM9.59,13.4937,5.74,12.605,15,5.3291V8.8569ZM17,8.75V5.3291l9.26,7.2759-3.15.727ZM4.6143,14.3979l4.6535,1.0738,1.4844,8.164-1.738,3.2281ZM22.9858,26.8638l-2.5766-4.7852,3.0063-6.7646,3.97-.9161Z"
    })), children);
  });
  var ChartRadar20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadar20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$q || (_path155$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2,2,13,8,30H24l6-17Zm2.5818,19.2651-5.9861,1.3306-1.4226-7.8252,4.91-4.209,5.4416,4.0816Zm.1977,2.0054L21.3264,28H10.6736l1.7912-3.3267ZM9.59,13.4937,5.74,12.605,15,5.3291V8.8569ZM17,8.75V5.3291l9.26,7.2759-3.15.727ZM4.6143,14.3979l4.6535,1.0738,1.4844,8.164-1.738,3.2281ZM22.9858,26.8638l-2.5766-4.7852,3.0063-6.7646,3.97-.9161Z"
    })), children);
  });
  var ChartRadar16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadar16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$q || (_path156$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2,2,13,8,30H24l6-17Zm2.5818,19.2651-5.9861,1.3306-1.4226-7.8252,4.91-4.209,5.4416,4.0816Zm.1977,2.0054L21.3264,28H10.6736l1.7912-3.3267ZM9.59,13.4937,5.74,12.605,15,5.3291V8.8569ZM17,8.75V5.3291l9.26,7.2759-3.15.727ZM4.6143,14.3979l4.6535,1.0738,1.4844,8.164-1.738,3.2281ZM22.9858,26.8638l-2.5766-4.7852,3.0063-6.7646,3.97-.9161Z"
    })), children);
  });
  var ChartRadial32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadial32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$q || (_path157$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path158$q || (_path158$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26A10.0115,10.0115,0,0,1,6,16H8a8,8,0,1,0,8-8V6a10,10,0,0,1,0,20Z"
    })), _path159$q || (_path159$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6.0069,6.0069,0,0,1-6-6h2a4,4,0,1,0,4-4V10a6,6,0,0,1,0,12Z"
    })), children);
  });
  var ChartRadial24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadial24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$q || (_path160$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path161$q || (_path161$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26A10.0115,10.0115,0,0,1,6,16H8a8,8,0,1,0,8-8V6a10,10,0,0,1,0,20Z"
    })), _path162$q || (_path162$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6.0069,6.0069,0,0,1-6-6h2a4,4,0,1,0,4-4V10a6,6,0,0,1,0,12Z"
    })), children);
  });
  var ChartRadial20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadial20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$q || (_path163$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path164$q || (_path164$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26A10.0115,10.0115,0,0,1,6,16H8a8,8,0,1,0,8-8V6a10,10,0,0,1,0,20Z"
    })), _path165$q || (_path165$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6.0069,6.0069,0,0,1-6-6h2a4,4,0,1,0,4-4V10a6,6,0,0,1,0,12Z"
    })), children);
  });
  var ChartRadial16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRadial16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$q || (_path166$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path167$q || (_path167$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26A10.0115,10.0115,0,0,1,6,16H8a8,8,0,1,0,8-8V6a10,10,0,0,1,0,20Z"
    })), _path168$q || (_path168$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6.0069,6.0069,0,0,1-6-6h2a4,4,0,1,0,4-4V10a6,6,0,0,1,0,12Z"
    })), children);
  });
  var ChartRelationship32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRelationship32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$q || (_path169$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6a3.9963,3.9963,0,0,0-3.8579,3H17.9305A7.9964,7.9964,0,1,0,9,17.9307v4.2114a4,4,0,1,0,2,0V17.9307a7.951,7.951,0,0,0,3.8976-1.6192l3.6693,3.67A3.9529,3.9529,0,0,0,18,22a4,4,0,1,0,4-4,3.9521,3.9521,0,0,0-2.019.5669l-3.6694-3.6694A7.9493,7.9493,0,0,0,17.9305,11h4.2116A3.9934,3.9934,0,1,0,26,6ZM12,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,12,26ZM10,16a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,10,16Zm14,6a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,24,22Zm2-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,12Z"
    })), children);
  });
  var ChartRelationship24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRelationship24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$q || (_path170$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6a3.9963,3.9963,0,0,0-3.8579,3H17.9305A7.9964,7.9964,0,1,0,9,17.9307v4.2114a4,4,0,1,0,2,0V17.9307a7.951,7.951,0,0,0,3.8976-1.6192l3.6693,3.67A3.9529,3.9529,0,0,0,18,22a4,4,0,1,0,4-4,3.9521,3.9521,0,0,0-2.019.5669l-3.6694-3.6694A7.9493,7.9493,0,0,0,17.9305,11h4.2116A3.9934,3.9934,0,1,0,26,6ZM12,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,12,26ZM10,16a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,10,16Zm14,6a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,24,22Zm2-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,12Z"
    })), children);
  });
  var ChartRelationship20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRelationship20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$q || (_path171$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6a3.9963,3.9963,0,0,0-3.8579,3H17.9305A7.9964,7.9964,0,1,0,9,17.9307v4.2114a4,4,0,1,0,2,0V17.9307a7.951,7.951,0,0,0,3.8976-1.6192l3.6693,3.67A3.9529,3.9529,0,0,0,18,22a4,4,0,1,0,4-4,3.9521,3.9521,0,0,0-2.019.5669l-3.6694-3.6694A7.9493,7.9493,0,0,0,17.9305,11h4.2116A3.9934,3.9934,0,1,0,26,6ZM12,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,12,26ZM10,16a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,10,16Zm14,6a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,24,22Zm2-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,12Z"
    })), children);
  });
  var ChartRelationship16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRelationship16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$q || (_path172$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6a3.9963,3.9963,0,0,0-3.8579,3H17.9305A7.9964,7.9964,0,1,0,9,17.9307v4.2114a4,4,0,1,0,2,0V17.9307a7.951,7.951,0,0,0,3.8976-1.6192l3.6693,3.67A3.9529,3.9529,0,0,0,18,22a4,4,0,1,0,4-4,3.9521,3.9521,0,0,0-2.019.5669l-3.6694-3.6694A7.9493,7.9493,0,0,0,17.9305,11h4.2116A3.9934,3.9934,0,1,0,26,6ZM12,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,12,26ZM10,16a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,10,16Zm14,6a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,24,22Zm2-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,12Z"
    })), children);
  });
  var ChartRing32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRing32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$q || (_path173$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9493,15.001H21.91a5.9825,5.9825,0,0,0-9.3806-3.8853l-4.27-4.27a11.9783,11.9783,0,0,1,19.69,8.1548ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20ZM4,16A11.937,11.937,0,0,1,6.8455,8.26l4.27,4.2695A5.9836,5.9836,0,0,0,15,21.9106v6.04A12.0105,12.0105,0,0,1,4,16ZM17,27.95v-6.04A6.0069,6.0069,0,0,0,21.91,17h6.04A12.0082,12.0082,0,0,1,17,27.95Z"
    })), children);
  });
  var ChartRing24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRing24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$q || (_path174$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9493,15.001H21.91a5.9825,5.9825,0,0,0-9.3806-3.8853l-4.27-4.27a11.9783,11.9783,0,0,1,19.69,8.1548ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20ZM4,16A11.937,11.937,0,0,1,6.8455,8.26l4.27,4.2695A5.9836,5.9836,0,0,0,15,21.9106v6.04A12.0105,12.0105,0,0,1,4,16ZM17,27.95v-6.04A6.0069,6.0069,0,0,0,21.91,17h6.04A12.0082,12.0082,0,0,1,17,27.95Z"
    })), children);
  });
  var ChartRing20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRing20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$q || (_path175$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9493,15.001H21.91a5.9825,5.9825,0,0,0-9.3806-3.8853l-4.27-4.27a11.9783,11.9783,0,0,1,19.69,8.1548ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20ZM4,16A11.937,11.937,0,0,1,6.8455,8.26l4.27,4.2695A5.9836,5.9836,0,0,0,15,21.9106v6.04A12.0105,12.0105,0,0,1,4,16ZM17,27.95v-6.04A6.0069,6.0069,0,0,0,21.91,17h6.04A12.0082,12.0082,0,0,1,17,27.95Z"
    })), children);
  });
  var ChartRing16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRing16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$q || (_path176$q = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9493,15.001H21.91a5.9825,5.9825,0,0,0-9.3806-3.8853l-4.27-4.27a11.9783,11.9783,0,0,1,19.69,8.1548ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20ZM4,16A11.937,11.937,0,0,1,6.8455,8.26l4.27,4.2695A5.9836,5.9836,0,0,0,15,21.9106v6.04A12.0105,12.0105,0,0,1,4,16ZM17,27.95v-6.04A6.0069,6.0069,0,0,0,21.91,17h6.04A12.0082,12.0082,0,0,1,17,27.95Z"
    })), children);
  });
  var ChartRiver32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRiver32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$p || (_path177$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4326,20.0171l8.0376,4.68a1.958,1.958,0,0,0,1.0508.3012,2.2412,2.2412,0,0,0,.4888-.0556l7.2532-1.9769A1,1,0,0,0,30,22.0007V7.996A1,1,0,0,0,28.74,7.0305L21.5034,8.9829l-8.0371-4.68a1.9917,1.9917,0,0,0-1.8652-.1352L4,7.4727V2H2V28a2,2,0,0,0,2,2H30V28H4V23.6577ZM28,21.2344l-6.4966,1.75-8.0371-4.68a1.9931,1.9931,0,0,0-1.8652-.1353L4,21.4746V16.6572l8.4326-3.6416L20.47,17.6968a1.962,1.962,0,0,0,1.0508.3008,2.2112,2.2112,0,0,0,.4888-.0557L28,16.31ZM12.4326,6.0156l8.0376,4.68a2.0091,2.0091,0,0,0,1.54.2451L28,9.3081v4.9258l-6.4966,1.7505-8.0371-4.6812a1.9917,1.9917,0,0,0-1.8652-.1352L4,14.4736V9.6562Z"
    })), children);
  });
  var ChartRiver24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRiver24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$p || (_path178$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4326,20.0171l8.0376,4.68a1.958,1.958,0,0,0,1.0508.3012,2.2412,2.2412,0,0,0,.4888-.0556l7.2532-1.9769A1,1,0,0,0,30,22.0007V7.996A1,1,0,0,0,28.74,7.0305L21.5034,8.9829l-8.0371-4.68a1.9917,1.9917,0,0,0-1.8652-.1352L4,7.4727V2H2V28a2,2,0,0,0,2,2H30V28H4V23.6577ZM28,21.2344l-6.4966,1.75-8.0371-4.68a1.9931,1.9931,0,0,0-1.8652-.1353L4,21.4746V16.6572l8.4326-3.6416L20.47,17.6968a1.962,1.962,0,0,0,1.0508.3008,2.2112,2.2112,0,0,0,.4888-.0557L28,16.31ZM12.4326,6.0156l8.0376,4.68a2.0091,2.0091,0,0,0,1.54.2451L28,9.3081v4.9258l-6.4966,1.7505-8.0371-4.6812a1.9917,1.9917,0,0,0-1.8652-.1352L4,14.4736V9.6562Z"
    })), children);
  });
  var ChartRiver20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRiver20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$p || (_path179$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4326,20.0171l8.0376,4.68a1.958,1.958,0,0,0,1.0508.3012,2.2412,2.2412,0,0,0,.4888-.0556l7.2532-1.9769A1,1,0,0,0,30,22.0007V7.996A1,1,0,0,0,28.74,7.0305L21.5034,8.9829l-8.0371-4.68a1.9917,1.9917,0,0,0-1.8652-.1352L4,7.4727V2H2V28a2,2,0,0,0,2,2H30V28H4V23.6577ZM28,21.2344l-6.4966,1.75-8.0371-4.68a1.9931,1.9931,0,0,0-1.8652-.1353L4,21.4746V16.6572l8.4326-3.6416L20.47,17.6968a1.962,1.962,0,0,0,1.0508.3008,2.2112,2.2112,0,0,0,.4888-.0557L28,16.31ZM12.4326,6.0156l8.0376,4.68a2.0091,2.0091,0,0,0,1.54.2451L28,9.3081v4.9258l-6.4966,1.7505-8.0371-4.6812a1.9917,1.9917,0,0,0-1.8652-.1352L4,14.4736V9.6562Z"
    })), children);
  });
  var ChartRiver16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRiver16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$p || (_path180$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4326,20.0171l8.0376,4.68a1.958,1.958,0,0,0,1.0508.3012,2.2412,2.2412,0,0,0,.4888-.0556l7.2532-1.9769A1,1,0,0,0,30,22.0007V7.996A1,1,0,0,0,28.74,7.0305L21.5034,8.9829l-8.0371-4.68a1.9917,1.9917,0,0,0-1.8652-.1352L4,7.4727V2H2V28a2,2,0,0,0,2,2H30V28H4V23.6577ZM28,21.2344l-6.4966,1.75-8.0371-4.68a1.9931,1.9931,0,0,0-1.8652-.1353L4,21.4746V16.6572l8.4326-3.6416L20.47,17.6968a1.962,1.962,0,0,0,1.0508.3008,2.2112,2.2112,0,0,0,.4888-.0557L28,16.31ZM12.4326,6.0156l8.0376,4.68a2.0091,2.0091,0,0,0,1.54.2451L28,9.3081v4.9258l-6.4966,1.7505-8.0371-4.6812a1.9917,1.9917,0,0,0-1.8652-.1352L4,14.4736V9.6562Z"
    })), children);
  });
  var ChartRose32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRose32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$p || (_path181$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17A15.017,15.017,0,0,0,15,2H14V8.0591A9.0122,9.0122,0,0,0,6.0591,16H4v1A11.0109,11.0109,0,0,0,14,27.9492V30h1A13.0084,13.0084,0,0,0,27.9492,18H30ZM16,4.0381A13.0217,13.0217,0,0,1,27.9619,16H16ZM14,10.08V16H8.08A7.0037,7.0037,0,0,1,14,10.08ZM6.0552,18H14v7.939A9.0134,9.0134,0,0,1,6.0552,18ZM16,27.9551V18h9.9551A11.0191,11.0191,0,0,1,16,27.9551Z"
    })), children);
  });
  var ChartRose24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRose24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$p || (_path182$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17A15.017,15.017,0,0,0,15,2H14V8.0591A9.0122,9.0122,0,0,0,6.0591,16H4v1A11.0109,11.0109,0,0,0,14,27.9492V30h1A13.0084,13.0084,0,0,0,27.9492,18H30ZM16,4.0381A13.0217,13.0217,0,0,1,27.9619,16H16ZM14,10.08V16H8.08A7.0037,7.0037,0,0,1,14,10.08ZM6.0552,18H14v7.939A9.0134,9.0134,0,0,1,6.0552,18ZM16,27.9551V18h9.9551A11.0191,11.0191,0,0,1,16,27.9551Z"
    })), children);
  });
  var ChartRose20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRose20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$p || (_path183$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17A15.017,15.017,0,0,0,15,2H14V8.0591A9.0122,9.0122,0,0,0,6.0591,16H4v1A11.0109,11.0109,0,0,0,14,27.9492V30h1A13.0084,13.0084,0,0,0,27.9492,18H30ZM16,4.0381A13.0217,13.0217,0,0,1,27.9619,16H16ZM14,10.08V16H8.08A7.0037,7.0037,0,0,1,14,10.08ZM6.0552,18H14v7.939A9.0134,9.0134,0,0,1,6.0552,18ZM16,27.9551V18h9.9551A11.0191,11.0191,0,0,1,16,27.9551Z"
    })), children);
  });
  var ChartRose16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartRose16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$p || (_path184$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17A15.017,15.017,0,0,0,15,2H14V8.0591A9.0122,9.0122,0,0,0,6.0591,16H4v1A11.0109,11.0109,0,0,0,14,27.9492V30h1A13.0084,13.0084,0,0,0,27.9492,18H30ZM16,4.0381A13.0217,13.0217,0,0,1,27.9619,16H16ZM14,10.08V16H8.08A7.0037,7.0037,0,0,1,14,10.08ZM6.0552,18H14v7.939A9.0134,9.0134,0,0,1,6.0552,18ZM16,27.9551V18h9.9551A11.0191,11.0191,0,0,1,16,27.9551Z"
    })), children);
  });
  var ChartScatter32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartScatter32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$p || (_path185$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _circle41$b || (_circle41$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "22",
      r: "2"
    })), _circle42$b || (_circle42$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "15",
      r: "2"
    })), _circle43$b || (_circle43$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "15",
      r: "2"
    })), _circle44$b || (_circle44$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "6",
      r: "2"
    })), _circle45$a || (_circle45$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), children);
  });
  var ChartScatter24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartScatter24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$p || (_path186$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _circle46$a || (_circle46$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "22",
      r: "2"
    })), _circle47$a || (_circle47$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "15",
      r: "2"
    })), _circle48$a || (_circle48$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "15",
      r: "2"
    })), _circle49$9 || (_circle49$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "6",
      r: "2"
    })), _circle50$8 || (_circle50$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), children);
  });
  var ChartScatter20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartScatter20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$p || (_path187$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _circle51$8 || (_circle51$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "22",
      r: "2"
    })), _circle52$8 || (_circle52$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "15",
      r: "2"
    })), _circle53$7 || (_circle53$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "15",
      r: "2"
    })), _circle54$7 || (_circle54$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "6",
      r: "2"
    })), _circle55$6 || (_circle55$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), children);
  });
  var ChartScatter16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartScatter16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$p || (_path188$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _circle56$6 || (_circle56$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "22",
      r: "2"
    })), _circle57$6 || (_circle57$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "15",
      r: "2"
    })), _circle58$6 || (_circle58$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "15",
      r: "2"
    })), _circle59$6 || (_circle59$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "6",
      r: "2"
    })), _circle60$6 || (_circle60$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), children);
  });
  var ChartSpiral32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSpiral32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$p || (_path189$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.919,13.919,0,0,0,7.3245,5.0327,1.9728,1.9728,0,0,0,7,5,2,2,0,0,0,5,7a1.9752,1.9752,0,0,0,.0327.3247A13.986,13.986,0,1,0,16,2Zm0,26A11.977,11.977,0,0,1,6.3589,8.8857a1.8311,1.8311,0,0,0,1.1528.04l1.4634,1.4634a8.9862,8.9862,0,0,0,11.8311,13.207,1.9916,1.9916,0,0,0,2.79-2.79,8.9294,8.9294,0,0,0,0-9.6124,1.9916,1.9916,0,0,0-2.79-2.79,8.9445,8.9445,0,0,0-10.417.5713L8.9258,7.5117a1.8294,1.8294,0,0,0-.04-1.1528A11.9925,11.9925,0,1,1,16,28Zm0-14a2,2,0,1,1-2,2A2.0025,2.0025,0,0,1,16,14Zm3.4331-.019,2.0552-2.0552a2.0443,2.0443,0,0,0,.2265.0454,6.9573,6.9573,0,0,1,0,8.0576,2.0443,2.0443,0,0,0-.2265.0454L19.4331,18.019a3.8788,3.8788,0,0,0,0-4.038Zm.5957-3.6958a1.9993,1.9993,0,0,0,.0454.2265L18.019,12.5669a3.8788,3.8788,0,0,0-4.038,0l-2.1653-2.1655a6.9522,6.9522,0,0,1,8.2131-.1162ZM12.5669,13.981A3.951,3.951,0,0,0,12,16a4.0045,4.0045,0,0,0,4,4,3.9521,3.9521,0,0,0,2.019-.5669l2.0552,2.0552a1.9993,1.9993,0,0,0-.0454.2265,6.988,6.988,0,0,1-9.6272-9.8994Z"
    })), children);
  });
  var ChartSpiral24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSpiral24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$p || (_path190$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.919,13.919,0,0,0,7.3245,5.0327,1.9728,1.9728,0,0,0,7,5,2,2,0,0,0,5,7a1.9752,1.9752,0,0,0,.0327.3247A13.986,13.986,0,1,0,16,2Zm0,26A11.977,11.977,0,0,1,6.3589,8.8857a1.8311,1.8311,0,0,0,1.1528.04l1.4634,1.4634a8.9862,8.9862,0,0,0,11.8311,13.207,1.9916,1.9916,0,0,0,2.79-2.79,8.9294,8.9294,0,0,0,0-9.6124,1.9916,1.9916,0,0,0-2.79-2.79,8.9445,8.9445,0,0,0-10.417.5713L8.9258,7.5117a1.8294,1.8294,0,0,0-.04-1.1528A11.9925,11.9925,0,1,1,16,28Zm0-14a2,2,0,1,1-2,2A2.0025,2.0025,0,0,1,16,14Zm3.4331-.019,2.0552-2.0552a2.0443,2.0443,0,0,0,.2265.0454,6.9573,6.9573,0,0,1,0,8.0576,2.0443,2.0443,0,0,0-.2265.0454L19.4331,18.019a3.8788,3.8788,0,0,0,0-4.038Zm.5957-3.6958a1.9993,1.9993,0,0,0,.0454.2265L18.019,12.5669a3.8788,3.8788,0,0,0-4.038,0l-2.1653-2.1655a6.9522,6.9522,0,0,1,8.2131-.1162ZM12.5669,13.981A3.951,3.951,0,0,0,12,16a4.0045,4.0045,0,0,0,4,4,3.9521,3.9521,0,0,0,2.019-.5669l2.0552,2.0552a1.9993,1.9993,0,0,0-.0454.2265,6.988,6.988,0,0,1-9.6272-9.8994Z"
    })), children);
  });
  var ChartSpiral20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSpiral20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$p || (_path191$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.919,13.919,0,0,0,7.3245,5.0327,1.9728,1.9728,0,0,0,7,5,2,2,0,0,0,5,7a1.9752,1.9752,0,0,0,.0327.3247A13.986,13.986,0,1,0,16,2Zm0,26A11.977,11.977,0,0,1,6.3589,8.8857a1.8311,1.8311,0,0,0,1.1528.04l1.4634,1.4634a8.9862,8.9862,0,0,0,11.8311,13.207,1.9916,1.9916,0,0,0,2.79-2.79,8.9294,8.9294,0,0,0,0-9.6124,1.9916,1.9916,0,0,0-2.79-2.79,8.9445,8.9445,0,0,0-10.417.5713L8.9258,7.5117a1.8294,1.8294,0,0,0-.04-1.1528A11.9925,11.9925,0,1,1,16,28Zm0-14a2,2,0,1,1-2,2A2.0025,2.0025,0,0,1,16,14Zm3.4331-.019,2.0552-2.0552a2.0443,2.0443,0,0,0,.2265.0454,6.9573,6.9573,0,0,1,0,8.0576,2.0443,2.0443,0,0,0-.2265.0454L19.4331,18.019a3.8788,3.8788,0,0,0,0-4.038Zm.5957-3.6958a1.9993,1.9993,0,0,0,.0454.2265L18.019,12.5669a3.8788,3.8788,0,0,0-4.038,0l-2.1653-2.1655a6.9522,6.9522,0,0,1,8.2131-.1162ZM12.5669,13.981A3.951,3.951,0,0,0,12,16a4.0045,4.0045,0,0,0,4,4,3.9521,3.9521,0,0,0,2.019-.5669l2.0552,2.0552a1.9993,1.9993,0,0,0-.0454.2265,6.988,6.988,0,0,1-9.6272-9.8994Z"
    })), children);
  });
  var ChartSpiral16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSpiral16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$p || (_path192$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.919,13.919,0,0,0,7.3245,5.0327,1.9728,1.9728,0,0,0,7,5,2,2,0,0,0,5,7a1.9752,1.9752,0,0,0,.0327.3247A13.986,13.986,0,1,0,16,2Zm0,26A11.977,11.977,0,0,1,6.3589,8.8857a1.8311,1.8311,0,0,0,1.1528.04l1.4634,1.4634a8.9862,8.9862,0,0,0,11.8311,13.207,1.9916,1.9916,0,0,0,2.79-2.79,8.9294,8.9294,0,0,0,0-9.6124,1.9916,1.9916,0,0,0-2.79-2.79,8.9445,8.9445,0,0,0-10.417.5713L8.9258,7.5117a1.8294,1.8294,0,0,0-.04-1.1528A11.9925,11.9925,0,1,1,16,28Zm0-14a2,2,0,1,1-2,2A2.0025,2.0025,0,0,1,16,14Zm3.4331-.019,2.0552-2.0552a2.0443,2.0443,0,0,0,.2265.0454,6.9573,6.9573,0,0,1,0,8.0576,2.0443,2.0443,0,0,0-.2265.0454L19.4331,18.019a3.8788,3.8788,0,0,0,0-4.038Zm.5957-3.6958a1.9993,1.9993,0,0,0,.0454.2265L18.019,12.5669a3.8788,3.8788,0,0,0-4.038,0l-2.1653-2.1655a6.9522,6.9522,0,0,1,8.2131-.1162ZM12.5669,13.981A3.951,3.951,0,0,0,12,16a4.0045,4.0045,0,0,0,4,4,3.9521,3.9521,0,0,0,2.019-.5669l2.0552,2.0552a1.9993,1.9993,0,0,0-.0454.2265,6.988,6.988,0,0,1-9.6272-9.8994Z"
    })), children);
  });
  var ChartStacked32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStacked32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$p || (_path193$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V6H20V28H16V14H8V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM22,8h4V18H22ZM10,16h4v6H10Z"
    })), children);
  });
  var ChartStacked24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStacked24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$p || (_path194$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V6H20V28H16V14H8V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM22,8h4V18H22ZM10,16h4v6H10Z"
    })), children);
  });
  var ChartStacked20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStacked20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$p || (_path195$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V6H20V28H16V14H8V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM22,8h4V18H22ZM10,16h4v6H10Z"
    })), children);
  });
  var ChartStacked16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStacked16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$q);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$p || (_path196$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V6H20V28H16V14H8V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM22,8h4V18H22ZM10,16h4v6H10Z"
    })), children);
  });
  var ChartStepper32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStepper32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$p || (_path197$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,22V14h8V6h8V4H20v8H12v8H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V22Z"
    })), children);
  });
  var ChartStepper24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStepper24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$p || (_path198$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,22V14h8V6h8V4H20v8H12v8H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V22Z"
    })), children);
  });
  var ChartStepper20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStepper20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$p || (_path199$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,22V14h8V6h8V4H20v8H12v8H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V22Z"
    })), children);
  });
  var ChartStepper16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartStepper16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$p || (_path200$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,22V14h8V6h8V4H20v8H12v8H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V22Z"
    })), children);
  });
  var ChartSunburst32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSunburst32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$p || (_path201$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-1,1v7.09a5.9618,5.9618,0,0,0-2.46,1.043L7.8384,6.4311a1.4554,1.4554,0,0,0-2.087.0244A14.05,14.05,0,0,0,9.8047,28.5972a10.8482,10.8482,0,0,0,1.8989.7676,14.0982,14.0982,0,0,0,13.8443-3.1319,1.4336,1.4336,0,0,0,.0278-2.0639L20.877,19.47A5.963,5.963,0,0,0,21.91,17H29a1,1,0,0,0,1-1A14.0158,14.0158,0,0,0,16,2Zm0,10a4,4,0,1,1-4,4A4.0045,4.0045,0,0,1,16,12ZM6.83,8.251l4.2959,4.2959a5.91,5.91,0,0,0-.0113,6.9243L6.8381,23.7481A12.0168,12.0168,0,0,1,6.83,8.251Zm1.4228,16.91,4.2759-4.2759A5.9589,5.9589,0,0,0,15,21.91v6.042A11.8783,11.8783,0,0,1,8.2529,25.1612ZM17,27.9561V21.9092a5.9631,5.9631,0,0,0,2.4609-1.0273l4.2818,4.2817A11.8905,11.8905,0,0,1,17,27.9561ZM21.91,15A6.0063,6.0063,0,0,0,17,10.09V4.041A12.0208,12.0208,0,0,1,27.9585,15Z"
    })), children);
  });
  var ChartSunburst24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSunburst24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$p || (_path202$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-1,1v7.09a5.9618,5.9618,0,0,0-2.46,1.043L7.8384,6.4311a1.4554,1.4554,0,0,0-2.087.0244A14.05,14.05,0,0,0,9.8047,28.5972a10.8482,10.8482,0,0,0,1.8989.7676,14.0982,14.0982,0,0,0,13.8443-3.1319,1.4336,1.4336,0,0,0,.0278-2.0639L20.877,19.47A5.963,5.963,0,0,0,21.91,17H29a1,1,0,0,0,1-1A14.0158,14.0158,0,0,0,16,2Zm0,10a4,4,0,1,1-4,4A4.0045,4.0045,0,0,1,16,12ZM6.83,8.251l4.2959,4.2959a5.91,5.91,0,0,0-.0113,6.9243L6.8381,23.7481A12.0168,12.0168,0,0,1,6.83,8.251Zm1.4228,16.91,4.2759-4.2759A5.9589,5.9589,0,0,0,15,21.91v6.042A11.8783,11.8783,0,0,1,8.2529,25.1612ZM17,27.9561V21.9092a5.9631,5.9631,0,0,0,2.4609-1.0273l4.2818,4.2817A11.8905,11.8905,0,0,1,17,27.9561ZM21.91,15A6.0063,6.0063,0,0,0,17,10.09V4.041A12.0208,12.0208,0,0,1,27.9585,15Z"
    })), children);
  });
  var ChartSunburst20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSunburst20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$p || (_path203$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-1,1v7.09a5.9618,5.9618,0,0,0-2.46,1.043L7.8384,6.4311a1.4554,1.4554,0,0,0-2.087.0244A14.05,14.05,0,0,0,9.8047,28.5972a10.8482,10.8482,0,0,0,1.8989.7676,14.0982,14.0982,0,0,0,13.8443-3.1319,1.4336,1.4336,0,0,0,.0278-2.0639L20.877,19.47A5.963,5.963,0,0,0,21.91,17H29a1,1,0,0,0,1-1A14.0158,14.0158,0,0,0,16,2Zm0,10a4,4,0,1,1-4,4A4.0045,4.0045,0,0,1,16,12ZM6.83,8.251l4.2959,4.2959a5.91,5.91,0,0,0-.0113,6.9243L6.8381,23.7481A12.0168,12.0168,0,0,1,6.83,8.251Zm1.4228,16.91,4.2759-4.2759A5.9589,5.9589,0,0,0,15,21.91v6.042A11.8783,11.8783,0,0,1,8.2529,25.1612ZM17,27.9561V21.9092a5.9631,5.9631,0,0,0,2.4609-1.0273l4.2818,4.2817A11.8905,11.8905,0,0,1,17,27.9561ZM21.91,15A6.0063,6.0063,0,0,0,17,10.09V4.041A12.0208,12.0208,0,0,1,27.9585,15Z"
    })), children);
  });
  var ChartSunburst16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartSunburst16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$p || (_path204$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-1,1v7.09a5.9618,5.9618,0,0,0-2.46,1.043L7.8384,6.4311a1.4554,1.4554,0,0,0-2.087.0244A14.05,14.05,0,0,0,9.8047,28.5972a10.8482,10.8482,0,0,0,1.8989.7676,14.0982,14.0982,0,0,0,13.8443-3.1319,1.4336,1.4336,0,0,0,.0278-2.0639L20.877,19.47A5.963,5.963,0,0,0,21.91,17H29a1,1,0,0,0,1-1A14.0158,14.0158,0,0,0,16,2Zm0,10a4,4,0,1,1-4,4A4.0045,4.0045,0,0,1,16,12ZM6.83,8.251l4.2959,4.2959a5.91,5.91,0,0,0-.0113,6.9243L6.8381,23.7481A12.0168,12.0168,0,0,1,6.83,8.251Zm1.4228,16.91,4.2759-4.2759A5.9589,5.9589,0,0,0,15,21.91v6.042A11.8783,11.8783,0,0,1,8.2529,25.1612ZM17,27.9561V21.9092a5.9631,5.9631,0,0,0,2.4609-1.0273l4.2818,4.2817A11.8905,11.8905,0,0,1,17,27.9561ZM21.91,15A6.0063,6.0063,0,0,0,17,10.09V4.041A12.0208,12.0208,0,0,1,27.9585,15Z"
    })), children);
  });
  var ChartTSne32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTSne32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle61$6 || (_circle61$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "20",
      r: "2"
    })), _circle62$6 || (_circle62$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle63$6 || (_circle63$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _circle64$6 || (_circle64$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), _circle65$6 || (_circle65$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "6",
      r: "2"
    })), _circle66$6 || (_circle66$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "10",
      r: "2"
    })), _circle67$6 || (_circle67$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "12",
      r: "2"
    })), _circle68$6 || (_circle68$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "22",
      r: "2"
    })), _circle69$6 || (_circle69$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "28",
      r: "2"
    })), _circle70$6 || (_circle70$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "26",
      r: "2"
    })), _circle71$6 || (_circle71$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "2"
    })), _circle72$6 || (_circle72$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle73$5 || (_circle73$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "24",
      r: "2"
    })), _circle74$5 || (_circle74$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), children);
  });
  var ChartTSne24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTSne24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle75$5 || (_circle75$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "20",
      r: "2"
    })), _circle76$5 || (_circle76$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle77$5 || (_circle77$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _circle78$5 || (_circle78$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), _circle79$5 || (_circle79$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "6",
      r: "2"
    })), _circle80$5 || (_circle80$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "10",
      r: "2"
    })), _circle81$5 || (_circle81$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "12",
      r: "2"
    })), _circle82$5 || (_circle82$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "22",
      r: "2"
    })), _circle83$5 || (_circle83$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "28",
      r: "2"
    })), _circle84$5 || (_circle84$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "26",
      r: "2"
    })), _circle85$4 || (_circle85$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "2"
    })), _circle86$4 || (_circle86$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle87$4 || (_circle87$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "24",
      r: "2"
    })), _circle88$4 || (_circle88$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), children);
  });
  var ChartTSne20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTSne20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle89$3 || (_circle89$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "20",
      r: "2"
    })), _circle90$3 || (_circle90$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle91$3 || (_circle91$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _circle92$3 || (_circle92$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), _circle93$3 || (_circle93$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "6",
      r: "2"
    })), _circle94$3 || (_circle94$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "10",
      r: "2"
    })), _circle95$3 || (_circle95$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "12",
      r: "2"
    })), _circle96$3 || (_circle96$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "22",
      r: "2"
    })), _circle97$3 || (_circle97$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "28",
      r: "2"
    })), _circle98$3 || (_circle98$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "26",
      r: "2"
    })), _circle99$3 || (_circle99$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "2"
    })), _circle100$3 || (_circle100$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle101$2 || (_circle101$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "24",
      r: "2"
    })), _circle102$2 || (_circle102$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), children);
  });
  var ChartTSne16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTSne16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle103$2 || (_circle103$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "20",
      r: "2"
    })), _circle104$2 || (_circle104$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle105$2 || (_circle105$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _circle106$2 || (_circle106$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), _circle107$2 || (_circle107$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "6",
      r: "2"
    })), _circle108$2 || (_circle108$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "10",
      r: "2"
    })), _circle109$2 || (_circle109$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "12",
      r: "2"
    })), _circle110$2 || (_circle110$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "22",
      r: "2"
    })), _circle111$2 || (_circle111$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "28",
      r: "2"
    })), _circle112$2 || (_circle112$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "26",
      r: "2"
    })), _circle113$2 || (_circle113$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "2"
    })), _circle114$2 || (_circle114$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle115$2 || (_circle115$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "24",
      r: "2"
    })), _circle116$2 || (_circle116$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), children);
  });
  var ChartTreemap32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTreemap32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$p || (_path205$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,12H23V4h5ZM16,4h5V14H16ZM14,4V20H4V4ZM4,22H14v6H4Zm12,6V16H28V28Z"
    })), children);
  });
  var ChartTreemap24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTreemap24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$p || (_path206$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,12H23V4h5ZM16,4h5V14H16ZM14,4V20H4V4ZM4,22H14v6H4Zm12,6V16H28V28Z"
    })), children);
  });
  var ChartTreemap20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTreemap20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$p || (_path207$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,12H23V4h5ZM16,4h5V14H16ZM14,4V20H4V4ZM4,22H14v6H4Zm12,6V16H28V28Z"
    })), children);
  });
  var ChartTreemap16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartTreemap16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$p || (_path208$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,12H23V4h5ZM16,4h5V14H16ZM14,4V20H4V4ZM4,22H14v6H4Zm12,6V16H28V28Z"
    })), children);
  });
  var ChartVennDiagram32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartVennDiagram32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$p || (_path209$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var ChartVennDiagram24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartVennDiagram24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$p || (_path210$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var ChartVennDiagram20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartVennDiagram20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$p || (_path211$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var ChartVennDiagram16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartVennDiagram16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$p || (_path212$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var ChartViolinPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartViolinPlot32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$p || (_path213$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path214$p || (_path214$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.86 7.8232L13 4.7231V2H11V4.7231l-1.86 3.1A7.9986 7.9986 0 008 11.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V19.2769l1.86-3.1A7.9986 7.9986 0 0016 12.061v-.122A7.9961 7.9961 0 0014.86 7.8232zM12 6.9434l1.145 1.9087A6.0027 6.0027 0 0113.9185 11h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0110.0815 13h3.837a6.0086 6.0086 0 01-.7735 2.1484zM27.86 11.8232L26 8.7231V2H24V8.7231l-1.86 3.1A7.9986 7.9986 0 0021 15.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V23.2769l1.86-3.1A7.9986 7.9986 0 0029 16.061v-.122A7.9961 7.9961 0 0027.86 11.8232zm-2.86-.88l1.145 1.9087A6.0027 6.0027 0 0126.9185 15h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0123.0815 17h3.837a6.0086 6.0086 0 01-.7735 2.1484z"
    })), children);
  });
  var ChartViolinPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartViolinPlot24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$p || (_path215$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path216$p || (_path216$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.86 7.8232L13 4.7231V2H11V4.7231l-1.86 3.1A7.9986 7.9986 0 008 11.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V19.2769l1.86-3.1A7.9986 7.9986 0 0016 12.061v-.122A7.9961 7.9961 0 0014.86 7.8232zM12 6.9434l1.145 1.9087A6.0027 6.0027 0 0113.9185 11h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0110.0815 13h3.837a6.0086 6.0086 0 01-.7735 2.1484zM27.86 11.8232L26 8.7231V2H24V8.7231l-1.86 3.1A7.9986 7.9986 0 0021 15.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V23.2769l1.86-3.1A7.9986 7.9986 0 0029 16.061v-.122A7.9961 7.9961 0 0027.86 11.8232zm-2.86-.88l1.145 1.9087A6.0027 6.0027 0 0126.9185 15h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0123.0815 17h3.837a6.0086 6.0086 0 01-.7735 2.1484z"
    })), children);
  });
  var ChartViolinPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartViolinPlot20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$p || (_path217$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path218$p || (_path218$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.86 7.8232L13 4.7231V2H11V4.7231l-1.86 3.1A7.9986 7.9986 0 008 11.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V19.2769l1.86-3.1A7.9986 7.9986 0 0016 12.061v-.122A7.9961 7.9961 0 0014.86 7.8232zM12 6.9434l1.145 1.9087A6.0027 6.0027 0 0113.9185 11h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0110.0815 13h3.837a6.0086 6.0086 0 01-.7735 2.1484zM27.86 11.8232L26 8.7231V2H24V8.7231l-1.86 3.1A7.9986 7.9986 0 0021 15.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V23.2769l1.86-3.1A7.9986 7.9986 0 0029 16.061v-.122A7.9961 7.9961 0 0027.86 11.8232zm-2.86-.88l1.145 1.9087A6.0027 6.0027 0 0126.9185 15h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0123.0815 17h3.837a6.0086 6.0086 0 01-.7735 2.1484z"
    })), children);
  });
  var ChartViolinPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartViolinPlot16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$p || (_path219$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"
    })), _path220$p || (_path220$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.86 7.8232L13 4.7231V2H11V4.7231l-1.86 3.1A7.9986 7.9986 0 008 11.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V19.2769l1.86-3.1A7.9986 7.9986 0 0016 12.061v-.122A7.9961 7.9961 0 0014.86 7.8232zM12 6.9434l1.145 1.9087A6.0027 6.0027 0 0113.9185 11h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0110.0815 13h3.837a6.0086 6.0086 0 01-.7735 2.1484zM27.86 11.8232L26 8.7231V2H24V8.7231l-1.86 3.1A7.9986 7.9986 0 0021 15.939v.122a7.9961 7.9961 0 001.14 4.1158l1.86 3.1V26h2V23.2769l1.86-3.1A7.9986 7.9986 0 0029 16.061v-.122A7.9961 7.9961 0 0027.86 11.8232zm-2.86-.88l1.145 1.9087A6.0027 6.0027 0 0126.9185 15h-3.837a6.0086 6.0086 0 01.7735-2.1484zm0 10.1132l-1.145-1.9087A6.0027 6.0027 0 0123.0815 17h3.837a6.0086 6.0086 0 01-.7735 2.1484z"
    })), children);
  });
  var ChartWaterfall32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWaterfall32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$p || (_path221$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V18H26V28H22V4H20V28H10V14H8V28H4V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), _path222$p || (_path222$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H16V18H14z"
    })), children);
  });
  var ChartWaterfall24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWaterfall24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$p || (_path223$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V18H26V28H22V4H20V28H10V14H8V28H4V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), _path224$p || (_path224$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H16V18H14z"
    })), children);
  });
  var ChartWaterfall20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWaterfall20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$p || (_path225$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V18H26V28H22V4H20V28H10V14H8V28H4V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), _path226$p || (_path226$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H16V18H14z"
    })), children);
  });
  var ChartWaterfall16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWaterfall16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$p || (_path227$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28V18H26V28H22V4H20V28H10V14H8V28H4V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), _path228$p || (_path228$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H16V18H14z"
    })), children);
  });
  var ChartWinLoss32 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWinLoss32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$p || (_path229$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H16V6a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,6v9H2v2H16v9a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V17h2ZM6,6h8v9H6ZM26,26H18V17h8Z"
    })), children);
  });
  var ChartWinLoss24 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWinLoss24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$p || (_path230$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H16V6a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,6v9H2v2H16v9a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V17h2ZM6,6h8v9H6ZM26,26H18V17h8Z"
    })), children);
  });
  var ChartWinLoss20 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWinLoss20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$p || (_path231$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H16V6a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,6v9H2v2H16v9a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V17h2ZM6,6h8v9H6ZM26,26H18V17h8Z"
    })), children);
  });
  var ChartWinLoss16 = /*#__PURE__*/React__default['default'].forwardRef(function ChartWinLoss16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$p || (_path232$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H16V6a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,6v9H2v2H16v9a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V17h2ZM6,6h8v9H6ZM26,26H18V17h8Z"
    })), children);
  });
  var Chat32 = /*#__PURE__*/React__default['default'].forwardRef(function Chat32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$p || (_path233$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path234$p || (_path234$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H24V12H8zM8 16H18V18H8z"
    })), children);
  });
  var Chat24 = /*#__PURE__*/React__default['default'].forwardRef(function Chat24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$p || (_path235$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path236$p || (_path236$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H24V12H8zM8 16H18V18H8z"
    })), children);
  });
  var Chat20 = /*#__PURE__*/React__default['default'].forwardRef(function Chat20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$p || (_path237$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path238$p || (_path238$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H24V12H8zM8 16H18V18H8z"
    })), children);
  });
  var Chat16 = /*#__PURE__*/React__default['default'].forwardRef(function Chat16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$p || (_path239$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"
    })), _path240$p || (_path240$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H24V12H8zM8 16H18V18H8z"
    })), children);
  });
  var ChatLaunch32 = /*#__PURE__*/React__default['default'].forwardRef(function ChatLaunch32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$p || (_path241$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4zM28 16v4a1.9965 1.9965 0 01-2 2H20l-4 7 1.7358 1 3.4288-6H26a3.9992 3.9992 0 004-4V16zM4 20V8A1.9965 1.9965 0 016 6H18V4H6A3.9986 3.9986 0 002 8V20a3.9992 3.9992 0 004 4h9V22H6A1.9965 1.9965 0 014 20z"
    })), children);
  });
  var ChatLaunch24 = /*#__PURE__*/React__default['default'].forwardRef(function ChatLaunch24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$p || (_path242$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4zM28 16v4a1.9965 1.9965 0 01-2 2H20l-4 7 1.7358 1 3.4288-6H26a3.9992 3.9992 0 004-4V16zM4 20V8A1.9965 1.9965 0 016 6H18V4H6A3.9986 3.9986 0 002 8V20a3.9992 3.9992 0 004 4h9V22H6A1.9965 1.9965 0 014 20z"
    })), children);
  });
  var ChatLaunch20 = /*#__PURE__*/React__default['default'].forwardRef(function ChatLaunch20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$p || (_path243$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4zM28 16v4a1.9965 1.9965 0 01-2 2H20l-4 7 1.7358 1 3.4288-6H26a3.9992 3.9992 0 004-4V16zM4 20V8A1.9965 1.9965 0 016 6H18V4H6A3.9986 3.9986 0 002 8V20a3.9992 3.9992 0 004 4h9V22H6A1.9965 1.9965 0 014 20z"
    })), children);
  });
  var ChatLaunch16 = /*#__PURE__*/React__default['default'].forwardRef(function ChatLaunch16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$p || (_path244$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 26.586 6 20 12.586 21.414 14 28 7.414 28 12 30 12 30 4 22 4zM28 16v4a1.9965 1.9965 0 01-2 2H20l-4 7 1.7358 1 3.4288-6H26a3.9992 3.9992 0 004-4V16zM4 20V8A1.9965 1.9965 0 016 6H18V4H6A3.9986 3.9986 0 002 8V20a3.9992 3.9992 0 004 4h9V22H6A1.9965 1.9965 0 014 20z"
    })), children);
  });
  var ChatOff32 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOff32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$p || (_path245$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8V21h2V8a3.9986 3.9986 0 00-4-4H8.2429l2 2H26A1.9965 1.9965 0 0128 8zM30 28.5859L3.4141 2 2 3.4141 3.5039 4.918A3.9181 3.9181 0 002 8V20a3.9992 3.9992 0 004 4h6V22H6a1.9965 1.9965 0 01-2-2V8a1.9814 1.9814 0 01.9194-1.6665L20.5859 22H17l-4 7 1.7358 1 3.4288-6h4.4213l6 6z"
    })), children);
  });
  var ChatOff24 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOff24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$p || (_path246$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8V21h2V8a3.9986 3.9986 0 00-4-4H8.2429l2 2H26A1.9965 1.9965 0 0128 8zM30 28.5859L3.4141 2 2 3.4141 3.5039 4.918A3.9181 3.9181 0 002 8V20a3.9992 3.9992 0 004 4h6V22H6a1.9965 1.9965 0 01-2-2V8a1.9814 1.9814 0 01.9194-1.6665L20.5859 22H17l-4 7 1.7358 1 3.4288-6h4.4213l6 6z"
    })), children);
  });
  var ChatOff20 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOff20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$p || (_path247$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8V21h2V8a3.9986 3.9986 0 00-4-4H8.2429l2 2H26A1.9965 1.9965 0 0128 8zM30 28.5859L3.4141 2 2 3.4141 3.5039 4.918A3.9181 3.9181 0 002 8V20a3.9992 3.9992 0 004 4h6V22H6a1.9965 1.9965 0 01-2-2V8a1.9814 1.9814 0 01.9194-1.6665L20.5859 22H17l-4 7 1.7358 1 3.4288-6h4.4213l6 6z"
    })), children);
  });
  var ChatOff16 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOff16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$p || (_path248$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8V21h2V8a3.9986 3.9986 0 00-4-4H8.2429l2 2H26A1.9965 1.9965 0 0128 8zM30 28.5859L3.4141 2 2 3.4141 3.5039 4.918A3.9181 3.9181 0 002 8V20a3.9992 3.9992 0 004 4h6V22H6a1.9965 1.9965 0 01-2-2V8a1.9814 1.9814 0 01.9194-1.6665L20.5859 22H17l-4 7 1.7358 1 3.4288-6h4.4213l6 6z"
    })), children);
  });
  var ChatOperational32 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOperational32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$p || (_path249$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.586 10.414L19.166 14 19.166 14 15.584 17.587 17 19 22 14 17 9 15.586 10.414z"
    })), _path250$p || (_path250$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 10.414L24.166 14 24.166 14 20.584 17.587 22 19 27 14 22 9 20.586 10.414zM10 9L11.593 12 15 12.414 12.5 14.667 13 18 10 16.125 7 18 7.5 14.667 5 12.414 8.5 12 10 9z"
    })), _path251$p || (_path251$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatOperational24 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOperational24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$p || (_path252$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.586 10.414L19.166 14 19.166 14 15.584 17.587 17 19 22 14 17 9 15.586 10.414z"
    })), _path253$p || (_path253$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 10.414L24.166 14 24.166 14 20.584 17.587 22 19 27 14 22 9 20.586 10.414zM10 9L11.593 12 15 12.414 12.5 14.667 13 18 10 16.125 7 18 7.5 14.667 5 12.414 8.5 12 10 9z"
    })), _path254$p || (_path254$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatOperational20 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOperational20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$p || (_path255$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.586 10.414L19.166 14 19.166 14 15.584 17.587 17 19 22 14 17 9 15.586 10.414z"
    })), _path256$p || (_path256$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 10.414L24.166 14 24.166 14 20.584 17.587 22 19 27 14 22 9 20.586 10.414zM10 9L11.593 12 15 12.414 12.5 14.667 13 18 10 16.125 7 18 7.5 14.667 5 12.414 8.5 12 10 9z"
    })), _path257$p || (_path257$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatOperational16 = /*#__PURE__*/React__default['default'].forwardRef(function ChatOperational16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$p || (_path258$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.586 10.414L19.166 14 19.166 14 15.584 17.587 17 19 22 14 17 9 15.586 10.414z"
    })), _path259$p || (_path259$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 10.414L24.166 14 24.166 14 20.584 17.587 22 19 27 14 22 9 20.586 10.414zM10 9L11.593 12 15 12.414 12.5 14.667 13 18 10 16.125 7 18 7.5 14.667 5 12.414 8.5 12 10 9z"
    })), _path260$p || (_path260$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatBot32 = /*#__PURE__*/React__default['default'].forwardRef(function ChatBot32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$p || (_path261$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 19zM20 8a2 2 0 102 2A1.9806 1.9806 0 0020 8zM12 8a2 2 0 102 2A1.9806 1.9806 0 0012 8z"
    })), _path262$p || (_path262$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatBot24 = /*#__PURE__*/React__default['default'].forwardRef(function ChatBot24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$p || (_path263$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 19zM20 8a2 2 0 102 2A1.9806 1.9806 0 0020 8zM12 8a2 2 0 102 2A1.9806 1.9806 0 0012 8z"
    })), _path264$p || (_path264$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatBot20 = /*#__PURE__*/React__default['default'].forwardRef(function ChatBot20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$p || (_path265$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 19zM20 8a2 2 0 102 2A1.9806 1.9806 0 0020 8zM12 8a2 2 0 102 2A1.9806 1.9806 0 0012 8z"
    })), _path266$p || (_path266$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ChatBot16 = /*#__PURE__*/React__default['default'].forwardRef(function ChatBot16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$p || (_path267$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 19zM20 8a2 2 0 102 2A1.9806 1.9806 0 0020 8zM12 8a2 2 0 102 2A1.9806 1.9806 0 0012 8z"
    })), _path268$p || (_path268$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var Checkbox32 = /*#__PURE__*/React__default['default'].forwardRef(function Checkbox32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$p || (_path269$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var Checkbox24 = /*#__PURE__*/React__default['default'].forwardRef(function Checkbox24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$p || (_path270$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var Checkbox20 = /*#__PURE__*/React__default['default'].forwardRef(function Checkbox20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$p || (_path271$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var Checkbox16 = /*#__PURE__*/React__default['default'].forwardRef(function Checkbox16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$p || (_path272$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxChecked32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxChecked32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$p || (_path273$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), _path274$p || (_path274$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"
    })), children);
  });
  var CheckboxChecked24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxChecked24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$p || (_path275$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), _path276$p || (_path276$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"
    })), children);
  });
  var CheckboxChecked20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxChecked20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$p || (_path277$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), _path278$p || (_path278$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"
    })), children);
  });
  var CheckboxChecked16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxChecked16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$p || (_path279$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), _path280$p || (_path280$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"
    })), children);
  });
  var CheckboxCheckedFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxCheckedFilled32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$p || (_path281$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z"
    })), _path282$p || (_path282$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxCheckedFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxCheckedFilled24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$p || (_path283$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z"
    })), _path284$p || (_path284$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxCheckedFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxCheckedFilled20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$p || (_path285$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z"
    })), _path286$p || (_path286$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxCheckedFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxCheckedFilled16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$p || (_path287$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z"
    })), _path288$p || (_path288$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14,21.5,9,16.5427,10.5908,15,14,18.3456,21.4087,11l1.5918,1.5772Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxIndeterminate32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminate32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$p || (_path289$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path290$p || (_path290$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxIndeterminate24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminate24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$p || (_path291$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path292$p || (_path292$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxIndeterminate20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminate20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$p || (_path293$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path294$p || (_path294$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxIndeterminate16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminate16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$p || (_path295$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path296$p || (_path296$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxIndeterminateFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminateFilled32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$p || (_path297$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), _path298$p || (_path298$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,18H10V14H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxIndeterminateFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminateFilled24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$p || (_path299$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), _path300$p || (_path300$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,18H10V14H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxIndeterminateFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminateFilled20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$p || (_path301$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), _path302$p || (_path302$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,18H10V14H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxIndeterminateFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxIndeterminateFilled16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$p || (_path303$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), _path304$p || (_path304$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,18H10V14H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckboxUndeterminate32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminate32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminate32']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminate32'] = true;
        console.warn("The CheckboxUndeterminate32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$p || (_path305$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path306$p || (_path306$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxUndeterminate24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminate24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminate24']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminate24'] = true;
        console.warn("The CheckboxUndeterminate24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$p || (_path307$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path308$p || (_path308$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxUndeterminate20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminate20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminate20']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminate20'] = true;
        console.warn("The CheckboxUndeterminate20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$p || (_path309$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path310$p || (_path310$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxUndeterminate16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminate16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminate16']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminate16'] = true;
        console.warn("The CheckboxUndeterminate16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$p || (_path311$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 14H22V18H10z"
    })), _path312$p || (_path312$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CheckboxUndeterminateFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminateFilled32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminateFilled32']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminateFilled32'] = true;
        console.warn("The CheckboxUndeterminateFilled32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$p || (_path313$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), children);
  });
  var CheckboxUndeterminateFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminateFilled24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminateFilled24']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminateFilled24'] = true;
        console.warn("The CheckboxUndeterminateFilled24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$p || (_path314$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), children);
  });
  var CheckboxUndeterminateFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminateFilled20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminateFilled20']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminateFilled20'] = true;
        console.warn("The CheckboxUndeterminateFilled20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$p || (_path315$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), children);
  });
  var CheckboxUndeterminateFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckboxUndeterminateFilled16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$p);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$a['CheckboxUndeterminateFilled16']) {
        didWarnAboutDeprecation$a['CheckboxUndeterminateFilled16'] = true;
        console.warn("The CheckboxUndeterminateFilled16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$p || (_path316$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"
    })), children);
  });
  var Checkmark32 = /*#__PURE__*/React__default['default'].forwardRef(function Checkmark32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$p || (_path317$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 24L4 15 5.414 13.586 13 21.171 26.586 7.586 28 9 13 24z"
    })), children);
  });
  var Checkmark24 = /*#__PURE__*/React__default['default'].forwardRef(function Checkmark24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$p || (_path318$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 15.9L4.7 10.6 3.6 11.6 8.9 16.9 10 18 20.6 7.4 19.5 6.3z"
    })), children);
  });
  var Checkmark20 = /*#__PURE__*/React__default['default'].forwardRef(function Checkmark20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$p || (_path319$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 13.2L3.6 8.8 2.7 9.7 7.1 14.1 8 15 16.5 6.5 15.6 5.6z"
    })), _path320$p || (_path320$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.6 5.6L8 13.2 3.6 8.8 2.7 9.7 7.1 14.1 8 15 16.5 6.5 15.6 5.6z"
    })), children);
  });
  var Checkmark16 = /*#__PURE__*/React__default['default'].forwardRef(function Checkmark16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$p || (_path321$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 24L4 15 5.414 13.586 13 21.171 26.586 7.586 28 9 13 24z"
    })), children);
  });
  var CheckmarkFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilled32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$p || (_path322$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,21.5908l-5-5L10.5906,15,14,18.4092,21.41,11l1.5957,1.5859Z"
    })), _path323$p || (_path323$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14 21.591L9 16.591 10.591 15 14 18.409 21.41 11 23.005 12.585 14 21.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilled24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$p || (_path324$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,1C6,1,1,6,1,12s5,11,11,11s11-4.9,11-11S18.1,1,12,1z M10.4,16.3l-3.9-3.9l1.3-1.2l2.7,2.7l5.8-5.8l1.3,1.3L10.4,16.3z"
    })), _path325$p || (_path325$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M10.4,16.3l-3.9-3.9l1.3-1.2l2.7,2.7l5.8-5.8l1.3,1.3L10.4,16.3z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var CheckmarkFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilled20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$p || (_path326$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,1c-4.9,0-9,4.1-9,9s4.1,9,9,9s9-4,9-9S15,1,10,1z M8.7,13.5l-3.2-3.2l1-1l2.2,2.2l4.8-4.8l1,1L8.7,13.5z"
    })), _path327$p || (_path327$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8.7,13.5l-3.2-3.2l1-1l2.2,2.2l4.8-4.8l1,1L8.7,13.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var CheckmarkFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilled16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$p || (_path328$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8c0,3.9,3.1,7,7,7s7-3.1,7-7C15,4.1,11.9,1,8,1z M7,11L4.3,8.3l0.9-0.8L7,9.3l4-3.9l0.9,0.8L7,11z"
    })), _path329$p || (_path329$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,11L4.3,8.3l0.9-0.8L7,9.3l4-3.9l0.9,0.8L7,11z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var CheckmarkFilledError32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledError32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$p || (_path330$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path331$p || (_path331$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.82V24a8,8,0,0,1,8-8h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path332$p || (_path332$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledError24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledError24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$p || (_path333$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path334$p || (_path334$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.82V24a8,8,0,0,1,8-8h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path335$p || (_path335$p = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledError20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledError20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$p || (_path336$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path337$p || (_path337$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.82V24a8,8,0,0,1,8-8h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path338$o || (_path338$o = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledError16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledError16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$o || (_path339$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path340$o || (_path340$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.82V24a8,8,0,0,1,8-8h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path341$o || (_path341$o = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledWarning32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$o || (_path342$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,3.3928,23.5059l3.9246-7.8492A2.9846,2.9846,0,0,1,24,16h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path343$o || (_path343$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path344$o || (_path344$o = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledWarning24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$o || (_path345$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,3.3928,23.5059l3.9246-7.8492A2.9846,2.9846,0,0,1,24,16h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path346$o || (_path346$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path347$o || (_path347$o = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledWarning20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$o || (_path348$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,3.3928,23.5059l3.9246-7.8492A2.9846,2.9846,0,0,1,24,16h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path349$o || (_path349$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path350$o || (_path350$o = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkFilledWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkFilledWarning16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$o || (_path351$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,3.3928,23.5059l3.9246-7.8492A2.9846,2.9846,0,0,1,24,16h1.82A11.9348,11.9348,0,0,0,14,2ZM12,18.5908l-4-4L9.5908,13,12,15.4092,17.4092,10,19,11.5908Z"
    })), _path352$o || (_path352$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path353$o || (_path353$o = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12 18.591L8 14.591 9.591 13 12 15.409 17.409 10 19 11.591 12 18.591z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var CheckmarkOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutline32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$o || (_path354$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.414L9 16.413 10.413 15 14 18.586 21.585 11 23 12.415 14 21.414z"
    })), _path355$n || (_path355$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var CheckmarkOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutline24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$n || (_path356$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.414L9 16.413 10.413 15 14 18.586 21.585 11 23 12.415 14 21.414z"
    })), _path357$n || (_path357$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var CheckmarkOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutline20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$n || (_path358$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.414L9 16.413 10.413 15 14 18.586 21.585 11 23 12.415 14 21.414z"
    })), _path359$n || (_path359$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var CheckmarkOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutline16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$n || (_path360$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 21.414L9 16.413 10.413 15 14 18.586 21.585 11 23 12.415 14 21.414z"
    })), _path361$m || (_path361$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var CheckmarkOutlineError32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineError32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$m || (_path362$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path363$k || (_path363$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var CheckmarkOutlineError24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineError24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$k || (_path364$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path365$k || (_path365$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var CheckmarkOutlineError20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineError20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$k || (_path366$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path367$k || (_path367$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var CheckmarkOutlineError16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineError16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$k || (_path368$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path369$k || (_path369$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var CheckmarkOutlineWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineWarning32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$k || (_path370$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path371$k || (_path371$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var CheckmarkOutlineWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineWarning24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$k || (_path372$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path373$k || (_path373$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var CheckmarkOutlineWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineWarning20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$k || (_path374$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path375$j || (_path375$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var CheckmarkOutlineWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function CheckmarkOutlineWarning16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$j || (_path376$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), _path377$j || (_path377$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var Chemistry32 = /*#__PURE__*/React__default['default'].forwardRef(function Chemistry32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$j || (_path378$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"
    })), children);
  });
  var Chemistry24 = /*#__PURE__*/React__default['default'].forwardRef(function Chemistry24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$j || (_path379$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"
    })), children);
  });
  var Chemistry20 = /*#__PURE__*/React__default['default'].forwardRef(function Chemistry20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$j || (_path380$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"
    })), children);
  });
  var Chemistry16 = /*#__PURE__*/React__default['default'].forwardRef(function Chemistry16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$j || (_path381$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"
    })), children);
  });
  var ChemistryReference32 = /*#__PURE__*/React__default['default'].forwardRef(function ChemistryReference32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$j || (_path382$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path383$j || (_path383$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13.67V4h2V2H10V4h2v9.67L9.58,17h2.4767L14,14.33V4h4V14.33l7.61,10.46a2.0133,2.0133,0,0,1-.44,2.82,2.0406,2.0406,0,0,1-1.19.39H15v2h8.98a4.0154,4.0154,0,0,0,3.25-6.38Z"
    })), children);
  });
  var ChemistryReference24 = /*#__PURE__*/React__default['default'].forwardRef(function ChemistryReference24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$i || (_path384$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path385$i || (_path385$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13.67V4h2V2H10V4h2v9.67L9.58,17h2.4767L14,14.33V4h4V14.33l7.61,10.46a2.0133,2.0133,0,0,1-.44,2.82,2.0406,2.0406,0,0,1-1.19.39H15v2h8.98a4.0154,4.0154,0,0,0,3.25-6.38Z"
    })), children);
  });
  var ChemistryReference20 = /*#__PURE__*/React__default['default'].forwardRef(function ChemistryReference20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$i || (_path386$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path387$i || (_path387$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13.67V4h2V2H10V4h2v9.67L9.58,17h2.4767L14,14.33V4h4V14.33l7.61,10.46a2.0133,2.0133,0,0,1-.44,2.82,2.0406,2.0406,0,0,1-1.19.39H15v2h8.98a4.0154,4.0154,0,0,0,3.25-6.38Z"
    })), children);
  });
  var ChemistryReference16 = /*#__PURE__*/React__default['default'].forwardRef(function ChemistryReference16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$i || (_path388$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path389$i || (_path389$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13.67V4h2V2H10V4h2v9.67L9.58,17h2.4767L14,14.33V4h4V14.33l7.61,10.46a2.0133,2.0133,0,0,1-.44,2.82,2.0406,2.0406,0,0,1-1.19.39H15v2h8.98a4.0154,4.0154,0,0,0,3.25-6.38Z"
    })), children);
  });
  var ChevronDown32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronDown32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$i || (_path390$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22L6 12 7.4 10.6 16 19.2 24.6 10.6 26 12z"
    })), children);
  });
  var ChevronDown24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronDown24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$i || (_path391$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22L6 12 7.4 10.6 16 19.2 24.6 10.6 26 12z"
    })), children);
  });
  var ChevronDown20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronDown20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$i || (_path392$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22L6 12 7.4 10.6 16 19.2 24.6 10.6 26 12z"
    })), children);
  });
  var ChevronDown16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronDown16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$i || (_path393$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z"
    })), children);
  });
  var ChevronDownGlyph = /*#__PURE__*/React__default['default'].forwardRef(function ChevronDownGlyph(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 10,
      height: 6,
      viewBox: "0 0 10 6",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$i || (_path394$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 6L0 1 0.7 0.3 5 4.6 9.3 0.3 10 1z"
    })), children);
  });
  var ChevronLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronLeft32(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$i || (_path395$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16L20 6 21.4 7.4 12.8 16 21.4 24.6 20 26z"
    })), children);
  });
  var ChevronLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronLeft24(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$i || (_path396$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16L20 6 21.4 7.4 12.8 16 21.4 24.6 20 26z"
    })), children);
  });
  var ChevronLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronLeft20(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$i || (_path397$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16L20 6 21.4 7.4 12.8 16 21.4 24.6 20 26z"
    })), children);
  });
  var ChevronLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronLeft16(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$i || (_path398$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 8L10 3 10.7 3.7 6.4 8 10.7 12.3 10 13z"
    })), children);
  });
  var ChevronLeftGlyph = /*#__PURE__*/React__default['default'].forwardRef(function ChevronLeftGlyph(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 6,
      height: 10,
      viewBox: "0 0 6 10",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$h || (_path399$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0 5L5 0 5.7 0.7 1.4 5 5.7 9.3 5 10z"
    })), children);
  });
  var ChevronMini32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronMini32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$h || (_path400$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 19L31 31 19 31 31 19z"
    })), children);
  });
  var ChevronMini24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronMini24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$h || (_path401$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 19L31 31 19 31 31 19z"
    })), children);
  });
  var ChevronMini20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronMini20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$h || (_path402$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 19L31 31 19 31 31 19z"
    })), children);
  });
  var ChevronMini16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronMini16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$g || (_path403$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L15 15 9 15z"
    })), children);
  });
  var ChevronRight32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronRight32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$g || (_path404$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L12 26 10.6 24.6 19.2 16 10.6 7.4 12 6z"
    })), children);
  });
  var ChevronRight24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronRight24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$f || (_path405$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L12 26 10.6 24.6 19.2 16 10.6 7.4 12 6z"
    })), children);
  });

  var _path$p, _path2$p, _path3$p, _path4$p, _path5$p, _path6$p, _path7$p, _path8$p, _path9$p, _path10$p, _path11$p, _path12$p, _path13$p, _path14$p, _path15$p, _path16$p, _path17$p, _path18$p, _path19$p, _path20$p, _path21$p, _path22$p, _path23$p, _path24$p, _path25$p, _path26$p, _path27$p, _path28$p, _path29$p, _path30$p, _path31$p, _path32$p, _path33$p, _path34$p, _path35$p, _path36$p, _path37$p, _path38$p, _path39$p, _path40$p, _path41$p, _path42$p, _path43$p, _path44$p, _path45$p, _path46$p, _path47$p, _path48$p, _path49$p, _path50$p, _path51$p, _path52$p, _path53$p, _path54$p, _path55$p, _path56$p, _path57$p, _path58$p, _path59$p, _path60$p, _path61$p, _path62$p, _path63$p, _path64$p, _path65$p, _path66$p, _path67$p, _path68$p, _path69$p, _path70$p, _path71$p, _path72$p, _path73$p, _path74$p, _path75$p, _path76$p, _path77$p, _path78$p, _path79$p, _path80$p, _path81$p, _path82$p, _path83$p, _path84$p, _path85$p, _path86$p, _path87$p, _path88$p, _path89$p, _path90$p, _path91$p, _path92$p, _path93$p, _path94$p, _path95$p, _path96$p, _path97$p, _path98$p, _path99$p, _path100$p, _path101$p, _path102$p, _path103$p, _path104$p, _circle$o, _path105$p, _circle2$o, _path106$p, _circle3$o, _path107$p, _circle4$n, _path108$p, _circle5$m, _circle6$m, _circle7$m, _circle8$m, _path109$p, _path110$p, _path111$p, _path112$p, _circle9$m, _path113$p, _path114$p, _path115$p, _path116$p, _path117$p, _path118$p, _path119$p, _path120$p, _path121$p, _path122$p, _path123$p, _path124$p, _path125$p, _path126$p, _path127$p, _path128$p, _path129$p, _path130$p, _path131$p, _path132$p, _path133$p, _circle10$m, _path134$p, _circle11$l, _path135$p, _circle12$l, _path136$p, _circle13$l, _path137$p, _path138$p, _path139$p, _path140$p, _path141$p, _path142$p, _path143$p, _path144$p, _path145$p, _path146$p, _path147$p, _path148$p, _path149$p, _path150$p, _path151$p, _path152$p, _path153$p, _path154$p, _path155$p, _path156$p, _path157$p, _path158$p, _path159$p, _path160$p, _path161$p, _path162$p, _path163$p, _path164$p, _path165$p, _path166$p, _path167$p, _path168$p, _path169$p, _path170$p, _path171$p, _path172$p, _path173$p, _path174$p, _path175$p, _path176$p, _path177$o, _path178$o, _path179$o, _path180$o, _path181$o, _path182$o, _path183$o, _path184$o, _path185$o, _path186$o, _path187$o, _path188$o, _path189$o, _path190$o, _path191$o, _path192$o, _path193$o, _path194$o, _path195$o, _path196$o, _path197$o, _path198$o, _path199$o, _path200$o, _path201$o, _path202$o, _path203$o, _path204$o, _path205$o, _path206$o, _path207$o, _path208$o, _path209$o, _path210$o, _path211$o, _path212$o, _path213$o, _path214$o, _path215$o, _path216$o, _path217$o, _path218$o, _path219$o, _path220$o, _path221$o, _path222$o, _path223$o, _path224$o, _path225$o, _path226$o, _path227$o, _path228$o, _path229$o, _path230$o, _path231$o, _path232$o, _path233$o, _path234$o, _path235$o, _path236$o, _path237$o, _path238$o, _path239$o, _path240$o, _path241$o, _path242$o, _path243$o, _path244$o, _path245$o, _path246$o, _path247$o, _path248$o, _path249$o, _path250$o, _path251$o, _path252$o, _path253$o, _path254$o, _path255$o, _path256$o, _path257$o, _path258$o, _path259$o, _path260$o, _path261$o, _path262$o, _path263$o, _path264$o, _path265$o, _path266$o, _path267$o, _path268$o, _path269$o, _path270$o, _path271$o, _path272$o, _path273$o, _path274$o, _path275$o, _path276$o, _path277$o, _path278$o, _path279$o, _path280$o, _path281$o, _path282$o, _path283$o, _path284$o, _path285$o, _path286$o, _path287$o, _path288$o, _path289$o, _path290$o, _path291$o, _path292$o, _path293$o, _path294$o, _path295$o, _path296$o, _path297$o, _path298$o, _path299$o, _path300$o, _path301$o, _path302$o, _path303$o, _path304$o, _path305$o, _path306$o, _path307$o, _path308$o, _circle14$l, _path309$o, _circle15$l, _path310$o, _circle16$l, _path311$o, _circle17$k, _path312$o, _circle18$k, _path313$o, _circle19$k, _path314$o, _circle20$k, _path315$o, _circle21$j, _path316$o, _path317$o, _circle22$j, _path318$o, _circle23$i, _path319$o, _path320$o, _circle24$i, _path321$o, _circle25$h, _path322$o, _path323$o, _circle26$h, _path324$o, _circle27$g, _path325$o, _path326$o, _circle28$g, _path327$o, _circle29$f, _path328$o, _path329$o, _path330$o, _circle30$f, _path331$o, _circle31$f, _path332$o, _path333$o, _path334$o, _circle32$f, _path335$o, _circle33$e, _path336$o, _path337$o, _path338$n, _circle34$d, _path339$n, _circle35$d, _path340$n, _path341$n, _path342$n, _circle36$d, _path343$n, _circle37$b, _path344$n, _path345$n, _circle38$b, _path346$n, _circle39$b, _path347$n, _path348$n, _circle40$b, _path349$n, _circle41$a, _path350$n, _path351$n, _circle42$a, _path352$n, _circle43$a, _path353$n, _path354$n, _circle44$a, _path355$m, _circle45$9, _path356$m, _path357$m, _path358$m, _path359$m, _path360$m, _path361$l, _path362$l, _path363$j, _path364$j, _path365$j, _path366$j, _path367$j, _path368$j, _path369$j, _path370$j, _path371$j, _path372$j, _path373$j, _path374$j, _path375$i, _path376$i, _path377$i, _path378$i, _path379$i, _path380$i, _path381$i, _path382$i, _path383$i, _path384$h, _path385$h, _path386$h, _path387$h, _path388$h, _path389$h, _path390$h, _path391$h, _path392$h, _path393$h, _path394$h, _path395$h, _path396$h, _circle46$9, _path397$h, _circle47$9, _path398$h, _circle48$9, _path399$g, _circle49$8, _path400$g, _path401$g, _path402$g, _path403$f, _path404$f;

  var _excluded$p = ["children"],
      _excluded2$p = ["children"],
      _excluded3$p = ["children"],
      _excluded4$p = ["children"],
      _excluded5$p = ["children"],
      _excluded6$p = ["children"],
      _excluded7$p = ["children"],
      _excluded8$p = ["children"],
      _excluded9$p = ["children"],
      _excluded10$p = ["children"],
      _excluded11$p = ["children"],
      _excluded12$p = ["children"],
      _excluded13$p = ["children"],
      _excluded14$p = ["children"],
      _excluded15$p = ["children"],
      _excluded16$p = ["children"],
      _excluded17$p = ["children"],
      _excluded18$p = ["children"],
      _excluded19$p = ["children"],
      _excluded20$p = ["children"],
      _excluded21$p = ["children"],
      _excluded22$p = ["children"],
      _excluded23$p = ["children"],
      _excluded24$p = ["children"],
      _excluded25$p = ["children"],
      _excluded26$p = ["children"],
      _excluded27$p = ["children"],
      _excluded28$p = ["children"],
      _excluded29$p = ["children"],
      _excluded30$p = ["children"],
      _excluded31$p = ["children"],
      _excluded32$p = ["children"],
      _excluded33$p = ["children"],
      _excluded34$p = ["children"],
      _excluded35$p = ["children"],
      _excluded36$p = ["children"],
      _excluded37$p = ["children"],
      _excluded38$p = ["children"],
      _excluded39$p = ["children"],
      _excluded40$p = ["children"],
      _excluded41$p = ["children"],
      _excluded42$p = ["children"],
      _excluded43$p = ["children"],
      _excluded44$p = ["children"],
      _excluded45$p = ["children"],
      _excluded46$p = ["children"],
      _excluded47$p = ["children"],
      _excluded48$p = ["children"],
      _excluded49$p = ["children"],
      _excluded50$p = ["children"],
      _excluded51$p = ["children"],
      _excluded52$p = ["children"],
      _excluded53$p = ["children"],
      _excluded54$p = ["children"],
      _excluded55$p = ["children"],
      _excluded56$p = ["children"],
      _excluded57$p = ["children"],
      _excluded58$p = ["children"],
      _excluded59$p = ["children"],
      _excluded60$p = ["children"],
      _excluded61$p = ["children"],
      _excluded62$p = ["children"],
      _excluded63$p = ["children"],
      _excluded64$p = ["children"],
      _excluded65$p = ["children"],
      _excluded66$p = ["children"],
      _excluded67$p = ["children"],
      _excluded68$p = ["children"],
      _excluded69$p = ["children"],
      _excluded70$p = ["children"],
      _excluded71$p = ["children"],
      _excluded72$p = ["children"],
      _excluded73$p = ["children"],
      _excluded74$p = ["children"],
      _excluded75$p = ["children"],
      _excluded76$p = ["children"],
      _excluded77$p = ["children"],
      _excluded78$p = ["children"],
      _excluded79$p = ["children"],
      _excluded80$p = ["children"],
      _excluded81$p = ["children"],
      _excluded82$p = ["children"],
      _excluded83$p = ["children"],
      _excluded84$p = ["children"],
      _excluded85$p = ["children"],
      _excluded86$p = ["children"],
      _excluded87$p = ["children"],
      _excluded88$p = ["children"],
      _excluded89$p = ["children"],
      _excluded90$p = ["children"],
      _excluded91$p = ["children"],
      _excluded92$p = ["children"],
      _excluded93$p = ["children"],
      _excluded94$p = ["children"],
      _excluded95$p = ["children"],
      _excluded96$p = ["children"],
      _excluded97$p = ["children"],
      _excluded98$p = ["children"],
      _excluded99$p = ["children"],
      _excluded100$p = ["children"],
      _excluded101$p = ["children"],
      _excluded102$p = ["children"],
      _excluded103$p = ["children"],
      _excluded104$p = ["children"],
      _excluded105$p = ["children"],
      _excluded106$p = ["children"],
      _excluded107$p = ["children"],
      _excluded108$p = ["children"],
      _excluded109$p = ["children"],
      _excluded110$p = ["children"],
      _excluded111$p = ["children"],
      _excluded112$p = ["children"],
      _excluded113$p = ["children"],
      _excluded114$p = ["children"],
      _excluded115$p = ["children"],
      _excluded116$p = ["children"],
      _excluded117$p = ["children"],
      _excluded118$p = ["children"],
      _excluded119$o = ["children"],
      _excluded120$o = ["children"],
      _excluded121$o = ["children"],
      _excluded122$o = ["children"],
      _excluded123$o = ["children"],
      _excluded124$o = ["children"],
      _excluded125$o = ["children"],
      _excluded126$o = ["children"],
      _excluded127$o = ["children"],
      _excluded128$o = ["children"],
      _excluded129$o = ["children"],
      _excluded130$o = ["children"],
      _excluded131$o = ["children"],
      _excluded132$o = ["children"],
      _excluded133$o = ["children"],
      _excluded134$o = ["children"],
      _excluded135$o = ["children"],
      _excluded136$o = ["children"],
      _excluded137$o = ["children"],
      _excluded138$o = ["children"],
      _excluded139$o = ["children"],
      _excluded140$o = ["children"],
      _excluded141$o = ["children"],
      _excluded142$o = ["children"],
      _excluded143$o = ["children"],
      _excluded144$o = ["children"],
      _excluded145$o = ["children"],
      _excluded146$o = ["children"],
      _excluded147$o = ["children"],
      _excluded148$o = ["children"],
      _excluded149$o = ["children"],
      _excluded150$o = ["children"],
      _excluded151$o = ["children"],
      _excluded152$o = ["children"],
      _excluded153$o = ["children"],
      _excluded154$o = ["children"],
      _excluded155$o = ["children"],
      _excluded156$o = ["children"],
      _excluded157$o = ["children"],
      _excluded158$o = ["children"],
      _excluded159$o = ["children"],
      _excluded160$o = ["children"],
      _excluded161$o = ["children"],
      _excluded162$o = ["children"],
      _excluded163$o = ["children"],
      _excluded164$o = ["children"],
      _excluded165$o = ["children"],
      _excluded166$o = ["children"],
      _excluded167$o = ["children"],
      _excluded168$o = ["children"],
      _excluded169$o = ["children"],
      _excluded170$o = ["children"],
      _excluded171$o = ["children"],
      _excluded172$o = ["children"],
      _excluded173$o = ["children"],
      _excluded174$o = ["children"],
      _excluded175$o = ["children"],
      _excluded176$o = ["children"],
      _excluded177$o = ["children"],
      _excluded178$o = ["children"],
      _excluded179$o = ["children"],
      _excluded180$o = ["children"],
      _excluded181$o = ["children"],
      _excluded182$o = ["children"],
      _excluded183$o = ["children"],
      _excluded184$o = ["children"],
      _excluded185$o = ["children"],
      _excluded186$o = ["children"],
      _excluded187$o = ["children"],
      _excluded188$o = ["children"],
      _excluded189$o = ["children"],
      _excluded190$o = ["children"],
      _excluded191$o = ["children"],
      _excluded192$o = ["children"],
      _excluded193$o = ["children"],
      _excluded194$o = ["children"],
      _excluded195$o = ["children"],
      _excluded196$o = ["children"],
      _excluded197$o = ["children"],
      _excluded198$o = ["children"],
      _excluded199$o = ["children"],
      _excluded200$o = ["children"],
      _excluded201$o = ["children"],
      _excluded202$o = ["children"],
      _excluded203$o = ["children"],
      _excluded204$o = ["children"],
      _excluded205$o = ["children"],
      _excluded206$o = ["children"],
      _excluded207$o = ["children"],
      _excluded208$o = ["children"],
      _excluded209$o = ["children"],
      _excluded210$o = ["children"],
      _excluded211$o = ["children"],
      _excluded212$o = ["children"],
      _excluded213$o = ["children"],
      _excluded214$o = ["children"],
      _excluded215$o = ["children"],
      _excluded216$o = ["children"],
      _excluded217$o = ["children"],
      _excluded218$o = ["children"],
      _excluded219$o = ["children"],
      _excluded220$o = ["children"],
      _excluded221$o = ["children"],
      _excluded222$o = ["children"],
      _excluded223$o = ["children"],
      _excluded224$o = ["children"],
      _excluded225$o = ["children"],
      _excluded226$o = ["children"],
      _excluded227$o = ["children"],
      _excluded228$o = ["children"],
      _excluded229$o = ["children"],
      _excluded230$o = ["children"],
      _excluded231$o = ["children"],
      _excluded232$o = ["children"],
      _excluded233$o = ["children"],
      _excluded234$o = ["children"],
      _excluded235$o = ["children"],
      _excluded236$o = ["children"],
      _excluded237$o = ["children"],
      _excluded238$o = ["children"],
      _excluded239$o = ["children"],
      _excluded240$o = ["children"],
      _excluded241$o = ["children"],
      _excluded242$o = ["children"],
      _excluded243$o = ["children"],
      _excluded244$o = ["children"],
      _excluded245$o = ["children"],
      _excluded246$o = ["children"],
      _excluded247$o = ["children"],
      _excluded248$o = ["children"],
      _excluded249$o = ["children"],
      _excluded250$o = ["children"];
  var didWarnAboutDeprecation$9 = {};
  var ChevronRight20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronRight20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$p || (_path$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L12 26 10.6 24.6 19.2 16 10.6 7.4 12 6z"
    })), children);
  });
  var ChevronRight16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronRight16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$p || (_path2$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 8L6 13 5.3 12.3 9.6 8 5.3 3.7 6 3z"
    })), children);
  });
  var ChevronRightGlyph = /*#__PURE__*/React__default['default'].forwardRef(function ChevronRightGlyph(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 6,
      height: 10,
      viewBox: "0 0 6 10",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$p || (_path3$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 5L1 10 0.3 9.3 4.6 5 0.3 0.7 1 0z"
    })), children);
  });
  var ChevronSort32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSort32(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$p || (_path4$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28L9 21 10.41 19.59 16 25.17 21.59 19.59 23 21 16 28zM16 4L23 11 21.59 12.41 16 6.83 10.41 12.41 9 11 16 4z"
    })), children);
  });
  var ChevronSort24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSort24(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$p || (_path5$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28L9 21 10.41 19.59 16 25.17 21.59 19.59 23 21 16 28zM16 4L23 11 21.59 12.41 16 6.83 10.41 12.41 9 11 16 4z"
    })), children);
  });
  var ChevronSort20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSort20(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$p || (_path6$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28L9 21 10.41 19.59 16 25.17 21.59 19.59 23 21 16 28zM16 4L23 11 21.59 12.41 16 6.83 10.41 12.41 9 11 16 4z"
    })), children);
  });
  var ChevronSort16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSort16(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$p || (_path7$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14L4.5 10.5 5.2 9.8 8 12.6 10.8 9.8 11.5 10.5zM8 2L11.5 5.5 10.8 6.2 8 3.4 5.2 6.2 4.5 5.5z"
    })), children);
  });
  var ChevronSortDown32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortDown32(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$p || (_path8$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28L9 21 10.4 19.6 16 25.2 21.6 19.6 23 21z"
    })), children);
  });
  var ChevronSortDown24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortDown24(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$p || (_path9$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28L9 21 10.4 19.6 16 25.2 21.6 19.6 23 21z"
    })), children);
  });
  var ChevronSortDown20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortDown20(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$p || (_path10$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28L9 21 10.4 19.6 16 25.2 21.6 19.6 23 21z"
    })), children);
  });
  var ChevronSortDown16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortDown16(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$p || (_path11$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14L4.5 10.5 5.2 9.8 8 12.6 10.8 9.8 11.5 10.5z"
    })), children);
  });
  var ChevronSortUp32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortUp32(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$p || (_path12$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L23 11 21.6 12.4 16 6.8 10.4 12.4 9 11z"
    })), children);
  });
  var ChevronSortUp24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortUp24(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$p || (_path13$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L23 11 21.6 12.4 16 6.8 10.4 12.4 9 11z"
    })), children);
  });
  var ChevronSortUp20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortUp20(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$p || (_path14$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L23 11 21.6 12.4 16 6.8 10.4 12.4 9 11z"
    })), children);
  });
  var ChevronSortUp16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronSortUp16(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$p || (_path15$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 2L11.5 5.5 10.8 6.2 8 3.4 5.2 6.2 4.5 5.5z"
    })), children);
  });
  var ChevronUp32 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronUp32(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$p || (_path16$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10L26 20 24.6 21.4 16 12.8 7.4 21.4 6 20z"
    })), children);
  });
  var ChevronUp24 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronUp24(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$p || (_path17$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10L26 20 24.6 21.4 16 12.8 7.4 21.4 6 20z"
    })), children);
  });
  var ChevronUp20 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronUp20(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$p || (_path18$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 10L26 20 24.6 21.4 16 12.8 7.4 21.4 6 20z"
    })), children);
  });
  var ChevronUp16 = /*#__PURE__*/React__default['default'].forwardRef(function ChevronUp16(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$p || (_path19$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 5L13 10 12.3 10.7 8 6.4 3.7 10.7 3 10z"
    })), children);
  });
  var ChevronUpGlyph = /*#__PURE__*/React__default['default'].forwardRef(function ChevronUpGlyph(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 10,
      height: 6,
      viewBox: "0 0 10 6",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$p || (_path20$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 0L10 5 9.3 5.7 5 1.4 0.7 5.7 0 5z"
    })), children);
  });
  var Chip32 = /*#__PURE__*/React__default['default'].forwardRef(function Chip32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$p || (_path21$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11V21H21V11Zm8,8H13V13h6Z"
    })), _path22$p || (_path22$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"
    })), children);
  });
  var Chip24 = /*#__PURE__*/React__default['default'].forwardRef(function Chip24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$p || (_path23$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11V21H21V11Zm8,8H13V13h6Z"
    })), _path24$p || (_path24$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"
    })), children);
  });
  var Chip20 = /*#__PURE__*/React__default['default'].forwardRef(function Chip20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$p || (_path25$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11V21H21V11Zm8,8H13V13h6Z"
    })), _path26$p || (_path26$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"
    })), children);
  });
  var Chip16 = /*#__PURE__*/React__default['default'].forwardRef(function Chip16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$p || (_path27$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11V21H21V11Zm8,8H13V13h6Z"
    })), _path28$p || (_path28$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"
    })), children);
  });
  var Choices32 = /*#__PURE__*/React__default['default'].forwardRef(function Choices32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$p || (_path29$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13L28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13 6 7.414 15 16.414 15 26 4 26 4 28 28 28 28 26 17 26 17 16.414 26 7.414 26 13 28 13z"
    })), children);
  });
  var Choices24 = /*#__PURE__*/React__default['default'].forwardRef(function Choices24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$p || (_path30$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13L28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13 6 7.414 15 16.414 15 26 4 26 4 28 28 28 28 26 17 26 17 16.414 26 7.414 26 13 28 13z"
    })), children);
  });
  var Choices20 = /*#__PURE__*/React__default['default'].forwardRef(function Choices20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$p || (_path31$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13L28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13 6 7.414 15 16.414 15 26 4 26 4 28 28 28 28 26 17 26 17 16.414 26 7.414 26 13 28 13z"
    })), children);
  });
  var Choices16 = /*#__PURE__*/React__default['default'].forwardRef(function Choices16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$p || (_path32$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13L28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13 6 7.414 15 16.414 15 26 4 26 4 28 28 28 28 26 17 26 17 16.414 26 7.414 26 13 28 13z"
    })), children);
  });
  var ChooseItem32 = /*#__PURE__*/React__default['default'].forwardRef(function ChooseItem32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$p || (_path33$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6H30V26H28zM17 6L15.57 7.393 23.15 15 2 15 2 17 23.15 17 15.57 24.573 17 26 27 16 17 6z"
    })), children);
  });
  var ChooseItem24 = /*#__PURE__*/React__default['default'].forwardRef(function ChooseItem24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$p || (_path34$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6H30V26H28zM17 6L15.57 7.393 23.15 15 2 15 2 17 23.15 17 15.57 24.573 17 26 27 16 17 6z"
    })), children);
  });
  var ChooseItem20 = /*#__PURE__*/React__default['default'].forwardRef(function ChooseItem20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$p || (_path35$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6H30V26H28zM17 6L15.57 7.393 23.15 15 2 15 2 17 23.15 17 15.57 24.573 17 26 27 16 17 6z"
    })), children);
  });
  var ChooseItem16 = /*#__PURE__*/React__default['default'].forwardRef(function ChooseItem16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$p || (_path36$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6H30V26H28zM17 6L15.57 7.393 23.15 15 2 15 2 17 23.15 17 15.57 24.573 17 26 27 16 17 6z"
    })), children);
  });
  var ChoroplethMap32 = /*#__PURE__*/React__default['default'].forwardRef(function ChoroplethMap32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$p || (_path37$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2427,4.03l-8-2a1.0065,1.0065,0,0,0-.6143.0415l-9.7,3.88L3.2427,4.03A1,1,0,0,0,2,5V27a1,1,0,0,0,.7573.97l8,2A1.0244,1.0244,0,0,0,11,30a.9953.9953,0,0,0,.3716-.0718l9.7-3.88,7.686,1.9219A1,1,0,0,0,30,27V5A1,1,0,0,0,29.2427,4.03ZM28,11H22V4.2806l6,1.5ZM10,19H4V13h6Zm2-8V7.6771l8-3.2V11Zm8,2v6H12V13Zm-8,8h8v3.3227l-8,3.2Zm10-8h6v6H22ZM10,7.7806V11H4V6.2806ZM4,21h6v6.7192l-6-1.5Zm18,3.2187V21h6v4.7192Z"
    })), children);
  });
  var ChoroplethMap24 = /*#__PURE__*/React__default['default'].forwardRef(function ChoroplethMap24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$p || (_path38$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2427,4.03l-8-2a1.0065,1.0065,0,0,0-.6143.0415l-9.7,3.88L3.2427,4.03A1,1,0,0,0,2,5V27a1,1,0,0,0,.7573.97l8,2A1.0244,1.0244,0,0,0,11,30a.9953.9953,0,0,0,.3716-.0718l9.7-3.88,7.686,1.9219A1,1,0,0,0,30,27V5A1,1,0,0,0,29.2427,4.03ZM28,11H22V4.2806l6,1.5ZM10,19H4V13h6Zm2-8V7.6771l8-3.2V11Zm8,2v6H12V13Zm-8,8h8v3.3227l-8,3.2Zm10-8h6v6H22ZM10,7.7806V11H4V6.2806ZM4,21h6v6.7192l-6-1.5Zm18,3.2187V21h6v4.7192Z"
    })), children);
  });
  var ChoroplethMap20 = /*#__PURE__*/React__default['default'].forwardRef(function ChoroplethMap20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$p || (_path39$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2427,4.03l-8-2a1.0065,1.0065,0,0,0-.6143.0415l-9.7,3.88L3.2427,4.03A1,1,0,0,0,2,5V27a1,1,0,0,0,.7573.97l8,2A1.0244,1.0244,0,0,0,11,30a.9953.9953,0,0,0,.3716-.0718l9.7-3.88,7.686,1.9219A1,1,0,0,0,30,27V5A1,1,0,0,0,29.2427,4.03ZM28,11H22V4.2806l6,1.5ZM10,19H4V13h6Zm2-8V7.6771l8-3.2V11Zm8,2v6H12V13Zm-8,8h8v3.3227l-8,3.2Zm10-8h6v6H22ZM10,7.7806V11H4V6.2806ZM4,21h6v6.7192l-6-1.5Zm18,3.2187V21h6v4.7192Z"
    })), children);
  });
  var ChoroplethMap16 = /*#__PURE__*/React__default['default'].forwardRef(function ChoroplethMap16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$p || (_path40$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2427,4.03l-8-2a1.0065,1.0065,0,0,0-.6143.0415l-9.7,3.88L3.2427,4.03A1,1,0,0,0,2,5V27a1,1,0,0,0,.7573.97l8,2A1.0244,1.0244,0,0,0,11,30a.9953.9953,0,0,0,.3716-.0718l9.7-3.88,7.686,1.9219A1,1,0,0,0,30,27V5A1,1,0,0,0,29.2427,4.03ZM28,11H22V4.2806l6,1.5ZM10,19H4V13h6Zm2-8V7.6771l8-3.2V11Zm8,2v6H12V13Zm-8,8h8v3.3227l-8,3.2Zm10-8h6v6H22ZM10,7.7806V11H4V6.2806ZM4,21h6v6.7192l-6-1.5Zm18,3.2187V21h6v4.7192Z"
    })), children);
  });
  var CicsCmas32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsCmas32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$p || (_path41$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.3335 30H26V28h4V26H28a2.002 2.002 0 01-2-2V21.6665A1.6684 1.6684 0 0127.6665 20H32v2H28v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0130.3335 30zM22.3335 20h-2.667A1.6665 1.6665 0 0018 21.6665V30h2V26h2v4h2V21.6665A1.6665 1.6665 0 0022.3335 20zM20 24V22h2v2zM12.5 24L11 20 9 20 9 30 11 30 11 23 12.5 27 14 23 14 30 16 30 16 20 14 20 12.5 24zM1 22v6.5A1.4727 1.4727 0 002.5 30H7V28H3V22H7V20H3A2.0059 2.0059 0 001 22zM13 8L11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11 13 11 13 8z"
    })), _path42$p || (_path42$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,6H26V18h2V6a2.0059,2.0059,0,0,0-2-2H6A2.0059,2.0059,0,0,0,4,6V18H6Z"
    })), children);
  });
  var CicsCmas24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsCmas24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$p || (_path43$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.3335 30H26V28h4V26H28a2.002 2.002 0 01-2-2V21.6665A1.6684 1.6684 0 0127.6665 20H32v2H28v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0130.3335 30zM22.3335 20h-2.667A1.6665 1.6665 0 0018 21.6665V30h2V26h2v4h2V21.6665A1.6665 1.6665 0 0022.3335 20zM20 24V22h2v2zM12.5 24L11 20 9 20 9 30 11 30 11 23 12.5 27 14 23 14 30 16 30 16 20 14 20 12.5 24zM1 22v6.5A1.4727 1.4727 0 002.5 30H7V28H3V22H7V20H3A2.0059 2.0059 0 001 22zM13 8L11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11 13 11 13 8z"
    })), _path44$p || (_path44$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,6H26V18h2V6a2.0059,2.0059,0,0,0-2-2H6A2.0059,2.0059,0,0,0,4,6V18H6Z"
    })), children);
  });
  var CicsCmas20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsCmas20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$p || (_path45$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.3335 30H26V28h4V26H28a2.002 2.002 0 01-2-2V21.6665A1.6684 1.6684 0 0127.6665 20H32v2H28v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0130.3335 30zM22.3335 20h-2.667A1.6665 1.6665 0 0018 21.6665V30h2V26h2v4h2V21.6665A1.6665 1.6665 0 0022.3335 20zM20 24V22h2v2zM12.5 24L11 20 9 20 9 30 11 30 11 23 12.5 27 14 23 14 30 16 30 16 20 14 20 12.5 24zM1 22v6.5A1.4727 1.4727 0 002.5 30H7V28H3V22H7V20H3A2.0059 2.0059 0 001 22zM13 8L11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11 13 11 13 8z"
    })), _path46$p || (_path46$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,6H26V18h2V6a2.0059,2.0059,0,0,0-2-2H6A2.0059,2.0059,0,0,0,4,6V18H6Z"
    })), children);
  });
  var CicsCmas16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsCmas16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$p || (_path47$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.3335 30H26V28h4V26H28a2.002 2.002 0 01-2-2V21.6665A1.6684 1.6684 0 0127.6665 20H32v2H28v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0130.3335 30zM22.3335 20h-2.667A1.6665 1.6665 0 0018 21.6665V30h2V26h2v4h2V21.6665A1.6665 1.6665 0 0022.3335 20zM20 24V22h2v2zM12.5 24L11 20 9 20 9 30 11 30 11 23 12.5 27 14 23 14 30 16 30 16 20 14 20 12.5 24zM1 22v6.5A1.4727 1.4727 0 002.5 30H7V28H3V22H7V20H3A2.0059 2.0059 0 001 22zM13 8L11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11 13 11 13 8z"
    })), _path48$p || (_path48$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,6H26V18h2V6a2.0059,2.0059,0,0,0-2-2H6A2.0059,2.0059,0,0,0,4,6V18H6Z"
    })), children);
  });
  var CicsExplorer32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsExplorer32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$p || (_path49$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 16L19.4 14.6 21.7 10.3 17.4 12.6 16 8 14.6 12.6 10.3 10.3 12.6 14.6 8 16 12.6 17.4 10.3 21.7 14.6 19.4 16 24 17.4 19.4 21.7 21.7 19.4 17.4 24 16z"
    })), _path50$p || (_path50$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CicsExplorer24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsExplorer24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$p || (_path51$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 16L19.4 14.6 21.7 10.3 17.4 12.6 16 8 14.6 12.6 10.3 10.3 12.6 14.6 8 16 12.6 17.4 10.3 21.7 14.6 19.4 16 24 17.4 19.4 21.7 21.7 19.4 17.4 24 16z"
    })), _path52$p || (_path52$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CicsExplorer20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsExplorer20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$p || (_path53$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 16L19.4 14.6 21.7 10.3 17.4 12.6 16 8 14.6 12.6 10.3 10.3 12.6 14.6 8 16 12.6 17.4 10.3 21.7 14.6 19.4 16 24 17.4 19.4 21.7 21.7 19.4 17.4 24 16z"
    })), _path54$p || (_path54$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CicsExplorer16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsExplorer16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$p || (_path55$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 16L19.4 14.6 21.7 10.3 17.4 12.6 16 8 14.6 12.6 10.3 10.3 12.6 14.6 8 16 12.6 17.4 10.3 21.7 14.6 19.4 16 24 17.4 19.4 21.7 21.7 19.4 17.4 24 16z"
    })), _path56$p || (_path56$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CicsSystemGroup32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsSystemGroup32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$p || (_path57$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H23V4h5V28H23v2h5a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0028 2zM14 17H8a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V18A.9448.9448 0 0014 17zm-1 6H9V19h4z"
    })), _path58$p || (_path58$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 24V18a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6A1.0021 1.0021 0 0025 24zm-2-1H19V19h4zM14 7H8A.9448.9448 0 007 8v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V8A.9448.9448 0 0014 7zm-1 6H9V9h4zM18 15h6a.9448.9448 0 001-1V8a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6A1.0021 1.0021 0 0018 15zm1-6h4v4H19z"
    })), _path59$p || (_path59$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4H9V2H4A2.0059,2.0059,0,0,0,2,4V28a2.0059,2.0059,0,0,0,2,2H9V28H4Z"
    })), children);
  });
  var CicsSystemGroup24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsSystemGroup24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$p || (_path60$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H23V4h5V28H23v2h5a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0028 2zM14 17H8a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V18A.9448.9448 0 0014 17zm-1 6H9V19h4z"
    })), _path61$p || (_path61$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 24V18a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6A1.0021 1.0021 0 0025 24zm-2-1H19V19h4zM14 7H8A.9448.9448 0 007 8v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V8A.9448.9448 0 0014 7zm-1 6H9V9h4zM18 15h6a.9448.9448 0 001-1V8a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6A1.0021 1.0021 0 0018 15zm1-6h4v4H19z"
    })), _path62$p || (_path62$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4H9V2H4A2.0059,2.0059,0,0,0,2,4V28a2.0059,2.0059,0,0,0,2,2H9V28H4Z"
    })), children);
  });
  var CicsSystemGroup20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsSystemGroup20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$p || (_path63$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H23V4h5V28H23v2h5a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0028 2zM14 17H8a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V18A.9448.9448 0 0014 17zm-1 6H9V19h4z"
    })), _path64$p || (_path64$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 24V18a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6A1.0021 1.0021 0 0025 24zm-2-1H19V19h4zM14 7H8A.9448.9448 0 007 8v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V8A.9448.9448 0 0014 7zm-1 6H9V9h4zM18 15h6a.9448.9448 0 001-1V8a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6A1.0021 1.0021 0 0018 15zm1-6h4v4H19z"
    })), _path65$p || (_path65$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4H9V2H4A2.0059,2.0059,0,0,0,2,4V28a2.0059,2.0059,0,0,0,2,2H9V28H4Z"
    })), children);
  });
  var CicsSystemGroup16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsSystemGroup16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$p || (_path66$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H23V4h5V28H23v2h5a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0028 2zM14 17H8a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V18A.9448.9448 0 0014 17zm-1 6H9V19h4z"
    })), _path67$p || (_path67$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 24V18a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6a.9448.9448 0 001 1h6A1.0021 1.0021 0 0025 24zm-2-1H19V19h4zM14 7H8A.9448.9448 0 007 8v6a.9448.9448 0 001 1h6a.9448.9448 0 001-1V8A.9448.9448 0 0014 7zm-1 6H9V9h4zM18 15h6a.9448.9448 0 001-1V8a.9448.9448 0 00-1-1H18a.9448.9448 0 00-1 1v6A1.0021 1.0021 0 0018 15zm1-6h4v4H19z"
    })), _path68$p || (_path68$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4H9V2H4A2.0059,2.0059,0,0,0,2,4V28a2.0059,2.0059,0,0,0,2,2H9V28H4Z"
    })), children);
  });
  var CicsWuiRegion32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsWuiRegion32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$p || (_path69$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22L24 22 24 28 22 28 22 30 28 30 28 28 26 28 26 22 28 22 28 20 22 20 22 22zM18 28H16V20H14v8.6A1.4529 1.4529 0 0015.5 30h3A1.4529 1.4529 0 0020 28.6V20H18zM10.2 20L10 28.5 9 22 7 22 6 28.5 5.8 20 4 20 4.72 30 7 30 8 23.5 9 30 11.28 30 12 20 10.2 20zM16 11L13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11z"
    })), _path70$p || (_path70$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V18H6V6H26V18h2V6A2.0059,2.0059,0,0,0,26,4Z"
    })), children);
  });
  var CicsWuiRegion24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsWuiRegion24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$p || (_path71$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22L24 22 24 28 22 28 22 30 28 30 28 28 26 28 26 22 28 22 28 20 22 20 22 22zM18 28H16V20H14v8.6A1.4529 1.4529 0 0015.5 30h3A1.4529 1.4529 0 0020 28.6V20H18zM10.2 20L10 28.5 9 22 7 22 6 28.5 5.8 20 4 20 4.72 30 7 30 8 23.5 9 30 11.28 30 12 20 10.2 20zM16 11L13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11z"
    })), _path72$p || (_path72$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V18H6V6H26V18h2V6A2.0059,2.0059,0,0,0,26,4Z"
    })), children);
  });
  var CicsWuiRegion20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsWuiRegion20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$p || (_path73$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22L24 22 24 28 22 28 22 30 28 30 28 28 26 28 26 22 28 22 28 20 22 20 22 22zM18 28H16V20H14v8.6A1.4529 1.4529 0 0015.5 30h3A1.4529 1.4529 0 0020 28.6V20H18zM10.2 20L10 28.5 9 22 7 22 6 28.5 5.8 20 4 20 4.72 30 7 30 8 23.5 9 30 11.28 30 12 20 10.2 20zM16 11L13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11z"
    })), _path74$p || (_path74$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V18H6V6H26V18h2V6A2.0059,2.0059,0,0,0,26,4Z"
    })), children);
  });
  var CicsWuiRegion16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsWuiRegion16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$p || (_path75$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22L24 22 24 28 22 28 22 30 28 30 28 28 26 28 26 22 28 22 28 20 22 20 22 22zM18 28H16V20H14v8.6A1.4529 1.4529 0 0015.5 30h3A1.4529 1.4529 0 0020 28.6V20H18zM10.2 20L10 28.5 9 22 7 22 6 28.5 5.8 20 4 20 4.72 30 7 30 8 23.5 9 30 11.28 30 12 20 10.2 20zM16 11L13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13 16 11z"
    })), _path76$p || (_path76$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V18H6V6H26V18h2V6A2.0059,2.0059,0,0,0,26,4Z"
    })), children);
  });
  var CicsRegion32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegion32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$p || (_path77$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 18L21 18.7 21 16 19 16 19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18zM16 13L16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13z"
    })), _path78$p || (_path78$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CicsRegion24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegion24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$p || (_path79$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 18L21 18.7 21 16 19 16 19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18zM16 13L16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13z"
    })), _path80$p || (_path80$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CicsRegion20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegion20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$p || (_path81$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 18L21 18.7 21 16 19 16 19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18zM16 13L16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13z"
    })), _path82$p || (_path82$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CicsRegion16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegion16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$p || (_path83$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 18L21 18.7 21 16 19 16 19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18zM16 13L16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16 13 13 16 13z"
    })), _path84$p || (_path84$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,26,4ZM6,26V6H26V26Z"
    })), children);
  });
  var CicsRegionRouting32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionRouting32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$p || (_path85$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 2L22 4 26.6 4 20 10.6 21.4 12 28 5.4 28 10 30 10 30 2 22 2zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path86$p || (_path86$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionRouting24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionRouting24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$p || (_path87$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 2L22 4 26.6 4 20 10.6 21.4 12 28 5.4 28 10 30 10 30 2 22 2zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path88$p || (_path88$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionRouting20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionRouting20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$p || (_path89$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 2L22 4 26.6 4 20 10.6 21.4 12 28 5.4 28 10 30 10 30 2 22 2zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path90$p || (_path90$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionRouting16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionRouting16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$p || (_path91$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 2L22 4 26.6 4 20 10.6 21.4 12 28 5.4 28 10 30 10 30 2 22 2zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path92$p || (_path92$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionTarget32 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionTarget32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$p || (_path93$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 7H28V10H26zM29 4H32V6H29zM26 0H28V3H26zM22 4H25V6H22zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path94$p || (_path94$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionTarget24 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionTarget24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$p || (_path95$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 7H28V10H26zM29 4H32V6H29zM26 0H28V3H26zM22 4H25V6H22zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path96$p || (_path96$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionTarget20 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionTarget20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$p || (_path97$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 7H28V10H26zM29 4H32V6H29zM26 0H28V3H26zM22 4H25V6H22zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path98$p || (_path98$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var CicsRegionTarget16 = /*#__PURE__*/React__default['default'].forwardRef(function CicsRegionTarget16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$p || (_path99$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 7H28V10H26zM29 4H32V6H29zM26 0H28V3H26zM22 4H25V6H22zM19 16L19 18.7 16.5 18 16 19.9 18.4 20.6 17 23 18.7 24 20 21.8 21.3 24 23 23 21.6 20.6 24 19.9 23.5 18 21 18.7 21 16 19 16zM13 16L13 13 16 13 16 11 13 11 13 8 11 8 11 11 8 11 8 13 11 13 11 16 13 16z"
    })), _path100$p || (_path100$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H19V4H6A2.0059,2.0059,0,0,0,4,6V26a2.0059,2.0059,0,0,0,2,2H26a2.0059,2.0059,0,0,0,2-2V13H26Z"
    })), children);
  });
  var Cicsplex32 = /*#__PURE__*/React__default['default'].forwardRef(function Cicsplex32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$p || (_path101$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18.6V17H6v1.6A7.3833 7.3833 0 0013.4 26H15V24H13.4A5.3775 5.3775 0 018 18.6zM28 18H20a2.0059 2.0059 0 00-2 2v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V20A2.0059 2.0059 0 0028 18zM20 28V20h8v8zM24 13.4V15h2V13.4A7.3833 7.3833 0 0018.6 6H17V8h1.6A5.3775 5.3775 0 0124 13.4zM12 2H4A2.0059 2.0059 0 002 4v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0012 2zM4 12V4h8v8z"
    })), children);
  });
  var Cicsplex24 = /*#__PURE__*/React__default['default'].forwardRef(function Cicsplex24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$p || (_path102$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18.6V17H6v1.6A7.3833 7.3833 0 0013.4 26H15V24H13.4A5.3775 5.3775 0 018 18.6zM28 18H20a2.0059 2.0059 0 00-2 2v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V20A2.0059 2.0059 0 0028 18zM20 28V20h8v8zM24 13.4V15h2V13.4A7.3833 7.3833 0 0018.6 6H17V8h1.6A5.3775 5.3775 0 0124 13.4zM12 2H4A2.0059 2.0059 0 002 4v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0012 2zM4 12V4h8v8z"
    })), children);
  });
  var Cicsplex20 = /*#__PURE__*/React__default['default'].forwardRef(function Cicsplex20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$p || (_path103$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18.6V17H6v1.6A7.3833 7.3833 0 0013.4 26H15V24H13.4A5.3775 5.3775 0 018 18.6zM28 18H20a2.0059 2.0059 0 00-2 2v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V20A2.0059 2.0059 0 0028 18zM20 28V20h8v8zM24 13.4V15h2V13.4A7.3833 7.3833 0 0018.6 6H17V8h1.6A5.3775 5.3775 0 0124 13.4zM12 2H4A2.0059 2.0059 0 002 4v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0012 2zM4 12V4h8v8z"
    })), children);
  });
  var Cicsplex16 = /*#__PURE__*/React__default['default'].forwardRef(function Cicsplex16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$p || (_path104$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18.6V17H6v1.6A7.3833 7.3833 0 0013.4 26H15V24H13.4A5.3775 5.3775 0 018 18.6zM28 18H20a2.0059 2.0059 0 00-2 2v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V20A2.0059 2.0059 0 0028 18zM20 28V20h8v8zM24 13.4V15h2V13.4A7.3833 7.3833 0 0018.6 6H17V8h1.6A5.3775 5.3775 0 0124 13.4zM12 2H4A2.0059 2.0059 0 002 4v8a2.0059 2.0059 0 002 2h8a2.0059 2.0059 0 002-2V4A2.0059 2.0059 0 0012 2zM4 12V4h8v8z"
    })), children);
  });
  var CircleFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CircleFilled32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$o || (_circle$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "10"
    })), _path105$p || (_path105$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CircleFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CircleFilled24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle2$o || (_circle2$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "10"
    })), _path106$p || (_path106$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CircleFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CircleFilled20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$o || (_circle3$o = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "10"
    })), _path107$p || (_path107$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CircleFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CircleFilled16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$n || (_circle4$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "10"
    })), _path108$p || (_path108$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var CircleSolid32 = /*#__PURE__*/React__default['default'].forwardRef(function CircleSolid32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$m || (_circle5$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "14"
    })), children);
  });
  var CircleSolid24 = /*#__PURE__*/React__default['default'].forwardRef(function CircleSolid24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$m || (_circle6$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "14"
    })), children);
  });
  var CircleSolid20 = /*#__PURE__*/React__default['default'].forwardRef(function CircleSolid20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$m || (_circle7$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "14"
    })), children);
  });
  var CircleSolid16 = /*#__PURE__*/React__default['default'].forwardRef(function CircleSolid16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$m || (_circle8$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "14"
    })), children);
  });
  var CircleDash32 = /*#__PURE__*/React__default['default'].forwardRef(function CircleDash32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$p || (_path109$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7 14.7 0 00-3 3.1L6.3 9A13.26 13.26 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 002 16H4A11.48 11.48 0 014.6 12.3zM2.7 20.4a14.4 14.4 0 002 3.9l1.6-1.2a12.89 12.89 0 01-1.7-3.3zM7.8 27.3a14.4 14.4 0 003.9 2l.6-1.9A12.89 12.89 0 019 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0116 4V2A12.51 12.51 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.53 11.53 0 0123 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0030 16H28A11.48 11.48 0 0127.4 19.7zM29.2 11.6a14.4 14.4 0 00-2-3.9L25.6 8.9a12.89 12.89 0 011.7 3.3zM24.1 4.6a14.4 14.4 0 00-3.9-2l-.6 1.9a12.89 12.89 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0116 28v2A21.42 21.42 0 0020.3 29.3z"
    })), children);
  });
  var CircleDash24 = /*#__PURE__*/React__default['default'].forwardRef(function CircleDash24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$p || (_path110$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7 14.7 0 00-3 3.1L6.3 9A13.26 13.26 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 002 16H4A11.48 11.48 0 014.6 12.3zM2.7 20.4a14.4 14.4 0 002 3.9l1.6-1.2a12.89 12.89 0 01-1.7-3.3zM7.8 27.3a14.4 14.4 0 003.9 2l.6-1.9A12.89 12.89 0 019 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0116 4V2A12.51 12.51 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.53 11.53 0 0123 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0030 16H28A11.48 11.48 0 0127.4 19.7zM29.2 11.6a14.4 14.4 0 00-2-3.9L25.6 8.9a12.89 12.89 0 011.7 3.3zM24.1 4.6a14.4 14.4 0 00-3.9-2l-.6 1.9a12.89 12.89 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0116 28v2A21.42 21.42 0 0020.3 29.3z"
    })), children);
  });
  var CircleDash20 = /*#__PURE__*/React__default['default'].forwardRef(function CircleDash20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$p || (_path111$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7 14.7 0 00-3 3.1L6.3 9A13.26 13.26 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 002 16H4A11.48 11.48 0 014.6 12.3zM2.7 20.4a14.4 14.4 0 002 3.9l1.6-1.2a12.89 12.89 0 01-1.7-3.3zM7.8 27.3a14.4 14.4 0 003.9 2l.6-1.9A12.89 12.89 0 019 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0116 4V2A12.51 12.51 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.53 11.53 0 0123 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0030 16H28A11.48 11.48 0 0127.4 19.7zM29.2 11.6a14.4 14.4 0 00-2-3.9L25.6 8.9a12.89 12.89 0 011.7 3.3zM24.1 4.6a14.4 14.4 0 00-3.9-2l-.6 1.9a12.89 12.89 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0116 28v2A21.42 21.42 0 0020.3 29.3z"
    })), children);
  });
  var CircleDash16 = /*#__PURE__*/React__default['default'].forwardRef(function CircleDash16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$p || (_path112$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7 14.7 0 00-3 3.1L6.3 9A13.26 13.26 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 002 16H4A11.48 11.48 0 014.6 12.3zM2.7 20.4a14.4 14.4 0 002 3.9l1.6-1.2a12.89 12.89 0 01-1.7-3.3zM7.8 27.3a14.4 14.4 0 003.9 2l.6-1.9A12.89 12.89 0 019 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0116 4V2A12.51 12.51 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.53 11.53 0 0123 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0030 16H28A11.48 11.48 0 0127.4 19.7zM29.2 11.6a14.4 14.4 0 00-2-3.9L25.6 8.9a12.89 12.89 0 011.7 3.3zM24.1 4.6a14.4 14.4 0 00-3.9-2l-.6 1.9a12.89 12.89 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0116 28v2A21.42 21.42 0 0020.3 29.3z"
    })), children);
  });
  var CircleFillGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CircleFillGlyph(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$m || (_circle9$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "8",
      r: "6"
    })), children);
  });
  var WatsonHealthCircleMeasurement32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCircleMeasurement32(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$p || (_path113$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path114$p || (_path114$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"
    })), children);
  });
  var WatsonHealthCircleMeasurement24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCircleMeasurement24(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$p || (_path115$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path116$p || (_path116$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"
    })), children);
  });
  var WatsonHealthCircleMeasurement20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCircleMeasurement20(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$p || (_path117$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path118$p || (_path118$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"
    })), children);
  });
  var WatsonHealthCircleMeasurement16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCircleMeasurement16(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$p || (_path119$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path120$p || (_path120$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"
    })), children);
  });
  var CirclePacking32 = /*#__PURE__*/React__default['default'].forwardRef(function CirclePacking32(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$p || (_path121$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.5,7A3.5,3.5,0,1,1,20,12.5,3.5041,3.5041,0,0,1,23.5,9Zm.4348-1.978C23.791,7.0107,23.6467,7,23.5,7a5.4826,5.4826,0,0,0-4.1323,1.8784,8.0109,8.0109,0,0,0-5.5664-4.6675A11.8554,11.8554,0,0,1,23.9348,7.022ZM16,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,28ZM12,18a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,12,18ZM4,16a11.97,11.97,0,0,1,.2112-2.1987,7.9921,7.9921,0,0,0,7.3459,6.1762,5.9581,5.9581,0,0,0-.89,6.7564A12.0025,12.0025,0,0,1,4,16ZM21.3325,26.7339a5.9834,5.9834,0,0,0-4.1782-8.6206,8.02,8.02,0,0,0,1.9126-2.3672,5.4883,5.4883,0,0,0,8.9167-.0679c.003.1079.0164.2134.0164.3218A12.0025,12.0025,0,0,1,21.3325,26.7339Z"
    })), children);
  });
  var CirclePacking24 = /*#__PURE__*/React__default['default'].forwardRef(function CirclePacking24(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$p || (_path122$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.5,7A3.5,3.5,0,1,1,20,12.5,3.5041,3.5041,0,0,1,23.5,9Zm.4348-1.978C23.791,7.0107,23.6467,7,23.5,7a5.4826,5.4826,0,0,0-4.1323,1.8784,8.0109,8.0109,0,0,0-5.5664-4.6675A11.8554,11.8554,0,0,1,23.9348,7.022ZM16,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,28ZM12,18a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,12,18ZM4,16a11.97,11.97,0,0,1,.2112-2.1987,7.9921,7.9921,0,0,0,7.3459,6.1762,5.9581,5.9581,0,0,0-.89,6.7564A12.0025,12.0025,0,0,1,4,16ZM21.3325,26.7339a5.9834,5.9834,0,0,0-4.1782-8.6206,8.02,8.02,0,0,0,1.9126-2.3672,5.4883,5.4883,0,0,0,8.9167-.0679c.003.1079.0164.2134.0164.3218A12.0025,12.0025,0,0,1,21.3325,26.7339Z"
    })), children);
  });
  var CirclePacking20 = /*#__PURE__*/React__default['default'].forwardRef(function CirclePacking20(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$p || (_path123$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.5,7A3.5,3.5,0,1,1,20,12.5,3.5041,3.5041,0,0,1,23.5,9Zm.4348-1.978C23.791,7.0107,23.6467,7,23.5,7a5.4826,5.4826,0,0,0-4.1323,1.8784,8.0109,8.0109,0,0,0-5.5664-4.6675A11.8554,11.8554,0,0,1,23.9348,7.022ZM16,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,28ZM12,18a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,12,18ZM4,16a11.97,11.97,0,0,1,.2112-2.1987,7.9921,7.9921,0,0,0,7.3459,6.1762,5.9581,5.9581,0,0,0-.89,6.7564A12.0025,12.0025,0,0,1,4,16ZM21.3325,26.7339a5.9834,5.9834,0,0,0-4.1782-8.6206,8.02,8.02,0,0,0,1.9126-2.3672,5.4883,5.4883,0,0,0,8.9167-.0679c.003.1079.0164.2134.0164.3218A12.0025,12.0025,0,0,1,21.3325,26.7339Z"
    })), children);
  });
  var CirclePacking16 = /*#__PURE__*/React__default['default'].forwardRef(function CirclePacking16(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$p || (_path124$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.5,7A3.5,3.5,0,1,1,20,12.5,3.5041,3.5041,0,0,1,23.5,9Zm.4348-1.978C23.791,7.0107,23.6467,7,23.5,7a5.4826,5.4826,0,0,0-4.1323,1.8784,8.0109,8.0109,0,0,0-5.5664-4.6675A11.8554,11.8554,0,0,1,23.9348,7.022ZM16,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,28ZM12,18a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,12,18ZM4,16a11.97,11.97,0,0,1,.2112-2.1987,7.9921,7.9921,0,0,0,7.3459,6.1762,5.9581,5.9581,0,0,0-.89,6.7564A12.0025,12.0025,0,0,1,4,16ZM21.3325,26.7339a5.9834,5.9834,0,0,0-4.1782-8.6206,8.02,8.02,0,0,0,1.9126-2.3672,5.4883,5.4883,0,0,0,8.9167-.0679c.003.1079.0164.2134.0164.3218A12.0025,12.0025,0,0,1,21.3325,26.7339Z"
    })), children);
  });
  var CircleStrokeGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CircleStrokeGlyph(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$p || (_path125$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,4A4,4,0,1,1,4,8,4.0045,4.0045,0,0,1,8,4M8,2a6,6,0,1,0,6,6A6,6,0,0,0,8,2Z"
    })), children);
  });
  var QCircuitComposer32 = /*#__PURE__*/React__default['default'].forwardRef(function QCircuitComposer32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$p || (_path126$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path127$p || (_path127$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"
    })), children);
  });
  var QCircuitComposer24 = /*#__PURE__*/React__default['default'].forwardRef(function QCircuitComposer24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$p || (_path128$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path129$p || (_path129$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"
    })), children);
  });
  var QCircuitComposer20 = /*#__PURE__*/React__default['default'].forwardRef(function QCircuitComposer20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$p || (_path130$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path131$p || (_path131$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"
    })), children);
  });
  var QCircuitComposer16 = /*#__PURE__*/React__default['default'].forwardRef(function QCircuitComposer16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$p || (_path132$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path133$p || (_path133$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"
    })), children);
  });
  var Classification32 = /*#__PURE__*/React__default['default'].forwardRef(function Classification32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$m || (_circle10$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "19",
      r: "1"
    })), _path134$p || (_path134$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"
    })), children);
  });
  var Classification24 = /*#__PURE__*/React__default['default'].forwardRef(function Classification24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$l || (_circle11$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "19",
      r: "1"
    })), _path135$p || (_path135$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"
    })), children);
  });
  var Classification20 = /*#__PURE__*/React__default['default'].forwardRef(function Classification20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12$l || (_circle12$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "19",
      r: "1"
    })), _path136$p || (_path136$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"
    })), children);
  });
  var Classification16 = /*#__PURE__*/React__default['default'].forwardRef(function Classification16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$l || (_circle13$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "19",
      r: "1"
    })), _path137$p || (_path137$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"
    })), children);
  });
  var ClassifierLanguage32 = /*#__PURE__*/React__default['default'].forwardRef(function ClassifierLanguage32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$p || (_path138$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 10-2 0V14H2v2H9V14H7zM4 6A2 2 0 116 8 2 2 0 014 6z"
    })), children);
  });
  var ClassifierLanguage24 = /*#__PURE__*/React__default['default'].forwardRef(function ClassifierLanguage24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$p || (_path139$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 10-2 0V14H2v2H9V14H7zM4 6A2 2 0 116 8 2 2 0 014 6z"
    })), children);
  });
  var ClassifierLanguage20 = /*#__PURE__*/React__default['default'].forwardRef(function ClassifierLanguage20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$p || (_path140$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 10-2 0V14H2v2H9V14H7zM4 6A2 2 0 116 8 2 2 0 014 6z"
    })), children);
  });
  var ClassifierLanguage16 = /*#__PURE__*/React__default['default'].forwardRef(function ClassifierLanguage16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$p || (_path141$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 10-2 0V14H2v2H9V14H7zM4 6A2 2 0 116 8 2 2 0 014 6z"
    })), children);
  });
  var Clean32 = /*#__PURE__*/React__default['default'].forwardRef(function Clean32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$p || (_path142$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H26V20H20z",
      transform: "rotate(-180 23 19)"
    })), _path143$p || (_path143$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H30V28H24z",
      transform: "rotate(-180 27 27)"
    })), _path144$p || (_path144$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22H28V24H22z",
      transform: "rotate(-180 25 23)"
    })), _path145$p || (_path145$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.0029,20a4.8952,4.8952,0,0,0-2.4044-4.1729L22,3,20.2691,2,12.6933,15.126A5.6988,5.6988,0,0,0,7.45,16.6289C3.7064,20.24,3.9963,28.6821,4.01,29.04a1,1,0,0,0,1,.96H20.0012a1,1,0,0,0,.6-1.8C17.0615,25.5439,17.0029,20.0537,17.0029,20ZM11.93,16.9971A3.11,3.11,0,0,1,15.0041,20c0,.0381.0019.208.0168.4688L9.1215,17.8452A3.8,3.8,0,0,1,11.93,16.9971ZM15.4494,28A5.2,5.2,0,0,1,14,25H12a6.4993,6.4993,0,0,0,.9684,3H10.7451A16.6166,16.6166,0,0,1,10,24H8a17.3424,17.3424,0,0,0,.6652,4H6c.031-1.8364.29-5.8921,1.8027-8.5527l7.533,3.35A13.0253,13.0253,0,0,0,17.5968,28Z"
    })), children);
  });
  var Clean24 = /*#__PURE__*/React__default['default'].forwardRef(function Clean24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$p || (_path146$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H26V20H20z",
      transform: "rotate(-180 23 19)"
    })), _path147$p || (_path147$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H30V28H24z",
      transform: "rotate(-180 27 27)"
    })), _path148$p || (_path148$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22H28V24H22z",
      transform: "rotate(-180 25 23)"
    })), _path149$p || (_path149$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.0029,20a4.8952,4.8952,0,0,0-2.4044-4.1729L22,3,20.2691,2,12.6933,15.126A5.6988,5.6988,0,0,0,7.45,16.6289C3.7064,20.24,3.9963,28.6821,4.01,29.04a1,1,0,0,0,1,.96H20.0012a1,1,0,0,0,.6-1.8C17.0615,25.5439,17.0029,20.0537,17.0029,20ZM11.93,16.9971A3.11,3.11,0,0,1,15.0041,20c0,.0381.0019.208.0168.4688L9.1215,17.8452A3.8,3.8,0,0,1,11.93,16.9971ZM15.4494,28A5.2,5.2,0,0,1,14,25H12a6.4993,6.4993,0,0,0,.9684,3H10.7451A16.6166,16.6166,0,0,1,10,24H8a17.3424,17.3424,0,0,0,.6652,4H6c.031-1.8364.29-5.8921,1.8027-8.5527l7.533,3.35A13.0253,13.0253,0,0,0,17.5968,28Z"
    })), children);
  });
  var Clean20 = /*#__PURE__*/React__default['default'].forwardRef(function Clean20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$p || (_path150$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H26V20H20z",
      transform: "rotate(-180 23 19)"
    })), _path151$p || (_path151$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H30V28H24z",
      transform: "rotate(-180 27 27)"
    })), _path152$p || (_path152$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22H28V24H22z",
      transform: "rotate(-180 25 23)"
    })), _path153$p || (_path153$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.0029,20a4.8952,4.8952,0,0,0-2.4044-4.1729L22,3,20.2691,2,12.6933,15.126A5.6988,5.6988,0,0,0,7.45,16.6289C3.7064,20.24,3.9963,28.6821,4.01,29.04a1,1,0,0,0,1,.96H20.0012a1,1,0,0,0,.6-1.8C17.0615,25.5439,17.0029,20.0537,17.0029,20ZM11.93,16.9971A3.11,3.11,0,0,1,15.0041,20c0,.0381.0019.208.0168.4688L9.1215,17.8452A3.8,3.8,0,0,1,11.93,16.9971ZM15.4494,28A5.2,5.2,0,0,1,14,25H12a6.4993,6.4993,0,0,0,.9684,3H10.7451A16.6166,16.6166,0,0,1,10,24H8a17.3424,17.3424,0,0,0,.6652,4H6c.031-1.8364.29-5.8921,1.8027-8.5527l7.533,3.35A13.0253,13.0253,0,0,0,17.5968,28Z"
    })), children);
  });
  var Clean16 = /*#__PURE__*/React__default['default'].forwardRef(function Clean16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$p || (_path154$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H26V20H20z",
      transform: "rotate(-180 23 19)"
    })), _path155$p || (_path155$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H30V28H24z",
      transform: "rotate(-180 27 27)"
    })), _path156$p || (_path156$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 22H28V24H22z",
      transform: "rotate(-180 25 23)"
    })), _path157$p || (_path157$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.0029,20a4.8952,4.8952,0,0,0-2.4044-4.1729L22,3,20.2691,2,12.6933,15.126A5.6988,5.6988,0,0,0,7.45,16.6289C3.7064,20.24,3.9963,28.6821,4.01,29.04a1,1,0,0,0,1,.96H20.0012a1,1,0,0,0,.6-1.8C17.0615,25.5439,17.0029,20.0537,17.0029,20ZM11.93,16.9971A3.11,3.11,0,0,1,15.0041,20c0,.0381.0019.208.0168.4688L9.1215,17.8452A3.8,3.8,0,0,1,11.93,16.9971ZM15.4494,28A5.2,5.2,0,0,1,14,25H12a6.4993,6.4993,0,0,0,.9684,3H10.7451A16.6166,16.6166,0,0,1,10,24H8a17.3424,17.3424,0,0,0,.6652,4H6c.031-1.8364.29-5.8921,1.8027-8.5527l7.533,3.35A13.0253,13.0253,0,0,0,17.5968,28Z"
    })), children);
  });
  var Close32 = /*#__PURE__*/React__default['default'].forwardRef(function Close32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$p || (_path158$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"
    })), children);
  });
  var Close24 = /*#__PURE__*/React__default['default'].forwardRef(function Close24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$p || (_path159$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"
    })), children);
  });
  var Close20 = /*#__PURE__*/React__default['default'].forwardRef(function Close20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$p || (_path160$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"
    })), children);
  });
  var Close16 = /*#__PURE__*/React__default['default'].forwardRef(function Close16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$p || (_path161$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"
    })), children);
  });
  var CloseFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CloseFilled32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$p || (_path162$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"
    })), _path163$p || (_path163$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4 16L9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4 21.4 23 16 17.6 10.6 23 9 21.4 14.4 16",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var CloseFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CloseFilled24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$p || (_path164$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"
    })), _path165$p || (_path165$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4 16L9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4 21.4 23 16 17.6 10.6 23 9 21.4 14.4 16",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var CloseFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CloseFilled20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$p || (_path166$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"
    })), _path167$p || (_path167$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4 16L9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4 21.4 23 16 17.6 10.6 23 9 21.4 14.4 16",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var CloseFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CloseFilled16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$p || (_path168$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M10.7,11.5L8,8.8l-2.7,2.7l-0.8-0.8L7.2,8L4.5,5.3l0.8-0.8L8,7.2\tl2.7-2.7l0.8,0.8L8.8,8l2.7,2.7L10.7,11.5z"
    })), children);
  });
  var CloseOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function CloseOutline32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$p || (_path169$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path170$p || (_path170$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var CloseOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function CloseOutline24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$p || (_path171$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path172$p || (_path172$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var CloseOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function CloseOutline20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$p || (_path173$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path174$p || (_path174$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var CloseOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function CloseOutline16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$p);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$p || (_path175$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path176$p || (_path176$p = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var ClosedCaption32 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaption32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$o || (_path177$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H10a2 2 0 01-2-2V13a2 2 0 012-2h5v2H10v6h5zM25 21H20a2 2 0 01-2-2V13a2 2 0 012-2h5v2H20v6h5z"
    })), _path178$o || (_path178$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var ClosedCaption24 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaption24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$o || (_path179$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H10a2 2 0 01-2-2V13a2 2 0 012-2h5v2H10v6h5zM25 21H20a2 2 0 01-2-2V13a2 2 0 012-2h5v2H20v6h5z"
    })), _path180$o || (_path180$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var ClosedCaption20 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaption20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$o || (_path181$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H10a2 2 0 01-2-2V13a2 2 0 012-2h5v2H10v6h5zM25 21H20a2 2 0 01-2-2V13a2 2 0 012-2h5v2H20v6h5z"
    })), _path182$o || (_path182$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var ClosedCaption16 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaption16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$o || (_path183$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H10a2 2 0 01-2-2V13a2 2 0 012-2h5v2H10v6h5zM25 21H20a2 2 0 01-2-2V13a2 2 0 012-2h5v2H20v6h5z"
    })), _path184$o || (_path184$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var ClosedCaptionAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionAlt32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$o || (_path185$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"
    })), _path186$o || (_path186$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ClosedCaptionAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionAlt24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$o || (_path187$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"
    })), _path188$o || (_path188$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ClosedCaptionAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionAlt20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$o || (_path189$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"
    })), _path190$o || (_path190$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ClosedCaptionAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionAlt16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$o || (_path191$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"
    })), _path192$o || (_path192$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var ClosedCaptionFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionFilled32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$o || (_path193$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"
    })), children);
  });
  var ClosedCaptionFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionFilled24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$o || (_path194$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"
    })), children);
  });
  var ClosedCaptionFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionFilled20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$o || (_path195$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"
    })), children);
  });
  var ClosedCaptionFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ClosedCaptionFilled16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$o || (_path196$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"
    })), children);
  });
  var Cloud32 = /*#__PURE__*/React__default['default'].forwardRef(function Cloud32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$o || (_path197$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), children);
  });
  var Cloud24 = /*#__PURE__*/React__default['default'].forwardRef(function Cloud24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$o || (_path198$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), children);
  });
  var Cloud20 = /*#__PURE__*/React__default['default'].forwardRef(function Cloud20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$o || (_path199$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), children);
  });
  var Cloud16 = /*#__PURE__*/React__default['default'].forwardRef(function Cloud16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$o || (_path200$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), children);
  });
  var CloudAlerting32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAlerting32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$o || (_path201$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H15V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path202$o || (_path202$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H17a1,1,0,0,1-.8574-1.5144l6-10a1,1,0,0,1,1.7154,0l6,10A1,1,0,0,1,29,14ZM18.7661,12h8.4678L23,4.9436Z"
    })), children);
  });
  var CloudAlerting24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAlerting24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$o || (_path203$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H15V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path204$o || (_path204$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H17a1,1,0,0,1-.8574-1.5144l6-10a1,1,0,0,1,1.7154,0l6,10A1,1,0,0,1,29,14ZM18.7661,12h8.4678L23,4.9436Z"
    })), children);
  });
  var CloudAlerting20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAlerting20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$o || (_path205$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H15V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path206$o || (_path206$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H17a1,1,0,0,1-.8574-1.5144l6-10a1,1,0,0,1,1.7154,0l6,10A1,1,0,0,1,29,14ZM18.7661,12h8.4678L23,4.9436Z"
    })), children);
  });
  var CloudAlerting16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAlerting16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$o || (_path207$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H15V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path208$o || (_path208$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H17a1,1,0,0,1-.8574-1.5144l6-10a1,1,0,0,1,1.7154,0l6,10A1,1,0,0,1,29,14ZM18.7661,12h8.4678L23,4.9436Z"
    })), children);
  });
  var CloudAuditing32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAuditing32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$o || (_path209$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path210$o || (_path210$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L16 10.04 17.59 8.47 21 11.85 28.41 4.5 30 6.08 21 15z"
    })), children);
  });
  var CloudAuditing24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAuditing24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$o || (_path211$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path212$o || (_path212$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L16 10.04 17.59 8.47 21 11.85 28.41 4.5 30 6.08 21 15z"
    })), children);
  });
  var CloudAuditing20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAuditing20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$o || (_path213$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path214$o || (_path214$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L16 10.04 17.59 8.47 21 11.85 28.41 4.5 30 6.08 21 15z"
    })), children);
  });
  var CloudAuditing16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudAuditing16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$o || (_path215$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6H16V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path216$o || (_path216$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L16 10.04 17.59 8.47 21 11.85 28.41 4.5 30 6.08 21 15z"
    })), children);
  });
  var CloudDataOps32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDataOps32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$o || (_path217$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 18H30V28H28zM24 14H26V28H24zM20 22H22V28H20zM22.175 10L23.76 8.7339A9.9522 9.9522 0 0017.89 5.1816 10.0025 10.0025 0 006.17 13.1152 7.5054 7.5054 0 00.0544 21.4087 7.6843 7.6843 0 007.7692 28H16V26H7.6945a5.632 5.632 0 01-5.6023-4.4858 5.5064 5.5064 0 014.4339-6.4307l1.3486-.2441.2139-1.11a8.206 8.206 0 016.7426-6.6426 7.9666 7.9666 0 013.0137.13A7.8037 7.8037 0 0122.175 10z"
    })), children);
  });
  var CloudDataOps24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDataOps24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$o || (_path218$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 18H30V28H28zM24 14H26V28H24zM20 22H22V28H20zM22.175 10L23.76 8.7339A9.9522 9.9522 0 0017.89 5.1816 10.0025 10.0025 0 006.17 13.1152 7.5054 7.5054 0 00.0544 21.4087 7.6843 7.6843 0 007.7692 28H16V26H7.6945a5.632 5.632 0 01-5.6023-4.4858 5.5064 5.5064 0 014.4339-6.4307l1.3486-.2441.2139-1.11a8.206 8.206 0 016.7426-6.6426 7.9666 7.9666 0 013.0137.13A7.8037 7.8037 0 0122.175 10z"
    })), children);
  });
  var CloudDataOps20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDataOps20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$o || (_path219$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 18H30V28H28zM24 14H26V28H24zM20 22H22V28H20zM22.175 10L23.76 8.7339A9.9522 9.9522 0 0017.89 5.1816 10.0025 10.0025 0 006.17 13.1152 7.5054 7.5054 0 00.0544 21.4087 7.6843 7.6843 0 007.7692 28H16V26H7.6945a5.632 5.632 0 01-5.6023-4.4858 5.5064 5.5064 0 014.4339-6.4307l1.3486-.2441.2139-1.11a8.206 8.206 0 016.7426-6.6426 7.9666 7.9666 0 013.0137.13A7.8037 7.8037 0 0122.175 10z"
    })), children);
  });
  var CloudDataOps16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDataOps16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$o || (_path220$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 18H30V28H28zM24 14H26V28H24zM20 22H22V28H20zM22.175 10L23.76 8.7339A9.9522 9.9522 0 0017.89 5.1816 10.0025 10.0025 0 006.17 13.1152 7.5054 7.5054 0 00.0544 21.4087 7.6843 7.6843 0 007.7692 28H16V26H7.6945a5.632 5.632 0 01-5.6023-4.4858 5.5064 5.5064 0 014.4339-6.4307l1.3486-.2441.2139-1.11a8.206 8.206 0 016.7426-6.6426 7.9666 7.9666 0 013.0137.13A7.8037 7.8037 0 0122.175 10z"
    })), children);
  });
  var CloudDownload32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDownload32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$o || (_path221$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path222$o || (_path222$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"
    })), children);
  });
  var CloudDownload24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDownload24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$o || (_path223$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path224$o || (_path224$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"
    })), children);
  });
  var CloudDownload20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDownload20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$o || (_path225$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path226$o || (_path226$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"
    })), children);
  });
  var CloudDownload16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudDownload16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$o || (_path227$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path228$o || (_path228$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"
    })), children);
  });
  var CloudLightning32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLightning32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudLightning32']) {
        didWarnAboutDeprecation$9['CloudLightning32'] = true;
        console.warn("The CloudLightning32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$o || (_path229$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var CloudLightning24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLightning24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudLightning24']) {
        didWarnAboutDeprecation$9['CloudLightning24'] = true;
        console.warn("The CloudLightning24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$o || (_path230$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var CloudLightning20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLightning20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudLightning20']) {
        didWarnAboutDeprecation$9['CloudLightning20'] = true;
        console.warn("The CloudLightning20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$o || (_path231$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var CloudLightning16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLightning16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudLightning16']) {
        didWarnAboutDeprecation$9['CloudLightning16'] = true;
        console.warn("The CloudLightning16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$o || (_path232$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var CloudLogging32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLogging32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$o || (_path233$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16v6H4V6H15V4H4A2 2 0 002 6V22a2 2 0 002 2h8v4H8v2H24V28H20V24h8a2 2 0 002-2V16zM18 28H14V24h4zM18 4H30V6H18z"
    })), _path234$o || (_path234$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H30V10H18zM18 12H24V14H18z"
    })), children);
  });
  var CloudLogging24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLogging24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$o || (_path235$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16v6H4V6H15V4H4A2 2 0 002 6V22a2 2 0 002 2h8v4H8v2H24V28H20V24h8a2 2 0 002-2V16zM18 28H14V24h4zM18 4H30V6H18z"
    })), _path236$o || (_path236$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H30V10H18zM18 12H24V14H18z"
    })), children);
  });
  var CloudLogging20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLogging20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$o || (_path237$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16v6H4V6H15V4H4A2 2 0 002 6V22a2 2 0 002 2h8v4H8v2H24V28H20V24h8a2 2 0 002-2V16zM18 28H14V24h4zM18 4H30V6H18z"
    })), _path238$o || (_path238$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H30V10H18zM18 12H24V14H18z"
    })), children);
  });
  var CloudLogging16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudLogging16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$o || (_path239$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16v6H4V6H15V4H4A2 2 0 002 6V22a2 2 0 002 2h8v4H8v2H24V28H20V24h8a2 2 0 002-2V16zM18 28H14V24h4zM18 4H30V6H18z"
    })), _path240$o || (_path240$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 8H30V10H18zM18 12H24V14H18z"
    })), children);
  });
  var CloudMonitoring32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudMonitoring32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$o || (_path241$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6h7V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path242$o || (_path242$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,18h-.01a1,1,0,0,1-.9511-.7253L15.2456,11H11V9h5a1,1,0,0,1,.9615.7252l1.0742,3.7589,3.0088-9.7783A1.0142,1.0142,0,0,1,22,3a.98.98,0,0,1,.9487.6838L24.7207,9H30v2H24a1,1,0,0,1-.9487-.6838l-1.0132-3.04L18.9556,17.2942A1,1,0,0,1,18,18Z"
    })), children);
  });
  var CloudMonitoring24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudMonitoring24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$o || (_path243$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6h7V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path244$o || (_path244$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,18h-.01a1,1,0,0,1-.9511-.7253L15.2456,11H11V9h5a1,1,0,0,1,.9615.7252l1.0742,3.7589,3.0088-9.7783A1.0142,1.0142,0,0,1,22,3a.98.98,0,0,1,.9487.6838L24.7207,9H30v2H24a1,1,0,0,1-.9487-.6838l-1.0132-3.04L18.9556,17.2942A1,1,0,0,1,18,18Z"
    })), children);
  });
  var CloudMonitoring20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudMonitoring20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$o || (_path245$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6h7V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path246$o || (_path246$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,18h-.01a1,1,0,0,1-.9511-.7253L15.2456,11H11V9h5a1,1,0,0,1,.9615.7252l1.0742,3.7589,3.0088-9.7783A1.0142,1.0142,0,0,1,22,3a.98.98,0,0,1,.9487.6838L24.7207,9H30v2H24a1,1,0,0,1-.9487-.6838l-1.0132-3.04L18.9556,17.2942A1,1,0,0,1,18,18Z"
    })), children);
  });
  var CloudMonitoring16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudMonitoring16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$o || (_path247$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16v6H4V6h7V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V16ZM18,28H14V24h4Z"
    })), _path248$o || (_path248$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,18h-.01a1,1,0,0,1-.9511-.7253L15.2456,11H11V9h5a1,1,0,0,1,.9615.7252l1.0742,3.7589,3.0088-9.7783A1.0142,1.0142,0,0,1,22,3a.98.98,0,0,1,.9487.6838L24.7207,9H30v2H24a1,1,0,0,1-.9487-.6838l-1.0132-3.04L18.9556,17.2942A1,1,0,0,1,18,18Z"
    })), children);
  });
  var CloudOffline32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudOffline32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$o || (_path249$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008 12.1362a8.8694 8.8694 0 00-.9795-2.5434L30 3.4142 28.5872 2 2 28.5872 3.4142 30l5-5H23.5a6.4974 6.4974 0 001.3008-12.8638zM23.5 23H10.4141L22.3418 11.0723a6.9049 6.9049 0 01.6006 2.0708l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 23zM4.2964 23.4487l1.4313-1.4311A4.4774 4.4774 0 018.144 14.019l.8155-.0639.0991-.812a6.9867 6.9867 0 0110.63-5.0865l1.4431-1.4428A8.9859 8.9859 0 007.2 12.1362 6.4891 6.4891 0 004.2964 23.4487z"
    })), children);
  });
  var CloudOffline24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudOffline24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$o || (_path250$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008 12.1362a8.8694 8.8694 0 00-.9795-2.5434L30 3.4142 28.5872 2 2 28.5872 3.4142 30l5-5H23.5a6.4974 6.4974 0 001.3008-12.8638zM23.5 23H10.4141L22.3418 11.0723a6.9049 6.9049 0 01.6006 2.0708l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 23zM4.2964 23.4487l1.4313-1.4311A4.4774 4.4774 0 018.144 14.019l.8155-.0639.0991-.812a6.9867 6.9867 0 0110.63-5.0865l1.4431-1.4428A8.9859 8.9859 0 007.2 12.1362 6.4891 6.4891 0 004.2964 23.4487z"
    })), children);
  });
  var CloudOffline20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudOffline20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$o || (_path251$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008 12.1362a8.8694 8.8694 0 00-.9795-2.5434L30 3.4142 28.5872 2 2 28.5872 3.4142 30l5-5H23.5a6.4974 6.4974 0 001.3008-12.8638zM23.5 23H10.4141L22.3418 11.0723a6.9049 6.9049 0 01.6006 2.0708l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 23zM4.2964 23.4487l1.4313-1.4311A4.4774 4.4774 0 018.144 14.019l.8155-.0639.0991-.812a6.9867 6.9867 0 0110.63-5.0865l1.4431-1.4428A8.9859 8.9859 0 007.2 12.1362 6.4891 6.4891 0 004.2964 23.4487z"
    })), children);
  });
  var CloudOffline16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudOffline16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$o || (_path252$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008 12.1362a8.8694 8.8694 0 00-.9795-2.5434L30 3.4142 28.5872 2 2 28.5872 3.4142 30l5-5H23.5a6.4974 6.4974 0 001.3008-12.8638zM23.5 23H10.4141L22.3418 11.0723a6.9049 6.9049 0 01.6006 2.0708l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 23zM4.2964 23.4487l1.4313-1.4311A4.4774 4.4774 0 018.144 14.019l.8155-.0639.0991-.812a6.9867 6.9867 0 0110.63-5.0865l1.4431-1.4428A8.9859 8.9859 0 007.2 12.1362 6.4891 6.4891 0 004.2964 23.4487z"
    })), children);
  });
  var CloudRain32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRain32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudRain32']) {
        didWarnAboutDeprecation$9['CloudRain32'] = true;
        console.warn("The CloudRain32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$o || (_path253$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var CloudRain24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRain24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudRain24']) {
        didWarnAboutDeprecation$9['CloudRain24'] = true;
        console.warn("The CloudRain24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$o || (_path254$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var CloudRain20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRain20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudRain20']) {
        didWarnAboutDeprecation$9['CloudRain20'] = true;
        console.warn("The CloudRain20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$o || (_path255$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var CloudRain16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRain16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudRain16']) {
        didWarnAboutDeprecation$9['CloudRain16'] = true;
        console.warn("The CloudRain16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$o || (_path256$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var CloudServiceManagement32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServiceManagement32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$o || (_path257$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H14V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path258$o || (_path258$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), children);
  });
  var CloudServiceManagement24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServiceManagement24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$o || (_path259$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H14V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path260$o || (_path260$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), children);
  });
  var CloudServiceManagement20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServiceManagement20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$o || (_path261$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H14V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path262$o || (_path262$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), children);
  });
  var CloudServiceManagement16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServiceManagement16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$o || (_path263$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v5H4V6H14V4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V17ZM18,28H14V24h4Z"
    })), _path264$o || (_path264$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), children);
  });
  var CloudSnow32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSnow32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudSnow32']) {
        didWarnAboutDeprecation$9['CloudSnow32'] = true;
        console.warn("The CloudSnow32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$o || (_path265$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var CloudSnow24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSnow24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudSnow24']) {
        didWarnAboutDeprecation$9['CloudSnow24'] = true;
        console.warn("The CloudSnow24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$o || (_path266$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var CloudSnow20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSnow20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudSnow20']) {
        didWarnAboutDeprecation$9['CloudSnow20'] = true;
        console.warn("The CloudSnow20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$o || (_path267$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var CloudSnow16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSnow16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$o);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$9['CloudSnow16']) {
        didWarnAboutDeprecation$9['CloudSnow16'] = true;
        console.warn("The CloudSnow16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$o || (_path268$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var CloudUpload32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudUpload32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$o || (_path269$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"
    })), _path270$o || (_path270$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), children);
  });
  var CloudUpload24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudUpload24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$o || (_path271$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"
    })), _path272$o || (_path272$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), children);
  });
  var CloudUpload20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudUpload20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$o || (_path273$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"
    })), _path274$o || (_path274$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), children);
  });
  var CloudUpload16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudUpload16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$o || (_path275$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"
    })), _path276$o || (_path276$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), children);
  });
  var CloudApp32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudApp32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$o || (_path277$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8289 13.1155A10.02 10.02 0 0016 5.0005V7a8.0233 8.0233 0 017.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0124.5076 26H16v2h8.5076a7.5019 7.5019 0 001.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"
    })), children);
  });
  var CloudApp24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudApp24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$o || (_path278$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8289 13.1155A10.02 10.02 0 0016 5.0005V7a8.0233 8.0233 0 017.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0124.5076 26H16v2h8.5076a7.5019 7.5019 0 001.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"
    })), children);
  });
  var CloudApp20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudApp20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$o || (_path279$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8289 13.1155A10.02 10.02 0 0016 5.0005V7a8.0233 8.0233 0 017.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0124.5076 26H16v2h8.5076a7.5019 7.5019 0 001.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"
    })), children);
  });
  var CloudApp16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudApp16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path280$o || (_path280$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8289 13.1155A10.02 10.02 0 0016 5.0005V7a8.0233 8.0233 0 017.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0124.5076 26H16v2h8.5076a7.5019 7.5019 0 001.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"
    })), children);
  });
  var CloudCeiling32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudCeiling32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$o || (_path281$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H11V30H2zM21 28H30V30H21zM17 26.167L17 17.832 19.586 20.414 21 19 16 14 11 19 12.413 20.415 15 17.832 15 26.167 12.413 23.584 11 25 16 30 21 25 19.586 23.586 17 26.167z"
    })), _path282$o || (_path282$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16H21V14h2a3,3,0,0,0,0-6c-.0938.0144-.1538.0219-.2153.0263l-.8037.0572L21.7544,7.31a5.9927,5.9927,0,0,0-11.1758-.8655l-.2832.5994-.8423-.0455A3.5008,3.5008,0,0,0,9.5,14H11v2H9.5A5.5,5.5,0,0,1,9.07,5.0166,7.9909,7.9909,0,0,1,23.42,6.0175,5,5,0,0,1,23,16Z"
    })), children);
  });
  var CloudCeiling24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudCeiling24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$o || (_path283$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H11V30H2zM21 28H30V30H21zM17 26.167L17 17.832 19.586 20.414 21 19 16 14 11 19 12.413 20.415 15 17.832 15 26.167 12.413 23.584 11 25 16 30 21 25 19.586 23.586 17 26.167z"
    })), _path284$o || (_path284$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16H21V14h2a3,3,0,0,0,0-6c-.0938.0144-.1538.0219-.2153.0263l-.8037.0572L21.7544,7.31a5.9927,5.9927,0,0,0-11.1758-.8655l-.2832.5994-.8423-.0455A3.5008,3.5008,0,0,0,9.5,14H11v2H9.5A5.5,5.5,0,0,1,9.07,5.0166,7.9909,7.9909,0,0,1,23.42,6.0175,5,5,0,0,1,23,16Z"
    })), children);
  });
  var CloudCeiling20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudCeiling20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$o || (_path285$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H11V30H2zM21 28H30V30H21zM17 26.167L17 17.832 19.586 20.414 21 19 16 14 11 19 12.413 20.415 15 17.832 15 26.167 12.413 23.584 11 25 16 30 21 25 19.586 23.586 17 26.167z"
    })), _path286$o || (_path286$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16H21V14h2a3,3,0,0,0,0-6c-.0938.0144-.1538.0219-.2153.0263l-.8037.0572L21.7544,7.31a5.9927,5.9927,0,0,0-11.1758-.8655l-.2832.5994-.8423-.0455A3.5008,3.5008,0,0,0,9.5,14H11v2H9.5A5.5,5.5,0,0,1,9.07,5.0166,7.9909,7.9909,0,0,1,23.42,6.0175,5,5,0,0,1,23,16Z"
    })), children);
  });
  var CloudCeiling16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudCeiling16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$o || (_path287$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H11V30H2zM21 28H30V30H21zM17 26.167L17 17.832 19.586 20.414 21 19 16 14 11 19 12.413 20.415 15 17.832 15 26.167 12.413 23.584 11 25 16 30 21 25 19.586 23.586 17 26.167z"
    })), _path288$o || (_path288$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16H21V14h2a3,3,0,0,0,0-6c-.0938.0144-.1538.0219-.2153.0263l-.8037.0572L21.7544,7.31a5.9927,5.9927,0,0,0-11.1758-.8655l-.2832.5994-.8423-.0455A3.5008,3.5008,0,0,0,9.5,14H11v2H9.5A5.5,5.5,0,0,1,9.07,5.0166,7.9909,7.9909,0,0,1,23.42,6.0175,5,5,0,0,1,23,16Z"
    })), children);
  });
  var CloudFoundry_132 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_132(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$o || (_path289$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), _path290$o || (_path290$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H11a2 2 0 01-2-2V19a2 2 0 012-2h3v2H11v3h3zM21 15V13H19a2 2 0 00-2 2v2H16v2h1v5h2V19h2V17H19V15z"
    })), children);
  });
  var CloudFoundry_124 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_124(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$o || (_path291$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), _path292$o || (_path292$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H11a2 2 0 01-2-2V19a2 2 0 012-2h3v2H11v3h3zM21 15V13H19a2 2 0 00-2 2v2H16v2h1v5h2V19h2V17H19V15z"
    })), children);
  });
  var CloudFoundry_120 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_120(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$o || (_path293$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), _path294$o || (_path294$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H11a2 2 0 01-2-2V19a2 2 0 012-2h3v2H11v3h3zM21 15V13H19a2 2 0 00-2 2v2H16v2h1v5h2V19h2V17H19V15z"
    })), children);
  });
  var CloudFoundry_116 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_116(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$o || (_path295$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"
    })), _path296$o || (_path296$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H11a2 2 0 01-2-2V19a2 2 0 012-2h3v2H11v3h3zM21 15V13H19a2 2 0 00-2 2v2H16v2h1v5h2V19h2V17H19V15z"
    })), children);
  });
  var CloudFoundry_232 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_232(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$o || (_path297$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var CloudFoundry_224 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_224(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$o || (_path298$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var CloudFoundry_220 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_220(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$o || (_path299$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var CloudFoundry_216 = /*#__PURE__*/React__default['default'].forwardRef(function CloudFoundry_216(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$o || (_path300$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var CloudRegistry32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRegistry32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$o || (_path301$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H23a2.0023 2.0023 0 01-2-2V23a2.0023 2.0023 0 012-2h5a2.0023 2.0023 0 012 2v5A2.0023 2.0023 0 0128 30zm-5-7h-.0012L23 28h5V23zM16 23H11a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v5H21V11H11V21h5z"
    })), _path302$o || (_path302$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V16H28V4H4V28H16Z"
    })), children);
  });
  var CloudRegistry24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRegistry24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$o || (_path303$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H23a2.0023 2.0023 0 01-2-2V23a2.0023 2.0023 0 012-2h5a2.0023 2.0023 0 012 2v5A2.0023 2.0023 0 0128 30zm-5-7h-.0012L23 28h5V23zM16 23H11a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v5H21V11H11V21h5z"
    })), _path304$o || (_path304$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V16H28V4H4V28H16Z"
    })), children);
  });
  var CloudRegistry20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRegistry20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$o || (_path305$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H23a2.0023 2.0023 0 01-2-2V23a2.0023 2.0023 0 012-2h5a2.0023 2.0023 0 012 2v5A2.0023 2.0023 0 0128 30zm-5-7h-.0012L23 28h5V23zM16 23H11a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v5H21V11H11V21h5z"
    })), _path306$o || (_path306$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V16H28V4H4V28H16Z"
    })), children);
  });
  var CloudRegistry16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudRegistry16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$o || (_path307$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H23a2.0023 2.0023 0 01-2-2V23a2.0023 2.0023 0 012-2h5a2.0023 2.0023 0 012 2v5A2.0023 2.0023 0 0128 30zm-5-7h-.0012L23 28h5V23zM16 23H11a2.0023 2.0023 0 01-2-2V11a2.0023 2.0023 0 012-2H21a2.0023 2.0023 0 012 2v5H21V11H11V21h5z"
    })), _path308$o || (_path308$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V16H28V4H4V28H16Z"
    })), children);
  });
  var CloudSatellite32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatellite32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$l || (_circle14$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "2"
    })), _path309$o || (_path309$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,16,14Z"
    })), _circle15$l || (_circle15$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path310$o || (_path310$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var CloudSatellite24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatellite24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$l || (_circle16$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "2"
    })), _path311$o || (_path311$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,16,14Z"
    })), _circle17$k || (_circle17$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path312$o || (_path312$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var CloudSatellite20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatellite20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle18$k || (_circle18$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "2"
    })), _path313$o || (_path313$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,16,14Z"
    })), _circle19$k || (_circle19$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path314$o || (_path314$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var CloudSatellite16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatellite16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle20$k || (_circle20$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "2"
    })), _path315$o || (_path315$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,16,14Z"
    })), _circle21$j || (_circle21$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path316$o || (_path316$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var CloudSatelliteConfig32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteConfig32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$o || (_path317$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,26V24H29.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,26,20.1011V18H24v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,20.1011,24H18v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,24,29.8989V32h2V29.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,29.8989,26Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,28Z"
    })), _circle22$j || (_circle22$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path318$o || (_path318$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle23$i || (_circle23$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path319$o || (_path319$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteConfig24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteConfig24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$o || (_path320$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,26V24H29.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,26,20.1011V18H24v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,20.1011,24H18v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,24,29.8989V32h2V29.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,29.8989,26Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,28Z"
    })), _circle24$i || (_circle24$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path321$o || (_path321$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle25$h || (_circle25$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path322$o || (_path322$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteConfig20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteConfig20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$o || (_path323$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,26V24H29.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,26,20.1011V18H24v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,20.1011,24H18v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,24,29.8989V32h2V29.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,29.8989,26Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,28Z"
    })), _circle26$h || (_circle26$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path324$o || (_path324$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle27$g || (_circle27$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path325$o || (_path325$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteConfig16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteConfig16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$o || (_path326$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,26V24H29.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,26,20.1011V18H24v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,20.1011,24H18v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,24,29.8989V32h2V29.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,29.8989,26Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,28Z"
    })), _circle28$g || (_circle28$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path327$o || (_path327$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle29$f || (_circle29$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path328$o || (_path328$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteLink32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteLink32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$o || (_path329$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.9763,24.9748l-5.0015,5.0015a3.501,3.501,0,0,1-4.9511-4.9511L22.4383,26.44A1.5,1.5,0,0,0,24.56,28.5617L29.5617,23.56A1.5,1.5,0,0,0,27.44,21.4383l-1.4146-1.4146a3.501,3.501,0,0,1,4.9511,4.9511Z"
    })), _path330$o || (_path330$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0252,21.0237l-5.0015,5.0015a3.501,3.501,0,0,0,4.9511,4.9511L18.56,29.5617A1.5,1.5,0,0,1,16.4383,27.44L21.44,22.4383A1.5,1.5,0,0,1,23.5617,24.56l1.4146,1.4146a3.501,3.501,0,0,0-4.9511-4.9511Z"
    })), _circle30$f || (_circle30$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path331$o || (_path331$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle31$f || (_circle31$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path332$o || (_path332$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.3076,27.2725,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L10.3,29Z"
    })), children);
  });
  var CloudSatelliteLink24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteLink24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$o || (_path333$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.9763,24.9748l-5.0015,5.0015a3.501,3.501,0,0,1-4.9511-4.9511L22.4383,26.44A1.5,1.5,0,0,0,24.56,28.5617L29.5617,23.56A1.5,1.5,0,0,0,27.44,21.4383l-1.4146-1.4146a3.501,3.501,0,0,1,4.9511,4.9511Z"
    })), _path334$o || (_path334$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0252,21.0237l-5.0015,5.0015a3.501,3.501,0,0,0,4.9511,4.9511L18.56,29.5617A1.5,1.5,0,0,1,16.4383,27.44L21.44,22.4383A1.5,1.5,0,0,1,23.5617,24.56l1.4146,1.4146a3.501,3.501,0,0,0-4.9511-4.9511Z"
    })), _circle32$f || (_circle32$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path335$o || (_path335$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle33$e || (_circle33$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path336$o || (_path336$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.3076,27.2725,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L10.3,29Z"
    })), children);
  });
  var CloudSatelliteLink20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteLink20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$o || (_path337$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.9763,24.9748l-5.0015,5.0015a3.501,3.501,0,0,1-4.9511-4.9511L22.4383,26.44A1.5,1.5,0,0,0,24.56,28.5617L29.5617,23.56A1.5,1.5,0,0,0,27.44,21.4383l-1.4146-1.4146a3.501,3.501,0,0,1,4.9511,4.9511Z"
    })), _path338$n || (_path338$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0252,21.0237l-5.0015,5.0015a3.501,3.501,0,0,0,4.9511,4.9511L18.56,29.5617A1.5,1.5,0,0,1,16.4383,27.44L21.44,22.4383A1.5,1.5,0,0,1,23.5617,24.56l1.4146,1.4146a3.501,3.501,0,0,0-4.9511-4.9511Z"
    })), _circle34$d || (_circle34$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path339$n || (_path339$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle35$d || (_circle35$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path340$n || (_path340$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.3076,27.2725,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L10.3,29Z"
    })), children);
  });
  var CloudSatelliteLink16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteLink16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$n || (_path341$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.9763,24.9748l-5.0015,5.0015a3.501,3.501,0,0,1-4.9511-4.9511L22.4383,26.44A1.5,1.5,0,0,0,24.56,28.5617L29.5617,23.56A1.5,1.5,0,0,0,27.44,21.4383l-1.4146-1.4146a3.501,3.501,0,0,1,4.9511,4.9511Z"
    })), _path342$n || (_path342$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0252,21.0237l-5.0015,5.0015a3.501,3.501,0,0,0,4.9511,4.9511L18.56,29.5617A1.5,1.5,0,0,1,16.4383,27.44L21.44,22.4383A1.5,1.5,0,0,1,23.5617,24.56l1.4146,1.4146a3.501,3.501,0,0,0-4.9511-4.9511Z"
    })), _circle36$d || (_circle36$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path343$n || (_path343$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle37$b || (_circle37$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path344$n || (_path344$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.3076,27.2725,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L10.3,29Z"
    })), children);
  });
  var CloudSatelliteServices32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteServices32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$n || (_path345$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26a2.97,2.97,0,0,0-1.8551.6607L25,25.4224V23.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,19,26a3.02,3.02,0,1,0,2.9254,2.3525L24,27.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,29,26ZM19,30a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,19,30Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,24,20Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,29,30Z"
    })), _circle38$b || (_circle38$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path346$n || (_path346$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle39$b || (_circle39$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path347$n || (_path347$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteServices24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteServices24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$n || (_path348$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26a2.97,2.97,0,0,0-1.8551.6607L25,25.4224V23.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,19,26a3.02,3.02,0,1,0,2.9254,2.3525L24,27.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,29,26ZM19,30a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,19,30Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,24,20Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,29,30Z"
    })), _circle40$b || (_circle40$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path349$n || (_path349$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle41$a || (_circle41$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path350$n || (_path350$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteServices20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteServices20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$n || (_path351$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26a2.97,2.97,0,0,0-1.8551.6607L25,25.4224V23.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,19,26a3.02,3.02,0,1,0,2.9254,2.3525L24,27.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,29,26ZM19,30a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,19,30Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,24,20Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,29,30Z"
    })), _circle42$a || (_circle42$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path352$n || (_path352$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle43$a || (_circle43$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path353$n || (_path353$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudSatelliteServices16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudSatelliteServices16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$n || (_path354$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,26a2.97,2.97,0,0,0-1.8551.6607L25,25.4224V23.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,19,26a3.02,3.02,0,1,0,2.9254,2.3525L24,27.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,29,26ZM19,30a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,19,30Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,24,20Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,29,30Z"
    })), _circle44$a || (_circle44$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "2"
    })), _path355$m || (_path355$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,14,20Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,14,14Z"
    })), _circle45$9 || (_circle45$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "12",
      r: "2"
    })), _path356$m || (_path356$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.0205,28.2715,3,22.4258V9.5742L14,3.1577,25.4961,9.8638l1.0078-1.7276-12-7a1,1,0,0,0-1.0078,0l-12,7A.9994.9994,0,0,0,1,9V23a1.0008,1.0008,0,0,0,.4961.8643L12.0127,30Z"
    })), children);
  });
  var CloudServices32 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServices32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$m || (_path357$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9991,9.9991,0,0,0-19.6435,0A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.3769-10.9795l.8364-.0571.09-.8335a7.9979,7.9979,0,0,1,15.9013,0l.09.8335.8364.0571A5.4961,5.4961,0,0,1,24.5,23H24v2h.5a7.4964,7.4964,0,0,0,1.3218-14.876Z"
    })), _path358$m || (_path358$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22V20H20.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,17,16.1011V14H15v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,11.1011,20H9v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,15,25.8989V28h2V25.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,20.8989,22Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,16,24Z"
    })), children);
  });
  var CloudServices24 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServices24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$m || (_path359$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9991,9.9991,0,0,0-19.6435,0A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.3769-10.9795l.8364-.0571.09-.8335a7.9979,7.9979,0,0,1,15.9013,0l.09.8335.8364.0571A5.4961,5.4961,0,0,1,24.5,23H24v2h.5a7.4964,7.4964,0,0,0,1.3218-14.876Z"
    })), _path360$m || (_path360$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22V20H20.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,17,16.1011V14H15v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,11.1011,20H9v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,15,25.8989V28h2V25.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,20.8989,22Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,16,24Z"
    })), children);
  });
  var CloudServices20 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServices20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$l || (_path361$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9991,9.9991,0,0,0-19.6435,0A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.3769-10.9795l.8364-.0571.09-.8335a7.9979,7.9979,0,0,1,15.9013,0l.09.8335.8364.0571A5.4961,5.4961,0,0,1,24.5,23H24v2h.5a7.4964,7.4964,0,0,0,1.3218-14.876Z"
    })), _path362$l || (_path362$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22V20H20.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,17,16.1011V14H15v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,11.1011,20H9v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,15,25.8989V28h2V25.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,20.8989,22Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,16,24Z"
    })), children);
  });
  var CloudServices16 = /*#__PURE__*/React__default['default'].forwardRef(function CloudServices16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$j || (_path363$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9991,9.9991,0,0,0-19.6435,0A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.3769-10.9795l.8364-.0571.09-.8335a7.9979,7.9979,0,0,1,15.9013,0l.09.8335.8364.0571A5.4961,5.4961,0,0,1,24.5,23H24v2h.5a7.4964,7.4964,0,0,0,1.3218-14.876Z"
    })), _path364$j || (_path364$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22V20H20.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,17,16.1011V14H15v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,11.1011,20H9v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,15,25.8989V28h2V25.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,20.8989,22Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,16,24Z"
    })), children);
  });
  var Cloudy32 = /*#__PURE__*/React__default['default'].forwardRef(function Cloudy32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$j || (_path365$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.0005,15.5005a6.5324,6.5324,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0,6.5321,6.5321,0,0,0-5.2,6.3638,6.4543,6.4543,0,0,0,1.6887,4.35A5.9829,5.9829,0,0,0,8,30H19a5.9764,5.9764,0,0,0,5.6094-8.1016A6.5051,6.5051,0,0,0,30.0005,15.5005ZM19,28H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,19.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,28Zm4.5-8h-.0554a5.9562,5.9562,0,0,0-2.7959-1.7564,7.4952,7.4952,0,0,0-14.2984,0,5.9877,5.9877,0,0,0-1.0315.4073A4.4446,4.4446,0,0,1,4,15.5005a4.5171,4.5171,0,0,1,4.144-4.481l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639a4.4975,4.4975,0,0,1-.3564,8.981Z"
    })), children);
  });
  var Cloudy24 = /*#__PURE__*/React__default['default'].forwardRef(function Cloudy24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$j || (_path366$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.0005,15.5005a6.5324,6.5324,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0,6.5321,6.5321,0,0,0-5.2,6.3638,6.4543,6.4543,0,0,0,1.6887,4.35A5.9829,5.9829,0,0,0,8,30H19a5.9764,5.9764,0,0,0,5.6094-8.1016A6.5051,6.5051,0,0,0,30.0005,15.5005ZM19,28H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,19.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,28Zm4.5-8h-.0554a5.9562,5.9562,0,0,0-2.7959-1.7564,7.4952,7.4952,0,0,0-14.2984,0,5.9877,5.9877,0,0,0-1.0315.4073A4.4446,4.4446,0,0,1,4,15.5005a4.5171,4.5171,0,0,1,4.144-4.481l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639a4.4975,4.4975,0,0,1-.3564,8.981Z"
    })), children);
  });
  var Cloudy20 = /*#__PURE__*/React__default['default'].forwardRef(function Cloudy20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$j || (_path367$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.0005,15.5005a6.5324,6.5324,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0,6.5321,6.5321,0,0,0-5.2,6.3638,6.4543,6.4543,0,0,0,1.6887,4.35A5.9829,5.9829,0,0,0,8,30H19a5.9764,5.9764,0,0,0,5.6094-8.1016A6.5051,6.5051,0,0,0,30.0005,15.5005ZM19,28H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,19.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,28Zm4.5-8h-.0554a5.9562,5.9562,0,0,0-2.7959-1.7564,7.4952,7.4952,0,0,0-14.2984,0,5.9877,5.9877,0,0,0-1.0315.4073A4.4446,4.4446,0,0,1,4,15.5005a4.5171,4.5171,0,0,1,4.144-4.481l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639a4.4975,4.4975,0,0,1-.3564,8.981Z"
    })), children);
  });
  var Cloudy16 = /*#__PURE__*/React__default['default'].forwardRef(function Cloudy16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$j || (_path368$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.0005,15.5005a6.5324,6.5324,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0,6.5321,6.5321,0,0,0-5.2,6.3638,6.4543,6.4543,0,0,0,1.6887,4.35A5.9829,5.9829,0,0,0,8,30H19a5.9764,5.9764,0,0,0,5.6094-8.1016A6.5051,6.5051,0,0,0,30.0005,15.5005ZM19,28H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,19.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,28Zm4.5-8h-.0554a5.9562,5.9562,0,0,0-2.7959-1.7564,7.4952,7.4952,0,0,0-14.2984,0,5.9877,5.9877,0,0,0-1.0315.4073A4.4446,4.4446,0,0,1,4,15.5005a4.5171,4.5171,0,0,1,4.144-4.481l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639a4.4975,4.4975,0,0,1-.3564,8.981Z"
    })), children);
  });
  var WatsonHealthCobbAngle32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCobbAngle32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$j || (_path369$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 17V15a2 2 0 00-2-2H10a2 2 0 00-2 2v2a2 2 0 002 2h8A2 2 0 0020 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0021 23.06l-7.73 2.07a2 2 0 00-1.42 2.44h0l.52 1.93A2 2 0 0014.27 31a3 3 0 00.52-.07l7.73-2.07h0a2 2 0 001.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 00.51.07 2 2 0 001.94-1.48L24 5.58a2 2 0 00-1.41-2.45L14.79 1.06a2 2 0 00-2.45 1.41h0l-.52 1.93a2 2 0 001.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"
    })), children);
  });
  var WatsonHealthCobbAngle24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCobbAngle24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$j || (_path370$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 17V15a2 2 0 00-2-2H10a2 2 0 00-2 2v2a2 2 0 002 2h8A2 2 0 0020 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0021 23.06l-7.73 2.07a2 2 0 00-1.42 2.44h0l.52 1.93A2 2 0 0014.27 31a3 3 0 00.52-.07l7.73-2.07h0a2 2 0 001.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 00.51.07 2 2 0 001.94-1.48L24 5.58a2 2 0 00-1.41-2.45L14.79 1.06a2 2 0 00-2.45 1.41h0l-.52 1.93a2 2 0 001.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"
    })), children);
  });
  var WatsonHealthCobbAngle20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCobbAngle20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$j || (_path371$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 17V15a2 2 0 00-2-2H10a2 2 0 00-2 2v2a2 2 0 002 2h8A2 2 0 0020 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0021 23.06l-7.73 2.07a2 2 0 00-1.42 2.44h0l.52 1.93A2 2 0 0014.27 31a3 3 0 00.52-.07l7.73-2.07h0a2 2 0 001.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 00.51.07 2 2 0 001.94-1.48L24 5.58a2 2 0 00-1.41-2.45L14.79 1.06a2 2 0 00-2.45 1.41h0l-.52 1.93a2 2 0 001.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"
    })), children);
  });
  var WatsonHealthCobbAngle16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCobbAngle16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$j || (_path372$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 17V15a2 2 0 00-2-2H10a2 2 0 00-2 2v2a2 2 0 002 2h8A2 2 0 0020 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0021 23.06l-7.73 2.07a2 2 0 00-1.42 2.44h0l.52 1.93A2 2 0 0014.27 31a3 3 0 00.52-.07l7.73-2.07h0a2 2 0 001.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 00.51.07 2 2 0 001.94-1.48L24 5.58a2 2 0 00-1.41-2.45L14.79 1.06a2 2 0 00-2.45 1.41h0l-.52 1.93a2 2 0 001.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"
    })), children);
  });
  var Code32 = /*#__PURE__*/React__default['default'].forwardRef(function Code32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$j || (_path373$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"
    })), _path374$j || (_path374$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.91 15H26.080000000000002V17H5.91z",
      transform: "rotate(-75 15.996 16)"
    })), children);
  });
  var Code24 = /*#__PURE__*/React__default['default'].forwardRef(function Code24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$i || (_path375$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"
    })), _path376$i || (_path376$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.91 15H26.080000000000002V17H5.91z",
      transform: "rotate(-75 15.996 16)"
    })), children);
  });
  var Code20 = /*#__PURE__*/React__default['default'].forwardRef(function Code20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$i || (_path377$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"
    })), _path378$i || (_path378$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.91 15H26.080000000000002V17H5.91z",
      transform: "rotate(-75 15.996 16)"
    })), children);
  });
  var Code16 = /*#__PURE__*/React__default['default'].forwardRef(function Code16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$i || (_path379$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"
    })), _path380$i || (_path380$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.91 15H26.080000000000002V17H5.91z",
      transform: "rotate(-75 15.996 16)"
    })), children);
  });
  var CodeHide32 = /*#__PURE__*/React__default['default'].forwardRef(function CodeHide32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$i || (_path381$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.713 13.471L19.576 6.518 17.645 6 16.08 11.838 17.713 13.471zM24.207 19.965L25.621 21.379 31 16 24 9 22.586 10.414 28.172 16 24.207 19.965zM30 28.586L3.414 2 2 3.414 7.793 9.207 1 16 8 23 9.414 21.586 3.828 16 9.207 10.621 14.884 16.298 12.423 25.482 14.355 26 16.517 17.931 28.586 30 30 28.586z"
    })), children);
  });
  var CodeHide24 = /*#__PURE__*/React__default['default'].forwardRef(function CodeHide24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$i || (_path382$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.713 13.471L19.576 6.518 17.645 6 16.08 11.838 17.713 13.471zM24.207 19.965L25.621 21.379 31 16 24 9 22.586 10.414 28.172 16 24.207 19.965zM30 28.586L3.414 2 2 3.414 7.793 9.207 1 16 8 23 9.414 21.586 3.828 16 9.207 10.621 14.884 16.298 12.423 25.482 14.355 26 16.517 17.931 28.586 30 30 28.586z"
    })), children);
  });
  var CodeHide20 = /*#__PURE__*/React__default['default'].forwardRef(function CodeHide20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$i || (_path383$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.713 13.471L19.576 6.518 17.645 6 16.08 11.838 17.713 13.471zM24.207 19.965L25.621 21.379 31 16 24 9 22.586 10.414 28.172 16 24.207 19.965zM30 28.586L3.414 2 2 3.414 7.793 9.207 1 16 8 23 9.414 21.586 3.828 16 9.207 10.621 14.884 16.298 12.423 25.482 14.355 26 16.517 17.931 28.586 30 30 28.586z"
    })), children);
  });
  var CodeHide16 = /*#__PURE__*/React__default['default'].forwardRef(function CodeHide16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$h || (_path384$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.713 13.471L19.576 6.518 17.645 6 16.08 11.838 17.713 13.471zM24.207 19.965L25.621 21.379 31 16 24 9 22.586 10.414 28.172 16 24.207 19.965zM30 28.586L3.414 2 2 3.414 7.793 9.207 1 16 8 23 9.414 21.586 3.828 16 9.207 10.621 14.884 16.298 12.423 25.482 14.355 26 16.517 17.931 28.586 30 30 28.586z"
    })), children);
  });
  var CodeReference32 = /*#__PURE__*/React__default['default'].forwardRef(function CodeReference32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$h || (_path385$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 10L24 4 22.586 5.414 27.172 10 22.586 14.586 24 16 30 10z"
    })), _path386$h || (_path386$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.944 9.001H24.974000000000004V11.001H8.944z",
      transform: "rotate(-74.995 16.96 10)"
    })), _path387$h || (_path387$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 10L10 4 11.414 5.414 6.828 10 11.414 14.586 10 16 4 10z"
    })), children);
  });
  var CodeReference24 = /*#__PURE__*/React__default['default'].forwardRef(function CodeReference24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$h || (_path388$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 10L24 4 22.586 5.414 27.172 10 22.586 14.586 24 16 30 10z"
    })), _path389$h || (_path389$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.944 9.001H24.974000000000004V11.001H8.944z",
      transform: "rotate(-74.995 16.96 10)"
    })), _path390$h || (_path390$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 10L10 4 11.414 5.414 6.828 10 11.414 14.586 10 16 4 10z"
    })), children);
  });
  var CodeReference20 = /*#__PURE__*/React__default['default'].forwardRef(function CodeReference20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$h || (_path391$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 10L24 4 22.586 5.414 27.172 10 22.586 14.586 24 16 30 10z"
    })), _path392$h || (_path392$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.944 9.001H24.974000000000004V11.001H8.944z",
      transform: "rotate(-74.995 16.96 10)"
    })), _path393$h || (_path393$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 10L10 4 11.414 5.414 6.828 10 11.414 14.586 10 16 4 10z"
    })), children);
  });
  var CodeReference16 = /*#__PURE__*/React__default['default'].forwardRef(function CodeReference16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$h || (_path394$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 10L24 4 22.586 5.414 27.172 10 22.586 14.586 24 16 30 10z"
    })), _path395$h || (_path395$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.944 9.001H24.974000000000004V11.001H8.944z",
      transform: "rotate(-74.995 16.96 10)"
    })), _path396$h || (_path396$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 10L10 4 11.414 5.414 6.828 10 11.414 14.586 10 16 4 10z"
    })), children);
  });
  var CodeSigningService32 = /*#__PURE__*/React__default['default'].forwardRef(function CodeSigningService32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle46$9 || (_circle46$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path397$h || (_path397$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141 30H15V25.5857l5.0337-5.0337A4.6069 4.6069 0 0120 20a5 5 0 114.4478 4.9663zM17 28h1.5859l5.2061-5.2063.5395.1238a3.0351 3.0351 0 10-2.249-2.2488l.1236.5393L17 26.4143zM6 8H8V16H6zM2 8H4V16H2zM18 8H20V14H18zM14 16H12a2 2 0 01-2-2V10a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0114 16zm-2-2h2V10H12zM2 18H4V26H2zM14 18H16V22H14zM10 26H8a2 2 0 01-2-2V20a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0110 26zM8 24h2V20H8zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM10 6H8A2 2 0 016 4V2H8V4h2V2h2V4A2 2 0 0110 6z"
    })), children);
  });
  var CodeSigningService24 = /*#__PURE__*/React__default['default'].forwardRef(function CodeSigningService24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle47$9 || (_circle47$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path398$h || (_path398$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141 30H15V25.5857l5.0337-5.0337A4.6069 4.6069 0 0120 20a5 5 0 114.4478 4.9663zM17 28h1.5859l5.2061-5.2063.5395.1238a3.0351 3.0351 0 10-2.249-2.2488l.1236.5393L17 26.4143zM6 8H8V16H6zM2 8H4V16H2zM18 8H20V14H18zM14 16H12a2 2 0 01-2-2V10a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0114 16zm-2-2h2V10H12zM2 18H4V26H2zM14 18H16V22H14zM10 26H8a2 2 0 01-2-2V20a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0110 26zM8 24h2V20H8zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM10 6H8A2 2 0 016 4V2H8V4h2V2h2V4A2 2 0 0110 6z"
    })), children);
  });
  var CodeSigningService20 = /*#__PURE__*/React__default['default'].forwardRef(function CodeSigningService20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle48$9 || (_circle48$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path399$g || (_path399$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141 30H15V25.5857l5.0337-5.0337A4.6069 4.6069 0 0120 20a5 5 0 114.4478 4.9663zM17 28h1.5859l5.2061-5.2063.5395.1238a3.0351 3.0351 0 10-2.249-2.2488l.1236.5393L17 26.4143zM6 8H8V16H6zM2 8H4V16H2zM18 8H20V14H18zM14 16H12a2 2 0 01-2-2V10a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0114 16zm-2-2h2V10H12zM2 18H4V26H2zM14 18H16V22H14zM10 26H8a2 2 0 01-2-2V20a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0110 26zM8 24h2V20H8zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM10 6H8A2 2 0 016 4V2H8V4h2V2h2V4A2 2 0 0110 6z"
    })), children);
  });
  var CodeSigningService16 = /*#__PURE__*/React__default['default'].forwardRef(function CodeSigningService16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle49$8 || (_circle49$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path400$g || (_path400$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141 30H15V25.5857l5.0337-5.0337A4.6069 4.6069 0 0120 20a5 5 0 114.4478 4.9663zM17 28h1.5859l5.2061-5.2063.5395.1238a3.0351 3.0351 0 10-2.249-2.2488l.1236.5393L17 26.4143zM6 8H8V16H6zM2 8H4V16H2zM18 8H20V14H18zM14 16H12a2 2 0 01-2-2V10a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0114 16zm-2-2h2V10H12zM2 18H4V26H2zM14 18H16V22H14zM10 26H8a2 2 0 01-2-2V20a2 2 0 012-2h2a2 2 0 012 2v4A2 2 0 0110 26zM8 24h2V20H8zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM10 6H8A2 2 0 016 4V2H8V4h2V2h2V4A2 2 0 0110 6z"
    })), children);
  });
  var Cognitive32 = /*#__PURE__*/React__default['default'].forwardRef(function Cognitive32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$g || (_path401$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"
    })), children);
  });
  var Cognitive24 = /*#__PURE__*/React__default['default'].forwardRef(function Cognitive24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$g || (_path402$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"
    })), children);
  });
  var Cognitive20 = /*#__PURE__*/React__default['default'].forwardRef(function Cognitive20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$f || (_path403$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"
    })), children);
  });
  var Cognitive16 = /*#__PURE__*/React__default['default'].forwardRef(function Cognitive16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$f || (_path404$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"
    })), children);
  });

  var _path$o, _path2$o, _path3$o, _path4$o, _path5$o, _path6$o, _path7$o, _path8$o, _path9$o, _path10$o, _path11$o, _path12$o, _path13$o, _path14$o, _path15$o, _path16$o, _path17$o, _path18$o, _path19$o, _path20$o, _circle$n, _circle2$n, _circle3$n, _circle4$m, _circle5$l, _path21$o, _circle6$l, _circle7$l, _circle8$l, _circle9$l, _circle10$l, _path22$o, _circle11$k, _circle12$k, _circle13$k, _circle14$k, _circle15$k, _path23$o, _circle16$k, _circle17$j, _circle18$j, _circle19$j, _circle20$j, _path24$o, _path25$o, _path26$o, _path27$o, _path28$o, _path29$o, _path30$o, _path31$o, _path32$o, _path33$o, _path34$o, _path35$o, _path36$o, _path37$o, _path38$o, _path39$o, _path40$o, _path41$o, _path42$o, _path43$o, _path44$o, _path45$o, _path46$o, _path47$o, _path48$o, _path49$o, _path50$o, _path51$o, _path52$o, _path53$o, _path54$o, _path55$o, _path56$o, _path57$o, _path58$o, _path59$o, _path60$o, _path61$o, _path62$o, _circle21$i, _path63$o, _path64$o, _circle22$i, _path65$o, _path66$o, _circle23$h, _path67$o, _path68$o, _circle24$h, _path69$o, _path70$o, _path71$o, _path72$o, _path73$o, _path74$o, _path75$o, _path76$o, _path77$o, _path78$o, _path79$o, _path80$o, _path81$o, _path82$o, _path83$o, _path84$o, _path85$o, _path86$o, _path87$o, _path88$o, _path89$o, _path90$o, _path91$o, _path92$o, _path93$o, _path94$o, _path95$o, _path96$o, _path97$o, _path98$o, _path99$o, _path100$o, _path101$o, _path102$o, _path103$o, _path104$o, _path105$o, _path106$o, _path107$o, _path108$o, _path109$o, _path110$o, _path111$o, _path112$o, _path113$o, _path114$o, _path115$o, _path116$o, _path117$o, _path118$o, _path119$o, _path120$o, _path121$o, _path122$o, _path123$o, _path124$o, _path125$o, _path126$o, _path127$o, _path128$o, _path129$o, _path130$o, _path131$o, _path132$o, _path133$o, _path134$o, _path135$o, _path136$o, _path137$o, _path138$o, _path139$o, _path140$o, _path141$o, _path142$o, _path143$o, _path144$o, _path145$o, _path146$o, _path147$o, _path148$o, _path149$o, _path150$o, _path151$o, _path152$o, _path153$o, _path154$o, _circle25$g, _path155$o, _path156$o, _circle26$g, _path157$o, _path158$o, _circle27$f, _path159$o, _path160$o, _circle28$f, _path161$o, _path162$o, _path163$o, _path164$o, _path165$o, _path166$o, _path167$o, _path168$o, _path169$o, _path170$o, _path171$o, _path172$o, _path173$o, _path174$o, _path175$o, _path176$o, _circle29$e, _circle30$e, _path177$n, _path178$n, _circle31$e, _circle32$e, _path179$n, _path180$n, _circle33$d, _circle34$c, _path181$n, _path182$n, _circle35$c, _circle36$c, _path183$n, _path184$n, _circle37$a, _path185$n, _path186$n, _circle38$a, _path187$n, _path188$n, _circle39$a, _path189$n, _path190$n, _circle40$a, _path191$n, _path192$n, _path193$n, _path194$n, _path195$n, _path196$n, _path197$n, _path198$n, _path199$n, _path200$n, _path201$n, _path202$n, _path203$n, _path204$n, _path205$n, _path206$n, _path207$n, _path208$n, _path209$n, _path210$n, _path211$n, _path212$n, _path213$n, _path214$n, _path215$n, _path216$n, _path217$n, _path218$n, _path219$n, _path220$n, _path221$n, _path222$n, _path223$n, _path224$n, _path225$n, _path226$n, _path227$n, _path228$n, _path229$n, _path230$n, _path231$n, _path232$n, _path233$n, _path234$n, _path235$n, _path236$n, _path237$n, _path238$n, _path239$n, _path240$n, _path241$n, _path242$n, _path243$n, _path244$n, _path245$n, _path246$n, _path247$n, _path248$n, _path249$n, _path250$n, _path251$n, _path252$n, _path253$n, _path254$n, _path255$n, _path256$n, _path257$n, _path258$n, _path259$n, _path260$n, _circle41$9, _circle42$9, _circle43$9, _circle44$9, _circle45$8, _path261$n, _circle46$8, _circle47$8, _circle48$8, _circle49$7, _circle50$7, _path262$n, _circle51$7, _circle52$7, _circle53$6, _circle54$6, _circle55$5, _path263$n, _circle56$5, _circle57$5, _circle58$5, _circle59$5, _circle60$5, _path264$n, _path265$n, _path266$n, _path267$n, _path268$n, _path269$n, _path270$n, _path271$n, _path272$n, _path273$n, _path274$n, _path275$n, _path276$n, _path277$n, _path278$n, _path279$n, _path280$n, _path281$n, _circle61$5, _circle62$5, _circle63$5, _circle64$5, _circle65$5, _circle66$5, _path282$n, _path283$n, _circle67$5, _circle68$5, _circle69$5, _circle70$5, _circle71$5, _circle72$5, _path284$n, _path285$n, _circle73$4, _circle74$4, _circle75$4, _circle76$4, _circle77$4, _circle78$4, _path286$n, _path287$n, _circle79$4, _circle80$4, _circle81$4, _circle82$4, _circle83$4, _circle84$4, _path288$n, _path289$n, _path290$n, _path291$n, _path292$n, _circle85$3, _circle86$3, _circle87$3, _circle88$3, _path293$n, _circle89$2, _circle90$2, _circle91$2, _circle92$2, _path294$n, _circle93$2, _circle94$2, _circle95$2, _circle96$2, _path295$n, _circle97$2, _circle98$2, _circle99$2, _circle100$2, _path296$n, _path297$n, _path298$n, _path299$n, _path300$n, _path301$n, _path302$n, _path303$n, _path304$n, _path305$n, _path306$n, _path307$n, _path308$n, _path309$n, _path310$n, _path311$n, _path312$n, _path313$n, _path314$n, _path315$n, _path316$n, _path317$n, _path318$n, _path319$n, _path320$n, _path321$n, _path322$n, _path323$n, _path324$n, _path325$n, _path326$n, _path327$n, _path328$n, _path329$n, _path330$n, _path331$n, _path332$n, _path333$n, _path334$n, _path335$n, _path336$n, _path337$n, _path338$m, _path339$m, _path340$m, _path341$m, _path342$m, _path343$m, _path344$m, _path345$m, _path346$m, _path347$m, _path348$m, _path349$m, _path350$m, _path351$m, _path352$m, _path353$m, _path354$m, _path355$l, _path356$l, _path357$l, _path358$l, _path359$l, _path360$l, _path361$k, _path362$k;

  var _excluded$o = ["children"],
      _excluded2$o = ["children"],
      _excluded3$o = ["children"],
      _excluded4$o = ["children"],
      _excluded5$o = ["children"],
      _excluded6$o = ["children"],
      _excluded7$o = ["children"],
      _excluded8$o = ["children"],
      _excluded9$o = ["children"],
      _excluded10$o = ["children"],
      _excluded11$o = ["children"],
      _excluded12$o = ["children"],
      _excluded13$o = ["children"],
      _excluded14$o = ["children"],
      _excluded15$o = ["children"],
      _excluded16$o = ["children"],
      _excluded17$o = ["children"],
      _excluded18$o = ["children"],
      _excluded19$o = ["children"],
      _excluded20$o = ["children"],
      _excluded21$o = ["children"],
      _excluded22$o = ["children"],
      _excluded23$o = ["children"],
      _excluded24$o = ["children"],
      _excluded25$o = ["children"],
      _excluded26$o = ["children"],
      _excluded27$o = ["children"],
      _excluded28$o = ["children"],
      _excluded29$o = ["children"],
      _excluded30$o = ["children"],
      _excluded31$o = ["children"],
      _excluded32$o = ["children"],
      _excluded33$o = ["children"],
      _excluded34$o = ["children"],
      _excluded35$o = ["children"],
      _excluded36$o = ["children"],
      _excluded37$o = ["children"],
      _excluded38$o = ["children"],
      _excluded39$o = ["children"],
      _excluded40$o = ["children"],
      _excluded41$o = ["children"],
      _excluded42$o = ["children"],
      _excluded43$o = ["children"],
      _excluded44$o = ["children"],
      _excluded45$o = ["children"],
      _excluded46$o = ["children"],
      _excluded47$o = ["children"],
      _excluded48$o = ["children"],
      _excluded49$o = ["children"],
      _excluded50$o = ["children"],
      _excluded51$o = ["children"],
      _excluded52$o = ["children"],
      _excluded53$o = ["children"],
      _excluded54$o = ["children"],
      _excluded55$o = ["children"],
      _excluded56$o = ["children"],
      _excluded57$o = ["children"],
      _excluded58$o = ["children"],
      _excluded59$o = ["children"],
      _excluded60$o = ["children"],
      _excluded61$o = ["children"],
      _excluded62$o = ["children"],
      _excluded63$o = ["children"],
      _excluded64$o = ["children"],
      _excluded65$o = ["children"],
      _excluded66$o = ["children"],
      _excluded67$o = ["children"],
      _excluded68$o = ["children"],
      _excluded69$o = ["children"],
      _excluded70$o = ["children"],
      _excluded71$o = ["children"],
      _excluded72$o = ["children"],
      _excluded73$o = ["children"],
      _excluded74$o = ["children"],
      _excluded75$o = ["children"],
      _excluded76$o = ["children"],
      _excluded77$o = ["children"],
      _excluded78$o = ["children"],
      _excluded79$o = ["children"],
      _excluded80$o = ["children"],
      _excluded81$o = ["children"],
      _excluded82$o = ["children"],
      _excluded83$o = ["children"],
      _excluded84$o = ["children"],
      _excluded85$o = ["children"],
      _excluded86$o = ["children"],
      _excluded87$o = ["children"],
      _excluded88$o = ["children"],
      _excluded89$o = ["children"],
      _excluded90$o = ["children"],
      _excluded91$o = ["children"],
      _excluded92$o = ["children"],
      _excluded93$o = ["children"],
      _excluded94$o = ["children"],
      _excluded95$o = ["children"],
      _excluded96$o = ["children"],
      _excluded97$o = ["children"],
      _excluded98$o = ["children"],
      _excluded99$o = ["children"],
      _excluded100$o = ["children"],
      _excluded101$o = ["children"],
      _excluded102$o = ["children"],
      _excluded103$o = ["children"],
      _excluded104$o = ["children"],
      _excluded105$o = ["children"],
      _excluded106$o = ["children"],
      _excluded107$o = ["children"],
      _excluded108$o = ["children"],
      _excluded109$o = ["children"],
      _excluded110$o = ["children"],
      _excluded111$o = ["children"],
      _excluded112$o = ["children"],
      _excluded113$o = ["children"],
      _excluded114$o = ["children"],
      _excluded115$o = ["children"],
      _excluded116$o = ["children"],
      _excluded117$o = ["children"],
      _excluded118$o = ["children"],
      _excluded119$n = ["children"],
      _excluded120$n = ["children"],
      _excluded121$n = ["children"],
      _excluded122$n = ["children"],
      _excluded123$n = ["children"],
      _excluded124$n = ["children"],
      _excluded125$n = ["children"],
      _excluded126$n = ["children"],
      _excluded127$n = ["children"],
      _excluded128$n = ["children"],
      _excluded129$n = ["children"],
      _excluded130$n = ["children"],
      _excluded131$n = ["children"],
      _excluded132$n = ["children"],
      _excluded133$n = ["children"],
      _excluded134$n = ["children"],
      _excluded135$n = ["children"],
      _excluded136$n = ["children"],
      _excluded137$n = ["children"],
      _excluded138$n = ["children"],
      _excluded139$n = ["children"],
      _excluded140$n = ["children"],
      _excluded141$n = ["children"],
      _excluded142$n = ["children"],
      _excluded143$n = ["children"],
      _excluded144$n = ["children"],
      _excluded145$n = ["children"],
      _excluded146$n = ["children"],
      _excluded147$n = ["children"],
      _excluded148$n = ["children"],
      _excluded149$n = ["children"],
      _excluded150$n = ["children"],
      _excluded151$n = ["children"],
      _excluded152$n = ["children"],
      _excluded153$n = ["children"],
      _excluded154$n = ["children"],
      _excluded155$n = ["children"],
      _excluded156$n = ["children"],
      _excluded157$n = ["children"],
      _excluded158$n = ["children"],
      _excluded159$n = ["children"],
      _excluded160$n = ["children"],
      _excluded161$n = ["children"],
      _excluded162$n = ["children"],
      _excluded163$n = ["children"],
      _excluded164$n = ["children"],
      _excluded165$n = ["children"],
      _excluded166$n = ["children"],
      _excluded167$n = ["children"],
      _excluded168$n = ["children"],
      _excluded169$n = ["children"],
      _excluded170$n = ["children"],
      _excluded171$n = ["children"],
      _excluded172$n = ["children"],
      _excluded173$n = ["children"],
      _excluded174$n = ["children"],
      _excluded175$n = ["children"],
      _excluded176$n = ["children"],
      _excluded177$n = ["children"],
      _excluded178$n = ["children"],
      _excluded179$n = ["children"],
      _excluded180$n = ["children"],
      _excluded181$n = ["children"],
      _excluded182$n = ["children"],
      _excluded183$n = ["children"],
      _excluded184$n = ["children"],
      _excluded185$n = ["children"],
      _excluded186$n = ["children"],
      _excluded187$n = ["children"],
      _excluded188$n = ["children"],
      _excluded189$n = ["children"],
      _excluded190$n = ["children"],
      _excluded191$n = ["children"],
      _excluded192$n = ["children"],
      _excluded193$n = ["children"],
      _excluded194$n = ["children"],
      _excluded195$n = ["children"],
      _excluded196$n = ["children"],
      _excluded197$n = ["children"],
      _excluded198$n = ["children"],
      _excluded199$n = ["children"],
      _excluded200$n = ["children"],
      _excluded201$n = ["children"],
      _excluded202$n = ["children"],
      _excluded203$n = ["children"],
      _excluded204$n = ["children"],
      _excluded205$n = ["children"],
      _excluded206$n = ["children"],
      _excluded207$n = ["children"],
      _excluded208$n = ["children"],
      _excluded209$n = ["children"],
      _excluded210$n = ["children"],
      _excluded211$n = ["children"],
      _excluded212$n = ["children"],
      _excluded213$n = ["children"],
      _excluded214$n = ["children"],
      _excluded215$n = ["children"],
      _excluded216$n = ["children"],
      _excluded217$n = ["children"],
      _excluded218$n = ["children"],
      _excluded219$n = ["children"],
      _excluded220$n = ["children"],
      _excluded221$n = ["children"],
      _excluded222$n = ["children"],
      _excluded223$n = ["children"],
      _excluded224$n = ["children"],
      _excluded225$n = ["children"],
      _excluded226$n = ["children"],
      _excluded227$n = ["children"],
      _excluded228$n = ["children"],
      _excluded229$n = ["children"],
      _excluded230$n = ["children"],
      _excluded231$n = ["children"],
      _excluded232$n = ["children"],
      _excluded233$n = ["children"],
      _excluded234$n = ["children"],
      _excluded235$n = ["children"],
      _excluded236$n = ["children"],
      _excluded237$n = ["children"],
      _excluded238$n = ["children"],
      _excluded239$n = ["children"],
      _excluded240$n = ["children"],
      _excluded241$n = ["children"],
      _excluded242$n = ["children"],
      _excluded243$n = ["children"],
      _excluded244$n = ["children"],
      _excluded245$n = ["children"],
      _excluded246$n = ["children"],
      _excluded247$n = ["children"],
      _excluded248$n = ["children"],
      _excluded249$n = ["children"],
      _excluded250$n = ["children"];
  var Collaborate32 = /*#__PURE__*/React__default['default'].forwardRef(function Collaborate32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$o || (_path$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM24 11v1h2V11a7 7 0 00-7-7H16V6h3A5 5 0 0124 11zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20z"
    })), children);
  });
  var Collaborate24 = /*#__PURE__*/React__default['default'].forwardRef(function Collaborate24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$o || (_path2$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM24 11v1h2V11a7 7 0 00-7-7H16V6h3A5 5 0 0124 11zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20z"
    })), children);
  });
  var Collaborate20 = /*#__PURE__*/React__default['default'].forwardRef(function Collaborate20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$o || (_path3$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM24 11v1h2V11a7 7 0 00-7-7H16V6h3A5 5 0 0124 11zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20z"
    })), children);
  });
  var Collaborate16 = /*#__PURE__*/React__default['default'].forwardRef(function Collaborate16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$o || (_path4$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM24 11v1h2V11a7 7 0 00-7-7H16V6h3A5 5 0 0124 11zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20z"
    })), children);
  });
  var CollapseAll32 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseAll32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$o || (_path5$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path6$o || (_path6$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path7$o || (_path7$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"
    })), children);
  });
  var CollapseAll24 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseAll24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$o || (_path8$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path9$o || (_path9$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path10$o || (_path10$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"
    })), children);
  });
  var CollapseAll20 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseAll20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$o || (_path11$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path12$o || (_path12$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path13$o || (_path13$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"
    })), children);
  });
  var CollapseAll16 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseAll16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$o || (_path14$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path15$o || (_path15$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path16$o || (_path16$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"
    })), children);
  });
  var CollapseCategories32 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseCategories32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$o || (_path17$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"
    })), children);
  });
  var CollapseCategories24 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseCategories24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$o || (_path18$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"
    })), children);
  });
  var CollapseCategories20 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseCategories20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$o || (_path19$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"
    })), children);
  });
  var CollapseCategories16 = /*#__PURE__*/React__default['default'].forwardRef(function CollapseCategories16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$o || (_path20$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"
    })), children);
  });
  var ColorPalette32 = /*#__PURE__*/React__default['default'].forwardRef(function ColorPalette32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$n || (_circle$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "12",
      r: "2"
    })), _circle2$n || (_circle2$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _circle3$n || (_circle3$n = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "2"
    })), _circle4$m || (_circle4$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "18",
      r: "2"
    })), _circle5$l || (_circle5$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "23",
      r: "2"
    })), _path21$o || (_path21$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"
    })), children);
  });
  var ColorPalette24 = /*#__PURE__*/React__default['default'].forwardRef(function ColorPalette24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$l || (_circle6$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "12",
      r: "2"
    })), _circle7$l || (_circle7$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _circle8$l || (_circle8$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "2"
    })), _circle9$l || (_circle9$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "18",
      r: "2"
    })), _circle10$l || (_circle10$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "23",
      r: "2"
    })), _path22$o || (_path22$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"
    })), children);
  });
  var ColorPalette20 = /*#__PURE__*/React__default['default'].forwardRef(function ColorPalette20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$k || (_circle11$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "12",
      r: "2"
    })), _circle12$k || (_circle12$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _circle13$k || (_circle13$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "2"
    })), _circle14$k || (_circle14$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "18",
      r: "2"
    })), _circle15$k || (_circle15$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "23",
      r: "2"
    })), _path23$o || (_path23$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"
    })), children);
  });
  var ColorPalette16 = /*#__PURE__*/React__default['default'].forwardRef(function ColorPalette16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$k || (_circle16$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "12",
      r: "2"
    })), _circle17$j || (_circle17$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _circle18$j || (_circle18$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "2"
    })), _circle19$j || (_circle19$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "18",
      r: "2"
    })), _circle20$j || (_circle20$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "23",
      r: "2"
    })), _path24$o || (_path24$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"
    })), children);
  });
  var ColorSwitch32 = /*#__PURE__*/React__default['default'].forwardRef(function ColorSwitch32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$o || (_path25$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"
    })), children);
  });
  var ColorSwitch24 = /*#__PURE__*/React__default['default'].forwardRef(function ColorSwitch24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$o || (_path26$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"
    })), children);
  });
  var ColorSwitch20 = /*#__PURE__*/React__default['default'].forwardRef(function ColorSwitch20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$o || (_path27$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"
    })), children);
  });
  var ColorSwitch16 = /*#__PURE__*/React__default['default'].forwardRef(function ColorSwitch16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$o || (_path28$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"
    })), children);
  });
  var Column32 = /*#__PURE__*/React__default['default'].forwardRef(function Column32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$o || (_path29$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V6a2 2 0 00-2-2zM6 4H8V28H6z"
    })), children);
  });
  var Column24 = /*#__PURE__*/React__default['default'].forwardRef(function Column24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$o || (_path30$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V6a2 2 0 00-2-2zM6 4H8V28H6z"
    })), children);
  });
  var Column20 = /*#__PURE__*/React__default['default'].forwardRef(function Column20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$o || (_path31$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V6a2 2 0 00-2-2zM6 4H8V28H6z"
    })), children);
  });
  var Column16 = /*#__PURE__*/React__default['default'].forwardRef(function Column16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$o || (_path32$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V6a2 2 0 00-2-2zM6 4H8V28H6z"
    })), children);
  });
  var ColumnDelete32 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDelete32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$o || (_path33$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path34$o || (_path34$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14V28H18V6H16V28a2.0023 2.0023 0 002 2h6a2.0023 2.0023 0 002-2V14zM10 30H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 8V28h6V8z"
    })), children);
  });
  var ColumnDelete24 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDelete24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$o || (_path35$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path36$o || (_path36$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14V28H18V6H16V28a2.0023 2.0023 0 002 2h6a2.0023 2.0023 0 002-2V14zM10 30H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 8V28h6V8z"
    })), children);
  });
  var ColumnDelete20 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDelete20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$o || (_path37$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path38$o || (_path38$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14V28H18V6H16V28a2.0023 2.0023 0 002 2h6a2.0023 2.0023 0 002-2V14zM10 30H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 8V28h6V8z"
    })), children);
  });
  var ColumnDelete16 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDelete16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$o || (_path39$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path40$o || (_path40$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14V28H18V6H16V28a2.0023 2.0023 0 002 2h6a2.0023 2.0023 0 002-2V14zM10 30H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 8V28h6V8z"
    })), children);
  });
  var ColumnInsert32 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnInsert32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$o || (_path41$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM22 10V28h6V10zM16 9L21.586 3.414 20.172 2 16 6.172 11.828 2 10.414 3.414 16 9zM10 30H4a2.0021 2.0021 0 01-2-2V10A2.0021 2.0021 0 014 8h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 10V28h6V10z"
    })), children);
  });
  var ColumnInsert24 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnInsert24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$o || (_path42$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM22 10V28h6V10zM16 9L21.586 3.414 20.172 2 16 6.172 11.828 2 10.414 3.414 16 9zM10 30H4a2.0021 2.0021 0 01-2-2V10A2.0021 2.0021 0 014 8h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 10V28h6V10z"
    })), children);
  });
  var ColumnInsert20 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnInsert20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$o || (_path43$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM22 10V28h6V10zM16 9L21.586 3.414 20.172 2 16 6.172 11.828 2 10.414 3.414 16 9zM10 30H4a2.0021 2.0021 0 01-2-2V10A2.0021 2.0021 0 014 8h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 10V28h6V10z"
    })), children);
  });
  var ColumnInsert16 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnInsert16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$o || (_path44$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM22 10V28h6V10zM16 9L21.586 3.414 20.172 2 16 6.172 11.828 2 10.414 3.414 16 9zM10 30H4a2.0021 2.0021 0 01-2-2V10A2.0021 2.0021 0 014 8h6a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0110 30zM4 10V28h6V10z"
    })), children);
  });
  var ColumnDependency32 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDependency32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$o || (_path45$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V2H22V5H17a2.0023,2.0023,0,0,0-2,2v8H10V12H2v8h8V17h5v8a2.0023,2.0023,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3h8V12H22v3H17V7h5v3ZM8,18H4V14H8Zm16,6h4v4H24Zm0-10h4v4H24ZM24,4h4V8H24Z"
    })), children);
  });
  var ColumnDependency24 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDependency24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$o || (_path46$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V2H22V5H17a2.0023,2.0023,0,0,0-2,2v8H10V12H2v8h8V17h5v8a2.0023,2.0023,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3h8V12H22v3H17V7h5v3ZM8,18H4V14H8Zm16,6h4v4H24Zm0-10h4v4H24ZM24,4h4V8H24Z"
    })), children);
  });
  var ColumnDependency20 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDependency20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$o || (_path47$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V2H22V5H17a2.0023,2.0023,0,0,0-2,2v8H10V12H2v8h8V17h5v8a2.0023,2.0023,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3h8V12H22v3H17V7h5v3ZM8,18H4V14H8Zm16,6h4v4H24Zm0-10h4v4H24ZM24,4h4V8H24Z"
    })), children);
  });
  var ColumnDependency16 = /*#__PURE__*/React__default['default'].forwardRef(function ColumnDependency16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$o || (_path48$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V2H22V5H17a2.0023,2.0023,0,0,0-2,2v8H10V12H2v8h8V17h5v8a2.0023,2.0023,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3h8V12H22v3H17V7h5v3ZM8,18H4V14H8Zm16,6h4v4H24Zm0-10h4v4H24ZM24,4h4V8H24Z"
    })), children);
  });
  var Commit32 = /*#__PURE__*/React__default['default'].forwardRef(function Commit32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$o || (_path49$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H21.91A5.9925,5.9925,0,0,0,10.09,15H2v2h8.09A5.9925,5.9925,0,0,0,21.91,17H30ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), children);
  });
  var Commit24 = /*#__PURE__*/React__default['default'].forwardRef(function Commit24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$o || (_path50$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H21.91A5.9925,5.9925,0,0,0,10.09,15H2v2h8.09A5.9925,5.9925,0,0,0,21.91,17H30ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), children);
  });
  var Commit20 = /*#__PURE__*/React__default['default'].forwardRef(function Commit20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$o || (_path51$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H21.91A5.9925,5.9925,0,0,0,10.09,15H2v2h8.09A5.9925,5.9925,0,0,0,21.91,17H30ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), children);
  });
  var Commit16 = /*#__PURE__*/React__default['default'].forwardRef(function Commit16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$o || (_path52$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H21.91A5.9925,5.9925,0,0,0,10.09,15H2v2h8.09A5.9925,5.9925,0,0,0,21.91,17H30ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), children);
  });
  var CommunicationUnified32 = /*#__PURE__*/React__default['default'].forwardRef(function CommunicationUnified32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$o || (_path53$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H18a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h4V25H18V19H28v6H25.4648l-2.5937 3.8906L24.5352 30l2-3H28a2.0025 2.0025 0 002-2V19A2.0025 2.0025 0 0028 17zM8.6667 24.1086l.8614-.8615a.8334.8334 0 01.8988-.1844l1.0493.42A.8334.8334 0 0112 24.2561v1.9082a.8334.8334 0 01-.8786.8341c-7.3546-.4578-8.84-6.6863-9.1158-9.0723A.8316.8316 0 012.8343 17H4.7085a.8335.8335 0 01.7737.5238l.42 1.0493a.8332.8332 0 01-.1845.8988l-.8614.8614A4.5267 4.5267 0 008.6667 24.1086zM21 9H28V11H21zM21 5H30V7H21zM17 6L14 8.2V6a2.0024 2.0024 0 00-2-2H4A2.0024 2.0024 0 002 6v6a2.0024 2.0024 0 002 2h8a2.0024 2.0024 0 002-2V9.8L17 12zM4 12V6h8v6z"
    })), children);
  });
  var CommunicationUnified24 = /*#__PURE__*/React__default['default'].forwardRef(function CommunicationUnified24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$o || (_path54$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H18a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h4V25H18V19H28v6H25.4648l-2.5937 3.8906L24.5352 30l2-3H28a2.0025 2.0025 0 002-2V19A2.0025 2.0025 0 0028 17zM8.6667 24.1086l.8614-.8615a.8334.8334 0 01.8988-.1844l1.0493.42A.8334.8334 0 0112 24.2561v1.9082a.8334.8334 0 01-.8786.8341c-7.3546-.4578-8.84-6.6863-9.1158-9.0723A.8316.8316 0 012.8343 17H4.7085a.8335.8335 0 01.7737.5238l.42 1.0493a.8332.8332 0 01-.1845.8988l-.8614.8614A4.5267 4.5267 0 008.6667 24.1086zM21 9H28V11H21zM21 5H30V7H21zM17 6L14 8.2V6a2.0024 2.0024 0 00-2-2H4A2.0024 2.0024 0 002 6v6a2.0024 2.0024 0 002 2h8a2.0024 2.0024 0 002-2V9.8L17 12zM4 12V6h8v6z"
    })), children);
  });
  var CommunicationUnified20 = /*#__PURE__*/React__default['default'].forwardRef(function CommunicationUnified20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$o || (_path55$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H18a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h4V25H18V19H28v6H25.4648l-2.5937 3.8906L24.5352 30l2-3H28a2.0025 2.0025 0 002-2V19A2.0025 2.0025 0 0028 17zM8.6667 24.1086l.8614-.8615a.8334.8334 0 01.8988-.1844l1.0493.42A.8334.8334 0 0112 24.2561v1.9082a.8334.8334 0 01-.8786.8341c-7.3546-.4578-8.84-6.6863-9.1158-9.0723A.8316.8316 0 012.8343 17H4.7085a.8335.8335 0 01.7737.5238l.42 1.0493a.8332.8332 0 01-.1845.8988l-.8614.8614A4.5267 4.5267 0 008.6667 24.1086zM21 9H28V11H21zM21 5H30V7H21zM17 6L14 8.2V6a2.0024 2.0024 0 00-2-2H4A2.0024 2.0024 0 002 6v6a2.0024 2.0024 0 002 2h8a2.0024 2.0024 0 002-2V9.8L17 12zM4 12V6h8v6z"
    })), children);
  });
  var CommunicationUnified16 = /*#__PURE__*/React__default['default'].forwardRef(function CommunicationUnified16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$o || (_path56$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 17H18a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h4V25H18V19H28v6H25.4648l-2.5937 3.8906L24.5352 30l2-3H28a2.0025 2.0025 0 002-2V19A2.0025 2.0025 0 0028 17zM8.6667 24.1086l.8614-.8615a.8334.8334 0 01.8988-.1844l1.0493.42A.8334.8334 0 0112 24.2561v1.9082a.8334.8334 0 01-.8786.8341c-7.3546-.4578-8.84-6.6863-9.1158-9.0723A.8316.8316 0 012.8343 17H4.7085a.8335.8335 0 01.7737.5238l.42 1.0493a.8332.8332 0 01-.1845.8988l-.8614.8614A4.5267 4.5267 0 008.6667 24.1086zM21 9H28V11H21zM21 5H30V7H21zM17 6L14 8.2V6a2.0024 2.0024 0 00-2-2H4A2.0024 2.0024 0 002 6v6a2.0024 2.0024 0 002 2h8a2.0024 2.0024 0 002-2V9.8L17 12zM4 12V6h8v6z"
    })), children);
  });
  var Compare32 = /*#__PURE__*/React__default['default'].forwardRef(function Compare32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$o || (_path57$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"
    })), children);
  });
  var Compare24 = /*#__PURE__*/React__default['default'].forwardRef(function Compare24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$o || (_path58$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"
    })), children);
  });
  var Compare20 = /*#__PURE__*/React__default['default'].forwardRef(function Compare20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$o || (_path59$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"
    })), children);
  });
  var Compare16 = /*#__PURE__*/React__default['default'].forwardRef(function Compare16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$o || (_path60$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"
    })), children);
  });
  var Compass32 = /*#__PURE__*/React__default['default'].forwardRef(function Compass32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$o || (_path61$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path62$o || (_path62$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"
    })), _circle21$i || (_circle21$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var Compass24 = /*#__PURE__*/React__default['default'].forwardRef(function Compass24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$o || (_path63$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path64$o || (_path64$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"
    })), _circle22$i || (_circle22$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var Compass20 = /*#__PURE__*/React__default['default'].forwardRef(function Compass20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$o || (_path65$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path66$o || (_path66$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"
    })), _circle23$h || (_circle23$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var Compass16 = /*#__PURE__*/React__default['default'].forwardRef(function Compass16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$o || (_path67$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path68$o || (_path68$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"
    })), _circle24$h || (_circle24$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7.5",
      r: "1.5"
    })), children);
  });
  var QComposerEdit32 = /*#__PURE__*/React__default['default'].forwardRef(function QComposerEdit32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$o || (_path69$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"
    })), children);
  });
  var QComposerEdit24 = /*#__PURE__*/React__default['default'].forwardRef(function QComposerEdit24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$o || (_path70$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"
    })), children);
  });
  var QComposerEdit20 = /*#__PURE__*/React__default['default'].forwardRef(function QComposerEdit20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$o || (_path71$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"
    })), children);
  });
  var QComposerEdit16 = /*#__PURE__*/React__default['default'].forwardRef(function QComposerEdit16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$o || (_path72$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"
    })), children);
  });
  var Concept32 = /*#__PURE__*/React__default['default'].forwardRef(function Concept32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$o || (_path73$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"
    })), children);
  });
  var Concept24 = /*#__PURE__*/React__default['default'].forwardRef(function Concept24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$o || (_path74$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"
    })), children);
  });
  var Concept20 = /*#__PURE__*/React__default['default'].forwardRef(function Concept20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$o || (_path75$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"
    })), children);
  });
  var Concept16 = /*#__PURE__*/React__default['default'].forwardRef(function Concept16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$o || (_path76$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"
    })), children);
  });
  var ConditionPoint32 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionPoint32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$o || (_path77$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path78$o || (_path78$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var ConditionPoint24 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionPoint24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$o || (_path79$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path80$o || (_path80$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var ConditionPoint20 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionPoint20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$o || (_path81$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path82$o || (_path82$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var ConditionPoint16 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionPoint16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$o || (_path83$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path84$o || (_path84$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var ConditionWaitPoint32 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionWaitPoint32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$o || (_path85$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path86$o || (_path86$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var ConditionWaitPoint24 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionWaitPoint24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$o || (_path87$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path88$o || (_path88$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var ConditionWaitPoint20 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionWaitPoint20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$o || (_path89$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path90$o || (_path90$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var ConditionWaitPoint16 = /*#__PURE__*/React__default['default'].forwardRef(function ConditionWaitPoint16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$o || (_path91$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.343 10.343H21.657V21.657H10.343z",
      transform: "rotate(-45 16 16)"
    })), _path92$o || (_path92$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var Connect32 = /*#__PURE__*/React__default['default'].forwardRef(function Connect32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$o || (_path93$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",
      transform: "translate(0 .01)"
    })), children);
  });
  var Connect24 = /*#__PURE__*/React__default['default'].forwardRef(function Connect24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$o || (_path94$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",
      transform: "translate(0 .01)"
    })), children);
  });
  var Connect20 = /*#__PURE__*/React__default['default'].forwardRef(function Connect20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$o || (_path95$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",
      transform: "translate(0 .01)"
    })), children);
  });
  var Connect16 = /*#__PURE__*/React__default['default'].forwardRef(function Connect16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$o || (_path96$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",
      transform: "translate(0 .01)"
    })), children);
  });
  var ConnectRecursive32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectRecursive32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$o || (_path97$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H13.8281l3.586-3.5859L16,2,10,8l6,6,1.4141-1.4141L13.8281,9H28V20H11.8989A5.0145,5.0145,0,0,0,8,16.1011V2H6V16.1011a5,5,0,0,0,0,9.7978V30H8V25.8989A5.0145,5.0145,0,0,0,11.8989,22H28a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,28,7ZM7,24a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,24Z"
    })), children);
  });
  var ConnectRecursive24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectRecursive24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$o || (_path98$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H13.8281l3.586-3.5859L16,2,10,8l6,6,1.4141-1.4141L13.8281,9H28V20H11.8989A5.0145,5.0145,0,0,0,8,16.1011V2H6V16.1011a5,5,0,0,0,0,9.7978V30H8V25.8989A5.0145,5.0145,0,0,0,11.8989,22H28a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,28,7ZM7,24a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,24Z"
    })), children);
  });
  var ConnectRecursive20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectRecursive20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$o || (_path99$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H13.8281l3.586-3.5859L16,2,10,8l6,6,1.4141-1.4141L13.8281,9H28V20H11.8989A5.0145,5.0145,0,0,0,8,16.1011V2H6V16.1011a5,5,0,0,0,0,9.7978V30H8V25.8989A5.0145,5.0145,0,0,0,11.8989,22H28a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,28,7ZM7,24a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,24Z"
    })), children);
  });
  var ConnectRecursive16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectRecursive16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$o || (_path100$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H13.8281l3.586-3.5859L16,2,10,8l6,6,1.4141-1.4141L13.8281,9H28V20H11.8989A5.0145,5.0145,0,0,0,8,16.1011V2H6V16.1011a5,5,0,0,0,0,9.7978V30H8V25.8989A5.0145,5.0145,0,0,0,11.8989,22H28a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,28,7ZM7,24a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,24Z"
    })), children);
  });
  var ConnectSource32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectSource32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$o || (_path101$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10l-1.4141,1.4141L26.1719,15H11.8989A5.0145,5.0145,0,0,0,8,11.1011V2H6v9.1011a5,5,0,0,0,0,9.7978V30H8V20.8989A5.0145,5.0145,0,0,0,11.8989,17h14.273l-3.586,3.5859L24,22l6-6ZM7,19a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,19Z"
    })), children);
  });
  var ConnectSource24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectSource24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$o || (_path102$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10l-1.4141,1.4141L26.1719,15H11.8989A5.0145,5.0145,0,0,0,8,11.1011V2H6v9.1011a5,5,0,0,0,0,9.7978V30H8V20.8989A5.0145,5.0145,0,0,0,11.8989,17h14.273l-3.586,3.5859L24,22l6-6ZM7,19a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,19Z"
    })), children);
  });
  var ConnectSource20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectSource20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$o || (_path103$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10l-1.4141,1.4141L26.1719,15H11.8989A5.0145,5.0145,0,0,0,8,11.1011V2H6v9.1011a5,5,0,0,0,0,9.7978V30H8V20.8989A5.0145,5.0145,0,0,0,11.8989,17h14.273l-3.586,3.5859L24,22l6-6ZM7,19a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,19Z"
    })), children);
  });
  var ConnectSource16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectSource16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$o || (_path104$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10l-1.4141,1.4141L26.1719,15H11.8989A5.0145,5.0145,0,0,0,8,11.1011V2H6v9.1011a5,5,0,0,0,0,9.7978V30H8V20.8989A5.0145,5.0145,0,0,0,11.8989,17h14.273l-3.586,3.5859L24,22l6-6ZM7,19a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,7,19Z"
    })), children);
  });
  var ConnectTarget32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectTarget32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$o || (_path105$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM20 10l-1.4141 1.4141L22.1719 15H11.8989a5 5 0 100 2h10.273l-3.586 3.5859L20 22l6-6zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19z"
    })), children);
  });
  var ConnectTarget24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectTarget24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$o || (_path106$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM20 10l-1.4141 1.4141L22.1719 15H11.8989a5 5 0 100 2h10.273l-3.586 3.5859L20 22l6-6zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19z"
    })), children);
  });
  var ConnectTarget20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectTarget20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$o || (_path107$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM20 10l-1.4141 1.4141L22.1719 15H11.8989a5 5 0 100 2h10.273l-3.586 3.5859L20 22l6-6zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19z"
    })), children);
  });
  var ConnectTarget16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectTarget16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$o || (_path108$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM20 10l-1.4141 1.4141L22.1719 15H11.8989a5 5 0 100 2h10.273l-3.586 3.5859L20 22l6-6zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19z"
    })), children);
  });
  var ConnectionReceive32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionReceive32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$o || (_path109$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 14L21.83 14 24.41 16.59 23 18 18 13 23 8 24.41 9.41 21.83 12 30 12 30 14z"
    })), _path110$o || (_path110$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionReceive24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionReceive24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$o || (_path111$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 14L21.83 14 24.41 16.59 23 18 18 13 23 8 24.41 9.41 21.83 12 30 12 30 14z"
    })), _path112$o || (_path112$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionReceive20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionReceive20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$o || (_path113$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 14L21.83 14 24.41 16.59 23 18 18 13 23 8 24.41 9.41 21.83 12 30 12 30 14z"
    })), _path114$o || (_path114$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionReceive16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionReceive16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$o || (_path115$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 14L21.83 14 24.41 16.59 23 18 18 13 23 8 24.41 9.41 21.83 12 30 12 30 14z"
    })), _path116$o || (_path116$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionSend32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSend32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$o || (_path117$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM18 14L26.17 14 23.59 16.59 25 18 30 13 25 8 23.59 9.41 26.17 12 18 12 18 14z"
    })), _path118$o || (_path118$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionSend24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSend24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$o || (_path119$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM18 14L26.17 14 23.59 16.59 25 18 30 13 25 8 23.59 9.41 26.17 12 18 12 18 14z"
    })), _path120$o || (_path120$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionSend20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSend20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$o || (_path121$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM18 14L26.17 14 23.59 16.59 25 18 30 13 25 8 23.59 9.41 26.17 12 18 12 18 14z"
    })), _path122$o || (_path122$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionSend16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSend16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$o || (_path123$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM18 14L26.17 14 23.59 16.59 25 18 30 13 25 8 23.59 9.41 26.17 12 18 12 18 14z"
    })), _path124$o || (_path124$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20v8H22V20H20v8H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V20Z"
    })), children);
  });
  var ConnectionTwoWay32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionTwoWay32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$o || (_path125$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 22L21.83 22 24.41 24.59 23 26 18 21 23 16 24.41 17.41 21.83 20 30 20 30 22zM19 12L27.17 12 24.59 14.59 26 16 31 11 26 6 24.59 7.41 27.17 10 19 10 19 12z"
    })), _path126$o || (_path126$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26v2H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V26Z"
    })), children);
  });
  var ConnectionTwoWay24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionTwoWay24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$o || (_path127$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 22L21.83 22 24.41 24.59 23 26 18 21 23 16 24.41 17.41 21.83 20 30 20 30 22zM19 12L27.17 12 24.59 14.59 26 16 31 11 26 6 24.59 7.41 27.17 10 19 10 19 12z"
    })), _path128$o || (_path128$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26v2H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V26Z"
    })), children);
  });
  var ConnectionTwoWay20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionTwoWay20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$o || (_path129$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 22L21.83 22 24.41 24.59 23 26 18 21 23 16 24.41 17.41 21.83 20 30 20 30 22zM19 12L27.17 12 24.59 14.59 26 16 31 11 26 6 24.59 7.41 27.17 10 19 10 19 12z"
    })), _path130$o || (_path130$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26v2H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V26Z"
    })), children);
  });
  var ConnectionTwoWay16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionTwoWay16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$o || (_path131$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14zM30 22L21.83 22 24.41 24.59 23 26 18 21 23 16 24.41 17.41 21.83 20 30 20 30 22zM19 12L27.17 12 24.59 14.59 26 16 31 11 26 6 24.59 7.41 27.17 10 19 10 19 12z"
    })), _path132$o || (_path132$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26v2H4V4H20V6h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30V26Z"
    })), children);
  });
  var ConnectionSignal32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignal32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$o || (_path133$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V30H15zM11.33 18.22a7 7 0 010-10.44l1.34 1.49a5 5 0 000 7.46zM20.67 18.22l-1.34-1.49a5 5 0 000-7.46l1.34-1.49a7 7 0 010 10.44z"
    })), _path134$o || (_path134$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.4 21.8a11 11 0 010-17.6L9.6 5.8a9 9 0 000 14.4zM23.6 21.8l-1.2-1.6a9 9 0 000-14.4l1.2-1.6a11 11 0 010 17.6z"
    })), children);
  });
  var ConnectionSignal24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignal24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$o || (_path135$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V30H15zM11.33 18.22a7 7 0 010-10.44l1.34 1.49a5 5 0 000 7.46zM20.67 18.22l-1.34-1.49a5 5 0 000-7.46l1.34-1.49a7 7 0 010 10.44z"
    })), _path136$o || (_path136$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.4 21.8a11 11 0 010-17.6L9.6 5.8a9 9 0 000 14.4zM23.6 21.8l-1.2-1.6a9 9 0 000-14.4l1.2-1.6a11 11 0 010 17.6z"
    })), children);
  });
  var ConnectionSignal20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignal20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$o || (_path137$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V30H15zM11.33 18.22a7 7 0 010-10.44l1.34 1.49a5 5 0 000 7.46zM20.67 18.22l-1.34-1.49a5 5 0 000-7.46l1.34-1.49a7 7 0 010 10.44z"
    })), _path138$o || (_path138$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.4 21.8a11 11 0 010-17.6L9.6 5.8a9 9 0 000 14.4zM23.6 21.8l-1.2-1.6a9 9 0 000-14.4l1.2-1.6a11 11 0 010 17.6z"
    })), children);
  });
  var ConnectionSignal16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignal16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$o || (_path139$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 12H17V30H15zM11.33 18.22a7 7 0 010-10.44l1.34 1.49a5 5 0 000 7.46zM20.67 18.22l-1.34-1.49a5 5 0 000-7.46l1.34-1.49a7 7 0 010 10.44z"
    })), _path140$o || (_path140$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.4 21.8a11 11 0 010-17.6L9.6 5.8a9 9 0 000 14.4zM23.6 21.8l-1.2-1.6a9 9 0 000-14.4l1.2-1.6a11 11 0 010 17.6z"
    })), children);
  });
  var ConnectionSignalOff32 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignalOff32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$o || (_path141$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a8.9089,8.9089,0,0,1-2.5249,6.2339l1.4133,1.4131A10.9795,10.9795,0,0,0,23.6006,4.2l-1.2012,1.6A8.932,8.932,0,0,1,26,13Z"
    })), _path142$o || (_path142$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13a5.0022 5.0022 0 01-.9023 2.8564l1.4277 1.4278a6.9831 6.9831 0 00-.8584-9.5015l-1.334 1.49A5.0077 5.0077 0 0121 13zM30 28.5859L3.4143 2 2 3.4141l3.71 3.71A10.9824 10.9824 0 008.3994 21.8008l1.2012-1.6A8.9678 8.9678 0 017.1714 8.5854l2.1963 2.1963a6.9664 6.9664 0 001.9648 7.4351l1.334-1.49A5.0072 5.0072 0 0111 13a4.8854 4.8854 0 01.0393-.5464L15 16.4141V30h2V18.4141L28.5857 30z"
    })), children);
  });
  var ConnectionSignalOff24 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignalOff24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$o || (_path143$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a8.9089,8.9089,0,0,1-2.5249,6.2339l1.4133,1.4131A10.9795,10.9795,0,0,0,23.6006,4.2l-1.2012,1.6A8.932,8.932,0,0,1,26,13Z"
    })), _path144$o || (_path144$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13a5.0022 5.0022 0 01-.9023 2.8564l1.4277 1.4278a6.9831 6.9831 0 00-.8584-9.5015l-1.334 1.49A5.0077 5.0077 0 0121 13zM30 28.5859L3.4143 2 2 3.4141l3.71 3.71A10.9824 10.9824 0 008.3994 21.8008l1.2012-1.6A8.9678 8.9678 0 017.1714 8.5854l2.1963 2.1963a6.9664 6.9664 0 001.9648 7.4351l1.334-1.49A5.0072 5.0072 0 0111 13a4.8854 4.8854 0 01.0393-.5464L15 16.4141V30h2V18.4141L28.5857 30z"
    })), children);
  });
  var ConnectionSignalOff20 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignalOff20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$o || (_path145$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a8.9089,8.9089,0,0,1-2.5249,6.2339l1.4133,1.4131A10.9795,10.9795,0,0,0,23.6006,4.2l-1.2012,1.6A8.932,8.932,0,0,1,26,13Z"
    })), _path146$o || (_path146$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13a5.0022 5.0022 0 01-.9023 2.8564l1.4277 1.4278a6.9831 6.9831 0 00-.8584-9.5015l-1.334 1.49A5.0077 5.0077 0 0121 13zM30 28.5859L3.4143 2 2 3.4141l3.71 3.71A10.9824 10.9824 0 008.3994 21.8008l1.2012-1.6A8.9678 8.9678 0 017.1714 8.5854l2.1963 2.1963a6.9664 6.9664 0 001.9648 7.4351l1.334-1.49A5.0072 5.0072 0 0111 13a4.8854 4.8854 0 01.0393-.5464L15 16.4141V30h2V18.4141L28.5857 30z"
    })), children);
  });
  var ConnectionSignalOff16 = /*#__PURE__*/React__default['default'].forwardRef(function ConnectionSignalOff16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$o || (_path147$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a8.9089,8.9089,0,0,1-2.5249,6.2339l1.4133,1.4131A10.9795,10.9795,0,0,0,23.6006,4.2l-1.2012,1.6A8.932,8.932,0,0,1,26,13Z"
    })), _path148$o || (_path148$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13a5.0022 5.0022 0 01-.9023 2.8564l1.4277 1.4278a6.9831 6.9831 0 00-.8584-9.5015l-1.334 1.49A5.0077 5.0077 0 0121 13zM30 28.5859L3.4143 2 2 3.4141l3.71 3.71A10.9824 10.9824 0 008.3994 21.8008l1.2012-1.6A8.9678 8.9678 0 017.1714 8.5854l2.1963 2.1963a6.9664 6.9664 0 001.9648 7.4351l1.334-1.49A5.0072 5.0072 0 0111 13a4.8854 4.8854 0 01.0393-.5464L15 16.4141V30h2V18.4141L28.5857 30z"
    })), children);
  });
  var Construction32 = /*#__PURE__*/React__default['default'].forwardRef(function Construction32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$o || (_path149$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.34 16.06a1.0007 1.0007 0 00-1.1084.3L24.46 20.8857l-5.4355-.9882-3.602-8.9512A3.014 3.014 0 0012.6138 9h-4.06A3.0018 3.0018 0 007.01 9.4277L2 12.4336v6.4009l5 .9092V30H9V20.1074l3.5652.648L14 24.2V30h2V23.8l-1.0911-2.6182L22.99 22.6509 18.2319 28.36A1 1 0 0019 30H29a1 1 0 001-1V17A1 1 0 0029.34 16.06zM4 17.1655V13.5664l3-1.8v5.9448zm5 .9092V11h3.6138a1.0141 1.0141 0 01.9453.6709l3.14 7.8037zM28 28H21.1353L28 19.7617zM12.5 8A3.5 3.5 0 1116 4.5 3.5042 3.5042 0 0112.5 8zm0-5A1.5 1.5 0 1014 4.5 1.5017 1.5017 0 0012.5 3z"
    })), children);
  });
  var Construction24 = /*#__PURE__*/React__default['default'].forwardRef(function Construction24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$o || (_path150$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.34 16.06a1.0007 1.0007 0 00-1.1084.3L24.46 20.8857l-5.4355-.9882-3.602-8.9512A3.014 3.014 0 0012.6138 9h-4.06A3.0018 3.0018 0 007.01 9.4277L2 12.4336v6.4009l5 .9092V30H9V20.1074l3.5652.648L14 24.2V30h2V23.8l-1.0911-2.6182L22.99 22.6509 18.2319 28.36A1 1 0 0019 30H29a1 1 0 001-1V17A1 1 0 0029.34 16.06zM4 17.1655V13.5664l3-1.8v5.9448zm5 .9092V11h3.6138a1.0141 1.0141 0 01.9453.6709l3.14 7.8037zM28 28H21.1353L28 19.7617zM12.5 8A3.5 3.5 0 1116 4.5 3.5042 3.5042 0 0112.5 8zm0-5A1.5 1.5 0 1014 4.5 1.5017 1.5017 0 0012.5 3z"
    })), children);
  });
  var Construction20 = /*#__PURE__*/React__default['default'].forwardRef(function Construction20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$o || (_path151$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.34 16.06a1.0007 1.0007 0 00-1.1084.3L24.46 20.8857l-5.4355-.9882-3.602-8.9512A3.014 3.014 0 0012.6138 9h-4.06A3.0018 3.0018 0 007.01 9.4277L2 12.4336v6.4009l5 .9092V30H9V20.1074l3.5652.648L14 24.2V30h2V23.8l-1.0911-2.6182L22.99 22.6509 18.2319 28.36A1 1 0 0019 30H29a1 1 0 001-1V17A1 1 0 0029.34 16.06zM4 17.1655V13.5664l3-1.8v5.9448zm5 .9092V11h3.6138a1.0141 1.0141 0 01.9453.6709l3.14 7.8037zM28 28H21.1353L28 19.7617zM12.5 8A3.5 3.5 0 1116 4.5 3.5042 3.5042 0 0112.5 8zm0-5A1.5 1.5 0 1014 4.5 1.5017 1.5017 0 0012.5 3z"
    })), children);
  });
  var Construction16 = /*#__PURE__*/React__default['default'].forwardRef(function Construction16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$o || (_path152$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.34 16.06a1.0007 1.0007 0 00-1.1084.3L24.46 20.8857l-5.4355-.9882-3.602-8.9512A3.014 3.014 0 0012.6138 9h-4.06A3.0018 3.0018 0 007.01 9.4277L2 12.4336v6.4009l5 .9092V30H9V20.1074l3.5652.648L14 24.2V30h2V23.8l-1.0911-2.6182L22.99 22.6509 18.2319 28.36A1 1 0 0019 30H29a1 1 0 001-1V17A1 1 0 0029.34 16.06zM4 17.1655V13.5664l3-1.8v5.9448zm5 .9092V11h3.6138a1.0141 1.0141 0 01.9453.6709l3.14 7.8037zM28 28H21.1353L28 19.7617zM12.5 8A3.5 3.5 0 1116 4.5 3.5042 3.5042 0 0112.5 8zm0-5A1.5 1.5 0 1014 4.5 1.5017 1.5017 0 0012.5 3z"
    })), children);
  });
  var ContainerRegistry32 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerRegistry32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$o || (_path153$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,13V6H8V22H24V13ZM10,8h5v5H10Zm0,7h5v5H10Zm12,5H17V15h5Z"
    })), _path154$o || (_path154$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11H19V2h9zM21 9h5V4H21zM28 20H26v2h2v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle25$g || (_circle25$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ContainerRegistry24 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerRegistry24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$o || (_path155$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,13V6H8V22H24V13ZM10,8h5v5H10Zm0,7h5v5H10Zm12,5H17V15h5Z"
    })), _path156$o || (_path156$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11H19V2h9zM21 9h5V4H21zM28 20H26v2h2v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle26$g || (_circle26$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ContainerRegistry20 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerRegistry20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$o || (_path157$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,13V6H8V22H24V13ZM10,8h5v5H10Zm0,7h5v5H10Zm12,5H17V15h5Z"
    })), _path158$o || (_path158$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11H19V2h9zM21 9h5V4H21zM28 20H26v2h2v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle27$f || (_circle27$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ContainerRegistry16 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerRegistry16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$o || (_path159$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,13V6H8V22H24V13ZM10,8h5v5H10Zm0,7h5v5H10Zm12,5H17V15h5Z"
    })), _path160$o || (_path160$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11H19V2h9zM21 9h5V4H21zM28 20H26v2h2v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle28$f || (_circle28$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ContainerServices32 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerServices32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$o || (_path161$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V17a2.0023,2.0023,0,0,0-2-2H17V10h3a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H12a2.0023,2.0023,0,0,0-2,2V8a2.0023,2.0023,0,0,0,2,2h3v5H7a2.0023,2.0023,0,0,0-2,2v5H2v8h8V22H7V17h8v5H12v8h8V22H17V17h8v5H22v8h8V22ZM12,4h8V8H12ZM8,28H4V24H8Zm10,0H14V24h4Zm10,0H24V24h4Z"
    })), children);
  });
  var ContainerServices24 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerServices24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$o || (_path162$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V17a2.0023,2.0023,0,0,0-2-2H17V10h3a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H12a2.0023,2.0023,0,0,0-2,2V8a2.0023,2.0023,0,0,0,2,2h3v5H7a2.0023,2.0023,0,0,0-2,2v5H2v8h8V22H7V17h8v5H12v8h8V22H17V17h8v5H22v8h8V22ZM12,4h8V8H12ZM8,28H4V24H8Zm10,0H14V24h4Zm10,0H24V24h4Z"
    })), children);
  });
  var ContainerServices20 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerServices20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$o || (_path163$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V17a2.0023,2.0023,0,0,0-2-2H17V10h3a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H12a2.0023,2.0023,0,0,0-2,2V8a2.0023,2.0023,0,0,0,2,2h3v5H7a2.0023,2.0023,0,0,0-2,2v5H2v8h8V22H7V17h8v5H12v8h8V22H17V17h8v5H22v8h8V22ZM12,4h8V8H12ZM8,28H4V24H8Zm10,0H14V24h4Zm10,0H24V24h4Z"
    })), children);
  });
  var ContainerServices16 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerServices16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$o || (_path164$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V17a2.0023,2.0023,0,0,0-2-2H17V10h3a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H12a2.0023,2.0023,0,0,0-2,2V8a2.0023,2.0023,0,0,0,2,2h3v5H7a2.0023,2.0023,0,0,0-2,2v5H2v8h8V22H7V17h8v5H12v8h8V22H17V17h8v5H22v8h8V22ZM12,4h8V8H12ZM8,28H4V24H8Zm10,0H14V24h4Zm10,0H24V24h4Z"
    })), children);
  });
  var ContainerSoftware32 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerSoftware32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$o || (_path165$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H20V4h8Zm-6-2h4V6H22Z"
    })), _path166$o || (_path166$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"
    })), _path167$o || (_path167$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var ContainerSoftware24 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerSoftware24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$o);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$o || (_path168$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H20V4h8Zm-6-2h4V6H22Z"
    })), _path169$o || (_path169$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"
    })), _path170$o || (_path170$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var ContainerSoftware20 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerSoftware20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$o || (_path171$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H20V4h8Zm-6-2h4V6H22Z"
    })), _path172$o || (_path172$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"
    })), _path173$o || (_path173$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var ContainerSoftware16 = /*#__PURE__*/React__default['default'].forwardRef(function ContainerSoftware16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$o || (_path174$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H20V4h8Zm-6-2h4V6H22Z"
    })), _path175$o || (_path175$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"
    })), _path176$o || (_path176$o = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"
    })), children);
  });
  var ContentDeliveryNetwork32 = /*#__PURE__*/React__default['default'].forwardRef(function ContentDeliveryNetwork32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29$e || (_circle29$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle30$e || (_circle30$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "2"
    })), _path177$n || (_path177$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,31a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,27,31Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,27,25Z"
    })), _path178$n || (_path178$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14.0412,14.0412,0,0,0,16,2,13.0426,13.0426,0,0,0,9.2,3.8l1.1,1.7a24.4254,24.4254,0,0,1,2.4-1A25.1349,25.1349,0,0,0,10,15H4a11.1489,11.1489,0,0,1,1.4-4.7L3.9,9A13.8418,13.8418,0,0,0,2,16,13.9983,13.9983,0,0,0,16,30a13.3656,13.3656,0,0,0,5.2-1l-.6-1.9a11.4416,11.4416,0,0,1-5.2.9h0A21.0713,21.0713,0,0,1,12,17H29.9A3.4019,3.4019,0,0,0,30,16ZM12.8,27.6h0a13.02,13.02,0,0,1-5.3-3.1A12.5053,12.5053,0,0,1,4,17h6A25.0022,25.0022,0,0,0,12.8,27.6ZM12,15A21.4461,21.4461,0,0,1,15.3,4h1.4A21.4461,21.4461,0,0,1,20,15Zm10,0A23.2777,23.2777,0,0,0,19.2,4.4,12.0919,12.0919,0,0,1,27.9,15Z"
    })), children);
  });
  var ContentDeliveryNetwork24 = /*#__PURE__*/React__default['default'].forwardRef(function ContentDeliveryNetwork24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle31$e || (_circle31$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle32$e || (_circle32$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "2"
    })), _path179$n || (_path179$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,31a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,27,31Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,27,25Z"
    })), _path180$n || (_path180$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14.0412,14.0412,0,0,0,16,2,13.0426,13.0426,0,0,0,9.2,3.8l1.1,1.7a24.4254,24.4254,0,0,1,2.4-1A25.1349,25.1349,0,0,0,10,15H4a11.1489,11.1489,0,0,1,1.4-4.7L3.9,9A13.8418,13.8418,0,0,0,2,16,13.9983,13.9983,0,0,0,16,30a13.3656,13.3656,0,0,0,5.2-1l-.6-1.9a11.4416,11.4416,0,0,1-5.2.9h0A21.0713,21.0713,0,0,1,12,17H29.9A3.4019,3.4019,0,0,0,30,16ZM12.8,27.6h0a13.02,13.02,0,0,1-5.3-3.1A12.5053,12.5053,0,0,1,4,17h6A25.0022,25.0022,0,0,0,12.8,27.6ZM12,15A21.4461,21.4461,0,0,1,15.3,4h1.4A21.4461,21.4461,0,0,1,20,15Zm10,0A23.2777,23.2777,0,0,0,19.2,4.4,12.0919,12.0919,0,0,1,27.9,15Z"
    })), children);
  });
  var ContentDeliveryNetwork20 = /*#__PURE__*/React__default['default'].forwardRef(function ContentDeliveryNetwork20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle33$d || (_circle33$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle34$c || (_circle34$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "2"
    })), _path181$n || (_path181$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,31a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,27,31Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,27,25Z"
    })), _path182$n || (_path182$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14.0412,14.0412,0,0,0,16,2,13.0426,13.0426,0,0,0,9.2,3.8l1.1,1.7a24.4254,24.4254,0,0,1,2.4-1A25.1349,25.1349,0,0,0,10,15H4a11.1489,11.1489,0,0,1,1.4-4.7L3.9,9A13.8418,13.8418,0,0,0,2,16,13.9983,13.9983,0,0,0,16,30a13.3656,13.3656,0,0,0,5.2-1l-.6-1.9a11.4416,11.4416,0,0,1-5.2.9h0A21.0713,21.0713,0,0,1,12,17H29.9A3.4019,3.4019,0,0,0,30,16ZM12.8,27.6h0a13.02,13.02,0,0,1-5.3-3.1A12.5053,12.5053,0,0,1,4,17h6A25.0022,25.0022,0,0,0,12.8,27.6ZM12,15A21.4461,21.4461,0,0,1,15.3,4h1.4A21.4461,21.4461,0,0,1,20,15Zm10,0A23.2777,23.2777,0,0,0,19.2,4.4,12.0919,12.0919,0,0,1,27.9,15Z"
    })), children);
  });
  var ContentDeliveryNetwork16 = /*#__PURE__*/React__default['default'].forwardRef(function ContentDeliveryNetwork16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle35$c || (_circle35$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle36$c || (_circle36$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "2"
    })), _path183$n || (_path183$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,31a4,4,0,1,1,4-4A4.0118,4.0118,0,0,1,27,31Zm0-6a2,2,0,1,0,2,2A2.0059,2.0059,0,0,0,27,25Z"
    })), _path184$n || (_path184$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14.0412,14.0412,0,0,0,16,2,13.0426,13.0426,0,0,0,9.2,3.8l1.1,1.7a24.4254,24.4254,0,0,1,2.4-1A25.1349,25.1349,0,0,0,10,15H4a11.1489,11.1489,0,0,1,1.4-4.7L3.9,9A13.8418,13.8418,0,0,0,2,16,13.9983,13.9983,0,0,0,16,30a13.3656,13.3656,0,0,0,5.2-1l-.6-1.9a11.4416,11.4416,0,0,1-5.2.9h0A21.0713,21.0713,0,0,1,12,17H29.9A3.4019,3.4019,0,0,0,30,16ZM12.8,27.6h0a13.02,13.02,0,0,1-5.3-3.1A12.5053,12.5053,0,0,1,4,17h6A25.0022,25.0022,0,0,0,12.8,27.6ZM12,15A21.4461,21.4461,0,0,1,15.3,4h1.4A21.4461,21.4461,0,0,1,20,15Zm10,0A23.2777,23.2777,0,0,0,19.2,4.4,12.0919,12.0919,0,0,1,27.9,15Z"
    })), children);
  });
  var ContentView32 = /*#__PURE__*/React__default['default'].forwardRef(function ContentView32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle37$a || (_circle37$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "2"
    })), _path185$n || (_path185$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,18.4785A8.64,8.64,0,0,0,16,13a8.64,8.64,0,0,0-7.7769,5.4785L8,19l.2231.5215A8.64,8.64,0,0,0,16,25a8.64,8.64,0,0,0,7.7769-5.4785L24,19ZM16,23a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,23Z"
    })), _path186$n || (_path186$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM5,5H27V9H5ZM5,27V11H27V27Z"
    })), children);
  });
  var ContentView24 = /*#__PURE__*/React__default['default'].forwardRef(function ContentView24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle38$a || (_circle38$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "2"
    })), _path187$n || (_path187$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,18.4785A8.64,8.64,0,0,0,16,13a8.64,8.64,0,0,0-7.7769,5.4785L8,19l.2231.5215A8.64,8.64,0,0,0,16,25a8.64,8.64,0,0,0,7.7769-5.4785L24,19ZM16,23a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,23Z"
    })), _path188$n || (_path188$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM5,5H27V9H5ZM5,27V11H27V27Z"
    })), children);
  });
  var ContentView20 = /*#__PURE__*/React__default['default'].forwardRef(function ContentView20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle39$a || (_circle39$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "2"
    })), _path189$n || (_path189$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,18.4785A8.64,8.64,0,0,0,16,13a8.64,8.64,0,0,0-7.7769,5.4785L8,19l.2231.5215A8.64,8.64,0,0,0,16,25a8.64,8.64,0,0,0,7.7769-5.4785L24,19ZM16,23a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,23Z"
    })), _path190$n || (_path190$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM5,5H27V9H5ZM5,27V11H27V27Z"
    })), children);
  });
  var ContentView16 = /*#__PURE__*/React__default['default'].forwardRef(function ContentView16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle40$a || (_circle40$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "2"
    })), _path191$n || (_path191$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,18.4785A8.64,8.64,0,0,0,16,13a8.64,8.64,0,0,0-7.7769,5.4785L8,19l.2231.5215A8.64,8.64,0,0,0,16,25a8.64,8.64,0,0,0,7.7769-5.4785L24,19ZM16,23a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,23Z"
    })), _path192$n || (_path192$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM5,5H27V9H5ZM5,27V11H27V27Z"
    })), children);
  });
  var Continue32 = /*#__PURE__*/React__default['default'].forwardRef(function Continue32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$n || (_path193$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM11 6.7344V25.2656L27 16zM4 4H6V28H4z"
    })), children);
  });
  var Continue24 = /*#__PURE__*/React__default['default'].forwardRef(function Continue24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$n || (_path194$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM11 6.7344V25.2656L27 16zM4 4H6V28H4z"
    })), children);
  });
  var Continue20 = /*#__PURE__*/React__default['default'].forwardRef(function Continue20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$n || (_path195$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM11 6.7344V25.2656L27 16zM4 4H6V28H4z"
    })), children);
  });
  var Continue16 = /*#__PURE__*/React__default['default'].forwardRef(function Continue16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$n || (_path196$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM11 6.7344V25.2656L27 16zM4 4H6V28H4z"
    })), children);
  });
  var ContinueFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ContinueFilled32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$n || (_path197$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM4 4H6V28H4z"
    })), children);
  });
  var ContinueFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ContinueFilled24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$n || (_path198$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM4 4H6V28H4z"
    })), children);
  });
  var ContinueFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ContinueFilled20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$n || (_path199$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM4 4H6V28H4z"
    })), children);
  });
  var ContinueFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ContinueFilled16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$n || (_path200$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 0110 28zM4 4H6V28H4z"
    })), children);
  });
  var WatsonHealthContourDraw32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourDraw32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$n || (_path201$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourDraw24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourDraw24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$n || (_path202$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourDraw20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourDraw20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$n || (_path203$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourDraw16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourDraw16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$n || (_path204$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourEdit32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourEdit32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$n || (_path205$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30V28A12.0021 12.0021 0 0019.6924 4.5786l.6152-1.9033A14.0022 14.0022 0 0116 30zM7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7z"
    })), _path206$n || (_path206$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourEdit24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourEdit24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$n || (_path207$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30V28A12.0021 12.0021 0 0019.6924 4.5786l.6152-1.9033A14.0022 14.0022 0 0116 30zM7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7z"
    })), _path208$n || (_path208$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourEdit20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourEdit20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$n || (_path209$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30V28A12.0021 12.0021 0 0019.6924 4.5786l.6152-1.9033A14.0022 14.0022 0 0116 30zM7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7z"
    })), _path210$n || (_path210$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourEdit16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourEdit16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$n || (_path211$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30V28A12.0021 12.0021 0 0019.6924 4.5786l.6152-1.9033A14.0022 14.0022 0 0116 30zM7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7z"
    })), _path212$n || (_path212$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.4023 24.248a11.9488 11.9488 0 00-1.7182-3.3354L15.2974 19.73a13.9486 13.9486 0 012.0044 3.893zM11.02 18.2668a11.9215 11.9215 0 00-3.3467-1.6943l.6114-1.9043a13.9242 13.9242 0 013.9072 1.978z"
    })), children);
  });
  var WatsonHealthContourFinding32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourFinding32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$n || (_path213$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM16 26A10 10 0 1126 16 10.0115 10.0115 0 0116 26zM16 8a8 8 0 108 8A8.0092 8.0092 0 0016 8z"
    })), children);
  });
  var WatsonHealthContourFinding24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourFinding24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$n || (_path214$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM16 26A10 10 0 1126 16 10.0115 10.0115 0 0116 26zM16 8a8 8 0 108 8A8.0092 8.0092 0 0016 8z"
    })), children);
  });
  var WatsonHealthContourFinding20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourFinding20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$n || (_path215$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM16 26A10 10 0 1126 16 10.0115 10.0115 0 0116 26zM16 8a8 8 0 108 8A8.0092 8.0092 0 0016 8z"
    })), children);
  });
  var WatsonHealthContourFinding16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthContourFinding16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$n || (_path216$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3zM16 26A10 10 0 1126 16 10.0115 10.0115 0 0116 26zM16 8a8 8 0 108 8A8.0092 8.0092 0 0016 8z"
    })), children);
  });
  var Contrast32 = /*#__PURE__*/React__default['default'].forwardRef(function Contrast32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$n || (_path217$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"
    })), children);
  });
  var Contrast24 = /*#__PURE__*/React__default['default'].forwardRef(function Contrast24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$n || (_path218$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"
    })), children);
  });
  var Contrast20 = /*#__PURE__*/React__default['default'].forwardRef(function Contrast20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$n || (_path219$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"
    })), children);
  });
  var Contrast16 = /*#__PURE__*/React__default['default'].forwardRef(function Contrast16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$n || (_path220$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"
    })), children);
  });
  var ConvertToCloud32 = /*#__PURE__*/React__default['default'].forwardRef(function ConvertToCloud32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$n || (_path221$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM23 14l-5 5 1.4141 1.4141L22 17.8325V24H16v2h6a2.0025 2.0025 0 002-2V17.8325l2.5874 2.583L28 19zM2 20H12V22H2zM2 24H12V26H2zM2 28H12V30H2z"
    })), children);
  });
  var ConvertToCloud24 = /*#__PURE__*/React__default['default'].forwardRef(function ConvertToCloud24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$n || (_path222$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM23 14l-5 5 1.4141 1.4141L22 17.8325V24H16v2h6a2.0025 2.0025 0 002-2V17.8325l2.5874 2.583L28 19zM2 20H12V22H2zM2 24H12V26H2zM2 28H12V30H2z"
    })), children);
  });
  var ConvertToCloud20 = /*#__PURE__*/React__default['default'].forwardRef(function ConvertToCloud20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$n || (_path223$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM23 14l-5 5 1.4141 1.4141L22 17.8325V24H16v2h6a2.0025 2.0025 0 002-2V17.8325l2.5874 2.583L28 19zM2 20H12V22H2zM2 24H12V26H2zM2 28H12V30H2z"
    })), children);
  });
  var ConvertToCloud16 = /*#__PURE__*/React__default['default'].forwardRef(function ConvertToCloud16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$n || (_path224$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM23 14l-5 5 1.4141 1.4141L22 17.8325V24H16v2h6a2.0025 2.0025 0 002-2V17.8325l2.5874 2.583L28 19zM2 20H12V22H2zM2 24H12V26H2zM2 28H12V30H2z"
    })), children);
  });
  var Copy32 = /*#__PURE__*/React__default['default'].forwardRef(function Copy32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$n || (_path225$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"
    })), _path226$n || (_path226$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"
    })), children);
  });
  var Copy24 = /*#__PURE__*/React__default['default'].forwardRef(function Copy24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$n || (_path227$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"
    })), _path228$n || (_path228$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"
    })), children);
  });
  var Copy20 = /*#__PURE__*/React__default['default'].forwardRef(function Copy20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$n || (_path229$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"
    })), _path230$n || (_path230$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"
    })), children);
  });
  var Copy16 = /*#__PURE__*/React__default['default'].forwardRef(function Copy16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$n || (_path231$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"
    })), _path232$n || (_path232$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"
    })), children);
  });
  var CopyFile32 = /*#__PURE__*/React__default['default'].forwardRef(function CopyFile32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$n || (_path233$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4,14.7l-6.1-6.1C21,8.2,20.5,8,20,8h-8c-1.1,0-2,0.9-2,2v18c0,1.1,0.9,2,2,2h14c1.1,0,2-0.9,2-2V16.1\tC28,15.6,27.8,15.1,27.4,14.7z M20,10l5.9,6H20V10z M12,28V10h6v6c0,1.1,0.9,2,2,2h6l0,10H12z"
    })), _path234$n || (_path234$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,18H4V4c0-1.1,0.9-2,2-2h14v2H6V18z"
    })), children);
  });
  var CopyFile24 = /*#__PURE__*/React__default['default'].forwardRef(function CopyFile24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$n || (_path235$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4,14.7l-6.1-6.1C21,8.2,20.5,8,20,8h-8c-1.1,0-2,0.9-2,2v18c0,1.1,0.9,2,2,2h14c1.1,0,2-0.9,2-2V16.1\tC28,15.6,27.8,15.1,27.4,14.7z M20,10l5.9,6H20V10z M12,28V10h6v6c0,1.1,0.9,2,2,2h6l0,10H12z"
    })), _path236$n || (_path236$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,18H4V4c0-1.1,0.9-2,2-2h14v2H6V18z"
    })), children);
  });
  var CopyFile20 = /*#__PURE__*/React__default['default'].forwardRef(function CopyFile20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$n || (_path237$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4,14.7l-6.1-6.1C21,8.2,20.5,8,20,8h-8c-1.1,0-2,0.9-2,2v18c0,1.1,0.9,2,2,2h14c1.1,0,2-0.9,2-2V16.1\tC28,15.6,27.8,15.1,27.4,14.7z M20,10l5.9,6H20V10z M12,28V10h6v6c0,1.1,0.9,2,2,2h6l0,10H12z"
    })), _path238$n || (_path238$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,18H4V4c0-1.1,0.9-2,2-2h14v2H6V18z"
    })), children);
  });
  var CopyFile16 = /*#__PURE__*/React__default['default'].forwardRef(function CopyFile16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$n || (_path239$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.4,14.7l-6.1-6.1C21,8.2,20.5,8,20,8h-8c-1.1,0-2,0.9-2,2v18c0,1.1,0.9,2,2,2h14c1.1,0,2-0.9,2-2V16.1\tC28,15.6,27.8,15.1,27.4,14.7z M20,10l5.9,6H20V10z M12,28V10h6v6c0,1.1,0.9,2,2,2h6l0,10H12z"
    })), _path240$n || (_path240$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,18H4V4c0-1.1,0.9-2,2-2h14v2H6V18z"
    })), children);
  });
  var CopyLink32 = /*#__PURE__*/React__default['default'].forwardRef(function CopyLink32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$n || (_path241$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.9474,19a4.9476,4.9476,0,0,1-3.4991-8.4465l5.1053-5.1043a4.9482,4.9482,0,0,1,6.9981,6.9976l-.5523.5526-1.4158-1.4129.5577-.5579a2.95,2.95,0,0,0-.0039-4.1653,3.02,3.02,0,0,0-4.17,0l-5.1047,5.104a2.9474,2.9474,0,0,0,0,4.1692,3.02,3.02,0,0,0,4.17,0l1.4143,1.4145A4.9176,4.9176,0,0,1,11.9474,19Z"
    })), _path242$n || (_path242$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.9474,17a4.9476,4.9476,0,0,1-3.4991-8.4465l.5526-.5526,1.4143,1.4146-.5526.5523a2.9476,2.9476,0,0,0,0,4.1689,3.02,3.02,0,0,0,4.17,0c.26-.26,4.7293-4.7293,5.1053-5.1045a2.951,2.951,0,0,0,0-4.1687,3.02,3.02,0,0,0-4.17,0L21.5536,3.449a4.9483,4.9483,0,0,1,6.9981,6.9978c-.3765.376-4.844,4.8428-5.1038,5.1035A4.9193,4.9193,0,0,1,19.9474,17Z"
    })), _path243$n || (_path243$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H4a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,4,6H8V8H4V28H24V18h2V28A2.0021,2.0021,0,0,1,24,30Z"
    })), children);
  });
  var CopyLink24 = /*#__PURE__*/React__default['default'].forwardRef(function CopyLink24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$n || (_path244$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.9474,19a4.9476,4.9476,0,0,1-3.4991-8.4465l5.1053-5.1043a4.9482,4.9482,0,0,1,6.9981,6.9976l-.5523.5526-1.4158-1.4129.5577-.5579a2.95,2.95,0,0,0-.0039-4.1653,3.02,3.02,0,0,0-4.17,0l-5.1047,5.104a2.9474,2.9474,0,0,0,0,4.1692,3.02,3.02,0,0,0,4.17,0l1.4143,1.4145A4.9176,4.9176,0,0,1,11.9474,19Z"
    })), _path245$n || (_path245$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.9474,17a4.9476,4.9476,0,0,1-3.4991-8.4465l.5526-.5526,1.4143,1.4146-.5526.5523a2.9476,2.9476,0,0,0,0,4.1689,3.02,3.02,0,0,0,4.17,0c.26-.26,4.7293-4.7293,5.1053-5.1045a2.951,2.951,0,0,0,0-4.1687,3.02,3.02,0,0,0-4.17,0L21.5536,3.449a4.9483,4.9483,0,0,1,6.9981,6.9978c-.3765.376-4.844,4.8428-5.1038,5.1035A4.9193,4.9193,0,0,1,19.9474,17Z"
    })), _path246$n || (_path246$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H4a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,4,6H8V8H4V28H24V18h2V28A2.0021,2.0021,0,0,1,24,30Z"
    })), children);
  });
  var CopyLink20 = /*#__PURE__*/React__default['default'].forwardRef(function CopyLink20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$n || (_path247$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.9474,19a4.9476,4.9476,0,0,1-3.4991-8.4465l5.1053-5.1043a4.9482,4.9482,0,0,1,6.9981,6.9976l-.5523.5526-1.4158-1.4129.5577-.5579a2.95,2.95,0,0,0-.0039-4.1653,3.02,3.02,0,0,0-4.17,0l-5.1047,5.104a2.9474,2.9474,0,0,0,0,4.1692,3.02,3.02,0,0,0,4.17,0l1.4143,1.4145A4.9176,4.9176,0,0,1,11.9474,19Z"
    })), _path248$n || (_path248$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.9474,17a4.9476,4.9476,0,0,1-3.4991-8.4465l.5526-.5526,1.4143,1.4146-.5526.5523a2.9476,2.9476,0,0,0,0,4.1689,3.02,3.02,0,0,0,4.17,0c.26-.26,4.7293-4.7293,5.1053-5.1045a2.951,2.951,0,0,0,0-4.1687,3.02,3.02,0,0,0-4.17,0L21.5536,3.449a4.9483,4.9483,0,0,1,6.9981,6.9978c-.3765.376-4.844,4.8428-5.1038,5.1035A4.9193,4.9193,0,0,1,19.9474,17Z"
    })), _path249$n || (_path249$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H4a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,4,6H8V8H4V28H24V18h2V28A2.0021,2.0021,0,0,1,24,30Z"
    })), children);
  });
  var CopyLink16 = /*#__PURE__*/React__default['default'].forwardRef(function CopyLink16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$n || (_path250$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.9474,19a4.9476,4.9476,0,0,1-3.4991-8.4465l5.1053-5.1043a4.9482,4.9482,0,0,1,6.9981,6.9976l-.5523.5526-1.4158-1.4129.5577-.5579a2.95,2.95,0,0,0-.0039-4.1653,3.02,3.02,0,0,0-4.17,0l-5.1047,5.104a2.9474,2.9474,0,0,0,0,4.1692,3.02,3.02,0,0,0,4.17,0l1.4143,1.4145A4.9176,4.9176,0,0,1,11.9474,19Z"
    })), _path251$n || (_path251$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.9474,17a4.9476,4.9476,0,0,1-3.4991-8.4465l.5526-.5526,1.4143,1.4146-.5526.5523a2.9476,2.9476,0,0,0,0,4.1689,3.02,3.02,0,0,0,4.17,0c.26-.26,4.7293-4.7293,5.1053-5.1045a2.951,2.951,0,0,0,0-4.1687,3.02,3.02,0,0,0-4.17,0L21.5536,3.449a4.9483,4.9483,0,0,1,6.9981,6.9978c-.3765.376-4.844,4.8428-5.1038,5.1035A4.9193,4.9193,0,0,1,19.9474,17Z"
    })), _path252$n || (_path252$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H4a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,4,6H8V8H4V28H24V18h2V28A2.0021,2.0021,0,0,1,24,30Z"
    })), children);
  });
  var Corn32 = /*#__PURE__*/React__default['default'].forwardRef(function Corn32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$n || (_path253$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Corn24 = /*#__PURE__*/React__default['default'].forwardRef(function Corn24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$n || (_path254$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Corn20 = /*#__PURE__*/React__default['default'].forwardRef(function Corn20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$n || (_path255$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Corn16 = /*#__PURE__*/React__default['default'].forwardRef(function Corn16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$n || (_path256$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Corner32 = /*#__PURE__*/React__default['default'].forwardRef(function Corner32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$n || (_path257$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"
    })), children);
  });
  var Corner24 = /*#__PURE__*/React__default['default'].forwardRef(function Corner24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$n || (_path258$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"
    })), children);
  });
  var Corner20 = /*#__PURE__*/React__default['default'].forwardRef(function Corner20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$n || (_path259$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"
    })), children);
  });
  var Corner16 = /*#__PURE__*/React__default['default'].forwardRef(function Corner16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$n || (_path260$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"
    })), children);
  });
  var Coronavirus32 = /*#__PURE__*/React__default['default'].forwardRef(function Coronavirus32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle41$9 || (_circle41$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.5",
      cy: "11.5",
      r: "1.5"
    })), _circle42$9 || (_circle42$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.5",
      cy: "15.5",
      r: "1.5"
    })), _circle43$9 || (_circle43$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "1"
    })), _circle44$9 || (_circle44$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "20.5",
      r: "1.5"
    })), _circle45$8 || (_circle45$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "16.5",
      r: "1.5"
    })), _path261$n || (_path261$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13v2H25.9492a9.9476,9.9476,0,0,0-2.2143-5.3213l1.4367-1.4365,1.4143,1.4145L28,8.2427,23.7578,4l-1.414,1.4141,1.414,1.414-1.437,1.4365A9.9464,9.9464,0,0,0,17,6.0508V4h2V2H13V4h2V6.0508A9.9464,9.9464,0,0,0,9.6792,8.2646L8.2422,6.8281l1.414-1.414L8.2422,4,4,8.2427l1.4141,1.414L6.8284,8.2422,8.2651,9.6787A9.9476,9.9476,0,0,0,6.0508,15H4V13H2v6H4V17H6.0508a9.9476,9.9476,0,0,0,2.2143,5.3213L6.8284,23.7578,5.4141,22.3433,4,23.7573,8.2422,28l1.414-1.4141-1.414-1.414,1.437-1.4365A9.9464,9.9464,0,0,0,15,25.9492V28H13v2h6V28H17V25.9492a9.9464,9.9464,0,0,0,5.3208-2.2138l1.437,1.4365-1.414,1.414L23.7578,28,28,23.7573l-1.4141-1.414-1.4143,1.4145-1.4367-1.4365A9.9476,9.9476,0,0,0,25.9492,17H28v2h2V13ZM16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Z"
    })), children);
  });
  var Coronavirus24 = /*#__PURE__*/React__default['default'].forwardRef(function Coronavirus24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle46$8 || (_circle46$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.5",
      cy: "11.5",
      r: "1.5"
    })), _circle47$8 || (_circle47$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.5",
      cy: "15.5",
      r: "1.5"
    })), _circle48$8 || (_circle48$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "1"
    })), _circle49$7 || (_circle49$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "20.5",
      r: "1.5"
    })), _circle50$7 || (_circle50$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "16.5",
      r: "1.5"
    })), _path262$n || (_path262$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13v2H25.9492a9.9476,9.9476,0,0,0-2.2143-5.3213l1.4367-1.4365,1.4143,1.4145L28,8.2427,23.7578,4l-1.414,1.4141,1.414,1.414-1.437,1.4365A9.9464,9.9464,0,0,0,17,6.0508V4h2V2H13V4h2V6.0508A9.9464,9.9464,0,0,0,9.6792,8.2646L8.2422,6.8281l1.414-1.414L8.2422,4,4,8.2427l1.4141,1.414L6.8284,8.2422,8.2651,9.6787A9.9476,9.9476,0,0,0,6.0508,15H4V13H2v6H4V17H6.0508a9.9476,9.9476,0,0,0,2.2143,5.3213L6.8284,23.7578,5.4141,22.3433,4,23.7573,8.2422,28l1.414-1.4141-1.414-1.414,1.437-1.4365A9.9464,9.9464,0,0,0,15,25.9492V28H13v2h6V28H17V25.9492a9.9464,9.9464,0,0,0,5.3208-2.2138l1.437,1.4365-1.414,1.414L23.7578,28,28,23.7573l-1.4141-1.414-1.4143,1.4145-1.4367-1.4365A9.9476,9.9476,0,0,0,25.9492,17H28v2h2V13ZM16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Z"
    })), children);
  });
  var Coronavirus20 = /*#__PURE__*/React__default['default'].forwardRef(function Coronavirus20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle51$7 || (_circle51$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.5",
      cy: "11.5",
      r: "1.5"
    })), _circle52$7 || (_circle52$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.5",
      cy: "15.5",
      r: "1.5"
    })), _circle53$6 || (_circle53$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "1"
    })), _circle54$6 || (_circle54$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "20.5",
      r: "1.5"
    })), _circle55$5 || (_circle55$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "16.5",
      r: "1.5"
    })), _path263$n || (_path263$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13v2H25.9492a9.9476,9.9476,0,0,0-2.2143-5.3213l1.4367-1.4365,1.4143,1.4145L28,8.2427,23.7578,4l-1.414,1.4141,1.414,1.414-1.437,1.4365A9.9464,9.9464,0,0,0,17,6.0508V4h2V2H13V4h2V6.0508A9.9464,9.9464,0,0,0,9.6792,8.2646L8.2422,6.8281l1.414-1.414L8.2422,4,4,8.2427l1.4141,1.414L6.8284,8.2422,8.2651,9.6787A9.9476,9.9476,0,0,0,6.0508,15H4V13H2v6H4V17H6.0508a9.9476,9.9476,0,0,0,2.2143,5.3213L6.8284,23.7578,5.4141,22.3433,4,23.7573,8.2422,28l1.414-1.4141-1.414-1.414,1.437-1.4365A9.9464,9.9464,0,0,0,15,25.9492V28H13v2h6V28H17V25.9492a9.9464,9.9464,0,0,0,5.3208-2.2138l1.437,1.4365-1.414,1.414L23.7578,28,28,23.7573l-1.4141-1.414-1.4143,1.4145-1.4367-1.4365A9.9476,9.9476,0,0,0,25.9492,17H28v2h2V13ZM16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Z"
    })), children);
  });
  var Coronavirus16 = /*#__PURE__*/React__default['default'].forwardRef(function Coronavirus16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle56$5 || (_circle56$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15.5",
      cy: "11.5",
      r: "1.5"
    })), _circle57$5 || (_circle57$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20.5",
      cy: "15.5",
      r: "1.5"
    })), _circle58$5 || (_circle58$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "1"
    })), _circle59$5 || (_circle59$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "20.5",
      r: "1.5"
    })), _circle60$5 || (_circle60$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "16.5",
      r: "1.5"
    })), _path264$n || (_path264$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13v2H25.9492a9.9476,9.9476,0,0,0-2.2143-5.3213l1.4367-1.4365,1.4143,1.4145L28,8.2427,23.7578,4l-1.414,1.4141,1.414,1.414-1.437,1.4365A9.9464,9.9464,0,0,0,17,6.0508V4h2V2H13V4h2V6.0508A9.9464,9.9464,0,0,0,9.6792,8.2646L8.2422,6.8281l1.414-1.414L8.2422,4,4,8.2427l1.4141,1.414L6.8284,8.2422,8.2651,9.6787A9.9476,9.9476,0,0,0,6.0508,15H4V13H2v6H4V17H6.0508a9.9476,9.9476,0,0,0,2.2143,5.3213L6.8284,23.7578,5.4141,22.3433,4,23.7573,8.2422,28l1.414-1.4141-1.414-1.414,1.437-1.4365A9.9464,9.9464,0,0,0,15,25.9492V28H13v2h6V28H17V25.9492a9.9464,9.9464,0,0,0,5.3208-2.2138l1.437,1.4365-1.414,1.414L23.7578,28,28,23.7573l-1.4141-1.414-1.4143,1.4145-1.4367-1.4365A9.9476,9.9476,0,0,0,25.9492,17H28v2h2V13ZM16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Z"
    })), children);
  });
  var Cost32 = /*#__PURE__*/React__default['default'].forwardRef(function Cost32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$n || (_path265$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,16,23Zm0-12a5,5,0,1,0,5,5A5.0057,5.0057,0,0,0,16,11Z"
    })), _path266$n || (_path266$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Cost24 = /*#__PURE__*/React__default['default'].forwardRef(function Cost24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$n || (_path267$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,16,23Zm0-12a5,5,0,1,0,5,5A5.0057,5.0057,0,0,0,16,11Z"
    })), _path268$n || (_path268$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Cost20 = /*#__PURE__*/React__default['default'].forwardRef(function Cost20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$n || (_path269$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,16,23Zm0-12a5,5,0,1,0,5,5A5.0057,5.0057,0,0,0,16,11Z"
    })), _path270$n || (_path270$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Cost16 = /*#__PURE__*/React__default['default'].forwardRef(function Cost16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$n || (_path271$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,16,23Zm0-12a5,5,0,1,0,5,5A5.0057,5.0057,0,0,0,16,11Z"
    })), _path272$n || (_path272$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var CostTotal32 = /*#__PURE__*/React__default['default'].forwardRef(function CostTotal32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$n || (_path273$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10zM10 18H22V20H10z"
    })), _path274$n || (_path274$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var CostTotal24 = /*#__PURE__*/React__default['default'].forwardRef(function CostTotal24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$n || (_path275$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10zM10 18H22V20H10z"
    })), _path276$n || (_path276$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var CostTotal20 = /*#__PURE__*/React__default['default'].forwardRef(function CostTotal20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$n || (_path277$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10zM10 18H22V20H10z"
    })), _path278$n || (_path278$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var CostTotal16 = /*#__PURE__*/React__default['default'].forwardRef(function CostTotal16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$n || (_path279$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H22V15H10zM10 18H22V20H10z"
    })), _path280$n || (_path280$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6.4141,28.5859,5l-3.35,3.35A12.0812,12.0812,0,0,0,23.65,6.7637L27,3.4141,25.5859,2,21.9766,5.6094A11.9792,11.9792,0,0,0,5.6094,21.9766L2,25.5859,3.4141,27l3.35-3.35A12.0812,12.0812,0,0,0,8.35,25.2363L5,28.5859,6.4141,30l3.6093-3.6094A11.9792,11.9792,0,0,0,26.3906,10.0234ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Cough32 = /*#__PURE__*/React__default['default'].forwardRef(function Cough32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$n || (_path281$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _circle61$5 || (_circle61$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "23",
      r: "1"
    })), _circle62$5 || (_circle62$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle63$5 || (_circle63$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "1"
    })), _circle64$5 || (_circle64$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "17",
      r: "1"
    })), _circle65$5 || (_circle65$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "29",
      r: "1"
    })), _circle66$5 || (_circle66$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "23",
      r: "1"
    })), _path282$n || (_path282$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Cough24 = /*#__PURE__*/React__default['default'].forwardRef(function Cough24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$n || (_path283$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _circle67$5 || (_circle67$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "23",
      r: "1"
    })), _circle68$5 || (_circle68$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle69$5 || (_circle69$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "1"
    })), _circle70$5 || (_circle70$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "17",
      r: "1"
    })), _circle71$5 || (_circle71$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "29",
      r: "1"
    })), _circle72$5 || (_circle72$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "23",
      r: "1"
    })), _path284$n || (_path284$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Cough20 = /*#__PURE__*/React__default['default'].forwardRef(function Cough20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$n || (_path285$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _circle73$4 || (_circle73$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "23",
      r: "1"
    })), _circle74$4 || (_circle74$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle75$4 || (_circle75$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "1"
    })), _circle76$4 || (_circle76$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "17",
      r: "1"
    })), _circle77$4 || (_circle77$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "29",
      r: "1"
    })), _circle78$4 || (_circle78$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "23",
      r: "1"
    })), _path286$n || (_path286$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Cough16 = /*#__PURE__*/React__default['default'].forwardRef(function Cough16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$n || (_path287$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _circle79$4 || (_circle79$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "23",
      r: "1"
    })), _circle80$4 || (_circle80$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "20",
      r: "1"
    })), _circle81$4 || (_circle81$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "26",
      r: "1"
    })), _circle82$4 || (_circle82$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "17",
      r: "1"
    })), _circle83$4 || (_circle83$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "29",
      r: "1"
    })), _circle84$4 || (_circle84$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "23",
      r: "1"
    })), _path288$n || (_path288$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Course32 = /*#__PURE__*/React__default['default'].forwardRef(function Course32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$n || (_path289$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"
    })), children);
  });
  var Course24 = /*#__PURE__*/React__default['default'].forwardRef(function Course24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$n || (_path290$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"
    })), children);
  });
  var Course20 = /*#__PURE__*/React__default['default'].forwardRef(function Course20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$n || (_path291$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"
    })), children);
  });
  var Course16 = /*#__PURE__*/React__default['default'].forwardRef(function Course16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$n || (_path292$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"
    })), children);
  });
  var Covariate32 = /*#__PURE__*/React__default['default'].forwardRef(function Covariate32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle85$3 || (_circle85$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle86$3 || (_circle86$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), _circle87$3 || (_circle87$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle88$3 || (_circle88$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _path293$n || (_path293$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,4,26.5859V2H2V28a2,2,0,0,0,2,2H30V28H5.4141ZM4,28Z"
    })), children);
  });
  var Covariate24 = /*#__PURE__*/React__default['default'].forwardRef(function Covariate24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle89$2 || (_circle89$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle90$2 || (_circle90$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), _circle91$2 || (_circle91$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle92$2 || (_circle92$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _path294$n || (_path294$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,4,26.5859V2H2V28a2,2,0,0,0,2,2H30V28H5.4141ZM4,28Z"
    })), children);
  });
  var Covariate20 = /*#__PURE__*/React__default['default'].forwardRef(function Covariate20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle93$2 || (_circle93$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle94$2 || (_circle94$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), _circle95$2 || (_circle95$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle96$2 || (_circle96$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _path295$n || (_path295$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,4,26.5859V2H2V28a2,2,0,0,0,2,2H30V28H5.4141ZM4,28Z"
    })), children);
  });
  var Covariate16 = /*#__PURE__*/React__default['default'].forwardRef(function Covariate16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle97$2 || (_circle97$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle98$2 || (_circle98$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "8",
      r: "2"
    })), _circle99$2 || (_circle99$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle100$2 || (_circle100$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _path296$n || (_path296$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,4,26.5859V2H2V28a2,2,0,0,0,2,2H30V28H5.4141ZM4,28Z"
    })), children);
  });
  var Credentials32 = /*#__PURE__*/React__default['default'].forwardRef(function Credentials32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$n || (_path297$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 10-4-4A4 4 0 0016 22zm0-6a2 2 0 11-2 2A2 2 0 0116 16zM14 6H18V8H14z"
    })), _path298$n || (_path298$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"
    })), children);
  });
  var Credentials24 = /*#__PURE__*/React__default['default'].forwardRef(function Credentials24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$n || (_path299$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 10-4-4A4 4 0 0016 22zm0-6a2 2 0 11-2 2A2 2 0 0116 16zM14 6H18V8H14z"
    })), _path300$n || (_path300$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"
    })), children);
  });
  var Credentials20 = /*#__PURE__*/React__default['default'].forwardRef(function Credentials20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$n || (_path301$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 10-4-4A4 4 0 0016 22zm0-6a2 2 0 11-2 2A2 2 0 0116 16zM14 6H18V8H14z"
    })), _path302$n || (_path302$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"
    })), children);
  });
  var Credentials16 = /*#__PURE__*/React__default['default'].forwardRef(function Credentials16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$n || (_path303$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 10-4-4A4 4 0 0016 22zm0-6a2 2 0 11-2 2A2 2 0 0116 16zM14 6H18V8H14z"
    })), _path304$n || (_path304$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"
    })), children);
  });
  var CriticalGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CriticalGlyph(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$n || (_path305$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.887 11.4727a5.9936 5.9936 0 00-8.36-8.3594zM3.113 4.5273a5.9936 5.9936 0 008.36 8.3594z"
    })), children);
  });
  var CriticalSeverityGlyph = /*#__PURE__*/React__default['default'].forwardRef(function CriticalSeverityGlyph(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$n || (_path306$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 13L3 13 3 3 13 13z"
    })), children);
  });
  var Crop32 = /*#__PURE__*/React__default['default'].forwardRef(function Crop32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$n || (_path307$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"
    })), _path308$n || (_path308$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"
    })), children);
  });
  var Crop24 = /*#__PURE__*/React__default['default'].forwardRef(function Crop24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$n || (_path309$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"
    })), _path310$n || (_path310$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"
    })), children);
  });
  var Crop20 = /*#__PURE__*/React__default['default'].forwardRef(function Crop20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$n || (_path311$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"
    })), _path312$n || (_path312$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"
    })), children);
  });
  var Crop16 = /*#__PURE__*/React__default['default'].forwardRef(function Crop16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$n || (_path313$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"
    })), _path314$n || (_path314$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"
    })), children);
  });
  var CropGrowth32 = /*#__PURE__*/React__default['default'].forwardRef(function CropGrowth32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$n || (_path315$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a4.0045,4.0045,0,0,0,4-4V6H27a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,19,4H16V7a6.0066,6.0066,0,0,0,6,6h1V26H11V21h1a4.0045,4.0045,0,0,0,4-4V14H13a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,5,12H2v3a6.0066,6.0066,0,0,0,6,6H9v5H2v2H30V26H25V13Zm-1-3a2.002,2.002,0,0,1,2-2h1V9a2.002,2.002,0,0,1-2,2H25ZM11,18a2.002,2.002,0,0,1,2-2h1v1a2.002,2.002,0,0,1-2,2H11ZM9,19H8a4.0045,4.0045,0,0,1-4-4V14H5a4.0045,4.0045,0,0,1,4,4Zm14-8H22a4.0045,4.0045,0,0,1-4-4V6h1a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CropGrowth24 = /*#__PURE__*/React__default['default'].forwardRef(function CropGrowth24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$n || (_path316$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a4.0045,4.0045,0,0,0,4-4V6H27a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,19,4H16V7a6.0066,6.0066,0,0,0,6,6h1V26H11V21h1a4.0045,4.0045,0,0,0,4-4V14H13a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,5,12H2v3a6.0066,6.0066,0,0,0,6,6H9v5H2v2H30V26H25V13Zm-1-3a2.002,2.002,0,0,1,2-2h1V9a2.002,2.002,0,0,1-2,2H25ZM11,18a2.002,2.002,0,0,1,2-2h1v1a2.002,2.002,0,0,1-2,2H11ZM9,19H8a4.0045,4.0045,0,0,1-4-4V14H5a4.0045,4.0045,0,0,1,4,4Zm14-8H22a4.0045,4.0045,0,0,1-4-4V6h1a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CropGrowth20 = /*#__PURE__*/React__default['default'].forwardRef(function CropGrowth20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$n || (_path317$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a4.0045,4.0045,0,0,0,4-4V6H27a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,19,4H16V7a6.0066,6.0066,0,0,0,6,6h1V26H11V21h1a4.0045,4.0045,0,0,0,4-4V14H13a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,5,12H2v3a6.0066,6.0066,0,0,0,6,6H9v5H2v2H30V26H25V13Zm-1-3a2.002,2.002,0,0,1,2-2h1V9a2.002,2.002,0,0,1-2,2H25ZM11,18a2.002,2.002,0,0,1,2-2h1v1a2.002,2.002,0,0,1-2,2H11ZM9,19H8a4.0045,4.0045,0,0,1-4-4V14H5a4.0045,4.0045,0,0,1,4,4Zm14-8H22a4.0045,4.0045,0,0,1-4-4V6h1a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CropGrowth16 = /*#__PURE__*/React__default['default'].forwardRef(function CropGrowth16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$n || (_path318$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13a4.0045,4.0045,0,0,0,4-4V6H27a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,19,4H16V7a6.0066,6.0066,0,0,0,6,6h1V26H11V21h1a4.0045,4.0045,0,0,0,4-4V14H13a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,5,12H2v3a6.0066,6.0066,0,0,0,6,6H9v5H2v2H30V26H25V13Zm-1-3a2.002,2.002,0,0,1,2-2h1V9a2.002,2.002,0,0,1-2,2H25ZM11,18a2.002,2.002,0,0,1,2-2h1v1a2.002,2.002,0,0,1-2,2H11ZM9,19H8a4.0045,4.0045,0,0,1-4-4V14H5a4.0045,4.0045,0,0,1,4,4Zm14-8H22a4.0045,4.0045,0,0,1-4-4V6h1a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CropHealth32 = /*#__PURE__*/React__default['default'].forwardRef(function CropHealth32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$n || (_path319$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM17 29a1 1 0 01-.7808-.3752L12.52 24H2V22H13a1 1 0 01.7808.3752l3.146 3.9322 5.2412-7.8621A1 1 0 0123.8 18.4L26.5 22H30v2H26a.9991.9991 0 01-.8-.4l-2.1523-2.8694-5.2159 7.824a.9986.9986 0 01-.7885.4443zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var CropHealth24 = /*#__PURE__*/React__default['default'].forwardRef(function CropHealth24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$n || (_path320$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM17 29a1 1 0 01-.7808-.3752L12.52 24H2V22H13a1 1 0 01.7808.3752l3.146 3.9322 5.2412-7.8621A1 1 0 0123.8 18.4L26.5 22H30v2H26a.9991.9991 0 01-.8-.4l-2.1523-2.8694-5.2159 7.824a.9986.9986 0 01-.7885.4443zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var CropHealth20 = /*#__PURE__*/React__default['default'].forwardRef(function CropHealth20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$n || (_path321$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM17 29a1 1 0 01-.7808-.3752L12.52 24H2V22H13a1 1 0 01.7808.3752l3.146 3.9322 5.2412-7.8621A1 1 0 0123.8 18.4L26.5 22H30v2H26a.9991.9991 0 01-.8-.4l-2.1523-2.8694-5.2159 7.824a.9986.9986 0 01-.7885.4443zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var CropHealth16 = /*#__PURE__*/React__default['default'].forwardRef(function CropHealth16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$n || (_path322$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM17 29a1 1 0 01-.7808-.3752L12.52 24H2V22H13a1 1 0 01.7808.3752l3.146 3.9322 5.2412-7.8621A1 1 0 0123.8 18.4L26.5 22H30v2H26a.9991.9991 0 01-.8-.4l-2.1523-2.8694-5.2159 7.824a.9986.9986 0 01-.7885.4443zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9z"
    })), children);
  });
  var WatsonHealthCrossReference32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCrossReference32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$n || (_path323$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 014-2h6a5.22 5.22 0 014 2h2.3A6.87 6.87 0 0019 18H13a6.87 6.87 0 00-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 117-7A7 7 0 0116 16zM16 4a5 5 0 00-5 5A5 5 0 0021 9 5 5 0 0016 4z"
    })), children);
  });
  var WatsonHealthCrossReference24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCrossReference24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$n || (_path324$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 014-2h6a5.22 5.22 0 014 2h2.3A6.87 6.87 0 0019 18H13a6.87 6.87 0 00-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 117-7A7 7 0 0116 16zM16 4a5 5 0 00-5 5A5 5 0 0021 9 5 5 0 0016 4z"
    })), children);
  });
  var WatsonHealthCrossReference20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCrossReference20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$n || (_path325$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 014-2h6a5.22 5.22 0 014 2h2.3A6.87 6.87 0 0019 18H13a6.87 6.87 0 00-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 117-7A7 7 0 0116 16zM16 4a5 5 0 00-5 5A5 5 0 0021 9 5 5 0 0016 4z"
    })), children);
  });
  var WatsonHealthCrossReference16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCrossReference16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$n || (_path326$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 014-2h6a5.22 5.22 0 014 2h2.3A6.87 6.87 0 0019 18H13a6.87 6.87 0 00-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 117-7A7 7 0 0116 16zM16 4a5 5 0 00-5 5A5 5 0 0021 9 5 5 0 0016 4z"
    })), children);
  });
  var CrossTab32 = /*#__PURE__*/React__default['default'].forwardRef(function CrossTab32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$n || (_path327$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H10A2.0023,2.0023,0,0,0,8,4V7H4A2.0023,2.0023,0,0,0,2,9V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM10,4H28V7H10ZM28,14H20V9h8ZM10,21V16h8v5Zm8,2v5H10V23ZM8,21H4V16H8ZM18,9v5H10V9Zm2,7h8v5H20ZM8,9v5H4V9ZM4,23H8v5H4Zm16,5V23h8v5Z"
    })), children);
  });
  var CrossTab24 = /*#__PURE__*/React__default['default'].forwardRef(function CrossTab24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$n || (_path328$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H10A2.0023,2.0023,0,0,0,8,4V7H4A2.0023,2.0023,0,0,0,2,9V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM10,4H28V7H10ZM28,14H20V9h8ZM10,21V16h8v5Zm8,2v5H10V23ZM8,21H4V16H8ZM18,9v5H10V9Zm2,7h8v5H20ZM8,9v5H4V9ZM4,23H8v5H4Zm16,5V23h8v5Z"
    })), children);
  });
  var CrossTab20 = /*#__PURE__*/React__default['default'].forwardRef(function CrossTab20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$n || (_path329$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H10A2.0023,2.0023,0,0,0,8,4V7H4A2.0023,2.0023,0,0,0,2,9V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM10,4H28V7H10ZM28,14H20V9h8ZM10,21V16h8v5Zm8,2v5H10V23ZM8,21H4V16H8ZM18,9v5H10V9Zm2,7h8v5H20ZM8,9v5H4V9ZM4,23H8v5H4Zm16,5V23h8v5Z"
    })), children);
  });
  var CrossTab16 = /*#__PURE__*/React__default['default'].forwardRef(function CrossTab16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$n || (_path330$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H10A2.0023,2.0023,0,0,0,8,4V7H4A2.0023,2.0023,0,0,0,2,9V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM10,4H28V7H10ZM28,14H20V9h8ZM10,21V16h8v5Zm8,2v5H10V23ZM8,21H4V16H8ZM18,9v5H10V9Zm2,7h8v5H20ZM8,9v5H4V9ZM4,23H8v5H4Zm16,5V23h8v5Z"
    })), children);
  });
  var Crossroads32 = /*#__PURE__*/React__default['default'].forwardRef(function Crossroads32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$n || (_path331$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,6.5859A1.9862,1.9862,0,0,0,25.1719,6H17V2H15V12H6.8281a1.9862,1.9862,0,0,0-1.414.5859L2,16l3.4141,3.4141A1.9862,1.9862,0,0,0,6.8281,20H15V30h2V14h8.1719a1.9862,1.9862,0,0,0,1.414-.5859L30,10ZM6.8281,18l-2-2,2-2H15v4Zm18.3438-6H17V8h8.1719l2,2Z"
    })), children);
  });
  var Crossroads24 = /*#__PURE__*/React__default['default'].forwardRef(function Crossroads24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$n || (_path332$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,6.5859A1.9862,1.9862,0,0,0,25.1719,6H17V2H15V12H6.8281a1.9862,1.9862,0,0,0-1.414.5859L2,16l3.4141,3.4141A1.9862,1.9862,0,0,0,6.8281,20H15V30h2V14h8.1719a1.9862,1.9862,0,0,0,1.414-.5859L30,10ZM6.8281,18l-2-2,2-2H15v4Zm18.3438-6H17V8h8.1719l2,2Z"
    })), children);
  });
  var Crossroads20 = /*#__PURE__*/React__default['default'].forwardRef(function Crossroads20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$n || (_path333$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,6.5859A1.9862,1.9862,0,0,0,25.1719,6H17V2H15V12H6.8281a1.9862,1.9862,0,0,0-1.414.5859L2,16l3.4141,3.4141A1.9862,1.9862,0,0,0,6.8281,20H15V30h2V14h8.1719a1.9862,1.9862,0,0,0,1.414-.5859L30,10ZM6.8281,18l-2-2,2-2H15v4Zm18.3438-6H17V8h8.1719l2,2Z"
    })), children);
  });
  var Crossroads16 = /*#__PURE__*/React__default['default'].forwardRef(function Crossroads16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$n || (_path334$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,6.5859A1.9862,1.9862,0,0,0,25.1719,6H17V2H15V12H6.8281a1.9862,1.9862,0,0,0-1.414.5859L2,16l3.4141,3.4141A1.9862,1.9862,0,0,0,6.8281,20H15V30h2V14h8.1719a1.9862,1.9862,0,0,0,1.414-.5859L30,10ZM6.8281,18l-2-2,2-2H15v4Zm18.3438-6H17V8h8.1719l2,2Z"
    })), children);
  });
  var CrowdReport32 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReport32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$n || (_path335$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path336$n || (_path336$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var CrowdReport24 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReport24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$n || (_path337$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path338$m || (_path338$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var CrowdReport20 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReport20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$m || (_path339$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path340$m || (_path340$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var CrowdReport16 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReport16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$m || (_path341$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path342$m || (_path342$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var CrowdReportFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReportFilled32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$m || (_path343$m = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path344$m || (_path344$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm6,13a2.0023,2.0023,0,0,1-2,2H18.5352L16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h8a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var CrowdReportFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReportFilled24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$m || (_path345$m = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path346$m || (_path346$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm6,13a2.0023,2.0023,0,0,1-2,2H18.5352L16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h8a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var CrowdReportFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReportFilled20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$m || (_path347$m = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path348$m || (_path348$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm6,13a2.0023,2.0023,0,0,1-2,2H18.5352L16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h8a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var CrowdReportFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function CrowdReportFilled16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$m || (_path349$m = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0021,2.0021,0,0,1-2-2V10a2.0021,2.0021,0,0,1,2-2h8a2.0021,2.0021,0,0,1,2,2v5a2.0021,2.0021,0,0,1-2,2H18.5352Z"
    })), _path350$m || (_path350$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm6,13a2.0023,2.0023,0,0,1-2,2H18.5352L16.832,19.5547l-1.664-1.1094L17.4648,15H20V10H12v5h2v2H12a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h8a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var Csv32 = /*#__PURE__*/React__default['default'].forwardRef(function Csv32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$m || (_path351$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Csv24 = /*#__PURE__*/React__default['default'].forwardRef(function Csv24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$m || (_path352$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Csv20 = /*#__PURE__*/React__default['default'].forwardRef(function Csv20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$m || (_path353$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var Csv16 = /*#__PURE__*/React__default['default'].forwardRef(function Csv16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$m || (_path354$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM10 23H4a2.0023 2.0023 0 01-2-2V11A2.002 2.002 0 014 9h6v2H4V21h6z"
    })), children);
  });
  var QCU132 = /*#__PURE__*/React__default['default'].forwardRef(function QCU132(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$l || (_path355$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"
    })), children);
  });
  var QCU124 = /*#__PURE__*/React__default['default'].forwardRef(function QCU124(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$l || (_path356$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"
    })), children);
  });
  var QCU120 = /*#__PURE__*/React__default['default'].forwardRef(function QCU120(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$l || (_path357$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"
    })), children);
  });
  var QCU116 = /*#__PURE__*/React__default['default'].forwardRef(function QCU116(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$l || (_path358$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"
    })), children);
  });
  var QCU332 = /*#__PURE__*/React__default['default'].forwardRef(function QCU332(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$l || (_path359$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9z"
    })), children);
  });
  var QCU324 = /*#__PURE__*/React__default['default'].forwardRef(function QCU324(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$l || (_path360$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9z"
    })), children);
  });
  var QCU320 = /*#__PURE__*/React__default['default'].forwardRef(function QCU320(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$k || (_path361$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9z"
    })), children);
  });
  var QCU316 = /*#__PURE__*/React__default['default'].forwardRef(function QCU316(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$k || (_path362$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 23H5a2 2 0 01-2-2V15a2 2 0 012-2h5v2H5v6h5zM18 23H14a2 2 0 01-2-2V9h2V21h4V9h2V21A2 2 0 0118 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9z"
    })), children);
  });

  var _path$n, _path2$n, _path3$n, _path4$n, _circle$m, _path5$n, _path6$n, _circle2$m, _path7$n, _path8$n, _circle3$m, _path9$n, _path10$n, _circle4$l, _path11$n, _path12$n, _path13$n, _path14$n, _path15$n, _path16$n, _path17$n, _path18$n, _path19$n, _path20$n, _path21$n, _path22$n, _path23$n, _path24$n, _path25$n, _path26$n, _path27$n, _path28$n, _path29$n, _path30$n, _path31$n, _path32$n, _path33$n, _path34$n, _path35$n, _path36$n, _path37$n, _path38$n, _path39$n, _path40$n, _path41$n, _path42$n, _path43$n, _path44$n, _path45$n, _path46$n, _path47$n, _path48$n, _path49$n, _path50$n, _path51$n, _path52$n, _path53$n, _path54$n, _path55$n, _path56$n, _path57$n, _path58$n, _path59$n, _path60$n, _path61$n, _path62$n, _path63$n, _path64$n, _path65$n, _path66$n, _path67$n, _path68$n, _path69$n, _path70$n, _path71$n, _path72$n, _path73$n, _path74$n, _path75$n, _path76$n, _path77$n, _path78$n, _path79$n, _path80$n, _path81$n, _path82$n, _path83$n, _path84$n, _path85$n, _path86$n, _path87$n, _path88$n, _path89$n, _path90$n, _path91$n, _path92$n, _path93$n, _path94$n, _path95$n, _path96$n, _path97$n, _path98$n, _path99$n, _path100$n, _path101$n, _path102$n, _path103$n, _path104$n, _path105$n, _path106$n, _path107$n, _path108$n, _path109$n, _path110$n, _path111$n, _path112$n, _path113$n, _path114$n, _path115$n, _path116$n, _path117$n, _path118$n, _path119$n, _path120$n, _path121$n, _path122$n, _path123$n, _path124$n, _path125$n, _path126$n, _path127$n, _path128$n, _path129$n, _circle5$k, _circle6$k, _circle7$k, _path130$n, _circle8$k, _circle9$k, _circle10$k, _path131$n, _circle11$j, _circle12$j, _circle13$j, _path132$n, _circle14$j, _circle15$j, _circle16$j, _path133$n, _path134$n, _path135$n, _path136$n, _path137$n, _path138$n, _path139$n, _path140$n, _path141$n, _path142$n, _path143$n, _path144$n, _path145$n, _path146$n, _path147$n, _path148$n, _path149$n, _circle17$i, _circle18$i, _circle19$i, _path150$n, _path151$n, _circle20$i, _circle21$h, _circle22$h, _path152$n, _path153$n, _circle23$g, _circle24$g, _circle25$f, _path154$n, _path155$n, _circle26$f, _circle27$e, _circle28$e, _path156$n, _path157$n, _path158$n, _path159$n, _path160$n, _path161$n, _path162$n, _path163$n, _path164$n, _path165$n, _path166$n, _path167$n, _path168$n, _circle29$d, _circle30$d, _circle31$d, _path169$n, _path170$n, _circle32$d, _circle33$c, _circle34$b, _path171$n, _path172$n, _circle35$b, _circle36$b, _circle37$9, _path173$n, _path174$n, _circle38$9, _circle39$9, _circle40$9, _path175$n, _path176$n, _path177$m, _path178$m, _path179$m, _path180$m, _path181$m, _path182$m, _path183$m, _path184$m, _path185$m, _path186$m, _path187$m, _path188$m, _path189$m, _path190$m, _path191$m, _path192$m, _circle41$8, _path193$m, _circle42$8, _path194$m, _circle43$8, _path195$m, _circle44$8, _path196$m, _path197$m, _path198$m, _path199$m, _path200$m, _path201$m, _path202$m, _path203$m, _path204$m, _circle45$7, _path205$m, _circle46$7, _circle47$7, _circle48$7, _path206$m, _circle49$6, _path207$m, _circle50$6, _circle51$6, _circle52$6, _path208$m, _circle53$5, _path209$m, _circle54$5, _circle55$4, _circle56$4, _path210$m, _circle57$4, _path211$m, _circle58$4, _circle59$4, _circle60$4, _path212$m, _circle61$4, _path213$m, _path214$m, _circle62$4, _path215$m, _path216$m, _circle63$4, _path217$m, _path218$m, _circle64$4, _path219$m, _path220$m, _path221$m, _circle65$4, _path222$m, _path223$m, _circle66$4, _path224$m, _path225$m, _circle67$4, _path226$m, _path227$m, _circle68$4, _path228$m, _circle69$4, _circle70$4, _circle71$4, _path229$m, _path230$m, _circle72$4, _circle73$3, _circle74$3, _path231$m, _path232$m, _circle75$3, _circle76$3, _circle77$3, _path233$m, _path234$m, _circle78$3, _circle79$3, _circle80$3, _path235$m, _path236$m, _path237$m, _path238$m, _path239$m, _path240$m, _path241$m, _path242$m, _path243$m, _path244$m, _path245$m, _path246$m, _path247$m, _path248$m, _path249$m, _path250$m, _path251$m, _path252$m, _path253$m, _path254$m, _path255$m, _path256$m, _circle81$3, _path257$m, _circle82$3, _path258$m, _circle83$3, _path259$m, _circle84$3, _path260$m, _circle85$2, _path261$m, _path262$m, _circle86$2, _path263$m, _path264$m, _circle87$2, _path265$m, _path266$m, _circle88$2, _path267$m, _path268$m, _path269$m, _path270$m, _path271$m, _path272$m, _path273$m, _path274$m, _path275$m, _path276$m, _path277$m, _path278$m, _path279$m, _path280$m, _path281$m, _path282$m, _path283$m, _path284$m, _path285$m, _path286$m, _path287$m, _path288$m, _path289$m, _path290$m, _path291$m, _path292$m, _path293$m, _path294$m, _path295$m, _path296$m, _path297$m, _path298$m, _path299$m, _path300$m, _path301$m, _path302$m, _path303$m, _path304$m, _path305$m, _path306$m, _path307$m, _path308$m, _path309$m, _path310$m, _path311$m, _path312$m, _path313$m, _path314$m, _path315$m, _path316$m, _path317$m, _path318$m, _path319$m, _path320$m, _path321$m, _path322$m, _path323$m, _path324$m, _path325$m, _path326$m, _path327$m, _path328$m, _path329$m, _path330$m, _path331$m, _path332$m, _path333$m, _path334$m, _path335$m, _path336$m, _path337$m, _path338$l, _path339$l, _path340$l, _path341$l, _path342$l, _path343$l, _path344$l, _path345$l, _path346$l, _path347$l, _path348$l, _path349$l, _path350$l, _path351$l, _path352$l, _path353$l, _path354$l, _path355$k, _path356$k, _path357$k, _path358$k, _path359$k, _path360$k, _path361$j, _path362$j;

  var _excluded$n = ["children"],
      _excluded2$n = ["children"],
      _excluded3$n = ["children"],
      _excluded4$n = ["children"],
      _excluded5$n = ["children"],
      _excluded6$n = ["children"],
      _excluded7$n = ["children"],
      _excluded8$n = ["children"],
      _excluded9$n = ["children"],
      _excluded10$n = ["children"],
      _excluded11$n = ["children"],
      _excluded12$n = ["children"],
      _excluded13$n = ["children"],
      _excluded14$n = ["children"],
      _excluded15$n = ["children"],
      _excluded16$n = ["children"],
      _excluded17$n = ["children"],
      _excluded18$n = ["children"],
      _excluded19$n = ["children"],
      _excluded20$n = ["children"],
      _excluded21$n = ["children"],
      _excluded22$n = ["children"],
      _excluded23$n = ["children"],
      _excluded24$n = ["children"],
      _excluded25$n = ["children"],
      _excluded26$n = ["children"],
      _excluded27$n = ["children"],
      _excluded28$n = ["children"],
      _excluded29$n = ["children"],
      _excluded30$n = ["children"],
      _excluded31$n = ["children"],
      _excluded32$n = ["children"],
      _excluded33$n = ["children"],
      _excluded34$n = ["children"],
      _excluded35$n = ["children"],
      _excluded36$n = ["children"],
      _excluded37$n = ["children"],
      _excluded38$n = ["children"],
      _excluded39$n = ["children"],
      _excluded40$n = ["children"],
      _excluded41$n = ["children"],
      _excluded42$n = ["children"],
      _excluded43$n = ["children"],
      _excluded44$n = ["children"],
      _excluded45$n = ["children"],
      _excluded46$n = ["children"],
      _excluded47$n = ["children"],
      _excluded48$n = ["children"],
      _excluded49$n = ["children"],
      _excluded50$n = ["children"],
      _excluded51$n = ["children"],
      _excluded52$n = ["children"],
      _excluded53$n = ["children"],
      _excluded54$n = ["children"],
      _excluded55$n = ["children"],
      _excluded56$n = ["children"],
      _excluded57$n = ["children"],
      _excluded58$n = ["children"],
      _excluded59$n = ["children"],
      _excluded60$n = ["children"],
      _excluded61$n = ["children"],
      _excluded62$n = ["children"],
      _excluded63$n = ["children"],
      _excluded64$n = ["children"],
      _excluded65$n = ["children"],
      _excluded66$n = ["children"],
      _excluded67$n = ["children"],
      _excluded68$n = ["children"],
      _excluded69$n = ["children"],
      _excluded70$n = ["children"],
      _excluded71$n = ["children"],
      _excluded72$n = ["children"],
      _excluded73$n = ["children"],
      _excluded74$n = ["children"],
      _excluded75$n = ["children"],
      _excluded76$n = ["children"],
      _excluded77$n = ["children"],
      _excluded78$n = ["children"],
      _excluded79$n = ["children"],
      _excluded80$n = ["children"],
      _excluded81$n = ["children"],
      _excluded82$n = ["children"],
      _excluded83$n = ["children"],
      _excluded84$n = ["children"],
      _excluded85$n = ["children"],
      _excluded86$n = ["children"],
      _excluded87$n = ["children"],
      _excluded88$n = ["children"],
      _excluded89$n = ["children"],
      _excluded90$n = ["children"],
      _excluded91$n = ["children"],
      _excluded92$n = ["children"],
      _excluded93$n = ["children"],
      _excluded94$n = ["children"],
      _excluded95$n = ["children"],
      _excluded96$n = ["children"],
      _excluded97$n = ["children"],
      _excluded98$n = ["children"],
      _excluded99$n = ["children"],
      _excluded100$n = ["children"],
      _excluded101$n = ["children"],
      _excluded102$n = ["children"],
      _excluded103$n = ["children"],
      _excluded104$n = ["children"],
      _excluded105$n = ["children"],
      _excluded106$n = ["children"],
      _excluded107$n = ["children"],
      _excluded108$n = ["children"],
      _excluded109$n = ["children"],
      _excluded110$n = ["children"],
      _excluded111$n = ["children"],
      _excluded112$n = ["children"],
      _excluded113$n = ["children"],
      _excluded114$n = ["children"],
      _excluded115$n = ["children"],
      _excluded116$n = ["children"],
      _excluded117$n = ["children"],
      _excluded118$n = ["children"],
      _excluded119$m = ["children"],
      _excluded120$m = ["children"],
      _excluded121$m = ["children"],
      _excluded122$m = ["children"],
      _excluded123$m = ["children"],
      _excluded124$m = ["children"],
      _excluded125$m = ["children"],
      _excluded126$m = ["children"],
      _excluded127$m = ["children"],
      _excluded128$m = ["children"],
      _excluded129$m = ["children"],
      _excluded130$m = ["children"],
      _excluded131$m = ["children"],
      _excluded132$m = ["children"],
      _excluded133$m = ["children"],
      _excluded134$m = ["children"],
      _excluded135$m = ["children"],
      _excluded136$m = ["children"],
      _excluded137$m = ["children"],
      _excluded138$m = ["children"],
      _excluded139$m = ["children"],
      _excluded140$m = ["children"],
      _excluded141$m = ["children"],
      _excluded142$m = ["children"],
      _excluded143$m = ["children"],
      _excluded144$m = ["children"],
      _excluded145$m = ["children"],
      _excluded146$m = ["children"],
      _excluded147$m = ["children"],
      _excluded148$m = ["children"],
      _excluded149$m = ["children"],
      _excluded150$m = ["children"],
      _excluded151$m = ["children"],
      _excluded152$m = ["children"],
      _excluded153$m = ["children"],
      _excluded154$m = ["children"],
      _excluded155$m = ["children"],
      _excluded156$m = ["children"],
      _excluded157$m = ["children"],
      _excluded158$m = ["children"],
      _excluded159$m = ["children"],
      _excluded160$m = ["children"],
      _excluded161$m = ["children"],
      _excluded162$m = ["children"],
      _excluded163$m = ["children"],
      _excluded164$m = ["children"],
      _excluded165$m = ["children"],
      _excluded166$m = ["children"],
      _excluded167$m = ["children"],
      _excluded168$m = ["children"],
      _excluded169$m = ["children"],
      _excluded170$m = ["children"],
      _excluded171$m = ["children"],
      _excluded172$m = ["children"],
      _excluded173$m = ["children"],
      _excluded174$m = ["children"],
      _excluded175$m = ["children"],
      _excluded176$m = ["children"],
      _excluded177$m = ["children"],
      _excluded178$m = ["children"],
      _excluded179$m = ["children"],
      _excluded180$m = ["children"],
      _excluded181$m = ["children"],
      _excluded182$m = ["children"],
      _excluded183$m = ["children"],
      _excluded184$m = ["children"],
      _excluded185$m = ["children"],
      _excluded186$m = ["children"],
      _excluded187$m = ["children"],
      _excluded188$m = ["children"],
      _excluded189$m = ["children"],
      _excluded190$m = ["children"],
      _excluded191$m = ["children"],
      _excluded192$m = ["children"],
      _excluded193$m = ["children"],
      _excluded194$m = ["children"],
      _excluded195$m = ["children"],
      _excluded196$m = ["children"],
      _excluded197$m = ["children"],
      _excluded198$m = ["children"],
      _excluded199$m = ["children"],
      _excluded200$m = ["children"],
      _excluded201$m = ["children"],
      _excluded202$m = ["children"],
      _excluded203$m = ["children"],
      _excluded204$m = ["children"],
      _excluded205$m = ["children"],
      _excluded206$m = ["children"],
      _excluded207$m = ["children"],
      _excluded208$m = ["children"],
      _excluded209$m = ["children"],
      _excluded210$m = ["children"],
      _excluded211$m = ["children"],
      _excluded212$m = ["children"],
      _excluded213$m = ["children"],
      _excluded214$m = ["children"],
      _excluded215$m = ["children"],
      _excluded216$m = ["children"],
      _excluded217$m = ["children"],
      _excluded218$m = ["children"],
      _excluded219$m = ["children"],
      _excluded220$m = ["children"],
      _excluded221$m = ["children"],
      _excluded222$m = ["children"],
      _excluded223$m = ["children"],
      _excluded224$m = ["children"],
      _excluded225$m = ["children"],
      _excluded226$m = ["children"],
      _excluded227$m = ["children"],
      _excluded228$m = ["children"],
      _excluded229$m = ["children"],
      _excluded230$m = ["children"],
      _excluded231$m = ["children"],
      _excluded232$m = ["children"],
      _excluded233$m = ["children"],
      _excluded234$m = ["children"],
      _excluded235$m = ["children"],
      _excluded236$m = ["children"],
      _excluded237$m = ["children"],
      _excluded238$m = ["children"],
      _excluded239$m = ["children"],
      _excluded240$m = ["children"],
      _excluded241$m = ["children"],
      _excluded242$m = ["children"],
      _excluded243$m = ["children"],
      _excluded244$m = ["children"],
      _excluded245$m = ["children"],
      _excluded246$m = ["children"],
      _excluded247$m = ["children"],
      _excluded248$m = ["children"],
      _excluded249$m = ["children"],
      _excluded250$m = ["children"];
  var Cube32 = /*#__PURE__*/React__default['default'].forwardRef(function Cube32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$n || (_path$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM16,3.1577,26.0156,9,16,14.8423,5.9844,9ZM5,10.7412l10,5.833V28.2588L5,22.4258ZM17,28.2588V16.5742l10-5.833V22.4258Z"
    })), children);
  });
  var Cube24 = /*#__PURE__*/React__default['default'].forwardRef(function Cube24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$n || (_path2$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM16,3.1577,26.0156,9,16,14.8423,5.9844,9ZM5,10.7412l10,5.833V28.2588L5,22.4258ZM17,28.2588V16.5742l10-5.833V22.4258Z"
    })), children);
  });
  var Cube20 = /*#__PURE__*/React__default['default'].forwardRef(function Cube20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$n || (_path3$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM16,3.1577,26.0156,9,16,14.8423,5.9844,9ZM5,10.7412l10,5.833V28.2588L5,22.4258ZM17,28.2588V16.5742l10-5.833V22.4258Z"
    })), children);
  });
  var Cube16 = /*#__PURE__*/React__default['default'].forwardRef(function Cube16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$n || (_path4$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM16,3.1577,26.0156,9,16,14.8423,5.9844,9ZM5,10.7412l10,5.833V28.2588L5,22.4258ZM17,28.2588V16.5742l10-5.833V22.4258Z"
    })), children);
  });
  var CubeView32 = /*#__PURE__*/React__default['default'].forwardRef(function CubeView32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$m || (_circle$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path5$n || (_path5$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,15.4785A8.64,8.64,0,0,0,16,10a8.64,8.64,0,0,0-7.7769,5.4785L8,16l.2231.5215A8.64,8.64,0,0,0,16,22a8.64,8.64,0,0,0,7.7769-5.4785L24,16ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path6$n || (_path6$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM27,22.4258,16,28.8423,5,22.4258V9.5742L16,3.1577,27,9.5742Z"
    })), children);
  });
  var CubeView24 = /*#__PURE__*/React__default['default'].forwardRef(function CubeView24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle2$m || (_circle2$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path7$n || (_path7$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,15.4785A8.64,8.64,0,0,0,16,10a8.64,8.64,0,0,0-7.7769,5.4785L8,16l.2231.5215A8.64,8.64,0,0,0,16,22a8.64,8.64,0,0,0,7.7769-5.4785L24,16ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path8$n || (_path8$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM27,22.4258,16,28.8423,5,22.4258V9.5742L16,3.1577,27,9.5742Z"
    })), children);
  });
  var CubeView20 = /*#__PURE__*/React__default['default'].forwardRef(function CubeView20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$m || (_circle3$m = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path9$n || (_path9$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,15.4785A8.64,8.64,0,0,0,16,10a8.64,8.64,0,0,0-7.7769,5.4785L8,16l.2231.5215A8.64,8.64,0,0,0,16,22a8.64,8.64,0,0,0,7.7769-5.4785L24,16ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path10$n || (_path10$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM27,22.4258,16,28.8423,5,22.4258V9.5742L16,3.1577,27,9.5742Z"
    })), children);
  });
  var CubeView16 = /*#__PURE__*/React__default['default'].forwardRef(function CubeView16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$l || (_circle4$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path11$n || (_path11$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7769,15.4785A8.64,8.64,0,0,0,16,10a8.64,8.64,0,0,0-7.7769,5.4785L8,16l.2231.5215A8.64,8.64,0,0,0,16,22a8.64,8.64,0,0,0,7.7769-5.4785L24,16ZM16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"
    })), _path12$n || (_path12$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5039,8.1362l-12-7a1,1,0,0,0-1.0078,0l-12,7A1,1,0,0,0,3,9V23a1,1,0,0,0,.4961.8638l12,7a1,1,0,0,0,1.0078,0l12-7A1,1,0,0,0,29,23V9A1,1,0,0,0,28.5039,8.1362ZM27,22.4258,16,28.8423,5,22.4258V9.5742L16,3.1577,27,9.5742Z"
    })), children);
  });
  var Currency32 = /*#__PURE__*/React__default['default'].forwardRef(function Currency32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$n || (_path13$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12V10H17V7H15v3H13a2.002,2.002,0,0,0-2,2v3a2.002,2.002,0,0,0,2,2h6v3H11v2h4v3h2V22h2a2.0023,2.0023,0,0,0,2-2V17a2.002,2.002,0,0,0-2-2H13V12Z"
    })), _path14$n || (_path14$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0353,12.0353,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14.0412,14.0412,0,0,0,16,2Z"
    })), children);
  });
  var Currency24 = /*#__PURE__*/React__default['default'].forwardRef(function Currency24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$n || (_path15$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12V10H17V7H15v3H13a2.002,2.002,0,0,0-2,2v3a2.002,2.002,0,0,0,2,2h6v3H11v2h4v3h2V22h2a2.0023,2.0023,0,0,0,2-2V17a2.002,2.002,0,0,0-2-2H13V12Z"
    })), _path16$n || (_path16$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0353,12.0353,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14.0412,14.0412,0,0,0,16,2Z"
    })), children);
  });
  var Currency20 = /*#__PURE__*/React__default['default'].forwardRef(function Currency20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$n || (_path17$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12V10H17V7H15v3H13a2.002,2.002,0,0,0-2,2v3a2.002,2.002,0,0,0,2,2h6v3H11v2h4v3h2V22h2a2.0023,2.0023,0,0,0,2-2V17a2.002,2.002,0,0,0-2-2H13V12Z"
    })), _path18$n || (_path18$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0353,12.0353,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14.0412,14.0412,0,0,0,16,2Z"
    })), children);
  });
  var Currency16 = /*#__PURE__*/React__default['default'].forwardRef(function Currency16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$n || (_path19$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,12V10H17V7H15v3H13a2.002,2.002,0,0,0-2,2v3a2.002,2.002,0,0,0,2,2h6v3H11v2h4v3h2V22h2a2.0023,2.0023,0,0,0,2-2V17a2.002,2.002,0,0,0-2-2H13V12Z"
    })), _path20$n || (_path20$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0353,12.0353,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14.0412,14.0412,0,0,0,16,2Z"
    })), children);
  });
  var CurrencyBaht32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyBaht32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$n || (_path21$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4023,15.6426A4.9727,4.9727,0,0,0,23,12V11a5.0059,5.0059,0,0,0-5-5H17V3H15V6H10V26h5v3h2V26h2a5.0059,5.0059,0,0,0,5-5V20A4.9834,4.9834,0,0,0,21.4023,15.6426ZM12,8h6a3.0033,3.0033,0,0,1,3,3v1a3.0033,3.0033,0,0,1-3,3H12ZM22,21a3.0033,3.0033,0,0,1-3,3H12V17h7a3.0033,3.0033,0,0,1,3,3Z"
    })), children);
  });
  var CurrencyBaht24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyBaht24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$n || (_path22$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4023,15.6426A4.9727,4.9727,0,0,0,23,12V11a5.0059,5.0059,0,0,0-5-5H17V3H15V6H10V26h5v3h2V26h2a5.0059,5.0059,0,0,0,5-5V20A4.9834,4.9834,0,0,0,21.4023,15.6426ZM12,8h6a3.0033,3.0033,0,0,1,3,3v1a3.0033,3.0033,0,0,1-3,3H12ZM22,21a3.0033,3.0033,0,0,1-3,3H12V17h7a3.0033,3.0033,0,0,1,3,3Z"
    })), children);
  });
  var CurrencyBaht20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyBaht20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$n || (_path23$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4023,15.6426A4.9727,4.9727,0,0,0,23,12V11a5.0059,5.0059,0,0,0-5-5H17V3H15V6H10V26h5v3h2V26h2a5.0059,5.0059,0,0,0,5-5V20A4.9834,4.9834,0,0,0,21.4023,15.6426ZM12,8h6a3.0033,3.0033,0,0,1,3,3v1a3.0033,3.0033,0,0,1-3,3H12ZM22,21a3.0033,3.0033,0,0,1-3,3H12V17h7a3.0033,3.0033,0,0,1,3,3Z"
    })), children);
  });
  var CurrencyBaht16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyBaht16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$n || (_path24$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4023,15.6426A4.9727,4.9727,0,0,0,23,12V11a5.0059,5.0059,0,0,0-5-5H17V3H15V6H10V26h5v3h2V26h2a5.0059,5.0059,0,0,0,5-5V20A4.9834,4.9834,0,0,0,21.4023,15.6426ZM12,8h6a3.0033,3.0033,0,0,1,3,3v1a3.0033,3.0033,0,0,1-3,3H12ZM22,21a3.0033,3.0033,0,0,1-3,3H12V17h7a3.0033,3.0033,0,0,1,3,3Z"
    })), children);
  });
  var CurrencyDollar32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyDollar32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$n || (_path25$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20.5151c0-4.6152-3.78-5.1411-6.8171-5.563-3.31-.4609-5.1829-.86-5.1829-3.71C11,8.8491,13.5071,8,15.6538,8a6.7538,6.7538,0,0,1,5.5681,2.6279l1.5562-1.2558A8.6508,8.6508,0,0,0,17,6.0962V3H15V6.022c-3.6152.2192-6,2.26-6,5.22,0,4.73,3.83,5.2627,6.9075,5.69C19.16,17.3848,21,17.7744,21,20.5151,21,23.5474,17.8674,24,16,24c-3.4294,0-4.8782-.9639-6.2219-2.6279L8.2219,22.6279A8.4382,8.4382,0,0,0,15,25.9648V29h2V25.9551C20.7256,25.6509,23,23.6279,23,20.5151Z"
    })), children);
  });
  var CurrencyDollar24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyDollar24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$n || (_path26$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20.5151c0-4.6152-3.78-5.1411-6.8171-5.563-3.31-.4609-5.1829-.86-5.1829-3.71C11,8.8491,13.5071,8,15.6538,8a6.7538,6.7538,0,0,1,5.5681,2.6279l1.5562-1.2558A8.6508,8.6508,0,0,0,17,6.0962V3H15V6.022c-3.6152.2192-6,2.26-6,5.22,0,4.73,3.83,5.2627,6.9075,5.69C19.16,17.3848,21,17.7744,21,20.5151,21,23.5474,17.8674,24,16,24c-3.4294,0-4.8782-.9639-6.2219-2.6279L8.2219,22.6279A8.4382,8.4382,0,0,0,15,25.9648V29h2V25.9551C20.7256,25.6509,23,23.6279,23,20.5151Z"
    })), children);
  });
  var CurrencyDollar20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyDollar20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$n || (_path27$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20.5151c0-4.6152-3.78-5.1411-6.8171-5.563-3.31-.4609-5.1829-.86-5.1829-3.71C11,8.8491,13.5071,8,15.6538,8a6.7538,6.7538,0,0,1,5.5681,2.6279l1.5562-1.2558A8.6508,8.6508,0,0,0,17,6.0962V3H15V6.022c-3.6152.2192-6,2.26-6,5.22,0,4.73,3.83,5.2627,6.9075,5.69C19.16,17.3848,21,17.7744,21,20.5151,21,23.5474,17.8674,24,16,24c-3.4294,0-4.8782-.9639-6.2219-2.6279L8.2219,22.6279A8.4382,8.4382,0,0,0,15,25.9648V29h2V25.9551C20.7256,25.6509,23,23.6279,23,20.5151Z"
    })), children);
  });
  var CurrencyDollar16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyDollar16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$n || (_path28$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20.5151c0-4.6152-3.78-5.1411-6.8171-5.563-3.31-.4609-5.1829-.86-5.1829-3.71C11,8.8491,13.5071,8,15.6538,8a6.7538,6.7538,0,0,1,5.5681,2.6279l1.5562-1.2558A8.6508,8.6508,0,0,0,17,6.0962V3H15V6.022c-3.6152.2192-6,2.26-6,5.22,0,4.73,3.83,5.2627,6.9075,5.69C19.16,17.3848,21,17.7744,21,20.5151,21,23.5474,17.8674,24,16,24c-3.4294,0-4.8782-.9639-6.2219-2.6279L8.2219,22.6279A8.4382,8.4382,0,0,0,15,25.9648V29h2V25.9551C20.7256,25.6509,23,23.6279,23,20.5151Z"
    })), children);
  });
  var CurrencyEuro32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyEuro32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$n || (_path29$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,26c-3.6162,0-6.3328-2.2974-7.4456-6H19V18H9.1321A15.2782,15.2782,0,0,1,9,16c0-.33.01-.6641.0259-1H19V13H9.2371C9.8447,9.3525,11.81,6,17,6c3.8533,0,5.5315,1.6465,7.1282,4.4893l1.7436-.9786C24.2649,6.6484,22.0779,4,17,4,10.6448,4,7,8.374,7,16c0,7.0654,4.1121,12,10,12,5.0779,0,7.2649-2.6484,8.8718-5.5107l-1.7436-.9786C22.5315,24.3535,20.8533,26,17,26Z"
    })), children);
  });
  var CurrencyEuro24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyEuro24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$n || (_path30$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,26c-3.6162,0-6.3328-2.2974-7.4456-6H19V18H9.1321A15.2782,15.2782,0,0,1,9,16c0-.33.01-.6641.0259-1H19V13H9.2371C9.8447,9.3525,11.81,6,17,6c3.8533,0,5.5315,1.6465,7.1282,4.4893l1.7436-.9786C24.2649,6.6484,22.0779,4,17,4,10.6448,4,7,8.374,7,16c0,7.0654,4.1121,12,10,12,5.0779,0,7.2649-2.6484,8.8718-5.5107l-1.7436-.9786C22.5315,24.3535,20.8533,26,17,26Z"
    })), children);
  });
  var CurrencyEuro20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyEuro20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$n || (_path31$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,26c-3.6162,0-6.3328-2.2974-7.4456-6H19V18H9.1321A15.2782,15.2782,0,0,1,9,16c0-.33.01-.6641.0259-1H19V13H9.2371C9.8447,9.3525,11.81,6,17,6c3.8533,0,5.5315,1.6465,7.1282,4.4893l1.7436-.9786C24.2649,6.6484,22.0779,4,17,4,10.6448,4,7,8.374,7,16c0,7.0654,4.1121,12,10,12,5.0779,0,7.2649-2.6484,8.8718-5.5107l-1.7436-.9786C22.5315,24.3535,20.8533,26,17,26Z"
    })), children);
  });
  var CurrencyEuro16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyEuro16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$n || (_path32$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,26c-3.6162,0-6.3328-2.2974-7.4456-6H19V18H9.1321A15.2782,15.2782,0,0,1,9,16c0-.33.01-.6641.0259-1H19V13H9.2371C9.8447,9.3525,11.81,6,17,6c3.8533,0,5.5315,1.6465,7.1282,4.4893l1.7436-.9786C24.2649,6.6484,22.0779,4,17,4,10.6448,4,7,8.374,7,16c0,7.0654,4.1121,12,10,12,5.0779,0,7.2649-2.6484,8.8718-5.5107l-1.7436-.9786C22.5315,24.3535,20.8533,26,17,26Z"
    })), children);
  });
  var CurrencyLira32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyLira32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$n || (_path33$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,19a6.0066,6.0066,0,0,1-6,6H13V18.1079L21.2139,15V13L13,16.1079v-3L21.2139,10V8L13,11.1079V5H11v6.8647L8,13v2l3-1.1353v3L8,18v2l3-1.1353V27h6a8.0092,8.0092,0,0,0,8-8Z"
    })), children);
  });
  var CurrencyLira24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyLira24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$n || (_path34$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,19a6.0066,6.0066,0,0,1-6,6H13V18.1079L21.2139,15V13L13,16.1079v-3L21.2139,10V8L13,11.1079V5H11v6.8647L8,13v2l3-1.1353v3L8,18v2l3-1.1353V27h6a8.0092,8.0092,0,0,0,8-8Z"
    })), children);
  });
  var CurrencyLira20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyLira20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$n || (_path35$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,19a6.0066,6.0066,0,0,1-6,6H13V18.1079L21.2139,15V13L13,16.1079v-3L21.2139,10V8L13,11.1079V5H11v6.8647L8,13v2l3-1.1353v3L8,18v2l3-1.1353V27h6a8.0092,8.0092,0,0,0,8-8Z"
    })), children);
  });
  var CurrencyLira16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyLira16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$n || (_path36$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,19a6.0066,6.0066,0,0,1-6,6H13V18.1079L21.2139,15V13L13,16.1079v-3L21.2139,10V8L13,11.1079V5H11v6.8647L8,13v2l3-1.1353v3L8,18v2l3-1.1353V27h6a8.0092,8.0092,0,0,0,8-8Z"
    })), children);
  });
  var CurrencyPound32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyPound32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$n || (_path37$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4531,25A8.7775,8.7775,0,0,0,14,20a10.6,10.6,0,0,0-.18-2H22V16H13.2175c-.0842-.2109-.17-.4194-.2556-.624A9.8586,9.8586,0,0,1,12,11a4.792,4.792,0,0,1,5-5,6.1234,6.1234,0,0,1,5.2222,2.6279l1.5556-1.2558A8.11,8.11,0,0,0,17,4a6.7781,6.7781,0,0,0-7,7,11.65,11.65,0,0,0,1.0559,5H8v2h3.7729A8.209,8.209,0,0,1,12,20c0,2.5234-1.4858,5-3,5v2H24V25Z"
    })), children);
  });
  var CurrencyPound24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyPound24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$n || (_path38$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4531,25A8.7775,8.7775,0,0,0,14,20a10.6,10.6,0,0,0-.18-2H22V16H13.2175c-.0842-.2109-.17-.4194-.2556-.624A9.8586,9.8586,0,0,1,12,11a4.792,4.792,0,0,1,5-5,6.1234,6.1234,0,0,1,5.2222,2.6279l1.5556-1.2558A8.11,8.11,0,0,0,17,4a6.7781,6.7781,0,0,0-7,7,11.65,11.65,0,0,0,1.0559,5H8v2h3.7729A8.209,8.209,0,0,1,12,20c0,2.5234-1.4858,5-3,5v2H24V25Z"
    })), children);
  });
  var CurrencyPound20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyPound20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$n || (_path39$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4531,25A8.7775,8.7775,0,0,0,14,20a10.6,10.6,0,0,0-.18-2H22V16H13.2175c-.0842-.2109-.17-.4194-.2556-.624A9.8586,9.8586,0,0,1,12,11a4.792,4.792,0,0,1,5-5,6.1234,6.1234,0,0,1,5.2222,2.6279l1.5556-1.2558A8.11,8.11,0,0,0,17,4a6.7781,6.7781,0,0,0-7,7,11.65,11.65,0,0,0,1.0559,5H8v2h3.7729A8.209,8.209,0,0,1,12,20c0,2.5234-1.4858,5-3,5v2H24V25Z"
    })), children);
  });
  var CurrencyPound16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyPound16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$n || (_path40$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.4531,25A8.7775,8.7775,0,0,0,14,20a10.6,10.6,0,0,0-.18-2H22V16H13.2175c-.0842-.2109-.17-.4194-.2556-.624A9.8586,9.8586,0,0,1,12,11a4.792,4.792,0,0,1,5-5,6.1234,6.1234,0,0,1,5.2222,2.6279l1.5556-1.2558A8.11,8.11,0,0,0,17,4a6.7781,6.7781,0,0,0-7,7,11.65,11.65,0,0,0,1.0559,5H8v2h3.7729A8.209,8.209,0,0,1,12,20c0,2.5234-1.4858,5-3,5v2H24V25Z"
    })), children);
  });
  var CurrencyRuble32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRuble32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$n || (_path41$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4H10V15H7v2h3v3H7v2h3v6h2V22h9V20H12V17h7a6.0067,6.0067,0,0,0,6-6V10A6.0067,6.0067,0,0,0,19,4Zm4,7a4.0045,4.0045,0,0,1-4,4H12V6h7a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CurrencyRuble24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRuble24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$n || (_path42$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4H10V15H7v2h3v3H7v2h3v6h2V22h9V20H12V17h7a6.0067,6.0067,0,0,0,6-6V10A6.0067,6.0067,0,0,0,19,4Zm4,7a4.0045,4.0045,0,0,1-4,4H12V6h7a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CurrencyRuble20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRuble20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$n || (_path43$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4H10V15H7v2h3v3H7v2h3v6h2V22h9V20H12V17h7a6.0067,6.0067,0,0,0,6-6V10A6.0067,6.0067,0,0,0,19,4Zm4,7a4.0045,4.0045,0,0,1-4,4H12V6h7a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CurrencyRuble16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRuble16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$n || (_path44$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4H10V15H7v2h3v3H7v2h3v6h2V22h9V20H12V17h7a6.0067,6.0067,0,0,0,6-6V10A6.0067,6.0067,0,0,0,19,4Zm4,7a4.0045,4.0045,0,0,1-4,4H12V6h7a4.0045,4.0045,0,0,1,4,4Z"
    })), children);
  });
  var CurrencyRupee32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRupee32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$n || (_path45$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,7V5H8V7h5.5a4.4906,4.4906,0,0,1,4.45,4H8v2h9.95A4.4906,4.4906,0,0,1,13.5,17H8v2.3452L17.6169,28l1.3379-1.4863L10.606,19H13.5a6.5041,6.5041,0,0,0,6.4746-6H24V11H19.9746A6.4719,6.4719,0,0,0,18.18,7Z"
    })), children);
  });
  var CurrencyRupee24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRupee24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$n || (_path46$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,7V5H8V7h5.5a4.4906,4.4906,0,0,1,4.45,4H8v2h9.95A4.4906,4.4906,0,0,1,13.5,17H8v2.3452L17.6169,28l1.3379-1.4863L10.606,19H13.5a6.5041,6.5041,0,0,0,6.4746-6H24V11H19.9746A6.4719,6.4719,0,0,0,18.18,7Z"
    })), children);
  });
  var CurrencyRupee20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRupee20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$n || (_path47$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,7V5H8V7h5.5a4.4906,4.4906,0,0,1,4.45,4H8v2h9.95A4.4906,4.4906,0,0,1,13.5,17H8v2.3452L17.6169,28l1.3379-1.4863L10.606,19H13.5a6.5041,6.5041,0,0,0,6.4746-6H24V11H19.9746A6.4719,6.4719,0,0,0,18.18,7Z"
    })), children);
  });
  var CurrencyRupee16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyRupee16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$n || (_path48$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,7V5H8V7h5.5a4.4906,4.4906,0,0,1,4.45,4H8v2h9.95A4.4906,4.4906,0,0,1,13.5,17H8v2.3452L17.6169,28l1.3379-1.4863L10.606,19H13.5a6.5041,6.5041,0,0,0,6.4746-6H24V11H19.9746A6.4719,6.4719,0,0,0,18.18,7Z"
    })), children);
  });
  var CurrencyShekel32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyShekel32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$n || (_path49$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,27H7V5h8a5.0057,5.0057,0,0,1,5,5V22H18V10a3.0033,3.0033,0,0,0-3-3H9Z"
    })), _path50$n || (_path50$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H12V10h2V25h6a3.0033,3.0033,0,0,0,3-3V5h2V22A5.0057,5.0057,0,0,1,20,27Z"
    })), children);
  });
  var CurrencyShekel24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyShekel24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$n || (_path51$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,27H7V5h8a5.0057,5.0057,0,0,1,5,5V22H18V10a3.0033,3.0033,0,0,0-3-3H9Z"
    })), _path52$n || (_path52$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H12V10h2V25h6a3.0033,3.0033,0,0,0,3-3V5h2V22A5.0057,5.0057,0,0,1,20,27Z"
    })), children);
  });
  var CurrencyShekel20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyShekel20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$n || (_path53$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,27H7V5h8a5.0057,5.0057,0,0,1,5,5V22H18V10a3.0033,3.0033,0,0,0-3-3H9Z"
    })), _path54$n || (_path54$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H12V10h2V25h6a3.0033,3.0033,0,0,0,3-3V5h2V22A5.0057,5.0057,0,0,1,20,27Z"
    })), children);
  });
  var CurrencyShekel16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyShekel16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$n || (_path55$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,27H7V5h8a5.0057,5.0057,0,0,1,5,5V22H18V10a3.0033,3.0033,0,0,0-3-3H9Z"
    })), _path56$n || (_path56$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H12V10h2V25h6a3.0033,3.0033,0,0,0,3-3V5h2V22A5.0057,5.0057,0,0,1,20,27Z"
    })), children);
  });
  var CurrencyWon32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyWon32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$n || (_path57$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14L28 12 23.045 12 24 5 22 5 20 23 17 8 15 8 12 23 10 5 8 5 8.955 12 4 12 4 14 9.227 14 9.636 17 4 17 4 19 9.909 19 11 27 13 27 16 12 19 27 21 27 22.091 19 28 19 28 17 22.364 17 22.773 14 28 14z"
    })), children);
  });
  var CurrencyWon24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyWon24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$n || (_path58$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14L28 12 23.045 12 24 5 22 5 20 23 17 8 15 8 12 23 10 5 8 5 8.955 12 4 12 4 14 9.227 14 9.636 17 4 17 4 19 9.909 19 11 27 13 27 16 12 19 27 21 27 22.091 19 28 19 28 17 22.364 17 22.773 14 28 14z"
    })), children);
  });
  var CurrencyWon20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyWon20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$n || (_path59$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14L28 12 23.045 12 24 5 22 5 20 23 17 8 15 8 12 23 10 5 8 5 8.955 12 4 12 4 14 9.227 14 9.636 17 4 17 4 19 9.909 19 11 27 13 27 16 12 19 27 21 27 22.091 19 28 19 28 17 22.364 17 22.773 14 28 14z"
    })), children);
  });
  var CurrencyWon16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyWon16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$n || (_path60$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 14L28 12 23.045 12 24 5 22 5 20 23 17 8 15 8 12 23 10 5 8 5 8.955 12 4 12 4 14 9.227 14 9.636 17 4 17 4 19 9.909 19 11 27 13 27 16 12 19 27 21 27 22.091 19 28 19 28 17 22.364 17 22.773 14 28 14z"
    })), children);
  });
  var CurrencyYen32 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyYen32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$n || (_path61$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.271 5L22 5 16 16 10 5 7.729 5 13.794 16 8 16 8 18 15 18 15 21 8 21 8 23 15 23 15 27 17 27 17 23 24 23 24 21 17 21 17 18 24 18 24 16 18.206 16 24.271 5z"
    })), children);
  });
  var CurrencyYen24 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyYen24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$n || (_path62$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.271 5L22 5 16 16 10 5 7.729 5 13.794 16 8 16 8 18 15 18 15 21 8 21 8 23 15 23 15 27 17 27 17 23 24 23 24 21 17 21 17 18 24 18 24 16 18.206 16 24.271 5z"
    })), children);
  });
  var CurrencyYen20 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyYen20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$n || (_path63$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.271 5L22 5 16 16 10 5 7.729 5 13.794 16 8 16 8 18 15 18 15 21 8 21 8 23 15 23 15 27 17 27 17 23 24 23 24 21 17 21 17 18 24 18 24 16 18.206 16 24.271 5z"
    })), children);
  });
  var CurrencyYen16 = /*#__PURE__*/React__default['default'].forwardRef(function CurrencyYen16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$n || (_path64$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.271 5L22 5 16 16 10 5 7.729 5 13.794 16 8 16 8 18 15 18 15 21 8 21 8 23 15 23 15 27 17 27 17 23 24 23 24 21 17 21 17 18 24 18 24 16 18.206 16 24.271 5z"
    })), children);
  });
  var Cursor_132 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_132(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$n || (_path65$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"
    })), children);
  });
  var Cursor_124 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_124(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$n || (_path66$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"
    })), children);
  });
  var Cursor_120 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_120(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$n || (_path67$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"
    })), children);
  });
  var Cursor_116 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_116(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$n || (_path68$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"
    })), children);
  });
  var Cursor_232 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_232(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$n || (_path69$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"
    })), children);
  });
  var Cursor_224 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_224(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$n || (_path70$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"
    })), children);
  });
  var Cursor_220 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_220(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$n || (_path71$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"
    })), children);
  });
  var Cursor_216 = /*#__PURE__*/React__default['default'].forwardRef(function Cursor_216(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$n || (_path72$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"
    })), children);
  });
  var Cut32 = /*#__PURE__*/React__default['default'].forwardRef(function Cut32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$n || (_path73$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"
    })), children);
  });
  var Cut24 = /*#__PURE__*/React__default['default'].forwardRef(function Cut24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$n || (_path74$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"
    })), children);
  });
  var Cut20 = /*#__PURE__*/React__default['default'].forwardRef(function Cut20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$n || (_path75$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"
    })), children);
  });
  var Cut16 = /*#__PURE__*/React__default['default'].forwardRef(function Cut16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$n || (_path76$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"
    })), children);
  });
  var WatsonHealthCutInHalf32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCutInHalf32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$n || (_path77$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H16V26H4Z"
    })), children);
  });
  var WatsonHealthCutInHalf24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCutInHalf24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$n || (_path78$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H16V26H4Z"
    })), children);
  });
  var WatsonHealthCutInHalf20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCutInHalf20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$n || (_path79$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H16V26H4Z"
    })), children);
  });
  var WatsonHealthCutInHalf16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthCutInHalf16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$n || (_path80$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H16V26H4Z"
    })), children);
  });
  var CutOut32 = /*#__PURE__*/React__default['default'].forwardRef(function CutOut32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$n || (_path81$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.05 13.7326L18.05 12 7.928 17.8457 6.9312 17.27a2.9524 2.9524 0 00.6672-.769A3 3 0 103.5 17.5986l2.428 1.4019L3.5 20.4023a3.0342 3.0342 0 103.4407.3223l.987-.5693L14.5914 24l1-1.7294-5.6634-3.27zM4.0344 15.26a1 1 0 11.4658.6069A.9929.9929 0 014.0344 15.26zM4.9988 22a1 1 0 11-.8645 1.5A1 1 0 014.9988 22zM17 26H21V28H17zM10 26H14V28H10z"
    })), _path82$n || (_path82$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H24V26h4V4H7V8H5V4A2.0023,2.0023,0,0,1,7,2H28a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,28,28Z"
    })), children);
  });
  var CutOut24 = /*#__PURE__*/React__default['default'].forwardRef(function CutOut24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$n || (_path83$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.05 13.7326L18.05 12 7.928 17.8457 6.9312 17.27a2.9524 2.9524 0 00.6672-.769A3 3 0 103.5 17.5986l2.428 1.4019L3.5 20.4023a3.0342 3.0342 0 103.4407.3223l.987-.5693L14.5914 24l1-1.7294-5.6634-3.27zM4.0344 15.26a1 1 0 11.4658.6069A.9929.9929 0 014.0344 15.26zM4.9988 22a1 1 0 11-.8645 1.5A1 1 0 014.9988 22zM17 26H21V28H17zM10 26H14V28H10z"
    })), _path84$n || (_path84$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H24V26h4V4H7V8H5V4A2.0023,2.0023,0,0,1,7,2H28a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,28,28Z"
    })), children);
  });
  var CutOut20 = /*#__PURE__*/React__default['default'].forwardRef(function CutOut20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$n || (_path85$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.05 13.7326L18.05 12 7.928 17.8457 6.9312 17.27a2.9524 2.9524 0 00.6672-.769A3 3 0 103.5 17.5986l2.428 1.4019L3.5 20.4023a3.0342 3.0342 0 103.4407.3223l.987-.5693L14.5914 24l1-1.7294-5.6634-3.27zM4.0344 15.26a1 1 0 11.4658.6069A.9929.9929 0 014.0344 15.26zM4.9988 22a1 1 0 11-.8645 1.5A1 1 0 014.9988 22zM17 26H21V28H17zM10 26H14V28H10z"
    })), _path86$n || (_path86$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H24V26h4V4H7V8H5V4A2.0023,2.0023,0,0,1,7,2H28a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,28,28Z"
    })), children);
  });
  var CutOut16 = /*#__PURE__*/React__default['default'].forwardRef(function CutOut16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$n || (_path87$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.05 13.7326L18.05 12 7.928 17.8457 6.9312 17.27a2.9524 2.9524 0 00.6672-.769A3 3 0 103.5 17.5986l2.428 1.4019L3.5 20.4023a3.0342 3.0342 0 103.4407.3223l.987-.5693L14.5914 24l1-1.7294-5.6634-3.27zM4.0344 15.26a1 1 0 11.4658.6069A.9929.9929 0 014.0344 15.26zM4.9988 22a1 1 0 11-.8645 1.5A1 1 0 014.9988 22zM17 26H21V28H17zM10 26H14V28H10z"
    })), _path88$n || (_path88$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H24V26h4V4H7V8H5V4A2.0023,2.0023,0,0,1,7,2H28a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,28,28Z"
    })), children);
  });
  var QCY32 = /*#__PURE__*/React__default['default'].forwardRef(function QCY32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$n || (_path89$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 23H10a2 2 0 01-2-2V15a2 2 0 012-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"
    })), children);
  });
  var QCY24 = /*#__PURE__*/React__default['default'].forwardRef(function QCY24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$n || (_path90$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 23H10a2 2 0 01-2-2V15a2 2 0 012-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"
    })), children);
  });
  var QCY20 = /*#__PURE__*/React__default['default'].forwardRef(function QCY20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$n || (_path91$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 23H10a2 2 0 01-2-2V15a2 2 0 012-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"
    })), children);
  });
  var QCY16 = /*#__PURE__*/React__default['default'].forwardRef(function QCY16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$n || (_path92$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 23H10a2 2 0 01-2-2V15a2 2 0 012-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"
    })), children);
  });
  var Cyclist32 = /*#__PURE__*/React__default['default'].forwardRef(function Cyclist32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$n || (_path93$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a6 6 0 116-6A6.0069 6.0069 0 0125 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0025 20zM7 30a6 6 0 116-6A6.0069 6.0069 0 017 30zM7 20a4 4 0 104 4A4.0045 4.0045 0 007 20z"
    })), _path94$n || (_path94$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27H15V20.4139L9.5849 15a2.003 2.003 0 010-2.8292l4.5859-4.5859a2.0024 2.0024 0 012.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1125 4.5 3.5042 3.5042 0 0121.5 8zm0-5A1.5 1.5 0 1023 4.5 1.5017 1.5017 0 0021.5 3z"
    })), children);
  });
  var Cyclist24 = /*#__PURE__*/React__default['default'].forwardRef(function Cyclist24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$n || (_path95$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a6 6 0 116-6A6.0069 6.0069 0 0125 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0025 20zM7 30a6 6 0 116-6A6.0069 6.0069 0 017 30zM7 20a4 4 0 104 4A4.0045 4.0045 0 007 20z"
    })), _path96$n || (_path96$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27H15V20.4139L9.5849 15a2.003 2.003 0 010-2.8292l4.5859-4.5859a2.0024 2.0024 0 012.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1125 4.5 3.5042 3.5042 0 0121.5 8zm0-5A1.5 1.5 0 1023 4.5 1.5017 1.5017 0 0021.5 3z"
    })), children);
  });
  var Cyclist20 = /*#__PURE__*/React__default['default'].forwardRef(function Cyclist20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$n || (_path97$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a6 6 0 116-6A6.0069 6.0069 0 0125 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0025 20zM7 30a6 6 0 116-6A6.0069 6.0069 0 017 30zM7 20a4 4 0 104 4A4.0045 4.0045 0 007 20z"
    })), _path98$n || (_path98$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27H15V20.4139L9.5849 15a2.003 2.003 0 010-2.8292l4.5859-4.5859a2.0024 2.0024 0 012.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1125 4.5 3.5042 3.5042 0 0121.5 8zm0-5A1.5 1.5 0 1023 4.5 1.5017 1.5017 0 0021.5 3z"
    })), children);
  });
  var Cyclist16 = /*#__PURE__*/React__default['default'].forwardRef(function Cyclist16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$n || (_path99$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a6 6 0 116-6A6.0069 6.0069 0 0125 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0025 20zM7 30a6 6 0 116-6A6.0069 6.0069 0 017 30zM7 20a4 4 0 104 4A4.0045 4.0045 0 007 20z"
    })), _path100$n || (_path100$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27H15V20.4139L9.5849 15a2.003 2.003 0 010-2.8292l4.5859-4.5859a2.0024 2.0024 0 012.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1125 4.5 3.5042 3.5042 0 0121.5 8zm0-5A1.5 1.5 0 1023 4.5 1.5017 1.5017 0 0021.5 3z"
    })), children);
  });
  var QCZ32 = /*#__PURE__*/React__default['default'].forwardRef(function QCZ32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$n || (_path101$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H9a2 2 0 01-2-2V15a2 2 0 012-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"
    })), children);
  });
  var QCZ24 = /*#__PURE__*/React__default['default'].forwardRef(function QCZ24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$n || (_path102$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H9a2 2 0 01-2-2V15a2 2 0 012-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"
    })), children);
  });
  var QCZ20 = /*#__PURE__*/React__default['default'].forwardRef(function QCZ20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$n || (_path103$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H9a2 2 0 01-2-2V15a2 2 0 012-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"
    })), children);
  });
  var QCZ16 = /*#__PURE__*/React__default['default'].forwardRef(function QCZ16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$n || (_path104$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H9a2 2 0 01-2-2V15a2 2 0 012-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"
    })), children);
  });
  var Dashboard32 = /*#__PURE__*/React__default['default'].forwardRef(function Dashboard32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$n || (_path105$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 01-5-5H8a3 3 0 103-3V16a5 5 0 010 10z"
    })), _path106$n || (_path106$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"
    })), children);
  });
  var Dashboard24 = /*#__PURE__*/React__default['default'].forwardRef(function Dashboard24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$n || (_path107$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 01-5-5H8a3 3 0 103-3V16a5 5 0 010 10z"
    })), _path108$n || (_path108$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"
    })), children);
  });
  var Dashboard20 = /*#__PURE__*/React__default['default'].forwardRef(function Dashboard20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$n || (_path109$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 01-5-5H8a3 3 0 103-3V16a5 5 0 010 10z"
    })), _path110$n || (_path110$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"
    })), children);
  });
  var Dashboard16 = /*#__PURE__*/React__default['default'].forwardRef(function Dashboard16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$n || (_path111$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 01-5-5H8a3 3 0 103-3V16a5 5 0 010 10z"
    })), _path112$n || (_path112$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"
    })), children);
  });
  var DashboardReference32 = /*#__PURE__*/React__default['default'].forwardRef(function DashboardReference32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$n || (_path113$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 21H26V26H24zM20 16H22V26H20zM16 18H18V26H16z"
    })), _path114$n || (_path114$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V16H4V13H28.001l.001,15H16v2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM12,11H4V4h8Zm2,0V4H28l.0007,7Z"
    })), children);
  });
  var DashboardReference24 = /*#__PURE__*/React__default['default'].forwardRef(function DashboardReference24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$n || (_path115$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 21H26V26H24zM20 16H22V26H20zM16 18H18V26H16z"
    })), _path116$n || (_path116$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V16H4V13H28.001l.001,15H16v2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM12,11H4V4h8Zm2,0V4H28l.0007,7Z"
    })), children);
  });
  var DashboardReference20 = /*#__PURE__*/React__default['default'].forwardRef(function DashboardReference20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$n || (_path117$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 21H26V26H24zM20 16H22V26H20zM16 18H18V26H16z"
    })), _path118$n || (_path118$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V16H4V13H28.001l.001,15H16v2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM12,11H4V4h8Zm2,0V4H28l.0007,7Z"
    })), children);
  });
  var DashboardReference16 = /*#__PURE__*/React__default['default'].forwardRef(function DashboardReference16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$n || (_path119$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 21H26V26H24zM20 16H22V26H20zM16 18H18V26H16z"
    })), _path120$n || (_path120$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.002,2.002,0,0,0,2,4V16H4V13H28.001l.001,15H16v2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2ZM12,11H4V4h8Zm2,0V4H28l.0007,7Z"
    })), children);
  });
  var Data_132 = /*#__PURE__*/React__default['default'].forwardRef(function Data_132(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$n || (_path121$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 114-4A4 4 0 017 11zM7 5A2 2 0 109 7 2 2 0 007 5zM7 29a4 4 0 114-4A4 4 0 017 29zm0-6a2 2 0 102 2A2 2 0 007 23zM25 20a4 4 0 114-4A4 4 0 0125 20zm0-6a2 2 0 102 2A2 2 0 0025 14z"
    })), children);
  });
  var Data_124 = /*#__PURE__*/React__default['default'].forwardRef(function Data_124(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$n || (_path122$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 114-4A4 4 0 017 11zM7 5A2 2 0 109 7 2 2 0 007 5zM7 29a4 4 0 114-4A4 4 0 017 29zm0-6a2 2 0 102 2A2 2 0 007 23zM25 20a4 4 0 114-4A4 4 0 0125 20zm0-6a2 2 0 102 2A2 2 0 0025 14z"
    })), children);
  });
  var Data_120 = /*#__PURE__*/React__default['default'].forwardRef(function Data_120(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$n || (_path123$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 114-4A4 4 0 017 11zM7 5A2 2 0 109 7 2 2 0 007 5zM7 29a4 4 0 114-4A4 4 0 017 29zm0-6a2 2 0 102 2A2 2 0 007 23zM25 20a4 4 0 114-4A4 4 0 0125 20zm0-6a2 2 0 102 2A2 2 0 0025 14z"
    })), children);
  });
  var Data_116 = /*#__PURE__*/React__default['default'].forwardRef(function Data_116(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$n || (_path124$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 114-4A4 4 0 017 11zM7 5A2 2 0 109 7 2 2 0 007 5zM7 29a4 4 0 114-4A4 4 0 017 29zm0-6a2 2 0 102 2A2 2 0 007 23zM25 20a4 4 0 114-4A4 4 0 0125 20zm0-6a2 2 0 102 2A2 2 0 0025 14z"
    })), children);
  });
  var Data_232 = /*#__PURE__*/React__default['default'].forwardRef(function Data_232(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$n || (_path125$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"
    })), children);
  });
  var Data_224 = /*#__PURE__*/React__default['default'].forwardRef(function Data_224(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$n || (_path126$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"
    })), children);
  });
  var Data_220 = /*#__PURE__*/React__default['default'].forwardRef(function Data_220(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$n || (_path127$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"
    })), children);
  });
  var Data_216 = /*#__PURE__*/React__default['default'].forwardRef(function Data_216(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$n || (_path128$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"
    })), children);
  });
  var DataBase32 = /*#__PURE__*/React__default['default'].forwardRef(function DataBase32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$n || (_path129$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"
    })), _circle5$k || (_circle5$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle6$k || (_circle6$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle7$k || (_circle7$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), children);
  });
  var DataBase24 = /*#__PURE__*/React__default['default'].forwardRef(function DataBase24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$n || (_path130$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"
    })), _circle8$k || (_circle8$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle9$k || (_circle9$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle10$k || (_circle10$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), children);
  });
  var DataBase20 = /*#__PURE__*/React__default['default'].forwardRef(function DataBase20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$n || (_path131$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"
    })), _circle11$j || (_circle11$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle12$j || (_circle12$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle13$j || (_circle13$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), children);
  });
  var DataBase16 = /*#__PURE__*/React__default['default'].forwardRef(function DataBase16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$n || (_path132$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"
    })), _circle14$j || (_circle14$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle15$j || (_circle15$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle16$j || (_circle16$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), children);
  });
  var DataBaseAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function DataBaseAlt32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$n || (_path133$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 8H12V10H7zM7 12H12V14H7zM7 16H12V18H7zM20 8H25V10H20zM20 12H25V14H20zM20 16H25V18H20z"
    })), _path134$n || (_path134$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H15V28H4ZM17,28V6H28V28Z"
    })), children);
  });
  var DataBaseAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function DataBaseAlt24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$n || (_path135$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 8H12V10H7zM7 12H12V14H7zM7 16H12V18H7zM20 8H25V10H20zM20 12H25V14H20zM20 16H25V18H20z"
    })), _path136$n || (_path136$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H15V28H4ZM17,28V6H28V28Z"
    })), children);
  });
  var DataBaseAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function DataBaseAlt20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$n || (_path137$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 8H12V10H7zM7 12H12V14H7zM7 16H12V18H7zM20 8H25V10H20zM20 12H25V14H20zM20 16H25V18H20z"
    })), _path138$n || (_path138$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H15V28H4ZM17,28V6H28V28Z"
    })), children);
  });
  var DataBaseAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function DataBaseAlt16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$n || (_path139$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 8H12V10H7zM7 12H12V14H7zM7 16H12V18H7zM20 8H25V10H20zM20 12H25V14H20zM20 16H25V18H20z"
    })), _path140$n || (_path140$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4ZM4,6H15V28H4ZM17,28V6H28V28Z"
    })), children);
  });
  var DataCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function DataCenter32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$n || (_path141$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H23V6a2.0023,2.0023,0,0,0-2-2H11A2.0023,2.0023,0,0,0,9,6v4H4a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM4,28V12H9v2H7v2H9v2H7v2H9v2H7v2H9v4Zm17,0H11V6H21Zm7,0H23V24h2V22H23V20h2V18H23V16h2V14H23V12h5Z"
    })), _path142$n || (_path142$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H18V10H14zM14 12H18V14H14zM14 16H18V18H14z"
    })), children);
  });
  var DataCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function DataCenter24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$n || (_path143$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H23V6a2.0023,2.0023,0,0,0-2-2H11A2.0023,2.0023,0,0,0,9,6v4H4a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM4,28V12H9v2H7v2H9v2H7v2H9v2H7v2H9v4Zm17,0H11V6H21Zm7,0H23V24h2V22H23V20h2V18H23V16h2V14H23V12h5Z"
    })), _path144$n || (_path144$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H18V10H14zM14 12H18V14H14zM14 16H18V18H14z"
    })), children);
  });
  var DataCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function DataCenter20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$n || (_path145$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H23V6a2.0023,2.0023,0,0,0-2-2H11A2.0023,2.0023,0,0,0,9,6v4H4a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM4,28V12H9v2H7v2H9v2H7v2H9v2H7v2H9v4Zm17,0H11V6H21Zm7,0H23V24h2V22H23V20h2V18H23V16h2V14H23V12h5Z"
    })), _path146$n || (_path146$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H18V10H14zM14 12H18V14H14zM14 16H18V18H14z"
    })), children);
  });
  var DataCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function DataCenter16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$n || (_path147$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H23V6a2.0023,2.0023,0,0,0-2-2H11A2.0023,2.0023,0,0,0,9,6v4H4a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM4,28V12H9v2H7v2H9v2H7v2H9v2H7v2H9v4Zm17,0H11V6H21Zm7,0H23V24h2V22H23V20h2V18H23V16h2V14H23V12h5Z"
    })), _path148$n || (_path148$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 8H18V10H14zM14 12H18V14H14zM14 16H18V18H14z"
    })), children);
  });
  var DataCheck32 = /*#__PURE__*/React__default['default'].forwardRef(function DataCheck32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$n || (_path149$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), _circle17$i || (_circle17$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle18$i || (_circle18$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle19$i || (_circle19$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path150$n || (_path150$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), children);
  });
  var DataCheck24 = /*#__PURE__*/React__default['default'].forwardRef(function DataCheck24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$n || (_path151$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), _circle20$i || (_circle20$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle21$h || (_circle21$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle22$h || (_circle22$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path152$n || (_path152$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), children);
  });
  var DataCheck20 = /*#__PURE__*/React__default['default'].forwardRef(function DataCheck20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$n || (_path153$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), _circle23$g || (_circle23$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle24$g || (_circle24$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle25$f || (_circle25$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path154$n || (_path154$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), children);
  });
  var DataCheck16 = /*#__PURE__*/React__default['default'].forwardRef(function DataCheck16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$n || (_path155$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), _circle26$f || (_circle26$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle27$e || (_circle27$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle28$e || (_circle28$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path156$n || (_path156$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), children);
  });
  var DataConnected32 = /*#__PURE__*/React__default['default'].forwardRef(function DataConnected32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$n || (_path157$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), _path158$n || (_path158$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"
    })), _path159$n || (_path159$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"
    })), children);
  });
  var DataConnected24 = /*#__PURE__*/React__default['default'].forwardRef(function DataConnected24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$n);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$n || (_path160$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), _path161$n || (_path161$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"
    })), _path162$n || (_path162$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"
    })), children);
  });
  var DataConnected20 = /*#__PURE__*/React__default['default'].forwardRef(function DataConnected20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$n || (_path163$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), _path164$n || (_path164$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"
    })), _path165$n || (_path165$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"
    })), children);
  });
  var DataConnected16 = /*#__PURE__*/React__default['default'].forwardRef(function DataConnected16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$n || (_path166$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), _path167$n || (_path167$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"
    })), _path168$n || (_path168$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"
    })), children);
  });
  var DataError32 = /*#__PURE__*/React__default['default'].forwardRef(function DataError32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29$d || (_circle29$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle30$d || (_circle30$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle31$d || (_circle31$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path169$n || (_path169$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H18V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), _path170$n || (_path170$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 24.415L27.586 23 25 25.587 22.414 23 21 24.415 23.586 27 21 29.586 22.414 31 25 28.414 27.586 31 29 29.586 26.414 27 29 24.415z"
    })), children);
  });
  var DataError24 = /*#__PURE__*/React__default['default'].forwardRef(function DataError24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle32$d || (_circle32$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle33$c || (_circle33$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle34$b || (_circle34$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path171$n || (_path171$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H18V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), _path172$n || (_path172$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 24.415L27.586 23 25 25.587 22.414 23 21 24.415 23.586 27 21 29.586 22.414 31 25 28.414 27.586 31 29 29.586 26.414 27 29 24.415z"
    })), children);
  });
  var DataError20 = /*#__PURE__*/React__default['default'].forwardRef(function DataError20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle35$b || (_circle35$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle36$b || (_circle36$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle37$9 || (_circle37$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path173$n || (_path173$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H18V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), _path174$n || (_path174$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 24.415L27.586 23 25 25.587 22.414 23 21 24.415 23.586 27 21 29.586 22.414 31 25 28.414 27.586 31 29 29.586 26.414 27 29 24.415z"
    })), children);
  });
  var DataError16 = /*#__PURE__*/React__default['default'].forwardRef(function DataError16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle38$9 || (_circle38$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "8",
      r: "1"
    })), _circle39$9 || (_circle39$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "16",
      r: "1"
    })), _circle40$9 || (_circle40$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "24",
      r: "1"
    })), _path175$n || (_path175$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H18V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"
    })), _path176$n || (_path176$n = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 24.415L27.586 23 25 25.587 22.414 23 21 24.415 23.586 27 21 29.586 22.414 31 25 28.414 27.586 31 29 29.586 26.414 27 29 24.415z"
    })), children);
  });
  var DataFormat32 = /*#__PURE__*/React__default['default'].forwardRef(function DataFormat32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$m || (_path177$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 11H26V13H18zM6 19H14V21H6zM10 16a4 4 0 114-4A4.0045 4.0045 0 0110 16zm0-6a2 2 0 102 2A2.002 2.002 0 0010 10zM22 24a4 4 0 114-4A4.0045 4.0045 0 0122 24zm0-6a2 2 0 102 2A2.002 2.002 0 0022 18z"
    })), _path178$m || (_path178$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var DataFormat24 = /*#__PURE__*/React__default['default'].forwardRef(function DataFormat24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$m || (_path179$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 11H26V13H18zM6 19H14V21H6zM10 16a4 4 0 114-4A4.0045 4.0045 0 0110 16zm0-6a2 2 0 102 2A2.002 2.002 0 0010 10zM22 24a4 4 0 114-4A4.0045 4.0045 0 0122 24zm0-6a2 2 0 102 2A2.002 2.002 0 0022 18z"
    })), _path180$m || (_path180$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var DataFormat20 = /*#__PURE__*/React__default['default'].forwardRef(function DataFormat20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$m || (_path181$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 11H26V13H18zM6 19H14V21H6zM10 16a4 4 0 114-4A4.0045 4.0045 0 0110 16zm0-6a2 2 0 102 2A2.002 2.002 0 0010 10zM22 24a4 4 0 114-4A4.0045 4.0045 0 0122 24zm0-6a2 2 0 102 2A2.002 2.002 0 0022 18z"
    })), _path182$m || (_path182$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var DataFormat16 = /*#__PURE__*/React__default['default'].forwardRef(function DataFormat16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$m || (_path183$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 11H26V13H18zM6 19H14V21H6zM10 16a4 4 0 114-4A4.0045 4.0045 0 0110 16zm0-6a2 2 0 102 2A2.002 2.002 0 0010 10zM22 24a4 4 0 114-4A4.0045 4.0045 0 0122 24zm0-6a2 2 0 102 2A2.002 2.002 0 0022 18z"
    })), _path184$m || (_path184$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var DataReference32 = /*#__PURE__*/React__default['default'].forwardRef(function DataReference32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$m || (_path185$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.504 3.504 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM23.5 20A3.5 3.5 0 1120 23.5 3.504 3.504 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"
    })), children);
  });
  var DataReference24 = /*#__PURE__*/React__default['default'].forwardRef(function DataReference24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$m || (_path186$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.504 3.504 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM23.5 20A3.5 3.5 0 1120 23.5 3.504 3.504 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"
    })), children);
  });
  var DataReference20 = /*#__PURE__*/React__default['default'].forwardRef(function DataReference20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$m || (_path187$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.504 3.504 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM23.5 20A3.5 3.5 0 1120 23.5 3.504 3.504 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"
    })), children);
  });
  var DataReference16 = /*#__PURE__*/React__default['default'].forwardRef(function DataReference16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$m || (_path188$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.504 3.504 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM23.5 20A3.5 3.5 0 1120 23.5 3.504 3.504 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"
    })), children);
  });
  var DataSet32 = /*#__PURE__*/React__default['default'].forwardRef(function DataSet32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$m || (_path189$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.5 3.5 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM8.5 20A3.5 3.5 0 115 23.5 3.5 3.5 0 018.5 20m0-2A5.5 5.5 0 1014 23.5 5.5 5.5 0 008.5 18zM23.5 20A3.5 3.5 0 1120 23.5 3.5 3.5 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18z"
    })), children);
  });
  var DataSet24 = /*#__PURE__*/React__default['default'].forwardRef(function DataSet24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$m || (_path190$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.5 3.5 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM8.5 20A3.5 3.5 0 115 23.5 3.5 3.5 0 018.5 20m0-2A5.5 5.5 0 1014 23.5 5.5 5.5 0 008.5 18zM23.5 20A3.5 3.5 0 1120 23.5 3.5 3.5 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18z"
    })), children);
  });
  var DataSet20 = /*#__PURE__*/React__default['default'].forwardRef(function DataSet20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$m || (_path191$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.5 3.5 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM8.5 20A3.5 3.5 0 115 23.5 3.5 3.5 0 018.5 20m0-2A5.5 5.5 0 1014 23.5 5.5 5.5 0 008.5 18zM23.5 20A3.5 3.5 0 1120 23.5 3.5 3.5 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18z"
    })), children);
  });
  var DataSet16 = /*#__PURE__*/React__default['default'].forwardRef(function DataSet16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$m || (_path192$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 115 9.5 3.5 3.5 0 018.5 6m0-2A5.5 5.5 0 1014 9.5 5.5 5.5 0 008.5 4zM8.5 20A3.5 3.5 0 115 23.5 3.5 3.5 0 018.5 20m0-2A5.5 5.5 0 1014 23.5 5.5 5.5 0 008.5 18zM23.5 20A3.5 3.5 0 1120 23.5 3.5 3.5 0 0123.5 20m0-2A5.5 5.5 0 1029 23.5 5.5 5.5 0 0023.5 18z"
    })), children);
  });
  var DataStructured32 = /*#__PURE__*/React__default['default'].forwardRef(function DataStructured32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle41$8 || (_circle41$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path193$m || (_path193$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataStructured24 = /*#__PURE__*/React__default['default'].forwardRef(function DataStructured24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle42$8 || (_circle42$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path194$m || (_path194$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataStructured20 = /*#__PURE__*/React__default['default'].forwardRef(function DataStructured20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle43$8 || (_circle43$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path195$m || (_path195$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataStructured16 = /*#__PURE__*/React__default['default'].forwardRef(function DataStructured16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle44$8 || (_circle44$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path196$m || (_path196$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataUnstructured32 = /*#__PURE__*/React__default['default'].forwardRef(function DataUnstructured32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$m || (_path197$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 006 22zM16 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0016 2zM26 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0026 2zM18 24v4H14V24h4m2-2H12v8h8z"
    })), _path198$m || (_path198$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataUnstructured24 = /*#__PURE__*/React__default['default'].forwardRef(function DataUnstructured24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$m || (_path199$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 006 22zM16 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0016 2zM26 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0026 2zM18 24v4H14V24h4m2-2H12v8h8z"
    })), _path200$m || (_path200$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataUnstructured20 = /*#__PURE__*/React__default['default'].forwardRef(function DataUnstructured20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$m || (_path201$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 006 22zM16 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0016 2zM26 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0026 2zM18 24v4H14V24h4m2-2H12v8h8z"
    })), _path202$m || (_path202$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataUnstructured16 = /*#__PURE__*/React__default['default'].forwardRef(function DataUnstructured16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$m || (_path203$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 006 22zM16 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0016 2zM26 4a2 2 0 11-2 2 2 2 0 012-2m0-2a4 4 0 104 4A4 4 0 0026 2zM18 24v4H14V24h4m2-2H12v8h8z"
    })), _path204$m || (_path204$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var DataView32 = /*#__PURE__*/React__default['default'].forwardRef(function DataView32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle45$7 || (_circle45$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path205$m || (_path205$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _circle46$7 || (_circle46$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "8",
      r: "1"
    })), _circle47$7 || (_circle47$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "1"
    })), _circle48$7 || (_circle48$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "24",
      r: "1"
    })), _path206$m || (_path206$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5,21h7V19H5V13H21v3h2V5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2h7V27H5ZM5,5H21v6H5Z"
    })), children);
  });
  var DataView24 = /*#__PURE__*/React__default['default'].forwardRef(function DataView24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle49$6 || (_circle49$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path207$m || (_path207$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _circle50$6 || (_circle50$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "8",
      r: "1"
    })), _circle51$6 || (_circle51$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "1"
    })), _circle52$6 || (_circle52$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "24",
      r: "1"
    })), _path208$m || (_path208$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5,21h7V19H5V13H21v3h2V5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2h7V27H5ZM5,5H21v6H5Z"
    })), children);
  });
  var DataView20 = /*#__PURE__*/React__default['default'].forwardRef(function DataView20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle53$5 || (_circle53$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path209$m || (_path209$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _circle54$5 || (_circle54$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "8",
      r: "1"
    })), _circle55$4 || (_circle55$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "1"
    })), _circle56$4 || (_circle56$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "24",
      r: "1"
    })), _path210$m || (_path210$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5,21h7V19H5V13H21v3h2V5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2h7V27H5ZM5,5H21v6H5Z"
    })), children);
  });
  var DataView16 = /*#__PURE__*/React__default['default'].forwardRef(function DataView16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle57$4 || (_circle57$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path211$m || (_path211$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _circle58$4 || (_circle58$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "8",
      r: "1"
    })), _circle59$4 || (_circle59$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "1"
    })), _circle60$4 || (_circle60$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "24",
      r: "1"
    })), _path212$m || (_path212$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5,21h7V19H5V13H21v3h2V5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2h7V27H5ZM5,5H21v6H5Z"
    })), children);
  });
  var DataViewAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function DataViewAlt32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle61$4 || (_circle61$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path213$m || (_path213$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM7 17H12V19H7zM7 12H19V14H7zM7 7H19V9H7z"
    })), _path214$m || (_path214$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2,4,2A2.0058,2.0058,0,0,0,2,4V28a2.0058,2.0058,0,0,0,2,2h8V28H4V4H22V15h2V4A2.0058,2.0058,0,0,0,22,2Z"
    })), children);
  });
  var DataViewAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function DataViewAlt24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle62$4 || (_circle62$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path215$m || (_path215$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM7 17H12V19H7zM7 12H19V14H7zM7 7H19V9H7z"
    })), _path216$m || (_path216$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2,4,2A2.0058,2.0058,0,0,0,2,4V28a2.0058,2.0058,0,0,0,2,2h8V28H4V4H22V15h2V4A2.0058,2.0058,0,0,0,22,2Z"
    })), children);
  });
  var DataViewAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function DataViewAlt20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle63$4 || (_circle63$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path217$m || (_path217$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM7 17H12V19H7zM7 12H19V14H7zM7 7H19V9H7z"
    })), _path218$m || (_path218$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2,4,2A2.0058,2.0058,0,0,0,2,4V28a2.0058,2.0058,0,0,0,2,2h8V28H4V4H22V15h2V4A2.0058,2.0058,0,0,0,22,2Z"
    })), children);
  });
  var DataViewAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function DataViewAlt16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle64$4 || (_circle64$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path219$m || (_path219$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM7 17H12V19H7zM7 12H19V14H7zM7 7H19V9H7z"
    })), _path220$m || (_path220$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2,4,2A2.0058,2.0058,0,0,0,2,4V28a2.0058,2.0058,0,0,0,2,2h8V28H4V4H22V15h2V4A2.0058,2.0058,0,0,0,22,2Z"
    })), children);
  });
  var DataAccessor32 = /*#__PURE__*/React__default['default'].forwardRef(function DataAccessor32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$m || (_path221$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle65$4 || (_circle65$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path222$m || (_path222$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,13a2.9609,2.9609,0,0,0-1.2854.3008L17.4141,11l2.3-2.3008A2.9609,2.9609,0,0,0,21,9a3,3,0,1,0-3-3,2.9665,2.9665,0,0,0,.3,1.2852L16,9.5859,13.7,7.2852A2.9665,2.9665,0,0,0,14,6a3,3,0,1,0-3,3,2.9609,2.9609,0,0,0,1.2854-.3008L14.5859,11l-2.3005,2.3008A2.9609,2.9609,0,0,0,11,13a3,3,0,1,0,3,3,2.9665,2.9665,0,0,0-.3-1.2852L16,12.4141l2.3,2.3007A2.9665,2.9665,0,0,0,18,16a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,5ZM10,6a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,10,6Zm1,11a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,17Zm10,0a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,17Z"
    })), children);
  });
  var DataAccessor24 = /*#__PURE__*/React__default['default'].forwardRef(function DataAccessor24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$m || (_path223$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle66$4 || (_circle66$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path224$m || (_path224$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,13a2.9609,2.9609,0,0,0-1.2854.3008L17.4141,11l2.3-2.3008A2.9609,2.9609,0,0,0,21,9a3,3,0,1,0-3-3,2.9665,2.9665,0,0,0,.3,1.2852L16,9.5859,13.7,7.2852A2.9665,2.9665,0,0,0,14,6a3,3,0,1,0-3,3,2.9609,2.9609,0,0,0,1.2854-.3008L14.5859,11l-2.3005,2.3008A2.9609,2.9609,0,0,0,11,13a3,3,0,1,0,3,3,2.9665,2.9665,0,0,0-.3-1.2852L16,12.4141l2.3,2.3007A2.9665,2.9665,0,0,0,18,16a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,5ZM10,6a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,10,6Zm1,11a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,17Zm10,0a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,17Z"
    })), children);
  });
  var DataAccessor20 = /*#__PURE__*/React__default['default'].forwardRef(function DataAccessor20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$m || (_path225$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle67$4 || (_circle67$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path226$m || (_path226$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,13a2.9609,2.9609,0,0,0-1.2854.3008L17.4141,11l2.3-2.3008A2.9609,2.9609,0,0,0,21,9a3,3,0,1,0-3-3,2.9665,2.9665,0,0,0,.3,1.2852L16,9.5859,13.7,7.2852A2.9665,2.9665,0,0,0,14,6a3,3,0,1,0-3,3,2.9609,2.9609,0,0,0,1.2854-.3008L14.5859,11l-2.3005,2.3008A2.9609,2.9609,0,0,0,11,13a3,3,0,1,0,3,3,2.9665,2.9665,0,0,0-.3-1.2852L16,12.4141l2.3,2.3007A2.9665,2.9665,0,0,0,18,16a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,5ZM10,6a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,10,6Zm1,11a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,17Zm10,0a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,17Z"
    })), children);
  });
  var DataAccessor16 = /*#__PURE__*/React__default['default'].forwardRef(function DataAccessor16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$m || (_path227$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle68$4 || (_circle68$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path228$m || (_path228$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,13a2.9609,2.9609,0,0,0-1.2854.3008L17.4141,11l2.3-2.3008A2.9609,2.9609,0,0,0,21,9a3,3,0,1,0-3-3,2.9665,2.9665,0,0,0,.3,1.2852L16,9.5859,13.7,7.2852A2.9665,2.9665,0,0,0,14,6a3,3,0,1,0-3,3,2.9609,2.9609,0,0,0,1.2854-.3008L14.5859,11l-2.3005,2.3008A2.9609,2.9609,0,0,0,11,13a3,3,0,1,0,3,3,2.9665,2.9665,0,0,0-.3-1.2852L16,12.4141l2.3,2.3007A2.9665,2.9665,0,0,0,18,16a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,5ZM10,6a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,10,6Zm1,11a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,17Zm10,0a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,17Z"
    })), children);
  });
  var DataBackup32 = /*#__PURE__*/React__default['default'].forwardRef(function DataBackup32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle69$4 || (_circle69$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle70$4 || (_circle70$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "15",
      r: "1"
    })), _circle71$4 || (_circle71$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path229$m || (_path229$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,26H4V20h8V18H4V12H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V26a2,2,0,0,0,2,2h8ZM4,4H20v6H4Z"
    })), _path230$m || (_path230$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v2.4131A6.996,6.996,0,1,0,22,30V28a5,5,0,1,1,4.5762-7H24v2h6V17Z"
    })), children);
  });
  var DataBackup24 = /*#__PURE__*/React__default['default'].forwardRef(function DataBackup24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle72$4 || (_circle72$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle73$3 || (_circle73$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "15",
      r: "1"
    })), _circle74$3 || (_circle74$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path231$m || (_path231$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,26H4V20h8V18H4V12H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V26a2,2,0,0,0,2,2h8ZM4,4H20v6H4Z"
    })), _path232$m || (_path232$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v2.4131A6.996,6.996,0,1,0,22,30V28a5,5,0,1,1,4.5762-7H24v2h6V17Z"
    })), children);
  });
  var DataBackup20 = /*#__PURE__*/React__default['default'].forwardRef(function DataBackup20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle75$3 || (_circle75$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle76$3 || (_circle76$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "15",
      r: "1"
    })), _circle77$3 || (_circle77$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path233$m || (_path233$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,26H4V20h8V18H4V12H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V26a2,2,0,0,0,2,2h8ZM4,4H20v6H4Z"
    })), _path234$m || (_path234$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v2.4131A6.996,6.996,0,1,0,22,30V28a5,5,0,1,1,4.5762-7H24v2h6V17Z"
    })), children);
  });
  var DataBackup16 = /*#__PURE__*/React__default['default'].forwardRef(function DataBackup16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle78$3 || (_circle78$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle79$3 || (_circle79$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "15",
      r: "1"
    })), _circle80$3 || (_circle80$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path235$m || (_path235$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,26H4V20h8V18H4V12H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V26a2,2,0,0,0,2,2h8ZM4,4H20v6H4Z"
    })), _path236$m || (_path236$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,17v2.4131A6.996,6.996,0,1,0,22,30V28a5,5,0,1,1,4.5762-7H24v2h6V17Z"
    })), children);
  });
  var DataBin32 = /*#__PURE__*/React__default['default'].forwardRef(function DataBin32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$m || (_path237$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H20a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2v7H20V4zm0 9v6H20V13zM20 28V21h8v7zM12 15L10 15 10 13 8 13 8 15 6 15 6 17 8 17 8 19 10 19 10 17 12 17 12 15z"
    })), _path238$m || (_path238$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6V4H10A2.0023,2.0023,0,0,0,8,6V9.08A6.99,6.99,0,0,0,8,22.92V26a2.0023,2.0023,0,0,0,2,2h6V26H10V22.92A6.99,6.99,0,0,0,10,9.08V6ZM14,16a5,5,0,1,1-5-5A5.0059,5.0059,0,0,1,14,16Z"
    })), children);
  });
  var DataBin24 = /*#__PURE__*/React__default['default'].forwardRef(function DataBin24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$m || (_path239$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H20a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2v7H20V4zm0 9v6H20V13zM20 28V21h8v7zM12 15L10 15 10 13 8 13 8 15 6 15 6 17 8 17 8 19 10 19 10 17 12 17 12 15z"
    })), _path240$m || (_path240$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6V4H10A2.0023,2.0023,0,0,0,8,6V9.08A6.99,6.99,0,0,0,8,22.92V26a2.0023,2.0023,0,0,0,2,2h6V26H10V22.92A6.99,6.99,0,0,0,10,9.08V6ZM14,16a5,5,0,1,1-5-5A5.0059,5.0059,0,0,1,14,16Z"
    })), children);
  });
  var DataBin20 = /*#__PURE__*/React__default['default'].forwardRef(function DataBin20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$m || (_path241$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H20a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2v7H20V4zm0 9v6H20V13zM20 28V21h8v7zM12 15L10 15 10 13 8 13 8 15 6 15 6 17 8 17 8 19 10 19 10 17 12 17 12 15z"
    })), _path242$m || (_path242$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6V4H10A2.0023,2.0023,0,0,0,8,6V9.08A6.99,6.99,0,0,0,8,22.92V26a2.0023,2.0023,0,0,0,2,2h6V26H10V22.92A6.99,6.99,0,0,0,10,9.08V6ZM14,16a5,5,0,1,1-5-5A5.0059,5.0059,0,0,1,14,16Z"
    })), children);
  });
  var DataBin16 = /*#__PURE__*/React__default['default'].forwardRef(function DataBin16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$m || (_path243$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H20a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2v7H20V4zm0 9v6H20V13zM20 28V21h8v7zM12 15L10 15 10 13 8 13 8 15 6 15 6 17 8 17 8 19 10 19 10 17 12 17 12 15z"
    })), _path244$m || (_path244$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6V4H10A2.0023,2.0023,0,0,0,8,6V9.08A6.99,6.99,0,0,0,8,22.92V26a2.0023,2.0023,0,0,0,2,2h6V26H10V22.92A6.99,6.99,0,0,0,10,9.08V6ZM14,16a5,5,0,1,1-5-5A5.0059,5.0059,0,0,1,14,16Z"
    })), children);
  });
  var DataBlob32 = /*#__PURE__*/React__default['default'].forwardRef(function DataBlob32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$m || (_path245$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path246$m || (_path246$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 7H15V14H13zM8 7H10V14H8zM22 14H20a2.0021 2.0021 0 01-2-2V9a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0122 14zM20 9v3h2V9zM22 18H24V25H22zM8 18H10V25H8zM17 25H15a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0117 25zm-2-5v3h2V20z"
    })), children);
  });
  var DataBlob24 = /*#__PURE__*/React__default['default'].forwardRef(function DataBlob24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$m || (_path247$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path248$m || (_path248$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 7H15V14H13zM8 7H10V14H8zM22 14H20a2.0021 2.0021 0 01-2-2V9a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0122 14zM20 9v3h2V9zM22 18H24V25H22zM8 18H10V25H8zM17 25H15a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0117 25zm-2-5v3h2V20z"
    })), children);
  });
  var DataBlob20 = /*#__PURE__*/React__default['default'].forwardRef(function DataBlob20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$m || (_path249$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path250$m || (_path250$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 7H15V14H13zM8 7H10V14H8zM22 14H20a2.0021 2.0021 0 01-2-2V9a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0122 14zM20 9v3h2V9zM22 18H24V25H22zM8 18H10V25H8zM17 25H15a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0117 25zm-2-5v3h2V20z"
    })), children);
  });
  var DataBlob16 = /*#__PURE__*/React__default['default'].forwardRef(function DataBlob16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$m || (_path251$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path252$m || (_path252$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 7H15V14H13zM8 7H10V14H8zM22 14H20a2.0021 2.0021 0 01-2-2V9a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0122 14zM20 9v3h2V9zM22 18H24V25H22zM8 18H10V25H8zM17 25H15a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v3A2.0021 2.0021 0 0117 25zm-2-5v3h2V20z"
    })), children);
  });
  var DataClass32 = /*#__PURE__*/React__default['default'].forwardRef(function DataClass32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$m || (_path253$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"
    })), children);
  });
  var DataClass24 = /*#__PURE__*/React__default['default'].forwardRef(function DataClass24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$m || (_path254$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"
    })), children);
  });
  var DataClass20 = /*#__PURE__*/React__default['default'].forwardRef(function DataClass20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$m || (_path255$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"
    })), children);
  });
  var DataClass16 = /*#__PURE__*/React__default['default'].forwardRef(function DataClass16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$m || (_path256$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"
    })), children);
  });
  var DataCollection32 = /*#__PURE__*/React__default['default'].forwardRef(function DataCollection32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle81$3 || (_circle81$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path257$m || (_path257$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 17L30 15 23.83 15 26.41 12.41 25 11 20 16 25 21 26.41 19.59 23.83 17 30 17zM15 23.83L15 30 17 30 17 23.83 19.59 26.41 21 25 16 20 11 25 12.41 26.41 15 23.83zM7 11L5.59 12.41 8.17 15 2 15 2 17 8.17 17 5.59 19.59 7 21 12 16 7 11zM17 8.17L17 2 15 2 15 8.17 12.41 5.59 11 7 16 12 21 7 19.59 5.59 17 8.17z"
    })), children);
  });
  var DataCollection24 = /*#__PURE__*/React__default['default'].forwardRef(function DataCollection24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle82$3 || (_circle82$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path258$m || (_path258$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 17L30 15 23.83 15 26.41 12.41 25 11 20 16 25 21 26.41 19.59 23.83 17 30 17zM15 23.83L15 30 17 30 17 23.83 19.59 26.41 21 25 16 20 11 25 12.41 26.41 15 23.83zM7 11L5.59 12.41 8.17 15 2 15 2 17 8.17 17 5.59 19.59 7 21 12 16 7 11zM17 8.17L17 2 15 2 15 8.17 12.41 5.59 11 7 16 12 21 7 19.59 5.59 17 8.17z"
    })), children);
  });
  var DataCollection20 = /*#__PURE__*/React__default['default'].forwardRef(function DataCollection20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle83$3 || (_circle83$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path259$m || (_path259$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 17L30 15 23.83 15 26.41 12.41 25 11 20 16 25 21 26.41 19.59 23.83 17 30 17zM15 23.83L15 30 17 30 17 23.83 19.59 26.41 21 25 16 20 11 25 12.41 26.41 15 23.83zM7 11L5.59 12.41 8.17 15 2 15 2 17 8.17 17 5.59 19.59 7 21 12 16 7 11zM17 8.17L17 2 15 2 15 8.17 12.41 5.59 11 7 16 12 21 7 19.59 5.59 17 8.17z"
    })), children);
  });
  var DataCollection16 = /*#__PURE__*/React__default['default'].forwardRef(function DataCollection16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle84$3 || (_circle84$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path260$m || (_path260$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 17L30 15 23.83 15 26.41 12.41 25 11 20 16 25 21 26.41 19.59 23.83 17 30 17zM15 23.83L15 30 17 30 17 23.83 19.59 26.41 21 25 16 20 11 25 12.41 26.41 15 23.83zM7 11L5.59 12.41 8.17 15 2 15 2 17 8.17 17 5.59 19.59 7 21 12 16 7 11zM17 8.17L17 2 15 2 15 8.17 12.41 5.59 11 7 16 12 21 7 19.59 5.59 17 8.17z"
    })), children);
  });
  var DataDefinition32 = /*#__PURE__*/React__default['default'].forwardRef(function DataDefinition32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle85$2 || (_circle85$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path261$m || (_path261$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30a.9967.9967,0,0,1-.707-.293L8.5859,19A2.0126,2.0126,0,0,1,8,17.5859V10a2.002,2.002,0,0,1,2-2h7.5859A1.9864,1.9864,0,0,1,19,8.5859L29.707,19.293a.9994.9994,0,0,1,0,1.414l-9,9A.9967.9967,0,0,1,20,30ZM10,10v7.5859l10,10L27.5859,20l-10-10Z"
    })), _path262$m || (_path262$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v8H28V4H4V28h8Z"
    })), children);
  });
  var DataDefinition24 = /*#__PURE__*/React__default['default'].forwardRef(function DataDefinition24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle86$2 || (_circle86$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path263$m || (_path263$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30a.9967.9967,0,0,1-.707-.293L8.5859,19A2.0126,2.0126,0,0,1,8,17.5859V10a2.002,2.002,0,0,1,2-2h7.5859A1.9864,1.9864,0,0,1,19,8.5859L29.707,19.293a.9994.9994,0,0,1,0,1.414l-9,9A.9967.9967,0,0,1,20,30ZM10,10v7.5859l10,10L27.5859,20l-10-10Z"
    })), _path264$m || (_path264$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v8H28V4H4V28h8Z"
    })), children);
  });
  var DataDefinition20 = /*#__PURE__*/React__default['default'].forwardRef(function DataDefinition20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle87$2 || (_circle87$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path265$m || (_path265$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30a.9967.9967,0,0,1-.707-.293L8.5859,19A2.0126,2.0126,0,0,1,8,17.5859V10a2.002,2.002,0,0,1,2-2h7.5859A1.9864,1.9864,0,0,1,19,8.5859L29.707,19.293a.9994.9994,0,0,1,0,1.414l-9,9A.9967.9967,0,0,1,20,30ZM10,10v7.5859l10,10L27.5859,20l-10-10Z"
    })), _path266$m || (_path266$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v8H28V4H4V28h8Z"
    })), children);
  });
  var DataDefinition16 = /*#__PURE__*/React__default['default'].forwardRef(function DataDefinition16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle88$2 || (_circle88$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path267$m || (_path267$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30a.9967.9967,0,0,1-.707-.293L8.5859,19A2.0126,2.0126,0,0,1,8,17.5859V10a2.002,2.002,0,0,1,2-2h7.5859A1.9864,1.9864,0,0,1,19,8.5859L29.707,19.293a.9994.9994,0,0,1,0,1.414l-9,9A.9967.9967,0,0,1,20,30ZM10,10v7.5859l10,10L27.5859,20l-10-10Z"
    })), _path268$m || (_path268$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v8H28V4H4V28h8Z"
    })), children);
  });
  var DataDiode32 = /*#__PURE__*/React__default['default'].forwardRef(function DataDiode32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$m || (_path269$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27V7H25v8H22V7H20v7.8262L7.5239,7.1484A1,1,0,0,0,6,8v7H2v2H6v7a1,1,0,0,0,1.5239.8516L20,17.1738V25h2V17h3v8h2V17h3ZM8,22.21V9.79L18.0918,16Z"
    })), children);
  });
  var DataDiode24 = /*#__PURE__*/React__default['default'].forwardRef(function DataDiode24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$m || (_path270$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27V7H25v8H22V7H20v7.8262L7.5239,7.1484A1,1,0,0,0,6,8v7H2v2H6v7a1,1,0,0,0,1.5239.8516L20,17.1738V25h2V17h3v8h2V17h3ZM8,22.21V9.79L18.0918,16Z"
    })), children);
  });
  var DataDiode20 = /*#__PURE__*/React__default['default'].forwardRef(function DataDiode20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$m || (_path271$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27V7H25v8H22V7H20v7.8262L7.5239,7.1484A1,1,0,0,0,6,8v7H2v2H6v7a1,1,0,0,0,1.5239.8516L20,17.1738V25h2V17h3v8h2V17h3ZM8,22.21V9.79L18.0918,16Z"
    })), children);
  });
  var DataDiode16 = /*#__PURE__*/React__default['default'].forwardRef(function DataDiode16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$m || (_path272$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27V7H25v8H22V7H20v7.8262L7.5239,7.1484A1,1,0,0,0,6,8v7H2v2H6v7a1,1,0,0,0,1.5239.8516L20,17.1738V25h2V17h3v8h2V17h3ZM8,22.21V9.79L18.0918,16Z"
    })), children);
  });
  var DataPlayer32 = /*#__PURE__*/React__default['default'].forwardRef(function DataPlayer32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$m || (_path273$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v2H15.8164a2.983 2.983 0 00-5.6328 0H4V24H2v6H4V28h6.1836a2.983 2.983 0 005.6328 0H28v2h2V24zM13 7.5L13 16.499 13 16.499 21 12 13 7.5z"
    })), _path274$m || (_path274$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22A10,10,0,1,1,26,12,10.0113,10.0113,0,0,1,16,22ZM16,4a8,8,0,1,0,8,8A8.0092,8.0092,0,0,0,16,4Z"
    })), children);
  });
  var DataPlayer24 = /*#__PURE__*/React__default['default'].forwardRef(function DataPlayer24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$m || (_path275$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v2H15.8164a2.983 2.983 0 00-5.6328 0H4V24H2v6H4V28h6.1836a2.983 2.983 0 005.6328 0H28v2h2V24zM13 7.5L13 16.499 13 16.499 21 12 13 7.5z"
    })), _path276$m || (_path276$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22A10,10,0,1,1,26,12,10.0113,10.0113,0,0,1,16,22ZM16,4a8,8,0,1,0,8,8A8.0092,8.0092,0,0,0,16,4Z"
    })), children);
  });
  var DataPlayer20 = /*#__PURE__*/React__default['default'].forwardRef(function DataPlayer20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$m || (_path277$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v2H15.8164a2.983 2.983 0 00-5.6328 0H4V24H2v6H4V28h6.1836a2.983 2.983 0 005.6328 0H28v2h2V24zM13 7.5L13 16.499 13 16.499 21 12 13 7.5z"
    })), _path278$m || (_path278$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22A10,10,0,1,1,26,12,10.0113,10.0113,0,0,1,16,22ZM16,4a8,8,0,1,0,8,8A8.0092,8.0092,0,0,0,16,4Z"
    })), children);
  });
  var DataPlayer16 = /*#__PURE__*/React__default['default'].forwardRef(function DataPlayer16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$m || (_path279$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v2H15.8164a2.983 2.983 0 00-5.6328 0H4V24H2v6H4V28h6.1836a2.983 2.983 0 005.6328 0H28v2h2V24zM13 7.5L13 16.499 13 16.499 21 12 13 7.5z"
    })), _path280$m || (_path280$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22A10,10,0,1,1,26,12,10.0113,10.0113,0,0,1,16,22ZM16,4a8,8,0,1,0,8,8A8.0092,8.0092,0,0,0,16,4Z"
    })), children);
  });
  var DataRefinery32 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefinery32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$m || (_path281$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,30a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,7,30Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,7,22Z"
    })), _path282$m || (_path282$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H14V24H24V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), _path283$m || (_path283$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22a2.0023,2.0023,0,0,1-2-2V4a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v6A2.0023,2.0023,0,0,1,28,12ZM22,4v6h6V4Z"
    })), children);
  });
  var DataRefinery24 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefinery24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$m || (_path284$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,30a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,7,30Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,7,22Z"
    })), _path285$m || (_path285$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H14V24H24V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), _path286$m || (_path286$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22a2.0023,2.0023,0,0,1-2-2V4a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v6A2.0023,2.0023,0,0,1,28,12ZM22,4v6h6V4Z"
    })), children);
  });
  var DataRefinery20 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefinery20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$m || (_path287$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,30a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,7,30Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,7,22Z"
    })), _path288$m || (_path288$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H14V24H24V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), _path289$m || (_path289$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22a2.0023,2.0023,0,0,1-2-2V4a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v6A2.0023,2.0023,0,0,1,28,12ZM22,4v6h6V4Z"
    })), children);
  });
  var DataRefinery16 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefinery16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$m || (_path290$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,30a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,7,30Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,7,22Z"
    })), _path291$m || (_path291$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H14V24H24V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), _path292$m || (_path292$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22a2.0023,2.0023,0,0,1-2-2V4a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v6A2.0023,2.0023,0,0,1,28,12ZM22,4v6h6V4Z"
    })), children);
  });
  var DataRefineryReference32 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefineryReference32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$m || (_path293$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6V4z"
    })), _path294$m || (_path294$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H16V24h8V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), children);
  });
  var DataRefineryReference24 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefineryReference24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$m || (_path295$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6V4z"
    })), _path296$m || (_path296$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H16V24h8V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), children);
  });
  var DataRefineryReference20 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefineryReference20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$m || (_path297$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6V4z"
    })), _path298$m || (_path298$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H16V24h8V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), children);
  });
  var DataRefineryReference16 = /*#__PURE__*/React__default['default'].forwardRef(function DataRefineryReference16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$m || (_path299$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6V4z"
    })), _path300$m || (_path300$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26H16V24h8V17H8a2.0021,2.0021,0,0,1-2-2V8A2.0021,2.0021,0,0,1,8,6H18V8H8v7H24a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,24,26Z"
    })), children);
  });
  var DataShare32 = /*#__PURE__*/React__default['default'].forwardRef(function DataShare32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$m || (_path301$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 015 25zM24 22h4a2.002 2.002 0 012 2v4a2.002 2.002 0 01-2 2H24a2.002 2.002 0 01-2-2V24A2.002 2.002 0 0124 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0127 6zM2 6H8V8H2zM2 2H10V4H2z"
    })), children);
  });
  var DataShare24 = /*#__PURE__*/React__default['default'].forwardRef(function DataShare24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$m || (_path302$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 015 25zM24 22h4a2.002 2.002 0 012 2v4a2.002 2.002 0 01-2 2H24a2.002 2.002 0 01-2-2V24A2.002 2.002 0 0124 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0127 6zM2 6H8V8H2zM2 2H10V4H2z"
    })), children);
  });
  var DataShare20 = /*#__PURE__*/React__default['default'].forwardRef(function DataShare20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$m || (_path303$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 015 25zM24 22h4a2.002 2.002 0 012 2v4a2.002 2.002 0 01-2 2H24a2.002 2.002 0 01-2-2V24A2.002 2.002 0 0124 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0127 6zM2 6H8V8H2zM2 2H10V4H2z"
    })), children);
  });
  var DataShare16 = /*#__PURE__*/React__default['default'].forwardRef(function DataShare16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$m || (_path304$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 015 25zM24 22h4a2.002 2.002 0 012 2v4a2.002 2.002 0 01-2 2H24a2.002 2.002 0 01-2-2V24A2.002 2.002 0 0124 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0127 6zM2 6H8V8H2zM2 2H10V4H2z"
    })), children);
  });
  var DataTable32 = /*#__PURE__*/React__default['default'].forwardRef(function DataTable32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$m || (_path305$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H12V20H8zM14 18H18V20H14zM8 14H12V16H8zM14 22H18V24H14zM20 14H24V16H20zM20 22H24V24H20z"
    })), _path306$m || (_path306$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,2,0,4H5V5ZM5,27V11H27l0,16Z"
    })), children);
  });
  var DataTable24 = /*#__PURE__*/React__default['default'].forwardRef(function DataTable24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$m || (_path307$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H12V20H8zM14 18H18V20H14zM8 14H12V16H8zM14 22H18V24H14zM20 14H24V16H20zM20 22H24V24H20z"
    })), _path308$m || (_path308$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,2,0,4H5V5ZM5,27V11H27l0,16Z"
    })), children);
  });
  var DataTable20 = /*#__PURE__*/React__default['default'].forwardRef(function DataTable20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$m || (_path309$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H12V20H8zM14 18H18V20H14zM8 14H12V16H8zM14 22H18V24H14zM20 14H24V16H20zM20 22H24V24H20z"
    })), _path310$m || (_path310$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,2,0,4H5V5ZM5,27V11H27l0,16Z"
    })), children);
  });
  var DataTable16 = /*#__PURE__*/React__default['default'].forwardRef(function DataTable16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$m || (_path311$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H12V20H8zM14 18H18V20H14zM8 14H12V16H8zM14 22H18V24H14zM20 14H24V16H20zM20 22H24V24H20z"
    })), _path312$m || (_path312$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0025,2.0025,0,0,0,3,5V27a2.0025,2.0025,0,0,0,2,2H27a2.0025,2.0025,0,0,0,2-2V5A2.0025,2.0025,0,0,0,27,3Zm0,2,0,4H5V5ZM5,27V11H27l0,16Z"
    })), children);
  });
  var DataTableReference32 = /*#__PURE__*/React__default['default'].forwardRef(function DataTableReference32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$m || (_path313$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM20 22H24V24H20zM16 18H20V20H16zM20 14H24V16H20zM8 14H12V16H8z"
    })), _path314$m || (_path314$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0027,2.0027,0,0,0,3,5V16H5V11H27V27H16v2H27a2.0027,2.0027,0,0,0,2-2V5A2.0027,2.0027,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var DataTableReference24 = /*#__PURE__*/React__default['default'].forwardRef(function DataTableReference24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$m || (_path315$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM20 22H24V24H20zM16 18H20V20H16zM20 14H24V16H20zM8 14H12V16H8z"
    })), _path316$m || (_path316$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0027,2.0027,0,0,0,3,5V16H5V11H27V27H16v2H27a2.0027,2.0027,0,0,0,2-2V5A2.0027,2.0027,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var DataTableReference20 = /*#__PURE__*/React__default['default'].forwardRef(function DataTableReference20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$m || (_path317$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM20 22H24V24H20zM16 18H20V20H16zM20 14H24V16H20zM8 14H12V16H8z"
    })), _path318$m || (_path318$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0027,2.0027,0,0,0,3,5V16H5V11H27V27H16v2H27a2.0027,2.0027,0,0,0,2-2V5A2.0027,2.0027,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var DataTableReference16 = /*#__PURE__*/React__default['default'].forwardRef(function DataTableReference16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$m || (_path319$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM20 22H24V24H20zM16 18H20V20H16zM20 14H24V16H20zM8 14H12V16H8z"
    })), _path320$m || (_path320$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0027,2.0027,0,0,0,3,5V16H5V11H27V27H16v2H27a2.0027,2.0027,0,0,0,2-2V5A2.0027,2.0027,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var DataVis_132 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_132(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$m || (_path321$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var DataVis_124 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_124(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$m || (_path322$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var DataVis_120 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_120(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$m || (_path323$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var DataVis_116 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_116(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$m || (_path324$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var DataVis_232 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_232(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$m || (_path325$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"
    })), children);
  });
  var DataVis_224 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_224(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$m || (_path326$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"
    })), children);
  });
  var DataVis_220 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_220(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$m || (_path327$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"
    })), children);
  });
  var DataVis_216 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_216(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$m || (_path328$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"
    })), children);
  });
  var DataVis_332 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_332(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$m || (_path329$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"
    })), children);
  });
  var DataVis_324 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_324(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$m || (_path330$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"
    })), children);
  });
  var DataVis_320 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_320(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$m || (_path331$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"
    })), children);
  });
  var DataVis_316 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_316(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$m || (_path332$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"
    })), children);
  });
  var DataVis_432 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_432(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$m || (_path333$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"
    })), children);
  });
  var DataVis_424 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_424(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$m || (_path334$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"
    })), children);
  });
  var DataVis_420 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_420(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$m || (_path335$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"
    })), children);
  });
  var DataVis_416 = /*#__PURE__*/React__default['default'].forwardRef(function DataVis_416(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$m || (_path336$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"
    })), children);
  });
  var DatabaseDatastax32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseDatastax32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$m || (_path337$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.8684 22.0684l1.7937-1.7476A4.2184 4.2184 0 0023.95 21.9534c1.4026 0 2.0005-.5288 2.0005-1.38 0-.69-.4138-1.1267-1.4717-1.2646l-1.1958-.1612c-2.5754-.3217-4.0009-1.4484-4.0009-3.633 0-2.3225 1.8166-3.7942 4.5529-3.7942a5.7221 5.7221 0 014.691 1.8855l-1.7246 1.7246a3.9649 3.9649 0 00-2.8743-1.2876c-1.2649 0-1.8167.5059-1.8167 1.2417 0 .8049.4368 1.1726 1.5638 1.3567l1.2187.1609c2.6213.3679 3.886 1.5408 3.886 3.5412 0 2.3226-1.9546 3.9322-4.9439 3.9322A6.0942 6.0942 0 0118.8684 22.0684zM4.24 7.95h5.8409c4.185 0 6.9213 2.69 6.9213 8.0254S14.2661 24 10.0811 24H4.24zm5.8409 13.36c2.2534 0 3.7021-1.3338 3.7021-4.07V14.71c0-2.7364-1.4487-4.07-3.7021-4.07H7.2756V21.31z"
    })), children);
  });
  var DatabaseDatastax24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseDatastax24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$l || (_path338$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.8684 22.0684l1.7937-1.7476A4.2184 4.2184 0 0023.95 21.9534c1.4026 0 2.0005-.5288 2.0005-1.38 0-.69-.4138-1.1267-1.4717-1.2646l-1.1958-.1612c-2.5754-.3217-4.0009-1.4484-4.0009-3.633 0-2.3225 1.8166-3.7942 4.5529-3.7942a5.7221 5.7221 0 014.691 1.8855l-1.7246 1.7246a3.9649 3.9649 0 00-2.8743-1.2876c-1.2649 0-1.8167.5059-1.8167 1.2417 0 .8049.4368 1.1726 1.5638 1.3567l1.2187.1609c2.6213.3679 3.886 1.5408 3.886 3.5412 0 2.3226-1.9546 3.9322-4.9439 3.9322A6.0942 6.0942 0 0118.8684 22.0684zM4.24 7.95h5.8409c4.185 0 6.9213 2.69 6.9213 8.0254S14.2661 24 10.0811 24H4.24zm5.8409 13.36c2.2534 0 3.7021-1.3338 3.7021-4.07V14.71c0-2.7364-1.4487-4.07-3.7021-4.07H7.2756V21.31z"
    })), children);
  });
  var DatabaseDatastax20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseDatastax20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$l || (_path339$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.8684 22.0684l1.7937-1.7476A4.2184 4.2184 0 0023.95 21.9534c1.4026 0 2.0005-.5288 2.0005-1.38 0-.69-.4138-1.1267-1.4717-1.2646l-1.1958-.1612c-2.5754-.3217-4.0009-1.4484-4.0009-3.633 0-2.3225 1.8166-3.7942 4.5529-3.7942a5.7221 5.7221 0 014.691 1.8855l-1.7246 1.7246a3.9649 3.9649 0 00-2.8743-1.2876c-1.2649 0-1.8167.5059-1.8167 1.2417 0 .8049.4368 1.1726 1.5638 1.3567l1.2187.1609c2.6213.3679 3.886 1.5408 3.886 3.5412 0 2.3226-1.9546 3.9322-4.9439 3.9322A6.0942 6.0942 0 0118.8684 22.0684zM4.24 7.95h5.8409c4.185 0 6.9213 2.69 6.9213 8.0254S14.2661 24 10.0811 24H4.24zm5.8409 13.36c2.2534 0 3.7021-1.3338 3.7021-4.07V14.71c0-2.7364-1.4487-4.07-3.7021-4.07H7.2756V21.31z"
    })), children);
  });
  var DatabaseDatastax16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseDatastax16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$l || (_path340$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.8684 22.0684l1.7937-1.7476A4.2184 4.2184 0 0023.95 21.9534c1.4026 0 2.0005-.5288 2.0005-1.38 0-.69-.4138-1.1267-1.4717-1.2646l-1.1958-.1612c-2.5754-.3217-4.0009-1.4484-4.0009-3.633 0-2.3225 1.8166-3.7942 4.5529-3.7942a5.7221 5.7221 0 014.691 1.8855l-1.7246 1.7246a3.9649 3.9649 0 00-2.8743-1.2876c-1.2649 0-1.8167.5059-1.8167 1.2417 0 .8049.4368 1.1726 1.5638 1.3567l1.2187.1609c2.6213.3679 3.886 1.5408 3.886 3.5412 0 2.3226-1.9546 3.9322-4.9439 3.9322A6.0942 6.0942 0 0118.8684 22.0684zM4.24 7.95h5.8409c4.185 0 6.9213 2.69 6.9213 8.0254S14.2661 24 10.0811 24H4.24zm5.8409 13.36c2.2534 0 3.7021-1.3338 3.7021-4.07V14.71c0-2.7364-1.4487-4.07-3.7021-4.07H7.2756V21.31z"
    })), children);
  });
  var DatabaseElastic32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseElastic32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$l || (_path341$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8281 22.0684l1.7937-1.7476A4.2185 4.2185 0 0022.91 21.9534c1.4025 0 2-.5288 2-1.38 0-.69-.4138-1.1267-1.4716-1.2646l-1.1958-.1612c-2.5755-.3217-4.001-1.4484-4.001-3.633 0-2.3225 1.8166-3.7942 4.553-3.7942a5.722 5.722 0 014.6909 1.8855l-1.7246 1.7246a3.9643 3.9643 0 00-2.8743-1.2876c-1.2649 0-1.8166.5059-1.8166 1.2417 0 .8049.4367 1.1726 1.5637 1.3567l1.2187.1609c2.6214.3679 3.886 1.5408 3.886 3.5413 0 2.3225-1.9546 3.9321-4.9438 3.9321A6.0944 6.0944 0 0117.8281 22.0684zM5.2471 24V7.95H15.825v2.69H8.2825v3.8862h6.6687v2.6905H8.2825V21.31H15.825V24z"
    })), children);
  });
  var DatabaseElastic24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseElastic24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$l || (_path342$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8281 22.0684l1.7937-1.7476A4.2185 4.2185 0 0022.91 21.9534c1.4025 0 2-.5288 2-1.38 0-.69-.4138-1.1267-1.4716-1.2646l-1.1958-.1612c-2.5755-.3217-4.001-1.4484-4.001-3.633 0-2.3225 1.8166-3.7942 4.553-3.7942a5.722 5.722 0 014.6909 1.8855l-1.7246 1.7246a3.9643 3.9643 0 00-2.8743-1.2876c-1.2649 0-1.8166.5059-1.8166 1.2417 0 .8049.4367 1.1726 1.5637 1.3567l1.2187.1609c2.6214.3679 3.886 1.5408 3.886 3.5413 0 2.3225-1.9546 3.9321-4.9438 3.9321A6.0944 6.0944 0 0117.8281 22.0684zM5.2471 24V7.95H15.825v2.69H8.2825v3.8862h6.6687v2.6905H8.2825V21.31H15.825V24z"
    })), children);
  });
  var DatabaseElastic20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseElastic20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$l || (_path343$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8281 22.0684l1.7937-1.7476A4.2185 4.2185 0 0022.91 21.9534c1.4025 0 2-.5288 2-1.38 0-.69-.4138-1.1267-1.4716-1.2646l-1.1958-.1612c-2.5755-.3217-4.001-1.4484-4.001-3.633 0-2.3225 1.8166-3.7942 4.553-3.7942a5.722 5.722 0 014.6909 1.8855l-1.7246 1.7246a3.9643 3.9643 0 00-2.8743-1.2876c-1.2649 0-1.8166.5059-1.8166 1.2417 0 .8049.4367 1.1726 1.5637 1.3567l1.2187.1609c2.6214.3679 3.886 1.5408 3.886 3.5413 0 2.3225-1.9546 3.9321-4.9438 3.9321A6.0944 6.0944 0 0117.8281 22.0684zM5.2471 24V7.95H15.825v2.69H8.2825v3.8862h6.6687v2.6905H8.2825V21.31H15.825V24z"
    })), children);
  });
  var DatabaseElastic16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseElastic16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$l || (_path344$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8281 22.0684l1.7937-1.7476A4.2185 4.2185 0 0022.91 21.9534c1.4025 0 2-.5288 2-1.38 0-.69-.4138-1.1267-1.4716-1.2646l-1.1958-.1612c-2.5755-.3217-4.001-1.4484-4.001-3.633 0-2.3225 1.8166-3.7942 4.553-3.7942a5.722 5.722 0 014.6909 1.8855l-1.7246 1.7246a3.9643 3.9643 0 00-2.8743-1.2876c-1.2649 0-1.8166.5059-1.8166 1.2417 0 .8049.4367 1.1726 1.5637 1.3567l1.2187.1609c2.6214.3679 3.886 1.5408 3.886 3.5413 0 2.3225-1.9546 3.9321-4.9438 3.9321A6.0944 6.0944 0 0117.8281 22.0684zM5.2471 24V7.95H15.825v2.69H8.2825v3.8862h6.6687v2.6905H8.2825V21.31H15.825V24z"
    })), children);
  });
  var DatabaseEnterpriseDb232 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEnterpriseDb232(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$l || (_path345$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.84 24V11.9966H20.783v2h.1149a3.3115 3.3115 0 013.3572-2.2764c2.46 0 3.84 1.7017 3.84 4.6909V24H25.1519V16.7107c0-1.7017-.5748-2.5754-1.9776-2.5754-1.2187 0-2.3913.6438-2.3913 1.9314V24zM4.2236 24V7.95H14.8015v2.69H7.259v3.8862h6.6687v2.6905H7.259V21.31h7.5425V24z"
    })), children);
  });
  var DatabaseEnterpriseDb224 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEnterpriseDb224(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$l || (_path346$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.84 24V11.9966H20.783v2h.1149a3.3115 3.3115 0 013.3572-2.2764c2.46 0 3.84 1.7017 3.84 4.6909V24H25.1519V16.7107c0-1.7017-.5748-2.5754-1.9776-2.5754-1.2187 0-2.3913.6438-2.3913 1.9314V24zM4.2236 24V7.95H14.8015v2.69H7.259v3.8862h6.6687v2.6905H7.259V21.31h7.5425V24z"
    })), children);
  });
  var DatabaseEnterpriseDb220 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEnterpriseDb220(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$l || (_path347$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.84 24V11.9966H20.783v2h.1149a3.3115 3.3115 0 013.3572-2.2764c2.46 0 3.84 1.7017 3.84 4.6909V24H25.1519V16.7107c0-1.7017-.5748-2.5754-1.9776-2.5754-1.2187 0-2.3913.6438-2.3913 1.9314V24zM4.2236 24V7.95H14.8015v2.69H7.259v3.8862h6.6687v2.6905H7.259V21.31h7.5425V24z"
    })), children);
  });
  var DatabaseEnterpriseDb216 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEnterpriseDb216(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$l || (_path348$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.84 24V11.9966H20.783v2h.1149a3.3115 3.3115 0 013.3572-2.2764c2.46 0 3.84 1.7017 3.84 4.6909V24H25.1519V16.7107c0-1.7017-.5748-2.5754-1.9776-2.5754-1.2187 0-2.3913.6438-2.3913 1.9314V24zM4.2236 24V7.95H14.8015v2.69H7.259v3.8862h6.6687v2.6905H7.259V21.31h7.5425V24z"
    })), children);
  });
  var DatabaseEtcd32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEtcd32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$l || (_path349$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.9443 20.9417v-6.6h-1.77V11.9966h.92c.8735 0 1.1494-.4138 1.1494-1.2417V8.7083h2.6445v3.2883h2.46V14.342h-2.46v7.3125h2.2764V24H24.0488A2.778 2.778 0 0120.9443 20.9417zM6.6846 24V7.95H17.2627v2.69H9.72v3.8862h6.669v2.6905H9.72V21.31h7.543V24z"
    })), children);
  });
  var DatabaseEtcd24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEtcd24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$l || (_path350$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.9443 20.9417v-6.6h-1.77V11.9966h.92c.8735 0 1.1494-.4138 1.1494-1.2417V8.7083h2.6445v3.2883h2.46V14.342h-2.46v7.3125h2.2764V24H24.0488A2.778 2.778 0 0120.9443 20.9417zM6.6846 24V7.95H17.2627v2.69H9.72v3.8862h6.669v2.6905H9.72V21.31h7.543V24z"
    })), children);
  });
  var DatabaseEtcd20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEtcd20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$l || (_path351$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.9443 20.9417v-6.6h-1.77V11.9966h.92c.8735 0 1.1494-.4138 1.1494-1.2417V8.7083h2.6445v3.2883h2.46V14.342h-2.46v7.3125h2.2764V24H24.0488A2.778 2.778 0 0120.9443 20.9417zM6.6846 24V7.95H17.2627v2.69H9.72v3.8862h6.669v2.6905H9.72V21.31h7.543V24z"
    })), children);
  });
  var DatabaseEtcd16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseEtcd16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$l || (_path352$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.9443 20.9417v-6.6h-1.77V11.9966h.92c.8735 0 1.1494-.4138 1.1494-1.2417V8.7083h2.6445v3.2883h2.46V14.342h-2.46v7.3125h2.2764V24H24.0488A2.778 2.778 0 0120.9443 20.9417zM6.6846 24V7.95H17.2627v2.69H9.72v3.8862h6.669v2.6905H9.72V21.31h7.543V24z"
    })), children);
  });
  var DatabaseMongodb32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseMongodb32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$l || (_path353$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3481 28.875c-4.0473 0-5.5878-1.0579-5.5878-2.8284a2.2115 2.2115 0 012.1386-2.3v-.253a1.9726 1.9726 0 01-1.5405-2c0-1.242 1.0576-1.8628 2.207-2.1158v-.0918a3.6228 3.6228 0 01-2.1845-3.4953c0-2.4375 1.7246-4.07 4.9672-4.07A6.6717 6.6717 0 0127.44 12.02v-.3908a1.5343 1.5343 0 011.7022-1.7476h1.8623v2.2534H28.4521v.322a3.5917 3.5917 0 011.8628 3.3343c0 2.4145-1.7016 4.0241-4.9668 4.0241a7.3662 7.3662 0 01-1.8393-.207 1.23 1.23 0 00-.8511 1.0808c0 .5979.5059.8967 1.564.8967H27.44c2.9434 0 4.208 1.2649 4.208 3.4263C31.6484 27.5183 29.9473 28.875 25.3481 28.875zm1.4947-4.7371H22.75a1.473 1.473 0 00-.6211 1.2417c0 .92.6895 1.4717 2.5293 1.4717H26.13c1.9087 0 2.76-.4829 2.76-1.4946C28.89 24.5979 28.3374 24.1379 26.8428 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1617-1.84s-2.1616.6209-2.1616 1.84v.3912c0 1.1955.7588 1.84 2.1616 1.84S27.51 17.17 27.51 15.9749zM2.2344 7.95H5.66l4.1162 7.8413h.0923l4.07-7.8413h3.2886V24H14.3525V12.48h-.0918L13.0186 15.032l-3.2881 6.07-3.2881-6.07L5.2007 12.48H5.1084V24H2.2344z"
    })), children);
  });
  var DatabaseMongodb24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseMongodb24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$l || (_path354$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3481 28.875c-4.0473 0-5.5878-1.0579-5.5878-2.8284a2.2115 2.2115 0 012.1386-2.3v-.253a1.9726 1.9726 0 01-1.5405-2c0-1.242 1.0576-1.8628 2.207-2.1158v-.0918a3.6228 3.6228 0 01-2.1845-3.4953c0-2.4375 1.7246-4.07 4.9672-4.07A6.6717 6.6717 0 0127.44 12.02v-.3908a1.5343 1.5343 0 011.7022-1.7476h1.8623v2.2534H28.4521v.322a3.5917 3.5917 0 011.8628 3.3343c0 2.4145-1.7016 4.0241-4.9668 4.0241a7.3662 7.3662 0 01-1.8393-.207 1.23 1.23 0 00-.8511 1.0808c0 .5979.5059.8967 1.564.8967H27.44c2.9434 0 4.208 1.2649 4.208 3.4263C31.6484 27.5183 29.9473 28.875 25.3481 28.875zm1.4947-4.7371H22.75a1.473 1.473 0 00-.6211 1.2417c0 .92.6895 1.4717 2.5293 1.4717H26.13c1.9087 0 2.76-.4829 2.76-1.4946C28.89 24.5979 28.3374 24.1379 26.8428 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1617-1.84s-2.1616.6209-2.1616 1.84v.3912c0 1.1955.7588 1.84 2.1616 1.84S27.51 17.17 27.51 15.9749zM2.2344 7.95H5.66l4.1162 7.8413h.0923l4.07-7.8413h3.2886V24H14.3525V12.48h-.0918L13.0186 15.032l-3.2881 6.07-3.2881-6.07L5.2007 12.48H5.1084V24H2.2344z"
    })), children);
  });
  var DatabaseMongodb20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseMongodb20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$k || (_path355$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3481 28.875c-4.0473 0-5.5878-1.0579-5.5878-2.8284a2.2115 2.2115 0 012.1386-2.3v-.253a1.9726 1.9726 0 01-1.5405-2c0-1.242 1.0576-1.8628 2.207-2.1158v-.0918a3.6228 3.6228 0 01-2.1845-3.4953c0-2.4375 1.7246-4.07 4.9672-4.07A6.6717 6.6717 0 0127.44 12.02v-.3908a1.5343 1.5343 0 011.7022-1.7476h1.8623v2.2534H28.4521v.322a3.5917 3.5917 0 011.8628 3.3343c0 2.4145-1.7016 4.0241-4.9668 4.0241a7.3662 7.3662 0 01-1.8393-.207 1.23 1.23 0 00-.8511 1.0808c0 .5979.5059.8967 1.564.8967H27.44c2.9434 0 4.208 1.2649 4.208 3.4263C31.6484 27.5183 29.9473 28.875 25.3481 28.875zm1.4947-4.7371H22.75a1.473 1.473 0 00-.6211 1.2417c0 .92.6895 1.4717 2.5293 1.4717H26.13c1.9087 0 2.76-.4829 2.76-1.4946C28.89 24.5979 28.3374 24.1379 26.8428 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1617-1.84s-2.1616.6209-2.1616 1.84v.3912c0 1.1955.7588 1.84 2.1616 1.84S27.51 17.17 27.51 15.9749zM2.2344 7.95H5.66l4.1162 7.8413h.0923l4.07-7.8413h3.2886V24H14.3525V12.48h-.0918L13.0186 15.032l-3.2881 6.07-3.2881-6.07L5.2007 12.48H5.1084V24H2.2344z"
    })), children);
  });
  var DatabaseMongodb16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseMongodb16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$k || (_path356$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3481 28.875c-4.0473 0-5.5878-1.0579-5.5878-2.8284a2.2115 2.2115 0 012.1386-2.3v-.253a1.9726 1.9726 0 01-1.5405-2c0-1.242 1.0576-1.8628 2.207-2.1158v-.0918a3.6228 3.6228 0 01-2.1845-3.4953c0-2.4375 1.7246-4.07 4.9672-4.07A6.6717 6.6717 0 0127.44 12.02v-.3908a1.5343 1.5343 0 011.7022-1.7476h1.8623v2.2534H28.4521v.322a3.5917 3.5917 0 011.8628 3.3343c0 2.4145-1.7016 4.0241-4.9668 4.0241a7.3662 7.3662 0 01-1.8393-.207 1.23 1.23 0 00-.8511 1.0808c0 .5979.5059.8967 1.564.8967H27.44c2.9434 0 4.208 1.2649 4.208 3.4263C31.6484 27.5183 29.9473 28.875 25.3481 28.875zm1.4947-4.7371H22.75a1.473 1.473 0 00-.6211 1.2417c0 .92.6895 1.4717 2.5293 1.4717H26.13c1.9087 0 2.76-.4829 2.76-1.4946C28.89 24.5979 28.3374 24.1379 26.8428 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1617-1.84s-2.1616.6209-2.1616 1.84v.3912c0 1.1955.7588 1.84 2.1616 1.84S27.51 17.17 27.51 15.9749zM2.2344 7.95H5.66l4.1162 7.8413h.0923l4.07-7.8413h3.2886V24H14.3525V12.48h-.0918L13.0186 15.032l-3.2881 6.07-3.2881-6.07L5.2007 12.48H5.1084V24H2.2344z"
    })), children);
  });
  var DatabasePostgreSql32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabasePostgreSql32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$k || (_path357$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.98 28.875c-4.0474 0-5.5879-1.0579-5.5879-2.8284a2.2112 2.2112 0 012.1387-2.3v-.253a1.9725 1.9725 0 01-1.541-2c0-1.242 1.0576-1.8628 2.2075-2.1158v-.0918a3.622 3.622 0 01-2.1846-3.4953c0-2.4375 1.7246-4.07 4.9673-4.07a6.6768 6.6768 0 012.0923.2988v-.3908a1.5341 1.5341 0 011.7016-1.7476h1.8623v2.2534H26.0835v.322a3.5926 3.5926 0 011.8628 3.3343c0 2.4145-1.7022 4.0241-4.9668 4.0241a7.3717 7.3717 0 01-1.84-.207 1.23 1.23 0 00-.8505 1.0808c0 .5979.5058.8967 1.5634.8967h3.2193c2.9433 0 4.208 1.2649 4.208 3.4263C29.28 27.5183 27.5781 28.875 22.98 28.875zm1.4941-4.7371H20.3809A1.474 1.474 0 0019.76 25.38c0 .92.69 1.4717 2.5293 1.4717h1.4716c1.9092 0 2.76-.4829 2.76-1.4946C26.5205 24.5979 25.9688 24.1379 24.4736 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1611-1.84s-2.1621.6209-2.1621 1.84v.3912c0 1.1955.7588 1.84 2.1621 1.84S25.1406 17.17 25.1406 15.9749zM4.603 24V7.95h7.22c2.9668 0 4.76 2 4.76 4.967 0 2.9893-1.7935 4.9668-4.76 4.9668H7.6387V24zm3.0357-8.738h3.9092a1.6886 1.6886 0 001.8852-1.8167V12.3875a1.672 1.672 0 00-1.8852-1.7935H7.6387z"
    })), children);
  });
  var DatabasePostgreSql24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabasePostgreSql24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$k || (_path358$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.98 28.875c-4.0474 0-5.5879-1.0579-5.5879-2.8284a2.2112 2.2112 0 012.1387-2.3v-.253a1.9725 1.9725 0 01-1.541-2c0-1.242 1.0576-1.8628 2.2075-2.1158v-.0918a3.622 3.622 0 01-2.1846-3.4953c0-2.4375 1.7246-4.07 4.9673-4.07a6.6768 6.6768 0 012.0923.2988v-.3908a1.5341 1.5341 0 011.7016-1.7476h1.8623v2.2534H26.0835v.322a3.5926 3.5926 0 011.8628 3.3343c0 2.4145-1.7022 4.0241-4.9668 4.0241a7.3717 7.3717 0 01-1.84-.207 1.23 1.23 0 00-.8505 1.0808c0 .5979.5058.8967 1.5634.8967h3.2193c2.9433 0 4.208 1.2649 4.208 3.4263C29.28 27.5183 27.5781 28.875 22.98 28.875zm1.4941-4.7371H20.3809A1.474 1.474 0 0019.76 25.38c0 .92.69 1.4717 2.5293 1.4717h1.4716c1.9092 0 2.76-.4829 2.76-1.4946C26.5205 24.5979 25.9688 24.1379 24.4736 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1611-1.84s-2.1621.6209-2.1621 1.84v.3912c0 1.1955.7588 1.84 2.1621 1.84S25.1406 17.17 25.1406 15.9749zM4.603 24V7.95h7.22c2.9668 0 4.76 2 4.76 4.967 0 2.9893-1.7935 4.9668-4.76 4.9668H7.6387V24zm3.0357-8.738h3.9092a1.6886 1.6886 0 001.8852-1.8167V12.3875a1.672 1.672 0 00-1.8852-1.7935H7.6387z"
    })), children);
  });
  var DatabasePostgreSql20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabasePostgreSql20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$k || (_path359$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.98 28.875c-4.0474 0-5.5879-1.0579-5.5879-2.8284a2.2112 2.2112 0 012.1387-2.3v-.253a1.9725 1.9725 0 01-1.541-2c0-1.242 1.0576-1.8628 2.2075-2.1158v-.0918a3.622 3.622 0 01-2.1846-3.4953c0-2.4375 1.7246-4.07 4.9673-4.07a6.6768 6.6768 0 012.0923.2988v-.3908a1.5341 1.5341 0 011.7016-1.7476h1.8623v2.2534H26.0835v.322a3.5926 3.5926 0 011.8628 3.3343c0 2.4145-1.7022 4.0241-4.9668 4.0241a7.3717 7.3717 0 01-1.84-.207 1.23 1.23 0 00-.8505 1.0808c0 .5979.5058.8967 1.5634.8967h3.2193c2.9433 0 4.208 1.2649 4.208 3.4263C29.28 27.5183 27.5781 28.875 22.98 28.875zm1.4941-4.7371H20.3809A1.474 1.474 0 0019.76 25.38c0 .92.69 1.4717 2.5293 1.4717h1.4716c1.9092 0 2.76-.4829 2.76-1.4946C26.5205 24.5979 25.9688 24.1379 24.4736 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1611-1.84s-2.1621.6209-2.1621 1.84v.3912c0 1.1955.7588 1.84 2.1621 1.84S25.1406 17.17 25.1406 15.9749zM4.603 24V7.95h7.22c2.9668 0 4.76 2 4.76 4.967 0 2.9893-1.7935 4.9668-4.76 4.9668H7.6387V24zm3.0357-8.738h3.9092a1.6886 1.6886 0 001.8852-1.8167V12.3875a1.672 1.672 0 00-1.8852-1.7935H7.6387z"
    })), children);
  });
  var DatabasePostgreSql16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabasePostgreSql16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$k || (_path360$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.98 28.875c-4.0474 0-5.5879-1.0579-5.5879-2.8284a2.2112 2.2112 0 012.1387-2.3v-.253a1.9725 1.9725 0 01-1.541-2c0-1.242 1.0576-1.8628 2.2075-2.1158v-.0918a3.622 3.622 0 01-2.1846-3.4953c0-2.4375 1.7246-4.07 4.9673-4.07a6.6768 6.6768 0 012.0923.2988v-.3908a1.5341 1.5341 0 011.7016-1.7476h1.8623v2.2534H26.0835v.322a3.5926 3.5926 0 011.8628 3.3343c0 2.4145-1.7022 4.0241-4.9668 4.0241a7.3717 7.3717 0 01-1.84-.207 1.23 1.23 0 00-.8505 1.0808c0 .5979.5058.8967 1.5634.8967h3.2193c2.9433 0 4.208 1.2649 4.208 3.4263C29.28 27.5183 27.5781 28.875 22.98 28.875zm1.4941-4.7371H20.3809A1.474 1.474 0 0019.76 25.38c0 .92.69 1.4717 2.5293 1.4717h1.4716c1.9092 0 2.76-.4829 2.76-1.4946C26.5205 24.5979 25.9688 24.1379 24.4736 24.1379zm.667-8.163v-.3912c0-1.2187-.7588-1.84-2.1611-1.84s-2.1621.6209-2.1621 1.84v.3912c0 1.1955.7588 1.84 2.1621 1.84S25.1406 17.17 25.1406 15.9749zM4.603 24V7.95h7.22c2.9668 0 4.76 2 4.76 4.967 0 2.9893-1.7935 4.9668-4.76 4.9668H7.6387V24zm3.0357-8.738h3.9092a1.6886 1.6886 0 001.8852-1.8167V12.3875a1.672 1.672 0 00-1.8852-1.7935H7.6387z"
    })), children);
  });
  var DatabaseRabbit32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRabbit32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$j || (_path361$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.9434 20.7346c0-2.46 1.8623-3.6792 5.1279-3.6792h2.0464v-.8738c0-1.3337-.6665-2.1154-2.23-2.1154a3.1249 3.1249 0 00-2.7363 1.5175L18.4033 14.02a5.0544 5.0544 0 014.6909-2.3c3.2422 0 4.9668 1.54 4.9668 4.2771v5.6567h1.1958V24H27.624a2.184 2.184 0 01-2.23-2.07h-.1377c-.3912 1.5408-1.7017 2.3455-3.4952 2.3455C19.3232 24.2759 17.9434 22.8733 17.9434 20.7346zm7.1743-.3218V18.8262H23.2324c-1.541 0-2.3.5288-2.3 1.4717v.3908c0 .9658.667 1.4488 1.8164 1.4488C24.06 22.1375 25.1177 21.54 25.1177 20.4128zM6.9717 24H3.9365V7.95H11.18c2.92 0 4.7373 1.9316 4.7373 4.967a4.4237 4.4237 0 01-2.9893 4.553L16.2158 24h-3.38L9.8462 17.8145H6.9717zm3.9092-8.738a1.689 1.689 0 001.8857-1.8167V12.3875a1.6723 1.6723 0 00-1.8857-1.7935H6.9717v4.668z"
    })), children);
  });
  var DatabaseRabbit24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRabbit24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$j || (_path362$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.9434 20.7346c0-2.46 1.8623-3.6792 5.1279-3.6792h2.0464v-.8738c0-1.3337-.6665-2.1154-2.23-2.1154a3.1249 3.1249 0 00-2.7363 1.5175L18.4033 14.02a5.0544 5.0544 0 014.6909-2.3c3.2422 0 4.9668 1.54 4.9668 4.2771v5.6567h1.1958V24H27.624a2.184 2.184 0 01-2.23-2.07h-.1377c-.3912 1.5408-1.7017 2.3455-3.4952 2.3455C19.3232 24.2759 17.9434 22.8733 17.9434 20.7346zm7.1743-.3218V18.8262H23.2324c-1.541 0-2.3.5288-2.3 1.4717v.3908c0 .9658.667 1.4488 1.8164 1.4488C24.06 22.1375 25.1177 21.54 25.1177 20.4128zM6.9717 24H3.9365V7.95H11.18c2.92 0 4.7373 1.9316 4.7373 4.967a4.4237 4.4237 0 01-2.9893 4.553L16.2158 24h-3.38L9.8462 17.8145H6.9717zm3.9092-8.738a1.689 1.689 0 001.8857-1.8167V12.3875a1.6723 1.6723 0 00-1.8857-1.7935H6.9717v4.668z"
    })), children);
  });

  var _path$m, _path2$m, _path3$m, _path4$m, _path5$m, _path6$m, _circle$l, _path7$m, _circle2$l, _path8$m, _path9$m, _circle3$l, _path10$m, _circle4$k, _path11$m, _path12$m, _circle5$j, _path13$m, _circle6$j, _path14$m, _path15$m, _circle7$j, _path16$m, _circle8$j, _path17$m, _path18$m, _path19$m, _path20$m, _path21$m, _path22$m, _path23$m, _path24$m, _path25$m, _path26$m, _path27$m, _path28$m, _path29$m, _path30$m, _path31$m, _path32$m, _path33$m, _path34$m, _path35$m, _path36$m, _path37$m, _path38$m, _path39$m, _path40$m, _path41$m, _path42$m, _path43$m, _path44$m, _path45$m, _path46$m, _path47$m, _path48$m, _path49$m, _path50$m, _path51$m, _path52$m, _path53$m, _path54$m, _path55$m, _path56$m, _path57$m, _path58$m, _path59$m, _path60$m, _path61$m, _path62$m, _path63$m, _path64$m, _path65$m, _path66$m, _path67$m, _path68$m, _path69$m, _path70$m, _path71$m, _path72$m, _path73$m, _path74$m, _path75$m, _path76$m, _path77$m, _path78$m, _path79$m, _path80$m, _path81$m, _path82$m, _path83$m, _path84$m, _path85$m, _path86$m, _path87$m, _path88$m, _path89$m, _path90$m, _path91$m, _path92$m, _path93$m, _path94$m, _path95$m, _path96$m, _path97$m, _path98$m, _path99$m, _path100$m, _path101$m, _path102$m, _path103$m, _path104$m, _path105$m, _path106$m, _path107$m, _path108$m, _path109$m, _path110$m, _path111$m, _path112$m, _path113$m, _path114$m, _path115$m, _path116$m, _path117$m, _path118$m, _path119$m, _path120$m, _path121$m, _path122$m, _path123$m, _path124$m, _path125$m, _path126$m, _path127$m, _path128$m, _path129$m, _path130$m, _path131$m, _path132$m, _path133$m, _path134$m, _path135$m, _path136$m, _path137$m, _path138$m, _path139$m, _path140$m, _path141$m, _path142$m, _path143$m, _path144$m, _path145$m, _path146$m, _path147$m, _path148$m, _path149$m, _path150$m, _path151$m, _path152$m, _path153$m, _path154$m, _path155$m, _path156$m, _path157$m, _path158$m, _path159$m, _path160$m, _path161$m, _path162$m, _path163$m, _path164$m, _path165$m, _path166$m, _path167$m, _path168$m, _path169$m, _path170$m, _path171$m, _path172$m, _path173$m, _path174$m, _path175$m, _path176$m, _path177$l, _path178$l, _path179$l, _path180$l, _path181$l, _path182$l, _path183$l, _path184$l, _path185$l, _path186$l, _path187$l, _path188$l, _path189$l, _path190$l, _path191$l, _path192$l, _path193$l, _path194$l, _path195$l, _path196$l, _path197$l, _path198$l, _path199$l, _path200$l, _path201$l, _path202$l, _path203$l, _path204$l, _path205$l, _path206$l, _path207$l, _path208$l, _path209$l, _path210$l, _path211$l, _path212$l, _path213$l, _path214$l, _path215$l, _path216$l, _path217$l, _path218$l, _path219$l, _path220$l, _path221$l, _path222$l, _path223$l, _path224$l, _path225$l, _path226$l, _path227$l, _path228$l, _path229$l, _path230$l, _path231$l, _path232$l, _path233$l, _path234$l, _path235$l, _path236$l, _path237$l, _path238$l, _path239$l, _path240$l, _path241$l, _path242$l, _path243$l, _path244$l, _path245$l, _path246$l, _path247$l, _path248$l, _path249$l, _path250$l, _path251$l, _path252$l, _path253$l, _path254$l, _path255$l, _path256$l, _path257$l, _path258$l, _path259$l, _path260$l, _path261$l, _path262$l, _path263$l, _path264$l, _path265$l, _path266$l, _path267$l, _path268$l, _path269$l, _path270$l, _path271$l, _path272$l, _path273$l, _path274$l, _path275$l, _path276$l, _path277$l, _path278$l, _path279$l, _path280$l, _path281$l, _path282$l, _path283$l, _path284$l, _path285$l, _path286$l, _path287$l, _path288$l, _path289$l, _path290$l, _path291$l, _path292$l, _path293$l, _path294$l, _path295$l, _path296$l, _path297$l, _path298$l, _path299$l, _path300$l, _path301$l, _path302$l, _path303$l, _path304$l, _path305$l, _path306$l, _path307$l, _path308$l, _path309$l, _path310$l, _path311$l, _path312$l, _path313$l, _path314$l, _path315$l, _path316$l, _path317$l, _path318$l, _path319$l, _path320$l, _path321$l, _path322$l, _path323$l, _path324$l, _path325$l, _path326$l, _path327$l, _path328$l, _path329$l, _path330$l, _path331$l, _path332$l, _path333$l, _path334$l, _path335$l, _path336$l, _path337$l, _path338$k, _path339$k, _path340$k, _path341$k, _path342$k, _path343$k, _path344$k, _path345$k, _path346$k, _circle9$j, _path347$k, _path348$k, _circle10$j, _path349$k, _path350$k, _circle11$i, _path351$k, _path352$k, _circle12$i, _path353$k, _path354$k, _path355$j, _path356$j, _path357$j, _path358$j, _circle13$i, _path359$j, _path360$j, _circle14$i, _path361$i, _path362$i, _circle15$i, _path363$i, _path364$i, _circle16$i, _path365$i, _path366$i, _path367$i, _path368$i, _path369$i, _path370$i, _circle17$h, _path371$i, _path372$i, _circle18$h, _path373$i, _path374$i, _circle19$h, _path375$h, _path376$h, _circle20$h, _path377$h, _path378$h, _path379$h, _path380$h, _path381$h, _path382$h, _path383$h, _path384$g, _path385$g, _path386$g, _path387$g, _path388$g, _path389$g, _path390$g, _path391$g, _path392$g, _path393$g, _path394$g, _path395$g, _path396$g, _path397$g, _path398$g, _path399$f, _path400$f, _path401$f, _path402$f, _path403$e, _path404$e, _path405$e, _path406$e;

  var _excluded$m = ["children"],
      _excluded2$m = ["children"],
      _excluded3$m = ["children"],
      _excluded4$m = ["children"],
      _excluded5$m = ["children"],
      _excluded6$m = ["children"],
      _excluded7$m = ["children"],
      _excluded8$m = ["children"],
      _excluded9$m = ["children"],
      _excluded10$m = ["children"],
      _excluded11$m = ["children"],
      _excluded12$m = ["children"],
      _excluded13$m = ["children"],
      _excluded14$m = ["children"],
      _excluded15$m = ["children"],
      _excluded16$m = ["children"],
      _excluded17$m = ["children"],
      _excluded18$m = ["children"],
      _excluded19$m = ["children"],
      _excluded20$m = ["children"],
      _excluded21$m = ["children"],
      _excluded22$m = ["children"],
      _excluded23$m = ["children"],
      _excluded24$m = ["children"],
      _excluded25$m = ["children"],
      _excluded26$m = ["children"],
      _excluded27$m = ["children"],
      _excluded28$m = ["children"],
      _excluded29$m = ["children"],
      _excluded30$m = ["children"],
      _excluded31$m = ["children"],
      _excluded32$m = ["children"],
      _excluded33$m = ["children"],
      _excluded34$m = ["children"],
      _excluded35$m = ["children"],
      _excluded36$m = ["children"],
      _excluded37$m = ["children"],
      _excluded38$m = ["children"],
      _excluded39$m = ["children"],
      _excluded40$m = ["children"],
      _excluded41$m = ["children"],
      _excluded42$m = ["children"],
      _excluded43$m = ["children"],
      _excluded44$m = ["children"],
      _excluded45$m = ["children"],
      _excluded46$m = ["children"],
      _excluded47$m = ["children"],
      _excluded48$m = ["children"],
      _excluded49$m = ["children"],
      _excluded50$m = ["children"],
      _excluded51$m = ["children"],
      _excluded52$m = ["children"],
      _excluded53$m = ["children"],
      _excluded54$m = ["children"],
      _excluded55$m = ["children"],
      _excluded56$m = ["children"],
      _excluded57$m = ["children"],
      _excluded58$m = ["children"],
      _excluded59$m = ["children"],
      _excluded60$m = ["children"],
      _excluded61$m = ["children"],
      _excluded62$m = ["children"],
      _excluded63$m = ["children"],
      _excluded64$m = ["children"],
      _excluded65$m = ["children"],
      _excluded66$m = ["children"],
      _excluded67$m = ["children"],
      _excluded68$m = ["children"],
      _excluded69$m = ["children"],
      _excluded70$m = ["children"],
      _excluded71$m = ["children"],
      _excluded72$m = ["children"],
      _excluded73$m = ["children"],
      _excluded74$m = ["children"],
      _excluded75$m = ["children"],
      _excluded76$m = ["children"],
      _excluded77$m = ["children"],
      _excluded78$m = ["children"],
      _excluded79$m = ["children"],
      _excluded80$m = ["children"],
      _excluded81$m = ["children"],
      _excluded82$m = ["children"],
      _excluded83$m = ["children"],
      _excluded84$m = ["children"],
      _excluded85$m = ["children"],
      _excluded86$m = ["children"],
      _excluded87$m = ["children"],
      _excluded88$m = ["children"],
      _excluded89$m = ["children"],
      _excluded90$m = ["children"],
      _excluded91$m = ["children"],
      _excluded92$m = ["children"],
      _excluded93$m = ["children"],
      _excluded94$m = ["children"],
      _excluded95$m = ["children"],
      _excluded96$m = ["children"],
      _excluded97$m = ["children"],
      _excluded98$m = ["children"],
      _excluded99$m = ["children"],
      _excluded100$m = ["children"],
      _excluded101$m = ["children"],
      _excluded102$m = ["children"],
      _excluded103$m = ["children"],
      _excluded104$m = ["children"],
      _excluded105$m = ["children"],
      _excluded106$m = ["children"],
      _excluded107$m = ["children"],
      _excluded108$m = ["children"],
      _excluded109$m = ["children"],
      _excluded110$m = ["children"],
      _excluded111$m = ["children"],
      _excluded112$m = ["children"],
      _excluded113$m = ["children"],
      _excluded114$m = ["children"],
      _excluded115$m = ["children"],
      _excluded116$m = ["children"],
      _excluded117$m = ["children"],
      _excluded118$m = ["children"],
      _excluded119$l = ["children"],
      _excluded120$l = ["children"],
      _excluded121$l = ["children"],
      _excluded122$l = ["children"],
      _excluded123$l = ["children"],
      _excluded124$l = ["children"],
      _excluded125$l = ["children"],
      _excluded126$l = ["children"],
      _excluded127$l = ["children"],
      _excluded128$l = ["children"],
      _excluded129$l = ["children"],
      _excluded130$l = ["children"],
      _excluded131$l = ["children"],
      _excluded132$l = ["children"],
      _excluded133$l = ["children"],
      _excluded134$l = ["children"],
      _excluded135$l = ["children"],
      _excluded136$l = ["children"],
      _excluded137$l = ["children"],
      _excluded138$l = ["children"],
      _excluded139$l = ["children"],
      _excluded140$l = ["children"],
      _excluded141$l = ["children"],
      _excluded142$l = ["children"],
      _excluded143$l = ["children"],
      _excluded144$l = ["children"],
      _excluded145$l = ["children"],
      _excluded146$l = ["children"],
      _excluded147$l = ["children"],
      _excluded148$l = ["children"],
      _excluded149$l = ["children"],
      _excluded150$l = ["children"],
      _excluded151$l = ["children"],
      _excluded152$l = ["children"],
      _excluded153$l = ["children"],
      _excluded154$l = ["children"],
      _excluded155$l = ["children"],
      _excluded156$l = ["children"],
      _excluded157$l = ["children"],
      _excluded158$l = ["children"],
      _excluded159$l = ["children"],
      _excluded160$l = ["children"],
      _excluded161$l = ["children"],
      _excluded162$l = ["children"],
      _excluded163$l = ["children"],
      _excluded164$l = ["children"],
      _excluded165$l = ["children"],
      _excluded166$l = ["children"],
      _excluded167$l = ["children"],
      _excluded168$l = ["children"],
      _excluded169$l = ["children"],
      _excluded170$l = ["children"],
      _excluded171$l = ["children"],
      _excluded172$l = ["children"],
      _excluded173$l = ["children"],
      _excluded174$l = ["children"],
      _excluded175$l = ["children"],
      _excluded176$l = ["children"],
      _excluded177$l = ["children"],
      _excluded178$l = ["children"],
      _excluded179$l = ["children"],
      _excluded180$l = ["children"],
      _excluded181$l = ["children"],
      _excluded182$l = ["children"],
      _excluded183$l = ["children"],
      _excluded184$l = ["children"],
      _excluded185$l = ["children"],
      _excluded186$l = ["children"],
      _excluded187$l = ["children"],
      _excluded188$l = ["children"],
      _excluded189$l = ["children"],
      _excluded190$l = ["children"],
      _excluded191$l = ["children"],
      _excluded192$l = ["children"],
      _excluded193$l = ["children"],
      _excluded194$l = ["children"],
      _excluded195$l = ["children"],
      _excluded196$l = ["children"],
      _excluded197$l = ["children"],
      _excluded198$l = ["children"],
      _excluded199$l = ["children"],
      _excluded200$l = ["children"],
      _excluded201$l = ["children"],
      _excluded202$l = ["children"],
      _excluded203$l = ["children"],
      _excluded204$l = ["children"],
      _excluded205$l = ["children"],
      _excluded206$l = ["children"],
      _excluded207$l = ["children"],
      _excluded208$l = ["children"],
      _excluded209$l = ["children"],
      _excluded210$l = ["children"],
      _excluded211$l = ["children"],
      _excluded212$l = ["children"],
      _excluded213$l = ["children"],
      _excluded214$l = ["children"],
      _excluded215$l = ["children"],
      _excluded216$l = ["children"],
      _excluded217$l = ["children"],
      _excluded218$l = ["children"],
      _excluded219$l = ["children"],
      _excluded220$l = ["children"],
      _excluded221$l = ["children"],
      _excluded222$l = ["children"],
      _excluded223$l = ["children"],
      _excluded224$l = ["children"],
      _excluded225$l = ["children"],
      _excluded226$l = ["children"],
      _excluded227$l = ["children"],
      _excluded228$l = ["children"],
      _excluded229$l = ["children"],
      _excluded230$l = ["children"],
      _excluded231$l = ["children"],
      _excluded232$l = ["children"],
      _excluded233$l = ["children"],
      _excluded234$l = ["children"],
      _excluded235$l = ["children"],
      _excluded236$l = ["children"],
      _excluded237$l = ["children"],
      _excluded238$l = ["children"],
      _excluded239$l = ["children"],
      _excluded240$l = ["children"],
      _excluded241$l = ["children"],
      _excluded242$l = ["children"],
      _excluded243$l = ["children"],
      _excluded244$l = ["children"],
      _excluded245$l = ["children"],
      _excluded246$l = ["children"],
      _excluded247$l = ["children"],
      _excluded248$l = ["children"],
      _excluded249$l = ["children"],
      _excluded250$l = ["children"];
  var didWarnAboutDeprecation$8 = {};
  var DatabaseRabbit20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRabbit20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$m || (_path$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.9434 20.7346c0-2.46 1.8623-3.6792 5.1279-3.6792h2.0464v-.8738c0-1.3337-.6665-2.1154-2.23-2.1154a3.1249 3.1249 0 00-2.7363 1.5175L18.4033 14.02a5.0544 5.0544 0 014.6909-2.3c3.2422 0 4.9668 1.54 4.9668 4.2771v5.6567h1.1958V24H27.624a2.184 2.184 0 01-2.23-2.07h-.1377c-.3912 1.5408-1.7017 2.3455-3.4952 2.3455C19.3232 24.2759 17.9434 22.8733 17.9434 20.7346zm7.1743-.3218V18.8262H23.2324c-1.541 0-2.3.5288-2.3 1.4717v.3908c0 .9658.667 1.4488 1.8164 1.4488C24.06 22.1375 25.1177 21.54 25.1177 20.4128zM6.9717 24H3.9365V7.95H11.18c2.92 0 4.7373 1.9316 4.7373 4.967a4.4237 4.4237 0 01-2.9893 4.553L16.2158 24h-3.38L9.8462 17.8145H6.9717zm3.9092-8.738a1.689 1.689 0 001.8857-1.8167V12.3875a1.6723 1.6723 0 00-1.8857-1.7935H6.9717v4.668z"
    })), children);
  });
  var DatabaseRabbit16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRabbit16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$m || (_path2$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.9434 20.7346c0-2.46 1.8623-3.6792 5.1279-3.6792h2.0464v-.8738c0-1.3337-.6665-2.1154-2.23-2.1154a3.1249 3.1249 0 00-2.7363 1.5175L18.4033 14.02a5.0544 5.0544 0 014.6909-2.3c3.2422 0 4.9668 1.54 4.9668 4.2771v5.6567h1.1958V24H27.624a2.184 2.184 0 01-2.23-2.07h-.1377c-.3912 1.5408-1.7017 2.3455-3.4952 2.3455C19.3232 24.2759 17.9434 22.8733 17.9434 20.7346zm7.1743-.3218V18.8262H23.2324c-1.541 0-2.3.5288-2.3 1.4717v.3908c0 .9658.667 1.4488 1.8164 1.4488C24.06 22.1375 25.1177 21.54 25.1177 20.4128zM6.9717 24H3.9365V7.95H11.18c2.92 0 4.7373 1.9316 4.7373 4.967a4.4237 4.4237 0 01-2.9893 4.553L16.2158 24h-3.38L9.8462 17.8145H6.9717zm3.9092-8.738a1.689 1.689 0 001.8857-1.8167V12.3875a1.6723 1.6723 0 00-1.8857-1.7935H6.9717v4.668z"
    })), children);
  });
  var DatabaseRedis32 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRedis32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$m || (_path3$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7156 22h-.115a3.371 3.371 0 01-3.3113 2.2764c-3.0124 0-4.6912-2.2764-4.6912-6.3006 0-4.0012 1.6788-6.2546 4.6912-6.2546a3.3049 3.3049 0 013.3113 2.2534h.115v-6.99h2.9433V24H25.7156zm0-2.1157V16.0667c0-1.1727-1.0808-1.9314-2.4837-1.9314A2.556 2.556 0 0020.68 16.9636v2.07a2.5365 2.5365 0 002.5522 2.8052C24.6348 21.8384 25.7156 21.1257 25.7156 19.8838zM6.5576 24H3.5222V7.95h7.2434c2.92 0 4.7371 1.9316 4.7371 4.967a4.4237 4.4237 0 01-2.9893 4.553L15.8018 24h-3.38L9.4321 17.8145H6.5576zm3.9092-8.738a1.6888 1.6888 0 001.8855-1.8167V12.3875a1.6722 1.6722 0 00-1.8855-1.7935H6.5576v4.668z"
    })), children);
  });
  var DatabaseRedis24 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRedis24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$m || (_path4$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7156 22h-.115a3.371 3.371 0 01-3.3113 2.2764c-3.0124 0-4.6912-2.2764-4.6912-6.3006 0-4.0012 1.6788-6.2546 4.6912-6.2546a3.3049 3.3049 0 013.3113 2.2534h.115v-6.99h2.9433V24H25.7156zm0-2.1157V16.0667c0-1.1727-1.0808-1.9314-2.4837-1.9314A2.556 2.556 0 0020.68 16.9636v2.07a2.5365 2.5365 0 002.5522 2.8052C24.6348 21.8384 25.7156 21.1257 25.7156 19.8838zM6.5576 24H3.5222V7.95h7.2434c2.92 0 4.7371 1.9316 4.7371 4.967a4.4237 4.4237 0 01-2.9893 4.553L15.8018 24h-3.38L9.4321 17.8145H6.5576zm3.9092-8.738a1.6888 1.6888 0 001.8855-1.8167V12.3875a1.6722 1.6722 0 00-1.8855-1.7935H6.5576v4.668z"
    })), children);
  });
  var DatabaseRedis20 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRedis20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$m || (_path5$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7156 22h-.115a3.371 3.371 0 01-3.3113 2.2764c-3.0124 0-4.6912-2.2764-4.6912-6.3006 0-4.0012 1.6788-6.2546 4.6912-6.2546a3.3049 3.3049 0 013.3113 2.2534h.115v-6.99h2.9433V24H25.7156zm0-2.1157V16.0667c0-1.1727-1.0808-1.9314-2.4837-1.9314A2.556 2.556 0 0020.68 16.9636v2.07a2.5365 2.5365 0 002.5522 2.8052C24.6348 21.8384 25.7156 21.1257 25.7156 19.8838zM6.5576 24H3.5222V7.95h7.2434c2.92 0 4.7371 1.9316 4.7371 4.967a4.4237 4.4237 0 01-2.9893 4.553L15.8018 24h-3.38L9.4321 17.8145H6.5576zm3.9092-8.738a1.6888 1.6888 0 001.8855-1.8167V12.3875a1.6722 1.6722 0 00-1.8855-1.7935H6.5576v4.668z"
    })), children);
  });
  var DatabaseRedis16 = /*#__PURE__*/React__default['default'].forwardRef(function DatabaseRedis16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$m || (_path6$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7156 22h-.115a3.371 3.371 0 01-3.3113 2.2764c-3.0124 0-4.6912-2.2764-4.6912-6.3006 0-4.0012 1.6788-6.2546 4.6912-6.2546a3.3049 3.3049 0 013.3113 2.2534h.115v-6.99h2.9433V24H25.7156zm0-2.1157V16.0667c0-1.1727-1.0808-1.9314-2.4837-1.9314A2.556 2.556 0 0020.68 16.9636v2.07a2.5365 2.5365 0 002.5522 2.8052C24.6348 21.8384 25.7156 21.1257 25.7156 19.8838zM6.5576 24H3.5222V7.95h7.2434c2.92 0 4.7371 1.9316 4.7371 4.967a4.4237 4.4237 0 01-2.9893 4.553L15.8018 24h-3.38L9.4321 17.8145H6.5576zm3.9092-8.738a1.6888 1.6888 0 001.8855-1.8167V12.3875a1.6722 1.6722 0 00-1.8855-1.7935H6.5576v4.668z"
    })), children);
  });
  var Datastore32 = /*#__PURE__*/React__default['default'].forwardRef(function Datastore32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$l || (_circle$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "23",
      r: "1"
    })), _path7$m || (_path7$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H20V24H8z"
    })), _circle2$l || (_circle2$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "9",
      r: "1"
    })), _path8$m || (_path8$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H20V10H8z"
    })), _path9$m || (_path9$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"
    })), children);
  });
  var Datastore24 = /*#__PURE__*/React__default['default'].forwardRef(function Datastore24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$l || (_circle3$l = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "23",
      r: "1"
    })), _path10$m || (_path10$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H20V24H8z"
    })), _circle4$k || (_circle4$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "9",
      r: "1"
    })), _path11$m || (_path11$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H20V10H8z"
    })), _path12$m || (_path12$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"
    })), children);
  });
  var Datastore20 = /*#__PURE__*/React__default['default'].forwardRef(function Datastore20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$j || (_circle5$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "23",
      r: "1"
    })), _path13$m || (_path13$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H20V24H8z"
    })), _circle6$j || (_circle6$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "9",
      r: "1"
    })), _path14$m || (_path14$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H20V10H8z"
    })), _path15$m || (_path15$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"
    })), children);
  });
  var Datastore16 = /*#__PURE__*/React__default['default'].forwardRef(function Datastore16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$j || (_circle7$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "23",
      r: "1"
    })), _path16$m || (_path16$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H20V24H8z"
    })), _circle8$j || (_circle8$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "9",
      r: "1"
    })), _path17$m || (_path17$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H20V10H8z"
    })), _path18$m || (_path18$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"
    })), children);
  });
  var Debug32 = /*#__PURE__*/React__default['default'].forwardRef(function Debug32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$m || (_path19$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"
    })), children);
  });
  var Debug24 = /*#__PURE__*/React__default['default'].forwardRef(function Debug24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$m || (_path20$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"
    })), children);
  });
  var Debug20 = /*#__PURE__*/React__default['default'].forwardRef(function Debug20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$m || (_path21$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"
    })), children);
  });
  var Debug16 = /*#__PURE__*/React__default['default'].forwardRef(function Debug16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$m || (_path22$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"
    })), children);
  });
  var DecisionTree32 = /*#__PURE__*/React__default['default'].forwardRef(function DecisionTree32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$m || (_path23$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,12V4H22V7H18a2.0023,2.0023,0,0,0-2,2v6H10V12H2v8h8V17h6v6a2.0023,2.0023,0,0,0,2,2h4v3h8V20H22v3H18V9h4v3ZM8,18H4V14H8Zm16,4h4v4H24ZM24,6h4v4H24Z"
    })), children);
  });
  var DecisionTree24 = /*#__PURE__*/React__default['default'].forwardRef(function DecisionTree24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$m || (_path24$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,12V4H22V7H18a2.0023,2.0023,0,0,0-2,2v6H10V12H2v8h8V17h6v6a2.0023,2.0023,0,0,0,2,2h4v3h8V20H22v3H18V9h4v3ZM8,18H4V14H8Zm16,4h4v4H24ZM24,6h4v4H24Z"
    })), children);
  });
  var DecisionTree20 = /*#__PURE__*/React__default['default'].forwardRef(function DecisionTree20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$m || (_path25$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,12V4H22V7H18a2.0023,2.0023,0,0,0-2,2v6H10V12H2v8h8V17h6v6a2.0023,2.0023,0,0,0,2,2h4v3h8V20H22v3H18V9h4v3ZM8,18H4V14H8Zm16,4h4v4H24ZM24,6h4v4H24Z"
    })), children);
  });
  var DecisionTree16 = /*#__PURE__*/React__default['default'].forwardRef(function DecisionTree16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$m || (_path26$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,12V4H22V7H18a2.0023,2.0023,0,0,0-2,2v6H10V12H2v8h8V17h6v6a2.0023,2.0023,0,0,0,2,2h4v3h8V20H22v3H18V9h4v3ZM8,18H4V14H8Zm16,4h4v4H24ZM24,6h4v4H24Z"
    })), children);
  });
  var Delete32 = /*#__PURE__*/React__default['default'].forwardRef(function Delete32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$m);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$8['Delete32']) {
        didWarnAboutDeprecation$8['Delete32'] = true;
        console.warn("The Delete32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$m || (_path27$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path28$m || (_path28$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var Delete24 = /*#__PURE__*/React__default['default'].forwardRef(function Delete24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$m);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$8['Delete24']) {
        didWarnAboutDeprecation$8['Delete24'] = true;
        console.warn("The Delete24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$m || (_path29$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path30$m || (_path30$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var Delete20 = /*#__PURE__*/React__default['default'].forwardRef(function Delete20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$m);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$8['Delete20']) {
        didWarnAboutDeprecation$8['Delete20'] = true;
        console.warn("The Delete20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$m || (_path31$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path32$m || (_path32$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var Delete16 = /*#__PURE__*/React__default['default'].forwardRef(function Delete16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$m);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$8['Delete16']) {
        didWarnAboutDeprecation$8['Delete16'] = true;
        console.warn("The Delete16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$m || (_path33$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path34$m || (_path34$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var Delivery32 = /*#__PURE__*/React__default['default'].forwardRef(function Delivery32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$m || (_path35$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V18H4zM2 11H12V13H2z"
    })), _path36$m || (_path36$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H6V8H21V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a4,4,0,1,0,0,2h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var Delivery24 = /*#__PURE__*/React__default['default'].forwardRef(function Delivery24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$m || (_path37$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V18H4zM2 11H12V13H2z"
    })), _path38$m || (_path38$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H6V8H21V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a4,4,0,1,0,0,2h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var Delivery20 = /*#__PURE__*/React__default['default'].forwardRef(function Delivery20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$m || (_path39$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V18H4zM2 11H12V13H2z"
    })), _path40$m || (_path40$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H6V8H21V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a4,4,0,1,0,0,2h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var Delivery16 = /*#__PURE__*/React__default['default'].forwardRef(function Delivery16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$m || (_path41$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V18H4zM2 11H12V13H2z"
    })), _path42$m || (_path42$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H6V8H21V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a4,4,0,1,0,0,2h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryAdd32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$m || (_path43$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6z"
    })), _path44$m || (_path44$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H15V8h6V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V14H2V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryAdd24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$m || (_path45$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6z"
    })), _path46$m || (_path46$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H15V8h6V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V14H2V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryAdd20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$m || (_path47$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6z"
    })), _path48$m || (_path48$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H15V8h6V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V14H2V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryAdd16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$m || (_path49$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6z"
    })), _path50$m || (_path50$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9189,16.6064l-3-7A.9985.9985,0,0,0,26,9H23V7a1,1,0,0,0-1-1H15V8h6V20.5562A3.9924,3.9924,0,0,0,19.1421,23H12.8579a3.9806,3.9806,0,0,0-7.7158,0H4V14H2V24a1,1,0,0,0,1,1H5.1421a3.9806,3.9806,0,0,0,7.7158,0h6.2842a3.9806,3.9806,0,0,0,7.7158,0H29a1,1,0,0,0,1-1V17A.9965.9965,0,0,0,29.9189,16.6064ZM9,26a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,9,26ZM23,11h2.3408l2.1431,5H23Zm0,15a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,23,26Zm5-3H26.8579A3.9954,3.9954,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryParcel32 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryParcel32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$m || (_path51$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4819,8.624l-10-5.5a1,1,0,0,0-.9638,0l-10,5.5a1,1,0,0,0,0,1.752L18,15.5913V26.3086l-3.0362-1.6693L14,26.3912l4.5181,2.4848a.9984.9984,0,0,0,.9638,0l10-5.5A1,1,0,0,0,30,22.5V9.5A1,1,0,0,0,29.4819,8.624ZM19,5.1416,26.9248,9.5,19,13.8584,11.0752,9.5Zm9,16.7671-8,4.4V15.5913l8-4.4Z"
    })), _path52$m || (_path52$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 14H10V16H2z",
      transform: "rotate(-180 6 15)"
    })), _path53$m || (_path53$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H12V24H4z",
      transform: "rotate(-180 8 23)"
    })), _path54$m || (_path54$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18H14V20H6z",
      transform: "rotate(-180 10 19)"
    })), children);
  });
  var DeliveryParcel24 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryParcel24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$m || (_path55$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4819,8.624l-10-5.5a1,1,0,0,0-.9638,0l-10,5.5a1,1,0,0,0,0,1.752L18,15.5913V26.3086l-3.0362-1.6693L14,26.3912l4.5181,2.4848a.9984.9984,0,0,0,.9638,0l10-5.5A1,1,0,0,0,30,22.5V9.5A1,1,0,0,0,29.4819,8.624ZM19,5.1416,26.9248,9.5,19,13.8584,11.0752,9.5Zm9,16.7671-8,4.4V15.5913l8-4.4Z"
    })), _path56$m || (_path56$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 14H10V16H2z",
      transform: "rotate(-180 6 15)"
    })), _path57$m || (_path57$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H12V24H4z",
      transform: "rotate(-180 8 23)"
    })), _path58$m || (_path58$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18H14V20H6z",
      transform: "rotate(-180 10 19)"
    })), children);
  });
  var DeliveryParcel20 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryParcel20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$m || (_path59$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4819,8.624l-10-5.5a1,1,0,0,0-.9638,0l-10,5.5a1,1,0,0,0,0,1.752L18,15.5913V26.3086l-3.0362-1.6693L14,26.3912l4.5181,2.4848a.9984.9984,0,0,0,.9638,0l10-5.5A1,1,0,0,0,30,22.5V9.5A1,1,0,0,0,29.4819,8.624ZM19,5.1416,26.9248,9.5,19,13.8584,11.0752,9.5Zm9,16.7671-8,4.4V15.5913l8-4.4Z"
    })), _path60$m || (_path60$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 14H10V16H2z",
      transform: "rotate(-180 6 15)"
    })), _path61$m || (_path61$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H12V24H4z",
      transform: "rotate(-180 8 23)"
    })), _path62$m || (_path62$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18H14V20H6z",
      transform: "rotate(-180 10 19)"
    })), children);
  });
  var DeliveryParcel16 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryParcel16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$m || (_path63$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4819,8.624l-10-5.5a1,1,0,0,0-.9638,0l-10,5.5a1,1,0,0,0,0,1.752L18,15.5913V26.3086l-3.0362-1.6693L14,26.3912l4.5181,2.4848a.9984.9984,0,0,0,.9638,0l10-5.5A1,1,0,0,0,30,22.5V9.5A1,1,0,0,0,29.4819,8.624ZM19,5.1416,26.9248,9.5,19,13.8584,11.0752,9.5Zm9,16.7671-8,4.4V15.5913l8-4.4Z"
    })), _path64$m || (_path64$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 14H10V16H2z",
      transform: "rotate(-180 6 15)"
    })), _path65$m || (_path65$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H12V24H4z",
      transform: "rotate(-180 8 23)"
    })), _path66$m || (_path66$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18H14V20H6z",
      transform: "rotate(-180 10 19)"
    })), children);
  });
  var DeliveryTruck32 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryTruck32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$m || (_path67$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryTruck24 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryTruck24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$m || (_path68$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryTruck20 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryTruck20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$m || (_path69$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"
    })), children);
  });
  var DeliveryTruck16 = /*#__PURE__*/React__default['default'].forwardRef(function DeliveryTruck16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$m || (_path70$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"
    })), children);
  });
  var WatsonHealthDenominate32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDenominate32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$m || (_path71$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"
    })), _path72$m || (_path72$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var WatsonHealthDenominate24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDenominate24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$m || (_path73$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"
    })), _path74$m || (_path74$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var WatsonHealthDenominate20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDenominate20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$m || (_path75$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"
    })), _path76$m || (_path76$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var WatsonHealthDenominate16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDenominate16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$m || (_path77$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"
    })), _path78$m || (_path78$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var Departure32 = /*#__PURE__*/React__default['default'].forwardRef(function Departure32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$m || (_path79$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 011.12 0A1.84 1.84 0 0128.23 14 1.87 1.87 0 0127 16.45l-18.71 5a1.78 1.78 0 01-1 0A1.87 1.87 0 016 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 00-.5 0l-3.09.83A1 1 0 009.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 00-.52-.36 1.06 1.06 0 00-.5 0L2.72 12A1 1 0 002 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 002.74 2.74 3.91 3.91 0 002 0l18.7-5a3.84 3.84 0 000-7.44 4.27 4.27 0 00-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0014.16 3z"
    })), children);
  });
  var Departure24 = /*#__PURE__*/React__default['default'].forwardRef(function Departure24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$m || (_path80$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 011.12 0A1.84 1.84 0 0128.23 14 1.87 1.87 0 0127 16.45l-18.71 5a1.78 1.78 0 01-1 0A1.87 1.87 0 016 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 00-.5 0l-3.09.83A1 1 0 009.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 00-.52-.36 1.06 1.06 0 00-.5 0L2.72 12A1 1 0 002 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 002.74 2.74 3.91 3.91 0 002 0l18.7-5a3.84 3.84 0 000-7.44 4.27 4.27 0 00-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0014.16 3z"
    })), children);
  });
  var Departure20 = /*#__PURE__*/React__default['default'].forwardRef(function Departure20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$m || (_path81$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 011.12 0A1.84 1.84 0 0128.23 14 1.87 1.87 0 0127 16.45l-18.71 5a1.78 1.78 0 01-1 0A1.87 1.87 0 016 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 00-.5 0l-3.09.83A1 1 0 009.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 00-.52-.36 1.06 1.06 0 00-.5 0L2.72 12A1 1 0 002 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 002.74 2.74 3.91 3.91 0 002 0l18.7-5a3.84 3.84 0 000-7.44 4.27 4.27 0 00-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0014.16 3z"
    })), children);
  });
  var Departure16 = /*#__PURE__*/React__default['default'].forwardRef(function Departure16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$m || (_path82$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 011.12 0A1.84 1.84 0 0128.23 14 1.87 1.87 0 0127 16.45l-18.71 5a1.78 1.78 0 01-1 0A1.87 1.87 0 016 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 00-.5 0l-3.09.83A1 1 0 009.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 00-.52-.36 1.06 1.06 0 00-.5 0L2.72 12A1 1 0 002 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 002.74 2.74 3.91 3.91 0 002 0l18.7-5a3.84 3.84 0 000-7.44 4.27 4.27 0 00-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0014.16 3z"
    })), children);
  });
  var Deploy32 = /*#__PURE__*/React__default['default'].forwardRef(function Deploy32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$m || (_path83$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,2,17,8l1.4146,1.4023L22,5.8184V28H6V12H4V28a2.0025,2.0025,0,0,0,2,2H22a2.0025,2.0025,0,0,0,2-2V5.8154l3.5859,3.5869L29,8Z"
    })), _path84$m || (_path84$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H12a2.0023,2.0023,0,0,1-2-2V18a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,16,24Zm-4-6v4h4V18Z"
    })), children);
  });
  var Deploy24 = /*#__PURE__*/React__default['default'].forwardRef(function Deploy24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$m || (_path85$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,2,17,8l1.4146,1.4023L22,5.8184V28H6V12H4V28a2.0025,2.0025,0,0,0,2,2H22a2.0025,2.0025,0,0,0,2-2V5.8154l3.5859,3.5869L29,8Z"
    })), _path86$m || (_path86$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H12a2.0023,2.0023,0,0,1-2-2V18a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,16,24Zm-4-6v4h4V18Z"
    })), children);
  });
  var Deploy20 = /*#__PURE__*/React__default['default'].forwardRef(function Deploy20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$m || (_path87$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,2,17,8l1.4146,1.4023L22,5.8184V28H6V12H4V28a2.0025,2.0025,0,0,0,2,2H22a2.0025,2.0025,0,0,0,2-2V5.8154l3.5859,3.5869L29,8Z"
    })), _path88$m || (_path88$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H12a2.0023,2.0023,0,0,1-2-2V18a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,16,24Zm-4-6v4h4V18Z"
    })), children);
  });
  var Deploy16 = /*#__PURE__*/React__default['default'].forwardRef(function Deploy16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$m || (_path89$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,2,17,8l1.4146,1.4023L22,5.8184V28H6V12H4V28a2.0025,2.0025,0,0,0,2,2H22a2.0025,2.0025,0,0,0,2-2V5.8154l3.5859,3.5869L29,8Z"
    })), _path90$m || (_path90$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H12a2.0023,2.0023,0,0,1-2-2V18a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,16,24Zm-4-6v4h4V18Z"
    })), children);
  });
  var DeployRules32 = /*#__PURE__*/React__default['default'].forwardRef(function DeployRules32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$m || (_path91$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"
    })), children);
  });
  var DeployRules24 = /*#__PURE__*/React__default['default'].forwardRef(function DeployRules24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$m || (_path92$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"
    })), children);
  });
  var DeployRules20 = /*#__PURE__*/React__default['default'].forwardRef(function DeployRules20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$m || (_path93$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"
    })), children);
  });
  var DeployRules16 = /*#__PURE__*/React__default['default'].forwardRef(function DeployRules16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$m || (_path94$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"
    })), children);
  });
  var DeploymentPattern32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPattern32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$m || (_path95$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H4.73A1.9735 1.9735 0 003 19a2 2 0 000 4A1.9735 1.9735 0 004.73 22H8zM29 9a1.9735 1.9735 0 00-1.73 1H24v2h3.27A1.9991 1.9991 0 1029 9z"
    })), _path96$m || (_path96$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4141 5L21 .5859 16.5859 5 20 8.4141V18h2V8.4141zM21 3.4141L22.5859 5 21 6.5859 19.4141 5zM12 23.5859V14H10v9.5859L6.5859 27 11 31.4141 15.4141 27zM9.4141 27L11 25.4141 12.5859 27 11 28.5859z"
    })), _path97$m || (_path97$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10H8.4141L5,6.5859.5859,11,5,15.4141,8.4141,12H18ZM5,12.5859,3.4141,11,5,9.4141,6.5859,11Z"
    })), _path98$m || (_path98$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 3A2 2 0 009 3 1.9733 1.9733 0 0010 4.73V8h2V4.73A1.9733 1.9733 0 0013 3zM22 27.2705V24H20v3.27a2 2 0 102 0z"
    })), _path99$m || (_path99$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.4141,21,27,16.5859,23.5859,20H14v2h9.5859L27,25.4141ZM27,19.4141,28.5859,21,27,22.5859,25.4141,21Z"
    })), children);
  });
  var DeploymentPattern24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPattern24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$m || (_path100$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H4.73A1.9735 1.9735 0 003 19a2 2 0 000 4A1.9735 1.9735 0 004.73 22H8zM29 9a1.9735 1.9735 0 00-1.73 1H24v2h3.27A1.9991 1.9991 0 1029 9z"
    })), _path101$m || (_path101$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4141 5L21 .5859 16.5859 5 20 8.4141V18h2V8.4141zM21 3.4141L22.5859 5 21 6.5859 19.4141 5zM12 23.5859V14H10v9.5859L6.5859 27 11 31.4141 15.4141 27zM9.4141 27L11 25.4141 12.5859 27 11 28.5859z"
    })), _path102$m || (_path102$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10H8.4141L5,6.5859.5859,11,5,15.4141,8.4141,12H18ZM5,12.5859,3.4141,11,5,9.4141,6.5859,11Z"
    })), _path103$m || (_path103$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 3A2 2 0 009 3 1.9733 1.9733 0 0010 4.73V8h2V4.73A1.9733 1.9733 0 0013 3zM22 27.2705V24H20v3.27a2 2 0 102 0z"
    })), _path104$m || (_path104$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.4141,21,27,16.5859,23.5859,20H14v2h9.5859L27,25.4141ZM27,19.4141,28.5859,21,27,22.5859,25.4141,21Z"
    })), children);
  });
  var DeploymentPattern20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPattern20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$m || (_path105$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H4.73A1.9735 1.9735 0 003 19a2 2 0 000 4A1.9735 1.9735 0 004.73 22H8zM29 9a1.9735 1.9735 0 00-1.73 1H24v2h3.27A1.9991 1.9991 0 1029 9z"
    })), _path106$m || (_path106$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4141 5L21 .5859 16.5859 5 20 8.4141V18h2V8.4141zM21 3.4141L22.5859 5 21 6.5859 19.4141 5zM12 23.5859V14H10v9.5859L6.5859 27 11 31.4141 15.4141 27zM9.4141 27L11 25.4141 12.5859 27 11 28.5859z"
    })), _path107$m || (_path107$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10H8.4141L5,6.5859.5859,11,5,15.4141,8.4141,12H18ZM5,12.5859,3.4141,11,5,9.4141,6.5859,11Z"
    })), _path108$m || (_path108$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 3A2 2 0 009 3 1.9733 1.9733 0 0010 4.73V8h2V4.73A1.9733 1.9733 0 0013 3zM22 27.2705V24H20v3.27a2 2 0 102 0z"
    })), _path109$m || (_path109$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.4141,21,27,16.5859,23.5859,20H14v2h9.5859L27,25.4141ZM27,19.4141,28.5859,21,27,22.5859,25.4141,21Z"
    })), children);
  });
  var DeploymentPattern16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPattern16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$m || (_path110$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H4.73A1.9735 1.9735 0 003 19a2 2 0 000 4A1.9735 1.9735 0 004.73 22H8zM29 9a1.9735 1.9735 0 00-1.73 1H24v2h3.27A1.9991 1.9991 0 1029 9z"
    })), _path111$m || (_path111$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4141 5L21 .5859 16.5859 5 20 8.4141V18h2V8.4141zM21 3.4141L22.5859 5 21 6.5859 19.4141 5zM12 23.5859V14H10v9.5859L6.5859 27 11 31.4141 15.4141 27zM9.4141 27L11 25.4141 12.5859 27 11 28.5859z"
    })), _path112$m || (_path112$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10H8.4141L5,6.5859.5859,11,5,15.4141,8.4141,12H18ZM5,12.5859,3.4141,11,5,9.4141,6.5859,11Z"
    })), _path113$m || (_path113$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 3A2 2 0 009 3 1.9733 1.9733 0 0010 4.73V8h2V4.73A1.9733 1.9733 0 0013 3zM22 27.2705V24H20v3.27a2 2 0 102 0z"
    })), _path114$m || (_path114$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.4141,21,27,16.5859,23.5859,20H14v2h9.5859L27,25.4141ZM27,19.4141,28.5859,21,27,22.5859,25.4141,21Z"
    })), children);
  });
  var DeploymentPolicy32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPolicy32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$m || (_path115$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 16L19 14 26.171 14 23.878 11.707 25.292 10.293 30 15 25.292 19.707 23.878 18.293 26.171 16 19 16zM17 12L15 12 15 5.828 12.707 8.121 11.293 6.707 16 2 20.707 6.707 19.293 8.121 17 5.828 17 12zM17 20.1011V18a4.0045 4.0045 0 00-4-4H5.8281l2.293-2.293L6.707 10.293 2 15l4.707 4.707 1.4141-1.414L5.8281 16H13a2.0025 2.0025 0 012 2v2.1011a5 5 0 102 0zM16 28a3 3 0 113-3A3.0033 3.0033 0 0116 28z"
    })), children);
  });
  var DeploymentPolicy24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPolicy24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$m || (_path116$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 16L19 14 26.171 14 23.878 11.707 25.292 10.293 30 15 25.292 19.707 23.878 18.293 26.171 16 19 16zM17 12L15 12 15 5.828 12.707 8.121 11.293 6.707 16 2 20.707 6.707 19.293 8.121 17 5.828 17 12zM17 20.1011V18a4.0045 4.0045 0 00-4-4H5.8281l2.293-2.293L6.707 10.293 2 15l4.707 4.707 1.4141-1.414L5.8281 16H13a2.0025 2.0025 0 012 2v2.1011a5 5 0 102 0zM16 28a3 3 0 113-3A3.0033 3.0033 0 0116 28z"
    })), children);
  });
  var DeploymentPolicy20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPolicy20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$m || (_path117$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 16L19 14 26.171 14 23.878 11.707 25.292 10.293 30 15 25.292 19.707 23.878 18.293 26.171 16 19 16zM17 12L15 12 15 5.828 12.707 8.121 11.293 6.707 16 2 20.707 6.707 19.293 8.121 17 5.828 17 12zM17 20.1011V18a4.0045 4.0045 0 00-4-4H5.8281l2.293-2.293L6.707 10.293 2 15l4.707 4.707 1.4141-1.414L5.8281 16H13a2.0025 2.0025 0 012 2v2.1011a5 5 0 102 0zM16 28a3 3 0 113-3A3.0033 3.0033 0 0116 28z"
    })), children);
  });
  var DeploymentPolicy16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentPolicy16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$m || (_path118$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 16L19 14 26.171 14 23.878 11.707 25.292 10.293 30 15 25.292 19.707 23.878 18.293 26.171 16 19 16zM17 12L15 12 15 5.828 12.707 8.121 11.293 6.707 16 2 20.707 6.707 19.293 8.121 17 5.828 17 12zM17 20.1011V18a4.0045 4.0045 0 00-4-4H5.8281l2.293-2.293L6.707 10.293 2 15l4.707 4.707 1.4141-1.414L5.8281 16H13a2.0025 2.0025 0 012 2v2.1011a5 5 0 102 0zM16 28a3 3 0 113-3A3.0033 3.0033 0 0116 28z"
    })), children);
  });
  var DeploymentUnitData32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitData32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$m || (_path119$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23H12V9h4a4.0045,4.0045,0,0,1,4,4v6A4.0042,4.0042,0,0,1,16,23Zm-2-2h2a2.0023,2.0023,0,0,0,2-2V13a2.002,2.002,0,0,0-2-2H14Z"
    })), children);
  });
  var DeploymentUnitData24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitData24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$m || (_path120$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23H12V9h4a4.0045,4.0045,0,0,1,4,4v6A4.0042,4.0042,0,0,1,16,23Zm-2-2h2a2.0023,2.0023,0,0,0,2-2V13a2.002,2.002,0,0,0-2-2H14Z"
    })), children);
  });
  var DeploymentUnitData20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitData20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$m || (_path121$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23H12V9h4a4.0045,4.0045,0,0,1,4,4v6A4.0042,4.0042,0,0,1,16,23Zm-2-2h2a2.0023,2.0023,0,0,0,2-2V13a2.002,2.002,0,0,0-2-2H14Z"
    })), children);
  });
  var DeploymentUnitData16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitData16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$m || (_path122$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23H12V9h4a4.0045,4.0045,0,0,1,4,4v6A4.0042,4.0042,0,0,1,16,23Zm-2-2h2a2.0023,2.0023,0,0,0,2-2V13a2.002,2.002,0,0,0-2-2H14Z"
    })), children);
  });
  var DeploymentUnitExecution32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitExecution32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$m || (_path123$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), children);
  });
  var DeploymentUnitExecution24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitExecution24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$m || (_path124$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), children);
  });
  var DeploymentUnitExecution20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitExecution20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$m || (_path125$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), children);
  });
  var DeploymentUnitExecution16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitExecution16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$m || (_path126$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), children);
  });
  var DeploymentUnitInstallation32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitInstallation32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$m || (_path127$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var DeploymentUnitInstallation24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitInstallation24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$m || (_path128$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var DeploymentUnitInstallation20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitInstallation20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$m || (_path129$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var DeploymentUnitInstallation16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitInstallation16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$m || (_path130$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var DeploymentUnitPresentation32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitPresentation32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$m || (_path131$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V11H14Z"
    })), children);
  });
  var DeploymentUnitPresentation24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitPresentation24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$m || (_path132$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V11H14Z"
    })), children);
  });
  var DeploymentUnitPresentation20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitPresentation20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$m || (_path133$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V11H14Z"
    })), children);
  });
  var DeploymentUnitPresentation16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitPresentation16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$m || (_path134$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V11H14Z"
    })), children);
  });
  var DeploymentUnitTechnicalData32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalData32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$m || (_path135$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 23H17V9h4a4.0045 4.0045 0 014 4v6A4.0042 4.0042 0 0121 23zm-2-2h2a2.0023 2.0023 0 002-2V13a2.002 2.002 0 00-2-2H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalData24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalData24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$m || (_path136$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 23H17V9h4a4.0045 4.0045 0 014 4v6A4.0042 4.0042 0 0121 23zm-2-2h2a2.0023 2.0023 0 002-2V13a2.002 2.002 0 00-2-2H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalData20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalData20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$m || (_path137$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 23H17V9h4a4.0045 4.0045 0 014 4v6A4.0042 4.0042 0 0121 23zm-2-2h2a2.0023 2.0023 0 002-2V13a2.002 2.002 0 00-2-2H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalData16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalData16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$m || (_path138$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 23H17V9h4a4.0045 4.0045 0 014 4v6A4.0042 4.0042 0 0121 23zm-2-2h2a2.0023 2.0023 0 002-2V13a2.002 2.002 0 00-2-2H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalExecution32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalExecution32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$m || (_path139$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 25 23 25 21 19 21 19 17 24 17 24 15 19 15 19 11 25 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalExecution24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalExecution24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$m || (_path140$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 25 23 25 21 19 21 19 17 24 17 24 15 19 15 19 11 25 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalExecution20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalExecution20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$m || (_path141$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 25 23 25 21 19 21 19 17 24 17 24 15 19 15 19 11 25 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalExecution16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalExecution16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$m || (_path142$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L25 9 17 9 17 23 25 23 25 21 19 21 19 17 24 17 24 15 19 15 19 11 25 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalInstallation32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalInstallation32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$m || (_path143$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L20 11 20 21 17 21 17 23 25 23 25 21 22 21 22 11 25 11 25 9 17 9 17 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalInstallation24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalInstallation24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$m || (_path144$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L20 11 20 21 17 21 17 23 25 23 25 21 22 21 22 11 25 11 25 9 17 9 17 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalInstallation20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalInstallation20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$m || (_path145$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L20 11 20 21 17 21 17 23 25 23 25 21 22 21 22 11 25 11 25 9 17 9 17 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalInstallation16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalInstallation16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$m || (_path146$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L20 11 20 21 17 21 17 23 25 23 25 21 22 21 22 11 25 11 25 9 17 9 17 11zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalPresentation32 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalPresentation32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$m || (_path147$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 23H17V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H19zm0-7h4V10.9985H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalPresentation24 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalPresentation24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$m || (_path148$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 23H17V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H19zm0-7h4V10.9985H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalPresentation20 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalPresentation20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$m || (_path149$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 23H17V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H19zm0-7h4V10.9985H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeploymentUnitTechnicalPresentation16 = /*#__PURE__*/React__default['default'].forwardRef(function DeploymentUnitTechnicalPresentation16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$m || (_path150$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 23H17V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H19zm0-7h4V10.9985H19zM7 11L10 11 10 23 12 23 12 11 15 11 15 9 7 9 7 11z"
    })), children);
  });
  var DeskAdjustable32 = /*#__PURE__*/React__default['default'].forwardRef(function DeskAdjustable32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$m || (_path151$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27.172L17 22 15 22 15 27.172 12.414 24.586 11 26 16 31 21 26 19.586 24.586 17 27.172z"
    })), _path152$m || (_path152$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 12H2v8H4V30H6V20H26V30h2V20h2zm-2 6H4V14H28zM15 4.828L15 10 17 10 17 4.828 19.586 7.414 21 6 16 1 11 6 12.414 7.414 15 4.828z"
    })), children);
  });
  var DeskAdjustable24 = /*#__PURE__*/React__default['default'].forwardRef(function DeskAdjustable24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$m || (_path153$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27.172L17 22 15 22 15 27.172 12.414 24.586 11 26 16 31 21 26 19.586 24.586 17 27.172z"
    })), _path154$m || (_path154$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 12H2v8H4V30H6V20H26V30h2V20h2zm-2 6H4V14H28zM15 4.828L15 10 17 10 17 4.828 19.586 7.414 21 6 16 1 11 6 12.414 7.414 15 4.828z"
    })), children);
  });
  var DeskAdjustable20 = /*#__PURE__*/React__default['default'].forwardRef(function DeskAdjustable20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$m || (_path155$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27.172L17 22 15 22 15 27.172 12.414 24.586 11 26 16 31 21 26 19.586 24.586 17 27.172z"
    })), _path156$m || (_path156$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 12H2v8H4V30H6V20H26V30h2V20h2zm-2 6H4V14H28zM15 4.828L15 10 17 10 17 4.828 19.586 7.414 21 6 16 1 11 6 12.414 7.414 15 4.828z"
    })), children);
  });
  var DeskAdjustable16 = /*#__PURE__*/React__default['default'].forwardRef(function DeskAdjustable16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$m || (_path157$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 27.172L17 22 15 22 15 27.172 12.414 24.586 11 26 16 31 21 26 19.586 24.586 17 27.172z"
    })), _path158$m || (_path158$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 12H2v8H4V30H6V20H26V30h2V20h2zm-2 6H4V14H28zM15 4.828L15 10 17 10 17 4.828 19.586 7.414 21 6 16 1 11 6 12.414 7.414 15 4.828z"
    })), children);
  });
  var Development32 = /*#__PURE__*/React__default['default'].forwardRef(function Development32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$m || (_path159$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"
    })), _path160$m || (_path160$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"
    })), children);
  });
  var Development24 = /*#__PURE__*/React__default['default'].forwardRef(function Development24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$m || (_path161$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"
    })), _path162$m || (_path162$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"
    })), children);
  });
  var Development20 = /*#__PURE__*/React__default['default'].forwardRef(function Development20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$m || (_path163$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"
    })), _path164$m || (_path164$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"
    })), children);
  });
  var Development16 = /*#__PURE__*/React__default['default'].forwardRef(function Development16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$m || (_path165$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"
    })), _path166$m || (_path166$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"
    })), children);
  });
  var Devices32 = /*#__PURE__*/React__default['default'].forwardRef(function Devices32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$m || (_path167$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"
    })), _path168$m || (_path168$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"
    })), children);
  });
  var Devices24 = /*#__PURE__*/React__default['default'].forwardRef(function Devices24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$m || (_path169$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"
    })), _path170$m || (_path170$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"
    })), children);
  });
  var Devices20 = /*#__PURE__*/React__default['default'].forwardRef(function Devices20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$m || (_path171$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"
    })), _path172$m || (_path172$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"
    })), children);
  });
  var Devices16 = /*#__PURE__*/React__default['default'].forwardRef(function Devices16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$m || (_path173$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"
    })), _path174$m || (_path174$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"
    })), children);
  });
  var DewPoint32 = /*#__PURE__*/React__default['default'].forwardRef(function DewPoint32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$m || (_path175$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30zm0-22.7561C13.0391 13.38 11 22.4089 11 24.52a3.5 3.5 0 007 0C18 22.4089 15.9609 13.38 14.5 7.2439z"
    })), children);
  });
  var DewPoint24 = /*#__PURE__*/React__default['default'].forwardRef(function DewPoint24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$m || (_path176$m = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30zm0-22.7561C13.0391 13.38 11 22.4089 11 24.52a3.5 3.5 0 007 0C18 22.4089 15.9609 13.38 14.5 7.2439z"
    })), children);
  });
  var DewPoint20 = /*#__PURE__*/React__default['default'].forwardRef(function DewPoint20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$l || (_path177$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30zm0-22.7561C13.0391 13.38 11 22.4089 11 24.52a3.5 3.5 0 007 0C18 22.4089 15.9609 13.38 14.5 7.2439z"
    })), children);
  });
  var DewPoint16 = /*#__PURE__*/React__default['default'].forwardRef(function DewPoint16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$l || (_path178$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30zm0-22.7561C13.0391 13.38 11 22.4089 11 24.52a3.5 3.5 0 007 0C18 22.4089 15.9609 13.38 14.5 7.2439z"
    })), children);
  });
  var DewPointFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DewPointFilled32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$l || (_path179$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30z"
    })), children);
  });
  var DewPointFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DewPointFilled24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$l || (_path180$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30z"
    })), children);
  });
  var DewPointFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DewPointFilled20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$l || (_path181$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30z"
    })), children);
  });
  var DewPointFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DewPointFilled16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$l || (_path182$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10a4 4 0 114-4A4.0045 4.0045 0 0124 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 4zM14.5 30A5.4962 5.4962 0 019 24.52c0-3.4426 4.3442-21.0141 4.5293-21.76a1 1 0 011.9414 0C15.6558 3.5059 20 21.0774 20 24.52A5.4962 5.4962 0 0114.5 30z"
    })), children);
  });
  var Diagram32 = /*#__PURE__*/React__default['default'].forwardRef(function Diagram32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$l || (_path183$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"
    })), _path184$l || (_path184$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"
    })), children);
  });
  var Diagram24 = /*#__PURE__*/React__default['default'].forwardRef(function Diagram24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$l || (_path185$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"
    })), _path186$l || (_path186$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"
    })), children);
  });
  var Diagram20 = /*#__PURE__*/React__default['default'].forwardRef(function Diagram20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$l || (_path187$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"
    })), _path188$l || (_path188$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"
    })), children);
  });
  var Diagram16 = /*#__PURE__*/React__default['default'].forwardRef(function Diagram16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$m);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$l || (_path189$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"
    })), _path190$l || (_path190$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"
    })), children);
  });
  var DiagramReference32 = /*#__PURE__*/React__default['default'].forwardRef(function DiagramReference32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$l || (_path191$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path192$l || (_path192$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28V26a9.0133,9.0133,0,0,0,8.9448-8H16a2.0021,2.0021,0,0,1-2-2V8.0552A9.0133,9.0133,0,0,0,6,17H4A11.0125,11.0125,0,0,1,15,6a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11.0125,11.0125,0,0,1,15,28Z"
    })), _path193$l || (_path193$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.0057,14H19.995A1.9957,1.9957,0,0,1,18,12V3a1.0083,1.0083,0,0,1,1.02-1A11.0125,11.0125,0,0,1,30,12.98,1.0035,1.0035,0,0,1,29.0057,14ZM20,12h7.9448A9.018,9.018,0,0,0,20,4.0552Z"
    })), children);
  });
  var DiagramReference24 = /*#__PURE__*/React__default['default'].forwardRef(function DiagramReference24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$l || (_path194$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path195$l || (_path195$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28V26a9.0133,9.0133,0,0,0,8.9448-8H16a2.0021,2.0021,0,0,1-2-2V8.0552A9.0133,9.0133,0,0,0,6,17H4A11.0125,11.0125,0,0,1,15,6a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11.0125,11.0125,0,0,1,15,28Z"
    })), _path196$l || (_path196$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.0057,14H19.995A1.9957,1.9957,0,0,1,18,12V3a1.0083,1.0083,0,0,1,1.02-1A11.0125,11.0125,0,0,1,30,12.98,1.0035,1.0035,0,0,1,29.0057,14ZM20,12h7.9448A9.018,9.018,0,0,0,20,4.0552Z"
    })), children);
  });
  var DiagramReference20 = /*#__PURE__*/React__default['default'].forwardRef(function DiagramReference20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$l || (_path197$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path198$l || (_path198$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28V26a9.0133,9.0133,0,0,0,8.9448-8H16a2.0021,2.0021,0,0,1-2-2V8.0552A9.0133,9.0133,0,0,0,6,17H4A11.0125,11.0125,0,0,1,15,6a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11.0125,11.0125,0,0,1,15,28Z"
    })), _path199$l || (_path199$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.0057,14H19.995A1.9957,1.9957,0,0,1,18,12V3a1.0083,1.0083,0,0,1,1.02-1A11.0125,11.0125,0,0,1,30,12.98,1.0035,1.0035,0,0,1,29.0057,14ZM20,12h7.9448A9.018,9.018,0,0,0,20,4.0552Z"
    })), children);
  });
  var DiagramReference16 = /*#__PURE__*/React__default['default'].forwardRef(function DiagramReference16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$l || (_path200$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path201$l || (_path201$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28V26a9.0133,9.0133,0,0,0,8.9448-8H16a2.0021,2.0021,0,0,1-2-2V8.0552A9.0133,9.0133,0,0,0,6,17H4A11.0125,11.0125,0,0,1,15,6a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11.0125,11.0125,0,0,1,15,28Z"
    })), _path202$l || (_path202$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.0057,14H19.995A1.9957,1.9957,0,0,1,18,12V3a1.0083,1.0083,0,0,1,1.02-1A11.0125,11.0125,0,0,1,30,12.98,1.0035,1.0035,0,0,1,29.0057,14ZM20,12h7.9448A9.018,9.018,0,0,0,20,4.0552Z"
    })), children);
  });
  var WatsonHealthDicom_600032 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicom_600032(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$l || (_path203$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H7a3 3 0 00-3 3v2H6V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0013 11zM10 10A4 4 0 106 6 4 4 0 0010 10zm0-6A2 2 0 118 6 2 2 0 0110 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 01-2-2V22a2 2 0 012-2H6v2H3v2H5a2 2 0 012 2v2A2 2 0 015 30zM3 26v2H5V26zM13 30H11a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0113 30zm-2-8v6h2V22zM21 30H19a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0121 30zm-2-8v6h2V22zM29 30H27a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0129 30zm-2-8v6h2V22z"
    })), children);
  });
  var WatsonHealthDicom_600024 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicom_600024(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$l || (_path204$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H7a3 3 0 00-3 3v2H6V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0013 11zM10 10A4 4 0 106 6 4 4 0 0010 10zm0-6A2 2 0 118 6 2 2 0 0110 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 01-2-2V22a2 2 0 012-2H6v2H3v2H5a2 2 0 012 2v2A2 2 0 015 30zM3 26v2H5V26zM13 30H11a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0113 30zm-2-8v6h2V22zM21 30H19a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0121 30zm-2-8v6h2V22zM29 30H27a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0129 30zm-2-8v6h2V22z"
    })), children);
  });
  var WatsonHealthDicom_600020 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicom_600020(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$l || (_path205$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H7a3 3 0 00-3 3v2H6V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0013 11zM10 10A4 4 0 106 6 4 4 0 0010 10zm0-6A2 2 0 118 6 2 2 0 0110 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 01-2-2V22a2 2 0 012-2H6v2H3v2H5a2 2 0 012 2v2A2 2 0 015 30zM3 26v2H5V26zM13 30H11a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0113 30zm-2-8v6h2V22zM21 30H19a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0121 30zm-2-8v6h2V22zM29 30H27a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0129 30zm-2-8v6h2V22z"
    })), children);
  });
  var WatsonHealthDicom_600016 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicom_600016(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$l || (_path206$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H7a3 3 0 00-3 3v2H6V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0013 11zM10 10A4 4 0 106 6 4 4 0 0010 10zm0-6A2 2 0 118 6 2 2 0 0110 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 01-2-2V22a2 2 0 012-2H6v2H3v2H5a2 2 0 012 2v2A2 2 0 015 30zM3 26v2H5V26zM13 30H11a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0113 30zm-2-8v6h2V22zM21 30H19a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0121 30zm-2-8v6h2V22zM29 30H27a2 2 0 01-2-2V22a2 2 0 012-2h2a2 2 0 012 2v6A2 2 0 0129 30zm-2-8v6h2V22z"
    })), children);
  });
  var WatsonHealthDicomOverlay32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicomOverlay32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$l || (_path207$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path208$l || (_path208$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"
    })), children);
  });
  var WatsonHealthDicomOverlay24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicomOverlay24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$l || (_path209$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path210$l || (_path210$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"
    })), children);
  });
  var WatsonHealthDicomOverlay20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicomOverlay20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$l || (_path211$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path212$l || (_path212$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"
    })), children);
  });
  var WatsonHealthDicomOverlay16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDicomOverlay16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$l || (_path213$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path214$l || (_path214$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"
    })), children);
  });
  var DirectLink32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectLink32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$l || (_path215$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4131,14.584,12.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L1.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l3.2915,3.2915L3,22.5859,4.4141,24l1.8784-1.8784L9.584,25.4131a2.0016,2.0016,0,0,0,2.832,0l2.2559-2.2559-1.4156-1.4155L10.998,23.999,3.001,16.002l7.997-8.001,8.001,8.001L17.5,17.5l1.4146,1.4146,1.4985-1.4986a2.0016,2.0016,0,0,0,0-2.832Z"
    })), _path216$l || (_path216$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4131,14.584l-3.2915-3.2915L29,9.4141,27.5859,8,25.7075,9.8784,22.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L17.3281,8.8428l1.4146,1.4145L20.998,8.001l8.001,8.001-8.001,7.997-7.997-7.997,1.5-1.501-1.4156-1.4156L11.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l7.9971,7.9971a2.0016,2.0016,0,0,0,2.832,0l7.9971-7.9971a2.0016,2.0016,0,0,0,0-2.832Z"
    })), children);
  });
  var DirectLink24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectLink24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$l || (_path217$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4131,14.584,12.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L1.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l3.2915,3.2915L3,22.5859,4.4141,24l1.8784-1.8784L9.584,25.4131a2.0016,2.0016,0,0,0,2.832,0l2.2559-2.2559-1.4156-1.4155L10.998,23.999,3.001,16.002l7.997-8.001,8.001,8.001L17.5,17.5l1.4146,1.4146,1.4985-1.4986a2.0016,2.0016,0,0,0,0-2.832Z"
    })), _path218$l || (_path218$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4131,14.584l-3.2915-3.2915L29,9.4141,27.5859,8,25.7075,9.8784,22.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L17.3281,8.8428l1.4146,1.4145L20.998,8.001l8.001,8.001-8.001,7.997-7.997-7.997,1.5-1.501-1.4156-1.4156L11.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l7.9971,7.9971a2.0016,2.0016,0,0,0,2.832,0l7.9971-7.9971a2.0016,2.0016,0,0,0,0-2.832Z"
    })), children);
  });
  var DirectLink20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectLink20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$l || (_path219$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4131,14.584,12.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L1.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l3.2915,3.2915L3,22.5859,4.4141,24l1.8784-1.8784L9.584,25.4131a2.0016,2.0016,0,0,0,2.832,0l2.2559-2.2559-1.4156-1.4155L10.998,23.999,3.001,16.002l7.997-8.001,8.001,8.001L17.5,17.5l1.4146,1.4146,1.4985-1.4986a2.0016,2.0016,0,0,0,0-2.832Z"
    })), _path220$l || (_path220$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4131,14.584l-3.2915-3.2915L29,9.4141,27.5859,8,25.7075,9.8784,22.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L17.3281,8.8428l1.4146,1.4145L20.998,8.001l8.001,8.001-8.001,7.997-7.997-7.997,1.5-1.501-1.4156-1.4156L11.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l7.9971,7.9971a2.0016,2.0016,0,0,0,2.832,0l7.9971-7.9971a2.0016,2.0016,0,0,0,0-2.832Z"
    })), children);
  });
  var DirectLink16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectLink16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$l || (_path221$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.4131,14.584,12.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L1.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l3.2915,3.2915L3,22.5859,4.4141,24l1.8784-1.8784L9.584,25.4131a2.0016,2.0016,0,0,0,2.832,0l2.2559-2.2559-1.4156-1.4155L10.998,23.999,3.001,16.002l7.997-8.001,8.001,8.001L17.5,17.5l1.4146,1.4146,1.4985-1.4986a2.0016,2.0016,0,0,0,0-2.832Z"
    })), _path222$l || (_path222$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4131,14.584l-3.2915-3.2915L29,9.4141,27.5859,8,25.7075,9.8784,22.416,6.5869a2.0016,2.0016,0,0,0-2.832,0L17.3281,8.8428l1.4146,1.4145L20.998,8.001l8.001,8.001-8.001,7.997-7.997-7.997,1.5-1.501-1.4156-1.4156L11.5869,14.584a2.0016,2.0016,0,0,0,0,2.832l7.9971,7.9971a2.0016,2.0016,0,0,0,2.832,0l7.9971-7.9971a2.0016,2.0016,0,0,0,0-2.832Z"
    })), children);
  });
  var DirectionBearRight_0132 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0132(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$l || (_path223$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4V6h6.5859L12.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,13.4644,13.95L20,7.4141V14h2V4Z"
    })), children);
  });
  var DirectionBearRight_0124 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0124(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$l || (_path224$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4V6h6.5859L12.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,13.4644,13.95L20,7.4141V14h2V4Z"
    })), children);
  });
  var DirectionBearRight_0120 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0120(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$l || (_path225$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4V6h6.5859L12.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,13.4644,13.95L20,7.4141V14h2V4Z"
    })), children);
  });
  var DirectionBearRight_0116 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0116(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$l || (_path226$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4V6h6.5859L12.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,13.4644,13.95L20,7.4141V14h2V4Z"
    })), children);
  });
  var DirectionBearRight_01Filled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_01Filled32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$l || (_path227$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z"
    })), _path228$l || (_path228$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_01Filled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_01Filled24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$l || (_path229$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z"
    })), _path230$l || (_path230$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_01Filled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_01Filled20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$l || (_path231$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z"
    })), _path232$l || (_path232$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_01Filled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_01Filled16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$l || (_path233$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z"
    })), _path234$l || (_path234$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,16H20V9.4141L13.4644,15.95A4.9683,4.9683,0,0,0,12,19.4854V26H10V19.4854a6.954,6.954,0,0,1,2.05-4.95L18.5859,8H12V6H22Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_0232 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0232(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$l || (_path235$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4V6h6.5859L16.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,17.4644,13.95L24,7.4141V14h2V4Z"
    })), _path236$l || (_path236$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5 5.55H10.5V13.45H8.5z",
      transform: "rotate(-45 9.5 9.5)"
    })), children);
  });
  var DirectionBearRight_0224 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0224(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$l || (_path237$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4V6h6.5859L16.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,17.4644,13.95L24,7.4141V14h2V4Z"
    })), _path238$l || (_path238$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5 5.55H10.5V13.45H8.5z",
      transform: "rotate(-45 9.5 9.5)"
    })), children);
  });
  var DirectionBearRight_0220 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0220(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$l || (_path239$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4V6h6.5859L16.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,17.4644,13.95L24,7.4141V14h2V4Z"
    })), _path240$l || (_path240$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5 5.55H10.5V13.45H8.5z",
      transform: "rotate(-45 9.5 9.5)"
    })), children);
  });
  var DirectionBearRight_0216 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_0216(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$l || (_path241$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4V6h6.5859L16.05,12.5356a6.954,6.954,0,0,0-2.05,4.95V28h2V17.4854A4.9683,4.9683,0,0,1,17.4644,13.95L24,7.4141V14h2V4Z"
    })), _path242$l || (_path242$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5 5.55H10.5V13.45H8.5z",
      transform: "rotate(-45 9.5 9.5)"
    })), children);
  });
  var DirectionBearRight_02Filled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_02Filled32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$l || (_path243$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM6,7.4141,7.4141,6,14,12.5859,12.5859,14ZM26,16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6H26Z"
    })), _path244$l || (_path244$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,6V16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6ZM14,12.5859,7.4141,6,6,7.4141,12.5859,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_02Filled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_02Filled24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$l || (_path245$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM6,7.4141,7.4141,6,14,12.5859,12.5859,14ZM26,16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6H26Z"
    })), _path246$l || (_path246$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,6V16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6ZM14,12.5859,7.4141,6,6,7.4141,12.5859,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_02Filled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_02Filled20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$l || (_path247$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM6,7.4141,7.4141,6,14,12.5859,12.5859,14ZM26,16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6H26Z"
    })), _path248$l || (_path248$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,6V16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6ZM14,12.5859,7.4141,6,6,7.4141,12.5859,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionBearRight_02Filled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionBearRight_02Filled16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$l || (_path249$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM6,7.4141,7.4141,6,14,12.5859,12.5859,14ZM26,16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6H26Z"
    })), _path250$l || (_path250$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,6V16H24V9.4141L17.4644,15.95A4.9683,4.9683,0,0,0,16,19.4854V26H14V19.4854a6.954,6.954,0,0,1,2.05-4.95L22.5859,8H16V6ZM14,12.5859,7.4141,6,6,7.4141,12.5859,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionCurve32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurve32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$l || (_path251$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,4l-7,7,1.4141,1.4141L16,7.8281v6.7686a3.01,3.01,0,0,1-.6572,1.874l-2.2471,2.8086A5.0206,5.0206,0,0,0,12,22.4033V28h2V22.4033a3.01,3.01,0,0,1,.6572-1.874l2.2471-2.8086A5.0206,5.0206,0,0,0,18,14.5967V7.8281l4.5859,4.586L24,11Z"
    })), children);
  });
  var DirectionCurve24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurve24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$l || (_path252$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,4l-7,7,1.4141,1.4141L16,7.8281v6.7686a3.01,3.01,0,0,1-.6572,1.874l-2.2471,2.8086A5.0206,5.0206,0,0,0,12,22.4033V28h2V22.4033a3.01,3.01,0,0,1,.6572-1.874l2.2471-2.8086A5.0206,5.0206,0,0,0,18,14.5967V7.8281l4.5859,4.586L24,11Z"
    })), children);
  });
  var DirectionCurve20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurve20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$l || (_path253$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,4l-7,7,1.4141,1.4141L16,7.8281v6.7686a3.01,3.01,0,0,1-.6572,1.874l-2.2471,2.8086A5.0206,5.0206,0,0,0,12,22.4033V28h2V22.4033a3.01,3.01,0,0,1,.6572-1.874l2.2471-2.8086A5.0206,5.0206,0,0,0,18,14.5967V7.8281l4.5859,4.586L24,11Z"
    })), children);
  });
  var DirectionCurve16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurve16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$l || (_path254$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,4l-7,7,1.4141,1.4141L16,7.8281v6.7686a3.01,3.01,0,0,1-.6572,1.874l-2.2471,2.8086A5.0206,5.0206,0,0,0,12,22.4033V28h2V22.4033a3.01,3.01,0,0,1,.6572-1.874l2.2471-2.8086A5.0206,5.0206,0,0,0,18,14.5967V7.8281l4.5859,4.586L24,11Z"
    })), children);
  });
  var DirectionCurveFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurveFilled32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$l || (_path255$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z"
    })), _path256$l || (_path256$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionCurveFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurveFilled24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$l || (_path257$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z"
    })), _path258$l || (_path258$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionCurveFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurveFilled20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$l || (_path259$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z"
    })), _path260$l || (_path260$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionCurveFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionCurveFilled16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$l || (_path261$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z"
    })), _path262$l || (_path262$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22.5859,13.4141,18,8.8281v5.7686a5.0206,5.0206,0,0,1-1.0957,3.124l-2.2471,2.8086A3.01,3.01,0,0,0,14,22.4033V27H12V22.4033a5.0206,5.0206,0,0,1,1.0957-3.124l2.2471-2.8086A3.01,3.01,0,0,0,16,14.5967V8.8281l-4.5859,4.586L10,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionFork32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionFork32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$l || (_path263$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 13L6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 13 28 13 28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13z"
    })), children);
  });
  var DirectionFork24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionFork24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$l || (_path264$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 13L6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 13 28 13 28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13z"
    })), children);
  });
  var DirectionFork20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionFork20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$l || (_path265$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 13L6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 13 28 13 28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13z"
    })), children);
  });
  var DirectionFork16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionFork16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$l || (_path266$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 13L6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 13 28 13 28 4 19 4 19 6 24.586 6 16 14.586 7.414 6 13 6 13 4 4 4 4 13 6 13z"
    })), children);
  });
  var DirectionForkFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionForkFilled32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$l || (_path267$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 14L8 9.414 15 16.414 15 26 17 26 17 16.414 24 9.414 24 14 26 14 26 6 18 6 18 8 22.586 8 16 14.586 9.414 8 14 8 14 6 6 6 6 14 8 14z",
      "data-icon-path": "inner-path"
    })), _path268$l || (_path268$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,14H24V9.4141l-7,7V26H15V16.4141l-7-7V14H6V6h8V8H9.4141L16,14.5859,22.5859,8H18V6h8Z"
    })), children);
  });
  var DirectionForkFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionForkFilled24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$l || (_path269$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 14L8 9.414 15 16.414 15 26 17 26 17 16.414 24 9.414 24 14 26 14 26 6 18 6 18 8 22.586 8 16 14.586 9.414 8 14 8 14 6 6 6 6 14 8 14z",
      "data-icon-path": "inner-path"
    })), _path270$l || (_path270$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,14H24V9.4141l-7,7V26H15V16.4141l-7-7V14H6V6h8V8H9.4141L16,14.5859,22.5859,8H18V6h8Z"
    })), children);
  });
  var DirectionForkFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionForkFilled20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$l || (_path271$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 14L8 9.414 15 16.414 15 26 17 26 17 16.414 24 9.414 24 14 26 14 26 6 18 6 18 8 22.586 8 16 14.586 9.414 8 14 8 14 6 6 6 6 14 8 14z",
      "data-icon-path": "inner-path"
    })), _path272$l || (_path272$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,14H24V9.4141l-7,7V26H15V16.4141l-7-7V14H6V6h8V8H9.4141L16,14.5859,22.5859,8H18V6h8Z"
    })), children);
  });
  var DirectionForkFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionForkFilled16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$l || (_path273$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 14L8 9.414 15 16.414 15 26 17 26 17 16.414 24 9.414 24 14 26 14 26 6 18 6 18 8 22.586 8 16 14.586 9.414 8 14 8 14 6 6 6 6 14 8 14z",
      "data-icon-path": "inner-path"
    })), _path274$l || (_path274$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,14H24V9.4141l-7,7V26H15V16.4141l-7-7V14H6V6h8V8H9.4141L16,14.5859,22.5859,8H18V6h8Z"
    })), children);
  });
  var DirectionLoopLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeft32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$l || (_path275$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H18V28H16z"
    })), _path276$l || (_path276$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,4a7.0078,7.0078,0,0,0-7,7v3h2V11a5,5,0,1,1,5,5H5.8281l4.586-4.5859L9,10,2,17l7,7,1.4141-1.4141L5.8281,18H23A7,7,0,0,0,23,4Z"
    })), children);
  });
  var DirectionLoopLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeft24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$l || (_path277$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H18V28H16z"
    })), _path278$l || (_path278$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,4a7.0078,7.0078,0,0,0-7,7v3h2V11a5,5,0,1,1,5,5H5.8281l4.586-4.5859L9,10,2,17l7,7,1.4141-1.4141L5.8281,18H23A7,7,0,0,0,23,4Z"
    })), children);
  });
  var DirectionLoopLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeft20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$l || (_path279$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H18V28H16z"
    })), _path280$l || (_path280$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,4a7.0078,7.0078,0,0,0-7,7v3h2V11a5,5,0,1,1,5,5H5.8281l4.586-4.5859L9,10,2,17l7,7,1.4141-1.4141L5.8281,18H23A7,7,0,0,0,23,4Z"
    })), children);
  });
  var DirectionLoopLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeft16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$l || (_path281$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H18V28H16z"
    })), _path282$l || (_path282$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,4a7.0078,7.0078,0,0,0-7,7v3h2V11a5,5,0,1,1,5,5H5.8281l4.586-4.5859L9,10,2,17l7,7,1.4141-1.4141L5.8281,18H23A7,7,0,0,0,23,4Z"
    })), children);
  });
  var DirectionLoopLeftFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeftFilled32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$l || (_path283$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,18h2v8H16ZM4,15l7,7,1.4141-1.4141L7.8281,16H21a5,5,0,1,0-5-5v1h2V11a3,3,0,1,1,3,3H7.8281l4.586-4.5859L11,8Z",
      "data-icon-path": "inner-path"
    })), _path284$l || (_path284$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4ZM16,18h2v8H16ZM4,15l7-7,1.4141,1.4141L7.8281,14H21a3,3,0,1,0-3-3v1H16V11a5,5,0,1,1,5,5H7.8281l4.586,4.5859L11,22Z"
    })), children);
  });
  var DirectionLoopLeftFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeftFilled24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$l || (_path285$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,18h2v8H16ZM4,15l7,7,1.4141-1.4141L7.8281,16H21a5,5,0,1,0-5-5v1h2V11a3,3,0,1,1,3,3H7.8281l4.586-4.5859L11,8Z",
      "data-icon-path": "inner-path"
    })), _path286$l || (_path286$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4ZM16,18h2v8H16ZM4,15l7-7,1.4141,1.4141L7.8281,14H21a3,3,0,1,0-3-3v1H16V11a5,5,0,1,1,5,5H7.8281l4.586,4.5859L11,22Z"
    })), children);
  });
  var DirectionLoopLeftFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeftFilled20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$l || (_path287$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,18h2v8H16ZM4,15l7,7,1.4141-1.4141L7.8281,16H21a5,5,0,1,0-5-5v1h2V11a3,3,0,1,1,3,3H7.8281l4.586-4.5859L11,8Z",
      "data-icon-path": "inner-path"
    })), _path288$l || (_path288$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4ZM16,18h2v8H16ZM4,15l7-7,1.4141,1.4141L7.8281,14H21a3,3,0,1,0-3-3v1H16V11a5,5,0,1,1,5,5H7.8281l4.586,4.5859L11,22Z"
    })), children);
  });
  var DirectionLoopLeftFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopLeftFilled16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$l || (_path289$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,18h2v8H16ZM4,15l7,7,1.4141-1.4141L7.8281,16H21a5,5,0,1,0-5-5v1h2V11a3,3,0,1,1,3,3H7.8281l4.586-4.5859L11,8Z",
      "data-icon-path": "inner-path"
    })), _path290$l || (_path290$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4ZM16,18h2v8H16ZM4,15l7-7,1.4141,1.4141L7.8281,14H21a3,3,0,1,0-3-3v1H16V11a5,5,0,1,1,5,5H7.8281l4.586,4.5859L11,22Z"
    })), children);
  });
  var DirectionLoopRight32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRight32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$l || (_path291$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20H16V28H14z"
    })), _path292$l || (_path292$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,4a7.0078,7.0078,0,0,1,7,7v3H14V11a5,5,0,1,0-5,5H26.1719l-4.586-4.5859L23,10l7,7-7,7-1.4141-1.4141L26.1719,18H9A7,7,0,0,1,9,4Z"
    })), children);
  });
  var DirectionLoopRight24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRight24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$l || (_path293$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20H16V28H14z"
    })), _path294$l || (_path294$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,4a7.0078,7.0078,0,0,1,7,7v3H14V11a5,5,0,1,0-5,5H26.1719l-4.586-4.5859L23,10l7,7-7,7-1.4141-1.4141L26.1719,18H9A7,7,0,0,1,9,4Z"
    })), children);
  });
  var DirectionLoopRight20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRight20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$l || (_path295$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20H16V28H14z"
    })), _path296$l || (_path296$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,4a7.0078,7.0078,0,0,1,7,7v3H14V11a5,5,0,1,0-5,5H26.1719l-4.586-4.5859L23,10l7,7-7,7-1.4141-1.4141L26.1719,18H9A7,7,0,0,1,9,4Z"
    })), children);
  });
  var DirectionLoopRight16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRight16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$l || (_path297$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20H16V28H14z"
    })), _path298$l || (_path298$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,4a7.0078,7.0078,0,0,1,7,7v3H14V11a5,5,0,1,0-5,5H26.1719l-4.586-4.5859L23,10l7,7-7,7-1.4141-1.4141L26.1719,18H9A7,7,0,0,1,9,4Z"
    })), children);
  });
  var DirectionLoopRightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRightFilled32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$l || (_path299$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26H14V18h2ZM21,8,19.5859,9.4141,24.1719,14H11a3,3,0,1,1,3-3v1h2V11a5,5,0,1,0-5,5H24.1719l-4.586,4.5859L21,22l7-7Z",
      "data-icon-path": "inner-path"
    })), _path300$l || (_path300$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM16,26H14V18h2Zm5-4-1.4141-1.4141L24.1719,16H11a5,5,0,1,1,5-5v1H14V11a3,3,0,1,0-3,3H24.1719l-4.586-4.5859L21,8l7,7Z"
    })), children);
  });
  var DirectionLoopRightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRightFilled24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$l || (_path301$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26H14V18h2ZM21,8,19.5859,9.4141,24.1719,14H11a3,3,0,1,1,3-3v1h2V11a5,5,0,1,0-5,5H24.1719l-4.586,4.5859L21,22l7-7Z",
      "data-icon-path": "inner-path"
    })), _path302$l || (_path302$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM16,26H14V18h2Zm5-4-1.4141-1.4141L24.1719,16H11a5,5,0,1,1,5-5v1H14V11a3,3,0,1,0-3,3H24.1719l-4.586-4.5859L21,8l7,7Z"
    })), children);
  });
  var DirectionLoopRightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRightFilled20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$l || (_path303$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26H14V18h2ZM21,8,19.5859,9.4141,24.1719,14H11a3,3,0,1,1,3-3v1h2V11a5,5,0,1,0-5,5H24.1719l-4.586,4.5859L21,22l7-7Z",
      "data-icon-path": "inner-path"
    })), _path304$l || (_path304$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM16,26H14V18h2Zm5-4-1.4141-1.4141L24.1719,16H11a5,5,0,1,1,5-5v1H14V11a3,3,0,1,0-3,3H24.1719l-4.586-4.5859L21,8l7,7Z"
    })), children);
  });
  var DirectionLoopRightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionLoopRightFilled16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$l || (_path305$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26H14V18h2ZM21,8,19.5859,9.4141,24.1719,14H11a3,3,0,1,1,3-3v1h2V11a5,5,0,1,0-5,5H24.1719l-4.586,4.5859L21,22l7-7Z",
      "data-icon-path": "inner-path"
    })), _path306$l || (_path306$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM16,26H14V18h2Zm5-4-1.4141-1.4141L24.1719,16H11a5,5,0,1,1,5-5v1H14V11a3,3,0,1,0-3,3H24.1719l-4.586-4.5859L21,8l7,7Z"
    })), children);
  });
  var DirectionMerge32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMerge32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$l || (_path307$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8784,15.4648A2.9821,2.9821,0,0,1,17,13.3433V7.8281l4.5859,4.586L23,11,16,4,9,11l1.4141,1.4141L15,7.8281v5.5152a2.9805,2.9805,0,0,1-.8784,2.1211l-2.6572,2.6567A4.9682,4.9682,0,0,0,10,21.6567V28h2V21.6567a2.9805,2.9805,0,0,1,.8784-2.1211l2.6572-2.6567A5.0021,5.0021,0,0,0,16,16.3135a5.0021,5.0021,0,0,0,.4644.5654l2.6572,2.6563A2.9821,2.9821,0,0,1,20,21.6567V28h2V21.6567a4.9682,4.9682,0,0,0-1.4644-3.5356Z"
    })), children);
  });
  var DirectionMerge24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMerge24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$l || (_path308$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8784,15.4648A2.9821,2.9821,0,0,1,17,13.3433V7.8281l4.5859,4.586L23,11,16,4,9,11l1.4141,1.4141L15,7.8281v5.5152a2.9805,2.9805,0,0,1-.8784,2.1211l-2.6572,2.6567A4.9682,4.9682,0,0,0,10,21.6567V28h2V21.6567a2.9805,2.9805,0,0,1,.8784-2.1211l2.6572-2.6567A5.0021,5.0021,0,0,0,16,16.3135a5.0021,5.0021,0,0,0,.4644.5654l2.6572,2.6563A2.9821,2.9821,0,0,1,20,21.6567V28h2V21.6567a4.9682,4.9682,0,0,0-1.4644-3.5356Z"
    })), children);
  });
  var DirectionMerge20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMerge20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$l || (_path309$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8784,15.4648A2.9821,2.9821,0,0,1,17,13.3433V7.8281l4.5859,4.586L23,11,16,4,9,11l1.4141,1.4141L15,7.8281v5.5152a2.9805,2.9805,0,0,1-.8784,2.1211l-2.6572,2.6567A4.9682,4.9682,0,0,0,10,21.6567V28h2V21.6567a2.9805,2.9805,0,0,1,.8784-2.1211l2.6572-2.6567A5.0021,5.0021,0,0,0,16,16.3135a5.0021,5.0021,0,0,0,.4644.5654l2.6572,2.6563A2.9821,2.9821,0,0,1,20,21.6567V28h2V21.6567a4.9682,4.9682,0,0,0-1.4644-3.5356Z"
    })), children);
  });
  var DirectionMerge16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMerge16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$l || (_path310$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8784,15.4648A2.9821,2.9821,0,0,1,17,13.3433V7.8281l4.5859,4.586L23,11,16,4,9,11l1.4141,1.4141L15,7.8281v5.5152a2.9805,2.9805,0,0,1-.8784,2.1211l-2.6572,2.6567A4.9682,4.9682,0,0,0,10,21.6567V28h2V21.6567a2.9805,2.9805,0,0,1,.8784-2.1211l2.6572-2.6567A5.0021,5.0021,0,0,0,16,16.3135a5.0021,5.0021,0,0,0,.4644.5654l2.6572,2.6563A2.9821,2.9821,0,0,1,20,21.6567V28h2V21.6567a4.9682,4.9682,0,0,0-1.4644-3.5356Z"
    })), children);
  });
  var DirectionMergeFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMergeFilled32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$l || (_path311$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z"
    })), _path312$l || (_path312$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionMergeFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMergeFilled24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$l || (_path313$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z"
    })), _path314$l || (_path314$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionMergeFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMergeFilled20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$l || (_path315$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z"
    })), _path316$l || (_path316$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionMergeFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionMergeFilled16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$l || (_path317$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z"
    })), _path318$l || (_path318$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M17.8784,15.4648l2.6572,2.6563A4.9682,4.9682,0,0,1,22,21.6567V26H20V21.6567a2.9821,2.9821,0,0,0-.8784-2.1215l-2.6572-2.6563A5.0021,5.0021,0,0,1,16,16.3135a5.0021,5.0021,0,0,1-.4644.5654l-2.6572,2.6567A2.9805,2.9805,0,0,0,12,21.6567V26H10V21.6567a4.9682,4.9682,0,0,1,1.4644-3.5356l2.6572-2.6567A2.9805,2.9805,0,0,0,15,13.3433V8.8281l-4.5859,4.586L9,12l7-7,7,7-1.4141,1.4141L17,8.8281v4.5152A2.9821,2.9821,0,0,0,17.8784,15.4648Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_0132 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0132(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$l || (_path319$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4,17.5859,5.4141,22.1719,10H10a2,2,0,0,0-2,2V28h2V12H22.1719l-4.586,4.5859L19,18l7-7Z"
    })), children);
  });
  var DirectionRight_0124 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0124(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$l || (_path320$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4,17.5859,5.4141,22.1719,10H10a2,2,0,0,0-2,2V28h2V12H22.1719l-4.586,4.5859L19,18l7-7Z"
    })), children);
  });
  var DirectionRight_0120 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0120(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$l || (_path321$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4,17.5859,5.4141,22.1719,10H10a2,2,0,0,0-2,2V28h2V12H22.1719l-4.586,4.5859L19,18l7-7Z"
    })), children);
  });
  var DirectionRight_0116 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0116(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$l || (_path322$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4,17.5859,5.4141,22.1719,10H10a2,2,0,0,0-2,2V28h2V12H22.1719l-4.586,4.5859L19,18l7-7Z"
    })), children);
  });
  var DirectionRight_01Filled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_01Filled32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$l || (_path323$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z"
    })), _path324$l || (_path324$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_01Filled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_01Filled24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$l || (_path325$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z"
    })), _path326$l || (_path326$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_01Filled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_01Filled20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$l || (_path327$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z"
    })), _path328$l || (_path328$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_01Filled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_01Filled16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$l || (_path329$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z"
    })), _path330$l || (_path330$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,18l-1.4141-1.4141L22.1719,12H10V26H8V12a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,4l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_0232 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0232(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$l || (_path331$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 8L17.5859 9.4141 22.1719 14H10a2 2 0 00-2 2V28h2V16H22.1719l-4.586 4.5859L19 22l7-7zM8 4H10V12H8z"
    })), children);
  });
  var DirectionRight_0224 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0224(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$l || (_path332$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 8L17.5859 9.4141 22.1719 14H10a2 2 0 00-2 2V28h2V16H22.1719l-4.586 4.5859L19 22l7-7zM8 4H10V12H8z"
    })), children);
  });
  var DirectionRight_0220 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0220(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$l || (_path333$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 8L17.5859 9.4141 22.1719 14H10a2 2 0 00-2 2V28h2V16H22.1719l-4.586 4.5859L19 22l7-7zM8 4H10V12H8z"
    })), children);
  });
  var DirectionRight_0216 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_0216(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$l || (_path334$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 8L17.5859 9.4141 22.1719 14H10a2 2 0 00-2 2V28h2V16H22.1719l-4.586 4.5859L19 22l7-7zM8 4H10V12H8z"
    })), children);
  });
  var DirectionRight_02Filled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_02Filled32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$l || (_path335$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z"
    })), _path336$l || (_path336$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_02Filled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_02Filled24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$l || (_path337$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z"
    })), _path338$k || (_path338$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_02Filled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_02Filled20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$k || (_path339$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z"
    })), _path340$k || (_path340$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRight_02Filled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRight_02Filled16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$k || (_path341$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z"
    })), _path342$k || (_path342$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8,6h2v8H8ZM19,24l-1.4141-1.4141L22.1719,18H10v8H8V18a2,2,0,0,1,2-2H22.1719l-4.586-4.5859L19,10l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryFirstRight32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRight32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$k || (_path343$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L15.8712,14.457A5.9242,5.9242,0,0,0,17,11a6,6,0,1,0-7,5.91V28h2V16.91a5.9566,5.9566,0,0,0,2.4554-1.04L24.5859,26H18v2H28V18ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryFirstRight24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRight24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$k || (_path344$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L15.8712,14.457A5.9242,5.9242,0,0,0,17,11a6,6,0,1,0-7,5.91V28h2V16.91a5.9566,5.9566,0,0,0,2.4554-1.04L24.5859,26H18v2H28V18ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryFirstRight20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRight20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$k || (_path345$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L15.8712,14.457A5.9242,5.9242,0,0,0,17,11a6,6,0,1,0-7,5.91V28h2V16.91a5.9566,5.9566,0,0,0,2.4554-1.04L24.5859,26H18v2H28V18ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryFirstRight16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRight16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$k || (_path346$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L15.8712,14.457A5.9242,5.9242,0,0,0,17,11a6,6,0,1,0-7,5.91V28h2V16.91a5.9566,5.9566,0,0,0,2.4554-1.04L24.5859,26H18v2H28V18ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryFirstRightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRightFilled32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$j || (_circle9$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path347$k || (_path347$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859l-8.833-8.833A4.9678,4.9678,0,0,1,12,15.8989V26H10V15.8989a5.0113,5.0113,0,1,1,5.167-2.146L24,22.5859V16h2Z"
    })), _path348$k || (_path348$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Zm13,2v6.5859l-8.833-8.833A4.9959,4.9959,0,1,0,10,15.8989V26h2V15.8989a4.9678,4.9678,0,0,0,1.7529-.7319L22.5859,24H16v2H26V16Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryFirstRightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRightFilled24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$j || (_circle10$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path349$k || (_path349$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859l-8.833-8.833A4.9678,4.9678,0,0,1,12,15.8989V26H10V15.8989a5.0113,5.0113,0,1,1,5.167-2.146L24,22.5859V16h2Z"
    })), _path350$k || (_path350$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Zm13,2v6.5859l-8.833-8.833A4.9959,4.9959,0,1,0,10,15.8989V26h2V15.8989a4.9678,4.9678,0,0,0,1.7529-.7319L22.5859,24H16v2H26V16Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryFirstRightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRightFilled20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$i || (_circle11$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path351$k || (_path351$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859l-8.833-8.833A4.9678,4.9678,0,0,1,12,15.8989V26H10V15.8989a5.0113,5.0113,0,1,1,5.167-2.146L24,22.5859V16h2Z"
    })), _path352$k || (_path352$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Zm13,2v6.5859l-8.833-8.833A4.9959,4.9959,0,1,0,10,15.8989V26h2V15.8989a4.9678,4.9678,0,0,0,1.7529-.7319L22.5859,24H16v2H26V16Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryFirstRightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryFirstRightFilled16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12$i || (_circle12$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path353$k || (_path353$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859l-8.833-8.833A4.9678,4.9678,0,0,1,12,15.8989V26H10V15.8989a5.0113,5.0113,0,1,1,5.167-2.146L24,22.5859V16h2Z"
    })), _path354$k || (_path354$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Zm13,2v6.5859l-8.833-8.833A4.9959,4.9959,0,1,0,10,15.8989V26h2V15.8989a4.9678,4.9678,0,0,0,1.7529-.7319L22.5859,24H16v2H26V16Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryRight32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRight32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$j || (_path355$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4,20.5859,5.4141,25.1719,10H16.91A5.9965,5.9965,0,1,0,10,16.91V28h2V16.91A6.0061,6.0061,0,0,0,16.91,12h8.2622l-4.586,4.5859L22,18l7-7ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryRight24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRight24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$j || (_path356$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4,20.5859,5.4141,25.1719,10H16.91A5.9965,5.9965,0,1,0,10,16.91V28h2V16.91A6.0061,6.0061,0,0,0,16.91,12h8.2622l-4.586,4.5859L22,18l7-7ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryRight20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRight20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$j || (_path357$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4,20.5859,5.4141,25.1719,10H16.91A5.9965,5.9965,0,1,0,10,16.91V28h2V16.91A6.0061,6.0061,0,0,0,16.91,12h8.2622l-4.586,4.5859L22,18l7-7ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryRight16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRight16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$j || (_path358$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4,20.5859,5.4141,25.1719,10H16.91A5.9965,5.9965,0,1,0,10,16.91V28h2V16.91A6.0061,6.0061,0,0,0,16.91,12h8.2622l-4.586,4.5859L22,18l7-7ZM11,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,11,15Z"
    })), children);
  });
  var DirectionRotaryRightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRightFilled32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$i || (_circle13$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path359$j || (_path359$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,18l-1.4141-1.4141L23.1719,12h-7.273A5.0145,5.0145,0,0,1,12,15.8989V26H10V15.8989A5,5,0,1,1,15.8989,10h7.273l-4.586-4.5859L20,4l7,7Z"
    })), _path360$j || (_path360$j = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,4,18.5859,5.4141,23.1719,10h-7.273A5,5,0,1,0,10,15.8989V26h2V15.8989A5.0145,5.0145,0,0,0,15.8989,12h7.273l-4.586,4.5859L20,18l7-7ZM11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryRightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRightFilled24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$i || (_circle14$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path361$i || (_path361$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,18l-1.4141-1.4141L23.1719,12h-7.273A5.0145,5.0145,0,0,1,12,15.8989V26H10V15.8989A5,5,0,1,1,15.8989,10h7.273l-4.586-4.5859L20,4l7,7Z"
    })), _path362$i || (_path362$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,4,18.5859,5.4141,23.1719,10h-7.273A5,5,0,1,0,10,15.8989V26h2V15.8989A5.0145,5.0145,0,0,0,15.8989,12h7.273l-4.586,4.5859L20,18l7-7ZM11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryRightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRightFilled20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$i || (_circle15$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path363$i || (_path363$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,18l-1.4141-1.4141L23.1719,12h-7.273A5.0145,5.0145,0,0,1,12,15.8989V26H10V15.8989A5,5,0,1,1,15.8989,10h7.273l-4.586-4.5859L20,4l7,7Z"
    })), _path364$i || (_path364$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,4,18.5859,5.4141,23.1719,10h-7.273A5,5,0,1,0,10,15.8989V26h2V15.8989A5.0145,5.0145,0,0,0,15.8989,12h7.273l-4.586,4.5859L20,18l7-7ZM11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryRightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryRightFilled16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$i || (_circle16$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "3"
    })), _path365$i || (_path365$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,18l-1.4141-1.4141L23.1719,12h-7.273A5.0145,5.0145,0,0,1,12,15.8989V26H10V15.8989A5,5,0,1,1,15.8989,10h7.273l-4.586-4.5859L20,4l7,7Z"
    })), _path366$i || (_path366$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,4,18.5859,5.4141,23.1719,10h-7.273A5,5,0,1,0,10,15.8989V26h2V15.8989A5.0145,5.0145,0,0,0,15.8989,12h7.273l-4.586,4.5859L20,18l7-7ZM11,14a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,11,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryStraight32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraight32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$i || (_path367$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,12.09V5.8281l4.5859,4.586L23,9,16,2,9,9l1.4141,1.4141L15,5.8281V12.09A5.9925,5.9925,0,0,0,15,23.91V28h2V23.91A5.9925,5.9925,0,0,0,17,12.09ZM16,22a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,22Z"
    })), children);
  });
  var DirectionRotaryStraight24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraight24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$i || (_path368$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,12.09V5.8281l4.5859,4.586L23,9,16,2,9,9l1.4141,1.4141L15,5.8281V12.09A5.9925,5.9925,0,0,0,15,23.91V28h2V23.91A5.9925,5.9925,0,0,0,17,12.09ZM16,22a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,22Z"
    })), children);
  });
  var DirectionRotaryStraight20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraight20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$i || (_path369$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,12.09V5.8281l4.5859,4.586L23,9,16,2,9,9l1.4141,1.4141L15,5.8281V12.09A5.9925,5.9925,0,0,0,15,23.91V28h2V23.91A5.9925,5.9925,0,0,0,17,12.09ZM16,22a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,22Z"
    })), children);
  });
  var DirectionRotaryStraight16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraight16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$i || (_path370$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,12.09V5.8281l4.5859,4.586L23,9,16,2,9,9l1.4141,1.4141L15,5.8281V12.09A5.9925,5.9925,0,0,0,15,23.91V28h2V23.91A5.9925,5.9925,0,0,0,17,12.09ZM16,22a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,22Z"
    })), children);
  });
  var DirectionRotaryStraightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraightFilled32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle17$h || (_circle17$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "3"
    })), _path371$i || (_path371$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,12.4141,17,7.8281v6.273a5,5,0,0,1,0,9.7978V28H15V23.8989a5,5,0,0,1,0-9.7978V7.8281l-4.5859,4.586L9,11l7-7,7,7Z"
    })), _path372$i || (_path372$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,12.4141,23,11,16,4,9,11l1.4141,1.4141L15,7.8281v6.273a5,5,0,0,0,0,9.7978V28h2V23.8989a5,5,0,0,0,0-9.7978V7.8281ZM19,19a3,3,0,1,1-3-3A3.0033,3.0033,0,0,1,19,19Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryStraightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraightFilled24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle18$h || (_circle18$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "3"
    })), _path373$i || (_path373$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,12.4141,17,7.8281v6.273a5,5,0,0,1,0,9.7978V28H15V23.8989a5,5,0,0,1,0-9.7978V7.8281l-4.5859,4.586L9,11l7-7,7,7Z"
    })), _path374$i || (_path374$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,12.4141,23,11,16,4,9,11l1.4141,1.4141L15,7.8281v6.273a5,5,0,0,0,0,9.7978V28h2V23.8989a5,5,0,0,0,0-9.7978V7.8281ZM19,19a3,3,0,1,1-3-3A3.0033,3.0033,0,0,1,19,19Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryStraightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraightFilled20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$h || (_circle19$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "3"
    })), _path375$h || (_path375$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,12.4141,17,7.8281v6.273a5,5,0,0,1,0,9.7978V28H15V23.8989a5,5,0,0,1,0-9.7978V7.8281l-4.5859,4.586L9,11l7-7,7,7Z"
    })), _path376$h || (_path376$h = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,12.4141,23,11,16,4,9,11l1.4141,1.4141L15,7.8281v6.273a5,5,0,0,0,0,9.7978V28h2V23.8989a5,5,0,0,0,0-9.7978V7.8281ZM19,19a3,3,0,1,1-3-3A3.0033,3.0033,0,0,1,19,19Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionRotaryStraightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionRotaryStraightFilled16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle20$h || (_circle20$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "19",
      r: "3"
    })), _path377$h || (_path377$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,12.4141,17,7.8281v6.273a5,5,0,0,1,0,9.7978V28H15V23.8989a5,5,0,0,1,0-9.7978V7.8281l-4.5859,4.586L9,11l7-7,7,7Z"
    })), _path378$h || (_path378$h = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,12.4141,23,11,16,4,9,11l1.4141,1.4141L15,7.8281v6.273a5,5,0,0,0,0,9.7978V28h2V23.8989a5,5,0,0,0,0-9.7978V7.8281ZM19,19a3,3,0,1,1-3-3A3.0033,3.0033,0,0,1,19,19Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionSharpTurn32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurn32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$h || (_path379$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L7.707,6.293A1,1,0,0,0,6,7V28H8V9.4141L24.5859,26H18v2H28V18Z"
    })), children);
  });
  var DirectionSharpTurn24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurn24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$h || (_path380$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L7.707,6.293A1,1,0,0,0,6,7V28H8V9.4141L24.5859,26H18v2H28V18Z"
    })), children);
  });
  var DirectionSharpTurn20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurn20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$h || (_path381$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L7.707,6.293A1,1,0,0,0,6,7V28H8V9.4141L24.5859,26H18v2H28V18Z"
    })), children);
  });
  var DirectionSharpTurn16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurn16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$h || (_path382$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18v6.5859L7.707,6.293A1,1,0,0,0,6,7V28H8V9.4141L24.5859,26H18v2H28V18Z"
    })), children);
  });
  var DirectionSharpTurnFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurnFilled32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$h || (_path383$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z"
    })), _path384$g || (_path384$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionSharpTurnFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurnFilled24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$g || (_path385$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z"
    })), _path386$g || (_path386$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionSharpTurnFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurnFilled20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$g || (_path387$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z"
    })), _path388$g || (_path388$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionSharpTurnFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionSharpTurnFilled16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$g || (_path389$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z"
    })), _path390$g || (_path390$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26,26H16V24h6.5859L8,9.4141V26H6V7a1,1,0,0,1,1.707-.707L24,22.5859V16h2Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraight32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraight32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$g || (_path391$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L9 11 10.414 12.414 15 7.828 15 28 17 28 17 7.828 21.586 12.414 23 11 16 4z"
    })), children);
  });
  var DirectionStraight24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraight24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$g || (_path392$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L9 11 10.414 12.414 15 7.828 15 28 17 28 17 7.828 21.586 12.414 23 11 16 4z"
    })), children);
  });
  var DirectionStraight20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraight20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$g || (_path393$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L9 11 10.414 12.414 15 7.828 15 28 17 28 17 7.828 21.586 12.414 23 11 16 4z"
    })), children);
  });
  var DirectionStraight16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraight16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$g || (_path394$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L9 11 10.414 12.414 15 7.828 15 28 17 28 17 7.828 21.586 12.414 23 11 16 4z"
    })), children);
  });
  var DirectionStraightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightFilled32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$g || (_path395$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z"
    })), _path396$g || (_path396$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightFilled24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$g || (_path397$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z"
    })), _path398$g || (_path398$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightFilled20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$f || (_path399$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z"
    })), _path400$f || (_path400$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightFilled16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$f || (_path401$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z"
    })), _path402$f || (_path402$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.5859,13.4141,17,8.8281V26H15V8.8281l-4.5859,4.586L9,12l7-7,7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightRight32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRight32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$e || (_path403$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16L21 9 19.586 10.414 24.172 15 4 15 4 17 24.172 17 19.586 21.586 21 23 28 16z"
    })), children);
  });
  var DirectionStraightRight24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRight24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$e || (_path404$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16L21 9 19.586 10.414 24.172 15 4 15 4 17 24.172 17 19.586 21.586 21 23 28 16z"
    })), children);
  });
  var DirectionStraightRight20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRight20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$e || (_path405$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16L21 9 19.586 10.414 24.172 15 4 15 4 17 24.172 17 19.586 21.586 21 23 28 16z"
    })), children);
  });
  var DirectionStraightRight16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRight16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$e || (_path406$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16L21 9 19.586 10.414 24.172 15 4 15 4 17 24.172 17 19.586 21.586 21 23 28 16z"
    })), children);
  });

  var _path$l, _path2$l, _path3$l, _path4$l, _path5$l, _path6$l, _path7$l, _path8$l, _path9$l, _path10$l, _path11$l, _path12$l, _path13$l, _path14$l, _path15$l, _path16$l, _path17$l, _path18$l, _path19$l, _path20$l, _path21$l, _path22$l, _path23$l, _path24$l, _path25$l, _path26$l, _path27$l, _path28$l, _path29$l, _path30$l, _path31$l, _path32$l, _path33$l, _path34$l, _path35$l, _path36$l, _path37$l, _path38$l, _path39$l, _path40$l, _path41$l, _path42$l, _path43$l, _path44$l, _path45$l, _path46$l, _path47$l, _path48$l, _path49$l, _path50$l, _path51$l, _path52$l, _path53$l, _path54$l, _path55$l, _path56$l, _path57$l, _path58$l, _path59$l, _path60$l, _path61$l, _path62$l, _path63$l, _path64$l, _path65$l, _path66$l, _path67$l, _path68$l, _path69$l, _path70$l, _path71$l, _path72$l, _path73$l, _path74$l, _path75$l, _path76$l, _path77$l, _path78$l, _path79$l, _path80$l, _path81$l, _path82$l, _path83$l, _path84$l, _path85$l, _path86$l, _path87$l, _path88$l, _path89$l, _path90$l, _path91$l, _path92$l, _path93$l, _path94$l, _path95$l, _path96$l, _path97$l, _path98$l, _path99$l, _path100$l, _path101$l, _path102$l, _path103$l, _path104$l, _path105$l, _path106$l, _path107$l, _path108$l, _path109$l, _path110$l, _path111$l, _path112$l, _path113$l, _path114$l, _path115$l, _path116$l, _path117$l, _path118$l, _path119$l, _path120$l, _path121$l, _path122$l, _path123$l, _path124$l, _path125$l, _path126$l, _path127$l, _path128$l, _path129$l, _path130$l, _path131$l, _path132$l, _path133$l, _path134$l, _path135$l, _path136$l, _path137$l, _path138$l, _path139$l, _path140$l, _path141$l, _path142$l, _path143$l, _path144$l, _path145$l, _path146$l, _path147$l, _path148$l, _path149$l, _path150$l, _path151$l, _path152$l, _path153$l, _path154$l, _path155$l, _path156$l, _path157$l, _path158$l, _path159$l, _path160$l, _path161$l, _path162$l, _path163$l, _path164$l, _path165$l, _path166$l, _path167$l, _path168$l, _path169$l, _path170$l, _path171$l, _path172$l, _path173$l, _circle$k, _path174$l, _path175$l, _path176$l, _circle2$k, _path177$k, _path178$k, _path179$k, _circle3$k, _path180$k, _path181$k, _path182$k, _circle4$j, _path183$k, _path184$k, _path185$k, _path186$k, _path187$k, _path188$k, _path189$k, _path190$k, _path191$k, _path192$k, _path193$k, _path194$k, _path195$k, _path196$k, _path197$k, _path198$k, _path199$k, _path200$k, _path201$k, _path202$k, _path203$k, _path204$k, _path205$k, _path206$k, _path207$k, _path208$k, _circle5$i, _path209$k, _path210$k, _circle6$i, _path211$k, _path212$k, _circle7$i, _path213$k, _path214$k, _circle8$i, _path215$k, _path216$k, _path217$k, _path218$k, _path219$k, _path220$k, _path221$k, _path222$k, _path223$k, _path224$k, _path225$k, _path226$k, _path227$k, _path228$k, _path229$k, _path230$k, _path231$k, _path232$k, _path233$k, _path234$k, _path235$k, _path236$k, _path237$k, _path238$k, _path239$k, _path240$k, _circle9$i, _path241$k, _path242$k, _path243$k, _circle10$i, _path244$k, _path245$k, _path246$k, _circle11$h, _path247$k, _path248$k, _path249$k, _circle12$h, _path250$k, _path251$k, _path252$k, _path253$k, _path254$k, _path255$k, _path256$k, _path257$k, _path258$k, _path259$k, _path260$k, _path261$k, _path262$k, _path263$k, _path264$k, _path265$k, _path266$k, _path267$k, _path268$k, _path269$k, _path270$k, _path271$k, _path272$k, _path273$k, _path274$k, _path275$k, _path276$k, _path277$k, _path278$k, _path279$k, _path280$k, _circle13$h, _circle14$h, _circle15$h, _circle16$h, _path281$k, _path282$k, _path283$k, _path284$k, _path285$k, _path286$k, _path287$k, _path288$k, _path289$k, _path290$k, _path291$k, _path292$k, _path293$k, _path294$k, _path295$k, _path296$k, _path297$k, _path298$k, _path299$k, _path300$k, _path301$k, _path302$k, _path303$k, _path304$k, _path305$k, _path306$k, _path307$k, _path308$k, _path309$k, _path310$k, _path311$k, _path312$k, _path313$k, _path314$k, _path315$k, _path316$k, _path317$k, _path318$k, _path319$k, _path320$k, _path321$k, _path322$k, _path323$k, _path324$k, _path325$k, _path326$k, _path327$k, _path328$k, _path329$k, _path330$k, _path331$k, _path332$k, _path333$k, _path334$k, _path335$k, _path336$k, _path337$k, _path338$j, _path339$j, _path340$j, _path341$j, _path342$j, _path343$j, _path344$j, _path345$j, _path346$j, _path347$j, _path348$j, _circle17$g, _path349$j, _circle18$g, _path350$j, _circle19$g, _path351$j, _circle20$g, _path352$j, _path353$j, _path354$j, _path355$i, _path356$i, _path357$i, _path358$i, _path359$i, _path360$i, _path361$h, _path362$h, _path363$h, _path364$h, _path365$h, _path366$h, _path367$h, _path368$h, _path369$h, _path370$h, _path371$h, _path372$h, _path373$h, _path374$h, _path375$g, _path376$g, _path377$g, _path378$g, _path379$g, _path380$g, _circle21$g, _path381$g, _path382$g, _circle22$g, _path383$g, _path384$f, _circle23$f, _path385$f, _path386$f, _circle24$f, _path387$f, _path388$f, _path389$f, _path390$f, _path391$f, _path392$f, _path393$f, _path394$f, _path395$f, _path396$f, _circle25$e, _path397$f, _path398$f, _path399$e, _circle26$e, _path400$e, _path401$e, _path402$e, _circle27$d, _path403$d, _path404$d, _path405$d, _circle28$d, _path406$d, _path407$d, _path408$c, _path409$c, _path410$b, _path411$b, _path412$b, _path413$b, _path414$b, _path415$a, _path416$8, _path417$8, _path418$7, _path419$6, _path420$6, _path421$6, _path422$6;

  var _excluded$l = ["children"],
      _excluded2$l = ["children"],
      _excluded3$l = ["children"],
      _excluded4$l = ["children"],
      _excluded5$l = ["children"],
      _excluded6$l = ["children"],
      _excluded7$l = ["children"],
      _excluded8$l = ["children"],
      _excluded9$l = ["children"],
      _excluded10$l = ["children"],
      _excluded11$l = ["children"],
      _excluded12$l = ["children"],
      _excluded13$l = ["children"],
      _excluded14$l = ["children"],
      _excluded15$l = ["children"],
      _excluded16$l = ["children"],
      _excluded17$l = ["children"],
      _excluded18$l = ["children"],
      _excluded19$l = ["children"],
      _excluded20$l = ["children"],
      _excluded21$l = ["children"],
      _excluded22$l = ["children"],
      _excluded23$l = ["children"],
      _excluded24$l = ["children"],
      _excluded25$l = ["children"],
      _excluded26$l = ["children"],
      _excluded27$l = ["children"],
      _excluded28$l = ["children"],
      _excluded29$l = ["children"],
      _excluded30$l = ["children"],
      _excluded31$l = ["children"],
      _excluded32$l = ["children"],
      _excluded33$l = ["children"],
      _excluded34$l = ["children"],
      _excluded35$l = ["children"],
      _excluded36$l = ["children"],
      _excluded37$l = ["children"],
      _excluded38$l = ["children"],
      _excluded39$l = ["children"],
      _excluded40$l = ["children"],
      _excluded41$l = ["children"],
      _excluded42$l = ["children"],
      _excluded43$l = ["children"],
      _excluded44$l = ["children"],
      _excluded45$l = ["children"],
      _excluded46$l = ["children"],
      _excluded47$l = ["children"],
      _excluded48$l = ["children"],
      _excluded49$l = ["children"],
      _excluded50$l = ["children"],
      _excluded51$l = ["children"],
      _excluded52$l = ["children"],
      _excluded53$l = ["children"],
      _excluded54$l = ["children"],
      _excluded55$l = ["children"],
      _excluded56$l = ["children"],
      _excluded57$l = ["children"],
      _excluded58$l = ["children"],
      _excluded59$l = ["children"],
      _excluded60$l = ["children"],
      _excluded61$l = ["children"],
      _excluded62$l = ["children"],
      _excluded63$l = ["children"],
      _excluded64$l = ["children"],
      _excluded65$l = ["children"],
      _excluded66$l = ["children"],
      _excluded67$l = ["children"],
      _excluded68$l = ["children"],
      _excluded69$l = ["children"],
      _excluded70$l = ["children"],
      _excluded71$l = ["children"],
      _excluded72$l = ["children"],
      _excluded73$l = ["children"],
      _excluded74$l = ["children"],
      _excluded75$l = ["children"],
      _excluded76$l = ["children"],
      _excluded77$l = ["children"],
      _excluded78$l = ["children"],
      _excluded79$l = ["children"],
      _excluded80$l = ["children"],
      _excluded81$l = ["children"],
      _excluded82$l = ["children"],
      _excluded83$l = ["children"],
      _excluded84$l = ["children"],
      _excluded85$l = ["children"],
      _excluded86$l = ["children"],
      _excluded87$l = ["children"],
      _excluded88$l = ["children"],
      _excluded89$l = ["children"],
      _excluded90$l = ["children"],
      _excluded91$l = ["children"],
      _excluded92$l = ["children"],
      _excluded93$l = ["children"],
      _excluded94$l = ["children"],
      _excluded95$l = ["children"],
      _excluded96$l = ["children"],
      _excluded97$l = ["children"],
      _excluded98$l = ["children"],
      _excluded99$l = ["children"],
      _excluded100$l = ["children"],
      _excluded101$l = ["children"],
      _excluded102$l = ["children"],
      _excluded103$l = ["children"],
      _excluded104$l = ["children"],
      _excluded105$l = ["children"],
      _excluded106$l = ["children"],
      _excluded107$l = ["children"],
      _excluded108$l = ["children"],
      _excluded109$l = ["children"],
      _excluded110$l = ["children"],
      _excluded111$l = ["children"],
      _excluded112$l = ["children"],
      _excluded113$l = ["children"],
      _excluded114$l = ["children"],
      _excluded115$l = ["children"],
      _excluded116$l = ["children"],
      _excluded117$l = ["children"],
      _excluded118$l = ["children"],
      _excluded119$k = ["children"],
      _excluded120$k = ["children"],
      _excluded121$k = ["children"],
      _excluded122$k = ["children"],
      _excluded123$k = ["children"],
      _excluded124$k = ["children"],
      _excluded125$k = ["children"],
      _excluded126$k = ["children"],
      _excluded127$k = ["children"],
      _excluded128$k = ["children"],
      _excluded129$k = ["children"],
      _excluded130$k = ["children"],
      _excluded131$k = ["children"],
      _excluded132$k = ["children"],
      _excluded133$k = ["children"],
      _excluded134$k = ["children"],
      _excluded135$k = ["children"],
      _excluded136$k = ["children"],
      _excluded137$k = ["children"],
      _excluded138$k = ["children"],
      _excluded139$k = ["children"],
      _excluded140$k = ["children"],
      _excluded141$k = ["children"],
      _excluded142$k = ["children"],
      _excluded143$k = ["children"],
      _excluded144$k = ["children"],
      _excluded145$k = ["children"],
      _excluded146$k = ["children"],
      _excluded147$k = ["children"],
      _excluded148$k = ["children"],
      _excluded149$k = ["children"],
      _excluded150$k = ["children"],
      _excluded151$k = ["children"],
      _excluded152$k = ["children"],
      _excluded153$k = ["children"],
      _excluded154$k = ["children"],
      _excluded155$k = ["children"],
      _excluded156$k = ["children"],
      _excluded157$k = ["children"],
      _excluded158$k = ["children"],
      _excluded159$k = ["children"],
      _excluded160$k = ["children"],
      _excluded161$k = ["children"],
      _excluded162$k = ["children"],
      _excluded163$k = ["children"],
      _excluded164$k = ["children"],
      _excluded165$k = ["children"],
      _excluded166$k = ["children"],
      _excluded167$k = ["children"],
      _excluded168$k = ["children"],
      _excluded169$k = ["children"],
      _excluded170$k = ["children"],
      _excluded171$k = ["children"],
      _excluded172$k = ["children"],
      _excluded173$k = ["children"],
      _excluded174$k = ["children"],
      _excluded175$k = ["children"],
      _excluded176$k = ["children"],
      _excluded177$k = ["children"],
      _excluded178$k = ["children"],
      _excluded179$k = ["children"],
      _excluded180$k = ["children"],
      _excluded181$k = ["children"],
      _excluded182$k = ["children"],
      _excluded183$k = ["children"],
      _excluded184$k = ["children"],
      _excluded185$k = ["children"],
      _excluded186$k = ["children"],
      _excluded187$k = ["children"],
      _excluded188$k = ["children"],
      _excluded189$k = ["children"],
      _excluded190$k = ["children"],
      _excluded191$k = ["children"],
      _excluded192$k = ["children"],
      _excluded193$k = ["children"],
      _excluded194$k = ["children"],
      _excluded195$k = ["children"],
      _excluded196$k = ["children"],
      _excluded197$k = ["children"],
      _excluded198$k = ["children"],
      _excluded199$k = ["children"],
      _excluded200$k = ["children"],
      _excluded201$k = ["children"],
      _excluded202$k = ["children"],
      _excluded203$k = ["children"],
      _excluded204$k = ["children"],
      _excluded205$k = ["children"],
      _excluded206$k = ["children"],
      _excluded207$k = ["children"],
      _excluded208$k = ["children"],
      _excluded209$k = ["children"],
      _excluded210$k = ["children"],
      _excluded211$k = ["children"],
      _excluded212$k = ["children"],
      _excluded213$k = ["children"],
      _excluded214$k = ["children"],
      _excluded215$k = ["children"],
      _excluded216$k = ["children"],
      _excluded217$k = ["children"],
      _excluded218$k = ["children"],
      _excluded219$k = ["children"],
      _excluded220$k = ["children"],
      _excluded221$k = ["children"],
      _excluded222$k = ["children"],
      _excluded223$k = ["children"],
      _excluded224$k = ["children"],
      _excluded225$k = ["children"],
      _excluded226$k = ["children"],
      _excluded227$k = ["children"],
      _excluded228$k = ["children"],
      _excluded229$k = ["children"],
      _excluded230$k = ["children"],
      _excluded231$k = ["children"],
      _excluded232$k = ["children"],
      _excluded233$k = ["children"],
      _excluded234$k = ["children"],
      _excluded235$k = ["children"],
      _excluded236$k = ["children"],
      _excluded237$k = ["children"],
      _excluded238$k = ["children"],
      _excluded239$k = ["children"],
      _excluded240$k = ["children"],
      _excluded241$k = ["children"],
      _excluded242$k = ["children"],
      _excluded243$k = ["children"],
      _excluded244$k = ["children"],
      _excluded245$k = ["children"],
      _excluded246$k = ["children"],
      _excluded247$k = ["children"],
      _excluded248$k = ["children"],
      _excluded249$k = ["children"],
      _excluded250$k = ["children"];
  var DirectionStraightRightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRightFilled32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$l || (_path$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z"
    })), _path2$l || (_path2$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightRightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRightFilled24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$l || (_path3$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z"
    })), _path4$l || (_path4$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightRightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRightFilled20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$l || (_path5$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z"
    })), _path6$l || (_path6$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionStraightRightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionStraightRightFilled16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$l || (_path7$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z"
    })), _path8$l || (_path8$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,23l-1.4141-1.4141L23.1719,17H6V15H23.1719l-4.586-4.5859L20,9l7,7Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var DirectionUTurn32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurn32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$l || (_path9$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,19.5859,22,24.1719V12A8,8,0,0,0,6,12V28H8V12a6,6,0,0,1,12,0V24.1719l-4.5859-4.586L14,21l7,7,7-7Z"
    })), children);
  });
  var DirectionUTurn24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurn24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$l || (_path10$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,19.5859,22,24.1719V12A8,8,0,0,0,6,12V28H8V12a6,6,0,0,1,12,0V24.1719l-4.5859-4.586L14,21l7,7,7-7Z"
    })), children);
  });
  var DirectionUTurn20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurn20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$l || (_path11$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,19.5859,22,24.1719V12A8,8,0,0,0,6,12V28H8V12a6,6,0,0,1,12,0V24.1719l-4.5859-4.586L14,21l7,7,7-7Z"
    })), children);
  });
  var DirectionUTurn16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurn16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$l || (_path12$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,19.5859,22,24.1719V12A8,8,0,0,0,6,12V28H8V12a6,6,0,0,1,12,0V24.1719l-4.5859-4.586L14,21l7,7,7-7Z"
    })), children);
  });
  var DirectionUTurnFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurnFilled32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$l || (_path13$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26.5859,17.5859,22,22.1719V14A8,8,0,0,0,6,14V26H8V14a6,6,0,0,1,12,0v8.1719l-4.5859-4.586L14,19l7,7,7-7Z",
      "data-icon-path": "inner-path"
    })), _path14$l || (_path14$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21,26l-7-7,1.4141-1.4141L20,22.1719V14A6,6,0,0,0,8,14V26H6V14a8,8,0,0,1,16,0v8.1719l4.5859-4.586L28,19Z"
    })), children);
  });
  var DirectionUTurnFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurnFilled24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$l || (_path15$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26.5859,17.5859,22,22.1719V14A8,8,0,0,0,6,14V26H8V14a6,6,0,0,1,12,0v8.1719l-4.5859-4.586L14,19l7,7,7-7Z",
      "data-icon-path": "inner-path"
    })), _path16$l || (_path16$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21,26l-7-7,1.4141-1.4141L20,22.1719V14A6,6,0,0,0,8,14V26H6V14a8,8,0,0,1,16,0v8.1719l4.5859-4.586L28,19Z"
    })), children);
  });
  var DirectionUTurnFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurnFilled20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$l || (_path17$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26.5859,17.5859,22,22.1719V14A8,8,0,0,0,6,14V26H8V14a6,6,0,0,1,12,0v8.1719l-4.5859-4.586L14,19l7,7,7-7Z",
      "data-icon-path": "inner-path"
    })), _path18$l || (_path18$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21,26l-7-7,1.4141-1.4141L20,22.1719V14A6,6,0,0,0,8,14V26H6V14a8,8,0,0,1,16,0v8.1719l4.5859-4.586L28,19Z"
    })), children);
  });
  var DirectionUTurnFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectionUTurnFilled16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$l || (_path19$l = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M26.5859,17.5859,22,22.1719V14A8,8,0,0,0,6,14V26H8V14a6,6,0,0,1,12,0v8.1719l-4.5859-4.586L14,19l7,7,7-7Z",
      "data-icon-path": "inner-path"
    })), _path20$l || (_path20$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V4A2,2,0,0,0,28,2ZM21,26l-7-7,1.4141-1.4141L20,22.1719V14A6,6,0,0,0,8,14V26H6V14a8,8,0,0,1,16,0v8.1719l4.5859-4.586L28,19Z"
    })), children);
  });
  var DirectoryDomain32 = /*#__PURE__*/React__default['default'].forwardRef(function DirectoryDomain32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$l || (_path21$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H18.8157A2.9959,2.9959,0,0,0,17,24.1841V19h7a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,4V17a2.0025,2.0025,0,0,0,2,2h7v5.1841A2.9959,2.9959,0,0,0,13.1843,26H4v2h9.1843a2.982,2.982,0,0,0,5.6314,0H28ZM24,12H8V9H24Zm0-8V7H8V4ZM8,14H24v3H8Zm8,14a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,16,28Z"
    })), children);
  });
  var DirectoryDomain24 = /*#__PURE__*/React__default['default'].forwardRef(function DirectoryDomain24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$l || (_path22$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H18.8157A2.9959,2.9959,0,0,0,17,24.1841V19h7a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,4V17a2.0025,2.0025,0,0,0,2,2h7v5.1841A2.9959,2.9959,0,0,0,13.1843,26H4v2h9.1843a2.982,2.982,0,0,0,5.6314,0H28ZM24,12H8V9H24Zm0-8V7H8V4ZM8,14H24v3H8Zm8,14a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,16,28Z"
    })), children);
  });
  var DirectoryDomain20 = /*#__PURE__*/React__default['default'].forwardRef(function DirectoryDomain20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$l || (_path23$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H18.8157A2.9959,2.9959,0,0,0,17,24.1841V19h7a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,4V17a2.0025,2.0025,0,0,0,2,2h7v5.1841A2.9959,2.9959,0,0,0,13.1843,26H4v2h9.1843a2.982,2.982,0,0,0,5.6314,0H28ZM24,12H8V9H24Zm0-8V7H8V4ZM8,14H24v3H8Zm8,14a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,16,28Z"
    })), children);
  });
  var DirectoryDomain16 = /*#__PURE__*/React__default['default'].forwardRef(function DirectoryDomain16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$l || (_path24$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H18.8157A2.9959,2.9959,0,0,0,17,24.1841V19h7a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,4V17a2.0025,2.0025,0,0,0,2,2h7v5.1841A2.9959,2.9959,0,0,0,13.1843,26H4v2h9.1843a2.982,2.982,0,0,0,5.6314,0H28ZM24,12H8V9H24Zm0-8V7H8V4ZM8,14H24v3H8Zm8,14a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,16,28Z"
    })), children);
  });
  var DistributeHorizontalCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalCenter32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$l || (_path25$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10H23V2H21v8H20a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h1v8h2V22h1a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0024 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 006 8V24a2.0023 2.0023 0 002 2H9v4h2V26h1a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0012 6zm0 18H8V8h4z"
    })), children);
  });
  var DistributeHorizontalCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalCenter24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$l || (_path26$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10H23V2H21v8H20a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h1v8h2V22h1a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0024 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 006 8V24a2.0023 2.0023 0 002 2H9v4h2V26h1a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0012 6zm0 18H8V8h4z"
    })), children);
  });
  var DistributeHorizontalCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalCenter20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$l || (_path27$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10H23V2H21v8H20a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h1v8h2V22h1a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0024 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 006 8V24a2.0023 2.0023 0 002 2H9v4h2V26h1a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0012 6zm0 18H8V8h4z"
    })), children);
  });
  var DistributeHorizontalCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalCenter16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$l || (_path28$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10H23V2H21v8H20a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h1v8h2V22h1a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0024 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 006 8V24a2.0023 2.0023 0 002 2H9v4h2V26h1a2.0023 2.0023 0 002-2V8A2.0023 2.0023 0 0012 6zm0 18H8V8h4z"
    })), children);
  });
  var DistributeHorizontalLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalLeft32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$l || (_path29$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H24a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 018 6h4a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 0112 26zM8 8V24h4V8zM2 2H4V30H2z"
    })), children);
  });
  var DistributeHorizontalLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalLeft24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$l || (_path30$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H24a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 018 6h4a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 0112 26zM8 8V24h4V8zM2 2H4V30H2z"
    })), children);
  });
  var DistributeHorizontalLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalLeft20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$l || (_path31$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H24a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 018 6h4a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 0112 26zM8 8V24h4V8zM2 2H4V30H2z"
    })), children);
  });
  var DistributeHorizontalLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalLeft16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$l || (_path32$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 22H24a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 018 6h4a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 0112 26zM8 8V24h4V8zM2 2H4V30H2z"
    })), children);
  });
  var DistributeHorizontalRight32 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalRight32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$l || (_path33$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0124 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6H8a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 018 26zM4 8H3.9985L4 24H8V8z"
    })), children);
  });
  var DistributeHorizontalRight24 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalRight24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$l || (_path34$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0124 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6H8a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 018 26zM4 8H3.9985L4 24H8V8z"
    })), children);
  });
  var DistributeHorizontalRight20 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalRight20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$l || (_path35$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0124 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6H8a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 018 26zM4 8H3.9985L4 24H8V8z"
    })), children);
  });
  var DistributeHorizontalRight16 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeHorizontalRight16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$l || (_path36$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0124 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 01-2-2V8A2.0021 2.0021 0 014 6H8a2.0021 2.0021 0 012 2V24A2.0021 2.0021 0 018 26zM4 8H3.9985L4 24H8V8z"
    })), children);
  });
  var DistributeVerticalBottom32 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalBottom32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$l || (_path37$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0120 10zm0-6.0012L12 4V8h8z"
    })), children);
  });
  var DistributeVerticalBottom24 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalBottom24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$l || (_path38$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0120 10zm0-6.0012L12 4V8h8z"
    })), children);
  });
  var DistributeVerticalBottom20 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalBottom20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$l || (_path39$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0120 10zm0-6.0012L12 4V8h8z"
    })), children);
  });
  var DistributeVerticalBottom16 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalBottom16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$l || (_path40$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0120 10zm0-6.0012L12 4V8h8z"
    })), children);
  });
  var DistributeVerticalCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalCenter32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$l || (_path41$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21H26V20a2.0023 2.0023 0 00-2-2H8a2.0023 2.0023 0 00-2 2v1H2v2H6v1a2.0023 2.0023 0 002 2H24a2.0023 2.0023 0 002-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 00-2-2H12a2.0023 2.0023 0 00-2 2V9H2v2h8v1a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V11h8zM20 12H12V8l8-.001z"
    })), children);
  });
  var DistributeVerticalCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalCenter24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$l || (_path42$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21H26V20a2.0023 2.0023 0 00-2-2H8a2.0023 2.0023 0 00-2 2v1H2v2H6v1a2.0023 2.0023 0 002 2H24a2.0023 2.0023 0 002-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 00-2-2H12a2.0023 2.0023 0 00-2 2V9H2v2h8v1a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V11h8zM20 12H12V8l8-.001z"
    })), children);
  });
  var DistributeVerticalCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalCenter20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$l || (_path43$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21H26V20a2.0023 2.0023 0 00-2-2H8a2.0023 2.0023 0 00-2 2v1H2v2H6v1a2.0023 2.0023 0 002 2H24a2.0023 2.0023 0 002-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 00-2-2H12a2.0023 2.0023 0 00-2 2V9H2v2h8v1a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V11h8zM20 12H12V8l8-.001z"
    })), children);
  });
  var DistributeVerticalCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalCenter16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$l || (_path44$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21H26V20a2.0023 2.0023 0 00-2-2H8a2.0023 2.0023 0 00-2 2v1H2v2H6v1a2.0023 2.0023 0 002 2H24a2.0023 2.0023 0 002-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 00-2-2H12a2.0023 2.0023 0 00-2 2V9H2v2h8v1a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V11h8zM20 12H12V8l8-.001z"
    })), children);
  });
  var DistributeVerticalTop32 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalTop32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$l || (_path45$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H8a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 01-2-2V8a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0120 14zM12 8v4h8V8zM2 2H30V4H2z"
    })), children);
  });
  var DistributeVerticalTop24 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalTop24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$l || (_path46$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H8a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 01-2-2V8a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0120 14zM12 8v4h8V8zM2 2H30V4H2z"
    })), children);
  });
  var DistributeVerticalTop20 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalTop20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$l || (_path47$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H8a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 01-2-2V8a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0120 14zM12 8v4h8V8zM2 2H30V4H2z"
    })), children);
  });
  var DistributeVerticalTop16 = /*#__PURE__*/React__default['default'].forwardRef(function DistributeVerticalTop16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$l || (_path48$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H8a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0124 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 01-2-2V8a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0120 14zM12 8v4h8V8zM2 2H30V4H2z"
    })), children);
  });
  var WatsonHealthDna32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDna32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$l || (_path49$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"
    })), children);
  });
  var WatsonHealthDna24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDna24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$l || (_path50$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"
    })), children);
  });
  var WatsonHealthDna20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDna20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$l || (_path51$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"
    })), children);
  });
  var WatsonHealthDna16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDna16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$l || (_path52$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"
    })), children);
  });
  var DnsServices32 = /*#__PURE__*/React__default['default'].forwardRef(function DnsServices32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$l || (_path53$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H26V26H20z"
    })), _path54$l || (_path54$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V16A13.9871,13.9871,0,1,0,19.23,29.625l-.46-1.9463A12.0419,12.0419,0,0,1,16,28c-.19,0-.375-.0186-.563-.0273A20.3044,20.3044,0,0,1,12.0259,17Zm-2.0415-2H21.9751A24.2838,24.2838,0,0,0,19.2014,4.4414,12.0228,12.0228,0,0,1,27.9585,15ZM16.563,4.0273A20.3044,20.3044,0,0,1,19.9741,15H12.0259A20.3044,20.3044,0,0,1,15.437,4.0273C15.625,4.0186,15.81,4,16,4S16.375,4.0186,16.563,4.0273Zm-3.7644.4141A24.2838,24.2838,0,0,0,10.0249,15H4.0415A12.0228,12.0228,0,0,1,12.7986,4.4414Zm0,23.1172A12.0228,12.0228,0,0,1,4.0415,17h5.9834A24.2838,24.2838,0,0,0,12.7986,27.5586Z"
    })), children);
  });
  var DnsServices24 = /*#__PURE__*/React__default['default'].forwardRef(function DnsServices24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$l || (_path55$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H26V26H20z"
    })), _path56$l || (_path56$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V16A13.9871,13.9871,0,1,0,19.23,29.625l-.46-1.9463A12.0419,12.0419,0,0,1,16,28c-.19,0-.375-.0186-.563-.0273A20.3044,20.3044,0,0,1,12.0259,17Zm-2.0415-2H21.9751A24.2838,24.2838,0,0,0,19.2014,4.4414,12.0228,12.0228,0,0,1,27.9585,15ZM16.563,4.0273A20.3044,20.3044,0,0,1,19.9741,15H12.0259A20.3044,20.3044,0,0,1,15.437,4.0273C15.625,4.0186,15.81,4,16,4S16.375,4.0186,16.563,4.0273Zm-3.7644.4141A24.2838,24.2838,0,0,0,10.0249,15H4.0415A12.0228,12.0228,0,0,1,12.7986,4.4414Zm0,23.1172A12.0228,12.0228,0,0,1,4.0415,17h5.9834A24.2838,24.2838,0,0,0,12.7986,27.5586Z"
    })), children);
  });
  var DnsServices20 = /*#__PURE__*/React__default['default'].forwardRef(function DnsServices20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$l || (_path57$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H26V26H20z"
    })), _path58$l || (_path58$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V16A13.9871,13.9871,0,1,0,19.23,29.625l-.46-1.9463A12.0419,12.0419,0,0,1,16,28c-.19,0-.375-.0186-.563-.0273A20.3044,20.3044,0,0,1,12.0259,17Zm-2.0415-2H21.9751A24.2838,24.2838,0,0,0,19.2014,4.4414,12.0228,12.0228,0,0,1,27.9585,15ZM16.563,4.0273A20.3044,20.3044,0,0,1,19.9741,15H12.0259A20.3044,20.3044,0,0,1,15.437,4.0273C15.625,4.0186,15.81,4,16,4S16.375,4.0186,16.563,4.0273Zm-3.7644.4141A24.2838,24.2838,0,0,0,10.0249,15H4.0415A12.0228,12.0228,0,0,1,12.7986,4.4414Zm0,23.1172A12.0228,12.0228,0,0,1,4.0415,17h5.9834A24.2838,24.2838,0,0,0,12.7986,27.5586Z"
    })), children);
  });
  var DnsServices16 = /*#__PURE__*/React__default['default'].forwardRef(function DnsServices16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$l || (_path59$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H26V26H20z"
    })), _path60$l || (_path60$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V16A13.9871,13.9871,0,1,0,19.23,29.625l-.46-1.9463A12.0419,12.0419,0,0,1,16,28c-.19,0-.375-.0186-.563-.0273A20.3044,20.3044,0,0,1,12.0259,17Zm-2.0415-2H21.9751A24.2838,24.2838,0,0,0,19.2014,4.4414,12.0228,12.0228,0,0,1,27.9585,15ZM16.563,4.0273A20.3044,20.3044,0,0,1,19.9741,15H12.0259A20.3044,20.3044,0,0,1,15.437,4.0273C15.625,4.0186,15.81,4,16,4S16.375,4.0186,16.563,4.0273Zm-3.7644.4141A24.2838,24.2838,0,0,0,10.0249,15H4.0415A12.0228,12.0228,0,0,1,12.7986,4.4414Zm0,23.1172A12.0228,12.0228,0,0,1,4.0415,17h5.9834A24.2838,24.2838,0,0,0,12.7986,27.5586Z"
    })), children);
  });
  var Doc32 = /*#__PURE__*/React__default['default'].forwardRef(function Doc32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$l || (_path61$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V21A2.0023 2.0023 0 0118 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 014 4v6A4.0045 4.0045 0 016 23zM4 21H6a2.002 2.002 0 002-2V13a2.002 2.002 0 00-2-2H4z"
    })), children);
  });
  var Doc24 = /*#__PURE__*/React__default['default'].forwardRef(function Doc24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$l || (_path62$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V21A2.0023 2.0023 0 0118 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 014 4v6A4.0045 4.0045 0 016 23zM4 21H6a2.002 2.002 0 002-2V13a2.002 2.002 0 00-2-2H4z"
    })), children);
  });
  var Doc20 = /*#__PURE__*/React__default['default'].forwardRef(function Doc20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$l || (_path63$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V21A2.0023 2.0023 0 0118 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 014 4v6A4.0045 4.0045 0 016 23zM4 21H6a2.002 2.002 0 002-2V13a2.002 2.002 0 00-2-2H4z"
    })), children);
  });
  var Doc16 = /*#__PURE__*/React__default['default'].forwardRef(function Doc16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$l || (_path64$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h4a2.002 2.002 0 012 2V21A2.0023 2.0023 0 0118 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 014 4v6A4.0045 4.0045 0 016 23zM4 21H6a2.002 2.002 0 002-2V13a2.002 2.002 0 00-2-2H4z"
    })), children);
  });
  var Document32 = /*#__PURE__*/React__default['default'].forwardRef(function Document32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$l || (_path65$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7C18.5,2.1,18.3,2,18,2H8C6.9,2,6,2.9,6,4v24c0,1.1,0.9,2,2,2h16c1.1,0,2-0.9,2-2V10C26,9.7,25.9,9.5,25.7,9.3\tz M18,4.4l5.6,5.6H18V4.4z M24,28H8V4h8v6c0,1.1,0.9,2,2,2h6V28z"
    })), _path66$l || (_path66$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 22H22V24H10zM10 16H22V18H10z"
    })), children);
  });
  var Document24 = /*#__PURE__*/React__default['default'].forwardRef(function Document24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$l || (_path67$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7C18.5,2.1,18.3,2,18,2H8C6.9,2,6,2.9,6,4v24c0,1.1,0.9,2,2,2h16c1.1,0,2-0.9,2-2V10C26,9.7,25.9,9.5,25.7,9.3\tz M18,4.4l5.6,5.6H18V4.4z M24,28H8V4h8v6c0,1.1,0.9,2,2,2h6V28z"
    })), _path68$l || (_path68$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 22H22V24H10zM10 16H22V18H10z"
    })), children);
  });
  var Document20 = /*#__PURE__*/React__default['default'].forwardRef(function Document20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$l || (_path69$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7C18.5,2.1,18.3,2,18,2H8C6.9,2,6,2.9,6,4v24c0,1.1,0.9,2,2,2h16c1.1,0,2-0.9,2-2V10C26,9.7,25.9,9.5,25.7,9.3\tz M18,4.4l5.6,5.6H18V4.4z M24,28H8V4h8v6c0,1.1,0.9,2,2,2h6V28z"
    })), _path70$l || (_path70$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 22H22V24H10zM10 16H22V18H10z"
    })), children);
  });
  var Document16 = /*#__PURE__*/React__default['default'].forwardRef(function Document16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$l || (_path71$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7C18.5,2.1,18.3,2,18,2H8C6.9,2,6,2.9,6,4v24c0,1.1,0.9,2,2,2h16c1.1,0,2-0.9,2-2V10C26,9.7,25.9,9.5,25.7,9.3\tz M18,4.4l5.6,5.6H18V4.4z M24,28H8V4h8v6c0,1.1,0.9,2,2,2h6V28z"
    })), _path72$l || (_path72$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 22H22V24H10zM10 16H22V18H10z"
    })), children);
  });
  var DocumentAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAdd32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$l || (_path73$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L26 24 26 20 24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24z"
    })), _path74$l || (_path74$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAdd24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$l || (_path75$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L26 24 26 20 24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24z"
    })), _path76$l || (_path76$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAdd20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$l || (_path77$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L26 24 26 20 24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24z"
    })), _path78$l || (_path78$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAdd16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$l || (_path79$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L26 24 26 20 24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24z"
    })), _path80$l || (_path80$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAttachment32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAttachment32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$l || (_path81$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H11a2.0023,2.0023,0,0,1-2-2V22h2v6H26V6H17V4h9a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30Z"
    })), _path82$l || (_path82$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10H24V12H17zM16 15H24V17H16zM15 20H24V22H15zM9 19a5.0055 5.0055 0 01-5-5V3H6V14a3 3 0 006 0V5a1 1 0 00-2 0V15H8V5a3 3 0 016 0v9A5.0055 5.0055 0 019 19z"
    })), children);
  });
  var DocumentAttachment24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAttachment24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$l || (_path83$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H11a2.0023,2.0023,0,0,1-2-2V22h2v6H26V6H17V4h9a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30Z"
    })), _path84$l || (_path84$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10H24V12H17zM16 15H24V17H16zM15 20H24V22H15zM9 19a5.0055 5.0055 0 01-5-5V3H6V14a3 3 0 006 0V5a1 1 0 00-2 0V15H8V5a3 3 0 016 0v9A5.0055 5.0055 0 019 19z"
    })), children);
  });
  var DocumentAttachment20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAttachment20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$l || (_path85$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H11a2.0023,2.0023,0,0,1-2-2V22h2v6H26V6H17V4h9a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30Z"
    })), _path86$l || (_path86$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10H24V12H17zM16 15H24V17H16zM15 20H24V22H15zM9 19a5.0055 5.0055 0 01-5-5V3H6V14a3 3 0 006 0V5a1 1 0 00-2 0V15H8V5a3 3 0 016 0v9A5.0055 5.0055 0 019 19z"
    })), children);
  });
  var DocumentAttachment16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAttachment16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$l || (_path87$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H11a2.0023,2.0023,0,0,1-2-2V22h2v6H26V6H17V4h9a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,26,30Z"
    })), _path88$l || (_path88$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10H24V12H17zM16 15H24V17H16zM15 20H24V22H15zM9 19a5.0055 5.0055 0 01-5-5V3H6V14a3 3 0 006 0V5a1 1 0 00-2 0V15H8V5a3 3 0 016 0v9A5.0055 5.0055 0 019 19z"
    })), children);
  });
  var DocumentAudio32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAudio32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$l || (_path89$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,31a.9987.9987,0,0,1-.6245-.2192L23.6494,27H20a1,1,0,0,1-1-1V21a1,1,0,0,1,1-1h3.6494l4.7261-3.7808A1,1,0,0,1,30,17V30a1,1,0,0,1-1,1Zm-8-6h3a1,1,0,0,1,.6245.2192L28,27.9194V19.0806l-3.3755,2.7A1,1,0,0,1,24,22H21Z"
    })), _path90$l || (_path90$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAudio24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAudio24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$l || (_path91$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,31a.9987.9987,0,0,1-.6245-.2192L23.6494,27H20a1,1,0,0,1-1-1V21a1,1,0,0,1,1-1h3.6494l4.7261-3.7808A1,1,0,0,1,30,17V30a1,1,0,0,1-1,1Zm-8-6h3a1,1,0,0,1,.6245.2192L28,27.9194V19.0806l-3.3755,2.7A1,1,0,0,1,24,22H21Z"
    })), _path92$l || (_path92$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAudio20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAudio20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$l || (_path93$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,31a.9987.9987,0,0,1-.6245-.2192L23.6494,27H20a1,1,0,0,1-1-1V21a1,1,0,0,1,1-1h3.6494l4.7261-3.7808A1,1,0,0,1,30,17V30a1,1,0,0,1-1,1Zm-8-6h3a1,1,0,0,1,.6245.2192L28,27.9194V19.0806l-3.3755,2.7A1,1,0,0,1,24,22H21Z"
    })), _path94$l || (_path94$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentAudio16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentAudio16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$l || (_path95$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,31a.9987.9987,0,0,1-.6245-.2192L23.6494,27H20a1,1,0,0,1-1-1V21a1,1,0,0,1,1-1h3.6494l4.7261-3.7808A1,1,0,0,1,30,17V30a1,1,0,0,1-1,1Zm-8-6h3a1,1,0,0,1,.6245.2192L28,27.9194V19.0806l-3.3755,2.7A1,1,0,0,1,24,22H21Z"
    })), _path96$l || (_path96$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentBlank32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentBlank32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$l || (_path97$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentBlank24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentBlank24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$l || (_path98$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentBlank20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentBlank20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$l || (_path99$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentBlank16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentBlank16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$l || (_path100$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentDownload32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentDownload32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$l || (_path101$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25z"
    })), _path102$l || (_path102$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2H18ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentDownload24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentDownload24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$l || (_path103$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25z"
    })), _path104$l || (_path104$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2H18ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentDownload20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentDownload20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$l || (_path105$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25z"
    })), _path106$l || (_path106$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2H18ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentDownload16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentDownload16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$l || (_path107$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25z"
    })), _path108$l || (_path108$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2H18ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentEpdf32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentEpdf32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$l || (_path109$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26V22a2.0023,2.0023,0,0,0-2-2H22a2.0023,2.0023,0,0,0-2,2v6a2.0077,2.0077,0,0,0,2,2h5V28H22V26Zm-6-4h4v2H22Z"
    })), _path110$l || (_path110$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentEpdf24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentEpdf24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$l || (_path111$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26V22a2.0023,2.0023,0,0,0-2-2H22a2.0023,2.0023,0,0,0-2,2v6a2.0077,2.0077,0,0,0,2,2h5V28H22V26Zm-6-4h4v2H22Z"
    })), _path112$l || (_path112$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentEpdf20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentEpdf20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$l || (_path113$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26V22a2.0023,2.0023,0,0,0-2-2H22a2.0023,2.0023,0,0,0-2,2v6a2.0077,2.0077,0,0,0,2,2h5V28H22V26Zm-6-4h4v2H22Z"
    })), _path114$l || (_path114$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentEpdf16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentEpdf16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$l || (_path115$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26V22a2.0023,2.0023,0,0,0-2-2H22a2.0023,2.0023,0,0,0-2,2v6a2.0077,2.0077,0,0,0,2,2h5V28H22V26Zm-6-4h4v2H22Z"
    })), _path116$l || (_path116$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentExport32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentExport32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$l || (_path117$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"
    })), _path118$l || (_path118$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"
    })), children);
  });
  var DocumentExport24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentExport24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$l || (_path119$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"
    })), _path120$l || (_path120$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"
    })), children);
  });
  var DocumentExport20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentExport20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$l || (_path121$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"
    })), _path122$l || (_path122$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"
    })), children);
  });
  var DocumentExport16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentExport16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$l || (_path123$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"
    })), _path124$l || (_path124$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"
    })), children);
  });
  var DocumentHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentHorizontal32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$l || (_path125$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2.0023,2.0023,0,0,0,2,8V24a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V8A2.0023,2.0023,0,0,0,28,6ZM20,24H12V22a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm8,0H22V22a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H4V8H28Z"
    })), _path126$l || (_path126$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a4,4,0,1,0-4-4A4,4,0,0,0,16,18Zm0-6a2,2,0,1,1-2,2A2,2,0,0,1,16,12Z"
    })), children);
  });
  var DocumentHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentHorizontal24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$l || (_path127$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2.0023,2.0023,0,0,0,2,8V24a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V8A2.0023,2.0023,0,0,0,28,6ZM20,24H12V22a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm8,0H22V22a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H4V8H28Z"
    })), _path128$l || (_path128$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a4,4,0,1,0-4-4A4,4,0,0,0,16,18Zm0-6a2,2,0,1,1-2,2A2,2,0,0,1,16,12Z"
    })), children);
  });
  var DocumentHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentHorizontal20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$l || (_path129$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2.0023,2.0023,0,0,0,2,8V24a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V8A2.0023,2.0023,0,0,0,28,6ZM20,24H12V22a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm8,0H22V22a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H4V8H28Z"
    })), _path130$l || (_path130$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a4,4,0,1,0-4-4A4,4,0,0,0,16,18Zm0-6a2,2,0,1,1-2,2A2,2,0,0,1,16,12Z"
    })), children);
  });
  var DocumentHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentHorizontal16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$l || (_path131$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2.0023,2.0023,0,0,0,2,8V24a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V8A2.0023,2.0023,0,0,0,28,6ZM20,24H12V22a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm8,0H22V22a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H4V8H28Z"
    })), _path132$l || (_path132$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a4,4,0,1,0-4-4A4,4,0,0,0,16,18Zm0-6a2,2,0,1,1-2,2A2,2,0,0,1,16,12Z"
    })), children);
  });
  var DocumentImport32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentImport32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$l || (_path133$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"
    })), _path134$l || (_path134$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"
    })), children);
  });
  var DocumentImport24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentImport24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$l || (_path135$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"
    })), _path136$l || (_path136$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"
    })), children);
  });
  var DocumentImport20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentImport20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$l || (_path137$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"
    })), _path138$l || (_path138$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"
    })), children);
  });
  var DocumentImport16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentImport16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$l || (_path139$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"
    })), _path140$l || (_path140$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"
    })), children);
  });
  var DocumentPdf32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPdf32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$l || (_path141$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18L30 16 24 16 24 26 26 26 26 22 29 22 29 20 26 20 26 18 30 18zM19 26H15V16h4a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0119 26zm-2-2h2a1.0011 1.0011 0 001-1V19a1.0011 1.0011 0 00-1-1H17zM11 16H6V26H8V23h3a2.0027 2.0027 0 002-2V18A2.0023 2.0023 0 0011 16zM8 21V18h3l.001 3z"
    })), _path142$l || (_path142$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,14,2H4A2.0059,2.0059,0,0,0,2,4V28a2,2,0,0,0,2,2H20V28H4V4h8v6a2.0059,2.0059,0,0,0,2,2h6v2Zm-8-4V4.4L19.6,10Z"
    })), children);
  });
  var DocumentPdf24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPdf24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$l || (_path143$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18L30 16 24 16 24 26 26 26 26 22 29 22 29 20 26 20 26 18 30 18zM19 26H15V16h4a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0119 26zm-2-2h2a1.0011 1.0011 0 001-1V19a1.0011 1.0011 0 00-1-1H17zM11 16H6V26H8V23h3a2.0027 2.0027 0 002-2V18A2.0023 2.0023 0 0011 16zM8 21V18h3l.001 3z"
    })), _path144$l || (_path144$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,14,2H4A2.0059,2.0059,0,0,0,2,4V28a2,2,0,0,0,2,2H20V28H4V4h8v6a2.0059,2.0059,0,0,0,2,2h6v2Zm-8-4V4.4L19.6,10Z"
    })), children);
  });
  var DocumentPdf20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPdf20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$l || (_path145$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18L30 16 24 16 24 26 26 26 26 22 29 22 29 20 26 20 26 18 30 18zM19 26H15V16h4a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0119 26zm-2-2h2a1.0011 1.0011 0 001-1V19a1.0011 1.0011 0 00-1-1H17zM11 16H6V26H8V23h3a2.0027 2.0027 0 002-2V18A2.0023 2.0023 0 0011 16zM8 21V18h3l.001 3z"
    })), _path146$l || (_path146$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,14,2H4A2.0059,2.0059,0,0,0,2,4V28a2,2,0,0,0,2,2H20V28H4V4h8v6a2.0059,2.0059,0,0,0,2,2h6v2Zm-8-4V4.4L19.6,10Z"
    })), children);
  });
  var DocumentPdf16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPdf16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$l || (_path147$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18L30 16 24 16 24 26 26 26 26 22 29 22 29 20 26 20 26 18 30 18zM19 26H15V16h4a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0119 26zm-2-2h2a1.0011 1.0011 0 001-1V19a1.0011 1.0011 0 00-1-1H17zM11 16H6V26H8V23h3a2.0027 2.0027 0 002-2V18A2.0023 2.0023 0 0011 16zM8 21V18h3l.001 3z"
    })), _path148$l || (_path148$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,14,2H4A2.0059,2.0059,0,0,0,2,4V28a2,2,0,0,0,2,2H20V28H4V4h8v6a2.0059,2.0059,0,0,0,2,2h6v2Zm-8-4V4.4L19.6,10Z"
    })), children);
  });
  var DocumentPreliminary32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPreliminary32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$l || (_path149$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM8 22H16V24H8zM8 16H18V18H8z"
    })), _path150$l || (_path150$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentPreliminary24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPreliminary24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$l || (_path151$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM8 22H16V24H8zM8 16H18V18H8z"
    })), _path152$l || (_path152$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentPreliminary20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPreliminary20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$l || (_path153$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM8 22H16V24H8zM8 16H18V18H8z"
    })), _path154$l || (_path154$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentPreliminary16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentPreliminary16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$l || (_path155$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM8 22H16V24H8zM8 16H18V18H8z"
    })), _path156$l || (_path156$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentProtected32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentProtected32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$l || (_path157$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-6-3a2,2,0,0,1,4,0v3H22ZM20,28V23h8v5Z"
    })), _path158$l || (_path158$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), children);
  });
  var DocumentProtected24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentProtected24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$l || (_path159$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-6-3a2,2,0,0,1,4,0v3H22ZM20,28V23h8v5Z"
    })), _path160$l || (_path160$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), children);
  });
  var DocumentProtected20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentProtected20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$l || (_path161$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-6-3a2,2,0,0,1,4,0v3H22ZM20,28V23h8v5Z"
    })), _path162$l || (_path162$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), children);
  });
  var DocumentProtected16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentProtected16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$l || (_path163$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-6-3a2,2,0,0,1,4,0v3H22ZM20,28V23h8v5Z"
    })), _path164$l || (_path164$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), children);
  });
  var DocumentSecurity32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSecurity32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$l || (_path165$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30l-2.1387-1.0127A5.0216,5.0216,0,0,1,18,24.4678V18H28v6.4678a5.0216,5.0216,0,0,1-2.8613,4.52ZM20,20v4.4678a3.012,3.012,0,0,0,1.7168,2.7109L23,27.7861l1.2832-.6074A3.012,3.012,0,0,0,26,24.4678V20Z"
    })), _path166$l || (_path166$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentSecurity24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSecurity24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$l || (_path167$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30l-2.1387-1.0127A5.0216,5.0216,0,0,1,18,24.4678V18H28v6.4678a5.0216,5.0216,0,0,1-2.8613,4.52ZM20,20v4.4678a3.012,3.012,0,0,0,1.7168,2.7109L23,27.7861l1.2832-.6074A3.012,3.012,0,0,0,26,24.4678V20Z"
    })), _path168$l || (_path168$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentSecurity20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSecurity20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$l || (_path169$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30l-2.1387-1.0127A5.0216,5.0216,0,0,1,18,24.4678V18H28v6.4678a5.0216,5.0216,0,0,1-2.8613,4.52ZM20,20v4.4678a3.012,3.012,0,0,0,1.7168,2.7109L23,27.7861l1.2832-.6074A3.012,3.012,0,0,0,26,24.4678V20Z"
    })), _path170$l || (_path170$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentSecurity16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSecurity16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$l || (_path171$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30l-2.1387-1.0127A5.0216,5.0216,0,0,1,18,24.4678V18H28v6.4678a5.0216,5.0216,0,0,1-2.8613,4.52ZM20,20v4.4678a3.012,3.012,0,0,0,1.7168,2.7109L23,27.7861l1.2832-.6074A3.012,3.012,0,0,0,26,24.4678V20Z"
    })), _path172$l || (_path172$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H6V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2H16ZM16,4.4,21.6,10H16Z"
    })), children);
  });
  var DocumentSigned32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSigned32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$l || (_path173$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141,30H15V25.5857l5.0337-5.0337A4.6069,4.6069,0,0,1,20,20a5,5,0,1,1,4.4478,4.9663ZM17,28h1.5859l5.2061-5.2063.5395.1238a3.0351,3.0351,0,1,0-2.249-2.2488l.1236.5393L17,26.4143Z"
    })), _circle$k || (_circle$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path174$l || (_path174$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path175$l || (_path175$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2v9H22V4H6V28h6Z"
    })), children);
  });
  var DocumentSigned24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSigned24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$l || (_path176$l = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141,30H15V25.5857l5.0337-5.0337A4.6069,4.6069,0,0,1,20,20a5,5,0,1,1,4.4478,4.9663ZM17,28h1.5859l5.2061-5.2063.5395.1238a3.0351,3.0351,0,1,0-2.249-2.2488l.1236.5393L17,26.4143Z"
    })), _circle2$k || (_circle2$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path177$k || (_path177$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path178$k || (_path178$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2v9H22V4H6V28h6Z"
    })), children);
  });
  var DocumentSigned20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSigned20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$k || (_path179$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141,30H15V25.5857l5.0337-5.0337A4.6069,4.6069,0,0,1,20,20a5,5,0,1,1,4.4478,4.9663ZM17,28h1.5859l5.2061-5.2063.5395.1238a3.0351,3.0351,0,1,0-2.249-2.2488l.1236.5393L17,26.4143Z"
    })), _circle3$k || (_circle3$k = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path180$k || (_path180$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path181$k || (_path181$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2v9H22V4H6V28h6Z"
    })), children);
  });
  var DocumentSigned16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSigned16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$k || (_path182$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.4141,30H15V25.5857l5.0337-5.0337A4.6069,4.6069,0,0,1,20,20a5,5,0,1,1,4.4478,4.9663ZM17,28h1.5859l5.2061-5.2063.5395.1238a3.0351,3.0351,0,1,0-2.249-2.2488l.1236.5393L17,26.4143Z"
    })), _circle4$j || (_circle4$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "20",
      r: "1"
    })), _path183$k || (_path183$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path184$k || (_path184$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2v9H22V4H6V28h6Z"
    })), children);
  });
  var DocumentSketch32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSketch32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$k || (_path185$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path186$k || (_path186$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSketch24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSketch24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$k || (_path187$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path188$k || (_path188$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSketch20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSketch20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$k || (_path189$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path190$k || (_path190$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSketch16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSketch16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$k || (_path191$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path192$k || (_path192$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSubtract32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSubtract32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$k || (_path193$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H30V26H20z"
    })), _path194$k || (_path194$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v8h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSubtract24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSubtract24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$l);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$k || (_path195$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H30V26H20z"
    })), _path196$k || (_path196$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v8h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSubtract20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSubtract20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$k || (_path197$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H30V26H20z"
    })), _path198$k || (_path198$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v8h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentSubtract16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSubtract16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$k || (_path199$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H30V26H20z"
    })), _path200$k || (_path200$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v8h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentTasks32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentTasks32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$k || (_path201$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path202$k || (_path202$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h7ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentTasks24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentTasks24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$k || (_path203$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path204$k || (_path204$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h7ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentTasks20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentTasks20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$k || (_path205$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path206$k || (_path206$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h7ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentTasks16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentTasks16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$k || (_path207$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path208$k || (_path208$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h7ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentUnknown32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnknown32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$i || (_circle5$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "28.5",
      r: "1.5"
    })), _path209$k || (_path209$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,25H8V21h2a2,2,0,0,0,0-4H8a2.0023,2.0023,0,0,0-2,2v.5H4V19a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path210$k || (_path210$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9085.9085,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4v8h2V4h8v6a2.0058,2.0058,0,0,0,2,2h6V28H14v2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,10V4.4L25.6,10Z"
    })), children);
  });
  var DocumentUnknown24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnknown24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$i || (_circle6$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "28.5",
      r: "1.5"
    })), _path211$k || (_path211$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,25H8V21h2a2,2,0,0,0,0-4H8a2.0023,2.0023,0,0,0-2,2v.5H4V19a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path212$k || (_path212$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9085.9085,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4v8h2V4h8v6a2.0058,2.0058,0,0,0,2,2h6V28H14v2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,10V4.4L25.6,10Z"
    })), children);
  });
  var DocumentUnknown20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnknown20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$i || (_circle7$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "28.5",
      r: "1.5"
    })), _path213$k || (_path213$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,25H8V21h2a2,2,0,0,0,0-4H8a2.0023,2.0023,0,0,0-2,2v.5H4V19a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path214$k || (_path214$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9085.9085,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4v8h2V4h8v6a2.0058,2.0058,0,0,0,2,2h6V28H14v2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,10V4.4L25.6,10Z"
    })), children);
  });
  var DocumentUnknown16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnknown16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$i || (_circle8$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "28.5",
      r: "1.5"
    })), _path215$k || (_path215$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,25H8V21h2a2,2,0,0,0,0-4H8a2.0023,2.0023,0,0,0-2,2v.5H4V19a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path216$k || (_path216$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7,9.3l-7-7A.9085.9085,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4v8h2V4h8v6a2.0058,2.0058,0,0,0,2,2h6V28H14v2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,10V4.4L25.6,10Z"
    })), children);
  });
  var DocumentUnprotected32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnprotected32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$k || (_path217$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), _path218$k || (_path218$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H22V18a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-8,7V23h8v5Z"
    })), children);
  });
  var DocumentUnprotected24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnprotected24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$k || (_path219$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), _path220$k || (_path220$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H22V18a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-8,7V23h8v5Z"
    })), children);
  });
  var DocumentUnprotected20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnprotected20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$k || (_path221$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), _path222$k || (_path222$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H22V18a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-8,7V23h8v5Z"
    })), children);
  });
  var DocumentUnprotected16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentUnprotected16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$k || (_path223$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.499,9.085,16.707,2.293A1,1,0,0,0,16,2H6A2.0058,2.0058,0,0,0,4,4V28a2.0058,2.0058,0,0,0,2,2h8V28H6V4h8v6a2.0023,2.0023,0,0,0,2,2h6.292a1.7075,1.7075,0,0,0,1.207-2.915ZM16,10V4.4141L21.5854,10Z"
    })), _path224$k || (_path224$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H22V18a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v5a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V23A2.0025,2.0025,0,0,0,28,21Zm-8,7V23h8v5Z"
    })), children);
  });
  var DocumentVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVertical32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$k || (_path225$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,14a4,4,0,1,1,4-4h0A4.0118,4.0118,0,0,1,16,14Zm0-6a2,2,0,1,0,2,2h0a2.0059,2.0059,0,0,0-2-2Z"
    })), _path226$k || (_path226$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.0023,2.0023,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM12,24V18a.9447.9447,0,0,1,1-1h6a.9447.9447,0,0,1,1,1v6H18v4H14V24Zm8,4V26a2.0058,2.0058,0,0,0,2-2V18a2.9463,2.9463,0,0,0-3-3H13a2.9463,2.9463,0,0,0-3,3v6a2.0058,2.0058,0,0,0,2,2v2H8V4H24V28Z"
    })), children);
  });
  var DocumentVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVertical24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$k || (_path227$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,14a4,4,0,1,1,4-4h0A4.0118,4.0118,0,0,1,16,14Zm0-6a2,2,0,1,0,2,2h0a2.0059,2.0059,0,0,0-2-2Z"
    })), _path228$k || (_path228$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.0023,2.0023,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM12,24V18a.9447.9447,0,0,1,1-1h6a.9447.9447,0,0,1,1,1v6H18v4H14V24Zm8,4V26a2.0058,2.0058,0,0,0,2-2V18a2.9463,2.9463,0,0,0-3-3H13a2.9463,2.9463,0,0,0-3,3v6a2.0058,2.0058,0,0,0,2,2v2H8V4H24V28Z"
    })), children);
  });
  var DocumentVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVertical20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$k || (_path229$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,14a4,4,0,1,1,4-4h0A4.0118,4.0118,0,0,1,16,14Zm0-6a2,2,0,1,0,2,2h0a2.0059,2.0059,0,0,0-2-2Z"
    })), _path230$k || (_path230$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.0023,2.0023,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM12,24V18a.9447.9447,0,0,1,1-1h6a.9447.9447,0,0,1,1,1v6H18v4H14V24Zm8,4V26a2.0058,2.0058,0,0,0,2-2V18a2.9463,2.9463,0,0,0-3-3H13a2.9463,2.9463,0,0,0-3,3v6a2.0058,2.0058,0,0,0,2,2v2H8V4H24V28Z"
    })), children);
  });
  var DocumentVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVertical16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$k || (_path231$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,14a4,4,0,1,1,4-4h0A4.0118,4.0118,0,0,1,16,14Zm0-6a2,2,0,1,0,2,2h0a2.0059,2.0059,0,0,0-2-2Z"
    })), _path232$k || (_path232$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2.0023,2.0023,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM12,24V18a.9447.9447,0,0,1,1-1h6a.9447.9447,0,0,1,1,1v6H18v4H14V24Zm8,4V26a2.0058,2.0058,0,0,0,2-2V18a2.9463,2.9463,0,0,0-3-3H13a2.9463,2.9463,0,0,0-3,3v6a2.0058,2.0058,0,0,0,2,2v2H8V4H24V28Z"
    })), children);
  });
  var DocumentVideo32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVideo32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$k || (_path233$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19l-4,3.2V20a2.0023,2.0023,0,0,0-2-2H16a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V23.8L30,27ZM16,26V20h8l.0015,6Z"
    })), _path234$k || (_path234$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentVideo24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVideo24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$k || (_path235$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19l-4,3.2V20a2.0023,2.0023,0,0,0-2-2H16a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V23.8L30,27ZM16,26V20h8l.0015,6Z"
    })), _path236$k || (_path236$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentVideo20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVideo20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$k || (_path237$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19l-4,3.2V20a2.0023,2.0023,0,0,0-2-2H16a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V23.8L30,27ZM16,26V20h8l.0015,6Z"
    })), _path238$k || (_path238$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentVideo16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentVideo16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$k || (_path239$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19l-4,3.2V20a2.0023,2.0023,0,0,0-2-2H16a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h8a2.0023,2.0023,0,0,0,2-2V23.8L30,27ZM16,26V20h8l.0015,6Z"
    })), _path240$k || (_path240$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3l2,0V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentView32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentView32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$i || (_circle9$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path241$k || (_path241$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path242$k || (_path242$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path243$k || (_path243$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentView24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentView24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$i || (_circle10$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path244$k || (_path244$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path245$k || (_path245$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path246$k || (_path246$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentView20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentView20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$h || (_circle11$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path247$k || (_path247$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path248$k || (_path248$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path249$k || (_path249$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentView16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentView16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12$h || (_circle12$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path250$k || (_path250$k = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path251$k || (_path251$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path252$k || (_path252$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v4h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h4ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var DocumentWordProcessor32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessor32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$k || (_path253$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20z"
    })), _path254$k || (_path254$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentWordProcessor24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessor24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$k || (_path255$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20z"
    })), _path256$k || (_path256$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentWordProcessor20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessor20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$k || (_path257$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20z"
    })), _path258$k || (_path258$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentWordProcessor16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessor16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$k || (_path259$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20z"
    })), _path260$k || (_path260$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,9.293l-7-7A1,1,0,0,0,18,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2h8V28H8V4h8v6a2.002,2.002,0,0,0,2,2h6v4h2V10A1,1,0,0,0,25.707,9.293ZM18,4.4141,23.5859,10H18Z"
    })), children);
  });
  var DocumentWordProcessorReference32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessorReference32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$k || (_path261$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM25.707 9.293l-7-7A1 1 0 0018 2H8A2.002 2.002 0 006 4V16H8V4h8v6a2.002 2.002 0 002 2h6v4h2V10A1 1 0 0025.707 9.293zM18 10V4.4141L23.5859 10z"
    })), children);
  });
  var DocumentWordProcessorReference24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessorReference24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$k || (_path262$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM25.707 9.293l-7-7A1 1 0 0018 2H8A2.002 2.002 0 006 4V16H8V4h8v6a2.002 2.002 0 002 2h6v4h2V10A1 1 0 0025.707 9.293zM18 10V4.4141L23.5859 10z"
    })), children);
  });
  var DocumentWordProcessorReference20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessorReference20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$k || (_path263$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM25.707 9.293l-7-7A1 1 0 0018 2H8A2.002 2.002 0 006 4V16H8V4h8v6a2.002 2.002 0 002 2h6v4h2V10A1 1 0 0025.707 9.293zM18 10V4.4141L23.5859 10z"
    })), children);
  });
  var DocumentWordProcessorReference16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentWordProcessorReference16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$k || (_path264$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.3 20L27.391 28.611 26 20 24 20 22.609 28.611 21.7 20 20 20 21.36 30 23.64 30 25 21.626 26.36 30 28.64 30 30 20 28.3 20zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM25.707 9.293l-7-7A1 1 0 0018 2H8A2.002 2.002 0 006 4V16H8V4h8v6a2.002 2.002 0 002 2h6v4h2V10A1 1 0 0025.707 9.293zM18 10V4.4141L23.5859 10z"
    })), children);
  });
  var DocumentSentiment32 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSentiment32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$k || (_path265$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"
    })), _path266$k || (_path266$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentSentiment24 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSentiment24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$k || (_path267$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"
    })), _path268$k || (_path268$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentSentiment20 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSentiment20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$k || (_path269$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"
    })), _path270$k || (_path270$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DocumentSentiment16 = /*#__PURE__*/React__default['default'].forwardRef(function DocumentSentiment16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$k || (_path271$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"
    })), _path272$k || (_path272$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var DogWalker32 = /*#__PURE__*/React__default['default'].forwardRef(function DogWalker32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$k || (_path273$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H22V30H20zM4 23H6V30H4z"
    })), _path274$k || (_path274$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V26a1.0011 1.0011 0 00-1-1H11v5H9V23h4a3.0033 3.0033 0 013 3zM7.5 22A3.5041 3.5041 0 014 18.5V17H2V15H6v3.5a1.5 1.5 0 003 0V15h4v2H11v1.5A3.5041 3.5041 0 017.5 22zM27 10H21.354a2.9861 2.9861 0 00-2.7856 1.8857l-1.4419 3.6055-3.6079 4.51 1.562 1.249 3.7-4.625 1.645-3.9961A.9949.9949 0 0121.354 12H27a1.0009 1.0009 0 011 1v7H25V30h2V22h1a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zM24 9a4 4 0 114-4A4.0045 4.0045 0 0124 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 3z"
    })), children);
  });
  var DogWalker24 = /*#__PURE__*/React__default['default'].forwardRef(function DogWalker24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$k || (_path275$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H22V30H20zM4 23H6V30H4z"
    })), _path276$k || (_path276$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V26a1.0011 1.0011 0 00-1-1H11v5H9V23h4a3.0033 3.0033 0 013 3zM7.5 22A3.5041 3.5041 0 014 18.5V17H2V15H6v3.5a1.5 1.5 0 003 0V15h4v2H11v1.5A3.5041 3.5041 0 017.5 22zM27 10H21.354a2.9861 2.9861 0 00-2.7856 1.8857l-1.4419 3.6055-3.6079 4.51 1.562 1.249 3.7-4.625 1.645-3.9961A.9949.9949 0 0121.354 12H27a1.0009 1.0009 0 011 1v7H25V30h2V22h1a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zM24 9a4 4 0 114-4A4.0045 4.0045 0 0124 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 3z"
    })), children);
  });
  var DogWalker20 = /*#__PURE__*/React__default['default'].forwardRef(function DogWalker20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$k || (_path277$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H22V30H20zM4 23H6V30H4z"
    })), _path278$k || (_path278$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V26a1.0011 1.0011 0 00-1-1H11v5H9V23h4a3.0033 3.0033 0 013 3zM7.5 22A3.5041 3.5041 0 014 18.5V17H2V15H6v3.5a1.5 1.5 0 003 0V15h4v2H11v1.5A3.5041 3.5041 0 017.5 22zM27 10H21.354a2.9861 2.9861 0 00-2.7856 1.8857l-1.4419 3.6055-3.6079 4.51 1.562 1.249 3.7-4.625 1.645-3.9961A.9949.9949 0 0121.354 12H27a1.0009 1.0009 0 011 1v7H25V30h2V22h1a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zM24 9a4 4 0 114-4A4.0045 4.0045 0 0124 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 3z"
    })), children);
  });
  var DogWalker16 = /*#__PURE__*/React__default['default'].forwardRef(function DogWalker16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$k || (_path279$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H22V30H20zM4 23H6V30H4z"
    })), _path280$k || (_path280$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V26a1.0011 1.0011 0 00-1-1H11v5H9V23h4a3.0033 3.0033 0 013 3zM7.5 22A3.5041 3.5041 0 014 18.5V17H2V15H6v3.5a1.5 1.5 0 003 0V15h4v2H11v1.5A3.5041 3.5041 0 017.5 22zM27 10H21.354a2.9861 2.9861 0 00-2.7856 1.8857l-1.4419 3.6055-3.6079 4.51 1.562 1.249 3.7-4.625 1.645-3.9961A.9949.9949 0 0121.354 12H27a1.0009 1.0009 0 011 1v7H25V30h2V22h1a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zM24 9a4 4 0 114-4A4.0045 4.0045 0 0124 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 3z"
    })), children);
  });
  var DotMark32 = /*#__PURE__*/React__default['default'].forwardRef(function DotMark32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$h || (_circle13$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "8"
    })), children);
  });
  var DotMark24 = /*#__PURE__*/React__default['default'].forwardRef(function DotMark24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$h || (_circle14$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "8"
    })), children);
  });
  var DotMark20 = /*#__PURE__*/React__default['default'].forwardRef(function DotMark20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$h || (_circle15$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "8"
    })), children);
  });
  var DotMark16 = /*#__PURE__*/React__default['default'].forwardRef(function DotMark16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$h || (_circle16$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "8"
    })), children);
  });
  var DoubleInteger32 = /*#__PURE__*/React__default['default'].forwardRef(function DoubleInteger32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$k || (_path281$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 8V6H13V2H11V6H8V2H6V6H2V8H6v3H2v2H6v4H8V13h3v4h2V13h4V11H13V8zm-6 3H8V8h3zM30 21V19H26V15H24v4H21V15H19v4H15v2h4v3H15v2h4v4h2V26h3v4h2V26h4V24H26V21zm-6 3H21V21h3z"
    })), children);
  });
  var DoubleInteger24 = /*#__PURE__*/React__default['default'].forwardRef(function DoubleInteger24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$k || (_path282$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 8V6H13V2H11V6H8V2H6V6H2V8H6v3H2v2H6v4H8V13h3v4h2V13h4V11H13V8zm-6 3H8V8h3zM30 21V19H26V15H24v4H21V15H19v4H15v2h4v3H15v2h4v4h2V26h3v4h2V26h4V24H26V21zm-6 3H21V21h3z"
    })), children);
  });
  var DoubleInteger20 = /*#__PURE__*/React__default['default'].forwardRef(function DoubleInteger20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$k || (_path283$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 8V6H13V2H11V6H8V2H6V6H2V8H6v3H2v2H6v4H8V13h3v4h2V13h4V11H13V8zm-6 3H8V8h3zM30 21V19H26V15H24v4H21V15H19v4H15v2h4v3H15v2h4v4h2V26h3v4h2V26h4V24H26V21zm-6 3H21V21h3z"
    })), children);
  });
  var DoubleInteger16 = /*#__PURE__*/React__default['default'].forwardRef(function DoubleInteger16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$k || (_path284$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 8V6H13V2H11V6H8V2H6V6H2V8H6v3H2v2H6v4H8V13h3v4h2V13h4V11H13V8zm-6 3H8V8h3zM30 21V19H26V15H24v4H21V15H19v4H15v2h4v3H15v2h4v4h2V26h3v4h2V26h4V24H26V21zm-6 3H21V21h3z"
    })), children);
  });
  var DownToBottom32 = /*#__PURE__*/React__default['default'].forwardRef(function DownToBottom32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$k || (_path285$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L6 8 7.4 6.6 16 15.2 24.6 6.6 26 8zM4 22H28V24H4z"
    })), children);
  });
  var DownToBottom24 = /*#__PURE__*/React__default['default'].forwardRef(function DownToBottom24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$k || (_path286$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L6 8 7.4 6.6 16 15.2 24.6 6.6 26 8zM4 22H28V24H4z"
    })), children);
  });
  var DownToBottom20 = /*#__PURE__*/React__default['default'].forwardRef(function DownToBottom20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$k || (_path287$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L6 8 7.4 6.6 16 15.2 24.6 6.6 26 8zM4 22H28V24H4z"
    })), children);
  });
  var DownToBottom16 = /*#__PURE__*/React__default['default'].forwardRef(function DownToBottom16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$k || (_path288$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L6 8 7.4 6.6 16 15.2 24.6 6.6 26 8zM4 22H28V24H4z"
    })), children);
  });
  var Download32 = /*#__PURE__*/React__default['default'].forwardRef(function Download32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$k || (_path289$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24v4H6V24H4v4H4a2 2 0 002 2H26a2 2 0 002-2h0V24zM26 14L24.59 12.59 17 20.17 17 2 15 2 15 20.17 7.41 12.59 6 14 16 24 26 14z"
    })), children);
  });
  var Download24 = /*#__PURE__*/React__default['default'].forwardRef(function Download24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$k || (_path290$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24v4H6V24H4v4H4a2 2 0 002 2H26a2 2 0 002-2h0V24zM26 14L24.59 12.59 17 20.17 17 2 15 2 15 20.17 7.41 12.59 6 14 16 24 26 14z"
    })), children);
  });
  var Download20 = /*#__PURE__*/React__default['default'].forwardRef(function Download20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$k || (_path291$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24v4H6V24H4v4H4a2 2 0 002 2H26a2 2 0 002-2h0V24zM26 14L24.59 12.59 17 20.17 17 2 15 2 15 20.17 7.41 12.59 6 14 16 24 26 14z"
    })), children);
  });
  var Download16 = /*#__PURE__*/React__default['default'].forwardRef(function Download16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$k || (_path292$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 7L12.3 6.3 8.5 10.1 8.5 1 7.5 1 7.5 10.1 3.7 6.3 3 7 8 12zM13 12v2H3v-2H2v2l0 0c0 .6.4 1 1 1h10c.6 0 1-.4 1-1l0 0v-2H13z"
    })), children);
  });
  var WatsonHealthDownloadStudy32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDownloadStudy32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$k || (_path293$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25zM19 14H23V16H19zM19 10H26V12H19zM9 18h6a3 3 0 013 3v2H16V21a1 1 0 00-1-1H9a1 1 0 00-1 1v2H6V21A3 3 0 019 18zM16 13a4 4 0 10-4 4A4 4 0 0016 13zm-2 0a2 2 0 11-2-2A2 2 0 0114 13z"
    })), _path294$k || (_path294$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H18Z"
    })), children);
  });
  var WatsonHealthDownloadStudy24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDownloadStudy24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$k || (_path295$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25zM19 14H23V16H19zM19 10H26V12H19zM9 18h6a3 3 0 013 3v2H16V21a1 1 0 00-1-1H9a1 1 0 00-1 1v2H6V21A3 3 0 019 18zM16 13a4 4 0 10-4 4A4 4 0 0016 13zm-2 0a2 2 0 11-2-2A2 2 0 0114 13z"
    })), _path296$k || (_path296$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H18Z"
    })), children);
  });
  var WatsonHealthDownloadStudy20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDownloadStudy20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$k || (_path297$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25zM19 14H23V16H19zM19 10H26V12H19zM9 18h6a3 3 0 013 3v2H16V21a1 1 0 00-1-1H9a1 1 0 00-1 1v2H6V21A3 3 0 019 18zM16 13a4 4 0 10-4 4A4 4 0 0016 13zm-2 0a2 2 0 11-2-2A2 2 0 0114 13z"
    })), _path298$k || (_path298$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H18Z"
    })), children);
  });
  var WatsonHealthDownloadStudy16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthDownloadStudy16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$k || (_path299$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L28.586 23.586 26 26.172 26 18 24 18 24 26.172 21.414 23.586 20 25 25 30 30 25zM19 14H23V16H19zM19 10H26V12H19zM9 18h6a3 3 0 013 3v2H16V21a1 1 0 00-1-1H9a1 1 0 00-1 1v2H6V21A3 3 0 019 18zM16 13a4 4 0 10-4 4A4 4 0 0016 13zm-2 0a2 2 0 11-2-2A2 2 0 0114 13z"
    })), _path300$k || (_path300$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H18Z"
    })), children);
  });
  var DragHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function DragHorizontal32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$k || (_path301$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var DragHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function DragHorizontal24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$k || (_path302$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var DragHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function DragHorizontal20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$k || (_path303$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var DragHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function DragHorizontal16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$k || (_path304$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var DragVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function DragVertical32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$k || (_path305$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"
    })), children);
  });
  var DragVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function DragVertical24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$k || (_path306$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"
    })), children);
  });
  var DragVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function DragVertical20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$k || (_path307$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"
    })), children);
  });
  var DragVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function DragVertical16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$k || (_path308$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"
    })), children);
  });
  var Draggable32 = /*#__PURE__*/React__default['default'].forwardRef(function Draggable32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$k || (_path309$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H14V10H10zM18 6H22V10H18zM10 14H14V18H10zM18 14H22V18H18zM10 22H14V26H10zM18 22H22V26H18z"
    })), children);
  });
  var Draggable24 = /*#__PURE__*/React__default['default'].forwardRef(function Draggable24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$k || (_path310$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H14V10H10zM18 6H22V10H18zM10 14H14V18H10zM18 14H22V18H18zM10 22H14V26H10zM18 22H22V26H18z"
    })), children);
  });
  var Draggable20 = /*#__PURE__*/React__default['default'].forwardRef(function Draggable20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$k || (_path311$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H14V10H10zM18 6H22V10H18zM10 14H14V18H10zM18 14H22V18H18zM10 22H14V26H10zM18 22H22V26H18z"
    })), children);
  });
  var Draggable16 = /*#__PURE__*/React__default['default'].forwardRef(function Draggable16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$k || (_path312$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H14V10H10zM18 6H22V10H18zM10 14H14V18H10zM18 14H22V18H18zM10 22H14V26H10zM18 22H22V26H18z"
    })), children);
  });
  var Draw32 = /*#__PURE__*/React__default['default'].forwardRef(function Draw32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$k || (_path313$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"
    })), children);
  });
  var Draw24 = /*#__PURE__*/React__default['default'].forwardRef(function Draw24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$k || (_path314$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"
    })), children);
  });
  var Draw20 = /*#__PURE__*/React__default['default'].forwardRef(function Draw20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$k || (_path315$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"
    })), children);
  });
  var Draw16 = /*#__PURE__*/React__default['default'].forwardRef(function Draw16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$k || (_path316$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"
    })), children);
  });
  var DrillBack32 = /*#__PURE__*/React__default['default'].forwardRef(function DrillBack32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$k || (_path317$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22L7.414 20.586 3.828 17 12 17 12 15 3.828 15 7.414 11.414 6 10 0 16 6 22z"
    })), _path318$k || (_path318$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a5.9815,5.9815,0,0,0-4.2427,1.7573L16,16l-4.2427,4.2427A6,6,0,1,0,16,10Z"
    })), _path319$k || (_path319$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9581,13.9581,0,0,0,6.105,6.105L7.5188,7.5186a12,12,0,1,1,0,16.9628L6.105,25.895A13.9974,13.9974,0,1,0,16,2Z"
    })), children);
  });
  var DrillBack24 = /*#__PURE__*/React__default['default'].forwardRef(function DrillBack24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$k || (_path320$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22L7.414 20.586 3.828 17 12 17 12 15 3.828 15 7.414 11.414 6 10 0 16 6 22z"
    })), _path321$k || (_path321$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a5.9815,5.9815,0,0,0-4.2427,1.7573L16,16l-4.2427,4.2427A6,6,0,1,0,16,10Z"
    })), _path322$k || (_path322$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9581,13.9581,0,0,0,6.105,6.105L7.5188,7.5186a12,12,0,1,1,0,16.9628L6.105,25.895A13.9974,13.9974,0,1,0,16,2Z"
    })), children);
  });
  var DrillBack20 = /*#__PURE__*/React__default['default'].forwardRef(function DrillBack20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$k || (_path323$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22L7.414 20.586 3.828 17 12 17 12 15 3.828 15 7.414 11.414 6 10 0 16 6 22z"
    })), _path324$k || (_path324$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a5.9815,5.9815,0,0,0-4.2427,1.7573L16,16l-4.2427,4.2427A6,6,0,1,0,16,10Z"
    })), _path325$k || (_path325$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9581,13.9581,0,0,0,6.105,6.105L7.5188,7.5186a12,12,0,1,1,0,16.9628L6.105,25.895A13.9974,13.9974,0,1,0,16,2Z"
    })), children);
  });
  var DrillBack16 = /*#__PURE__*/React__default['default'].forwardRef(function DrillBack16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$k || (_path326$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22L7.414 20.586 3.828 17 12 17 12 15 3.828 15 7.414 11.414 6 10 0 16 6 22z"
    })), _path327$k || (_path327$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a5.9815,5.9815,0,0,0-4.2427,1.7573L16,16l-4.2427,4.2427A6,6,0,1,0,16,10Z"
    })), _path328$k || (_path328$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9581,13.9581,0,0,0,6.105,6.105L7.5188,7.5186a12,12,0,1,1,0,16.9628L6.105,25.895A13.9974,13.9974,0,1,0,16,2Z"
    })), children);
  });
  var DrillDown32 = /*#__PURE__*/React__default['default'].forwardRef(function DrillDown32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$k || (_path329$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L11.414 4.586 15 8.172 15 0 17 0 17 8.172 20.586 4.586 22 6 16 12 10 6z"
    })), _path330$k || (_path330$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,16a5.9815,5.9815,0,0,0-1.7573-4.2427L16,16l-4.2427-4.2427A6,6,0,1,0,22,16Z"
    })), _path331$k || (_path331$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a13.9581,13.9581,0,0,0-4.105-9.895L24.4814,7.5188a12,12,0,1,1-16.9628,0L6.105,6.105A13.9974,13.9974,0,1,0,30,16Z"
    })), children);
  });
  var DrillDown24 = /*#__PURE__*/React__default['default'].forwardRef(function DrillDown24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$k || (_path332$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L11.414 4.586 15 8.172 15 0 17 0 17 8.172 20.586 4.586 22 6 16 12 10 6z"
    })), _path333$k || (_path333$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,16a5.9815,5.9815,0,0,0-1.7573-4.2427L16,16l-4.2427-4.2427A6,6,0,1,0,22,16Z"
    })), _path334$k || (_path334$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a13.9581,13.9581,0,0,0-4.105-9.895L24.4814,7.5188a12,12,0,1,1-16.9628,0L6.105,6.105A13.9974,13.9974,0,1,0,30,16Z"
    })), children);
  });
  var DrillDown20 = /*#__PURE__*/React__default['default'].forwardRef(function DrillDown20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$k || (_path335$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L11.414 4.586 15 8.172 15 0 17 0 17 8.172 20.586 4.586 22 6 16 12 10 6z"
    })), _path336$k || (_path336$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,16a5.9815,5.9815,0,0,0-1.7573-4.2427L16,16l-4.2427-4.2427A6,6,0,1,0,22,16Z"
    })), _path337$k || (_path337$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a13.9581,13.9581,0,0,0-4.105-9.895L24.4814,7.5188a12,12,0,1,1-16.9628,0L6.105,6.105A13.9974,13.9974,0,1,0,30,16Z"
    })), children);
  });
  var DrillDown16 = /*#__PURE__*/React__default['default'].forwardRef(function DrillDown16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$j || (_path338$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6L11.414 4.586 15 8.172 15 0 17 0 17 8.172 20.586 4.586 22 6 16 12 10 6z"
    })), _path339$j || (_path339$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,16a5.9815,5.9815,0,0,0-1.7573-4.2427L16,16l-4.2427-4.2427A6,6,0,1,0,22,16Z"
    })), _path340$j || (_path340$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a13.9581,13.9581,0,0,0-4.105-9.895L24.4814,7.5188a12,12,0,1,1-16.9628,0L6.105,6.105A13.9974,13.9974,0,1,0,30,16Z"
    })), children);
  });
  var DrillThrough32 = /*#__PURE__*/React__default['default'].forwardRef(function DrillThrough32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$j || (_path341$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path342$j || (_path342$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12L4 10 8.586 10 2 3.414 3.414 2 10 8.586 10 4 12 4 12 12 4 12zM16 10v6H10a6 6 0 106-6z"
    })), children);
  });
  var DrillThrough24 = /*#__PURE__*/React__default['default'].forwardRef(function DrillThrough24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$j || (_path343$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path344$j || (_path344$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12L4 10 8.586 10 2 3.414 3.414 2 10 8.586 10 4 12 4 12 12 4 12zM16 10v6H10a6 6 0 106-6z"
    })), children);
  });
  var DrillThrough20 = /*#__PURE__*/React__default['default'].forwardRef(function DrillThrough20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$j || (_path345$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path346$j || (_path346$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12L4 10 8.586 10 2 3.414 3.414 2 10 8.586 10 4 12 4 12 12 4 12zM16 10v6H10a6 6 0 106-6z"
    })), children);
  });
  var DrillThrough16 = /*#__PURE__*/React__default['default'].forwardRef(function DrillThrough16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$j || (_path347$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12,12,0,1,0,16,4V2a14,14,0,0,1,0,28Z"
    })), _path348$j || (_path348$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12L4 10 8.586 10 2 3.414 3.414 2 10 8.586 10 4 12 4 12 12 4 12zM16 10v6H10a6 6 0 106-6z"
    })), children);
  });
  var DriverAnalysis32 = /*#__PURE__*/React__default['default'].forwardRef(function DriverAnalysis32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle17$g || (_circle17$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "2"
    })), _path349$j || (_path349$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.91A6.0048,6.0048,0,0,0,22,10l-.022.001A9.9833,9.9833,0,0,0,4.0508,15H2v2H4.0508A9.9833,9.9833,0,0,0,21.978,21.999L22,22a6.0048,6.0048,0,0,0,5.91-5H30ZM14,8a7.9769,7.9769,0,0,1,5.7383,2.4463A6.0152,6.0152,0,0,0,16.0891,15H6.0693A8.0073,8.0073,0,0,1,14,8Zm0,16a8.0073,8.0073,0,0,1-7.9307-7h10.02a6.0152,6.0152,0,0,0,3.6492,4.5537A7.9769,7.9769,0,0,1,14,24Zm8-4a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,20Z"
    })), children);
  });
  var DriverAnalysis24 = /*#__PURE__*/React__default['default'].forwardRef(function DriverAnalysis24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle18$g || (_circle18$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "2"
    })), _path350$j || (_path350$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.91A6.0048,6.0048,0,0,0,22,10l-.022.001A9.9833,9.9833,0,0,0,4.0508,15H2v2H4.0508A9.9833,9.9833,0,0,0,21.978,21.999L22,22a6.0048,6.0048,0,0,0,5.91-5H30ZM14,8a7.9769,7.9769,0,0,1,5.7383,2.4463A6.0152,6.0152,0,0,0,16.0891,15H6.0693A8.0073,8.0073,0,0,1,14,8Zm0,16a8.0073,8.0073,0,0,1-7.9307-7h10.02a6.0152,6.0152,0,0,0,3.6492,4.5537A7.9769,7.9769,0,0,1,14,24Zm8-4a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,20Z"
    })), children);
  });
  var DriverAnalysis20 = /*#__PURE__*/React__default['default'].forwardRef(function DriverAnalysis20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$g || (_circle19$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "2"
    })), _path351$j || (_path351$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.91A6.0048,6.0048,0,0,0,22,10l-.022.001A9.9833,9.9833,0,0,0,4.0508,15H2v2H4.0508A9.9833,9.9833,0,0,0,21.978,21.999L22,22a6.0048,6.0048,0,0,0,5.91-5H30ZM14,8a7.9769,7.9769,0,0,1,5.7383,2.4463A6.0152,6.0152,0,0,0,16.0891,15H6.0693A8.0073,8.0073,0,0,1,14,8Zm0,16a8.0073,8.0073,0,0,1-7.9307-7h10.02a6.0152,6.0152,0,0,0,3.6492,4.5537A7.9769,7.9769,0,0,1,14,24Zm8-4a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,20Z"
    })), children);
  });
  var DriverAnalysis16 = /*#__PURE__*/React__default['default'].forwardRef(function DriverAnalysis16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle20$g || (_circle20$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "2"
    })), _path352$j || (_path352$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.91A6.0048,6.0048,0,0,0,22,10l-.022.001A9.9833,9.9833,0,0,0,4.0508,15H2v2H4.0508A9.9833,9.9833,0,0,0,21.978,21.999L22,22a6.0048,6.0048,0,0,0,5.91-5H30ZM14,8a7.9769,7.9769,0,0,1,5.7383,2.4463A6.0152,6.0152,0,0,0,16.0891,15H6.0693A8.0073,8.0073,0,0,1,14,8Zm0,16a8.0073,8.0073,0,0,1-7.9307-7h10.02a6.0152,6.0152,0,0,0,3.6492,4.5537A7.9769,7.9769,0,0,1,14,24Zm8-4a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,20Z"
    })), children);
  });
  var Drone32 = /*#__PURE__*/React__default['default'].forwardRef(function Drone32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$j || (_path353$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12a5 5 0 115-5H10a3 3 0 10-3 3zM25 12V10a3 3 0 10-3-3H20a5 5 0 115 5zM7 30A5 5 0 017 20v2a3 3 0 103 3h2A5.0055 5.0055 0 017 30zM25 30a5.0055 5.0055 0 01-5-5h2a3 3 0 103-3V20a5 5 0 010 10z"
    })), _path354$j || (_path354$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18.5859V13.4141L25.707,7.707a1,1,0,1,0-1.414-1.414l-4.4995,4.5a3.9729,3.9729,0,0,0-7.587,0L7.707,6.293a.9994.9994,0,0,0-1.414,0h0a.9994.9994,0,0,0,0,1.414L12,13.4141v5.1718L6.293,24.293a.9994.9994,0,0,0,0,1.414h0a.9994.9994,0,0,0,1.414,0l4.5-4.5a3.9729,3.9729,0,0,0,7.587,0l4.4995,4.5a1,1,0,0,0,1.414-1.414ZM18,20a2,2,0,0,1-4,0V12a2,2,0,0,1,4,0Z"
    })), children);
  });
  var Drone24 = /*#__PURE__*/React__default['default'].forwardRef(function Drone24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$i || (_path355$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12a5 5 0 115-5H10a3 3 0 10-3 3zM25 12V10a3 3 0 10-3-3H20a5 5 0 115 5zM7 30A5 5 0 017 20v2a3 3 0 103 3h2A5.0055 5.0055 0 017 30zM25 30a5.0055 5.0055 0 01-5-5h2a3 3 0 103-3V20a5 5 0 010 10z"
    })), _path356$i || (_path356$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18.5859V13.4141L25.707,7.707a1,1,0,1,0-1.414-1.414l-4.4995,4.5a3.9729,3.9729,0,0,0-7.587,0L7.707,6.293a.9994.9994,0,0,0-1.414,0h0a.9994.9994,0,0,0,0,1.414L12,13.4141v5.1718L6.293,24.293a.9994.9994,0,0,0,0,1.414h0a.9994.9994,0,0,0,1.414,0l4.5-4.5a3.9729,3.9729,0,0,0,7.587,0l4.4995,4.5a1,1,0,0,0,1.414-1.414ZM18,20a2,2,0,0,1-4,0V12a2,2,0,0,1,4,0Z"
    })), children);
  });
  var Drone20 = /*#__PURE__*/React__default['default'].forwardRef(function Drone20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$i || (_path357$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12a5 5 0 115-5H10a3 3 0 10-3 3zM25 12V10a3 3 0 10-3-3H20a5 5 0 115 5zM7 30A5 5 0 017 20v2a3 3 0 103 3h2A5.0055 5.0055 0 017 30zM25 30a5.0055 5.0055 0 01-5-5h2a3 3 0 103-3V20a5 5 0 010 10z"
    })), _path358$i || (_path358$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18.5859V13.4141L25.707,7.707a1,1,0,1,0-1.414-1.414l-4.4995,4.5a3.9729,3.9729,0,0,0-7.587,0L7.707,6.293a.9994.9994,0,0,0-1.414,0h0a.9994.9994,0,0,0,0,1.414L12,13.4141v5.1718L6.293,24.293a.9994.9994,0,0,0,0,1.414h0a.9994.9994,0,0,0,1.414,0l4.5-4.5a3.9729,3.9729,0,0,0,7.587,0l4.4995,4.5a1,1,0,0,0,1.414-1.414ZM18,20a2,2,0,0,1-4,0V12a2,2,0,0,1,4,0Z"
    })), children);
  });
  var Drone16 = /*#__PURE__*/React__default['default'].forwardRef(function Drone16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$i || (_path359$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12a5 5 0 115-5H10a3 3 0 10-3 3zM25 12V10a3 3 0 10-3-3H20a5 5 0 115 5zM7 30A5 5 0 017 20v2a3 3 0 103 3h2A5.0055 5.0055 0 017 30zM25 30a5.0055 5.0055 0 01-5-5h2a3 3 0 103-3V20a5 5 0 010 10z"
    })), _path360$i || (_path360$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18.5859V13.4141L25.707,7.707a1,1,0,1,0-1.414-1.414l-4.4995,4.5a3.9729,3.9729,0,0,0-7.587,0L7.707,6.293a.9994.9994,0,0,0-1.414,0h0a.9994.9994,0,0,0,0,1.414L12,13.4141v5.1718L6.293,24.293a.9994.9994,0,0,0,0,1.414h0a.9994.9994,0,0,0,1.414,0l4.5-4.5a3.9729,3.9729,0,0,0,7.587,0l4.4995,4.5a1,1,0,0,0,1.414-1.414ZM18,20a2,2,0,0,1-4,0V12a2,2,0,0,1,4,0Z"
    })), children);
  });
  var DroneDelivery32 = /*#__PURE__*/React__default['default'].forwardRef(function DroneDelivery32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$h || (_path361$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H12V22h8Zm-6-2h4V24H14Z"
    })), _path362$h || (_path362$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 11L22 11 22 13 26 13 26 16 6 16 6 13 10 13 10 11 0 11 0 13 4 13 4 18 9.132 18 6 22.697 6 27 8 27 8 23.303 11.535 18 20.465 18 24 23.303 24 27 26 27 26 22.697 22.868 18 28 18 28 13 32 13 32 11zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path363$h || (_path363$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneDelivery24 = /*#__PURE__*/React__default['default'].forwardRef(function DroneDelivery24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$h || (_path364$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H12V22h8Zm-6-2h4V24H14Z"
    })), _path365$h || (_path365$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 11L22 11 22 13 26 13 26 16 6 16 6 13 10 13 10 11 0 11 0 13 4 13 4 18 9.132 18 6 22.697 6 27 8 27 8 23.303 11.535 18 20.465 18 24 23.303 24 27 26 27 26 22.697 22.868 18 28 18 28 13 32 13 32 11zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path366$h || (_path366$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneDelivery20 = /*#__PURE__*/React__default['default'].forwardRef(function DroneDelivery20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$h || (_path367$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H12V22h8Zm-6-2h4V24H14Z"
    })), _path368$h || (_path368$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 11L22 11 22 13 26 13 26 16 6 16 6 13 10 13 10 11 0 11 0 13 4 13 4 18 9.132 18 6 22.697 6 27 8 27 8 23.303 11.535 18 20.465 18 24 23.303 24 27 26 27 26 22.697 22.868 18 28 18 28 13 32 13 32 11zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path369$h || (_path369$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneDelivery16 = /*#__PURE__*/React__default['default'].forwardRef(function DroneDelivery16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$h || (_path370$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H12V22h8Zm-6-2h4V24H14Z"
    })), _path371$h || (_path371$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 11L22 11 22 13 26 13 26 16 6 16 6 13 10 13 10 11 0 11 0 13 4 13 4 18 9.132 18 6 22.697 6 27 8 27 8 23.303 11.535 18 20.465 18 24 23.303 24 27 26 27 26 22.697 22.868 18 28 18 28 13 32 13 32 11zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path372$h || (_path372$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneFront32 = /*#__PURE__*/React__default['default'].forwardRef(function DroneFront32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$h || (_path373$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path374$h || (_path374$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneFront24 = /*#__PURE__*/React__default['default'].forwardRef(function DroneFront24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$g || (_path375$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path376$g || (_path376$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneFront20 = /*#__PURE__*/React__default['default'].forwardRef(function DroneFront20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$g || (_path377$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path378$g || (_path378$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneFront16 = /*#__PURE__*/React__default['default'].forwardRef(function DroneFront16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$g || (_path379$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path380$g || (_path380$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneVideo32 = /*#__PURE__*/React__default['default'].forwardRef(function DroneVideo32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21$g || (_circle21$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "21",
      r: "1"
    })), _path381$g || (_path381$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path382$g || (_path382$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneVideo24 = /*#__PURE__*/React__default['default'].forwardRef(function DroneVideo24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22$g || (_circle22$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "21",
      r: "1"
    })), _path383$g || (_path383$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path384$f || (_path384$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneVideo20 = /*#__PURE__*/React__default['default'].forwardRef(function DroneVideo20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle23$f || (_circle23$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "21",
      r: "1"
    })), _path385$f || (_path385$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path386$f || (_path386$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DroneVideo16 = /*#__PURE__*/React__default['default'].forwardRef(function DroneVideo16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle24$f || (_circle24$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "21",
      r: "1"
    })), _path387$f || (_path387$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19V15H26v2H6V15H4v4h7v4.4116L7 25.6367V30H9V26.8125L12.26 25h7.481L23 26.8125V30h2V25.6367l-4-2.2251V19zm-9 4H13V19h6zM0 11H10V13H0zM22 11H32V13H22zM16 6a5.9817 5.9817 0 00-4.2407 1.7593l1.4136 1.4136a3.9936 3.9936 0 015.6542 0l1.4136-1.4136A5.9814 5.9814 0 0016 6z"
    })), _path388$f || (_path388$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9324,4.9321l1.4133,1.4136a7.9877,7.9877,0,0,1,11.3086,0l1.4136-1.4136a9.9844,9.9844,0,0,0-14.1355,0Z"
    })), children);
  });
  var DropPhoto32 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhoto32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$f || (_path389$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"
    })), _path390$f || (_path390$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 29H11a2 2 0 01-2-2V18a2 2 0 012-2h3.2793l.5441-1.6324A2 2 0 0116.7208 13h4.5584a2 2 0 011.8974 1.3676L23.7207 16H27a2 2 0 012 2v9A2 2 0 0127 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhoto24 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhoto24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$f || (_path391$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"
    })), _path392$f || (_path392$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 29H11a2 2 0 01-2-2V18a2 2 0 012-2h3.2793l.5441-1.6324A2 2 0 0116.7208 13h4.5584a2 2 0 011.8974 1.3676L23.7207 16H27a2 2 0 012 2v9A2 2 0 0127 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhoto20 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhoto20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$f || (_path393$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"
    })), _path394$f || (_path394$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 29H11a2 2 0 01-2-2V18a2 2 0 012-2h3.2793l.5441-1.6324A2 2 0 0116.7208 13h4.5584a2 2 0 011.8974 1.3676L23.7207 16H27a2 2 0 012 2v9A2 2 0 0127 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhoto16 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhoto16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$f || (_path395$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"
    })), _path396$f || (_path396$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 29H11a2 2 0 01-2-2V18a2 2 0 012-2h3.2793l.5441-1.6324A2 2 0 0116.7208 13h4.5584a2 2 0 011.8974 1.3676L23.7207 16H27a2 2 0 012 2v9A2 2 0 0127 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhotoFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhotoFilled32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle25$e || (_circle25$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "22",
      r: "2"
    })), _path397$f || (_path397$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"
    })), _path398$f || (_path398$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z",
      "data-icon-path": "inner-path"
    })), _path399$e || (_path399$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhotoFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhotoFilled24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle26$e || (_circle26$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "22",
      r: "2"
    })), _path400$e || (_path400$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"
    })), _path401$e || (_path401$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z",
      "data-icon-path": "inner-path"
    })), _path402$e || (_path402$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhotoFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhotoFilled20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle27$d || (_circle27$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "22",
      r: "2"
    })), _path403$d || (_path403$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"
    })), _path404$d || (_path404$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z",
      "data-icon-path": "inner-path"
    })), _path405$d || (_path405$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var DropPhotoFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function DropPhotoFilled16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle28$d || (_circle28$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "22",
      r: "2"
    })), _path406$d || (_path406$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"
    })), _path407$d || (_path407$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z",
      "data-icon-path": "inner-path"
    })), _path408$c || (_path408$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"
    })), children);
  });
  var Drought32 = /*#__PURE__*/React__default['default'].forwardRef(function Drought32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$c || (_path409$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18h3V15a4.0045,4.0045,0,0,0-4-4H25V9.5A3.5042,3.5042,0,0,0,21.5,6a3.4556,3.4556,0,0,0-1.5.3511V5.41a3.41,3.41,0,0,0-6.5449-1.3433L11.3408,9H9a5.0059,5.0059,0,0,0-5,5v4H8a5.0059,5.0059,0,0,0,5-5V10.2051l2.293-5.35A1.41,1.41,0,0,1,18,5.41V22H14.6123L11,25.2939,7.3877,22H2v2H6.6123L11,28l4.3877-4H30V22H20V9.5a1.5,1.5,0,0,1,3,0V14A4.0045,4.0045,0,0,0,27,18Zm-2-5h1a2.0023,2.0023,0,0,1,2,2v1H27a2.0023,2.0023,0,0,1-2-2ZM11,13a3.0033,3.0033,0,0,1-3,3H6V14a3.0033,3.0033,0,0,1,3-3h2Z"
    })), children);
  });
  var Drought24 = /*#__PURE__*/React__default['default'].forwardRef(function Drought24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$b || (_path410$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18h3V15a4.0045,4.0045,0,0,0-4-4H25V9.5A3.5042,3.5042,0,0,0,21.5,6a3.4556,3.4556,0,0,0-1.5.3511V5.41a3.41,3.41,0,0,0-6.5449-1.3433L11.3408,9H9a5.0059,5.0059,0,0,0-5,5v4H8a5.0059,5.0059,0,0,0,5-5V10.2051l2.293-5.35A1.41,1.41,0,0,1,18,5.41V22H14.6123L11,25.2939,7.3877,22H2v2H6.6123L11,28l4.3877-4H30V22H20V9.5a1.5,1.5,0,0,1,3,0V14A4.0045,4.0045,0,0,0,27,18Zm-2-5h1a2.0023,2.0023,0,0,1,2,2v1H27a2.0023,2.0023,0,0,1-2-2ZM11,13a3.0033,3.0033,0,0,1-3,3H6V14a3.0033,3.0033,0,0,1,3-3h2Z"
    })), children);
  });
  var Drought20 = /*#__PURE__*/React__default['default'].forwardRef(function Drought20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$b || (_path411$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18h3V15a4.0045,4.0045,0,0,0-4-4H25V9.5A3.5042,3.5042,0,0,0,21.5,6a3.4556,3.4556,0,0,0-1.5.3511V5.41a3.41,3.41,0,0,0-6.5449-1.3433L11.3408,9H9a5.0059,5.0059,0,0,0-5,5v4H8a5.0059,5.0059,0,0,0,5-5V10.2051l2.293-5.35A1.41,1.41,0,0,1,18,5.41V22H14.6123L11,25.2939,7.3877,22H2v2H6.6123L11,28l4.3877-4H30V22H20V9.5a1.5,1.5,0,0,1,3,0V14A4.0045,4.0045,0,0,0,27,18Zm-2-5h1a2.0023,2.0023,0,0,1,2,2v1H27a2.0023,2.0023,0,0,1-2-2ZM11,13a3.0033,3.0033,0,0,1-3,3H6V14a3.0033,3.0033,0,0,1,3-3h2Z"
    })), children);
  });
  var Drought16 = /*#__PURE__*/React__default['default'].forwardRef(function Drought16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$b || (_path412$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18h3V15a4.0045,4.0045,0,0,0-4-4H25V9.5A3.5042,3.5042,0,0,0,21.5,6a3.4556,3.4556,0,0,0-1.5.3511V5.41a3.41,3.41,0,0,0-6.5449-1.3433L11.3408,9H9a5.0059,5.0059,0,0,0-5,5v4H8a5.0059,5.0059,0,0,0,5-5V10.2051l2.293-5.35A1.41,1.41,0,0,1,18,5.41V22H14.6123L11,25.2939,7.3877,22H2v2H6.6123L11,28l4.3877-4H30V22H20V9.5a1.5,1.5,0,0,1,3,0V14A4.0045,4.0045,0,0,0,27,18Zm-2-5h1a2.0023,2.0023,0,0,1,2,2v1H27a2.0023,2.0023,0,0,1-2-2ZM11,13a3.0033,3.0033,0,0,1-3,3H6V14a3.0033,3.0033,0,0,1,3-3h2Z"
    })), children);
  });
  var Dvr32 = /*#__PURE__*/React__default['default'].forwardRef(function Dvr32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$b || (_path413$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 014 4v6A4 4 0 016 23zM4 21H6a2 2 0 002-2V13a2 2 0 00-2-2H4z"
    })), children);
  });
  var Dvr24 = /*#__PURE__*/React__default['default'].forwardRef(function Dvr24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$b || (_path414$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 014 4v6A4 4 0 016 23zM4 21H6a2 2 0 002-2V13a2 2 0 00-2-2H4z"
    })), children);
  });
  var Dvr20 = /*#__PURE__*/React__default['default'].forwardRef(function Dvr20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$a || (_path415$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 014 4v6A4 4 0 016 23zM4 21H6a2 2 0 002-2V13a2 2 0 00-2-2H4z"
    })), children);
  });
  var Dvr16 = /*#__PURE__*/React__default['default'].forwardRef(function Dvr16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path416$8 || (_path416$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 014 4v6A4 4 0 016 23zM4 21H6a2 2 0 002-2V13a2 2 0 00-2-2H4z"
    })), children);
  });
  var Earth32 = /*#__PURE__*/React__default['default'].forwardRef(function Earth32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$8 || (_path417$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"
    })), children);
  });
  var Earth24 = /*#__PURE__*/React__default['default'].forwardRef(function Earth24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path418$7 || (_path418$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"
    })), children);
  });
  var Earth20 = /*#__PURE__*/React__default['default'].forwardRef(function Earth20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path419$6 || (_path419$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"
    })), children);
  });
  var Earth16 = /*#__PURE__*/React__default['default'].forwardRef(function Earth16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path420$6 || (_path420$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"
    })), children);
  });
  var EarthAmericas32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericas32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$6 || (_path421$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"
    })), children);
  });
  var EarthAmericas24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericas24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path422$6 || (_path422$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"
    })), children);
  });

  var _path$k, _path2$k, _path3$k, _path4$k, _path5$k, _path6$k, _path7$k, _path8$k, _path9$k, _path10$k, _path11$k, _path12$k, _path13$k, _path14$k, _path15$k, _path16$k, _path17$k, _path18$k, _path19$k, _path20$k, _path21$k, _path22$k, _path23$k, _path24$k, _path25$k, _path26$k, _path27$k, _path28$k, _path29$k, _path30$k, _path31$k, _path32$k, _path33$k, _path34$k, _path35$k, _path36$k, _path37$k, _path38$k, _path39$k, _path40$k, _path41$k, _path42$k, _path43$k, _path44$k, _path45$k, _path46$k, _path47$k, _path48$k, _path49$k, _path50$k, _path51$k, _path52$k, _path53$k, _path54$k, _path55$k, _path56$k, _path57$k, _path58$k, _path59$k, _path60$k, _path61$k, _path62$k, _path63$k, _path64$k, _path65$k, _path66$k, _path67$k, _path68$k, _path69$k, _path70$k, _path71$k, _path72$k, _path73$k, _path74$k, _path75$k, _path76$k, _path77$k, _path78$k, _path79$k, _path80$k, _path81$k, _path82$k, _path83$k, _circle$j, _circle2$j, _circle3$j, _circle4$i, _path84$k, _path85$k, _path86$k, _circle5$h, _circle6$h, _circle7$h, _circle8$h, _path87$k, _path88$k, _path89$k, _circle9$h, _circle10$h, _circle11$g, _circle12$g, _path90$k, _path91$k, _path92$k, _circle13$g, _circle14$g, _circle15$g, _circle16$g, _path93$k, _path94$k, _path95$k, _circle17$f, _circle18$f, _circle19$f, _path96$k, _path97$k, _circle20$f, _circle21$f, _circle22$f, _path98$k, _path99$k, _circle23$e, _circle24$e, _circle25$d, _path100$k, _path101$k, _circle26$d, _circle27$c, _circle28$c, _path102$k, _path103$k, _path104$k, _path105$k, _path106$k, _path107$k, _path108$k, _path109$k, _path110$k, _path111$k, _path112$k, _path113$k, _path114$k, _path115$k, _path116$k, _path117$k, _path118$k, _path119$k, _path120$k, _path121$k, _path122$k, _path123$k, _path124$k, _path125$k, _path126$k, _path127$k, _path128$k, _path129$k, _path130$k, _path131$k, _path132$k, _path133$k, _path134$k, _path135$k, _path136$k, _path137$k, _path138$k, _path139$k, _path140$k, _path141$k, _path142$k, _path143$k, _circle29$c, _path144$k, _circle30$c, _path145$k, _circle31$c, _path146$k, _circle32$c, _path147$k, _path148$k, _path149$k, _path150$k, _path151$k, _path152$k, _path153$k, _path154$k, _path155$k, _path156$k, _path157$k, _path158$k, _path159$k, _path160$k, _path161$k, _path162$k, _path163$k, _path164$k, _path165$k, _path166$k, _path167$k, _path168$k, _path169$k, _path170$k, _path171$k, _path172$k, _path173$k, _path174$k, _path175$k, _path176$k, _path177$j, _path178$j, _path179$j, _path180$j, _path181$j, _path182$j, _path183$j, _path184$j, _path185$j, _path186$j, _path187$j, _path188$j, _path189$j, _path190$j, _path191$j, _path192$j, _path193$j, _path194$j, _path195$j, _path196$j, _path197$j, _path198$j, _path199$j, _path200$j, _path201$j, _path202$j, _path203$j, _path204$j, _path205$j, _path206$j, _path207$j, _path208$j, _path209$j, _path210$j, _path211$j, _path212$j, _path213$j, _path214$j, _path215$j, _path216$j, _path217$j, _path218$j, _path219$j, _path220$j, _path221$j, _path222$j, _path223$j, _path224$j, _path225$j, _path226$j, _path227$j, _path228$j, _path229$j, _path230$j, _path231$j, _path232$j, _path233$j, _path234$j, _path235$j, _path236$j, _path237$j, _path238$j, _path239$j, _path240$j, _path241$j, _path242$j, _path243$j, _path244$j, _path245$j, _path246$j, _path247$j, _path248$j, _path249$j, _path250$j, _path251$j, _path252$j, _path253$j, _path254$j, _path255$j, _path256$j, _path257$j, _path258$j, _path259$j, _path260$j, _path261$j, _path262$j, _path263$j, _path264$j, _path265$j, _path266$j, _path267$j, _path268$j, _path269$j, _path270$j, _path271$j, _path272$j, _path273$j, _path274$j, _path275$j, _path276$j, _path277$j, _path278$j, _path279$j, _path280$j, _path281$j, _path282$j, _path283$j, _path284$j, _path285$j, _path286$j, _path287$j, _path288$j, _path289$j, _path290$j, _path291$j, _path292$j, _path293$j, _path294$j, _path295$j, _path296$j, _path297$j, _path298$j, _path299$j, _path300$j, _path301$j, _path302$j, _path303$j, _path304$j, _path305$j, _path306$j, _path307$j, _path308$j, _path309$j, _path310$j, _path311$j, _path312$j, _path313$j, _path314$j, _path315$j, _path316$j, _path317$j, _path318$j, _path319$j, _path320$j, _path321$j, _path322$j, _path323$j, _path324$j, _path325$j, _path326$j, _path327$j, _path328$j, _path329$j, _path330$j, _path331$j, _path332$j, _path333$j, _path334$j, _path335$j, _path336$j, _path337$j, _path338$i, _path339$i, _path340$i, _path341$i, _path342$i, _path343$i, _path344$i, _path345$i, _path346$i, _path347$i, _path348$i, _path349$i, _path350$i, _path351$i, _path352$i, _path353$i, _path354$i, _path355$h, _path356$h, _path357$h, _path358$h, _path359$h, _path360$h, _path361$g, _path362$g, _path363$g, _path364$g, _path365$g, _path366$g, _path367$g, _path368$g, _path369$g, _path370$g, _path371$g, _path372$g, _path373$g, _path374$g;

  var _excluded$k = ["children"],
      _excluded2$k = ["children"],
      _excluded3$k = ["children"],
      _excluded4$k = ["children"],
      _excluded5$k = ["children"],
      _excluded6$k = ["children"],
      _excluded7$k = ["children"],
      _excluded8$k = ["children"],
      _excluded9$k = ["children"],
      _excluded10$k = ["children"],
      _excluded11$k = ["children"],
      _excluded12$k = ["children"],
      _excluded13$k = ["children"],
      _excluded14$k = ["children"],
      _excluded15$k = ["children"],
      _excluded16$k = ["children"],
      _excluded17$k = ["children"],
      _excluded18$k = ["children"],
      _excluded19$k = ["children"],
      _excluded20$k = ["children"],
      _excluded21$k = ["children"],
      _excluded22$k = ["children"],
      _excluded23$k = ["children"],
      _excluded24$k = ["children"],
      _excluded25$k = ["children"],
      _excluded26$k = ["children"],
      _excluded27$k = ["children"],
      _excluded28$k = ["children"],
      _excluded29$k = ["children"],
      _excluded30$k = ["children"],
      _excluded31$k = ["children"],
      _excluded32$k = ["children"],
      _excluded33$k = ["children"],
      _excluded34$k = ["children"],
      _excluded35$k = ["children"],
      _excluded36$k = ["children"],
      _excluded37$k = ["children"],
      _excluded38$k = ["children"],
      _excluded39$k = ["children"],
      _excluded40$k = ["children"],
      _excluded41$k = ["children"],
      _excluded42$k = ["children"],
      _excluded43$k = ["children"],
      _excluded44$k = ["children"],
      _excluded45$k = ["children"],
      _excluded46$k = ["children"],
      _excluded47$k = ["children"],
      _excluded48$k = ["children"],
      _excluded49$k = ["children"],
      _excluded50$k = ["children"],
      _excluded51$k = ["children"],
      _excluded52$k = ["children"],
      _excluded53$k = ["children"],
      _excluded54$k = ["children"],
      _excluded55$k = ["children"],
      _excluded56$k = ["children"],
      _excluded57$k = ["children"],
      _excluded58$k = ["children"],
      _excluded59$k = ["children"],
      _excluded60$k = ["children"],
      _excluded61$k = ["children"],
      _excluded62$k = ["children"],
      _excluded63$k = ["children"],
      _excluded64$k = ["children"],
      _excluded65$k = ["children"],
      _excluded66$k = ["children"],
      _excluded67$k = ["children"],
      _excluded68$k = ["children"],
      _excluded69$k = ["children"],
      _excluded70$k = ["children"],
      _excluded71$k = ["children"],
      _excluded72$k = ["children"],
      _excluded73$k = ["children"],
      _excluded74$k = ["children"],
      _excluded75$k = ["children"],
      _excluded76$k = ["children"],
      _excluded77$k = ["children"],
      _excluded78$k = ["children"],
      _excluded79$k = ["children"],
      _excluded80$k = ["children"],
      _excluded81$k = ["children"],
      _excluded82$k = ["children"],
      _excluded83$k = ["children"],
      _excluded84$k = ["children"],
      _excluded85$k = ["children"],
      _excluded86$k = ["children"],
      _excluded87$k = ["children"],
      _excluded88$k = ["children"],
      _excluded89$k = ["children"],
      _excluded90$k = ["children"],
      _excluded91$k = ["children"],
      _excluded92$k = ["children"],
      _excluded93$k = ["children"],
      _excluded94$k = ["children"],
      _excluded95$k = ["children"],
      _excluded96$k = ["children"],
      _excluded97$k = ["children"],
      _excluded98$k = ["children"],
      _excluded99$k = ["children"],
      _excluded100$k = ["children"],
      _excluded101$k = ["children"],
      _excluded102$k = ["children"],
      _excluded103$k = ["children"],
      _excluded104$k = ["children"],
      _excluded105$k = ["children"],
      _excluded106$k = ["children"],
      _excluded107$k = ["children"],
      _excluded108$k = ["children"],
      _excluded109$k = ["children"],
      _excluded110$k = ["children"],
      _excluded111$k = ["children"],
      _excluded112$k = ["children"],
      _excluded113$k = ["children"],
      _excluded114$k = ["children"],
      _excluded115$k = ["children"],
      _excluded116$k = ["children"],
      _excluded117$k = ["children"],
      _excluded118$k = ["children"],
      _excluded119$j = ["children"],
      _excluded120$j = ["children"],
      _excluded121$j = ["children"],
      _excluded122$j = ["children"],
      _excluded123$j = ["children"],
      _excluded124$j = ["children"],
      _excluded125$j = ["children"],
      _excluded126$j = ["children"],
      _excluded127$j = ["children"],
      _excluded128$j = ["children"],
      _excluded129$j = ["children"],
      _excluded130$j = ["children"],
      _excluded131$j = ["children"],
      _excluded132$j = ["children"],
      _excluded133$j = ["children"],
      _excluded134$j = ["children"],
      _excluded135$j = ["children"],
      _excluded136$j = ["children"],
      _excluded137$j = ["children"],
      _excluded138$j = ["children"],
      _excluded139$j = ["children"],
      _excluded140$j = ["children"],
      _excluded141$j = ["children"],
      _excluded142$j = ["children"],
      _excluded143$j = ["children"],
      _excluded144$j = ["children"],
      _excluded145$j = ["children"],
      _excluded146$j = ["children"],
      _excluded147$j = ["children"],
      _excluded148$j = ["children"],
      _excluded149$j = ["children"],
      _excluded150$j = ["children"],
      _excluded151$j = ["children"],
      _excluded152$j = ["children"],
      _excluded153$j = ["children"],
      _excluded154$j = ["children"],
      _excluded155$j = ["children"],
      _excluded156$j = ["children"],
      _excluded157$j = ["children"],
      _excluded158$j = ["children"],
      _excluded159$j = ["children"],
      _excluded160$j = ["children"],
      _excluded161$j = ["children"],
      _excluded162$j = ["children"],
      _excluded163$j = ["children"],
      _excluded164$j = ["children"],
      _excluded165$j = ["children"],
      _excluded166$j = ["children"],
      _excluded167$j = ["children"],
      _excluded168$j = ["children"],
      _excluded169$j = ["children"],
      _excluded170$j = ["children"],
      _excluded171$j = ["children"],
      _excluded172$j = ["children"],
      _excluded173$j = ["children"],
      _excluded174$j = ["children"],
      _excluded175$j = ["children"],
      _excluded176$j = ["children"],
      _excluded177$j = ["children"],
      _excluded178$j = ["children"],
      _excluded179$j = ["children"],
      _excluded180$j = ["children"],
      _excluded181$j = ["children"],
      _excluded182$j = ["children"],
      _excluded183$j = ["children"],
      _excluded184$j = ["children"],
      _excluded185$j = ["children"],
      _excluded186$j = ["children"],
      _excluded187$j = ["children"],
      _excluded188$j = ["children"],
      _excluded189$j = ["children"],
      _excluded190$j = ["children"],
      _excluded191$j = ["children"],
      _excluded192$j = ["children"],
      _excluded193$j = ["children"],
      _excluded194$j = ["children"],
      _excluded195$j = ["children"],
      _excluded196$j = ["children"],
      _excluded197$j = ["children"],
      _excluded198$j = ["children"],
      _excluded199$j = ["children"],
      _excluded200$j = ["children"],
      _excluded201$j = ["children"],
      _excluded202$j = ["children"],
      _excluded203$j = ["children"],
      _excluded204$j = ["children"],
      _excluded205$j = ["children"],
      _excluded206$j = ["children"],
      _excluded207$j = ["children"],
      _excluded208$j = ["children"],
      _excluded209$j = ["children"],
      _excluded210$j = ["children"],
      _excluded211$j = ["children"],
      _excluded212$j = ["children"],
      _excluded213$j = ["children"],
      _excluded214$j = ["children"],
      _excluded215$j = ["children"],
      _excluded216$j = ["children"],
      _excluded217$j = ["children"],
      _excluded218$j = ["children"],
      _excluded219$j = ["children"],
      _excluded220$j = ["children"],
      _excluded221$j = ["children"],
      _excluded222$j = ["children"],
      _excluded223$j = ["children"],
      _excluded224$j = ["children"],
      _excluded225$j = ["children"],
      _excluded226$j = ["children"],
      _excluded227$j = ["children"],
      _excluded228$j = ["children"],
      _excluded229$j = ["children"],
      _excluded230$j = ["children"],
      _excluded231$j = ["children"],
      _excluded232$j = ["children"],
      _excluded233$j = ["children"],
      _excluded234$j = ["children"],
      _excluded235$j = ["children"],
      _excluded236$j = ["children"],
      _excluded237$j = ["children"],
      _excluded238$j = ["children"],
      _excluded239$j = ["children"],
      _excluded240$j = ["children"],
      _excluded241$j = ["children"],
      _excluded242$j = ["children"],
      _excluded243$j = ["children"],
      _excluded244$j = ["children"],
      _excluded245$j = ["children"],
      _excluded246$j = ["children"],
      _excluded247$j = ["children"],
      _excluded248$j = ["children"],
      _excluded249$j = ["children"],
      _excluded250$j = ["children"];
  var didWarnAboutDeprecation$7 = {};
  var EarthAmericas20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericas20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$k || (_path$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"
    })), children);
  });
  var EarthAmericas16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericas16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$k || (_path2$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"
    })), children);
  });
  var EarthAmericasFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericasFilled32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$k || (_path3$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"
    })), children);
  });
  var EarthAmericasFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericasFilled24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$k || (_path4$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"
    })), children);
  });
  var EarthAmericasFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericasFilled20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$k || (_path5$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"
    })), children);
  });
  var EarthAmericasFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthAmericasFilled16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$k || (_path6$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"
    })), children);
  });
  var EarthEuropeAfrica32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfrica32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$k || (_path7$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthEuropeAfrica24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfrica24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$k || (_path8$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthEuropeAfrica20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfrica20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$k || (_path9$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthEuropeAfrica16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfrica16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$k || (_path10$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthEuropeAfricaFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfricaFilled32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$k || (_path11$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"
    })), children);
  });
  var EarthEuropeAfricaFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfricaFilled24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$k || (_path12$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"
    })), children);
  });
  var EarthEuropeAfricaFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfricaFilled20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$k || (_path13$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"
    })), children);
  });
  var EarthEuropeAfricaFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthEuropeAfricaFilled16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$k || (_path14$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"
    })), children);
  });
  var EarthFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthFilled32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$k || (_path15$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"
    })), children);
  });
  var EarthFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthFilled24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$k || (_path16$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"
    })), children);
  });
  var EarthFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthFilled20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$k || (_path17$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"
    })), children);
  });
  var EarthFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthFilled16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$k || (_path18$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"
    })), children);
  });
  var EarthSoutheastAsia32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsia32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$k || (_path19$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"
    })), _path20$k || (_path20$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthSoutheastAsia24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsia24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$k || (_path21$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"
    })), _path22$k || (_path22$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthSoutheastAsia20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsia20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$k || (_path23$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"
    })), _path24$k || (_path24$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthSoutheastAsia16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsia16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$k || (_path25$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"
    })), _path26$k || (_path26$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"
    })), children);
  });
  var EarthSoutheastAsiaFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsiaFilled32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$k || (_path27$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"
    })), _path28$k || (_path28$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"
    })), children);
  });
  var EarthSoutheastAsiaFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsiaFilled24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$k || (_path29$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"
    })), _path30$k || (_path30$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"
    })), children);
  });
  var EarthSoutheastAsiaFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsiaFilled20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$k || (_path31$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"
    })), _path32$k || (_path32$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"
    })), children);
  });
  var EarthSoutheastAsiaFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function EarthSoutheastAsiaFilled16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$k || (_path33$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"
    })), _path34$k || (_path34$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"
    })), children);
  });
  var Earthquake32 = /*#__PURE__*/React__default['default'].forwardRef(function Earthquake32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$k || (_path35$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM6,12.0615,15,5.05v7.3638l3.458,3.458-6.7344,4.8105L14.3818,26H6ZM26,26H16.6182l-2.3418-4.6826,7.2656-5.1895L17,11.5859V5.0518l9,7.02Z"
    })), children);
  });
  var Earthquake24 = /*#__PURE__*/React__default['default'].forwardRef(function Earthquake24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$k || (_path36$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM6,12.0615,15,5.05v7.3638l3.458,3.458-6.7344,4.8105L14.3818,26H6ZM26,26H16.6182l-2.3418-4.6826,7.2656-5.1895L17,11.5859V5.0518l9,7.02Z"
    })), children);
  });
  var Earthquake20 = /*#__PURE__*/React__default['default'].forwardRef(function Earthquake20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$k || (_path37$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM6,12.0615,15,5.05v7.3638l3.458,3.458-6.7344,4.8105L14.3818,26H6ZM26,26H16.6182l-2.3418-4.6826,7.2656-5.1895L17,11.5859V5.0518l9,7.02Z"
    })), children);
  });
  var Earthquake16 = /*#__PURE__*/React__default['default'].forwardRef(function Earthquake16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$k || (_path38$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM6,12.0615,15,5.05v7.3638l3.458,3.458-6.7344,4.8105L14.3818,26H6ZM26,26H16.6182l-2.3418-4.6826,7.2656-5.1895L17,11.5859V5.0518l9,7.02Z"
    })), children);
  });
  var EdgeCluster32 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeCluster32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$k || (_path39$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7a3 3 0 113-3A3.0033 3.0033 0 0116 7zm0-4a1 1 0 101 1A1.001 1.001 0 0016 3zM11 30a3 3 0 113-3A3.0033 3.0033 0 0111 30zm0-4a1 1 0 101 1A1.001 1.001 0 0011 26zM7 11a3 3 0 113-3A3.0033 3.0033 0 017 11zM7 7A1 1 0 108 8 1.001 1.001 0 007 7zM21 30a3 3 0 113-3A3.0033 3.0033 0 0121 30zm0-4a1 1 0 101 1A1.001 1.001 0 0021 26zM25 11a3 3 0 113-3A3.0033 3.0033 0 0125 11zm0-4a1 1 0 101 1A1.001 1.001 0 0025 7zM4 21a3 3 0 113-3A3.0033 3.0033 0 014 21zm0-4a1 1 0 101 1A1.001 1.001 0 004 17zM28 21a3 3 0 113-3A3.0033 3.0033 0 0128 21zm0-4a1 1 0 101 1A1.001 1.001 0 0028 17zM16 22a6 6 0 116-6A6.0069 6.0069 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), children);
  });
  var EdgeCluster24 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeCluster24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$k || (_path40$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7a3 3 0 113-3A3.0033 3.0033 0 0116 7zm0-4a1 1 0 101 1A1.001 1.001 0 0016 3zM11 30a3 3 0 113-3A3.0033 3.0033 0 0111 30zm0-4a1 1 0 101 1A1.001 1.001 0 0011 26zM7 11a3 3 0 113-3A3.0033 3.0033 0 017 11zM7 7A1 1 0 108 8 1.001 1.001 0 007 7zM21 30a3 3 0 113-3A3.0033 3.0033 0 0121 30zm0-4a1 1 0 101 1A1.001 1.001 0 0021 26zM25 11a3 3 0 113-3A3.0033 3.0033 0 0125 11zm0-4a1 1 0 101 1A1.001 1.001 0 0025 7zM4 21a3 3 0 113-3A3.0033 3.0033 0 014 21zm0-4a1 1 0 101 1A1.001 1.001 0 004 17zM28 21a3 3 0 113-3A3.0033 3.0033 0 0128 21zm0-4a1 1 0 101 1A1.001 1.001 0 0028 17zM16 22a6 6 0 116-6A6.0069 6.0069 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), children);
  });
  var EdgeCluster20 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeCluster20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$k || (_path41$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7a3 3 0 113-3A3.0033 3.0033 0 0116 7zm0-4a1 1 0 101 1A1.001 1.001 0 0016 3zM11 30a3 3 0 113-3A3.0033 3.0033 0 0111 30zm0-4a1 1 0 101 1A1.001 1.001 0 0011 26zM7 11a3 3 0 113-3A3.0033 3.0033 0 017 11zM7 7A1 1 0 108 8 1.001 1.001 0 007 7zM21 30a3 3 0 113-3A3.0033 3.0033 0 0121 30zm0-4a1 1 0 101 1A1.001 1.001 0 0021 26zM25 11a3 3 0 113-3A3.0033 3.0033 0 0125 11zm0-4a1 1 0 101 1A1.001 1.001 0 0025 7zM4 21a3 3 0 113-3A3.0033 3.0033 0 014 21zm0-4a1 1 0 101 1A1.001 1.001 0 004 17zM28 21a3 3 0 113-3A3.0033 3.0033 0 0128 21zm0-4a1 1 0 101 1A1.001 1.001 0 0028 17zM16 22a6 6 0 116-6A6.0069 6.0069 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), children);
  });
  var EdgeCluster16 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeCluster16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$k || (_path42$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7a3 3 0 113-3A3.0033 3.0033 0 0116 7zm0-4a1 1 0 101 1A1.001 1.001 0 0016 3zM11 30a3 3 0 113-3A3.0033 3.0033 0 0111 30zm0-4a1 1 0 101 1A1.001 1.001 0 0011 26zM7 11a3 3 0 113-3A3.0033 3.0033 0 017 11zM7 7A1 1 0 108 8 1.001 1.001 0 007 7zM21 30a3 3 0 113-3A3.0033 3.0033 0 0121 30zm0-4a1 1 0 101 1A1.001 1.001 0 0021 26zM25 11a3 3 0 113-3A3.0033 3.0033 0 0125 11zm0-4a1 1 0 101 1A1.001 1.001 0 0025 7zM4 21a3 3 0 113-3A3.0033 3.0033 0 014 21zm0-4a1 1 0 101 1A1.001 1.001 0 004 17zM28 21a3 3 0 113-3A3.0033 3.0033 0 0128 21zm0-4a1 1 0 101 1A1.001 1.001 0 0028 17zM16 22a6 6 0 116-6A6.0069 6.0069 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), children);
  });
  var EdgeDevice32 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeDevice32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$k || (_path43$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 21H23V23H9zM11 14a2 2 0 102 2A1.9806 1.9806 0 0011 14zM21 14a2 2 0 102 2A1.9806 1.9806 0 0021 14z"
    })), _path44$k || (_path44$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H18.4141l2.0722-2.0723A2.04,2.04,0,0,0,21,6a2,2,0,1,0-2-2,2.0412,2.0412,0,0,0,.0723.5137L15.5859,8H4a2.0025,2.0025,0,0,0-2,2V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM4,26V10H28V26Z"
    })), children);
  });
  var EdgeDevice24 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeDevice24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$k || (_path45$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 21H23V23H9zM11 14a2 2 0 102 2A1.9806 1.9806 0 0011 14zM21 14a2 2 0 102 2A1.9806 1.9806 0 0021 14z"
    })), _path46$k || (_path46$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H18.4141l2.0722-2.0723A2.04,2.04,0,0,0,21,6a2,2,0,1,0-2-2,2.0412,2.0412,0,0,0,.0723.5137L15.5859,8H4a2.0025,2.0025,0,0,0-2,2V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM4,26V10H28V26Z"
    })), children);
  });
  var EdgeDevice20 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeDevice20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$k || (_path47$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 21H23V23H9zM11 14a2 2 0 102 2A1.9806 1.9806 0 0011 14zM21 14a2 2 0 102 2A1.9806 1.9806 0 0021 14z"
    })), _path48$k || (_path48$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H18.4141l2.0722-2.0723A2.04,2.04,0,0,0,21,6a2,2,0,1,0-2-2,2.0412,2.0412,0,0,0,.0723.5137L15.5859,8H4a2.0025,2.0025,0,0,0-2,2V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM4,26V10H28V26Z"
    })), children);
  });
  var EdgeDevice16 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeDevice16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$k || (_path49$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 21H23V23H9zM11 14a2 2 0 102 2A1.9806 1.9806 0 0011 14zM21 14a2 2 0 102 2A1.9806 1.9806 0 0021 14z"
    })), _path50$k || (_path50$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H18.4141l2.0722-2.0723A2.04,2.04,0,0,0,21,6a2,2,0,1,0-2-2,2.0412,2.0412,0,0,0,.0723.5137L15.5859,8H4a2.0025,2.0025,0,0,0-2,2V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM4,26V10H28V26Z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$k || (_path51$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM16 26A10 10 0 0016 6h0z"
    })), _path52$k || (_path52$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$k || (_path53$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM16 26A10 10 0 0016 6h0z"
    })), _path54$k || (_path54$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$k || (_path55$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM16 26A10 10 0 0016 6h0z"
    })), _path56$k || (_path56$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$k || (_path57$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM16 26A10 10 0 0016 6h0z"
    })), _path58$k || (_path58$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0132 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0132(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$k || (_path59$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28L26 20 24 20 24 21 22 21 22 23 24 23 24 28 22 28 22 30 28 30 28 28 26 28zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path60$k || (_path60$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0124 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0124(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$k || (_path61$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28L26 20 24 20 24 21 22 21 22 23 24 23 24 28 22 28 22 30 28 30 28 28 26 28zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path62$k || (_path62$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0120 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0120(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$k || (_path63$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28L26 20 24 20 24 21 22 21 22 23 24 23 24 28 22 28 22 30 28 30 28 28 26 28zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path64$k || (_path64$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0116 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0116(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$k || (_path65$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28L26 20 24 20 24 21 22 21 22 23 24 23 24 28 22 28 22 30 28 30 28 28 26 28zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path66$k || (_path66$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0232 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0232(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$k || (_path67$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22V26a2.002 2.002 0 012-2h2V22H22V20h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H24v2h4zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path68$k || (_path68$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0224 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0224(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$k || (_path69$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22V26a2.002 2.002 0 012-2h2V22H22V20h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H24v2h4zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path70$k || (_path70$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0220 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0220(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$k || (_path71$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22V26a2.002 2.002 0 012-2h2V22H22V20h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H24v2h4zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path72$k || (_path72$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0216 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0216(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$k || (_path73$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22V26a2.002 2.002 0 012-2h2V22H22V20h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H24v2h4zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path74$k || (_path74$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0332 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0332(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$k || (_path75$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0026 20zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path76$k || (_path76$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0324 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0324(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$k || (_path77$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0026 20zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path78$k || (_path78$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0320 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0320(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$k || (_path79$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0026 20zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path80$k || (_path80$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var WatsonHealthEdgeEnhancement_0316 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEdgeEnhancement_0316(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$k || (_path81$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0026 20zM28 16h2A14 14 0 0016 2V4A12 12 0 0128 16z"
    })), _path82$k || (_path82$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16A10 10 0 0016 6V16zM16 28A11.96 11.96 0 015.416 21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207 13.1207 0 014.19 18l-1.9677.4131A13.9173 13.9173 0 002.7 20.2993l-.0251.0083A13.9615 13.9615 0 0016 30zM5.5913 10L3.86 9a14.14 14.14 0 00-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 015.5913 10zM11.8164 4.7646L11.1328 2.887A13.976 13.976 0 006.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0111.8164 4.7646z"
    })), children);
  });
  var EdgeNode32 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNode32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$k || (_path83$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6H26V10H22z"
    })), _circle$j || (_circle$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle2$j || (_circle2$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle3$j || (_circle3$j = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "21",
      r: "1"
    })), _circle4$i || (_circle4$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "17",
      r: "1"
    })), _path84$k || (_path84$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17V15H20V14a2.0023,2.0023,0,0,0-2-2H17V10H15v2H13V10H11v2H10a2.0023,2.0023,0,0,0-2,2v1H6v2H8v2H6v2H8v1a2.0023,2.0023,0,0,0,2,2h1v2h2V24h2v2h2V24h1a2.0023,2.0023,0,0,0,2-2V21h2V19H20V17Zm-4,5H10V14h8Z"
    })), _path85$k || (_path85$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var EdgeNode24 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNode24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$k || (_path86$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6H26V10H22z"
    })), _circle5$h || (_circle5$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle6$h || (_circle6$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle7$h || (_circle7$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "21",
      r: "1"
    })), _circle8$h || (_circle8$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "17",
      r: "1"
    })), _path87$k || (_path87$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17V15H20V14a2.0023,2.0023,0,0,0-2-2H17V10H15v2H13V10H11v2H10a2.0023,2.0023,0,0,0-2,2v1H6v2H8v2H6v2H8v1a2.0023,2.0023,0,0,0,2,2h1v2h2V24h2v2h2V24h1a2.0023,2.0023,0,0,0,2-2V21h2V19H20V17Zm-4,5H10V14h8Z"
    })), _path88$k || (_path88$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var EdgeNode20 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNode20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$k || (_path89$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6H26V10H22z"
    })), _circle9$h || (_circle9$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle10$h || (_circle10$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle11$g || (_circle11$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "21",
      r: "1"
    })), _circle12$g || (_circle12$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "17",
      r: "1"
    })), _path90$k || (_path90$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17V15H20V14a2.0023,2.0023,0,0,0-2-2H17V10H15v2H13V10H11v2H10a2.0023,2.0023,0,0,0-2,2v1H6v2H8v2H6v2H8v1a2.0023,2.0023,0,0,0,2,2h1v2h2V24h2v2h2V24h1a2.0023,2.0023,0,0,0,2-2V21h2V19H20V17Zm-4,5H10V14h8Z"
    })), _path91$k || (_path91$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var EdgeNode16 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNode16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$k || (_path92$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 6H26V10H22z"
    })), _circle13$g || (_circle13$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle14$g || (_circle14$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle15$g || (_circle15$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "21",
      r: "1"
    })), _circle16$g || (_circle16$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "17",
      r: "1"
    })), _path93$k || (_path93$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17V15H20V14a2.0023,2.0023,0,0,0-2-2H17V10H15v2H13V10H11v2H10a2.0023,2.0023,0,0,0-2,2v1H6v2H8v2H6v2H8v1a2.0023,2.0023,0,0,0,2,2h1v2h2V24h2v2h2V24h1a2.0023,2.0023,0,0,0,2-2V21h2V19H20V17Zm-4,5H10V14h8Z"
    })), _path94$k || (_path94$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var EdgeNodeAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNodeAlt32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$k || (_path95$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023a2.0429,2.0429,0,0,0,0-.8174l4.0039-2.4023A2.9909,2.9909,0,1,0,24,15a2.9345,2.9345,0,0,0,.0415.4092l-4.0039,2.4023a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,24,25a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,14Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,21Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,26Z"
    })), _circle17$f || (_circle17$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "8",
      r: "1"
    })), _circle18$f || (_circle18$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle19$f || (_circle19$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "24",
      r: "1"
    })), _path96$k || (_path96$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13V5a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,5V27a2.0023,2.0023,0,0,0,2,2H20V27H4V21h8V19H4V13ZM4,5H20v6H4Z"
    })), children);
  });
  var EdgeNodeAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNodeAlt24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$k || (_path97$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023a2.0429,2.0429,0,0,0,0-.8174l4.0039-2.4023A2.9909,2.9909,0,1,0,24,15a2.9345,2.9345,0,0,0,.0415.4092l-4.0039,2.4023a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,24,25a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,14Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,21Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,26Z"
    })), _circle20$f || (_circle20$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "8",
      r: "1"
    })), _circle21$f || (_circle21$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle22$f || (_circle22$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "24",
      r: "1"
    })), _path98$k || (_path98$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13V5a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,5V27a2.0023,2.0023,0,0,0,2,2H20V27H4V21h8V19H4V13ZM4,5H20v6H4Z"
    })), children);
  });
  var EdgeNodeAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNodeAlt20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$k || (_path99$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023a2.0429,2.0429,0,0,0,0-.8174l4.0039-2.4023A2.9909,2.9909,0,1,0,24,15a2.9345,2.9345,0,0,0,.0415.4092l-4.0039,2.4023a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,24,25a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,14Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,21Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,26Z"
    })), _circle23$e || (_circle23$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "8",
      r: "1"
    })), _circle24$e || (_circle24$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle25$d || (_circle25$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "24",
      r: "1"
    })), _path100$k || (_path100$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13V5a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,5V27a2.0023,2.0023,0,0,0,2,2H20V27H4V21h8V19H4V13ZM4,5H20v6H4Z"
    })), children);
  });
  var EdgeNodeAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeNodeAlt16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$k || (_path101$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023a2.0429,2.0429,0,0,0,0-.8174l4.0039-2.4023A2.9909,2.9909,0,1,0,24,15a2.9345,2.9345,0,0,0,.0415.4092l-4.0039,2.4023a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,24,25a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,14Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,21Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,26Z"
    })), _circle26$d || (_circle26$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "8",
      r: "1"
    })), _circle27$c || (_circle27$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle28$c || (_circle28$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "24",
      r: "1"
    })), _path102$k || (_path102$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13V5a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,5V27a2.0023,2.0023,0,0,0,2,2H20V27H4V21h8V19H4V13ZM4,5H20v6H4Z"
    })), children);
  });
  var EdgeService32 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeService32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$k || (_path103$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11H9V21H7zM11 11H13V21H11zM15 11H17V21H15zM19 11H21V21H19zM23 11H25V21H23z"
    })), _path104$k || (_path104$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H28a2.0023,2.0023,0,0,1,2,2V24A2.0023,2.0023,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var EdgeService24 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeService24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$k || (_path105$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11H9V21H7zM11 11H13V21H11zM15 11H17V21H15zM19 11H21V21H19zM23 11H25V21H23z"
    })), _path106$k || (_path106$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H28a2.0023,2.0023,0,0,1,2,2V24A2.0023,2.0023,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var EdgeService20 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeService20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$k || (_path107$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11H9V21H7zM11 11H13V21H11zM15 11H17V21H15zM19 11H21V21H19zM23 11H25V21H23z"
    })), _path108$k || (_path108$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H28a2.0023,2.0023,0,0,1,2,2V24A2.0023,2.0023,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var EdgeService16 = /*#__PURE__*/React__default['default'].forwardRef(function EdgeService16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$k || (_path109$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11H9V21H7zM11 11H13V21H11zM15 11H17V21H15zM19 11H21V21H19zM23 11H25V21H23z"
    })), _path110$k || (_path110$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H28a2.0023,2.0023,0,0,1,2,2V24A2.0023,2.0023,0,0,1,28,26ZM4,8V24H28V8Z"
    })), children);
  });
  var Edit32 = /*#__PURE__*/React__default['default'].forwardRef(function Edit32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$k || (_path111$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM25.4 9c.8-.8.8-2 0-2.8 0 0 0 0 0 0l-3.6-3.6c-.8-.8-2-.8-2.8 0 0 0 0 0 0 0l-15 15V24h6.4L25.4 9zM20.4 4L24 7.6l-3 3L17.4 7 20.4 4zM6 22v-3.6l10-10 3.6 3.6-10 10H6z"
    })), children);
  });
  var Edit24 = /*#__PURE__*/React__default['default'].forwardRef(function Edit24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$k || (_path112$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM25.4 9c.8-.8.8-2 0-2.8 0 0 0 0 0 0l-3.6-3.6c-.8-.8-2-.8-2.8 0 0 0 0 0 0 0l-15 15V24h6.4L25.4 9zM20.4 4L24 7.6l-3 3L17.4 7 20.4 4zM6 22v-3.6l10-10 3.6 3.6-10 10H6z"
    })), children);
  });
  var Edit20 = /*#__PURE__*/React__default['default'].forwardRef(function Edit20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$k || (_path113$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM25.4 9c.8-.8.8-2 0-2.8 0 0 0 0 0 0l-3.6-3.6c-.8-.8-2-.8-2.8 0 0 0 0 0 0 0l-15 15V24h6.4L25.4 9zM20.4 4L24 7.6l-3 3L17.4 7 20.4 4zM6 22v-3.6l10-10 3.6 3.6-10 10H6z"
    })), children);
  });
  var Edit16 = /*#__PURE__*/React__default['default'].forwardRef(function Edit16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$k || (_path114$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H30V28H2zM25.4 9c.8-.8.8-2 0-2.8 0 0 0 0 0 0l-3.6-3.6c-.8-.8-2-.8-2.8 0 0 0 0 0 0 0l-15 15V24h6.4L25.4 9zM20.4 4L24 7.6l-3 3L17.4 7 20.4 4zM6 22v-3.6l10-10 3.6 3.6-10 10H6z"
    })), children);
  });
  var EditOff32 = /*#__PURE__*/React__default['default'].forwardRef(function EditOff32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$k || (_path115$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.6L3.4 2 2 3.4l10.1 10.1L4 21.6V28h6.4l8.1-8.1L28.6 30 30 28.6zM9.6 26H6v-3.6l7.5-7.5 3.6 3.6L9.6 26zM29.4 6.2L29.4 6.2l-3.6-3.6c-.8-.8-2-.8-2.8 0l0 0 0 0-8 8 1.4 1.4L20 8.4l3.6 3.6L20 15.6l1.4 1.4 8-8C30.2 8.2 30.2 7 29.4 6.2L29.4 6.2zM25 10.6L21.4 7l3-3L28 7.6 25 10.6z"
    })), children);
  });
  var EditOff24 = /*#__PURE__*/React__default['default'].forwardRef(function EditOff24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$k || (_path116$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.6L3.4 2 2 3.4l10.1 10.1L4 21.6V28h6.4l8.1-8.1L28.6 30 30 28.6zM9.6 26H6v-3.6l7.5-7.5 3.6 3.6L9.6 26zM29.4 6.2L29.4 6.2l-3.6-3.6c-.8-.8-2-.8-2.8 0l0 0 0 0-8 8 1.4 1.4L20 8.4l3.6 3.6L20 15.6l1.4 1.4 8-8C30.2 8.2 30.2 7 29.4 6.2L29.4 6.2zM25 10.6L21.4 7l3-3L28 7.6 25 10.6z"
    })), children);
  });
  var EditOff20 = /*#__PURE__*/React__default['default'].forwardRef(function EditOff20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$k || (_path117$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.6L3.4 2 2 3.4l10.1 10.1L4 21.6V28h6.4l8.1-8.1L28.6 30 30 28.6zM9.6 26H6v-3.6l7.5-7.5 3.6 3.6L9.6 26zM29.4 6.2L29.4 6.2l-3.6-3.6c-.8-.8-2-.8-2.8 0l0 0 0 0-8 8 1.4 1.4L20 8.4l3.6 3.6L20 15.6l1.4 1.4 8-8C30.2 8.2 30.2 7 29.4 6.2L29.4 6.2zM25 10.6L21.4 7l3-3L28 7.6 25 10.6z"
    })), children);
  });
  var EditOff16 = /*#__PURE__*/React__default['default'].forwardRef(function EditOff16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$k || (_path118$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.6L3.4 2 2 3.4l10.1 10.1L4 21.6V28h6.4l8.1-8.1L28.6 30 30 28.6zM9.6 26H6v-3.6l7.5-7.5 3.6 3.6L9.6 26zM29.4 6.2L29.4 6.2l-3.6-3.6c-.8-.8-2-.8-2.8 0l0 0 0 0-8 8 1.4 1.4L20 8.4l3.6 3.6L20 15.6l1.4 1.4 8-8C30.2 8.2 30.2 7 29.4 6.2L29.4 6.2zM25 10.6L21.4 7l3-3L28 7.6 25 10.6z"
    })), children);
  });
  var WatsonHealthEditFilter32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEditFilter32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$k);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$7['WatsonHealthEditFilter32']) {
        didWarnAboutDeprecation$7['WatsonHealthEditFilter32'] = true;
        console.warn("The WatsonHealthEditFilter32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$k || (_path119$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path120$k || (_path120$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var WatsonHealthEditFilter24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEditFilter24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$k);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$7['WatsonHealthEditFilter24']) {
        didWarnAboutDeprecation$7['WatsonHealthEditFilter24'] = true;
        console.warn("The WatsonHealthEditFilter24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$k || (_path121$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path122$k || (_path122$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var WatsonHealthEditFilter20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEditFilter20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$k);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$7['WatsonHealthEditFilter20']) {
        didWarnAboutDeprecation$7['WatsonHealthEditFilter20'] = true;
        console.warn("The WatsonHealthEditFilter20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$k || (_path123$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path124$k || (_path124$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var WatsonHealthEditFilter16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthEditFilter16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$k);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$7['WatsonHealthEditFilter16']) {
        didWarnAboutDeprecation$7['WatsonHealthEditFilter16'] = true;
        console.warn("The WatsonHealthEditFilter16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$k || (_path125$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path126$k || (_path126$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var EdtLoop32 = /*#__PURE__*/React__default['default'].forwardRef(function EdtLoop32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$k || (_path127$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"
    })), children);
  });
  var EdtLoop24 = /*#__PURE__*/React__default['default'].forwardRef(function EdtLoop24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$k || (_path128$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"
    })), children);
  });
  var EdtLoop20 = /*#__PURE__*/React__default['default'].forwardRef(function EdtLoop20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$k || (_path129$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"
    })), children);
  });
  var EdtLoop16 = /*#__PURE__*/React__default['default'].forwardRef(function EdtLoop16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$k || (_path130$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"
    })), children);
  });
  var Education32 = /*#__PURE__*/React__default['default'].forwardRef(function Education32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$k || (_path131$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V27a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v3H6V27a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM5 6A1 1 0 004 7v9H6V7A1 1 0 005 6z"
    })), _path132$k || (_path132$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"
    })), children);
  });
  var Education24 = /*#__PURE__*/React__default['default'].forwardRef(function Education24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$k || (_path133$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V27a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v3H6V27a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM5 6A1 1 0 004 7v9H6V7A1 1 0 005 6z"
    })), _path134$k || (_path134$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"
    })), children);
  });
  var Education20 = /*#__PURE__*/React__default['default'].forwardRef(function Education20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$k || (_path135$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V27a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v3H6V27a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM5 6A1 1 0 004 7v9H6V7A1 1 0 005 6z"
    })), _path136$k || (_path136$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"
    })), children);
  });
  var Education16 = /*#__PURE__*/React__default['default'].forwardRef(function Education16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$k || (_path137$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V27a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v3H6V27a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM5 6A1 1 0 004 7v9H6V7A1 1 0 005 6z"
    })), _path138$k || (_path138$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"
    })), children);
  });
  var Email32 = /*#__PURE__*/React__default['default'].forwardRef(function Email32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$k || (_path139$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"
    })), children);
  });
  var Email24 = /*#__PURE__*/React__default['default'].forwardRef(function Email24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$k || (_path140$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"
    })), children);
  });
  var Email20 = /*#__PURE__*/React__default['default'].forwardRef(function Email20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$k || (_path141$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"
    })), children);
  });
  var Email16 = /*#__PURE__*/React__default['default'].forwardRef(function Email16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$k || (_path142$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"
    })), children);
  });
  var EmailNew32 = /*#__PURE__*/React__default['default'].forwardRef(function EmailNew32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$k || (_path143$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H4L3.9966,8.9062l11.4341,7.9161a1.0008,1.0008,0,0,0,1.1386,0L28,8.9087,28,18h2V8a2.0027,2.0027,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,8V24a2.0027,2.0027,0,0,0,2,2H19ZM25.7986,8,16,14.7837,6.2014,8Z"
    })), _circle29$c || (_circle29$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "24",
      r: "4"
    })), children);
  });
  var EmailNew24 = /*#__PURE__*/React__default['default'].forwardRef(function EmailNew24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$k || (_path144$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H4L3.9966,8.9062l11.4341,7.9161a1.0008,1.0008,0,0,0,1.1386,0L28,8.9087,28,18h2V8a2.0027,2.0027,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,8V24a2.0027,2.0027,0,0,0,2,2H19ZM25.7986,8,16,14.7837,6.2014,8Z"
    })), _circle30$c || (_circle30$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "24",
      r: "4"
    })), children);
  });
  var EmailNew20 = /*#__PURE__*/React__default['default'].forwardRef(function EmailNew20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$k || (_path145$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H4L3.9966,8.9062l11.4341,7.9161a1.0008,1.0008,0,0,0,1.1386,0L28,8.9087,28,18h2V8a2.0027,2.0027,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,8V24a2.0027,2.0027,0,0,0,2,2H19ZM25.7986,8,16,14.7837,6.2014,8Z"
    })), _circle31$c || (_circle31$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "24",
      r: "4"
    })), children);
  });
  var EmailNew16 = /*#__PURE__*/React__default['default'].forwardRef(function EmailNew16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$k || (_path146$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H4L3.9966,8.9062l11.4341,7.9161a1.0008,1.0008,0,0,0,1.1386,0L28,8.9087,28,18h2V8a2.0027,2.0027,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,8V24a2.0027,2.0027,0,0,0,2,2H19ZM25.7986,8,16,14.7837,6.2014,8Z"
    })), _circle32$c || (_circle32$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "24",
      r: "4"
    })), children);
  });
  var Encryption32 = /*#__PURE__*/React__default['default'].forwardRef(function Encryption32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$k || (_path147$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 21.2783V19a4 4 0 00-8 0v2.2783A1.9935 1.9935 0 0020 23v5a2.0025 2.0025 0 002 2h6a2.0025 2.0025 0 002-2V23A1.9935 1.9935 0 0029 21.2783zM25 17a2.0025 2.0025 0 012 2v2H23V19A2.0025 2.0025 0 0125 17zM22 28V23h6v5zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM2 8H4V16H2zM2 18H4V26H2zM14 18H16V26H14zM6 8H8V16H6zM18 8H20V14H18zM10 26H8a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0110 26zM8 20v4h2V20zM14 16H12a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0114 16zm-2-6v4h2V10zM10 6H8A2.0023 2.0023 0 016 4V2H8V4h2V2h2V4A2.0023 2.0023 0 0110 6z"
    })), children);
  });
  var Encryption24 = /*#__PURE__*/React__default['default'].forwardRef(function Encryption24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$k || (_path148$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 21.2783V19a4 4 0 00-8 0v2.2783A1.9935 1.9935 0 0020 23v5a2.0025 2.0025 0 002 2h6a2.0025 2.0025 0 002-2V23A1.9935 1.9935 0 0029 21.2783zM25 17a2.0025 2.0025 0 012 2v2H23V19A2.0025 2.0025 0 0125 17zM22 28V23h6v5zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM2 8H4V16H2zM2 18H4V26H2zM14 18H16V26H14zM6 8H8V16H6zM18 8H20V14H18zM10 26H8a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0110 26zM8 20v4h2V20zM14 16H12a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0114 16zm-2-6v4h2V10zM10 6H8A2.0023 2.0023 0 016 4V2H8V4h2V2h2V4A2.0023 2.0023 0 0110 6z"
    })), children);
  });
  var Encryption20 = /*#__PURE__*/React__default['default'].forwardRef(function Encryption20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$k || (_path149$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 21.2783V19a4 4 0 00-8 0v2.2783A1.9935 1.9935 0 0020 23v5a2.0025 2.0025 0 002 2h6a2.0025 2.0025 0 002-2V23A1.9935 1.9935 0 0029 21.2783zM25 17a2.0025 2.0025 0 012 2v2H23V19A2.0025 2.0025 0 0125 17zM22 28V23h6v5zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM2 8H4V16H2zM2 18H4V26H2zM14 18H16V26H14zM6 8H8V16H6zM18 8H20V14H18zM10 26H8a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0110 26zM8 20v4h2V20zM14 16H12a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0114 16zm-2-6v4h2V10zM10 6H8A2.0023 2.0023 0 016 4V2H8V4h2V2h2V4A2.0023 2.0023 0 0110 6z"
    })), children);
  });
  var Encryption16 = /*#__PURE__*/React__default['default'].forwardRef(function Encryption16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$k || (_path150$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 21.2783V19a4 4 0 00-8 0v2.2783A1.9935 1.9935 0 0020 23v5a2.0025 2.0025 0 002 2h6a2.0025 2.0025 0 002-2V23A1.9935 1.9935 0 0029 21.2783zM25 17a2.0025 2.0025 0 012 2v2H23V19A2.0025 2.0025 0 0125 17zM22 28V23h6v5zM2 2H4V6H2zM14 2H16V6H14zM18 2H20V6H18zM2 8H4V16H2zM2 18H4V26H2zM14 18H16V26H14zM6 8H8V16H6zM18 8H20V14H18zM10 26H8a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0110 26zM8 20v4h2V20zM14 16H12a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2h2a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0114 16zm-2-6v4h2V10zM10 6H8A2.0023 2.0023 0 016 4V2H8V4h2V2h2V4A2.0023 2.0023 0 0110 6z"
    })), children);
  });
  var EnergyRenewable32 = /*#__PURE__*/React__default['default'].forwardRef(function EnergyRenewable32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$k || (_path151$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H28V10H26v4H24V10H22v4H21a1,1,0,0,0-1,1v4a5.0079,5.0079,0,0,0,4,4.8989V27a1.0008,1.0008,0,0,1-1,1H5a1,1,0,0,1,0-2h5a3,3,0,0,0,0-6H5a1,1,0,0,1,0-2h5a3.0033,3.0033,0,0,0,3-3V11h1a4.0045,4.0045,0,0,0,4-4V4H15a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,7,2H4V5a6.0066,6.0066,0,0,0,6,6h1v4a1.0008,1.0008,0,0,1-1,1H5a3,3,0,0,0,0,6h5a1,1,0,0,1,0,2H5a3,3,0,0,0,0,6H23a3.0033,3.0033,0,0,0,3-3V23.8989A5.0079,5.0079,0,0,0,30,19V15A1,1,0,0,0,29,14ZM13,8a2.002,2.002,0,0,1,2-2h1V7a2.002,2.002,0,0,1-2,2H13ZM10,9A4.0045,4.0045,0,0,1,6,5V4H7a4.0045,4.0045,0,0,1,4,4V9ZM28,19a3,3,0,0,1-6,0V16h6Z"
    })), children);
  });
  var EnergyRenewable24 = /*#__PURE__*/React__default['default'].forwardRef(function EnergyRenewable24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$k || (_path152$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H28V10H26v4H24V10H22v4H21a1,1,0,0,0-1,1v4a5.0079,5.0079,0,0,0,4,4.8989V27a1.0008,1.0008,0,0,1-1,1H5a1,1,0,0,1,0-2h5a3,3,0,0,0,0-6H5a1,1,0,0,1,0-2h5a3.0033,3.0033,0,0,0,3-3V11h1a4.0045,4.0045,0,0,0,4-4V4H15a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,7,2H4V5a6.0066,6.0066,0,0,0,6,6h1v4a1.0008,1.0008,0,0,1-1,1H5a3,3,0,0,0,0,6h5a1,1,0,0,1,0,2H5a3,3,0,0,0,0,6H23a3.0033,3.0033,0,0,0,3-3V23.8989A5.0079,5.0079,0,0,0,30,19V15A1,1,0,0,0,29,14ZM13,8a2.002,2.002,0,0,1,2-2h1V7a2.002,2.002,0,0,1-2,2H13ZM10,9A4.0045,4.0045,0,0,1,6,5V4H7a4.0045,4.0045,0,0,1,4,4V9ZM28,19a3,3,0,0,1-6,0V16h6Z"
    })), children);
  });
  var EnergyRenewable20 = /*#__PURE__*/React__default['default'].forwardRef(function EnergyRenewable20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$k || (_path153$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H28V10H26v4H24V10H22v4H21a1,1,0,0,0-1,1v4a5.0079,5.0079,0,0,0,4,4.8989V27a1.0008,1.0008,0,0,1-1,1H5a1,1,0,0,1,0-2h5a3,3,0,0,0,0-6H5a1,1,0,0,1,0-2h5a3.0033,3.0033,0,0,0,3-3V11h1a4.0045,4.0045,0,0,0,4-4V4H15a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,7,2H4V5a6.0066,6.0066,0,0,0,6,6h1v4a1.0008,1.0008,0,0,1-1,1H5a3,3,0,0,0,0,6h5a1,1,0,0,1,0,2H5a3,3,0,0,0,0,6H23a3.0033,3.0033,0,0,0,3-3V23.8989A5.0079,5.0079,0,0,0,30,19V15A1,1,0,0,0,29,14ZM13,8a2.002,2.002,0,0,1,2-2h1V7a2.002,2.002,0,0,1-2,2H13ZM10,9A4.0045,4.0045,0,0,1,6,5V4H7a4.0045,4.0045,0,0,1,4,4V9ZM28,19a3,3,0,0,1-6,0V16h6Z"
    })), children);
  });
  var EnergyRenewable16 = /*#__PURE__*/React__default['default'].forwardRef(function EnergyRenewable16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$k || (_path154$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14H28V10H26v4H24V10H22v4H21a1,1,0,0,0-1,1v4a5.0079,5.0079,0,0,0,4,4.8989V27a1.0008,1.0008,0,0,1-1,1H5a1,1,0,0,1,0-2h5a3,3,0,0,0,0-6H5a1,1,0,0,1,0-2h5a3.0033,3.0033,0,0,0,3-3V11h1a4.0045,4.0045,0,0,0,4-4V4H15a3.979,3.979,0,0,0-2.7468,1.1064A6.0041,6.0041,0,0,0,7,2H4V5a6.0066,6.0066,0,0,0,6,6h1v4a1.0008,1.0008,0,0,1-1,1H5a3,3,0,0,0,0,6h5a1,1,0,0,1,0,2H5a3,3,0,0,0,0,6H23a3.0033,3.0033,0,0,0,3-3V23.8989A5.0079,5.0079,0,0,0,30,19V15A1,1,0,0,0,29,14ZM13,8a2.002,2.002,0,0,1,2-2h1V7a2.002,2.002,0,0,1-2,2H13ZM10,9A4.0045,4.0045,0,0,1,6,5V4H7a4.0045,4.0045,0,0,1,4,4V9ZM28,19a3,3,0,0,1-6,0V16h6Z"
    })), children);
  });
  var Enterprise32 = /*#__PURE__*/React__default['default'].forwardRef(function Enterprise32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$k || (_path155$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"
    })), _path156$k || (_path156$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"
    })), children);
  });
  var Enterprise24 = /*#__PURE__*/React__default['default'].forwardRef(function Enterprise24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$k || (_path157$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"
    })), _path158$k || (_path158$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"
    })), children);
  });
  var Enterprise20 = /*#__PURE__*/React__default['default'].forwardRef(function Enterprise20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$k || (_path159$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"
    })), _path160$k || (_path160$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"
    })), children);
  });
  var Enterprise16 = /*#__PURE__*/React__default['default'].forwardRef(function Enterprise16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$k || (_path161$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"
    })), _path162$k || (_path162$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"
    })), children);
  });
  var Equalizer32 = /*#__PURE__*/React__default['default'].forwardRef(function Equalizer32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$k || (_path163$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM2 24H10V26H2zM12 28H20V30H12zM12 24H20V26H12zM2 20H10V22H2zM12 20H20V22H12zM2 16H10V18H2zM12 16H20V18H12zM12 12H20V14H12zM12 8H20V10H12zM12 4H20V6H12zM22 28H30V30H22zM22 24H30V26H22z"
    })), children);
  });
  var Equalizer24 = /*#__PURE__*/React__default['default'].forwardRef(function Equalizer24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$k || (_path164$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM2 24H10V26H2zM12 28H20V30H12zM12 24H20V26H12zM2 20H10V22H2zM12 20H20V22H12zM2 16H10V18H2zM12 16H20V18H12zM12 12H20V14H12zM12 8H20V10H12zM12 4H20V6H12zM22 28H30V30H22zM22 24H30V26H22z"
    })), children);
  });
  var Equalizer20 = /*#__PURE__*/React__default['default'].forwardRef(function Equalizer20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$k || (_path165$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM2 24H10V26H2zM12 28H20V30H12zM12 24H20V26H12zM2 20H10V22H2zM12 20H20V22H12zM2 16H10V18H2zM12 16H20V18H12zM12 12H20V14H12zM12 8H20V10H12zM12 4H20V6H12zM22 28H30V30H22zM22 24H30V26H22z"
    })), children);
  });
  var Equalizer16 = /*#__PURE__*/React__default['default'].forwardRef(function Equalizer16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$k || (_path166$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H10V30H2zM2 24H10V26H2zM12 28H20V30H12zM12 24H20V26H12zM2 20H10V22H2zM12 20H20V22H12zM2 16H10V18H2zM12 16H20V18H12zM12 12H20V14H12zM12 8H20V10H12zM12 4H20V6H12zM22 28H30V30H22zM22 24H30V26H22z"
    })), children);
  });
  var Erase32 = /*#__PURE__*/React__default['default'].forwardRef(function Erase32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$k || (_path167$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 00-2.83 0l-14 14a2 2 0 000 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0027.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"
    })), children);
  });
  var Erase24 = /*#__PURE__*/React__default['default'].forwardRef(function Erase24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$k || (_path168$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 00-2.83 0l-14 14a2 2 0 000 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0027.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"
    })), children);
  });
  var Erase20 = /*#__PURE__*/React__default['default'].forwardRef(function Erase20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$k || (_path169$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 00-2.83 0l-14 14a2 2 0 000 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0027.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"
    })), children);
  });
  var Erase16 = /*#__PURE__*/React__default['default'].forwardRef(function Erase16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$k || (_path170$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 00-2.83 0l-14 14a2 2 0 000 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0027.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"
    })), children);
  });
  var WatsonHealthErase_3D32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthErase_3D32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$k || (_path171$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 00-2.8291 0L5.6208 22.624a2.0024 2.0024 0 000 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0030.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0111 12zm-1-2h1a1.0009 1.0009 0 001-1V5a1.0009 1.0009 0 00-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 004 2z"
    })), children);
  });
  var WatsonHealthErase_3D24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthErase_3D24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$k || (_path172$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 00-2.8291 0L5.6208 22.624a2.0024 2.0024 0 000 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0030.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0111 12zm-1-2h1a1.0009 1.0009 0 001-1V5a1.0009 1.0009 0 00-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 004 2z"
    })), children);
  });
  var WatsonHealthErase_3D20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthErase_3D20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$k || (_path173$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 00-2.8291 0L5.6208 22.624a2.0024 2.0024 0 000 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0030.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0111 12zm-1-2h1a1.0009 1.0009 0 001-1V5a1.0009 1.0009 0 00-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 004 2z"
    })), children);
  });
  var WatsonHealthErase_3D16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthErase_3D16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$k);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$k || (_path174$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 00-2.8291 0L5.6208 22.624a2.0024 2.0024 0 000 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0030.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0111 12zm-1-2h1a1.0009 1.0009 0 001-1V5a1.0009 1.0009 0 00-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 004 2z"
    })), children);
  });
  var Error32 = /*#__PURE__*/React__default['default'].forwardRef(function Error32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$k || (_path175$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"
    })), children);
  });
  var Error24 = /*#__PURE__*/React__default['default'].forwardRef(function Error24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$k || (_path176$k = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"
    })), children);
  });
  var Error20 = /*#__PURE__*/React__default['default'].forwardRef(function Error20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$j || (_path177$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"
    })), children);
  });
  var Error16 = /*#__PURE__*/React__default['default'].forwardRef(function Error16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$j || (_path178$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"
    })), children);
  });
  var ErrorFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorFilled32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$j || (_path179$j = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.9 7.2H17.1V24.799H14.9z",
      "data-icon-path": "inner-path",
      transform: "rotate(-45 16 16)"
    })), _path180$j || (_path180$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.914,13.914,0,0,0,2,16,13.914,13.914,0,0,0,16,30,13.914,13.914,0,0,0,30,16,13.914,13.914,0,0,0,16,2Zm5.4449,21L9,10.5557,10.5557,9,23,21.4448Z"
    })), children);
  });
  var ErrorFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorFilled24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$j || (_path181$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,1C5.9,1,1,5.9,1,12s4.9,11,11,11s11-4.9,11-11S18.1,1,12,1z M16.3,17.5L6.5,7.7l1.2-1.2l9.8,9.8L16.3,17.5z"
    })), _path182$j || (_path182$j = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16.3,17.5L6.5,7.7l1.2-1.2l9.8,9.8L16.3,17.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var ErrorFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorFilled20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$j || (_path183$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,1c-5,0-9,4-9,9s4,9,9,9s9-4,9-9S15,1,10,1z M13.5,14.5l-8-8l1-1l8,8L13.5,14.5z"
    })), _path184$j || (_path184$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5,14.5l-8-8l1-1l8,8L13.5,14.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var ErrorFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorFilled16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$j || (_path185$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M10.7,11.5L4.5,5.3l0.8-0.8l6.2,6.2L10.7,11.5z"
    })), _path186$j || (_path186$j = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M10.7,11.5L4.5,5.3l0.8-0.8l6.2,6.2L10.7,11.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var ErrorOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorOutline32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$j || (_path187$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.9 7.2H17.1V24.799H14.9z",
      transform: "rotate(-45 16 16)"
    })), _path188$j || (_path188$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9138,13.9138,0,0,0,2,16,13.9138,13.9138,0,0,0,16,30,13.9138,13.9138,0,0,0,30,16,13.9138,13.9138,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12.0353,12.0353,0,0,1,16,28Z"
    })), children);
  });
  var ErrorOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorOutline24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$j || (_path189$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.9 7.2H17.1V24.799H14.9z",
      transform: "rotate(-45 16 16)"
    })), _path190$j || (_path190$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9138,13.9138,0,0,0,2,16,13.9138,13.9138,0,0,0,16,30,13.9138,13.9138,0,0,0,30,16,13.9138,13.9138,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12.0353,12.0353,0,0,1,16,28Z"
    })), children);
  });
  var ErrorOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorOutline20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$j || (_path191$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.9 7.2H17.1V24.799H14.9z",
      transform: "rotate(-45 16 16)"
    })), _path192$j || (_path192$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9138,13.9138,0,0,0,2,16,13.9138,13.9138,0,0,0,16,30,13.9138,13.9138,0,0,0,30,16,13.9138,13.9138,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12.0353,12.0353,0,0,1,16,28Z"
    })), children);
  });
  var ErrorOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function ErrorOutline16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$j || (_path193$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"
    })), _path194$j || (_path194$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.4 3.6H8.5V12.4H7.4z",
      transform: "rotate(-45.001 8 8)"
    })), children);
  });
  var Event32 = /*#__PURE__*/React__default['default'].forwardRef(function Event32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$j || (_path195$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), _path196$j || (_path196$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"
    })), children);
  });
  var Event24 = /*#__PURE__*/React__default['default'].forwardRef(function Event24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$j || (_path197$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), _path198$j || (_path198$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"
    })), children);
  });
  var Event20 = /*#__PURE__*/React__default['default'].forwardRef(function Event20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$j || (_path199$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), _path200$j || (_path200$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"
    })), children);
  });
  var Event16 = /*#__PURE__*/React__default['default'].forwardRef(function Event16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$j || (_path201$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), _path202$j || (_path202$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"
    })), children);
  });
  var EventSchedule32 = /*#__PURE__*/React__default['default'].forwardRef(function EventSchedule32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$j || (_path203$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"
    })), _path204$j || (_path204$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"
    })), _path205$j || (_path205$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var EventSchedule24 = /*#__PURE__*/React__default['default'].forwardRef(function EventSchedule24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$j || (_path206$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"
    })), _path207$j || (_path207$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"
    })), _path208$j || (_path208$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var EventSchedule20 = /*#__PURE__*/React__default['default'].forwardRef(function EventSchedule20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$j || (_path209$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"
    })), _path210$j || (_path210$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"
    })), _path211$j || (_path211$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var EventSchedule16 = /*#__PURE__*/React__default['default'].forwardRef(function EventSchedule16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$j || (_path212$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"
    })), _path213$j || (_path213$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"
    })), _path214$j || (_path214$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var Events32 = /*#__PURE__*/React__default['default'].forwardRef(function Events32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$j || (_path215$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24v2h2a3.0033 3.0033 0 013 3v4h2V19A5.0058 5.0058 0 0026 14zM24 4a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 2zM23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11zM8 14H6a5.0059 5.0059 0 00-5 5v4H3V19a3.0033 3.0033 0 013-3H8zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var Events24 = /*#__PURE__*/React__default['default'].forwardRef(function Events24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$j || (_path216$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24v2h2a3.0033 3.0033 0 013 3v4h2V19A5.0058 5.0058 0 0026 14zM24 4a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 2zM23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11zM8 14H6a5.0059 5.0059 0 00-5 5v4H3V19a3.0033 3.0033 0 013-3H8zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var Events20 = /*#__PURE__*/React__default['default'].forwardRef(function Events20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$j || (_path217$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24v2h2a3.0033 3.0033 0 013 3v4h2V19A5.0058 5.0058 0 0026 14zM24 4a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 2zM23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11zM8 14H6a5.0059 5.0059 0 00-5 5v4H3V19a3.0033 3.0033 0 013-3H8zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var Events16 = /*#__PURE__*/React__default['default'].forwardRef(function Events16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$j || (_path218$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24v2h2a3.0033 3.0033 0 013 3v4h2V19A5.0058 5.0058 0 0026 14zM24 4a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 2zM23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11zM8 14H6a5.0059 5.0059 0 00-5 5v4H3V19a3.0033 3.0033 0 013-3H8zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var EventsAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function EventsAlt32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$j || (_path219$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 31h2V29a1.0006 1.0006 0 011-1h6a1.0006 1.0006 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 25a4 4 0 114-4A4.0039 4.0039 0 0124 25zm0-6a2 2 0 102 2A2.0027 2.0027 0 0024 19zM2 31H4V29a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 25a4 4 0 114-4A4.0042 4.0042 0 018 25zm0-6a2 2 0 102 2A2.0023 2.0023 0 008 19zM18 16h2V14a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 10a4 4 0 114-4A4.0042 4.0042 0 0124 10zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 4zM2 16H4V14a1.0013 1.0013 0 011-1h6a1.0013 1.0013 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4z"
    })), children);
  });
  var EventsAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function EventsAlt24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$j || (_path220$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 31h2V29a1.0006 1.0006 0 011-1h6a1.0006 1.0006 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 25a4 4 0 114-4A4.0039 4.0039 0 0124 25zm0-6a2 2 0 102 2A2.0027 2.0027 0 0024 19zM2 31H4V29a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 25a4 4 0 114-4A4.0042 4.0042 0 018 25zm0-6a2 2 0 102 2A2.0023 2.0023 0 008 19zM18 16h2V14a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 10a4 4 0 114-4A4.0042 4.0042 0 0124 10zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 4zM2 16H4V14a1.0013 1.0013 0 011-1h6a1.0013 1.0013 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4z"
    })), children);
  });
  var EventsAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function EventsAlt20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$j || (_path221$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 31h2V29a1.0006 1.0006 0 011-1h6a1.0006 1.0006 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 25a4 4 0 114-4A4.0039 4.0039 0 0124 25zm0-6a2 2 0 102 2A2.0027 2.0027 0 0024 19zM2 31H4V29a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 25a4 4 0 114-4A4.0042 4.0042 0 018 25zm0-6a2 2 0 102 2A2.0023 2.0023 0 008 19zM18 16h2V14a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 10a4 4 0 114-4A4.0042 4.0042 0 0124 10zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 4zM2 16H4V14a1.0013 1.0013 0 011-1h6a1.0013 1.0013 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4z"
    })), children);
  });
  var EventsAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function EventsAlt16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$j || (_path222$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 31h2V29a1.0006 1.0006 0 011-1h6a1.0006 1.0006 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 25a4 4 0 114-4A4.0039 4.0039 0 0124 25zm0-6a2 2 0 102 2A2.0027 2.0027 0 0024 19zM2 31H4V29a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V29a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 25a4 4 0 114-4A4.0042 4.0042 0 018 25zm0-6a2 2 0 102 2A2.0023 2.0023 0 008 19zM18 16h2V14a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 10a4 4 0 114-4A4.0042 4.0042 0 0124 10zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 4zM2 16H4V14a1.0013 1.0013 0 011-1h6a1.0013 1.0013 0 011 1v2h2V14a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4z"
    })), children);
  });
  var ExamMode32 = /*#__PURE__*/React__default['default'].forwardRef(function ExamMode32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$j || (_path223$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 002 2H25a2 2 0 002-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0127 7zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var ExamMode24 = /*#__PURE__*/React__default['default'].forwardRef(function ExamMode24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$j || (_path224$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 002 2H25a2 2 0 002-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0127 7zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var ExamMode20 = /*#__PURE__*/React__default['default'].forwardRef(function ExamMode20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$j || (_path225$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 002 2H25a2 2 0 002-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0127 7zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var ExamMode16 = /*#__PURE__*/React__default['default'].forwardRef(function ExamMode16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$j || (_path226$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 002 2H25a2 2 0 002-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0127 7zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var Exit32 = /*#__PURE__*/React__default['default'].forwardRef(function Exit32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$j || (_path227$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"
    })), children);
  });
  var Exit24 = /*#__PURE__*/React__default['default'].forwardRef(function Exit24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$j || (_path228$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"
    })), children);
  });
  var Exit20 = /*#__PURE__*/React__default['default'].forwardRef(function Exit20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$j || (_path229$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"
    })), children);
  });
  var Exit16 = /*#__PURE__*/React__default['default'].forwardRef(function Exit16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$j || (_path230$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"
    })), children);
  });
  var ExpandAll32 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandAll32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$j || (_path231$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"
    })), children);
  });
  var ExpandAll24 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandAll24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$j || (_path232$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"
    })), children);
  });
  var ExpandAll20 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandAll20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$j || (_path233$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"
    })), children);
  });
  var ExpandAll16 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandAll16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$j || (_path234$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"
    })), children);
  });
  var ExpandCategories32 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandCategories32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$j || (_path235$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"
    })), children);
  });
  var ExpandCategories24 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandCategories24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$j || (_path236$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"
    })), children);
  });
  var ExpandCategories20 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandCategories20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$j || (_path237$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"
    })), children);
  });
  var ExpandCategories16 = /*#__PURE__*/React__default['default'].forwardRef(function ExpandCategories16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$j || (_path238$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"
    })), children);
  });
  var Explore32 = /*#__PURE__*/React__default['default'].forwardRef(function Explore32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$j || (_path239$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,9.2931a.9992.9992,0,0,0-1.0234-.2417l-9,3a1.001,1.001,0,0,0-.6323.6323l-3,9a1,1,0,0,0,1.2651,1.2651l9-3a1.0013,1.0013,0,0,0,.6323-.6324l3-9A1,1,0,0,0,22.707,9.2931ZM11.5811,20.419l2.2094-6.6284L18.21,18.21Z"
    })), _path240$j || (_path240$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Explore24 = /*#__PURE__*/React__default['default'].forwardRef(function Explore24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$j || (_path241$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,9.2931a.9992.9992,0,0,0-1.0234-.2417l-9,3a1.001,1.001,0,0,0-.6323.6323l-3,9a1,1,0,0,0,1.2651,1.2651l9-3a1.0013,1.0013,0,0,0,.6323-.6324l3-9A1,1,0,0,0,22.707,9.2931ZM11.5811,20.419l2.2094-6.6284L18.21,18.21Z"
    })), _path242$j || (_path242$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Explore20 = /*#__PURE__*/React__default['default'].forwardRef(function Explore20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$j || (_path243$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,9.2931a.9992.9992,0,0,0-1.0234-.2417l-9,3a1.001,1.001,0,0,0-.6323.6323l-3,9a1,1,0,0,0,1.2651,1.2651l9-3a1.0013,1.0013,0,0,0,.6323-.6324l3-9A1,1,0,0,0,22.707,9.2931ZM11.5811,20.419l2.2094-6.6284L18.21,18.21Z"
    })), _path244$j || (_path244$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Explore16 = /*#__PURE__*/React__default['default'].forwardRef(function Explore16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$j || (_path245$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,9.2931a.9992.9992,0,0,0-1.0234-.2417l-9,3a1.001,1.001,0,0,0-.6323.6323l-3,9a1,1,0,0,0,1.2651,1.2651l9-3a1.0013,1.0013,0,0,0,.6323-.6324l3-9A1,1,0,0,0,22.707,9.2931ZM11.5811,20.419l2.2094-6.6284L18.21,18.21Z"
    })), _path246$j || (_path246$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Export32 = /*#__PURE__*/React__default['default'].forwardRef(function Export32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$j || (_path247$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24v4H6V24H4v4l.0076-.0049A1.9977 1.9977 0 006 30H26a2 2 0 002-2h0V24zM6 12L7.411 13.405 15 5.825 15 24 17 24 17 5.825 24.591 13.405 26 12 16 2 6 12z"
    })), children);
  });
  var Export24 = /*#__PURE__*/React__default['default'].forwardRef(function Export24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$j || (_path248$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24v4H6V24H4v4l.0076-.0049A1.9977 1.9977 0 006 30H26a2 2 0 002-2h0V24zM6 12L7.411 13.405 15 5.825 15 24 17 24 17 5.825 24.591 13.405 26 12 16 2 6 12z"
    })), children);
  });
  var Export20 = /*#__PURE__*/React__default['default'].forwardRef(function Export20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$j || (_path249$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24v4H6V24H4v4l.0076-.0049A1.9977 1.9977 0 006 30H26a2 2 0 002-2h0V24zM6 12L7.411 13.405 15 5.825 15 24 17 24 17 5.825 24.591 13.405 26 12 16 2 6 12z"
    })), children);
  });
  var Export16 = /*#__PURE__*/React__default['default'].forwardRef(function Export16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$j || (_path250$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 12v2H3v-2H2v2l0 0c0 .6.4 1 1 1h10c.6 0 1-.4 1-1l0 0v-2H13zM3 6L3.7 6.7 7.5 2.9 7.5 12 8.5 12 8.5 2.9 12.3 6.7 13 6 8 1z"
    })), children);
  });
  var Eyedropper32 = /*#__PURE__*/React__default['default'].forwardRef(function Eyedropper32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$j || (_path251$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 00-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 008 18v1.59l-2.71 2.7a1 1 0 000 1.41h0l3 3a1 1 0 001.41 0h0L12.41 24H14a1 1 0 00.71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 000-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"
    })), children);
  });
  var Eyedropper24 = /*#__PURE__*/React__default['default'].forwardRef(function Eyedropper24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$j || (_path252$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 00-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 008 18v1.59l-2.71 2.7a1 1 0 000 1.41h0l3 3a1 1 0 001.41 0h0L12.41 24H14a1 1 0 00.71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 000-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"
    })), children);
  });
  var Eyedropper20 = /*#__PURE__*/React__default['default'].forwardRef(function Eyedropper20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$j || (_path253$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 00-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 008 18v1.59l-2.71 2.7a1 1 0 000 1.41h0l3 3a1 1 0 001.41 0h0L12.41 24H14a1 1 0 00.71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 000-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"
    })), children);
  });
  var Eyedropper16 = /*#__PURE__*/React__default['default'].forwardRef(function Eyedropper16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$j || (_path254$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 00-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 008 18v1.59l-2.71 2.7a1 1 0 000 1.41h0l3 3a1 1 0 001.41 0h0L12.41 24H14a1 1 0 00.71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 000-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"
    })), children);
  });
  var FaceActivated32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivated32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$j || (_path255$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path256$j || (_path256$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), children);
  });
  var FaceActivated24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivated24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$j || (_path257$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path258$j || (_path258$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), children);
  });
  var FaceActivated20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivated20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$j || (_path259$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path260$j || (_path260$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), children);
  });
  var FaceActivated16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivated16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$j || (_path261$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path262$j || (_path262$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), children);
  });
  var FaceActivatedAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedAdd32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$j || (_path263$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), _path264$j || (_path264$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"
    })), children);
  });
  var FaceActivatedAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedAdd24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$j || (_path265$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), _path266$j || (_path266$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"
    })), children);
  });
  var FaceActivatedAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedAdd20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$j || (_path267$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), _path268$j || (_path268$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"
    })), children);
  });
  var FaceActivatedAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedAdd16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$j || (_path269$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM9 20a8.13 8.13 0 0014 0z"
    })), _path270$j || (_path270$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"
    })), children);
  });
  var FaceActivatedFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedFilled32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$j || (_path271$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceActivatedFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedFilled24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$j || (_path272$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceActivatedFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedFilled20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$j || (_path273$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceActivatedFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceActivatedFilled16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$j || (_path274$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceAdd32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$j || (_path275$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a6 6 0 01-5.14-2.92l-1.71 1a8 8 0 0013.7 0l-1.71-1A6 6 0 0116 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), _path276$j || (_path276$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"
    })), children);
  });
  var FaceAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceAdd24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$j || (_path277$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a6 6 0 01-5.14-2.92l-1.71 1a8 8 0 0013.7 0l-1.71-1A6 6 0 0116 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), _path278$j || (_path278$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"
    })), children);
  });
  var FaceAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceAdd20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$j || (_path279$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a6 6 0 01-5.14-2.92l-1.71 1a8 8 0 0013.7 0l-1.71-1A6 6 0 0116 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), _path280$j || (_path280$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"
    })), children);
  });
  var FaceAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceAdd16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$j || (_path281$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a6 6 0 01-5.14-2.92l-1.71 1a8 8 0 0013.7 0l-1.71-1A6 6 0 0116 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), _path282$j || (_path282$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"
    })), children);
  });
  var FaceCool32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceCool32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$j || (_path283$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"
    })), _path284$j || (_path284$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"
    })), children);
  });
  var FaceCool24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceCool24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$j || (_path285$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"
    })), _path286$j || (_path286$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"
    })), children);
  });
  var FaceCool20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceCool20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$j || (_path287$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"
    })), _path288$j || (_path288$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"
    })), children);
  });
  var FaceCool16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceCool16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$j || (_path289$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"
    })), _path290$j || (_path290$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"
    })), children);
  });
  var FaceDissatisfied32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfied32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$j || (_path291$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path292$j || (_path292$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM16 19a8 8 0 00-6.85 3.89l1.71 1a6 6 0 0110.28 0l1.71-1A8 8 0 0016 19z"
    })), children);
  });
  var FaceDissatisfied24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfied24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$j || (_path293$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path294$j || (_path294$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM16 19a8 8 0 00-6.85 3.89l1.71 1a6 6 0 0110.28 0l1.71-1A8 8 0 0016 19z"
    })), children);
  });
  var FaceDissatisfied20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfied20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$j || (_path295$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path296$j || (_path296$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM16 19a8 8 0 00-6.85 3.89l1.71 1a6 6 0 0110.28 0l1.71-1A8 8 0 0016 19z"
    })), children);
  });
  var FaceDissatisfied16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfied16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$j || (_path297$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path298$j || (_path298$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM16 19a8 8 0 00-6.85 3.89l1.71 1a6 6 0 0110.28 0l1.71-1A8 8 0 0016 19z"
    })), children);
  });
  var FaceDissatisfiedFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfiedFilled32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$j || (_path299$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceDissatisfiedFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfiedFilled24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$j || (_path300$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceDissatisfiedFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfiedFilled20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$j || (_path301$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceDissatisfiedFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDissatisfiedFilled16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$j || (_path302$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceDizzy32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzy32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$j || (_path303$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path304$j || (_path304$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 103 3 3 3 0 00-3-3z"
    })), children);
  });
  var FaceDizzy24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzy24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$j || (_path305$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path306$j || (_path306$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 103 3 3 3 0 00-3-3z"
    })), children);
  });
  var FaceDizzy20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzy20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$j || (_path307$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path308$j || (_path308$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 103 3 3 3 0 00-3-3z"
    })), children);
  });
  var FaceDizzy16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzy16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$j || (_path309$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path310$j || (_path310$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 103 3 3 3 0 00-3-3z"
    })), children);
  });
  var FaceDizzyFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzyFilled32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$j || (_path311$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"
    })), children);
  });
  var FaceDizzyFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzyFilled24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$j || (_path312$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"
    })), children);
  });
  var FaceDizzyFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzyFilled20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$j || (_path313$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"
    })), children);
  });
  var FaceDizzyFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceDizzyFilled16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$j || (_path314$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"
    })), children);
  });
  var FaceMask32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceMask32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$j || (_path315$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11z"
    })), _path316$j || (_path316$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,1,0,8.8994,28.042l.0156.1562A1.993,1.993,0,0,0,10.9048,30h10.19a1.9929,1.9929,0,0,0,1.99-1.8008l.0156-.1572A13.9674,13.9674,0,0,0,30,16ZM16,4A11.99,11.99,0,0,1,27.97,15.397L22.7637,18H9.2363L4.0305,15.397A11.99,11.99,0,0,1,16,4ZM4.12,17.6777l3.94,1.97.5813,5.81A11.97,11.97,0,0,1,4.12,17.6777ZM21.0947,28H10.9053l-.8-8h11.79Zm2.2644-2.542.5811-5.81,3.94-1.97A11.9712,11.9712,0,0,1,23.3591,25.458Z"
    })), children);
  });
  var FaceMask24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceMask24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$j || (_path317$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11z"
    })), _path318$j || (_path318$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,1,0,8.8994,28.042l.0156.1562A1.993,1.993,0,0,0,10.9048,30h10.19a1.9929,1.9929,0,0,0,1.99-1.8008l.0156-.1572A13.9674,13.9674,0,0,0,30,16ZM16,4A11.99,11.99,0,0,1,27.97,15.397L22.7637,18H9.2363L4.0305,15.397A11.99,11.99,0,0,1,16,4ZM4.12,17.6777l3.94,1.97.5813,5.81A11.97,11.97,0,0,1,4.12,17.6777ZM21.0947,28H10.9053l-.8-8h11.79Zm2.2644-2.542.5811-5.81,3.94-1.97A11.9712,11.9712,0,0,1,23.3591,25.458Z"
    })), children);
  });
  var FaceMask20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceMask20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$j || (_path319$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11z"
    })), _path320$j || (_path320$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,1,0,8.8994,28.042l.0156.1562A1.993,1.993,0,0,0,10.9048,30h10.19a1.9929,1.9929,0,0,0,1.99-1.8008l.0156-.1572A13.9674,13.9674,0,0,0,30,16ZM16,4A11.99,11.99,0,0,1,27.97,15.397L22.7637,18H9.2363L4.0305,15.397A11.99,11.99,0,0,1,16,4ZM4.12,17.6777l3.94,1.97.5813,5.81A11.97,11.97,0,0,1,4.12,17.6777ZM21.0947,28H10.9053l-.8-8h11.79Zm2.2644-2.542.5811-5.81,3.94-1.97A11.9712,11.9712,0,0,1,23.3591,25.458Z"
    })), children);
  });
  var FaceMask16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceMask16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$j || (_path321$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11z"
    })), _path322$j || (_path322$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16A14,14,0,1,0,8.8994,28.042l.0156.1562A1.993,1.993,0,0,0,10.9048,30h10.19a1.9929,1.9929,0,0,0,1.99-1.8008l.0156-.1572A13.9674,13.9674,0,0,0,30,16ZM16,4A11.99,11.99,0,0,1,27.97,15.397L22.7637,18H9.2363L4.0305,15.397A11.99,11.99,0,0,1,16,4ZM4.12,17.6777l3.94,1.97.5813,5.81A11.97,11.97,0,0,1,4.12,17.6777ZM21.0947,28H10.9053l-.8-8h11.79Zm2.2644-2.542.5811-5.81,3.94-1.97A11.9712,11.9712,0,0,1,23.3591,25.458Z"
    })), children);
  });
  var FaceNeutral32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutral32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$j || (_path323$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path324$j || (_path324$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM10 20H22V22H10z"
    })), children);
  });
  var FaceNeutral24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutral24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$j || (_path325$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path326$j || (_path326$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM10 20H22V22H10z"
    })), children);
  });
  var FaceNeutral20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutral20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$j || (_path327$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path328$j || (_path328$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM10 20H22V22H10z"
    })), children);
  });
  var FaceNeutral16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutral16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$j || (_path329$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path330$j || (_path330$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.5 2.5 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM10 20H22V22H10z"
    })), children);
  });
  var FaceNeutralFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutralFilled32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$j || (_path331$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceNeutralFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutralFilled24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$j || (_path332$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceNeutralFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutralFilled20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$j || (_path333$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceNeutralFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceNeutralFilled16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$j || (_path334$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"
    })), children);
  });
  var FacePending32 = /*#__PURE__*/React__default['default'].forwardRef(function FacePending32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$j || (_path335$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path336$j || (_path336$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), children);
  });
  var FacePending24 = /*#__PURE__*/React__default['default'].forwardRef(function FacePending24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$j || (_path337$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path338$i || (_path338$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), children);
  });
  var FacePending20 = /*#__PURE__*/React__default['default'].forwardRef(function FacePending20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$i || (_path339$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path340$i || (_path340$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), children);
  });
  var FacePending16 = /*#__PURE__*/React__default['default'].forwardRef(function FacePending16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$i || (_path341$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path342$i || (_path342$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11z"
    })), children);
  });
  var FacePendingFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FacePendingFilled32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$i || (_path343$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FacePendingFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FacePendingFilled24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$i || (_path344$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FacePendingFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FacePendingFilled20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$i || (_path345$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FacePendingFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FacePendingFilled16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$i || (_path346$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceSatisfied32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfied32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$i || (_path347$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path348$i || (_path348$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceSatisfied24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfied24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$i || (_path349$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path350$i || (_path350$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceSatisfied20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfied20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$i || (_path351$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path352$i || (_path352$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceSatisfied16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfied16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$i || (_path353$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path354$i || (_path354$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.5 11A2.5 2.5 0 1014 13.5 2.48 2.48 0 0011.5 11zM20.5 11A2.5 2.5 0 1023 13.5 2.48 2.48 0 0020.5 11zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceSatisfiedFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfiedFilled32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$h || (_path355$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceSatisfiedFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfiedFilled24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$h || (_path356$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceSatisfiedFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfiedFilled20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$h || (_path357$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceSatisfiedFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceSatisfiedFilled16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$h || (_path358$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"
    })), children);
  });
  var FaceWink32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWink32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$h || (_path359$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path360$h || (_path360$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM8 13H14V15H8zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceWink24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWink24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$g || (_path361$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path362$g || (_path362$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM8 13H14V15H8zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceWink20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWink20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$g || (_path363$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path364$g || (_path364$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM8 13H14V15H8zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceWink16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWink16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$g || (_path365$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path366$g || (_path366$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5 11A2.5 2.5 0 1023 13.5 2.5 2.5 0 0020.5 11zM8 13H14V15H8zM16 24a8 8 0 006.85-3.89l-1.71-1a6 6 0 01-10.28 0l-1.71 1A8 8 0 0016 24z"
    })), children);
  });
  var FaceWinkFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWinkFilled32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$g || (_path367$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceWinkFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWinkFilled24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$g || (_path368$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceWinkFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWinkFilled20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$g || (_path369$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var FaceWinkFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FaceWinkFilled16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$g || (_path370$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"
    })), children);
  });
  var Factor32 = /*#__PURE__*/React__default['default'].forwardRef(function Factor32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$g || (_path371$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V9H24V4h2V2H20V4h2V9H19V28H15V16H12V11h2V9H8v2h2v5H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V18h4Zm8-17h4V28H21Z"
    })), children);
  });
  var Factor24 = /*#__PURE__*/React__default['default'].forwardRef(function Factor24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$g || (_path372$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V9H24V4h2V2H20V4h2V9H19V28H15V16H12V11h2V9H8v2h2v5H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V18h4Zm8-17h4V28H21Z"
    })), children);
  });
  var Factor20 = /*#__PURE__*/React__default['default'].forwardRef(function Factor20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$g || (_path373$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V9H24V4h2V2H20V4h2V9H19V28H15V16H12V11h2V9H8v2h2v5H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V18h4Zm8-17h4V28H21Z"
    })), children);
  });
  var Factor16 = /*#__PURE__*/React__default['default'].forwardRef(function Factor16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$g || (_path374$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28V9H24V4h2V2H20V4h2V9H19V28H15V16H12V11h2V9H8v2h2v5H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V18h4Zm8-17h4V28H21Z"
    })), children);
  });

  var _path$j, _path2$j, _path3$j, _path4$j, _path5$j, _path6$j, _path7$j, _path8$j, _path9$j, _path10$j, _path11$j, _path12$j, _path13$j, _path14$j, _path15$j, _path16$j, _path17$j, _path18$j, _path19$j, _path20$j, _path21$j, _path22$j, _path23$j, _path24$j, _path25$j, _path26$j, _path27$j, _path28$j, _path29$j, _path30$j, _path31$j, _path32$j, _path33$j, _circle$i, _path34$j, _path35$j, _circle2$i, _path36$j, _path37$j, _circle3$i, _path38$j, _path39$j, _circle4$h, _path40$j, _path41$j, _path42$j, _path43$j, _path44$j, _path45$j, _path46$j, _path47$j, _path48$j, _path49$j, _path50$j, _path51$j, _path52$j, _path53$j, _path54$j, _path55$j, _path56$j, _path57$j, _path58$j, _path59$j, _path60$j, _path61$j, _path62$j, _path63$j, _path64$j, _path65$j, _path66$j, _path67$j, _path68$j, _path69$j, _path70$j, _path71$j, _path72$j, _path73$j, _path74$j, _path75$j, _path76$j, _path77$j, _path78$j, _path79$j, _path80$j, _path81$j, _path82$j, _path83$j, _path84$j, _path85$j, _path86$j, _path87$j, _path88$j, _path89$j, _path90$j, _path91$j, _path92$j, _path93$j, _path94$j, _path95$j, _path96$j, _path97$j, _path98$j, _path99$j, _path100$j, _path101$j, _path102$j, _path103$j, _path104$j, _path105$j, _path106$j, _path107$j, _path108$j, _circle5$g, _path109$j, _circle6$g, _path110$j, _circle7$g, _path111$j, _circle8$g, _path112$j, _path113$j, _circle9$g, _path114$j, _circle10$g, _circle11$f, _path115$j, _path116$j, _circle12$f, _path117$j, _circle13$f, _circle14$f, _path118$j, _path119$j, _circle15$f, _path120$j, _circle16$f, _circle17$e, _path121$j, _path122$j, _circle18$e, _path123$j, _circle19$e, _circle20$e, _path124$j, _path125$j, _path126$j, _path127$j, _path128$j, _path129$j, _path130$j, _path131$j, _path132$j, _path133$j, _path134$j, _path135$j, _path136$j, _path137$j, _path138$j, _path139$j, _path140$j, _path141$j, _path142$j, _path143$j, _path144$j, _path145$j, _path146$j, _path147$j, _path148$j, _path149$j, _path150$j, _path151$j, _path152$j, _path153$j, _path154$j, _path155$j, _path156$j, _path157$j, _path158$j, _path159$j, _path160$j, _path161$j, _path162$j, _path163$j, _path164$j, _path165$j, _path166$j, _path167$j, _path168$j, _path169$j, _path170$j, _path171$j, _path172$j, _path173$j, _path174$j, _path175$j, _path176$j, _path177$i, _path178$i, _path179$i, _path180$i, _path181$i, _path182$i, _path183$i, _path184$i, _path185$i, _path186$i, _path187$i, _path188$i, _path189$i, _path190$i, _path191$i, _path192$i, _path193$i, _path194$i, _path195$i, _path196$i, _path197$i, _path198$i, _path199$i, _path200$i, _path201$i, _path202$i, _path203$i, _path204$i, _path205$i, _path206$i, _path207$i, _path208$i, _path209$i, _path210$i, _path211$i, _path212$i, _path213$i, _path214$i, _path215$i, _path216$i, _path217$i, _path218$i, _path219$i, _path220$i, _path221$i, _path222$i, _path223$i, _path224$i, _path225$i, _path226$i, _path227$i, _path228$i, _path229$i, _path230$i, _path231$i, _path232$i, _path233$i, _path234$i, _path235$i, _path236$i, _path237$i, _path238$i, _path239$i, _path240$i, _path241$i, _path242$i, _path243$i, _path244$i, _path245$i, _path246$i, _path247$i, _path248$i, _path249$i, _path250$i, _path251$i, _path252$i, _path253$i, _path254$i, _path255$i, _path256$i, _path257$i, _path258$i, _path259$i, _path260$i, _path261$i, _path262$i, _path263$i, _path264$i, _path265$i, _path266$i, _path267$i, _path268$i, _path269$i, _path270$i, _path271$i, _path272$i, _path273$i, _path274$i, _path275$i, _path276$i, _path277$i, _path278$i, _path279$i, _path280$i, _path281$i, _path282$i, _path283$i, _path284$i, _path285$i, _rect$3, _path286$i, _rect2$3, _path287$i, _rect3$3, _path288$i, _rect4$3, _path289$i, _path290$i, _path291$i, _path292$i, _path293$i, _path294$i, _path295$i, _path296$i, _path297$i, _path298$i, _path299$i, _path300$i, _path301$i, _path302$i, _path303$i, _path304$i, _path305$i, _path306$i, _path307$i, _path308$i, _path309$i, _path310$i, _path311$i, _path312$i, _path313$i, _path314$i, _path315$i, _path316$i, _path317$i, _path318$i, _path319$i, _path320$i, _path321$i, _path322$i, _path323$i, _path324$i, _path325$i, _path326$i, _path327$i, _path328$i, _path329$i, _path330$i, _path331$i, _path332$i, _path333$i, _path334$i, _path335$i, _path336$i, _path337$i, _path338$h, _path339$h, _path340$h, _path341$h, _path342$h, _path343$h, _path344$h, _path345$h, _circle21$e, _circle22$e, _circle23$d, _path346$h, _path347$h, _path348$h, _circle24$d, _circle25$c, _circle26$c, _path349$h, _path350$h, _path351$h, _circle27$b, _circle28$b, _circle29$b, _path352$h, _path353$h, _path354$h, _circle30$b, _circle31$b, _circle32$b, _path355$g, _path356$g, _path357$g, _path358$g, _circle33$b, _circle34$a, _circle35$a, _path359$g, _path360$g, _path361$f, _path362$f, _circle36$a, _circle37$8, _circle38$8, _path363$f, _path364$f, _path365$f, _path366$f, _circle39$8, _circle40$8, _circle41$7, _path367$f, _path368$f, _path369$f, _path370$f, _circle42$7, _circle43$7, _circle44$7, _path371$f, _path372$f, _path373$f, _path374$f, _path375$f, _path376$f, _path377$f, _path378$f, _path379$f, _path380$f, _path381$f, _path382$f, _path383$f, _path384$e, _path385$e, _path386$e, _path387$e, _path388$e, _path389$e, _path390$e, _path391$e, _path392$e, _path393$e, _path394$e, _path395$e, _path396$e, _path397$e, _path398$e, _path399$d, _path400$d, _path401$d, _path402$d, _path403$c, _path404$c, _path405$c, _path406$c, _path407$c, _path408$b, _path409$b, _path410$a, _path411$a, _path412$a, _path413$a, _path414$a, _path415$9, _path416$7, _path417$7, _path418$6, _path419$5, _path420$5, _path421$5, _path422$5, _path423$5, _path424$5, _path425$4, _path426$4;

  var _excluded$j = ["children"],
      _excluded2$j = ["children"],
      _excluded3$j = ["children"],
      _excluded4$j = ["children"],
      _excluded5$j = ["children"],
      _excluded6$j = ["children"],
      _excluded7$j = ["children"],
      _excluded8$j = ["children"],
      _excluded9$j = ["children"],
      _excluded10$j = ["children"],
      _excluded11$j = ["children"],
      _excluded12$j = ["children"],
      _excluded13$j = ["children"],
      _excluded14$j = ["children"],
      _excluded15$j = ["children"],
      _excluded16$j = ["children"],
      _excluded17$j = ["children"],
      _excluded18$j = ["children"],
      _excluded19$j = ["children"],
      _excluded20$j = ["children"],
      _excluded21$j = ["children"],
      _excluded22$j = ["children"],
      _excluded23$j = ["children"],
      _excluded24$j = ["children"],
      _excluded25$j = ["children"],
      _excluded26$j = ["children"],
      _excluded27$j = ["children"],
      _excluded28$j = ["children"],
      _excluded29$j = ["children"],
      _excluded30$j = ["children"],
      _excluded31$j = ["children"],
      _excluded32$j = ["children"],
      _excluded33$j = ["children"],
      _excluded34$j = ["children"],
      _excluded35$j = ["children"],
      _excluded36$j = ["children"],
      _excluded37$j = ["children"],
      _excluded38$j = ["children"],
      _excluded39$j = ["children"],
      _excluded40$j = ["children"],
      _excluded41$j = ["children"],
      _excluded42$j = ["children"],
      _excluded43$j = ["children"],
      _excluded44$j = ["children"],
      _excluded45$j = ["children"],
      _excluded46$j = ["children"],
      _excluded47$j = ["children"],
      _excluded48$j = ["children"],
      _excluded49$j = ["children"],
      _excluded50$j = ["children"],
      _excluded51$j = ["children"],
      _excluded52$j = ["children"],
      _excluded53$j = ["children"],
      _excluded54$j = ["children"],
      _excluded55$j = ["children"],
      _excluded56$j = ["children"],
      _excluded57$j = ["children"],
      _excluded58$j = ["children"],
      _excluded59$j = ["children"],
      _excluded60$j = ["children"],
      _excluded61$j = ["children"],
      _excluded62$j = ["children"],
      _excluded63$j = ["children"],
      _excluded64$j = ["children"],
      _excluded65$j = ["children"],
      _excluded66$j = ["children"],
      _excluded67$j = ["children"],
      _excluded68$j = ["children"],
      _excluded69$j = ["children"],
      _excluded70$j = ["children"],
      _excluded71$j = ["children"],
      _excluded72$j = ["children"],
      _excluded73$j = ["children"],
      _excluded74$j = ["children"],
      _excluded75$j = ["children"],
      _excluded76$j = ["children"],
      _excluded77$j = ["children"],
      _excluded78$j = ["children"],
      _excluded79$j = ["children"],
      _excluded80$j = ["children"],
      _excluded81$j = ["children"],
      _excluded82$j = ["children"],
      _excluded83$j = ["children"],
      _excluded84$j = ["children"],
      _excluded85$j = ["children"],
      _excluded86$j = ["children"],
      _excluded87$j = ["children"],
      _excluded88$j = ["children"],
      _excluded89$j = ["children"],
      _excluded90$j = ["children"],
      _excluded91$j = ["children"],
      _excluded92$j = ["children"],
      _excluded93$j = ["children"],
      _excluded94$j = ["children"],
      _excluded95$j = ["children"],
      _excluded96$j = ["children"],
      _excluded97$j = ["children"],
      _excluded98$j = ["children"],
      _excluded99$j = ["children"],
      _excluded100$j = ["children"],
      _excluded101$j = ["children"],
      _excluded102$j = ["children"],
      _excluded103$j = ["children"],
      _excluded104$j = ["children"],
      _excluded105$j = ["children"],
      _excluded106$j = ["children"],
      _excluded107$j = ["children"],
      _excluded108$j = ["children"],
      _excluded109$j = ["children"],
      _excluded110$j = ["children"],
      _excluded111$j = ["children"],
      _excluded112$j = ["children"],
      _excluded113$j = ["children"],
      _excluded114$j = ["children"],
      _excluded115$j = ["children"],
      _excluded116$j = ["children"],
      _excluded117$j = ["children"],
      _excluded118$j = ["children"],
      _excluded119$i = ["children"],
      _excluded120$i = ["children"],
      _excluded121$i = ["children"],
      _excluded122$i = ["children"],
      _excluded123$i = ["children"],
      _excluded124$i = ["children"],
      _excluded125$i = ["children"],
      _excluded126$i = ["children"],
      _excluded127$i = ["children"],
      _excluded128$i = ["children"],
      _excluded129$i = ["children"],
      _excluded130$i = ["children"],
      _excluded131$i = ["children"],
      _excluded132$i = ["children"],
      _excluded133$i = ["children"],
      _excluded134$i = ["children"],
      _excluded135$i = ["children"],
      _excluded136$i = ["children"],
      _excluded137$i = ["children"],
      _excluded138$i = ["children"],
      _excluded139$i = ["children"],
      _excluded140$i = ["children"],
      _excluded141$i = ["children"],
      _excluded142$i = ["children"],
      _excluded143$i = ["children"],
      _excluded144$i = ["children"],
      _excluded145$i = ["children"],
      _excluded146$i = ["children"],
      _excluded147$i = ["children"],
      _excluded148$i = ["children"],
      _excluded149$i = ["children"],
      _excluded150$i = ["children"],
      _excluded151$i = ["children"],
      _excluded152$i = ["children"],
      _excluded153$i = ["children"],
      _excluded154$i = ["children"],
      _excluded155$i = ["children"],
      _excluded156$i = ["children"],
      _excluded157$i = ["children"],
      _excluded158$i = ["children"],
      _excluded159$i = ["children"],
      _excluded160$i = ["children"],
      _excluded161$i = ["children"],
      _excluded162$i = ["children"],
      _excluded163$i = ["children"],
      _excluded164$i = ["children"],
      _excluded165$i = ["children"],
      _excluded166$i = ["children"],
      _excluded167$i = ["children"],
      _excluded168$i = ["children"],
      _excluded169$i = ["children"],
      _excluded170$i = ["children"],
      _excluded171$i = ["children"],
      _excluded172$i = ["children"],
      _excluded173$i = ["children"],
      _excluded174$i = ["children"],
      _excluded175$i = ["children"],
      _excluded176$i = ["children"],
      _excluded177$i = ["children"],
      _excluded178$i = ["children"],
      _excluded179$i = ["children"],
      _excluded180$i = ["children"],
      _excluded181$i = ["children"],
      _excluded182$i = ["children"],
      _excluded183$i = ["children"],
      _excluded184$i = ["children"],
      _excluded185$i = ["children"],
      _excluded186$i = ["children"],
      _excluded187$i = ["children"],
      _excluded188$i = ["children"],
      _excluded189$i = ["children"],
      _excluded190$i = ["children"],
      _excluded191$i = ["children"],
      _excluded192$i = ["children"],
      _excluded193$i = ["children"],
      _excluded194$i = ["children"],
      _excluded195$i = ["children"],
      _excluded196$i = ["children"],
      _excluded197$i = ["children"],
      _excluded198$i = ["children"],
      _excluded199$i = ["children"],
      _excluded200$i = ["children"],
      _excluded201$i = ["children"],
      _excluded202$i = ["children"],
      _excluded203$i = ["children"],
      _excluded204$i = ["children"],
      _excluded205$i = ["children"],
      _excluded206$i = ["children"],
      _excluded207$i = ["children"],
      _excluded208$i = ["children"],
      _excluded209$i = ["children"],
      _excluded210$i = ["children"],
      _excluded211$i = ["children"],
      _excluded212$i = ["children"],
      _excluded213$i = ["children"],
      _excluded214$i = ["children"],
      _excluded215$i = ["children"],
      _excluded216$i = ["children"],
      _excluded217$i = ["children"],
      _excluded218$i = ["children"],
      _excluded219$i = ["children"],
      _excluded220$i = ["children"],
      _excluded221$i = ["children"],
      _excluded222$i = ["children"],
      _excluded223$i = ["children"],
      _excluded224$i = ["children"],
      _excluded225$i = ["children"],
      _excluded226$i = ["children"],
      _excluded227$i = ["children"],
      _excluded228$i = ["children"],
      _excluded229$i = ["children"],
      _excluded230$i = ["children"],
      _excluded231$i = ["children"],
      _excluded232$i = ["children"],
      _excluded233$i = ["children"],
      _excluded234$i = ["children"],
      _excluded235$i = ["children"],
      _excluded236$i = ["children"],
      _excluded237$i = ["children"],
      _excluded238$i = ["children"],
      _excluded239$i = ["children"],
      _excluded240$i = ["children"],
      _excluded241$i = ["children"],
      _excluded242$i = ["children"],
      _excluded243$i = ["children"],
      _excluded244$i = ["children"],
      _excluded245$i = ["children"],
      _excluded246$i = ["children"],
      _excluded247$i = ["children"],
      _excluded248$i = ["children"],
      _excluded249$i = ["children"],
      _excluded250$i = ["children"];
  var Fade32 = /*#__PURE__*/React__default['default'].forwardRef(function Fade32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$j || (_path$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.24 25.14L7 26.67a13.79 13.79 0 004.18 2.44l.69-1.87A12 12 0 018.24 25.14zM4.19 18l-2 .41A14.09 14.09 0 003.86 23L5.59 22A12.44 12.44 0 014.19 18zM11.82 4.76l-.69-1.87A13.79 13.79 0 007 5.33L8.24 6.86A12 12 0 0111.82 4.76zM5.59 10L3.86 9a14.37 14.37 0 00-1.64 4.59l2 .34A12.05 12.05 0 015.59 10zM16 2V4a12 12 0 010 24v2A14 14 0 0016 2z"
    })), children);
  });
  var Fade24 = /*#__PURE__*/React__default['default'].forwardRef(function Fade24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$j || (_path2$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.24 25.14L7 26.67a13.79 13.79 0 004.18 2.44l.69-1.87A12 12 0 018.24 25.14zM4.19 18l-2 .41A14.09 14.09 0 003.86 23L5.59 22A12.44 12.44 0 014.19 18zM11.82 4.76l-.69-1.87A13.79 13.79 0 007 5.33L8.24 6.86A12 12 0 0111.82 4.76zM5.59 10L3.86 9a14.37 14.37 0 00-1.64 4.59l2 .34A12.05 12.05 0 015.59 10zM16 2V4a12 12 0 010 24v2A14 14 0 0016 2z"
    })), children);
  });
  var Fade20 = /*#__PURE__*/React__default['default'].forwardRef(function Fade20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$j || (_path3$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.24 25.14L7 26.67a13.79 13.79 0 004.18 2.44l.69-1.87A12 12 0 018.24 25.14zM4.19 18l-2 .41A14.09 14.09 0 003.86 23L5.59 22A12.44 12.44 0 014.19 18zM11.82 4.76l-.69-1.87A13.79 13.79 0 007 5.33L8.24 6.86A12 12 0 0111.82 4.76zM5.59 10L3.86 9a14.37 14.37 0 00-1.64 4.59l2 .34A12.05 12.05 0 015.59 10zM16 2V4a12 12 0 010 24v2A14 14 0 0016 2z"
    })), children);
  });
  var Fade16 = /*#__PURE__*/React__default['default'].forwardRef(function Fade16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$j || (_path4$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.1 12.6l-.6.8c.6.5 1.3.9 2.1 1.2l.3-.9C5.3 13.4 4.7 13 4.1 12.6zM2.1 9l-1 .2c.1.8.4 1.6.8 2.3L2.8 11C2.4 10.4 2.2 9.7 2.1 9zM5.9 2.4L5.6 1.4C4.8 1.7 4.1 2.1 3.5 2.7l.6.8C4.7 3 5.3 2.6 5.9 2.4zM2.8 5L1.9 4.5C1.5 5.2 1.3 6 1.1 6.8l1 .2C2.2 6.3 2.5 5.6 2.8 5zM8 1v1c3.3 0 6 2.7 6 6s-2.7 6-6 6v1c3.9 0 7-3.1 7-7S11.9 1 8 1z"
    })), children);
  });
  var Favorite32 = /*#__PURE__*/React__default['default'].forwardRef(function Favorite32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$j || (_path5$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"
    })), children);
  });
  var Favorite24 = /*#__PURE__*/React__default['default'].forwardRef(function Favorite24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$j || (_path6$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"
    })), children);
  });
  var Favorite20 = /*#__PURE__*/React__default['default'].forwardRef(function Favorite20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$j || (_path7$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"
    })), children);
  });
  var Favorite16 = /*#__PURE__*/React__default['default'].forwardRef(function Favorite16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$j || (_path8$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"
    })), children);
  });
  var FavoriteFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteFilled32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$j || (_path9$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,4c-2,0-3.9,0.8-5.3,2.2L16,7.4l-1.1-1.1C12,3.3,7.2,3.3,4.3,6.2c0,0-0.1,0.1-0.1,0.1c-3,3-3,7.8,0,10.8L16,29\tl11.8-11.9c3-3,3-7.8,0-10.8C26.4,4.8,24.5,4,22.5,4z"
    })), children);
  });
  var FavoriteFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteFilled24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$j || (_path10$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,4c-2,0-3.9,0.8-5.3,2.2L16,7.4l-1.1-1.1C12,3.3,7.2,3.3,4.3,6.2c0,0-0.1,0.1-0.1,0.1c-3,3-3,7.8,0,10.8L16,29\tl11.8-11.9c3-3,3-7.8,0-10.8C26.4,4.8,24.5,4,22.5,4z"
    })), children);
  });
  var FavoriteFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteFilled20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$j || (_path11$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,4c-2,0-3.9,0.8-5.3,2.2L16,7.4l-1.1-1.1C12,3.3,7.2,3.3,4.3,6.2c0,0-0.1,0.1-0.1,0.1c-3,3-3,7.8,0,10.8L16,29\tl11.8-11.9c3-3,3-7.8,0-10.8C26.4,4.8,24.5,4,22.5,4z"
    })), children);
  });
  var FavoriteFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteFilled16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$j || (_path12$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,4c-2,0-3.9,0.8-5.3,2.2L16,7.4l-1.1-1.1C12,3.3,7.2,3.3,4.3,6.2c0,0-0.1,0.1-0.1,0.1c-3,3-3,7.8,0,10.8L16,29\tl11.8-11.9c3-3,3-7.8,0-10.8C26.4,4.8,24.5,4,22.5,4z"
    })), children);
  });
  var FavoriteHalf32 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteHalf32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$j || (_path13$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.21,17.0615,16,29,27.79,17.0615a7.7313,7.7313,0,0,0,0-10.8232,7.494,7.494,0,0,0-10.6841,0L16,7.3643l-1.1062-1.126a7.494,7.494,0,0,0-10.6841,0A7.7313,7.7313,0,0,0,4.21,17.0615ZM26.3552,15.645,16,26.1255V10.23q1.2708-1.2876,2.5413-2.5742a5.4768,5.4768,0,0,1,7.8139,0A5.708,5.708,0,0,1,26.3552,15.645Z"
    })), children);
  });
  var FavoriteHalf24 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteHalf24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$j || (_path14$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.21,17.0615,16,29,27.79,17.0615a7.7313,7.7313,0,0,0,0-10.8232,7.494,7.494,0,0,0-10.6841,0L16,7.3643l-1.1062-1.126a7.494,7.494,0,0,0-10.6841,0A7.7313,7.7313,0,0,0,4.21,17.0615ZM26.3552,15.645,16,26.1255V10.23q1.2708-1.2876,2.5413-2.5742a5.4768,5.4768,0,0,1,7.8139,0A5.708,5.708,0,0,1,26.3552,15.645Z"
    })), children);
  });
  var FavoriteHalf20 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteHalf20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$j || (_path15$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.21,17.0615,16,29,27.79,17.0615a7.7313,7.7313,0,0,0,0-10.8232,7.494,7.494,0,0,0-10.6841,0L16,7.3643l-1.1062-1.126a7.494,7.494,0,0,0-10.6841,0A7.7313,7.7313,0,0,0,4.21,17.0615ZM26.3552,15.645,16,26.1255V10.23q1.2708-1.2876,2.5413-2.5742a5.4768,5.4768,0,0,1,7.8139,0A5.708,5.708,0,0,1,26.3552,15.645Z"
    })), children);
  });
  var FavoriteHalf16 = /*#__PURE__*/React__default['default'].forwardRef(function FavoriteHalf16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$j || (_path16$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.21,17.0615,16,29,27.79,17.0615a7.7313,7.7313,0,0,0,0-10.8232,7.494,7.494,0,0,0-10.6841,0L16,7.3643l-1.1062-1.126a7.494,7.494,0,0,0-10.6841,0A7.7313,7.7313,0,0,0,4.21,17.0615ZM26.3552,15.645,16,26.1255V10.23q1.2708-1.2876,2.5413-2.5742a5.4768,5.4768,0,0,1,7.8139,0A5.708,5.708,0,0,1,26.3552,15.645Z"
    })), children);
  });
  var FetchUpload32 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUpload32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$j || (_path17$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7,6,17l1.41,1.41L15,10.83V28H2v2H15a2,2,0,0,0,2-2V10.83l7.59,7.58L26,17Z"
    })), _path18$j || (_path18$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"
    })), children);
  });
  var FetchUpload24 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUpload24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$j || (_path19$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7,6,17l1.41,1.41L15,10.83V28H2v2H15a2,2,0,0,0,2-2V10.83l7.59,7.58L26,17Z"
    })), _path20$j || (_path20$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"
    })), children);
  });
  var FetchUpload20 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUpload20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$j || (_path21$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7,6,17l1.41,1.41L15,10.83V28H2v2H15a2,2,0,0,0,2-2V10.83l7.59,7.58L26,17Z"
    })), _path22$j || (_path22$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"
    })), children);
  });
  var FetchUpload16 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUpload16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$j || (_path23$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7,6,17l1.41,1.41L15,10.83V28H2v2H15a2,2,0,0,0,2-2V10.83l7.59,7.58L26,17Z"
    })), _path24$j || (_path24$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"
    })), children);
  });
  var FetchUploadCloud32 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUploadCloud32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$j || (_path25$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13l-5,5,1.41,1.41L15,16.83V28H6v2h9a2,2,0,0,0,2-2V16.83l2.59,2.58L21,18Z"
    })), _path26$j || (_path26$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var FetchUploadCloud24 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUploadCloud24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$j || (_path27$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13l-5,5,1.41,1.41L15,16.83V28H6v2h9a2,2,0,0,0,2-2V16.83l2.59,2.58L21,18Z"
    })), _path28$j || (_path28$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var FetchUploadCloud20 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUploadCloud20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$j || (_path29$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13l-5,5,1.41,1.41L15,16.83V28H6v2h9a2,2,0,0,0,2-2V16.83l2.59,2.58L21,18Z"
    })), _path30$j || (_path30$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var FetchUploadCloud16 = /*#__PURE__*/React__default['default'].forwardRef(function FetchUploadCloud16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$j || (_path31$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13l-5,5,1.41,1.41L15,16.83V28H6v2h9a2,2,0,0,0,2-2V16.83l2.59,2.58L21,18Z"
    })), _path32$j || (_path32$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var FileStorage32 = /*#__PURE__*/React__default['default'].forwardRef(function FileStorage32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$j || (_path33$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle$i || (_circle$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path34$j || (_path34$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,7.293l-5-5A1,1,0,0,0,17,2H11A2.0023,2.0023,0,0,0,9,4V20a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V8A1,1,0,0,0,22.707,7.293ZM20.5857,8H17V4.4141ZM11,20V4h4V8a2.0023,2.0023,0,0,0,2,2h4V20Z"
    })), children);
  });
  var FileStorage24 = /*#__PURE__*/React__default['default'].forwardRef(function FileStorage24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$j || (_path35$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle2$i || (_circle2$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path36$j || (_path36$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,7.293l-5-5A1,1,0,0,0,17,2H11A2.0023,2.0023,0,0,0,9,4V20a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V8A1,1,0,0,0,22.707,7.293ZM20.5857,8H17V4.4141ZM11,20V4h4V8a2.0023,2.0023,0,0,0,2,2h4V20Z"
    })), children);
  });
  var FileStorage20 = /*#__PURE__*/React__default['default'].forwardRef(function FileStorage20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$j || (_path37$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle3$i || (_circle3$i = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path38$j || (_path38$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,7.293l-5-5A1,1,0,0,0,17,2H11A2.0023,2.0023,0,0,0,9,4V20a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V8A1,1,0,0,0,22.707,7.293ZM20.5857,8H17V4.4141ZM11,20V4h4V8a2.0023,2.0023,0,0,0,2,2h4V20Z"
    })), children);
  });
  var FileStorage16 = /*#__PURE__*/React__default['default'].forwardRef(function FileStorage16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$j || (_path39$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle4$h || (_circle4$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path40$j || (_path40$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.707,7.293l-5-5A1,1,0,0,0,17,2H11A2.0023,2.0023,0,0,0,9,4V20a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V8A1,1,0,0,0,22.707,7.293ZM20.5857,8H17V4.4141ZM11,20V4h4V8a2.0023,2.0023,0,0,0,2,2h4V20Z"
    })), children);
  });
  var Filter32 = /*#__PURE__*/React__default['default'].forwardRef(function Filter32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$j || (_path41$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"
    })), children);
  });
  var Filter24 = /*#__PURE__*/React__default['default'].forwardRef(function Filter24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$j || (_path42$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"
    })), children);
  });
  var Filter20 = /*#__PURE__*/React__default['default'].forwardRef(function Filter20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$j || (_path43$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"
    })), children);
  });
  var Filter16 = /*#__PURE__*/React__default['default'].forwardRef(function Filter16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$j || (_path44$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"
    })), children);
  });
  var FilterEdit32 = /*#__PURE__*/React__default['default'].forwardRef(function FilterEdit32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$j || (_path45$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path46$j || (_path46$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var FilterEdit24 = /*#__PURE__*/React__default['default'].forwardRef(function FilterEdit24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$j || (_path47$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path48$j || (_path48$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var FilterEdit20 = /*#__PURE__*/React__default['default'].forwardRef(function FilterEdit20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$j || (_path49$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path50$j || (_path50$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var FilterEdit16 = /*#__PURE__*/React__default['default'].forwardRef(function FilterEdit16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$j || (_path51$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"
    })), _path52$j || (_path52$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"
    })), children);
  });
  var FilterRemove32 = /*#__PURE__*/React__default['default'].forwardRef(function FilterRemove32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$j || (_path53$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.414L28.586 10 24 14.586 19.414 10 18 11.414 22.586 16 18 20.585 19.415 22 24 17.414 28.587 22 30 20.587 25.414 16 30 11.414z"
    })), _path54$j || (_path54$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4A2,2,0,0,0,2,6V9.1709a2,2,0,0,0,.5859,1.4145L10,18v8a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V24H16v2H12V17.1709l-.5859-.5855L4,9.1709V6H24V8h2V6a2,2,0,0,0-2-2Z"
    })), children);
  });
  var FilterRemove24 = /*#__PURE__*/React__default['default'].forwardRef(function FilterRemove24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$j || (_path55$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.414L28.586 10 24 14.586 19.414 10 18 11.414 22.586 16 18 20.585 19.415 22 24 17.414 28.587 22 30 20.587 25.414 16 30 11.414z"
    })), _path56$j || (_path56$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4A2,2,0,0,0,2,6V9.1709a2,2,0,0,0,.5859,1.4145L10,18v8a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V24H16v2H12V17.1709l-.5859-.5855L4,9.1709V6H24V8h2V6a2,2,0,0,0-2-2Z"
    })), children);
  });
  var FilterRemove20 = /*#__PURE__*/React__default['default'].forwardRef(function FilterRemove20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$j || (_path57$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.414L28.586 10 24 14.586 19.414 10 18 11.414 22.586 16 18 20.585 19.415 22 24 17.414 28.587 22 30 20.587 25.414 16 30 11.414z"
    })), _path58$j || (_path58$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4A2,2,0,0,0,2,6V9.1709a2,2,0,0,0,.5859,1.4145L10,18v8a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V24H16v2H12V17.1709l-.5859-.5855L4,9.1709V6H24V8h2V6a2,2,0,0,0-2-2Z"
    })), children);
  });
  var FilterRemove16 = /*#__PURE__*/React__default['default'].forwardRef(function FilterRemove16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$j || (_path59$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.414L28.586 10 24 14.586 19.414 10 18 11.414 22.586 16 18 20.585 19.415 22 24 17.414 28.587 22 30 20.587 25.414 16 30 11.414z"
    })), _path60$j || (_path60$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4A2,2,0,0,0,2,6V9.1709a2,2,0,0,0,.5859,1.4145L10,18v8a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V24H16v2H12V17.1709l-.5859-.5855L4,9.1709V6H24V8h2V6a2,2,0,0,0-2-2Z"
    })), children);
  });
  var FilterReset32 = /*#__PURE__*/React__default['default'].forwardRef(function FilterReset32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$j || (_path61$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,9A7.4522,7.4522,0,0,0,16,12.792V8H14v8h8V14H17.6167A5.4941,5.4941,0,1,1,22.5,22H22v2h.5a7.5,7.5,0,0,0,0-15Z"
    })), _path62$j || (_path62$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.171l7.4142,7.4143L12,17.171V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.5858,10.5853A2,2,0,0,1,2,9.171V6A2,2,0,0,1,4,4H26Z"
    })), children);
  });
  var FilterReset24 = /*#__PURE__*/React__default['default'].forwardRef(function FilterReset24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$j || (_path63$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,9A7.4522,7.4522,0,0,0,16,12.792V8H14v8h8V14H17.6167A5.4941,5.4941,0,1,1,22.5,22H22v2h.5a7.5,7.5,0,0,0,0-15Z"
    })), _path64$j || (_path64$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.171l7.4142,7.4143L12,17.171V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.5858,10.5853A2,2,0,0,1,2,9.171V6A2,2,0,0,1,4,4H26Z"
    })), children);
  });
  var FilterReset20 = /*#__PURE__*/React__default['default'].forwardRef(function FilterReset20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$j || (_path65$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,9A7.4522,7.4522,0,0,0,16,12.792V8H14v8h8V14H17.6167A5.4941,5.4941,0,1,1,22.5,22H22v2h.5a7.5,7.5,0,0,0,0-15Z"
    })), _path66$j || (_path66$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.171l7.4142,7.4143L12,17.171V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.5858,10.5853A2,2,0,0,1,2,9.171V6A2,2,0,0,1,4,4H26Z"
    })), children);
  });
  var FilterReset16 = /*#__PURE__*/React__default['default'].forwardRef(function FilterReset16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$j || (_path67$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,9A7.4522,7.4522,0,0,0,16,12.792V8H14v8h8V14H17.6167A5.4941,5.4941,0,1,1,22.5,22H22v2h.5a7.5,7.5,0,0,0,0-15Z"
    })), _path68$j || (_path68$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6H4V9.171l7.4142,7.4143L12,17.171V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.5858,10.5853A2,2,0,0,1,2,9.171V6A2,2,0,0,1,4,4H26Z"
    })), children);
  });
  var Finance32 = /*#__PURE__*/React__default['default'].forwardRef(function Finance32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$j || (_path69$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM27 11a1 1 0 001-1V7a1 1 0 00-.66-.94l-11-4a1 1 0 00-.68 0l-11 4A1 1 0 004 7v3a1 1 0 001 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"
    })), children);
  });
  var Finance24 = /*#__PURE__*/React__default['default'].forwardRef(function Finance24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$j || (_path70$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM27 11a1 1 0 001-1V7a1 1 0 00-.66-.94l-11-4a1 1 0 00-.68 0l-11 4A1 1 0 004 7v3a1 1 0 001 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"
    })), children);
  });
  var Finance20 = /*#__PURE__*/React__default['default'].forwardRef(function Finance20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$j || (_path71$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM27 11a1 1 0 001-1V7a1 1 0 00-.66-.94l-11-4a1 1 0 00-.68 0l-11 4A1 1 0 004 7v3a1 1 0 001 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"
    })), children);
  });
  var Finance16 = /*#__PURE__*/React__default['default'].forwardRef(function Finance16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$j || (_path72$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM27 11a1 1 0 001-1V7a1 1 0 00-.66-.94l-11-4a1 1 0 00-.68 0l-11 4A1 1 0 004 7v3a1 1 0 001 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"
    })), children);
  });
  var FingerprintRecognition32 = /*#__PURE__*/React__default['default'].forwardRef(function FingerprintRecognition32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$j || (_path73$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"
    })), _path74$j || (_path74$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"
    })), _path75$j || (_path75$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"
    })), _path76$j || (_path76$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"
    })), _path77$j || (_path77$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"
    })), children);
  });
  var FingerprintRecognition24 = /*#__PURE__*/React__default['default'].forwardRef(function FingerprintRecognition24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$j || (_path78$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"
    })), _path79$j || (_path79$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"
    })), _path80$j || (_path80$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"
    })), _path81$j || (_path81$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"
    })), _path82$j || (_path82$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"
    })), children);
  });
  var FingerprintRecognition20 = /*#__PURE__*/React__default['default'].forwardRef(function FingerprintRecognition20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$j || (_path83$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"
    })), _path84$j || (_path84$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"
    })), _path85$j || (_path85$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"
    })), _path86$j || (_path86$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"
    })), _path87$j || (_path87$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"
    })), children);
  });
  var FingerprintRecognition16 = /*#__PURE__*/React__default['default'].forwardRef(function FingerprintRecognition16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$j || (_path88$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"
    })), _path89$j || (_path89$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"
    })), _path90$j || (_path90$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"
    })), _path91$j || (_path91$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"
    })), _path92$j || (_path92$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"
    })), children);
  });
  var Fire32 = /*#__PURE__*/React__default['default'].forwardRef(function Fire32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$j || (_path93$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.832,16.9688c-.2724-.6465-.5815-1.38-.8833-2.2852-.79-2.3682,1.7344-4.9522,1.7583-4.9766L24.293,8.293c-.1407.1406-3.4234,3.4775-2.2417,7.0234.3261.978.6513,1.749.938,2.43A9.3812,9.3812,0,0,1,24,22a6.24,6.24,0,0,1-4.1892,5.293,8.52,8.52,0,0,0-2.1038-8l-1.0444-1.0445-.5815,1.3575C14.2449,23.89,12.06,25.76,10.7747,26.54A5.8437,5.8437,0,0,1,8,22a9.6239,9.6239,0,0,1,.9287-3.6289A11.3329,11.3329,0,0,0,10,14V12.2217c.8735.36,2,1.3037,2,3.7783v2.6035l1.7432-1.9341c3.1118-3.4546,2.4624-7.5678,1.206-10.3081A4.4859,4.4859,0,0,1,18,11h2c0-5.5371-4.5786-7-7-7H11l1.1992,1.5986c.1377.1856,2.8628,3.9278,1.3535,7.688A4.9426,4.9426,0,0,0,9,10H8v4a9.6239,9.6239,0,0,1-.9287,3.6289A11.3329,11.3329,0,0,0,6,22c0,3.8477,3.8232,8,10,8s10-4.1523,10-8A11.3771,11.3771,0,0,0,24.832,16.9688ZM12.8352,27.5264a16.4987,16.4987,0,0,0,4.3665-5.5987,6.1053,6.1053,0,0,1,.2573,5.9717A11.3213,11.3213,0,0,1,16,28,10.3278,10.3278,0,0,1,12.8352,27.5264Z"
    })), children);
  });
  var Fire24 = /*#__PURE__*/React__default['default'].forwardRef(function Fire24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$j || (_path94$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.832,16.9688c-.2724-.6465-.5815-1.38-.8833-2.2852-.79-2.3682,1.7344-4.9522,1.7583-4.9766L24.293,8.293c-.1407.1406-3.4234,3.4775-2.2417,7.0234.3261.978.6513,1.749.938,2.43A9.3812,9.3812,0,0,1,24,22a6.24,6.24,0,0,1-4.1892,5.293,8.52,8.52,0,0,0-2.1038-8l-1.0444-1.0445-.5815,1.3575C14.2449,23.89,12.06,25.76,10.7747,26.54A5.8437,5.8437,0,0,1,8,22a9.6239,9.6239,0,0,1,.9287-3.6289A11.3329,11.3329,0,0,0,10,14V12.2217c.8735.36,2,1.3037,2,3.7783v2.6035l1.7432-1.9341c3.1118-3.4546,2.4624-7.5678,1.206-10.3081A4.4859,4.4859,0,0,1,18,11h2c0-5.5371-4.5786-7-7-7H11l1.1992,1.5986c.1377.1856,2.8628,3.9278,1.3535,7.688A4.9426,4.9426,0,0,0,9,10H8v4a9.6239,9.6239,0,0,1-.9287,3.6289A11.3329,11.3329,0,0,0,6,22c0,3.8477,3.8232,8,10,8s10-4.1523,10-8A11.3771,11.3771,0,0,0,24.832,16.9688ZM12.8352,27.5264a16.4987,16.4987,0,0,0,4.3665-5.5987,6.1053,6.1053,0,0,1,.2573,5.9717A11.3213,11.3213,0,0,1,16,28,10.3278,10.3278,0,0,1,12.8352,27.5264Z"
    })), children);
  });
  var Fire20 = /*#__PURE__*/React__default['default'].forwardRef(function Fire20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$j || (_path95$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.832,16.9688c-.2724-.6465-.5815-1.38-.8833-2.2852-.79-2.3682,1.7344-4.9522,1.7583-4.9766L24.293,8.293c-.1407.1406-3.4234,3.4775-2.2417,7.0234.3261.978.6513,1.749.938,2.43A9.3812,9.3812,0,0,1,24,22a6.24,6.24,0,0,1-4.1892,5.293,8.52,8.52,0,0,0-2.1038-8l-1.0444-1.0445-.5815,1.3575C14.2449,23.89,12.06,25.76,10.7747,26.54A5.8437,5.8437,0,0,1,8,22a9.6239,9.6239,0,0,1,.9287-3.6289A11.3329,11.3329,0,0,0,10,14V12.2217c.8735.36,2,1.3037,2,3.7783v2.6035l1.7432-1.9341c3.1118-3.4546,2.4624-7.5678,1.206-10.3081A4.4859,4.4859,0,0,1,18,11h2c0-5.5371-4.5786-7-7-7H11l1.1992,1.5986c.1377.1856,2.8628,3.9278,1.3535,7.688A4.9426,4.9426,0,0,0,9,10H8v4a9.6239,9.6239,0,0,1-.9287,3.6289A11.3329,11.3329,0,0,0,6,22c0,3.8477,3.8232,8,10,8s10-4.1523,10-8A11.3771,11.3771,0,0,0,24.832,16.9688ZM12.8352,27.5264a16.4987,16.4987,0,0,0,4.3665-5.5987,6.1053,6.1053,0,0,1,.2573,5.9717A11.3213,11.3213,0,0,1,16,28,10.3278,10.3278,0,0,1,12.8352,27.5264Z"
    })), children);
  });
  var Fire16 = /*#__PURE__*/React__default['default'].forwardRef(function Fire16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$j || (_path96$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.832,16.9688c-.2724-.6465-.5815-1.38-.8833-2.2852-.79-2.3682,1.7344-4.9522,1.7583-4.9766L24.293,8.293c-.1407.1406-3.4234,3.4775-2.2417,7.0234.3261.978.6513,1.749.938,2.43A9.3812,9.3812,0,0,1,24,22a6.24,6.24,0,0,1-4.1892,5.293,8.52,8.52,0,0,0-2.1038-8l-1.0444-1.0445-.5815,1.3575C14.2449,23.89,12.06,25.76,10.7747,26.54A5.8437,5.8437,0,0,1,8,22a9.6239,9.6239,0,0,1,.9287-3.6289A11.3329,11.3329,0,0,0,10,14V12.2217c.8735.36,2,1.3037,2,3.7783v2.6035l1.7432-1.9341c3.1118-3.4546,2.4624-7.5678,1.206-10.3081A4.4859,4.4859,0,0,1,18,11h2c0-5.5371-4.5786-7-7-7H11l1.1992,1.5986c.1377.1856,2.8628,3.9278,1.3535,7.688A4.9426,4.9426,0,0,0,9,10H8v4a9.6239,9.6239,0,0,1-.9287,3.6289A11.3329,11.3329,0,0,0,6,22c0,3.8477,3.8232,8,10,8s10-4.1523,10-8A11.3771,11.3771,0,0,0,24.832,16.9688ZM12.8352,27.5264a16.4987,16.4987,0,0,0,4.3665-5.5987,6.1053,6.1053,0,0,1,.2573,5.9717A11.3213,11.3213,0,0,1,16,28,10.3278,10.3278,0,0,1,12.8352,27.5264Z"
    })), children);
  });
  var Firewall32 = /*#__PURE__*/React__default['default'].forwardRef(function Firewall32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$j || (_path97$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.3972v3c-1 0-2-1.5-2-4v-3c-4 5-5 7-5 9A5.0008 5.0008 0 0023.0458 30 7.5281 7.5281 0 0125 26.3972 7.5281 7.5281 0 0126.9542 30 5.0008 5.0008 0 0030 25.3972C30 23.3972 28.875 21.8258 27 20.3972zM17 28H4V24H17V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17z"
    })), _path98$j || (_path98$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H7a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17V18H7V14H28l.0011 2H30V14A2.0023 2.0023 0 0028 12zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4z"
    })), children);
  });
  var Firewall24 = /*#__PURE__*/React__default['default'].forwardRef(function Firewall24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$j || (_path99$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.3972v3c-1 0-2-1.5-2-4v-3c-4 5-5 7-5 9A5.0008 5.0008 0 0023.0458 30 7.5281 7.5281 0 0125 26.3972 7.5281 7.5281 0 0126.9542 30 5.0008 5.0008 0 0030 25.3972C30 23.3972 28.875 21.8258 27 20.3972zM17 28H4V24H17V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17z"
    })), _path100$j || (_path100$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H7a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17V18H7V14H28l.0011 2H30V14A2.0023 2.0023 0 0028 12zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4z"
    })), children);
  });
  var Firewall20 = /*#__PURE__*/React__default['default'].forwardRef(function Firewall20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$j || (_path101$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.3972v3c-1 0-2-1.5-2-4v-3c-4 5-5 7-5 9A5.0008 5.0008 0 0023.0458 30 7.5281 7.5281 0 0125 26.3972 7.5281 7.5281 0 0126.9542 30 5.0008 5.0008 0 0030 25.3972C30 23.3972 28.875 21.8258 27 20.3972zM17 28H4V24H17V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17z"
    })), _path102$j || (_path102$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H7a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17V18H7V14H28l.0011 2H30V14A2.0023 2.0023 0 0028 12zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4z"
    })), children);
  });
  var Firewall16 = /*#__PURE__*/React__default['default'].forwardRef(function Firewall16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$j || (_path103$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.3972v3c-1 0-2-1.5-2-4v-3c-4 5-5 7-5 9A5.0008 5.0008 0 0023.0458 30 7.5281 7.5281 0 0125 26.3972 7.5281 7.5281 0 0126.9542 30 5.0008 5.0008 0 0030 25.3972C30 23.3972 28.875 21.8258 27 20.3972zM17 28H4V24H17V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17z"
    })), _path104$j || (_path104$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H7a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2H17V18H7V14H28l.0011 2H30V14A2.0023 2.0023 0 0028 12zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4z"
    })), children);
  });
  var FirewallClassic32 = /*#__PURE__*/React__default['default'].forwardRef(function FirewallClassic32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$j || (_path105$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20V17a4 4 0 00-8 0v3a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 0028 20zm-6-3a2 2 0 014 0v3H22zm6 11H20V22h8zM15 27H4a2 2 0 01-2-2V22a2 2 0 012-2H15v2H4v3H15zM17 18H8a2 2 0 01-2-2V13a2 2 0 012-2H19v2H8v3h9zM22 9H4A2 2 0 012 7V4A2 2 0 014 2H22a2 2 0 012 2V7A2 2 0 0122 9zM4 7H22V4H4z"
    })), children);
  });
  var FirewallClassic24 = /*#__PURE__*/React__default['default'].forwardRef(function FirewallClassic24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$j || (_path106$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20V17a4 4 0 00-8 0v3a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 0028 20zm-6-3a2 2 0 014 0v3H22zm6 11H20V22h8zM15 27H4a2 2 0 01-2-2V22a2 2 0 012-2H15v2H4v3H15zM17 18H8a2 2 0 01-2-2V13a2 2 0 012-2H19v2H8v3h9zM22 9H4A2 2 0 012 7V4A2 2 0 014 2H22a2 2 0 012 2V7A2 2 0 0122 9zM4 7H22V4H4z"
    })), children);
  });
  var FirewallClassic20 = /*#__PURE__*/React__default['default'].forwardRef(function FirewallClassic20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$j || (_path107$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20V17a4 4 0 00-8 0v3a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 0028 20zm-6-3a2 2 0 014 0v3H22zm6 11H20V22h8zM15 27H4a2 2 0 01-2-2V22a2 2 0 012-2H15v2H4v3H15zM17 18H8a2 2 0 01-2-2V13a2 2 0 012-2H19v2H8v3h9zM22 9H4A2 2 0 012 7V4A2 2 0 014 2H22a2 2 0 012 2V7A2 2 0 0122 9zM4 7H22V4H4z"
    })), children);
  });
  var FirewallClassic16 = /*#__PURE__*/React__default['default'].forwardRef(function FirewallClassic16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$j || (_path108$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20V17a4 4 0 00-8 0v3a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h8a2.0023 2.0023 0 002-2V22A2.0023 2.0023 0 0028 20zm-6-3a2 2 0 014 0v3H22zm6 11H20V22h8zM15 27H4a2 2 0 01-2-2V22a2 2 0 012-2H15v2H4v3H15zM17 18H8a2 2 0 01-2-2V13a2 2 0 012-2H19v2H8v3h9zM22 9H4A2 2 0 012 7V4A2 2 0 014 2H22a2 2 0 012 2V7A2 2 0 0122 9zM4 7H22V4H4z"
    })), children);
  });
  var Fish32 = /*#__PURE__*/React__default['default'].forwardRef(function Fish32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$g || (_circle5$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "7",
      r: "1"
    })), _path109$j || (_path109$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"
    })), children);
  });
  var Fish24 = /*#__PURE__*/React__default['default'].forwardRef(function Fish24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$g || (_circle6$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "7",
      r: "1"
    })), _path110$j || (_path110$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"
    })), children);
  });
  var Fish20 = /*#__PURE__*/React__default['default'].forwardRef(function Fish20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$g || (_circle7$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "7",
      r: "1"
    })), _path111$j || (_path111$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"
    })), children);
  });
  var Fish16 = /*#__PURE__*/React__default['default'].forwardRef(function Fish16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$g || (_circle8$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "7",
      r: "1"
    })), _path112$j || (_path112$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"
    })), children);
  });
  var FishMultiple32 = /*#__PURE__*/React__default['default'].forwardRef(function FishMultiple32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$j || (_path113$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"
    })), _circle9$g || (_circle9$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "11",
      r: "1"
    })), _path114$j || (_path114$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"
    })), _circle10$g || (_circle10$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "11",
      r: "1"
    })), _circle11$f || (_circle11$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _path115$j || (_path115$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"
    })), children);
  });
  var FishMultiple24 = /*#__PURE__*/React__default['default'].forwardRef(function FishMultiple24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$j || (_path116$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"
    })), _circle12$f || (_circle12$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "11",
      r: "1"
    })), _path117$j || (_path117$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"
    })), _circle13$f || (_circle13$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "11",
      r: "1"
    })), _circle14$f || (_circle14$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _path118$j || (_path118$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"
    })), children);
  });
  var FishMultiple20 = /*#__PURE__*/React__default['default'].forwardRef(function FishMultiple20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$j || (_path119$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"
    })), _circle15$f || (_circle15$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "11",
      r: "1"
    })), _path120$j || (_path120$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"
    })), _circle16$f || (_circle16$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "11",
      r: "1"
    })), _circle17$e || (_circle17$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _path121$j || (_path121$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"
    })), children);
  });
  var FishMultiple16 = /*#__PURE__*/React__default['default'].forwardRef(function FishMultiple16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$j || (_path122$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"
    })), _circle18$e || (_circle18$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "11",
      r: "1"
    })), _path123$j || (_path123$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"
    })), _circle19$e || (_circle19$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "11",
      r: "1"
    })), _circle20$e || (_circle20$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "11",
      r: "1"
    })), _path124$j || (_path124$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"
    })), children);
  });
  var FitToHeight32 = /*#__PURE__*/React__default['default'].forwardRef(function FitToHeight32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$j || (_path125$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 10L12.41 11.41 15 8.83 15 23.17 12.41 20.59 11 22 16 27 21 22 19.59 20.59 17 23.17 17 8.83 19.59 11.41 21 10 16 5 11 10z"
    })), _path126$j || (_path126$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToHeight24 = /*#__PURE__*/React__default['default'].forwardRef(function FitToHeight24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$j || (_path127$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 10L12.41 11.41 15 8.83 15 23.17 12.41 20.59 11 22 16 27 21 22 19.59 20.59 17 23.17 17 8.83 19.59 11.41 21 10 16 5 11 10z"
    })), _path128$j || (_path128$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToHeight20 = /*#__PURE__*/React__default['default'].forwardRef(function FitToHeight20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$j || (_path129$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 10L12.41 11.41 15 8.83 15 23.17 12.41 20.59 11 22 16 27 21 22 19.59 20.59 17 23.17 17 8.83 19.59 11.41 21 10 16 5 11 10z"
    })), _path130$j || (_path130$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToHeight16 = /*#__PURE__*/React__default['default'].forwardRef(function FitToHeight16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$j || (_path131$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 10L12.41 11.41 15 8.83 15 23.17 12.41 20.59 11 22 16 27 21 22 19.59 20.59 17 23.17 17 8.83 19.59 11.41 21 10 16 5 11 10z"
    })), _path132$j || (_path132$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToScreen32 = /*#__PURE__*/React__default['default'].forwardRef(function FitToScreen32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$j || (_path133$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"
    })), _path134$j || (_path134$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var FitToScreen24 = /*#__PURE__*/React__default['default'].forwardRef(function FitToScreen24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$j || (_path135$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"
    })), _path136$j || (_path136$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var FitToScreen20 = /*#__PURE__*/React__default['default'].forwardRef(function FitToScreen20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$j || (_path137$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"
    })), _path138$j || (_path138$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var FitToScreen16 = /*#__PURE__*/React__default['default'].forwardRef(function FitToScreen16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$j || (_path139$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"
    })), _path140$j || (_path140$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var FitToWidth32 = /*#__PURE__*/React__default['default'].forwardRef(function FitToWidth32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$j || (_path141$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L20.59 12.41 23.17 15 8.83 15 11.41 12.41 10 11 5 16 10 21 11.41 19.59 8.83 17 23.17 17 20.59 19.59 22 21 27 16 22 11z"
    })), _path142$j || (_path142$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToWidth24 = /*#__PURE__*/React__default['default'].forwardRef(function FitToWidth24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$j || (_path143$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L20.59 12.41 23.17 15 8.83 15 11.41 12.41 10 11 5 16 10 21 11.41 19.59 8.83 17 23.17 17 20.59 19.59 22 21 27 16 22 11z"
    })), _path144$j || (_path144$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToWidth20 = /*#__PURE__*/React__default['default'].forwardRef(function FitToWidth20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$j || (_path145$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L20.59 12.41 23.17 15 8.83 15 11.41 12.41 10 11 5 16 10 21 11.41 19.59 8.83 17 23.17 17 20.59 19.59 22 21 27 16 22 11z"
    })), _path146$j || (_path146$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var FitToWidth16 = /*#__PURE__*/React__default['default'].forwardRef(function FitToWidth16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$j || (_path147$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L20.59 12.41 23.17 15 8.83 15 11.41 12.41 10 11 5 16 10 21 11.41 19.59 8.83 17 23.17 17 20.59 19.59 22 21 27 16 22 11z"
    })), _path148$j || (_path148$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var Flag32 = /*#__PURE__*/React__default['default'].forwardRef(function Flag32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$j || (_path149$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"
    })), children);
  });
  var Flag24 = /*#__PURE__*/React__default['default'].forwardRef(function Flag24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$j || (_path150$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"
    })), children);
  });
  var Flag20 = /*#__PURE__*/React__default['default'].forwardRef(function Flag20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$j || (_path151$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"
    })), children);
  });
  var Flag16 = /*#__PURE__*/React__default['default'].forwardRef(function Flag16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$j || (_path152$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"
    })), children);
  });
  var FlagFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FlagFilled32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$j || (_path153$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6Z"
    })), children);
  });
  var FlagFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FlagFilled24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$j || (_path154$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6Z"
    })), children);
  });
  var FlagFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FlagFilled20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$j || (_path155$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6Z"
    })), children);
  });
  var FlagFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FlagFilled16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$j || (_path156$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H4V2H28l-5.8,9L28,20H6Z"
    })), children);
  });
  var FlaggingTaxi32 = /*#__PURE__*/React__default['default'].forwardRef(function FlaggingTaxi32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$j || (_path157$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"
    })), _path158$j || (_path158$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"
    })), children);
  });
  var FlaggingTaxi24 = /*#__PURE__*/React__default['default'].forwardRef(function FlaggingTaxi24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$j || (_path159$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"
    })), _path160$j || (_path160$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"
    })), children);
  });
  var FlaggingTaxi20 = /*#__PURE__*/React__default['default'].forwardRef(function FlaggingTaxi20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$j || (_path161$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"
    })), _path162$j || (_path162$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"
    })), children);
  });
  var FlaggingTaxi16 = /*#__PURE__*/React__default['default'].forwardRef(function FlaggingTaxi16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$j || (_path163$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"
    })), _path164$j || (_path164$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"
    })), children);
  });
  var Flash32 = /*#__PURE__*/React__default['default'].forwardRef(function Flash32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$j || (_path165$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Flash24 = /*#__PURE__*/React__default['default'].forwardRef(function Flash24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$j || (_path166$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Flash20 = /*#__PURE__*/React__default['default'].forwardRef(function Flash20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$j || (_path167$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Flash16 = /*#__PURE__*/React__default['default'].forwardRef(function Flash16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$j || (_path168$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var FlashFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FlashFilled32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$j || (_path169$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"
    })), children);
  });
  var FlashFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FlashFilled24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$j || (_path170$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"
    })), children);
  });
  var FlashFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FlashFilled20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$j || (_path171$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"
    })), children);
  });
  var FlashFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FlashFilled16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$j || (_path172$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"
    })), children);
  });
  var FlashOff32 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOff32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$j || (_path173$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"
    })), children);
  });
  var FlashOff24 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOff24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$j || (_path174$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"
    })), children);
  });
  var FlashOff20 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOff20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$j || (_path175$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"
    })), children);
  });
  var FlashOff16 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOff16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$j || (_path176$j = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"
    })), children);
  });
  var FlashOffFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOffFilled32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$i || (_path177$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77l-.3 1.3z"
    })), children);
  });
  var FlashOffFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOffFilled24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$i || (_path178$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77l-.3 1.3z"
    })), children);
  });
  var FlashOffFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOffFilled20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$i || (_path179$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77l-.3 1.3z"
    })), children);
  });
  var FlashOffFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function FlashOffFilled16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$i || (_path180$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 008 17h4.83L11 28.85a1 1 0 00.6 1.07A1.09 1.09 0 0012 30a1 1 0 00.79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 00.11-1A1 1 0 0025 11H20.25L22 3.22a1 1 0 00-.2-.85A1 1 0 0021 2H11a1 1 0 00-1 .77l-.3 1.3z"
    })), children);
  });
  var FlightInternational32 = /*#__PURE__*/React__default['default'].forwardRef(function FlightInternational32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$i || (_path181$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a5.3257,5.3257,0,0,1-.6714-.044A21.7855,21.7855,0,0,1,12.0332,17H29.95c.0236-.3315.05-.6626.05-1A14,14,0,1,0,16,30ZM27.9492,15H21.9631A24.3247,24.3247,0,0,0,19.21,4.4492,12.0123,12.0123,0,0,1,27.9492,15ZM16.6714,4.0439A21.7855,21.7855,0,0,1,19.9668,15H12.0332A21.7855,21.7855,0,0,1,15.3286,4.0439,5.159,5.159,0,0,1,16.6714,4.0439ZM12.79,4.4492A24.3275,24.3275,0,0,0,10.0369,15H4.0508A12.0126,12.0126,0,0,1,12.79,4.4492ZM4.0508,17h5.9861A24.3275,24.3275,0,0,0,12.79,27.5508,12.0126,12.0126,0,0,1,4.0508,17Z"
    })), _path182$i || (_path182$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,25l5,2V25l-5-2.5V20a1,1,0,0,0-2,0v2.5L18,25v2l5-2v3.5L21,30v1l3-1,3,1V30l-2-1.5Z"
    })), children);
  });
  var FlightInternational24 = /*#__PURE__*/React__default['default'].forwardRef(function FlightInternational24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$i || (_path183$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a5.3257,5.3257,0,0,1-.6714-.044A21.7855,21.7855,0,0,1,12.0332,17H29.95c.0236-.3315.05-.6626.05-1A14,14,0,1,0,16,30ZM27.9492,15H21.9631A24.3247,24.3247,0,0,0,19.21,4.4492,12.0123,12.0123,0,0,1,27.9492,15ZM16.6714,4.0439A21.7855,21.7855,0,0,1,19.9668,15H12.0332A21.7855,21.7855,0,0,1,15.3286,4.0439,5.159,5.159,0,0,1,16.6714,4.0439ZM12.79,4.4492A24.3275,24.3275,0,0,0,10.0369,15H4.0508A12.0126,12.0126,0,0,1,12.79,4.4492ZM4.0508,17h5.9861A24.3275,24.3275,0,0,0,12.79,27.5508,12.0126,12.0126,0,0,1,4.0508,17Z"
    })), _path184$i || (_path184$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,25l5,2V25l-5-2.5V20a1,1,0,0,0-2,0v2.5L18,25v2l5-2v3.5L21,30v1l3-1,3,1V30l-2-1.5Z"
    })), children);
  });
  var FlightInternational20 = /*#__PURE__*/React__default['default'].forwardRef(function FlightInternational20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$i || (_path185$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a5.3257,5.3257,0,0,1-.6714-.044A21.7855,21.7855,0,0,1,12.0332,17H29.95c.0236-.3315.05-.6626.05-1A14,14,0,1,0,16,30ZM27.9492,15H21.9631A24.3247,24.3247,0,0,0,19.21,4.4492,12.0123,12.0123,0,0,1,27.9492,15ZM16.6714,4.0439A21.7855,21.7855,0,0,1,19.9668,15H12.0332A21.7855,21.7855,0,0,1,15.3286,4.0439,5.159,5.159,0,0,1,16.6714,4.0439ZM12.79,4.4492A24.3275,24.3275,0,0,0,10.0369,15H4.0508A12.0126,12.0126,0,0,1,12.79,4.4492ZM4.0508,17h5.9861A24.3275,24.3275,0,0,0,12.79,27.5508,12.0126,12.0126,0,0,1,4.0508,17Z"
    })), _path186$i || (_path186$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,25l5,2V25l-5-2.5V20a1,1,0,0,0-2,0v2.5L18,25v2l5-2v3.5L21,30v1l3-1,3,1V30l-2-1.5Z"
    })), children);
  });
  var FlightInternational16 = /*#__PURE__*/React__default['default'].forwardRef(function FlightInternational16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$i || (_path187$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a5.3257,5.3257,0,0,1-.6714-.044A21.7855,21.7855,0,0,1,12.0332,17H29.95c.0236-.3315.05-.6626.05-1A14,14,0,1,0,16,30ZM27.9492,15H21.9631A24.3247,24.3247,0,0,0,19.21,4.4492,12.0123,12.0123,0,0,1,27.9492,15ZM16.6714,4.0439A21.7855,21.7855,0,0,1,19.9668,15H12.0332A21.7855,21.7855,0,0,1,15.3286,4.0439,5.159,5.159,0,0,1,16.6714,4.0439ZM12.79,4.4492A24.3275,24.3275,0,0,0,10.0369,15H4.0508A12.0126,12.0126,0,0,1,12.79,4.4492ZM4.0508,17h5.9861A24.3275,24.3275,0,0,0,12.79,27.5508,12.0126,12.0126,0,0,1,4.0508,17Z"
    })), _path188$i || (_path188$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,25l5,2V25l-5-2.5V20a1,1,0,0,0-2,0v2.5L18,25v2l5-2v3.5L21,30v1l3-1,3,1V30l-2-1.5Z"
    })), children);
  });
  var FlightRoster32 = /*#__PURE__*/React__default['default'].forwardRef(function FlightRoster32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$i || (_path189$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6V26a2,2,0,0,0,2,2h8V26H8V6H24v6h2Z"
    })), _path190$i || (_path190$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H16V20H10zM10 14H22V16H10z"
    })), _path191$i || (_path191$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M22 10v2H10V10zM25 23l5 2V23l-5-2.5V18a1 1 0 00-2 0v2.5L18 23v2l5-2v3.5L21 28v1l3-1 3 1V28l-2-1.5z"
    })), children);
  });
  var FlightRoster24 = /*#__PURE__*/React__default['default'].forwardRef(function FlightRoster24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$j);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$i || (_path192$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6V26a2,2,0,0,0,2,2h8V26H8V6H24v6h2Z"
    })), _path193$i || (_path193$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H16V20H10zM10 14H22V16H10z"
    })), _path194$i || (_path194$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M22 10v2H10V10zM25 23l5 2V23l-5-2.5V18a1 1 0 00-2 0v2.5L18 23v2l5-2v3.5L21 28v1l3-1 3 1V28l-2-1.5z"
    })), children);
  });
  var FlightRoster20 = /*#__PURE__*/React__default['default'].forwardRef(function FlightRoster20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$i || (_path195$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6V26a2,2,0,0,0,2,2h8V26H8V6H24v6h2Z"
    })), _path196$i || (_path196$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H16V20H10zM10 14H22V16H10z"
    })), _path197$i || (_path197$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M22 10v2H10V10zM25 23l5 2V23l-5-2.5V18a1 1 0 00-2 0v2.5L18 23v2l5-2v3.5L21 28v1l3-1 3 1V28l-2-1.5z"
    })), children);
  });
  var FlightRoster16 = /*#__PURE__*/React__default['default'].forwardRef(function FlightRoster16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$i || (_path198$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6V26a2,2,0,0,0,2,2h8V26H8V6H24v6h2Z"
    })), _path199$i || (_path199$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H16V20H10zM10 14H22V16H10z"
    })), _path200$i || (_path200$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M22 10v2H10V10zM25 23l5 2V23l-5-2.5V18a1 1 0 00-2 0v2.5L18 23v2l5-2v3.5L21 28v1l3-1 3 1V28l-2-1.5z"
    })), children);
  });
  var FlightSchedule32 = /*#__PURE__*/React__default['default'].forwardRef(function FlightSchedule32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$i || (_path201$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,23l5,2V23l-5-2.5V18a1,1,0,0,0-2,0v2.5L18,23v2l5-2v3.5L21,28v1l3-1,3,1V28l-2-1.5Z"
    })), _path202$i || (_path202$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16V26H6V6h4V8h2V6h8V8h2V6h4v7h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var FlightSchedule24 = /*#__PURE__*/React__default['default'].forwardRef(function FlightSchedule24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$i || (_path203$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,23l5,2V23l-5-2.5V18a1,1,0,0,0-2,0v2.5L18,23v2l5-2v3.5L21,28v1l3-1,3,1V28l-2-1.5Z"
    })), _path204$i || (_path204$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16V26H6V6h4V8h2V6h8V8h2V6h4v7h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var FlightSchedule20 = /*#__PURE__*/React__default['default'].forwardRef(function FlightSchedule20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$i || (_path205$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,23l5,2V23l-5-2.5V18a1,1,0,0,0-2,0v2.5L18,23v2l5-2v3.5L21,28v1l3-1,3,1V28l-2-1.5Z"
    })), _path206$i || (_path206$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16V26H6V6h4V8h2V6h8V8h2V6h4v7h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var FlightSchedule16 = /*#__PURE__*/React__default['default'].forwardRef(function FlightSchedule16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$i || (_path207$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M25,23l5,2V23l-5-2.5V18a1,1,0,0,0-2,0v2.5L18,23v2l5-2v3.5L21,28v1l3-1,3,1V28l-2-1.5Z"
    })), _path208$i || (_path208$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16V26H6V6h4V8h2V6h8V8h2V6h4v7h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var FloatingIp32 = /*#__PURE__*/React__default['default'].forwardRef(function FloatingIp32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$i || (_path209$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11a5.0083,5.0083,0,0,0-4.8989,4H11.8989a5,5,0,1,0,0,2h8.2022A5,5,0,1,0,25,11Zm0,8a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,19Z"
    })), children);
  });
  var FloatingIp24 = /*#__PURE__*/React__default['default'].forwardRef(function FloatingIp24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$i || (_path210$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11a5.0083,5.0083,0,0,0-4.8989,4H11.8989a5,5,0,1,0,0,2h8.2022A5,5,0,1,0,25,11Zm0,8a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,19Z"
    })), children);
  });
  var FloatingIp20 = /*#__PURE__*/React__default['default'].forwardRef(function FloatingIp20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$i || (_path211$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11a5.0083,5.0083,0,0,0-4.8989,4H11.8989a5,5,0,1,0,0,2h8.2022A5,5,0,1,0,25,11Zm0,8a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,19Z"
    })), children);
  });
  var FloatingIp16 = /*#__PURE__*/React__default['default'].forwardRef(function FloatingIp16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$i || (_path212$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,11a5.0083,5.0083,0,0,0-4.8989,4H11.8989a5,5,0,1,0,0,2h8.2022A5,5,0,1,0,25,11Zm0,8a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,25,19Z"
    })), children);
  });
  var Flood32 = /*#__PURE__*/React__default['default'].forwardRef(function Flood32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$i || (_path213$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 28a2.8828 2.8828 0 01-1-.1816v-.0059a3.7662 3.7662 0 01-2.0532-2.1338A.971.971 0 0025 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0121 28a3.44 3.44 0 01-3.0532-2.3213A.9894.9894 0 0017 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0113 28a3.44 3.44 0 01-3.0532-2.3213 1 1 0 00-1.8955.0049A3.4376 3.4376 0 015 28H2v2H5a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0 5.1433 5.1433 0 002.1379 1.62A4.8374 4.8374 0 0029 30h1V28zM28 13.63L29.7573 15 31 13.4282 16.6123 2.2139a1.0094 1.0094 0 00-1.2427 0L1 13.4194l1.2427 1.5718L4 13.6211v5.1875a3.6907 3.6907 0 01-2 2.0039V22.896a4.9958 4.9958 0 003-1.8833 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0025 23h5V21H28zm-6.0513 5.0532a1 1 0 00-1.8955-.0049A3.44 3.44 0 0117 21a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0013 18a.9894.9894 0 00-.9468.6787A3.44 3.44 0 019 21a3.37 3.37 0 01-3.0021-2.19L6 12.0615l9.991-7.79L26 12.0718 26.0017 21H25A3.4376 3.4376 0 0121.9487 18.6836z"
    })), children);
  });
  var Flood24 = /*#__PURE__*/React__default['default'].forwardRef(function Flood24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$i || (_path214$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 28a2.8828 2.8828 0 01-1-.1816v-.0059a3.7662 3.7662 0 01-2.0532-2.1338A.971.971 0 0025 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0121 28a3.44 3.44 0 01-3.0532-2.3213A.9894.9894 0 0017 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0113 28a3.44 3.44 0 01-3.0532-2.3213 1 1 0 00-1.8955.0049A3.4376 3.4376 0 015 28H2v2H5a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0 5.1433 5.1433 0 002.1379 1.62A4.8374 4.8374 0 0029 30h1V28zM28 13.63L29.7573 15 31 13.4282 16.6123 2.2139a1.0094 1.0094 0 00-1.2427 0L1 13.4194l1.2427 1.5718L4 13.6211v5.1875a3.6907 3.6907 0 01-2 2.0039V22.896a4.9958 4.9958 0 003-1.8833 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0025 23h5V21H28zm-6.0513 5.0532a1 1 0 00-1.8955-.0049A3.44 3.44 0 0117 21a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0013 18a.9894.9894 0 00-.9468.6787A3.44 3.44 0 019 21a3.37 3.37 0 01-3.0021-2.19L6 12.0615l9.991-7.79L26 12.0718 26.0017 21H25A3.4376 3.4376 0 0121.9487 18.6836z"
    })), children);
  });
  var Flood20 = /*#__PURE__*/React__default['default'].forwardRef(function Flood20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$i || (_path215$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 28a2.8828 2.8828 0 01-1-.1816v-.0059a3.7662 3.7662 0 01-2.0532-2.1338A.971.971 0 0025 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0121 28a3.44 3.44 0 01-3.0532-2.3213A.9894.9894 0 0017 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0113 28a3.44 3.44 0 01-3.0532-2.3213 1 1 0 00-1.8955.0049A3.4376 3.4376 0 015 28H2v2H5a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0 5.1433 5.1433 0 002.1379 1.62A4.8374 4.8374 0 0029 30h1V28zM28 13.63L29.7573 15 31 13.4282 16.6123 2.2139a1.0094 1.0094 0 00-1.2427 0L1 13.4194l1.2427 1.5718L4 13.6211v5.1875a3.6907 3.6907 0 01-2 2.0039V22.896a4.9958 4.9958 0 003-1.8833 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0025 23h5V21H28zm-6.0513 5.0532a1 1 0 00-1.8955-.0049A3.44 3.44 0 0117 21a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0013 18a.9894.9894 0 00-.9468.6787A3.44 3.44 0 019 21a3.37 3.37 0 01-3.0021-2.19L6 12.0615l9.991-7.79L26 12.0718 26.0017 21H25A3.4376 3.4376 0 0121.9487 18.6836z"
    })), children);
  });
  var Flood16 = /*#__PURE__*/React__default['default'].forwardRef(function Flood16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$i || (_path216$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 28a2.8828 2.8828 0 01-1-.1816v-.0059a3.7662 3.7662 0 01-2.0532-2.1338A.971.971 0 0025 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0121 28a3.44 3.44 0 01-3.0532-2.3213A.9894.9894 0 0017 25a1.007 1.007 0 00-.9487.6836A3.4376 3.4376 0 0113 28a3.44 3.44 0 01-3.0532-2.3213 1 1 0 00-1.8955.0049A3.4376 3.4376 0 015 28H2v2H5a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0 5.1433 5.1433 0 002.1379 1.62A4.8374 4.8374 0 0029 30h1V28zM28 13.63L29.7573 15 31 13.4282 16.6123 2.2139a1.0094 1.0094 0 00-1.2427 0L1 13.4194l1.2427 1.5718L4 13.6211v5.1875a3.6907 3.6907 0 01-2 2.0039V22.896a4.9958 4.9958 0 003-1.8833 5.0192 5.0192 0 008 0 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0025 23h5V21H28zm-6.0513 5.0532a1 1 0 00-1.8955-.0049A3.44 3.44 0 0117 21a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0013 18a.9894.9894 0 00-.9468.6787A3.44 3.44 0 019 21a3.37 3.37 0 01-3.0021-2.19L6 12.0615l9.991-7.79L26 12.0718 26.0017 21H25A3.4376 3.4376 0 0121.9487 18.6836z"
    })), children);
  });
  var FloodWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function FloodWarning32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$i || (_path217$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,28a2.8828,2.8828,0,0,1-1-.1816v-.0059a3.7662,3.7662,0,0,1-2.0532-2.1338A.971.971,0,0,0,25,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,21,28a3.44,3.44,0,0,1-3.0532-2.3213A.9894.9894,0,0,0,17,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,13,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,5,28H2v2H5a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0,5.1433,5.1433,0,0,0,2.1379,1.62A4.8374,4.8374,0,0,0,29,30h1V28Z"
    })), _path218$i || (_path218$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,11h-1.5V7h1.5ZM23,12a1,1,0,1,0,1,1A1,1,0,0,0,23,12Z"
    })), _path219$i || (_path219$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,14.9355,23.6284,3.3706a.7181.7181,0,0,0-1.2568,0L16.0885,14.9355A.72.72,0,0,0,16.72,16H29.28A.72.72,0,0,0,29.9115,14.9355ZM22.25,7h1.5v4h-1.5ZM23,14a1,1,0,1,1,1-1A1,1,0,0,1,23,14Z"
    })), _path220$i || (_path220$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18H26v3H25a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,17,21a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,13,18a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,9,21a3.3663,3.3663,0,0,1-3-2.1855v-6.753l10-7.79,2.5327,1.9756.9682-1.7818L16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211v5.1875a3.6892,3.6892,0,0,1-2,2.0039V22.896a4.9958,4.9958,0,0,0,3-1.8833,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,25,23h5V21Z"
    })), children);
  });
  var FloodWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function FloodWarning24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$i || (_path221$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,28a2.8828,2.8828,0,0,1-1-.1816v-.0059a3.7662,3.7662,0,0,1-2.0532-2.1338A.971.971,0,0,0,25,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,21,28a3.44,3.44,0,0,1-3.0532-2.3213A.9894.9894,0,0,0,17,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,13,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,5,28H2v2H5a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0,5.1433,5.1433,0,0,0,2.1379,1.62A4.8374,4.8374,0,0,0,29,30h1V28Z"
    })), _path222$i || (_path222$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,11h-1.5V7h1.5ZM23,12a1,1,0,1,0,1,1A1,1,0,0,0,23,12Z"
    })), _path223$i || (_path223$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,14.9355,23.6284,3.3706a.7181.7181,0,0,0-1.2568,0L16.0885,14.9355A.72.72,0,0,0,16.72,16H29.28A.72.72,0,0,0,29.9115,14.9355ZM22.25,7h1.5v4h-1.5ZM23,14a1,1,0,1,1,1-1A1,1,0,0,1,23,14Z"
    })), _path224$i || (_path224$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18H26v3H25a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,17,21a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,13,18a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,9,21a3.3663,3.3663,0,0,1-3-2.1855v-6.753l10-7.79,2.5327,1.9756.9682-1.7818L16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211v5.1875a3.6892,3.6892,0,0,1-2,2.0039V22.896a4.9958,4.9958,0,0,0,3-1.8833,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,25,23h5V21Z"
    })), children);
  });
  var FloodWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function FloodWarning20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$i || (_path225$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,28a2.8828,2.8828,0,0,1-1-.1816v-.0059a3.7662,3.7662,0,0,1-2.0532-2.1338A.971.971,0,0,0,25,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,21,28a3.44,3.44,0,0,1-3.0532-2.3213A.9894.9894,0,0,0,17,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,13,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,5,28H2v2H5a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0,5.1433,5.1433,0,0,0,2.1379,1.62A4.8374,4.8374,0,0,0,29,30h1V28Z"
    })), _path226$i || (_path226$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,11h-1.5V7h1.5ZM23,12a1,1,0,1,0,1,1A1,1,0,0,0,23,12Z"
    })), _path227$i || (_path227$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,14.9355,23.6284,3.3706a.7181.7181,0,0,0-1.2568,0L16.0885,14.9355A.72.72,0,0,0,16.72,16H29.28A.72.72,0,0,0,29.9115,14.9355ZM22.25,7h1.5v4h-1.5ZM23,14a1,1,0,1,1,1-1A1,1,0,0,1,23,14Z"
    })), _path228$i || (_path228$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18H26v3H25a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,17,21a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,13,18a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,9,21a3.3663,3.3663,0,0,1-3-2.1855v-6.753l10-7.79,2.5327,1.9756.9682-1.7818L16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211v5.1875a3.6892,3.6892,0,0,1-2,2.0039V22.896a4.9958,4.9958,0,0,0,3-1.8833,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,25,23h5V21Z"
    })), children);
  });
  var FloodWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function FloodWarning16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$i || (_path229$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,28a2.8828,2.8828,0,0,1-1-.1816v-.0059a3.7662,3.7662,0,0,1-2.0532-2.1338A.971.971,0,0,0,25,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,21,28a3.44,3.44,0,0,1-3.0532-2.3213A.9894.9894,0,0,0,17,25a1.007,1.007,0,0,0-.9487.6836A3.4376,3.4376,0,0,1,13,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,5,28H2v2H5a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0,5.1433,5.1433,0,0,0,2.1379,1.62A4.8374,4.8374,0,0,0,29,30h1V28Z"
    })), _path230$i || (_path230$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,11h-1.5V7h1.5ZM23,12a1,1,0,1,0,1,1A1,1,0,0,0,23,12Z"
    })), _path231$i || (_path231$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,14.9355,23.6284,3.3706a.7181.7181,0,0,0-1.2568,0L16.0885,14.9355A.72.72,0,0,0,16.72,16H29.28A.72.72,0,0,0,29.9115,14.9355ZM22.25,7h1.5v4h-1.5ZM23,14a1,1,0,1,1,1-1A1,1,0,0,1,23,14Z"
    })), _path232$i || (_path232$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21V18H26v3H25a3.4376,3.4376,0,0,1-3.0513-2.3164,1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,17,21a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,13,18a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,9,21a3.3663,3.3663,0,0,1-3-2.1855v-6.753l10-7.79,2.5327,1.9756.9682-1.7818L16.6123,2.2139a1.0094,1.0094,0,0,0-1.2427,0L1,13.4194l1.2427,1.5718L4,13.6211v5.1875a3.6892,3.6892,0,0,1-2,2.0039V22.896a4.9958,4.9958,0,0,0,3-1.8833,5.0192,5.0192,0,0,0,8,0,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,25,23h5V21Z"
    })), children);
  });
  var Flow32 = /*#__PURE__*/React__default['default'].forwardRef(function Flow32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$i || (_path233$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Flow24 = /*#__PURE__*/React__default['default'].forwardRef(function Flow24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$i || (_path234$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Flow20 = /*#__PURE__*/React__default['default'].forwardRef(function Flow20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$i || (_path235$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var Flow16 = /*#__PURE__*/React__default['default'].forwardRef(function Flow16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$i || (_path236$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), children);
  });
  var FlowConnection32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowConnection32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$i || (_path237$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H22a2.0023,2.0023,0,0,0-2,2v2H14.4141L10,17.5859V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4v6a2.0023,2.0023,0,0,0,2,2H8v5.5859L3.293,22.293a.9994.9994,0,0,0,0,1.414l5,5a.9995.9995,0,0,0,1.414,0L14.4141,24H20v2a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18ZM6,4h6v6H6ZM9,26.5859,5.4141,23,9,19.4141,12.5859,23ZM22,26V20h6v6Z"
    })), children);
  });
  var FlowConnection24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowConnection24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$i || (_path238$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H22a2.0023,2.0023,0,0,0-2,2v2H14.4141L10,17.5859V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4v6a2.0023,2.0023,0,0,0,2,2H8v5.5859L3.293,22.293a.9994.9994,0,0,0,0,1.414l5,5a.9995.9995,0,0,0,1.414,0L14.4141,24H20v2a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18ZM6,4h6v6H6ZM9,26.5859,5.4141,23,9,19.4141,12.5859,23ZM22,26V20h6v6Z"
    })), children);
  });
  var FlowConnection20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowConnection20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$i || (_path239$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H22a2.0023,2.0023,0,0,0-2,2v2H14.4141L10,17.5859V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4v6a2.0023,2.0023,0,0,0,2,2H8v5.5859L3.293,22.293a.9994.9994,0,0,0,0,1.414l5,5a.9995.9995,0,0,0,1.414,0L14.4141,24H20v2a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18ZM6,4h6v6H6ZM9,26.5859,5.4141,23,9,19.4141,12.5859,23ZM22,26V20h6v6Z"
    })), children);
  });
  var FlowConnection16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowConnection16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$i || (_path240$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18H22a2.0023,2.0023,0,0,0-2,2v2H14.4141L10,17.5859V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4v6a2.0023,2.0023,0,0,0,2,2H8v5.5859L3.293,22.293a.9994.9994,0,0,0,0,1.414l5,5a.9995.9995,0,0,0,1.414,0L14.4141,24H20v2a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V20A2.0023,2.0023,0,0,0,28,18ZM6,4h6v6H6ZM9,26.5859,5.4141,23,9,19.4141,12.5859,23ZM22,26V20h6v6Z"
    })), children);
  });
  var FlowData32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowData32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$i || (_path241$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"
    })), children);
  });
  var FlowData24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowData24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$i || (_path242$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"
    })), children);
  });
  var FlowData20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowData20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$i || (_path243$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"
    })), children);
  });
  var FlowData16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowData16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$i || (_path244$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"
    })), children);
  });
  var FlowModeler32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModeler32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$i || (_path245$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 10H2V2h8zM4 8H8V4H4zM30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15v2a4 4 0 000 8H20zM24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12z"
    })), _path246$i || (_path246$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,11H13l-3,4,6,6,6-6Z"
    })), children);
  });
  var FlowModeler24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModeler24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$i || (_path247$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 10H2V2h8zM4 8H8V4H4zM30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15v2a4 4 0 000 8H20zM24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12z"
    })), _path248$i || (_path248$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,11H13l-3,4,6,6,6-6Z"
    })), children);
  });
  var FlowModeler20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModeler20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$i || (_path249$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 10H2V2h8zM4 8H8V4H4zM30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15v2a4 4 0 000 8H20zM24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12z"
    })), _path250$i || (_path250$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,11H13l-3,4,6,6,6-6Z"
    })), children);
  });
  var FlowModeler16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModeler16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$i || (_path251$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 10H2V2h8zM4 8H8V4H4zM30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15v2a4 4 0 000 8H20zM24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12z"
    })), _path252$i || (_path252$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,11H13l-3,4,6,6,6-6Z"
    })), children);
  });
  var FlowModelerReference32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModelerReference32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$i || (_path253$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 11H13l-3 4 6 6 6-6z"
    })), _path254$i || (_path254$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var FlowModelerReference24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModelerReference24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$i || (_path255$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 11H13l-3 4 6 6 6-6z"
    })), _path256$i || (_path256$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var FlowModelerReference20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModelerReference20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$i || (_path257$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 11H13l-3 4 6 6 6-6z"
    })), _path258$i || (_path258$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var FlowModelerReference16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowModelerReference16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$i || (_path259$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 11H13l-3 4 6 6 6-6z"
    })), _path260$i || (_path260$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17V15a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var FlowStream32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStream32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$i || (_path261$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H11.8625a4.13 4.13 0 00-.4284-1.02L21.98 12.4343A3.9943 3.9943 0 1020.1414 8H14v2h6.1414a3.96 3.96 0 00.4243 1.02L10.02 21.5656A3.9943 3.9943 0 1011.8587 26H20v3h8V21H20zM24 7a2 2 0 11-2 2A2.0023 2.0023 0 0124 7zM8 27a2 2 0 112-2A2.0023 2.0023 0 018 27zm14-4h4v4H22zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path262$i || (_path262$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStream24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStream24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$i || (_path263$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H11.8625a4.13 4.13 0 00-.4284-1.02L21.98 12.4343A3.9943 3.9943 0 1020.1414 8H14v2h6.1414a3.96 3.96 0 00.4243 1.02L10.02 21.5656A3.9943 3.9943 0 1011.8587 26H20v3h8V21H20zM24 7a2 2 0 11-2 2A2.0023 2.0023 0 0124 7zM8 27a2 2 0 112-2A2.0023 2.0023 0 018 27zm14-4h4v4H22zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path264$i || (_path264$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStream20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStream20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$i || (_path265$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H11.8625a4.13 4.13 0 00-.4284-1.02L21.98 12.4343A3.9943 3.9943 0 1020.1414 8H14v2h6.1414a3.96 3.96 0 00.4243 1.02L10.02 21.5656A3.9943 3.9943 0 1011.8587 26H20v3h8V21H20zM24 7a2 2 0 11-2 2A2.0023 2.0023 0 0124 7zM8 27a2 2 0 112-2A2.0023 2.0023 0 018 27zm14-4h4v4H22zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path266$i || (_path266$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStream16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStream16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$i || (_path267$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H11.8625a4.13 4.13 0 00-.4284-1.02L21.98 12.4343A3.9943 3.9943 0 1020.1414 8H14v2h6.1414a3.96 3.96 0 00.4243 1.02L10.02 21.5656A3.9943 3.9943 0 1011.8587 26H20v3h8V21H20zM24 7a2 2 0 11-2 2A2.0023 2.0023 0 0124 7zM8 27a2 2 0 112-2A2.0023 2.0023 0 018 27zm14-4h4v4H22zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path268$i || (_path268$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStreamReference32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStreamReference32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$i || (_path269$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H16v2h4v3h8V21H20zm2-1h4v4H22zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 5a3.9962 3.9962 0 00-3.8579 3H14v2h6.1421a3.94 3.94 0 00.4248 1.019L14 17.5862 15.4138 19l6.5672-6.5669A3.9521 3.9521 0 0024 13a4 4 0 000-8zm0 6a2 2 0 112-2A2.0023 2.0023 0 0124 11zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path270$i || (_path270$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStreamReference24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStreamReference24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$i || (_path271$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H16v2h4v3h8V21H20zm2-1h4v4H22zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 5a3.9962 3.9962 0 00-3.8579 3H14v2h6.1421a3.94 3.94 0 00.4248 1.019L14 17.5862 15.4138 19l6.5672-6.5669A3.9521 3.9521 0 0024 13a4 4 0 000-8zm0 6a2 2 0 112-2A2.0023 2.0023 0 0124 11zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path272$i || (_path272$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStreamReference20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStreamReference20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$i || (_path273$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H16v2h4v3h8V21H20zm2-1h4v4H22zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 5a3.9962 3.9962 0 00-3.8579 3H14v2h6.1421a3.94 3.94 0 00.4248 1.019L14 17.5862 15.4138 19l6.5672-6.5669A3.9521 3.9521 0 0024 13a4 4 0 000-8zm0 6a2 2 0 112-2A2.0023 2.0023 0 0124 11zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path274$i || (_path274$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowStreamReference16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowStreamReference16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$i || (_path275$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 24H16v2h4v3h8V21H20zm2-1h4v4H22zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM24 5a3.9962 3.9962 0 00-3.8579 3H14v2h6.1421a3.94 3.94 0 00.4248 1.019L14 17.5862 15.4138 19l6.5672-6.5669A3.9521 3.9521 0 0024 13a4 4 0 000-8zm0 6a2 2 0 112-2A2.0023 2.0023 0 0124 11zM9.6929 12.7505a5 5 0 01-.0005-7.5L11.0166 6.75a3 3 0 00-.0005 4.501z"
    })), _path276$i || (_path276$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.0474,15.751a9,9,0,0,1,0-13.501l1.3232,1.5a7,7,0,0,0,0,10.501Z"
    })), children);
  });
  var FlowLogsVpc32 = /*#__PURE__*/React__default['default'].forwardRef(function FlowLogsVpc32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$i || (_path277$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H30V21H18zM18 23H30V25H18zM18 27H26V29H18z"
    })), _path278$i || (_path278$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4a3.9962,3.9962,0,0,0-3.8579,3H12V4H4v8h8V9h8.1421a3.94,3.94,0,0,0,.4248,1.019L10.019,20.5669A3.9521,3.9521,0,0,0,8,20a4,4,0,1,0,3.8579,5H16V23H11.8579a3.94,3.94,0,0,0-.4248-1.019L21.981,11.4331A3.9521,3.9521,0,0,0,24,12a4,4,0,0,0,0-8ZM10,10H6V6h4ZM8,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,26ZM24,10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,24,10Z"
    })), children);
  });
  var FlowLogsVpc24 = /*#__PURE__*/React__default['default'].forwardRef(function FlowLogsVpc24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$i || (_path279$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H30V21H18zM18 23H30V25H18zM18 27H26V29H18z"
    })), _path280$i || (_path280$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4a3.9962,3.9962,0,0,0-3.8579,3H12V4H4v8h8V9h8.1421a3.94,3.94,0,0,0,.4248,1.019L10.019,20.5669A3.9521,3.9521,0,0,0,8,20a4,4,0,1,0,3.8579,5H16V23H11.8579a3.94,3.94,0,0,0-.4248-1.019L21.981,11.4331A3.9521,3.9521,0,0,0,24,12a4,4,0,0,0,0-8ZM10,10H6V6h4ZM8,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,26ZM24,10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,24,10Z"
    })), children);
  });
  var FlowLogsVpc20 = /*#__PURE__*/React__default['default'].forwardRef(function FlowLogsVpc20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$i || (_path281$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H30V21H18zM18 23H30V25H18zM18 27H26V29H18z"
    })), _path282$i || (_path282$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4a3.9962,3.9962,0,0,0-3.8579,3H12V4H4v8h8V9h8.1421a3.94,3.94,0,0,0,.4248,1.019L10.019,20.5669A3.9521,3.9521,0,0,0,8,20a4,4,0,1,0,3.8579,5H16V23H11.8579a3.94,3.94,0,0,0-.4248-1.019L21.981,11.4331A3.9521,3.9521,0,0,0,24,12a4,4,0,0,0,0-8ZM10,10H6V6h4ZM8,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,26ZM24,10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,24,10Z"
    })), children);
  });
  var FlowLogsVpc16 = /*#__PURE__*/React__default['default'].forwardRef(function FlowLogsVpc16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$i || (_path283$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H30V21H18zM18 23H30V25H18zM18 27H26V29H18z"
    })), _path284$i || (_path284$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,4a3.9962,3.9962,0,0,0-3.8579,3H12V4H4v8h8V9h8.1421a3.94,3.94,0,0,0,.4248,1.019L10.019,20.5669A3.9521,3.9521,0,0,0,8,20a4,4,0,1,0,3.8579,5H16V23H11.8579a3.94,3.94,0,0,0-.4248-1.019L21.981,11.4331A3.9521,3.9521,0,0,0,24,12a4,4,0,0,0,0-8ZM10,10H6V6h4ZM8,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,26ZM24,10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,24,10Z"
    })), children);
  });
  var Fog32 = /*#__PURE__*/React__default['default'].forwardRef(function Fog32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$i || (_path285$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,11.1382a8.9938,8.9938,0,0,0-17.6006,0A6.533,6.533,0,0,0,2,17.5H2V19a1,1,0,0,0,1,1H15a1,1,0,0,0,0-2H4v-.4966H4a4.5176,4.5176,0,0,1,4.144-4.4819l.8155-.064.0991-.812a6.9936,6.9936,0,0,1,13.8838,0l.0986.812.8154.064A4.4962,4.4962,0,0,1,23.5,22H7a1,1,0,0,0,0,2H23.5a6.4963,6.4963,0,0,0,1.3008-12.8618Z"
    })), _rect$3 || (_rect$3 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "18",
      height: "2",
      x: "2",
      y: "26",
      rx: "1"
    })), children);
  });
  var Fog24 = /*#__PURE__*/React__default['default'].forwardRef(function Fog24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$i || (_path286$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,11.1382a8.9938,8.9938,0,0,0-17.6006,0A6.533,6.533,0,0,0,2,17.5H2V19a1,1,0,0,0,1,1H15a1,1,0,0,0,0-2H4v-.4966H4a4.5176,4.5176,0,0,1,4.144-4.4819l.8155-.064.0991-.812a6.9936,6.9936,0,0,1,13.8838,0l.0986.812.8154.064A4.4962,4.4962,0,0,1,23.5,22H7a1,1,0,0,0,0,2H23.5a6.4963,6.4963,0,0,0,1.3008-12.8618Z"
    })), _rect2$3 || (_rect2$3 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "18",
      height: "2",
      x: "2",
      y: "26",
      rx: "1"
    })), children);
  });
  var Fog20 = /*#__PURE__*/React__default['default'].forwardRef(function Fog20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$i || (_path287$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,11.1382a8.9938,8.9938,0,0,0-17.6006,0A6.533,6.533,0,0,0,2,17.5H2V19a1,1,0,0,0,1,1H15a1,1,0,0,0,0-2H4v-.4966H4a4.5176,4.5176,0,0,1,4.144-4.4819l.8155-.064.0991-.812a6.9936,6.9936,0,0,1,13.8838,0l.0986.812.8154.064A4.4962,4.4962,0,0,1,23.5,22H7a1,1,0,0,0,0,2H23.5a6.4963,6.4963,0,0,0,1.3008-12.8618Z"
    })), _rect3$3 || (_rect3$3 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "18",
      height: "2",
      x: "2",
      y: "26",
      rx: "1"
    })), children);
  });
  var Fog16 = /*#__PURE__*/React__default['default'].forwardRef(function Fog16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$i || (_path288$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,11.1382a8.9938,8.9938,0,0,0-17.6006,0A6.533,6.533,0,0,0,2,17.5H2V19a1,1,0,0,0,1,1H15a1,1,0,0,0,0-2H4v-.4966H4a4.5176,4.5176,0,0,1,4.144-4.4819l.8155-.064.0991-.812a6.9936,6.9936,0,0,1,13.8838,0l.0986.812.8154.064A4.4962,4.4962,0,0,1,23.5,22H7a1,1,0,0,0,0,2H23.5a6.4963,6.4963,0,0,0,1.3008-12.8618Z"
    })), _rect4$3 || (_rect4$3 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "18",
      height: "2",
      x: "2",
      y: "26",
      rx: "1"
    })), children);
  });
  var Folder32 = /*#__PURE__*/React__default['default'].forwardRef(function Folder32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$i || (_path289$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"
    })), children);
  });
  var Folder24 = /*#__PURE__*/React__default['default'].forwardRef(function Folder24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$i || (_path290$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"
    })), children);
  });
  var Folder20 = /*#__PURE__*/React__default['default'].forwardRef(function Folder20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$i || (_path291$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"
    })), children);
  });
  var Folder16 = /*#__PURE__*/React__default['default'].forwardRef(function Folder16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$i || (_path292$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"
    })), children);
  });
  var FolderAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderAdd32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$i || (_path293$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24z"
    })), _path294$i || (_path294$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16l-3.4-3.4C12.2,4.2,11.7,4,11.2,4H4C2.9,4,2,4.9,2,6v20c0,1.1,0.9,2,2,2h14v-2H4V6h7.2l3.4,3.4l0.6,0.6H28v8h2v-8\tC30,8.9,29.1,8,28,8z"
    })), children);
  });
  var FolderAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderAdd24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$i || (_path295$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24z"
    })), _path296$i || (_path296$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16l-3.4-3.4C12.2,4.2,11.7,4,11.2,4H4C2.9,4,2,4.9,2,6v20c0,1.1,0.9,2,2,2h14v-2H4V6h7.2l3.4,3.4l0.6,0.6H28v8h2v-8\tC30,8.9,29.1,8,28,8z"
    })), children);
  });
  var FolderAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderAdd20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$i || (_path297$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24z"
    })), _path298$i || (_path298$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16l-3.4-3.4C12.2,4.2,11.7,4,11.2,4H4C2.9,4,2,4.9,2,6v20c0,1.1,0.9,2,2,2h14v-2H4V6h7.2l3.4,3.4l0.6,0.6H28v8h2v-8\tC30,8.9,29.1,8,28,8z"
    })), children);
  });
  var FolderAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderAdd16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$i || (_path299$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24z"
    })), _path300$i || (_path300$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16l-3.4-3.4C12.2,4.2,11.7,4,11.2,4H4C2.9,4,2,4.9,2,6v20c0,1.1,0.9,2,2,2h14v-2H4V6h7.2l3.4,3.4l0.6,0.6H28v8h2v-8\tC30,8.9,29.1,8,28,8z"
    })), children);
  });
  var FolderDetails32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetails32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$i || (_path301$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"
    })), _path302$i || (_path302$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var FolderDetails24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetails24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$i || (_path303$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"
    })), _path304$i || (_path304$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var FolderDetails20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetails20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$i || (_path305$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"
    })), _path306$i || (_path306$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var FolderDetails16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetails16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$i || (_path307$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"
    })), _path308$i || (_path308$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var FolderDetailsReference32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetailsReference32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$i || (_path309$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H23V30H16zM16 24H30V26H16zM16 20H30V22H16zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V18H4V6h7.1716l3.4141 3.4141L15.1716 10H28v8h2V10A2 2 0 0028 8z"
    })), children);
  });
  var FolderDetailsReference24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetailsReference24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$i || (_path310$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H23V30H16zM16 24H30V26H16zM16 20H30V22H16zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V18H4V6h7.1716l3.4141 3.4141L15.1716 10H28v8h2V10A2 2 0 0028 8z"
    })), children);
  });
  var FolderDetailsReference20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetailsReference20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$i || (_path311$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H23V30H16zM16 24H30V26H16zM16 20H30V22H16zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V18H4V6h7.1716l3.4141 3.4141L15.1716 10H28v8h2V10A2 2 0 0028 8z"
    })), children);
  });
  var FolderDetailsReference16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderDetailsReference16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$i || (_path312$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H23V30H16zM16 24H30V26H16zM16 20H30V22H16zM4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V18H4V6h7.1716l3.4141 3.4141L15.1716 10H28v8h2V10A2 2 0 0028 8z"
    })), children);
  });
  var FolderMoveTo32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderMoveTo32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$i || (_path313$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L16.59 14.41 19.17 17 10 17 10 19 19.17 19 16.59 21.59 18 23 23 18 18 13z"
    })), _path314$i || (_path314$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.1716,6l3.4142,3.4142L15.1716,10H28V26H4V6h7.1716m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.5858,4.5858A2,2,0,0,0,11.1716,4Z"
    })), children);
  });
  var FolderMoveTo24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderMoveTo24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$i || (_path315$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L16.59 14.41 19.17 17 10 17 10 19 19.17 19 16.59 21.59 18 23 23 18 18 13z"
    })), _path316$i || (_path316$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.1716,6l3.4142,3.4142L15.1716,10H28V26H4V6h7.1716m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.5858,4.5858A2,2,0,0,0,11.1716,4Z"
    })), children);
  });
  var FolderMoveTo20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderMoveTo20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$i || (_path317$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L16.59 14.41 19.17 17 10 17 10 19 19.17 19 16.59 21.59 18 23 23 18 18 13z"
    })), _path318$i || (_path318$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.1716,6l3.4142,3.4142L15.1716,10H28V26H4V6h7.1716m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.5858,4.5858A2,2,0,0,0,11.1716,4Z"
    })), children);
  });
  var FolderMoveTo16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderMoveTo16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$i || (_path319$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L16.59 14.41 19.17 17 10 17 10 19 19.17 19 16.59 21.59 18 23 23 18 18 13z"
    })), _path320$i || (_path320$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.1716,6l3.4142,3.4142L15.1716,10H28V26H4V6h7.1716m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.5858,4.5858A2,2,0,0,0,11.1716,4Z"
    })), children);
  });
  var FolderOff32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOff32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$i || (_path321$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 002-2V10A2 2 0 0028 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V24H4z"
    })), children);
  });
  var FolderOff24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOff24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$i || (_path322$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 002-2V10A2 2 0 0028 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V24H4z"
    })), children);
  });
  var FolderOff20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOff20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$i || (_path323$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 002-2V10A2 2 0 0028 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V24H4z"
    })), children);
  });
  var FolderOff16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOff16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$i || (_path324$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 002-2V10A2 2 0 0028 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0011.1716 4H4A2 2 0 002 6V24H4z"
    })), children);
  });
  var FolderOpen32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOpen32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$i || (_path325$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H20.8284L17.4143,4.5859A2,2,0,0,0,16,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM8,26V14h8v6.17l-2.59-2.58L12,19l5,5,5-5-1.41-1.41L18,20.17V14a2.0025,2.0025,0,0,0-2-2H8a2.0025,2.0025,0,0,0-2,2V26H4V6H16l4,4h8v2H22v2h6V26Z"
    })), children);
  });
  var FolderOpen24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOpen24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$i || (_path326$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H20.8284L17.4143,4.5859A2,2,0,0,0,16,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM8,26V14h8v6.17l-2.59-2.58L12,19l5,5,5-5-1.41-1.41L18,20.17V14a2.0025,2.0025,0,0,0-2-2H8a2.0025,2.0025,0,0,0-2,2V26H4V6H16l4,4h8v2H22v2h6V26Z"
    })), children);
  });
  var FolderOpen20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOpen20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$i || (_path327$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H20.8284L17.4143,4.5859A2,2,0,0,0,16,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM8,26V14h8v6.17l-2.59-2.58L12,19l5,5,5-5-1.41-1.41L18,20.17V14a2.0025,2.0025,0,0,0-2-2H8a2.0025,2.0025,0,0,0-2,2V26H4V6H16l4,4h8v2H22v2h6V26Z"
    })), children);
  });
  var FolderOpen16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderOpen16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$i || (_path328$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H20.8284L17.4143,4.5859A2,2,0,0,0,16,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM8,26V14h8v6.17l-2.59-2.58L12,19l5,5,5-5-1.41-1.41L18,20.17V14a2.0025,2.0025,0,0,0-2-2H8a2.0025,2.0025,0,0,0-2,2V26H4V6H16l4,4h8v2H22v2h6V26Z"
    })), children);
  });
  var FolderParent32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderParent32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$i || (_path329$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.5857,4.5857A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16a2,2,0,0,0,2-2V16.83l2.59,2.58L22,18l-5-5-5,5,1.41,1.41L16,16.83V26H4V6h7.1716l4,4H28V26H22v2h6a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8Z"
    })), children);
  });
  var FolderParent24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderParent24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$i || (_path330$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.5857,4.5857A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16a2,2,0,0,0,2-2V16.83l2.59,2.58L22,18l-5-5-5,5,1.41,1.41L16,16.83V26H4V6h7.1716l4,4H28V26H22v2h6a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8Z"
    })), children);
  });
  var FolderParent20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderParent20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$i || (_path331$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.5857,4.5857A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16a2,2,0,0,0,2-2V16.83l2.59,2.58L22,18l-5-5-5,5,1.41,1.41L16,16.83V26H4V6h7.1716l4,4H28V26H22v2h6a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8Z"
    })), children);
  });
  var FolderParent16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderParent16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$i || (_path332$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.5857,4.5857A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16a2,2,0,0,0,2-2V16.83l2.59,2.58L22,18l-5-5-5,5,1.41,1.41L16,16.83V26H4V6h7.1716l4,4H28V26H22v2h6a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8Z"
    })), children);
  });
  var FolderShared32 = /*#__PURE__*/React__default['default'].forwardRef(function FolderShared32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$i || (_path333$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"
    })), _path334$i || (_path334$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"
    })), children);
  });
  var FolderShared24 = /*#__PURE__*/React__default['default'].forwardRef(function FolderShared24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$i || (_path335$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"
    })), _path336$i || (_path336$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"
    })), children);
  });
  var FolderShared20 = /*#__PURE__*/React__default['default'].forwardRef(function FolderShared20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$i || (_path337$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"
    })), _path338$h || (_path338$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"
    })), children);
  });
  var FolderShared16 = /*#__PURE__*/React__default['default'].forwardRef(function FolderShared16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$h || (_path339$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"
    })), _path340$h || (_path340$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"
    })), children);
  });
  var Folders32 = /*#__PURE__*/React__default['default'].forwardRef(function Folders32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$h || (_path341$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V11A2.0021 2.0021 0 016 9h5.6665a2.0119 2.0119 0 011.2007.4L16.3335 12H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 011.2007.4L18.3335 7H28z"
    })), children);
  });
  var Folders24 = /*#__PURE__*/React__default['default'].forwardRef(function Folders24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$h || (_path342$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V11A2.0021 2.0021 0 016 9h5.6665a2.0119 2.0119 0 011.2007.4L16.3335 12H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 011.2007.4L18.3335 7H28z"
    })), children);
  });
  var Folders20 = /*#__PURE__*/React__default['default'].forwardRef(function Folders20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$h || (_path343$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V11A2.0021 2.0021 0 016 9h5.6665a2.0119 2.0119 0 011.2007.4L16.3335 12H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 011.2007.4L18.3335 7H28z"
    })), children);
  });
  var Folders16 = /*#__PURE__*/React__default['default'].forwardRef(function Folders16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$h || (_path344$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V11A2.0021 2.0021 0 016 9h5.6665a2.0119 2.0119 0 011.2007.4L16.3335 12H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 011.2007.4L18.3335 7H28z"
    })), children);
  });
  var ForecastHail32 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$h || (_path345$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _circle21$e || (_circle21$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "23.5",
      r: "1.5"
    })), _circle22$e || (_circle22$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "19.5",
      r: "1.5"
    })), _circle23$d || (_circle23$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.5",
      cy: "19.5",
      r: "1.5"
    })), _path346$h || (_path346$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.964 14.5H18.036V16.499H12.964z",
      transform: "rotate(-45 15.5 15.5)"
    })), _path347$h || (_path347$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.964 14.5H24.035999999999998V16.499H18.964z",
      transform: "rotate(-45 21.5 15.5)"
    })), children);
  });
  var ForecastHail24 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$h || (_path348$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _circle24$d || (_circle24$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "23.5",
      r: "1.5"
    })), _circle25$c || (_circle25$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "19.5",
      r: "1.5"
    })), _circle26$c || (_circle26$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.5",
      cy: "19.5",
      r: "1.5"
    })), _path349$h || (_path349$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.964 14.5H18.036V16.499H12.964z",
      transform: "rotate(-45 15.5 15.5)"
    })), _path350$h || (_path350$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.964 14.5H24.035999999999998V16.499H18.964z",
      transform: "rotate(-45 21.5 15.5)"
    })), children);
  });
  var ForecastHail20 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$h || (_path351$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _circle27$b || (_circle27$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "23.5",
      r: "1.5"
    })), _circle28$b || (_circle28$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "19.5",
      r: "1.5"
    })), _circle29$b || (_circle29$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.5",
      cy: "19.5",
      r: "1.5"
    })), _path352$h || (_path352$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.964 14.5H18.036V16.499H12.964z",
      transform: "rotate(-45 15.5 15.5)"
    })), _path353$h || (_path353$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.964 14.5H24.035999999999998V16.499H18.964z",
      transform: "rotate(-45 21.5 15.5)"
    })), children);
  });
  var ForecastHail16 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$h || (_path354$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _circle30$b || (_circle30$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14.5",
      cy: "23.5",
      r: "1.5"
    })), _circle31$b || (_circle31$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11.5",
      cy: "19.5",
      r: "1.5"
    })), _circle32$b || (_circle32$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17.5",
      cy: "19.5",
      r: "1.5"
    })), _path355$g || (_path355$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.964 14.5H18.036V16.499H12.964z",
      transform: "rotate(-45 15.5 15.5)"
    })), _path356$g || (_path356$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.964 14.5H24.035999999999998V16.499H18.964z",
      transform: "rotate(-45 21.5 15.5)"
    })), children);
  });
  var ForecastHail_3032 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail_3032(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$g || (_path357$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.964 13.5H14.036000000000001V15.499H8.964z",
      transform: "rotate(-45 11.5 14.5)"
    })), _path358$g || (_path358$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.379 14.5H17.622V16.499H15.379z",
      transform: "rotate(-44.995 16.5 15.5)"
    })), _circle33$b || (_circle33$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "22.5",
      r: "1.5"
    })), _circle34$a || (_circle34$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "18.5",
      r: "1.5"
    })), _circle35$a || (_circle35$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "18.5",
      r: "1.5"
    })), _path359$g || (_path359$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path360$g || (_path360$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastHail_3024 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail_3024(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$f || (_path361$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.964 13.5H14.036000000000001V15.499H8.964z",
      transform: "rotate(-45 11.5 14.5)"
    })), _path362$f || (_path362$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.379 14.5H17.622V16.499H15.379z",
      transform: "rotate(-44.995 16.5 15.5)"
    })), _circle36$a || (_circle36$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "22.5",
      r: "1.5"
    })), _circle37$8 || (_circle37$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "18.5",
      r: "1.5"
    })), _circle38$8 || (_circle38$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "18.5",
      r: "1.5"
    })), _path363$f || (_path363$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path364$f || (_path364$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastHail_3020 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail_3020(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$f || (_path365$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.964 13.5H14.036000000000001V15.499H8.964z",
      transform: "rotate(-45 11.5 14.5)"
    })), _path366$f || (_path366$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.379 14.5H17.622V16.499H15.379z",
      transform: "rotate(-44.995 16.5 15.5)"
    })), _circle39$8 || (_circle39$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "22.5",
      r: "1.5"
    })), _circle40$8 || (_circle40$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "18.5",
      r: "1.5"
    })), _circle41$7 || (_circle41$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "18.5",
      r: "1.5"
    })), _path367$f || (_path367$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path368$f || (_path368$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastHail_3016 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastHail_3016(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$f || (_path369$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.964 13.5H14.036000000000001V15.499H8.964z",
      transform: "rotate(-45 11.5 14.5)"
    })), _path370$f || (_path370$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.379 14.5H17.622V16.499H15.379z",
      transform: "rotate(-44.995 16.5 15.5)"
    })), _circle42$7 || (_circle42$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "22.5",
      r: "1.5"
    })), _circle43$7 || (_circle43$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "18.5",
      r: "1.5"
    })), _circle44$7 || (_circle44$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "18.5",
      r: "1.5"
    })), _path371$f || (_path371$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path372$f || (_path372$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastLightning32 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$f || (_path373$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path374$f || (_path374$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var ForecastLightning24 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$f || (_path375$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path376$f || (_path376$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var ForecastLightning20 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$f || (_path377$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path378$f || (_path378$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var ForecastLightning16 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$f || (_path379$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path380$f || (_path380$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var ForecastLightning_3032 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning_3032(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$f || (_path381$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path382$f || (_path382$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.67 24L9.934 23 12.221 19 8.332 19 12.325 12 14.062 13 11.778 17 15.668 17 11.67 24zM20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastLightning_3024 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning_3024(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$f || (_path383$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path384$e || (_path384$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.67 24L9.934 23 12.221 19 8.332 19 12.325 12 14.062 13 11.778 17 15.668 17 11.67 24zM20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastLightning_3020 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning_3020(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$e || (_path385$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path386$e || (_path386$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.67 24L9.934 23 12.221 19 8.332 19 12.325 12 14.062 13 11.778 17 15.668 17 11.67 24zM20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var ForecastLightning_3016 = /*#__PURE__*/React__default['default'].forwardRef(function ForecastLightning_3016(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$e || (_path387$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28A10,10,0,0,1,14,8h4v5l6-6L18,1V6H14a12,12,0,0,0,0,24Z"
    })), _path388$e || (_path388$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.67 24L9.934 23 12.221 19 8.332 19 12.325 12 14.062 13 11.778 17 15.668 17 11.67 24zM20 20H16v2h4v2H17v2h3v2H16v2h4a2.0027 2.0027 0 002-2V22A2.0023 2.0023 0 0020 20zM28 30H26a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zm-2-8v6h2V22z"
    })), children);
  });
  var Fork32 = /*#__PURE__*/React__default['default'].forwardRef(function Fork32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$e || (_path389$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"
    })), children);
  });
  var Fork24 = /*#__PURE__*/React__default['default'].forwardRef(function Fork24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$e || (_path390$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"
    })), children);
  });
  var Fork20 = /*#__PURE__*/React__default['default'].forwardRef(function Fork20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$e || (_path391$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"
    })), children);
  });
  var Fork16 = /*#__PURE__*/React__default['default'].forwardRef(function Fork16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$e || (_path392$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"
    })), children);
  });
  var Forum32 = /*#__PURE__*/React__default['default'].forwardRef(function Forum32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$e || (_path393$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H8C6.8,6,6,6.8,6,8v14c0,1.2,0.8,2,2,2h8v-2H8V8h20v14h-7.2L16,28.8l1.6,1.2l4.2-6H28c1.2,0,2-0.8,2-2V8\tC30,6.8,29.2,6,28,6z"
    })), _path394$e || (_path394$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V5c0-1.7,1.3-3,3-3h13v2H5C4.4,4,4,4.4,4,5V18z"
    })), children);
  });
  var Forum24 = /*#__PURE__*/React__default['default'].forwardRef(function Forum24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$e || (_path395$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H8C6.8,6,6,6.8,6,8v14c0,1.2,0.8,2,2,2h8v-2H8V8h20v14h-7.2L16,28.8l1.6,1.2l4.2-6H28c1.2,0,2-0.8,2-2V8\tC30,6.8,29.2,6,28,6z"
    })), _path396$e || (_path396$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V5c0-1.7,1.3-3,3-3h13v2H5C4.4,4,4,4.4,4,5V18z"
    })), children);
  });
  var Forum20 = /*#__PURE__*/React__default['default'].forwardRef(function Forum20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$e || (_path397$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H8C6.8,6,6,6.8,6,8v14c0,1.2,0.8,2,2,2h8v-2H8V8h20v14h-7.2L16,28.8l1.6,1.2l4.2-6H28c1.2,0,2-0.8,2-2V8\tC30,6.8,29.2,6,28,6z"
    })), _path398$e || (_path398$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V5c0-1.7,1.3-3,3-3h13v2H5C4.4,4,4,4.4,4,5V18z"
    })), children);
  });
  var Forum16 = /*#__PURE__*/React__default['default'].forwardRef(function Forum16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$d || (_path399$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H8C6.8,6,6,6.8,6,8v14c0,1.2,0.8,2,2,2h8v-2H8V8h20v14h-7.2L16,28.8l1.6,1.2l4.2-6H28c1.2,0,2-0.8,2-2V8\tC30,6.8,29.2,6,28,6z"
    })), _path400$d || (_path400$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18H2V5c0-1.7,1.3-3,3-3h13v2H5C4.4,4,4,4.4,4,5V18z"
    })), children);
  });
  var Forward_1032 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_1032(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$d || (_path401$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path402$d || (_path402$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Forward_1024 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_1024(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$c || (_path403$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path404$c || (_path404$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Forward_1020 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_1020(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$c || (_path405$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path406$c || (_path406$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Forward_1016 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_1016(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$c || (_path407$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path408$b || (_path408$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Forward_3032 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_3032(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$b || (_path409$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path410$a || (_path410$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Forward_3024 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_3024(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$a || (_path411$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path412$a || (_path412$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Forward_3020 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_3020(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$a || (_path413$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path414$a || (_path414$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Forward_3016 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_3016(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$9 || (_path415$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path416$7 || (_path416$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Forward_532 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_532(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$7 || (_path417$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path418$6 || (_path418$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Forward_524 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_524(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path419$5 || (_path419$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path420$5 || (_path420$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Forward_520 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_520(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$5 || (_path421$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path422$5 || (_path422$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Forward_516 = /*#__PURE__*/React__default['default'].forwardRef(function Forward_516(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path423$5 || (_path423$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"
    })), _path424$5 || (_path424$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Fragile32 = /*#__PURE__*/React__default['default'].forwardRef(function Fragile32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path425$4 || (_path425$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,12V6H21v6a5,5,0,0,1-10,0V4h5.5859L14.293,6.293a.9994.9994,0,0,0,0,1.414L15.5859,9,13.293,11.293l1.414,1.414,3-3a.9994.9994,0,0,0,0-1.414L16.4141,7,19.707,3.707A1,1,0,0,0,19,2H10A1,1,0,0,0,9,3v9a7.0053,7.0053,0,0,0,6,6.92V28H10v2H22V28H17V18.92A7.0053,7.0053,0,0,0,23,12Z"
    })), children);
  });
  var Fragile24 = /*#__PURE__*/React__default['default'].forwardRef(function Fragile24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path426$4 || (_path426$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,12V6H21v6a5,5,0,0,1-10,0V4h5.5859L14.293,6.293a.9994.9994,0,0,0,0,1.414L15.5859,9,13.293,11.293l1.414,1.414,3-3a.9994.9994,0,0,0,0-1.414L16.4141,7,19.707,3.707A1,1,0,0,0,19,2H10A1,1,0,0,0,9,3v9a7.0053,7.0053,0,0,0,6,6.92V28H10v2H22V28H17V18.92A7.0053,7.0053,0,0,0,23,12Z"
    })), children);
  });

  var _path$i, _path2$i, _path3$i, _path4$i, _path5$i, _path6$i, _path7$i, _path8$i, _path9$i, _path10$i, _path11$i, _path12$i, _path13$i, _path14$i, _path15$i, _path16$i, _path17$i, _path18$i, _path19$i, _path20$i, _path21$i, _path22$i, _path23$i, _path24$i, _path25$i, _path26$i, _path27$i, _path28$i, _path29$i, _path30$i, _path31$i, _path32$i, _circle$h, _circle2$h, _circle3$h, _circle4$g, _path33$i, _path34$i, _circle5$f, _circle6$f, _circle7$f, _circle8$f, _path35$i, _path36$i, _circle9$f, _circle10$f, _circle11$e, _circle12$e, _path37$i, _path38$i, _circle13$e, _circle14$e, _circle15$e, _circle16$e, _path39$i, _path40$i, _circle17$d, _circle18$d, _circle19$d, _circle20$d, _path41$i, _path42$i, _path43$i, _path44$i, _circle21$d, _circle22$d, _circle23$c, _circle24$c, _path45$i, _path46$i, _path47$i, _path48$i, _circle25$b, _circle26$b, _circle27$a, _circle28$a, _path49$i, _path50$i, _path51$i, _path52$i, _circle29$a, _circle30$a, _circle31$a, _circle32$a, _path53$i, _path54$i, _path55$i, _path56$i, _path57$i, _path58$i, _path59$i, _path60$i, _path61$i, _path62$i, _path63$i, _path64$i, _path65$i, _path66$i, _path67$i, _path68$i, _path69$i, _path70$i, _path71$i, _path72$i, _path73$i, _path74$i, _path75$i, _path76$i, _path77$i, _path78$i, _path79$i, _path80$i, _path81$i, _path82$i, _path83$i, _path84$i, _path85$i, _path86$i, _path87$i, _path88$i, _path89$i, _path90$i, _path91$i, _path92$i, _path93$i, _path94$i, _path95$i, _path96$i, _path97$i, _path98$i, _path99$i, _path100$i, _path101$i, _path102$i, _path103$i, _path104$i, _path105$i, _path106$i, _path107$i, _path108$i, _path109$i, _path110$i, _path111$i, _path112$i, _path113$i, _path114$i, _path115$i, _path116$i, _path117$i, _path118$i, _path119$i, _path120$i, _path121$i, _path122$i, _path123$i, _path124$i, _path125$i, _path126$i, _path127$i, _path128$i, _path129$i, _path130$i, _path131$i, _path132$i, _path133$i, _path134$i, _path135$i, _path136$i, _path137$i, _path138$i, _path139$i, _path140$i, _path141$i, _path142$i, _path143$i, _path144$i, _path145$i, _path146$i, _path147$i, _path148$i, _path149$i, _path150$i, _path151$i, _path152$i, _path153$i, _path154$i, _path155$i, _path156$i, _path157$i, _path158$i, _path159$i, _path160$i, _path161$i, _circle33$a, _path162$i, _path163$i, _path164$i, _path165$i, _path166$i, _path167$i, _path168$i, _path169$i, _path170$i, _path171$i, _path172$i, _path173$i, _path174$i, _path175$i, _path176$i, _path177$h, _path178$h, _path179$h, _path180$h, _path181$h, _path182$h, _path183$h, _path184$h, _path185$h, _path186$h, _path187$h, _path188$h, _path189$h, _path190$h, _path191$h, _path192$h, _path193$h, _path194$h, _path195$h, _path196$h, _path197$h, _path198$h, _path199$h, _path200$h, _circle34$9, _circle35$9, _circle36$9, _circle37$7, _circle38$7, _path201$h, _path202$h, _circle39$7, _circle40$7, _circle41$6, _circle42$6, _circle43$6, _path203$h, _path204$h, _circle44$6, _circle45$6, _circle46$6, _circle47$6, _circle48$6, _path205$h, _path206$h, _circle49$5, _circle50$5, _circle51$5, _circle52$5, _circle53$4, _path207$h, _path208$h, _path209$h, _path210$h, _path211$h, _path212$h, _path213$h, _path214$h, _path215$h, _path216$h, _path217$h, _path218$h, _path219$h, _path220$h, _path221$h, _path222$h, _path223$h, _path224$h, _path225$h, _path226$h, _path227$h, _path228$h, _path229$h, _path230$h, _path231$h, _path232$h, _path233$h, _path234$h, _path235$h, _path236$h, _path237$h, _path238$h, _path239$h, _path240$h, _path241$h, _path242$h, _path243$h, _path244$h, _path245$h, _path246$h, _path247$h, _circle54$4, _circle55$3, _circle56$3, _path248$h, _circle57$3, _circle58$3, _circle59$3, _path249$h, _circle60$3, _circle61$3, _circle62$3, _path250$h, _circle63$3, _circle64$3, _circle65$3, _path251$h, _path252$h, _path253$h, _circle66$3, _circle67$3, _circle68$3, _path254$h, _path255$h, _circle69$3, _circle70$3, _circle71$3, _path256$h, _path257$h, _circle72$3, _circle73$2, _circle74$2, _path258$h, _path259$h, _circle75$2, _circle76$2, _circle77$2, _path260$h, _path261$h, _path262$h, _path263$h, _circle78$2, _circle79$2, _circle80$2, _circle81$2, _circle82$2, _path264$h, _path265$h, _circle83$2, _circle84$2, _circle85$1, _circle86$1, _circle87$1, _path266$h, _path267$h, _circle88$1, _circle89$1, _circle90$1, _circle91$1, _circle92$1, _path268$h, _path269$h, _circle93$1, _circle94$1, _circle95$1, _circle96$1, _circle97$1, _path270$h, _path271$h, _path272$h, _path273$h, _path274$h, _path275$h, _path276$h, _path277$h, _path278$h, _path279$h, _circle98$1, _path280$h, _circle99$1, _circle100$1, _path281$h, _circle101$1, _circle102$1, _path282$h, _circle103$1, _circle104$1, _path283$h, _circle105$1, _path284$h, _path285$h, _path286$h, _path287$h, _path288$h, _path289$h, _path290$h, _path291$h, _path292$h, _path293$h, _path294$h, _path295$h, _path296$h, _path297$h, _path298$h, _path299$h, _path300$h, _path301$h, _path302$h, _path303$h, _path304$h, _path305$h, _path306$h, _path307$h, _path308$h, _path309$h, _path310$h, _path311$h, _path312$h, _path313$h, _path314$h, _path315$h, _path316$h, _path317$h, _path318$h, _path319$h, _path320$h, _path321$h, _path322$h, _path323$h, _path324$h, _path325$h, _path326$h, _path327$h, _path328$h, _path329$h, _path330$h, _path331$h, _path332$h, _path333$h, _path334$h, _path335$h, _path336$h, _path337$h, _path338$g, _path339$g, _path340$g, _path341$g, _path342$g, _path343$g, _path344$g, _path345$g, _path346$g, _path347$g, _path348$g, _path349$g, _path350$g, _path351$g, _path352$g, _path353$g, _path354$g, _path355$f, _path356$f, _path357$f, _path358$f, _path359$f, _path360$f, _path361$e, _path362$e, _path363$e, _path364$e, _path365$e, _path366$e, _path367$e, _path368$e, _path369$e, _path370$e, _path371$e, _path372$e, _path373$e, _path374$e, _path375$e, _circle106$1, _circle107$1, _circle108$1, _path376$e, _circle109$1, _circle110$1, _circle111$1, _path377$e, _circle112$1, _circle113$1, _circle114$1, _path378$e, _circle115$1, _circle116$1, _circle117$1, _path379$e, _path380$e, _path381$e, _path382$e, _path383$e, _path384$d, _path385$d, _path386$d, _path387$d, _path388$d, _path389$d, _path390$d, _path391$d, _path392$d, _circle118$1, _path393$d, _path394$d, _circle119$1, _path395$d, _path396$d, _circle120$1, _path397$d, _path398$d, _circle121$1, _path399$c, _path400$c, _path401$c, _path402$c, _path403$b, _path404$b, _path405$b, _path406$b, _path407$b;

  var _excluded$i = ["children"],
      _excluded2$i = ["children"],
      _excluded3$i = ["children"],
      _excluded4$i = ["children"],
      _excluded5$i = ["children"],
      _excluded6$i = ["children"],
      _excluded7$i = ["children"],
      _excluded8$i = ["children"],
      _excluded9$i = ["children"],
      _excluded10$i = ["children"],
      _excluded11$i = ["children"],
      _excluded12$i = ["children"],
      _excluded13$i = ["children"],
      _excluded14$i = ["children"],
      _excluded15$i = ["children"],
      _excluded16$i = ["children"],
      _excluded17$i = ["children"],
      _excluded18$i = ["children"],
      _excluded19$i = ["children"],
      _excluded20$i = ["children"],
      _excluded21$i = ["children"],
      _excluded22$i = ["children"],
      _excluded23$i = ["children"],
      _excluded24$i = ["children"],
      _excluded25$i = ["children"],
      _excluded26$i = ["children"],
      _excluded27$i = ["children"],
      _excluded28$i = ["children"],
      _excluded29$i = ["children"],
      _excluded30$i = ["children"],
      _excluded31$i = ["children"],
      _excluded32$i = ["children"],
      _excluded33$i = ["children"],
      _excluded34$i = ["children"],
      _excluded35$i = ["children"],
      _excluded36$i = ["children"],
      _excluded37$i = ["children"],
      _excluded38$i = ["children"],
      _excluded39$i = ["children"],
      _excluded40$i = ["children"],
      _excluded41$i = ["children"],
      _excluded42$i = ["children"],
      _excluded43$i = ["children"],
      _excluded44$i = ["children"],
      _excluded45$i = ["children"],
      _excluded46$i = ["children"],
      _excluded47$i = ["children"],
      _excluded48$i = ["children"],
      _excluded49$i = ["children"],
      _excluded50$i = ["children"],
      _excluded51$i = ["children"],
      _excluded52$i = ["children"],
      _excluded53$i = ["children"],
      _excluded54$i = ["children"],
      _excluded55$i = ["children"],
      _excluded56$i = ["children"],
      _excluded57$i = ["children"],
      _excluded58$i = ["children"],
      _excluded59$i = ["children"],
      _excluded60$i = ["children"],
      _excluded61$i = ["children"],
      _excluded62$i = ["children"],
      _excluded63$i = ["children"],
      _excluded64$i = ["children"],
      _excluded65$i = ["children"],
      _excluded66$i = ["children"],
      _excluded67$i = ["children"],
      _excluded68$i = ["children"],
      _excluded69$i = ["children"],
      _excluded70$i = ["children"],
      _excluded71$i = ["children"],
      _excluded72$i = ["children"],
      _excluded73$i = ["children"],
      _excluded74$i = ["children"],
      _excluded75$i = ["children"],
      _excluded76$i = ["children"],
      _excluded77$i = ["children"],
      _excluded78$i = ["children"],
      _excluded79$i = ["children"],
      _excluded80$i = ["children"],
      _excluded81$i = ["children"],
      _excluded82$i = ["children"],
      _excluded83$i = ["children"],
      _excluded84$i = ["children"],
      _excluded85$i = ["children"],
      _excluded86$i = ["children"],
      _excluded87$i = ["children"],
      _excluded88$i = ["children"],
      _excluded89$i = ["children"],
      _excluded90$i = ["children"],
      _excluded91$i = ["children"],
      _excluded92$i = ["children"],
      _excluded93$i = ["children"],
      _excluded94$i = ["children"],
      _excluded95$i = ["children"],
      _excluded96$i = ["children"],
      _excluded97$i = ["children"],
      _excluded98$i = ["children"],
      _excluded99$i = ["children"],
      _excluded100$i = ["children"],
      _excluded101$i = ["children"],
      _excluded102$i = ["children"],
      _excluded103$i = ["children"],
      _excluded104$i = ["children"],
      _excluded105$i = ["children"],
      _excluded106$i = ["children"],
      _excluded107$i = ["children"],
      _excluded108$i = ["children"],
      _excluded109$i = ["children"],
      _excluded110$i = ["children"],
      _excluded111$i = ["children"],
      _excluded112$i = ["children"],
      _excluded113$i = ["children"],
      _excluded114$i = ["children"],
      _excluded115$i = ["children"],
      _excluded116$i = ["children"],
      _excluded117$i = ["children"],
      _excluded118$i = ["children"],
      _excluded119$h = ["children"],
      _excluded120$h = ["children"],
      _excluded121$h = ["children"],
      _excluded122$h = ["children"],
      _excluded123$h = ["children"],
      _excluded124$h = ["children"],
      _excluded125$h = ["children"],
      _excluded126$h = ["children"],
      _excluded127$h = ["children"],
      _excluded128$h = ["children"],
      _excluded129$h = ["children"],
      _excluded130$h = ["children"],
      _excluded131$h = ["children"],
      _excluded132$h = ["children"],
      _excluded133$h = ["children"],
      _excluded134$h = ["children"],
      _excluded135$h = ["children"],
      _excluded136$h = ["children"],
      _excluded137$h = ["children"],
      _excluded138$h = ["children"],
      _excluded139$h = ["children"],
      _excluded140$h = ["children"],
      _excluded141$h = ["children"],
      _excluded142$h = ["children"],
      _excluded143$h = ["children"],
      _excluded144$h = ["children"],
      _excluded145$h = ["children"],
      _excluded146$h = ["children"],
      _excluded147$h = ["children"],
      _excluded148$h = ["children"],
      _excluded149$h = ["children"],
      _excluded150$h = ["children"],
      _excluded151$h = ["children"],
      _excluded152$h = ["children"],
      _excluded153$h = ["children"],
      _excluded154$h = ["children"],
      _excluded155$h = ["children"],
      _excluded156$h = ["children"],
      _excluded157$h = ["children"],
      _excluded158$h = ["children"],
      _excluded159$h = ["children"],
      _excluded160$h = ["children"],
      _excluded161$h = ["children"],
      _excluded162$h = ["children"],
      _excluded163$h = ["children"],
      _excluded164$h = ["children"],
      _excluded165$h = ["children"],
      _excluded166$h = ["children"],
      _excluded167$h = ["children"],
      _excluded168$h = ["children"],
      _excluded169$h = ["children"],
      _excluded170$h = ["children"],
      _excluded171$h = ["children"],
      _excluded172$h = ["children"],
      _excluded173$h = ["children"],
      _excluded174$h = ["children"],
      _excluded175$h = ["children"],
      _excluded176$h = ["children"],
      _excluded177$h = ["children"],
      _excluded178$h = ["children"],
      _excluded179$h = ["children"],
      _excluded180$h = ["children"],
      _excluded181$h = ["children"],
      _excluded182$h = ["children"],
      _excluded183$h = ["children"],
      _excluded184$h = ["children"],
      _excluded185$h = ["children"],
      _excluded186$h = ["children"],
      _excluded187$h = ["children"],
      _excluded188$h = ["children"],
      _excluded189$h = ["children"],
      _excluded190$h = ["children"],
      _excluded191$h = ["children"],
      _excluded192$h = ["children"],
      _excluded193$h = ["children"],
      _excluded194$h = ["children"],
      _excluded195$h = ["children"],
      _excluded196$h = ["children"],
      _excluded197$h = ["children"],
      _excluded198$h = ["children"],
      _excluded199$h = ["children"],
      _excluded200$h = ["children"],
      _excluded201$h = ["children"],
      _excluded202$h = ["children"],
      _excluded203$h = ["children"],
      _excluded204$h = ["children"],
      _excluded205$h = ["children"],
      _excluded206$h = ["children"],
      _excluded207$h = ["children"],
      _excluded208$h = ["children"],
      _excluded209$h = ["children"],
      _excluded210$h = ["children"],
      _excluded211$h = ["children"],
      _excluded212$h = ["children"],
      _excluded213$h = ["children"],
      _excluded214$h = ["children"],
      _excluded215$h = ["children"],
      _excluded216$h = ["children"],
      _excluded217$h = ["children"],
      _excluded218$h = ["children"],
      _excluded219$h = ["children"],
      _excluded220$h = ["children"],
      _excluded221$h = ["children"],
      _excluded222$h = ["children"],
      _excluded223$h = ["children"],
      _excluded224$h = ["children"],
      _excluded225$h = ["children"],
      _excluded226$h = ["children"],
      _excluded227$h = ["children"],
      _excluded228$h = ["children"],
      _excluded229$h = ["children"],
      _excluded230$h = ["children"],
      _excluded231$h = ["children"],
      _excluded232$h = ["children"],
      _excluded233$h = ["children"],
      _excluded234$h = ["children"],
      _excluded235$h = ["children"],
      _excluded236$h = ["children"],
      _excluded237$h = ["children"],
      _excluded238$h = ["children"],
      _excluded239$h = ["children"],
      _excluded240$h = ["children"],
      _excluded241$h = ["children"],
      _excluded242$h = ["children"],
      _excluded243$h = ["children"],
      _excluded244$h = ["children"],
      _excluded245$h = ["children"],
      _excluded246$h = ["children"],
      _excluded247$h = ["children"],
      _excluded248$h = ["children"],
      _excluded249$h = ["children"],
      _excluded250$h = ["children"];
  var didWarnAboutDeprecation$6 = {};
  var Fragile20 = /*#__PURE__*/React__default['default'].forwardRef(function Fragile20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$i || (_path$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,12V6H21v6a5,5,0,0,1-10,0V4h5.5859L14.293,6.293a.9994.9994,0,0,0,0,1.414L15.5859,9,13.293,11.293l1.414,1.414,3-3a.9994.9994,0,0,0,0-1.414L16.4141,7,19.707,3.707A1,1,0,0,0,19,2H10A1,1,0,0,0,9,3v9a7.0053,7.0053,0,0,0,6,6.92V28H10v2H22V28H17V18.92A7.0053,7.0053,0,0,0,23,12Z"
    })), children);
  });
  var Fragile16 = /*#__PURE__*/React__default['default'].forwardRef(function Fragile16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$i || (_path2$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,12V6H21v6a5,5,0,0,1-10,0V4h5.5859L14.293,6.293a.9994.9994,0,0,0,0,1.414L15.5859,9,13.293,11.293l1.414,1.414,3-3a.9994.9994,0,0,0,0-1.414L16.4141,7,19.707,3.707A1,1,0,0,0,19,2H10A1,1,0,0,0,9,3v9a7.0053,7.0053,0,0,0,6,6.92V28H10v2H22V28H17V18.92A7.0053,7.0053,0,0,0,23,12Z"
    })), children);
  });
  var Friendship32 = /*#__PURE__*/React__default['default'].forwardRef(function Friendship32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$i || (_path3$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10H7a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V16H12V28H8V19H6V13a1.0009 1.0009 0 011-1H25a1.0009 1.0009 0 011 1v6H24v9H20V16H18V28a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0025 10zM10 9a4 4 0 114-4A4.0042 4.0042 0 0110 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0010 3zM22 9a4 4 0 114-4A4.0042 4.0042 0 0122 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0022 3z"
    })), children);
  });
  var Friendship24 = /*#__PURE__*/React__default['default'].forwardRef(function Friendship24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$i || (_path4$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10H7a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V16H12V28H8V19H6V13a1.0009 1.0009 0 011-1H25a1.0009 1.0009 0 011 1v6H24v9H20V16H18V28a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0025 10zM10 9a4 4 0 114-4A4.0042 4.0042 0 0110 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0010 3zM22 9a4 4 0 114-4A4.0042 4.0042 0 0122 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0022 3z"
    })), children);
  });
  var Friendship20 = /*#__PURE__*/React__default['default'].forwardRef(function Friendship20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$i || (_path5$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10H7a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V16H12V28H8V19H6V13a1.0009 1.0009 0 011-1H25a1.0009 1.0009 0 011 1v6H24v9H20V16H18V28a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0025 10zM10 9a4 4 0 114-4A4.0042 4.0042 0 0110 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0010 3zM22 9a4 4 0 114-4A4.0042 4.0042 0 0122 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0022 3z"
    })), children);
  });
  var Friendship16 = /*#__PURE__*/React__default['default'].forwardRef(function Friendship16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$i || (_path6$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10H7a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V16H12V28H8V19H6V13a1.0009 1.0009 0 011-1H25a1.0009 1.0009 0 011 1v6H24v9H20V16H18V28a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0025 10zM10 9a4 4 0 114-4A4.0042 4.0042 0 0110 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0010 3zM22 9a4 4 0 114-4A4.0042 4.0042 0 0122 9zm0-6a2 2 0 102 2A2.0023 2.0023 0 0022 3z"
    })), children);
  });
  var FruitBowl32 = /*#__PURE__*/React__default['default'].forwardRef(function FruitBowl32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$i || (_path7$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), children);
  });
  var FruitBowl24 = /*#__PURE__*/React__default['default'].forwardRef(function FruitBowl24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$i || (_path8$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), children);
  });
  var FruitBowl20 = /*#__PURE__*/React__default['default'].forwardRef(function FruitBowl20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$i || (_path9$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), children);
  });
  var FruitBowl16 = /*#__PURE__*/React__default['default'].forwardRef(function FruitBowl16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$i || (_path10$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), children);
  });
  var Function32 = /*#__PURE__*/React__default['default'].forwardRef(function Function32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$i || (_path11$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.6262,29.5256,19.11,27.5935A12.0035,12.0035,0,0,0,25.2312,8.3323l1.5376-1.2788a14.0033,14.0033,0,0,1-7.1426,22.4721Z"
    })), _path12$i || (_path12$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,29H8V25.18l.8037-.1607C10.2617,24.728,12,23.6206,12,20V18.6182l-4-2V14.3818l4-2V12c0-5.4673,3.9253-9,10-9h2V6.82l-.8037.1607C21.7383,7.272,20,8.3794,20,12v.3818l4,2v2.2364l-4,2V20C20,25.4673,16.0747,29,10,29Zm0-2c4.9346,0,8-2.6821,8-7V17.3818L21.7642,15.5,18,13.6182V12c0-4.5781,2.3853-6.1924,4-6.76V5c-4.9346,0-8,2.6821-8,7v1.6182L10.2358,15.5,14,17.3818V20c0,4.5781-2.3853,6.1924-4,6.76Z"
    })), _path13$i || (_path13$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.2312,24.9465A14.0032,14.0032,0,0,1,12.3779,2.4734l.5161,1.9321A12.0035,12.0035,0,0,0,6.7688,23.6677Z"
    })), children);
  });
  var Function24 = /*#__PURE__*/React__default['default'].forwardRef(function Function24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$i || (_path14$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.6262,29.5256,19.11,27.5935A12.0035,12.0035,0,0,0,25.2312,8.3323l1.5376-1.2788a14.0033,14.0033,0,0,1-7.1426,22.4721Z"
    })), _path15$i || (_path15$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,29H8V25.18l.8037-.1607C10.2617,24.728,12,23.6206,12,20V18.6182l-4-2V14.3818l4-2V12c0-5.4673,3.9253-9,10-9h2V6.82l-.8037.1607C21.7383,7.272,20,8.3794,20,12v.3818l4,2v2.2364l-4,2V20C20,25.4673,16.0747,29,10,29Zm0-2c4.9346,0,8-2.6821,8-7V17.3818L21.7642,15.5,18,13.6182V12c0-4.5781,2.3853-6.1924,4-6.76V5c-4.9346,0-8,2.6821-8,7v1.6182L10.2358,15.5,14,17.3818V20c0,4.5781-2.3853,6.1924-4,6.76Z"
    })), _path16$i || (_path16$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.2312,24.9465A14.0032,14.0032,0,0,1,12.3779,2.4734l.5161,1.9321A12.0035,12.0035,0,0,0,6.7688,23.6677Z"
    })), children);
  });
  var Function20 = /*#__PURE__*/React__default['default'].forwardRef(function Function20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$i || (_path17$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.6262,29.5256,19.11,27.5935A12.0035,12.0035,0,0,0,25.2312,8.3323l1.5376-1.2788a14.0033,14.0033,0,0,1-7.1426,22.4721Z"
    })), _path18$i || (_path18$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,29H8V25.18l.8037-.1607C10.2617,24.728,12,23.6206,12,20V18.6182l-4-2V14.3818l4-2V12c0-5.4673,3.9253-9,10-9h2V6.82l-.8037.1607C21.7383,7.272,20,8.3794,20,12v.3818l4,2v2.2364l-4,2V20C20,25.4673,16.0747,29,10,29Zm0-2c4.9346,0,8-2.6821,8-7V17.3818L21.7642,15.5,18,13.6182V12c0-4.5781,2.3853-6.1924,4-6.76V5c-4.9346,0-8,2.6821-8,7v1.6182L10.2358,15.5,14,17.3818V20c0,4.5781-2.3853,6.1924-4,6.76Z"
    })), _path19$i || (_path19$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.2312,24.9465A14.0032,14.0032,0,0,1,12.3779,2.4734l.5161,1.9321A12.0035,12.0035,0,0,0,6.7688,23.6677Z"
    })), children);
  });
  var Function16 = /*#__PURE__*/React__default['default'].forwardRef(function Function16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$i || (_path20$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.6262,29.5256,19.11,27.5935A12.0035,12.0035,0,0,0,25.2312,8.3323l1.5376-1.2788a14.0033,14.0033,0,0,1-7.1426,22.4721Z"
    })), _path21$i || (_path21$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,29H8V25.18l.8037-.1607C10.2617,24.728,12,23.6206,12,20V18.6182l-4-2V14.3818l4-2V12c0-5.4673,3.9253-9,10-9h2V6.82l-.8037.1607C21.7383,7.272,20,8.3794,20,12v.3818l4,2v2.2364l-4,2V20C20,25.4673,16.0747,29,10,29Zm0-2c4.9346,0,8-2.6821,8-7V17.3818L21.7642,15.5,18,13.6182V12c0-4.5781,2.3853-6.1924,4-6.76V5c-4.9346,0-8,2.6821-8,7v1.6182L10.2358,15.5,14,17.3818V20c0,4.5781-2.3853,6.1924-4,6.76Z"
    })), _path22$i || (_path22$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.2312,24.9465A14.0032,14.0032,0,0,1,12.3779,2.4734l.5161,1.9321A12.0035,12.0035,0,0,0,6.7688,23.6677Z"
    })), children);
  });
  var FunctionMath32 = /*#__PURE__*/React__default['default'].forwardRef(function FunctionMath32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$i || (_path23$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18L24 18 22 21.897 20 18 18 18 20.905 23 18 28 20 28 22 24.201 24 28 26 28 23.098 23 26 18zM19 6V4H13.9133a1.9906 1.9906 0 00-1.9919 1.8188L11.2686 13H7v2h4.0867l-1 11H5v2h5.0867a1.9906 1.9906 0 001.9919-1.8188L13.0952 15H18V13H13.2769l.6364-7z"
    })), children);
  });
  var FunctionMath24 = /*#__PURE__*/React__default['default'].forwardRef(function FunctionMath24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$i || (_path24$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18L24 18 22 21.897 20 18 18 18 20.905 23 18 28 20 28 22 24.201 24 28 26 28 23.098 23 26 18zM19 6V4H13.9133a1.9906 1.9906 0 00-1.9919 1.8188L11.2686 13H7v2h4.0867l-1 11H5v2h5.0867a1.9906 1.9906 0 001.9919-1.8188L13.0952 15H18V13H13.2769l.6364-7z"
    })), children);
  });
  var FunctionMath20 = /*#__PURE__*/React__default['default'].forwardRef(function FunctionMath20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$i || (_path25$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18L24 18 22 21.897 20 18 18 18 20.905 23 18 28 20 28 22 24.201 24 28 26 28 23.098 23 26 18zM19 6V4H13.9133a1.9906 1.9906 0 00-1.9919 1.8188L11.2686 13H7v2h4.0867l-1 11H5v2h5.0867a1.9906 1.9906 0 001.9919-1.8188L13.0952 15H18V13H13.2769l.6364-7z"
    })), children);
  });
  var FunctionMath16 = /*#__PURE__*/React__default['default'].forwardRef(function FunctionMath16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$i || (_path26$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18L24 18 22 21.897 20 18 18 18 20.905 23 18 28 20 28 22 24.201 24 28 26 28 23.098 23 26 18zM19 6V4H13.9133a1.9906 1.9906 0 00-1.9919 1.8188L11.2686 13H7v2h4.0867l-1 11H5v2h5.0867a1.9906 1.9906 0 001.9919-1.8188L13.0952 15H18V13H13.2769l.6364-7z"
    })), children);
  });
  var WatsonHealthFusionBlender32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthFusionBlender32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$i || (_path27$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"
    })), children);
  });
  var WatsonHealthFusionBlender24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthFusionBlender24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$i || (_path28$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"
    })), children);
  });
  var WatsonHealthFusionBlender20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthFusionBlender20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$i || (_path29$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"
    })), children);
  });
  var WatsonHealthFusionBlender16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthFusionBlender16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$i || (_path30$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"
    })), children);
  });
  var GameConsole32 = /*#__PURE__*/React__default['default'].forwardRef(function GameConsole32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$i || (_path31$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"
    })), _path32$i || (_path32$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"
    })), _circle$h || (_circle$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "1"
    })), _circle2$h || (_circle2$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle3$h || (_circle3$h = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "14",
      r: "1"
    })), _circle4$g || (_circle4$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "14",
      r: "1"
    })), children);
  });
  var GameConsole24 = /*#__PURE__*/React__default['default'].forwardRef(function GameConsole24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$i || (_path33$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"
    })), _path34$i || (_path34$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"
    })), _circle5$f || (_circle5$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "1"
    })), _circle6$f || (_circle6$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle7$f || (_circle7$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "14",
      r: "1"
    })), _circle8$f || (_circle8$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "14",
      r: "1"
    })), children);
  });
  var GameConsole20 = /*#__PURE__*/React__default['default'].forwardRef(function GameConsole20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$i || (_path35$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"
    })), _path36$i || (_path36$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"
    })), _circle9$f || (_circle9$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "1"
    })), _circle10$f || (_circle10$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle11$e || (_circle11$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "14",
      r: "1"
    })), _circle12$e || (_circle12$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "14",
      r: "1"
    })), children);
  });
  var GameConsole16 = /*#__PURE__*/React__default['default'].forwardRef(function GameConsole16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$i || (_path37$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"
    })), _path38$i || (_path38$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"
    })), _circle13$e || (_circle13$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "12",
      r: "1"
    })), _circle14$e || (_circle14$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle15$e || (_circle15$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "14",
      r: "1"
    })), _circle16$e || (_circle16$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "14",
      r: "1"
    })), children);
  });
  var GameWireless32 = /*#__PURE__*/React__default['default'].forwardRef(function GameWireless32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$i || (_path39$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"
    })), _path40$i || (_path40$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"
    })), _circle17$d || (_circle17$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle18$d || (_circle18$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "1"
    })), _circle19$d || (_circle19$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "18",
      r: "1"
    })), _circle20$d || (_circle20$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "18",
      r: "1"
    })), _path41$i || (_path41$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"
    })), _path42$i || (_path42$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"
    })), children);
  });
  var GameWireless24 = /*#__PURE__*/React__default['default'].forwardRef(function GameWireless24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$i || (_path43$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"
    })), _path44$i || (_path44$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"
    })), _circle21$d || (_circle21$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle22$d || (_circle22$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "1"
    })), _circle23$c || (_circle23$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "18",
      r: "1"
    })), _circle24$c || (_circle24$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "18",
      r: "1"
    })), _path45$i || (_path45$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"
    })), _path46$i || (_path46$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"
    })), children);
  });
  var GameWireless20 = /*#__PURE__*/React__default['default'].forwardRef(function GameWireless20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$i || (_path47$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"
    })), _path48$i || (_path48$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"
    })), _circle25$b || (_circle25$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle26$b || (_circle26$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "1"
    })), _circle27$a || (_circle27$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "18",
      r: "1"
    })), _circle28$a || (_circle28$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "18",
      r: "1"
    })), _path49$i || (_path49$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"
    })), _path50$i || (_path50$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"
    })), children);
  });
  var GameWireless16 = /*#__PURE__*/React__default['default'].forwardRef(function GameWireless16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$i || (_path51$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"
    })), _path52$i || (_path52$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"
    })), _circle29$a || (_circle29$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "16",
      r: "1"
    })), _circle30$a || (_circle30$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "20",
      r: "1"
    })), _circle31$a || (_circle31$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "18",
      r: "1"
    })), _circle32$a || (_circle32$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "18",
      r: "1"
    })), _path53$i || (_path53$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"
    })), _path54$i || (_path54$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"
    })), children);
  });
  var Gamification32 = /*#__PURE__*/React__default['default'].forwardRef(function Gamification32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$i || (_path55$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"
    })), children);
  });
  var Gamification24 = /*#__PURE__*/React__default['default'].forwardRef(function Gamification24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$i || (_path56$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"
    })), children);
  });
  var Gamification20 = /*#__PURE__*/React__default['default'].forwardRef(function Gamification20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$i || (_path57$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"
    })), children);
  });
  var Gamification16 = /*#__PURE__*/React__default['default'].forwardRef(function Gamification16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$i || (_path58$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"
    })), children);
  });
  var GasStation32 = /*#__PURE__*/React__default['default'].forwardRef(function GasStation32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$i || (_path59$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H15V12H8z"
    })), _path60$i || (_path60$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4142,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5644,3.5644,0,0,0,2.7654,3.5251A3.5062,3.5062,0,0,0,29,24.5V9.4144A2,2,0,0,0,28.4142,8ZM17,26H6V6H17Z"
    })), children);
  });
  var GasStation24 = /*#__PURE__*/React__default['default'].forwardRef(function GasStation24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$i || (_path61$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H15V12H8z"
    })), _path62$i || (_path62$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4142,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5644,3.5644,0,0,0,2.7654,3.5251A3.5062,3.5062,0,0,0,29,24.5V9.4144A2,2,0,0,0,28.4142,8ZM17,26H6V6H17Z"
    })), children);
  });
  var GasStation20 = /*#__PURE__*/React__default['default'].forwardRef(function GasStation20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$i || (_path63$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H15V12H8z"
    })), _path64$i || (_path64$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4142,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5644,3.5644,0,0,0,2.7654,3.5251A3.5062,3.5062,0,0,0,29,24.5V9.4144A2,2,0,0,0,28.4142,8ZM17,26H6V6H17Z"
    })), children);
  });
  var GasStation16 = /*#__PURE__*/React__default['default'].forwardRef(function GasStation16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$i || (_path65$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H15V12H8z"
    })), _path66$i || (_path66$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4142,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5644,3.5644,0,0,0,2.7654,3.5251A3.5062,3.5062,0,0,0,29,24.5V9.4144A2,2,0,0,0,28.4142,8ZM17,26H6V6H17Z"
    })), children);
  });
  var GasStationFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function GasStationFilled32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$i || (_path67$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H15V12H8z",
      "data-icon-path": "inner-path"
    })), _path68$i || (_path68$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4143,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5645,3.5645,0,0,0,2.7654,3.5249A3.506,3.506,0,0,0,29,24.5V9.4146A2,2,0,0,0,28.4143,8ZM15,12H8V10h7Z"
    })), children);
  });
  var GasStationFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function GasStationFilled24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$i || (_path69$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H15V12H8z",
      "data-icon-path": "inner-path"
    })), _path70$i || (_path70$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4143,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5645,3.5645,0,0,0,2.7654,3.5249A3.506,3.506,0,0,0,29,24.5V9.4146A2,2,0,0,0,28.4143,8ZM15,12H8V10h7Z"
    })), children);
  });
  var GasStationFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function GasStationFilled20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$i || (_path71$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H15V12H8z",
      "data-icon-path": "inner-path"
    })), _path72$i || (_path72$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4143,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5645,3.5645,0,0,0,2.7654,3.5249A3.506,3.506,0,0,0,29,24.5V9.4146A2,2,0,0,0,28.4143,8ZM15,12H8V10h7Z"
    })), children);
  });
  var GasStationFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function GasStationFilled16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$i || (_path73$i = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H15V12H8z",
      "data-icon-path": "inner-path"
    })), _path74$i || (_path74$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4143,8l-5-5L22,4.4141l3,3V12a2.0023,2.0023,0,0,0,2,2V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.4a3.5645,3.5645,0,0,0,2.7654,3.5249A3.506,3.506,0,0,0,29,24.5V9.4146A2,2,0,0,0,28.4143,8ZM15,12H8V10h7Z"
    })), children);
  });
  var Gateway32 = /*#__PURE__*/React__default['default'].forwardRef(function Gateway32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$i || (_path75$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31,16a1.9857,1.9857,0,0,0-.5859-1.4141L24.6211,8.793,27.489,5.9253a2,2,0,1,0-1.414-1.4141L23.207,7.3789l-5.7929-5.793a1.9995,1.9995,0,0,0-2.8282,0L8.793,7.3789,5.925,4.5112A2,2,0,1,0,4.511,5.9253L7.3789,8.793l-5.793,5.7929a1.9995,1.9995,0,0,0,0,2.8282l5.793,5.7929L4.511,26.0747a2,2,0,1,0,1.414,1.4141l2.868-2.8677,5.7929,5.793a1.9995,1.9995,0,0,0,2.8282,0l5.7929-5.793,2.868,2.8677a2,2,0,1,0,1.414-1.4141L24.6211,23.207l5.793-5.7929A1.9866,1.9866,0,0,0,31,16Zm-7.793,5.793L20.4141,19,19,20.4141l2.793,2.7929L16,29l-5.793-5.793L13,20.4141,11.5859,19,8.793,21.793,3,16l5.7925-5.7935L11.5859,13,13,11.5859,10.2065,8.7925,16,3l5.7935,5.7925L19,11.5859,20.4141,13l2.7934-2.7935L29,16Z"
    })), children);
  });
  var Gateway24 = /*#__PURE__*/React__default['default'].forwardRef(function Gateway24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$i || (_path76$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31,16a1.9857,1.9857,0,0,0-.5859-1.4141L24.6211,8.793,27.489,5.9253a2,2,0,1,0-1.414-1.4141L23.207,7.3789l-5.7929-5.793a1.9995,1.9995,0,0,0-2.8282,0L8.793,7.3789,5.925,4.5112A2,2,0,1,0,4.511,5.9253L7.3789,8.793l-5.793,5.7929a1.9995,1.9995,0,0,0,0,2.8282l5.793,5.7929L4.511,26.0747a2,2,0,1,0,1.414,1.4141l2.868-2.8677,5.7929,5.793a1.9995,1.9995,0,0,0,2.8282,0l5.7929-5.793,2.868,2.8677a2,2,0,1,0,1.414-1.4141L24.6211,23.207l5.793-5.7929A1.9866,1.9866,0,0,0,31,16Zm-7.793,5.793L20.4141,19,19,20.4141l2.793,2.7929L16,29l-5.793-5.793L13,20.4141,11.5859,19,8.793,21.793,3,16l5.7925-5.7935L11.5859,13,13,11.5859,10.2065,8.7925,16,3l5.7935,5.7925L19,11.5859,20.4141,13l2.7934-2.7935L29,16Z"
    })), children);
  });
  var Gateway20 = /*#__PURE__*/React__default['default'].forwardRef(function Gateway20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$i || (_path77$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31,16a1.9857,1.9857,0,0,0-.5859-1.4141L24.6211,8.793,27.489,5.9253a2,2,0,1,0-1.414-1.4141L23.207,7.3789l-5.7929-5.793a1.9995,1.9995,0,0,0-2.8282,0L8.793,7.3789,5.925,4.5112A2,2,0,1,0,4.511,5.9253L7.3789,8.793l-5.793,5.7929a1.9995,1.9995,0,0,0,0,2.8282l5.793,5.7929L4.511,26.0747a2,2,0,1,0,1.414,1.4141l2.868-2.8677,5.7929,5.793a1.9995,1.9995,0,0,0,2.8282,0l5.7929-5.793,2.868,2.8677a2,2,0,1,0,1.414-1.4141L24.6211,23.207l5.793-5.7929A1.9866,1.9866,0,0,0,31,16Zm-7.793,5.793L20.4141,19,19,20.4141l2.793,2.7929L16,29l-5.793-5.793L13,20.4141,11.5859,19,8.793,21.793,3,16l5.7925-5.7935L11.5859,13,13,11.5859,10.2065,8.7925,16,3l5.7935,5.7925L19,11.5859,20.4141,13l2.7934-2.7935L29,16Z"
    })), children);
  });
  var Gateway16 = /*#__PURE__*/React__default['default'].forwardRef(function Gateway16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$i || (_path78$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31,16a1.9857,1.9857,0,0,0-.5859-1.4141L24.6211,8.793,27.489,5.9253a2,2,0,1,0-1.414-1.4141L23.207,7.3789l-5.7929-5.793a1.9995,1.9995,0,0,0-2.8282,0L8.793,7.3789,5.925,4.5112A2,2,0,1,0,4.511,5.9253L7.3789,8.793l-5.793,5.7929a1.9995,1.9995,0,0,0,0,2.8282l5.793,5.7929L4.511,26.0747a2,2,0,1,0,1.414,1.4141l2.868-2.8677,5.7929,5.793a1.9995,1.9995,0,0,0,2.8282,0l5.7929-5.793,2.868,2.8677a2,2,0,1,0,1.414-1.4141L24.6211,23.207l5.793-5.7929A1.9866,1.9866,0,0,0,31,16Zm-7.793,5.793L20.4141,19,19,20.4141l2.793,2.7929L16,29l-5.793-5.793L13,20.4141,11.5859,19,8.793,21.793,3,16l5.7925-5.7935L11.5859,13,13,11.5859,10.2065,8.7925,16,3l5.7935,5.7925L19,11.5859,20.4141,13l2.7934-2.7935L29,16Z"
    })), children);
  });
  var GatewayApi32 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayApi32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$i || (_path79$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,18.1841V13.8159a3.0007,3.0007,0,1,0-2,0v4.3687a3,3,0,1,0,2,0ZM16,10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Zm0,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,22Z"
    })), _path80$i || (_path80$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayApi24 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayApi24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$i || (_path81$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,18.1841V13.8159a3.0007,3.0007,0,1,0-2,0v4.3687a3,3,0,1,0,2,0ZM16,10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Zm0,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,22Z"
    })), _path82$i || (_path82$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayApi20 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayApi20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$i || (_path83$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,18.1841V13.8159a3.0007,3.0007,0,1,0-2,0v4.3687a3,3,0,1,0,2,0ZM16,10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Zm0,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,22Z"
    })), _path84$i || (_path84$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayApi16 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayApi16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$i || (_path85$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,18.1841V13.8159a3.0007,3.0007,0,1,0-2,0v4.3687a3,3,0,1,0,2,0ZM16,10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Zm0,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,22Z"
    })), _path86$i || (_path86$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayMail32 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayMail32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$i || (_path87$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.8779,12.1218a.4186.4186,0,0,0-.437-.0971l-9.1666,3.3335a.4167.4167,0,0,0-.0122.7786l4.0006,1.6,1.6,4.0007A.4168.4168,0,0,0,16.25,22h.0067a.4169.4169,0,0,0,.3849-.2743l3.3333-9.1669A.4165.4165,0,0,0,19.8779,12.1218Z"
    })), _path88$i || (_path88$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayMail24 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayMail24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$i || (_path89$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.8779,12.1218a.4186.4186,0,0,0-.437-.0971l-9.1666,3.3335a.4167.4167,0,0,0-.0122.7786l4.0006,1.6,1.6,4.0007A.4168.4168,0,0,0,16.25,22h.0067a.4169.4169,0,0,0,.3849-.2743l3.3333-9.1669A.4165.4165,0,0,0,19.8779,12.1218Z"
    })), _path90$i || (_path90$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayMail20 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayMail20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$i || (_path91$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.8779,12.1218a.4186.4186,0,0,0-.437-.0971l-9.1666,3.3335a.4167.4167,0,0,0-.0122.7786l4.0006,1.6,1.6,4.0007A.4168.4168,0,0,0,16.25,22h.0067a.4169.4169,0,0,0,.3849-.2743l3.3333-9.1669A.4165.4165,0,0,0,19.8779,12.1218Z"
    })), _path92$i || (_path92$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayMail16 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayMail16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$i || (_path93$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.8779,12.1218a.4186.4186,0,0,0-.437-.0971l-9.1666,3.3335a.4167.4167,0,0,0-.0122.7786l4.0006,1.6,1.6,4.0007A.4168.4168,0,0,0,16.25,22h.0067a.4169.4169,0,0,0,.3849-.2743l3.3333-9.1669A.4165.4165,0,0,0,19.8779,12.1218Z"
    })), _path94$i || (_path94$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayPublic32 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayPublic32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$i || (_path95$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14H14V12a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A2.0023,2.0023,0,0,0,19,14Zm0,7H13V16h6Z"
    })), _path96$i || (_path96$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayPublic24 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayPublic24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$i || (_path97$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14H14V12a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A2.0023,2.0023,0,0,0,19,14Zm0,7H13V16h6Z"
    })), _path98$i || (_path98$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayPublic20 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayPublic20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$i || (_path99$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14H14V12a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A2.0023,2.0023,0,0,0,19,14Zm0,7H13V16h6Z"
    })), _path100$i || (_path100$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayPublic16 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayPublic16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$i || (_path101$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14H14V12a2,2,0,0,1,4,0h2a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A2.0023,2.0023,0,0,0,19,14Zm0,7H13V16h6Z"
    })), _path102$i || (_path102$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewaySecurity32 = /*#__PURE__*/React__default['default'].forwardRef(function GatewaySecurity32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$i || (_path103$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11v6.4678a5.0216,5.0216,0,0,0,2.8613,4.52L16,23l2.1387-1.0127A5.0216,5.0216,0,0,0,21,17.4678V11Zm8,6.4678a3.012,3.012,0,0,1-1.7168,2.7109L16,20.7861l-1.2832-.6074A3.012,3.012,0,0,1,13,17.4678V13h6Z"
    })), _path104$i || (_path104$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewaySecurity24 = /*#__PURE__*/React__default['default'].forwardRef(function GatewaySecurity24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$i || (_path105$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11v6.4678a5.0216,5.0216,0,0,0,2.8613,4.52L16,23l2.1387-1.0127A5.0216,5.0216,0,0,0,21,17.4678V11Zm8,6.4678a3.012,3.012,0,0,1-1.7168,2.7109L16,20.7861l-1.2832-.6074A3.012,3.012,0,0,1,13,17.4678V13h6Z"
    })), _path106$i || (_path106$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewaySecurity20 = /*#__PURE__*/React__default['default'].forwardRef(function GatewaySecurity20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$i || (_path107$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11v6.4678a5.0216,5.0216,0,0,0,2.8613,4.52L16,23l2.1387-1.0127A5.0216,5.0216,0,0,0,21,17.4678V11Zm8,6.4678a3.012,3.012,0,0,1-1.7168,2.7109L16,20.7861l-1.2832-.6074A3.012,3.012,0,0,1,13,17.4678V13h6Z"
    })), _path108$i || (_path108$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewaySecurity16 = /*#__PURE__*/React__default['default'].forwardRef(function GatewaySecurity16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$i || (_path109$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,11v6.4678a5.0216,5.0216,0,0,0,2.8613,4.52L16,23l2.1387-1.0127A5.0216,5.0216,0,0,0,21,17.4678V11Zm8,6.4678a3.012,3.012,0,0,1-1.7168,2.7109L16,20.7861l-1.2832-.6074A3.012,3.012,0,0,1,13,17.4678V13h6Z"
    })), _path110$i || (_path110$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayUserAccess32 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayUserAccess32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$i || (_path111$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 22H19V20a1.0011 1.0011 0 00-1-1H14a1.0011 1.0011 0 00-1 1v2H11V20a3.0033 3.0033 0 013-3h4a3.0033 3.0033 0 013 3zM16 16a3.5 3.5 0 113.5-3.5A3.5041 3.5041 0 0116 16zm0-5a1.5 1.5 0 101.5 1.5A1.5017 1.5017 0 0016 11z"
    })), _path112$i || (_path112$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayUserAccess24 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayUserAccess24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$i || (_path113$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 22H19V20a1.0011 1.0011 0 00-1-1H14a1.0011 1.0011 0 00-1 1v2H11V20a3.0033 3.0033 0 013-3h4a3.0033 3.0033 0 013 3zM16 16a3.5 3.5 0 113.5-3.5A3.5041 3.5041 0 0116 16zm0-5a1.5 1.5 0 101.5 1.5A1.5017 1.5017 0 0016 11z"
    })), _path114$i || (_path114$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayUserAccess20 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayUserAccess20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$i || (_path115$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 22H19V20a1.0011 1.0011 0 00-1-1H14a1.0011 1.0011 0 00-1 1v2H11V20a3.0033 3.0033 0 013-3h4a3.0033 3.0033 0 013 3zM16 16a3.5 3.5 0 113.5-3.5A3.5041 3.5041 0 0116 16zm0-5a1.5 1.5 0 101.5 1.5A1.5017 1.5017 0 0016 11z"
    })), _path116$i || (_path116$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayUserAccess16 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayUserAccess16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$i || (_path117$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 22H19V20a1.0011 1.0011 0 00-1-1H14a1.0011 1.0011 0 00-1 1v2H11V20a3.0033 3.0033 0 013-3h4a3.0033 3.0033 0 013 3zM16 16a3.5 3.5 0 113.5-3.5A3.5041 3.5041 0 0116 16zm0-5a1.5 1.5 0 101.5 1.5A1.5017 1.5017 0 0016 11z"
    })), _path118$i || (_path118$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayVpn32 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayVpn32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$i || (_path119$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14.2783V12a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A1.9929,1.9929,0,0,0,20,14.2783ZM16,10a2.0023,2.0023,0,0,1,2,2v2H14V12A2.0023,2.0023,0,0,1,16,10Zm3,11H13V16h6Z"
    })), _path120$i || (_path120$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayVpn24 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayVpn24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$i || (_path121$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14.2783V12a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A1.9929,1.9929,0,0,0,20,14.2783ZM16,10a2.0023,2.0023,0,0,1,2,2v2H14V12A2.0023,2.0023,0,0,1,16,10Zm3,11H13V16h6Z"
    })), _path122$i || (_path122$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayVpn20 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayVpn20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$i || (_path123$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14.2783V12a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A1.9929,1.9929,0,0,0,20,14.2783ZM16,10a2.0023,2.0023,0,0,1,2,2v2H14V12A2.0023,2.0023,0,0,1,16,10Zm3,11H13V16h6Z"
    })), _path124$i || (_path124$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GatewayVpn16 = /*#__PURE__*/React__default['default'].forwardRef(function GatewayVpn16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$i || (_path125$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14.2783V12a4,4,0,0,0-8,0v2.2783A1.9929,1.9929,0,0,0,11,16v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V16A1.9929,1.9929,0,0,0,20,14.2783ZM16,10a2.0023,2.0023,0,0,1,2,2v2H14V12A2.0023,2.0023,0,0,1,16,10Zm3,11H13V16h6Z"
    })), _path126$i || (_path126$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var GenderFemale32 = /*#__PURE__*/React__default['default'].forwardRef(function GenderFemale32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$i || (_path127$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19.9307a8,8,0,1,0-2,0V22H10v2h5v4h2V24h5V22H17ZM10,12a6,6,0,1,1,6,6A6.0066,6.0066,0,0,1,10,12Z"
    })), children);
  });
  var GenderFemale24 = /*#__PURE__*/React__default['default'].forwardRef(function GenderFemale24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$i || (_path128$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19.9307a8,8,0,1,0-2,0V22H10v2h5v4h2V24h5V22H17ZM10,12a6,6,0,1,1,6,6A6.0066,6.0066,0,0,1,10,12Z"
    })), children);
  });
  var GenderFemale20 = /*#__PURE__*/React__default['default'].forwardRef(function GenderFemale20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$i || (_path129$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19.9307a8,8,0,1,0-2,0V22H10v2h5v4h2V24h5V22H17ZM10,12a6,6,0,1,1,6,6A6.0066,6.0066,0,0,1,10,12Z"
    })), children);
  });
  var GenderFemale16 = /*#__PURE__*/React__default['default'].forwardRef(function GenderFemale16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$i || (_path130$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19.9307a8,8,0,1,0-2,0V22H10v2h5v4h2V24h5V22H17ZM10,12a6,6,0,1,1,6,6A6.0066,6.0066,0,0,1,10,12Z"
    })), children);
  });
  var GenderMale32 = /*#__PURE__*/React__default['default'].forwardRef(function GenderMale32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$i || (_path131$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,4V6h6.5859l-7.6884,7.6885a8.028,8.028,0,1,0,1.414,1.414L26,7.4141V14h2V4ZM12,26a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,12,26Z"
    })), children);
  });
  var GenderMale24 = /*#__PURE__*/React__default['default'].forwardRef(function GenderMale24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$i || (_path132$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,4V6h6.5859l-7.6884,7.6885a8.028,8.028,0,1,0,1.414,1.414L26,7.4141V14h2V4ZM12,26a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,12,26Z"
    })), children);
  });
  var GenderMale20 = /*#__PURE__*/React__default['default'].forwardRef(function GenderMale20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$i || (_path133$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,4V6h6.5859l-7.6884,7.6885a8.028,8.028,0,1,0,1.414,1.414L26,7.4141V14h2V4ZM12,26a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,12,26Z"
    })), children);
  });
  var GenderMale16 = /*#__PURE__*/React__default['default'].forwardRef(function GenderMale16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$i || (_path134$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,4V6h6.5859l-7.6884,7.6885a8.028,8.028,0,1,0,1.414,1.414L26,7.4141V14h2V4ZM12,26a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,12,26Z"
    })), children);
  });
  var GeneratePdf32 = /*#__PURE__*/React__default['default'].forwardRef(function GeneratePdf32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$i || (_path135$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24v4H8V24H6v4H6a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2h0V24Z"
    })), _path136$i || (_path136$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21L19.586 19.586 17 22.172 17 14 15 14 15 22.172 12.414 19.586 11 21 16 26 21 21zM28 4L28 2 22 2 22 12 24 12 24 8 27 8 27 6 24 6 24 4 28 4zM17 12H13V2h4a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0117 12zm-2-2h2a1.0011 1.0011 0 001-1V5a1.0011 1.0011 0 00-1-1H15zM9 2H4V12H6V9H9a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 009 2zM6 7V4H9l.001 3z"
    })), children);
  });
  var GeneratePdf24 = /*#__PURE__*/React__default['default'].forwardRef(function GeneratePdf24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$i || (_path137$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24v4H8V24H6v4H6a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2h0V24Z"
    })), _path138$i || (_path138$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21L19.586 19.586 17 22.172 17 14 15 14 15 22.172 12.414 19.586 11 21 16 26 21 21zM28 4L28 2 22 2 22 12 24 12 24 8 27 8 27 6 24 6 24 4 28 4zM17 12H13V2h4a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0117 12zm-2-2h2a1.0011 1.0011 0 001-1V5a1.0011 1.0011 0 00-1-1H15zM9 2H4V12H6V9H9a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 009 2zM6 7V4H9l.001 3z"
    })), children);
  });
  var GeneratePdf20 = /*#__PURE__*/React__default['default'].forwardRef(function GeneratePdf20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$i || (_path139$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24v4H8V24H6v4H6a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2h0V24Z"
    })), _path140$i || (_path140$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21L19.586 19.586 17 22.172 17 14 15 14 15 22.172 12.414 19.586 11 21 16 26 21 21zM28 4L28 2 22 2 22 12 24 12 24 8 27 8 27 6 24 6 24 4 28 4zM17 12H13V2h4a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0117 12zm-2-2h2a1.0011 1.0011 0 001-1V5a1.0011 1.0011 0 00-1-1H15zM9 2H4V12H6V9H9a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 009 2zM6 7V4H9l.001 3z"
    })), children);
  });
  var GeneratePdf16 = /*#__PURE__*/React__default['default'].forwardRef(function GeneratePdf16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$i || (_path141$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24v4H8V24H6v4H6a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2h0V24Z"
    })), _path142$i || (_path142$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21L19.586 19.586 17 22.172 17 14 15 14 15 22.172 12.414 19.586 11 21 16 26 21 21zM28 4L28 2 22 2 22 12 24 12 24 8 27 8 27 6 24 6 24 4 28 4zM17 12H13V2h4a3.0033 3.0033 0 013 3V9A3.0033 3.0033 0 0117 12zm-2-2h2a1.0011 1.0011 0 001-1V5a1.0011 1.0011 0 00-1-1H15zM9 2H4V12H6V9H9a2.0027 2.0027 0 002-2V4A2.0023 2.0023 0 009 2zM6 7V4H9l.001 3z"
    })), children);
  });
  var Gif32 = /*#__PURE__*/React__default['default'].forwardRef(function Gif32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$i || (_path143$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 12v8a3 3 0 003 3h5V15H6v2H8v4H5a1 1 0 01-1-1V12a1 1 0 011-1h5V9H5A3 3 0 002 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"
    })), children);
  });
  var Gif24 = /*#__PURE__*/React__default['default'].forwardRef(function Gif24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$i || (_path144$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 12v8a3 3 0 003 3h5V15H6v2H8v4H5a1 1 0 01-1-1V12a1 1 0 011-1h5V9H5A3 3 0 002 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"
    })), children);
  });
  var Gif20 = /*#__PURE__*/React__default['default'].forwardRef(function Gif20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$i || (_path145$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 12v8a3 3 0 003 3h5V15H6v2H8v4H5a1 1 0 01-1-1V12a1 1 0 011-1h5V9H5A3 3 0 002 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"
    })), children);
  });
  var Gif16 = /*#__PURE__*/React__default['default'].forwardRef(function Gif16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$i || (_path146$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 12v8a3 3 0 003 3h5V15H6v2H8v4H5a1 1 0 01-1-1V12a1 1 0 011-1h5V9H5A3 3 0 002 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"
    })), children);
  });
  var Gift32 = /*#__PURE__*/React__default['default'].forwardRef(function Gift32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$i || (_path147$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H23.2383A4.4867,4.4867,0,0,0,16,4.7065,4.4873,4.4873,0,0,0,8.7617,10H6a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2V28a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V18a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,26,10ZM17,7.5A2.5,2.5,0,1,1,19.5,10H17ZM12.5,5A2.503,2.503,0,0,1,15,7.5V10H12.5a2.5,2.5,0,0,1,0-5ZM6,12h9v4H6Zm2,6h7V28H8ZM24.0012,28H17V18h7ZM17,16V12h9l.0012,4Z"
    })), children);
  });
  var Gift24 = /*#__PURE__*/React__default['default'].forwardRef(function Gift24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$i || (_path148$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H23.2383A4.4867,4.4867,0,0,0,16,4.7065,4.4873,4.4873,0,0,0,8.7617,10H6a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2V28a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V18a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,26,10ZM17,7.5A2.5,2.5,0,1,1,19.5,10H17ZM12.5,5A2.503,2.503,0,0,1,15,7.5V10H12.5a2.5,2.5,0,0,1,0-5ZM6,12h9v4H6Zm2,6h7V28H8ZM24.0012,28H17V18h7ZM17,16V12h9l.0012,4Z"
    })), children);
  });
  var Gift20 = /*#__PURE__*/React__default['default'].forwardRef(function Gift20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$i || (_path149$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H23.2383A4.4867,4.4867,0,0,0,16,4.7065,4.4873,4.4873,0,0,0,8.7617,10H6a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2V28a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V18a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,26,10ZM17,7.5A2.5,2.5,0,1,1,19.5,10H17ZM12.5,5A2.503,2.503,0,0,1,15,7.5V10H12.5a2.5,2.5,0,0,1,0-5ZM6,12h9v4H6Zm2,6h7V28H8ZM24.0012,28H17V18h7ZM17,16V12h9l.0012,4Z"
    })), children);
  });
  var Gift16 = /*#__PURE__*/React__default['default'].forwardRef(function Gift16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$i || (_path150$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,10H23.2383A4.4867,4.4867,0,0,0,16,4.7065,4.4873,4.4873,0,0,0,8.7617,10H6a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2V28a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V18a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,26,10ZM17,7.5A2.5,2.5,0,1,1,19.5,10H17ZM12.5,5A2.503,2.503,0,0,1,15,7.5V10H12.5a2.5,2.5,0,0,1,0-5ZM6,12h9v4H6Zm2,6h7V28H8ZM24.0012,28H17V18h7ZM17,16V12h9l.0012,4Z"
    })), children);
  });
  var Globe32 = /*#__PURE__*/React__default['default'].forwardRef(function Globe32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$i || (_path151$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"
    })), _path152$i || (_path152$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11a13.9563,13.9563,0,0,0-4.1051-9.8949L22.4813,2.5187A11.9944,11.9944,0,0,1,5.5568,19.5194l-.0381-.0381L4.1051,20.8949A13.9563,13.9563,0,0,0,14,25v3H10v2H20V28H16V24.84A14.0094,14.0094,0,0,0,28,11Z"
    })), children);
  });
  var Globe24 = /*#__PURE__*/React__default['default'].forwardRef(function Globe24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$i || (_path153$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"
    })), _path154$i || (_path154$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11a13.9563,13.9563,0,0,0-4.1051-9.8949L22.4813,2.5187A11.9944,11.9944,0,0,1,5.5568,19.5194l-.0381-.0381L4.1051,20.8949A13.9563,13.9563,0,0,0,14,25v3H10v2H20V28H16V24.84A14.0094,14.0094,0,0,0,28,11Z"
    })), children);
  });
  var Globe20 = /*#__PURE__*/React__default['default'].forwardRef(function Globe20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$i || (_path155$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"
    })), _path156$i || (_path156$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11a13.9563,13.9563,0,0,0-4.1051-9.8949L22.4813,2.5187A11.9944,11.9944,0,0,1,5.5568,19.5194l-.0381-.0381L4.1051,20.8949A13.9563,13.9563,0,0,0,14,25v3H10v2H20V28H16V24.84A14.0094,14.0094,0,0,0,28,11Z"
    })), children);
  });
  var Globe16 = /*#__PURE__*/React__default['default'].forwardRef(function Globe16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$i || (_path157$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"
    })), _path158$i || (_path158$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11a13.9563,13.9563,0,0,0-4.1051-9.8949L22.4813,2.5187A11.9944,11.9944,0,0,1,5.5568,19.5194l-.0381-.0381L4.1051,20.8949A13.9563,13.9563,0,0,0,14,25v3H10v2H20V28H16V24.84A14.0094,14.0094,0,0,0,28,11Z"
    })), children);
  });
  var GlyphCautionGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphCautionGlyph(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphCautionGlyph']) {
        didWarnAboutDeprecation$6['GlyphCautionGlyph'] = true;
        console.warn("The GlyphCautionGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$i || (_path159$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.3154,12H3.6846L8,4.0884,12.3154,12M14,13,8,2,2,13Z"
    })), _path160$i || (_path160$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.315 12L3.685 12 8 4.088 12.315 12z"
    })), children);
  });
  var GlyphCautionInvertedGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphCautionInvertedGlyph(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphCautionInvertedGlyph']) {
        didWarnAboutDeprecation$6['GlyphCautionInvertedGlyph'] = true;
        console.warn("The GlyphCautionInvertedGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$i || (_path161$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14L2 3 14 3 8 14z"
    })), children);
  });
  var GlyphCircleFillGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphCircleFillGlyph(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphCircleFillGlyph']) {
        didWarnAboutDeprecation$6['GlyphCircleFillGlyph'] = true;
        console.warn("The GlyphCircleFillGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle33$a || (_circle33$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "8",
      r: "6"
    })), children);
  });
  var GlyphCircleStrokeGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphCircleStrokeGlyph(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphCircleStrokeGlyph']) {
        didWarnAboutDeprecation$6['GlyphCircleStrokeGlyph'] = true;
        console.warn("The GlyphCircleStrokeGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$i || (_path162$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,4A4,4,0,1,1,4,8,4.0045,4.0045,0,0,1,8,4M8,2a6,6,0,1,0,6,6A6,6,0,0,0,8,2Z"
    })), children);
  });
  var GlyphCriticalGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphCriticalGlyph(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphCriticalGlyph']) {
        didWarnAboutDeprecation$6['GlyphCriticalGlyph'] = true;
        console.warn("The GlyphCriticalGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$i || (_path163$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.887 11.4727a5.9936 5.9936 0 00-8.36-8.3594zM3.113 4.5273a5.9936 5.9936 0 008.36 8.3594z"
    })), children);
  });
  var GlyphIncompleteGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphIncompleteGlyph(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphIncompleteGlyph']) {
        didWarnAboutDeprecation$6['GlyphIncompleteGlyph'] = true;
        console.warn("The GlyphIncompleteGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$i || (_path164$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2a6,6,0,1,0,6,6A6,6,0,0,0,8,2ZM8,4a4.0045,4.0045,0,0,1,4,4H4A4.0045,4.0045,0,0,1,8,4Z"
    })), children);
  });
  var GlyphSquareFillGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphSquareFillGlyph(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphSquareFillGlyph']) {
        didWarnAboutDeprecation$6['GlyphSquareFillGlyph'] = true;
        console.warn("The GlyphSquareFillGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$i || (_path165$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H13V13H3z"
    })), children);
  });
  var GlyphUndefinedGlyph = /*#__PURE__*/React__default['default'].forwardRef(function GlyphUndefinedGlyph(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$i);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$6['GlyphUndefinedGlyph']) {
        didWarnAboutDeprecation$6['GlyphUndefinedGlyph'] = true;
        console.warn("The GlyphUndefinedGlyph component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$i || (_path166$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2.4142,13.5858,8,8,13.5858,2.4142,8,8,2.4142M8,1,1,8l7,7,7-7L8,1Z"
    })), _path167$i || (_path167$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2.4142,13.5858,8,8,13.5858,2.4142,8,8,2.4142"
    })), children);
  });
  var Gradient32 = /*#__PURE__*/React__default['default'].forwardRef(function Gradient32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$i || (_path168$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0023,2.0023,0,0,0,4,6V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM22,26V22H18v4H14V22H10V18h4V14H10V10h4V6h4v4h4V6h4V26Z"
    })), _path169$i || (_path169$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10H18V14H14zM14 18H18V22H14zM18 14H22V18H18z"
    })), children);
  });
  var Gradient24 = /*#__PURE__*/React__default['default'].forwardRef(function Gradient24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$i || (_path170$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0023,2.0023,0,0,0,4,6V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM22,26V22H18v4H14V22H10V18h4V14H10V10h4V6h4v4h4V6h4V26Z"
    })), _path171$i || (_path171$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10H18V14H14zM14 18H18V22H14zM18 14H22V18H18z"
    })), children);
  });
  var Gradient20 = /*#__PURE__*/React__default['default'].forwardRef(function Gradient20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$i || (_path172$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0023,2.0023,0,0,0,4,6V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM22,26V22H18v4H14V22H10V18h4V14H10V10h4V6h4v4h4V6h4V26Z"
    })), _path173$i || (_path173$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10H18V14H14zM14 18H18V22H14zM18 14H22V18H18z"
    })), children);
  });
  var Gradient16 = /*#__PURE__*/React__default['default'].forwardRef(function Gradient16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$i || (_path174$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0023,2.0023,0,0,0,4,6V26a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM22,26V22H18v4H14V22H10V18h4V14H10V10h4V6h4v4h4V6h4V26Z"
    })), _path175$i || (_path175$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10H18V14H14zM14 18H18V22H14zM18 14H22V18H18z"
    })), children);
  });
  var GraphicalDataFlow32 = /*#__PURE__*/React__default['default'].forwardRef(function GraphicalDataFlow32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$i || (_path176$i = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 30zm-6-8h-.0012L22 28h6V22zM18 26H12a3.0033 3.0033 0 01-3-3V19h2v4a1.001 1.001 0 001 1h6zM26 18H24V15a1.001 1.001 0 00-1-1H18V12h5a3.0033 3.0033 0 013 3zM15 18a.9986.9986 0 01-.4971-.1323L10 15.2886 5.4968 17.8677a1 1 0 01-1.4712-1.0938l1.0618-4.572L2.269 9.1824a1 1 0 01.5662-1.6687l4.2-.7019L9.1006 2.5627a1 1 0 011.7881-.0214l2.2046 4.271 4.0764.7021a1 1 0 01.5613 1.668l-2.8184 3.02 1.0613 4.5718A1 1 0 0115 18zm-5-5s.343.18.4971.2686l3.01 1.7241-.7837-3.3763 2.282-2.4453-3.2331-.5569-1.7456-3.382L8.3829 8.6144l-3.3809.565 2.2745 2.437-.7841 3.3763 3.0105-1.7241C9.657 13.18 10 13 10 13z"
    })), children);
  });
  var GraphicalDataFlow24 = /*#__PURE__*/React__default['default'].forwardRef(function GraphicalDataFlow24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$h || (_path177$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 30zm-6-8h-.0012L22 28h6V22zM18 26H12a3.0033 3.0033 0 01-3-3V19h2v4a1.001 1.001 0 001 1h6zM26 18H24V15a1.001 1.001 0 00-1-1H18V12h5a3.0033 3.0033 0 013 3zM15 18a.9986.9986 0 01-.4971-.1323L10 15.2886 5.4968 17.8677a1 1 0 01-1.4712-1.0938l1.0618-4.572L2.269 9.1824a1 1 0 01.5662-1.6687l4.2-.7019L9.1006 2.5627a1 1 0 011.7881-.0214l2.2046 4.271 4.0764.7021a1 1 0 01.5613 1.668l-2.8184 3.02 1.0613 4.5718A1 1 0 0115 18zm-5-5s.343.18.4971.2686l3.01 1.7241-.7837-3.3763 2.282-2.4453-3.2331-.5569-1.7456-3.382L8.3829 8.6144l-3.3809.565 2.2745 2.437-.7841 3.3763 3.0105-1.7241C9.657 13.18 10 13 10 13z"
    })), children);
  });
  var GraphicalDataFlow20 = /*#__PURE__*/React__default['default'].forwardRef(function GraphicalDataFlow20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$h || (_path178$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 30zm-6-8h-.0012L22 28h6V22zM18 26H12a3.0033 3.0033 0 01-3-3V19h2v4a1.001 1.001 0 001 1h6zM26 18H24V15a1.001 1.001 0 00-1-1H18V12h5a3.0033 3.0033 0 013 3zM15 18a.9986.9986 0 01-.4971-.1323L10 15.2886 5.4968 17.8677a1 1 0 01-1.4712-1.0938l1.0618-4.572L2.269 9.1824a1 1 0 01.5662-1.6687l4.2-.7019L9.1006 2.5627a1 1 0 011.7881-.0214l2.2046 4.271 4.0764.7021a1 1 0 01.5613 1.668l-2.8184 3.02 1.0613 4.5718A1 1 0 0115 18zm-5-5s.343.18.4971.2686l3.01 1.7241-.7837-3.3763 2.282-2.4453-3.2331-.5569-1.7456-3.382L8.3829 8.6144l-3.3809.565 2.2745 2.437-.7841 3.3763 3.0105-1.7241C9.657 13.18 10 13 10 13z"
    })), children);
  });
  var GraphicalDataFlow16 = /*#__PURE__*/React__default['default'].forwardRef(function GraphicalDataFlow16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$h || (_path179$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H22a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 30zm-6-8h-.0012L22 28h6V22zM18 26H12a3.0033 3.0033 0 01-3-3V19h2v4a1.001 1.001 0 001 1h6zM26 18H24V15a1.001 1.001 0 00-1-1H18V12h5a3.0033 3.0033 0 013 3zM15 18a.9986.9986 0 01-.4971-.1323L10 15.2886 5.4968 17.8677a1 1 0 01-1.4712-1.0938l1.0618-4.572L2.269 9.1824a1 1 0 01.5662-1.6687l4.2-.7019L9.1006 2.5627a1 1 0 011.7881-.0214l2.2046 4.271 4.0764.7021a1 1 0 01.5613 1.668l-2.8184 3.02 1.0613 4.5718A1 1 0 0115 18zm-5-5s.343.18.4971.2686l3.01 1.7241-.7837-3.3763 2.282-2.4453-3.2331-.5569-1.7456-3.382L8.3829 8.6144l-3.3809.565 2.2745 2.437-.7841 3.3763 3.0105-1.7241C9.657 13.18 10 13 10 13z"
    })), children);
  });
  var Grid32 = /*#__PURE__*/React__default['default'].forwardRef(function Grid32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$h || (_path180$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0012 4zm0 8H6V6h6zM26 4H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0026 4zm0 8H20V6h6zM12 18H6a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0012 18zm0 8H6V20h6zM26 18H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0026 18zm0 8H20V20h6z"
    })), children);
  });
  var Grid24 = /*#__PURE__*/React__default['default'].forwardRef(function Grid24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$h || (_path181$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0012 4zm0 8H6V6h6zM26 4H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0026 4zm0 8H20V6h6zM12 18H6a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0012 18zm0 8H6V20h6zM26 18H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0026 18zm0 8H20V20h6z"
    })), children);
  });
  var Grid20 = /*#__PURE__*/React__default['default'].forwardRef(function Grid20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$h || (_path182$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0012 4zm0 8H6V6h6zM26 4H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0026 4zm0 8H20V6h6zM12 18H6a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0012 18zm0 8H6V20h6zM26 18H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0026 18zm0 8H20V20h6z"
    })), children);
  });
  var Grid16 = /*#__PURE__*/React__default['default'].forwardRef(function Grid16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$h || (_path183$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0012 4zm0 8H6V6h6zM26 4H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6A2 2 0 0026 4zm0 8H20V6h6zM12 18H6a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0012 18zm0 8H6V20h6zM26 18H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V20A2 2 0 0026 18zm0 8H20V20h6z"
    })), children);
  });
  var Group32 = /*#__PURE__*/React__default['default'].forwardRef(function Group32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$h || (_path184$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 30H29V27a3 3 0 00-3-3H22a3 3 0 00-3 3v3H17V27a5 5 0 015-5h4a5 5 0 015 5zM24 12a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 10zM15 22H13V19a3 3 0 00-3-3H6a3 3 0 00-3 3v3H1V19a5 5 0 015-5h4a5 5 0 015 5zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var Group24 = /*#__PURE__*/React__default['default'].forwardRef(function Group24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$h || (_path185$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 30H29V27a3 3 0 00-3-3H22a3 3 0 00-3 3v3H17V27a5 5 0 015-5h4a5 5 0 015 5zM24 12a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 10zM15 22H13V19a3 3 0 00-3-3H6a3 3 0 00-3 3v3H1V19a5 5 0 015-5h4a5 5 0 015 5zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var Group20 = /*#__PURE__*/React__default['default'].forwardRef(function Group20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$h || (_path186$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 30H29V27a3 3 0 00-3-3H22a3 3 0 00-3 3v3H17V27a5 5 0 015-5h4a5 5 0 015 5zM24 12a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 10zM15 22H13V19a3 3 0 00-3-3H6a3 3 0 00-3 3v3H1V19a5 5 0 015-5h4a5 5 0 015 5zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var Group16 = /*#__PURE__*/React__default['default'].forwardRef(function Group16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$i);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$h || (_path187$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 30H29V27a3 3 0 00-3-3H22a3 3 0 00-3 3v3H17V27a5 5 0 015-5h4a5 5 0 015 5zM24 12a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0024 10zM15 22H13V19a3 3 0 00-3-3H6a3 3 0 00-3 3v3H1V19a5 5 0 015-5h4a5 5 0 015 5zM8 4A3 3 0 115 7 3 3 0 018 4M8 2a5 5 0 105 5A5 5 0 008 2z"
    })), children);
  });
  var GroupAccess32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccess32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$h || (_path188$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 19H6V17a3.0033 3.0033 0 013-3h5v2H9a1.0011 1.0011 0 00-1 1zM12 13a4 4 0 114-4A4.0045 4.0045 0 0112 13zm0-6a2 2 0 102 2A2.0021 2.0021 0 0012 7zM20 20a4 4 0 114-4A4.0045 4.0045 0 0120 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0020 14zM26 26H24V24a1.0011 1.0011 0 00-1-1H17a1.0011 1.0011 0 00-1 1v2H14V24a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path189$h || (_path189$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccess24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccess24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$h || (_path190$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 19H6V17a3.0033 3.0033 0 013-3h5v2H9a1.0011 1.0011 0 00-1 1zM12 13a4 4 0 114-4A4.0045 4.0045 0 0112 13zm0-6a2 2 0 102 2A2.0021 2.0021 0 0012 7zM20 20a4 4 0 114-4A4.0045 4.0045 0 0120 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0020 14zM26 26H24V24a1.0011 1.0011 0 00-1-1H17a1.0011 1.0011 0 00-1 1v2H14V24a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path191$h || (_path191$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccess20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccess20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$h || (_path192$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 19H6V17a3.0033 3.0033 0 013-3h5v2H9a1.0011 1.0011 0 00-1 1zM12 13a4 4 0 114-4A4.0045 4.0045 0 0112 13zm0-6a2 2 0 102 2A2.0021 2.0021 0 0012 7zM20 20a4 4 0 114-4A4.0045 4.0045 0 0120 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0020 14zM26 26H24V24a1.0011 1.0011 0 00-1-1H17a1.0011 1.0011 0 00-1 1v2H14V24a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path193$h || (_path193$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccess16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccess16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$h || (_path194$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 19H6V17a3.0033 3.0033 0 013-3h5v2H9a1.0011 1.0011 0 00-1 1zM12 13a4 4 0 114-4A4.0045 4.0045 0 0112 13zm0-6a2 2 0 102 2A2.0021 2.0021 0 0012 7zM20 20a4 4 0 114-4A4.0045 4.0045 0 0120 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0020 14zM26 26H24V24a1.0011 1.0011 0 00-1-1H17a1.0011 1.0011 0 00-1 1v2H14V24a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path195$h || (_path195$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccount32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccount32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$h || (_path196$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11H11a3 3 0 00-3 3v4h2V14a1 1 0 011-1h6a1 1 0 011 1v1h2V14A3 3 0 0017 11zM10 6a4 4 0 104-4A4 4 0 0010 6zm6 0a2 2 0 11-2-2A2 2 0 0116 6zM22 27H16a2.0021 2.0021 0 01-2-2V19a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0122 27zm-6-8v6h6V19zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccount24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccount24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$h || (_path197$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11H11a3 3 0 00-3 3v4h2V14a1 1 0 011-1h6a1 1 0 011 1v1h2V14A3 3 0 0017 11zM10 6a4 4 0 104-4A4 4 0 0010 6zm6 0a2 2 0 11-2-2A2 2 0 0116 6zM22 27H16a2.0021 2.0021 0 01-2-2V19a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0122 27zm-6-8v6h6V19zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccount20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccount20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$h || (_path198$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11H11a3 3 0 00-3 3v4h2V14a1 1 0 011-1h6a1 1 0 011 1v1h2V14A3 3 0 0017 11zM10 6a4 4 0 104-4A4 4 0 0010 6zm6 0a2 2 0 11-2-2A2 2 0 0116 6zM22 27H16a2.0021 2.0021 0 01-2-2V19a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0122 27zm-6-8v6h6V19zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupAccount16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupAccount16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$h || (_path199$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11H11a3 3 0 00-3 3v4h2V14a1 1 0 011-1h6a1 1 0 011 1v1h2V14A3 3 0 0017 11zM10 6a4 4 0 104-4A4 4 0 0010 6zm6 0a2 2 0 11-2-2A2 2 0 0116 6zM22 27H16a2.0021 2.0021 0 01-2-2V19a2.0021 2.0021 0 012-2h6a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0122 27zm-6-8v6h6V19zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupPresentation32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupPresentation32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$h || (_path200$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 30H8V27H4v3H2V27a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2zM30 30H28V27H24v3H22V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2zM20 30H18V27H14v3H12V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2z"
    })), _circle34$9 || (_circle34$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22",
      r: "2"
    })), _circle35$9 || (_circle35$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "22",
      r: "2"
    })), _circle36$9 || (_circle36$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "22",
      r: "2"
    })), _circle37$7 || (_circle37$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _circle38$7 || (_circle38$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "18",
      r: "2"
    })), _path201$h || (_path201$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,26,14ZM6,4v8H26V4Z"
    })), children);
  });
  var GroupPresentation24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupPresentation24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$h || (_path202$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 30H8V27H4v3H2V27a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2zM30 30H28V27H24v3H22V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2zM20 30H18V27H14v3H12V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2z"
    })), _circle39$7 || (_circle39$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22",
      r: "2"
    })), _circle40$7 || (_circle40$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "22",
      r: "2"
    })), _circle41$6 || (_circle41$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "22",
      r: "2"
    })), _circle42$6 || (_circle42$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _circle43$6 || (_circle43$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "18",
      r: "2"
    })), _path203$h || (_path203$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,26,14ZM6,4v8H26V4Z"
    })), children);
  });
  var GroupPresentation20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupPresentation20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$h || (_path204$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 30H8V27H4v3H2V27a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2zM30 30H28V27H24v3H22V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2zM20 30H18V27H14v3H12V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2z"
    })), _circle44$6 || (_circle44$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22",
      r: "2"
    })), _circle45$6 || (_circle45$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "22",
      r: "2"
    })), _circle46$6 || (_circle46$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "22",
      r: "2"
    })), _circle47$6 || (_circle47$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _circle48$6 || (_circle48$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "18",
      r: "2"
    })), _path205$h || (_path205$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,26,14ZM6,4v8H26V4Z"
    })), children);
  });
  var GroupPresentation16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupPresentation16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$h || (_path206$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 30H8V27H4v3H2V27a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2zM30 30H28V27H24v3H22V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2zM20 30H18V27H14v3H12V27a2.0023 2.0023 0 012-2h4a2.0023 2.0023 0 012 2z"
    })), _circle49$5 || (_circle49$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22",
      r: "2"
    })), _circle50$5 || (_circle50$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "6",
      cy: "22",
      r: "2"
    })), _circle51$5 || (_circle51$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "22",
      r: "2"
    })), _circle52$5 || (_circle52$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "18",
      r: "2"
    })), _circle53$4 || (_circle53$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "18",
      r: "2"
    })), _path207$h || (_path207$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14H6a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,6,2H26a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,26,14ZM6,4v8H26V4Z"
    })), children);
  });
  var GroupResource32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupResource32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$h || (_path208$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2H22a2.0021 2.0021 0 012 2V22A2.0021 2.0021 0 0122 24zM10 10V22H22V10zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupResource24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupResource24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$h || (_path209$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2H22a2.0021 2.0021 0 012 2V22A2.0021 2.0021 0 0122 24zM10 10V22H22V10zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupResource20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupResource20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$h || (_path210$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2H22a2.0021 2.0021 0 012 2V22A2.0021 2.0021 0 0122 24zM10 10V22H22V10zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupResource16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupResource16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$h || (_path211$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0021 2.0021 0 01-2-2V10a2.0021 2.0021 0 012-2H22a2.0021 2.0021 0 012 2V22A2.0021 2.0021 0 0122 24zM10 10V22H22V10zM8 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H8V4H4V28H8zM28 30H24V28h4V4H24V2h4a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), children);
  });
  var GroupSecurity32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupSecurity32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$h || (_path212$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H9V19a3.0033 3.0033 0 013-3h6v2H12a1.0011 1.0011 0 00-1 1zM15 15a4 4 0 114-4A4.0045 4.0045 0 0115 15zm0-6a2 2 0 102 2A2.0021 2.0021 0 0015 9zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 16zM30 28H28V26a1.0011 1.0011 0 00-1-1H21a1.0011 1.0011 0 00-1 1v2H18V26a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path213$h || (_path213$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var GroupSecurity24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupSecurity24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$h || (_path214$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H9V19a3.0033 3.0033 0 013-3h6v2H12a1.0011 1.0011 0 00-1 1zM15 15a4 4 0 114-4A4.0045 4.0045 0 0115 15zm0-6a2 2 0 102 2A2.0021 2.0021 0 0015 9zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 16zM30 28H28V26a1.0011 1.0011 0 00-1-1H21a1.0011 1.0011 0 00-1 1v2H18V26a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path215$h || (_path215$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var GroupSecurity20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupSecurity20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$h || (_path216$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H9V19a3.0033 3.0033 0 013-3h6v2H12a1.0011 1.0011 0 00-1 1zM15 15a4 4 0 114-4A4.0045 4.0045 0 0115 15zm0-6a2 2 0 102 2A2.0021 2.0021 0 0015 9zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 16zM30 28H28V26a1.0011 1.0011 0 00-1-1H21a1.0011 1.0011 0 00-1 1v2H18V26a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path217$h || (_path217$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var GroupSecurity16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupSecurity16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$h || (_path218$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H9V19a3.0033 3.0033 0 013-3h6v2H12a1.0011 1.0011 0 00-1 1zM15 15a4 4 0 114-4A4.0045 4.0045 0 0115 15zm0-6a2 2 0 102 2A2.0021 2.0021 0 0015 9zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 16zM30 28H28V26a1.0011 1.0011 0 00-1-1H21a1.0011 1.0011 0 00-1 1v2H18V26a3.0033 3.0033 0 013-3h6a3.0033 3.0033 0 013 3z"
    })), _path219$h || (_path219$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var GroupObjects32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjects32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$h || (_path220$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,13V9H9V19h4v4H23V13Zm-8-2h6v6H11ZM21,21H15V19h4V15h2Z"
    })), _path221$h || (_path221$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjects24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjects24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$h || (_path222$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,13V9H9V19h4v4H23V13Zm-8-2h6v6H11ZM21,21H15V19h4V15h2Z"
    })), _path223$h || (_path223$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjects20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjects20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$h || (_path224$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,13V9H9V19h4v4H23V13Zm-8-2h6v6H11ZM21,21H15V19h4V15h2Z"
    })), _path225$h || (_path225$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjects16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjects16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$h || (_path226$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,13V9H9V19h4v4H23V13Zm-8-2h6v6H11ZM21,21H15V19h4V15h2Z"
    })), _path227$h || (_path227$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsNew32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsNew32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$h || (_path228$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10L15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15 17 15 17 10z"
    })), _path229$h || (_path229$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsNew24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsNew24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$h || (_path230$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10L15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15 17 15 17 10z"
    })), _path231$h || (_path231$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsNew20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsNew20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$h || (_path232$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10L15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15 17 15 17 10z"
    })), _path233$h || (_path233$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsNew16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsNew16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$h || (_path234$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 10L15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15 17 15 17 10z"
    })), _path235$h || (_path235$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsSave32 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsSave32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$h || (_path236$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 18.18L10.41 14.59 9 16 14 21 23 12 21.59 10.581 14 18.18z"
    })), _path237$h || (_path237$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsSave24 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsSave24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$h || (_path238$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 18.18L10.41 14.59 9 16 14 21 23 12 21.59 10.581 14 18.18z"
    })), _path239$h || (_path239$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsSave20 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsSave20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$h || (_path240$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 18.18L10.41 14.59 9 16 14 21 23 12 21.59 10.581 14 18.18z"
    })), _path241$h || (_path241$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var GroupObjectsSave16 = /*#__PURE__*/React__default['default'].forwardRef(function GroupObjectsSave16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$h || (_path242$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 18.18L10.41 14.59 9 16 14 21 23 12 21.59 10.581 14 18.18z"
    })), _path243$h || (_path243$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V2H24V4H8V2H2V8H4V24H2v6H8V28H24v2h6V24H28V8ZM26,4h2V6H26ZM4,4H6V6H4ZM6,28H4V26H6Zm22,0H26V26h2Zm-2-4H24v2H8V24H6V8H8V6H24V8h2Z"
    })), children);
  });
  var Growth32 = /*#__PURE__*/React__default['default'].forwardRef(function Growth32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$h || (_path244$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8v2h6.5859L18,18.5859,13.707,14.293a.9994.9994,0,0,0-1.414,0L2,24.5859,3.4141,26,13,16.4141l4.293,4.2929a.9994.9994,0,0,0,1.414,0L28,11.4141V18h2V8Z"
    })), children);
  });
  var Growth24 = /*#__PURE__*/React__default['default'].forwardRef(function Growth24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$h || (_path245$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8v2h6.5859L18,18.5859,13.707,14.293a.9994.9994,0,0,0-1.414,0L2,24.5859,3.4141,26,13,16.4141l4.293,4.2929a.9994.9994,0,0,0,1.414,0L28,11.4141V18h2V8Z"
    })), children);
  });
  var Growth20 = /*#__PURE__*/React__default['default'].forwardRef(function Growth20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$h || (_path246$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8v2h6.5859L18,18.5859,13.707,14.293a.9994.9994,0,0,0-1.414,0L2,24.5859,3.4141,26,13,16.4141l4.293,4.2929a.9994.9994,0,0,0,1.414,0L28,11.4141V18h2V8Z"
    })), children);
  });
  var Growth16 = /*#__PURE__*/React__default['default'].forwardRef(function Growth16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$h || (_path247$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8v2h6.5859L18,18.5859,13.707,14.293a.9994.9994,0,0,0-1.414,0L2,24.5859,3.4141,26,13,16.4141l4.293,4.2929a.9994.9994,0,0,0,1.414,0L28,11.4141V18h2V8Z"
    })), children);
  });
  var Gui32 = /*#__PURE__*/React__default['default'].forwardRef(function Gui32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle54$4 || (_circle54$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle55$3 || (_circle55$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle56$3 || (_circle56$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), _path248$h || (_path248$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4Zm0,2v4H4V6ZM4,12h6V26H4Zm8,14V12H28V26Z"
    })), children);
  });
  var Gui24 = /*#__PURE__*/React__default['default'].forwardRef(function Gui24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle57$3 || (_circle57$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle58$3 || (_circle58$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle59$3 || (_circle59$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), _path249$h || (_path249$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4Zm0,2v4H4V6ZM4,12h6V26H4Zm8,14V12H28V26Z"
    })), children);
  });
  var Gui20 = /*#__PURE__*/React__default['default'].forwardRef(function Gui20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle60$3 || (_circle60$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle61$3 || (_circle61$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle62$3 || (_circle62$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), _path250$h || (_path250$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4Zm0,2v4H4V6ZM4,12h6V26H4Zm8,14V12H28V26Z"
    })), children);
  });
  var Gui16 = /*#__PURE__*/React__default['default'].forwardRef(function Gui16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle63$3 || (_circle63$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle64$3 || (_circle64$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle65$3 || (_circle65$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), _path251$h || (_path251$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,28,4Zm0,2v4H4V6ZM4,12h6V26H4Zm8,14V12H28V26Z"
    })), children);
  });
  var GuiManagement32 = /*#__PURE__*/React__default['default'].forwardRef(function GuiManagement32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$h || (_path252$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path253$h || (_path253$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.002,2.002,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H14V26H4V12H28v3h2V6A2.0023,2.0023,0,0,0,28,4Zm0,6H4V6H28Z"
    })), _circle66$3 || (_circle66$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle67$3 || (_circle67$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle68$3 || (_circle68$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), children);
  });
  var GuiManagement24 = /*#__PURE__*/React__default['default'].forwardRef(function GuiManagement24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$h || (_path254$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path255$h || (_path255$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.002,2.002,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H14V26H4V12H28v3h2V6A2.0023,2.0023,0,0,0,28,4Zm0,6H4V6H28Z"
    })), _circle69$3 || (_circle69$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle70$3 || (_circle70$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle71$3 || (_circle71$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), children);
  });
  var GuiManagement20 = /*#__PURE__*/React__default['default'].forwardRef(function GuiManagement20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$h || (_path256$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path257$h || (_path257$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.002,2.002,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H14V26H4V12H28v3h2V6A2.0023,2.0023,0,0,0,28,4Zm0,6H4V6H28Z"
    })), _circle72$3 || (_circle72$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle73$2 || (_circle73$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle74$2 || (_circle74$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), children);
  });
  var GuiManagement16 = /*#__PURE__*/React__default['default'].forwardRef(function GuiManagement16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$h || (_path258$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path259$h || (_path259$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2.002,2.002,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H14V26H4V12H28v3h2V6A2.0023,2.0023,0,0,0,28,4Zm0,6H4V6H28Z"
    })), _circle75$2 || (_circle75$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "8",
      r: "1"
    })), _circle76$2 || (_circle76$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "8",
      r: "1"
    })), _circle77$2 || (_circle77$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "1"
    })), children);
  });
  var QH32 = /*#__PURE__*/React__default['default'].forwardRef(function QH32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$h || (_path260$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), children);
  });
  var QH24 = /*#__PURE__*/React__default['default'].forwardRef(function QH24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$h || (_path261$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), children);
  });
  var QH20 = /*#__PURE__*/React__default['default'].forwardRef(function QH20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$h || (_path262$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), children);
  });
  var QH16 = /*#__PURE__*/React__default['default'].forwardRef(function QH16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$h || (_path263$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), children);
  });
  var Hail32 = /*#__PURE__*/React__default['default'].forwardRef(function Hail32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle78$2 || (_circle78$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _circle79$2 || (_circle79$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle80$2 || (_circle80$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "25.5",
      r: "1.5"
    })), _circle81$2 || (_circle81$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.5",
      cy: "29.5",
      r: "1.5"
    })), _circle82$2 || (_circle82$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.499",
      cy: "29.5",
      r: "1.5"
    })), _path264$h || (_path264$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path265$h || (_path265$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var Hail24 = /*#__PURE__*/React__default['default'].forwardRef(function Hail24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle83$2 || (_circle83$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _circle84$2 || (_circle84$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle85$1 || (_circle85$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "25.5",
      r: "1.5"
    })), _circle86$1 || (_circle86$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.5",
      cy: "29.5",
      r: "1.5"
    })), _circle87$1 || (_circle87$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.499",
      cy: "29.5",
      r: "1.5"
    })), _path266$h || (_path266$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path267$h || (_path267$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var Hail20 = /*#__PURE__*/React__default['default'].forwardRef(function Hail20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle88$1 || (_circle88$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _circle89$1 || (_circle89$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle90$1 || (_circle90$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "25.5",
      r: "1.5"
    })), _circle91$1 || (_circle91$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.5",
      cy: "29.5",
      r: "1.5"
    })), _circle92$1 || (_circle92$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.499",
      cy: "29.5",
      r: "1.5"
    })), _path268$h || (_path268$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path269$h || (_path269$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var Hail16 = /*#__PURE__*/React__default['default'].forwardRef(function Hail16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle93$1 || (_circle93$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _circle94$1 || (_circle94$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle95$1 || (_circle95$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "25.5",
      r: "1.5"
    })), _circle96$1 || (_circle96$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4.5",
      cy: "29.5",
      r: "1.5"
    })), _circle97$1 || (_circle97$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.499",
      cy: "29.5",
      r: "1.5"
    })), _path270$h || (_path270$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path271$h || (_path271$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,20H9v2H8.5A6.4973,6.4973,0,0,1,7.2,9.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,22Z"
    })), children);
  });
  var WatsonHealthHangingProtocol32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHangingProtocol32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$h || (_path272$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"
    })), children);
  });
  var WatsonHealthHangingProtocol24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHangingProtocol24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$h || (_path273$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"
    })), children);
  });
  var WatsonHealthHangingProtocol20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHangingProtocol20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$h || (_path274$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"
    })), children);
  });
  var WatsonHealthHangingProtocol16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHangingProtocol16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$h || (_path275$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"
    })), children);
  });
  var Harbor32 = /*#__PURE__*/React__default['default'].forwardRef(function Harbor32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$h || (_path276$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,17A11.0109,11.0109,0,0,1,17,27.9492V14h6V12H17V9.8579a4,4,0,1,0-2,0V12H9v2h6V27.9492A11.0109,11.0109,0,0,1,5,17H3a13,13,0,0,0,26,0ZM14,6a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,14,6Z"
    })), children);
  });
  var Harbor24 = /*#__PURE__*/React__default['default'].forwardRef(function Harbor24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$h || (_path277$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,17A11.0109,11.0109,0,0,1,17,27.9492V14h6V12H17V9.8579a4,4,0,1,0-2,0V12H9v2h6V27.9492A11.0109,11.0109,0,0,1,5,17H3a13,13,0,0,0,26,0ZM14,6a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,14,6Z"
    })), children);
  });
  var Harbor20 = /*#__PURE__*/React__default['default'].forwardRef(function Harbor20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$h || (_path278$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,17A11.0109,11.0109,0,0,1,17,27.9492V14h6V12H17V9.8579a4,4,0,1,0-2,0V12H9v2h6V27.9492A11.0109,11.0109,0,0,1,5,17H3a13,13,0,0,0,26,0ZM14,6a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,14,6Z"
    })), children);
  });
  var Harbor16 = /*#__PURE__*/React__default['default'].forwardRef(function Harbor16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$h || (_path279$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,17A11.0109,11.0109,0,0,1,17,27.9492V14h6V12H17V9.8579a4,4,0,1,0-2,0V12H9v2h6V27.9492A11.0109,11.0109,0,0,1,5,17H3a13,13,0,0,0,26,0ZM14,6a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,14,6Z"
    })), children);
  });
  var HardwareSecurityModule32 = /*#__PURE__*/React__default['default'].forwardRef(function HardwareSecurityModule32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle98$1 || (_circle98$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "7.5",
      r: "1.5"
    })), _path280$h || (_path280$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4143 20H9V14.5857l6.03-6.03A5.3518 5.3518 0 0115 8a6 6 0 116 6 5.3583 5.3583 0 01-.5559-.03zM11 18h2.5857l6.1706-6.1709.5174.0957A3.935 3.935 0 0021 12a4.0507 4.0507 0 10-3.925-3.2729l.0952.5166L11 15.4143zM28 20H19v2h9v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle99$1 || (_circle99$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var HardwareSecurityModule24 = /*#__PURE__*/React__default['default'].forwardRef(function HardwareSecurityModule24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle100$1 || (_circle100$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "7.5",
      r: "1.5"
    })), _path281$h || (_path281$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4143 20H9V14.5857l6.03-6.03A5.3518 5.3518 0 0115 8a6 6 0 116 6 5.3583 5.3583 0 01-.5559-.03zM11 18h2.5857l6.1706-6.1709.5174.0957A3.935 3.935 0 0021 12a4.0507 4.0507 0 10-3.925-3.2729l.0952.5166L11 15.4143zM28 20H19v2h9v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle101$1 || (_circle101$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var HardwareSecurityModule20 = /*#__PURE__*/React__default['default'].forwardRef(function HardwareSecurityModule20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle102$1 || (_circle102$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "7.5",
      r: "1.5"
    })), _path282$h || (_path282$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4143 20H9V14.5857l6.03-6.03A5.3518 5.3518 0 0115 8a6 6 0 116 6 5.3583 5.3583 0 01-.5559-.03zM11 18h2.5857l6.1706-6.1709.5174.0957A3.935 3.935 0 0021 12a4.0507 4.0507 0 10-3.925-3.2729l.0952.5166L11 15.4143zM28 20H19v2h9v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle103$1 || (_circle103$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var HardwareSecurityModule16 = /*#__PURE__*/React__default['default'].forwardRef(function HardwareSecurityModule16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle104$1 || (_circle104$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "7.5",
      r: "1.5"
    })), _path283$h || (_path283$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4143 20H9V14.5857l6.03-6.03A5.3518 5.3518 0 0115 8a6 6 0 116 6 5.3583 5.3583 0 01-.5559-.03zM11 18h2.5857l6.1706-6.1709.5174.0957A3.935 3.935 0 0021 12a4.0507 4.0507 0 10-3.925-3.2729l.0952.5166L11 15.4143zM28 20H19v2h9v6H4V22H6V20H4a2.0024 2.0024 0 00-2 2v6a2.0024 2.0024 0 002 2H28a2.0024 2.0024 0 002-2V22A2.0024 2.0024 0 0028 20z"
    })), _circle105$1 || (_circle105$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var Hashtag32 = /*#__PURE__*/React__default['default'].forwardRef(function Hashtag32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$h || (_path284$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12V10H22V4H20v6H12V4H10v6H4v2h6v8H4v2h6v6h2V22h8v6h2V22h6V20H22V12Zm-8,8H12V12h8Z"
    })), children);
  });
  var Hashtag24 = /*#__PURE__*/React__default['default'].forwardRef(function Hashtag24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$h || (_path285$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12V10H22V4H20v6H12V4H10v6H4v2h6v8H4v2h6v6h2V22h8v6h2V22h6V20H22V12Zm-8,8H12V12h8Z"
    })), children);
  });
  var Hashtag20 = /*#__PURE__*/React__default['default'].forwardRef(function Hashtag20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$h || (_path286$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12V10H22V4H20v6H12V4H10v6H4v2h6v8H4v2h6v6h2V22h8v6h2V22h6V20H22V12Zm-8,8H12V12h8Z"
    })), children);
  });
  var Hashtag16 = /*#__PURE__*/React__default['default'].forwardRef(function Hashtag16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$h || (_path287$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12V10H22V4H20v6H12V4H10v6H4v2h6v8H4v2h6v6h2V22h8v6h2V22h6V20H22V12Zm-8,8H12V12h8Z"
    })), children);
  });
  var Haze32 = /*#__PURE__*/React__default['default'].forwardRef(function Haze32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$h || (_path288$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 28H3a1 1 0 010-2H19a1 1 0 010 2zM15 20H3a1 1 0 010-2H15a1 1 0 010 2z"
    })), _path289$h || (_path289$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 23.5H28.5V25.5H24.5z",
      transform: "rotate(45 26.5 24.5)"
    })), _path290$h || (_path290$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 15H32V17H28z"
    })), _path291$h || (_path291$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 6.5H28.5V8.5H24.5z",
      transform: "rotate(-45 26.5 7.5)"
    })), _path292$h || (_path292$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17z"
    })), _path293$h || (_path293$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 6.5H11.5V8.5H7.5z",
      transform: "rotate(-135 9.5 7.5)"
    })), _path294$h || (_path294$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,8a8.0092,8.0092,0,0,0-8,8h2a6,6,0,1,1,6,6H7a1,1,0,0,0,0,2H18A8,8,0,0,0,18,8Z"
    })), children);
  });
  var Haze24 = /*#__PURE__*/React__default['default'].forwardRef(function Haze24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$h || (_path295$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 28H3a1 1 0 010-2H19a1 1 0 010 2zM15 20H3a1 1 0 010-2H15a1 1 0 010 2z"
    })), _path296$h || (_path296$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 23.5H28.5V25.5H24.5z",
      transform: "rotate(45 26.5 24.5)"
    })), _path297$h || (_path297$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 15H32V17H28z"
    })), _path298$h || (_path298$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 6.5H28.5V8.5H24.5z",
      transform: "rotate(-45 26.5 7.5)"
    })), _path299$h || (_path299$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17z"
    })), _path300$h || (_path300$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 6.5H11.5V8.5H7.5z",
      transform: "rotate(-135 9.5 7.5)"
    })), _path301$h || (_path301$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,8a8.0092,8.0092,0,0,0-8,8h2a6,6,0,1,1,6,6H7a1,1,0,0,0,0,2H18A8,8,0,0,0,18,8Z"
    })), children);
  });
  var Haze20 = /*#__PURE__*/React__default['default'].forwardRef(function Haze20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$h || (_path302$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 28H3a1 1 0 010-2H19a1 1 0 010 2zM15 20H3a1 1 0 010-2H15a1 1 0 010 2z"
    })), _path303$h || (_path303$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 23.5H28.5V25.5H24.5z",
      transform: "rotate(45 26.5 24.5)"
    })), _path304$h || (_path304$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 15H32V17H28z"
    })), _path305$h || (_path305$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 6.5H28.5V8.5H24.5z",
      transform: "rotate(-45 26.5 7.5)"
    })), _path306$h || (_path306$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17z"
    })), _path307$h || (_path307$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 6.5H11.5V8.5H7.5z",
      transform: "rotate(-135 9.5 7.5)"
    })), _path308$h || (_path308$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,8a8.0092,8.0092,0,0,0-8,8h2a6,6,0,1,1,6,6H7a1,1,0,0,0,0,2H18A8,8,0,0,0,18,8Z"
    })), children);
  });
  var Haze16 = /*#__PURE__*/React__default['default'].forwardRef(function Haze16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$h || (_path309$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 28H3a1 1 0 010-2H19a1 1 0 010 2zM15 20H3a1 1 0 010-2H15a1 1 0 010 2z"
    })), _path310$h || (_path310$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 23.5H28.5V25.5H24.5z",
      transform: "rotate(45 26.5 24.5)"
    })), _path311$h || (_path311$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 15H32V17H28z"
    })), _path312$h || (_path312$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 6.5H28.5V8.5H24.5z",
      transform: "rotate(-45 26.5 7.5)"
    })), _path313$h || (_path313$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17z"
    })), _path314$h || (_path314$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 6.5H11.5V8.5H7.5z",
      transform: "rotate(-135 9.5 7.5)"
    })), _path315$h || (_path315$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,8a8.0092,8.0092,0,0,0-8,8h2a6,6,0,1,1,6,6H7a1,1,0,0,0,0,2H18A8,8,0,0,0,18,8Z"
    })), children);
  });
  var HazeNight32 = /*#__PURE__*/React__default['default'].forwardRef(function HazeNight32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$h || (_path316$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,22H13a1,1,0,0,0,0,2h9.6772a11.0991,11.0991,0,0,1-7.5561,2.9976c-.1384,0-.2783.0048-.4177,0a11.0945,11.0945,0,0,1-3.201-21.584,15.1528,15.1528,0,0,0-.0488,6.5869h2.0457a13.15,13.15,0,0,1,.39-7.6206A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0A13.04,13.04,0,0,0,25.3779,24H29a1,1,0,0,0,0-2Z"
    })), _path317$h || (_path317$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20H17a1 1 0 010-2H27a1 1 0 010 2zM25 16H13a1 1 0 010-2H25a1 1 0 010 2z"
    })), children);
  });
  var HazeNight24 = /*#__PURE__*/React__default['default'].forwardRef(function HazeNight24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$h || (_path318$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,22H13a1,1,0,0,0,0,2h9.6772a11.0991,11.0991,0,0,1-7.5561,2.9976c-.1384,0-.2783.0048-.4177,0a11.0945,11.0945,0,0,1-3.201-21.584,15.1528,15.1528,0,0,0-.0488,6.5869h2.0457a13.15,13.15,0,0,1,.39-7.6206A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0A13.04,13.04,0,0,0,25.3779,24H29a1,1,0,0,0,0-2Z"
    })), _path319$h || (_path319$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20H17a1 1 0 010-2H27a1 1 0 010 2zM25 16H13a1 1 0 010-2H25a1 1 0 010 2z"
    })), children);
  });
  var HazeNight20 = /*#__PURE__*/React__default['default'].forwardRef(function HazeNight20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$h || (_path320$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,22H13a1,1,0,0,0,0,2h9.6772a11.0991,11.0991,0,0,1-7.5561,2.9976c-.1384,0-.2783.0048-.4177,0a11.0945,11.0945,0,0,1-3.201-21.584,15.1528,15.1528,0,0,0-.0488,6.5869h2.0457a13.15,13.15,0,0,1,.39-7.6206A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0A13.04,13.04,0,0,0,25.3779,24H29a1,1,0,0,0,0-2Z"
    })), _path321$h || (_path321$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20H17a1 1 0 010-2H27a1 1 0 010 2zM25 16H13a1 1 0 010-2H25a1 1 0 010 2z"
    })), children);
  });
  var HazeNight16 = /*#__PURE__*/React__default['default'].forwardRef(function HazeNight16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$h || (_path322$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,22H13a1,1,0,0,0,0,2h9.6772a11.0991,11.0991,0,0,1-7.5561,2.9976c-.1384,0-.2783.0048-.4177,0a11.0945,11.0945,0,0,1-3.201-21.584,15.1528,15.1528,0,0,0-.0488,6.5869h2.0457a13.15,13.15,0,0,1,.39-7.6206A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0A13.04,13.04,0,0,0,25.3779,24H29a1,1,0,0,0,0-2Z"
    })), _path323$h || (_path323$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20H17a1 1 0 010-2H27a1 1 0 010 2zM25 16H13a1 1 0 010-2H25a1 1 0 010 2z"
    })), children);
  });
  var Hd32 = /*#__PURE__*/React__default['default'].forwardRef(function Hd32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$h || (_path324$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), _path325$h || (_path325$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11H18V21h4a3 3 0 003-3V14A3 3 0 0022 11zm1 7a1 1 0 01-1 1H20V13h2a1 1 0 011 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"
    })), children);
  });
  var Hd24 = /*#__PURE__*/React__default['default'].forwardRef(function Hd24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$h || (_path326$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), _path327$h || (_path327$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11H18V21h4a3 3 0 003-3V14A3 3 0 0022 11zm1 7a1 1 0 01-1 1H20V13h2a1 1 0 011 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"
    })), children);
  });
  var Hd20 = /*#__PURE__*/React__default['default'].forwardRef(function Hd20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$h || (_path328$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), _path329$h || (_path329$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11H18V21h4a3 3 0 003-3V14A3 3 0 0022 11zm1 7a1 1 0 01-1 1H20V13h2a1 1 0 011 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"
    })), children);
  });
  var Hd16 = /*#__PURE__*/React__default['default'].forwardRef(function Hd16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$h || (_path330$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), _path331$h || (_path331$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11H18V21h4a3 3 0 003-3V14A3 3 0 0022 11zm1 7a1 1 0 01-1 1H20V13h2a1 1 0 011 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"
    })), children);
  });
  var HdFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function HdFilled32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$h || (_path332$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"
    })), _path333$h || (_path333$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"
    })), children);
  });
  var HdFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function HdFilled24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$h || (_path334$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"
    })), _path335$h || (_path335$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"
    })), children);
  });
  var HdFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function HdFilled20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$h || (_path336$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"
    })), _path337$h || (_path337$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"
    })), children);
  });
  var HdFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function HdFilled16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$g || (_path338$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"
    })), _path339$g || (_path339$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"
    })), children);
  });
  var Hdr32 = /*#__PURE__*/React__default['default'].forwardRef(function Hdr32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$g || (_path340$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Hdr24 = /*#__PURE__*/React__default['default'].forwardRef(function Hdr24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$g || (_path341$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Hdr20 = /*#__PURE__*/React__default['default'].forwardRef(function Hdr20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$g || (_path342$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Hdr16 = /*#__PURE__*/React__default['default'].forwardRef(function Hdr16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$g || (_path343$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15V11a2 2 0 00-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0030 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Headphones32 = /*#__PURE__*/React__default['default'].forwardRef(function Headphones32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$g || (_path344$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headphones24 = /*#__PURE__*/React__default['default'].forwardRef(function Headphones24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$g || (_path345$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headphones20 = /*#__PURE__*/React__default['default'].forwardRef(function Headphones20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$g || (_path346$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headphones16 = /*#__PURE__*/React__default['default'].forwardRef(function Headphones16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$g || (_path347$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headset32 = /*#__PURE__*/React__default['default'].forwardRef(function Headset32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$g || (_path348$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headset24 = /*#__PURE__*/React__default['default'].forwardRef(function Headset24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$g || (_path349$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headset20 = /*#__PURE__*/React__default['default'].forwardRef(function Headset20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$g || (_path350$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"
    })), children);
  });
  var Headset16 = /*#__PURE__*/React__default['default'].forwardRef(function Headset16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$g || (_path351$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"
    })), children);
  });
  var HealthCross32 = /*#__PURE__*/React__default['default'].forwardRef(function HealthCross32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$g || (_path352$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"
    })), children);
  });
  var HealthCross24 = /*#__PURE__*/React__default['default'].forwardRef(function HealthCross24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$g || (_path353$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"
    })), children);
  });
  var HealthCross20 = /*#__PURE__*/React__default['default'].forwardRef(function HealthCross20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$g || (_path354$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"
    })), children);
  });
  var HealthCross16 = /*#__PURE__*/React__default['default'].forwardRef(function HealthCross16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$f || (_path355$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"
    })), children);
  });
  var Hearing32 = /*#__PURE__*/React__default['default'].forwardRef(function Hearing32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$f || (_path356$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"
    })), _path357$f || (_path357$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"
    })), _path358$f || (_path358$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22V20a2.0023 2.0023 0 002-2h2A4.0042 4.0042 0 0118 22zM10 2a9.01 9.01 0 00-9 9H3a7 7 0 0114 0 7.09 7.09 0 01-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 01-.9009 2.1514 4.1824 4.1824 0 01-4.6318 1.03A4.0918 4.0918 0 015 20H3a6.1156 6.1156 0 003.6694 5.5117 5.7822 5.7822 0 002.3145.4863A6.5854 6.5854 0 0013.4624 24.11 4.94 4.94 0 0015 20.4961V18.5537A9.1077 9.1077 0 0019 11 9.01 9.01 0 0010 2z"
    })), _path359$f || (_path359$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"
    })), children);
  });
  var Hearing24 = /*#__PURE__*/React__default['default'].forwardRef(function Hearing24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$f || (_path360$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"
    })), _path361$e || (_path361$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"
    })), _path362$e || (_path362$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22V20a2.0023 2.0023 0 002-2h2A4.0042 4.0042 0 0118 22zM10 2a9.01 9.01 0 00-9 9H3a7 7 0 0114 0 7.09 7.09 0 01-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 01-.9009 2.1514 4.1824 4.1824 0 01-4.6318 1.03A4.0918 4.0918 0 015 20H3a6.1156 6.1156 0 003.6694 5.5117 5.7822 5.7822 0 002.3145.4863A6.5854 6.5854 0 0013.4624 24.11 4.94 4.94 0 0015 20.4961V18.5537A9.1077 9.1077 0 0019 11 9.01 9.01 0 0010 2z"
    })), _path363$e || (_path363$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"
    })), children);
  });
  var Hearing20 = /*#__PURE__*/React__default['default'].forwardRef(function Hearing20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$e || (_path364$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"
    })), _path365$e || (_path365$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"
    })), _path366$e || (_path366$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22V20a2.0023 2.0023 0 002-2h2A4.0042 4.0042 0 0118 22zM10 2a9.01 9.01 0 00-9 9H3a7 7 0 0114 0 7.09 7.09 0 01-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 01-.9009 2.1514 4.1824 4.1824 0 01-4.6318 1.03A4.0918 4.0918 0 015 20H3a6.1156 6.1156 0 003.6694 5.5117 5.7822 5.7822 0 002.3145.4863A6.5854 6.5854 0 0013.4624 24.11 4.94 4.94 0 0015 20.4961V18.5537A9.1077 9.1077 0 0019 11 9.01 9.01 0 0010 2z"
    })), _path367$e || (_path367$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"
    })), children);
  });
  var Hearing16 = /*#__PURE__*/React__default['default'].forwardRef(function Hearing16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$e || (_path368$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"
    })), _path369$e || (_path369$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"
    })), _path370$e || (_path370$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22V20a2.0023 2.0023 0 002-2h2A4.0042 4.0042 0 0118 22zM10 2a9.01 9.01 0 00-9 9H3a7 7 0 0114 0 7.09 7.09 0 01-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 01-.9009 2.1514 4.1824 4.1824 0 01-4.6318 1.03A4.0918 4.0918 0 015 20H3a6.1156 6.1156 0 003.6694 5.5117 5.7822 5.7822 0 002.3145.4863A6.5854 6.5854 0 0013.4624 24.11 4.94 4.94 0 0015 20.4961V18.5537A9.1077 9.1077 0 0019 11 9.01 9.01 0 0010 2z"
    })), _path371$e || (_path371$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"
    })), children);
  });
  var HeatMap32 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$e || (_path372$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H22V20H20zM28 16H30V18H28zM14 6H16V8H14zM16 22H12V16a2.0023 2.0023 0 00-2-2H4a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h6v4a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V24A2.0023 2.0023 0 0016 22zM4 22V16h6v6zm8 6V24h4v4zM28 30H24a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0128 30zm-4-6v4h4V24zM28 2H22a2.0023 2.0023 0 00-2 2v6H18a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2h2a2.0023 2.0023 0 002-2V12h6a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zM18 14V12h2v2zm4-4V4h6v6zM8 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var HeatMap24 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$e || (_path373$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H22V20H20zM28 16H30V18H28zM14 6H16V8H14zM16 22H12V16a2.0023 2.0023 0 00-2-2H4a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h6v4a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V24A2.0023 2.0023 0 0016 22zM4 22V16h6v6zm8 6V24h4v4zM28 30H24a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0128 30zm-4-6v4h4V24zM28 2H22a2.0023 2.0023 0 00-2 2v6H18a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2h2a2.0023 2.0023 0 002-2V12h6a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zM18 14V12h2v2zm4-4V4h6v6zM8 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var HeatMap20 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$e || (_path374$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H22V20H20zM28 16H30V18H28zM14 6H16V8H14zM16 22H12V16a2.0023 2.0023 0 00-2-2H4a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h6v4a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V24A2.0023 2.0023 0 0016 22zM4 22V16h6v6zm8 6V24h4v4zM28 30H24a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0128 30zm-4-6v4h4V24zM28 2H22a2.0023 2.0023 0 00-2 2v6H18a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2h2a2.0023 2.0023 0 002-2V12h6a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zM18 14V12h2v2zm4-4V4h6v6zM8 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var HeatMap16 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$e || (_path375$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 18H22V20H20zM28 16H30V18H28zM14 6H16V8H14zM16 22H12V16a2.0023 2.0023 0 00-2-2H4a2.0023 2.0023 0 00-2 2v6a2.0023 2.0023 0 002 2h6v4a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V24A2.0023 2.0023 0 0016 22zM4 22V16h6v6zm8 6V24h4v4zM28 30H24a2.0021 2.0021 0 01-2-2V24a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0128 30zm-4-6v4h4V24zM28 2H22a2.0023 2.0023 0 00-2 2v6H18a2.0023 2.0023 0 00-2 2v2a2.0023 2.0023 0 002 2h2a2.0023 2.0023 0 002-2V12h6a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zM18 14V12h2v2zm4-4V4h6v6zM8 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H8a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 018 10zM4 4V8H8V4z"
    })), children);
  });
  var HeatMap_0232 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0232(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle106$1 || (_circle106$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "20",
      r: "2"
    })), _circle107$1 || (_circle107$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "12",
      r: "2"
    })), _circle108$1 || (_circle108$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "19",
      r: "1"
    })), _path376$e || (_path376$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 30A3.5 3.5 0 1130 26.5 3.5041 3.5041 0 0126.5 30zm0-5A1.5 1.5 0 1028 26.5 1.5017 1.5017 0 0026.5 25zM14 30a3.958 3.958 0 01-2.126-.6211 6.9977 6.9977 0 114.1109-6.8384A3.9916 3.9916 0 0114 30zm-1.8843-3.0278l.5391.4946a1.9915 1.9915 0 102.0039-3.343l-.6909-.2432.03-.8467a5.0085 5.0085 0 10-2.5166 4.3023zM24 16a6.0067 6.0067 0 01-6-6 5.3246 5.3246 0 01.0269-.5327A3.9564 3.9564 0 0116 6a4.0045 4.0045 0 014-4 3.9564 3.9564 0 013.4673 2.0271C23.6484 4.009 23.8252 4 24 4a6 6 0 010 12zM20 4a2.0021 2.0021 0 00-2 2 1.9805 1.9805 0 001.43 1.9023l.9018.2706-.2153.9162A3.9938 3.9938 0 1024 6a4.0064 4.0064 0 00-.9121.1162l-.9155.2141-.27-.9006A1.9807 1.9807 0 0020 4zM6.5 11A4.5 4.5 0 1111 6.5 4.5051 4.5051 0 016.5 11zm0-7A2.5 2.5 0 109 6.5 2.503 2.503 0 006.5 4z"
    })), children);
  });
  var HeatMap_0224 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0224(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle109$1 || (_circle109$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "20",
      r: "2"
    })), _circle110$1 || (_circle110$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "12",
      r: "2"
    })), _circle111$1 || (_circle111$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "19",
      r: "1"
    })), _path377$e || (_path377$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 30A3.5 3.5 0 1130 26.5 3.5041 3.5041 0 0126.5 30zm0-5A1.5 1.5 0 1028 26.5 1.5017 1.5017 0 0026.5 25zM14 30a3.958 3.958 0 01-2.126-.6211 6.9977 6.9977 0 114.1109-6.8384A3.9916 3.9916 0 0114 30zm-1.8843-3.0278l.5391.4946a1.9915 1.9915 0 102.0039-3.343l-.6909-.2432.03-.8467a5.0085 5.0085 0 10-2.5166 4.3023zM24 16a6.0067 6.0067 0 01-6-6 5.3246 5.3246 0 01.0269-.5327A3.9564 3.9564 0 0116 6a4.0045 4.0045 0 014-4 3.9564 3.9564 0 013.4673 2.0271C23.6484 4.009 23.8252 4 24 4a6 6 0 010 12zM20 4a2.0021 2.0021 0 00-2 2 1.9805 1.9805 0 001.43 1.9023l.9018.2706-.2153.9162A3.9938 3.9938 0 1024 6a4.0064 4.0064 0 00-.9121.1162l-.9155.2141-.27-.9006A1.9807 1.9807 0 0020 4zM6.5 11A4.5 4.5 0 1111 6.5 4.5051 4.5051 0 016.5 11zm0-7A2.5 2.5 0 109 6.5 2.503 2.503 0 006.5 4z"
    })), children);
  });
  var HeatMap_0220 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0220(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle112$1 || (_circle112$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "20",
      r: "2"
    })), _circle113$1 || (_circle113$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "12",
      r: "2"
    })), _circle114$1 || (_circle114$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "19",
      r: "1"
    })), _path378$e || (_path378$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 30A3.5 3.5 0 1130 26.5 3.5041 3.5041 0 0126.5 30zm0-5A1.5 1.5 0 1028 26.5 1.5017 1.5017 0 0026.5 25zM14 30a3.958 3.958 0 01-2.126-.6211 6.9977 6.9977 0 114.1109-6.8384A3.9916 3.9916 0 0114 30zm-1.8843-3.0278l.5391.4946a1.9915 1.9915 0 102.0039-3.343l-.6909-.2432.03-.8467a5.0085 5.0085 0 10-2.5166 4.3023zM24 16a6.0067 6.0067 0 01-6-6 5.3246 5.3246 0 01.0269-.5327A3.9564 3.9564 0 0116 6a4.0045 4.0045 0 014-4 3.9564 3.9564 0 013.4673 2.0271C23.6484 4.009 23.8252 4 24 4a6 6 0 010 12zM20 4a2.0021 2.0021 0 00-2 2 1.9805 1.9805 0 001.43 1.9023l.9018.2706-.2153.9162A3.9938 3.9938 0 1024 6a4.0064 4.0064 0 00-.9121.1162l-.9155.2141-.27-.9006A1.9807 1.9807 0 0020 4zM6.5 11A4.5 4.5 0 1111 6.5 4.5051 4.5051 0 016.5 11zm0-7A2.5 2.5 0 109 6.5 2.503 2.503 0 006.5 4z"
    })), children);
  });
  var HeatMap_0216 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0216(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle115$1 || (_circle115$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "20",
      r: "2"
    })), _circle116$1 || (_circle116$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "12",
      r: "2"
    })), _circle117$1 || (_circle117$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "19",
      r: "1"
    })), _path379$e || (_path379$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 30A3.5 3.5 0 1130 26.5 3.5041 3.5041 0 0126.5 30zm0-5A1.5 1.5 0 1028 26.5 1.5017 1.5017 0 0026.5 25zM14 30a3.958 3.958 0 01-2.126-.6211 6.9977 6.9977 0 114.1109-6.8384A3.9916 3.9916 0 0114 30zm-1.8843-3.0278l.5391.4946a1.9915 1.9915 0 102.0039-3.343l-.6909-.2432.03-.8467a5.0085 5.0085 0 10-2.5166 4.3023zM24 16a6.0067 6.0067 0 01-6-6 5.3246 5.3246 0 01.0269-.5327A3.9564 3.9564 0 0116 6a4.0045 4.0045 0 014-4 3.9564 3.9564 0 013.4673 2.0271C23.6484 4.009 23.8252 4 24 4a6 6 0 010 12zM20 4a2.0021 2.0021 0 00-2 2 1.9805 1.9805 0 001.43 1.9023l.9018.2706-.2153.9162A3.9938 3.9938 0 1024 6a4.0064 4.0064 0 00-.9121.1162l-.9155.2141-.27-.9006A1.9807 1.9807 0 0020 4zM6.5 11A4.5 4.5 0 1111 6.5 4.5051 4.5051 0 016.5 11zm0-7A2.5 2.5 0 109 6.5 2.503 2.503 0 006.5 4z"
    })), children);
  });
  var HeatMap_0332 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0332(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$e || (_path380$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM19,9H13V5h6Zm0,2v4H13V11Zm-8,0v4H5V11Zm0,6v4H5V17Zm2,0h6v4H13Zm8-2V11h6l0,4ZM5,23h6v4H5Zm16,4V23h6v4Z"
    })), children);
  });
  var HeatMap_0324 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0324(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$e || (_path381$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM19,9H13V5h6Zm0,2v4H13V11Zm-8,0v4H5V11Zm0,6v4H5V17Zm2,0h6v4H13Zm8-2V11h6l0,4ZM5,23h6v4H5Zm16,4V23h6v4Z"
    })), children);
  });
  var HeatMap_0320 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0320(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$e || (_path382$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM19,9H13V5h6Zm0,2v4H13V11Zm-8,0v4H5V11Zm0,6v4H5V17Zm2,0h6v4H13Zm8-2V11h6l0,4ZM5,23h6v4H5Zm16,4V23h6v4Z"
    })), children);
  });
  var HeatMap_0316 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMap_0316(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$e || (_path383$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2.0023,2.0023,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3ZM19,9H13V5h6Zm0,2v4H13V11Zm-8,0v4H5V11Zm0,6v4H5V17Zm2,0h6v4H13Zm8-2V11h6l0,4ZM5,23h6v4H5Zm16,4V23h6v4Z"
    })), children);
  });
  var HeatMapStocks32 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMapStocks32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$d || (_path384$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM9,21H5V17H9Zm2,2h4v4H11Zm6,0h4v4H17Zm0-8V11h4v4Zm4-6H17V5h4Zm2,2h4v4H23ZM15,5V15H5V5Zm8,22V17h4V27Z"
    })), children);
  });
  var HeatMapStocks24 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMapStocks24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$d || (_path385$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM9,21H5V17H9Zm2,2h4v4H11Zm6,0h4v4H17Zm0-8V11h4v4Zm4-6H17V5h4Zm2,2h4v4H23ZM15,5V15H5V5Zm8,22V17h4V27Z"
    })), children);
  });
  var HeatMapStocks20 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMapStocks20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$d || (_path386$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM9,21H5V17H9Zm2,2h4v4H11Zm6,0h4v4H17Zm0-8V11h4v4Zm4-6H17V5h4Zm2,2h4v4H23ZM15,5V15H5V5Zm8,22V17h4V27Z"
    })), children);
  });
  var HeatMapStocks16 = /*#__PURE__*/React__default['default'].forwardRef(function HeatMapStocks16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$d || (_path387$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3ZM9,21H5V17H9Zm2,2h4v4H11Zm6,0h4v4H17Zm0-8V11h4v4Zm4-6H17V5h4Zm2,2h4v4H23ZM15,5V15H5V5Zm8,22V17h4V27Z"
    })), children);
  });
  var Helicopter32 = /*#__PURE__*/React__default['default'].forwardRef(function Helicopter32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$d || (_path388$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V6H8V8H18v4H4V8H2v8H4V14h6.2192l2.0533,8.2129A4.9923,4.9923,0,0,0,17.123,26H26a4.0045,4.0045,0,0,0,4-4V19.3623a2.0007,2.0007,0,0,0-.4639-1.28L25.0684,12.72A1.9968,1.9968,0,0,0,23.5317,12H20V8ZM26,24H17.123a2.9949,2.9949,0,0,1-2.91-2.2725L12.2808,14H18v6H28v2A2.0023,2.0023,0,0,1,26,24ZM23.5317,14l3.3333,4H20V14Z"
    })), children);
  });
  var Helicopter24 = /*#__PURE__*/React__default['default'].forwardRef(function Helicopter24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$d || (_path389$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V6H8V8H18v4H4V8H2v8H4V14h6.2192l2.0533,8.2129A4.9923,4.9923,0,0,0,17.123,26H26a4.0045,4.0045,0,0,0,4-4V19.3623a2.0007,2.0007,0,0,0-.4639-1.28L25.0684,12.72A1.9968,1.9968,0,0,0,23.5317,12H20V8ZM26,24H17.123a2.9949,2.9949,0,0,1-2.91-2.2725L12.2808,14H18v6H28v2A2.0023,2.0023,0,0,1,26,24ZM23.5317,14l3.3333,4H20V14Z"
    })), children);
  });
  var Helicopter20 = /*#__PURE__*/React__default['default'].forwardRef(function Helicopter20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$d || (_path390$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V6H8V8H18v4H4V8H2v8H4V14h6.2192l2.0533,8.2129A4.9923,4.9923,0,0,0,17.123,26H26a4.0045,4.0045,0,0,0,4-4V19.3623a2.0007,2.0007,0,0,0-.4639-1.28L25.0684,12.72A1.9968,1.9968,0,0,0,23.5317,12H20V8ZM26,24H17.123a2.9949,2.9949,0,0,1-2.91-2.2725L12.2808,14H18v6H28v2A2.0023,2.0023,0,0,1,26,24ZM23.5317,14l3.3333,4H20V14Z"
    })), children);
  });
  var Helicopter16 = /*#__PURE__*/React__default['default'].forwardRef(function Helicopter16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$d || (_path391$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,8V6H8V8H18v4H4V8H2v8H4V14h6.2192l2.0533,8.2129A4.9923,4.9923,0,0,0,17.123,26H26a4.0045,4.0045,0,0,0,4-4V19.3623a2.0007,2.0007,0,0,0-.4639-1.28L25.0684,12.72A1.9968,1.9968,0,0,0,23.5317,12H20V8ZM26,24H17.123a2.9949,2.9949,0,0,1-2.91-2.2725L12.2808,14H18v6H28v2A2.0023,2.0023,0,0,1,26,24ZM23.5317,14l3.3333,4H20V14Z"
    })), children);
  });
  var Help32 = /*#__PURE__*/React__default['default'].forwardRef(function Help32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$d || (_path392$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _circle118$1 || (_circle118$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23.5",
      r: "1.5"
    })), _path393$d || (_path393$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,8H15.5A4.49,4.49,0,0,0,11,12.5V13h2v-.5A2.5,2.5,0,0,1,15.5,10H17a2.5,2.5,0,0,1,0,5H15v4.5h2V17a4.5,4.5,0,0,0,0-9Z"
    })), children);
  });
  var Help24 = /*#__PURE__*/React__default['default'].forwardRef(function Help24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$d || (_path394$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _circle119$1 || (_circle119$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23.5",
      r: "1.5"
    })), _path395$d || (_path395$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,8H15.5A4.49,4.49,0,0,0,11,12.5V13h2v-.5A2.5,2.5,0,0,1,15.5,10H17a2.5,2.5,0,0,1,0,5H15v4.5h2V17a4.5,4.5,0,0,0,0-9Z"
    })), children);
  });
  var Help20 = /*#__PURE__*/React__default['default'].forwardRef(function Help20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$d || (_path396$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _circle120$1 || (_circle120$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23.5",
      r: "1.5"
    })), _path397$d || (_path397$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,8H15.5A4.49,4.49,0,0,0,11,12.5V13h2v-.5A2.5,2.5,0,0,1,15.5,10H17a2.5,2.5,0,0,1,0,5H15v4.5h2V17a4.5,4.5,0,0,0,0-9Z"
    })), children);
  });
  var Help16 = /*#__PURE__*/React__default['default'].forwardRef(function Help16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$d || (_path398$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"
    })), _circle121$1 || (_circle121$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "11.8",
      r: ".8"
    })), _path399$c || (_path399$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5,4H7.8C6.5,4,5.5,5,5.5,6.2c0,0,0,0,0,0v0.2h1V6.2C6.5,5.6,7.1,5,7.8,5h0.8c0.7,0,1.2,0.6,1.2,1.2S9.2,7.5,8.5,7.5h-1\tv2.2h1V8.5c1.2,0,2.2-1,2.2-2.2S9.7,4,8.5,4z"
    })), children);
  });
  var HelpFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function HelpFilled32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$c || (_path400$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z"
    })), _path401$c || (_path401$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var HelpFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function HelpFilled24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$c || (_path402$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z"
    })), _path403$b || (_path403$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var HelpFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function HelpFilled20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$b || (_path404$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z"
    })), _path405$b || (_path405$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var HelpFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function HelpFilled16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$b || (_path406$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z"
    })), _path407$b || (_path407$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.1421-7.754v2.5014h-2.25V15h2.125a2.3763,2.3763,0,0,0,0-4.7526h-1.5a2.3777,2.3777,0,0,0-2.375,2.375V13.26h-2.25v-.6377A4.6279,4.6279,0,0,1,15.5171,8h1.5a4.6238,4.6238,0,0,1,.125,9.246Z",
      "data-icon-path": "inner-path"
    })), children);
  });

  var _path$h, _path2$h, _path3$h, _path4$h, _path5$h, _path6$h, _path7$h, _path8$h, _path9$h, _path10$h, _path11$h, _path12$h, _circle$g, _path13$h, _circle2$g, _path14$h, _circle3$g, _path15$h, _circle4$f, _path16$h, _circle5$e, _path17$h, _circle6$e, _path18$h, _circle7$e, _path19$h, _circle8$e, _path20$h, _path21$h, _path22$h, _path23$h, _path24$h, _path25$h, _path26$h, _path27$h, _path28$h, _path29$h, _path30$h, _path31$h, _path32$h, _path33$h, _path34$h, _path35$h, _path36$h, _path37$h, _path38$h, _path39$h, _path40$h, _path41$h, _path42$h, _path43$h, _path44$h, _path45$h, _path46$h, _path47$h, _path48$h, _path49$h, _path50$h, _path51$h, _path52$h, _path53$h, _path54$h, _path55$h, _path56$h, _path57$h, _path58$h, _path59$h, _path60$h, _path61$h, _path62$h, _path63$h, _path64$h, _path65$h, _path66$h, _path67$h, _path68$h, _path69$h, _path70$h, _path71$h, _path72$h, _path73$h, _path74$h, _path75$h, _path76$h, _path77$h, _path78$h, _path79$h, _path80$h, _path81$h, _path82$h, _path83$h, _path84$h, _path85$h, _path86$h, _path87$h, _path88$h, _path89$h, _path90$h, _path91$h, _path92$h, _path93$h, _path94$h, _path95$h, _path96$h, _path97$h, _path98$h, _path99$h, _path100$h, _path101$h, _path102$h, _path103$h, _path104$h, _path105$h, _path106$h, _path107$h, _path108$h, _path109$h, _path110$h, _path111$h, _path112$h, _circle9$e, _path113$h, _circle10$e, _path114$h, _circle11$d, _path115$h, _circle12$d, _path116$h, _circle13$d, _path117$h, _circle14$d, _path118$h, _circle15$d, _path119$h, _circle16$d, _path120$h, _path121$h, _path122$h, _path123$h, _path124$h, _path125$h, _path126$h, _path127$h, _path128$h, _path129$h, _path130$h, _path131$h, _path132$h, _path133$h, _path134$h, _path135$h, _path136$h, _path137$h, _path138$h, _path139$h, _path140$h, _path141$h, _path142$h, _path143$h, _path144$h, _path145$h, _path146$h, _path147$h, _path148$h, _path149$h, _path150$h, _path151$h, _path152$h, _path153$h, _path154$h, _path155$h, _path156$h, _path157$h, _path158$h, _path159$h, _path160$h, _circle17$c, _circle18$c, _circle19$c, _circle20$c, _path161$h, _path162$h, _circle21$c, _circle22$c, _circle23$b, _circle24$b, _path163$h, _path164$h, _circle25$a, _circle26$a, _circle27$9, _circle28$9, _path165$h, _path166$h, _circle29$9, _circle30$9, _circle31$9, _circle32$9, _path167$h, _path168$h, _path169$h, _path170$h, _path171$h, _path172$h, _path173$h, _path174$h, _path175$h, _path176$h, _path177$g, _path178$g, _path179$g, _path180$g, _path181$g, _path182$g, _path183$g, _path184$g, _path185$g, _path186$g, _path187$g, _path188$g, _path189$g, _path190$g, _path191$g, _path192$g, _path193$g, _path194$g, _path195$g, _path196$g, _path197$g, _path198$g, _path199$g, _path200$g, _path201$g, _path202$g, _path203$g, _path204$g, _path205$g, _path206$g, _path207$g, _path208$g, _path209$g, _path210$g, _path211$g, _path212$g, _path213$g, _path214$g, _path215$g, _path216$g, _path217$g, _path218$g, _path219$g, _path220$g, _path221$g, _path222$g, _path223$g, _path224$g, _path225$g, _path226$g, _path227$g, _path228$g, _path229$g, _path230$g, _path231$g, _path232$g, _path233$g, _path234$g, _path235$g, _path236$g, _path237$g, _path238$g, _path239$g, _path240$g, _path241$g, _path242$g, _path243$g, _path244$g, _path245$g, _path246$g, _path247$g, _path248$g, _path249$g, _path250$g, _path251$g, _path252$g, _path253$g, _path254$g, _path255$g, _path256$g, _path257$g, _path258$g, _path259$g, _path260$g, _path261$g, _path262$g, _path263$g, _path264$g, _path265$g, _path266$g, _path267$g, _path268$g, _path269$g, _path270$g, _path271$g, _path272$g, _path273$g, _path274$g, _path275$g, _path276$g, _path277$g, _path278$g, _path279$g, _path280$g, _path281$g, _path282$g, _path283$g, _path284$g, _path285$g, _path286$g, _path287$g, _path288$g, _path289$g, _path290$g, _path291$g, _path292$g, _path293$g, _path294$g, _path295$g, _path296$g, _path297$g, _path298$g, _path299$g, _path300$g, _path301$g, _path302$g, _path303$g, _path304$g, _path305$g, _path306$g, _path307$g, _path308$g, _path309$g, _path310$g, _path311$g, _path312$g, _path313$g, _path314$g, _path315$g, _path316$g, _path317$g, _path318$g, _path319$g, _path320$g, _path321$g, _path322$g, _path323$g, _path324$g, _path325$g, _path326$g, _path327$g, _path328$g, _path329$g, _path330$g, _path331$g, _path332$g, _path333$g, _path334$g, _path335$g, _path336$g, _path337$g, _path338$f, _path339$f, _path340$f, _path341$f, _path342$f, _path343$f, _path344$f, _path345$f, _circle33$9, _path346$f, _path347$f, _circle34$8, _path348$f, _path349$f, _circle35$8, _path350$f, _path351$f, _circle36$8, _path352$f, _path353$f, _path354$f, _path355$e, _path356$e, _path357$e, _circle37$6, _path358$e, _path359$e, _path360$e, _circle38$6, _path361$d, _path362$d, _path363$d, _circle39$6, _path364$d, _path365$d, _path366$d, _circle40$6, _path367$d, _path368$d, _path369$d, _path370$d, _path371$d, _path372$d, _path373$d, _path374$d, _path375$d, _path376$d, _path377$d, _path378$d, _path379$d, _path380$d, _path381$d, _path382$d, _path383$d, _path384$c, _path385$c, _path386$c, _path387$c, _path388$c, _path389$c, _path390$c, _path391$c, _path392$c, _path393$c, _path394$c, _path395$c, _path396$c, _path397$c, _path398$c, _path399$b, _path400$b, _path401$b, _path402$b, _path403$a, _path404$a, _path405$a, _path406$a, _path407$a, _path408$a, _path409$a, _path410$9, _path411$9, _path412$9, _path413$9, _path414$9, _path415$8;

  var _excluded$h = ["children"],
      _excluded2$h = ["children"],
      _excluded3$h = ["children"],
      _excluded4$h = ["children"],
      _excluded5$h = ["children"],
      _excluded6$h = ["children"],
      _excluded7$h = ["children"],
      _excluded8$h = ["children"],
      _excluded9$h = ["children"],
      _excluded10$h = ["children"],
      _excluded11$h = ["children"],
      _excluded12$h = ["children"],
      _excluded13$h = ["children"],
      _excluded14$h = ["children"],
      _excluded15$h = ["children"],
      _excluded16$h = ["children"],
      _excluded17$h = ["children"],
      _excluded18$h = ["children"],
      _excluded19$h = ["children"],
      _excluded20$h = ["children"],
      _excluded21$h = ["children"],
      _excluded22$h = ["children"],
      _excluded23$h = ["children"],
      _excluded24$h = ["children"],
      _excluded25$h = ["children"],
      _excluded26$h = ["children"],
      _excluded27$h = ["children"],
      _excluded28$h = ["children"],
      _excluded29$h = ["children"],
      _excluded30$h = ["children"],
      _excluded31$h = ["children"],
      _excluded32$h = ["children"],
      _excluded33$h = ["children"],
      _excluded34$h = ["children"],
      _excluded35$h = ["children"],
      _excluded36$h = ["children"],
      _excluded37$h = ["children"],
      _excluded38$h = ["children"],
      _excluded39$h = ["children"],
      _excluded40$h = ["children"],
      _excluded41$h = ["children"],
      _excluded42$h = ["children"],
      _excluded43$h = ["children"],
      _excluded44$h = ["children"],
      _excluded45$h = ["children"],
      _excluded46$h = ["children"],
      _excluded47$h = ["children"],
      _excluded48$h = ["children"],
      _excluded49$h = ["children"],
      _excluded50$h = ["children"],
      _excluded51$h = ["children"],
      _excluded52$h = ["children"],
      _excluded53$h = ["children"],
      _excluded54$h = ["children"],
      _excluded55$h = ["children"],
      _excluded56$h = ["children"],
      _excluded57$h = ["children"],
      _excluded58$h = ["children"],
      _excluded59$h = ["children"],
      _excluded60$h = ["children"],
      _excluded61$h = ["children"],
      _excluded62$h = ["children"],
      _excluded63$h = ["children"],
      _excluded64$h = ["children"],
      _excluded65$h = ["children"],
      _excluded66$h = ["children"],
      _excluded67$h = ["children"],
      _excluded68$h = ["children"],
      _excluded69$h = ["children"],
      _excluded70$h = ["children"],
      _excluded71$h = ["children"],
      _excluded72$h = ["children"],
      _excluded73$h = ["children"],
      _excluded74$h = ["children"],
      _excluded75$h = ["children"],
      _excluded76$h = ["children"],
      _excluded77$h = ["children"],
      _excluded78$h = ["children"],
      _excluded79$h = ["children"],
      _excluded80$h = ["children"],
      _excluded81$h = ["children"],
      _excluded82$h = ["children"],
      _excluded83$h = ["children"],
      _excluded84$h = ["children"],
      _excluded85$h = ["children"],
      _excluded86$h = ["children"],
      _excluded87$h = ["children"],
      _excluded88$h = ["children"],
      _excluded89$h = ["children"],
      _excluded90$h = ["children"],
      _excluded91$h = ["children"],
      _excluded92$h = ["children"],
      _excluded93$h = ["children"],
      _excluded94$h = ["children"],
      _excluded95$h = ["children"],
      _excluded96$h = ["children"],
      _excluded97$h = ["children"],
      _excluded98$h = ["children"],
      _excluded99$h = ["children"],
      _excluded100$h = ["children"],
      _excluded101$h = ["children"],
      _excluded102$h = ["children"],
      _excluded103$h = ["children"],
      _excluded104$h = ["children"],
      _excluded105$h = ["children"],
      _excluded106$h = ["children"],
      _excluded107$h = ["children"],
      _excluded108$h = ["children"],
      _excluded109$h = ["children"],
      _excluded110$h = ["children"],
      _excluded111$h = ["children"],
      _excluded112$h = ["children"],
      _excluded113$h = ["children"],
      _excluded114$h = ["children"],
      _excluded115$h = ["children"],
      _excluded116$h = ["children"],
      _excluded117$h = ["children"],
      _excluded118$h = ["children"],
      _excluded119$g = ["children"],
      _excluded120$g = ["children"],
      _excluded121$g = ["children"],
      _excluded122$g = ["children"],
      _excluded123$g = ["children"],
      _excluded124$g = ["children"],
      _excluded125$g = ["children"],
      _excluded126$g = ["children"],
      _excluded127$g = ["children"],
      _excluded128$g = ["children"],
      _excluded129$g = ["children"],
      _excluded130$g = ["children"],
      _excluded131$g = ["children"],
      _excluded132$g = ["children"],
      _excluded133$g = ["children"],
      _excluded134$g = ["children"],
      _excluded135$g = ["children"],
      _excluded136$g = ["children"],
      _excluded137$g = ["children"],
      _excluded138$g = ["children"],
      _excluded139$g = ["children"],
      _excluded140$g = ["children"],
      _excluded141$g = ["children"],
      _excluded142$g = ["children"],
      _excluded143$g = ["children"],
      _excluded144$g = ["children"],
      _excluded145$g = ["children"],
      _excluded146$g = ["children"],
      _excluded147$g = ["children"],
      _excluded148$g = ["children"],
      _excluded149$g = ["children"],
      _excluded150$g = ["children"],
      _excluded151$g = ["children"],
      _excluded152$g = ["children"],
      _excluded153$g = ["children"],
      _excluded154$g = ["children"],
      _excluded155$g = ["children"],
      _excluded156$g = ["children"],
      _excluded157$g = ["children"],
      _excluded158$g = ["children"],
      _excluded159$g = ["children"],
      _excluded160$g = ["children"],
      _excluded161$g = ["children"],
      _excluded162$g = ["children"],
      _excluded163$g = ["children"],
      _excluded164$g = ["children"],
      _excluded165$g = ["children"],
      _excluded166$g = ["children"],
      _excluded167$g = ["children"],
      _excluded168$g = ["children"],
      _excluded169$g = ["children"],
      _excluded170$g = ["children"],
      _excluded171$g = ["children"],
      _excluded172$g = ["children"],
      _excluded173$g = ["children"],
      _excluded174$g = ["children"],
      _excluded175$g = ["children"],
      _excluded176$g = ["children"],
      _excluded177$g = ["children"],
      _excluded178$g = ["children"],
      _excluded179$g = ["children"],
      _excluded180$g = ["children"],
      _excluded181$g = ["children"],
      _excluded182$g = ["children"],
      _excluded183$g = ["children"],
      _excluded184$g = ["children"],
      _excluded185$g = ["children"],
      _excluded186$g = ["children"],
      _excluded187$g = ["children"],
      _excluded188$g = ["children"],
      _excluded189$g = ["children"],
      _excluded190$g = ["children"],
      _excluded191$g = ["children"],
      _excluded192$g = ["children"],
      _excluded193$g = ["children"],
      _excluded194$g = ["children"],
      _excluded195$g = ["children"],
      _excluded196$g = ["children"],
      _excluded197$g = ["children"],
      _excluded198$g = ["children"],
      _excluded199$g = ["children"],
      _excluded200$g = ["children"],
      _excluded201$g = ["children"],
      _excluded202$g = ["children"],
      _excluded203$g = ["children"],
      _excluded204$g = ["children"],
      _excluded205$g = ["children"],
      _excluded206$g = ["children"],
      _excluded207$g = ["children"],
      _excluded208$g = ["children"],
      _excluded209$g = ["children"],
      _excluded210$g = ["children"],
      _excluded211$g = ["children"],
      _excluded212$g = ["children"],
      _excluded213$g = ["children"],
      _excluded214$g = ["children"],
      _excluded215$g = ["children"],
      _excluded216$g = ["children"],
      _excluded217$g = ["children"],
      _excluded218$g = ["children"],
      _excluded219$g = ["children"],
      _excluded220$g = ["children"],
      _excluded221$g = ["children"],
      _excluded222$g = ["children"],
      _excluded223$g = ["children"],
      _excluded224$g = ["children"],
      _excluded225$g = ["children"],
      _excluded226$g = ["children"],
      _excluded227$g = ["children"],
      _excluded228$g = ["children"],
      _excluded229$g = ["children"],
      _excluded230$g = ["children"],
      _excluded231$g = ["children"],
      _excluded232$g = ["children"],
      _excluded233$g = ["children"],
      _excluded234$g = ["children"],
      _excluded235$g = ["children"],
      _excluded236$g = ["children"],
      _excluded237$g = ["children"],
      _excluded238$g = ["children"],
      _excluded239$g = ["children"],
      _excluded240$g = ["children"],
      _excluded241$g = ["children"],
      _excluded242$g = ["children"],
      _excluded243$g = ["children"],
      _excluded244$g = ["children"],
      _excluded245$g = ["children"],
      _excluded246$g = ["children"],
      _excluded247$g = ["children"],
      _excluded248$g = ["children"],
      _excluded249$g = ["children"],
      _excluded250$g = ["children"];
  var HelpDesk32 = /*#__PURE__*/React__default['default'].forwardRef(function HelpDesk32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$h || (_path$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 10H21a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1zM20 5a4 4 0 114 4A4.0042 4.0042 0 0120 5zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 5zM14 16V13a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v3H4zM4 5A4 4 0 118 9 4.0042 4.0042 0 014 5zM6 5A2 2 0 108 3 2.0023 2.0023 0 006 5z"
    })), children);
  });
  var HelpDesk24 = /*#__PURE__*/React__default['default'].forwardRef(function HelpDesk24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$h || (_path2$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 10H21a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1zM20 5a4 4 0 114 4A4.0042 4.0042 0 0120 5zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 5zM14 16V13a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v3H4zM4 5A4 4 0 118 9 4.0042 4.0042 0 014 5zM6 5A2 2 0 108 3 2.0023 2.0023 0 006 5z"
    })), children);
  });
  var HelpDesk20 = /*#__PURE__*/React__default['default'].forwardRef(function HelpDesk20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$h || (_path3$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 10H21a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1zM20 5a4 4 0 114 4A4.0042 4.0042 0 0120 5zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 5zM14 16V13a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v3H4zM4 5A4 4 0 118 9 4.0042 4.0042 0 014 5zM6 5A2 2 0 108 3 2.0023 2.0023 0 006 5z"
    })), children);
  });
  var HelpDesk16 = /*#__PURE__*/React__default['default'].forwardRef(function HelpDesk16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$h || (_path4$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 10H21a3.0033 3.0033 0 00-3 3v6a2.0023 2.0023 0 002 2v7a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V21a2.0023 2.0023 0 002-2V13A3.0033 3.0033 0 0027 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1zM20 5a4 4 0 114 4A4.0042 4.0042 0 0120 5zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 5zM14 16V13a3.0033 3.0033 0 00-3-3H5a3.0033 3.0033 0 00-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v3H4zM4 5A4 4 0 118 9 4.0042 4.0042 0 014 5zM6 5A2 2 0 108 3 2.0023 2.0023 0 006 5z"
    })), children);
  });
  var QHintonPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function QHintonPlot32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$h || (_path5$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var QHintonPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function QHintonPlot24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$h || (_path6$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var QHintonPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function QHintonPlot20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$h || (_path7$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var QHintonPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function QHintonPlot16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$h || (_path8$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var WatsonHealthHl7Attributes32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHl7Attributes32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$h || (_path9$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L21 9 21 13 23 13 23 11 26.847 11 22 23 24.157 23 29 11 29 9zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var WatsonHealthHl7Attributes24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHl7Attributes24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$h || (_path10$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L21 9 21 13 23 13 23 11 26.847 11 22 23 24.157 23 29 11 29 9zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var WatsonHealthHl7Attributes20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHl7Attributes20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$h || (_path11$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L21 9 21 13 23 13 23 11 26.847 11 22 23 24.157 23 29 11 29 9zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var WatsonHealthHl7Attributes16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHl7Attributes16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$h || (_path12$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L21 9 21 13 23 13 23 11 26.847 11 22 23 24.157 23 29 11 29 9zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var WatsonHealthHoleFilling32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFilling32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$g || (_circle$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path13$h || (_path13$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WatsonHealthHoleFilling24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFilling24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle2$g || (_circle2$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path14$h || (_path14$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WatsonHealthHoleFilling20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFilling20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$g || (_circle3$g = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path15$h || (_path15$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WatsonHealthHoleFilling16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFilling16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$f || (_circle4$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path16$h || (_path16$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WatsonHealthHoleFillingCursor32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFillingCursor32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$e || (_circle5$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "19",
      r: "4"
    })), _path17$h || (_path17$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM10 10V28H28V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthHoleFillingCursor24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFillingCursor24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$e || (_circle6$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "19",
      r: "4"
    })), _path18$h || (_path18$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM10 10V28H28V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthHoleFillingCursor20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFillingCursor20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$e || (_circle7$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "19",
      r: "4"
    })), _path19$h || (_path19$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM10 10V28H28V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthHoleFillingCursor16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthHoleFillingCursor16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$e || (_circle8$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "19",
      cy: "19",
      r: "4"
    })), _path20$h || (_path20$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM10 10V28H28V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var Home32 = /*#__PURE__*/React__default['default'].forwardRef(function Home32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$h || (_path21$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2138a1.01,1.01,0,0,0-1.2427,0L1,13.4194l1.2427,1.5717L4,13.6209V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM18,26H14V18h4Zm2,0V18a2.0023,2.0023,0,0,0-2-2H14a2.002,2.002,0,0,0-2,2v8H6V12.0615l10-7.79,10,7.8005V26Z"
    })), children);
  });
  var Home24 = /*#__PURE__*/React__default['default'].forwardRef(function Home24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$h || (_path22$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2138a1.01,1.01,0,0,0-1.2427,0L1,13.4194l1.2427,1.5717L4,13.6209V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM18,26H14V18h4Zm2,0V18a2.0023,2.0023,0,0,0-2-2H14a2.002,2.002,0,0,0-2,2v8H6V12.0615l10-7.79,10,7.8005V26Z"
    })), children);
  });
  var Home20 = /*#__PURE__*/React__default['default'].forwardRef(function Home20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$h || (_path23$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2138a1.01,1.01,0,0,0-1.2427,0L1,13.4194l1.2427,1.5717L4,13.6209V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM18,26H14V18h4Zm2,0V18a2.0023,2.0023,0,0,0-2-2H14a2.002,2.002,0,0,0-2,2v8H6V12.0615l10-7.79,10,7.8005V26Z"
    })), children);
  });
  var Home16 = /*#__PURE__*/React__default['default'].forwardRef(function Home16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$h || (_path24$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6123,2.2138a1.01,1.01,0,0,0-1.2427,0L1,13.4194l1.2427,1.5717L4,13.6209V26a2.0041,2.0041,0,0,0,2,2H26a2.0037,2.0037,0,0,0,2-2V13.63L29.7573,15,31,13.4282ZM18,26H14V18h4Zm2,0V18a2.0023,2.0023,0,0,0-2-2H14a2.002,2.002,0,0,0-2,2v8H6V12.0615l10-7.79,10,7.8005V26Z"
    })), children);
  });
  var HorizontalView32 = /*#__PURE__*/React__default['default'].forwardRef(function HorizontalView32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$h || (_path25$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 30zM4 20H3.9985L4 28H28V20zM28 14H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM4 4H3.9985L4 12H28V4z"
    })), children);
  });
  var HorizontalView24 = /*#__PURE__*/React__default['default'].forwardRef(function HorizontalView24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$h || (_path26$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 30zM4 20H3.9985L4 28H28V20zM28 14H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM4 4H3.9985L4 12H28V4z"
    })), children);
  });
  var HorizontalView20 = /*#__PURE__*/React__default['default'].forwardRef(function HorizontalView20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$h || (_path27$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 30zM4 20H3.9985L4 28H28V20zM28 14H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM4 4H3.9985L4 12H28V4z"
    })), children);
  });
  var HorizontalView16 = /*#__PURE__*/React__default['default'].forwardRef(function HorizontalView16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$h || (_path28$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 30zM4 20H3.9985L4 28H28V20zM28 14H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2v8A2.0021 2.0021 0 0128 14zM4 4H3.9985L4 12H28V4z"
    })), children);
  });
  var Hospital32 = /*#__PURE__*/React__default['default'].forwardRef(function Hospital32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$h || (_path29$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path30$h || (_path30$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H26V4a2.0023,2.0023,0,0,0-2-2H8A2.0023,2.0023,0,0,0,6,4v6H4a2.0023,2.0023,0,0,0-2,2V30H30V12A2.0023,2.0023,0,0,0,28,10ZM14,28V22h4v6Zm6,0V21a1,1,0,0,0-1-1H13a1,1,0,0,0-1,1v7H4V12H8V4H24v8h4V28Z"
    })), children);
  });
  var Hospital24 = /*#__PURE__*/React__default['default'].forwardRef(function Hospital24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$h || (_path31$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path32$h || (_path32$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H26V4a2.0023,2.0023,0,0,0-2-2H8A2.0023,2.0023,0,0,0,6,4v6H4a2.0023,2.0023,0,0,0-2,2V30H30V12A2.0023,2.0023,0,0,0,28,10ZM14,28V22h4v6Zm6,0V21a1,1,0,0,0-1-1H13a1,1,0,0,0-1,1v7H4V12H8V4H24v8h4V28Z"
    })), children);
  });
  var Hospital20 = /*#__PURE__*/React__default['default'].forwardRef(function Hospital20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$h || (_path33$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path34$h || (_path34$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H26V4a2.0023,2.0023,0,0,0-2-2H8A2.0023,2.0023,0,0,0,6,4v6H4a2.0023,2.0023,0,0,0-2,2V30H30V12A2.0023,2.0023,0,0,0,28,10ZM14,28V22h4v6Zm6,0V21a1,1,0,0,0-1-1H13a1,1,0,0,0-1,1v7H4V12H8V4H24v8h4V28Z"
    })), children);
  });
  var Hospital16 = /*#__PURE__*/React__default['default'].forwardRef(function Hospital16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$h || (_path35$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"
    })), _path36$h || (_path36$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H26V4a2.0023,2.0023,0,0,0-2-2H8A2.0023,2.0023,0,0,0,6,4v6H4a2.0023,2.0023,0,0,0-2,2V30H30V12A2.0023,2.0023,0,0,0,28,10ZM14,28V22h4v6Zm6,0V21a1,1,0,0,0-1-1H13a1,1,0,0,0-1,1v7H4V12H8V4H24v8h4V28Z"
    })), children);
  });
  var HospitalBed32 = /*#__PURE__*/React__default['default'].forwardRef(function HospitalBed32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$h || (_path37$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16H17a2.0023,2.0023,0,0,0-2,2v6H4V14H2V30H4V26H28v4h2V21A5.0059,5.0059,0,0,0,25,16Zm3,8H17V18h8a3.0033,3.0033,0,0,1,3,3Z"
    })), _path38$h || (_path38$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5 17A1.5 1.5 0 118 18.5 1.5017 1.5017 0 019.5 17m0-2A3.5 3.5 0 1013 18.5 3.5 3.5 0 009.5 15zM21 6L17 6 17 2 15 2 15 6 11 6 11 8 15 8 15 12 17 12 17 8 21 8 21 6z"
    })), children);
  });
  var HospitalBed24 = /*#__PURE__*/React__default['default'].forwardRef(function HospitalBed24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$h || (_path39$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16H17a2.0023,2.0023,0,0,0-2,2v6H4V14H2V30H4V26H28v4h2V21A5.0059,5.0059,0,0,0,25,16Zm3,8H17V18h8a3.0033,3.0033,0,0,1,3,3Z"
    })), _path40$h || (_path40$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5 17A1.5 1.5 0 118 18.5 1.5017 1.5017 0 019.5 17m0-2A3.5 3.5 0 1013 18.5 3.5 3.5 0 009.5 15zM21 6L17 6 17 2 15 2 15 6 11 6 11 8 15 8 15 12 17 12 17 8 21 8 21 6z"
    })), children);
  });
  var HospitalBed20 = /*#__PURE__*/React__default['default'].forwardRef(function HospitalBed20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$h || (_path41$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16H17a2.0023,2.0023,0,0,0-2,2v6H4V14H2V30H4V26H28v4h2V21A5.0059,5.0059,0,0,0,25,16Zm3,8H17V18h8a3.0033,3.0033,0,0,1,3,3Z"
    })), _path42$h || (_path42$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5 17A1.5 1.5 0 118 18.5 1.5017 1.5017 0 019.5 17m0-2A3.5 3.5 0 1013 18.5 3.5 3.5 0 009.5 15zM21 6L17 6 17 2 15 2 15 6 11 6 11 8 15 8 15 12 17 12 17 8 21 8 21 6z"
    })), children);
  });
  var HospitalBed16 = /*#__PURE__*/React__default['default'].forwardRef(function HospitalBed16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$h || (_path43$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,16H17a2.0023,2.0023,0,0,0-2,2v6H4V14H2V30H4V26H28v4h2V21A5.0059,5.0059,0,0,0,25,16Zm3,8H17V18h8a3.0033,3.0033,0,0,1,3,3Z"
    })), _path44$h || (_path44$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5 17A1.5 1.5 0 118 18.5 1.5017 1.5017 0 019.5 17m0-2A3.5 3.5 0 1013 18.5 3.5 3.5 0 009.5 15zM21 6L17 6 17 2 15 2 15 6 11 6 11 8 15 8 15 12 17 12 17 8 21 8 21 6z"
    })), children);
  });
  var Hotel32 = /*#__PURE__*/React__default['default'].forwardRef(function Hotel32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$h || (_path45$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"
    })), _path46$h || (_path46$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"
    })), children);
  });
  var Hotel24 = /*#__PURE__*/React__default['default'].forwardRef(function Hotel24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$h || (_path47$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"
    })), _path48$h || (_path48$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"
    })), children);
  });
  var Hotel20 = /*#__PURE__*/React__default['default'].forwardRef(function Hotel20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$h || (_path49$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"
    })), _path50$h || (_path50$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"
    })), children);
  });
  var Hotel16 = /*#__PURE__*/React__default['default'].forwardRef(function Hotel16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$h || (_path51$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"
    })), _path52$h || (_path52$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"
    })), children);
  });
  var Hourglass32 = /*#__PURE__*/React__default['default'].forwardRef(function Hourglass32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$h || (_path53$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V21H15zM15 23H17V25H15z"
    })), _path54$h || (_path54$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"
    })), children);
  });
  var Hourglass24 = /*#__PURE__*/React__default['default'].forwardRef(function Hourglass24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$h || (_path55$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V21H15zM15 23H17V25H15z"
    })), _path56$h || (_path56$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"
    })), children);
  });
  var Hourglass20 = /*#__PURE__*/React__default['default'].forwardRef(function Hourglass20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$h || (_path57$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V21H15zM15 23H17V25H15z"
    })), _path58$h || (_path58$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"
    })), children);
  });
  var Hourglass16 = /*#__PURE__*/React__default['default'].forwardRef(function Hourglass16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$h || (_path59$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V21H15zM15 23H17V25H15z"
    })), _path60$h || (_path60$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"
    })), children);
  });
  var Html32 = /*#__PURE__*/React__default['default'].forwardRef(function Html32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$h || (_path61$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L28 11 26 11 26 21 32 21 32 19 28 19zM24 11L22 11 20.5 15 19 11 17 11 17 21 19 21 19 14 20.5 18 22 14 22 21 24 21 24 11zM9 13L11 13 11 21 13 21 13 13 15 13 15 11 9 11 9 13zM5 11L5 15 2 15 2 11 0 11 0 21 2 21 2 17 5 17 5 21 7 21 7 11 5 11z"
    })), children);
  });
  var Html24 = /*#__PURE__*/React__default['default'].forwardRef(function Html24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$h || (_path62$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L28 11 26 11 26 21 32 21 32 19 28 19zM24 11L22 11 20.5 15 19 11 17 11 17 21 19 21 19 14 20.5 18 22 14 22 21 24 21 24 11zM9 13L11 13 11 21 13 21 13 13 15 13 15 11 9 11 9 13zM5 11L5 15 2 15 2 11 0 11 0 21 2 21 2 17 5 17 5 21 7 21 7 11 5 11z"
    })), children);
  });
  var Html20 = /*#__PURE__*/React__default['default'].forwardRef(function Html20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$h || (_path63$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L28 11 26 11 26 21 32 21 32 19 28 19zM24 11L22 11 20.5 15 19 11 17 11 17 21 19 21 19 14 20.5 18 22 14 22 21 24 21 24 11zM9 13L11 13 11 21 13 21 13 13 15 13 15 11 9 11 9 13zM5 11L5 15 2 15 2 11 0 11 0 21 2 21 2 17 5 17 5 21 7 21 7 11 5 11z"
    })), children);
  });
  var Html16 = /*#__PURE__*/React__default['default'].forwardRef(function Html16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$h || (_path64$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 19L28 11 26 11 26 21 32 21 32 19 28 19zM24 11L22 11 20.5 15 19 11 17 11 17 21 19 21 19 14 20.5 18 22 14 22 21 24 21 24 11zM9 13L11 13 11 21 13 21 13 13 15 13 15 11 9 11 9 13zM5 11L5 15 2 15 2 11 0 11 0 21 2 21 2 17 5 17 5 21 7 21 7 11 5 11z"
    })), children);
  });
  var HtmlReference32 = /*#__PURE__*/React__default['default'].forwardRef(function HtmlReference32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$h || (_path65$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 14L28 6 26 6 26 16 32 16 32 14 28 14zM24 6L22 6 20.5 10 19 6 17 6 17 16 19 16 19 9 20.5 13 22 9 22 16 24 16 24 6zM9 8L11 8 11 16 13 16 13 8 15 8 15 6 9 6 9 8zM5 6L5 10 2 10 2 6 0 6 0 16 2 16 2 12 5 12 5 16 7 16 7 6 5 6z"
    })), children);
  });
  var HtmlReference24 = /*#__PURE__*/React__default['default'].forwardRef(function HtmlReference24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$h || (_path66$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 14L28 6 26 6 26 16 32 16 32 14 28 14zM24 6L22 6 20.5 10 19 6 17 6 17 16 19 16 19 9 20.5 13 22 9 22 16 24 16 24 6zM9 8L11 8 11 16 13 16 13 8 15 8 15 6 9 6 9 8zM5 6L5 10 2 10 2 6 0 6 0 16 2 16 2 12 5 12 5 16 7 16 7 6 5 6z"
    })), children);
  });
  var HtmlReference20 = /*#__PURE__*/React__default['default'].forwardRef(function HtmlReference20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$h || (_path67$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 14L28 6 26 6 26 16 32 16 32 14 28 14zM24 6L22 6 20.5 10 19 6 17 6 17 16 19 16 19 9 20.5 13 22 9 22 16 24 16 24 6zM9 8L11 8 11 16 13 16 13 8 15 8 15 6 9 6 9 8zM5 6L5 10 2 10 2 6 0 6 0 16 2 16 2 12 5 12 5 16 7 16 7 6 5 6z"
    })), children);
  });
  var HtmlReference16 = /*#__PURE__*/React__default['default'].forwardRef(function HtmlReference16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$h || (_path68$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 14L28 6 26 6 26 16 32 16 32 14 28 14zM24 6L22 6 20.5 10 19 6 17 6 17 16 19 16 19 9 20.5 13 22 9 22 16 24 16 24 6zM9 8L11 8 11 16 13 16 13 8 15 8 15 6 9 6 9 8zM5 6L5 10 2 10 2 6 0 6 0 16 2 16 2 12 5 12 5 16 7 16 7 6 5 6z"
    })), children);
  });
  var Http32 = /*#__PURE__*/React__default['default'].forwardRef(function Http32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$h || (_path69$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11H25V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0030 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"
    })), children);
  });
  var Http24 = /*#__PURE__*/React__default['default'].forwardRef(function Http24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$h || (_path70$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11H25V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0030 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"
    })), children);
  });
  var Http20 = /*#__PURE__*/React__default['default'].forwardRef(function Http20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$h || (_path71$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11H25V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0030 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"
    })), children);
  });
  var Http16 = /*#__PURE__*/React__default['default'].forwardRef(function Http16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$h || (_path72$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11H25V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0030 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"
    })), children);
  });
  var Humidity32 = /*#__PURE__*/React__default['default'].forwardRef(function Humidity32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$h || (_path73$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4761,13.9932,16.8472,3.4365a1.04,1.04,0,0,0-1.6944,0L8.4941,14.0444A9.9861,9.9861,0,0,0,7,19a9,9,0,0,0,18,0A10.0632,10.0632,0,0,0,23.4761,13.9932ZM16,26.0005a7.0089,7.0089,0,0,1-7-7,7.978,7.978,0,0,1,1.2183-3.9438l.935-1.4888L21.2271,23.6411A6.9772,6.9772,0,0,1,16,26.0005Z"
    })), children);
  });
  var Humidity24 = /*#__PURE__*/React__default['default'].forwardRef(function Humidity24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$h || (_path74$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4761,13.9932,16.8472,3.4365a1.04,1.04,0,0,0-1.6944,0L8.4941,14.0444A9.9861,9.9861,0,0,0,7,19a9,9,0,0,0,18,0A10.0632,10.0632,0,0,0,23.4761,13.9932ZM16,26.0005a7.0089,7.0089,0,0,1-7-7,7.978,7.978,0,0,1,1.2183-3.9438l.935-1.4888L21.2271,23.6411A6.9772,6.9772,0,0,1,16,26.0005Z"
    })), children);
  });
  var Humidity20 = /*#__PURE__*/React__default['default'].forwardRef(function Humidity20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$h || (_path75$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4761,13.9932,16.8472,3.4365a1.04,1.04,0,0,0-1.6944,0L8.4941,14.0444A9.9861,9.9861,0,0,0,7,19a9,9,0,0,0,18,0A10.0632,10.0632,0,0,0,23.4761,13.9932ZM16,26.0005a7.0089,7.0089,0,0,1-7-7,7.978,7.978,0,0,1,1.2183-3.9438l.935-1.4888L21.2271,23.6411A6.9772,6.9772,0,0,1,16,26.0005Z"
    })), children);
  });
  var Humidity16 = /*#__PURE__*/React__default['default'].forwardRef(function Humidity16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$h || (_path76$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4761,13.9932,16.8472,3.4365a1.04,1.04,0,0,0-1.6944,0L8.4941,14.0444A9.9861,9.9861,0,0,0,7,19a9,9,0,0,0,18,0A10.0632,10.0632,0,0,0,23.4761,13.9932ZM16,26.0005a7.0089,7.0089,0,0,1-7-7,7.978,7.978,0,0,1,1.2183-3.9438l.935-1.4888L21.2271,23.6411A6.9772,6.9772,0,0,1,16,26.0005Z"
    })), children);
  });
  var HumidityAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function HumidityAlt32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$h || (_path77$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L25.17 2.4141a1.0381 1.0381 0 011.6592 0L29.3154 6.11A3.9693 3.9693 0 0130 8.223 3.8978 3.8978 0 0126 12zm0-7.2368L24.3438 7.2257A1.89 1.89 0 0024 8.223a2.0139 2.0139 0 004 0 1.98 1.98 0 00-.375-1.0466zM23.5 30H8.5A6.4962 6.4962 0 017.2 17.1381a8.9938 8.9938 0 0117.6006 0A6.4964 6.4964 0 0123.5 30zM16 12a7 7 0 00-6.9414 6.1452l-.0991.8122-.8155.064A4.4962 4.4962 0 008.5 28h15a4.4962 4.4962 0 00.3564-8.9786l-.8154-.064-.0986-.8122A7.0022 7.0022 0 0016 12z"
    })), children);
  });
  var HumidityAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function HumidityAlt24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$h || (_path78$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L25.17 2.4141a1.0381 1.0381 0 011.6592 0L29.3154 6.11A3.9693 3.9693 0 0130 8.223 3.8978 3.8978 0 0126 12zm0-7.2368L24.3438 7.2257A1.89 1.89 0 0024 8.223a2.0139 2.0139 0 004 0 1.98 1.98 0 00-.375-1.0466zM23.5 30H8.5A6.4962 6.4962 0 017.2 17.1381a8.9938 8.9938 0 0117.6006 0A6.4964 6.4964 0 0123.5 30zM16 12a7 7 0 00-6.9414 6.1452l-.0991.8122-.8155.064A4.4962 4.4962 0 008.5 28h15a4.4962 4.4962 0 00.3564-8.9786l-.8154-.064-.0986-.8122A7.0022 7.0022 0 0016 12z"
    })), children);
  });
  var HumidityAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function HumidityAlt20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$h || (_path79$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L25.17 2.4141a1.0381 1.0381 0 011.6592 0L29.3154 6.11A3.9693 3.9693 0 0130 8.223 3.8978 3.8978 0 0126 12zm0-7.2368L24.3438 7.2257A1.89 1.89 0 0024 8.223a2.0139 2.0139 0 004 0 1.98 1.98 0 00-.375-1.0466zM23.5 30H8.5A6.4962 6.4962 0 017.2 17.1381a8.9938 8.9938 0 0117.6006 0A6.4964 6.4964 0 0123.5 30zM16 12a7 7 0 00-6.9414 6.1452l-.0991.8122-.8155.064A4.4962 4.4962 0 008.5 28h15a4.4962 4.4962 0 00.3564-8.9786l-.8154-.064-.0986-.8122A7.0022 7.0022 0 0016 12z"
    })), children);
  });
  var HumidityAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function HumidityAlt16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$h || (_path80$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L25.17 2.4141a1.0381 1.0381 0 011.6592 0L29.3154 6.11A3.9693 3.9693 0 0130 8.223 3.8978 3.8978 0 0126 12zm0-7.2368L24.3438 7.2257A1.89 1.89 0 0024 8.223a2.0139 2.0139 0 004 0 1.98 1.98 0 00-.375-1.0466zM23.5 30H8.5A6.4962 6.4962 0 017.2 17.1381a8.9938 8.9938 0 0117.6006 0A6.4964 6.4964 0 0123.5 30zM16 12a7 7 0 00-6.9414 6.1452l-.0991.8122-.8155.064A4.4962 4.4962 0 008.5 28h15a4.4962 4.4962 0 00.3564-8.9786l-.8154-.064-.0986-.8122A7.0022 7.0022 0 0016 12z"
    })), children);
  });
  var Hurricane32 = /*#__PURE__*/React__default['default'].forwardRef(function Hurricane32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$h || (_path81$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var Hurricane24 = /*#__PURE__*/React__default['default'].forwardRef(function Hurricane24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$h || (_path82$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var Hurricane20 = /*#__PURE__*/React__default['default'].forwardRef(function Hurricane20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$h || (_path83$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var Hurricane16 = /*#__PURE__*/React__default['default'].forwardRef(function Hurricane16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$h || (_path84$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var HybridNetworking32 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworking32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$h || (_path85$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"
    })), _path86$h || (_path86$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"
    })), _path87$h || (_path87$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"
    })), children);
  });
  var HybridNetworking24 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworking24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$h || (_path88$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"
    })), _path89$h || (_path89$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"
    })), _path90$h || (_path90$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"
    })), children);
  });
  var HybridNetworking20 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworking20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$h || (_path91$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"
    })), _path92$h || (_path92$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"
    })), _path93$h || (_path93$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"
    })), children);
  });
  var HybridNetworking16 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworking16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$h || (_path94$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"
    })), _path95$h || (_path95$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"
    })), _path96$h || (_path96$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"
    })), children);
  });
  var HybridNetworkingAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworkingAlt32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$h || (_path97$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9583,3.9583,0,0,0-2.02.5659L17.4141,16,23.981,9.4331A3.9521,3.9521,0,0,0,26,10a4,4,0,1,0-4-4,3.951,3.951,0,0,0,.5669,2.019L16,14.5859,9.4343,8.02A3.9577,3.9577,0,0,0,10,6a4,4,0,1,0-4,4,3.9583,3.9583,0,0,0,2.02-.5659L14.5859,16,8.019,22.5669A3.9521,3.9521,0,0,0,6,22a4,4,0,1,0,4,4,3.951,3.951,0,0,0-.5669-2.019L16,17.4141,22.5657,23.98A3.9577,3.9577,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Z"
    })), children);
  });
  var HybridNetworkingAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworkingAlt24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$h || (_path98$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9583,3.9583,0,0,0-2.02.5659L17.4141,16,23.981,9.4331A3.9521,3.9521,0,0,0,26,10a4,4,0,1,0-4-4,3.951,3.951,0,0,0,.5669,2.019L16,14.5859,9.4343,8.02A3.9577,3.9577,0,0,0,10,6a4,4,0,1,0-4,4,3.9583,3.9583,0,0,0,2.02-.5659L14.5859,16,8.019,22.5669A3.9521,3.9521,0,0,0,6,22a4,4,0,1,0,4,4,3.951,3.951,0,0,0-.5669-2.019L16,17.4141,22.5657,23.98A3.9577,3.9577,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Z"
    })), children);
  });
  var HybridNetworkingAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworkingAlt20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$h || (_path99$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9583,3.9583,0,0,0-2.02.5659L17.4141,16,23.981,9.4331A3.9521,3.9521,0,0,0,26,10a4,4,0,1,0-4-4,3.951,3.951,0,0,0,.5669,2.019L16,14.5859,9.4343,8.02A3.9577,3.9577,0,0,0,10,6a4,4,0,1,0-4,4,3.9583,3.9583,0,0,0,2.02-.5659L14.5859,16,8.019,22.5669A3.9521,3.9521,0,0,0,6,22a4,4,0,1,0,4,4,3.951,3.951,0,0,0-.5669-2.019L16,17.4141,22.5657,23.98A3.9577,3.9577,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Z"
    })), children);
  });
  var HybridNetworkingAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function HybridNetworkingAlt16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$h || (_path100$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.9583,3.9583,0,0,0-2.02.5659L17.4141,16,23.981,9.4331A3.9521,3.9521,0,0,0,26,10a4,4,0,1,0-4-4,3.951,3.951,0,0,0,.5669,2.019L16,14.5859,9.4343,8.02A3.9577,3.9577,0,0,0,10,6a4,4,0,1,0-4,4,3.9583,3.9583,0,0,0,2.02-.5659L14.5859,16,8.019,22.5669A3.9521,3.9521,0,0,0,6,22a4,4,0,1,0,4,4,3.951,3.951,0,0,0-.5669-2.019L16,17.4141,22.5657,23.98A3.9577,3.9577,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Z"
    })), children);
  });
  var IbmDataReplication32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmDataReplication32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$h || (_path101$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20v2h5.22a11.0163 11.0163 0 01-11.97 4.6533l-.4986 1.937A13 13 0 0026 24.293V28h2V20zM25 3a4.0045 4.0045 0 00-4 4 3.954 3.954 0 00.5669 2.019L9.019 21.5669A3.9521 3.9521 0 007 21a4 4 0 104 4 3.954 3.954 0 00-.5669-2.019L22.981 10.4331A3.9518 3.9518 0 0025 11a4 4 0 000-8zM7 27a2 2 0 112-2A2.002 2.002 0 017 27zM25 9a2 2 0 112-2A2.002 2.002 0 0125 9zM16 3A13.04 13.04 0 006 7.707V4H4v8h8V10H6.78a11.0163 11.0163 0 0111.97-4.6533l.4986-1.937A13.0358 13.0358 0 0016 3z"
    })), children);
  });
  var IbmDataReplication24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmDataReplication24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$h || (_path102$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20v2h5.22a11.0163 11.0163 0 01-11.97 4.6533l-.4986 1.937A13 13 0 0026 24.293V28h2V20zM25 3a4.0045 4.0045 0 00-4 4 3.954 3.954 0 00.5669 2.019L9.019 21.5669A3.9521 3.9521 0 007 21a4 4 0 104 4 3.954 3.954 0 00-.5669-2.019L22.981 10.4331A3.9518 3.9518 0 0025 11a4 4 0 000-8zM7 27a2 2 0 112-2A2.002 2.002 0 017 27zM25 9a2 2 0 112-2A2.002 2.002 0 0125 9zM16 3A13.04 13.04 0 006 7.707V4H4v8h8V10H6.78a11.0163 11.0163 0 0111.97-4.6533l.4986-1.937A13.0358 13.0358 0 0016 3z"
    })), children);
  });
  var IbmDataReplication20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmDataReplication20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$h || (_path103$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20v2h5.22a11.0163 11.0163 0 01-11.97 4.6533l-.4986 1.937A13 13 0 0026 24.293V28h2V20zM25 3a4.0045 4.0045 0 00-4 4 3.954 3.954 0 00.5669 2.019L9.019 21.5669A3.9521 3.9521 0 007 21a4 4 0 104 4 3.954 3.954 0 00-.5669-2.019L22.981 10.4331A3.9518 3.9518 0 0025 11a4 4 0 000-8zM7 27a2 2 0 112-2A2.002 2.002 0 017 27zM25 9a2 2 0 112-2A2.002 2.002 0 0125 9zM16 3A13.04 13.04 0 006 7.707V4H4v8h8V10H6.78a11.0163 11.0163 0 0111.97-4.6533l.4986-1.937A13.0358 13.0358 0 0016 3z"
    })), children);
  });
  var IbmDataReplication16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmDataReplication16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$h || (_path104$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20v2h5.22a11.0163 11.0163 0 01-11.97 4.6533l-.4986 1.937A13 13 0 0026 24.293V28h2V20zM25 3a4.0045 4.0045 0 00-4 4 3.954 3.954 0 00.5669 2.019L9.019 21.5669A3.9521 3.9521 0 007 21a4 4 0 104 4 3.954 3.954 0 00-.5669-2.019L22.981 10.4331A3.9518 3.9518 0 0025 11a4 4 0 000-8zM7 27a2 2 0 112-2A2.002 2.002 0 017 27zM25 9a2 2 0 112-2A2.002 2.002 0 0125 9zM16 3A13.04 13.04 0 006 7.707V4H4v8h8V10H6.78a11.0163 11.0163 0 0111.97-4.6533l.4986-1.937A13.0358 13.0358 0 0016 3z"
    })), children);
  });
  var IbmMatch_36032 = /*#__PURE__*/React__default['default'].forwardRef(function IbmMatch_36032(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$h || (_path105$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25a2 2 0 102 2A2.0059 2.0059 0 005 25zM16 25a2 2 0 102 2A2.0059 2.0059 0 0016 25zM27 25a2 2 0 102 2A2.0059 2.0059 0 0027 25zM28 23H26V11a2.0059 2.0059 0 00-2-2H22V7h2a4.0118 4.0118 0 014 4zM15 12H17V23H15zM6 23H4V11A4.0118 4.0118 0 018 7h2V9H8a2.0059 2.0059 0 00-2 2zM16 2L14.7 4.6343l-2.9057.42 2.1029 2.0514L13.4 10 16 8.6343 18.6 10l-.4972-2.8943 2.1029-2.0486L17.3 4.6343z"
    })), children);
  });
  var IbmMatch_36024 = /*#__PURE__*/React__default['default'].forwardRef(function IbmMatch_36024(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$h || (_path106$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25a2 2 0 102 2A2.0059 2.0059 0 005 25zM16 25a2 2 0 102 2A2.0059 2.0059 0 0016 25zM27 25a2 2 0 102 2A2.0059 2.0059 0 0027 25zM28 23H26V11a2.0059 2.0059 0 00-2-2H22V7h2a4.0118 4.0118 0 014 4zM15 12H17V23H15zM6 23H4V11A4.0118 4.0118 0 018 7h2V9H8a2.0059 2.0059 0 00-2 2zM16 2L14.7 4.6343l-2.9057.42 2.1029 2.0514L13.4 10 16 8.6343 18.6 10l-.4972-2.8943 2.1029-2.0486L17.3 4.6343z"
    })), children);
  });
  var IbmMatch_36020 = /*#__PURE__*/React__default['default'].forwardRef(function IbmMatch_36020(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$h || (_path107$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25a2 2 0 102 2A2.0059 2.0059 0 005 25zM16 25a2 2 0 102 2A2.0059 2.0059 0 0016 25zM27 25a2 2 0 102 2A2.0059 2.0059 0 0027 25zM28 23H26V11a2.0059 2.0059 0 00-2-2H22V7h2a4.0118 4.0118 0 014 4zM15 12H17V23H15zM6 23H4V11A4.0118 4.0118 0 018 7h2V9H8a2.0059 2.0059 0 00-2 2zM16 2L14.7 4.6343l-2.9057.42 2.1029 2.0514L13.4 10 16 8.6343 18.6 10l-.4972-2.8943 2.1029-2.0486L17.3 4.6343z"
    })), children);
  });
  var IbmMatch_36016 = /*#__PURE__*/React__default['default'].forwardRef(function IbmMatch_36016(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$h || (_path108$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 25a2 2 0 102 2A2.0059 2.0059 0 005 25zM16 25a2 2 0 102 2A2.0059 2.0059 0 0016 25zM27 25a2 2 0 102 2A2.0059 2.0059 0 0027 25zM28 23H26V11a2.0059 2.0059 0 00-2-2H22V7h2a4.0118 4.0118 0 014 4zM15 12H17V23H15zM6 23H4V11A4.0118 4.0118 0 018 7h2V9H8a2.0059 2.0059 0 00-2 2zM16 2L14.7 4.6343l-2.9057.42 2.1029 2.0514L13.4 10 16 8.6343 18.6 10l-.4972-2.8943 2.1029-2.0486L17.3 4.6343z"
    })), children);
  });
  var IbmCloud32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloud32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$h || (_path109$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5805 13.65A9.7327 9.7327 0 006.286 17.5387 6.75 6.75 0 007 31H23a8.7465 8.7465 0 001.5805-17.35zM23 29.5H7a5.2373 5.2373 0 01-.6993-10.4293 9.7265 9.7265 0 001.1036 3.7838.75.75 0 101.3213-.709A8.25 8.25 0 0122.752 13.5133a8.754 8.754 0 00-6.315 2.95.75.75 0 101.1245.9922A7.25 7.25 0 1123 29.5zM31.8983 10.2548a.7582.7582 0 00-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1028.6 13.035l3.02-1.7438A.7589.7589 0 0031.8983 10.2548zM22.6764 7.87a.7583.7583 0 001.0364-.2776l1.7438-3.02a.7587.7587 0 00-1.314-.7588l-1.7438 3.02A.7588.7588 0 0022.6764 7.87zM16 6.0811a.759.759 0 00.7588-.7588V1.8347a.7588.7588 0 10-1.5175 0V5.3223A.7589.7589 0 0016 6.0811zM8.2873 7.5922a.7587.7587 0 001.314-.7588l-1.7438-3.02a.7587.7587 0 10-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 10-.7588 1.314L3.4 13.035a.7587.7587 0 10.7588-1.314z"
    })), children);
  });
  var IbmCloud24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloud24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$h || (_path110$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5805 13.65A9.7327 9.7327 0 006.286 17.5387 6.75 6.75 0 007 31H23a8.7465 8.7465 0 001.5805-17.35zM23 29.5H7a5.2373 5.2373 0 01-.6993-10.4293 9.7265 9.7265 0 001.1036 3.7838.75.75 0 101.3213-.709A8.25 8.25 0 0122.752 13.5133a8.754 8.754 0 00-6.315 2.95.75.75 0 101.1245.9922A7.25 7.25 0 1123 29.5zM31.8983 10.2548a.7582.7582 0 00-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1028.6 13.035l3.02-1.7438A.7589.7589 0 0031.8983 10.2548zM22.6764 7.87a.7583.7583 0 001.0364-.2776l1.7438-3.02a.7587.7587 0 00-1.314-.7588l-1.7438 3.02A.7588.7588 0 0022.6764 7.87zM16 6.0811a.759.759 0 00.7588-.7588V1.8347a.7588.7588 0 10-1.5175 0V5.3223A.7589.7589 0 0016 6.0811zM8.2873 7.5922a.7587.7587 0 001.314-.7588l-1.7438-3.02a.7587.7587 0 10-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 10-.7588 1.314L3.4 13.035a.7587.7587 0 10.7588-1.314z"
    })), children);
  });
  var IbmCloud20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloud20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$h || (_path111$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5805 13.65A9.7327 9.7327 0 006.286 17.5387 6.75 6.75 0 007 31H23a8.7465 8.7465 0 001.5805-17.35zM23 29.5H7a5.2373 5.2373 0 01-.6993-10.4293 9.7265 9.7265 0 001.1036 3.7838.75.75 0 101.3213-.709A8.25 8.25 0 0122.752 13.5133a8.754 8.754 0 00-6.315 2.95.75.75 0 101.1245.9922A7.25 7.25 0 1123 29.5zM31.8983 10.2548a.7582.7582 0 00-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1028.6 13.035l3.02-1.7438A.7589.7589 0 0031.8983 10.2548zM22.6764 7.87a.7583.7583 0 001.0364-.2776l1.7438-3.02a.7587.7587 0 00-1.314-.7588l-1.7438 3.02A.7588.7588 0 0022.6764 7.87zM16 6.0811a.759.759 0 00.7588-.7588V1.8347a.7588.7588 0 10-1.5175 0V5.3223A.7589.7589 0 0016 6.0811zM8.2873 7.5922a.7587.7587 0 001.314-.7588l-1.7438-3.02a.7587.7587 0 10-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 10-.7588 1.314L3.4 13.035a.7587.7587 0 10.7588-1.314z"
    })), children);
  });
  var IbmCloud16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloud16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$h || (_path112$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5805 13.65A9.7327 9.7327 0 006.286 17.5387 6.75 6.75 0 007 31H23a8.7465 8.7465 0 001.5805-17.35zM23 29.5H7a5.2373 5.2373 0 01-.6993-10.4293 9.7265 9.7265 0 001.1036 3.7838.75.75 0 101.3213-.709A8.25 8.25 0 0122.752 13.5133a8.754 8.754 0 00-6.315 2.95.75.75 0 101.1245.9922A7.25 7.25 0 1123 29.5zM31.8983 10.2548a.7582.7582 0 00-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1028.6 13.035l3.02-1.7438A.7589.7589 0 0031.8983 10.2548zM22.6764 7.87a.7583.7583 0 001.0364-.2776l1.7438-3.02a.7587.7587 0 00-1.314-.7588l-1.7438 3.02A.7588.7588 0 0022.6764 7.87zM16 6.0811a.759.759 0 00.7588-.7588V1.8347a.7588.7588 0 10-1.5175 0V5.3223A.7589.7589 0 0016 6.0811zM8.2873 7.5922a.7587.7587 0 001.314-.7588l-1.7438-3.02a.7587.7587 0 10-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 10-.7588 1.314L3.4 13.035a.7587.7587 0 10.7588-1.314z"
    })), children);
  });
  var IbmCloudDedicatedHost32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudDedicatedHost32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$e || (_circle9$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path113$h || (_path113$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v4h2V10h9a2 2 0 002-2V4A2 2 0 0026 2zm0 6H6V4H26zM17 28L17 26 15 26 15 28 4 28 4 30 28 30 28 28 17 28z"
    })), _circle10$e || (_circle10$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "1"
    })), _path114$h || (_path114$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H26a2,2,0,0,0,2-2V18a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v4A2,2,0,0,0,6,24Zm0-6H26v4H6Z"
    })), children);
  });
  var IbmCloudDedicatedHost24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudDedicatedHost24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$d || (_circle11$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path115$h || (_path115$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v4h2V10h9a2 2 0 002-2V4A2 2 0 0026 2zm0 6H6V4H26zM17 28L17 26 15 26 15 28 4 28 4 30 28 30 28 28 17 28z"
    })), _circle12$d || (_circle12$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "1"
    })), _path116$h || (_path116$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H26a2,2,0,0,0,2-2V18a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v4A2,2,0,0,0,6,24Zm0-6H26v4H6Z"
    })), children);
  });
  var IbmCloudDedicatedHost20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudDedicatedHost20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$d || (_circle13$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path117$h || (_path117$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v4h2V10h9a2 2 0 002-2V4A2 2 0 0026 2zm0 6H6V4H26zM17 28L17 26 15 26 15 28 4 28 4 30 28 30 28 28 17 28z"
    })), _circle14$d || (_circle14$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "1"
    })), _path118$h || (_path118$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H26a2,2,0,0,0,2-2V18a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v4A2,2,0,0,0,6,24Zm0-6H26v4H6Z"
    })), children);
  });
  var IbmCloudDedicatedHost16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudDedicatedHost16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$d || (_circle15$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "6",
      r: "1"
    })), _path119$h || (_path119$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v4h2V10h9a2 2 0 002-2V4A2 2 0 0026 2zm0 6H6V4H26zM17 28L17 26 15 26 15 28 4 28 4 30 28 30 28 28 17 28z"
    })), _circle16$d || (_circle16$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "20",
      r: "1"
    })), _path120$h || (_path120$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,24H26a2,2,0,0,0,2-2V18a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v4A2,2,0,0,0,6,24Zm0-6H26v4H6Z"
    })), children);
  });
  var IbmCloudInternetServices32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudInternetServices32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$h || (_path121$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,9.5,25H11V23H9.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,25.7368,10Z"
    })), _path122$h || (_path122$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,24a2.9716,2.9716,0,0,0-1.9253.7188l-4.1008-2.461C20.9814,22.1719,21,22.0884,21,22s-.0186-.1709-.0259-.2568l4.1016-2.461A2.9712,2.9712,0,0,0,27,20a3.021,3.021,0,1,0-2.9434-2.4385l-3.9121,2.3472a3,3,0,1,0-.0009,4.1836l3.913,2.3476A2.9979,2.9979,0,1,0,27,24Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,16Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,23Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,28Z"
    })), children);
  });
  var IbmCloudInternetServices24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudInternetServices24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$h || (_path123$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,9.5,25H11V23H9.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,25.7368,10Z"
    })), _path124$h || (_path124$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,24a2.9716,2.9716,0,0,0-1.9253.7188l-4.1008-2.461C20.9814,22.1719,21,22.0884,21,22s-.0186-.1709-.0259-.2568l4.1016-2.461A2.9712,2.9712,0,0,0,27,20a3.021,3.021,0,1,0-2.9434-2.4385l-3.9121,2.3472a3,3,0,1,0-.0009,4.1836l3.913,2.3476A2.9979,2.9979,0,1,0,27,24Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,16Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,23Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,28Z"
    })), children);
  });
  var IbmCloudInternetServices20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudInternetServices20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$h || (_path125$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,9.5,25H11V23H9.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,25.7368,10Z"
    })), _path126$h || (_path126$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,24a2.9716,2.9716,0,0,0-1.9253.7188l-4.1008-2.461C20.9814,22.1719,21,22.0884,21,22s-.0186-.1709-.0259-.2568l4.1016-2.461A2.9712,2.9712,0,0,0,27,20a3.021,3.021,0,1,0-2.9434-2.4385l-3.9121,2.3472a3,3,0,1,0-.0009,4.1836l3.913,2.3476A2.9979,2.9979,0,1,0,27,24Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,16Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,23Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,28Z"
    })), children);
  });
  var IbmCloudInternetServices16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudInternetServices16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$h || (_path127$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,9.5,25H11V23H9.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,25.7368,10Z"
    })), _path128$h || (_path128$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,24a2.9716,2.9716,0,0,0-1.9253.7188l-4.1008-2.461C20.9814,22.1719,21,22.0884,21,22s-.0186-.1709-.0259-.2568l4.1016-2.461A2.9712,2.9712,0,0,0,27,20a3.021,3.021,0,1,0-2.9434-2.4385l-3.9121,2.3472a3,3,0,1,0-.0009,4.1836l3.913,2.3476A2.9979,2.9979,0,1,0,27,24Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,27,16Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,18,23Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,27,28Z"
    })), children);
  });
  var IbmCloudSubnets32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudSubnets32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$h || (_path129$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.6069,3.6069,0,0,0-2,.6L19.4143,18,18,19.4141,22.6,24a4.1755,4.1755,0,0,0-.4,1H9.8583A3.5525,3.5525,0,0,0,9.4,24L24,9.4a3.6069,3.6069,0,0,0,2,.6,4,4,0,1,0-3.8569-5H9.9A4.0785,4.0785,0,0,0,6,2a4,4,0,0,0,0,8,3.6066,3.6066,0,0,0,2-.6L12.5858,14,14,12.5859,9.4,8a4.175,4.175,0,0,0,.4-1H22.1418A3.5553,3.5553,0,0,0,22.6,8L8,22.6A3.6066,3.6066,0,0,0,6,22a4,4,0,1,0,3.8569,5H22.1A4.0118,4.0118,0,1,0,26,22ZM26,4a2,2,0,1,1-2,2A2.0058,2.0058,0,0,1,26,4ZM6,8A2,2,0,1,1,8,6,2.0058,2.0058,0,0,1,6,8ZM6,28a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,28Z"
    })), children);
  });
  var IbmCloudSubnets24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudSubnets24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$h || (_path130$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.6069,3.6069,0,0,0-2,.6L19.4143,18,18,19.4141,22.6,24a4.1755,4.1755,0,0,0-.4,1H9.8583A3.5525,3.5525,0,0,0,9.4,24L24,9.4a3.6069,3.6069,0,0,0,2,.6,4,4,0,1,0-3.8569-5H9.9A4.0785,4.0785,0,0,0,6,2a4,4,0,0,0,0,8,3.6066,3.6066,0,0,0,2-.6L12.5858,14,14,12.5859,9.4,8a4.175,4.175,0,0,0,.4-1H22.1418A3.5553,3.5553,0,0,0,22.6,8L8,22.6A3.6066,3.6066,0,0,0,6,22a4,4,0,1,0,3.8569,5H22.1A4.0118,4.0118,0,1,0,26,22ZM26,4a2,2,0,1,1-2,2A2.0058,2.0058,0,0,1,26,4ZM6,8A2,2,0,1,1,8,6,2.0058,2.0058,0,0,1,6,8ZM6,28a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,28Z"
    })), children);
  });
  var IbmCloudSubnets20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudSubnets20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$h || (_path131$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.6069,3.6069,0,0,0-2,.6L19.4143,18,18,19.4141,22.6,24a4.1755,4.1755,0,0,0-.4,1H9.8583A3.5525,3.5525,0,0,0,9.4,24L24,9.4a3.6069,3.6069,0,0,0,2,.6,4,4,0,1,0-3.8569-5H9.9A4.0785,4.0785,0,0,0,6,2a4,4,0,0,0,0,8,3.6066,3.6066,0,0,0,2-.6L12.5858,14,14,12.5859,9.4,8a4.175,4.175,0,0,0,.4-1H22.1418A3.5553,3.5553,0,0,0,22.6,8L8,22.6A3.6066,3.6066,0,0,0,6,22a4,4,0,1,0,3.8569,5H22.1A4.0118,4.0118,0,1,0,26,22ZM26,4a2,2,0,1,1-2,2A2.0058,2.0058,0,0,1,26,4ZM6,8A2,2,0,1,1,8,6,2.0058,2.0058,0,0,1,6,8ZM6,28a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,28Z"
    })), children);
  });
  var IbmCloudSubnets16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudSubnets16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$h || (_path132$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a3.6069,3.6069,0,0,0-2,.6L19.4143,18,18,19.4141,22.6,24a4.1755,4.1755,0,0,0-.4,1H9.8583A3.5525,3.5525,0,0,0,9.4,24L24,9.4a3.6069,3.6069,0,0,0,2,.6,4,4,0,1,0-3.8569-5H9.9A4.0785,4.0785,0,0,0,6,2a4,4,0,0,0,0,8,3.6066,3.6066,0,0,0,2-.6L12.5858,14,14,12.5859,9.4,8a4.175,4.175,0,0,0,.4-1H22.1418A3.5553,3.5553,0,0,0,22.6,8L8,22.6A3.6066,3.6066,0,0,0,6,22a4,4,0,1,0,3.8569,5H22.1A4.0118,4.0118,0,1,0,26,22ZM26,4a2,2,0,1,1-2,2A2.0058,2.0058,0,0,1,26,4ZM6,8A2,2,0,1,1,8,6,2.0058,2.0058,0,0,1,6,8ZM6,28a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0058,2.0058,0,0,1,26,28Z"
    })), children);
  });
  var IbmCloudTransitGateway32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudTransitGateway32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$h || (_path133$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9,20.9l3.5-3.5a1.9333,1.9333,0,0,0,0-2.8L24.1,9.3l1.4-1.4A.9015.9015,0,0,0,26,8a2,2,0,1,0-2-2,.9015.9015,0,0,0,.1.5L18,12.6a3.6333,3.6333,0,0,0-4,0L10.7,9.3,16,4l3.5,3.5,1.4-1.4L17.4,2.6a1.9333,1.9333,0,0,0-2.8,0L9.3,7.9,7.9,6.5A.9015.9015,0,0,0,8,6,2,2,0,1,0,6,8a.9015.9015,0,0,0,.5-.1L12.6,14a3.6333,3.6333,0,0,0,0,4L9.3,21.3,4,16l3.5-3.5L6.1,11.1,2.6,14.6a1.9333,1.9333,0,0,0,0,2.8l5.3,5.3L6.5,24.1A.9015.9015,0,0,0,6,24a2,2,0,1,0,2,2,.9015.9015,0,0,0-.1-.5L14,19.4a3.6333,3.6333,0,0,0,4,0l3.3,3.3L16,28l-3.5-3.5-1.4,1.4,3.5,3.5a1.9333,1.9333,0,0,0,2.8,0l5.3-5.3,1.4,1.4c0,.2-.1.3-.1.5a2,2,0,1,0,2-2,.9015.9015,0,0,0-.5.1L19.4,18a3.6333,3.6333,0,0,0,0-4l3.3-3.3L28,16l-3.5,3.5ZM16,18a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18Z"
    })), children);
  });
  var IbmCloudTransitGateway24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudTransitGateway24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$h || (_path134$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9,20.9l3.5-3.5a1.9333,1.9333,0,0,0,0-2.8L24.1,9.3l1.4-1.4A.9015.9015,0,0,0,26,8a2,2,0,1,0-2-2,.9015.9015,0,0,0,.1.5L18,12.6a3.6333,3.6333,0,0,0-4,0L10.7,9.3,16,4l3.5,3.5,1.4-1.4L17.4,2.6a1.9333,1.9333,0,0,0-2.8,0L9.3,7.9,7.9,6.5A.9015.9015,0,0,0,8,6,2,2,0,1,0,6,8a.9015.9015,0,0,0,.5-.1L12.6,14a3.6333,3.6333,0,0,0,0,4L9.3,21.3,4,16l3.5-3.5L6.1,11.1,2.6,14.6a1.9333,1.9333,0,0,0,0,2.8l5.3,5.3L6.5,24.1A.9015.9015,0,0,0,6,24a2,2,0,1,0,2,2,.9015.9015,0,0,0-.1-.5L14,19.4a3.6333,3.6333,0,0,0,4,0l3.3,3.3L16,28l-3.5-3.5-1.4,1.4,3.5,3.5a1.9333,1.9333,0,0,0,2.8,0l5.3-5.3,1.4,1.4c0,.2-.1.3-.1.5a2,2,0,1,0,2-2,.9015.9015,0,0,0-.5.1L19.4,18a3.6333,3.6333,0,0,0,0-4l3.3-3.3L28,16l-3.5,3.5ZM16,18a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18Z"
    })), children);
  });
  var IbmCloudTransitGateway20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudTransitGateway20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$h || (_path135$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9,20.9l3.5-3.5a1.9333,1.9333,0,0,0,0-2.8L24.1,9.3l1.4-1.4A.9015.9015,0,0,0,26,8a2,2,0,1,0-2-2,.9015.9015,0,0,0,.1.5L18,12.6a3.6333,3.6333,0,0,0-4,0L10.7,9.3,16,4l3.5,3.5,1.4-1.4L17.4,2.6a1.9333,1.9333,0,0,0-2.8,0L9.3,7.9,7.9,6.5A.9015.9015,0,0,0,8,6,2,2,0,1,0,6,8a.9015.9015,0,0,0,.5-.1L12.6,14a3.6333,3.6333,0,0,0,0,4L9.3,21.3,4,16l3.5-3.5L6.1,11.1,2.6,14.6a1.9333,1.9333,0,0,0,0,2.8l5.3,5.3L6.5,24.1A.9015.9015,0,0,0,6,24a2,2,0,1,0,2,2,.9015.9015,0,0,0-.1-.5L14,19.4a3.6333,3.6333,0,0,0,4,0l3.3,3.3L16,28l-3.5-3.5-1.4,1.4,3.5,3.5a1.9333,1.9333,0,0,0,2.8,0l5.3-5.3,1.4,1.4c0,.2-.1.3-.1.5a2,2,0,1,0,2-2,.9015.9015,0,0,0-.5.1L19.4,18a3.6333,3.6333,0,0,0,0-4l3.3-3.3L28,16l-3.5,3.5ZM16,18a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18Z"
    })), children);
  });
  var IbmCloudTransitGateway16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudTransitGateway16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$h || (_path136$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9,20.9l3.5-3.5a1.9333,1.9333,0,0,0,0-2.8L24.1,9.3l1.4-1.4A.9015.9015,0,0,0,26,8a2,2,0,1,0-2-2,.9015.9015,0,0,0,.1.5L18,12.6a3.6333,3.6333,0,0,0-4,0L10.7,9.3,16,4l3.5,3.5,1.4-1.4L17.4,2.6a1.9333,1.9333,0,0,0-2.8,0L9.3,7.9,7.9,6.5A.9015.9015,0,0,0,8,6,2,2,0,1,0,6,8a.9015.9015,0,0,0,.5-.1L12.6,14a3.6333,3.6333,0,0,0,0,4L9.3,21.3,4,16l3.5-3.5L6.1,11.1,2.6,14.6a1.9333,1.9333,0,0,0,0,2.8l5.3,5.3L6.5,24.1A.9015.9015,0,0,0,6,24a2,2,0,1,0,2,2,.9015.9015,0,0,0-.1-.5L14,19.4a3.6333,3.6333,0,0,0,4,0l3.3,3.3L16,28l-3.5-3.5-1.4,1.4,3.5,3.5a1.9333,1.9333,0,0,0,2.8,0l5.3-5.3,1.4,1.4c0,.2-.1.3-.1.5a2,2,0,1,0,2-2,.9015.9015,0,0,0-.5.1L19.4,18a3.6333,3.6333,0,0,0,0-4l3.3-3.3L28,16l-3.5,3.5ZM16,18a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18Z"
    })), children);
  });
  var IbmCloudVpcEndpoints32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudVpcEndpoints32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$h || (_path137$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H7a2.0059,2.0059,0,0,1-2-2V12H7V25H20Z"
    })), _path138$h || (_path138$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4,22l-4-4a3.6057,3.6057,0,0,0,.6-2,4.0118,4.0118,0,0,0-4-4,3.6057,3.6057,0,0,0-2,.6l-4-4V2H2v8H8.6l4,4a3.6057,3.6057,0,0,0-.6,2,4.0118,4.0118,0,0,0,4,4,3.6057,3.6057,0,0,0,2-.6l4,4V30h8V22ZM8,8H4V4H8Zm8,10a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18ZM28,28H24V24h4Z"
    })), _path139$h || (_path139$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20h2V7a2.0059,2.0059,0,0,0-2-2H12V7H25Z"
    })), children);
  });
  var IbmCloudVpcEndpoints24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudVpcEndpoints24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$h || (_path140$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H7a2.0059,2.0059,0,0,1-2-2V12H7V25H20Z"
    })), _path141$h || (_path141$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4,22l-4-4a3.6057,3.6057,0,0,0,.6-2,4.0118,4.0118,0,0,0-4-4,3.6057,3.6057,0,0,0-2,.6l-4-4V2H2v8H8.6l4,4a3.6057,3.6057,0,0,0-.6,2,4.0118,4.0118,0,0,0,4,4,3.6057,3.6057,0,0,0,2-.6l4,4V30h8V22ZM8,8H4V4H8Zm8,10a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18ZM28,28H24V24h4Z"
    })), _path142$h || (_path142$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20h2V7a2.0059,2.0059,0,0,0-2-2H12V7H25Z"
    })), children);
  });
  var IbmCloudVpcEndpoints20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudVpcEndpoints20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$h || (_path143$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H7a2.0059,2.0059,0,0,1-2-2V12H7V25H20Z"
    })), _path144$h || (_path144$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4,22l-4-4a3.6057,3.6057,0,0,0,.6-2,4.0118,4.0118,0,0,0-4-4,3.6057,3.6057,0,0,0-2,.6l-4-4V2H2v8H8.6l4,4a3.6057,3.6057,0,0,0-.6,2,4.0118,4.0118,0,0,0,4,4,3.6057,3.6057,0,0,0,2-.6l4,4V30h8V22ZM8,8H4V4H8Zm8,10a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18ZM28,28H24V24h4Z"
    })), _path145$h || (_path145$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20h2V7a2.0059,2.0059,0,0,0-2-2H12V7H25Z"
    })), children);
  });
  var IbmCloudVpcEndpoints16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudVpcEndpoints16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$h || (_path146$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,27H7a2.0059,2.0059,0,0,1-2-2V12H7V25H20Z"
    })), _path147$h || (_path147$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4,22l-4-4a3.6057,3.6057,0,0,0,.6-2,4.0118,4.0118,0,0,0-4-4,3.6057,3.6057,0,0,0-2,.6l-4-4V2H2v8H8.6l4,4a3.6057,3.6057,0,0,0-.6,2,4.0118,4.0118,0,0,0,4,4,3.6057,3.6057,0,0,0,2-.6l4,4V30h8V22ZM8,8H4V4H8Zm8,10a2,2,0,1,1,2-2A2.0059,2.0059,0,0,1,16,18ZM28,28H24V24h4Z"
    })), _path148$h || (_path148$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,20h2V7a2.0059,2.0059,0,0,0-2-2H12V7H25Z"
    })), children);
  });
  var IbmCloudPakApplications32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakApplications32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$h || (_path149$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,22H15a2.0023,2.0023,0,0,1-2-2V16a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,21,22Zm-6-6v4h6V16Z"
    })), _path150$h || (_path150$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,17H9V12a2.0023,2.0023,0,0,1,2-2h6v2H11Z"
    })), _path151$h || (_path151$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakApplications24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakApplications24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$h || (_path152$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,22H15a2.0023,2.0023,0,0,1-2-2V16a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,21,22Zm-6-6v4h6V16Z"
    })), _path153$h || (_path153$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,17H9V12a2.0023,2.0023,0,0,1,2-2h6v2H11Z"
    })), _path154$h || (_path154$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakApplications20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakApplications20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$h || (_path155$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,22H15a2.0023,2.0023,0,0,1-2-2V16a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,21,22Zm-6-6v4h6V16Z"
    })), _path156$h || (_path156$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,17H9V12a2.0023,2.0023,0,0,1,2-2h6v2H11Z"
    })), _path157$h || (_path157$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakApplications16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakApplications16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$h || (_path158$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,22H15a2.0023,2.0023,0,0,1-2-2V16a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v4A2.0023,2.0023,0,0,1,21,22Zm-6-6v4h6V16Z"
    })), _path159$h || (_path159$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,17H9V12a2.0023,2.0023,0,0,1,2-2h6v2H11Z"
    })), _path160$h || (_path160$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakData32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakData32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle17$c || (_circle17$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "15",
      r: "1"
    })), _circle18$c || (_circle18$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "15",
      r: "1"
    })), _circle19$c || (_circle19$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "10",
      r: "1"
    })), _circle20$c || (_circle20$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "23",
      r: "1"
    })), _path161$h || (_path161$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257A2.9642,2.9642,0,0,0,19,16a3.0033,3.0033,0,0,0-3-3,2.9642,2.9642,0,0,0-1.3187.3187l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258A2.9634,2.9634,0,0,0,13,16a3.0033,3.0033,0,0,0,3,3,2.9634,2.9634,0,0,0,1.3188-.3188l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,17Z"
    })), _path162$h || (_path162$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakData24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakData24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21$c || (_circle21$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "15",
      r: "1"
    })), _circle22$c || (_circle22$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "15",
      r: "1"
    })), _circle23$b || (_circle23$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "10",
      r: "1"
    })), _circle24$b || (_circle24$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "23",
      r: "1"
    })), _path163$h || (_path163$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257A2.9642,2.9642,0,0,0,19,16a3.0033,3.0033,0,0,0-3-3,2.9642,2.9642,0,0,0-1.3187.3187l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258A2.9634,2.9634,0,0,0,13,16a3.0033,3.0033,0,0,0,3,3,2.9634,2.9634,0,0,0,1.3188-.3188l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,17Z"
    })), _path164$h || (_path164$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakData20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakData20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle25$a || (_circle25$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "15",
      r: "1"
    })), _circle26$a || (_circle26$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "15",
      r: "1"
    })), _circle27$9 || (_circle27$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "10",
      r: "1"
    })), _circle28$9 || (_circle28$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "23",
      r: "1"
    })), _path165$h || (_path165$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257A2.9642,2.9642,0,0,0,19,16a3.0033,3.0033,0,0,0-3-3,2.9642,2.9642,0,0,0-1.3187.3187l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258A2.9634,2.9634,0,0,0,13,16a3.0033,3.0033,0,0,0,3,3,2.9634,2.9634,0,0,0,1.3188-.3188l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,17Z"
    })), _path166$h || (_path166$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakData16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakData16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29$9 || (_circle29$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "15",
      r: "1"
    })), _circle30$9 || (_circle30$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "15",
      r: "1"
    })), _circle31$9 || (_circle31$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "10",
      r: "1"
    })), _circle32$9 || (_circle32$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "23",
      r: "1"
    })), _path167$h || (_path167$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257A2.9642,2.9642,0,0,0,19,16a3.0033,3.0033,0,0,0-3-3,2.9642,2.9642,0,0,0-1.3187.3187l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258A2.9634,2.9634,0,0,0,13,16a3.0033,3.0033,0,0,0,3,3,2.9634,2.9634,0,0,0,1.3188-.3188l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,17Z"
    })), _path168$h || (_path168$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakIntegration32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakIntegration32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$h || (_path169$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213 9.8787a3 3 0 00-4.2426 0l-.4645.4644 1.4142 1.4142.4645-.4645a1 1 0 011.4142 1.4144L17.4142 16l1.4143 1.4142 3.2928-3.2929A3 3 0 0022.1213 9.8787zM12.7071 20.7072a1 1 0 01-1.4142-1.4144L14.5858 16l-1.4142-1.4142L9.8787 17.8787a3 3 0 104.2426 4.2426l.4645-.4644-1.4142-1.4143zM14.1213 9.8787a3 3 0 00-4.2426 4.2426l.4645.4645 1.4142-1.4142-.4645-.4645a1 1 0 011.4142-1.4143L16 14.5858l1.4142-1.4143z"
    })), _path170$h || (_path170$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213,17.8787l-.4645-.4645-1.4141,1.4142.4644.4645a1,1,0,0,1-1.4142,1.4143L16,17.4142l-1.4142,1.4142,3.2929,3.2929a3,3,0,0,0,4.2426-4.2426Z"
    })), _path171$h || (_path171$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakIntegration24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakIntegration24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$h);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$h || (_path172$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213 9.8787a3 3 0 00-4.2426 0l-.4645.4644 1.4142 1.4142.4645-.4645a1 1 0 011.4142 1.4144L17.4142 16l1.4143 1.4142 3.2928-3.2929A3 3 0 0022.1213 9.8787zM12.7071 20.7072a1 1 0 01-1.4142-1.4144L14.5858 16l-1.4142-1.4142L9.8787 17.8787a3 3 0 104.2426 4.2426l.4645-.4644-1.4142-1.4143zM14.1213 9.8787a3 3 0 00-4.2426 4.2426l.4645.4645 1.4142-1.4142-.4645-.4645a1 1 0 011.4142-1.4143L16 14.5858l1.4142-1.4143z"
    })), _path173$h || (_path173$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213,17.8787l-.4645-.4645-1.4141,1.4142.4644.4645a1,1,0,0,1-1.4142,1.4143L16,17.4142l-1.4142,1.4142,3.2929,3.2929a3,3,0,0,0,4.2426-4.2426Z"
    })), _path174$h || (_path174$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakIntegration20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakIntegration20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$h || (_path175$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213 9.8787a3 3 0 00-4.2426 0l-.4645.4644 1.4142 1.4142.4645-.4645a1 1 0 011.4142 1.4144L17.4142 16l1.4143 1.4142 3.2928-3.2929A3 3 0 0022.1213 9.8787zM12.7071 20.7072a1 1 0 01-1.4142-1.4144L14.5858 16l-1.4142-1.4142L9.8787 17.8787a3 3 0 104.2426 4.2426l.4645-.4644-1.4142-1.4143zM14.1213 9.8787a3 3 0 00-4.2426 4.2426l.4645.4645 1.4142-1.4142-.4645-.4645a1 1 0 011.4142-1.4143L16 14.5858l1.4142-1.4143z"
    })), _path176$h || (_path176$h = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213,17.8787l-.4645-.4645-1.4141,1.4142.4644.4645a1,1,0,0,1-1.4142,1.4143L16,17.4142l-1.4142,1.4142,3.2929,3.2929a3,3,0,0,0,4.2426-4.2426Z"
    })), _path177$g || (_path177$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakIntegration16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakIntegration16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$g || (_path178$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213 9.8787a3 3 0 00-4.2426 0l-.4645.4644 1.4142 1.4142.4645-.4645a1 1 0 011.4142 1.4144L17.4142 16l1.4143 1.4142 3.2928-3.2929A3 3 0 0022.1213 9.8787zM12.7071 20.7072a1 1 0 01-1.4142-1.4144L14.5858 16l-1.4142-1.4142L9.8787 17.8787a3 3 0 104.2426 4.2426l.4645-.4644-1.4142-1.4143zM14.1213 9.8787a3 3 0 00-4.2426 4.2426l.4645.4645 1.4142-1.4142-.4645-.4645a1 1 0 011.4142-1.4143L16 14.5858l1.4142-1.4143z"
    })), _path179$g || (_path179$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.1213,17.8787l-.4645-.4645-1.4141,1.4142.4644.4645a1,1,0,0,1-1.4142,1.4143L16,17.4142l-1.4142,1.4142,3.2929,3.2929a3,3,0,0,0,4.2426-4.2426Z"
    })), _path180$g || (_path180$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakMulticloudMgmt32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakMulticloudMgmt32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$g || (_path181$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257a2.8876,2.8876,0,0,0,0-2.6374l.0257.0257,1.7814-1.7813a2.0345,2.0345,0,1,0-1.4141-1.4141L17.293,13.293l.0257.0257a2.8876,2.8876,0,0,0-2.6374,0l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258a2.8872,2.8872,0,0,0,0,2.6376l-.0258-.0258-1.7814,1.7813a2.0345,2.0345,0,1,0,1.4141,1.4141L14.707,18.707l-.0258-.0258a2.8872,2.8872,0,0,0,2.6376,0l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,17Z"
    })), _path182$g || (_path182$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakMulticloudMgmt24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakMulticloudMgmt24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$g || (_path183$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257a2.8876,2.8876,0,0,0,0-2.6374l.0257.0257,1.7814-1.7813a2.0345,2.0345,0,1,0-1.4141-1.4141L17.293,13.293l.0257.0257a2.8876,2.8876,0,0,0-2.6374,0l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258a2.8872,2.8872,0,0,0,0,2.6376l-.0258-.0258-1.7814,1.7813a2.0345,2.0345,0,1,0,1.4141,1.4141L14.707,18.707l-.0258-.0258a2.8872,2.8872,0,0,0,2.6376,0l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,17Z"
    })), _path184$g || (_path184$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakMulticloudMgmt20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakMulticloudMgmt20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$g || (_path185$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257a2.8876,2.8876,0,0,0,0-2.6374l.0257.0257,1.7814-1.7813a2.0345,2.0345,0,1,0-1.4141-1.4141L17.293,13.293l.0257.0257a2.8876,2.8876,0,0,0-2.6374,0l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258a2.8872,2.8872,0,0,0,0,2.6376l-.0258-.0258-1.7814,1.7813a2.0345,2.0345,0,1,0,1.4141,1.4141L14.707,18.707l-.0258-.0258a2.8872,2.8872,0,0,0,2.6376,0l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,17Z"
    })), _path186$g || (_path186$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakMulticloudMgmt16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakMulticloudMgmt16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$g || (_path187$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,19a1.9822,1.9822,0,0,0-.5116.0743L18.707,17.293l-.0257.0257a2.8876,2.8876,0,0,0,0-2.6374l.0257.0257,1.7814-1.7813a2.0345,2.0345,0,1,0-1.4141-1.4141L17.293,13.293l.0257.0257a2.8876,2.8876,0,0,0-2.6374,0l.0257-.0257-1.7813-1.7814a2.0345,2.0345,0,1,0-1.4141,1.4141L13.293,14.707l.0258-.0258a2.8872,2.8872,0,0,0,0,2.6376l-.0258-.0258-1.7814,1.7813a2.0345,2.0345,0,1,0,1.4141,1.4141L14.707,18.707l-.0258-.0258a2.8872,2.8872,0,0,0,2.6376,0l-.0258.0258,1.7813,1.7814A1.9956,1.9956,0,1,0,21,19Zm-5-2a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,17Z"
    })), _path188$g || (_path188$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakNetworkAutomation32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakNetworkAutomation32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$g || (_path189$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.3638,21.364,20.95,19.95a6.9993,6.9993,0,0,0,0-9.899L22.3638,8.636a9,9,0,0,1,0,12.728Z"
    })), _path190$g || (_path190$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356 18.5354l-1.414-1.4141a3.0039 3.0039 0 000-4.2426l1.414-1.4141A5.0048 5.0048 0 0119.5356 18.5354zM17 26H15V15a1 1 0 011-1h0a1 1 0 011 1zM12.4644 18.5354a5.0048 5.0048 0 010-7.0708l1.414 1.4141a3.0039 3.0039 0 000 4.2426z"
    })), _path191$g || (_path191$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.6362,21.364a9,9,0,0,1,0-12.728L11.05,10.0505a6.9993,6.9993,0,0,0,0,9.899Z"
    })), _path192$g || (_path192$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakNetworkAutomation24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakNetworkAutomation24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$g || (_path193$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.3638,21.364,20.95,19.95a6.9993,6.9993,0,0,0,0-9.899L22.3638,8.636a9,9,0,0,1,0,12.728Z"
    })), _path194$g || (_path194$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356 18.5354l-1.414-1.4141a3.0039 3.0039 0 000-4.2426l1.414-1.4141A5.0048 5.0048 0 0119.5356 18.5354zM17 26H15V15a1 1 0 011-1h0a1 1 0 011 1zM12.4644 18.5354a5.0048 5.0048 0 010-7.0708l1.414 1.4141a3.0039 3.0039 0 000 4.2426z"
    })), _path195$g || (_path195$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.6362,21.364a9,9,0,0,1,0-12.728L11.05,10.0505a6.9993,6.9993,0,0,0,0,9.899Z"
    })), _path196$g || (_path196$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakNetworkAutomation20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakNetworkAutomation20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$g || (_path197$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.3638,21.364,20.95,19.95a6.9993,6.9993,0,0,0,0-9.899L22.3638,8.636a9,9,0,0,1,0,12.728Z"
    })), _path198$g || (_path198$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356 18.5354l-1.414-1.4141a3.0039 3.0039 0 000-4.2426l1.414-1.4141A5.0048 5.0048 0 0119.5356 18.5354zM17 26H15V15a1 1 0 011-1h0a1 1 0 011 1zM12.4644 18.5354a5.0048 5.0048 0 010-7.0708l1.414 1.4141a3.0039 3.0039 0 000 4.2426z"
    })), _path199$g || (_path199$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.6362,21.364a9,9,0,0,1,0-12.728L11.05,10.0505a6.9993,6.9993,0,0,0,0,9.899Z"
    })), _path200$g || (_path200$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakNetworkAutomation16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakNetworkAutomation16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$g || (_path201$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.3638,21.364,20.95,19.95a6.9993,6.9993,0,0,0,0-9.899L22.3638,8.636a9,9,0,0,1,0,12.728Z"
    })), _path202$g || (_path202$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356 18.5354l-1.414-1.4141a3.0039 3.0039 0 000-4.2426l1.414-1.4141A5.0048 5.0048 0 0119.5356 18.5354zM17 26H15V15a1 1 0 011-1h0a1 1 0 011 1zM12.4644 18.5354a5.0048 5.0048 0 010-7.0708l1.414 1.4141a3.0039 3.0039 0 000 4.2426z"
    })), _path203$g || (_path203$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.6362,21.364a9,9,0,0,1,0-12.728L11.05,10.0505a6.9993,6.9993,0,0,0,0,9.899Z"
    })), _path204$g || (_path204$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSecurity32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSecurity32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$g || (_path205$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23.7285a6.0069,6.0069,0,0,1-6-6v-6.457l6-3,6,3v6.457A6.0069,6.0069,0,0,1,16,23.7285ZM12,12.5073v5.2212a4,4,0,0,0,8,0V12.5073l-4-2Z"
    })), _path206$g || (_path206$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSecurity24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSecurity24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$g || (_path207$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23.7285a6.0069,6.0069,0,0,1-6-6v-6.457l6-3,6,3v6.457A6.0069,6.0069,0,0,1,16,23.7285ZM12,12.5073v5.2212a4,4,0,0,0,8,0V12.5073l-4-2Z"
    })), _path208$g || (_path208$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSecurity20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSecurity20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$g || (_path209$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23.7285a6.0069,6.0069,0,0,1-6-6v-6.457l6-3,6,3v6.457A6.0069,6.0069,0,0,1,16,23.7285ZM12,12.5073v5.2212a4,4,0,0,0,8,0V12.5073l-4-2Z"
    })), _path210$g || (_path210$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSecurity16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSecurity16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$g || (_path211$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,23.7285a6.0069,6.0069,0,0,1-6-6v-6.457l6-3,6,3v6.457A6.0069,6.0069,0,0,1,16,23.7285ZM12,12.5073v5.2212a4,4,0,0,0,8,0V12.5073l-4-2Z"
    })), _path212$g || (_path212$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSystem32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSystem32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$g || (_path213$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11.671H17V15.328H15z",
      transform: "rotate(-45 16 13.5)"
    })), _path214$g || (_path214$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16.672H17V20.329H15z",
      transform: "rotate(-45 16 18.5)"
    })), _path215$g || (_path215$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H13a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2V22A2.0023,2.0023,0,0,1,19,24ZM13,10V22h6.0012L19,10Z"
    })), _path216$g || (_path216$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSystem24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSystem24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$g || (_path217$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11.671H17V15.328H15z",
      transform: "rotate(-45 16 13.5)"
    })), _path218$g || (_path218$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16.672H17V20.329H15z",
      transform: "rotate(-45 16 18.5)"
    })), _path219$g || (_path219$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H13a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2V22A2.0023,2.0023,0,0,1,19,24ZM13,10V22h6.0012L19,10Z"
    })), _path220$g || (_path220$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSystem20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSystem20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$g || (_path221$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11.671H17V15.328H15z",
      transform: "rotate(-45 16 13.5)"
    })), _path222$g || (_path222$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16.672H17V20.329H15z",
      transform: "rotate(-45 16 18.5)"
    })), _path223$g || (_path223$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H13a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2V22A2.0023,2.0023,0,0,1,19,24ZM13,10V22h6.0012L19,10Z"
    })), _path224$g || (_path224$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakSystem16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakSystem16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$g || (_path225$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11.671H17V15.328H15z",
      transform: "rotate(-45 16 13.5)"
    })), _path226$g || (_path226$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16.672H17V20.329H15z",
      transform: "rotate(-45 16 18.5)"
    })), _path227$g || (_path227$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24H13a2.0023,2.0023,0,0,1-2-2V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2V22A2.0023,2.0023,0,0,1,19,24ZM13,10V22h6.0012L19,10Z"
    })), _path228$g || (_path228$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakWatsonAiops32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakWatsonAiops32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$g || (_path229$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24a1,1,0,0,1-.9614-.7253L11.2456,17H8V15h4a1,1,0,0,1,.9614.7253L14,19.36,17.0386,8.7253a1,1,0,0,1,1.9228,0L20.7544,15H24v2H20a1,1,0,0,1-.9614-.7253L18,12.64,14.9614,23.2747A1,1,0,0,1,14,24Z"
    })), _path230$g || (_path230$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakWatsonAiops24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakWatsonAiops24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$g || (_path231$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24a1,1,0,0,1-.9614-.7253L11.2456,17H8V15h4a1,1,0,0,1,.9614.7253L14,19.36,17.0386,8.7253a1,1,0,0,1,1.9228,0L20.7544,15H24v2H20a1,1,0,0,1-.9614-.7253L18,12.64,14.9614,23.2747A1,1,0,0,1,14,24Z"
    })), _path232$g || (_path232$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakWatsonAiops20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakWatsonAiops20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$g || (_path233$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24a1,1,0,0,1-.9614-.7253L11.2456,17H8V15h4a1,1,0,0,1,.9614.7253L14,19.36,17.0386,8.7253a1,1,0,0,1,1.9228,0L20.7544,15H24v2H20a1,1,0,0,1-.9614-.7253L18,12.64,14.9614,23.2747A1,1,0,0,1,14,24Z"
    })), _path234$g || (_path234$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmCloudPakWatsonAiops16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmCloudPakWatsonAiops16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$g || (_path235$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24a1,1,0,0,1-.9614-.7253L11.2456,17H8V15h4a1,1,0,0,1,.9614.7253L14,19.36,17.0386,8.7253a1,1,0,0,1,1.9228,0L20.7544,15H24v2H20a1,1,0,0,1-.9614-.7253L18,12.64,14.9614,23.2747A1,1,0,0,1,14,24Z"
    })), _path236$g || (_path236$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31a.9988.9988,0,0,1-.5039-.1357l-12-7A1.0008,1.0008,0,0,1,3,23V9a.9994.9994,0,0,1,.4961-.8638l12-7a1,1,0,0,1,1.0078,0l12,7L27.4961,9.8638,16,3.1577,5,9.5742V22.4258l11,6.417,11-6.417V15h2v8a1.0008,1.0008,0,0,1-.4961.8643l-12,7A.9988.9988,0,0,1,16,31Z"
    })), children);
  });
  var IbmSecurity32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurity32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$g || (_path237$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"
    })), children);
  });
  var IbmSecurity24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurity24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$g || (_path238$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"
    })), children);
  });
  var IbmSecurity20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurity20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$g || (_path239$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"
    })), children);
  });
  var IbmSecurity16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurity16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$g || (_path240$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"
    })), children);
  });
  var IbmSecurityServices32 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurityServices32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$g || (_path241$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20a2.97,2.97,0,0,0-1.8551.6607L22,19.4224V17.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,16,20a3.02,3.02,0,1,0,2.9254,2.3525L21,21.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,26,20ZM16,24a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,24Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,14Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,26,24Z"
    })), _path242$g || (_path242$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31A11.0125,11.0125,0,0,1,5,20V6.3823L15.9873.8816,26.4478,6.1187l-.8956,1.7885L15.9873,3.1184,7,7.6177V20a9.0008,9.0008,0,0,0,14.3994,7.2012L22.6006,28.8A10.9077,10.9077,0,0,1,16,31Z"
    })), children);
  });
  var IbmSecurityServices24 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurityServices24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$g || (_path243$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20a2.97,2.97,0,0,0-1.8551.6607L22,19.4224V17.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,16,20a3.02,3.02,0,1,0,2.9254,2.3525L21,21.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,26,20ZM16,24a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,24Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,14Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,26,24Z"
    })), _path244$g || (_path244$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31A11.0125,11.0125,0,0,1,5,20V6.3823L15.9873.8816,26.4478,6.1187l-.8956,1.7885L15.9873,3.1184,7,7.6177V20a9.0008,9.0008,0,0,0,14.3994,7.2012L22.6006,28.8A10.9077,10.9077,0,0,1,16,31Z"
    })), children);
  });
  var IbmSecurityServices20 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurityServices20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$g || (_path245$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20a2.97,2.97,0,0,0-1.8551.6607L22,19.4224V17.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,16,20a3.02,3.02,0,1,0,2.9254,2.3525L21,21.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,26,20ZM16,24a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,24Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,14Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,26,24Z"
    })), _path246$g || (_path246$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31A11.0125,11.0125,0,0,1,5,20V6.3823L15.9873.8816,26.4478,6.1187l-.8956,1.7885L15.9873,3.1184,7,7.6177V20a9.0008,9.0008,0,0,0,14.3994,7.2012L22.6006,28.8A10.9077,10.9077,0,0,1,16,31Z"
    })), children);
  });
  var IbmSecurityServices16 = /*#__PURE__*/React__default['default'].forwardRef(function IbmSecurityServices16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$g || (_path247$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20a2.97,2.97,0,0,0-1.8551.6607L22,19.4224V17.8157a3,3,0,1,0-2,0v1.6067l-2.1449,1.2383A2.97,2.97,0,0,0,16,20a3.02,3.02,0,1,0,2.9254,2.3525L21,21.1548l2.0746,1.1977A2.9978,2.9978,0,1,0,26,20ZM16,24a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,16,24Zm5-10a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,14Zm5,10a1,1,0,1,1,1-1A1.0006,1.0006,0,0,1,26,24Z"
    })), _path248$g || (_path248$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,31A11.0125,11.0125,0,0,1,5,20V6.3823L15.9873.8816,26.4478,6.1187l-.8956,1.7885L15.9873,3.1184,7,7.6177V20a9.0008,9.0008,0,0,0,14.3994,7.2012L22.6006,28.8A10.9077,10.9077,0,0,1,16,31Z"
    })), children);
  });
  var WatsonHealthICa_2D32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthICa_2D32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$g || (_path249$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H22a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0122 24zM10 10V22H22V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30z"
    })), children);
  });
  var WatsonHealthICa_2D24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthICa_2D24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$g || (_path250$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H22a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0122 24zM10 10V22H22V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30z"
    })), children);
  });
  var WatsonHealthICa_2D20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthICa_2D20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$g || (_path251$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H22a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0122 24zM10 10V22H22V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30z"
    })), children);
  });
  var WatsonHealthICa_2D16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthICa_2D16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$g || (_path252$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2.0023 2.0023 0 01-2-2V10a2.0023 2.0023 0 012-2H22a2.0023 2.0023 0 012 2V22A2.0023 2.0023 0 0122 24zM10 10V22H22V10zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30z"
    })), children);
  });
  var IceAccretion32 = /*#__PURE__*/React__default['default'].forwardRef(function IceAccretion32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$g || (_path253$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2A2 2 0 002 4V20l1 2 1-2V4H8V14l1 2 1-2V2zM28 2H14v8l1 2 1-2V4h2V17l1 2 1-2V4h4V14l1 2 1-2V4h2V24l1 2 1-2V4A2 2 0 0028 2zM14 28L13 30 12 28 12 16 14 16 14 28z"
    })), _path254$g || (_path254$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26L23 28 22 26 22 20 24 20 24 26zM8 24L7 26 6 24 6 18 8 18 8 24z"
    })), children);
  });
  var IceAccretion24 = /*#__PURE__*/React__default['default'].forwardRef(function IceAccretion24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$g || (_path255$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2A2 2 0 002 4V20l1 2 1-2V4H8V14l1 2 1-2V2zM28 2H14v8l1 2 1-2V4h2V17l1 2 1-2V4h4V14l1 2 1-2V4h2V24l1 2 1-2V4A2 2 0 0028 2zM14 28L13 30 12 28 12 16 14 16 14 28z"
    })), _path256$g || (_path256$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26L23 28 22 26 22 20 24 20 24 26zM8 24L7 26 6 24 6 18 8 18 8 24z"
    })), children);
  });
  var IceAccretion20 = /*#__PURE__*/React__default['default'].forwardRef(function IceAccretion20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$g || (_path257$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2A2 2 0 002 4V20l1 2 1-2V4H8V14l1 2 1-2V2zM28 2H14v8l1 2 1-2V4h2V17l1 2 1-2V4h4V14l1 2 1-2V4h2V24l1 2 1-2V4A2 2 0 0028 2zM14 28L13 30 12 28 12 16 14 16 14 28z"
    })), _path258$g || (_path258$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26L23 28 22 26 22 20 24 20 24 26zM8 24L7 26 6 24 6 18 8 18 8 24z"
    })), children);
  });
  var IceAccretion16 = /*#__PURE__*/React__default['default'].forwardRef(function IceAccretion16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$g || (_path259$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2A2 2 0 002 4V20l1 2 1-2V4H8V14l1 2 1-2V2zM28 2H14v8l1 2 1-2V4h2V17l1 2 1-2V4h4V14l1 2 1-2V4h2V24l1 2 1-2V4A2 2 0 0028 2zM14 28L13 30 12 28 12 16 14 16 14 28z"
    })), _path260$g || (_path260$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26L23 28 22 26 22 20 24 20 24 26zM8 24L7 26 6 24 6 18 8 18 8 24z"
    })), children);
  });
  var IceVision32 = /*#__PURE__*/React__default['default'].forwardRef(function IceVision32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$g || (_path261$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 14L19 21 20 23 21 21 21 14 19 14zM17 14H13a2 2 0 00-2 2v4l1 2 1-2V16h2v7l1 2 1-2z"
    })), _path262$g || (_path262$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var IceVision24 = /*#__PURE__*/React__default['default'].forwardRef(function IceVision24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$g || (_path263$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 14L19 21 20 23 21 21 21 14 19 14zM17 14H13a2 2 0 00-2 2v4l1 2 1-2V16h2v7l1 2 1-2z"
    })), _path264$g || (_path264$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var IceVision20 = /*#__PURE__*/React__default['default'].forwardRef(function IceVision20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$g || (_path265$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 14L19 21 20 23 21 21 21 14 19 14zM17 14H13a2 2 0 00-2 2v4l1 2 1-2V16h2v7l1 2 1-2z"
    })), _path266$g || (_path266$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var IceVision16 = /*#__PURE__*/React__default['default'].forwardRef(function IceVision16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$g || (_path267$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 14L19 21 20 23 21 21 21 14 19 14zM17 14H13a2 2 0 00-2 2v4l1 2 1-2V16h2v7l1 2 1-2z"
    })), _path268$g || (_path268$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var QID32 = /*#__PURE__*/React__default['default'].forwardRef(function QID32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$g || (_path269$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 9H12V11H10zM18 23H14V9h4a4 4 0 014 4v6A4 4 0 0118 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H16zM10 13H12V23H10z"
    })), children);
  });
  var QID24 = /*#__PURE__*/React__default['default'].forwardRef(function QID24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$g || (_path270$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 9H12V11H10zM18 23H14V9h4a4 4 0 014 4v6A4 4 0 0118 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H16zM10 13H12V23H10z"
    })), children);
  });
  var QID20 = /*#__PURE__*/React__default['default'].forwardRef(function QID20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$g || (_path271$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 9H12V11H10zM18 23H14V9h4a4 4 0 014 4v6A4 4 0 0118 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H16zM10 13H12V23H10z"
    })), children);
  });
  var QID16 = /*#__PURE__*/React__default['default'].forwardRef(function QID16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$g || (_path272$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 9H12V11H10zM18 23H14V9h4a4 4 0 014 4v6A4 4 0 0118 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H16zM10 13H12V23H10z"
    })), children);
  });
  var IdManagement32 = /*#__PURE__*/React__default['default'].forwardRef(function IdManagement32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$g || (_path273$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H9a3 3 0 00-3 3v2H8V23a1 1 0 011-1h6a1 1 0 011 1v2h2V23A3 3 0 0015 20zM12 19a4 4 0 10-4-4A4 4 0 0012 19zm0-6a2 2 0 11-2 2A2 2 0 0112 13z"
    })), _path274$g || (_path274$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,19v9H4V8H16V6H4A2,2,0,0,0,2,8V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19Z"
    })), _path275$g || (_path275$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H26V21H20zM22 23H26V25H22zM32 10V8H29.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0026 4.1011V2H24V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0020.1011 8H18v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0024 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0029.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0125 12z"
    })), children);
  });
  var IdManagement24 = /*#__PURE__*/React__default['default'].forwardRef(function IdManagement24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$g || (_path276$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H9a3 3 0 00-3 3v2H8V23a1 1 0 011-1h6a1 1 0 011 1v2h2V23A3 3 0 0015 20zM12 19a4 4 0 10-4-4A4 4 0 0012 19zm0-6a2 2 0 11-2 2A2 2 0 0112 13z"
    })), _path277$g || (_path277$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,19v9H4V8H16V6H4A2,2,0,0,0,2,8V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19Z"
    })), _path278$g || (_path278$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H26V21H20zM22 23H26V25H22zM32 10V8H29.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0026 4.1011V2H24V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0020.1011 8H18v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0024 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0029.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0125 12z"
    })), children);
  });
  var IdManagement20 = /*#__PURE__*/React__default['default'].forwardRef(function IdManagement20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$g || (_path279$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H9a3 3 0 00-3 3v2H8V23a1 1 0 011-1h6a1 1 0 011 1v2h2V23A3 3 0 0015 20zM12 19a4 4 0 10-4-4A4 4 0 0012 19zm0-6a2 2 0 11-2 2A2 2 0 0112 13z"
    })), _path280$g || (_path280$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,19v9H4V8H16V6H4A2,2,0,0,0,2,8V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19Z"
    })), _path281$g || (_path281$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H26V21H20zM22 23H26V25H22zM32 10V8H29.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0026 4.1011V2H24V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0020.1011 8H18v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0024 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0029.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0125 12z"
    })), children);
  });
  var IdManagement16 = /*#__PURE__*/React__default['default'].forwardRef(function IdManagement16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$g || (_path282$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H9a3 3 0 00-3 3v2H8V23a1 1 0 011-1h6a1 1 0 011 1v2h2V23A3 3 0 0015 20zM12 19a4 4 0 10-4-4A4 4 0 0012 19zm0-6a2 2 0 11-2 2A2 2 0 0112 13z"
    })), _path283$g || (_path283$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,19v9H4V8H16V6H4A2,2,0,0,0,2,8V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19Z"
    })), _path284$g || (_path284$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H26V21H20zM22 23H26V25H22zM32 10V8H29.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0026 4.1011V2H24V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0020.1011 8H18v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0024 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0029.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0125 12z"
    })), children);
  });
  var Idea32 = /*#__PURE__*/React__default['default'].forwardRef(function Idea32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$g || (_path285$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 006 12a9.19 9.19 0 003.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 018 12a8 8 0 0116 0 7.2 7.2 0 01-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0026 12 10 10 0 0016 2z"
    })), children);
  });
  var Idea24 = /*#__PURE__*/React__default['default'].forwardRef(function Idea24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$g || (_path286$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 006 12a9.19 9.19 0 003.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 018 12a8 8 0 0116 0 7.2 7.2 0 01-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0026 12 10 10 0 0016 2z"
    })), children);
  });
  var Idea20 = /*#__PURE__*/React__default['default'].forwardRef(function Idea20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$g || (_path287$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 006 12a9.19 9.19 0 003.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 018 12a8 8 0 0116 0 7.2 7.2 0 01-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0026 12 10 10 0 0016 2z"
    })), children);
  });
  var Idea16 = /*#__PURE__*/React__default['default'].forwardRef(function Idea16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$g || (_path288$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 006 12a9.19 9.19 0 003.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 018 12a8 8 0 0116 0 7.2 7.2 0 01-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0026 12 10 10 0 0016 2z"
    })), children);
  });
  var Identification32 = /*#__PURE__*/React__default['default'].forwardRef(function Identification32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$g || (_path289$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path290$g || (_path290$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 00-3 3v2h2V21a1 1 0 011-1h6a1 1 0 011 1v2h2V21A3 3 0 0023 18zM20 17a4 4 0 10-4-4A4 4 0 0020 17zm0-6a2 2 0 11-2 2A2 2 0 0120 11z"
    })), children);
  });
  var Identification24 = /*#__PURE__*/React__default['default'].forwardRef(function Identification24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$g || (_path291$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path292$g || (_path292$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 00-3 3v2h2V21a1 1 0 011-1h6a1 1 0 011 1v2h2V21A3 3 0 0023 18zM20 17a4 4 0 10-4-4A4 4 0 0020 17zm0-6a2 2 0 11-2 2A2 2 0 0120 11z"
    })), children);
  });
  var Identification20 = /*#__PURE__*/React__default['default'].forwardRef(function Identification20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$g || (_path293$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path294$g || (_path294$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 00-3 3v2h2V21a1 1 0 011-1h6a1 1 0 011 1v2h2V21A3 3 0 0023 18zM20 17a4 4 0 10-4-4A4 4 0 0020 17zm0-6a2 2 0 11-2 2A2 2 0 0120 11z"
    })), children);
  });
  var Identification16 = /*#__PURE__*/React__default['default'].forwardRef(function Identification16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$g || (_path295$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path296$g || (_path296$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 00-3 3v2h2V21a1 1 0 011-1h6a1 1 0 011 1v2h2V21A3 3 0 0023 18zM20 17a4 4 0 10-4-4A4 4 0 0020 17zm0-6a2 2 0 11-2 2A2 2 0 0120 11z"
    })), children);
  });
  var Image32 = /*#__PURE__*/React__default['default'].forwardRef(function Image32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$g || (_path297$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"
    })), _path298$g || (_path298$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"
    })), children);
  });
  var Image24 = /*#__PURE__*/React__default['default'].forwardRef(function Image24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$g || (_path299$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"
    })), _path300$g || (_path300$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"
    })), children);
  });
  var Image20 = /*#__PURE__*/React__default['default'].forwardRef(function Image20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$g || (_path301$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"
    })), _path302$g || (_path302$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"
    })), children);
  });
  var Image16 = /*#__PURE__*/React__default['default'].forwardRef(function Image16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$g || (_path303$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"
    })), _path304$g || (_path304$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"
    })), children);
  });
  var ImageCopy32 = /*#__PURE__*/React__default['default'].forwardRef(function ImageCopy32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$g || (_path305$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H2V4A2.0023 2.0023 0 014 2H22V4H4zM21 17a3 3 0 10-3-3A3.0033 3.0033 0 0021 17zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0121 13z"
    })), _path306$g || (_path306$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H9A2.0025,2.0025,0,0,0,7,9V28a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V9A2.0025,2.0025,0,0,0,28,7Zm0,21H9v-6l4-3.9971,5.5859,5.586a2,2,0,0,0,2.8282,0L23,22.0034,28,27Zm0-3.8281-3.5859-3.586a2,2,0,0,0-2.8282,0L20,22.1719l-5.5859-5.586a2,2,0,0,0-2.8282,0L9,19.1719V9H28Z"
    })), children);
  });
  var ImageCopy24 = /*#__PURE__*/React__default['default'].forwardRef(function ImageCopy24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$g || (_path307$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H2V4A2.0023 2.0023 0 014 2H22V4H4zM21 17a3 3 0 10-3-3A3.0033 3.0033 0 0021 17zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0121 13z"
    })), _path308$g || (_path308$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H9A2.0025,2.0025,0,0,0,7,9V28a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V9A2.0025,2.0025,0,0,0,28,7Zm0,21H9v-6l4-3.9971,5.5859,5.586a2,2,0,0,0,2.8282,0L23,22.0034,28,27Zm0-3.8281-3.5859-3.586a2,2,0,0,0-2.8282,0L20,22.1719l-5.5859-5.586a2,2,0,0,0-2.8282,0L9,19.1719V9H28Z"
    })), children);
  });
  var ImageCopy20 = /*#__PURE__*/React__default['default'].forwardRef(function ImageCopy20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$g || (_path309$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H2V4A2.0023 2.0023 0 014 2H22V4H4zM21 17a3 3 0 10-3-3A3.0033 3.0033 0 0021 17zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0121 13z"
    })), _path310$g || (_path310$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H9A2.0025,2.0025,0,0,0,7,9V28a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V9A2.0025,2.0025,0,0,0,28,7Zm0,21H9v-6l4-3.9971,5.5859,5.586a2,2,0,0,0,2.8282,0L23,22.0034,28,27Zm0-3.8281-3.5859-3.586a2,2,0,0,0-2.8282,0L20,22.1719l-5.5859-5.586a2,2,0,0,0-2.8282,0L9,19.1719V9H28Z"
    })), children);
  });
  var ImageCopy16 = /*#__PURE__*/React__default['default'].forwardRef(function ImageCopy16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$g || (_path311$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 22H2V4A2.0023 2.0023 0 014 2H22V4H4zM21 17a3 3 0 10-3-3A3.0033 3.0033 0 0021 17zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0121 13z"
    })), _path312$g || (_path312$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H9A2.0025,2.0025,0,0,0,7,9V28a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V9A2.0025,2.0025,0,0,0,28,7Zm0,21H9v-6l4-3.9971,5.5859,5.586a2,2,0,0,0,2.8282,0L23,22.0034,28,27Zm0-3.8281-3.5859-3.586a2,2,0,0,0-2.8282,0L20,22.1719l-5.5859-5.586a2,2,0,0,0-2.8282,0L9,19.1719V9H28Z"
    })), children);
  });
  var ImageMedical32 = /*#__PURE__*/React__default['default'].forwardRef(function ImageMedical32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$g || (_path313$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path314$g || (_path314$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"
    })), children);
  });
  var ImageMedical24 = /*#__PURE__*/React__default['default'].forwardRef(function ImageMedical24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$g || (_path315$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path316$g || (_path316$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"
    })), children);
  });
  var ImageMedical20 = /*#__PURE__*/React__default['default'].forwardRef(function ImageMedical20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$g || (_path317$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path318$g || (_path318$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"
    })), children);
  });
  var ImageMedical16 = /*#__PURE__*/React__default['default'].forwardRef(function ImageMedical16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$g || (_path319$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"
    })), _path320$g || (_path320$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"
    })), children);
  });
  var ImageReference32 = /*#__PURE__*/React__default['default'].forwardRef(function ImageReference32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$g || (_path321$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 14a3 3 0 10-3-3A3 3 0 0019 14zm0-4a1 1 0 11-1 1A1 1 0 0119 10z"
    })), _path322$g || (_path322$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V16H6V6H26V21.17l-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17,11.8308,13l-1.4151,1.4155L14,18l2.59,2.59a2,2,0,0,0,2.82,0L21,19l5,5v2H16v2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ImageReference24 = /*#__PURE__*/React__default['default'].forwardRef(function ImageReference24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$g || (_path323$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 14a3 3 0 10-3-3A3 3 0 0019 14zm0-4a1 1 0 11-1 1A1 1 0 0119 10z"
    })), _path324$g || (_path324$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V16H6V6H26V21.17l-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17,11.8308,13l-1.4151,1.4155L14,18l2.59,2.59a2,2,0,0,0,2.82,0L21,19l5,5v2H16v2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ImageReference20 = /*#__PURE__*/React__default['default'].forwardRef(function ImageReference20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$g || (_path325$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 14a3 3 0 10-3-3A3 3 0 0019 14zm0-4a1 1 0 11-1 1A1 1 0 0119 10z"
    })), _path326$g || (_path326$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V16H6V6H26V21.17l-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17,11.8308,13l-1.4151,1.4155L14,18l2.59,2.59a2,2,0,0,0,2.82,0L21,19l5,5v2H16v2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ImageReference16 = /*#__PURE__*/React__default['default'].forwardRef(function ImageReference16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$g || (_path327$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM19 14a3 3 0 10-3-3A3 3 0 0019 14zm0-4a1 1 0 11-1 1A1 1 0 0119 10z"
    })), _path328$g || (_path328$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V16H6V6H26V21.17l-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17,11.8308,13l-1.4151,1.4155L14,18l2.59,2.59a2,2,0,0,0,2.82,0L21,19l5,5v2H16v2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ImageSearch32 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearch32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$g || (_path329$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14a5.99 5.99 0 00-4.885 9.4712L14 28.5859 15.4141 30l5.1147-5.1147A5.9971 5.9971 0 1024 14zm0 10a4 4 0 114-4A4.0045 4.0045 0 0124 24zM17 12a3 3 0 10-3-3A3.0033 3.0033 0 0017 12zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0117 8z"
    })), _path330$g || (_path330$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24H4V17.9966L9,13l5.5859,5.5859L16,17.168l-5.5859-5.5855a2,2,0,0,0-2.8282,0L4,15.168V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.002,2.002,0,0,0,2,4V24a2.0023,2.0023,0,0,0,2,2h8Z"
    })), children);
  });
  var ImageSearch24 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearch24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$g || (_path331$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14a5.99 5.99 0 00-4.885 9.4712L14 28.5859 15.4141 30l5.1147-5.1147A5.9971 5.9971 0 1024 14zm0 10a4 4 0 114-4A4.0045 4.0045 0 0124 24zM17 12a3 3 0 10-3-3A3.0033 3.0033 0 0017 12zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0117 8z"
    })), _path332$g || (_path332$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24H4V17.9966L9,13l5.5859,5.5859L16,17.168l-5.5859-5.5855a2,2,0,0,0-2.8282,0L4,15.168V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.002,2.002,0,0,0,2,4V24a2.0023,2.0023,0,0,0,2,2h8Z"
    })), children);
  });
  var ImageSearch20 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearch20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$g || (_path333$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14a5.99 5.99 0 00-4.885 9.4712L14 28.5859 15.4141 30l5.1147-5.1147A5.9971 5.9971 0 1024 14zm0 10a4 4 0 114-4A4.0045 4.0045 0 0124 24zM17 12a3 3 0 10-3-3A3.0033 3.0033 0 0017 12zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0117 8z"
    })), _path334$g || (_path334$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24H4V17.9966L9,13l5.5859,5.5859L16,17.168l-5.5859-5.5855a2,2,0,0,0-2.8282,0L4,15.168V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.002,2.002,0,0,0,2,4V24a2.0023,2.0023,0,0,0,2,2h8Z"
    })), children);
  });
  var ImageSearch16 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearch16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$g || (_path335$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 14a5.99 5.99 0 00-4.885 9.4712L14 28.5859 15.4141 30l5.1147-5.1147A5.9971 5.9971 0 1024 14zm0 10a4 4 0 114-4A4.0045 4.0045 0 0124 24zM17 12a3 3 0 10-3-3A3.0033 3.0033 0 0017 12zm0-4a1 1 0 11-1 1A1.0009 1.0009 0 0117 8z"
    })), _path336$g || (_path336$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24H4V17.9966L9,13l5.5859,5.5859L16,17.168l-5.5859-5.5855a2,2,0,0,0-2.8282,0L4,15.168V4H24v6h2V4a2.0023,2.0023,0,0,0-2-2H4A2.002,2.002,0,0,0,2,4V24a2.0023,2.0023,0,0,0,2,2h8Z"
    })), children);
  });
  var ImageSearchAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearchAlt32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$g || (_path337$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a5.9908,5.9908,0,0,0,9.4712,4.8853L24.5859,26,26,24.5859l-5.115-5.1147A5.997,5.997,0,1,0,10,16Zm2,0a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Z"
    })), _path338$f || (_path338$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7H22.54L20.83,4.45A.9946.9946,0,0,0,20,4H12a.9946.9946,0,0,0-.83.45L9.46,7H3A1.0031,1.0031,0,0,0,2,8V25a1.0031,1.0031,0,0,0,1,1h9V24H4V9h6a.9946.9946,0,0,0,.83-.45L12.54,6h6.92l1.71,2.55A.9946.9946,0,0,0,22,9h6V21h2V8A1.0031,1.0031,0,0,0,29,7Z"
    })), children);
  });
  var ImageSearchAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearchAlt24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$f || (_path339$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a5.9908,5.9908,0,0,0,9.4712,4.8853L24.5859,26,26,24.5859l-5.115-5.1147A5.997,5.997,0,1,0,10,16Zm2,0a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Z"
    })), _path340$f || (_path340$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7H22.54L20.83,4.45A.9946.9946,0,0,0,20,4H12a.9946.9946,0,0,0-.83.45L9.46,7H3A1.0031,1.0031,0,0,0,2,8V25a1.0031,1.0031,0,0,0,1,1h9V24H4V9h6a.9946.9946,0,0,0,.83-.45L12.54,6h6.92l1.71,2.55A.9946.9946,0,0,0,22,9h6V21h2V8A1.0031,1.0031,0,0,0,29,7Z"
    })), children);
  });
  var ImageSearchAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearchAlt20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$f || (_path341$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a5.9908,5.9908,0,0,0,9.4712,4.8853L24.5859,26,26,24.5859l-5.115-5.1147A5.997,5.997,0,1,0,10,16Zm2,0a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Z"
    })), _path342$f || (_path342$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7H22.54L20.83,4.45A.9946.9946,0,0,0,20,4H12a.9946.9946,0,0,0-.83.45L9.46,7H3A1.0031,1.0031,0,0,0,2,8V25a1.0031,1.0031,0,0,0,1,1h9V24H4V9h6a.9946.9946,0,0,0,.83-.45L12.54,6h6.92l1.71,2.55A.9946.9946,0,0,0,22,9h6V21h2V8A1.0031,1.0031,0,0,0,29,7Z"
    })), children);
  });
  var ImageSearchAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ImageSearchAlt16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$f || (_path343$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a5.9908,5.9908,0,0,0,9.4712,4.8853L24.5859,26,26,24.5859l-5.115-5.1147A5.997,5.997,0,1,0,10,16Zm2,0a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Z"
    })), _path344$f || (_path344$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,7H22.54L20.83,4.45A.9946.9946,0,0,0,20,4H12a.9946.9946,0,0,0-.83.45L9.46,7H3A1.0031,1.0031,0,0,0,2,8V25a1.0031,1.0031,0,0,0,1,1h9V24H4V9h6a.9946.9946,0,0,0,.83-.45L12.54,6h6.92l1.71,2.55A.9946.9946,0,0,0,22,9h6V21h2V8A1.0031,1.0031,0,0,0,29,7Z"
    })), children);
  });
  var ImageService32 = /*#__PURE__*/React__default['default'].forwardRef(function ImageService32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$f || (_path345$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle33$9 || (_circle33$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path346$f || (_path346$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4H15V12H13zM9 4H11V12H9zM21 12H19a2.0021 2.0021 0 01-2-2V6a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0121 12zM19 6v4h2V6zM21 14H23V22H21zM9 14H11V22H9zM17 22H15a2.0021 2.0021 0 01-2-2V16a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0117 22zm-2-6v4h2V16z"
    })), children);
  });
  var ImageService24 = /*#__PURE__*/React__default['default'].forwardRef(function ImageService24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$f || (_path347$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle34$8 || (_circle34$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path348$f || (_path348$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4H15V12H13zM9 4H11V12H9zM21 12H19a2.0021 2.0021 0 01-2-2V6a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0121 12zM19 6v4h2V6zM21 14H23V22H21zM9 14H11V22H9zM17 22H15a2.0021 2.0021 0 01-2-2V16a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0117 22zm-2-6v4h2V16z"
    })), children);
  });
  var ImageService20 = /*#__PURE__*/React__default['default'].forwardRef(function ImageService20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$f || (_path349$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle35$8 || (_circle35$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path350$f || (_path350$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4H15V12H13zM9 4H11V12H9zM21 12H19a2.0021 2.0021 0 01-2-2V6a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0121 12zM19 6v4h2V6zM21 14H23V22H21zM9 14H11V22H9zM17 22H15a2.0021 2.0021 0 01-2-2V16a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0117 22zm-2-6v4h2V16z"
    })), children);
  });
  var ImageService16 = /*#__PURE__*/React__default['default'].forwardRef(function ImageService16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$f || (_path351$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle36$8 || (_circle36$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path352$f || (_path352$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 4H15V12H13zM9 4H11V12H9zM21 12H19a2.0021 2.0021 0 01-2-2V6a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0121 12zM19 6v4h2V6zM21 14H23V22H21zM9 14H11V22H9zM17 22H15a2.0021 2.0021 0 01-2-2V16a2.0021 2.0021 0 012-2h2a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0117 22zm-2-6v4h2V16z"
    })), children);
  });
  var ImportExport32 = /*#__PURE__*/React__default['default'].forwardRef(function ImportExport32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$f || (_path353$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v4H4V24H2v4l.0076-.0049A1.9977 1.9977 0 004 30H28a2 2 0 002-2h0V24zM27.6 14.6L24 18.2 24 4 22 4 22 18.2 18.4 14.6 17 16 23 22 29 16 27.6 14.6zM9 4L3 10 4.4 11.4 8 7.8 8 22 10 22 10 7.8 13.6 11.4 15 10 9 4z"
    })), children);
  });
  var ImportExport24 = /*#__PURE__*/React__default['default'].forwardRef(function ImportExport24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$f || (_path354$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v4H4V24H2v4l.0076-.0049A1.9977 1.9977 0 004 30H28a2 2 0 002-2h0V24zM27.6 14.6L24 18.2 24 4 22 4 22 18.2 18.4 14.6 17 16 23 22 29 16 27.6 14.6zM9 4L3 10 4.4 11.4 8 7.8 8 22 10 22 10 7.8 13.6 11.4 15 10 9 4z"
    })), children);
  });
  var ImportExport20 = /*#__PURE__*/React__default['default'].forwardRef(function ImportExport20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$e || (_path355$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v4H4V24H2v4l.0076-.0049A1.9977 1.9977 0 004 30H28a2 2 0 002-2h0V24zM27.6 14.6L24 18.2 24 4 22 4 22 18.2 18.4 14.6 17 16 23 22 29 16 27.6 14.6zM9 4L3 10 4.4 11.4 8 7.8 8 22 10 22 10 7.8 13.6 11.4 15 10 9 4z"
    })), children);
  });
  var ImportExport16 = /*#__PURE__*/React__default['default'].forwardRef(function ImportExport16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$e || (_path356$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24v4H4V24H2v4l.0076-.0049A1.9977 1.9977 0 004 30H28a2 2 0 002-2h0V24zM27.6 14.6L24 18.2 24 4 22 4 22 18.2 18.4 14.6 17 16 23 22 29 16 27.6 14.6zM9 4L3 10 4.4 11.4 8 7.8 8 22 10 22 10 7.8 13.6 11.4 15 10 9 4z"
    })), children);
  });
  var ImproveRelevance32 = /*#__PURE__*/React__default['default'].forwardRef(function ImproveRelevance32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$e || (_path357$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"
    })), _circle37$6 || (_circle37$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path358$e || (_path358$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path359$e || (_path359$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"
    })), children);
  });
  var ImproveRelevance24 = /*#__PURE__*/React__default['default'].forwardRef(function ImproveRelevance24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$e || (_path360$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"
    })), _circle38$6 || (_circle38$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path361$d || (_path361$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path362$d || (_path362$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"
    })), children);
  });
  var ImproveRelevance20 = /*#__PURE__*/React__default['default'].forwardRef(function ImproveRelevance20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$d || (_path363$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"
    })), _circle39$6 || (_circle39$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path364$d || (_path364$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path365$d || (_path365$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"
    })), children);
  });
  var ImproveRelevance16 = /*#__PURE__*/React__default['default'].forwardRef(function ImproveRelevance16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$d || (_path366$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"
    })), _circle40$6 || (_circle40$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path367$d || (_path367$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path368$d || (_path368$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"
    })), children);
  });
  var InProgress32 = /*#__PURE__*/React__default['default'].forwardRef(function InProgress32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$d || (_path369$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm0,26A12,12,0,0,1,16,4V16l8.4812,8.4814A11.9625,11.9625,0,0,1,16,28Z"
    })), children);
  });
  var InProgress24 = /*#__PURE__*/React__default['default'].forwardRef(function InProgress24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$d || (_path370$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm0,26A12,12,0,0,1,16,4V16l8.4812,8.4814A11.9625,11.9625,0,0,1,16,28Z"
    })), children);
  });
  var InProgress20 = /*#__PURE__*/React__default['default'].forwardRef(function InProgress20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$d || (_path371$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm0,26A12,12,0,0,1,16,4V16l8.4812,8.4814A11.9625,11.9625,0,0,1,16,28Z"
    })), children);
  });
  var InProgress16 = /*#__PURE__*/React__default['default'].forwardRef(function InProgress16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$d || (_path372$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm0,26A12,12,0,0,1,16,4V16l8.4812,8.4814A11.9625,11.9625,0,0,1,16,28Z"
    })), children);
  });
  var InProgressError32 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressError32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$d || (_path373$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path374$d || (_path374$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.8193v-2.021A10,10,0,1,1,14,4V14l4.343,4.3433A7.9751,7.9751,0,0,1,24,16h1.8193A11.93,11.93,0,0,0,14,2Z"
    })), children);
  });
  var InProgressError24 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressError24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$d || (_path375$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path376$d || (_path376$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.8193v-2.021A10,10,0,1,1,14,4V14l4.343,4.3433A7.9751,7.9751,0,0,1,24,16h1.8193A11.93,11.93,0,0,0,14,2Z"
    })), children);
  });
  var InProgressError20 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressError20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$d || (_path377$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path378$d || (_path378$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.8193v-2.021A10,10,0,1,1,14,4V14l4.343,4.3433A7.9751,7.9751,0,0,1,24,16h1.8193A11.93,11.93,0,0,0,14,2Z"
    })), children);
  });
  var InProgressError16 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressError16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$d || (_path379$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24a6,6,0,1,0-6,6A6.0066,6.0066,0,0,0,30,24Zm-2,0a3.9521,3.9521,0,0,1-.5669,2.019L21.981,20.5669A3.9529,3.9529,0,0,1,24,20,4.0045,4.0045,0,0,1,28,24Zm-8,0a3.9521,3.9521,0,0,1,.5669-2.019l5.4521,5.4521A3.9529,3.9529,0,0,1,24,28,4.0045,4.0045,0,0,1,20,24Z"
    })), _path380$d || (_path380$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2a12,12,0,1,0,2,23.8193v-2.021A10,10,0,1,1,14,4V14l4.343,4.3433A7.9751,7.9751,0,0,1,24,16h1.8193A11.93,11.93,0,0,0,14,2Z"
    })), children);
  });
  var InProgressWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressWarning32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$d || (_path381$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path382$d || (_path382$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.746,22.7993A9.999,9.999,0,1,1,14,4V14l6.0971,6.0972,1.22-2.44A2.9849,2.9849,0,0,1,24,16h1.8193A11.993,11.993,0,1,0,14,26a11.9337,11.9337,0,0,0,3.3939-.4966Z"
    })), children);
  });
  var InProgressWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressWarning24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$d || (_path383$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path384$c || (_path384$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.746,22.7993A9.999,9.999,0,1,1,14,4V14l6.0971,6.0972,1.22-2.44A2.9849,2.9849,0,0,1,24,16h1.8193A11.993,11.993,0,1,0,14,26a11.9337,11.9337,0,0,0,3.3939-.4966Z"
    })), children);
  });
  var InProgressWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressWarning20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$c || (_path385$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path386$c || (_path386$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.746,22.7993A9.999,9.999,0,1,1,14,4V14l6.0971,6.0972,1.22-2.44A2.9849,2.9849,0,0,1,24,16h1.8193A11.993,11.993,0,1,0,14,26a11.9337,11.9337,0,0,0,3.3939-.4966Z"
    })), children);
  });
  var InProgressWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function InProgressWarning16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$c || (_path387$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.38,28H20.6178L24,21.2358ZM24,18a1,1,0,0,0-.8947.5527l-5,10A1.0005,1.0005,0,0,0,19,30H29a1,1,0,0,0,.9214-1.3892L24.8946,18.5527A1,1,0,0,0,24,18Z"
    })), _path388$c || (_path388$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.746,22.7993A9.999,9.999,0,1,1,14,4V14l6.0971,6.0972,1.22-2.44A2.9849,2.9849,0,0,1,24,16h1.8193A11.993,11.993,0,1,0,14,26a11.9337,11.9337,0,0,0,3.3939-.4966Z"
    })), children);
  });
  var Incomplete32 = /*#__PURE__*/React__default['default'].forwardRef(function Incomplete32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$c || (_path389$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7642 6.8593l1.2851-1.5315A13.976 13.976 0 0020.8672 2.887l-.6836 1.8776A11.9729 11.9729 0 0123.7642 6.8593zM27.81 14l1.9677-.4128A13.8888 13.8888 0 0028.14 9.0457L26.4087 10A12.52 12.52 0 0127.81 14zM20.1836 27.2354l.6836 1.8776a13.976 13.976 0 004.1821-2.4408l-1.2851-1.5315A11.9729 11.9729 0 0120.1836 27.2354zM26.4087 22L28.14 23a14.14 14.14 0 001.6382-4.5872L27.81 18.0659A12.1519 12.1519 0 0126.4087 22zM16 30V2a14 14 0 000 28z"
    })), children);
  });
  var Incomplete24 = /*#__PURE__*/React__default['default'].forwardRef(function Incomplete24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$c || (_path390$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7642 6.8593l1.2851-1.5315A13.976 13.976 0 0020.8672 2.887l-.6836 1.8776A11.9729 11.9729 0 0123.7642 6.8593zM27.81 14l1.9677-.4128A13.8888 13.8888 0 0028.14 9.0457L26.4087 10A12.52 12.52 0 0127.81 14zM20.1836 27.2354l.6836 1.8776a13.976 13.976 0 004.1821-2.4408l-1.2851-1.5315A11.9729 11.9729 0 0120.1836 27.2354zM26.4087 22L28.14 23a14.14 14.14 0 001.6382-4.5872L27.81 18.0659A12.1519 12.1519 0 0126.4087 22zM16 30V2a14 14 0 000 28z"
    })), children);
  });
  var Incomplete20 = /*#__PURE__*/React__default['default'].forwardRef(function Incomplete20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$c || (_path391$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7642 6.8593l1.2851-1.5315A13.976 13.976 0 0020.8672 2.887l-.6836 1.8776A11.9729 11.9729 0 0123.7642 6.8593zM27.81 14l1.9677-.4128A13.8888 13.8888 0 0028.14 9.0457L26.4087 10A12.52 12.52 0 0127.81 14zM20.1836 27.2354l.6836 1.8776a13.976 13.976 0 004.1821-2.4408l-1.2851-1.5315A11.9729 11.9729 0 0120.1836 27.2354zM26.4087 22L28.14 23a14.14 14.14 0 001.6382-4.5872L27.81 18.0659A12.1519 12.1519 0 0126.4087 22zM16 30V2a14 14 0 000 28z"
    })), children);
  });
  var Incomplete16 = /*#__PURE__*/React__default['default'].forwardRef(function Incomplete16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$c || (_path392$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.7642 6.8593l1.2851-1.5315A13.976 13.976 0 0020.8672 2.887l-.6836 1.8776A11.9729 11.9729 0 0123.7642 6.8593zM27.81 14l1.9677-.4128A13.8888 13.8888 0 0028.14 9.0457L26.4087 10A12.52 12.52 0 0127.81 14zM20.1836 27.2354l.6836 1.8776a13.976 13.976 0 004.1821-2.4408l-1.2851-1.5315A11.9729 11.9729 0 0120.1836 27.2354zM26.4087 22L28.14 23a14.14 14.14 0 001.6382-4.5872L27.81 18.0659A12.1519 12.1519 0 0126.4087 22zM16 30V2a14 14 0 000 28z"
    })), children);
  });
  var IncompleteGlyph = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteGlyph(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$c || (_path393$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2a6,6,0,1,0,6,6A6,6,0,0,0,8,2ZM8,4a4.0045,4.0045,0,0,1,4,4H4A4.0045,4.0045,0,0,1,8,4Z"
    })), children);
  });
  var IncompleteCancel32 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteCancel32(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$c || (_path394$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21.41L28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25 30 21.41zM14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14z"
    })), children);
  });
  var IncompleteCancel24 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteCancel24(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$c || (_path395$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21.41L28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25 30 21.41zM14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14z"
    })), children);
  });
  var IncompleteCancel20 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteCancel20(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$c || (_path396$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21.41L28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25 30 21.41zM14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14z"
    })), children);
  });
  var IncompleteCancel16 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteCancel16(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$c || (_path397$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 21.41L28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25 30 21.41zM14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14z"
    })), children);
  });
  var IncompleteError32 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteError32(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$c || (_path398$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var IncompleteError24 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteError24(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$b || (_path399$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var IncompleteError20 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteError20(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$b || (_path400$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var IncompleteError16 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteError16(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$b || (_path401$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24z"
    })), children);
  });
  var IncompleteWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteWarning32(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$b || (_path402$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var IncompleteWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteWarning24(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$a || (_path403$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var IncompleteWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteWarning20(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$a || (_path404$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var IncompleteWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function IncompleteWarning16(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$a || (_path405$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 26A12 12 0 0114 2zM17.8257 4.7642a10.0288 10.0288 0 013.2422 2.1679l1.4133-1.4135a12.0359 12.0359 0 00-3.89-2.6016zM26 14a11.93 11.93 0 00-.9167-4.5908l-1.8472.7651A9.9428 9.9428 0 0124 14zM27.38 28H20.6178L24 21.2358zM24 18a1 1 0 00-.8947.5527l-5 10A1.0005 1.0005 0 0019 30H29a1 1 0 00.9214-1.3892L24.8946 18.5527A1 1 0 0024 18z"
    })), children);
  });
  var IncreaseLevel32 = /*#__PURE__*/React__default['default'].forwardRef(function IncreaseLevel32(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$a || (_path406$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"
    })), children);
  });
  var IncreaseLevel24 = /*#__PURE__*/React__default['default'].forwardRef(function IncreaseLevel24(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$a || (_path407$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"
    })), children);
  });
  var IncreaseLevel20 = /*#__PURE__*/React__default['default'].forwardRef(function IncreaseLevel20(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$a || (_path408$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"
    })), children);
  });
  var IncreaseLevel16 = /*#__PURE__*/React__default['default'].forwardRef(function IncreaseLevel16(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$a || (_path409$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"
    })), children);
  });
  var Industry32 = /*#__PURE__*/React__default['default'].forwardRef(function Industry32(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$9 || (_path410$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"
    })), children);
  });
  var Industry24 = /*#__PURE__*/React__default['default'].forwardRef(function Industry24(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$9 || (_path411$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"
    })), children);
  });
  var Industry20 = /*#__PURE__*/React__default['default'].forwardRef(function Industry20(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$9 || (_path412$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"
    })), children);
  });
  var Industry16 = /*#__PURE__*/React__default['default'].forwardRef(function Industry16(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$9 || (_path413$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"
    })), children);
  });
  var Information32 = /*#__PURE__*/React__default['default'].forwardRef(function Information32(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$9 || (_path414$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path415$8 || (_path415$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), children);
  });

  var _path$g, _path2$g, _path3$g, _path4$g, _path5$g, _path6$g, _path7$g, _path8$g, _path9$g, _path10$g, _path11$g, _path12$g, _path13$g, _path14$g, _path15$g, _path16$g, _path17$g, _path18$g, _path19$g, _path20$g, _path21$g, _path22$g, _path23$g, _path24$g, _path25$g, _path26$g, _path27$g, _path28$g, _path29$g, _path30$g, _path31$g, _path32$g, _path33$g, _path34$g, _path35$g, _path36$g, _path37$g, _path38$g, _path39$g, _path40$g, _path41$g, _path42$g, _path43$g, _path44$g, _path45$g, _path46$g, _path47$g, _path48$g, _path49$g, _path50$g, _path51$g, _path52$g, _path53$g, _path54$g, _path55$g, _path56$g, _path57$g, _path58$g, _path59$g, _path60$g, _path61$g, _path62$g, _path63$g, _path64$g, _path65$g, _path66$g, _path67$g, _path68$g, _path69$g, _path70$g, _path71$g, _circle$f, _path72$g, _path73$g, _circle2$f, _path74$g, _path75$g, _circle3$f, _path76$g, _path77$g, _circle4$e, _path78$g, _path79$g, _circle5$d, _path80$g, _path81$g, _circle6$d, _path82$g, _path83$g, _circle7$d, _path84$g, _path85$g, _circle8$d, _path86$g, _circle9$d, _path87$g, _circle10$d, _path88$g, _circle11$c, _path89$g, _circle12$c, _path90$g, _path91$g, _circle13$c, _path92$g, _path93$g, _circle14$c, _path94$g, _path95$g, _circle15$c, _path96$g, _path97$g, _circle16$c, _path98$g, _circle17$b, _path99$g, _circle18$b, _path100$g, _circle19$b, _path101$g, _circle20$b, _path102$g, _path103$g, _path104$g, _path105$g, _path106$g, _path107$g, _path108$g, _path109$g, _path110$g, _path111$g, _path112$g, _path113$g, _path114$g, _path115$g, _path116$g, _path117$g, _path118$g, _path119$g, _path120$g, _path121$g, _path122$g, _path123$g, _path124$g, _path125$g, _path126$g, _path127$g, _path128$g, _path129$g, _path130$g, _path131$g, _path132$g, _path133$g, _path134$g, _path135$g, _path136$g, _path137$g, _path138$g, _circle21$b, _path139$g, _path140$g, _circle22$b, _path141$g, _path142$g, _circle23$a, _path143$g, _path144$g, _circle24$a, _path145$g, _path146$g, _path147$g, _path148$g, _path149$g, _path150$g, _path151$g, _path152$g, _path153$g, _path154$g, _path155$g, _path156$g, _path157$g, _path158$g, _path159$g, _path160$g, _path161$g, _path162$g, _path163$g, _path164$g, _path165$g, _path166$g, _path167$g, _path168$g, _path169$g, _path170$g, _path171$g, _path172$g, _path173$g, _path174$g, _path175$g, _path176$g, _path177$f, _path178$f, _path179$f, _path180$f, _path181$f, _path182$f, _path183$f, _path184$f, _path185$f, _path186$f, _path187$f, _path188$f, _path189$f, _path190$f, _path191$f, _path192$f, _path193$f, _path194$f, _path195$f, _path196$f, _path197$f, _path198$f, _path199$f, _path200$f, _path201$f, _path202$f, _path203$f, _path204$f, _path205$f, _path206$f, _path207$f, _path208$f, _path209$f, _path210$f, _path211$f, _path212$f, _path213$f, _path214$f, _path215$f, _path216$f, _path217$f, _path218$f, _path219$f, _path220$f, _path221$f, _path222$f, _path223$f, _path224$f, _path225$f, _path226$f, _path227$f, _path228$f, _path229$f, _path230$f, _path231$f, _path232$f, _path233$f, _path234$f, _path235$f, _path236$f, _path237$f, _path238$f, _path239$f, _path240$f, _path241$f, _path242$f, _path243$f, _path244$f, _path245$f, _path246$f, _path247$f, _path248$f, _path249$f, _path250$f, _path251$f, _path252$f, _path253$f, _path254$f, _path255$f, _path256$f, _path257$f, _path258$f, _path259$f, _path260$f, _path261$f, _path262$f, _path263$f, _path264$f, _path265$f, _path266$f, _path267$f, _path268$f, _path269$f, _path270$f, _path271$f, _path272$f, _path273$f, _path274$f, _path275$f, _path276$f, _path277$f, _path278$f, _path279$f, _path280$f, _path281$f, _path282$f, _path283$f, _path284$f, _path285$f, _path286$f, _path287$f, _path288$f, _path289$f, _path290$f, _path291$f, _path292$f, _path293$f, _path294$f, _path295$f, _path296$f, _path297$f, _path298$f, _path299$f, _path300$f, _path301$f, _path302$f, _path303$f, _path304$f, _path305$f, _path306$f, _path307$f, _path308$f, _path309$f, _path310$f, _path311$f, _path312$f, _path313$f, _path314$f, _path315$f, _path316$f, _path317$f, _path318$f, _path319$f, _path320$f, _path321$f, _path322$f, _circle25$9, _path323$f, _path324$f, _circle26$9, _path325$f, _path326$f, _circle27$8, _path327$f, _path328$f, _circle28$8, _path329$f, _path330$f, _circle29$8, _path331$f, _path332$f, _circle30$8, _path333$f, _path334$f, _circle31$8, _path335$f, _path336$f, _circle32$8, _path337$f, _path338$e, _circle33$8, _path339$e, _path340$e, _circle34$7, _path341$e, _path342$e, _circle35$7, _path343$e, _path344$e, _circle36$7, _path345$e, _path346$e, _path347$e, _path348$e, _path349$e, _path350$e, _path351$e, _path352$e, _path353$e, _path354$e, _path355$d, _rect$2, _path356$d, _path357$d, _rect2$2, _path358$d, _path359$d, _rect3$2, _path360$d, _path361$c, _rect4$2, _path362$c, _path363$c, _path364$c, _path365$c, _path366$c, _path367$c, _path368$c, _path369$c, _path370$c, _path371$c, _path372$c, _path373$c, _path374$c, _path375$c, _path376$c, _path377$c, _path378$c, _path379$c, _path380$c, _path381$c, _path382$c, _path383$c, _path384$b, _path385$b, _path386$b, _path387$b, _path388$b, _path389$b, _path390$b, _path391$b, _path392$b, _path393$b, _path394$b, _path395$b, _path396$b, _path397$b, _path398$b, _path399$a, _path400$a, _path401$a, _path402$a, _path403$9, _path404$9, _path405$9, _path406$9, _path407$9, _path408$9, _path409$9, _path410$8, _path411$8, _path412$8, _path413$8, _path414$8, _path415$7, _path416$6, _path417$6;

  var _excluded$g = ["children"],
      _excluded2$g = ["children"],
      _excluded3$g = ["children"],
      _excluded4$g = ["children"],
      _excluded5$g = ["children"],
      _excluded6$g = ["children"],
      _excluded7$g = ["children"],
      _excluded8$g = ["children"],
      _excluded9$g = ["children"],
      _excluded10$g = ["children"],
      _excluded11$g = ["children"],
      _excluded12$g = ["children"],
      _excluded13$g = ["children"],
      _excluded14$g = ["children"],
      _excluded15$g = ["children"],
      _excluded16$g = ["children"],
      _excluded17$g = ["children"],
      _excluded18$g = ["children"],
      _excluded19$g = ["children"],
      _excluded20$g = ["children"],
      _excluded21$g = ["children"],
      _excluded22$g = ["children"],
      _excluded23$g = ["children"],
      _excluded24$g = ["children"],
      _excluded25$g = ["children"],
      _excluded26$g = ["children"],
      _excluded27$g = ["children"],
      _excluded28$g = ["children"],
      _excluded29$g = ["children"],
      _excluded30$g = ["children"],
      _excluded31$g = ["children"],
      _excluded32$g = ["children"],
      _excluded33$g = ["children"],
      _excluded34$g = ["children"],
      _excluded35$g = ["children"],
      _excluded36$g = ["children"],
      _excluded37$g = ["children"],
      _excluded38$g = ["children"],
      _excluded39$g = ["children"],
      _excluded40$g = ["children"],
      _excluded41$g = ["children"],
      _excluded42$g = ["children"],
      _excluded43$g = ["children"],
      _excluded44$g = ["children"],
      _excluded45$g = ["children"],
      _excluded46$g = ["children"],
      _excluded47$g = ["children"],
      _excluded48$g = ["children"],
      _excluded49$g = ["children"],
      _excluded50$g = ["children"],
      _excluded51$g = ["children"],
      _excluded52$g = ["children"],
      _excluded53$g = ["children"],
      _excluded54$g = ["children"],
      _excluded55$g = ["children"],
      _excluded56$g = ["children"],
      _excluded57$g = ["children"],
      _excluded58$g = ["children"],
      _excluded59$g = ["children"],
      _excluded60$g = ["children"],
      _excluded61$g = ["children"],
      _excluded62$g = ["children"],
      _excluded63$g = ["children"],
      _excluded64$g = ["children"],
      _excluded65$g = ["children"],
      _excluded66$g = ["children"],
      _excluded67$g = ["children"],
      _excluded68$g = ["children"],
      _excluded69$g = ["children"],
      _excluded70$g = ["children"],
      _excluded71$g = ["children"],
      _excluded72$g = ["children"],
      _excluded73$g = ["children"],
      _excluded74$g = ["children"],
      _excluded75$g = ["children"],
      _excluded76$g = ["children"],
      _excluded77$g = ["children"],
      _excluded78$g = ["children"],
      _excluded79$g = ["children"],
      _excluded80$g = ["children"],
      _excluded81$g = ["children"],
      _excluded82$g = ["children"],
      _excluded83$g = ["children"],
      _excluded84$g = ["children"],
      _excluded85$g = ["children"],
      _excluded86$g = ["children"],
      _excluded87$g = ["children"],
      _excluded88$g = ["children"],
      _excluded89$g = ["children"],
      _excluded90$g = ["children"],
      _excluded91$g = ["children"],
      _excluded92$g = ["children"],
      _excluded93$g = ["children"],
      _excluded94$g = ["children"],
      _excluded95$g = ["children"],
      _excluded96$g = ["children"],
      _excluded97$g = ["children"],
      _excluded98$g = ["children"],
      _excluded99$g = ["children"],
      _excluded100$g = ["children"],
      _excluded101$g = ["children"],
      _excluded102$g = ["children"],
      _excluded103$g = ["children"],
      _excluded104$g = ["children"],
      _excluded105$g = ["children"],
      _excluded106$g = ["children"],
      _excluded107$g = ["children"],
      _excluded108$g = ["children"],
      _excluded109$g = ["children"],
      _excluded110$g = ["children"],
      _excluded111$g = ["children"],
      _excluded112$g = ["children"],
      _excluded113$g = ["children"],
      _excluded114$g = ["children"],
      _excluded115$g = ["children"],
      _excluded116$g = ["children"],
      _excluded117$g = ["children"],
      _excluded118$g = ["children"],
      _excluded119$f = ["children"],
      _excluded120$f = ["children"],
      _excluded121$f = ["children"],
      _excluded122$f = ["children"],
      _excluded123$f = ["children"],
      _excluded124$f = ["children"],
      _excluded125$f = ["children"],
      _excluded126$f = ["children"],
      _excluded127$f = ["children"],
      _excluded128$f = ["children"],
      _excluded129$f = ["children"],
      _excluded130$f = ["children"],
      _excluded131$f = ["children"],
      _excluded132$f = ["children"],
      _excluded133$f = ["children"],
      _excluded134$f = ["children"],
      _excluded135$f = ["children"],
      _excluded136$f = ["children"],
      _excluded137$f = ["children"],
      _excluded138$f = ["children"],
      _excluded139$f = ["children"],
      _excluded140$f = ["children"],
      _excluded141$f = ["children"],
      _excluded142$f = ["children"],
      _excluded143$f = ["children"],
      _excluded144$f = ["children"],
      _excluded145$f = ["children"],
      _excluded146$f = ["children"],
      _excluded147$f = ["children"],
      _excluded148$f = ["children"],
      _excluded149$f = ["children"],
      _excluded150$f = ["children"],
      _excluded151$f = ["children"],
      _excluded152$f = ["children"],
      _excluded153$f = ["children"],
      _excluded154$f = ["children"],
      _excluded155$f = ["children"],
      _excluded156$f = ["children"],
      _excluded157$f = ["children"],
      _excluded158$f = ["children"],
      _excluded159$f = ["children"],
      _excluded160$f = ["children"],
      _excluded161$f = ["children"],
      _excluded162$f = ["children"],
      _excluded163$f = ["children"],
      _excluded164$f = ["children"],
      _excluded165$f = ["children"],
      _excluded166$f = ["children"],
      _excluded167$f = ["children"],
      _excluded168$f = ["children"],
      _excluded169$f = ["children"],
      _excluded170$f = ["children"],
      _excluded171$f = ["children"],
      _excluded172$f = ["children"],
      _excluded173$f = ["children"],
      _excluded174$f = ["children"],
      _excluded175$f = ["children"],
      _excluded176$f = ["children"],
      _excluded177$f = ["children"],
      _excluded178$f = ["children"],
      _excluded179$f = ["children"],
      _excluded180$f = ["children"],
      _excluded181$f = ["children"],
      _excluded182$f = ["children"],
      _excluded183$f = ["children"],
      _excluded184$f = ["children"],
      _excluded185$f = ["children"],
      _excluded186$f = ["children"],
      _excluded187$f = ["children"],
      _excluded188$f = ["children"],
      _excluded189$f = ["children"],
      _excluded190$f = ["children"],
      _excluded191$f = ["children"],
      _excluded192$f = ["children"],
      _excluded193$f = ["children"],
      _excluded194$f = ["children"],
      _excluded195$f = ["children"],
      _excluded196$f = ["children"],
      _excluded197$f = ["children"],
      _excluded198$f = ["children"],
      _excluded199$f = ["children"],
      _excluded200$f = ["children"],
      _excluded201$f = ["children"],
      _excluded202$f = ["children"],
      _excluded203$f = ["children"],
      _excluded204$f = ["children"],
      _excluded205$f = ["children"],
      _excluded206$f = ["children"],
      _excluded207$f = ["children"],
      _excluded208$f = ["children"],
      _excluded209$f = ["children"],
      _excluded210$f = ["children"],
      _excluded211$f = ["children"],
      _excluded212$f = ["children"],
      _excluded213$f = ["children"],
      _excluded214$f = ["children"],
      _excluded215$f = ["children"],
      _excluded216$f = ["children"],
      _excluded217$f = ["children"],
      _excluded218$f = ["children"],
      _excluded219$f = ["children"],
      _excluded220$f = ["children"],
      _excluded221$f = ["children"],
      _excluded222$f = ["children"],
      _excluded223$f = ["children"],
      _excluded224$f = ["children"],
      _excluded225$f = ["children"],
      _excluded226$f = ["children"],
      _excluded227$f = ["children"],
      _excluded228$f = ["children"],
      _excluded229$f = ["children"],
      _excluded230$f = ["children"],
      _excluded231$f = ["children"],
      _excluded232$f = ["children"],
      _excluded233$f = ["children"],
      _excluded234$f = ["children"],
      _excluded235$f = ["children"],
      _excluded236$f = ["children"],
      _excluded237$f = ["children"],
      _excluded238$f = ["children"],
      _excluded239$f = ["children"],
      _excluded240$f = ["children"],
      _excluded241$f = ["children"],
      _excluded242$f = ["children"],
      _excluded243$f = ["children"],
      _excluded244$f = ["children"],
      _excluded245$f = ["children"],
      _excluded246$f = ["children"],
      _excluded247$f = ["children"],
      _excluded248$f = ["children"],
      _excluded249$f = ["children"],
      _excluded250$f = ["children"];
  var didWarnAboutDeprecation$5 = {};
  var Information24 = /*#__PURE__*/React__default['default'].forwardRef(function Information24(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$g || (_path$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path2$g || (_path2$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), children);
  });
  var Information20 = /*#__PURE__*/React__default['default'].forwardRef(function Information20(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$g || (_path3$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path4$g || (_path4$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), children);
  });
  var Information16 = /*#__PURE__*/React__default['default'].forwardRef(function Information16(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$g || (_path5$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5 11L8.5 6.5 6.5 6.5 6.5 7.5 7.5 7.5 7.5 11 6 11 6 12 10 12 10 11zM8 3.5c-.4 0-.8.3-.8.8S7.6 5 8 5c.4 0 .8-.3.8-.8S8.4 3.5 8 3.5z"
    })), _path6$g || (_path6$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,15c-3.9,0-7-3.1-7-7s3.1-7,7-7s7,3.1,7,7S11.9,15,8,15z M8,2C4.7,2,2,4.7,2,8s2.7,6,6,6s6-2.7,6-6S11.3,2,8,2z"
    })), children);
  });
  var InformationDisabled32 = /*#__PURE__*/React__default['default'].forwardRef(function InformationDisabled32(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$g || (_path7$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l3.4433-3.4434A13.9614 13.9614 0 0026.5565 6.8574zM28 16A11.9734 11.9734 0 018.2678 25.146L15 18.4141V22H13v2h7V22H17V16.4141l8.146-8.146A11.8967 11.8967 0 0128 16zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path8$g || (_path8$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.67,22.0854A11.9829,11.9829,0,0,1,22.0856,5.67L23.54,4.2163A13.985,13.985,0,0,0,4.2162,23.54Z"
    })), children);
  });
  var InformationDisabled24 = /*#__PURE__*/React__default['default'].forwardRef(function InformationDisabled24(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$g || (_path9$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l3.4433-3.4434A13.9614 13.9614 0 0026.5565 6.8574zM28 16A11.9734 11.9734 0 018.2678 25.146L15 18.4141V22H13v2h7V22H17V16.4141l8.146-8.146A11.8967 11.8967 0 0128 16zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path10$g || (_path10$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.67,22.0854A11.9829,11.9829,0,0,1,22.0856,5.67L23.54,4.2163A13.985,13.985,0,0,0,4.2162,23.54Z"
    })), children);
  });
  var InformationDisabled20 = /*#__PURE__*/React__default['default'].forwardRef(function InformationDisabled20(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$g || (_path11$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l3.4433-3.4434A13.9614 13.9614 0 0026.5565 6.8574zM28 16A11.9734 11.9734 0 018.2678 25.146L15 18.4141V22H13v2h7V22H17V16.4141l8.146-8.146A11.8967 11.8967 0 0128 16zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path12$g || (_path12$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.67,22.0854A11.9829,11.9829,0,0,1,22.0856,5.67L23.54,4.2163A13.985,13.985,0,0,0,4.2162,23.54Z"
    })), children);
  });
  var InformationDisabled16 = /*#__PURE__*/React__default['default'].forwardRef(function InformationDisabled16(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$g || (_path13$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l3.4433-3.4434A13.9614 13.9614 0 0026.5565 6.8574zM28 16A11.9734 11.9734 0 018.2678 25.146L15 18.4141V22H13v2h7V22H17V16.4141l8.146-8.146A11.8967 11.8967 0 0128 16zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path14$g || (_path14$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.67,22.0854A11.9829,11.9829,0,0,1,22.0856,5.67L23.54,4.2163A13.985,13.985,0,0,0,4.2162,23.54Z"
    })), children);
  });
  var InformationFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function InformationFilled32(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$g || (_path15$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path16$g || (_path16$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,6a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function InformationFilled24(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$g || (_path17$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path18$g || (_path18$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,6a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function InformationFilled20(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$g || (_path19$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path20$g || (_path20$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,6a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function InformationFilled16(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$g || (_path21$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path22$g || (_path22$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,6a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationSquare32 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquare32(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$g || (_path23$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path24$g || (_path24$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26V6Z"
    })), children);
  });
  var InformationSquare24 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquare24(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$g || (_path25$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path26$g || (_path26$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26V6Z"
    })), children);
  });
  var InformationSquare20 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquare20(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$g || (_path27$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path28$g || (_path28$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26V6Z"
    })), children);
  });
  var InformationSquare16 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquare16(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$g || (_path29$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 22L17 14 13 14 13 16 15 16 15 22 12 22 12 24 20 24 20 22 17 22zM16 8a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 8z"
    })), _path30$g || (_path30$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26V6Z"
    })), children);
  });
  var InformationSquareFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquareFilled32(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$g || (_path31$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path32$g || (_path32$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationSquareFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquareFilled24(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$g || (_path33$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path34$g || (_path34$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationSquareFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquareFilled20(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$g || (_path35$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path36$g || (_path36$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InformationSquareFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function InformationSquareFilled16(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$g || (_path37$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,13.875H17.125v-8H13v2.25h1.875v5.75H12v2.25h8Z",
      "data-icon-path": "inner-path"
    })), _path38$g || (_path38$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM16,8a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,8Zm4,16.125H12v-2.25h2.875v-5.75H13v-2.25h4.125v8H20Z"
    })), children);
  });
  var InfrastructureClassic32 = /*#__PURE__*/React__default['default'].forwardRef(function InfrastructureClassic32(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$g || (_path39$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H30V28H18zM18 21H30V23H18zM18 16H30V18H18z"
    })), _path40$g || (_path40$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,25H9.5A7.4964,7.4964,0,0,1,8.1782,10.124,10,10,0,0,1,28,12H26a7.999,7.999,0,0,0-15.9507-.87l-.09.8335L9.123,12.02A5.4962,5.4962,0,0,0,9.5,23H14Z"
    })), children);
  });
  var InfrastructureClassic24 = /*#__PURE__*/React__default['default'].forwardRef(function InfrastructureClassic24(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$g || (_path41$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H30V28H18zM18 21H30V23H18zM18 16H30V18H18z"
    })), _path42$g || (_path42$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,25H9.5A7.4964,7.4964,0,0,1,8.1782,10.124,10,10,0,0,1,28,12H26a7.999,7.999,0,0,0-15.9507-.87l-.09.8335L9.123,12.02A5.4962,5.4962,0,0,0,9.5,23H14Z"
    })), children);
  });
  var InfrastructureClassic20 = /*#__PURE__*/React__default['default'].forwardRef(function InfrastructureClassic20(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$g || (_path43$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H30V28H18zM18 21H30V23H18zM18 16H30V18H18z"
    })), _path44$g || (_path44$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,25H9.5A7.4964,7.4964,0,0,1,8.1782,10.124,10,10,0,0,1,28,12H26a7.999,7.999,0,0,0-15.9507-.87l-.09.8335L9.123,12.02A5.4962,5.4962,0,0,0,9.5,23H14Z"
    })), children);
  });
  var InfrastructureClassic16 = /*#__PURE__*/React__default['default'].forwardRef(function InfrastructureClassic16(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$g || (_path45$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H30V28H18zM18 21H30V23H18zM18 16H30V18H18z"
    })), _path46$g || (_path46$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,25H9.5A7.4964,7.4964,0,0,1,8.1782,10.124,10,10,0,0,1,28,12H26a7.999,7.999,0,0,0-15.9507-.87l-.09.8335L9.123,12.02A5.4962,5.4962,0,0,0,9.5,23H14Z"
    })), children);
  });
  var Insert32 = /*#__PURE__*/React__default['default'].forwardRef(function Insert32(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$g || (_path47$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 011 1V24a1 1 0 01-1 1H15v2H27a3 3 0 003-3V12A3 3 0 0027 9z"
    })), children);
  });
  var Insert24 = /*#__PURE__*/React__default['default'].forwardRef(function Insert24(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$g || (_path48$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 011 1V24a1 1 0 01-1 1H15v2H27a3 3 0 003-3V12A3 3 0 0027 9z"
    })), children);
  });
  var Insert20 = /*#__PURE__*/React__default['default'].forwardRef(function Insert20(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$g || (_path49$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 011 1V24a1 1 0 01-1 1H15v2H27a3 3 0 003-3V12A3 3 0 0027 9z"
    })), children);
  });
  var Insert16 = /*#__PURE__*/React__default['default'].forwardRef(function Insert16(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$g || (_path50$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 011 1V24a1 1 0 01-1 1H15v2H27a3 3 0 003-3V12A3 3 0 0027 9z"
    })), children);
  });
  var InsertPage32 = /*#__PURE__*/React__default['default'].forwardRef(function InsertPage32(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$g || (_path51$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V20H12V30H10V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2zM5.17 16L2 19.17 3.411 20.589 8 16 3.42 11.42 2 12.83 5.17 16zM24 14H12a2.0021 2.0021 0 01-2-2V2h2V12H24V2h2V12A2.0021 2.0021 0 0124 14z"
    })), children);
  });
  var InsertPage24 = /*#__PURE__*/React__default['default'].forwardRef(function InsertPage24(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$g || (_path52$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V20H12V30H10V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2zM5.17 16L2 19.17 3.411 20.589 8 16 3.42 11.42 2 12.83 5.17 16zM24 14H12a2.0021 2.0021 0 01-2-2V2h2V12H24V2h2V12A2.0021 2.0021 0 0124 14z"
    })), children);
  });
  var InsertPage20 = /*#__PURE__*/React__default['default'].forwardRef(function InsertPage20(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$g || (_path53$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V20H12V30H10V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2zM5.17 16L2 19.17 3.411 20.589 8 16 3.42 11.42 2 12.83 5.17 16zM24 14H12a2.0021 2.0021 0 01-2-2V2h2V12H24V2h2V12A2.0021 2.0021 0 0124 14z"
    })), children);
  });
  var InsertPage16 = /*#__PURE__*/React__default['default'].forwardRef(function InsertPage16(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$g || (_path54$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V20H12V30H10V20a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2zM5.17 16L2 19.17 3.411 20.589 8 16 3.42 11.42 2 12.83 5.17 16zM24 14H12a2.0021 2.0021 0 01-2-2V2h2V12H24V2h2V12A2.0021 2.0021 0 0124 14z"
    })), children);
  });
  var InsertSyntax32 = /*#__PURE__*/React__default['default'].forwardRef(function InsertSyntax32(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$g || (_path55$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.17 16L17.59 18.58 19 20 23 16 19 12 17.58 13.41 20.17 16zM11.83 16L14.41 13.42 13 12 9 16 13 20 14.42 18.59 11.83 16z"
    })), _path56$g || (_path56$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var InsertSyntax24 = /*#__PURE__*/React__default['default'].forwardRef(function InsertSyntax24(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$g || (_path57$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.17 16L17.59 18.58 19 20 23 16 19 12 17.58 13.41 20.17 16zM11.83 16L14.41 13.42 13 12 9 16 13 20 14.42 18.59 11.83 16z"
    })), _path58$g || (_path58$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var InsertSyntax20 = /*#__PURE__*/React__default['default'].forwardRef(function InsertSyntax20(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$g || (_path59$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.17 16L17.59 18.58 19 20 23 16 19 12 17.58 13.41 20.17 16zM11.83 16L14.41 13.42 13 12 9 16 13 20 14.42 18.59 11.83 16z"
    })), _path60$g || (_path60$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var InsertSyntax16 = /*#__PURE__*/React__default['default'].forwardRef(function InsertSyntax16(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$g || (_path61$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.17 16L17.59 18.58 19 20 23 16 19 12 17.58 13.41 20.17 16zM11.83 16L14.41 13.42 13 12 9 16 13 20 14.42 18.59 11.83 16z"
    })), _path62$g || (_path62$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.142V9.858A3.9916,3.9916,0,1,0,22.142,5H9.858A3.9916,3.9916,0,1,0,5,9.858V22.142A3.9916,3.9916,0,1,0,9.858,27H22.142A3.9916,3.9916,0,1,0,27,22.142ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm16.142-3H9.858A3.9937,3.9937,0,0,0,7,22.142V9.858A3.9947,3.9947,0,0,0,9.858,7H22.142A3.9937,3.9937,0,0,0,25,9.858V22.142A3.9931,3.9931,0,0,0,22.142,25ZM26,28a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"
    })), children);
  });
  var Inspection32 = /*#__PURE__*/React__default['default'].forwardRef(function Inspection32(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$g || (_path63$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 17.18L12.41 14.59 11 16 15 20 22 13 20.59 11.59 15 17.18z"
    })), _path64$g || (_path64$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V23H15v2.9492A10.0166,10.0166,0,0,1,6.0508,17H9V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V9h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H23v2h2.949A10.0165,10.0165,0,0,1,17,25.9492Z"
    })), children);
  });
  var Inspection24 = /*#__PURE__*/React__default['default'].forwardRef(function Inspection24(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$g || (_path65$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 17.18L12.41 14.59 11 16 15 20 22 13 20.59 11.59 15 17.18z"
    })), _path66$g || (_path66$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V23H15v2.9492A10.0166,10.0166,0,0,1,6.0508,17H9V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V9h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H23v2h2.949A10.0165,10.0165,0,0,1,17,25.9492Z"
    })), children);
  });
  var Inspection20 = /*#__PURE__*/React__default['default'].forwardRef(function Inspection20(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$g || (_path67$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 17.18L12.41 14.59 11 16 15 20 22 13 20.59 11.59 15 17.18z"
    })), _path68$g || (_path68$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V23H15v2.9492A10.0166,10.0166,0,0,1,6.0508,17H9V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V9h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H23v2h2.949A10.0165,10.0165,0,0,1,17,25.9492Z"
    })), children);
  });
  var Inspection16 = /*#__PURE__*/React__default['default'].forwardRef(function Inspection16(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$g || (_path69$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 17.18L12.41 14.59 11 16 15 20 22 13 20.59 11.59 15 17.18z"
    })), _path70$g || (_path70$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15H27.9492A12.0071,12.0071,0,0,0,17,4.0508V2H15V4.0508A12.0071,12.0071,0,0,0,4.0508,15H2v2H4.0508A12.0071,12.0071,0,0,0,15,27.9492V30h2V27.9492A12.0071,12.0071,0,0,0,27.9492,17H30ZM17,25.9492V23H15v2.9492A10.0166,10.0166,0,0,1,6.0508,17H9V15H6.0508A10.0166,10.0166,0,0,1,15,6.0508V9h2V6.0508A10.0166,10.0166,0,0,1,25.9492,15H23v2h2.949A10.0165,10.0165,0,0,1,17,25.9492Z"
    })), children);
  });
  var InstanceBx32 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceBx32(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$g || (_path71$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 5A3.0033 3.0033 0 009 2H4V15H9a3.0033 3.0033 0 003-3V10.5a2.977 2.977 0 00-.78-2 2.9768 2.9768 0 00.78-2zM6 4H9a1.0013 1.0013 0 011 1V6.5513A.9587.9587 0 019 7.5H6zm4 8a1.0009 1.0009 0 01-1 1H6V9.5H9a1.0009 1.0009 0 011 1zM22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5z"
    })), _circle$f || (_circle$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path72$g || (_path72$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceBx24 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceBx24(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$g || (_path73$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 5A3.0033 3.0033 0 009 2H4V15H9a3.0033 3.0033 0 003-3V10.5a2.977 2.977 0 00-.78-2 2.9768 2.9768 0 00.78-2zM6 4H9a1.0013 1.0013 0 011 1V6.5513A.9587.9587 0 019 7.5H6zm4 8a1.0009 1.0009 0 01-1 1H6V9.5H9a1.0009 1.0009 0 011 1zM22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5z"
    })), _circle2$f || (_circle2$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path74$g || (_path74$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceBx20 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceBx20(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$g || (_path75$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 5A3.0033 3.0033 0 009 2H4V15H9a3.0033 3.0033 0 003-3V10.5a2.977 2.977 0 00-.78-2 2.9768 2.9768 0 00.78-2zM6 4H9a1.0013 1.0013 0 011 1V6.5513A.9587.9587 0 019 7.5H6zm4 8a1.0009 1.0009 0 01-1 1H6V9.5H9a1.0009 1.0009 0 011 1zM22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5z"
    })), _circle3$f || (_circle3$f = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path76$g || (_path76$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceBx16 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceBx16(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$g || (_path77$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 5A3.0033 3.0033 0 009 2H4V15H9a3.0033 3.0033 0 003-3V10.5a2.977 2.977 0 00-.78-2 2.9768 2.9768 0 00.78-2zM6 4H9a1.0013 1.0013 0 011 1V6.5513A.9587.9587 0 019 7.5H6zm4 8a1.0009 1.0009 0 01-1 1H6V9.5H9a1.0009 1.0009 0 011 1zM22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5z"
    })), _circle4$e || (_circle4$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path78$g || (_path78$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceClassic32 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceClassic32(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$g || (_path79$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,21H23V19h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,19H9v2H8.5A6.4973,6.4973,0,0,1,7.2,8.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,21Z"
    })), _circle5$d || (_circle5$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path80$g || (_path80$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,23H17V15.83l2.59,2.58L21,17l-5-5-5,5,1.41,1.41L15,15.83V23H6a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V25A2.0023,2.0023,0,0,0,26,23Zm0,6H6V25H26Z"
    })), children);
  });
  var InstanceClassic24 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceClassic24(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$g || (_path81$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,21H23V19h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,19H9v2H8.5A6.4973,6.4973,0,0,1,7.2,8.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,21Z"
    })), _circle6$d || (_circle6$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path82$g || (_path82$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,23H17V15.83l2.59,2.58L21,17l-5-5-5,5,1.41,1.41L15,15.83V23H6a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V25A2.0023,2.0023,0,0,0,26,23Zm0,6H6V25H26Z"
    })), children);
  });
  var InstanceClassic20 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceClassic20(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$g || (_path83$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,21H23V19h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,19H9v2H8.5A6.4973,6.4973,0,0,1,7.2,8.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,21Z"
    })), _circle7$d || (_circle7$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path84$g || (_path84$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,23H17V15.83l2.59,2.58L21,17l-5-5-5,5,1.41,1.41L15,15.83V23H6a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V25A2.0023,2.0023,0,0,0,26,23Zm0,6H6V25H26Z"
    })), children);
  });
  var InstanceClassic16 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceClassic16(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$g || (_path85$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,21H23V19h.5a4.4975,4.4975,0,0,0,.3564-8.981l-.8154-.0639-.0986-.812a6.9938,6.9938,0,0,0-13.8838,0l-.0991.812-.8155.0639A4.4975,4.4975,0,0,0,8.5,19H9v2H8.5A6.4973,6.4973,0,0,1,7.2,8.1362a8.9943,8.9943,0,0,1,17.6006,0A6.4974,6.4974,0,0,1,23.5,21Z"
    })), _circle8$d || (_circle8$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path86$g || (_path86$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,23H17V15.83l2.59,2.58L21,17l-5-5-5,5,1.41,1.41L15,15.83V23H6a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V25A2.0023,2.0023,0,0,0,26,23Zm0,6H6V25H26Z"
    })), children);
  });
  var InstanceCx32 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceCx32(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$d || (_circle9$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path87$g || (_path87$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM12 15H6a2.0023 2.0023 0 01-2-2V4A2.002 2.002 0 016 2h6V4H6v9h6zM2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceCx24 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceCx24(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$d || (_circle10$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path88$g || (_path88$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM12 15H6a2.0023 2.0023 0 01-2-2V4A2.002 2.002 0 016 2h6V4H6v9h6zM2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceCx20 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceCx20(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$c || (_circle11$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path89$g || (_path89$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM12 15H6a2.0023 2.0023 0 01-2-2V4A2.002 2.002 0 016 2h6V4H6v9h6zM2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceCx16 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceCx16(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12$c || (_circle12$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path90$g || (_path90$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM12 15H6a2.0023 2.0023 0 01-2-2V4A2.002 2.002 0 016 2h6V4H6v9h6zM2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceMx32 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceMx32(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$g || (_path91$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM10 2L8.485 6.374 8 8 7.535 6.374 6 2 4 2 4 15 6 15 6 7.374 5.841 5.378 6.421 7.374 8 12 9.579 7.374 10.159 5.374 10 7.374 10 15 12 15 12 2 10 2z"
    })), _circle13$c || (_circle13$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path92$g || (_path92$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceMx24 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceMx24(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$g || (_path93$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM10 2L8.485 6.374 8 8 7.535 6.374 6 2 4 2 4 15 6 15 6 7.374 5.841 5.378 6.421 7.374 8 12 9.579 7.374 10.159 5.374 10 7.374 10 15 12 15 12 2 10 2z"
    })), _circle14$c || (_circle14$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path94$g || (_path94$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceMx20 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceMx20(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$g || (_path95$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM10 2L8.485 6.374 8 8 7.535 6.374 6 2 4 2 4 15 6 15 6 7.374 5.841 5.378 6.421 7.374 8 12 9.579 7.374 10.159 5.374 10 7.374 10 15 12 15 12 2 10 2z"
    })), _circle15$c || (_circle15$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path96$g || (_path96$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceMx16 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceMx16(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$g || (_path97$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 5L20 5 18 8.897 16 5 14 5 16.905 10 14 15 16 15 18 11.201 20 15 22 15 19.098 10 22 5zM10 2L8.485 6.374 8 8 7.535 6.374 6 2 4 2 4 15 6 15 6 7.374 5.841 5.378 6.421 7.374 8 12 9.579 7.374 10.159 5.374 10 7.374 10 15 12 15 12 2 10 2z"
    })), _circle16$c || (_circle16$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _path98$g || (_path98$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM8 18H12V20H8zM14 18H18V20H14zM20 18H24V20H20zM26 18H30V20H26zM26 31H6a2.0021 2.0021 0 01-2-2V25a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2v4A2.0021 2.0021 0 0126 31zM6 25v4H26V25z"
    })), children);
  });
  var InstanceVirtual32 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceVirtual32(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle17$b || (_circle17$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path99$g || (_path99$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H6V8H2zM8 6H12V8H8zM14 6H18V8H14zM20 6H24V8H20zM26 6H30V8H26zM28 28H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 28zM4 20v6H28V20zM2 12H30V14H2z"
    })), children);
  });
  var InstanceVirtual24 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceVirtual24(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle18$b || (_circle18$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path100$g || (_path100$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H6V8H2zM8 6H12V8H8zM14 6H18V8H14zM20 6H24V8H20zM26 6H30V8H26zM28 28H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 28zM4 20v6H28V20zM2 12H30V14H2z"
    })), children);
  });
  var InstanceVirtual20 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceVirtual20(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$b || (_circle19$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path101$g || (_path101$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H6V8H2zM8 6H12V8H8zM14 6H18V8H14zM20 6H24V8H20zM26 6H30V8H26zM28 28H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 28zM4 20v6H28V20zM2 12H30V14H2z"
    })), children);
  });
  var InstanceVirtual16 = /*#__PURE__*/React__default['default'].forwardRef(function InstanceVirtual16(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle20$b || (_circle20$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "1"
    })), _path102$g || (_path102$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H6V8H2zM8 6H12V8H8zM14 6H18V8H14zM20 6H24V8H20zM26 6H30V8H26zM28 28H4a2.0021 2.0021 0 01-2-2V20a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 28zM4 20v6H28V20zM2 12H30V14H2z"
    })), children);
  });
  var Integration32 = /*#__PURE__*/React__default['default'].forwardRef(function Integration32(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$g || (_path103$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"
    })), children);
  });
  var Integration24 = /*#__PURE__*/React__default['default'].forwardRef(function Integration24(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$g || (_path104$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"
    })), children);
  });
  var Integration20 = /*#__PURE__*/React__default['default'].forwardRef(function Integration20(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$g || (_path105$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"
    })), children);
  });
  var Integration16 = /*#__PURE__*/React__default['default'].forwardRef(function Integration16(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$g || (_path106$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"
    })), children);
  });
  var Interactions32 = /*#__PURE__*/React__default['default'].forwardRef(function Interactions32(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$g || (_path107$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18H22V14H20V28h6a2.0027 2.0027 0 002-2V20A2.0023 2.0023 0 0026 18zm-4 8V20h4v6zM20 6.076L19.256 4.219 16 5.522 16 2 14 2 14 5.523 10.744 4.22 10 6.077 13.417 7.444 10.9 10.8 12.5 12 15 8.667 17.5 12 19.1 10.8 16.583 7.443 20 6.076zM10 18H5v2h5v2H6a2 2 0 00-2 2v2a2 2 0 002 2h6V20A2.0023 2.0023 0 0010 18zm0 8H6V24h4z"
    })), children);
  });
  var Interactions24 = /*#__PURE__*/React__default['default'].forwardRef(function Interactions24(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$g || (_path108$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18H22V14H20V28h6a2.0027 2.0027 0 002-2V20A2.0023 2.0023 0 0026 18zm-4 8V20h4v6zM20 6.076L19.256 4.219 16 5.522 16 2 14 2 14 5.523 10.744 4.22 10 6.077 13.417 7.444 10.9 10.8 12.5 12 15 8.667 17.5 12 19.1 10.8 16.583 7.443 20 6.076zM10 18H5v2h5v2H6a2 2 0 00-2 2v2a2 2 0 002 2h6V20A2.0023 2.0023 0 0010 18zm0 8H6V24h4z"
    })), children);
  });
  var Interactions20 = /*#__PURE__*/React__default['default'].forwardRef(function Interactions20(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$g || (_path109$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18H22V14H20V28h6a2.0027 2.0027 0 002-2V20A2.0023 2.0023 0 0026 18zm-4 8V20h4v6zM20 6.076L19.256 4.219 16 5.522 16 2 14 2 14 5.523 10.744 4.22 10 6.077 13.417 7.444 10.9 10.8 12.5 12 15 8.667 17.5 12 19.1 10.8 16.583 7.443 20 6.076zM10 18H5v2h5v2H6a2 2 0 00-2 2v2a2 2 0 002 2h6V20A2.0023 2.0023 0 0010 18zm0 8H6V24h4z"
    })), children);
  });
  var Interactions16 = /*#__PURE__*/React__default['default'].forwardRef(function Interactions16(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$g || (_path110$g = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M11,7 L11,9 L13,9 C13.5522847,9 14,9.44771525 14,10 L14,10 L14,13 C14,13.5522847 13.5522847,14 13,14 L13,14 L10,14 L10,7 L11,7 Z M5,9 C5.55228475,9 6,9.44771525 6,10 L6,10 L6,14 L3,14 C2.44771525,14 2,13.5522847 2,13 L2,13 L2,12 C2,11.4477153 2.44771525,11 3,11 L3,11 L5,11 L5,10 L2.5,10 L2.5,9 Z M13,10 L11,10 L11,13 L13,13 L13,10 Z M5,12 L3,12 L3,13 L5,13 L5,12 Z M7.912,2 L7.834,3.911 L9.628,3.248 L9.914,4.119 L8.068,4.626 L9.251,6.134 L8.523,6.667 L7.457,5.068 L6.391,6.667 L5.663,6.134 L6.846,4.626 L5,4.119 L5.286,3.248 L7.08,3.911 L7.002,2 L7.912,2 Z"
    })), children);
  });
  var WatsonHealthInteractiveSegmentationCursor32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthInteractiveSegmentationCursor32(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$g || (_path111$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"
    })), _path112$g || (_path112$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 18.586H10.414V21.413999999999998H7.586z",
      transform: "rotate(-45 9 20)"
    })), _path113$g || (_path113$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.586 7.586H21.413999999999998V10.414H18.586z",
      transform: "rotate(-45 20 9)"
    })), _path114$g || (_path114$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 7.586H10.414V10.414H7.586z",
      transform: "rotate(-45 9 9)"
    })), _path115$g || (_path115$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthInteractiveSegmentationCursor24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthInteractiveSegmentationCursor24(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$g || (_path116$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"
    })), _path117$g || (_path117$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 18.586H10.414V21.413999999999998H7.586z",
      transform: "rotate(-45 9 20)"
    })), _path118$g || (_path118$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.586 7.586H21.413999999999998V10.414H18.586z",
      transform: "rotate(-45 20 9)"
    })), _path119$g || (_path119$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 7.586H10.414V10.414H7.586z",
      transform: "rotate(-45 9 9)"
    })), _path120$g || (_path120$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthInteractiveSegmentationCursor20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthInteractiveSegmentationCursor20(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$g || (_path121$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"
    })), _path122$g || (_path122$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 18.586H10.414V21.413999999999998H7.586z",
      transform: "rotate(-45 9 20)"
    })), _path123$g || (_path123$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.586 7.586H21.413999999999998V10.414H18.586z",
      transform: "rotate(-45 20 9)"
    })), _path124$g || (_path124$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 7.586H10.414V10.414H7.586z",
      transform: "rotate(-45 9 9)"
    })), _path125$g || (_path125$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthInteractiveSegmentationCursor16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthInteractiveSegmentationCursor16(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$g || (_path126$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"
    })), _path127$g || (_path127$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 18.586H10.414V21.413999999999998H7.586z",
      transform: "rotate(-45 9 20)"
    })), _path128$g || (_path128$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.586 7.586H21.413999999999998V10.414H18.586z",
      transform: "rotate(-45 20 9)"
    })), _path129$g || (_path129$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.586 7.586H10.414V10.414H7.586z",
      transform: "rotate(-45 9 9)"
    })), _path130$g || (_path130$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var Intersect32 = /*#__PURE__*/React__default['default'].forwardRef(function Intersect32(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$g || (_path131$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H18V22h4V18h2v4A2.0021 2.0021 0 0122 24zM10 14H8V10a2.0022 2.0022 0 012-2h4v2H10z"
    })), _path132$g || (_path132$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8Zm0,20H10V24h4V22H10V18H8v4H4V4H22V8H18v2h4v4h2V10h4Z"
    })), children);
  });
  var Intersect24 = /*#__PURE__*/React__default['default'].forwardRef(function Intersect24(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$g || (_path133$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H18V22h4V18h2v4A2.0021 2.0021 0 0122 24zM10 14H8V10a2.0022 2.0022 0 012-2h4v2H10z"
    })), _path134$g || (_path134$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8Zm0,20H10V24h4V22H10V18H8v4H4V4H22V8H18v2h4v4h2V10h4Z"
    })), children);
  });
  var Intersect20 = /*#__PURE__*/React__default['default'].forwardRef(function Intersect20(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$g || (_path135$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H18V22h4V18h2v4A2.0021 2.0021 0 0122 24zM10 14H8V10a2.0022 2.0022 0 012-2h4v2H10z"
    })), _path136$g || (_path136$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8Zm0,20H10V24h4V22H10V18H8v4H4V4H22V8H18v2h4v4h2V10h4Z"
    })), children);
  });
  var Intersect16 = /*#__PURE__*/React__default['default'].forwardRef(function Intersect16(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$g || (_path137$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H18V22h4V18h2v4A2.0021 2.0021 0 0122 24zM10 14H8V10a2.0022 2.0022 0 012-2h4v2H10z"
    })), _path138$g || (_path138$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8Zm0,20H10V24h4V22H10V18H8v4H4V4H22V8H18v2h4v4h2V10h4Z"
    })), children);
  });
  var IntrusionPrevention32 = /*#__PURE__*/React__default['default'].forwardRef(function IntrusionPrevention32(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21$b || (_circle21$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "23.887",
      r: "2"
    })), _path139$g || (_path139$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4zM12 28H4V24h8V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2h8z"
    })), _path140$g || (_path140$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H7a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h5V18H7V14H28l.0007,2H30V14A2.0023,2.0023,0,0,0,28,12Z"
    })), children);
  });
  var IntrusionPrevention24 = /*#__PURE__*/React__default['default'].forwardRef(function IntrusionPrevention24(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22$b || (_circle22$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "23.887",
      r: "2"
    })), _path141$g || (_path141$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4zM12 28H4V24h8V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2h8z"
    })), _path142$g || (_path142$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H7a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h5V18H7V14H28l.0007,2H30V14A2.0023,2.0023,0,0,0,28,12Z"
    })), children);
  });
  var IntrusionPrevention20 = /*#__PURE__*/React__default['default'].forwardRef(function IntrusionPrevention20(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle23$a || (_circle23$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "23.887",
      r: "2"
    })), _path143$g || (_path143$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4zM12 28H4V24h8V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2h8z"
    })), _path144$g || (_path144$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H7a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h5V18H7V14H28l.0007,2H30V14A2.0023,2.0023,0,0,0,28,12Z"
    })), children);
  });
  var IntrusionPrevention16 = /*#__PURE__*/React__default['default'].forwardRef(function IntrusionPrevention16(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle24$a || (_circle24$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "23.887",
      r: "2"
    })), _path145$g || (_path145$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769 23.4785A8.64 8.64 0 0022 18a8.64 8.64 0 00-7.7769 5.4785L14 24l.2231.5215A8.64 8.64 0 0022 30a8.64 8.64 0 007.7769-5.4785L30 24zM22 28a4 4 0 114-4A4.0045 4.0045 0 0122 28zM25 10H4A2.0021 2.0021 0 012 8V4A2.0021 2.0021 0 014 2H25a2.0021 2.0021 0 012 2V8A2.0021 2.0021 0 0125 10zM4 4V8H25V4zM12 28H4V24h8V22H4a2.0023 2.0023 0 00-2 2v4a2.0023 2.0023 0 002 2h8z"
    })), _path146$g || (_path146$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H7a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h5V18H7V14H28l.0007,2H30V14A2.0023,2.0023,0,0,0,28,12Z"
    })), children);
  });
  var InventoryManagement32 = /*#__PURE__*/React__default['default'].forwardRef(function InventoryManagement32(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$g || (_path147$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"
    })), _path148$g || (_path148$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"
    })), children);
  });
  var InventoryManagement24 = /*#__PURE__*/React__default['default'].forwardRef(function InventoryManagement24(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$g || (_path149$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"
    })), _path150$g || (_path150$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"
    })), children);
  });
  var InventoryManagement20 = /*#__PURE__*/React__default['default'].forwardRef(function InventoryManagement20(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$g || (_path151$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"
    })), _path152$g || (_path152$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"
    })), children);
  });
  var InventoryManagement16 = /*#__PURE__*/React__default['default'].forwardRef(function InventoryManagement16(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$g || (_path153$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"
    })), _path154$g || (_path154$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"
    })), children);
  });
  var IotConnect32 = /*#__PURE__*/React__default['default'].forwardRef(function IotConnect32(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$g || (_path155$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path156$g || (_path156$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"
    })), children);
  });
  var IotConnect24 = /*#__PURE__*/React__default['default'].forwardRef(function IotConnect24(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$g || (_path157$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path158$g || (_path158$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"
    })), children);
  });
  var IotConnect20 = /*#__PURE__*/React__default['default'].forwardRef(function IotConnect20(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$g || (_path159$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path160$g || (_path160$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"
    })), children);
  });
  var IotConnect16 = /*#__PURE__*/React__default['default'].forwardRef(function IotConnect16(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$g || (_path161$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path162$g || (_path162$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"
    })), children);
  });
  var IotPlatform32 = /*#__PURE__*/React__default['default'].forwardRef(function IotPlatform32(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$g || (_path163$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path164$g || (_path164$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0019 3V1A12.0131 12.0131 0 0131 13z"
    })), _path165$g || (_path165$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"
    })), children);
  });
  var IotPlatform24 = /*#__PURE__*/React__default['default'].forwardRef(function IotPlatform24(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$g || (_path166$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path167$g || (_path167$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0019 3V1A12.0131 12.0131 0 0131 13z"
    })), _path168$g || (_path168$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"
    })), children);
  });
  var IotPlatform20 = /*#__PURE__*/React__default['default'].forwardRef(function IotPlatform20(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$g || (_path169$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path170$g || (_path170$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0019 3V1A12.0131 12.0131 0 0131 13z"
    })), _path171$g || (_path171$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"
    })), children);
  });
  var IotPlatform16 = /*#__PURE__*/React__default['default'].forwardRef(function IotPlatform16(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$g || (_path172$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"
    })), _path173$g || (_path173$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0019 3V1A12.0131 12.0131 0 0131 13z"
    })), _path174$g || (_path174$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"
    })), children);
  });
  var Iso32 = /*#__PURE__*/React__default['default'].forwardRef(function Iso32(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$g || (_path175$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H24a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0128 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 01-2-2V11a2 2 0 012-2h6v2H14v4h4a2 2 0 012 2v4A2 2 0 0118 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Iso24 = /*#__PURE__*/React__default['default'].forwardRef(function Iso24(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$g || (_path176$g = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H24a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0128 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 01-2-2V11a2 2 0 012-2h6v2H14v4h4a2 2 0 012 2v4A2 2 0 0118 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Iso20 = /*#__PURE__*/React__default['default'].forwardRef(function Iso20(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$f || (_path177$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H24a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0128 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 01-2-2V11a2 2 0 012-2h6v2H14v4h4a2 2 0 012 2v4A2 2 0 0118 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Iso16 = /*#__PURE__*/React__default['default'].forwardRef(function Iso16(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$f || (_path178$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H24a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0128 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 01-2-2V11a2 2 0 012-2h6v2H14v4h4a2 2 0 012 2v4A2 2 0 0118 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var IsoFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function IsoFilled32(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$f || (_path179$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13H24V19H21z"
    })), _path180$f || (_path180$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"
    })), children);
  });
  var IsoFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function IsoFilled24(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$f || (_path181$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13H24V19H21z"
    })), _path182$f || (_path182$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"
    })), children);
  });
  var IsoFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function IsoFilled20(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$f || (_path183$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13H24V19H21z"
    })), _path184$f || (_path184$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"
    })), children);
  });
  var IsoFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function IsoFilled16(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$f || (_path185$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 13H24V19H21z"
    })), _path186$f || (_path186$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"
    })), children);
  });
  var IsoOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function IsoOutline32(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$f || (_path187$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H21a2 2 0 01-2-2V13a2 2 0 012-2h3a2 2 0 012 2v6A2 2 0 0124 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 01-2-2V13a2 2 0 012-2h5v2H12v2h3a2 2 0 012 2v2A2 2 0 0115 21zM6 11H8V21H6z"
    })), _path188$f || (_path188$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), children);
  });
  var IsoOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function IsoOutline24(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$f || (_path189$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H21a2 2 0 01-2-2V13a2 2 0 012-2h3a2 2 0 012 2v6A2 2 0 0124 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 01-2-2V13a2 2 0 012-2h5v2H12v2h3a2 2 0 012 2v2A2 2 0 0115 21zM6 11H8V21H6z"
    })), _path190$f || (_path190$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), children);
  });
  var IsoOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function IsoOutline20(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$f || (_path191$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H21a2 2 0 01-2-2V13a2 2 0 012-2h3a2 2 0 012 2v6A2 2 0 0124 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 01-2-2V13a2 2 0 012-2h5v2H12v2h3a2 2 0 012 2v2A2 2 0 0115 21zM6 11H8V21H6z"
    })), _path192$f || (_path192$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), children);
  });
  var IsoOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function IsoOutline16(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$f || (_path193$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21H21a2 2 0 01-2-2V13a2 2 0 012-2h3a2 2 0 012 2v6A2 2 0 0124 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 01-2-2V13a2 2 0 012-2h5v2H12v2h3a2 2 0 012 2v2A2 2 0 0115 21zM6 11H8V21H6z"
    })), _path194$f || (_path194$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"
    })), children);
  });
  var JoinFull32 = /*#__PURE__*/React__default['default'].forwardRef(function JoinFull32(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$f || (_path195$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,9.0752a7.9941,7.9941,0,0,1,0,13.85,7.9941,7.9941,0,0,1,0-13.85m0-2.2373a9.9953,9.9953,0,0,0,0,18.3242A9.9953,9.9953,0,0,0,16,6.8379Z",
      "data-icon-path": "inner-path"
    })), _path196$f || (_path196$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9976,9.9976,0,0,1,6-9.1621,10,10,0,1,0,0,18.3242A9.9976,9.9976,0,0,1,10,16Z"
    })), _path197$f || (_path197$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.0752a7.9941,7.9941,0,0,0,0,13.85,7.9941,7.9941,0,0,0,0-13.85Z"
    })), _path198$f || (_path198$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9539,9.9539,0,0,0-4,.8379,9.9953,9.9953,0,0,1,0,18.3242A9.9988,9.9988,0,1,0,20,6Z"
    })), children);
  });
  var JoinFull24 = /*#__PURE__*/React__default['default'].forwardRef(function JoinFull24(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$f || (_path199$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,9.0752a7.9941,7.9941,0,0,1,0,13.85,7.9941,7.9941,0,0,1,0-13.85m0-2.2373a9.9953,9.9953,0,0,0,0,18.3242A9.9953,9.9953,0,0,0,16,6.8379Z",
      "data-icon-path": "inner-path"
    })), _path200$f || (_path200$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9976,9.9976,0,0,1,6-9.1621,10,10,0,1,0,0,18.3242A9.9976,9.9976,0,0,1,10,16Z"
    })), _path201$f || (_path201$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.0752a7.9941,7.9941,0,0,0,0,13.85,7.9941,7.9941,0,0,0,0-13.85Z"
    })), _path202$f || (_path202$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9539,9.9539,0,0,0-4,.8379,9.9953,9.9953,0,0,1,0,18.3242A9.9988,9.9988,0,1,0,20,6Z"
    })), children);
  });
  var JoinFull20 = /*#__PURE__*/React__default['default'].forwardRef(function JoinFull20(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$f || (_path203$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,9.0752a7.9941,7.9941,0,0,1,0,13.85,7.9941,7.9941,0,0,1,0-13.85m0-2.2373a9.9953,9.9953,0,0,0,0,18.3242A9.9953,9.9953,0,0,0,16,6.8379Z",
      "data-icon-path": "inner-path"
    })), _path204$f || (_path204$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9976,9.9976,0,0,1,6-9.1621,10,10,0,1,0,0,18.3242A9.9976,9.9976,0,0,1,10,16Z"
    })), _path205$f || (_path205$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.0752a7.9941,7.9941,0,0,0,0,13.85,7.9941,7.9941,0,0,0,0-13.85Z"
    })), _path206$f || (_path206$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9539,9.9539,0,0,0-4,.8379,9.9953,9.9953,0,0,1,0,18.3242A9.9988,9.9988,0,1,0,20,6Z"
    })), children);
  });
  var JoinFull16 = /*#__PURE__*/React__default['default'].forwardRef(function JoinFull16(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$f || (_path207$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,9.0752a7.9941,7.9941,0,0,1,0,13.85,7.9941,7.9941,0,0,1,0-13.85m0-2.2373a9.9953,9.9953,0,0,0,0,18.3242A9.9953,9.9953,0,0,0,16,6.8379Z",
      "data-icon-path": "inner-path"
    })), _path208$f || (_path208$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9976,9.9976,0,0,1,6-9.1621,10,10,0,1,0,0,18.3242A9.9976,9.9976,0,0,1,10,16Z"
    })), _path209$f || (_path209$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.0752a7.9941,7.9941,0,0,0,0,13.85,7.9941,7.9941,0,0,0,0-13.85Z"
    })), _path210$f || (_path210$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9539,9.9539,0,0,0-4,.8379,9.9953,9.9953,0,0,1,0,18.3242A9.9988,9.9988,0,1,0,20,6Z"
    })), children);
  });
  var JoinInner32 = /*#__PURE__*/React__default['default'].forwardRef(function JoinInner32(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$f || (_path211$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9355,9.9355,0,0,0-4,.8418A9.999,9.999,0,1,0,16,25.16,9.998,9.998,0,1,0,20,6ZM12,24A8,8,0,1,1,13.7573,8.2017a9.9734,9.9734,0,0,0,0,15.5986A7.9919,7.9919,0,0,1,12,24Zm8,0a7.9919,7.9919,0,0,1-1.7573-.2,9.9734,9.9734,0,0,0,0-15.5986A7.9972,7.9972,0,1,1,20,24Z"
    })), children);
  });
  var JoinInner24 = /*#__PURE__*/React__default['default'].forwardRef(function JoinInner24(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$f || (_path212$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9355,9.9355,0,0,0-4,.8418A9.999,9.999,0,1,0,16,25.16,9.998,9.998,0,1,0,20,6ZM12,24A8,8,0,1,1,13.7573,8.2017a9.9734,9.9734,0,0,0,0,15.5986A7.9919,7.9919,0,0,1,12,24Zm8,0a7.9919,7.9919,0,0,1-1.7573-.2,9.9734,9.9734,0,0,0,0-15.5986A7.9972,7.9972,0,1,1,20,24Z"
    })), children);
  });
  var JoinInner20 = /*#__PURE__*/React__default['default'].forwardRef(function JoinInner20(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$f || (_path213$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9355,9.9355,0,0,0-4,.8418A9.999,9.999,0,1,0,16,25.16,9.998,9.998,0,1,0,20,6ZM12,24A8,8,0,1,1,13.7573,8.2017a9.9734,9.9734,0,0,0,0,15.5986A7.9919,7.9919,0,0,1,12,24Zm8,0a7.9919,7.9919,0,0,1-1.7573-.2,9.9734,9.9734,0,0,0,0-15.5986A7.9972,7.9972,0,1,1,20,24Z"
    })), children);
  });
  var JoinInner16 = /*#__PURE__*/React__default['default'].forwardRef(function JoinInner16(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$f || (_path214$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9355,9.9355,0,0,0-4,.8418A9.999,9.999,0,1,0,16,25.16,9.998,9.998,0,1,0,20,6ZM12,24A8,8,0,1,1,13.7573,8.2017a9.9734,9.9734,0,0,0,0,15.5986A7.9919,7.9919,0,0,1,12,24Zm8,0a7.9919,7.9919,0,0,1-1.7573-.2,9.9734,9.9734,0,0,0,0-15.5986A7.9972,7.9972,0,1,1,20,24Z"
    })), children);
  });
  var JoinLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function JoinLeft32(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$f || (_path215$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9272,9.9272,0,0,0-3.9968.8394,9.9758,9.9758,0,0,1,2.2451,1.36,8,8,0,1,1,0,15.6016,9.9758,9.9758,0,0,1-2.2451,1.36A9.9976,9.9976,0,1,0,20,6Z"
    })), _path216$f || (_path216$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,16a8.01,8.01,0,0,0,6.2483,7.8008,9.9858,9.9858,0,0,0,0-15.6016A8.01,8.01,0,0,0,12,16Z"
    })), _path217$f || (_path217$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12,16a8.01,8.01,0,0,1,6.2483-7.8008,9.9758,9.9758,0,0,0-2.2451-1.36,9.9909,9.9909,0,0,0,0,18.3212,9.9758,9.9758,0,0,0,2.2451-1.36A8.01,8.01,0,0,1,12,16Z",
      "data-icon-path": "inner-path"
    })), _path218$f || (_path218$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a10.0105,10.0105,0,0,1,6.0032-9.1606,10,10,0,1,0,0,18.3212A10.0105,10.0105,0,0,1,10,16Z"
    })), children);
  });
  var JoinLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function JoinLeft24(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$f || (_path219$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9272,9.9272,0,0,0-3.9968.8394,9.9758,9.9758,0,0,1,2.2451,1.36,8,8,0,1,1,0,15.6016,9.9758,9.9758,0,0,1-2.2451,1.36A9.9976,9.9976,0,1,0,20,6Z"
    })), _path220$f || (_path220$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,16a8.01,8.01,0,0,0,6.2483,7.8008,9.9858,9.9858,0,0,0,0-15.6016A8.01,8.01,0,0,0,12,16Z"
    })), _path221$f || (_path221$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12,16a8.01,8.01,0,0,1,6.2483-7.8008,9.9758,9.9758,0,0,0-2.2451-1.36,9.9909,9.9909,0,0,0,0,18.3212,9.9758,9.9758,0,0,0,2.2451-1.36A8.01,8.01,0,0,1,12,16Z",
      "data-icon-path": "inner-path"
    })), _path222$f || (_path222$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a10.0105,10.0105,0,0,1,6.0032-9.1606,10,10,0,1,0,0,18.3212A10.0105,10.0105,0,0,1,10,16Z"
    })), children);
  });
  var JoinLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function JoinLeft20(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$f || (_path223$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9272,9.9272,0,0,0-3.9968.8394,9.9758,9.9758,0,0,1,2.2451,1.36,8,8,0,1,1,0,15.6016,9.9758,9.9758,0,0,1-2.2451,1.36A9.9976,9.9976,0,1,0,20,6Z"
    })), _path224$f || (_path224$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,16a8.01,8.01,0,0,0,6.2483,7.8008,9.9858,9.9858,0,0,0,0-15.6016A8.01,8.01,0,0,0,12,16Z"
    })), _path225$f || (_path225$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12,16a8.01,8.01,0,0,1,6.2483-7.8008,9.9758,9.9758,0,0,0-2.2451-1.36,9.9909,9.9909,0,0,0,0,18.3212,9.9758,9.9758,0,0,0,2.2451-1.36A8.01,8.01,0,0,1,12,16Z",
      "data-icon-path": "inner-path"
    })), _path226$f || (_path226$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a10.0105,10.0105,0,0,1,6.0032-9.1606,10,10,0,1,0,0,18.3212A10.0105,10.0105,0,0,1,10,16Z"
    })), children);
  });
  var JoinLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function JoinLeft16(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$f || (_path227$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.9272,9.9272,0,0,0-3.9968.8394,9.9758,9.9758,0,0,1,2.2451,1.36,8,8,0,1,1,0,15.6016,9.9758,9.9758,0,0,1-2.2451,1.36A9.9976,9.9976,0,1,0,20,6Z"
    })), _path228$f || (_path228$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,16a8.01,8.01,0,0,0,6.2483,7.8008,9.9858,9.9858,0,0,0,0-15.6016A8.01,8.01,0,0,0,12,16Z"
    })), _path229$f || (_path229$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12,16a8.01,8.01,0,0,1,6.2483-7.8008,9.9758,9.9758,0,0,0-2.2451-1.36,9.9909,9.9909,0,0,0,0,18.3212,9.9758,9.9758,0,0,0,2.2451-1.36A8.01,8.01,0,0,1,12,16Z",
      "data-icon-path": "inner-path"
    })), _path230$f || (_path230$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a10.0105,10.0105,0,0,1,6.0032-9.1606,10,10,0,1,0,0,18.3212A10.0105,10.0105,0,0,1,10,16Z"
    })), children);
  });
  var JoinOuter32 = /*#__PURE__*/React__default['default'].forwardRef(function JoinOuter32(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$f || (_path231$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6a9.9539 9.9539 0 00-4 .8379 9.9953 9.9953 0 010 18.3242A9.9988 9.9988 0 1020 6zM10 16a9.9976 9.9976 0 016-9.1621 10 10 0 100 18.3242A9.9976 9.9976 0 0110 16z"
    })), children);
  });
  var JoinOuter24 = /*#__PURE__*/React__default['default'].forwardRef(function JoinOuter24(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$f || (_path232$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6a9.9539 9.9539 0 00-4 .8379 9.9953 9.9953 0 010 18.3242A9.9988 9.9988 0 1020 6zM10 16a9.9976 9.9976 0 016-9.1621 10 10 0 100 18.3242A9.9976 9.9976 0 0110 16z"
    })), children);
  });
  var JoinOuter20 = /*#__PURE__*/React__default['default'].forwardRef(function JoinOuter20(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$g);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$f || (_path233$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6a9.9539 9.9539 0 00-4 .8379 9.9953 9.9953 0 010 18.3242A9.9988 9.9988 0 1020 6zM10 16a9.9976 9.9976 0 016-9.1621 10 10 0 100 18.3242A9.9976 9.9976 0 0110 16z"
    })), children);
  });
  var JoinOuter16 = /*#__PURE__*/React__default['default'].forwardRef(function JoinOuter16(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$f || (_path234$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6a9.9539 9.9539 0 00-4 .8379 9.9953 9.9953 0 010 18.3242A9.9988 9.9988 0 1020 6zM10 16a9.9976 9.9976 0 016-9.1621 10 10 0 100 18.3242A9.9976 9.9976 0 0110 16z"
    })), children);
  });
  var JoinRight32 = /*#__PURE__*/React__default['default'].forwardRef(function JoinRight32(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$f || (_path235$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.95,9.95,0,0,0-4.0032.8394,9.9909,9.9909,0,0,1,0,18.3212A9.9988,9.9988,0,1,0,20,6Z"
    })), _path236$f || (_path236$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,16a8.01,8.01,0,0,0-6.2483-7.8008,9.9758,9.9758,0,0,1,2.2451-1.36,9.9909,9.9909,0,0,1,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A8.01,8.01,0,0,0,20,16Z",
      "data-icon-path": "inner-path"
    })), _path237$f || (_path237$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9759,9.9759,0,0,0,3.7517,7.8008,7.9937,7.9937,0,0,0,0-15.6016A9.9759,9.9759,0,0,0,10,16Z"
    })), _path238$f || (_path238$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24A8,8,0,1,1,13.7517,8.1992a9.9758,9.9758,0,0,1,2.2451-1.36,10,10,0,1,0,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A7.9727,7.9727,0,0,1,12,24Z"
    })), children);
  });
  var JoinRight24 = /*#__PURE__*/React__default['default'].forwardRef(function JoinRight24(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$f || (_path239$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.95,9.95,0,0,0-4.0032.8394,9.9909,9.9909,0,0,1,0,18.3212A9.9988,9.9988,0,1,0,20,6Z"
    })), _path240$f || (_path240$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,16a8.01,8.01,0,0,0-6.2483-7.8008,9.9758,9.9758,0,0,1,2.2451-1.36,9.9909,9.9909,0,0,1,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A8.01,8.01,0,0,0,20,16Z",
      "data-icon-path": "inner-path"
    })), _path241$f || (_path241$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9759,9.9759,0,0,0,3.7517,7.8008,7.9937,7.9937,0,0,0,0-15.6016A9.9759,9.9759,0,0,0,10,16Z"
    })), _path242$f || (_path242$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24A8,8,0,1,1,13.7517,8.1992a9.9758,9.9758,0,0,1,2.2451-1.36,10,10,0,1,0,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A7.9727,7.9727,0,0,1,12,24Z"
    })), children);
  });
  var JoinRight20 = /*#__PURE__*/React__default['default'].forwardRef(function JoinRight20(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$f || (_path243$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.95,9.95,0,0,0-4.0032.8394,9.9909,9.9909,0,0,1,0,18.3212A9.9988,9.9988,0,1,0,20,6Z"
    })), _path244$f || (_path244$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,16a8.01,8.01,0,0,0-6.2483-7.8008,9.9758,9.9758,0,0,1,2.2451-1.36,9.9909,9.9909,0,0,1,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A8.01,8.01,0,0,0,20,16Z",
      "data-icon-path": "inner-path"
    })), _path245$f || (_path245$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9759,9.9759,0,0,0,3.7517,7.8008,7.9937,7.9937,0,0,0,0-15.6016A9.9759,9.9759,0,0,0,10,16Z"
    })), _path246$f || (_path246$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24A8,8,0,1,1,13.7517,8.1992a9.9758,9.9758,0,0,1,2.2451-1.36,10,10,0,1,0,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A7.9727,7.9727,0,0,1,12,24Z"
    })), children);
  });
  var JoinRight16 = /*#__PURE__*/React__default['default'].forwardRef(function JoinRight16(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$f || (_path247$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,6a9.95,9.95,0,0,0-4.0032.8394,9.9909,9.9909,0,0,1,0,18.3212A9.9988,9.9988,0,1,0,20,6Z"
    })), _path248$f || (_path248$f = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,16a8.01,8.01,0,0,0-6.2483-7.8008,9.9758,9.9758,0,0,1,2.2451-1.36,9.9909,9.9909,0,0,1,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A8.01,8.01,0,0,0,20,16Z",
      "data-icon-path": "inner-path"
    })), _path249$f || (_path249$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,16a9.9759,9.9759,0,0,0,3.7517,7.8008,7.9937,7.9937,0,0,0,0-15.6016A9.9759,9.9759,0,0,0,10,16Z"
    })), _path250$f || (_path250$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,24A8,8,0,1,1,13.7517,8.1992a9.9758,9.9758,0,0,1,2.2451-1.36,10,10,0,1,0,0,18.3212,9.9758,9.9758,0,0,1-2.2451-1.36A7.9727,7.9727,0,0,1,12,24Z"
    })), children);
  });
  var Jpg32 = /*#__PURE__*/React__default['default'].forwardRef(function Jpg32(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$f || (_path251$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 01-2-2V19H4v2H8V9h2V21A2 2 0 018 23z"
    })), children);
  });
  var Jpg24 = /*#__PURE__*/React__default['default'].forwardRef(function Jpg24(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$f || (_path252$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 01-2-2V19H4v2H8V9h2V21A2 2 0 018 23z"
    })), children);
  });
  var Jpg20 = /*#__PURE__*/React__default['default'].forwardRef(function Jpg20(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$f || (_path253$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 01-2-2V19H4v2H8V9h2V21A2 2 0 018 23z"
    })), children);
  });
  var Jpg16 = /*#__PURE__*/React__default['default'].forwardRef(function Jpg16(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$f || (_path254$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 01-2-2V19H4v2H8V9h2V21A2 2 0 018 23z"
    })), children);
  });
  var Json32 = /*#__PURE__*/React__default['default'].forwardRef(function Json32(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$f || (_path255$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0117 19.3335v-6.667A1.6684 1.6684 0 0118.6665 11h2.667A1.6684 1.6684 0 0123 12.6665v6.667A1.6684 1.6684 0 0121.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 01-2-2V12.6665A1.6684 1.6684 0 0110.6665 11H15v2H11v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0113.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 011 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 015.3335 21z"
    })), children);
  });
  var Json24 = /*#__PURE__*/React__default['default'].forwardRef(function Json24(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$f || (_path256$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0117 19.3335v-6.667A1.6684 1.6684 0 0118.6665 11h2.667A1.6684 1.6684 0 0123 12.6665v6.667A1.6684 1.6684 0 0121.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 01-2-2V12.6665A1.6684 1.6684 0 0110.6665 11H15v2H11v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0113.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 011 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 015.3335 21z"
    })), children);
  });
  var Json20 = /*#__PURE__*/React__default['default'].forwardRef(function Json20(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$f || (_path257$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0117 19.3335v-6.667A1.6684 1.6684 0 0118.6665 11h2.667A1.6684 1.6684 0 0123 12.6665v6.667A1.6684 1.6684 0 0121.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 01-2-2V12.6665A1.6684 1.6684 0 0110.6665 11H15v2H11v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0113.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 011 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 015.3335 21z"
    })), children);
  });
  var Json16 = /*#__PURE__*/React__default['default'].forwardRef(function Json16(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$f || (_path258$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0117 19.3335v-6.667A1.6684 1.6684 0 0118.6665 11h2.667A1.6684 1.6684 0 0123 12.6665v6.667A1.6684 1.6684 0 0121.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 01-2-2V12.6665A1.6684 1.6684 0 0110.6665 11H15v2H11v2h2a2.002 2.002 0 012 2v2.3335A1.6684 1.6684 0 0113.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 011 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 015.3335 21z"
    })), children);
  });
  var JsonReference32 = /*#__PURE__*/React__default['default'].forwardRef(function JsonReference32(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$f || (_path259$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM29 12L27 6 25 6 25 16 27 16 27 10 29 16 31 16 31 6 29 6 29 12zM21.3335 6h-2.667A1.6683 1.6683 0 0017 7.6665v6.667A1.6684 1.6684 0 0018.6665 16h2.667A1.6683 1.6683 0 0023 14.3335V7.6665A1.6683 1.6683 0 0021.3335 6zM21 14H19V8h2zM9 7.6665V10a2.002 2.002 0 002 2h2v2H9v2h4.3335A1.6683 1.6683 0 0015 14.3335V12a2.002 2.002 0 00-2-2H11V8h4V6H10.6665A1.6683 1.6683 0 009 7.6665zM5 14H3V12H1v2.3335A1.6684 1.6684 0 002.6665 16h2.667A1.6683 1.6683 0 007 14.3335V6H5z"
    })), children);
  });
  var JsonReference24 = /*#__PURE__*/React__default['default'].forwardRef(function JsonReference24(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$f || (_path260$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM29 12L27 6 25 6 25 16 27 16 27 10 29 16 31 16 31 6 29 6 29 12zM21.3335 6h-2.667A1.6683 1.6683 0 0017 7.6665v6.667A1.6684 1.6684 0 0018.6665 16h2.667A1.6683 1.6683 0 0023 14.3335V7.6665A1.6683 1.6683 0 0021.3335 6zM21 14H19V8h2zM9 7.6665V10a2.002 2.002 0 002 2h2v2H9v2h4.3335A1.6683 1.6683 0 0015 14.3335V12a2.002 2.002 0 00-2-2H11V8h4V6H10.6665A1.6683 1.6683 0 009 7.6665zM5 14H3V12H1v2.3335A1.6684 1.6684 0 002.6665 16h2.667A1.6683 1.6683 0 007 14.3335V6H5z"
    })), children);
  });
  var JsonReference20 = /*#__PURE__*/React__default['default'].forwardRef(function JsonReference20(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$f || (_path261$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM29 12L27 6 25 6 25 16 27 16 27 10 29 16 31 16 31 6 29 6 29 12zM21.3335 6h-2.667A1.6683 1.6683 0 0017 7.6665v6.667A1.6684 1.6684 0 0018.6665 16h2.667A1.6683 1.6683 0 0023 14.3335V7.6665A1.6683 1.6683 0 0021.3335 6zM21 14H19V8h2zM9 7.6665V10a2.002 2.002 0 002 2h2v2H9v2h4.3335A1.6683 1.6683 0 0015 14.3335V12a2.002 2.002 0 00-2-2H11V8h4V6H10.6665A1.6683 1.6683 0 009 7.6665zM5 14H3V12H1v2.3335A1.6684 1.6684 0 002.6665 16h2.667A1.6683 1.6683 0 007 14.3335V6H5z"
    })), children);
  });
  var JsonReference16 = /*#__PURE__*/React__default['default'].forwardRef(function JsonReference16(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$f || (_path262$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM29 12L27 6 25 6 25 16 27 16 27 10 29 16 31 16 31 6 29 6 29 12zM21.3335 6h-2.667A1.6683 1.6683 0 0017 7.6665v6.667A1.6684 1.6684 0 0018.6665 16h2.667A1.6683 1.6683 0 0023 14.3335V7.6665A1.6683 1.6683 0 0021.3335 6zM21 14H19V8h2zM9 7.6665V10a2.002 2.002 0 002 2h2v2H9v2h4.3335A1.6683 1.6683 0 0015 14.3335V12a2.002 2.002 0 00-2-2H11V8h4V6H10.6665A1.6683 1.6683 0 009 7.6665zM5 14H3V12H1v2.3335A1.6684 1.6684 0 002.6665 16h2.667A1.6683 1.6683 0 007 14.3335V6H5z"
    })), children);
  });
  var JumpLink32 = /*#__PURE__*/React__default['default'].forwardRef(function JumpLink32(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$f || (_path263$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.4141,17.5859,18,22.1719V8H8V6H18a2.0024,2.0024,0,0,1,2,2V22.1719l4.5859-4.586L26,19l-7,7-7-7Z"
    })), children);
  });
  var JumpLink24 = /*#__PURE__*/React__default['default'].forwardRef(function JumpLink24(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$f || (_path264$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.4141,17.5859,18,22.1719V8H8V6H18a2.0024,2.0024,0,0,1,2,2V22.1719l4.5859-4.586L26,19l-7,7-7-7Z"
    })), children);
  });
  var JumpLink20 = /*#__PURE__*/React__default['default'].forwardRef(function JumpLink20(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$f || (_path265$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.4141,17.5859,18,22.1719V8H8V6H18a2.0024,2.0024,0,0,1,2,2V22.1719l4.5859-4.586L26,19l-7,7-7-7Z"
    })), children);
  });
  var JumpLink16 = /*#__PURE__*/React__default['default'].forwardRef(function JumpLink16(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$f || (_path266$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.4141,17.5859,18,22.1719V8H8V6H18a2.0024,2.0024,0,0,1,2,2V22.1719l4.5859-4.586L26,19l-7,7-7-7Z"
    })), children);
  });
  var KeepDry32 = /*#__PURE__*/React__default['default'].forwardRef(function KeepDry32(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$f || (_path267$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10a3.8978,3.8978,0,0,1-4-3.777,3.9017,3.9017,0,0,1,.6533-2.0639L24.17.4141a1.0381,1.0381,0,0,1,1.6592,0L28.3154,4.11A3.9693,3.9693,0,0,1,29,6.223,3.8978,3.8978,0,0,1,25,10Zm0-7.2368L23.3438,5.2257A1.89,1.89,0,0,0,23,6.223a2.014,2.014,0,0,0,4,0,1.98,1.98,0,0,0-.375-1.0466Z"
    })), _path268$f || (_path268$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83a13.9726,13.9726,0,0,0-1.8147-4.8323L26.4329,12.001a12.092,12.092,0,0,1,1.07,2.2124A5.4079,5.4079,0,0,0,26,14a6.5439,6.5439,0,0,0-3.939,1.333,14.5177,14.5177,0,0,0-3.0456-8.9341A13.8858,13.8858,0,0,0,17,4.4014V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM9.939,15.333A6.5439,6.5439,0,0,0,6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4413,12.4413,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333ZM16,14a6.5526,6.5526,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0564-9.1763,3.4307,2.6768,4.009,6.9487,4.0522,9.1728A6.552,6.552,0,0,0,16,14Z"
    })), children);
  });
  var KeepDry24 = /*#__PURE__*/React__default['default'].forwardRef(function KeepDry24(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$f || (_path269$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10a3.8978,3.8978,0,0,1-4-3.777,3.9017,3.9017,0,0,1,.6533-2.0639L24.17.4141a1.0381,1.0381,0,0,1,1.6592,0L28.3154,4.11A3.9693,3.9693,0,0,1,29,6.223,3.8978,3.8978,0,0,1,25,10Zm0-7.2368L23.3438,5.2257A1.89,1.89,0,0,0,23,6.223a2.014,2.014,0,0,0,4,0,1.98,1.98,0,0,0-.375-1.0466Z"
    })), _path270$f || (_path270$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83a13.9726,13.9726,0,0,0-1.8147-4.8323L26.4329,12.001a12.092,12.092,0,0,1,1.07,2.2124A5.4079,5.4079,0,0,0,26,14a6.5439,6.5439,0,0,0-3.939,1.333,14.5177,14.5177,0,0,0-3.0456-8.9341A13.8858,13.8858,0,0,0,17,4.4014V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM9.939,15.333A6.5439,6.5439,0,0,0,6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4413,12.4413,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333ZM16,14a6.5526,6.5526,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0564-9.1763,3.4307,2.6768,4.009,6.9487,4.0522,9.1728A6.552,6.552,0,0,0,16,14Z"
    })), children);
  });
  var KeepDry20 = /*#__PURE__*/React__default['default'].forwardRef(function KeepDry20(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$f || (_path271$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10a3.8978,3.8978,0,0,1-4-3.777,3.9017,3.9017,0,0,1,.6533-2.0639L24.17.4141a1.0381,1.0381,0,0,1,1.6592,0L28.3154,4.11A3.9693,3.9693,0,0,1,29,6.223,3.8978,3.8978,0,0,1,25,10Zm0-7.2368L23.3438,5.2257A1.89,1.89,0,0,0,23,6.223a2.014,2.014,0,0,0,4,0,1.98,1.98,0,0,0-.375-1.0466Z"
    })), _path272$f || (_path272$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83a13.9726,13.9726,0,0,0-1.8147-4.8323L26.4329,12.001a12.092,12.092,0,0,1,1.07,2.2124A5.4079,5.4079,0,0,0,26,14a6.5439,6.5439,0,0,0-3.939,1.333,14.5177,14.5177,0,0,0-3.0456-8.9341A13.8858,13.8858,0,0,0,17,4.4014V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM9.939,15.333A6.5439,6.5439,0,0,0,6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4413,12.4413,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333ZM16,14a6.5526,6.5526,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0564-9.1763,3.4307,2.6768,4.009,6.9487,4.0522,9.1728A6.552,6.552,0,0,0,16,14Z"
    })), children);
  });
  var KeepDry16 = /*#__PURE__*/React__default['default'].forwardRef(function KeepDry16(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$f || (_path273$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,10a3.8978,3.8978,0,0,1-4-3.777,3.9017,3.9017,0,0,1,.6533-2.0639L24.17.4141a1.0381,1.0381,0,0,1,1.6592,0L28.3154,4.11A3.9693,3.9693,0,0,1,29,6.223,3.8978,3.8978,0,0,1,25,10Zm0-7.2368L23.3438,5.2257A1.89,1.89,0,0,0,23,6.223a2.014,2.014,0,0,0,4,0,1.98,1.98,0,0,0-.375-1.0466Z"
    })), _path274$f || (_path274$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83a13.9726,13.9726,0,0,0-1.8147-4.8323L26.4329,12.001a12.092,12.092,0,0,1,1.07,2.2124A5.4079,5.4079,0,0,0,26,14a6.5439,6.5439,0,0,0-3.939,1.333,14.5177,14.5177,0,0,0-3.0456-8.9341A13.8858,13.8858,0,0,0,17,4.4014V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM9.939,15.333A6.5439,6.5439,0,0,0,6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4413,12.4413,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333ZM16,14a6.5526,6.5526,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0564-9.1763,3.4307,2.6768,4.009,6.9487,4.0522,9.1728A6.552,6.552,0,0,0,16,14Z"
    })), children);
  });
  var Keyboard32 = /*#__PURE__*/React__default['default'].forwardRef(function Keyboard32(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$f || (_path275$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"
    })), _path276$f || (_path276$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"
    })), children);
  });
  var Keyboard24 = /*#__PURE__*/React__default['default'].forwardRef(function Keyboard24(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$f || (_path277$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"
    })), _path278$f || (_path278$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"
    })), children);
  });
  var Keyboard20 = /*#__PURE__*/React__default['default'].forwardRef(function Keyboard20(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$f || (_path279$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"
    })), _path280$f || (_path280$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"
    })), children);
  });
  var Keyboard16 = /*#__PURE__*/React__default['default'].forwardRef(function Keyboard16(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$f || (_path281$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"
    })), _path282$f || (_path282$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"
    })), children);
  });
  var Kubernetes32 = /*#__PURE__*/React__default['default'].forwardRef(function Kubernetes32(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$f || (_path283$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2227,17.9639,25.9194,17.21a9.7843,9.7843,0,0,0-1.5249-6.6245l2.54-2.0254L25.6875,6.9961,23.1482,9.0205A9.97,9.97,0,0,0,17,6.0508V3H15V6.0508a9.97,9.97,0,0,0-6.1482,2.97L6.3125,6.9961,5.0654,8.56l2.54,2.0254A9.7843,9.7843,0,0,0,6.0806,17.21l-3.3033.7544.4454,1.9492L6.52,19.1606a10.0359,10.0359,0,0,0,4.2688,5.358l-1.33,2.7631,1.8018.8677L12.59,25.3882a9.8113,9.8113,0,0,0,6.8208,0L20.74,28.1494l1.8018-.8682-1.33-2.7626a10.0359,10.0359,0,0,0,4.2688-5.358l3.2973.7525ZM24,16c0,.2573-.0148.5112-.0386.7627l-5-1.1416a2.9664,2.9664,0,0,0-.1376-.5942L22.82,11.84A7.9392,7.9392,0,0,1,24,16Zm-9,0a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,15,16Zm6.5758-5.7256L17.58,13.4609a3.0028,3.0028,0,0,0-.58-.2768V8.0693A7.9762,7.9762,0,0,1,21.5758,10.2744ZM15,8.0693v5.1148a3.0028,3.0028,0,0,0-.58.2768l-3.9956-3.1865A7.9762,7.9762,0,0,1,15,8.0693ZM8,16a7.9392,7.9392,0,0,1,1.18-4.16l3.9962,3.1866a2.9664,2.9664,0,0,0-.1376.5942l-5,1.1416C8.0148,16.5112,8,16.2573,8,16Zm.4835,2.7124,4.9752-1.1362a3.0132,3.0132,0,0,0,.4146.5366L11.6594,22.71A8.031,8.031,0,0,1,8.4835,18.7124ZM16,24a7.9679,7.9679,0,0,1-2.54-.42l2.2206-4.6123A2.9988,2.9988,0,0,0,16,19a2.9988,2.9988,0,0,0,.319-.0322L18.54,23.58A7.9546,7.9546,0,0,1,16,24Zm4.3406-1.29-2.2139-4.5976a3.0132,3.0132,0,0,0,.4146-.5366l4.9752,1.1362A8.031,8.031,0,0,1,20.3406,22.71Z"
    })), children);
  });
  var Kubernetes24 = /*#__PURE__*/React__default['default'].forwardRef(function Kubernetes24(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$f || (_path284$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2227,17.9639,25.9194,17.21a9.7843,9.7843,0,0,0-1.5249-6.6245l2.54-2.0254L25.6875,6.9961,23.1482,9.0205A9.97,9.97,0,0,0,17,6.0508V3H15V6.0508a9.97,9.97,0,0,0-6.1482,2.97L6.3125,6.9961,5.0654,8.56l2.54,2.0254A9.7843,9.7843,0,0,0,6.0806,17.21l-3.3033.7544.4454,1.9492L6.52,19.1606a10.0359,10.0359,0,0,0,4.2688,5.358l-1.33,2.7631,1.8018.8677L12.59,25.3882a9.8113,9.8113,0,0,0,6.8208,0L20.74,28.1494l1.8018-.8682-1.33-2.7626a10.0359,10.0359,0,0,0,4.2688-5.358l3.2973.7525ZM24,16c0,.2573-.0148.5112-.0386.7627l-5-1.1416a2.9664,2.9664,0,0,0-.1376-.5942L22.82,11.84A7.9392,7.9392,0,0,1,24,16Zm-9,0a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,15,16Zm6.5758-5.7256L17.58,13.4609a3.0028,3.0028,0,0,0-.58-.2768V8.0693A7.9762,7.9762,0,0,1,21.5758,10.2744ZM15,8.0693v5.1148a3.0028,3.0028,0,0,0-.58.2768l-3.9956-3.1865A7.9762,7.9762,0,0,1,15,8.0693ZM8,16a7.9392,7.9392,0,0,1,1.18-4.16l3.9962,3.1866a2.9664,2.9664,0,0,0-.1376.5942l-5,1.1416C8.0148,16.5112,8,16.2573,8,16Zm.4835,2.7124,4.9752-1.1362a3.0132,3.0132,0,0,0,.4146.5366L11.6594,22.71A8.031,8.031,0,0,1,8.4835,18.7124ZM16,24a7.9679,7.9679,0,0,1-2.54-.42l2.2206-4.6123A2.9988,2.9988,0,0,0,16,19a2.9988,2.9988,0,0,0,.319-.0322L18.54,23.58A7.9546,7.9546,0,0,1,16,24Zm4.3406-1.29-2.2139-4.5976a3.0132,3.0132,0,0,0,.4146-.5366l4.9752,1.1362A8.031,8.031,0,0,1,20.3406,22.71Z"
    })), children);
  });
  var Kubernetes20 = /*#__PURE__*/React__default['default'].forwardRef(function Kubernetes20(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$f || (_path285$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2227,17.9639,25.9194,17.21a9.7843,9.7843,0,0,0-1.5249-6.6245l2.54-2.0254L25.6875,6.9961,23.1482,9.0205A9.97,9.97,0,0,0,17,6.0508V3H15V6.0508a9.97,9.97,0,0,0-6.1482,2.97L6.3125,6.9961,5.0654,8.56l2.54,2.0254A9.7843,9.7843,0,0,0,6.0806,17.21l-3.3033.7544.4454,1.9492L6.52,19.1606a10.0359,10.0359,0,0,0,4.2688,5.358l-1.33,2.7631,1.8018.8677L12.59,25.3882a9.8113,9.8113,0,0,0,6.8208,0L20.74,28.1494l1.8018-.8682-1.33-2.7626a10.0359,10.0359,0,0,0,4.2688-5.358l3.2973.7525ZM24,16c0,.2573-.0148.5112-.0386.7627l-5-1.1416a2.9664,2.9664,0,0,0-.1376-.5942L22.82,11.84A7.9392,7.9392,0,0,1,24,16Zm-9,0a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,15,16Zm6.5758-5.7256L17.58,13.4609a3.0028,3.0028,0,0,0-.58-.2768V8.0693A7.9762,7.9762,0,0,1,21.5758,10.2744ZM15,8.0693v5.1148a3.0028,3.0028,0,0,0-.58.2768l-3.9956-3.1865A7.9762,7.9762,0,0,1,15,8.0693ZM8,16a7.9392,7.9392,0,0,1,1.18-4.16l3.9962,3.1866a2.9664,2.9664,0,0,0-.1376.5942l-5,1.1416C8.0148,16.5112,8,16.2573,8,16Zm.4835,2.7124,4.9752-1.1362a3.0132,3.0132,0,0,0,.4146.5366L11.6594,22.71A8.031,8.031,0,0,1,8.4835,18.7124ZM16,24a7.9679,7.9679,0,0,1-2.54-.42l2.2206-4.6123A2.9988,2.9988,0,0,0,16,19a2.9988,2.9988,0,0,0,.319-.0322L18.54,23.58A7.9546,7.9546,0,0,1,16,24Zm4.3406-1.29-2.2139-4.5976a3.0132,3.0132,0,0,0,.4146-.5366l4.9752,1.1362A8.031,8.031,0,0,1,20.3406,22.71Z"
    })), children);
  });
  var Kubernetes16 = /*#__PURE__*/React__default['default'].forwardRef(function Kubernetes16(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$f || (_path286$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2227,17.9639,25.9194,17.21a9.7843,9.7843,0,0,0-1.5249-6.6245l2.54-2.0254L25.6875,6.9961,23.1482,9.0205A9.97,9.97,0,0,0,17,6.0508V3H15V6.0508a9.97,9.97,0,0,0-6.1482,2.97L6.3125,6.9961,5.0654,8.56l2.54,2.0254A9.7843,9.7843,0,0,0,6.0806,17.21l-3.3033.7544.4454,1.9492L6.52,19.1606a10.0359,10.0359,0,0,0,4.2688,5.358l-1.33,2.7631,1.8018.8677L12.59,25.3882a9.8113,9.8113,0,0,0,6.8208,0L20.74,28.1494l1.8018-.8682-1.33-2.7626a10.0359,10.0359,0,0,0,4.2688-5.358l3.2973.7525ZM24,16c0,.2573-.0148.5112-.0386.7627l-5-1.1416a2.9664,2.9664,0,0,0-.1376-.5942L22.82,11.84A7.9392,7.9392,0,0,1,24,16Zm-9,0a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,15,16Zm6.5758-5.7256L17.58,13.4609a3.0028,3.0028,0,0,0-.58-.2768V8.0693A7.9762,7.9762,0,0,1,21.5758,10.2744ZM15,8.0693v5.1148a3.0028,3.0028,0,0,0-.58.2768l-3.9956-3.1865A7.9762,7.9762,0,0,1,15,8.0693ZM8,16a7.9392,7.9392,0,0,1,1.18-4.16l3.9962,3.1866a2.9664,2.9664,0,0,0-.1376.5942l-5,1.1416C8.0148,16.5112,8,16.2573,8,16Zm.4835,2.7124,4.9752-1.1362a3.0132,3.0132,0,0,0,.4146.5366L11.6594,22.71A8.031,8.031,0,0,1,8.4835,18.7124ZM16,24a7.9679,7.9679,0,0,1-2.54-.42l2.2206-4.6123A2.9988,2.9988,0,0,0,16,19a2.9988,2.9988,0,0,0,.319-.0322L18.54,23.58A7.9546,7.9546,0,0,1,16,24Zm4.3406-1.29-2.2139-4.5976a3.0132,3.0132,0,0,0,.4146-.5366l4.9752,1.1362A8.031,8.031,0,0,1,20.3406,22.71Z"
    })), children);
  });
  var Label32 = /*#__PURE__*/React__default['default'].forwardRef(function Label32(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$f || (_path287$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2.0023 2.0023 0 0023 13zm0 8H19V19h4zM13 9H9a2.002 2.002 0 00-2 2V23H9V18h4v5h2V11A2.002 2.002 0 0013 9zM9 16V11h4v5z"
    })), _path288$f || (_path288$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var Label24 = /*#__PURE__*/React__default['default'].forwardRef(function Label24(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$f || (_path289$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2.0023 2.0023 0 0023 13zm0 8H19V19h4zM13 9H9a2.002 2.002 0 00-2 2V23H9V18h4v5h2V11A2.002 2.002 0 0013 9zM9 16V11h4v5z"
    })), _path290$f || (_path290$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var Label20 = /*#__PURE__*/React__default['default'].forwardRef(function Label20(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$f || (_path291$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2.0023 2.0023 0 0023 13zm0 8H19V19h4zM13 9H9a2.002 2.002 0 00-2 2V23H9V18h4v5h2V11A2.002 2.002 0 0013 9zM9 16V11h4v5z"
    })), _path292$f || (_path292$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var Label16 = /*#__PURE__*/React__default['default'].forwardRef(function Label16(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$f || (_path293$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2.0023 2.0023 0 0023 13zm0 8H19V19h4zM13 9H9a2.002 2.002 0 00-2 2V23H9V18h4v5h2V11A2.002 2.002 0 0013 9zM9 16V11h4v5z"
    })), _path294$f || (_path294$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var Language32 = /*#__PURE__*/React__default['default'].forwardRef(function Language32(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$f || (_path295$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 01-2.2159 3.9771A9.2731 9.2731 0 016.5521 23H4.3334a10.8553 10.8553 0 002.1451 3.2966A14.6584 14.6584 0 013 28.127L3.7021 30a16.42 16.42 0 004.2907-2.3362A16.4883 16.4883 0 0012.2979 30L13 28.127A14.664 14.664 0 019.5228 26.3 10.3132 10.3132 0 0012.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"
    })), children);
  });
  var Language24 = /*#__PURE__*/React__default['default'].forwardRef(function Language24(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$f || (_path296$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 01-2.2159 3.9771A9.2731 9.2731 0 016.5521 23H4.3334a10.8553 10.8553 0 002.1451 3.2966A14.6584 14.6584 0 013 28.127L3.7021 30a16.42 16.42 0 004.2907-2.3362A16.4883 16.4883 0 0012.2979 30L13 28.127A14.664 14.664 0 019.5228 26.3 10.3132 10.3132 0 0012.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"
    })), children);
  });
  var Language20 = /*#__PURE__*/React__default['default'].forwardRef(function Language20(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$f || (_path297$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 01-2.2159 3.9771A9.2731 9.2731 0 016.5521 23H4.3334a10.8553 10.8553 0 002.1451 3.2966A14.6584 14.6584 0 013 28.127L3.7021 30a16.42 16.42 0 004.2907-2.3362A16.4883 16.4883 0 0012.2979 30L13 28.127A14.664 14.664 0 019.5228 26.3 10.3132 10.3132 0 0012.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"
    })), children);
  });
  var Language16 = /*#__PURE__*/React__default['default'].forwardRef(function Language16(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$f || (_path298$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 01-2.2159 3.9771A9.2731 9.2731 0 016.5521 23H4.3334a10.8553 10.8553 0 002.1451 3.2966A14.6584 14.6584 0 013 28.127L3.7021 30a16.42 16.42 0 004.2907-2.3362A16.4883 16.4883 0 0012.2979 30L13 28.127A14.664 14.664 0 019.5228 26.3 10.3132 10.3132 0 0012.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"
    })), children);
  });
  var Laptop32 = /*#__PURE__*/React__default['default'].forwardRef(function Laptop32(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$f || (_path299$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",
      transform: "translate(0 .005)"
    })), _path300$f || (_path300$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26.005H30V28.005H2z"
    })), children);
  });
  var Laptop24 = /*#__PURE__*/React__default['default'].forwardRef(function Laptop24(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$f || (_path301$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",
      transform: "translate(0 .005)"
    })), _path302$f || (_path302$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26.005H30V28.005H2z"
    })), children);
  });
  var Laptop20 = /*#__PURE__*/React__default['default'].forwardRef(function Laptop20(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$f || (_path303$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",
      transform: "translate(0 .005)"
    })), _path304$f || (_path304$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26.005H30V28.005H2z"
    })), children);
  });
  var Laptop16 = /*#__PURE__*/React__default['default'].forwardRef(function Laptop16(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$f || (_path305$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",
      transform: "translate(0 .005)"
    })), _path306$f || (_path306$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26.005H30V28.005H2z"
    })), children);
  });
  var Lasso32 = /*#__PURE__*/React__default['default'].forwardRef(function Lasso32(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$f || (_path307$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H12A9.9842,9.9842,0,0,0,7.0349,20.6553C7.0249,20.7705,7,20.8818,7,21a3.9929,3.9929,0,0,0,2.9106,3.83A4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,3.9966,3.9966,0,0,0,2.93-2.88H20A10,10,0,0,0,20,2ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm9-3H14.8579a3.9841,3.9841,0,0,0-7.15-1.2637A7.99,7.99,0,0,1,12,4h8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var Lasso24 = /*#__PURE__*/React__default['default'].forwardRef(function Lasso24(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$f || (_path308$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H12A9.9842,9.9842,0,0,0,7.0349,20.6553C7.0249,20.7705,7,20.8818,7,21a3.9929,3.9929,0,0,0,2.9106,3.83A4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,3.9966,3.9966,0,0,0,2.93-2.88H20A10,10,0,0,0,20,2ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm9-3H14.8579a3.9841,3.9841,0,0,0-7.15-1.2637A7.99,7.99,0,0,1,12,4h8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var Lasso20 = /*#__PURE__*/React__default['default'].forwardRef(function Lasso20(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$f || (_path309$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H12A9.9842,9.9842,0,0,0,7.0349,20.6553C7.0249,20.7705,7,20.8818,7,21a3.9929,3.9929,0,0,0,2.9106,3.83A4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,3.9966,3.9966,0,0,0,2.93-2.88H20A10,10,0,0,0,20,2ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm9-3H14.8579a3.9841,3.9841,0,0,0-7.15-1.2637A7.99,7.99,0,0,1,12,4h8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var Lasso16 = /*#__PURE__*/React__default['default'].forwardRef(function Lasso16(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$f || (_path310$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H12A9.9842,9.9842,0,0,0,7.0349,20.6553C7.0249,20.7705,7,20.8818,7,21a3.9929,3.9929,0,0,0,2.9106,3.83A4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,3.9966,3.9966,0,0,0,2.93-2.88H20A10,10,0,0,0,20,2ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm9-3H14.8579a3.9841,3.9841,0,0,0-7.15-1.2637A7.99,7.99,0,0,1,12,4h8a8,8,0,0,1,0,16Z"
    })), children);
  });
  var LassoPolygon32 = /*#__PURE__*/React__default['default'].forwardRef(function LassoPolygon32(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$f || (_path311$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.6245,2.2193a1.0005,1.0005,0,0,0-1.0972-.1006L17.9353,7.8,3.366,2.0694a1,1,0,0,0-1.28,1.3369l6.4353,14.479A3.965,3.965,0,0,0,9.9106,24.83,4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,4.0021,4.0021,0,0,0,2.93-2.88H23.24a2,2,0,0,0,1.9273-1.4649L29.9634,3.2676A1,1,0,0,0,29.6245,2.2193ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm12.24-3H14.8579a3.897,3.897,0,0,0-4.5117-2.9336L4.905,4.8238,18.0647,10,27.41,4.9878Z"
    })), children);
  });
  var LassoPolygon24 = /*#__PURE__*/React__default['default'].forwardRef(function LassoPolygon24(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$f || (_path312$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.6245,2.2193a1.0005,1.0005,0,0,0-1.0972-.1006L17.9353,7.8,3.366,2.0694a1,1,0,0,0-1.28,1.3369l6.4353,14.479A3.965,3.965,0,0,0,9.9106,24.83,4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,4.0021,4.0021,0,0,0,2.93-2.88H23.24a2,2,0,0,0,1.9273-1.4649L29.9634,3.2676A1,1,0,0,0,29.6245,2.2193ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm12.24-3H14.8579a3.897,3.897,0,0,0-4.5117-2.9336L4.905,4.8238,18.0647,10,27.41,4.9878Z"
    })), children);
  });
  var LassoPolygon20 = /*#__PURE__*/React__default['default'].forwardRef(function LassoPolygon20(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$f || (_path313$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.6245,2.2193a1.0005,1.0005,0,0,0-1.0972-.1006L17.9353,7.8,3.366,2.0694a1,1,0,0,0-1.28,1.3369l6.4353,14.479A3.965,3.965,0,0,0,9.9106,24.83,4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,4.0021,4.0021,0,0,0,2.93-2.88H23.24a2,2,0,0,0,1.9273-1.4649L29.9634,3.2676A1,1,0,0,0,29.6245,2.2193ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm12.24-3H14.8579a3.897,3.897,0,0,0-4.5117-2.9336L4.905,4.8238,18.0647,10,27.41,4.9878Z"
    })), children);
  });
  var LassoPolygon16 = /*#__PURE__*/React__default['default'].forwardRef(function LassoPolygon16(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$f || (_path314$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.6245,2.2193a1.0005,1.0005,0,0,0-1.0972-.1006L17.9353,7.8,3.366,2.0694a1,1,0,0,0-1.28,1.3369l6.4353,14.479A3.965,3.965,0,0,0,9.9106,24.83,4.0049,4.0049,0,0,1,6,28H4v2H6a6.0044,6.0044,0,0,0,5.928-5.12,4.0021,4.0021,0,0,0,2.93-2.88H23.24a2,2,0,0,0,1.9273-1.4649L29.9634,3.2676A1,1,0,0,0,29.6245,2.2193ZM11,23a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,11,23Zm12.24-3H14.8579a3.897,3.897,0,0,0-4.5117-2.9336L4.905,4.8238,18.0647,10,27.41,4.9878Z"
    })), children);
  });
  var Launch32 = /*#__PURE__*/React__default['default'].forwardRef(function Launch32(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$f || (_path315$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0027,2.0027,0,0,1-2-2V6A2.0027,2.0027,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0027,2.0027,0,0,1,26,28Z"
    })), _path316$f || (_path316$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 2L20 4 26.586 4 18 12.586 19.414 14 28 5.414 28 12 30 12 30 2 20 2z"
    })), children);
  });
  var Launch24 = /*#__PURE__*/React__default['default'].forwardRef(function Launch24(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$f || (_path317$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0027,2.0027,0,0,1-2-2V6A2.0027,2.0027,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0027,2.0027,0,0,1,26,28Z"
    })), _path318$f || (_path318$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 2L20 4 26.586 4 18 12.586 19.414 14 28 5.414 28 12 30 12 30 2 20 2z"
    })), children);
  });
  var Launch20 = /*#__PURE__*/React__default['default'].forwardRef(function Launch20(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$f || (_path319$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0027,2.0027,0,0,1-2-2V6A2.0027,2.0027,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0027,2.0027,0,0,1,26,28Z"
    })), _path320$f || (_path320$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 2L20 4 26.586 4 18 12.586 19.414 14 28 5.414 28 12 30 12 30 2 20 2z"
    })), children);
  });
  var Launch16 = /*#__PURE__*/React__default['default'].forwardRef(function Launch16(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$f || (_path321$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,14H3c-0.6,0-1-0.4-1-1V3c0-0.6,0.4-1,1-1h5v1H3v10h10V8h1v5C14,13.6,13.6,14,13,14z"
    })), _path322$f || (_path322$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 1L10 2 13.3 2 9 6.3 9.7 7 14 2.7 14 6 15 6 15 1z"
    })), children);
  });
  var WatsonHealthLaunchStudy_132 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_132(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle25$9 || (_circle25$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path323$f || (_path323$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"
    })), _path324$f || (_path324$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_124 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_124(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle26$9 || (_circle26$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path325$f || (_path325$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"
    })), _path326$f || (_path326$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_120 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_120(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle27$8 || (_circle27$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path327$f || (_path327$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"
    })), _path328$f || (_path328$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_116 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_116(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle28$8 || (_circle28$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path329$f || (_path329$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"
    })), _path330$f || (_path330$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_232 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_232(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29$8 || (_circle29$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "7",
      r: "1"
    })), _path331$f || (_path331$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4v6H6V4H26m0-2H6A2 2 0 004 4v6a2 2 0 002 2H26a2 2 0 002-2V4a2 2 0 00-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"
    })), _path332$f || (_path332$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_224 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_224(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle30$8 || (_circle30$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "7",
      r: "1"
    })), _path333$f || (_path333$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4v6H6V4H26m0-2H6A2 2 0 004 4v6a2 2 0 002 2H26a2 2 0 002-2V4a2 2 0 00-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"
    })), _path334$f || (_path334$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_220 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_220(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle31$8 || (_circle31$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "7",
      r: "1"
    })), _path335$f || (_path335$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4v6H6V4H26m0-2H6A2 2 0 004 4v6a2 2 0 002 2H26a2 2 0 002-2V4a2 2 0 00-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"
    })), _path336$f || (_path336$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_216 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_216(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle32$8 || (_circle32$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "7",
      r: "1"
    })), _path337$f || (_path337$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 4v6H6V4H26m0-2H6A2 2 0 004 4v6a2 2 0 002 2H26a2 2 0 002-2V4a2 2 0 00-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"
    })), _path338$e || (_path338$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_332 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_332(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle33$8 || (_circle33$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path339$e || (_path339$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"
    })), _path340$e || (_path340$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_324 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_324(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle34$7 || (_circle34$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path341$e || (_path341$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"
    })), _path342$e || (_path342$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_320 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_320(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle35$7 || (_circle35$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path343$e || (_path343$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"
    })), _path344$e || (_path344$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"
    })), children);
  });
  var WatsonHealthLaunchStudy_316 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthLaunchStudy_316(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle36$7 || (_circle36$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "25",
      r: "1"
    })), _path345$e || (_path345$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22v6H6V22H26m0-2H6a2 2 0 00-2 2v6a2 2 0 002 2H26a2 2 0 002-2V22a2 2 0 00-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"
    })), _path346$e || (_path346$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"
    })), children);
  });
  var Layers32 = /*#__PURE__*/React__default['default'].forwardRef(function Layers32(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$e || (_path347$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a.9967.9967,0,0,1-.4741-.12l-13-7L3.4741,15.12,16,21.8643,28.5259,15.12l.9482,1.7607-13,7A.9967.9967,0,0,1,16,24Z"
    })), _path348$e || (_path348$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30a.9967.9967 0 01-.4741-.12l-13-7L3.4741 21.12 16 27.8643 28.5259 21.12l.9482 1.7607-13 7A.9967.9967 0 0116 30zM16 18a.9967.9967 0 01-.4741-.12l-13-7a1 1 0 010-1.7607l13-7a.9982.9982 0 01.9482 0l13 7a1 1 0 010 1.7607l-13 7A.9967.9967 0 0116 18zM5.1094 10L16 15.8643 26.8906 10 16 4.1358z"
    })), children);
  });
  var Layers24 = /*#__PURE__*/React__default['default'].forwardRef(function Layers24(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$e || (_path349$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a.9967.9967,0,0,1-.4741-.12l-13-7L3.4741,15.12,16,21.8643,28.5259,15.12l.9482,1.7607-13,7A.9967.9967,0,0,1,16,24Z"
    })), _path350$e || (_path350$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30a.9967.9967 0 01-.4741-.12l-13-7L3.4741 21.12 16 27.8643 28.5259 21.12l.9482 1.7607-13 7A.9967.9967 0 0116 30zM16 18a.9967.9967 0 01-.4741-.12l-13-7a1 1 0 010-1.7607l13-7a.9982.9982 0 01.9482 0l13 7a1 1 0 010 1.7607l-13 7A.9967.9967 0 0116 18zM5.1094 10L16 15.8643 26.8906 10 16 4.1358z"
    })), children);
  });
  var Layers20 = /*#__PURE__*/React__default['default'].forwardRef(function Layers20(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$e || (_path351$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a.9967.9967,0,0,1-.4741-.12l-13-7L3.4741,15.12,16,21.8643,28.5259,15.12l.9482,1.7607-13,7A.9967.9967,0,0,1,16,24Z"
    })), _path352$e || (_path352$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30a.9967.9967 0 01-.4741-.12l-13-7L3.4741 21.12 16 27.8643 28.5259 21.12l.9482 1.7607-13 7A.9967.9967 0 0116 30zM16 18a.9967.9967 0 01-.4741-.12l-13-7a1 1 0 010-1.7607l13-7a.9982.9982 0 01.9482 0l13 7a1 1 0 010 1.7607l-13 7A.9967.9967 0 0116 18zM5.1094 10L16 15.8643 26.8906 10 16 4.1358z"
    })), children);
  });
  var Layers16 = /*#__PURE__*/React__default['default'].forwardRef(function Layers16(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$e || (_path353$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a.9967.9967,0,0,1-.4741-.12l-13-7L3.4741,15.12,16,21.8643,28.5259,15.12l.9482,1.7607-13,7A.9967.9967,0,0,1,16,24Z"
    })), _path354$e || (_path354$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30a.9967.9967 0 01-.4741-.12l-13-7L3.4741 21.12 16 27.8643 28.5259 21.12l.9482 1.7607-13 7A.9967.9967 0 0116 30zM16 18a.9967.9967 0 01-.4741-.12l-13-7a1 1 0 010-1.7607l13-7a.9982.9982 0 01.9482 0l13 7a1 1 0 010 1.7607l-13 7A.9967.9967 0 0116 18zM5.1094 10L16 15.8643 26.8906 10 16 4.1358z"
    })), children);
  });
  var Legend32 = /*#__PURE__*/React__default['default'].forwardRef(function Legend32(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$d || (_path355$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16z"
    })), _rect$2 || (_rect$2 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "6",
      height: "6",
      x: "4",
      y: "20",
      rx: "1"
    })), _path356$d || (_path356$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM9.5 12h-5a.5.5 0 01-.4473-.7236l2.5-5.0224a.5206.5206 0 01.8945 0l2.5 5.0225A.5.5 0 019.5 12z"
    })), children);
  });
  var Legend24 = /*#__PURE__*/React__default['default'].forwardRef(function Legend24(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$d || (_path357$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16z"
    })), _rect2$2 || (_rect2$2 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "6",
      height: "6",
      x: "4",
      y: "20",
      rx: "1"
    })), _path358$d || (_path358$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM9.5 12h-5a.5.5 0 01-.4473-.7236l2.5-5.0224a.5206.5206 0 01.8945 0l2.5 5.0225A.5.5 0 019.5 12z"
    })), children);
  });
  var Legend20 = /*#__PURE__*/React__default['default'].forwardRef(function Legend20(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$d || (_path359$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16z"
    })), _rect3$2 || (_rect3$2 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "6",
      height: "6",
      x: "4",
      y: "20",
      rx: "1"
    })), _path360$d || (_path360$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM9.5 12h-5a.5.5 0 01-.4473-.7236l2.5-5.0224a.5206.5206 0 01.8945 0l2.5 5.0225A.5.5 0 019.5 12z"
    })), children);
  });
  var Legend16 = /*#__PURE__*/React__default['default'].forwardRef(function Legend16(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$c || (_path361$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16z"
    })), _rect4$2 || (_rect4$2 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "6",
      height: "6",
      x: "4",
      y: "20",
      rx: "1"
    })), _path362$c || (_path362$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM9.5 12h-5a.5.5 0 01-.4473-.7236l2.5-5.0224a.5206.5206 0 01.8945 0l2.5 5.0225A.5.5 0 019.5 12z"
    })), children);
  });
  var LetterAa32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAa32(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$c || (_path363$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2 2 0 0023 13zm0 8H19V19h4zM13 9H9a2 2 0 00-2 2V23H9V18h4v5h2V11A2 2 0 0013 9zM9 16V11h4v5z"
    })), children);
  });
  var LetterAa24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAa24(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$c || (_path364$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2 2 0 0023 13zm0 8H19V19h4zM13 9H9a2 2 0 00-2 2V23H9V18h4v5h2V11A2 2 0 0013 9zM9 16V11h4v5z"
    })), children);
  });
  var LetterAa20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAa20(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$c || (_path365$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2 2 0 0023 13zm0 8H19V19h4zM13 9H9a2 2 0 00-2 2V23H9V18h4v5h2V11A2 2 0 0013 9zM9 16V11h4v5z"
    })), children);
  });
  var LetterAa16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAa16(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$c || (_path366$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H18v2h5v2H19a2 2 0 00-2 2v2a2 2 0 002 2h6V15A2 2 0 0023 13zm0 8H19V19h4zM13 9H9a2 2 0 00-2 2V23H9V18h4v5h2V11A2 2 0 0013 9zM9 16V11h4v5z"
    })), children);
  });
  var LetterAaLarge32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAaLarge32(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$f);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$5['LetterAaLarge32']) {
        didWarnAboutDeprecation$5['LetterAaLarge32'] = true;
        console.warn("The LetterAaLarge32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$c || (_path367$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var LetterAaLarge24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAaLarge24(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$f);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$5['LetterAaLarge24']) {
        didWarnAboutDeprecation$5['LetterAaLarge24'] = true;
        console.warn("The LetterAaLarge24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$c || (_path368$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var LetterAaLarge20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAaLarge20(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$f);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$5['LetterAaLarge20']) {
        didWarnAboutDeprecation$5['LetterAaLarge20'] = true;
        console.warn("The LetterAaLarge20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$c || (_path369$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var LetterAaLarge16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterAaLarge16(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$f);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$5['LetterAaLarge16']) {
        didWarnAboutDeprecation$5['LetterAaLarge16'] = true;
        console.warn("The LetterAaLarge16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$c || (_path370$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var LetterBb32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterBb32(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$c || (_path371$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H19V9H17V23h6a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM15 12a3 3 0 00-3-3H7V23h5a3 3 0 003-3V18a3 3 0 00-.78-2A3 3 0 0015 14zM9 11h3a1 1 0 011 1v2a1 1 0 01-1 1H9zm4 9a1 1 0 01-1 1H9V17h3a1 1 0 011 1z"
    })), children);
  });
  var LetterBb24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterBb24(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$c || (_path372$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H19V9H17V23h6a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM15 12a3 3 0 00-3-3H7V23h5a3 3 0 003-3V18a3 3 0 00-.78-2A3 3 0 0015 14zM9 11h3a1 1 0 011 1v2a1 1 0 01-1 1H9zm4 9a1 1 0 01-1 1H9V17h3a1 1 0 011 1z"
    })), children);
  });
  var LetterBb20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterBb20(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$c || (_path373$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H19V9H17V23h6a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM15 12a3 3 0 00-3-3H7V23h5a3 3 0 003-3V18a3 3 0 00-.78-2A3 3 0 0015 14zM9 11h3a1 1 0 011 1v2a1 1 0 01-1 1H9zm4 9a1 1 0 01-1 1H9V17h3a1 1 0 011 1z"
    })), children);
  });
  var LetterBb16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterBb16(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$c || (_path374$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H19V9H17V23h6a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM15 12a3 3 0 00-3-3H7V23h5a3 3 0 003-3V18a3 3 0 00-.78-2A3 3 0 0015 14zM9 11h3a1 1 0 011 1v2a1 1 0 01-1 1H9zm4 9a1 1 0 01-1 1H9V17h3a1 1 0 011 1z"
    })), children);
  });
  var LetterCc32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterCc32(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$c || (_path375$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 23H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v6h5zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var LetterCc24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterCc24(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$c || (_path376$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 23H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v6h5zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var LetterCc20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterCc20(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$c || (_path377$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 23H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v6h5zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var LetterCc16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterCc16(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$c || (_path378$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 23H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v6h5zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h6z"
    })), children);
  });
  var LetterDd32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterDd32(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$c || (_path379$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 9v4H19a2 2 0 00-2 2v6a2 2 0 002 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 014 4v6A4 4 0 0111 23zM9 21h2a2 2 0 002-2V13a2 2 0 00-2-2H9z"
    })), children);
  });
  var LetterDd24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterDd24(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$c || (_path380$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 9v4H19a2 2 0 00-2 2v6a2 2 0 002 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 014 4v6A4 4 0 0111 23zM9 21h2a2 2 0 002-2V13a2 2 0 00-2-2H9z"
    })), children);
  });
  var LetterDd20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterDd20(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$c || (_path381$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 9v4H19a2 2 0 00-2 2v6a2 2 0 002 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 014 4v6A4 4 0 0111 23zM9 21h2a2 2 0 002-2V13a2 2 0 00-2-2H9z"
    })), children);
  });
  var LetterDd16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterDd16(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$c || (_path382$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 9v4H19a2 2 0 00-2 2v6a2 2 0 002 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 014 4v6A4 4 0 0111 23zM9 21h2a2 2 0 002-2V13a2 2 0 00-2-2H9z"
    })), children);
  });
  var LetterEe32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterEe32(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$c || (_path383$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 19V15a2.0023 2.0023 0 00-2-2H19a2.0023 2.0023 0 00-2 2v6a2.0077 2.0077 0 002 2h5V21H19V19zm-6-4h4v2H19zM15 11L15 9 7 9 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11z"
    })), children);
  });
  var LetterEe24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterEe24(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$b || (_path384$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 19V15a2.0023 2.0023 0 00-2-2H19a2.0023 2.0023 0 00-2 2v6a2.0077 2.0077 0 002 2h5V21H19V19zm-6-4h4v2H19zM15 11L15 9 7 9 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11z"
    })), children);
  });
  var LetterEe20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterEe20(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$b || (_path385$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 19V15a2.0023 2.0023 0 00-2-2H19a2.0023 2.0023 0 00-2 2v6a2.0077 2.0077 0 002 2h5V21H19V19zm-6-4h4v2H19zM15 11L15 9 7 9 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11z"
    })), children);
  });
  var LetterEe16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterEe16(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$b || (_path386$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 19V15a2.0023 2.0023 0 00-2-2H19a2.0023 2.0023 0 00-2 2v6a2.0077 2.0077 0 002 2h5V21H19V19zm-6-4h4v2H19zM15 11L15 9 7 9 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11z"
    })), children);
  });
  var LetterFf32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterFf32(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$b || (_path387$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 00-2 2v2H17v2h2v8h2V15h3V13H21V11z"
    })), children);
  });
  var LetterFf24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterFf24(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$b || (_path388$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 00-2 2v2H17v2h2v8h2V15h3V13H21V11z"
    })), children);
  });
  var LetterFf20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterFf20(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$b || (_path389$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 00-2 2v2H17v2h2v8h2V15h3V13H21V11z"
    })), children);
  });
  var LetterFf16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterFf16(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$b || (_path390$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 00-2 2v2H17v2h2v8h2V15h3V13H21V11z"
    })), children);
  });
  var LetterGg32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterGg32(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$b || (_path391$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v2H18v2h5a2 2 0 002-2V13zm4 8H19V15h4zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h4V17H11V15h4z"
    })), children);
  });
  var LetterGg24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterGg24(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$b || (_path392$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v2H18v2h5a2 2 0 002-2V13zm4 8H19V15h4zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h4V17H11V15h4z"
    })), children);
  });
  var LetterGg20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterGg20(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$b || (_path393$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v2H18v2h5a2 2 0 002-2V13zm4 8H19V15h4zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h4V17H11V15h4z"
    })), children);
  });
  var LetterGg16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterGg16(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$b || (_path394$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v2H18v2h5a2 2 0 002-2V13zm4 8H19V15h4zM15 23H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9V21h4V17H11V15h4z"
    })), children);
  });
  var LetterHh32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterHh32(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$b || (_path395$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0023 13z"
    })), children);
  });
  var LetterHh24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterHh24(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$b || (_path396$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0023 13z"
    })), children);
  });
  var LetterHh20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterHh20(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$b || (_path397$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0023 13z"
    })), children);
  });
  var LetterHh16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterHh16(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$b || (_path398$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0023 13z"
    })), children);
  });
  var LetterIi32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterIi32(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$a || (_path399$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"
    })), children);
  });
  var LetterIi24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterIi24(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$a || (_path400$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"
    })), children);
  });
  var LetterIi20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterIi20(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$a || (_path401$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"
    })), children);
  });
  var LetterIi16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterIi16(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$a || (_path402$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"
    })), children);
  });
  var LetterJj32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterJj32(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$9 || (_path403$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9H22V11H20zM20 25H17v2h3a2 2 0 002-2V13H20zM14 23H10a2 2 0 01-2-2V19h2v2h4V9h2V21A2 2 0 0114 23z"
    })), children);
  });
  var LetterJj24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterJj24(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$9 || (_path404$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9H22V11H20zM20 25H17v2h3a2 2 0 002-2V13H20zM14 23H10a2 2 0 01-2-2V19h2v2h4V9h2V21A2 2 0 0114 23z"
    })), children);
  });
  var LetterJj20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterJj20(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$9 || (_path405$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9H22V11H20zM20 25H17v2h3a2 2 0 002-2V13H20zM14 23H10a2 2 0 01-2-2V19h2v2h4V9h2V21A2 2 0 0114 23z"
    })), children);
  });
  var LetterJj16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterJj16(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$9 || (_path406$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9H22V11H20zM20 25H17v2h3a2 2 0 002-2V13H20zM14 23H10a2 2 0 01-2-2V19h2v2h4V9h2V21A2 2 0 0114 23z"
    })), children);
  });
  var LetterKk32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterKk32(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$9 || (_path407$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"
    })), children);
  });
  var LetterKk24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterKk24(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$9 || (_path408$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"
    })), children);
  });
  var LetterKk20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterKk20(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$9 || (_path409$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"
    })), children);
  });
  var LetterKk16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterKk16(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$8 || (_path410$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"
    })), children);
  });
  var LetterLl32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterLl32(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$8 || (_path411$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 01-2-2V9h2V21h2z"
    })), children);
  });
  var LetterLl24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterLl24(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$8 || (_path412$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 01-2-2V9h2V21h2z"
    })), children);
  });
  var LetterLl20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterLl20(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$8 || (_path413$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 01-2-2V9h2V21h2z"
    })), children);
  });
  var LetterLl16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterLl16(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$8 || (_path414$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 01-2-2V9h2V21h2z"
    })), children);
  });
  var LetterMm32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterMm32(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$7 || (_path415$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0024 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"
    })), children);
  });
  var LetterMm24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterMm24(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path416$6 || (_path416$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0024 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"
    })), children);
  });
  var LetterMm20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterMm20(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$6 || (_path417$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0024 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"
    })), children);
  });

  var _path$f, _path2$f, _path3$f, _path4$f, _path5$f, _path6$f, _path7$f, _path8$f, _path9$f, _path10$f, _path11$f, _path12$f, _path13$f, _path14$f, _path15$f, _path16$f, _path17$f, _path18$f, _path19$f, _path20$f, _path21$f, _path22$f, _path23$f, _path24$f, _path25$f, _path26$f, _path27$f, _path28$f, _path29$f, _path30$f, _path31$f, _path32$f, _path33$f, _path34$f, _path35$f, _path36$f, _path37$f, _path38$f, _path39$f, _path40$f, _path41$f, _path42$f, _path43$f, _path44$f, _path45$f, _path46$f, _path47$f, _path48$f, _path49$f, _path50$f, _path51$f, _path52$f, _path53$f, _path54$f, _path55$f, _path56$f, _path57$f, _path58$f, _path59$f, _path60$f, _path61$f, _path62$f, _path63$f, _path64$f, _path65$f, _path66$f, _path67$f, _path68$f, _path69$f, _path70$f, _path71$f, _path72$f, _path73$f, _path74$f, _path75$f, _path76$f, _path77$f, _path78$f, _path79$f, _path80$f, _path81$f, _path82$f, _path83$f, _path84$f, _path85$f, _path86$f, _path87$f, _path88$f, _path89$f, _path90$f, _path91$f, _path92$f, _path93$f, _path94$f, _path95$f, _path96$f, _path97$f, _path98$f, _path99$f, _path100$f, _path101$f, _path102$f, _path103$f, _path104$f, _path105$f, _path106$f, _path107$f, _path108$f, _path109$f, _path110$f, _path111$f, _path112$f, _path113$f, _path114$f, _path115$f, _path116$f, _path117$f, _path118$f, _path119$f, _path120$f, _path121$f, _path122$f, _path123$f, _path124$f, _path125$f, _path126$f, _path127$f, _path128$f, _path129$f, _path130$f, _path131$f, _path132$f, _path133$f, _path134$f, _path135$f, _path136$f, _path137$f, _path138$f, _path139$f, _path140$f, _path141$f, _path142$f, _path143$f, _path144$f, _path145$f, _path146$f, _path147$f, _path148$f, _path149$f, _path150$f, _path151$f, _path152$f, _path153$f, _path154$f, _path155$f, _path156$f, _path157$f, _path158$f, _path159$f, _path160$f, _path161$f, _path162$f, _path163$f, _path164$f, _path165$f, _path166$f, _path167$f, _path168$f, _path169$f, _path170$f, _path171$f, _path172$f, _path173$f, _path174$f, _path175$f, _path176$f, _path177$e, _path178$e, _path179$e, _path180$e, _path181$e, _path182$e, _path183$e, _path184$e, _path185$e, _path186$e, _path187$e, _path188$e, _path189$e, _path190$e, _path191$e, _path192$e, _path193$e, _path194$e, _path195$e, _path196$e, _path197$e, _path198$e, _path199$e, _path200$e, _path201$e, _path202$e, _path203$e, _path204$e, _path205$e, _path206$e, _path207$e, _path208$e, _path209$e, _path210$e, _path211$e, _path212$e, _path213$e, _path214$e, _path215$e, _path216$e, _path217$e, _circle$e, _circle2$e, _path218$e, _circle3$e, _circle4$d, _path219$e, _circle5$c, _circle6$c, _path220$e, _circle7$c, _circle8$c, _path221$e, _path222$e, _path223$e, _path224$e, _path225$e, _path226$e, _path227$e, _path228$e, _path229$e, _path230$e, _path231$e, _path232$e, _path233$e, _path234$e, _path235$e, _path236$e, _path237$e, _path238$e, _path239$e, _path240$e, _path241$e, _path242$e, _path243$e, _path244$e, _path245$e, _path246$e, _path247$e, _path248$e, _path249$e, _path250$e, _path251$e, _path252$e, _path253$e, _path254$e, _path255$e, _path256$e, _path257$e, _path258$e, _path259$e, _path260$e, _path261$e, _path262$e, _path263$e, _path264$e, _path265$e, _path266$e, _path267$e, _path268$e, _path269$e, _path270$e, _path271$e, _path272$e, _path273$e, _path274$e, _path275$e, _path276$e, _path277$e, _path278$e, _path279$e, _path280$e, _path281$e, _path282$e, _path283$e, _path284$e, _path285$e, _path286$e, _path287$e, _path288$e, _path289$e, _path290$e, _path291$e, _path292$e, _path293$e, _path294$e, _path295$e, _path296$e, _path297$e, _path298$e, _path299$e, _path300$e, _path301$e, _path302$e, _circle9$c, _path303$e, _circle10$c, _path304$e, _circle11$b, _path305$e, _circle12$b, _circle13$b, _path306$e, _path307$e, _circle14$b, _path308$e, _path309$e, _circle15$b, _path310$e, _path311$e, _circle16$b, _path312$e, _path313$e, _path314$e, _path315$e, _path316$e, _path317$e, _path318$e, _path319$e, _path320$e, _path321$e, _path322$e, _path323$e, _path324$e, _path325$e, _path326$e, _path327$e, _path328$e, _path329$e, _path330$e, _path331$e, _path332$e, _path333$e, _path334$e, _path335$e, _path336$e, _path337$e, _path338$d, _path339$d, _path340$d, _path341$d, _path342$d, _path343$d, _path344$d, _path345$d, _path346$d, _circle17$a, _path347$d, _path348$d, _circle18$a, _path349$d, _path350$d, _circle19$a, _path351$d, _path352$d, _circle20$a, _path353$d, _path354$d, _path355$c, _path356$c, _path357$c, _path358$c, _path359$c, _path360$c, _path361$b, _path362$b, _path363$b, _path364$b, _path365$b, _path366$b, _path367$b, _path368$b, _path369$b, _path370$b, _path371$b, _path372$b, _path373$b, _path374$b, _path375$b, _path376$b, _path377$b, _circle21$a, _path378$b, _circle22$a, _path379$b, _circle23$9, _path380$b, _circle24$9, _path381$b, _path382$b, _path383$b, _path384$a, _path385$a, _path386$a, _path387$a, _path388$a, _path389$a, _path390$a, _path391$a, _path392$a, _path393$a, _path394$a, _path395$a, _path396$a, _path397$a, _path398$a, _path399$9, _path400$9, _path401$9, _path402$9, _path403$8, _path404$8, _path405$8, _path406$8, _path407$8, _path408$8, _path409$8, _circle25$8, _circle26$8;

  var _excluded$f = ["children"],
      _excluded2$f = ["children"],
      _excluded3$f = ["children"],
      _excluded4$f = ["children"],
      _excluded5$f = ["children"],
      _excluded6$f = ["children"],
      _excluded7$f = ["children"],
      _excluded8$f = ["children"],
      _excluded9$f = ["children"],
      _excluded10$f = ["children"],
      _excluded11$f = ["children"],
      _excluded12$f = ["children"],
      _excluded13$f = ["children"],
      _excluded14$f = ["children"],
      _excluded15$f = ["children"],
      _excluded16$f = ["children"],
      _excluded17$f = ["children"],
      _excluded18$f = ["children"],
      _excluded19$f = ["children"],
      _excluded20$f = ["children"],
      _excluded21$f = ["children"],
      _excluded22$f = ["children"],
      _excluded23$f = ["children"],
      _excluded24$f = ["children"],
      _excluded25$f = ["children"],
      _excluded26$f = ["children"],
      _excluded27$f = ["children"],
      _excluded28$f = ["children"],
      _excluded29$f = ["children"],
      _excluded30$f = ["children"],
      _excluded31$f = ["children"],
      _excluded32$f = ["children"],
      _excluded33$f = ["children"],
      _excluded34$f = ["children"],
      _excluded35$f = ["children"],
      _excluded36$f = ["children"],
      _excluded37$f = ["children"],
      _excluded38$f = ["children"],
      _excluded39$f = ["children"],
      _excluded40$f = ["children"],
      _excluded41$f = ["children"],
      _excluded42$f = ["children"],
      _excluded43$f = ["children"],
      _excluded44$f = ["children"],
      _excluded45$f = ["children"],
      _excluded46$f = ["children"],
      _excluded47$f = ["children"],
      _excluded48$f = ["children"],
      _excluded49$f = ["children"],
      _excluded50$f = ["children"],
      _excluded51$f = ["children"],
      _excluded52$f = ["children"],
      _excluded53$f = ["children"],
      _excluded54$f = ["children"],
      _excluded55$f = ["children"],
      _excluded56$f = ["children"],
      _excluded57$f = ["children"],
      _excluded58$f = ["children"],
      _excluded59$f = ["children"],
      _excluded60$f = ["children"],
      _excluded61$f = ["children"],
      _excluded62$f = ["children"],
      _excluded63$f = ["children"],
      _excluded64$f = ["children"],
      _excluded65$f = ["children"],
      _excluded66$f = ["children"],
      _excluded67$f = ["children"],
      _excluded68$f = ["children"],
      _excluded69$f = ["children"],
      _excluded70$f = ["children"],
      _excluded71$f = ["children"],
      _excluded72$f = ["children"],
      _excluded73$f = ["children"],
      _excluded74$f = ["children"],
      _excluded75$f = ["children"],
      _excluded76$f = ["children"],
      _excluded77$f = ["children"],
      _excluded78$f = ["children"],
      _excluded79$f = ["children"],
      _excluded80$f = ["children"],
      _excluded81$f = ["children"],
      _excluded82$f = ["children"],
      _excluded83$f = ["children"],
      _excluded84$f = ["children"],
      _excluded85$f = ["children"],
      _excluded86$f = ["children"],
      _excluded87$f = ["children"],
      _excluded88$f = ["children"],
      _excluded89$f = ["children"],
      _excluded90$f = ["children"],
      _excluded91$f = ["children"],
      _excluded92$f = ["children"],
      _excluded93$f = ["children"],
      _excluded94$f = ["children"],
      _excluded95$f = ["children"],
      _excluded96$f = ["children"],
      _excluded97$f = ["children"],
      _excluded98$f = ["children"],
      _excluded99$f = ["children"],
      _excluded100$f = ["children"],
      _excluded101$f = ["children"],
      _excluded102$f = ["children"],
      _excluded103$f = ["children"],
      _excluded104$f = ["children"],
      _excluded105$f = ["children"],
      _excluded106$f = ["children"],
      _excluded107$f = ["children"],
      _excluded108$f = ["children"],
      _excluded109$f = ["children"],
      _excluded110$f = ["children"],
      _excluded111$f = ["children"],
      _excluded112$f = ["children"],
      _excluded113$f = ["children"],
      _excluded114$f = ["children"],
      _excluded115$f = ["children"],
      _excluded116$f = ["children"],
      _excluded117$f = ["children"],
      _excluded118$f = ["children"],
      _excluded119$e = ["children"],
      _excluded120$e = ["children"],
      _excluded121$e = ["children"],
      _excluded122$e = ["children"],
      _excluded123$e = ["children"],
      _excluded124$e = ["children"],
      _excluded125$e = ["children"],
      _excluded126$e = ["children"],
      _excluded127$e = ["children"],
      _excluded128$e = ["children"],
      _excluded129$e = ["children"],
      _excluded130$e = ["children"],
      _excluded131$e = ["children"],
      _excluded132$e = ["children"],
      _excluded133$e = ["children"],
      _excluded134$e = ["children"],
      _excluded135$e = ["children"],
      _excluded136$e = ["children"],
      _excluded137$e = ["children"],
      _excluded138$e = ["children"],
      _excluded139$e = ["children"],
      _excluded140$e = ["children"],
      _excluded141$e = ["children"],
      _excluded142$e = ["children"],
      _excluded143$e = ["children"],
      _excluded144$e = ["children"],
      _excluded145$e = ["children"],
      _excluded146$e = ["children"],
      _excluded147$e = ["children"],
      _excluded148$e = ["children"],
      _excluded149$e = ["children"],
      _excluded150$e = ["children"],
      _excluded151$e = ["children"],
      _excluded152$e = ["children"],
      _excluded153$e = ["children"],
      _excluded154$e = ["children"],
      _excluded155$e = ["children"],
      _excluded156$e = ["children"],
      _excluded157$e = ["children"],
      _excluded158$e = ["children"],
      _excluded159$e = ["children"],
      _excluded160$e = ["children"],
      _excluded161$e = ["children"],
      _excluded162$e = ["children"],
      _excluded163$e = ["children"],
      _excluded164$e = ["children"],
      _excluded165$e = ["children"],
      _excluded166$e = ["children"],
      _excluded167$e = ["children"],
      _excluded168$e = ["children"],
      _excluded169$e = ["children"],
      _excluded170$e = ["children"],
      _excluded171$e = ["children"],
      _excluded172$e = ["children"],
      _excluded173$e = ["children"],
      _excluded174$e = ["children"],
      _excluded175$e = ["children"],
      _excluded176$e = ["children"],
      _excluded177$e = ["children"],
      _excluded178$e = ["children"],
      _excluded179$e = ["children"],
      _excluded180$e = ["children"],
      _excluded181$e = ["children"],
      _excluded182$e = ["children"],
      _excluded183$e = ["children"],
      _excluded184$e = ["children"],
      _excluded185$e = ["children"],
      _excluded186$e = ["children"],
      _excluded187$e = ["children"],
      _excluded188$e = ["children"],
      _excluded189$e = ["children"],
      _excluded190$e = ["children"],
      _excluded191$e = ["children"],
      _excluded192$e = ["children"],
      _excluded193$e = ["children"],
      _excluded194$e = ["children"],
      _excluded195$e = ["children"],
      _excluded196$e = ["children"],
      _excluded197$e = ["children"],
      _excluded198$e = ["children"],
      _excluded199$e = ["children"],
      _excluded200$e = ["children"],
      _excluded201$e = ["children"],
      _excluded202$e = ["children"],
      _excluded203$e = ["children"],
      _excluded204$e = ["children"],
      _excluded205$e = ["children"],
      _excluded206$e = ["children"],
      _excluded207$e = ["children"],
      _excluded208$e = ["children"],
      _excluded209$e = ["children"],
      _excluded210$e = ["children"],
      _excluded211$e = ["children"],
      _excluded212$e = ["children"],
      _excluded213$e = ["children"],
      _excluded214$e = ["children"],
      _excluded215$e = ["children"],
      _excluded216$e = ["children"],
      _excluded217$e = ["children"],
      _excluded218$e = ["children"],
      _excluded219$e = ["children"],
      _excluded220$e = ["children"],
      _excluded221$e = ["children"],
      _excluded222$e = ["children"],
      _excluded223$e = ["children"],
      _excluded224$e = ["children"],
      _excluded225$e = ["children"],
      _excluded226$e = ["children"],
      _excluded227$e = ["children"],
      _excluded228$e = ["children"],
      _excluded229$e = ["children"],
      _excluded230$e = ["children"],
      _excluded231$e = ["children"],
      _excluded232$e = ["children"],
      _excluded233$e = ["children"],
      _excluded234$e = ["children"],
      _excluded235$e = ["children"],
      _excluded236$e = ["children"],
      _excluded237$e = ["children"],
      _excluded238$e = ["children"],
      _excluded239$e = ["children"],
      _excluded240$e = ["children"],
      _excluded241$e = ["children"],
      _excluded242$e = ["children"],
      _excluded243$e = ["children"],
      _excluded244$e = ["children"],
      _excluded245$e = ["children"],
      _excluded246$e = ["children"],
      _excluded247$e = ["children"],
      _excluded248$e = ["children"],
      _excluded249$e = ["children"],
      _excluded250$e = ["children"];
  var didWarnAboutDeprecation$4 = {};
  var LetterMm16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterMm16(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$f || (_path$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0024 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"
    })), children);
  });
  var LetterNn32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterNn32(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$f || (_path2$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H23V15H19v8H17V13h6a2 2 0 012 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"
    })), children);
  });
  var LetterNn24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterNn24(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$f || (_path3$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H23V15H19v8H17V13h6a2 2 0 012 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"
    })), children);
  });
  var LetterNn20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterNn20(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$f || (_path4$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H23V15H19v8H17V13h6a2 2 0 012 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"
    })), children);
  });
  var LetterNn16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterNn16(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$f || (_path5$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H23V15H19v8H17V13h6a2 2 0 012 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"
    })), children);
  });
  var LetterOo32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterOo32(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$f || (_path6$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V15a2 2 0 012-2h4a2 2 0 012 2v6A2 2 0 0123 23zm-4-8v6h4V15zM13 23H9a2 2 0 01-2-2V11A2 2 0 019 9h4a2 2 0 012 2V21A2 2 0 0113 23zM9 11V21h4V11z"
    })), children);
  });
  var LetterOo24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterOo24(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$f || (_path7$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V15a2 2 0 012-2h4a2 2 0 012 2v6A2 2 0 0123 23zm-4-8v6h4V15zM13 23H9a2 2 0 01-2-2V11A2 2 0 019 9h4a2 2 0 012 2V21A2 2 0 0113 23zM9 11V21h4V11z"
    })), children);
  });
  var LetterOo20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterOo20(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$f || (_path8$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V15a2 2 0 012-2h4a2 2 0 012 2v6A2 2 0 0123 23zm-4-8v6h4V15zM13 23H9a2 2 0 01-2-2V11A2 2 0 019 9h4a2 2 0 012 2V21A2 2 0 0113 23zM9 11V21h4V11z"
    })), children);
  });
  var LetterOo16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterOo16(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$f || (_path9$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V15a2 2 0 012-2h4a2 2 0 012 2v6A2 2 0 0123 23zm-4-8v6h4V15zM13 23H9a2 2 0 01-2-2V11A2 2 0 019 9h4a2 2 0 012 2V21A2 2 0 0113 23zM9 11V21h4V11z"
    })), children);
  });
  var LetterPp32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterPp32(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$f || (_path10$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H17V27h2V23h4a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 012 2v5a2 2 0 01-2 2H9zm0-7h4V11H9z"
    })), children);
  });
  var LetterPp24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterPp24(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$f || (_path11$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H17V27h2V23h4a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 012 2v5a2 2 0 01-2 2H9zm0-7h4V11H9z"
    })), children);
  });
  var LetterPp20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterPp20(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$f || (_path12$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H17V27h2V23h4a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 012 2v5a2 2 0 01-2 2H9zm0-7h4V11H9z"
    })), children);
  });
  var LetterPp16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterPp16(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$f || (_path13$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 13H17V27h2V23h4a2 2 0 002-2V15A2 2 0 0023 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 012 2v5a2 2 0 01-2 2H9zm0-7h4V11H9z"
    })), children);
  });
  var LetterQq32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterQq32(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$f || (_path14$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H12V23h1a2 2 0 002-2V11A2 2 0 0013 9zM9 21V11h4V21z"
    })), children);
  });
  var LetterQq24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterQq24(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$f || (_path15$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H12V23h1a2 2 0 002-2V11A2 2 0 0013 9zM9 21V11h4V21z"
    })), children);
  });
  var LetterQq20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterQq20(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$f || (_path16$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H12V23h1a2 2 0 002-2V11A2 2 0 0013 9zM9 21V11h4V21z"
    })), children);
  });
  var LetterQq16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterQq16(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$f || (_path17$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13a2 2 0 00-2 2v6a2 2 0 002 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H12V23h1a2 2 0 002-2V11A2 2 0 0013 9zM9 21V11h4V21z"
    })), children);
  });
  var LetterRr32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterRr32(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$f || (_path18$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 15V11a2 2 0 00-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0016 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"
    })), children);
  });
  var LetterRr24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterRr24(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$f || (_path19$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 15V11a2 2 0 00-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0016 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"
    })), children);
  });
  var LetterRr20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterRr20(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$f || (_path20$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 15V11a2 2 0 00-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0016 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"
    })), children);
  });
  var LetterRr16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterRr16(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$f || (_path21$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 15V11a2 2 0 00-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0016 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"
    })), children);
  });
  var LetterSs32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterSs32(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$f || (_path22$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23H17V21h5V19H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v2h3a2 2 0 012 2v2A2 2 0 0122 23zM13 23H7V21h6V17H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9v4h4a2 2 0 012 2v4A2 2 0 0113 23z"
    })), children);
  });
  var LetterSs24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterSs24(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$f || (_path23$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23H17V21h5V19H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v2h3a2 2 0 012 2v2A2 2 0 0122 23zM13 23H7V21h6V17H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9v4h4a2 2 0 012 2v4A2 2 0 0113 23z"
    })), children);
  });
  var LetterSs20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterSs20(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$f || (_path24$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23H17V21h5V19H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v2h3a2 2 0 012 2v2A2 2 0 0122 23zM13 23H7V21h6V17H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9v4h4a2 2 0 012 2v4A2 2 0 0113 23z"
    })), children);
  });
  var LetterSs16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterSs16(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$f || (_path25$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23H17V21h5V19H19a2 2 0 01-2-2V15a2 2 0 012-2h5v2H19v2h3a2 2 0 012 2v2A2 2 0 0122 23zM13 23H7V21h6V17H9a2 2 0 01-2-2V11A2 2 0 019 9h6v2H9v4h4a2 2 0 012 2v4A2 2 0 0113 23z"
    })), children);
  });
  var LetterTt32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterTt32(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$f || (_path26$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 002 2h3V21H20V15z"
    })), children);
  });
  var LetterTt24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterTt24(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$f || (_path27$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 002 2h3V21H20V15z"
    })), children);
  });
  var LetterTt20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterTt20(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$f || (_path28$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 002 2h3V21H20V15z"
    })), children);
  });
  var LetterTt16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterTt16(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$f || (_path29$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 002 2h3V21H20V15z"
    })), children);
  });
  var LetterUu32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterUu32(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$f || (_path30$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V13h2v8h4V13h2v8A2 2 0 0123 23zM13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23z"
    })), children);
  });
  var LetterUu24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterUu24(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$f || (_path31$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V13h2v8h4V13h2v8A2 2 0 0123 23zM13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23z"
    })), children);
  });
  var LetterUu20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterUu20(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$f || (_path32$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V13h2v8h4V13h2v8A2 2 0 0123 23zM13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23z"
    })), children);
  });
  var LetterUu16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterUu16(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$f || (_path33$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 23H19a2 2 0 01-2-2V13h2v8h4V13h2v8A2 2 0 0123 23zM13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23z"
    })), children);
  });
  var LetterVv32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterVv32(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$f || (_path34$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"
    })), children);
  });
  var LetterVv24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterVv24(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$f || (_path35$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"
    })), children);
  });
  var LetterVv20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterVv20(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$f || (_path36$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"
    })), children);
  });
  var LetterVv16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterVv16(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$f || (_path37$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"
    })), children);
  });
  var LetterWw32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterWw32(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$f || (_path38$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"
    })), children);
  });
  var LetterWw24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterWw24(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$f || (_path39$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"
    })), children);
  });
  var LetterWw20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterWw20(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$f || (_path40$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"
    })), children);
  });
  var LetterWw16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterWw16(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$f || (_path41$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"
    })), children);
  });
  var LetterXx32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterXx32(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$f || (_path42$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"
    })), children);
  });
  var LetterXx24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterXx24(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$f || (_path43$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"
    })), children);
  });
  var LetterXx20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterXx20(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$f || (_path44$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"
    })), children);
  });
  var LetterXx16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterXx16(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$f || (_path45$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"
    })), children);
  });
  var LetterYy32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterYy32(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$f || (_path46$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 001.91-1.42L25 13z"
    })), children);
  });
  var LetterYy24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterYy24(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$f || (_path47$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 001.91-1.42L25 13z"
    })), children);
  });
  var LetterYy20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterYy20(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$f || (_path48$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 001.91-1.42L25 13z"
    })), children);
  });
  var LetterYy16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterYy16(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$f || (_path49$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 001.91-1.42L25 13z"
    })), children);
  });
  var LetterZz32 = /*#__PURE__*/React__default['default'].forwardRef(function LetterZz32(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$f || (_path50$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"
    })), children);
  });
  var LetterZz24 = /*#__PURE__*/React__default['default'].forwardRef(function LetterZz24(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$f || (_path51$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"
    })), children);
  });
  var LetterZz20 = /*#__PURE__*/React__default['default'].forwardRef(function LetterZz20(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$f || (_path52$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"
    })), children);
  });
  var LetterZz16 = /*#__PURE__*/React__default['default'].forwardRef(function LetterZz16(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$f || (_path53$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"
    })), children);
  });
  var License32 = /*#__PURE__*/React__default['default'].forwardRef(function License32(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$f || (_path54$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H22V8H10zM10 10H22V12H10zM10 24H16V26H10zM10 14H16V16H10z"
    })), _path55$f || (_path55$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,24,30ZM8,4V28H24V4Z"
    })), children);
  });
  var License24 = /*#__PURE__*/React__default['default'].forwardRef(function License24(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$f || (_path56$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H22V8H10zM10 10H22V12H10zM10 24H16V26H10zM10 14H16V16H10z"
    })), _path57$f || (_path57$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,24,30ZM8,4V28H24V4Z"
    })), children);
  });
  var License20 = /*#__PURE__*/React__default['default'].forwardRef(function License20(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$f || (_path58$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H22V8H10zM10 10H22V12H10zM10 24H16V26H10zM10 14H16V16H10z"
    })), _path59$f || (_path59$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,24,30ZM8,4V28H24V4Z"
    })), children);
  });
  var License16 = /*#__PURE__*/React__default['default'].forwardRef(function License16(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$f || (_path60$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H22V8H10zM10 10H22V12H10zM10 24H16V26H10zM10 14H16V16H10z"
    })), _path61$f || (_path61$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V28A2.0023,2.0023,0,0,1,24,30ZM8,4V28H24V4Z"
    })), children);
  });
  var LicenseDraft32 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseDraft32(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$f || (_path62$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path63$f || (_path63$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM12 30H6a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 016 2H22a2.0021 2.0021 0 012 2V14H22V4H6V28h6z"
    })), children);
  });
  var LicenseDraft24 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseDraft24(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$f || (_path64$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path65$f || (_path65$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM12 30H6a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 016 2H22a2.0021 2.0021 0 012 2V14H22V4H6V28h6z"
    })), children);
  });
  var LicenseDraft20 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseDraft20(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$f || (_path66$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path67$f || (_path67$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM12 30H6a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 016 2H22a2.0021 2.0021 0 012 2V14H22V4H6V28h6z"
    })), children);
  });
  var LicenseDraft16 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseDraft16(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$f || (_path68$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 6H20V8H8zM8 10H20V12H8zM8 14H14V16H8zM8 24H12V26H8z"
    })), _path69$f || (_path69$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM12 30H6a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 016 2H22a2.0021 2.0021 0 012 2V14H22V4H6V28h6z"
    })), children);
  });
  var LicenseGlobal32 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseGlobal32(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$f || (_path70$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 14a8 8 0 108 8A8.0092 8.0092 0 0022 14zm5.91 7H25.9563a12.03 12.03 0 00-1.2183-4.3325A6.01 6.01 0 0127.91 21zm-7.8545 0A10.0135 10.0135 0 0122 16.0146 10.0121 10.0121 0 0123.9448 21zm3.89 2A10.01 10.01 0 0122 27.9854 10.0121 10.0121 0 0120.0552 23zm-4.6831-6.332A12.0265 12.0265 0 0018.0435 21H16.09A6.01 6.01 0 0119.2617 16.668zM16.09 23h1.9532a12.0265 12.0265 0 001.2182 4.332A6.01 6.01 0 0116.09 23zm8.6482 4.332A12.0242 12.0242 0 0025.9565 23H27.91A6.0088 6.0088 0 0124.7385 27.332zM6 14H12V16H6zM6 6H18V8H6zM6 10H18V12H6zM6 24H12V26H6z"
    })), _path71$f || (_path71$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H20a2.0021,2.0021,0,0,1,2,2v8H20V4H4V28h8Z"
    })), children);
  });
  var LicenseGlobal24 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseGlobal24(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$f || (_path72$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 14a8 8 0 108 8A8.0092 8.0092 0 0022 14zm5.91 7H25.9563a12.03 12.03 0 00-1.2183-4.3325A6.01 6.01 0 0127.91 21zm-7.8545 0A10.0135 10.0135 0 0122 16.0146 10.0121 10.0121 0 0123.9448 21zm3.89 2A10.01 10.01 0 0122 27.9854 10.0121 10.0121 0 0120.0552 23zm-4.6831-6.332A12.0265 12.0265 0 0018.0435 21H16.09A6.01 6.01 0 0119.2617 16.668zM16.09 23h1.9532a12.0265 12.0265 0 001.2182 4.332A6.01 6.01 0 0116.09 23zm8.6482 4.332A12.0242 12.0242 0 0025.9565 23H27.91A6.0088 6.0088 0 0124.7385 27.332zM6 14H12V16H6zM6 6H18V8H6zM6 10H18V12H6zM6 24H12V26H6z"
    })), _path73$f || (_path73$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H20a2.0021,2.0021,0,0,1,2,2v8H20V4H4V28h8Z"
    })), children);
  });
  var LicenseGlobal20 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseGlobal20(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$f || (_path74$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 14a8 8 0 108 8A8.0092 8.0092 0 0022 14zm5.91 7H25.9563a12.03 12.03 0 00-1.2183-4.3325A6.01 6.01 0 0127.91 21zm-7.8545 0A10.0135 10.0135 0 0122 16.0146 10.0121 10.0121 0 0123.9448 21zm3.89 2A10.01 10.01 0 0122 27.9854 10.0121 10.0121 0 0120.0552 23zm-4.6831-6.332A12.0265 12.0265 0 0018.0435 21H16.09A6.01 6.01 0 0119.2617 16.668zM16.09 23h1.9532a12.0265 12.0265 0 001.2182 4.332A6.01 6.01 0 0116.09 23zm8.6482 4.332A12.0242 12.0242 0 0025.9565 23H27.91A6.0088 6.0088 0 0124.7385 27.332zM6 14H12V16H6zM6 6H18V8H6zM6 10H18V12H6zM6 24H12V26H6z"
    })), _path75$f || (_path75$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H20a2.0021,2.0021,0,0,1,2,2v8H20V4H4V28h8Z"
    })), children);
  });
  var LicenseGlobal16 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseGlobal16(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$f || (_path76$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 14a8 8 0 108 8A8.0092 8.0092 0 0022 14zm5.91 7H25.9563a12.03 12.03 0 00-1.2183-4.3325A6.01 6.01 0 0127.91 21zm-7.8545 0A10.0135 10.0135 0 0122 16.0146 10.0121 10.0121 0 0123.9448 21zm3.89 2A10.01 10.01 0 0122 27.9854 10.0121 10.0121 0 0120.0552 23zm-4.6831-6.332A12.0265 12.0265 0 0018.0435 21H16.09A6.01 6.01 0 0119.2617 16.668zM16.09 23h1.9532a12.0265 12.0265 0 001.2182 4.332A6.01 6.01 0 0116.09 23zm8.6482 4.332A12.0242 12.0242 0 0025.9565 23H27.91A6.0088 6.0088 0 0124.7385 27.332zM6 14H12V16H6zM6 6H18V8H6zM6 10H18V12H6zM6 24H12V26H6z"
    })), _path77$f || (_path77$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H20a2.0021,2.0021,0,0,1,2,2v8H20V4H4V28h8Z"
    })), children);
  });
  var LicenseMaintenance32 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenance32(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$f || (_path78$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM30 24V22H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 18.1011V16H22v2.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 22H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 27.8989V30h2V27.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 24zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 26z"
    })), _path79$f || (_path79$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseMaintenance24 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenance24(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$f || (_path80$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM30 24V22H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 18.1011V16H22v2.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 22H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 27.8989V30h2V27.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 24zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 26z"
    })), _path81$f || (_path81$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseMaintenance20 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenance20(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$f || (_path82$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM30 24V22H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 18.1011V16H22v2.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 22H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 27.8989V30h2V27.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 24zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 26z"
    })), _path83$f || (_path83$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseMaintenance16 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenance16(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$f || (_path84$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM30 24V22H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 18.1011V16H22v2.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 22H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 27.8989V30h2V27.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 24zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 26z"
    })), _path85$f || (_path85$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseMaintenanceDraft32 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenanceDraft32(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$f || (_path86$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM20 13V11H17.8579a3.94 3.94 0 00-.4248-1.019L18.95 8.4644 17.5356 7.05 16.019 8.5669A3.9443 3.9443 0 0015 8.1421V6H13V8.1421a3.9443 3.9443 0 00-1.019.4248L10.4644 7.05 9.05 8.4644 10.5669 9.981A3.94 3.94 0 0010.1421 11H8v2h2.1421a3.94 3.94 0 00.4248 1.019L9.05 15.5356 10.4644 16.95l1.5166-1.5166A3.9443 3.9443 0 0013 15.8579V18h2V15.8579a3.9443 3.9443 0 001.019-.4248L17.5356 16.95 18.95 15.5356 17.4331 14.019A3.94 3.94 0 0017.8579 13zm-6 1a2 2 0 112-2A2.0025 2.0025 0 0114 14z"
    })), _path87$f || (_path87$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseMaintenanceDraft24 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenanceDraft24(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$f || (_path88$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM20 13V11H17.8579a3.94 3.94 0 00-.4248-1.019L18.95 8.4644 17.5356 7.05 16.019 8.5669A3.9443 3.9443 0 0015 8.1421V6H13V8.1421a3.9443 3.9443 0 00-1.019.4248L10.4644 7.05 9.05 8.4644 10.5669 9.981A3.94 3.94 0 0010.1421 11H8v2h2.1421a3.94 3.94 0 00.4248 1.019L9.05 15.5356 10.4644 16.95l1.5166-1.5166A3.9443 3.9443 0 0013 15.8579V18h2V15.8579a3.9443 3.9443 0 001.019-.4248L17.5356 16.95 18.95 15.5356 17.4331 14.019A3.94 3.94 0 0017.8579 13zm-6 1a2 2 0 112-2A2.0025 2.0025 0 0114 14z"
    })), _path89$f || (_path89$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseMaintenanceDraft20 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenanceDraft20(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$f || (_path90$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM20 13V11H17.8579a3.94 3.94 0 00-.4248-1.019L18.95 8.4644 17.5356 7.05 16.019 8.5669A3.9443 3.9443 0 0015 8.1421V6H13V8.1421a3.9443 3.9443 0 00-1.019.4248L10.4644 7.05 9.05 8.4644 10.5669 9.981A3.94 3.94 0 0010.1421 11H8v2h2.1421a3.94 3.94 0 00.4248 1.019L9.05 15.5356 10.4644 16.95l1.5166-1.5166A3.9443 3.9443 0 0013 15.8579V18h2V15.8579a3.9443 3.9443 0 001.019-.4248L17.5356 16.95 18.95 15.5356 17.4331 14.019A3.94 3.94 0 0017.8579 13zm-6 1a2 2 0 112-2A2.0025 2.0025 0 0114 14z"
    })), _path91$f || (_path91$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseMaintenanceDraft16 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseMaintenanceDraft16(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$f || (_path92$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM20 13V11H17.8579a3.94 3.94 0 00-.4248-1.019L18.95 8.4644 17.5356 7.05 16.019 8.5669A3.9443 3.9443 0 0015 8.1421V6H13V8.1421a3.9443 3.9443 0 00-1.019.4248L10.4644 7.05 9.05 8.4644 10.5669 9.981A3.94 3.94 0 0010.1421 11H8v2h2.1421a3.94 3.94 0 00.4248 1.019L9.05 15.5356 10.4644 16.95l1.5166-1.5166A3.9443 3.9443 0 0013 15.8579V18h2V15.8579a3.9443 3.9443 0 001.019-.4248L17.5356 16.95 18.95 15.5356 17.4331 14.019A3.94 3.94 0 0017.8579 13zm-6 1a2 2 0 112-2A2.0025 2.0025 0 0114 14z"
    })), _path93$f || (_path93$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseThirdParty32 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdParty32(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$f || (_path94$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM24 24a4 4 0 10-4-4A4 4 0 0024 24zm0-6a2 2 0 11-2 2A2 2 0 0124 18z"
    })), _path95$f || (_path95$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseThirdParty24 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdParty24(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$f || (_path96$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM24 24a4 4 0 10-4-4A4 4 0 0024 24zm0-6a2 2 0 11-2 2A2 2 0 0124 18z"
    })), _path97$f || (_path97$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseThirdParty20 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdParty20(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$f || (_path98$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM24 24a4 4 0 10-4-4A4 4 0 0024 24zm0-6a2 2 0 11-2 2A2 2 0 0124 18z"
    })), _path99$f || (_path99$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseThirdParty16 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdParty16(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$f || (_path100$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 14H14V16H8zM8 6H20V8H8zM8 10H20V12H8zM8 24H14V26H8zM27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM24 24a4 4 0 10-4-4A4 4 0 0024 24zm0-6a2 2 0 11-2 2A2 2 0 0124 18z"
    })), _path101$f || (_path101$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h8Z"
    })), children);
  });
  var LicenseThirdPartyDraft32 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdPartyDraft32(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$f || (_path102$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM17 15H11a3 3 0 00-3 3v1h2V18a1 1 0 011-1h6a1 1 0 011 1v1h2V18A3 3 0 0017 15zM14 14a4 4 0 10-4-4A4 4 0 0014 14zm0-6a2 2 0 11-2 2A2 2 0 0114 8z"
    })), _path103$f || (_path103$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseThirdPartyDraft24 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdPartyDraft24(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$f || (_path104$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM17 15H11a3 3 0 00-3 3v1h2V18a1 1 0 011-1h6a1 1 0 011 1v1h2V18A3 3 0 0017 15zM14 14a4 4 0 10-4-4A4 4 0 0014 14zm0-6a2 2 0 11-2 2A2 2 0 0114 8z"
    })), _path105$f || (_path105$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseThirdPartyDraft20 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdPartyDraft20(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$f || (_path106$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM17 15H11a3 3 0 00-3 3v1h2V18a1 1 0 011-1h6a1 1 0 011 1v1h2V18A3 3 0 0017 15zM14 14a4 4 0 10-4-4A4 4 0 0014 14zm0-6a2 2 0 11-2 2A2 2 0 0114 8z"
    })), _path107$f || (_path107$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var LicenseThirdPartyDraft16 = /*#__PURE__*/React__default['default'].forwardRef(function LicenseThirdPartyDraft16(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$f || (_path108$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM17 15H11a3 3 0 00-3 3v1h2V18a1 1 0 011-1h6a1 1 0 011 1v1h2V18A3 3 0 0017 15zM14 14a4 4 0 10-4-4A4 4 0 0014 14zm0-6a2 2 0 11-2 2A2 2 0 0114 8z"
    })), _path109$f || (_path109$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H6a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V14H22V4H6V28h6Z"
    })), children);
  });
  var Lifesaver32 = /*#__PURE__*/React__default['default'].forwardRef(function Lifesaver32(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$f || (_path110$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.2261,22.812a13.9664,13.9664,0,0,0,0-13.624L28.4141,9a2.0021,2.0021,0,0,0,0-2.8281l-2.5857-2.586a2.0028,2.0028,0,0,0-2.8284,0l-.1877.1875a13.9687,13.9687,0,0,0-13.6243,0L9,3.5859a2.0024,2.0024,0,0,0-2.8284,0L3.5859,6.1719A2.0021,2.0021,0,0,0,3.5859,9l.1878.1875a13.97,13.97,0,0,0,0,13.625L3.5859,23a2.0021,2.0021,0,0,0,0,2.8281l2.5857,2.586a2.0021,2.0021,0,0,0,2.8284,0l.188-.188a13.9687,13.9687,0,0,0,13.6243.0005L23,28.4141a2.0021,2.0021,0,0,0,2.8284,0l2.5857-2.586a2.0021,2.0021,0,0,0,0-2.8281ZM28,16a11.973,11.973,0,0,1-1.2546,5.3315l-3.8948-3.895a6.9808,6.9808,0,0,0,0-2.873l3.8948-3.895A11.973,11.973,0,0,1,28,16ZM27,7.5859l-4.9346,4.9346A7.0434,7.0434,0,0,0,19.48,9.9346L24.4143,5ZM16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21ZM21.3154,5.2705,17.4365,9.1494a6.9808,6.9808,0,0,0-2.873,0L10.6846,5.2705A12.2484,12.2484,0,0,1,21.3154,5.2705ZM7.5859,5l4.9346,4.9346a7.0449,7.0449,0,0,0-2.5859,2.5859L5,7.5859ZM4,16a11.9716,11.9716,0,0,1,1.2546-5.3311l3.8948,3.8946a6.9808,6.9808,0,0,0,0,2.873L5.2546,21.3311A11.9716,11.9716,0,0,1,4,16ZM7.5857,27,5,24.4141,9.9346,19.48a7.0434,7.0434,0,0,0,2.5859,2.5859Zm3.0989-.27,3.8789-3.8789a6.9808,6.9808,0,0,0,2.873,0L21.3154,26.73A12.2484,12.2484,0,0,1,10.6846,26.73Zm13.73.27L19.48,22.0654A7.0449,7.0449,0,0,0,22.0654,19.48L27,24.4141Z"
    })), children);
  });
  var Lifesaver24 = /*#__PURE__*/React__default['default'].forwardRef(function Lifesaver24(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$f || (_path111$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.2261,22.812a13.9664,13.9664,0,0,0,0-13.624L28.4141,9a2.0021,2.0021,0,0,0,0-2.8281l-2.5857-2.586a2.0028,2.0028,0,0,0-2.8284,0l-.1877.1875a13.9687,13.9687,0,0,0-13.6243,0L9,3.5859a2.0024,2.0024,0,0,0-2.8284,0L3.5859,6.1719A2.0021,2.0021,0,0,0,3.5859,9l.1878.1875a13.97,13.97,0,0,0,0,13.625L3.5859,23a2.0021,2.0021,0,0,0,0,2.8281l2.5857,2.586a2.0021,2.0021,0,0,0,2.8284,0l.188-.188a13.9687,13.9687,0,0,0,13.6243.0005L23,28.4141a2.0021,2.0021,0,0,0,2.8284,0l2.5857-2.586a2.0021,2.0021,0,0,0,0-2.8281ZM28,16a11.973,11.973,0,0,1-1.2546,5.3315l-3.8948-3.895a6.9808,6.9808,0,0,0,0-2.873l3.8948-3.895A11.973,11.973,0,0,1,28,16ZM27,7.5859l-4.9346,4.9346A7.0434,7.0434,0,0,0,19.48,9.9346L24.4143,5ZM16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21ZM21.3154,5.2705,17.4365,9.1494a6.9808,6.9808,0,0,0-2.873,0L10.6846,5.2705A12.2484,12.2484,0,0,1,21.3154,5.2705ZM7.5859,5l4.9346,4.9346a7.0449,7.0449,0,0,0-2.5859,2.5859L5,7.5859ZM4,16a11.9716,11.9716,0,0,1,1.2546-5.3311l3.8948,3.8946a6.9808,6.9808,0,0,0,0,2.873L5.2546,21.3311A11.9716,11.9716,0,0,1,4,16ZM7.5857,27,5,24.4141,9.9346,19.48a7.0434,7.0434,0,0,0,2.5859,2.5859Zm3.0989-.27,3.8789-3.8789a6.9808,6.9808,0,0,0,2.873,0L21.3154,26.73A12.2484,12.2484,0,0,1,10.6846,26.73Zm13.73.27L19.48,22.0654A7.0449,7.0449,0,0,0,22.0654,19.48L27,24.4141Z"
    })), children);
  });
  var Lifesaver20 = /*#__PURE__*/React__default['default'].forwardRef(function Lifesaver20(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$f || (_path112$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.2261,22.812a13.9664,13.9664,0,0,0,0-13.624L28.4141,9a2.0021,2.0021,0,0,0,0-2.8281l-2.5857-2.586a2.0028,2.0028,0,0,0-2.8284,0l-.1877.1875a13.9687,13.9687,0,0,0-13.6243,0L9,3.5859a2.0024,2.0024,0,0,0-2.8284,0L3.5859,6.1719A2.0021,2.0021,0,0,0,3.5859,9l.1878.1875a13.97,13.97,0,0,0,0,13.625L3.5859,23a2.0021,2.0021,0,0,0,0,2.8281l2.5857,2.586a2.0021,2.0021,0,0,0,2.8284,0l.188-.188a13.9687,13.9687,0,0,0,13.6243.0005L23,28.4141a2.0021,2.0021,0,0,0,2.8284,0l2.5857-2.586a2.0021,2.0021,0,0,0,0-2.8281ZM28,16a11.973,11.973,0,0,1-1.2546,5.3315l-3.8948-3.895a6.9808,6.9808,0,0,0,0-2.873l3.8948-3.895A11.973,11.973,0,0,1,28,16ZM27,7.5859l-4.9346,4.9346A7.0434,7.0434,0,0,0,19.48,9.9346L24.4143,5ZM16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21ZM21.3154,5.2705,17.4365,9.1494a6.9808,6.9808,0,0,0-2.873,0L10.6846,5.2705A12.2484,12.2484,0,0,1,21.3154,5.2705ZM7.5859,5l4.9346,4.9346a7.0449,7.0449,0,0,0-2.5859,2.5859L5,7.5859ZM4,16a11.9716,11.9716,0,0,1,1.2546-5.3311l3.8948,3.8946a6.9808,6.9808,0,0,0,0,2.873L5.2546,21.3311A11.9716,11.9716,0,0,1,4,16ZM7.5857,27,5,24.4141,9.9346,19.48a7.0434,7.0434,0,0,0,2.5859,2.5859Zm3.0989-.27,3.8789-3.8789a6.9808,6.9808,0,0,0,2.873,0L21.3154,26.73A12.2484,12.2484,0,0,1,10.6846,26.73Zm13.73.27L19.48,22.0654A7.0449,7.0449,0,0,0,22.0654,19.48L27,24.4141Z"
    })), children);
  });
  var Lifesaver16 = /*#__PURE__*/React__default['default'].forwardRef(function Lifesaver16(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$f || (_path113$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.2261,22.812a13.9664,13.9664,0,0,0,0-13.624L28.4141,9a2.0021,2.0021,0,0,0,0-2.8281l-2.5857-2.586a2.0028,2.0028,0,0,0-2.8284,0l-.1877.1875a13.9687,13.9687,0,0,0-13.6243,0L9,3.5859a2.0024,2.0024,0,0,0-2.8284,0L3.5859,6.1719A2.0021,2.0021,0,0,0,3.5859,9l.1878.1875a13.97,13.97,0,0,0,0,13.625L3.5859,23a2.0021,2.0021,0,0,0,0,2.8281l2.5857,2.586a2.0021,2.0021,0,0,0,2.8284,0l.188-.188a13.9687,13.9687,0,0,0,13.6243.0005L23,28.4141a2.0021,2.0021,0,0,0,2.8284,0l2.5857-2.586a2.0021,2.0021,0,0,0,0-2.8281ZM28,16a11.973,11.973,0,0,1-1.2546,5.3315l-3.8948-3.895a6.9808,6.9808,0,0,0,0-2.873l3.8948-3.895A11.973,11.973,0,0,1,28,16ZM27,7.5859l-4.9346,4.9346A7.0434,7.0434,0,0,0,19.48,9.9346L24.4143,5ZM16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21ZM21.3154,5.2705,17.4365,9.1494a6.9808,6.9808,0,0,0-2.873,0L10.6846,5.2705A12.2484,12.2484,0,0,1,21.3154,5.2705ZM7.5859,5l4.9346,4.9346a7.0449,7.0449,0,0,0-2.5859,2.5859L5,7.5859ZM4,16a11.9716,11.9716,0,0,1,1.2546-5.3311l3.8948,3.8946a6.9808,6.9808,0,0,0,0,2.873L5.2546,21.3311A11.9716,11.9716,0,0,1,4,16ZM7.5857,27,5,24.4141,9.9346,19.48a7.0434,7.0434,0,0,0,2.5859,2.5859Zm3.0989-.27,3.8789-3.8789a6.9808,6.9808,0,0,0,2.873,0L21.3154,26.73A12.2484,12.2484,0,0,1,10.6846,26.73Zm13.73.27L19.48,22.0654A7.0449,7.0449,0,0,0,22.0654,19.48L27,24.4141Z"
    })), children);
  });
  var Light32 = /*#__PURE__*/React__default['default'].forwardRef(function Light32(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$f || (_path114$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path115$f || (_path115$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path116$f || (_path116$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path117$f || (_path117$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path118$f || (_path118$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path119$f || (_path119$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path120$f || (_path120$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path121$f || (_path121$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path122$f || (_path122$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Light24 = /*#__PURE__*/React__default['default'].forwardRef(function Light24(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$f || (_path123$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path124$f || (_path124$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path125$f || (_path125$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path126$f || (_path126$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path127$f || (_path127$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path128$f || (_path128$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path129$f || (_path129$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path130$f || (_path130$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path131$f || (_path131$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Light20 = /*#__PURE__*/React__default['default'].forwardRef(function Light20(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$f || (_path132$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path133$f || (_path133$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path134$f || (_path134$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path135$f || (_path135$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path136$f || (_path136$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path137$f || (_path137$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path138$f || (_path138$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path139$f || (_path139$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path140$f || (_path140$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Light16 = /*#__PURE__*/React__default['default'].forwardRef(function Light16(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$f || (_path141$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 1H8.5V3.5H7.5z"
    })), _path142$f || (_path142$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8 3.4H13.3V4.4H10.8z",
      transform: "rotate(-45.001 12.041 3.923)"
    })), _path143$f || (_path143$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.5 7.5H15V8.5H12.5z"
    })), _path144$f || (_path144$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.6 10.8H12.6V13.3H11.6z",
      transform: "rotate(-45.001 12.075 12.041)"
    })), _path145$f || (_path145$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 12.5H8.5V15H7.5z"
    })), _path146$f || (_path146$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.7 11.6H5.2V12.6H2.7z",
      transform: "rotate(-45.001 3.96 12.079)"
    })), _path147$f || (_path147$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 7.5H3.5V8.5H1z"
    })), _path148$f || (_path148$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.4 2.7H4.4V5.2H3.4z",
      transform: "rotate(-45.001 3.925 3.961)"
    })), _path149$f || (_path149$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,6c1.1,0,2,0.9,2,2s-0.9,2-2,2S6,9.1,6,8S6.9,6,8,6 M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z"
    })), children);
  });
  var LightFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LightFilled32(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$f || (_path150$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path151$f || (_path151$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path152$f || (_path152$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path153$f || (_path153$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path154$f || (_path154$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path155$f || (_path155$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path156$f || (_path156$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path157$f || (_path157$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path158$f || (_path158$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var LightFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LightFilled24(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$f || (_path159$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path160$f || (_path160$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path161$f || (_path161$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path162$f || (_path162$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path163$f || (_path163$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path164$f || (_path164$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path165$f || (_path165$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path166$f || (_path166$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path167$f || (_path167$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var LightFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LightFilled20(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$f || (_path168$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path169$f || (_path169$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path170$f || (_path170$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path171$f || (_path171$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path172$f || (_path172$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path173$f || (_path173$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path174$f || (_path174$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path175$f || (_path175$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path176$f || (_path176$f = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var LightFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LightFilled16(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$e || (_path177$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V7H15z"
    })), _path178$e || (_path178$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path179$e || (_path179$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25z"
    })), _path180$e || (_path180$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.147 24.146)"
    })), _path181$e || (_path181$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25H17V30H15z"
    })), _path182$e || (_path182$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.853 24.146)"
    })), _path183$e || (_path183$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15H7V17H2z"
    })), _path184$e || (_path184$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path185$e || (_path185$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Lightning32 = /*#__PURE__*/React__default['default'].forwardRef(function Lightning32(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$e || (_path186$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Lightning24 = /*#__PURE__*/React__default['default'].forwardRef(function Lightning24(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$e || (_path187$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Lightning20 = /*#__PURE__*/React__default['default'].forwardRef(function Lightning20(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$e || (_path188$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Lightning16 = /*#__PURE__*/React__default['default'].forwardRef(function Lightning16(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$e || (_path189$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"
    })), children);
  });
  var Link32 = /*#__PURE__*/React__default['default'].forwardRef(function Link32(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$e || (_path190$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"
    })), _path191$e || (_path191$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"
    })), children);
  });
  var Link24 = /*#__PURE__*/React__default['default'].forwardRef(function Link24(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$e || (_path192$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"
    })), _path193$e || (_path193$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"
    })), children);
  });
  var Link20 = /*#__PURE__*/React__default['default'].forwardRef(function Link20(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$e || (_path194$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"
    })), _path195$e || (_path195$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"
    })), children);
  });
  var Link16 = /*#__PURE__*/React__default['default'].forwardRef(function Link16(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$e || (_path196$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"
    })), _path197$e || (_path197$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"
    })), children);
  });
  var Linux32 = /*#__PURE__*/React__default['default'].forwardRef(function Linux32(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$e || (_path198$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8945,23.542l-1.7238-3.4473a1.9994,1.9994,0,0,0-1.7886-1.1054h-.4683a14.887,14.887,0,0,0-1.8193-4.5977C23.0647,12.4429,22,10.4277,22,8A6,6,0,0,0,10,8a13.0041,13.0041,0,0,1-2.0486,6.2153,14.7022,14.7022,0,0,0-1.8708,4.7759H5.6184a2.0007,2.0007,0,0,0-1.7893,1.106L2.1055,23.5439a1,1,0,0,0,.0971,1.0508L6.2319,29.92a2.9995,2.9995,0,0,0,3.8482.6519l1.8735-1.1241A13.8223,13.8223,0,0,0,16,30a13.8034,13.8034,0,0,0,4.0488-.5527L21.92,30.57a2.9819,2.9819,0,0,0,1.5385.43,3.0385,3.0385,0,0,0,2.3389-1.1187l4-5.2885A1.001,1.001,0,0,0,29.8945,23.542Zm-7.5683-8.2158a14.8311,14.8311,0,0,1,1.5591,3.6631H21.738a16.6591,16.6591,0,0,0-.98-2.6455,12.7083,12.7083,0,0,1-.8789-2.4454,8.8046,8.8046,0,0,0,1.0034-1.4277l.0384-.0718A30.746,30.746,0,0,0,22.3262,15.3262ZM12,21a9.3959,9.3959,0,0,1,1.0728-3.8516c.2563-.5825.5158-1.1757.726-1.7993a4.0474,4.0474,0,0,0,4.4024,0c.21.6236.47,1.2168.726,1.7993A9.3959,9.3959,0,0,1,20,21c0,1.2881-.4146,3-4,3S12,22.2881,12,21Zm6.5105-8.5752A3.6265,3.6265,0,0,1,16,14a3.6273,3.6273,0,0,1-2.5107-1.5757,7.6356,7.6356,0,0,1,5.0212,0ZM12,8a4,4,0,0,1,8,0,10.9164,10.9164,0,0,0,.4673,3.1152A7.9811,7.9811,0,0,0,19,10.4849V8H17v2.0542a9.2522,9.2522,0,0,0-2,0V8H13v2.4849a7.9019,7.9019,0,0,0-1.4785.6372A10.7093,10.7093,0,0,0,12,8ZM9.7146,15.1592A29.8007,29.8007,0,0,0,11.0693,12.38l.0484.09a8.8046,8.8046,0,0,0,1.0034,1.4277,12.7083,12.7083,0,0,1-.8789,2.4454,16.6574,16.6574,0,0,0-.981,2.6474H8.1047A14.0567,14.0567,0,0,1,9.7146,15.1592Zm1.3708,12.4775L9.0508,28.8574a.9866.9866,0,0,1-1.2529-.1806L4.1724,23.8833l1.4458-2.8921h3.706L11.49,26.3853A1.0036,1.0036,0,0,1,11.0854,27.6367Zm2.316.1177a2.9571,2.9571,0,0,0-.0562-2.11A9.03,9.03,0,0,0,16,26a9.0237,9.0237,0,0,0,2.6562-.3564,2.9889,2.9889,0,0,0-.0546,2.11,13.8722,13.8722,0,0,1-5.2,0Zm10.83.8833a.996.996,0,0,1-1.2827.2178l-2.0342-1.2207h0a1.01,1.01,0,0,1-.396-1.273l2.157-5.3725h3.7058l1.4461,2.892Z"
    })), children);
  });
  var Linux24 = /*#__PURE__*/React__default['default'].forwardRef(function Linux24(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$e || (_path199$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8945,23.542l-1.7238-3.4473a1.9994,1.9994,0,0,0-1.7886-1.1054h-.4683a14.887,14.887,0,0,0-1.8193-4.5977C23.0647,12.4429,22,10.4277,22,8A6,6,0,0,0,10,8a13.0041,13.0041,0,0,1-2.0486,6.2153,14.7022,14.7022,0,0,0-1.8708,4.7759H5.6184a2.0007,2.0007,0,0,0-1.7893,1.106L2.1055,23.5439a1,1,0,0,0,.0971,1.0508L6.2319,29.92a2.9995,2.9995,0,0,0,3.8482.6519l1.8735-1.1241A13.8223,13.8223,0,0,0,16,30a13.8034,13.8034,0,0,0,4.0488-.5527L21.92,30.57a2.9819,2.9819,0,0,0,1.5385.43,3.0385,3.0385,0,0,0,2.3389-1.1187l4-5.2885A1.001,1.001,0,0,0,29.8945,23.542Zm-7.5683-8.2158a14.8311,14.8311,0,0,1,1.5591,3.6631H21.738a16.6591,16.6591,0,0,0-.98-2.6455,12.7083,12.7083,0,0,1-.8789-2.4454,8.8046,8.8046,0,0,0,1.0034-1.4277l.0384-.0718A30.746,30.746,0,0,0,22.3262,15.3262ZM12,21a9.3959,9.3959,0,0,1,1.0728-3.8516c.2563-.5825.5158-1.1757.726-1.7993a4.0474,4.0474,0,0,0,4.4024,0c.21.6236.47,1.2168.726,1.7993A9.3959,9.3959,0,0,1,20,21c0,1.2881-.4146,3-4,3S12,22.2881,12,21Zm6.5105-8.5752A3.6265,3.6265,0,0,1,16,14a3.6273,3.6273,0,0,1-2.5107-1.5757,7.6356,7.6356,0,0,1,5.0212,0ZM12,8a4,4,0,0,1,8,0,10.9164,10.9164,0,0,0,.4673,3.1152A7.9811,7.9811,0,0,0,19,10.4849V8H17v2.0542a9.2522,9.2522,0,0,0-2,0V8H13v2.4849a7.9019,7.9019,0,0,0-1.4785.6372A10.7093,10.7093,0,0,0,12,8ZM9.7146,15.1592A29.8007,29.8007,0,0,0,11.0693,12.38l.0484.09a8.8046,8.8046,0,0,0,1.0034,1.4277,12.7083,12.7083,0,0,1-.8789,2.4454,16.6574,16.6574,0,0,0-.981,2.6474H8.1047A14.0567,14.0567,0,0,1,9.7146,15.1592Zm1.3708,12.4775L9.0508,28.8574a.9866.9866,0,0,1-1.2529-.1806L4.1724,23.8833l1.4458-2.8921h3.706L11.49,26.3853A1.0036,1.0036,0,0,1,11.0854,27.6367Zm2.316.1177a2.9571,2.9571,0,0,0-.0562-2.11A9.03,9.03,0,0,0,16,26a9.0237,9.0237,0,0,0,2.6562-.3564,2.9889,2.9889,0,0,0-.0546,2.11,13.8722,13.8722,0,0,1-5.2,0Zm10.83.8833a.996.996,0,0,1-1.2827.2178l-2.0342-1.2207h0a1.01,1.01,0,0,1-.396-1.273l2.157-5.3725h3.7058l1.4461,2.892Z"
    })), children);
  });
  var Linux20 = /*#__PURE__*/React__default['default'].forwardRef(function Linux20(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$e || (_path200$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8945,23.542l-1.7238-3.4473a1.9994,1.9994,0,0,0-1.7886-1.1054h-.4683a14.887,14.887,0,0,0-1.8193-4.5977C23.0647,12.4429,22,10.4277,22,8A6,6,0,0,0,10,8a13.0041,13.0041,0,0,1-2.0486,6.2153,14.7022,14.7022,0,0,0-1.8708,4.7759H5.6184a2.0007,2.0007,0,0,0-1.7893,1.106L2.1055,23.5439a1,1,0,0,0,.0971,1.0508L6.2319,29.92a2.9995,2.9995,0,0,0,3.8482.6519l1.8735-1.1241A13.8223,13.8223,0,0,0,16,30a13.8034,13.8034,0,0,0,4.0488-.5527L21.92,30.57a2.9819,2.9819,0,0,0,1.5385.43,3.0385,3.0385,0,0,0,2.3389-1.1187l4-5.2885A1.001,1.001,0,0,0,29.8945,23.542Zm-7.5683-8.2158a14.8311,14.8311,0,0,1,1.5591,3.6631H21.738a16.6591,16.6591,0,0,0-.98-2.6455,12.7083,12.7083,0,0,1-.8789-2.4454,8.8046,8.8046,0,0,0,1.0034-1.4277l.0384-.0718A30.746,30.746,0,0,0,22.3262,15.3262ZM12,21a9.3959,9.3959,0,0,1,1.0728-3.8516c.2563-.5825.5158-1.1757.726-1.7993a4.0474,4.0474,0,0,0,4.4024,0c.21.6236.47,1.2168.726,1.7993A9.3959,9.3959,0,0,1,20,21c0,1.2881-.4146,3-4,3S12,22.2881,12,21Zm6.5105-8.5752A3.6265,3.6265,0,0,1,16,14a3.6273,3.6273,0,0,1-2.5107-1.5757,7.6356,7.6356,0,0,1,5.0212,0ZM12,8a4,4,0,0,1,8,0,10.9164,10.9164,0,0,0,.4673,3.1152A7.9811,7.9811,0,0,0,19,10.4849V8H17v2.0542a9.2522,9.2522,0,0,0-2,0V8H13v2.4849a7.9019,7.9019,0,0,0-1.4785.6372A10.7093,10.7093,0,0,0,12,8ZM9.7146,15.1592A29.8007,29.8007,0,0,0,11.0693,12.38l.0484.09a8.8046,8.8046,0,0,0,1.0034,1.4277,12.7083,12.7083,0,0,1-.8789,2.4454,16.6574,16.6574,0,0,0-.981,2.6474H8.1047A14.0567,14.0567,0,0,1,9.7146,15.1592Zm1.3708,12.4775L9.0508,28.8574a.9866.9866,0,0,1-1.2529-.1806L4.1724,23.8833l1.4458-2.8921h3.706L11.49,26.3853A1.0036,1.0036,0,0,1,11.0854,27.6367Zm2.316.1177a2.9571,2.9571,0,0,0-.0562-2.11A9.03,9.03,0,0,0,16,26a9.0237,9.0237,0,0,0,2.6562-.3564,2.9889,2.9889,0,0,0-.0546,2.11,13.8722,13.8722,0,0,1-5.2,0Zm10.83.8833a.996.996,0,0,1-1.2827.2178l-2.0342-1.2207h0a1.01,1.01,0,0,1-.396-1.273l2.157-5.3725h3.7058l1.4461,2.892Z"
    })), children);
  });
  var Linux16 = /*#__PURE__*/React__default['default'].forwardRef(function Linux16(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$e || (_path201$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8945,23.542l-1.7238-3.4473a1.9994,1.9994,0,0,0-1.7886-1.1054h-.4683a14.887,14.887,0,0,0-1.8193-4.5977C23.0647,12.4429,22,10.4277,22,8A6,6,0,0,0,10,8a13.0041,13.0041,0,0,1-2.0486,6.2153,14.7022,14.7022,0,0,0-1.8708,4.7759H5.6184a2.0007,2.0007,0,0,0-1.7893,1.106L2.1055,23.5439a1,1,0,0,0,.0971,1.0508L6.2319,29.92a2.9995,2.9995,0,0,0,3.8482.6519l1.8735-1.1241A13.8223,13.8223,0,0,0,16,30a13.8034,13.8034,0,0,0,4.0488-.5527L21.92,30.57a2.9819,2.9819,0,0,0,1.5385.43,3.0385,3.0385,0,0,0,2.3389-1.1187l4-5.2885A1.001,1.001,0,0,0,29.8945,23.542Zm-7.5683-8.2158a14.8311,14.8311,0,0,1,1.5591,3.6631H21.738a16.6591,16.6591,0,0,0-.98-2.6455,12.7083,12.7083,0,0,1-.8789-2.4454,8.8046,8.8046,0,0,0,1.0034-1.4277l.0384-.0718A30.746,30.746,0,0,0,22.3262,15.3262ZM12,21a9.3959,9.3959,0,0,1,1.0728-3.8516c.2563-.5825.5158-1.1757.726-1.7993a4.0474,4.0474,0,0,0,4.4024,0c.21.6236.47,1.2168.726,1.7993A9.3959,9.3959,0,0,1,20,21c0,1.2881-.4146,3-4,3S12,22.2881,12,21Zm6.5105-8.5752A3.6265,3.6265,0,0,1,16,14a3.6273,3.6273,0,0,1-2.5107-1.5757,7.6356,7.6356,0,0,1,5.0212,0ZM12,8a4,4,0,0,1,8,0,10.9164,10.9164,0,0,0,.4673,3.1152A7.9811,7.9811,0,0,0,19,10.4849V8H17v2.0542a9.2522,9.2522,0,0,0-2,0V8H13v2.4849a7.9019,7.9019,0,0,0-1.4785.6372A10.7093,10.7093,0,0,0,12,8ZM9.7146,15.1592A29.8007,29.8007,0,0,0,11.0693,12.38l.0484.09a8.8046,8.8046,0,0,0,1.0034,1.4277,12.7083,12.7083,0,0,1-.8789,2.4454,16.6574,16.6574,0,0,0-.981,2.6474H8.1047A14.0567,14.0567,0,0,1,9.7146,15.1592Zm1.3708,12.4775L9.0508,28.8574a.9866.9866,0,0,1-1.2529-.1806L4.1724,23.8833l1.4458-2.8921h3.706L11.49,26.3853A1.0036,1.0036,0,0,1,11.0854,27.6367Zm2.316.1177a2.9571,2.9571,0,0,0-.0562-2.11A9.03,9.03,0,0,0,16,26a9.0237,9.0237,0,0,0,2.6562-.3564,2.9889,2.9889,0,0,0-.0546,2.11,13.8722,13.8722,0,0,1-5.2,0Zm10.83.8833a.996.996,0,0,1-1.2827.2178l-2.0342-1.2207h0a1.01,1.01,0,0,1-.396-1.273l2.157-5.3725h3.7058l1.4461,2.892Z"
    })), children);
  });
  var LinuxAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function LinuxAlt32(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$e || (_path202$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6121,20.5215A6.1582,6.1582,0,0,0,24,16.5254C24,13.4785,21.9812,11,19.5,11A4.2435,4.2435,0,0,0,16,13.06,4.2435,4.2435,0,0,0,12.5,11C10.0188,11,8,13.4785,8,16.5254a6.1593,6.1593,0,0,0,1.3879,3.9961c-.5688.3686-.9389.6416-.988.6787a1,1,0,0,0-.1807,1.4248C8.6592,23.1748,12.6169,28,16,28s7.3408-4.8252,7.7808-5.375A1,1,0,0,0,23.6,21.2C23.551,21.1631,23.1812,20.89,22.6121,20.5215ZM12.5,13c1.3552,0,2.5,1.6143,2.5,3.5254v1.5664a9.1005,9.1005,0,0,0-1.0244.2314A2.6411,2.6411,0,0,0,14,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.38,2.38,0,0,0,.4072,1.3623c-.0813.0415-.1687.0806-.248.1221A4.0291,4.0291,0,0,1,10,16.5254C10,14.6143,11.1448,13,12.5,13ZM16,26c-1.5691,0-3.9648-2.084-5.52-3.8057C11.9,21.2788,14.2656,20,16,20s4.1,1.2788,5.52,2.1943C19.9648,23.916,17.5691,26,16,26Zm4.8408-6.5156c-.0793-.0415-.1667-.0806-.248-.1221A2.38,2.38,0,0,0,21,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.6411,2.6411,0,0,0,.0244.3232A9.1005,9.1005,0,0,0,17,18.0918V16.5254C17,14.6143,18.1448,13,19.5,13S22,14.6143,22,16.5254A4.0291,4.0291,0,0,1,20.8408,19.4844Z"
    })), _path203$e || (_path203$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30a3.8876,3.8876,0,0,1-4-4V14A10,10,0,0,0,6,14V26a3.8876,3.8876,0,0,1-4,4V28a1.8793,1.8793,0,0,0,2-2V14a12,12,0,0,1,24,0V26a1.8825,1.8825,0,0,0,2,2Z"
    })), children);
  });
  var LinuxAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function LinuxAlt24(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$e || (_path204$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6121,20.5215A6.1582,6.1582,0,0,0,24,16.5254C24,13.4785,21.9812,11,19.5,11A4.2435,4.2435,0,0,0,16,13.06,4.2435,4.2435,0,0,0,12.5,11C10.0188,11,8,13.4785,8,16.5254a6.1593,6.1593,0,0,0,1.3879,3.9961c-.5688.3686-.9389.6416-.988.6787a1,1,0,0,0-.1807,1.4248C8.6592,23.1748,12.6169,28,16,28s7.3408-4.8252,7.7808-5.375A1,1,0,0,0,23.6,21.2C23.551,21.1631,23.1812,20.89,22.6121,20.5215ZM12.5,13c1.3552,0,2.5,1.6143,2.5,3.5254v1.5664a9.1005,9.1005,0,0,0-1.0244.2314A2.6411,2.6411,0,0,0,14,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.38,2.38,0,0,0,.4072,1.3623c-.0813.0415-.1687.0806-.248.1221A4.0291,4.0291,0,0,1,10,16.5254C10,14.6143,11.1448,13,12.5,13ZM16,26c-1.5691,0-3.9648-2.084-5.52-3.8057C11.9,21.2788,14.2656,20,16,20s4.1,1.2788,5.52,2.1943C19.9648,23.916,17.5691,26,16,26Zm4.8408-6.5156c-.0793-.0415-.1667-.0806-.248-.1221A2.38,2.38,0,0,0,21,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.6411,2.6411,0,0,0,.0244.3232A9.1005,9.1005,0,0,0,17,18.0918V16.5254C17,14.6143,18.1448,13,19.5,13S22,14.6143,22,16.5254A4.0291,4.0291,0,0,1,20.8408,19.4844Z"
    })), _path205$e || (_path205$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30a3.8876,3.8876,0,0,1-4-4V14A10,10,0,0,0,6,14V26a3.8876,3.8876,0,0,1-4,4V28a1.8793,1.8793,0,0,0,2-2V14a12,12,0,0,1,24,0V26a1.8825,1.8825,0,0,0,2,2Z"
    })), children);
  });
  var LinuxAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function LinuxAlt20(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$e || (_path206$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6121,20.5215A6.1582,6.1582,0,0,0,24,16.5254C24,13.4785,21.9812,11,19.5,11A4.2435,4.2435,0,0,0,16,13.06,4.2435,4.2435,0,0,0,12.5,11C10.0188,11,8,13.4785,8,16.5254a6.1593,6.1593,0,0,0,1.3879,3.9961c-.5688.3686-.9389.6416-.988.6787a1,1,0,0,0-.1807,1.4248C8.6592,23.1748,12.6169,28,16,28s7.3408-4.8252,7.7808-5.375A1,1,0,0,0,23.6,21.2C23.551,21.1631,23.1812,20.89,22.6121,20.5215ZM12.5,13c1.3552,0,2.5,1.6143,2.5,3.5254v1.5664a9.1005,9.1005,0,0,0-1.0244.2314A2.6411,2.6411,0,0,0,14,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.38,2.38,0,0,0,.4072,1.3623c-.0813.0415-.1687.0806-.248.1221A4.0291,4.0291,0,0,1,10,16.5254C10,14.6143,11.1448,13,12.5,13ZM16,26c-1.5691,0-3.9648-2.084-5.52-3.8057C11.9,21.2788,14.2656,20,16,20s4.1,1.2788,5.52,2.1943C19.9648,23.916,17.5691,26,16,26Zm4.8408-6.5156c-.0793-.0415-.1667-.0806-.248-.1221A2.38,2.38,0,0,0,21,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.6411,2.6411,0,0,0,.0244.3232A9.1005,9.1005,0,0,0,17,18.0918V16.5254C17,14.6143,18.1448,13,19.5,13S22,14.6143,22,16.5254A4.0291,4.0291,0,0,1,20.8408,19.4844Z"
    })), _path207$e || (_path207$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30a3.8876,3.8876,0,0,1-4-4V14A10,10,0,0,0,6,14V26a3.8876,3.8876,0,0,1-4,4V28a1.8793,1.8793,0,0,0,2-2V14a12,12,0,0,1,24,0V26a1.8825,1.8825,0,0,0,2,2Z"
    })), children);
  });
  var LinuxAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function LinuxAlt16(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$e || (_path208$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6121,20.5215A6.1582,6.1582,0,0,0,24,16.5254C24,13.4785,21.9812,11,19.5,11A4.2435,4.2435,0,0,0,16,13.06,4.2435,4.2435,0,0,0,12.5,11C10.0188,11,8,13.4785,8,16.5254a6.1593,6.1593,0,0,0,1.3879,3.9961c-.5688.3686-.9389.6416-.988.6787a1,1,0,0,0-.1807,1.4248C8.6592,23.1748,12.6169,28,16,28s7.3408-4.8252,7.7808-5.375A1,1,0,0,0,23.6,21.2C23.551,21.1631,23.1812,20.89,22.6121,20.5215ZM12.5,13c1.3552,0,2.5,1.6143,2.5,3.5254v1.5664a9.1005,9.1005,0,0,0-1.0244.2314A2.6411,2.6411,0,0,0,14,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.38,2.38,0,0,0,.4072,1.3623c-.0813.0415-.1687.0806-.248.1221A4.0291,4.0291,0,0,1,10,16.5254C10,14.6143,11.1448,13,12.5,13ZM16,26c-1.5691,0-3.9648-2.084-5.52-3.8057C11.9,21.2788,14.2656,20,16,20s4.1,1.2788,5.52,2.1943C19.9648,23.916,17.5691,26,16,26Zm4.8408-6.5156c-.0793-.0415-.1667-.0806-.248-.1221A2.38,2.38,0,0,0,21,18c0-1.1045-.6716-2-1.5-2s-1.5.8955-1.5,2a2.6411,2.6411,0,0,0,.0244.3232A9.1005,9.1005,0,0,0,17,18.0918V16.5254C17,14.6143,18.1448,13,19.5,13S22,14.6143,22,16.5254A4.0291,4.0291,0,0,1,20.8408,19.4844Z"
    })), _path209$e || (_path209$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30a3.8876,3.8876,0,0,1-4-4V14A10,10,0,0,0,6,14V26a3.8876,3.8876,0,0,1-4,4V28a1.8793,1.8793,0,0,0,2-2V14a12,12,0,0,1,24,0V26a1.8825,1.8825,0,0,0,2,2Z"
    })), children);
  });
  var List32 = /*#__PURE__*/React__default['default'].forwardRef(function List32(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$e || (_path210$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"
    })), children);
  });
  var List24 = /*#__PURE__*/React__default['default'].forwardRef(function List24(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$e || (_path211$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"
    })), children);
  });
  var List20 = /*#__PURE__*/React__default['default'].forwardRef(function List20(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$e || (_path212$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"
    })), children);
  });
  var List16 = /*#__PURE__*/React__default['default'].forwardRef(function List16(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$e || (_path213$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"
    })), children);
  });
  var ListBoxes32 = /*#__PURE__*/React__default['default'].forwardRef(function ListBoxes32(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$e || (_path214$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 28zM4 20v6h6.0012L10 20z"
    })), children);
  });
  var ListBoxes24 = /*#__PURE__*/React__default['default'].forwardRef(function ListBoxes24(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$e || (_path215$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 28zM4 20v6h6.0012L10 20z"
    })), children);
  });
  var ListBoxes20 = /*#__PURE__*/React__default['default'].forwardRef(function ListBoxes20(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$e || (_path216$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 28zM4 20v6h6.0012L10 20z"
    })), children);
  });
  var ListBoxes16 = /*#__PURE__*/React__default['default'].forwardRef(function ListBoxes16(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$e || (_path217$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0110 28zM4 20v6h6.0012L10 20z"
    })), children);
  });
  var ListBulleted32 = /*#__PURE__*/React__default['default'].forwardRef(function ListBulleted32(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$f);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$e || (_circle$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "9",
      r: "3"
    })), _circle2$e || (_circle2$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "3"
    })), _path218$e || (_path218$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16z"
    })), children);
  });
  var ListBulleted24 = /*#__PURE__*/React__default['default'].forwardRef(function ListBulleted24(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$e || (_circle3$e = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "9",
      r: "3"
    })), _circle4$d || (_circle4$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "3"
    })), _path219$e || (_path219$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16z"
    })), children);
  });
  var ListBulleted20 = /*#__PURE__*/React__default['default'].forwardRef(function ListBulleted20(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$c || (_circle5$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "9",
      r: "3"
    })), _circle6$c || (_circle6$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "23",
      r: "3"
    })), _path220$e || (_path220$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16z"
    })), children);
  });
  var ListBulleted16 = /*#__PURE__*/React__default['default'].forwardRef(function ListBulleted16(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$c || (_circle7$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3.5",
      cy: "4.5",
      r: "1.5"
    })), _circle8$c || (_circle8$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3.5",
      cy: "11.5",
      r: "1.5"
    })), _path221$e || (_path221$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11H15V12H8zM8 4H15V5H8z"
    })), children);
  });
  var ListChecked32 = /*#__PURE__*/React__default['default'].forwardRef(function ListChecked32(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$e || (_path222$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"
    })), children);
  });
  var ListChecked24 = /*#__PURE__*/React__default['default'].forwardRef(function ListChecked24(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$e || (_path223$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"
    })), children);
  });
  var ListChecked20 = /*#__PURE__*/React__default['default'].forwardRef(function ListChecked20(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$e || (_path224$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"
    })), children);
  });
  var ListChecked16 = /*#__PURE__*/React__default['default'].forwardRef(function ListChecked16(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$e || (_path225$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"
    })), children);
  });
  var ListDropdown32 = /*#__PURE__*/React__default['default'].forwardRef(function ListDropdown32(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$e || (_path226$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"
    })), _path227$e || (_path227$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"
    })), children);
  });
  var ListDropdown24 = /*#__PURE__*/React__default['default'].forwardRef(function ListDropdown24(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$e || (_path228$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"
    })), _path229$e || (_path229$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"
    })), children);
  });
  var ListDropdown20 = /*#__PURE__*/React__default['default'].forwardRef(function ListDropdown20(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$e || (_path230$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"
    })), _path231$e || (_path231$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"
    })), children);
  });
  var ListDropdown16 = /*#__PURE__*/React__default['default'].forwardRef(function ListDropdown16(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$e || (_path232$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"
    })), _path233$e || (_path233$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"
    })), children);
  });
  var ListNumbered32 = /*#__PURE__*/React__default['default'].forwardRef(function ListNumbered32(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$e || (_path234$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 012-2H8V20H4V18H8a2 2 0 012 2v2a2 2 0 01-2 2H6v2h4z"
    })), children);
  });
  var ListNumbered24 = /*#__PURE__*/React__default['default'].forwardRef(function ListNumbered24(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$e || (_path235$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 012-2H8V20H4V18H8a2 2 0 012 2v2a2 2 0 01-2 2H6v2h4z"
    })), children);
  });
  var ListNumbered20 = /*#__PURE__*/React__default['default'].forwardRef(function ListNumbered20(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$e || (_path236$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 012-2H8V20H4V18H8a2 2 0 012 2v2a2 2 0 01-2 2H6v2h4z"
    })), children);
  });
  var ListNumbered16 = /*#__PURE__*/React__default['default'].forwardRef(function ListNumbered16(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$e || (_path237$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 012-2H8V20H4V18H8a2 2 0 012 2v2a2 2 0 01-2 2H6v2h4z"
    })), children);
  });
  var LoadBalancerApplication32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerApplication32(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$e || (_path238$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V14H15v2H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM9 2V12H23V2zm2 2h2v6H11zm10 6H15V4h6z"
    })), children);
  });
  var LoadBalancerApplication24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerApplication24(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$e || (_path239$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V14H15v2H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM9 2V12H23V2zm2 2h2v6H11zm10 6H15V4h6z"
    })), children);
  });
  var LoadBalancerApplication20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerApplication20(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$e || (_path240$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V14H15v2H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM9 2V12H23V2zm2 2h2v6H11zm10 6H15V4h6z"
    })), children);
  });
  var LoadBalancerApplication16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerApplication16(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$e || (_path241$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V14H15v2H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM9 2V12H23V2zm2 2h2v6H11zm10 6H15V4h6z"
    })), children);
  });
  var LoadBalancerClassic32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerClassic32(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$e || (_path242$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8zM14 8V4h4V8z"
    })), children);
  });
  var LoadBalancerClassic24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerClassic24(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$e || (_path243$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8zM14 8V4h4V8z"
    })), children);
  });
  var LoadBalancerClassic20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerClassic20(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$e || (_path244$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8zM14 8V4h4V8z"
    })), children);
  });
  var LoadBalancerClassic16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerClassic16(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$e || (_path245$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8zM14 8V4h4V8z"
    })), children);
  });
  var LoadBalancerGlobal32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerGlobal32(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$e || (_path246$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 4z"
    })), children);
  });
  var LoadBalancerGlobal24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerGlobal24(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$e || (_path247$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 4z"
    })), children);
  });
  var LoadBalancerGlobal20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerGlobal20(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$e || (_path248$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 4z"
    })), children);
  });
  var LoadBalancerGlobal16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerGlobal16(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$e || (_path249$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 4z"
    })), children);
  });
  var LoadBalancerListener32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerListener32(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$e || (_path250$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V10H15zM19 8H21V10H19zM11 8H13V10H11zM25 16H17V13H15v3H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 3H21V5H11z"
    })), children);
  });
  var LoadBalancerListener24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerListener24(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$e || (_path251$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V10H15zM19 8H21V10H19zM11 8H13V10H11zM25 16H17V13H15v3H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 3H21V5H11z"
    })), children);
  });
  var LoadBalancerListener20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerListener20(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$e || (_path252$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V10H15zM19 8H21V10H19zM11 8H13V10H11zM25 16H17V13H15v3H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 3H21V5H11z"
    })), children);
  });
  var LoadBalancerListener16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerListener16(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$e || (_path253$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V10H15zM19 8H21V10H19zM11 8H13V10H11zM25 16H17V13H15v3H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 3H21V5H11z"
    })), children);
  });
  var LoadBalancerLocal32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerLocal32(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$e || (_path254$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V10H15v6H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 5H21V7H11z"
    })), children);
  });
  var LoadBalancerLocal24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerLocal24(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$e || (_path255$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V10H15v6H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 5H21V7H11z"
    })), children);
  });
  var LoadBalancerLocal20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerLocal20(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$e || (_path256$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V10H15v6H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 5H21V7H11z"
    })), children);
  });
  var LoadBalancerLocal16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerLocal16(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$e || (_path257$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V10H15v6H7a2.0023 2.0023 0 00-2 2v6H7V18h8v6h2V18h8v6h2V18A2.0023 2.0023 0 0025 16zM4 26H8V30H4zM14 26H18V30H14zM24 26H28V30H24zM11 5H21V7H11z"
    })), children);
  });
  var LoadBalancerNetwork32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerNetwork32(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$e || (_path258$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v4H7V18h8v4h2V18h8v4h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8h8zM14 8V4h4V8zM26 24a2.9948 2.9948 0 00-2.8157 2H18.8157a2.982 2.982 0 00-5.6314 0H8.8157a3 3 0 100 2h4.3686a2.982 2.982 0 005.6314 0h4.3686A2.9947 2.9947 0 1026 24zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0116 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerNetwork24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerNetwork24(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$e || (_path259$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v4H7V18h8v4h2V18h8v4h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8h8zM14 8V4h4V8zM26 24a2.9948 2.9948 0 00-2.8157 2H18.8157a2.982 2.982 0 00-5.6314 0H8.8157a3 3 0 100 2h4.3686a2.982 2.982 0 005.6314 0h4.3686A2.9947 2.9947 0 1026 24zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0116 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerNetwork20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerNetwork20(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$e || (_path260$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v4H7V18h8v4h2V18h8v4h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8h8zM14 8V4h4V8zM26 24a2.9948 2.9948 0 00-2.8157 2H18.8157a2.982 2.982 0 00-5.6314 0H8.8157a3 3 0 100 2h4.3686a2.982 2.982 0 005.6314 0h4.3686A2.9947 2.9947 0 1026 24zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0116 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerNetwork16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerNetwork16(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$e || (_path261$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 16H17V12H15v4H7a2.0023 2.0023 0 00-2 2v4H7V18h8v4h2V18h8v4h2V18A2.0023 2.0023 0 0025 16zM20 10V2H12v8h8zM14 8V4h4V8zM26 24a2.9948 2.9948 0 00-2.8157 2H18.8157a2.982 2.982 0 00-5.6314 0H8.8157a3 3 0 100 2h4.3686a2.982 2.982 0 005.6314 0h4.3686A2.9947 2.9947 0 1026 24zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0116 28zm10 0a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerPool32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerPool32(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$e || (_path262$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 15H22V17H10zM8.7 6.2852A2.9665 2.9665 0 009 5 3 3 0 106 8a2.96 2.96 0 001.2852-.3008L10 10.4141V13h2V9.5859zM6 6A1 1 0 117 5 1.0009 1.0009 0 016 6zM19 5a3 3 0 10-4 2.8154V13h2V7.8159A2.9957 2.9957 0 0019 5zM16 6a1 1 0 111-1A1.0009 1.0009 0 0116 6zM26 2a3.0033 3.0033 0 00-3 3 2.9665 2.9665 0 00.3 1.2852L20 9.5859V13h2V10.4141l2.7148-2.7149A2.96 2.96 0 0026 8a3 3 0 000-6zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 6zM12 19H10v2.5859L7.2854 24.3008A2.9609 2.9609 0 006 24a3 3 0 103 3 2.9665 2.9665 0 00-.3-1.2852L12 22.4141zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zM17 24.1841V19H15v5.1841a3 3 0 102 0zM16 28a1 1 0 111-1A1.0009 1.0009 0 0116 28zM26 24a2.9609 2.9609 0 00-1.2854.3008L22 21.5859V19H20v3.4141l3.3 3.3007A2.9665 2.9665 0 0023 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerPool24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerPool24(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$e || (_path263$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 15H22V17H10zM8.7 6.2852A2.9665 2.9665 0 009 5 3 3 0 106 8a2.96 2.96 0 001.2852-.3008L10 10.4141V13h2V9.5859zM6 6A1 1 0 117 5 1.0009 1.0009 0 016 6zM19 5a3 3 0 10-4 2.8154V13h2V7.8159A2.9957 2.9957 0 0019 5zM16 6a1 1 0 111-1A1.0009 1.0009 0 0116 6zM26 2a3.0033 3.0033 0 00-3 3 2.9665 2.9665 0 00.3 1.2852L20 9.5859V13h2V10.4141l2.7148-2.7149A2.96 2.96 0 0026 8a3 3 0 000-6zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 6zM12 19H10v2.5859L7.2854 24.3008A2.9609 2.9609 0 006 24a3 3 0 103 3 2.9665 2.9665 0 00-.3-1.2852L12 22.4141zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zM17 24.1841V19H15v5.1841a3 3 0 102 0zM16 28a1 1 0 111-1A1.0009 1.0009 0 0116 28zM26 24a2.9609 2.9609 0 00-1.2854.3008L22 21.5859V19H20v3.4141l3.3 3.3007A2.9665 2.9665 0 0023 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerPool20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerPool20(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$e || (_path264$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 15H22V17H10zM8.7 6.2852A2.9665 2.9665 0 009 5 3 3 0 106 8a2.96 2.96 0 001.2852-.3008L10 10.4141V13h2V9.5859zM6 6A1 1 0 117 5 1.0009 1.0009 0 016 6zM19 5a3 3 0 10-4 2.8154V13h2V7.8159A2.9957 2.9957 0 0019 5zM16 6a1 1 0 111-1A1.0009 1.0009 0 0116 6zM26 2a3.0033 3.0033 0 00-3 3 2.9665 2.9665 0 00.3 1.2852L20 9.5859V13h2V10.4141l2.7148-2.7149A2.96 2.96 0 0026 8a3 3 0 000-6zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 6zM12 19H10v2.5859L7.2854 24.3008A2.9609 2.9609 0 006 24a3 3 0 103 3 2.9665 2.9665 0 00-.3-1.2852L12 22.4141zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zM17 24.1841V19H15v5.1841a3 3 0 102 0zM16 28a1 1 0 111-1A1.0009 1.0009 0 0116 28zM26 24a2.9609 2.9609 0 00-1.2854.3008L22 21.5859V19H20v3.4141l3.3 3.3007A2.9665 2.9665 0 0023 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerPool16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerPool16(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$e || (_path265$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 15H22V17H10zM8.7 6.2852A2.9665 2.9665 0 009 5 3 3 0 106 8a2.96 2.96 0 001.2852-.3008L10 10.4141V13h2V9.5859zM6 6A1 1 0 117 5 1.0009 1.0009 0 016 6zM19 5a3 3 0 10-4 2.8154V13h2V7.8159A2.9957 2.9957 0 0019 5zM16 6a1 1 0 111-1A1.0009 1.0009 0 0116 6zM26 2a3.0033 3.0033 0 00-3 3 2.9665 2.9665 0 00.3 1.2852L20 9.5859V13h2V10.4141l2.7148-2.7149A2.96 2.96 0 0026 8a3 3 0 000-6zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 6zM12 19H10v2.5859L7.2854 24.3008A2.9609 2.9609 0 006 24a3 3 0 103 3 2.9665 2.9665 0 00-.3-1.2852L12 22.4141zM6 28a1 1 0 111-1A1.0009 1.0009 0 016 28zM17 24.1841V19H15v5.1841a3 3 0 102 0zM16 28a1 1 0 111-1A1.0009 1.0009 0 0116 28zM26 24a2.9609 2.9609 0 00-1.2854.3008L22 21.5859V19H20v3.4141l3.3 3.3007A2.9665 2.9665 0 0023 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0126 28z"
    })), children);
  });
  var LoadBalancerVpc32 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerVpc32(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$e || (_path266$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2V24H8zM4 28H6V26H4zM19 30H13V24h6zm-4-2h2V26H15zM30 30H24V24h6zm-4-2h2V26H26zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.002 2.002 0 0016 4zM26 16H21a4.0045 4.0045 0 01-4-4H15a4.0045 4.0045 0 01-4 4H6a2.0023 2.0023 0 00-2 2v4H6V18h5A5.9694 5.9694 0 0015 16.46V22h2V16.46A5.9694 5.9694 0 0021 18h5v4h2V18A2.0023 2.0023 0 0026 16z"
    })), children);
  });
  var LoadBalancerVpc24 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerVpc24(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$e || (_path267$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2V24H8zM4 28H6V26H4zM19 30H13V24h6zm-4-2h2V26H15zM30 30H24V24h6zm-4-2h2V26H26zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.002 2.002 0 0016 4zM26 16H21a4.0045 4.0045 0 01-4-4H15a4.0045 4.0045 0 01-4 4H6a2.0023 2.0023 0 00-2 2v4H6V18h5A5.9694 5.9694 0 0015 16.46V22h2V16.46A5.9694 5.9694 0 0021 18h5v4h2V18A2.0023 2.0023 0 0026 16z"
    })), children);
  });
  var LoadBalancerVpc20 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerVpc20(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$e || (_path268$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2V24H8zM4 28H6V26H4zM19 30H13V24h6zm-4-2h2V26H15zM30 30H24V24h6zm-4-2h2V26H26zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.002 2.002 0 0016 4zM26 16H21a4.0045 4.0045 0 01-4-4H15a4.0045 4.0045 0 01-4 4H6a2.0023 2.0023 0 00-2 2v4H6V18h5A5.9694 5.9694 0 0015 16.46V22h2V16.46A5.9694 5.9694 0 0021 18h5v4h2V18A2.0023 2.0023 0 0026 16z"
    })), children);
  });
  var LoadBalancerVpc16 = /*#__PURE__*/React__default['default'].forwardRef(function LoadBalancerVpc16(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$e || (_path269$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2V24H8zM4 28H6V26H4zM19 30H13V24h6zm-4-2h2V26H15zM30 30H24V24h6zm-4-2h2V26H26zM16 10a4 4 0 114-4A4.0045 4.0045 0 0116 10zm0-6a2 2 0 102 2A2.002 2.002 0 0016 4zM26 16H21a4.0045 4.0045 0 01-4-4H15a4.0045 4.0045 0 01-4 4H6a2.0023 2.0023 0 00-2 2v4H6V18h5A5.9694 5.9694 0 0015 16.46V22h2V16.46A5.9694 5.9694 0 0021 18h5v4h2V18A2.0023 2.0023 0 0026 16z"
    })), children);
  });
  var Location32 = /*#__PURE__*/React__default['default'].forwardRef(function Location32(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$e || (_path270$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,18Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,10Z"
    })), _path271$e || (_path271$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,1,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var Location24 = /*#__PURE__*/React__default['default'].forwardRef(function Location24(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$e || (_path272$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,18Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,10Z"
    })), _path273$e || (_path273$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,1,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var Location20 = /*#__PURE__*/React__default['default'].forwardRef(function Location20(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$e || (_path274$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,18Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,10Z"
    })), _path275$e || (_path275$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,1,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var Location16 = /*#__PURE__*/React__default['default'].forwardRef(function Location16(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$e || (_path276$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,18Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,10Z"
    })), _path277$e || (_path277$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,1,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationCompany32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompany32(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$e || (_path278$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), _path279$e || (_path279$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Z"
    })), _path280$e || (_path280$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16H17V18H15zM15 12H17V14H15z"
    })), children);
  });
  var LocationCompany24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompany24(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$e || (_path281$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), _path282$e || (_path282$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Z"
    })), _path283$e || (_path283$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16H17V18H15zM15 12H17V14H15z"
    })), children);
  });
  var LocationCompany20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompany20(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$e || (_path284$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), _path285$e || (_path285$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Z"
    })), _path286$e || (_path286$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16H17V18H15zM15 12H17V14H15z"
    })), children);
  });
  var LocationCompany16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompany16(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$e || (_path287$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), _path288$e || (_path288$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Z"
    })), _path289$e || (_path289$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 16H17V18H15zM15 12H17V14H15z"
    })), children);
  });
  var LocationCompanyFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompanyFilled32(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$e || (_path290$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Zm-4-2H15v2h2Zm0-4H15v2h2Z"
    })), _path291$e || (_path291$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm1,16H15V16h2Zm0-4H15V12h2Zm4,4H19V10H13v8H11V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationCompanyFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompanyFilled24(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$e || (_path292$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Zm-4-2H15v2h2Zm0-4H15v2h2Z"
    })), _path293$e || (_path293$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm1,16H15V16h2Zm0-4H15V12h2Zm4,4H19V10H13v8H11V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationCompanyFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompanyFilled20(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$e || (_path294$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Zm-4-2H15v2h2Zm0-4H15v2h2Z"
    })), _path295$e || (_path295$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm1,16H15V16h2Zm0-4H15V12h2Zm4,4H19V10H13v8H11V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationCompanyFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCompanyFilled16(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$e || (_path296$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21,18H19V10H13v8H11V10a2.0021,2.0021,0,0,1,2-2h6a2.0021,2.0021,0,0,1,2,2Zm-4-2H15v2h2Zm0-4H15v2h2Z"
    })), _path297$e || (_path297$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm1,16H15V16h2Zm0-4H15V12h2Zm4,4H19V10H13v8H11V10a2.0023,2.0023,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationCurrent32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCurrent32(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$e || (_path298$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,12.9835a1,1,0,0,0,.6289.9448l9.6015,3.8409,3.8407,9.6019A1,1,0,0,0,19,28h.0162a1.0009,1.0009,0,0,0,.9238-.6582l8-22.0007A1,1,0,0,0,26.658,4.0594l-22,8A1.0011,1.0011,0,0,0,4,12.9835Z"
    })), children);
  });
  var LocationCurrent24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCurrent24(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$e || (_path299$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,12.9835a1,1,0,0,0,.6289.9448l9.6015,3.8409,3.8407,9.6019A1,1,0,0,0,19,28h.0162a1.0009,1.0009,0,0,0,.9238-.6582l8-22.0007A1,1,0,0,0,26.658,4.0594l-22,8A1.0011,1.0011,0,0,0,4,12.9835Z"
    })), children);
  });
  var LocationCurrent20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCurrent20(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$e || (_path300$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,12.9835a1,1,0,0,0,.6289.9448l9.6015,3.8409,3.8407,9.6019A1,1,0,0,0,19,28h.0162a1.0009,1.0009,0,0,0,.9238-.6582l8-22.0007A1,1,0,0,0,26.658,4.0594l-22,8A1.0011,1.0011,0,0,0,4,12.9835Z"
    })), children);
  });
  var LocationCurrent16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationCurrent16(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$e || (_path301$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,12.9835a1,1,0,0,0,.6289.9448l9.6015,3.8409,3.8407,9.6019A1,1,0,0,0,19,28h.0162a1.0009,1.0009,0,0,0,.9238-.6582l8-22.0007A1,1,0,0,0,26.658,4.0594l-22,8A1.0011,1.0011,0,0,0,4,12.9835Z"
    })), children);
  });
  var LocationFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationFilled32(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$e || (_path302$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,17Z"
    })), _circle9$c || (_circle9$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "4",
      fill: "none"
    })), children);
  });
  var LocationFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationFilled24(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$e || (_path303$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,17Z"
    })), _circle10$c || (_circle10$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "4",
      fill: "none"
    })), children);
  });
  var LocationFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationFilled20(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$e || (_path304$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,17Z"
    })), _circle11$b || (_circle11$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "4",
      fill: "none"
    })), children);
  });
  var LocationFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationFilled16(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$e || (_path305$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,15a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,17Z"
    })), _circle12$b || (_circle12$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "4",
      fill: "none"
    })), children);
  });
  var LocationHazard32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazard32(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$b || (_circle13$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "20.5",
      r: "1.5"
    })), _path306$e || (_path306$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V16H15z"
    })), _path307$e || (_path307$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHazard24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazard24(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$b || (_circle14$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "20.5",
      r: "1.5"
    })), _path308$e || (_path308$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V16H15z"
    })), _path309$e || (_path309$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHazard20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazard20(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$b || (_circle15$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "20.5",
      r: "1.5"
    })), _path310$e || (_path310$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V16H15z"
    })), _path311$e || (_path311$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHazard16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazard16(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$b || (_circle16$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "20.5",
      r: "1.5"
    })), _path312$e || (_path312$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 7H17V16H15z"
    })), _path313$e || (_path313$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHazardFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazardFilled32(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$e || (_path314$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Zm-1.125-6h2.25V7h-2.25Z"
    })), _path315$e || (_path315$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2ZM14.875,7h2.25v9h-2.25ZM16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Z"
    })), children);
  });
  var LocationHazardFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazardFilled24(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$e || (_path316$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Zm-1.125-6h2.25V7h-2.25Z"
    })), _path317$e || (_path317$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2ZM14.875,7h2.25v9h-2.25ZM16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Z"
    })), children);
  });
  var LocationHazardFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazardFilled20(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$e || (_path318$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Zm-1.125-6h2.25V7h-2.25Z"
    })), _path319$e || (_path319$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2ZM14.875,7h2.25v9h-2.25ZM16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Z"
    })), children);
  });
  var LocationHazardFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHazardFilled16(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$e || (_path320$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Zm-1.125-6h2.25V7h-2.25Z"
    })), _path321$e || (_path321$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2ZM14.875,7h2.25v9h-2.25ZM16,22a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,22Z"
    })), children);
  });
  var LocationHeart32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeart32(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$e || (_path322$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path323$e || (_path323$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHeart24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeart24(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$e || (_path324$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path325$e || (_path325$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHeart20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeart20(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$e || (_path326$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path327$e || (_path327$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHeart16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeart16(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$e || (_path328$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path329$e || (_path329$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationHeartFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeartFilled32(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$e || (_path330$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path331$e || (_path331$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm4.2109,11.7021L16.002,18l-4.2129-4.2979a2.7992,2.7992,0,0,1,0-3.8964,2.6619,2.6619,0,0,1,3.8159,0l.397.4057.393-.4057a2.6619,2.6619,0,0,1,3.8159,0A2.7992,2.7992,0,0,1,20.2109,13.7021Z"
    })), children);
  });
  var LocationHeartFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeartFilled24(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$e || (_path332$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path333$e || (_path333$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm4.2109,11.7021L16.002,18l-4.2129-4.2979a2.7992,2.7992,0,0,1,0-3.8964,2.6619,2.6619,0,0,1,3.8159,0l.397.4057.393-.4057a2.6619,2.6619,0,0,1,3.8159,0A2.7992,2.7992,0,0,1,20.2109,13.7021Z"
    })), children);
  });
  var LocationHeartFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeartFilled20(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$e || (_path334$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path335$e || (_path335$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm4.2109,11.7021L16.002,18l-4.2129-4.2979a2.7992,2.7992,0,0,1,0-3.8964,2.6619,2.6619,0,0,1,3.8159,0l.397.4057.393-.4057a2.6619,2.6619,0,0,1,3.8159,0A2.7992,2.7992,0,0,1,20.2109,13.7021Z"
    })), children);
  });
  var LocationHeartFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationHeartFilled16(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$e || (_path336$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M18.303,9a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,18l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,9Z"
    })), _path337$e || (_path337$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm4.2109,11.7021L16.002,18l-4.2129-4.2979a2.7992,2.7992,0,0,1,0-3.8964,2.6619,2.6619,0,0,1,3.8159,0l.397.4057.393-.4057a2.6619,2.6619,0,0,1,3.8159,0A2.7992,2.7992,0,0,1,20.2109,13.7021Z"
    })), children);
  });
  var LocationPerson32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPerson32(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$d || (_path338$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H18V17H14v2H12V17a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2zM16 14a3 3 0 113-3A3.0033 3.0033 0 0116 14zm0-4a1 1 0 101 1A1.0011 1.0011 0 0016 10z"
    })), _path339$d || (_path339$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationPerson24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPerson24(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$d || (_path340$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H18V17H14v2H12V17a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2zM16 14a3 3 0 113-3A3.0033 3.0033 0 0116 14zm0-4a1 1 0 101 1A1.0011 1.0011 0 0016 10z"
    })), _path341$d || (_path341$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationPerson20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPerson20(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$d || (_path342$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H18V17H14v2H12V17a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2zM16 14a3 3 0 113-3A3.0033 3.0033 0 0116 14zm0-4a1 1 0 101 1A1.0011 1.0011 0 0016 10z"
    })), _path343$d || (_path343$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationPerson16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPerson16(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$d || (_path344$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19H18V17H14v2H12V17a2.0021 2.0021 0 012-2h4a2.0021 2.0021 0 012 2zM16 14a3 3 0 113-3A3.0033 3.0033 0 0116 14zm0-4a1 1 0 101 1A1.0011 1.0011 0 0016 10z"
    })), _path345$d || (_path345$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationPersonFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPersonFilled32(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$d || (_path346$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,19H18V17H14v2H12V17a2.0021,2.0021,0,0,1,2-2h4a2.0021,2.0021,0,0,1,2,2Zm-1-8a3,3,0,1,0-3,3A3.0033,3.0033,0,0,0,19,11Zm-2,0a1,1,0,1,1-1-1A1.0011,1.0011,0,0,1,17,11Z"
    })), _circle17$a || (_circle17$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "11",
      r: "1"
    })), _path347$d || (_path347$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,6a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,8Zm4,11H18V17H14v2H12V17a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationPersonFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPersonFilled24(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$d || (_path348$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,19H18V17H14v2H12V17a2.0021,2.0021,0,0,1,2-2h4a2.0021,2.0021,0,0,1,2,2Zm-1-8a3,3,0,1,0-3,3A3.0033,3.0033,0,0,0,19,11Zm-2,0a1,1,0,1,1-1-1A1.0011,1.0011,0,0,1,17,11Z"
    })), _circle18$a || (_circle18$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "11",
      r: "1"
    })), _path349$d || (_path349$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,6a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,8Zm4,11H18V17H14v2H12V17a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationPersonFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPersonFilled20(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$d || (_path350$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,19H18V17H14v2H12V17a2.0021,2.0021,0,0,1,2-2h4a2.0021,2.0021,0,0,1,2,2Zm-1-8a3,3,0,1,0-3,3A3.0033,3.0033,0,0,0,19,11Zm-2,0a1,1,0,1,1-1-1A1.0011,1.0011,0,0,1,17,11Z"
    })), _circle19$a || (_circle19$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "11",
      r: "1"
    })), _path351$d || (_path351$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,6a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,8Zm4,11H18V17H14v2H12V17a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationPersonFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationPersonFilled16(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$d || (_path352$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M20,19H18V17H14v2H12V17a2.0021,2.0021,0,0,1,2-2h4a2.0021,2.0021,0,0,1,2,2Zm-1-8a3,3,0,1,0-3,3A3.0033,3.0033,0,0,0,19,11Zm-2,0a1,1,0,1,1-1-1A1.0011,1.0011,0,0,1,17,11Z"
    })), _circle20$a || (_circle20$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "11",
      r: "1"
    })), _path353$d || (_path353$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm0,6a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,8Zm4,11H18V17H14v2H12V17a2.0023,2.0023,0,0,1,2-2h4a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var LocationSave32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationSave32(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$d || (_path354$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30h2V28a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V28a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 24a4 4 0 114-4A4.0042 4.0042 0 0124 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.001 1.001 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6016-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0269 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var LocationSave24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationSave24(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$c || (_path355$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30h2V28a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V28a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 24a4 4 0 114-4A4.0042 4.0042 0 0124 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.001 1.001 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6016-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0269 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var LocationSave20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationSave20(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$c || (_path356$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30h2V28a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V28a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 24a4 4 0 114-4A4.0042 4.0042 0 0124 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.001 1.001 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6016-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0269 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var LocationSave16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationSave16(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$c || (_path357$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30h2V28a1.0009 1.0009 0 011-1h6a1.0009 1.0009 0 011 1v2h2V28a3.0033 3.0033 0 00-3-3H21a3.0033 3.0033 0 00-3 3zM24 24a4 4 0 114-4A4.0042 4.0042 0 0124 24zm0-6a2 2 0 102 2A2.0023 2.0023 0 0024 18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.001 1.001 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6016-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0269 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var LocationStar32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStar32(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$c || (_path358$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path359$c || (_path359$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationStar24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStar24(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$c || (_path360$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path361$b || (_path361$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationStar20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStar20(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$b || (_path362$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path363$b || (_path363$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationStar16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStar16(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$b || (_path364$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path365$b || (_path365$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,7.5645,20.0513c-.0479-.0571-.3482-.4515-.3482-.4515A10.8888,10.8888,0,0,1,5,13a11,11,0,0,1,22,0,10.8844,10.8844,0,0,1-2.2148,6.5973l-.0015.0025s-.3.3944-.3447.4474ZM8.8125,18.395c.001.0007.2334.3082.2866.3744L16,26.9079l6.91-8.15c.0439-.0552.2783-.3649.2788-.3657A8.901,8.901,0,0,0,25,13,9,9,0,0,0,7,13a8.9054,8.9054,0,0,0,1.8125,5.395Z"
    })), children);
  });
  var LocationStarFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStarFilled32(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$b || (_path366$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path367$b || (_path367$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm3.6,16L16,15.7085,12.4,18l.6-4.0742-3-2.7529,4.2-.5064L16,7l1.9116,3.6665L22,11.1729l-3,2.7529Z"
    })), children);
  });
  var LocationStarFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStarFilled24(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$b || (_path368$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path369$b || (_path369$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm3.6,16L16,15.7085,12.4,18l.6-4.0742-3-2.7529,4.2-.5064L16,7l1.9116,3.6665L22,11.1729l-3,2.7529Z"
    })), children);
  });
  var LocationStarFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStarFilled20(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$b || (_path370$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path371$b || (_path371$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm3.6,16L16,15.7085,12.4,18l.6-4.0742-3-2.7529,4.2-.5064L16,7l1.9116,3.6665L22,11.1729l-3,2.7529Z"
    })), children);
  });
  var LocationStarFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function LocationStarFilled16(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$b || (_path372$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 7L17.912 10.667 22 11.173 19 13.926 19.6 18 16 15.708 12.4 18 13 13.926 10 11.173 14.2 10.667 16 7z"
    })), _path373$b || (_path373$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A11.0134,11.0134,0,0,0,5,13a10.8885,10.8885,0,0,0,2.2163,6.6s.3.3945.3482.4517L16,30l8.439-9.9526c.0444-.0533.3447-.4478.3447-.4478l.0015-.0024A10.8846,10.8846,0,0,0,27,13,11.0134,11.0134,0,0,0,16,2Zm3.6,16L16,15.7085,12.4,18l.6-4.0742-3-2.7529,4.2-.5064L16,7l1.9116,3.6665L22,11.1729l-3,2.7529Z"
    })), children);
  });
  var Locked32 = /*#__PURE__*/React__default['default'].forwardRef(function Locked32(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$b || (_path374$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"
    })), children);
  });
  var Locked24 = /*#__PURE__*/React__default['default'].forwardRef(function Locked24(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$b || (_path375$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"
    })), children);
  });
  var Locked20 = /*#__PURE__*/React__default['default'].forwardRef(function Locked20(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$b || (_path376$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"
    })), children);
  });
  var Locked16 = /*#__PURE__*/React__default['default'].forwardRef(function Locked16(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$b || (_path377$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"
    })), children);
  });
  var LogicalPartition32 = /*#__PURE__*/React__default['default'].forwardRef(function LogicalPartition32(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21$a || (_circle21$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path378$b || (_path378$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4H2v8h8V22H7V18h8v4H12v8h8V22H17V18h8v4H22v8h8V22ZM8,28H4V24H8Zm10-4v4H14V24ZM6,10V4H26v6ZM28,28H24V24h4Z"
    })), children);
  });
  var LogicalPartition24 = /*#__PURE__*/React__default['default'].forwardRef(function LogicalPartition24(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22$a || (_circle22$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path379$b || (_path379$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4H2v8h8V22H7V18h8v4H12v8h8V22H17V18h8v4H22v8h8V22ZM8,28H4V24H8Zm10-4v4H14V24ZM6,10V4H26v6ZM28,28H24V24h4Z"
    })), children);
  });
  var LogicalPartition20 = /*#__PURE__*/React__default['default'].forwardRef(function LogicalPartition20(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle23$9 || (_circle23$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path380$b || (_path380$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4H2v8h8V22H7V18h8v4H12v8h8V22H17V18h8v4H22v8h8V22ZM8,28H4V24H8Zm10-4v4H14V24ZM6,10V4H26v6ZM28,28H24V24h4Z"
    })), children);
  });
  var LogicalPartition16 = /*#__PURE__*/React__default['default'].forwardRef(function LogicalPartition16(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle24$9 || (_circle24$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "7",
      r: "1"
    })), _path381$b || (_path381$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4H2v8h8V22H7V18h8v4H12v8h8V22H17V18h8v4H22v8h8V22ZM8,28H4V24H8Zm10-4v4H14V24ZM6,10V4H26v6ZM28,28H24V24h4Z"
    })), children);
  });
  var Login32 = /*#__PURE__*/React__default['default'].forwardRef(function Login32(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$b || (_path382$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path383$b || (_path383$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"
    })), children);
  });
  var Login24 = /*#__PURE__*/React__default['default'].forwardRef(function Login24(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$a || (_path384$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path385$a || (_path385$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"
    })), children);
  });
  var Login20 = /*#__PURE__*/React__default['default'].forwardRef(function Login20(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$a || (_path386$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path387$a || (_path387$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"
    })), children);
  });
  var Login16 = /*#__PURE__*/React__default['default'].forwardRef(function Login16(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$a || (_path388$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path389$a || (_path389$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"
    })), children);
  });
  var LogoDelicious32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDelicious32(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$4['LogoDelicious32']) {
        didWarnAboutDeprecation$4['LogoDelicious32'] = true;
        console.warn("The LogoDelicious32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$a || (_path390$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V28H4zM16 4H28V16H16z"
    })), children);
  });
  var LogoDelicious24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDelicious24(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$4['LogoDelicious24']) {
        didWarnAboutDeprecation$4['LogoDelicious24'] = true;
        console.warn("The LogoDelicious24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$a || (_path391$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V28H4zM16 4H28V16H16z"
    })), children);
  });
  var LogoDelicious20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDelicious20(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$4['LogoDelicious20']) {
        didWarnAboutDeprecation$4['LogoDelicious20'] = true;
        console.warn("The LogoDelicious20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$a || (_path392$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V28H4zM16 4H28V16H16z"
    })), children);
  });
  var LogoDelicious16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDelicious16(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$4['LogoDelicious16']) {
        didWarnAboutDeprecation$4['LogoDelicious16'] = true;
        console.warn("The LogoDelicious16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$a || (_path393$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 16H16V28H4zM16 4H28V16H16z"
    })), children);
  });
  var LogoDigg32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDigg32(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$a || (_path394$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"
    })), children);
  });
  var LogoDigg24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDigg24(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$a || (_path395$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"
    })), children);
  });
  var LogoDigg20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDigg20(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$a || (_path396$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"
    })), children);
  });
  var LogoDigg16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDigg16(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$a || (_path397$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"
    })), children);
  });
  var LogoDiscord32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDiscord32(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$a || (_path398$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.647,14.907a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,13.647,14.907Zm4.745,0a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,18.392,14.907Z"
    })), _path399$9 || (_path399$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.71,4H7.29A2.6714,2.6714,0,0,0,4.625,6.678V24.254A2.6714,2.6714,0,0,0,7.29,26.932H22.032l-.689-2.405,1.664,1.547L24.58,27.53,27.375,30V6.678A2.6714,2.6714,0,0,0,24.71,4ZM19.692,20.978s-.468-.559-.858-1.053a4.1021,4.1021,0,0,0,2.353-1.547,7.4391,7.4391,0,0,1-1.495.767,8.5564,8.5564,0,0,1-1.885.559,9.1068,9.1068,0,0,1-3.367-.013,10.9127,10.9127,0,0,1-1.911-.559,7.6184,7.6184,0,0,1-.949-.442c-.039-.026-.078-.039-.117-.065a.18.18,0,0,1-.052-.039c-.234-.13-.364-.221-.364-.221a4.0432,4.0432,0,0,0,2.275,1.534c-.39.494-.871,1.079-.871,1.079a4.7134,4.7134,0,0,1-3.965-1.976,17.409,17.409,0,0,1,1.872-7.579,6.4285,6.4285,0,0,1,3.653-1.365l.13.156a8.77,8.77,0,0,0-3.419,1.703s.286-.156.767-.377a9.7625,9.7625,0,0,1,2.951-.819,1.2808,1.2808,0,0,1,.221-.026,11,11,0,0,1,2.626-.026A10.5971,10.5971,0,0,1,21.2,11.917a8.6518,8.6518,0,0,0-3.237-1.651l.182-.208a6.4285,6.4285,0,0,1,3.653,1.365,17.409,17.409,0,0,1,1.872,7.579A4.752,4.752,0,0,1,19.692,20.978Z"
    })), children);
  });
  var LogoDiscord24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDiscord24(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$9 || (_path400$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.647,14.907a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,13.647,14.907Zm4.745,0a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,18.392,14.907Z"
    })), _path401$9 || (_path401$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.71,4H7.29A2.6714,2.6714,0,0,0,4.625,6.678V24.254A2.6714,2.6714,0,0,0,7.29,26.932H22.032l-.689-2.405,1.664,1.547L24.58,27.53,27.375,30V6.678A2.6714,2.6714,0,0,0,24.71,4ZM19.692,20.978s-.468-.559-.858-1.053a4.1021,4.1021,0,0,0,2.353-1.547,7.4391,7.4391,0,0,1-1.495.767,8.5564,8.5564,0,0,1-1.885.559,9.1068,9.1068,0,0,1-3.367-.013,10.9127,10.9127,0,0,1-1.911-.559,7.6184,7.6184,0,0,1-.949-.442c-.039-.026-.078-.039-.117-.065a.18.18,0,0,1-.052-.039c-.234-.13-.364-.221-.364-.221a4.0432,4.0432,0,0,0,2.275,1.534c-.39.494-.871,1.079-.871,1.079a4.7134,4.7134,0,0,1-3.965-1.976,17.409,17.409,0,0,1,1.872-7.579,6.4285,6.4285,0,0,1,3.653-1.365l.13.156a8.77,8.77,0,0,0-3.419,1.703s.286-.156.767-.377a9.7625,9.7625,0,0,1,2.951-.819,1.2808,1.2808,0,0,1,.221-.026,11,11,0,0,1,2.626-.026A10.5971,10.5971,0,0,1,21.2,11.917a8.6518,8.6518,0,0,0-3.237-1.651l.182-.208a6.4285,6.4285,0,0,1,3.653,1.365,17.409,17.409,0,0,1,1.872,7.579A4.752,4.752,0,0,1,19.692,20.978Z"
    })), children);
  });
  var LogoDiscord20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDiscord20(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$9 || (_path402$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.647,14.907a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,13.647,14.907Zm4.745,0a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,18.392,14.907Z"
    })), _path403$8 || (_path403$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.71,4H7.29A2.6714,2.6714,0,0,0,4.625,6.678V24.254A2.6714,2.6714,0,0,0,7.29,26.932H22.032l-.689-2.405,1.664,1.547L24.58,27.53,27.375,30V6.678A2.6714,2.6714,0,0,0,24.71,4ZM19.692,20.978s-.468-.559-.858-1.053a4.1021,4.1021,0,0,0,2.353-1.547,7.4391,7.4391,0,0,1-1.495.767,8.5564,8.5564,0,0,1-1.885.559,9.1068,9.1068,0,0,1-3.367-.013,10.9127,10.9127,0,0,1-1.911-.559,7.6184,7.6184,0,0,1-.949-.442c-.039-.026-.078-.039-.117-.065a.18.18,0,0,1-.052-.039c-.234-.13-.364-.221-.364-.221a4.0432,4.0432,0,0,0,2.275,1.534c-.39.494-.871,1.079-.871,1.079a4.7134,4.7134,0,0,1-3.965-1.976,17.409,17.409,0,0,1,1.872-7.579,6.4285,6.4285,0,0,1,3.653-1.365l.13.156a8.77,8.77,0,0,0-3.419,1.703s.286-.156.767-.377a9.7625,9.7625,0,0,1,2.951-.819,1.2808,1.2808,0,0,1,.221-.026,11,11,0,0,1,2.626-.026A10.5971,10.5971,0,0,1,21.2,11.917a8.6518,8.6518,0,0,0-3.237-1.651l.182-.208a6.4285,6.4285,0,0,1,3.653,1.365,17.409,17.409,0,0,1,1.872,7.579A4.752,4.752,0,0,1,19.692,20.978Z"
    })), children);
  });
  var LogoDiscord16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoDiscord16(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$8 || (_path404$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.647,14.907a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,13.647,14.907Zm4.745,0a1.4482,1.4482,0,1,0,1.326,1.443A1.385,1.385,0,0,0,18.392,14.907Z"
    })), _path405$8 || (_path405$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.71,4H7.29A2.6714,2.6714,0,0,0,4.625,6.678V24.254A2.6714,2.6714,0,0,0,7.29,26.932H22.032l-.689-2.405,1.664,1.547L24.58,27.53,27.375,30V6.678A2.6714,2.6714,0,0,0,24.71,4ZM19.692,20.978s-.468-.559-.858-1.053a4.1021,4.1021,0,0,0,2.353-1.547,7.4391,7.4391,0,0,1-1.495.767,8.5564,8.5564,0,0,1-1.885.559,9.1068,9.1068,0,0,1-3.367-.013,10.9127,10.9127,0,0,1-1.911-.559,7.6184,7.6184,0,0,1-.949-.442c-.039-.026-.078-.039-.117-.065a.18.18,0,0,1-.052-.039c-.234-.13-.364-.221-.364-.221a4.0432,4.0432,0,0,0,2.275,1.534c-.39.494-.871,1.079-.871,1.079a4.7134,4.7134,0,0,1-3.965-1.976,17.409,17.409,0,0,1,1.872-7.579,6.4285,6.4285,0,0,1,3.653-1.365l.13.156a8.77,8.77,0,0,0-3.419,1.703s.286-.156.767-.377a9.7625,9.7625,0,0,1,2.951-.819,1.2808,1.2808,0,0,1,.221-.026,11,11,0,0,1,2.626-.026A10.5971,10.5971,0,0,1,21.2,11.917a8.6518,8.6518,0,0,0-3.237-1.651l.182-.208a6.4285,6.4285,0,0,1,3.653,1.365,17.409,17.409,0,0,1,1.872,7.579A4.752,4.752,0,0,1,19.692,20.978Z"
    })), children);
  });
  var LogoFacebook32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFacebook32(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$8 || (_path406$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"
    })), children);
  });
  var LogoFacebook24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFacebook24(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$8 || (_path407$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"
    })), children);
  });
  var LogoFacebook20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFacebook20(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$8 || (_path408$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"
    })), children);
  });
  var LogoFacebook16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFacebook16(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$8 || (_path409$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"
    })), children);
  });
  var LogoFlickr32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFlickr32(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle25$8 || (_circle25$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "6"
    })), _circle26$8 || (_circle26$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "6"
    })), children);
  });

  var _circle$d, _circle2$d, _circle3$d, _circle4$c, _circle5$b, _circle6$b, _path$e, _path2$e, _path3$e, _path4$e, _path5$e, _path6$e, _path7$e, _path8$e, _path9$e, _path10$e, _path11$e, _path12$e, _path13$e, _path14$e, _path15$e, _path16$e, _circle7$b, _path17$e, _path18$e, _circle8$b, _path19$e, _path20$e, _circle9$b, _path21$e, _path22$e, _circle10$b, _path23$e, _path24$e, _path25$e, _path26$e, _path27$e, _path28$e, _path29$e, _path30$e, _path31$e, _path32$e, _path33$e, _path34$e, _path35$e, _path36$e, _path37$e, _path38$e, _path39$e, _path40$e, _path41$e, _path42$e, _path43$e, _path44$e, _path45$e, _path46$e, _path47$e, _path48$e, _path49$e, _path50$e, _path51$e, _path52$e, _path53$e, _path54$e, _path55$e, _path56$e, _path57$e, _path58$e, _path59$e, _path60$e, _path61$e, _path62$e, _path63$e, _path64$e, _path65$e, _path66$e, _path67$e, _path68$e, _path69$e, _path70$e, _path71$e, _path72$e, _path73$e, _path74$e, _path75$e, _path76$e, _path77$e, _path78$e, _path79$e, _path80$e, _path81$e, _path82$e, _path83$e, _path84$e, _path85$e, _path86$e, _path87$e, _path88$e, _path89$e, _path90$e, _path91$e, _path92$e, _path93$e, _path94$e, _path95$e, _path96$e, _path97$e, _path98$e, _path99$e, _path100$e, _path101$e, _path102$e, _path103$e, _path104$e, _path105$e, _path106$e, _path107$e, _path108$e, _path109$e, _path110$e, _path111$e, _path112$e, _path113$e, _path114$e, _path115$e, _path116$e, _path117$e, _path118$e, _path119$e, _path120$e, _path121$e, _path122$e, _path123$e, _path124$e, _path125$e, _path126$e, _path127$e, _path128$e, _path129$e, _path130$e, _path131$e, _path132$e, _path133$e, _path134$e, _path135$e, _path136$e, _path137$e, _path138$e, _path139$e, _path140$e, _path141$e, _path142$e, _path143$e, _path144$e, _path145$e, _path146$e, _path147$e, _path148$e, _path149$e, _path150$e, _path151$e, _path152$e, _path153$e, _path154$e, _path155$e, _path156$e, _path157$e, _path158$e, _path159$e, _path160$e, _path161$e, _path162$e, _path163$e, _path164$e, _path165$e, _path166$e, _path167$e, _path168$e, _path169$e, _path170$e, _path171$e, _path172$e, _path173$e, _path174$e, _path175$e, _path176$e, _path177$d, _path178$d, _path179$d, _path180$d, _path181$d, _path182$d, _path183$d, _path184$d, _path185$d, _path186$d, _path187$d, _path188$d, _path189$d, _path190$d, _path191$d, _path192$d, _path193$d, _path194$d, _path195$d, _path196$d, _path197$d, _path198$d, _path199$d, _path200$d, _path201$d, _path202$d, _path203$d, _path204$d, _path205$d, _path206$d, _path207$d, _path208$d, _path209$d, _path210$d, _path211$d, _path212$d, _path213$d, _path214$d, _path215$d, _path216$d, _path217$d, _path218$d, _path219$d, _path220$d, _path221$d, _path222$d, _path223$d, _path224$d, _path225$d, _path226$d, _path227$d, _path228$d, _path229$d, _path230$d, _path231$d, _path232$d, _path233$d, _path234$d, _path235$d, _path236$d, _path237$d, _path238$d, _path239$d, _path240$d, _path241$d, _path242$d, _path243$d, _path244$d, _path245$d, _path246$d, _path247$d, _path248$d, _path249$d, _path250$d, _path251$d, _path252$d, _path253$d, _path254$d, _path255$d, _path256$d, _path257$d, _path258$d, _path259$d, _path260$d, _path261$d, _path262$d, _path263$d, _path264$d, _path265$d, _path266$d, _path267$d, _path268$d, _path269$d, _path270$d, _path271$d, _path272$d, _path273$d, _path274$d, _path275$d, _circle11$a, _path276$d, _path277$d, _circle12$a, _path278$d, _path279$d, _circle13$a, _path280$d, _path281$d, _circle14$a, _path282$d, _path283$d, _path284$d, _path285$d, _path286$d, _path287$d, _path288$d, _path289$d, _path290$d, _path291$d, _path292$d, _path293$d, _path294$d, _path295$d, _path296$d, _path297$d, _path298$d, _path299$d, _path300$d, _path301$d, _path302$d, _path303$d, _path304$d, _path305$d, _path306$d, _path307$d, _path308$d, _path309$d, _path310$d, _path311$d, _path312$d, _path313$d, _path314$d, _path315$d, _path316$d, _path317$d, _path318$d, _path319$d, _path320$d, _path321$d, _path322$d, _path323$d, _path324$d, _path325$d, _path326$d, _path327$d, _path328$d, _path329$d, _path330$d, _path331$d, _path332$d, _path333$d, _path334$d, _path335$d, _path336$d, _path337$d, _path338$c, _path339$c, _path340$c, _path341$c, _path342$c, _path343$c, _path344$c, _path345$c, _path346$c, _path347$c, _path348$c, _path349$c, _path350$c, _path351$c, _path352$c, _path353$c, _path354$c, _path355$b, _path356$b, _path357$b, _path358$b, _path359$b, _path360$b, _path361$a, _path362$a, _path363$a, _path364$a, _path365$a, _path366$a, _path367$a, _path368$a, _circle15$a, _path369$a, _path370$a, _path371$a, _circle16$a, _path372$a, _path373$a, _path374$a, _circle17$9, _path375$a, _path376$a, _path377$a, _circle18$9, _path378$a, _path379$a, _circle19$9, _path380$a, _circle20$9, _path381$a, _circle21$9, _path382$a, _circle22$9, _path383$a, _path384$9, _path385$9, _path386$9, _path387$9, _path388$9, _path389$9, _path390$9, _path391$9, _path392$9, _path393$9, _path394$9, _path395$9, _path396$9, _path397$9, _path398$9, _path399$8, _path400$8, _path401$8, _path402$8, _path403$7, _path404$7, _path405$7, _path406$7, _path407$7, _path408$7, _path409$7, _path410$7, _path411$7, _path412$7, _path413$7, _path414$7, _path415$6, _path416$5, _path417$5, _path418$5;

  var _excluded$e = ["children"],
      _excluded2$e = ["children"],
      _excluded3$e = ["children"],
      _excluded4$e = ["children"],
      _excluded5$e = ["children"],
      _excluded6$e = ["children"],
      _excluded7$e = ["children"],
      _excluded8$e = ["children"],
      _excluded9$e = ["children"],
      _excluded10$e = ["children"],
      _excluded11$e = ["children"],
      _excluded12$e = ["children"],
      _excluded13$e = ["children"],
      _excluded14$e = ["children"],
      _excluded15$e = ["children"],
      _excluded16$e = ["children"],
      _excluded17$e = ["children"],
      _excluded18$e = ["children"],
      _excluded19$e = ["children"],
      _excluded20$e = ["children"],
      _excluded21$e = ["children"],
      _excluded22$e = ["children"],
      _excluded23$e = ["children"],
      _excluded24$e = ["children"],
      _excluded25$e = ["children"],
      _excluded26$e = ["children"],
      _excluded27$e = ["children"],
      _excluded28$e = ["children"],
      _excluded29$e = ["children"],
      _excluded30$e = ["children"],
      _excluded31$e = ["children"],
      _excluded32$e = ["children"],
      _excluded33$e = ["children"],
      _excluded34$e = ["children"],
      _excluded35$e = ["children"],
      _excluded36$e = ["children"],
      _excluded37$e = ["children"],
      _excluded38$e = ["children"],
      _excluded39$e = ["children"],
      _excluded40$e = ["children"],
      _excluded41$e = ["children"],
      _excluded42$e = ["children"],
      _excluded43$e = ["children"],
      _excluded44$e = ["children"],
      _excluded45$e = ["children"],
      _excluded46$e = ["children"],
      _excluded47$e = ["children"],
      _excluded48$e = ["children"],
      _excluded49$e = ["children"],
      _excluded50$e = ["children"],
      _excluded51$e = ["children"],
      _excluded52$e = ["children"],
      _excluded53$e = ["children"],
      _excluded54$e = ["children"],
      _excluded55$e = ["children"],
      _excluded56$e = ["children"],
      _excluded57$e = ["children"],
      _excluded58$e = ["children"],
      _excluded59$e = ["children"],
      _excluded60$e = ["children"],
      _excluded61$e = ["children"],
      _excluded62$e = ["children"],
      _excluded63$e = ["children"],
      _excluded64$e = ["children"],
      _excluded65$e = ["children"],
      _excluded66$e = ["children"],
      _excluded67$e = ["children"],
      _excluded68$e = ["children"],
      _excluded69$e = ["children"],
      _excluded70$e = ["children"],
      _excluded71$e = ["children"],
      _excluded72$e = ["children"],
      _excluded73$e = ["children"],
      _excluded74$e = ["children"],
      _excluded75$e = ["children"],
      _excluded76$e = ["children"],
      _excluded77$e = ["children"],
      _excluded78$e = ["children"],
      _excluded79$e = ["children"],
      _excluded80$e = ["children"],
      _excluded81$e = ["children"],
      _excluded82$e = ["children"],
      _excluded83$e = ["children"],
      _excluded84$e = ["children"],
      _excluded85$e = ["children"],
      _excluded86$e = ["children"],
      _excluded87$e = ["children"],
      _excluded88$e = ["children"],
      _excluded89$e = ["children"],
      _excluded90$e = ["children"],
      _excluded91$e = ["children"],
      _excluded92$e = ["children"],
      _excluded93$e = ["children"],
      _excluded94$e = ["children"],
      _excluded95$e = ["children"],
      _excluded96$e = ["children"],
      _excluded97$e = ["children"],
      _excluded98$e = ["children"],
      _excluded99$e = ["children"],
      _excluded100$e = ["children"],
      _excluded101$e = ["children"],
      _excluded102$e = ["children"],
      _excluded103$e = ["children"],
      _excluded104$e = ["children"],
      _excluded105$e = ["children"],
      _excluded106$e = ["children"],
      _excluded107$e = ["children"],
      _excluded108$e = ["children"],
      _excluded109$e = ["children"],
      _excluded110$e = ["children"],
      _excluded111$e = ["children"],
      _excluded112$e = ["children"],
      _excluded113$e = ["children"],
      _excluded114$e = ["children"],
      _excluded115$e = ["children"],
      _excluded116$e = ["children"],
      _excluded117$e = ["children"],
      _excluded118$e = ["children"],
      _excluded119$d = ["children"],
      _excluded120$d = ["children"],
      _excluded121$d = ["children"],
      _excluded122$d = ["children"],
      _excluded123$d = ["children"],
      _excluded124$d = ["children"],
      _excluded125$d = ["children"],
      _excluded126$d = ["children"],
      _excluded127$d = ["children"],
      _excluded128$d = ["children"],
      _excluded129$d = ["children"],
      _excluded130$d = ["children"],
      _excluded131$d = ["children"],
      _excluded132$d = ["children"],
      _excluded133$d = ["children"],
      _excluded134$d = ["children"],
      _excluded135$d = ["children"],
      _excluded136$d = ["children"],
      _excluded137$d = ["children"],
      _excluded138$d = ["children"],
      _excluded139$d = ["children"],
      _excluded140$d = ["children"],
      _excluded141$d = ["children"],
      _excluded142$d = ["children"],
      _excluded143$d = ["children"],
      _excluded144$d = ["children"],
      _excluded145$d = ["children"],
      _excluded146$d = ["children"],
      _excluded147$d = ["children"],
      _excluded148$d = ["children"],
      _excluded149$d = ["children"],
      _excluded150$d = ["children"],
      _excluded151$d = ["children"],
      _excluded152$d = ["children"],
      _excluded153$d = ["children"],
      _excluded154$d = ["children"],
      _excluded155$d = ["children"],
      _excluded156$d = ["children"],
      _excluded157$d = ["children"],
      _excluded158$d = ["children"],
      _excluded159$d = ["children"],
      _excluded160$d = ["children"],
      _excluded161$d = ["children"],
      _excluded162$d = ["children"],
      _excluded163$d = ["children"],
      _excluded164$d = ["children"],
      _excluded165$d = ["children"],
      _excluded166$d = ["children"],
      _excluded167$d = ["children"],
      _excluded168$d = ["children"],
      _excluded169$d = ["children"],
      _excluded170$d = ["children"],
      _excluded171$d = ["children"],
      _excluded172$d = ["children"],
      _excluded173$d = ["children"],
      _excluded174$d = ["children"],
      _excluded175$d = ["children"],
      _excluded176$d = ["children"],
      _excluded177$d = ["children"],
      _excluded178$d = ["children"],
      _excluded179$d = ["children"],
      _excluded180$d = ["children"],
      _excluded181$d = ["children"],
      _excluded182$d = ["children"],
      _excluded183$d = ["children"],
      _excluded184$d = ["children"],
      _excluded185$d = ["children"],
      _excluded186$d = ["children"],
      _excluded187$d = ["children"],
      _excluded188$d = ["children"],
      _excluded189$d = ["children"],
      _excluded190$d = ["children"],
      _excluded191$d = ["children"],
      _excluded192$d = ["children"],
      _excluded193$d = ["children"],
      _excluded194$d = ["children"],
      _excluded195$d = ["children"],
      _excluded196$d = ["children"],
      _excluded197$d = ["children"],
      _excluded198$d = ["children"],
      _excluded199$d = ["children"],
      _excluded200$d = ["children"],
      _excluded201$d = ["children"],
      _excluded202$d = ["children"],
      _excluded203$d = ["children"],
      _excluded204$d = ["children"],
      _excluded205$d = ["children"],
      _excluded206$d = ["children"],
      _excluded207$d = ["children"],
      _excluded208$d = ["children"],
      _excluded209$d = ["children"],
      _excluded210$d = ["children"],
      _excluded211$d = ["children"],
      _excluded212$d = ["children"],
      _excluded213$d = ["children"],
      _excluded214$d = ["children"],
      _excluded215$d = ["children"],
      _excluded216$d = ["children"],
      _excluded217$d = ["children"],
      _excluded218$d = ["children"],
      _excluded219$d = ["children"],
      _excluded220$d = ["children"],
      _excluded221$d = ["children"],
      _excluded222$d = ["children"],
      _excluded223$d = ["children"],
      _excluded224$d = ["children"],
      _excluded225$d = ["children"],
      _excluded226$d = ["children"],
      _excluded227$d = ["children"],
      _excluded228$d = ["children"],
      _excluded229$d = ["children"],
      _excluded230$d = ["children"],
      _excluded231$d = ["children"],
      _excluded232$d = ["children"],
      _excluded233$d = ["children"],
      _excluded234$d = ["children"],
      _excluded235$d = ["children"],
      _excluded236$d = ["children"],
      _excluded237$d = ["children"],
      _excluded238$d = ["children"],
      _excluded239$d = ["children"],
      _excluded240$d = ["children"],
      _excluded241$d = ["children"],
      _excluded242$d = ["children"],
      _excluded243$d = ["children"],
      _excluded244$d = ["children"],
      _excluded245$d = ["children"],
      _excluded246$d = ["children"],
      _excluded247$d = ["children"],
      _excluded248$d = ["children"],
      _excluded249$d = ["children"],
      _excluded250$d = ["children"];
  var didWarnAboutDeprecation$3 = {};
  var LogoFlickr24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFlickr24(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$d || (_circle$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "6"
    })), _circle2$d || (_circle2$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "6"
    })), children);
  });
  var LogoFlickr20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFlickr20(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$d || (_circle3$d = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "6"
    })), _circle4$c || (_circle4$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "6"
    })), children);
  });
  var LogoFlickr16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoFlickr16(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$b || (_circle5$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "6"
    })), _circle6$b || (_circle6$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "6"
    })), children);
  });
  var LogoGithub32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGithub32(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$e || (_path$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"
    })), children);
  });
  var LogoGithub24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGithub24(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$e || (_path2$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"
    })), children);
  });
  var LogoGithub20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGithub20(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$e || (_path3$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"
    })), children);
  });
  var LogoGithub16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGithub16(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$e || (_path4$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"
    })), children);
  });
  var LogoGlassdoor32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGlassdoor32(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$e || (_path5$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"
    })), _path6$e || (_path6$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"
    })), children);
  });
  var LogoGlassdoor24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGlassdoor24(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$e || (_path7$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"
    })), _path8$e || (_path8$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"
    })), children);
  });
  var LogoGlassdoor20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGlassdoor20(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$e || (_path9$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"
    })), _path10$e || (_path10$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"
    })), children);
  });
  var LogoGlassdoor16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGlassdoor16(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$e || (_path11$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"
    })), _path12$e || (_path12$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"
    })), children);
  });
  var LogoGoogle32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGoogle32(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoGoogle32']) {
        didWarnAboutDeprecation$3['LogoGoogle32'] = true;
        console.warn("The LogoGoogle32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$e || (_path13$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"
    })), children);
  });
  var LogoGoogle24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGoogle24(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoGoogle24']) {
        didWarnAboutDeprecation$3['LogoGoogle24'] = true;
        console.warn("The LogoGoogle24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$e || (_path14$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"
    })), children);
  });
  var LogoGoogle20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGoogle20(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoGoogle20']) {
        didWarnAboutDeprecation$3['LogoGoogle20'] = true;
        console.warn("The LogoGoogle20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$e || (_path15$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"
    })), children);
  });
  var LogoGoogle16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoGoogle16(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoGoogle16']) {
        didWarnAboutDeprecation$3['LogoGoogle16'] = true;
        console.warn("The LogoGoogle16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$e || (_path16$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"
    })), children);
  });
  var LogoInstagram32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoInstagram32(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$b || (_circle7$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.406",
      cy: "9.594",
      r: "1.44"
    })), _path17$e || (_path17$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), _path18$e || (_path18$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"
    })), children);
  });
  var LogoInstagram24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoInstagram24(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$b || (_circle8$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.406",
      cy: "9.594",
      r: "1.44"
    })), _path19$e || (_path19$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), _path20$e || (_path20$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"
    })), children);
  });
  var LogoInstagram20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoInstagram20(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$b || (_circle9$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.406",
      cy: "9.594",
      r: "1.44"
    })), _path21$e || (_path21$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), _path22$e || (_path22$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"
    })), children);
  });
  var LogoInstagram16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoInstagram16(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$b || (_circle10$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.406",
      cy: "9.594",
      r: "1.44"
    })), _path23$e || (_path23$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), _path24$e || (_path24$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"
    })), children);
  });
  var LogoJupyter32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoJupyter32(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$e || (_path25$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0766 3.5878a1.69 1.69 0 11-1.76-1.5853 1.67 1.67 0 011.76 1.5853zM16.2191 23.1113c-4.4866 0-8.43-1.61-10.4688-3.9882a11.1618 11.1618 0 0020.9377 0C24.6541 21.5011 20.7257 23.1113 16.2191 23.1113zM16.2191 7.6483c4.4867 0 8.43 1.61 10.4689 3.9881a11.1618 11.1618 0 00-20.9377 0C7.7892 9.2535 11.7126 7.6483 16.2191 7.6483zM10.0427 27.7388a2.1085 2.1085 0 11-.2031-.7976 2.1278 2.1278 0 01.2031.7976zM6.26 7.1064A1.2263 1.2263 0 117.4517 5.83 1.2415 1.2415 0 016.26 7.1064z"
    })), children);
  });
  var LogoJupyter24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoJupyter24(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$e || (_path26$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0766 3.5878a1.69 1.69 0 11-1.76-1.5853 1.67 1.67 0 011.76 1.5853zM16.2191 23.1113c-4.4866 0-8.43-1.61-10.4688-3.9882a11.1618 11.1618 0 0020.9377 0C24.6541 21.5011 20.7257 23.1113 16.2191 23.1113zM16.2191 7.6483c4.4867 0 8.43 1.61 10.4689 3.9881a11.1618 11.1618 0 00-20.9377 0C7.7892 9.2535 11.7126 7.6483 16.2191 7.6483zM10.0427 27.7388a2.1085 2.1085 0 11-.2031-.7976 2.1278 2.1278 0 01.2031.7976zM6.26 7.1064A1.2263 1.2263 0 117.4517 5.83 1.2415 1.2415 0 016.26 7.1064z"
    })), children);
  });
  var LogoJupyter20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoJupyter20(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$e || (_path27$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0766 3.5878a1.69 1.69 0 11-1.76-1.5853 1.67 1.67 0 011.76 1.5853zM16.2191 23.1113c-4.4866 0-8.43-1.61-10.4688-3.9882a11.1618 11.1618 0 0020.9377 0C24.6541 21.5011 20.7257 23.1113 16.2191 23.1113zM16.2191 7.6483c4.4867 0 8.43 1.61 10.4689 3.9881a11.1618 11.1618 0 00-20.9377 0C7.7892 9.2535 11.7126 7.6483 16.2191 7.6483zM10.0427 27.7388a2.1085 2.1085 0 11-.2031-.7976 2.1278 2.1278 0 01.2031.7976zM6.26 7.1064A1.2263 1.2263 0 117.4517 5.83 1.2415 1.2415 0 016.26 7.1064z"
    })), children);
  });
  var LogoJupyter16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoJupyter16(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$e || (_path28$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0766 3.5878a1.69 1.69 0 11-1.76-1.5853 1.67 1.67 0 011.76 1.5853zM16.2191 23.1113c-4.4866 0-8.43-1.61-10.4688-3.9882a11.1618 11.1618 0 0020.9377 0C24.6541 21.5011 20.7257 23.1113 16.2191 23.1113zM16.2191 7.6483c4.4867 0 8.43 1.61 10.4689 3.9881a11.1618 11.1618 0 00-20.9377 0C7.7892 9.2535 11.7126 7.6483 16.2191 7.6483zM10.0427 27.7388a2.1085 2.1085 0 11-.2031-.7976 2.1278 2.1278 0 01.2031.7976zM6.26 7.1064A1.2263 1.2263 0 117.4517 5.83 1.2415 1.2415 0 016.26 7.1064z"
    })), children);
  });
  var LogoKeybase32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoKeybase32(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$e || (_path29$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.1233 26.9328a1.1122 1.1122 0 11-1.1121-1.1122 1.112 1.112 0 011.1121 1.1122M21.0257 26.9328a1.1122 1.1122 0 11-1.1122-1.1122 1.1121 1.1121 0 011.1122 1.1122"
    })), _path30$e || (_path30$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.999 5.797H10.973V6.771H9.999z",
      transform: "rotate(-86.462 10.486 6.284)"
    })), _path31$e || (_path31$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4275,16.3825l-.0013.001a13.0868,13.0868,0,0,0-5.1431-4.1825c-.3754-.1667-.7543-.3142-1.1354-.4454.0128-.0314.0277-.0615.04-.0933a4.83,4.83,0,0,0-2.9861-6.319,5.9368,5.9368,0,0,0-1.9962-.3558c-.0366-.1253-.1165-.6743.58-2.1571L14.3742,2q-.17.236-.3368.4661c-.384.5309-.7549,1.0444-1.1029,1.55a2.1657,2.1657,0,0,0-1.4486-.6771L9.8543,3.2377H9.852l-.0025,0c-.0429-.0025-.0864-.0039-.1293-.0039A2.1877,2.1877,0,0,0,7.54,5.2825L7.4388,6.9169l0,.003,0,.0028A2.1882,2.1882,0,0,0,9.4854,9.23l1.1673.0723a5.1711,5.1711,0,0,0,.47,2.688,13.1954,13.1954,0,0,0-4.2637,2.9C3,18.7883,3,23.06,3,26.4916v2.0706l1.524-1.6163A12.3293,12.3293,0,0,0,5.8548,30H7.8367A10.7091,10.7091,0,0,1,5.878,25.51l2.2353-2.3708L6.963,26.745l2.03-1.4774c3.5858-2.61,7.8678-3.2093,12.7263-1.7826a4.6276,4.6276,0,0,0,5.2189-1.468c.0441-.0628.0828-.128.1228-.1926a9.6141,9.6141,0,0,1,.1638,1.7454,12.4214,12.4214,0,0,1-1.61,6.43h1.877A14.4022,14.4022,0,0,0,28.87,23.57,12.2666,12.2666,0,0,0,26.4275,16.3825ZM13.8455,5.9257a1.5872,1.5872,0,0,0,1.3983.7068,4.2111,4.2111,0,0,1,1.44.2719,3.17,3.17,0,0,1,1.0279,5.4638l-.4752-.5849-.0032-.004a1.7048,1.7048,0,0,0-3.0235.9865,3.2143,3.2143,0,0,1-1.899-3.5412,8.4815,8.4815,0,0,1,1.4374-3.466A1.642,1.642,0,0,0,13.8455,5.9257Zm3.49,9.2589-.6072.4962a.2675.2675,0,0,1-.376-.038l-.1264-.1549a.2791.2791,0,0,1,.0394-.3927l.6-.49-1.235-1.5158a.362.362,0,1,1,.5611-.4575l3.4546,4.2517a.3619.3619,0,0,1-.1988.5815.3566.3566,0,0,1-.0816.0094.3609.3609,0,0,1-.2806-.1332l-.3441-.4239-1.2215.9971a.2815.2815,0,0,1-.3965-.04l-.5532-.6775a.2786.2786,0,0,1,.04-.3919l1.2275-1.002ZM9.08,7.0184l.1014-1.6342A.5394.5394,0,0,1,9.72,4.8781l.0326.001,1.6335.1013a.5387.5387,0,0,1,.5046.5716l-.0073.1182a10.6739,10.6739,0,0,0-.9028,2.0046L9.5859,7.5886A.5407.5407,0,0,1,9.08,7.0184ZM25.5944,21.07a2.9883,2.9883,0,0,1-3.4112.8373c-4.5313-1.3305-8.6289-1.0534-12.2124.82l1.9069-5.978-7.203,7.6393a11.67,11.67,0,0,1,3.3532-8.3419,11.4953,11.4953,0,0,1,4.1073-2.6908,5.42,5.42,0,0,0,2.2411,1.2214,4.714,4.714,0,0,0,.5627.12,1.6258,1.6258,0,0,0,.2449,1.6416l.0847.1038a1.6247,1.6247,0,0,0,.2594,1.605l.5532.6777a1.6276,1.6276,0,0,0,2.29.2314l.3314-.2705a1.7079,1.7079,0,0,0,1.9867-2.6535l-1.9427-2.3911a4.88,4.88,0,0,0,.4863-.456,12.449,12.449,0,0,1,1.3829.5181,11.419,11.419,0,0,1,4.5085,3.6838C26.0987,18.7278,26.2745,20.1043,25.5944,21.07Z"
    })), children);
  });
  var LogoKeybase24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoKeybase24(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$e || (_path32$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.1233 26.9328a1.1122 1.1122 0 11-1.1121-1.1122 1.112 1.112 0 011.1121 1.1122M21.0257 26.9328a1.1122 1.1122 0 11-1.1122-1.1122 1.1121 1.1121 0 011.1122 1.1122"
    })), _path33$e || (_path33$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.999 5.797H10.973V6.771H9.999z",
      transform: "rotate(-86.462 10.486 6.284)"
    })), _path34$e || (_path34$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4275,16.3825l-.0013.001a13.0868,13.0868,0,0,0-5.1431-4.1825c-.3754-.1667-.7543-.3142-1.1354-.4454.0128-.0314.0277-.0615.04-.0933a4.83,4.83,0,0,0-2.9861-6.319,5.9368,5.9368,0,0,0-1.9962-.3558c-.0366-.1253-.1165-.6743.58-2.1571L14.3742,2q-.17.236-.3368.4661c-.384.5309-.7549,1.0444-1.1029,1.55a2.1657,2.1657,0,0,0-1.4486-.6771L9.8543,3.2377H9.852l-.0025,0c-.0429-.0025-.0864-.0039-.1293-.0039A2.1877,2.1877,0,0,0,7.54,5.2825L7.4388,6.9169l0,.003,0,.0028A2.1882,2.1882,0,0,0,9.4854,9.23l1.1673.0723a5.1711,5.1711,0,0,0,.47,2.688,13.1954,13.1954,0,0,0-4.2637,2.9C3,18.7883,3,23.06,3,26.4916v2.0706l1.524-1.6163A12.3293,12.3293,0,0,0,5.8548,30H7.8367A10.7091,10.7091,0,0,1,5.878,25.51l2.2353-2.3708L6.963,26.745l2.03-1.4774c3.5858-2.61,7.8678-3.2093,12.7263-1.7826a4.6276,4.6276,0,0,0,5.2189-1.468c.0441-.0628.0828-.128.1228-.1926a9.6141,9.6141,0,0,1,.1638,1.7454,12.4214,12.4214,0,0,1-1.61,6.43h1.877A14.4022,14.4022,0,0,0,28.87,23.57,12.2666,12.2666,0,0,0,26.4275,16.3825ZM13.8455,5.9257a1.5872,1.5872,0,0,0,1.3983.7068,4.2111,4.2111,0,0,1,1.44.2719,3.17,3.17,0,0,1,1.0279,5.4638l-.4752-.5849-.0032-.004a1.7048,1.7048,0,0,0-3.0235.9865,3.2143,3.2143,0,0,1-1.899-3.5412,8.4815,8.4815,0,0,1,1.4374-3.466A1.642,1.642,0,0,0,13.8455,5.9257Zm3.49,9.2589-.6072.4962a.2675.2675,0,0,1-.376-.038l-.1264-.1549a.2791.2791,0,0,1,.0394-.3927l.6-.49-1.235-1.5158a.362.362,0,1,1,.5611-.4575l3.4546,4.2517a.3619.3619,0,0,1-.1988.5815.3566.3566,0,0,1-.0816.0094.3609.3609,0,0,1-.2806-.1332l-.3441-.4239-1.2215.9971a.2815.2815,0,0,1-.3965-.04l-.5532-.6775a.2786.2786,0,0,1,.04-.3919l1.2275-1.002ZM9.08,7.0184l.1014-1.6342A.5394.5394,0,0,1,9.72,4.8781l.0326.001,1.6335.1013a.5387.5387,0,0,1,.5046.5716l-.0073.1182a10.6739,10.6739,0,0,0-.9028,2.0046L9.5859,7.5886A.5407.5407,0,0,1,9.08,7.0184ZM25.5944,21.07a2.9883,2.9883,0,0,1-3.4112.8373c-4.5313-1.3305-8.6289-1.0534-12.2124.82l1.9069-5.978-7.203,7.6393a11.67,11.67,0,0,1,3.3532-8.3419,11.4953,11.4953,0,0,1,4.1073-2.6908,5.42,5.42,0,0,0,2.2411,1.2214,4.714,4.714,0,0,0,.5627.12,1.6258,1.6258,0,0,0,.2449,1.6416l.0847.1038a1.6247,1.6247,0,0,0,.2594,1.605l.5532.6777a1.6276,1.6276,0,0,0,2.29.2314l.3314-.2705a1.7079,1.7079,0,0,0,1.9867-2.6535l-1.9427-2.3911a4.88,4.88,0,0,0,.4863-.456,12.449,12.449,0,0,1,1.3829.5181,11.419,11.419,0,0,1,4.5085,3.6838C26.0987,18.7278,26.2745,20.1043,25.5944,21.07Z"
    })), children);
  });
  var LogoKeybase20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoKeybase20(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$e || (_path35$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.1233 26.9328a1.1122 1.1122 0 11-1.1121-1.1122 1.112 1.112 0 011.1121 1.1122M21.0257 26.9328a1.1122 1.1122 0 11-1.1122-1.1122 1.1121 1.1121 0 011.1122 1.1122"
    })), _path36$e || (_path36$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.999 5.797H10.973V6.771H9.999z",
      transform: "rotate(-86.462 10.486 6.284)"
    })), _path37$e || (_path37$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4275,16.3825l-.0013.001a13.0868,13.0868,0,0,0-5.1431-4.1825c-.3754-.1667-.7543-.3142-1.1354-.4454.0128-.0314.0277-.0615.04-.0933a4.83,4.83,0,0,0-2.9861-6.319,5.9368,5.9368,0,0,0-1.9962-.3558c-.0366-.1253-.1165-.6743.58-2.1571L14.3742,2q-.17.236-.3368.4661c-.384.5309-.7549,1.0444-1.1029,1.55a2.1657,2.1657,0,0,0-1.4486-.6771L9.8543,3.2377H9.852l-.0025,0c-.0429-.0025-.0864-.0039-.1293-.0039A2.1877,2.1877,0,0,0,7.54,5.2825L7.4388,6.9169l0,.003,0,.0028A2.1882,2.1882,0,0,0,9.4854,9.23l1.1673.0723a5.1711,5.1711,0,0,0,.47,2.688,13.1954,13.1954,0,0,0-4.2637,2.9C3,18.7883,3,23.06,3,26.4916v2.0706l1.524-1.6163A12.3293,12.3293,0,0,0,5.8548,30H7.8367A10.7091,10.7091,0,0,1,5.878,25.51l2.2353-2.3708L6.963,26.745l2.03-1.4774c3.5858-2.61,7.8678-3.2093,12.7263-1.7826a4.6276,4.6276,0,0,0,5.2189-1.468c.0441-.0628.0828-.128.1228-.1926a9.6141,9.6141,0,0,1,.1638,1.7454,12.4214,12.4214,0,0,1-1.61,6.43h1.877A14.4022,14.4022,0,0,0,28.87,23.57,12.2666,12.2666,0,0,0,26.4275,16.3825ZM13.8455,5.9257a1.5872,1.5872,0,0,0,1.3983.7068,4.2111,4.2111,0,0,1,1.44.2719,3.17,3.17,0,0,1,1.0279,5.4638l-.4752-.5849-.0032-.004a1.7048,1.7048,0,0,0-3.0235.9865,3.2143,3.2143,0,0,1-1.899-3.5412,8.4815,8.4815,0,0,1,1.4374-3.466A1.642,1.642,0,0,0,13.8455,5.9257Zm3.49,9.2589-.6072.4962a.2675.2675,0,0,1-.376-.038l-.1264-.1549a.2791.2791,0,0,1,.0394-.3927l.6-.49-1.235-1.5158a.362.362,0,1,1,.5611-.4575l3.4546,4.2517a.3619.3619,0,0,1-.1988.5815.3566.3566,0,0,1-.0816.0094.3609.3609,0,0,1-.2806-.1332l-.3441-.4239-1.2215.9971a.2815.2815,0,0,1-.3965-.04l-.5532-.6775a.2786.2786,0,0,1,.04-.3919l1.2275-1.002ZM9.08,7.0184l.1014-1.6342A.5394.5394,0,0,1,9.72,4.8781l.0326.001,1.6335.1013a.5387.5387,0,0,1,.5046.5716l-.0073.1182a10.6739,10.6739,0,0,0-.9028,2.0046L9.5859,7.5886A.5407.5407,0,0,1,9.08,7.0184ZM25.5944,21.07a2.9883,2.9883,0,0,1-3.4112.8373c-4.5313-1.3305-8.6289-1.0534-12.2124.82l1.9069-5.978-7.203,7.6393a11.67,11.67,0,0,1,3.3532-8.3419,11.4953,11.4953,0,0,1,4.1073-2.6908,5.42,5.42,0,0,0,2.2411,1.2214,4.714,4.714,0,0,0,.5627.12,1.6258,1.6258,0,0,0,.2449,1.6416l.0847.1038a1.6247,1.6247,0,0,0,.2594,1.605l.5532.6777a1.6276,1.6276,0,0,0,2.29.2314l.3314-.2705a1.7079,1.7079,0,0,0,1.9867-2.6535l-1.9427-2.3911a4.88,4.88,0,0,0,.4863-.456,12.449,12.449,0,0,1,1.3829.5181,11.419,11.419,0,0,1,4.5085,3.6838C26.0987,18.7278,26.2745,20.1043,25.5944,21.07Z"
    })), children);
  });
  var LogoKeybase16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoKeybase16(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$e || (_path38$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.1233 26.9328a1.1122 1.1122 0 11-1.1121-1.1122 1.112 1.112 0 011.1121 1.1122M21.0257 26.9328a1.1122 1.1122 0 11-1.1122-1.1122 1.1121 1.1121 0 011.1122 1.1122"
    })), _path39$e || (_path39$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.999 5.797H10.973V6.771H9.999z",
      transform: "rotate(-86.462 10.486 6.284)"
    })), _path40$e || (_path40$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4275,16.3825l-.0013.001a13.0868,13.0868,0,0,0-5.1431-4.1825c-.3754-.1667-.7543-.3142-1.1354-.4454.0128-.0314.0277-.0615.04-.0933a4.83,4.83,0,0,0-2.9861-6.319,5.9368,5.9368,0,0,0-1.9962-.3558c-.0366-.1253-.1165-.6743.58-2.1571L14.3742,2q-.17.236-.3368.4661c-.384.5309-.7549,1.0444-1.1029,1.55a2.1657,2.1657,0,0,0-1.4486-.6771L9.8543,3.2377H9.852l-.0025,0c-.0429-.0025-.0864-.0039-.1293-.0039A2.1877,2.1877,0,0,0,7.54,5.2825L7.4388,6.9169l0,.003,0,.0028A2.1882,2.1882,0,0,0,9.4854,9.23l1.1673.0723a5.1711,5.1711,0,0,0,.47,2.688,13.1954,13.1954,0,0,0-4.2637,2.9C3,18.7883,3,23.06,3,26.4916v2.0706l1.524-1.6163A12.3293,12.3293,0,0,0,5.8548,30H7.8367A10.7091,10.7091,0,0,1,5.878,25.51l2.2353-2.3708L6.963,26.745l2.03-1.4774c3.5858-2.61,7.8678-3.2093,12.7263-1.7826a4.6276,4.6276,0,0,0,5.2189-1.468c.0441-.0628.0828-.128.1228-.1926a9.6141,9.6141,0,0,1,.1638,1.7454,12.4214,12.4214,0,0,1-1.61,6.43h1.877A14.4022,14.4022,0,0,0,28.87,23.57,12.2666,12.2666,0,0,0,26.4275,16.3825ZM13.8455,5.9257a1.5872,1.5872,0,0,0,1.3983.7068,4.2111,4.2111,0,0,1,1.44.2719,3.17,3.17,0,0,1,1.0279,5.4638l-.4752-.5849-.0032-.004a1.7048,1.7048,0,0,0-3.0235.9865,3.2143,3.2143,0,0,1-1.899-3.5412,8.4815,8.4815,0,0,1,1.4374-3.466A1.642,1.642,0,0,0,13.8455,5.9257Zm3.49,9.2589-.6072.4962a.2675.2675,0,0,1-.376-.038l-.1264-.1549a.2791.2791,0,0,1,.0394-.3927l.6-.49-1.235-1.5158a.362.362,0,1,1,.5611-.4575l3.4546,4.2517a.3619.3619,0,0,1-.1988.5815.3566.3566,0,0,1-.0816.0094.3609.3609,0,0,1-.2806-.1332l-.3441-.4239-1.2215.9971a.2815.2815,0,0,1-.3965-.04l-.5532-.6775a.2786.2786,0,0,1,.04-.3919l1.2275-1.002ZM9.08,7.0184l.1014-1.6342A.5394.5394,0,0,1,9.72,4.8781l.0326.001,1.6335.1013a.5387.5387,0,0,1,.5046.5716l-.0073.1182a10.6739,10.6739,0,0,0-.9028,2.0046L9.5859,7.5886A.5407.5407,0,0,1,9.08,7.0184ZM25.5944,21.07a2.9883,2.9883,0,0,1-3.4112.8373c-4.5313-1.3305-8.6289-1.0534-12.2124.82l1.9069-5.978-7.203,7.6393a11.67,11.67,0,0,1,3.3532-8.3419,11.4953,11.4953,0,0,1,4.1073-2.6908,5.42,5.42,0,0,0,2.2411,1.2214,4.714,4.714,0,0,0,.5627.12,1.6258,1.6258,0,0,0,.2449,1.6416l.0847.1038a1.6247,1.6247,0,0,0,.2594,1.605l.5532.6777a1.6276,1.6276,0,0,0,2.29.2314l.3314-.2705a1.7079,1.7079,0,0,0,1.9867-2.6535l-1.9427-2.3911a4.88,4.88,0,0,0,.4863-.456,12.449,12.449,0,0,1,1.3829.5181,11.419,11.419,0,0,1,4.5085,3.6838C26.0987,18.7278,26.2745,20.1043,25.5944,21.07Z"
    })), children);
  });
  var LogoLinkedin32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLinkedin32(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$e || (_path41$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.2,4H5.8C4.8,4,4,4.8,4,5.7v20.5c0,0.9,0.8,1.7,1.8,1.7h20.4c1,0,1.8-0.8,1.8-1.7V5.7C28,4.8,27.2,4,26.2,4z M11.1,24.4\tH7.6V13h3.5V24.4z M9.4,11.4c-1.1,0-2.1-0.9-2.1-2.1c0-1.2,0.9-2.1,2.1-2.1c1.1,0,2.1,0.9,2.1,2.1S10.5,11.4,9.4,11.4z M24.5,24.3\tH21v-5.6c0-1.3,0-3.1-1.9-3.1c-1.9,0-2.1,1.5-2.1,2.9v5.7h-3.5V13h3.3v1.5h0.1c0.5-0.9,1.7-1.9,3.4-1.9c3.6,0,4.3,2.4,4.3,5.5V24.3z"
    })), children);
  });
  var LogoLinkedin24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLinkedin24(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$e || (_path42$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.2,4H5.8C4.8,4,4,4.8,4,5.7v20.5c0,0.9,0.8,1.7,1.8,1.7h20.4c1,0,1.8-0.8,1.8-1.7V5.7C28,4.8,27.2,4,26.2,4z M11.1,24.4\tH7.6V13h3.5V24.4z M9.4,11.4c-1.1,0-2.1-0.9-2.1-2.1c0-1.2,0.9-2.1,2.1-2.1c1.1,0,2.1,0.9,2.1,2.1S10.5,11.4,9.4,11.4z M24.5,24.3\tH21v-5.6c0-1.3,0-3.1-1.9-3.1c-1.9,0-2.1,1.5-2.1,2.9v5.7h-3.5V13h3.3v1.5h0.1c0.5-0.9,1.7-1.9,3.4-1.9c3.6,0,4.3,2.4,4.3,5.5V24.3z"
    })), children);
  });
  var LogoLinkedin20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLinkedin20(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$e || (_path43$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.2,4H5.8C4.8,4,4,4.8,4,5.7v20.5c0,0.9,0.8,1.7,1.8,1.7h20.4c1,0,1.8-0.8,1.8-1.7V5.7C28,4.8,27.2,4,26.2,4z M11.1,24.4\tH7.6V13h3.5V24.4z M9.4,11.4c-1.1,0-2.1-0.9-2.1-2.1c0-1.2,0.9-2.1,2.1-2.1c1.1,0,2.1,0.9,2.1,2.1S10.5,11.4,9.4,11.4z M24.5,24.3\tH21v-5.6c0-1.3,0-3.1-1.9-3.1c-1.9,0-2.1,1.5-2.1,2.9v5.7h-3.5V13h3.3v1.5h0.1c0.5-0.9,1.7-1.9,3.4-1.9c3.6,0,4.3,2.4,4.3,5.5V24.3z"
    })), children);
  });
  var LogoLinkedin16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLinkedin16(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$e || (_path44$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.2,4H5.8C4.8,4,4,4.8,4,5.7v20.5c0,0.9,0.8,1.7,1.8,1.7h20.4c1,0,1.8-0.8,1.8-1.7V5.7C28,4.8,27.2,4,26.2,4z M11.1,24.4\tH7.6V13h3.5V24.4z M9.4,11.4c-1.1,0-2.1-0.9-2.1-2.1c0-1.2,0.9-2.1,2.1-2.1c1.1,0,2.1,0.9,2.1,2.1S10.5,11.4,9.4,11.4z M24.5,24.3\tH21v-5.6c0-1.3,0-3.1-1.9-3.1c-1.9,0-2.1,1.5-2.1,2.9v5.7h-3.5V13h3.3v1.5h0.1c0.5-0.9,1.7-1.9,3.4-1.9c3.6,0,4.3,2.4,4.3,5.5V24.3z"
    })), children);
  });
  var LogoLivestream32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLivestream32(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$e || (_path45$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 01-2.41-1A14.91 14.91 0 0110 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 002 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 017 .61 8.09 8.09 0 016.34 5.09 48.51 48.51 0 012.17 7.36A26 26 0 0022.49 23.71zM28.1 26.38a2.93 2.93 0 01-2.74-2.64 42.08 42.08 0 01-.14-4.9 48 48 0 00-.61-7.58 3.75 3.75 0 00-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0128 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 000 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0128.1 26.38z"
    })), children);
  });
  var LogoLivestream24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLivestream24(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$e || (_path46$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 01-2.41-1A14.91 14.91 0 0110 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 002 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 017 .61 8.09 8.09 0 016.34 5.09 48.51 48.51 0 012.17 7.36A26 26 0 0022.49 23.71zM28.1 26.38a2.93 2.93 0 01-2.74-2.64 42.08 42.08 0 01-.14-4.9 48 48 0 00-.61-7.58 3.75 3.75 0 00-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0128 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 000 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0128.1 26.38z"
    })), children);
  });
  var LogoLivestream20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLivestream20(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$e || (_path47$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 01-2.41-1A14.91 14.91 0 0110 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 002 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 017 .61 8.09 8.09 0 016.34 5.09 48.51 48.51 0 012.17 7.36A26 26 0 0022.49 23.71zM28.1 26.38a2.93 2.93 0 01-2.74-2.64 42.08 42.08 0 01-.14-4.9 48 48 0 00-.61-7.58 3.75 3.75 0 00-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0128 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 000 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0128.1 26.38z"
    })), children);
  });
  var LogoLivestream16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoLivestream16(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$e || (_path48$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 01-2.41-1A14.91 14.91 0 0110 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 002 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 017 .61 8.09 8.09 0 016.34 5.09 48.51 48.51 0 012.17 7.36A26 26 0 0022.49 23.71zM28.1 26.38a2.93 2.93 0 01-2.74-2.64 42.08 42.08 0 01-.14-4.9 48 48 0 00-.61-7.58 3.75 3.75 0 00-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0128 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 000 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0128.1 26.38z"
    })), children);
  });
  var LogoMedium32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoMedium32(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$e || (_path49$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"
    })), _path50$e || (_path50$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoMedium24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoMedium24(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$e || (_path51$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"
    })), _path52$e || (_path52$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoMedium20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoMedium20(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$e || (_path53$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"
    })), _path54$e || (_path54$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoMedium16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoMedium16(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$e || (_path55$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"
    })), _path56$e || (_path56$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoOpenshift32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoOpenshift32(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$e || (_path57$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"
    })), children);
  });
  var LogoOpenshift24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoOpenshift24(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$e || (_path58$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"
    })), children);
  });
  var LogoOpenshift20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoOpenshift20(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$e || (_path59$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"
    })), children);
  });
  var LogoOpenshift16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoOpenshift16(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$e || (_path60$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"
    })), children);
  });
  var LogoPinterest32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPinterest32(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$e || (_path61$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"
    })), children);
  });
  var LogoPinterest24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPinterest24(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$e || (_path62$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"
    })), children);
  });
  var LogoPinterest20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPinterest20(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$e || (_path63$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"
    })), children);
  });
  var LogoPinterest16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPinterest16(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$e || (_path64$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"
    })), children);
  });
  var LogoPython32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPython32(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$e || (_path65$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4882,9.14v2.9663a4.2843,4.2843,0,0,1-4.173,4.2352H12.6431a3.4077,3.4077,0,0,0-3.34,3.3945v6.3607c0,1.81,1.5742,2.8751,3.34,3.3945a11.1762,11.1762,0,0,0,6.6721,0c1.6817-.4869,3.34-1.4668,3.34-3.3945V23.55H15.983v-.8486H25.9951c1.9414,0,2.6648-1.3542,3.34-3.3867a11.4642,11.4642,0,0,0,0-6.7889c-.48-1.9327-1.3961-3.3867-3.34-3.3867ZM19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path66$e || (_path66$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path67$e || (_path67$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8351,2a19.0717,19.0717,0,0,0-3.192.2725c-2.8268.4994-3.34,1.5447-3.34,3.4723V8.2909h6.68V9.14H6.7962a4.1708,4.1708,0,0,0-4.173,3.3867,12.4855,12.4855,0,0,0,0,6.7889c.4748,1.9776,1.6088,3.3867,3.55,3.3867H8.47V19.65a4.2449,4.2449,0,0,1,4.173-4.15h6.6721a3.3654,3.3654,0,0,0,3.34-3.3944V5.745a3.729,3.729,0,0,0-3.34-3.4723A20.8377,20.8377,0,0,0,15.8351,2ZM12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), _path68$e || (_path68$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), children);
  });
  var LogoPython24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPython24(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$e || (_path69$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4882,9.14v2.9663a4.2843,4.2843,0,0,1-4.173,4.2352H12.6431a3.4077,3.4077,0,0,0-3.34,3.3945v6.3607c0,1.81,1.5742,2.8751,3.34,3.3945a11.1762,11.1762,0,0,0,6.6721,0c1.6817-.4869,3.34-1.4668,3.34-3.3945V23.55H15.983v-.8486H25.9951c1.9414,0,2.6648-1.3542,3.34-3.3867a11.4642,11.4642,0,0,0,0-6.7889c-.48-1.9327-1.3961-3.3867-3.34-3.3867ZM19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path70$e || (_path70$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path71$e || (_path71$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8351,2a19.0717,19.0717,0,0,0-3.192.2725c-2.8268.4994-3.34,1.5447-3.34,3.4723V8.2909h6.68V9.14H6.7962a4.1708,4.1708,0,0,0-4.173,3.3867,12.4855,12.4855,0,0,0,0,6.7889c.4748,1.9776,1.6088,3.3867,3.55,3.3867H8.47V19.65a4.2449,4.2449,0,0,1,4.173-4.15h6.6721a3.3654,3.3654,0,0,0,3.34-3.3944V5.745a3.729,3.729,0,0,0-3.34-3.4723A20.8377,20.8377,0,0,0,15.8351,2ZM12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), _path72$e || (_path72$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), children);
  });
  var LogoPython20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPython20(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$e || (_path73$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4882,9.14v2.9663a4.2843,4.2843,0,0,1-4.173,4.2352H12.6431a3.4077,3.4077,0,0,0-3.34,3.3945v6.3607c0,1.81,1.5742,2.8751,3.34,3.3945a11.1762,11.1762,0,0,0,6.6721,0c1.6817-.4869,3.34-1.4668,3.34-3.3945V23.55H15.983v-.8486H25.9951c1.9414,0,2.6648-1.3542,3.34-3.3867a11.4642,11.4642,0,0,0,0-6.7889c-.48-1.9327-1.3961-3.3867-3.34-3.3867ZM19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path74$e || (_path74$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path75$e || (_path75$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8351,2a19.0717,19.0717,0,0,0-3.192.2725c-2.8268.4994-3.34,1.5447-3.34,3.4723V8.2909h6.68V9.14H6.7962a4.1708,4.1708,0,0,0-4.173,3.3867,12.4855,12.4855,0,0,0,0,6.7889c.4748,1.9776,1.6088,3.3867,3.55,3.3867H8.47V19.65a4.2449,4.2449,0,0,1,4.173-4.15h6.6721a3.3654,3.3654,0,0,0,3.34-3.3944V5.745a3.729,3.729,0,0,0-3.34-3.4723A20.8377,20.8377,0,0,0,15.8351,2ZM12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), _path76$e || (_path76$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), children);
  });
  var LogoPython16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoPython16(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$e || (_path77$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4882,9.14v2.9663a4.2843,4.2843,0,0,1-4.173,4.2352H12.6431a3.4077,3.4077,0,0,0-3.34,3.3945v6.3607c0,1.81,1.5742,2.8751,3.34,3.3945a11.1762,11.1762,0,0,0,6.6721,0c1.6817-.4869,3.34-1.4668,3.34-3.3945V23.55H15.983v-.8486H25.9951c1.9414,0,2.6648-1.3542,3.34-3.3867a11.4642,11.4642,0,0,0,0-6.7889c-.48-1.9327-1.3961-3.3867-3.34-3.3867ZM19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path78$e || (_path78$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M19.7356,25.2476a1.2731,1.2731,0,1,1-1.2534,1.269A1.2607,1.2607,0,0,1,19.7356,25.2476Z"
    })), _path79$e || (_path79$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8351,2a19.0717,19.0717,0,0,0-3.192.2725c-2.8268.4994-3.34,1.5447-3.34,3.4723V8.2909h6.68V9.14H6.7962a4.1708,4.1708,0,0,0-4.173,3.3867,12.4855,12.4855,0,0,0,0,6.7889c.4748,1.9776,1.6088,3.3867,3.55,3.3867H8.47V19.65a4.2449,4.2449,0,0,1,4.173-4.15h6.6721a3.3654,3.3654,0,0,0,3.34-3.3944V5.745a3.729,3.729,0,0,0-3.34-3.4723A20.8377,20.8377,0,0,0,15.8351,2ZM12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), _path80$e || (_path80$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M12.2226,4.0478a1.2731,1.2731,0,1,1-1.2534,1.2768A1.2675,1.2675,0,0,1,12.2226,4.0478Z"
    })), children);
  });
  var LogoQuora32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoQuora32(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$e || (_path81$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"
    })), children);
  });
  var LogoQuora24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoQuora24(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$e || (_path82$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"
    })), children);
  });
  var LogoQuora20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoQuora20(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$e || (_path83$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"
    })), children);
  });
  var LogoQuora16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoQuora16(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$e || (_path84$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"
    })), children);
  });
  var LogoRScript32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoRScript32(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$e || (_path85$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M30,14.7842c0-5.1782-6.2681-9.376-14-9.376S2,9.606,2,14.7842c0,4.6147,4.9814,8.4419,11.5361,9.2226v2.9917l4.7762-.0019,0-2.9741a19.3812,19.3812,0,0,0,3.3418-.6646L23.593,27l5.3975-.0024-3.253-5.4849C28.3625,19.8086,30,17.4263,30,14.7842Zm-22.4983.7c0-3.54,4.7644-6.41,10.6414-6.41s10.2138,1.9629,10.2138,6.41A5.4694,5.4694,0,0,1,24.9587,20.61a3.2252,3.2252,0,0,0-.2978-.1749,10.4735,10.4735,0,0,0-1.34-.5048s4.1743-.31,4.1743-4.4659-4.3684-4.2343-4.3684-4.2343H13.5361V21.2554C9.97,20.22,7.5017,18.0283,7.5017,15.4839Zm13.7422,1.8452-2.8928.001.0014-2.6812,2.8914.0015a1.2476,1.2476,0,0,1,1.34,1.3149A1.3232,1.3232,0,0,1,21.2439,17.3291Zm-2.9326,3.4946h1.2825a.8785.8785,0,0,1,.6406.291,3.2917,3.2917,0,0,1,.51.63,22.4033,22.4033,0,0,1-2.4326.1455Z"
    })), children);
  });
  var LogoRScript24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoRScript24(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$e || (_path86$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M30,14.7842c0-5.1782-6.2681-9.376-14-9.376S2,9.606,2,14.7842c0,4.6147,4.9814,8.4419,11.5361,9.2226v2.9917l4.7762-.0019,0-2.9741a19.3812,19.3812,0,0,0,3.3418-.6646L23.593,27l5.3975-.0024-3.253-5.4849C28.3625,19.8086,30,17.4263,30,14.7842Zm-22.4983.7c0-3.54,4.7644-6.41,10.6414-6.41s10.2138,1.9629,10.2138,6.41A5.4694,5.4694,0,0,1,24.9587,20.61a3.2252,3.2252,0,0,0-.2978-.1749,10.4735,10.4735,0,0,0-1.34-.5048s4.1743-.31,4.1743-4.4659-4.3684-4.2343-4.3684-4.2343H13.5361V21.2554C9.97,20.22,7.5017,18.0283,7.5017,15.4839Zm13.7422,1.8452-2.8928.001.0014-2.6812,2.8914.0015a1.2476,1.2476,0,0,1,1.34,1.3149A1.3232,1.3232,0,0,1,21.2439,17.3291Zm-2.9326,3.4946h1.2825a.8785.8785,0,0,1,.6406.291,3.2917,3.2917,0,0,1,.51.63,22.4033,22.4033,0,0,1-2.4326.1455Z"
    })), children);
  });
  var LogoRScript20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoRScript20(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$e || (_path87$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M30,14.7842c0-5.1782-6.2681-9.376-14-9.376S2,9.606,2,14.7842c0,4.6147,4.9814,8.4419,11.5361,9.2226v2.9917l4.7762-.0019,0-2.9741a19.3812,19.3812,0,0,0,3.3418-.6646L23.593,27l5.3975-.0024-3.253-5.4849C28.3625,19.8086,30,17.4263,30,14.7842Zm-22.4983.7c0-3.54,4.7644-6.41,10.6414-6.41s10.2138,1.9629,10.2138,6.41A5.4694,5.4694,0,0,1,24.9587,20.61a3.2252,3.2252,0,0,0-.2978-.1749,10.4735,10.4735,0,0,0-1.34-.5048s4.1743-.31,4.1743-4.4659-4.3684-4.2343-4.3684-4.2343H13.5361V21.2554C9.97,20.22,7.5017,18.0283,7.5017,15.4839Zm13.7422,1.8452-2.8928.001.0014-2.6812,2.8914.0015a1.2476,1.2476,0,0,1,1.34,1.3149A1.3232,1.3232,0,0,1,21.2439,17.3291Zm-2.9326,3.4946h1.2825a.8785.8785,0,0,1,.6406.291,3.2917,3.2917,0,0,1,.51.63,22.4033,22.4033,0,0,1-2.4326.1455Z"
    })), children);
  });
  var LogoRScript16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoRScript16(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$e || (_path88$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M30,14.7842c0-5.1782-6.2681-9.376-14-9.376S2,9.606,2,14.7842c0,4.6147,4.9814,8.4419,11.5361,9.2226v2.9917l4.7762-.0019,0-2.9741a19.3812,19.3812,0,0,0,3.3418-.6646L23.593,27l5.3975-.0024-3.253-5.4849C28.3625,19.8086,30,17.4263,30,14.7842Zm-22.4983.7c0-3.54,4.7644-6.41,10.6414-6.41s10.2138,1.9629,10.2138,6.41A5.4694,5.4694,0,0,1,24.9587,20.61a3.2252,3.2252,0,0,0-.2978-.1749,10.4735,10.4735,0,0,0-1.34-.5048s4.1743-.31,4.1743-4.4659-4.3684-4.2343-4.3684-4.2343H13.5361V21.2554C9.97,20.22,7.5017,18.0283,7.5017,15.4839Zm13.7422,1.8452-2.8928.001.0014-2.6812,2.8914.0015a1.2476,1.2476,0,0,1,1.34,1.3149A1.3232,1.3232,0,0,1,21.2439,17.3291Zm-2.9326,3.4946h1.2825a.8785.8785,0,0,1,.6406.291,3.2917,3.2917,0,0,1,.51.63,22.4033,22.4033,0,0,1-2.4326.1455Z"
    })), children);
  });
  var LogoSkype32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSkype32(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$e || (_path89$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"
    })), children);
  });
  var LogoSkype24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSkype24(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$e || (_path90$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"
    })), children);
  });
  var LogoSkype20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSkype20(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$e || (_path91$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"
    })), children);
  });
  var LogoSkype16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSkype16(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$e || (_path92$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"
    })), children);
  });
  var LogoSlack32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSlack32(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$e || (_path93$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.0423 19.1661A2.5212 2.5212 0 116.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 015.0423 0v6.3127a2.5212 2.5212 0 11-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1115.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 010 5.0423H6.5212a2.5212 2.5212 0 110-5.0423zM22.9577 12.8339a2.5212 2.5212 0 112.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 01-5.0423 0V6.5212a2.5212 2.5212 0 115.0423 0zM19.1661 22.9577a2.5212 2.5212 0 11-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 010-5.0423h6.3127a2.5212 2.5212 0 110 5.0423z"
    })), children);
  });
  var LogoSlack24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSlack24(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$e || (_path94$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.0423 19.1661A2.5212 2.5212 0 116.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 015.0423 0v6.3127a2.5212 2.5212 0 11-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1115.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 010 5.0423H6.5212a2.5212 2.5212 0 110-5.0423zM22.9577 12.8339a2.5212 2.5212 0 112.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 01-5.0423 0V6.5212a2.5212 2.5212 0 115.0423 0zM19.1661 22.9577a2.5212 2.5212 0 11-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 010-5.0423h6.3127a2.5212 2.5212 0 110 5.0423z"
    })), children);
  });
  var LogoSlack20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSlack20(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$e || (_path95$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.0423 19.1661A2.5212 2.5212 0 116.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 015.0423 0v6.3127a2.5212 2.5212 0 11-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1115.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 010 5.0423H6.5212a2.5212 2.5212 0 110-5.0423zM22.9577 12.8339a2.5212 2.5212 0 112.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 01-5.0423 0V6.5212a2.5212 2.5212 0 115.0423 0zM19.1661 22.9577a2.5212 2.5212 0 11-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 010-5.0423h6.3127a2.5212 2.5212 0 110 5.0423z"
    })), children);
  });
  var LogoSlack16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSlack16(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$e || (_path96$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.0423 19.1661A2.5212 2.5212 0 116.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 015.0423 0v6.3127a2.5212 2.5212 0 11-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1115.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 010 5.0423H6.5212a2.5212 2.5212 0 110-5.0423zM22.9577 12.8339a2.5212 2.5212 0 112.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 01-5.0423 0V6.5212a2.5212 2.5212 0 115.0423 0zM19.1661 22.9577a2.5212 2.5212 0 11-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 010-5.0423h6.3127a2.5212 2.5212 0 110 5.0423z"
    })), children);
  });
  var LogoSnapchat32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSnapchat32(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$e || (_path97$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"
    })), _path98$e || (_path98$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoSnapchat24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSnapchat24(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$e || (_path99$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"
    })), _path100$e || (_path100$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoSnapchat20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSnapchat20(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$e || (_path101$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"
    })), _path102$e || (_path102$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoSnapchat16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoSnapchat16(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$e || (_path103$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"
    })), _path104$e || (_path104$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var LogoStumbleupon32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoStumbleupon32(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoStumbleupon32']) {
        didWarnAboutDeprecation$3['LogoStumbleupon32'] = true;
        console.warn("The LogoStumbleupon32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$e || (_path105$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-.09,10.45a.84.84,0,0,0-.84.84v5.14a3.55,3.55,0,0,1-7.1,0V16.09h2.71v2.24a.84.84,0,0,0,1.68,0v-5a3.55,3.55,0,0,1,7.09,0v1l-1.58.51-1.12-.51v-1A.85.85,0,0,0,15.91,12.45Zm7.93,6a3.55,3.55,0,0,1-7.09,0V16.14l1.12.51,1.58-.51v2.29a.84.84,0,0,0,1.68,0V16.19h2.71Z"
    })), children);
  });
  var LogoStumbleupon24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoStumbleupon24(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoStumbleupon24']) {
        didWarnAboutDeprecation$3['LogoStumbleupon24'] = true;
        console.warn("The LogoStumbleupon24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$e || (_path106$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-.09,10.45a.84.84,0,0,0-.84.84v5.14a3.55,3.55,0,0,1-7.1,0V16.09h2.71v2.24a.84.84,0,0,0,1.68,0v-5a3.55,3.55,0,0,1,7.09,0v1l-1.58.51-1.12-.51v-1A.85.85,0,0,0,15.91,12.45Zm7.93,6a3.55,3.55,0,0,1-7.09,0V16.14l1.12.51,1.58-.51v2.29a.84.84,0,0,0,1.68,0V16.19h2.71Z"
    })), children);
  });
  var LogoStumbleupon20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoStumbleupon20(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoStumbleupon20']) {
        didWarnAboutDeprecation$3['LogoStumbleupon20'] = true;
        console.warn("The LogoStumbleupon20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$e || (_path107$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-.09,10.45a.84.84,0,0,0-.84.84v5.14a3.55,3.55,0,0,1-7.1,0V16.09h2.71v2.24a.84.84,0,0,0,1.68,0v-5a3.55,3.55,0,0,1,7.09,0v1l-1.58.51-1.12-.51v-1A.85.85,0,0,0,15.91,12.45Zm7.93,6a3.55,3.55,0,0,1-7.09,0V16.14l1.12.51,1.58-.51v2.29a.84.84,0,0,0,1.68,0V16.19h2.71Z"
    })), children);
  });
  var LogoStumbleupon16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoStumbleupon16(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$e);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['LogoStumbleupon16']) {
        didWarnAboutDeprecation$3['LogoStumbleupon16'] = true;
        console.warn("The LogoStumbleupon16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$e || (_path108$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-.09,10.45a.84.84,0,0,0-.84.84v5.14a3.55,3.55,0,0,1-7.1,0V16.09h2.71v2.24a.84.84,0,0,0,1.68,0v-5a3.55,3.55,0,0,1,7.09,0v1l-1.58.51-1.12-.51v-1A.85.85,0,0,0,15.91,12.45Zm7.93,6a3.55,3.55,0,0,1-7.09,0V16.14l1.12.51,1.58-.51v2.29a.84.84,0,0,0,1.68,0V16.19h2.71Z"
    })), children);
  });
  var LogoTumblr32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTumblr32(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$e || (_path109$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"
    })), children);
  });
  var LogoTumblr24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTumblr24(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$e || (_path110$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"
    })), children);
  });
  var LogoTumblr20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTumblr20(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$e || (_path111$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"
    })), children);
  });
  var LogoTumblr16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTumblr16(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$e || (_path112$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"
    })), children);
  });
  var LogoTwitter32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTwitter32(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$e || (_path113$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"
    })), children);
  });
  var LogoTwitter24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTwitter24(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$e || (_path114$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"
    })), children);
  });
  var LogoTwitter20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTwitter20(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$e || (_path115$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"
    })), children);
  });
  var LogoTwitter16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoTwitter16(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$e || (_path116$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"
    })), children);
  });
  var LogoVmware32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoVmware32(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$e || (_path117$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16.77V13.8372c0-2.4818-2.4817-3.8355-4.5123-3.8355a6.7446,6.7446,0,0,0-3.8354,1.5793,5.066,5.066,0,0,0-3.61-1.5793,5.9389,5.9389,0,0,0-3.8354,1.5793,3.8172,3.8172,0,0,0-3.3842-1.5793A3.4913,3.4913,0,0,0,9.482,11.8232L6.5058,18.575,3.2011,11.0011a1.67,1.67,0,0,0-2.1883-.8656h0A1.67,1.67,0,0,0,.1536,12.37L4.25,21.2824s.6769,1.5793,2.0305,1.5793a1.9088,1.9088,0,0,0,2.0306-1.1281c.3124-.4687,2.6809-5.45,4.1078-8.4692a.5679.5679,0,0,1,1.0812.2437v7.4868a1.8462,1.8462,0,0,0,1.6848,1.8629,1.8051,1.8051,0,0,0,1.9251-1.801V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0Z"
    })), children);
  });
  var LogoVmware24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoVmware24(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$e || (_path118$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16.77V13.8372c0-2.4818-2.4817-3.8355-4.5123-3.8355a6.7446,6.7446,0,0,0-3.8354,1.5793,5.066,5.066,0,0,0-3.61-1.5793,5.9389,5.9389,0,0,0-3.8354,1.5793,3.8172,3.8172,0,0,0-3.3842-1.5793A3.4913,3.4913,0,0,0,9.482,11.8232L6.5058,18.575,3.2011,11.0011a1.67,1.67,0,0,0-2.1883-.8656h0A1.67,1.67,0,0,0,.1536,12.37L4.25,21.2824s.6769,1.5793,2.0305,1.5793a1.9088,1.9088,0,0,0,2.0306-1.1281c.3124-.4687,2.6809-5.45,4.1078-8.4692a.5679.5679,0,0,1,1.0812.2437v7.4868a1.8462,1.8462,0,0,0,1.6848,1.8629,1.8051,1.8051,0,0,0,1.9251-1.801V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0Z"
    })), children);
  });
  var LogoVmware20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoVmware20(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$e || (_path119$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16.77V13.8372c0-2.4818-2.4817-3.8355-4.5123-3.8355a6.7446,6.7446,0,0,0-3.8354,1.5793,5.066,5.066,0,0,0-3.61-1.5793,5.9389,5.9389,0,0,0-3.8354,1.5793,3.8172,3.8172,0,0,0-3.3842-1.5793A3.4913,3.4913,0,0,0,9.482,11.8232L6.5058,18.575,3.2011,11.0011a1.67,1.67,0,0,0-2.1883-.8656h0A1.67,1.67,0,0,0,.1536,12.37L4.25,21.2824s.6769,1.5793,2.0305,1.5793a1.9088,1.9088,0,0,0,2.0306-1.1281c.3124-.4687,2.6809-5.45,4.1078-8.4692a.5679.5679,0,0,1,1.0812.2437v7.4868a1.8462,1.8462,0,0,0,1.6848,1.8629,1.8051,1.8051,0,0,0,1.9251-1.801V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0Z"
    })), children);
  });
  var LogoVmware16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoVmware16(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$e || (_path120$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16.77V13.8372c0-2.4818-2.4817-3.8355-4.5123-3.8355a6.7446,6.7446,0,0,0-3.8354,1.5793,5.066,5.066,0,0,0-3.61-1.5793,5.9389,5.9389,0,0,0-3.8354,1.5793,3.8172,3.8172,0,0,0-3.3842-1.5793A3.4913,3.4913,0,0,0,9.482,11.8232L6.5058,18.575,3.2011,11.0011a1.67,1.67,0,0,0-2.1883-.8656h0A1.67,1.67,0,0,0,.1536,12.37L4.25,21.2824s.6769,1.5793,2.0305,1.5793a1.9088,1.9088,0,0,0,2.0306-1.1281c.3124-.4687,2.6809-5.45,4.1078-8.4692a.5679.5679,0,0,1,1.0812.2437v7.4868a1.8462,1.8462,0,0,0,1.6848,1.8629,1.8051,1.8051,0,0,0,1.9251-1.801V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0V14.8524a1.9177,1.9177,0,0,1,3.8354,0v6.2044a1.8049,1.8049,0,0,0,3.61,0Z"
    })), children);
  });
  var LogoWechat32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoWechat32(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$e || (_path121$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M27.0857,24.7792A6.6179,6.6179,0,0,0,30,19.4662c0-3.88-3.7765-7.0269-8.4338-7.0269s-8.4339,3.1465-8.4339,7.0269,3.7765,7.028,8.4339,7.028a9.9547,9.9547,0,0,0,2.7533-.385l.2473-.0374a.8923.8923,0,0,1,.448.13l1.8469,1.0664.1621.0525a.2813.2813,0,0,0,.2812-.2812l-.0455-.2053-.38-1.4175-.0292-.18A.56.56,0,0,1,27.0857,24.7792ZM12.1208,4.68C6.5313,4.68,2,8.4552,2,13.1137a7.9386,7.9386,0,0,0,3.4965,6.3746.6713.6713,0,0,1,.2835.55l-.035.2147-.4562,1.701L5.234,22.2a.3384.3384,0,0,0,.3372.3383l.196-.063,2.2155-1.28a1.0584,1.0584,0,0,1,.5366-.1552l.2975.0443a11.9674,11.9674,0,0,0,3.304.4632l.5554-.014a6.5153,6.5153,0,0,1-.3395-2.0662c0-4.2478,4.1323-7.6918,9.2295-7.6918l.55.014C21.3538,7.761,17.169,4.68,12.1208,4.68Zm6.6337,13.6629a1.1247,1.1247,0,1,1,1.1247-1.1247A1.1243,1.1243,0,0,1,18.7545,18.3427Zm5.6233,0a1.1247,1.1247,0,1,1,1.1235-1.1247A1.1245,1.1245,0,0,1,24.3778,18.3427ZM8.7468,11.7638a1.3493,1.3493,0,1,1,1.35-1.3486A1.3485,1.3485,0,0,1,8.7468,11.7638Zm6.7469,0a1.3493,1.3493,0,1,1,1.35-1.3486A1.3486,1.3486,0,0,1,15.4937,11.7638Z"
    })), children);
  });
  var LogoWechat24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoWechat24(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$e || (_path122$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M27.0857,24.7792A6.6179,6.6179,0,0,0,30,19.4662c0-3.88-3.7765-7.0269-8.4338-7.0269s-8.4339,3.1465-8.4339,7.0269,3.7765,7.028,8.4339,7.028a9.9547,9.9547,0,0,0,2.7533-.385l.2473-.0374a.8923.8923,0,0,1,.448.13l1.8469,1.0664.1621.0525a.2813.2813,0,0,0,.2812-.2812l-.0455-.2053-.38-1.4175-.0292-.18A.56.56,0,0,1,27.0857,24.7792ZM12.1208,4.68C6.5313,4.68,2,8.4552,2,13.1137a7.9386,7.9386,0,0,0,3.4965,6.3746.6713.6713,0,0,1,.2835.55l-.035.2147-.4562,1.701L5.234,22.2a.3384.3384,0,0,0,.3372.3383l.196-.063,2.2155-1.28a1.0584,1.0584,0,0,1,.5366-.1552l.2975.0443a11.9674,11.9674,0,0,0,3.304.4632l.5554-.014a6.5153,6.5153,0,0,1-.3395-2.0662c0-4.2478,4.1323-7.6918,9.2295-7.6918l.55.014C21.3538,7.761,17.169,4.68,12.1208,4.68Zm6.6337,13.6629a1.1247,1.1247,0,1,1,1.1247-1.1247A1.1243,1.1243,0,0,1,18.7545,18.3427Zm5.6233,0a1.1247,1.1247,0,1,1,1.1235-1.1247A1.1245,1.1245,0,0,1,24.3778,18.3427ZM8.7468,11.7638a1.3493,1.3493,0,1,1,1.35-1.3486A1.3485,1.3485,0,0,1,8.7468,11.7638Zm6.7469,0a1.3493,1.3493,0,1,1,1.35-1.3486A1.3486,1.3486,0,0,1,15.4937,11.7638Z"
    })), children);
  });
  var LogoWechat20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoWechat20(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$e || (_path123$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M27.0857,24.7792A6.6179,6.6179,0,0,0,30,19.4662c0-3.88-3.7765-7.0269-8.4338-7.0269s-8.4339,3.1465-8.4339,7.0269,3.7765,7.028,8.4339,7.028a9.9547,9.9547,0,0,0,2.7533-.385l.2473-.0374a.8923.8923,0,0,1,.448.13l1.8469,1.0664.1621.0525a.2813.2813,0,0,0,.2812-.2812l-.0455-.2053-.38-1.4175-.0292-.18A.56.56,0,0,1,27.0857,24.7792ZM12.1208,4.68C6.5313,4.68,2,8.4552,2,13.1137a7.9386,7.9386,0,0,0,3.4965,6.3746.6713.6713,0,0,1,.2835.55l-.035.2147-.4562,1.701L5.234,22.2a.3384.3384,0,0,0,.3372.3383l.196-.063,2.2155-1.28a1.0584,1.0584,0,0,1,.5366-.1552l.2975.0443a11.9674,11.9674,0,0,0,3.304.4632l.5554-.014a6.5153,6.5153,0,0,1-.3395-2.0662c0-4.2478,4.1323-7.6918,9.2295-7.6918l.55.014C21.3538,7.761,17.169,4.68,12.1208,4.68Zm6.6337,13.6629a1.1247,1.1247,0,1,1,1.1247-1.1247A1.1243,1.1243,0,0,1,18.7545,18.3427Zm5.6233,0a1.1247,1.1247,0,1,1,1.1235-1.1247A1.1245,1.1245,0,0,1,24.3778,18.3427ZM8.7468,11.7638a1.3493,1.3493,0,1,1,1.35-1.3486A1.3485,1.3485,0,0,1,8.7468,11.7638Zm6.7469,0a1.3493,1.3493,0,1,1,1.35-1.3486A1.3486,1.3486,0,0,1,15.4937,11.7638Z"
    })), children);
  });
  var LogoWechat16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoWechat16(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$e || (_path124$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M27.0857,24.7792A6.6179,6.6179,0,0,0,30,19.4662c0-3.88-3.7765-7.0269-8.4338-7.0269s-8.4339,3.1465-8.4339,7.0269,3.7765,7.028,8.4339,7.028a9.9547,9.9547,0,0,0,2.7533-.385l.2473-.0374a.8923.8923,0,0,1,.448.13l1.8469,1.0664.1621.0525a.2813.2813,0,0,0,.2812-.2812l-.0455-.2053-.38-1.4175-.0292-.18A.56.56,0,0,1,27.0857,24.7792ZM12.1208,4.68C6.5313,4.68,2,8.4552,2,13.1137a7.9386,7.9386,0,0,0,3.4965,6.3746.6713.6713,0,0,1,.2835.55l-.035.2147-.4562,1.701L5.234,22.2a.3384.3384,0,0,0,.3372.3383l.196-.063,2.2155-1.28a1.0584,1.0584,0,0,1,.5366-.1552l.2975.0443a11.9674,11.9674,0,0,0,3.304.4632l.5554-.014a6.5153,6.5153,0,0,1-.3395-2.0662c0-4.2478,4.1323-7.6918,9.2295-7.6918l.55.014C21.3538,7.761,17.169,4.68,12.1208,4.68Zm6.6337,13.6629a1.1247,1.1247,0,1,1,1.1247-1.1247A1.1243,1.1243,0,0,1,18.7545,18.3427Zm5.6233,0a1.1247,1.1247,0,1,1,1.1235-1.1247A1.1245,1.1245,0,0,1,24.3778,18.3427ZM8.7468,11.7638a1.3493,1.3493,0,1,1,1.35-1.3486A1.3485,1.3485,0,0,1,8.7468,11.7638Zm6.7469,0a1.3493,1.3493,0,1,1,1.35-1.3486A1.3486,1.3486,0,0,1,15.4937,11.7638Z"
    })), children);
  });
  var LogoXing32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoXing32(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$e || (_path125$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.42,8.29a1.25,1.25,0,0,0-1.13-.76h-4a.65.65,0,0,0-.55.25.63.63,0,0,0,0,.62l2.73,4.73v0L4.17,20.72a.6.6,0,0,0,0,.62.58.58,0,0,0,.52.28h4a1.22,1.22,0,0,0,1.1-.78l4.36-7.71S11.42,8.29,11.42,8.29Z"
    })), _path126$e || (_path126$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.83,2.88a.65.65,0,0,0,0-.62A.61.61,0,0,0,27.3,2H23.22a1.19,1.19,0,0,0-1.08.77s-8.7,15.43-9,15.93l5.74,10.53A1.26,1.26,0,0,0,20,30h4a.59.59,0,0,0,.54-.26.62.62,0,0,0,0-.62l-5.69-10.4a0,0,0,0,1,0,0Z"
    })), children);
  });
  var LogoXing24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoXing24(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$e || (_path127$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.42,8.29a1.25,1.25,0,0,0-1.13-.76h-4a.65.65,0,0,0-.55.25.63.63,0,0,0,0,.62l2.73,4.73v0L4.17,20.72a.6.6,0,0,0,0,.62.58.58,0,0,0,.52.28h4a1.22,1.22,0,0,0,1.1-.78l4.36-7.71S11.42,8.29,11.42,8.29Z"
    })), _path128$e || (_path128$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.83,2.88a.65.65,0,0,0,0-.62A.61.61,0,0,0,27.3,2H23.22a1.19,1.19,0,0,0-1.08.77s-8.7,15.43-9,15.93l5.74,10.53A1.26,1.26,0,0,0,20,30h4a.59.59,0,0,0,.54-.26.62.62,0,0,0,0-.62l-5.69-10.4a0,0,0,0,1,0,0Z"
    })), children);
  });
  var LogoXing20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoXing20(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$e || (_path129$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.42,8.29a1.25,1.25,0,0,0-1.13-.76h-4a.65.65,0,0,0-.55.25.63.63,0,0,0,0,.62l2.73,4.73v0L4.17,20.72a.6.6,0,0,0,0,.62.58.58,0,0,0,.52.28h4a1.22,1.22,0,0,0,1.1-.78l4.36-7.71S11.42,8.29,11.42,8.29Z"
    })), _path130$e || (_path130$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.83,2.88a.65.65,0,0,0,0-.62A.61.61,0,0,0,27.3,2H23.22a1.19,1.19,0,0,0-1.08.77s-8.7,15.43-9,15.93l5.74,10.53A1.26,1.26,0,0,0,20,30h4a.59.59,0,0,0,.54-.26.62.62,0,0,0,0-.62l-5.69-10.4a0,0,0,0,1,0,0Z"
    })), children);
  });
  var LogoXing16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoXing16(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$e || (_path131$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.42,8.29a1.25,1.25,0,0,0-1.13-.76h-4a.65.65,0,0,0-.55.25.63.63,0,0,0,0,.62l2.73,4.73v0L4.17,20.72a.6.6,0,0,0,0,.62.58.58,0,0,0,.52.28h4a1.22,1.22,0,0,0,1.1-.78l4.36-7.71S11.42,8.29,11.42,8.29Z"
    })), _path132$e || (_path132$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.83,2.88a.65.65,0,0,0,0-.62A.61.61,0,0,0,27.3,2H23.22a1.19,1.19,0,0,0-1.08.77s-8.7,15.43-9,15.93l5.74,10.53A1.26,1.26,0,0,0,20,30h4a.59.59,0,0,0,.54-.26.62.62,0,0,0,0-.62l-5.69-10.4a0,0,0,0,1,0,0Z"
    })), children);
  });
  var LogoYelp32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYelp32(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$e || (_path133$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 01-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 01-1.3241-.921 9.2173 9.2173 0 01.4213-3.9965A1.0706 1.0706 0 019.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 011.8657.7537l-.1814 5.1945a1.072 1.072 0 01-1.2491 1.0192A9.3014 9.3014 0 0111.1488 26.46 1.0713 1.0713 0 0110.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 01.6363 1.4794 9.3022 9.3022 0 01-2.4707 3.1663 1.072 1.072 0 01-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0119.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0118.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0122.55 11.86 9.2168 9.2168 0 0124.9135 15.11 1.0729 1.0729 0 0124.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 00-2.5676.9459 1.07 1.07 0 00-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 001.9979-.5353V5.0534A1.07 1.07 0 0015.2526 3.985 14.9577 14.9577 0 0012.5561 4.45z"
    })), children);
  });
  var LogoYelp24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYelp24(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$e || (_path134$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 01-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 01-1.3241-.921 9.2173 9.2173 0 01.4213-3.9965A1.0706 1.0706 0 019.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 011.8657.7537l-.1814 5.1945a1.072 1.072 0 01-1.2491 1.0192A9.3014 9.3014 0 0111.1488 26.46 1.0713 1.0713 0 0110.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 01.6363 1.4794 9.3022 9.3022 0 01-2.4707 3.1663 1.072 1.072 0 01-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0119.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0118.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0122.55 11.86 9.2168 9.2168 0 0124.9135 15.11 1.0729 1.0729 0 0124.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 00-2.5676.9459 1.07 1.07 0 00-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 001.9979-.5353V5.0534A1.07 1.07 0 0015.2526 3.985 14.9577 14.9577 0 0012.5561 4.45z"
    })), children);
  });
  var LogoYelp20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYelp20(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$e || (_path135$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 01-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 01-1.3241-.921 9.2173 9.2173 0 01.4213-3.9965A1.0706 1.0706 0 019.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 011.8657.7537l-.1814 5.1945a1.072 1.072 0 01-1.2491 1.0192A9.3014 9.3014 0 0111.1488 26.46 1.0713 1.0713 0 0110.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 01.6363 1.4794 9.3022 9.3022 0 01-2.4707 3.1663 1.072 1.072 0 01-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0119.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0118.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0122.55 11.86 9.2168 9.2168 0 0124.9135 15.11 1.0729 1.0729 0 0124.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 00-2.5676.9459 1.07 1.07 0 00-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 001.9979-.5353V5.0534A1.07 1.07 0 0015.2526 3.985 14.9577 14.9577 0 0012.5561 4.45z"
    })), children);
  });
  var LogoYelp16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYelp16(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$e || (_path136$e = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 01-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 01-1.3241-.921 9.2173 9.2173 0 01.4213-3.9965A1.0706 1.0706 0 019.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 011.8657.7537l-.1814 5.1945a1.072 1.072 0 01-1.2491 1.0192A9.3014 9.3014 0 0111.1488 26.46 1.0713 1.0713 0 0110.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 01.6363 1.4794 9.3022 9.3022 0 01-2.4707 3.1663 1.072 1.072 0 01-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0119.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0118.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0122.55 11.86 9.2168 9.2168 0 0124.9135 15.11 1.0729 1.0729 0 0124.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 00-2.5676.9459 1.07 1.07 0 00-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 001.9979-.5353V5.0534A1.07 1.07 0 0015.2526 3.985 14.9577 14.9577 0 0012.5561 4.45z"
    })), children);
  });
  var LogoYoutube32 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYoutube32(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$e || (_path137$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"
    })), children);
  });
  var LogoYoutube24 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYoutube24(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$e || (_path138$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"
    })), children);
  });
  var LogoYoutube20 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYoutube20(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$e || (_path139$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"
    })), children);
  });
  var LogoYoutube16 = /*#__PURE__*/React__default['default'].forwardRef(function LogoYoutube16(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$e || (_path140$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"
    })), children);
  });
  var Logout32 = /*#__PURE__*/React__default['default'].forwardRef(function Logout32(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$e || (_path141$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"
    })), _path142$e || (_path142$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"
    })), children);
  });
  var Logout24 = /*#__PURE__*/React__default['default'].forwardRef(function Logout24(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$e || (_path143$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"
    })), _path144$e || (_path144$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"
    })), children);
  });
  var Logout20 = /*#__PURE__*/React__default['default'].forwardRef(function Logout20(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$e || (_path145$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"
    })), _path146$e || (_path146$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"
    })), children);
  });
  var Logout16 = /*#__PURE__*/React__default['default'].forwardRef(function Logout16(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$e || (_path147$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"
    })), _path148$e || (_path148$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"
    })), children);
  });
  var Loop32 = /*#__PURE__*/React__default['default'].forwardRef(function Loop32(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$e || (_path149$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 005.52 20l1.66-1.11A7 7 0 1113 22H2v2H13A9 9 0 0013 6z"
    })), children);
  });
  var Loop24 = /*#__PURE__*/React__default['default'].forwardRef(function Loop24(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$e || (_path150$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 005.52 20l1.66-1.11A7 7 0 1113 22H2v2H13A9 9 0 0013 6z"
    })), children);
  });
  var Loop20 = /*#__PURE__*/React__default['default'].forwardRef(function Loop20(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$e || (_path151$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 005.52 20l1.66-1.11A7 7 0 1113 22H2v2H13A9 9 0 0013 6z"
    })), children);
  });
  var Loop16 = /*#__PURE__*/React__default['default'].forwardRef(function Loop16(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$e || (_path152$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 005.52 20l1.66-1.11A7 7 0 1113 22H2v2H13A9 9 0 0013 6z"
    })), children);
  });
  var LowSeverityGlyph = /*#__PURE__*/React__default['default'].forwardRef(function LowSeverityGlyph(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$e || (_path153$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 4H12V12H4z"
    })), _path154$e || (_path154$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4v8H4V4h8m1-1H3V13H13V3Z"
    })), children);
  });
  var MacCommand32 = /*#__PURE__*/React__default['default'].forwardRef(function MacCommand32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$e || (_path155$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"
    })), children);
  });
  var MacCommand24 = /*#__PURE__*/React__default['default'].forwardRef(function MacCommand24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$e || (_path156$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"
    })), children);
  });
  var MacCommand20 = /*#__PURE__*/React__default['default'].forwardRef(function MacCommand20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$e || (_path157$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"
    })), children);
  });
  var MacCommand16 = /*#__PURE__*/React__default['default'].forwardRef(function MacCommand16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$e || (_path158$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"
    })), children);
  });
  var MacOption32 = /*#__PURE__*/React__default['default'].forwardRef(function MacOption32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$e || (_path159$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"
    })), children);
  });
  var MacOption24 = /*#__PURE__*/React__default['default'].forwardRef(function MacOption24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$e);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$e || (_path160$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"
    })), children);
  });
  var MacOption20 = /*#__PURE__*/React__default['default'].forwardRef(function MacOption20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$e || (_path161$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"
    })), children);
  });
  var MacOption16 = /*#__PURE__*/React__default['default'].forwardRef(function MacOption16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$e || (_path162$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"
    })), children);
  });
  var MacShift32 = /*#__PURE__*/React__default['default'].forwardRef(function MacShift32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$e || (_path163$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,28H11a2.0023,2.0023,0,0,1-2-2V16H4a1,1,0,0,1-.707-1.707l12-12a.9994.9994,0,0,1,1.414,0l12,12A1,1,0,0,1,28,16H23V26A2.0027,2.0027,0,0,1,21,28ZM6.4141,14H11V26H21V14h4.5859L16,4.4141Z"
    })), children);
  });
  var MacShift24 = /*#__PURE__*/React__default['default'].forwardRef(function MacShift24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$e || (_path164$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,28H11a2.0023,2.0023,0,0,1-2-2V16H4a1,1,0,0,1-.707-1.707l12-12a.9994.9994,0,0,1,1.414,0l12,12A1,1,0,0,1,28,16H23V26A2.0027,2.0027,0,0,1,21,28ZM6.4141,14H11V26H21V14h4.5859L16,4.4141Z"
    })), children);
  });
  var MacShift20 = /*#__PURE__*/React__default['default'].forwardRef(function MacShift20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$e || (_path165$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,28H11a2.0023,2.0023,0,0,1-2-2V16H4a1,1,0,0,1-.707-1.707l12-12a.9994.9994,0,0,1,1.414,0l12,12A1,1,0,0,1,28,16H23V26A2.0027,2.0027,0,0,1,21,28ZM6.4141,14H11V26H21V14h4.5859L16,4.4141Z"
    })), children);
  });
  var MacShift16 = /*#__PURE__*/React__default['default'].forwardRef(function MacShift16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$e || (_path166$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,28H11a2.0023,2.0023,0,0,1-2-2V16H4a1,1,0,0,1-.707-1.707l12-12a.9994.9994,0,0,1,1.414,0l12,12A1,1,0,0,1,28,16H23V26A2.0027,2.0027,0,0,1,21,28ZM6.4141,14H11V26H21V14h4.5859L16,4.4141Z"
    })), children);
  });
  var MachineLearning32 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearning32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$e || (_path167$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 25zM20 14a2 2 0 102 2A1.9806 1.9806 0 0020 14zM12 14a2 2 0 102 2A1.9806 1.9806 0 0012 14z"
    })), _path168$e || (_path168$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var MachineLearning24 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearning24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$e || (_path169$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 25zM20 14a2 2 0 102 2A1.9806 1.9806 0 0020 14zM12 14a2 2 0 102 2A1.9806 1.9806 0 0012 14z"
    })), _path170$e || (_path170$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var MachineLearning20 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearning20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$e || (_path171$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 25zM20 14a2 2 0 102 2A1.9806 1.9806 0 0020 14zM12 14a2 2 0 102 2A1.9806 1.9806 0 0012 14z"
    })), _path172$e || (_path172$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var MachineLearning16 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearning16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$e || (_path173$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0116 25zM20 14a2 2 0 102 2A1.9806 1.9806 0 0020 14zM12 14a2 2 0 102 2A1.9806 1.9806 0 0012 14z"
    })), _path174$e || (_path174$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"
    })), children);
  });
  var MachineLearningModel32 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearningModel32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$e || (_path175$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 24a2.9609 2.9609 0 00-1.2854.3008L21.4141 20H18v2h2.5859l3.7146 3.7148A2.9665 2.9665 0 0024 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 28zM27 13a2.9948 2.9948 0 00-2.8157 2H18v2h6.1843A2.9947 2.9947 0 1027 13zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 17zM27 2a3.0033 3.0033 0 00-3 3 2.9657 2.9657 0 00.3481 1.373L20.5957 10H18v2h3.4043l4.3989-4.2524A2.9987 2.9987 0 1027 2zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 6z"
    })), _path176$e || (_path176$e = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,6h2V4H18a3.9756,3.9756,0,0,0-3,1.3823A3.9756,3.9756,0,0,0,12,4H11a9.01,9.01,0,0,0-9,9v6a9.01,9.01,0,0,0,9,9h1a3.9756,3.9756,0,0,0,3-1.3823A3.9756,3.9756,0,0,0,18,28h2V26H18a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,18,6ZM12,26H11a7.0047,7.0047,0,0,1-6.92-6H6V18H4V14H7a3.0033,3.0033,0,0,0,3-3V9H8v2a1.0009,1.0009,0,0,1-1,1H4.08A7.0047,7.0047,0,0,1,11,6h1a2.0023,2.0023,0,0,1,2,2v4H12v2h2v4H12a3.0033,3.0033,0,0,0-3,3v2h2V21a1.0009,1.0009,0,0,1,1-1h2v4A2.0023,2.0023,0,0,1,12,26Z"
    })), children);
  });
  var MachineLearningModel24 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearningModel24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$d || (_path177$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 24a2.9609 2.9609 0 00-1.2854.3008L21.4141 20H18v2h2.5859l3.7146 3.7148A2.9665 2.9665 0 0024 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 28zM27 13a2.9948 2.9948 0 00-2.8157 2H18v2h6.1843A2.9947 2.9947 0 1027 13zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 17zM27 2a3.0033 3.0033 0 00-3 3 2.9657 2.9657 0 00.3481 1.373L20.5957 10H18v2h3.4043l4.3989-4.2524A2.9987 2.9987 0 1027 2zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 6z"
    })), _path178$d || (_path178$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,6h2V4H18a3.9756,3.9756,0,0,0-3,1.3823A3.9756,3.9756,0,0,0,12,4H11a9.01,9.01,0,0,0-9,9v6a9.01,9.01,0,0,0,9,9h1a3.9756,3.9756,0,0,0,3-1.3823A3.9756,3.9756,0,0,0,18,28h2V26H18a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,18,6ZM12,26H11a7.0047,7.0047,0,0,1-6.92-6H6V18H4V14H7a3.0033,3.0033,0,0,0,3-3V9H8v2a1.0009,1.0009,0,0,1-1,1H4.08A7.0047,7.0047,0,0,1,11,6h1a2.0023,2.0023,0,0,1,2,2v4H12v2h2v4H12a3.0033,3.0033,0,0,0-3,3v2h2V21a1.0009,1.0009,0,0,1,1-1h2v4A2.0023,2.0023,0,0,1,12,26Z"
    })), children);
  });
  var MachineLearningModel20 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearningModel20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$d || (_path179$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 24a2.9609 2.9609 0 00-1.2854.3008L21.4141 20H18v2h2.5859l3.7146 3.7148A2.9665 2.9665 0 0024 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 28zM27 13a2.9948 2.9948 0 00-2.8157 2H18v2h6.1843A2.9947 2.9947 0 1027 13zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 17zM27 2a3.0033 3.0033 0 00-3 3 2.9657 2.9657 0 00.3481 1.373L20.5957 10H18v2h3.4043l4.3989-4.2524A2.9987 2.9987 0 1027 2zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 6z"
    })), _path180$d || (_path180$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,6h2V4H18a3.9756,3.9756,0,0,0-3,1.3823A3.9756,3.9756,0,0,0,12,4H11a9.01,9.01,0,0,0-9,9v6a9.01,9.01,0,0,0,9,9h1a3.9756,3.9756,0,0,0,3-1.3823A3.9756,3.9756,0,0,0,18,28h2V26H18a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,18,6ZM12,26H11a7.0047,7.0047,0,0,1-6.92-6H6V18H4V14H7a3.0033,3.0033,0,0,0,3-3V9H8v2a1.0009,1.0009,0,0,1-1,1H4.08A7.0047,7.0047,0,0,1,11,6h1a2.0023,2.0023,0,0,1,2,2v4H12v2h2v4H12a3.0033,3.0033,0,0,0-3,3v2h2V21a1.0009,1.0009,0,0,1,1-1h2v4A2.0023,2.0023,0,0,1,12,26Z"
    })), children);
  });
  var MachineLearningModel16 = /*#__PURE__*/React__default['default'].forwardRef(function MachineLearningModel16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$d || (_path181$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 24a2.9609 2.9609 0 00-1.2854.3008L21.4141 20H18v2h2.5859l3.7146 3.7148A2.9665 2.9665 0 0024 27a3 3 0 103-3zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 28zM27 13a2.9948 2.9948 0 00-2.8157 2H18v2h6.1843A2.9947 2.9947 0 1027 13zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 17zM27 2a3.0033 3.0033 0 00-3 3 2.9657 2.9657 0 00.3481 1.373L20.5957 10H18v2h3.4043l4.3989-4.2524A2.9987 2.9987 0 1027 2zm0 4a1 1 0 111-1A1.0009 1.0009 0 0127 6z"
    })), _path182$d || (_path182$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,6h2V4H18a3.9756,3.9756,0,0,0-3,1.3823A3.9756,3.9756,0,0,0,12,4H11a9.01,9.01,0,0,0-9,9v6a9.01,9.01,0,0,0,9,9h1a3.9756,3.9756,0,0,0,3-1.3823A3.9756,3.9756,0,0,0,18,28h2V26H18a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,18,6ZM12,26H11a7.0047,7.0047,0,0,1-6.92-6H6V18H4V14H7a3.0033,3.0033,0,0,0,3-3V9H8v2a1.0009,1.0009,0,0,1-1,1H4.08A7.0047,7.0047,0,0,1,11,6h1a2.0023,2.0023,0,0,1,2,2v4H12v2h2v4H12a3.0033,3.0033,0,0,0-3,3v2h2V21a1.0009,1.0009,0,0,1,1-1h2v4A2.0023,2.0023,0,0,1,12,26Z"
    })), children);
  });
  var MagicWand32 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWand32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$d || (_path183$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"
    })), _path184$d || (_path184$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path185$d || (_path185$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path186$d || (_path186$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWand24 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWand24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$d || (_path187$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"
    })), _path188$d || (_path188$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path189$d || (_path189$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path190$d || (_path190$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWand20 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWand20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$d || (_path191$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"
    })), _path192$d || (_path192$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path193$d || (_path193$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path194$d || (_path194$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWand16 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWand16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$d || (_path195$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"
    })), _path196$d || (_path196$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path197$d || (_path197$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path198$d || (_path198$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWandFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWandFilled32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$d || (_path199$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"
    })), _path200$d || (_path200$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path201$d || (_path201$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path202$d || (_path202$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWandFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWandFilled24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$d || (_path203$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"
    })), _path204$d || (_path204$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path205$d || (_path205$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path206$d || (_path206$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWandFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWandFilled20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$d || (_path207$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"
    })), _path208$d || (_path208$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path209$d || (_path209$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path210$d || (_path210$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var MagicWandFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function MagicWandFilled16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$d || (_path211$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"
    })), _path212$d || (_path212$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 14.586H5.414V17.414H2.586z",
      transform: "rotate(-45 4 16)"
    })), _path213$d || (_path213$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.586 2.586H17.414V5.414H14.586z",
      transform: "rotate(-45 16 4)"
    })), _path214$d || (_path214$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 2.586H5.414V5.414H2.586z",
      transform: "rotate(-45 4 4)"
    })), children);
  });
  var WatsonHealthMagnify32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMagnify32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$d || (_path215$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"
    })), _path216$d || (_path216$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"
    })), children);
  });
  var WatsonHealthMagnify24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMagnify24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$d || (_path217$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"
    })), _path218$d || (_path218$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"
    })), children);
  });
  var WatsonHealthMagnify20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMagnify20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$d || (_path219$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"
    })), _path220$d || (_path220$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"
    })), children);
  });
  var WatsonHealthMagnify16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMagnify16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$d || (_path221$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"
    })), _path222$d || (_path222$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"
    })), children);
  });
  var MailAll32 = /*#__PURE__*/React__default['default'].forwardRef(function MailAll32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$d || (_path223$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"
    })), _path224$d || (_path224$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"
    })), children);
  });
  var MailAll24 = /*#__PURE__*/React__default['default'].forwardRef(function MailAll24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$d || (_path225$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"
    })), _path226$d || (_path226$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"
    })), children);
  });
  var MailAll20 = /*#__PURE__*/React__default['default'].forwardRef(function MailAll20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$d || (_path227$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"
    })), _path228$d || (_path228$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"
    })), children);
  });
  var MailAll16 = /*#__PURE__*/React__default['default'].forwardRef(function MailAll16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$d || (_path229$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"
    })), _path230$d || (_path230$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"
    })), children);
  });
  var MailReply32 = /*#__PURE__*/React__default['default'].forwardRef(function MailReply32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$d || (_path231$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,18l-1.4141,1.4141L26.1672,22H18a4,4,0,0,0,0,8h2V28H18a2,2,0,0,1,0-4h8.1672l-2.5827,2.5874L25,28l5-5Z"
    })), _path232$d || (_path232$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,22H4L3.9966,6.9064l11.4341,7.9159a1.0008,1.0008,0,0,0,1.1386,0L28,6.9086,28,16h2V6a2.0025,2.0025,0,0,0-2-2H4A2,2,0,0,0,2,5.9965V22a2.0026,2.0026,0,0,0,2,2h6ZM25.7986,6,16,12.7837,6.2014,6Z"
    })), children);
  });
  var MailReply24 = /*#__PURE__*/React__default['default'].forwardRef(function MailReply24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$d || (_path233$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,18l-1.4141,1.4141L26.1672,22H18a4,4,0,0,0,0,8h2V28H18a2,2,0,0,1,0-4h8.1672l-2.5827,2.5874L25,28l5-5Z"
    })), _path234$d || (_path234$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,22H4L3.9966,6.9064l11.4341,7.9159a1.0008,1.0008,0,0,0,1.1386,0L28,6.9086,28,16h2V6a2.0025,2.0025,0,0,0-2-2H4A2,2,0,0,0,2,5.9965V22a2.0026,2.0026,0,0,0,2,2h6ZM25.7986,6,16,12.7837,6.2014,6Z"
    })), children);
  });
  var MailReply20 = /*#__PURE__*/React__default['default'].forwardRef(function MailReply20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$d || (_path235$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,18l-1.4141,1.4141L26.1672,22H18a4,4,0,0,0,0,8h2V28H18a2,2,0,0,1,0-4h8.1672l-2.5827,2.5874L25,28l5-5Z"
    })), _path236$d || (_path236$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,22H4L3.9966,6.9064l11.4341,7.9159a1.0008,1.0008,0,0,0,1.1386,0L28,6.9086,28,16h2V6a2.0025,2.0025,0,0,0-2-2H4A2,2,0,0,0,2,5.9965V22a2.0026,2.0026,0,0,0,2,2h6ZM25.7986,6,16,12.7837,6.2014,6Z"
    })), children);
  });
  var MailReply16 = /*#__PURE__*/React__default['default'].forwardRef(function MailReply16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$d || (_path237$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,18l-1.4141,1.4141L26.1672,22H18a4,4,0,0,0,0,8h2V28H18a2,2,0,0,1,0-4h8.1672l-2.5827,2.5874L25,28l5-5Z"
    })), _path238$d || (_path238$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,22H4L3.9966,6.9064l11.4341,7.9159a1.0008,1.0008,0,0,0,1.1386,0L28,6.9086,28,16h2V6a2.0025,2.0025,0,0,0-2-2H4A2,2,0,0,0,2,5.9965V22a2.0026,2.0026,0,0,0,2,2h6ZM25.7986,6,16,12.7837,6.2014,6Z"
    })), children);
  });
  var WatsonHealthMammogram32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMammogram32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$d || (_path239$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 27zm-1-2h1a1.0006 1.0006 0 001-1V20a1.0006 1.0006 0 00-1-1H24zM20 27H14V23a2.002 2.002 0 012-2h2V19H14V17h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 15zm-1-2h1a1.0009 1.0009 0 001-1V8a1.0009 1.0009 0 00-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 002-2V7A2.0023 2.0023 0 0018 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 011 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"
    })), children);
  });
  var WatsonHealthMammogram24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMammogram24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$d || (_path240$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 27zm-1-2h1a1.0006 1.0006 0 001-1V20a1.0006 1.0006 0 00-1-1H24zM20 27H14V23a2.002 2.002 0 012-2h2V19H14V17h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 15zm-1-2h1a1.0009 1.0009 0 001-1V8a1.0009 1.0009 0 00-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 002-2V7A2.0023 2.0023 0 0018 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 011 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"
    })), children);
  });
  var WatsonHealthMammogram20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMammogram20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$d || (_path241$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 27zm-1-2h1a1.0006 1.0006 0 001-1V20a1.0006 1.0006 0 00-1-1H24zM20 27H14V23a2.002 2.002 0 012-2h2V19H14V17h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 15zm-1-2h1a1.0009 1.0009 0 001-1V8a1.0009 1.0009 0 00-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 002-2V7A2.0023 2.0023 0 0018 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 011 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"
    })), children);
  });
  var WatsonHealthMammogram16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthMammogram16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$d || (_path242$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 27zm-1-2h1a1.0006 1.0006 0 001-1V20a1.0006 1.0006 0 00-1-1H24zM20 27H14V23a2.002 2.002 0 012-2h2V19H14V17h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 013 3v4A3.0033 3.0033 0 0125 15zm-1-2h1a1.0009 1.0009 0 001-1V8a1.0009 1.0009 0 00-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 002-2V7A2.0023 2.0023 0 0018 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 011 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"
    })), children);
  });
  var MammogramStacked32 = /*#__PURE__*/React__default['default'].forwardRef(function MammogramStacked32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['MammogramStacked32']) {
        didWarnAboutDeprecation$3['MammogramStacked32'] = true;
        console.warn("The MammogramStacked32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$d || (_path243$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path244$d || (_path244$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path245$d || (_path245$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2.0023,2.0023,0,0,1-2-2V14a2.002,2.002,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,18,30ZM4,14V28H18.002L18,14Z"
    })), _path246$d || (_path246$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,18h1V16H13a5.0083,5.0083,0,0,0-4.8989,4H7v2H8.1011A5.0083,5.0083,0,0,0,13,26h1V24H13a3,3,0,0,1,0-6Z"
    })), children);
  });
  var MammogramStacked24 = /*#__PURE__*/React__default['default'].forwardRef(function MammogramStacked24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['MammogramStacked24']) {
        didWarnAboutDeprecation$3['MammogramStacked24'] = true;
        console.warn("The MammogramStacked24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$d || (_path247$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path248$d || (_path248$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path249$d || (_path249$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2.0023,2.0023,0,0,1-2-2V14a2.002,2.002,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,18,30ZM4,14V28H18.002L18,14Z"
    })), _path250$d || (_path250$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,18h1V16H13a5.0083,5.0083,0,0,0-4.8989,4H7v2H8.1011A5.0083,5.0083,0,0,0,13,26h1V24H13a3,3,0,0,1,0-6Z"
    })), children);
  });
  var MammogramStacked20 = /*#__PURE__*/React__default['default'].forwardRef(function MammogramStacked20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['MammogramStacked20']) {
        didWarnAboutDeprecation$3['MammogramStacked20'] = true;
        console.warn("The MammogramStacked20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$d || (_path251$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path252$d || (_path252$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path253$d || (_path253$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2.0023,2.0023,0,0,1-2-2V14a2.002,2.002,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,18,30ZM4,14V28H18.002L18,14Z"
    })), _path254$d || (_path254$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,18h1V16H13a5.0083,5.0083,0,0,0-4.8989,4H7v2H8.1011A5.0083,5.0083,0,0,0,13,26h1V24H13a3,3,0,0,1,0-6Z"
    })), children);
  });
  var MammogramStacked16 = /*#__PURE__*/React__default['default'].forwardRef(function MammogramStacked16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$3['MammogramStacked16']) {
        didWarnAboutDeprecation$3['MammogramStacked16'] = true;
        console.warn("The MammogramStacked16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$d || (_path255$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2.0023,2.0023,0,0,1,2,2Z"
    })), _path256$d || (_path256$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2.0023,2.0023,0,0,1,2,2Z"
    })), _path257$d || (_path257$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2.0023,2.0023,0,0,1-2-2V14a2.002,2.002,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,18,30ZM4,14V28H18.002L18,14Z"
    })), _path258$d || (_path258$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,18h1V16H13a5.0083,5.0083,0,0,0-4.8989,4H7v2H8.1011A5.0083,5.0083,0,0,0,13,26h1V24H13a3,3,0,0,1,0-6Z"
    })), children);
  });
  var ManageProtection32 = /*#__PURE__*/React__default['default'].forwardRef(function ManageProtection32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$d || (_path259$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), _path260$d || (_path260$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"
    })), children);
  });
  var ManageProtection24 = /*#__PURE__*/React__default['default'].forwardRef(function ManageProtection24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$d || (_path261$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), _path262$d || (_path262$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"
    })), children);
  });
  var ManageProtection20 = /*#__PURE__*/React__default['default'].forwardRef(function ManageProtection20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$d || (_path263$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), _path264$d || (_path264$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"
    })), children);
  });
  var ManageProtection16 = /*#__PURE__*/React__default['default'].forwardRef(function ManageProtection16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$d || (_path265$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), _path266$d || (_path266$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"
    })), children);
  });
  var ManagedSolutions32 = /*#__PURE__*/React__default['default'].forwardRef(function ManagedSolutions32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$d || (_path267$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"
    })), _path268$d || (_path268$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"
    })), children);
  });
  var ManagedSolutions24 = /*#__PURE__*/React__default['default'].forwardRef(function ManagedSolutions24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$d || (_path269$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"
    })), _path270$d || (_path270$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"
    })), children);
  });
  var ManagedSolutions20 = /*#__PURE__*/React__default['default'].forwardRef(function ManagedSolutions20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$d || (_path271$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"
    })), _path272$d || (_path272$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"
    })), children);
  });
  var ManagedSolutions16 = /*#__PURE__*/React__default['default'].forwardRef(function ManagedSolutions16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$d || (_path273$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"
    })), _path274$d || (_path274$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"
    })), children);
  });
  var Map32 = /*#__PURE__*/React__default['default'].forwardRef(function Map32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$d || (_path275$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"
    })), _circle11$a || (_circle11$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path276$d || (_path276$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"
    })), children);
  });
  var Map24 = /*#__PURE__*/React__default['default'].forwardRef(function Map24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$d || (_path277$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"
    })), _circle12$a || (_circle12$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path278$d || (_path278$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"
    })), children);
  });
  var Map20 = /*#__PURE__*/React__default['default'].forwardRef(function Map20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$d || (_path279$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"
    })), _circle13$a || (_circle13$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path280$d || (_path280$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"
    })), children);
  });
  var Map16 = /*#__PURE__*/React__default['default'].forwardRef(function Map16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$d || (_path281$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"
    })), _circle14$a || (_circle14$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "9",
      r: "2"
    })), _path282$d || (_path282$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"
    })), children);
  });
  var MapCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function MapCenter32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$d || (_path283$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26H25V30H23zM23 18H25V22H23zM26 23H30V25H26zM18 23H22V25H18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.0011 1.0011 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6015-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0268 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var MapCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function MapCenter24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$d || (_path284$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26H25V30H23zM23 18H25V22H23zM26 23H30V25H26zM18 23H22V25H18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.0011 1.0011 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6015-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0268 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var MapCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function MapCenter20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$d || (_path285$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26H25V30H23zM23 18H25V22H23zM26 23H30V25H26zM18 23H22V25H18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.0011 1.0011 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6015-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0268 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var MapCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function MapCenter16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$d || (_path286$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26H25V30H23zM23 18H25V22H23zM26 23H30V25H26zM18 23H22V25H18zM25.3418 10.06l-22-8A1 1 0 002.06 3.3415l8 22A1.0011 1.0011 0 0010.9839 26H11a1 1 0 00.9287-.6289L15.77 15.7692l9.6015-3.8408a1 1 0 00-.0293-1.8687zM14.6284 14.0709v0l-.3979.1591-.1591.3979 0 0-3.0268 7.5678L4.6719 4.6715l17.5244 6.3726z"
    })), children);
  });
  var MapIdentify32 = /*#__PURE__*/React__default['default'].forwardRef(function MapIdentify32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$d || (_path287$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V14H15zM15 18H17V24H15zM18 15H24V17H18zM8 15H14V17H8zM4 10H2V4A2.0021 2.0021 0 014 2h6V4H4zM10 30H4a2.0021 2.0021 0 01-2-2V22H4v6h6zM28 30H22V28h6V22h2v6A2.0021 2.0021 0 0128 30zM30 10H28V4H22V2h6a2.0021 2.0021 0 012 2z"
    })), children);
  });
  var MapIdentify24 = /*#__PURE__*/React__default['default'].forwardRef(function MapIdentify24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$d || (_path288$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V14H15zM15 18H17V24H15zM18 15H24V17H18zM8 15H14V17H8zM4 10H2V4A2.0021 2.0021 0 014 2h6V4H4zM10 30H4a2.0021 2.0021 0 01-2-2V22H4v6h6zM28 30H22V28h6V22h2v6A2.0021 2.0021 0 0128 30zM30 10H28V4H22V2h6a2.0021 2.0021 0 012 2z"
    })), children);
  });
  var MapIdentify20 = /*#__PURE__*/React__default['default'].forwardRef(function MapIdentify20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$d || (_path289$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V14H15zM15 18H17V24H15zM18 15H24V17H18zM8 15H14V17H8zM4 10H2V4A2.0021 2.0021 0 014 2h6V4H4zM10 30H4a2.0021 2.0021 0 01-2-2V22H4v6h6zM28 30H22V28h6V22h2v6A2.0021 2.0021 0 0128 30zM30 10H28V4H22V2h6a2.0021 2.0021 0 012 2z"
    })), children);
  });
  var MapIdentify16 = /*#__PURE__*/React__default['default'].forwardRef(function MapIdentify16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$d || (_path290$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V14H15zM15 18H17V24H15zM18 15H24V17H18zM8 15H14V17H8zM4 10H2V4A2.0021 2.0021 0 014 2h6V4H4zM10 30H4a2.0021 2.0021 0 01-2-2V22H4v6h6zM28 30H22V28h6V22h2v6A2.0021 2.0021 0 0128 30zM30 10H28V4H22V2h6a2.0021 2.0021 0 012 2z"
    })), children);
  });
  var MapBoundary32 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundary32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$d || (_path291$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H14V14H12zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM16 4H28V16H16z"
    })), _path292$d || (_path292$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 29.997L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.773 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 29.997z"
    })), children);
  });
  var MapBoundary24 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundary24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$d || (_path293$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H14V14H12zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM16 4H28V16H16z"
    })), _path294$d || (_path294$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 29.997L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.773 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 29.997z"
    })), children);
  });
  var MapBoundary20 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundary20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$d || (_path295$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H14V14H12zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM16 4H28V16H16z"
    })), _path296$d || (_path296$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 29.997L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.773 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 29.997z"
    })), children);
  });
  var MapBoundary16 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundary16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$d || (_path297$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H14V14H12zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM16 4H28V16H16z"
    })), _path298$d || (_path298$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 29.997L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.773 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 29.997z"
    })), children);
  });
  var MapBoundaryVegetation32 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundaryVegetation32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$d || (_path299$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16H18V14h5V10a2 2 0 012-2h1.5a1.5 1.5 0 00.2837-2.9734l-.7109-.1355L25.9982 4.32a2.6322 2.6322 0 00-1.68-2.1823 2.5051 2.5051 0 00-3.0836 1.3042l-.3032.6472-.71-.0771a2.0185 2.0185 0 00-2.17 2.4343A2.0976 2.0976 0 0020.1261 8H21v2h-.7817A4.1491 4.1491 0 0116.012 6.3136a4.0047 4.0047 0 013.7414-4.306A4.5006 4.5006 0 0127.8267 3.26a3.5051 3.5051 0 012.1422 3.7094A3.6283 3.6283 0 0126.3172 10H25v4h3zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM12 10H14V14H12z"
    })), _path300$d || (_path300$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 30L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.776 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 30z"
    })), children);
  });
  var MapBoundaryVegetation24 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundaryVegetation24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$d || (_path301$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16H18V14h5V10a2 2 0 012-2h1.5a1.5 1.5 0 00.2837-2.9734l-.7109-.1355L25.9982 4.32a2.6322 2.6322 0 00-1.68-2.1823 2.5051 2.5051 0 00-3.0836 1.3042l-.3032.6472-.71-.0771a2.0185 2.0185 0 00-2.17 2.4343A2.0976 2.0976 0 0020.1261 8H21v2h-.7817A4.1491 4.1491 0 0116.012 6.3136a4.0047 4.0047 0 013.7414-4.306A4.5006 4.5006 0 0127.8267 3.26a3.5051 3.5051 0 012.1422 3.7094A3.6283 3.6283 0 0126.3172 10H25v4h3zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM12 10H14V14H12z"
    })), _path302$d || (_path302$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 30L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.776 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 30z"
    })), children);
  });
  var MapBoundaryVegetation20 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundaryVegetation20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$d || (_path303$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16H18V14h5V10a2 2 0 012-2h1.5a1.5 1.5 0 00.2837-2.9734l-.7109-.1355L25.9982 4.32a2.6322 2.6322 0 00-1.68-2.1823 2.5051 2.5051 0 00-3.0836 1.3042l-.3032.6472-.71-.0771a2.0185 2.0185 0 00-2.17 2.4343A2.0976 2.0976 0 0020.1261 8H21v2h-.7817A4.1491 4.1491 0 0116.012 6.3136a4.0047 4.0047 0 013.7414-4.306A4.5006 4.5006 0 0127.8267 3.26a3.5051 3.5051 0 012.1422 3.7094A3.6283 3.6283 0 0126.3172 10H25v4h3zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM12 10H14V14H12z"
    })), _path304$d || (_path304$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 30L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.776 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 30z"
    })), children);
  });
  var MapBoundaryVegetation16 = /*#__PURE__*/React__default['default'].forwardRef(function MapBoundaryVegetation16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$d || (_path305$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16H18V14h5V10a2 2 0 012-2h1.5a1.5 1.5 0 00.2837-2.9734l-.7109-.1355L25.9982 4.32a2.6322 2.6322 0 00-1.68-2.1823 2.5051 2.5051 0 00-3.0836 1.3042l-.3032.6472-.71-.0771a2.0185 2.0185 0 00-2.17 2.4343A2.0976 2.0976 0 0020.1261 8H21v2h-.7817A4.1491 4.1491 0 0116.012 6.3136a4.0047 4.0047 0 013.7414-4.306A4.5006 4.5006 0 0127.8267 3.26a3.5051 3.5051 0 012.1422 3.7094A3.6283 3.6283 0 0126.3172 10H25v4h3zM18 18H22V20H18zM14 18L14 16 12 16 12 20 16 20 16 18 14 18zM12 10H14V14H12z"
    })), _path306$d || (_path306$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.885 30L11.819 26.142 4 27.989 4 4 14 4 14 8 12 8 12 6 6 6 6 25.461 12.181 24.001 18.115 27.776 22.818 26 26 26 26 20 24 20 24 18 28 18 28 28 23.182 28 17.885 30z"
    })), children);
  });
  var MarineWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function MarineWarning32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$d || (_path307$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,20H7a1,1,0,0,0-.97,1.2422L6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H14V3a1,1,0,0,0-1.7993-.6011L2.2075,15.3906A1,1,0,0,0,3,17h9ZM5.0308,15,12,5.94V15Z"
    })), _path308$d || (_path308$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), _path309$d || (_path309$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path310$d || (_path310$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var MarineWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function MarineWarning24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$d || (_path311$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,20H7a1,1,0,0,0-.97,1.2422L6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H14V3a1,1,0,0,0-1.7993-.6011L2.2075,15.3906A1,1,0,0,0,3,17h9ZM5.0308,15,12,5.94V15Z"
    })), _path312$d || (_path312$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), _path313$d || (_path313$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path314$d || (_path314$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var MarineWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function MarineWarning20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$d || (_path315$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,20H7a1,1,0,0,0-.97,1.2422L6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H14V3a1,1,0,0,0-1.7993-.6011L2.2075,15.3906A1,1,0,0,0,3,17h9ZM5.0308,15,12,5.94V15Z"
    })), _path316$d || (_path316$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), _path317$d || (_path317$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path318$d || (_path318$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var MarineWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function MarineWarning16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$d || (_path319$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,20H7a1,1,0,0,0-.97,1.2422L6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H14V3a1,1,0,0,0-1.7993-.6011L2.2075,15.3906A1,1,0,0,0,3,17h9ZM5.0308,15,12,5.94V15Z"
    })), _path320$d || (_path320$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), _path321$d || (_path321$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path322$d || (_path322$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var MathCurve32 = /*#__PURE__*/React__default['default'].forwardRef(function MathCurve32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$d || (_path323$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.3555,23.0581C12.77,24.5918,15.6208,26,17.9514,26a3.8729,3.8729,0,0,0,2.856-1.084c2.2859-2.29.14-6.3979-1.938-10.3721L24.67,8.7427c1.07.686,2.1038,1.4253,3.0117,2.124L29,9.3486c-.7783-.6064-1.772-1.3383-2.8721-2.0634L30,3.4131,28.5859,2,24.3794,6.2061c-3.3164-1.91-7.1079-3.2461-9.2288-1.1216-2.0388,2.0425-.5512,5.5317,1.2683,9.082l-6.3071,6.3066c-1.0322-.7133-1.9985-1.4448-2.8-2.101L6,19.8848c.6145.5058,1.5513,1.2451,2.6653,2.0351L4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4133ZM16.5647,6.501c1.1357-1.1377,3.6931-.2862,6.3372,1.1831l-4.9947,4.9941C16.5942,10.0591,15.5562,7.5112,16.5647,6.501Zm.8215,9.5259c1.58,3.0317,3.1822,6.2959,2.0071,7.4726-1.3125,1.3145-4.5227-.0254-7.572-1.9077Z"
    })), children);
  });
  var MathCurve24 = /*#__PURE__*/React__default['default'].forwardRef(function MathCurve24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$d || (_path324$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.3555,23.0581C12.77,24.5918,15.6208,26,17.9514,26a3.8729,3.8729,0,0,0,2.856-1.084c2.2859-2.29.14-6.3979-1.938-10.3721L24.67,8.7427c1.07.686,2.1038,1.4253,3.0117,2.124L29,9.3486c-.7783-.6064-1.772-1.3383-2.8721-2.0634L30,3.4131,28.5859,2,24.3794,6.2061c-3.3164-1.91-7.1079-3.2461-9.2288-1.1216-2.0388,2.0425-.5512,5.5317,1.2683,9.082l-6.3071,6.3066c-1.0322-.7133-1.9985-1.4448-2.8-2.101L6,19.8848c.6145.5058,1.5513,1.2451,2.6653,2.0351L4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4133ZM16.5647,6.501c1.1357-1.1377,3.6931-.2862,6.3372,1.1831l-4.9947,4.9941C16.5942,10.0591,15.5562,7.5112,16.5647,6.501Zm.8215,9.5259c1.58,3.0317,3.1822,6.2959,2.0071,7.4726-1.3125,1.3145-4.5227-.0254-7.572-1.9077Z"
    })), children);
  });
  var MathCurve20 = /*#__PURE__*/React__default['default'].forwardRef(function MathCurve20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$d || (_path325$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.3555,23.0581C12.77,24.5918,15.6208,26,17.9514,26a3.8729,3.8729,0,0,0,2.856-1.084c2.2859-2.29.14-6.3979-1.938-10.3721L24.67,8.7427c1.07.686,2.1038,1.4253,3.0117,2.124L29,9.3486c-.7783-.6064-1.772-1.3383-2.8721-2.0634L30,3.4131,28.5859,2,24.3794,6.2061c-3.3164-1.91-7.1079-3.2461-9.2288-1.1216-2.0388,2.0425-.5512,5.5317,1.2683,9.082l-6.3071,6.3066c-1.0322-.7133-1.9985-1.4448-2.8-2.101L6,19.8848c.6145.5058,1.5513,1.2451,2.6653,2.0351L4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4133ZM16.5647,6.501c1.1357-1.1377,3.6931-.2862,6.3372,1.1831l-4.9947,4.9941C16.5942,10.0591,15.5562,7.5112,16.5647,6.501Zm.8215,9.5259c1.58,3.0317,3.1822,6.2959,2.0071,7.4726-1.3125,1.3145-4.5227-.0254-7.572-1.9077Z"
    })), children);
  });
  var MathCurve16 = /*#__PURE__*/React__default['default'].forwardRef(function MathCurve16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$d || (_path326$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.3555,23.0581C12.77,24.5918,15.6208,26,17.9514,26a3.8729,3.8729,0,0,0,2.856-1.084c2.2859-2.29.14-6.3979-1.938-10.3721L24.67,8.7427c1.07.686,2.1038,1.4253,3.0117,2.124L29,9.3486c-.7783-.6064-1.772-1.3383-2.8721-2.0634L30,3.4131,28.5859,2,24.3794,6.2061c-3.3164-1.91-7.1079-3.2461-9.2288-1.1216-2.0388,2.0425-.5512,5.5317,1.2683,9.082l-6.3071,6.3066c-1.0322-.7133-1.9985-1.4448-2.8-2.101L6,19.8848c.6145.5058,1.5513,1.2451,2.6653,2.0351L4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4133ZM16.5647,6.501c1.1357-1.1377,3.6931-.2862,6.3372,1.1831l-4.9947,4.9941C16.5942,10.0591,15.5562,7.5112,16.5647,6.501Zm.8215,9.5259c1.58,3.0317,3.1822,6.2959,2.0071,7.4726-1.3125,1.3145-4.5227-.0254-7.572-1.9077Z"
    })), children);
  });
  var QMatrix32 = /*#__PURE__*/React__default['default'].forwardRef(function QMatrix32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$d || (_path327$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var QMatrix24 = /*#__PURE__*/React__default['default'].forwardRef(function QMatrix24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$d || (_path328$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var QMatrix20 = /*#__PURE__*/React__default['default'].forwardRef(function QMatrix20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$d || (_path329$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var QMatrix16 = /*#__PURE__*/React__default['default'].forwardRef(function QMatrix16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$d || (_path330$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var Maximize32 = /*#__PURE__*/React__default['default'].forwardRef(function Maximize32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$d || (_path331$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 2L20 4 26.586 4 18 12.582 19.414 14 28 5.414 28 12 30 12 30 2 20 2zM14 19.416L12.592 18 4 26.586 4 20 2 20 2 30 12 30 12 28 5.414 28 14 19.416z"
    })), children);
  });
  var Maximize24 = /*#__PURE__*/React__default['default'].forwardRef(function Maximize24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$d || (_path332$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 2L20 4 26.586 4 18 12.582 19.414 14 28 5.414 28 12 30 12 30 2 20 2zM14 19.416L12.592 18 4 26.586 4 20 2 20 2 30 12 30 12 28 5.414 28 14 19.416z"
    })), children);
  });
  var Maximize20 = /*#__PURE__*/React__default['default'].forwardRef(function Maximize20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$d || (_path333$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 2L20 4 26.586 4 18 12.582 19.414 14 28 5.414 28 12 30 12 30 2 20 2zM14 19.416L12.592 18 4 26.586 4 20 2 20 2 30 12 30 12 28 5.414 28 14 19.416z"
    })), children);
  });
  var Maximize16 = /*#__PURE__*/React__default['default'].forwardRef(function Maximize16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$d || (_path334$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 15L6 14 2.7 14 7 9.7 6.3 9 2 13.3 2 10 1 10 1 15zM10 1L10 2 13.3 2 9 6.3 9.7 7 14 2.7 14 6 15 6 15 1z"
    })), children);
  });
  var MediaLibrary32 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibrary32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$d || (_path335$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15L13 23 13 23 20 19 13 15z"
    })), _path336$d || (_path336$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM6 12V26H26V12zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibrary24 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibrary24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$d || (_path337$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15L13 23 13 23 20 19 13 15z"
    })), _path338$c || (_path338$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM6 12V26H26V12zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibrary20 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibrary20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$c || (_path339$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15L13 23 13 23 20 19 13 15z"
    })), _path340$c || (_path340$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM6 12V26H26V12zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibrary16 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibrary16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$c || (_path341$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15L13 23 13 23 20 19 13 15z"
    })), _path342$c || (_path342$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H6a2.0021 2.0021 0 01-2-2V12a2.0021 2.0021 0 012-2H26a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM6 12V26H26V12zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibraryFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibraryFilled32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$c || (_path343$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M13 15L13 23 13 23 20 19 13 15z",
      "data-icon-path": "inner-path"
    })), _path344$c || (_path344$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H6a2.0023 2.0023 0 00-2 2V26a2.0023 2.0023 0 002 2H26a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0026 10zM13 23h0V15l7 4zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibraryFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibraryFilled24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$c || (_path345$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M13 15L13 23 13 23 20 19 13 15z",
      "data-icon-path": "inner-path"
    })), _path346$c || (_path346$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H6a2.0023 2.0023 0 00-2 2V26a2.0023 2.0023 0 002 2H26a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0026 10zM13 23h0V15l7 4zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibraryFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibraryFilled20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$c || (_path347$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M13 15L13 23 13 23 20 19 13 15z",
      "data-icon-path": "inner-path"
    })), _path348$c || (_path348$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H6a2.0023 2.0023 0 00-2 2V26a2.0023 2.0023 0 002 2H26a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0026 10zM13 23h0V15l7 4zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaLibraryFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function MediaLibraryFilled16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$c || (_path349$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M13 15L13 23 13 23 20 19 13 15z",
      "data-icon-path": "inner-path"
    })), _path350$c || (_path350$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 10H6a2.0023 2.0023 0 00-2 2V26a2.0023 2.0023 0 002 2H26a2.0023 2.0023 0 002-2V12A2.0023 2.0023 0 0026 10zM13 23h0V15l7 4zM6 6H26V8H6zM8 2H24V4H8z"
    })), children);
  });
  var MediaCast32 = /*#__PURE__*/React__default['default'].forwardRef(function MediaCast32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$c || (_path351$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H5a3 3 0 00-3-3zM9 26H7a5.0057 5.0057 0 00-5-5V19A7.0078 7.0078 0 019 26z"
    })), _path352$c || (_path352$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a9.01,9.01,0,0,0-9-9V15A11.0125,11.0125,0,0,1,13,26Z"
    })), _path353$c || (_path353$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H15V24H28V8H4v5H2V8A2.0021,2.0021,0,0,1,4,6H28a2.0021,2.0021,0,0,1,2,2V24A2.0021,2.0021,0,0,1,28,26Z"
    })), children);
  });
  var MediaCast24 = /*#__PURE__*/React__default['default'].forwardRef(function MediaCast24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$c || (_path354$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H5a3 3 0 00-3-3zM9 26H7a5.0057 5.0057 0 00-5-5V19A7.0078 7.0078 0 019 26z"
    })), _path355$b || (_path355$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a9.01,9.01,0,0,0-9-9V15A11.0125,11.0125,0,0,1,13,26Z"
    })), _path356$b || (_path356$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H15V24H28V8H4v5H2V8A2.0021,2.0021,0,0,1,4,6H28a2.0021,2.0021,0,0,1,2,2V24A2.0021,2.0021,0,0,1,28,26Z"
    })), children);
  });
  var MediaCast20 = /*#__PURE__*/React__default['default'].forwardRef(function MediaCast20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$b || (_path357$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H5a3 3 0 00-3-3zM9 26H7a5.0057 5.0057 0 00-5-5V19A7.0078 7.0078 0 019 26z"
    })), _path358$b || (_path358$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a9.01,9.01,0,0,0-9-9V15A11.0125,11.0125,0,0,1,13,26Z"
    })), _path359$b || (_path359$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H15V24H28V8H4v5H2V8A2.0021,2.0021,0,0,1,4,6H28a2.0021,2.0021,0,0,1,2,2V24A2.0021,2.0021,0,0,1,28,26Z"
    })), children);
  });
  var MediaCast16 = /*#__PURE__*/React__default['default'].forwardRef(function MediaCast16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$b || (_path360$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H5a3 3 0 00-3-3zM9 26H7a5.0057 5.0057 0 00-5-5V19A7.0078 7.0078 0 019 26z"
    })), _path361$a || (_path361$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a9.01,9.01,0,0,0-9-9V15A11.0125,11.0125,0,0,1,13,26Z"
    })), _path362$a || (_path362$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H15V24H28V8H4v5H2V8A2.0021,2.0021,0,0,1,4,6H28a2.0021,2.0021,0,0,1,2,2V24A2.0021,2.0021,0,0,1,28,26Z"
    })), children);
  });
  var Medication32 = /*#__PURE__*/React__default['default'].forwardRef(function Medication32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$a || (_path363$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"
    })), children);
  });
  var Medication24 = /*#__PURE__*/React__default['default'].forwardRef(function Medication24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$a || (_path364$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"
    })), children);
  });
  var Medication20 = /*#__PURE__*/React__default['default'].forwardRef(function Medication20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$a || (_path365$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"
    })), children);
  });
  var Medication16 = /*#__PURE__*/React__default['default'].forwardRef(function Medication16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$a || (_path366$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"
    })), children);
  });
  var MedicationAlert32 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationAlert32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$a || (_path367$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19H24V24H22z"
    })), _path368$a || (_path368$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"
    })), _circle15$a || (_circle15$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "26",
      r: "1"
    })), _path369$a || (_path369$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"
    })), children);
  });
  var MedicationAlert24 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationAlert24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$a || (_path370$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19H24V24H22z"
    })), _path371$a || (_path371$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"
    })), _circle16$a || (_circle16$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "26",
      r: "1"
    })), _path372$a || (_path372$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"
    })), children);
  });
  var MedicationAlert20 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationAlert20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$a || (_path373$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19H24V24H22z"
    })), _path374$a || (_path374$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"
    })), _circle17$9 || (_circle17$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "26",
      r: "1"
    })), _path375$a || (_path375$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"
    })), children);
  });
  var MedicationAlert16 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationAlert16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$a || (_path376$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19H24V24H22z"
    })), _path377$a || (_path377$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"
    })), _circle18$9 || (_circle18$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "26",
      r: "1"
    })), _path378$a || (_path378$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"
    })), children);
  });
  var MedicationReminder32 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationReminder32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$a || (_path379$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"
    })), _circle19$9 || (_circle19$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), children);
  });
  var MedicationReminder24 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationReminder24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$a || (_path380$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"
    })), _circle20$9 || (_circle20$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), children);
  });
  var MedicationReminder20 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationReminder20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$a || (_path381$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"
    })), _circle21$9 || (_circle21$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), children);
  });
  var MedicationReminder16 = /*#__PURE__*/React__default['default'].forwardRef(function MedicationReminder16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$a || (_path382$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"
    })), _circle22$9 || (_circle22$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), children);
  });
  var Menu32 = /*#__PURE__*/React__default['default'].forwardRef(function Menu32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$a || (_path383$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H28V8H4zM4 24H28V26H4zM4 12H28V14H4zM4 18H28V20H4z"
    })), children);
  });
  var Menu24 = /*#__PURE__*/React__default['default'].forwardRef(function Menu24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$9 || (_path384$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 18H21V19.5H3zM3 13.5H21V15H3zM3 9H21V10.5H3zM3 4.5H21V6H3z"
    })), children);
  });
  var Menu20 = /*#__PURE__*/React__default['default'].forwardRef(function Menu20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$9 || (_path385$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 14.8H18V16H2zM2 11.2H18V12.399999999999999H2zM2 7.6H18V8.799999999999999H2zM2 4H18V5.2H2z"
    })), children);
  });
  var Menu16 = /*#__PURE__*/React__default['default'].forwardRef(function Menu16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$9 || (_path386$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 12H14V13H2zM2 9H14V10H2zM2 6H14V7H2zM2 3H14V4H2z"
    })), children);
  });
  var MessageQueue32 = /*#__PURE__*/React__default['default'].forwardRef(function MessageQueue32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$9 || (_path387$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V21H4v5H28V21h2v5A2.0021,2.0021,0,0,1,28,28Z"
    })), _path388$9 || (_path388$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 21H25V23H7zM7 16H25V18H7zM7 11H25V13H7zM7 6H25V8H7z"
    })), children);
  });
  var MessageQueue24 = /*#__PURE__*/React__default['default'].forwardRef(function MessageQueue24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$9 || (_path389$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V21H4v5H28V21h2v5A2.0021,2.0021,0,0,1,28,28Z"
    })), _path390$9 || (_path390$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 21H25V23H7zM7 16H25V18H7zM7 11H25V13H7zM7 6H25V8H7z"
    })), children);
  });
  var MessageQueue20 = /*#__PURE__*/React__default['default'].forwardRef(function MessageQueue20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$9 || (_path391$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V21H4v5H28V21h2v5A2.0021,2.0021,0,0,1,28,28Z"
    })), _path392$9 || (_path392$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 21H25V23H7zM7 16H25V18H7zM7 11H25V13H7zM7 6H25V8H7z"
    })), children);
  });
  var MessageQueue16 = /*#__PURE__*/React__default['default'].forwardRef(function MessageQueue16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$9 || (_path393$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V21H4v5H28V21h2v5A2.0021,2.0021,0,0,1,28,28Z"
    })), _path394$9 || (_path394$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 21H25V23H7zM7 16H25V18H7zM7 11H25V13H7zM7 6H25V8H7z"
    })), children);
  });
  var Meter32 = /*#__PURE__*/React__default['default'].forwardRef(function Meter32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$9 || (_path395$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16a9.9283 9.9283 0 00-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0124 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0016 13a3 3 0 103 3 2.9659 2.9659 0 00-.3006-1.2853zM16 17a1 1 0 111-1A1.0013 1.0013 0 0116 17zM16 8a7.9515 7.9515 0 013.1223.6353l1.4961-1.4961A9.9864 9.9864 0 006 16H8A8.0092 8.0092 0 0116 8z"
    })), _path396$9 || (_path396$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Meter24 = /*#__PURE__*/React__default['default'].forwardRef(function Meter24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$9 || (_path397$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16a9.9283 9.9283 0 00-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0124 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0016 13a3 3 0 103 3 2.9659 2.9659 0 00-.3006-1.2853zM16 17a1 1 0 111-1A1.0013 1.0013 0 0116 17zM16 8a7.9515 7.9515 0 013.1223.6353l1.4961-1.4961A9.9864 9.9864 0 006 16H8A8.0092 8.0092 0 0116 8z"
    })), _path398$9 || (_path398$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Meter20 = /*#__PURE__*/React__default['default'].forwardRef(function Meter20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$8 || (_path399$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16a9.9283 9.9283 0 00-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0124 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0016 13a3 3 0 103 3 2.9659 2.9659 0 00-.3006-1.2853zM16 17a1 1 0 111-1A1.0013 1.0013 0 0116 17zM16 8a7.9515 7.9515 0 013.1223.6353l1.4961-1.4961A9.9864 9.9864 0 006 16H8A8.0092 8.0092 0 0116 8z"
    })), _path400$8 || (_path400$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Meter16 = /*#__PURE__*/React__default['default'].forwardRef(function Meter16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$8 || (_path401$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16a9.9283 9.9283 0 00-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0124 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0016 13a3 3 0 103 3 2.9659 2.9659 0 00-.3006-1.2853zM16 17a1 1 0 111-1A1.0013 1.0013 0 0116 17zM16 8a7.9515 7.9515 0 013.1223.6353l1.4961-1.4961A9.9864 9.9864 0 006 16H8A8.0092 8.0092 0 0116 8z"
    })), _path402$8 || (_path402$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var MeterAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function MeterAlt32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$7 || (_path403$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 20a13.8535 13.8535 0 00-2.2291-7.5288l-1.4452 1.4453A11.8917 11.8917 0 0128 20zM28 9.414L26.5859 8 18.019 16.5669A3.9521 3.9521 0 0016 16a4 4 0 104 4 3.9533 3.9533 0 00-.5669-2.0191zM16 22a2 2 0 112-2A2.0023 2.0023 0 0116 22zM16 8a11.9086 11.9086 0 016.0833 1.6743l1.4536-1.4536A13.9773 13.9773 0 002 20H4A12.0137 12.0137 0 0116 8z"
    })), children);
  });
  var MeterAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function MeterAlt24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$7 || (_path404$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 20a13.8535 13.8535 0 00-2.2291-7.5288l-1.4452 1.4453A11.8917 11.8917 0 0128 20zM28 9.414L26.5859 8 18.019 16.5669A3.9521 3.9521 0 0016 16a4 4 0 104 4 3.9533 3.9533 0 00-.5669-2.0191zM16 22a2 2 0 112-2A2.0023 2.0023 0 0116 22zM16 8a11.9086 11.9086 0 016.0833 1.6743l1.4536-1.4536A13.9773 13.9773 0 002 20H4A12.0137 12.0137 0 0116 8z"
    })), children);
  });
  var MeterAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function MeterAlt20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$7 || (_path405$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 20a13.8535 13.8535 0 00-2.2291-7.5288l-1.4452 1.4453A11.8917 11.8917 0 0128 20zM28 9.414L26.5859 8 18.019 16.5669A3.9521 3.9521 0 0016 16a4 4 0 104 4 3.9533 3.9533 0 00-.5669-2.0191zM16 22a2 2 0 112-2A2.0023 2.0023 0 0116 22zM16 8a11.9086 11.9086 0 016.0833 1.6743l1.4536-1.4536A13.9773 13.9773 0 002 20H4A12.0137 12.0137 0 0116 8z"
    })), children);
  });
  var MeterAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function MeterAlt16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$7 || (_path406$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 20a13.8535 13.8535 0 00-2.2291-7.5288l-1.4452 1.4453A11.8917 11.8917 0 0128 20zM28 9.414L26.5859 8 18.019 16.5669A3.9521 3.9521 0 0016 16a4 4 0 104 4 3.9533 3.9533 0 00-.5669-2.0191zM16 22a2 2 0 112-2A2.0023 2.0023 0 0116 22zM16 8a11.9086 11.9086 0 016.0833 1.6743l1.4536-1.4536A13.9773 13.9773 0 002 20H4A12.0137 12.0137 0 0116 8z"
    })), children);
  });
  var Microphone32 = /*#__PURE__*/React__default['default'].forwardRef(function Microphone32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$7 || (_path407$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path408$7 || (_path408$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"
    })), children);
  });
  var Microphone24 = /*#__PURE__*/React__default['default'].forwardRef(function Microphone24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$7 || (_path409$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path410$7 || (_path410$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"
    })), children);
  });
  var Microphone20 = /*#__PURE__*/React__default['default'].forwardRef(function Microphone20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$7 || (_path411$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path412$7 || (_path412$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"
    })), children);
  });
  var Microphone16 = /*#__PURE__*/React__default['default'].forwardRef(function Microphone16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$7 || (_path413$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path414$7 || (_path414$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"
    })), children);
  });
  var MicrophoneFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneFilled32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$6 || (_path415$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path416$5 || (_path416$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"
    })), children);
  });
  var MicrophoneFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneFilled24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$5 || (_path417$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path418$5 || (_path418$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"
    })), children);
  });

  var _path$d, _path2$d, _path3$d, _path4$d, _path5$d, _path6$d, _path7$d, _path8$d, _path9$d, _path10$d, _path11$d, _path12$d, _path13$d, _path14$d, _path15$d, _path16$d, _path17$d, _path18$d, _path19$d, _path20$d, _path21$d, _path22$d, _path23$d, _path24$d, _path25$d, _path26$d, _path27$d, _path28$d, _path29$d, _path30$d, _path31$d, _path32$d, _path33$d, _path34$d, _path35$d, _path36$d, _path37$d, _path38$d, _path39$d, _path40$d, _path41$d, _path42$d, _path43$d, _path44$d, _path45$d, _path46$d, _path47$d, _path48$d, _path49$d, _path50$d, _path51$d, _path52$d, _path53$d, _path54$d, _path55$d, _path56$d, _path57$d, _path58$d, _path59$d, _path60$d, _circle$c, _circle2$c, _path61$d, _path62$d, _circle3$c, _circle4$b, _path63$d, _path64$d, _circle5$a, _circle6$a, _path65$d, _path66$d, _circle7$a, _circle8$a, _path67$d, _path68$d, _path69$d, _path70$d, _path71$d, _path72$d, _path73$d, _path74$d, _path75$d, _path76$d, _path77$d, _path78$d, _path79$d, _path80$d, _path81$d, _circle9$a, _path82$d, _path83$d, _circle10$a, _path84$d, _path85$d, _circle11$9, _path86$d, _path87$d, _circle12$9, _path88$d, _path89$d, _path90$d, _path91$d, _path92$d, _path93$d, _path94$d, _path95$d, _path96$d, _path97$d, _path98$d, _path99$d, _path100$d, _path101$d, _path102$d, _path103$d, _path104$d, _path105$d, _path106$d, _path107$d, _path108$d, _path109$d, _path110$d, _path111$d, _path112$d, _path113$d, _path114$d, _path115$d, _path116$d, _path117$d, _path118$d, _path119$d, _path120$d, _path121$d, _path122$d, _path123$d, _path124$d, _path125$d, _path126$d, _path127$d, _path128$d, _path129$d, _path130$d, _path131$d, _path132$d, _path133$d, _path134$d, _path135$d, _path136$d, _path137$d, _path138$d, _path139$d, _path140$d, _path141$d, _path142$d, _path143$d, _path144$d, _path145$d, _path146$d, _path147$d, _path148$d, _path149$d, _path150$d, _path151$d, _path152$d, _path153$d, _path154$d, _path155$d, _path156$d, _path157$d, _path158$d, _path159$d, _path160$d, _path161$d, _path162$d, _path163$d, _path164$d, _path165$d, _path166$d, _path167$d, _path168$d, _path169$d, _path170$d, _path171$d, _path172$d, _path173$d, _path174$d, _path175$d, _path176$d, _path177$c, _path178$c, _path179$c, _path180$c, _path181$c, _path182$c, _path183$c, _path184$c, _path185$c, _path186$c, _path187$c, _path188$c, _path189$c, _path190$c, _path191$c, _path192$c, _path193$c, _path194$c, _path195$c, _path196$c, _path197$c, _path198$c, _path199$c, _path200$c, _path201$c, _path202$c, _path203$c, _path204$c, _path205$c, _path206$c, _path207$c, _path208$c, _path209$c, _path210$c, _path211$c, _path212$c, _path213$c, _path214$c, _path215$c, _path216$c, _path217$c, _path218$c, _path219$c, _path220$c, _path221$c, _path222$c, _path223$c, _path224$c, _path225$c, _path226$c, _path227$c, _path228$c, _path229$c, _path230$c, _path231$c, _path232$c, _path233$c, _path234$c, _path235$c, _path236$c, _path237$c, _path238$c, _path239$c, _path240$c, _path241$c, _path242$c, _path243$c, _path244$c, _path245$c, _path246$c, _path247$c, _path248$c, _path249$c, _path250$c, _path251$c, _path252$c, _path253$c, _path254$c, _path255$c, _path256$c, _path257$c, _path258$c, _path259$c, _path260$c, _path261$c, _path262$c, _path263$c, _path264$c, _path265$c, _path266$c, _path267$c, _path268$c, _path269$c, _path270$c, _path271$c, _path272$c, _path273$c, _path274$c, _circle13$9, _path275$c, _path276$c, _circle14$9, _path277$c, _path278$c, _circle15$9, _path279$c, _path280$c, _circle16$9, _path281$c, _path282$c, _path283$c, _path284$c, _path285$c, _path286$c, _path287$c, _path288$c, _path289$c, _circle17$8, _circle18$8, _circle19$8, _circle20$8, _circle21$8, _circle22$8, _circle23$8, _circle24$8, _circle25$7, _path290$c, _circle26$7, _circle27$7, _circle28$7, _circle29$7, _circle30$7, _circle31$7, _circle32$7, _circle33$7, _circle34$6, _path291$c, _circle35$6, _circle36$6, _circle37$5, _circle38$5, _circle39$5, _circle40$5, _circle41$5, _circle42$5, _circle43$5, _path292$c, _circle44$5, _circle45$5, _circle46$5, _circle47$5, _circle48$5, _circle49$4, _circle50$4, _circle51$4, _circle52$4, _path293$c, _circle53$3, _circle54$3, _circle55$2, _circle56$2, _circle57$2, _circle58$2, _circle59$2, _circle60$2, _circle61$2, _circle62$2, _circle63$2, _circle64$2, _circle65$2, _circle66$2, _circle67$2, _circle68$2, _circle69$2, _path294$c, _circle70$2, _circle71$2, _circle72$2, _circle73$1, _circle74$1, _circle75$1, _circle76$1, _circle77$1, _circle78$1, _circle79$1, _circle80$1, _circle81$1, _circle82$1, _circle83$1, _circle84$1, _circle85, _circle86, _path295$c, _circle87, _circle88, _circle89, _circle90, _circle91, _circle92, _circle93, _circle94, _circle95, _circle96, _circle97, _circle98, _circle99, _circle100, _circle101, _circle102, _circle103, _path296$c, _circle104, _circle105, _circle106, _circle107, _circle108, _circle109, _circle110, _circle111, _circle112, _circle113, _circle114, _circle115, _circle116, _circle117, _circle118, _circle119, _circle120, _path297$c, _path298$c, _path299$c, _path300$c, _path301$c, _path302$c, _path303$c, _path304$c, _path305$c, _path306$c, _path307$c, _path308$c, _path309$c, _path310$c, _path311$c, _path312$c, _circle121, _path313$c, _circle122, _path314$c, _circle123, _path315$c, _circle124, _path316$c, _path317$c, _path318$c, _path319$c, _path320$c, _path321$c, _path322$c, _path323$c, _path324$c, _circle125, _path325$c, _circle126, _path326$c, _circle127, _path327$c, _circle128, _path328$c, _circle129, _path329$c, _circle130, _path330$c, _circle131, _path331$c, _circle132, _path332$c, _circle133, _path333$c, _circle134, _path334$c, _circle135, _path335$c, _circle136, _path336$c, _path337$c, _path338$b, _path339$b, _path340$b, _path341$b, _path342$b, _path343$b, _path344$b, _path345$b, _path346$b, _path347$b, _path348$b, _path349$b, _path350$b, _path351$b, _path352$b, _path353$b, _path354$b, _path355$a, _path356$a, _path357$a, _path358$a, _path359$a, _path360$a;

  var _excluded$d = ["children"],
      _excluded2$d = ["children"],
      _excluded3$d = ["children"],
      _excluded4$d = ["children"],
      _excluded5$d = ["children"],
      _excluded6$d = ["children"],
      _excluded7$d = ["children"],
      _excluded8$d = ["children"],
      _excluded9$d = ["children"],
      _excluded10$d = ["children"],
      _excluded11$d = ["children"],
      _excluded12$d = ["children"],
      _excluded13$d = ["children"],
      _excluded14$d = ["children"],
      _excluded15$d = ["children"],
      _excluded16$d = ["children"],
      _excluded17$d = ["children"],
      _excluded18$d = ["children"],
      _excluded19$d = ["children"],
      _excluded20$d = ["children"],
      _excluded21$d = ["children"],
      _excluded22$d = ["children"],
      _excluded23$d = ["children"],
      _excluded24$d = ["children"],
      _excluded25$d = ["children"],
      _excluded26$d = ["children"],
      _excluded27$d = ["children"],
      _excluded28$d = ["children"],
      _excluded29$d = ["children"],
      _excluded30$d = ["children"],
      _excluded31$d = ["children"],
      _excluded32$d = ["children"],
      _excluded33$d = ["children"],
      _excluded34$d = ["children"],
      _excluded35$d = ["children"],
      _excluded36$d = ["children"],
      _excluded37$d = ["children"],
      _excluded38$d = ["children"],
      _excluded39$d = ["children"],
      _excluded40$d = ["children"],
      _excluded41$d = ["children"],
      _excluded42$d = ["children"],
      _excluded43$d = ["children"],
      _excluded44$d = ["children"],
      _excluded45$d = ["children"],
      _excluded46$d = ["children"],
      _excluded47$d = ["children"],
      _excluded48$d = ["children"],
      _excluded49$d = ["children"],
      _excluded50$d = ["children"],
      _excluded51$d = ["children"],
      _excluded52$d = ["children"],
      _excluded53$d = ["children"],
      _excluded54$d = ["children"],
      _excluded55$d = ["children"],
      _excluded56$d = ["children"],
      _excluded57$d = ["children"],
      _excluded58$d = ["children"],
      _excluded59$d = ["children"],
      _excluded60$d = ["children"],
      _excluded61$d = ["children"],
      _excluded62$d = ["children"],
      _excluded63$d = ["children"],
      _excluded64$d = ["children"],
      _excluded65$d = ["children"],
      _excluded66$d = ["children"],
      _excluded67$d = ["children"],
      _excluded68$d = ["children"],
      _excluded69$d = ["children"],
      _excluded70$d = ["children"],
      _excluded71$d = ["children"],
      _excluded72$d = ["children"],
      _excluded73$d = ["children"],
      _excluded74$d = ["children"],
      _excluded75$d = ["children"],
      _excluded76$d = ["children"],
      _excluded77$d = ["children"],
      _excluded78$d = ["children"],
      _excluded79$d = ["children"],
      _excluded80$d = ["children"],
      _excluded81$d = ["children"],
      _excluded82$d = ["children"],
      _excluded83$d = ["children"],
      _excluded84$d = ["children"],
      _excluded85$d = ["children"],
      _excluded86$d = ["children"],
      _excluded87$d = ["children"],
      _excluded88$d = ["children"],
      _excluded89$d = ["children"],
      _excluded90$d = ["children"],
      _excluded91$d = ["children"],
      _excluded92$d = ["children"],
      _excluded93$d = ["children"],
      _excluded94$d = ["children"],
      _excluded95$d = ["children"],
      _excluded96$d = ["children"],
      _excluded97$d = ["children"],
      _excluded98$d = ["children"],
      _excluded99$d = ["children"],
      _excluded100$d = ["children"],
      _excluded101$d = ["children"],
      _excluded102$d = ["children"],
      _excluded103$d = ["children"],
      _excluded104$d = ["children"],
      _excluded105$d = ["children"],
      _excluded106$d = ["children"],
      _excluded107$d = ["children"],
      _excluded108$d = ["children"],
      _excluded109$d = ["children"],
      _excluded110$d = ["children"],
      _excluded111$d = ["children"],
      _excluded112$d = ["children"],
      _excluded113$d = ["children"],
      _excluded114$d = ["children"],
      _excluded115$d = ["children"],
      _excluded116$d = ["children"],
      _excluded117$d = ["children"],
      _excluded118$d = ["children"],
      _excluded119$c = ["children"],
      _excluded120$c = ["children"],
      _excluded121$c = ["children"],
      _excluded122$c = ["children"],
      _excluded123$c = ["children"],
      _excluded124$c = ["children"],
      _excluded125$c = ["children"],
      _excluded126$c = ["children"],
      _excluded127$c = ["children"],
      _excluded128$c = ["children"],
      _excluded129$c = ["children"],
      _excluded130$c = ["children"],
      _excluded131$c = ["children"],
      _excluded132$c = ["children"],
      _excluded133$c = ["children"],
      _excluded134$c = ["children"],
      _excluded135$c = ["children"],
      _excluded136$c = ["children"],
      _excluded137$c = ["children"],
      _excluded138$c = ["children"],
      _excluded139$c = ["children"],
      _excluded140$c = ["children"],
      _excluded141$c = ["children"],
      _excluded142$c = ["children"],
      _excluded143$c = ["children"],
      _excluded144$c = ["children"],
      _excluded145$c = ["children"],
      _excluded146$c = ["children"],
      _excluded147$c = ["children"],
      _excluded148$c = ["children"],
      _excluded149$c = ["children"],
      _excluded150$c = ["children"],
      _excluded151$c = ["children"],
      _excluded152$c = ["children"],
      _excluded153$c = ["children"],
      _excluded154$c = ["children"],
      _excluded155$c = ["children"],
      _excluded156$c = ["children"],
      _excluded157$c = ["children"],
      _excluded158$c = ["children"],
      _excluded159$c = ["children"],
      _excluded160$c = ["children"],
      _excluded161$c = ["children"],
      _excluded162$c = ["children"],
      _excluded163$c = ["children"],
      _excluded164$c = ["children"],
      _excluded165$c = ["children"],
      _excluded166$c = ["children"],
      _excluded167$c = ["children"],
      _excluded168$c = ["children"],
      _excluded169$c = ["children"],
      _excluded170$c = ["children"],
      _excluded171$c = ["children"],
      _excluded172$c = ["children"],
      _excluded173$c = ["children"],
      _excluded174$c = ["children"],
      _excluded175$c = ["children"],
      _excluded176$c = ["children"],
      _excluded177$c = ["children"],
      _excluded178$c = ["children"],
      _excluded179$c = ["children"],
      _excluded180$c = ["children"],
      _excluded181$c = ["children"],
      _excluded182$c = ["children"],
      _excluded183$c = ["children"],
      _excluded184$c = ["children"],
      _excluded185$c = ["children"],
      _excluded186$c = ["children"],
      _excluded187$c = ["children"],
      _excluded188$c = ["children"],
      _excluded189$c = ["children"],
      _excluded190$c = ["children"],
      _excluded191$c = ["children"],
      _excluded192$c = ["children"],
      _excluded193$c = ["children"],
      _excluded194$c = ["children"],
      _excluded195$c = ["children"],
      _excluded196$c = ["children"],
      _excluded197$c = ["children"],
      _excluded198$c = ["children"],
      _excluded199$c = ["children"],
      _excluded200$c = ["children"],
      _excluded201$c = ["children"],
      _excluded202$c = ["children"],
      _excluded203$c = ["children"],
      _excluded204$c = ["children"],
      _excluded205$c = ["children"],
      _excluded206$c = ["children"],
      _excluded207$c = ["children"],
      _excluded208$c = ["children"],
      _excluded209$c = ["children"],
      _excluded210$c = ["children"],
      _excluded211$c = ["children"],
      _excluded212$c = ["children"],
      _excluded213$c = ["children"],
      _excluded214$c = ["children"],
      _excluded215$c = ["children"],
      _excluded216$c = ["children"],
      _excluded217$c = ["children"],
      _excluded218$c = ["children"],
      _excluded219$c = ["children"],
      _excluded220$c = ["children"],
      _excluded221$c = ["children"],
      _excluded222$c = ["children"],
      _excluded223$c = ["children"],
      _excluded224$c = ["children"],
      _excluded225$c = ["children"],
      _excluded226$c = ["children"],
      _excluded227$c = ["children"],
      _excluded228$c = ["children"],
      _excluded229$c = ["children"],
      _excluded230$c = ["children"],
      _excluded231$c = ["children"],
      _excluded232$c = ["children"],
      _excluded233$c = ["children"],
      _excluded234$c = ["children"],
      _excluded235$c = ["children"],
      _excluded236$c = ["children"],
      _excluded237$c = ["children"],
      _excluded238$c = ["children"],
      _excluded239$c = ["children"],
      _excluded240$c = ["children"],
      _excluded241$c = ["children"],
      _excluded242$c = ["children"],
      _excluded243$c = ["children"],
      _excluded244$c = ["children"],
      _excluded245$c = ["children"],
      _excluded246$c = ["children"],
      _excluded247$c = ["children"],
      _excluded248$c = ["children"],
      _excluded249$c = ["children"],
      _excluded250$c = ["children"];
  var didWarnAboutDeprecation$2 = {};
  var MicrophoneFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneFilled20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$d || (_path$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path2$d || (_path2$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"
    })), children);
  });
  var MicrophoneFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneFilled16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$d || (_path3$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"
    })), _path4$d || (_path4$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"
    })), children);
  });
  var MicrophoneOff32 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOff32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$d || (_path5$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.18 18.57A7.41 7.41 0 019 17V14H7v3a8.84 8.84 0 00.58 3.18zM13 15V7a3 3 0 016 0V8.75l2-2A5 5 0 0011 7v8zM23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zm-4 0a3 3 0 01-4.9 2.31L19 14.42z"
    })), children);
  });
  var MicrophoneOff24 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOff24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$d || (_path6$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.18 18.57A7.41 7.41 0 019 17V14H7v3a8.84 8.84 0 00.58 3.18zM13 15V7a3 3 0 016 0V8.75l2-2A5 5 0 0011 7v8zM23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zm-4 0a3 3 0 01-4.9 2.31L19 14.42z"
    })), children);
  });
  var MicrophoneOff20 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOff20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$d || (_path7$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.18 18.57A7.41 7.41 0 019 17V14H7v3a8.84 8.84 0 00.58 3.18zM13 15V7a3 3 0 016 0V8.75l2-2A5 5 0 0011 7v8zM23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zm-4 0a3 3 0 01-4.9 2.31L19 14.42z"
    })), children);
  });
  var MicrophoneOff16 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOff16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$d || (_path8$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.18 18.57A7.41 7.41 0 019 17V14H7v3a8.84 8.84 0 00.58 3.18zM13 15V7a3 3 0 016 0V8.75l2-2A5 5 0 0011 7v8zM23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zm-4 0a3 3 0 01-4.9 2.31L19 14.42z"
    })), children);
  });
  var MicrophoneOffFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOffFilled32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$d || (_path9$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 00.25 2.09zM20.76 5.58A5 5 0 0011 7v8.34z"
    })), children);
  });
  var MicrophoneOffFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOffFilled24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$d || (_path10$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 00.25 2.09zM20.76 5.58A5 5 0 0011 7v8.34z"
    })), children);
  });
  var MicrophoneOffFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOffFilled20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$d || (_path11$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 00.25 2.09zM20.76 5.58A5 5 0 0011 7v8.34z"
    })), children);
  });
  var MicrophoneOffFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function MicrophoneOffFilled16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$d || (_path12$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17a7 7 0 01-11.73 5.14l1.42-1.41A5 5 0 0021 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0015 25.94V28H11v2H21V28H17V25.94A9 9 0 0025 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 00.25 2.09zM20.76 5.58A5 5 0 0011 7v8.34z"
    })), children);
  });
  var Microscope32 = /*#__PURE__*/React__default['default'].forwardRef(function Microscope32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$d || (_path13$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"
    })), children);
  });
  var Microscope24 = /*#__PURE__*/React__default['default'].forwardRef(function Microscope24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$d || (_path14$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"
    })), children);
  });
  var Microscope20 = /*#__PURE__*/React__default['default'].forwardRef(function Microscope20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$d || (_path15$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"
    })), children);
  });
  var Microscope16 = /*#__PURE__*/React__default['default'].forwardRef(function Microscope16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$d || (_path16$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"
    })), children);
  });
  var Migrate32 = /*#__PURE__*/React__default['default'].forwardRef(function Migrate32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$d || (_path17$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 002-2V4A2 2 0 0026 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V24A2 2 0 0026 22zM6 24H20v4H6zm20 4H22V24h4z"
    })), children);
  });
  var Migrate24 = /*#__PURE__*/React__default['default'].forwardRef(function Migrate24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$d || (_path18$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 002-2V4A2 2 0 0026 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V24A2 2 0 0026 22zM6 24H20v4H6zm20 4H22V24h4z"
    })), children);
  });
  var Migrate20 = /*#__PURE__*/React__default['default'].forwardRef(function Migrate20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$d || (_path19$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 002-2V4A2 2 0 0026 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V24A2 2 0 0026 22zM6 24H20v4H6zm20 4H22V24h4z"
    })), children);
  });
  var Migrate16 = /*#__PURE__*/React__default['default'].forwardRef(function Migrate16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$d || (_path20$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H6A2 2 0 004 4V8a2 2 0 002 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 002-2V4A2 2 0 0026 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V24A2 2 0 0026 22zM6 24H20v4H6zm20 4H22V24h4z"
    })), children);
  });
  var MigrateAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function MigrateAlt32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$d || (_path21$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"
    })), children);
  });
  var MigrateAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function MigrateAlt24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$d || (_path22$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"
    })), children);
  });
  var MigrateAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function MigrateAlt20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$d || (_path23$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"
    })), children);
  });
  var MigrateAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function MigrateAlt16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$d || (_path24$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"
    })), children);
  });
  var Milestone32 = /*#__PURE__*/React__default['default'].forwardRef(function Milestone32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$d || (_path25$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5857,6.5859A1.9865,1.9865,0,0,0,23.1714,6H16V2H14V6H6A2.0025,2.0025,0,0,0,4,8v6a2.0025,2.0025,0,0,0,2,2h8V30h2V16h7.1714a1.9865,1.9865,0,0,0,1.4143-.5859L29,11ZM23.1714,14H6V8H23.1716l3,3Z"
    })), children);
  });
  var Milestone24 = /*#__PURE__*/React__default['default'].forwardRef(function Milestone24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$d || (_path26$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5857,6.5859A1.9865,1.9865,0,0,0,23.1714,6H16V2H14V6H6A2.0025,2.0025,0,0,0,4,8v6a2.0025,2.0025,0,0,0,2,2h8V30h2V16h7.1714a1.9865,1.9865,0,0,0,1.4143-.5859L29,11ZM23.1714,14H6V8H23.1716l3,3Z"
    })), children);
  });
  var Milestone20 = /*#__PURE__*/React__default['default'].forwardRef(function Milestone20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$d || (_path27$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5857,6.5859A1.9865,1.9865,0,0,0,23.1714,6H16V2H14V6H6A2.0025,2.0025,0,0,0,4,8v6a2.0025,2.0025,0,0,0,2,2h8V30h2V16h7.1714a1.9865,1.9865,0,0,0,1.4143-.5859L29,11ZM23.1714,14H6V8H23.1716l3,3Z"
    })), children);
  });
  var Milestone16 = /*#__PURE__*/React__default['default'].forwardRef(function Milestone16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$d || (_path28$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5857,6.5859A1.9865,1.9865,0,0,0,23.1714,6H16V2H14V6H6A2.0025,2.0025,0,0,0,4,8v6a2.0025,2.0025,0,0,0,2,2h8V30h2V16h7.1714a1.9865,1.9865,0,0,0,1.4143-.5859L29,11ZM23.1714,14H6V8H23.1716l3,3Z"
    })), children);
  });
  var MilitaryCamp32 = /*#__PURE__*/React__default['default'].forwardRef(function MilitaryCamp32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$d || (_path29$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28v-10.48a2.0035,2.0035,0,0,0-.853-1.6387L17,9.48V8h6V2H15V9.48L5.8528,15.8823A2.0023,2.0023,0,0,0,5,17.5205V28H2v2H30V28ZM17,4h4V6H17ZM7,17.5205l9-6.3,9,6.3V28H17V20H15v8H7Z"
    })), children);
  });
  var MilitaryCamp24 = /*#__PURE__*/React__default['default'].forwardRef(function MilitaryCamp24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$d || (_path30$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28v-10.48a2.0035,2.0035,0,0,0-.853-1.6387L17,9.48V8h6V2H15V9.48L5.8528,15.8823A2.0023,2.0023,0,0,0,5,17.5205V28H2v2H30V28ZM17,4h4V6H17ZM7,17.5205l9-6.3,9,6.3V28H17V20H15v8H7Z"
    })), children);
  });
  var MilitaryCamp20 = /*#__PURE__*/React__default['default'].forwardRef(function MilitaryCamp20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$d || (_path31$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28v-10.48a2.0035,2.0035,0,0,0-.853-1.6387L17,9.48V8h6V2H15V9.48L5.8528,15.8823A2.0023,2.0023,0,0,0,5,17.5205V28H2v2H30V28ZM17,4h4V6H17ZM7,17.5205l9-6.3,9,6.3V28H17V20H15v8H7Z"
    })), children);
  });
  var MilitaryCamp16 = /*#__PURE__*/React__default['default'].forwardRef(function MilitaryCamp16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$d || (_path32$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,28v-10.48a2.0035,2.0035,0,0,0-.853-1.6387L17,9.48V8h6V2H15V9.48L5.8528,15.8823A2.0023,2.0023,0,0,0,5,17.5205V28H2v2H30V28ZM17,4h4V6H17ZM7,17.5205l9-6.3,9,6.3V28H17V20H15v8H7Z"
    })), children);
  });
  var Minimize32 = /*#__PURE__*/React__default['default'].forwardRef(function Minimize32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$d || (_path33$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L4 20 10.586 20 2 28.582 3.414 30 12 21.414 12 28 14 28 14 18 4 18zM30 3.416L28.592 2 20 10.586 20 4 18 4 18 14 28 14 28 12 21.414 12 30 3.416z"
    })), children);
  });
  var Minimize24 = /*#__PURE__*/React__default['default'].forwardRef(function Minimize24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$d || (_path34$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L4 20 10.586 20 2 28.582 3.414 30 12 21.414 12 28 14 28 14 18 4 18zM30 3.416L28.592 2 20 10.586 20 4 18 4 18 14 28 14 28 12 21.414 12 30 3.416z"
    })), children);
  });
  var Minimize20 = /*#__PURE__*/React__default['default'].forwardRef(function Minimize20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$d || (_path35$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L4 20 10.586 20 2 28.582 3.414 30 12 21.414 12 28 14 28 14 18 4 18zM30 3.416L28.592 2 20 10.586 20 4 18 4 18 14 28 14 28 12 21.414 12 30 3.416z"
    })), children);
  });
  var Minimize16 = /*#__PURE__*/React__default['default'].forwardRef(function Minimize16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$d || (_path36$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 9L2 10 5.3 10 1 14.3 1.7 15 6 10.7 6 14 7 14 7 9zM14 7L14 6 10.7 6 15 1.7 14.3 1 10 5.3 10 2 9 2 9 7z"
    })), children);
  });
  var Misuse32 = /*#__PURE__*/React__default['default'].forwardRef(function Misuse32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$d || (_path37$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"
    })), _path38$d || (_path38$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9l5.4,5.4L21.4,9l1.6,1.6L17.6,16\tl5.4,5.4L21.4,23z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var Misuse24 = /*#__PURE__*/React__default['default'].forwardRef(function Misuse24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$d || (_path39$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,1C6,1,1,6,1,12s5,11,11,11s11-4.9,11-11S18.1,1,12,1z M16.2,17.5L12,13.3l-4.2,4.2l-1.3-1.3l4.2-4.2L6.5,7.8l1.3-1.3\tl4.2,4.2l4.2-4.2l1.3,1.3L13.3,12l4.2,4.2L16.2,17.5z"
    })), _path40$d || (_path40$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16.2,17.5L12,13.3l-4.2,4.2l-1.3-1.3l4.2-4.2L6.5,7.8l1.3-1.3l4.2,4.2l4.2-4.2l1.3,1.3\tL13.3,12l4.2,4.2L16.2,17.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var Misuse20 = /*#__PURE__*/React__default['default'].forwardRef(function Misuse20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$d || (_path41$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,1c-4.9,0-9,4.1-9,9s4.1,9,9,9s9-4,9-9S15,1,10,1z M13.5,14.5L10,11l-3.5,3.5l-1-1L9,10L5.5,6.5l1-1L10,9l3.5-3.5l1,1\tL11,10l3.5,3.5L13.5,14.5z"
    })), _path42$d || (_path42$d = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M13.5,14.5L10,11l-3.5,3.5l-1-1L9,10L5.5,6.5l1-1L10,9l3.5-3.5l1,1L11,10l3.5,3.5L13.5,14.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var Misuse16 = /*#__PURE__*/React__default['default'].forwardRef(function Misuse16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$d || (_path43$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M10.7,11.5L8,8.8l-2.7,2.7l-0.8-0.8L7.2,8L4.5,5.3l0.8-0.8L8,7.2\tl2.7-2.7l0.8,0.8L8.8,8l2.7,2.7L10.7,11.5z"
    })), _path44$d || (_path44$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7,11.5L8,8.8l-2.7,2.7l-0.8-0.8L7.2,8L4.5,5.3l0.8-0.8L8,7.2l2.7-2.7l0.8,0.8L8.8,8\tl2.7,2.7L10.7,11.5z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var MisuseAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseAlt32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$2['MisuseAlt32']) {
        didWarnAboutDeprecation$2['MisuseAlt32'] = true;
        console.warn("The MisuseAlt32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$d || (_path45$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"
    })), _path46$d || (_path46$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var MisuseAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseAlt24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$2['MisuseAlt24']) {
        didWarnAboutDeprecation$2['MisuseAlt24'] = true;
        console.warn("The MisuseAlt24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$d || (_path47$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"
    })), _path48$d || (_path48$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var MisuseAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseAlt20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$2['MisuseAlt20']) {
        didWarnAboutDeprecation$2['MisuseAlt20'] = true;
        console.warn("The MisuseAlt20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$d || (_path49$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"
    })), _path50$d || (_path50$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var MisuseAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseAlt16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$d);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$2['MisuseAlt16']) {
        didWarnAboutDeprecation$2['MisuseAlt16'] = true;
        console.warn("The MisuseAlt16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$d || (_path51$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"
    })), _path52$d || (_path52$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var MisuseOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseOutline32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$d || (_path53$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path54$d || (_path54$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var MisuseOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseOutline24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$d || (_path55$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path56$d || (_path56$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var MisuseOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseOutline20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$d || (_path57$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"
    })), _path58$d || (_path58$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"
    })), children);
  });
  var MisuseOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function MisuseOutline16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$d || (_path59$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"
    })), _path60$d || (_path60$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7 11.5L8 8.8 5.3 11.5 4.5 10.7 7.2 8 4.5 5.3 5.3 4.5 8 7.2 10.7 4.5 11.5 5.3 8.8 8 11.5 10.7z"
    })), children);
  });
  var MixedRainHail32 = /*#__PURE__*/React__default['default'].forwardRef(function MixedRainHail32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$c || (_circle$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle2$c || (_circle2$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _path61$d || (_path61$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path62$d || (_path62$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0 6.4929 6.4929 0 00.23 12.7681L6.106 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.447-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20H23v2h.5A6.4974 6.4974 0 0024.8008 9.1362z"
    })), children);
  });
  var MixedRainHail24 = /*#__PURE__*/React__default['default'].forwardRef(function MixedRainHail24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$c || (_circle3$c = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle4$b || (_circle4$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _path63$d || (_path63$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path64$d || (_path64$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0 6.4929 6.4929 0 00.23 12.7681L6.106 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.447-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20H23v2h.5A6.4974 6.4974 0 0024.8008 9.1362z"
    })), children);
  });
  var MixedRainHail20 = /*#__PURE__*/React__default['default'].forwardRef(function MixedRainHail20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$a || (_circle5$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle6$a || (_circle6$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _path65$d || (_path65$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path66$d || (_path66$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0 6.4929 6.4929 0 00.23 12.7681L6.106 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.447-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20H23v2h.5A6.4974 6.4974 0 0024.8008 9.1362z"
    })), children);
  });
  var MixedRainHail16 = /*#__PURE__*/React__default['default'].forwardRef(function MixedRainHail16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$a || (_circle7$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "25.5",
      r: "1.5"
    })), _circle8$a || (_circle8$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "29.5",
      r: "1.5"
    })), _path67$d || (_path67$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.868 30.496L14.132 29.504 17.276 24 11.277 24 16.132 15.504 17.868 16.496 14.723 22 20.724 22 15.868 30.496z"
    })), _path68$d || (_path68$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0 6.4929 6.4929 0 00.23 12.7681L6.106 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.447-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20H23v2h.5A6.4974 6.4974 0 0024.8008 9.1362z"
    })), children);
  });
  var Mobile32 = /*#__PURE__*/React__default['default'].forwardRef(function Mobile32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$d || (_path69$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"
    })), children);
  });
  var Mobile24 = /*#__PURE__*/React__default['default'].forwardRef(function Mobile24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$d || (_path70$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"
    })), children);
  });
  var Mobile20 = /*#__PURE__*/React__default['default'].forwardRef(function Mobile20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$d || (_path71$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"
    })), children);
  });
  var Mobile16 = /*#__PURE__*/React__default['default'].forwardRef(function Mobile16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$d || (_path72$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"
    })), children);
  });
  var MobileAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAdd32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$d || (_path73$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"
    })), _path74$d || (_path74$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAdd24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$d || (_path75$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"
    })), _path76$d || (_path76$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAdd20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$d || (_path77$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"
    })), _path78$d || (_path78$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAdd16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$d || (_path79$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"
    })), _path80$d || (_path80$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileAudio32 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAudio32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$d || (_path81$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"
    })), _circle9$a || (_circle9$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path82$d || (_path82$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var MobileAudio24 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAudio24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$d || (_path83$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"
    })), _circle10$a || (_circle10$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path84$d || (_path84$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var MobileAudio20 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAudio20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$d || (_path85$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"
    })), _circle11$9 || (_circle11$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path86$d || (_path86$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var MobileAudio16 = /*#__PURE__*/React__default['default'].forwardRef(function MobileAudio16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$d || (_path87$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"
    })), _circle12$9 || (_circle12$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "24.5",
      r: "1.5"
    })), _path88$d || (_path88$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"
    })), children);
  });
  var MobileCheck32 = /*#__PURE__*/React__default['default'].forwardRef(function MobileCheck32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$d || (_path89$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"
    })), _path90$d || (_path90$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileCheck24 = /*#__PURE__*/React__default['default'].forwardRef(function MobileCheck24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$d || (_path91$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"
    })), _path92$d || (_path92$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileCheck20 = /*#__PURE__*/React__default['default'].forwardRef(function MobileCheck20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$d || (_path93$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"
    })), _path94$d || (_path94$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileCheck16 = /*#__PURE__*/React__default['default'].forwardRef(function MobileCheck16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$d || (_path95$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"
    })), _path96$d || (_path96$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileDownload32 = /*#__PURE__*/React__default['default'].forwardRef(function MobileDownload32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$d || (_path97$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"
    })), _path98$d || (_path98$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileDownload24 = /*#__PURE__*/React__default['default'].forwardRef(function MobileDownload24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$d || (_path99$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"
    })), _path100$d || (_path100$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileDownload20 = /*#__PURE__*/React__default['default'].forwardRef(function MobileDownload20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$d || (_path101$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"
    })), _path102$d || (_path102$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileDownload16 = /*#__PURE__*/React__default['default'].forwardRef(function MobileDownload16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$d || (_path103$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"
    })), _path104$d || (_path104$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"
    })), children);
  });
  var MobileLandscape32 = /*#__PURE__*/React__default['default'].forwardRef(function MobileLandscape32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$d || (_path105$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"
    })), children);
  });
  var MobileLandscape24 = /*#__PURE__*/React__default['default'].forwardRef(function MobileLandscape24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$d || (_path106$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"
    })), children);
  });
  var MobileLandscape20 = /*#__PURE__*/React__default['default'].forwardRef(function MobileLandscape20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$d || (_path107$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"
    })), children);
  });
  var MobileLandscape16 = /*#__PURE__*/React__default['default'].forwardRef(function MobileLandscape16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$d || (_path108$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"
    })), children);
  });
  var MobilityServices32 = /*#__PURE__*/React__default['default'].forwardRef(function MobilityServices32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$d || (_path109$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781zM28 2H24a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2V6H24V4zm-4 8V8h4v4z"
    })), children);
  });
  var MobilityServices24 = /*#__PURE__*/React__default['default'].forwardRef(function MobilityServices24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$d || (_path110$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781zM28 2H24a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2V6H24V4zm-4 8V8h4v4z"
    })), children);
  });
  var MobilityServices20 = /*#__PURE__*/React__default['default'].forwardRef(function MobilityServices20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$d || (_path111$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781zM28 2H24a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2V6H24V4zm-4 8V8h4v4z"
    })), children);
  });
  var MobilityServices16 = /*#__PURE__*/React__default['default'].forwardRef(function MobilityServices16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$d || (_path112$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781zM28 2H24a2.0023 2.0023 0 00-2 2v8a2.0023 2.0023 0 002 2h4a2.0023 2.0023 0 002-2V4A2.0023 2.0023 0 0028 2zm0 2V6H24V4zm-4 8V8h4v4z"
    })), children);
  });
  var Model32 = /*#__PURE__*/React__default['default'].forwardRef(function Model32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$d || (_path113$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"
    })), children);
  });
  var Model24 = /*#__PURE__*/React__default['default'].forwardRef(function Model24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$d || (_path114$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"
    })), children);
  });
  var Model20 = /*#__PURE__*/React__default['default'].forwardRef(function Model20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$d || (_path115$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"
    })), children);
  });
  var Model16 = /*#__PURE__*/React__default['default'].forwardRef(function Model16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$d || (_path116$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"
    })), children);
  });
  var ModelAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ModelAlt32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$d || (_path117$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4473,16.1055,23,13.3818V7a1,1,0,0,0-.5527-.8945l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,9,7v6.3818L3.5527,16.1055A1,1,0,0,0,3,17v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0L16,25.1182l5.5527,2.7763a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,29,24V17A1,1,0,0,0,28.4473,16.1055ZM21,13.3818l-4,2V10.6182l4-2ZM16,5.1182,19.7637,7,16,8.8818,12.2363,7Zm-5,3.5,4,2v4.7636l-4-2ZM9,25.3818l-4-2V18.6182l4,2Zm1-6.5L6.2363,17,10,15.1182,13.7637,17Zm1,1.7364,4-2v4.7636l-4,2Zm10,4.7636-4-2V18.6182l4,2Zm1-6.5L18.2363,17,22,15.1182,25.7637,17Zm5,4.5-4,2V20.6182l4-2Z"
    })), children);
  });
  var ModelAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ModelAlt24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$d || (_path118$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4473,16.1055,23,13.3818V7a1,1,0,0,0-.5527-.8945l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,9,7v6.3818L3.5527,16.1055A1,1,0,0,0,3,17v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0L16,25.1182l5.5527,2.7763a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,29,24V17A1,1,0,0,0,28.4473,16.1055ZM21,13.3818l-4,2V10.6182l4-2ZM16,5.1182,19.7637,7,16,8.8818,12.2363,7Zm-5,3.5,4,2v4.7636l-4-2ZM9,25.3818l-4-2V18.6182l4,2Zm1-6.5L6.2363,17,10,15.1182,13.7637,17Zm1,1.7364,4-2v4.7636l-4,2Zm10,4.7636-4-2V18.6182l4,2Zm1-6.5L18.2363,17,22,15.1182,25.7637,17Zm5,4.5-4,2V20.6182l4-2Z"
    })), children);
  });
  var ModelAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ModelAlt20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$d || (_path119$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4473,16.1055,23,13.3818V7a1,1,0,0,0-.5527-.8945l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,9,7v6.3818L3.5527,16.1055A1,1,0,0,0,3,17v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0L16,25.1182l5.5527,2.7763a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,29,24V17A1,1,0,0,0,28.4473,16.1055ZM21,13.3818l-4,2V10.6182l4-2ZM16,5.1182,19.7637,7,16,8.8818,12.2363,7Zm-5,3.5,4,2v4.7636l-4-2ZM9,25.3818l-4-2V18.6182l4,2Zm1-6.5L6.2363,17,10,15.1182,13.7637,17Zm1,1.7364,4-2v4.7636l-4,2Zm10,4.7636-4-2V18.6182l4,2Zm1-6.5L18.2363,17,22,15.1182,25.7637,17Zm5,4.5-4,2V20.6182l4-2Z"
    })), children);
  });
  var ModelAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ModelAlt16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$d || (_path120$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.4473,16.1055,23,13.3818V7a1,1,0,0,0-.5527-.8945l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,9,7v6.3818L3.5527,16.1055A1,1,0,0,0,3,17v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0L16,25.1182l5.5527,2.7763a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,29,24V17A1,1,0,0,0,28.4473,16.1055ZM21,13.3818l-4,2V10.6182l4-2ZM16,5.1182,19.7637,7,16,8.8818,12.2363,7Zm-5,3.5,4,2v4.7636l-4-2ZM9,25.3818l-4-2V18.6182l4,2Zm1-6.5L6.2363,17,10,15.1182,13.7637,17Zm1,1.7364,4-2v4.7636l-4,2Zm10,4.7636-4-2V18.6182l4,2Zm1-6.5L18.2363,17,22,15.1182,25.7637,17Zm5,4.5-4,2V20.6182l4-2Z"
    })), children);
  });
  var ModelReference32 = /*#__PURE__*/React__default['default'].forwardRef(function ModelReference32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$d || (_path121$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path122$d || (_path122$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,6.01,18l1.5114-1.31L5.19,14h5.2554L16,22.8867,21.5544,14H26.81L15.8125,26.6919,17.3242,28l12.96-14.9546ZM5,12,9.5,6h4.6958l-3.75,6ZM16,6.8867,19.1958,12H12.8042Zm0,12.2266L12.8044,14h6.3912ZM21.5542,12l-3.75-6H22.5L27,12Z"
    })), children);
  });
  var ModelReference24 = /*#__PURE__*/React__default['default'].forwardRef(function ModelReference24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$d || (_path123$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path124$d || (_path124$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,6.01,18l1.5114-1.31L5.19,14h5.2554L16,22.8867,21.5544,14H26.81L15.8125,26.6919,17.3242,28l12.96-14.9546ZM5,12,9.5,6h4.6958l-3.75,6ZM16,6.8867,19.1958,12H12.8042Zm0,12.2266L12.8044,14h6.3912ZM21.5542,12l-3.75-6H22.5L27,12Z"
    })), children);
  });
  var ModelReference20 = /*#__PURE__*/React__default['default'].forwardRef(function ModelReference20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$d || (_path125$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path126$d || (_path126$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,6.01,18l1.5114-1.31L5.19,14h5.2554L16,22.8867,21.5544,14H26.81L15.8125,26.6919,17.3242,28l12.96-14.9546ZM5,12,9.5,6h4.6958l-3.75,6ZM16,6.8867,19.1958,12H12.8042Zm0,12.2266L12.8044,14h6.3912ZM21.5542,12l-3.75-6H22.5L27,12Z"
    })), children);
  });
  var ModelReference16 = /*#__PURE__*/React__default['default'].forwardRef(function ModelReference16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$d || (_path127$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path128$d || (_path128$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,4H8.5L1.7158,13.0454,6.01,18l1.5114-1.31L5.19,14h5.2554L16,22.8867,21.5544,14H26.81L15.8125,26.6919,17.3242,28l12.96-14.9546ZM5,12,9.5,6h4.6958l-3.75,6ZM16,6.8867,19.1958,12H12.8042Zm0,12.2266L12.8044,14h6.3912ZM21.5542,12l-3.75-6H22.5L27,12Z"
    })), children);
  });
  var ModelBuilder32 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilder32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$d || (_path129$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12v8A3.0037,3.0037,0,0,1,13,23H10V20H2v8h8V25H13A5.0062,5.0062,0,0,0,18,20V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8ZM8,26H4V22H8ZM28,10H24V6h4Z"
    })), children);
  });
  var ModelBuilder24 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilder24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$d || (_path130$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12v8A3.0037,3.0037,0,0,1,13,23H10V20H2v8h8V25H13A5.0062,5.0062,0,0,0,18,20V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8ZM8,26H4V22H8ZM28,10H24V6h4Z"
    })), children);
  });
  var ModelBuilder20 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilder20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$d || (_path131$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12v8A3.0037,3.0037,0,0,1,13,23H10V20H2v8h8V25H13A5.0062,5.0062,0,0,0,18,20V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8ZM8,26H4V22H8ZM28,10H24V6h4Z"
    })), children);
  });
  var ModelBuilder16 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilder16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$d || (_path132$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12v8A3.0037,3.0037,0,0,1,13,23H10V20H2v8h8V25H13A5.0062,5.0062,0,0,0,18,20V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8ZM8,26H4V22H8ZM28,10H24V6h4Z"
    })), children);
  });
  var ModelBuilderReference32 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilderReference32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$d || (_path133$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path134$d || (_path134$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12V28h2V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8Zm20,0H24V6h4Z"
    })), children);
  });
  var ModelBuilderReference24 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilderReference24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$d || (_path135$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path136$d || (_path136$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12V28h2V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8Zm20,0H24V6h4Z"
    })), children);
  });
  var ModelBuilderReference20 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilderReference20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$d || (_path137$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path138$d || (_path138$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12V28h2V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8Zm20,0H24V6h4Z"
    })), children);
  });
  var ModelBuilderReference16 = /*#__PURE__*/React__default['default'].forwardRef(function ModelBuilderReference16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$d || (_path139$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _path140$d || (_path140$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,4V7H10V4H2v8h8V9h7.0234A4.9463,4.9463,0,0,0,16,12V28h2V12a2.9982,2.9982,0,0,1,2.9971-3H22v3h8V4ZM8,10H4V6H8Zm20,0H24V6h4Z"
    })), children);
  });
  var Money32 = /*#__PURE__*/React__default['default'].forwardRef(function Money32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$d || (_path141$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 102 2 2 2 0 00-2-2zM16 16a4 4 0 114-4A4.0045 4.0045 0 0116 16zm0-6a2 2 0 102 2A2.002 2.002 0 0016 10zM8 10a2 2 0 102 2 2 2 0 00-2-2z"
    })), _path142$d || (_path142$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"
    })), children);
  });
  var Money24 = /*#__PURE__*/React__default['default'].forwardRef(function Money24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$d || (_path143$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 102 2 2 2 0 00-2-2zM16 16a4 4 0 114-4A4.0045 4.0045 0 0116 16zm0-6a2 2 0 102 2A2.002 2.002 0 0016 10zM8 10a2 2 0 102 2 2 2 0 00-2-2z"
    })), _path144$d || (_path144$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"
    })), children);
  });
  var Money20 = /*#__PURE__*/React__default['default'].forwardRef(function Money20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$d || (_path145$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 102 2 2 2 0 00-2-2zM16 16a4 4 0 114-4A4.0045 4.0045 0 0116 16zm0-6a2 2 0 102 2A2.002 2.002 0 0016 10zM8 10a2 2 0 102 2 2 2 0 00-2-2z"
    })), _path146$d || (_path146$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"
    })), children);
  });
  var Money16 = /*#__PURE__*/React__default['default'].forwardRef(function Money16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$d || (_path147$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 102 2 2 2 0 00-2-2zM16 16a4 4 0 114-4A4.0045 4.0045 0 0116 16zm0-6a2 2 0 102 2A2.002 2.002 0 0016 10zM8 10a2 2 0 102 2 2 2 0 00-2-2z"
    })), _path148$d || (_path148$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"
    })), children);
  });
  var Monster32 = /*#__PURE__*/React__default['default'].forwardRef(function Monster32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$d || (_path149$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 22L21 22 21 20 19 20 19 22 17 22 17 20 15 20 15 22 13 22 13 20 11 20 11 22 9 22 9 24 11 24 11 26 13 26 13 24 15 24 15 26 17 26 17 24 19 24 19 26 21 26 21 24 23 24 23 22z"
    })), _path150$d || (_path150$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11H27V4a2.0025,2.0025,0,0,0-2-2H7A2.0025,2.0025,0,0,0,5,4v7H4a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2H5v4a7.0078,7.0078,0,0,0,7,7h8a7.0078,7.0078,0,0,0,7-7V19h1a2.0025,2.0025,0,0,0,2-2V13A2.0025,2.0025,0,0,0,28,11ZM25,4V7.3818L22.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L18,7.8818,14.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L10,7.8818l-3-1.5V4Zm3,13H25v6a5.0057,5.0057,0,0,1-5,5H12a5.0057,5.0057,0,0,1-5-5V17H4V13H7V8.6182L9.5527,9.8945a1.0008,1.0008,0,0,0,.8946,0L14,8.1182l3.5527,1.7763a1.001,1.001,0,0,0,.8946,0L22,8.1182l3,1.5V13h3Z"
    })), _path151$d || (_path151$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 14H14V16H9zM18 14H23V16H18z"
    })), children);
  });
  var Monster24 = /*#__PURE__*/React__default['default'].forwardRef(function Monster24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$d || (_path152$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 22L21 22 21 20 19 20 19 22 17 22 17 20 15 20 15 22 13 22 13 20 11 20 11 22 9 22 9 24 11 24 11 26 13 26 13 24 15 24 15 26 17 26 17 24 19 24 19 26 21 26 21 24 23 24 23 22z"
    })), _path153$d || (_path153$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11H27V4a2.0025,2.0025,0,0,0-2-2H7A2.0025,2.0025,0,0,0,5,4v7H4a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2H5v4a7.0078,7.0078,0,0,0,7,7h8a7.0078,7.0078,0,0,0,7-7V19h1a2.0025,2.0025,0,0,0,2-2V13A2.0025,2.0025,0,0,0,28,11ZM25,4V7.3818L22.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L18,7.8818,14.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L10,7.8818l-3-1.5V4Zm3,13H25v6a5.0057,5.0057,0,0,1-5,5H12a5.0057,5.0057,0,0,1-5-5V17H4V13H7V8.6182L9.5527,9.8945a1.0008,1.0008,0,0,0,.8946,0L14,8.1182l3.5527,1.7763a1.001,1.001,0,0,0,.8946,0L22,8.1182l3,1.5V13h3Z"
    })), _path154$d || (_path154$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 14H14V16H9zM18 14H23V16H18z"
    })), children);
  });
  var Monster20 = /*#__PURE__*/React__default['default'].forwardRef(function Monster20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$d || (_path155$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 22L21 22 21 20 19 20 19 22 17 22 17 20 15 20 15 22 13 22 13 20 11 20 11 22 9 22 9 24 11 24 11 26 13 26 13 24 15 24 15 26 17 26 17 24 19 24 19 26 21 26 21 24 23 24 23 22z"
    })), _path156$d || (_path156$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11H27V4a2.0025,2.0025,0,0,0-2-2H7A2.0025,2.0025,0,0,0,5,4v7H4a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2H5v4a7.0078,7.0078,0,0,0,7,7h8a7.0078,7.0078,0,0,0,7-7V19h1a2.0025,2.0025,0,0,0,2-2V13A2.0025,2.0025,0,0,0,28,11ZM25,4V7.3818L22.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L18,7.8818,14.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L10,7.8818l-3-1.5V4Zm3,13H25v6a5.0057,5.0057,0,0,1-5,5H12a5.0057,5.0057,0,0,1-5-5V17H4V13H7V8.6182L9.5527,9.8945a1.0008,1.0008,0,0,0,.8946,0L14,8.1182l3.5527,1.7763a1.001,1.001,0,0,0,.8946,0L22,8.1182l3,1.5V13h3Z"
    })), _path157$d || (_path157$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 14H14V16H9zM18 14H23V16H18z"
    })), children);
  });
  var Monster16 = /*#__PURE__*/React__default['default'].forwardRef(function Monster16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$d || (_path158$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 22L21 22 21 20 19 20 19 22 17 22 17 20 15 20 15 22 13 22 13 20 11 20 11 22 9 22 9 24 11 24 11 26 13 26 13 24 15 24 15 26 17 26 17 24 19 24 19 26 21 26 21 24 23 24 23 22z"
    })), _path159$d || (_path159$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11H27V4a2.0025,2.0025,0,0,0-2-2H7A2.0025,2.0025,0,0,0,5,4v7H4a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2H5v4a7.0078,7.0078,0,0,0,7,7h8a7.0078,7.0078,0,0,0,7-7V19h1a2.0025,2.0025,0,0,0,2-2V13A2.0025,2.0025,0,0,0,28,11ZM25,4V7.3818L22.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L18,7.8818,14.4473,6.1055a1.0008,1.0008,0,0,0-.8946,0L10,7.8818l-3-1.5V4Zm3,13H25v6a5.0057,5.0057,0,0,1-5,5H12a5.0057,5.0057,0,0,1-5-5V17H4V13H7V8.6182L9.5527,9.8945a1.0008,1.0008,0,0,0,.8946,0L14,8.1182l3.5527,1.7763a1.001,1.001,0,0,0,.8946,0L22,8.1182l3,1.5V13h3Z"
    })), _path160$d || (_path160$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 14H14V16H9zM18 14H23V16H18z"
    })), children);
  });
  var Monument32 = /*#__PURE__*/React__default['default'].forwardRef(function Monument32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$d || (_path161$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28V6L16,2,12,6V28H2v2H30V28Zm-6,0V6.8281l2-2,2,2V28Z"
    })), children);
  });
  var Monument24 = /*#__PURE__*/React__default['default'].forwardRef(function Monument24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$d || (_path162$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28V6L16,2,12,6V28H2v2H30V28Zm-6,0V6.8281l2-2,2,2V28Z"
    })), children);
  });
  var Monument20 = /*#__PURE__*/React__default['default'].forwardRef(function Monument20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$d || (_path163$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28V6L16,2,12,6V28H2v2H30V28Zm-6,0V6.8281l2-2,2,2V28Z"
    })), children);
  });
  var Monument16 = /*#__PURE__*/React__default['default'].forwardRef(function Monument16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$d || (_path164$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28V6L16,2,12,6V28H2v2H30V28Zm-6,0V6.8281l2-2,2,2V28Z"
    })), children);
  });
  var Moon32 = /*#__PURE__*/React__default['default'].forwardRef(function Moon32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$d || (_path165$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Moon24 = /*#__PURE__*/React__default['default'].forwardRef(function Moon24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$d || (_path166$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Moon20 = /*#__PURE__*/React__default['default'].forwardRef(function Moon20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$d || (_path167$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Moon16 = /*#__PURE__*/React__default['default'].forwardRef(function Moon16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$d || (_path168$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5025,5.4136A15.0755,15.0755,0,0,0,25.096,23.6082a11.1134,11.1134,0,0,1-7.9749,3.3893c-.1385,0-.2782.0051-.4178,0A11.0944,11.0944,0,0,1,13.5025,5.4136M14.98,3a1.0024,1.0024,0,0,0-.1746.0156A13.0959,13.0959,0,0,0,16.63,28.9973c.1641.006.3282,0,.4909,0a13.0724,13.0724,0,0,0,10.702-5.5556,1.0094,1.0094,0,0,0-.7833-1.5644A13.08,13.08,0,0,1,15.8892,4.38,1.0149,1.0149,0,0,0,14.98,3Z"
    })), children);
  });
  var Moonrise32 = /*#__PURE__*/React__default['default'].forwardRef(function Moonrise32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$d || (_path169$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 2L11 7 12.41 8.41 15 5.83 15 6 15 14 17 14 17 6 17 5.83 19.59 8.41 21 7 16 2z"
    })), children);
  });
  var Moonrise24 = /*#__PURE__*/React__default['default'].forwardRef(function Moonrise24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$d || (_path170$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 2L11 7 12.41 8.41 15 5.83 15 6 15 14 17 14 17 6 17 5.83 19.59 8.41 21 7 16 2z"
    })), children);
  });
  var Moonrise20 = /*#__PURE__*/React__default['default'].forwardRef(function Moonrise20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$d || (_path171$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 2L11 7 12.41 8.41 15 5.83 15 6 15 14 17 14 17 6 17 5.83 19.59 8.41 21 7 16 2z"
    })), children);
  });
  var Moonrise16 = /*#__PURE__*/React__default['default'].forwardRef(function Moonrise16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$d);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$d || (_path172$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 2L11 7 12.41 8.41 15 5.83 15 6 15 14 17 14 17 6 17 5.83 19.59 8.41 21 7 16 2z"
    })), children);
  });
  var Moonset32 = /*#__PURE__*/React__default['default'].forwardRef(function Moonset32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$d || (_path173$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 14L11 9 12.41 7.59 15 10.17 15 10 15 2 17 2 17 10 17 10.17 19.59 7.59 21 9 16 14z"
    })), children);
  });
  var Moonset24 = /*#__PURE__*/React__default['default'].forwardRef(function Moonset24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$d || (_path174$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 14L11 9 12.41 7.59 15 10.17 15 10 15 2 17 2 17 10 17 10.17 19.59 7.59 21 9 16 14z"
    })), children);
  });
  var Moonset20 = /*#__PURE__*/React__default['default'].forwardRef(function Moonset20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$d || (_path175$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 14L11 9 12.41 7.59 15 10.17 15 10 15 2 17 2 17 10 17 10.17 19.59 7.59 21 9 16 14z"
    })), children);
  });
  var Moonset16 = /*#__PURE__*/React__default['default'].forwardRef(function Moonset16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$d || (_path176$d = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM26 26H24a7.987 7.987 0 00-2.0371-5.3335l1.49-1.334A9.9835 9.9835 0 0126 26zM16 26H14a9.9268 9.9268 0 013.7539-7.804A7.89 7.89 0 0016 18a8.0092 8.0092 0 00-8 8H6A10.0113 10.0113 0 0116 16a9.8923 9.8923 0 014.4458 1.0515 1 1 0 010 1.79A7.9567 7.9567 0 0016 26zM16 14L11 9 12.41 7.59 15 10.17 15 10 15 2 17 2 17 10 17 10.17 19.59 7.59 21 9 16 14z"
    })), children);
  });
  var MostlyCloudy32 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudy32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$c || (_path177$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",
      transform: "translate(0 .005)"
    })), _path178$c || (_path178$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13.005H30V15.005H26z"
    })), _path179$c || (_path179$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.071 5.929H27.071V7.929H23.071z",
      transform: "rotate(-45 25.077 6.931)"
    })), _path180$c || (_path180$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2.005H19V6.005H17z"
    })), _path181$c || (_path181$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.929 4.929H11.929V8.929H9.929z",
      transform: "rotate(-45 10.935 6.931)"
    })), children);
  });
  var MostlyCloudy24 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudy24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$c || (_path182$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",
      transform: "translate(0 .005)"
    })), _path183$c || (_path183$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13.005H30V15.005H26z"
    })), _path184$c || (_path184$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.071 5.929H27.071V7.929H23.071z",
      transform: "rotate(-45 25.077 6.931)"
    })), _path185$c || (_path185$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2.005H19V6.005H17z"
    })), _path186$c || (_path186$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.929 4.929H11.929V8.929H9.929z",
      transform: "rotate(-45 10.935 6.931)"
    })), children);
  });
  var MostlyCloudy20 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudy20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$c || (_path187$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",
      transform: "translate(0 .005)"
    })), _path188$c || (_path188$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13.005H30V15.005H26z"
    })), _path189$c || (_path189$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.071 5.929H27.071V7.929H23.071z",
      transform: "rotate(-45 25.077 6.931)"
    })), _path190$c || (_path190$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2.005H19V6.005H17z"
    })), _path191$c || (_path191$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.929 4.929H11.929V8.929H9.929z",
      transform: "rotate(-45 10.935 6.931)"
    })), children);
  });
  var MostlyCloudy16 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudy16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$c || (_path192$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",
      transform: "translate(0 .005)"
    })), _path193$c || (_path193$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13.005H30V15.005H26z"
    })), _path194$c || (_path194$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.071 5.929H27.071V7.929H23.071z",
      transform: "rotate(-45 25.077 6.931)"
    })), _path195$c || (_path195$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2.005H19V6.005H17z"
    })), _path196$c || (_path196$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.929 4.929H11.929V8.929H9.929z",
      transform: "rotate(-45 10.935 6.931)"
    })), children);
  });
  var MostlyCloudyNight32 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudyNight32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$c || (_path197$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8438,15.0347a1.5169,1.5169,0,0,0-1.23-.8658,5.3547,5.3547,0,0,1-3.4094-1.7158A6.4653,6.4653,0,0,1,23.918,6.0605a1.6025,1.6025,0,0,0-.2989-1.5459,1.4543,1.4543,0,0,0-1.36-.4931l-.0191.0039a7.927,7.927,0,0,0-6.22,7.4307A7.3638,7.3638,0,0,0,13.5,11a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,28H19a5.9771,5.9771,0,0,0,5.6147-8.0884,7.5054,7.5054,0,0,0,5.1324-3.3569A1.5372,1.5372,0,0,0,29.8438,15.0347ZM19,26H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,26Zm4.4653-8.001h-.0217a5.9581,5.9581,0,0,0-2.7942-1.7549,7.5068,7.5068,0,0,0-2.6008-3.6767c-.01-.1016-.0361-.1978-.041-.3008a6.078,6.078,0,0,1,3.7907-6.05,8.4577,8.4577,0,0,0,1.94,7.5967A7.4007,7.4007,0,0,0,27.64,16.041,5.4286,5.4286,0,0,1,23.4653,17.999Z"
    })), children);
  });
  var MostlyCloudyNight24 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudyNight24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$c || (_path198$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8438,15.0347a1.5169,1.5169,0,0,0-1.23-.8658,5.3547,5.3547,0,0,1-3.4094-1.7158A6.4653,6.4653,0,0,1,23.918,6.0605a1.6025,1.6025,0,0,0-.2989-1.5459,1.4543,1.4543,0,0,0-1.36-.4931l-.0191.0039a7.927,7.927,0,0,0-6.22,7.4307A7.3638,7.3638,0,0,0,13.5,11a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,28H19a5.9771,5.9771,0,0,0,5.6147-8.0884,7.5054,7.5054,0,0,0,5.1324-3.3569A1.5372,1.5372,0,0,0,29.8438,15.0347ZM19,26H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,26Zm4.4653-8.001h-.0217a5.9581,5.9581,0,0,0-2.7942-1.7549,7.5068,7.5068,0,0,0-2.6008-3.6767c-.01-.1016-.0361-.1978-.041-.3008a6.078,6.078,0,0,1,3.7907-6.05,8.4577,8.4577,0,0,0,1.94,7.5967A7.4007,7.4007,0,0,0,27.64,16.041,5.4286,5.4286,0,0,1,23.4653,17.999Z"
    })), children);
  });
  var MostlyCloudyNight20 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudyNight20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$c || (_path199$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8438,15.0347a1.5169,1.5169,0,0,0-1.23-.8658,5.3547,5.3547,0,0,1-3.4094-1.7158A6.4653,6.4653,0,0,1,23.918,6.0605a1.6025,1.6025,0,0,0-.2989-1.5459,1.4543,1.4543,0,0,0-1.36-.4931l-.0191.0039a7.927,7.927,0,0,0-6.22,7.4307A7.3638,7.3638,0,0,0,13.5,11a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,28H19a5.9771,5.9771,0,0,0,5.6147-8.0884,7.5054,7.5054,0,0,0,5.1324-3.3569A1.5372,1.5372,0,0,0,29.8438,15.0347ZM19,26H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,26Zm4.4653-8.001h-.0217a5.9581,5.9581,0,0,0-2.7942-1.7549,7.5068,7.5068,0,0,0-2.6008-3.6767c-.01-.1016-.0361-.1978-.041-.3008a6.078,6.078,0,0,1,3.7907-6.05,8.4577,8.4577,0,0,0,1.94,7.5967A7.4007,7.4007,0,0,0,27.64,16.041,5.4286,5.4286,0,0,1,23.4653,17.999Z"
    })), children);
  });
  var MostlyCloudyNight16 = /*#__PURE__*/React__default['default'].forwardRef(function MostlyCloudyNight16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$c || (_path200$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8438,15.0347a1.5169,1.5169,0,0,0-1.23-.8658,5.3547,5.3547,0,0,1-3.4094-1.7158A6.4653,6.4653,0,0,1,23.918,6.0605a1.6025,1.6025,0,0,0-.2989-1.5459,1.4543,1.4543,0,0,0-1.36-.4931l-.0191.0039a7.927,7.927,0,0,0-6.22,7.4307A7.3638,7.3638,0,0,0,13.5,11a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,28H19a5.9771,5.9771,0,0,0,5.6147-8.0884,7.5054,7.5054,0,0,0,5.1324-3.3569A1.5372,1.5372,0,0,0,29.8438,15.0347ZM19,26H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,26Zm4.4653-8.001h-.0217a5.9581,5.9581,0,0,0-2.7942-1.7549,7.5068,7.5068,0,0,0-2.6008-3.6767c-.01-.1016-.0361-.1978-.041-.3008a6.078,6.078,0,0,1,3.7907-6.05,8.4577,8.4577,0,0,0,1.94,7.5967A7.4007,7.4007,0,0,0,27.64,16.041,5.4286,5.4286,0,0,1,23.4653,17.999Z"
    })), children);
  });
  var Mountain32 = /*#__PURE__*/React__default['default'].forwardRef(function Mountain32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$c || (_path201$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6343,26,17.7888,5.1055a2,2,0,0,0-3.5879.021L4.3657,26H2v2H30V26ZM15.99,5.979,20.9473,16.5,19,17.7979l-3-2-3,2-1.9551-1.3033ZM10.1846,18.3247,13,20.2021l3-2,3,2,2.8091-1.873L25.4233,26H6.5752Z"
    })), children);
  });
  var Mountain24 = /*#__PURE__*/React__default['default'].forwardRef(function Mountain24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$c || (_path202$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6343,26,17.7888,5.1055a2,2,0,0,0-3.5879.021L4.3657,26H2v2H30V26ZM15.99,5.979,20.9473,16.5,19,17.7979l-3-2-3,2-1.9551-1.3033ZM10.1846,18.3247,13,20.2021l3-2,3,2,2.8091-1.873L25.4233,26H6.5752Z"
    })), children);
  });
  var Mountain20 = /*#__PURE__*/React__default['default'].forwardRef(function Mountain20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$c || (_path203$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6343,26,17.7888,5.1055a2,2,0,0,0-3.5879.021L4.3657,26H2v2H30V26ZM15.99,5.979,20.9473,16.5,19,17.7979l-3-2-3,2-1.9551-1.3033ZM10.1846,18.3247,13,20.2021l3-2,3,2,2.8091-1.873L25.4233,26H6.5752Z"
    })), children);
  });
  var Mountain16 = /*#__PURE__*/React__default['default'].forwardRef(function Mountain16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$c || (_path204$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.6343,26,17.7888,5.1055a2,2,0,0,0-3.5879.021L4.3657,26H2v2H30V26ZM15.99,5.979,20.9473,16.5,19,17.7979l-3-2-3,2-1.9551-1.3033ZM10.1846,18.3247,13,20.2021l3-2,3,2,2.8091-1.873L25.4233,26H6.5752Z"
    })), children);
  });
  var Mov32 = /*#__PURE__*/React__default['default'].forwardRef(function Mov32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$c || (_path205$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0118 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mov24 = /*#__PURE__*/React__default['default'].forwardRef(function Mov24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$c || (_path206$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0118 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mov20 = /*#__PURE__*/React__default['default'].forwardRef(function Mov20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$c || (_path207$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0118 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mov16 = /*#__PURE__*/React__default['default'].forwardRef(function Mov16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$c || (_path208$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 01-2-2V11a2 2 0 012-2h4a2 2 0 012 2V21A2 2 0 0118 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Move32 = /*#__PURE__*/React__default['default'].forwardRef(function Move32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$c || (_path209$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var Move24 = /*#__PURE__*/React__default['default'].forwardRef(function Move24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$c || (_path210$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var Move20 = /*#__PURE__*/React__default['default'].forwardRef(function Move20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$c || (_path211$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var Move16 = /*#__PURE__*/React__default['default'].forwardRef(function Move16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$c || (_path212$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"
    })), children);
  });
  var Movement32 = /*#__PURE__*/React__default['default'].forwardRef(function Movement32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$c || (_path213$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"
    })), children);
  });
  var Movement24 = /*#__PURE__*/React__default['default'].forwardRef(function Movement24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$c || (_path214$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"
    })), children);
  });
  var Movement20 = /*#__PURE__*/React__default['default'].forwardRef(function Movement20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$c || (_path215$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"
    })), children);
  });
  var Movement16 = /*#__PURE__*/React__default['default'].forwardRef(function Movement16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$c || (_path216$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"
    })), children);
  });
  var Mp332 = /*#__PURE__*/React__default['default'].forwardRef(function Mp332(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$c || (_path217$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp324 = /*#__PURE__*/React__default['default'].forwardRef(function Mp324(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$c || (_path218$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp320 = /*#__PURE__*/React__default['default'].forwardRef(function Mp320(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$c || (_path219$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp316 = /*#__PURE__*/React__default['default'].forwardRef(function Mp316(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$c || (_path220$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 002-2V11A2 2 0 0028 9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp432 = /*#__PURE__*/React__default['default'].forwardRef(function Mp432(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$c || (_path221$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp424 = /*#__PURE__*/React__default['default'].forwardRef(function Mp424(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$c || (_path222$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp420 = /*#__PURE__*/React__default['default'].forwardRef(function Mp420(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$c || (_path223$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mp416 = /*#__PURE__*/React__default['default'].forwardRef(function Mp416(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$c || (_path224$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"
    })), children);
  });
  var Mpeg32 = /*#__PURE__*/React__default['default'].forwardRef(function Mpeg32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$c || (_path225$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H28a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpeg24 = /*#__PURE__*/React__default['default'].forwardRef(function Mpeg24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$c || (_path226$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H28a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpeg20 = /*#__PURE__*/React__default['default'].forwardRef(function Mpeg20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$c || (_path227$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H28a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpeg16 = /*#__PURE__*/React__default['default'].forwardRef(function Mpeg16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$c || (_path228$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H28a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpg232 = /*#__PURE__*/React__default['default'].forwardRef(function Mpg232(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$c || (_path229$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H26V17a2.002 2.002 0 012-2h2V13H26V11h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpg224 = /*#__PURE__*/React__default['default'].forwardRef(function Mpg224(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$c || (_path230$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H26V17a2.002 2.002 0 012-2h2V13H26V11h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpg220 = /*#__PURE__*/React__default['default'].forwardRef(function Mpg220(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$c || (_path231$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H26V17a2.002 2.002 0 012-2h2V13H26V11h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Mpg216 = /*#__PURE__*/React__default['default'].forwardRef(function Mpg216(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$c || (_path232$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 21H26V17a2.002 2.002 0 012-2h2V13H26V11h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 01-2-2V13a2.002 2.002 0 012-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 002-2V13A2.0023 2.0023 0 0014 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"
    })), children);
  });
  var Music32 = /*#__PURE__*/React__default['default'].forwardRef(function Music32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$c || (_path233$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"
    })), children);
  });
  var Music24 = /*#__PURE__*/React__default['default'].forwardRef(function Music24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$c || (_path234$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"
    })), children);
  });
  var Music20 = /*#__PURE__*/React__default['default'].forwardRef(function Music20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$c || (_path235$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"
    })), children);
  });
  var Music16 = /*#__PURE__*/React__default['default'].forwardRef(function Music16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$c || (_path236$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"
    })), children);
  });
  var MusicAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function MusicAdd32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$c || (_path237$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function MusicAdd24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$c || (_path238$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function MusicAdd20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$c || (_path239$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function MusicAdd16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$c || (_path240$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicRemove32 = /*#__PURE__*/React__default['default'].forwardRef(function MusicRemove32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$c || (_path241$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 7L30 3.41 28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicRemove24 = /*#__PURE__*/React__default['default'].forwardRef(function MusicRemove24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$c || (_path242$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 7L30 3.41 28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicRemove20 = /*#__PURE__*/React__default['default'].forwardRef(function MusicRemove20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$c || (_path243$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 7L30 3.41 28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var MusicRemove16 = /*#__PURE__*/React__default['default'].forwardRef(function MusicRemove16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$c || (_path244$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 7L30 3.41 28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7zM24 15v7.5562A3.9552 3.9552 0 0022 22a4 4 0 104 4V15zM22 28a2 2 0 112-2A2.0027 2.0027 0 0122 28zM17 6H10A2.002 2.002 0 008 8V22.5562A3.9557 3.9557 0 006 22a4 4 0 104 4V8h7zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var NameSpace32 = /*#__PURE__*/React__default['default'].forwardRef(function NameSpace32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$c || (_path245$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4H7V6H4v4H7zM9 10H15V12H9zM17 10H23V12H17zM28 12H25V10h3V6H25V4h3a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 12zM17 4H23V6H17zM9 4H15V6H9zM28 28H4a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 28zM4 22v4H28V22zM2 15H30V17H2z"
    })), children);
  });
  var NameSpace24 = /*#__PURE__*/React__default['default'].forwardRef(function NameSpace24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$c || (_path246$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4H7V6H4v4H7zM9 10H15V12H9zM17 10H23V12H17zM28 12H25V10h3V6H25V4h3a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 12zM17 4H23V6H17zM9 4H15V6H9zM28 28H4a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 28zM4 22v4H28V22zM2 15H30V17H2z"
    })), children);
  });
  var NameSpace20 = /*#__PURE__*/React__default['default'].forwardRef(function NameSpace20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$c || (_path247$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4H7V6H4v4H7zM9 10H15V12H9zM17 10H23V12H17zM28 12H25V10h3V6H25V4h3a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 12zM17 4H23V6H17zM9 4H15V6H9zM28 28H4a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 28zM4 22v4H28V22zM2 15H30V17H2z"
    })), children);
  });
  var NameSpace16 = /*#__PURE__*/React__default['default'].forwardRef(function NameSpace16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$c || (_path248$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 12H4a2.0023 2.0023 0 01-2-2V6A2.0023 2.0023 0 014 4H7V6H4v4H7zM9 10H15V12H9zM17 10H23V12H17zM28 12H25V10h3V6H25V4h3a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 12zM17 4H23V6H17zM9 4H15V6H9zM28 28H4a2.0023 2.0023 0 01-2-2V22a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 28zM4 22v4H28V22zM2 15H30V17H2z"
    })), children);
  });
  var NavaidCivil32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidCivil32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$c || (_path249$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidCivil24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidCivil24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$c || (_path250$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidCivil20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidCivil20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$c || (_path251$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidCivil16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidCivil16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$c || (_path252$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidDme32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidDme32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$c || (_path253$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path254$c || (_path254$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8H24a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,24,24ZM8,10V22H24V10Z"
    })), _path255$c || (_path255$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var NavaidDme24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidDme24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$c || (_path256$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path257$c || (_path257$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8H24a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,24,24ZM8,10V22H24V10Z"
    })), _path258$c || (_path258$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var NavaidDme20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidDme20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$c || (_path259$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path260$c || (_path260$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8H24a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,24,24ZM8,10V22H24V10Z"
    })), _path261$c || (_path261$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var NavaidDme16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidDme16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$c || (_path262$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"
    })), _path263$c || (_path263$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,24H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8H24a2.0021,2.0021,0,0,1,2,2V22A2.0021,2.0021,0,0,1,24,24ZM8,10V22H24V10Z"
    })), _path264$c || (_path264$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,28H4a2.0021,2.0021,0,0,1-2-2V6A2.0021,2.0021,0,0,1,4,4H28a2.0021,2.0021,0,0,1,2,2V26A2.0021,2.0021,0,0,1,28,28ZM4,6V26H28V6Z"
    })), children);
  });
  var NavaidHelipad32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidHelipad32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$c || (_path265$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path266$c || (_path266$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidHelipad24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidHelipad24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$c || (_path267$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path268$c || (_path268$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidHelipad20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidHelipad20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$c || (_path269$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path270$c || (_path270$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidHelipad16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidHelipad16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$c || (_path271$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"
    })), _path272$c || (_path272$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidMilitary32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitary32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$c || (_path273$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path274$c || (_path274$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle13$9 || (_circle13$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var NavaidMilitary24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitary24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$c || (_path275$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path276$c || (_path276$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle14$9 || (_circle14$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var NavaidMilitary20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitary20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$c || (_path277$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path278$c || (_path278$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle15$9 || (_circle15$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var NavaidMilitary16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitary16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$c || (_path279$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), _path280$c || (_path280$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle16$9 || (_circle16$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), children);
  });
  var NavaidMilitaryCivil32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitaryCivil32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$c || (_path281$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _path282$c || (_path282$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidMilitaryCivil24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitaryCivil24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$c || (_path283$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _path284$c || (_path284$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidMilitaryCivil20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitaryCivil20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$c || (_path285$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _path286$c || (_path286$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidMilitaryCivil16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidMilitaryCivil16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$c || (_path287$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _path288$c || (_path288$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidNdb32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdb32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$c || (_path289$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle17$8 || (_circle17$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle18$8 || (_circle18$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle19$8 || (_circle19$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "28",
      r: "2"
    })), _circle20$8 || (_circle20$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "16",
      r: "2"
    })), _circle21$8 || (_circle21$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _circle22$8 || (_circle22$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "7.515",
      r: "2"
    })), _circle23$8 || (_circle23$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "24.485",
      r: "2"
    })), _circle24$8 || (_circle24$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "7.515",
      r: "2"
    })), _circle25$7 || (_circle25$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "24.485",
      r: "2"
    })), children);
  });
  var NavaidNdb24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdb24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$c || (_path290$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle26$7 || (_circle26$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle27$7 || (_circle27$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle28$7 || (_circle28$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "28",
      r: "2"
    })), _circle29$7 || (_circle29$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "16",
      r: "2"
    })), _circle30$7 || (_circle30$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _circle31$7 || (_circle31$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "7.515",
      r: "2"
    })), _circle32$7 || (_circle32$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "24.485",
      r: "2"
    })), _circle33$7 || (_circle33$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "7.515",
      r: "2"
    })), _circle34$6 || (_circle34$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "24.485",
      r: "2"
    })), children);
  });
  var NavaidNdb20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdb20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$c || (_path291$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle35$6 || (_circle35$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle36$6 || (_circle36$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle37$5 || (_circle37$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "28",
      r: "2"
    })), _circle38$5 || (_circle38$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "16",
      r: "2"
    })), _circle39$5 || (_circle39$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _circle40$5 || (_circle40$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "7.515",
      r: "2"
    })), _circle41$5 || (_circle41$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "24.485",
      r: "2"
    })), _circle42$5 || (_circle42$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "7.515",
      r: "2"
    })), _circle43$5 || (_circle43$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "24.485",
      r: "2"
    })), children);
  });
  var NavaidNdb16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdb16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$c || (_path292$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,24Zm0-14a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,10Z"
    })), _circle44$5 || (_circle44$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle45$5 || (_circle45$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "4",
      r: "2"
    })), _circle46$5 || (_circle46$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "28",
      r: "2"
    })), _circle47$5 || (_circle47$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "16",
      r: "2"
    })), _circle48$5 || (_circle48$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _circle49$4 || (_circle49$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "7.515",
      r: "2"
    })), _circle50$4 || (_circle50$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "24.485",
      r: "2"
    })), _circle51$4 || (_circle51$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.485",
      cy: "7.515",
      r: "2"
    })), _circle52$4 || (_circle52$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.515",
      cy: "24.485",
      r: "2"
    })), children);
  });
  var NavaidNdbDme32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdbDme32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$c || (_path293$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12H2V4A2.0021 2.0021 0 014 2h8V4H4zM12 30H4a2.0021 2.0021 0 01-2-2V20H4v8h8zM28 30H20V28h8V20h2v8A2.0021 2.0021 0 0128 30zM30 12H28V4H20V2h8a2.0021 2.0021 0 012 2zM16 22a6 6 0 116-6A6.0067 6.0067 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), _circle53$3 || (_circle53$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle54$3 || (_circle54$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7",
      r: "1"
    })), _circle55$2 || (_circle55$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "3",
      r: "1"
    })), _circle56$2 || (_circle56$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "1"
    })), _circle57$2 || (_circle57$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "29",
      r: "1"
    })), _circle58$2 || (_circle58$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "16",
      r: "1"
    })), _circle59$2 || (_circle59$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "16",
      r: "1"
    })), _circle60$2 || (_circle60$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle61$2 || (_circle61$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "16",
      r: "1"
    })), _circle62$2 || (_circle62$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "9.636",
      r: "1"
    })), _circle63$2 || (_circle63$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle64$2 || (_circle64$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "22.364",
      r: "1"
    })), _circle65$2 || (_circle65$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle66$2 || (_circle66$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "9.636",
      r: "1"
    })), _circle67$2 || (_circle67$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "1"
    })), _circle68$2 || (_circle68$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "22.364",
      r: "1"
    })), _circle69$2 || (_circle69$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var NavaidNdbDme24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdbDme24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$c || (_path294$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12H2V4A2.0021 2.0021 0 014 2h8V4H4zM12 30H4a2.0021 2.0021 0 01-2-2V20H4v8h8zM28 30H20V28h8V20h2v8A2.0021 2.0021 0 0128 30zM30 12H28V4H20V2h8a2.0021 2.0021 0 012 2zM16 22a6 6 0 116-6A6.0067 6.0067 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), _circle70$2 || (_circle70$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle71$2 || (_circle71$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7",
      r: "1"
    })), _circle72$2 || (_circle72$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "3",
      r: "1"
    })), _circle73$1 || (_circle73$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "1"
    })), _circle74$1 || (_circle74$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "29",
      r: "1"
    })), _circle75$1 || (_circle75$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "16",
      r: "1"
    })), _circle76$1 || (_circle76$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "16",
      r: "1"
    })), _circle77$1 || (_circle77$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle78$1 || (_circle78$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "16",
      r: "1"
    })), _circle79$1 || (_circle79$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "9.636",
      r: "1"
    })), _circle80$1 || (_circle80$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle81$1 || (_circle81$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "22.364",
      r: "1"
    })), _circle82$1 || (_circle82$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle83$1 || (_circle83$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "9.636",
      r: "1"
    })), _circle84$1 || (_circle84$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "1"
    })), _circle85 || (_circle85 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "22.364",
      r: "1"
    })), _circle86 || (_circle86 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var NavaidNdbDme20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdbDme20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$c || (_path295$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12H2V4A2.0021 2.0021 0 014 2h8V4H4zM12 30H4a2.0021 2.0021 0 01-2-2V20H4v8h8zM28 30H20V28h8V20h2v8A2.0021 2.0021 0 0128 30zM30 12H28V4H20V2h8a2.0021 2.0021 0 012 2zM16 22a6 6 0 116-6A6.0067 6.0067 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), _circle87 || (_circle87 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle88 || (_circle88 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7",
      r: "1"
    })), _circle89 || (_circle89 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "3",
      r: "1"
    })), _circle90 || (_circle90 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "1"
    })), _circle91 || (_circle91 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "29",
      r: "1"
    })), _circle92 || (_circle92 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "16",
      r: "1"
    })), _circle93 || (_circle93 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "16",
      r: "1"
    })), _circle94 || (_circle94 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle95 || (_circle95 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "16",
      r: "1"
    })), _circle96 || (_circle96 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "9.636",
      r: "1"
    })), _circle97 || (_circle97 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle98 || (_circle98 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "22.364",
      r: "1"
    })), _circle99 || (_circle99 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle100 || (_circle100 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "9.636",
      r: "1"
    })), _circle101 || (_circle101 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "1"
    })), _circle102 || (_circle102 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "22.364",
      r: "1"
    })), _circle103 || (_circle103 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var NavaidNdbDme16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidNdbDme16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$c || (_path296$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 12H2V4A2.0021 2.0021 0 014 2h8V4H4zM12 30H4a2.0021 2.0021 0 01-2-2V20H4v8h8zM28 30H20V28h8V20h2v8A2.0021 2.0021 0 0128 30zM30 12H28V4H20V2h8a2.0021 2.0021 0 012 2zM16 22a6 6 0 116-6A6.0067 6.0067 0 0116 22zm0-10a4 4 0 104 4A4.0045 4.0045 0 0016 12z"
    })), _circle104 || (_circle104 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle105 || (_circle105 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "7",
      r: "1"
    })), _circle106 || (_circle106 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "3",
      r: "1"
    })), _circle107 || (_circle107 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "1"
    })), _circle108 || (_circle108 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "29",
      r: "1"
    })), _circle109 || (_circle109 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "16",
      r: "1"
    })), _circle110 || (_circle110 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "29",
      cy: "16",
      r: "1"
    })), _circle111 || (_circle111 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "16",
      r: "1"
    })), _circle112 || (_circle112 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "16",
      r: "1"
    })), _circle113 || (_circle113 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "9.636",
      r: "1"
    })), _circle114 || (_circle114 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "7",
      r: "1"
    })), _circle115 || (_circle115 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "22.364",
      r: "1"
    })), _circle116 || (_circle116 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "25",
      r: "1"
    })), _circle117 || (_circle117 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.364",
      cy: "9.636",
      r: "1"
    })), _circle118 || (_circle118 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "25",
      cy: "7",
      r: "1"
    })), _circle119 || (_circle119 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.636",
      cy: "22.364",
      r: "1"
    })), _circle120 || (_circle120 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var NavaidPrivate32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidPrivate32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$c || (_path297$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,15V11a2.0023,2.0023,0,0,0-2-2H12V23h2V17h1.4807l2.3345,6H19.96l-2.333-6H18A2.0027,2.0027,0,0,0,20,15Zm-6-4h4v4H14Z"
    })), _path298$c || (_path298$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidPrivate24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidPrivate24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$c || (_path299$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,15V11a2.0023,2.0023,0,0,0-2-2H12V23h2V17h1.4807l2.3345,6H19.96l-2.333-6H18A2.0027,2.0027,0,0,0,20,15Zm-6-4h4v4H14Z"
    })), _path300$c || (_path300$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidPrivate20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidPrivate20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$c || (_path301$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,15V11a2.0023,2.0023,0,0,0-2-2H12V23h2V17h1.4807l2.3345,6H19.96l-2.333-6H18A2.0027,2.0027,0,0,0,20,15Zm-6-4h4v4H14Z"
    })), _path302$c || (_path302$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidPrivate16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidPrivate16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$c || (_path303$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,15V11a2.0023,2.0023,0,0,0-2-2H12V23h2V17h1.4807l2.3345,6H19.96l-2.333-6H18A2.0027,2.0027,0,0,0,20,15Zm-6-4h4v4H14Z"
    })), _path304$c || (_path304$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NavaidSeaplane32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidSeaplane32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$c || (_path305$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18a3.9962,3.9962,0,0,1-3,3.8579V17h2V15H17V13.8159a3.0007,3.0007,0,1,0-2,0V15H13v2h2v4.8579A3.9962,3.9962,0,0,1,12,18H10a6,6,0,0,0,12,0Zm-4-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Z"
    })), _path306$c || (_path306$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidSeaplane24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidSeaplane24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$c || (_path307$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18a3.9962,3.9962,0,0,1-3,3.8579V17h2V15H17V13.8159a3.0007,3.0007,0,1,0-2,0V15H13v2h2v4.8579A3.9962,3.9962,0,0,1,12,18H10a6,6,0,0,0,12,0Zm-4-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Z"
    })), _path308$c || (_path308$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidSeaplane20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidSeaplane20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$c || (_path309$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18a3.9962,3.9962,0,0,1-3,3.8579V17h2V15H17V13.8159a3.0007,3.0007,0,1,0-2,0V15H13v2h2v4.8579A3.9962,3.9962,0,0,1,12,18H10a6,6,0,0,0,12,0Zm-4-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Z"
    })), _path310$c || (_path310$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidSeaplane16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidSeaplane16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$c || (_path311$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,18a3.9962,3.9962,0,0,1-3,3.8579V17h2V15H17V13.8159a3.0007,3.0007,0,1,0-2,0V15H13v2h2v4.8579A3.9962,3.9962,0,0,1,12,18H10a6,6,0,0,0,12,0Zm-4-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,16,10Z"
    })), _path312$c || (_path312$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H27.8193A12.0112,12.0112,0,0,0,18,4.1807V2H14V4.1807A12.0112,12.0112,0,0,0,4.1807,14H2v4H4.1807A12.0112,12.0112,0,0,0,14,27.8193V30h4V27.8193A12.0112,12.0112,0,0,0,27.8193,18H30ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var NavaidTacan32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidTacan32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle121 || (_circle121 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path313$c || (_path313$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28H12a1,1,0,0,1-1-1V21.2656L7.2612,14.7231,2.4854,11.8574a1,1,0,0,1-.3536-1.3535l4-7a1,1,0,0,1,1.3828-.3613L12.2769,6h7.4462l4.7623-2.8574a1,1,0,0,1,1.3828.3613l4,7a1,1,0,0,1-.3536,1.3535l-4.7758,2.8657L21,21.2656V27A1,1,0,0,1,20,28Zm-7-2h6V20.7346l4.2616-7.4578,4.3844-2.6306L24.6387,5.3831,20.277,8H11.723L7.3613,5.3831,4.354,10.6462l4.3844,2.6306L13,20.7346Z"
    })), children);
  });
  var NavaidTacan24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidTacan24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle122 || (_circle122 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path314$c || (_path314$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28H12a1,1,0,0,1-1-1V21.2656L7.2612,14.7231,2.4854,11.8574a1,1,0,0,1-.3536-1.3535l4-7a1,1,0,0,1,1.3828-.3613L12.2769,6h7.4462l4.7623-2.8574a1,1,0,0,1,1.3828.3613l4,7a1,1,0,0,1-.3536,1.3535l-4.7758,2.8657L21,21.2656V27A1,1,0,0,1,20,28Zm-7-2h6V20.7346l4.2616-7.4578,4.3844-2.6306L24.6387,5.3831,20.277,8H11.723L7.3613,5.3831,4.354,10.6462l4.3844,2.6306L13,20.7346Z"
    })), children);
  });
  var NavaidTacan20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidTacan20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle123 || (_circle123 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path315$c || (_path315$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28H12a1,1,0,0,1-1-1V21.2656L7.2612,14.7231,2.4854,11.8574a1,1,0,0,1-.3536-1.3535l4-7a1,1,0,0,1,1.3828-.3613L12.2769,6h7.4462l4.7623-2.8574a1,1,0,0,1,1.3828.3613l4,7a1,1,0,0,1-.3536,1.3535l-4.7758,2.8657L21,21.2656V27A1,1,0,0,1,20,28Zm-7-2h6V20.7346l4.2616-7.4578,4.3844-2.6306L24.6387,5.3831,20.277,8H11.723L7.3613,5.3831,4.354,10.6462l4.3844,2.6306L13,20.7346Z"
    })), children);
  });
  var NavaidTacan16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidTacan16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle124 || (_circle124 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path316$c || (_path316$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,28H12a1,1,0,0,1-1-1V21.2656L7.2612,14.7231,2.4854,11.8574a1,1,0,0,1-.3536-1.3535l4-7a1,1,0,0,1,1.3828-.3613L12.2769,6h7.4462l4.7623-2.8574a1,1,0,0,1,1.3828.3613l4,7a1,1,0,0,1-.3536,1.3535l-4.7758,2.8657L21,21.2656V27A1,1,0,0,1,20,28Zm-7-2h6V20.7346l4.2616-7.4578,4.3844-2.6306L24.6387,5.3831,20.277,8H11.723L7.3613,5.3831,4.354,10.6462l4.3844,2.6306L13,20.7346Z"
    })), children);
  });
  var NavaidVhfor32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVhfor32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$c || (_path317$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H10a1,1,0,0,1-.8438-.4631l-7-11a1,1,0,0,1,0-1.0738l7-11A1,1,0,0,1,10,4H22a1,1,0,0,1,.8438.4631l7,11a1,1,0,0,1,0,1.0738l-7,11A1,1,0,0,1,22,28ZM10.5488,26H21.4512l6.3633-10L21.4512,6H10.5488L4.1855,16Z"
    })), _path318$c || (_path318$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5,24h-7a1.0005,1.0005,0,0,1-.8413-.4592l-4.5-7a1.0016,1.0016,0,0,1,0-1.0816l4.5-7A1.0005,1.0005,0,0,1,12.5,8h7a1.0005,1.0005,0,0,1,.8413.4592l4.5,7a1.0016,1.0016,0,0,1,0,1.0816l-4.5,7A1.0005,1.0005,0,0,1,19.5,24Zm-6.4541-2h5.9082l3.8569-6-3.8569-6H13.0459L9.189,16Z"
    })), children);
  });
  var NavaidVhfor24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVhfor24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$c || (_path319$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H10a1,1,0,0,1-.8438-.4631l-7-11a1,1,0,0,1,0-1.0738l7-11A1,1,0,0,1,10,4H22a1,1,0,0,1,.8438.4631l7,11a1,1,0,0,1,0,1.0738l-7,11A1,1,0,0,1,22,28ZM10.5488,26H21.4512l6.3633-10L21.4512,6H10.5488L4.1855,16Z"
    })), _path320$c || (_path320$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5,24h-7a1.0005,1.0005,0,0,1-.8413-.4592l-4.5-7a1.0016,1.0016,0,0,1,0-1.0816l4.5-7A1.0005,1.0005,0,0,1,12.5,8h7a1.0005,1.0005,0,0,1,.8413.4592l4.5,7a1.0016,1.0016,0,0,1,0,1.0816l-4.5,7A1.0005,1.0005,0,0,1,19.5,24Zm-6.4541-2h5.9082l3.8569-6-3.8569-6H13.0459L9.189,16Z"
    })), children);
  });
  var NavaidVhfor20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVhfor20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$c || (_path321$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H10a1,1,0,0,1-.8438-.4631l-7-11a1,1,0,0,1,0-1.0738l7-11A1,1,0,0,1,10,4H22a1,1,0,0,1,.8438.4631l7,11a1,1,0,0,1,0,1.0738l-7,11A1,1,0,0,1,22,28ZM10.5488,26H21.4512l6.3633-10L21.4512,6H10.5488L4.1855,16Z"
    })), _path322$c || (_path322$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5,24h-7a1.0005,1.0005,0,0,1-.8413-.4592l-4.5-7a1.0016,1.0016,0,0,1,0-1.0816l4.5-7A1.0005,1.0005,0,0,1,12.5,8h7a1.0005,1.0005,0,0,1,.8413.4592l4.5,7a1.0016,1.0016,0,0,1,0,1.0816l-4.5,7A1.0005,1.0005,0,0,1,19.5,24Zm-6.4541-2h5.9082l3.8569-6-3.8569-6H13.0459L9.189,16Z"
    })), children);
  });
  var NavaidVhfor16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVhfor16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$c || (_path323$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,28H10a1,1,0,0,1-.8438-.4631l-7-11a1,1,0,0,1,0-1.0738l7-11A1,1,0,0,1,10,4H22a1,1,0,0,1,.8438.4631l7,11a1,1,0,0,1,0,1.0738l-7,11A1,1,0,0,1,22,28ZM10.5488,26H21.4512l6.3633-10L21.4512,6H10.5488L4.1855,16Z"
    })), _path324$c || (_path324$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5,24h-7a1.0005,1.0005,0,0,1-.8413-.4592l-4.5-7a1.0016,1.0016,0,0,1,0-1.0816l4.5-7A1.0005,1.0005,0,0,1,12.5,8h7a1.0005,1.0005,0,0,1,.8413.4592l4.5,7a1.0016,1.0016,0,0,1,0,1.0816l-4.5,7A1.0005,1.0005,0,0,1,19.5,24Zm-6.4541-2h5.9082l3.8569-6-3.8569-6H13.0459L9.189,16Z"
    })), children);
  });
  var NavaidVor32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVor32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle125 || (_circle125 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path325$c || (_path325$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8638,15.4961l-7-12A1,1,0,0,0,23,3H9a1,1,0,0,0-.8638.4961l-7,12a1,1,0,0,0,0,1.0078l7,12A1,1,0,0,0,9,29H23a1,1,0,0,0,.8638-.4961l7-12a1,1,0,0,0,0-1.0078ZM22.4258,27H9.5742L3.1577,16,9.5742,5H22.4258l6.4165,11Z"
    })), children);
  });
  var NavaidVor24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVor24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle126 || (_circle126 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path326$c || (_path326$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8638,15.4961l-7-12A1,1,0,0,0,23,3H9a1,1,0,0,0-.8638.4961l-7,12a1,1,0,0,0,0,1.0078l7,12A1,1,0,0,0,9,29H23a1,1,0,0,0,.8638-.4961l7-12a1,1,0,0,0,0-1.0078ZM22.4258,27H9.5742L3.1577,16,9.5742,5H22.4258l6.4165,11Z"
    })), children);
  });
  var NavaidVor20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVor20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle127 || (_circle127 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path327$c || (_path327$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8638,15.4961l-7-12A1,1,0,0,0,23,3H9a1,1,0,0,0-.8638.4961l-7,12a1,1,0,0,0,0,1.0078l7,12A1,1,0,0,0,9,29H23a1,1,0,0,0,.8638-.4961l7-12a1,1,0,0,0,0-1.0078ZM22.4258,27H9.5742L3.1577,16,9.5742,5H22.4258l6.4165,11Z"
    })), children);
  });
  var NavaidVor16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVor16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle128 || (_circle128 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path328$c || (_path328$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8638,15.4961l-7-12A1,1,0,0,0,23,3H9a1,1,0,0,0-.8638.4961l-7,12a1,1,0,0,0,0,1.0078l7,12A1,1,0,0,0,9,29H23a1,1,0,0,0,.8638-.4961l7-12a1,1,0,0,0,0-1.0078ZM22.4258,27H9.5742L3.1577,16,9.5742,5H22.4258l6.4165,11Z"
    })), children);
  });
  var NavaidVordme32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVordme32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle129 || (_circle129 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path329$c || (_path329$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2Zm-2,6.9258L22.9636,6H28ZM27.7637,16,20.491,26H11.509L4.2363,16,11.509,6h8.982ZM9.0364,6,4,12.9248V6ZM4,19.0752,9.0364,26H4ZM22.9636,26l5.0374-6.9263L28,26Z"
    })), children);
  });
  var NavaidVordme24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVordme24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle130 || (_circle130 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path330$c || (_path330$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2Zm-2,6.9258L22.9636,6H28ZM27.7637,16,20.491,26H11.509L4.2363,16,11.509,6h8.982ZM9.0364,6,4,12.9248V6ZM4,19.0752,9.0364,26H4ZM22.9636,26l5.0374-6.9263L28,26Z"
    })), children);
  });
  var NavaidVordme20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVordme20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle131 || (_circle131 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path331$c || (_path331$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2Zm-2,6.9258L22.9636,6H28ZM27.7637,16,20.491,26H11.509L4.2363,16,11.509,6h8.982ZM9.0364,6,4,12.9248V6ZM4,19.0752,9.0364,26H4ZM22.9636,26l5.0374-6.9263L28,26Z"
    })), children);
  });
  var NavaidVordme16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVordme16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle132 || (_circle132 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path332$c || (_path332$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,6a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,6V26a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2Zm-2,6.9258L22.9636,6H28ZM27.7637,16,20.491,26H11.509L4.2363,16,11.509,6h8.982ZM9.0364,6,4,12.9248V6ZM4,19.0752,9.0364,26H4ZM22.9636,26l5.0374-6.9263L28,26Z"
    })), children);
  });
  var NavaidVortac32 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVortac32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle133 || (_circle133 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path333$c || (_path333$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8682,10.5039l-4-7a.9992.9992,0,0,0-1.3828-.3613L19.7231,6H12.2769L7.5146,3.1426a.9992.9992,0,0,0-1.3828.3613l-4,7a1,1,0,0,0,.3536,1.3535l4.7758,2.8657L11,21.2656V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V21.2656l3.7388-6.5425,4.7758-2.8657A1,1,0,0,0,29.8682,10.5039ZM18.8484,21H13.1516L8.5757,12.9922,11.4287,8h9.1426l2.853,4.9922Z"
    })), children);
  });
  var NavaidVortac24 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVortac24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle134 || (_circle134 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path334$c || (_path334$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8682,10.5039l-4-7a.9992.9992,0,0,0-1.3828-.3613L19.7231,6H12.2769L7.5146,3.1426a.9992.9992,0,0,0-1.3828.3613l-4,7a1,1,0,0,0,.3536,1.3535l4.7758,2.8657L11,21.2656V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V21.2656l3.7388-6.5425,4.7758-2.8657A1,1,0,0,0,29.8682,10.5039ZM18.8484,21H13.1516L8.5757,12.9922,11.4287,8h9.1426l2.853,4.9922Z"
    })), children);
  });
  var NavaidVortac20 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVortac20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle135 || (_circle135 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path335$c || (_path335$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8682,10.5039l-4-7a.9992.9992,0,0,0-1.3828-.3613L19.7231,6H12.2769L7.5146,3.1426a.9992.9992,0,0,0-1.3828.3613l-4,7a1,1,0,0,0,.3536,1.3535l4.7758,2.8657L11,21.2656V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V21.2656l3.7388-6.5425,4.7758-2.8657A1,1,0,0,0,29.8682,10.5039ZM18.8484,21H13.1516L8.5757,12.9922,11.4287,8h9.1426l2.853,4.9922Z"
    })), children);
  });
  var NavaidVortac16 = /*#__PURE__*/React__default['default'].forwardRef(function NavaidVortac16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle136 || (_circle136 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14",
      r: "2"
    })), _path336$c || (_path336$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.8682,10.5039l-4-7a.9992.9992,0,0,0-1.3828-.3613L19.7231,6H12.2769L7.5146,3.1426a.9992.9992,0,0,0-1.3828.3613l-4,7a1,1,0,0,0,.3536,1.3535l4.7758,2.8657L11,21.2656V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V21.2656l3.7388-6.5425,4.7758-2.8657A1,1,0,0,0,29.8682,10.5039ZM18.8484,21H13.1516L8.5757,12.9922,11.4287,8h9.1426l2.853,4.9922Z"
    })), children);
  });
  var Need32 = /*#__PURE__*/React__default['default'].forwardRef(function Need32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$c || (_path337$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1211 16.8789A2.98 2.98 0 0027.01 16H27a2.9774 2.9774 0 00-2.1211.8789L19.9778 21.78A2.9943 2.9943 0 0017 19H10a5.0059 5.0059 0 00-5 5v.667L2 28.6631l1.6 1.2L7 25.333V24a3.0033 3.0033 0 013-3h7a1 1 0 010 2H13v2h4.9287a3.9717 3.9717 0 002.8286-1.1719L26.293 18.293A.9929.9929 0 0127 18h.0034a1 1 0 01.7036 1.707l-7.414 7.4141A2.9791 2.9791 0 0118.1714 28H11v2h7.1714a4.9665 4.9665 0 003.5356-1.4648l7.4141-7.4141a2.9989 2.9989 0 000-4.2422zM21.586 8.586L18 12 18 2 16 2 16 12 12.414 8.586 11 10 17 16 23 10 21.586 8.586z"
    })), children);
  });
  var Need24 = /*#__PURE__*/React__default['default'].forwardRef(function Need24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$b || (_path338$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1211 16.8789A2.98 2.98 0 0027.01 16H27a2.9774 2.9774 0 00-2.1211.8789L19.9778 21.78A2.9943 2.9943 0 0017 19H10a5.0059 5.0059 0 00-5 5v.667L2 28.6631l1.6 1.2L7 25.333V24a3.0033 3.0033 0 013-3h7a1 1 0 010 2H13v2h4.9287a3.9717 3.9717 0 002.8286-1.1719L26.293 18.293A.9929.9929 0 0127 18h.0034a1 1 0 01.7036 1.707l-7.414 7.4141A2.9791 2.9791 0 0118.1714 28H11v2h7.1714a4.9665 4.9665 0 003.5356-1.4648l7.4141-7.4141a2.9989 2.9989 0 000-4.2422zM21.586 8.586L18 12 18 2 16 2 16 12 12.414 8.586 11 10 17 16 23 10 21.586 8.586z"
    })), children);
  });
  var Need20 = /*#__PURE__*/React__default['default'].forwardRef(function Need20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$b || (_path339$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1211 16.8789A2.98 2.98 0 0027.01 16H27a2.9774 2.9774 0 00-2.1211.8789L19.9778 21.78A2.9943 2.9943 0 0017 19H10a5.0059 5.0059 0 00-5 5v.667L2 28.6631l1.6 1.2L7 25.333V24a3.0033 3.0033 0 013-3h7a1 1 0 010 2H13v2h4.9287a3.9717 3.9717 0 002.8286-1.1719L26.293 18.293A.9929.9929 0 0127 18h.0034a1 1 0 01.7036 1.707l-7.414 7.4141A2.9791 2.9791 0 0118.1714 28H11v2h7.1714a4.9665 4.9665 0 003.5356-1.4648l7.4141-7.4141a2.9989 2.9989 0 000-4.2422zM21.586 8.586L18 12 18 2 16 2 16 12 12.414 8.586 11 10 17 16 23 10 21.586 8.586z"
    })), children);
  });
  var Need16 = /*#__PURE__*/React__default['default'].forwardRef(function Need16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$b || (_path340$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1211 16.8789A2.98 2.98 0 0027.01 16H27a2.9774 2.9774 0 00-2.1211.8789L19.9778 21.78A2.9943 2.9943 0 0017 19H10a5.0059 5.0059 0 00-5 5v.667L2 28.6631l1.6 1.2L7 25.333V24a3.0033 3.0033 0 013-3h7a1 1 0 010 2H13v2h4.9287a3.9717 3.9717 0 002.8286-1.1719L26.293 18.293A.9929.9929 0 0127 18h.0034a1 1 0 01.7036 1.707l-7.414 7.4141A2.9791 2.9791 0 0118.1714 28H11v2h7.1714a4.9665 4.9665 0 003.5356-1.4648l7.4141-7.4141a2.9989 2.9989 0 000-4.2422zM21.586 8.586L18 12 18 2 16 2 16 12 12.414 8.586 11 10 17 16 23 10 21.586 8.586z"
    })), children);
  });
  var Network_132 = /*#__PURE__*/React__default['default'].forwardRef(function Network_132(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$b || (_path341$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a4 4 0 114-4A4.0045 4.0045 0 0116 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 14zM5 20a4 4 0 114-4A4.0045 4.0045 0 015 20zm0-6a2 2 0 102 2A2.0023 2.0023 0 005 14zM10 31a4 4 0 114-4A4.0045 4.0045 0 0110 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 25zM22 31a4 4 0 114-4A4.0045 4.0045 0 0122 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 25zM27 20a4 4 0 114-4A4.0045 4.0045 0 0127 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0027 14zM22 9a4 4 0 114-4A4.0045 4.0045 0 0122 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 3zM10 9a4 4 0 114-4A4.0045 4.0045 0 0110 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 3z"
    })), children);
  });
  var Network_124 = /*#__PURE__*/React__default['default'].forwardRef(function Network_124(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$b || (_path342$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a4 4 0 114-4A4.0045 4.0045 0 0116 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 14zM5 20a4 4 0 114-4A4.0045 4.0045 0 015 20zm0-6a2 2 0 102 2A2.0023 2.0023 0 005 14zM10 31a4 4 0 114-4A4.0045 4.0045 0 0110 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 25zM22 31a4 4 0 114-4A4.0045 4.0045 0 0122 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 25zM27 20a4 4 0 114-4A4.0045 4.0045 0 0127 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0027 14zM22 9a4 4 0 114-4A4.0045 4.0045 0 0122 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 3zM10 9a4 4 0 114-4A4.0045 4.0045 0 0110 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 3z"
    })), children);
  });
  var Network_120 = /*#__PURE__*/React__default['default'].forwardRef(function Network_120(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$b || (_path343$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a4 4 0 114-4A4.0045 4.0045 0 0116 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 14zM5 20a4 4 0 114-4A4.0045 4.0045 0 015 20zm0-6a2 2 0 102 2A2.0023 2.0023 0 005 14zM10 31a4 4 0 114-4A4.0045 4.0045 0 0110 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 25zM22 31a4 4 0 114-4A4.0045 4.0045 0 0122 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 25zM27 20a4 4 0 114-4A4.0045 4.0045 0 0127 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0027 14zM22 9a4 4 0 114-4A4.0045 4.0045 0 0122 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 3zM10 9a4 4 0 114-4A4.0045 4.0045 0 0110 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 3z"
    })), children);
  });
  var Network_116 = /*#__PURE__*/React__default['default'].forwardRef(function Network_116(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$b || (_path344$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a4 4 0 114-4A4.0045 4.0045 0 0116 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0016 14zM5 20a4 4 0 114-4A4.0045 4.0045 0 015 20zm0-6a2 2 0 102 2A2.0023 2.0023 0 005 14zM10 31a4 4 0 114-4A4.0045 4.0045 0 0110 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 25zM22 31a4 4 0 114-4A4.0045 4.0045 0 0122 31zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 25zM27 20a4 4 0 114-4A4.0045 4.0045 0 0127 20zm0-6a2 2 0 102 2A2.0021 2.0021 0 0027 14zM22 9a4 4 0 114-4A4.0045 4.0045 0 0122 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0022 3zM10 9a4 4 0 114-4A4.0045 4.0045 0 0110 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 3z"
    })), children);
  });
  var Network_232 = /*#__PURE__*/React__default['default'].forwardRef(function Network_232(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$b || (_path345$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"
    })), children);
  });
  var Network_224 = /*#__PURE__*/React__default['default'].forwardRef(function Network_224(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$b || (_path346$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"
    })), children);
  });
  var Network_220 = /*#__PURE__*/React__default['default'].forwardRef(function Network_220(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$b || (_path347$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"
    })), children);
  });
  var Network_216 = /*#__PURE__*/React__default['default'].forwardRef(function Network_216(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$b || (_path348$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"
    })), children);
  });
  var Network_332 = /*#__PURE__*/React__default['default'].forwardRef(function Network_332(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$b || (_path349$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15h2v2H8a4 4 0 000 8H20z"
    })), _path350$b || (_path350$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20H12V12h8Zm-6-2h4V14H14Z"
    })), _path351$b || (_path351$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_324 = /*#__PURE__*/React__default['default'].forwardRef(function Network_324(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$b || (_path352$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15h2v2H8a4 4 0 000 8H20z"
    })), _path353$b || (_path353$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20H12V12h8Zm-6-2h4V14H14Z"
    })), _path354$b || (_path354$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_320 = /*#__PURE__*/React__default['default'].forwardRef(function Network_320(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$a || (_path355$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15h2v2H8a4 4 0 000 8H20z"
    })), _path356$a || (_path356$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20H12V12h8Zm-6-2h4V14H14Z"
    })), _path357$a || (_path357$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_316 = /*#__PURE__*/React__default['default'].forwardRef(function Network_316(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$a || (_path358$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 018 15h2v2H8a4 4 0 000 8H20z"
    })), _path359$a || (_path359$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20H12V12h8Zm-6-2h4V14H14Z"
    })), _path360$a || (_path360$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });

  var _path$c, _path2$c, _path3$c, _path4$c, _path5$c, _path6$c, _path7$c, _path8$c, _circle$b, _circle2$b, _circle3$b, _path9$c, _circle4$a, _circle5$9, _circle6$9, _path10$c, _circle7$9, _circle8$9, _circle9$9, _path11$c, _circle10$9, _circle11$8, _circle12$8, _path12$c, _circle13$8, _path13$c, _circle14$8, _circle15$8, _path14$c, _circle16$8, _path15$c, _circle17$7, _circle18$7, _path16$c, _circle19$7, _path17$c, _circle20$7, _circle21$7, _path18$c, _circle22$7, _path19$c, _circle23$7, _circle24$7, _path20$c, _path21$c, _path22$c, _path23$c, _path24$c, _path25$c, _path26$c, _path27$c, _path28$c, _path29$c, _path30$c, _path31$c, _path32$c, _path33$c, _path34$c, _path35$c, _path36$c, _path37$c, _path38$c, _path39$c, _path40$c, _path41$c, _path42$c, _path43$c, _path44$c, _path45$c, _path46$c, _path47$c, _path48$c, _path49$c, _path50$c, _path51$c, _path52$c, _path53$c, _path54$c, _path55$c, _path56$c, _path57$c, _path58$c, _path59$c, _path60$c, _path61$c, _path62$c, _path63$c, _path64$c, _path65$c, _path66$c, _path67$c, _path68$c, _path69$c, _path70$c, _path71$c, _path72$c, _path73$c, _path74$c, _path75$c, _path76$c, _path77$c, _path78$c, _path79$c, _path80$c, _path81$c, _path82$c, _path83$c, _path84$c, _path85$c, _path86$c, _path87$c, _path88$c, _path89$c, _path90$c, _path91$c, _path92$c, _path93$c, _path94$c, _path95$c, _path96$c, _path97$c, _path98$c, _path99$c, _path100$c, _path101$c, _path102$c, _path103$c, _path104$c, _path105$c, _path106$c, _path107$c, _path108$c, _path109$c, _path110$c, _path111$c, _path112$c, _path113$c, _path114$c, _path115$c, _path116$c, _path117$c, _path118$c, _path119$c, _path120$c, _path121$c, _path122$c, _path123$c, _path124$c, _path125$c, _path126$c, _path127$c, _path128$c, _path129$c, _path130$c, _path131$c, _path132$c, _path133$c, _path134$c, _path135$c, _path136$c, _path137$c, _path138$c, _path139$c, _path140$c, _path141$c, _path142$c, _path143$c, _path144$c, _path145$c, _path146$c, _path147$c, _path148$c, _path149$c, _path150$c, _path151$c, _path152$c, _circle25$6, _path153$c, _circle26$6, _path154$c, _circle27$6, _path155$c, _circle28$6, _path156$c, _path157$c, _path158$c, _path159$c, _path160$c, _path161$c, _path162$c, _path163$c, _path164$c, _path165$c, _path166$c, _path167$c, _path168$c, _path169$c, _path170$c, _path171$c, _path172$c, _path173$c, _path174$c, _path175$c, _path176$c, _path177$b, _path178$b, _path179$b, _path180$b, _path181$b, _path182$b, _path183$b, _path184$b, _path185$b, _path186$b, _path187$b, _path188$b, _path189$b, _path190$b, _path191$b, _path192$b, _path193$b, _path194$b, _path195$b, _path196$b, _path197$b, _path198$b, _path199$b, _path200$b, _path201$b, _path202$b, _path203$b, _path204$b, _path205$b, _path206$b, _path207$b, _path208$b, _path209$b, _path210$b, _path211$b, _path212$b, _path213$b, _path214$b, _path215$b, _path216$b, _path217$b, _path218$b, _path219$b, _path220$b, _path221$b, _path222$b, _path223$b, _path224$b, _path225$b, _path226$b, _path227$b, _path228$b, _path229$b, _path230$b, _path231$b, _path232$b, _path233$b, _path234$b, _path235$b, _path236$b, _path237$b, _path238$b, _path239$b, _path240$b, _path241$b, _path242$b, _path243$b, _path244$b, _path245$b, _path246$b, _path247$b, _path248$b, _circle29$6, _path249$b, _path250$b, _circle30$6, _path251$b, _path252$b, _circle31$6, _path253$b, _path254$b, _circle32$6, _path255$b, _path256$b, _circle33$6, _path257$b, _path258$b, _circle34$5, _path259$b, _path260$b, _circle35$5, _path261$b, _path262$b, _circle36$5, _path263$b, _path264$b, _circle37$4, _circle38$4, _circle39$4, _path265$b, _path266$b, _path267$b, _circle40$4, _circle41$4, _circle42$4, _path268$b, _path269$b, _path270$b, _circle43$4, _circle44$4, _circle45$4, _path271$b, _path272$b, _path273$b, _circle46$4, _circle47$4, _circle48$4, _path274$b, _path275$b, _path276$b, _path277$b, _path278$b, _path279$b, _path280$b, _path281$b, _path282$b, _path283$b, _path284$b, _path285$b, _path286$b, _path287$b, _path288$b, _path289$b, _path290$b, _path291$b, _path292$b, _path293$b, _path294$b, _path295$b, _path296$b, _path297$b, _path298$b, _path299$b, _path300$b, _path301$b, _path302$b, _path303$b, _path304$b, _path305$b, _path306$b, _path307$b, _path308$b, _path309$b, _path310$b, _path311$b, _path312$b, _path313$b, _path314$b, _path315$b, _path316$b, _path317$b, _path318$b, _path319$b, _path320$b, _path321$b, _path322$b, _path323$b, _path324$b, _path325$b, _path326$b, _path327$b, _path328$b, _path329$b, _path330$b, _path331$b, _path332$b, _path333$b, _path334$b, _path335$b, _path336$b, _path337$b;

  var _excluded$c = ["children"],
      _excluded2$c = ["children"],
      _excluded3$c = ["children"],
      _excluded4$c = ["children"],
      _excluded5$c = ["children"],
      _excluded6$c = ["children"],
      _excluded7$c = ["children"],
      _excluded8$c = ["children"],
      _excluded9$c = ["children"],
      _excluded10$c = ["children"],
      _excluded11$c = ["children"],
      _excluded12$c = ["children"],
      _excluded13$c = ["children"],
      _excluded14$c = ["children"],
      _excluded15$c = ["children"],
      _excluded16$c = ["children"],
      _excluded17$c = ["children"],
      _excluded18$c = ["children"],
      _excluded19$c = ["children"],
      _excluded20$c = ["children"],
      _excluded21$c = ["children"],
      _excluded22$c = ["children"],
      _excluded23$c = ["children"],
      _excluded24$c = ["children"],
      _excluded25$c = ["children"],
      _excluded26$c = ["children"],
      _excluded27$c = ["children"],
      _excluded28$c = ["children"],
      _excluded29$c = ["children"],
      _excluded30$c = ["children"],
      _excluded31$c = ["children"],
      _excluded32$c = ["children"],
      _excluded33$c = ["children"],
      _excluded34$c = ["children"],
      _excluded35$c = ["children"],
      _excluded36$c = ["children"],
      _excluded37$c = ["children"],
      _excluded38$c = ["children"],
      _excluded39$c = ["children"],
      _excluded40$c = ["children"],
      _excluded41$c = ["children"],
      _excluded42$c = ["children"],
      _excluded43$c = ["children"],
      _excluded44$c = ["children"],
      _excluded45$c = ["children"],
      _excluded46$c = ["children"],
      _excluded47$c = ["children"],
      _excluded48$c = ["children"],
      _excluded49$c = ["children"],
      _excluded50$c = ["children"],
      _excluded51$c = ["children"],
      _excluded52$c = ["children"],
      _excluded53$c = ["children"],
      _excluded54$c = ["children"],
      _excluded55$c = ["children"],
      _excluded56$c = ["children"],
      _excluded57$c = ["children"],
      _excluded58$c = ["children"],
      _excluded59$c = ["children"],
      _excluded60$c = ["children"],
      _excluded61$c = ["children"],
      _excluded62$c = ["children"],
      _excluded63$c = ["children"],
      _excluded64$c = ["children"],
      _excluded65$c = ["children"],
      _excluded66$c = ["children"],
      _excluded67$c = ["children"],
      _excluded68$c = ["children"],
      _excluded69$c = ["children"],
      _excluded70$c = ["children"],
      _excluded71$c = ["children"],
      _excluded72$c = ["children"],
      _excluded73$c = ["children"],
      _excluded74$c = ["children"],
      _excluded75$c = ["children"],
      _excluded76$c = ["children"],
      _excluded77$c = ["children"],
      _excluded78$c = ["children"],
      _excluded79$c = ["children"],
      _excluded80$c = ["children"],
      _excluded81$c = ["children"],
      _excluded82$c = ["children"],
      _excluded83$c = ["children"],
      _excluded84$c = ["children"],
      _excluded85$c = ["children"],
      _excluded86$c = ["children"],
      _excluded87$c = ["children"],
      _excluded88$c = ["children"],
      _excluded89$c = ["children"],
      _excluded90$c = ["children"],
      _excluded91$c = ["children"],
      _excluded92$c = ["children"],
      _excluded93$c = ["children"],
      _excluded94$c = ["children"],
      _excluded95$c = ["children"],
      _excluded96$c = ["children"],
      _excluded97$c = ["children"],
      _excluded98$c = ["children"],
      _excluded99$c = ["children"],
      _excluded100$c = ["children"],
      _excluded101$c = ["children"],
      _excluded102$c = ["children"],
      _excluded103$c = ["children"],
      _excluded104$c = ["children"],
      _excluded105$c = ["children"],
      _excluded106$c = ["children"],
      _excluded107$c = ["children"],
      _excluded108$c = ["children"],
      _excluded109$c = ["children"],
      _excluded110$c = ["children"],
      _excluded111$c = ["children"],
      _excluded112$c = ["children"],
      _excluded113$c = ["children"],
      _excluded114$c = ["children"],
      _excluded115$c = ["children"],
      _excluded116$c = ["children"],
      _excluded117$c = ["children"],
      _excluded118$c = ["children"],
      _excluded119$b = ["children"],
      _excluded120$b = ["children"],
      _excluded121$b = ["children"],
      _excluded122$b = ["children"],
      _excluded123$b = ["children"],
      _excluded124$b = ["children"],
      _excluded125$b = ["children"],
      _excluded126$b = ["children"],
      _excluded127$b = ["children"],
      _excluded128$b = ["children"],
      _excluded129$b = ["children"],
      _excluded130$b = ["children"],
      _excluded131$b = ["children"],
      _excluded132$b = ["children"],
      _excluded133$b = ["children"],
      _excluded134$b = ["children"],
      _excluded135$b = ["children"],
      _excluded136$b = ["children"],
      _excluded137$b = ["children"],
      _excluded138$b = ["children"],
      _excluded139$b = ["children"],
      _excluded140$b = ["children"],
      _excluded141$b = ["children"],
      _excluded142$b = ["children"],
      _excluded143$b = ["children"],
      _excluded144$b = ["children"],
      _excluded145$b = ["children"],
      _excluded146$b = ["children"],
      _excluded147$b = ["children"],
      _excluded148$b = ["children"],
      _excluded149$b = ["children"],
      _excluded150$b = ["children"],
      _excluded151$b = ["children"],
      _excluded152$b = ["children"],
      _excluded153$b = ["children"],
      _excluded154$b = ["children"],
      _excluded155$b = ["children"],
      _excluded156$b = ["children"],
      _excluded157$b = ["children"],
      _excluded158$b = ["children"],
      _excluded159$b = ["children"],
      _excluded160$b = ["children"],
      _excluded161$b = ["children"],
      _excluded162$b = ["children"],
      _excluded163$b = ["children"],
      _excluded164$b = ["children"],
      _excluded165$b = ["children"],
      _excluded166$b = ["children"],
      _excluded167$b = ["children"],
      _excluded168$b = ["children"],
      _excluded169$b = ["children"],
      _excluded170$b = ["children"],
      _excluded171$b = ["children"],
      _excluded172$b = ["children"],
      _excluded173$b = ["children"],
      _excluded174$b = ["children"],
      _excluded175$b = ["children"],
      _excluded176$b = ["children"],
      _excluded177$b = ["children"],
      _excluded178$b = ["children"],
      _excluded179$b = ["children"],
      _excluded180$b = ["children"],
      _excluded181$b = ["children"],
      _excluded182$b = ["children"],
      _excluded183$b = ["children"],
      _excluded184$b = ["children"],
      _excluded185$b = ["children"],
      _excluded186$b = ["children"],
      _excluded187$b = ["children"],
      _excluded188$b = ["children"],
      _excluded189$b = ["children"],
      _excluded190$b = ["children"],
      _excluded191$b = ["children"],
      _excluded192$b = ["children"],
      _excluded193$b = ["children"],
      _excluded194$b = ["children"],
      _excluded195$b = ["children"],
      _excluded196$b = ["children"],
      _excluded197$b = ["children"],
      _excluded198$b = ["children"],
      _excluded199$b = ["children"],
      _excluded200$b = ["children"],
      _excluded201$b = ["children"],
      _excluded202$b = ["children"],
      _excluded203$b = ["children"],
      _excluded204$b = ["children"],
      _excluded205$b = ["children"],
      _excluded206$b = ["children"],
      _excluded207$b = ["children"],
      _excluded208$b = ["children"],
      _excluded209$b = ["children"],
      _excluded210$b = ["children"],
      _excluded211$b = ["children"],
      _excluded212$b = ["children"],
      _excluded213$b = ["children"],
      _excluded214$b = ["children"],
      _excluded215$b = ["children"],
      _excluded216$b = ["children"],
      _excluded217$b = ["children"],
      _excluded218$b = ["children"],
      _excluded219$b = ["children"],
      _excluded220$b = ["children"],
      _excluded221$b = ["children"],
      _excluded222$b = ["children"],
      _excluded223$b = ["children"],
      _excluded224$b = ["children"],
      _excluded225$b = ["children"],
      _excluded226$b = ["children"],
      _excluded227$b = ["children"],
      _excluded228$b = ["children"],
      _excluded229$b = ["children"],
      _excluded230$b = ["children"],
      _excluded231$b = ["children"],
      _excluded232$b = ["children"],
      _excluded233$b = ["children"],
      _excluded234$b = ["children"],
      _excluded235$b = ["children"],
      _excluded236$b = ["children"],
      _excluded237$b = ["children"],
      _excluded238$b = ["children"],
      _excluded239$b = ["children"],
      _excluded240$b = ["children"],
      _excluded241$b = ["children"],
      _excluded242$b = ["children"],
      _excluded243$b = ["children"],
      _excluded244$b = ["children"],
      _excluded245$b = ["children"],
      _excluded246$b = ["children"],
      _excluded247$b = ["children"],
      _excluded248$b = ["children"],
      _excluded249$b = ["children"],
      _excluded250$b = ["children"];
  var Network_3Reference32 = /*#__PURE__*/React__default['default'].forwardRef(function Network_3Reference32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$c || (_path$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 30H22V22h8zm-6-2h4V24H24zM20 20H12V12h8zm-6-2h4V14H14z"
    })), _path2$c || (_path2$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_3Reference24 = /*#__PURE__*/React__default['default'].forwardRef(function Network_3Reference24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$c || (_path3$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 30H22V22h8zm-6-2h4V24H24zM20 20H12V12h8zm-6-2h4V14H14z"
    })), _path4$c || (_path4$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_3Reference20 = /*#__PURE__*/React__default['default'].forwardRef(function Network_3Reference20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$c || (_path5$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 30H22V22h8zm-6-2h4V24H24zM20 20H12V12h8zm-6-2h4V14H14z"
    })), _path6$c || (_path6$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_3Reference16 = /*#__PURE__*/React__default['default'].forwardRef(function Network_3Reference16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$c || (_path7$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM30 30H22V22h8zm-6-2h4V24H24zM20 20H12V12h8zm-6-2h4V14H14z"
    })), _path8$c || (_path8$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 17H22V15h2a4 4 0 000-8H12V5H24a6 6 0 010 12zM10 10H2V2h8zM4 8H8V4H4z"
    })), children);
  });
  var Network_432 = /*#__PURE__*/React__default['default'].forwardRef(function Network_432(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$b || (_circle$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _circle2$b || (_circle2$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle3$b || (_circle3$b = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path9$c || (_path9$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_424 = /*#__PURE__*/React__default['default'].forwardRef(function Network_424(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$a || (_circle4$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _circle5$9 || (_circle5$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle6$9 || (_circle6$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path10$c || (_path10$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_420 = /*#__PURE__*/React__default['default'].forwardRef(function Network_420(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$9 || (_circle7$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _circle8$9 || (_circle8$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle9$9 || (_circle9$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path11$c || (_path11$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_416 = /*#__PURE__*/React__default['default'].forwardRef(function Network_416(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$9 || (_circle10$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _circle11$8 || (_circle11$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle12$8 || (_circle12$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path12$c || (_path12$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_4Reference32 = /*#__PURE__*/React__default['default'].forwardRef(function Network_4Reference32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$8 || (_circle13$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _path13$c || (_path13$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _circle14$8 || (_circle14$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle15$8 || (_circle15$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path14$c || (_path14$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9624,3.9624,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97A3.9613,3.9613,0,0,0,12,16a3.9915,3.9915,0,0,0,7.8579,1h4.2842A3.9934,3.9934,0,1,0,28,12ZM8,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,8Zm8,10a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_4Reference24 = /*#__PURE__*/React__default['default'].forwardRef(function Network_4Reference24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$8 || (_circle16$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _path15$c || (_path15$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _circle17$7 || (_circle17$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle18$7 || (_circle18$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path16$c || (_path16$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9624,3.9624,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97A3.9613,3.9613,0,0,0,12,16a3.9915,3.9915,0,0,0,7.8579,1h4.2842A3.9934,3.9934,0,1,0,28,12ZM8,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,8Zm8,10a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_4Reference20 = /*#__PURE__*/React__default['default'].forwardRef(function Network_4Reference20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$7 || (_circle19$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _path17$c || (_path17$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _circle20$7 || (_circle20$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle21$7 || (_circle21$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path18$c || (_path18$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9624,3.9624,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97A3.9613,3.9613,0,0,0,12,16a3.9915,3.9915,0,0,0,7.8579,1h4.2842A3.9934,3.9934,0,1,0,28,12ZM8,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,8Zm8,10a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var Network_4Reference16 = /*#__PURE__*/React__default['default'].forwardRef(function Network_4Reference16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22$7 || (_circle22$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "26",
      r: "2"
    })), _path19$c || (_path19$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20z"
    })), _circle23$7 || (_circle23$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "6",
      r: "2"
    })), _circle24$7 || (_circle24$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "16",
      r: "2"
    })), _path20$c || (_path20$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9624,3.9624,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97A3.9613,3.9613,0,0,0,12,16a3.9915,3.9915,0,0,0,7.8579,1h4.2842A3.9934,3.9934,0,1,0,28,12ZM8,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,8Zm8,10a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"
    })), children);
  });
  var NetworkAdminControl32 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkAdminControl32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$c || (_path21$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.415L25.586 19 23 21.587 20.414 19 19 20.415 21.586 23 19 25.586 20.414 27 23 24.414 25.586 27 27 25.586 24.414 23 27 20.415zM24 4a4.0045 4.0045 0 00-4 4 3.951 3.951 0 00.5669 2.019L10.019 20.5669A3.9521 3.9521 0 008 20a4 4 0 104 4 3.951 3.951 0 00-.5669-2.019L21.981 11.4331A3.9521 3.9521 0 0024 12a4 4 0 000-8zM8 26a2 2 0 112-2A2.0023 2.0023 0 018 26zM24 10a2 2 0 112-2A2.0023 2.0023 0 0124 10zM8 11.18L5.41 8.59 4 10 8 14 15 7 13.59 5.59 8 11.18z"
    })), children);
  });
  var NetworkAdminControl24 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkAdminControl24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$c || (_path22$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.415L25.586 19 23 21.587 20.414 19 19 20.415 21.586 23 19 25.586 20.414 27 23 24.414 25.586 27 27 25.586 24.414 23 27 20.415zM24 4a4.0045 4.0045 0 00-4 4 3.951 3.951 0 00.5669 2.019L10.019 20.5669A3.9521 3.9521 0 008 20a4 4 0 104 4 3.951 3.951 0 00-.5669-2.019L21.981 11.4331A3.9521 3.9521 0 0024 12a4 4 0 000-8zM8 26a2 2 0 112-2A2.0023 2.0023 0 018 26zM24 10a2 2 0 112-2A2.0023 2.0023 0 0124 10zM8 11.18L5.41 8.59 4 10 8 14 15 7 13.59 5.59 8 11.18z"
    })), children);
  });
  var NetworkAdminControl20 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkAdminControl20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$c || (_path23$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.415L25.586 19 23 21.587 20.414 19 19 20.415 21.586 23 19 25.586 20.414 27 23 24.414 25.586 27 27 25.586 24.414 23 27 20.415zM24 4a4.0045 4.0045 0 00-4 4 3.951 3.951 0 00.5669 2.019L10.019 20.5669A3.9521 3.9521 0 008 20a4 4 0 104 4 3.951 3.951 0 00-.5669-2.019L21.981 11.4331A3.9521 3.9521 0 0024 12a4 4 0 000-8zM8 26a2 2 0 112-2A2.0023 2.0023 0 018 26zM24 10a2 2 0 112-2A2.0023 2.0023 0 0124 10zM8 11.18L5.41 8.59 4 10 8 14 15 7 13.59 5.59 8 11.18z"
    })), children);
  });
  var NetworkAdminControl16 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkAdminControl16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$c || (_path24$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 20.415L25.586 19 23 21.587 20.414 19 19 20.415 21.586 23 19 25.586 20.414 27 23 24.414 25.586 27 27 25.586 24.414 23 27 20.415zM24 4a4.0045 4.0045 0 00-4 4 3.951 3.951 0 00.5669 2.019L10.019 20.5669A3.9521 3.9521 0 008 20a4 4 0 104 4 3.951 3.951 0 00-.5669-2.019L21.981 11.4331A3.9521 3.9521 0 0024 12a4 4 0 000-8zM8 26a2 2 0 112-2A2.0023 2.0023 0 018 26zM24 10a2 2 0 112-2A2.0023 2.0023 0 0124 10zM8 11.18L5.41 8.59 4 10 8 14 15 7 13.59 5.59 8 11.18z"
    })), children);
  });
  var NetworkEnterprise32 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkEnterprise32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$c || (_path25$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,23.7368,10Z"
    })), _path26$c || (_path26$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H18a2.0023,2.0023,0,0,0-2,2v4H12a2.0023,2.0023,0,0,0-2,2V30H30V14A2.0023,2.0023,0,0,0,28,12ZM12,28V20h4v8Zm16,0H18V14H28Z"
    })), _path27$c || (_path27$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 16H22V20H20zM24 16H26V20H24zM20 22H22V26H20zM24 22H26V26H24z"
    })), children);
  });
  var NetworkEnterprise24 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkEnterprise24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$c || (_path28$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,23.7368,10Z"
    })), _path29$c || (_path29$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H18a2.0023,2.0023,0,0,0-2,2v4H12a2.0023,2.0023,0,0,0-2,2V30H30V14A2.0023,2.0023,0,0,0,28,12ZM12,28V20h4v8Zm16,0H18V14H28Z"
    })), _path30$c || (_path30$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 16H22V20H20zM24 16H26V20H24zM20 22H22V26H20zM24 22H26V26H24z"
    })), children);
  });
  var NetworkEnterprise20 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkEnterprise20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$c || (_path31$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,23.7368,10Z"
    })), _path32$c || (_path32$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H18a2.0023,2.0023,0,0,0-2,2v4H12a2.0023,2.0023,0,0,0-2,2V30H30V14A2.0023,2.0023,0,0,0,28,12ZM12,28V20h4v8Zm16,0H18V14H28Z"
    })), _path33$c || (_path33$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 16H22V20H20zM24 16H26V20H24zM20 22H22V26H20zM24 22H26V26H24z"
    })), children);
  });
  var NetworkEnterprise16 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkEnterprise16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$c || (_path34$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7983,10a10,10,0,0,0-19.62.124A7.4964,7.4964,0,0,0,7.5,25H8V23H7.5a5.4961,5.4961,0,0,1-.377-10.9795l.8365-.0571.09-.8335A7.9934,7.9934,0,0,1,23.7368,10Z"
    })), _path35$c || (_path35$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H18a2.0023,2.0023,0,0,0-2,2v4H12a2.0023,2.0023,0,0,0-2,2V30H30V14A2.0023,2.0023,0,0,0,28,12ZM12,28V20h4v8Zm16,0H18V14H28Z"
    })), _path36$c || (_path36$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 16H22V20H20zM24 16H26V20H24zM20 22H22V26H20zM24 22H26V26H24z"
    })), children);
  });
  var NetworkOverlay32 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkOverlay32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$c || (_path37$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23L13.83 23 16.41 20.41 15 19 10 24 15 29 16.41 27.59 13.83 25 22 25 22 23zM11 13L19.17 13 16.59 10.41 18 9 23 14 18 19 16.59 17.59 19.17 15 11 15 11 13z"
    })), _path38$c || (_path38$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var NetworkOverlay24 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkOverlay24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$c || (_path39$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23L13.83 23 16.41 20.41 15 19 10 24 15 29 16.41 27.59 13.83 25 22 25 22 23zM11 13L19.17 13 16.59 10.41 18 9 23 14 18 19 16.59 17.59 19.17 15 11 15 11 13z"
    })), _path40$c || (_path40$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var NetworkOverlay20 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkOverlay20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$c || (_path41$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23L13.83 23 16.41 20.41 15 19 10 24 15 29 16.41 27.59 13.83 25 22 25 22 23zM11 13L19.17 13 16.59 10.41 18 9 23 14 18 19 16.59 17.59 19.17 15 11 15 11 13z"
    })), _path42$c || (_path42$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var NetworkOverlay16 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkOverlay16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$c || (_path43$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 23L13.83 23 16.41 20.41 15 19 10 24 15 29 16.41 27.59 13.83 25 22 25 22 23zM11 13L19.17 13 16.59 10.41 18 9 23 14 18 19 16.59 17.59 19.17 15 11 15 11 13z"
    })), _path44$c || (_path44$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,25H24V23h.5a5.4961,5.4961,0,0,0,.377-10.9795l-.8365-.0566-.09-.834a7.9979,7.9979,0,0,0-15.9014,0l-.09.834-.8365.0566A5.4961,5.4961,0,0,0,7.5,23H8v2H7.5A7.4964,7.4964,0,0,1,6.1782,10.124a9.9992,9.9992,0,0,1,19.6436,0A7.4964,7.4964,0,0,1,24.5,25Z"
    })), children);
  });
  var NetworkPublic32 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkPublic32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$c || (_path45$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,13c-4.7,0-8.5,3.8-8.5,8.5s3.8,8.5,8.5,8.5s8.5-3.8,8.5-8.5S27.2,13,22.5,13z M29,21h-3c0-2-0.3-4-0.9-5.5\tC27.2,16.5,28.8,18.5,29,21z M22.5,28C22.5,28,22.5,28,22.5,28c-0.4-0.2-1.3-1.8-1.5-5h2.9C23.7,26.2,22.9,27.8,22.5,28z M21,21\tc0.1-3.8,1.1-5.8,1.4-6c0,0,0,0,0,0c0.4,0.2,1.4,2.2,1.5,6H21z M19.9,15.5C19.3,17,19.1,19,19,21h-3C16.2,18.5,17.8,16.5,19.9,15.5z M16.2,23H19c0.1,1.6,0.4,3.2,0.9,4.5C18.1,26.7,16.7,25,16.2,23z M25.1,27.5c0.5-1.3,0.8-2.8,0.9-4.5h2.9\tC28.3,25,26.9,26.7,25.1,27.5z"
    })), _path46$c || (_path46$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8,10c-0.9-4.6-5-8-9.8-8c-4.8,0-8.9,3.4-9.8,8.1C2.7,10.8,0,13.8,0,17.5C0,21.6,3.4,25,7.5,25H11v-2H7.5\tc-3,0-5.5-2.5-5.5-5.5c0-2.9,2.2-5.3,5.1-5.5L8,12L8,11.1C8.5,7.1,11.9,4,16,4c3.7,0,6.8,2.6,7.7,6H25.8z"
    })), children);
  });
  var NetworkPublic24 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkPublic24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$c || (_path47$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,13c-4.7,0-8.5,3.8-8.5,8.5s3.8,8.5,8.5,8.5s8.5-3.8,8.5-8.5S27.2,13,22.5,13z M29,21h-3c0-2-0.3-4-0.9-5.5\tC27.2,16.5,28.8,18.5,29,21z M22.5,28C22.5,28,22.5,28,22.5,28c-0.4-0.2-1.3-1.8-1.5-5h2.9C23.7,26.2,22.9,27.8,22.5,28z M21,21\tc0.1-3.8,1.1-5.8,1.4-6c0,0,0,0,0,0c0.4,0.2,1.4,2.2,1.5,6H21z M19.9,15.5C19.3,17,19.1,19,19,21h-3C16.2,18.5,17.8,16.5,19.9,15.5z M16.2,23H19c0.1,1.6,0.4,3.2,0.9,4.5C18.1,26.7,16.7,25,16.2,23z M25.1,27.5c0.5-1.3,0.8-2.8,0.9-4.5h2.9\tC28.3,25,26.9,26.7,25.1,27.5z"
    })), _path48$c || (_path48$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8,10c-0.9-4.6-5-8-9.8-8c-4.8,0-8.9,3.4-9.8,8.1C2.7,10.8,0,13.8,0,17.5C0,21.6,3.4,25,7.5,25H11v-2H7.5\tc-3,0-5.5-2.5-5.5-5.5c0-2.9,2.2-5.3,5.1-5.5L8,12L8,11.1C8.5,7.1,11.9,4,16,4c3.7,0,6.8,2.6,7.7,6H25.8z"
    })), children);
  });
  var NetworkPublic20 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkPublic20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$c || (_path49$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,13c-4.7,0-8.5,3.8-8.5,8.5s3.8,8.5,8.5,8.5s8.5-3.8,8.5-8.5S27.2,13,22.5,13z M29,21h-3c0-2-0.3-4-0.9-5.5\tC27.2,16.5,28.8,18.5,29,21z M22.5,28C22.5,28,22.5,28,22.5,28c-0.4-0.2-1.3-1.8-1.5-5h2.9C23.7,26.2,22.9,27.8,22.5,28z M21,21\tc0.1-3.8,1.1-5.8,1.4-6c0,0,0,0,0,0c0.4,0.2,1.4,2.2,1.5,6H21z M19.9,15.5C19.3,17,19.1,19,19,21h-3C16.2,18.5,17.8,16.5,19.9,15.5z M16.2,23H19c0.1,1.6,0.4,3.2,0.9,4.5C18.1,26.7,16.7,25,16.2,23z M25.1,27.5c0.5-1.3,0.8-2.8,0.9-4.5h2.9\tC28.3,25,26.9,26.7,25.1,27.5z"
    })), _path50$c || (_path50$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8,10c-0.9-4.6-5-8-9.8-8c-4.8,0-8.9,3.4-9.8,8.1C2.7,10.8,0,13.8,0,17.5C0,21.6,3.4,25,7.5,25H11v-2H7.5\tc-3,0-5.5-2.5-5.5-5.5c0-2.9,2.2-5.3,5.1-5.5L8,12L8,11.1C8.5,7.1,11.9,4,16,4c3.7,0,6.8,2.6,7.7,6H25.8z"
    })), children);
  });
  var NetworkPublic16 = /*#__PURE__*/React__default['default'].forwardRef(function NetworkPublic16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$c || (_path51$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,13c-4.7,0-8.5,3.8-8.5,8.5s3.8,8.5,8.5,8.5s8.5-3.8,8.5-8.5S27.2,13,22.5,13z M29,21h-3c0-2-0.3-4-0.9-5.5\tC27.2,16.5,28.8,18.5,29,21z M22.5,28C22.5,28,22.5,28,22.5,28c-0.4-0.2-1.3-1.8-1.5-5h2.9C23.7,26.2,22.9,27.8,22.5,28z M21,21\tc0.1-3.8,1.1-5.8,1.4-6c0,0,0,0,0,0c0.4,0.2,1.4,2.2,1.5,6H21z M19.9,15.5C19.3,17,19.1,19,19,21h-3C16.2,18.5,17.8,16.5,19.9,15.5z M16.2,23H19c0.1,1.6,0.4,3.2,0.9,4.5C18.1,26.7,16.7,25,16.2,23z M25.1,27.5c0.5-1.3,0.8-2.8,0.9-4.5h2.9\tC28.3,25,26.9,26.7,25.1,27.5z"
    })), _path52$c || (_path52$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8,10c-0.9-4.6-5-8-9.8-8c-4.8,0-8.9,3.4-9.8,8.1C2.7,10.8,0,13.8,0,17.5C0,21.6,3.4,25,7.5,25H11v-2H7.5\tc-3,0-5.5-2.5-5.5-5.5c0-2.9,2.2-5.3,5.1-5.5L8,12L8,11.1C8.5,7.1,11.9,4,16,4c3.7,0,6.8,2.6,7.7,6H25.8z"
    })), children);
  });
  var NewTab32 = /*#__PURE__*/React__default['default'].forwardRef(function NewTab32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$c || (_path53$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"
    })), _path54$c || (_path54$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"
    })), _path55$c || (_path55$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var NewTab24 = /*#__PURE__*/React__default['default'].forwardRef(function NewTab24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$c || (_path56$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"
    })), _path57$c || (_path57$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"
    })), _path58$c || (_path58$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var NewTab20 = /*#__PURE__*/React__default['default'].forwardRef(function NewTab20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$c || (_path59$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"
    })), _path60$c || (_path60$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26H6V6H16V4H6A2.002,2.002,0,0,0,4,6V26a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16H26Z"
    })), _path61$c || (_path61$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"
    })), children);
  });
  var NewTab16 = /*#__PURE__*/React__default['default'].forwardRef(function NewTab16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$c || (_path62$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,13H3V3h5V2H3C2.4,2,2,2.4,2,3v10c0,0.6,0.4,1,1,1h10c0.6,0,1-0.4,1-1V8h-1V13z"
    })), _path63$c || (_path63$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 3L13 1 12 1 12 3 10 3 10 4 12 4 12 6 13 6 13 4 15 4 15 3z"
    })), children);
  });
  var NextFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function NextFilled32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$c || (_path64$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm6-1H20.15L14.57,9.3926,16,8l8,8-8,8-1.43-1.4272L20.15,17H8Z"
    })), _path65$c || (_path65$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var NextFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function NextFilled24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$c || (_path66$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm6-1H20.15L14.57,9.3926,16,8l8,8-8,8-1.43-1.4272L20.15,17H8Z"
    })), _path67$c || (_path67$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var NextFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function NextFilled20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$c || (_path68$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm6-1H20.15L14.57,9.3926,16,8l8,8-8,8-1.43-1.4272L20.15,17H8Z"
    })), _path69$c || (_path69$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var NextFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function NextFilled16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$c || (_path70$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,16A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm6-1H20.15L14.57,9.3926,16,8l8,8-8,8-1.43-1.4272L20.15,17H8Z"
    })), _path71$c || (_path71$c = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var NextOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function NextOutline32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$c || (_path72$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z"
    })), _path73$c || (_path73$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NextOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function NextOutline24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$c || (_path74$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z"
    })), _path75$c || (_path75$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NextOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function NextOutline20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$c || (_path76$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z"
    })), _path77$c || (_path77$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NextOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function NextOutline16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$c || (_path78$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L14.57 9.393 20.15 15 8 15 8 17 20.15 17 14.57 22.573 16 24 24 16 16 8z"
    })), _path79$c || (_path79$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var NoImage32 = /*#__PURE__*/React__default['default'].forwardRef(function NoImage32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$c || (_path80$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 002-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 002.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 00-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 00-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 004 6V22z"
    })), children);
  });
  var NoImage24 = /*#__PURE__*/React__default['default'].forwardRef(function NoImage24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$c || (_path81$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 002-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 002.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 00-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 00-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 004 6V22z"
    })), children);
  });
  var NoImage20 = /*#__PURE__*/React__default['default'].forwardRef(function NoImage20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$c || (_path82$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 002-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 002.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 00-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 00-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 004 6V22z"
    })), children);
  });
  var NoImage16 = /*#__PURE__*/React__default['default'].forwardRef(function NoImage16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$c || (_path83$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 002-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 002.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 00-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 00-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 004 6V22z"
    })), children);
  });
  var NoTicket32 = /*#__PURE__*/React__default['default'].forwardRef(function NoTicket32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$c || (_path84$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 002-2V19a1 1 0 00-1-1 2 2 0 010-4 1 1 0 001-1V8A2.0023 2.0023 0 0028 6zm0 6.1265a4 4 0 000 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 002 8v5a1 1 0 001 1 2 2 0 010 4 1 1 0 00-1 1v5H4V19.873a4 4 0 000-7.7465z"
    })), children);
  });
  var NoTicket24 = /*#__PURE__*/React__default['default'].forwardRef(function NoTicket24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$c || (_path85$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 002-2V19a1 1 0 00-1-1 2 2 0 010-4 1 1 0 001-1V8A2.0023 2.0023 0 0028 6zm0 6.1265a4 4 0 000 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 002 8v5a1 1 0 001 1 2 2 0 010 4 1 1 0 00-1 1v5H4V19.873a4 4 0 000-7.7465z"
    })), children);
  });
  var NoTicket20 = /*#__PURE__*/React__default['default'].forwardRef(function NoTicket20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$c || (_path86$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 002-2V19a1 1 0 00-1-1 2 2 0 010-4 1 1 0 001-1V8A2.0023 2.0023 0 0028 6zm0 6.1265a4 4 0 000 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 002 8v5a1 1 0 001 1 2 2 0 010 4 1 1 0 00-1 1v5H4V19.873a4 4 0 000-7.7465z"
    })), children);
  });
  var NoTicket16 = /*#__PURE__*/React__default['default'].forwardRef(function NoTicket16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$c || (_path87$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 002-2V19a1 1 0 00-1-1 2 2 0 010-4 1 1 0 001-1V8A2.0023 2.0023 0 0028 6zm0 6.1265a4 4 0 000 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 002 8v5a1 1 0 001 1 2 2 0 010 4 1 1 0 00-1 1v5H4V19.873a4 4 0 000-7.7465z"
    })), children);
  });
  var Nominal32 = /*#__PURE__*/React__default['default'].forwardRef(function Nominal32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$c || (_path88$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 28a6 6 0 116-6A6.0069 6.0069 0 0124 28zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 18zM8 28a6 6 0 116-6A6.0069 6.0069 0 018 28zM8 18a4 4 0 104 4A4.0045 4.0045 0 008 18zM16 14a6 6 0 116-6A6.0069 6.0069 0 0116 14zM16 4a4 4 0 104 4A4.0045 4.0045 0 0016 4z"
    })), children);
  });
  var Nominal24 = /*#__PURE__*/React__default['default'].forwardRef(function Nominal24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$c || (_path89$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 28a6 6 0 116-6A6.0069 6.0069 0 0124 28zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 18zM8 28a6 6 0 116-6A6.0069 6.0069 0 018 28zM8 18a4 4 0 104 4A4.0045 4.0045 0 008 18zM16 14a6 6 0 116-6A6.0069 6.0069 0 0116 14zM16 4a4 4 0 104 4A4.0045 4.0045 0 0016 4z"
    })), children);
  });
  var Nominal20 = /*#__PURE__*/React__default['default'].forwardRef(function Nominal20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$c || (_path90$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 28a6 6 0 116-6A6.0069 6.0069 0 0124 28zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 18zM8 28a6 6 0 116-6A6.0069 6.0069 0 018 28zM8 18a4 4 0 104 4A4.0045 4.0045 0 008 18zM16 14a6 6 0 116-6A6.0069 6.0069 0 0116 14zM16 4a4 4 0 104 4A4.0045 4.0045 0 0016 4z"
    })), children);
  });
  var Nominal16 = /*#__PURE__*/React__default['default'].forwardRef(function Nominal16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$c || (_path91$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,8 C13.6568542,8 15,9.34314575 15,11 C15,12.6568542 13.6568542,14 12,14 C10.3431458,14 9,12.6568542 9,11 C9,9.34314575 10.3431458,8 12,8 Z M4,8 C5.65685425,8 7,9.34314575 7,11 C7,12.6568542 5.65685425,14 4,14 C2.34314575,14 1,12.6568542 1,11 C1,9.34314575 2.34314575,8 4,8 Z M12,9 C10.8954305,9 10,9.8954305 10,11 C10,12.1045695 10.8954305,13 12,13 C13.1045695,13 14,12.1045695 14,11 C14,9.8954305 13.1045695,9 12,9 Z M4,9 C2.8954305,9 2,9.8954305 2,11 C2,12.1045695 2.8954305,13 4,13 C5.1045695,13 6,12.1045695 6,11 C6,9.8954305 5.1045695,9 4,9 Z M8,2 C9.65685425,2 11,3.34314575 11,5 C11,6.65685425 9.65685425,8 8,8 C6.34314575,8 5,6.65685425 5,5 C5,3.34314575 6.34314575,2 8,2 Z M8,3 C6.8954305,3 6,3.8954305 6,5 C6,6.1045695 6.8954305,7 8,7 C9.1045695,7 10,6.1045695 10,5 C10,3.8954305 9.1045695,3 8,3 Z"
    })), children);
  });
  var WatsonHealthNominate32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthNominate32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$c || (_path92$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"
    })), _path93$c || (_path93$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var WatsonHealthNominate24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthNominate24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$c || (_path94$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"
    })), _path95$c || (_path95$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var WatsonHealthNominate20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthNominate20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$c || (_path96$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"
    })), _path97$c || (_path97$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var WatsonHealthNominate16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthNominate16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$c || (_path98$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H19a3 3 0 00-3 3v2h2V26a1 1 0 011-1h6a1 1 0 011 1v2h2V26A3 3 0 0025 23zM18 18a4 4 0 104-4A4 4 0 0018 18zm6 0a2 2 0 11-2-2A2 2 0 0124 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"
    })), _path99$c || (_path99$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"
    })), children);
  });
  var NonCertified32 = /*#__PURE__*/React__default['default'].forwardRef(function NonCertified32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$c || (_path100$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H14V14H6zM6 16H10V18H6z"
    })), _path101$c || (_path101$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H7.4141L30,3.4141,28.5859,2l-2,2H4A2.0023,2.0023,0,0,0,2,6V22H4V6H24.5859L2,28.5859,3.4141,30l2-2H28a2.0023,2.0023,0,0,0,2-2V10H28Z"
    })), children);
  });
  var NonCertified24 = /*#__PURE__*/React__default['default'].forwardRef(function NonCertified24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$c || (_path102$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H14V14H6zM6 16H10V18H6z"
    })), _path103$c || (_path103$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H7.4141L30,3.4141,28.5859,2l-2,2H4A2.0023,2.0023,0,0,0,2,6V22H4V6H24.5859L2,28.5859,3.4141,30l2-2H28a2.0023,2.0023,0,0,0,2-2V10H28Z"
    })), children);
  });
  var NonCertified20 = /*#__PURE__*/React__default['default'].forwardRef(function NonCertified20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$c || (_path104$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H14V14H6zM6 16H10V18H6z"
    })), _path105$c || (_path105$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H7.4141L30,3.4141,28.5859,2l-2,2H4A2.0023,2.0023,0,0,0,2,6V22H4V6H24.5859L2,28.5859,3.4141,30l2-2H28a2.0023,2.0023,0,0,0,2-2V10H28Z"
    })), children);
  });
  var NonCertified16 = /*#__PURE__*/React__default['default'].forwardRef(function NonCertified16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$c || (_path106$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 8H16V10H6zM6 12H14V14H6zM6 16H10V18H6z"
    })), _path107$c || (_path107$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H7.4141L30,3.4141,28.5859,2l-2,2H4A2.0023,2.0023,0,0,0,2,6V22H4V6H24.5859L2,28.5859,3.4141,30l2-2H28a2.0023,2.0023,0,0,0,2-2V10H28Z"
    })), children);
  });
  var NoodleBowl32 = /*#__PURE__*/React__default['default'].forwardRef(function NoodleBowl32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$c || (_path108$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), _path109$c || (_path109$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"
    })), children);
  });
  var NoodleBowl24 = /*#__PURE__*/React__default['default'].forwardRef(function NoodleBowl24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$c || (_path110$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), _path111$c || (_path111$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"
    })), children);
  });
  var NoodleBowl20 = /*#__PURE__*/React__default['default'].forwardRef(function NoodleBowl20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$c || (_path112$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), _path113$c || (_path113$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"
    })), children);
  });
  var NoodleBowl16 = /*#__PURE__*/React__default['default'].forwardRef(function NoodleBowl16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$c || (_path114$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"
    })), _path115$c || (_path115$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"
    })), children);
  });
  var NotAvailable32 = /*#__PURE__*/React__default['default'].forwardRef(function NotAvailable32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$c || (_path116$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 15H14V17H4zM18 15H28V17H18z"
    })), children);
  });
  var NotAvailable24 = /*#__PURE__*/React__default['default'].forwardRef(function NotAvailable24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$c || (_path117$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 15H14V17H4zM18 15H28V17H18z"
    })), children);
  });
  var NotAvailable20 = /*#__PURE__*/React__default['default'].forwardRef(function NotAvailable20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$c || (_path118$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 15H14V17H4zM18 15H28V17H18z"
    })), children);
  });
  var NotAvailable16 = /*#__PURE__*/React__default['default'].forwardRef(function NotAvailable16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$c || (_path119$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 15H14V17H4zM18 15H28V17H18z"
    })), children);
  });
  var NotSent32 = /*#__PURE__*/React__default['default'].forwardRef(function NotSent32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$c || (_path120$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l9.6 3.84 3.84 9.6A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 00-1.28-1.28L14.13 9.89z"
    })), children);
  });
  var NotSent24 = /*#__PURE__*/React__default['default'].forwardRef(function NotSent24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$c || (_path121$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l9.6 3.84 3.84 9.6A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 00-1.28-1.28L14.13 9.89z"
    })), children);
  });
  var NotSent20 = /*#__PURE__*/React__default['default'].forwardRef(function NotSent20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$c || (_path122$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l9.6 3.84 3.84 9.6A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 00-1.28-1.28L14.13 9.89z"
    })), children);
  });
  var NotSent16 = /*#__PURE__*/React__default['default'].forwardRef(function NotSent16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$c || (_path123$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l9.6 3.84 3.84 9.6A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 00-1.28-1.28L14.13 9.89z"
    })), children);
  });
  var NotSentFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function NotSentFilled32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$c || (_path124$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 00-1.28-1.28L15.17 9.51z"
    })), children);
  });
  var NotSentFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function NotSentFilled24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$c || (_path125$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 00-1.28-1.28L15.17 9.51z"
    })), children);
  });
  var NotSentFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function NotSentFilled20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$c || (_path126$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 00-1.28-1.28L15.17 9.51z"
    })), children);
  });
  var NotSentFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function NotSentFilled16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$c || (_path127$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 000 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0017 30h0a1 1 0 00.92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 00-1.28-1.28L15.17 9.51z"
    })), children);
  });
  var Notebook32 = /*#__PURE__*/React__default['default'].forwardRef(function Notebook32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$c || (_path128$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path129$c || (_path129$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"
    })), children);
  });
  var Notebook24 = /*#__PURE__*/React__default['default'].forwardRef(function Notebook24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$c || (_path130$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path131$c || (_path131$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"
    })), children);
  });
  var Notebook20 = /*#__PURE__*/React__default['default'].forwardRef(function Notebook20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$c || (_path132$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path133$c || (_path133$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"
    })), children);
  });
  var Notebook16 = /*#__PURE__*/React__default['default'].forwardRef(function Notebook16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$c || (_path134$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path135$c || (_path135$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"
    })), children);
  });
  var NotebookReference32 = /*#__PURE__*/React__default['default'].forwardRef(function NotebookReference32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$c || (_path136$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path137$c || (_path137$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"
    })), children);
  });
  var NotebookReference24 = /*#__PURE__*/React__default['default'].forwardRef(function NotebookReference24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$c || (_path138$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path139$c || (_path139$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"
    })), children);
  });
  var NotebookReference20 = /*#__PURE__*/React__default['default'].forwardRef(function NotebookReference20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$c || (_path140$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path141$c || (_path141$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"
    })), children);
  });
  var NotebookReference16 = /*#__PURE__*/React__default['default'].forwardRef(function NotebookReference16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$c || (_path142$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"
    })), _path143$c || (_path143$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"
    })), children);
  });
  var Notification32 = /*#__PURE__*/React__default['default'].forwardRef(function Notification32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$c || (_path144$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7071,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.2929,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v.7768a5.152,5.152,0,0,0,4.5,5.1987A5.0057,5.0057,0,0,0,21,25V24h7a1,1,0,0,0,1-1V20A1,1,0,0,0,28.7071,19.293ZM19,25a3,3,0,0,1-6,0V24h6Zm8-3H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13a8,8,0,0,1,16,0v4a1,1,0,0,0,.293.707L27,20.4141Z"
    })), children);
  });
  var Notification24 = /*#__PURE__*/React__default['default'].forwardRef(function Notification24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$c || (_path145$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7071,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.2929,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v.7768a5.152,5.152,0,0,0,4.5,5.1987A5.0057,5.0057,0,0,0,21,25V24h7a1,1,0,0,0,1-1V20A1,1,0,0,0,28.7071,19.293ZM19,25a3,3,0,0,1-6,0V24h6Zm8-3H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13a8,8,0,0,1,16,0v4a1,1,0,0,0,.293.707L27,20.4141Z"
    })), children);
  });
  var Notification20 = /*#__PURE__*/React__default['default'].forwardRef(function Notification20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$c || (_path146$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7071,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.2929,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v.7768a5.152,5.152,0,0,0,4.5,5.1987A5.0057,5.0057,0,0,0,21,25V24h7a1,1,0,0,0,1-1V20A1,1,0,0,0,28.7071,19.293ZM19,25a3,3,0,0,1-6,0V24h6Zm8-3H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13a8,8,0,0,1,16,0v4a1,1,0,0,0,.293.707L27,20.4141Z"
    })), children);
  });
  var Notification16 = /*#__PURE__*/React__default['default'].forwardRef(function Notification16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$c || (_path147$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.4,10.1L13,8.8V6.5c0-2.6-1.9-4.7-4.5-5v-1h-1v1C5,1.8,3,3.9,3,6.5v2.3l-1.4,1.3c-0.1,0.1-0.2,0.2-0.1,0.4V12\tc0,0.3,0.2,0.5,0.4,0.5c0,0,0,0,0.1,0h3.5C5.5,13.9,6.6,15,8,15s2.5-1.1,2.5-2.5H14c0.3,0,0.5-0.2,0.5-0.4c0,0,0,0,0-0.1v-1.5\tC14.5,10.4,14.4,10.2,14.4,10.1z M8,14c-0.8,0-1.5-0.7-1.5-1.5h3C9.5,13.3,8.8,14,8,14z M13.5,11.5h-11v-0.8l1.3-1.4\tC3.9,9.3,4,9.1,4,9V6.5c0-2.2,1.8-4,4-4s4,1.8,4,4V9c0,0.1,0.1,0.3,0.1,0.4l1.4,1.3V11.5z"
    })), children);
  });
  var NotificationFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationFilled32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$c || (_path148$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.707,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A.9993.9993,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20A.9993.9993,0,0,0,28.707,19.293ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), children);
  });
  var NotificationFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationFilled24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$c || (_path149$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.707,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A.9993.9993,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20A.9993.9993,0,0,0,28.707,19.293ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), children);
  });
  var NotificationFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationFilled20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$c || (_path150$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.707,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A.9993.9993,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20A.9993.9993,0,0,0,28.707,19.293ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), children);
  });
  var NotificationFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationFilled16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$c || (_path151$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.707,19.293,26,16.5859V13a10.0136,10.0136,0,0,0-9-9.9492V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A.9993.9993,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20A.9993.9993,0,0,0,28.707,19.293ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), children);
  });
  var NotificationNew32 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationNew32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$c || (_path152$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16.5859V14H24v3a1,1,0,0,0,.293.707L27,20.4141V22H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13A7.9854,7.9854,0,0,1,20,6.0825V3.8467a9.896,9.896,0,0,0-3-.7959V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20a1,1,0,0,0-.293-.707ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), _circle25$6 || (_circle25$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "4"
    })), children);
  });
  var NotificationNew24 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationNew24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$c || (_path153$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16.5859V14H24v3a1,1,0,0,0,.293.707L27,20.4141V22H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13A7.9854,7.9854,0,0,1,20,6.0825V3.8467a9.896,9.896,0,0,0-3-.7959V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20a1,1,0,0,0-.293-.707ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), _circle26$6 || (_circle26$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "4"
    })), children);
  });
  var NotificationNew20 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationNew20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$c || (_path154$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16.5859V14H24v3a1,1,0,0,0,.293.707L27,20.4141V22H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13A7.9854,7.9854,0,0,1,20,6.0825V3.8467a9.896,9.896,0,0,0-3-.7959V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20a1,1,0,0,0-.293-.707ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), _circle27$6 || (_circle27$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "4"
    })), children);
  });
  var NotificationNew16 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationNew16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$c || (_path155$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16.5859V14H24v3a1,1,0,0,0,.293.707L27,20.4141V22H5V20.4141L7.707,17.707A1,1,0,0,0,8,17V13A7.9854,7.9854,0,0,1,20,6.0825V3.8467a9.896,9.896,0,0,0-3-.7959V1H15V3.0508A10.0136,10.0136,0,0,0,6,13v3.5859L3.293,19.293A1,1,0,0,0,3,20v3a1,1,0,0,0,1,1h7v1a5,5,0,0,0,10,0V24h7a1,1,0,0,0,1-1V20a1,1,0,0,0-.293-.707ZM19,25a3,3,0,0,1-6,0V24h6Z"
    })), _circle28$6 || (_circle28$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "8",
      r: "4"
    })), children);
  });
  var NotificationOff32 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOff32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$c || (_path156$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.9217 9.9217 0 00-1.0833-4.5024L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a1 1 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zm8-3H11.4141L23.4119 10.0024A7.949 7.949 0 0124 13v4a1 1 0 00.293.707L27 20.4141zM7.707 17.707A1 1 0 008 17V13a8.0092 8.0092 0 018-8 7.9253 7.9253 0 014.9857 1.7681l1.4264-1.4263A9.934 9.934 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859l-3 3L4.4141 21z"
    })), children);
  });
  var NotificationOff24 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOff24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$c || (_path157$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.9217 9.9217 0 00-1.0833-4.5024L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a1 1 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zm8-3H11.4141L23.4119 10.0024A7.949 7.949 0 0124 13v4a1 1 0 00.293.707L27 20.4141zM7.707 17.707A1 1 0 008 17V13a8.0092 8.0092 0 018-8 7.9253 7.9253 0 014.9857 1.7681l1.4264-1.4263A9.934 9.934 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859l-3 3L4.4141 21z"
    })), children);
  });
  var NotificationOff20 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOff20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$c || (_path158$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.9217 9.9217 0 00-1.0833-4.5024L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a1 1 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zm8-3H11.4141L23.4119 10.0024A7.949 7.949 0 0124 13v4a1 1 0 00.293.707L27 20.4141zM7.707 17.707A1 1 0 008 17V13a8.0092 8.0092 0 018-8 7.9253 7.9253 0 014.9857 1.7681l1.4264-1.4263A9.934 9.934 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859l-3 3L4.4141 21z"
    })), children);
  });
  var NotificationOff16 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOff16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$c || (_path159$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.5 11.5v-.8l1.3-1.4C3.9 9.3 4 9.1 4 9V6.5c0-2.2 1.8-4 4-4 .9 0 1.8.3 2.5.9l.7-.7C10.5 2 9.5 1.6 8.5 1.5v-1h-1v1C5 1.8 3 3.9 3 6.5v2.3l-1.4 1.3c-.1.1-.2.2-.1.4v1H2.5zM13 8.8V6.5c0-.8-.2-1.6-.5-2.2L15 1.7 14.3 1 1 14.3 1.7 15l2.5-2.5h1.3C5.5 13.9 6.6 15 8 15s2.5-1.1 2.5-2.5H14c.3 0 .5-.2.5-.4 0 0 0 0 0-.1v-1.5c0-.1-.1-.3-.1-.4L13 8.8zM8 14c-.8 0-1.5-.7-1.5-1.5h3C9.5 13.3 8.8 14 8 14zM13.5 11.5H5.2L11.7 5C11.9 5.5 12 6 12 6.5V9c0 .1.1.3.1.4l1.4 1.3V11.5z"
    })), children);
  });
  var NotificationOffFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOffFilled32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$c || (_path160$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.8828 9.8828 0 00-1.0869-4.499L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a.9993.9993 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zM21.61 4.7383A9.9256 9.9256 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859L3.293 19.293A.9993.9993 0 003 20v3a.9738.9738 0 00.0585.29z"
    })), children);
  });
  var NotificationOffFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOffFilled24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$c || (_path161$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.8828 9.8828 0 00-1.0869-4.499L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a.9993.9993 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zM21.61 4.7383A9.9256 9.9256 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859L3.293 19.293A.9993.9993 0 003 20v3a.9738.9738 0 00.0585.29z"
    })), children);
  });
  var NotificationOffFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOffFilled20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$c || (_path162$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.8828 9.8828 0 00-1.0869-4.499L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a.9993.9993 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zM21.61 4.7383A9.9256 9.9256 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859L3.293 19.293A.9993.9993 0 003 20v3a.9738.9738 0 00.0585.29z"
    })), children);
  });
  var NotificationOffFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function NotificationOffFilled16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$c || (_path163$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 16.5859V13a9.8828 9.8828 0 00-1.0869-4.499L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6-6H11v1a5 5 0 0010 0V24h7a1 1 0 001-1V20a.9993.9993 0 00-.293-.707zM19 25a3 3 0 01-6 0V24h6zM21.61 4.7383A9.9256 9.9256 0 0017 3.0508V1H15V3.0508A10.0136 10.0136 0 006 13v3.5859L3.293 19.293A.9993.9993 0 003 20v3a.9738.9738 0 00.0585.29z"
    })), children);
  });
  var Number_032 = /*#__PURE__*/React__default['default'].forwardRef(function Number_032(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$c || (_path164$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"
    })), _path165$c || (_path165$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H17V17H15z"
    })), children);
  });
  var Number_024 = /*#__PURE__*/React__default['default'].forwardRef(function Number_024(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$c || (_path166$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"
    })), _path167$c || (_path167$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H17V17H15z"
    })), children);
  });
  var Number_020 = /*#__PURE__*/React__default['default'].forwardRef(function Number_020(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$c || (_path168$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"
    })), _path169$c || (_path169$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H17V17H15z"
    })), children);
  });
  var Number_016 = /*#__PURE__*/React__default['default'].forwardRef(function Number_016(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$c || (_path170$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"
    })), _path171$c || (_path171$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 15H17V17H15z"
    })), children);
  });
  var Number_132 = /*#__PURE__*/React__default['default'].forwardRef(function Number_132(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$c || (_path172$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"
    })), children);
  });
  var Number_124 = /*#__PURE__*/React__default['default'].forwardRef(function Number_124(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$c || (_path173$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"
    })), children);
  });
  var Number_120 = /*#__PURE__*/React__default['default'].forwardRef(function Number_120(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$c || (_path174$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"
    })), children);
  });
  var Number_116 = /*#__PURE__*/React__default['default'].forwardRef(function Number_116(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$c || (_path175$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"
    })), children);
  });
  var Number_232 = /*#__PURE__*/React__default['default'].forwardRef(function Number_232(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$c || (_path176$c = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"
    })), children);
  });
  var Number_224 = /*#__PURE__*/React__default['default'].forwardRef(function Number_224(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$b || (_path177$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"
    })), children);
  });
  var Number_220 = /*#__PURE__*/React__default['default'].forwardRef(function Number_220(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$b || (_path178$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"
    })), children);
  });
  var Number_216 = /*#__PURE__*/React__default['default'].forwardRef(function Number_216(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$b || (_path179$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"
    })), children);
  });
  var Number_332 = /*#__PURE__*/React__default['default'].forwardRef(function Number_332(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$b || (_path180$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"
    })), children);
  });
  var Number_324 = /*#__PURE__*/React__default['default'].forwardRef(function Number_324(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$c);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$b || (_path181$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"
    })), children);
  });
  var Number_320 = /*#__PURE__*/React__default['default'].forwardRef(function Number_320(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$b || (_path182$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"
    })), children);
  });
  var Number_316 = /*#__PURE__*/React__default['default'].forwardRef(function Number_316(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$b || (_path183$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"
    })), children);
  });
  var Number_432 = /*#__PURE__*/React__default['default'].forwardRef(function Number_432(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$b || (_path184$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"
    })), children);
  });
  var Number_424 = /*#__PURE__*/React__default['default'].forwardRef(function Number_424(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$b || (_path185$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"
    })), children);
  });
  var Number_420 = /*#__PURE__*/React__default['default'].forwardRef(function Number_420(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$b || (_path186$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"
    })), children);
  });
  var Number_416 = /*#__PURE__*/React__default['default'].forwardRef(function Number_416(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$b || (_path187$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"
    })), children);
  });
  var Number_532 = /*#__PURE__*/React__default['default'].forwardRef(function Number_532(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$b || (_path188$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var Number_524 = /*#__PURE__*/React__default['default'].forwardRef(function Number_524(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$b || (_path189$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var Number_520 = /*#__PURE__*/React__default['default'].forwardRef(function Number_520(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$b || (_path190$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var Number_516 = /*#__PURE__*/React__default['default'].forwardRef(function Number_516(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$b || (_path191$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var Number_632 = /*#__PURE__*/React__default['default'].forwardRef(function Number_632(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$b || (_path192$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"
    })), children);
  });
  var Number_624 = /*#__PURE__*/React__default['default'].forwardRef(function Number_624(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$b || (_path193$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"
    })), children);
  });
  var Number_620 = /*#__PURE__*/React__default['default'].forwardRef(function Number_620(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$b || (_path194$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"
    })), children);
  });
  var Number_616 = /*#__PURE__*/React__default['default'].forwardRef(function Number_616(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$b || (_path195$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"
    })), children);
  });
  var Number_732 = /*#__PURE__*/React__default['default'].forwardRef(function Number_732(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$b || (_path196$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"
    })), children);
  });
  var Number_724 = /*#__PURE__*/React__default['default'].forwardRef(function Number_724(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$b || (_path197$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"
    })), children);
  });
  var Number_720 = /*#__PURE__*/React__default['default'].forwardRef(function Number_720(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$b || (_path198$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"
    })), children);
  });
  var Number_716 = /*#__PURE__*/React__default['default'].forwardRef(function Number_716(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$b || (_path199$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"
    })), children);
  });
  var Number_832 = /*#__PURE__*/React__default['default'].forwardRef(function Number_832(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$b || (_path200$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"
    })), children);
  });
  var Number_824 = /*#__PURE__*/React__default['default'].forwardRef(function Number_824(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$b || (_path201$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"
    })), children);
  });
  var Number_820 = /*#__PURE__*/React__default['default'].forwardRef(function Number_820(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$b || (_path202$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"
    })), children);
  });
  var Number_816 = /*#__PURE__*/React__default['default'].forwardRef(function Number_816(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$b || (_path203$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"
    })), children);
  });
  var Number_932 = /*#__PURE__*/React__default['default'].forwardRef(function Number_932(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$b || (_path204$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"
    })), children);
  });
  var Number_924 = /*#__PURE__*/React__default['default'].forwardRef(function Number_924(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$b || (_path205$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"
    })), children);
  });
  var Number_920 = /*#__PURE__*/React__default['default'].forwardRef(function Number_920(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$b || (_path206$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"
    })), children);
  });
  var Number_916 = /*#__PURE__*/React__default['default'].forwardRef(function Number_916(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$b || (_path207$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"
    })), children);
  });
  var NumberSmall_032 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_032(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$b || (_path208$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"
    })), children);
  });
  var NumberSmall_024 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_024(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$b || (_path209$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"
    })), children);
  });
  var NumberSmall_020 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_020(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$b || (_path210$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"
    })), children);
  });
  var NumberSmall_016 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_016(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$b || (_path211$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"
    })), children);
  });
  var NumberSmall_132 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_132(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$b || (_path212$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var NumberSmall_124 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_124(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$b || (_path213$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var NumberSmall_120 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_120(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$b || (_path214$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var NumberSmall_116 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_116(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$b || (_path215$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var NumberSmall_232 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_232(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$b || (_path216$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"
    })), children);
  });
  var NumberSmall_224 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_224(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$b || (_path217$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"
    })), children);
  });
  var NumberSmall_220 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_220(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$b || (_path218$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"
    })), children);
  });
  var NumberSmall_216 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_216(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$b || (_path219$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"
    })), children);
  });
  var NumberSmall_332 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_332(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$b || (_path220$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"
    })), children);
  });
  var NumberSmall_324 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_324(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$b || (_path221$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"
    })), children);
  });
  var NumberSmall_320 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_320(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$b || (_path222$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"
    })), children);
  });
  var NumberSmall_316 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_316(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$b || (_path223$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"
    })), children);
  });
  var NumberSmall_432 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_432(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$b || (_path224$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"
    })), children);
  });
  var NumberSmall_424 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_424(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$b || (_path225$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"
    })), children);
  });
  var NumberSmall_420 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_420(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$b || (_path226$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"
    })), children);
  });
  var NumberSmall_416 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_416(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$b || (_path227$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"
    })), children);
  });
  var NumberSmall_532 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_532(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$b || (_path228$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"
    })), children);
  });
  var NumberSmall_524 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_524(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$b || (_path229$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"
    })), children);
  });
  var NumberSmall_520 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_520(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$b || (_path230$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"
    })), children);
  });
  var NumberSmall_516 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_516(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$b || (_path231$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"
    })), children);
  });
  var NumberSmall_632 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_632(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$b || (_path232$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"
    })), children);
  });
  var NumberSmall_624 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_624(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$b || (_path233$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"
    })), children);
  });
  var NumberSmall_620 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_620(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$b || (_path234$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"
    })), children);
  });
  var NumberSmall_616 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_616(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$b || (_path235$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"
    })), children);
  });
  var NumberSmall_732 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_732(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$b || (_path236$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"
    })), children);
  });
  var NumberSmall_724 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_724(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$b || (_path237$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"
    })), children);
  });
  var NumberSmall_720 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_720(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$b || (_path238$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"
    })), children);
  });
  var NumberSmall_716 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_716(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$b || (_path239$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"
    })), children);
  });
  var NumberSmall_832 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_832(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$b || (_path240$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"
    })), children);
  });
  var NumberSmall_824 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_824(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$b || (_path241$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"
    })), children);
  });
  var NumberSmall_820 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_820(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$b || (_path242$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"
    })), children);
  });
  var NumberSmall_816 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_816(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$b || (_path243$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"
    })), children);
  });
  var NumberSmall_932 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_932(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$b || (_path244$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"
    })), children);
  });
  var NumberSmall_924 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_924(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$b || (_path245$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"
    })), children);
  });
  var NumberSmall_920 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_920(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$b || (_path246$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"
    })), children);
  });
  var NumberSmall_916 = /*#__PURE__*/React__default['default'].forwardRef(function NumberSmall_916(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$b || (_path247$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"
    })), children);
  });
  var ObjectStorage32 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorage32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$b || (_path248$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V22A2.0023,2.0023,0,0,0,28,20Z"
    })), _circle29$6 || (_circle29$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path249$b || (_path249$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H22v6H16v8h8V16h6zM22 20H18V16h4zm6-6H24V10h4zM18 10H10V2h8zM12 8h4V4H12z"
    })), children);
  });
  var ObjectStorage24 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorage24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$b || (_path250$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V22A2.0023,2.0023,0,0,0,28,20Z"
    })), _circle30$6 || (_circle30$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path251$b || (_path251$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H22v6H16v8h8V16h6zM22 20H18V16h4zm6-6H24V10h4zM18 10H10V2h8zM12 8h4V4H12z"
    })), children);
  });
  var ObjectStorage20 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorage20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$b || (_path252$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V22A2.0023,2.0023,0,0,0,28,20Z"
    })), _circle31$6 || (_circle31$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path253$b || (_path253$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H22v6H16v8h8V16h6zM22 20H18V16h4zm6-6H24V10h4zM18 10H10V2h8zM12 8h4V4H12z"
    })), children);
  });
  var ObjectStorage16 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorage16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$b || (_path254$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V22A2.0023,2.0023,0,0,0,28,20Z"
    })), _circle32$6 || (_circle32$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path255$b || (_path255$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H22v6H16v8h8V16h6zM22 20H18V16h4zm6-6H24V10h4zM18 10H10V2h8zM12 8h4V4H12z"
    })), children);
  });
  var ObjectStorageAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorageAlt32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$b || (_path256$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle33$6 || (_circle33$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path257$b || (_path257$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,14a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023A2.9578,2.9578,0,0,0,15,12a2.9578,2.9578,0,0,0-.0413-.4087L18.9626,9.189A2.9909,2.9909,0,1,0,18,7a2.9345,2.9345,0,0,0,.0415.4092L14.0376,9.8115a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,18,17a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,6Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,12,13Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,18Z"
    })), children);
  });
  var ObjectStorageAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorageAlt24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$b || (_path258$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle34$5 || (_circle34$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path259$b || (_path259$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,14a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023A2.9578,2.9578,0,0,0,15,12a2.9578,2.9578,0,0,0-.0413-.4087L18.9626,9.189A2.9909,2.9909,0,1,0,18,7a2.9345,2.9345,0,0,0,.0415.4092L14.0376,9.8115a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,18,17a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,6Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,12,13Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,18Z"
    })), children);
  });
  var ObjectStorageAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorageAlt20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$b || (_path260$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle35$5 || (_circle35$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path261$b || (_path261$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,14a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023A2.9578,2.9578,0,0,0,15,12a2.9578,2.9578,0,0,0-.0413-.4087L18.9626,9.189A2.9909,2.9909,0,1,0,18,7a2.9345,2.9345,0,0,0,.0415.4092L14.0376,9.8115a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,18,17a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,6Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,12,13Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,18Z"
    })), children);
  });
  var ObjectStorageAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ObjectStorageAlt16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$b || (_path262$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H14V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle36$5 || (_circle36$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path263$b || (_path263$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,14a2.981,2.981,0,0,0-2.0374.811l-4.0039-2.4023A2.9578,2.9578,0,0,0,15,12a2.9578,2.9578,0,0,0-.0413-.4087L18.9626,9.189A2.9909,2.9909,0,1,0,18,7a2.9345,2.9345,0,0,0,.0415.4092L14.0376,9.8115a3,3,0,1,0,0,4.377l4.0039,2.4023A2.9345,2.9345,0,0,0,18,17a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,6Zm-9,7a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,12,13Zm9,5a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,21,18Z"
    })), children);
  });
  var ObservedHail32 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedHail32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$b || (_path264$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _circle37$4 || (_circle37$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "23.5",
      r: "1.5"
    })), _circle38$4 || (_circle38$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "19.5",
      r: "1.5"
    })), _circle39$4 || (_circle39$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "19.5",
      r: "1.5"
    })), _path265$b || (_path265$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.964 14.5H17.036V16.499H11.964z",
      transform: "rotate(-45 14.5 15.5)"
    })), _path266$b || (_path266$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.964 14.5H23.035999999999998V16.499H17.964z",
      transform: "rotate(-45 20.5 15.5)"
    })), children);
  });
  var ObservedHail24 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedHail24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$b || (_path267$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _circle40$4 || (_circle40$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "23.5",
      r: "1.5"
    })), _circle41$4 || (_circle41$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "19.5",
      r: "1.5"
    })), _circle42$4 || (_circle42$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "19.5",
      r: "1.5"
    })), _path268$b || (_path268$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.964 14.5H17.036V16.499H11.964z",
      transform: "rotate(-45 14.5 15.5)"
    })), _path269$b || (_path269$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.964 14.5H23.035999999999998V16.499H17.964z",
      transform: "rotate(-45 20.5 15.5)"
    })), children);
  });
  var ObservedHail20 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedHail20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$b || (_path270$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _circle43$4 || (_circle43$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "23.5",
      r: "1.5"
    })), _circle44$4 || (_circle44$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "19.5",
      r: "1.5"
    })), _circle45$4 || (_circle45$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "19.5",
      r: "1.5"
    })), _path271$b || (_path271$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.964 14.5H17.036V16.499H11.964z",
      transform: "rotate(-45 14.5 15.5)"
    })), _path272$b || (_path272$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.964 14.5H23.035999999999998V16.499H17.964z",
      transform: "rotate(-45 20.5 15.5)"
    })), children);
  });
  var ObservedHail16 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedHail16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$b || (_path273$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _circle46$4 || (_circle46$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13.5",
      cy: "23.5",
      r: "1.5"
    })), _circle47$4 || (_circle47$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "19.5",
      r: "1.5"
    })), _circle48$4 || (_circle48$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16.5",
      cy: "19.5",
      r: "1.5"
    })), _path274$b || (_path274$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.964 14.5H17.036V16.499H11.964z",
      transform: "rotate(-45 14.5 15.5)"
    })), _path275$b || (_path275$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.964 14.5H23.035999999999998V16.499H17.964z",
      transform: "rotate(-45 20.5 15.5)"
    })), children);
  });
  var ObservedLightning32 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedLightning32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$b || (_path276$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path277$b || (_path277$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var ObservedLightning24 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedLightning24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$b || (_path278$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path279$b || (_path279$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var ObservedLightning20 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedLightning20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path280$b || (_path280$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path281$b || (_path281$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var ObservedLightning16 = /*#__PURE__*/React__default['default'].forwardRef(function ObservedLightning16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$b || (_path282$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.67 24L13.934 23 16.221 19 12.332 19 16.325 12 18.062 13 15.778 17 19.668 17 15.67 24z"
    })), _path283$b || (_path283$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), children);
  });
  var Omega32 = /*#__PURE__*/React__default['default'].forwardRef(function Omega32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$b || (_path284$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h8V24.7617A12.5683,12.5683,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5683,12.5683,0,0,1-5,9.7617V27h8V25Z"
    })), children);
  });
  var Omega24 = /*#__PURE__*/React__default['default'].forwardRef(function Omega24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$b || (_path285$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h8V24.7617A12.5683,12.5683,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5683,12.5683,0,0,1-5,9.7617V27h8V25Z"
    })), children);
  });
  var Omega20 = /*#__PURE__*/React__default['default'].forwardRef(function Omega20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$b || (_path286$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h8V24.7617A12.5683,12.5683,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5683,12.5683,0,0,1-5,9.7617V27h8V25Z"
    })), children);
  });
  var Omega16 = /*#__PURE__*/React__default['default'].forwardRef(function Omega16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$b || (_path287$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h8V24.7617A12.5683,12.5683,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5683,12.5683,0,0,1-5,9.7617V27h8V25Z"
    })), children);
  });
  var Opacity32 = /*#__PURE__*/React__default['default'].forwardRef(function Opacity32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$b || (_path288$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"
    })), children);
  });
  var Opacity24 = /*#__PURE__*/React__default['default'].forwardRef(function Opacity24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$b || (_path289$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"
    })), children);
  });
  var Opacity20 = /*#__PURE__*/React__default['default'].forwardRef(function Opacity20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$b || (_path290$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"
    })), children);
  });
  var Opacity16 = /*#__PURE__*/React__default['default'].forwardRef(function Opacity16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$b || (_path291$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"
    })), children);
  });
  var OpenPanelBottom32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelBottom32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$b || (_path292$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"
    })), children);
  });
  var OpenPanelBottom24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelBottom24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$b || (_path293$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"
    })), children);
  });
  var OpenPanelBottom20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelBottom20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$b || (_path294$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"
    })), children);
  });
  var OpenPanelBottom16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelBottom16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$b || (_path295$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"
    })), children);
  });
  var OpenPanelFilledBottom32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledBottom32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$b || (_path296$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"
    })), children);
  });
  var OpenPanelFilledBottom24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledBottom24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$b || (_path297$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"
    })), children);
  });
  var OpenPanelFilledBottom20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledBottom20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$b || (_path298$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"
    })), children);
  });
  var OpenPanelFilledBottom16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledBottom16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$b || (_path299$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"
    })), children);
  });
  var OpenPanelFilledLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledLeft32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$b || (_path300$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"
    })), children);
  });
  var OpenPanelFilledLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledLeft24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$b || (_path301$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"
    })), children);
  });
  var OpenPanelFilledLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledLeft20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$b || (_path302$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"
    })), children);
  });
  var OpenPanelFilledLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledLeft16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$b || (_path303$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"
    })), children);
  });
  var OpenPanelFilledRight32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledRight32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$b || (_path304$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"
    })), children);
  });
  var OpenPanelFilledRight24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledRight24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$b || (_path305$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"
    })), children);
  });
  var OpenPanelFilledRight20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledRight20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$b || (_path306$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"
    })), children);
  });
  var OpenPanelFilledRight16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledRight16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$b || (_path307$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"
    })), children);
  });
  var OpenPanelFilledTop32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledTop32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$b || (_path308$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelFilledTop24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledTop24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$b || (_path309$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelFilledTop20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledTop20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$b || (_path310$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelFilledTop16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelFilledTop16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$b || (_path311$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelLeft32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$b || (_path312$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"
    })), children);
  });
  var OpenPanelLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelLeft24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$b || (_path313$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"
    })), children);
  });
  var OpenPanelLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelLeft20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$b || (_path314$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"
    })), children);
  });
  var OpenPanelLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelLeft16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$b || (_path315$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"
    })), children);
  });
  var OpenPanelRight32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelRight32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$b || (_path316$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"
    })), children);
  });
  var OpenPanelRight24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelRight24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$b || (_path317$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"
    })), children);
  });
  var OpenPanelRight20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelRight20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$b || (_path318$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"
    })), children);
  });
  var OpenPanelRight16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelRight16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$b || (_path319$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"
    })), children);
  });
  var OpenPanelTop32 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelTop32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$b || (_path320$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelTop24 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelTop24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$b || (_path321$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelTop20 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelTop20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$b || (_path322$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"
    })), children);
  });
  var OpenPanelTop16 = /*#__PURE__*/React__default['default'].forwardRef(function OpenPanelTop16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$b || (_path323$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"
    })), children);
  });
  var QOperation32 = /*#__PURE__*/React__default['default'].forwardRef(function QOperation32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$b || (_path324$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 00-2 2V21a2 2 0 002 2h4a2 2 0 002-2V11A2 2 0 0016 9zm0 12H12V11h4z"
    })), _path325$b || (_path325$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15H15V17H13z"
    })), children);
  });
  var QOperation24 = /*#__PURE__*/React__default['default'].forwardRef(function QOperation24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$b || (_path326$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 00-2 2V21a2 2 0 002 2h4a2 2 0 002-2V11A2 2 0 0016 9zm0 12H12V11h4z"
    })), _path327$b || (_path327$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15H15V17H13z"
    })), children);
  });
  var QOperation20 = /*#__PURE__*/React__default['default'].forwardRef(function QOperation20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$b || (_path328$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 00-2 2V21a2 2 0 002 2h4a2 2 0 002-2V11A2 2 0 0016 9zm0 12H12V11h4z"
    })), _path329$b || (_path329$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15H15V17H13z"
    })), children);
  });
  var QOperation16 = /*#__PURE__*/React__default['default'].forwardRef(function QOperation16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$b || (_path330$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 00-2 2V21a2 2 0 002 2h4a2 2 0 002-2V11A2 2 0 0016 9zm0 12H12V11h4z"
    })), _path331$b || (_path331$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 15H15V17H13z"
    })), children);
  });
  var QOperationGauge32 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationGauge32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$b || (_path332$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 002 28H4a10 10 0 0113.16-9.48L14 24a2 2 0 102 2 2 2 0 00-.27-1L19 19.35A10 10 0 0124 28h2A12 12 0 0020 17.62z"
    })), children);
  });
  var QOperationGauge24 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationGauge24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$b || (_path333$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 002 28H4a10 10 0 0113.16-9.48L14 24a2 2 0 102 2 2 2 0 00-.27-1L19 19.35A10 10 0 0124 28h2A12 12 0 0020 17.62z"
    })), children);
  });
  var QOperationGauge20 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationGauge20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$b || (_path334$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 002 28H4a10 10 0 0113.16-9.48L14 24a2 2 0 102 2 2 2 0 00-.27-1L19 19.35A10 10 0 0124 28h2A12 12 0 0020 17.62z"
    })), children);
  });
  var QOperationGauge16 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationGauge16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$b || (_path335$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 002 28H4a10 10 0 0113.16-9.48L14 24a2 2 0 102 2 2 2 0 00-.27-1L19 19.35A10 10 0 0124 28h2A12 12 0 0020 17.62z"
    })), children);
  });
  var QOperationIf32 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationIf32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$b || (_path336$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 00-2 2v2H16v2h2v8h2V15h3V13H20V11z"
    })), children);
  });
  var QOperationIf24 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationIf24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$b || (_path337$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 00-2 2v2H16v2h2v8h2V15h3V13H20V11z"
    })), children);
  });

  var _path$b, _path2$b, _path3$b, _path4$b, _path5$b, _path6$b, _path7$b, _path8$b, _path9$b, _path10$b, _path11$b, _path12$b, _path13$b, _path14$b, _path15$b, _path16$b, _path17$b, _path18$b, _path19$b, _path20$b, _path21$b, _path22$b, _path23$b, _path24$b, _path25$b, _path26$b, _path27$b, _path28$b, _path29$b, _path30$b, _path31$b, _path32$b, _path33$b, _path34$b, _path35$b, _path36$b, _path37$b, _path38$b, _path39$b, _path40$b, _path41$b, _path42$b, _path43$b, _path44$b, _path45$b, _path46$b, _path47$b, _path48$b, _path49$b, _path50$b, _path51$b, _path52$b, _path53$b, _path54$b, _path55$b, _path56$b, _path57$b, _path58$b, _path59$b, _path60$b, _path61$b, _path62$b, _circle$a, _circle2$a, _circle3$a, _circle4$9, _circle5$8, _circle6$8, _circle7$8, _circle8$8, _circle9$8, _circle10$8, _circle11$7, _circle12$7, _circle13$7, _circle14$7, _circle15$7, _circle16$7, _circle17$6, _circle18$6, _circle19$6, _circle20$6, _circle21$6, _circle22$6, _circle23$6, _circle24$6, _path63$b, _path64$b, _path65$b, _path66$b, _path67$b, _path68$b, _path69$b, _path70$b, _path71$b, _path72$b, _path73$b, _path74$b, _path75$b, _path76$b, _path77$b, _path78$b, _path79$b, _path80$b, _path81$b, _path82$b, _path83$b, _path84$b, _path85$b, _path86$b, _path87$b, _path88$b, _path89$b, _path90$b, _path91$b, _path92$b, _path93$b, _path94$b, _path95$b, _path96$b, _path97$b, _path98$b, _path99$b, _path100$b, _path101$b, _path102$b, _path103$b, _path104$b, _path105$b, _path106$b, _path107$b, _path108$b, _path109$b, _path110$b, _path111$b, _path112$b, _path113$b, _path114$b, _path115$b, _path116$b, _path117$b, _path118$b, _path119$b, _path120$b, _path121$b, _path122$b, _path123$b, _path124$b, _path125$b, _path126$b, _path127$b, _path128$b, _path129$b, _path130$b, _path131$b, _path132$b, _path133$b, _path134$b, _path135$b, _path136$b, _path137$b, _path138$b, _path139$b, _path140$b, _path141$b, _path142$b, _path143$b, _path144$b, _path145$b, _path146$b, _path147$b, _path148$b, _path149$b, _path150$b, _path151$b, _path152$b, _path153$b, _path154$b, _path155$b, _path156$b, _path157$b, _path158$b, _path159$b, _path160$b, _path161$b, _path162$b, _path163$b, _path164$b, _path165$b, _path166$b, _path167$b, _path168$b, _path169$b, _path170$b, _path171$b, _path172$b, _path173$b, _path174$b, _path175$b, _path176$b, _path177$a, _path178$a, _path179$a, _path180$a, _path181$a, _path182$a, _path183$a, _path184$a, _path185$a, _path186$a, _path187$a, _path188$a, _path189$a, _path190$a, _path191$a, _path192$a, _path193$a, _path194$a, _path195$a, _path196$a, _path197$a, _path198$a, _path199$a, _circle25$5, _path200$a, _circle26$5, _path201$a, _circle27$5, _path202$a, _circle28$5, _path203$a, _path204$a, _path205$a, _path206$a, _path207$a, _path208$a, _path209$a, _path210$a, _path211$a, _path212$a, _path213$a, _path214$a, _path215$a, _path216$a, _path217$a, _path218$a, _path219$a, _path220$a, _path221$a, _path222$a, _path223$a, _path224$a, _path225$a, _path226$a, _path227$a, _path228$a, _path229$a, _path230$a, _path231$a, _path232$a, _path233$a, _path234$a, _path235$a, _path236$a, _path237$a, _path238$a, _path239$a, _path240$a, _path241$a, _path242$a, _path243$a, _path244$a, _path245$a, _path246$a, _path247$a, _path248$a, _path249$a, _path250$a, _path251$a, _path252$a, _path253$a, _path254$a, _path255$a, _path256$a, _path257$a, _path258$a, _path259$a, _path260$a, _path261$a, _path262$a, _path263$a, _path264$a, _path265$a, _path266$a, _path267$a, _path268$a, _path269$a, _path270$a, _path271$a, _path272$a, _path273$a, _path274$a, _path275$a, _path276$a, _path277$a, _path278$a, _path279$a, _path280$a, _path281$a, _path282$a, _path283$a, _path284$a, _path285$a, _path286$a, _path287$a, _path288$a, _path289$a, _path290$a, _path291$a, _path292$a, _path293$a, _path294$a, _path295$a, _path296$a, _path297$a, _path298$a, _path299$a, _path300$a, _path301$a, _path302$a, _path303$a, _path304$a, _path305$a, _path306$a, _path307$a, _path308$a, _path309$a, _path310$a, _path311$a, _path312$a, _path313$a, _path314$a, _path315$a, _path316$a, _path317$a, _path318$a, _path319$a, _path320$a, _path321$a, _path322$a, _path323$a, _path324$a, _path325$a, _path326$a, _path327$a, _path328$a, _path329$a, _path330$a, _circle29$5, _circle30$5, _circle31$5, _path331$a, _circle32$5, _circle33$5, _circle34$4, _path332$a, _circle35$4, _circle36$4, _circle37$3, _path333$a, _circle38$3, _circle39$3, _circle40$3, _path334$a, _path335$a, _path336$a, _path337$a, _path338$a, _path339$a, _path340$a, _path341$a, _path342$a, _path343$a, _path344$a, _path345$a, _path346$a, _path347$a, _path348$a, _path349$a, _path350$a, _path351$a, _path352$a, _path353$a, _path354$a, _path355$9, _path356$9, _path357$9, _path358$9, _path359$9, _path360$9, _path361$9, _path362$9, _path363$9, _path364$9, _path365$9, _path366$9, _path367$9, _path368$9, _path369$9, _path370$9, _path371$9, _path372$9, _path373$9, _path374$9, _circle41$3, _circle42$3, _circle43$3, _path375$9, _circle44$3, _circle45$3, _circle46$3, _path376$9, _circle47$3, _circle48$3, _circle49$3, _path377$9, _circle50$3, _circle51$3, _circle52$3, _path378$9, _path379$9, _path380$9, _path381$9, _path382$9, _path383$9, _path384$8, _path385$8, _path386$8, _path387$8, _path388$8, _path389$8, _path390$8, _path391$8, _path392$8, _path393$8, _path394$8, _path395$8, _path396$8, _path397$8, _path398$8, _path399$7, _path400$7, _path401$7, _path402$7, _path403$6, _path404$6, _path405$6, _path406$6, _path407$6, _path408$6, _path409$6, _path410$6, _path411$6, _path412$6, _path413$6, _path414$6, _path415$5, _path416$4, _path417$4, _path418$4, _path419$4, _path420$4, _path421$4, _path422$4, _path423$4, _path424$4, _path425$3, _path426$3, _path427$3, _path428$3, _path429$3, _path430$3, _path431$3, _path432$3, _path433$3, _path434$3, _path435$3, _path436$3, _path437$3, _path438$3, _path439$2, _path440$2, _path441$2, _path442$2, _path443$2, _path444$2, _path445$2, _path446$2, _path447$2, _path448$2, _path449$2, _path450$2, _path451$2, _path452$2, _path453$2, _path454$2;

  var _excluded$b = ["children"],
      _excluded2$b = ["children"],
      _excluded3$b = ["children"],
      _excluded4$b = ["children"],
      _excluded5$b = ["children"],
      _excluded6$b = ["children"],
      _excluded7$b = ["children"],
      _excluded8$b = ["children"],
      _excluded9$b = ["children"],
      _excluded10$b = ["children"],
      _excluded11$b = ["children"],
      _excluded12$b = ["children"],
      _excluded13$b = ["children"],
      _excluded14$b = ["children"],
      _excluded15$b = ["children"],
      _excluded16$b = ["children"],
      _excluded17$b = ["children"],
      _excluded18$b = ["children"],
      _excluded19$b = ["children"],
      _excluded20$b = ["children"],
      _excluded21$b = ["children"],
      _excluded22$b = ["children"],
      _excluded23$b = ["children"],
      _excluded24$b = ["children"],
      _excluded25$b = ["children"],
      _excluded26$b = ["children"],
      _excluded27$b = ["children"],
      _excluded28$b = ["children"],
      _excluded29$b = ["children"],
      _excluded30$b = ["children"],
      _excluded31$b = ["children"],
      _excluded32$b = ["children"],
      _excluded33$b = ["children"],
      _excluded34$b = ["children"],
      _excluded35$b = ["children"],
      _excluded36$b = ["children"],
      _excluded37$b = ["children"],
      _excluded38$b = ["children"],
      _excluded39$b = ["children"],
      _excluded40$b = ["children"],
      _excluded41$b = ["children"],
      _excluded42$b = ["children"],
      _excluded43$b = ["children"],
      _excluded44$b = ["children"],
      _excluded45$b = ["children"],
      _excluded46$b = ["children"],
      _excluded47$b = ["children"],
      _excluded48$b = ["children"],
      _excluded49$b = ["children"],
      _excluded50$b = ["children"],
      _excluded51$b = ["children"],
      _excluded52$b = ["children"],
      _excluded53$b = ["children"],
      _excluded54$b = ["children"],
      _excluded55$b = ["children"],
      _excluded56$b = ["children"],
      _excluded57$b = ["children"],
      _excluded58$b = ["children"],
      _excluded59$b = ["children"],
      _excluded60$b = ["children"],
      _excluded61$b = ["children"],
      _excluded62$b = ["children"],
      _excluded63$b = ["children"],
      _excluded64$b = ["children"],
      _excluded65$b = ["children"],
      _excluded66$b = ["children"],
      _excluded67$b = ["children"],
      _excluded68$b = ["children"],
      _excluded69$b = ["children"],
      _excluded70$b = ["children"],
      _excluded71$b = ["children"],
      _excluded72$b = ["children"],
      _excluded73$b = ["children"],
      _excluded74$b = ["children"],
      _excluded75$b = ["children"],
      _excluded76$b = ["children"],
      _excluded77$b = ["children"],
      _excluded78$b = ["children"],
      _excluded79$b = ["children"],
      _excluded80$b = ["children"],
      _excluded81$b = ["children"],
      _excluded82$b = ["children"],
      _excluded83$b = ["children"],
      _excluded84$b = ["children"],
      _excluded85$b = ["children"],
      _excluded86$b = ["children"],
      _excluded87$b = ["children"],
      _excluded88$b = ["children"],
      _excluded89$b = ["children"],
      _excluded90$b = ["children"],
      _excluded91$b = ["children"],
      _excluded92$b = ["children"],
      _excluded93$b = ["children"],
      _excluded94$b = ["children"],
      _excluded95$b = ["children"],
      _excluded96$b = ["children"],
      _excluded97$b = ["children"],
      _excluded98$b = ["children"],
      _excluded99$b = ["children"],
      _excluded100$b = ["children"],
      _excluded101$b = ["children"],
      _excluded102$b = ["children"],
      _excluded103$b = ["children"],
      _excluded104$b = ["children"],
      _excluded105$b = ["children"],
      _excluded106$b = ["children"],
      _excluded107$b = ["children"],
      _excluded108$b = ["children"],
      _excluded109$b = ["children"],
      _excluded110$b = ["children"],
      _excluded111$b = ["children"],
      _excluded112$b = ["children"],
      _excluded113$b = ["children"],
      _excluded114$b = ["children"],
      _excluded115$b = ["children"],
      _excluded116$b = ["children"],
      _excluded117$b = ["children"],
      _excluded118$b = ["children"],
      _excluded119$a = ["children"],
      _excluded120$a = ["children"],
      _excluded121$a = ["children"],
      _excluded122$a = ["children"],
      _excluded123$a = ["children"],
      _excluded124$a = ["children"],
      _excluded125$a = ["children"],
      _excluded126$a = ["children"],
      _excluded127$a = ["children"],
      _excluded128$a = ["children"],
      _excluded129$a = ["children"],
      _excluded130$a = ["children"],
      _excluded131$a = ["children"],
      _excluded132$a = ["children"],
      _excluded133$a = ["children"],
      _excluded134$a = ["children"],
      _excluded135$a = ["children"],
      _excluded136$a = ["children"],
      _excluded137$a = ["children"],
      _excluded138$a = ["children"],
      _excluded139$a = ["children"],
      _excluded140$a = ["children"],
      _excluded141$a = ["children"],
      _excluded142$a = ["children"],
      _excluded143$a = ["children"],
      _excluded144$a = ["children"],
      _excluded145$a = ["children"],
      _excluded146$a = ["children"],
      _excluded147$a = ["children"],
      _excluded148$a = ["children"],
      _excluded149$a = ["children"],
      _excluded150$a = ["children"],
      _excluded151$a = ["children"],
      _excluded152$a = ["children"],
      _excluded153$a = ["children"],
      _excluded154$a = ["children"],
      _excluded155$a = ["children"],
      _excluded156$a = ["children"],
      _excluded157$a = ["children"],
      _excluded158$a = ["children"],
      _excluded159$a = ["children"],
      _excluded160$a = ["children"],
      _excluded161$a = ["children"],
      _excluded162$a = ["children"],
      _excluded163$a = ["children"],
      _excluded164$a = ["children"],
      _excluded165$a = ["children"],
      _excluded166$a = ["children"],
      _excluded167$a = ["children"],
      _excluded168$a = ["children"],
      _excluded169$a = ["children"],
      _excluded170$a = ["children"],
      _excluded171$a = ["children"],
      _excluded172$a = ["children"],
      _excluded173$a = ["children"],
      _excluded174$a = ["children"],
      _excluded175$a = ["children"],
      _excluded176$a = ["children"],
      _excluded177$a = ["children"],
      _excluded178$a = ["children"],
      _excluded179$a = ["children"],
      _excluded180$a = ["children"],
      _excluded181$a = ["children"],
      _excluded182$a = ["children"],
      _excluded183$a = ["children"],
      _excluded184$a = ["children"],
      _excluded185$a = ["children"],
      _excluded186$a = ["children"],
      _excluded187$a = ["children"],
      _excluded188$a = ["children"],
      _excluded189$a = ["children"],
      _excluded190$a = ["children"],
      _excluded191$a = ["children"],
      _excluded192$a = ["children"],
      _excluded193$a = ["children"],
      _excluded194$a = ["children"],
      _excluded195$a = ["children"],
      _excluded196$a = ["children"],
      _excluded197$a = ["children"],
      _excluded198$a = ["children"],
      _excluded199$a = ["children"],
      _excluded200$a = ["children"],
      _excluded201$a = ["children"],
      _excluded202$a = ["children"],
      _excluded203$a = ["children"],
      _excluded204$a = ["children"],
      _excluded205$a = ["children"],
      _excluded206$a = ["children"],
      _excluded207$a = ["children"],
      _excluded208$a = ["children"],
      _excluded209$a = ["children"],
      _excluded210$a = ["children"],
      _excluded211$a = ["children"],
      _excluded212$a = ["children"],
      _excluded213$a = ["children"],
      _excluded214$a = ["children"],
      _excluded215$a = ["children"],
      _excluded216$a = ["children"],
      _excluded217$a = ["children"],
      _excluded218$a = ["children"],
      _excluded219$a = ["children"],
      _excluded220$a = ["children"],
      _excluded221$a = ["children"],
      _excluded222$a = ["children"],
      _excluded223$a = ["children"],
      _excluded224$a = ["children"],
      _excluded225$a = ["children"],
      _excluded226$a = ["children"],
      _excluded227$a = ["children"],
      _excluded228$a = ["children"],
      _excluded229$a = ["children"],
      _excluded230$a = ["children"],
      _excluded231$a = ["children"],
      _excluded232$a = ["children"],
      _excluded233$a = ["children"],
      _excluded234$a = ["children"],
      _excluded235$a = ["children"],
      _excluded236$a = ["children"],
      _excluded237$a = ["children"],
      _excluded238$a = ["children"],
      _excluded239$a = ["children"],
      _excluded240$a = ["children"],
      _excluded241$a = ["children"],
      _excluded242$a = ["children"],
      _excluded243$a = ["children"],
      _excluded244$a = ["children"],
      _excluded245$a = ["children"],
      _excluded246$a = ["children"],
      _excluded247$a = ["children"],
      _excluded248$a = ["children"],
      _excluded249$a = ["children"],
      _excluded250$a = ["children"];
  var QOperationIf20 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationIf20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$b || (_path$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 00-2 2v2H16v2h2v8h2V15h3V13H20V11z"
    })), children);
  });
  var QOperationIf16 = /*#__PURE__*/React__default['default'].forwardRef(function QOperationIf16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$b || (_path2$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 00-2 2v2H16v2h2v8h2V15h3V13H20V11z"
    })), children);
  });
  var OperationsField32 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsField32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$b || (_path3$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H26V8H16z",
      transform: "rotate(-90 21 7)"
    })), _path4$b || (_path4$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20z",
      transform: "rotate(-90 25 7)"
    })), _path5$b || (_path5$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 6H34V8H24z",
      transform: "rotate(-90 29 7)"
    })), _path6$b || (_path6$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a3.9123,3.9123,0,0,1-4-4,3.9123,3.9123,0,0,1,4-4V10a6,6,0,1,0,6,6H20A3.9123,3.9123,0,0,1,16,20Z"
    })), _path7$b || (_path7$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8928,18.4536,26.0979,16,24.78,17.5044l2.7922,2.4517-2.36,4.0878-3.4273-1.1591a9.0315,9.0315,0,0,1-2.7143,1.5644L18.36,28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H16V2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18.36a2,2,0,0,0,1.9611-1.6079l.5037-2.5186a10.9666,10.9666,0,0,0,1.3267-.7534l2.4194.8184a1.9977,1.9977,0,0,0,2.3728-.8946l2.3606-4.0878A2.0006,2.0006,0,0,0,28.8928,18.4536Z"
    })), children);
  });
  var OperationsField24 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsField24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$b || (_path8$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H26V8H16z",
      transform: "rotate(-90 21 7)"
    })), _path9$b || (_path9$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20z",
      transform: "rotate(-90 25 7)"
    })), _path10$b || (_path10$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 6H34V8H24z",
      transform: "rotate(-90 29 7)"
    })), _path11$b || (_path11$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a3.9123,3.9123,0,0,1-4-4,3.9123,3.9123,0,0,1,4-4V10a6,6,0,1,0,6,6H20A3.9123,3.9123,0,0,1,16,20Z"
    })), _path12$b || (_path12$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8928,18.4536,26.0979,16,24.78,17.5044l2.7922,2.4517-2.36,4.0878-3.4273-1.1591a9.0315,9.0315,0,0,1-2.7143,1.5644L18.36,28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H16V2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18.36a2,2,0,0,0,1.9611-1.6079l.5037-2.5186a10.9666,10.9666,0,0,0,1.3267-.7534l2.4194.8184a1.9977,1.9977,0,0,0,2.3728-.8946l2.3606-4.0878A2.0006,2.0006,0,0,0,28.8928,18.4536Z"
    })), children);
  });
  var OperationsField20 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsField20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$b || (_path13$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H26V8H16z",
      transform: "rotate(-90 21 7)"
    })), _path14$b || (_path14$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20z",
      transform: "rotate(-90 25 7)"
    })), _path15$b || (_path15$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 6H34V8H24z",
      transform: "rotate(-90 29 7)"
    })), _path16$b || (_path16$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a3.9123,3.9123,0,0,1-4-4,3.9123,3.9123,0,0,1,4-4V10a6,6,0,1,0,6,6H20A3.9123,3.9123,0,0,1,16,20Z"
    })), _path17$b || (_path17$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8928,18.4536,26.0979,16,24.78,17.5044l2.7922,2.4517-2.36,4.0878-3.4273-1.1591a9.0315,9.0315,0,0,1-2.7143,1.5644L18.36,28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H16V2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18.36a2,2,0,0,0,1.9611-1.6079l.5037-2.5186a10.9666,10.9666,0,0,0,1.3267-.7534l2.4194.8184a1.9977,1.9977,0,0,0,2.3728-.8946l2.3606-4.0878A2.0006,2.0006,0,0,0,28.8928,18.4536Z"
    })), children);
  });
  var OperationsField16 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsField16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$b || (_path18$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 6H26V8H16z",
      transform: "rotate(-90 21 7)"
    })), _path19$b || (_path19$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20z",
      transform: "rotate(-90 25 7)"
    })), _path20$b || (_path20$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 6H34V8H24z",
      transform: "rotate(-90 29 7)"
    })), _path21$b || (_path21$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a3.9123,3.9123,0,0,1-4-4,3.9123,3.9123,0,0,1,4-4V10a6,6,0,1,0,6,6H20A3.9123,3.9123,0,0,1,16,20Z"
    })), _path22$b || (_path22$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8928,18.4536,26.0979,16,24.78,17.5044l2.7922,2.4517-2.36,4.0878-3.4273-1.1591a9.0315,9.0315,0,0,1-2.7143,1.5644L18.36,28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H16V2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18.36a2,2,0,0,0,1.9611-1.6079l.5037-2.5186a10.9666,10.9666,0,0,0,1.3267-.7534l2.4194.8184a1.9977,1.9977,0,0,0,2.3728-.8946l2.3606-4.0878A2.0006,2.0006,0,0,0,28.8928,18.4536Z"
    })), children);
  });
  var OperationsRecord32 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsRecord32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$b || (_path23$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H30V26H20zM20 28H30V30H20zM16 20a3.9123 3.9123 0 01-4-4 3.9123 3.9123 0 014-4 3.9123 3.9123 0 014 4h2a6 6 0 10-6 6z"
    })), _path24$b || (_path24$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H16V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var OperationsRecord24 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsRecord24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$b || (_path25$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H30V26H20zM20 28H30V30H20zM16 20a3.9123 3.9123 0 01-4-4 3.9123 3.9123 0 014-4 3.9123 3.9123 0 014 4h2a6 6 0 10-6 6z"
    })), _path26$b || (_path26$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H16V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var OperationsRecord20 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsRecord20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$b || (_path27$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H30V26H20zM20 28H30V30H20zM16 20a3.9123 3.9123 0 01-4-4 3.9123 3.9123 0 014-4 3.9123 3.9123 0 014 4h2a6 6 0 10-6 6z"
    })), _path28$b || (_path28$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H16V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var OperationsRecord16 = /*#__PURE__*/React__default['default'].forwardRef(function OperationsRecord16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$b || (_path29$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H30V22H20zM20 24H30V26H20zM20 28H30V30H20zM16 20a3.9123 3.9123 0 01-4-4 3.9123 3.9123 0 014-4 3.9123 3.9123 0 014 4h2a6 6 0 10-6 6z"
    })), _path30$b || (_path30$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H16V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var OrderDetails32 = /*#__PURE__*/React__default['default'].forwardRef(function OrderDetails32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$b || (_path31$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H13a3 3 0 00-3 3v2h2V24a1 1 0 011-1h6a1 1 0 011 1v2h2V24A3 3 0 0019 21zM16 20a4 4 0 10-4-4A4 4 0 0016 20zm0-6a2 2 0 11-2 2A2 2 0 0116 14z"
    })), _path32$b || (_path32$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var OrderDetails24 = /*#__PURE__*/React__default['default'].forwardRef(function OrderDetails24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$b || (_path33$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H13a3 3 0 00-3 3v2h2V24a1 1 0 011-1h6a1 1 0 011 1v2h2V24A3 3 0 0019 21zM16 20a4 4 0 10-4-4A4 4 0 0016 20zm0-6a2 2 0 11-2 2A2 2 0 0116 14z"
    })), _path34$b || (_path34$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var OrderDetails20 = /*#__PURE__*/React__default['default'].forwardRef(function OrderDetails20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$b || (_path35$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H13a3 3 0 00-3 3v2h2V24a1 1 0 011-1h6a1 1 0 011 1v2h2V24A3 3 0 0019 21zM16 20a4 4 0 10-4-4A4 4 0 0016 20zm0-6a2 2 0 11-2 2A2 2 0 0116 14z"
    })), _path36$b || (_path36$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var OrderDetails16 = /*#__PURE__*/React__default['default'].forwardRef(function OrderDetails16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$b || (_path37$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H13a3 3 0 00-3 3v2h2V24a1 1 0 011-1h6a1 1 0 011 1v2h2V24A3 3 0 0019 21zM16 20a4 4 0 10-4-4A4 4 0 0016 20zm0-6a2 2 0 11-2 2A2 2 0 0116 14z"
    })), _path38$b || (_path38$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Ordinal32 = /*#__PURE__*/React__default['default'].forwardRef(function Ordinal32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$b || (_path39$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26V4H18v6H12v6H6V26H2v2H30V26ZM8,26V18h4v8Zm6,0V12h4V26Zm6,0V6h4V26Z"
    })), children);
  });
  var Ordinal24 = /*#__PURE__*/React__default['default'].forwardRef(function Ordinal24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$b || (_path40$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26V4H18v6H12v6H6V26H2v2H30V26ZM8,26V18h4v8Zm6,0V12h4V26Zm6,0V6h4V26Z"
    })), children);
  });
  var Ordinal20 = /*#__PURE__*/React__default['default'].forwardRef(function Ordinal20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$b || (_path41$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,26V4H18v6H12v6H6V26H2v2H30V26ZM8,26V18h4v8Zm6,0V12h4V26Zm6,0V6h4V26Z"
    })), children);
  });
  var Ordinal16 = /*#__PURE__*/React__default['default'].forwardRef(function Ordinal16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$b || (_path42$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1,13 L1,12 L3,12 L3,9 L5.999,9 L6,6 L9,6 L9,3 L13,3 L13,12 L15,12 L15,13 L1,13 Z M5.999,10 L4,10 L4,12 L5.999,12 L5.999,10 Z M8.999,7 L6.999,7 L6.999,9 L7,9 L7,12 L8.999,12 L8.999,7 Z M12,4 L10,4 L10,12 L12,12 L12,4 Z"
    })), children);
  });
  var Outage32 = /*#__PURE__*/React__default['default'].forwardRef(function Outage32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$b || (_path43$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 24H21V26H12zM13 28H19V30H13z"
    })), _path44$b || (_path44$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.7832 18.9746l1.4177-1.418A6.9206 6.9206 0 018 12 7.99 7.99 0 0121.5273 6.2305l1.4136-1.4136A9.9884 9.9884 0 006 12 8.9411 8.9411 0 008.7832 18.9746zM30 3.4141L28.5859 2 2 28.5859 3.4141 30 23.6606 9.7534A7.7069 7.7069 0 0124 12a7.2032 7.2032 0 01-2.8223 6.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12a9.8739 9.8739 0 00-.7764-3.81z"
    })), children);
  });
  var Outage24 = /*#__PURE__*/React__default['default'].forwardRef(function Outage24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$b || (_path45$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 24H21V26H12zM13 28H19V30H13z"
    })), _path46$b || (_path46$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.7832 18.9746l1.4177-1.418A6.9206 6.9206 0 018 12 7.99 7.99 0 0121.5273 6.2305l1.4136-1.4136A9.9884 9.9884 0 006 12 8.9411 8.9411 0 008.7832 18.9746zM30 3.4141L28.5859 2 2 28.5859 3.4141 30 23.6606 9.7534A7.7069 7.7069 0 0124 12a7.2032 7.2032 0 01-2.8223 6.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12a9.8739 9.8739 0 00-.7764-3.81z"
    })), children);
  });
  var Outage20 = /*#__PURE__*/React__default['default'].forwardRef(function Outage20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$b || (_path47$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 24H21V26H12zM13 28H19V30H13z"
    })), _path48$b || (_path48$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.7832 18.9746l1.4177-1.418A6.9206 6.9206 0 018 12 7.99 7.99 0 0121.5273 6.2305l1.4136-1.4136A9.9884 9.9884 0 006 12 8.9411 8.9411 0 008.7832 18.9746zM30 3.4141L28.5859 2 2 28.5859 3.4141 30 23.6606 9.7534A7.7069 7.7069 0 0124 12a7.2032 7.2032 0 01-2.8223 6.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12a9.8739 9.8739 0 00-.7764-3.81z"
    })), children);
  });
  var Outage16 = /*#__PURE__*/React__default['default'].forwardRef(function Outage16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$b || (_path49$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 24H21V26H12zM13 28H19V30H13z"
    })), _path50$b || (_path50$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.7832 18.9746l1.4177-1.418A6.9206 6.9206 0 018 12 7.99 7.99 0 0121.5273 6.2305l1.4136-1.4136A9.9884 9.9884 0 006 12 8.9411 8.9411 0 008.7832 18.9746zM30 3.4141L28.5859 2 2 28.5859 3.4141 30 23.6606 9.7534A7.7069 7.7069 0 0124 12a7.2032 7.2032 0 01-2.8223 6.1426C20.1069 19.1348 19 20.1611 19 22h2c0-.9194.5264-1.45 1.5352-2.3857A9.193 9.193 0 0026 12a9.8739 9.8739 0 00-.7764-3.81z"
    })), children);
  });
  var OutlookSevere32 = /*#__PURE__*/React__default['default'].forwardRef(function OutlookSevere32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$b || (_path51$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M15.1249,19h1.75v5.5h-1.75ZM17,27a1,1,0,1,0-1,1A1,1,0,0,0,17,27Z"
    })), _path52$b || (_path52$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.9084,28.94,16.8318,14.4878a.9531.9531,0,0,0-1.6636,0L7.0916,28.94A.7122.7122,0,0,0,7.7134,30H24.2867A.7121.7121,0,0,0,24.9084,28.94ZM15.125,19h1.75v5.5h-1.75ZM16,28a1,1,0,1,1,1-1A1,1,0,0,1,16,28Z"
    })), _path53$b || (_path53$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4926,6.4926,0,0,0,.9153,12.8443L9.2217,20H8.5a4.48,4.48,0,0,1-3.3693-7.4556l5.297,5.2964,1.013-1.8135-4.66-4.6606A4.402,4.402,0,0,1,8.144,11.019l.8155-.0639.0991-.812c.0237-.1944.0581-.3848.0972-.5733l3.78,3.7808,1.0138-1.815L9.936,7.522a7.0212,7.0212,0,0,1,1.9754-2.1968L25.8861,19.3A4.4594,4.4594,0,0,1,23.5,20h-.7239l1.107,1.98a6.4927,6.4927,0,0,0,.9177-12.8443Zm2.4994,8.75L13.7823,4.3682a6.9736,6.9736,0,0,1,9.16,5.7749l.0986.812.8154.0639A4.5171,4.5171,0,0,1,28,15.5,4.46,4.46,0,0,1,27.3,17.8862Z"
    })), children);
  });
  var OutlookSevere24 = /*#__PURE__*/React__default['default'].forwardRef(function OutlookSevere24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$b || (_path54$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M15.1249,19h1.75v5.5h-1.75ZM17,27a1,1,0,1,0-1,1A1,1,0,0,0,17,27Z"
    })), _path55$b || (_path55$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.9084,28.94,16.8318,14.4878a.9531.9531,0,0,0-1.6636,0L7.0916,28.94A.7122.7122,0,0,0,7.7134,30H24.2867A.7121.7121,0,0,0,24.9084,28.94ZM15.125,19h1.75v5.5h-1.75ZM16,28a1,1,0,1,1,1-1A1,1,0,0,1,16,28Z"
    })), _path56$b || (_path56$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4926,6.4926,0,0,0,.9153,12.8443L9.2217,20H8.5a4.48,4.48,0,0,1-3.3693-7.4556l5.297,5.2964,1.013-1.8135-4.66-4.6606A4.402,4.402,0,0,1,8.144,11.019l.8155-.0639.0991-.812c.0237-.1944.0581-.3848.0972-.5733l3.78,3.7808,1.0138-1.815L9.936,7.522a7.0212,7.0212,0,0,1,1.9754-2.1968L25.8861,19.3A4.4594,4.4594,0,0,1,23.5,20h-.7239l1.107,1.98a6.4927,6.4927,0,0,0,.9177-12.8443Zm2.4994,8.75L13.7823,4.3682a6.9736,6.9736,0,0,1,9.16,5.7749l.0986.812.8154.0639A4.5171,4.5171,0,0,1,28,15.5,4.46,4.46,0,0,1,27.3,17.8862Z"
    })), children);
  });
  var OutlookSevere20 = /*#__PURE__*/React__default['default'].forwardRef(function OutlookSevere20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$b || (_path57$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M15.1249,19h1.75v5.5h-1.75ZM17,27a1,1,0,1,0-1,1A1,1,0,0,0,17,27Z"
    })), _path58$b || (_path58$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.9084,28.94,16.8318,14.4878a.9531.9531,0,0,0-1.6636,0L7.0916,28.94A.7122.7122,0,0,0,7.7134,30H24.2867A.7121.7121,0,0,0,24.9084,28.94ZM15.125,19h1.75v5.5h-1.75ZM16,28a1,1,0,1,1,1-1A1,1,0,0,1,16,28Z"
    })), _path59$b || (_path59$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4926,6.4926,0,0,0,.9153,12.8443L9.2217,20H8.5a4.48,4.48,0,0,1-3.3693-7.4556l5.297,5.2964,1.013-1.8135-4.66-4.6606A4.402,4.402,0,0,1,8.144,11.019l.8155-.0639.0991-.812c.0237-.1944.0581-.3848.0972-.5733l3.78,3.7808,1.0138-1.815L9.936,7.522a7.0212,7.0212,0,0,1,1.9754-2.1968L25.8861,19.3A4.4594,4.4594,0,0,1,23.5,20h-.7239l1.107,1.98a6.4927,6.4927,0,0,0,.9177-12.8443Zm2.4994,8.75L13.7823,4.3682a6.9736,6.9736,0,0,1,9.16,5.7749l.0986.812.8154.0639A4.5171,4.5171,0,0,1,28,15.5,4.46,4.46,0,0,1,27.3,17.8862Z"
    })), children);
  });
  var OutlookSevere16 = /*#__PURE__*/React__default['default'].forwardRef(function OutlookSevere16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$b || (_path60$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M15.1249,19h1.75v5.5h-1.75ZM17,27a1,1,0,1,0-1,1A1,1,0,0,0,17,27Z"
    })), _path61$b || (_path61$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.9084,28.94,16.8318,14.4878a.9531.9531,0,0,0-1.6636,0L7.0916,28.94A.7122.7122,0,0,0,7.7134,30H24.2867A.7121.7121,0,0,0,24.9084,28.94ZM15.125,19h1.75v5.5h-1.75ZM16,28a1,1,0,1,1,1-1A1,1,0,0,1,16,28Z"
    })), _path62$b || (_path62$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4926,6.4926,0,0,0,.9153,12.8443L9.2217,20H8.5a4.48,4.48,0,0,1-3.3693-7.4556l5.297,5.2964,1.013-1.8135-4.66-4.6606A4.402,4.402,0,0,1,8.144,11.019l.8155-.0639.0991-.812c.0237-.1944.0581-.3848.0972-.5733l3.78,3.7808,1.0138-1.815L9.936,7.522a7.0212,7.0212,0,0,1,1.9754-2.1968L25.8861,19.3A4.4594,4.4594,0,0,1,23.5,20h-.7239l1.107,1.98a6.4927,6.4927,0,0,0,.9177-12.8443Zm2.4994,8.75L13.7823,4.3682a6.9736,6.9736,0,0,1,9.16,5.7749l.0986.812.8154.0639A4.5171,4.5171,0,0,1,28,15.5,4.46,4.46,0,0,1,27.3,17.8862Z"
    })), children);
  });
  var OverflowMenuHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuHorizontal32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$a || (_circle$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle2$a || (_circle2$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle3$a || (_circle3$a = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "2"
    })), children);
  });
  var OverflowMenuHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuHorizontal24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$9 || (_circle4$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle5$8 || (_circle5$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle6$8 || (_circle6$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "2"
    })), children);
  });
  var OverflowMenuHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuHorizontal20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$8 || (_circle7$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle8$8 || (_circle8$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle9$8 || (_circle9$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "2"
    })), children);
  });
  var OverflowMenuHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuHorizontal16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$8 || (_circle10$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle11$7 || (_circle11$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle12$7 || (_circle12$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "16",
      r: "2"
    })), children);
  });
  var OverflowMenuVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuVertical32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$7 || (_circle13$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "8",
      r: "2"
    })), _circle14$7 || (_circle14$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle15$7 || (_circle15$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), children);
  });
  var OverflowMenuVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuVertical24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$7 || (_circle16$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "8",
      r: "2"
    })), _circle17$6 || (_circle17$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle18$6 || (_circle18$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), children);
  });
  var OverflowMenuVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuVertical20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$6 || (_circle19$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "8",
      r: "2"
    })), _circle20$6 || (_circle20$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle21$6 || (_circle21$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), children);
  });
  var OverflowMenuVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function OverflowMenuVertical16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22$6 || (_circle22$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "8",
      r: "2"
    })), _circle23$6 || (_circle23$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle24$6 || (_circle24$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), children);
  });
  var Overlay32 = /*#__PURE__*/React__default['default'].forwardRef(function Overlay32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$b || (_path63$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8ZM4,22V4H22V8H10a2.0023,2.0023,0,0,0-2,2V22Zm18,0H19.4141L10,12.586V10h2.5859l9.4153,9.4156ZM10,15.4141,16.5859,22H10ZM22.001,16.587,15.4141,10H22ZM10,28V24H22a2.0023,2.0023,0,0,0,2-2V10h4V28Z"
    })), children);
  });
  var Overlay24 = /*#__PURE__*/React__default['default'].forwardRef(function Overlay24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$b || (_path64$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8ZM4,22V4H22V8H10a2.0023,2.0023,0,0,0-2,2V22Zm18,0H19.4141L10,12.586V10h2.5859l9.4153,9.4156ZM10,15.4141,16.5859,22H10ZM22.001,16.587,15.4141,10H22ZM10,28V24H22a2.0023,2.0023,0,0,0,2-2V10h4V28Z"
    })), children);
  });
  var Overlay20 = /*#__PURE__*/React__default['default'].forwardRef(function Overlay20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$b || (_path65$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8ZM4,22V4H22V8H10a2.0023,2.0023,0,0,0-2,2V22Zm18,0H19.4141L10,12.586V10h2.5859l9.4153,9.4156ZM10,15.4141,16.5859,22H10ZM22.001,16.587,15.4141,10H22ZM10,28V24H22a2.0023,2.0023,0,0,0,2-2V10h4V28Z"
    })), children);
  });
  var Overlay16 = /*#__PURE__*/React__default['default'].forwardRef(function Overlay16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$b || (_path66$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V22a2.0023,2.0023,0,0,0,2,2H8v4a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V10A2.0023,2.0023,0,0,0,28,8ZM4,22V4H22V8H10a2.0023,2.0023,0,0,0-2,2V22Zm18,0H19.4141L10,12.586V10h2.5859l9.4153,9.4156ZM10,15.4141,16.5859,22H10ZM22.001,16.587,15.4141,10H22ZM10,28V24H22a2.0023,2.0023,0,0,0,2-2V10h4V28Z"
    })), children);
  });
  var Package32 = /*#__PURE__*/React__default['default'].forwardRef(function Package32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$b || (_path67$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path68$b || (_path68$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"
    })), children);
  });
  var Package24 = /*#__PURE__*/React__default['default'].forwardRef(function Package24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$b || (_path69$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path70$b || (_path70$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"
    })), children);
  });
  var Package20 = /*#__PURE__*/React__default['default'].forwardRef(function Package20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$b || (_path71$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path72$b || (_path72$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"
    })), children);
  });
  var Package16 = /*#__PURE__*/React__default['default'].forwardRef(function Package16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$b || (_path73$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"
    })), _path74$b || (_path74$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"
    })), children);
  });
  var PageFirst32 = /*#__PURE__*/React__default['default'].forwardRef(function PageFirst32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$b || (_path75$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"
    })), children);
  });
  var PageFirst24 = /*#__PURE__*/React__default['default'].forwardRef(function PageFirst24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$b || (_path76$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"
    })), children);
  });
  var PageFirst20 = /*#__PURE__*/React__default['default'].forwardRef(function PageFirst20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$b || (_path77$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"
    })), children);
  });
  var PageFirst16 = /*#__PURE__*/React__default['default'].forwardRef(function PageFirst16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$b || (_path78$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"
    })), children);
  });
  var PageLast32 = /*#__PURE__*/React__default['default'].forwardRef(function PageLast32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$b || (_path79$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"
    })), children);
  });
  var PageLast24 = /*#__PURE__*/React__default['default'].forwardRef(function PageLast24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$b || (_path80$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"
    })), children);
  });
  var PageLast20 = /*#__PURE__*/React__default['default'].forwardRef(function PageLast20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$b || (_path81$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"
    })), children);
  });
  var PageLast16 = /*#__PURE__*/React__default['default'].forwardRef(function PageLast16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$b || (_path82$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"
    })), children);
  });
  var PageBreak32 = /*#__PURE__*/React__default['default'].forwardRef(function PageBreak32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$b || (_path83$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM26 18H30V20H26zM24 22v6H8V22H6v6a2.0058 2.0058 0 002 2H24a2.0058 2.0058 0 002-2V22zM8 16V4h8v6a2.0058 2.0058 0 002 2h6v4h2V10a.9092.9092 0 00-.3-.7l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16zM18 4.4L23.6 10H18zM10 18H14V20H10zM18 18H22V20H18z"
    })), children);
  });
  var PageBreak24 = /*#__PURE__*/React__default['default'].forwardRef(function PageBreak24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$b || (_path84$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM26 18H30V20H26zM24 22v6H8V22H6v6a2.0058 2.0058 0 002 2H24a2.0058 2.0058 0 002-2V22zM8 16V4h8v6a2.0058 2.0058 0 002 2h6v4h2V10a.9092.9092 0 00-.3-.7l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16zM18 4.4L23.6 10H18zM10 18H14V20H10zM18 18H22V20H18z"
    })), children);
  });
  var PageBreak20 = /*#__PURE__*/React__default['default'].forwardRef(function PageBreak20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$b || (_path85$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM26 18H30V20H26zM24 22v6H8V22H6v6a2.0058 2.0058 0 002 2H24a2.0058 2.0058 0 002-2V22zM8 16V4h8v6a2.0058 2.0058 0 002 2h6v4h2V10a.9092.9092 0 00-.3-.7l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16zM18 4.4L23.6 10H18zM10 18H14V20H10zM18 18H22V20H18z"
    })), children);
  });
  var PageBreak16 = /*#__PURE__*/React__default['default'].forwardRef(function PageBreak16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$b || (_path86$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 18H6V20H2zM26 18H30V20H26zM24 22v6H8V22H6v6a2.0058 2.0058 0 002 2H24a2.0058 2.0058 0 002-2V22zM8 16V4h8v6a2.0058 2.0058 0 002 2h6v4h2V10a.9092.9092 0 00-.3-.7l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16zM18 4.4L23.6 10H18zM10 18H14V20H10zM18 18H22V20H18z"
    })), children);
  });
  var PageNumber32 = /*#__PURE__*/React__default['default'].forwardRef(function PageNumber32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$b || (_path87$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L16 26 16 20 20 20 20 18 16 18 16 16 22 16 22 22 18 22 18 24 22 24 22 26z"
    })), _path88$b || (_path88$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var PageNumber24 = /*#__PURE__*/React__default['default'].forwardRef(function PageNumber24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$b || (_path89$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L16 26 16 20 20 20 20 18 16 18 16 16 22 16 22 22 18 22 18 24 22 24 22 26z"
    })), _path90$b || (_path90$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var PageNumber20 = /*#__PURE__*/React__default['default'].forwardRef(function PageNumber20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$b || (_path91$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L16 26 16 20 20 20 20 18 16 18 16 16 22 16 22 22 18 22 18 24 22 24 22 26z"
    })), _path92$b || (_path92$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var PageNumber16 = /*#__PURE__*/React__default['default'].forwardRef(function PageNumber16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$b || (_path93$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26L16 26 16 20 20 20 20 18 16 18 16 16 22 16 22 22 18 22 18 24 22 24 22 26z"
    })), _path94$b || (_path94$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"
    })), children);
  });
  var WatsonHealthPageScroll32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPageScroll32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$b || (_path95$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"
    })), _path96$b || (_path96$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"
    })), _path97$b || (_path97$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24V6H16V4h8a1.89 1.89 0 012 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"
    })), children);
  });
  var WatsonHealthPageScroll24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPageScroll24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$b || (_path98$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"
    })), _path99$b || (_path99$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"
    })), _path100$b || (_path100$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24V6H16V4h8a1.89 1.89 0 012 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"
    })), children);
  });
  var WatsonHealthPageScroll20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPageScroll20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$b || (_path101$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"
    })), _path102$b || (_path102$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"
    })), _path103$b || (_path103$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24V6H16V4h8a1.89 1.89 0 012 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"
    })), children);
  });
  var WatsonHealthPageScroll16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPageScroll16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$b || (_path104$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"
    })), _path105$b || (_path105$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"
    })), _path106$b || (_path106$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24V6H16V4h8a1.89 1.89 0 012 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"
    })), children);
  });
  var PaintBrush32 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrush32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$b || (_path107$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var PaintBrush24 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrush24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$b || (_path108$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var PaintBrush20 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrush20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$b || (_path109$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var PaintBrush16 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrush16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$b || (_path110$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var PaintBrushAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrushAlt32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$b || (_path111$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"
    })), children);
  });
  var PaintBrushAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrushAlt24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$b || (_path112$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"
    })), children);
  });
  var PaintBrushAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrushAlt20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$b || (_path113$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"
    })), children);
  });
  var PaintBrushAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function PaintBrushAlt16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$b || (_path114$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"
    })), children);
  });
  var PalmTree32 = /*#__PURE__*/React__default['default'].forwardRef(function PalmTree32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$b || (_path115$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.57,28C17.897,26.7251,16,22.2261,16,12v-.1313l1.1172.7446A6.4613,6.4613,0,0,1,20,18h2a8.457,8.457,0,0,0-3.7734-7.0508L16.8027,10h1.5308a7.04,7.04,0,0,1,4.2,1.4L24.4,12.8l1.2-1.6L23.7334,9.8a9.06,9.06,0,0,0-5.4-1.8H17.1172A7.0306,7.0306,0,0,1,22,6h2V4H22a9.035,9.035,0,0,0-7,3.3643A9.035,9.035,0,0,0,8,4H6V6H8a7.0306,7.0306,0,0,1,4.8828,2H11.6665a9.06,9.06,0,0,0-5.4,1.8L4.4,11.2l1.2,1.6L7.4668,11.4a7.04,7.04,0,0,1,4.2-1.4h1.5308l-1.4239.9492A8.457,8.457,0,0,0,8,18h2a6.4613,6.4613,0,0,1,2.8828-5.3867L14,11.8687V12c0,8.9438,1.4116,13.7646,2.3611,16H2v2H30V28Z"
    })), children);
  });
  var PalmTree24 = /*#__PURE__*/React__default['default'].forwardRef(function PalmTree24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$b || (_path116$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.57,28C17.897,26.7251,16,22.2261,16,12v-.1313l1.1172.7446A6.4613,6.4613,0,0,1,20,18h2a8.457,8.457,0,0,0-3.7734-7.0508L16.8027,10h1.5308a7.04,7.04,0,0,1,4.2,1.4L24.4,12.8l1.2-1.6L23.7334,9.8a9.06,9.06,0,0,0-5.4-1.8H17.1172A7.0306,7.0306,0,0,1,22,6h2V4H22a9.035,9.035,0,0,0-7,3.3643A9.035,9.035,0,0,0,8,4H6V6H8a7.0306,7.0306,0,0,1,4.8828,2H11.6665a9.06,9.06,0,0,0-5.4,1.8L4.4,11.2l1.2,1.6L7.4668,11.4a7.04,7.04,0,0,1,4.2-1.4h1.5308l-1.4239.9492A8.457,8.457,0,0,0,8,18h2a6.4613,6.4613,0,0,1,2.8828-5.3867L14,11.8687V12c0,8.9438,1.4116,13.7646,2.3611,16H2v2H30V28Z"
    })), children);
  });
  var PalmTree20 = /*#__PURE__*/React__default['default'].forwardRef(function PalmTree20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$b || (_path117$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.57,28C17.897,26.7251,16,22.2261,16,12v-.1313l1.1172.7446A6.4613,6.4613,0,0,1,20,18h2a8.457,8.457,0,0,0-3.7734-7.0508L16.8027,10h1.5308a7.04,7.04,0,0,1,4.2,1.4L24.4,12.8l1.2-1.6L23.7334,9.8a9.06,9.06,0,0,0-5.4-1.8H17.1172A7.0306,7.0306,0,0,1,22,6h2V4H22a9.035,9.035,0,0,0-7,3.3643A9.035,9.035,0,0,0,8,4H6V6H8a7.0306,7.0306,0,0,1,4.8828,2H11.6665a9.06,9.06,0,0,0-5.4,1.8L4.4,11.2l1.2,1.6L7.4668,11.4a7.04,7.04,0,0,1,4.2-1.4h1.5308l-1.4239.9492A8.457,8.457,0,0,0,8,18h2a6.4613,6.4613,0,0,1,2.8828-5.3867L14,11.8687V12c0,8.9438,1.4116,13.7646,2.3611,16H2v2H30V28Z"
    })), children);
  });
  var PalmTree16 = /*#__PURE__*/React__default['default'].forwardRef(function PalmTree16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$b || (_path118$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.57,28C17.897,26.7251,16,22.2261,16,12v-.1313l1.1172.7446A6.4613,6.4613,0,0,1,20,18h2a8.457,8.457,0,0,0-3.7734-7.0508L16.8027,10h1.5308a7.04,7.04,0,0,1,4.2,1.4L24.4,12.8l1.2-1.6L23.7334,9.8a9.06,9.06,0,0,0-5.4-1.8H17.1172A7.0306,7.0306,0,0,1,22,6h2V4H22a9.035,9.035,0,0,0-7,3.3643A9.035,9.035,0,0,0,8,4H6V6H8a7.0306,7.0306,0,0,1,4.8828,2H11.6665a9.06,9.06,0,0,0-5.4,1.8L4.4,11.2l1.2,1.6L7.4668,11.4a7.04,7.04,0,0,1,4.2-1.4h1.5308l-1.4239.9492A8.457,8.457,0,0,0,8,18h2a6.4613,6.4613,0,0,1,2.8828-5.3867L14,11.8687V12c0,8.9438,1.4116,13.7646,2.3611,16H2v2H30V28Z"
    })), children);
  });
  var PanHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function PanHorizontal32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$b || (_path119$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10L22.586 11.414 26.172 15 5.828 15 9.414 11.414 8 10 2 16 8 22 9.414 20.586 5.828 17 26.172 17 22.586 20.586 24 22 30 16 24 10z"
    })), children);
  });
  var PanHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function PanHorizontal24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$b || (_path120$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10L22.586 11.414 26.172 15 5.828 15 9.414 11.414 8 10 2 16 8 22 9.414 20.586 5.828 17 26.172 17 22.586 20.586 24 22 30 16 24 10z"
    })), children);
  });
  var PanHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function PanHorizontal20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$b || (_path121$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10L22.586 11.414 26.172 15 5.828 15 9.414 11.414 8 10 2 16 8 22 9.414 20.586 5.828 17 26.172 17 22.586 20.586 24 22 30 16 24 10z"
    })), children);
  });
  var PanHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function PanHorizontal16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$b || (_path122$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 10L22.586 11.414 26.172 15 5.828 15 9.414 11.414 8 10 2 16 8 22 9.414 20.586 5.828 17 26.172 17 22.586 20.586 24 22 30 16 24 10z"
    })), children);
  });
  var PanVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function PanVertical32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$b || (_path123$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 8L11.414 9.414 15 5.828 15 26.172 11.414 22.586 10 24 16 30 22 24 20.586 22.586 17 26.172 17 5.828 20.586 9.414 22 8 16 2 10 8z"
    })), children);
  });
  var PanVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function PanVertical24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$b || (_path124$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 8L11.414 9.414 15 5.828 15 26.172 11.414 22.586 10 24 16 30 22 24 20.586 22.586 17 26.172 17 5.828 20.586 9.414 22 8 16 2 10 8z"
    })), children);
  });
  var PanVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function PanVertical20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$b || (_path125$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 8L11.414 9.414 15 5.828 15 26.172 11.414 22.586 10 24 16 30 22 24 20.586 22.586 17 26.172 17 5.828 20.586 9.414 22 8 16 2 10 8z"
    })), children);
  });
  var PanVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function PanVertical16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$b || (_path126$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 8L11.414 9.414 15 5.828 15 26.172 11.414 22.586 10 24 16 30 22 24 20.586 22.586 17 26.172 17 5.828 20.586 9.414 22 8 16 2 10 8z"
    })), children);
  });
  var PanelExpansion32 = /*#__PURE__*/React__default['default'].forwardRef(function PanelExpansion32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$b || (_path127$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H6A2 2 0 004 8v6a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0012 6zM6 14V8h6v6zM26 6H20a2 2 0 00-2 2V24a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0026 6zM20 24V8h6V24z"
    })), children);
  });
  var PanelExpansion24 = /*#__PURE__*/React__default['default'].forwardRef(function PanelExpansion24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$b || (_path128$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H6A2 2 0 004 8v6a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0012 6zM6 14V8h6v6zM26 6H20a2 2 0 00-2 2V24a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0026 6zM20 24V8h6V24z"
    })), children);
  });
  var PanelExpansion20 = /*#__PURE__*/React__default['default'].forwardRef(function PanelExpansion20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$b || (_path129$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H6A2 2 0 004 8v6a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0012 6zM6 14V8h6v6zM26 6H20a2 2 0 00-2 2V24a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0026 6zM20 24V8h6V24z"
    })), children);
  });
  var PanelExpansion16 = /*#__PURE__*/React__default['default'].forwardRef(function PanelExpansion16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$b || (_path130$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H6A2 2 0 004 8v6a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0012 6zM6 14V8h6v6zM26 6H20a2 2 0 00-2 2V24a2 2 0 002 2h6a2 2 0 002-2V8A2 2 0 0026 6zM20 24V8h6V24z"
    })), children);
  });
  var Paragraph32 = /*#__PURE__*/React__default['default'].forwardRef(function Paragraph32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$b || (_path131$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"
    })), children);
  });
  var Paragraph24 = /*#__PURE__*/React__default['default'].forwardRef(function Paragraph24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$b || (_path132$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"
    })), children);
  });
  var Paragraph20 = /*#__PURE__*/React__default['default'].forwardRef(function Paragraph20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$b || (_path133$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"
    })), children);
  });
  var Paragraph16 = /*#__PURE__*/React__default['default'].forwardRef(function Paragraph16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$b || (_path134$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"
    })), children);
  });
  var Parameter32 = /*#__PURE__*/React__default['default'].forwardRef(function Parameter32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$b || (_path135$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13V8a2.0023,2.0023,0,0,0-2-2H23V8h3v5a3.9756,3.9756,0,0,0,1.3823,3A3.9756,3.9756,0,0,0,26,19v5H23v2h3a2.0023,2.0023,0,0,0,2-2V19a2.0023,2.0023,0,0,1,2-2V15A2.0023,2.0023,0,0,1,28,13Z"
    })), _path136$b || (_path136$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,9l-.857,3h2L19,9h2l-.857,3H22v2H19.572l-1.143,4H21v2H17.857L17,23H15l.857-3h-2L13,23H11l.857-3H10V18h2.429l1.143-4H11V12h3.143L15,9Zm.572,5h-2l-1.143,4h2Z"
    })), _path137$b || (_path137$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,13V8H9V6H6A2.0023,2.0023,0,0,0,4,8v5a2.0023,2.0023,0,0,1-2,2v2a2.0023,2.0023,0,0,1,2,2v5a2.0023,2.0023,0,0,0,2,2H9V24H6V19a3.9756,3.9756,0,0,0-1.3823-3A3.9756,3.9756,0,0,0,6,13Z"
    })), children);
  });
  var Parameter24 = /*#__PURE__*/React__default['default'].forwardRef(function Parameter24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$b || (_path138$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13V8a2.0023,2.0023,0,0,0-2-2H23V8h3v5a3.9756,3.9756,0,0,0,1.3823,3A3.9756,3.9756,0,0,0,26,19v5H23v2h3a2.0023,2.0023,0,0,0,2-2V19a2.0023,2.0023,0,0,1,2-2V15A2.0023,2.0023,0,0,1,28,13Z"
    })), _path139$b || (_path139$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,9l-.857,3h2L19,9h2l-.857,3H22v2H19.572l-1.143,4H21v2H17.857L17,23H15l.857-3h-2L13,23H11l.857-3H10V18h2.429l1.143-4H11V12h3.143L15,9Zm.572,5h-2l-1.143,4h2Z"
    })), _path140$b || (_path140$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,13V8H9V6H6A2.0023,2.0023,0,0,0,4,8v5a2.0023,2.0023,0,0,1-2,2v2a2.0023,2.0023,0,0,1,2,2v5a2.0023,2.0023,0,0,0,2,2H9V24H6V19a3.9756,3.9756,0,0,0-1.3823-3A3.9756,3.9756,0,0,0,6,13Z"
    })), children);
  });
  var Parameter20 = /*#__PURE__*/React__default['default'].forwardRef(function Parameter20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$b || (_path141$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13V8a2.0023,2.0023,0,0,0-2-2H23V8h3v5a3.9756,3.9756,0,0,0,1.3823,3A3.9756,3.9756,0,0,0,26,19v5H23v2h3a2.0023,2.0023,0,0,0,2-2V19a2.0023,2.0023,0,0,1,2-2V15A2.0023,2.0023,0,0,1,28,13Z"
    })), _path142$b || (_path142$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,9l-.857,3h2L19,9h2l-.857,3H22v2H19.572l-1.143,4H21v2H17.857L17,23H15l.857-3h-2L13,23H11l.857-3H10V18h2.429l1.143-4H11V12h3.143L15,9Zm.572,5h-2l-1.143,4h2Z"
    })), _path143$b || (_path143$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,13V8H9V6H6A2.0023,2.0023,0,0,0,4,8v5a2.0023,2.0023,0,0,1-2,2v2a2.0023,2.0023,0,0,1,2,2v5a2.0023,2.0023,0,0,0,2,2H9V24H6V19a3.9756,3.9756,0,0,0-1.3823-3A3.9756,3.9756,0,0,0,6,13Z"
    })), children);
  });
  var Parameter16 = /*#__PURE__*/React__default['default'].forwardRef(function Parameter16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$b || (_path144$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,13V8a2.0023,2.0023,0,0,0-2-2H23V8h3v5a3.9756,3.9756,0,0,0,1.3823,3A3.9756,3.9756,0,0,0,26,19v5H23v2h3a2.0023,2.0023,0,0,0,2-2V19a2.0023,2.0023,0,0,1,2-2V15A2.0023,2.0023,0,0,1,28,13Z"
    })), _path145$b || (_path145$b = /*#__PURE__*/React__default['default'].createElement("path", {
      fillRule: "evenodd",
      d: "M17,9l-.857,3h2L19,9h2l-.857,3H22v2H19.572l-1.143,4H21v2H17.857L17,23H15l.857-3h-2L13,23H11l.857-3H10V18h2.429l1.143-4H11V12h3.143L15,9Zm.572,5h-2l-1.143,4h2Z"
    })), _path146$b || (_path146$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,13V8H9V6H6A2.0023,2.0023,0,0,0,4,8v5a2.0023,2.0023,0,0,1-2,2v2a2.0023,2.0023,0,0,1,2,2v5a2.0023,2.0023,0,0,0,2,2H9V24H6V19a3.9756,3.9756,0,0,0-1.3823-3A3.9756,3.9756,0,0,0,6,13Z"
    })), children);
  });
  var ParentChild32 = /*#__PURE__*/React__default['default'].forwardRef(function ParentChild32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$b || (_path147$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"
    })), children);
  });
  var ParentChild24 = /*#__PURE__*/React__default['default'].forwardRef(function ParentChild24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$b || (_path148$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"
    })), children);
  });
  var ParentChild20 = /*#__PURE__*/React__default['default'].forwardRef(function ParentChild20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$b || (_path149$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"
    })), children);
  });
  var ParentChild16 = /*#__PURE__*/React__default['default'].forwardRef(function ParentChild16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$b || (_path150$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"
    })), children);
  });
  var PartlyCloudy32 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudy32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$b || (_path151$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H31V17H27z"
    })), _path152$b || (_path152$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.086 5.794H27.329V7.794H23.086z",
      transform: "rotate(-45 25.207 6.794)"
    })), _path153$b || (_path153$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 1H17V5H15z"
    })), _path154$b || (_path154$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.672 24.208H8.915V26.208H4.672z",
      transform: "rotate(-45 6.793 25.208)"
    })), _path155$b || (_path155$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.793 4.672H7.793V8.915H5.793z",
      transform: "rotate(-45 6.793 6.794)"
    })), _path156$b || (_path156$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 15H5V17H1zM26.7939 20.3418a6.9617 6.9617 0 00-1.8681-3.2671A8.485 8.485 0 0025 16a9 9 0 10-14.585 7.0332A4.9771 4.9771 0 0015 30H25a4.9947 4.9947 0 001.7939-9.6582zM9 16a6.9955 6.9955 0 0113.9849-.2969A6.8883 6.8883 0 0020 15a7.04 7.04 0 00-6.7944 5.3418A4.986 4.986 0 0011.5618 21.39 6.9675 6.9675 0 019 16zM25 28H15a2.9945 2.9945 0 01-.6963-5.9082l.6587-.1572.0986-.67a4.9923 4.9923 0 019.878 0l.0986.6695.6587.1572A2.9945 2.9945 0 0125 28z"
    })), children);
  });
  var PartlyCloudy24 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudy24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$b || (_path157$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H31V17H27z"
    })), _path158$b || (_path158$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.086 5.794H27.329V7.794H23.086z",
      transform: "rotate(-45 25.207 6.794)"
    })), _path159$b || (_path159$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 1H17V5H15z"
    })), _path160$b || (_path160$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.672 24.208H8.915V26.208H4.672z",
      transform: "rotate(-45 6.793 25.208)"
    })), _path161$b || (_path161$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.793 4.672H7.793V8.915H5.793z",
      transform: "rotate(-45 6.793 6.794)"
    })), _path162$b || (_path162$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 15H5V17H1zM26.7939 20.3418a6.9617 6.9617 0 00-1.8681-3.2671A8.485 8.485 0 0025 16a9 9 0 10-14.585 7.0332A4.9771 4.9771 0 0015 30H25a4.9947 4.9947 0 001.7939-9.6582zM9 16a6.9955 6.9955 0 0113.9849-.2969A6.8883 6.8883 0 0020 15a7.04 7.04 0 00-6.7944 5.3418A4.986 4.986 0 0011.5618 21.39 6.9675 6.9675 0 019 16zM25 28H15a2.9945 2.9945 0 01-.6963-5.9082l.6587-.1572.0986-.67a4.9923 4.9923 0 019.878 0l.0986.6695.6587.1572A2.9945 2.9945 0 0125 28z"
    })), children);
  });
  var PartlyCloudy20 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudy20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$b || (_path163$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H31V17H27z"
    })), _path164$b || (_path164$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.086 5.794H27.329V7.794H23.086z",
      transform: "rotate(-45 25.207 6.794)"
    })), _path165$b || (_path165$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 1H17V5H15z"
    })), _path166$b || (_path166$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.672 24.208H8.915V26.208H4.672z",
      transform: "rotate(-45 6.793 25.208)"
    })), _path167$b || (_path167$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.793 4.672H7.793V8.915H5.793z",
      transform: "rotate(-45 6.793 6.794)"
    })), _path168$b || (_path168$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 15H5V17H1zM26.7939 20.3418a6.9617 6.9617 0 00-1.8681-3.2671A8.485 8.485 0 0025 16a9 9 0 10-14.585 7.0332A4.9771 4.9771 0 0015 30H25a4.9947 4.9947 0 001.7939-9.6582zM9 16a6.9955 6.9955 0 0113.9849-.2969A6.8883 6.8883 0 0020 15a7.04 7.04 0 00-6.7944 5.3418A4.986 4.986 0 0011.5618 21.39 6.9675 6.9675 0 019 16zM25 28H15a2.9945 2.9945 0 01-.6963-5.9082l.6587-.1572.0986-.67a4.9923 4.9923 0 019.878 0l.0986.6695.6587.1572A2.9945 2.9945 0 0125 28z"
    })), children);
  });
  var PartlyCloudy16 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudy16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$b || (_path169$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 15H31V17H27z"
    })), _path170$b || (_path170$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.086 5.794H27.329V7.794H23.086z",
      transform: "rotate(-45 25.207 6.794)"
    })), _path171$b || (_path171$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 1H17V5H15z"
    })), _path172$b || (_path172$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.672 24.208H8.915V26.208H4.672z",
      transform: "rotate(-45 6.793 25.208)"
    })), _path173$b || (_path173$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.793 4.672H7.793V8.915H5.793z",
      transform: "rotate(-45 6.793 6.794)"
    })), _path174$b || (_path174$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 15H5V17H1zM26.7939 20.3418a6.9617 6.9617 0 00-1.8681-3.2671A8.485 8.485 0 0025 16a9 9 0 10-14.585 7.0332A4.9771 4.9771 0 0015 30H25a4.9947 4.9947 0 001.7939-9.6582zM9 16a6.9955 6.9955 0 0113.9849-.2969A6.8883 6.8883 0 0020 15a7.04 7.04 0 00-6.7944 5.3418A4.986 4.986 0 0011.5618 21.39 6.9675 6.9675 0 019 16zM25 28H15a2.9945 2.9945 0 01-.6963-5.9082l.6587-.1572.0986-.67a4.9923 4.9923 0 019.878 0l.0986.6695.6587.1572A2.9945 2.9945 0 0125 28z"
    })), children);
  });
  var PartlyCloudyNight32 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudyNight32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$b || (_path175$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19a4.974,4.974,0,0,0-3.2061-4.6582A6.9711,6.9711,0,0,0,13.7578,12.9a13.1418,13.1418,0,0,1,.1314-8.52A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0a13.0412,13.0412,0,0,0,10.29-5.0386A4.99,4.99,0,0,0,30,19ZM14.7034,26.9976a11.0945,11.0945,0,0,1-3.201-21.584,15.1817,15.1817,0,0,0,.8443,9.3676A4.9877,4.9877,0,0,0,15,24h7.6772a11.0991,11.0991,0,0,1-7.5561,2.9976C14.9827,26.9976,14.8428,27.0024,14.7034,26.9976ZM25,22H15a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878.0005l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,25,22Z"
    })), children);
  });
  var PartlyCloudyNight24 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudyNight24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$b || (_path176$b = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19a4.974,4.974,0,0,0-3.2061-4.6582A6.9711,6.9711,0,0,0,13.7578,12.9a13.1418,13.1418,0,0,1,.1314-8.52A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0a13.0412,13.0412,0,0,0,10.29-5.0386A4.99,4.99,0,0,0,30,19ZM14.7034,26.9976a11.0945,11.0945,0,0,1-3.201-21.584,15.1817,15.1817,0,0,0,.8443,9.3676A4.9877,4.9877,0,0,0,15,24h7.6772a11.0991,11.0991,0,0,1-7.5561,2.9976C14.9827,26.9976,14.8428,27.0024,14.7034,26.9976ZM25,22H15a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878.0005l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,25,22Z"
    })), children);
  });
  var PartlyCloudyNight20 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudyNight20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$a || (_path177$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19a4.974,4.974,0,0,0-3.2061-4.6582A6.9711,6.9711,0,0,0,13.7578,12.9a13.1418,13.1418,0,0,1,.1314-8.52A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0a13.0412,13.0412,0,0,0,10.29-5.0386A4.99,4.99,0,0,0,30,19ZM14.7034,26.9976a11.0945,11.0945,0,0,1-3.201-21.584,15.1817,15.1817,0,0,0,.8443,9.3676A4.9877,4.9877,0,0,0,15,24h7.6772a11.0991,11.0991,0,0,1-7.5561,2.9976C14.9827,26.9976,14.8428,27.0024,14.7034,26.9976ZM25,22H15a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878.0005l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,25,22Z"
    })), children);
  });
  var PartlyCloudyNight16 = /*#__PURE__*/React__default['default'].forwardRef(function PartlyCloudyNight16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$a || (_path178$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,19a4.974,4.974,0,0,0-3.2061-4.6582A6.9711,6.9711,0,0,0,13.7578,12.9a13.1418,13.1418,0,0,1,.1314-8.52A1.015,1.015,0,0,0,12.98,3a.9825.9825,0,0,0-.1746.0156A13.0958,13.0958,0,0,0,14.63,28.9971c.164.0063.3281,0,.4907,0a13.0412,13.0412,0,0,0,10.29-5.0386A4.99,4.99,0,0,0,30,19ZM14.7034,26.9976a11.0945,11.0945,0,0,1-3.201-21.584,15.1817,15.1817,0,0,0,.8443,9.3676A4.9877,4.9877,0,0,0,15,24h7.6772a11.0991,11.0991,0,0,1-7.5561,2.9976C14.9827,26.9976,14.8428,27.0024,14.7034,26.9976ZM25,22H15a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878.0005l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,25,22Z"
    })), children);
  });
  var Partnership32 = /*#__PURE__*/React__default['default'].forwardRef(function Partnership32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$a || (_path179$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9a4 4 0 114-4A4 4 0 018 9zM8 3a2 2 0 102 2A2 2 0 008 3zM24 9a4 4 0 114-4A4 4 0 0124 9zm0-6a2 2 0 102 2A2 2 0 0024 3zM26 30H22a2 2 0 01-2-2V21h2v7h4V19h2V13a1 1 0 00-1-1H20.58L16 20l-4.58-8H5a1 1 0 00-1 1v6H6v9h4V21h2v7a2 2 0 01-2 2H6a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h7.58L16 16l3.42-6H27a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0126 30z"
    })), children);
  });
  var Partnership24 = /*#__PURE__*/React__default['default'].forwardRef(function Partnership24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$a || (_path180$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9a4 4 0 114-4A4 4 0 018 9zM8 3a2 2 0 102 2A2 2 0 008 3zM24 9a4 4 0 114-4A4 4 0 0124 9zm0-6a2 2 0 102 2A2 2 0 0024 3zM26 30H22a2 2 0 01-2-2V21h2v7h4V19h2V13a1 1 0 00-1-1H20.58L16 20l-4.58-8H5a1 1 0 00-1 1v6H6v9h4V21h2v7a2 2 0 01-2 2H6a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h7.58L16 16l3.42-6H27a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0126 30z"
    })), children);
  });
  var Partnership20 = /*#__PURE__*/React__default['default'].forwardRef(function Partnership20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$a || (_path181$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9a4 4 0 114-4A4 4 0 018 9zM8 3a2 2 0 102 2A2 2 0 008 3zM24 9a4 4 0 114-4A4 4 0 0124 9zm0-6a2 2 0 102 2A2 2 0 0024 3zM26 30H22a2 2 0 01-2-2V21h2v7h4V19h2V13a1 1 0 00-1-1H20.58L16 20l-4.58-8H5a1 1 0 00-1 1v6H6v9h4V21h2v7a2 2 0 01-2 2H6a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h7.58L16 16l3.42-6H27a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0126 30z"
    })), children);
  });
  var Partnership16 = /*#__PURE__*/React__default['default'].forwardRef(function Partnership16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$a || (_path182$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 9a4 4 0 114-4A4 4 0 018 9zM8 3a2 2 0 102 2A2 2 0 008 3zM24 9a4 4 0 114-4A4 4 0 0124 9zm0-6a2 2 0 102 2A2 2 0 0024 3zM26 30H22a2 2 0 01-2-2V21h2v7h4V19h2V13a1 1 0 00-1-1H20.58L16 20l-4.58-8H5a1 1 0 00-1 1v6H6v9h4V21h2v7a2 2 0 01-2 2H6a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h7.58L16 16l3.42-6H27a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0126 30z"
    })), children);
  });
  var PassengerDrinks32 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerDrinks32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$a || (_path183$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4V2H22V4a3.9906 3.9906 0 003 3.8586V11H23v2h6V11H27V7.8586A3.9906 3.9906 0 0030 4zM10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4746 31.313L19.3408 24H12.2393A4.0073 4.0073 0 018.373 21.0293l-1.6337-6.126a3.8987 3.8987 0 017.5341-2.0092L15.1016 16H21v2H13.5645l-1.2227-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0052 2.0052 0 0012.2393 22h8.42l3.6543 8.5254z"
    })), _path184$a || (_path184$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7683a2.0025,2.0025,0,0,1-1.9326-1.4849L2.0337,12.2576l1.9326-.5152L7.7683,26H18Z"
    })), children);
  });
  var PassengerDrinks24 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerDrinks24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$a || (_path185$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4V2H22V4a3.9906 3.9906 0 003 3.8586V11H23v2h6V11H27V7.8586A3.9906 3.9906 0 0030 4zM10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4746 31.313L19.3408 24H12.2393A4.0073 4.0073 0 018.373 21.0293l-1.6337-6.126a3.8987 3.8987 0 017.5341-2.0092L15.1016 16H21v2H13.5645l-1.2227-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0052 2.0052 0 0012.2393 22h8.42l3.6543 8.5254z"
    })), _path186$a || (_path186$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7683a2.0025,2.0025,0,0,1-1.9326-1.4849L2.0337,12.2576l1.9326-.5152L7.7683,26H18Z"
    })), children);
  });
  var PassengerDrinks20 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerDrinks20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$a || (_path187$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4V2H22V4a3.9906 3.9906 0 003 3.8586V11H23v2h6V11H27V7.8586A3.9906 3.9906 0 0030 4zM10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4746 31.313L19.3408 24H12.2393A4.0073 4.0073 0 018.373 21.0293l-1.6337-6.126a3.8987 3.8987 0 017.5341-2.0092L15.1016 16H21v2H13.5645l-1.2227-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0052 2.0052 0 0012.2393 22h8.42l3.6543 8.5254z"
    })), _path188$a || (_path188$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7683a2.0025,2.0025,0,0,1-1.9326-1.4849L2.0337,12.2576l1.9326-.5152L7.7683,26H18Z"
    })), children);
  });
  var PassengerDrinks16 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerDrinks16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$a || (_path189$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 4V2H22V4a3.9906 3.9906 0 003 3.8586V11H23v2h6V11H27V7.8586A3.9906 3.9906 0 0030 4zM10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4746 31.313L19.3408 24H12.2393A4.0073 4.0073 0 018.373 21.0293l-1.6337-6.126a3.8987 3.8987 0 017.5341-2.0092L15.1016 16H21v2H13.5645l-1.2227-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0052 2.0052 0 0012.2393 22h8.42l3.6543 8.5254z"
    })), _path190$a || (_path190$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7683a2.0025,2.0025,0,0,1-1.9326-1.4849L2.0337,12.2576l1.9326-.5152L7.7683,26H18Z"
    })), children);
  });
  var PassengerPlus32 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerPlus32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$a || (_path191$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4739 31.313L19.34 24H12.2385a4.0072 4.0072 0 01-3.8662-2.9707l-1.6338-6.126a3.8988 3.8988 0 017.5342-2.0092L15.1008 16H21v2H13.5637l-1.2226-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0051 2.0051 0 0012.2385 22h8.42l3.6543 8.5254zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), _path192$a || (_path192$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7676A2.0025,2.0025,0,0,1,5.835,26.5151L2.033,12.2576l1.9326-.5152L7.7676,26H18Z"
    })), children);
  });
  var PassengerPlus24 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerPlus24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$a || (_path193$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4739 31.313L19.34 24H12.2385a4.0072 4.0072 0 01-3.8662-2.9707l-1.6338-6.126a3.8988 3.8988 0 017.5342-2.0092L15.1008 16H21v2H13.5637l-1.2226-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0051 2.0051 0 0012.2385 22h8.42l3.6543 8.5254zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), _path194$a || (_path194$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7676A2.0025,2.0025,0,0,1,5.835,26.5151L2.033,12.2576l1.9326-.5152L7.7676,26H18Z"
    })), children);
  });
  var PassengerPlus20 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerPlus20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$a || (_path195$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4739 31.313L19.34 24H12.2385a4.0072 4.0072 0 01-3.8662-2.9707l-1.6338-6.126a3.8988 3.8988 0 017.5342-2.0092L15.1008 16H21v2H13.5637l-1.2226-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0051 2.0051 0 0012.2385 22h8.42l3.6543 8.5254zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), _path196$a || (_path196$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7676A2.0025,2.0025,0,0,1,5.835,26.5151L2.033,12.2576l1.9326-.5152L7.7676,26H18Z"
    })), children);
  });
  var PassengerPlus16 = /*#__PURE__*/React__default['default'].forwardRef(function PassengerPlus16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$b);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$a || (_path197$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.5 9A3.5 3.5 0 1114 5.5 3.5042 3.5042 0 0110.5 9zm0-5A1.5 1.5 0 1012 5.5 1.5017 1.5017 0 0010.5 4zM22.4739 31.313L19.34 24H12.2385a4.0072 4.0072 0 01-3.8662-2.9707l-1.6338-6.126a3.8988 3.8988 0 017.5342-2.0092L15.1008 16H21v2H13.5637l-1.2226-4.5908a1.9 1.9 0 00-3.6709.979l1.6338 6.1255A2.0051 2.0051 0 0012.2385 22h8.42l3.6543 8.5254zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"
    })), _path198$a || (_path198$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28H7.7676A2.0025,2.0025,0,0,1,5.835,26.5151L2.033,12.2576l1.9326-.5152L7.7676,26H18Z"
    })), children);
  });
  var Password32 = /*#__PURE__*/React__default['default'].forwardRef(function Password32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$a || (_path199$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2a8.9977,8.9977,0,0,0-8.6119,11.6118L2,24v6H8L18.3881,19.6118A9,9,0,1,0,21,2Zm0,16a7.0125,7.0125,0,0,1-2.0322-.3022L17.821,17.35l-.8472.8472-3.1811,3.1812L12.4141,20,11,21.4141l1.3787,1.3786-1.5859,1.586L9.4141,23,8,24.4141l1.3787,1.3786L7.1716,28H4V24.8284l9.8023-9.8023.8472-.8474-.3473-1.1467A7,7,0,1,1,21,18Z"
    })), _circle25$5 || (_circle25$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "10",
      r: "2"
    })), children);
  });
  var Password24 = /*#__PURE__*/React__default['default'].forwardRef(function Password24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$a || (_path200$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2a8.9977,8.9977,0,0,0-8.6119,11.6118L2,24v6H8L18.3881,19.6118A9,9,0,1,0,21,2Zm0,16a7.0125,7.0125,0,0,1-2.0322-.3022L17.821,17.35l-.8472.8472-3.1811,3.1812L12.4141,20,11,21.4141l1.3787,1.3786-1.5859,1.586L9.4141,23,8,24.4141l1.3787,1.3786L7.1716,28H4V24.8284l9.8023-9.8023.8472-.8474-.3473-1.1467A7,7,0,1,1,21,18Z"
    })), _circle26$5 || (_circle26$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "10",
      r: "2"
    })), children);
  });
  var Password20 = /*#__PURE__*/React__default['default'].forwardRef(function Password20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$a || (_path201$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2a8.9977,8.9977,0,0,0-8.6119,11.6118L2,24v6H8L18.3881,19.6118A9,9,0,1,0,21,2Zm0,16a7.0125,7.0125,0,0,1-2.0322-.3022L17.821,17.35l-.8472.8472-3.1811,3.1812L12.4141,20,11,21.4141l1.3787,1.3786-1.5859,1.586L9.4141,23,8,24.4141l1.3787,1.3786L7.1716,28H4V24.8284l9.8023-9.8023.8472-.8474-.3473-1.1467A7,7,0,1,1,21,18Z"
    })), _circle27$5 || (_circle27$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "10",
      r: "2"
    })), children);
  });
  var Password16 = /*#__PURE__*/React__default['default'].forwardRef(function Password16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$a || (_path202$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2a8.9977,8.9977,0,0,0-8.6119,11.6118L2,24v6H8L18.3881,19.6118A9,9,0,1,0,21,2Zm0,16a7.0125,7.0125,0,0,1-2.0322-.3022L17.821,17.35l-.8472.8472-3.1811,3.1812L12.4141,20,11,21.4141l1.3787,1.3786-1.5859,1.586L9.4141,23,8,24.4141l1.3787,1.3786L7.1716,28H4V24.8284l9.8023-9.8023.8472-.8474-.3473-1.1467A7,7,0,1,1,21,18Z"
    })), _circle28$5 || (_circle28$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "10",
      r: "2"
    })), children);
  });
  var Paste32 = /*#__PURE__*/React__default['default'].forwardRef(function Paste32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$a || (_path203$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"
    })), _path204$a || (_path204$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"
    })), children);
  });
  var Paste24 = /*#__PURE__*/React__default['default'].forwardRef(function Paste24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$a || (_path205$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"
    })), _path206$a || (_path206$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"
    })), children);
  });
  var Paste20 = /*#__PURE__*/React__default['default'].forwardRef(function Paste20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$a || (_path207$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"
    })), _path208$a || (_path208$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"
    })), children);
  });
  var Paste16 = /*#__PURE__*/React__default['default'].forwardRef(function Paste16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$a || (_path209$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"
    })), _path210$a || (_path210$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"
    })), children);
  });
  var Pause32 = /*#__PURE__*/React__default['default'].forwardRef(function Pause32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$a || (_path211$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8V24H8V8h4m0-2H8A2 2 0 006 8V24a2 2 0 002 2h4a2 2 0 002-2V8a2 2 0 00-2-2zM24 8V24H20V8h4m0-2H20a2 2 0 00-2 2V24a2 2 0 002 2h4a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var Pause24 = /*#__PURE__*/React__default['default'].forwardRef(function Pause24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$a || (_path212$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8V24H8V8h4m0-2H8A2 2 0 006 8V24a2 2 0 002 2h4a2 2 0 002-2V8a2 2 0 00-2-2zM24 8V24H20V8h4m0-2H20a2 2 0 00-2 2V24a2 2 0 002 2h4a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var Pause20 = /*#__PURE__*/React__default['default'].forwardRef(function Pause20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$a || (_path213$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 8V24H8V8h4m0-2H8A2 2 0 006 8V24a2 2 0 002 2h4a2 2 0 002-2V8a2 2 0 00-2-2zM24 8V24H20V8h4m0-2H20a2 2 0 00-2 2V24a2 2 0 002 2h4a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var Pause16 = /*#__PURE__*/React__default['default'].forwardRef(function Pause16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$a || (_path214$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 4v8H4V4H6M6 3H4C3.4 3 3 3.4 3 4v8c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V4C7 3.4 6.6 3 6 3zM12 4v8h-2V4H12M12 3h-2C9.4 3 9 3.4 9 4v8c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V4C13 3.4 12.6 3 12 3z"
    })), children);
  });
  var PauseFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFilled32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$a || (_path215$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H10A2 2 0 008 8V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2zM22 6H20a2 2 0 00-2 2V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var PauseFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFilled24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$a || (_path216$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H10A2 2 0 008 8V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2zM22 6H20a2 2 0 00-2 2V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var PauseFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFilled20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$a || (_path217$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H10A2 2 0 008 8V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2zM22 6H20a2 2 0 00-2 2V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var PauseFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFilled16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$a || (_path218$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H10A2 2 0 008 8V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2zM22 6H20a2 2 0 00-2 2V24a2 2 0 002 2h2a2 2 0 002-2V8a2 2 0 00-2-2z"
    })), children);
  });
  var PauseOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutline32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$a || (_path219$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10L12 10 12 22 14 22 14 10 14 10zM20 10L18 10 18 22 20 22 20 10 20 10z"
    })), _path220$a || (_path220$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var PauseOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutline24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$a || (_path221$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10L12 10 12 22 14 22 14 10 14 10zM20 10L18 10 18 22 20 22 20 10 20 10z"
    })), _path222$a || (_path222$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var PauseOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutline20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$a || (_path223$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 10L12 10 12 22 14 22 14 10 14 10zM20 10L18 10 18 22 20 22 20 10 20 10z"
    })), _path224$a || (_path224$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var PauseOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutline16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$a || (_path225$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 5L6 5 6 11 7 11 7 5zM10 5L9 5 9 11 10 11 10 5z"
    })), _path226$a || (_path226$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"
    })), children);
  });
  var PauseOutlineFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutlineFilled32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$a || (_path227$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,22H12V10h2Zm6,0H18V10h2Z"
    })), children);
  });
  var PauseOutlineFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutlineFilled24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$a || (_path228$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,22H12V10h2Zm6,0H18V10h2Z"
    })), children);
  });
  var PauseOutlineFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutlineFilled20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$a || (_path229$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,22H12V10h2Zm6,0H18V10h2Z"
    })), children);
  });
  var PauseOutlineFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PauseOutlineFilled16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$a || (_path230$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M7,11H6V5h1V11z M10,11H9V5h1V11z"
    })), children);
  });
  var PauseFuture32 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFuture32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$a || (_path231$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path232$a || (_path232$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var PauseFuture24 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFuture24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$a || (_path233$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path234$a || (_path234$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var PauseFuture20 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFuture20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$a || (_path235$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path236$a || (_path236$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var PauseFuture16 = /*#__PURE__*/React__default['default'].forwardRef(function PauseFuture16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$a || (_path237$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path238$a || (_path238$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var PausePast32 = /*#__PURE__*/React__default['default'].forwardRef(function PausePast32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$a || (_path239$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path240$a || (_path240$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,0,6,6.2343V2H4v8h8V8H7.0783A11.9818,11.9818,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var PausePast24 = /*#__PURE__*/React__default['default'].forwardRef(function PausePast24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$a || (_path241$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path242$a || (_path242$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,0,6,6.2343V2H4v8h8V8H7.0783A11.9818,11.9818,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var PausePast20 = /*#__PURE__*/React__default['default'].forwardRef(function PausePast20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$a || (_path243$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path244$a || (_path244$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,0,6,6.2343V2H4v8h8V8H7.0783A11.9818,11.9818,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var PausePast16 = /*#__PURE__*/React__default['default'].forwardRef(function PausePast16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$a || (_path245$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11L12 11 12 22 14 22 14 11 14 11zM20 11L18 11 18 22 20 22 20 11 20 11z"
    })), _path246$a || (_path246$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,0,6,6.2343V2H4v8h8V8H7.0783A11.9818,11.9818,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var PcnENode32 = /*#__PURE__*/React__default['default'].forwardRef(function PcnENode32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$a || (_path247$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), _path248$a || (_path248$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnENode24 = /*#__PURE__*/React__default['default'].forwardRef(function PcnENode24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$a || (_path249$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), _path250$a || (_path250$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnENode20 = /*#__PURE__*/React__default['default'].forwardRef(function PcnENode20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$a || (_path251$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), _path252$a || (_path252$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnENode16 = /*#__PURE__*/React__default['default'].forwardRef(function PcnENode16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$a || (_path253$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 11L20 9 12 9 12 23 20 23 20 21 14 21 14 17 19 17 19 15 14 15 14 11 20 11z"
    })), _path254$a || (_path254$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnMilitary32 = /*#__PURE__*/React__default['default'].forwardRef(function PcnMilitary32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$a || (_path255$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16L14.407 19 11 19.414 13.5 21.667 13 25 16 23.125 19 25 18.5 21.667 21 19.414 17.5 19 16 16z"
    })), _path256$a || (_path256$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 17.414L16 13.834 16 13.834 19.588 17.416 21 16 16 11 11 16 12.414 17.414z"
    })), _path257$a || (_path257$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 12.414L16 8.834 16 8.834 19.588 12.416 21 11 16 6 11 11 12.414 12.414z"
    })), _path258$a || (_path258$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnMilitary24 = /*#__PURE__*/React__default['default'].forwardRef(function PcnMilitary24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$a || (_path259$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16L14.407 19 11 19.414 13.5 21.667 13 25 16 23.125 19 25 18.5 21.667 21 19.414 17.5 19 16 16z"
    })), _path260$a || (_path260$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 17.414L16 13.834 16 13.834 19.588 17.416 21 16 16 11 11 16 12.414 17.414z"
    })), _path261$a || (_path261$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 12.414L16 8.834 16 8.834 19.588 12.416 21 11 16 6 11 11 12.414 12.414z"
    })), _path262$a || (_path262$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnMilitary20 = /*#__PURE__*/React__default['default'].forwardRef(function PcnMilitary20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$a || (_path263$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16L14.407 19 11 19.414 13.5 21.667 13 25 16 23.125 19 25 18.5 21.667 21 19.414 17.5 19 16 16z"
    })), _path264$a || (_path264$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 17.414L16 13.834 16 13.834 19.588 17.416 21 16 16 11 11 16 12.414 17.414z"
    })), _path265$a || (_path265$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 12.414L16 8.834 16 8.834 19.588 12.416 21 11 16 6 11 11 12.414 12.414z"
    })), _path266$a || (_path266$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnMilitary16 = /*#__PURE__*/React__default['default'].forwardRef(function PcnMilitary16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$a || (_path267$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 16L14.407 19 11 19.414 13.5 21.667 13 25 16 23.125 19 25 18.5 21.667 21 19.414 17.5 19 16 16z"
    })), _path268$a || (_path268$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 17.414L16 13.834 16 13.834 19.588 17.416 21 16 16 11 11 16 12.414 17.414z"
    })), _path269$a || (_path269$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.414 12.414L16 8.834 16 8.834 19.588 12.416 21 11 16 6 11 11 12.414 12.414z"
    })), _path270$a || (_path270$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnPNode32 = /*#__PURE__*/React__default['default'].forwardRef(function PcnPNode32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$a || (_path271$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V10.9985H14Z"
    })), _path272$a || (_path272$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnPNode24 = /*#__PURE__*/React__default['default'].forwardRef(function PcnPNode24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$a || (_path273$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V10.9985H14Z"
    })), _path274$a || (_path274$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnPNode20 = /*#__PURE__*/React__default['default'].forwardRef(function PcnPNode20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$a || (_path275$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V10.9985H14Z"
    })), _path276$a || (_path276$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnPNode16 = /*#__PURE__*/React__default['default'].forwardRef(function PcnPNode16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$a || (_path277$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,23H12V9h6a2.002,2.002,0,0,1,2,2v5a2.002,2.002,0,0,1-2,2H14Zm0-7h4V10.9985H14Z"
    })), _path278$a || (_path278$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnZNode32 = /*#__PURE__*/React__default['default'].forwardRef(function PcnZNode32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$a || (_path279$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), _path280$a || (_path280$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnZNode24 = /*#__PURE__*/React__default['default'].forwardRef(function PcnZNode24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$a || (_path281$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), _path282$a || (_path282$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnZNode20 = /*#__PURE__*/React__default['default'].forwardRef(function PcnZNode20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$a || (_path283$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), _path284$a || (_path284$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var PcnZNode16 = /*#__PURE__*/React__default['default'].forwardRef(function PcnZNode16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$a || (_path285$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), _path286$a || (_path286$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.4141,17.4141a1.9995,1.9995,0,0,0,0-2.8282L24.6272,8.7993l2.9006-2.8628a2.0018,2.0018,0,1,0-1.4416-1.3872L23.2129,7.3848,17.4141,1.5859a1.9995,1.9995,0,0,0-2.8282,0L8.7993,7.3726,5.9368,4.4717A2.002,2.002,0,1,0,4.55,5.9136l2.835,2.8735L1.5859,14.5859a1.9995,1.9995,0,0,0,0,2.8282l5.7989,5.7988L4.55,26.0864a1.9977,1.9977,0,1,0,1.387,1.4419l2.8625-2.9009,5.7866,5.7867a1.9995,1.9995,0,0,0,2.8282,0l5.7988-5.7989,2.8733,2.8355a1.998,1.998,0,1,0,1.4416-1.3872l-2.9006-2.8628ZM16,29,3,16,16,3,29,16Z"
    })), children);
  });
  var Pdf32 = /*#__PURE__*/React__default['default'].forwardRef(function Pdf32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$a || (_path287$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 002-2V11A2 2 0 008 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14z"
    })), children);
  });
  var Pdf24 = /*#__PURE__*/React__default['default'].forwardRef(function Pdf24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$a || (_path288$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 002-2V11A2 2 0 008 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14z"
    })), children);
  });
  var Pdf20 = /*#__PURE__*/React__default['default'].forwardRef(function Pdf20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$a || (_path289$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 002-2V11A2 2 0 008 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14z"
    })), children);
  });
  var Pdf16 = /*#__PURE__*/React__default['default'].forwardRef(function Pdf16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$a || (_path290$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 002-2V11A2 2 0 008 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 014 4v6A4 4 0 0116 23zm-2-2h2a2 2 0 002-2V13a2 2 0 00-2-2H14z"
    })), children);
  });
  var PdfReference32 = /*#__PURE__*/React__default['default'].forwardRef(function PdfReference32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$a || (_path291$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM22 16L24 16 24 10 29 10 29 8 24 8 24 4 30 4 30 2 22 2 22 16zM16 2H12V16h4a4 4 0 004-4V6A4 4 0 0016 2zm2 10a2 2 0 01-2 2H14V4h2a2 2 0 012 2zM8 2H2V16H4V11H8a2 2 0 002-2V4A2 2 0 008 2zM8 9H4V4H8z"
    })), children);
  });
  var PdfReference24 = /*#__PURE__*/React__default['default'].forwardRef(function PdfReference24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$a || (_path292$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM22 16L24 16 24 10 29 10 29 8 24 8 24 4 30 4 30 2 22 2 22 16zM16 2H12V16h4a4 4 0 004-4V6A4 4 0 0016 2zm2 10a2 2 0 01-2 2H14V4h2a2 2 0 012 2zM8 2H2V16H4V11H8a2 2 0 002-2V4A2 2 0 008 2zM8 9H4V4H8z"
    })), children);
  });
  var PdfReference20 = /*#__PURE__*/React__default['default'].forwardRef(function PdfReference20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$a || (_path293$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM22 16L24 16 24 10 29 10 29 8 24 8 24 4 30 4 30 2 22 2 22 16zM16 2H12V16h4a4 4 0 004-4V6A4 4 0 0016 2zm2 10a2 2 0 01-2 2H14V4h2a2 2 0 012 2zM8 2H2V16H4V11H8a2 2 0 002-2V4A2 2 0 008 2zM8 9H4V4H8z"
    })), children);
  });
  var PdfReference16 = /*#__PURE__*/React__default['default'].forwardRef(function PdfReference16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$a || (_path294$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM22 16L24 16 24 10 29 10 29 8 24 8 24 4 30 4 30 2 22 2 22 16zM16 2H12V16h4a4 4 0 004-4V6A4 4 0 0016 2zm2 10a2 2 0 01-2 2H14V4h2a2 2 0 012 2zM8 2H2V16H4V11H8a2 2 0 002-2V4A2 2 0 008 2zM8 9H4V4H8z"
    })), children);
  });
  var Pedestrian32 = /*#__PURE__*/React__default['default'].forwardRef(function Pedestrian32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$a || (_path295$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"
    })), _path296$a || (_path296$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1120 4.5 3.5042 3.5042 0 0116.5 8zm0-5A1.5 1.5 0 1018 4.5 1.5017 1.5017 0 0016.5 3z"
    })), children);
  });
  var Pedestrian24 = /*#__PURE__*/React__default['default'].forwardRef(function Pedestrian24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$a || (_path297$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"
    })), _path298$a || (_path298$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1120 4.5 3.5042 3.5042 0 0116.5 8zm0-5A1.5 1.5 0 1018 4.5 1.5017 1.5017 0 0016.5 3z"
    })), children);
  });
  var Pedestrian20 = /*#__PURE__*/React__default['default'].forwardRef(function Pedestrian20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$a || (_path299$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"
    })), _path300$a || (_path300$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1120 4.5 3.5042 3.5042 0 0116.5 8zm0-5A1.5 1.5 0 1018 4.5 1.5017 1.5017 0 0016.5 3z"
    })), children);
  });
  var Pedestrian16 = /*#__PURE__*/React__default['default'].forwardRef(function Pedestrian16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$a || (_path301$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"
    })), _path302$a || (_path302$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1120 4.5 3.5042 3.5042 0 0116.5 8zm0-5A1.5 1.5 0 1018 4.5 1.5017 1.5017 0 0016.5 3z"
    })), children);
  });
  var PedestrianFamily32 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianFamily32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$a || (_path303$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 30H17a2.0021 2.0021 0 01-2-2V23h2v5h3V23h2V19a1.0011 1.0011 0 00-1-1H12.2793l-2-6H4a1.0011 1.0011 0 00-1 1v6H5v9H9V21h2v7a2.0021 2.0021 0 01-2 2H5a2.0021 2.0021 0 01-2-2V21a2.0021 2.0021 0 01-2-2V13a3.0033 3.0033 0 013-3h6.2793a1.998 1.998 0 011.8975 1.3674L13.7207 16H21a3.0033 3.0033 0 013 3v4a2.0021 2.0021 0 01-2 2v3A2.0021 2.0021 0 0120 30zM28 30H26V19h3V13a1.0011 1.0011 0 00-1-1H24V10h4a3.0033 3.0033 0 013 3v6a2.0021 2.0021 0 01-2 2H28zM7 9a4 4 0 114-4A4.0045 4.0045 0 017 9zM7 3A2 2 0 109 5 2.0021 2.0021 0 007 3zM25 9a4 4 0 114-4A4.0045 4.0045 0 0125 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0025 3z"
    })), _path304$a || (_path304$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.5,15A3.5,3.5,0,1,1,22,11.5,3.5041,3.5041,0,0,1,18.5,15Zm0-5A1.5,1.5,0,1,0,20,11.5,1.5017,1.5017,0,0,0,18.5,10Z"
    })), children);
  });
  var PedestrianFamily24 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianFamily24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$a || (_path305$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 30H17a2.0021 2.0021 0 01-2-2V23h2v5h3V23h2V19a1.0011 1.0011 0 00-1-1H12.2793l-2-6H4a1.0011 1.0011 0 00-1 1v6H5v9H9V21h2v7a2.0021 2.0021 0 01-2 2H5a2.0021 2.0021 0 01-2-2V21a2.0021 2.0021 0 01-2-2V13a3.0033 3.0033 0 013-3h6.2793a1.998 1.998 0 011.8975 1.3674L13.7207 16H21a3.0033 3.0033 0 013 3v4a2.0021 2.0021 0 01-2 2v3A2.0021 2.0021 0 0120 30zM28 30H26V19h3V13a1.0011 1.0011 0 00-1-1H24V10h4a3.0033 3.0033 0 013 3v6a2.0021 2.0021 0 01-2 2H28zM7 9a4 4 0 114-4A4.0045 4.0045 0 017 9zM7 3A2 2 0 109 5 2.0021 2.0021 0 007 3zM25 9a4 4 0 114-4A4.0045 4.0045 0 0125 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0025 3z"
    })), _path306$a || (_path306$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.5,15A3.5,3.5,0,1,1,22,11.5,3.5041,3.5041,0,0,1,18.5,15Zm0-5A1.5,1.5,0,1,0,20,11.5,1.5017,1.5017,0,0,0,18.5,10Z"
    })), children);
  });
  var PedestrianFamily20 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianFamily20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$a || (_path307$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 30H17a2.0021 2.0021 0 01-2-2V23h2v5h3V23h2V19a1.0011 1.0011 0 00-1-1H12.2793l-2-6H4a1.0011 1.0011 0 00-1 1v6H5v9H9V21h2v7a2.0021 2.0021 0 01-2 2H5a2.0021 2.0021 0 01-2-2V21a2.0021 2.0021 0 01-2-2V13a3.0033 3.0033 0 013-3h6.2793a1.998 1.998 0 011.8975 1.3674L13.7207 16H21a3.0033 3.0033 0 013 3v4a2.0021 2.0021 0 01-2 2v3A2.0021 2.0021 0 0120 30zM28 30H26V19h3V13a1.0011 1.0011 0 00-1-1H24V10h4a3.0033 3.0033 0 013 3v6a2.0021 2.0021 0 01-2 2H28zM7 9a4 4 0 114-4A4.0045 4.0045 0 017 9zM7 3A2 2 0 109 5 2.0021 2.0021 0 007 3zM25 9a4 4 0 114-4A4.0045 4.0045 0 0125 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0025 3z"
    })), _path308$a || (_path308$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.5,15A3.5,3.5,0,1,1,22,11.5,3.5041,3.5041,0,0,1,18.5,15Zm0-5A1.5,1.5,0,1,0,20,11.5,1.5017,1.5017,0,0,0,18.5,10Z"
    })), children);
  });
  var PedestrianFamily16 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianFamily16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$a || (_path309$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 30H17a2.0021 2.0021 0 01-2-2V23h2v5h3V23h2V19a1.0011 1.0011 0 00-1-1H12.2793l-2-6H4a1.0011 1.0011 0 00-1 1v6H5v9H9V21h2v7a2.0021 2.0021 0 01-2 2H5a2.0021 2.0021 0 01-2-2V21a2.0021 2.0021 0 01-2-2V13a3.0033 3.0033 0 013-3h6.2793a1.998 1.998 0 011.8975 1.3674L13.7207 16H21a3.0033 3.0033 0 013 3v4a2.0021 2.0021 0 01-2 2v3A2.0021 2.0021 0 0120 30zM28 30H26V19h3V13a1.0011 1.0011 0 00-1-1H24V10h4a3.0033 3.0033 0 013 3v6a2.0021 2.0021 0 01-2 2H28zM7 9a4 4 0 114-4A4.0045 4.0045 0 017 9zM7 3A2 2 0 109 5 2.0021 2.0021 0 007 3zM25 9a4 4 0 114-4A4.0045 4.0045 0 0125 9zm0-6a2 2 0 102 2A2.0021 2.0021 0 0025 3z"
    })), _path310$a || (_path310$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.5,15A3.5,3.5,0,1,1,22,11.5,3.5041,3.5041,0,0,1,18.5,15Zm0-5A1.5,1.5,0,1,0,20,11.5,1.5017,1.5017,0,0,0,18.5,10Z"
    })), children);
  });
  var PedestrianChild32 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianChild32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$a || (_path311$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"
    })), _path312$a || (_path312$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 15A3.5 3.5 0 1127 11.5 3.5042 3.5042 0 0123.5 15zm0-5A1.5 1.5 0 1025 11.5 1.5017 1.5017 0 0023.5 10zM8 9a4 4 0 114-4A4.0042 4.0042 0 018 9zM8 3a2 2 0 102 2A2.0023 2.0023 0 008 3z"
    })), children);
  });
  var PedestrianChild24 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianChild24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$a || (_path313$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"
    })), _path314$a || (_path314$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 15A3.5 3.5 0 1127 11.5 3.5042 3.5042 0 0123.5 15zm0-5A1.5 1.5 0 1025 11.5 1.5017 1.5017 0 0023.5 10zM8 9a4 4 0 114-4A4.0042 4.0042 0 018 9zM8 3a2 2 0 102 2A2.0023 2.0023 0 008 3z"
    })), children);
  });
  var PedestrianChild20 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianChild20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$a || (_path315$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"
    })), _path316$a || (_path316$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 15A3.5 3.5 0 1127 11.5 3.5042 3.5042 0 0123.5 15zm0-5A1.5 1.5 0 1025 11.5 1.5017 1.5017 0 0023.5 10zM8 9a4 4 0 114-4A4.0042 4.0042 0 018 9zM8 3a2 2 0 102 2A2.0023 2.0023 0 008 3z"
    })), children);
  });
  var PedestrianChild16 = /*#__PURE__*/React__default['default'].forwardRef(function PedestrianChild16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$a || (_path317$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"
    })), _path318$a || (_path318$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 15A3.5 3.5 0 1127 11.5 3.5042 3.5042 0 0123.5 15zm0-5A1.5 1.5 0 1025 11.5 1.5017 1.5017 0 0023.5 10zM8 9a4 4 0 114-4A4.0042 4.0042 0 018 9zM8 3a2 2 0 102 2A2.0023 2.0023 0 008 3z"
    })), children);
  });
  var Pen32 = /*#__PURE__*/React__default['default'].forwardRef(function Pen32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$a || (_path319$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3069,6.1069,30,3.4141,28.5859,2,25.8931,4.6929,24.8,3.6a1.9328,1.9328,0,0,0-2.8,0L4,21.6V28h6.4l18-18a1.9329,1.9329,0,0,0,0-2.8ZM9.6,26H6V22.4L23.4,5,27,8.6Z"
    })), _path320$a || (_path320$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.136 7.5H18.863999999999997V9.5H8.136z",
      transform: "rotate(-45 13.5 8.5)"
    })), children);
  });
  var Pen24 = /*#__PURE__*/React__default['default'].forwardRef(function Pen24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$a || (_path321$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3069,6.1069,30,3.4141,28.5859,2,25.8931,4.6929,24.8,3.6a1.9328,1.9328,0,0,0-2.8,0L4,21.6V28h6.4l18-18a1.9329,1.9329,0,0,0,0-2.8ZM9.6,26H6V22.4L23.4,5,27,8.6Z"
    })), _path322$a || (_path322$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.136 7.5H18.863999999999997V9.5H8.136z",
      transform: "rotate(-45 13.5 8.5)"
    })), children);
  });
  var Pen20 = /*#__PURE__*/React__default['default'].forwardRef(function Pen20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$a || (_path323$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3069,6.1069,30,3.4141,28.5859,2,25.8931,4.6929,24.8,3.6a1.9328,1.9328,0,0,0-2.8,0L4,21.6V28h6.4l18-18a1.9329,1.9329,0,0,0,0-2.8ZM9.6,26H6V22.4L23.4,5,27,8.6Z"
    })), _path324$a || (_path324$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.136 7.5H18.863999999999997V9.5H8.136z",
      transform: "rotate(-45 13.5 8.5)"
    })), children);
  });
  var Pen16 = /*#__PURE__*/React__default['default'].forwardRef(function Pen16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$a || (_path325$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3069,6.1069,30,3.4141,28.5859,2,25.8931,4.6929,24.8,3.6a1.9328,1.9328,0,0,0-2.8,0L4,21.6V28h6.4l18-18a1.9329,1.9329,0,0,0,0-2.8ZM9.6,26H6V22.4L23.4,5,27,8.6Z"
    })), _path326$a || (_path326$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.136 7.5H18.863999999999997V9.5H8.136z",
      transform: "rotate(-45 13.5 8.5)"
    })), children);
  });
  var PenFountain32 = /*#__PURE__*/React__default['default'].forwardRef(function PenFountain32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$a || (_path327$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,5.293l-3-3a.9994.9994,0,0,0-1.414,0L19.5859,8H17.0947A11.0118,11.0118,0,0,0,6.7124,15.3662L2.0562,28.67a1,1,0,0,0,1.2744,1.2739l13.3037-4.6562A11.012,11.012,0,0,0,24,14.9053V12.4141L29.707,6.707A.9994.9994,0,0,0,29.707,5.293Zm-7.414,6A1,1,0,0,0,22,12v2.9053A9.01,9.01,0,0,1,15.9731,23.4l-9.1677,3.209L16,17.4141,14.5859,16,5.3914,25.1948,8.6,16.0269A9.01,9.01,0,0,1,17.0947,10H20a1,1,0,0,0,.707-.293L26,4.4141,27.5859,6Z"
    })), children);
  });
  var PenFountain24 = /*#__PURE__*/React__default['default'].forwardRef(function PenFountain24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$a || (_path328$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,5.293l-3-3a.9994.9994,0,0,0-1.414,0L19.5859,8H17.0947A11.0118,11.0118,0,0,0,6.7124,15.3662L2.0562,28.67a1,1,0,0,0,1.2744,1.2739l13.3037-4.6562A11.012,11.012,0,0,0,24,14.9053V12.4141L29.707,6.707A.9994.9994,0,0,0,29.707,5.293Zm-7.414,6A1,1,0,0,0,22,12v2.9053A9.01,9.01,0,0,1,15.9731,23.4l-9.1677,3.209L16,17.4141,14.5859,16,5.3914,25.1948,8.6,16.0269A9.01,9.01,0,0,1,17.0947,10H20a1,1,0,0,0,.707-.293L26,4.4141,27.5859,6Z"
    })), children);
  });
  var PenFountain20 = /*#__PURE__*/React__default['default'].forwardRef(function PenFountain20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$a || (_path329$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,5.293l-3-3a.9994.9994,0,0,0-1.414,0L19.5859,8H17.0947A11.0118,11.0118,0,0,0,6.7124,15.3662L2.0562,28.67a1,1,0,0,0,1.2744,1.2739l13.3037-4.6562A11.012,11.012,0,0,0,24,14.9053V12.4141L29.707,6.707A.9994.9994,0,0,0,29.707,5.293Zm-7.414,6A1,1,0,0,0,22,12v2.9053A9.01,9.01,0,0,1,15.9731,23.4l-9.1677,3.209L16,17.4141,14.5859,16,5.3914,25.1948,8.6,16.0269A9.01,9.01,0,0,1,17.0947,10H20a1,1,0,0,0,.707-.293L26,4.4141,27.5859,6Z"
    })), children);
  });
  var PenFountain16 = /*#__PURE__*/React__default['default'].forwardRef(function PenFountain16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$a || (_path330$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707,5.293l-3-3a.9994.9994,0,0,0-1.414,0L19.5859,8H17.0947A11.0118,11.0118,0,0,0,6.7124,15.3662L2.0562,28.67a1,1,0,0,0,1.2744,1.2739l13.3037-4.6562A11.012,11.012,0,0,0,24,14.9053V12.4141L29.707,6.707A.9994.9994,0,0,0,29.707,5.293Zm-7.414,6A1,1,0,0,0,22,12v2.9053A9.01,9.01,0,0,1,15.9731,23.4l-9.1677,3.209L16,17.4141,14.5859,16,5.3914,25.1948,8.6,16.0269A9.01,9.01,0,0,1,17.0947,10H20a1,1,0,0,0,.707-.293L26,4.4141,27.5859,6Z"
    })), children);
  });
  var Pending32 = /*#__PURE__*/React__default['default'].forwardRef(function Pending32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29$5 || (_circle29$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _circle30$5 || (_circle30$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle31$5 || (_circle31$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path331$a || (_path331$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Pending24 = /*#__PURE__*/React__default['default'].forwardRef(function Pending24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle32$5 || (_circle32$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _circle33$5 || (_circle33$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle34$4 || (_circle34$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path332$a || (_path332$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Pending20 = /*#__PURE__*/React__default['default'].forwardRef(function Pending20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle35$4 || (_circle35$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _circle36$4 || (_circle36$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle37$3 || (_circle37$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path333$a || (_path333$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Pending16 = /*#__PURE__*/React__default['default'].forwardRef(function Pending16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle38$3 || (_circle38$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _circle39$3 || (_circle39$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle40$3 || (_circle40$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _path334$a || (_path334$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var PendingFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PendingFilled32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$a || (_path335$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,18a2,2,0,1,1,2-2A2,2,0,0,1,8,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,16,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,24,18Z"
    })), _path336$a || (_path336$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M10,16a2,2,0,1,1-2-2A2,2,0,0,1,10,16Zm6-2a2,2,0,1,0,2,2A2,2,0,0,0,16,14Zm8,0a2,2,0,1,0,2,2A2,2,0,0,0,24,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PendingFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PendingFilled24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$a || (_path337$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,18a2,2,0,1,1,2-2A2,2,0,0,1,8,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,16,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,24,18Z"
    })), _path338$a || (_path338$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M10,16a2,2,0,1,1-2-2A2,2,0,0,1,10,16Zm6-2a2,2,0,1,0,2,2A2,2,0,0,0,16,14Zm8,0a2,2,0,1,0,2,2A2,2,0,0,0,24,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PendingFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PendingFilled20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$a || (_path339$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,18a2,2,0,1,1,2-2A2,2,0,0,1,8,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,16,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,24,18Z"
    })), _path340$a || (_path340$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M10,16a2,2,0,1,1-2-2A2,2,0,0,1,10,16Zm6-2a2,2,0,1,0,2,2A2,2,0,0,0,16,14Zm8,0a2,2,0,1,0,2,2A2,2,0,0,0,24,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PendingFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PendingFilled16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$a || (_path341$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,18a2,2,0,1,1,2-2A2,2,0,0,1,8,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,16,18Zm8,0a2,2,0,1,1,2-2A2,2,0,0,1,24,18Z"
    })), _path342$a || (_path342$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M10,16a2,2,0,1,1-2-2A2,2,0,0,1,10,16Zm6-2a2,2,0,1,0,2,2A2,2,0,0,0,16,14Zm8,0a2,2,0,1,0,2,2A2,2,0,0,0,24,14Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var Percentage32 = /*#__PURE__*/React__default['default'].forwardRef(function Percentage32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$a || (_path343$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"
    })), _path344$a || (_path344$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path345$a || (_path345$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"
    })), children);
  });
  var Percentage24 = /*#__PURE__*/React__default['default'].forwardRef(function Percentage24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$a || (_path346$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"
    })), _path347$a || (_path347$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path348$a || (_path348$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"
    })), children);
  });
  var Percentage20 = /*#__PURE__*/React__default['default'].forwardRef(function Percentage20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$a || (_path349$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"
    })), _path350$a || (_path350$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path351$a || (_path351$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"
    })), children);
  });
  var Percentage16 = /*#__PURE__*/React__default['default'].forwardRef(function Percentage16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$a || (_path352$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"
    })), _path353$a || (_path353$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path354$a || (_path354$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"
    })), children);
  });
  var PercentageFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PercentageFilled32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$9 || (_path355$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"
    })), _path356$9 || (_path356$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path357$9 || (_path357$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"
    })), children);
  });
  var PercentageFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PercentageFilled24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$9 || (_path358$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"
    })), _path359$9 || (_path359$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path360$9 || (_path360$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"
    })), children);
  });
  var PercentageFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PercentageFilled20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$9 || (_path361$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"
    })), _path362$9 || (_path362$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path363$9 || (_path363$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"
    })), children);
  });
  var PercentageFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PercentageFilled16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$9 || (_path364$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"
    })), _path365$9 || (_path365$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M0.029 15H31.97V17H0.029z",
      transform: "rotate(-45 16 16)"
    })), _path366$9 || (_path366$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"
    })), children);
  });
  var Person32 = /*#__PURE__*/React__default['default'].forwardRef(function Person32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$9 || (_path367$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30H14a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h6a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0118 30zM13 12a.94.94 0 00-1 1v6h2v9h4V19h2V13a.94.94 0 00-1-1zM16 9a4 4 0 114-4h0A4 4 0 0116 9zm0-6a2 2 0 102 2h0a2 2 0 00-2-2z"
    })), children);
  });
  var Person24 = /*#__PURE__*/React__default['default'].forwardRef(function Person24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$9 || (_path368$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30H14a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h6a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0118 30zM13 12a.94.94 0 00-1 1v6h2v9h4V19h2V13a.94.94 0 00-1-1zM16 9a4 4 0 114-4h0A4 4 0 0116 9zm0-6a2 2 0 102 2h0a2 2 0 00-2-2z"
    })), children);
  });
  var Person20 = /*#__PURE__*/React__default['default'].forwardRef(function Person20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$9 || (_path369$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30H14a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h6a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0118 30zM13 12a.94.94 0 00-1 1v6h2v9h4V19h2V13a.94.94 0 00-1-1zM16 9a4 4 0 114-4h0A4 4 0 0116 9zm0-6a2 2 0 102 2h0a2 2 0 00-2-2z"
    })), children);
  });
  var Person16 = /*#__PURE__*/React__default['default'].forwardRef(function Person16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$9 || (_path370$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30H14a2 2 0 01-2-2V21a2 2 0 01-2-2V13a3 3 0 013-3h6a3 3 0 013 3v6a2 2 0 01-2 2v7A2 2 0 0118 30zM13 12a.94.94 0 00-1 1v6h2v9h4V19h2V13a.94.94 0 00-1-1zM16 9a4 4 0 114-4h0A4 4 0 0116 9zm0-6a2 2 0 102 2h0a2 2 0 00-2-2z"
    })), children);
  });
  var PersonFavorite32 = /*#__PURE__*/React__default['default'].forwardRef(function PersonFavorite32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$9 || (_path371$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 31H6a2.0059 2.0059 0 01-2-2V22a2.0059 2.0059 0 01-2-2V14a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0110 31zM5 13a.9448.9448 0 00-1 1v6H6v9h4V20h2V14a.9448.9448 0 00-1-1zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4zM28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948z"
    })), children);
  });
  var PersonFavorite24 = /*#__PURE__*/React__default['default'].forwardRef(function PersonFavorite24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$9 || (_path372$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 31H6a2.0059 2.0059 0 01-2-2V22a2.0059 2.0059 0 01-2-2V14a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0110 31zM5 13a.9448.9448 0 00-1 1v6H6v9h4V20h2V14a.9448.9448 0 00-1-1zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4zM28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948z"
    })), children);
  });
  var PersonFavorite20 = /*#__PURE__*/React__default['default'].forwardRef(function PersonFavorite20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$9 || (_path373$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 31H6a2.0059 2.0059 0 01-2-2V22a2.0059 2.0059 0 01-2-2V14a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0110 31zM5 13a.9448.9448 0 00-1 1v6H6v9h4V20h2V14a.9448.9448 0 00-1-1zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4zM28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948z"
    })), children);
  });
  var PersonFavorite16 = /*#__PURE__*/React__default['default'].forwardRef(function PersonFavorite16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$9 || (_path374$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 31H6a2.0059 2.0059 0 01-2-2V22a2.0059 2.0059 0 01-2-2V14a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0110 31zM5 13a.9448.9448 0 00-1 1v6H6v9h4V20h2V14a.9448.9448 0 00-1-1zM8 10a4 4 0 114-4A4.0045 4.0045 0 018 10zM8 4a2 2 0 102 2A2.002 2.002 0 008 4zM28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948z"
    })), children);
  });
  var Pest32 = /*#__PURE__*/React__default['default'].forwardRef(function Pest32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle41$3 || (_circle41$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "9.5",
      r: "1.5"
    })), _circle42$3 || (_circle42$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "13",
      r: "1"
    })), _circle43$3 || (_circle43$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "21",
      r: "1"
    })), _path375$9 || (_path375$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14a8.9844,8.9844,0,0,0-7,3.3555V13a10.9054,10.9054,0,0,0-1.0093-4.5845l-.3569-.7768L15.811,7.87A2.9549,2.9549,0,0,1,15,8a3.0033,3.0033,0,0,1-3-3,2.9574,2.9574,0,0,1,.1294-.8105l.2324-.8233-.7773-.3569A10.9115,10.9115,0,0,0,7,2H2V9a10.8954,10.8954,0,0,0,2.2339,6.627l.3887.4277.54-.0381a5.5286,5.5286,0,0,1,5.3628,3.2559l.2207.497.5376.0845A11.0219,11.0219,0,0,0,13,20h3V30h2V26h3a9.01,9.01,0,0,0,9-9V14ZM12.1016,17.9468A7.51,7.51,0,0,0,5.5283,14,8.8945,8.8945,0,0,1,4,9V4H7a8.8624,8.8624,0,0,1,3.0259.53A4.2457,4.2457,0,0,0,10,5a4.9658,4.9658,0,0,0,5.47,4.9736A8.8793,8.8793,0,0,1,16,13v5H13A8.1153,8.1153,0,0,1,12.1016,17.9468ZM28,17a7.0078,7.0078,0,0,1-7,7H18V23a7.01,7.01,0,0,1,5.0212-6.7109A1.4971,1.4971,0,1,0,26,16.5a1.485,1.485,0,0,0-.0918-.5H28Z"
    })), children);
  });
  var Pest24 = /*#__PURE__*/React__default['default'].forwardRef(function Pest24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle44$3 || (_circle44$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "9.5",
      r: "1.5"
    })), _circle45$3 || (_circle45$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "13",
      r: "1"
    })), _circle46$3 || (_circle46$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "21",
      r: "1"
    })), _path376$9 || (_path376$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14a8.9844,8.9844,0,0,0-7,3.3555V13a10.9054,10.9054,0,0,0-1.0093-4.5845l-.3569-.7768L15.811,7.87A2.9549,2.9549,0,0,1,15,8a3.0033,3.0033,0,0,1-3-3,2.9574,2.9574,0,0,1,.1294-.8105l.2324-.8233-.7773-.3569A10.9115,10.9115,0,0,0,7,2H2V9a10.8954,10.8954,0,0,0,2.2339,6.627l.3887.4277.54-.0381a5.5286,5.5286,0,0,1,5.3628,3.2559l.2207.497.5376.0845A11.0219,11.0219,0,0,0,13,20h3V30h2V26h3a9.01,9.01,0,0,0,9-9V14ZM12.1016,17.9468A7.51,7.51,0,0,0,5.5283,14,8.8945,8.8945,0,0,1,4,9V4H7a8.8624,8.8624,0,0,1,3.0259.53A4.2457,4.2457,0,0,0,10,5a4.9658,4.9658,0,0,0,5.47,4.9736A8.8793,8.8793,0,0,1,16,13v5H13A8.1153,8.1153,0,0,1,12.1016,17.9468ZM28,17a7.0078,7.0078,0,0,1-7,7H18V23a7.01,7.01,0,0,1,5.0212-6.7109A1.4971,1.4971,0,1,0,26,16.5a1.485,1.485,0,0,0-.0918-.5H28Z"
    })), children);
  });
  var Pest20 = /*#__PURE__*/React__default['default'].forwardRef(function Pest20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle47$3 || (_circle47$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "9.5",
      r: "1.5"
    })), _circle48$3 || (_circle48$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "13",
      r: "1"
    })), _circle49$3 || (_circle49$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "21",
      r: "1"
    })), _path377$9 || (_path377$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14a8.9844,8.9844,0,0,0-7,3.3555V13a10.9054,10.9054,0,0,0-1.0093-4.5845l-.3569-.7768L15.811,7.87A2.9549,2.9549,0,0,1,15,8a3.0033,3.0033,0,0,1-3-3,2.9574,2.9574,0,0,1,.1294-.8105l.2324-.8233-.7773-.3569A10.9115,10.9115,0,0,0,7,2H2V9a10.8954,10.8954,0,0,0,2.2339,6.627l.3887.4277.54-.0381a5.5286,5.5286,0,0,1,5.3628,3.2559l.2207.497.5376.0845A11.0219,11.0219,0,0,0,13,20h3V30h2V26h3a9.01,9.01,0,0,0,9-9V14ZM12.1016,17.9468A7.51,7.51,0,0,0,5.5283,14,8.8945,8.8945,0,0,1,4,9V4H7a8.8624,8.8624,0,0,1,3.0259.53A4.2457,4.2457,0,0,0,10,5a4.9658,4.9658,0,0,0,5.47,4.9736A8.8793,8.8793,0,0,1,16,13v5H13A8.1153,8.1153,0,0,1,12.1016,17.9468ZM28,17a7.0078,7.0078,0,0,1-7,7H18V23a7.01,7.01,0,0,1,5.0212-6.7109A1.4971,1.4971,0,1,0,26,16.5a1.485,1.485,0,0,0-.0918-.5H28Z"
    })), children);
  });
  var Pest16 = /*#__PURE__*/React__default['default'].forwardRef(function Pest16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle50$3 || (_circle50$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7.5",
      cy: "9.5",
      r: "1.5"
    })), _circle51$3 || (_circle51$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "13",
      r: "1"
    })), _circle52$3 || (_circle52$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "21",
      r: "1"
    })), _path378$9 || (_path378$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,14a8.9844,8.9844,0,0,0-7,3.3555V13a10.9054,10.9054,0,0,0-1.0093-4.5845l-.3569-.7768L15.811,7.87A2.9549,2.9549,0,0,1,15,8a3.0033,3.0033,0,0,1-3-3,2.9574,2.9574,0,0,1,.1294-.8105l.2324-.8233-.7773-.3569A10.9115,10.9115,0,0,0,7,2H2V9a10.8954,10.8954,0,0,0,2.2339,6.627l.3887.4277.54-.0381a5.5286,5.5286,0,0,1,5.3628,3.2559l.2207.497.5376.0845A11.0219,11.0219,0,0,0,13,20h3V30h2V26h3a9.01,9.01,0,0,0,9-9V14ZM12.1016,17.9468A7.51,7.51,0,0,0,5.5283,14,8.8945,8.8945,0,0,1,4,9V4H7a8.8624,8.8624,0,0,1,3.0259.53A4.2457,4.2457,0,0,0,10,5a4.9658,4.9658,0,0,0,5.47,4.9736A8.8793,8.8793,0,0,1,16,13v5H13A8.1153,8.1153,0,0,1,12.1016,17.9468ZM28,17a7.0078,7.0078,0,0,1-7,7H18V23a7.01,7.01,0,0,1,5.0212-6.7109A1.4971,1.4971,0,1,0,26,16.5a1.485,1.485,0,0,0-.0918-.5H28Z"
    })), children);
  });
  var WatsonHealthPetImageB32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageB32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$9 || (_path379$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"
    })), _path380$9 || (_path380$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.59 3.07H13.57V6.07H11.59z",
      transform: "rotate(-45 12.586 4.577)"
    })), _path381$9 || (_path381$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.44 17.92H28.42V20.92H26.44z",
      transform: "rotate(-45 27.43 19.408)"
    })), _path382$9 || (_path382$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.09 18.42H14.09V20.400000000000002H11.09z",
      transform: "rotate(-45 12.592 19.414)"
    })), _path383$9 || (_path383$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.93 3.58H28.93V5.5600000000000005H25.93z",
      transform: "rotate(-45 27.423 4.57)"
    })), _path384$8 || (_path384$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 5a7 7 0 107 7A7 7 0 0020 5zm0 12A5 5 0 0120 7zM5 18H0V32H5a3 3 0 003-3V27a3 3 0 00-.78-2A3 3 0 008 23V21A3 3 0 005 18zM2 20H5a1 1 0 011 1v2a1 1 0 01-1 1H2zm4 9a1 1 0 01-1 1H2V26H5a1 1 0 011 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"
    })), children);
  });
  var WatsonHealthPetImageB24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageB24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$8 || (_path385$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"
    })), _path386$8 || (_path386$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.59 3.07H13.57V6.07H11.59z",
      transform: "rotate(-45 12.586 4.577)"
    })), _path387$8 || (_path387$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.44 17.92H28.42V20.92H26.44z",
      transform: "rotate(-45 27.43 19.408)"
    })), _path388$8 || (_path388$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.09 18.42H14.09V20.400000000000002H11.09z",
      transform: "rotate(-45 12.592 19.414)"
    })), _path389$8 || (_path389$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.93 3.58H28.93V5.5600000000000005H25.93z",
      transform: "rotate(-45 27.423 4.57)"
    })), _path390$8 || (_path390$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 5a7 7 0 107 7A7 7 0 0020 5zm0 12A5 5 0 0120 7zM5 18H0V32H5a3 3 0 003-3V27a3 3 0 00-.78-2A3 3 0 008 23V21A3 3 0 005 18zM2 20H5a1 1 0 011 1v2a1 1 0 01-1 1H2zm4 9a1 1 0 01-1 1H2V26H5a1 1 0 011 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"
    })), children);
  });
  var WatsonHealthPetImageB20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageB20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$8 || (_path391$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"
    })), _path392$8 || (_path392$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.59 3.07H13.57V6.07H11.59z",
      transform: "rotate(-45 12.586 4.577)"
    })), _path393$8 || (_path393$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.44 17.92H28.42V20.92H26.44z",
      transform: "rotate(-45 27.43 19.408)"
    })), _path394$8 || (_path394$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.09 18.42H14.09V20.400000000000002H11.09z",
      transform: "rotate(-45 12.592 19.414)"
    })), _path395$8 || (_path395$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.93 3.58H28.93V5.5600000000000005H25.93z",
      transform: "rotate(-45 27.423 4.57)"
    })), _path396$8 || (_path396$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 5a7 7 0 107 7A7 7 0 0020 5zm0 12A5 5 0 0120 7zM5 18H0V32H5a3 3 0 003-3V27a3 3 0 00-.78-2A3 3 0 008 23V21A3 3 0 005 18zM2 20H5a1 1 0 011 1v2a1 1 0 01-1 1H2zm4 9a1 1 0 01-1 1H2V26H5a1 1 0 011 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"
    })), children);
  });
  var WatsonHealthPetImageB16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageB16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$8 || (_path397$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"
    })), _path398$8 || (_path398$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.59 3.07H13.57V6.07H11.59z",
      transform: "rotate(-45 12.586 4.577)"
    })), _path399$7 || (_path399$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.44 17.92H28.42V20.92H26.44z",
      transform: "rotate(-45 27.43 19.408)"
    })), _path400$7 || (_path400$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.09 18.42H14.09V20.400000000000002H11.09z",
      transform: "rotate(-45 12.592 19.414)"
    })), _path401$7 || (_path401$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.93 3.58H28.93V5.5600000000000005H25.93z",
      transform: "rotate(-45 27.423 4.57)"
    })), _path402$7 || (_path402$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 5a7 7 0 107 7A7 7 0 0020 5zm0 12A5 5 0 0120 7zM5 18H0V32H5a3 3 0 003-3V27a3 3 0 00-.78-2A3 3 0 008 23V21A3 3 0 005 18zM2 20H5a1 1 0 011 1v2a1 1 0 01-1 1H2zm4 9a1 1 0 01-1 1H2V26H5a1 1 0 011 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"
    })), children);
  });
  var WatsonHealthPetImageO32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageO32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$6 || (_path403$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"
    })), _path404$6 || (_path404$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.59 11.09H5.57V14.09H3.59z",
      transform: "rotate(-45 4.585 12.59)"
    })), _path405$6 || (_path405$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.44 25.93H20.42V28.93H18.44z",
      transform: "rotate(-45 19.429 27.422)"
    })), _path406$6 || (_path406$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.09 26.44H6.09V28.42H3.09z",
      transform: "rotate(-45 4.591 27.428)"
    })), _path407$6 || (_path407$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.93 11.59H20.93V13.57H17.93z",
      transform: "rotate(-45 19.423 12.585)"
    })), _path408$6 || (_path408$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13a7 7 0 107 7A7 7 0 0012 13zm0 12a5 5 0 010-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 00-2 2V12a2 2 0 002 2h4a2 2 0 002-2V2A2 2 0 0030 0zM26 12V2h4V12z"
    })), children);
  });
  var WatsonHealthPetImageO24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageO24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$6 || (_path409$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"
    })), _path410$6 || (_path410$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.59 11.09H5.57V14.09H3.59z",
      transform: "rotate(-45 4.585 12.59)"
    })), _path411$6 || (_path411$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.44 25.93H20.42V28.93H18.44z",
      transform: "rotate(-45 19.429 27.422)"
    })), _path412$6 || (_path412$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.09 26.44H6.09V28.42H3.09z",
      transform: "rotate(-45 4.591 27.428)"
    })), _path413$6 || (_path413$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.93 11.59H20.93V13.57H17.93z",
      transform: "rotate(-45 19.423 12.585)"
    })), _path414$6 || (_path414$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13a7 7 0 107 7A7 7 0 0012 13zm0 12a5 5 0 010-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 00-2 2V12a2 2 0 002 2h4a2 2 0 002-2V2A2 2 0 0030 0zM26 12V2h4V12z"
    })), children);
  });
  var WatsonHealthPetImageO20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageO20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$5 || (_path415$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"
    })), _path416$4 || (_path416$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.59 11.09H5.57V14.09H3.59z",
      transform: "rotate(-45 4.585 12.59)"
    })), _path417$4 || (_path417$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.44 25.93H20.42V28.93H18.44z",
      transform: "rotate(-45 19.429 27.422)"
    })), _path418$4 || (_path418$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.09 26.44H6.09V28.42H3.09z",
      transform: "rotate(-45 4.591 27.428)"
    })), _path419$4 || (_path419$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.93 11.59H20.93V13.57H17.93z",
      transform: "rotate(-45 19.423 12.585)"
    })), _path420$4 || (_path420$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13a7 7 0 107 7A7 7 0 0012 13zm0 12a5 5 0 010-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 00-2 2V12a2 2 0 002 2h4a2 2 0 002-2V2A2 2 0 0030 0zM26 12V2h4V12z"
    })), children);
  });
  var WatsonHealthPetImageO16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPetImageO16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$4 || (_path421$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"
    })), _path422$4 || (_path422$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.59 11.09H5.57V14.09H3.59z",
      transform: "rotate(-45 4.585 12.59)"
    })), _path423$4 || (_path423$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.44 25.93H20.42V28.93H18.44z",
      transform: "rotate(-45 19.429 27.422)"
    })), _path424$4 || (_path424$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.09 26.44H6.09V28.42H3.09z",
      transform: "rotate(-45 4.591 27.428)"
    })), _path425$3 || (_path425$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.93 11.59H20.93V13.57H17.93z",
      transform: "rotate(-45 19.423 12.585)"
    })), _path426$3 || (_path426$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 13a7 7 0 107 7A7 7 0 0012 13zm0 12a5 5 0 010-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 00-2 2V12a2 2 0 002 2h4a2 2 0 002-2V2A2 2 0 0030 0zM26 12V2h4V12z"
    })), children);
  });
  var Phone32 = /*#__PURE__*/React__default['default'].forwardRef(function Phone32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path427$3 || (_path427$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), children);
  });
  var Phone24 = /*#__PURE__*/React__default['default'].forwardRef(function Phone24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path428$3 || (_path428$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), children);
  });
  var Phone20 = /*#__PURE__*/React__default['default'].forwardRef(function Phone20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path429$3 || (_path429$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), children);
  });
  var Phone16 = /*#__PURE__*/React__default['default'].forwardRef(function Phone16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path430$3 || (_path430$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), children);
  });
  var PhoneApplication32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneApplication32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path431$3 || (_path431$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20zM25 30h-.17C5.18 28.87 2.39 12.29 2 7.23A3 3 0 014.7611 4.0088Q4.88 4 5 4h5.27a2 2 0 011.86 1.26L13.65 9a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0123 18.35l3.77 1.51A2 2 0 0128 21.72V27A3 3 0 0125 30zM5 6a1 1 0 00-1.0032.9968c0 .0278.001.0555.0032.0832C4.46 13 7.41 27 24.94 28a1 1 0 001.0581-.9382Q26 27.0309 26 27V21.72l-3.77-1.51-2.87 2.85L18.88 23C10.18 21.91 9 13.21 9 13.12l-.06-.48 2.84-2.87L10.28 6z"
    })), children);
  });
  var PhoneApplication24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneApplication24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path432$3 || (_path432$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20zM25 30h-.17C5.18 28.87 2.39 12.29 2 7.23A3 3 0 014.7611 4.0088Q4.88 4 5 4h5.27a2 2 0 011.86 1.26L13.65 9a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0123 18.35l3.77 1.51A2 2 0 0128 21.72V27A3 3 0 0125 30zM5 6a1 1 0 00-1.0032.9968c0 .0278.001.0555.0032.0832C4.46 13 7.41 27 24.94 28a1 1 0 001.0581-.9382Q26 27.0309 26 27V21.72l-3.77-1.51-2.87 2.85L18.88 23C10.18 21.91 9 13.21 9 13.12l-.06-.48 2.84-2.87L10.28 6z"
    })), children);
  });
  var PhoneApplication20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneApplication20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path433$3 || (_path433$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20zM25 30h-.17C5.18 28.87 2.39 12.29 2 7.23A3 3 0 014.7611 4.0088Q4.88 4 5 4h5.27a2 2 0 011.86 1.26L13.65 9a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0123 18.35l3.77 1.51A2 2 0 0128 21.72V27A3 3 0 0125 30zM5 6a1 1 0 00-1.0032.9968c0 .0278.001.0555.0032.0832C4.46 13 7.41 27 24.94 28a1 1 0 001.0581-.9382Q26 27.0309 26 27V21.72l-3.77-1.51-2.87 2.85L18.88 23C10.18 21.91 9 13.21 9 13.12l-.06-.48 2.84-2.87L10.28 6z"
    })), children);
  });
  var PhoneApplication16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneApplication16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path434$3 || (_path434$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 2H30V6H26zM26 8H30V12H26zM20 2H24V6H20zM20 8H24V12H20zM25 30h-.17C5.18 28.87 2.39 12.29 2 7.23A3 3 0 014.7611 4.0088Q4.88 4 5 4h5.27a2 2 0 011.86 1.26L13.65 9a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0123 18.35l3.77 1.51A2 2 0 0128 21.72V27A3 3 0 0125 30zM5 6a1 1 0 00-1.0032.9968c0 .0278.001.0555.0032.0832C4.46 13 7.41 27 24.94 28a1 1 0 001.0581-.9382Q26 27.0309 26 27V21.72l-3.77-1.51-2.87 2.85L18.88 23C10.18 21.91 9 13.21 9 13.12l-.06-.48 2.84-2.87L10.28 6z"
    })), children);
  });
  var PhoneBlock32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlock32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path435$3 || (_path435$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path436$3 || (_path436$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlock24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlock24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path437$3 || (_path437$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path438$3 || (_path438$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlock20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlock20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path439$2 || (_path439$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path440$2 || (_path440$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlock16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlock16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path441$2 || (_path441$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path442$2 || (_path442$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlockFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlockFilled32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path443$2 || (_path443$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path444$2 || (_path444$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlockFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlockFilled24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path445$2 || (_path445$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path446$2 || (_path446$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlockFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlockFilled20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path447$2 || (_path447$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path448$2 || (_path448$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneBlockFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneBlockFilled16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path449$2 || (_path449$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path450$2 || (_path450$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.41 9L28 5.41 26.59 4 23 7.59 19.41 4 18 5.41 21.59 9 18 12.59 19.41 14 23 10.41 26.59 14 28 12.59 24.41 9z"
    })), children);
  });
  var PhoneFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneFilled32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path451$2 || (_path451$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"
    })), children);
  });
  var PhoneFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneFilled24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path452$2 || (_path452$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"
    })), children);
  });
  var PhoneFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneFilled20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path453$2 || (_path453$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"
    })), children);
  });
  var PhoneFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneFilled16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path454$2 || (_path454$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"
    })), children);
  });

  var _path$a, _path2$a, _path3$a, _path4$a, _path5$a, _path6$a, _path7$a, _path8$a, _path9$a, _path10$a, _path11$a, _path12$a, _path13$a, _path14$a, _path15$a, _path16$a, _path17$a, _path18$a, _path19$a, _path20$a, _path21$a, _path22$a, _path23$a, _path24$a, _path25$a, _path26$a, _path27$a, _path28$a, _path29$a, _path30$a, _path31$a, _path32$a, _path33$a, _path34$a, _path35$a, _path36$a, _path37$a, _path38$a, _path39$a, _path40$a, _path41$a, _path42$a, _path43$a, _path44$a, _path45$a, _path46$a, _path47$a, _path48$a, _path49$a, _path50$a, _path51$a, _path52$a, _path53$a, _path54$a, _path55$a, _path56$a, _path57$a, _path58$a, _path59$a, _path60$a, _path61$a, _path62$a, _path63$a, _path64$a, _path65$a, _path66$a, _path67$a, _path68$a, _path69$a, _path70$a, _path71$a, _path72$a, _path73$a, _path74$a, _path75$a, _path76$a, _path77$a, _path78$a, _path79$a, _path80$a, _path81$a, _path82$a, _path83$a, _path84$a, _path85$a, _path86$a, _path87$a, _path88$a, _path89$a, _path90$a, _path91$a, _path92$a, _path93$a, _path94$a, _path95$a, _path96$a, _path97$a, _path98$a, _path99$a, _path100$a, _path101$a, _path102$a, _path103$a, _path104$a, _path105$a, _path106$a, _path107$a, _path108$a, _path109$a, _path110$a, _path111$a, _path112$a, _path113$a, _path114$a, _path115$a, _path116$a, _path117$a, _path118$a, _path119$a, _path120$a, _path121$a, _path122$a, _path123$a, _path124$a, _path125$a, _path126$a, _path127$a, _path128$a, _path129$a, _path130$a, _path131$a, _path132$a, _path133$a, _path134$a, _path135$a, _path136$a, _path137$a, _path138$a, _path139$a, _path140$a, _path141$a, _path142$a, _path143$a, _path144$a, _path145$a, _path146$a, _path147$a, _path148$a, _path149$a, _path150$a, _path151$a, _path152$a, _path153$a, _path154$a, _path155$a, _path156$a, _path157$a, _path158$a, _path159$a, _path160$a, _path161$a, _path162$a, _path163$a, _path164$a, _path165$a, _path166$a, _path167$a, _path168$a, _path169$a, _path170$a, _path171$a, _path172$a, _path173$a, _path174$a, _path175$a, _path176$a, _path177$9, _path178$9, _path179$9, _path180$9, _path181$9, _path182$9, _path183$9, _path184$9, _path185$9, _path186$9, _path187$9, _path188$9, _path189$9, _path190$9, _path191$9, _path192$9, _path193$9, _path194$9, _path195$9, _path196$9, _path197$9, _path198$9, _path199$9, _path200$9, _path201$9, _path202$9, _path203$9, _path204$9, _path205$9, _path206$9, _path207$9, _path208$9, _path209$9, _path210$9, _path211$9, _path212$9, _path213$9, _path214$9, _path215$9, _path216$9, _path217$9, _path218$9, _path219$9, _path220$9, _path221$9, _path222$9, _path223$9, _path224$9, _path225$9, _path226$9, _path227$9, _path228$9, _path229$9, _path230$9, _path231$9, _path232$9, _path233$9, _path234$9, _path235$9, _path236$9, _path237$9, _path238$9, _path239$9, _path240$9, _path241$9, _path242$9, _path243$9, _path244$9, _path245$9, _path246$9, _path247$9, _path248$9, _path249$9, _path250$9, _path251$9, _path252$9, _path253$9, _path254$9, _path255$9, _path256$9, _path257$9, _path258$9, _path259$9, _path260$9, _path261$9, _path262$9, _path263$9, _path264$9, _path265$9, _path266$9, _path267$9, _path268$9, _path269$9, _path270$9, _path271$9, _path272$9, _path273$9, _path274$9, _path275$9, _path276$9, _path277$9, _path278$9, _path279$9, _path280$9, _path281$9, _path282$9, _path283$9, _path284$9, _path285$9, _path286$9, _path287$9, _path288$9, _path289$9, _path290$9, _path291$9, _path292$9, _path293$9, _path294$9, _path295$9, _path296$9, _path297$9, _path298$9, _path299$9, _path300$9, _path301$9, _path302$9, _path303$9, _path304$9, _path305$9, _path306$9, _path307$9, _path308$9, _path309$9, _path310$9, _path311$9, _path312$9, _path313$9, _path314$9, _path315$9, _path316$9, _path317$9, _path318$9, _path319$9, _path320$9, _path321$9, _path322$9, _path323$9, _path324$9, _path325$9, _path326$9, _path327$9, _path328$9, _path329$9, _path330$9, _path331$9, _path332$9, _path333$9, _path334$9, _circle$9, _circle2$9, _circle3$9, _circle4$8, _circle5$7, _path335$9, _circle6$7, _circle7$7, _circle8$7, _circle9$7, _circle10$7, _path336$9, _circle11$6, _circle12$6, _circle13$6, _circle14$6, _circle15$6, _path337$9, _circle16$6, _circle17$5, _circle18$5, _circle19$5, _circle20$5, _path338$9, _path339$9, _path340$9, _path341$9, _path342$9, _path343$9, _path344$9, _path345$9, _path346$9, _path347$9, _path348$9, _path349$9, _path350$9, _path351$9, _path352$9, _path353$9, _path354$9, _path355$8, _path356$8, _path357$8, _path358$8, _path359$8, _path360$8, _path361$8, _path362$8, _path363$8, _path364$8, _path365$8, _path366$8, _path367$8, _path368$8, _path369$8, _path370$8, _path371$8, _path372$8, _path373$8, _path374$8, _path375$8, _path376$8, _path377$8, _path378$8, _path379$8, _path380$8, _circle21$5, _circle22$5, _circle23$5, _circle24$5, _circle25$4, _circle26$4, _circle27$4, _path381$8, _path382$8, _circle28$4, _circle29$4, _circle30$4, _circle31$4, _circle32$4, _circle33$4, _circle34$3, _path383$8, _path384$7, _circle35$3, _circle36$3, _circle37$2, _circle38$2, _circle39$2, _circle40$2, _circle41$2, _path385$7, _path386$7, _circle42$2, _circle43$2, _circle44$2, _circle45$2, _circle46$2, _circle47$2, _circle48$2, _circle49$2, _path387$7, _path388$7, _circle50$2, _path389$7, _path390$7, _circle51$2, _path391$7, _path392$7, _circle52$2, _path393$7, _path394$7, _path395$7, _path396$7, _path397$7, _path398$7, _path399$6, _path400$6, _path401$6, _path402$6, _path403$5, _path404$5, _path405$5, _path406$5, _path407$5, _path408$5, _path409$5, _path410$5, _path411$5, _path412$5, _path413$5, _path414$5, _path415$4, _path416$3, _path417$3, _path418$3, _path419$3, _path420$3, _path421$3, _path422$3, _path423$3, _path424$3, _path425$2, _path426$2, _path427$2, _path428$2, _path429$2, _path430$2, _path431$2, _path432$2, _path433$2, _path434$2, _path435$2, _circle53$2, _path436$2, _path437$2, _circle54$2, _path438$2;

  var _excluded$a = ["children"],
      _excluded2$a = ["children"],
      _excluded3$a = ["children"],
      _excluded4$a = ["children"],
      _excluded5$a = ["children"],
      _excluded6$a = ["children"],
      _excluded7$a = ["children"],
      _excluded8$a = ["children"],
      _excluded9$a = ["children"],
      _excluded10$a = ["children"],
      _excluded11$a = ["children"],
      _excluded12$a = ["children"],
      _excluded13$a = ["children"],
      _excluded14$a = ["children"],
      _excluded15$a = ["children"],
      _excluded16$a = ["children"],
      _excluded17$a = ["children"],
      _excluded18$a = ["children"],
      _excluded19$a = ["children"],
      _excluded20$a = ["children"],
      _excluded21$a = ["children"],
      _excluded22$a = ["children"],
      _excluded23$a = ["children"],
      _excluded24$a = ["children"],
      _excluded25$a = ["children"],
      _excluded26$a = ["children"],
      _excluded27$a = ["children"],
      _excluded28$a = ["children"],
      _excluded29$a = ["children"],
      _excluded30$a = ["children"],
      _excluded31$a = ["children"],
      _excluded32$a = ["children"],
      _excluded33$a = ["children"],
      _excluded34$a = ["children"],
      _excluded35$a = ["children"],
      _excluded36$a = ["children"],
      _excluded37$a = ["children"],
      _excluded38$a = ["children"],
      _excluded39$a = ["children"],
      _excluded40$a = ["children"],
      _excluded41$a = ["children"],
      _excluded42$a = ["children"],
      _excluded43$a = ["children"],
      _excluded44$a = ["children"],
      _excluded45$a = ["children"],
      _excluded46$a = ["children"],
      _excluded47$a = ["children"],
      _excluded48$a = ["children"],
      _excluded49$a = ["children"],
      _excluded50$a = ["children"],
      _excluded51$a = ["children"],
      _excluded52$a = ["children"],
      _excluded53$a = ["children"],
      _excluded54$a = ["children"],
      _excluded55$a = ["children"],
      _excluded56$a = ["children"],
      _excluded57$a = ["children"],
      _excluded58$a = ["children"],
      _excluded59$a = ["children"],
      _excluded60$a = ["children"],
      _excluded61$a = ["children"],
      _excluded62$a = ["children"],
      _excluded63$a = ["children"],
      _excluded64$a = ["children"],
      _excluded65$a = ["children"],
      _excluded66$a = ["children"],
      _excluded67$a = ["children"],
      _excluded68$a = ["children"],
      _excluded69$a = ["children"],
      _excluded70$a = ["children"],
      _excluded71$a = ["children"],
      _excluded72$a = ["children"],
      _excluded73$a = ["children"],
      _excluded74$a = ["children"],
      _excluded75$a = ["children"],
      _excluded76$a = ["children"],
      _excluded77$a = ["children"],
      _excluded78$a = ["children"],
      _excluded79$a = ["children"],
      _excluded80$a = ["children"],
      _excluded81$a = ["children"],
      _excluded82$a = ["children"],
      _excluded83$a = ["children"],
      _excluded84$a = ["children"],
      _excluded85$a = ["children"],
      _excluded86$a = ["children"],
      _excluded87$a = ["children"],
      _excluded88$a = ["children"],
      _excluded89$a = ["children"],
      _excluded90$a = ["children"],
      _excluded91$a = ["children"],
      _excluded92$a = ["children"],
      _excluded93$a = ["children"],
      _excluded94$a = ["children"],
      _excluded95$a = ["children"],
      _excluded96$a = ["children"],
      _excluded97$a = ["children"],
      _excluded98$a = ["children"],
      _excluded99$a = ["children"],
      _excluded100$a = ["children"],
      _excluded101$a = ["children"],
      _excluded102$a = ["children"],
      _excluded103$a = ["children"],
      _excluded104$a = ["children"],
      _excluded105$a = ["children"],
      _excluded106$a = ["children"],
      _excluded107$a = ["children"],
      _excluded108$a = ["children"],
      _excluded109$a = ["children"],
      _excluded110$a = ["children"],
      _excluded111$a = ["children"],
      _excluded112$a = ["children"],
      _excluded113$a = ["children"],
      _excluded114$a = ["children"],
      _excluded115$a = ["children"],
      _excluded116$a = ["children"],
      _excluded117$a = ["children"],
      _excluded118$a = ["children"],
      _excluded119$9 = ["children"],
      _excluded120$9 = ["children"],
      _excluded121$9 = ["children"],
      _excluded122$9 = ["children"],
      _excluded123$9 = ["children"],
      _excluded124$9 = ["children"],
      _excluded125$9 = ["children"],
      _excluded126$9 = ["children"],
      _excluded127$9 = ["children"],
      _excluded128$9 = ["children"],
      _excluded129$9 = ["children"],
      _excluded130$9 = ["children"],
      _excluded131$9 = ["children"],
      _excluded132$9 = ["children"],
      _excluded133$9 = ["children"],
      _excluded134$9 = ["children"],
      _excluded135$9 = ["children"],
      _excluded136$9 = ["children"],
      _excluded137$9 = ["children"],
      _excluded138$9 = ["children"],
      _excluded139$9 = ["children"],
      _excluded140$9 = ["children"],
      _excluded141$9 = ["children"],
      _excluded142$9 = ["children"],
      _excluded143$9 = ["children"],
      _excluded144$9 = ["children"],
      _excluded145$9 = ["children"],
      _excluded146$9 = ["children"],
      _excluded147$9 = ["children"],
      _excluded148$9 = ["children"],
      _excluded149$9 = ["children"],
      _excluded150$9 = ["children"],
      _excluded151$9 = ["children"],
      _excluded152$9 = ["children"],
      _excluded153$9 = ["children"],
      _excluded154$9 = ["children"],
      _excluded155$9 = ["children"],
      _excluded156$9 = ["children"],
      _excluded157$9 = ["children"],
      _excluded158$9 = ["children"],
      _excluded159$9 = ["children"],
      _excluded160$9 = ["children"],
      _excluded161$9 = ["children"],
      _excluded162$9 = ["children"],
      _excluded163$9 = ["children"],
      _excluded164$9 = ["children"],
      _excluded165$9 = ["children"],
      _excluded166$9 = ["children"],
      _excluded167$9 = ["children"],
      _excluded168$9 = ["children"],
      _excluded169$9 = ["children"],
      _excluded170$9 = ["children"],
      _excluded171$9 = ["children"],
      _excluded172$9 = ["children"],
      _excluded173$9 = ["children"],
      _excluded174$9 = ["children"],
      _excluded175$9 = ["children"],
      _excluded176$9 = ["children"],
      _excluded177$9 = ["children"],
      _excluded178$9 = ["children"],
      _excluded179$9 = ["children"],
      _excluded180$9 = ["children"],
      _excluded181$9 = ["children"],
      _excluded182$9 = ["children"],
      _excluded183$9 = ["children"],
      _excluded184$9 = ["children"],
      _excluded185$9 = ["children"],
      _excluded186$9 = ["children"],
      _excluded187$9 = ["children"],
      _excluded188$9 = ["children"],
      _excluded189$9 = ["children"],
      _excluded190$9 = ["children"],
      _excluded191$9 = ["children"],
      _excluded192$9 = ["children"],
      _excluded193$9 = ["children"],
      _excluded194$9 = ["children"],
      _excluded195$9 = ["children"],
      _excluded196$9 = ["children"],
      _excluded197$9 = ["children"],
      _excluded198$9 = ["children"],
      _excluded199$9 = ["children"],
      _excluded200$9 = ["children"],
      _excluded201$9 = ["children"],
      _excluded202$9 = ["children"],
      _excluded203$9 = ["children"],
      _excluded204$9 = ["children"],
      _excluded205$9 = ["children"],
      _excluded206$9 = ["children"],
      _excluded207$9 = ["children"],
      _excluded208$9 = ["children"],
      _excluded209$9 = ["children"],
      _excluded210$9 = ["children"],
      _excluded211$9 = ["children"],
      _excluded212$9 = ["children"],
      _excluded213$9 = ["children"],
      _excluded214$9 = ["children"],
      _excluded215$9 = ["children"],
      _excluded216$9 = ["children"],
      _excluded217$9 = ["children"],
      _excluded218$9 = ["children"],
      _excluded219$9 = ["children"],
      _excluded220$9 = ["children"],
      _excluded221$9 = ["children"],
      _excluded222$9 = ["children"],
      _excluded223$9 = ["children"],
      _excluded224$9 = ["children"],
      _excluded225$9 = ["children"],
      _excluded226$9 = ["children"],
      _excluded227$9 = ["children"],
      _excluded228$9 = ["children"],
      _excluded229$9 = ["children"],
      _excluded230$9 = ["children"],
      _excluded231$9 = ["children"],
      _excluded232$9 = ["children"],
      _excluded233$9 = ["children"],
      _excluded234$9 = ["children"],
      _excluded235$9 = ["children"],
      _excluded236$9 = ["children"],
      _excluded237$9 = ["children"],
      _excluded238$9 = ["children"],
      _excluded239$9 = ["children"],
      _excluded240$9 = ["children"],
      _excluded241$9 = ["children"],
      _excluded242$9 = ["children"],
      _excluded243$9 = ["children"],
      _excluded244$9 = ["children"],
      _excluded245$9 = ["children"],
      _excluded246$9 = ["children"],
      _excluded247$9 = ["children"],
      _excluded248$9 = ["children"],
      _excluded249$9 = ["children"],
      _excluded250$9 = ["children"];
  var PhoneIncoming32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncoming32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$a || (_path$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path2$a || (_path2$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncoming24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncoming24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$a || (_path3$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path4$a || (_path4$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncoming20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncoming20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$a || (_path5$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path6$a || (_path6$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncoming16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncoming16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$a || (_path7$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.7612,3.0088Q5.88,3,6,3h5.27a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5a1,1,0,0,0-1.0032.9968q0,.0417.0032.0832C5.46,12,8.41,26,25.94,27a1,1,0,0,0,1.0582-.9382Q27,26.0309,27,26V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"
    })), _path8$a || (_path8$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncomingFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncomingFilled32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$a || (_path9$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path10$a || (_path10$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncomingFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncomingFilled24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$a || (_path11$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path12$a || (_path12$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncomingFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncomingFilled20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$a || (_path13$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path14$a || (_path14$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIncomingFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIncomingFilled16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$a || (_path15$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path16$a || (_path16$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 13L27 11 22.414 11 29 4.414 27.586 3 21 9.586 21 5 19 5 19 13 27 13z"
    })), children);
  });
  var PhoneIp32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIp32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$a || (_path17$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14H18V16H16zM20 14H22V16H20zM24 14H26V16H24zM16 18H18V20H16zM20 18H22V20H20zM24 18H26V20H24zM16 22H18V24H16zM20 22H22V24H20zM24 22H26V24H24zM16 10H26V12H16z"
    })), _path18$a || (_path18$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H14V5a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,5V6H4A2.0025,2.0025,0,0,0,2,8V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V8A2.0025,2.0025,0,0,0,28,6ZM8,5h4V22H8ZM28,26H4V8H6V22a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V8H28Z"
    })), children);
  });
  var PhoneIp24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIp24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$a || (_path19$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14H18V16H16zM20 14H22V16H20zM24 14H26V16H24zM16 18H18V20H16zM20 18H22V20H20zM24 18H26V20H24zM16 22H18V24H16zM20 22H22V24H20zM24 22H26V24H24zM16 10H26V12H16z"
    })), _path20$a || (_path20$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H14V5a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,5V6H4A2.0025,2.0025,0,0,0,2,8V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V8A2.0025,2.0025,0,0,0,28,6ZM8,5h4V22H8ZM28,26H4V8H6V22a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V8H28Z"
    })), children);
  });
  var PhoneIp20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIp20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$a || (_path21$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14H18V16H16zM20 14H22V16H20zM24 14H26V16H24zM16 18H18V20H16zM20 18H22V20H20zM24 18H26V20H24zM16 22H18V24H16zM20 22H22V24H20zM24 22H26V24H24zM16 10H26V12H16z"
    })), _path22$a || (_path22$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H14V5a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,5V6H4A2.0025,2.0025,0,0,0,2,8V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V8A2.0025,2.0025,0,0,0,28,6ZM8,5h4V22H8ZM28,26H4V8H6V22a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V8H28Z"
    })), children);
  });
  var PhoneIp16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneIp16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$a || (_path23$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14H18V16H16zM20 14H22V16H20zM24 14H26V16H24zM16 18H18V20H16zM20 18H22V20H20zM24 18H26V20H24zM16 22H18V24H16zM20 22H22V24H20zM24 22H26V24H24zM16 10H26V12H16z"
    })), _path24$a || (_path24$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H14V5a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,5V6H4A2.0025,2.0025,0,0,0,2,8V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V8A2.0025,2.0025,0,0,0,28,6ZM8,5h4V22H8ZM28,26H4V8H6V22a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V8H28Z"
    })), children);
  });
  var PhoneOff32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOff32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$a || (_path25$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.19 18.56A25.66 25.66 0 015 6.08V6A1 1 0 016 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 001.46 4.17l1.46-1.46a9.34 9.34 0 01-.84-2.52l2.13-2.15A2 2 0 0014.65 8L13.13 4.26A2 2 0 0011.27 3H5.76A3 3 0 003 6.23 28 28 0 007.79 20zM27.77 18.86L24 17.35a2 2 0 00-2.17.41l-2.17 2.15A9.17 9.17 0 0115.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 003-3V20.72A2 2 0 0027.77 18.86zM27 26v.06a1 1 0 01-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0019.88 22l.48.06 2.87-2.85L27 20.72z"
    })), children);
  });
  var PhoneOff24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOff24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$a || (_path26$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.19 18.56A25.66 25.66 0 015 6.08V6A1 1 0 016 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 001.46 4.17l1.46-1.46a9.34 9.34 0 01-.84-2.52l2.13-2.15A2 2 0 0014.65 8L13.13 4.26A2 2 0 0011.27 3H5.76A3 3 0 003 6.23 28 28 0 007.79 20zM27.77 18.86L24 17.35a2 2 0 00-2.17.41l-2.17 2.15A9.17 9.17 0 0115.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 003-3V20.72A2 2 0 0027.77 18.86zM27 26v.06a1 1 0 01-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0019.88 22l.48.06 2.87-2.85L27 20.72z"
    })), children);
  });
  var PhoneOff20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOff20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$a || (_path27$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.19 18.56A25.66 25.66 0 015 6.08V6A1 1 0 016 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 001.46 4.17l1.46-1.46a9.34 9.34 0 01-.84-2.52l2.13-2.15A2 2 0 0014.65 8L13.13 4.26A2 2 0 0011.27 3H5.76A3 3 0 003 6.23 28 28 0 007.79 20zM27.77 18.86L24 17.35a2 2 0 00-2.17.41l-2.17 2.15A9.17 9.17 0 0115.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 003-3V20.72A2 2 0 0027.77 18.86zM27 26v.06a1 1 0 01-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0019.88 22l.48.06 2.87-2.85L27 20.72z"
    })), children);
  });
  var PhoneOff16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOff16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$a || (_path28$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.19 18.56A25.66 25.66 0 015 6.08V6A1 1 0 016 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 001.46 4.17l1.46-1.46a9.34 9.34 0 01-.84-2.52l2.13-2.15A2 2 0 0014.65 8L13.13 4.26A2 2 0 0011.27 3H5.76A3 3 0 003 6.23 28 28 0 007.79 20zM27.77 18.86L24 17.35a2 2 0 00-2.17.41l-2.17 2.15A9.17 9.17 0 0115.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 003-3V20.72A2 2 0 0027.77 18.86zM27 26v.06a1 1 0 01-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0019.88 22l.48.06 2.87-2.85L27 20.72z"
    })), children);
  });
  var PhoneOffFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOffFilled32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$a || (_path29$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.74 19.56l-2.52-1a2 2 0 00-2.15.44L20 21.06a9.93 9.93 0 01-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0028 26V21.41A2 2 0 0026.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0110.85 12l2.07-2.07a2 2 0 00.44-2.15l-1-2.52A2 2 0 0010.5 4H6A2 2 0 004 6.22 29 29 0 008.15 18.19z"
    })), children);
  });
  var PhoneOffFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOffFilled24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$a || (_path30$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.74 19.56l-2.52-1a2 2 0 00-2.15.44L20 21.06a9.93 9.93 0 01-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0028 26V21.41A2 2 0 0026.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0110.85 12l2.07-2.07a2 2 0 00.44-2.15l-1-2.52A2 2 0 0010.5 4H6A2 2 0 004 6.22 29 29 0 008.15 18.19z"
    })), children);
  });
  var PhoneOffFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOffFilled20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$a || (_path31$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.74 19.56l-2.52-1a2 2 0 00-2.15.44L20 21.06a9.93 9.93 0 01-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0028 26V21.41A2 2 0 0026.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0110.85 12l2.07-2.07a2 2 0 00.44-2.15l-1-2.52A2 2 0 0010.5 4H6A2 2 0 004 6.22 29 29 0 008.15 18.19z"
    })), children);
  });
  var PhoneOffFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOffFilled16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$a || (_path32$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.74 19.56l-2.52-1a2 2 0 00-2.15.44L20 21.06a9.93 9.93 0 01-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0028 26V21.41A2 2 0 0026.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0110.85 12l2.07-2.07a2 2 0 00.44-2.15l-1-2.52A2 2 0 0010.5 4H6A2 2 0 004 6.22 29 29 0 008.15 18.19z"
    })), children);
  });
  var PhoneOutgoing32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoing32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$a || (_path33$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-0.2C6.2,27.9,3.4,11.3,3,6.2C2.9,4.6,4.1,3.1,5.8,3C5.8,3,5.9,3,6,3h5.3c0.8,0,1.6,0.5,1.9,1.3L14.6,8\tc0.3,0.7,0.1,1.6-0.4,2.2l-2.1,2.1c0.7,3.9,3.7,6.9,7.6,7.6l2.2-2.1c0.6-0.6,1.4-0.7,2.2-0.4l3.8,1.5c0.7,0.3,1.2,1,1.2,1.9V26\tC29,27.7,27.7,29,26,29z M6,5C5.4,5,5,5.4,5,6c0,0,0,0.1,0,0.1C5.5,12,8.4,26,25.9,27c0.6,0,1-0.4,1.1-0.9c0,0,0,0,0-0.1v-5.3\tl-3.8-1.5l-2.9,2.9L19.9,22c-8.7-1.1-9.9-9.8-9.9-9.9l-0.1-0.5l2.8-2.9L11.3,5H6z"
    })), _path34$a || (_path34$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.6 6 18 12.6 19.4 14 26 7.4 26 12 28 12 28 4z"
    })), children);
  });
  var PhoneOutgoing24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoing24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$a || (_path35$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-0.2C6.2,27.9,3.4,11.3,3,6.2C2.9,4.6,4.1,3.1,5.8,3C5.8,3,5.9,3,6,3h5.3c0.8,0,1.6,0.5,1.9,1.3L14.6,8\tc0.3,0.7,0.1,1.6-0.4,2.2l-2.1,2.1c0.7,3.9,3.7,6.9,7.6,7.6l2.2-2.1c0.6-0.6,1.4-0.7,2.2-0.4l3.8,1.5c0.7,0.3,1.2,1,1.2,1.9V26\tC29,27.7,27.7,29,26,29z M6,5C5.4,5,5,5.4,5,6c0,0,0,0.1,0,0.1C5.5,12,8.4,26,25.9,27c0.6,0,1-0.4,1.1-0.9c0,0,0,0,0-0.1v-5.3\tl-3.8-1.5l-2.9,2.9L19.9,22c-8.7-1.1-9.9-9.8-9.9-9.9l-0.1-0.5l2.8-2.9L11.3,5H6z"
    })), _path36$a || (_path36$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.6 6 18 12.6 19.4 14 26 7.4 26 12 28 12 28 4z"
    })), children);
  });
  var PhoneOutgoing20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoing20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$a || (_path37$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-0.2C6.2,27.9,3.4,11.3,3,6.2C2.9,4.6,4.1,3.1,5.8,3C5.8,3,5.9,3,6,3h5.3c0.8,0,1.6,0.5,1.9,1.3L14.6,8\tc0.3,0.7,0.1,1.6-0.4,2.2l-2.1,2.1c0.7,3.9,3.7,6.9,7.6,7.6l2.2-2.1c0.6-0.6,1.4-0.7,2.2-0.4l3.8,1.5c0.7,0.3,1.2,1,1.2,1.9V26\tC29,27.7,27.7,29,26,29z M6,5C5.4,5,5,5.4,5,6c0,0,0,0.1,0,0.1C5.5,12,8.4,26,25.9,27c0.6,0,1-0.4,1.1-0.9c0,0,0,0,0-0.1v-5.3\tl-3.8-1.5l-2.9,2.9L19.9,22c-8.7-1.1-9.9-9.8-9.9-9.9l-0.1-0.5l2.8-2.9L11.3,5H6z"
    })), _path38$a || (_path38$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.6 6 18 12.6 19.4 14 26 7.4 26 12 28 12 28 4z"
    })), children);
  });
  var PhoneOutgoing16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoing16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$a || (_path39$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,29h-0.2C6.2,27.9,3.4,11.3,3,6.2C2.9,4.6,4.1,3.1,5.8,3C5.8,3,5.9,3,6,3h5.3c0.8,0,1.6,0.5,1.9,1.3L14.6,8\tc0.3,0.7,0.1,1.6-0.4,2.2l-2.1,2.1c0.7,3.9,3.7,6.9,7.6,7.6l2.2-2.1c0.6-0.6,1.4-0.7,2.2-0.4l3.8,1.5c0.7,0.3,1.2,1,1.2,1.9V26\tC29,27.7,27.7,29,26,29z M6,5C5.4,5,5,5.4,5,6c0,0,0,0.1,0,0.1C5.5,12,8.4,26,25.9,27c0.6,0,1-0.4,1.1-0.9c0,0,0,0,0-0.1v-5.3\tl-3.8-1.5l-2.9,2.9L19.9,22c-8.7-1.1-9.9-9.8-9.9-9.9l-0.1-0.5l2.8-2.9L11.3,5H6z"
    })), _path40$a || (_path40$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.6 6 18 12.6 19.4 14 26 7.4 26 12 28 12 28 4z"
    })), children);
  });
  var PhoneOutgoingFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoingFilled32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$a || (_path41$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path42$a || (_path42$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.586 6 18 12.586 19.414 14 26 7.414 26 12 28 12 28 4 20 4z"
    })), children);
  });
  var PhoneOutgoingFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoingFilled24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$a || (_path43$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path44$a || (_path44$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.586 6 18 12.586 19.414 14 26 7.414 26 12 28 12 28 4 20 4z"
    })), children);
  });
  var PhoneOutgoingFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoingFilled20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$a || (_path45$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path46$a || (_path46$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.586 6 18 12.586 19.414 14 26 7.414 26 12 28 12 28 4 20 4z"
    })), children);
  });
  var PhoneOutgoingFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneOutgoingFilled16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$a || (_path47$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.3333,21.4823l2.24-2.24a2.1667,2.1667,0,0,1,2.3368-.48l2.7281,1.0913A2.1666,2.1666,0,0,1,29,21.8659v4.9613a2.1668,2.1668,0,0,1-2.2843,2.1686C7.5938,27.8054,3.7321,11.6114,3.0146,5.4079A2.162,2.162,0,0,1,5.1692,3H10.042a2.1666,2.1666,0,0,1,2.0117,1.362L13.145,7.09a2.1666,2.1666,0,0,1-.48,2.3367l-2.24,2.24S11.6667,20.399,20.3333,21.4823Z"
    })), _path48$a || (_path48$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4L20 6 24.586 6 18 12.586 19.414 14 26 7.414 26 12 28 12 28 4 20 4z"
    })), children);
  });
  var PhoneSettings32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneSettings32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$a || (_path49$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), _path50$a || (_path50$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30h-.17C5.18,28.87,2.39,12.29,2,7.23A3,3,0,0,1,4.7611,4.0088Q4.88,4,5,4h5.27a2,2,0,0,1,1.86,1.26L13.65,9a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,23,18.35l3.77,1.51A2,2,0,0,1,28,21.72V27A3,3,0,0,1,25,30ZM5,6a1,1,0,0,0-1.0032.9968c0,.0278.001.0555.0032.0832C4.46,13,7.41,27,24.94,28a1,1,0,0,0,1.0581-.9382Q26,27.0309,26,27V21.72l-3.77-1.51-2.87,2.85L18.88,23C10.18,21.91,9,13.21,9,13.12l-.06-.48,2.84-2.87L10.28,6Z"
    })), children);
  });
  var PhoneSettings24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneSettings24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$a || (_path51$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), _path52$a || (_path52$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30h-.17C5.18,28.87,2.39,12.29,2,7.23A3,3,0,0,1,4.7611,4.0088Q4.88,4,5,4h5.27a2,2,0,0,1,1.86,1.26L13.65,9a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,23,18.35l3.77,1.51A2,2,0,0,1,28,21.72V27A3,3,0,0,1,25,30ZM5,6a1,1,0,0,0-1.0032.9968c0,.0278.001.0555.0032.0832C4.46,13,7.41,27,24.94,28a1,1,0,0,0,1.0581-.9382Q26,27.0309,26,27V21.72l-3.77-1.51-2.87,2.85L18.88,23C10.18,21.91,9,13.21,9,13.12l-.06-.48,2.84-2.87L10.28,6Z"
    })), children);
  });
  var PhoneSettings20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneSettings20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$a || (_path53$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), _path54$a || (_path54$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30h-.17C5.18,28.87,2.39,12.29,2,7.23A3,3,0,0,1,4.7611,4.0088Q4.88,4,5,4h5.27a2,2,0,0,1,1.86,1.26L13.65,9a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,23,18.35l3.77,1.51A2,2,0,0,1,28,21.72V27A3,3,0,0,1,25,30ZM5,6a1,1,0,0,0-1.0032.9968c0,.0278.001.0555.0032.0832C4.46,13,7.41,27,24.94,28a1,1,0,0,0,1.0581-.9382Q26,27.0309,26,27V21.72l-3.77-1.51-2.87,2.85L18.88,23C10.18,21.91,9,13.21,9,13.12l-.06-.48,2.84-2.87L10.28,6Z"
    })), children);
  });
  var PhoneSettings16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneSettings16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$a || (_path55$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10V8H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,4.1011V2H22V4.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,8H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,13.8989V16h2V13.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,10Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,12Z"
    })), _path56$a || (_path56$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30h-.17C5.18,28.87,2.39,12.29,2,7.23A3,3,0,0,1,4.7611,4.0088Q4.88,4,5,4h5.27a2,2,0,0,1,1.86,1.26L13.65,9a2,2,0,0,1-.44,2.16l-2.13,2.15a9.36,9.36,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,23,18.35l3.77,1.51A2,2,0,0,1,28,21.72V27A3,3,0,0,1,25,30ZM5,6a1,1,0,0,0-1.0032.9968c0,.0278.001.0555.0032.0832C4.46,13,7.41,27,24.94,28a1,1,0,0,0,1.0581-.9382Q26,27.0309,26,27V21.72l-3.77-1.51-2.87,2.85L18.88,23C10.18,21.91,9,13.21,9,13.12l-.06-.48,2.84-2.87L10.28,6Z"
    })), children);
  });
  var PhoneVoice32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoice32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$a || (_path57$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path58$a || (_path58$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM26 29h-.17C6.18 27.87 3.39 11.29 3 6.23A3 3 0 015.7612 3.0088Q5.88 3 6 3h5.27a2 2 0 011.86 1.26L14.65 8a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0124 17.35l3.77 1.51A2 2 0 0129 20.72V26A3 3 0 0126 29zM6 5a1 1 0 00-1.0032.9968q0 .0417.0032.0832C5.46 12 8.41 26 25.94 27a1 1 0 001.0582-.9382Q27 26.0309 27 26V20.72l-3.77-1.51-2.87 2.85L19.88 22C11.18 20.91 10 12.21 10 12.12l-.06-.48 2.84-2.87L11.28 5z"
    })), children);
  });
  var PhoneVoice24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoice24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$a || (_path59$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path60$a || (_path60$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM26 29h-.17C6.18 27.87 3.39 11.29 3 6.23A3 3 0 015.7612 3.0088Q5.88 3 6 3h5.27a2 2 0 011.86 1.26L14.65 8a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0124 17.35l3.77 1.51A2 2 0 0129 20.72V26A3 3 0 0126 29zM6 5a1 1 0 00-1.0032.9968q0 .0417.0032.0832C5.46 12 8.41 26 25.94 27a1 1 0 001.0582-.9382Q27 26.0309 27 26V20.72l-3.77-1.51-2.87 2.85L19.88 22C11.18 20.91 10 12.21 10 12.12l-.06-.48 2.84-2.87L11.28 5z"
    })), children);
  });
  var PhoneVoice20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoice20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$a || (_path61$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path62$a || (_path62$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM26 29h-.17C6.18 27.87 3.39 11.29 3 6.23A3 3 0 015.7612 3.0088Q5.88 3 6 3h5.27a2 2 0 011.86 1.26L14.65 8a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0124 17.35l3.77 1.51A2 2 0 0129 20.72V26A3 3 0 0126 29zM6 5a1 1 0 00-1.0032.9968q0 .0417.0032.0832C5.46 12 8.41 26 25.94 27a1 1 0 001.0582-.9382Q27 26.0309 27 26V20.72l-3.77-1.51-2.87 2.85L19.88 22C11.18 20.91 10 12.21 10 12.12l-.06-.48 2.84-2.87L11.28 5z"
    })), children);
  });
  var PhoneVoice16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoice16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$a || (_path63$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path64$a || (_path64$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM26 29h-.17C6.18 27.87 3.39 11.29 3 6.23A3 3 0 015.7612 3.0088Q5.88 3 6 3h5.27a2 2 0 011.86 1.26L14.65 8a2 2 0 01-.44 2.16l-2.13 2.15a9.36 9.36 0 007.58 7.6l2.17-2.15A2 2 0 0124 17.35l3.77 1.51A2 2 0 0129 20.72V26A3 3 0 0126 29zM6 5a1 1 0 00-1.0032.9968q0 .0417.0032.0832C5.46 12 8.41 26 25.94 27a1 1 0 001.0582-.9382Q27 26.0309 27 26V20.72l-3.77-1.51-2.87 2.85L19.88 22C11.18 20.91 10 12.21 10 12.12l-.06-.48 2.84-2.87L11.28 5z"
    })), children);
  });
  var PhoneVoiceFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoiceFilled32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$a || (_path65$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path66$a || (_path66$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM20.3333 21.4823l2.24-2.24a2.1667 2.1667 0 012.3368-.48l2.7281 1.0913A2.1666 2.1666 0 0129 21.8659v4.9613a2.1668 2.1668 0 01-2.2843 2.1686C7.5938 27.8054 3.7321 11.6114 3.0146 5.4079A2.162 2.162 0 015.1692 3H10.042a2.1666 2.1666 0 012.0117 1.362L13.145 7.09a2.1666 2.1666 0 01-.48 2.3367l-2.24 2.24S11.6667 20.399 20.3333 21.4823z"
    })), children);
  });
  var PhoneVoiceFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoiceFilled24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$a || (_path67$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path68$a || (_path68$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM20.3333 21.4823l2.24-2.24a2.1667 2.1667 0 012.3368-.48l2.7281 1.0913A2.1666 2.1666 0 0129 21.8659v4.9613a2.1668 2.1668 0 01-2.2843 2.1686C7.5938 27.8054 3.7321 11.6114 3.0146 5.4079A2.162 2.162 0 015.1692 3H10.042a2.1666 2.1666 0 012.0117 1.362L13.145 7.09a2.1666 2.1666 0 01-.48 2.3367l-2.24 2.24S11.6667 20.399 20.3333 21.4823z"
    })), children);
  });
  var PhoneVoiceFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoiceFilled20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$a || (_path69$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path70$a || (_path70$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM20.3333 21.4823l2.24-2.24a2.1667 2.1667 0 012.3368-.48l2.7281 1.0913A2.1666 2.1666 0 0129 21.8659v4.9613a2.1668 2.1668 0 01-2.2843 2.1686C7.5938 27.8054 3.7321 11.6114 3.0146 5.4079A2.162 2.162 0 015.1692 3H10.042a2.1666 2.1666 0 012.0117 1.362L13.145 7.09a2.1666 2.1666 0 01-.48 2.3367l-2.24 2.24S11.6667 20.399 20.3333 21.4823z"
    })), children);
  });
  var PhoneVoiceFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PhoneVoiceFilled16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$a || (_path71$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,13H22a3.0033,3.0033,0,0,0-3-3V8A5.0057,5.0057,0,0,1,24,13Z"
    })), _path72$a || (_path72$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 13H26a7.0078 7.0078 0 00-7-7V4A9.01 9.01 0 0128 13zM20.3333 21.4823l2.24-2.24a2.1667 2.1667 0 012.3368-.48l2.7281 1.0913A2.1666 2.1666 0 0129 21.8659v4.9613a2.1668 2.1668 0 01-2.2843 2.1686C7.5938 27.8054 3.7321 11.6114 3.0146 5.4079A2.162 2.162 0 015.1692 3H10.042a2.1666 2.1666 0 012.0117 1.362L13.145 7.09a2.1666 2.1666 0 01-.48 2.3367l-2.24 2.24S11.6667 20.399 20.3333 21.4823z"
    })), children);
  });
  var PhraseSentiment32 = /*#__PURE__*/React__default['default'].forwardRef(function PhraseSentiment32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$a || (_path73$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"
    })), _path74$a || (_path74$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var PhraseSentiment24 = /*#__PURE__*/React__default['default'].forwardRef(function PhraseSentiment24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$a || (_path75$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"
    })), _path76$a || (_path76$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var PhraseSentiment20 = /*#__PURE__*/React__default['default'].forwardRef(function PhraseSentiment20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$a || (_path77$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"
    })), _path78$a || (_path78$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var PhraseSentiment16 = /*#__PURE__*/React__default['default'].forwardRef(function PhraseSentiment16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$a || (_path79$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"
    })), _path80$a || (_path80$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var PicnicArea32 = /*#__PURE__*/React__default['default'].forwardRef(function PicnicArea32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$a || (_path81$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12a4 4 0 114-4A4.0045 4.0045 0 0124 12zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 6zM26 22H21.8472L21.18 18H24V16H8v2h2.82l-.6668 4H6v2H9.82l-.6668 4H11.18l.6668-4h8.3056l.6668 4h2.0276L22.18 24H26zM12.18 22l.6665-4h6.3062l.6665 4z"
    })), children);
  });
  var PicnicArea24 = /*#__PURE__*/React__default['default'].forwardRef(function PicnicArea24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$a || (_path82$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12a4 4 0 114-4A4.0045 4.0045 0 0124 12zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 6zM26 22H21.8472L21.18 18H24V16H8v2h2.82l-.6668 4H6v2H9.82l-.6668 4H11.18l.6668-4h8.3056l.6668 4h2.0276L22.18 24H26zM12.18 22l.6665-4h6.3062l.6665 4z"
    })), children);
  });
  var PicnicArea20 = /*#__PURE__*/React__default['default'].forwardRef(function PicnicArea20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$a || (_path83$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12a4 4 0 114-4A4.0045 4.0045 0 0124 12zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 6zM26 22H21.8472L21.18 18H24V16H8v2h2.82l-.6668 4H6v2H9.82l-.6668 4H11.18l.6668-4h8.3056l.6668 4h2.0276L22.18 24H26zM12.18 22l.6665-4h6.3062l.6665 4z"
    })), children);
  });
  var PicnicArea16 = /*#__PURE__*/React__default['default'].forwardRef(function PicnicArea16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$a || (_path84$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 12a4 4 0 114-4A4.0045 4.0045 0 0124 12zm0-6a2 2 0 102 2A2.0021 2.0021 0 0024 6zM26 22H21.8472L21.18 18H24V16H8v2h2.82l-.6668 4H6v2H9.82l-.6668 4H11.18l.6668-4h8.3056l.6668 4h2.0276L22.18 24H26zM12.18 22l.6665-4h6.3062l.6665 4z"
    })), children);
  });
  var PiggyBank32 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBank32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$a || (_path85$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.5,14H20V12H18V11H16v1.0508A2.5,2.5,0,0,0,16.5,17h1a.5.5,0,0,1,0,1H14v2h2v1h2V19.9492A2.5,2.5,0,0,0,17.5,15h-1a.5.5,0,0,1,0-1Z"
    })), _path86$a || (_path86$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7789,5.7789,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0926,5.0926,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.013,7.013,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBank24 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBank24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$a || (_path87$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.5,14H20V12H18V11H16v1.0508A2.5,2.5,0,0,0,16.5,17h1a.5.5,0,0,1,0,1H14v2h2v1h2V19.9492A2.5,2.5,0,0,0,17.5,15h-1a.5.5,0,0,1,0-1Z"
    })), _path88$a || (_path88$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7789,5.7789,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0926,5.0926,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.013,7.013,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBank20 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBank20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$a || (_path89$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.5,14H20V12H18V11H16v1.0508A2.5,2.5,0,0,0,16.5,17h1a.5.5,0,0,1,0,1H14v2h2v1h2V19.9492A2.5,2.5,0,0,0,17.5,15h-1a.5.5,0,0,1,0-1Z"
    })), _path90$a || (_path90$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7789,5.7789,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0926,5.0926,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.013,7.013,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBank16 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBank16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$a || (_path91$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.5,14H20V12H18V11H16v1.0508A2.5,2.5,0,0,0,16.5,17h1a.5.5,0,0,1,0,1H14v2h2v1h2V19.9492A2.5,2.5,0,0,0,17.5,15h-1a.5.5,0,0,1,0-1Z"
    })), _path92$a || (_path92$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7789,5.7789,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0926,5.0926,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.013,7.013,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBankSlot32 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBankSlot32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$a || (_path93$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H20V13H13z"
    })), _path94$a || (_path94$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7791,5.7791,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0928,5.0928,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.0129,7.0129,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBankSlot24 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBankSlot24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$a || (_path95$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H20V13H13z"
    })), _path96$a || (_path96$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7791,5.7791,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0928,5.0928,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.0129,7.0129,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBankSlot20 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBankSlot20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$a || (_path97$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H20V13H13z"
    })), _path98$a || (_path98$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7791,5.7791,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0928,5.0928,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.0129,7.0129,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var PiggyBankSlot16 = /*#__PURE__*/React__default['default'].forwardRef(function PiggyBankSlot16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$a || (_path99$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H20V13H13z"
    })), _path100$a || (_path100$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,13H26.98A5.7791,5.7791,0,0,0,25,8.8525V5a1,1,0,0,0-1.6-.8L19.6665,7H15c-5.5095,0-9.4634,3.2412-9.9485,8H5a1.0009,1.0009,0,0,1-1-1V12H2v2a3.0033,3.0033,0,0,0,3,3h.07A9.1733,9.1733,0,0,0,9,23.5566V27a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V25h3v2a1,1,0,0,0,1,1h4a1,1,0,0,0,1-1V23.6372A5.0928,5.0928,0,0,0,26.8188,20H29a1,1,0,0,0,1-1V14A1,1,0,0,0,29,13Zm-1,5H25.124c-.3052,2.7529-.8235,3.4854-3.124,4.3154V26H20V23H13v3H11V22.3779A7.0129,7.0129,0,0,1,7,16c0-4.8354,4.0181-7,8-7h5.3335L23,7V9.7764c2.4182,1.8593,1.9126,3.186,2.0183,5.2236H28Z"
    })), children);
  });
  var Pills32 = /*#__PURE__*/React__default['default'].forwardRef(function Pills32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$a || (_path101$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"
    })), children);
  });
  var Pills24 = /*#__PURE__*/React__default['default'].forwardRef(function Pills24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$a || (_path102$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"
    })), children);
  });
  var Pills20 = /*#__PURE__*/React__default['default'].forwardRef(function Pills20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$a || (_path103$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"
    })), children);
  });
  var Pills16 = /*#__PURE__*/React__default['default'].forwardRef(function Pills16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$a || (_path104$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"
    })), children);
  });
  var PillsAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function PillsAdd32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$a || (_path105$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path106$a || (_path106$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"
    })), children);
  });
  var PillsAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function PillsAdd24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$a || (_path107$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path108$a || (_path108$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"
    })), children);
  });
  var PillsAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function PillsAdd20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$a || (_path109$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path110$a || (_path110$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"
    })), children);
  });
  var PillsAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function PillsAdd16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$a || (_path111$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path112$a || (_path112$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"
    })), children);
  });
  var PillsSubtract32 = /*#__PURE__*/React__default['default'].forwardRef(function PillsSubtract32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$a || (_path113$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path114$a || (_path114$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H25V23H19z"
    })), children);
  });
  var PillsSubtract24 = /*#__PURE__*/React__default['default'].forwardRef(function PillsSubtract24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$a || (_path115$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path116$a || (_path116$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H25V23H19z"
    })), children);
  });
  var PillsSubtract20 = /*#__PURE__*/React__default['default'].forwardRef(function PillsSubtract20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$a || (_path117$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path118$a || (_path118$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H25V23H19z"
    })), children);
  });
  var PillsSubtract16 = /*#__PURE__*/React__default['default'].forwardRef(function PillsSubtract16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$a || (_path119$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"
    })), _path120$a || (_path120$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 21H25V23H19z"
    })), children);
  });
  var Pin32 = /*#__PURE__*/React__default['default'].forwardRef(function Pin32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$a || (_path121$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"
    })), children);
  });
  var Pin24 = /*#__PURE__*/React__default['default'].forwardRef(function Pin24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$a || (_path122$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"
    })), children);
  });
  var Pin20 = /*#__PURE__*/React__default['default'].forwardRef(function Pin20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$a || (_path123$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"
    })), children);
  });
  var Pin16 = /*#__PURE__*/React__default['default'].forwardRef(function Pin16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$a || (_path124$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"
    })), children);
  });
  var PinFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PinFilled32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$a || (_path125$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5858,13.3137,30,11.9,20,2,18.6858,3.415l1.1858,1.1857L8.38,14.3225,6.6641,12.6067,5.25,14l5.6572,5.6773L2,28.5831,3.41,30l8.9111-8.9087L18,26.7482l1.3929-1.414L17.6765,23.618l9.724-11.4895Z"
    })), children);
  });
  var PinFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PinFilled24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$a || (_path126$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5858,13.3137,30,11.9,20,2,18.6858,3.415l1.1858,1.1857L8.38,14.3225,6.6641,12.6067,5.25,14l5.6572,5.6773L2,28.5831,3.41,30l8.9111-8.9087L18,26.7482l1.3929-1.414L17.6765,23.618l9.724-11.4895Z"
    })), children);
  });
  var PinFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PinFilled20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$a || (_path127$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5858,13.3137,30,11.9,20,2,18.6858,3.415l1.1858,1.1857L8.38,14.3225,6.6641,12.6067,5.25,14l5.6572,5.6773L2,28.5831,3.41,30l8.9111-8.9087L18,26.7482l1.3929-1.414L17.6765,23.618l9.724-11.4895Z"
    })), children);
  });
  var PinFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PinFilled16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$a || (_path128$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5858,13.3137,30,11.9,20,2,18.6858,3.415l1.1858,1.1857L8.38,14.3225,6.6641,12.6067,5.25,14l5.6572,5.6773L2,28.5831,3.41,30l8.9111-8.9087L18,26.7482l1.3929-1.414L17.6765,23.618l9.724-11.4895Z"
    })), children);
  });
  var Plane32 = /*#__PURE__*/React__default['default'].forwardRef(function Plane32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$a || (_path129$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"
    })), children);
  });
  var Plane24 = /*#__PURE__*/React__default['default'].forwardRef(function Plane24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$a || (_path130$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"
    })), children);
  });
  var Plane20 = /*#__PURE__*/React__default['default'].forwardRef(function Plane20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$a || (_path131$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"
    })), children);
  });
  var Plane16 = /*#__PURE__*/React__default['default'].forwardRef(function Plane16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$a || (_path132$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"
    })), children);
  });
  var PlanePrivate32 = /*#__PURE__*/React__default['default'].forwardRef(function PlanePrivate32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$a || (_path133$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5845,14.585l-3.12-1.8721A4.9951,4.9951,0,0,0,22.8921,12H7.7808L7.16,9.5151A1.9975,1.9975,0,0,0,5.2192,8H4a2.0023,2.0023,0,0,0-2,2v7a3.0033,3.0033,0,0,0,3,3h7v6a2.0023,2.0023,0,0,0,2,2h1.3071A2.0086,2.0086,0,0,0,17.18,26.7021L19.6929,20h7.3916a2.9152,2.9152,0,0,0,1.5-5.415ZM27.0845,18H18.3071l-3,8H14V18H5a1.0009,1.0009,0,0,1-1-1V10H5.2192l1,4H10v2h2V14h3v2h2V14h3v2h2V14h.8921a2.9977,2.9977,0,0,1,1.5434.4277l3.12,1.8721a.9154.9154,0,0,1-.4712,1.7Z"
    })), _path134$a || (_path134$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4h1.3228l2.4,6h2.1545L17.18,3.2573A1.9906,1.9906,0,0,0,15.3228,2H14a2.0023,2.0023,0,0,0-2,2v6h2Z"
    })), children);
  });
  var PlanePrivate24 = /*#__PURE__*/React__default['default'].forwardRef(function PlanePrivate24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$a || (_path135$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5845,14.585l-3.12-1.8721A4.9951,4.9951,0,0,0,22.8921,12H7.7808L7.16,9.5151A1.9975,1.9975,0,0,0,5.2192,8H4a2.0023,2.0023,0,0,0-2,2v7a3.0033,3.0033,0,0,0,3,3h7v6a2.0023,2.0023,0,0,0,2,2h1.3071A2.0086,2.0086,0,0,0,17.18,26.7021L19.6929,20h7.3916a2.9152,2.9152,0,0,0,1.5-5.415ZM27.0845,18H18.3071l-3,8H14V18H5a1.0009,1.0009,0,0,1-1-1V10H5.2192l1,4H10v2h2V14h3v2h2V14h3v2h2V14h.8921a2.9977,2.9977,0,0,1,1.5434.4277l3.12,1.8721a.9154.9154,0,0,1-.4712,1.7Z"
    })), _path136$a || (_path136$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4h1.3228l2.4,6h2.1545L17.18,3.2573A1.9906,1.9906,0,0,0,15.3228,2H14a2.0023,2.0023,0,0,0-2,2v6h2Z"
    })), children);
  });
  var PlanePrivate20 = /*#__PURE__*/React__default['default'].forwardRef(function PlanePrivate20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$a || (_path137$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5845,14.585l-3.12-1.8721A4.9951,4.9951,0,0,0,22.8921,12H7.7808L7.16,9.5151A1.9975,1.9975,0,0,0,5.2192,8H4a2.0023,2.0023,0,0,0-2,2v7a3.0033,3.0033,0,0,0,3,3h7v6a2.0023,2.0023,0,0,0,2,2h1.3071A2.0086,2.0086,0,0,0,17.18,26.7021L19.6929,20h7.3916a2.9152,2.9152,0,0,0,1.5-5.415ZM27.0845,18H18.3071l-3,8H14V18H5a1.0009,1.0009,0,0,1-1-1V10H5.2192l1,4H10v2h2V14h3v2h2V14h3v2h2V14h.8921a2.9977,2.9977,0,0,1,1.5434.4277l3.12,1.8721a.9154.9154,0,0,1-.4712,1.7Z"
    })), _path138$a || (_path138$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4h1.3228l2.4,6h2.1545L17.18,3.2573A1.9906,1.9906,0,0,0,15.3228,2H14a2.0023,2.0023,0,0,0-2,2v6h2Z"
    })), children);
  });
  var PlanePrivate16 = /*#__PURE__*/React__default['default'].forwardRef(function PlanePrivate16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$a || (_path139$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5845,14.585l-3.12-1.8721A4.9951,4.9951,0,0,0,22.8921,12H7.7808L7.16,9.5151A1.9975,1.9975,0,0,0,5.2192,8H4a2.0023,2.0023,0,0,0-2,2v7a3.0033,3.0033,0,0,0,3,3h7v6a2.0023,2.0023,0,0,0,2,2h1.3071A2.0086,2.0086,0,0,0,17.18,26.7021L19.6929,20h7.3916a2.9152,2.9152,0,0,0,1.5-5.415ZM27.0845,18H18.3071l-3,8H14V18H5a1.0009,1.0009,0,0,1-1-1V10H5.2192l1,4H10v2h2V14h3v2h2V14h3v2h2V14h.8921a2.9977,2.9977,0,0,1,1.5434.4277l3.12,1.8721a.9154.9154,0,0,1-.4712,1.7Z"
    })), _path140$a || (_path140$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4h1.3228l2.4,6h2.1545L17.18,3.2573A1.9906,1.9906,0,0,0,15.3228,2H14a2.0023,2.0023,0,0,0-2,2v6h2Z"
    })), children);
  });
  var PlaneSea32 = /*#__PURE__*/React__default['default'].forwardRef(function PlaneSea32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$a || (_path141$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 30H2V28H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 28a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 28a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 28h2zM28 6v4H25.5L23.4 7.2A3.0129 3.0129 0 0021 6H15a3.0033 3.0033 0 00-3 3v1H8.6182L7.8945 8.5527l-1-2A1 1 0 006 6H3A1 1 0 002 7v6a3.0033 3.0033 0 003 3h6.82l-.6666 4H7a1 1 0 000 2H27a1 1 0 000-2H22.847L22.18 16h.1629a4.9662 4.9662 0 003.5351-1.4648L28 12.4141V16h2V6zM14 9a1.0009 1.0009 0 011-1h6a1.0045 1.0045 0 01.8.4L23 10H14zm6.82 11H13.18l.6666-4h6.306zm1.5237-6H5a1.0009 1.0009 0 01-1-1V8H5.3818l.7237 1.4473L7.3818 12h18.204l-1.1214 1.1211A2.9789 2.9789 0 0122.3433 14z"
    })), children);
  });
  var PlaneSea24 = /*#__PURE__*/React__default['default'].forwardRef(function PlaneSea24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$a || (_path142$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 30H2V28H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 28a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 28a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 28h2zM28 6v4H25.5L23.4 7.2A3.0129 3.0129 0 0021 6H15a3.0033 3.0033 0 00-3 3v1H8.6182L7.8945 8.5527l-1-2A1 1 0 006 6H3A1 1 0 002 7v6a3.0033 3.0033 0 003 3h6.82l-.6666 4H7a1 1 0 000 2H27a1 1 0 000-2H22.847L22.18 16h.1629a4.9662 4.9662 0 003.5351-1.4648L28 12.4141V16h2V6zM14 9a1.0009 1.0009 0 011-1h6a1.0045 1.0045 0 01.8.4L23 10H14zm6.82 11H13.18l.6666-4h6.306zm1.5237-6H5a1.0009 1.0009 0 01-1-1V8H5.3818l.7237 1.4473L7.3818 12h18.204l-1.1214 1.1211A2.9789 2.9789 0 0122.3433 14z"
    })), children);
  });
  var PlaneSea20 = /*#__PURE__*/React__default['default'].forwardRef(function PlaneSea20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$a || (_path143$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 30H2V28H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 28a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 28a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 28h2zM28 6v4H25.5L23.4 7.2A3.0129 3.0129 0 0021 6H15a3.0033 3.0033 0 00-3 3v1H8.6182L7.8945 8.5527l-1-2A1 1 0 006 6H3A1 1 0 002 7v6a3.0033 3.0033 0 003 3h6.82l-.6666 4H7a1 1 0 000 2H27a1 1 0 000-2H22.847L22.18 16h.1629a4.9662 4.9662 0 003.5351-1.4648L28 12.4141V16h2V6zM14 9a1.0009 1.0009 0 011-1h6a1.0045 1.0045 0 01.8.4L23 10H14zm6.82 11H13.18l.6666-4h6.306zm1.5237-6H5a1.0009 1.0009 0 01-1-1V8H5.3818l.7237 1.4473L7.3818 12h18.204l-1.1214 1.1211A2.9789 2.9789 0 0122.3433 14z"
    })), children);
  });
  var PlaneSea16 = /*#__PURE__*/React__default['default'].forwardRef(function PlaneSea16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$a || (_path144$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 30H2V28H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 28a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 25a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 28a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 28h2zM28 6v4H25.5L23.4 7.2A3.0129 3.0129 0 0021 6H15a3.0033 3.0033 0 00-3 3v1H8.6182L7.8945 8.5527l-1-2A1 1 0 006 6H3A1 1 0 002 7v6a3.0033 3.0033 0 003 3h6.82l-.6666 4H7a1 1 0 000 2H27a1 1 0 000-2H22.847L22.18 16h.1629a4.9662 4.9662 0 003.5351-1.4648L28 12.4141V16h2V6zM14 9a1.0009 1.0009 0 011-1h6a1.0045 1.0045 0 01.8.4L23 10H14zm6.82 11H13.18l.6666-4h6.306zm1.5237-6H5a1.0009 1.0009 0 01-1-1V8H5.3818l.7237 1.4473L7.3818 12h18.204l-1.1214 1.1211A2.9789 2.9789 0 0122.3433 14z"
    })), children);
  });
  var Play32 = /*#__PURE__*/React__default['default'].forwardRef(function Play32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$a || (_path145$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28ZM8,6.6909V25.3088L24.9248,16Z"
    })), children);
  });
  var Play24 = /*#__PURE__*/React__default['default'].forwardRef(function Play24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$a || (_path146$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28ZM8,6.6909V25.3088L24.9248,16Z"
    })), children);
  });
  var Play20 = /*#__PURE__*/React__default['default'].forwardRef(function Play20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$a || (_path147$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28ZM8,6.6909V25.3088L24.9248,16Z"
    })), children);
  });
  var Play16 = /*#__PURE__*/React__default['default'].forwardRef(function Play16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$a || (_path148$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.5,14C3.2,14,3,13.8,3,13.5v-11c0-0.2,0.1-0.3,0.2-0.4C3.4,2,3.6,2,3.8,2.1l9.5,5.5c0.2,0.1,0.3,0.4,0.2,0.7\tc0,0.1-0.1,0.1-0.2,0.2l-9.5,5.5C3.7,14,3.6,14,3.5,14z M4,3.4v9.3L12,8L4,3.4z"
    })), children);
  });
  var PlayFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilled32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$a || (_path149$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Z"
    })), _path150$a || (_path150$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.4473,14.8945-12,6A1,1,0,0,1,10,22V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789Z"
    })), children);
  });
  var PlayFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilled24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$a || (_path151$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Z"
    })), _path152$a || (_path152$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.4473,14.8945-12,6A1,1,0,0,1,10,22V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789Z"
    })), children);
  });
  var PlayFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilled20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$a || (_path153$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Z"
    })), _path154$a || (_path154$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.4473,14.8945-12,6A1,1,0,0,1,10,22V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789Z"
    })), children);
  });
  var PlayFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilled16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$a || (_path155$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11.7,8.4l-5.5,3c-0.2,0.1-0.3,0.1-0.5,0c-0.2-0.1-0.2-0.3-0.2-0.4V5\tc0-0.2,0.1-0.3,0.2-0.4c0.2-0.1,0.3-0.1,0.5,0l5.5,3C12,7.7,12.1,8,11.9,8.2C11.9,8.3,11.8,8.4,11.7,8.4L11.7,8.4z"
    })), children);
  });
  var PlayFilledAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilledAlt32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$a || (_path156$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28Z"
    })), children);
  });
  var PlayFilledAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilledAlt24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$a || (_path157$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28Z"
    })), children);
  });
  var PlayFilledAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilledAlt20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$a || (_path158$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28Z"
    })), children);
  });
  var PlayFilledAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function PlayFilledAlt16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$a || (_path159$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.4819-.8763l20,11a1,1,0,0,1,0,1.7525l-20,11A1.0005,1.0005,0,0,1,7,28Z"
    })), children);
  });
  var PlayOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutline32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$a || (_path160$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Zm1-11.3821v8.7642L20.7642,16Z"
    })), _path161$a || (_path161$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var PlayOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutline24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$a || (_path162$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Zm1-11.3821v8.7642L20.7642,16Z"
    })), _path163$a || (_path163$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var PlayOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutline20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$a || (_path164$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Zm1-11.3821v8.7642L20.7642,16Z"
    })), _path165$a || (_path165$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), children);
  });
  var PlayOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutline16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$a || (_path166$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"
    })), _path167$a || (_path167$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,11.5c-0.1,0-0.2,0-0.3-0.1c-0.2-0.1-0.2-0.3-0.2-0.4V5c0-0.2,0.1-0.3,0.2-0.4c0.2-0.1,0.3-0.1,0.5,0l5.5,3\tC12,7.7,12.1,8,11.9,8.2c0,0.1-0.1,0.2-0.2,0.2l-5.5,3C6.2,11.5,6.1,11.5,6,11.5z M6.5,5.8v4.3l4-2.2L6.5,5.8z"
    })), children);
  });
  var PlayOutlineFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutlineFilled32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$a || (_path168$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Zm1-11.3821v8.7642L20.7642,16Z"
    })), _path169$a || (_path169$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 20.382L20.764 16 12 11.618 12 20.382z"
    })), _path170$a || (_path170$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.4473,14.8945-12,6A1,1,0,0,1,10,22V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789Z"
    })), children);
  });
  var PlayOutlineFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutlineFilled24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$a || (_path171$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Zm1-11.3821v8.7642L20.7642,16Z"
    })), _path172$a || (_path172$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 20.382L20.764 16 12 11.618 12 20.382z"
    })), _path173$a || (_path173$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.4473,14.8945-12,6A1,1,0,0,1,10,22V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789Z"
    })), children);
  });
  var PlayOutlineFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutlineFilled20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$a || (_path174$a = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11,23a1,1,0,0,1-1-1V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789l-12,6A1.001,1.001,0,0,1,11,23Zm1-11.3821v8.7642L20.7642,16Z"
    })), _path175$a || (_path175$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 20.382L20.764 16 12 11.618 12 20.382z"
    })), _path176$a || (_path176$a = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.4473,14.8945-12,6A1,1,0,0,1,10,22V10a1,1,0,0,1,1.4473-.8945l12,6a1,1,0,0,1,0,1.789Z"
    })), children);
  });
  var PlayOutlineFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PlayOutlineFilled16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$9 || (_path177$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11.7,8.4l-5.5,3c-0.2,0.1-0.3,0.1-0.5,0c-0.2-0.1-0.2-0.3-0.2-0.4V5\tc0-0.2,0.1-0.3,0.2-0.4c0.2-0.1,0.3-0.1,0.5,0l5.5,3C12,7.7,12.1,8,11.9,8.2C11.9,8.3,11.8,8.4,11.7,8.4L11.7,8.4z"
    })), _path178$9 || (_path178$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.5 10.2L10.5 8 6.5 5.8z"
    })), children);
  });
  var Playlist32 = /*#__PURE__*/React__default['default'].forwardRef(function Playlist32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$9 || (_path179$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"
    })), children);
  });
  var Playlist24 = /*#__PURE__*/React__default['default'].forwardRef(function Playlist24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$9 || (_path180$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"
    })), children);
  });
  var Playlist20 = /*#__PURE__*/React__default['default'].forwardRef(function Playlist20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$9 || (_path181$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"
    })), children);
  });
  var Playlist16 = /*#__PURE__*/React__default['default'].forwardRef(function Playlist16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$9 || (_path182$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"
    })), children);
  });
  var Plug32 = /*#__PURE__*/React__default['default'].forwardRef(function Plug32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$9 || (_path183$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Zm0,8a6,6,0,0,1-12,0V10H22Z"
    })), children);
  });
  var Plug24 = /*#__PURE__*/React__default['default'].forwardRef(function Plug24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$9 || (_path184$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Zm0,8a6,6,0,0,1-12,0V10H22Z"
    })), children);
  });
  var Plug20 = /*#__PURE__*/React__default['default'].forwardRef(function Plug20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$9 || (_path185$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Zm0,8a6,6,0,0,1-12,0V10H22Z"
    })), children);
  });
  var Plug16 = /*#__PURE__*/React__default['default'].forwardRef(function Plug16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$9 || (_path186$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Zm0,8a6,6,0,0,1-12,0V10H22Z"
    })), children);
  });
  var PlugFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PlugFilled32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$9 || (_path187$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Z"
    })), children);
  });
  var PlugFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PlugFilled24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$a);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$9 || (_path188$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Z"
    })), children);
  });
  var PlugFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PlugFilled20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$9 || (_path189$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Z"
    })), children);
  });
  var PlugFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PlugFilled16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$9 || (_path190$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,8H21V2H19V8H13V2H11V8H10a2,2,0,0,0-2,2v6a8.0073,8.0073,0,0,0,7,7.9307V30h2V23.9307A8.0073,8.0073,0,0,0,24,16V10A2,2,0,0,0,22,8Z"
    })), children);
  });
  var Png32 = /*#__PURE__*/React__default['default'].forwardRef(function Png32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$9 || (_path191$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 012 2v5a2 2 0 01-2 2H4zm0-7H8V11H4z"
    })), children);
  });
  var Png24 = /*#__PURE__*/React__default['default'].forwardRef(function Png24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$9 || (_path192$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 012 2v5a2 2 0 01-2 2H4zm0-7H8V11H4z"
    })), children);
  });
  var Png20 = /*#__PURE__*/React__default['default'].forwardRef(function Png20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$9 || (_path193$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 012 2v5a2 2 0 01-2 2H4zm0-7H8V11H4z"
    })), children);
  });
  var Png16 = /*#__PURE__*/React__default['default'].forwardRef(function Png16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$9 || (_path194$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 012 2v5a2 2 0 01-2 2H4zm0-7H8V11H4z"
    })), children);
  });
  var PointOfPresence32 = /*#__PURE__*/React__default['default'].forwardRef(function PointOfPresence32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$9 || (_path195$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H18a2.0021 2.0021 0 01-2-2V18a2.0021 2.0021 0 012-2h2v2H18V28H28V18H26V16h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM14 16H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H14a2.0021 2.0021 0 012 2V6H14V4H4V14H14V12h2v2A2.0021 2.0021 0 0114 16z"
    })), _path196$9 || (_path196$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,9a2.9926,2.9926,0,0,0-5.8157-1H9v2H20.1843A2.9939,2.9939,0,0,0,22,11.8154V23h2V11.8159A2.9958,2.9958,0,0,0,26,9Zm-3,1a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,23,10Z"
    })), children);
  });
  var PointOfPresence24 = /*#__PURE__*/React__default['default'].forwardRef(function PointOfPresence24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$9 || (_path197$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H18a2.0021 2.0021 0 01-2-2V18a2.0021 2.0021 0 012-2h2v2H18V28H28V18H26V16h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM14 16H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H14a2.0021 2.0021 0 012 2V6H14V4H4V14H14V12h2v2A2.0021 2.0021 0 0114 16z"
    })), _path198$9 || (_path198$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,9a2.9926,2.9926,0,0,0-5.8157-1H9v2H20.1843A2.9939,2.9939,0,0,0,22,11.8154V23h2V11.8159A2.9958,2.9958,0,0,0,26,9Zm-3,1a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,23,10Z"
    })), children);
  });
  var PointOfPresence20 = /*#__PURE__*/React__default['default'].forwardRef(function PointOfPresence20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$9 || (_path199$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H18a2.0021 2.0021 0 01-2-2V18a2.0021 2.0021 0 012-2h2v2H18V28H28V18H26V16h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM14 16H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H14a2.0021 2.0021 0 012 2V6H14V4H4V14H14V12h2v2A2.0021 2.0021 0 0114 16z"
    })), _path200$9 || (_path200$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,9a2.9926,2.9926,0,0,0-5.8157-1H9v2H20.1843A2.9939,2.9939,0,0,0,22,11.8154V23h2V11.8159A2.9958,2.9958,0,0,0,26,9Zm-3,1a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,23,10Z"
    })), children);
  });
  var PointOfPresence16 = /*#__PURE__*/React__default['default'].forwardRef(function PointOfPresence16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$9 || (_path201$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H18a2.0021 2.0021 0 01-2-2V18a2.0021 2.0021 0 012-2h2v2H18V28H28V18H26V16h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM14 16H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2H14a2.0021 2.0021 0 012 2V6H14V4H4V14H14V12h2v2A2.0021 2.0021 0 0114 16z"
    })), _path202$9 || (_path202$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,9a2.9926,2.9926,0,0,0-5.8157-1H9v2H20.1843A2.9939,2.9939,0,0,0,22,11.8154V23h2V11.8159A2.9958,2.9958,0,0,0,26,9Zm-3,1a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,23,10Z"
    })), children);
  });
  var WatsonHealthPointerText32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPointerText32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$9 || (_path203$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 01-2-2V18h2V28H28V12H18V10H28a2 2 0 012 2V28A2 2 0 0128 30z"
    })), _path204$9 || (_path204$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"
    })), children);
  });
  var WatsonHealthPointerText24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPointerText24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$9 || (_path205$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 01-2-2V18h2V28H28V12H18V10H28a2 2 0 012 2V28A2 2 0 0128 30z"
    })), _path206$9 || (_path206$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"
    })), children);
  });
  var WatsonHealthPointerText20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPointerText20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$9 || (_path207$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 01-2-2V18h2V28H28V12H18V10H28a2 2 0 012 2V28A2 2 0 0128 30z"
    })), _path208$9 || (_path208$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"
    })), children);
  });
  var WatsonHealthPointerText16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthPointerText16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$9 || (_path209$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 01-2-2V18h2V28H28V12H18V10H28a2 2 0 012 2V28A2 2 0 0128 30z"
    })), _path210$9 || (_path210$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"
    })), children);
  });
  var Police32 = /*#__PURE__*/React__default['default'].forwardRef(function Police32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$9 || (_path211$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 24H12V30H10z"
    })), _path212$9 || (_path212$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H7a3.0033,3.0033,0,0,1-3-3V6H2V17a5.0059,5.0059,0,0,0,5,5H21a4.9419,4.9419,0,0,1,2.105.481L17,28.5859,18.4141,30l6.3071-6.3071A4.96,4.96,0,0,1,26,27v3h2V27A7.0078,7.0078,0,0,0,21,20Z"
    })), _path213$9 || (_path213$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.2746,4.0386l-7-2a1.0013,1.0013,0,0,0-.55,0l-7,2A.9993.9993,0,0,0,10.03,5.2422L11,9.123V11A7,7,0,1,0,25,11V9.123l.97-3.8808A.9993.9993,0,0,0,25.2746,4.0386ZM18,4.04l5.7952,1.6558L23.219,8H19V6H17V8H12.781l-.5762-2.3042ZM18,16a5.0058,5.0058,0,0,1-5-5V10H23v1A5.0058,5.0058,0,0,1,18,16Z"
    })), children);
  });
  var Police24 = /*#__PURE__*/React__default['default'].forwardRef(function Police24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$9 || (_path214$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 24H12V30H10z"
    })), _path215$9 || (_path215$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H7a3.0033,3.0033,0,0,1-3-3V6H2V17a5.0059,5.0059,0,0,0,5,5H21a4.9419,4.9419,0,0,1,2.105.481L17,28.5859,18.4141,30l6.3071-6.3071A4.96,4.96,0,0,1,26,27v3h2V27A7.0078,7.0078,0,0,0,21,20Z"
    })), _path216$9 || (_path216$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.2746,4.0386l-7-2a1.0013,1.0013,0,0,0-.55,0l-7,2A.9993.9993,0,0,0,10.03,5.2422L11,9.123V11A7,7,0,1,0,25,11V9.123l.97-3.8808A.9993.9993,0,0,0,25.2746,4.0386ZM18,4.04l5.7952,1.6558L23.219,8H19V6H17V8H12.781l-.5762-2.3042ZM18,16a5.0058,5.0058,0,0,1-5-5V10H23v1A5.0058,5.0058,0,0,1,18,16Z"
    })), children);
  });
  var Police20 = /*#__PURE__*/React__default['default'].forwardRef(function Police20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$9 || (_path217$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 24H12V30H10z"
    })), _path218$9 || (_path218$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H7a3.0033,3.0033,0,0,1-3-3V6H2V17a5.0059,5.0059,0,0,0,5,5H21a4.9419,4.9419,0,0,1,2.105.481L17,28.5859,18.4141,30l6.3071-6.3071A4.96,4.96,0,0,1,26,27v3h2V27A7.0078,7.0078,0,0,0,21,20Z"
    })), _path219$9 || (_path219$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.2746,4.0386l-7-2a1.0013,1.0013,0,0,0-.55,0l-7,2A.9993.9993,0,0,0,10.03,5.2422L11,9.123V11A7,7,0,1,0,25,11V9.123l.97-3.8808A.9993.9993,0,0,0,25.2746,4.0386ZM18,4.04l5.7952,1.6558L23.219,8H19V6H17V8H12.781l-.5762-2.3042ZM18,16a5.0058,5.0058,0,0,1-5-5V10H23v1A5.0058,5.0058,0,0,1,18,16Z"
    })), children);
  });
  var Police16 = /*#__PURE__*/React__default['default'].forwardRef(function Police16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$9 || (_path220$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 24H12V30H10z"
    })), _path221$9 || (_path221$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H7a3.0033,3.0033,0,0,1-3-3V6H2V17a5.0059,5.0059,0,0,0,5,5H21a4.9419,4.9419,0,0,1,2.105.481L17,28.5859,18.4141,30l6.3071-6.3071A4.96,4.96,0,0,1,26,27v3h2V27A7.0078,7.0078,0,0,0,21,20Z"
    })), _path222$9 || (_path222$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.2746,4.0386l-7-2a1.0013,1.0013,0,0,0-.55,0l-7,2A.9993.9993,0,0,0,10.03,5.2422L11,9.123V11A7,7,0,1,0,25,11V9.123l.97-3.8808A.9993.9993,0,0,0,25.2746,4.0386ZM18,4.04l5.7952,1.6558L23.219,8H19V6H17V8H12.781l-.5762-2.3042ZM18,16a5.0058,5.0058,0,0,1-5-5V10H23v1A5.0058,5.0058,0,0,1,18,16Z"
    })), children);
  });
  var Policy32 = /*#__PURE__*/React__default['default'].forwardRef(function Policy32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$9 || (_path223$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18A6 6 0 1020 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0030 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 004 0zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zM9 14H16V16H9zM9 8H19V10H9z"
    })), _path224$9 || (_path224$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"
    })), children);
  });
  var Policy24 = /*#__PURE__*/React__default['default'].forwardRef(function Policy24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$9 || (_path225$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18A6 6 0 1020 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0030 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 004 0zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zM9 14H16V16H9zM9 8H19V10H9z"
    })), _path226$9 || (_path226$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"
    })), children);
  });
  var Policy20 = /*#__PURE__*/React__default['default'].forwardRef(function Policy20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$9 || (_path227$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18A6 6 0 1020 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0030 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 004 0zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zM9 14H16V16H9zM9 8H19V10H9z"
    })), _path228$9 || (_path228$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"
    })), children);
  });
  var Policy16 = /*#__PURE__*/React__default['default'].forwardRef(function Policy16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$9 || (_path229$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18A6 6 0 1020 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0030 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 004 0zM24 22a4 4 0 114-4A4.0045 4.0045 0 0124 22zM9 14H16V16H9zM9 8H19V10H9z"
    })), _path230$9 || (_path230$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"
    })), children);
  });
  var Popup32 = /*#__PURE__*/React__default['default'].forwardRef(function Popup32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$9 || (_path231$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"
    })), _path232$9 || (_path232$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"
    })), children);
  });
  var Popup24 = /*#__PURE__*/React__default['default'].forwardRef(function Popup24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$9 || (_path233$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"
    })), _path234$9 || (_path234$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"
    })), children);
  });
  var Popup20 = /*#__PURE__*/React__default['default'].forwardRef(function Popup20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$9 || (_path235$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"
    })), _path236$9 || (_path236$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"
    })), children);
  });
  var Popup16 = /*#__PURE__*/React__default['default'].forwardRef(function Popup16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$9 || (_path237$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"
    })), _path238$9 || (_path238$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"
    })), children);
  });
  var Portfolio32 = /*#__PURE__*/React__default['default'].forwardRef(function Portfolio32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$9 || (_path239$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"
    })), children);
  });
  var Portfolio24 = /*#__PURE__*/React__default['default'].forwardRef(function Portfolio24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$9 || (_path240$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"
    })), children);
  });
  var Portfolio20 = /*#__PURE__*/React__default['default'].forwardRef(function Portfolio20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$9 || (_path241$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"
    })), children);
  });
  var Portfolio16 = /*#__PURE__*/React__default['default'].forwardRef(function Portfolio16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$9 || (_path242$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"
    })), children);
  });
  var Power32 = /*#__PURE__*/React__default['default'].forwardRef(function Power32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$9 || (_path243$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,5.74l-1,1.73a11,11,0,1,1-11,0l-1-1.73a13,13,0,1,0,13,0Z"
    })), _path244$9 || (_path244$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V16H15z"
    })), children);
  });
  var Power24 = /*#__PURE__*/React__default['default'].forwardRef(function Power24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$9 || (_path245$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,5.74l-1,1.73a11,11,0,1,1-11,0l-1-1.73a13,13,0,1,0,13,0Z"
    })), _path246$9 || (_path246$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V16H15z"
    })), children);
  });
  var Power20 = /*#__PURE__*/React__default['default'].forwardRef(function Power20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$9 || (_path247$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,5.74l-1,1.73a11,11,0,1,1-11,0l-1-1.73a13,13,0,1,0,13,0Z"
    })), _path248$9 || (_path248$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V16H15z"
    })), children);
  });
  var Power16 = /*#__PURE__*/React__default['default'].forwardRef(function Power16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$9 || (_path249$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.2,2.9l-0.5,0.9c2.6,1.5,3.5,4.9,2,7.5s-4.9,3.5-7.5,2s-3.5-4.9-2-7.5c0.5-0.8,1.2-1.5,2-2L4.8,2.9\tc-3.1,1.8-4.2,5.8-2.4,8.9s5.8,4.2,8.9,2.4s4.2-5.8,2.4-8.9C13.1,4.3,12.2,3.4,11.2,2.9z"
    })), _path250$9 || (_path250$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 1H8.5V8H7.5z"
    })), children);
  });
  var Ppt32 = /*#__PURE__*/React__default['default'].forwardRef(function Ppt32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$9 || (_path251$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H4zm0-7H8V10.9985H4z"
    })), children);
  });
  var Ppt24 = /*#__PURE__*/React__default['default'].forwardRef(function Ppt24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$9 || (_path252$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H4zm0-7H8V10.9985H4z"
    })), children);
  });
  var Ppt20 = /*#__PURE__*/React__default['default'].forwardRef(function Ppt20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$9 || (_path253$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H4zm0-7H8V10.9985H4z"
    })), children);
  });
  var Ppt16 = /*#__PURE__*/React__default['default'].forwardRef(function Ppt16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$9 || (_path254$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 012 2v5a2.002 2.002 0 01-2 2H4zm0-7H8V10.9985H4z"
    })), children);
  });
  var PresentationFile32 = /*#__PURE__*/React__default['default'].forwardRef(function PresentationFile32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$9 || (_path255$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"
    })), _path256$9 || (_path256$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"
    })), children);
  });
  var PresentationFile24 = /*#__PURE__*/React__default['default'].forwardRef(function PresentationFile24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$9 || (_path257$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"
    })), _path258$9 || (_path258$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"
    })), children);
  });
  var PresentationFile20 = /*#__PURE__*/React__default['default'].forwardRef(function PresentationFile20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$9 || (_path259$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"
    })), _path260$9 || (_path260$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"
    })), children);
  });
  var PresentationFile16 = /*#__PURE__*/React__default['default'].forwardRef(function PresentationFile16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$9 || (_path261$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"
    })), _path262$9 || (_path262$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"
    })), children);
  });
  var Pressure32 = /*#__PURE__*/React__default['default'].forwardRef(function Pressure32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$9 || (_path263$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5053,16l8.1591-7.2529A1,1,0,0,0,25,7H22V2H20V9h2.37L16,14.6621,9.63,9H12V2H10V7H7a1,1,0,0,0-.6646,1.7471L14.4945,16,6.3353,23.2529A1,1,0,0,0,7,25h3v5h2V23H9.63L16,17.3379,22.37,23H20v7h2V25h3a1,1,0,0,0,.6645-1.7471Z"
    })), children);
  });
  var Pressure24 = /*#__PURE__*/React__default['default'].forwardRef(function Pressure24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$9 || (_path264$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5053,16l8.1591-7.2529A1,1,0,0,0,25,7H22V2H20V9h2.37L16,14.6621,9.63,9H12V2H10V7H7a1,1,0,0,0-.6646,1.7471L14.4945,16,6.3353,23.2529A1,1,0,0,0,7,25h3v5h2V23H9.63L16,17.3379,22.37,23H20v7h2V25h3a1,1,0,0,0,.6645-1.7471Z"
    })), children);
  });
  var Pressure20 = /*#__PURE__*/React__default['default'].forwardRef(function Pressure20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$9 || (_path265$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5053,16l8.1591-7.2529A1,1,0,0,0,25,7H22V2H20V9h2.37L16,14.6621,9.63,9H12V2H10V7H7a1,1,0,0,0-.6646,1.7471L14.4945,16,6.3353,23.2529A1,1,0,0,0,7,25h3v5h2V23H9.63L16,17.3379,22.37,23H20v7h2V25h3a1,1,0,0,0,.6645-1.7471Z"
    })), children);
  });
  var Pressure16 = /*#__PURE__*/React__default['default'].forwardRef(function Pressure16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$9 || (_path266$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5053,16l8.1591-7.2529A1,1,0,0,0,25,7H22V2H20V9h2.37L16,14.6621,9.63,9H12V2H10V7H7a1,1,0,0,0-.6646,1.7471L14.4945,16,6.3353,23.2529A1,1,0,0,0,7,25h3v5h2V23H9.63L16,17.3379,22.37,23H20v7h2V25h3a1,1,0,0,0,.6645-1.7471Z"
    })), children);
  });
  var PressureFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PressureFilled32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$9 || (_path267$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H10V25H6l10-9 10 9H22zM16 16L6 7h4V2H22V7h4z"
    })), children);
  });
  var PressureFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PressureFilled24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$9 || (_path268$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H10V25H6l10-9 10 9H22zM16 16L6 7h4V2H22V7h4z"
    })), children);
  });
  var PressureFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PressureFilled20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$9 || (_path269$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H10V25H6l10-9 10 9H22zM16 16L6 7h4V2H22V7h4z"
    })), children);
  });
  var PressureFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PressureFilled16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$9 || (_path270$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H10V25H6l10-9 10 9H22zM16 16L6 7h4V2H22V7h4z"
    })), children);
  });
  var PreviousFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousFilled32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$9 || (_path271$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,15H11.85l5.58,5.5728L16,24,8,16l8-8,1.43,1.3926L11.85,15H24Z"
    })), _path272$9 || (_path272$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PreviousFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousFilled24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$9 || (_path273$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,15H11.85l5.58,5.5728L16,24,8,16l8-8,1.43,1.3926L11.85,15H24Z"
    })), _path274$9 || (_path274$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PreviousFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousFilled20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$9 || (_path275$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,15H11.85l5.58,5.5728L16,24,8,16l8-8,1.43,1.3926L11.85,15H24Z"
    })), _path276$9 || (_path276$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PreviousFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousFilled16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$9 || (_path277$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,15H11.85l5.58,5.5728L16,24,8,16l8-8,1.43,1.3926L11.85,15H24Z"
    })), _path278$9 || (_path278$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var PreviousOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousOutline32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$9 || (_path279$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z"
    })), _path280$9 || (_path280$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var PreviousOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousOutline24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$9 || (_path281$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z"
    })), _path282$9 || (_path282$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var PreviousOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousOutline20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$9 || (_path283$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z"
    })), _path284$9 || (_path284$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var PreviousOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function PreviousOutline16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$9 || (_path285$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.43 9.393 11.85 15 24 15 24 17 11.85 17 17.43 22.573 16 24 8 16 16 8z"
    })), _path286$9 || (_path286$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Printer32 = /*#__PURE__*/React__default['default'].forwardRef(function Printer32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$9 || (_path287$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"
    })), children);
  });
  var Printer24 = /*#__PURE__*/React__default['default'].forwardRef(function Printer24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$9 || (_path288$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"
    })), children);
  });
  var Printer20 = /*#__PURE__*/React__default['default'].forwardRef(function Printer20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$9 || (_path289$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"
    })), children);
  });
  var Printer16 = /*#__PURE__*/React__default['default'].forwardRef(function Printer16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$9 || (_path290$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"
    })), children);
  });
  var Product32 = /*#__PURE__*/React__default['default'].forwardRef(function Product32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$9 || (_path291$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H14V20H8zM8 22H18V24H8z"
    })), _path292$9 || (_path292$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"
    })), children);
  });
  var Product24 = /*#__PURE__*/React__default['default'].forwardRef(function Product24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$9 || (_path293$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H14V20H8zM8 22H18V24H8z"
    })), _path294$9 || (_path294$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"
    })), children);
  });
  var Product20 = /*#__PURE__*/React__default['default'].forwardRef(function Product20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$9 || (_path295$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H14V20H8zM8 22H18V24H8z"
    })), _path296$9 || (_path296$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"
    })), children);
  });
  var Product16 = /*#__PURE__*/React__default['default'].forwardRef(function Product16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$9 || (_path297$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18H14V20H8zM8 22H18V24H8z"
    })), _path298$9 || (_path298$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"
    })), children);
  });
  var ProgressBar32 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBar32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$9 || (_path299$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H4a2.0021,2.0021,0,0,1-2-2V13a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,21ZM4,13v6H28V13Z"
    })), _path300$9 || (_path300$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 15H20V17H6z"
    })), children);
  });
  var ProgressBar24 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBar24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$9 || (_path301$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H4a2.0021,2.0021,0,0,1-2-2V13a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,21ZM4,13v6H28V13Z"
    })), _path302$9 || (_path302$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 15H20V17H6z"
    })), children);
  });
  var ProgressBar20 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBar20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$9 || (_path303$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H4a2.0021,2.0021,0,0,1-2-2V13a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,21ZM4,13v6H28V13Z"
    })), _path304$9 || (_path304$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 15H20V17H6z"
    })), children);
  });
  var ProgressBar16 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBar16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$9 || (_path305$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,21H4a2.0021,2.0021,0,0,1-2-2V13a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,21ZM4,13v6H28V13Z"
    })), _path306$9 || (_path306$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 15H20V17H6z"
    })), children);
  });
  var ProgressBarRound32 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBarRound32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$9 || (_path307$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path308$9 || (_path308$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26a10.0162,10.0162,0,0,1-7.4531-3.3325l1.49-1.334A8,8,0,1,0,16,8V6a10,10,0,0,1,0,20Z"
    })), _path309$9 || (_path309$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var ProgressBarRound24 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBarRound24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$9 || (_path310$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path311$9 || (_path311$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26a10.0162,10.0162,0,0,1-7.4531-3.3325l1.49-1.334A8,8,0,1,0,16,8V6a10,10,0,0,1,0,20Z"
    })), _path312$9 || (_path312$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var ProgressBarRound20 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBarRound20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$9 || (_path313$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path314$9 || (_path314$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26a10.0162,10.0162,0,0,1-7.4531-3.3325l1.49-1.334A8,8,0,1,0,16,8V6a10,10,0,0,1,0,20Z"
    })), _path315$9 || (_path315$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var ProgressBarRound16 = /*#__PURE__*/React__default['default'].forwardRef(function ProgressBarRound16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$9 || (_path316$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A6.0067,6.0067,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"
    })), _path317$9 || (_path317$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26a10.0162,10.0162,0,0,1-7.4531-3.3325l1.49-1.334A8,8,0,1,0,16,8V6a10,10,0,0,1,0,20Z"
    })), _path318$9 || (_path318$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var Purchase32 = /*#__PURE__*/React__default['default'].forwardRef(function Purchase32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$9 || (_path319$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"
    })), _path320$9 || (_path320$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 20H16V22H6z"
    })), children);
  });
  var Purchase24 = /*#__PURE__*/React__default['default'].forwardRef(function Purchase24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$9 || (_path321$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"
    })), _path322$9 || (_path322$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 20H16V22H6z"
    })), children);
  });
  var Purchase20 = /*#__PURE__*/React__default['default'].forwardRef(function Purchase20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$9 || (_path323$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"
    })), _path324$9 || (_path324$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 20H16V22H6z"
    })), children);
  });
  var Purchase16 = /*#__PURE__*/React__default['default'].forwardRef(function Purchase16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$9 || (_path325$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"
    })), _path326$9 || (_path326$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 20H16V22H6z"
    })), children);
  });
  var WatsonHealthQcLaunch32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthQcLaunch32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$9 || (_path327$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22H19a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h6v2H19V20h6zM13 8H9a2.002 2.002 0 00-2 2V20a2.0023 2.0023 0 002 2h1v2a2.0023 2.0023 0 002 2h2V24H12V22h1a2.0023 2.0023 0 002-2V10A2.002 2.002 0 0013 8zM9 20V10h4V20z"
    })), _path328$9 || (_path328$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var WatsonHealthQcLaunch24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthQcLaunch24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$9 || (_path329$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22H19a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h6v2H19V20h6zM13 8H9a2.002 2.002 0 00-2 2V20a2.0023 2.0023 0 002 2h1v2a2.0023 2.0023 0 002 2h2V24H12V22h1a2.0023 2.0023 0 002-2V10A2.002 2.002 0 0013 8zM9 20V10h4V20z"
    })), _path330$9 || (_path330$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var WatsonHealthQcLaunch20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthQcLaunch20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$9 || (_path331$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22H19a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h6v2H19V20h6zM13 8H9a2.002 2.002 0 00-2 2V20a2.0023 2.0023 0 002 2h1v2a2.0023 2.0023 0 002 2h2V24H12V22h1a2.0023 2.0023 0 002-2V10A2.002 2.002 0 0013 8zM9 20V10h4V20z"
    })), _path332$9 || (_path332$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var WatsonHealthQcLaunch16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthQcLaunch16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$9 || (_path333$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22H19a2.0023 2.0023 0 01-2-2V10a2.002 2.002 0 012-2h6v2H19V20h6zM13 8H9a2.002 2.002 0 00-2 2V20a2.0023 2.0023 0 002 2h1v2a2.0023 2.0023 0 002 2h2V24H12V22h1a2.0023 2.0023 0 002-2V10A2.002 2.002 0 0013 8zM9 20V10h4V20z"
    })), _path334$9 || (_path334$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,4,2H28a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var QqPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function QqPlot32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$9 || (_circle$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "4",
      r: "2"
    })), _circle2$9 || (_circle2$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle3$9 || (_circle3$9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle4$8 || (_circle4$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "2"
    })), _circle5$7 || (_circle5$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), _path335$9 || (_path335$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4131,28.5859,2,4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4131Z"
    })), children);
  });
  var QqPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function QqPlot24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$7 || (_circle6$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "4",
      r: "2"
    })), _circle7$7 || (_circle7$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle8$7 || (_circle8$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle9$7 || (_circle9$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "2"
    })), _circle10$7 || (_circle10$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), _path336$9 || (_path336$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4131,28.5859,2,4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4131Z"
    })), children);
  });
  var QqPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function QqPlot20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$6 || (_circle11$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "4",
      r: "2"
    })), _circle12$6 || (_circle12$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle13$6 || (_circle13$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle14$6 || (_circle14$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "2"
    })), _circle15$6 || (_circle15$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), _path337$9 || (_path337$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4131,28.5859,2,4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4131Z"
    })), children);
  });
  var QqPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function QqPlot16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$6 || (_circle16$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "20",
      cy: "4",
      r: "2"
    })), _circle17$5 || (_circle17$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "8",
      cy: "16",
      r: "2"
    })), _circle18$5 || (_circle18$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "12",
      r: "2"
    })), _circle19$5 || (_circle19$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "7",
      r: "2"
    })), _circle20$5 || (_circle20$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "24",
      r: "2"
    })), _path338$9 || (_path338$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4131,28.5859,2,4,26.585V2H2V28a2,2,0,0,0,2,2H30V28H5.4131Z"
    })), children);
  });
  var QrCode32 = /*#__PURE__*/React__default['default'].forwardRef(function QrCode32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$9 || (_path339$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H26V28H24z",
      transform: "rotate(-90 25 27)"
    })), _path340$9 || (_path340$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22H20V24H18z",
      transform: "rotate(-90 19 23)"
    })), _path341$9 || (_path341$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"
    })), _path342$9 || (_path342$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H29V25H25z",
      transform: "rotate(-90 27 24)"
    })), _path343$9 || (_path343$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"
    })), _path344$9 || (_path344$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H21V21H19z",
      transform: "rotate(-90 20 19)"
    })), _path345$9 || (_path345$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22H10V26H6z"
    })), _path346$9 || (_path346$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"
    })), _path347$9 || (_path347$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"
    })), _path348$9 || (_path348$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,14H2V2H14ZM4,12h8V4H4Z"
    })), children);
  });
  var QrCode24 = /*#__PURE__*/React__default['default'].forwardRef(function QrCode24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$9 || (_path349$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H26V28H24z",
      transform: "rotate(-90 25 27)"
    })), _path350$9 || (_path350$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22H20V24H18z",
      transform: "rotate(-90 19 23)"
    })), _path351$9 || (_path351$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"
    })), _path352$9 || (_path352$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H29V25H25z",
      transform: "rotate(-90 27 24)"
    })), _path353$9 || (_path353$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"
    })), _path354$9 || (_path354$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H21V21H19z",
      transform: "rotate(-90 20 19)"
    })), _path355$8 || (_path355$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22H10V26H6z"
    })), _path356$8 || (_path356$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"
    })), _path357$8 || (_path357$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"
    })), _path358$8 || (_path358$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,14H2V2H14ZM4,12h8V4H4Z"
    })), children);
  });
  var QrCode20 = /*#__PURE__*/React__default['default'].forwardRef(function QrCode20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$8 || (_path359$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H26V28H24z",
      transform: "rotate(-90 25 27)"
    })), _path360$8 || (_path360$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22H20V24H18z",
      transform: "rotate(-90 19 23)"
    })), _path361$8 || (_path361$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"
    })), _path362$8 || (_path362$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H29V25H25z",
      transform: "rotate(-90 27 24)"
    })), _path363$8 || (_path363$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"
    })), _path364$8 || (_path364$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H21V21H19z",
      transform: "rotate(-90 20 19)"
    })), _path365$8 || (_path365$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22H10V26H6z"
    })), _path366$8 || (_path366$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"
    })), _path367$8 || (_path367$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"
    })), _path368$8 || (_path368$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,14H2V2H14ZM4,12h8V4H4Z"
    })), children);
  });
  var QrCode16 = /*#__PURE__*/React__default['default'].forwardRef(function QrCode16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$8 || (_path369$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 26H26V28H24z",
      transform: "rotate(-90 25 27)"
    })), _path370$8 || (_path370$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22H20V24H18z",
      transform: "rotate(-90 19 23)"
    })), _path371$8 || (_path371$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"
    })), _path372$8 || (_path372$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23H29V25H25z",
      transform: "rotate(-90 27 24)"
    })), _path373$8 || (_path373$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"
    })), _path374$8 || (_path374$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 17H21V21H19z",
      transform: "rotate(-90 20 19)"
    })), _path375$8 || (_path375$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 22H10V26H6z"
    })), _path376$8 || (_path376$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"
    })), _path377$8 || (_path377$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"
    })), _path378$8 || (_path378$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,14H2V2H14ZM4,12h8V4H4Z"
    })), children);
  });
  var QuadrantPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function QuadrantPlot32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$8 || (_path379$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path380$8 || (_path380$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 30a3 3 0 113-3A3.0033 3.0033 0 015 30zm0-4a1 1 0 101 1A1.001 1.001 0 005 26zM8 8a3 3 0 113-3A3.0033 3.0033 0 018 8zM8 4A1 1 0 109 5 1.001 1.001 0 008 4zM22 13a3 3 0 113-3A3.0033 3.0033 0 0122 13zm0-4a1 1 0 101 1A1.001 1.001 0 0022 9z"
    })), _circle21$5 || (_circle21$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "2"
    })), _circle22$5 || (_circle22$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "21",
      r: "2"
    })), _circle23$5 || (_circle23$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle24$5 || (_circle24$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "28",
      r: "2"
    })), _circle25$4 || (_circle25$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "24",
      r: "2"
    })), _circle26$4 || (_circle26$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "11",
      r: "2"
    })), _circle27$4 || (_circle27$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), children);
  });
  var QuadrantPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function QuadrantPlot24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$8 || (_path381$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path382$8 || (_path382$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 30a3 3 0 113-3A3.0033 3.0033 0 015 30zm0-4a1 1 0 101 1A1.001 1.001 0 005 26zM8 8a3 3 0 113-3A3.0033 3.0033 0 018 8zM8 4A1 1 0 109 5 1.001 1.001 0 008 4zM22 13a3 3 0 113-3A3.0033 3.0033 0 0122 13zm0-4a1 1 0 101 1A1.001 1.001 0 0022 9z"
    })), _circle28$4 || (_circle28$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "2"
    })), _circle29$4 || (_circle29$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "21",
      r: "2"
    })), _circle30$4 || (_circle30$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle31$4 || (_circle31$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "28",
      r: "2"
    })), _circle32$4 || (_circle32$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "24",
      r: "2"
    })), _circle33$4 || (_circle33$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "11",
      r: "2"
    })), _circle34$3 || (_circle34$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), children);
  });
  var QuadrantPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function QuadrantPlot20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$8 || (_path383$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path384$7 || (_path384$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 30a3 3 0 113-3A3.0033 3.0033 0 015 30zm0-4a1 1 0 101 1A1.001 1.001 0 005 26zM8 8a3 3 0 113-3A3.0033 3.0033 0 018 8zM8 4A1 1 0 109 5 1.001 1.001 0 008 4zM22 13a3 3 0 113-3A3.0033 3.0033 0 0122 13zm0-4a1 1 0 101 1A1.001 1.001 0 0022 9z"
    })), _circle35$3 || (_circle35$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "2"
    })), _circle36$3 || (_circle36$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "21",
      r: "2"
    })), _circle37$2 || (_circle37$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle38$2 || (_circle38$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "28",
      r: "2"
    })), _circle39$2 || (_circle39$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "24",
      r: "2"
    })), _circle40$2 || (_circle40$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "11",
      r: "2"
    })), _circle41$2 || (_circle41$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), children);
  });
  var QuadrantPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function QuadrantPlot16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$7 || (_path385$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path386$7 || (_path386$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 30a3 3 0 113-3A3.0033 3.0033 0 015 30zm0-4a1 1 0 101 1A1.001 1.001 0 005 26zM8 8a3 3 0 113-3A3.0033 3.0033 0 018 8zM8 4A1 1 0 109 5 1.001 1.001 0 008 4zM22 13a3 3 0 113-3A3.0033 3.0033 0 0122 13zm0-4a1 1 0 101 1A1.001 1.001 0 0022 9z"
    })), _circle42$2 || (_circle42$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "11",
      r: "2"
    })), _circle43$2 || (_circle43$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "21",
      r: "2"
    })), _circle44$2 || (_circle44$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21",
      cy: "21",
      r: "2"
    })), _circle45$2 || (_circle45$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "28",
      r: "2"
    })), _circle46$2 || (_circle46$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "24",
      r: "2"
    })), _circle47$2 || (_circle47$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "4",
      cy: "11",
      r: "2"
    })), _circle48$2 || (_circle48$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "28",
      cy: "4",
      r: "2"
    })), children);
  });
  var Query32 = /*#__PURE__*/React__default['default'].forwardRef(function Query32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle49$2 || (_circle49$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "15.5",
      r: "1.5"
    })), _path387$7 || (_path387$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,12H10V8h2a2,2,0,0,0,0-4H10A2.0023,2.0023,0,0,0,8,6v.5H6V6a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path388$7 || (_path388$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4479,21.0337A10.971,10.971,0,0,0,19.9211,4.7446l-.999,1.73A8.9967,8.9967,0,1,1,5,14H3a10.9916,10.9916,0,0,0,18.0338,8.4478L28.5859,30,30,28.5859Z"
    })), children);
  });
  var Query24 = /*#__PURE__*/React__default['default'].forwardRef(function Query24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle50$2 || (_circle50$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "15.5",
      r: "1.5"
    })), _path389$7 || (_path389$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,12H10V8h2a2,2,0,0,0,0-4H10A2.0023,2.0023,0,0,0,8,6v.5H6V6a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path390$7 || (_path390$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4479,21.0337A10.971,10.971,0,0,0,19.9211,4.7446l-.999,1.73A8.9967,8.9967,0,1,1,5,14H3a10.9916,10.9916,0,0,0,18.0338,8.4478L28.5859,30,30,28.5859Z"
    })), children);
  });
  var Query20 = /*#__PURE__*/React__default['default'].forwardRef(function Query20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle51$2 || (_circle51$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "15.5",
      r: "1.5"
    })), _path391$7 || (_path391$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,12H10V8h2a2,2,0,0,0,0-4H10A2.0023,2.0023,0,0,0,8,6v.5H6V6a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path392$7 || (_path392$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4479,21.0337A10.971,10.971,0,0,0,19.9211,4.7446l-.999,1.73A8.9967,8.9967,0,1,1,5,14H3a10.9916,10.9916,0,0,0,18.0338,8.4478L28.5859,30,30,28.5859Z"
    })), children);
  });
  var Query16 = /*#__PURE__*/React__default['default'].forwardRef(function Query16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle52$2 || (_circle52$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "15.5",
      r: "1.5"
    })), _path393$7 || (_path393$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,12H10V8h2a2,2,0,0,0,0-4H10A2.0023,2.0023,0,0,0,8,6v.5H6V6a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path394$7 || (_path394$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4479,21.0337A10.971,10.971,0,0,0,19.9211,4.7446l-.999,1.73A8.9967,8.9967,0,1,1,5,14H3a10.9916,10.9916,0,0,0,18.0338,8.4478L28.5859,30,30,28.5859Z"
    })), children);
  });
  var QueryQueue32 = /*#__PURE__*/React__default['default'].forwardRef(function QueryQueue32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$7 || (_path395$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"
    })), children);
  });
  var QueryQueue24 = /*#__PURE__*/React__default['default'].forwardRef(function QueryQueue24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$7 || (_path396$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"
    })), children);
  });
  var QueryQueue20 = /*#__PURE__*/React__default['default'].forwardRef(function QueryQueue20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$7 || (_path397$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"
    })), children);
  });
  var QueryQueue16 = /*#__PURE__*/React__default['default'].forwardRef(function QueryQueue16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$7 || (_path398$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"
    })), children);
  });
  var Queued32 = /*#__PURE__*/React__default['default'].forwardRef(function Queued32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$6 || (_path399$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 20H30V22H22zM22 24H30V26H22zM22 28H30V30H22zM18 24H20V26H18zM18 20H20V22H18zM18 28H20V30H18zM6.8149 8.293A12.0777 12.0777 0 0110.0068 5.62L9.0079 3.89A14.0845 14.0845 0 005.2841 7.0083zM25.1851 8.293l1.5308-1.2847A14.0845 14.0845 0 0022.9921 3.89l-.9989 1.73A12.0777 12.0777 0 0125.1851 8.293zM4.7366 11.9l-1.8772-.6831A13.9019 13.9019 0 002 16H4A11.917 11.917 0 014.7366 11.9zM6.8149 23.707A11.9975 11.9975 0 014.7366 20.1l-1.8772.6831a13.99 13.99 0 002.4247 4.209zM27.2634 11.9A11.917 11.917 0 0128 16h2a13.8971 13.8971 0 00-.8594-4.7827zM13.9182 27.8066A11.8894 11.8894 0 0110.0068 26.38l-.9989 1.73a13.8673 13.8673 0 004.5633 1.664zM13.9182 4.1934a11.3012 11.3012 0 014.1636 0l.347-1.9678a13.187 13.187 0 00-4.8576 0z"
    })), children);
  });
  var Queued24 = /*#__PURE__*/React__default['default'].forwardRef(function Queued24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$6 || (_path400$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 20H30V22H22zM22 24H30V26H22zM22 28H30V30H22zM18 24H20V26H18zM18 20H20V22H18zM18 28H20V30H18zM6.8149 8.293A12.0777 12.0777 0 0110.0068 5.62L9.0079 3.89A14.0845 14.0845 0 005.2841 7.0083zM25.1851 8.293l1.5308-1.2847A14.0845 14.0845 0 0022.9921 3.89l-.9989 1.73A12.0777 12.0777 0 0125.1851 8.293zM4.7366 11.9l-1.8772-.6831A13.9019 13.9019 0 002 16H4A11.917 11.917 0 014.7366 11.9zM6.8149 23.707A11.9975 11.9975 0 014.7366 20.1l-1.8772.6831a13.99 13.99 0 002.4247 4.209zM27.2634 11.9A11.917 11.917 0 0128 16h2a13.8971 13.8971 0 00-.8594-4.7827zM13.9182 27.8066A11.8894 11.8894 0 0110.0068 26.38l-.9989 1.73a13.8673 13.8673 0 004.5633 1.664zM13.9182 4.1934a11.3012 11.3012 0 014.1636 0l.347-1.9678a13.187 13.187 0 00-4.8576 0z"
    })), children);
  });
  var Queued20 = /*#__PURE__*/React__default['default'].forwardRef(function Queued20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$6 || (_path401$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 20H30V22H22zM22 24H30V26H22zM22 28H30V30H22zM18 24H20V26H18zM18 20H20V22H18zM18 28H20V30H18zM6.8149 8.293A12.0777 12.0777 0 0110.0068 5.62L9.0079 3.89A14.0845 14.0845 0 005.2841 7.0083zM25.1851 8.293l1.5308-1.2847A14.0845 14.0845 0 0022.9921 3.89l-.9989 1.73A12.0777 12.0777 0 0125.1851 8.293zM4.7366 11.9l-1.8772-.6831A13.9019 13.9019 0 002 16H4A11.917 11.917 0 014.7366 11.9zM6.8149 23.707A11.9975 11.9975 0 014.7366 20.1l-1.8772.6831a13.99 13.99 0 002.4247 4.209zM27.2634 11.9A11.917 11.917 0 0128 16h2a13.8971 13.8971 0 00-.8594-4.7827zM13.9182 27.8066A11.8894 11.8894 0 0110.0068 26.38l-.9989 1.73a13.8673 13.8673 0 004.5633 1.664zM13.9182 4.1934a11.3012 11.3012 0 014.1636 0l.347-1.9678a13.187 13.187 0 00-4.8576 0z"
    })), children);
  });
  var Queued16 = /*#__PURE__*/React__default['default'].forwardRef(function Queued16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$6 || (_path402$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 20H30V22H22zM22 24H30V26H22zM22 28H30V30H22zM18 24H20V26H18zM18 20H20V22H18zM18 28H20V30H18zM6.8149 8.293A12.0777 12.0777 0 0110.0068 5.62L9.0079 3.89A14.0845 14.0845 0 005.2841 7.0083zM25.1851 8.293l1.5308-1.2847A14.0845 14.0845 0 0022.9921 3.89l-.9989 1.73A12.0777 12.0777 0 0125.1851 8.293zM4.7366 11.9l-1.8772-.6831A13.9019 13.9019 0 002 16H4A11.917 11.917 0 014.7366 11.9zM6.8149 23.707A11.9975 11.9975 0 014.7366 20.1l-1.8772.6831a13.99 13.99 0 002.4247 4.209zM27.2634 11.9A11.917 11.917 0 0128 16h2a13.8971 13.8971 0 00-.8594-4.7827zM13.9182 27.8066A11.8894 11.8894 0 0110.0068 26.38l-.9989 1.73a13.8673 13.8673 0 004.5633 1.664zM13.9182 4.1934a11.3012 11.3012 0 014.1636 0l.347-1.9678a13.187 13.187 0 00-4.8576 0z"
    })), children);
  });
  var Quotes32 = /*#__PURE__*/React__default['default'].forwardRef(function Quotes32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$5 || (_path403$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H6.11A9 9 0 0110 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 004 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0012 15zM26 15H20.11A9 9 0 0124 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0018 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0026 15z"
    })), children);
  });
  var Quotes24 = /*#__PURE__*/React__default['default'].forwardRef(function Quotes24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$5 || (_path404$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H6.11A9 9 0 0110 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 004 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0012 15zM26 15H20.11A9 9 0 0124 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0018 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0026 15z"
    })), children);
  });
  var Quotes20 = /*#__PURE__*/React__default['default'].forwardRef(function Quotes20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$5 || (_path405$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H6.11A9 9 0 0110 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 004 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0012 15zM26 15H20.11A9 9 0 0124 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0018 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0026 15z"
    })), children);
  });
  var Quotes16 = /*#__PURE__*/React__default['default'].forwardRef(function Quotes16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$5 || (_path406$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H6.11A9 9 0 0110 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 004 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0012 15zM26 15H20.11A9 9 0 0124 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0018 16.35V23a2 2 0 002 2h6a2 2 0 002-2V17A2 2 0 0026 15z"
    })), children);
  });
  var Radar32 = /*#__PURE__*/React__default['default'].forwardRef(function Radar32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$5 || (_path407$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,15.293,15.293a1,1,0,0,0,1.414,1.414l4.18-4.1792A5.9956,5.9956,0,1,1,16,10V8a8.011,8.011,0,1,0,6.3164,3.0977L25.1631,8.251A11.881,11.881,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a13.8572,13.8572,0,0,0-3.4224-9.1636Z"
    })), children);
  });
  var Radar24 = /*#__PURE__*/React__default['default'].forwardRef(function Radar24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$5 || (_path408$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,15.293,15.293a1,1,0,0,0,1.414,1.414l4.18-4.1792A5.9956,5.9956,0,1,1,16,10V8a8.011,8.011,0,1,0,6.3164,3.0977L25.1631,8.251A11.881,11.881,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a13.8572,13.8572,0,0,0-3.4224-9.1636Z"
    })), children);
  });
  var Radar20 = /*#__PURE__*/React__default['default'].forwardRef(function Radar20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$5 || (_path409$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,15.293,15.293a1,1,0,0,0,1.414,1.414l4.18-4.1792A5.9956,5.9956,0,1,1,16,10V8a8.011,8.011,0,1,0,6.3164,3.0977L25.1631,8.251A11.881,11.881,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a13.8572,13.8572,0,0,0-3.4224-9.1636Z"
    })), children);
  });
  var Radar16 = /*#__PURE__*/React__default['default'].forwardRef(function Radar16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$5 || (_path410$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4141,28.5859,2,15.293,15.293a1,1,0,0,0,1.414,1.414l4.18-4.1792A5.9956,5.9956,0,1,1,16,10V8a8.011,8.011,0,1,0,6.3164,3.0977L25.1631,8.251A11.881,11.881,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a13.8572,13.8572,0,0,0-3.4224-9.1636Z"
    })), children);
  });
  var RadarEnhanced32 = /*#__PURE__*/React__default['default'].forwardRef(function RadarEnhanced32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$5 || (_path411$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541A4.9817,4.9817,0,0,1,18,19a5.0385,5.0385,0,0,1-.6074-.05,8.0432,8.0432,0,0,0-4.3421-4.3423A4.9,4.9,0,0,1,18,9V7a7.0078,7.0078,0,0,0-7,7c0,.0234.0056.0469.0059.07A8.0469,8.0469,0,0,0,10,14a7.95,7.95,0,0,0-1.9883.26C8.0095,14.1729,8,14.0879,8,14A10.0114,10.0114,0,0,1,18,4V2A12.0137,12.0137,0,0,0,6,14c0,.355.0171.7061.0471,1.0537A7.9943,7.9943,0,1,0,16.9465,25.9521c.35.03.7019.0479,1.0535.0479A11.9853,11.9853,0,0,0,27.1538,6.2607ZM15.91,21H13.9563a12.029,12.029,0,0,0-1.218-4.332A6.01,6.01,0,0,1,15.91,21ZM4.09,23H6.0435a12.0318,12.0318,0,0,0,1.2182,4.3325A6.01,6.01,0,0,1,4.09,23Zm1.9532-2H4.09a6.01,6.01,0,0,1,3.1714-4.332A12.0321,12.0321,0,0,0,6.0435,21ZM10,27.9858A10.0149,10.0149,0,0,1,8.0552,23h3.89A10.0149,10.0149,0,0,1,10,27.9858ZM8.0552,21A10.0118,10.0118,0,0,1,10,16.0151,10.01,10.01,0,0,1,11.9448,21Zm4.6831,6.3325A12.0318,12.0318,0,0,0,13.9565,23H15.91A6.01,6.01,0,0,1,12.7383,27.3325ZM28,14A10.0114,10.0114,0,0,1,18,24c-.0869,0-.1733-.01-.26-.0117a7.5527,7.5527,0,0,0,.19-2.9942c.0237,0,.0466.0059.07.0059A6.9991,6.9991,0,0,0,23.6055,9.8086l2.1313-2.1314A9.95,9.95,0,0,1,28,14Z"
    })), children);
  });
  var RadarEnhanced24 = /*#__PURE__*/React__default['default'].forwardRef(function RadarEnhanced24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$5 || (_path412$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541A4.9817,4.9817,0,0,1,18,19a5.0385,5.0385,0,0,1-.6074-.05,8.0432,8.0432,0,0,0-4.3421-4.3423A4.9,4.9,0,0,1,18,9V7a7.0078,7.0078,0,0,0-7,7c0,.0234.0056.0469.0059.07A8.0469,8.0469,0,0,0,10,14a7.95,7.95,0,0,0-1.9883.26C8.0095,14.1729,8,14.0879,8,14A10.0114,10.0114,0,0,1,18,4V2A12.0137,12.0137,0,0,0,6,14c0,.355.0171.7061.0471,1.0537A7.9943,7.9943,0,1,0,16.9465,25.9521c.35.03.7019.0479,1.0535.0479A11.9853,11.9853,0,0,0,27.1538,6.2607ZM15.91,21H13.9563a12.029,12.029,0,0,0-1.218-4.332A6.01,6.01,0,0,1,15.91,21ZM4.09,23H6.0435a12.0318,12.0318,0,0,0,1.2182,4.3325A6.01,6.01,0,0,1,4.09,23Zm1.9532-2H4.09a6.01,6.01,0,0,1,3.1714-4.332A12.0321,12.0321,0,0,0,6.0435,21ZM10,27.9858A10.0149,10.0149,0,0,1,8.0552,23h3.89A10.0149,10.0149,0,0,1,10,27.9858ZM8.0552,21A10.0118,10.0118,0,0,1,10,16.0151,10.01,10.01,0,0,1,11.9448,21Zm4.6831,6.3325A12.0318,12.0318,0,0,0,13.9565,23H15.91A6.01,6.01,0,0,1,12.7383,27.3325ZM28,14A10.0114,10.0114,0,0,1,18,24c-.0869,0-.1733-.01-.26-.0117a7.5527,7.5527,0,0,0,.19-2.9942c.0237,0,.0466.0059.07.0059A6.9991,6.9991,0,0,0,23.6055,9.8086l2.1313-2.1314A9.95,9.95,0,0,1,28,14Z"
    })), children);
  });
  var RadarEnhanced20 = /*#__PURE__*/React__default['default'].forwardRef(function RadarEnhanced20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$5 || (_path413$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541A4.9817,4.9817,0,0,1,18,19a5.0385,5.0385,0,0,1-.6074-.05,8.0432,8.0432,0,0,0-4.3421-4.3423A4.9,4.9,0,0,1,18,9V7a7.0078,7.0078,0,0,0-7,7c0,.0234.0056.0469.0059.07A8.0469,8.0469,0,0,0,10,14a7.95,7.95,0,0,0-1.9883.26C8.0095,14.1729,8,14.0879,8,14A10.0114,10.0114,0,0,1,18,4V2A12.0137,12.0137,0,0,0,6,14c0,.355.0171.7061.0471,1.0537A7.9943,7.9943,0,1,0,16.9465,25.9521c.35.03.7019.0479,1.0535.0479A11.9853,11.9853,0,0,0,27.1538,6.2607ZM15.91,21H13.9563a12.029,12.029,0,0,0-1.218-4.332A6.01,6.01,0,0,1,15.91,21ZM4.09,23H6.0435a12.0318,12.0318,0,0,0,1.2182,4.3325A6.01,6.01,0,0,1,4.09,23Zm1.9532-2H4.09a6.01,6.01,0,0,1,3.1714-4.332A12.0321,12.0321,0,0,0,6.0435,21ZM10,27.9858A10.0149,10.0149,0,0,1,8.0552,23h3.89A10.0149,10.0149,0,0,1,10,27.9858ZM8.0552,21A10.0118,10.0118,0,0,1,10,16.0151,10.01,10.01,0,0,1,11.9448,21Zm4.6831,6.3325A12.0318,12.0318,0,0,0,13.9565,23H15.91A6.01,6.01,0,0,1,12.7383,27.3325ZM28,14A10.0114,10.0114,0,0,1,18,24c-.0869,0-.1733-.01-.26-.0117a7.5527,7.5527,0,0,0,.19-2.9942c.0237,0,.0466.0059.07.0059A6.9991,6.9991,0,0,0,23.6055,9.8086l2.1313-2.1314A9.95,9.95,0,0,1,28,14Z"
    })), children);
  });
  var RadarEnhanced16 = /*#__PURE__*/React__default['default'].forwardRef(function RadarEnhanced16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$5 || (_path414$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541A4.9817,4.9817,0,0,1,18,19a5.0385,5.0385,0,0,1-.6074-.05,8.0432,8.0432,0,0,0-4.3421-4.3423A4.9,4.9,0,0,1,18,9V7a7.0078,7.0078,0,0,0-7,7c0,.0234.0056.0469.0059.07A8.0469,8.0469,0,0,0,10,14a7.95,7.95,0,0,0-1.9883.26C8.0095,14.1729,8,14.0879,8,14A10.0114,10.0114,0,0,1,18,4V2A12.0137,12.0137,0,0,0,6,14c0,.355.0171.7061.0471,1.0537A7.9943,7.9943,0,1,0,16.9465,25.9521c.35.03.7019.0479,1.0535.0479A11.9853,11.9853,0,0,0,27.1538,6.2607ZM15.91,21H13.9563a12.029,12.029,0,0,0-1.218-4.332A6.01,6.01,0,0,1,15.91,21ZM4.09,23H6.0435a12.0318,12.0318,0,0,0,1.2182,4.3325A6.01,6.01,0,0,1,4.09,23Zm1.9532-2H4.09a6.01,6.01,0,0,1,3.1714-4.332A12.0321,12.0321,0,0,0,6.0435,21ZM10,27.9858A10.0149,10.0149,0,0,1,8.0552,23h3.89A10.0149,10.0149,0,0,1,10,27.9858ZM8.0552,21A10.0118,10.0118,0,0,1,10,16.0151,10.01,10.01,0,0,1,11.9448,21Zm4.6831,6.3325A12.0318,12.0318,0,0,0,13.9565,23H15.91A6.01,6.01,0,0,1,12.7383,27.3325ZM28,14A10.0114,10.0114,0,0,1,18,24c-.0869,0-.1733-.01-.26-.0117a7.5527,7.5527,0,0,0,.19-2.9942c.0237,0,.0466.0059.07.0059A6.9991,6.9991,0,0,0,23.6055,9.8086l2.1313-2.1314A9.95,9.95,0,0,1,28,14Z"
    })), children);
  });
  var RadarWeather32 = /*#__PURE__*/React__default['default'].forwardRef(function RadarWeather32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$4 || (_path415$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541a4.9646,4.9646,0,0,1-3.8811,7.7193,7.0485,7.0485,0,0,0-5.1438-3.8731A4.9431,4.9431,0,0,1,18,9V7a6.9551,6.9551,0,0,0-6.9087,8.0791,6.93,6.93,0,0,0-2.8525,1.06A9.97,9.97,0,0,1,18,4V2A11.9756,11.9756,0,0,0,6.573,17.6357a6.9293,6.9293,0,0,0-1.3674,2.7061A4.9948,4.9948,0,0,0,7,30H17a4.9921,4.9921,0,0,0,4.9678-4.68A12.0391,12.0391,0,0,0,30,14a11.8678,11.8678,0,0,0-2.8389-7.7466ZM17,28H7a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878,0l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,17,28ZM28,14a10.0346,10.0346,0,0,1-6.3118,9.291,4.9577,4.9577,0,0,0-2.0207-2.5,6.9922,6.9922,0,0,0,3.938-10.9824l2.132-2.1318A9.8873,9.8873,0,0,1,28,14Z"
    })), children);
  });
  var RadarWeather24 = /*#__PURE__*/React__default['default'].forwardRef(function RadarWeather24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path416$3 || (_path416$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541a4.9646,4.9646,0,0,1-3.8811,7.7193,7.0485,7.0485,0,0,0-5.1438-3.8731A4.9431,4.9431,0,0,1,18,9V7a6.9551,6.9551,0,0,0-6.9087,8.0791,6.93,6.93,0,0,0-2.8525,1.06A9.97,9.97,0,0,1,18,4V2A11.9756,11.9756,0,0,0,6.573,17.6357a6.9293,6.9293,0,0,0-1.3674,2.7061A4.9948,4.9948,0,0,0,7,30H17a4.9921,4.9921,0,0,0,4.9678-4.68A12.0391,12.0391,0,0,0,30,14a11.8678,11.8678,0,0,0-2.8389-7.7466ZM17,28H7a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878,0l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,17,28ZM28,14a10.0346,10.0346,0,0,1-6.3118,9.291,4.9577,4.9577,0,0,0-2.0207-2.5,6.9922,6.9922,0,0,0,3.938-10.9824l2.132-2.1318A9.8873,9.8873,0,0,1,28,14Z"
    })), children);
  });
  var RadarWeather20 = /*#__PURE__*/React__default['default'].forwardRef(function RadarWeather20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$3 || (_path417$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541a4.9646,4.9646,0,0,1-3.8811,7.7193,7.0485,7.0485,0,0,0-5.1438-3.8731A4.9431,4.9431,0,0,1,18,9V7a6.9551,6.9551,0,0,0-6.9087,8.0791,6.93,6.93,0,0,0-2.8525,1.06A9.97,9.97,0,0,1,18,4V2A11.9756,11.9756,0,0,0,6.573,17.6357a6.9293,6.9293,0,0,0-1.3674,2.7061A4.9948,4.9948,0,0,0,7,30H17a4.9921,4.9921,0,0,0,4.9678-4.68A12.0391,12.0391,0,0,0,30,14a11.8678,11.8678,0,0,0-2.8389-7.7466ZM17,28H7a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878,0l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,17,28ZM28,14a10.0346,10.0346,0,0,1-6.3118,9.291,4.9577,4.9577,0,0,0-2.0207-2.5,6.9922,6.9922,0,0,0,3.938-10.9824l2.132-2.1318A9.8873,9.8873,0,0,1,28,14Z"
    })), children);
  });
  var RadarWeather16 = /*#__PURE__*/React__default['default'].forwardRef(function RadarWeather16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path418$3 || (_path418$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,3.4146,28.5854,2,17.2932,13.2925a1,1,0,1,0,1.4141,1.414l3.4543-3.4541a4.9646,4.9646,0,0,1-3.8811,7.7193,7.0485,7.0485,0,0,0-5.1438-3.8731A4.9431,4.9431,0,0,1,18,9V7a6.9551,6.9551,0,0,0-6.9087,8.0791,6.93,6.93,0,0,0-2.8525,1.06A9.97,9.97,0,0,1,18,4V2A11.9756,11.9756,0,0,0,6.573,17.6357a6.9293,6.9293,0,0,0-1.3674,2.7061A4.9948,4.9948,0,0,0,7,30H17a4.9921,4.9921,0,0,0,4.9678-4.68A12.0391,12.0391,0,0,0,30,14a11.8678,11.8678,0,0,0-2.8389-7.7466ZM17,28H7a2.9945,2.9945,0,0,1-.6963-5.9082l.6587-.1572.0986-.67a4.9923,4.9923,0,0,1,9.878,0l.0986.6695.6587.1572A2.9945,2.9945,0,0,1,17,28ZM28,14a10.0346,10.0346,0,0,1-6.3118,9.291,4.9577,4.9577,0,0,0-2.0207-2.5,6.9922,6.9922,0,0,0,3.938-10.9824l2.132-2.1318A9.8873,9.8873,0,0,1,28,14Z"
    })), children);
  });
  var Radio32 = /*#__PURE__*/React__default['default'].forwardRef(function Radio32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path419$3 || (_path419$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"
    })), _path420$3 || (_path420$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4 4 0 0110 26zm0-6a2 2 0 102 2A2 2 0 0010 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"
    })), children);
  });
  var Radio24 = /*#__PURE__*/React__default['default'].forwardRef(function Radio24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$3 || (_path421$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"
    })), _path422$3 || (_path422$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4 4 0 0110 26zm0-6a2 2 0 102 2A2 2 0 0010 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"
    })), children);
  });
  var Radio20 = /*#__PURE__*/React__default['default'].forwardRef(function Radio20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path423$3 || (_path423$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"
    })), _path424$3 || (_path424$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4 4 0 0110 26zm0-6a2 2 0 102 2A2 2 0 0010 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"
    })), children);
  });
  var Radio16 = /*#__PURE__*/React__default['default'].forwardRef(function Radio16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path425$2 || (_path425$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"
    })), _path426$2 || (_path426$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4 4 0 0110 26zm0-6a2 2 0 102 2A2 2 0 0010 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"
    })), children);
  });
  var RadioCombat32 = /*#__PURE__*/React__default['default'].forwardRef(function RadioCombat32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path427$2 || (_path427$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4.0045 4.0045 0 0110 26zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 20zM17 20H26V22H17zM17 24H26V26H17z"
    })), _path428$2 || (_path428$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12h8a2.0023,2.0023,0,0,0,2-2V6a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2V7H12a4.0045,4.0045,0,0,0-4,4v3H6V4H4V14a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V16a2.0023,2.0023,0,0,0-2-2H10V11a2.0023,2.0023,0,0,1,2-2h6v1A2.0023,2.0023,0,0,0,20,12Zm4-6h4v4H24ZM20,6h2v4H20Zm8,22H4V16H28Z"
    })), children);
  });
  var RadioCombat24 = /*#__PURE__*/React__default['default'].forwardRef(function RadioCombat24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path429$2 || (_path429$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4.0045 4.0045 0 0110 26zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 20zM17 20H26V22H17zM17 24H26V26H17z"
    })), _path430$2 || (_path430$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12h8a2.0023,2.0023,0,0,0,2-2V6a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2V7H12a4.0045,4.0045,0,0,0-4,4v3H6V4H4V14a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V16a2.0023,2.0023,0,0,0-2-2H10V11a2.0023,2.0023,0,0,1,2-2h6v1A2.0023,2.0023,0,0,0,20,12Zm4-6h4v4H24ZM20,6h2v4H20Zm8,22H4V16H28Z"
    })), children);
  });
  var RadioCombat20 = /*#__PURE__*/React__default['default'].forwardRef(function RadioCombat20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path431$2 || (_path431$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4.0045 4.0045 0 0110 26zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 20zM17 20H26V22H17zM17 24H26V26H17z"
    })), _path432$2 || (_path432$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12h8a2.0023,2.0023,0,0,0,2-2V6a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2V7H12a4.0045,4.0045,0,0,0-4,4v3H6V4H4V14a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V16a2.0023,2.0023,0,0,0-2-2H10V11a2.0023,2.0023,0,0,1,2-2h6v1A2.0023,2.0023,0,0,0,20,12Zm4-6h4v4H24ZM20,6h2v4H20Zm8,22H4V16H28Z"
    })), children);
  });
  var RadioCombat16 = /*#__PURE__*/React__default['default'].forwardRef(function RadioCombat16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path433$2 || (_path433$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 26a4 4 0 114-4A4.0045 4.0045 0 0110 26zm0-6a2 2 0 102 2A2.0021 2.0021 0 0010 20zM17 20H26V22H17zM17 24H26V26H17z"
    })), _path434$2 || (_path434$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12h8a2.0023,2.0023,0,0,0,2-2V6a2.0023,2.0023,0,0,0-2-2H20a2.0023,2.0023,0,0,0-2,2V7H12a4.0045,4.0045,0,0,0-4,4v3H6V4H4V14a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V16a2.0023,2.0023,0,0,0-2-2H10V11a2.0023,2.0023,0,0,1,2-2h6v1A2.0023,2.0023,0,0,0,20,12Zm4-6h4v4H24ZM20,6h2v4H20Zm8,22H4V16H28Z"
    })), children);
  });
  var RadioPushToTalk32 = /*#__PURE__*/React__default['default'].forwardRef(function RadioPushToTalk32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path435$2 || (_path435$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H19V13H13zM13 15H19V17H13z"
    })), _circle53$2 || (_circle53$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23",
      r: "2"
    })), _path436$2 || (_path436$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,7H21V2H19V7H10A2.0023,2.0023,0,0,0,8,9v2H6v2H8v2H6v2H8V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,22,7ZM10,28V9H22V28Z"
    })), children);
  });
  var RadioPushToTalk24 = /*#__PURE__*/React__default['default'].forwardRef(function RadioPushToTalk24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path437$2 || (_path437$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H19V13H13zM13 15H19V17H13z"
    })), _circle54$2 || (_circle54$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23",
      r: "2"
    })), _path438$2 || (_path438$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,7H21V2H19V7H10A2.0023,2.0023,0,0,0,8,9v2H6v2H8v2H6v2H8V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,22,7ZM10,28V9H22V28Z"
    })), children);
  });

  var _path$9, _circle$8, _path2$9, _path3$9, _circle2$8, _path4$9, _path5$9, _path6$9, _path7$9, _path8$9, _path9$9, _path10$9, _path11$9, _path12$9, _path13$9, _path14$9, _path15$9, _path16$9, _path17$9, _path18$9, _path19$9, _path20$9, _path21$9, _path22$9, _path23$9, _path24$9, _path25$9, _path26$9, _path27$9, _path28$9, _path29$9, _path30$9, _path31$9, _path32$9, _path33$9, _path34$9, _path35$9, _path36$9, _path37$9, _path38$9, _path39$9, _path40$9, _path41$9, _path42$9, _path43$9, _path44$9, _path45$9, _path46$9, _path47$9, _path48$9, _path49$9, _path50$9, _path51$9, _path52$9, _path53$9, _path54$9, _path55$9, _path56$9, _path57$9, _path58$9, _path59$9, _path60$9, _path61$9, _path62$9, _path63$9, _path64$9, _path65$9, _path66$9, _path67$9, _path68$9, _path69$9, _path70$9, _path71$9, _path72$9, _path73$9, _path74$9, _path75$9, _path76$9, _path77$9, _path78$9, _path79$9, _path80$9, _path81$9, _path82$9, _path83$9, _path84$9, _path85$9, _path86$9, _path87$9, _path88$9, _path89$9, _path90$9, _path91$9, _path92$9, _path93$9, _path94$9, _path95$9, _path96$9, _path97$9, _path98$9, _path99$9, _path100$9, _path101$9, _path102$9, _path103$9, _path104$9, _path105$9, _path106$9, _path107$9, _path108$9, _circle3$8, _path109$9, _circle4$7, _path110$9, _circle5$6, _path111$9, _circle6$6, _path112$9, _path113$9, _path114$9, _path115$9, _path116$9, _path117$9, _path118$9, _path119$9, _path120$9, _path121$9, _path122$9, _path123$9, _path124$9, _path125$9, _path126$9, _path127$9, _path128$9, _path129$9, _path130$9, _path131$9, _path132$9, _path133$9, _path134$9, _path135$9, _path136$9, _path137$9, _path138$9, _path139$9, _path140$9, _path141$9, _path142$9, _path143$9, _path144$9, _path145$9, _path146$9, _path147$9, _path148$9, _path149$9, _path150$9, _path151$9, _path152$9, _path153$9, _path154$9, _path155$9, _path156$9, _path157$9, _path158$9, _path159$9, _path160$9, _path161$9, _path162$9, _path163$9, _path164$9, _path165$9, _path166$9, _path167$9, _path168$9, _path169$9, _path170$9, _path171$9, _path172$9, _path173$9, _path174$9, _path175$9, _path176$9, _path177$8, _path178$8, _path179$8, _path180$8, _path181$8, _path182$8, _path183$8, _path184$8, _path185$8, _path186$8, _path187$8, _path188$8, _path189$8, _path190$8, _path191$8, _path192$8, _path193$8, _path194$8, _path195$8, _path196$8, _path197$8, _path198$8, _path199$8, _path200$8, _path201$8, _path202$8, _path203$8, _path204$8, _path205$8, _path206$8, _path207$8, _path208$8, _path209$8, _path210$8, _path211$8, _path212$8, _path213$8, _path214$8, _path215$8, _path216$8, _path217$8, _path218$8, _path219$8, _path220$8, _path221$8, _path222$8, _path223$8, _path224$8, _path225$8, _path226$8, _path227$8, _path228$8, _path229$8, _path230$8, _path231$8, _path232$8, _path233$8, _path234$8, _path235$8, _path236$8, _path237$8, _path238$8, _path239$8, _path240$8, _path241$8, _path242$8, _path243$8, _path244$8, _path245$8, _path246$8, _path247$8, _path248$8, _path249$8, _path250$8, _path251$8, _path252$8, _path253$8, _path254$8, _path255$8, _path256$8, _path257$8, _path258$8, _path259$8, _path260$8, _path261$8, _path262$8, _path263$8, _path264$8, _path265$8, _path266$8, _path267$8, _path268$8, _path269$8, _path270$8, _path271$8, _path272$8, _path273$8, _path274$8, _path275$8, _path276$8, _path277$8, _path278$8, _path279$8, _path280$8, _path281$8, _path282$8, _path283$8, _path284$8, _path285$8, _path286$8, _path287$8, _path288$8, _path289$8, _path290$8, _path291$8, _path292$8, _path293$8, _path294$8, _path295$8, _path296$8, _path297$8, _path298$8, _path299$8, _path300$8, _circle7$6, _path301$8, _path302$8, _circle8$6, _path303$8, _path304$8, _circle9$6, _path305$8, _path306$8, _circle10$6, _path307$8, _path308$8, _path309$8, _path310$8, _path311$8, _path312$8, _path313$8, _path314$8, _path315$8, _path316$8, _path317$8, _path318$8, _path319$8, _path320$8, _path321$8, _path322$8, _path323$8, _path324$8, _path325$8, _path326$8, _path327$8, _path328$8, _path329$8, _path330$8, _path331$8, _path332$8, _path333$8, _path334$8, _path335$8, _path336$8, _path337$8, _path338$8, _path339$8, _path340$8, _path341$8, _path342$8, _path343$8, _path344$8, _path345$8, _path346$8, _path347$8, _path348$8, _path349$8, _path350$8, _path351$8, _path352$8, _path353$8, _path354$8, _path355$7, _path356$7, _path357$7, _path358$7, _path359$7, _path360$7, _path361$7, _path362$7, _path363$7, _path364$7, _path365$7, _path366$7, _path367$7, _path368$7, _path369$7, _path370$7, _path371$7, _path372$7, _path373$7, _path374$7, _path375$7, _path376$7, _path377$7, _path378$7, _path379$7, _path380$7, _path381$7, _path382$7, _path383$7, _path384$6, _path385$6, _path386$6, _path387$6, _path388$6, _path389$6, _path390$6, _path391$6, _path392$6, _path393$6, _path394$6, _path395$6, _path396$6, _path397$6, _path398$6, _path399$5, _path400$5, _path401$5, _path402$5, _path403$4, _path404$4, _path405$4, _path406$4, _path407$4, _path408$4, _path409$4, _path410$4, _path411$4, _path412$4, _path413$4, _path414$4, _path415$3, _path416$2, _path417$2, _path418$2, _path419$2, _path420$2, _path421$2, _path422$2, _path423$2, _path424$2;

  var _excluded$9 = ["children"],
      _excluded2$9 = ["children"],
      _excluded3$9 = ["children"],
      _excluded4$9 = ["children"],
      _excluded5$9 = ["children"],
      _excluded6$9 = ["children"],
      _excluded7$9 = ["children"],
      _excluded8$9 = ["children"],
      _excluded9$9 = ["children"],
      _excluded10$9 = ["children"],
      _excluded11$9 = ["children"],
      _excluded12$9 = ["children"],
      _excluded13$9 = ["children"],
      _excluded14$9 = ["children"],
      _excluded15$9 = ["children"],
      _excluded16$9 = ["children"],
      _excluded17$9 = ["children"],
      _excluded18$9 = ["children"],
      _excluded19$9 = ["children"],
      _excluded20$9 = ["children"],
      _excluded21$9 = ["children"],
      _excluded22$9 = ["children"],
      _excluded23$9 = ["children"],
      _excluded24$9 = ["children"],
      _excluded25$9 = ["children"],
      _excluded26$9 = ["children"],
      _excluded27$9 = ["children"],
      _excluded28$9 = ["children"],
      _excluded29$9 = ["children"],
      _excluded30$9 = ["children"],
      _excluded31$9 = ["children"],
      _excluded32$9 = ["children"],
      _excluded33$9 = ["children"],
      _excluded34$9 = ["children"],
      _excluded35$9 = ["children"],
      _excluded36$9 = ["children"],
      _excluded37$9 = ["children"],
      _excluded38$9 = ["children"],
      _excluded39$9 = ["children"],
      _excluded40$9 = ["children"],
      _excluded41$9 = ["children"],
      _excluded42$9 = ["children"],
      _excluded43$9 = ["children"],
      _excluded44$9 = ["children"],
      _excluded45$9 = ["children"],
      _excluded46$9 = ["children"],
      _excluded47$9 = ["children"],
      _excluded48$9 = ["children"],
      _excluded49$9 = ["children"],
      _excluded50$9 = ["children"],
      _excluded51$9 = ["children"],
      _excluded52$9 = ["children"],
      _excluded53$9 = ["children"],
      _excluded54$9 = ["children"],
      _excluded55$9 = ["children"],
      _excluded56$9 = ["children"],
      _excluded57$9 = ["children"],
      _excluded58$9 = ["children"],
      _excluded59$9 = ["children"],
      _excluded60$9 = ["children"],
      _excluded61$9 = ["children"],
      _excluded62$9 = ["children"],
      _excluded63$9 = ["children"],
      _excluded64$9 = ["children"],
      _excluded65$9 = ["children"],
      _excluded66$9 = ["children"],
      _excluded67$9 = ["children"],
      _excluded68$9 = ["children"],
      _excluded69$9 = ["children"],
      _excluded70$9 = ["children"],
      _excluded71$9 = ["children"],
      _excluded72$9 = ["children"],
      _excluded73$9 = ["children"],
      _excluded74$9 = ["children"],
      _excluded75$9 = ["children"],
      _excluded76$9 = ["children"],
      _excluded77$9 = ["children"],
      _excluded78$9 = ["children"],
      _excluded79$9 = ["children"],
      _excluded80$9 = ["children"],
      _excluded81$9 = ["children"],
      _excluded82$9 = ["children"],
      _excluded83$9 = ["children"],
      _excluded84$9 = ["children"],
      _excluded85$9 = ["children"],
      _excluded86$9 = ["children"],
      _excluded87$9 = ["children"],
      _excluded88$9 = ["children"],
      _excluded89$9 = ["children"],
      _excluded90$9 = ["children"],
      _excluded91$9 = ["children"],
      _excluded92$9 = ["children"],
      _excluded93$9 = ["children"],
      _excluded94$9 = ["children"],
      _excluded95$9 = ["children"],
      _excluded96$9 = ["children"],
      _excluded97$9 = ["children"],
      _excluded98$9 = ["children"],
      _excluded99$9 = ["children"],
      _excluded100$9 = ["children"],
      _excluded101$9 = ["children"],
      _excluded102$9 = ["children"],
      _excluded103$9 = ["children"],
      _excluded104$9 = ["children"],
      _excluded105$9 = ["children"],
      _excluded106$9 = ["children"],
      _excluded107$9 = ["children"],
      _excluded108$9 = ["children"],
      _excluded109$9 = ["children"],
      _excluded110$9 = ["children"],
      _excluded111$9 = ["children"],
      _excluded112$9 = ["children"],
      _excluded113$9 = ["children"],
      _excluded114$9 = ["children"],
      _excluded115$9 = ["children"],
      _excluded116$9 = ["children"],
      _excluded117$9 = ["children"],
      _excluded118$9 = ["children"],
      _excluded119$8 = ["children"],
      _excluded120$8 = ["children"],
      _excluded121$8 = ["children"],
      _excluded122$8 = ["children"],
      _excluded123$8 = ["children"],
      _excluded124$8 = ["children"],
      _excluded125$8 = ["children"],
      _excluded126$8 = ["children"],
      _excluded127$8 = ["children"],
      _excluded128$8 = ["children"],
      _excluded129$8 = ["children"],
      _excluded130$8 = ["children"],
      _excluded131$8 = ["children"],
      _excluded132$8 = ["children"],
      _excluded133$8 = ["children"],
      _excluded134$8 = ["children"],
      _excluded135$8 = ["children"],
      _excluded136$8 = ["children"],
      _excluded137$8 = ["children"],
      _excluded138$8 = ["children"],
      _excluded139$8 = ["children"],
      _excluded140$8 = ["children"],
      _excluded141$8 = ["children"],
      _excluded142$8 = ["children"],
      _excluded143$8 = ["children"],
      _excluded144$8 = ["children"],
      _excluded145$8 = ["children"],
      _excluded146$8 = ["children"],
      _excluded147$8 = ["children"],
      _excluded148$8 = ["children"],
      _excluded149$8 = ["children"],
      _excluded150$8 = ["children"],
      _excluded151$8 = ["children"],
      _excluded152$8 = ["children"],
      _excluded153$8 = ["children"],
      _excluded154$8 = ["children"],
      _excluded155$8 = ["children"],
      _excluded156$8 = ["children"],
      _excluded157$8 = ["children"],
      _excluded158$8 = ["children"],
      _excluded159$8 = ["children"],
      _excluded160$8 = ["children"],
      _excluded161$8 = ["children"],
      _excluded162$8 = ["children"],
      _excluded163$8 = ["children"],
      _excluded164$8 = ["children"],
      _excluded165$8 = ["children"],
      _excluded166$8 = ["children"],
      _excluded167$8 = ["children"],
      _excluded168$8 = ["children"],
      _excluded169$8 = ["children"],
      _excluded170$8 = ["children"],
      _excluded171$8 = ["children"],
      _excluded172$8 = ["children"],
      _excluded173$8 = ["children"],
      _excluded174$8 = ["children"],
      _excluded175$8 = ["children"],
      _excluded176$8 = ["children"],
      _excluded177$8 = ["children"],
      _excluded178$8 = ["children"],
      _excluded179$8 = ["children"],
      _excluded180$8 = ["children"],
      _excluded181$8 = ["children"],
      _excluded182$8 = ["children"],
      _excluded183$8 = ["children"],
      _excluded184$8 = ["children"],
      _excluded185$8 = ["children"],
      _excluded186$8 = ["children"],
      _excluded187$8 = ["children"],
      _excluded188$8 = ["children"],
      _excluded189$8 = ["children"],
      _excluded190$8 = ["children"],
      _excluded191$8 = ["children"],
      _excluded192$8 = ["children"],
      _excluded193$8 = ["children"],
      _excluded194$8 = ["children"],
      _excluded195$8 = ["children"],
      _excluded196$8 = ["children"],
      _excluded197$8 = ["children"],
      _excluded198$8 = ["children"],
      _excluded199$8 = ["children"],
      _excluded200$8 = ["children"],
      _excluded201$8 = ["children"],
      _excluded202$8 = ["children"],
      _excluded203$8 = ["children"],
      _excluded204$8 = ["children"],
      _excluded205$8 = ["children"],
      _excluded206$8 = ["children"],
      _excluded207$8 = ["children"],
      _excluded208$8 = ["children"],
      _excluded209$8 = ["children"],
      _excluded210$8 = ["children"],
      _excluded211$8 = ["children"],
      _excluded212$8 = ["children"],
      _excluded213$8 = ["children"],
      _excluded214$8 = ["children"],
      _excluded215$8 = ["children"],
      _excluded216$8 = ["children"],
      _excluded217$8 = ["children"],
      _excluded218$8 = ["children"],
      _excluded219$8 = ["children"],
      _excluded220$8 = ["children"],
      _excluded221$8 = ["children"],
      _excluded222$8 = ["children"],
      _excluded223$8 = ["children"],
      _excluded224$8 = ["children"],
      _excluded225$8 = ["children"],
      _excluded226$8 = ["children"],
      _excluded227$8 = ["children"],
      _excluded228$8 = ["children"],
      _excluded229$8 = ["children"],
      _excluded230$8 = ["children"],
      _excluded231$8 = ["children"],
      _excluded232$8 = ["children"],
      _excluded233$8 = ["children"],
      _excluded234$8 = ["children"],
      _excluded235$8 = ["children"],
      _excluded236$8 = ["children"],
      _excluded237$8 = ["children"],
      _excluded238$8 = ["children"],
      _excluded239$8 = ["children"],
      _excluded240$8 = ["children"],
      _excluded241$8 = ["children"],
      _excluded242$8 = ["children"],
      _excluded243$8 = ["children"],
      _excluded244$8 = ["children"],
      _excluded245$8 = ["children"],
      _excluded246$8 = ["children"],
      _excluded247$8 = ["children"],
      _excluded248$8 = ["children"],
      _excluded249$8 = ["children"],
      _excluded250$8 = ["children"];
  var didWarnAboutDeprecation$1 = {};
  var RadioPushToTalk20 = /*#__PURE__*/React__default['default'].forwardRef(function RadioPushToTalk20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$9 || (_path$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H19V13H13zM13 15H19V17H13z"
    })), _circle$8 || (_circle$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23",
      r: "2"
    })), _path2$9 || (_path2$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,7H21V2H19V7H10A2.0023,2.0023,0,0,0,8,9v2H6v2H8v2H6v2H8V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,22,7ZM10,28V9H22V28Z"
    })), children);
  });
  var RadioPushToTalk16 = /*#__PURE__*/React__default['default'].forwardRef(function RadioPushToTalk16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$9 || (_path3$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 11H19V13H13zM13 15H19V17H13z"
    })), _circle2$8 || (_circle2$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "23",
      r: "2"
    })), _path4$9 || (_path4$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,7H21V2H19V7H10A2.0023,2.0023,0,0,0,8,9v2H6v2H8v2H6v2H8V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V9A2.0023,2.0023,0,0,0,22,7ZM10,28V9H22V28Z"
    })), children);
  });
  var RadioButton32 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButton32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$9 || (_path5$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var RadioButton24 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButton24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$9 || (_path6$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var RadioButton20 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButton20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$9 || (_path7$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var RadioButton16 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButton16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$9 || (_path8$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), children);
  });
  var RadioButtonChecked32 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButtonChecked32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$9 || (_path9$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path10$9 || (_path10$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"
    })), children);
  });
  var RadioButtonChecked24 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButtonChecked24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$9 || (_path11$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path12$9 || (_path12$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"
    })), children);
  });
  var RadioButtonChecked20 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButtonChecked20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$9 || (_path13$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path14$9 || (_path14$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"
    })), children);
  });
  var RadioButtonChecked16 = /*#__PURE__*/React__default['default'].forwardRef(function RadioButtonChecked16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$9 || (_path15$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path16$9 || (_path16$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"
    })), children);
  });
  var Rain32 = /*#__PURE__*/React__default['default'].forwardRef(function Rain32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$9 || (_path17$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var Rain24 = /*#__PURE__*/React__default['default'].forwardRef(function Rain24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$9 || (_path18$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var Rain20 = /*#__PURE__*/React__default['default'].forwardRef(function Rain20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$9 || (_path19$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var Rain16 = /*#__PURE__*/React__default['default'].forwardRef(function Rain16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$9 || (_path20$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM14 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0114 30zM20 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 0120 30zM8 30a.93.93 0 01-.45-.11 1 1 0 01-.44-1.34l2-4a1 1 0 111.78.9l-2 4A1 1 0 018 30z"
    })), children);
  });
  var RainDrizzle32 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrizzle32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$9 || (_path21$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,30a1,1,0,0,1-.8944-1.4474l2-4a1,1,0,1,1,1.7887.8946l-2,4A.9979.9979,0,0,1,11,30Z"
    })), _path22$9 || (_path22$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4973,6.4973,0,0,0,8.5,22H19.3813L18.105,24.5527a1,1,0,0,0,1.789.8946L21.6177,22H23.5A6.4974,6.4974,0,0,0,24.8008,9.1362ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainDrizzle24 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrizzle24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$9 || (_path23$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,30a1,1,0,0,1-.8944-1.4474l2-4a1,1,0,1,1,1.7887.8946l-2,4A.9979.9979,0,0,1,11,30Z"
    })), _path24$9 || (_path24$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4973,6.4973,0,0,0,8.5,22H19.3813L18.105,24.5527a1,1,0,0,0,1.789.8946L21.6177,22H23.5A6.4974,6.4974,0,0,0,24.8008,9.1362ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainDrizzle20 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrizzle20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$9 || (_path25$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,30a1,1,0,0,1-.8944-1.4474l2-4a1,1,0,1,1,1.7887.8946l-2,4A.9979.9979,0,0,1,11,30Z"
    })), _path26$9 || (_path26$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4973,6.4973,0,0,0,8.5,22H19.3813L18.105,24.5527a1,1,0,0,0,1.789.8946L21.6177,22H23.5A6.4974,6.4974,0,0,0,24.8008,9.1362ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainDrizzle16 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrizzle16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$9 || (_path27$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,30a1,1,0,0,1-.8944-1.4474l2-4a1,1,0,1,1,1.7887.8946l-2,4A.9979.9979,0,0,1,11,30Z"
    })), _path28$9 || (_path28$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4973,6.4973,0,0,0,8.5,22H19.3813L18.105,24.5527a1,1,0,0,0,1.789.8946L21.6177,22H23.5A6.4974,6.4974,0,0,0,24.8008,9.1362ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainHeavy32 = /*#__PURE__*/React__default['default'].forwardRef(function RainHeavy32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$9 || (_path29$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0117 30zM8 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 018 30z"
    })), _path30$9 || (_path30$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15.5a6.5323,6.5323,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0A6.4905,6.4905,0,0,0,5.7026,21.3584L4.106,24.5527a1,1,0,1,0,1.7885.8946L7.6174,22l6.7644,0L13.106,24.5527a1,1,0,1,0,1.7885.8946L16.6177,22h6.7641L22.106,24.5527a1,1,0,1,0,1.7885.8946l1.9444-3.89A6.5058,6.5058,0,0,0,30,15.5ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainHeavy24 = /*#__PURE__*/React__default['default'].forwardRef(function RainHeavy24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$9 || (_path31$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0117 30zM8 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 018 30z"
    })), _path32$9 || (_path32$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15.5a6.5323,6.5323,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0A6.4905,6.4905,0,0,0,5.7026,21.3584L4.106,24.5527a1,1,0,1,0,1.7885.8946L7.6174,22l6.7644,0L13.106,24.5527a1,1,0,1,0,1.7885.8946L16.6177,22h6.7641L22.106,24.5527a1,1,0,1,0,1.7885.8946l1.9444-3.89A6.5058,6.5058,0,0,0,30,15.5ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainHeavy20 = /*#__PURE__*/React__default['default'].forwardRef(function RainHeavy20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$9 || (_path33$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0117 30zM8 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 018 30z"
    })), _path34$9 || (_path34$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15.5a6.5323,6.5323,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0A6.4905,6.4905,0,0,0,5.7026,21.3584L4.106,24.5527a1,1,0,1,0,1.7885.8946L7.6174,22l6.7644,0L13.106,24.5527a1,1,0,1,0,1.7885.8946L16.6177,22h6.7641L22.106,24.5527a1,1,0,1,0,1.7885.8946l1.9444-3.89A6.5058,6.5058,0,0,0,30,15.5ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainHeavy16 = /*#__PURE__*/React__default['default'].forwardRef(function RainHeavy16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$9 || (_path35$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0117 30zM8 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 018 30z"
    })), _path36$9 || (_path36$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15.5a6.5323,6.5323,0,0,0-5.1992-6.3638,8.9943,8.9943,0,0,0-17.6006,0A6.4905,6.4905,0,0,0,5.7026,21.3584L4.106,24.5527a1,1,0,1,0,1.7885.8946L7.6174,22l6.7644,0L13.106,24.5527a1,1,0,1,0,1.7885.8946L16.6177,22h6.7641L22.106,24.5527a1,1,0,1,0,1.7885.8946l1.9444-3.89A6.5058,6.5058,0,0,0,30,15.5ZM23.5,20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20Z"
    })), children);
  });
  var RainScattered32 = /*#__PURE__*/React__default['default'].forwardRef(function RainScattered32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$9 || (_path37$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084,32a1.0127,1.0127,0,0,1-.4485-.1054.9986.9986,0,0,1-.4486-1.3418l1.4934-3.0005a1.0025,1.0025,0,0,1,1.7943.8945l-1.4934,3A1.0013,1.0013,0,0,1,8.5084,32Z"
    })), _path38$9 || (_path38$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.232 15.733H29.232V18.733H27.232z",
      transform: "rotate(-45.009 28.232 17.233)"
    })), _path39$9 || (_path39$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path40$9 || (_path40$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path41$9 || (_path41$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path42$9 || (_path42$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.768 3.268H14.768V6.268H12.768z",
      transform: "rotate(-45 13.768 4.768)"
    })), _path43$9 || (_path43$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25h7.3818L14.106,27.5527a1,1,0,1,0,1.7885.8946L17.6177,25H19a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11ZM19,23H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23Zm3.9268-8.5107a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), children);
  });
  var RainScattered24 = /*#__PURE__*/React__default['default'].forwardRef(function RainScattered24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$9 || (_path44$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084,32a1.0127,1.0127,0,0,1-.4485-.1054.9986.9986,0,0,1-.4486-1.3418l1.4934-3.0005a1.0025,1.0025,0,0,1,1.7943.8945l-1.4934,3A1.0013,1.0013,0,0,1,8.5084,32Z"
    })), _path45$9 || (_path45$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.232 15.733H29.232V18.733H27.232z",
      transform: "rotate(-45.009 28.232 17.233)"
    })), _path46$9 || (_path46$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path47$9 || (_path47$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path48$9 || (_path48$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path49$9 || (_path49$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.768 3.268H14.768V6.268H12.768z",
      transform: "rotate(-45 13.768 4.768)"
    })), _path50$9 || (_path50$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25h7.3818L14.106,27.5527a1,1,0,1,0,1.7885.8946L17.6177,25H19a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11ZM19,23H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23Zm3.9268-8.5107a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), children);
  });
  var RainScattered20 = /*#__PURE__*/React__default['default'].forwardRef(function RainScattered20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$9 || (_path51$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084,32a1.0127,1.0127,0,0,1-.4485-.1054.9986.9986,0,0,1-.4486-1.3418l1.4934-3.0005a1.0025,1.0025,0,0,1,1.7943.8945l-1.4934,3A1.0013,1.0013,0,0,1,8.5084,32Z"
    })), _path52$9 || (_path52$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.232 15.733H29.232V18.733H27.232z",
      transform: "rotate(-45.009 28.232 17.233)"
    })), _path53$9 || (_path53$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path54$9 || (_path54$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path55$9 || (_path55$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path56$9 || (_path56$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.768 3.268H14.768V6.268H12.768z",
      transform: "rotate(-45 13.768 4.768)"
    })), _path57$9 || (_path57$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25h7.3818L14.106,27.5527a1,1,0,1,0,1.7885.8946L17.6177,25H19a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11ZM19,23H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23Zm3.9268-8.5107a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), children);
  });
  var RainScattered16 = /*#__PURE__*/React__default['default'].forwardRef(function RainScattered16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$9 || (_path58$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084,32a1.0127,1.0127,0,0,1-.4485-.1054.9986.9986,0,0,1-.4486-1.3418l1.4934-3.0005a1.0025,1.0025,0,0,1,1.7943.8945l-1.4934,3A1.0013,1.0013,0,0,1,8.5084,32Z"
    })), _path59$9 || (_path59$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.232 15.733H29.232V18.733H27.232z",
      transform: "rotate(-45.009 28.232 17.233)"
    })), _path60$9 || (_path60$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path61$9 || (_path61$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path62$9 || (_path62$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path63$9 || (_path63$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.768 3.268H14.768V6.268H12.768z",
      transform: "rotate(-45 13.768 4.768)"
    })), _path64$9 || (_path64$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25h7.3818L14.106,27.5527a1,1,0,1,0,1.7885.8946L17.6177,25H19a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11ZM19,23H8a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23Zm3.9268-8.5107a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), children);
  });
  var RainScatteredNight32 = /*#__PURE__*/React__default['default'].forwardRef(function RainScatteredNight32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$9 || (_path65$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084 32a1.0115 1.0115 0 01-.4485-.1055.9986.9986 0 01-.4486-1.3418l1.4934-3a1.0025 1.0025 0 011.7943.8945l-1.4934 3A1.0015 1.0015 0 018.5084 32zM29.8442 13.0347a1.5184 1.5184 0 00-1.2309-.8658 5.3587 5.3587 0 01-3.4094-1.7163 6.4648 6.4648 0 01-1.285-6.393 1.6031 1.6031 0 00-.3-1.5459 1.4535 1.4535 0 00-1.3594-.4922l-.0191.0029a7.8549 7.8549 0 00-6.1054 6.48A7.3725 7.3725 0 0013.5 8a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 25h7.3818L14.106 27.5527a1 1 0 101.7885.8946L17.6177 25H19a5.9549 5.9549 0 005.88-7.1455 7.5 7.5 0 004.8672-3.3A1.5381 1.5381 0 0029.8442 13.0347zM19 23H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 23zm5.1509-7.0479a5.9639 5.9639 0 00-3.5015-2.708A7.5076 7.5076 0 0018.0286 9.55a6.01 6.01 0 013.77-5.334 8.4581 8.4581 0 001.9395 7.5972A7.4007 7.4007 0 0027.64 14.041 5.4392 5.4392 0 0124.1509 15.9521z"
    })), children);
  });
  var RainScatteredNight24 = /*#__PURE__*/React__default['default'].forwardRef(function RainScatteredNight24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$9 || (_path66$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084 32a1.0115 1.0115 0 01-.4485-.1055.9986.9986 0 01-.4486-1.3418l1.4934-3a1.0025 1.0025 0 011.7943.8945l-1.4934 3A1.0015 1.0015 0 018.5084 32zM29.8442 13.0347a1.5184 1.5184 0 00-1.2309-.8658 5.3587 5.3587 0 01-3.4094-1.7163 6.4648 6.4648 0 01-1.285-6.393 1.6031 1.6031 0 00-.3-1.5459 1.4535 1.4535 0 00-1.3594-.4922l-.0191.0029a7.8549 7.8549 0 00-6.1054 6.48A7.3725 7.3725 0 0013.5 8a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 25h7.3818L14.106 27.5527a1 1 0 101.7885.8946L17.6177 25H19a5.9549 5.9549 0 005.88-7.1455 7.5 7.5 0 004.8672-3.3A1.5381 1.5381 0 0029.8442 13.0347zM19 23H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 23zm5.1509-7.0479a5.9639 5.9639 0 00-3.5015-2.708A7.5076 7.5076 0 0018.0286 9.55a6.01 6.01 0 013.77-5.334 8.4581 8.4581 0 001.9395 7.5972A7.4007 7.4007 0 0027.64 14.041 5.4392 5.4392 0 0124.1509 15.9521z"
    })), children);
  });
  var RainScatteredNight20 = /*#__PURE__*/React__default['default'].forwardRef(function RainScatteredNight20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$9 || (_path67$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084 32a1.0115 1.0115 0 01-.4485-.1055.9986.9986 0 01-.4486-1.3418l1.4934-3a1.0025 1.0025 0 011.7943.8945l-1.4934 3A1.0015 1.0015 0 018.5084 32zM29.8442 13.0347a1.5184 1.5184 0 00-1.2309-.8658 5.3587 5.3587 0 01-3.4094-1.7163 6.4648 6.4648 0 01-1.285-6.393 1.6031 1.6031 0 00-.3-1.5459 1.4535 1.4535 0 00-1.3594-.4922l-.0191.0029a7.8549 7.8549 0 00-6.1054 6.48A7.3725 7.3725 0 0013.5 8a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 25h7.3818L14.106 27.5527a1 1 0 101.7885.8946L17.6177 25H19a5.9549 5.9549 0 005.88-7.1455 7.5 7.5 0 004.8672-3.3A1.5381 1.5381 0 0029.8442 13.0347zM19 23H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 23zm5.1509-7.0479a5.9639 5.9639 0 00-3.5015-2.708A7.5076 7.5076 0 0018.0286 9.55a6.01 6.01 0 013.77-5.334 8.4581 8.4581 0 001.9395 7.5972A7.4007 7.4007 0 0027.64 14.041 5.4392 5.4392 0 0124.1509 15.9521z"
    })), children);
  });
  var RainScatteredNight16 = /*#__PURE__*/React__default['default'].forwardRef(function RainScatteredNight16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$9 || (_path68$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.5084 32a1.0115 1.0115 0 01-.4485-.1055.9986.9986 0 01-.4486-1.3418l1.4934-3a1.0025 1.0025 0 011.7943.8945l-1.4934 3A1.0015 1.0015 0 018.5084 32zM29.8442 13.0347a1.5184 1.5184 0 00-1.2309-.8658 5.3587 5.3587 0 01-3.4094-1.7163 6.4648 6.4648 0 01-1.285-6.393 1.6031 1.6031 0 00-.3-1.5459 1.4535 1.4535 0 00-1.3594-.4922l-.0191.0029a7.8549 7.8549 0 00-6.1054 6.48A7.3725 7.3725 0 0013.5 8a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 25h7.3818L14.106 27.5527a1 1 0 101.7885.8946L17.6177 25H19a5.9549 5.9549 0 005.88-7.1455 7.5 7.5 0 004.8672-3.3A1.5381 1.5381 0 0029.8442 13.0347zM19 23H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 23zm5.1509-7.0479a5.9639 5.9639 0 00-3.5015-2.708A7.5076 7.5076 0 0018.0286 9.55a6.01 6.01 0 013.77-5.334 8.4581 8.4581 0 001.9395 7.5972A7.4007 7.4007 0 0027.64 14.041 5.4392 5.4392 0 0124.1509 15.9521z"
    })), children);
  });
  var RainDrop32 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrop32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$9 || (_path69$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24V22a3.2965,3.2965,0,0,0,3-3h2A5.2668,5.2668,0,0,1,16,24Z"
    })), _path70$9 || (_path70$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), children);
  });
  var RainDrop24 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrop24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$9 || (_path71$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24V22a3.2965,3.2965,0,0,0,3-3h2A5.2668,5.2668,0,0,1,16,24Z"
    })), _path72$9 || (_path72$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), children);
  });
  var RainDrop20 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrop20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$9 || (_path73$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24V22a3.2965,3.2965,0,0,0,3-3h2A5.2668,5.2668,0,0,1,16,24Z"
    })), _path74$9 || (_path74$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), children);
  });
  var RainDrop16 = /*#__PURE__*/React__default['default'].forwardRef(function RainDrop16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$9 || (_path75$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24V22a3.2965,3.2965,0,0,0,3-3h2A5.2668,5.2668,0,0,1,16,24Z"
    })), _path76$9 || (_path76$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), children);
  });
  var Raw32 = /*#__PURE__*/React__default['default'].forwardRef(function Raw32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$9 || (_path77$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM10 15V11A2 2 0 008 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0010 15zM4 11H8v4H4z"
    })), children);
  });
  var Raw24 = /*#__PURE__*/React__default['default'].forwardRef(function Raw24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$9 || (_path78$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM10 15V11A2 2 0 008 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0010 15zM4 11H8v4H4z"
    })), children);
  });
  var Raw20 = /*#__PURE__*/React__default['default'].forwardRef(function Raw20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$9 || (_path79$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM10 15V11A2 2 0 008 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0010 15zM4 11H8v4H4z"
    })), children);
  });
  var Raw16 = /*#__PURE__*/React__default['default'].forwardRef(function Raw16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$9 || (_path80$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 00-2 2V23h2V18h4v5h2V11A2 2 0 0018 9zm-4 7V11h4v5zM10 15V11A2 2 0 008 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0010 15zM4 11H8v4H4z"
    })), children);
  });
  var Receipt32 = /*#__PURE__*/React__default['default'].forwardRef(function Receipt32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$9 || (_path81$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"
    })), _path82$9 || (_path82$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"
    })), children);
  });
  var Receipt24 = /*#__PURE__*/React__default['default'].forwardRef(function Receipt24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$9 || (_path83$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"
    })), _path84$9 || (_path84$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"
    })), children);
  });
  var Receipt20 = /*#__PURE__*/React__default['default'].forwardRef(function Receipt20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$9 || (_path85$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"
    })), _path86$9 || (_path86$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"
    })), children);
  });
  var Receipt16 = /*#__PURE__*/React__default['default'].forwardRef(function Receipt16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$9 || (_path87$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"
    })), _path88$9 || (_path88$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"
    })), children);
  });
  var RecentlyViewed32 = /*#__PURE__*/React__default['default'].forwardRef(function RecentlyViewed32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$9 || (_path89$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), _path90$9 || (_path90$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var RecentlyViewed24 = /*#__PURE__*/React__default['default'].forwardRef(function RecentlyViewed24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$9 || (_path91$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), _path92$9 || (_path92$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var RecentlyViewed20 = /*#__PURE__*/React__default['default'].forwardRef(function RecentlyViewed20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$9 || (_path93$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), _path94$9 || (_path94$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var RecentlyViewed16 = /*#__PURE__*/React__default['default'].forwardRef(function RecentlyViewed16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$9 || (_path95$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), _path96$9 || (_path96$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"
    })), children);
  });
  var Recommend32 = /*#__PURE__*/React__default['default'].forwardRef(function Recommend32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$9 || (_path97$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"
    })), children);
  });
  var Recommend24 = /*#__PURE__*/React__default['default'].forwardRef(function Recommend24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$9 || (_path98$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"
    })), children);
  });
  var Recommend20 = /*#__PURE__*/React__default['default'].forwardRef(function Recommend20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$9 || (_path99$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"
    })), children);
  });
  var Recommend16 = /*#__PURE__*/React__default['default'].forwardRef(function Recommend16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$9 || (_path100$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"
    })), children);
  });
  var Recording32 = /*#__PURE__*/React__default['default'].forwardRef(function Recording32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$9 || (_path101$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path102$9 || (_path102$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Recording24 = /*#__PURE__*/React__default['default'].forwardRef(function Recording24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$9 || (_path103$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path104$9 || (_path104$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Recording20 = /*#__PURE__*/React__default['default'].forwardRef(function Recording20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$9 || (_path105$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path106$9 || (_path106$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var Recording16 = /*#__PURE__*/React__default['default'].forwardRef(function Recording16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$9 || (_path107$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path108$9 || (_path108$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"
    })), children);
  });
  var RecordingFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilled32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$8 || (_circle3$8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path109$9 || (_path109$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"
    })), children);
  });
  var RecordingFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilled24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$7 || (_circle4$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path110$9 || (_path110$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"
    })), children);
  });
  var RecordingFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilled20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$6 || (_circle5$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path111$9 || (_path111$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"
    })), children);
  });
  var RecordingFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilled16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$6 || (_circle6$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path112$9 || (_path112$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"
    })), children);
  });
  var RecordingFilledAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilledAlt32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$9 || (_path113$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"
    })), _path114$9 || (_path114$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var RecordingFilledAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilledAlt24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$9 || (_path115$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"
    })), _path116$9 || (_path116$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var RecordingFilledAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilledAlt20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$9 || (_path117$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"
    })), _path118$9 || (_path118$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var RecordingFilledAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function RecordingFilledAlt16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$9 || (_path119$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"
    })), _path120$9 || (_path120$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var Redo32 = /*#__PURE__*/React__default['default'].forwardRef(function Redo32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$9 || (_path121$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H24.1851L20.5977,6.4141,22,5,28,11,22,17l-1.4023-1.4146L24.1821,12H12a6,6,0,0,0,0,12h8v2H12a8,8,0,0,1,0-16Z"
    })), children);
  });
  var Redo24 = /*#__PURE__*/React__default['default'].forwardRef(function Redo24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$9 || (_path122$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.8,11.2c-1.8,0-3.2,1.7-3.2,3.3c0,1.5,1.5,3.2,3.2,3.2H10v1.5H6.8C4.6,19.2,2,17,2,14.5s2-4.8,4.8-4.8\th12.4l-3-3l1.1-1.1l4.8,4.8l-4.8,4.8l-1.1-1.1l3-3H6.8z"
    })), children);
  });
  var Redo20 = /*#__PURE__*/React__default['default'].forwardRef(function Redo20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$9 || (_path123$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5,9.3c-1.5,0-2.8,1.3-2.8,2.7c0,1.5,1.3,2.7,2.8,2.7h4V16H5c-2.3,0-4-1.7-4-4c0-2.2,1.8-4,4-4h11.6\tl-2.5-2.5L15,4.6l4,4l-4,4l-0.9-0.9l2.5-2.5H5z"
    })), children);
  });
  var Redo16 = /*#__PURE__*/React__default['default'].forwardRef(function Redo16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$9 || (_path124$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,8c-1.2,0-2,0.8-2,2c0,1.2,0.8,2,2,2h3v1H4c-1.7,0-3-1.2-3-3c0-1.7,1.3-3,3-3l9.1,0l-2-2l0.7-0.7\tL15,7.5l-3.2,3.2L11.1,10l2-2L4,8z"
    })), children);
  });
  var RefEvapotranspiration32 = /*#__PURE__*/React__default['default'].forwardRef(function RefEvapotranspiration32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$9 || (_path125$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L13.17 2.4141a1.0381 1.0381 0 011.6592 0L17.3154 6.11A3.9693 3.9693 0 0118 8.223 3.8978 3.8978 0 0114 12zm.0005-7.2368L12.3438 7.2257A1.89 1.89 0 0012 8.223 1.9 1.9 0 0014 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466zM7.5 26A5.385 5.385 0 012 20.751 5.3837 5.3837 0 012.874 17.92L6.49 12.5383a1.2168 1.2168 0 012.02-.0006l3.55 5.2777A5.4923 5.4923 0 0113 20.751 5.385 5.385 0 017.5 26zm0-11.38L4.5649 18.9868A3.3586 3.3586 0 004 20.751 3.3855 3.3855 0 007.5 24 3.3855 3.3855 0 0011 20.751a3.4354 3.4354 0 00-.63-1.867zM25 2L20 7l1.4141 1.4141L24 5.8281V16a4.0045 4.0045 0 01-4 4H16v2h4a6.0066 6.0066 0 006-6V5.8281l2.5859 2.586L30 7zM2 28H30V30H2z"
    })), children);
  });
  var RefEvapotranspiration24 = /*#__PURE__*/React__default['default'].forwardRef(function RefEvapotranspiration24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$9 || (_path126$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L13.17 2.4141a1.0381 1.0381 0 011.6592 0L17.3154 6.11A3.9693 3.9693 0 0118 8.223 3.8978 3.8978 0 0114 12zm.0005-7.2368L12.3438 7.2257A1.89 1.89 0 0012 8.223 1.9 1.9 0 0014 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466zM7.5 26A5.385 5.385 0 012 20.751 5.3837 5.3837 0 012.874 17.92L6.49 12.5383a1.2168 1.2168 0 012.02-.0006l3.55 5.2777A5.4923 5.4923 0 0113 20.751 5.385 5.385 0 017.5 26zm0-11.38L4.5649 18.9868A3.3586 3.3586 0 004 20.751 3.3855 3.3855 0 007.5 24 3.3855 3.3855 0 0011 20.751a3.4354 3.4354 0 00-.63-1.867zM25 2L20 7l1.4141 1.4141L24 5.8281V16a4.0045 4.0045 0 01-4 4H16v2h4a6.0066 6.0066 0 006-6V5.8281l2.5859 2.586L30 7zM2 28H30V30H2z"
    })), children);
  });
  var RefEvapotranspiration20 = /*#__PURE__*/React__default['default'].forwardRef(function RefEvapotranspiration20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$9 || (_path127$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L13.17 2.4141a1.0381 1.0381 0 011.6592 0L17.3154 6.11A3.9693 3.9693 0 0118 8.223 3.8978 3.8978 0 0114 12zm.0005-7.2368L12.3438 7.2257A1.89 1.89 0 0012 8.223 1.9 1.9 0 0014 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466zM7.5 26A5.385 5.385 0 012 20.751 5.3837 5.3837 0 012.874 17.92L6.49 12.5383a1.2168 1.2168 0 012.02-.0006l3.55 5.2777A5.4923 5.4923 0 0113 20.751 5.385 5.385 0 017.5 26zm0-11.38L4.5649 18.9868A3.3586 3.3586 0 004 20.751 3.3855 3.3855 0 007.5 24 3.3855 3.3855 0 0011 20.751a3.4354 3.4354 0 00-.63-1.867zM25 2L20 7l1.4141 1.4141L24 5.8281V16a4.0045 4.0045 0 01-4 4H16v2h4a6.0066 6.0066 0 006-6V5.8281l2.5859 2.586L30 7zM2 28H30V30H2z"
    })), children);
  });
  var RefEvapotranspiration16 = /*#__PURE__*/React__default['default'].forwardRef(function RefEvapotranspiration16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$9 || (_path128$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 12a3.8978 3.8978 0 01-4-3.777 3.9017 3.9017 0 01.6533-2.0639L13.17 2.4141a1.0381 1.0381 0 011.6592 0L17.3154 6.11A3.9693 3.9693 0 0118 8.223 3.8978 3.8978 0 0114 12zm.0005-7.2368L12.3438 7.2257A1.89 1.89 0 0012 8.223 1.9 1.9 0 0014 10a1.9 1.9 0 002-1.777 1.98 1.98 0 00-.375-1.0466zM7.5 26A5.385 5.385 0 012 20.751 5.3837 5.3837 0 012.874 17.92L6.49 12.5383a1.2168 1.2168 0 012.02-.0006l3.55 5.2777A5.4923 5.4923 0 0113 20.751 5.385 5.385 0 017.5 26zm0-11.38L4.5649 18.9868A3.3586 3.3586 0 004 20.751 3.3855 3.3855 0 007.5 24 3.3855 3.3855 0 0011 20.751a3.4354 3.4354 0 00-.63-1.867zM25 2L20 7l1.4141 1.4141L24 5.8281V16a4.0045 4.0045 0 01-4 4H16v2h4a6.0066 6.0066 0 006-6V5.8281l2.5859 2.586L30 7zM2 28H30V30H2z"
    })), children);
  });
  var ReflectHorizontal32 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectHorizontal32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$9 || (_path129$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.386,15.2105l9-7A1,1,0,0,1,30,9V23a1,1,0,0,1-1.614.79l-9-7a1,1,0,0,1,0-1.5791Z"
    })), _path130$9 || (_path130$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-180 16 16)"
    })), _path131$9 || (_path131$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,16a1.001,1.001,0,0,1-.386.79l-9,7A1,1,0,0,1,2,23V9a1,1,0,0,1,1.614-.79l9,7A1.001,1.001,0,0,1,13,16ZM4,20.9556,10.3711,16,4,11.0444Z"
    })), children);
  });
  var ReflectHorizontal24 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectHorizontal24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$9 || (_path132$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.386,15.2105l9-7A1,1,0,0,1,30,9V23a1,1,0,0,1-1.614.79l-9-7a1,1,0,0,1,0-1.5791Z"
    })), _path133$9 || (_path133$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-180 16 16)"
    })), _path134$9 || (_path134$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,16a1.001,1.001,0,0,1-.386.79l-9,7A1,1,0,0,1,2,23V9a1,1,0,0,1,1.614-.79l9,7A1.001,1.001,0,0,1,13,16ZM4,20.9556,10.3711,16,4,11.0444Z"
    })), children);
  });
  var ReflectHorizontal20 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectHorizontal20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$9 || (_path135$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.386,15.2105l9-7A1,1,0,0,1,30,9V23a1,1,0,0,1-1.614.79l-9-7a1,1,0,0,1,0-1.5791Z"
    })), _path136$9 || (_path136$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-180 16 16)"
    })), _path137$9 || (_path137$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,16a1.001,1.001,0,0,1-.386.79l-9,7A1,1,0,0,1,2,23V9a1,1,0,0,1,1.614-.79l9,7A1.001,1.001,0,0,1,13,16ZM4,20.9556,10.3711,16,4,11.0444Z"
    })), children);
  });
  var ReflectHorizontal16 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectHorizontal16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$9 || (_path138$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.386,15.2105l9-7A1,1,0,0,1,30,9V23a1,1,0,0,1-1.614.79l-9-7a1,1,0,0,1,0-1.5791Z"
    })), _path139$9 || (_path139$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-180 16 16)"
    })), _path140$9 || (_path140$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,16a1.001,1.001,0,0,1-.386.79l-9,7A1,1,0,0,1,2,23V9a1,1,0,0,1,1.614-.79l9,7A1.001,1.001,0,0,1,13,16ZM4,20.9556,10.3711,16,4,11.0444Z"
    })), children);
  });
  var ReflectVertical32 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectVertical32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$9 || (_path141$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.79,19.386l7,9A1,1,0,0,1,23,30H9a1,1,0,0,1-.79-1.614l7-9a1,1,0,0,1,1.5791,0Z"
    })), _path142$9 || (_path142$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-90 16 16)"
    })), _path143$9 || (_path143$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13a1.001,1.001,0,0,1-.79-.386l-7-9A1,1,0,0,1,9,2H23a1,1,0,0,1,.79,1.614l-7,9A1.001,1.001,0,0,1,16,13ZM11.0444,4,16,10.3711,20.9556,4Z"
    })), children);
  });
  var ReflectVertical24 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectVertical24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$9 || (_path144$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.79,19.386l7,9A1,1,0,0,1,23,30H9a1,1,0,0,1-.79-1.614l7-9a1,1,0,0,1,1.5791,0Z"
    })), _path145$9 || (_path145$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-90 16 16)"
    })), _path146$9 || (_path146$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13a1.001,1.001,0,0,1-.79-.386l-7-9A1,1,0,0,1,9,2H23a1,1,0,0,1,.79,1.614l-7,9A1.001,1.001,0,0,1,16,13ZM11.0444,4,16,10.3711,20.9556,4Z"
    })), children);
  });
  var ReflectVertical20 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectVertical20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$9 || (_path147$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.79,19.386l7,9A1,1,0,0,1,23,30H9a1,1,0,0,1-.79-1.614l7-9a1,1,0,0,1,1.5791,0Z"
    })), _path148$9 || (_path148$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-90 16 16)"
    })), _path149$9 || (_path149$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13a1.001,1.001,0,0,1-.79-.386l-7-9A1,1,0,0,1,9,2H23a1,1,0,0,1,.79,1.614l-7,9A1.001,1.001,0,0,1,16,13ZM11.0444,4,16,10.3711,20.9556,4Z"
    })), children);
  });
  var ReflectVertical16 = /*#__PURE__*/React__default['default'].forwardRef(function ReflectVertical16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$9 || (_path150$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.79,19.386l7,9A1,1,0,0,1,23,30H9a1,1,0,0,1-.79-1.614l7-9a1,1,0,0,1,1.5791,0Z"
    })), _path151$9 || (_path151$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V30H15z",
      transform: "rotate(-90 16 16)"
    })), _path152$9 || (_path152$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,13a1.001,1.001,0,0,1-.79-.386l-7-9A1,1,0,0,1,9,2H23a1,1,0,0,1,.79,1.614l-7,9A1.001,1.001,0,0,1,16,13ZM11.0444,4,16,10.3711,20.9556,4Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisArea32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisArea32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$9 || (_path153$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path154$9 || (_path154$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisArea24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisArea24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$9 || (_path155$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path156$9 || (_path156$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisArea20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisArea20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$9 || (_path157$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path158$9 || (_path158$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisArea16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisArea16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$9 || (_path159$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path160$9 || (_path160$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisVolume32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisVolume32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$9 || (_path161$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path162$9 || (_path162$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisVolume24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisVolume24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$9 || (_path163$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path164$9 || (_path164$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisVolume20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisVolume20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$9 || (_path165$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path166$9 || (_path166$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"
    })), children);
  });
  var WatsonHealthRegionAnalysisVolume16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegionAnalysisVolume16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$9 || (_path167$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"
    })), _path168$9 || (_path168$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"
    })), children);
  });
  var WatsonHealthRegistration32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegistration32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$9 || (_path169$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25H20a2.0027 2.0027 0 01-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2V23A2.0027 2.0027 0 0128 25zM8 15H12V17H8z"
    })), _path170$9 || (_path170$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 01-2-2V9A2.002 2.002 0 014 7h8a2.002 2.002 0 012 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0112 25z"
    })), children);
  });
  var WatsonHealthRegistration24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegistration24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$9 || (_path171$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25H20a2.0027 2.0027 0 01-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2V23A2.0027 2.0027 0 0128 25zM8 15H12V17H8z"
    })), _path172$9 || (_path172$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 01-2-2V9A2.002 2.002 0 014 7h8a2.002 2.002 0 012 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0112 25z"
    })), children);
  });
  var WatsonHealthRegistration20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegistration20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$9 || (_path173$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25H20a2.0027 2.0027 0 01-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2V23A2.0027 2.0027 0 0128 25zM8 15H12V17H8z"
    })), _path174$9 || (_path174$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 01-2-2V9A2.002 2.002 0 014 7h8a2.002 2.002 0 012 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0112 25z"
    })), children);
  });
  var WatsonHealthRegistration16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRegistration16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$9 || (_path175$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 25H20a2.0027 2.0027 0 01-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2V23A2.0027 2.0027 0 0128 25zM8 15H12V17H8z"
    })), _path176$9 || (_path176$9 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 01-2-2V9A2.002 2.002 0 014 7h8a2.002 2.002 0 012 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0112 25z"
    })), children);
  });
  var Reminder32 = /*#__PURE__*/React__default['default'].forwardRef(function Reminder32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$8 || (_path177$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"
    })), _path178$8 || (_path178$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var Reminder24 = /*#__PURE__*/React__default['default'].forwardRef(function Reminder24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$8 || (_path179$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"
    })), _path180$8 || (_path180$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var Reminder20 = /*#__PURE__*/React__default['default'].forwardRef(function Reminder20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$8 || (_path181$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"
    })), _path182$8 || (_path182$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var Reminder16 = /*#__PURE__*/React__default['default'].forwardRef(function Reminder16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$8 || (_path183$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"
    })), _path184$8 || (_path184$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"
    })), children);
  });
  var ReminderMedical32 = /*#__PURE__*/React__default['default'].forwardRef(function ReminderMedical32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$8 || (_path185$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"
    })), _path186$8 || (_path186$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ReminderMedical24 = /*#__PURE__*/React__default['default'].forwardRef(function ReminderMedical24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$8 || (_path187$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"
    })), _path188$8 || (_path188$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ReminderMedical20 = /*#__PURE__*/React__default['default'].forwardRef(function ReminderMedical20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$8 || (_path189$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"
    })), _path190$8 || (_path190$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var ReminderMedical16 = /*#__PURE__*/React__default['default'].forwardRef(function ReminderMedical16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$8 || (_path191$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"
    })), _path192$8 || (_path192$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"
    })), children);
  });
  var Renew32 = /*#__PURE__*/React__default['default'].forwardRef(function Renew32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$8 || (_path193$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H6.78A11 11 0 0127 16h2A13 13 0 006 7.68V4H4v8h8zM20 22h5.22A11 11 0 015 16H3a13 13 0 0023 8.32V28h2V20H20z"
    })), children);
  });
  var Renew24 = /*#__PURE__*/React__default['default'].forwardRef(function Renew24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$8 || (_path194$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H6.78A11 11 0 0127 16h2A13 13 0 006 7.68V4H4v8h8zM20 22h5.22A11 11 0 015 16H3a13 13 0 0023 8.32V28h2V20H20z"
    })), children);
  });
  var Renew20 = /*#__PURE__*/React__default['default'].forwardRef(function Renew20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$8 || (_path195$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H6.78A11 11 0 0127 16h2A13 13 0 006 7.68V4H4v8h8zM20 22h5.22A11 11 0 015 16H3a13 13 0 0023 8.32V28h2V20H20z"
    })), children);
  });
  var Renew16 = /*#__PURE__*/React__default['default'].forwardRef(function Renew16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$8 || (_path196$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H6.78A11 11 0 0127 16h2A13 13 0 006 7.68V4H4v8h8zM20 22h5.22A11 11 0 015 16H3a13 13 0 0023 8.32V28h2V20H20z"
    })), children);
  });
  var Repeat32 = /*#__PURE__*/React__default['default'].forwardRef(function Repeat32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$8 || (_path197$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), children);
  });
  var Repeat24 = /*#__PURE__*/React__default['default'].forwardRef(function Repeat24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$8 || (_path198$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), children);
  });
  var Repeat20 = /*#__PURE__*/React__default['default'].forwardRef(function Repeat20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$8 || (_path199$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), children);
  });
  var Repeat16 = /*#__PURE__*/React__default['default'].forwardRef(function Repeat16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$8 || (_path200$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), children);
  });
  var RepeatOne32 = /*#__PURE__*/React__default['default'].forwardRef(function RepeatOne32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$8 || (_path201$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), _path202$8 || (_path202$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var RepeatOne24 = /*#__PURE__*/React__default['default'].forwardRef(function RepeatOne24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$8 || (_path203$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), _path204$8 || (_path204$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var RepeatOne20 = /*#__PURE__*/React__default['default'].forwardRef(function RepeatOne20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$8 || (_path205$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), _path206$8 || (_path206$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var RepeatOne16 = /*#__PURE__*/React__default['default'].forwardRef(function RepeatOne16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$8 || (_path207$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26.1719l-3.586-3.5859L24 1l6 6-6 6-1.4141-1.4141L26.1719 8H6v7H4V8A2.0024 2.0024 0 016 6zM9.4141 20.4141L5.8281 24H26V17h2v7a2.0024 2.0024 0 01-2 2H5.8281L9.414 29.5859 8 31 2 25l6-6z"
    })), _path208$8 || (_path208$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"
    })), children);
  });
  var Replicate32 = /*#__PURE__*/React__default['default'].forwardRef(function Replicate32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$8 || (_path209$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8h2V4a2.0021 2.0021 0 00-2-2H24V4h4zM17 2H21V4H17zM28 11H30V15H28zM28 18v4H24V10a2.0023 2.0023 0 00-2-2H10V4h4V2H10A2.0023 2.0023 0 008 4V8H4a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2H22a2.0023 2.0023 0 002-2V24h4a2.0023 2.0023 0 002-2V18zM22 28H4V10H22z"
    })), children);
  });
  var Replicate24 = /*#__PURE__*/React__default['default'].forwardRef(function Replicate24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$8 || (_path210$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8h2V4a2.0021 2.0021 0 00-2-2H24V4h4zM17 2H21V4H17zM28 11H30V15H28zM28 18v4H24V10a2.0023 2.0023 0 00-2-2H10V4h4V2H10A2.0023 2.0023 0 008 4V8H4a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2H22a2.0023 2.0023 0 002-2V24h4a2.0023 2.0023 0 002-2V18zM22 28H4V10H22z"
    })), children);
  });
  var Replicate20 = /*#__PURE__*/React__default['default'].forwardRef(function Replicate20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$8 || (_path211$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8h2V4a2.0021 2.0021 0 00-2-2H24V4h4zM17 2H21V4H17zM28 11H30V15H28zM28 18v4H24V10a2.0023 2.0023 0 00-2-2H10V4h4V2H10A2.0023 2.0023 0 008 4V8H4a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2H22a2.0023 2.0023 0 002-2V24h4a2.0023 2.0023 0 002-2V18zM22 28H4V10H22z"
    })), children);
  });
  var Replicate16 = /*#__PURE__*/React__default['default'].forwardRef(function Replicate16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$8 || (_path212$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8h2V4a2.0021 2.0021 0 00-2-2H24V4h4zM17 2H21V4H17zM28 11H30V15H28zM28 18v4H24V10a2.0023 2.0023 0 00-2-2H10V4h4V2H10A2.0023 2.0023 0 008 4V8H4a2.0023 2.0023 0 00-2 2V28a2.0023 2.0023 0 002 2H22a2.0023 2.0023 0 002-2V24h4a2.0023 2.0023 0 002-2V18zM22 28H4V10H22z"
    })), children);
  });
  var Reply32 = /*#__PURE__*/React__default['default'].forwardRef(function Reply32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$8 || (_path213$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"
    })), children);
  });
  var Reply24 = /*#__PURE__*/React__default['default'].forwardRef(function Reply24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$8 || (_path214$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"
    })), children);
  });
  var Reply20 = /*#__PURE__*/React__default['default'].forwardRef(function Reply20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$8 || (_path215$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"
    })), children);
  });
  var Reply16 = /*#__PURE__*/React__default['default'].forwardRef(function Reply16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$8 || (_path216$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"
    })), children);
  });
  var ReplyAll32 = /*#__PURE__*/React__default['default'].forwardRef(function ReplyAll32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$8 || (_path217$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,29a.9989.9989,0,0,1-.768-.36l-10-12a1,1,0,0,1,0-1.28l10-12A1,1,0,0,1,20,4v7.0325c7.0074.4629,11,5.86,11,14.9677a1,1,0,0,1-1.8.6c-2.8218-3.7623-5.3912-5.3463-9.2-5.5716V28a1,1,0,0,1-1,1ZM10.3016,16,18,25.238V20a1,1,0,0,1,1-1,12.7127,12.7127,0,0,1,9.8414,4.0909C28.0864,16.5553,24.6587,13,19,13a1,1,0,0,1-1-1V6.7618Z"
    })), _path218$8 || (_path218$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4639,28.9182,1.2318,16.64a1,1,0,0,1,0-1.28L11.4638,3.0792,13,4.36,3.3016,16,13,27.638Z"
    })), children);
  });
  var ReplyAll24 = /*#__PURE__*/React__default['default'].forwardRef(function ReplyAll24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$8 || (_path219$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,29a.9989.9989,0,0,1-.768-.36l-10-12a1,1,0,0,1,0-1.28l10-12A1,1,0,0,1,20,4v7.0325c7.0074.4629,11,5.86,11,14.9677a1,1,0,0,1-1.8.6c-2.8218-3.7623-5.3912-5.3463-9.2-5.5716V28a1,1,0,0,1-1,1ZM10.3016,16,18,25.238V20a1,1,0,0,1,1-1,12.7127,12.7127,0,0,1,9.8414,4.0909C28.0864,16.5553,24.6587,13,19,13a1,1,0,0,1-1-1V6.7618Z"
    })), _path220$8 || (_path220$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4639,28.9182,1.2318,16.64a1,1,0,0,1,0-1.28L11.4638,3.0792,13,4.36,3.3016,16,13,27.638Z"
    })), children);
  });
  var ReplyAll20 = /*#__PURE__*/React__default['default'].forwardRef(function ReplyAll20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$8 || (_path221$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,29a.9989.9989,0,0,1-.768-.36l-10-12a1,1,0,0,1,0-1.28l10-12A1,1,0,0,1,20,4v7.0325c7.0074.4629,11,5.86,11,14.9677a1,1,0,0,1-1.8.6c-2.8218-3.7623-5.3912-5.3463-9.2-5.5716V28a1,1,0,0,1-1,1ZM10.3016,16,18,25.238V20a1,1,0,0,1,1-1,12.7127,12.7127,0,0,1,9.8414,4.0909C28.0864,16.5553,24.6587,13,19,13a1,1,0,0,1-1-1V6.7618Z"
    })), _path222$8 || (_path222$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4639,28.9182,1.2318,16.64a1,1,0,0,1,0-1.28L11.4638,3.0792,13,4.36,3.3016,16,13,27.638Z"
    })), children);
  });
  var ReplyAll16 = /*#__PURE__*/React__default['default'].forwardRef(function ReplyAll16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$8 || (_path223$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,29a.9989.9989,0,0,1-.768-.36l-10-12a1,1,0,0,1,0-1.28l10-12A1,1,0,0,1,20,4v7.0325c7.0074.4629,11,5.86,11,14.9677a1,1,0,0,1-1.8.6c-2.8218-3.7623-5.3912-5.3463-9.2-5.5716V28a1,1,0,0,1-1,1ZM10.3016,16,18,25.238V20a1,1,0,0,1,1-1,12.7127,12.7127,0,0,1,9.8414,4.0909C28.0864,16.5553,24.6587,13,19,13a1,1,0,0,1-1-1V6.7618Z"
    })), _path224$8 || (_path224$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.4639,28.9182,1.2318,16.64a1,1,0,0,1,0-1.28L11.4638,3.0792,13,4.36,3.3016,16,13,27.638Z"
    })), children);
  });
  var Report32 = /*#__PURE__*/React__default['default'].forwardRef(function Report32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$8 || (_path225$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"
    })), _path226$8 || (_path226$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Report24 = /*#__PURE__*/React__default['default'].forwardRef(function Report24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$8 || (_path227$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"
    })), _path228$8 || (_path228$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Report20 = /*#__PURE__*/React__default['default'].forwardRef(function Report20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$8 || (_path229$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"
    })), _path230$8 || (_path230$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Report16 = /*#__PURE__*/React__default['default'].forwardRef(function Report16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$8 || (_path231$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"
    })), _path232$8 || (_path232$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var ReportData32 = /*#__PURE__*/React__default['default'].forwardRef(function ReportData32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$8 || (_path233$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"
    })), _path234$8 || (_path234$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var ReportData24 = /*#__PURE__*/React__default['default'].forwardRef(function ReportData24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$8 || (_path235$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"
    })), _path236$8 || (_path236$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var ReportData20 = /*#__PURE__*/React__default['default'].forwardRef(function ReportData20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$8 || (_path237$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"
    })), _path238$8 || (_path238$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var ReportData16 = /*#__PURE__*/React__default['default'].forwardRef(function ReportData16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$8 || (_path239$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"
    })), _path240$8 || (_path240$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var RequestQuote32 = /*#__PURE__*/React__default['default'].forwardRef(function RequestQuote32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$8 || (_path241$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"
    })), _path242$8 || (_path242$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"
    })), children);
  });
  var RequestQuote24 = /*#__PURE__*/React__default['default'].forwardRef(function RequestQuote24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$8 || (_path243$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"
    })), _path244$8 || (_path244$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"
    })), children);
  });
  var RequestQuote20 = /*#__PURE__*/React__default['default'].forwardRef(function RequestQuote20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$8 || (_path245$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"
    })), _path246$8 || (_path246$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"
    })), children);
  });
  var RequestQuote16 = /*#__PURE__*/React__default['default'].forwardRef(function RequestQuote16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$8 || (_path247$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"
    })), _path248$8 || (_path248$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"
    })), children);
  });
  var ResearchBlochSphere32 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchBlochSphere32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchBlochSphere32']) {
        didWarnAboutDeprecation$1['ResearchBlochSphere32'] = true;
        console.warn("The ResearchBlochSphere32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$8 || (_path249$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path250$8 || (_path250$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var ResearchBlochSphere24 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchBlochSphere24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchBlochSphere24']) {
        didWarnAboutDeprecation$1['ResearchBlochSphere24'] = true;
        console.warn("The ResearchBlochSphere24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$8 || (_path251$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path252$8 || (_path252$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var ResearchBlochSphere20 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchBlochSphere20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchBlochSphere20']) {
        didWarnAboutDeprecation$1['ResearchBlochSphere20'] = true;
        console.warn("The ResearchBlochSphere20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$8 || (_path253$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path254$8 || (_path254$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var ResearchBlochSphere16 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchBlochSphere16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchBlochSphere16']) {
        didWarnAboutDeprecation$1['ResearchBlochSphere16'] = true;
        console.warn("The ResearchBlochSphere16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$8 || (_path255$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"
    })), _path256$8 || (_path256$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"
    })), children);
  });
  var ResearchHintonPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchHintonPlot32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchHintonPlot32']) {
        didWarnAboutDeprecation$1['ResearchHintonPlot32'] = true;
        console.warn("The ResearchHintonPlot32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$8 || (_path257$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var ResearchHintonPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchHintonPlot24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchHintonPlot24']) {
        didWarnAboutDeprecation$1['ResearchHintonPlot24'] = true;
        console.warn("The ResearchHintonPlot24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$8 || (_path258$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var ResearchHintonPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchHintonPlot20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchHintonPlot20']) {
        didWarnAboutDeprecation$1['ResearchHintonPlot20'] = true;
        console.warn("The ResearchHintonPlot20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$8 || (_path259$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var ResearchHintonPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchHintonPlot16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchHintonPlot16']) {
        didWarnAboutDeprecation$1['ResearchHintonPlot16'] = true;
        console.warn("The ResearchHintonPlot16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$8 || (_path260$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"
    })), children);
  });
  var ResearchMatrix32 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchMatrix32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchMatrix32']) {
        didWarnAboutDeprecation$1['ResearchMatrix32'] = true;
        console.warn("The ResearchMatrix32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$8 || (_path261$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var ResearchMatrix24 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchMatrix24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchMatrix24']) {
        didWarnAboutDeprecation$1['ResearchMatrix24'] = true;
        console.warn("The ResearchMatrix24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$8 || (_path262$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var ResearchMatrix20 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchMatrix20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchMatrix20']) {
        didWarnAboutDeprecation$1['ResearchMatrix20'] = true;
        console.warn("The ResearchMatrix20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$8 || (_path263$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var ResearchMatrix16 = /*#__PURE__*/React__default['default'].forwardRef(function ResearchMatrix16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$8);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation$1['ResearchMatrix16']) {
        didWarnAboutDeprecation$1['ResearchMatrix16'] = true;
        console.warn("The ResearchMatrix16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$8 || (_path264$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1113 23.5 3.5 3.5 0 0116.5 20m0-2A5.5 5.5 0 1022 23.5 5.5 5.5 0 0016.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"
    })), children);
  });
  var Reset32 = /*#__PURE__*/React__default['default'].forwardRef(function Reset32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$8 || (_path265$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"
    })), children);
  });
  var Reset24 = /*#__PURE__*/React__default['default'].forwardRef(function Reset24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$8 || (_path266$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"
    })), children);
  });
  var Reset20 = /*#__PURE__*/React__default['default'].forwardRef(function Reset20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$8 || (_path267$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"
    })), children);
  });
  var Reset16 = /*#__PURE__*/React__default['default'].forwardRef(function Reset16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$8 || (_path268$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"
    })), children);
  });
  var ResetAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ResetAlt32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$8 || (_path269$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"
    })), children);
  });
  var ResetAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ResetAlt24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$8 || (_path270$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"
    })), children);
  });
  var ResetAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ResetAlt20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$8 || (_path271$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"
    })), children);
  });
  var ResetAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ResetAlt16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$8 || (_path272$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"
    })), children);
  });
  var Restart32 = /*#__PURE__*/React__default['default'].forwardRef(function Restart32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$8 || (_path273$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h6.1821l-3.5844,3.5854L20,13l6-6L20,1,18.5977,2.414,22.1851,6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var Restart24 = /*#__PURE__*/React__default['default'].forwardRef(function Restart24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$8 || (_path274$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h6.1821l-3.5844,3.5854L20,13l6-6L20,1,18.5977,2.414,22.1851,6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var Restart20 = /*#__PURE__*/React__default['default'].forwardRef(function Restart20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$8 || (_path275$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18A10,10,0,1,1,16,8h6.1821l-3.5844,3.5854L20,13l6-6L20,1,18.5977,2.414,22.1851,6H16A12,12,0,1,0,28,18Z"
    })), children);
  });
  var Restart16 = /*#__PURE__*/React__default['default'].forwardRef(function Restart16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$8 || (_path276$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,9c0,2.8-2.2,5-5,5s-5-2.2-5-5s2.2-5,5-5h3.1L9.3,5.8L10,6.5l3-3l-3-3L9.3,1.2L11.1,3H8C4.7,3,2,5.7,2,9s2.7,6,6,6\ts6-2.7,6-6H13z"
    })), children);
  });
  var Restaurant32 = /*#__PURE__*/React__default['default'].forwardRef(function Restaurant32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$8 || (_path277$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 2H11V12H9z"
    })), _path278$8 || (_path278$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11a4 4 0 01-8 0V2H4v9a6 6 0 005 5.91V30h2V16.91A6 6 0 0016 11V2H14zM22 2H21V30h2V20h3a2 2 0 002-2V8A5.78 5.78 0 0022 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"
    })), children);
  });
  var Restaurant24 = /*#__PURE__*/React__default['default'].forwardRef(function Restaurant24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$8 || (_path279$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 2H11V12H9z"
    })), _path280$8 || (_path280$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11a4 4 0 01-8 0V2H4v9a6 6 0 005 5.91V30h2V16.91A6 6 0 0016 11V2H14zM22 2H21V30h2V20h3a2 2 0 002-2V8A5.78 5.78 0 0022 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"
    })), children);
  });
  var Restaurant20 = /*#__PURE__*/React__default['default'].forwardRef(function Restaurant20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$8 || (_path281$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 2H11V12H9z"
    })), _path282$8 || (_path282$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11a4 4 0 01-8 0V2H4v9a6 6 0 005 5.91V30h2V16.91A6 6 0 0016 11V2H14zM22 2H21V30h2V20h3a2 2 0 002-2V8A5.78 5.78 0 0022 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"
    })), children);
  });
  var Restaurant16 = /*#__PURE__*/React__default['default'].forwardRef(function Restaurant16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$8 || (_path283$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 2H11V12H9z"
    })), _path284$8 || (_path284$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 11a4 4 0 01-8 0V2H4v9a6 6 0 005 5.91V30h2V16.91A6 6 0 0016 11V2H14zM22 2H21V30h2V20h3a2 2 0 002-2V8A5.78 5.78 0 0022 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"
    })), children);
  });
  var RestaurantFine32 = /*#__PURE__*/React__default['default'].forwardRef(function RestaurantFine32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$8 || (_path285$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.0005v-8a1 1 0 00-1-1H19a1 1 0 00-1 1v8A6.0039 6.0039 0 0023 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0030 11.0005zm-10 0V4h8v7.0005a4 4 0 11-8 0zM12 2v9.02a3.9644 3.9644 0 01-3.96 3.96A4.0052 4.0052 0 014 11.02V2H2v9.02a5.9888 5.9888 0 005 5.8652V30H9V16.8953A5.9646 5.9646 0 0014 11.02V2z"
    })), _path286$8 || (_path286$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 2H9V11.98H7z"
    })), children);
  });
  var RestaurantFine24 = /*#__PURE__*/React__default['default'].forwardRef(function RestaurantFine24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$8 || (_path287$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.0005v-8a1 1 0 00-1-1H19a1 1 0 00-1 1v8A6.0039 6.0039 0 0023 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0030 11.0005zm-10 0V4h8v7.0005a4 4 0 11-8 0zM12 2v9.02a3.9644 3.9644 0 01-3.96 3.96A4.0052 4.0052 0 014 11.02V2H2v9.02a5.9888 5.9888 0 005 5.8652V30H9V16.8953A5.9646 5.9646 0 0014 11.02V2z"
    })), _path288$8 || (_path288$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 2H9V11.98H7z"
    })), children);
  });
  var RestaurantFine20 = /*#__PURE__*/React__default['default'].forwardRef(function RestaurantFine20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$8 || (_path289$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.0005v-8a1 1 0 00-1-1H19a1 1 0 00-1 1v8A6.0039 6.0039 0 0023 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0030 11.0005zm-10 0V4h8v7.0005a4 4 0 11-8 0zM12 2v9.02a3.9644 3.9644 0 01-3.96 3.96A4.0052 4.0052 0 014 11.02V2H2v9.02a5.9888 5.9888 0 005 5.8652V30H9V16.8953A5.9646 5.9646 0 0014 11.02V2z"
    })), _path290$8 || (_path290$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 2H9V11.98H7z"
    })), children);
  });
  var RestaurantFine16 = /*#__PURE__*/React__default['default'].forwardRef(function RestaurantFine16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$8 || (_path291$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11.0005v-8a1 1 0 00-1-1H19a1 1 0 00-1 1v8A6.0039 6.0039 0 0023 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0030 11.0005zm-10 0V4h8v7.0005a4 4 0 11-8 0zM12 2v9.02a3.9644 3.9644 0 01-3.96 3.96A4.0052 4.0052 0 014 11.02V2H2v9.02a5.9888 5.9888 0 005 5.8652V30H9V16.8953A5.9646 5.9646 0 0014 11.02V2z"
    })), _path292$8 || (_path292$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 2H9V11.98H7z"
    })), children);
  });
  var Result32 = /*#__PURE__*/React__default['default'].forwardRef(function Result32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$8 || (_path293$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H22V25H14zM10 23H12V25H10zM14 18H22V20H14zM10 18H12V20H10zM14 13H22V15H14zM10 13H12V15H10z"
    })), _path294$8 || (_path294$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Result24 = /*#__PURE__*/React__default['default'].forwardRef(function Result24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$8 || (_path295$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H22V25H14zM10 23H12V25H10zM14 18H22V20H14zM10 18H12V20H10zM14 13H22V15H14zM10 13H12V15H10z"
    })), _path296$8 || (_path296$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Result20 = /*#__PURE__*/React__default['default'].forwardRef(function Result20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$8 || (_path297$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H22V25H14zM10 23H12V25H10zM14 18H22V20H14zM10 18H12V20H10zM14 13H22V15H14zM10 13H12V15H10z"
    })), _path298$8 || (_path298$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Result16 = /*#__PURE__*/React__default['default'].forwardRef(function Result16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$8 || (_path299$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H22V25H14zM10 23H12V25H10zM14 18H22V20H14zM10 18H12V20H10zM14 13H22V15H14zM10 13H12V15H10z"
    })), _path300$8 || (_path300$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var ResultNew32 = /*#__PURE__*/React__default['default'].forwardRef(function ResultNew32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$6 || (_circle7$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "26",
      r: "4"
    })), _path301$8 || (_path301$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM10 18H12V20H10zM10 23H12V25H10zM14 13H22V15H14zM14 18H22V20H14zM14 23H18V25H14z"
    })), _path302$8 || (_path302$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3V18h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H18V28ZM12,4h8V8H12Z"
    })), children);
  });
  var ResultNew24 = /*#__PURE__*/React__default['default'].forwardRef(function ResultNew24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$6 || (_circle8$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "26",
      r: "4"
    })), _path303$8 || (_path303$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM10 18H12V20H10zM10 23H12V25H10zM14 13H22V15H14zM14 18H22V20H14zM14 23H18V25H14z"
    })), _path304$8 || (_path304$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3V18h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H18V28ZM12,4h8V8H12Z"
    })), children);
  });
  var ResultNew20 = /*#__PURE__*/React__default['default'].forwardRef(function ResultNew20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$6 || (_circle9$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "26",
      r: "4"
    })), _path305$8 || (_path305$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM10 18H12V20H10zM10 23H12V25H10zM14 13H22V15H14zM14 18H22V20H14zM14 23H18V25H14z"
    })), _path306$8 || (_path306$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3V18h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H18V28ZM12,4h8V8H12Z"
    })), children);
  });
  var ResultNew16 = /*#__PURE__*/React__default['default'].forwardRef(function ResultNew16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$6 || (_circle10$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "26",
      r: "4"
    })), _path307$8 || (_path307$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM10 18H12V20H10zM10 23H12V25H10zM14 13H22V15H14zM14 18H22V20H14zM14 23H18V25H14z"
    })), _path308$8 || (_path308$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3V18h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H18V28ZM12,4h8V8H12Z"
    })), children);
  });
  var ResultOld32 = /*#__PURE__*/React__default['default'].forwardRef(function ResultOld32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$8 || (_path309$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM14 13H22V15H14zM10 18H12V20H10zM10 23H12V25H10z"
    })), _path310$8 || (_path310$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3v8h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h9V28ZM12,4h8V8H12Z"
    })), _path311$8 || (_path311$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,19v2.4131A6.996,6.996,0,1,1,24,32V30a5,5,0,1,0-4.5762-7H22v2H16V19Z"
    })), children);
  });
  var ResultOld24 = /*#__PURE__*/React__default['default'].forwardRef(function ResultOld24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$8 || (_path312$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM14 13H22V15H14zM10 18H12V20H10zM10 23H12V25H10z"
    })), _path313$8 || (_path313$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3v8h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h9V28ZM12,4h8V8H12Z"
    })), _path314$8 || (_path314$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,19v2.4131A6.996,6.996,0,1,1,24,32V30a5,5,0,1,0-4.5762-7H22v2H16V19Z"
    })), children);
  });
  var ResultOld20 = /*#__PURE__*/React__default['default'].forwardRef(function ResultOld20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$8 || (_path315$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM14 13H22V15H14zM10 18H12V20H10zM10 23H12V25H10z"
    })), _path316$8 || (_path316$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3v8h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h9V28ZM12,4h8V8H12Z"
    })), _path317$8 || (_path317$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,19v2.4131A6.996,6.996,0,1,1,24,32V30a5,5,0,1,0-4.5762-7H22v2H16V19Z"
    })), children);
  });
  var ResultOld16 = /*#__PURE__*/React__default['default'].forwardRef(function ResultOld16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$8 || (_path318$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 13H12V15H10zM14 13H22V15H14zM10 18H12V20H10zM10 23H12V25H10z"
    })), _path319$8 || (_path319$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,28V7h3v3H22V7h3v8h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h9V28ZM12,4h8V8H12Z"
    })), _path320$8 || (_path320$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,19v2.4131A6.996,6.996,0,1,1,24,32V30a5,5,0,1,0-4.5762-7H22v2H16V19Z"
    })), children);
  });
  var RetryFailed32 = /*#__PURE__*/React__default['default'].forwardRef(function RetryFailed32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$8 || (_path321$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25zM18 2A12.0351 12.0351 0 006 14v6.2L2.4 16.6 1 18l6 6 6-6-1.4-1.4L8 20.2V14a10 10 0 0120 0v3h2V14A12.0351 12.0351 0 0018 2z"
    })), children);
  });
  var RetryFailed24 = /*#__PURE__*/React__default['default'].forwardRef(function RetryFailed24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$8 || (_path322$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25zM18 2A12.0351 12.0351 0 006 14v6.2L2.4 16.6 1 18l6 6 6-6-1.4-1.4L8 20.2V14a10 10 0 0120 0v3h2V14A12.0351 12.0351 0 0018 2z"
    })), children);
  });
  var RetryFailed20 = /*#__PURE__*/React__default['default'].forwardRef(function RetryFailed20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$8 || (_path323$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25zM18 2A12.0351 12.0351 0 006 14v6.2L2.4 16.6 1 18l6 6 6-6-1.4-1.4L8 20.2V14a10 10 0 0120 0v3h2V14A12.0351 12.0351 0 0018 2z"
    })), children);
  });
  var RetryFailed16 = /*#__PURE__*/React__default['default'].forwardRef(function RetryFailed16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$8 || (_path324$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25zM18 2A12.0351 12.0351 0 006 14v6.2L2.4 16.6 1 18l6 6 6-6-1.4-1.4L8 20.2V14a10 10 0 0120 0v3h2V14A12.0351 12.0351 0 0018 2z"
    })), children);
  });
  var Review32 = /*#__PURE__*/React__default['default'].forwardRef(function Review32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$8 || (_path325$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.912 11.703 22 12.297 19 15 20 19 16 16.75 12 19 13 15 10 12.297 14.2 11.703 16 8z"
    })), _path326$8 || (_path326$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var Review24 = /*#__PURE__*/React__default['default'].forwardRef(function Review24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$8 || (_path327$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.912 11.703 22 12.297 19 15 20 19 16 16.75 12 19 13 15 10 12.297 14.2 11.703 16 8z"
    })), _path328$8 || (_path328$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var Review20 = /*#__PURE__*/React__default['default'].forwardRef(function Review20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$8 || (_path329$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.912 11.703 22 12.297 19 15 20 19 16 16.75 12 19 13 15 10 12.297 14.2 11.703 16 8z"
    })), _path330$8 || (_path330$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var Review16 = /*#__PURE__*/React__default['default'].forwardRef(function Review16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$8 || (_path331$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 8L17.912 11.703 22 12.297 19 15 20 19 16 16.75 12 19 13 15 10 12.297 14.2 11.703 16 8z"
    })), _path332$8 || (_path332$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"
    })), children);
  });
  var Rewind_1032 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_1032(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$8 || (_path333$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path334$8 || (_path334$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Rewind_1024 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_1024(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$8 || (_path335$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path336$8 || (_path336$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Rewind_1020 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_1020(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$8 || (_path337$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path338$8 || (_path338$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Rewind_1016 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_1016(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$8 || (_path339$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path340$8 || (_path340$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.63 22.13a2.84 2.84 0 01-1.28-.27 2.44 2.44 0 01-.89-.77 3.57 3.57 0 01-.52-1.25 7.69 7.69 0 01-.17-1.68 7.83 7.83 0 01.17-1.68 3.65 3.65 0 01.52-1.25 2.44 2.44 0 01.89-.77 2.84 2.84 0 011.28-.27 2.44 2.44 0 012.16 1 5.23 5.23 0 01.7 2.93 5.23 5.23 0 01-.7 2.93A2.44 2.44 0 0119.63 22.13zm0-1.22a1.07 1.07 0 001-.55A3.38 3.38 0 0021 18.85V17.47a3.31 3.31 0 00-.29-1.5 1.23 1.23 0 00-2.06 0 3.31 3.31 0 00-.29 1.5v1.38a3.38 3.38 0 00.29 1.51A1.06 1.06 0 0019.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"
    })), children);
  });
  var Rewind_3032 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_3032(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$8 || (_path341$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path342$8 || (_path342$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Rewind_3024 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_3024(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$8 || (_path343$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path344$8 || (_path344$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Rewind_3020 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_3020(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$8 || (_path345$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path346$8 || (_path346$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Rewind_3016 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_3016(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$8 || (_path347$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path348$8 || (_path348$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.64 22.13a2.81 2.81 0 01-1.28-.27 2.36 2.36 0 01-.89-.77A3.39 3.39 0 0117 19.84a7.12 7.12 0 01-.17-1.68A7.24 7.24 0 0117 16.48a3.46 3.46 0 01.52-1.25 2.36 2.36 0 01.89-.77 2.81 2.81 0 011.28-.27 2.44 2.44 0 012.16 1 5.31 5.31 0 01.7 2.93 5.31 5.31 0 01-.7 2.93A2.44 2.44 0 0119.64 22.13zm0-1.22a1 1 0 001-.55 3.24 3.24 0 00.3-1.51V17.47a3.17 3.17 0 00-.3-1.5 1.22 1.22 0 00-2.05 0 3.18 3.18 0 00-.29 1.5v1.38a3.25 3.25 0 00.29 1.51A1 1 0 0019.64 20.91zM12.62 17.42a1.46 1.46 0 001-.27.84.84 0 00.31-.68v-.08a.94.94 0 00-.3-.74 1.2 1.2 0 00-.83-.27 1.65 1.65 0 00-.89.24 2.1 2.1 0 00-.68.68l-.93-.83a5.37 5.37 0 01.44-.51 2.7 2.7 0 01.54-.4 2.55 2.55 0 01.7-.27 3.25 3.25 0 01.87-.1 3.94 3.94 0 011.06.14 2.33 2.33 0 01.82.4 1.91 1.91 0 01.54.63 1.87 1.87 0 01.18.83 2 2 0 01-.11.67 1.82 1.82 0 01-.32.52 1.79 1.79 0 01-.47.36 2.27 2.27 0 01-.57.2V18a2.34 2.34 0 01.63.21 1.7 1.7 0 01.51.38 1.89 1.89 0 01.34.55 2.07 2.07 0 01.12.73 2 2 0 01-.2.92 2 2 0 01-.58.72 2.66 2.66 0 01-.89.45 3.76 3.76 0 01-1.15.16 4.1 4.1 0 01-1-.11A3.1 3.1 0 0111 21.7a2.76 2.76 0 01-.56-.45A4.22 4.22 0 0110 20.7l1.07-.81a3.07 3.07 0 00.28.42 1.94 1.94 0 00.36.34 1.57 1.57 0 00.45.22 2 2 0 00.57.07 1.45 1.45 0 001-.3 1.12 1.12 0 00.34-.85v-.08a1 1 0 00-.37-.8 1.78 1.78 0 00-1.06-.28h-.76V17.42z"
    })), children);
  });
  var Rewind_532 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_532(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$8 || (_path349$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path350$8 || (_path350$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Rewind_524 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_524(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$8 || (_path351$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path352$8 || (_path352$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Rewind_520 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_520(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$8 || (_path353$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path354$8 || (_path354$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Rewind_516 = /*#__PURE__*/React__default['default'].forwardRef(function Rewind_516(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$7 || (_path355$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"
    })), _path356$7 || (_path356$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"
    })), children);
  });
  var Road32 = /*#__PURE__*/React__default['default'].forwardRef(function Road32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$7 || (_path357$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 13H19V15H13z"
    })), _path358$7 || (_path358$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409 8L24.1687 3.45A2.009 2.009 0 0022.2456 2H9.7544A2.0089 2.0089 0 007.8313 3.4507L6.5315 8H4v2H6v7a2.0025 2.0025 0 002 2v3h2V19H22v3h2V19a2.0025 2.0025 0 002-2V10h2V8zM9.7544 4H22.2458l1.4285 5H8.3257zM24 13H22v2h2v2H8V15h2V13H8V11H24zM2 16H4V30H2zM28 16H30V30H28z"
    })), _path359$7 || (_path359$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H17V24H15zM15 26H17V30H15z"
    })), children);
  });
  var Road24 = /*#__PURE__*/React__default['default'].forwardRef(function Road24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$7 || (_path360$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 13H19V15H13z"
    })), _path361$7 || (_path361$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409 8L24.1687 3.45A2.009 2.009 0 0022.2456 2H9.7544A2.0089 2.0089 0 007.8313 3.4507L6.5315 8H4v2H6v7a2.0025 2.0025 0 002 2v3h2V19H22v3h2V19a2.0025 2.0025 0 002-2V10h2V8zM9.7544 4H22.2458l1.4285 5H8.3257zM24 13H22v2h2v2H8V15h2V13H8V11H24zM2 16H4V30H2zM28 16H30V30H28z"
    })), _path362$7 || (_path362$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H17V24H15zM15 26H17V30H15z"
    })), children);
  });
  var Road20 = /*#__PURE__*/React__default['default'].forwardRef(function Road20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$7 || (_path363$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 13H19V15H13z"
    })), _path364$7 || (_path364$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409 8L24.1687 3.45A2.009 2.009 0 0022.2456 2H9.7544A2.0089 2.0089 0 007.8313 3.4507L6.5315 8H4v2H6v7a2.0025 2.0025 0 002 2v3h2V19H22v3h2V19a2.0025 2.0025 0 002-2V10h2V8zM9.7544 4H22.2458l1.4285 5H8.3257zM24 13H22v2h2v2H8V15h2V13H8V11H24zM2 16H4V30H2zM28 16H30V30H28z"
    })), _path365$7 || (_path365$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H17V24H15zM15 26H17V30H15z"
    })), children);
  });
  var Road16 = /*#__PURE__*/React__default['default'].forwardRef(function Road16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$7 || (_path366$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 13H19V15H13z"
    })), _path367$7 || (_path367$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.4409 8L24.1687 3.45A2.009 2.009 0 0022.2456 2H9.7544A2.0089 2.0089 0 007.8313 3.4507L6.5315 8H4v2H6v7a2.0025 2.0025 0 002 2v3h2V19H22v3h2V19a2.0025 2.0025 0 002-2V10h2V8zM9.7544 4H22.2458l1.4285 5H8.3257zM24 13H22v2h2v2H8V15h2V13H8V11H24zM2 16H4V30H2zM28 16H30V30H28z"
    })), _path368$7 || (_path368$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 21H17V24H15zM15 26H17V30H15z"
    })), children);
  });
  var RoadWeather32 = /*#__PURE__*/React__default['default'].forwardRef(function RoadWeather32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$7 || (_path369$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 31H14v-.228a3.0135 3.0135 0 00-1.9468-2.8091L8.5215 26.6384A3.9034 3.9034 0 016 23H8a1.8946 1.8946 0 001.2236 1.7659L12.7554 26.09A5.0226 5.0226 0 0116 30.772zM30 31H28v-.228a3.0135 3.0135 0 00-1.9468-2.8091l-3.5317-1.3245A3.9034 3.9034 0 0120 23h2a1.8946 1.8946 0 001.2236 1.7659L26.7554 26.09A5.0226 5.0226 0 0130 30.772zM11 13H17V15H11z"
    })), _path370$7 || (_path370$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4409,8,22.1687,3.45A2.009,2.009,0,0,0,20.2456,2H7.7544A2.0089,2.0089,0,0,0,5.8313,3.4507L4.5315,8H2v2H4v7a2.0025,2.0025,0,0,0,2,2v2H8V19H20v2h2V19a2.0025,2.0025,0,0,0,2-2V10h2V8ZM7.7544,4H20.2458l1.4285,5H6.3257ZM22,13H20v2h2v2H6V15H8V13H6V11H22Z"
    })), children);
  });
  var RoadWeather24 = /*#__PURE__*/React__default['default'].forwardRef(function RoadWeather24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$7 || (_path371$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 31H14v-.228a3.0135 3.0135 0 00-1.9468-2.8091L8.5215 26.6384A3.9034 3.9034 0 016 23H8a1.8946 1.8946 0 001.2236 1.7659L12.7554 26.09A5.0226 5.0226 0 0116 30.772zM30 31H28v-.228a3.0135 3.0135 0 00-1.9468-2.8091l-3.5317-1.3245A3.9034 3.9034 0 0120 23h2a1.8946 1.8946 0 001.2236 1.7659L26.7554 26.09A5.0226 5.0226 0 0130 30.772zM11 13H17V15H11z"
    })), _path372$7 || (_path372$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4409,8,22.1687,3.45A2.009,2.009,0,0,0,20.2456,2H7.7544A2.0089,2.0089,0,0,0,5.8313,3.4507L4.5315,8H2v2H4v7a2.0025,2.0025,0,0,0,2,2v2H8V19H20v2h2V19a2.0025,2.0025,0,0,0,2-2V10h2V8ZM7.7544,4H20.2458l1.4285,5H6.3257ZM22,13H20v2h2v2H6V15H8V13H6V11H22Z"
    })), children);
  });
  var RoadWeather20 = /*#__PURE__*/React__default['default'].forwardRef(function RoadWeather20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$7 || (_path373$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 31H14v-.228a3.0135 3.0135 0 00-1.9468-2.8091L8.5215 26.6384A3.9034 3.9034 0 016 23H8a1.8946 1.8946 0 001.2236 1.7659L12.7554 26.09A5.0226 5.0226 0 0116 30.772zM30 31H28v-.228a3.0135 3.0135 0 00-1.9468-2.8091l-3.5317-1.3245A3.9034 3.9034 0 0120 23h2a1.8946 1.8946 0 001.2236 1.7659L26.7554 26.09A5.0226 5.0226 0 0130 30.772zM11 13H17V15H11z"
    })), _path374$7 || (_path374$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4409,8,22.1687,3.45A2.009,2.009,0,0,0,20.2456,2H7.7544A2.0089,2.0089,0,0,0,5.8313,3.4507L4.5315,8H2v2H4v7a2.0025,2.0025,0,0,0,2,2v2H8V19H20v2h2V19a2.0025,2.0025,0,0,0,2-2V10h2V8ZM7.7544,4H20.2458l1.4285,5H6.3257ZM22,13H20v2h2v2H6V15H8V13H6V11H22Z"
    })), children);
  });
  var RoadWeather16 = /*#__PURE__*/React__default['default'].forwardRef(function RoadWeather16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375$7 || (_path375$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 31H14v-.228a3.0135 3.0135 0 00-1.9468-2.8091L8.5215 26.6384A3.9034 3.9034 0 016 23H8a1.8946 1.8946 0 001.2236 1.7659L12.7554 26.09A5.0226 5.0226 0 0116 30.772zM30 31H28v-.228a3.0135 3.0135 0 00-1.9468-2.8091l-3.5317-1.3245A3.9034 3.9034 0 0120 23h2a1.8946 1.8946 0 001.2236 1.7659L26.7554 26.09A5.0226 5.0226 0 0130 30.772zM11 13H17V15H11z"
    })), _path376$7 || (_path376$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4409,8,22.1687,3.45A2.009,2.009,0,0,0,20.2456,2H7.7544A2.0089,2.0089,0,0,0,5.8313,3.4507L4.5315,8H2v2H4v7a2.0025,2.0025,0,0,0,2,2v2H8V19H20v2h2V19a2.0025,2.0025,0,0,0,2-2V10h2V8ZM7.7544,4H20.2458l1.4285,5H6.3257ZM22,13H20v2h2v2H6V15H8V13H6V11H22Z"
    })), children);
  });
  var Roadmap32 = /*#__PURE__*/React__default['default'].forwardRef(function Roadmap32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$7 || (_path377$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0023 2.0023 0 01-2-2V24a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0112 30zM4 24v4h8V24zM28 20H12a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 20zM12 14v4H28V14zM16 10H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H16a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0116 10zM4 4V8H16V4z"
    })), children);
  });
  var Roadmap24 = /*#__PURE__*/React__default['default'].forwardRef(function Roadmap24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$7 || (_path378$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0023 2.0023 0 01-2-2V24a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0112 30zM4 24v4h8V24zM28 20H12a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 20zM12 14v4H28V14zM16 10H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H16a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0116 10zM4 4V8H16V4z"
    })), children);
  });
  var Roadmap20 = /*#__PURE__*/React__default['default'].forwardRef(function Roadmap20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$7 || (_path379$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0023 2.0023 0 01-2-2V24a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0112 30zM4 24v4h8V24zM28 20H12a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 20zM12 14v4H28V14zM16 10H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H16a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0116 10zM4 4V8H16V4z"
    })), children);
  });
  var Roadmap16 = /*#__PURE__*/React__default['default'].forwardRef(function Roadmap16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$7 || (_path380$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0023 2.0023 0 01-2-2V24a2.0023 2.0023 0 012-2h8a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0112 30zM4 24v4h8V24zM28 20H12a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2v4A2.0023 2.0023 0 0128 20zM12 14v4H28V14zM16 10H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H16a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0116 10zM4 4V8H16V4z"
    })), children);
  });
  var Rocket32 = /*#__PURE__*/React__default['default'].forwardRef(function Rocket32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$7 || (_path381$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.34 19H17.65V21H6.34z",
      transform: "rotate(-45 11.995 20.002)"
    })), _path382$7 || (_path382$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"
    })), children);
  });
  var Rocket24 = /*#__PURE__*/React__default['default'].forwardRef(function Rocket24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$7 || (_path383$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.34 19H17.65V21H6.34z",
      transform: "rotate(-45 11.995 20.002)"
    })), _path384$6 || (_path384$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"
    })), children);
  });
  var Rocket20 = /*#__PURE__*/React__default['default'].forwardRef(function Rocket20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$6 || (_path385$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.34 19H17.65V21H6.34z",
      transform: "rotate(-45 11.995 20.002)"
    })), _path386$6 || (_path386$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"
    })), children);
  });
  var Rocket16 = /*#__PURE__*/React__default['default'].forwardRef(function Rocket16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path387$6 || (_path387$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.34 19H17.65V21H6.34z",
      transform: "rotate(-45 11.995 20.002)"
    })), _path388$6 || (_path388$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"
    })), children);
  });
  var Rotate32 = /*#__PURE__*/React__default['default'].forwardRef(function Rotate32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path389$6 || (_path389$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.91 26.82l.35 2a12.9 12.9 0 004.24-1.54l-1-1.73A10.88 10.88 0 0117.91 26.82zM24.42 23.07L26 24.35a13 13 0 002.24-3.91l-1.87-.68A11 11 0 0124.42 23.07zM9.5 27.25a12.9 12.9 0 004.24 1.54l.35-2a10.88 10.88 0 01-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 006 24.35l.32-.26 1.22-1h0a11 11 0 01-1.91-3.31zM29 16a12.85 12.85 0 00-.8-4.44l-1.87.68A11.18 11.18 0 0127 16zM26 7.65a13 13 0 00-20 0V4H4v8h8V10H6.81A11 11 0 0124.42 8.93z"
    })), children);
  });
  var Rotate24 = /*#__PURE__*/React__default['default'].forwardRef(function Rotate24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$6 || (_path390$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.91 26.82l.35 2a12.9 12.9 0 004.24-1.54l-1-1.73A10.88 10.88 0 0117.91 26.82zM24.42 23.07L26 24.35a13 13 0 002.24-3.91l-1.87-.68A11 11 0 0124.42 23.07zM9.5 27.25a12.9 12.9 0 004.24 1.54l.35-2a10.88 10.88 0 01-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 006 24.35l.32-.26 1.22-1h0a11 11 0 01-1.91-3.31zM29 16a12.85 12.85 0 00-.8-4.44l-1.87.68A11.18 11.18 0 0127 16zM26 7.65a13 13 0 00-20 0V4H4v8h8V10H6.81A11 11 0 0124.42 8.93z"
    })), children);
  });
  var Rotate20 = /*#__PURE__*/React__default['default'].forwardRef(function Rotate20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$6 || (_path391$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.91 26.82l.35 2a12.9 12.9 0 004.24-1.54l-1-1.73A10.88 10.88 0 0117.91 26.82zM24.42 23.07L26 24.35a13 13 0 002.24-3.91l-1.87-.68A11 11 0 0124.42 23.07zM9.5 27.25a12.9 12.9 0 004.24 1.54l.35-2a10.88 10.88 0 01-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 006 24.35l.32-.26 1.22-1h0a11 11 0 01-1.91-3.31zM29 16a12.85 12.85 0 00-.8-4.44l-1.87.68A11.18 11.18 0 0127 16zM26 7.65a13 13 0 00-20 0V4H4v8h8V10H6.81A11 11 0 0124.42 8.93z"
    })), children);
  });
  var Rotate16 = /*#__PURE__*/React__default['default'].forwardRef(function Rotate16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$6 || (_path392$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.91 26.82l.35 2a12.9 12.9 0 004.24-1.54l-1-1.73A10.88 10.88 0 0117.91 26.82zM24.42 23.07L26 24.35a13 13 0 002.24-3.91l-1.87-.68A11 11 0 0124.42 23.07zM9.5 27.25a12.9 12.9 0 004.24 1.54l.35-2a10.88 10.88 0 01-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 006 24.35l.32-.26 1.22-1h0a11 11 0 01-1.91-3.31zM29 16a12.85 12.85 0 00-.8-4.44l-1.87.68A11.18 11.18 0 0127 16zM26 7.65a13 13 0 00-20 0V4H4v8h8V10H6.81A11 11 0 0124.42 8.93z"
    })), children);
  });
  var WatsonHealthRotate_18032 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_18032(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path393$6 || (_path393$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 01-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0014.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 01-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 007.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 01-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 003.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 01-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 001.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 005 16H3A12.9363 12.9363 0 016.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0126 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0016 5a11.1114 11.1114 0 00-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"
    })), children);
  });
  var WatsonHealthRotate_18024 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_18024(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$6 || (_path394$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 01-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0014.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 01-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 007.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 01-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 003.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 01-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 001.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 005 16H3A12.9363 12.9363 0 016.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0126 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0016 5a11.1114 11.1114 0 00-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"
    })), children);
  });
  var WatsonHealthRotate_18020 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_18020(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$6 || (_path395$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 01-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0014.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 01-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 007.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 01-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 003.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 01-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 001.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 005 16H3A12.9363 12.9363 0 016.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0126 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0016 5a11.1114 11.1114 0 00-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"
    })), children);
  });
  var WatsonHealthRotate_18016 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_18016(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$6 || (_path396$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 01-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0014.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 01-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 007.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 01-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 003.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 01-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 001.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 005 16H3A12.9363 12.9363 0 016.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0126 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0016 5a11.1114 11.1114 0 00-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"
    })), children);
  });
  var WatsonHealthRotate_36032 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_36032(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$6 || (_path397$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"
    })), children);
  });
  var WatsonHealthRotate_36024 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_36024(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$6 || (_path398$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"
    })), children);
  });
  var WatsonHealthRotate_36020 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_36020(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$5 || (_path399$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"
    })), children);
  });
  var WatsonHealthRotate_36016 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthRotate_36016(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$5 || (_path400$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"
    })), children);
  });
  var RotateClockwise32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwise32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$5 || (_path401$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwise24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwise24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$5 || (_path402$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwise20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwise20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$4 || (_path403$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwise16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwise16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$4 || (_path404$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwiseAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAlt32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$4 || (_path405$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAlt24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$4 || (_path406$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAlt20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$4 || (_path407$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAlt16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$4 || (_path408$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAltFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAltFilled32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$4 || (_path409$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAltFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAltFilled24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$4 || (_path410$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAltFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAltFilled20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$4 || (_path411$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseAltFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseAltFilled16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$4 || (_path412$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H4a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0116 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 00-7-7H14V6h5a5.0057 5.0057 0 015 5v5.17l-2.59-2.58L20 15l5 5z"
    })), children);
  });
  var RotateClockwiseFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseFilled32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$4 || (_path413$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwiseFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseFilled24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$4 || (_path414$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwiseFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseFilled20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$3 || (_path415$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateClockwiseFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateClockwiseFilled16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path416$2 || (_path416$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 30H16a2.0023 2.0023 0 01-2-2V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 00-7 7v5H6V13a5.0057 5.0057 0 015-5h5.17l-2.58 2.59L15 12l5-5z"
    })), children);
  });
  var RotateCounterclockwise32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwise32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path417$2 || (_path417$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwise24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwise24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path418$2 || (_path418$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwise20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwise20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path419$2 || (_path419$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwise16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwise16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path420$2 || (_path420$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwiseAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAlt32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$2 || (_path421$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAlt24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path422$2 || (_path422$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAlt20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path423$2 || (_path423$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAlt16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path424$2 || (_path424$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });

  var _path$8, _path2$8, _path3$8, _path4$8, _path5$8, _path6$8, _path7$8, _path8$8, _path9$8, _path10$8, _path11$8, _path12$8, _path13$8, _path14$8, _path15$8, _path16$8, _circle$7, _path17$8, _path18$8, _circle2$7, _path19$8, _path20$8, _circle3$7, _path21$8, _path22$8, _circle4$6, _path23$8, _path24$8, _path25$8, _path26$8, _path27$8, _path28$8, _path29$8, _path30$8, _path31$8, _path32$8, _path33$8, _path34$8, _path35$8, _path36$8, _path37$8, _path38$8, _path39$8, _path40$8, _path41$8, _path42$8, _path43$8, _path44$8, _path45$8, _path46$8, _path47$8, _path48$8, _path49$8, _path50$8, _path51$8, _path52$8, _path53$8, _path54$8, _path55$8, _path56$8, _path57$8, _path58$8, _path59$8, _path60$8, _path61$8, _path62$8, _path63$8, _path64$8, _path65$8, _path66$8, _path67$8, _path68$8, _path69$8, _path70$8, _path71$8, _path72$8, _path73$8, _path74$8, _path75$8, _path76$8, _path77$8, _path78$8, _path79$8, _path80$8, _path81$8, _path82$8, _path83$8, _path84$8, _path85$8, _path86$8, _path87$8, _path88$8, _path89$8, _path90$8, _path91$8, _path92$8, _path93$8, _path94$8, _path95$8, _path96$8, _path97$8, _path98$8, _path99$8, _path100$8, _path101$8, _path102$8, _path103$8, _path104$8, _path105$8, _path106$8, _path107$8, _path108$8, _path109$8, _path110$8, _path111$8, _path112$8, _path113$8, _path114$8, _path115$8, _path116$8, _path117$8, _path118$8, _path119$8, _path120$8, _path121$8, _path122$8, _path123$8, _path124$8, _path125$8, _path126$8, _path127$8, _path128$8, _path129$8, _path130$8, _path131$8, _path132$8, _path133$8, _path134$8, _path135$8, _path136$8, _path137$8, _path138$8, _path139$8, _path140$8, _path141$8, _path142$8, _path143$8, _path144$8, _path145$8, _path146$8, _path147$8, _path148$8, _path149$8, _path150$8, _path151$8, _path152$8, _path153$8, _path154$8, _path155$8, _path156$8, _path157$8, _path158$8, _path159$8, _path160$8, _path161$8, _path162$8, _path163$8, _path164$8, _path165$8, _path166$8, _path167$8, _path168$8, _path169$8, _path170$8, _path171$8, _path172$8, _path173$8, _path174$8, _path175$8, _path176$8, _path177$7, _path178$7, _path179$7, _path180$7, _path181$7, _path182$7, _path183$7, _path184$7, _path185$7, _path186$7, _path187$7, _path188$7, _path189$7, _path190$7, _path191$7, _path192$7, _path193$7, _path194$7, _path195$7, _path196$7, _path197$7, _path198$7, _path199$7, _path200$7, _path201$7, _path202$7, _path203$7, _path204$7, _path205$7, _path206$7, _path207$7, _path208$7, _path209$7, _path210$7, _path211$7, _path212$7, _path213$7, _path214$7, _path215$7, _path216$7, _path217$7, _path218$7, _path219$7, _path220$7, _path221$7, _path222$7, _path223$7, _path224$7, _path225$7, _path226$7, _path227$7, _path228$7, _path229$7, _path230$7, _path231$7, _path232$7, _path233$7, _path234$7, _path235$7, _path236$7, _path237$7, _path238$7, _path239$7, _path240$7, _path241$7, _path242$7, _path243$7, _path244$7, _path245$7, _path246$7, _path247$7, _path248$7, _path249$7, _path250$7, _path251$7, _path252$7, _path253$7, _path254$7, _path255$7, _path256$7, _path257$7, _path258$7, _path259$7, _path260$7, _circle5$5, _circle6$5, _circle7$5, _path261$7, _circle8$5, _circle9$5, _circle10$5, _path262$7, _circle11$5, _circle12$5, _circle13$5, _path263$7, _circle14$5, _circle15$5, _circle16$5, _path264$7, _path265$7, _path266$7, _path267$7, _path268$7, _path269$7, _path270$7, _path271$7, _path272$7, _path273$7, _path274$7, _path275$7, _path276$7, _path277$7, _path278$7, _path279$7, _path280$7, _path281$7, _path282$7, _path283$7, _path284$7, _path285$7, _path286$7, _path287$7, _path288$7, _path289$7, _path290$7, _path291$7, _path292$7, _path293$7, _path294$7, _path295$7, _path296$7, _path297$7, _path298$7, _path299$7, _path300$7, _path301$7, _path302$7, _path303$7, _path304$7, _path305$7, _path306$7, _path307$7, _path308$7, _path309$7, _path310$7, _path311$7, _path312$7, _path313$7, _path314$7, _path315$7, _path316$7, _path317$7, _path318$7, _path319$7, _path320$7, _path321$7, _path322$7, _path323$7, _path324$7, _path325$7, _path326$7, _path327$7, _path328$7, _path329$7, _path330$7, _path331$7, _path332$7, _path333$7, _path334$7, _path335$7, _path336$7, _path337$7, _path338$7, _path339$7, _path340$7, _path341$7, _path342$7, _path343$7, _path344$7, _path345$7, _path346$7, _path347$7, _path348$7, _path349$7, _path350$7, _path351$7, _path352$7, _path353$7, _path354$7;

  var _excluded$8 = ["children"],
      _excluded2$8 = ["children"],
      _excluded3$8 = ["children"],
      _excluded4$8 = ["children"],
      _excluded5$8 = ["children"],
      _excluded6$8 = ["children"],
      _excluded7$8 = ["children"],
      _excluded8$8 = ["children"],
      _excluded9$8 = ["children"],
      _excluded10$8 = ["children"],
      _excluded11$8 = ["children"],
      _excluded12$8 = ["children"],
      _excluded13$8 = ["children"],
      _excluded14$8 = ["children"],
      _excluded15$8 = ["children"],
      _excluded16$8 = ["children"],
      _excluded17$8 = ["children"],
      _excluded18$8 = ["children"],
      _excluded19$8 = ["children"],
      _excluded20$8 = ["children"],
      _excluded21$8 = ["children"],
      _excluded22$8 = ["children"],
      _excluded23$8 = ["children"],
      _excluded24$8 = ["children"],
      _excluded25$8 = ["children"],
      _excluded26$8 = ["children"],
      _excluded27$8 = ["children"],
      _excluded28$8 = ["children"],
      _excluded29$8 = ["children"],
      _excluded30$8 = ["children"],
      _excluded31$8 = ["children"],
      _excluded32$8 = ["children"],
      _excluded33$8 = ["children"],
      _excluded34$8 = ["children"],
      _excluded35$8 = ["children"],
      _excluded36$8 = ["children"],
      _excluded37$8 = ["children"],
      _excluded38$8 = ["children"],
      _excluded39$8 = ["children"],
      _excluded40$8 = ["children"],
      _excluded41$8 = ["children"],
      _excluded42$8 = ["children"],
      _excluded43$8 = ["children"],
      _excluded44$8 = ["children"],
      _excluded45$8 = ["children"],
      _excluded46$8 = ["children"],
      _excluded47$8 = ["children"],
      _excluded48$8 = ["children"],
      _excluded49$8 = ["children"],
      _excluded50$8 = ["children"],
      _excluded51$8 = ["children"],
      _excluded52$8 = ["children"],
      _excluded53$8 = ["children"],
      _excluded54$8 = ["children"],
      _excluded55$8 = ["children"],
      _excluded56$8 = ["children"],
      _excluded57$8 = ["children"],
      _excluded58$8 = ["children"],
      _excluded59$8 = ["children"],
      _excluded60$8 = ["children"],
      _excluded61$8 = ["children"],
      _excluded62$8 = ["children"],
      _excluded63$8 = ["children"],
      _excluded64$8 = ["children"],
      _excluded65$8 = ["children"],
      _excluded66$8 = ["children"],
      _excluded67$8 = ["children"],
      _excluded68$8 = ["children"],
      _excluded69$8 = ["children"],
      _excluded70$8 = ["children"],
      _excluded71$8 = ["children"],
      _excluded72$8 = ["children"],
      _excluded73$8 = ["children"],
      _excluded74$8 = ["children"],
      _excluded75$8 = ["children"],
      _excluded76$8 = ["children"],
      _excluded77$8 = ["children"],
      _excluded78$8 = ["children"],
      _excluded79$8 = ["children"],
      _excluded80$8 = ["children"],
      _excluded81$8 = ["children"],
      _excluded82$8 = ["children"],
      _excluded83$8 = ["children"],
      _excluded84$8 = ["children"],
      _excluded85$8 = ["children"],
      _excluded86$8 = ["children"],
      _excluded87$8 = ["children"],
      _excluded88$8 = ["children"],
      _excluded89$8 = ["children"],
      _excluded90$8 = ["children"],
      _excluded91$8 = ["children"],
      _excluded92$8 = ["children"],
      _excluded93$8 = ["children"],
      _excluded94$8 = ["children"],
      _excluded95$8 = ["children"],
      _excluded96$8 = ["children"],
      _excluded97$8 = ["children"],
      _excluded98$8 = ["children"],
      _excluded99$8 = ["children"],
      _excluded100$8 = ["children"],
      _excluded101$8 = ["children"],
      _excluded102$8 = ["children"],
      _excluded103$8 = ["children"],
      _excluded104$8 = ["children"],
      _excluded105$8 = ["children"],
      _excluded106$8 = ["children"],
      _excluded107$8 = ["children"],
      _excluded108$8 = ["children"],
      _excluded109$8 = ["children"],
      _excluded110$8 = ["children"],
      _excluded111$8 = ["children"],
      _excluded112$8 = ["children"],
      _excluded113$8 = ["children"],
      _excluded114$8 = ["children"],
      _excluded115$8 = ["children"],
      _excluded116$8 = ["children"],
      _excluded117$8 = ["children"],
      _excluded118$8 = ["children"],
      _excluded119$7 = ["children"],
      _excluded120$7 = ["children"],
      _excluded121$7 = ["children"],
      _excluded122$7 = ["children"],
      _excluded123$7 = ["children"],
      _excluded124$7 = ["children"],
      _excluded125$7 = ["children"],
      _excluded126$7 = ["children"],
      _excluded127$7 = ["children"],
      _excluded128$7 = ["children"],
      _excluded129$7 = ["children"],
      _excluded130$7 = ["children"],
      _excluded131$7 = ["children"],
      _excluded132$7 = ["children"],
      _excluded133$7 = ["children"],
      _excluded134$7 = ["children"],
      _excluded135$7 = ["children"],
      _excluded136$7 = ["children"],
      _excluded137$7 = ["children"],
      _excluded138$7 = ["children"],
      _excluded139$7 = ["children"],
      _excluded140$7 = ["children"],
      _excluded141$7 = ["children"],
      _excluded142$7 = ["children"],
      _excluded143$7 = ["children"],
      _excluded144$7 = ["children"],
      _excluded145$7 = ["children"],
      _excluded146$7 = ["children"],
      _excluded147$7 = ["children"],
      _excluded148$7 = ["children"],
      _excluded149$7 = ["children"],
      _excluded150$7 = ["children"],
      _excluded151$7 = ["children"],
      _excluded152$7 = ["children"],
      _excluded153$7 = ["children"],
      _excluded154$7 = ["children"],
      _excluded155$7 = ["children"],
      _excluded156$7 = ["children"],
      _excluded157$7 = ["children"],
      _excluded158$7 = ["children"],
      _excluded159$7 = ["children"],
      _excluded160$7 = ["children"],
      _excluded161$7 = ["children"],
      _excluded162$7 = ["children"],
      _excluded163$7 = ["children"],
      _excluded164$7 = ["children"],
      _excluded165$7 = ["children"],
      _excluded166$7 = ["children"],
      _excluded167$7 = ["children"],
      _excluded168$7 = ["children"],
      _excluded169$7 = ["children"],
      _excluded170$7 = ["children"],
      _excluded171$7 = ["children"],
      _excluded172$7 = ["children"],
      _excluded173$7 = ["children"],
      _excluded174$7 = ["children"],
      _excluded175$7 = ["children"],
      _excluded176$7 = ["children"],
      _excluded177$7 = ["children"],
      _excluded178$7 = ["children"],
      _excluded179$7 = ["children"],
      _excluded180$7 = ["children"],
      _excluded181$7 = ["children"],
      _excluded182$7 = ["children"],
      _excluded183$7 = ["children"],
      _excluded184$7 = ["children"],
      _excluded185$7 = ["children"],
      _excluded186$7 = ["children"],
      _excluded187$7 = ["children"],
      _excluded188$7 = ["children"],
      _excluded189$7 = ["children"],
      _excluded190$7 = ["children"],
      _excluded191$7 = ["children"],
      _excluded192$7 = ["children"],
      _excluded193$7 = ["children"],
      _excluded194$7 = ["children"],
      _excluded195$7 = ["children"],
      _excluded196$7 = ["children"],
      _excluded197$7 = ["children"],
      _excluded198$7 = ["children"],
      _excluded199$7 = ["children"],
      _excluded200$7 = ["children"],
      _excluded201$7 = ["children"],
      _excluded202$7 = ["children"],
      _excluded203$7 = ["children"],
      _excluded204$7 = ["children"],
      _excluded205$7 = ["children"],
      _excluded206$7 = ["children"],
      _excluded207$7 = ["children"],
      _excluded208$7 = ["children"],
      _excluded209$7 = ["children"],
      _excluded210$7 = ["children"],
      _excluded211$7 = ["children"],
      _excluded212$7 = ["children"],
      _excluded213$7 = ["children"],
      _excluded214$7 = ["children"],
      _excluded215$7 = ["children"],
      _excluded216$7 = ["children"],
      _excluded217$7 = ["children"],
      _excluded218$7 = ["children"],
      _excluded219$7 = ["children"],
      _excluded220$7 = ["children"],
      _excluded221$7 = ["children"],
      _excluded222$7 = ["children"],
      _excluded223$7 = ["children"],
      _excluded224$7 = ["children"],
      _excluded225$7 = ["children"],
      _excluded226$7 = ["children"],
      _excluded227$7 = ["children"],
      _excluded228$7 = ["children"],
      _excluded229$7 = ["children"],
      _excluded230$7 = ["children"],
      _excluded231$7 = ["children"],
      _excluded232$7 = ["children"],
      _excluded233$7 = ["children"],
      _excluded234$7 = ["children"],
      _excluded235$7 = ["children"],
      _excluded236$7 = ["children"],
      _excluded237$7 = ["children"],
      _excluded238$7 = ["children"],
      _excluded239$7 = ["children"],
      _excluded240$7 = ["children"],
      _excluded241$7 = ["children"],
      _excluded242$7 = ["children"],
      _excluded243$7 = ["children"],
      _excluded244$7 = ["children"],
      _excluded245$7 = ["children"],
      _excluded246$7 = ["children"],
      _excluded247$7 = ["children"],
      _excluded248$7 = ["children"],
      _excluded249$7 = ["children"],
      _excluded250$7 = ["children"];
  var RotateCounterclockwiseAltFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAltFilled32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$8 || (_path$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseAltFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAltFilled24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$8 || (_path2$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseAltFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAltFilled20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$8 || (_path3$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseAltFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseAltFilled16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$8 || (_path4$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 28V16a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H16A2.0023 2.0023 0 0114 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 017-7h5V6H13a5.0057 5.0057 0 00-5 5v5.17l2.59-2.58L12 15 7 20z"
    })), children);
  });
  var RotateCounterclockwiseFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseFilled32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$8 || (_path5$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwiseFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseFilled24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$8 || (_path6$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwiseFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseFilled20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$8 || (_path7$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var RotateCounterclockwiseFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function RotateCounterclockwiseFilled16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$8 || (_path8$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28V16a2.0023 2.0023 0 012-2H16a2.0023 2.0023 0 012 2V28a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 017 7v5H26V13a5.0057 5.0057 0 00-5-5H15.83l2.58 2.59L17 12 12 7z"
    })), children);
  });
  var Router32 = /*#__PURE__*/React__default['default'].forwardRef(function Router32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$8 || (_path9$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 7L16 2 11 7 12.409 8.419 15 5.847 15 13 17 13 17 5.794 19.591 8.419 21 7zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var Router24 = /*#__PURE__*/React__default['default'].forwardRef(function Router24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$8 || (_path10$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 7L16 2 11 7 12.409 8.419 15 5.847 15 13 17 13 17 5.794 19.591 8.419 21 7zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var Router20 = /*#__PURE__*/React__default['default'].forwardRef(function Router20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$8 || (_path11$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 7L16 2 11 7 12.409 8.419 15 5.847 15 13 17 13 17 5.794 19.591 8.419 21 7zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var Router16 = /*#__PURE__*/React__default['default'].forwardRef(function Router16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$8 || (_path12$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 7L16 2 11 7 12.409 8.419 15 5.847 15 13 17 13 17 5.794 19.591 8.419 21 7zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var RouterVoice32 = /*#__PURE__*/React__default['default'].forwardRef(function RouterVoice32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$8 || (_path13$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11zM12.4289 5.8227v1.63a1.1269 1.1269 0 01-.6767 1.026l-1.39.5967A1.1218 1.1218 0 019.14 8.8424L7.3208 7.0233a1.1165 1.1165 0 01.0125-1.579l.0348-.0328c7.393-6.527 14.6913-2.0374 17.2127-.0473a1.1166 1.1166 0 01.1746 1.5693 1.1011 1.1011 0 01-.0873.0971L22.9108 8.7878a1.1114 1.1114 0 01-1.2225.2329l-1.39-.5967a1.1112 1.1112 0 01-.68-1.0223v-1.63S15.9726 3.0648 12.4289 5.8227z"
    })), children);
  });
  var RouterVoice24 = /*#__PURE__*/React__default['default'].forwardRef(function RouterVoice24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$8 || (_path14$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11zM12.4289 5.8227v1.63a1.1269 1.1269 0 01-.6767 1.026l-1.39.5967A1.1218 1.1218 0 019.14 8.8424L7.3208 7.0233a1.1165 1.1165 0 01.0125-1.579l.0348-.0328c7.393-6.527 14.6913-2.0374 17.2127-.0473a1.1166 1.1166 0 01.1746 1.5693 1.1011 1.1011 0 01-.0873.0971L22.9108 8.7878a1.1114 1.1114 0 01-1.2225.2329l-1.39-.5967a1.1112 1.1112 0 01-.68-1.0223v-1.63S15.9726 3.0648 12.4289 5.8227z"
    })), children);
  });
  var RouterVoice20 = /*#__PURE__*/React__default['default'].forwardRef(function RouterVoice20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$8 || (_path15$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11zM12.4289 5.8227v1.63a1.1269 1.1269 0 01-.6767 1.026l-1.39.5967A1.1218 1.1218 0 019.14 8.8424L7.3208 7.0233a1.1165 1.1165 0 01.0125-1.579l.0348-.0328c7.393-6.527 14.6913-2.0374 17.2127-.0473a1.1166 1.1166 0 01.1746 1.5693 1.1011 1.1011 0 01-.0873.0971L22.9108 8.7878a1.1114 1.1114 0 01-1.2225.2329l-1.39-.5967a1.1112 1.1112 0 01-.68-1.0223v-1.63S15.9726 3.0648 12.4289 5.8227z"
    })), children);
  });
  var RouterVoice16 = /*#__PURE__*/React__default['default'].forwardRef(function RouterVoice16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$8 || (_path16$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11zM12.4289 5.8227v1.63a1.1269 1.1269 0 01-.6767 1.026l-1.39.5967A1.1218 1.1218 0 019.14 8.8424L7.3208 7.0233a1.1165 1.1165 0 01.0125-1.579l.0348-.0328c7.393-6.527 14.6913-2.0374 17.2127-.0473a1.1166 1.1166 0 01.1746 1.5693 1.1011 1.1011 0 01-.0873.0971L22.9108 8.7878a1.1114 1.1114 0 01-1.2225.2329l-1.39-.5967a1.1112 1.1112 0 01-.68-1.0223v-1.63S15.9726 3.0648 12.4289 5.8227z"
    })), children);
  });
  var RouterWifi32 = /*#__PURE__*/React__default['default'].forwardRef(function RouterWifi32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$7 || (_circle$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13.5",
      r: "1.5"
    })), _path17$8 || (_path17$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356,10.4648a5,5,0,0,0-7.0717,0L11.05,9.0508a6.9992,6.9992,0,0,1,9.9,0Z"
    })), _path18$8 || (_path18$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.0713 6.929a10 10 0 00-14.1426 0L7.5146 5.5144a12.0011 12.0011 0 0116.9708 0zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var RouterWifi24 = /*#__PURE__*/React__default['default'].forwardRef(function RouterWifi24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle2$7 || (_circle2$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13.5",
      r: "1.5"
    })), _path19$8 || (_path19$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356,10.4648a5,5,0,0,0-7.0717,0L11.05,9.0508a6.9992,6.9992,0,0,1,9.9,0Z"
    })), _path20$8 || (_path20$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.0713 6.929a10 10 0 00-14.1426 0L7.5146 5.5144a12.0011 12.0011 0 0116.9708 0zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var RouterWifi20 = /*#__PURE__*/React__default['default'].forwardRef(function RouterWifi20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$7 || (_circle3$7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13.5",
      r: "1.5"
    })), _path21$8 || (_path21$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356,10.4648a5,5,0,0,0-7.0717,0L11.05,9.0508a6.9992,6.9992,0,0,1,9.9,0Z"
    })), _path22$8 || (_path22$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.0713 6.929a10 10 0 00-14.1426 0L7.5146 5.5144a12.0011 12.0011 0 0116.9708 0zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var RouterWifi16 = /*#__PURE__*/React__default['default'].forwardRef(function RouterWifi16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$6 || (_circle4$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13.5",
      r: "1.5"
    })), _path23$8 || (_path23$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5356,10.4648a5,5,0,0,0-7.0717,0L11.05,9.0508a6.9992,6.9992,0,0,1,9.9,0Z"
    })), _path24$8 || (_path24$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.0713 6.929a10 10 0 00-14.1426 0L7.5146 5.5144a12.0011 12.0011 0 0116.9708 0zM21 25L16 30 11 25 12.409 23.581 15 26.153 15 19 17 19 17 26.206 19.591 23.581 21 25zM24 11L19 16 24 21 25.419 19.591 22.847 17 30 17 30 15 22.794 15 25.419 12.409 24 11zM8 11L13 16 8 21 6.581 19.591 9.153 17 2 17 2 15 9.206 15 6.581 12.409 8 11z"
    })), children);
  });
  var Row32 = /*#__PURE__*/React__default['default'].forwardRef(function Row32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$8 || (_path25$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 00-2-2H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2zM4 6H28V8H4z"
    })), children);
  });
  var Row24 = /*#__PURE__*/React__default['default'].forwardRef(function Row24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$8 || (_path26$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 00-2-2H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2zM4 6H28V8H4z"
    })), children);
  });
  var Row20 = /*#__PURE__*/React__default['default'].forwardRef(function Row20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$8 || (_path27$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 00-2-2H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2zM4 6H28V8H4z"
    })), children);
  });
  var Row16 = /*#__PURE__*/React__default['default'].forwardRef(function Row16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$8 || (_path28$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 00-2-2H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2zM4 6H28V8H4z"
    })), children);
  });
  var RowCollapse32 = /*#__PURE__*/React__default['default'].forwardRef(function RowCollapse32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$8 || (_path29$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V22A2 2 0 0026 20zm0 6H6V22H26zM17 7.828L19.586 10.414 21 9 16 4 11 9 12.414 10.414 15 7.828 15 14 4 14 4 16 28 16 28 14 17 14 17 7.828z"
    })), children);
  });
  var RowCollapse24 = /*#__PURE__*/React__default['default'].forwardRef(function RowCollapse24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$8 || (_path30$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V22A2 2 0 0026 20zm0 6H6V22H26zM17 7.828L19.586 10.414 21 9 16 4 11 9 12.414 10.414 15 7.828 15 14 4 14 4 16 28 16 28 14 17 14 17 7.828z"
    })), children);
  });
  var RowCollapse20 = /*#__PURE__*/React__default['default'].forwardRef(function RowCollapse20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$8 || (_path31$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V22A2 2 0 0026 20zm0 6H6V22H26zM17 7.828L19.586 10.414 21 9 16 4 11 9 12.414 10.414 15 7.828 15 14 4 14 4 16 28 16 28 14 17 14 17 7.828z"
    })), children);
  });
  var RowCollapse16 = /*#__PURE__*/React__default['default'].forwardRef(function RowCollapse16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$8 || (_path32$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 20H6a2 2 0 00-2 2v4a2 2 0 002 2H26a2 2 0 002-2V22A2 2 0 0026 20zm0 6H6V22H26zM17 7.828L19.586 10.414 21 9 16 4 11 9 12.414 10.414 15 7.828 15 14 4 14 4 16 28 16 28 14 17 14 17 7.828z"
    })), children);
  });
  var RowDelete32 = /*#__PURE__*/React__default['default'].forwardRef(function RowDelete32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$8 || (_path33$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0124 30zM4 22H3.9985L4 28H24V22zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path34$8 || (_path34$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,14V8H18V6H4A2.0023,2.0023,0,0,0,2,8v6a2.0023,2.0023,0,0,0,2,2H26V14Z"
    })), children);
  });
  var RowDelete24 = /*#__PURE__*/React__default['default'].forwardRef(function RowDelete24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$8 || (_path35$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0124 30zM4 22H3.9985L4 28H24V22zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path36$8 || (_path36$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,14V8H18V6H4A2.0023,2.0023,0,0,0,2,8v6a2.0023,2.0023,0,0,0,2,2H26V14Z"
    })), children);
  });
  var RowDelete20 = /*#__PURE__*/React__default['default'].forwardRef(function RowDelete20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$8 || (_path37$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0124 30zM4 22H3.9985L4 28H24V22zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path38$8 || (_path38$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,14V8H18V6H4A2.0023,2.0023,0,0,0,2,8v6a2.0023,2.0023,0,0,0,2,2H26V14Z"
    })), children);
  });
  var RowDelete16 = /*#__PURE__*/React__default['default'].forwardRef(function RowDelete16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$8 || (_path39$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H24a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0124 30zM4 22H3.9985L4 28H24V22zM30 3.41L28.59 2 25 5.59 21.41 2 20 3.41 23.59 7 20 10.59 21.41 12 25 8.41 28.59 12 30 10.59 26.41 7 30 3.41z"
    })), _path40$8 || (_path40$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,14V8H18V6H4A2.0023,2.0023,0,0,0,2,8v6a2.0023,2.0023,0,0,0,2,2H26V14Z"
    })), children);
  });
  var RowExpand32 = /*#__PURE__*/React__default['default'].forwardRef(function RowExpand32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$8 || (_path41$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L15 18 15 24.172 12.414 21.586 11 23 16 28 21 23 19.586 21.586 17 24.172 17 18 28 18 28 16 4 16 4 18zM26 4H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6A2 2 0 0026 4zm0 6H6V6H26z"
    })), children);
  });
  var RowExpand24 = /*#__PURE__*/React__default['default'].forwardRef(function RowExpand24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$8 || (_path42$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L15 18 15 24.172 12.414 21.586 11 23 16 28 21 23 19.586 21.586 17 24.172 17 18 28 18 28 16 4 16 4 18zM26 4H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6A2 2 0 0026 4zm0 6H6V6H26z"
    })), children);
  });
  var RowExpand20 = /*#__PURE__*/React__default['default'].forwardRef(function RowExpand20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$8 || (_path43$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L15 18 15 24.172 12.414 21.586 11 23 16 28 21 23 19.586 21.586 17 24.172 17 18 28 18 28 16 4 16 4 18zM26 4H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6A2 2 0 0026 4zm0 6H6V6H26z"
    })), children);
  });
  var RowExpand16 = /*#__PURE__*/React__default['default'].forwardRef(function RowExpand16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$8 || (_path44$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 18L15 18 15 24.172 12.414 21.586 11 23 16 28 21 23 19.586 21.586 17 24.172 17 18 28 18 28 16 4 16 4 18zM26 4H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6A2 2 0 0026 4zm0 6H6V6H26z"
    })), children);
  });
  var RowInsert32 = /*#__PURE__*/React__default['default'].forwardRef(function RowInsert32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$8 || (_path45$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H10a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 12zM10 4v6H28V4zM28 30H10a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM10 22v6H28V22zM9 16L3.414 10.414 2 11.828 6.172 16 2 20.172 3.414 21.586 9 16z"
    })), children);
  });
  var RowInsert24 = /*#__PURE__*/React__default['default'].forwardRef(function RowInsert24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$8 || (_path46$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H10a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 12zM10 4v6H28V4zM28 30H10a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM10 22v6H28V22zM9 16L3.414 10.414 2 11.828 6.172 16 2 20.172 3.414 21.586 9 16z"
    })), children);
  });
  var RowInsert20 = /*#__PURE__*/React__default['default'].forwardRef(function RowInsert20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$8 || (_path47$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H10a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 12zM10 4v6H28V4zM28 30H10a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM10 22v6H28V22zM9 16L3.414 10.414 2 11.828 6.172 16 2 20.172 3.414 21.586 9 16z"
    })), children);
  });
  var RowInsert16 = /*#__PURE__*/React__default['default'].forwardRef(function RowInsert16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$8 || (_path48$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 12H10a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 12zM10 4v6H28V4zM28 30H10a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM10 22v6H28V22zM9 16L3.414 10.414 2 11.828 6.172 16 2 20.172 3.414 21.586 9 16z"
    })), children);
  });
  var Rss32 = /*#__PURE__*/React__default['default'].forwardRef(function Rss32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$8 || (_path49$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"
    })), _path50$8 || (_path50$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"
    })), children);
  });
  var Rss24 = /*#__PURE__*/React__default['default'].forwardRef(function Rss24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$8 || (_path51$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"
    })), _path52$8 || (_path52$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"
    })), children);
  });
  var Rss20 = /*#__PURE__*/React__default['default'].forwardRef(function Rss20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$8 || (_path53$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"
    })), _path54$8 || (_path54$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"
    })), children);
  });
  var Rss16 = /*#__PURE__*/React__default['default'].forwardRef(function Rss16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$8 || (_path55$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"
    })), _path56$8 || (_path56$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"
    })), children);
  });
  var Rule32 = /*#__PURE__*/React__default['default'].forwardRef(function Rule32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$8 || (_path57$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 10H22V12H10z"
    })), _path58$8 || (_path58$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var Rule24 = /*#__PURE__*/React__default['default'].forwardRef(function Rule24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$8 || (_path59$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 10H22V12H10z"
    })), _path60$8 || (_path60$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var Rule20 = /*#__PURE__*/React__default['default'].forwardRef(function Rule20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$8 || (_path61$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 10H22V12H10z"
    })), _path62$8 || (_path62$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var Rule16 = /*#__PURE__*/React__default['default'].forwardRef(function Rule16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$8 || (_path63$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 10H22V12H10z"
    })), _path64$8 || (_path64$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var RuleCancelled32 = /*#__PURE__*/React__default['default'].forwardRef(function RuleCancelled32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$8 || (_path65$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path66$8 || (_path66$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24l0,11h2L26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var RuleCancelled24 = /*#__PURE__*/React__default['default'].forwardRef(function RuleCancelled24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$8 || (_path67$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path68$8 || (_path68$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24l0,11h2L26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var RuleCancelled20 = /*#__PURE__*/React__default['default'].forwardRef(function RuleCancelled20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$8 || (_path69$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path70$8 || (_path70$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24l0,11h2L26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var RuleCancelled16 = /*#__PURE__*/React__default['default'].forwardRef(function RuleCancelled16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$8 || (_path71$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24a6 6 0 10-6 6A6.0066 6.0066 0 0030 24zm-2 0a3.9521 3.9521 0 01-.5669 2.019L21.981 20.5669A3.9529 3.9529 0 0124 20 4.0045 4.0045 0 0128 24zm-8 0a3.9521 3.9521 0 01.5669-2.019l5.4521 5.4521A3.9529 3.9529 0 0124 28 4.0045 4.0045 0 0120 24zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path72$8 || (_path72$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,27.7334l-5.2344-2.791A8.9858,8.9858,0,0,1,4,17V4H24l0,11h2L26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,30Z"
    })), children);
  });
  var RuleDraft32 = /*#__PURE__*/React__default['default'].forwardRef(function RuleDraft32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$8 || (_path73$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path74$8 || (_path74$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleDraft24 = /*#__PURE__*/React__default['default'].forwardRef(function RuleDraft24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$8 || (_path75$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path76$8 || (_path76$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleDraft20 = /*#__PURE__*/React__default['default'].forwardRef(function RuleDraft20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$8 || (_path77$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path78$8 || (_path78$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleDraft16 = /*#__PURE__*/React__default['default'].forwardRef(function RuleDraft16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$8 || (_path79$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 19.293l-3-3a.9994.9994 0 00-1.414 0L16 25.5859V30h4.4141l9.2929-9.293A.9994.9994 0 0029.707 19.293zM19.5859 28H18V26.4141l5-5L24.5859 23zM26 21.5859L24.4141 20 26 18.4141 27.5859 20zM8 16H18V18H8zM8 10H20V12H8z"
    })), _path80$8 || (_path80$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function RuleFilled32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$8 || (_path81$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 16H23V18H9z",
      "data-icon-path": "inner-path"
    })), _path82$8 || (_path82$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 10H23V12H9z"
    })), _path83$8 || (_path83$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L16,30l6.1758-3.293A10.9814,10.9814,0,0,0,28,17V4A2.0023,2.0023,0,0,0,26,2ZM23,18H9V16H23Zm0-6H9V10H23Z"
    })), children);
  });
  var RuleFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function RuleFilled24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$8 || (_path84$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 16H23V18H9z",
      "data-icon-path": "inner-path"
    })), _path85$8 || (_path85$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 10H23V12H9z"
    })), _path86$8 || (_path86$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L16,30l6.1758-3.293A10.9814,10.9814,0,0,0,28,17V4A2.0023,2.0023,0,0,0,26,2ZM23,18H9V16H23Zm0-6H9V10H23Z"
    })), children);
  });
  var RuleFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function RuleFilled20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$8 || (_path87$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 16H23V18H9z",
      "data-icon-path": "inner-path"
    })), _path88$8 || (_path88$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 10H23V12H9z"
    })), _path89$8 || (_path89$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L16,30l6.1758-3.293A10.9814,10.9814,0,0,0,28,17V4A2.0023,2.0023,0,0,0,26,2ZM23,18H9V16H23Zm0-6H9V10H23Z"
    })), children);
  });
  var RuleFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function RuleFilled16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$8 || (_path90$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 16H23V18H9z",
      "data-icon-path": "inner-path"
    })), _path91$8 || (_path91$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M9 10H23V12H9z"
    })), _path92$8 || (_path92$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L16,30l6.1758-3.293A10.9814,10.9814,0,0,0,28,17V4A2.0023,2.0023,0,0,0,26,2ZM23,18H9V16H23Zm0-6H9V10H23Z"
    })), children);
  });
  var RuleTest32 = /*#__PURE__*/React__default['default'].forwardRef(function RuleTest32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$8 || (_path93$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,30Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,18Z"
    })), _path94$8 || (_path94$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24.586L24 22.586 24 20 22 20 22 23.414 24.586 26 26 24.586zM8 16H14V18H8zM8 10H20V12H8z"
    })), _path95$8 || (_path95$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleTest24 = /*#__PURE__*/React__default['default'].forwardRef(function RuleTest24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$8 || (_path96$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,30Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,18Z"
    })), _path97$8 || (_path97$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24.586L24 22.586 24 20 22 20 22 23.414 24.586 26 26 24.586zM8 16H14V18H8zM8 10H20V12H8z"
    })), _path98$8 || (_path98$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleTest20 = /*#__PURE__*/React__default['default'].forwardRef(function RuleTest20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$8 || (_path99$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,30Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,18Z"
    })), _path100$8 || (_path100$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24.586L24 22.586 24 20 22 20 22 23.414 24.586 26 26 24.586zM8 16H14V18H8zM8 10H20V12H8z"
    })), _path101$8 || (_path101$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var RuleTest16 = /*#__PURE__*/React__default['default'].forwardRef(function RuleTest16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$8 || (_path102$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,30a7,7,0,1,1,7-7A7.0078,7.0078,0,0,1,23,30Zm0-12a5,5,0,1,0,5,5A5.0055,5.0055,0,0,0,23,18Z"
    })), _path103$8 || (_path103$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 24.586L24 22.586 24 20 22 20 22 23.414 24.586 26 26 24.586zM8 16H14V18H8zM8 10H20V12H8z"
    })), _path104$8 || (_path104$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L13,29.4668V27.2L8.7656,24.9424A8.9858,8.9858,0,0,1,4,17V4H24v9h2Z"
    })), children);
  });
  var Ruler32 = /*#__PURE__*/React__default['default'].forwardRef(function Ruler32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$8 || (_path105$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"
    })), children);
  });
  var Ruler24 = /*#__PURE__*/React__default['default'].forwardRef(function Ruler24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$8 || (_path106$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"
    })), children);
  });
  var Ruler20 = /*#__PURE__*/React__default['default'].forwardRef(function Ruler20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$8 || (_path107$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"
    })), children);
  });
  var Ruler16 = /*#__PURE__*/React__default['default'].forwardRef(function Ruler16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$8 || (_path108$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"
    })), children);
  });
  var RulerAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function RulerAlt32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$8 || (_path109$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"
    })), children);
  });
  var RulerAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function RulerAlt24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$8 || (_path110$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"
    })), children);
  });
  var RulerAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function RulerAlt20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$8 || (_path111$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"
    })), children);
  });
  var RulerAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function RulerAlt16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$8 || (_path112$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"
    })), children);
  });
  var Run32 = /*#__PURE__*/React__default['default'].forwardRef(function Run32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$8 || (_path113$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"
    })), _path114$8 || (_path114$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"
    })), _path115$8 || (_path115$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 19L19 25 24 22 19 19z"
    })), children);
  });
  var Run24 = /*#__PURE__*/React__default['default'].forwardRef(function Run24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$8 || (_path116$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"
    })), _path117$8 || (_path117$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"
    })), _path118$8 || (_path118$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 19L19 25 24 22 19 19z"
    })), children);
  });
  var Run20 = /*#__PURE__*/React__default['default'].forwardRef(function Run20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$8 || (_path119$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"
    })), _path120$8 || (_path120$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"
    })), _path121$8 || (_path121$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 19L19 25 24 22 19 19z"
    })), children);
  });
  var Run16 = /*#__PURE__*/React__default['default'].forwardRef(function Run16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$8 || (_path122$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"
    })), _path123$8 || (_path123$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"
    })), _path124$8 || (_path124$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 19L19 25 24 22 19 19z"
    })), children);
  });
  var QS32 = /*#__PURE__*/React__default['default'].forwardRef(function QS32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$8 || (_path125$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var QS24 = /*#__PURE__*/React__default['default'].forwardRef(function QS24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$8 || (_path126$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var QS20 = /*#__PURE__*/React__default['default'].forwardRef(function QS20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$8 || (_path127$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var QS16 = /*#__PURE__*/React__default['default'].forwardRef(function QS16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$8 || (_path128$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"
    })), children);
  });
  var QSAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function QSAlt32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$8 || (_path129$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 01-2-2V11a2 2 0 012-2h6v2H10v4h4a2 2 0 012 2v4A2 2 0 0114 23z"
    })), children);
  });
  var QSAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function QSAlt24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$8 || (_path130$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 01-2-2V11a2 2 0 012-2h6v2H10v4h4a2 2 0 012 2v4A2 2 0 0114 23z"
    })), children);
  });
  var QSAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function QSAlt20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$8 || (_path131$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 01-2-2V11a2 2 0 012-2h6v2H10v4h4a2 2 0 012 2v4A2 2 0 0114 23z"
    })), children);
  });
  var QSAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function QSAlt16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$8 || (_path132$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 01-2-2V11a2 2 0 012-2h6v2H10v4h4a2 2 0 012 2v4A2 2 0 0114 23z"
    })), children);
  });
  var SailboatCoastal32 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatCoastal32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$8 || (_path133$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7808,26,25.97,21.2422A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422L7.2192,26H2v2H30V26ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15ZM22.7192,26H9.2808l-1-4H23.7192Z"
    })), children);
  });
  var SailboatCoastal24 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatCoastal24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$8 || (_path134$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7808,26,25.97,21.2422A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422L7.2192,26H2v2H30V26ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15ZM22.7192,26H9.2808l-1-4H23.7192Z"
    })), children);
  });
  var SailboatCoastal20 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatCoastal20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$8 || (_path135$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7808,26,25.97,21.2422A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422L7.2192,26H2v2H30V26ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15ZM22.7192,26H9.2808l-1-4H23.7192Z"
    })), children);
  });
  var SailboatCoastal16 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatCoastal16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$8 || (_path136$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7808,26,25.97,21.2422A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422L7.2192,26H2v2H30V26ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15ZM22.7192,26H9.2808l-1-4H23.7192Z"
    })), children);
  });
  var SailboatOffshore32 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatOffshore32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$8 || (_path137$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15Z"
    })), _path138$8 || (_path138$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), children);
  });
  var SailboatOffshore24 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatOffshore24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$8 || (_path139$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15Z"
    })), _path140$8 || (_path140$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), children);
  });
  var SailboatOffshore20 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatOffshore20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$8 || (_path141$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15Z"
    })), _path142$8 || (_path142$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), children);
  });
  var SailboatOffshore16 = /*#__PURE__*/React__default['default'].forwardRef(function SailboatOffshore16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$8 || (_path143$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9692,25H9.0308l-.75-3H23.7192l-.75,3h2.0616l.9394-3.7578A1,1,0,0,0,25,20H20V17h5a1,1,0,0,0,.9082-1.4189l-6-13a1.0006,1.0006,0,0,0-1.7021-.19L8.2075,15.3906A1,1,0,0,0,9,17h9v3H7a1,1,0,0,0-.97,1.2422ZM20,7.5527,23.437,15H20ZM11.0308,15,18,5.94V15Z"
    })), _path144$8 || (_path144$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.9058,25.751A2.998,2.998,0,0,1,24,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,20,25a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,16,28a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,12,25a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,8,28a2.998,2.998,0,0,1-2.9058-2.249l-1.9365.498A4.9965,4.9965,0,0,0,8,30a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,24,30a4.9965,4.9965,0,0,0,4.8423-3.751Z"
    })), children);
  });
  var SankeyDiagram32 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagram32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$8 || (_path145$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V8.0439c-1.9634.1968-6.3162,1.2325-10.5637,6.2764-.198-.2768-.3982-.5464-.5882-.8506C11.9736,5.6714,6.3191,4.2759,4,4.042V2H2V30H4V26.0464a14.8661,14.8661,0,0,0,9.9185-3.96C18.47,27.46,25.2363,28.0381,27.9341,28.0381c.0244,0,.0422-.001.0659-.001V30h2V2Zm0,8.0552v9.99a12.8834,12.8834,0,0,1-9.2756-4.1328C22.5032,11.2666,26.2915,10.26,28,10.0552ZM15.1519,14.53c.3242.5185.663.9907,1.0078,1.4409-.3384.4741-.6753.9707-1.0078,1.5029a16.1346,16.1346,0,0,1-1.0313,1.4531c-.0825-.1372-.1675-.27-.2466-.4126C9.3279,10.3315,5.7871,8.4438,4,8.0684V6.0508C5.9932,6.2905,10.8228,7.6035,15.1519,14.53ZM4,24.0488V10.1406c1.3254.4644,4.2034,2.2847,8.126,9.3448.1894.3413.396.6523.6.9667A12.8784,12.8784,0,0,1,4,24.0488Zm11.3179-3.4209a18.0563,18.0563,0,0,0,1.53-2.0937c.2212-.354.4454-.67.6687-.9951A14.8686,14.8686,0,0,0,28,22.0425v3.9863C25.67,26.019,19.374,25.5088,15.3179,20.6279Z"
    })), children);
  });
  var SankeyDiagram24 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagram24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$8 || (_path146$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V8.0439c-1.9634.1968-6.3162,1.2325-10.5637,6.2764-.198-.2768-.3982-.5464-.5882-.8506C11.9736,5.6714,6.3191,4.2759,4,4.042V2H2V30H4V26.0464a14.8661,14.8661,0,0,0,9.9185-3.96C18.47,27.46,25.2363,28.0381,27.9341,28.0381c.0244,0,.0422-.001.0659-.001V30h2V2Zm0,8.0552v9.99a12.8834,12.8834,0,0,1-9.2756-4.1328C22.5032,11.2666,26.2915,10.26,28,10.0552ZM15.1519,14.53c.3242.5185.663.9907,1.0078,1.4409-.3384.4741-.6753.9707-1.0078,1.5029a16.1346,16.1346,0,0,1-1.0313,1.4531c-.0825-.1372-.1675-.27-.2466-.4126C9.3279,10.3315,5.7871,8.4438,4,8.0684V6.0508C5.9932,6.2905,10.8228,7.6035,15.1519,14.53ZM4,24.0488V10.1406c1.3254.4644,4.2034,2.2847,8.126,9.3448.1894.3413.396.6523.6.9667A12.8784,12.8784,0,0,1,4,24.0488Zm11.3179-3.4209a18.0563,18.0563,0,0,0,1.53-2.0937c.2212-.354.4454-.67.6687-.9951A14.8686,14.8686,0,0,0,28,22.0425v3.9863C25.67,26.019,19.374,25.5088,15.3179,20.6279Z"
    })), children);
  });
  var SankeyDiagram20 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagram20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$8 || (_path147$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V8.0439c-1.9634.1968-6.3162,1.2325-10.5637,6.2764-.198-.2768-.3982-.5464-.5882-.8506C11.9736,5.6714,6.3191,4.2759,4,4.042V2H2V30H4V26.0464a14.8661,14.8661,0,0,0,9.9185-3.96C18.47,27.46,25.2363,28.0381,27.9341,28.0381c.0244,0,.0422-.001.0659-.001V30h2V2Zm0,8.0552v9.99a12.8834,12.8834,0,0,1-9.2756-4.1328C22.5032,11.2666,26.2915,10.26,28,10.0552ZM15.1519,14.53c.3242.5185.663.9907,1.0078,1.4409-.3384.4741-.6753.9707-1.0078,1.5029a16.1346,16.1346,0,0,1-1.0313,1.4531c-.0825-.1372-.1675-.27-.2466-.4126C9.3279,10.3315,5.7871,8.4438,4,8.0684V6.0508C5.9932,6.2905,10.8228,7.6035,15.1519,14.53ZM4,24.0488V10.1406c1.3254.4644,4.2034,2.2847,8.126,9.3448.1894.3413.396.6523.6.9667A12.8784,12.8784,0,0,1,4,24.0488Zm11.3179-3.4209a18.0563,18.0563,0,0,0,1.53-2.0937c.2212-.354.4454-.67.6687-.9951A14.8686,14.8686,0,0,0,28,22.0425v3.9863C25.67,26.019,19.374,25.5088,15.3179,20.6279Z"
    })), children);
  });
  var SankeyDiagram16 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagram16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$8 || (_path148$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2V8.0439c-1.9634.1968-6.3162,1.2325-10.5637,6.2764-.198-.2768-.3982-.5464-.5882-.8506C11.9736,5.6714,6.3191,4.2759,4,4.042V2H2V30H4V26.0464a14.8661,14.8661,0,0,0,9.9185-3.96C18.47,27.46,25.2363,28.0381,27.9341,28.0381c.0244,0,.0422-.001.0659-.001V30h2V2Zm0,8.0552v9.99a12.8834,12.8834,0,0,1-9.2756-4.1328C22.5032,11.2666,26.2915,10.26,28,10.0552ZM15.1519,14.53c.3242.5185.663.9907,1.0078,1.4409-.3384.4741-.6753.9707-1.0078,1.5029a16.1346,16.1346,0,0,1-1.0313,1.4531c-.0825-.1372-.1675-.27-.2466-.4126C9.3279,10.3315,5.7871,8.4438,4,8.0684V6.0508C5.9932,6.2905,10.8228,7.6035,15.1519,14.53ZM4,24.0488V10.1406c1.3254.4644,4.2034,2.2847,8.126,9.3448.1894.3413.396.6523.6.9667A12.8784,12.8784,0,0,1,4,24.0488Zm11.3179-3.4209a18.0563,18.0563,0,0,0,1.53-2.0937c.2212-.354.4454-.67.6687-.9951A14.8686,14.8686,0,0,0,28,22.0425v3.9863C25.67,26.019,19.374,25.5088,15.3179,20.6279Z"
    })), children);
  });
  var SankeyDiagramAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagramAlt32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$8 || (_path149$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,2H2V16H8.1113a7.0359,7.0359,0,0,1,3.13.7393L15.7637,19l-4.522,2.2607A7.0359,7.0359,0,0,1,8.1113,22H2v8H9.2231a9.0446,9.0446,0,0,0,4.0249-.95L21.87,24.7393A7.0359,7.0359,0,0,1,25,24h5V14H25a7.0359,7.0359,0,0,1-3.13-.7393L15.3481,10H30ZM8,4H24V8H8ZM4,4H6V14H4ZM4,24H6v4H4Zm16.9751-1.05-8.6216,4.3105A7.0359,7.0359,0,0,1,9.2231,28H8V24h.1113a9.0446,9.0446,0,0,0,4.0249-.95L18,20.1182l1.8638.9316a9.0446,9.0446,0,0,0,4.0249.95H24v.0586A9.0515,9.0515,0,0,0,20.9751,22.95ZM28,22H26V16h2ZM12.3535,10.7393l8.6216,4.31A9.0515,9.0515,0,0,0,24,15.9414V20h-.1113a7.0359,7.0359,0,0,1-3.13-.7393l-8.6221-4.31A9.0446,9.0446,0,0,0,8.1113,14H8V10H9.2231A7.0359,7.0359,0,0,1,12.3535,10.7393ZM28,8H26V4h2Z"
    })), children);
  });
  var SankeyDiagramAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagramAlt24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$8 || (_path150$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,2H2V16H8.1113a7.0359,7.0359,0,0,1,3.13.7393L15.7637,19l-4.522,2.2607A7.0359,7.0359,0,0,1,8.1113,22H2v8H9.2231a9.0446,9.0446,0,0,0,4.0249-.95L21.87,24.7393A7.0359,7.0359,0,0,1,25,24h5V14H25a7.0359,7.0359,0,0,1-3.13-.7393L15.3481,10H30ZM8,4H24V8H8ZM4,4H6V14H4ZM4,24H6v4H4Zm16.9751-1.05-8.6216,4.3105A7.0359,7.0359,0,0,1,9.2231,28H8V24h.1113a9.0446,9.0446,0,0,0,4.0249-.95L18,20.1182l1.8638.9316a9.0446,9.0446,0,0,0,4.0249.95H24v.0586A9.0515,9.0515,0,0,0,20.9751,22.95ZM28,22H26V16h2ZM12.3535,10.7393l8.6216,4.31A9.0515,9.0515,0,0,0,24,15.9414V20h-.1113a7.0359,7.0359,0,0,1-3.13-.7393l-8.6221-4.31A9.0446,9.0446,0,0,0,8.1113,14H8V10H9.2231A7.0359,7.0359,0,0,1,12.3535,10.7393ZM28,8H26V4h2Z"
    })), children);
  });
  var SankeyDiagramAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagramAlt20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$8 || (_path151$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,2H2V16H8.1113a7.0359,7.0359,0,0,1,3.13.7393L15.7637,19l-4.522,2.2607A7.0359,7.0359,0,0,1,8.1113,22H2v8H9.2231a9.0446,9.0446,0,0,0,4.0249-.95L21.87,24.7393A7.0359,7.0359,0,0,1,25,24h5V14H25a7.0359,7.0359,0,0,1-3.13-.7393L15.3481,10H30ZM8,4H24V8H8ZM4,4H6V14H4ZM4,24H6v4H4Zm16.9751-1.05-8.6216,4.3105A7.0359,7.0359,0,0,1,9.2231,28H8V24h.1113a9.0446,9.0446,0,0,0,4.0249-.95L18,20.1182l1.8638.9316a9.0446,9.0446,0,0,0,4.0249.95H24v.0586A9.0515,9.0515,0,0,0,20.9751,22.95ZM28,22H26V16h2ZM12.3535,10.7393l8.6216,4.31A9.0515,9.0515,0,0,0,24,15.9414V20h-.1113a7.0359,7.0359,0,0,1-3.13-.7393l-8.6221-4.31A9.0446,9.0446,0,0,0,8.1113,14H8V10H9.2231A7.0359,7.0359,0,0,1,12.3535,10.7393ZM28,8H26V4h2Z"
    })), children);
  });
  var SankeyDiagramAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function SankeyDiagramAlt16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$8 || (_path152$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,2H2V16H8.1113a7.0359,7.0359,0,0,1,3.13.7393L15.7637,19l-4.522,2.2607A7.0359,7.0359,0,0,1,8.1113,22H2v8H9.2231a9.0446,9.0446,0,0,0,4.0249-.95L21.87,24.7393A7.0359,7.0359,0,0,1,25,24h5V14H25a7.0359,7.0359,0,0,1-3.13-.7393L15.3481,10H30ZM8,4H24V8H8ZM4,4H6V14H4ZM4,24H6v4H4Zm16.9751-1.05-8.6216,4.3105A7.0359,7.0359,0,0,1,9.2231,28H8V24h.1113a9.0446,9.0446,0,0,0,4.0249-.95L18,20.1182l1.8638.9316a9.0446,9.0446,0,0,0,4.0249.95H24v.0586A9.0515,9.0515,0,0,0,20.9751,22.95ZM28,22H26V16h2ZM12.3535,10.7393l8.6216,4.31A9.0515,9.0515,0,0,0,24,15.9414V20h-.1113a7.0359,7.0359,0,0,1-3.13-.7393l-8.6221-4.31A9.0446,9.0446,0,0,0,8.1113,14H8V10H9.2231A7.0359,7.0359,0,0,1,12.3535,10.7393ZM28,8H26V4h2Z"
    })), children);
  });
  var Satellite32 = /*#__PURE__*/React__default['default'].forwardRef(function Satellite32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$8 || (_path153$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9141,16.5l2.7929-2.793a.9994.9994,0,0,0,0-1.414L23.4141,10,25.5,7.9141,28.5859,11,30,9.5859,22.4141,2,21,3.4141,24.0859,6.5,22,8.5859,19.707,6.293a.9994.9994,0,0,0-1.414,0L15.5,9.0859,8.707,2.293a.9994.9994,0,0,0-1.414,0l-5,5a.9994.9994,0,0,0,0,1.414L9.0859,15.5,6.293,18.293a.9994.9994,0,0,0,0,1.414L8.5859,22,6.5,24.0859,3.4141,21,2,22.4141,9.5859,30,11,28.5859,7.9141,25.5,10,23.4141l2.293,2.2929a.9995.9995,0,0,0,1.414,0L16.5,22.9141l6.793,6.7929a.9995.9995,0,0,0,1.414,0l5-5a.9994.9994,0,0,0,0-1.414ZM4.4141,8,8,4.4141,10.0859,6.5,6.5,10.0859Zm3.5,3.5L11.5,7.9141,14.0859,10.5,10.5,14.0859ZM13,23.5859,8.4141,19,19,8.4141,23.5859,13ZM17.9141,21.5,21.5,17.9141,24.0859,20.5,20.5,24.0859ZM24,27.5859,21.9141,25.5,25.5,21.9141,27.5859,24Z"
    })), children);
  });
  var Satellite24 = /*#__PURE__*/React__default['default'].forwardRef(function Satellite24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$8 || (_path154$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9141,16.5l2.7929-2.793a.9994.9994,0,0,0,0-1.414L23.4141,10,25.5,7.9141,28.5859,11,30,9.5859,22.4141,2,21,3.4141,24.0859,6.5,22,8.5859,19.707,6.293a.9994.9994,0,0,0-1.414,0L15.5,9.0859,8.707,2.293a.9994.9994,0,0,0-1.414,0l-5,5a.9994.9994,0,0,0,0,1.414L9.0859,15.5,6.293,18.293a.9994.9994,0,0,0,0,1.414L8.5859,22,6.5,24.0859,3.4141,21,2,22.4141,9.5859,30,11,28.5859,7.9141,25.5,10,23.4141l2.293,2.2929a.9995.9995,0,0,0,1.414,0L16.5,22.9141l6.793,6.7929a.9995.9995,0,0,0,1.414,0l5-5a.9994.9994,0,0,0,0-1.414ZM4.4141,8,8,4.4141,10.0859,6.5,6.5,10.0859Zm3.5,3.5L11.5,7.9141,14.0859,10.5,10.5,14.0859ZM13,23.5859,8.4141,19,19,8.4141,23.5859,13ZM17.9141,21.5,21.5,17.9141,24.0859,20.5,20.5,24.0859ZM24,27.5859,21.9141,25.5,25.5,21.9141,27.5859,24Z"
    })), children);
  });
  var Satellite20 = /*#__PURE__*/React__default['default'].forwardRef(function Satellite20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$8 || (_path155$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9141,16.5l2.7929-2.793a.9994.9994,0,0,0,0-1.414L23.4141,10,25.5,7.9141,28.5859,11,30,9.5859,22.4141,2,21,3.4141,24.0859,6.5,22,8.5859,19.707,6.293a.9994.9994,0,0,0-1.414,0L15.5,9.0859,8.707,2.293a.9994.9994,0,0,0-1.414,0l-5,5a.9994.9994,0,0,0,0,1.414L9.0859,15.5,6.293,18.293a.9994.9994,0,0,0,0,1.414L8.5859,22,6.5,24.0859,3.4141,21,2,22.4141,9.5859,30,11,28.5859,7.9141,25.5,10,23.4141l2.293,2.2929a.9995.9995,0,0,0,1.414,0L16.5,22.9141l6.793,6.7929a.9995.9995,0,0,0,1.414,0l5-5a.9994.9994,0,0,0,0-1.414ZM4.4141,8,8,4.4141,10.0859,6.5,6.5,10.0859Zm3.5,3.5L11.5,7.9141,14.0859,10.5,10.5,14.0859ZM13,23.5859,8.4141,19,19,8.4141,23.5859,13ZM17.9141,21.5,21.5,17.9141,24.0859,20.5,20.5,24.0859ZM24,27.5859,21.9141,25.5,25.5,21.9141,27.5859,24Z"
    })), children);
  });
  var Satellite16 = /*#__PURE__*/React__default['default'].forwardRef(function Satellite16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$8 || (_path156$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.9141,16.5l2.7929-2.793a.9994.9994,0,0,0,0-1.414L23.4141,10,25.5,7.9141,28.5859,11,30,9.5859,22.4141,2,21,3.4141,24.0859,6.5,22,8.5859,19.707,6.293a.9994.9994,0,0,0-1.414,0L15.5,9.0859,8.707,2.293a.9994.9994,0,0,0-1.414,0l-5,5a.9994.9994,0,0,0,0,1.414L9.0859,15.5,6.293,18.293a.9994.9994,0,0,0,0,1.414L8.5859,22,6.5,24.0859,3.4141,21,2,22.4141,9.5859,30,11,28.5859,7.9141,25.5,10,23.4141l2.293,2.2929a.9995.9995,0,0,0,1.414,0L16.5,22.9141l6.793,6.7929a.9995.9995,0,0,0,1.414,0l5-5a.9994.9994,0,0,0,0-1.414ZM4.4141,8,8,4.4141,10.0859,6.5,6.5,10.0859Zm3.5,3.5L11.5,7.9141,14.0859,10.5,10.5,14.0859ZM13,23.5859,8.4141,19,19,8.4141,23.5859,13ZM17.9141,21.5,21.5,17.9141,24.0859,20.5,20.5,24.0859ZM24,27.5859,21.9141,25.5,25.5,21.9141,27.5859,24Z"
    })), children);
  });
  var SatelliteRadar32 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteRadar32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$8 || (_path157$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H28A10.0113,10.0113,0,0,0,18,4V2A12.0137,12.0137,0,0,1,30,14Z"
    })), _path158$8 || (_path158$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24a6.0067 6.0067 0 00-6-6V6A8.0092 8.0092 0 0126 14zM16 28V24.96a9.9124 9.9124 0 007.3179-2.208 1.8482 1.8482 0 00.6777-1.3344 1.8 1.8 0 00-.5239-1.36L18.4141 15 21 12.4141 19.5859 11 17 13.5859 11.9419 8.5273a1.8145 1.8145 0 00-1.36-.5229 1.845 1.845 0 00-1.3339.6782 9.9566 9.9566 0 00-.5127 11.95L6.2793 28H2v2H30V28zM10.68 10.0938L21.9058 21.32A8.0011 8.0011 0 0110.68 10.0938zM14 28H8.3875l1.8757-5.627A9.9894 9.9894 0 0014 24.5435z"
    })), children);
  });
  var SatelliteRadar24 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteRadar24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$8 || (_path159$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H28A10.0113,10.0113,0,0,0,18,4V2A12.0137,12.0137,0,0,1,30,14Z"
    })), _path160$8 || (_path160$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24a6.0067 6.0067 0 00-6-6V6A8.0092 8.0092 0 0126 14zM16 28V24.96a9.9124 9.9124 0 007.3179-2.208 1.8482 1.8482 0 00.6777-1.3344 1.8 1.8 0 00-.5239-1.36L18.4141 15 21 12.4141 19.5859 11 17 13.5859 11.9419 8.5273a1.8145 1.8145 0 00-1.36-.5229 1.845 1.845 0 00-1.3339.6782 9.9566 9.9566 0 00-.5127 11.95L6.2793 28H2v2H30V28zM10.68 10.0938L21.9058 21.32A8.0011 8.0011 0 0110.68 10.0938zM14 28H8.3875l1.8757-5.627A9.9894 9.9894 0 0014 24.5435z"
    })), children);
  });
  var SatelliteRadar20 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteRadar20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$8 || (_path161$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H28A10.0113,10.0113,0,0,0,18,4V2A12.0137,12.0137,0,0,1,30,14Z"
    })), _path162$8 || (_path162$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24a6.0067 6.0067 0 00-6-6V6A8.0092 8.0092 0 0126 14zM16 28V24.96a9.9124 9.9124 0 007.3179-2.208 1.8482 1.8482 0 00.6777-1.3344 1.8 1.8 0 00-.5239-1.36L18.4141 15 21 12.4141 19.5859 11 17 13.5859 11.9419 8.5273a1.8145 1.8145 0 00-1.36-.5229 1.845 1.845 0 00-1.3339.6782 9.9566 9.9566 0 00-.5127 11.95L6.2793 28H2v2H30V28zM10.68 10.0938L21.9058 21.32A8.0011 8.0011 0 0110.68 10.0938zM14 28H8.3875l1.8757-5.627A9.9894 9.9894 0 0014 24.5435z"
    })), children);
  });
  var SatelliteRadar16 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteRadar16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$8 || (_path163$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14H28A10.0113,10.0113,0,0,0,18,4V2A12.0137,12.0137,0,0,1,30,14Z"
    })), _path164$8 || (_path164$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 14H24a6.0067 6.0067 0 00-6-6V6A8.0092 8.0092 0 0126 14zM16 28V24.96a9.9124 9.9124 0 007.3179-2.208 1.8482 1.8482 0 00.6777-1.3344 1.8 1.8 0 00-.5239-1.36L18.4141 15 21 12.4141 19.5859 11 17 13.5859 11.9419 8.5273a1.8145 1.8145 0 00-1.36-.5229 1.845 1.845 0 00-1.3339.6782 9.9566 9.9566 0 00-.5127 11.95L6.2793 28H2v2H30V28zM10.68 10.0938L21.9058 21.32A8.0011 8.0011 0 0110.68 10.0938zM14 28H8.3875l1.8757-5.627A9.9894 9.9894 0 0014 24.5435z"
    })), children);
  });
  var SatelliteWeather32 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteWeather32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$8 || (_path165$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM13 28V24.8882a7.9363 7.9363 0 004.707-2.2818.9995.9995 0 000-1.414L13.4644 16.95 16 14.4141 14.5859 13 12.05 15.5356 7.8076 11.293a.9994.9994 0 00-1.414 0 7.9993 7.9993 0 000 11.3134c.1621.1622.3327.3125.5058.459L4.4321 28H2v2H30V28zm-2 0H6.6685L8.59 24.1567A7.8927 7.8927 0 0011 24.873zM7.8076 21.1924a6.0036 6.0036 0 01-.6489-7.72l8.3686 8.3681a6.0026 6.0026 0 01-7.72-.6484z"
    })), children);
  });
  var SatelliteWeather24 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteWeather24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$8 || (_path166$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM13 28V24.8882a7.9363 7.9363 0 004.707-2.2818.9995.9995 0 000-1.414L13.4644 16.95 16 14.4141 14.5859 13 12.05 15.5356 7.8076 11.293a.9994.9994 0 00-1.414 0 7.9993 7.9993 0 000 11.3134c.1621.1622.3327.3125.5058.459L4.4321 28H2v2H30V28zm-2 0H6.6685L8.59 24.1567A7.8927 7.8927 0 0011 24.873zM7.8076 21.1924a6.0036 6.0036 0 01-.6489-7.72l8.3686 8.3681a6.0026 6.0026 0 01-7.72-.6484z"
    })), children);
  });
  var SatelliteWeather20 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteWeather20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$8 || (_path167$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM13 28V24.8882a7.9363 7.9363 0 004.707-2.2818.9995.9995 0 000-1.414L13.4644 16.95 16 14.4141 14.5859 13 12.05 15.5356 7.8076 11.293a.9994.9994 0 00-1.414 0 7.9993 7.9993 0 000 11.3134c.1621.1622.3327.3125.5058.459L4.4321 28H2v2H30V28zm-2 0H6.6685L8.59 24.1567A7.8927 7.8927 0 0011 24.873zM7.8076 21.1924a6.0036 6.0036 0 01-.6489-7.72l8.3686 8.3681a6.0026 6.0026 0 01-7.72-.6484z"
    })), children);
  });
  var SatelliteWeather16 = /*#__PURE__*/React__default['default'].forwardRef(function SatelliteWeather16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$8 || (_path168$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5 12H19a4 4 0 010-8h.0835A4.7864 4.7864 0 0123 2a4.9816 4.9816 0 014.6543 3.2034A3.4667 3.4667 0 0130 8.5 3.5041 3.5041 0 0126.5 12zM19 6a2 2 0 000 4h7.5A1.5017 1.5017 0 0028 8.5a1.4855 1.4855 0 00-1.2778-1.4739L26.061 6.927l-.1616-.6487a2.9568 2.9568 0 00-5.4873-.7121L20.1143 6zM13 28V24.8882a7.9363 7.9363 0 004.707-2.2818.9995.9995 0 000-1.414L13.4644 16.95 16 14.4141 14.5859 13 12.05 15.5356 7.8076 11.293a.9994.9994 0 00-1.414 0 7.9993 7.9993 0 000 11.3134c.1621.1622.3327.3125.5058.459L4.4321 28H2v2H30V28zm-2 0H6.6685L8.59 24.1567A7.8927 7.8927 0 0011 24.873zM7.8076 21.1924a6.0036 6.0036 0 01-.6489-7.72l8.3686 8.3681a6.0026 6.0026 0 01-7.72-.6484z"
    })), children);
  });
  var Save32 = /*#__PURE__*/React__default['default'].forwardRef(function Save32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$8 || (_path169$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,9.29l-5-5A1,1,0,0,0,22,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V10A1,1,0,0,0,27.71,9.29ZM12,6h8v4H12Zm8,20H12V18h8Zm2,0V18a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v8H6V6h4v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V6.41l4,4V26Z"
    })), children);
  });
  var Save24 = /*#__PURE__*/React__default['default'].forwardRef(function Save24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$8 || (_path170$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.8,7L17,3.2C16.9,3.1,16.7,3,16.5,3h-12C3.7,3,3,3.7,3,4.5v15C3,20.3,3.7,21,4.5,21h15c0.8,0,1.5-0.7,1.5-1.5v-12\tC21,7.3,20.9,7.1,20.8,7z M9,4.5h6v3H9V4.5z M15,19.5H9v-6h6V19.5z M16.5,19.5v-6c0-0.8-0.7-1.5-1.5-1.5H9c-0.8,0-1.5,0.7-1.5,1.5v6\th-3v-15h3v3C7.5,8.3,8.2,9,9,9h6c0.8,0,1.5-0.7,1.5-1.5V4.8l3,3v11.7H16.5z"
    })), children);
  });
  var Save20 = /*#__PURE__*/React__default['default'].forwardRef(function Save20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$8 || (_path171$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.8,5.5l-3.3-3.3C14.3,2.1,14.2,2,14,2H3.3C2.6,2,2,2.6,2,3.3v13.3C2,17.4,2.6,18,3.3,18h13.3c0.7,0,1.4-0.5,1.4-1.2V6.1\tC18,5.7,17.9,5.7,17.8,5.5z M7.3,3.3h5.3v3.3H7.3V3.3z M12.7,16.7H7.3v-5.3h5.3L12.7,16.7L12.7,16.7z M14,16.7v-5.3\tc0-0.7-0.6-1.3-1.3-1.3H7.3C6.6,10,6,10.6,6,11.3v5.3H3.3V3.3H6v3.3C6,7.4,6.6,8,7.3,8h5.3C13.4,8,14,7.4,14,6.7v-3l2.7,2.7v10.4\tL14,16.7L14,16.7z"
    })), children);
  });
  var Save16 = /*#__PURE__*/React__default['default'].forwardRef(function Save16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$8 || (_path172$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.9,4.6l-2.5-2.5C11.3,2.1,11.1,2,11,2H3C2.4,2,2,2.4,2,3v10c0,0.6,0.4,1,1,1h10c0.6,0,1-0.4,1-1V5\tC14,4.9,13.9,4.7,13.9,4.6z M6,3h4v2H6V3z M10,13H6V9h4V13z M11,13V9c0-0.6-0.4-1-1-1H6C5.4,8,5,8.4,5,9v4H3V3h2v2c0,0.6,0.4,1,1,1\th4c0.6,0,1-0.4,1-1V3.2l2,2V13H11z"
    })), children);
  });
  var WatsonHealthSaveAnnotation32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveAnnotation32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$8 || (_path173$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path174$8 || (_path174$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), _path175$8 || (_path175$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H26V8H20zM22 10H26V12H22z"
    })), children);
  });
  var WatsonHealthSaveAnnotation24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveAnnotation24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$8 || (_path176$8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path177$7 || (_path177$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), _path178$7 || (_path178$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H26V8H20zM22 10H26V12H22z"
    })), children);
  });
  var WatsonHealthSaveAnnotation20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveAnnotation20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$7 || (_path179$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path180$7 || (_path180$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), _path181$7 || (_path181$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H26V8H20zM22 10H26V12H22z"
    })), children);
  });
  var WatsonHealthSaveAnnotation16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveAnnotation16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$7 || (_path182$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path183$7 || (_path183$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), _path184$7 || (_path184$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H26V8H20zM22 10H26V12H22z"
    })), children);
  });
  var WatsonHealthSaveImage32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveImage32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$7 || (_path185$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path186$7 || (_path186$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), children);
  });
  var WatsonHealthSaveImage24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveImage24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$7 || (_path187$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path188$7 || (_path188$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), children);
  });
  var WatsonHealthSaveImage20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveImage20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$7 || (_path189$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path190$7 || (_path190$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), children);
  });
  var WatsonHealthSaveImage16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveImage16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$7 || (_path191$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path192$7 || (_path192$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"
    })), children);
  });
  var SaveModel32 = /*#__PURE__*/React__default['default'].forwardRef(function SaveModel32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$7 || (_path193$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path194$7 || (_path194$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H12V18h2V16H12a2,2,0,0,0-2,2v8H6V6h4v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V6.41l4,4V16h2V10a1,1,0,0,0-.29-.71l-5-5A.9989.9989,0,0,0,22,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16ZM12,6h8v4H12Z"
    })), children);
  });
  var SaveModel24 = /*#__PURE__*/React__default['default'].forwardRef(function SaveModel24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$7 || (_path195$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path196$7 || (_path196$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H12V18h2V16H12a2,2,0,0,0-2,2v8H6V6h4v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V6.41l4,4V16h2V10a1,1,0,0,0-.29-.71l-5-5A.9989.9989,0,0,0,22,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16ZM12,6h8v4H12Z"
    })), children);
  });
  var SaveModel20 = /*#__PURE__*/React__default['default'].forwardRef(function SaveModel20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$7 || (_path197$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path198$7 || (_path198$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H12V18h2V16H12a2,2,0,0,0-2,2v8H6V6h4v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V6.41l4,4V16h2V10a1,1,0,0,0-.29-.71l-5-5A.9989.9989,0,0,0,22,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16ZM12,6h8v4H12Z"
    })), children);
  });
  var SaveModel16 = /*#__PURE__*/React__default['default'].forwardRef(function SaveModel16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$7 || (_path199$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,20l1.4272,1.9028L23,26.9629l-4.4272-5.06L20,20h6m1-2H19l-3,4,7,8,7-8-3-4Z"
    })), _path200$7 || (_path200$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,26H12V18h2V16H12a2,2,0,0,0-2,2v8H6V6h4v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V6.41l4,4V16h2V10a1,1,0,0,0-.29-.71l-5-5A.9989.9989,0,0,0,22,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H16ZM12,6h8v4H12Z"
    })), children);
  });
  var WatsonHealthSaveSeries32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveSeries32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$7 || (_path201$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path202$7 || (_path202$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"
    })), _path203$7 || (_path203$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthSaveSeries24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveSeries24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$7 || (_path204$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path205$7 || (_path205$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"
    })), _path206$7 || (_path206$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthSaveSeries20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveSeries20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$7 || (_path207$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path208$7 || (_path208$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"
    })), _path209$7 || (_path209$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthSaveSeries16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSaveSeries16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$7 || (_path210$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"
    })), _path211$7 || (_path211$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"
    })), _path212$7 || (_path212$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"
    })), children);
  });
  var Scale32 = /*#__PURE__*/React__default['default'].forwardRef(function Scale32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$7 || (_path213$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"
    })), _path214$7 || (_path214$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"
    })), children);
  });
  var Scale24 = /*#__PURE__*/React__default['default'].forwardRef(function Scale24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$7 || (_path215$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"
    })), _path216$7 || (_path216$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"
    })), children);
  });
  var Scale20 = /*#__PURE__*/React__default['default'].forwardRef(function Scale20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$7 || (_path217$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"
    })), _path218$7 || (_path218$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"
    })), children);
  });
  var Scale16 = /*#__PURE__*/React__default['default'].forwardRef(function Scale16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$7 || (_path219$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"
    })), _path220$7 || (_path220$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"
    })), children);
  });
  var Scales32 = /*#__PURE__*/React__default['default'].forwardRef(function Scales32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$7 || (_path221$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L25.896,7.5562a.8913.8913,0,0,0-.0454-.0816A1,1,0,0,0,25,7H18.8218A3.0155,3.0155,0,0,0,17,5.1841V2H15V5.1841A3.0155,3.0155,0,0,0,13.1782,7H7a1,1,0,0,0-.8945.5527l-4,8A1,1,0,0,0,2,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.6182,9h4.56A3.0147,3.0147,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159A3.0155,3.0155,0,0,0,18.8218,9h4.56l-3.2763,6.5527A1,1,0,0,0,20,16ZM7,19a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,19Zm2.3821-4H4.6179L7,10.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,10a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,19Zm0-8.7637L27.3821,15H22.6179Z"
    })), children);
  });
  var Scales24 = /*#__PURE__*/React__default['default'].forwardRef(function Scales24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$7 || (_path222$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L25.896,7.5562a.8913.8913,0,0,0-.0454-.0816A1,1,0,0,0,25,7H18.8218A3.0155,3.0155,0,0,0,17,5.1841V2H15V5.1841A3.0155,3.0155,0,0,0,13.1782,7H7a1,1,0,0,0-.8945.5527l-4,8A1,1,0,0,0,2,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.6182,9h4.56A3.0147,3.0147,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159A3.0155,3.0155,0,0,0,18.8218,9h4.56l-3.2763,6.5527A1,1,0,0,0,20,16ZM7,19a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,19Zm2.3821-4H4.6179L7,10.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,10a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,19Zm0-8.7637L27.3821,15H22.6179Z"
    })), children);
  });
  var Scales20 = /*#__PURE__*/React__default['default'].forwardRef(function Scales20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$7 || (_path223$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L25.896,7.5562a.8913.8913,0,0,0-.0454-.0816A1,1,0,0,0,25,7H18.8218A3.0155,3.0155,0,0,0,17,5.1841V2H15V5.1841A3.0155,3.0155,0,0,0,13.1782,7H7a1,1,0,0,0-.8945.5527l-4,8A1,1,0,0,0,2,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.6182,9h4.56A3.0147,3.0147,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159A3.0155,3.0155,0,0,0,18.8218,9h4.56l-3.2763,6.5527A1,1,0,0,0,20,16ZM7,19a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,19Zm2.3821-4H4.6179L7,10.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,10a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,19Zm0-8.7637L27.3821,15H22.6179Z"
    })), children);
  });
  var Scales16 = /*#__PURE__*/React__default['default'].forwardRef(function Scales16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$7 || (_path224$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L25.896,7.5562a.8913.8913,0,0,0-.0454-.0816A1,1,0,0,0,25,7H18.8218A3.0155,3.0155,0,0,0,17,5.1841V2H15V5.1841A3.0155,3.0155,0,0,0,13.1782,7H7a1,1,0,0,0-.8945.5527l-4,8A1,1,0,0,0,2,16a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.6182,9h4.56A3.0147,3.0147,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159A3.0155,3.0155,0,0,0,18.8218,9h4.56l-3.2763,6.5527A1,1,0,0,0,20,16ZM7,19a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,19Zm2.3821-4H4.6179L7,10.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,10a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,19Zm0-8.7637L27.3821,15H22.6179Z"
    })), children);
  });
  var ScalesTipped32 = /*#__PURE__*/React__default['default'].forwardRef(function ScalesTipped32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$7 || (_path225$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473l-4-8a1,1,0,0,0-1.2109-.5014l-6.3308,2.11A3.0322,3.0322,0,0,0,17,5.1841V2H15V5.1841a2.9949,2.9949,0,0,0-1.9956,2.76l-6.3208,2.107a1,1,0,0,0-.5781.5014l-4,8A1,1,0,0,0,2,19a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.41,11.584l5.237-1.7456A3.0285,3.0285,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159a2.9951,2.9951,0,0,0,1.9956-2.76l4.03-1.3438-2.92,5.8408A1,1,0,0,0,20,13ZM7,22a2.9956,2.9956,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,22Zm2.3821-4H4.6179L7,13.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,7a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,16Zm0-8.7637L27.3821,12H22.6179Z"
    })), children);
  });
  var ScalesTipped24 = /*#__PURE__*/React__default['default'].forwardRef(function ScalesTipped24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$7 || (_path226$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473l-4-8a1,1,0,0,0-1.2109-.5014l-6.3308,2.11A3.0322,3.0322,0,0,0,17,5.1841V2H15V5.1841a2.9949,2.9949,0,0,0-1.9956,2.76l-6.3208,2.107a1,1,0,0,0-.5781.5014l-4,8A1,1,0,0,0,2,19a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.41,11.584l5.237-1.7456A3.0285,3.0285,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159a2.9951,2.9951,0,0,0,1.9956-2.76l4.03-1.3438-2.92,5.8408A1,1,0,0,0,20,13ZM7,22a2.9956,2.9956,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,22Zm2.3821-4H4.6179L7,13.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,7a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,16Zm0-8.7637L27.3821,12H22.6179Z"
    })), children);
  });
  var ScalesTipped20 = /*#__PURE__*/React__default['default'].forwardRef(function ScalesTipped20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$7 || (_path227$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473l-4-8a1,1,0,0,0-1.2109-.5014l-6.3308,2.11A3.0322,3.0322,0,0,0,17,5.1841V2H15V5.1841a2.9949,2.9949,0,0,0-1.9956,2.76l-6.3208,2.107a1,1,0,0,0-.5781.5014l-4,8A1,1,0,0,0,2,19a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.41,11.584l5.237-1.7456A3.0285,3.0285,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159a2.9951,2.9951,0,0,0,1.9956-2.76l4.03-1.3438-2.92,5.8408A1,1,0,0,0,20,13ZM7,22a2.9956,2.9956,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,22Zm2.3821-4H4.6179L7,13.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,7a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,16Zm0-8.7637L27.3821,12H22.6179Z"
    })), children);
  });
  var ScalesTipped16 = /*#__PURE__*/React__default['default'].forwardRef(function ScalesTipped16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$7 || (_path228$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473l-4-8a1,1,0,0,0-1.2109-.5014l-6.3308,2.11A3.0322,3.0322,0,0,0,17,5.1841V2H15V5.1841a2.9949,2.9949,0,0,0-1.9956,2.76l-6.3208,2.107a1,1,0,0,0-.5781.5014l-4,8A1,1,0,0,0,2,19a5,5,0,0,0,10,0,1,1,0,0,0-.1055-.4473L8.41,11.584l5.237-1.7456A3.0285,3.0285,0,0,0,15,10.8154V28H6v2H26V28H17V10.8159a2.9951,2.9951,0,0,0,1.9956-2.76l4.03-1.3438-2.92,5.8408A1,1,0,0,0,20,13ZM7,22a2.9956,2.9956,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,7,22Zm2.3821-4H4.6179L7,13.2363ZM16,9a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,16,9Zm9,7a2.9958,2.9958,0,0,1-2.8152-2h5.63A2.9956,2.9956,0,0,1,25,16Zm0-8.7637L27.3821,12H22.6179Z"
    })), children);
  });
  var Scalpel32 = /*#__PURE__*/React__default['default'].forwardRef(function Scalpel32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$7 || (_path229$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var Scalpel24 = /*#__PURE__*/React__default['default'].forwardRef(function Scalpel24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$7 || (_path230$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var Scalpel20 = /*#__PURE__*/React__default['default'].forwardRef(function Scalpel20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$7 || (_path231$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var Scalpel16 = /*#__PURE__*/React__default['default'].forwardRef(function Scalpel16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$7 || (_path232$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"
    })), children);
  });
  var WatsonHealthScalpelCursor32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelCursor32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$7 || (_path233$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM13 4L4 4 4 13 6 13 6 6 13 6 13 4z"
    })), children);
  });
  var WatsonHealthScalpelCursor24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelCursor24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$7 || (_path234$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM13 4L4 4 4 13 6 13 6 6 13 6 13 4z"
    })), children);
  });
  var WatsonHealthScalpelCursor20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelCursor20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$7 || (_path235$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM13 4L4 4 4 13 6 13 6 6 13 6 13 4z"
    })), children);
  });
  var WatsonHealthScalpelCursor16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelCursor16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$7 || (_path236$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM13 4L4 4 4 13 6 13 6 6 13 6 13 4z"
    })), children);
  });
  var WatsonHealthScalpelLasso32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelLasso32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$7 || (_path237$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM11 2H7a4.9843 4.9843 0 00-3.8633 8.1528A2.9586 2.9586 0 003 11a2.9945 2.9945 0 002 2.8154V14a2.0025 2.0025 0 01-2 2H2v2H3a4.0045 4.0045 0 004-4v-.1841A2.9959 2.9959 0 008.8157 12H11A5 5 0 0011 2zM6 12a1 1 0 111-1A1.0009 1.0009 0 016 12zm5-2H8.8157A2.974 2.974 0 004.394 8.4746 2.9908 2.9908 0 017 4h4a3 3 0 010 6z"
    })), children);
  });
  var WatsonHealthScalpelLasso24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelLasso24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$7 || (_path238$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM11 2H7a4.9843 4.9843 0 00-3.8633 8.1528A2.9586 2.9586 0 003 11a2.9945 2.9945 0 002 2.8154V14a2.0025 2.0025 0 01-2 2H2v2H3a4.0045 4.0045 0 004-4v-.1841A2.9959 2.9959 0 008.8157 12H11A5 5 0 0011 2zM6 12a1 1 0 111-1A1.0009 1.0009 0 016 12zm5-2H8.8157A2.974 2.974 0 004.394 8.4746 2.9908 2.9908 0 017 4h4a3 3 0 010 6z"
    })), children);
  });
  var WatsonHealthScalpelLasso20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelLasso20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$7 || (_path239$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM11 2H7a4.9843 4.9843 0 00-3.8633 8.1528A2.9586 2.9586 0 003 11a2.9945 2.9945 0 002 2.8154V14a2.0025 2.0025 0 01-2 2H2v2H3a4.0045 4.0045 0 004-4v-.1841A2.9959 2.9959 0 008.8157 12H11A5 5 0 0011 2zM6 12a1 1 0 111-1A1.0009 1.0009 0 016 12zm5-2H8.8157A2.974 2.974 0 004.394 8.4746 2.9908 2.9908 0 017 4h4a3 3 0 010 6z"
    })), children);
  });
  var WatsonHealthScalpelLasso16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelLasso16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$7 || (_path240$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1338a4.0941 4.0941 0 00-5.6562 0L.3433 29.9619H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.79a3.9984 3.9984 0 000-5.6562zM12.2928 20.8406l2.086-2.0858 2.8293 2.8293L15.1224 23.67zM11.71 27.083a2.9824 2.9824 0 01-2.1215.8789H5.1714l5.7073-5.7072 2.83 2.83zM27.4141 11.376L18.6221 20.17l-2.8293-2.8292 8.7931-8.7928a2.0471 2.0471 0 012.8282 0 1.9993 1.9993 0 010 2.8281zM11 2H7a4.9843 4.9843 0 00-3.8633 8.1528A2.9586 2.9586 0 003 11a2.9945 2.9945 0 002 2.8154V14a2.0025 2.0025 0 01-2 2H2v2H3a4.0045 4.0045 0 004-4v-.1841A2.9959 2.9959 0 008.8157 12H11A5 5 0 0011 2zM6 12a1 1 0 111-1A1.0009 1.0009 0 016 12zm5-2H8.8157A2.974 2.974 0 004.394 8.4746 2.9908 2.9908 0 017 4h4a3 3 0 010 6z"
    })), children);
  });
  var WatsonHealthScalpelSelect32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelSelect32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$7 || (_path241$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1719a4.0941 4.0941 0 00-5.6562 0L.3433 30H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.8281a3.9984 3.9984 0 000-5.6562zM12.2928 20.8787l2.086-2.0859 2.8293 2.8294-2.0857 2.0862zM11.71 27.1211A2.9824 2.9824 0 019.5889 28H5.1714l5.7073-5.7072 2.83 2.83zm15.7037-15.707l-8.792 8.7939-2.8293-2.8292 8.7931-8.7929a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM15 2a2.9948 2.9948 0 00-2.8157 2H7.8156A2.9925 2.9925 0 104 7.8154v4.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8156 6h4.3686A2.9947 2.9947 0 1015 2zM5 16a1 1 0 111-1A1.0008 1.0008 0 015 16zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zM15 6a1 1 0 111-1A1.0008 1.0008 0 0115 6z"
    })), children);
  });
  var WatsonHealthScalpelSelect24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelSelect24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$7 || (_path242$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1719a4.0941 4.0941 0 00-5.6562 0L.3433 30H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.8281a3.9984 3.9984 0 000-5.6562zM12.2928 20.8787l2.086-2.0859 2.8293 2.8294-2.0857 2.0862zM11.71 27.1211A2.9824 2.9824 0 019.5889 28H5.1714l5.7073-5.7072 2.83 2.83zm15.7037-15.707l-8.792 8.7939-2.8293-2.8292 8.7931-8.7929a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM15 2a2.9948 2.9948 0 00-2.8157 2H7.8156A2.9925 2.9925 0 104 7.8154v4.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8156 6h4.3686A2.9947 2.9947 0 1015 2zM5 16a1 1 0 111-1A1.0008 1.0008 0 015 16zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zM15 6a1 1 0 111-1A1.0008 1.0008 0 0115 6z"
    })), children);
  });
  var WatsonHealthScalpelSelect20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelSelect20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$7 || (_path243$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1719a4.0941 4.0941 0 00-5.6562 0L.3433 30H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.8281a3.9984 3.9984 0 000-5.6562zM12.2928 20.8787l2.086-2.0859 2.8293 2.8294-2.0857 2.0862zM11.71 27.1211A2.9824 2.9824 0 019.5889 28H5.1714l5.7073-5.7072 2.83 2.83zm15.7037-15.707l-8.792 8.7939-2.8293-2.8292 8.7931-8.7929a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM15 2a2.9948 2.9948 0 00-2.8157 2H7.8156A2.9925 2.9925 0 104 7.8154v4.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8156 6h4.3686A2.9947 2.9947 0 1015 2zM5 16a1 1 0 111-1A1.0008 1.0008 0 015 16zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zM15 6a1 1 0 111-1A1.0008 1.0008 0 0115 6z"
    })), children);
  });
  var WatsonHealthScalpelSelect16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthScalpelSelect16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$7 || (_path244$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.8281 7.1719a4.0941 4.0941 0 00-5.6562 0L.3433 30H9.5889a4.9682 4.9682 0 003.5356-1.4648L28.8281 12.8281a3.9984 3.9984 0 000-5.6562zM12.2928 20.8787l2.086-2.0859 2.8293 2.8294-2.0857 2.0862zM11.71 27.1211A2.9824 2.9824 0 019.5889 28H5.1714l5.7073-5.7072 2.83 2.83zm15.7037-15.707l-8.792 8.7939-2.8293-2.8292 8.7931-8.7929a2.0473 2.0473 0 012.8282 0 1.9995 1.9995 0 010 2.8282zM15 2a2.9948 2.9948 0 00-2.8157 2H7.8156A2.9925 2.9925 0 104 7.8154v4.3687a3 3 0 102 0V7.8159A2.9959 2.9959 0 007.8156 6h4.3686A2.9947 2.9947 0 1015 2zM5 16a1 1 0 111-1A1.0008 1.0008 0 015 16zM5 6A1 1 0 116 5 1.0008 1.0008 0 015 6zM15 6a1 1 0 111-1A1.0008 1.0008 0 0115 6z"
    })), children);
  });
  var Scan32 = /*#__PURE__*/React__default['default'].forwardRef(function Scan32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$7 || (_path245$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"
    })), _path246$7 || (_path246$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"
    })), children);
  });
  var Scan24 = /*#__PURE__*/React__default['default'].forwardRef(function Scan24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$7 || (_path247$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"
    })), _path248$7 || (_path248$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"
    })), children);
  });
  var Scan20 = /*#__PURE__*/React__default['default'].forwardRef(function Scan20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$7 || (_path249$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"
    })), _path250$7 || (_path250$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"
    })), children);
  });
  var Scan16 = /*#__PURE__*/React__default['default'].forwardRef(function Scan16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$7 || (_path251$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"
    })), _path252$7 || (_path252$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"
    })), children);
  });
  var ScanAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ScanAlt32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$7 || (_path253$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2 2 0 01-2-2V19h2v3H22V19h2v3A2 2 0 0122 24zM2 15H30V17H2zM24 13H22V10H10v3H8V10a2 2 0 012-2H22a2 2 0 012 2zM30 10L28 10 28 4 22 4 22 2 30 2 30 10zM4 10L2 10 2 2 10 2 10 4 4 4 4 10zM10 30L2 30 2 22 4 22 4 28 10 28 10 30zM30 30L22 30 22 28 28 28 28 22 30 22 30 30z"
    })), children);
  });
  var ScanAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ScanAlt24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$7 || (_path254$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2 2 0 01-2-2V19h2v3H22V19h2v3A2 2 0 0122 24zM2 15H30V17H2zM24 13H22V10H10v3H8V10a2 2 0 012-2H22a2 2 0 012 2zM30 10L28 10 28 4 22 4 22 2 30 2 30 10zM4 10L2 10 2 2 10 2 10 4 4 4 4 10zM10 30L2 30 2 22 4 22 4 28 10 28 10 30zM30 30L22 30 22 28 28 28 28 22 30 22 30 30z"
    })), children);
  });
  var ScanAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ScanAlt20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$7 || (_path255$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2 2 0 01-2-2V19h2v3H22V19h2v3A2 2 0 0122 24zM2 15H30V17H2zM24 13H22V10H10v3H8V10a2 2 0 012-2H22a2 2 0 012 2zM30 10L28 10 28 4 22 4 22 2 30 2 30 10zM4 10L2 10 2 2 10 2 10 4 4 4 4 10zM10 30L2 30 2 22 4 22 4 28 10 28 10 30zM30 30L22 30 22 28 28 28 28 22 30 22 30 30z"
    })), children);
  });
  var ScanAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ScanAlt16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$7 || (_path256$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 24H10a2 2 0 01-2-2V19h2v3H22V19h2v3A2 2 0 0122 24zM2 15H30V17H2zM24 13H22V10H10v3H8V10a2 2 0 012-2H22a2 2 0 012 2zM30 10L28 10 28 4 22 4 22 2 30 2 30 10zM4 10L2 10 2 2 10 2 10 4 4 4 4 10zM10 30L2 30 2 22 4 22 4 28 10 28 10 30zM30 30L22 30 22 28 28 28 28 22 30 22 30 30z"
    })), children);
  });
  var ScanDisabled32 = /*#__PURE__*/React__default['default'].forwardRef(function ScanDisabled32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$7 || (_path257$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3826 2.0762a.9993.9993 0 00-1.09.2168l-26 26A1 1 0 003 30h8V28H5.4143l4-4H22a2.0021 2.0021 0 002-2V9.4146l4-4V11h2V3A1 1 0 0029.3826 2.0762zM22 22H11.4143L22 11.4146zM10 17.7554V10h7.7554l2-2H10a2.0025 2.0025 0 00-2 2v9.7554zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM4 23.755L4 21 2 21 2 25.754 4 23.755zM25.755 2L21 2 21 4 23.755 4 25.755 2z"
    })), children);
  });
  var ScanDisabled24 = /*#__PURE__*/React__default['default'].forwardRef(function ScanDisabled24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$7 || (_path258$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3826 2.0762a.9993.9993 0 00-1.09.2168l-26 26A1 1 0 003 30h8V28H5.4143l4-4H22a2.0021 2.0021 0 002-2V9.4146l4-4V11h2V3A1 1 0 0029.3826 2.0762zM22 22H11.4143L22 11.4146zM10 17.7554V10h7.7554l2-2H10a2.0025 2.0025 0 00-2 2v9.7554zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM4 23.755L4 21 2 21 2 25.754 4 23.755zM25.755 2L21 2 21 4 23.755 4 25.755 2z"
    })), children);
  });
  var ScanDisabled20 = /*#__PURE__*/React__default['default'].forwardRef(function ScanDisabled20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$7 || (_path259$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3826 2.0762a.9993.9993 0 00-1.09.2168l-26 26A1 1 0 003 30h8V28H5.4143l4-4H22a2.0021 2.0021 0 002-2V9.4146l4-4V11h2V3A1 1 0 0029.3826 2.0762zM22 22H11.4143L22 11.4146zM10 17.7554V10h7.7554l2-2H10a2.0025 2.0025 0 00-2 2v9.7554zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM4 23.755L4 21 2 21 2 25.754 4 23.755zM25.755 2L21 2 21 4 23.755 4 25.755 2z"
    })), children);
  });
  var ScanDisabled16 = /*#__PURE__*/React__default['default'].forwardRef(function ScanDisabled16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$7 || (_path260$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3826 2.0762a.9993.9993 0 00-1.09.2168l-26 26A1 1 0 003 30h8V28H5.4143l4-4H22a2.0021 2.0021 0 002-2V9.4146l4-4V11h2V3A1 1 0 0029.3826 2.0762zM22 22H11.4143L22 11.4146zM10 17.7554V10h7.7554l2-2H10a2.0025 2.0025 0 00-2 2v9.7554zM11 2L2 2 2 11 4 11 4 4 11 4 11 2zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM4 23.755L4 21 2 21 2 25.754 4 23.755zM25.755 2L21 2 21 4 23.755 4 25.755 2z"
    })), children);
  });
  var ScatterMatrix32 = /*#__PURE__*/React__default['default'].forwardRef(function ScatterMatrix32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$5 || (_circle5$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "9.5",
      r: "2.5"
    })), _circle6$5 || (_circle6$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "22.5",
      r: "2.5"
    })), _circle7$5 || (_circle7$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.5",
      cy: "22.5",
      r: "2.5"
    })), _path261$7 || (_path261$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,13H17V4H28ZM15,4V15H4V4ZM4,17H15V28H4ZM17,28V17H28V28Z"
    })), children);
  });
  var ScatterMatrix24 = /*#__PURE__*/React__default['default'].forwardRef(function ScatterMatrix24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$5 || (_circle8$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "9.5",
      r: "2.5"
    })), _circle9$5 || (_circle9$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "22.5",
      r: "2.5"
    })), _circle10$5 || (_circle10$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.5",
      cy: "22.5",
      r: "2.5"
    })), _path262$7 || (_path262$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,13H17V4H28ZM15,4V15H4V4ZM4,17H15V28H4ZM17,28V17H28V28Z"
    })), children);
  });
  var ScatterMatrix20 = /*#__PURE__*/React__default['default'].forwardRef(function ScatterMatrix20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$5 || (_circle11$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "9.5",
      r: "2.5"
    })), _circle12$5 || (_circle12$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "22.5",
      r: "2.5"
    })), _circle13$5 || (_circle13$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.5",
      cy: "22.5",
      r: "2.5"
    })), _path263$7 || (_path263$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,13H17V4H28ZM15,4V15H4V4ZM4,17H15V28H4ZM17,28V17H28V28Z"
    })), children);
  });
  var ScatterMatrix16 = /*#__PURE__*/React__default['default'].forwardRef(function ScatterMatrix16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$5 || (_circle14$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "9.5",
      r: "2.5"
    })), _circle15$5 || (_circle15$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9.5",
      cy: "22.5",
      r: "2.5"
    })), _circle16$5 || (_circle16$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22.5",
      cy: "22.5",
      r: "2.5"
    })), _path264$7 || (_path264$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,2H4A2.0023,2.0023,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,13H17V4H28ZM15,4V15H4V4ZM4,17H15V28H4ZM17,28V17H28V28Z"
    })), children);
  });
  var Schematics32 = /*#__PURE__*/React__default['default'].forwardRef(function Schematics32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$7 || (_path265$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"
    })), children);
  });
  var Schematics24 = /*#__PURE__*/React__default['default'].forwardRef(function Schematics24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$7 || (_path266$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"
    })), children);
  });
  var Schematics20 = /*#__PURE__*/React__default['default'].forwardRef(function Schematics20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$7 || (_path267$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"
    })), children);
  });
  var Schematics16 = /*#__PURE__*/React__default['default'].forwardRef(function Schematics16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$7 || (_path268$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"
    })), children);
  });
  var Scooter32 = /*#__PURE__*/React__default['default'].forwardRef(function Scooter32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$7 || (_path269$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28a4 4 0 114-4A4.0045 4.0045 0 0126 28zm0-6a2 2 0 102 2A2.0023 2.0023 0 0026 22zM24 8H18v2h6a1 1 0 010 2H21a1 1 0 00-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0011.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 00-5 5v2a1 1 0 001 1H4a4 4 0 008 0h7a1 1 0 00.8574-.4854l3-5a1 1 0 00.1231-.7109L22.22 14H24a3 3 0 000-6zM8 26a2.0025 2.0025 0 01-2-2h4A2.0025 2.0025 0 018 26zM4 22V21a3.0033 3.0033 0 013-3h5.4561l1.2 4z"
    })), children);
  });
  var Scooter24 = /*#__PURE__*/React__default['default'].forwardRef(function Scooter24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$7 || (_path270$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28a4 4 0 114-4A4.0045 4.0045 0 0126 28zm0-6a2 2 0 102 2A2.0023 2.0023 0 0026 22zM24 8H18v2h6a1 1 0 010 2H21a1 1 0 00-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0011.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 00-5 5v2a1 1 0 001 1H4a4 4 0 008 0h7a1 1 0 00.8574-.4854l3-5a1 1 0 00.1231-.7109L22.22 14H24a3 3 0 000-6zM8 26a2.0025 2.0025 0 01-2-2h4A2.0025 2.0025 0 018 26zM4 22V21a3.0033 3.0033 0 013-3h5.4561l1.2 4z"
    })), children);
  });
  var Scooter20 = /*#__PURE__*/React__default['default'].forwardRef(function Scooter20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$7 || (_path271$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28a4 4 0 114-4A4.0045 4.0045 0 0126 28zm0-6a2 2 0 102 2A2.0023 2.0023 0 0026 22zM24 8H18v2h6a1 1 0 010 2H21a1 1 0 00-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0011.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 00-5 5v2a1 1 0 001 1H4a4 4 0 008 0h7a1 1 0 00.8574-.4854l3-5a1 1 0 00.1231-.7109L22.22 14H24a3 3 0 000-6zM8 26a2.0025 2.0025 0 01-2-2h4A2.0025 2.0025 0 018 26zM4 22V21a3.0033 3.0033 0 013-3h5.4561l1.2 4z"
    })), children);
  });
  var Scooter16 = /*#__PURE__*/React__default['default'].forwardRef(function Scooter16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$7 || (_path272$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28a4 4 0 114-4A4.0045 4.0045 0 0126 28zm0-6a2 2 0 102 2A2.0023 2.0023 0 0026 22zM24 8H18v2h6a1 1 0 010 2H21a1 1 0 00-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0011.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 00-5 5v2a1 1 0 001 1H4a4 4 0 008 0h7a1 1 0 00.8574-.4854l3-5a1 1 0 00.1231-.7109L22.22 14H24a3 3 0 000-6zM8 26a2.0025 2.0025 0 01-2-2h4A2.0025 2.0025 0 018 26zM4 22V21a3.0033 3.0033 0 013-3h5.4561l1.2 4z"
    })), children);
  });
  var ScooterFront32 = /*#__PURE__*/React__default['default'].forwardRef(function ScooterFront32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$7 || (_path273$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V28H15z"
    })), _path274$7 || (_path274$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"
    })), children);
  });
  var ScooterFront24 = /*#__PURE__*/React__default['default'].forwardRef(function ScooterFront24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$7 || (_path275$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V28H15z"
    })), _path276$7 || (_path276$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"
    })), children);
  });
  var ScooterFront20 = /*#__PURE__*/React__default['default'].forwardRef(function ScooterFront20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$7 || (_path277$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V28H15z"
    })), _path278$7 || (_path278$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"
    })), children);
  });
  var ScooterFront16 = /*#__PURE__*/React__default['default'].forwardRef(function ScooterFront16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$7 || (_path279$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 19H17V28H15z"
    })), _path280$7 || (_path280$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"
    })), children);
  });
  var Screen32 = /*#__PURE__*/React__default['default'].forwardRef(function Screen32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$7 || (_path281$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"
    })), children);
  });
  var Screen24 = /*#__PURE__*/React__default['default'].forwardRef(function Screen24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$7 || (_path282$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"
    })), children);
  });
  var Screen20 = /*#__PURE__*/React__default['default'].forwardRef(function Screen20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$7 || (_path283$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"
    })), children);
  });
  var Screen16 = /*#__PURE__*/React__default['default'].forwardRef(function Screen16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$7 || (_path284$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"
    })), children);
  });
  var ScreenOff32 = /*#__PURE__*/React__default['default'].forwardRef(function ScreenOff32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$7 || (_path285$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"
    })), children);
  });
  var ScreenOff24 = /*#__PURE__*/React__default['default'].forwardRef(function ScreenOff24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$7 || (_path286$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"
    })), children);
  });
  var ScreenOff20 = /*#__PURE__*/React__default['default'].forwardRef(function ScreenOff20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$7 || (_path287$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"
    })), children);
  });
  var ScreenOff16 = /*#__PURE__*/React__default['default'].forwardRef(function ScreenOff16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$7 || (_path288$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"
    })), children);
  });
  var Script32 = /*#__PURE__*/React__default['default'].forwardRef(function Script32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$7 || (_path289$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26z"
    })), _path290$7 || (_path290$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h6ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Script24 = /*#__PURE__*/React__default['default'].forwardRef(function Script24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$7 || (_path291$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26z"
    })), _path292$7 || (_path292$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h6ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Script20 = /*#__PURE__*/React__default['default'].forwardRef(function Script20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$7 || (_path293$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26z"
    })), _path294$7 || (_path294$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h6ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Script16 = /*#__PURE__*/React__default['default'].forwardRef(function Script16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$7 || (_path295$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26z"
    })), _path296$7 || (_path296$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v6h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h6ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var ScriptReference32 = /*#__PURE__*/React__default['default'].forwardRef(function ScriptReference32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$7 || (_path297$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26zM18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM25.7 9.3l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16H8V4h8v6a2.0058 2.0058 0 002 2h6v6h2V10A.9092.9092 0 0025.7 9.3zM18 10V4.4L23.6 10z"
    })), children);
  });
  var ScriptReference24 = /*#__PURE__*/React__default['default'].forwardRef(function ScriptReference24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$7 || (_path298$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26zM18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM25.7 9.3l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16H8V4h8v6a2.0058 2.0058 0 002 2h6v6h2V10A.9092.9092 0 0025.7 9.3zM18 10V4.4L23.6 10z"
    })), children);
  });
  var ScriptReference20 = /*#__PURE__*/React__default['default'].forwardRef(function ScriptReference20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$7 || (_path299$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26zM18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM25.7 9.3l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16H8V4h8v6a2.0058 2.0058 0 002 2h6v6h2V10A.9092.9092 0 0025.7 9.3zM18 10V4.4L23.6 10z"
    })), children);
  });
  var ScriptReference16 = /*#__PURE__*/React__default['default'].forwardRef(function ScriptReference16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$7 || (_path300$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM27.17 26L24.59 28.58 26 30 30 26 26 22 24.58 23.41 27.17 26zM18.83 26L21.41 23.42 20 22 16 26 20 30 21.42 28.59 18.83 26zM25.7 9.3l-7-7A.9087.9087 0 0018 2H8A2.0058 2.0058 0 006 4V16H8V4h8v6a2.0058 2.0058 0 002 2h6v6h2V10A.9092.9092 0 0025.7 9.3zM18 10V4.4L23.6 10z"
    })), children);
  });
  var Sdk32 = /*#__PURE__*/React__default['default'].forwardRef(function Sdk32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$7 || (_path301$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 014 4v6A4.0118 4.0118 0 0116 23zm-2-2h2a2.0059 2.0059 0 002-2V13a2.0059 2.0059 0 00-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 01-2-2V11A2.0059 2.0059 0 014 9h6v2H4v4H8a2.0059 2.0059 0 012 2v4A2.0059 2.0059 0 018 23z"
    })), children);
  });
  var Sdk24 = /*#__PURE__*/React__default['default'].forwardRef(function Sdk24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$7 || (_path302$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 014 4v6A4.0118 4.0118 0 0116 23zm-2-2h2a2.0059 2.0059 0 002-2V13a2.0059 2.0059 0 00-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 01-2-2V11A2.0059 2.0059 0 014 9h6v2H4v4H8a2.0059 2.0059 0 012 2v4A2.0059 2.0059 0 018 23z"
    })), children);
  });
  var Sdk20 = /*#__PURE__*/React__default['default'].forwardRef(function Sdk20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$7 || (_path303$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 014 4v6A4.0118 4.0118 0 0116 23zm-2-2h2a2.0059 2.0059 0 002-2V13a2.0059 2.0059 0 00-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 01-2-2V11A2.0059 2.0059 0 014 9h6v2H4v4H8a2.0059 2.0059 0 012 2v4A2.0059 2.0059 0 018 23z"
    })), children);
  });
  var Sdk16 = /*#__PURE__*/React__default['default'].forwardRef(function Sdk16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$7 || (_path304$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 014 4v6A4.0118 4.0118 0 0116 23zm-2-2h2a2.0059 2.0059 0 002-2V13a2.0059 2.0059 0 00-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 01-2-2V11A2.0059 2.0059 0 014 9h6v2H4v4H8a2.0059 2.0059 0 012 2v4A2.0059 2.0059 0 018 23z"
    })), children);
  });
  var Search32 = /*#__PURE__*/React__default['default'].forwardRef(function Search32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$7 || (_path305$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27.5859l-7.5521-7.5521a11.0177,11.0177,0,1,0-1.4141,1.4141L27.5859,29ZM4,13a9,9,0,1,1,9,9A9.01,9.01,0,0,1,4,13Z"
    })), children);
  });
  var Search24 = /*#__PURE__*/React__default['default'].forwardRef(function Search24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$7 || (_path306$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27.5859l-7.5521-7.5521a11.0177,11.0177,0,1,0-1.4141,1.4141L27.5859,29ZM4,13a9,9,0,1,1,9,9A9.01,9.01,0,0,1,4,13Z"
    })), children);
  });
  var Search20 = /*#__PURE__*/React__default['default'].forwardRef(function Search20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$7 || (_path307$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,27.5859l-7.5521-7.5521a11.0177,11.0177,0,1,0-1.4141,1.4141L27.5859,29ZM4,13a9,9,0,1,1,9,9A9.01,9.01,0,0,1,4,13Z"
    })), children);
  });
  var Search16 = /*#__PURE__*/React__default['default'].forwardRef(function Search16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$7 || (_path308$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,14.3L10.7,10c1.9-2.3,1.6-5.8-0.7-7.7S4.2,0.7,2.3,3S0.7,8.8,3,10.7c2,1.7,5,1.7,7,0l4.3,4.3L15,14.3z M2,6.5\tC2,4,4,2,6.5,2S11,4,11,6.5S9,11,6.5,11S2,9,2,6.5z"
    })), children);
  });
  var SearchAdvanced32 = /*#__PURE__*/React__default['default'].forwardRef(function SearchAdvanced32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$7 || (_path309$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 28.5859l-5.9751-5.9751a9.0234 9.0234 0 10-1.4141 1.4141L22.5859 30zM4 17a7 7 0 117 7A7.0078 7.0078 0 014 17z"
    })), children);
  });
  var SearchAdvanced24 = /*#__PURE__*/React__default['default'].forwardRef(function SearchAdvanced24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$7 || (_path310$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 28.5859l-5.9751-5.9751a9.0234 9.0234 0 10-1.4141 1.4141L22.5859 30zM4 17a7 7 0 117 7A7.0078 7.0078 0 014 17z"
    })), children);
  });
  var SearchAdvanced20 = /*#__PURE__*/React__default['default'].forwardRef(function SearchAdvanced20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$7 || (_path311$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 28.5859l-5.9751-5.9751a9.0234 9.0234 0 10-1.4141 1.4141L22.5859 30zM4 17a7 7 0 117 7A7.0078 7.0078 0 014 17z"
    })), children);
  });
  var SearchAdvanced16 = /*#__PURE__*/React__default['default'].forwardRef(function SearchAdvanced16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$7 || (_path312$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6zM24 28.5859l-5.9751-5.9751a9.0234 9.0234 0 10-1.4141 1.4141L22.5859 30zM4 17a7 7 0 117 7A7.0078 7.0078 0 014 17z"
    })), children);
  });
  var SearchLocate32 = /*#__PURE__*/React__default['default'].forwardRef(function SearchLocate32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$7 || (_path313$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L28.5859 30zM19 25a6 6 0 116-6A6.0066 6.0066 0 0119 25zM2 12H10V14H2zM2 2H18V4H2zM2 7H18V9H2z"
    })), children);
  });
  var SearchLocate24 = /*#__PURE__*/React__default['default'].forwardRef(function SearchLocate24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$7 || (_path314$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L28.5859 30zM19 25a6 6 0 116-6A6.0066 6.0066 0 0119 25zM2 12H10V14H2zM2 2H18V4H2zM2 7H18V9H2z"
    })), children);
  });
  var SearchLocate20 = /*#__PURE__*/React__default['default'].forwardRef(function SearchLocate20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$7 || (_path315$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L28.5859 30zM19 25a6 6 0 116-6A6.0066 6.0066 0 0119 25zM2 12H10V14H2zM2 2H18V4H2zM2 7H18V9H2z"
    })), children);
  });
  var SearchLocate16 = /*#__PURE__*/React__default['default'].forwardRef(function SearchLocate16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$7 || (_path316$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L28.5859 30zM19 25a6 6 0 116-6A6.0066 6.0066 0 0119 25zM2 12H10V14H2zM2 2H18V4H2zM2 7H18V9H2z"
    })), children);
  });
  var Security32 = /*#__PURE__*/React__default['default'].forwardRef(function Security32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$7 || (_path317$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16.59L11.41 14 10 15.41 14 19.41 22 11.41 20.59 10 14 16.59z"
    })), _path318$7 || (_path318$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9818,10.9818,0,0,1,4,17V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V17a10.9818,10.9818,0,0,1-5.8242,9.7071ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var Security24 = /*#__PURE__*/React__default['default'].forwardRef(function Security24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$7 || (_path319$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16.59L11.41 14 10 15.41 14 19.41 22 11.41 20.59 10 14 16.59z"
    })), _path320$7 || (_path320$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9818,10.9818,0,0,1,4,17V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V17a10.9818,10.9818,0,0,1-5.8242,9.7071ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var Security20 = /*#__PURE__*/React__default['default'].forwardRef(function Security20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$7 || (_path321$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16.59L11.41 14 10 15.41 14 19.41 22 11.41 20.59 10 14 16.59z"
    })), _path322$7 || (_path322$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9818,10.9818,0,0,1,4,17V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V17a10.9818,10.9818,0,0,1-5.8242,9.7071ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var Security16 = /*#__PURE__*/React__default['default'].forwardRef(function Security16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$7 || (_path323$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 16.59L11.41 14 10 15.41 14 19.41 22 11.41 20.59 10 14 16.59z"
    })), _path324$7 || (_path324$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30,9.8242,26.7071A10.9818,10.9818,0,0,1,4,17V4A2.0021,2.0021,0,0,1,6,2H26a2.0021,2.0021,0,0,1,2,2V17a10.9818,10.9818,0,0,1-5.8242,9.7071ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"
    })), children);
  });
  var SecurityServices32 = /*#__PURE__*/React__default['default'].forwardRef(function SecurityServices32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$7 || (_path325$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path326$7 || (_path326$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26.667l-3.2344-1.7246A8.9858,8.9858,0,0,1,6,17V4H26V14h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,28.9336Z"
    })), children);
  });
  var SecurityServices24 = /*#__PURE__*/React__default['default'].forwardRef(function SecurityServices24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$7 || (_path327$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path328$7 || (_path328$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26.667l-3.2344-1.7246A8.9858,8.9858,0,0,1,6,17V4H26V14h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,28.9336Z"
    })), children);
  });
  var SecurityServices20 = /*#__PURE__*/React__default['default'].forwardRef(function SecurityServices20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$7 || (_path329$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path330$7 || (_path330$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26.667l-3.2344-1.7246A8.9858,8.9858,0,0,1,6,17V4H26V14h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,28.9336Z"
    })), children);
  });
  var SecurityServices16 = /*#__PURE__*/React__default['default'].forwardRef(function SecurityServices16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$7 || (_path331$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path332$7 || (_path332$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,26.667l-3.2344-1.7246A8.9858,8.9858,0,0,1,6,17V4H26V14h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V17a10.9814,10.9814,0,0,0,5.8242,9.707L14,28.9336Z"
    })), children);
  });
  var Select_0132 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0132(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$7 || (_path333$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM16 6H20V8H16zM24 6V8h4v4h2V8a2 2 0 00-2-2zM6 16H8V20H6zM8 28V24H6v4a2 2 0 002 2h4V28zM28 16H30V20H28zM16 28H20V30H16zM28 24v4H24v2h4a2 2 0 002-2V24z"
    })), children);
  });
  var Select_0124 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0124(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$7 || (_path334$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM16 6H20V8H16zM24 6V8h4v4h2V8a2 2 0 00-2-2zM6 16H8V20H6zM8 28V24H6v4a2 2 0 002 2h4V28zM28 16H30V20H28zM16 28H20V30H16zM28 24v4H24v2h4a2 2 0 002-2V24z"
    })), children);
  });
  var Select_0120 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0120(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$7 || (_path335$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM16 6H20V8H16zM24 6V8h4v4h2V8a2 2 0 00-2-2zM6 16H8V20H6zM8 28V24H6v4a2 2 0 002 2h4V28zM28 16H30V20H28zM16 28H20V30H16zM28 24v4H24v2h4a2 2 0 002-2V24z"
    })), children);
  });
  var Select_0116 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0116(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$7 || (_path336$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM16 6H20V8H16zM24 6V8h4v4h2V8a2 2 0 00-2-2zM6 16H8V20H6zM8 28V24H6v4a2 2 0 002 2h4V28zM28 16H30V20H28zM16 28H20V30H16zM28 24v4H24v2h4a2 2 0 002-2V24z"
    })), children);
  });
  var Select_0232 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0232(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$7 || (_path337$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM30 10V4H24V6H16V8h8v2h2V24H24v2H10V24H8V16H6v8H4v6h6V28H24v2h6V24H28V10zM8 28H6V26H8zm20 0H26V26h2zM26 6h2V8H26z"
    })), children);
  });
  var Select_0224 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0224(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$7 || (_path338$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM30 10V4H24V6H16V8h8v2h2V24H24v2H10V24H8V16H6v8H4v6h6V28H24v2h6V24H28V10zM8 28H6V26H8zm20 0H26V26h2zM26 6h2V8H26z"
    })), children);
  });
  var Select_0220 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0220(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$7 || (_path339$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM30 10V4H24V6H16V8h8v2h2V24H24v2H10V24H8V16H6v8H4v6h6V28H24v2h6V24H28V10zM8 28H6V26H8zm20 0H26V26h2zM26 6h2V8H26z"
    })), children);
  });
  var Select_0216 = /*#__PURE__*/React__default['default'].forwardRef(function Select_0216(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$7 || (_path340$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L8 6 8 2 6 2 6 6 2 6 2 8 6 8 6 12 8 12 8 8 12 8 12 6zM30 10V4H24V6H16V8h8v2h2V24H24v2H10V24H8V16H6v8H4v6h6V28H24v2h6V24H28V10zM8 28H6V26H8zm20 0H26V26h2zM26 6h2V8H26z"
    })), children);
  });
  var SelectWindow32 = /*#__PURE__*/React__default['default'].forwardRef(function SelectWindow32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$7 || (_path341$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM27 32a.9967.9967 0 01-.707-.293l-6.1377-6.1377L16.832 30.5547a1 1 0 01-1.79-.2676l-6-20A1 1 0 0110.2871 9.042l20 6a1 1 0 01.2676 1.79l-4.9854 3.3233L31.707 26.293a.9994.9994 0 010 1.414l-4 4A.9967.9967 0 0127 32zm0-2.4141L29.5859 27 22.431 19.845l5.2458-3.4978L11.4917 11.4917l4.8555 16.1851L19.845 22.431z"
    })), children);
  });
  var SelectWindow24 = /*#__PURE__*/React__default['default'].forwardRef(function SelectWindow24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$7 || (_path342$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM27 32a.9967.9967 0 01-.707-.293l-6.1377-6.1377L16.832 30.5547a1 1 0 01-1.79-.2676l-6-20A1 1 0 0110.2871 9.042l20 6a1 1 0 01.2676 1.79l-4.9854 3.3233L31.707 26.293a.9994.9994 0 010 1.414l-4 4A.9967.9967 0 0127 32zm0-2.4141L29.5859 27 22.431 19.845l5.2458-3.4978L11.4917 11.4917l4.8555 16.1851L19.845 22.431z"
    })), children);
  });
  var SelectWindow20 = /*#__PURE__*/React__default['default'].forwardRef(function SelectWindow20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$7 || (_path343$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM27 32a.9967.9967 0 01-.707-.293l-6.1377-6.1377L16.832 30.5547a1 1 0 01-1.79-.2676l-6-20A1 1 0 0110.2871 9.042l20 6a1 1 0 01.2676 1.79l-4.9854 3.3233L31.707 26.293a.9994.9994 0 010 1.414l-4 4A.9967.9967 0 0127 32zm0-2.4141L29.5859 27 22.431 19.845l5.2458-3.4978L11.4917 11.4917l4.8555 16.1851L19.845 22.431z"
    })), children);
  });
  var SelectWindow16 = /*#__PURE__*/React__default['default'].forwardRef(function SelectWindow16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$7 || (_path344$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM27 32a.9967.9967 0 01-.707-.293l-6.1377-6.1377L16.832 30.5547a1 1 0 01-1.79-.2676l-6-20A1 1 0 0110.2871 9.042l20 6a1 1 0 01.2676 1.79l-4.9854 3.3233L31.707 26.293a.9994.9994 0 010 1.414l-4 4A.9967.9967 0 0127 32zm0-2.4141L29.5859 27 22.431 19.845l5.2458-3.4978L11.4917 11.4917l4.8555 16.1851L19.845 22.431z"
    })), children);
  });
  var Send32 = /*#__PURE__*/React__default['default'].forwardRef(function Send32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$7 || (_path345$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"
    })), children);
  });
  var Send24 = /*#__PURE__*/React__default['default'].forwardRef(function Send24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$7 || (_path346$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"
    })), children);
  });
  var Send20 = /*#__PURE__*/React__default['default'].forwardRef(function Send20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$7 || (_path347$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"
    })), children);
  });
  var Send16 = /*#__PURE__*/React__default['default'].forwardRef(function Send16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$7 || (_path348$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"
    })), children);
  });
  var SendAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function SendAlt32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$7 || (_path349$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"
    })), children);
  });
  var SendAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function SendAlt24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$7 || (_path350$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"
    })), children);
  });
  var SendAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function SendAlt20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$7 || (_path351$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"
    })), children);
  });
  var SendAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function SendAlt16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$7 || (_path352$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"
    })), children);
  });
  var SendAltFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SendAltFilled32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$7 || (_path353$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"
    })), children);
  });
  var SendAltFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SendAltFilled24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$7 || (_path354$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"
    })), children);
  });

  var _path$7, _path2$7, _path3$7, _path4$7, _path5$7, _path6$7, _path7$7, _path8$7, _path9$7, _path10$7, _path11$7, _path12$7, _path13$7, _path14$7, _path15$7, _circle$6, _path16$7, _circle2$6, _path17$7, _circle3$6, _path18$7, _circle4$5, _path19$7, _circle5$4, _path20$7, _path21$7, _circle6$4, _path22$7, _path23$7, _circle7$4, _path24$7, _path25$7, _circle8$4, _path26$7, _path27$7, _circle9$4, _path28$7, _path29$7, _path30$7, _circle10$4, _path31$7, _path32$7, _path33$7, _circle11$4, _path34$7, _path35$7, _path36$7, _circle12$4, _path37$7, _path38$7, _path39$7, _path40$7, _path41$7, _path42$7, _path43$7, _path44$7, _path45$7, _path46$7, _path47$7, _path48$7, _path49$7, _path50$7, _path51$7, _path52$7, _path53$7, _path54$7, _path55$7, _path56$7, _path57$7, _path58$7, _path59$7, _path60$7, _path61$7, _path62$7, _path63$7, _path64$7, _path65$7, _path66$7, _path67$7, _path68$7, _path69$7, _path70$7, _path71$7, _path72$7, _path73$7, _path74$7, _path75$7, _path76$7, _path77$7, _path78$7, _path79$7, _path80$7, _path81$7, _path82$7, _circle13$4, _path83$7, _path84$7, _circle14$4, _path85$7, _path86$7, _circle15$4, _path87$7, _path88$7, _circle16$4, _path89$7, _path90$7, _path91$7, _path92$7, _path93$7, _path94$7, _path95$7, _path96$7, _path97$7, _path98$7, _path99$7, _path100$7, _path101$7, _path102$7, _path103$7, _path104$7, _path105$7, _path106$7, _path107$7, _path108$7, _path109$7, _path110$7, _path111$7, _path112$7, _path113$7, _path114$7, _path115$7, _path116$7, _path117$7, _path118$7, _path119$7, _path120$7, _path121$7, _path122$7, _path123$7, _path124$7, _path125$7, _path126$7, _circle17$4, _circle18$4, _path127$7, _circle19$4, _circle20$4, _path128$7, _circle21$4, _circle22$4, _path129$7, _circle23$4, _circle24$4, _path130$7, _circle25$3, _circle26$3, _path131$7, _path132$7, _circle27$3, _circle28$3, _path133$7, _path134$7, _circle29$3, _circle30$3, _path135$7, _path136$7, _circle31$3, _circle32$3, _path137$7, _path138$7, _circle33$3, _circle34$2, _path139$7, _path140$7, _circle35$2, _circle36$2, _path141$7, _path142$7, _circle37$1, _circle38$1, _path143$7, _path144$7, _circle39$1, _circle40$1, _path145$7, _path146$7, _circle41$1, _circle42$1, _path147$7, _path148$7, _circle43$1, _circle44$1, _path149$7, _path150$7, _circle45$1, _circle46$1, _path151$7, _path152$7, _circle47$1, _circle48$1, _path153$7, _path154$7, _circle49$1, _circle50$1, _path155$7, _path156$7, _circle51$1, _circle52$1, _path157$7, _path158$7, _circle53$1, _circle54$1, _path159$7, _path160$7, _circle55$1, _circle56$1, _path161$7, _path162$7, _circle57$1, _circle58$1, _path163$7, _path164$7, _circle59$1, _circle60$1, _path165$7, _path166$7, _circle61$1, _circle62$1, _path167$7, _path168$7, _circle63$1, _circle64$1, _path169$7, _path170$7, _circle65$1, _circle66$1, _path171$7, _path172$7, _circle67$1, _circle68$1, _path173$7, _path174$7, _circle69$1, _circle70$1, _path175$7, _path176$7, _circle71$1, _circle72$1, _path177$6, _path178$6, _path179$6, _path180$6, _path181$6, _path182$6, _path183$6, _path184$6, _path185$6, _path186$6, _path187$6, _path188$6, _path189$6, _path190$6, _path191$6, _path192$6, _path193$6, _path194$6, _path195$6, _path196$6, _path197$6, _path198$6, _rect$1, _path199$6, _path200$6, _rect2$1, _path201$6, _path202$6, _rect3$1, _path203$6, _path204$6, _rect4$1, _path205$6, _path206$6, _path207$6, _path208$6, _path209$6, _path210$6, _path211$6, _path212$6, _path213$6, _path214$6, _path215$6, _path216$6, _path217$6, _path218$6, _path219$6, _path220$6, _path221$6, _path222$6, _path223$6, _path224$6, _path225$6, _path226$6, _path227$6, _path228$6, _path229$6, _path230$6, _path231$6, _path232$6, _path233$6, _path234$6, _path235$6, _path236$6, _path237$6, _path238$6, _path239$6, _path240$6, _path241$6, _path242$6, _path243$6, _path244$6, _path245$6, _path246$6, _path247$6, _path248$6, _path249$6, _path250$6, _path251$6, _path252$6, _path253$6, _path254$6, _path255$6, _path256$6, _path257$6, _path258$6, _path259$6, _path260$6, _path261$6, _path262$6, _path263$6, _path264$6, _path265$6, _path266$6, _path267$6, _path268$6, _path269$6, _path270$6, _path271$6, _path272$6, _path273$6, _path274$6, _path275$6, _path276$6, _path277$6, _path278$6, _path279$6, _path280$6, _path281$6, _path282$6, _path283$6, _path284$6, _path285$6, _path286$6, _path287$6, _path288$6, _path289$6, _path290$6, _path291$6, _path292$6, _path293$6, _path294$6, _path295$6, _path296$6, _path297$6, _path298$6, _path299$6, _path300$6, _path301$6, _path302$6, _path303$6, _path304$6, _path305$6, _path306$6, _path307$6, _path308$6, _path309$6, _path310$6, _path311$6, _path312$6, _path313$6, _path314$6, _path315$6, _path316$6, _path317$6, _path318$6, _path319$6, _path320$6, _path321$6, _path322$6, _path323$6, _path324$6, _path325$6, _path326$6, _path327$6, _path328$6, _path329$6, _path330$6, _path331$6, _path332$6, _path333$6, _path334$6, _path335$6, _path336$6, _path337$6, _path338$6, _path339$6, _path340$6, _path341$6, _path342$6, _path343$6, _path344$6, _path345$6, _path346$6, _path347$6, _path348$6, _path349$6, _path350$6, _path351$6, _path352$6, _path353$6, _path354$6, _path355$6, _path356$6, _path357$6, _path358$6, _path359$6, _path360$6, _path361$6, _path362$6, _path363$6, _path364$6, _path365$6, _path366$6, _path367$6, _circle73, _path368$6, _path369$6, _path370$6, _circle74, _path371$6, _path372$6, _path373$6, _circle75, _path374$6, _path375$6, _path376$6, _circle76, _path377$6, _path378$6, _path379$6, _path380$6, _path381$6, _path382$6, _path383$6, _path384$5, _path385$5, _path386$5, _circle77, _path387$5, _circle78, _path388$5, _circle79, _path389$5, _circle80, _path390$5, _circle81, _path391$5, _circle82, _path392$5, _circle83, _path393$5, _circle84, _path394$5, _path395$5, _path396$5, _path397$5, _path398$5, _path399$4, _path400$4, _path401$4, _path402$4, _path403$3, _path404$3, _path405$3, _path406$3, _path407$3, _path408$3, _path409$3, _path410$3, _path411$3, _path412$3, _path413$3, _path414$3;

  var _excluded$7 = ["children"],
      _excluded2$7 = ["children"],
      _excluded3$7 = ["children"],
      _excluded4$7 = ["children"],
      _excluded5$7 = ["children"],
      _excluded6$7 = ["children"],
      _excluded7$7 = ["children"],
      _excluded8$7 = ["children"],
      _excluded9$7 = ["children"],
      _excluded10$7 = ["children"],
      _excluded11$7 = ["children"],
      _excluded12$7 = ["children"],
      _excluded13$7 = ["children"],
      _excluded14$7 = ["children"],
      _excluded15$7 = ["children"],
      _excluded16$7 = ["children"],
      _excluded17$7 = ["children"],
      _excluded18$7 = ["children"],
      _excluded19$7 = ["children"],
      _excluded20$7 = ["children"],
      _excluded21$7 = ["children"],
      _excluded22$7 = ["children"],
      _excluded23$7 = ["children"],
      _excluded24$7 = ["children"],
      _excluded25$7 = ["children"],
      _excluded26$7 = ["children"],
      _excluded27$7 = ["children"],
      _excluded28$7 = ["children"],
      _excluded29$7 = ["children"],
      _excluded30$7 = ["children"],
      _excluded31$7 = ["children"],
      _excluded32$7 = ["children"],
      _excluded33$7 = ["children"],
      _excluded34$7 = ["children"],
      _excluded35$7 = ["children"],
      _excluded36$7 = ["children"],
      _excluded37$7 = ["children"],
      _excluded38$7 = ["children"],
      _excluded39$7 = ["children"],
      _excluded40$7 = ["children"],
      _excluded41$7 = ["children"],
      _excluded42$7 = ["children"],
      _excluded43$7 = ["children"],
      _excluded44$7 = ["children"],
      _excluded45$7 = ["children"],
      _excluded46$7 = ["children"],
      _excluded47$7 = ["children"],
      _excluded48$7 = ["children"],
      _excluded49$7 = ["children"],
      _excluded50$7 = ["children"],
      _excluded51$7 = ["children"],
      _excluded52$7 = ["children"],
      _excluded53$7 = ["children"],
      _excluded54$7 = ["children"],
      _excluded55$7 = ["children"],
      _excluded56$7 = ["children"],
      _excluded57$7 = ["children"],
      _excluded58$7 = ["children"],
      _excluded59$7 = ["children"],
      _excluded60$7 = ["children"],
      _excluded61$7 = ["children"],
      _excluded62$7 = ["children"],
      _excluded63$7 = ["children"],
      _excluded64$7 = ["children"],
      _excluded65$7 = ["children"],
      _excluded66$7 = ["children"],
      _excluded67$7 = ["children"],
      _excluded68$7 = ["children"],
      _excluded69$7 = ["children"],
      _excluded70$7 = ["children"],
      _excluded71$7 = ["children"],
      _excluded72$7 = ["children"],
      _excluded73$7 = ["children"],
      _excluded74$7 = ["children"],
      _excluded75$7 = ["children"],
      _excluded76$7 = ["children"],
      _excluded77$7 = ["children"],
      _excluded78$7 = ["children"],
      _excluded79$7 = ["children"],
      _excluded80$7 = ["children"],
      _excluded81$7 = ["children"],
      _excluded82$7 = ["children"],
      _excluded83$7 = ["children"],
      _excluded84$7 = ["children"],
      _excluded85$7 = ["children"],
      _excluded86$7 = ["children"],
      _excluded87$7 = ["children"],
      _excluded88$7 = ["children"],
      _excluded89$7 = ["children"],
      _excluded90$7 = ["children"],
      _excluded91$7 = ["children"],
      _excluded92$7 = ["children"],
      _excluded93$7 = ["children"],
      _excluded94$7 = ["children"],
      _excluded95$7 = ["children"],
      _excluded96$7 = ["children"],
      _excluded97$7 = ["children"],
      _excluded98$7 = ["children"],
      _excluded99$7 = ["children"],
      _excluded100$7 = ["children"],
      _excluded101$7 = ["children"],
      _excluded102$7 = ["children"],
      _excluded103$7 = ["children"],
      _excluded104$7 = ["children"],
      _excluded105$7 = ["children"],
      _excluded106$7 = ["children"],
      _excluded107$7 = ["children"],
      _excluded108$7 = ["children"],
      _excluded109$7 = ["children"],
      _excluded110$7 = ["children"],
      _excluded111$7 = ["children"],
      _excluded112$7 = ["children"],
      _excluded113$7 = ["children"],
      _excluded114$7 = ["children"],
      _excluded115$7 = ["children"],
      _excluded116$7 = ["children"],
      _excluded117$7 = ["children"],
      _excluded118$7 = ["children"],
      _excluded119$6 = ["children"],
      _excluded120$6 = ["children"],
      _excluded121$6 = ["children"],
      _excluded122$6 = ["children"],
      _excluded123$6 = ["children"],
      _excluded124$6 = ["children"],
      _excluded125$6 = ["children"],
      _excluded126$6 = ["children"],
      _excluded127$6 = ["children"],
      _excluded128$6 = ["children"],
      _excluded129$6 = ["children"],
      _excluded130$6 = ["children"],
      _excluded131$6 = ["children"],
      _excluded132$6 = ["children"],
      _excluded133$6 = ["children"],
      _excluded134$6 = ["children"],
      _excluded135$6 = ["children"],
      _excluded136$6 = ["children"],
      _excluded137$6 = ["children"],
      _excluded138$6 = ["children"],
      _excluded139$6 = ["children"],
      _excluded140$6 = ["children"],
      _excluded141$6 = ["children"],
      _excluded142$6 = ["children"],
      _excluded143$6 = ["children"],
      _excluded144$6 = ["children"],
      _excluded145$6 = ["children"],
      _excluded146$6 = ["children"],
      _excluded147$6 = ["children"],
      _excluded148$6 = ["children"],
      _excluded149$6 = ["children"],
      _excluded150$6 = ["children"],
      _excluded151$6 = ["children"],
      _excluded152$6 = ["children"],
      _excluded153$6 = ["children"],
      _excluded154$6 = ["children"],
      _excluded155$6 = ["children"],
      _excluded156$6 = ["children"],
      _excluded157$6 = ["children"],
      _excluded158$6 = ["children"],
      _excluded159$6 = ["children"],
      _excluded160$6 = ["children"],
      _excluded161$6 = ["children"],
      _excluded162$6 = ["children"],
      _excluded163$6 = ["children"],
      _excluded164$6 = ["children"],
      _excluded165$6 = ["children"],
      _excluded166$6 = ["children"],
      _excluded167$6 = ["children"],
      _excluded168$6 = ["children"],
      _excluded169$6 = ["children"],
      _excluded170$6 = ["children"],
      _excluded171$6 = ["children"],
      _excluded172$6 = ["children"],
      _excluded173$6 = ["children"],
      _excluded174$6 = ["children"],
      _excluded175$6 = ["children"],
      _excluded176$6 = ["children"],
      _excluded177$6 = ["children"],
      _excluded178$6 = ["children"],
      _excluded179$6 = ["children"],
      _excluded180$6 = ["children"],
      _excluded181$6 = ["children"],
      _excluded182$6 = ["children"],
      _excluded183$6 = ["children"],
      _excluded184$6 = ["children"],
      _excluded185$6 = ["children"],
      _excluded186$6 = ["children"],
      _excluded187$6 = ["children"],
      _excluded188$6 = ["children"],
      _excluded189$6 = ["children"],
      _excluded190$6 = ["children"],
      _excluded191$6 = ["children"],
      _excluded192$6 = ["children"],
      _excluded193$6 = ["children"],
      _excluded194$6 = ["children"],
      _excluded195$6 = ["children"],
      _excluded196$6 = ["children"],
      _excluded197$6 = ["children"],
      _excluded198$6 = ["children"],
      _excluded199$6 = ["children"],
      _excluded200$6 = ["children"],
      _excluded201$6 = ["children"],
      _excluded202$6 = ["children"],
      _excluded203$6 = ["children"],
      _excluded204$6 = ["children"],
      _excluded205$6 = ["children"],
      _excluded206$6 = ["children"],
      _excluded207$6 = ["children"],
      _excluded208$6 = ["children"],
      _excluded209$6 = ["children"],
      _excluded210$6 = ["children"],
      _excluded211$6 = ["children"],
      _excluded212$6 = ["children"],
      _excluded213$6 = ["children"],
      _excluded214$6 = ["children"],
      _excluded215$6 = ["children"],
      _excluded216$6 = ["children"],
      _excluded217$6 = ["children"],
      _excluded218$6 = ["children"],
      _excluded219$6 = ["children"],
      _excluded220$6 = ["children"],
      _excluded221$6 = ["children"],
      _excluded222$6 = ["children"],
      _excluded223$6 = ["children"],
      _excluded224$6 = ["children"],
      _excluded225$6 = ["children"],
      _excluded226$6 = ["children"],
      _excluded227$6 = ["children"],
      _excluded228$6 = ["children"],
      _excluded229$6 = ["children"],
      _excluded230$6 = ["children"],
      _excluded231$6 = ["children"],
      _excluded232$6 = ["children"],
      _excluded233$6 = ["children"],
      _excluded234$6 = ["children"],
      _excluded235$6 = ["children"],
      _excluded236$6 = ["children"],
      _excluded237$6 = ["children"],
      _excluded238$6 = ["children"],
      _excluded239$6 = ["children"],
      _excluded240$6 = ["children"],
      _excluded241$6 = ["children"],
      _excluded242$6 = ["children"],
      _excluded243$6 = ["children"],
      _excluded244$6 = ["children"],
      _excluded245$6 = ["children"],
      _excluded246$6 = ["children"],
      _excluded247$6 = ["children"],
      _excluded248$6 = ["children"],
      _excluded249$6 = ["children"],
      _excluded250$6 = ["children"];
  var SendAltFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SendAltFilled20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$7 || (_path$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"
    })), children);
  });
  var SendAltFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SendAltFilled16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$7 || (_path2$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"
    })), children);
  });
  var SendFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SendFilled32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$7 || (_path3$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"
    })), children);
  });
  var SendFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SendFilled24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$7 || (_path4$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"
    })), children);
  });
  var SendFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SendFilled20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$7 || (_path5$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"
    })), children);
  });
  var SendFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SendFilled16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$7 || (_path6$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"
    })), children);
  });
  var SendBackward32 = /*#__PURE__*/React__default['default'].forwardRef(function SendBackward32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$7 || (_path7$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 7H2V4A2.0023 2.0023 0 014 2H7V4H4zM7 22H4a2.0023 2.0023 0 01-2-2V17H4v3H7zM2 10H4V14H2zM22 7H20V4H17V2h3a2.0023 2.0023 0 012 2zM10 2H14V4H10zM28 30H12a2.0023 2.0023 0 01-2-2V12a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM12 12V28H28V12z"
    })), children);
  });
  var SendBackward24 = /*#__PURE__*/React__default['default'].forwardRef(function SendBackward24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$7 || (_path8$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 7H2V4A2.0023 2.0023 0 014 2H7V4H4zM7 22H4a2.0023 2.0023 0 01-2-2V17H4v3H7zM2 10H4V14H2zM22 7H20V4H17V2h3a2.0023 2.0023 0 012 2zM10 2H14V4H10zM28 30H12a2.0023 2.0023 0 01-2-2V12a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM12 12V28H28V12z"
    })), children);
  });
  var SendBackward20 = /*#__PURE__*/React__default['default'].forwardRef(function SendBackward20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$7 || (_path9$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 7H2V4A2.0023 2.0023 0 014 2H7V4H4zM7 22H4a2.0023 2.0023 0 01-2-2V17H4v3H7zM2 10H4V14H2zM22 7H20V4H17V2h3a2.0023 2.0023 0 012 2zM10 2H14V4H10zM28 30H12a2.0023 2.0023 0 01-2-2V12a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM12 12V28H28V12z"
    })), children);
  });
  var SendBackward16 = /*#__PURE__*/React__default['default'].forwardRef(function SendBackward16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$7 || (_path10$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 7H2V4A2.0023 2.0023 0 014 2H7V4H4zM7 22H4a2.0023 2.0023 0 01-2-2V17H4v3H7zM2 10H4V14H2zM22 7H20V4H17V2h3a2.0023 2.0023 0 012 2zM10 2H14V4H10zM28 30H12a2.0023 2.0023 0 01-2-2V12a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 0128 30zM12 12V28H28V12z"
    })), children);
  });
  var SendToBack32 = /*#__PURE__*/React__default['default'].forwardRef(function SendToBack32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$7 || (_path11$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM12,28V12H28l.0015,16Z"
    })), children);
  });
  var SendToBack24 = /*#__PURE__*/React__default['default'].forwardRef(function SendToBack24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$7 || (_path12$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM12,28V12H28l.0015,16Z"
    })), children);
  });
  var SendToBack20 = /*#__PURE__*/React__default['default'].forwardRef(function SendToBack20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$7 || (_path13$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM12,28V12H28l.0015,16Z"
    })), children);
  });
  var SendToBack16 = /*#__PURE__*/React__default['default'].forwardRef(function SendToBack16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$7 || (_path14$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2.0023,2.0023,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V12A2.0023,2.0023,0,0,0,28,10ZM12,28V12H28l.0015,16Z"
    })), children);
  });
  var ServerDns32 = /*#__PURE__*/React__default['default'].forwardRef(function ServerDns32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$7 || (_path15$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2a8 8 0 108 8A8.0092 8.0092 0 0016 2zm5.91 7H19.4724a15.2457 15.2457 0 00-.7917-4.36A6.0088 6.0088 0 0121.91 9zM16.022 15.999h-.0076c-.3813-.1206-1.3091-1.8213-1.479-4.999h2.9292C17.2952 14.1763 16.3711 15.877 16.022 15.999zM14.5354 9c.1694-3.1763 1.0935-4.877 1.4426-4.999h.0076c.3813.1206 1.3091 1.8213 1.479 4.999zM13.3193 4.64A15.2457 15.2457 0 0012.5276 9H10.09A6.0088 6.0088 0 0113.3193 4.64zM10.09 11h2.4373a15.2457 15.2457 0 00.7917 4.36A6.0088 6.0088 0 0110.09 11zm8.59 4.36A15.2457 15.2457 0 0019.4724 11H21.91A6.0088 6.0088 0 0118.6807 15.36zM28 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM4 22v6H28V22z"
    })), _circle$6 || (_circle$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ServerDns24 = /*#__PURE__*/React__default['default'].forwardRef(function ServerDns24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$7 || (_path16$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2a8 8 0 108 8A8.0092 8.0092 0 0016 2zm5.91 7H19.4724a15.2457 15.2457 0 00-.7917-4.36A6.0088 6.0088 0 0121.91 9zM16.022 15.999h-.0076c-.3813-.1206-1.3091-1.8213-1.479-4.999h2.9292C17.2952 14.1763 16.3711 15.877 16.022 15.999zM14.5354 9c.1694-3.1763 1.0935-4.877 1.4426-4.999h.0076c.3813.1206 1.3091 1.8213 1.479 4.999zM13.3193 4.64A15.2457 15.2457 0 0012.5276 9H10.09A6.0088 6.0088 0 0113.3193 4.64zM10.09 11h2.4373a15.2457 15.2457 0 00.7917 4.36A6.0088 6.0088 0 0110.09 11zm8.59 4.36A15.2457 15.2457 0 0019.4724 11H21.91A6.0088 6.0088 0 0118.6807 15.36zM28 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM4 22v6H28V22z"
    })), _circle2$6 || (_circle2$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ServerDns20 = /*#__PURE__*/React__default['default'].forwardRef(function ServerDns20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$7 || (_path17$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2a8 8 0 108 8A8.0092 8.0092 0 0016 2zm5.91 7H19.4724a15.2457 15.2457 0 00-.7917-4.36A6.0088 6.0088 0 0121.91 9zM16.022 15.999h-.0076c-.3813-.1206-1.3091-1.8213-1.479-4.999h2.9292C17.2952 14.1763 16.3711 15.877 16.022 15.999zM14.5354 9c.1694-3.1763 1.0935-4.877 1.4426-4.999h.0076c.3813.1206 1.3091 1.8213 1.479 4.999zM13.3193 4.64A15.2457 15.2457 0 0012.5276 9H10.09A6.0088 6.0088 0 0113.3193 4.64zM10.09 11h2.4373a15.2457 15.2457 0 00.7917 4.36A6.0088 6.0088 0 0110.09 11zm8.59 4.36A15.2457 15.2457 0 0019.4724 11H21.91A6.0088 6.0088 0 0118.6807 15.36zM28 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM4 22v6H28V22z"
    })), _circle3$6 || (_circle3$6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ServerDns16 = /*#__PURE__*/React__default['default'].forwardRef(function ServerDns16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$7 || (_path18$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 2a8 8 0 108 8A8.0092 8.0092 0 0016 2zm5.91 7H19.4724a15.2457 15.2457 0 00-.7917-4.36A6.0088 6.0088 0 0121.91 9zM16.022 15.999h-.0076c-.3813-.1206-1.3091-1.8213-1.479-4.999h2.9292C17.2952 14.1763 16.3711 15.877 16.022 15.999zM14.5354 9c.1694-3.1763 1.0935-4.877 1.4426-4.999h.0076c.3813.1206 1.3091 1.8213 1.479 4.999zM13.3193 4.64A15.2457 15.2457 0 0012.5276 9H10.09A6.0088 6.0088 0 0113.3193 4.64zM10.09 11h2.4373a15.2457 15.2457 0 00.7917 4.36A6.0088 6.0088 0 0110.09 11zm8.59 4.36A15.2457 15.2457 0 0019.4724 11H21.91A6.0088 6.0088 0 0118.6807 15.36zM28 30H4a2.0021 2.0021 0 01-2-2V22a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v6A2.0021 2.0021 0 0128 30zM4 22v6H28V22z"
    })), _circle4$5 || (_circle4$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), children);
  });
  var ServerProxy32 = /*#__PURE__*/React__default['default'].forwardRef(function ServerProxy32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$7 || (_path19$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle5$4 || (_circle5$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _path20$7 || (_path20$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2,24.59,3.41,27.17,6H22.315A6.9835,6.9835,0,0,0,9.08,10H4.83L7.41,7.41,6,6,1,11l5,5,1.41-1.41L4.83,12H9.685A6.9835,6.9835,0,0,0,22.92,8h4.25l-2.58,2.59L26,12l5-5ZM21,9a4.983,4.983,0,0,1-8.9745,3H16V10H11.1011a4.9852,4.9852,0,0,1,8.8734-4H16V8h4.8989A5.0019,5.0019,0,0,1,21,9Z"
    })), children);
  });
  var ServerProxy24 = /*#__PURE__*/React__default['default'].forwardRef(function ServerProxy24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$7 || (_path21$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle6$4 || (_circle6$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _path22$7 || (_path22$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2,24.59,3.41,27.17,6H22.315A6.9835,6.9835,0,0,0,9.08,10H4.83L7.41,7.41,6,6,1,11l5,5,1.41-1.41L4.83,12H9.685A6.9835,6.9835,0,0,0,22.92,8h4.25l-2.58,2.59L26,12l5-5ZM21,9a4.983,4.983,0,0,1-8.9745,3H16V10H11.1011a4.9852,4.9852,0,0,1,8.8734-4H16V8h4.8989A5.0019,5.0019,0,0,1,21,9Z"
    })), children);
  });
  var ServerProxy20 = /*#__PURE__*/React__default['default'].forwardRef(function ServerProxy20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$7 || (_path23$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle7$4 || (_circle7$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _path24$7 || (_path24$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2,24.59,3.41,27.17,6H22.315A6.9835,6.9835,0,0,0,9.08,10H4.83L7.41,7.41,6,6,1,11l5,5,1.41-1.41L4.83,12H9.685A6.9835,6.9835,0,0,0,22.92,8h4.25l-2.58,2.59L26,12l5-5ZM21,9a4.983,4.983,0,0,1-8.9745,3H16V10H11.1011a4.9852,4.9852,0,0,1,8.8734-4H16V8h4.8989A5.0019,5.0019,0,0,1,21,9Z"
    })), children);
  });
  var ServerProxy16 = /*#__PURE__*/React__default['default'].forwardRef(function ServerProxy16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$7 || (_path25$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle8$4 || (_circle8$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _path26$7 || (_path26$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2,24.59,3.41,27.17,6H22.315A6.9835,6.9835,0,0,0,9.08,10H4.83L7.41,7.41,6,6,1,11l5,5,1.41-1.41L4.83,12H9.685A6.9835,6.9835,0,0,0,22.92,8h4.25l-2.58,2.59L26,12l5-5ZM21,9a4.983,4.983,0,0,1-8.9745,3H16V10H11.1011a4.9852,4.9852,0,0,1,8.8734-4H16V8h4.8989A5.0019,5.0019,0,0,1,21,9Z"
    })), children);
  });
  var ServerTime32 = /*#__PURE__*/React__default['default'].forwardRef(function ServerTime32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$7 || (_path27$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V22a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,30ZM4,22v6H28V22Z"
    })), _circle9$4 || (_circle9$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path28$7 || (_path28$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 11.586L17 9.586 17 6 15 6 15 10.414 17.586 13 19 11.586z"
    })), _path29$7 || (_path29$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,18ZM16,4a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,4Z"
    })), children);
  });
  var ServerTime24 = /*#__PURE__*/React__default['default'].forwardRef(function ServerTime24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$7 || (_path30$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V22a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,30ZM4,22v6H28V22Z"
    })), _circle10$4 || (_circle10$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path31$7 || (_path31$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 11.586L17 9.586 17 6 15 6 15 10.414 17.586 13 19 11.586z"
    })), _path32$7 || (_path32$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,18ZM16,4a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,4Z"
    })), children);
  });
  var ServerTime20 = /*#__PURE__*/React__default['default'].forwardRef(function ServerTime20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$7 || (_path33$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V22a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,30ZM4,22v6H28V22Z"
    })), _circle11$4 || (_circle11$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path34$7 || (_path34$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 11.586L17 9.586 17 6 15 6 15 10.414 17.586 13 19 11.586z"
    })), _path35$7 || (_path35$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,18ZM16,4a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,4Z"
    })), children);
  });
  var ServerTime16 = /*#__PURE__*/React__default['default'].forwardRef(function ServerTime16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$7 || (_path36$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V22a2.0021,2.0021,0,0,1,2-2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,30ZM4,22v6H28V22Z"
    })), _circle12$4 || (_circle12$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path37$7 || (_path37$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 11.586L17 9.586 17 6 15 6 15 10.414 17.586 13 19 11.586z"
    })), _path38$7 || (_path38$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,16,18ZM16,4a6,6,0,1,0,6,6A6.0067,6.0067,0,0,0,16,4Z"
    })), children);
  });
  var ServiceDesk32 = /*#__PURE__*/React__default['default'].forwardRef(function ServiceDesk32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$7 || (_path39$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var ServiceDesk24 = /*#__PURE__*/React__default['default'].forwardRef(function ServiceDesk24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$7 || (_path40$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var ServiceDesk20 = /*#__PURE__*/React__default['default'].forwardRef(function ServiceDesk20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$7 || (_path41$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var ServiceDesk16 = /*#__PURE__*/React__default['default'].forwardRef(function ServiceDesk16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$7 || (_path42$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var SessionBorderControl32 = /*#__PURE__*/React__default['default'].forwardRef(function SessionBorderControl32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$7 || (_path43$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,8,24.59,9.41,27.17,12H16a5.967,5.967,0,0,0-4,1.54V6.83l2.59,2.58L16,8,11,3,6,8,7.41,9.41,10,6.83V18a5.969,5.969,0,0,0,1.54,4H4.83l2.58-2.59L6,18,1,23l5,5,1.41-1.41L4.83,24H16A5.99,5.99,0,0,0,20.46,14h6.71l-2.58,2.59L26,18l5-5ZM20,18a4,4,0,1,1-4-4A4.0045,4.0045,0,0,1,20,18Z"
    })), children);
  });
  var SessionBorderControl24 = /*#__PURE__*/React__default['default'].forwardRef(function SessionBorderControl24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$7 || (_path44$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,8,24.59,9.41,27.17,12H16a5.967,5.967,0,0,0-4,1.54V6.83l2.59,2.58L16,8,11,3,6,8,7.41,9.41,10,6.83V18a5.969,5.969,0,0,0,1.54,4H4.83l2.58-2.59L6,18,1,23l5,5,1.41-1.41L4.83,24H16A5.99,5.99,0,0,0,20.46,14h6.71l-2.58,2.59L26,18l5-5ZM20,18a4,4,0,1,1-4-4A4.0045,4.0045,0,0,1,20,18Z"
    })), children);
  });
  var SessionBorderControl20 = /*#__PURE__*/React__default['default'].forwardRef(function SessionBorderControl20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$7 || (_path45$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,8,24.59,9.41,27.17,12H16a5.967,5.967,0,0,0-4,1.54V6.83l2.59,2.58L16,8,11,3,6,8,7.41,9.41,10,6.83V18a5.969,5.969,0,0,0,1.54,4H4.83l2.58-2.59L6,18,1,23l5,5,1.41-1.41L4.83,24H16A5.99,5.99,0,0,0,20.46,14h6.71l-2.58,2.59L26,18l5-5ZM20,18a4,4,0,1,1-4-4A4.0045,4.0045,0,0,1,20,18Z"
    })), children);
  });
  var SessionBorderControl16 = /*#__PURE__*/React__default['default'].forwardRef(function SessionBorderControl16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$7 || (_path46$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,8,24.59,9.41,27.17,12H16a5.967,5.967,0,0,0-4,1.54V6.83l2.59,2.58L16,8,11,3,6,8,7.41,9.41,10,6.83V18a5.969,5.969,0,0,0,1.54,4H4.83l2.58-2.59L6,18,1,23l5,5,1.41-1.41L4.83,24H16A5.99,5.99,0,0,0,20.46,14h6.71l-2.58,2.59L26,18l5-5ZM20,18a4,4,0,1,1-4-4A4.0045,4.0045,0,0,1,20,18Z"
    })), children);
  });
  var Settings32 = /*#__PURE__*/React__default['default'].forwardRef(function Settings32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$7 || (_path47$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16.76c0-.25,0-.5,0-.76s0-.51,0-.77l1.92-1.68A2,2,0,0,0,29.3,11L26.94,7a2,2,0,0,0-1.73-1,2,2,0,0,0-.64.1l-2.43.82a11.35,11.35,0,0,0-1.31-.75l-.51-2.52a2,2,0,0,0-2-1.61H13.64a2,2,0,0,0-2,1.61l-.51,2.52a11.48,11.48,0,0,0-1.32.75L7.43,6.06A2,2,0,0,0,6.79,6,2,2,0,0,0,5.06,7L2.7,11a2,2,0,0,0,.41,2.51L5,15.24c0,.25,0,.5,0,.76s0,.51,0,.77L3.11,18.45A2,2,0,0,0,2.7,21L5.06,25a2,2,0,0,0,1.73,1,2,2,0,0,0,.64-.1l2.43-.82a11.35,11.35,0,0,0,1.31.75l.51,2.52a2,2,0,0,0,2,1.61h4.72a2,2,0,0,0,2-1.61l.51-2.52a11.48,11.48,0,0,0,1.32-.75l2.42.82a2,2,0,0,0,.64.1,2,2,0,0,0,1.73-1L29.3,21a2,2,0,0,0-.41-2.51ZM25.21,24l-3.43-1.16a8.86,8.86,0,0,1-2.71,1.57L18.36,28H13.64l-.71-3.55a9.36,9.36,0,0,1-2.7-1.57L6.79,24,4.43,20l2.72-2.4a8.9,8.9,0,0,1,0-3.13L4.43,12,6.79,8l3.43,1.16a8.86,8.86,0,0,1,2.71-1.57L13.64,4h4.72l.71,3.55a9.36,9.36,0,0,1,2.7,1.57L25.21,8,27.57,12l-2.72,2.4a8.9,8.9,0,0,1,0,3.13L27.57,20Z"
    })), _path48$7 || (_path48$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.94,5.94,0,0,1,16,22Zm0-10a3.91,3.91,0,0,0-4,4,3.91,3.91,0,0,0,4,4,3.91,3.91,0,0,0,4-4A3.91,3.91,0,0,0,16,12Z"
    })), children);
  });
  var Settings24 = /*#__PURE__*/React__default['default'].forwardRef(function Settings24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$7 || (_path49$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16.76c0-.25,0-.5,0-.76s0-.51,0-.77l1.92-1.68A2,2,0,0,0,29.3,11L26.94,7a2,2,0,0,0-1.73-1,2,2,0,0,0-.64.1l-2.43.82a11.35,11.35,0,0,0-1.31-.75l-.51-2.52a2,2,0,0,0-2-1.61H13.64a2,2,0,0,0-2,1.61l-.51,2.52a11.48,11.48,0,0,0-1.32.75L7.43,6.06A2,2,0,0,0,6.79,6,2,2,0,0,0,5.06,7L2.7,11a2,2,0,0,0,.41,2.51L5,15.24c0,.25,0,.5,0,.76s0,.51,0,.77L3.11,18.45A2,2,0,0,0,2.7,21L5.06,25a2,2,0,0,0,1.73,1,2,2,0,0,0,.64-.1l2.43-.82a11.35,11.35,0,0,0,1.31.75l.51,2.52a2,2,0,0,0,2,1.61h4.72a2,2,0,0,0,2-1.61l.51-2.52a11.48,11.48,0,0,0,1.32-.75l2.42.82a2,2,0,0,0,.64.1,2,2,0,0,0,1.73-1L29.3,21a2,2,0,0,0-.41-2.51ZM25.21,24l-3.43-1.16a8.86,8.86,0,0,1-2.71,1.57L18.36,28H13.64l-.71-3.55a9.36,9.36,0,0,1-2.7-1.57L6.79,24,4.43,20l2.72-2.4a8.9,8.9,0,0,1,0-3.13L4.43,12,6.79,8l3.43,1.16a8.86,8.86,0,0,1,2.71-1.57L13.64,4h4.72l.71,3.55a9.36,9.36,0,0,1,2.7,1.57L25.21,8,27.57,12l-2.72,2.4a8.9,8.9,0,0,1,0,3.13L27.57,20Z"
    })), _path50$7 || (_path50$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.94,5.94,0,0,1,16,22Zm0-10a3.91,3.91,0,0,0-4,4,3.91,3.91,0,0,0,4,4,3.91,3.91,0,0,0,4-4A3.91,3.91,0,0,0,16,12Z"
    })), children);
  });
  var Settings20 = /*#__PURE__*/React__default['default'].forwardRef(function Settings20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$7 || (_path51$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,16.76c0-.25,0-.5,0-.76s0-.51,0-.77l1.92-1.68A2,2,0,0,0,29.3,11L26.94,7a2,2,0,0,0-1.73-1,2,2,0,0,0-.64.1l-2.43.82a11.35,11.35,0,0,0-1.31-.75l-.51-2.52a2,2,0,0,0-2-1.61H13.64a2,2,0,0,0-2,1.61l-.51,2.52a11.48,11.48,0,0,0-1.32.75L7.43,6.06A2,2,0,0,0,6.79,6,2,2,0,0,0,5.06,7L2.7,11a2,2,0,0,0,.41,2.51L5,15.24c0,.25,0,.5,0,.76s0,.51,0,.77L3.11,18.45A2,2,0,0,0,2.7,21L5.06,25a2,2,0,0,0,1.73,1,2,2,0,0,0,.64-.1l2.43-.82a11.35,11.35,0,0,0,1.31.75l.51,2.52a2,2,0,0,0,2,1.61h4.72a2,2,0,0,0,2-1.61l.51-2.52a11.48,11.48,0,0,0,1.32-.75l2.42.82a2,2,0,0,0,.64.1,2,2,0,0,0,1.73-1L29.3,21a2,2,0,0,0-.41-2.51ZM25.21,24l-3.43-1.16a8.86,8.86,0,0,1-2.71,1.57L18.36,28H13.64l-.71-3.55a9.36,9.36,0,0,1-2.7-1.57L6.79,24,4.43,20l2.72-2.4a8.9,8.9,0,0,1,0-3.13L4.43,12,6.79,8l3.43,1.16a8.86,8.86,0,0,1,2.71-1.57L13.64,4h4.72l.71,3.55a9.36,9.36,0,0,1,2.7,1.57L25.21,8,27.57,12l-2.72,2.4a8.9,8.9,0,0,1,0,3.13L27.57,20Z"
    })), _path52$7 || (_path52$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.94,5.94,0,0,1,16,22Zm0-10a3.91,3.91,0,0,0-4,4,3.91,3.91,0,0,0,4,4,3.91,3.91,0,0,0,4-4A3.91,3.91,0,0,0,16,12Z"
    })), children);
  });
  var Settings16 = /*#__PURE__*/React__default['default'].forwardRef(function Settings16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$7 || (_path53$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.5,8.4c0-0.1,0-0.3,0-0.4c0-0.1,0-0.3,0-0.4l1-0.8c0.4-0.3,0.4-0.9,0.2-1.3l-1.2-2C13.3,3.2,13,3,12.6,3\tc-0.1,0-0.2,0-0.3,0.1l-1.2,0.4c-0.2-0.1-0.4-0.3-0.7-0.4l-0.3-1.3C10.1,1.3,9.7,1,9.2,1H6.8c-0.5,0-0.9,0.3-1,0.8L5.6,3.1\tC5.3,3.2,5.1,3.3,4.9,3.4L3.7,3C3.6,3,3.5,3,3.4,3C3,3,2.7,3.2,2.5,3.5l-1.2,2C1.1,5.9,1.2,6.4,1.6,6.8l0.9,0.9c0,0.1,0,0.3,0,0.4\tc0,0.1,0,0.3,0,0.4L1.6,9.2c-0.4,0.3-0.5,0.9-0.2,1.3l1.2,2C2.7,12.8,3,13,3.4,13c0.1,0,0.2,0,0.3-0.1l1.2-0.4\tc0.2,0.1,0.4,0.3,0.7,0.4l0.3,1.3c0.1,0.5,0.5,0.8,1,0.8h2.4c0.5,0,0.9-0.3,1-0.8l0.3-1.3c0.2-0.1,0.4-0.2,0.7-0.4l1.2,0.4\tc0.1,0,0.2,0.1,0.3,0.1c0.4,0,0.7-0.2,0.9-0.5l1.1-2c0.2-0.4,0.2-0.9-0.2-1.3L13.5,8.4z M12.6,12l-1.7-0.6c-0.4,0.3-0.9,0.6-1.4,0.8\tL9.2,14H6.8l-0.4-1.8c-0.5-0.2-0.9-0.5-1.4-0.8L3.4,12l-1.2-2l1.4-1.2c-0.1-0.5-0.1-1.1,0-1.6L2.2,6l1.2-2l1.7,0.6\tC5.5,4.2,6,4,6.5,3.8L6.8,2h2.4l0.4,1.8c0.5,0.2,0.9,0.5,1.4,0.8L12.6,4l1.2,2l-1.4,1.2c0.1,0.5,0.1,1.1,0,1.6l1.4,1.2L12.6,12z"
    })), _path54$7 || (_path54$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,11c-1.7,0-3-1.3-3-3s1.3-3,3-3s3,1.3,3,3C11,9.6,9.7,11,8,11C8,11,8,11,8,11z M8,6C6.9,6,6,6.8,6,7.9C6,7.9,6,8,6,8\tc0,1.1,0.8,2,1.9,2c0,0,0.1,0,0.1,0c1.1,0,2-0.8,2-1.9c0,0,0-0.1,0-0.1C10,6.9,9.2,6,8,6C8.1,6,8,6,8,6z"
    })), children);
  });
  var SettingsAdjust32 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsAdjust32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$7 || (_path55$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8h-4.1c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2v2h14.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30V8zM21 12c-1.7 0-3-1.3-3-3s1.3-3 3-3 3 1.3 3 3S22.7 12 21 12zM2 24h4.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30v-2H15.9c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2V24zM11 20c1.7 0 3 1.3 3 3s-1.3 3-3 3-3-1.3-3-3S9.3 20 11 20z"
    })), children);
  });
  var SettingsAdjust24 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsAdjust24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$7 || (_path56$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8h-4.1c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2v2h14.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30V8zM21 12c-1.7 0-3-1.3-3-3s1.3-3 3-3 3 1.3 3 3S22.7 12 21 12zM2 24h4.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30v-2H15.9c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2V24zM11 20c1.7 0 3 1.3 3 3s-1.3 3-3 3-3-1.3-3-3S9.3 20 11 20z"
    })), children);
  });
  var SettingsAdjust20 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsAdjust20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$7 || (_path57$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8h-4.1c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2v2h14.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30V8zM21 12c-1.7 0-3-1.3-3-3s1.3-3 3-3 3 1.3 3 3S22.7 12 21 12zM2 24h4.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30v-2H15.9c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2V24zM11 20c1.7 0 3 1.3 3 3s-1.3 3-3 3-3-1.3-3-3S9.3 20 11 20z"
    })), children);
  });
  var SettingsAdjust16 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsAdjust16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$7 || (_path58$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8h-4.1c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2v2h14.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30V8zM21 12c-1.7 0-3-1.3-3-3s1.3-3 3-3 3 1.3 3 3S22.7 12 21 12zM2 24h4.1c.5 2.3 2.5 4 4.9 4s4.4-1.7 4.9-4H30v-2H15.9c-.5-2.3-2.5-4-4.9-4s-4.4 1.7-4.9 4H2V24zM11 20c1.7 0 3 1.3 3 3s-1.3 3-3 3-3-1.3-3-3S9.3 20 11 20z"
    })), children);
  });
  var SettingsCheck32 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsCheck32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$7 || (_path59$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.9364,5.9364,0,0,1,16,22Zm0-10a3.9123,3.9123,0,0,0-4,4,3.9123,3.9123,0,0,0,4,4,3.9123,3.9123,0,0,0,4-4A3.9123,3.9123,0,0,0,16,12Z"
    })), _path60$7 || (_path60$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.044,26.9441,6.9562a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583L20.3215,3.608A2,2,0,0,0,18.36,2H13.64A2,2,0,0,0,11.6785,3.608l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0616a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.044a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4947,5,15.7447,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025L5.0559,25.044a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713L6.7878,24.044l-2.36-4.0878,2.7253-2.3951a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.044,6.7886,7.9562l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.044Z"
    })), _path61$7 || (_path61$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26.18L20.41 23.59 19 25 23 29 30 22 28.59 20.59 23 26.18z"
    })), children);
  });
  var SettingsCheck24 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsCheck24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$7 || (_path62$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.9364,5.9364,0,0,1,16,22Zm0-10a3.9123,3.9123,0,0,0-4,4,3.9123,3.9123,0,0,0,4,4,3.9123,3.9123,0,0,0,4-4A3.9123,3.9123,0,0,0,16,12Z"
    })), _path63$7 || (_path63$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.044,26.9441,6.9562a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583L20.3215,3.608A2,2,0,0,0,18.36,2H13.64A2,2,0,0,0,11.6785,3.608l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0616a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.044a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4947,5,15.7447,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025L5.0559,25.044a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713L6.7878,24.044l-2.36-4.0878,2.7253-2.3951a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.044,6.7886,7.9562l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.044Z"
    })), _path64$7 || (_path64$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26.18L20.41 23.59 19 25 23 29 30 22 28.59 20.59 23 26.18z"
    })), children);
  });
  var SettingsCheck20 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsCheck20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$7 || (_path65$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.9364,5.9364,0,0,1,16,22Zm0-10a3.9123,3.9123,0,0,0-4,4,3.9123,3.9123,0,0,0,4,4,3.9123,3.9123,0,0,0,4-4A3.9123,3.9123,0,0,0,16,12Z"
    })), _path66$7 || (_path66$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.044,26.9441,6.9562a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583L20.3215,3.608A2,2,0,0,0,18.36,2H13.64A2,2,0,0,0,11.6785,3.608l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0616a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.044a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4947,5,15.7447,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025L5.0559,25.044a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713L6.7878,24.044l-2.36-4.0878,2.7253-2.3951a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.044,6.7886,7.9562l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.044Z"
    })), _path67$7 || (_path67$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26.18L20.41 23.59 19 25 23 29 30 22 28.59 20.59 23 26.18z"
    })), children);
  });
  var SettingsCheck16 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsCheck16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$7 || (_path68$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,1,6-6A5.9364,5.9364,0,0,1,16,22Zm0-10a3.9123,3.9123,0,0,0-4,4,3.9123,3.9123,0,0,0,4,4,3.9123,3.9123,0,0,0,4-4A3.9123,3.9123,0,0,0,16,12Z"
    })), _path69$7 || (_path69$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.044,26.9441,6.9562a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583L20.3215,3.608A2,2,0,0,0,18.36,2H13.64A2,2,0,0,0,11.6785,3.608l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0616a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.044a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4947,5,15.7447,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025L5.0559,25.044a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H18V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713L6.7878,24.044l-2.36-4.0878,2.7253-2.3951a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.044,6.7886,7.9562l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.044Z"
    })), _path70$7 || (_path70$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 26.18L20.41 23.59 19 25 23 29 30 22 28.59 20.59 23 26.18z"
    })), children);
  });
  var SettingsServices32 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsServices32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$7 || (_path71$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,25H27V23h1V19H24v1H22V18a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v6A1,1,0,0,1,29,25Z"
    })), _path72$7 || (_path72$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H18a1 1 0 01-1-1V23a1 1 0 011-1h6a1 1 0 011 1v6A1 1 0 0124 30zm-5-2h4V24H19zM15 19.8579A3.9934 3.9934 0 1120 16h2a6 6 0 10-7 5.91z"
    })), _path73$7 || (_path73$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.89,13.55l-2.31,2.03-1.42-1.42,2.41-2.12L25.21,7.96,21.77,9.12a9.3684,9.3684,0,0,0-2.7-1.57L18.36,4H13.64l-.71,3.55a8.8609,8.8609,0,0,0-2.71,1.57L6.79,7.96,4.43,12.04l2.72,2.39a8.8948,8.8948,0,0,0,0,3.13l-2.72,2.4,2.36,4.08,3.44-1.16a9.3684,9.3684,0,0,0,2.7,1.57L13.64,28H15v2H13.64a2.0007,2.0007,0,0,1-1.96-1.61l-.51-2.52a11.412,11.412,0,0,1-1.31-.75l-2.43.82a2.038,2.038,0,0,1-.64.1,1.973,1.973,0,0,1-1.73-1L2.7,20.96a2,2,0,0,1,.41-2.51l1.92-1.68C5.01,16.51,5,16.26,5,16s.02-.51.04-.76L3.11,13.55a2,2,0,0,1-.41-2.51L5.06,6.96a1.973,1.973,0,0,1,1.73-1,2.038,2.038,0,0,1,.64.1l2.42.82a11.5416,11.5416,0,0,1,1.32-.75l.51-2.52A2.0007,2.0007,0,0,1,13.64,2h4.72a2.0007,2.0007,0,0,1,1.96,1.61l.51,2.52a11.412,11.412,0,0,1,1.31.75l2.43-.82a2.038,2.038,0,0,1,.64-.1,1.973,1.973,0,0,1,1.73,1l2.36,4.08A2,2,0,0,1,28.89,13.55Z"
    })), children);
  });
  var SettingsServices24 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsServices24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$7 || (_path74$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,25H27V23h1V19H24v1H22V18a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v6A1,1,0,0,1,29,25Z"
    })), _path75$7 || (_path75$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H18a1 1 0 01-1-1V23a1 1 0 011-1h6a1 1 0 011 1v6A1 1 0 0124 30zm-5-2h4V24H19zM15 19.8579A3.9934 3.9934 0 1120 16h2a6 6 0 10-7 5.91z"
    })), _path76$7 || (_path76$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.89,13.55l-2.31,2.03-1.42-1.42,2.41-2.12L25.21,7.96,21.77,9.12a9.3684,9.3684,0,0,0-2.7-1.57L18.36,4H13.64l-.71,3.55a8.8609,8.8609,0,0,0-2.71,1.57L6.79,7.96,4.43,12.04l2.72,2.39a8.8948,8.8948,0,0,0,0,3.13l-2.72,2.4,2.36,4.08,3.44-1.16a9.3684,9.3684,0,0,0,2.7,1.57L13.64,28H15v2H13.64a2.0007,2.0007,0,0,1-1.96-1.61l-.51-2.52a11.412,11.412,0,0,1-1.31-.75l-2.43.82a2.038,2.038,0,0,1-.64.1,1.973,1.973,0,0,1-1.73-1L2.7,20.96a2,2,0,0,1,.41-2.51l1.92-1.68C5.01,16.51,5,16.26,5,16s.02-.51.04-.76L3.11,13.55a2,2,0,0,1-.41-2.51L5.06,6.96a1.973,1.973,0,0,1,1.73-1,2.038,2.038,0,0,1,.64.1l2.42.82a11.5416,11.5416,0,0,1,1.32-.75l.51-2.52A2.0007,2.0007,0,0,1,13.64,2h4.72a2.0007,2.0007,0,0,1,1.96,1.61l.51,2.52a11.412,11.412,0,0,1,1.31.75l2.43-.82a2.038,2.038,0,0,1,.64-.1,1.973,1.973,0,0,1,1.73,1l2.36,4.08A2,2,0,0,1,28.89,13.55Z"
    })), children);
  });
  var SettingsServices20 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsServices20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$7 || (_path77$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,25H27V23h1V19H24v1H22V18a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v6A1,1,0,0,1,29,25Z"
    })), _path78$7 || (_path78$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H18a1 1 0 01-1-1V23a1 1 0 011-1h6a1 1 0 011 1v6A1 1 0 0124 30zm-5-2h4V24H19zM15 19.8579A3.9934 3.9934 0 1120 16h2a6 6 0 10-7 5.91z"
    })), _path79$7 || (_path79$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.89,13.55l-2.31,2.03-1.42-1.42,2.41-2.12L25.21,7.96,21.77,9.12a9.3684,9.3684,0,0,0-2.7-1.57L18.36,4H13.64l-.71,3.55a8.8609,8.8609,0,0,0-2.71,1.57L6.79,7.96,4.43,12.04l2.72,2.39a8.8948,8.8948,0,0,0,0,3.13l-2.72,2.4,2.36,4.08,3.44-1.16a9.3684,9.3684,0,0,0,2.7,1.57L13.64,28H15v2H13.64a2.0007,2.0007,0,0,1-1.96-1.61l-.51-2.52a11.412,11.412,0,0,1-1.31-.75l-2.43.82a2.038,2.038,0,0,1-.64.1,1.973,1.973,0,0,1-1.73-1L2.7,20.96a2,2,0,0,1,.41-2.51l1.92-1.68C5.01,16.51,5,16.26,5,16s.02-.51.04-.76L3.11,13.55a2,2,0,0,1-.41-2.51L5.06,6.96a1.973,1.973,0,0,1,1.73-1,2.038,2.038,0,0,1,.64.1l2.42.82a11.5416,11.5416,0,0,1,1.32-.75l.51-2.52A2.0007,2.0007,0,0,1,13.64,2h4.72a2.0007,2.0007,0,0,1,1.96,1.61l.51,2.52a11.412,11.412,0,0,1,1.31.75l2.43-.82a2.038,2.038,0,0,1,.64-.1,1.973,1.973,0,0,1,1.73,1l2.36,4.08A2,2,0,0,1,28.89,13.55Z"
    })), children);
  });
  var SettingsServices16 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsServices16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$7 || (_path80$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,25H27V23h1V19H24v1H22V18a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v6A1,1,0,0,1,29,25Z"
    })), _path81$7 || (_path81$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30H18a1 1 0 01-1-1V23a1 1 0 011-1h6a1 1 0 011 1v6A1 1 0 0124 30zm-5-2h4V24H19zM15 19.8579A3.9934 3.9934 0 1120 16h2a6 6 0 10-7 5.91z"
    })), _path82$7 || (_path82$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.89,13.55l-2.31,2.03-1.42-1.42,2.41-2.12L25.21,7.96,21.77,9.12a9.3684,9.3684,0,0,0-2.7-1.57L18.36,4H13.64l-.71,3.55a8.8609,8.8609,0,0,0-2.71,1.57L6.79,7.96,4.43,12.04l2.72,2.39a8.8948,8.8948,0,0,0,0,3.13l-2.72,2.4,2.36,4.08,3.44-1.16a9.3684,9.3684,0,0,0,2.7,1.57L13.64,28H15v2H13.64a2.0007,2.0007,0,0,1-1.96-1.61l-.51-2.52a11.412,11.412,0,0,1-1.31-.75l-2.43.82a2.038,2.038,0,0,1-.64.1,1.973,1.973,0,0,1-1.73-1L2.7,20.96a2,2,0,0,1,.41-2.51l1.92-1.68C5.01,16.51,5,16.26,5,16s.02-.51.04-.76L3.11,13.55a2,2,0,0,1-.41-2.51L5.06,6.96a1.973,1.973,0,0,1,1.73-1,2.038,2.038,0,0,1,.64.1l2.42.82a11.5416,11.5416,0,0,1,1.32-.75l.51-2.52A2.0007,2.0007,0,0,1,13.64,2h4.72a2.0007,2.0007,0,0,1,1.96,1.61l.51,2.52a11.412,11.412,0,0,1,1.31.75l2.43-.82a2.038,2.038,0,0,1,.64-.1,1.973,1.973,0,0,1,1.73,1l2.36,4.08A2,2,0,0,1,28.89,13.55Z"
    })), children);
  });
  var SettingsView32 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsView32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$4 || (_circle13$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "24",
      r: "2"
    })), _path83$7 || (_path83$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.7769 23.4785A8.64 8.64 0 0023 18a8.64 8.64 0 00-7.7769 5.4785L15 24l.2231.5215A8.64 8.64 0 0023 30a8.64 8.64 0 007.7769-5.4785L31 24zM23 28a4 4 0 114-4A4.0045 4.0045 0 0123 28zM12.3989 20.8A6 6 0 1122 16H20a4 4 0 10-6.4 3.2z"
    })), _path84$7 || (_path84$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H15V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var SettingsView24 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsView24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$4 || (_circle14$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "24",
      r: "2"
    })), _path85$7 || (_path85$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.7769 23.4785A8.64 8.64 0 0023 18a8.64 8.64 0 00-7.7769 5.4785L15 24l.2231.5215A8.64 8.64 0 0023 30a8.64 8.64 0 007.7769-5.4785L31 24zM23 28a4 4 0 114-4A4.0045 4.0045 0 0123 28zM12.3989 20.8A6 6 0 1122 16H20a4 4 0 10-6.4 3.2z"
    })), _path86$7 || (_path86$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H15V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var SettingsView20 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsView20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$4 || (_circle15$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "24",
      r: "2"
    })), _path87$7 || (_path87$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.7769 23.4785A8.64 8.64 0 0023 18a8.64 8.64 0 00-7.7769 5.4785L15 24l.2231.5215A8.64 8.64 0 0023 30a8.64 8.64 0 007.7769-5.4785L31 24zM23 28a4 4 0 114-4A4.0045 4.0045 0 0123 28zM12.3989 20.8A6 6 0 1122 16H20a4 4 0 10-6.4 3.2z"
    })), _path88$7 || (_path88$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H15V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var SettingsView16 = /*#__PURE__*/React__default['default'].forwardRef(function SettingsView16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$4 || (_circle16$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "24",
      r: "2"
    })), _path89$7 || (_path89$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.7769 23.4785A8.64 8.64 0 0023 18a8.64 8.64 0 00-7.7769 5.4785L15 24l.2231.5215A8.64 8.64 0 0023 30a8.64 8.64 0 007.7769-5.4785L31 24zM23 28a4 4 0 114-4A4.0045 4.0045 0 0123 28zM12.3989 20.8A6 6 0 1122 16H20a4 4 0 10-6.4 3.2z"
    })), _path90$7 || (_path90$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3047,11.0439,26.9441,6.9561a1.9977,1.9977,0,0,0-2.3728-.8946l-2.4341.8233a11.0419,11.0419,0,0,0-1.312-.7583l-.5037-2.5186A2,2,0,0,0,18.36,2H13.64a2,2,0,0,0-1.9611,1.6079l-.5037,2.5186A10.9666,10.9666,0,0,0,9.8481,6.88L7.4287,6.0615a1.9977,1.9977,0,0,0-2.3728.8946L2.6953,11.0439a2.0006,2.0006,0,0,0,.4119,2.5025l1.9309,1.6968C5.021,15.4946,5,15.7446,5,16c0,.2578.01.5127.0278.7656l-1.9206,1.688a2.0006,2.0006,0,0,0-.4119,2.5025l2.3606,4.0878a1.9977,1.9977,0,0,0,2.3728.8946l2.4341-.8233a10.9736,10.9736,0,0,0,1.312.7583l.5037,2.5186A2,2,0,0,0,13.64,30H15V28H13.64l-.71-3.5508a9.0953,9.0953,0,0,1-2.6948-1.5713l-3.4468,1.166-2.36-4.0878L7.1528,17.561a8.9263,8.9263,0,0,1-.007-3.1279L4.4275,12.0439,6.7886,7.9561l3.4267,1.1591a9.0305,9.0305,0,0,1,2.7141-1.5644L13.64,4H18.36l.71,3.5508a9.0978,9.0978,0,0,1,2.6948,1.5713l3.4468-1.166,2.36,4.0878-2.7978,2.4522L26.0923,16l2.8-2.4536A2.0006,2.0006,0,0,0,29.3047,11.0439Z"
    })), children);
  });
  var ShapeExcept32 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExcept32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$7 || (_path91$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,20V12h8v8ZM3.9988,4H20v6H12a2.0023,2.0023,0,0,0-2,2v8H4Z"
    })), children);
  });
  var ShapeExcept24 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExcept24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$7 || (_path92$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,20V12h8v8ZM3.9988,4H20v6H12a2.0023,2.0023,0,0,0-2,2v8H4Z"
    })), children);
  });
  var ShapeExcept20 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExcept20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$7 || (_path93$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,20V12h8v8ZM3.9988,4H20v6H12a2.0023,2.0023,0,0,0-2,2v8H4Z"
    })), children);
  });
  var ShapeExcept16 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExcept16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$7 || (_path94$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,20V12h8v8ZM3.9988,4H20v6H12a2.0023,2.0023,0,0,0-2,2v8H4Z"
    })), children);
  });
  var ShapeExclude32 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExclude32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$7 || (_path95$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6V12A2,2,0,0,1,12,10Z"
    })), _path96$7 || (_path96$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V20a2,2,0,0,1-2,2H10v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeExclude24 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExclude24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$7 || (_path97$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6V12A2,2,0,0,1,12,10Z"
    })), _path98$7 || (_path98$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V20a2,2,0,0,1-2,2H10v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeExclude20 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExclude20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$7 || (_path99$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6V12A2,2,0,0,1,12,10Z"
    })), _path100$7 || (_path100$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V20a2,2,0,0,1-2,2H10v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeExclude16 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeExclude16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$7 || (_path101$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6V12A2,2,0,0,1,12,10Z"
    })), _path102$7 || (_path102$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V20a2,2,0,0,1-2,2H10v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeIntersect32 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeIntersect32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$7 || (_path103$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4H20v6H12a2.0025,2.0025,0,0,0-2,2v8Zm8,8V22h8a2.0025,2.0025,0,0,0,2-2V12h6V28Z"
    })), children);
  });
  var ShapeIntersect24 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeIntersect24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$7 || (_path104$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4H20v6H12a2.0025,2.0025,0,0,0-2,2v8Zm8,8V22h8a2.0025,2.0025,0,0,0,2-2V12h6V28Z"
    })), children);
  });
  var ShapeIntersect20 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeIntersect20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$7 || (_path105$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4H20v6H12a2.0025,2.0025,0,0,0-2,2v8Zm8,8V22h8a2.0025,2.0025,0,0,0,2-2V12h6V28Z"
    })), children);
  });
  var ShapeIntersect16 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeIntersect16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$7 || (_path106$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4H20v6H12a2.0025,2.0025,0,0,0-2,2v8Zm8,8V22h8a2.0025,2.0025,0,0,0,2-2V12h6V28Z"
    })), children);
  });
  var ShapeJoin32 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeJoin32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$7 || (_path107$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4h6V20Zm18,8V12h6V28Z"
    })), children);
  });
  var ShapeJoin24 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeJoin24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$7 || (_path108$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4h6V20Zm18,8V12h6V28Z"
    })), children);
  });
  var ShapeJoin20 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeJoin20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$7 || (_path109$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4h6V20Zm18,8V12h6V28Z"
    })), children);
  });
  var ShapeJoin16 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeJoin16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$7 || (_path110$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V20a2.0025,2.0025,0,0,0,2,2h6v6a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V12A2.0025,2.0025,0,0,0,28,10ZM4,20V4h6V20Zm18,8V12h6V28Z"
    })), children);
  });
  var ShapeUnite32 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeUnite32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$7 || (_path111$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeUnite24 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeUnite24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$7 || (_path112$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeUnite20 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeUnite20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$7 || (_path113$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var ShapeUnite16 = /*#__PURE__*/React__default['default'].forwardRef(function ShapeUnite16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$7 || (_path114$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,10H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2h6v6a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10Z"
    })), children);
  });
  var Share32 = /*#__PURE__*/React__default['default'].forwardRef(function Share32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$7 || (_path115$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"
    })), children);
  });
  var Share24 = /*#__PURE__*/React__default['default'].forwardRef(function Share24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$7 || (_path116$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"
    })), children);
  });
  var Share20 = /*#__PURE__*/React__default['default'].forwardRef(function Share20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$7 || (_path117$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"
    })), children);
  });
  var Share16 = /*#__PURE__*/React__default['default'].forwardRef(function Share16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$7 || (_path118$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"
    })), children);
  });
  var ShareKnowledge32 = /*#__PURE__*/React__default['default'].forwardRef(function ShareKnowledge32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$7 || (_path119$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20zM6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4z"
    })), children);
  });
  var ShareKnowledge24 = /*#__PURE__*/React__default['default'].forwardRef(function ShareKnowledge24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$7 || (_path120$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20zM6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4z"
    })), children);
  });
  var ShareKnowledge20 = /*#__PURE__*/React__default['default'].forwardRef(function ShareKnowledge20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$7 || (_path121$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20zM6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4z"
    })), children);
  });
  var ShareKnowledge16 = /*#__PURE__*/React__default['default'].forwardRef(function ShareKnowledge16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$7 || (_path122$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25H21a3 3 0 00-3 3v2h2V28a1 1 0 011-1h6a1 1 0 011 1v2h2V28A3 3 0 0027 25zM20 20a4 4 0 104-4A4 4 0 0020 20zm6 0a2 2 0 11-2-2A2 2 0 0126 20zM6 21V20H4v1a7 7 0 007 7h3V26H11A5 5 0 016 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 00-3 3v2H4V14a1 1 0 011-1h6a1 1 0 011 1v2h2V14A3 3 0 0011 11zM8 10A4 4 0 104 6 4 4 0 008 10zM8 4A2 2 0 116 6 2 2 0 018 4z"
    })), children);
  });
  var ShoppingBag32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingBag32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$7 || (_path123$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"
    })), children);
  });
  var ShoppingBag24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingBag24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$7 || (_path124$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"
    })), children);
  });
  var ShoppingBag20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingBag20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$7 || (_path125$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"
    })), children);
  });
  var ShoppingBag16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingBag16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$7 || (_path126$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"
    })), children);
  });
  var ShoppingCart32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCart32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle17$4 || (_circle17$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle18$4 || (_circle18$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path127$7 || (_path127$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"
    })), children);
  });
  var ShoppingCart24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCart24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$4 || (_circle19$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle20$4 || (_circle20$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path128$7 || (_path128$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"
    })), children);
  });
  var ShoppingCart20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCart20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21$4 || (_circle21$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle22$4 || (_circle22$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path129$7 || (_path129$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"
    })), children);
  });
  var ShoppingCart16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCart16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle23$4 || (_circle23$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle24$4 || (_circle24$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path130$7 || (_path130$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"
    })), children);
  });
  var ShoppingCartArrowDown32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowDown32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle25$3 || (_circle25$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle26$3 || (_circle26$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path131$7 || (_path131$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path132$7 || (_path132$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 6.586L18 10.172 18 2 16 2 16 10.172 12.414 6.586 11 8 17 14 23 8 21.586 6.586z"
    })), children);
  });
  var ShoppingCartArrowDown24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowDown24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle27$3 || (_circle27$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle28$3 || (_circle28$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path133$7 || (_path133$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path134$7 || (_path134$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 6.586L18 10.172 18 2 16 2 16 10.172 12.414 6.586 11 8 17 14 23 8 21.586 6.586z"
    })), children);
  });
  var ShoppingCartArrowDown20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowDown20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29$3 || (_circle29$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle30$3 || (_circle30$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path135$7 || (_path135$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path136$7 || (_path136$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 6.586L18 10.172 18 2 16 2 16 10.172 12.414 6.586 11 8 17 14 23 8 21.586 6.586z"
    })), children);
  });
  var ShoppingCartArrowDown16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowDown16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle31$3 || (_circle31$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle32$3 || (_circle32$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path137$7 || (_path137$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path138$7 || (_path138$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 6.586L18 10.172 18 2 16 2 16 10.172 12.414 6.586 11 8 17 14 23 8 21.586 6.586z"
    })), children);
  });
  var ShoppingCartArrowUp32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowUp32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle33$3 || (_circle33$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle34$2 || (_circle34$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path139$7 || (_path139$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path140$7 || (_path140$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 9.414L18 5.828 18 14 16 14 16 5.828 12.414 9.414 11 8 17 2 23 8 21.586 9.414z"
    })), children);
  });
  var ShoppingCartArrowUp24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowUp24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle35$2 || (_circle35$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle36$2 || (_circle36$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path141$7 || (_path141$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path142$7 || (_path142$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 9.414L18 5.828 18 14 16 14 16 5.828 12.414 9.414 11 8 17 2 23 8 21.586 9.414z"
    })), children);
  });
  var ShoppingCartArrowUp20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowUp20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle37$1 || (_circle37$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle38$1 || (_circle38$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path143$7 || (_path143$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path144$7 || (_path144$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 9.414L18 5.828 18 14 16 14 16 5.828 12.414 9.414 11 8 17 2 23 8 21.586 9.414z"
    })), children);
  });
  var ShoppingCartArrowUp16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartArrowUp16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle39$1 || (_circle39$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle40$1 || (_circle40$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path145$7 || (_path145$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path146$7 || (_path146$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.586 9.414L18 5.828 18 14 16 14 16 5.828 12.414 9.414 11 8 17 2 23 8 21.586 9.414z"
    })), children);
  });
  var ShoppingCartClear32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartClear32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle41$1 || (_circle41$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle42$1 || (_circle42$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path147$7 || (_path147$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path148$7 || (_path148$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.41 8L22 4.41 20.59 3 17 6.59 13.41 3 12 4.41 15.59 8 12 11.59 13.41 13 17 9.41 20.59 13 22 11.59 18.41 8z"
    })), children);
  });
  var ShoppingCartClear24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartClear24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle43$1 || (_circle43$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle44$1 || (_circle44$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path149$7 || (_path149$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path150$7 || (_path150$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.41 8L22 4.41 20.59 3 17 6.59 13.41 3 12 4.41 15.59 8 12 11.59 13.41 13 17 9.41 20.59 13 22 11.59 18.41 8z"
    })), children);
  });
  var ShoppingCartClear20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartClear20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle45$1 || (_circle45$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle46$1 || (_circle46$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path151$7 || (_path151$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path152$7 || (_path152$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.41 8L22 4.41 20.59 3 17 6.59 13.41 3 12 4.41 15.59 8 12 11.59 13.41 13 17 9.41 20.59 13 22 11.59 18.41 8z"
    })), children);
  });
  var ShoppingCartClear16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartClear16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle47$1 || (_circle47$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle48$1 || (_circle48$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path153$7 || (_path153$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path154$7 || (_path154$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.41 8L22 4.41 20.59 3 17 6.59 13.41 3 12 4.41 15.59 8 12 11.59 13.41 13 17 9.41 20.59 13 22 11.59 18.41 8z"
    })), children);
  });
  var ShoppingCartError32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartError32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle49$1 || (_circle49$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle50$1 || (_circle50$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path155$7 || (_path155$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path156$7 || (_path156$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,2a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,17,2Zm0,2a3.9521,3.9521,0,0,1,2.019.5669L13.5669,10.019A3.9529,3.9529,0,0,1,13,8,4.0045,4.0045,0,0,1,17,4Zm0,8a3.9521,3.9521,0,0,1-2.019-.5669L20.4331,5.981A3.9529,3.9529,0,0,1,21,8,4.0045,4.0045,0,0,1,17,12Z"
    })), children);
  });
  var ShoppingCartError24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartError24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle51$1 || (_circle51$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle52$1 || (_circle52$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path157$7 || (_path157$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path158$7 || (_path158$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,2a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,17,2Zm0,2a3.9521,3.9521,0,0,1,2.019.5669L13.5669,10.019A3.9529,3.9529,0,0,1,13,8,4.0045,4.0045,0,0,1,17,4Zm0,8a3.9521,3.9521,0,0,1-2.019-.5669L20.4331,5.981A3.9529,3.9529,0,0,1,21,8,4.0045,4.0045,0,0,1,17,12Z"
    })), children);
  });
  var ShoppingCartError20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartError20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle53$1 || (_circle53$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle54$1 || (_circle54$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path159$7 || (_path159$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path160$7 || (_path160$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,2a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,17,2Zm0,2a3.9521,3.9521,0,0,1,2.019.5669L13.5669,10.019A3.9529,3.9529,0,0,1,13,8,4.0045,4.0045,0,0,1,17,4Zm0,8a3.9521,3.9521,0,0,1-2.019-.5669L20.4331,5.981A3.9529,3.9529,0,0,1,21,8,4.0045,4.0045,0,0,1,17,12Z"
    })), children);
  });
  var ShoppingCartError16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartError16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle55$1 || (_circle55$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle56$1 || (_circle56$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path161$7 || (_path161$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path162$7 || (_path162$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,2a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,17,2Zm0,2a3.9521,3.9521,0,0,1,2.019.5669L13.5669,10.019A3.9529,3.9529,0,0,1,13,8,4.0045,4.0045,0,0,1,17,4Zm0,8a3.9521,3.9521,0,0,1-2.019-.5669L20.4331,5.981A3.9529,3.9529,0,0,1,21,8,4.0045,4.0045,0,0,1,17,12Z"
    })), children);
  });
  var ShoppingCartMinus32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartMinus32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle57$1 || (_circle57$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle58$1 || (_circle58$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path163$7 || (_path163$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path164$7 || (_path164$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L12 8 22 8 22 6 12 6z"
    })), children);
  });
  var ShoppingCartMinus24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartMinus24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle59$1 || (_circle59$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle60$1 || (_circle60$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path165$7 || (_path165$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path166$7 || (_path166$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L12 8 22 8 22 6 12 6z"
    })), children);
  });
  var ShoppingCartMinus20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartMinus20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle61$1 || (_circle61$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle62$1 || (_circle62$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path167$7 || (_path167$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path168$7 || (_path168$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L12 8 22 8 22 6 12 6z"
    })), children);
  });
  var ShoppingCartMinus16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartMinus16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle63$1 || (_circle63$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle64$1 || (_circle64$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path169$7 || (_path169$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path170$7 || (_path170$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6L12 8 22 8 22 6 12 6z"
    })), children);
  });
  var ShoppingCartPlus32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartPlus32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle65$1 || (_circle65$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle66$1 || (_circle66$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path171$7 || (_path171$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path172$7 || (_path172$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 6L18 2 16 2 16 6 12 6 12 8 16 8 16 12 18 12 18 8 22 8 22 6 18 6z"
    })), children);
  });
  var ShoppingCartPlus24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartPlus24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle67$1 || (_circle67$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle68$1 || (_circle68$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path173$7 || (_path173$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path174$7 || (_path174$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 6L18 2 16 2 16 6 12 6 12 8 16 8 16 12 18 12 18 8 22 8 22 6 18 6z"
    })), children);
  });
  var ShoppingCartPlus20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartPlus20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle69$1 || (_circle69$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle70$1 || (_circle70$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path175$7 || (_path175$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path176$7 || (_path176$7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 6L18 2 16 2 16 6 12 6 12 8 16 8 16 12 18 12 18 8 22 8 22 6 18 6z"
    })), children);
  });
  var ShoppingCartPlus16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCartPlus16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle71$1 || (_circle71$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "28",
      r: "2"
    })), _circle72$1 || (_circle72$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "28",
      r: "2"
    })), _path177$6 || (_path177$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.9806,2.8039A1,1,0,0,0,4,2H0V4H3.18L7.0194,23.1961A1,1,0,0,0,8,24H26V22H8.82l-.8-4H26a1,1,0,0,0,.9762-.783L29.2445,7H27.1971l-1.9989,9H7.62Z"
    })), _path178$6 || (_path178$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 6L18 2 16 2 16 6 12 6 12 8 16 8 16 12 18 12 18 8 22 8 22 6 18 6z"
    })), children);
  });
  var ShoppingCatalog32 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCatalog32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$6 || (_path179$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"
    })), _path180$6 || (_path180$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"
    })), children);
  });
  var ShoppingCatalog24 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCatalog24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$6 || (_path181$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"
    })), _path182$6 || (_path182$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"
    })), children);
  });
  var ShoppingCatalog20 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCatalog20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$6 || (_path183$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"
    })), _path184$6 || (_path184$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"
    })), children);
  });
  var ShoppingCatalog16 = /*#__PURE__*/React__default['default'].forwardRef(function ShoppingCatalog16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$6 || (_path185$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"
    })), _path186$6 || (_path186$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"
    })), children);
  });
  var ShowDataCards32 = /*#__PURE__*/React__default['default'].forwardRef(function ShowDataCards32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$6 || (_path187$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H4A2.0022 2.0022 0 012 8V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2V8A2.0022 2.0022 0 0128 10zM4 4V8H28V4zM28 30H4a2.0022 2.0022 0 01-2-2V24a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 30zM4 24v4H28V24zM28 20H4a2.0022 2.0022 0 01-2-2V14a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 20zM4 14v4H28V14z"
    })), children);
  });
  var ShowDataCards24 = /*#__PURE__*/React__default['default'].forwardRef(function ShowDataCards24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$6 || (_path188$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H4A2.0022 2.0022 0 012 8V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2V8A2.0022 2.0022 0 0128 10zM4 4V8H28V4zM28 30H4a2.0022 2.0022 0 01-2-2V24a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 30zM4 24v4H28V24zM28 20H4a2.0022 2.0022 0 01-2-2V14a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 20zM4 14v4H28V14z"
    })), children);
  });
  var ShowDataCards20 = /*#__PURE__*/React__default['default'].forwardRef(function ShowDataCards20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$6 || (_path189$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H4A2.0022 2.0022 0 012 8V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2V8A2.0022 2.0022 0 0128 10zM4 4V8H28V4zM28 30H4a2.0022 2.0022 0 01-2-2V24a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 30zM4 24v4H28V24zM28 20H4a2.0022 2.0022 0 01-2-2V14a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 20zM4 14v4H28V14z"
    })), children);
  });
  var ShowDataCards16 = /*#__PURE__*/React__default['default'].forwardRef(function ShowDataCards16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$6 || (_path190$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 10H4A2.0022 2.0022 0 012 8V4A2.0021 2.0021 0 014 2H28a2.0021 2.0021 0 012 2V8A2.0022 2.0022 0 0128 10zM4 4V8H28V4zM28 30H4a2.0022 2.0022 0 01-2-2V24a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 30zM4 24v4H28V24zM28 20H4a2.0022 2.0022 0 01-2-2V14a2.0021 2.0021 0 012-2H28a2.0021 2.0021 0 012 2v4A2.0022 2.0022 0 0128 20zM4 14v4H28V14z"
    })), children);
  });
  var ShrinkScreen32 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreen32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$6 || (_path191$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 28H17a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H28a2.0027 2.0027 0 012 2v6A2.0027 2.0027 0 0128 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path192$6 || (_path192$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreen24 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreen24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$6 || (_path193$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 28H17a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H28a2.0027 2.0027 0 012 2v6A2.0027 2.0027 0 0128 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path194$6 || (_path194$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreen20 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreen20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$6 || (_path195$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 28H17a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H28a2.0027 2.0027 0 012 2v6A2.0027 2.0027 0 0128 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path196$6 || (_path196$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreen16 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreen16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$6 || (_path197$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 28H17a2.0023 2.0023 0 01-2-2V20a2.0023 2.0023 0 012-2H28a2.0027 2.0027 0 012 2v6A2.0027 2.0027 0 0128 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path198$6 || (_path198$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreenFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreenFilled32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect$1 || (_rect$1 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "15",
      height: "10",
      x: "15",
      y: "18",
      rx: "2"
    })), _path199$6 || (_path199$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path200$6 || (_path200$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreenFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreenFilled24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect2$1 || (_rect2$1 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "15",
      height: "10",
      x: "15",
      y: "18",
      rx: "2"
    })), _path201$6 || (_path201$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path202$6 || (_path202$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreenFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreenFilled20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect3$1 || (_rect3$1 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "15",
      height: "10",
      x: "15",
      y: "18",
      rx: "2"
    })), _path203$6 || (_path203$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path204$6 || (_path204$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var ShrinkScreenFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ShrinkScreenFilled16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect4$1 || (_rect4$1 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "15",
      height: "10",
      x: "15",
      y: "18",
      rx: "2"
    })), _path205$6 || (_path205$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"
    })), _path206$6 || (_path206$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"
    })), children);
  });
  var Shuffle32 = /*#__PURE__*/React__default['default'].forwardRef(function Shuffle32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$6 || (_path207$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"
    })), children);
  });
  var Shuffle24 = /*#__PURE__*/React__default['default'].forwardRef(function Shuffle24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$6 || (_path208$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"
    })), children);
  });
  var Shuffle20 = /*#__PURE__*/React__default['default'].forwardRef(function Shuffle20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$6 || (_path209$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"
    })), children);
  });
  var Shuffle16 = /*#__PURE__*/React__default['default'].forwardRef(function Shuffle16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$6 || (_path210$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"
    })), children);
  });
  var Shuttle32 = /*#__PURE__*/React__default['default'].forwardRef(function Shuttle32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$6 || (_path211$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"
    })), children);
  });
  var Shuttle24 = /*#__PURE__*/React__default['default'].forwardRef(function Shuttle24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$6 || (_path212$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"
    })), children);
  });
  var Shuttle20 = /*#__PURE__*/React__default['default'].forwardRef(function Shuttle20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$6 || (_path213$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"
    })), children);
  });
  var Shuttle16 = /*#__PURE__*/React__default['default'].forwardRef(function Shuttle16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$6 || (_path214$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"
    })), children);
  });
  var Sight32 = /*#__PURE__*/React__default['default'].forwardRef(function Sight32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$6 || (_path215$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H12V14H10zM6 12H8V14H6zM2 12H4V14H2zM26 30H24V27H20a5.0055 5.0055 0 01-5-5V20.7207l-2.3162-.772a1 1 0 01-.5412-1.4631L15 13.7229V11a9.01 9.01 0 019-9h5V4H24a7.0078 7.0078 0 00-7 7v3a.9991.9991 0 01-.1426.5144l-2.3586 3.9312 1.8174.6057A1 1 0 0117 20v2a3.0033 3.0033 0 003 3h5a1 1 0 011 1z"
    })), _path216$6 || (_path216$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Sight24 = /*#__PURE__*/React__default['default'].forwardRef(function Sight24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$6 || (_path217$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H12V14H10zM6 12H8V14H6zM2 12H4V14H2zM26 30H24V27H20a5.0055 5.0055 0 01-5-5V20.7207l-2.3162-.772a1 1 0 01-.5412-1.4631L15 13.7229V11a9.01 9.01 0 019-9h5V4H24a7.0078 7.0078 0 00-7 7v3a.9991.9991 0 01-.1426.5144l-2.3586 3.9312 1.8174.6057A1 1 0 0117 20v2a3.0033 3.0033 0 003 3h5a1 1 0 011 1z"
    })), _path218$6 || (_path218$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Sight20 = /*#__PURE__*/React__default['default'].forwardRef(function Sight20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$6 || (_path219$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H12V14H10zM6 12H8V14H6zM2 12H4V14H2zM26 30H24V27H20a5.0055 5.0055 0 01-5-5V20.7207l-2.3162-.772a1 1 0 01-.5412-1.4631L15 13.7229V11a9.01 9.01 0 019-9h5V4H24a7.0078 7.0078 0 00-7 7v3a.9991.9991 0 01-.1426.5144l-2.3586 3.9312 1.8174.6057A1 1 0 0117 20v2a3.0033 3.0033 0 003 3h5a1 1 0 011 1z"
    })), _path220$6 || (_path220$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Sight16 = /*#__PURE__*/React__default['default'].forwardRef(function Sight16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$6 || (_path221$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H12V14H10zM6 12H8V14H6zM2 12H4V14H2zM26 30H24V27H20a5.0055 5.0055 0 01-5-5V20.7207l-2.3162-.772a1 1 0 01-.5412-1.4631L15 13.7229V11a9.01 9.01 0 019-9h5V4H24a7.0078 7.0078 0 00-7 7v3a.9991.9991 0 01-.1426.5144l-2.3586 3.9312 1.8174.6057A1 1 0 0117 20v2a3.0033 3.0033 0 003 3h5a1 1 0 011 1z"
    })), _path222$6 || (_path222$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19z"
    })), children);
  });
  var Sigma32 = /*#__PURE__*/React__default['default'].forwardRef(function Sigma32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$6 || (_path223$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"
    })), children);
  });
  var Sigma24 = /*#__PURE__*/React__default['default'].forwardRef(function Sigma24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$6 || (_path224$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"
    })), children);
  });
  var Sigma20 = /*#__PURE__*/React__default['default'].forwardRef(function Sigma20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$6 || (_path225$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"
    })), children);
  });
  var Sigma16 = /*#__PURE__*/React__default['default'].forwardRef(function Sigma16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$6 || (_path226$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"
    })), children);
  });
  var SignalStrength32 = /*#__PURE__*/React__default['default'].forwardRef(function SignalStrength32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$6 || (_path227$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6H28V26H26zM18 11H20V26H18zM11 16H13V26H11zM4 20H6V26H4z"
    })), children);
  });
  var SignalStrength24 = /*#__PURE__*/React__default['default'].forwardRef(function SignalStrength24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$6 || (_path228$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6H28V26H26zM18 11H20V26H18zM11 16H13V26H11zM4 20H6V26H4z"
    })), children);
  });
  var SignalStrength20 = /*#__PURE__*/React__default['default'].forwardRef(function SignalStrength20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$6 || (_path229$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6H28V26H26zM18 11H20V26H18zM11 16H13V26H11zM4 20H6V26H4z"
    })), children);
  });
  var SignalStrength16 = /*#__PURE__*/React__default['default'].forwardRef(function SignalStrength16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$6 || (_path230$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6H28V26H26zM18 11H20V26H18zM11 16H13V26H11zM4 20H6V26H4z"
    })), children);
  });
  var SimCard32 = /*#__PURE__*/React__default['default'].forwardRef(function SimCard32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$6 || (_path231$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,9H8a2.0023,2.0023,0,0,0-2,2V21a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V11A2.0023,2.0023,0,0,0,21,9Zm0,4H18V11h3Zm-3,2h3v2H18Zm-2-4V21H13V14a1,1,0,0,0-1-1H8V11Zm-5,6H8V15h3ZM8,19h3v2H8Zm10,2V19h3v2Z"
    })), _path232$6 || (_path232$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5317,27H4a2.0021,2.0021,0,0,1-2-2V7A2.0021,2.0021,0,0,1,4,5H28a2.0021,2.0021,0,0,1,2,2V19.6379a2.0044,2.0044,0,0,1-.4639,1.2808L25.0679,26.28A1.9944,1.9944,0,0,1,23.5317,27ZM4,7V25H23.5317L28,19.6379V7Z"
    })), children);
  });
  var SimCard24 = /*#__PURE__*/React__default['default'].forwardRef(function SimCard24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$6 || (_path233$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,9H8a2.0023,2.0023,0,0,0-2,2V21a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V11A2.0023,2.0023,0,0,0,21,9Zm0,4H18V11h3Zm-3,2h3v2H18Zm-2-4V21H13V14a1,1,0,0,0-1-1H8V11Zm-5,6H8V15h3ZM8,19h3v2H8Zm10,2V19h3v2Z"
    })), _path234$6 || (_path234$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5317,27H4a2.0021,2.0021,0,0,1-2-2V7A2.0021,2.0021,0,0,1,4,5H28a2.0021,2.0021,0,0,1,2,2V19.6379a2.0044,2.0044,0,0,1-.4639,1.2808L25.0679,26.28A1.9944,1.9944,0,0,1,23.5317,27ZM4,7V25H23.5317L28,19.6379V7Z"
    })), children);
  });
  var SimCard20 = /*#__PURE__*/React__default['default'].forwardRef(function SimCard20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$6 || (_path235$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,9H8a2.0023,2.0023,0,0,0-2,2V21a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V11A2.0023,2.0023,0,0,0,21,9Zm0,4H18V11h3Zm-3,2h3v2H18Zm-2-4V21H13V14a1,1,0,0,0-1-1H8V11Zm-5,6H8V15h3ZM8,19h3v2H8Zm10,2V19h3v2Z"
    })), _path236$6 || (_path236$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5317,27H4a2.0021,2.0021,0,0,1-2-2V7A2.0021,2.0021,0,0,1,4,5H28a2.0021,2.0021,0,0,1,2,2V19.6379a2.0044,2.0044,0,0,1-.4639,1.2808L25.0679,26.28A1.9944,1.9944,0,0,1,23.5317,27ZM4,7V25H23.5317L28,19.6379V7Z"
    })), children);
  });
  var SimCard16 = /*#__PURE__*/React__default['default'].forwardRef(function SimCard16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$6 || (_path237$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,9H8a2.0023,2.0023,0,0,0-2,2V21a2.0023,2.0023,0,0,0,2,2H21a2.0023,2.0023,0,0,0,2-2V11A2.0023,2.0023,0,0,0,21,9Zm0,4H18V11h3Zm-3,2h3v2H18Zm-2-4V21H13V14a1,1,0,0,0-1-1H8V11Zm-5,6H8V15h3ZM8,19h3v2H8Zm10,2V19h3v2Z"
    })), _path238$6 || (_path238$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5317,27H4a2.0021,2.0021,0,0,1-2-2V7A2.0021,2.0021,0,0,1,4,5H28a2.0021,2.0021,0,0,1,2,2V19.6379a2.0044,2.0044,0,0,1-.4639,1.2808L25.0679,26.28A1.9944,1.9944,0,0,1,23.5317,27ZM4,7V25H23.5317L28,19.6379V7Z"
    })), children);
  });
  var SkillLevel32 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevel32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$6 || (_path239$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"
    })), children);
  });
  var SkillLevel24 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevel24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$6 || (_path240$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"
    })), children);
  });
  var SkillLevel20 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevel20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$6 || (_path241$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"
    })), children);
  });
  var SkillLevel16 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevel16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$6 || (_path242$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"
    })), children);
  });
  var SkillLevelAdvanced32 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelAdvanced32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$6 || (_path243$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelAdvanced24 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelAdvanced24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$6 || (_path244$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelAdvanced20 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelAdvanced20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$6 || (_path245$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelAdvanced16 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelAdvanced16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$6 || (_path246$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelBasic32 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelBasic32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$6 || (_path247$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelBasic24 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelBasic24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$6 || (_path248$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelBasic20 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelBasic20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$6 || (_path249$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelBasic16 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelBasic16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$6 || (_path250$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelIntermediate32 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelIntermediate32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$6 || (_path251$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelIntermediate24 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelIntermediate24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$6 || (_path252$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelIntermediate20 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelIntermediate20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$6 || (_path253$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkillLevelIntermediate16 = /*#__PURE__*/React__default['default'].forwardRef(function SkillLevelIntermediate16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$6 || (_path254$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zM10 30H2V18h8z"
    })), children);
  });
  var SkipBack32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBack32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$6 || (_path255$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a1 1 0 01-.5-.13l-19-11a1 1 0 010-1.74l19-11a1 1 0 011 0A1 1 0 0128 5V27a1 1 0 01-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"
    })), children);
  });
  var SkipBack24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBack24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$6 || (_path256$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a1 1 0 01-.5-.13l-19-11a1 1 0 010-1.74l19-11a1 1 0 011 0A1 1 0 0128 5V27a1 1 0 01-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"
    })), children);
  });
  var SkipBack20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBack20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$6 || (_path257$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a1 1 0 01-.5-.13l-19-11a1 1 0 010-1.74l19-11a1 1 0 011 0A1 1 0 0128 5V27a1 1 0 01-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"
    })), children);
  });
  var SkipBack16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBack16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$6 || (_path258$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a1 1 0 01-.5-.13l-19-11a1 1 0 010-1.74l19-11a1 1 0 011 0A1 1 0 0128 5V27a1 1 0 01-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"
    })), children);
  });
  var SkipBackFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackFilled32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$6 || (_path259$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a.9975.9975 0 01-.501-.1348l-19-11a1 1 0 010-1.73l19-11A1 1 0 0128 5V27a1 1 0 01-1 1zM2 4H4V28H2z"
    })), children);
  });
  var SkipBackFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackFilled24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$6 || (_path260$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a.9975.9975 0 01-.501-.1348l-19-11a1 1 0 010-1.73l19-11A1 1 0 0128 5V27a1 1 0 01-1 1zM2 4H4V28H2z"
    })), children);
  });
  var SkipBackFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackFilled20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$6 || (_path261$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a.9975.9975 0 01-.501-.1348l-19-11a1 1 0 010-1.73l19-11A1 1 0 0128 5V27a1 1 0 01-1 1zM2 4H4V28H2z"
    })), children);
  });
  var SkipBackFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackFilled16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$6 || (_path262$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 28a.9975.9975 0 01-.501-.1348l-19-11a1 1 0 010-1.73l19-11A1 1 0 0128 5V27a1 1 0 01-1 1zM2 4H4V28H2z"
    })), children);
  });
  var SkipBackOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutline32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$6 || (_path263$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3006V12.7Z"
    })), _path264$6 || (_path264$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path265$6 || (_path265$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutline24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$6 || (_path266$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3006V12.7Z"
    })), _path267$6 || (_path267$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path268$6 || (_path268$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutline20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$6 || (_path269$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3006V12.7Z"
    })), _path270$6 || (_path270$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path271$6 || (_path271$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutline16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$6 || (_path272$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3006V12.7Z"
    })), _path273$6 || (_path273$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path274$6 || (_path274$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutlineFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineFilled32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$6 || (_path275$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path276$6 || (_path276$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19.301L22 12.699 16.059 16 22 19.301z"
    })), _path277$6 || (_path277$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3005V12.7Z"
    })), _path278$6 || (_path278$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackOutlineFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineFilled24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$6 || (_path279$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path280$6 || (_path280$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19.301L22 12.699 16.059 16 22 19.301z"
    })), _path281$6 || (_path281$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3005V12.7Z"
    })), _path282$6 || (_path282$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackOutlineFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineFilled20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$6 || (_path283$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path284$6 || (_path284$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19.301L22 12.699 16.059 16 22 19.301z"
    })), _path285$6 || (_path285$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3005V12.7Z"
    })), _path286$6 || (_path286$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackOutlineFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineFilled16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$6 || (_path287$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path288$6 || (_path288$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 19.301L22 12.699 16.059 16 22 19.301z"
    })), _path289$6 || (_path289$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Zm-6.9409-6L22,19.3005V12.7Z"
    })), _path290$6 || (_path290$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackOutlineSolid32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineSolid32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path291$6 || (_path291$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path292$6 || (_path292$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path293$6 || (_path293$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutlineSolid24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineSolid24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$6 || (_path294$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path295$6 || (_path295$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path296$6 || (_path296$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutlineSolid20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineSolid20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$6 || (_path297$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path298$6 || (_path298$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path299$6 || (_path299$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackOutlineSolid16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackOutlineSolid16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$6 || (_path300$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7485l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path301$6 || (_path301$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V22H9z",
      transform: "rotate(-180 10 16)"
    })), _path302$6 || (_path302$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipBackSolidFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackSolidFilled32(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$6 || (_path303$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path304$6 || (_path304$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path305$6 || (_path305$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackSolidFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackSolidFilled24(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$6 || (_path306$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path307$6 || (_path307$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path308$6 || (_path308$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackSolidFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackSolidFilled20(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$6 || (_path309$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path310$6 || (_path310$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path311$6 || (_path311$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipBackSolidFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipBackSolidFilled16(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$6 || (_path312$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,22H8V10h2Zm14-1a1,1,0,0,1-1.4858.874l-9-5a1,1,0,0,1,0-1.748l9-5A1,1,0,0,1,24,11Z"
    })), _path313$6 || (_path313$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23,22a1.0037,1.0037,0,0,1-.4858-.1257l-9-5a1,1,0,0,1,0-1.7486l9-5A1,1,0,0,1,24,11V21a1,1,0,0,1-1,1Z"
    })), _path314$6 || (_path314$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8 10H10V22H8z",
      transform: "rotate(-180 9 16)"
    })), children);
  });
  var SkipForward32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForward32(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$6 || (_path315$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 28a1 1 0 01-1-1V5a1 1 0 01.5-.87 1 1 0 011 0l19 11a1 1 0 010 1.74l-19 11A1 1 0 015 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"
    })), children);
  });
  var SkipForward24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForward24(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$6 || (_path316$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 28a1 1 0 01-1-1V5a1 1 0 01.5-.87 1 1 0 011 0l19 11a1 1 0 010 1.74l-19 11A1 1 0 015 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"
    })), children);
  });
  var SkipForward20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForward20(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$6 || (_path317$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 28a1 1 0 01-1-1V5a1 1 0 01.5-.87 1 1 0 011 0l19 11a1 1 0 010 1.74l-19 11A1 1 0 015 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"
    })), children);
  });
  var SkipForward16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForward16(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$6 || (_path318$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 28a1 1 0 01-1-1V5a1 1 0 01.5-.87 1 1 0 011 0l19 11a1 1 0 010 1.74l-19 11A1 1 0 015 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"
    })), children);
  });
  var SkipForwardFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardFilled32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$6 || (_path319$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 4H30V28H28zM5 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 015 28z"
    })), children);
  });
  var SkipForwardFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardFilled24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$6 || (_path320$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 4H30V28H28zM5 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 015 28z"
    })), children);
  });
  var SkipForwardFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardFilled20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$6 || (_path321$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 4H30V28H28zM5 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 015 28z"
    })), children);
  });
  var SkipForwardFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardFilled16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$6 || (_path322$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 4H30V28H28zM5 28a1 1 0 01-1-1V5a1 1 0 011.501-.8652l19 11a1 1 0 010 1.73l-19 11A.9975.9975 0 015 28z"
    })), children);
  });
  var SkipForwardOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutline32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$6 || (_path323$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.6011L15.9409 16z"
    })), _path324$6 || (_path324$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutline24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$6 || (_path325$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.6011L15.9409 16z"
    })), _path326$6 || (_path326$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutline20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$6 || (_path327$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.6011L15.9409 16z"
    })), _path328$6 || (_path328$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutline16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$6 || (_path329$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.6011L15.9409 16z"
    })), _path330$6 || (_path330$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutlineFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineFilled32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$6 || (_path331$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 19.301L15.941 16 10 12.699 10 19.301z"
    })), _path332$6 || (_path332$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path333$6 || (_path333$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.601L15.9409 16z"
    })), children);
  });
  var SkipForwardOutlineFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineFilled24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$6 || (_path334$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 19.301L15.941 16 10 12.699 10 19.301z"
    })), _path335$6 || (_path335$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path336$6 || (_path336$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.601L15.9409 16z"
    })), children);
  });
  var SkipForwardOutlineFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineFilled20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$6 || (_path337$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 19.301L15.941 16 10 12.699 10 19.301z"
    })), _path338$6 || (_path338$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path339$6 || (_path339$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.601L15.9409 16z"
    })), children);
  });
  var SkipForwardOutlineFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineFilled16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$6 || (_path340$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 19.301L15.941 16 10 12.699 10 19.301z"
    })), _path341$6 || (_path341$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path342$6 || (_path342$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125zM10 12.7v6.601L15.9409 16z"
    })), children);
  });
  var SkipForwardOutlineSolid32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineSolid32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$6 || (_path343$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), _path344$6 || (_path344$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutlineSolid24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineSolid24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$6 || (_path345$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), _path346$6 || (_path346$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutlineSolid20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineSolid20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$6 || (_path347$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), _path348$6 || (_path348$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardOutlineSolid16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardOutlineSolid16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$6 || (_path349$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 10H23V22H21zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8742l9 5a1 1 0 010 1.7485l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), _path350$6 || (_path350$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"
    })), children);
  });
  var SkipForwardSolidFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardSolidFilled32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$6 || (_path351$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path352$6 || (_path352$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), children);
  });
  var SkipForwardSolidFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardSolidFilled24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$6 || (_path353$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path354$6 || (_path354$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), children);
  });
  var SkipForwardSolidFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardSolidFilled20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$6 || (_path355$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path356$6 || (_path356$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), children);
  });
  var SkipForwardSolidFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function SkipForwardSolidFilled16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$6 || (_path357$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm2.4858,14.874-9,5A1,1,0,0,1,8,21V11a1,1,0,0,1,1.4858-.874l9,5a1,1,0,0,1,0,1.748ZM24,22H22V10h2Z"
    })), _path358$6 || (_path358$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22 10H24V22H22zM8.4927 21.8618A1 1 0 018 21V11a1 1 0 011.4858-.8743l9 5a1 1 0 010 1.7486l-9 5a1.0009 1.0009 0 01-.9931-.0125z"
    })), children);
  });
  var Sleet32 = /*#__PURE__*/React__default['default'].forwardRef(function Sleet32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$6 || (_path359$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24H8V26H6zM8 26H10V28H8zM10 28H12V30H10zM10 24H12V26H10zM6 28H8V30H6z"
    })), _path360$6 || (_path360$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0A6.4973 6.4973 0 008.5 22h8.8818L16.106 24.5527a1 1 0 101.7885.8946L19.6177 22H23.5A6.4974 6.4974 0 0024.8008 9.1362zM23.5 20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20z"
    })), children);
  });
  var Sleet24 = /*#__PURE__*/React__default['default'].forwardRef(function Sleet24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$6 || (_path361$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24H8V26H6zM8 26H10V28H8zM10 28H12V30H10zM10 24H12V26H10zM6 28H8V30H6z"
    })), _path362$6 || (_path362$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0A6.4973 6.4973 0 008.5 22h8.8818L16.106 24.5527a1 1 0 101.7885.8946L19.6177 22H23.5A6.4974 6.4974 0 0024.8008 9.1362zM23.5 20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20z"
    })), children);
  });
  var Sleet20 = /*#__PURE__*/React__default['default'].forwardRef(function Sleet20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$6 || (_path363$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24H8V26H6zM8 26H10V28H8zM10 28H12V30H10zM10 24H12V26H10zM6 28H8V30H6z"
    })), _path364$6 || (_path364$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0A6.4973 6.4973 0 008.5 22h8.8818L16.106 24.5527a1 1 0 101.7885.8946L19.6177 22H23.5A6.4974 6.4974 0 0024.8008 9.1362zM23.5 20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20z"
    })), children);
  });
  var Sleet16 = /*#__PURE__*/React__default['default'].forwardRef(function Sleet16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$6 || (_path365$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 24H8V26H6zM8 26H10V28H8zM10 28H12V30H10zM10 24H12V26H10zM6 28H8V30H6z"
    })), _path366$6 || (_path366$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM24.8008 9.1362a8.9943 8.9943 0 00-17.6006 0A6.4973 6.4973 0 008.5 22h8.8818L16.106 24.5527a1 1 0 101.7885.8946L19.6177 22H23.5A6.4974 6.4974 0 0024.8008 9.1362zM23.5 20H8.5a4.4975 4.4975 0 01-.356-8.981l.8155-.0639.0991-.812a6.9938 6.9938 0 0113.8838 0l.0986.812.8154.0639A4.4975 4.4975 0 0123.5 20z"
    })), children);
  });
  var Slisor32 = /*#__PURE__*/React__default['default'].forwardRef(function Slisor32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$6 || (_path367$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle73 || (_circle73 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path368$6 || (_path368$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a1.0005,1.0005,0,0,1-.4473-.1055l-10-5,.8946-1.789L16,19.8821l9.5527-4.7766.8946,1.789-10,5A1.0005,1.0005,0,0,1,16,22Z"
    })), _path369$6 || (_path369$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,16a1.0005,1.0005,0,0,1-.4473-.1055l-10-5a1,1,0,0,1,0-1.789l10-5a1.0008,1.0008,0,0,1,.8946,0l10,5a1,1,0,0,1,0,1.789l-10,5A1.0005,1.0005,0,0,1,16,16ZM8.2358,10,16,13.8821,23.7642,10,16,6.1179Z"
    })), children);
  });
  var Slisor24 = /*#__PURE__*/React__default['default'].forwardRef(function Slisor24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$6 || (_path370$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle74 || (_circle74 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path371$6 || (_path371$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a1.0005,1.0005,0,0,1-.4473-.1055l-10-5,.8946-1.789L16,19.8821l9.5527-4.7766.8946,1.789-10,5A1.0005,1.0005,0,0,1,16,22Z"
    })), _path372$6 || (_path372$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,16a1.0005,1.0005,0,0,1-.4473-.1055l-10-5a1,1,0,0,1,0-1.789l10-5a1.0008,1.0008,0,0,1,.8946,0l10,5a1,1,0,0,1,0,1.789l-10,5A1.0005,1.0005,0,0,1,16,16ZM8.2358,10,16,13.8821,23.7642,10,16,6.1179Z"
    })), children);
  });
  var Slisor20 = /*#__PURE__*/React__default['default'].forwardRef(function Slisor20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$6 || (_path373$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle75 || (_circle75 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path374$6 || (_path374$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a1.0005,1.0005,0,0,1-.4473-.1055l-10-5,.8946-1.789L16,19.8821l9.5527-4.7766.8946,1.789-10,5A1.0005,1.0005,0,0,1,16,22Z"
    })), _path375$6 || (_path375$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,16a1.0005,1.0005,0,0,1-.4473-.1055l-10-5a1,1,0,0,1,0-1.789l10-5a1.0008,1.0008,0,0,1,.8946,0l10,5a1,1,0,0,1,0,1.789l-10,5A1.0005,1.0005,0,0,1,16,16ZM8.2358,10,16,13.8821,23.7642,10,16,6.1179Z"
    })), children);
  });
  var Slisor16 = /*#__PURE__*/React__default['default'].forwardRef(function Slisor16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$6 || (_path376$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,20H26v2h2v6H4V22H6V20H4a2.0024,2.0024,0,0,0-2,2v6a2.0024,2.0024,0,0,0,2,2H28a2.0024,2.0024,0,0,0,2-2V22A2.0024,2.0024,0,0,0,28,20Z"
    })), _circle76 || (_circle76 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "25",
      r: "1"
    })), _path377$6 || (_path377$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a1.0005,1.0005,0,0,1-.4473-.1055l-10-5,.8946-1.789L16,19.8821l9.5527-4.7766.8946,1.789-10,5A1.0005,1.0005,0,0,1,16,22Z"
    })), _path378$6 || (_path378$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,16a1.0005,1.0005,0,0,1-.4473-.1055l-10-5a1,1,0,0,1,0-1.789l10-5a1.0008,1.0008,0,0,1,.8946,0l10,5a1,1,0,0,1,0,1.789l-10,5A1.0005,1.0005,0,0,1,16,16ZM8.2358,10,16,13.8821,23.7642,10,16,6.1179Z"
    })), children);
  });
  var Smell32 = /*#__PURE__*/React__default['default'].forwardRef(function Smell32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$6 || (_path379$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"
    })), children);
  });
  var Smell24 = /*#__PURE__*/React__default['default'].forwardRef(function Smell24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$6 || (_path380$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"
    })), children);
  });
  var Smell20 = /*#__PURE__*/React__default['default'].forwardRef(function Smell20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$6 || (_path381$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"
    })), children);
  });
  var Smell16 = /*#__PURE__*/React__default['default'].forwardRef(function Smell16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$6 || (_path382$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"
    })), children);
  });
  var Smoke32 = /*#__PURE__*/React__default['default'].forwardRef(function Smoke32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$6 || (_path383$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L23.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L27.8 26.4A1 1 0 0127.001 28zM22.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L18.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L22.8 26.4A1 1 0 0122.001 28zM17.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L13.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L17.8 26.4A1 1 0 0117.001 28zM12.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762A6.9956 6.9956 0 009.0142 6.6855L8.2 5.6A1 1 0 119.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L12.8 26.4A1 1 0 0112.001 28zM7.001 28A.998.998 0 016.2 27.6l-.8145-1.086a8.9976 8.9976 0 01-1.6-7.2856l1.4736-6.8762A6.9956 6.9956 0 004.0142 6.6855L3.2 5.6A1 1 0 114.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856L5.7412 19.6474a6.9956 6.9956 0 001.2446 5.6668L7.8 26.4A1 1 0 017.001 28z"
    })), children);
  });
  var Smoke24 = /*#__PURE__*/React__default['default'].forwardRef(function Smoke24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$5 || (_path384$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L23.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L27.8 26.4A1 1 0 0127.001 28zM22.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L18.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L22.8 26.4A1 1 0 0122.001 28zM17.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L13.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L17.8 26.4A1 1 0 0117.001 28zM12.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762A6.9956 6.9956 0 009.0142 6.6855L8.2 5.6A1 1 0 119.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L12.8 26.4A1 1 0 0112.001 28zM7.001 28A.998.998 0 016.2 27.6l-.8145-1.086a8.9976 8.9976 0 01-1.6-7.2856l1.4736-6.8762A6.9956 6.9956 0 004.0142 6.6855L3.2 5.6A1 1 0 114.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856L5.7412 19.6474a6.9956 6.9956 0 001.2446 5.6668L7.8 26.4A1 1 0 017.001 28z"
    })), children);
  });
  var Smoke20 = /*#__PURE__*/React__default['default'].forwardRef(function Smoke20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$5 || (_path385$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L23.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L27.8 26.4A1 1 0 0127.001 28zM22.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L18.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L22.8 26.4A1 1 0 0122.001 28zM17.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L13.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L17.8 26.4A1 1 0 0117.001 28zM12.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762A6.9956 6.9956 0 009.0142 6.6855L8.2 5.6A1 1 0 119.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L12.8 26.4A1 1 0 0112.001 28zM7.001 28A.998.998 0 016.2 27.6l-.8145-1.086a8.9976 8.9976 0 01-1.6-7.2856l1.4736-6.8762A6.9956 6.9956 0 004.0142 6.6855L3.2 5.6A1 1 0 114.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856L5.7412 19.6474a6.9956 6.9956 0 001.2446 5.6668L7.8 26.4A1 1 0 017.001 28z"
    })), children);
  });
  var Smoke16 = /*#__PURE__*/React__default['default'].forwardRef(function Smoke16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$5 || (_path386$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L23.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L27.8 26.4A1 1 0 0127.001 28zM22.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L18.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L22.8 26.4A1 1 0 0122.001 28zM17.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762a6.9956 6.9956 0 00-1.2446-5.6668L13.2 5.6a1 1 0 111.6-1.2l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L17.8 26.4A1 1 0 0117.001 28zM12.001 28a.998.998 0 01-.8008-.4l-.8145-1.086a8.9976 8.9976 0 01-1.6005-7.2856l1.4736-6.8762A6.9956 6.9956 0 009.0142 6.6855L8.2 5.6A1 1 0 119.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856l-1.4736 6.8762a6.9956 6.9956 0 001.2446 5.6668L12.8 26.4A1 1 0 0112.001 28zM7.001 28A.998.998 0 016.2 27.6l-.8145-1.086a8.9976 8.9976 0 01-1.6-7.2856l1.4736-6.8762A6.9956 6.9956 0 004.0142 6.6855L3.2 5.6A1 1 0 114.8 4.4l.8145 1.0857a8.9976 8.9976 0 011.6005 7.2856L5.7412 19.6474a6.9956 6.9956 0 001.2446 5.6668L7.8 26.4A1 1 0 017.001 28z"
    })), children);
  });
  var WatsonHealthSmoothing32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothing32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle77 || (_circle77 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path387$5 || (_path387$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3z"
    })), children);
  });
  var WatsonHealthSmoothing24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothing24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle78 || (_circle78 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path388$5 || (_path388$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3z"
    })), children);
  });
  var WatsonHealthSmoothing20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothing20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle79 || (_circle79 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path389$5 || (_path389$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3z"
    })), children);
  });
  var WatsonHealthSmoothing16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothing16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle80 || (_circle80 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "5"
    })), _path390$5 || (_path390$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.7 4.7a14.7029 14.7029 0 00-3 3.1L6.3 9A13.2634 13.2634 0 018.9 6.3zM4.6 12.3l-1.9-.6A12.5111 12.5111 0 002 16H4A11.4756 11.4756 0 014.6 12.3zM2.7 20.4a14.4029 14.4029 0 002 3.9l1.6-1.2a12.8867 12.8867 0 01-1.7-3.3zM7.8 27.3a14.4029 14.4029 0 003.9 2l.6-1.9A12.8867 12.8867 0 019 25.7zM11.7 2.7l.6 1.9A11.4756 11.4756 0 0116 4V2A12.5111 12.5111 0 0011.7 2.7zM24.2 27.3a15.18 15.18 0 003.1-3.1L25.7 23A11.526 11.526 0 0123 25.7zM27.4 19.7l1.9.6A15.4747 15.4747 0 0030 16H28A11.4756 11.4756 0 0127.4 19.7zM29.2 11.6a14.4029 14.4029 0 00-2-3.9L25.6 8.9a12.8867 12.8867 0 011.7 3.3zM24.1 4.6a14.4029 14.4029 0 00-3.9-2l-.6 1.9a12.8867 12.8867 0 013.3 1.7zM20.3 29.3l-.6-1.9A11.4756 11.4756 0 0116 28v2A21.4206 21.4206 0 0020.3 29.3z"
    })), children);
  });
  var WatsonHealthSmoothingCursor32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothingCursor32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle81 || (_circle81 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "18",
      r: "4"
    })), _path391$5 || (_path391$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30a11.8932 11.8932 0 01-4.1035-.72L14.58 27.4A9.9725 9.9725 0 0018 28zM22.1484 29.2637l-.6914-1.877a9.9556 9.9556 0 002.9973-1.748l1.2916 1.5268A11.9525 11.9525 0 0122.1484 29.2637zM10.2893 27.1951A12.0141 12.0141 0 017.61 24.0078l1.73-1.0029a10.0236 10.0236 0 002.2347 2.6584zM28.4133 23.967l-1.7343-.9956a9.9159 9.9159 0 001.176-3.2641l1.9712.3388A11.8956 11.8956 0 0128.4133 23.967zM6.1821 20.0925A12.1282 12.1282 0 016.1777 15.93l1.9707.3423a10.1214 10.1214 0 00.0035 3.4738zM27.8447 16.2339a9.9019 9.9019 0 00-1.1953-3.2564l1.7285-1.0063a11.9029 11.9029 0 011.4361 3.9121zM9.3313 13.0107l-1.7324-.999a12.01 12.01 0 012.6738-3.1931l1.2886 1.53A10.01 10.01 0 009.3313 13.0107zM24.4094 10.3237a9.96 9.96 0 00-3.0088-1.7309l.68-1.8809a11.9491 11.9491 0 013.6118 2.0772zM14.562 8.6064l-.6875-1.8779A12.1031 12.1031 0 0118 6V8A10.0875 10.0875 0 0014.562 8.6064zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthSmoothingCursor24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothingCursor24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle82 || (_circle82 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "18",
      r: "4"
    })), _path392$5 || (_path392$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30a11.8932 11.8932 0 01-4.1035-.72L14.58 27.4A9.9725 9.9725 0 0018 28zM22.1484 29.2637l-.6914-1.877a9.9556 9.9556 0 002.9973-1.748l1.2916 1.5268A11.9525 11.9525 0 0122.1484 29.2637zM10.2893 27.1951A12.0141 12.0141 0 017.61 24.0078l1.73-1.0029a10.0236 10.0236 0 002.2347 2.6584zM28.4133 23.967l-1.7343-.9956a9.9159 9.9159 0 001.176-3.2641l1.9712.3388A11.8956 11.8956 0 0128.4133 23.967zM6.1821 20.0925A12.1282 12.1282 0 016.1777 15.93l1.9707.3423a10.1214 10.1214 0 00.0035 3.4738zM27.8447 16.2339a9.9019 9.9019 0 00-1.1953-3.2564l1.7285-1.0063a11.9029 11.9029 0 011.4361 3.9121zM9.3313 13.0107l-1.7324-.999a12.01 12.01 0 012.6738-3.1931l1.2886 1.53A10.01 10.01 0 009.3313 13.0107zM24.4094 10.3237a9.96 9.96 0 00-3.0088-1.7309l.68-1.8809a11.9491 11.9491 0 013.6118 2.0772zM14.562 8.6064l-.6875-1.8779A12.1031 12.1031 0 0118 6V8A10.0875 10.0875 0 0014.562 8.6064zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthSmoothingCursor20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothingCursor20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle83 || (_circle83 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "18",
      r: "4"
    })), _path393$5 || (_path393$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30a11.8932 11.8932 0 01-4.1035-.72L14.58 27.4A9.9725 9.9725 0 0018 28zM22.1484 29.2637l-.6914-1.877a9.9556 9.9556 0 002.9973-1.748l1.2916 1.5268A11.9525 11.9525 0 0122.1484 29.2637zM10.2893 27.1951A12.0141 12.0141 0 017.61 24.0078l1.73-1.0029a10.0236 10.0236 0 002.2347 2.6584zM28.4133 23.967l-1.7343-.9956a9.9159 9.9159 0 001.176-3.2641l1.9712.3388A11.8956 11.8956 0 0128.4133 23.967zM6.1821 20.0925A12.1282 12.1282 0 016.1777 15.93l1.9707.3423a10.1214 10.1214 0 00.0035 3.4738zM27.8447 16.2339a9.9019 9.9019 0 00-1.1953-3.2564l1.7285-1.0063a11.9029 11.9029 0 011.4361 3.9121zM9.3313 13.0107l-1.7324-.999a12.01 12.01 0 012.6738-3.1931l1.2886 1.53A10.01 10.01 0 009.3313 13.0107zM24.4094 10.3237a9.96 9.96 0 00-3.0088-1.7309l.68-1.8809a11.9491 11.9491 0 013.6118 2.0772zM14.562 8.6064l-.6875-1.8779A12.1031 12.1031 0 0118 6V8A10.0875 10.0875 0 0014.562 8.6064zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var WatsonHealthSmoothingCursor16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSmoothingCursor16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle84 || (_circle84 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "18",
      r: "4"
    })), _path394$5 || (_path394$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 30a11.8932 11.8932 0 01-4.1035-.72L14.58 27.4A9.9725 9.9725 0 0018 28zM22.1484 29.2637l-.6914-1.877a9.9556 9.9556 0 002.9973-1.748l1.2916 1.5268A11.9525 11.9525 0 0122.1484 29.2637zM10.2893 27.1951A12.0141 12.0141 0 017.61 24.0078l1.73-1.0029a10.0236 10.0236 0 002.2347 2.6584zM28.4133 23.967l-1.7343-.9956a9.9159 9.9159 0 001.176-3.2641l1.9712.3388A11.8956 11.8956 0 0128.4133 23.967zM6.1821 20.0925A12.1282 12.1282 0 016.1777 15.93l1.9707.3423a10.1214 10.1214 0 00.0035 3.4738zM27.8447 16.2339a9.9019 9.9019 0 00-1.1953-3.2564l1.7285-1.0063a11.9029 11.9029 0 011.4361 3.9121zM9.3313 13.0107l-1.7324-.999a12.01 12.01 0 012.6738-3.1931l1.2886 1.53A10.01 10.01 0 009.3313 13.0107zM24.4094 10.3237a9.96 9.96 0 00-3.0088-1.7309l.68-1.8809a11.9491 11.9491 0 013.6118 2.0772zM14.562 8.6064l-.6875-1.8779A12.1031 12.1031 0 0118 6V8A10.0875 10.0875 0 0014.562 8.6064zM11 2L2 2 2 11 4 11 4 4 11 4 11 2z"
    })), children);
  });
  var Snooze32 = /*#__PURE__*/React__default['default'].forwardRef(function Snooze32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$5 || (_path395$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"
    })), _path396$5 || (_path396$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.965H26.499V9.036999999999999H24.5z",
      transform: "rotate(-44.945 25.5 6.5)"
    })), _path397$5 || (_path397$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"
    })), _path398$5 || (_path398$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.965 5.501H9.036999999999999V7.5H3.965z",
      transform: "rotate(-45.055 6.5 6.5)"
    })), children);
  });
  var Snooze24 = /*#__PURE__*/React__default['default'].forwardRef(function Snooze24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$4 || (_path399$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"
    })), _path400$4 || (_path400$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.965H26.499V9.036999999999999H24.5z",
      transform: "rotate(-44.945 25.5 6.5)"
    })), _path401$4 || (_path401$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"
    })), _path402$4 || (_path402$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.965 5.501H9.036999999999999V7.5H3.965z",
      transform: "rotate(-45.055 6.5 6.5)"
    })), children);
  });
  var Snooze20 = /*#__PURE__*/React__default['default'].forwardRef(function Snooze20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$3 || (_path403$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"
    })), _path404$3 || (_path404$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.965H26.499V9.036999999999999H24.5z",
      transform: "rotate(-44.945 25.5 6.5)"
    })), _path405$3 || (_path405$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"
    })), _path406$3 || (_path406$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.965 5.501H9.036999999999999V7.5H3.965z",
      transform: "rotate(-45.055 6.5 6.5)"
    })), children);
  });
  var Snooze16 = /*#__PURE__*/React__default['default'].forwardRef(function Snooze16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$3 || (_path407$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"
    })), _path408$3 || (_path408$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 3.965H26.499V9.036999999999999H24.5z",
      transform: "rotate(-44.945 25.5 6.5)"
    })), _path409$3 || (_path409$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"
    })), _path410$3 || (_path410$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3.965 5.501H9.036999999999999V7.5H3.965z",
      transform: "rotate(-45.055 6.5 6.5)"
    })), children);
  });
  var Snow32 = /*#__PURE__*/React__default['default'].forwardRef(function Snow32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$3 || (_path411$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var Snow24 = /*#__PURE__*/React__default['default'].forwardRef(function Snow24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$3 || (_path412$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var Snow20 = /*#__PURE__*/React__default['default'].forwardRef(function Snow20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$3 || (_path413$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });
  var Snow16 = /*#__PURE__*/React__default['default'].forwardRef(function Snow16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$3 || (_path414$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5 22H8.5A6.5 6.5 0 017.2 9.14a9 9 0 0117.6 0A6.5 6.5 0 0123.5 22zM16 4a7 7 0 00-6.94 6.14L9 11 8.14 11a4.5 4.5 0 00.36 9h15a4.5 4.5 0 00.36-9L23 11l-.1-.82A7 7 0 0016 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"
    })), children);
  });

  var _path$6, _path2$6, _path3$6, _path4$6, _path5$6, _path6$6, _path7$6, _path8$6, _path9$6, _path10$6, _path11$6, _path12$6, _path13$6, _path14$6, _path15$6, _path16$6, _path17$6, _path18$6, _path19$6, _path20$6, _path21$6, _path22$6, _path23$6, _path24$6, _path25$6, _path26$6, _path27$6, _path28$6, _path29$6, _path30$6, _path31$6, _path32$6, _path33$6, _path34$6, _path35$6, _path36$6, _path37$6, _path38$6, _path39$6, _path40$6, _path41$6, _path42$6, _path43$6, _path44$6, _path45$6, _path46$6, _path47$6, _path48$6, _path49$6, _path50$6, _path51$6, _path52$6, _circle$5, _path53$6, _path54$6, _circle2$5, _path55$6, _path56$6, _circle3$5, _path57$6, _path58$6, _circle4$4, _path59$6, _path60$6, _path61$6, _circle5$3, _circle6$3, _circle7$3, _circle8$3, _circle9$3, _circle10$3, _circle11$3, _circle12$3, _path62$6, _path63$6, _circle13$3, _circle14$3, _circle15$3, _circle16$3, _circle17$3, _circle18$3, _circle19$3, _circle20$3, _path64$6, _path65$6, _circle21$3, _circle22$3, _circle23$3, _circle24$3, _circle25$2, _circle26$2, _circle27$2, _circle28$2, _path66$6, _path67$6, _circle29$2, _circle30$2, _circle31$2, _circle32$2, _circle33$2, _circle34$1, _circle35$1, _circle36$1, _path68$6, _path69$6, _path70$6, _path71$6, _path72$6, _path73$6, _path74$6, _path75$6, _path76$6, _path77$6, _path78$6, _path79$6, _path80$6, _path81$6, _path82$6, _path83$6, _path84$6, _circle37, _circle38, _circle39, _circle40, _circle41, _circle42, _circle43, _path85$6, _circle44, _circle45, _circle46, _circle47, _circle48, _circle49, _circle50, _path86$6, _circle51, _circle52, _circle53, _circle54, _circle55, _circle56, _circle57, _path87$6, _circle58, _circle59, _circle60, _circle61, _circle62, _circle63, _circle64, _path88$6, _path89$6, _path90$6, _path91$6, _path92$6, _path93$6, _path94$6, _path95$6, _path96$6, _path97$6, _path98$6, _path99$6, _path100$6, _path101$6, _path102$6, _path103$6, _path104$6, _path105$6, _path106$6, _path107$6, _path108$6, _path109$6, _path110$6, _path111$6, _path112$6, _path113$6, _path114$6, _path115$6, _path116$6, _path117$6, _path118$6, _path119$6, _path120$6, _path121$6, _path122$6, _path123$6, _path124$6, _path125$6, _path126$6, _path127$6, _path128$6, _path129$6, _path130$6, _path131$6, _path132$6, _path133$6, _path134$6, _path135$6, _path136$6, _path137$6, _path138$6, _path139$6, _path140$6, _path141$6, _path142$6, _path143$6, _path144$6, _path145$6, _path146$6, _path147$6, _path148$6, _path149$6, _path150$6, _path151$6, _path152$6, _path153$6, _path154$6, _path155$6, _path156$6, _path157$6, _path158$6, _path159$6, _path160$6, _path161$6, _path162$6, _path163$6, _path164$6, _path165$6, _path166$6, _path167$6, _path168$6, _path169$6, _path170$6, _path171$6, _path172$6, _path173$6, _path174$6, _path175$6, _path176$6, _path177$5, _path178$5, _path179$5, _path180$5, _path181$5, _path182$5, _path183$5, _path184$5, _path185$5, _path186$5, _path187$5, _path188$5, _path189$5, _path190$5, _path191$5, _path192$5, _path193$5, _path194$5, _path195$5, _path196$5, _path197$5, _path198$5, _path199$5, _path200$5, _path201$5, _path202$5, _path203$5, _path204$5, _path205$5, _path206$5, _path207$5, _path208$5, _path209$5, _path210$5, _path211$5, _path212$5, _path213$5, _path214$5, _path215$5, _path216$5, _path217$5, _path218$5, _path219$5, _path220$5, _path221$5, _path222$5, _path223$5, _path224$5, _path225$5, _path226$5, _path227$5, _path228$5, _path229$5, _path230$5, _path231$5, _path232$5, _path233$5, _path234$5, _path235$5, _path236$5, _path237$5, _path238$5, _path239$5, _path240$5, _path241$5, _path242$5, _path243$5, _path244$5, _path245$5, _path246$5, _path247$5, _path248$5, _path249$5, _path250$5, _path251$5, _path252$5, _path253$5, _path254$5, _path255$5, _path256$5, _path257$5, _path258$5, _path259$5, _path260$5, _path261$5, _path262$5, _path263$5, _path264$5, _path265$5, _path266$5, _path267$5, _path268$5, _path269$5, _path270$5, _path271$5, _path272$5, _path273$5, _path274$5, _path275$5, _path276$5, _path277$5, _path278$5, _path279$5, _path280$5, _path281$5, _path282$5, _path283$5, _path284$5, _path285$5, _path286$5, _path287$5, _path288$5, _path289$5, _path290$5, _path291$5, _path292$5, _path293$5, _path294$5, _path295$5, _path296$5, _path297$5, _path298$5, _path299$5, _path300$5, _path301$5, _path302$5, _path303$5, _path304$5, _path305$5, _path306$5, _path307$5, _path308$5, _path309$5, _path310$5, _path311$5, _path312$5, _path313$5, _path314$5, _path315$5, _path316$5, _path317$5, _path318$5, _circle65, _circle66, _path319$5, _circle67, _circle68, _path320$5, _circle69, _circle70, _path321$5, _circle71, _circle72, _path322$5, _path323$5, _path324$5, _path325$5, _path326$5, _path327$5, _path328$5, _path329$5, _path330$5, _path331$5, _path332$5, _path333$5, _path334$5, _path335$5, _path336$5, _path337$5, _path338$5, _path339$5, _path340$5, _path341$5, _path342$5, _path343$5, _path344$5, _path345$5, _path346$5, _path347$5, _path348$5, _path349$5, _path350$5, _path351$5, _path352$5, _path353$5, _path354$5, _path355$5, _path356$5, _path357$5, _path358$5, _path359$5, _path360$5, _path361$5, _path362$5, _path363$5, _path364$5, _path365$5, _path366$5, _path367$5, _path368$5, _path369$5, _path370$5, _path371$5, _path372$5, _path373$5, _path374$5, _path375$5, _path376$5, _path377$5, _path378$5, _path379$5, _path380$5, _path381$5, _path382$5, _path383$5, _path384$4, _path385$4, _path386$4, _path387$4, _path388$4, _path389$4, _path390$4, _path391$4, _path392$4, _path393$4, _path394$4, _path395$4, _path396$4, _path397$4, _path398$4, _path399$3, _path400$3, _path401$3, _path402$3;

  var _excluded$6 = ["children"],
      _excluded2$6 = ["children"],
      _excluded3$6 = ["children"],
      _excluded4$6 = ["children"],
      _excluded5$6 = ["children"],
      _excluded6$6 = ["children"],
      _excluded7$6 = ["children"],
      _excluded8$6 = ["children"],
      _excluded9$6 = ["children"],
      _excluded10$6 = ["children"],
      _excluded11$6 = ["children"],
      _excluded12$6 = ["children"],
      _excluded13$6 = ["children"],
      _excluded14$6 = ["children"],
      _excluded15$6 = ["children"],
      _excluded16$6 = ["children"],
      _excluded17$6 = ["children"],
      _excluded18$6 = ["children"],
      _excluded19$6 = ["children"],
      _excluded20$6 = ["children"],
      _excluded21$6 = ["children"],
      _excluded22$6 = ["children"],
      _excluded23$6 = ["children"],
      _excluded24$6 = ["children"],
      _excluded25$6 = ["children"],
      _excluded26$6 = ["children"],
      _excluded27$6 = ["children"],
      _excluded28$6 = ["children"],
      _excluded29$6 = ["children"],
      _excluded30$6 = ["children"],
      _excluded31$6 = ["children"],
      _excluded32$6 = ["children"],
      _excluded33$6 = ["children"],
      _excluded34$6 = ["children"],
      _excluded35$6 = ["children"],
      _excluded36$6 = ["children"],
      _excluded37$6 = ["children"],
      _excluded38$6 = ["children"],
      _excluded39$6 = ["children"],
      _excluded40$6 = ["children"],
      _excluded41$6 = ["children"],
      _excluded42$6 = ["children"],
      _excluded43$6 = ["children"],
      _excluded44$6 = ["children"],
      _excluded45$6 = ["children"],
      _excluded46$6 = ["children"],
      _excluded47$6 = ["children"],
      _excluded48$6 = ["children"],
      _excluded49$6 = ["children"],
      _excluded50$6 = ["children"],
      _excluded51$6 = ["children"],
      _excluded52$6 = ["children"],
      _excluded53$6 = ["children"],
      _excluded54$6 = ["children"],
      _excluded55$6 = ["children"],
      _excluded56$6 = ["children"],
      _excluded57$6 = ["children"],
      _excluded58$6 = ["children"],
      _excluded59$6 = ["children"],
      _excluded60$6 = ["children"],
      _excluded61$6 = ["children"],
      _excluded62$6 = ["children"],
      _excluded63$6 = ["children"],
      _excluded64$6 = ["children"],
      _excluded65$6 = ["children"],
      _excluded66$6 = ["children"],
      _excluded67$6 = ["children"],
      _excluded68$6 = ["children"],
      _excluded69$6 = ["children"],
      _excluded70$6 = ["children"],
      _excluded71$6 = ["children"],
      _excluded72$6 = ["children"],
      _excluded73$6 = ["children"],
      _excluded74$6 = ["children"],
      _excluded75$6 = ["children"],
      _excluded76$6 = ["children"],
      _excluded77$6 = ["children"],
      _excluded78$6 = ["children"],
      _excluded79$6 = ["children"],
      _excluded80$6 = ["children"],
      _excluded81$6 = ["children"],
      _excluded82$6 = ["children"],
      _excluded83$6 = ["children"],
      _excluded84$6 = ["children"],
      _excluded85$6 = ["children"],
      _excluded86$6 = ["children"],
      _excluded87$6 = ["children"],
      _excluded88$6 = ["children"],
      _excluded89$6 = ["children"],
      _excluded90$6 = ["children"],
      _excluded91$6 = ["children"],
      _excluded92$6 = ["children"],
      _excluded93$6 = ["children"],
      _excluded94$6 = ["children"],
      _excluded95$6 = ["children"],
      _excluded96$6 = ["children"],
      _excluded97$6 = ["children"],
      _excluded98$6 = ["children"],
      _excluded99$6 = ["children"],
      _excluded100$6 = ["children"],
      _excluded101$6 = ["children"],
      _excluded102$6 = ["children"],
      _excluded103$6 = ["children"],
      _excluded104$6 = ["children"],
      _excluded105$6 = ["children"],
      _excluded106$6 = ["children"],
      _excluded107$6 = ["children"],
      _excluded108$6 = ["children"],
      _excluded109$6 = ["children"],
      _excluded110$6 = ["children"],
      _excluded111$6 = ["children"],
      _excluded112$6 = ["children"],
      _excluded113$6 = ["children"],
      _excluded114$6 = ["children"],
      _excluded115$6 = ["children"],
      _excluded116$6 = ["children"],
      _excluded117$6 = ["children"],
      _excluded118$6 = ["children"],
      _excluded119$5 = ["children"],
      _excluded120$5 = ["children"],
      _excluded121$5 = ["children"],
      _excluded122$5 = ["children"],
      _excluded123$5 = ["children"],
      _excluded124$5 = ["children"],
      _excluded125$5 = ["children"],
      _excluded126$5 = ["children"],
      _excluded127$5 = ["children"],
      _excluded128$5 = ["children"],
      _excluded129$5 = ["children"],
      _excluded130$5 = ["children"],
      _excluded131$5 = ["children"],
      _excluded132$5 = ["children"],
      _excluded133$5 = ["children"],
      _excluded134$5 = ["children"],
      _excluded135$5 = ["children"],
      _excluded136$5 = ["children"],
      _excluded137$5 = ["children"],
      _excluded138$5 = ["children"],
      _excluded139$5 = ["children"],
      _excluded140$5 = ["children"],
      _excluded141$5 = ["children"],
      _excluded142$5 = ["children"],
      _excluded143$5 = ["children"],
      _excluded144$5 = ["children"],
      _excluded145$5 = ["children"],
      _excluded146$5 = ["children"],
      _excluded147$5 = ["children"],
      _excluded148$5 = ["children"],
      _excluded149$5 = ["children"],
      _excluded150$5 = ["children"],
      _excluded151$5 = ["children"],
      _excluded152$5 = ["children"],
      _excluded153$5 = ["children"],
      _excluded154$5 = ["children"],
      _excluded155$5 = ["children"],
      _excluded156$5 = ["children"],
      _excluded157$5 = ["children"],
      _excluded158$5 = ["children"],
      _excluded159$5 = ["children"],
      _excluded160$5 = ["children"],
      _excluded161$5 = ["children"],
      _excluded162$5 = ["children"],
      _excluded163$5 = ["children"],
      _excluded164$5 = ["children"],
      _excluded165$5 = ["children"],
      _excluded166$5 = ["children"],
      _excluded167$5 = ["children"],
      _excluded168$5 = ["children"],
      _excluded169$5 = ["children"],
      _excluded170$5 = ["children"],
      _excluded171$5 = ["children"],
      _excluded172$5 = ["children"],
      _excluded173$5 = ["children"],
      _excluded174$5 = ["children"],
      _excluded175$5 = ["children"],
      _excluded176$5 = ["children"],
      _excluded177$5 = ["children"],
      _excluded178$5 = ["children"],
      _excluded179$5 = ["children"],
      _excluded180$5 = ["children"],
      _excluded181$5 = ["children"],
      _excluded182$5 = ["children"],
      _excluded183$5 = ["children"],
      _excluded184$5 = ["children"],
      _excluded185$5 = ["children"],
      _excluded186$5 = ["children"],
      _excluded187$5 = ["children"],
      _excluded188$5 = ["children"],
      _excluded189$5 = ["children"],
      _excluded190$5 = ["children"],
      _excluded191$5 = ["children"],
      _excluded192$5 = ["children"],
      _excluded193$5 = ["children"],
      _excluded194$5 = ["children"],
      _excluded195$5 = ["children"],
      _excluded196$5 = ["children"],
      _excluded197$5 = ["children"],
      _excluded198$5 = ["children"],
      _excluded199$5 = ["children"],
      _excluded200$5 = ["children"],
      _excluded201$5 = ["children"],
      _excluded202$5 = ["children"],
      _excluded203$5 = ["children"],
      _excluded204$5 = ["children"],
      _excluded205$5 = ["children"],
      _excluded206$5 = ["children"],
      _excluded207$5 = ["children"],
      _excluded208$5 = ["children"],
      _excluded209$5 = ["children"],
      _excluded210$5 = ["children"],
      _excluded211$5 = ["children"],
      _excluded212$5 = ["children"],
      _excluded213$5 = ["children"],
      _excluded214$5 = ["children"],
      _excluded215$5 = ["children"],
      _excluded216$5 = ["children"],
      _excluded217$5 = ["children"],
      _excluded218$5 = ["children"],
      _excluded219$5 = ["children"],
      _excluded220$5 = ["children"],
      _excluded221$5 = ["children"],
      _excluded222$5 = ["children"],
      _excluded223$5 = ["children"],
      _excluded224$5 = ["children"],
      _excluded225$5 = ["children"],
      _excluded226$5 = ["children"],
      _excluded227$5 = ["children"],
      _excluded228$5 = ["children"],
      _excluded229$5 = ["children"],
      _excluded230$5 = ["children"],
      _excluded231$5 = ["children"],
      _excluded232$5 = ["children"],
      _excluded233$5 = ["children"],
      _excluded234$5 = ["children"],
      _excluded235$5 = ["children"],
      _excluded236$5 = ["children"],
      _excluded237$5 = ["children"],
      _excluded238$5 = ["children"],
      _excluded239$5 = ["children"],
      _excluded240$5 = ["children"],
      _excluded241$5 = ["children"],
      _excluded242$5 = ["children"],
      _excluded243$5 = ["children"],
      _excluded244$5 = ["children"],
      _excluded245$5 = ["children"],
      _excluded246$5 = ["children"],
      _excluded247$5 = ["children"],
      _excluded248$5 = ["children"],
      _excluded249$5 = ["children"],
      _excluded250$5 = ["children"];
  var SnowBlizzard32 = /*#__PURE__*/React__default['default'].forwardRef(function SnowBlizzard32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$6 || (_path$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 10H15V12H13zM15 12H17V14H15zM17 14H19V16H17zM17 10H19V12H17zM13 14H15V16H13zM3 26H5V28H3zM5 28H7V30H5zM7 30H9V32H7zM7 26H9V28H7zM3 30H5V32H3zM23 26H25V28H23zM25 28H27V30H25zM27 30H29V32H27zM27 26H29V28H27zM23 30H25V32H23zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM13 26H15V28H13zM15 28H17V30H15zM17 30H19V32H17zM17 26H19V28H17zM13 30H15V32H13z"
    })), _path2$6 || (_path2$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowBlizzard24 = /*#__PURE__*/React__default['default'].forwardRef(function SnowBlizzard24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$6 || (_path3$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 10H15V12H13zM15 12H17V14H15zM17 14H19V16H17zM17 10H19V12H17zM13 14H15V16H13zM3 26H5V28H3zM5 28H7V30H5zM7 30H9V32H7zM7 26H9V28H7zM3 30H5V32H3zM23 26H25V28H23zM25 28H27V30H25zM27 30H29V32H27zM27 26H29V28H27zM23 30H25V32H23zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM13 26H15V28H13zM15 28H17V30H15zM17 30H19V32H17zM17 26H19V28H17zM13 30H15V32H13z"
    })), _path4$6 || (_path4$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowBlizzard20 = /*#__PURE__*/React__default['default'].forwardRef(function SnowBlizzard20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$6 || (_path5$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 10H15V12H13zM15 12H17V14H15zM17 14H19V16H17zM17 10H19V12H17zM13 14H15V16H13zM3 26H5V28H3zM5 28H7V30H5zM7 30H9V32H7zM7 26H9V28H7zM3 30H5V32H3zM23 26H25V28H23zM25 28H27V30H25zM27 30H29V32H27zM27 26H29V28H27zM23 30H25V32H23zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM13 26H15V28H13zM15 28H17V30H15zM17 30H19V32H17zM17 26H19V28H17zM13 30H15V32H13z"
    })), _path6$6 || (_path6$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowBlizzard16 = /*#__PURE__*/React__default['default'].forwardRef(function SnowBlizzard16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$6 || (_path7$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 10H15V12H13zM15 12H17V14H15zM17 14H19V16H17zM17 10H19V12H17zM13 14H15V16H13zM3 26H5V28H3zM5 28H7V30H5zM7 30H9V32H7zM7 26H9V28H7zM3 30H5V32H3zM23 26H25V28H23zM25 28H27V30H25zM27 30H29V32H27zM27 26H29V28H27zM23 30H25V32H23zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM13 26H15V28H13zM15 28H17V30H15zM17 30H19V32H17zM17 26H19V28H17zM13 30H15V32H13z"
    })), _path8$6 || (_path8$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowHeavy32 = /*#__PURE__*/React__default['default'].forwardRef(function SnowHeavy32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$6 || (_path9$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H6V28H4zM6 28H8V30H6zM8 30H10V32H8zM8 26H10V28H8zM4 30H6V32H4zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM14 26H16V28H14zM16 28H18V30H16zM18 30H20V32H18zM18 26H20V28H18zM14 30H16V32H14z"
    })), _path10$6 || (_path10$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowHeavy24 = /*#__PURE__*/React__default['default'].forwardRef(function SnowHeavy24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$6 || (_path11$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H6V28H4zM6 28H8V30H6zM8 30H10V32H8zM8 26H10V28H8zM4 30H6V32H4zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM14 26H16V28H14zM16 28H18V30H16zM18 30H20V32H18zM18 26H20V28H18zM14 30H16V32H14z"
    })), _path12$6 || (_path12$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowHeavy20 = /*#__PURE__*/React__default['default'].forwardRef(function SnowHeavy20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$6 || (_path13$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H6V28H4zM6 28H8V30H6zM8 30H10V32H8zM8 26H10V28H8zM4 30H6V32H4zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM14 26H16V28H14zM16 28H18V30H16zM18 30H20V32H18zM18 26H20V28H18zM14 30H16V32H14z"
    })), _path14$6 || (_path14$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowHeavy16 = /*#__PURE__*/React__default['default'].forwardRef(function SnowHeavy16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$6 || (_path15$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H6V28H4zM6 28H8V30H6zM8 30H10V32H8zM8 26H10V28H8zM4 30H6V32H4zM8 18H10V20H8zM10 20H12V22H10zM12 22H14V24H12zM12 18H14V20H12zM8 22H10V24H8zM18 18H20V20H18zM20 20H22V22H20zM22 22H24V24H22zM22 18H24V20H22zM18 22H20V24H18zM14 26H16V28H14zM16 28H18V30H16zM18 30H20V32H18zM18 26H20V28H18zM14 30H16V32H14z"
    })), _path16$6 || (_path16$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.4957,6.4957,0,0,0,6,21.4985v-2.26A4.4943,4.4943,0,0,1,8.144,11.019l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4944,4.4944,0,0,1,26,19.2383v2.26A6.4958,6.4958,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var SnowScattered32 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScattered32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$6 || (_path17$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM20 0H22V3H20zM29 10.001H32V12.001H29z"
    })), _path18$6 || (_path18$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path19$6 || (_path19$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path20$6 || (_path20$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), _path21$6 || (_path21$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9852,5.9852,0,0,0,16.1431,7.5083,7.3737,7.3737,0,0,0,13.5,7a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,24H19a5.9672,5.9672,0,0,0,5.5667-8.2A5.9722,5.9722,0,0,0,27,11ZM19,22H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,22Zm4.5222-7.9131a5.9592,5.9592,0,0,0-2.8728-1.8428,7.5212,7.5212,0,0,0-2.7224-3.78,3.9869,3.9869,0,1,1,5.5952,5.6225Z"
    })), children);
  });
  var SnowScattered24 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScattered24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$6 || (_path22$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM20 0H22V3H20zM29 10.001H32V12.001H29z"
    })), _path23$6 || (_path23$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path24$6 || (_path24$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path25$6 || (_path25$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), _path26$6 || (_path26$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9852,5.9852,0,0,0,16.1431,7.5083,7.3737,7.3737,0,0,0,13.5,7a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,24H19a5.9672,5.9672,0,0,0,5.5667-8.2A5.9722,5.9722,0,0,0,27,11ZM19,22H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,22Zm4.5222-7.9131a5.9592,5.9592,0,0,0-2.8728-1.8428,7.5212,7.5212,0,0,0-2.7224-3.78,3.9869,3.9869,0,1,1,5.5952,5.6225Z"
    })), children);
  });
  var SnowScattered20 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScattered20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$6 || (_path27$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM20 0H22V3H20zM29 10.001H32V12.001H29z"
    })), _path28$6 || (_path28$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path29$6 || (_path29$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path30$6 || (_path30$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), _path31$6 || (_path31$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9852,5.9852,0,0,0,16.1431,7.5083,7.3737,7.3737,0,0,0,13.5,7a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,24H19a5.9672,5.9672,0,0,0,5.5667-8.2A5.9722,5.9722,0,0,0,27,11ZM19,22H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,22Zm4.5222-7.9131a5.9592,5.9592,0,0,0-2.8728-1.8428,7.5212,7.5212,0,0,0-2.7224-3.78,3.9869,3.9869,0,1,1,5.5952,5.6225Z"
    })), children);
  });
  var SnowScattered16 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScattered16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$6 || (_path32$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM20 0H22V3H20zM29 10.001H32V12.001H29z"
    })), _path33$6 || (_path33$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path34$6 || (_path34$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path35$6 || (_path35$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), _path36$6 || (_path36$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9852,5.9852,0,0,0,16.1431,7.5083,7.3737,7.3737,0,0,0,13.5,7a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,24H19a5.9672,5.9672,0,0,0,5.5667-8.2A5.9722,5.9722,0,0,0,27,11ZM19,22H8a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,22Zm4.5222-7.9131a5.9592,5.9592,0,0,0-2.8728-1.8428,7.5212,7.5212,0,0,0-2.7224-3.78,3.9869,3.9869,0,1,1,5.5952,5.6225Z"
    })), children);
  });
  var SnowScatteredNight32 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScatteredNight32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$6 || (_path37$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM29.8439 13.0347a1.517 1.517 0 00-1.23-.8658 5.3552 5.3552 0 01-3.4095-1.7158 6.4655 6.4655 0 01-1.286-6.3926 1.6025 1.6025 0 00-.2989-1.5459 1.4543 1.4543 0 00-1.36-.4931l-.0191.0039a7.7685 7.7685 0 00-5.8847 5.5737A7.3706 7.3706 0 0013.5 7a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 24H19a6.0066 6.0066 0 006-6c0-.0571-.0123-.1113-.0139-.1685a7.5076 7.5076 0 004.7611-3.2768A1.5369 1.5369 0 0029.8439 13.0347zM19 22H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 22zm5.5974-6.1289a5.9661 5.9661 0 00-3.948-3.627 7.49 7.49 0 00-2.489-3.58 5.9018 5.9018 0 013.6381-4.4473 8.4577 8.4577 0 001.94 7.5967A7.4007 7.4007 0 0027.64 14.041 5.4487 5.4487 0 0124.5974 15.8711z"
    })), children);
  });
  var SnowScatteredNight24 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScatteredNight24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$6 || (_path38$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM29.8439 13.0347a1.517 1.517 0 00-1.23-.8658 5.3552 5.3552 0 01-3.4095-1.7158 6.4655 6.4655 0 01-1.286-6.3926 1.6025 1.6025 0 00-.2989-1.5459 1.4543 1.4543 0 00-1.36-.4931l-.0191.0039a7.7685 7.7685 0 00-5.8847 5.5737A7.3706 7.3706 0 0013.5 7a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 24H19a6.0066 6.0066 0 006-6c0-.0571-.0123-.1113-.0139-.1685a7.5076 7.5076 0 004.7611-3.2768A1.5369 1.5369 0 0029.8439 13.0347zM19 22H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 22zm5.5974-6.1289a5.9661 5.9661 0 00-3.948-3.627 7.49 7.49 0 00-2.489-3.58 5.9018 5.9018 0 013.6381-4.4473 8.4577 8.4577 0 001.94 7.5967A7.4007 7.4007 0 0027.64 14.041 5.4487 5.4487 0 0124.5974 15.8711z"
    })), children);
  });
  var SnowScatteredNight20 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScatteredNight20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$6 || (_path39$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM29.8439 13.0347a1.517 1.517 0 00-1.23-.8658 5.3552 5.3552 0 01-3.4095-1.7158 6.4655 6.4655 0 01-1.286-6.3926 1.6025 1.6025 0 00-.2989-1.5459 1.4543 1.4543 0 00-1.36-.4931l-.0191.0039a7.7685 7.7685 0 00-5.8847 5.5737A7.3706 7.3706 0 0013.5 7a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 24H19a6.0066 6.0066 0 006-6c0-.0571-.0123-.1113-.0139-.1685a7.5076 7.5076 0 004.7611-3.2768A1.5369 1.5369 0 0029.8439 13.0347zM19 22H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 22zm5.5974-6.1289a5.9661 5.9661 0 00-3.948-3.627 7.49 7.49 0 00-2.489-3.58 5.9018 5.9018 0 013.6381-4.4473 8.4577 8.4577 0 001.94 7.5967A7.4007 7.4007 0 0027.64 14.041 5.4487 5.4487 0 0124.5974 15.8711z"
    })), children);
  });
  var SnowScatteredNight16 = /*#__PURE__*/React__default['default'].forwardRef(function SnowScatteredNight16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$6 || (_path40$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2zM20 26H22V28H20zM22 28H24V30H22zM24 30H26V32H24zM24 26H26V28H24zM20 30H22V32H20zM11 26H13V28H11zM13 28H15V30H13zM15 30H17V32H15zM15 26H17V28H15zM11 30H13V32H11zM29.8439 13.0347a1.517 1.517 0 00-1.23-.8658 5.3552 5.3552 0 01-3.4095-1.7158 6.4655 6.4655 0 01-1.286-6.3926 1.6025 1.6025 0 00-.2989-1.5459 1.4543 1.4543 0 00-1.36-.4931l-.0191.0039a7.7685 7.7685 0 00-5.8847 5.5737A7.3706 7.3706 0 0013.5 7a7.5511 7.5511 0 00-7.1494 5.2441A5.9926 5.9926 0 008 24H19a6.0066 6.0066 0 006-6c0-.0571-.0123-.1113-.0139-.1685a7.5076 7.5076 0 004.7611-3.2768A1.5369 1.5369 0 0029.8439 13.0347zM19 22H8a3.9926 3.9926 0 01-.6733-7.9292l.663-.1128.1456-.6562a5.496 5.496 0 0110.7294 0l.1456.6562.6626.1128A3.9925 3.9925 0 0119 22zm5.5974-6.1289a5.9661 5.9661 0 00-3.948-3.627 7.49 7.49 0 00-2.489-3.58 5.9018 5.9018 0 013.6381-4.4473 8.4577 8.4577 0 001.94 7.5967A7.4007 7.4007 0 0027.64 14.041 5.4487 5.4487 0 0124.5974 15.8711z"
    })), children);
  });
  var SnowDensity32 = /*#__PURE__*/React__default['default'].forwardRef(function SnowDensity32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$6 || (_path41$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), _path42$6 || (_path42$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.6 16.8L19.4 15.2 17 17 17 14 15 14 15 17 12.6 15.2 11.4 16.8 14.333 19 11.4 21.2 12.6 22.8 15 21 15 24 17 24 17 21 19.4 22.8 20.6 21.2 17.667 19 20.6 16.8z"
    })), children);
  });
  var SnowDensity24 = /*#__PURE__*/React__default['default'].forwardRef(function SnowDensity24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$6 || (_path43$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), _path44$6 || (_path44$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.6 16.8L19.4 15.2 17 17 17 14 15 14 15 17 12.6 15.2 11.4 16.8 14.333 19 11.4 21.2 12.6 22.8 15 21 15 24 17 24 17 21 19.4 22.8 20.6 21.2 17.667 19 20.6 16.8z"
    })), children);
  });
  var SnowDensity20 = /*#__PURE__*/React__default['default'].forwardRef(function SnowDensity20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$6 || (_path45$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), _path46$6 || (_path46$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.6 16.8L19.4 15.2 17 17 17 14 15 14 15 17 12.6 15.2 11.4 16.8 14.333 19 11.4 21.2 12.6 22.8 15 21 15 24 17 24 17 21 19.4 22.8 20.6 21.2 17.667 19 20.6 16.8z"
    })), children);
  });
  var SnowDensity16 = /*#__PURE__*/React__default['default'].forwardRef(function SnowDensity16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$6 || (_path47$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28a9.0114,9.0114,0,0,1-9-9,9.9843,9.9843,0,0,1,1.4941-4.9554L15.1528,3.4367a1.04,1.04,0,0,1,1.6944,0l6.6289,10.5564A10.0633,10.0633,0,0,1,25,19,9.0114,9.0114,0,0,1,16,28ZM16,5.8483l-5.7817,9.2079A7.9771,7.9771,0,0,0,9,19a7,7,0,0,0,14,0,8.0615,8.0615,0,0,0-1.248-3.9953Z"
    })), _path48$6 || (_path48$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.6 16.8L19.4 15.2 17 17 17 14 15 14 15 17 12.6 15.2 11.4 16.8 14.333 19 11.4 21.2 12.6 22.8 15 21 15 24 17 24 17 21 19.4 22.8 20.6 21.2 17.667 19 20.6 16.8z"
    })), children);
  });
  var Snowflake32 = /*#__PURE__*/React__default['default'].forwardRef(function Snowflake32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$6 || (_path49$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4148,12H28V10H23.4148l4.5857-4.5854L26.5864,4,22,8.5869V4H20v6.5869L18.5867,12H17V8H15v4H13.4133L12,10.5869V4H10V8.5869L5.4136,4,4,5.4146,8.5852,10H4v2h6.5852L12,13.415V15H8v2h4v1.5869L10.5867,20H4v2H8.5867L4,26.5864l1.4141,1.4141L10,23.415V28h2V21.415L13.4148,20H15v4h2V20h1.5852L20,21.415V28h2V23.415l4.5854,4.5855L28,26.5864,23.4133,22H28V20H21.4133L20,18.5869V17h4V15H20V13.415ZM18,18H14V14h4Z"
    })), children);
  });
  var Snowflake24 = /*#__PURE__*/React__default['default'].forwardRef(function Snowflake24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$6 || (_path50$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4148,12H28V10H23.4148l4.5857-4.5854L26.5864,4,22,8.5869V4H20v6.5869L18.5867,12H17V8H15v4H13.4133L12,10.5869V4H10V8.5869L5.4136,4,4,5.4146,8.5852,10H4v2h6.5852L12,13.415V15H8v2h4v1.5869L10.5867,20H4v2H8.5867L4,26.5864l1.4141,1.4141L10,23.415V28h2V21.415L13.4148,20H15v4h2V20h1.5852L20,21.415V28h2V23.415l4.5854,4.5855L28,26.5864,23.4133,22H28V20H21.4133L20,18.5869V17h4V15H20V13.415ZM18,18H14V14h4Z"
    })), children);
  });
  var Snowflake20 = /*#__PURE__*/React__default['default'].forwardRef(function Snowflake20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$6 || (_path51$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4148,12H28V10H23.4148l4.5857-4.5854L26.5864,4,22,8.5869V4H20v6.5869L18.5867,12H17V8H15v4H13.4133L12,10.5869V4H10V8.5869L5.4136,4,4,5.4146,8.5852,10H4v2h6.5852L12,13.415V15H8v2h4v1.5869L10.5867,20H4v2H8.5867L4,26.5864l1.4141,1.4141L10,23.415V28h2V21.415L13.4148,20H15v4h2V20h1.5852L20,21.415V28h2V23.415l4.5854,4.5855L28,26.5864,23.4133,22H28V20H21.4133L20,18.5869V17h4V15H20V13.415ZM18,18H14V14h4Z"
    })), children);
  });
  var Snowflake16 = /*#__PURE__*/React__default['default'].forwardRef(function Snowflake16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$6 || (_path52$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4148,12H28V10H23.4148l4.5857-4.5854L26.5864,4,22,8.5869V4H20v6.5869L18.5867,12H17V8H15v4H13.4133L12,10.5869V4H10V8.5869L5.4136,4,4,5.4146,8.5852,10H4v2h6.5852L12,13.415V15H8v2h4v1.5869L10.5867,20H4v2H8.5867L4,26.5864l1.4141,1.4141L10,23.415V28h2V21.415L13.4148,20H15v4h2V20h1.5852L20,21.415V28h2V23.415l4.5854,4.5855L28,26.5864,23.4133,22H28V20H21.4133L20,18.5869V17h4V15H20V13.415ZM18,18H14V14h4Z"
    })), children);
  });
  var Soccer32 = /*#__PURE__*/React__default['default'].forwardRef(function Soccer32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$5 || (_circle$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "28",
      r: "2"
    })), _path53$6 || (_path53$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 17.5H15.45V19.5H7.55z",
      transform: "rotate(-45 11.5 18.5)"
    })), _path54$6 || (_path54$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0028 16.584zM24.5 9A3.5 3.5 0 1128 5.5 3.504 3.504 0 0124.5 9zm0-5A1.5 1.5 0 1026 5.5 1.5017 1.5017 0 0024.5 4z"
    })), children);
  });
  var Soccer24 = /*#__PURE__*/React__default['default'].forwardRef(function Soccer24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle2$5 || (_circle2$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "28",
      r: "2"
    })), _path55$6 || (_path55$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 17.5H15.45V19.5H7.55z",
      transform: "rotate(-45 11.5 18.5)"
    })), _path56$6 || (_path56$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0028 16.584zM24.5 9A3.5 3.5 0 1128 5.5 3.504 3.504 0 0124.5 9zm0-5A1.5 1.5 0 1026 5.5 1.5017 1.5017 0 0024.5 4z"
    })), children);
  });
  var Soccer20 = /*#__PURE__*/React__default['default'].forwardRef(function Soccer20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$5 || (_circle3$5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "28",
      r: "2"
    })), _path57$6 || (_path57$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 17.5H15.45V19.5H7.55z",
      transform: "rotate(-45 11.5 18.5)"
    })), _path58$6 || (_path58$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0028 16.584zM24.5 9A3.5 3.5 0 1128 5.5 3.504 3.504 0 0124.5 9zm0-5A1.5 1.5 0 1026 5.5 1.5017 1.5017 0 0024.5 4z"
    })), children);
  });
  var Soccer16 = /*#__PURE__*/React__default['default'].forwardRef(function Soccer16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$4 || (_circle4$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "28",
      r: "2"
    })), _path59$6 || (_path59$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 17.5H15.45V19.5H7.55z",
      transform: "rotate(-45 11.5 18.5)"
    })), _path60$6 || (_path60$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0028 16.584zM24.5 9A3.5 3.5 0 1128 5.5 3.504 3.504 0 0124.5 9zm0-5A1.5 1.5 0 1026 5.5 1.5017 1.5017 0 0024.5 4z"
    })), children);
  });
  var SoilMoisture32 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoisture32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$6 || (_path61$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,28A5.385,5.385,0,0,1,19,22.751a5.3837,5.3837,0,0,1,.874-2.8308L23.49,14.5383a1.217,1.217,0,0,1,2.02,0L29.06,19.8154A5.4923,5.4923,0,0,1,30,22.751,5.385,5.385,0,0,1,24.5,28Zm0-11.38-2.9356,4.3672A3.3586,3.3586,0,0,0,21,22.751a3.51,3.51,0,0,0,7,0,3.4356,3.4356,0,0,0-.63-1.867Z"
    })), _circle5$3 || (_circle5$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle6$3 || (_circle6$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle7$3 || (_circle7$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle8$3 || (_circle8$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle9$3 || (_circle9$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle10$3 || (_circle10$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "11",
      r: "1"
    })), _circle11$3 || (_circle11$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle12$3 || (_circle12$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path62$6 || (_path62$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H30V8H2z"
    })), children);
  });
  var SoilMoisture24 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoisture24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$6 || (_path63$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,28A5.385,5.385,0,0,1,19,22.751a5.3837,5.3837,0,0,1,.874-2.8308L23.49,14.5383a1.217,1.217,0,0,1,2.02,0L29.06,19.8154A5.4923,5.4923,0,0,1,30,22.751,5.385,5.385,0,0,1,24.5,28Zm0-11.38-2.9356,4.3672A3.3586,3.3586,0,0,0,21,22.751a3.51,3.51,0,0,0,7,0,3.4356,3.4356,0,0,0-.63-1.867Z"
    })), _circle13$3 || (_circle13$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle14$3 || (_circle14$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle15$3 || (_circle15$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle16$3 || (_circle16$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle17$3 || (_circle17$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle18$3 || (_circle18$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "11",
      r: "1"
    })), _circle19$3 || (_circle19$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle20$3 || (_circle20$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path64$6 || (_path64$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H30V8H2z"
    })), children);
  });
  var SoilMoisture20 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoisture20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$6 || (_path65$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,28A5.385,5.385,0,0,1,19,22.751a5.3837,5.3837,0,0,1,.874-2.8308L23.49,14.5383a1.217,1.217,0,0,1,2.02,0L29.06,19.8154A5.4923,5.4923,0,0,1,30,22.751,5.385,5.385,0,0,1,24.5,28Zm0-11.38-2.9356,4.3672A3.3586,3.3586,0,0,0,21,22.751a3.51,3.51,0,0,0,7,0,3.4356,3.4356,0,0,0-.63-1.867Z"
    })), _circle21$3 || (_circle21$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle22$3 || (_circle22$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle23$3 || (_circle23$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle24$3 || (_circle24$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle25$2 || (_circle25$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle26$2 || (_circle26$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "11",
      r: "1"
    })), _circle27$2 || (_circle27$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle28$2 || (_circle28$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path66$6 || (_path66$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H30V8H2z"
    })), children);
  });
  var SoilMoisture16 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoisture16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$6 || (_path67$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5,28A5.385,5.385,0,0,1,19,22.751a5.3837,5.3837,0,0,1,.874-2.8308L23.49,14.5383a1.217,1.217,0,0,1,2.02,0L29.06,19.8154A5.4923,5.4923,0,0,1,30,22.751,5.385,5.385,0,0,1,24.5,28Zm0-11.38-2.9356,4.3672A3.3586,3.3586,0,0,0,21,22.751a3.51,3.51,0,0,0,7,0,3.4356,3.4356,0,0,0-.63-1.867Z"
    })), _circle29$2 || (_circle29$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle30$2 || (_circle30$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle31$2 || (_circle31$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle32$2 || (_circle32$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle33$2 || (_circle33$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle34$1 || (_circle34$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "27",
      cy: "11",
      r: "1"
    })), _circle35$1 || (_circle35$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle36$1 || (_circle36$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path68$6 || (_path68$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H30V8H2z"
    })), children);
  });
  var SoilMoistureField32 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureField32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$6 || (_path69$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 30a5.202 5.202 0 01-4.626-8.08L23.49 16.5382a1.217 1.217 0 012.02 0L29.06 21.8154A5.4921 5.4921 0 0130 24.751 5.385 5.385 0 0124.5 30zm0-11.38l-2.9356 4.3672A3.2079 3.2079 0 0024.5 28 3.3855 3.3855 0 0028 24.751a3.4354 3.4354 0 00-.63-1.867zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2z"
    })), children);
  });
  var SoilMoistureField24 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureField24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$6 || (_path70$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 30a5.202 5.202 0 01-4.626-8.08L23.49 16.5382a1.217 1.217 0 012.02 0L29.06 21.8154A5.4921 5.4921 0 0130 24.751 5.385 5.385 0 0124.5 30zm0-11.38l-2.9356 4.3672A3.2079 3.2079 0 0024.5 28 3.3855 3.3855 0 0028 24.751a3.4354 3.4354 0 00-.63-1.867zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2z"
    })), children);
  });
  var SoilMoistureField20 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureField20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$6 || (_path71$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 30a5.202 5.202 0 01-4.626-8.08L23.49 16.5382a1.217 1.217 0 012.02 0L29.06 21.8154A5.4921 5.4921 0 0130 24.751 5.385 5.385 0 0124.5 30zm0-11.38l-2.9356 4.3672A3.2079 3.2079 0 0024.5 28 3.3855 3.3855 0 0028 24.751a3.4354 3.4354 0 00-.63-1.867zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2z"
    })), children);
  });
  var SoilMoistureField16 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureField16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$6 || (_path72$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.5 30a5.202 5.202 0 01-4.626-8.08L23.49 16.5382a1.217 1.217 0 012.02 0L29.06 21.8154A5.4921 5.4921 0 0130 24.751 5.385 5.385 0 0124.5 30zm0-11.38l-2.9356 4.3672A3.2079 3.2079 0 0024.5 28 3.3855 3.3855 0 0028 24.751a3.4354 3.4354 0 00-.63-1.867zM11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2z"
    })), children);
  });
  var SoilMoistureGlobal32 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureGlobal32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$6 || (_path73$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.7347 4.7347 0 01-4.2075-7.35l3.3687-5.1942a1 1 0 011.6779 0l3.3152 5.11A4.9753 4.9753 0 0130 25.2231 4.8979 4.8979 0 0125 30zm0-10.1629l-2.5078 3.8662A2.9264 2.9264 0 1028 25.2231a2.96 2.96 0 00-.5444-1.6028zM11 24H9A17.0192 17.0192 0 0126 7h4V9H26A15.017 15.017 0 0011 24z"
    })), _path74$6 || (_path74$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H14A12.0137,12.0137,0,0,1,26,12h4v2H26A10.0113,10.0113,0,0,0,16,24Z"
    })), _path75$6 || (_path75$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilMoistureGlobal24 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureGlobal24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$6 || (_path76$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.7347 4.7347 0 01-4.2075-7.35l3.3687-5.1942a1 1 0 011.6779 0l3.3152 5.11A4.9753 4.9753 0 0130 25.2231 4.8979 4.8979 0 0125 30zm0-10.1629l-2.5078 3.8662A2.9264 2.9264 0 1028 25.2231a2.96 2.96 0 00-.5444-1.6028zM11 24H9A17.0192 17.0192 0 0126 7h4V9H26A15.017 15.017 0 0011 24z"
    })), _path77$6 || (_path77$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H14A12.0137,12.0137,0,0,1,26,12h4v2H26A10.0113,10.0113,0,0,0,16,24Z"
    })), _path78$6 || (_path78$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilMoistureGlobal20 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureGlobal20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$6 || (_path79$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.7347 4.7347 0 01-4.2075-7.35l3.3687-5.1942a1 1 0 011.6779 0l3.3152 5.11A4.9753 4.9753 0 0130 25.2231 4.8979 4.8979 0 0125 30zm0-10.1629l-2.5078 3.8662A2.9264 2.9264 0 1028 25.2231a2.96 2.96 0 00-.5444-1.6028zM11 24H9A17.0192 17.0192 0 0126 7h4V9H26A15.017 15.017 0 0011 24z"
    })), _path80$6 || (_path80$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H14A12.0137,12.0137,0,0,1,26,12h4v2H26A10.0113,10.0113,0,0,0,16,24Z"
    })), _path81$6 || (_path81$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilMoistureGlobal16 = /*#__PURE__*/React__default['default'].forwardRef(function SoilMoistureGlobal16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$6 || (_path82$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.7347 4.7347 0 01-4.2075-7.35l3.3687-5.1942a1 1 0 011.6779 0l3.3152 5.11A4.9753 4.9753 0 0130 25.2231 4.8979 4.8979 0 0125 30zm0-10.1629l-2.5078 3.8662A2.9264 2.9264 0 1028 25.2231a2.96 2.96 0 00-.5444-1.6028zM11 24H9A17.0192 17.0192 0 0126 7h4V9H26A15.017 15.017 0 0011 24z"
    })), _path83$6 || (_path83$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,24H14A12.0137,12.0137,0,0,1,26,12h4v2H26A10.0113,10.0113,0,0,0,16,24Z"
    })), _path84$6 || (_path84$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilTemperature32 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperature32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle37 || (_circle37 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle38 || (_circle38 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle39 || (_circle39 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle40 || (_circle40 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle41 || (_circle41 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle42 || (_circle42 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle43 || (_circle43 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path85$6 || (_path85$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM2 6H30V8H2z"
    })), children);
  });
  var SoilTemperature24 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperature24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle44 || (_circle44 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle45 || (_circle45 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle46 || (_circle46 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle47 || (_circle47 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle48 || (_circle48 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle49 || (_circle49 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle50 || (_circle50 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path86$6 || (_path86$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM2 6H30V8H2z"
    })), children);
  });
  var SoilTemperature20 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperature20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle51 || (_circle51 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle52 || (_circle52 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle53 || (_circle53 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle54 || (_circle54 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle55 || (_circle55 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle56 || (_circle56 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle57 || (_circle57 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path87$6 || (_path87$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM2 6H30V8H2z"
    })), children);
  });
  var SoilTemperature16 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperature16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle58 || (_circle58 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "5",
      cy: "13",
      r: "1"
    })), _circle59 || (_circle59 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "11",
      cy: "19",
      r: "1"
    })), _circle60 || (_circle60 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "15",
      cy: "25",
      r: "1"
    })), _circle61 || (_circle61 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "17",
      cy: "15",
      r: "1"
    })), _circle62 || (_circle62 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "13",
      cy: "11",
      r: "1"
    })), _circle63 || (_circle63 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "27",
      r: "1"
    })), _circle64 || (_circle64 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "3",
      cy: "21",
      r: "1"
    })), _path88$6 || (_path88$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM2 6H30V8H2z"
    })), children);
  });
  var SoilTemperatureField32 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureField32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$6 || (_path89$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2zM25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14z"
    })), children);
  });
  var SoilTemperatureField24 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureField24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$6 || (_path90$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2zM25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14z"
    })), children);
  });
  var SoilTemperatureField20 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureField20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$6 || (_path91$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2zM25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14z"
    })), children);
  });
  var SoilTemperatureField16 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureField16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$6 || (_path92$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 16V11h1a4.0045 4.0045 0 004-4V4H13a3.9779 3.9779 0 00-2.7468 1.1067A6.0034 6.0034 0 005 2H2V5a6.0066 6.0066 0 006 6H9v5H2v2H16V16zM13 6h1V7a2.002 2.002 0 01-2 2H11V8A2.002 2.002 0 0113 6zM8 9A4.0045 4.0045 0 014 5V4H5A4.0045 4.0045 0 019 8V9zM2 21H16V23H2zM2 26H16V28H2zM25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14z"
    })), children);
  });
  var SoilTemperatureGlobal32 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureGlobal32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$6 || (_path93$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM16 24H14a11.89 11.89 0 013.7642-8.7271l1.373 1.4542A9.909 9.909 0 0016 24z"
    })), _path94$6 || (_path94$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,24H9A17.0192,17.0192,0,0,1,26,7h4V9H26A15.017,15.017,0,0,0,11,24Z"
    })), _path95$6 || (_path95$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilTemperatureGlobal24 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureGlobal24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$6 || (_path96$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM16 24H14a11.89 11.89 0 013.7642-8.7271l1.373 1.4542A9.909 9.909 0 0016 24z"
    })), _path97$6 || (_path97$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,24H9A17.0192,17.0192,0,0,1,26,7h4V9H26A15.017,15.017,0,0,0,11,24Z"
    })), _path98$6 || (_path98$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilTemperatureGlobal20 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureGlobal20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$6 || (_path99$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM16 24H14a11.89 11.89 0 013.7642-8.7271l1.373 1.4542A9.909 9.909 0 0016 24z"
    })), _path100$6 || (_path100$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,24H9A17.0192,17.0192,0,0,1,26,7h4V9H26A15.017,15.017,0,0,0,11,24Z"
    })), _path101$6 || (_path101$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SoilTemperatureGlobal16 = /*#__PURE__*/React__default['default'].forwardRef(function SoilTemperatureGlobal16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$6 || (_path102$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 30a4.9863 4.9863 0 01-3-8.98V15a3 3 0 016 0v6.02A4.9863 4.9863 0 0125 30zm0-16a1.0011 1.0011 0 00-1 1v7.13l-.4971.2893A2.9676 2.9676 0 0022 25a3 3 0 006 0 2.9676 2.9676 0 00-1.5029-2.5811L26 22.13V15A1.0011 1.0011 0 0025 14zM16 24H14a11.89 11.89 0 013.7642-8.7271l1.373 1.4542A9.909 9.909 0 0016 24z"
    })), _path103$6 || (_path103$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,24H9A17.0192,17.0192,0,0,1,26,7h4V9H26A15.017,15.017,0,0,0,11,24Z"
    })), _path104$6 || (_path104$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2A21.8625,21.8625,0,0,0,13.9993,5.5757,21.856,21.856,0,0,0,2,2V4A19.8735,19.8735,0,0,1,12.2622,6.835,22.1514,22.1514,0,0,0,9.9475,8.979,17.001,17.001,0,0,0,2,7V9a15.0142,15.0142,0,0,1,6.6191,1.5366,22.0768,22.0768,0,0,0-1.7016,2.5371A12.0319,12.0319,0,0,0,2,12v2a9.8838,9.8838,0,0,1,4.0007.8506A21.861,21.861,0,0,0,4,24H6A20.0226,20.0226,0,0,1,26,4h4V2Z"
    })), children);
  });
  var SolarPanel32 = /*#__PURE__*/React__default['default'].forwardRef(function SolarPanel32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$6 || (_path105$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26V14H13V26h5v2H2v2H30V28H25V26zm-5-2V21h3v3zm-2-3v3H20V21zm-3-2V16h3v3zm8 0H25V16h3zM18 16v3H15V16zm-3 8V21h3v3zm8 4H20V26h3zM9.3328 14.981A4 4 0 1116 12H14a2 2 0 10-3.3333 1.4907zM11 2H13V6H11zM2 11H6V13H2z"
    })), _path106$6 || (_path106$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.343 4.343H7.343V8.343H5.343z",
      transform: "rotate(-45 6.343 6.343)"
    })), _path107$6 || (_path107$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.657 4.343H18.657V8.343H16.657z",
      transform: "rotate(-135 17.657 6.343)"
    })), children);
  });
  var SolarPanel24 = /*#__PURE__*/React__default['default'].forwardRef(function SolarPanel24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$6 || (_path108$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26V14H13V26h5v2H2v2H30V28H25V26zm-5-2V21h3v3zm-2-3v3H20V21zm-3-2V16h3v3zm8 0H25V16h3zM18 16v3H15V16zm-3 8V21h3v3zm8 4H20V26h3zM9.3328 14.981A4 4 0 1116 12H14a2 2 0 10-3.3333 1.4907zM11 2H13V6H11zM2 11H6V13H2z"
    })), _path109$6 || (_path109$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.343 4.343H7.343V8.343H5.343z",
      transform: "rotate(-45 6.343 6.343)"
    })), _path110$6 || (_path110$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.657 4.343H18.657V8.343H16.657z",
      transform: "rotate(-135 17.657 6.343)"
    })), children);
  });
  var SolarPanel20 = /*#__PURE__*/React__default['default'].forwardRef(function SolarPanel20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$6 || (_path111$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26V14H13V26h5v2H2v2H30V28H25V26zm-5-2V21h3v3zm-2-3v3H20V21zm-3-2V16h3v3zm8 0H25V16h3zM18 16v3H15V16zm-3 8V21h3v3zm8 4H20V26h3zM9.3328 14.981A4 4 0 1116 12H14a2 2 0 10-3.3333 1.4907zM11 2H13V6H11zM2 11H6V13H2z"
    })), _path112$6 || (_path112$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.343 4.343H7.343V8.343H5.343z",
      transform: "rotate(-45 6.343 6.343)"
    })), _path113$6 || (_path113$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.657 4.343H18.657V8.343H16.657z",
      transform: "rotate(-135 17.657 6.343)"
    })), children);
  });
  var SolarPanel16 = /*#__PURE__*/React__default['default'].forwardRef(function SolarPanel16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$6 || (_path114$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26V14H13V26h5v2H2v2H30V28H25V26zm-5-2V21h3v3zm-2-3v3H20V21zm-3-2V16h3v3zm8 0H25V16h3zM18 16v3H15V16zm-3 8V21h3v3zm8 4H20V26h3zM9.3328 14.981A4 4 0 1116 12H14a2 2 0 10-3.3333 1.4907zM11 2H13V6H11zM2 11H6V13H2z"
    })), _path115$6 || (_path115$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.343 4.343H7.343V8.343H5.343z",
      transform: "rotate(-45 6.343 6.343)"
    })), _path116$6 || (_path116$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.657 4.343H18.657V8.343H16.657z",
      transform: "rotate(-135 17.657 6.343)"
    })), children);
  });
  var SortAscending32 = /*#__PURE__*/React__default['default'].forwardRef(function SortAscending32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$6 || (_path117$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 18H16V20H2zM6 12H16V14H6zM10 6H16V8H10z"
    })), children);
  });
  var SortAscending24 = /*#__PURE__*/React__default['default'].forwardRef(function SortAscending24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$6 || (_path118$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 18H16V20H2zM6 12H16V14H6zM10 6H16V8H10z"
    })), children);
  });
  var SortAscending20 = /*#__PURE__*/React__default['default'].forwardRef(function SortAscending20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$6 || (_path119$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 18H16V20H2zM6 12H16V14H6zM10 6H16V8H10z"
    })), children);
  });
  var SortAscending16 = /*#__PURE__*/React__default['default'].forwardRef(function SortAscending16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$6 || (_path120$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 18H16V20H2zM6 12H16V14H6zM10 6H16V8H10z"
    })), children);
  });
  var SortDescending32 = /*#__PURE__*/React__default['default'].forwardRef(function SortDescending32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$6 || (_path121$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 6H16V8H2zM6 12H16V14H6zM10 18H16V20H10z"
    })), children);
  });
  var SortDescending24 = /*#__PURE__*/React__default['default'].forwardRef(function SortDescending24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$6 || (_path122$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 6H16V8H2zM6 12H16V14H6zM10 18H16V20H10z"
    })), children);
  });
  var SortDescending20 = /*#__PURE__*/React__default['default'].forwardRef(function SortDescending20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$6 || (_path123$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 6H16V8H2zM6 12H16V14H6zM10 18H16V20H10z"
    })), children);
  });
  var SortDescending16 = /*#__PURE__*/React__default['default'].forwardRef(function SortDescending16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$6 || (_path124$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 22L19.414 20.586 23 24.172 23 4 25 4 25 24.172 28.586 20.586 30 22 24 28 18 22zM2 6H16V8H2zM6 12H16V14H6zM10 18H16V20H10z"
    })), children);
  });
  var SpellCheck32 = /*#__PURE__*/React__default['default'].forwardRef(function SpellCheck32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$6 || (_path125$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"
    })), _path126$6 || (_path126$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 28H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), children);
  });
  var SpellCheck24 = /*#__PURE__*/React__default['default'].forwardRef(function SpellCheck24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$6 || (_path127$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"
    })), _path128$6 || (_path128$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 28H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), children);
  });
  var SpellCheck20 = /*#__PURE__*/React__default['default'].forwardRef(function SpellCheck20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$6 || (_path129$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"
    })), _path130$6 || (_path130$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 28H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), children);
  });
  var SpellCheck16 = /*#__PURE__*/React__default['default'].forwardRef(function SpellCheck16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$6 || (_path131$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"
    })), _path132$6 || (_path132$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 28H6a2 2 0 01-2-2V6A2 2 0 016 4H26a2 2 0 012 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"
    })), children);
  });
  var WatsonHealthSpineLabel32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSpineLabel32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$6 || (_path133$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V19h3a2 2 0 002-2V15A2 2 0 0026 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V29h3a2 2 0 002-2V25A2 2 0 0026 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 00-2 2V7a2 2 0 002 2h3v1h2V9h3a2 2 0 002-2V5A2 2 0 0026 3zM18 7V5h8V7z"
    })), children);
  });
  var WatsonHealthSpineLabel24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSpineLabel24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$6 || (_path134$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V19h3a2 2 0 002-2V15A2 2 0 0026 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V29h3a2 2 0 002-2V25A2 2 0 0026 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 00-2 2V7a2 2 0 002 2h3v1h2V9h3a2 2 0 002-2V5A2 2 0 0026 3zM18 7V5h8V7z"
    })), children);
  });
  var WatsonHealthSpineLabel20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSpineLabel20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$6 || (_path135$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V19h3a2 2 0 002-2V15A2 2 0 0026 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V29h3a2 2 0 002-2V25A2 2 0 0026 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 00-2 2V7a2 2 0 002 2h3v1h2V9h3a2 2 0 002-2V5A2 2 0 0026 3zM18 7V5h8V7z"
    })), children);
  });
  var WatsonHealthSpineLabel16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSpineLabel16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$6 || (_path136$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V19h3a2 2 0 002-2V15A2 2 0 0026 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 00-2 2v2a2 2 0 002 2h3v1h2V29h3a2 2 0 002-2V25A2 2 0 0026 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 00-2 2V7a2 2 0 002 2h3v1h2V9h3a2 2 0 002-2V5A2 2 0 0026 3zM18 7V5h8V7z"
    })), children);
  });
  var Split32 = /*#__PURE__*/React__default['default'].forwardRef(function Split32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$6 || (_path137$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM15 14H17V18H15zM15 8H17V12H15z"
    })), _path138$6 || (_path138$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Split24 = /*#__PURE__*/React__default['default'].forwardRef(function Split24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$6 || (_path139$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM15 14H17V18H15zM15 8H17V12H15z"
    })), _path140$6 || (_path140$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Split20 = /*#__PURE__*/React__default['default'].forwardRef(function Split20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$6 || (_path141$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM15 14H17V18H15zM15 8H17V12H15z"
    })), _path142$6 || (_path142$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var Split16 = /*#__PURE__*/React__default['default'].forwardRef(function Split16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$6 || (_path143$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 20H17V24H15zM15 14H17V18H15zM15 8H17V12H15z"
    })), _path144$6 || (_path144$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26A10,10,0,1,1,26,16,10.0114,10.0114,0,0,1,16,26Z"
    })), children);
  });
  var WatsonHealthSplitDiscard32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSplitDiscard32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$6 || (_path145$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26V6a10,10,0,0,1,0,20Z"
    })), children);
  });
  var WatsonHealthSplitDiscard24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSplitDiscard24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$6 || (_path146$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26V6a10,10,0,0,1,0,20Z"
    })), children);
  });
  var WatsonHealthSplitDiscard20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSplitDiscard20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$6 || (_path147$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26V6a10,10,0,0,1,0,20Z"
    })), children);
  });
  var WatsonHealthSplitDiscard16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSplitDiscard16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$6 || (_path148$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,16A12.01,12.01,0,0,0,17,4.0508V2H15V4.0508a11.99,11.99,0,0,0,0,23.8984V30h2V27.9492A12.01,12.01,0,0,0,28,16ZM16,26V6a10,10,0,0,1,0,20Z"
    })), children);
  });
  var SplitScreen32 = /*#__PURE__*/React__default['default'].forwardRef(function SplitScreen32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$6 || (_path149$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 002 7V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 00-2 2V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2z"
    })), children);
  });
  var SplitScreen24 = /*#__PURE__*/React__default['default'].forwardRef(function SplitScreen24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$6 || (_path150$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 002 7V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 00-2 2V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2z"
    })), children);
  });
  var SplitScreen20 = /*#__PURE__*/React__default['default'].forwardRef(function SplitScreen20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$6 || (_path151$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 002 7V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 00-2 2V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2z"
    })), children);
  });
  var SplitScreen16 = /*#__PURE__*/React__default['default'].forwardRef(function SplitScreen16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$6 || (_path152$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 002 7V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 00-2 2V25a2 2 0 002 2h6a2 2 0 002-2V7a2 2 0 00-2-2z"
    })), children);
  });
  var SprayPaint32 = /*#__PURE__*/React__default['default'].forwardRef(function SprayPaint32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$6 || (_path153$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"
    })), _path154$6 || (_path154$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H26V3H19V8H17a2.002 2.002 0 00-2 2V28a2.0023 2.0023 0 002 2H28a2.0027 2.0027 0 002-2V10A2.0023 2.0023 0 0028 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"
    })), children);
  });
  var SprayPaint24 = /*#__PURE__*/React__default['default'].forwardRef(function SprayPaint24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$6 || (_path155$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"
    })), _path156$6 || (_path156$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H26V3H19V8H17a2.002 2.002 0 00-2 2V28a2.0023 2.0023 0 002 2H28a2.0027 2.0027 0 002-2V10A2.0023 2.0023 0 0028 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"
    })), children);
  });
  var SprayPaint20 = /*#__PURE__*/React__default['default'].forwardRef(function SprayPaint20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$6 || (_path157$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"
    })), _path158$6 || (_path158$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H26V3H19V8H17a2.002 2.002 0 00-2 2V28a2.0023 2.0023 0 002 2H28a2.0027 2.0027 0 002-2V10A2.0023 2.0023 0 0028 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"
    })), children);
  });
  var SprayPaint16 = /*#__PURE__*/React__default['default'].forwardRef(function SprayPaint16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$6 || (_path159$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"
    })), _path160$6 || (_path160$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H26V3H19V8H17a2.002 2.002 0 00-2 2V28a2.0023 2.0023 0 002 2H28a2.0027 2.0027 0 002-2V10A2.0023 2.0023 0 0028 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"
    })), children);
  });
  var Sprout32 = /*#__PURE__*/React__default['default'].forwardRef(function Sprout32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$6 || (_path161$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Sprout24 = /*#__PURE__*/React__default['default'].forwardRef(function Sprout24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$6 || (_path162$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Sprout20 = /*#__PURE__*/React__default['default'].forwardRef(function Sprout20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$6 || (_path163$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Sprout16 = /*#__PURE__*/React__default['default'].forwardRef(function Sprout16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$6 || (_path164$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"
    })), children);
  });
  var Sql32 = /*#__PURE__*/React__default['default'].forwardRef(function Sql32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$6 || (_path165$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H17V23h1a2 2 0 002-2V11A2 2 0 0018 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Sql24 = /*#__PURE__*/React__default['default'].forwardRef(function Sql24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$6 || (_path166$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H17V23h1a2 2 0 002-2V11A2 2 0 0018 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Sql20 = /*#__PURE__*/React__default['default'].forwardRef(function Sql20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$6 || (_path167$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H17V23h1a2 2 0 002-2V11A2 2 0 0018 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Sql16 = /*#__PURE__*/React__default['default'].forwardRef(function Sql16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$6 || (_path168$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 00-2 2V21a2 2 0 002 2h1v2a2 2 0 002 2h2V25H17V23h1a2 2 0 002-2V11A2 2 0 0018 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var SquareFillGlyph = /*#__PURE__*/React__default['default'].forwardRef(function SquareFillGlyph(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$6 || (_path169$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 3H13V13H3z"
    })), children);
  });
  var StackLimitation32 = /*#__PURE__*/React__default['default'].forwardRef(function StackLimitation32(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$6 || (_path170$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H16V30H8zM24 12H20v2h4v2H21v2h3v2H20v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0024 12zM16 20H8V12h8zm-6-2h4V14H10zM16 3.41L14.59 2 12 4.59 9.41 2 8 3.41 10.59 6 8 8.59 9.41 10 12 7.41 14.59 10 16 8.59 13.41 6 16 3.41z"
    })), children);
  });
  var StackLimitation24 = /*#__PURE__*/React__default['default'].forwardRef(function StackLimitation24(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$6 || (_path171$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H16V30H8zM24 12H20v2h4v2H21v2h3v2H20v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0024 12zM16 20H8V12h8zm-6-2h4V14H10zM16 3.41L14.59 2 12 4.59 9.41 2 8 3.41 10.59 6 8 8.59 9.41 10 12 7.41 14.59 10 16 8.59 13.41 6 16 3.41z"
    })), children);
  });
  var StackLimitation20 = /*#__PURE__*/React__default['default'].forwardRef(function StackLimitation20(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$6 || (_path172$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H16V30H8zM24 12H20v2h4v2H21v2h3v2H20v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0024 12zM16 20H8V12h8zm-6-2h4V14H10zM16 3.41L14.59 2 12 4.59 9.41 2 8 3.41 10.59 6 8 8.59 9.41 10 12 7.41 14.59 10 16 8.59 13.41 6 16 3.41z"
    })), children);
  });
  var StackLimitation16 = /*#__PURE__*/React__default['default'].forwardRef(function StackLimitation16(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$6 || (_path173$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 22H16V30H8zM24 12H20v2h4v2H21v2h3v2H20v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0024 12zM16 20H8V12h8zm-6-2h4V14H10zM16 3.41L14.59 2 12 4.59 9.41 2 8 3.41 10.59 6 8 8.59 9.41 10 12 7.41 14.59 10 16 8.59 13.41 6 16 3.41z"
    })), children);
  });
  var WatsonHealthStackedMove32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedMove32(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$6 || (_path174$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"
    })), _path175$6 || (_path175$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"
    })), children);
  });
  var WatsonHealthStackedMove24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedMove24(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$6 || (_path176$6 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"
    })), _path177$5 || (_path177$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"
    })), children);
  });
  var WatsonHealthStackedMove20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedMove20(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$5 || (_path178$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"
    })), _path179$5 || (_path179$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"
    })), children);
  });
  var WatsonHealthStackedMove16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedMove16(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$5 || (_path180$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"
    })), _path181$5 || (_path181$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_132 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_132(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$5 || (_path182$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"
    })), _path183$5 || (_path183$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"
    })), _path184$5 || (_path184$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_124 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_124(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$5 || (_path185$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"
    })), _path186$5 || (_path186$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"
    })), _path187$5 || (_path187$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_120 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_120(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$5 || (_path188$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"
    })), _path189$5 || (_path189$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"
    })), _path190$5 || (_path190$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_116 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_116(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$5 || (_path191$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"
    })), _path192$5 || (_path192$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"
    })), _path193$5 || (_path193$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_232 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_232(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$5 || (_path194$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2V28A2 2 0 018 30zM2 14V28H8V14zM20 30H14a2 2 0 01-2-2V14a2 2 0 012-2h6a2 2 0 012 2V28A2 2 0 0120 30zM14 14V28h6V14z"
    })), _path195$5 || (_path195$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"
    })), _path196$5 || (_path196$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_224 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_224(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$5 || (_path197$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2V28A2 2 0 018 30zM2 14V28H8V14zM20 30H14a2 2 0 01-2-2V14a2 2 0 012-2h6a2 2 0 012 2V28A2 2 0 0120 30zM14 14V28h6V14z"
    })), _path198$5 || (_path198$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"
    })), _path199$5 || (_path199$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_220 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_220(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$5 || (_path200$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2V28A2 2 0 018 30zM2 14V28H8V14zM20 30H14a2 2 0 01-2-2V14a2 2 0 012-2h6a2 2 0 012 2V28A2 2 0 0120 30zM14 14V28h6V14z"
    })), _path201$5 || (_path201$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"
    })), _path202$5 || (_path202$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var WatsonHealthStackedScrolling_216 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStackedScrolling_216(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$5 || (_path203$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H2a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2V28A2 2 0 018 30zM2 14V28H8V14zM20 30H14a2 2 0 01-2-2V14a2 2 0 012-2h6a2 2 0 012 2V28A2 2 0 0120 30zM14 14V28h6V14z"
    })), _path204$5 || (_path204$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"
    })), _path205$5 || (_path205$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var Stamp32 = /*#__PURE__*/React__default['default'].forwardRef(function Stamp32(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$5 || (_path206$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"
    })), children);
  });
  var Stamp24 = /*#__PURE__*/React__default['default'].forwardRef(function Stamp24(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$5 || (_path207$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"
    })), children);
  });
  var Stamp20 = /*#__PURE__*/React__default['default'].forwardRef(function Stamp20(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$5 || (_path208$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"
    })), children);
  });
  var Stamp16 = /*#__PURE__*/React__default['default'].forwardRef(function Stamp16(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$5 || (_path209$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"
    })), children);
  });
  var Star32 = /*#__PURE__*/React__default['default'].forwardRef(function Star32(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$5 || (_path210$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.52l2.76,5.58.46,1,1,.15,6.16.89L22,18.44l-.75.73.18,1,1.05,6.13-5.51-2.89L16,23l-.93.49L9.56,26.34l1-6.13.18-1L10,18.44,5.58,14.09l6.16-.89,1-.15.46-1L16,6.52M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"
    })), children);
  });
  var Star24 = /*#__PURE__*/React__default['default'].forwardRef(function Star24(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$5 || (_path211$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.52l2.76,5.58.46,1,1,.15,6.16.89L22,18.44l-.75.73.18,1,1.05,6.13-5.51-2.89L16,23l-.93.49L9.56,26.34l1-6.13.18-1L10,18.44,5.58,14.09l6.16-.89,1-.15.46-1L16,6.52M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"
    })), children);
  });
  var Star20 = /*#__PURE__*/React__default['default'].forwardRef(function Star20(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$5 || (_path212$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6.52l2.76,5.58.46,1,1,.15,6.16.89L22,18.44l-.75.73.18,1,1.05,6.13-5.51-2.89L16,23l-.93.49L9.56,26.34l1-6.13.18-1L10,18.44,5.58,14.09l6.16-.89,1-.15.46-1L16,6.52M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"
    })), children);
  });
  var Star16 = /*#__PURE__*/React__default['default'].forwardRef(function Star16(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$5 || (_path213$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,3.3l1.4,2.8l0.2,0.5l0.5,0.1l3.1,0.4L11,9.2l-0.4,0.4l0.1,0.5l0.5,3.1l-2.8-1.4L8,11.5l-0.5,0.2l-2.8,1.4l0.5-3.1\tl0.1-0.5L5,9.2L2.8,7l3.1-0.4l0.5-0.1L6.6,6L8,3.3 M8,1L5.7,5.6L0.6,6.3l3.7,3.6L3.5,15L8,12.6l4.6,2.4l-0.9-5.1l3.7-3.6l-5.1-0.7\tL8,1z"
    })), children);
  });
  var StarFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function StarFilled32(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$5 || (_path214$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"
    })), children);
  });
  var StarFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function StarFilled24(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$5 || (_path215$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"
    })), children);
  });
  var StarFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function StarFilled20(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$5 || (_path216$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"
    })), children);
  });
  var StarFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function StarFilled16(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$5 || (_path217$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1L5.7,5.6L0.6,6.3l3.7,3.6L3.5,15L8,12.6l4.6,2.4l-0.9-5.1l3.7-3.6l-5.1-0.7L8,1z"
    })), children);
  });
  var StarHalf32 = /*#__PURE__*/React__default['default'].forwardRef(function StarHalf32(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$5 || (_path218$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.45 11.22L1.28 12.7 8.64 19.87 6.9 30 16 25.22 16 2 11.45 11.22z"
    })), children);
  });
  var StarHalf24 = /*#__PURE__*/React__default['default'].forwardRef(function StarHalf24(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$5 || (_path219$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.45 11.22L1.28 12.7 8.64 19.87 6.9 30 16 25.22 16 2 11.45 11.22z"
    })), children);
  });
  var StarHalf20 = /*#__PURE__*/React__default['default'].forwardRef(function StarHalf20(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$5 || (_path220$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.45 11.22L1.28 12.7 8.64 19.87 6.9 30 16 25.22 16 2 11.45 11.22z"
    })), children);
  });
  var StarHalf16 = /*#__PURE__*/React__default['default'].forwardRef(function StarHalf16(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$5 || (_path221$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.7 5.6L0.6 6.3 4.3 9.9 3.5 15 8 12.6 8 1z"
    })), children);
  });
  var StarReview32 = /*#__PURE__*/React__default['default'].forwardRef(function StarReview32(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$5 || (_path222$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H26V28H18zM18 22H30V24H18zM18 18H30V20H18z"
    })), _path223$5 || (_path223$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.549 11.217L16 2 11.451 11.217 1.28 12.695 8.64 19.87 6.902 30 14 26.269 14 24.009 9.559 26.344 10.611 20.208 10.789 19.171 10.036 18.438 5.578 14.091 11.739 13.196 12.779 13.045 13.245 12.102 16 6.519 18.755 12.102 19.221 13.045 20.261 13.196 27.715 14.281 28 12.3 20.549 11.217z"
    })), children);
  });
  var StarReview24 = /*#__PURE__*/React__default['default'].forwardRef(function StarReview24(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$5 || (_path224$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H26V28H18zM18 22H30V24H18zM18 18H30V20H18z"
    })), _path225$5 || (_path225$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.549 11.217L16 2 11.451 11.217 1.28 12.695 8.64 19.87 6.902 30 14 26.269 14 24.009 9.559 26.344 10.611 20.208 10.789 19.171 10.036 18.438 5.578 14.091 11.739 13.196 12.779 13.045 13.245 12.102 16 6.519 18.755 12.102 19.221 13.045 20.261 13.196 27.715 14.281 28 12.3 20.549 11.217z"
    })), children);
  });
  var StarReview20 = /*#__PURE__*/React__default['default'].forwardRef(function StarReview20(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$5 || (_path226$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H26V28H18zM18 22H30V24H18zM18 18H30V20H18z"
    })), _path227$5 || (_path227$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.549 11.217L16 2 11.451 11.217 1.28 12.695 8.64 19.87 6.902 30 14 26.269 14 24.009 9.559 26.344 10.611 20.208 10.789 19.171 10.036 18.438 5.578 14.091 11.739 13.196 12.779 13.045 13.245 12.102 16 6.519 18.755 12.102 19.221 13.045 20.261 13.196 27.715 14.281 28 12.3 20.549 11.217z"
    })), children);
  });
  var StarReview16 = /*#__PURE__*/React__default['default'].forwardRef(function StarReview16(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$5 || (_path228$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H26V28H18zM18 22H30V24H18zM18 18H30V20H18z"
    })), _path229$5 || (_path229$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.549 11.217L16 2 11.451 11.217 1.28 12.695 8.64 19.87 6.902 30 14 26.269 14 24.009 9.559 26.344 10.611 20.208 10.789 19.171 10.036 18.438 5.578 14.091 11.739 13.196 12.779 13.045 13.245 12.102 16 6.519 18.755 12.102 19.221 13.045 20.261 13.196 27.715 14.281 28 12.3 20.549 11.217z"
    })), children);
  });
  var WatsonHealthStatusAcknowledge32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusAcknowledge32(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$5 || (_path230$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path231$5 || (_path231$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), children);
  });
  var WatsonHealthStatusAcknowledge24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusAcknowledge24(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$5 || (_path232$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path233$5 || (_path233$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), children);
  });
  var WatsonHealthStatusAcknowledge20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusAcknowledge20(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$5 || (_path234$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path235$5 || (_path235$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), children);
  });
  var WatsonHealthStatusAcknowledge16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusAcknowledge16(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$5 || (_path236$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path237$5 || (_path237$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,24A10,10,0,1,1,24,14h2A12,12,0,1,0,14,26Z"
    })), children);
  });
  var WatsonHealthStatusChange32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusChange32(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$5 || (_path238$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 30a5 5 0 115-5A5.0057 5.0057 0 017 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 007 22zM23 30a5 5 0 115-5A5.0057 5.0057 0 0123 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 0023 22zM24 7v7l3.5859-3.4141L29 12l-6 6-6-6 1.4141-1.4141L22 14V7a1.0009 1.0009 0 00-1-1H9A1.0006 1.0006 0 008 7V18H6V7A3.0033 3.0033 0 019 4H21A3.0033 3.0033 0 0124 7z"
    })), children);
  });
  var WatsonHealthStatusChange24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusChange24(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$5 || (_path239$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 30a5 5 0 115-5A5.0057 5.0057 0 017 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 007 22zM23 30a5 5 0 115-5A5.0057 5.0057 0 0123 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 0023 22zM24 7v7l3.5859-3.4141L29 12l-6 6-6-6 1.4141-1.4141L22 14V7a1.0009 1.0009 0 00-1-1H9A1.0006 1.0006 0 008 7V18H6V7A3.0033 3.0033 0 019 4H21A3.0033 3.0033 0 0124 7z"
    })), children);
  });
  var WatsonHealthStatusChange20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusChange20(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$5 || (_path240$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 30a5 5 0 115-5A5.0057 5.0057 0 017 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 007 22zM23 30a5 5 0 115-5A5.0057 5.0057 0 0123 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 0023 22zM24 7v7l3.5859-3.4141L29 12l-6 6-6-6 1.4141-1.4141L22 14V7a1.0009 1.0009 0 00-1-1H9A1.0006 1.0006 0 008 7V18H6V7A3.0033 3.0033 0 019 4H21A3.0033 3.0033 0 0124 7z"
    })), children);
  });
  var WatsonHealthStatusChange16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusChange16(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$5 || (_path241$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 30a5 5 0 115-5A5.0057 5.0057 0 017 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 007 22zM23 30a5 5 0 115-5A5.0057 5.0057 0 0123 30zm0-8a3 3 0 103 3A3.0033 3.0033 0 0023 22zM24 7v7l3.5859-3.4141L29 12l-6 6-6-6 1.4141-1.4141L22 14V7a1.0009 1.0009 0 00-1-1H9A1.0006 1.0006 0 008 7V18H6V7A3.0033 3.0033 0 019 4H21A3.0033 3.0033 0 0124 7z"
    })), children);
  });
  var WatsonHealthStatusPartialFail32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusPartialFail32(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$5 || (_path242$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1407 23.7642l1.5315 1.2851a13.976 13.976 0 002.4408-4.1821l-1.8776-.6836A11.9729 11.9729 0 0125.1407 23.7642zM18 27.81l.4128 1.9677A13.8888 13.8888 0 0022.9543 28.14L22 26.4087A12.52 12.52 0 0118 27.81zM10 26.4087L9 28.14a14.14 14.14 0 004.5872 1.6382l.3469-1.9677A12.1519 12.1519 0 0110 26.4087zM4.7646 20.1836l-1.8776.6836a13.976 13.976 0 002.4408 4.1821l1.5315-1.2851A11.9729 11.9729 0 014.7646 20.1836zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22zM15 8H17V19H15z"
    })), _path243$5 || (_path243$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12,12,0,0,0,4,16H2a14,14,0,0,1,28,0Z"
    })), children);
  });
  var WatsonHealthStatusPartialFail24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusPartialFail24(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$5 || (_path244$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1407 23.7642l1.5315 1.2851a13.976 13.976 0 002.4408-4.1821l-1.8776-.6836A11.9729 11.9729 0 0125.1407 23.7642zM18 27.81l.4128 1.9677A13.8888 13.8888 0 0022.9543 28.14L22 26.4087A12.52 12.52 0 0118 27.81zM10 26.4087L9 28.14a14.14 14.14 0 004.5872 1.6382l.3469-1.9677A12.1519 12.1519 0 0110 26.4087zM4.7646 20.1836l-1.8776.6836a13.976 13.976 0 002.4408 4.1821l1.5315-1.2851A11.9729 11.9729 0 014.7646 20.1836zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22zM15 8H17V19H15z"
    })), _path245$5 || (_path245$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12,12,0,0,0,4,16H2a14,14,0,0,1,28,0Z"
    })), children);
  });
  var WatsonHealthStatusPartialFail20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusPartialFail20(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$5 || (_path246$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1407 23.7642l1.5315 1.2851a13.976 13.976 0 002.4408-4.1821l-1.8776-.6836A11.9729 11.9729 0 0125.1407 23.7642zM18 27.81l.4128 1.9677A13.8888 13.8888 0 0022.9543 28.14L22 26.4087A12.52 12.52 0 0118 27.81zM10 26.4087L9 28.14a14.14 14.14 0 004.5872 1.6382l.3469-1.9677A12.1519 12.1519 0 0110 26.4087zM4.7646 20.1836l-1.8776.6836a13.976 13.976 0 002.4408 4.1821l1.5315-1.2851A11.9729 11.9729 0 014.7646 20.1836zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22zM15 8H17V19H15z"
    })), _path247$5 || (_path247$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12,12,0,0,0,4,16H2a14,14,0,0,1,28,0Z"
    })), children);
  });
  var WatsonHealthStatusPartialFail16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusPartialFail16(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$5 || (_path248$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1407 23.7642l1.5315 1.2851a13.976 13.976 0 002.4408-4.1821l-1.8776-.6836A11.9729 11.9729 0 0125.1407 23.7642zM18 27.81l.4128 1.9677A13.8888 13.8888 0 0022.9543 28.14L22 26.4087A12.52 12.52 0 0118 27.81zM10 26.4087L9 28.14a14.14 14.14 0 004.5872 1.6382l.3469-1.9677A12.1519 12.1519 0 0110 26.4087zM4.7646 20.1836l-1.8776.6836a13.976 13.976 0 002.4408 4.1821l1.5315-1.2851A11.9729 11.9729 0 014.7646 20.1836zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22zM15 8H17V19H15z"
    })), _path249$5 || (_path249$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12,12,0,0,0,4,16H2a14,14,0,0,1,28,0Z"
    })), children);
  });
  var WatsonHealthStatusResolved32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusResolved32(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$5 || (_path250$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 28.414L16 23.413 17.413 22 21 25.586 28.585 18 30 19.415 21 28.414zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path251$5 || (_path251$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8193,25.8022a11.992,11.992,0,1,1,13.9829-9.6215l-1.9668-.3614A10.001,10.001,0,1,0,12.1807,23.835Z"
    })), children);
  });
  var WatsonHealthStatusResolved24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusResolved24(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$5 || (_path252$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 28.414L16 23.413 17.413 22 21 25.586 28.585 18 30 19.415 21 28.414zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path253$5 || (_path253$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8193,25.8022a11.992,11.992,0,1,1,13.9829-9.6215l-1.9668-.3614A10.001,10.001,0,1,0,12.1807,23.835Z"
    })), children);
  });
  var WatsonHealthStatusResolved20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusResolved20(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$5 || (_path254$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 28.414L16 23.413 17.413 22 21 25.586 28.585 18 30 19.415 21 28.414zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path255$5 || (_path255$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8193,25.8022a11.992,11.992,0,1,1,13.9829-9.6215l-1.9668-.3614A10.001,10.001,0,1,0,12.1807,23.835Z"
    })), children);
  });
  var WatsonHealthStatusResolved16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStatusResolved16(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$5 || (_path256$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 28.414L16 23.413 17.413 22 21 25.586 28.585 18 30 19.415 21 28.414zM12 15.59L9.41 13 8 14.41 12 18.41 19 11.41 17.59 10 12 15.59z"
    })), _path257$5 || (_path257$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.8193,25.8022a11.992,11.992,0,1,1,13.9829-9.6215l-1.9668-.3614A10.001,10.001,0,1,0,12.1807,23.835Z"
    })), children);
  });
  var StayInside32 = /*#__PURE__*/React__default['default'].forwardRef(function StayInside32(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$5 || (_path258$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11z"
    })), _path259$5 || (_path259$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H28V14.4639L16,4.31,4,14.4639V30H2V14a1,1,0,0,1,.354-.7634l13-11a1,1,0,0,1,1.292,0l13,11A1,1,0,0,1,30,14Z"
    })), children);
  });
  var StayInside24 = /*#__PURE__*/React__default['default'].forwardRef(function StayInside24(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$5 || (_path260$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11z"
    })), _path261$5 || (_path261$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H28V14.4639L16,4.31,4,14.4639V30H2V14a1,1,0,0,1,.354-.7634l13-11a1,1,0,0,1,1.292,0l13,11A1,1,0,0,1,30,14Z"
    })), children);
  });
  var StayInside20 = /*#__PURE__*/React__default['default'].forwardRef(function StayInside20(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$5 || (_path262$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11z"
    })), _path263$5 || (_path263$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H28V14.4639L16,4.31,4,14.4639V30H2V14a1,1,0,0,1,.354-.7634l13-11a1,1,0,0,1,1.292,0l13,11A1,1,0,0,1,30,14Z"
    })), children);
  });
  var StayInside16 = /*#__PURE__*/React__default['default'].forwardRef(function StayInside16(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$5 || (_path264$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 30H21V28a3.0033 3.0033 0 00-3-3H14a3.0033 3.0033 0 00-3 3v2H9V28a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM16 13a3 3 0 11-3 3 3 3 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 11z"
    })), _path265$5 || (_path265$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,30H28V14.4639L16,4.31,4,14.4639V30H2V14a1,1,0,0,1,.354-.7634l13-11a1,1,0,0,1,1.292,0l13,11A1,1,0,0,1,30,14Z"
    })), children);
  });
  var StemLeafPlot32 = /*#__PURE__*/React__default['default'].forwardRef(function StemLeafPlot32(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$5 || (_path266$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10a3 3 0 113-3A3.0033 3.0033 0 0119 10zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 6zM19 19a3 3 0 113-3A3.0033 3.0033 0 0119 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 15zM27 19a3 3 0 113-3A3.0033 3.0033 0 0127 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0027 15zM19 28a3 3 0 113-3A3.0033 3.0033 0 0119 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 24zM12 2H14V30H12zM7 28a3 3 0 113-3A3.0033 3.0033 0 017 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 24zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 15zM7 10a3 3 0 113-3A3.0033 3.0033 0 017 10zM7 6A1 1 0 108 7 1.0011 1.0011 0 007 6z"
    })), children);
  });
  var StemLeafPlot24 = /*#__PURE__*/React__default['default'].forwardRef(function StemLeafPlot24(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$5 || (_path267$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10a3 3 0 113-3A3.0033 3.0033 0 0119 10zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 6zM19 19a3 3 0 113-3A3.0033 3.0033 0 0119 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 15zM27 19a3 3 0 113-3A3.0033 3.0033 0 0127 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0027 15zM19 28a3 3 0 113-3A3.0033 3.0033 0 0119 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 24zM12 2H14V30H12zM7 28a3 3 0 113-3A3.0033 3.0033 0 017 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 24zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 15zM7 10a3 3 0 113-3A3.0033 3.0033 0 017 10zM7 6A1 1 0 108 7 1.0011 1.0011 0 007 6z"
    })), children);
  });
  var StemLeafPlot20 = /*#__PURE__*/React__default['default'].forwardRef(function StemLeafPlot20(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$5 || (_path268$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10a3 3 0 113-3A3.0033 3.0033 0 0119 10zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 6zM19 19a3 3 0 113-3A3.0033 3.0033 0 0119 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 15zM27 19a3 3 0 113-3A3.0033 3.0033 0 0127 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0027 15zM19 28a3 3 0 113-3A3.0033 3.0033 0 0119 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 24zM12 2H14V30H12zM7 28a3 3 0 113-3A3.0033 3.0033 0 017 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 24zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 15zM7 10a3 3 0 113-3A3.0033 3.0033 0 017 10zM7 6A1 1 0 108 7 1.0011 1.0011 0 007 6z"
    })), children);
  });
  var StemLeafPlot16 = /*#__PURE__*/React__default['default'].forwardRef(function StemLeafPlot16(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$5 || (_path269$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 10a3 3 0 113-3A3.0033 3.0033 0 0119 10zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 6zM19 19a3 3 0 113-3A3.0033 3.0033 0 0119 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 15zM27 19a3 3 0 113-3A3.0033 3.0033 0 0127 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 0027 15zM19 28a3 3 0 113-3A3.0033 3.0033 0 0119 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 0019 24zM12 2H14V30H12zM7 28a3 3 0 113-3A3.0033 3.0033 0 017 28zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 24zM7 19a3 3 0 113-3A3.0033 3.0033 0 017 19zm0-4a1 1 0 101 1A1.0011 1.0011 0 007 15zM7 10a3 3 0 113-3A3.0033 3.0033 0 017 10zM7 6A1 1 0 108 7 1.0011 1.0011 0 007 6z"
    })), children);
  });
  var Stethoscope32 = /*#__PURE__*/React__default['default'].forwardRef(function Stethoscope32(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$5 || (_path270$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2V4h2v6a4,4,0,0,1-8,0V4h2V2H16v8a6.0051,6.0051,0,0,0,5,5.91V22A6,6,0,0,1,9,22V15.8579a4,4,0,1,0-2,0V22a8,8,0,0,0,16,0V15.91A6.0051,6.0051,0,0,0,28,10V2ZM6,12a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,6,12Z"
    })), children);
  });
  var Stethoscope24 = /*#__PURE__*/React__default['default'].forwardRef(function Stethoscope24(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$5 || (_path271$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2V4h2v6a4,4,0,0,1-8,0V4h2V2H16v8a6.0051,6.0051,0,0,0,5,5.91V22A6,6,0,0,1,9,22V15.8579a4,4,0,1,0-2,0V22a8,8,0,0,0,16,0V15.91A6.0051,6.0051,0,0,0,28,10V2ZM6,12a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,6,12Z"
    })), children);
  });
  var Stethoscope20 = /*#__PURE__*/React__default['default'].forwardRef(function Stethoscope20(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$5 || (_path272$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2V4h2v6a4,4,0,0,1-8,0V4h2V2H16v8a6.0051,6.0051,0,0,0,5,5.91V22A6,6,0,0,1,9,22V15.8579a4,4,0,1,0-2,0V22a8,8,0,0,0,16,0V15.91A6.0051,6.0051,0,0,0,28,10V2ZM6,12a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,6,12Z"
    })), children);
  });
  var Stethoscope16 = /*#__PURE__*/React__default['default'].forwardRef(function Stethoscope16(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$5 || (_path273$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,2V4h2v6a4,4,0,0,1-8,0V4h2V2H16v8a6.0051,6.0051,0,0,0,5,5.91V22A6,6,0,0,1,9,22V15.8579a4,4,0,1,0-2,0V22a8,8,0,0,0,16,0V15.91A6.0051,6.0051,0,0,0,28,10V2ZM6,12a2,2,0,1,1,2,2A2.0023,2.0023,0,0,1,6,12Z"
    })), children);
  });
  var Stop32 = /*#__PURE__*/React__default['default'].forwardRef(function Stop32(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$5 || (_path274$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,8V24H8V8H24m0-2H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var Stop24 = /*#__PURE__*/React__default['default'].forwardRef(function Stop24(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$5 || (_path275$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,8V24H8V8H24m0-2H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var Stop20 = /*#__PURE__*/React__default['default'].forwardRef(function Stop20(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$5 || (_path276$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,8V24H8V8H24m0-2H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var Stop16 = /*#__PURE__*/React__default['default'].forwardRef(function Stop16(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$5 || (_path277$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4v8H4V4H12 M12,3H4C3.4,3,3,3.4,3,4v8c0,0.6,0.4,1,1,1h8c0.6,0,1-0.4,1-1V4C13,3.4,12.6,3,12,3z"
    })), children);
  });
  var StopFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilled32(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$5 || (_path278$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var StopFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilled24(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$5 || (_path279$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var StopFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilled20(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path280$5 || (_path280$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"
    })), children);
  });
  var StopFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilled16(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$5 || (_path281$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11,10c0,0.6-0.4,1-1,1H6c-0.6,0-1-0.4-1-1V6c0-0.6,0.4-1,1-1h4\tc0.6,0,1,0.4,1,1V10z"
    })), children);
  });
  var StopFilledAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilledAlt32(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$5 || (_path282$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopFilledAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilledAlt24(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$5 || (_path283$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopFilledAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilledAlt20(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$5 || (_path284$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopFilledAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function StopFilledAlt16(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$5 || (_path285$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopOutline32 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutline32(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$5 || (_path286$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path287$5 || (_path287$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12v8H12V12h8m0-2H12a2,2,0,0,0-2,2v8a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V12a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopOutline24 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutline24(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$5 || (_path288$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path289$5 || (_path289$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12v8H12V12h8m0-2H12a2,2,0,0,0-2,2v8a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V12a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopOutline20 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutline20(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$5 || (_path290$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"
    })), _path291$5 || (_path291$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,12v8H12V12h8m0-2H12a2,2,0,0,0-2,2v8a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V12a2,2,0,0,0-2-2Z"
    })), children);
  });
  var StopOutline16 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutline16(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$5 || (_path292$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"
    })), _path293$5 || (_path293$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,6v4H6V6H10 M10,5H6C5.4,5,5,5.4,5,6v4c0,0.6,0.4,1,1,1h4c0.6,0,1-0.4,1-1V6C11,5.4,10.6,5,10,5z"
    })), children);
  });
  var StopOutlineFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutlineFilled32(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$5 || (_path294$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"
    })), _path295$5 || (_path295$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V20H12z"
    })), children);
  });
  var StopOutlineFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutlineFilled24(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$5 || (_path296$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"
    })), _path297$5 || (_path297$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V20H12z"
    })), children);
  });
  var StopOutlineFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutlineFilled20(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$5 || (_path298$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"
    })), _path299$5 || (_path299$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H20V20H12z"
    })), children);
  });
  var StopOutlineFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function StopOutlineFilled16(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$5 || (_path300$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11,10c0,0.6-0.4,1-1,1H6c-0.6,0-1-0.4-1-1V6c0-0.6,0.4-1,1-1h4\tc0.6,0,1,0.4,1,1V10z"
    })), _path301$5 || (_path301$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H10V10H6z"
    })), children);
  });
  var StopSign32 = /*#__PURE__*/React__default['default'].forwardRef(function StopSign32(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$5 || (_path302$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29ZM11.4141,5,5,11.4141v9.1716L11.4141,27h9.1716L27,20.5859V11.4143L20.5859,5H11.4141Z"
    })), children);
  });
  var StopSign24 = /*#__PURE__*/React__default['default'].forwardRef(function StopSign24(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$5 || (_path303$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29ZM11.4141,5,5,11.4141v9.1716L11.4141,27h9.1716L27,20.5859V11.4143L20.5859,5H11.4141Z"
    })), children);
  });
  var StopSign20 = /*#__PURE__*/React__default['default'].forwardRef(function StopSign20(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$5 || (_path304$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29ZM11.4141,5,5,11.4141v9.1716L11.4141,27h9.1716L27,20.5859V11.4143L20.5859,5H11.4141Z"
    })), children);
  });
  var StopSign16 = /*#__PURE__*/React__default['default'].forwardRef(function StopSign16(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$5 || (_path305$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29ZM11.4141,5,5,11.4141v9.1716L11.4141,27h9.1716L27,20.5859V11.4143L20.5859,5H11.4141Z"
    })), children);
  });
  var StopSignFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function StopSignFilled32(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$5 || (_path306$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29Z"
    })), children);
  });
  var StopSignFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function StopSignFilled24(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$5 || (_path307$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29Z"
    })), children);
  });
  var StopSignFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function StopSignFilled20(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$5 || (_path308$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29Z"
    })), children);
  });
  var StopSignFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function StopSignFilled16(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$5 || (_path309$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5857,29H11.4143A1.9865,1.9865,0,0,1,10,28.4141L3.5859,22A1.9865,1.9865,0,0,1,3,20.5857V11.4143A1.9865,1.9865,0,0,1,3.5859,10L10,3.5859A1.9865,1.9865,0,0,1,11.4143,3h9.1714A1.9865,1.9865,0,0,1,22,3.5859L28.4141,10A1.9865,1.9865,0,0,1,29,11.4143v9.1714A1.9865,1.9865,0,0,1,28.4141,22L22,28.4141A1.9865,1.9865,0,0,1,20.5857,29Z"
    })), children);
  });
  var StoragePool32 = /*#__PURE__*/React__default['default'].forwardRef(function StoragePool32(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$5 || (_path310$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path311$5 || (_path311$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5 13A3.5 3.5 0 1121 9.5 3.5041 3.5041 0 0117.5 13zm0-5A1.5 1.5 0 1019 9.5 1.5017 1.5017 0 0017.5 8zM14.5 26A3.5 3.5 0 1118 22.5 3.5041 3.5041 0 0114.5 26zm0-5A1.5 1.5 0 1016 22.5 1.5017 1.5017 0 0014.5 21zM9.5 18A3.5 3.5 0 1113 14.5 3.5041 3.5041 0 019.5 18zm0-5A1.5 1.5 0 1011 14.5 1.5017 1.5017 0 009.5 13zM22.5 21A3.5 3.5 0 1126 17.5 3.5041 3.5041 0 0122.5 21zm0-5A1.5 1.5 0 1024 17.5 1.5017 1.5017 0 0022.5 16z"
    })), children);
  });
  var StoragePool24 = /*#__PURE__*/React__default['default'].forwardRef(function StoragePool24(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$5 || (_path312$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path313$5 || (_path313$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5 13A3.5 3.5 0 1121 9.5 3.5041 3.5041 0 0117.5 13zm0-5A1.5 1.5 0 1019 9.5 1.5017 1.5017 0 0017.5 8zM14.5 26A3.5 3.5 0 1118 22.5 3.5041 3.5041 0 0114.5 26zm0-5A1.5 1.5 0 1016 22.5 1.5017 1.5017 0 0014.5 21zM9.5 18A3.5 3.5 0 1113 14.5 3.5041 3.5041 0 019.5 18zm0-5A1.5 1.5 0 1011 14.5 1.5017 1.5017 0 009.5 13zM22.5 21A3.5 3.5 0 1126 17.5 3.5041 3.5041 0 0122.5 21zm0-5A1.5 1.5 0 1024 17.5 1.5017 1.5017 0 0022.5 16z"
    })), children);
  });
  var StoragePool20 = /*#__PURE__*/React__default['default'].forwardRef(function StoragePool20(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$5 || (_path314$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path315$5 || (_path315$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5 13A3.5 3.5 0 1121 9.5 3.5041 3.5041 0 0117.5 13zm0-5A1.5 1.5 0 1019 9.5 1.5017 1.5017 0 0017.5 8zM14.5 26A3.5 3.5 0 1118 22.5 3.5041 3.5041 0 0114.5 26zm0-5A1.5 1.5 0 1016 22.5 1.5017 1.5017 0 0014.5 21zM9.5 18A3.5 3.5 0 1113 14.5 3.5041 3.5041 0 019.5 18zm0-5A1.5 1.5 0 1011 14.5 1.5017 1.5017 0 009.5 13zM22.5 21A3.5 3.5 0 1126 17.5 3.5041 3.5041 0 0122.5 21zm0-5A1.5 1.5 0 1024 17.5 1.5017 1.5017 0 0022.5 16z"
    })), children);
  });
  var StoragePool16 = /*#__PURE__*/React__default['default'].forwardRef(function StoragePool16(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$5 || (_path316$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), _path317$5 || (_path317$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.5 13A3.5 3.5 0 1121 9.5 3.5041 3.5041 0 0117.5 13zm0-5A1.5 1.5 0 1019 9.5 1.5017 1.5017 0 0017.5 8zM14.5 26A3.5 3.5 0 1118 22.5 3.5041 3.5041 0 0114.5 26zm0-5A1.5 1.5 0 1016 22.5 1.5017 1.5017 0 0014.5 21zM9.5 18A3.5 3.5 0 1113 14.5 3.5041 3.5041 0 019.5 18zm0-5A1.5 1.5 0 1011 14.5 1.5017 1.5017 0 009.5 13zM22.5 21A3.5 3.5 0 1126 17.5 3.5041 3.5041 0 0122.5 21zm0-5A1.5 1.5 0 1024 17.5 1.5017 1.5017 0 0022.5 16z"
    })), children);
  });
  var StorageRequest32 = /*#__PURE__*/React__default['default'].forwardRef(function StorageRequest32(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$5 || (_path318$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 21H2v3a2.0059 2.0059 0 002 2H7V24H4zM4 8H7V6H4A2.0059 2.0059 0 002 8v3H4zM17 6H23V8H17zM9 6H15V8H9zM17 24H23V26H17zM28 15L4 15 4 13 2 13 2 19 4 19 4 17 28 17 28 19 30 19 30 13 28 13 28 15zM28 24H25v2h3a2.0059 2.0059 0 002-2V21H28zM28 6H25V8h3v3h2V8A2.0059 2.0059 0 0028 6zM9 24H15V26H9z"
    })), _circle65 || (_circle65 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "12",
      r: "1"
    })), _circle66 || (_circle66 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "1"
    })), children);
  });
  var StorageRequest24 = /*#__PURE__*/React__default['default'].forwardRef(function StorageRequest24(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$5 || (_path319$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 21H2v3a2.0059 2.0059 0 002 2H7V24H4zM4 8H7V6H4A2.0059 2.0059 0 002 8v3H4zM17 6H23V8H17zM9 6H15V8H9zM17 24H23V26H17zM28 15L4 15 4 13 2 13 2 19 4 19 4 17 28 17 28 19 30 19 30 13 28 13 28 15zM28 24H25v2h3a2.0059 2.0059 0 002-2V21H28zM28 6H25V8h3v3h2V8A2.0059 2.0059 0 0028 6zM9 24H15V26H9z"
    })), _circle67 || (_circle67 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "12",
      r: "1"
    })), _circle68 || (_circle68 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "1"
    })), children);
  });
  var StorageRequest20 = /*#__PURE__*/React__default['default'].forwardRef(function StorageRequest20(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$5 || (_path320$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 21H2v3a2.0059 2.0059 0 002 2H7V24H4zM4 8H7V6H4A2.0059 2.0059 0 002 8v3H4zM17 6H23V8H17zM9 6H15V8H9zM17 24H23V26H17zM28 15L4 15 4 13 2 13 2 19 4 19 4 17 28 17 28 19 30 19 30 13 28 13 28 15zM28 24H25v2h3a2.0059 2.0059 0 002-2V21H28zM28 6H25V8h3v3h2V8A2.0059 2.0059 0 0028 6zM9 24H15V26H9z"
    })), _circle69 || (_circle69 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "12",
      r: "1"
    })), _circle70 || (_circle70 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "1"
    })), children);
  });
  var StorageRequest16 = /*#__PURE__*/React__default['default'].forwardRef(function StorageRequest16(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$5 || (_path321$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 21H2v3a2.0059 2.0059 0 002 2H7V24H4zM4 8H7V6H4A2.0059 2.0059 0 002 8v3H4zM17 6H23V8H17zM9 6H15V8H9zM17 24H23V26H17zM28 15L4 15 4 13 2 13 2 19 4 19 4 17 28 17 28 19 30 19 30 13 28 13 28 15zM28 24H25v2h3a2.0059 2.0059 0 002-2V21H28zM28 6H25V8h3v3h2V8A2.0059 2.0059 0 0028 6zM9 24H15V26H9z"
    })), _circle71 || (_circle71 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "12",
      r: "1"
    })), _circle72 || (_circle72 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "7",
      cy: "20",
      r: "1"
    })), children);
  });
  var Store32 = /*#__PURE__*/React__default['default'].forwardRef(function Store32(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$5 || (_path322$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"
    })), children);
  });
  var Store24 = /*#__PURE__*/React__default['default'].forwardRef(function Store24(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$5 || (_path323$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"
    })), children);
  });
  var Store20 = /*#__PURE__*/React__default['default'].forwardRef(function Store20(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$5 || (_path324$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"
    })), children);
  });
  var Store16 = /*#__PURE__*/React__default['default'].forwardRef(function Store16(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$5 || (_path325$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"
    })), children);
  });
  var StormTracker32 = /*#__PURE__*/React__default['default'].forwardRef(function StormTracker32(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$5 || (_path326$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-.9736.771l-1.7229,7.3223a10.0653,10.0653,0,1,0,8.6032,8.603l7.3223-1.7227A1,1,0,0,0,30,16,14.0158,14.0158,0,0,0,16,2ZM11.293,20.707A1,1,0,0,0,12,21a1.013,1.013,0,0,0,.229-.0264l3.7622-.8852a3.996,3.996,0,1,1-4.08-4.08l-.8852,3.7622A1,1,0,0,0,11.293,20.707Zm2.05-2.0508,2.271-9.65a7.5018,7.5018,0,0,1,7.38,7.38ZM20,20a8,8,0,1,1-8-8,8.1017,8.1017,0,0,1,.8438.0469L12.38,14.019C12.2532,14.0107,12.127,14,12,14a6,6,0,1,0,6,6c0-.127-.011-.2534-.019-.38l1.9721-.4643A8.1048,8.1048,0,0,1,20,20Zm4.9707-4.0791a9.4981,9.4981,0,0,0-8.8914-8.8916l.7068-3.0039A12.0193,12.0193,0,0,1,27.9746,15.2139Z"
    })), children);
  });
  var StormTracker24 = /*#__PURE__*/React__default['default'].forwardRef(function StormTracker24(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$5 || (_path327$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-.9736.771l-1.7229,7.3223a10.0653,10.0653,0,1,0,8.6032,8.603l7.3223-1.7227A1,1,0,0,0,30,16,14.0158,14.0158,0,0,0,16,2ZM11.293,20.707A1,1,0,0,0,12,21a1.013,1.013,0,0,0,.229-.0264l3.7622-.8852a3.996,3.996,0,1,1-4.08-4.08l-.8852,3.7622A1,1,0,0,0,11.293,20.707Zm2.05-2.0508,2.271-9.65a7.5018,7.5018,0,0,1,7.38,7.38ZM20,20a8,8,0,1,1-8-8,8.1017,8.1017,0,0,1,.8438.0469L12.38,14.019C12.2532,14.0107,12.127,14,12,14a6,6,0,1,0,6,6c0-.127-.011-.2534-.019-.38l1.9721-.4643A8.1048,8.1048,0,0,1,20,20Zm4.9707-4.0791a9.4981,9.4981,0,0,0-8.8914-8.8916l.7068-3.0039A12.0193,12.0193,0,0,1,27.9746,15.2139Z"
    })), children);
  });
  var StormTracker20 = /*#__PURE__*/React__default['default'].forwardRef(function StormTracker20(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$5 || (_path328$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-.9736.771l-1.7229,7.3223a10.0653,10.0653,0,1,0,8.6032,8.603l7.3223-1.7227A1,1,0,0,0,30,16,14.0158,14.0158,0,0,0,16,2ZM11.293,20.707A1,1,0,0,0,12,21a1.013,1.013,0,0,0,.229-.0264l3.7622-.8852a3.996,3.996,0,1,1-4.08-4.08l-.8852,3.7622A1,1,0,0,0,11.293,20.707Zm2.05-2.0508,2.271-9.65a7.5018,7.5018,0,0,1,7.38,7.38ZM20,20a8,8,0,1,1-8-8,8.1017,8.1017,0,0,1,.8438.0469L12.38,14.019C12.2532,14.0107,12.127,14,12,14a6,6,0,1,0,6,6c0-.127-.011-.2534-.019-.38l1.9721-.4643A8.1048,8.1048,0,0,1,20,20Zm4.9707-4.0791a9.4981,9.4981,0,0,0-8.8914-8.8916l.7068-3.0039A12.0193,12.0193,0,0,1,27.9746,15.2139Z"
    })), children);
  });
  var StormTracker16 = /*#__PURE__*/React__default['default'].forwardRef(function StormTracker16(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$5 || (_path329$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2a1,1,0,0,0-.9736.771l-1.7229,7.3223a10.0653,10.0653,0,1,0,8.6032,8.603l7.3223-1.7227A1,1,0,0,0,30,16,14.0158,14.0158,0,0,0,16,2ZM11.293,20.707A1,1,0,0,0,12,21a1.013,1.013,0,0,0,.229-.0264l3.7622-.8852a3.996,3.996,0,1,1-4.08-4.08l-.8852,3.7622A1,1,0,0,0,11.293,20.707Zm2.05-2.0508,2.271-9.65a7.5018,7.5018,0,0,1,7.38,7.38ZM20,20a8,8,0,1,1-8-8,8.1017,8.1017,0,0,1,.8438.0469L12.38,14.019C12.2532,14.0107,12.127,14,12,14a6,6,0,1,0,6,6c0-.127-.011-.2534-.019-.38l1.9721-.4643A8.1048,8.1048,0,0,1,20,20Zm4.9707-4.0791a9.4981,9.4981,0,0,0-8.8914-8.8916l.7068-3.0039A12.0193,12.0193,0,0,1,27.9746,15.2139Z"
    })), children);
  });
  var Strawberry32 = /*#__PURE__*/React__default['default'].forwardRef(function Strawberry32(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$5 || (_path330$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"
    })), _path331$5 || (_path331$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 28a5.169 5.169 0 01-.7441-.054A5.0935 5.0935 0 014 22.8669V11.1985a7.1615 7.1615 0 016.31-7.1653 6.9607 6.9607 0 014.4643 1.0706l7.9688 4.9807a6.98 6.98 0 01-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 019 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 006 11.1985V22.8669a3.0839 3.0839 0 002.5435 3.1 3.0266 3.0266 0 001.7622-.2649l10.8828-5.23a4.9807 4.9807 0 00.4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0011.002 6zM26 7H22a4.0045 4.0045 0 01-4-4V2h2V3a2.0021 2.0021 0 002 2h4z"
    })), children);
  });
  var Strawberry24 = /*#__PURE__*/React__default['default'].forwardRef(function Strawberry24(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$5 || (_path332$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"
    })), _path333$5 || (_path333$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 28a5.169 5.169 0 01-.7441-.054A5.0935 5.0935 0 014 22.8669V11.1985a7.1615 7.1615 0 016.31-7.1653 6.9607 6.9607 0 014.4643 1.0706l7.9688 4.9807a6.98 6.98 0 01-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 019 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 006 11.1985V22.8669a3.0839 3.0839 0 002.5435 3.1 3.0266 3.0266 0 001.7622-.2649l10.8828-5.23a4.9807 4.9807 0 00.4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0011.002 6zM26 7H22a4.0045 4.0045 0 01-4-4V2h2V3a2.0021 2.0021 0 002 2h4z"
    })), children);
  });
  var Strawberry20 = /*#__PURE__*/React__default['default'].forwardRef(function Strawberry20(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$5 || (_path334$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"
    })), _path335$5 || (_path335$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 28a5.169 5.169 0 01-.7441-.054A5.0935 5.0935 0 014 22.8669V11.1985a7.1615 7.1615 0 016.31-7.1653 6.9607 6.9607 0 014.4643 1.0706l7.9688 4.9807a6.98 6.98 0 01-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 019 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 006 11.1985V22.8669a3.0839 3.0839 0 002.5435 3.1 3.0266 3.0266 0 001.7622-.2649l10.8828-5.23a4.9807 4.9807 0 00.4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0011.002 6zM26 7H22a4.0045 4.0045 0 01-4-4V2h2V3a2.0021 2.0021 0 002 2h4z"
    })), children);
  });
  var Strawberry16 = /*#__PURE__*/React__default['default'].forwardRef(function Strawberry16(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$5 || (_path336$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"
    })), _path337$5 || (_path337$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 28a5.169 5.169 0 01-.7441-.054A5.0935 5.0935 0 014 22.8669V11.1985a7.1615 7.1615 0 016.31-7.1653 6.9607 6.9607 0 014.4643 1.0706l7.9688 4.9807a6.98 6.98 0 01-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 019 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 006 11.1985V22.8669a3.0839 3.0839 0 002.5435 3.1 3.0266 3.0266 0 001.7622-.2649l10.8828-5.23a4.9807 4.9807 0 00.4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0011.002 6zM26 7H22a4.0045 4.0045 0 01-4-4V2h2V3a2.0021 2.0021 0 002 2h4z"
    })), children);
  });
  var WatsonHealthStressBreathEditor32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStressBreathEditor32(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$5 || (_path338$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7zM11 8H5A3 3 0 012 5V3H4V5A1 1 0 005 6h6zM4 15H2V13a3 3 0 013-3h6v2H5a1 1 0 00-1 1z"
    })), children);
  });
  var WatsonHealthStressBreathEditor24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStressBreathEditor24(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$5 || (_path339$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7zM11 8H5A3 3 0 012 5V3H4V5A1 1 0 005 6h6zM4 15H2V13a3 3 0 013-3h6v2H5a1 1 0 00-1 1z"
    })), children);
  });
  var WatsonHealthStressBreathEditor20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStressBreathEditor20(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$5 || (_path340$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7zM11 8H5A3 3 0 012 5V3H4V5A1 1 0 005 6h6zM4 15H2V13a3 3 0 013-3h6v2H5a1 1 0 00-1 1z"
    })), children);
  });
  var WatsonHealthStressBreathEditor16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStressBreathEditor16(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$5 || (_path341$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7zM11 8H5A3 3 0 012 5V3H4V5A1 1 0 005 6h6zM4 15H2V13a3 3 0 013-3h6v2H5a1 1 0 00-1 1z"
    })), children);
  });
  var StringInteger32 = /*#__PURE__*/React__default['default'].forwardRef(function StringInteger32(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$5 || (_path342$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0026 12zM19 22H13V18a2.002 2.002 0 012-2h2V14H13V12h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H15v2h4zM8 20L8 12 6 12 6 13 4 13 4 15 6 15 6 20 4 20 4 22 10 22 10 20 8 20z"
    })), children);
  });
  var StringInteger24 = /*#__PURE__*/React__default['default'].forwardRef(function StringInteger24(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$5 || (_path343$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0026 12zM19 22H13V18a2.002 2.002 0 012-2h2V14H13V12h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H15v2h4zM8 20L8 12 6 12 6 13 4 13 4 15 6 15 6 20 4 20 4 22 10 22 10 20 8 20z"
    })), children);
  });
  var StringInteger20 = /*#__PURE__*/React__default['default'].forwardRef(function StringInteger20(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$5 || (_path344$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0026 12zM19 22H13V18a2.002 2.002 0 012-2h2V14H13V12h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H15v2h4zM8 20L8 12 6 12 6 13 4 13 4 15 6 15 6 20 4 20 4 22 10 22 10 20 8 20z"
    })), children);
  });
  var StringInteger16 = /*#__PURE__*/React__default['default'].forwardRef(function StringInteger16(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$5 || (_path345$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 12H22v2h4v2H23v2h3v2H22v2h4a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0026 12zM19 22H13V18a2.002 2.002 0 012-2h2V14H13V12h4a2.0023 2.0023 0 012 2v2a2.0023 2.0023 0 01-2 2H15v2h4zM8 20L8 12 6 12 6 13 4 13 4 15 6 15 6 20 4 20 4 22 10 22 10 20 8 20z"
    })), children);
  });
  var StringText32 = /*#__PURE__*/React__default['default'].forwardRef(function StringText32(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$5 || (_path346$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 22H24a2.0027 2.0027 0 01-2-2V14a2.0023 2.0023 0 012-2h5v2H24v6h5zM18 12H14V8H12V22h6a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0018 12zm-4 8V14h4v6zM8 12H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V14A2.0023 2.0023 0 008 12zm0 8H4V18H8z"
    })), children);
  });
  var StringText24 = /*#__PURE__*/React__default['default'].forwardRef(function StringText24(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$5 || (_path347$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 22H24a2.0027 2.0027 0 01-2-2V14a2.0023 2.0023 0 012-2h5v2H24v6h5zM18 12H14V8H12V22h6a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0018 12zm-4 8V14h4v6zM8 12H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V14A2.0023 2.0023 0 008 12zm0 8H4V18H8z"
    })), children);
  });
  var StringText20 = /*#__PURE__*/React__default['default'].forwardRef(function StringText20(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$5 || (_path348$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 22H24a2.0027 2.0027 0 01-2-2V14a2.0023 2.0023 0 012-2h5v2H24v6h5zM18 12H14V8H12V22h6a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0018 12zm-4 8V14h4v6zM8 12H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V14A2.0023 2.0023 0 008 12zm0 8H4V18H8z"
    })), children);
  });
  var StringText16 = /*#__PURE__*/React__default['default'].forwardRef(function StringText16(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$5 || (_path349$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 22H24a2.0027 2.0027 0 01-2-2V14a2.0023 2.0023 0 012-2h5v2H24v6h5zM18 12H14V8H12V22h6a2.0027 2.0027 0 002-2V14A2.0023 2.0023 0 0018 12zm-4 8V14h4v6zM8 12H3v2H8v2H4a2 2 0 00-2 2v2a2 2 0 002 2h6V14A2.0023 2.0023 0 008 12zm0 8H4V18H8z"
    })), children);
  });
  var WatsonHealthStudyNext32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyNext32(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$5 || (_path350$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyNext24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyNext24(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$5 || (_path351$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyNext20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyNext20(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$5 || (_path352$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyNext16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyNext16(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$5 || (_path353$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyPrevious32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyPrevious32(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$5 || (_path354$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyPrevious24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyPrevious24(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$5 || (_path355$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyPrevious20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyPrevious20(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$5 || (_path356$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyPrevious16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyPrevious16(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$5 || (_path357$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0020 2zM30 30H28V25a5 5 0 00-5-5H17a5 5 0 00-5 5v5H10V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var WatsonHealthStudyRead32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyRead32(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$5 || (_path358$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 29.414L16 24.413 17.413 23 21 26.586 28.585 19 30 20.415 21 29.414zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 15 22 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path359$5 || (_path359$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,24H4V4H24V16h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2h9Z"
    })), children);
  });
  var WatsonHealthStudyRead24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyRead24(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$5 || (_path360$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 29.414L16 24.413 17.413 23 21 26.586 28.585 19 30 20.415 21 29.414zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 15 22 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path361$5 || (_path361$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,24H4V4H24V16h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2h9Z"
    })), children);
  });
  var WatsonHealthStudyRead20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyRead20(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$5 || (_path362$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 29.414L16 24.413 17.413 23 21 26.586 28.585 19 30 20.415 21 29.414zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 15 22 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path363$5 || (_path363$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,24H4V4H24V16h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2h9Z"
    })), children);
  });
  var WatsonHealthStudyRead16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyRead16(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$5 || (_path364$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 29.414L16 24.413 17.413 23 21 26.586 28.585 19 30 20.415 21 29.414zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 15 22 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path365$5 || (_path365$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,24H4V4H24V16h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2h9Z"
    })), children);
  });
  var WatsonHealthStudySkip32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudySkip32(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$5 || (_path366$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"
    })), _path367$5 || (_path367$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12a3 3 0 11-3 3 2.95 2.95 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 10zM23 30H21V27a3 3 0 00-3-3H14a3 3 0 00-3 3v3H9V27a5 5 0 015-5h4a5 5 0 015 5z"
    })), children);
  });
  var WatsonHealthStudySkip24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudySkip24(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$5 || (_path368$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"
    })), _path369$5 || (_path369$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12a3 3 0 11-3 3 2.95 2.95 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 10zM23 30H21V27a3 3 0 00-3-3H14a3 3 0 00-3 3v3H9V27a5 5 0 015-5h4a5 5 0 015 5z"
    })), children);
  });
  var WatsonHealthStudySkip20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudySkip20(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$5 || (_path370$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"
    })), _path371$5 || (_path371$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12a3 3 0 11-3 3 2.95 2.95 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 10zM23 30H21V27a3 3 0 00-3-3H14a3 3 0 00-3 3v3H9V27a5 5 0 015-5h4a5 5 0 015 5z"
    })), children);
  });
  var WatsonHealthStudySkip16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudySkip16(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$5 || (_path372$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"
    })), _path373$5 || (_path373$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 12a3 3 0 11-3 3 2.95 2.95 0 013-3m0-2a5 5 0 105 5A5 5 0 0016 10zM23 30H21V27a3 3 0 00-3-3H14a3 3 0 00-3 3v3H9V27a5 5 0 015-5h4a5 5 0 015 5z"
    })), children);
  });
  var WatsonHealthStudyTransfer32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyTransfer32(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$5 || (_path374$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 19.414L13.165 24 8.586 28.586 10 30 16 24 10 18 8.586 19.414z"
    })), _path375$5 || (_path375$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 19.414L7.165 24 2.586 28.586 4 30 10 24 4 18 2.586 19.414zM12 14L12 12 17 12 17 10 14 10 14 8 17 8 17 6 19 6 19 8 22 8 22 10 19 10 19 12 24 12 24 14 19 14 19 16 24 16 24 18 19 18 19 20 22 20 22 22 17 22 17 18 14 18 14 16 17 16 17 14 12 14z"
    })), _path376$5 || (_path376$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24h9V4H8V16H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V24a2,2,0,0,1-2,2H19Z"
    })), children);
  });
  var WatsonHealthStudyTransfer24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyTransfer24(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$5 || (_path377$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 19.414L13.165 24 8.586 28.586 10 30 16 24 10 18 8.586 19.414z"
    })), _path378$5 || (_path378$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 19.414L7.165 24 2.586 28.586 4 30 10 24 4 18 2.586 19.414zM12 14L12 12 17 12 17 10 14 10 14 8 17 8 17 6 19 6 19 8 22 8 22 10 19 10 19 12 24 12 24 14 19 14 19 16 24 16 24 18 19 18 19 20 22 20 22 22 17 22 17 18 14 18 14 16 17 16 17 14 12 14z"
    })), _path379$5 || (_path379$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24h9V4H8V16H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V24a2,2,0,0,1-2,2H19Z"
    })), children);
  });
  var WatsonHealthStudyTransfer20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyTransfer20(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$5 || (_path380$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 19.414L13.165 24 8.586 28.586 10 30 16 24 10 18 8.586 19.414z"
    })), _path381$5 || (_path381$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 19.414L7.165 24 2.586 28.586 4 30 10 24 4 18 2.586 19.414zM12 14L12 12 17 12 17 10 14 10 14 8 17 8 17 6 19 6 19 8 22 8 22 10 19 10 19 12 24 12 24 14 19 14 19 16 24 16 24 18 19 18 19 20 22 20 22 22 17 22 17 18 14 18 14 16 17 16 17 14 12 14z"
    })), _path382$5 || (_path382$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24h9V4H8V16H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V24a2,2,0,0,1-2,2H19Z"
    })), children);
  });
  var WatsonHealthStudyTransfer16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyTransfer16(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$5 || (_path383$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 19.414L13.165 24 8.586 28.586 10 30 16 24 10 18 8.586 19.414z"
    })), _path384$4 || (_path384$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.586 19.414L7.165 24 2.586 28.586 4 30 10 24 4 18 2.586 19.414zM12 14L12 12 17 12 17 10 14 10 14 8 17 8 17 6 19 6 19 8 22 8 22 10 19 10 19 12 24 12 24 14 19 14 19 16 24 16 24 18 19 18 19 20 22 20 22 22 17 22 17 18 14 18 14 16 17 16 17 14 12 14z"
    })), _path385$4 || (_path385$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,24h9V4H8V16H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V24a2,2,0,0,1-2,2H19Z"
    })), children);
  });
  var WatsonHealthStudyUnread32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyUnread32(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$4 || (_path386$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 17 22 17 20 15 20 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path387$4 || (_path387$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,24H4V4H24V15h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H15Z"
    })), children);
  });
  var WatsonHealthStudyUnread24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyUnread24(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$4 || (_path388$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 17 22 17 20 15 20 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path389$4 || (_path389$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,24H4V4H24V15h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H15Z"
    })), children);
  });
  var WatsonHealthStudyUnread20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyUnread20(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path390$4 || (_path390$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 17 22 17 20 15 20 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path391$4 || (_path391$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,24H4V4H24V15h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H15Z"
    })), children);
  });
  var WatsonHealthStudyUnread16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyUnread16(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path392$4 || (_path392$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 30a6 6 0 116-6A6.0067 6.0067 0 0124 30zm0-10a4 4 0 104 4A4.0045 4.0045 0 0024 20zM20 14L20 12 15 12 15 10 18 10 18 8 15 8 15 6 13 6 13 8 10 8 10 10 13 10 13 12 8 12 8 14 13 14 13 16 8 16 8 18 13 18 13 20 10 20 10 22 17 22 17 20 15 20 15 18 18 18 18 16 15 16 15 14 20 14z"
    })), _path393$4 || (_path393$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,24H4V4H24V15h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H15Z"
    })), children);
  });
  var WatsonHealthStudyView32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyView32(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$4 || (_path394$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20H25V18h3V4H14V7H12V4a2.002 2.002 0 012-2H28a2.0023 2.0023 0 012 2V18A2.0027 2.0027 0 0128 20zM17 22L17 20 13 20 13 18 16 18 16 16 13 16 13 14 11 14 11 16 8 16 8 18 11 18 11 20 7 20 7 22 11 22 11 24 8 24 8 26 16 26 16 24 13 24 13 22 17 22z"
    })), _path395$4 || (_path395$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H4a2.0021,2.0021,0,0,1-2-2V12a2.0021,2.0021,0,0,1,2-2H20a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,20,30ZM4,12V28H20V12Z"
    })), children);
  });
  var WatsonHealthStudyView24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyView24(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$4 || (_path396$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20H25V18h3V4H14V7H12V4a2.002 2.002 0 012-2H28a2.0023 2.0023 0 012 2V18A2.0027 2.0027 0 0128 20zM17 22L17 20 13 20 13 18 16 18 16 16 13 16 13 14 11 14 11 16 8 16 8 18 11 18 11 20 7 20 7 22 11 22 11 24 8 24 8 26 16 26 16 24 13 24 13 22 17 22z"
    })), _path397$4 || (_path397$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H4a2.0021,2.0021,0,0,1-2-2V12a2.0021,2.0021,0,0,1,2-2H20a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,20,30ZM4,12V28H20V12Z"
    })), children);
  });
  var WatsonHealthStudyView20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyView20(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$4 || (_path398$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20H25V18h3V4H14V7H12V4a2.002 2.002 0 012-2H28a2.0023 2.0023 0 012 2V18A2.0027 2.0027 0 0128 20zM17 22L17 20 13 20 13 18 16 18 16 16 13 16 13 14 11 14 11 16 8 16 8 18 11 18 11 20 7 20 7 22 11 22 11 24 8 24 8 26 16 26 16 24 13 24 13 22 17 22z"
    })), _path399$3 || (_path399$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H4a2.0021,2.0021,0,0,1-2-2V12a2.0021,2.0021,0,0,1,2-2H20a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,20,30ZM4,12V28H20V12Z"
    })), children);
  });
  var WatsonHealthStudyView16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthStudyView16(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$3 || (_path400$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 20H25V18h3V4H14V7H12V4a2.002 2.002 0 012-2H28a2.0023 2.0023 0 012 2V18A2.0027 2.0027 0 0128 20zM17 22L17 20 13 20 13 18 16 18 16 16 13 16 13 14 11 14 11 16 8 16 8 18 11 18 11 20 7 20 7 22 11 22 11 24 8 24 8 26 16 26 16 24 13 24 13 22 17 22z"
    })), _path401$3 || (_path401$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,30H4a2.0021,2.0021,0,0,1-2-2V12a2.0021,2.0021,0,0,1,2-2H20a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,20,30ZM4,12V28H20V12Z"
    })), children);
  });
  var WatsonHealthSubVolume32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSubVolume32(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$3 || (_path402$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4741,19.12,23.6807,16l5.7934-3.12a1,1,0,0,0,0-1.7607l-13-7a.9982.9982,0,0,0-.9482,0l-13,7a1,1,0,0,0,0,1.7607L8.3193,16,2.5259,19.12a1,1,0,0,0,0,1.7607l13,7a.9995.9995,0,0,0,.9482,0l13-7a1,1,0,0,0,0-1.7607ZM16,6.1359,26.8906,12,16,17.8643,5.1094,12Zm0,19.7284L5.1094,20l5.3193-2.8642L15.5259,19.88a.9995.9995,0,0,0,.9482,0l5.0972-2.7446L26.8906,20Z"
    })), children);
  });

  var _path$5, _path2$5, _path3$5, _path4$5, _path5$5, _path6$5, _path7$5, _path8$5, _path9$5, _path10$5, _path11$5, _path12$5, _path13$5, _path14$5, _path15$5, _path16$5, _path17$5, _path18$5, _path19$5, _path20$5, _path21$5, _path22$5, _path23$5, _path24$5, _path25$5, _path26$5, _path27$5, _path28$5, _path29$5, _path30$5, _path31$5, _path32$5, _path33$5, _path34$5, _path35$5, _path36$5, _path37$5, _path38$5, _path39$5, _path40$5, _path41$5, _path42$5, _path43$5, _path44$5, _path45$5, _path46$5, _path47$5, _path48$5, _path49$5, _path50$5, _path51$5, _path52$5, _path53$5, _path54$5, _path55$5, _path56$5, _path57$5, _path58$5, _path59$5, _path60$5, _path61$5, _path62$5, _path63$5, _path64$5, _path65$5, _path66$5, _path67$5, _path68$5, _path69$5, _path70$5, _path71$5, _path72$5, _path73$5, _path74$5, _path75$5, _path76$5, _path77$5, _path78$5, _path79$5, _path80$5, _path81$5, _path82$5, _path83$5, _path84$5, _path85$5, _path86$5, _path87$5, _path88$5, _path89$5, _path90$5, _path91$5, _path92$5, _path93$5, _path94$5, _path95$5, _path96$5, _path97$5, _path98$5, _path99$5, _path100$5, _path101$5, _path102$5, _path103$5, _path104$5, _path105$5, _path106$5, _path107$5, _path108$5, _path109$5, _path110$5, _path111$5, _path112$5, _path113$5, _path114$5, _path115$5, _path116$5, _path117$5, _path118$5, _path119$5, _path120$5, _path121$5, _path122$5, _path123$5, _path124$5, _path125$5, _path126$5, _path127$5, _path128$5, _path129$5, _path130$5, _path131$5, _path132$5, _path133$5, _path134$5, _path135$5, _path136$5, _path137$5, _path138$5, _path139$5, _path140$5, _path141$5, _path142$5, _path143$5, _path144$5, _path145$5, _path146$5, _path147$5, _path148$5, _path149$5, _path150$5, _path151$5, _path152$5, _path153$5, _path154$5, _path155$5, _path156$5, _path157$5, _path158$5, _path159$5, _path160$5, _path161$5, _path162$5, _path163$5, _path164$5, _path165$5, _path166$5, _path167$5, _path168$5, _path169$5, _path170$5, _path171$5, _path172$5, _path173$5, _path174$5, _path175$5, _path176$5, _path177$4, _path178$4, _path179$4, _path180$4, _path181$4, _path182$4, _path183$4, _path184$4, _circle$4, _path185$4, _path186$4, _path187$4, _circle2$4, _path188$4, _path189$4, _path190$4, _circle3$4, _path191$4, _path192$4, _path193$4, _circle4$3, _path194$4, _path195$4, _path196$4, _path197$4, _path198$4, _path199$4, _path200$4, _path201$4, _path202$4, _path203$4, _path204$4, _path205$4, _path206$4, _path207$4, _path208$4, _path209$4, _path210$4, _path211$4, _path212$4, _path213$4, _path214$4, _path215$4, _path216$4, _path217$4, _path218$4, _path219$4, _path220$4, _path221$4, _path222$4, _path223$4, _path224$4, _path225$4, _path226$4, _path227$4, _path228$4, _path229$4, _path230$4, _path231$4, _path232$4, _path233$4, _path234$4, _path235$4, _path236$4, _path237$4, _path238$4, _path239$4, _path240$4, _path241$4, _path242$4, _path243$4, _path244$4, _path245$4, _path246$4, _path247$4, _path248$4, _path249$4, _path250$4, _path251$4, _path252$4, _path253$4, _path254$4, _path255$4, _path256$4, _path257$4, _path258$4, _path259$4, _path260$4, _path261$4, _path262$4, _path263$4, _path264$4, _path265$4, _path266$4, _path267$4, _path268$4, _path269$4, _path270$4, _path271$4, _path272$4, _path273$4, _path274$4, _path275$4, _circle5$2, _path276$4, _path277$4, _circle6$2, _path278$4, _path279$4, _circle7$2, _path280$4, _path281$4, _circle8$2, _path282$4, _path283$4, _path284$4, _path285$4, _path286$4, _path287$4, _path288$4, _path289$4, _path290$4, _path291$4, _path292$4, _path293$4, _path294$4, _path295$4, _path296$4, _path297$4, _path298$4, _path299$4, _path300$4, _path301$4, _path302$4, _path303$4, _path304$4, _path305$4, _path306$4, _path307$4, _path308$4, _path309$4, _path310$4, _path311$4, _path312$4, _path313$4, _path314$4, _path315$4, _path316$4, _path317$4, _path318$4, _path319$4, _path320$4, _path321$4, _path322$4, _path323$4, _path324$4, _path325$4, _path326$4, _path327$4, _path328$4, _path329$4, _path330$4, _path331$4, _path332$4, _path333$4, _path334$4, _path335$4, _path336$4, _path337$4, _path338$4, _path339$4, _path340$4, _path341$4, _path342$4, _path343$4, _path344$4, _path345$4, _path346$4, _path347$4, _circle9$2, _path348$4, _path349$4, _circle10$2, _path350$4, _path351$4, _circle11$2, _path352$4, _path353$4, _circle12$2, _path354$4, _path355$4, _path356$4, _path357$4, _path358$4, _path359$4, _path360$4, _path361$4, _path362$4, _path363$4, _path364$4, _path365$4, _path366$4, _path367$4, _path368$4, _path369$4, _path370$4, _path371$4, _path372$4, _path373$4, _path374$4, _path375$4, _path376$4, _path377$4, _path378$4, _path379$4, _path380$4, _path381$4, _path382$4, _path383$4, _path384$3, _path385$3, _path386$3, _path387$3, _circle13$2, _path388$3, _path389$3, _path390$3, _circle14$2, _path391$3, _path392$3, _path393$3, _circle15$2, _path394$3, _path395$3, _path396$3, _circle16$2, _path397$3, _path398$3, _path399$2, _path400$2, _path401$2, _path402$2, _path403$2, _path404$2, _path405$2, _path406$2, _path407$2, _path408$2, _path409$2, _path410$2, _path411$2, _path412$2, _circle17$2, _path413$2, _path414$2, _path415$2, _circle18$2, _path416$1, _path417$1, _path418$1, _circle19$2, _path419$1, _path420$1, _path421$1, _circle20$2, _path422$1, _path423$1, _path424$1, _path425$1, _path426$1, _path427$1, _path428$1, _circle21$2, _path429$1, _path430$1, _path431$1, _circle22$2, _path432$1, _path433$1, _path434$1, _circle23$2, _path435$1, _path436$1, _path437$1, _circle24$2, _path438$1, _path439$1, _path440$1, _path441$1, _path442$1, _path443$1, _path444$1, _path445$1, _path446$1, _path447$1, _path448$1, _path449$1, _path450$1, _path451$1, _path452$1, _path453$1, _path454$1, _path455$1, _path456$1, _path457$1, _path458$1, _path459$1, _path460$1, _path461$1, _path462$1, _path463$1, _path464$1, _path465$1, _path466$1, _path467$1, _path468$1, _path469$1, _path470$1, _path471$1, _path472$1, _path473$1, _path474$1, _path475$1, _path476$1, _path477$1, _path478$1, _path479$1, _path480$1, _path481$1, _path482$1, _path483$1, _path484$1, _path485$1, _path486$1, _path487$1, _path488$1, _path489$1, _path490$1, _path491$1, _path492$1, _path493$1, _path494$1, _path495$1, _path496$1, _path497$1, _path498$1, _path499$1, _path500$1, _path501$1, _path502$1, _path503$1, _path504$1, _path505$1, _path506$1, _path507$1, _rect, _path508$1, _path509$1, _rect2, _path510$1, _path511$1, _rect3, _path512$1, _path513$1, _rect4, _path514$1, _path515$1, _path516$1, _path517$1, _path518$1, _path519$1, _path520$1, _circle25$1, _circle26$1, _circle27$1, _path521$1, _path522$1, _circle28$1, _circle29$1, _circle30$1, _path523$1, _path524$1, _circle31$1, _circle32$1, _circle33$1, _path525$1;

  var _excluded$5 = ["children"],
      _excluded2$5 = ["children"],
      _excluded3$5 = ["children"],
      _excluded4$5 = ["children"],
      _excluded5$5 = ["children"],
      _excluded6$5 = ["children"],
      _excluded7$5 = ["children"],
      _excluded8$5 = ["children"],
      _excluded9$5 = ["children"],
      _excluded10$5 = ["children"],
      _excluded11$5 = ["children"],
      _excluded12$5 = ["children"],
      _excluded13$5 = ["children"],
      _excluded14$5 = ["children"],
      _excluded15$5 = ["children"],
      _excluded16$5 = ["children"],
      _excluded17$5 = ["children"],
      _excluded18$5 = ["children"],
      _excluded19$5 = ["children"],
      _excluded20$5 = ["children"],
      _excluded21$5 = ["children"],
      _excluded22$5 = ["children"],
      _excluded23$5 = ["children"],
      _excluded24$5 = ["children"],
      _excluded25$5 = ["children"],
      _excluded26$5 = ["children"],
      _excluded27$5 = ["children"],
      _excluded28$5 = ["children"],
      _excluded29$5 = ["children"],
      _excluded30$5 = ["children"],
      _excluded31$5 = ["children"],
      _excluded32$5 = ["children"],
      _excluded33$5 = ["children"],
      _excluded34$5 = ["children"],
      _excluded35$5 = ["children"],
      _excluded36$5 = ["children"],
      _excluded37$5 = ["children"],
      _excluded38$5 = ["children"],
      _excluded39$5 = ["children"],
      _excluded40$5 = ["children"],
      _excluded41$5 = ["children"],
      _excluded42$5 = ["children"],
      _excluded43$5 = ["children"],
      _excluded44$5 = ["children"],
      _excluded45$5 = ["children"],
      _excluded46$5 = ["children"],
      _excluded47$5 = ["children"],
      _excluded48$5 = ["children"],
      _excluded49$5 = ["children"],
      _excluded50$5 = ["children"],
      _excluded51$5 = ["children"],
      _excluded52$5 = ["children"],
      _excluded53$5 = ["children"],
      _excluded54$5 = ["children"],
      _excluded55$5 = ["children"],
      _excluded56$5 = ["children"],
      _excluded57$5 = ["children"],
      _excluded58$5 = ["children"],
      _excluded59$5 = ["children"],
      _excluded60$5 = ["children"],
      _excluded61$5 = ["children"],
      _excluded62$5 = ["children"],
      _excluded63$5 = ["children"],
      _excluded64$5 = ["children"],
      _excluded65$5 = ["children"],
      _excluded66$5 = ["children"],
      _excluded67$5 = ["children"],
      _excluded68$5 = ["children"],
      _excluded69$5 = ["children"],
      _excluded70$5 = ["children"],
      _excluded71$5 = ["children"],
      _excluded72$5 = ["children"],
      _excluded73$5 = ["children"],
      _excluded74$5 = ["children"],
      _excluded75$5 = ["children"],
      _excluded76$5 = ["children"],
      _excluded77$5 = ["children"],
      _excluded78$5 = ["children"],
      _excluded79$5 = ["children"],
      _excluded80$5 = ["children"],
      _excluded81$5 = ["children"],
      _excluded82$5 = ["children"],
      _excluded83$5 = ["children"],
      _excluded84$5 = ["children"],
      _excluded85$5 = ["children"],
      _excluded86$5 = ["children"],
      _excluded87$5 = ["children"],
      _excluded88$5 = ["children"],
      _excluded89$5 = ["children"],
      _excluded90$5 = ["children"],
      _excluded91$5 = ["children"],
      _excluded92$5 = ["children"],
      _excluded93$5 = ["children"],
      _excluded94$5 = ["children"],
      _excluded95$5 = ["children"],
      _excluded96$5 = ["children"],
      _excluded97$5 = ["children"],
      _excluded98$5 = ["children"],
      _excluded99$5 = ["children"],
      _excluded100$5 = ["children"],
      _excluded101$5 = ["children"],
      _excluded102$5 = ["children"],
      _excluded103$5 = ["children"],
      _excluded104$5 = ["children"],
      _excluded105$5 = ["children"],
      _excluded106$5 = ["children"],
      _excluded107$5 = ["children"],
      _excluded108$5 = ["children"],
      _excluded109$5 = ["children"],
      _excluded110$5 = ["children"],
      _excluded111$5 = ["children"],
      _excluded112$5 = ["children"],
      _excluded113$5 = ["children"],
      _excluded114$5 = ["children"],
      _excluded115$5 = ["children"],
      _excluded116$5 = ["children"],
      _excluded117$5 = ["children"],
      _excluded118$5 = ["children"],
      _excluded119$4 = ["children"],
      _excluded120$4 = ["children"],
      _excluded121$4 = ["children"],
      _excluded122$4 = ["children"],
      _excluded123$4 = ["children"],
      _excluded124$4 = ["children"],
      _excluded125$4 = ["children"],
      _excluded126$4 = ["children"],
      _excluded127$4 = ["children"],
      _excluded128$4 = ["children"],
      _excluded129$4 = ["children"],
      _excluded130$4 = ["children"],
      _excluded131$4 = ["children"],
      _excluded132$4 = ["children"],
      _excluded133$4 = ["children"],
      _excluded134$4 = ["children"],
      _excluded135$4 = ["children"],
      _excluded136$4 = ["children"],
      _excluded137$4 = ["children"],
      _excluded138$4 = ["children"],
      _excluded139$4 = ["children"],
      _excluded140$4 = ["children"],
      _excluded141$4 = ["children"],
      _excluded142$4 = ["children"],
      _excluded143$4 = ["children"],
      _excluded144$4 = ["children"],
      _excluded145$4 = ["children"],
      _excluded146$4 = ["children"],
      _excluded147$4 = ["children"],
      _excluded148$4 = ["children"],
      _excluded149$4 = ["children"],
      _excluded150$4 = ["children"],
      _excluded151$4 = ["children"],
      _excluded152$4 = ["children"],
      _excluded153$4 = ["children"],
      _excluded154$4 = ["children"],
      _excluded155$4 = ["children"],
      _excluded156$4 = ["children"],
      _excluded157$4 = ["children"],
      _excluded158$4 = ["children"],
      _excluded159$4 = ["children"],
      _excluded160$4 = ["children"],
      _excluded161$4 = ["children"],
      _excluded162$4 = ["children"],
      _excluded163$4 = ["children"],
      _excluded164$4 = ["children"],
      _excluded165$4 = ["children"],
      _excluded166$4 = ["children"],
      _excluded167$4 = ["children"],
      _excluded168$4 = ["children"],
      _excluded169$4 = ["children"],
      _excluded170$4 = ["children"],
      _excluded171$4 = ["children"],
      _excluded172$4 = ["children"],
      _excluded173$4 = ["children"],
      _excluded174$4 = ["children"],
      _excluded175$4 = ["children"],
      _excluded176$4 = ["children"],
      _excluded177$4 = ["children"],
      _excluded178$4 = ["children"],
      _excluded179$4 = ["children"],
      _excluded180$4 = ["children"],
      _excluded181$4 = ["children"],
      _excluded182$4 = ["children"],
      _excluded183$4 = ["children"],
      _excluded184$4 = ["children"],
      _excluded185$4 = ["children"],
      _excluded186$4 = ["children"],
      _excluded187$4 = ["children"],
      _excluded188$4 = ["children"],
      _excluded189$4 = ["children"],
      _excluded190$4 = ["children"],
      _excluded191$4 = ["children"],
      _excluded192$4 = ["children"],
      _excluded193$4 = ["children"],
      _excluded194$4 = ["children"],
      _excluded195$4 = ["children"],
      _excluded196$4 = ["children"],
      _excluded197$4 = ["children"],
      _excluded198$4 = ["children"],
      _excluded199$4 = ["children"],
      _excluded200$4 = ["children"],
      _excluded201$4 = ["children"],
      _excluded202$4 = ["children"],
      _excluded203$4 = ["children"],
      _excluded204$4 = ["children"],
      _excluded205$4 = ["children"],
      _excluded206$4 = ["children"],
      _excluded207$4 = ["children"],
      _excluded208$4 = ["children"],
      _excluded209$4 = ["children"],
      _excluded210$4 = ["children"],
      _excluded211$4 = ["children"],
      _excluded212$4 = ["children"],
      _excluded213$4 = ["children"],
      _excluded214$4 = ["children"],
      _excluded215$4 = ["children"],
      _excluded216$4 = ["children"],
      _excluded217$4 = ["children"],
      _excluded218$4 = ["children"],
      _excluded219$4 = ["children"],
      _excluded220$4 = ["children"],
      _excluded221$4 = ["children"],
      _excluded222$4 = ["children"],
      _excluded223$4 = ["children"],
      _excluded224$4 = ["children"],
      _excluded225$4 = ["children"],
      _excluded226$4 = ["children"],
      _excluded227$4 = ["children"],
      _excluded228$4 = ["children"],
      _excluded229$4 = ["children"],
      _excluded230$4 = ["children"],
      _excluded231$4 = ["children"],
      _excluded232$4 = ["children"],
      _excluded233$4 = ["children"],
      _excluded234$4 = ["children"],
      _excluded235$4 = ["children"],
      _excluded236$4 = ["children"],
      _excluded237$4 = ["children"],
      _excluded238$4 = ["children"],
      _excluded239$4 = ["children"],
      _excluded240$4 = ["children"],
      _excluded241$4 = ["children"],
      _excluded242$4 = ["children"],
      _excluded243$4 = ["children"],
      _excluded244$4 = ["children"],
      _excluded245$4 = ["children"],
      _excluded246$4 = ["children"],
      _excluded247$4 = ["children"],
      _excluded248$4 = ["children"],
      _excluded249$4 = ["children"],
      _excluded250$4 = ["children"];
  var didWarnAboutDeprecation = {};
  var WatsonHealthSubVolume24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSubVolume24(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$5 || (_path$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4741,19.12,23.6807,16l5.7934-3.12a1,1,0,0,0,0-1.7607l-13-7a.9982.9982,0,0,0-.9482,0l-13,7a1,1,0,0,0,0,1.7607L8.3193,16,2.5259,19.12a1,1,0,0,0,0,1.7607l13,7a.9995.9995,0,0,0,.9482,0l13-7a1,1,0,0,0,0-1.7607ZM16,6.1359,26.8906,12,16,17.8643,5.1094,12Zm0,19.7284L5.1094,20l5.3193-2.8642L15.5259,19.88a.9995.9995,0,0,0,.9482,0l5.0972-2.7446L26.8906,20Z"
    })), children);
  });
  var WatsonHealthSubVolume20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSubVolume20(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$5 || (_path2$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4741,19.12,23.6807,16l5.7934-3.12a1,1,0,0,0,0-1.7607l-13-7a.9982.9982,0,0,0-.9482,0l-13,7a1,1,0,0,0,0,1.7607L8.3193,16,2.5259,19.12a1,1,0,0,0,0,1.7607l13,7a.9995.9995,0,0,0,.9482,0l13-7a1,1,0,0,0,0-1.7607ZM16,6.1359,26.8906,12,16,17.8643,5.1094,12Zm0,19.7284L5.1094,20l5.3193-2.8642L15.5259,19.88a.9995.9995,0,0,0,.9482,0l5.0972-2.7446L26.8906,20Z"
    })), children);
  });
  var WatsonHealthSubVolume16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthSubVolume16(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$5 || (_path3$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4741,19.12,23.6807,16l5.7934-3.12a1,1,0,0,0,0-1.7607l-13-7a.9982.9982,0,0,0-.9482,0l-13,7a1,1,0,0,0,0,1.7607L8.3193,16,2.5259,19.12a1,1,0,0,0,0,1.7607l13,7a.9995.9995,0,0,0,.9482,0l13-7a1,1,0,0,0,0-1.7607ZM16,6.1359,26.8906,12,16,17.8643,5.1094,12Zm0,19.7284L5.1094,20l5.3193-2.8642L15.5259,19.88a.9995.9995,0,0,0,.9482,0l5.0972-2.7446L26.8906,20Z"
    })), children);
  });
  var Subflow32 = /*#__PURE__*/React__default['default'].forwardRef(function Subflow32(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$5 || (_path4$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12.0025,12.0025,0,0,0,22.4609,26.1143l1.0782,1.684A13.9511,13.9511,0,0,1,16,30Z"
    })), _path5$5 || (_path5$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,17l-1.4141,1.4141L26.1719,20H15.8157a2.9874,2.9874,0,0,0-.2742-.5762l4.481-5.601A2.9676,2.9676,0,0,0,21,14a3,3,0,1,0-2.8157-4H13.8157a2.982,2.982,0,0,0-5.6314,0H2v2H8.1843a2.982,2.982,0,0,0,5.6314,0h4.3686a2.9874,2.9874,0,0,0,.2742.5762l-4.481,5.601A2.9676,2.9676,0,0,0,13,18a3,3,0,1,0,2.8157,4H26.1719l-1.586,1.5859L26,25l4-4Zm-5-7a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,10ZM11,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,12Zm2,10a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,13,22Z"
    })), _path6$5 || (_path6$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12.0025,12.0025,0,0,0,9.5391,5.8857L8.4609,4.2017A14.0019,14.0019,0,0,1,30,16Z"
    })), children);
  });
  var Subflow24 = /*#__PURE__*/React__default['default'].forwardRef(function Subflow24(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$5 || (_path7$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12.0025,12.0025,0,0,0,22.4609,26.1143l1.0782,1.684A13.9511,13.9511,0,0,1,16,30Z"
    })), _path8$5 || (_path8$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,17l-1.4141,1.4141L26.1719,20H15.8157a2.9874,2.9874,0,0,0-.2742-.5762l4.481-5.601A2.9676,2.9676,0,0,0,21,14a3,3,0,1,0-2.8157-4H13.8157a2.982,2.982,0,0,0-5.6314,0H2v2H8.1843a2.982,2.982,0,0,0,5.6314,0h4.3686a2.9874,2.9874,0,0,0,.2742.5762l-4.481,5.601A2.9676,2.9676,0,0,0,13,18a3,3,0,1,0,2.8157,4H26.1719l-1.586,1.5859L26,25l4-4Zm-5-7a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,10ZM11,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,12Zm2,10a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,13,22Z"
    })), _path9$5 || (_path9$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12.0025,12.0025,0,0,0,9.5391,5.8857L8.4609,4.2017A14.0019,14.0019,0,0,1,30,16Z"
    })), children);
  });
  var Subflow20 = /*#__PURE__*/React__default['default'].forwardRef(function Subflow20(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$5 || (_path10$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12.0025,12.0025,0,0,0,22.4609,26.1143l1.0782,1.684A13.9511,13.9511,0,0,1,16,30Z"
    })), _path11$5 || (_path11$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,17l-1.4141,1.4141L26.1719,20H15.8157a2.9874,2.9874,0,0,0-.2742-.5762l4.481-5.601A2.9676,2.9676,0,0,0,21,14a3,3,0,1,0-2.8157-4H13.8157a2.982,2.982,0,0,0-5.6314,0H2v2H8.1843a2.982,2.982,0,0,0,5.6314,0h4.3686a2.9874,2.9874,0,0,0,.2742.5762l-4.481,5.601A2.9676,2.9676,0,0,0,13,18a3,3,0,1,0,2.8157,4H26.1719l-1.586,1.5859L26,25l4-4Zm-5-7a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,10ZM11,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,12Zm2,10a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,13,22Z"
    })), _path12$5 || (_path12$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12.0025,12.0025,0,0,0,9.5391,5.8857L8.4609,4.2017A14.0019,14.0019,0,0,1,30,16Z"
    })), children);
  });
  var Subflow16 = /*#__PURE__*/React__default['default'].forwardRef(function Subflow16(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$5 || (_path13$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14.0158,14.0158,0,0,1,2,16H4A12.0025,12.0025,0,0,0,22.4609,26.1143l1.0782,1.684A13.9511,13.9511,0,0,1,16,30Z"
    })), _path14$5 || (_path14$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,17l-1.4141,1.4141L26.1719,20H15.8157a2.9874,2.9874,0,0,0-.2742-.5762l4.481-5.601A2.9676,2.9676,0,0,0,21,14a3,3,0,1,0-2.8157-4H13.8157a2.982,2.982,0,0,0-5.6314,0H2v2H8.1843a2.982,2.982,0,0,0,5.6314,0h4.3686a2.9874,2.9874,0,0,0,.2742.5762l-4.481,5.601A2.9676,2.9676,0,0,0,13,18a3,3,0,1,0,2.8157,4H26.1719l-1.586,1.5859L26,25l4-4Zm-5-7a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,21,10ZM11,12a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,11,12Zm2,10a1,1,0,1,1,1-1A1.0009,1.0009,0,0,1,13,22Z"
    })), _path15$5 || (_path15$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16H28A12.0025,12.0025,0,0,0,9.5391,5.8857L8.4609,4.2017A14.0019,14.0019,0,0,1,30,16Z"
    })), children);
  });
  var SubflowLocal32 = /*#__PURE__*/React__default['default'].forwardRef(function SubflowLocal32(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$5 || (_path16$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.3472 29.9851a13.9282 13.9282 0 01-4.2051-.8516l.6943-1.8754a11.929 11.929 0 003.6026.729zm4.2651-.4558l-.5146-1.9326a11.915 11.915 0 003.3632-1.4827l1.0782 1.6846A13.915 13.915 0 0119.6123 29.5293zM7.395 27.0439a14.0632 14.0632 0 01-2.94-3.1218l1.6484-1.1333a12.0521 12.0521 0 002.522 2.6785zM2.5967 20.0544A14.0512 14.0512 0 012.0005 16H4a12.0412 12.0412 0 00.5117 3.4763zM26 17l-1.4141 1.4141L26.1719 20H15.8157a2.9874 2.9874 0 00-.2742-.5762l4.481-5.601A2.9676 2.9676 0 0021 14a3 3 0 10-2.8157-4H13.8157a2.982 2.982 0 00-5.6314 0H2v2H8.1843a2.982 2.982 0 005.6314 0h4.3686a2.9874 2.9874 0 00.2742.5762l-4.481 5.601A2.9676 2.9676 0 0013 18a3 3 0 102.8157 4H26.1719l-1.586 1.5859L26 25l4-4zm-5-7a1 1 0 11-1 1A1.0009 1.0009 0 0121 10zM11 12a1 1 0 111-1A1.0009 1.0009 0 0111 12zm2 10a1 1 0 111-1A1.0009 1.0009 0 0113 22zM28 16a12.0412 12.0412 0 00-.5117-3.4763l1.915-.5781A14.0551 14.0551 0 0130 16zM25.8965 9.2112a12.0521 12.0521 0 00-2.522-2.6785l1.23-1.5766a14.0632 14.0632 0 012.94 3.1218zM9.5391 5.886L8.4609 4.2014a13.915 13.915 0 013.9268-1.7307l.5146 1.9326A11.915 11.915 0 009.5391 5.886zM20.1636 4.7419a11.929 11.929 0 00-3.6026-.729l.0918-1.998a13.9282 13.9282 0 014.2051.8516z"
    })), children);
  });
  var SubflowLocal24 = /*#__PURE__*/React__default['default'].forwardRef(function SubflowLocal24(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$5 || (_path17$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.3472 29.9851a13.9282 13.9282 0 01-4.2051-.8516l.6943-1.8754a11.929 11.929 0 003.6026.729zm4.2651-.4558l-.5146-1.9326a11.915 11.915 0 003.3632-1.4827l1.0782 1.6846A13.915 13.915 0 0119.6123 29.5293zM7.395 27.0439a14.0632 14.0632 0 01-2.94-3.1218l1.6484-1.1333a12.0521 12.0521 0 002.522 2.6785zM2.5967 20.0544A14.0512 14.0512 0 012.0005 16H4a12.0412 12.0412 0 00.5117 3.4763zM26 17l-1.4141 1.4141L26.1719 20H15.8157a2.9874 2.9874 0 00-.2742-.5762l4.481-5.601A2.9676 2.9676 0 0021 14a3 3 0 10-2.8157-4H13.8157a2.982 2.982 0 00-5.6314 0H2v2H8.1843a2.982 2.982 0 005.6314 0h4.3686a2.9874 2.9874 0 00.2742.5762l-4.481 5.601A2.9676 2.9676 0 0013 18a3 3 0 102.8157 4H26.1719l-1.586 1.5859L26 25l4-4zm-5-7a1 1 0 11-1 1A1.0009 1.0009 0 0121 10zM11 12a1 1 0 111-1A1.0009 1.0009 0 0111 12zm2 10a1 1 0 111-1A1.0009 1.0009 0 0113 22zM28 16a12.0412 12.0412 0 00-.5117-3.4763l1.915-.5781A14.0551 14.0551 0 0130 16zM25.8965 9.2112a12.0521 12.0521 0 00-2.522-2.6785l1.23-1.5766a14.0632 14.0632 0 012.94 3.1218zM9.5391 5.886L8.4609 4.2014a13.915 13.915 0 013.9268-1.7307l.5146 1.9326A11.915 11.915 0 009.5391 5.886zM20.1636 4.7419a11.929 11.929 0 00-3.6026-.729l.0918-1.998a13.9282 13.9282 0 014.2051.8516z"
    })), children);
  });
  var SubflowLocal20 = /*#__PURE__*/React__default['default'].forwardRef(function SubflowLocal20(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$5 || (_path18$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.3472 29.9851a13.9282 13.9282 0 01-4.2051-.8516l.6943-1.8754a11.929 11.929 0 003.6026.729zm4.2651-.4558l-.5146-1.9326a11.915 11.915 0 003.3632-1.4827l1.0782 1.6846A13.915 13.915 0 0119.6123 29.5293zM7.395 27.0439a14.0632 14.0632 0 01-2.94-3.1218l1.6484-1.1333a12.0521 12.0521 0 002.522 2.6785zM2.5967 20.0544A14.0512 14.0512 0 012.0005 16H4a12.0412 12.0412 0 00.5117 3.4763zM26 17l-1.4141 1.4141L26.1719 20H15.8157a2.9874 2.9874 0 00-.2742-.5762l4.481-5.601A2.9676 2.9676 0 0021 14a3 3 0 10-2.8157-4H13.8157a2.982 2.982 0 00-5.6314 0H2v2H8.1843a2.982 2.982 0 005.6314 0h4.3686a2.9874 2.9874 0 00.2742.5762l-4.481 5.601A2.9676 2.9676 0 0013 18a3 3 0 102.8157 4H26.1719l-1.586 1.5859L26 25l4-4zm-5-7a1 1 0 11-1 1A1.0009 1.0009 0 0121 10zM11 12a1 1 0 111-1A1.0009 1.0009 0 0111 12zm2 10a1 1 0 111-1A1.0009 1.0009 0 0113 22zM28 16a12.0412 12.0412 0 00-.5117-3.4763l1.915-.5781A14.0551 14.0551 0 0130 16zM25.8965 9.2112a12.0521 12.0521 0 00-2.522-2.6785l1.23-1.5766a14.0632 14.0632 0 012.94 3.1218zM9.5391 5.886L8.4609 4.2014a13.915 13.915 0 013.9268-1.7307l.5146 1.9326A11.915 11.915 0 009.5391 5.886zM20.1636 4.7419a11.929 11.929 0 00-3.6026-.729l.0918-1.998a13.9282 13.9282 0 014.2051.8516z"
    })), children);
  });
  var SubflowLocal16 = /*#__PURE__*/React__default['default'].forwardRef(function SubflowLocal16(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$5 || (_path19$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.3472 29.9851a13.9282 13.9282 0 01-4.2051-.8516l.6943-1.8754a11.929 11.929 0 003.6026.729zm4.2651-.4558l-.5146-1.9326a11.915 11.915 0 003.3632-1.4827l1.0782 1.6846A13.915 13.915 0 0119.6123 29.5293zM7.395 27.0439a14.0632 14.0632 0 01-2.94-3.1218l1.6484-1.1333a12.0521 12.0521 0 002.522 2.6785zM2.5967 20.0544A14.0512 14.0512 0 012.0005 16H4a12.0412 12.0412 0 00.5117 3.4763zM26 17l-1.4141 1.4141L26.1719 20H15.8157a2.9874 2.9874 0 00-.2742-.5762l4.481-5.601A2.9676 2.9676 0 0021 14a3 3 0 10-2.8157-4H13.8157a2.982 2.982 0 00-5.6314 0H2v2H8.1843a2.982 2.982 0 005.6314 0h4.3686a2.9874 2.9874 0 00.2742.5762l-4.481 5.601A2.9676 2.9676 0 0013 18a3 3 0 102.8157 4H26.1719l-1.586 1.5859L26 25l4-4zm-5-7a1 1 0 11-1 1A1.0009 1.0009 0 0121 10zM11 12a1 1 0 111-1A1.0009 1.0009 0 0111 12zm2 10a1 1 0 111-1A1.0009 1.0009 0 0113 22zM28 16a12.0412 12.0412 0 00-.5117-3.4763l1.915-.5781A14.0551 14.0551 0 0130 16zM25.8965 9.2112a12.0521 12.0521 0 00-2.522-2.6785l1.23-1.5766a14.0632 14.0632 0 012.94 3.1218zM9.5391 5.886L8.4609 4.2014a13.915 13.915 0 013.9268-1.7307l.5146 1.9326A11.915 11.915 0 009.5391 5.886zM20.1636 4.7419a11.929 11.929 0 00-3.6026-.729l.0918-1.998a13.9282 13.9282 0 014.2051.8516z"
    })), children);
  });
  var SubnetAclRules32 = /*#__PURE__*/React__default['default'].forwardRef(function SubnetAclRules32(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$5 || (_path20$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 14H30V16H18zM18 19H26V21H18zM18 9H30V11H18z"
    })), _path21$5 || (_path21$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24v4H6V16h8V14H10V8a4.0008,4.0008,0,0,1,7.6675-1.6L19.5005,5.6A6.001,6.001,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V24Z"
    })), children);
  });
  var SubnetAclRules24 = /*#__PURE__*/React__default['default'].forwardRef(function SubnetAclRules24(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$5 || (_path22$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 14H30V16H18zM18 19H26V21H18zM18 9H30V11H18z"
    })), _path23$5 || (_path23$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24v4H6V16h8V14H10V8a4.0008,4.0008,0,0,1,7.6675-1.6L19.5005,5.6A6.001,6.001,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V24Z"
    })), children);
  });
  var SubnetAclRules20 = /*#__PURE__*/React__default['default'].forwardRef(function SubnetAclRules20(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$5 || (_path24$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 14H30V16H18zM18 19H26V21H18zM18 9H30V11H18z"
    })), _path25$5 || (_path25$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24v4H6V16h8V14H10V8a4.0008,4.0008,0,0,1,7.6675-1.6L19.5005,5.6A6.001,6.001,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V24Z"
    })), children);
  });
  var SubnetAclRules16 = /*#__PURE__*/React__default['default'].forwardRef(function SubnetAclRules16(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$5 || (_path26$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 14H30V16H18zM18 19H26V21H18zM18 9H30V11H18z"
    })), _path27$5 || (_path27$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,24v4H6V16h8V14H10V8a4.0008,4.0008,0,0,1,7.6675-1.6L19.5005,5.6A6.001,6.001,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H22a2.0023,2.0023,0,0,0,2-2V24Z"
    })), children);
  });
  var Subtract32 = /*#__PURE__*/React__default['default'].forwardRef(function Subtract32(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$5 || (_path28$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var Subtract24 = /*#__PURE__*/React__default['default'].forwardRef(function Subtract24(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$5 || (_path29$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var Subtract20 = /*#__PURE__*/React__default['default'].forwardRef(function Subtract20(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$5 || (_path30$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var Subtract16 = /*#__PURE__*/React__default['default'].forwardRef(function Subtract16(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$5 || (_path31$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var SubtractAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function SubtractAlt32(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$5 || (_path32$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path33$5 || (_path33$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var SubtractAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function SubtractAlt24(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$5 || (_path34$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path35$5 || (_path35$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var SubtractAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function SubtractAlt20(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$5 || (_path36$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path37$5 || (_path37$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var SubtractAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function SubtractAlt16(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$5 || (_path38$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,4c6.6,0,12,5.4,12,12s-5.4,12-12,12S4,22.6,4,16S9.4,4,16,4 M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14\tS23.7,2,16,2z"
    })), _path39$5 || (_path39$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 15H24V17H8z"
    })), children);
  });
  var SummaryKpi32 = /*#__PURE__*/React__default['default'].forwardRef(function SummaryKpi32(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$5 || (_path40$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.6667 27.5027L2 22.4484l1.3311-1.4927 5.6411 5.0316 7.6906-7.4449a1.9282 1.9282 0 012.6736-.0084L22.96 21.9983l5.5791-5.9735L30 17.3905l-5.5812 5.9758a1.996 1.996 0 01-2.8379.08l-3.5765-3.4191-7.666 7.4206A1.9629 1.9629 0 017.6667 27.5027zM30 11L26 11 28 8 30 11zM22 4H18V6h4V8H19v2h3v2H18v2h4a2.0027 2.0027 0 002-2V6A2.0023 2.0023 0 0022 4zM16 14H10V10a2.002 2.002 0 012-2h2V6H10V4h4a2.0023 2.0023 0 012 2V8a2.0023 2.0023 0 01-2 2H12v2h4zM6 12L6 4 4 4 4 5 2 5 2 7 4 7 4 12 2 12 2 14 8 14 8 12 6 12z"
    })), children);
  });
  var SummaryKpi24 = /*#__PURE__*/React__default['default'].forwardRef(function SummaryKpi24(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$5 || (_path41$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.6667 27.5027L2 22.4484l1.3311-1.4927 5.6411 5.0316 7.6906-7.4449a1.9282 1.9282 0 012.6736-.0084L22.96 21.9983l5.5791-5.9735L30 17.3905l-5.5812 5.9758a1.996 1.996 0 01-2.8379.08l-3.5765-3.4191-7.666 7.4206A1.9629 1.9629 0 017.6667 27.5027zM30 11L26 11 28 8 30 11zM22 4H18V6h4V8H19v2h3v2H18v2h4a2.0027 2.0027 0 002-2V6A2.0023 2.0023 0 0022 4zM16 14H10V10a2.002 2.002 0 012-2h2V6H10V4h4a2.0023 2.0023 0 012 2V8a2.0023 2.0023 0 01-2 2H12v2h4zM6 12L6 4 4 4 4 5 2 5 2 7 4 7 4 12 2 12 2 14 8 14 8 12 6 12z"
    })), children);
  });
  var SummaryKpi20 = /*#__PURE__*/React__default['default'].forwardRef(function SummaryKpi20(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$5 || (_path42$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.6667 27.5027L2 22.4484l1.3311-1.4927 5.6411 5.0316 7.6906-7.4449a1.9282 1.9282 0 012.6736-.0084L22.96 21.9983l5.5791-5.9735L30 17.3905l-5.5812 5.9758a1.996 1.996 0 01-2.8379.08l-3.5765-3.4191-7.666 7.4206A1.9629 1.9629 0 017.6667 27.5027zM30 11L26 11 28 8 30 11zM22 4H18V6h4V8H19v2h3v2H18v2h4a2.0027 2.0027 0 002-2V6A2.0023 2.0023 0 0022 4zM16 14H10V10a2.002 2.002 0 012-2h2V6H10V4h4a2.0023 2.0023 0 012 2V8a2.0023 2.0023 0 01-2 2H12v2h4zM6 12L6 4 4 4 4 5 2 5 2 7 4 7 4 12 2 12 2 14 8 14 8 12 6 12z"
    })), children);
  });
  var SummaryKpi16 = /*#__PURE__*/React__default['default'].forwardRef(function SummaryKpi16(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$5 || (_path43$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.6667 27.5027L2 22.4484l1.3311-1.4927 5.6411 5.0316 7.6906-7.4449a1.9282 1.9282 0 012.6736-.0084L22.96 21.9983l5.5791-5.9735L30 17.3905l-5.5812 5.9758a1.996 1.996 0 01-2.8379.08l-3.5765-3.4191-7.666 7.4206A1.9629 1.9629 0 017.6667 27.5027zM30 11L26 11 28 8 30 11zM22 4H18V6h4V8H19v2h3v2H18v2h4a2.0027 2.0027 0 002-2V6A2.0023 2.0023 0 0022 4zM16 14H10V10a2.002 2.002 0 012-2h2V6H10V4h4a2.0023 2.0023 0 012 2V8a2.0023 2.0023 0 01-2 2H12v2h4zM6 12L6 4 4 4 4 5 2 5 2 7 4 7 4 12 2 12 2 14 8 14 8 12 6 12z"
    })), children);
  });
  var Sun32 = /*#__PURE__*/React__default['default'].forwardRef(function Sun32(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$5 || (_path44$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path45$5 || (_path45$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path46$5 || (_path46$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path47$5 || (_path47$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path48$5 || (_path48$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path49$5 || (_path49$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path50$5 || (_path50$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path51$5 || (_path51$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path52$5 || (_path52$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sun24 = /*#__PURE__*/React__default['default'].forwardRef(function Sun24(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$5 || (_path53$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path54$5 || (_path54$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path55$5 || (_path55$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path56$5 || (_path56$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path57$5 || (_path57$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path58$5 || (_path58$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path59$5 || (_path59$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path60$5 || (_path60$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path61$5 || (_path61$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sun20 = /*#__PURE__*/React__default['default'].forwardRef(function Sun20(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$5 || (_path62$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path63$5 || (_path63$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path64$5 || (_path64$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path65$5 || (_path65$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path66$5 || (_path66$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path67$5 || (_path67$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path68$5 || (_path68$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path69$5 || (_path69$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path70$5 || (_path70$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sun16 = /*#__PURE__*/React__default['default'].forwardRef(function Sun16(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$5 || (_path71$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path72$5 || (_path72$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path73$5 || (_path73$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path74$5 || (_path74$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path75$5 || (_path75$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path76$5 || (_path76$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path77$5 || (_path77$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path78$5 || (_path78$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path79$5 || (_path79$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sunny32 = /*#__PURE__*/React__default['default'].forwardRef(function Sunny32(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$5);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation['Sunny32']) {
        didWarnAboutDeprecation['Sunny32'] = true;
        console.warn("The Sunny32 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$5 || (_path80$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path81$5 || (_path81$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path82$5 || (_path82$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path83$5 || (_path83$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path84$5 || (_path84$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path85$5 || (_path85$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path86$5 || (_path86$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path87$5 || (_path87$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path88$5 || (_path88$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sunny24 = /*#__PURE__*/React__default['default'].forwardRef(function Sunny24(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$5);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation['Sunny24']) {
        didWarnAboutDeprecation['Sunny24'] = true;
        console.warn("The Sunny24 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$5 || (_path89$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path90$5 || (_path90$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path91$5 || (_path91$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path92$5 || (_path92$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path93$5 || (_path93$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path94$5 || (_path94$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path95$5 || (_path95$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path96$5 || (_path96$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path97$5 || (_path97$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sunny20 = /*#__PURE__*/React__default['default'].forwardRef(function Sunny20(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$5);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation['Sunny20']) {
        didWarnAboutDeprecation['Sunny20'] = true;
        console.warn("The Sunny20 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$5 || (_path98$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path99$5 || (_path99$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path100$5 || (_path100$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path101$5 || (_path101$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path102$5 || (_path102$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path103$5 || (_path103$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path104$5 || (_path104$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path105$5 || (_path105$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path106$5 || (_path106$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sunny16 = /*#__PURE__*/React__default['default'].forwardRef(function Sunny16(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$5);

    if (process.env.NODE_ENV !== "production") {
      if (!didWarnAboutDeprecation['Sunny16']) {
        didWarnAboutDeprecation['Sunny16'] = true;
        console.warn("The Sunny16 component has been deprecated and will be " + "removed in the next major version of @carbon/icons-react.");
      }
    }

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$5 || (_path107$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",
      transform: "translate(0 .005)"
    })), _path108$5 || (_path108$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.86 7.856)"
    })), _path109$5 || (_path109$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 15.005H7V17.005000000000003H2z"
    })), _path110$5 || (_path110$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.375 23.147H10.333V25.147H5.375z",
      transform: "rotate(-45 7.86 24.149)"
    })), _path111$5 || (_path111$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 25.005H17V30.005H15z"
    })), _path112$5 || (_path112$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.147 21.668H25.147V26.625999999999998H23.147z",
      transform: "rotate(-45 24.152 24.149)"
    })), _path113$5 || (_path113$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15.005H30V17.005000000000003H25z"
    })), _path114$5 || (_path114$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.152 7.856)"
    })), _path115$5 || (_path115$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2.005H17V7.005H15z"
    })), children);
  });
  var Sunrise32 = /*#__PURE__*/React__default['default'].forwardRef(function Sunrise32(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$5 || (_path116$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 014 4h2a6 6 0 00-12 0h2A4.0045 4.0045 0 0116 20zM25 22H30V24H25z"
    })), _path117$5 || (_path117$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.146 15.854)"
    })), _path118$5 || (_path118$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"
    })), _path119$5 || (_path119$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.854 15.854)"
    })), _path120$5 || (_path120$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H7V24H2z"
    })), children);
  });
  var Sunrise24 = /*#__PURE__*/React__default['default'].forwardRef(function Sunrise24(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$5 || (_path121$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 014 4h2a6 6 0 00-12 0h2A4.0045 4.0045 0 0116 20zM25 22H30V24H25z"
    })), _path122$5 || (_path122$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.146 15.854)"
    })), _path123$5 || (_path123$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"
    })), _path124$5 || (_path124$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.854 15.854)"
    })), _path125$5 || (_path125$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H7V24H2z"
    })), children);
  });
  var Sunrise20 = /*#__PURE__*/React__default['default'].forwardRef(function Sunrise20(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$5 || (_path126$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 014 4h2a6 6 0 00-12 0h2A4.0045 4.0045 0 0116 20zM25 22H30V24H25z"
    })), _path127$5 || (_path127$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.146 15.854)"
    })), _path128$5 || (_path128$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"
    })), _path129$5 || (_path129$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.854 15.854)"
    })), _path130$5 || (_path130$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H7V24H2z"
    })), children);
  });
  var Sunrise16 = /*#__PURE__*/React__default['default'].forwardRef(function Sunrise16(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$5 || (_path131$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 014 4h2a6 6 0 00-12 0h2A4.0045 4.0045 0 0116 20zM25 22H30V24H25z"
    })), _path132$5 || (_path132$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.146 15.854)"
    })), _path133$5 || (_path133$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"
    })), _path134$5 || (_path134$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.854 15.854)"
    })), _path135$5 || (_path135$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22H7V24H2z"
    })), children);
  });
  var Sunset32 = /*#__PURE__*/React__default['default'].forwardRef(function Sunset32(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$5 || (_path136$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27.005H29.998V29.005H2z"
    })), _path137$5 || (_path137$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",
      transform: "translate(0 .005)"
    })), _path138$5 || (_path138$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22.005H30V24.005H25z"
    })), _path139$5 || (_path139$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.152 15.856)"
    })), _path140$5 || (_path140$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"
    })), _path141$5 || (_path141$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.86 15.856)"
    })), _path142$5 || (_path142$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22.005H7V24.005H2z"
    })), children);
  });
  var Sunset24 = /*#__PURE__*/React__default['default'].forwardRef(function Sunset24(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$5 || (_path143$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27.005H29.998V29.005H2z"
    })), _path144$5 || (_path144$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",
      transform: "translate(0 .005)"
    })), _path145$5 || (_path145$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22.005H30V24.005H25z"
    })), _path146$5 || (_path146$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.152 15.856)"
    })), _path147$5 || (_path147$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"
    })), _path148$5 || (_path148$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.86 15.856)"
    })), _path149$5 || (_path149$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22.005H7V24.005H2z"
    })), children);
  });
  var Sunset20 = /*#__PURE__*/React__default['default'].forwardRef(function Sunset20(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$5 || (_path150$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27.005H29.998V29.005H2z"
    })), _path151$5 || (_path151$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",
      transform: "translate(0 .005)"
    })), _path152$5 || (_path152$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22.005H30V24.005H25z"
    })), _path153$5 || (_path153$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.152 15.856)"
    })), _path154$5 || (_path154$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"
    })), _path155$5 || (_path155$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.86 15.856)"
    })), _path156$5 || (_path156$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22.005H7V24.005H2z"
    })), children);
  });
  var Sunset16 = /*#__PURE__*/React__default['default'].forwardRef(function Sunset16(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$5 || (_path157$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 27.005H29.998V29.005H2z"
    })), _path158$5 || (_path158$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",
      transform: "translate(0 .005)"
    })), _path159$5 || (_path159$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 22.005H30V24.005H25z"
    })), _path160$5 || (_path160$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 14.854H26.625999999999998V16.854H21.668z",
      transform: "rotate(-45 24.152 15.856)"
    })), _path161$5 || (_path161$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"
    })), _path162$5 || (_path162$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 13.374H8.854V18.332H6.854z",
      transform: "rotate(-45 7.86 15.856)"
    })), _path163$5 || (_path163$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 22.005H7V24.005H2z"
    })), children);
  });
  var Svg32 = /*#__PURE__*/React__default['default'].forwardRef(function Svg32(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$5 || (_path164$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Svg24 = /*#__PURE__*/React__default['default'].forwardRef(function Svg24(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$5 || (_path165$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Svg20 = /*#__PURE__*/React__default['default'].forwardRef(function Svg20(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$5 || (_path166$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Svg16 = /*#__PURE__*/React__default['default'].forwardRef(function Svg16(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$5 || (_path167$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 23H24a2 2 0 01-2-2V11a2 2 0 012-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 01-2-2V11A2 2 0 014 9h6v2H4v4H8a2 2 0 012 2v4A2 2 0 018 23z"
    })), children);
  });
  var Swim32 = /*#__PURE__*/React__default['default'].forwardRef(function Swim32(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$5 || (_path168$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 26H2V24H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 24a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 24a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 24h2zM23 17.5859l-8.707-8.707A2.9791 2.9791 0 0012.1714 8H4v2h8.1714a.9933.9933 0 01.7075.293L15.5859 13 10 18.5859 11.4141 20 17 14.4141 21.5859 19zM20 10a4 4 0 114 4A4.0042 4.0042 0 0120 10zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 10z"
    })), children);
  });
  var Swim24 = /*#__PURE__*/React__default['default'].forwardRef(function Swim24(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$5 || (_path169$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 26H2V24H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 24a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 24a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 24h2zM23 17.5859l-8.707-8.707A2.9791 2.9791 0 0012.1714 8H4v2h8.1714a.9933.9933 0 01.7075.293L15.5859 13 10 18.5859 11.4141 20 17 14.4141 21.5859 19zM20 10a4 4 0 114 4A4.0042 4.0042 0 0120 10zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 10z"
    })), children);
  });
  var Swim20 = /*#__PURE__*/React__default['default'].forwardRef(function Swim20(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$5 || (_path170$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 26H2V24H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 24a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 24a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 24h2zM23 17.5859l-8.707-8.707A2.9791 2.9791 0 0012.1714 8H4v2h8.1714a.9933.9933 0 01.7075.293L15.5859 13 10 18.5859 11.4141 20 17 14.4141 21.5859 19zM20 10a4 4 0 114 4A4.0042 4.0042 0 0120 10zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 10z"
    })), children);
  });
  var Swim16 = /*#__PURE__*/React__default['default'].forwardRef(function Swim16(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$5 || (_path171$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 26H28a4.9316 4.9316 0 01-4-1.9873 5.0192 5.0192 0 01-8 0 5.0192 5.0192 0 01-8 0A4.9316 4.9316 0 014 26H2V24H4a3.44 3.44 0 003.0532-2.3215A.9712.9712 0 018 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0012 24a3.44 3.44 0 003.0532-2.3215A.99.99 0 0116 21a1.0069 1.0069 0 01.9487.6838A3.4381 3.4381 0 0020 24a3.44 3.44 0 003.0532-2.3215 1 1 0 011.8955.0053A3.4381 3.4381 0 0028 24h2zM23 17.5859l-8.707-8.707A2.9791 2.9791 0 0012.1714 8H4v2h8.1714a.9933.9933 0 01.7075.293L15.5859 13 10 18.5859 11.4141 20 17 14.4141 21.5859 19zM20 10a4 4 0 114 4A4.0042 4.0042 0 0120 10zm2 0a2 2 0 102-2A2.0023 2.0023 0 0022 10z"
    })), children);
  });
  var SwitchLayer_232 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_232(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$5 || (_path172$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26L16 24 5.83 24 8.41 21.41 7 20 2 25 7 30 8.41 28.59 5.83 26 16 26zM16 14L16 12 5.83 12 8.41 9.41 7 8 2 13 7 18 8.41 16.59 5.83 14 16 14zM16 6L16 8 26.17 8 23.59 10.59 25 12 30 7 25 2 23.59 3.41 26.17 6 16 6zM16 18L16 20 26.17 20 23.59 22.59 25 24 30 19 25 14 23.59 15.41 26.17 18 16 18z"
    })), children);
  });
  var SwitchLayer_224 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_224(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$5 || (_path173$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26L16 24 5.83 24 8.41 21.41 7 20 2 25 7 30 8.41 28.59 5.83 26 16 26zM16 14L16 12 5.83 12 8.41 9.41 7 8 2 13 7 18 8.41 16.59 5.83 14 16 14zM16 6L16 8 26.17 8 23.59 10.59 25 12 30 7 25 2 23.59 3.41 26.17 6 16 6zM16 18L16 20 26.17 20 23.59 22.59 25 24 30 19 25 14 23.59 15.41 26.17 18 16 18z"
    })), children);
  });
  var SwitchLayer_220 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_220(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$5 || (_path174$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26L16 24 5.83 24 8.41 21.41 7 20 2 25 7 30 8.41 28.59 5.83 26 16 26zM16 14L16 12 5.83 12 8.41 9.41 7 8 2 13 7 18 8.41 16.59 5.83 14 16 14zM16 6L16 8 26.17 8 23.59 10.59 25 12 30 7 25 2 23.59 3.41 26.17 6 16 6zM16 18L16 20 26.17 20 23.59 22.59 25 24 30 19 25 14 23.59 15.41 26.17 18 16 18z"
    })), children);
  });
  var SwitchLayer_216 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_216(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$5 || (_path175$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26L16 24 5.83 24 8.41 21.41 7 20 2 25 7 30 8.41 28.59 5.83 26 16 26zM16 14L16 12 5.83 12 8.41 9.41 7 8 2 13 7 18 8.41 16.59 5.83 14 16 14zM16 6L16 8 26.17 8 23.59 10.59 25 12 30 7 25 2 23.59 3.41 26.17 6 16 6zM16 18L16 20 26.17 20 23.59 22.59 25 24 30 19 25 14 23.59 15.41 26.17 18 16 18z"
    })), children);
  });
  var SwitchLayer_332 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_332(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$5 || (_path176$5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 24.586 6 19.586 11 21 12.414 26 7.414 26 10 28 10 28 4 22 4zM10 4L10 6 7.414 6 12.414 11 11 12.414 6 7.414 6 10 4 10 4 4 10 4zM20 5L16 1 12 5 13.414 6.414 15 4.829 15 11 17 11 17 4.829 18.586 6.414 20 5zM22 28L22 26 24.586 26 19.586 21 21 19.586 26 24.586 26 22 28 22 28 28 22 28zM10 28L10 26 7.414 26 12.414 21 11 19.586 6 24.586 6 22 4 22 4 28 10 28zM20 27L16 31 12 27 13.414 25.586 15 27.171 15 21 17 21 17 27.171 18.586 25.586 20 27zM5 12L1 16 5 20 6.414 18.586 4.829 17 11 17 11 15 4.829 15 6.414 13.414 5 12zM27 12L31 16 27 20 25.586 18.586 27.171 17 21 17 21 15 27.171 15 25.586 13.414 27 12z"
    })), children);
  });
  var SwitchLayer_324 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_324(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$4 || (_path177$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 24.586 6 19.586 11 21 12.414 26 7.414 26 10 28 10 28 4 22 4zM10 4L10 6 7.414 6 12.414 11 11 12.414 6 7.414 6 10 4 10 4 4 10 4zM20 5L16 1 12 5 13.414 6.414 15 4.829 15 11 17 11 17 4.829 18.586 6.414 20 5zM22 28L22 26 24.586 26 19.586 21 21 19.586 26 24.586 26 22 28 22 28 28 22 28zM10 28L10 26 7.414 26 12.414 21 11 19.586 6 24.586 6 22 4 22 4 28 10 28zM20 27L16 31 12 27 13.414 25.586 15 27.171 15 21 17 21 17 27.171 18.586 25.586 20 27zM5 12L1 16 5 20 6.414 18.586 4.829 17 11 17 11 15 4.829 15 6.414 13.414 5 12zM27 12L31 16 27 20 25.586 18.586 27.171 17 21 17 21 15 27.171 15 25.586 13.414 27 12z"
    })), children);
  });
  var SwitchLayer_320 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_320(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$4 || (_path178$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 24.586 6 19.586 11 21 12.414 26 7.414 26 10 28 10 28 4 22 4zM10 4L10 6 7.414 6 12.414 11 11 12.414 6 7.414 6 10 4 10 4 4 10 4zM20 5L16 1 12 5 13.414 6.414 15 4.829 15 11 17 11 17 4.829 18.586 6.414 20 5zM22 28L22 26 24.586 26 19.586 21 21 19.586 26 24.586 26 22 28 22 28 28 22 28zM10 28L10 26 7.414 26 12.414 21 11 19.586 6 24.586 6 22 4 22 4 28 10 28zM20 27L16 31 12 27 13.414 25.586 15 27.171 15 21 17 21 17 27.171 18.586 25.586 20 27zM5 12L1 16 5 20 6.414 18.586 4.829 17 11 17 11 15 4.829 15 6.414 13.414 5 12zM27 12L31 16 27 20 25.586 18.586 27.171 17 21 17 21 15 27.171 15 25.586 13.414 27 12z"
    })), children);
  });
  var SwitchLayer_316 = /*#__PURE__*/React__default['default'].forwardRef(function SwitchLayer_316(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$4 || (_path179$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 4L22 6 24.586 6 19.586 11 21 12.414 26 7.414 26 10 28 10 28 4 22 4zM10 4L10 6 7.414 6 12.414 11 11 12.414 6 7.414 6 10 4 10 4 4 10 4zM20 5L16 1 12 5 13.414 6.414 15 4.829 15 11 17 11 17 4.829 18.586 6.414 20 5zM22 28L22 26 24.586 26 19.586 21 21 19.586 26 24.586 26 22 28 22 28 28 22 28zM10 28L10 26 7.414 26 12.414 21 11 19.586 6 24.586 6 22 4 22 4 28 10 28zM20 27L16 31 12 27 13.414 25.586 15 27.171 15 21 17 21 17 27.171 18.586 25.586 20 27zM5 12L1 16 5 20 6.414 18.586 4.829 17 11 17 11 15 4.829 15 6.414 13.414 5 12zM27 12L31 16 27 20 25.586 18.586 27.171 17 21 17 21 15 27.171 15 25.586 13.414 27 12z"
    })), children);
  });
  var Switcher32 = /*#__PURE__*/React__default['default'].forwardRef(function Switcher32(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$4 || (_path180$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var Switcher24 = /*#__PURE__*/React__default['default'].forwardRef(function Switcher24(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$4 || (_path181$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var Switcher20 = /*#__PURE__*/React__default['default'].forwardRef(function Switcher20(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$4 || (_path182$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var Switcher16 = /*#__PURE__*/React__default['default'].forwardRef(function Switcher16(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$4 || (_path183$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H18V8H14zM4 4H8V8H4zM24 4H28V8H24zM14 14H18V18H14zM4 14H8V18H4zM24 14H28V18H24zM14 24H18V28H14zM4 24H8V28H4zM24 24H28V28H24z"
    })), children);
  });
  var SysProvision32 = /*#__PURE__*/React__default['default'].forwardRef(function SysProvision32(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$4 || (_path184$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20L21 30 30 25 21 20z"
    })), _circle$4 || (_circle$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path185$4 || (_path185$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,14,10Z"
    })), _path186$4 || (_path186$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9512,12.91l-.0064,0A12.05,12.05,0,1,0,17,25.605V23.5386a9.9813,9.9813,0,1,1,6.6235-6.81l1.9248.544A12.0341,12.0341,0,0,0,26,14Q26,13.4492,25.9512,12.91Z"
    })), children);
  });
  var SysProvision24 = /*#__PURE__*/React__default['default'].forwardRef(function SysProvision24(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$4 || (_path187$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20L21 30 30 25 21 20z"
    })), _circle2$4 || (_circle2$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path188$4 || (_path188$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,14,10Z"
    })), _path189$4 || (_path189$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9512,12.91l-.0064,0A12.05,12.05,0,1,0,17,25.605V23.5386a9.9813,9.9813,0,1,1,6.6235-6.81l1.9248.544A12.0341,12.0341,0,0,0,26,14Q26,13.4492,25.9512,12.91Z"
    })), children);
  });
  var SysProvision20 = /*#__PURE__*/React__default['default'].forwardRef(function SysProvision20(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$4 || (_path190$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20L21 30 30 25 21 20z"
    })), _circle3$4 || (_circle3$4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path191$4 || (_path191$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,14,10Z"
    })), _path192$4 || (_path192$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9512,12.91l-.0064,0A12.05,12.05,0,1,0,17,25.605V23.5386a9.9813,9.9813,0,1,1,6.6235-6.81l1.9248.544A12.0341,12.0341,0,0,0,26,14Q26,13.4492,25.9512,12.91Z"
    })), children);
  });
  var SysProvision16 = /*#__PURE__*/React__default['default'].forwardRef(function SysProvision16(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$4 || (_path193$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 20L21 30 30 25 21 20z"
    })), _circle4$3 || (_circle4$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "14",
      cy: "14",
      r: "2"
    })), _path194$4 || (_path194$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,20a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,14,10Z"
    })), _path195$4 || (_path195$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.9512,12.91l-.0064,0A12.05,12.05,0,1,0,17,25.605V23.5386a9.9813,9.9813,0,1,1,6.6235-6.81l1.9248.544A12.0341,12.0341,0,0,0,26,14Q26,13.4492,25.9512,12.91Z"
    })), children);
  });
  var QT32 = /*#__PURE__*/React__default['default'].forwardRef(function QT32(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$4 || (_path196$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var QT24 = /*#__PURE__*/React__default['default'].forwardRef(function QT24(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$4 || (_path197$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var QT20 = /*#__PURE__*/React__default['default'].forwardRef(function QT20(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$4 || (_path198$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var QT16 = /*#__PURE__*/React__default['default'].forwardRef(function QT16(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$4 || (_path199$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"
    })), children);
  });
  var QTAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function QTAlt32(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$4 || (_path200$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"
    })), children);
  });
  var QTAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function QTAlt24(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$4 || (_path201$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"
    })), children);
  });
  var QTAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function QTAlt20(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$4 || (_path202$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"
    })), children);
  });
  var QTAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function QTAlt16(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$4 || (_path203$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"
    })), children);
  });
  var Table32 = /*#__PURE__*/React__default['default'].forwardRef(function Table32(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$4 || (_path204$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"
    })), children);
  });
  var Table24 = /*#__PURE__*/React__default['default'].forwardRef(function Table24(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$4 || (_path205$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"
    })), children);
  });
  var Table20 = /*#__PURE__*/React__default['default'].forwardRef(function Table20(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$4 || (_path206$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"
    })), children);
  });
  var Table16 = /*#__PURE__*/React__default['default'].forwardRef(function Table16(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$4 || (_path207$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"
    })), children);
  });
  var TableAlias32 = /*#__PURE__*/React__default['default'].forwardRef(function TableAlias32(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path208$4 || (_path208$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29H5a2.0021,2.0021,0,0,1-2-2V20a2.0021,2.0021,0,0,1,2-2h7a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,12,29ZM5,20v7h7V20Z"
    })), _path209$4 || (_path209$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableAlias24 = /*#__PURE__*/React__default['default'].forwardRef(function TableAlias24(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$4 || (_path210$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29H5a2.0021,2.0021,0,0,1-2-2V20a2.0021,2.0021,0,0,1,2-2h7a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,12,29ZM5,20v7h7V20Z"
    })), _path211$4 || (_path211$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableAlias20 = /*#__PURE__*/React__default['default'].forwardRef(function TableAlias20(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212$4 || (_path212$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29H5a2.0021,2.0021,0,0,1-2-2V20a2.0021,2.0021,0,0,1,2-2h7a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,12,29ZM5,20v7h7V20Z"
    })), _path213$4 || (_path213$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableAlias16 = /*#__PURE__*/React__default['default'].forwardRef(function TableAlias16(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214$4 || (_path214$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,29H5a2.0021,2.0021,0,0,1-2-2V20a2.0021,2.0021,0,0,1,2-2h7a2.0021,2.0021,0,0,1,2,2v7A2.0021,2.0021,0,0,1,12,29ZM5,20v7h7V20Z"
    })), _path215$4 || (_path215$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableBuilt32 = /*#__PURE__*/React__default['default'].forwardRef(function TableBuilt32(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$4 || (_path216$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V22a2.0025,2.0025,0,0,0,2,2H8v4a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM22,22H14V17h8Zm0-7H14V10h8ZM12,15H4V10h8ZM22,4V8H4V4ZM4,22V17h8v5Zm24,6H10V24H22a2.0025,2.0025,0,0,0,2-2V10h4Z"
    })), children);
  });
  var TableBuilt24 = /*#__PURE__*/React__default['default'].forwardRef(function TableBuilt24(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$4 || (_path217$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V22a2.0025,2.0025,0,0,0,2,2H8v4a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM22,22H14V17h8Zm0-7H14V10h8ZM12,15H4V10h8ZM22,4V8H4V4ZM4,22V17h8v5Zm24,6H10V24H22a2.0025,2.0025,0,0,0,2-2V10h4Z"
    })), children);
  });
  var TableBuilt20 = /*#__PURE__*/React__default['default'].forwardRef(function TableBuilt20(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$4 || (_path218$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V22a2.0025,2.0025,0,0,0,2,2H8v4a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM22,22H14V17h8Zm0-7H14V10h8ZM12,15H4V10h8ZM22,4V8H4V4ZM4,22V17h8v5Zm24,6H10V24H22a2.0025,2.0025,0,0,0,2-2V10h4Z"
    })), children);
  });
  var TableBuilt16 = /*#__PURE__*/React__default['default'].forwardRef(function TableBuilt16(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$4 || (_path219$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H24V4a2.0025,2.0025,0,0,0-2-2H4A2.0025,2.0025,0,0,0,2,4V22a2.0025,2.0025,0,0,0,2,2H8v4a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V10A2.0025,2.0025,0,0,0,28,8ZM22,22H14V17h8Zm0-7H14V10h8ZM12,15H4V10h8ZM22,4V8H4V4ZM4,22V17h8v5Zm24,6H10V24H22a2.0025,2.0025,0,0,0,2-2V10h4Z"
    })), children);
  });
  var TableShortcut32 = /*#__PURE__*/React__default['default'].forwardRef(function TableShortcut32(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$4 || (_path220$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 18L5 20 10.586 20 3 27.586 4.414 29 12 21.414 12 27 14 27 14 18 5 18z"
    })), _path221$4 || (_path221$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableShortcut24 = /*#__PURE__*/React__default['default'].forwardRef(function TableShortcut24(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$4 || (_path222$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 18L5 20 10.586 20 3 27.586 4.414 29 12 21.414 12 27 14 27 14 18 5 18z"
    })), _path223$4 || (_path223$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableShortcut20 = /*#__PURE__*/React__default['default'].forwardRef(function TableShortcut20(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$4 || (_path224$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 18L5 20 10.586 20 3 27.586 4.414 29 12 21.414 12 27 14 27 14 18 5 18z"
    })), _path225$4 || (_path225$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableShortcut16 = /*#__PURE__*/React__default['default'].forwardRef(function TableShortcut16(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$4 || (_path226$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 18L5 20 10.586 20 3 27.586 4.414 29 12 21.414 12 27 14 27 14 18 5 18z"
    })), _path227$4 || (_path227$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V15H5V11H15v4h2V11H27v7H17v2H27v7H17v2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,6H5V5H27Z"
    })), children);
  });
  var TableSplit32 = /*#__PURE__*/React__default['default'].forwardRef(function TableSplit32(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$4 || (_path228$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"
    })), children);
  });
  var TableSplit24 = /*#__PURE__*/React__default['default'].forwardRef(function TableSplit24(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$4 || (_path229$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"
    })), children);
  });
  var TableSplit20 = /*#__PURE__*/React__default['default'].forwardRef(function TableSplit20(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$4 || (_path230$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"
    })), children);
  });
  var TableSplit16 = /*#__PURE__*/React__default['default'].forwardRef(function TableSplit16(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$4 || (_path231$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"
    })), children);
  });
  var TableOfContents32 = /*#__PURE__*/React__default['default'].forwardRef(function TableOfContents32(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$4 || (_path232$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"
    })), children);
  });
  var TableOfContents24 = /*#__PURE__*/React__default['default'].forwardRef(function TableOfContents24(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$4 || (_path233$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"
    })), children);
  });
  var TableOfContents20 = /*#__PURE__*/React__default['default'].forwardRef(function TableOfContents20(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$4 || (_path234$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"
    })), children);
  });
  var TableOfContents16 = /*#__PURE__*/React__default['default'].forwardRef(function TableOfContents16(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$4 || (_path235$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"
    })), children);
  });
  var Tablet32 = /*#__PURE__*/React__default['default'].forwardRef(function Tablet32(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$4 || (_path236$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 22H17V28H15z",
      transform: "rotate(90 16 25)"
    })), _path237$4 || (_path237$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"
    })), children);
  });
  var Tablet24 = /*#__PURE__*/React__default['default'].forwardRef(function Tablet24(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$4 || (_path238$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 22H17V28H15z",
      transform: "rotate(90 16 25)"
    })), _path239$4 || (_path239$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"
    })), children);
  });
  var Tablet20 = /*#__PURE__*/React__default['default'].forwardRef(function Tablet20(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$4 || (_path240$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 22H17V28H15z",
      transform: "rotate(90 16 25)"
    })), _path241$4 || (_path241$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"
    })), children);
  });
  var Tablet16 = /*#__PURE__*/React__default['default'].forwardRef(function Tablet16(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$4 || (_path242$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 22H17V28H15z",
      transform: "rotate(90 16 25)"
    })), _path243$4 || (_path243$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"
    })), children);
  });
  var TabletLandscape32 = /*#__PURE__*/React__default['default'].forwardRef(function TabletLandscape32(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$4 || (_path244$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H26V19H24z"
    })), _path245$4 || (_path245$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"
    })), children);
  });
  var TabletLandscape24 = /*#__PURE__*/React__default['default'].forwardRef(function TabletLandscape24(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$4 || (_path246$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H26V19H24z"
    })), _path247$4 || (_path247$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"
    })), children);
  });
  var TabletLandscape20 = /*#__PURE__*/React__default['default'].forwardRef(function TabletLandscape20(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$4 || (_path248$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H26V19H24z"
    })), _path249$4 || (_path249$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"
    })), children);
  });
  var TabletLandscape16 = /*#__PURE__*/React__default['default'].forwardRef(function TabletLandscape16(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$4 || (_path250$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 13H26V19H24z"
    })), _path251$4 || (_path251$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"
    })), children);
  });
  var Tag32 = /*#__PURE__*/React__default['default'].forwardRef(function Tag32(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$4 || (_path252$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,14a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,14Zm0-6a2,2,0,1,0,1.998,2.0044A2.002,2.002,0,0,0,10,8Z"
    })), _path253$4 || (_path253$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6436,29.4145,2.5858,15.3555A2,2,0,0,1,2,13.9414V4A2,2,0,0,1,4,2h9.9413a2,2,0,0,1,1.4142.5858L29.4144,16.6436a2.0005,2.0005,0,0,1,0,2.8285l-9.9424,9.9425a2.0008,2.0008,0,0,1-2.8285,0ZM4,4v9.9417L18.0578,28,28,18.0579,13.9416,4Z"
    })), children);
  });
  var Tag24 = /*#__PURE__*/React__default['default'].forwardRef(function Tag24(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$4 || (_path254$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,14a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,14Zm0-6a2,2,0,1,0,1.998,2.0044A2.002,2.002,0,0,0,10,8Z"
    })), _path255$4 || (_path255$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6436,29.4145,2.5858,15.3555A2,2,0,0,1,2,13.9414V4A2,2,0,0,1,4,2h9.9413a2,2,0,0,1,1.4142.5858L29.4144,16.6436a2.0005,2.0005,0,0,1,0,2.8285l-9.9424,9.9425a2.0008,2.0008,0,0,1-2.8285,0ZM4,4v9.9417L18.0578,28,28,18.0579,13.9416,4Z"
    })), children);
  });
  var Tag20 = /*#__PURE__*/React__default['default'].forwardRef(function Tag20(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$4 || (_path256$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,14a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,14Zm0-6a2,2,0,1,0,1.998,2.0044A2.002,2.002,0,0,0,10,8Z"
    })), _path257$4 || (_path257$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6436,29.4145,2.5858,15.3555A2,2,0,0,1,2,13.9414V4A2,2,0,0,1,4,2h9.9413a2,2,0,0,1,1.4142.5858L29.4144,16.6436a2.0005,2.0005,0,0,1,0,2.8285l-9.9424,9.9425a2.0008,2.0008,0,0,1-2.8285,0ZM4,4v9.9417L18.0578,28,28,18.0579,13.9416,4Z"
    })), children);
  });
  var Tag16 = /*#__PURE__*/React__default['default'].forwardRef(function Tag16(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$4 || (_path258$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,14a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,14Zm0-6a2,2,0,1,0,1.998,2.0044A2.002,2.002,0,0,0,10,8Z"
    })), _path259$4 || (_path259$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.6436,29.4145,2.5858,15.3555A2,2,0,0,1,2,13.9414V4A2,2,0,0,1,4,2h9.9413a2,2,0,0,1,1.4142.5858L29.4144,16.6436a2.0005,2.0005,0,0,1,0,2.8285l-9.9424,9.9425a2.0008,2.0008,0,0,1-2.8285,0ZM4,4v9.9417L18.0578,28,28,18.0579,13.9416,4Z"
    })), children);
  });
  var TagEdit32 = /*#__PURE__*/React__default['default'].forwardRef(function TagEdit32(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260$4 || (_path260$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 7.293l-3-3a.9994.9994 0 00-1.414 0L16 13.5859V18h4.4141L29.707 8.707A.9994.9994 0 0029.707 7.293zM19.5859 16H18V14.4141l5-5L24.5859 11zM26 9.5859L24.4141 8 26 6.4141 27.5859 8zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path261$4 || (_path261$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.0059,14.2354l-1.4141,1.414L28,18.0576,18.0579,28,4,13.9414V4h9.9417l4.4067,4.4067,1.4141-1.4145-4.407-4.4063A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l9.9424-9.9424a2.001,2.001,0,0,0,0-2.8286Z"
    })), children);
  });
  var TagEdit24 = /*#__PURE__*/React__default['default'].forwardRef(function TagEdit24(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$4 || (_path262$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 7.293l-3-3a.9994.9994 0 00-1.414 0L16 13.5859V18h4.4141L29.707 8.707A.9994.9994 0 0029.707 7.293zM19.5859 16H18V14.4141l5-5L24.5859 11zM26 9.5859L24.4141 8 26 6.4141 27.5859 8zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path263$4 || (_path263$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.0059,14.2354l-1.4141,1.414L28,18.0576,18.0579,28,4,13.9414V4h9.9417l4.4067,4.4067,1.4141-1.4145-4.407-4.4063A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l9.9424-9.9424a2.001,2.001,0,0,0,0-2.8286Z"
    })), children);
  });
  var TagEdit20 = /*#__PURE__*/React__default['default'].forwardRef(function TagEdit20(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264$4 || (_path264$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 7.293l-3-3a.9994.9994 0 00-1.414 0L16 13.5859V18h4.4141L29.707 8.707A.9994.9994 0 0029.707 7.293zM19.5859 16H18V14.4141l5-5L24.5859 11zM26 9.5859L24.4141 8 26 6.4141 27.5859 8zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path265$4 || (_path265$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.0059,14.2354l-1.4141,1.414L28,18.0576,18.0579,28,4,13.9414V4h9.9417l4.4067,4.4067,1.4141-1.4145-4.407-4.4063A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l9.9424-9.9424a2.001,2.001,0,0,0,0-2.8286Z"
    })), children);
  });
  var TagEdit16 = /*#__PURE__*/React__default['default'].forwardRef(function TagEdit16(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path266$4 || (_path266$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.707 7.293l-3-3a.9994.9994 0 00-1.414 0L16 13.5859V18h4.4141L29.707 8.707A.9994.9994 0 0029.707 7.293zM19.5859 16H18V14.4141l5-5L24.5859 11zM26 9.5859L24.4141 8 26 6.4141 27.5859 8zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path267$4 || (_path267$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.0059,14.2354l-1.4141,1.414L28,18.0576,18.0579,28,4,13.9414V4h9.9417l4.4067,4.4067,1.4141-1.4145-4.407-4.4063A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l9.9424-9.9424a2.001,2.001,0,0,0,0-2.8286Z"
    })), children);
  });
  var TagExport32 = /*#__PURE__*/React__default['default'].forwardRef(function TagExport32(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$4 || (_path268$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 18L25 12 23.586 13.414 27.172 17 17 17 17 19 27.172 19 23.586 22.586 25 24 31 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path269$4 || (_path269$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.0593,25l-3.0014,3L4,13.9414V4h9.9417l7,7,1.4143-1.414-7.001-7A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l3.0014-3Z"
    })), children);
  });
  var TagExport24 = /*#__PURE__*/React__default['default'].forwardRef(function TagExport24(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$4 || (_path270$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 18L25 12 23.586 13.414 27.172 17 17 17 17 19 27.172 19 23.586 22.586 25 24 31 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path271$4 || (_path271$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.0593,25l-3.0014,3L4,13.9414V4h9.9417l7,7,1.4143-1.414-7.001-7A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l3.0014-3Z"
    })), children);
  });
  var TagExport20 = /*#__PURE__*/React__default['default'].forwardRef(function TagExport20(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$4 || (_path272$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 18L25 12 23.586 13.414 27.172 17 17 17 17 19 27.172 19 23.586 22.586 25 24 31 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path273$4 || (_path273$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.0593,25l-3.0014,3L4,13.9414V4h9.9417l7,7,1.4143-1.414-7.001-7A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l3.0014-3Z"
    })), children);
  });
  var TagExport16 = /*#__PURE__*/React__default['default'].forwardRef(function TagExport16(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$4 || (_path274$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 18L25 12 23.586 13.414 27.172 17 17 17 17 19 27.172 19 23.586 22.586 25 24 31 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path275$4 || (_path275$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.0593,25l-3.0014,3L4,13.9414V4h9.9417l7,7,1.4143-1.414-7.001-7A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l3.0014-3Z"
    })), children);
  });
  var TagGroup32 = /*#__PURE__*/React__default['default'].forwardRef(function TagGroup32(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$2 || (_circle5$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _path276$4 || (_path276$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"
    })), _path277$4 || (_path277$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"
    })), children);
  });
  var TagGroup24 = /*#__PURE__*/React__default['default'].forwardRef(function TagGroup24(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$2 || (_circle6$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _path278$4 || (_path278$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"
    })), _path279$4 || (_path279$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"
    })), children);
  });
  var TagGroup20 = /*#__PURE__*/React__default['default'].forwardRef(function TagGroup20(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$2 || (_circle7$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _path280$4 || (_path280$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"
    })), _path281$4 || (_path281$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"
    })), children);
  });
  var TagGroup16 = /*#__PURE__*/React__default['default'].forwardRef(function TagGroup16(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$2 || (_circle8$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10",
      cy: "14",
      r: "2"
    })), _path282$4 || (_path282$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"
    })), _path283$4 || (_path283$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"
    })), children);
  });
  var TagImport32 = /*#__PURE__*/React__default['default'].forwardRef(function TagImport32(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$4 || (_path284$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L22 12 23.414 13.414 19.828 17 30 17 30 19 19.828 19 23.414 22.586 22 24 16 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path285$4 || (_path285$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0586,26l-2.0007,2L4,13.9414V4h9.9417l6,6,1.4143-1.414-6.001-6A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l2.0006-2.0007Z"
    })), children);
  });
  var TagImport24 = /*#__PURE__*/React__default['default'].forwardRef(function TagImport24(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path286$4 || (_path286$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L22 12 23.414 13.414 19.828 17 30 17 30 19 19.828 19 23.414 22.586 22 24 16 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path287$4 || (_path287$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0586,26l-2.0007,2L4,13.9414V4h9.9417l6,6,1.4143-1.414-6.001-6A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l2.0006-2.0007Z"
    })), children);
  });
  var TagImport20 = /*#__PURE__*/React__default['default'].forwardRef(function TagImport20(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$4 || (_path288$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L22 12 23.414 13.414 19.828 17 30 17 30 19 19.828 19 23.414 22.586 22 24 16 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path289$4 || (_path289$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0586,26l-2.0007,2L4,13.9414V4h9.9417l6,6,1.4143-1.414-6.001-6A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l2.0006-2.0007Z"
    })), children);
  });
  var TagImport16 = /*#__PURE__*/React__default['default'].forwardRef(function TagImport16(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$4 || (_path290$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 18L22 12 23.414 13.414 19.828 17 30 17 30 19 19.828 19 23.414 22.586 22 24 16 18zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path291$4 || (_path291$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0586,26l-2.0007,2L4,13.9414V4h9.9417l6,6,1.4143-1.414-6.001-6A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141L16.6436,29.4146a2.001,2.001,0,0,0,2.8286,0l2.0006-2.0007Z"
    })), children);
  });
  var TagNone32 = /*#__PURE__*/React__default['default'].forwardRef(function TagNone32(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path292$4 || (_path292$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.092 10.3218L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6.9077-6.9077 6.3218 6.3223a2.001 2.001 0 002.8286 0l9.9424-9.9424a2.001 2.001 0 000-2.8286zM18.0579 28l-6.3218-6.3223 9.9419-9.9419L28 18.0576zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path293$4 || (_path293$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.4927,20.2627l1.414-1.4141L4,13.9414V4h9.9417l4.9069,4.9067,1.4141-1.414L15.3555,2.5859A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141Z"
    })), children);
  });
  var TagNone24 = /*#__PURE__*/React__default['default'].forwardRef(function TagNone24(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294$4 || (_path294$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.092 10.3218L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6.9077-6.9077 6.3218 6.3223a2.001 2.001 0 002.8286 0l9.9424-9.9424a2.001 2.001 0 000-2.8286zM18.0579 28l-6.3218-6.3223 9.9419-9.9419L28 18.0576zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path295$4 || (_path295$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.4927,20.2627l1.414-1.4141L4,13.9414V4h9.9417l4.9069,4.9067,1.4141-1.414L15.3555,2.5859A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141Z"
    })), children);
  });
  var TagNone20 = /*#__PURE__*/React__default['default'].forwardRef(function TagNone20(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$4 || (_path296$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.092 10.3218L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6.9077-6.9077 6.3218 6.3223a2.001 2.001 0 002.8286 0l9.9424-9.9424a2.001 2.001 0 000-2.8286zM18.0579 28l-6.3218-6.3223 9.9419-9.9419L28 18.0576zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path297$4 || (_path297$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.4927,20.2627l1.414-1.4141L4,13.9414V4h9.9417l4.9069,4.9067,1.4141-1.414L15.3555,2.5859A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141Z"
    })), children);
  });
  var TagNone16 = /*#__PURE__*/React__default['default'].forwardRef(function TagNone16(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$4 || (_path298$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.092 10.3218L30 3.4141 28.5859 2 2 28.5859 3.4141 30l6.9077-6.9077 6.3218 6.3223a2.001 2.001 0 002.8286 0l9.9424-9.9424a2.001 2.001 0 000-2.8286zM18.0579 28l-6.3218-6.3223 9.9419-9.9419L28 18.0576zM10 14a4 4 0 114-4A4.0045 4.0045 0 0110 14zm0-6a2 2 0 101.998 2.0044A2.002 2.002 0 0010 8z"
    })), _path299$4 || (_path299$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.4927,20.2627l1.414-1.4141L4,13.9414V4h9.9417l4.9069,4.9067,1.4141-1.414L15.3555,2.5859A2,2,0,0,0,13.9414,2H4A2,2,0,0,0,2,4v9.9414a2,2,0,0,0,.5857,1.4141Z"
    })), children);
  });
  var Tank32 = /*#__PURE__*/React__default['default'].forwardRef(function Tank32(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$4 || (_path300$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H18.6182l-.7237-1.4473A1,1,0,0,0,17,9H9a1,1,0,0,0-1,1v5H4v2H22.6379l3.6,3H3a1,1,0,0,0-1,1v2a5.0057,5.0057,0,0,0,5,5H25a5.0057,5.0057,0,0,0,5-5V21a1.0011,1.0011,0,0,0-.36-.7686l-6-5A1.0015,1.0015,0,0,0,23,15H20.6182l-1-2ZM28,23a3.0033,3.0033,0,0,1-3,3H7a3.0033,3.0033,0,0,1-3-3V22H28ZM10,15V11h6.3821l2,4Z"
    })), children);
  });
  var Tank24 = /*#__PURE__*/React__default['default'].forwardRef(function Tank24(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$4 || (_path301$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H18.6182l-.7237-1.4473A1,1,0,0,0,17,9H9a1,1,0,0,0-1,1v5H4v2H22.6379l3.6,3H3a1,1,0,0,0-1,1v2a5.0057,5.0057,0,0,0,5,5H25a5.0057,5.0057,0,0,0,5-5V21a1.0011,1.0011,0,0,0-.36-.7686l-6-5A1.0015,1.0015,0,0,0,23,15H20.6182l-1-2ZM28,23a3.0033,3.0033,0,0,1-3,3H7a3.0033,3.0033,0,0,1-3-3V22H28ZM10,15V11h6.3821l2,4Z"
    })), children);
  });
  var Tank20 = /*#__PURE__*/React__default['default'].forwardRef(function Tank20(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$4 || (_path302$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H18.6182l-.7237-1.4473A1,1,0,0,0,17,9H9a1,1,0,0,0-1,1v5H4v2H22.6379l3.6,3H3a1,1,0,0,0-1,1v2a5.0057,5.0057,0,0,0,5,5H25a5.0057,5.0057,0,0,0,5-5V21a1.0011,1.0011,0,0,0-.36-.7686l-6-5A1.0015,1.0015,0,0,0,23,15H20.6182l-1-2ZM28,23a3.0033,3.0033,0,0,1-3,3H7a3.0033,3.0033,0,0,1-3-3V22H28ZM10,15V11h6.3821l2,4Z"
    })), children);
  });
  var Tank16 = /*#__PURE__*/React__default['default'].forwardRef(function Tank16(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$4 || (_path303$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,13V11H18.6182l-.7237-1.4473A1,1,0,0,0,17,9H9a1,1,0,0,0-1,1v5H4v2H22.6379l3.6,3H3a1,1,0,0,0-1,1v2a5.0057,5.0057,0,0,0,5,5H25a5.0057,5.0057,0,0,0,5-5V21a1.0011,1.0011,0,0,0-.36-.7686l-6-5A1.0015,1.0015,0,0,0,23,15H20.6182l-1-2ZM28,23a3.0033,3.0033,0,0,1-3,3H7a3.0033,3.0033,0,0,1-3-3V22H28ZM10,15V11h6.3821l2,4Z"
    })), children);
  });
  var Task32 = /*#__PURE__*/React__default['default'].forwardRef(function Task32(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$4 || (_path304$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"
    })), _path305$4 || (_path305$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Task24 = /*#__PURE__*/React__default['default'].forwardRef(function Task24(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$4 || (_path306$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"
    })), _path307$4 || (_path307$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Task20 = /*#__PURE__*/React__default['default'].forwardRef(function Task20(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$4 || (_path308$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"
    })), _path309$4 || (_path309$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var Task16 = /*#__PURE__*/React__default['default'].forwardRef(function Task16(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$4 || (_path310$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"
    })), _path311$4 || (_path311$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"
    })), children);
  });
  var TaskAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAdd32(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$4 || (_path312$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 24L27 24 27 20 25 20 25 24 21 24 21 26 25 26 25 30 27 30 27 26 31 26 31 24z"
    })), _path313$4 || (_path313$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2H17V28H7V7h3v3H22V7h3v9h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAdd24(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$4 || (_path314$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 24L27 24 27 20 25 20 25 24 21 24 21 26 25 26 25 30 27 30 27 26 31 26 31 24z"
    })), _path315$4 || (_path315$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2H17V28H7V7h3v3H22V7h3v9h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAdd20(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path316$4 || (_path316$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 24L27 24 27 20 25 20 25 24 21 24 21 26 25 26 25 30 27 30 27 26 31 26 31 24z"
    })), _path317$4 || (_path317$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2H17V28H7V7h3v3H22V7h3v9h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAdd16(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$4 || (_path318$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 24L27 24 27 20 25 20 25 24 21 24 21 26 25 26 25 30 27 30 27 26 31 26 31 24z"
    })), _path319$4 || (_path319$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2H17V28H7V7h3v3H22V7h3v9h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskApproved32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskApproved32(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path320$4 || (_path320$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20A6,6,0,1,0,20,24.46V32l4-1.8936L28,32V24.46A5.98,5.98,0,0,0,30,20Zm-4,8.84-2-.9467L22,28.84V25.65a5.8877,5.8877,0,0,0,4,0ZM24,24a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,24Z"
    })), _path321$4 || (_path321$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskApproved24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskApproved24(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path322$4 || (_path322$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20A6,6,0,1,0,20,24.46V32l4-1.8936L28,32V24.46A5.98,5.98,0,0,0,30,20Zm-4,8.84-2-.9467L22,28.84V25.65a5.8877,5.8877,0,0,0,4,0ZM24,24a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,24Z"
    })), _path323$4 || (_path323$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskApproved20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskApproved20(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$4 || (_path324$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20A6,6,0,1,0,20,24.46V32l4-1.8936L28,32V24.46A5.98,5.98,0,0,0,30,20Zm-4,8.84-2-.9467L22,28.84V25.65a5.8877,5.8877,0,0,0,4,0ZM24,24a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,24Z"
    })), _path325$4 || (_path325$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskApproved16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskApproved16(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$4 || (_path326$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20A6,6,0,1,0,20,24.46V32l4-1.8936L28,32V24.46A5.98,5.98,0,0,0,30,20Zm-4,8.84-2-.9467L22,28.84V25.65a5.8877,5.8877,0,0,0,4,0ZM24,24a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,24Z"
    })), _path327$4 || (_path327$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAssetView32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAssetView32(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$4 || (_path328$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,26A3.5,3.5,0,1,1,26,22.5,3.5041,3.5041,0,0,1,22.5,26Zm0-5A1.5,1.5,0,1,0,24,22.5,1.5017,1.5017,0,0,0,22.5,21Z"
    })), _path329$4 || (_path329$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,31A8.5,8.5,0,1,1,31,22.5,8.51,8.51,0,0,1,22.5,31Zm0-15A6.5,6.5,0,1,0,29,22.5,6.5074,6.5074,0,0,0,22.5,16Z"
    })), _path330$4 || (_path330$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h5V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAssetView24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAssetView24(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$4 || (_path331$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,26A3.5,3.5,0,1,1,26,22.5,3.5041,3.5041,0,0,1,22.5,26Zm0-5A1.5,1.5,0,1,0,24,22.5,1.5017,1.5017,0,0,0,22.5,21Z"
    })), _path332$4 || (_path332$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,31A8.5,8.5,0,1,1,31,22.5,8.51,8.51,0,0,1,22.5,31Zm0-15A6.5,6.5,0,1,0,29,22.5,6.5074,6.5074,0,0,0,22.5,16Z"
    })), _path333$4 || (_path333$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h5V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAssetView20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAssetView20(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$4 || (_path334$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,26A3.5,3.5,0,1,1,26,22.5,3.5041,3.5041,0,0,1,22.5,26Zm0-5A1.5,1.5,0,1,0,24,22.5,1.5017,1.5017,0,0,0,22.5,21Z"
    })), _path335$4 || (_path335$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,31A8.5,8.5,0,1,1,31,22.5,8.51,8.51,0,0,1,22.5,31Zm0-15A6.5,6.5,0,1,0,29,22.5,6.5074,6.5074,0,0,0,22.5,16Z"
    })), _path336$4 || (_path336$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h5V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskAssetView16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskAssetView16(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$4 || (_path337$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,26A3.5,3.5,0,1,1,26,22.5,3.5041,3.5041,0,0,1,22.5,26Zm0-5A1.5,1.5,0,1,0,24,22.5,1.5017,1.5017,0,0,0,22.5,21Z"
    })), _path338$4 || (_path338$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.5,31A8.5,8.5,0,1,1,31,22.5,8.51,8.51,0,0,1,22.5,31Zm0-15A6.5,6.5,0,1,0,29,22.5,6.5074,6.5074,0,0,0,22.5,16Z"
    })), _path339$4 || (_path339$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h5V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskComplete32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskComplete32(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$4 || (_path340$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path341$4 || (_path341$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V18h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskComplete24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskComplete24(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$4 || (_path342$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path343$4 || (_path343$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V18h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskComplete20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskComplete20(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$4 || (_path344$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path345$4 || (_path345$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V18h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskComplete16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskComplete16(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$4 || (_path346$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 27.18L19.41 24.59 18 26 22 30 30 22 28.59 20.59 22 27.18z"
    })), _path347$4 || (_path347$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V18h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskLocation32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskLocation32(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$2 || (_circle9$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "21",
      r: "2"
    })), _path348$4 || (_path348$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,31l-4.7788-6.4019A5.9354,5.9354,0,0,1,18,21a6,6,0,0,1,12,0,5.9407,5.9407,0,0,1-1.2246,3.6028Zm0-14a4.0045,4.0045,0,0,0-4,4,3.9572,3.9572,0,0,0,.82,2.3972L24,27.6567l3.1763-4.2548A3.9627,3.9627,0,0,0,28,21,4.0045,4.0045,0,0,0,24,17Z"
    })), _path349$4 || (_path349$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskLocation24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskLocation24(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$2 || (_circle10$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "21",
      r: "2"
    })), _path350$4 || (_path350$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,31l-4.7788-6.4019A5.9354,5.9354,0,0,1,18,21a6,6,0,0,1,12,0,5.9407,5.9407,0,0,1-1.2246,3.6028Zm0-14a4.0045,4.0045,0,0,0-4,4,3.9572,3.9572,0,0,0,.82,2.3972L24,27.6567l3.1763-4.2548A3.9627,3.9627,0,0,0,28,21,4.0045,4.0045,0,0,0,24,17Z"
    })), _path351$4 || (_path351$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskLocation20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskLocation20(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$2 || (_circle11$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "21",
      r: "2"
    })), _path352$4 || (_path352$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,31l-4.7788-6.4019A5.9354,5.9354,0,0,1,18,21a6,6,0,0,1,12,0,5.9407,5.9407,0,0,1-1.2246,3.6028Zm0-14a4.0045,4.0045,0,0,0-4,4,3.9572,3.9572,0,0,0,.82,2.3972L24,27.6567l3.1763-4.2548A3.9627,3.9627,0,0,0,28,21,4.0045,4.0045,0,0,0,24,17Z"
    })), _path353$4 || (_path353$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskLocation16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskLocation16(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12$2 || (_circle12$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "21",
      r: "2"
    })), _path354$4 || (_path354$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,31l-4.7788-6.4019A5.9354,5.9354,0,0,1,18,21a6,6,0,0,1,12,0,5.9407,5.9407,0,0,1-1.2246,3.6028Zm0-14a4.0045,4.0045,0,0,0-4,4,3.9572,3.9572,0,0,0,.82,2.3972L24,27.6567l3.1763-4.2548A3.9627,3.9627,0,0,0,28,21,4.0045,4.0045,0,0,0,24,17Z"
    })), _path355$4 || (_path355$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskRemove32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskRemove32(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$4 || (_path356$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25z"
    })), _path357$4 || (_path357$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V17h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskRemove24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskRemove24(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$4 || (_path358$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25z"
    })), _path359$4 || (_path359$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V17h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskRemove20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskRemove20(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$4 || (_path360$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25z"
    })), _path361$4 || (_path361$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V17h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskRemove16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskRemove16(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$4 || (_path362$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.41 25L30 21.41 28.59 20 25 23.59 21.41 20 20 21.41 23.59 25 20 28.59 21.41 30 25 26.41 28.59 30 30 28.59 26.41 25z"
    })), _path363$4 || (_path363$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h9V28H7V7h3v3H22V7h3V17h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskSettings32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskSettings32(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$4 || (_path364$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path365$4 || (_path365$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v6h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskSettings24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskSettings24(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366$4 || (_path366$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path367$4 || (_path367$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v6h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskSettings20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskSettings20(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$4 || (_path368$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path369$4 || (_path369$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v6h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskSettings16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskSettings16(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$4 || (_path370$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,24V22H27.8989a4.9678,4.9678,0,0,0-.7319-1.7529l1.49-1.49-1.414-1.414-1.49,1.49A4.9678,4.9678,0,0,0,24,18.1011V16H22v2.1011a4.9678,4.9678,0,0,0-1.7529.7319l-1.49-1.49-1.414,1.414,1.49,1.49A4.9678,4.9678,0,0,0,18.1011,22H16v2h2.1011a4.9678,4.9678,0,0,0,.7319,1.7529l-1.49,1.49,1.414,1.414,1.49-1.49A4.9678,4.9678,0,0,0,22,27.8989V30h2V27.8989a4.9678,4.9678,0,0,0,1.7529-.7319l1.49,1.49,1.414-1.414-1.49-1.49A4.9678,4.9678,0,0,0,27.8989,24Zm-7,2a3,3,0,1,1,3-3A3.0033,3.0033,0,0,1,23,26Z"
    })), _path371$4 || (_path371$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v6h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskStar32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskStar32(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372$4 || (_path372$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17L25.23 21.32 30 22 26.5 25.167 28 30 23 27.208 18 30 19.5 25.167 16 22 20.9 21.32 23 17z"
    })), _path373$4 || (_path373$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v7h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskStar24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskStar24(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$4 || (_path374$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17L25.23 21.32 30 22 26.5 25.167 28 30 23 27.208 18 30 19.5 25.167 16 22 20.9 21.32 23 17z"
    })), _path375$4 || (_path375$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v7h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskStar20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskStar20(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$4 || (_path376$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17L25.23 21.32 30 22 26.5 25.167 28 30 23 27.208 18 30 19.5 25.167 16 22 20.9 21.32 23 17z"
    })), _path377$4 || (_path377$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v7h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskStar16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskStar16(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$4 || (_path378$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 17L25.23 21.32 30 22 26.5 25.167 28 30 23 27.208 18 30 19.5 25.167 16 22 20.9 21.32 23 17z"
    })), _path379$4 || (_path379$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v7h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskTools32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskTools32(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$4 || (_path380$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5,32a3.4762,3.4762,0,0,1-2.4751-1.0254L21.897,26.8469a6.496,6.496,0,0,1-7.3482-8.9563l.5879-1.34L19.293,20.707a1.0234,1.0234,0,0,0,1.4135,0,.999.999,0,0,0,.0005-1.4141l-4.1562-4.1565,1.34-.5881a6.4965,6.4965,0,0,1,8.9566,7.3486l4.1274,4.1282A3.5,3.5,0,0,1,28.5,32Zm-6.03-7.4087,4.9693,4.9692a1.5352,1.5352,0,0,0,2.1211,0,1.4985,1.4985,0,0,0,0-2.1208v0l-4.9692-4.97.188-.5823A4.496,4.496,0,0,0,20.5,16q-.126,0-.25.0068l1.8716,1.8721a2.9992,2.9992,0,0,1,0,4.2424,3.0722,3.0722,0,0,1-4.2427-.0005l-1.8716-1.8715Q16,20.3741,16,20.5A4.4968,4.4968,0,0,0,21.8877,24.78Z"
    })), _path381$4 || (_path381$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskTools24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskTools24(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$4 || (_path382$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5,32a3.4762,3.4762,0,0,1-2.4751-1.0254L21.897,26.8469a6.496,6.496,0,0,1-7.3482-8.9563l.5879-1.34L19.293,20.707a1.0234,1.0234,0,0,0,1.4135,0,.999.999,0,0,0,.0005-1.4141l-4.1562-4.1565,1.34-.5881a6.4965,6.4965,0,0,1,8.9566,7.3486l4.1274,4.1282A3.5,3.5,0,0,1,28.5,32Zm-6.03-7.4087,4.9693,4.9692a1.5352,1.5352,0,0,0,2.1211,0,1.4985,1.4985,0,0,0,0-2.1208v0l-4.9692-4.97.188-.5823A4.496,4.496,0,0,0,20.5,16q-.126,0-.25.0068l1.8716,1.8721a2.9992,2.9992,0,0,1,0,4.2424,3.0722,3.0722,0,0,1-4.2427-.0005l-1.8716-1.8715Q16,20.3741,16,20.5A4.4968,4.4968,0,0,0,21.8877,24.78Z"
    })), _path383$4 || (_path383$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskTools20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskTools20(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$3 || (_path384$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5,32a3.4762,3.4762,0,0,1-2.4751-1.0254L21.897,26.8469a6.496,6.496,0,0,1-7.3482-8.9563l.5879-1.34L19.293,20.707a1.0234,1.0234,0,0,0,1.4135,0,.999.999,0,0,0,.0005-1.4141l-4.1562-4.1565,1.34-.5881a6.4965,6.4965,0,0,1,8.9566,7.3486l4.1274,4.1282A3.5,3.5,0,0,1,28.5,32Zm-6.03-7.4087,4.9693,4.9692a1.5352,1.5352,0,0,0,2.1211,0,1.4985,1.4985,0,0,0,0-2.1208v0l-4.9692-4.97.188-.5823A4.496,4.496,0,0,0,20.5,16q-.126,0-.25.0068l1.8716,1.8721a2.9992,2.9992,0,0,1,0,4.2424,3.0722,3.0722,0,0,1-4.2427-.0005l-1.8716-1.8715Q16,20.3741,16,20.5A4.4968,4.4968,0,0,0,21.8877,24.78Z"
    })), _path385$3 || (_path385$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskTools16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskTools16(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$3 || (_path386$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5,32a3.4762,3.4762,0,0,1-2.4751-1.0254L21.897,26.8469a6.496,6.496,0,0,1-7.3482-8.9563l.5879-1.34L19.293,20.707a1.0234,1.0234,0,0,0,1.4135,0,.999.999,0,0,0,.0005-1.4141l-4.1562-4.1565,1.34-.5881a6.4965,6.4965,0,0,1,8.9566,7.3486l4.1274,4.1282A3.5,3.5,0,0,1,28.5,32Zm-6.03-7.4087,4.9693,4.9692a1.5352,1.5352,0,0,0,2.1211,0,1.4985,1.4985,0,0,0,0-2.1208v0l-4.9692-4.97.188-.5823A4.496,4.496,0,0,0,20.5,16q-.126,0-.25.0068l1.8716,1.8721a2.9992,2.9992,0,0,1,0,4.2424,3.0722,3.0722,0,0,1-4.2427-.0005l-1.8716-1.8715Q16,20.3741,16,20.5A4.4968,4.4968,0,0,0,21.8877,24.78Z"
    })), _path387$3 || (_path387$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,5H22V4a2.0058,2.0058,0,0,0-2-2H12a2.0058,2.0058,0,0,0-2,2V5H7A2.0058,2.0058,0,0,0,5,7V28a2.0058,2.0058,0,0,0,2,2h7V28H7V7h3v3H22V7h3v5h2V7A2.0058,2.0058,0,0,0,25,5ZM20,8H12V4h8Z"
    })), children);
  });
  var TaskView32 = /*#__PURE__*/React__default['default'].forwardRef(function TaskView32(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$2 || (_circle13$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path388$3 || (_path388$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path389$3 || (_path389$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path390$3 || (_path390$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H7V7h3v3H22V7h3v9h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h5ZM12,4h8V8H12Z"
    })), children);
  });
  var TaskView24 = /*#__PURE__*/React__default['default'].forwardRef(function TaskView24(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$2 || (_circle14$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path391$3 || (_path391$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path392$3 || (_path392$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path393$3 || (_path393$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H7V7h3v3H22V7h3v9h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h5ZM12,4h8V8H12Z"
    })), children);
  });
  var TaskView20 = /*#__PURE__*/React__default['default'].forwardRef(function TaskView20(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$2 || (_circle15$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path394$3 || (_path394$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path395$3 || (_path395$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path396$3 || (_path396$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H7V7h3v3H22V7h3v9h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h5ZM12,4h8V8H12Z"
    })), children);
  });
  var TaskView16 = /*#__PURE__*/React__default['default'].forwardRef(function TaskView16(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$2 || (_circle16$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "22",
      cy: "24",
      r: "2"
    })), _path397$3 || (_path397$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M22,28a4,4,0,1,1,4-4A4.0039,4.0039,0,0,1,22,28Zm0-6a2,2,0,1,0,2,2A2.0027,2.0027,0,0,0,22,22Z"
    })), _path398$3 || (_path398$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.7769,23.4785A8.64,8.64,0,0,0,22,18a8.64,8.64,0,0,0-7.7769,5.4785L14,24l.2231.5215A8.64,8.64,0,0,0,22,30a8.64,8.64,0,0,0,7.7769-5.4785L30,24ZM22,28a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,22,28Z"
    })), _path399$2 || (_path399$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,28H7V7h3v3H22V7h3v9h2V7a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2h5ZM12,4h8V8H12Z"
    })), children);
  });
  var Taste32 = /*#__PURE__*/React__default['default'].forwardRef(function Taste32(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$2 || (_path400$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 4V6H8v8a8 8 0 0016 0V6h4V4zM22 14a6 6 0 01-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"
    })), children);
  });
  var Taste24 = /*#__PURE__*/React__default['default'].forwardRef(function Taste24(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$2 || (_path401$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 4V6H8v8a8 8 0 0016 0V6h4V4zM22 14a6 6 0 01-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"
    })), children);
  });
  var Taste20 = /*#__PURE__*/React__default['default'].forwardRef(function Taste20(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$2 || (_path402$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 4V6H8v8a8 8 0 0016 0V6h4V4zM22 14a6 6 0 01-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"
    })), children);
  });
  var Taste16 = /*#__PURE__*/React__default['default'].forwardRef(function Taste16(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403$2 || (_path403$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 4V6H8v8a8 8 0 0016 0V6h4V4zM22 14a6 6 0 01-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"
    })), children);
  });
  var Taxi32 = /*#__PURE__*/React__default['default'].forwardRef(function Taxi32(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$2 || (_path404$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"
    })), children);
  });
  var Taxi24 = /*#__PURE__*/React__default['default'].forwardRef(function Taxi24(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path405$2 || (_path405$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"
    })), children);
  });
  var Taxi20 = /*#__PURE__*/React__default['default'].forwardRef(function Taxi20(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$2 || (_path406$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"
    })), children);
  });
  var Taxi16 = /*#__PURE__*/React__default['default'].forwardRef(function Taxi16(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path407$2 || (_path407$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"
    })), children);
  });
  var Temperature32 = /*#__PURE__*/React__default['default'].forwardRef(function Temperature32(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$2 || (_path408$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 17.26V6A4 4 0 005 6V17.26a7 7 0 108 0zM9 4a2 2 0 012 2v7H7V6A2 2 0 019 4zM9 28a5 5 0 01-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 019 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"
    })), children);
  });
  var Temperature24 = /*#__PURE__*/React__default['default'].forwardRef(function Temperature24(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409$2 || (_path409$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 17.26V6A4 4 0 005 6V17.26a7 7 0 108 0zM9 4a2 2 0 012 2v7H7V6A2 2 0 019 4zM9 28a5 5 0 01-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 019 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"
    })), children);
  });
  var Temperature20 = /*#__PURE__*/React__default['default'].forwardRef(function Temperature20(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$2 || (_path410$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 17.26V6A4 4 0 005 6V17.26a7 7 0 108 0zM9 4a2 2 0 012 2v7H7V6A2 2 0 019 4zM9 28a5 5 0 01-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 019 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"
    })), children);
  });
  var Temperature16 = /*#__PURE__*/React__default['default'].forwardRef(function Temperature16(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$2 || (_path411$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 17.26V6A4 4 0 005 6V17.26a7 7 0 108 0zM9 4a2 2 0 012 2v7H7V6A2 2 0 019 4zM9 28a5 5 0 01-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 019 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"
    })), children);
  });
  var TemperatureCelsius32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsius32(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$2 || (_path412$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,18H24a2.0023,2.0023,0,0,1-2-2V6a2.002,2.002,0,0,1,2-2h6V6H24V16h6Z"
    })), _circle17$2 || (_circle17$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path413$2 || (_path413$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path414$2 || (_path414$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureCelsius24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsius24(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$2 || (_path415$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,18H24a2.0023,2.0023,0,0,1-2-2V6a2.002,2.002,0,0,1,2-2h6V6H24V16h6Z"
    })), _circle18$2 || (_circle18$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path416$1 || (_path416$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path417$1 || (_path417$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureCelsius20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsius20(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path418$1 || (_path418$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,18H24a2.0023,2.0023,0,0,1-2-2V6a2.002,2.002,0,0,1,2-2h6V6H24V16h6Z"
    })), _circle19$2 || (_circle19$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path419$1 || (_path419$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path420$1 || (_path420$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureCelsius16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsius16(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421$1 || (_path421$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,18H24a2.0023,2.0023,0,0,1-2-2V6a2.002,2.002,0,0,1,2-2h6V6H24V16h6Z"
    })), _circle20$2 || (_circle20$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path422$1 || (_path422$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path423$1 || (_path423$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureCelsiusAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsiusAlt32(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path424$1 || (_path424$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 27H17a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h9v2H17V25h9zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureCelsiusAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsiusAlt24(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path425$1 || (_path425$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 27H17a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h9v2H17V25h9zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureCelsiusAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsiusAlt20(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path426$1 || (_path426$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 27H17a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h9v2H17V25h9zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureCelsiusAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureCelsiusAlt16(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path427$1 || (_path427$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 27H17a2.0023 2.0023 0 01-2-2V11a2.002 2.002 0 012-2h9v2H17V25h9zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureFahrenheit32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheit32(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path428$1 || (_path428$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L30 4 22 4 22 18 24 18 24 12 29 12 29 10 24 10 24 6 30 6z"
    })), _circle21$2 || (_circle21$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path429$1 || (_path429$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path430$1 || (_path430$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFahrenheit24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheit24(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path431$1 || (_path431$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L30 4 22 4 22 18 24 18 24 12 29 12 29 10 24 10 24 6 30 6z"
    })), _circle22$2 || (_circle22$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path432$1 || (_path432$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path433$1 || (_path433$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFahrenheit20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheit20(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path434$1 || (_path434$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L30 4 22 4 22 18 24 18 24 12 29 12 29 10 24 10 24 6 30 6z"
    })), _circle23$2 || (_circle23$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path435$1 || (_path435$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path436$1 || (_path436$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFahrenheit16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheit16(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path437$1 || (_path437$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6L30 4 22 4 22 18 24 18 24 12 29 12 29 10 24 10 24 6 30 6z"
    })), _circle24$2 || (_circle24$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "4",
      r: "2"
    })), _path438$1 || (_path438$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,20.1841V12H8v8.1841a3,3,0,1,0,2,0Z"
    })), _path439$1 || (_path439$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFahrenheitAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheitAlt32(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path440$1 || (_path440$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 11L26 9 15 9 15 27 17 27 17 19 25 19 25 17 17 17 17 11 26 11zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureFahrenheitAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheitAlt24(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path441$1 || (_path441$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 11L26 9 15 9 15 27 17 27 17 19 25 19 25 17 17 17 17 11 26 11zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureFahrenheitAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheitAlt20(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path442$1 || (_path442$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 11L26 9 15 9 15 27 17 27 17 19 25 19 25 17 17 17 17 11 26 11zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureFahrenheitAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFahrenheitAlt16(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path443$1 || (_path443$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 11L26 9 15 9 15 27 17 27 17 19 25 19 25 17 17 17 17 11 26 11zM8 13a4 4 0 114-4h0A4.0118 4.0118 0 018 13zM8 7a2 2 0 102 2h0A2.0059 2.0059 0 008 7z"
    })), children);
  });
  var TemperatureFeelsLike32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFeelsLike32(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path444$1 || (_path444$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H22a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0126 30zM21 12a.9448.9448 0 00-1 1v6h2v9h4V19h2V13a.9448.9448 0 00-1-1zM24 9a4 4 0 114-4h0A4.0118 4.0118 0 0124 9zm0-6a2 2 0 102 2h0a2.0059 2.0059 0 00-2-2zM10 20.1839V12H8v8.1839a3 3 0 102 0z"
    })), _path445$1 || (_path445$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFeelsLike24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFeelsLike24(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path446$1 || (_path446$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H22a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0126 30zM21 12a.9448.9448 0 00-1 1v6h2v9h4V19h2V13a.9448.9448 0 00-1-1zM24 9a4 4 0 114-4h0A4.0118 4.0118 0 0124 9zm0-6a2 2 0 102 2h0a2.0059 2.0059 0 00-2-2zM10 20.1839V12H8v8.1839a3 3 0 102 0z"
    })), _path447$1 || (_path447$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFeelsLike20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFeelsLike20(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path448$1 || (_path448$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H22a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0126 30zM21 12a.9448.9448 0 00-1 1v6h2v9h4V19h2V13a.9448.9448 0 00-1-1zM24 9a4 4 0 114-4h0A4.0118 4.0118 0 0124 9zm0-6a2 2 0 102 2h0a2.0059 2.0059 0 00-2-2zM10 20.1839V12H8v8.1839a3 3 0 102 0z"
    })), _path449$1 || (_path449$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFeelsLike16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFeelsLike16(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path450$1 || (_path450$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H22a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0126 30zM21 12a.9448.9448 0 00-1 1v6h2v9h4V19h2V13a.9448.9448 0 00-1-1zM24 9a4 4 0 114-4h0A4.0118 4.0118 0 0124 9zm0-6a2 2 0 102 2h0a2.0059 2.0059 0 00-2-2zM10 20.1839V12H8v8.1839a3 3 0 102 0z"
    })), _path451$1 || (_path451$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFrigid32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFrigid32(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path452$1 || (_path452$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.167 16.89L21.72 13 27.167 9.109 29.684 9.948 30.316 8.051 28 7.279 28 5 26 5 26 7.485 21 11.057 21 5.367 23.555 3.664 22.445 2 20 3.63 17.555 2 16.445 3.664 19 5.367 19 11.057 16 8.914 16 11.372 18.28 13 16 14.628 16 17.086 19 14.943 19 21.703 22.445 24 23.555 22.336 21 20.633 21 14.943 26 18.515 26 21 28 21 28 18.721 30.316 17.948 29.684 16.051 27.167 16.89zM12 23a3 3 0 01-6 0z"
    })), _path453$1 || (_path453$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFrigid24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFrigid24(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path454$1 || (_path454$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.167 16.89L21.72 13 27.167 9.109 29.684 9.948 30.316 8.051 28 7.279 28 5 26 5 26 7.485 21 11.057 21 5.367 23.555 3.664 22.445 2 20 3.63 17.555 2 16.445 3.664 19 5.367 19 11.057 16 8.914 16 11.372 18.28 13 16 14.628 16 17.086 19 14.943 19 21.703 22.445 24 23.555 22.336 21 20.633 21 14.943 26 18.515 26 21 28 21 28 18.721 30.316 17.948 29.684 16.051 27.167 16.89zM12 23a3 3 0 01-6 0z"
    })), _path455$1 || (_path455$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFrigid20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFrigid20(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path456$1 || (_path456$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.167 16.89L21.72 13 27.167 9.109 29.684 9.948 30.316 8.051 28 7.279 28 5 26 5 26 7.485 21 11.057 21 5.367 23.555 3.664 22.445 2 20 3.63 17.555 2 16.445 3.664 19 5.367 19 11.057 16 8.914 16 11.372 18.28 13 16 14.628 16 17.086 19 14.943 19 21.703 22.445 24 23.555 22.336 21 20.633 21 14.943 26 18.515 26 21 28 21 28 18.721 30.316 17.948 29.684 16.051 27.167 16.89zM12 23a3 3 0 01-6 0z"
    })), _path457$1 || (_path457$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureFrigid16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureFrigid16(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path458$1 || (_path458$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.167 16.89L21.72 13 27.167 9.109 29.684 9.948 30.316 8.051 28 7.279 28 5 26 5 26 7.485 21 11.057 21 5.367 23.555 3.664 22.445 2 20 3.63 17.555 2 16.445 3.664 19 5.367 19 11.057 16 8.914 16 11.372 18.28 13 16 14.628 16 17.086 19 14.943 19 21.703 22.445 24 23.555 22.336 21 20.633 21 14.943 26 18.515 26 21 28 21 28 18.721 30.316 17.948 29.684 16.051 27.167 16.89zM12 23a3 3 0 01-6 0z"
    })), _path459$1 || (_path459$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureHot32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureHot32(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path460$1 || (_path460$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13H30V15H26z"
    })), _path461$1 || (_path461$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.121 5.879H27.121V7.879H23.121z",
      transform: "rotate(-45 25.121 6.879)"
    })), _path462$1 || (_path462$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.121 19.121H26.121V23.121H24.121z",
      transform: "rotate(-45 25.121 21.121)"
    })), _path463$1 || (_path463$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17zM18 8a6.0365 6.0365 0 00-1 .09v2.0518A3.9567 3.9567 0 0118 10a4 4 0 010 8v2A6 6 0 0018 8zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path464$1 || (_path464$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureHot24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureHot24(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path465$1 || (_path465$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13H30V15H26z"
    })), _path466$1 || (_path466$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.121 5.879H27.121V7.879H23.121z",
      transform: "rotate(-45 25.121 6.879)"
    })), _path467$1 || (_path467$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.121 19.121H26.121V23.121H24.121z",
      transform: "rotate(-45 25.121 21.121)"
    })), _path468$1 || (_path468$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17zM18 8a6.0365 6.0365 0 00-1 .09v2.0518A3.9567 3.9567 0 0118 10a4 4 0 010 8v2A6 6 0 0018 8zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path469$1 || (_path469$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureHot20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureHot20(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path470$1 || (_path470$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13H30V15H26z"
    })), _path471$1 || (_path471$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.121 5.879H27.121V7.879H23.121z",
      transform: "rotate(-45 25.121 6.879)"
    })), _path472$1 || (_path472$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.121 19.121H26.121V23.121H24.121z",
      transform: "rotate(-45 25.121 21.121)"
    })), _path473$1 || (_path473$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17zM18 8a6.0365 6.0365 0 00-1 .09v2.0518A3.9567 3.9567 0 0118 10a4 4 0 010 8v2A6 6 0 0018 8zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path474$1 || (_path474$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureHot16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureHot16(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path475$1 || (_path475$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 13H30V15H26z"
    })), _path476$1 || (_path476$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.121 5.879H27.121V7.879H23.121z",
      transform: "rotate(-45 25.121 6.879)"
    })), _path477$1 || (_path477$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.121 19.121H26.121V23.121H24.121z",
      transform: "rotate(-45 25.121 21.121)"
    })), _path478$1 || (_path478$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 2H19V6H17zM18 8a6.0365 6.0365 0 00-1 .09v2.0518A3.9567 3.9567 0 0118 10a4 4 0 010 8v2A6 6 0 0018 8zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path479$1 || (_path479$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9,30A6.9931,6.9931,0,0,1,4,18.1108V7A5,5,0,0,1,14,7V18.1108A6.9931,6.9931,0,0,1,9,30ZM9,4A3.0033,3.0033,0,0,0,6,7V18.9834l-.332.2983a5,5,0,1,0,6.664,0L12,18.9834V7A3.0033,3.0033,0,0,0,9,4Z"
    })), children);
  });
  var TemperatureInversion32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureInversion32(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path480$1 || (_path480$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H24v6h2V11.541A5.939 5.939 0 0128 16a6.0039 6.0039 0 01-5.0945 5.9243A7.0273 7.0273 0 0020 17.2617V6a4 4 0 00-8 0V17.2617a6.996 6.996 0 1010.9292 6.68A7.9794 7.9794 0 0027.2651 10H30zM14 6a2 2 0 014 0v7H14zm2 22a4.9965 4.9965 0 01-2.499-9.3252L14 18.3857V15h4v3.3857l.499.2891A4.9965 4.9965 0 0116 28zM2 10a8.04 8.04 0 002.7349 6H2v2H8V12H6v2.4592A5.94 5.94 0 014 10a6.0066 6.0066 0 016-6V2A8.0092 8.0092 0 002 10z"
    })), children);
  });
  var TemperatureInversion24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureInversion24(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path481$1 || (_path481$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H24v6h2V11.541A5.939 5.939 0 0128 16a6.0039 6.0039 0 01-5.0945 5.9243A7.0273 7.0273 0 0020 17.2617V6a4 4 0 00-8 0V17.2617a6.996 6.996 0 1010.9292 6.68A7.9794 7.9794 0 0027.2651 10H30zM14 6a2 2 0 014 0v7H14zm2 22a4.9965 4.9965 0 01-2.499-9.3252L14 18.3857V15h4v3.3857l.499.2891A4.9965 4.9965 0 0116 28zM2 10a8.04 8.04 0 002.7349 6H2v2H8V12H6v2.4592A5.94 5.94 0 014 10a6.0066 6.0066 0 016-6V2A8.0092 8.0092 0 002 10z"
    })), children);
  });
  var TemperatureInversion20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureInversion20(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path482$1 || (_path482$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H24v6h2V11.541A5.939 5.939 0 0128 16a6.0039 6.0039 0 01-5.0945 5.9243A7.0273 7.0273 0 0020 17.2617V6a4 4 0 00-8 0V17.2617a6.996 6.996 0 1010.9292 6.68A7.9794 7.9794 0 0027.2651 10H30zM14 6a2 2 0 014 0v7H14zm2 22a4.9965 4.9965 0 01-2.499-9.3252L14 18.3857V15h4v3.3857l.499.2891A4.9965 4.9965 0 0116 28zM2 10a8.04 8.04 0 002.7349 6H2v2H8V12H6v2.4592A5.94 5.94 0 014 10a6.0066 6.0066 0 016-6V2A8.0092 8.0092 0 002 10z"
    })), children);
  });
  var TemperatureInversion16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureInversion16(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path483$1 || (_path483$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 8H24v6h2V11.541A5.939 5.939 0 0128 16a6.0039 6.0039 0 01-5.0945 5.9243A7.0273 7.0273 0 0020 17.2617V6a4 4 0 00-8 0V17.2617a6.996 6.996 0 1010.9292 6.68A7.9794 7.9794 0 0027.2651 10H30zM14 6a2 2 0 014 0v7H14zm2 22a4.9965 4.9965 0 01-2.499-9.3252L14 18.3857V15h4v3.3857l.499.2891A4.9965 4.9965 0 0116 28zM2 10a8.04 8.04 0 002.7349 6H2v2H8V12H6v2.4592A5.94 5.94 0 014 10a6.0066 6.0066 0 016-6V2A8.0092 8.0092 0 002 10z"
    })), children);
  });
  var TemperatureMax32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMax32(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path484$1 || (_path484$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path485$1 || (_path485$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,4H12.9744A4.9829,4.9829,0,0,0,4,7V18.1108a7,7,0,1,0,10,0V7a5.0019,5.0019,0,0,0-.1011-1H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMax24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMax24(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path486$1 || (_path486$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path487$1 || (_path487$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,4H12.9744A4.9829,4.9829,0,0,0,4,7V18.1108a7,7,0,1,0,10,0V7a5.0019,5.0019,0,0,0-.1011-1H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMax20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMax20(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path488$1 || (_path488$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path489$1 || (_path489$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,4H12.9744A4.9829,4.9829,0,0,0,4,7V18.1108a7,7,0,1,0,10,0V7a5.0019,5.0019,0,0,0-.1011-1H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMax16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMax16(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path490$1 || (_path490$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20zM10 20.1839V7H8V20.1839a3 3 0 102 0z"
    })), _path491$1 || (_path491$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,4H12.9744A4.9829,4.9829,0,0,0,4,7V18.1108a7,7,0,1,0,10,0V7a5.0019,5.0019,0,0,0-.1011-1H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMin32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMin32(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path492$1 || (_path492$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4H27V6H20zM20 10H30V12H20zM20 16H27V18H20zM12 23a3 3 0 01-6 0z"
    })), _path493$1 || (_path493$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H15.9192A7.0107,7.0107,0,0,0,14,18.1108V7A5,5,0,0,0,4,7V18.1108A6.9946,6.9946,0,1,0,15.92,24H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMin24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMin24(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path494$1 || (_path494$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4H27V6H20zM20 10H30V12H20zM20 16H27V18H20zM12 23a3 3 0 01-6 0z"
    })), _path495$1 || (_path495$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H15.9192A7.0107,7.0107,0,0,0,14,18.1108V7A5,5,0,0,0,4,7V18.1108A6.9946,6.9946,0,1,0,15.92,24H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMin20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMin20(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path496$1 || (_path496$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4H27V6H20zM20 10H30V12H20zM20 16H27V18H20zM12 23a3 3 0 01-6 0z"
    })), _path497$1 || (_path497$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H15.9192A7.0107,7.0107,0,0,0,14,18.1108V7A5,5,0,0,0,4,7V18.1108A6.9946,6.9946,0,1,0,15.92,24H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureMin16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureMin16(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path498$1 || (_path498$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 4H27V6H20zM20 10H30V12H20zM20 16H27V18H20zM12 23a3 3 0 01-6 0z"
    })), _path499$1 || (_path499$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,22H15.9192A7.0107,7.0107,0,0,0,14,18.1108V7A5,5,0,0,0,4,7V18.1108A6.9946,6.9946,0,1,0,15.92,24H30ZM9,28a4.9933,4.9933,0,0,1-3.332-8.7183L6,18.9834V7a3,3,0,0,1,6,0V18.9834l.332.2983A4.9933,4.9933,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureWater32 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureWater32(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path500$1 || (_path500$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,9a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,9V7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,4a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,4a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,7H13V6A4,4,0,0,0,5,6V17.2617A7.0126,7.0126,0,1,0,13.8735,18H14a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,18V16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,13a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,13a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,16H13V9ZM7,6a2,2,0,0,1,4,0v6H7ZM9,28a4.9965,4.9965,0,0,1-2.499-9.3252L7,18.3857V14h4v4.3857l.499.2891A4.9965,4.9965,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureWater24 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureWater24(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path501$1 || (_path501$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,9a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,9V7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,4a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,4a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,7H13V6A4,4,0,0,0,5,6V17.2617A7.0126,7.0126,0,1,0,13.8735,18H14a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,18V16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,13a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,13a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,16H13V9ZM7,6a2,2,0,0,1,4,0v6H7ZM9,28a4.9965,4.9965,0,0,1-2.499-9.3252L7,18.3857V14h4v4.3857l.499.2891A4.9965,4.9965,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureWater20 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureWater20(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path502$1 || (_path502$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,9a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,9V7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,4a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,4a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,7H13V6A4,4,0,0,0,5,6V17.2617A7.0126,7.0126,0,1,0,13.8735,18H14a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,18V16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,13a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,13a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,16H13V9ZM7,6a2,2,0,0,1,4,0v6H7ZM9,28a4.9965,4.9965,0,0,1-2.499-9.3252L7,18.3857V14h4v4.3857l.499.2891A4.9965,4.9965,0,0,1,9,28Z"
    })), children);
  });
  var TemperatureWater16 = /*#__PURE__*/React__default['default'].forwardRef(function TemperatureWater16(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path503$1 || (_path503$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,9a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,9V7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,4a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,7a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,4a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,7H13V6A4,4,0,0,0,5,6V17.2617A7.0126,7.0126,0,1,0,13.8735,18H14a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0A4.9316,4.9316,0,0,0,30,18V16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,26,13a.9894.9894,0,0,0-.9468.6787A3.44,3.44,0,0,1,22,16a3.4376,3.4376,0,0,1-3.0513-2.3164A1.007,1.007,0,0,0,18,13a.971.971,0,0,0-.9468.6787A3.44,3.44,0,0,1,14,16H13V9ZM7,6a2,2,0,0,1,4,0v6H7ZM9,28a4.9965,4.9965,0,0,1-2.499-9.3252L7,18.3857V14h4v4.3857l.499.2891A4.9965,4.9965,0,0,1,9,28Z"
    })), children);
  });
  var Template32 = /*#__PURE__*/React__default['default'].forwardRef(function Template32(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path504$1 || (_path504$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6v4H6V6H26m0-2H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V16a2 2 0 00-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 00-2 2V26a2 2 0 002 2H26a2 2 0 002-2V16a2 2 0 00-2-2z"
    })), children);
  });
  var Template24 = /*#__PURE__*/React__default['default'].forwardRef(function Template24(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path505$1 || (_path505$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6v4H6V6H26m0-2H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V16a2 2 0 00-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 00-2 2V26a2 2 0 002 2H26a2 2 0 002-2V16a2 2 0 00-2-2z"
    })), children);
  });
  var Template20 = /*#__PURE__*/React__default['default'].forwardRef(function Template20(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path506$1 || (_path506$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6v4H6V6H26m0-2H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V16a2 2 0 00-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 00-2 2V26a2 2 0 002 2H26a2 2 0 002-2V16a2 2 0 00-2-2z"
    })), children);
  });
  var Template16 = /*#__PURE__*/React__default['default'].forwardRef(function Template16(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path507$1 || (_path507$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 6v4H6V6H26m0-2H6A2 2 0 004 6v4a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 00-2 2V26a2 2 0 002 2h4a2 2 0 002-2V16a2 2 0 00-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 00-2 2V26a2 2 0 002 2H26a2 2 0 002-2V16a2 2 0 00-2-2z"
    })), children);
  });
  var Tennis32 = /*#__PURE__*/React__default['default'].forwardRef(function Tennis32(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect || (_rect = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "4",
      height: "4",
      x: "20",
      y: "2",
      rx: "2"
    })), _path508$1 || (_path508$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"
    })), _path509$1 || (_path509$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"
    })), children);
  });
  var Tennis24 = /*#__PURE__*/React__default['default'].forwardRef(function Tennis24(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect2 || (_rect2 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "4",
      height: "4",
      x: "20",
      y: "2",
      rx: "2"
    })), _path510$1 || (_path510$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"
    })), _path511$1 || (_path511$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"
    })), children);
  });
  var Tennis20 = /*#__PURE__*/React__default['default'].forwardRef(function Tennis20(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect3 || (_rect3 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "4",
      height: "4",
      x: "20",
      y: "2",
      rx: "2"
    })), _path512$1 || (_path512$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"
    })), _path513$1 || (_path513$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"
    })), children);
  });
  var Tennis16 = /*#__PURE__*/React__default['default'].forwardRef(function Tennis16(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _rect4 || (_rect4 = /*#__PURE__*/React__default['default'].createElement("rect", {
      width: "4",
      height: "4",
      x: "20",
      y: "2",
      rx: "2"
    })), _path514$1 || (_path514$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"
    })), _path515$1 || (_path515$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"
    })), children);
  });
  var TennisBall32 = /*#__PURE__*/React__default['default'].forwardRef(function TennisBall32(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path516$1 || (_path516$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"
    })), children);
  });
  var TennisBall24 = /*#__PURE__*/React__default['default'].forwardRef(function TennisBall24(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path517$1 || (_path517$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"
    })), children);
  });
  var TennisBall20 = /*#__PURE__*/React__default['default'].forwardRef(function TennisBall20(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path518$1 || (_path518$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"
    })), children);
  });
  var TennisBall16 = /*#__PURE__*/React__default['default'].forwardRef(function TennisBall16(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path519$1 || (_path519$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"
    })), children);
  });
  var Term32 = /*#__PURE__*/React__default['default'].forwardRef(function Term32(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path520$1 || (_path520$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"
    })), _circle25$1 || (_circle25$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle26$1 || (_circle26$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle27$1 || (_circle27$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _path521$1 || (_path521$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"
    })), children);
  });
  var Term24 = /*#__PURE__*/React__default['default'].forwardRef(function Term24(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path522$1 || (_path522$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"
    })), _circle28$1 || (_circle28$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle29$1 || (_circle29$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle30$1 || (_circle30$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _path523$1 || (_path523$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"
    })), children);
  });
  var Term20 = /*#__PURE__*/React__default['default'].forwardRef(function Term20(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path524$1 || (_path524$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"
    })), _circle31$1 || (_circle31$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle32$1 || (_circle32$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle33$1 || (_circle33$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _path525$1 || (_path525$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"
    })), children);
  });

  var _path$4, _circle$3, _circle2$3, _circle3$3, _path2$4, _path3$4, _path4$4, _path5$4, _path6$4, _path7$4, _path8$4, _path9$4, _path10$4, _path11$4, _path12$4, _path13$4, _path14$4, _path15$4, _path16$4, _path17$4, _path18$4, _path19$4, _path20$4, _path21$4, _path22$4, _path23$4, _path24$4, _path25$4, _path26$4, _path27$4, _path28$4, _path29$4, _path30$4, _path31$4, _path32$4, _path33$4, _path34$4, _path35$4, _path36$4, _path37$4, _path38$4, _path39$4, _path40$4, _path41$4, _path42$4, _path43$4, _path44$4, _path45$4, _path46$4, _path47$4, _path48$4, _path49$4, _path50$4, _path51$4, _path52$4, _path53$4, _path54$4, _path55$4, _path56$4, _path57$4, _path58$4, _path59$4, _path60$4, _path61$4, _path62$4, _path63$4, _path64$4, _path65$4, _path66$4, _path67$4, _path68$4, _path69$4, _path70$4, _path71$4, _path72$4, _path73$4, _path74$4, _path75$4, _path76$4, _path77$4, _path78$4, _path79$4, _path80$4, _path81$4, _path82$4, _path83$4, _path84$4, _path85$4, _path86$4, _path87$4, _path88$4, _path89$4, _path90$4, _path91$4, _path92$4, _path93$4, _path94$4, _path95$4, _path96$4, _path97$4, _path98$4, _path99$4, _path100$4, _path101$4, _path102$4, _path103$4, _path104$4, _path105$4, _path106$4, _path107$4, _path108$4, _path109$4, _path110$4, _path111$4, _path112$4, _path113$4, _path114$4, _path115$4, _path116$4, _path117$4, _path118$4, _path119$4, _path120$4, _path121$4, _path122$4, _path123$4, _path124$4, _path125$4, _path126$4, _path127$4, _path128$4, _path129$4, _path130$4, _path131$4, _path132$4, _path133$4, _path134$4, _path135$4, _path136$4, _path137$4, _path138$4, _path139$4, _path140$4, _path141$4, _path142$4, _path143$4, _path144$4, _path145$4, _path146$4, _path147$4, _path148$4, _path149$4, _path150$4, _path151$4, _path152$4, _path153$4, _path154$4, _path155$4, _path156$4, _path157$4, _path158$4, _path159$4, _path160$4, _path161$4, _path162$4, _path163$4, _path164$4, _path165$4, _path166$4, _path167$4, _path168$4, _path169$4, _path170$4, _path171$4, _path172$4, _path173$4, _path174$4, _path175$4, _path176$4, _path177$3, _path178$3, _path179$3, _path180$3, _path181$3, _path182$3, _path183$3, _path184$3, _path185$3, _path186$3, _path187$3, _path188$3, _path189$3, _path190$3, _path191$3, _path192$3, _path193$3, _path194$3, _path195$3, _path196$3, _path197$3, _path198$3, _path199$3, _path200$3, _path201$3, _path202$3, _path203$3, _path204$3, _path205$3, _path206$3, _path207$3, _path208$3, _path209$3, _path210$3, _path211$3, _path212$3, _path213$3, _path214$3, _path215$3, _path216$3, _path217$3, _path218$3, _path219$3, _path220$3, _path221$3, _path222$3, _path223$3, _path224$3, _path225$3, _path226$3, _path227$3, _path228$3, _path229$3, _path230$3, _path231$3, _path232$3, _path233$3, _path234$3, _path235$3, _path236$3, _path237$3, _path238$3, _path239$3, _path240$3, _path241$3, _path242$3, _path243$3, _path244$3, _path245$3, _path246$3, _path247$3, _path248$3, _path249$3, _path250$3, _path251$3, _path252$3, _path253$3, _path254$3, _path255$3, _path256$3, _path257$3, _path258$3, _path259$3, _path260$3, _path261$3, _path262$3, _path263$3, _path264$3, _path265$3, _path266$3, _path267$3, _path268$3, _path269$3, _path270$3, _path271$3, _path272$3, _path273$3, _path274$3, _path275$3, _path276$3, _path277$3, _path278$3, _path279$3, _path280$3, _path281$3, _path282$3, _path283$3, _path284$3, _path285$3, _path286$3, _path287$3, _path288$3, _path289$3, _path290$3, _path291$3, _path292$3, _path293$3, _path294$3, _path295$3, _path296$3, _path297$3, _path298$3, _path299$3, _path300$3, _path301$3, _path302$3, _path303$3, _path304$3, _path305$3, _path306$3, _path307$3, _path308$3, _path309$3, _path310$3, _path311$3, _path312$3, _path313$3, _path314$3, _path315$3, _path316$3, _path317$3, _path318$3, _path319$3, _path320$3, _path321$3, _path322$3, _path323$3, _path324$3, _path325$3, _path326$3, _path327$3, _path328$3, _path329$3, _path330$3, _path331$3, _path332$3, _path333$3, _path334$3, _path335$3, _path336$3, _path337$3, _path338$3, _path339$3, _path340$3, _path341$3, _path342$3, _path343$3, _path344$3, _path345$3, _path346$3, _path347$3, _path348$3, _path349$3, _path350$3, _path351$3, _path352$3, _path353$3, _path354$3, _path355$3, _path356$3, _path357$3, _path358$3, _path359$3, _path360$3, _path361$3, _path362$3, _path363$3, _path364$3, _path365$3, _path366$3, _path367$3, _path368$3, _path369$3, _path370$3, _path371$3, _path372$3, _path373$3, _path374$3, _path375$3, _path376$3, _path377$3, _path378$3, _path379$3, _path380$3, _path381$3, _path382$3, _path383$3;

  var _excluded$4 = ["children"],
      _excluded2$4 = ["children"],
      _excluded3$4 = ["children"],
      _excluded4$4 = ["children"],
      _excluded5$4 = ["children"],
      _excluded6$4 = ["children"],
      _excluded7$4 = ["children"],
      _excluded8$4 = ["children"],
      _excluded9$4 = ["children"],
      _excluded10$4 = ["children"],
      _excluded11$4 = ["children"],
      _excluded12$4 = ["children"],
      _excluded13$4 = ["children"],
      _excluded14$4 = ["children"],
      _excluded15$4 = ["children"],
      _excluded16$4 = ["children"],
      _excluded17$4 = ["children"],
      _excluded18$4 = ["children"],
      _excluded19$4 = ["children"],
      _excluded20$4 = ["children"],
      _excluded21$4 = ["children"],
      _excluded22$4 = ["children"],
      _excluded23$4 = ["children"],
      _excluded24$4 = ["children"],
      _excluded25$4 = ["children"],
      _excluded26$4 = ["children"],
      _excluded27$4 = ["children"],
      _excluded28$4 = ["children"],
      _excluded29$4 = ["children"],
      _excluded30$4 = ["children"],
      _excluded31$4 = ["children"],
      _excluded32$4 = ["children"],
      _excluded33$4 = ["children"],
      _excluded34$4 = ["children"],
      _excluded35$4 = ["children"],
      _excluded36$4 = ["children"],
      _excluded37$4 = ["children"],
      _excluded38$4 = ["children"],
      _excluded39$4 = ["children"],
      _excluded40$4 = ["children"],
      _excluded41$4 = ["children"],
      _excluded42$4 = ["children"],
      _excluded43$4 = ["children"],
      _excluded44$4 = ["children"],
      _excluded45$4 = ["children"],
      _excluded46$4 = ["children"],
      _excluded47$4 = ["children"],
      _excluded48$4 = ["children"],
      _excluded49$4 = ["children"],
      _excluded50$4 = ["children"],
      _excluded51$4 = ["children"],
      _excluded52$4 = ["children"],
      _excluded53$4 = ["children"],
      _excluded54$4 = ["children"],
      _excluded55$4 = ["children"],
      _excluded56$4 = ["children"],
      _excluded57$4 = ["children"],
      _excluded58$4 = ["children"],
      _excluded59$4 = ["children"],
      _excluded60$4 = ["children"],
      _excluded61$4 = ["children"],
      _excluded62$4 = ["children"],
      _excluded63$4 = ["children"],
      _excluded64$4 = ["children"],
      _excluded65$4 = ["children"],
      _excluded66$4 = ["children"],
      _excluded67$4 = ["children"],
      _excluded68$4 = ["children"],
      _excluded69$4 = ["children"],
      _excluded70$4 = ["children"],
      _excluded71$4 = ["children"],
      _excluded72$4 = ["children"],
      _excluded73$4 = ["children"],
      _excluded74$4 = ["children"],
      _excluded75$4 = ["children"],
      _excluded76$4 = ["children"],
      _excluded77$4 = ["children"],
      _excluded78$4 = ["children"],
      _excluded79$4 = ["children"],
      _excluded80$4 = ["children"],
      _excluded81$4 = ["children"],
      _excluded82$4 = ["children"],
      _excluded83$4 = ["children"],
      _excluded84$4 = ["children"],
      _excluded85$4 = ["children"],
      _excluded86$4 = ["children"],
      _excluded87$4 = ["children"],
      _excluded88$4 = ["children"],
      _excluded89$4 = ["children"],
      _excluded90$4 = ["children"],
      _excluded91$4 = ["children"],
      _excluded92$4 = ["children"],
      _excluded93$4 = ["children"],
      _excluded94$4 = ["children"],
      _excluded95$4 = ["children"],
      _excluded96$4 = ["children"],
      _excluded97$4 = ["children"],
      _excluded98$4 = ["children"],
      _excluded99$4 = ["children"],
      _excluded100$4 = ["children"],
      _excluded101$4 = ["children"],
      _excluded102$4 = ["children"],
      _excluded103$4 = ["children"],
      _excluded104$4 = ["children"],
      _excluded105$4 = ["children"],
      _excluded106$4 = ["children"],
      _excluded107$4 = ["children"],
      _excluded108$4 = ["children"],
      _excluded109$4 = ["children"],
      _excluded110$4 = ["children"],
      _excluded111$4 = ["children"],
      _excluded112$4 = ["children"],
      _excluded113$4 = ["children"],
      _excluded114$4 = ["children"],
      _excluded115$4 = ["children"],
      _excluded116$4 = ["children"],
      _excluded117$4 = ["children"],
      _excluded118$4 = ["children"],
      _excluded119$3 = ["children"],
      _excluded120$3 = ["children"],
      _excluded121$3 = ["children"],
      _excluded122$3 = ["children"],
      _excluded123$3 = ["children"],
      _excluded124$3 = ["children"],
      _excluded125$3 = ["children"],
      _excluded126$3 = ["children"],
      _excluded127$3 = ["children"],
      _excluded128$3 = ["children"],
      _excluded129$3 = ["children"],
      _excluded130$3 = ["children"],
      _excluded131$3 = ["children"],
      _excluded132$3 = ["children"],
      _excluded133$3 = ["children"],
      _excluded134$3 = ["children"],
      _excluded135$3 = ["children"],
      _excluded136$3 = ["children"],
      _excluded137$3 = ["children"],
      _excluded138$3 = ["children"],
      _excluded139$3 = ["children"],
      _excluded140$3 = ["children"],
      _excluded141$3 = ["children"],
      _excluded142$3 = ["children"],
      _excluded143$3 = ["children"],
      _excluded144$3 = ["children"],
      _excluded145$3 = ["children"],
      _excluded146$3 = ["children"],
      _excluded147$3 = ["children"],
      _excluded148$3 = ["children"],
      _excluded149$3 = ["children"],
      _excluded150$3 = ["children"],
      _excluded151$3 = ["children"],
      _excluded152$3 = ["children"],
      _excluded153$3 = ["children"],
      _excluded154$3 = ["children"],
      _excluded155$3 = ["children"],
      _excluded156$3 = ["children"],
      _excluded157$3 = ["children"],
      _excluded158$3 = ["children"],
      _excluded159$3 = ["children"],
      _excluded160$3 = ["children"],
      _excluded161$3 = ["children"],
      _excluded162$3 = ["children"],
      _excluded163$3 = ["children"],
      _excluded164$3 = ["children"],
      _excluded165$3 = ["children"],
      _excluded166$3 = ["children"],
      _excluded167$3 = ["children"],
      _excluded168$3 = ["children"],
      _excluded169$3 = ["children"],
      _excluded170$3 = ["children"],
      _excluded171$3 = ["children"],
      _excluded172$3 = ["children"],
      _excluded173$3 = ["children"],
      _excluded174$3 = ["children"],
      _excluded175$3 = ["children"],
      _excluded176$3 = ["children"],
      _excluded177$3 = ["children"],
      _excluded178$3 = ["children"],
      _excluded179$3 = ["children"],
      _excluded180$3 = ["children"],
      _excluded181$3 = ["children"],
      _excluded182$3 = ["children"],
      _excluded183$3 = ["children"],
      _excluded184$3 = ["children"],
      _excluded185$3 = ["children"],
      _excluded186$3 = ["children"],
      _excluded187$3 = ["children"],
      _excluded188$3 = ["children"],
      _excluded189$3 = ["children"],
      _excluded190$3 = ["children"],
      _excluded191$3 = ["children"],
      _excluded192$3 = ["children"],
      _excluded193$3 = ["children"],
      _excluded194$3 = ["children"],
      _excluded195$3 = ["children"],
      _excluded196$3 = ["children"],
      _excluded197$3 = ["children"],
      _excluded198$3 = ["children"],
      _excluded199$3 = ["children"],
      _excluded200$3 = ["children"],
      _excluded201$3 = ["children"],
      _excluded202$3 = ["children"],
      _excluded203$3 = ["children"],
      _excluded204$3 = ["children"],
      _excluded205$3 = ["children"],
      _excluded206$3 = ["children"],
      _excluded207$3 = ["children"],
      _excluded208$3 = ["children"],
      _excluded209$3 = ["children"],
      _excluded210$3 = ["children"],
      _excluded211$3 = ["children"],
      _excluded212$3 = ["children"],
      _excluded213$3 = ["children"],
      _excluded214$3 = ["children"],
      _excluded215$3 = ["children"],
      _excluded216$3 = ["children"],
      _excluded217$3 = ["children"],
      _excluded218$3 = ["children"],
      _excluded219$3 = ["children"],
      _excluded220$3 = ["children"],
      _excluded221$3 = ["children"],
      _excluded222$3 = ["children"],
      _excluded223$3 = ["children"],
      _excluded224$3 = ["children"],
      _excluded225$3 = ["children"],
      _excluded226$3 = ["children"],
      _excluded227$3 = ["children"],
      _excluded228$3 = ["children"],
      _excluded229$3 = ["children"],
      _excluded230$3 = ["children"],
      _excluded231$3 = ["children"],
      _excluded232$3 = ["children"],
      _excluded233$3 = ["children"],
      _excluded234$3 = ["children"],
      _excluded235$3 = ["children"],
      _excluded236$3 = ["children"],
      _excluded237$3 = ["children"],
      _excluded238$3 = ["children"],
      _excluded239$3 = ["children"],
      _excluded240$3 = ["children"],
      _excluded241$3 = ["children"],
      _excluded242$3 = ["children"],
      _excluded243$3 = ["children"],
      _excluded244$3 = ["children"],
      _excluded245$3 = ["children"],
      _excluded246$3 = ["children"],
      _excluded247$3 = ["children"],
      _excluded248$3 = ["children"],
      _excluded249$3 = ["children"],
      _excluded250$3 = ["children"];
  var Term16 = /*#__PURE__*/React__default['default'].forwardRef(function Term16(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$4 || (_path$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"
    })), _circle$3 || (_circle$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "16",
      r: "2"
    })), _circle2$3 || (_circle2$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "2"
    })), _circle3$3 || (_circle3$3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "16",
      r: "2"
    })), _path2$4 || (_path2$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"
    })), children);
  });
  var Terminal32 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal32(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$4 || (_path3$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",
      transform: "translate(0 .01)"
    })), _path4$4 || (_path4$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"
    })), children);
  });
  var Terminal24 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal24(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$4 || (_path5$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",
      transform: "translate(0 .01)"
    })), _path6$4 || (_path6$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"
    })), children);
  });
  var Terminal20 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal20(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$4 || (_path7$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",
      transform: "translate(0 .01)"
    })), _path8$4 || (_path8$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"
    })), children);
  });
  var Terminal16 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal16(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$4 || (_path9$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",
      transform: "translate(0 .01)"
    })), _path10$4 || (_path10$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"
    })), children);
  });
  var Terminal_327032 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal_327032(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$4 || (_path11$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 21H16V23H10z"
    })), _path12$4 || (_path12$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z"
    })), children);
  });
  var Terminal_327024 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal_327024(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$4 || (_path13$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 21H16V23H10z"
    })), _path14$4 || (_path14$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z"
    })), children);
  });
  var Terminal_327020 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal_327020(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$4 || (_path15$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 21H16V23H10z"
    })), _path16$4 || (_path16$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z"
    })), children);
  });
  var Terminal_327016 = /*#__PURE__*/React__default['default'].forwardRef(function Terminal_327016(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$4 || (_path17$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 21H16V23H10z"
    })), _path18$4 || (_path18$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z"
    })), children);
  });
  var TextAlignCenter32 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignCenter32(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$4 || (_path19$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"
    })), children);
  });
  var TextAlignCenter24 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignCenter24(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$4 || (_path20$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"
    })), children);
  });
  var TextAlignCenter20 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignCenter20(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$4 || (_path21$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"
    })), children);
  });
  var TextAlignCenter16 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignCenter16(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$4 || (_path22$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"
    })), children);
  });
  var TextAlignJustify32 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignJustify32(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$4 || (_path23$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"
    })), children);
  });
  var TextAlignJustify24 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignJustify24(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$4 || (_path24$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"
    })), children);
  });
  var TextAlignJustify20 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignJustify20(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$4 || (_path25$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"
    })), children);
  });
  var TextAlignJustify16 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignJustify16(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$4 || (_path26$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"
    })), children);
  });
  var TextAlignLeft32 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignLeft32(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$4 || (_path27$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"
    })), children);
  });
  var TextAlignLeft24 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignLeft24(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$4 || (_path28$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"
    })), children);
  });
  var TextAlignLeft20 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignLeft20(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$4 || (_path29$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"
    })), children);
  });
  var TextAlignLeft16 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignLeft16(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$4 || (_path30$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"
    })), children);
  });
  var TextAlignMixed32 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignMixed32(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$4 || (_path31$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H9V6h5V8H10a2 2 0 00-2 2v2a2 2 0 002 2h6V6A2.0023 2.0023 0 0014 4zm0 8H10V10h4zM22 26L22 18 20 18 20 19 18 19 18 21 20 21 20 26 18 26 18 28 24 28 24 26 22 26zM2 2H4V16H2zM28 16H30V30H28z"
    })), children);
  });
  var TextAlignMixed24 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignMixed24(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$4 || (_path32$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H9V6h5V8H10a2 2 0 00-2 2v2a2 2 0 002 2h6V6A2.0023 2.0023 0 0014 4zm0 8H10V10h4zM22 26L22 18 20 18 20 19 18 19 18 21 20 21 20 26 18 26 18 28 24 28 24 26 22 26zM2 2H4V16H2zM28 16H30V30H28z"
    })), children);
  });
  var TextAlignMixed20 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignMixed20(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$4 || (_path33$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H9V6h5V8H10a2 2 0 00-2 2v2a2 2 0 002 2h6V6A2.0023 2.0023 0 0014 4zm0 8H10V10h4zM22 26L22 18 20 18 20 19 18 19 18 21 20 21 20 26 18 26 18 28 24 28 24 26 22 26zM2 2H4V16H2zM28 16H30V30H28z"
    })), children);
  });
  var TextAlignMixed16 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignMixed16(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$4 || (_path34$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 4H9V6h5V8H10a2 2 0 00-2 2v2a2 2 0 002 2h6V6A2.0023 2.0023 0 0014 4zm0 8H10V10h4zM22 26L22 18 20 18 20 19 18 19 18 21 20 21 20 26 18 26 18 28 24 28 24 26 22 26zM2 2H4V16H2zM28 16H30V30H28z"
    })), children);
  });
  var TextAlignRight32 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignRight32(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$4 || (_path35$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"
    })), children);
  });
  var TextAlignRight24 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignRight24(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$4 || (_path36$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"
    })), children);
  });
  var TextAlignRight20 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignRight20(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$4 || (_path37$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"
    })), children);
  });
  var TextAlignRight16 = /*#__PURE__*/React__default['default'].forwardRef(function TextAlignRight16(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$4 || (_path38$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"
    })), children);
  });
  var TextAllCaps32 = /*#__PURE__*/React__default['default'].forwardRef(function TextAllCaps32(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$4 || (_path39$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"
    })), children);
  });
  var TextAllCaps24 = /*#__PURE__*/React__default['default'].forwardRef(function TextAllCaps24(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$4 || (_path40$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"
    })), children);
  });
  var TextAllCaps20 = /*#__PURE__*/React__default['default'].forwardRef(function TextAllCaps20(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$4 || (_path41$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"
    })), children);
  });
  var TextAllCaps16 = /*#__PURE__*/React__default['default'].forwardRef(function TextAllCaps16(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$4 || (_path42$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"
    })), children);
  });
  var TextBold32 = /*#__PURE__*/React__default['default'].forwardRef(function TextBold32(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$4 || (_path43$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"
    })), children);
  });
  var TextBold24 = /*#__PURE__*/React__default['default'].forwardRef(function TextBold24(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$4 || (_path44$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"
    })), children);
  });
  var TextBold20 = /*#__PURE__*/React__default['default'].forwardRef(function TextBold20(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$4 || (_path45$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"
    })), children);
  });
  var TextBold16 = /*#__PURE__*/React__default['default'].forwardRef(function TextBold16(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$4 || (_path46$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"
    })), children);
  });
  var TextClearFormat32 = /*#__PURE__*/React__default['default'].forwardRef(function TextClearFormat32(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$4 || (_path47$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4384,16.5715l-7.985-7.9856a2.0014,2.0014,0,0,0-2.8291,0l-5.3584,5.3584L9,2H7L2,16H4l.999-3h6l.8035,2.4077L4.5858,22.6244a2,2,0,0,0,0,2.8282L9.1316,30h9.5908l10.716-10.717A1.9173,1.9173,0,0,0,29.4384,16.5715ZM5.6653,11l2.331-7,2.3355,7Zm12.229,17H9.96L6,24.0381l6.3123-6.3115L20.24,25.6538Zm3.76-3.76-7.9275-7.9272L20.0393,10l7.9268,7.9272Z"
    })), children);
  });
  var TextClearFormat24 = /*#__PURE__*/React__default['default'].forwardRef(function TextClearFormat24(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$4 || (_path48$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4384,16.5715l-7.985-7.9856a2.0014,2.0014,0,0,0-2.8291,0l-5.3584,5.3584L9,2H7L2,16H4l.999-3h6l.8035,2.4077L4.5858,22.6244a2,2,0,0,0,0,2.8282L9.1316,30h9.5908l10.716-10.717A1.9173,1.9173,0,0,0,29.4384,16.5715ZM5.6653,11l2.331-7,2.3355,7Zm12.229,17H9.96L6,24.0381l6.3123-6.3115L20.24,25.6538Zm3.76-3.76-7.9275-7.9272L20.0393,10l7.9268,7.9272Z"
    })), children);
  });
  var TextClearFormat20 = /*#__PURE__*/React__default['default'].forwardRef(function TextClearFormat20(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$4 || (_path49$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4384,16.5715l-7.985-7.9856a2.0014,2.0014,0,0,0-2.8291,0l-5.3584,5.3584L9,2H7L2,16H4l.999-3h6l.8035,2.4077L4.5858,22.6244a2,2,0,0,0,0,2.8282L9.1316,30h9.5908l10.716-10.717A1.9173,1.9173,0,0,0,29.4384,16.5715ZM5.6653,11l2.331-7,2.3355,7Zm12.229,17H9.96L6,24.0381l6.3123-6.3115L20.24,25.6538Zm3.76-3.76-7.9275-7.9272L20.0393,10l7.9268,7.9272Z"
    })), children);
  });
  var TextClearFormat16 = /*#__PURE__*/React__default['default'].forwardRef(function TextClearFormat16(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$4 || (_path50$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4384,16.5715l-7.985-7.9856a2.0014,2.0014,0,0,0-2.8291,0l-5.3584,5.3584L9,2H7L2,16H4l.999-3h6l.8035,2.4077L4.5858,22.6244a2,2,0,0,0,0,2.8282L9.1316,30h9.5908l10.716-10.717A1.9173,1.9173,0,0,0,29.4384,16.5715ZM5.6653,11l2.331-7,2.3355,7Zm12.229,17H9.96L6,24.0381l6.3123-6.3115L20.24,25.6538Zm3.76-3.76-7.9275-7.9272L20.0393,10l7.9268,7.9272Z"
    })), children);
  });
  var TextColor32 = /*#__PURE__*/React__default['default'].forwardRef(function TextColor32(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$4 || (_path51$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"
    })), children);
  });
  var TextColor24 = /*#__PURE__*/React__default['default'].forwardRef(function TextColor24(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$4 || (_path52$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"
    })), children);
  });
  var TextColor20 = /*#__PURE__*/React__default['default'].forwardRef(function TextColor20(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$4 || (_path53$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"
    })), children);
  });
  var TextColor16 = /*#__PURE__*/React__default['default'].forwardRef(function TextColor16(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$4 || (_path54$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"
    })), children);
  });
  var TextCreation32 = /*#__PURE__*/React__default['default'].forwardRef(function TextCreation32(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$4 || (_path55$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), _path56$4 || (_path56$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"
    })), children);
  });
  var TextCreation24 = /*#__PURE__*/React__default['default'].forwardRef(function TextCreation24(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$4 || (_path57$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), _path58$4 || (_path58$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"
    })), children);
  });
  var TextCreation20 = /*#__PURE__*/React__default['default'].forwardRef(function TextCreation20(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$4 || (_path59$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), _path60$4 || (_path60$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"
    })), children);
  });
  var TextCreation16 = /*#__PURE__*/React__default['default'].forwardRef(function TextCreation16(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$4 || (_path61$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"
    })), _path62$4 || (_path62$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"
    })), children);
  });
  var TextFill32 = /*#__PURE__*/React__default['default'].forwardRef(function TextFill32(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$4 || (_path63$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V30H4z"
    })), _path64$4 || (_path64$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"
    })), children);
  });
  var TextFill24 = /*#__PURE__*/React__default['default'].forwardRef(function TextFill24(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$4 || (_path65$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V30H4z"
    })), _path66$4 || (_path66$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"
    })), children);
  });
  var TextFill20 = /*#__PURE__*/React__default['default'].forwardRef(function TextFill20(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$4 || (_path67$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V30H4z"
    })), _path68$4 || (_path68$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"
    })), children);
  });
  var TextFill16 = /*#__PURE__*/React__default['default'].forwardRef(function TextFill16(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$4 || (_path69$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V30H4z"
    })), _path70$4 || (_path70$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"
    })), children);
  });
  var TextFont32 = /*#__PURE__*/React__default['default'].forwardRef(function TextFont32(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$4 || (_path71$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var TextFont24 = /*#__PURE__*/React__default['default'].forwardRef(function TextFont24(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$4 || (_path72$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var TextFont20 = /*#__PURE__*/React__default['default'].forwardRef(function TextFont20(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$4 || (_path73$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var TextFont16 = /*#__PURE__*/React__default['default'].forwardRef(function TextFont16(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$4 || (_path74$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 12H20v2h5a1.0008 1.0008 0 011 1v2H22a3.0033 3.0033 0 00-3 3v1a3.0033 3.0033 0 003 3h6V15A3.0033 3.0033 0 0025 12zM22 22a1.0008 1.0008 0 01-1-1V20a1.0008 1.0008 0 011-1h4v3zM16 24h2L12 7H10L4 24H6l1.6936-5h6.6135zM8.3711 17l2.4966-7.3711.2668.0005L13.63 17z"
    })), children);
  });
  var TextFootnote32 = /*#__PURE__*/React__default['default'].forwardRef(function TextFootnote32(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$4 || (_path75$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 7L2 9 9 9 9 25 11 25 11 9 18 9 18 7 2 7zM30 11.076L29.256 9.219 26 10.522 26 7 24 7 24 10.523 20.744 9.22 20 11.077 23.417 12.444 20.9 15.8 22.5 17 25 13.667 27.5 17 29.1 15.8 26.583 12.443 30 11.076z"
    })), children);
  });
  var TextFootnote24 = /*#__PURE__*/React__default['default'].forwardRef(function TextFootnote24(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$4 || (_path76$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 7L2 9 9 9 9 25 11 25 11 9 18 9 18 7 2 7zM30 11.076L29.256 9.219 26 10.522 26 7 24 7 24 10.523 20.744 9.22 20 11.077 23.417 12.444 20.9 15.8 22.5 17 25 13.667 27.5 17 29.1 15.8 26.583 12.443 30 11.076z"
    })), children);
  });
  var TextFootnote20 = /*#__PURE__*/React__default['default'].forwardRef(function TextFootnote20(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$4 || (_path77$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 7L2 9 9 9 9 25 11 25 11 9 18 9 18 7 2 7zM30 11.076L29.256 9.219 26 10.522 26 7 24 7 24 10.523 20.744 9.22 20 11.077 23.417 12.444 20.9 15.8 22.5 17 25 13.667 27.5 17 29.1 15.8 26.583 12.443 30 11.076z"
    })), children);
  });
  var TextFootnote16 = /*#__PURE__*/React__default['default'].forwardRef(function TextFootnote16(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$4 || (_path78$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 7L2 9 9 9 9 25 11 25 11 9 18 9 18 7 2 7zM30 11.076L29.256 9.219 26 10.522 26 7 24 7 24 10.523 20.744 9.22 20 11.077 23.417 12.444 20.9 15.8 22.5 17 25 13.667 27.5 17 29.1 15.8 26.583 12.443 30 11.076z"
    })), children);
  });
  var TextHighlight32 = /*#__PURE__*/React__default['default'].forwardRef(function TextHighlight32(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$4 || (_path79$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H5a3 3 0 01-3-3V10A3 3 0 015 7h5V5A1 1 0 009 4H3V2H9a3 3 0 013 3zM5 9a1 1 0 00-1 1v2a1 1 0 001 1h5V9zM20 23v2a1 1 0 001 1h5V22H21A1 1 0 0020 23z"
    })), _path80$4 || (_path80$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"
    })), children);
  });
  var TextHighlight24 = /*#__PURE__*/React__default['default'].forwardRef(function TextHighlight24(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$4 || (_path81$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H5a3 3 0 01-3-3V10A3 3 0 015 7h5V5A1 1 0 009 4H3V2H9a3 3 0 013 3zM5 9a1 1 0 00-1 1v2a1 1 0 001 1h5V9zM20 23v2a1 1 0 001 1h5V22H21A1 1 0 0020 23z"
    })), _path82$4 || (_path82$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"
    })), children);
  });
  var TextHighlight20 = /*#__PURE__*/React__default['default'].forwardRef(function TextHighlight20(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$4 || (_path83$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H5a3 3 0 01-3-3V10A3 3 0 015 7h5V5A1 1 0 009 4H3V2H9a3 3 0 013 3zM5 9a1 1 0 00-1 1v2a1 1 0 001 1h5V9zM20 23v2a1 1 0 001 1h5V22H21A1 1 0 0020 23z"
    })), _path84$4 || (_path84$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"
    })), children);
  });
  var TextHighlight16 = /*#__PURE__*/React__default['default'].forwardRef(function TextHighlight16(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$4 || (_path85$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15H5a3 3 0 01-3-3V10A3 3 0 015 7h5V5A1 1 0 009 4H3V2H9a3 3 0 013 3zM5 9a1 1 0 00-1 1v2a1 1 0 001 1h5V9zM20 23v2a1 1 0 001 1h5V22H21A1 1 0 0020 23z"
    })), _path86$4 || (_path86$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"
    })), children);
  });
  var TextIndent32 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndent32(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$4 || (_path87$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"
    })), children);
  });
  var TextIndent24 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndent24(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$4 || (_path88$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"
    })), children);
  });
  var TextIndent20 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndent20(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$4 || (_path89$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"
    })), children);
  });
  var TextIndent16 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndent16(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$4 || (_path90$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"
    })), children);
  });
  var TextIndentLess32 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentLess32(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$4 || (_path91$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"
    })), children);
  });
  var TextIndentLess24 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentLess24(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$4 || (_path92$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"
    })), children);
  });
  var TextIndentLess20 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentLess20(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$4 || (_path93$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"
    })), children);
  });
  var TextIndentLess16 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentLess16(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$4 || (_path94$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"
    })), children);
  });
  var TextIndentMore32 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentMore32(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$4 || (_path95$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"
    })), children);
  });
  var TextIndentMore24 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentMore24(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$4 || (_path96$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"
    })), children);
  });
  var TextIndentMore20 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentMore20(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$4 || (_path97$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"
    })), children);
  });
  var TextIndentMore16 = /*#__PURE__*/React__default['default'].forwardRef(function TextIndentMore16(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$4 || (_path98$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"
    })), children);
  });
  var TextItalic32 = /*#__PURE__*/React__default['default'].forwardRef(function TextItalic32(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$4 || (_path99$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"
    })), children);
  });
  var TextItalic24 = /*#__PURE__*/React__default['default'].forwardRef(function TextItalic24(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$4 || (_path100$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"
    })), children);
  });
  var TextItalic20 = /*#__PURE__*/React__default['default'].forwardRef(function TextItalic20(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$4 || (_path101$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"
    })), children);
  });
  var TextItalic16 = /*#__PURE__*/React__default['default'].forwardRef(function TextItalic16(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$4 || (_path102$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"
    })), children);
  });
  var TextKerning32 = /*#__PURE__*/React__default['default'].forwardRef(function TextKerning32(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$4 || (_path103$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"
    })), children);
  });
  var TextKerning24 = /*#__PURE__*/React__default['default'].forwardRef(function TextKerning24(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$4 || (_path104$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"
    })), children);
  });
  var TextKerning20 = /*#__PURE__*/React__default['default'].forwardRef(function TextKerning20(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$4 || (_path105$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"
    })), children);
  });
  var TextKerning16 = /*#__PURE__*/React__default['default'].forwardRef(function TextKerning16(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106$4 || (_path106$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"
    })), children);
  });
  var TextLeading32 = /*#__PURE__*/React__default['default'].forwardRef(function TextLeading32(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$4 || (_path107$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"
    })), children);
  });
  var TextLeading24 = /*#__PURE__*/React__default['default'].forwardRef(function TextLeading24(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$4 || (_path108$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"
    })), children);
  });
  var TextLeading20 = /*#__PURE__*/React__default['default'].forwardRef(function TextLeading20(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$4 || (_path109$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"
    })), children);
  });
  var TextLeading16 = /*#__PURE__*/React__default['default'].forwardRef(function TextLeading16(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$4 || (_path110$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"
    })), children);
  });
  var TextLineSpacing32 = /*#__PURE__*/React__default['default'].forwardRef(function TextLineSpacing32(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$4 || (_path111$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"
    })), children);
  });
  var TextLineSpacing24 = /*#__PURE__*/React__default['default'].forwardRef(function TextLineSpacing24(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$4 || (_path112$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"
    })), children);
  });
  var TextLineSpacing20 = /*#__PURE__*/React__default['default'].forwardRef(function TextLineSpacing20(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$4 || (_path113$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"
    })), children);
  });
  var TextLineSpacing16 = /*#__PURE__*/React__default['default'].forwardRef(function TextLineSpacing16(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$4 || (_path114$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"
    })), children);
  });
  var TextNewLine32 = /*#__PURE__*/React__default['default'].forwardRef(function TextNewLine32(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$4 || (_path115$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"
    })), children);
  });
  var TextNewLine24 = /*#__PURE__*/React__default['default'].forwardRef(function TextNewLine24(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$4 || (_path116$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"
    })), children);
  });
  var TextNewLine20 = /*#__PURE__*/React__default['default'].forwardRef(function TextNewLine20(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$4 || (_path117$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"
    })), children);
  });
  var TextNewLine16 = /*#__PURE__*/React__default['default'].forwardRef(function TextNewLine16(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$4 || (_path118$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"
    })), children);
  });
  var TextScale32 = /*#__PURE__*/React__default['default'].forwardRef(function TextScale32(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$4 || (_path119$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"
    })), _path120$4 || (_path120$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"
    })), children);
  });
  var TextScale24 = /*#__PURE__*/React__default['default'].forwardRef(function TextScale24(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$4 || (_path121$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"
    })), _path122$4 || (_path122$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"
    })), children);
  });
  var TextScale20 = /*#__PURE__*/React__default['default'].forwardRef(function TextScale20(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$4 || (_path123$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"
    })), _path124$4 || (_path124$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"
    })), children);
  });
  var TextScale16 = /*#__PURE__*/React__default['default'].forwardRef(function TextScale16(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$4 || (_path125$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"
    })), _path126$4 || (_path126$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"
    })), children);
  });
  var TextSelection32 = /*#__PURE__*/React__default['default'].forwardRef(function TextSelection32(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$4 || (_path127$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 27H21a3 3 0 01-3-3V22a3 3 0 013-3h5V17a1 1 0 00-1-1H19V14h6a3 3 0 013 3zm-7-6a1 1 0 00-1 1v2a1 1 0 001 1h5V21zM13 7h3V5H13a4 4 0 00-3 1.38A4 4 0 007 5H4V7H7A2 2 0 019 9v5H5v2H9v7a2 2 0 01-2 2H4v2H7a4 4 0 003-1.38A4 4 0 0013 27h3V25H13a2 2 0 01-2-2V16h4V14H11V9A2 2 0 0113 7z"
    })), children);
  });
  var TextSelection24 = /*#__PURE__*/React__default['default'].forwardRef(function TextSelection24(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$4 || (_path128$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 27H21a3 3 0 01-3-3V22a3 3 0 013-3h5V17a1 1 0 00-1-1H19V14h6a3 3 0 013 3zm-7-6a1 1 0 00-1 1v2a1 1 0 001 1h5V21zM13 7h3V5H13a4 4 0 00-3 1.38A4 4 0 007 5H4V7H7A2 2 0 019 9v5H5v2H9v7a2 2 0 01-2 2H4v2H7a4 4 0 003-1.38A4 4 0 0013 27h3V25H13a2 2 0 01-2-2V16h4V14H11V9A2 2 0 0113 7z"
    })), children);
  });
  var TextSelection20 = /*#__PURE__*/React__default['default'].forwardRef(function TextSelection20(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$4 || (_path129$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 27H21a3 3 0 01-3-3V22a3 3 0 013-3h5V17a1 1 0 00-1-1H19V14h6a3 3 0 013 3zm-7-6a1 1 0 00-1 1v2a1 1 0 001 1h5V21zM13 7h3V5H13a4 4 0 00-3 1.38A4 4 0 007 5H4V7H7A2 2 0 019 9v5H5v2H9v7a2 2 0 01-2 2H4v2H7a4 4 0 003-1.38A4 4 0 0013 27h3V25H13a2 2 0 01-2-2V16h4V14H11V9A2 2 0 0113 7z"
    })), children);
  });
  var TextSelection16 = /*#__PURE__*/React__default['default'].forwardRef(function TextSelection16(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$4 || (_path130$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 27H21a3 3 0 01-3-3V22a3 3 0 013-3h5V17a1 1 0 00-1-1H19V14h6a3 3 0 013 3zm-7-6a1 1 0 00-1 1v2a1 1 0 001 1h5V21zM13 7h3V5H13a4 4 0 00-3 1.38A4 4 0 007 5H4V7H7A2 2 0 019 9v5H5v2H9v7a2 2 0 01-2 2H4v2H7a4 4 0 003-1.38A4 4 0 0013 27h3V25H13a2 2 0 01-2-2V16h4V14H11V9A2 2 0 0113 7z"
    })), children);
  });
  var TextSmallCaps32 = /*#__PURE__*/React__default['default'].forwardRef(function TextSmallCaps32(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$4 || (_path131$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"
    })), _path132$4 || (_path132$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"
    })), children);
  });
  var TextSmallCaps24 = /*#__PURE__*/React__default['default'].forwardRef(function TextSmallCaps24(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133$4 || (_path133$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"
    })), _path134$4 || (_path134$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"
    })), children);
  });
  var TextSmallCaps20 = /*#__PURE__*/React__default['default'].forwardRef(function TextSmallCaps20(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$4 || (_path135$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"
    })), _path136$4 || (_path136$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"
    })), children);
  });
  var TextSmallCaps16 = /*#__PURE__*/React__default['default'].forwardRef(function TextSmallCaps16(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$4 || (_path137$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"
    })), _path138$4 || (_path138$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"
    })), children);
  });
  var TextStrikethrough32 = /*#__PURE__*/React__default['default'].forwardRef(function TextStrikethrough32(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139$4 || (_path139$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"
    })), children);
  });
  var TextStrikethrough24 = /*#__PURE__*/React__default['default'].forwardRef(function TextStrikethrough24(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$4 || (_path140$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"
    })), children);
  });
  var TextStrikethrough20 = /*#__PURE__*/React__default['default'].forwardRef(function TextStrikethrough20(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$4 || (_path141$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"
    })), children);
  });
  var TextStrikethrough16 = /*#__PURE__*/React__default['default'].forwardRef(function TextStrikethrough16(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$4 || (_path142$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"
    })), children);
  });
  var TextSubscript32 = /*#__PURE__*/React__default['default'].forwardRef(function TextSubscript32(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$4 || (_path143$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"
    })), children);
  });
  var TextSubscript24 = /*#__PURE__*/React__default['default'].forwardRef(function TextSubscript24(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$4 || (_path144$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"
    })), children);
  });
  var TextSubscript20 = /*#__PURE__*/React__default['default'].forwardRef(function TextSubscript20(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$4 || (_path145$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"
    })), children);
  });
  var TextSubscript16 = /*#__PURE__*/React__default['default'].forwardRef(function TextSubscript16(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$4 || (_path146$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"
    })), children);
  });
  var TextSuperscript32 = /*#__PURE__*/React__default['default'].forwardRef(function TextSuperscript32(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$4 || (_path147$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"
    })), children);
  });
  var TextSuperscript24 = /*#__PURE__*/React__default['default'].forwardRef(function TextSuperscript24(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$4 || (_path148$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"
    })), children);
  });
  var TextSuperscript20 = /*#__PURE__*/React__default['default'].forwardRef(function TextSuperscript20(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$4 || (_path149$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"
    })), children);
  });
  var TextSuperscript16 = /*#__PURE__*/React__default['default'].forwardRef(function TextSuperscript16(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$4 || (_path150$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"
    })), children);
  });
  var TextTracking32 = /*#__PURE__*/React__default['default'].forwardRef(function TextTracking32(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$4 || (_path151$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"
    })), children);
  });
  var TextTracking24 = /*#__PURE__*/React__default['default'].forwardRef(function TextTracking24(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$4 || (_path152$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"
    })), children);
  });
  var TextTracking20 = /*#__PURE__*/React__default['default'].forwardRef(function TextTracking20(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$4 || (_path153$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"
    })), children);
  });
  var TextTracking16 = /*#__PURE__*/React__default['default'].forwardRef(function TextTracking16(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path154$4 || (_path154$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"
    })), children);
  });
  var TextUnderline32 = /*#__PURE__*/React__default['default'].forwardRef(function TextUnderline32(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$4 || (_path155$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM16 23a7 7 0 01-7-7V5h2V16a5 5 0 0010 0V5h2V16A7 7 0 0116 23z"
    })), children);
  });
  var TextUnderline24 = /*#__PURE__*/React__default['default'].forwardRef(function TextUnderline24(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path156$4 || (_path156$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM16 23a7 7 0 01-7-7V5h2V16a5 5 0 0010 0V5h2V16A7 7 0 0116 23z"
    })), children);
  });
  var TextUnderline20 = /*#__PURE__*/React__default['default'].forwardRef(function TextUnderline20(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$4 || (_path157$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM16 23a7 7 0 01-7-7V5h2V16a5 5 0 0010 0V5h2V16A7 7 0 0116 23z"
    })), children);
  });
  var TextUnderline16 = /*#__PURE__*/React__default['default'].forwardRef(function TextUnderline16(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$4 || (_path158$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM16 23a7 7 0 01-7-7V5h2V16a5 5 0 0010 0V5h2V16A7 7 0 0116 23z"
    })), children);
  });
  var TextVerticalAlignment32 = /*#__PURE__*/React__default['default'].forwardRef(function TextVerticalAlignment32(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$4 || (_path159$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H30V30H16zM16 23H30V25H16zM10.8458 30H13L8.64 20H6.36L2 30H4.1542l.8-2h5.0916zM5.7541 26L7.5 21.6347 9.2459 26zM2 15H30V17H2zM16 7H30V9H16zM16 2H30V4H16zM10.8458 12H13L8.64 2H6.36L2 12H4.1542l.8-2h5.0916zM5.7541 8L7.5 3.6347 9.2459 8z"
    })), children);
  });
  var TextVerticalAlignment24 = /*#__PURE__*/React__default['default'].forwardRef(function TextVerticalAlignment24(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path160$4 || (_path160$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H30V30H16zM16 23H30V25H16zM10.8458 30H13L8.64 20H6.36L2 30H4.1542l.8-2h5.0916zM5.7541 26L7.5 21.6347 9.2459 26zM2 15H30V17H2zM16 7H30V9H16zM16 2H30V4H16zM10.8458 12H13L8.64 2H6.36L2 12H4.1542l.8-2h5.0916zM5.7541 8L7.5 3.6347 9.2459 8z"
    })), children);
  });
  var TextVerticalAlignment20 = /*#__PURE__*/React__default['default'].forwardRef(function TextVerticalAlignment20(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$4 || (_path161$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H30V30H16zM16 23H30V25H16zM10.8458 30H13L8.64 20H6.36L2 30H4.1542l.8-2h5.0916zM5.7541 26L7.5 21.6347 9.2459 26zM2 15H30V17H2zM16 7H30V9H16zM16 2H30V4H16zM10.8458 12H13L8.64 2H6.36L2 12H4.1542l.8-2h5.0916zM5.7541 8L7.5 3.6347 9.2459 8z"
    })), children);
  });
  var TextVerticalAlignment16 = /*#__PURE__*/React__default['default'].forwardRef(function TextVerticalAlignment16(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path162$4 || (_path162$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 28H30V30H16zM16 23H30V25H16zM10.8458 30H13L8.64 20H6.36L2 30H4.1542l.8-2h5.0916zM5.7541 26L7.5 21.6347 9.2459 26zM2 15H30V17H2zM16 7H30V9H16zM16 2H30V4H16zM10.8458 12H13L8.64 2H6.36L2 12H4.1542l.8-2h5.0916zM5.7541 8L7.5 3.6347 9.2459 8z"
    })), children);
  });
  var TextWrap32 = /*#__PURE__*/React__default['default'].forwardRef(function TextWrap32(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$4 || (_path163$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 010 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 00-.01-11zM4 5H28V7H4z"
    })), children);
  });
  var TextWrap24 = /*#__PURE__*/React__default['default'].forwardRef(function TextWrap24(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$4 || (_path164$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 010 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 00-.01-11zM4 5H28V7H4z"
    })), children);
  });
  var TextWrap20 = /*#__PURE__*/React__default['default'].forwardRef(function TextWrap20(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$4 || (_path165$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 010 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 00-.01-11zM4 5H28V7H4z"
    })), children);
  });
  var TextWrap16 = /*#__PURE__*/React__default['default'].forwardRef(function TextWrap16(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$4 || (_path166$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 010 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 00-.01-11zM4 5H28V7H4z"
    })), children);
  });
  var WatsonHealthTextAnnotationToggle32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthTextAnnotationToggle32(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$4 || (_path167$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.537 13.76L26.24 10.463a1.5862 1.5862 0 00-2.24 0L10 24.4674V30h5.5326L29.537 16a1.5862 1.5862 0 000-2.24zM14.7042 28H12V25.2958l9.4409-9.4409 2.7042 2.7042zM25.5591 17.145L22.855 14.4409l2.2672-2.2672 2.7042 2.7042zM11 17L13 17 13 10 16 10 16 8 8 8 8 10 11 10 11 17z"
    })), _path168$4 || (_path168$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,20H4V4H20V8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2H8Z"
    })), children);
  });
  var WatsonHealthTextAnnotationToggle24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthTextAnnotationToggle24(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$4 || (_path169$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.537 13.76L26.24 10.463a1.5862 1.5862 0 00-2.24 0L10 24.4674V30h5.5326L29.537 16a1.5862 1.5862 0 000-2.24zM14.7042 28H12V25.2958l9.4409-9.4409 2.7042 2.7042zM25.5591 17.145L22.855 14.4409l2.2672-2.2672 2.7042 2.7042zM11 17L13 17 13 10 16 10 16 8 8 8 8 10 11 10 11 17z"
    })), _path170$4 || (_path170$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,20H4V4H20V8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2H8Z"
    })), children);
  });
  var WatsonHealthTextAnnotationToggle20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthTextAnnotationToggle20(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$4 || (_path171$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.537 13.76L26.24 10.463a1.5862 1.5862 0 00-2.24 0L10 24.4674V30h5.5326L29.537 16a1.5862 1.5862 0 000-2.24zM14.7042 28H12V25.2958l9.4409-9.4409 2.7042 2.7042zM25.5591 17.145L22.855 14.4409l2.2672-2.2672 2.7042 2.7042zM11 17L13 17 13 10 16 10 16 8 8 8 8 10 11 10 11 17z"
    })), _path172$4 || (_path172$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,20H4V4H20V8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2H8Z"
    })), children);
  });
  var WatsonHealthTextAnnotationToggle16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthTextAnnotationToggle16(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$4 || (_path173$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.537 13.76L26.24 10.463a1.5862 1.5862 0 00-2.24 0L10 24.4674V30h5.5326L29.537 16a1.5862 1.5862 0 000-2.24zM14.7042 28H12V25.2958l9.4409-9.4409 2.7042 2.7042zM25.5591 17.145L22.855 14.4409l2.2672-2.2672 2.7042 2.7042zM11 17L13 17 13 10 16 10 16 8 8 8 8 10 11 10 11 17z"
    })), _path174$4 || (_path174$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,20H4V4H20V8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V20a2,2,0,0,0,2,2H8Z"
    })), children);
  });
  var TextLink32 = /*#__PURE__*/React__default['default'].forwardRef(function TextLink32(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$4 || (_path175$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"
    })), _path176$4 || (_path176$4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.2642 29.9971A5.2619 5.2619 0 016.542 21.0137l6.03-6.03a5.2636 5.2636 0 117.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 10-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 004.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0110.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"
    })), children);
  });
  var TextLink24 = /*#__PURE__*/React__default['default'].forwardRef(function TextLink24(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177$3 || (_path177$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"
    })), _path178$3 || (_path178$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.2642 29.9971A5.2619 5.2619 0 016.542 21.0137l6.03-6.03a5.2636 5.2636 0 117.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 10-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 004.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0110.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"
    })), children);
  });
  var TextLink20 = /*#__PURE__*/React__default['default'].forwardRef(function TextLink20(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179$3 || (_path179$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"
    })), _path180$3 || (_path180$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.2642 29.9971A5.2619 5.2619 0 016.542 21.0137l6.03-6.03a5.2636 5.2636 0 117.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 10-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 004.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0110.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"
    })), children);
  });
  var TextLink16 = /*#__PURE__*/React__default['default'].forwardRef(function TextLink16(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181$3 || (_path181$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"
    })), _path182$3 || (_path182$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.2642 29.9971A5.2619 5.2619 0 016.542 21.0137l6.03-6.03a5.2636 5.2636 0 117.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 10-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 004.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0110.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"
    })), children);
  });
  var TextLinkAnalysis32 = /*#__PURE__*/React__default['default'].forwardRef(function TextLinkAnalysis32(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183$3 || (_path183$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"
    })), _path184$3 || (_path184$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), children);
  });
  var TextLinkAnalysis24 = /*#__PURE__*/React__default['default'].forwardRef(function TextLinkAnalysis24(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$3 || (_path185$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"
    })), _path186$3 || (_path186$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), children);
  });
  var TextLinkAnalysis20 = /*#__PURE__*/React__default['default'].forwardRef(function TextLinkAnalysis20(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$3 || (_path187$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"
    })), _path188$3 || (_path188$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), children);
  });
  var TextLinkAnalysis16 = /*#__PURE__*/React__default['default'].forwardRef(function TextLinkAnalysis16(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189$3 || (_path189$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"
    })), _path190$3 || (_path190$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"
    })), children);
  });
  var TextMining32 = /*#__PURE__*/React__default['default'].forwardRef(function TextMining32(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191$3 || (_path191$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"
    })), _path192$3 || (_path192$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), children);
  });
  var TextMining24 = /*#__PURE__*/React__default['default'].forwardRef(function TextMining24(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193$3 || (_path193$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"
    })), _path194$3 || (_path194$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), children);
  });
  var TextMining20 = /*#__PURE__*/React__default['default'].forwardRef(function TextMining20(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$3 || (_path195$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"
    })), _path196$3 || (_path196$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), children);
  });
  var TextMining16 = /*#__PURE__*/React__default['default'].forwardRef(function TextMining16(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$3 || (_path197$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"
    })), _path198$3 || (_path198$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), children);
  });
  var TextMiningApplier32 = /*#__PURE__*/React__default['default'].forwardRef(function TextMiningApplier32(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$3 || (_path199$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), _path200$3 || (_path200$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19L27 24 20 29 20 19z"
    })), children);
  });
  var TextMiningApplier24 = /*#__PURE__*/React__default['default'].forwardRef(function TextMiningApplier24(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$3 || (_path201$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), _path202$3 || (_path202$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19L27 24 20 29 20 19z"
    })), children);
  });
  var TextMiningApplier20 = /*#__PURE__*/React__default['default'].forwardRef(function TextMiningApplier20(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$3 || (_path203$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), _path204$3 || (_path204$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19L27 24 20 29 20 19z"
    })), children);
  });
  var TextMiningApplier16 = /*#__PURE__*/React__default['default'].forwardRef(function TextMiningApplier16(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$3 || (_path205$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"
    })), _path206$3 || (_path206$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 19L27 24 20 29 20 19z"
    })), children);
  });
  var Theater32 = /*#__PURE__*/React__default['default'].forwardRef(function Theater32(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$3 || (_path207$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0120 25zM24 14a2 2 0 102 2A1.9806 1.9806 0 0024 14zM16 14a2 2 0 102 2A1.9806 1.9806 0 0016 14z"
    })), _path208$3 || (_path208$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V14a10.01,10.01,0,0,0,8.8027,9.9214A9.9989,9.9989,0,0,0,30,20V10A2.0023,2.0023,0,0,0,28,8ZM4,14V4H20V8H12a2.0023,2.0023,0,0,0-2,2V20a9.9628,9.9628,0,0,0,.168,1.78A8.0081,8.0081,0,0,1,4,14Zm24,6a8,8,0,0,1-16,0V10H28Z"
    })), children);
  });
  var Theater24 = /*#__PURE__*/React__default['default'].forwardRef(function Theater24(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209$3 || (_path209$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0120 25zM24 14a2 2 0 102 2A1.9806 1.9806 0 0024 14zM16 14a2 2 0 102 2A1.9806 1.9806 0 0016 14z"
    })), _path210$3 || (_path210$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V14a10.01,10.01,0,0,0,8.8027,9.9214A9.9989,9.9989,0,0,0,30,20V10A2.0023,2.0023,0,0,0,28,8ZM4,14V4H20V8H12a2.0023,2.0023,0,0,0-2,2V20a9.9628,9.9628,0,0,0,.168,1.78A8.0081,8.0081,0,0,1,4,14Zm24,6a8,8,0,0,1-16,0V10H28Z"
    })), children);
  });
  var Theater20 = /*#__PURE__*/React__default['default'].forwardRef(function Theater20(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211$3 || (_path211$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0120 25zM24 14a2 2 0 102 2A1.9806 1.9806 0 0024 14zM16 14a2 2 0 102 2A1.9806 1.9806 0 0016 14z"
    })), _path212$3 || (_path212$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V14a10.01,10.01,0,0,0,8.8027,9.9214A9.9989,9.9989,0,0,0,30,20V10A2.0023,2.0023,0,0,0,28,8ZM4,14V4H20V8H12a2.0023,2.0023,0,0,0-2,2V20a9.9628,9.9628,0,0,0,.168,1.78A8.0081,8.0081,0,0,1,4,14Zm24,6a8,8,0,0,1-16,0V10H28Z"
    })), children);
  });
  var Theater16 = /*#__PURE__*/React__default['default'].forwardRef(function Theater16(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$3 || (_path213$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 25a6.9908 6.9908 0 01-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 008.334 0l1.666 1.1074A6.9908 6.9908 0 0120 25zM24 14a2 2 0 102 2A1.9806 1.9806 0 0024 14zM16 14a2 2 0 102 2A1.9806 1.9806 0 0016 14z"
    })), _path214$3 || (_path214$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H22V4a2.0023,2.0023,0,0,0-2-2H4A2.0023,2.0023,0,0,0,2,4V14a10.01,10.01,0,0,0,8.8027,9.9214A9.9989,9.9989,0,0,0,30,20V10A2.0023,2.0023,0,0,0,28,8ZM4,14V4H20V8H12a2.0023,2.0023,0,0,0-2,2V20a9.9628,9.9628,0,0,0,.168,1.78A8.0081,8.0081,0,0,1,4,14Zm24,6a8,8,0,0,1-16,0V10H28Z"
    })), children);
  });
  var ThisSideUp32 = /*#__PURE__*/React__default['default'].forwardRef(function ThisSideUp32(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$3 || (_path215$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM7 5.828L7 24 9 24 9 5.828 12.586 9.414 14 8 8 2 2 8 3.414 9.414 7 5.828zM23 5.828L23 24 25 24 25 5.828 28.586 9.414 30 8 24 2 18 8 19.414 9.414 23 5.828z"
    })), children);
  });
  var ThisSideUp24 = /*#__PURE__*/React__default['default'].forwardRef(function ThisSideUp24(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$3 || (_path216$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM7 5.828L7 24 9 24 9 5.828 12.586 9.414 14 8 8 2 2 8 3.414 9.414 7 5.828zM23 5.828L23 24 25 24 25 5.828 28.586 9.414 30 8 24 2 18 8 19.414 9.414 23 5.828z"
    })), children);
  });
  var ThisSideUp20 = /*#__PURE__*/React__default['default'].forwardRef(function ThisSideUp20(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$3 || (_path217$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM7 5.828L7 24 9 24 9 5.828 12.586 9.414 14 8 8 2 2 8 3.414 9.414 7 5.828zM23 5.828L23 24 25 24 25 5.828 28.586 9.414 30 8 24 2 18 8 19.414 9.414 23 5.828z"
    })), children);
  });
  var ThisSideUp16 = /*#__PURE__*/React__default['default'].forwardRef(function ThisSideUp16(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$3 || (_path218$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2zM7 5.828L7 24 9 24 9 5.828 12.586 9.414 14 8 8 2 2 8 3.414 9.414 7 5.828zM23 5.828L23 24 25 24 25 5.828 28.586 9.414 30 8 24 2 18 8 19.414 9.414 23 5.828z"
    })), children);
  });
  var WatsonHealthThreshold32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThreshold32(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$3 || (_path219$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM6,6H26V16H24v2h2v2H24v2h2v2H24v2H22V24H20v2H18V24H16v2H14V24H12v2H10V24H8v2H6Z"
    })), _path220$3 || (_path220$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H10V22H8zM12 20H14V22H12zM16 20H18V22H16zM20 20H22V22H20zM8 16H10V18H8zM16 16H18V18H16zM20 16H22V18H20zM20 12H22V14H20zM20 8H22V10H20z"
    })), children);
  });
  var WatsonHealthThreshold24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThreshold24(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$3 || (_path221$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM6,6H26V16H24v2h2v2H24v2h2v2H24v2H22V24H20v2H18V24H16v2H14V24H12v2H10V24H8v2H6Z"
    })), _path222$3 || (_path222$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H10V22H8zM12 20H14V22H12zM16 20H18V22H16zM20 20H22V22H20zM8 16H10V18H8zM16 16H18V18H16zM20 16H22V18H20zM20 12H22V14H20zM20 8H22V10H20z"
    })), children);
  });
  var WatsonHealthThreshold20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThreshold20(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$3 || (_path223$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM6,6H26V16H24v2h2v2H24v2h2v2H24v2H22V24H20v2H18V24H16v2H14V24H12v2H10V24H8v2H6Z"
    })), _path224$3 || (_path224$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H10V22H8zM12 20H14V22H12zM16 20H18V22H16zM20 20H22V22H20zM8 16H10V18H8zM16 16H18V18H16zM20 16H22V18H20zM20 12H22V14H20zM20 8H22V10H20z"
    })), children);
  });
  var WatsonHealthThreshold16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThreshold16(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$3 || (_path225$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0023,2.0023,0,0,0,2-2V6A2.0023,2.0023,0,0,0,26,4ZM6,6H26V16H24v2h2v2H24v2h2v2H24v2H22V24H20v2H18V24H16v2H14V24H12v2H10V24H8v2H6Z"
    })), _path226$3 || (_path226$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 20H10V22H8zM12 20H14V22H12zM16 20H18V22H16zM20 20H22V22H20zM8 16H10V18H8zM16 16H18V18H16zM20 16H22V18H20zM20 12H22V14H20zM20 8H22V10H20z"
    })), children);
  });
  var Thumbnail_132 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_132(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$3 || (_path227$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM28 20H4a2 2 0 01-2-2V4A2 2 0 014 2H28a2 2 0 012 2V18A2 2 0 0128 20zM4 4V18H28V4z"
    })), children);
  });
  var Thumbnail_124 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_124(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$3 || (_path228$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM28 20H4a2 2 0 01-2-2V4A2 2 0 014 2H28a2 2 0 012 2V18A2 2 0 0128 20zM4 4V18H28V4z"
    })), children);
  });
  var Thumbnail_120 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_120(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$3 || (_path229$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM28 20H4a2 2 0 01-2-2V4A2 2 0 014 2H28a2 2 0 012 2V18A2 2 0 0128 20zM4 4V18H28V4z"
    })), children);
  });
  var Thumbnail_116 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_116(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$3 || (_path230$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM28 20H4a2 2 0 01-2-2V4A2 2 0 014 2H28a2 2 0 012 2V18A2 2 0 0128 20zM4 4V18H28V4z"
    })), children);
  });
  var Thumbnail_232 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_232(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$3 || (_path231$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM8 20H4a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 20zM4 14v4H8V14zM18 20H14a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 20zm-4-6v4h4V14zM28 20H24a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 20zm-4-6v4h4V14zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4zM18 10H14a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0118 10zM14 4V8h4V4zM28 10H24a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0128 10zM24 4V8h4V4z"
    })), children);
  });
  var Thumbnail_224 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_224(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$3 || (_path232$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM8 20H4a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 20zM4 14v4H8V14zM18 20H14a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 20zm-4-6v4h4V14zM28 20H24a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 20zm-4-6v4h4V14zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4zM18 10H14a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0118 10zM14 4V8h4V4zM28 10H24a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0128 10zM24 4V8h4V4z"
    })), children);
  });
  var Thumbnail_220 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_220(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$3 || (_path233$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM8 20H4a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 20zM4 14v4H8V14zM18 20H14a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 20zm-4-6v4h4V14zM28 20H24a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 20zm-4-6v4h4V14zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4zM18 10H14a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0118 10zM14 4V8h4V4zM28 10H24a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0128 10zM24 4V8h4V4z"
    })), children);
  });
  var Thumbnail_216 = /*#__PURE__*/React__default['default'].forwardRef(function Thumbnail_216(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$3 || (_path234$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 30H4a2 2 0 01-2-2V24a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 30zM4 24v4H8V24zM18 30H14a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 30zm-4-6v4h4V24zM28 30H24a2 2 0 01-2-2V24a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 30zm-4-6v4h4V24zM8 20H4a2 2 0 01-2-2V14a2 2 0 012-2H8a2 2 0 012 2v4A2 2 0 018 20zM4 14v4H8V14zM18 20H14a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0118 20zm-4-6v4h4V14zM28 20H24a2 2 0 01-2-2V14a2 2 0 012-2h4a2 2 0 012 2v4A2 2 0 0128 20zm-4-6v4h4V14zM8 10H4A2 2 0 012 8V4A2 2 0 014 2H8a2 2 0 012 2V8A2 2 0 018 10zM4 4V8H8V4zM18 10H14a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0118 10zM14 4V8h4V4zM28 10H24a2 2 0 01-2-2V4a2 2 0 012-2h4a2 2 0 012 2V8A2 2 0 0128 10zM24 4V8h4V4z"
    })), children);
  });
  var WatsonHealthThumbnailPreview32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThumbnailPreview32(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$3 || (_path235$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"
    })), _path236$3 || (_path236$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a4 4 0 114-4A4.0042 4.0042 0 0116 23zm0-6a2 2 0 102 2A2.0023 2.0023 0 0016 17zM30 4V8a2.0027 2.0027 0 01-2 2H24a2.0027 2.0027 0 01-2-2V4a2.0027 2.0027 0 012-2h4A2.0027 2.0027 0 0130 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 01-2 2H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h4A2.0027 2.0027 0 0120 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H8A2.0023 2.0023 0 0110 4zM8 8l.0015-4H4V8z"
    })), children);
  });
  var WatsonHealthThumbnailPreview24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThumbnailPreview24(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237$3 || (_path237$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"
    })), _path238$3 || (_path238$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a4 4 0 114-4A4.0042 4.0042 0 0116 23zm0-6a2 2 0 102 2A2.0023 2.0023 0 0016 17zM30 4V8a2.0027 2.0027 0 01-2 2H24a2.0027 2.0027 0 01-2-2V4a2.0027 2.0027 0 012-2h4A2.0027 2.0027 0 0130 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 01-2 2H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h4A2.0027 2.0027 0 0120 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H8A2.0023 2.0023 0 0110 4zM8 8l.0015-4H4V8z"
    })), children);
  });
  var WatsonHealthThumbnailPreview20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThumbnailPreview20(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239$3 || (_path239$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"
    })), _path240$3 || (_path240$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a4 4 0 114-4A4.0042 4.0042 0 0116 23zm0-6a2 2 0 102 2A2.0023 2.0023 0 0016 17zM30 4V8a2.0027 2.0027 0 01-2 2H24a2.0027 2.0027 0 01-2-2V4a2.0027 2.0027 0 012-2h4A2.0027 2.0027 0 0130 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 01-2 2H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h4A2.0027 2.0027 0 0120 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H8A2.0023 2.0023 0 0110 4zM8 8l.0015-4H4V8z"
    })), children);
  });
  var WatsonHealthThumbnailPreview16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthThumbnailPreview16(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$3 || (_path241$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"
    })), _path242$3 || (_path242$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a4 4 0 114-4A4.0042 4.0042 0 0116 23zm0-6a2 2 0 102 2A2.0023 2.0023 0 0016 17zM30 4V8a2.0027 2.0027 0 01-2 2H24a2.0027 2.0027 0 01-2-2V4a2.0027 2.0027 0 012-2h4A2.0027 2.0027 0 0130 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 01-2 2H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h4A2.0027 2.0027 0 0120 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 01-2 2H4A2.0023 2.0023 0 012 8V4A2.0023 2.0023 0 014 2H8A2.0023 2.0023 0 0110 4zM8 8l.0015-4H4V8z"
    })), children);
  });
  var ThumbsDown32 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDown32(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243$3 || (_path243$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V9a7.0078,7.0078,0,0,0-7-7H2V16H8.4648l3.5774,5.3662.8453,5.9165A2.0094,2.0094,0,0,0,14.8672,29H17a3.0033,3.0033,0,0,0,3-3V20h6A4.0045,4.0045,0,0,0,30,16ZM8,14H4V4H8Zm20,2a2.0025,2.0025,0,0,1-2,2H18v8a1.0008,1.0008,0,0,1-1,1H14.8672l-.9094-6.3662L10,14.6973V4H23a5.0057,5.0057,0,0,1,5,5Z"
    })), children);
  });
  var ThumbsDown24 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDown24(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$3 || (_path244$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V9a7.0078,7.0078,0,0,0-7-7H2V16H8.4648l3.5774,5.3662.8453,5.9165A2.0094,2.0094,0,0,0,14.8672,29H17a3.0033,3.0033,0,0,0,3-3V20h6A4.0045,4.0045,0,0,0,30,16ZM8,14H4V4H8Zm20,2a2.0025,2.0025,0,0,1-2,2H18v8a1.0008,1.0008,0,0,1-1,1H14.8672l-.9094-6.3662L10,14.6973V4H23a5.0057,5.0057,0,0,1,5,5Z"
    })), children);
  });
  var ThumbsDown20 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDown20(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245$3 || (_path245$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V9a7.0078,7.0078,0,0,0-7-7H2V16H8.4648l3.5774,5.3662.8453,5.9165A2.0094,2.0094,0,0,0,14.8672,29H17a3.0033,3.0033,0,0,0,3-3V20h6A4.0045,4.0045,0,0,0,30,16ZM8,14H4V4H8Zm20,2a2.0025,2.0025,0,0,1-2,2H18v8a1.0008,1.0008,0,0,1-1,1H14.8672l-.9094-6.3662L10,14.6973V4H23a5.0057,5.0057,0,0,1,5,5Z"
    })), children);
  });
  var ThumbsDown16 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDown16(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$3 || (_path246$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,16V9a7.0078,7.0078,0,0,0-7-7H2V16H8.4648l3.5774,5.3662.8453,5.9165A2.0094,2.0094,0,0,0,14.8672,29H17a3.0033,3.0033,0,0,0,3-3V20h6A4.0045,4.0045,0,0,0,30,16ZM8,14H4V4H8Zm20,2a2.0025,2.0025,0,0,1-2,2H18v8a1.0008,1.0008,0,0,1-1,1H14.8672l-.9094-6.3662L10,14.6973V4H23a5.0057,5.0057,0,0,1,5,5Z"
    })), children);
  });
  var ThumbsDownFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDownFilled32(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$3 || (_path247$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H7V16H2zM23 2H9V16.8027l3.0422 4.5635.8453 5.9165A2.0094 2.0094 0 0014.8672 29H15a3.0033 3.0033 0 003-3V20h8a4.0045 4.0045 0 004-4V9A7.0078 7.0078 0 0023 2z"
    })), children);
  });
  var ThumbsDownFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDownFilled24(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$3 || (_path248$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H7V16H2zM23 2H9V16.8027l3.0422 4.5635.8453 5.9165A2.0094 2.0094 0 0014.8672 29H15a3.0033 3.0033 0 003-3V20h8a4.0045 4.0045 0 004-4V9A7.0078 7.0078 0 0023 2z"
    })), children);
  });
  var ThumbsDownFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDownFilled20(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$3 || (_path249$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H7V16H2zM23 2H9V16.8027l3.0422 4.5635.8453 5.9165A2.0094 2.0094 0 0014.8672 29H15a3.0033 3.0033 0 003-3V20h8a4.0045 4.0045 0 004-4V9A7.0078 7.0078 0 0023 2z"
    })), children);
  });
  var ThumbsDownFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsDownFilled16(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$3 || (_path250$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 2H7V16H2zM23 2H9V16.8027l3.0422 4.5635.8453 5.9165A2.0094 2.0094 0 0014.8672 29H15a3.0033 3.0033 0 003-3V20h8a4.0045 4.0045 0 004-4V9A7.0078 7.0078 0 0023 2z"
    })), children);
  });
  var ThumbsUp32 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUp32(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$3 || (_path251$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12H20V6a3.0033,3.0033,0,0,0-3-3H14.8672a2.0094,2.0094,0,0,0-1.98,1.7173l-.8453,5.9165L8.4648,16H2V30H23a7.0078,7.0078,0,0,0,7-7V16A4.0045,4.0045,0,0,0,26,12ZM8,28H4V18H8Zm20-5a5.0057,5.0057,0,0,1-5,5H10V17.3027l3.9578-5.9365L14.8672,5H17a1.0008,1.0008,0,0,1,1,1v8h8a2.0025,2.0025,0,0,1,2,2Z"
    })), children);
  });
  var ThumbsUp24 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUp24(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$3 || (_path252$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12H20V6a3.0033,3.0033,0,0,0-3-3H14.8672a2.0094,2.0094,0,0,0-1.98,1.7173l-.8453,5.9165L8.4648,16H2V30H23a7.0078,7.0078,0,0,0,7-7V16A4.0045,4.0045,0,0,0,26,12ZM8,28H4V18H8Zm20-5a5.0057,5.0057,0,0,1-5,5H10V17.3027l3.9578-5.9365L14.8672,5H17a1.0008,1.0008,0,0,1,1,1v8h8a2.0025,2.0025,0,0,1,2,2Z"
    })), children);
  });
  var ThumbsUp20 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUp20(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$3 || (_path253$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12H20V6a3.0033,3.0033,0,0,0-3-3H14.8672a2.0094,2.0094,0,0,0-1.98,1.7173l-.8453,5.9165L8.4648,16H2V30H23a7.0078,7.0078,0,0,0,7-7V16A4.0045,4.0045,0,0,0,26,12ZM8,28H4V18H8Zm20-5a5.0057,5.0057,0,0,1-5,5H10V17.3027l3.9578-5.9365L14.8672,5H17a1.0008,1.0008,0,0,1,1,1v8h8a2.0025,2.0025,0,0,1,2,2Z"
    })), children);
  });
  var ThumbsUp16 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUp16(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$3 || (_path254$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,12H20V6a3.0033,3.0033,0,0,0-3-3H14.8672a2.0094,2.0094,0,0,0-1.98,1.7173l-.8453,5.9165L8.4648,16H2V30H23a7.0078,7.0078,0,0,0,7-7V16A4.0045,4.0045,0,0,0,26,12ZM8,28H4V18H8Zm20-5a5.0057,5.0057,0,0,1-5,5H10V17.3027l3.9578-5.9365L14.8672,5H17a1.0008,1.0008,0,0,1,1,1v8h8a2.0025,2.0025,0,0,1,2,2Z"
    })), children);
  });
  var ThumbsUpFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUpFilled32(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$3 || (_path255$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16H7V30H2zM23 30H9V15.1973l3.0422-4.5635.8453-5.9165A2.0094 2.0094 0 0114.8672 3H15a3.0033 3.0033 0 013 3v6h8a4.0045 4.0045 0 014 4v7A7.0078 7.0078 0 0123 30z"
    })), children);
  });
  var ThumbsUpFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUpFilled24(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$3 || (_path256$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16H7V30H2zM23 30H9V15.1973l3.0422-4.5635.8453-5.9165A2.0094 2.0094 0 0114.8672 3H15a3.0033 3.0033 0 013 3v6h8a4.0045 4.0045 0 014 4v7A7.0078 7.0078 0 0123 30z"
    })), children);
  });
  var ThumbsUpFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUpFilled20(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$3 || (_path257$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16H7V30H2zM23 30H9V15.1973l3.0422-4.5635.8453-5.9165A2.0094 2.0094 0 0114.8672 3H15a3.0033 3.0033 0 013 3v6h8a4.0045 4.0045 0 014 4v7A7.0078 7.0078 0 0123 30z"
    })), children);
  });
  var ThumbsUpFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ThumbsUpFilled16(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258$3 || (_path258$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16H7V30H2zM23 30H9V15.1973l3.0422-4.5635.8453-5.9165A2.0094 2.0094 0 0114.8672 3H15a3.0033 3.0033 0 013 3v6h8a4.0045 4.0045 0 014 4v7A7.0078 7.0078 0 0123 30z"
    })), children);
  });
  var Thunderstorm32 = /*#__PURE__*/React__default['default'].forwardRef(function Thunderstorm32(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$3 || (_path259$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path260$3 || (_path260$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"
    })), children);
  });
  var Thunderstorm24 = /*#__PURE__*/React__default['default'].forwardRef(function Thunderstorm24(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$3 || (_path261$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path262$3 || (_path262$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"
    })), children);
  });
  var Thunderstorm20 = /*#__PURE__*/React__default['default'].forwardRef(function Thunderstorm20(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$3 || (_path263$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path264$3 || (_path264$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"
    })), children);
  });
  var Thunderstorm16 = /*#__PURE__*/React__default['default'].forwardRef(function Thunderstorm16(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$3 || (_path265$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"
    })), _path266$3 || (_path266$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"
    })), children);
  });
  var ThunderstormScattered32 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScattered32(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$3 || (_path267$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path268$3 || (_path268$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11Zm-4.0732,3.4893a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), _path269$3 || (_path269$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path270$3 || (_path270$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path271$3 || (_path271$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path272$3 || (_path272$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path273$3 || (_path273$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), children);
  });
  var ThunderstormScattered24 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScattered24(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$3 || (_path274$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path275$3 || (_path275$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11Zm-4.0732,3.4893a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), _path276$3 || (_path276$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path277$3 || (_path277$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path278$3 || (_path278$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path279$3 || (_path279$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path280$3 || (_path280$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), children);
  });
  var ThunderstormScattered20 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScattered20(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$3 || (_path281$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path282$3 || (_path282$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11Zm-4.0732,3.4893a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), _path283$3 || (_path283$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path284$3 || (_path284$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path285$3 || (_path285$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path286$3 || (_path286$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path287$3 || (_path287$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), children);
  });
  var ThunderstormScattered16 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScattered16(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path288$3 || (_path288$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path289$3 || (_path289$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11A5.9955,5.9955,0,0,0,15.6335,8.3311,7.3494,7.3494,0,0,0,13.5,8a7.5509,7.5509,0,0,0-7.1492,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9925,3.9925,0,0,1-.6731-7.9292L7.99,14.958l.1458-.6562a5.496,5.496,0,0,1,10.7294,0l.1458.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9853,5.9853,0,0,0,5.2163-8.9463A5.9941,5.9941,0,0,0,27,11Zm-4.0732,3.4893a5.96,5.96,0,0,0-2.2776-1.2452,7.5157,7.5157,0,0,0-3.1853-4.0688,3.9869,3.9869,0,1,1,5.4629,5.314Z"
    })), _path290$3 || (_path290$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 16.233H29.732V18.233H26.732z",
      transform: "rotate(-135 28.232 17.233)"
    })), _path291$3 || (_path291$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 10H32V12H29z"
    })), _path292$3 || (_path292$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.732 3.768H29.732V5.768H26.732z",
      transform: "rotate(-45 28.232 4.768)"
    })), _path293$3 || (_path293$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 0H22V3H20z"
    })), _path294$3 || (_path294$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.268 3.768H15.268V5.768H12.268z",
      transform: "rotate(-135 13.768 4.768)"
    })), children);
  });
  var ThunderstormScatteredNight32 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScatteredNight32(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$3 || (_path295$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path296$3 || (_path296$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.844,13.0347a1.52,1.52,0,0,0-1.231-.8658,5.3562,5.3562,0,0,1-3.4094-1.7158A6.4652,6.4652,0,0,1,23.9187,4.06a1.6039,1.6039,0,0,0-.3-1.5459,1.4547,1.4547,0,0,0-1.3591-.4922l-.0191.0039a7.8544,7.8544,0,0,0-6.1054,6.48A7.3725,7.3725,0,0,0,13.5,8a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9549,5.9549,0,0,0,5.88-7.1455,7.502,7.502,0,0,0,4.8669-3.3A1.537,1.537,0,0,0,29.844,13.0347Zm-5.6926,2.9179a5.9658,5.9658,0,0,0-3.502-2.7085A7.5084,7.5084,0,0,0,18.0288,9.55a6.0085,6.0085,0,0,1,3.77-5.3335,8.4582,8.4582,0,0,0,1.9392,7.5967A7.4037,7.4037,0,0,0,27.64,14.041,5.4419,5.4419,0,0,1,24.1514,15.9526Z"
    })), children);
  });
  var ThunderstormScatteredNight24 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScatteredNight24(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$3 || (_path297$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path298$3 || (_path298$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.844,13.0347a1.52,1.52,0,0,0-1.231-.8658,5.3562,5.3562,0,0,1-3.4094-1.7158A6.4652,6.4652,0,0,1,23.9187,4.06a1.6039,1.6039,0,0,0-.3-1.5459,1.4547,1.4547,0,0,0-1.3591-.4922l-.0191.0039a7.8544,7.8544,0,0,0-6.1054,6.48A7.3725,7.3725,0,0,0,13.5,8a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9549,5.9549,0,0,0,5.88-7.1455,7.502,7.502,0,0,0,4.8669-3.3A1.537,1.537,0,0,0,29.844,13.0347Zm-5.6926,2.9179a5.9658,5.9658,0,0,0-3.502-2.7085A7.5084,7.5084,0,0,0,18.0288,9.55a6.0085,6.0085,0,0,1,3.77-5.3335,8.4582,8.4582,0,0,0,1.9392,7.5967A7.4037,7.4037,0,0,0,27.64,14.041,5.4419,5.4419,0,0,1,24.1514,15.9526Z"
    })), children);
  });
  var ThunderstormScatteredNight20 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScatteredNight20(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$3 || (_path299$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path300$3 || (_path300$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.844,13.0347a1.52,1.52,0,0,0-1.231-.8658,5.3562,5.3562,0,0,1-3.4094-1.7158A6.4652,6.4652,0,0,1,23.9187,4.06a1.6039,1.6039,0,0,0-.3-1.5459,1.4547,1.4547,0,0,0-1.3591-.4922l-.0191.0039a7.8544,7.8544,0,0,0-6.1054,6.48A7.3725,7.3725,0,0,0,13.5,8a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9549,5.9549,0,0,0,5.88-7.1455,7.502,7.502,0,0,0,4.8669-3.3A1.537,1.537,0,0,0,29.844,13.0347Zm-5.6926,2.9179a5.9658,5.9658,0,0,0-3.502-2.7085A7.5084,7.5084,0,0,0,18.0288,9.55a6.0085,6.0085,0,0,1,3.77-5.3335,8.4582,8.4582,0,0,0,1.9392,7.5967A7.4037,7.4037,0,0,0,27.64,14.041,5.4419,5.4419,0,0,1,24.1514,15.9526Z"
    })), children);
  });
  var ThunderstormScatteredNight16 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormScatteredNight16(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$3 || (_path301$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13.338 30L11.602 29 13.889 25 10 25 13.993 18 15.73 19 13.446 23 17.337 23 13.338 30z"
    })), _path302$3 || (_path302$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.844,13.0347a1.52,1.52,0,0,0-1.231-.8658,5.3562,5.3562,0,0,1-3.4094-1.7158A6.4652,6.4652,0,0,1,23.9187,4.06a1.6039,1.6039,0,0,0-.3-1.5459,1.4547,1.4547,0,0,0-1.3591-.4922l-.0191.0039a7.8544,7.8544,0,0,0-6.1054,6.48A7.3725,7.3725,0,0,0,13.5,8a7.5511,7.5511,0,0,0-7.1494,5.2441A5.9926,5.9926,0,0,0,8,25V23a3.9926,3.9926,0,0,1-.6733-7.9292l.663-.1128.1456-.6562a5.496,5.496,0,0,1,10.7294,0l.1456.6562.6626.1128A3.9925,3.9925,0,0,1,19,23v2a5.9549,5.9549,0,0,0,5.88-7.1455,7.502,7.502,0,0,0,4.8669-3.3A1.537,1.537,0,0,0,29.844,13.0347Zm-5.6926,2.9179a5.9658,5.9658,0,0,0-3.502-2.7085A7.5084,7.5084,0,0,0,18.0288,9.55a6.0085,6.0085,0,0,1,3.77-5.3335,8.4582,8.4582,0,0,0,1.9392,7.5967A7.4037,7.4037,0,0,0,27.64,14.041,5.4419,5.4419,0,0,1,24.1514,15.9526Z"
    })), children);
  });
  var ThunderstormSevere32 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormSevere32(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$3 || (_path303$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.309 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496zM27.9516 15A4.399 4.399 0 0128 15.5 4.5049 4.5049 0 0123.5 20H23v2h.5A6.5075 6.5075 0 0030 15.5c0-.17-.0312-.333-.0444-.5z"
    })), _path304$3 || (_path304$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.75,8h-1.5V4h1.5ZM25,9a1,1,0,1,0,1,1A1,1,0,0,0,25,9Z"
    })), _path305$3 || (_path305$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9115 11.9355L25.6283.3706a.7181.7181 0 00-1.2568 0L18.0883 11.9355A.72.72 0 0018.72 13H31.28A.72.72 0 0031.9115 11.9355zM24.25 4h1.5V8h-1.5zM25 11a1 1 0 111-1A1 1 0 0125 11zM8.144 11.019l.8154-.0639.0991-.812a6.9863 6.9863 0 019.97-5.45L20 2.9468A8.9777 8.9777 0 007.2 9.1362 6.4929 6.4929 0 007.43 21.9043L6.1059 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.4471-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.3559-8.981z"
    })), children);
  });
  var ThunderstormSevere24 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormSevere24(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$3 || (_path306$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.309 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496zM27.9516 15A4.399 4.399 0 0128 15.5 4.5049 4.5049 0 0123.5 20H23v2h.5A6.5075 6.5075 0 0030 15.5c0-.17-.0312-.333-.0444-.5z"
    })), _path307$3 || (_path307$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.75,8h-1.5V4h1.5ZM25,9a1,1,0,1,0,1,1A1,1,0,0,0,25,9Z"
    })), _path308$3 || (_path308$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9115 11.9355L25.6283.3706a.7181.7181 0 00-1.2568 0L18.0883 11.9355A.72.72 0 0018.72 13H31.28A.72.72 0 0031.9115 11.9355zM24.25 4h1.5V8h-1.5zM25 11a1 1 0 111-1A1 1 0 0125 11zM8.144 11.019l.8154-.0639.0991-.812a6.9863 6.9863 0 019.97-5.45L20 2.9468A8.9777 8.9777 0 007.2 9.1362 6.4929 6.4929 0 007.43 21.9043L6.1059 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.4471-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.3559-8.981z"
    })), children);
  });
  var ThunderstormSevere20 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormSevere20(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$3 || (_path309$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.309 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496zM27.9516 15A4.399 4.399 0 0128 15.5 4.5049 4.5049 0 0123.5 20H23v2h.5A6.5075 6.5075 0 0030 15.5c0-.17-.0312-.333-.0444-.5z"
    })), _path310$3 || (_path310$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.75,8h-1.5V4h1.5ZM25,9a1,1,0,1,0,1,1A1,1,0,0,0,25,9Z"
    })), _path311$3 || (_path311$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9115 11.9355L25.6283.3706a.7181.7181 0 00-1.2568 0L18.0883 11.9355A.72.72 0 0018.72 13H31.28A.72.72 0 0031.9115 11.9355zM24.25 4h1.5V8h-1.5zM25 11a1 1 0 111-1A1 1 0 0125 11zM8.144 11.019l.8154-.0639.0991-.812a6.9863 6.9863 0 019.97-5.45L20 2.9468A8.9777 8.9777 0 007.2 9.1362 6.4929 6.4929 0 007.43 21.9043L6.1059 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.4471-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.3559-8.981z"
    })), children);
  });
  var ThunderstormSevere16 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormSevere16(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$3 || (_path312$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7887.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.309 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496zM27.9516 15A4.399 4.399 0 0128 15.5 4.5049 4.5049 0 0123.5 20H23v2h.5A6.5075 6.5075 0 0030 15.5c0-.17-.0312-.333-.0444-.5z"
    })), _path313$3 || (_path313$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.75,8h-1.5V4h1.5ZM25,9a1,1,0,1,0,1,1A1,1,0,0,0,25,9Z"
    })), _path314$3 || (_path314$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31.9115 11.9355L25.6283.3706a.7181.7181 0 00-1.2568 0L18.0883 11.9355A.72.72 0 0018.72 13H31.28A.72.72 0 0031.9115 11.9355zM24.25 4h1.5V8h-1.5zM25 11a1 1 0 111-1A1 1 0 0125 11zM8.144 11.019l.8154-.0639.0991-.812a6.9863 6.9863 0 019.97-5.45L20 2.9468A8.9777 8.9777 0 007.2 9.1362 6.4929 6.4929 0 007.43 21.9043L6.1059 24.5527a1 1 0 101.7885.8946l2-4a1 1 0 00-.4471-1.3418A.9786.9786 0 009 20.01V20H8.5a4.4975 4.4975 0 01-.3559-8.981z"
    })), children);
  });
  var ThunderstormStrong32 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormStrong32(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$3 || (_path315$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.31 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496z"
    })), _path316$3 || (_path316$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4929,6.4929,0,0,0,.23,12.7681L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418A.9786.9786,0,0,0,9,20.01V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20H23v2h.5A6.4974,6.4974,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var ThunderstormStrong24 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormStrong24(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$3 || (_path317$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.31 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496z"
    })), _path318$3 || (_path318$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4929,6.4929,0,0,0,.23,12.7681L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418A.9786.9786,0,0,0,9,20.01V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20H23v2h.5A6.4974,6.4974,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var ThunderstormStrong20 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormStrong20(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$3 || (_path319$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.31 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496z"
    })), _path320$3 || (_path320$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4929,6.4929,0,0,0,.23,12.7681L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418A.9786.9786,0,0,0,9,20.01V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20H23v2h.5A6.4974,6.4974,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var ThunderstormStrong16 = /*#__PURE__*/React__default['default'].forwardRef(function ThunderstormStrong16(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$3 || (_path321$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0121 30zM9 32a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 019 32zM15.901 30.496L14.165 29.504 17.31 24 11.31 24 16.165 15.504 17.901 16.496 14.756 22 20.757 22 15.901 30.496z"
    })), _path322$3 || (_path322$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0,6.4929,6.4929,0,0,0,.23,12.7681L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418A.9786.9786,0,0,0,9,20.01V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20H23v2h.5A6.4974,6.4974,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var Ticket32 = /*#__PURE__*/React__default['default'].forwardRef(function Ticket32(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$3 || (_path323$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"
    })), _path324$3 || (_path324$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H21V19H19z"
    })), children);
  });
  var Ticket24 = /*#__PURE__*/React__default['default'].forwardRef(function Ticket24(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$3 || (_path325$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"
    })), _path326$3 || (_path326$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H21V19H19z"
    })), children);
  });
  var Ticket20 = /*#__PURE__*/React__default['default'].forwardRef(function Ticket20(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$3 || (_path327$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"
    })), _path328$3 || (_path328$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H21V19H19z"
    })), children);
  });
  var Ticket16 = /*#__PURE__*/React__default['default'].forwardRef(function Ticket16(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$3 || (_path329$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"
    })), _path330$3 || (_path330$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H21V19H19z"
    })), children);
  });
  var Tides32 = /*#__PURE__*/React__default['default'].forwardRef(function Tides32(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$3 || (_path331$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 7L9 2 4 7 5.413 8.416 8 5.833 8 14 10 14 10 5.833 12.586 8.414 14 7zM26.586 7.586L24 10.167 24 2 22 2 22 10.167 19.413 7.584 18 9 23 14 28 9 26.586 7.586zM20 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 17a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0112 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 008 17a.971.971 0 00-.9468.6787A3.44 3.44 0 014 20H2v2H4a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0020 22H30V20zM28 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0024 25a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0120 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 25a.971.971 0 00-.9468.6787A3.44 3.44 0 0112 28H2v2H12a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0028 30h2V28z"
    })), children);
  });
  var Tides24 = /*#__PURE__*/React__default['default'].forwardRef(function Tides24(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$3 || (_path332$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 7L9 2 4 7 5.413 8.416 8 5.833 8 14 10 14 10 5.833 12.586 8.414 14 7zM26.586 7.586L24 10.167 24 2 22 2 22 10.167 19.413 7.584 18 9 23 14 28 9 26.586 7.586zM20 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 17a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0112 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 008 17a.971.971 0 00-.9468.6787A3.44 3.44 0 014 20H2v2H4a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0020 22H30V20zM28 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0024 25a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0120 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 25a.971.971 0 00-.9468.6787A3.44 3.44 0 0112 28H2v2H12a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0028 30h2V28z"
    })), children);
  });
  var Tides20 = /*#__PURE__*/React__default['default'].forwardRef(function Tides20(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$3 || (_path333$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 7L9 2 4 7 5.413 8.416 8 5.833 8 14 10 14 10 5.833 12.586 8.414 14 7zM26.586 7.586L24 10.167 24 2 22 2 22 10.167 19.413 7.584 18 9 23 14 28 9 26.586 7.586zM20 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 17a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0112 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 008 17a.971.971 0 00-.9468.6787A3.44 3.44 0 014 20H2v2H4a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0020 22H30V20zM28 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0024 25a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0120 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 25a.971.971 0 00-.9468.6787A3.44 3.44 0 0112 28H2v2H12a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0028 30h2V28z"
    })), children);
  });
  var Tides16 = /*#__PURE__*/React__default['default'].forwardRef(function Tides16(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$3 || (_path334$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 7L9 2 4 7 5.413 8.416 8 5.833 8 14 10 14 10 5.833 12.586 8.414 14 7zM26.586 7.586L24 10.167 24 2 22 2 22 10.167 19.413 7.584 18 9 23 14 28 9 26.586 7.586zM20 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 17a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0112 20a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 008 17a.971.971 0 00-.9468.6787A3.44 3.44 0 014 20H2v2H4a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0020 22H30V20zM28 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0024 25a.9894.9894 0 00-.9468.6787A3.44 3.44 0 0120 28a3.4376 3.4376 0 01-3.0513-2.3164A1.007 1.007 0 0016 25a.971.971 0 00-.9468.6787A3.44 3.44 0 0112 28H2v2H12a4.9316 4.9316 0 004-1.9873 5.0192 5.0192 0 008 0A4.9316 4.9316 0 0028 30h2V28z"
    })), children);
  });
  var Tif32 = /*#__PURE__*/React__default['default'].forwardRef(function Tif32(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$3 || (_path335$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Tif24 = /*#__PURE__*/React__default['default'].forwardRef(function Tif24(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$3 || (_path336$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Tif20 = /*#__PURE__*/React__default['default'].forwardRef(function Tif20(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$3 || (_path337$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Tif16 = /*#__PURE__*/React__default['default'].forwardRef(function Tif16(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$3 || (_path338$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Time32 = /*#__PURE__*/React__default['default'].forwardRef(function Time32(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$3 || (_path339$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path340$3 || (_path340$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), children);
  });
  var Time24 = /*#__PURE__*/React__default['default'].forwardRef(function Time24(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341$3 || (_path341$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path342$3 || (_path342$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), children);
  });
  var Time20 = /*#__PURE__*/React__default['default'].forwardRef(function Time20(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$3 || (_path343$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,19c-5,0-9-4-9-9s4-9,9-9s9,4,9,9S15,19,10,19z M10,2.3c-4.3,0-7.7,3.5-7.7,7.7s3.5,7.7,7.7,7.7s7.7-3.5,7.7-7.7\tS14.3,2.3,10,2.3z"
    })), _path344$3 || (_path344$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 13.9L9.4 10.3 9.4 4 10.6 4 10.6 9.7 13.9 13z"
    })), children);
  });
  var Time16 = /*#__PURE__*/React__default['default'].forwardRef(function Time16(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$3 || (_path345$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"
    })), _path346$3 || (_path346$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"
    })), children);
  });
  var TimePlot32 = /*#__PURE__*/React__default['default'].forwardRef(function TimePlot32(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$3 || (_path347$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.586 13L21 10.414 21 6 23 6 23 9.586 25 11.586 23.586 13z"
    })), _path348$3 || (_path348$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,22,18ZM22,4a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,22,4Z"
    })), _path349$3 || (_path349$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.63,18l7,6H30V22H16.37l-7-6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V18Z"
    })), children);
  });
  var TimePlot24 = /*#__PURE__*/React__default['default'].forwardRef(function TimePlot24(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$3 || (_path350$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.586 13L21 10.414 21 6 23 6 23 9.586 25 11.586 23.586 13z"
    })), _path351$3 || (_path351$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,22,18ZM22,4a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,22,4Z"
    })), _path352$3 || (_path352$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.63,18l7,6H30V22H16.37l-7-6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V18Z"
    })), children);
  });
  var TimePlot20 = /*#__PURE__*/React__default['default'].forwardRef(function TimePlot20(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$3 || (_path353$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.586 13L21 10.414 21 6 23 6 23 9.586 25 11.586 23.586 13z"
    })), _path354$3 || (_path354$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,22,18ZM22,4a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,22,4Z"
    })), _path355$3 || (_path355$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.63,18l7,6H30V22H16.37l-7-6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V18Z"
    })), children);
  });
  var TimePlot16 = /*#__PURE__*/React__default['default'].forwardRef(function TimePlot16(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$3 || (_path356$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.586 13L21 10.414 21 6 23 6 23 9.586 25 11.586 23.586 13z"
    })), _path357$3 || (_path357$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,18a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,22,18ZM22,4a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,22,4Z"
    })), _path358$3 || (_path358$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.63,18l7,6H30V22H16.37l-7-6H4V2H2V28a2.0025,2.0025,0,0,0,2,2H30V28H4V18Z"
    })), children);
  });
  var Timer32 = /*#__PURE__*/React__default['default'].forwardRef(function Timer32(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$3 || (_path359$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V20H15zM13 2H19V4H13z"
    })), _path360$3 || (_path360$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"
    })), children);
  });
  var Timer24 = /*#__PURE__*/React__default['default'].forwardRef(function Timer24(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$3 || (_path361$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V20H15zM13 2H19V4H13z"
    })), _path362$3 || (_path362$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"
    })), children);
  });
  var Timer20 = /*#__PURE__*/React__default['default'].forwardRef(function Timer20(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$3 || (_path363$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V20H15zM13 2H19V4H13z"
    })), _path364$3 || (_path364$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"
    })), children);
  });
  var Timer16 = /*#__PURE__*/React__default['default'].forwardRef(function Timer16(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$3 || (_path365$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 11H17V20H15zM13 2H19V4H13z"
    })), _path366$3 || (_path366$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"
    })), children);
  });
  var ToolBox32 = /*#__PURE__*/React__default['default'].forwardRef(function ToolBox32(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$3 || (_path367$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"
    })), children);
  });
  var ToolBox24 = /*#__PURE__*/React__default['default'].forwardRef(function ToolBox24(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368$3 || (_path368$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"
    })), children);
  });
  var ToolBox20 = /*#__PURE__*/React__default['default'].forwardRef(function ToolBox20(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$3 || (_path369$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"
    })), children);
  });
  var ToolBox16 = /*#__PURE__*/React__default['default'].forwardRef(function ToolBox16(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path370$3 || (_path370$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"
    })), children);
  });
  var ToolKit32 = /*#__PURE__*/React__default['default'].forwardRef(function ToolKit32(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$3 || (_path371$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9141,24.5l4.257-4.2568-1.414-1.4141L7.5,23.0859l-.793-.7929a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l3,3a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414ZM5,28.5859,3.4141,27,6,24.4141,7.5859,26Z"
    })), _path372$3 || (_path372$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6.0067,6.0067,0,0,1-6-6,5.84,5.84,0,0,1,.2109-1.5469l-8.664-8.6638A5.8483,5.8483,0,0,1,8,14,5.9757,5.9757,0,0,1,2.4228,5.8164l.5577-1.4219L6.293,7.707a1.0233,1.0233,0,0,0,1.4135,0,.999.999,0,0,0,0-1.4141L4.3936,2.979l1.4233-.5571A5.9772,5.9772,0,0,1,14,8a5.84,5.84,0,0,1-.2109,1.5469l8.664,8.6635A5.8548,5.8548,0,0,1,24,18a5.9755,5.9755,0,0,1,5.5771,8.1836L29.02,27.6055,25.707,24.293a1.0233,1.0233,0,0,0-1.4135,0,.999.999,0,0,0-.0005,1.4141L27.6055,29.02l-1.4219.5579A5.96,5.96,0,0,1,24,30ZM10.0625,11.4763,20.5234,21.9375l-.2392.6094A3.9754,3.9754,0,0,0,23.75,27.9922l-.8711-.8711a2.9992,2.9992,0,0,1,0-4.2424,3.0721,3.0721,0,0,1,4.2427.0005l.8706.8708a3.9759,3.9759,0,0,0-5.4458-3.4658l-.6094.2385-10.46-10.46.2392-.6094A3.9755,3.9755,0,0,0,8.2505,4.0078l.8706.8711a2.9992,2.9992,0,0,1,0,4.2424,3.0721,3.0721,0,0,1-4.2427-.0005L4.0078,8.25a3.975,3.975,0,0,0,5.4453,3.4656Z"
    })), _path373$3 || (_path373$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1226,2.85a3.0716,3.0716,0,0,0-4.2422,0L17.4,10.33l1.4141,1.414,7.48-7.48a1.0244,1.0244,0,0,1,1.4141,0,1.002,1.002,0,0,1,0,1.4145l-7.48,7.48,1.414,1.4141,7.48-7.4795A3.0031,3.0031,0,0,0,29.1226,2.85Z"
    })), children);
  });
  var ToolKit24 = /*#__PURE__*/React__default['default'].forwardRef(function ToolKit24(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$3 || (_path374$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9141,24.5l4.257-4.2568-1.414-1.4141L7.5,23.0859l-.793-.7929a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l3,3a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414ZM5,28.5859,3.4141,27,6,24.4141,7.5859,26Z"
    })), _path375$3 || (_path375$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6.0067,6.0067,0,0,1-6-6,5.84,5.84,0,0,1,.2109-1.5469l-8.664-8.6638A5.8483,5.8483,0,0,1,8,14,5.9757,5.9757,0,0,1,2.4228,5.8164l.5577-1.4219L6.293,7.707a1.0233,1.0233,0,0,0,1.4135,0,.999.999,0,0,0,0-1.4141L4.3936,2.979l1.4233-.5571A5.9772,5.9772,0,0,1,14,8a5.84,5.84,0,0,1-.2109,1.5469l8.664,8.6635A5.8548,5.8548,0,0,1,24,18a5.9755,5.9755,0,0,1,5.5771,8.1836L29.02,27.6055,25.707,24.293a1.0233,1.0233,0,0,0-1.4135,0,.999.999,0,0,0-.0005,1.4141L27.6055,29.02l-1.4219.5579A5.96,5.96,0,0,1,24,30ZM10.0625,11.4763,20.5234,21.9375l-.2392.6094A3.9754,3.9754,0,0,0,23.75,27.9922l-.8711-.8711a2.9992,2.9992,0,0,1,0-4.2424,3.0721,3.0721,0,0,1,4.2427.0005l.8706.8708a3.9759,3.9759,0,0,0-5.4458-3.4658l-.6094.2385-10.46-10.46.2392-.6094A3.9755,3.9755,0,0,0,8.2505,4.0078l.8706.8711a2.9992,2.9992,0,0,1,0,4.2424,3.0721,3.0721,0,0,1-4.2427-.0005L4.0078,8.25a3.975,3.975,0,0,0,5.4453,3.4656Z"
    })), _path376$3 || (_path376$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1226,2.85a3.0716,3.0716,0,0,0-4.2422,0L17.4,10.33l1.4141,1.414,7.48-7.48a1.0244,1.0244,0,0,1,1.4141,0,1.002,1.002,0,0,1,0,1.4145l-7.48,7.48,1.414,1.4141,7.48-7.4795A3.0031,3.0031,0,0,0,29.1226,2.85Z"
    })), children);
  });
  var ToolKit20 = /*#__PURE__*/React__default['default'].forwardRef(function ToolKit20(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path377$3 || (_path377$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9141,24.5l4.257-4.2568-1.414-1.4141L7.5,23.0859l-.793-.7929a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l3,3a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414ZM5,28.5859,3.4141,27,6,24.4141,7.5859,26Z"
    })), _path378$3 || (_path378$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6.0067,6.0067,0,0,1-6-6,5.84,5.84,0,0,1,.2109-1.5469l-8.664-8.6638A5.8483,5.8483,0,0,1,8,14,5.9757,5.9757,0,0,1,2.4228,5.8164l.5577-1.4219L6.293,7.707a1.0233,1.0233,0,0,0,1.4135,0,.999.999,0,0,0,0-1.4141L4.3936,2.979l1.4233-.5571A5.9772,5.9772,0,0,1,14,8a5.84,5.84,0,0,1-.2109,1.5469l8.664,8.6635A5.8548,5.8548,0,0,1,24,18a5.9755,5.9755,0,0,1,5.5771,8.1836L29.02,27.6055,25.707,24.293a1.0233,1.0233,0,0,0-1.4135,0,.999.999,0,0,0-.0005,1.4141L27.6055,29.02l-1.4219.5579A5.96,5.96,0,0,1,24,30ZM10.0625,11.4763,20.5234,21.9375l-.2392.6094A3.9754,3.9754,0,0,0,23.75,27.9922l-.8711-.8711a2.9992,2.9992,0,0,1,0-4.2424,3.0721,3.0721,0,0,1,4.2427.0005l.8706.8708a3.9759,3.9759,0,0,0-5.4458-3.4658l-.6094.2385-10.46-10.46.2392-.6094A3.9755,3.9755,0,0,0,8.2505,4.0078l.8706.8711a2.9992,2.9992,0,0,1,0,4.2424,3.0721,3.0721,0,0,1-4.2427-.0005L4.0078,8.25a3.975,3.975,0,0,0,5.4453,3.4656Z"
    })), _path379$3 || (_path379$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1226,2.85a3.0716,3.0716,0,0,0-4.2422,0L17.4,10.33l1.4141,1.414,7.48-7.48a1.0244,1.0244,0,0,1,1.4141,0,1.002,1.002,0,0,1,0,1.4145l-7.48,7.48,1.414,1.4141,7.48-7.4795A3.0031,3.0031,0,0,0,29.1226,2.85Z"
    })), children);
  });
  var ToolKit16 = /*#__PURE__*/React__default['default'].forwardRef(function ToolKit16(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$3 || (_path380$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.9141,24.5l4.257-4.2568-1.414-1.4141L7.5,23.0859l-.793-.7929a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l3,3a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414ZM5,28.5859,3.4141,27,6,24.4141,7.5859,26Z"
    })), _path381$3 || (_path381$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6.0067,6.0067,0,0,1-6-6,5.84,5.84,0,0,1,.2109-1.5469l-8.664-8.6638A5.8483,5.8483,0,0,1,8,14,5.9757,5.9757,0,0,1,2.4228,5.8164l.5577-1.4219L6.293,7.707a1.0233,1.0233,0,0,0,1.4135,0,.999.999,0,0,0,0-1.4141L4.3936,2.979l1.4233-.5571A5.9772,5.9772,0,0,1,14,8a5.84,5.84,0,0,1-.2109,1.5469l8.664,8.6635A5.8548,5.8548,0,0,1,24,18a5.9755,5.9755,0,0,1,5.5771,8.1836L29.02,27.6055,25.707,24.293a1.0233,1.0233,0,0,0-1.4135,0,.999.999,0,0,0-.0005,1.4141L27.6055,29.02l-1.4219.5579A5.96,5.96,0,0,1,24,30ZM10.0625,11.4763,20.5234,21.9375l-.2392.6094A3.9754,3.9754,0,0,0,23.75,27.9922l-.8711-.8711a2.9992,2.9992,0,0,1,0-4.2424,3.0721,3.0721,0,0,1,4.2427.0005l.8706.8708a3.9759,3.9759,0,0,0-5.4458-3.4658l-.6094.2385-10.46-10.46.2392-.6094A3.9755,3.9755,0,0,0,8.2505,4.0078l.8706.8711a2.9992,2.9992,0,0,1,0,4.2424,3.0721,3.0721,0,0,1-4.2427-.0005L4.0078,8.25a3.975,3.975,0,0,0,5.4453,3.4656Z"
    })), _path382$3 || (_path382$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1226,2.85a3.0716,3.0716,0,0,0-4.2422,0L17.4,10.33l1.4141,1.414,7.48-7.48a1.0244,1.0244,0,0,1,1.4141,0,1.002,1.002,0,0,1,0,1.4145l-7.48,7.48,1.414,1.4141,7.48-7.4795A3.0031,3.0031,0,0,0,29.1226,2.85Z"
    })), children);
  });
  var Tools32 = /*#__PURE__*/React__default['default'].forwardRef(function Tools32(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$3 || (_path383$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"
    })), children);
  });

  var _path$3, _path2$3, _path3$3, _path4$3, _path5$3, _path6$3, _path7$3, _path8$3, _path9$3, _path10$3, _path11$3, _path12$3, _path13$3, _path14$3, _path15$3, _path16$3, _path17$3, _path18$3, _path19$3, _path20$3, _path21$3, _path22$3, _path23$3, _path24$3, _path25$3, _path26$3, _path27$3, _path28$3, _path29$3, _path30$3, _path31$3, _path32$3, _path33$3, _path34$3, _path35$3, _path36$3, _path37$3, _path38$3, _path39$3, _path40$3, _path41$3, _path42$3, _path43$3, _path44$3, _path45$3, _path46$3, _path47$3, _path48$3, _path49$3, _path50$3, _path51$3, _path52$3, _path53$3, _path54$3, _path55$3, _path56$3, _path57$3, _path58$3, _path59$3, _path60$3, _path61$3, _path62$3, _path63$3, _path64$3, _path65$3, _path66$3, _path67$3, _path68$3, _path69$3, _path70$3, _path71$3, _path72$3, _path73$3, _path74$3, _path75$3, _path76$3, _path77$3, _path78$3, _path79$3, _path80$3, _path81$3, _path82$3, _path83$3, _path84$3, _path85$3, _path86$3, _path87$3, _path88$3, _path89$3, _path90$3, _path91$3, _path92$3, _path93$3, _path94$3, _path95$3, _path96$3, _path97$3, _path98$3, _path99$3, _path100$3, _path101$3, _path102$3, _path103$3, _path104$3, _path105$3, _path106$3, _path107$3, _path108$3, _path109$3, _path110$3, _path111$3, _path112$3, _path113$3, _path114$3, _path115$3, _path116$3, _path117$3, _path118$3, _path119$3, _path120$3, _path121$3, _path122$3, _path123$3, _path124$3, _path125$3, _path126$3, _path127$3, _path128$3, _path129$3, _path130$3, _path131$3, _path132$3, _path133$3, _path134$3, _path135$3, _path136$3, _path137$3, _path138$3, _path139$3, _path140$3, _path141$3, _path142$3, _path143$3, _path144$3, _path145$3, _path146$3, _path147$3, _path148$3, _path149$3, _path150$3, _path151$3, _path152$3, _path153$3, _path154$3, _path155$3, _path156$3, _path157$3, _path158$3, _path159$3, _path160$3, _path161$3, _path162$3, _path163$3, _path164$3, _path165$3, _path166$3, _path167$3, _path168$3, _path169$3, _path170$3, _path171$3, _path172$3, _path173$3, _path174$3, _path175$3, _path176$3, _path177$2, _path178$2, _path179$2, _path180$2, _path181$2, _path182$2, _path183$2, _path184$2, _path185$2, _path186$2, _path187$2, _path188$2, _path189$2, _path190$2, _path191$2, _path192$2, _path193$2, _path194$2, _path195$2, _path196$2, _path197$2, _path198$2, _path199$2, _path200$2, _path201$2, _path202$2, _path203$2, _path204$2, _path205$2, _path206$2, _path207$2, _path208$2, _path209$2, _path210$2, _path211$2, _path212$2, _path213$2, _path214$2, _path215$2, _path216$2, _path217$2, _path218$2, _path219$2, _path220$2, _path221$2, _path222$2, _path223$2, _path224$2, _path225$2, _path226$2, _path227$2, _path228$2, _path229$2, _path230$2, _path231$2, _path232$2, _path233$2, _path234$2, _path235$2, _path236$2, _path237$2, _path238$2, _path239$2, _path240$2, _path241$2, _path242$2, _path243$2, _path244$2, _path245$2, _path246$2, _path247$2, _path248$2, _path249$2, _path250$2, _path251$2, _path252$2, _path253$2, _path254$2, _path255$2, _path256$2, _path257$2, _path258$2, _path259$2, _path260$2, _path261$2, _path262$2, _path263$2, _path264$2, _path265$2, _path266$2, _path267$2, _path268$2, _path269$2, _path270$2, _path271$2, _path272$2, _path273$2, _path274$2, _path275$2, _path276$2, _path277$2, _path278$2, _path279$2, _path280$2, _path281$2, _path282$2, _path283$2, _path284$2, _path285$2, _path286$2, _path287$2, _path288$2, _path289$2, _path290$2, _path291$2, _path292$2, _path293$2, _path294$2, _path295$2, _path296$2, _path297$2, _path298$2, _path299$2, _path300$2, _path301$2, _path302$2, _path303$2, _path304$2, _path305$2, _path306$2, _path307$2, _path308$2, _path309$2, _path310$2, _path311$2, _path312$2, _path313$2, _path314$2, _path315$2, _path316$2, _path317$2, _path318$2, _path319$2, _path320$2, _path321$2, _path322$2, _path323$2, _path324$2, _path325$2, _path326$2, _path327$2, _path328$2, _path329$2, _path330$2, _path331$2, _path332$2, _path333$2, _path334$2, _path335$2, _path336$2, _path337$2, _path338$2, _path339$2, _path340$2, _path341$2, _path342$2, _path343$2, _path344$2, _path345$2, _path346$2, _path347$2, _path348$2, _path349$2, _path350$2, _path351$2, _path352$2, _path353$2, _path354$2, _path355$2, _path356$2, _path357$2, _path358$2, _path359$2, _path360$2, _path361$2, _path362$2, _path363$2, _path364$2, _path365$2, _circle$2, _path366$2, _path367$2, _circle2$2, _path368$2, _path369$2, _circle3$2, _path370$2, _path371$2, _circle4$2, _path372$2, _path373$2, _path374$2, _path375$2, _path376$2, _path377$2, _path378$2, _path379$2, _path380$2, _path381$2, _path382$2, _path383$2, _path384$2, _path385$2, _path386$2, _path387$2, _path388$2, _path389$2, _path390$2, _path391$2, _path392$2, _path393$2, _path394$2, _path395$2, _path396$2, _path397$2, _path398$2, _path399$1, _path400$1, _path401$1, _path402$1, _path403$1, _path404$1, _path405$1, _path406$1, _path407$1, _path408$1, _path409$1, _path410$1, _path411$1, _path412$1, _path413$1, _path414$1, _path415$1;

  var _excluded$3 = ["children"],
      _excluded2$3 = ["children"],
      _excluded3$3 = ["children"],
      _excluded4$3 = ["children"],
      _excluded5$3 = ["children"],
      _excluded6$3 = ["children"],
      _excluded7$3 = ["children"],
      _excluded8$3 = ["children"],
      _excluded9$3 = ["children"],
      _excluded10$3 = ["children"],
      _excluded11$3 = ["children"],
      _excluded12$3 = ["children"],
      _excluded13$3 = ["children"],
      _excluded14$3 = ["children"],
      _excluded15$3 = ["children"],
      _excluded16$3 = ["children"],
      _excluded17$3 = ["children"],
      _excluded18$3 = ["children"],
      _excluded19$3 = ["children"],
      _excluded20$3 = ["children"],
      _excluded21$3 = ["children"],
      _excluded22$3 = ["children"],
      _excluded23$3 = ["children"],
      _excluded24$3 = ["children"],
      _excluded25$3 = ["children"],
      _excluded26$3 = ["children"],
      _excluded27$3 = ["children"],
      _excluded28$3 = ["children"],
      _excluded29$3 = ["children"],
      _excluded30$3 = ["children"],
      _excluded31$3 = ["children"],
      _excluded32$3 = ["children"],
      _excluded33$3 = ["children"],
      _excluded34$3 = ["children"],
      _excluded35$3 = ["children"],
      _excluded36$3 = ["children"],
      _excluded37$3 = ["children"],
      _excluded38$3 = ["children"],
      _excluded39$3 = ["children"],
      _excluded40$3 = ["children"],
      _excluded41$3 = ["children"],
      _excluded42$3 = ["children"],
      _excluded43$3 = ["children"],
      _excluded44$3 = ["children"],
      _excluded45$3 = ["children"],
      _excluded46$3 = ["children"],
      _excluded47$3 = ["children"],
      _excluded48$3 = ["children"],
      _excluded49$3 = ["children"],
      _excluded50$3 = ["children"],
      _excluded51$3 = ["children"],
      _excluded52$3 = ["children"],
      _excluded53$3 = ["children"],
      _excluded54$3 = ["children"],
      _excluded55$3 = ["children"],
      _excluded56$3 = ["children"],
      _excluded57$3 = ["children"],
      _excluded58$3 = ["children"],
      _excluded59$3 = ["children"],
      _excluded60$3 = ["children"],
      _excluded61$3 = ["children"],
      _excluded62$3 = ["children"],
      _excluded63$3 = ["children"],
      _excluded64$3 = ["children"],
      _excluded65$3 = ["children"],
      _excluded66$3 = ["children"],
      _excluded67$3 = ["children"],
      _excluded68$3 = ["children"],
      _excluded69$3 = ["children"],
      _excluded70$3 = ["children"],
      _excluded71$3 = ["children"],
      _excluded72$3 = ["children"],
      _excluded73$3 = ["children"],
      _excluded74$3 = ["children"],
      _excluded75$3 = ["children"],
      _excluded76$3 = ["children"],
      _excluded77$3 = ["children"],
      _excluded78$3 = ["children"],
      _excluded79$3 = ["children"],
      _excluded80$3 = ["children"],
      _excluded81$3 = ["children"],
      _excluded82$3 = ["children"],
      _excluded83$3 = ["children"],
      _excluded84$3 = ["children"],
      _excluded85$3 = ["children"],
      _excluded86$3 = ["children"],
      _excluded87$3 = ["children"],
      _excluded88$3 = ["children"],
      _excluded89$3 = ["children"],
      _excluded90$3 = ["children"],
      _excluded91$3 = ["children"],
      _excluded92$3 = ["children"],
      _excluded93$3 = ["children"],
      _excluded94$3 = ["children"],
      _excluded95$3 = ["children"],
      _excluded96$3 = ["children"],
      _excluded97$3 = ["children"],
      _excluded98$3 = ["children"],
      _excluded99$3 = ["children"],
      _excluded100$3 = ["children"],
      _excluded101$3 = ["children"],
      _excluded102$3 = ["children"],
      _excluded103$3 = ["children"],
      _excluded104$3 = ["children"],
      _excluded105$3 = ["children"],
      _excluded106$3 = ["children"],
      _excluded107$3 = ["children"],
      _excluded108$3 = ["children"],
      _excluded109$3 = ["children"],
      _excluded110$3 = ["children"],
      _excluded111$3 = ["children"],
      _excluded112$3 = ["children"],
      _excluded113$3 = ["children"],
      _excluded114$3 = ["children"],
      _excluded115$3 = ["children"],
      _excluded116$3 = ["children"],
      _excluded117$3 = ["children"],
      _excluded118$3 = ["children"],
      _excluded119$2 = ["children"],
      _excluded120$2 = ["children"],
      _excluded121$2 = ["children"],
      _excluded122$2 = ["children"],
      _excluded123$2 = ["children"],
      _excluded124$2 = ["children"],
      _excluded125$2 = ["children"],
      _excluded126$2 = ["children"],
      _excluded127$2 = ["children"],
      _excluded128$2 = ["children"],
      _excluded129$2 = ["children"],
      _excluded130$2 = ["children"],
      _excluded131$2 = ["children"],
      _excluded132$2 = ["children"],
      _excluded133$2 = ["children"],
      _excluded134$2 = ["children"],
      _excluded135$2 = ["children"],
      _excluded136$2 = ["children"],
      _excluded137$2 = ["children"],
      _excluded138$2 = ["children"],
      _excluded139$2 = ["children"],
      _excluded140$2 = ["children"],
      _excluded141$2 = ["children"],
      _excluded142$2 = ["children"],
      _excluded143$2 = ["children"],
      _excluded144$2 = ["children"],
      _excluded145$2 = ["children"],
      _excluded146$2 = ["children"],
      _excluded147$2 = ["children"],
      _excluded148$2 = ["children"],
      _excluded149$2 = ["children"],
      _excluded150$2 = ["children"],
      _excluded151$2 = ["children"],
      _excluded152$2 = ["children"],
      _excluded153$2 = ["children"],
      _excluded154$2 = ["children"],
      _excluded155$2 = ["children"],
      _excluded156$2 = ["children"],
      _excluded157$2 = ["children"],
      _excluded158$2 = ["children"],
      _excluded159$2 = ["children"],
      _excluded160$2 = ["children"],
      _excluded161$2 = ["children"],
      _excluded162$2 = ["children"],
      _excluded163$2 = ["children"],
      _excluded164$2 = ["children"],
      _excluded165$2 = ["children"],
      _excluded166$2 = ["children"],
      _excluded167$2 = ["children"],
      _excluded168$2 = ["children"],
      _excluded169$2 = ["children"],
      _excluded170$2 = ["children"],
      _excluded171$2 = ["children"],
      _excluded172$2 = ["children"],
      _excluded173$2 = ["children"],
      _excluded174$2 = ["children"],
      _excluded175$2 = ["children"],
      _excluded176$2 = ["children"],
      _excluded177$2 = ["children"],
      _excluded178$2 = ["children"],
      _excluded179$2 = ["children"],
      _excluded180$2 = ["children"],
      _excluded181$2 = ["children"],
      _excluded182$2 = ["children"],
      _excluded183$2 = ["children"],
      _excluded184$2 = ["children"],
      _excluded185$2 = ["children"],
      _excluded186$2 = ["children"],
      _excluded187$2 = ["children"],
      _excluded188$2 = ["children"],
      _excluded189$2 = ["children"],
      _excluded190$2 = ["children"],
      _excluded191$2 = ["children"],
      _excluded192$2 = ["children"],
      _excluded193$2 = ["children"],
      _excluded194$2 = ["children"],
      _excluded195$2 = ["children"],
      _excluded196$2 = ["children"],
      _excluded197$2 = ["children"],
      _excluded198$2 = ["children"],
      _excluded199$2 = ["children"],
      _excluded200$2 = ["children"],
      _excluded201$2 = ["children"],
      _excluded202$2 = ["children"],
      _excluded203$2 = ["children"],
      _excluded204$2 = ["children"],
      _excluded205$2 = ["children"],
      _excluded206$2 = ["children"],
      _excluded207$2 = ["children"],
      _excluded208$2 = ["children"],
      _excluded209$2 = ["children"],
      _excluded210$2 = ["children"],
      _excluded211$2 = ["children"],
      _excluded212$2 = ["children"],
      _excluded213$2 = ["children"],
      _excluded214$2 = ["children"],
      _excluded215$2 = ["children"],
      _excluded216$2 = ["children"],
      _excluded217$2 = ["children"],
      _excluded218$2 = ["children"],
      _excluded219$2 = ["children"],
      _excluded220$2 = ["children"],
      _excluded221$2 = ["children"],
      _excluded222$2 = ["children"],
      _excluded223$2 = ["children"],
      _excluded224$2 = ["children"],
      _excluded225$2 = ["children"],
      _excluded226$2 = ["children"],
      _excluded227$2 = ["children"],
      _excluded228$2 = ["children"],
      _excluded229$2 = ["children"],
      _excluded230$2 = ["children"],
      _excluded231$2 = ["children"],
      _excluded232$2 = ["children"],
      _excluded233$2 = ["children"],
      _excluded234$2 = ["children"],
      _excluded235$2 = ["children"],
      _excluded236$2 = ["children"],
      _excluded237$2 = ["children"],
      _excluded238$2 = ["children"],
      _excluded239$2 = ["children"],
      _excluded240$2 = ["children"],
      _excluded241$2 = ["children"],
      _excluded242$2 = ["children"],
      _excluded243$2 = ["children"],
      _excluded244$2 = ["children"],
      _excluded245$2 = ["children"],
      _excluded246$2 = ["children"],
      _excluded247$2 = ["children"],
      _excluded248$2 = ["children"],
      _excluded249$2 = ["children"],
      _excluded250$2 = ["children"];
  var Tools24 = /*#__PURE__*/React__default['default'].forwardRef(function Tools24(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$3 || (_path$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"
    })), children);
  });
  var Tools20 = /*#__PURE__*/React__default['default'].forwardRef(function Tools20(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$3 || (_path2$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"
    })), children);
  });
  var Tools16 = /*#__PURE__*/React__default['default'].forwardRef(function Tools16(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$3 || (_path3$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"
    })), children);
  });
  var ToolsAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function ToolsAlt32(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$3 || (_path4$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4148,21.6664,23.08,15.3305l6.3337-6.334a2,2,0,0,0,.0017-2.8281l-.0017-.002-3.58-3.58a2,2,0,0,0-2.8284-.0015l-.0017.0015L16.67,8.9194,10.3352,2.5839a2.0037,2.0037,0,0,0-2.8281.0005L2.5854,7.5063a2.0011,2.0011,0,0,0,0,2.8286l6.3338,6.3345L2,23.5883V30H8.4106l6.919-6.9194,6.3354,6.3364a2.0076,2.0076,0,0,0,2.8291,0l4.9207-4.9223A2.0011,2.0011,0,0,0,29.4148,21.6664Zm-5.0015-17.67,3.59,3.59L21.67,13.92l-3.59-3.59ZM8,28H4V24.4086L10.3291,18.08l3.677,3.6778Zm15.08.0035L4,8.9213,8.9219,4,12.71,7.7875,10.458,10.04l1.4153,1.4141,2.2507-2.252,4.1294,4.1294L16,15.5834l1.416,1.4141,2.2517-2.252,4.13,4.13-2.2517,2.251,1.4141,1.415L25.2117,20.29l2.7907,2.791Z"
    })), children);
  });
  var ToolsAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function ToolsAlt24(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$3 || (_path5$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4148,21.6664,23.08,15.3305l6.3337-6.334a2,2,0,0,0,.0017-2.8281l-.0017-.002-3.58-3.58a2,2,0,0,0-2.8284-.0015l-.0017.0015L16.67,8.9194,10.3352,2.5839a2.0037,2.0037,0,0,0-2.8281.0005L2.5854,7.5063a2.0011,2.0011,0,0,0,0,2.8286l6.3338,6.3345L2,23.5883V30H8.4106l6.919-6.9194,6.3354,6.3364a2.0076,2.0076,0,0,0,2.8291,0l4.9207-4.9223A2.0011,2.0011,0,0,0,29.4148,21.6664Zm-5.0015-17.67,3.59,3.59L21.67,13.92l-3.59-3.59ZM8,28H4V24.4086L10.3291,18.08l3.677,3.6778Zm15.08.0035L4,8.9213,8.9219,4,12.71,7.7875,10.458,10.04l1.4153,1.4141,2.2507-2.252,4.1294,4.1294L16,15.5834l1.416,1.4141,2.2517-2.252,4.13,4.13-2.2517,2.251,1.4141,1.415L25.2117,20.29l2.7907,2.791Z"
    })), children);
  });
  var ToolsAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function ToolsAlt20(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path6$3 || (_path6$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4148,21.6664,23.08,15.3305l6.3337-6.334a2,2,0,0,0,.0017-2.8281l-.0017-.002-3.58-3.58a2,2,0,0,0-2.8284-.0015l-.0017.0015L16.67,8.9194,10.3352,2.5839a2.0037,2.0037,0,0,0-2.8281.0005L2.5854,7.5063a2.0011,2.0011,0,0,0,0,2.8286l6.3338,6.3345L2,23.5883V30H8.4106l6.919-6.9194,6.3354,6.3364a2.0076,2.0076,0,0,0,2.8291,0l4.9207-4.9223A2.0011,2.0011,0,0,0,29.4148,21.6664Zm-5.0015-17.67,3.59,3.59L21.67,13.92l-3.59-3.59ZM8,28H4V24.4086L10.3291,18.08l3.677,3.6778Zm15.08.0035L4,8.9213,8.9219,4,12.71,7.7875,10.458,10.04l1.4153,1.4141,2.2507-2.252,4.1294,4.1294L16,15.5834l1.416,1.4141,2.2517-2.252,4.13,4.13-2.2517,2.251,1.4141,1.415L25.2117,20.29l2.7907,2.791Z"
    })), children);
  });
  var ToolsAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function ToolsAlt16(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$3 || (_path7$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4148,21.6664,23.08,15.3305l6.3337-6.334a2,2,0,0,0,.0017-2.8281l-.0017-.002-3.58-3.58a2,2,0,0,0-2.8284-.0015l-.0017.0015L16.67,8.9194,10.3352,2.5839a2.0037,2.0037,0,0,0-2.8281.0005L2.5854,7.5063a2.0011,2.0011,0,0,0,0,2.8286l6.3338,6.3345L2,23.5883V30H8.4106l6.919-6.9194,6.3354,6.3364a2.0076,2.0076,0,0,0,2.8291,0l4.9207-4.9223A2.0011,2.0011,0,0,0,29.4148,21.6664Zm-5.0015-17.67,3.59,3.59L21.67,13.92l-3.59-3.59ZM8,28H4V24.4086L10.3291,18.08l3.677,3.6778Zm15.08.0035L4,8.9213,8.9219,4,12.71,7.7875,10.458,10.04l1.4153,1.4141,2.2507-2.252,4.1294,4.1294L16,15.5834l1.416,1.4141,2.2517-2.252,4.13,4.13-2.2517,2.251,1.4141,1.415L25.2117,20.29l2.7907,2.791Z"
    })), children);
  });
  var Tornado32 = /*#__PURE__*/React__default['default'].forwardRef(function Tornado32(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8$3 || (_path8$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26H20V28H16zM12 22H18V24H12zM8 18H18V20H8zM8 14H20V16H8zM10 10H24V12H10zM8 6H26V8H8z"
    })), children);
  });
  var Tornado24 = /*#__PURE__*/React__default['default'].forwardRef(function Tornado24(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$3 || (_path9$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26H20V28H16zM12 22H18V24H12zM8 18H18V20H8zM8 14H20V16H8zM10 10H24V12H10zM8 6H26V8H8z"
    })), children);
  });
  var Tornado20 = /*#__PURE__*/React__default['default'].forwardRef(function Tornado20(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$3 || (_path10$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26H20V28H16zM12 22H18V24H12zM8 18H18V20H8zM8 14H20V16H8zM10 10H24V12H10zM8 6H26V8H8z"
    })), children);
  });
  var Tornado16 = /*#__PURE__*/React__default['default'].forwardRef(function Tornado16(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$3 || (_path11$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 26H20V28H16zM12 22H18V24H12zM8 18H18V20H8zM8 14H20V16H8zM10 10H24V12H10zM8 6H26V8H8z"
    })), children);
  });
  var TornadoWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function TornadoWarning32(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$3 || (_path12$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 4H18V6H2zM4 8H16V10H4zM2 12H14V14H2zM2 16H12V18H2zM4 20H12V22H4zM8 24H14V26H8zM12 28H16V30H12z"
    })), _path13$3 || (_path13$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path14$3 || (_path14$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var TornadoWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function TornadoWarning24(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$3 || (_path15$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 4H18V6H2zM4 8H16V10H4zM2 12H14V14H2zM2 16H12V18H2zM4 20H12V22H4zM8 24H14V26H8zM12 28H16V30H12z"
    })), _path16$3 || (_path16$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path17$3 || (_path17$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var TornadoWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function TornadoWarning20(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$3 || (_path18$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 4H18V6H2zM4 8H16V10H4zM2 12H14V14H2zM2 16H12V18H2zM4 20H12V22H4zM8 24H14V26H8zM12 28H16V30H12z"
    })), _path19$3 || (_path19$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path20$3 || (_path20$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var TornadoWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function TornadoWarning16(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$3 || (_path21$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 4H18V6H2zM4 8H16V10H4zM2 12H14V14H2zM2 16H12V18H2zM4 20H12V22H4zM8 24H14V26H8zM12 28H16V30H12z"
    })), _path22$3 || (_path22$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path23$3 || (_path23$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var Touch_132 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_132(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$3 || (_path24$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"
    })), _path25$3 || (_path25$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"
    })), children);
  });
  var Touch_124 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_124(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$3 || (_path26$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"
    })), _path27$3 || (_path27$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"
    })), children);
  });
  var Touch_120 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_120(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$3 || (_path28$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"
    })), _path29$3 || (_path29$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"
    })), children);
  });
  var Touch_116 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_116(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$3 || (_path30$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"
    })), _path31$3 || (_path31$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"
    })), children);
  });
  var Touch_1Filled32 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Filled32(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$3 || (_path32$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,2A6.0067,6.0067,0,0,0,7,8H9a4,4,0,0,1,8,0h2A6.0067,6.0067,0,0,0,13,2Z"
    })), _path33$3 || (_path33$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H16.5606a4,4,0,0,1-2.7088-1.0566L4.6513,20.4771A2.0018,2.0018,0,0,1,4.77,17.4219a2.0743,2.0743,0,0,1,2.6578.1728L11,20.8569V8a2,2,0,0,1,4,0v7a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v7A6,6,0,0,1,21,30Z"
    })), children);
  });
  var Touch_1Filled24 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Filled24(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$3 || (_path34$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,2A6.0067,6.0067,0,0,0,7,8H9a4,4,0,0,1,8,0h2A6.0067,6.0067,0,0,0,13,2Z"
    })), _path35$3 || (_path35$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H16.5606a4,4,0,0,1-2.7088-1.0566L4.6513,20.4771A2.0018,2.0018,0,0,1,4.77,17.4219a2.0743,2.0743,0,0,1,2.6578.1728L11,20.8569V8a2,2,0,0,1,4,0v7a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v7A6,6,0,0,1,21,30Z"
    })), children);
  });
  var Touch_1Filled20 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Filled20(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$3 || (_path36$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,2A6.0067,6.0067,0,0,0,7,8H9a4,4,0,0,1,8,0h2A6.0067,6.0067,0,0,0,13,2Z"
    })), _path37$3 || (_path37$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H16.5606a4,4,0,0,1-2.7088-1.0566L4.6513,20.4771A2.0018,2.0018,0,0,1,4.77,17.4219a2.0743,2.0743,0,0,1,2.6578.1728L11,20.8569V8a2,2,0,0,1,4,0v7a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v7A6,6,0,0,1,21,30Z"
    })), children);
  });
  var Touch_1Filled16 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Filled16(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$3 || (_path38$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,2A6.0067,6.0067,0,0,0,7,8H9a4,4,0,0,1,8,0h2A6.0067,6.0067,0,0,0,13,2Z"
    })), _path39$3 || (_path39$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,30H16.5606a4,4,0,0,1-2.7088-1.0566L4.6513,20.4771A2.0018,2.0018,0,0,1,4.77,17.4219a2.0743,2.0743,0,0,1,2.6578.1728L11,20.8569V8a2,2,0,0,1,4,0v7a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v1a2,2,0,0,1,4,0v7A6,6,0,0,1,21,30Z"
    })), children);
  });
  var Touch_1Down32 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Down32(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$3 || (_path40$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,24H18A5,5,0,0,1,8,24H6a7,7,0,0,0,14,0Z"
    })), _path41$3 || (_path41$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14V8a7.0085,7.0085,0,0,0-7-7H16a6.1457,6.1457,0,0,0-4.1055,1.5664L3.8833,9.874a2.9986,2.9986,0,0,0,3.881,4.55l.0008.0012L10,12.8955V24a3,3,0,0,0,6,0h0l0-5.1843a2.939,2.939,0,0,0,3.5294-1.2171A2.963,2.963,0,0,0,21,18a2.9936,2.9936,0,0,0,2.5292-1.4014A2.963,2.963,0,0,0,25,17,3.0033,3.0033,0,0,0,28,14Zm-2,0a1,1,0,0,1-2,0V13H22v2a1,1,0,0,1-2,0V13H18v3a1,1,0,0,1-2,0V13H14V24h.0005A1,1,0,0,1,12,24V9.1045L6.6,12.8008a.9993.9993,0,0,1-1.3081-1.5044l7.9507-7.2515A4.1483,4.1483,0,0,1,16,3h5a5.0059,5.0059,0,0,1,5,5Z"
    })), children);
  });
  var Touch_1Down24 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Down24(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path42$3 || (_path42$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,24H18A5,5,0,0,1,8,24H6a7,7,0,0,0,14,0Z"
    })), _path43$3 || (_path43$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14V8a7.0085,7.0085,0,0,0-7-7H16a6.1457,6.1457,0,0,0-4.1055,1.5664L3.8833,9.874a2.9986,2.9986,0,0,0,3.881,4.55l.0008.0012L10,12.8955V24a3,3,0,0,0,6,0h0l0-5.1843a2.939,2.939,0,0,0,3.5294-1.2171A2.963,2.963,0,0,0,21,18a2.9936,2.9936,0,0,0,2.5292-1.4014A2.963,2.963,0,0,0,25,17,3.0033,3.0033,0,0,0,28,14Zm-2,0a1,1,0,0,1-2,0V13H22v2a1,1,0,0,1-2,0V13H18v3a1,1,0,0,1-2,0V13H14V24h.0005A1,1,0,0,1,12,24V9.1045L6.6,12.8008a.9993.9993,0,0,1-1.3081-1.5044l7.9507-7.2515A4.1483,4.1483,0,0,1,16,3h5a5.0059,5.0059,0,0,1,5,5Z"
    })), children);
  });
  var Touch_1Down20 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Down20(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path44$3 || (_path44$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,24H18A5,5,0,0,1,8,24H6a7,7,0,0,0,14,0Z"
    })), _path45$3 || (_path45$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14V8a7.0085,7.0085,0,0,0-7-7H16a6.1457,6.1457,0,0,0-4.1055,1.5664L3.8833,9.874a2.9986,2.9986,0,0,0,3.881,4.55l.0008.0012L10,12.8955V24a3,3,0,0,0,6,0h0l0-5.1843a2.939,2.939,0,0,0,3.5294-1.2171A2.963,2.963,0,0,0,21,18a2.9936,2.9936,0,0,0,2.5292-1.4014A2.963,2.963,0,0,0,25,17,3.0033,3.0033,0,0,0,28,14Zm-2,0a1,1,0,0,1-2,0V13H22v2a1,1,0,0,1-2,0V13H18v3a1,1,0,0,1-2,0V13H14V24h.0005A1,1,0,0,1,12,24V9.1045L6.6,12.8008a.9993.9993,0,0,1-1.3081-1.5044l7.9507-7.2515A4.1483,4.1483,0,0,1,16,3h5a5.0059,5.0059,0,0,1,5,5Z"
    })), children);
  });
  var Touch_1Down16 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1Down16(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path46$3 || (_path46$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,24H18A5,5,0,0,1,8,24H6a7,7,0,0,0,14,0Z"
    })), _path47$3 || (_path47$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,14V8a7.0085,7.0085,0,0,0-7-7H16a6.1457,6.1457,0,0,0-4.1055,1.5664L3.8833,9.874a2.9986,2.9986,0,0,0,3.881,4.55l.0008.0012L10,12.8955V24a3,3,0,0,0,6,0h0l0-5.1843a2.939,2.939,0,0,0,3.5294-1.2171A2.963,2.963,0,0,0,21,18a2.9936,2.9936,0,0,0,2.5292-1.4014A2.963,2.963,0,0,0,25,17,3.0033,3.0033,0,0,0,28,14Zm-2,0a1,1,0,0,1-2,0V13H22v2a1,1,0,0,1-2,0V13H18v3a1,1,0,0,1-2,0V13H14V24h.0005A1,1,0,0,1,12,24V9.1045L6.6,12.8008a.9993.9993,0,0,1-1.3081-1.5044l7.9507-7.2515A4.1483,4.1483,0,0,1,16,3h5a5.0059,5.0059,0,0,1,5,5Z"
    })), children);
  });
  var Touch_1DownFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1DownFilled32(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path48$3 || (_path48$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a6.0067,6.0067,0,0,1-6-6H9a4,4,0,0,0,8,0h2A6.0067,6.0067,0,0,1,13,30Z"
    })), _path49$3 || (_path49$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2H16.5606a4,4,0,0,0-2.7088,1.0566L4.6513,11.5229A2.0018,2.0018,0,0,0,4.77,14.5781a2.0743,2.0743,0,0,0,2.6578-.1728L11,11.1431V24a2,2,0,0,0,4,0V17a2,2,0,0,0,4,0V16a2,2,0,0,0,4,0V15a2,2,0,0,0,4,0V8A6,6,0,0,0,21,2Z"
    })), children);
  });
  var Touch_1DownFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1DownFilled24(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$3 || (_path50$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a6.0067,6.0067,0,0,1-6-6H9a4,4,0,0,0,8,0h2A6.0067,6.0067,0,0,1,13,30Z"
    })), _path51$3 || (_path51$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2H16.5606a4,4,0,0,0-2.7088,1.0566L4.6513,11.5229A2.0018,2.0018,0,0,0,4.77,14.5781a2.0743,2.0743,0,0,0,2.6578-.1728L11,11.1431V24a2,2,0,0,0,4,0V17a2,2,0,0,0,4,0V16a2,2,0,0,0,4,0V15a2,2,0,0,0,4,0V8A6,6,0,0,0,21,2Z"
    })), children);
  });
  var Touch_1DownFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1DownFilled20(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$3 || (_path52$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a6.0067,6.0067,0,0,1-6-6H9a4,4,0,0,0,8,0h2A6.0067,6.0067,0,0,1,13,30Z"
    })), _path53$3 || (_path53$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2H16.5606a4,4,0,0,0-2.7088,1.0566L4.6513,11.5229A2.0018,2.0018,0,0,0,4.77,14.5781a2.0743,2.0743,0,0,0,2.6578-.1728L11,11.1431V24a2,2,0,0,0,4,0V17a2,2,0,0,0,4,0V16a2,2,0,0,0,4,0V15a2,2,0,0,0,4,0V8A6,6,0,0,0,21,2Z"
    })), children);
  });
  var Touch_1DownFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_1DownFilled16(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$3 || (_path54$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a6.0067,6.0067,0,0,1-6-6H9a4,4,0,0,0,8,0h2A6.0067,6.0067,0,0,1,13,30Z"
    })), _path55$3 || (_path55$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,2H16.5606a4,4,0,0,0-2.7088,1.0566L4.6513,11.5229A2.0018,2.0018,0,0,0,4.77,14.5781a2.0743,2.0743,0,0,0,2.6578-.1728L11,11.1431V24a2,2,0,0,0,4,0V17a2,2,0,0,0,4,0V16a2,2,0,0,0,4,0V15a2,2,0,0,0,4,0V8A6,6,0,0,0,21,2Z"
    })), children);
  });
  var Touch_232 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_232(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$3 || (_path56$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), _path57$3 || (_path57$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"
    })), _path58$3 || (_path58$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"
    })), children);
  });
  var Touch_224 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_224(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$3 || (_path59$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), _path60$3 || (_path60$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"
    })), _path61$3 || (_path61$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"
    })), children);
  });
  var Touch_220 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_220(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$3 || (_path62$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), _path63$3 || (_path63$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"
    })), _path64$3 || (_path64$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"
    })), children);
  });
  var Touch_216 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_216(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$3 || (_path65$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), _path66$3 || (_path66$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"
    })), _path67$3 || (_path67$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"
    })), children);
  });
  var Touch_2Filled32 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_2Filled32(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$3 || (_path68$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a3.0033,3.0033,0,0,0-3,3v3h6V15A3.0033,3.0033,0,0,0,16,12Z"
    })), _path69$3 || (_path69$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a9.0092,9.0092,0,0,0-9,9V28H25V15A9.01,9.01,0,0,0,16,6Zm5,14H11V15a5,5,0,0,1,10,0Z"
    })), _path70$3 || (_path70$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), children);
  });
  var Touch_2Filled24 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_2Filled24(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$3 || (_path71$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a3.0033,3.0033,0,0,0-3,3v3h6V15A3.0033,3.0033,0,0,0,16,12Z"
    })), _path72$3 || (_path72$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a9.0092,9.0092,0,0,0-9,9V28H25V15A9.01,9.01,0,0,0,16,6Zm5,14H11V15a5,5,0,0,1,10,0Z"
    })), _path73$3 || (_path73$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), children);
  });
  var Touch_2Filled20 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_2Filled20(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$3 || (_path74$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a3.0033,3.0033,0,0,0-3,3v3h6V15A3.0033,3.0033,0,0,0,16,12Z"
    })), _path75$3 || (_path75$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a9.0092,9.0092,0,0,0-9,9V28H25V15A9.01,9.01,0,0,0,16,6Zm5,14H11V15a5,5,0,0,1,10,0Z"
    })), _path76$3 || (_path76$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), children);
  });
  var Touch_2Filled16 = /*#__PURE__*/React__default['default'].forwardRef(function Touch_2Filled16(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$3 || (_path77$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,12a3.0033,3.0033,0,0,0-3,3v3h6V15A3.0033,3.0033,0,0,0,16,12Z"
    })), _path78$3 || (_path78$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a9.0092,9.0092,0,0,0-9,9V28H25V15A9.01,9.01,0,0,0,16,6Zm5,14H11V15a5,5,0,0,1,10,0Z"
    })), _path79$3 || (_path79$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"
    })), children);
  });
  var TouchInteraction32 = /*#__PURE__*/React__default['default'].forwardRef(function TouchInteraction32(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path80$3 || (_path80$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,21V20a1,1,0,0,1,2,0V30h2V20a3.0033,3.0033,0,0,0-3-3,2.964,2.964,0,0,0-1.4708.4014,2.9541,2.9541,0,0,0-4-1A2.9934,2.9934,0,0,0,19,15a2.96,2.96,0,0,0-1,.1846L18,10h0a3,3,0,0,0-6,0V21.1045L9.7651,19.5752l-.0008.001a2.999,2.999,0,0,0-3.881,4.55L12.3223,30l1.3479-1.478L7.2915,22.7036A.9908.9908,0,0,1,7,22a1.0005,1.0005,0,0,1,1.6-.8008L14,24.8955V10a1,1,0,0,1,2,0h0V21h2V18a1,1,0,0,1,2,0v3h2V19a1,1,0,0,1,2,0v2Z"
    })), _path81$3 || (_path81$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22V10h6V4H4v6H8v2H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,12Z"
    })), children);
  });
  var TouchInteraction24 = /*#__PURE__*/React__default['default'].forwardRef(function TouchInteraction24(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path82$3 || (_path82$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,21V20a1,1,0,0,1,2,0V30h2V20a3.0033,3.0033,0,0,0-3-3,2.964,2.964,0,0,0-1.4708.4014,2.9541,2.9541,0,0,0-4-1A2.9934,2.9934,0,0,0,19,15a2.96,2.96,0,0,0-1,.1846L18,10h0a3,3,0,0,0-6,0V21.1045L9.7651,19.5752l-.0008.001a2.999,2.999,0,0,0-3.881,4.55L12.3223,30l1.3479-1.478L7.2915,22.7036A.9908.9908,0,0,1,7,22a1.0005,1.0005,0,0,1,1.6-.8008L14,24.8955V10a1,1,0,0,1,2,0h0V21h2V18a1,1,0,0,1,2,0v3h2V19a1,1,0,0,1,2,0v2Z"
    })), _path83$3 || (_path83$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22V10h6V4H4v6H8v2H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,12Z"
    })), children);
  });
  var TouchInteraction20 = /*#__PURE__*/React__default['default'].forwardRef(function TouchInteraction20(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path84$3 || (_path84$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,21V20a1,1,0,0,1,2,0V30h2V20a3.0033,3.0033,0,0,0-3-3,2.964,2.964,0,0,0-1.4708.4014,2.9541,2.9541,0,0,0-4-1A2.9934,2.9934,0,0,0,19,15a2.96,2.96,0,0,0-1,.1846L18,10h0a3,3,0,0,0-6,0V21.1045L9.7651,19.5752l-.0008.001a2.999,2.999,0,0,0-3.881,4.55L12.3223,30l1.3479-1.478L7.2915,22.7036A.9908.9908,0,0,1,7,22a1.0005,1.0005,0,0,1,1.6-.8008L14,24.8955V10a1,1,0,0,1,2,0h0V21h2V18a1,1,0,0,1,2,0v3h2V19a1,1,0,0,1,2,0v2Z"
    })), _path85$3 || (_path85$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22V10h6V4H4v6H8v2H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,12Z"
    })), children);
  });
  var TouchInteraction16 = /*#__PURE__*/React__default['default'].forwardRef(function TouchInteraction16(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$3 || (_path86$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,21V20a1,1,0,0,1,2,0V30h2V20a3.0033,3.0033,0,0,0-3-3,2.964,2.964,0,0,0-1.4708.4014,2.9541,2.9541,0,0,0-4-1A2.9934,2.9934,0,0,0,19,15a2.96,2.96,0,0,0-1,.1846L18,10h0a3,3,0,0,0-6,0V21.1045L9.7651,19.5752l-.0008.001a2.999,2.999,0,0,0-3.881,4.55L12.3223,30l1.3479-1.478L7.2915,22.7036A.9908.9908,0,0,1,7,22a1.0005,1.0005,0,0,1,1.6-.8008L14,24.8955V10a1,1,0,0,1,2,0h0V21h2V18a1,1,0,0,1,2,0v3h2V19a1,1,0,0,1,2,0v2Z"
    })), _path87$3 || (_path87$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,12H22V10h6V4H4v6H8v2H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2v6A2.0021,2.0021,0,0,1,28,12Z"
    })), children);
  });
  var TrafficEvent32 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficEvent32(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$3 || (_path88$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H17V23H11z"
    })), _path89$3 || (_path89$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.2456,8,25.96,14H30V12H27.4688l-1.3-4.5488A2.0077,2.0077,0,0,0,24.2456,6H22.8972l-.7287-2.5488A2.0077,2.0077,0,0,0,20.2456,2H7.7544A2.0078,2.0078,0,0,0,5.8315,3.4507L4.5312,8H2v2H6.04L7.7544,4H20.2456l.5715,2H11.7544A2.008,2.008,0,0,0,9.8315,7.45L8.8171,11H7.7144a1.9981,1.9981,0,0,0-1.8916,1.3516L4.5715,16H2v2H4v7a2.0025,2.0025,0,0,0,2,2v3H8V27H20v3h2V27a2.0025,2.0025,0,0,0,2-2V18h2V16H23.4287l-1.251-3.6475A1.9988,1.9988,0,0,0,20.2856,11H10.897l.8574-3ZM22,19v2H20v2h2v2H6V23H8V21H6V19Zm-.3429-2H6.3428l1.3716-4H20.2856Z"
    })), children);
  });
  var TrafficEvent24 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficEvent24(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$3 || (_path90$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H17V23H11z"
    })), _path91$3 || (_path91$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.2456,8,25.96,14H30V12H27.4688l-1.3-4.5488A2.0077,2.0077,0,0,0,24.2456,6H22.8972l-.7287-2.5488A2.0077,2.0077,0,0,0,20.2456,2H7.7544A2.0078,2.0078,0,0,0,5.8315,3.4507L4.5312,8H2v2H6.04L7.7544,4H20.2456l.5715,2H11.7544A2.008,2.008,0,0,0,9.8315,7.45L8.8171,11H7.7144a1.9981,1.9981,0,0,0-1.8916,1.3516L4.5715,16H2v2H4v7a2.0025,2.0025,0,0,0,2,2v3H8V27H20v3h2V27a2.0025,2.0025,0,0,0,2-2V18h2V16H23.4287l-1.251-3.6475A1.9988,1.9988,0,0,0,20.2856,11H10.897l.8574-3ZM22,19v2H20v2h2v2H6V23H8V21H6V19Zm-.3429-2H6.3428l1.3716-4H20.2856Z"
    })), children);
  });
  var TrafficEvent20 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficEvent20(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$3 || (_path92$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H17V23H11z"
    })), _path93$3 || (_path93$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.2456,8,25.96,14H30V12H27.4688l-1.3-4.5488A2.0077,2.0077,0,0,0,24.2456,6H22.8972l-.7287-2.5488A2.0077,2.0077,0,0,0,20.2456,2H7.7544A2.0078,2.0078,0,0,0,5.8315,3.4507L4.5312,8H2v2H6.04L7.7544,4H20.2456l.5715,2H11.7544A2.008,2.008,0,0,0,9.8315,7.45L8.8171,11H7.7144a1.9981,1.9981,0,0,0-1.8916,1.3516L4.5715,16H2v2H4v7a2.0025,2.0025,0,0,0,2,2v3H8V27H20v3h2V27a2.0025,2.0025,0,0,0,2-2V18h2V16H23.4287l-1.251-3.6475A1.9988,1.9988,0,0,0,20.2856,11H10.897l.8574-3ZM22,19v2H20v2h2v2H6V23H8V21H6V19Zm-.3429-2H6.3428l1.3716-4H20.2856Z"
    })), children);
  });
  var TrafficEvent16 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficEvent16(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$3 || (_path94$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 21H17V23H11z"
    })), _path95$3 || (_path95$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.2456,8,25.96,14H30V12H27.4688l-1.3-4.5488A2.0077,2.0077,0,0,0,24.2456,6H22.8972l-.7287-2.5488A2.0077,2.0077,0,0,0,20.2456,2H7.7544A2.0078,2.0078,0,0,0,5.8315,3.4507L4.5312,8H2v2H6.04L7.7544,4H20.2456l.5715,2H11.7544A2.008,2.008,0,0,0,9.8315,7.45L8.8171,11H7.7144a1.9981,1.9981,0,0,0-1.8916,1.3516L4.5715,16H2v2H4v7a2.0025,2.0025,0,0,0,2,2v3H8V27H20v3h2V27a2.0025,2.0025,0,0,0,2-2V18h2V16H23.4287l-1.251-3.6475A1.9988,1.9988,0,0,0,20.2856,11H10.897l.8574-3ZM22,19v2H20v2h2v2H6V23H8V21H6V19Zm-.3429-2H6.3428l1.3716-4H20.2856Z"
    })), children);
  });
  var TrafficFlow32 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlow32(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$3 || (_path96$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8L22 4 18 8 19.41 9.42 21 7.83 21 18 23 18 23 7.83 24.58 9.41 26 8zM12.59 22.58L11 24.17 11 14 9 14 9 24.17 7.42 22.59 6 24 10 28 14 24 12.59 22.58zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlow24 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlow24(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$3 || (_path97$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8L22 4 18 8 19.41 9.42 21 7.83 21 18 23 18 23 7.83 24.58 9.41 26 8zM12.59 22.58L11 24.17 11 14 9 14 9 24.17 7.42 22.59 6 24 10 28 14 24 12.59 22.58zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlow20 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlow20(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98$3 || (_path98$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8L22 4 18 8 19.41 9.42 21 7.83 21 18 23 18 23 7.83 24.58 9.41 26 8zM12.59 22.58L11 24.17 11 14 9 14 9 24.17 7.42 22.59 6 24 10 28 14 24 12.59 22.58zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlow16 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlow16(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$3 || (_path99$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8L22 4 18 8 19.41 9.42 21 7.83 21 18 23 18 23 7.83 24.58 9.41 26 8zM12.59 22.58L11 24.17 11 14 9 14 9 24.17 7.42 22.59 6 24 10 28 14 24 12.59 22.58zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlowIncident32 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlowIncident32(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$3 || (_path100$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 9.42L24.59 8 22.005 10.585 22 10.58 21.995 10.585 19.42 8.01 18 9.42 20.58 12 18 14.58 19.41 16 21.995 13.415 22 13.42 22.005 13.415 24.58 15.99 26 14.58 23.42 12 26 9.42zM14 17.42L12.59 16 10.005 18.585 10 18.58 9.995 18.585 7.42 16.01 6 17.42 8.58 20 6 22.58 7.41 24 9.995 21.415 10 21.42 10.005 21.415 12.58 23.99 14 22.58 11.42 20 14 17.42zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlowIncident24 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlowIncident24(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$3 || (_path101$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 9.42L24.59 8 22.005 10.585 22 10.58 21.995 10.585 19.42 8.01 18 9.42 20.58 12 18 14.58 19.41 16 21.995 13.415 22 13.42 22.005 13.415 24.58 15.99 26 14.58 23.42 12 26 9.42zM14 17.42L12.59 16 10.005 18.585 10 18.58 9.995 18.585 7.42 16.01 6 17.42 8.58 20 6 22.58 7.41 24 9.995 21.415 10 21.42 10.005 21.415 12.58 23.99 14 22.58 11.42 20 14 17.42zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlowIncident20 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlowIncident20(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$3 || (_path102$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 9.42L24.59 8 22.005 10.585 22 10.58 21.995 10.585 19.42 8.01 18 9.42 20.58 12 18 14.58 19.41 16 21.995 13.415 22 13.42 22.005 13.415 24.58 15.99 26 14.58 23.42 12 26 9.42zM14 17.42L12.59 16 10.005 18.585 10 18.58 9.995 18.585 7.42 16.01 6 17.42 8.58 20 6 22.58 7.41 24 9.995 21.415 10 21.42 10.005 21.415 12.58 23.99 14 22.58 11.42 20 14 17.42zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficFlowIncident16 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficFlowIncident16(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$3 || (_path103$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 9.42L24.59 8 22.005 10.585 22 10.58 21.995 10.585 19.42 8.01 18 9.42 20.58 12 18 14.58 19.41 16 21.995 13.415 22 13.42 22.005 13.415 24.58 15.99 26 14.58 23.42 12 26 9.42zM14 17.42L12.59 16 10.005 18.585 10 18.58 9.995 18.585 7.42 16.01 6 17.42 8.58 20 6 22.58 7.41 24 9.995 21.415 10 21.42 10.005 21.415 12.58 23.99 14 22.58 11.42 20 14 17.42zM2 2H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15z"
    })), children);
  });
  var TrafficIncident32 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficIncident32(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104$3 || (_path104$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2z"
    })), _path105$3 || (_path105$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.314 11.514H17.314V13.514H11.314z",
      transform: "rotate(-45 14.314 12.514)"
    })), _path106$3 || (_path106$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.0815,23.4329l4.1168,2.3176a2.009,2.009,0,0,0,2.3853-.3344l8.8326-8.8326a2.0088,2.0088,0,0,0,.334-2.3856l-2.2977-4.136,1.79-1.79L25.8283,6.8577,24.4141,8.2719l-4.95-4.95a2.0026,2.0026,0,0,0-2.8285,0L14.5146,1.2008,13.1,2.615l2.1213,2.1214L6.7364,13.2216,4.6151,11.1,3.2009,12.5145l2.1213,2.1213a2.0025,2.0025,0,0,0,0,2.8285l4.95,4.95L8.8577,23.8282l1.4143,1.4142Zm13.92-8.2636-8.8328,8.8328-4.5456-2.5255L23.4767,10.6235ZM9.5649,18.8785l1.4142-1.4142L9.5649,16.05,8.1506,17.4643,6.7364,16.05,18.05,4.7364l1.4143,1.4142L18.05,7.5648,19.4644,8.979l1.4142-1.4142L22.2928,8.979,10.9791,20.2927Z"
    })), children);
  });
  var TrafficIncident24 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficIncident24(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$3 || (_path107$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2z"
    })), _path108$3 || (_path108$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.314 11.514H17.314V13.514H11.314z",
      transform: "rotate(-45 14.314 12.514)"
    })), _path109$3 || (_path109$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.0815,23.4329l4.1168,2.3176a2.009,2.009,0,0,0,2.3853-.3344l8.8326-8.8326a2.0088,2.0088,0,0,0,.334-2.3856l-2.2977-4.136,1.79-1.79L25.8283,6.8577,24.4141,8.2719l-4.95-4.95a2.0026,2.0026,0,0,0-2.8285,0L14.5146,1.2008,13.1,2.615l2.1213,2.1214L6.7364,13.2216,4.6151,11.1,3.2009,12.5145l2.1213,2.1213a2.0025,2.0025,0,0,0,0,2.8285l4.95,4.95L8.8577,23.8282l1.4143,1.4142Zm13.92-8.2636-8.8328,8.8328-4.5456-2.5255L23.4767,10.6235ZM9.5649,18.8785l1.4142-1.4142L9.5649,16.05,8.1506,17.4643,6.7364,16.05,18.05,4.7364l1.4143,1.4142L18.05,7.5648,19.4644,8.979l1.4142-1.4142L22.2928,8.979,10.9791,20.2927Z"
    })), children);
  });
  var TrafficIncident20 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficIncident20(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$3 || (_path110$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2z"
    })), _path111$3 || (_path111$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.314 11.514H17.314V13.514H11.314z",
      transform: "rotate(-45 14.314 12.514)"
    })), _path112$3 || (_path112$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.0815,23.4329l4.1168,2.3176a2.009,2.009,0,0,0,2.3853-.3344l8.8326-8.8326a2.0088,2.0088,0,0,0,.334-2.3856l-2.2977-4.136,1.79-1.79L25.8283,6.8577,24.4141,8.2719l-4.95-4.95a2.0026,2.0026,0,0,0-2.8285,0L14.5146,1.2008,13.1,2.615l2.1213,2.1214L6.7364,13.2216,4.6151,11.1,3.2009,12.5145l2.1213,2.1213a2.0025,2.0025,0,0,0,0,2.8285l4.95,4.95L8.8577,23.8282l1.4143,1.4142Zm13.92-8.2636-8.8328,8.8328-4.5456-2.5255L23.4767,10.6235ZM9.5649,18.8785l1.4142-1.4142L9.5649,16.05,8.1506,17.4643,6.7364,16.05,18.05,4.7364l1.4143,1.4142L18.05,7.5648,19.4644,8.979l1.4142-1.4142L22.2928,8.979,10.9791,20.2927Z"
    })), children);
  });
  var TrafficIncident16 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficIncident16(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$3 || (_path113$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 28H30V30H2z"
    })), _path114$3 || (_path114$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11.314 11.514H17.314V13.514H11.314z",
      transform: "rotate(-45 14.314 12.514)"
    })), _path115$3 || (_path115$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12.0815,23.4329l4.1168,2.3176a2.009,2.009,0,0,0,2.3853-.3344l8.8326-8.8326a2.0088,2.0088,0,0,0,.334-2.3856l-2.2977-4.136,1.79-1.79L25.8283,6.8577,24.4141,8.2719l-4.95-4.95a2.0026,2.0026,0,0,0-2.8285,0L14.5146,1.2008,13.1,2.615l2.1213,2.1214L6.7364,13.2216,4.6151,11.1,3.2009,12.5145l2.1213,2.1213a2.0025,2.0025,0,0,0,0,2.8285l4.95,4.95L8.8577,23.8282l1.4143,1.4142Zm13.92-8.2636-8.8328,8.8328-4.5456-2.5255L23.4767,10.6235ZM9.5649,18.8785l1.4142-1.4142L9.5649,16.05,8.1506,17.4643,6.7364,16.05,18.05,4.7364l1.4143,1.4142L18.05,7.5648,19.4644,8.979l1.4142-1.4142L22.2928,8.979,10.9791,20.2927Z"
    })), children);
  });
  var TrafficWeatherIncident32 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficWeatherIncident32(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$3 || (_path116$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 24H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15zM6 12A3.8978 3.8978 0 012 8.223a3.9017 3.9017 0 01.6533-2.0639L5.17 2.4141a1.0381 1.0381 0 011.6592 0L9.3154 6.11A3.9693 3.9693 0 0110 8.223 3.8978 3.8978 0 016 12zm0-7.2368L4.3438 7.2257A1.89 1.89 0 004 8.223a1.9007 1.9007 0 002 1.7775A1.9007 1.9007 0 008 8.223a1.98 1.98 0 00-.375-1.0466zM11 11.7627L9.3438 14.2253A1.89 1.89 0 009 15.2226 1.9007 1.9007 0 0011 17a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467zM6 15.7627L4.3438 18.2253A1.89 1.89 0 004 19.2226 1.9007 1.9007 0 006 21a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467z"
    })), children);
  });
  var TrafficWeatherIncident24 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficWeatherIncident24(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$3 || (_path117$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 24H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15zM6 12A3.8978 3.8978 0 012 8.223a3.9017 3.9017 0 01.6533-2.0639L5.17 2.4141a1.0381 1.0381 0 011.6592 0L9.3154 6.11A3.9693 3.9693 0 0110 8.223 3.8978 3.8978 0 016 12zm0-7.2368L4.3438 7.2257A1.89 1.89 0 004 8.223a1.9007 1.9007 0 002 1.7775A1.9007 1.9007 0 008 8.223a1.98 1.98 0 00-.375-1.0466zM11 11.7627L9.3438 14.2253A1.89 1.89 0 009 15.2226 1.9007 1.9007 0 0011 17a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467zM6 15.7627L4.3438 18.2253A1.89 1.89 0 004 19.2226 1.9007 1.9007 0 006 21a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467z"
    })), children);
  });
  var TrafficWeatherIncident20 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficWeatherIncident20(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$3 || (_path118$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 24H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15zM6 12A3.8978 3.8978 0 012 8.223a3.9017 3.9017 0 01.6533-2.0639L5.17 2.4141a1.0381 1.0381 0 011.6592 0L9.3154 6.11A3.9693 3.9693 0 0110 8.223 3.8978 3.8978 0 016 12zm0-7.2368L4.3438 7.2257A1.89 1.89 0 004 8.223a1.9007 1.9007 0 002 1.7775A1.9007 1.9007 0 008 8.223a1.98 1.98 0 00-.375-1.0466zM11 11.7627L9.3438 14.2253A1.89 1.89 0 009 15.2226 1.9007 1.9007 0 0011 17a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467zM6 15.7627L4.3438 18.2253A1.89 1.89 0 004 19.2226 1.9007 1.9007 0 006 21a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467z"
    })), children);
  });
  var TrafficWeatherIncident16 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficWeatherIncident16(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$3 || (_path119$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 24H4V30H2zM28 2H30V30H28zM15 2H17V6H15zM15 10H17V14H15zM15 18H17V22H15zM15 26H17V30H15zM6 12A3.8978 3.8978 0 012 8.223a3.9017 3.9017 0 01.6533-2.0639L5.17 2.4141a1.0381 1.0381 0 011.6592 0L9.3154 6.11A3.9693 3.9693 0 0110 8.223 3.8978 3.8978 0 016 12zm0-7.2368L4.3438 7.2257A1.89 1.89 0 004 8.223a1.9007 1.9007 0 002 1.7775A1.9007 1.9007 0 008 8.223a1.98 1.98 0 00-.375-1.0466zM11 11.7627L9.3438 14.2253A1.89 1.89 0 009 15.2226 1.9007 1.9007 0 0011 17a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467zM6 15.7627L4.3438 18.2253A1.89 1.89 0 004 19.2226 1.9007 1.9007 0 006 21a1.9007 1.9007 0 002-1.7774 1.98 1.98 0 00-.375-1.0467z"
    })), children);
  });
  var TrafficCone32 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficCone32(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$3 || (_path120$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7957,28,18.9746,2.7754A1,1,0,0,0,18,2H14a1,1,0,0,0-.9746.7754L7.2043,28H4v2H28V28ZM19.9736,16H12.0264l.9229-4h6.1014Zm.4616,2,.923,4H10.6418l.923-4Zm-5.64-14h2.4092l1.3845,6H13.4109ZM10.18,24H21.82l.923,4H9.2573Z"
    })), children);
  });
  var TrafficCone24 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficCone24(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$3 || (_path121$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7957,28,18.9746,2.7754A1,1,0,0,0,18,2H14a1,1,0,0,0-.9746.7754L7.2043,28H4v2H28V28ZM19.9736,16H12.0264l.9229-4h6.1014Zm.4616,2,.923,4H10.6418l.923-4Zm-5.64-14h2.4092l1.3845,6H13.4109ZM10.18,24H21.82l.923,4H9.2573Z"
    })), children);
  });
  var TrafficCone20 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficCone20(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$3 || (_path122$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7957,28,18.9746,2.7754A1,1,0,0,0,18,2H14a1,1,0,0,0-.9746.7754L7.2043,28H4v2H28V28ZM19.9736,16H12.0264l.9229-4h6.1014Zm.4616,2,.923,4H10.6418l.923-4Zm-5.64-14h2.4092l1.3845,6H13.4109ZM10.18,24H21.82l.923,4H9.2573Z"
    })), children);
  });
  var TrafficCone16 = /*#__PURE__*/React__default['default'].forwardRef(function TrafficCone16(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$3 || (_path123$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.7957,28,18.9746,2.7754A1,1,0,0,0,18,2H14a1,1,0,0,0-.9746.7754L7.2043,28H4v2H28V28ZM19.9736,16H12.0264l.9229-4h6.1014Zm.4616,2,.923,4H10.6418l.923-4Zm-5.64-14h2.4092l1.3845,6H13.4109ZM10.18,24H21.82l.923,4H9.2573Z"
    })), children);
  });
  var Train32 = /*#__PURE__*/React__default['default'].forwardRef(function Train32(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124$3 || (_path124$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"
    })), children);
  });
  var Train24 = /*#__PURE__*/React__default['default'].forwardRef(function Train24(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$3 || (_path125$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"
    })), children);
  });
  var Train20 = /*#__PURE__*/React__default['default'].forwardRef(function Train20(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126$3 || (_path126$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"
    })), children);
  });
  var Train16 = /*#__PURE__*/React__default['default'].forwardRef(function Train16(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$3 || (_path127$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"
    })), children);
  });
  var TrainHeart32 = /*#__PURE__*/React__default['default'].forwardRef(function TrainHeart32(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128$3 || (_path128$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 2a2.6613 2.6613 0 00-1.9079.8059l-.3932.4053-.397-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25.0019 11l4.2089-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2zM22 13v3H6V10h9V8H6.1843A2.9948 2.9948 0 019 6h6V4H9A5.0057 5.0057 0 004 9V21a4.99 4.99 0 003.582 4.77L5.7693 30H7.9451l1.7143-4h8.6812l1.7143 4h2.1758L20.418 25.77A4.99 4.99 0 0024 21V13zm0 7H19v2h2.8157A2.9948 2.9948 0 0119 24H9a2.9948 2.9948 0 01-2.8157-2H9V20H6V18H22z"
    })), children);
  });
  var TrainHeart24 = /*#__PURE__*/React__default['default'].forwardRef(function TrainHeart24(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$3 || (_path129$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 2a2.6613 2.6613 0 00-1.9079.8059l-.3932.4053-.397-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25.0019 11l4.2089-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2zM22 13v3H6V10h9V8H6.1843A2.9948 2.9948 0 019 6h6V4H9A5.0057 5.0057 0 004 9V21a4.99 4.99 0 003.582 4.77L5.7693 30H7.9451l1.7143-4h8.6812l1.7143 4h2.1758L20.418 25.77A4.99 4.99 0 0024 21V13zm0 7H19v2h2.8157A2.9948 2.9948 0 0119 24H9a2.9948 2.9948 0 01-2.8157-2H9V20H6V18H22z"
    })), children);
  });
  var TrainHeart20 = /*#__PURE__*/React__default['default'].forwardRef(function TrainHeart20(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$3 || (_path130$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 2a2.6613 2.6613 0 00-1.9079.8059l-.3932.4053-.397-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25.0019 11l4.2089-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2zM22 13v3H6V10h9V8H6.1843A2.9948 2.9948 0 019 6h6V4H9A5.0057 5.0057 0 004 9V21a4.99 4.99 0 003.582 4.77L5.7693 30H7.9451l1.7143-4h8.6812l1.7143 4h2.1758L20.418 25.77A4.99 4.99 0 0024 21V13zm0 7H19v2h2.8157A2.9948 2.9948 0 0119 24H9a2.9948 2.9948 0 01-2.8157-2H9V20H6V18H22z"
    })), children);
  });
  var TrainHeart16 = /*#__PURE__*/React__default['default'].forwardRef(function TrainHeart16(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131$3 || (_path131$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 2a2.6613 2.6613 0 00-1.9079.8059l-.3932.4053-.397-.4053a2.6612 2.6612 0 00-3.8157 0 2.7991 2.7991 0 000 3.8963L25.0019 11l4.2089-4.2978a2.7991 2.7991 0 000-3.8963A2.6613 2.6613 0 0027.303 2zM22 13v3H6V10h9V8H6.1843A2.9948 2.9948 0 019 6h6V4H9A5.0057 5.0057 0 004 9V21a4.99 4.99 0 003.582 4.77L5.7693 30H7.9451l1.7143-4h8.6812l1.7143 4h2.1758L20.418 25.77A4.99 4.99 0 0024 21V13zm0 7H19v2h2.8157A2.9948 2.9948 0 0119 24H9a2.9948 2.9948 0 01-2.8157-2H9V20H6V18H22z"
    })), children);
  });
  var TrainProfile32 = /*#__PURE__*/React__default['default'].forwardRef(function TrainProfile32(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$3 || (_path132$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM8 16H2V14H8V12H2V10H8a2.0021 2.0021 0 012 2v2A2.0021 2.0021 0 018 16z"
    })), _path133$3 || (_path133$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.55,14.2305,19.97,6.3657A8.9775,8.9775,0,0,0,13.8882,4H2V6H12v4a2.0023,2.0023,0,0,0,2,2h9.1565l4.0417,3.7051A2.4723,2.4723,0,0,1,25.5273,20H2v2H25.5273a4.4726,4.4726,0,0,0,3.0225-7.77ZM14,10V6.0054A6.9774,6.9774,0,0,1,18.6182,7.84L20.9746,10Z"
    })), children);
  });
  var TrainProfile24 = /*#__PURE__*/React__default['default'].forwardRef(function TrainProfile24(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path134$3 || (_path134$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM8 16H2V14H8V12H2V10H8a2.0021 2.0021 0 012 2v2A2.0021 2.0021 0 018 16z"
    })), _path135$3 || (_path135$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.55,14.2305,19.97,6.3657A8.9775,8.9775,0,0,0,13.8882,4H2V6H12v4a2.0023,2.0023,0,0,0,2,2h9.1565l4.0417,3.7051A2.4723,2.4723,0,0,1,25.5273,20H2v2H25.5273a4.4726,4.4726,0,0,0,3.0225-7.77ZM14,10V6.0054A6.9774,6.9774,0,0,1,18.6182,7.84L20.9746,10Z"
    })), children);
  });
  var TrainProfile20 = /*#__PURE__*/React__default['default'].forwardRef(function TrainProfile20(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path136$3 || (_path136$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM8 16H2V14H8V12H2V10H8a2.0021 2.0021 0 012 2v2A2.0021 2.0021 0 018 16z"
    })), _path137$3 || (_path137$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.55,14.2305,19.97,6.3657A8.9775,8.9775,0,0,0,13.8882,4H2V6H12v4a2.0023,2.0023,0,0,0,2,2h9.1565l4.0417,3.7051A2.4723,2.4723,0,0,1,25.5273,20H2v2H25.5273a4.4726,4.4726,0,0,0,3.0225-7.77ZM14,10V6.0054A6.9774,6.9774,0,0,1,18.6182,7.84L20.9746,10Z"
    })), children);
  });
  var TrainProfile16 = /*#__PURE__*/React__default['default'].forwardRef(function TrainProfile16(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$3 || (_path138$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM8 16H2V14H8V12H2V10H8a2.0021 2.0021 0 012 2v2A2.0021 2.0021 0 018 16z"
    })), _path139$3 || (_path139$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.55,14.2305,19.97,6.3657A8.9775,8.9775,0,0,0,13.8882,4H2V6H12v4a2.0023,2.0023,0,0,0,2,2h9.1565l4.0417,3.7051A2.4723,2.4723,0,0,1,25.5273,20H2v2H25.5273a4.4726,4.4726,0,0,0,3.0225-7.77ZM14,10V6.0054A6.9774,6.9774,0,0,1,18.6182,7.84L20.9746,10Z"
    })), children);
  });
  var TrainSpeed32 = /*#__PURE__*/React__default['default'].forwardRef(function TrainSpeed32(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path140$3 || (_path140$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM29.7144 16.59L18.1494 8.64A14.9327 14.9327 0 009.6519 6H2V8H9.6519a12.9459 12.9459 0 017.3647 2.2871L18.0532 11H9v2H20.9624l7.6187 5.2378A.966.966 0 0128.0342 20H2v2H28.0342a2.9661 2.9661 0 001.68-5.41z"
    })), children);
  });
  var TrainSpeed24 = /*#__PURE__*/React__default['default'].forwardRef(function TrainSpeed24(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$3 || (_path141$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM29.7144 16.59L18.1494 8.64A14.9327 14.9327 0 009.6519 6H2V8H9.6519a12.9459 12.9459 0 017.3647 2.2871L18.0532 11H9v2H20.9624l7.6187 5.2378A.966.966 0 0128.0342 20H2v2H28.0342a2.9661 2.9661 0 001.68-5.41z"
    })), children);
  });
  var TrainSpeed20 = /*#__PURE__*/React__default['default'].forwardRef(function TrainSpeed20(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path142$3 || (_path142$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM29.7144 16.59L18.1494 8.64A14.9327 14.9327 0 009.6519 6H2V8H9.6519a12.9459 12.9459 0 017.3647 2.2871L18.0532 11H9v2H20.9624l7.6187 5.2378A.966.966 0 0128.0342 20H2v2H28.0342a2.9661 2.9661 0 001.68-5.41z"
    })), children);
  });
  var TrainSpeed16 = /*#__PURE__*/React__default['default'].forwardRef(function TrainSpeed16(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$3 || (_path143$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 25L2 25 2 27 4 27 4 29 6 29 6 27 11 27 11 29 13 29 13 27 18 27 18 29 20 29 20 27 25 27 25 29 27 29 27 27 30 27 30 25zM29.7144 16.59L18.1494 8.64A14.9327 14.9327 0 009.6519 6H2V8H9.6519a12.9459 12.9459 0 017.3647 2.2871L18.0532 11H9v2H20.9624l7.6187 5.2378A.966.966 0 0128.0342 20H2v2H28.0342a2.9661 2.9661 0 001.68-5.41z"
    })), children);
  });
  var TrainTicket32 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTicket32(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$3 || (_path144$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1257,7.125a1.125,1.125,0,1,1,0-2.25h.875V2h-12V4.875h.875a1.125,1.125,0,0,1,0,2.25h-.875V10h12V7.125Z"
    })), _path145$3 || (_path145$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.0007,13v3h-16V10h9V8H6.185A2.9948,2.9948,0,0,1,9.0007,6h6V4h-6a5.0057,5.0057,0,0,0-5,5V21a4.99,4.99,0,0,0,3.582,4.77L5.77,30H7.9458L9.66,26h8.6812l1.7143,4h2.1758l-1.8127-4.23A4.99,4.99,0,0,0,24.0007,21V13Zm0,7h-3v2h2.8157a2.9948,2.9948,0,0,1-2.8157,2h-10A2.9948,2.9948,0,0,1,6.185,22H9.0007V20h-3V18h16Z"
    })), children);
  });
  var TrainTicket24 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTicket24(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path146$3 || (_path146$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1257,7.125a1.125,1.125,0,1,1,0-2.25h.875V2h-12V4.875h.875a1.125,1.125,0,0,1,0,2.25h-.875V10h12V7.125Z"
    })), _path147$3 || (_path147$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.0007,13v3h-16V10h9V8H6.185A2.9948,2.9948,0,0,1,9.0007,6h6V4h-6a5.0057,5.0057,0,0,0-5,5V21a4.99,4.99,0,0,0,3.582,4.77L5.77,30H7.9458L9.66,26h8.6812l1.7143,4h2.1758l-1.8127-4.23A4.99,4.99,0,0,0,24.0007,21V13Zm0,7h-3v2h2.8157a2.9948,2.9948,0,0,1-2.8157,2h-10A2.9948,2.9948,0,0,1,6.185,22H9.0007V20h-3V18h16Z"
    })), children);
  });
  var TrainTicket20 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTicket20(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path148$3 || (_path148$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1257,7.125a1.125,1.125,0,1,1,0-2.25h.875V2h-12V4.875h.875a1.125,1.125,0,0,1,0,2.25h-.875V10h12V7.125Z"
    })), _path149$3 || (_path149$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.0007,13v3h-16V10h9V8H6.185A2.9948,2.9948,0,0,1,9.0007,6h6V4h-6a5.0057,5.0057,0,0,0-5,5V21a4.99,4.99,0,0,0,3.582,4.77L5.77,30H7.9458L9.66,26h8.6812l1.7143,4h2.1758l-1.8127-4.23A4.99,4.99,0,0,0,24.0007,21V13Zm0,7h-3v2h2.8157a2.9948,2.9948,0,0,1-2.8157,2h-10A2.9948,2.9948,0,0,1,6.185,22H9.0007V20h-3V18h16Z"
    })), children);
  });
  var TrainTicket16 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTicket16(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path150$3 || (_path150$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.1257,7.125a1.125,1.125,0,1,1,0-2.25h.875V2h-12V4.875h.875a1.125,1.125,0,0,1,0,2.25h-.875V10h12V7.125Z"
    })), _path151$3 || (_path151$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.0007,13v3h-16V10h9V8H6.185A2.9948,2.9948,0,0,1,9.0007,6h6V4h-6a5.0057,5.0057,0,0,0-5,5V21a4.99,4.99,0,0,0,3.582,4.77L5.77,30H7.9458L9.66,26h8.6812l1.7143,4h2.1758l-1.8127-4.23A4.99,4.99,0,0,0,24.0007,21V13Zm0,7h-3v2h2.8157a2.9948,2.9948,0,0,1-2.8157,2h-10A2.9948,2.9948,0,0,1,6.185,22H9.0007V20h-3V18h16Z"
    })), children);
  });
  var TrainTime32 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTime32(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$3 || (_path152$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.496 10.088L22.874 7.466 22.874 3 25.124 3 25.124 6.534 27.088 8.498 25.496 10.088z"
    })), _path153$3 || (_path153$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,1a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,24,1Zm1.4971,9.0884L22.875,7.4658V3h2.25V6.5342l1.9639,1.9634Z"
    })), _path154$3 || (_path154$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16V10h9V8H6.1843A2.9948,2.9948,0,0,1,9,6h6V4H9A5.0057,5.0057,0,0,0,4,9V21a4.99,4.99,0,0,0,3.582,4.77L5.7693,30H7.9451l1.7143-4h8.6812l1.7143,4h2.1758L20.418,25.77A4.99,4.99,0,0,0,24,21V16Zm16,4H19v2h2.8157A2.9948,2.9948,0,0,1,19,24H9a2.9948,2.9948,0,0,1-2.8157-2H9V20H6V18H22Z"
    })), children);
  });
  var TrainTime24 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTime24(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$3 || (_path155$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.496 10.088L22.874 7.466 22.874 3 25.124 3 25.124 6.534 27.088 8.498 25.496 10.088z"
    })), _path156$3 || (_path156$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,1a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,24,1Zm1.4971,9.0884L22.875,7.4658V3h2.25V6.5342l1.9639,1.9634Z"
    })), _path157$3 || (_path157$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16V10h9V8H6.1843A2.9948,2.9948,0,0,1,9,6h6V4H9A5.0057,5.0057,0,0,0,4,9V21a4.99,4.99,0,0,0,3.582,4.77L5.7693,30H7.9451l1.7143-4h8.6812l1.7143,4h2.1758L20.418,25.77A4.99,4.99,0,0,0,24,21V16Zm16,4H19v2h2.8157A2.9948,2.9948,0,0,1,19,24H9a2.9948,2.9948,0,0,1-2.8157-2H9V20H6V18H22Z"
    })), children);
  });
  var TrainTime20 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTime20(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$3 || (_path158$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.496 10.088L22.874 7.466 22.874 3 25.124 3 25.124 6.534 27.088 8.498 25.496 10.088z"
    })), _path159$3 || (_path159$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,1a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,24,1Zm1.4971,9.0884L22.875,7.4658V3h2.25V6.5342l1.9639,1.9634Z"
    })), _path160$3 || (_path160$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16V10h9V8H6.1843A2.9948,2.9948,0,0,1,9,6h6V4H9A5.0057,5.0057,0,0,0,4,9V21a4.99,4.99,0,0,0,3.582,4.77L5.7693,30H7.9451l1.7143-4h8.6812l1.7143,4h2.1758L20.418,25.77A4.99,4.99,0,0,0,24,21V16Zm16,4H19v2h2.8157A2.9948,2.9948,0,0,1,19,24H9a2.9948,2.9948,0,0,1-2.8157-2H9V20H6V18H22Z"
    })), children);
  });
  var TrainTime16 = /*#__PURE__*/React__default['default'].forwardRef(function TrainTime16(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$3 || (_path161$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M25.496 10.088L22.874 7.466 22.874 3 25.124 3 25.124 6.534 27.088 8.498 25.496 10.088z"
    })), _path162$3 || (_path162$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,1a6,6,0,1,0,6,6A6.0066,6.0066,0,0,0,24,1Zm1.4971,9.0884L22.875,7.4658V3h2.25V6.5342l1.9639,1.9634Z"
    })), _path163$3 || (_path163$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,16V10h9V8H6.1843A2.9948,2.9948,0,0,1,9,6h6V4H9A5.0057,5.0057,0,0,0,4,9V21a4.99,4.99,0,0,0,3.582,4.77L5.7693,30H7.9451l1.7143-4h8.6812l1.7143,4h2.1758L20.418,25.77A4.99,4.99,0,0,0,24,21V16Zm16,4H19v2h2.8157A2.9948,2.9948,0,0,1,19,24H9a2.9948,2.9948,0,0,1-2.8157-2H9V20H6V18H22Z"
    })), children);
  });
  var Tram32 = /*#__PURE__*/React__default['default'].forwardRef(function Tram32(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path164$3 || (_path164$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"
    })), children);
  });
  var Tram24 = /*#__PURE__*/React__default['default'].forwardRef(function Tram24(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$3 || (_path165$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"
    })), children);
  });
  var Tram20 = /*#__PURE__*/React__default['default'].forwardRef(function Tram20(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path166$3 || (_path166$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"
    })), children);
  });
  var Tram16 = /*#__PURE__*/React__default['default'].forwardRef(function Tram16(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$3 || (_path167$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"
    })), children);
  });
  var Transgender32 = /*#__PURE__*/React__default['default'].forwardRef(function Transgender32(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$3 || (_path168$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V4h4.5859l-6.4016,6.4014a6.9474,6.9474,0,0,0-8.3686,0L10.4143,9,13,6.4141,11.5857,5,9,7.5859,5.4141,4H10V2H2v8H4V5.4141L7.5859,9,5,11.5854,6.4143,13,9,10.4141l1.4014,1.4013A6.9785,6.9785,0,0,0,15,22.92V25H11v2h4v3h2V27h4V25H17V22.92a6.9785,6.9785,0,0,0,4.5984-11.1045L28,5.4141V10h2V2ZM16,21a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,16,21Z"
    })), children);
  });
  var Transgender24 = /*#__PURE__*/React__default['default'].forwardRef(function Transgender24(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$3 || (_path169$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V4h4.5859l-6.4016,6.4014a6.9474,6.9474,0,0,0-8.3686,0L10.4143,9,13,6.4141,11.5857,5,9,7.5859,5.4141,4H10V2H2v8H4V5.4141L7.5859,9,5,11.5854,6.4143,13,9,10.4141l1.4014,1.4013A6.9785,6.9785,0,0,0,15,22.92V25H11v2h4v3h2V27h4V25H17V22.92a6.9785,6.9785,0,0,0,4.5984-11.1045L28,5.4141V10h2V2ZM16,21a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,16,21Z"
    })), children);
  });
  var Transgender20 = /*#__PURE__*/React__default['default'].forwardRef(function Transgender20(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$3 || (_path170$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V4h4.5859l-6.4016,6.4014a6.9474,6.9474,0,0,0-8.3686,0L10.4143,9,13,6.4141,11.5857,5,9,7.5859,5.4141,4H10V2H2v8H4V5.4141L7.5859,9,5,11.5854,6.4143,13,9,10.4141l1.4014,1.4013A6.9785,6.9785,0,0,0,15,22.92V25H11v2h4v3h2V27h4V25H17V22.92a6.9785,6.9785,0,0,0,4.5984-11.1045L28,5.4141V10h2V2ZM16,21a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,16,21Z"
    })), children);
  });
  var Transgender16 = /*#__PURE__*/React__default['default'].forwardRef(function Transgender16(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$3 || (_path171$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,2V4h4.5859l-6.4016,6.4014a6.9474,6.9474,0,0,0-8.3686,0L10.4143,9,13,6.4141,11.5857,5,9,7.5859,5.4141,4H10V2H2v8H4V5.4141L7.5859,9,5,11.5854,6.4143,13,9,10.4141l1.4014,1.4013A6.9785,6.9785,0,0,0,15,22.92V25H11v2h4v3h2V27h4V25H17V22.92a6.9785,6.9785,0,0,0,4.5984-11.1045L28,5.4141V10h2V2ZM16,21a5,5,0,1,1,5-5A5.0059,5.0059,0,0,1,16,21Z"
    })), children);
  });
  var Translate32 = /*#__PURE__*/React__default['default'].forwardRef(function Translate32(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$3 || (_path172$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 01-3.19 6.18A13.5 13.5 0 017.26 9H5.16a16.47 16.47 0 003 5.58A16.84 16.84 0 013 18l.75 1.86A18.47 18.47 0 009.53 16a16.92 16.92 0 005.76 3.84L16 18a14.48 14.48 0 01-5.12-3.37A17.64 17.64 0 0014.8 7z"
    })), children);
  });
  var Translate24 = /*#__PURE__*/React__default['default'].forwardRef(function Translate24(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$3 || (_path173$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 01-3.19 6.18A13.5 13.5 0 017.26 9H5.16a16.47 16.47 0 003 5.58A16.84 16.84 0 013 18l.75 1.86A18.47 18.47 0 009.53 16a16.92 16.92 0 005.76 3.84L16 18a14.48 14.48 0 01-5.12-3.37A17.64 17.64 0 0014.8 7z"
    })), children);
  });
  var Translate20 = /*#__PURE__*/React__default['default'].forwardRef(function Translate20(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$3 || (_path174$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 01-3.19 6.18A13.5 13.5 0 017.26 9H5.16a16.47 16.47 0 003 5.58A16.84 16.84 0 013 18l.75 1.86A18.47 18.47 0 009.53 16a16.92 16.92 0 005.76 3.84L16 18a14.48 14.48 0 01-5.12-3.37A17.64 17.64 0 0014.8 7z"
    })), children);
  });
  var Translate16 = /*#__PURE__*/React__default['default'].forwardRef(function Translate16(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$3 || (_path175$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 01-3.19 6.18A13.5 13.5 0 017.26 9H5.16a16.47 16.47 0 003 5.58A16.84 16.84 0 013 18l.75 1.86A18.47 18.47 0 009.53 16a16.92 16.92 0 005.76 3.84L16 18a14.48 14.48 0 01-5.12-3.37A17.64 17.64 0 0014.8 7z"
    })), children);
  });
  var TransmissionLte32 = /*#__PURE__*/React__default['default'].forwardRef(function TransmissionLte32(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176$3 || (_path176$3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.57 30l.9333-2h8.9928l.9333 2h2.2072L17 15.7778V11H15v4.7778L8.3631 30zM16 18.3647L17.6965 22h-3.393zM13.37 24h5.26l.9333 2H12.4369zM10.7832 9.3325a7.0007 7.0007 0 0110.4341 0l-1.49 1.334a5 5 0 00-7.4537 0z"
    })), _path177$2 || (_path177$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,6.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,7.6a9.0009,9.0009,0,0,0-14.4014,0Z"
    })), children);
  });
  var TransmissionLte24 = /*#__PURE__*/React__default['default'].forwardRef(function TransmissionLte24(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path178$2 || (_path178$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.57 30l.9333-2h8.9928l.9333 2h2.2072L17 15.7778V11H15v4.7778L8.3631 30zM16 18.3647L17.6965 22h-3.393zM13.37 24h5.26l.9333 2H12.4369zM10.7832 9.3325a7.0007 7.0007 0 0110.4341 0l-1.49 1.334a5 5 0 00-7.4537 0z"
    })), _path179$2 || (_path179$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,6.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,7.6a9.0009,9.0009,0,0,0-14.4014,0Z"
    })), children);
  });
  var TransmissionLte20 = /*#__PURE__*/React__default['default'].forwardRef(function TransmissionLte20(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$2 || (_path180$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.57 30l.9333-2h8.9928l.9333 2h2.2072L17 15.7778V11H15v4.7778L8.3631 30zM16 18.3647L17.6965 22h-3.393zM13.37 24h5.26l.9333 2H12.4369zM10.7832 9.3325a7.0007 7.0007 0 0110.4341 0l-1.49 1.334a5 5 0 00-7.4537 0z"
    })), _path181$2 || (_path181$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,6.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,7.6a9.0009,9.0009,0,0,0-14.4014,0Z"
    })), children);
  });
  var TransmissionLte16 = /*#__PURE__*/React__default['default'].forwardRef(function TransmissionLte16(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path182$2 || (_path182$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.57 30l.9333-2h8.9928l.9333 2h2.2072L17 15.7778V11H15v4.7778L8.3631 30zM16 18.3647L17.6965 22h-3.393zM13.37 24h5.26l.9333 2H12.4369zM10.7832 9.3325a7.0007 7.0007 0 0110.4341 0l-1.49 1.334a5 5 0 00-7.4537 0z"
    })), _path183$2 || (_path183$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,6.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,7.6a9.0009,9.0009,0,0,0-14.4014,0Z"
    })), children);
  });
  var Transpose32 = /*#__PURE__*/React__default['default'].forwardRef(function Transpose32(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path184$2 || (_path184$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 26H14V24h5a5.0055 5.0055 0 005-5V14h2v5A7.0078 7.0078 0 0119 26zM8 30H4a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 018 30zM4 14V28H8V14zM28 10H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0128 10zM14 4V8H28V4z"
    })), children);
  });
  var Transpose24 = /*#__PURE__*/React__default['default'].forwardRef(function Transpose24(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$2 || (_path185$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 26H14V24h5a5.0055 5.0055 0 005-5V14h2v5A7.0078 7.0078 0 0119 26zM8 30H4a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 018 30zM4 14V28H8V14zM28 10H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0128 10zM14 4V8H28V4z"
    })), children);
  });
  var Transpose20 = /*#__PURE__*/React__default['default'].forwardRef(function Transpose20(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path186$2 || (_path186$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 26H14V24h5a5.0055 5.0055 0 005-5V14h2v5A7.0078 7.0078 0 0119 26zM8 30H4a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 018 30zM4 14V28H8V14zM28 10H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0128 10zM14 4V8H28V4z"
    })), children);
  });
  var Transpose16 = /*#__PURE__*/React__default['default'].forwardRef(function Transpose16(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187$2 || (_path187$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 26H14V24h5a5.0055 5.0055 0 005-5V14h2v5A7.0078 7.0078 0 0119 26zM8 30H4a2.0023 2.0023 0 01-2-2V14a2.0023 2.0023 0 012-2H8a2.0023 2.0023 0 012 2V28A2.0023 2.0023 0 018 30zM4 14V28H8V14zM28 10H14a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2H28a2.0023 2.0023 0 012 2V8A2.0023 2.0023 0 0128 10zM14 4V8H28V4z"
    })), children);
  });
  var TrashCan32 = /*#__PURE__*/React__default['default'].forwardRef(function TrashCan32(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path188$2 || (_path188$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path189$2 || (_path189$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var TrashCan24 = /*#__PURE__*/React__default['default'].forwardRef(function TrashCan24(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$2 || (_path190$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path191$2 || (_path191$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var TrashCan20 = /*#__PURE__*/React__default['default'].forwardRef(function TrashCan20(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path192$2 || (_path192$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path193$2 || (_path193$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var TrashCan16 = /*#__PURE__*/React__default['default'].forwardRef(function TrashCan16(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path194$2 || (_path194$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 12H14V24H12zM18 12H20V24H18z"
    })), _path195$2 || (_path195$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6V8H6V28a2 2 0 002 2H24a2 2 0 002-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"
    })), children);
  });
  var Tree32 = /*#__PURE__*/React__default['default'].forwardRef(function Tree32(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$2 || (_path196$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"
    })), _path197$2 || (_path197$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"
    })), children);
  });
  var Tree24 = /*#__PURE__*/React__default['default'].forwardRef(function Tree24(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$2 || (_path198$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"
    })), _path199$2 || (_path199$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"
    })), children);
  });
  var Tree20 = /*#__PURE__*/React__default['default'].forwardRef(function Tree20(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$2 || (_path200$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"
    })), _path201$2 || (_path201$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"
    })), children);
  });
  var Tree16 = /*#__PURE__*/React__default['default'].forwardRef(function Tree16(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$2 || (_path202$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"
    })), _path203$2 || (_path203$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"
    })), children);
  });
  var TreeFallRisk32 = /*#__PURE__*/React__default['default'].forwardRef(function TreeFallRisk32(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$2 || (_path204$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z",
      "data-icon-path": "inner-path"
    })), _path205$2 || (_path205$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115 13.9355L23.6284 2.3706a.7181.7181 0 00-1.2568 0L16.0885 13.9355A.72.72 0 0016.72 15H29.28A.72.72 0 0029.9115 13.9355zM22.25 6h1.5v4h-1.5zM23 13a1 1 0 111-1A1 1 0 0123 13zM26 19V17H17V28a2.0027 2.0027 0 002 2h3V28H19V19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path206$2 || (_path206$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.6638,5.0059l.96-1.7671A8.9324,8.9324,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4,6.8916,6.8916,0,0,1,18.6638,5.0059Z"
    })), children);
  });
  var TreeFallRisk24 = /*#__PURE__*/React__default['default'].forwardRef(function TreeFallRisk24(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207$2 || (_path207$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z",
      "data-icon-path": "inner-path"
    })), _path208$2 || (_path208$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115 13.9355L23.6284 2.3706a.7181.7181 0 00-1.2568 0L16.0885 13.9355A.72.72 0 0016.72 15H29.28A.72.72 0 0029.9115 13.9355zM22.25 6h1.5v4h-1.5zM23 13a1 1 0 111-1A1 1 0 0123 13zM26 19V17H17V28a2.0027 2.0027 0 002 2h3V28H19V19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path209$2 || (_path209$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.6638,5.0059l.96-1.7671A8.9324,8.9324,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4,6.8916,6.8916,0,0,1,18.6638,5.0059Z"
    })), children);
  });
  var TreeFallRisk20 = /*#__PURE__*/React__default['default'].forwardRef(function TreeFallRisk20(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210$2 || (_path210$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z",
      "data-icon-path": "inner-path"
    })), _path211$2 || (_path211$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115 13.9355L23.6284 2.3706a.7181.7181 0 00-1.2568 0L16.0885 13.9355A.72.72 0 0016.72 15H29.28A.72.72 0 0029.9115 13.9355zM22.25 6h1.5v4h-1.5zM23 13a1 1 0 111-1A1 1 0 0123 13zM26 19V17H17V28a2.0027 2.0027 0 002 2h3V28H19V19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path212$2 || (_path212$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.6638,5.0059l.96-1.7671A8.9324,8.9324,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4,6.8916,6.8916,0,0,1,18.6638,5.0059Z"
    })), children);
  });
  var TreeFallRisk16 = /*#__PURE__*/React__default['default'].forwardRef(function TreeFallRisk16(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213$2 || (_path213$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z",
      "data-icon-path": "inner-path"
    })), _path214$2 || (_path214$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115 13.9355L23.6284 2.3706a.7181.7181 0 00-1.2568 0L16.0885 13.9355A.72.72 0 0016.72 15H29.28A.72.72 0 0029.9115 13.9355zM22.25 6h1.5v4h-1.5zM23 13a1 1 0 111-1A1 1 0 0123 13zM26 19V17H17V28a2.0027 2.0027 0 002 2h3V28H19V19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path215$2 || (_path215$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18.6638,5.0059l.96-1.7671A8.9324,8.9324,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4,6.8916,6.8916,0,0,1,18.6638,5.0059Z"
    })), children);
  });
  var TreeView32 = /*#__PURE__*/React__default['default'].forwardRef(function TreeView32(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$2 || (_path216$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"
    })), children);
  });
  var TreeView24 = /*#__PURE__*/React__default['default'].forwardRef(function TreeView24(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$2 || (_path217$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"
    })), children);
  });
  var TreeView20 = /*#__PURE__*/React__default['default'].forwardRef(function TreeView20(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$2 || (_path218$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"
    })), children);
  });
  var TreeView16 = /*#__PURE__*/React__default['default'].forwardRef(function TreeView16(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$2 || (_path219$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"
    })), children);
  });
  var TreeViewAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function TreeViewAlt32(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220$2 || (_path220$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var TreeViewAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function TreeViewAlt24(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$2 || (_path221$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var TreeViewAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function TreeViewAlt20(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path222$2 || (_path222$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var TreeViewAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function TreeViewAlt16(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$2 || (_path223$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",
      transform: "translate(0 .005)"
    })), children);
  });
  var Trophy32 = /*#__PURE__*/React__default['default'].forwardRef(function Trophy32(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224$2 || (_path224$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var Trophy24 = /*#__PURE__*/React__default['default'].forwardRef(function Trophy24(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$2 || (_path225$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var Trophy20 = /*#__PURE__*/React__default['default'].forwardRef(function Trophy20(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path226$2 || (_path226$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var Trophy16 = /*#__PURE__*/React__default['default'].forwardRef(function Trophy16(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$2 || (_path227$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var TrophyFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function TrophyFilled32(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$2 || (_path228$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var TrophyFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function TrophyFilled24(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$2 || (_path229$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var TrophyFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function TrophyFilled20(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$2 || (_path230$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var TrophyFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function TrophyFilled16(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$2 || (_path231$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"
    })), children);
  });
  var TropicalStorm32 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStorm32(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$2 || (_path232$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path233$2 || (_path233$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var TropicalStorm24 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStorm24(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$2 || (_path234$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path235$2 || (_path235$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var TropicalStorm20 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStorm20(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path236$2 || (_path236$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path237$2 || (_path237$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var TropicalStorm16 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStorm16(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$2 || (_path238$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path239$2 || (_path239$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.6521,4.1821l-2.177,2.5142L19.0713,8.3174,20.7864,9.605A7.9361,7.9361,0,0,1,23.9963,16l.0008.0576.0017.0415c.018.4317.2412,10.1113-14.6538,11.7222l2.18-2.5176,1.4039-1.6211L11.2139,22.395A7.9361,7.9361,0,0,1,8.0037,16l-.0008-.0576-.0017-.0415C7.9832,15.47,7.7605,5.8071,22.6521,4.1821M24.9978,2c-.0164,0-.0327,0-.0493.001C5.2532,2.9146,6.0037,16,6.0037,16a9.975,9.975,0,0,0,4.0095,7.9946L6.2368,28.3555A1.0044,1.0044,0,0,0,7.0022,30c.0164,0,.0327,0,.0493-.001C26.7468,29.0854,25.9963,16,25.9963,16a9.9756,9.9756,0,0,0-4.0092-7.9946l3.7761-4.3609A1.0044,1.0044,0,0,0,24.9978,2Z"
    })), children);
  });
  var TropicalStormModelTracks32 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormModelTracks32(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path240$2 || (_path240$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,17a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,17Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,10,11Z"
    })), _path241$2 || (_path241$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.8188 6.65c.1163-.1211 1.8643-1.919 2.8882-2.9434A1 1 0 0017 2C11.812 2 2 4.2988 2 13a7.8938 7.8938 0 003.1812 6.35c-.1612.1675-1.9507 2.0054-2.8882 2.9429A1 1 0 003 24c5.188 0 15-2.2988 15-11A7.8927 7.8927 0 0014.8188 6.65zM9.7065 20.793a20.94 20.94 0 01-4.0932.9853c.1621-.166 2.7685-2.9053 2.7685-2.9053l-1.1743-.6074A5.9064 5.9064 0 014 13c0-3.667 2.1177-6.2886 6.2935-7.793a20.94 20.94 0 014.0932-.9853c-.227.2324-2.769 2.9057-2.769 2.9057l1.1748.607A5.9075 5.9075 0 0116 13C16 16.667 13.8823 19.2886 9.7065 20.793zM30 17l-5-5-5 5 1.4126 1.4155L24 15.8325V19a9.01 9.01 0 01-9 9H12v2h3A11.0125 11.0125 0 0026 19V15.8325l2.5859 2.5816z"
    })), children);
  });
  var TropicalStormModelTracks24 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormModelTracks24(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path242$2 || (_path242$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,17a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,17Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,10,11Z"
    })), _path243$2 || (_path243$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.8188 6.65c.1163-.1211 1.8643-1.919 2.8882-2.9434A1 1 0 0017 2C11.812 2 2 4.2988 2 13a7.8938 7.8938 0 003.1812 6.35c-.1612.1675-1.9507 2.0054-2.8882 2.9429A1 1 0 003 24c5.188 0 15-2.2988 15-11A7.8927 7.8927 0 0014.8188 6.65zM9.7065 20.793a20.94 20.94 0 01-4.0932.9853c.1621-.166 2.7685-2.9053 2.7685-2.9053l-1.1743-.6074A5.9064 5.9064 0 014 13c0-3.667 2.1177-6.2886 6.2935-7.793a20.94 20.94 0 014.0932-.9853c-.227.2324-2.769 2.9057-2.769 2.9057l1.1748.607A5.9075 5.9075 0 0116 13C16 16.667 13.8823 19.2886 9.7065 20.793zM30 17l-5-5-5 5 1.4126 1.4155L24 15.8325V19a9.01 9.01 0 01-9 9H12v2h3A11.0125 11.0125 0 0026 19V15.8325l2.5859 2.5816z"
    })), children);
  });
  var TropicalStormModelTracks20 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormModelTracks20(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$2 || (_path244$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,17a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,17Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,10,11Z"
    })), _path245$2 || (_path245$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.8188 6.65c.1163-.1211 1.8643-1.919 2.8882-2.9434A1 1 0 0017 2C11.812 2 2 4.2988 2 13a7.8938 7.8938 0 003.1812 6.35c-.1612.1675-1.9507 2.0054-2.8882 2.9429A1 1 0 003 24c5.188 0 15-2.2988 15-11A7.8927 7.8927 0 0014.8188 6.65zM9.7065 20.793a20.94 20.94 0 01-4.0932.9853c.1621-.166 2.7685-2.9053 2.7685-2.9053l-1.1743-.6074A5.9064 5.9064 0 014 13c0-3.667 2.1177-6.2886 6.2935-7.793a20.94 20.94 0 014.0932-.9853c-.227.2324-2.769 2.9057-2.769 2.9057l1.1748.607A5.9075 5.9075 0 0116 13C16 16.667 13.8823 19.2886 9.7065 20.793zM30 17l-5-5-5 5 1.4126 1.4155L24 15.8325V19a9.01 9.01 0 01-9 9H12v2h3A11.0125 11.0125 0 0026 19V15.8325l2.5859 2.5816z"
    })), children);
  });
  var TropicalStormModelTracks16 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormModelTracks16(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path246$2 || (_path246$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,17a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,10,17Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,10,11Z"
    })), _path247$2 || (_path247$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.8188 6.65c.1163-.1211 1.8643-1.919 2.8882-2.9434A1 1 0 0017 2C11.812 2 2 4.2988 2 13a7.8938 7.8938 0 003.1812 6.35c-.1612.1675-1.9507 2.0054-2.8882 2.9429A1 1 0 003 24c5.188 0 15-2.2988 15-11A7.8927 7.8927 0 0014.8188 6.65zM9.7065 20.793a20.94 20.94 0 01-4.0932.9853c.1621-.166 2.7685-2.9053 2.7685-2.9053l-1.1743-.6074A5.9064 5.9064 0 014 13c0-3.667 2.1177-6.2886 6.2935-7.793a20.94 20.94 0 014.0932-.9853c-.227.2324-2.769 2.9057-2.769 2.9057l1.1748.607A5.9075 5.9075 0 0116 13C16 16.667 13.8823 19.2886 9.7065 20.793zM30 17l-5-5-5 5 1.4126 1.4155L24 15.8325V19a9.01 9.01 0 01-9 9H12v2h3A11.0125 11.0125 0 0026 19V15.8325l2.5859 2.5816z"
    })), children);
  });
  var TropicalStormTracks32 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormTracks32(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$2 || (_path248$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path249$2 || (_path249$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.86,12.4805h0a12.9277,12.9277,0,0,0-4.8575-4.9991q.2044-.213.4424-.4589h0c.82-.8482,1.93-1.9825,3.2622-3.3155A1,1,0,0,0,25,2c-.354,0-8.7363.0488-14.269,4.3018h0A12.15,12.15,0,0,0,7.481,9.998c-.1416-.1367-.295-.2841-.4585-.4423C6.1743,8.7349,5.04,7.6255,3.707,6.293A1,1,0,0,0,2,7c0,.3594.05,8.874,4.4058,14.4023a12.1023,12.1023,0,0,0,3.5918,3.1163c-.21.2177-.4346.4516-.6563.68h0c-.7954.8208-1.8286,1.8745-3.0483,3.0943A1,1,0,0,0,7,30c.2856,0,7.061-.0352,12.459-3.1055a12.9618,12.9618,0,0,0,5.06-4.8925q.3062.2937.68.6567c.82.7954,1.8745,1.8286,3.0943,3.0483A1,1,0,0,0,30,25C30,24.7119,29.9644,17.8877,26.86,12.4805Zm-3.03,6.1074-.5469,1.3672A10.5415,10.5415,0,0,1,18.47,25.1562,24.3514,24.3514,0,0,1,9.584,27.8135c.4409-.4492,3.8281-3.9824,3.8281-3.9824l-1.3682-.5474a9.8021,9.8021,0,0,1-4.0668-3.1191c-2.5406-3.2242-3.4585-7.7623-3.79-10.58.5435.5337,3.9815,3.8266,3.9815,3.8266l.5468-1.3672A9.8569,9.8569,0,0,1,11.95,7.8877h0C15.1665,5.415,19.6309,4.5146,22.4155,4.187c-.5332.5435-3.8276,3.9819-3.8276,3.9819l1.3677.5469a10.52,10.52,0,0,1,5.17,4.7608v0a24.29,24.29,0,0,1,2.688,8.94C27.3643,21.9751,23.83,18.5879,23.83,18.5879Z"
    })), children);
  });
  var TropicalStormTracks24 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormTracks24(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$2 || (_path250$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path251$2 || (_path251$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.86,12.4805h0a12.9277,12.9277,0,0,0-4.8575-4.9991q.2044-.213.4424-.4589h0c.82-.8482,1.93-1.9825,3.2622-3.3155A1,1,0,0,0,25,2c-.354,0-8.7363.0488-14.269,4.3018h0A12.15,12.15,0,0,0,7.481,9.998c-.1416-.1367-.295-.2841-.4585-.4423C6.1743,8.7349,5.04,7.6255,3.707,6.293A1,1,0,0,0,2,7c0,.3594.05,8.874,4.4058,14.4023a12.1023,12.1023,0,0,0,3.5918,3.1163c-.21.2177-.4346.4516-.6563.68h0c-.7954.8208-1.8286,1.8745-3.0483,3.0943A1,1,0,0,0,7,30c.2856,0,7.061-.0352,12.459-3.1055a12.9618,12.9618,0,0,0,5.06-4.8925q.3062.2937.68.6567c.82.7954,1.8745,1.8286,3.0943,3.0483A1,1,0,0,0,30,25C30,24.7119,29.9644,17.8877,26.86,12.4805Zm-3.03,6.1074-.5469,1.3672A10.5415,10.5415,0,0,1,18.47,25.1562,24.3514,24.3514,0,0,1,9.584,27.8135c.4409-.4492,3.8281-3.9824,3.8281-3.9824l-1.3682-.5474a9.8021,9.8021,0,0,1-4.0668-3.1191c-2.5406-3.2242-3.4585-7.7623-3.79-10.58.5435.5337,3.9815,3.8266,3.9815,3.8266l.5468-1.3672A9.8569,9.8569,0,0,1,11.95,7.8877h0C15.1665,5.415,19.6309,4.5146,22.4155,4.187c-.5332.5435-3.8276,3.9819-3.8276,3.9819l1.3677.5469a10.52,10.52,0,0,1,5.17,4.7608v0a24.29,24.29,0,0,1,2.688,8.94C27.3643,21.9751,23.83,18.5879,23.83,18.5879Z"
    })), children);
  });
  var TropicalStormTracks20 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormTracks20(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$2 || (_path252$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path253$2 || (_path253$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.86,12.4805h0a12.9277,12.9277,0,0,0-4.8575-4.9991q.2044-.213.4424-.4589h0c.82-.8482,1.93-1.9825,3.2622-3.3155A1,1,0,0,0,25,2c-.354,0-8.7363.0488-14.269,4.3018h0A12.15,12.15,0,0,0,7.481,9.998c-.1416-.1367-.295-.2841-.4585-.4423C6.1743,8.7349,5.04,7.6255,3.707,6.293A1,1,0,0,0,2,7c0,.3594.05,8.874,4.4058,14.4023a12.1023,12.1023,0,0,0,3.5918,3.1163c-.21.2177-.4346.4516-.6563.68h0c-.7954.8208-1.8286,1.8745-3.0483,3.0943A1,1,0,0,0,7,30c.2856,0,7.061-.0352,12.459-3.1055a12.9618,12.9618,0,0,0,5.06-4.8925q.3062.2937.68.6567c.82.7954,1.8745,1.8286,3.0943,3.0483A1,1,0,0,0,30,25C30,24.7119,29.9644,17.8877,26.86,12.4805Zm-3.03,6.1074-.5469,1.3672A10.5415,10.5415,0,0,1,18.47,25.1562,24.3514,24.3514,0,0,1,9.584,27.8135c.4409-.4492,3.8281-3.9824,3.8281-3.9824l-1.3682-.5474a9.8021,9.8021,0,0,1-4.0668-3.1191c-2.5406-3.2242-3.4585-7.7623-3.79-10.58.5435.5337,3.9815,3.8266,3.9815,3.8266l.5468-1.3672A9.8569,9.8569,0,0,1,11.95,7.8877h0C15.1665,5.415,19.6309,4.5146,22.4155,4.187c-.5332.5435-3.8276,3.9819-3.8276,3.9819l1.3677.5469a10.52,10.52,0,0,1,5.17,4.7608v0a24.29,24.29,0,0,1,2.688,8.94C27.3643,21.9751,23.83,18.5879,23.83,18.5879Z"
    })), children);
  });
  var TropicalStormTracks16 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalStormTracks16(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$2 || (_path254$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,21a5,5,0,1,1,5-5A5.0057,5.0057,0,0,1,16,21Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,16,13Z"
    })), _path255$2 || (_path255$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.86,12.4805h0a12.9277,12.9277,0,0,0-4.8575-4.9991q.2044-.213.4424-.4589h0c.82-.8482,1.93-1.9825,3.2622-3.3155A1,1,0,0,0,25,2c-.354,0-8.7363.0488-14.269,4.3018h0A12.15,12.15,0,0,0,7.481,9.998c-.1416-.1367-.295-.2841-.4585-.4423C6.1743,8.7349,5.04,7.6255,3.707,6.293A1,1,0,0,0,2,7c0,.3594.05,8.874,4.4058,14.4023a12.1023,12.1023,0,0,0,3.5918,3.1163c-.21.2177-.4346.4516-.6563.68h0c-.7954.8208-1.8286,1.8745-3.0483,3.0943A1,1,0,0,0,7,30c.2856,0,7.061-.0352,12.459-3.1055a12.9618,12.9618,0,0,0,5.06-4.8925q.3062.2937.68.6567c.82.7954,1.8745,1.8286,3.0943,3.0483A1,1,0,0,0,30,25C30,24.7119,29.9644,17.8877,26.86,12.4805Zm-3.03,6.1074-.5469,1.3672A10.5415,10.5415,0,0,1,18.47,25.1562,24.3514,24.3514,0,0,1,9.584,27.8135c.4409-.4492,3.8281-3.9824,3.8281-3.9824l-1.3682-.5474a9.8021,9.8021,0,0,1-4.0668-3.1191c-2.5406-3.2242-3.4585-7.7623-3.79-10.58.5435.5337,3.9815,3.8266,3.9815,3.8266l.5468-1.3672A9.8569,9.8569,0,0,1,11.95,7.8877h0C15.1665,5.415,19.6309,4.5146,22.4155,4.187c-.5332.5435-3.8276,3.9819-3.8276,3.9819l1.3677.5469a10.52,10.52,0,0,1,5.17,4.7608v0a24.29,24.29,0,0,1,2.688,8.94C27.3643,21.9751,23.83,18.5879,23.83,18.5879Z"
    })), children);
  });
  var TropicalWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalWarning32(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256$2 || (_path256$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9487,25.6836a1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,23,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,15,28h-.4336C13.9241,26.7939,12,22.312,12,12v-.1313l1.1169.7446A6.46,6.46,0,0,1,14.4346,13.79l1.0007-1.8418a8.4469,8.4469,0,0,0-1.209-.9986L12.8025,10h1.5308a6.9861,6.9861,0,0,1,1.9934.3071l.9755-1.7954A9.0059,9.0059,0,0,0,14.3333,8H13.1169A7.0329,7.0329,0,0,1,18,6h.6669l1.0867-2H18a9.0361,9.0361,0,0,0-7,3.3638A9.0362,9.0362,0,0,0,4,4H2V6H4A7.0308,7.0308,0,0,1,8.8828,8H7.6665a9.06,9.06,0,0,0-5.4,1.8L.4,11.2l1.2,1.6L3.4668,11.4a7.04,7.04,0,0,1,4.2-1.4H9.1973l-1.4239.9492A8.457,8.457,0,0,0,4,18H6a6.46,6.46,0,0,1,2.8828-5.3867L10,11.8687V12c0,8.9365,1.3994,13.7539,2.355,16H2v2H15a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,4.9955,4.9955,0,0,0,3,1.8833V27.8125A3.7616,3.7616,0,0,1,27.9487,25.6836Z"
    })), _path257$2 || (_path257$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path258$2 || (_path258$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var TropicalWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalWarning24(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$2 || (_path259$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9487,25.6836a1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,23,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,15,28h-.4336C13.9241,26.7939,12,22.312,12,12v-.1313l1.1169.7446A6.46,6.46,0,0,1,14.4346,13.79l1.0007-1.8418a8.4469,8.4469,0,0,0-1.209-.9986L12.8025,10h1.5308a6.9861,6.9861,0,0,1,1.9934.3071l.9755-1.7954A9.0059,9.0059,0,0,0,14.3333,8H13.1169A7.0329,7.0329,0,0,1,18,6h.6669l1.0867-2H18a9.0361,9.0361,0,0,0-7,3.3638A9.0362,9.0362,0,0,0,4,4H2V6H4A7.0308,7.0308,0,0,1,8.8828,8H7.6665a9.06,9.06,0,0,0-5.4,1.8L.4,11.2l1.2,1.6L3.4668,11.4a7.04,7.04,0,0,1,4.2-1.4H9.1973l-1.4239.9492A8.457,8.457,0,0,0,4,18H6a6.46,6.46,0,0,1,2.8828-5.3867L10,11.8687V12c0,8.9365,1.3994,13.7539,2.355,16H2v2H15a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,4.9955,4.9955,0,0,0,3,1.8833V27.8125A3.7616,3.7616,0,0,1,27.9487,25.6836Z"
    })), _path260$2 || (_path260$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path261$2 || (_path261$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var TropicalWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalWarning20(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path262$2 || (_path262$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9487,25.6836a1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,23,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,15,28h-.4336C13.9241,26.7939,12,22.312,12,12v-.1313l1.1169.7446A6.46,6.46,0,0,1,14.4346,13.79l1.0007-1.8418a8.4469,8.4469,0,0,0-1.209-.9986L12.8025,10h1.5308a6.9861,6.9861,0,0,1,1.9934.3071l.9755-1.7954A9.0059,9.0059,0,0,0,14.3333,8H13.1169A7.0329,7.0329,0,0,1,18,6h.6669l1.0867-2H18a9.0361,9.0361,0,0,0-7,3.3638A9.0362,9.0362,0,0,0,4,4H2V6H4A7.0308,7.0308,0,0,1,8.8828,8H7.6665a9.06,9.06,0,0,0-5.4,1.8L.4,11.2l1.2,1.6L3.4668,11.4a7.04,7.04,0,0,1,4.2-1.4H9.1973l-1.4239.9492A8.457,8.457,0,0,0,4,18H6a6.46,6.46,0,0,1,2.8828-5.3867L10,11.8687V12c0,8.9365,1.3994,13.7539,2.355,16H2v2H15a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,4.9955,4.9955,0,0,0,3,1.8833V27.8125A3.7616,3.7616,0,0,1,27.9487,25.6836Z"
    })), _path263$2 || (_path263$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path264$2 || (_path264$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var TropicalWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function TropicalWarning16(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$2 || (_path265$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.9487,25.6836a1,1,0,0,0-1.8955-.0049A3.44,3.44,0,0,1,23,28a3.44,3.44,0,0,1-3.0532-2.3213,1,1,0,0,0-1.8955.0049A3.4376,3.4376,0,0,1,15,28h-.4336C13.9241,26.7939,12,22.312,12,12v-.1313l1.1169.7446A6.46,6.46,0,0,1,14.4346,13.79l1.0007-1.8418a8.4469,8.4469,0,0,0-1.209-.9986L12.8025,10h1.5308a6.9861,6.9861,0,0,1,1.9934.3071l.9755-1.7954A9.0059,9.0059,0,0,0,14.3333,8H13.1169A7.0329,7.0329,0,0,1,18,6h.6669l1.0867-2H18a9.0361,9.0361,0,0,0-7,3.3638A9.0362,9.0362,0,0,0,4,4H2V6H4A7.0308,7.0308,0,0,1,8.8828,8H7.6665a9.06,9.06,0,0,0-5.4,1.8L.4,11.2l1.2,1.6L3.4668,11.4a7.04,7.04,0,0,1,4.2-1.4H9.1973l-1.4239.9492A8.457,8.457,0,0,0,4,18H6a6.46,6.46,0,0,1,2.8828-5.3867L10,11.8687V12c0,8.9365,1.3994,13.7539,2.355,16H2v2H15a4.9316,4.9316,0,0,0,4-1.9873,5.0192,5.0192,0,0,0,8,0,4.9955,4.9955,0,0,0,3,1.8833V27.8125A3.7616,3.7616,0,0,1,27.9487,25.6836Z"
    })), _path266$2 || (_path266$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path267$2 || (_path267$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var Tsunami32 = /*#__PURE__*/React__default['default'].forwardRef(function Tsunami32(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path268$2 || (_path268$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,26H24A10.0349,10.0349,0,0,1,17.0732,8.7378,11.9629,11.9629,0,0,0,12.9937,8a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,14.4348,4,19.34,4,26H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,6h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,24h6Z"
    })), children);
  });
  var Tsunami24 = /*#__PURE__*/React__default['default'].forwardRef(function Tsunami24(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$2 || (_path269$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,26H24A10.0349,10.0349,0,0,1,17.0732,8.7378,11.9629,11.9629,0,0,0,12.9937,8a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,14.4348,4,19.34,4,26H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,6h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,24h6Z"
    })), children);
  });
  var Tsunami20 = /*#__PURE__*/React__default['default'].forwardRef(function Tsunami20(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270$2 || (_path270$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,26H24A10.0349,10.0349,0,0,1,17.0732,8.7378,11.9629,11.9629,0,0,0,12.9937,8a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,14.4348,4,19.34,4,26H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,6h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,24h6Z"
    })), children);
  });
  var Tsunami16 = /*#__PURE__*/React__default['default'].forwardRef(function Tsunami16(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$2 || (_path271$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,26H24A10.0349,10.0349,0,0,1,17.0732,8.7378,11.9629,11.9629,0,0,0,12.9937,8a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,14.4348,4,19.34,4,26H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,6h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,24h6Z"
    })), children);
  });
  var Tsv32 = /*#__PURE__*/React__default['default'].forwardRef(function Tsv32(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$2 || (_path272$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Tsv24 = /*#__PURE__*/React__default['default'].forwardRef(function Tsv24(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$2 || (_path273$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Tsv20 = /*#__PURE__*/React__default['default'].forwardRef(function Tsv20(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$2 || (_path274$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var Tsv16 = /*#__PURE__*/React__default['default'].forwardRef(function Tsv16(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$2 || (_path275$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H14v4h4a2.002 2.002 0 012 2v4A2.002 2.002 0 0118 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"
    })), children);
  });
  var TwoFactorAuthentication32 = /*#__PURE__*/React__default['default'].forwardRef(function TwoFactorAuthentication32(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$2 || (_path276$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23.18L9 21.179 7.589 22.589 11 26 17 20 15.59 18.59 11 23.18zM28 30H24V28h4V16H24V8a4.0045 4.0045 0 00-4-4V2a6.0067 6.0067 0 016 6v6h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), _path277$2 || (_path277$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14H18V8A6,6,0,0,0,6,8v6H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16A2,2,0,0,0,20,14ZM8,8a4,4,0,0,1,8,0v6H8ZM20,28H4V16H20Z"
    })), children);
  });
  var TwoFactorAuthentication24 = /*#__PURE__*/React__default['default'].forwardRef(function TwoFactorAuthentication24(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$2 || (_path278$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23.18L9 21.179 7.589 22.589 11 26 17 20 15.59 18.59 11 23.18zM28 30H24V28h4V16H24V8a4.0045 4.0045 0 00-4-4V2a6.0067 6.0067 0 016 6v6h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), _path279$2 || (_path279$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14H18V8A6,6,0,0,0,6,8v6H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16A2,2,0,0,0,20,14ZM8,8a4,4,0,0,1,8,0v6H8ZM20,28H4V16H20Z"
    })), children);
  });
  var TwoFactorAuthentication20 = /*#__PURE__*/React__default['default'].forwardRef(function TwoFactorAuthentication20(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path280$2 || (_path280$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23.18L9 21.179 7.589 22.589 11 26 17 20 15.59 18.59 11 23.18zM28 30H24V28h4V16H24V8a4.0045 4.0045 0 00-4-4V2a6.0067 6.0067 0 016 6v6h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), _path281$2 || (_path281$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14H18V8A6,6,0,0,0,6,8v6H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16A2,2,0,0,0,20,14ZM8,8a4,4,0,0,1,8,0v6H8ZM20,28H4V16H20Z"
    })), children);
  });
  var TwoFactorAuthentication16 = /*#__PURE__*/React__default['default'].forwardRef(function TwoFactorAuthentication16(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$2 || (_path282$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23.18L9 21.179 7.589 22.589 11 26 17 20 15.59 18.59 11 23.18zM28 30H24V28h4V16H24V8a4.0045 4.0045 0 00-4-4V2a6.0067 6.0067 0 016 6v6h2a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30z"
    })), _path283$2 || (_path283$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,14H18V8A6,6,0,0,0,6,8v6H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16A2,2,0,0,0,20,14ZM8,8a4,4,0,0,1,8,0v6H8ZM20,28H4V16H20Z"
    })), children);
  });
  var TwoPersonLift32 = /*#__PURE__*/React__default['default'].forwardRef(function TwoPersonLift32(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path284$2 || (_path284$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.96 30l-1.9215-6.7253a1.0008 1.0008 0 01.3369-1.0554L29.874 18.62 28.52 13.2014l-2.7382 3.4234A1.0026 1.0026 0 0125 17H20V15h4.52l3.6993-4.6248a1 1 0 011.7509.3824l2 8a.9989.9989 0 01-.3447 1.0232l-4.48 3.5845 1.7389 6.0854zM23 5.5A3.5 3.5 0 1126.5 9 3.5042 3.5042 0 0123 5.5zm2 0A1.5 1.5 0 1026.5 4 1.5017 1.5017 0 0025 5.5z"
    })), _path285$2 || (_path285$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0039,19A2.0039,2.0039,0,0,1,18,16.9961V15.0039A2.0039,2.0039,0,0,1,20.0039,13H22V10H10v3h1.9961A2.0039,2.0039,0,0,1,14,15.0039v1.9922A2.0039,2.0039,0,0,1,11.9961,19H10v3H22V19Z"
    })), _path286$2 || (_path286$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.04 30l1.9215-6.7253a1.0013 1.0013 0 00-.3369-1.0555L2.126 18.62l1.3545-5.4185 2.7382 3.4234A1.0026 1.0026 0 007 17h5V15H7.4805L3.7812 10.3752a1 1 0 00-1.7509.3824l-2 8A.9989.9989 0 00.375 19.7808l4.4805 3.5844-1.739 6.0855zM5.5 9A3.5 3.5 0 119 5.5 3.5042 3.5042 0 015.5 9zm0-5A1.5 1.5 0 107 5.5 1.5017 1.5017 0 005.5 4z"
    })), children);
  });
  var TwoPersonLift24 = /*#__PURE__*/React__default['default'].forwardRef(function TwoPersonLift24(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$2 || (_path287$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.96 30l-1.9215-6.7253a1.0008 1.0008 0 01.3369-1.0554L29.874 18.62 28.52 13.2014l-2.7382 3.4234A1.0026 1.0026 0 0125 17H20V15h4.52l3.6993-4.6248a1 1 0 011.7509.3824l2 8a.9989.9989 0 01-.3447 1.0232l-4.48 3.5845 1.7389 6.0854zM23 5.5A3.5 3.5 0 1126.5 9 3.5042 3.5042 0 0123 5.5zm2 0A1.5 1.5 0 1026.5 4 1.5017 1.5017 0 0025 5.5z"
    })), _path288$2 || (_path288$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0039,19A2.0039,2.0039,0,0,1,18,16.9961V15.0039A2.0039,2.0039,0,0,1,20.0039,13H22V10H10v3h1.9961A2.0039,2.0039,0,0,1,14,15.0039v1.9922A2.0039,2.0039,0,0,1,11.9961,19H10v3H22V19Z"
    })), _path289$2 || (_path289$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.04 30l1.9215-6.7253a1.0013 1.0013 0 00-.3369-1.0555L2.126 18.62l1.3545-5.4185 2.7382 3.4234A1.0026 1.0026 0 007 17h5V15H7.4805L3.7812 10.3752a1 1 0 00-1.7509.3824l-2 8A.9989.9989 0 00.375 19.7808l4.4805 3.5844-1.739 6.0855zM5.5 9A3.5 3.5 0 119 5.5 3.5042 3.5042 0 015.5 9zm0-5A1.5 1.5 0 107 5.5 1.5017 1.5017 0 005.5 4z"
    })), children);
  });
  var TwoPersonLift20 = /*#__PURE__*/React__default['default'].forwardRef(function TwoPersonLift20(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path290$2 || (_path290$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.96 30l-1.9215-6.7253a1.0008 1.0008 0 01.3369-1.0554L29.874 18.62 28.52 13.2014l-2.7382 3.4234A1.0026 1.0026 0 0125 17H20V15h4.52l3.6993-4.6248a1 1 0 011.7509.3824l2 8a.9989.9989 0 01-.3447 1.0232l-4.48 3.5845 1.7389 6.0854zM23 5.5A3.5 3.5 0 1126.5 9 3.5042 3.5042 0 0123 5.5zm2 0A1.5 1.5 0 1026.5 4 1.5017 1.5017 0 0025 5.5z"
    })), _path291$2 || (_path291$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0039,19A2.0039,2.0039,0,0,1,18,16.9961V15.0039A2.0039,2.0039,0,0,1,20.0039,13H22V10H10v3h1.9961A2.0039,2.0039,0,0,1,14,15.0039v1.9922A2.0039,2.0039,0,0,1,11.9961,19H10v3H22V19Z"
    })), _path292$2 || (_path292$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.04 30l1.9215-6.7253a1.0013 1.0013 0 00-.3369-1.0555L2.126 18.62l1.3545-5.4185 2.7382 3.4234A1.0026 1.0026 0 007 17h5V15H7.4805L3.7812 10.3752a1 1 0 00-1.7509.3824l-2 8A.9989.9989 0 00.375 19.7808l4.4805 3.5844-1.739 6.0855zM5.5 9A3.5 3.5 0 119 5.5 3.5042 3.5042 0 015.5 9zm0-5A1.5 1.5 0 107 5.5 1.5017 1.5017 0 005.5 4z"
    })), children);
  });
  var TwoPersonLift16 = /*#__PURE__*/React__default['default'].forwardRef(function TwoPersonLift16(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293$2 || (_path293$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.96 30l-1.9215-6.7253a1.0008 1.0008 0 01.3369-1.0554L29.874 18.62 28.52 13.2014l-2.7382 3.4234A1.0026 1.0026 0 0125 17H20V15h4.52l3.6993-4.6248a1 1 0 011.7509.3824l2 8a.9989.9989 0 01-.3447 1.0232l-4.48 3.5845 1.7389 6.0854zM23 5.5A3.5 3.5 0 1126.5 9 3.5042 3.5042 0 0123 5.5zm2 0A1.5 1.5 0 1026.5 4 1.5017 1.5017 0 0025 5.5z"
    })), _path294$2 || (_path294$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.0039,19A2.0039,2.0039,0,0,1,18,16.9961V15.0039A2.0039,2.0039,0,0,1,20.0039,13H22V10H10v3h1.9961A2.0039,2.0039,0,0,1,14,15.0039v1.9922A2.0039,2.0039,0,0,1,11.9961,19H10v3H22V19Z"
    })), _path295$2 || (_path295$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.04 30l1.9215-6.7253a1.0013 1.0013 0 00-.3369-1.0555L2.126 18.62l1.3545-5.4185 2.7382 3.4234A1.0026 1.0026 0 007 17h5V15H7.4805L3.7812 10.3752a1 1 0 00-1.7509.3824l-2 8A.9989.9989 0 00.375 19.7808l4.4805 3.5844-1.739 6.0855zM5.5 9A3.5 3.5 0 119 5.5 3.5042 3.5042 0 015.5 9zm0-5A1.5 1.5 0 107 5.5 1.5017 1.5017 0 005.5 4z"
    })), children);
  });
  var Txt32 = /*#__PURE__*/React__default['default'].forwardRef(function Txt32(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$2 || (_path296$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"
    })), children);
  });
  var Txt24 = /*#__PURE__*/React__default['default'].forwardRef(function Txt24(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$2 || (_path297$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"
    })), children);
  });
  var Txt20 = /*#__PURE__*/React__default['default'].forwardRef(function Txt20(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$2 || (_path298$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"
    })), children);
  });
  var Txt16 = /*#__PURE__*/React__default['default'].forwardRef(function Txt16(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$2 || (_path299$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"
    })), children);
  });
  var TxtReference32 = /*#__PURE__*/React__default['default'].forwardRef(function TxtReference32(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$2 || (_path300$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM21 4L24 4 24 16 26 16 26 4 29 4 29 2 21 2 21 4zM20 2L18 2 16 8 14 2 12 2 14.752 9 12 16 14 16 16 10 18 16 20 16 17.245 9 20 2zM3 4L6 4 6 16 8 16 8 4 11 4 11 2 3 2 3 4z"
    })), children);
  });
  var TxtReference24 = /*#__PURE__*/React__default['default'].forwardRef(function TxtReference24(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$2 || (_path301$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM21 4L24 4 24 16 26 16 26 4 29 4 29 2 21 2 21 4zM20 2L18 2 16 8 14 2 12 2 14.752 9 12 16 14 16 16 10 18 16 20 16 17.245 9 20 2zM3 4L6 4 6 16 8 16 8 4 11 4 11 2 3 2 3 4z"
    })), children);
  });
  var TxtReference20 = /*#__PURE__*/React__default['default'].forwardRef(function TxtReference20(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$2 || (_path302$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM21 4L24 4 24 16 26 16 26 4 29 4 29 2 21 2 21 4zM20 2L18 2 16 8 14 2 12 2 14.752 9 12 16 14 16 16 10 18 16 20 16 17.245 9 20 2zM3 4L6 4 6 16 8 16 8 4 11 4 11 2 3 2 3 4z"
    })), children);
  });
  var TxtReference16 = /*#__PURE__*/React__default['default'].forwardRef(function TxtReference16(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$2 || (_path303$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM21 4L24 4 24 16 26 16 26 4 29 4 29 2 21 2 21 4zM20 2L18 2 16 8 14 2 12 2 14.752 9 12 16 14 16 16 10 18 16 20 16 17.245 9 20 2zM3 4L6 4 6 16 8 16 8 4 11 4 11 2 3 2 3 4z"
    })), children);
  });
  var TypePattern32 = /*#__PURE__*/React__default['default'].forwardRef(function TypePattern32(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path304$2 || (_path304$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path305$2 || (_path305$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 01-.8945-1.4473l4-8a1.0412 1.0412 0 011.789 0l4 8A1 1 0 0111 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6.001L28 4zM7 12a5 5 0 115-5A5.0059 5.0059 0 017 12zM7 4a3 3 0 103 3A3.0033 3.0033 0 007 4z"
    })), children);
  });
  var TypePattern24 = /*#__PURE__*/React__default['default'].forwardRef(function TypePattern24(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path306$2 || (_path306$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path307$2 || (_path307$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 01-.8945-1.4473l4-8a1.0412 1.0412 0 011.789 0l4 8A1 1 0 0111 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6.001L28 4zM7 12a5 5 0 115-5A5.0059 5.0059 0 017 12zM7 4a3 3 0 103 3A3.0033 3.0033 0 007 4z"
    })), children);
  });
  var TypePattern20 = /*#__PURE__*/React__default['default'].forwardRef(function TypePattern20(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path308$2 || (_path308$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path309$2 || (_path309$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 01-.8945-1.4473l4-8a1.0412 1.0412 0 011.789 0l4 8A1 1 0 0111 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6.001L28 4zM7 12a5 5 0 115-5A5.0059 5.0059 0 017 12zM7 4a3 3 0 103 3A3.0033 3.0033 0 007 4z"
    })), children);
  });
  var TypePattern16 = /*#__PURE__*/React__default['default'].forwardRef(function TypePattern16(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path310$2 || (_path310$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"
    })), _path311$2 || (_path311$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 01-.8945-1.4473l4-8a1.0412 1.0412 0 011.789 0l4 8A1 1 0 0111 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 01-2-2V4a2.0023 2.0023 0 012-2h6a2.0023 2.0023 0 012 2v6A2.0023 2.0023 0 0128 12zM22 4v6h6.001L28 4zM7 12a5 5 0 115-5A5.0059 5.0059 0 017 12zM7 4a3 3 0 103 3A3.0033 3.0033 0 007 4z"
    })), children);
  });
  var Types32 = /*#__PURE__*/React__default['default'].forwardRef(function Types32(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$2 || (_path312$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"
    })), _path313$2 || (_path313$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"
    })), _path314$2 || (_path314$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"
    })), children);
  });
  var Types24 = /*#__PURE__*/React__default['default'].forwardRef(function Types24(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$2 || (_path315$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"
    })), _path316$2 || (_path316$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"
    })), _path317$2 || (_path317$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"
    })), children);
  });
  var Types20 = /*#__PURE__*/React__default['default'].forwardRef(function Types20(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318$2 || (_path318$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"
    })), _path319$2 || (_path319$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"
    })), _path320$2 || (_path320$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"
    })), children);
  });
  var Types16 = /*#__PURE__*/React__default['default'].forwardRef(function Types16(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$2 || (_path321$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"
    })), _path322$2 || (_path322$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"
    })), _path323$2 || (_path323$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"
    })), children);
  });
  var QU132 = /*#__PURE__*/React__default['default'].forwardRef(function QU132(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path324$2 || (_path324$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"
    })), children);
  });
  var QU124 = /*#__PURE__*/React__default['default'].forwardRef(function QU124(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325$2 || (_path325$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"
    })), children);
  });
  var QU120 = /*#__PURE__*/React__default['default'].forwardRef(function QU120(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$2 || (_path326$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"
    })), children);
  });
  var QU116 = /*#__PURE__*/React__default['default'].forwardRef(function QU116(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327$2 || (_path327$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"
    })), children);
  });
  var QU232 = /*#__PURE__*/React__default['default'].forwardRef(function QU232(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path328$2 || (_path328$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM25 23H17V17a2 2 0 012-2h4V11H17V9h6a2 2 0 012 2v4a2 2 0 01-2 2H19v4h6z"
    })), children);
  });
  var QU224 = /*#__PURE__*/React__default['default'].forwardRef(function QU224(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$2 || (_path329$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM25 23H17V17a2 2 0 012-2h4V11H17V9h6a2 2 0 012 2v4a2 2 0 01-2 2H19v4h6z"
    })), children);
  });
  var QU220 = /*#__PURE__*/React__default['default'].forwardRef(function QU220(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path330$2 || (_path330$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM25 23H17V17a2 2 0 012-2h4V11H17V9h6a2 2 0 012 2v4a2 2 0 01-2 2H19v4h6z"
    })), children);
  });
  var QU216 = /*#__PURE__*/React__default['default'].forwardRef(function QU216(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path331$2 || (_path331$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM25 23H17V17a2 2 0 012-2h4V11H17V9h6a2 2 0 012 2v4a2 2 0 01-2 2H19v4h6z"
    })), children);
  });
  var QU332 = /*#__PURE__*/React__default['default'].forwardRef(function QU332(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$2 || (_path332$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 002-2V11A2 2 0 0023 9z"
    })), children);
  });
  var QU324 = /*#__PURE__*/React__default['default'].forwardRef(function QU324(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333$2 || (_path333$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 002-2V11A2 2 0 0023 9z"
    })), children);
  });
  var QU320 = /*#__PURE__*/React__default['default'].forwardRef(function QU320(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path334$2 || (_path334$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 002-2V11A2 2 0 0023 9z"
    })), children);
  });
  var QU316 = /*#__PURE__*/React__default['default'].forwardRef(function QU316(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335$2 || (_path335$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 23H9a2 2 0 01-2-2V9H9V21h4V9h2V21A2 2 0 0113 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 002-2V11A2 2 0 0023 9z"
    })), children);
  });
  var Umbrella32 = /*#__PURE__*/React__default['default'].forwardRef(function Umbrella32(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path336$2 || (_path336$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83A14.3808,14.3808,0,0,0,17,4.0464V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4411,12.4411,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333,6.5439,6.5439,0,0,0,6,14Zm10,0a6.5528,6.5528,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0563-9.1763,3.4308,2.6768,4.0091,6.9487,4.0525,9.1728A6.553,6.553,0,0,0,16,14Zm10,0a6.5439,6.5439,0,0,0-3.939,1.333,14.5164,14.5164,0,0,0-3.0456-8.9341,12.4411,12.4411,0,0,1,8.488,7.8145A5.4079,5.4079,0,0,0,26,14Z"
    })), children);
  });
  var Umbrella24 = /*#__PURE__*/React__default['default'].forwardRef(function Umbrella24(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337$2 || (_path337$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83A14.3808,14.3808,0,0,0,17,4.0464V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4411,12.4411,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333,6.5439,6.5439,0,0,0,6,14Zm10,0a6.5528,6.5528,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0563-9.1763,3.4308,2.6768,4.0091,6.9487,4.0525,9.1728A6.553,6.553,0,0,0,16,14Zm10,0a6.5439,6.5439,0,0,0-3.939,1.333,14.5164,14.5164,0,0,0-3.0456-8.9341,12.4411,12.4411,0,0,1,8.488,7.8145A5.4079,5.4079,0,0,0,26,14Z"
    })), children);
  });
  var Umbrella20 = /*#__PURE__*/React__default['default'].forwardRef(function Umbrella20(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path338$2 || (_path338$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83A14.3808,14.3808,0,0,0,17,4.0464V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4411,12.4411,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333,6.5439,6.5439,0,0,0,6,14Zm10,0a6.5528,6.5528,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0563-9.1763,3.4308,2.6768,4.0091,6.9487,4.0525,9.1728A6.553,6.553,0,0,0,16,14Zm10,0a6.5439,6.5439,0,0,0-3.939,1.333,14.5164,14.5164,0,0,0-3.0456-8.9341,12.4411,12.4411,0,0,1,8.488,7.8145A5.4079,5.4079,0,0,0,26,14Z"
    })), children);
  });
  var Umbrella16 = /*#__PURE__*/React__default['default'].forwardRef(function Umbrella16(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339$2 || (_path339$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9854,15.83A14.3808,14.3808,0,0,0,17,4.0464V2H15V4.0464A14.3808,14.3808,0,0,0,2.0146,15.83,1,1,0,0,0,3.51,16.86,4.8551,4.8551,0,0,1,6,16a4.8653,4.8653,0,0,1,4.1406,2.5107,1.0393,1.0393,0,0,0,1.7188,0A5.02,5.02,0,0,1,15,16.1255V25.5a2.5,2.5,0,0,1-5,0V25H8v.5a4.5,4.5,0,0,0,9,0V16.1255a5.02,5.02,0,0,1,3.1406,2.3852.9994.9994,0,0,0,1.7188,0A4.8653,4.8653,0,0,1,26,16a4.8551,4.8551,0,0,1,2.49.86,1,1,0,0,0,1.4957-1.03ZM6,14a5.4079,5.4079,0,0,0-1.5034.2134,12.4411,12.4411,0,0,1,8.488-7.8145A14.5157,14.5157,0,0,0,9.939,15.333,6.5439,6.5439,0,0,0,6,14Zm10,0a6.5528,6.5528,0,0,0-4.0564,1.4307c.0378-2.22.6089-6.49,4.0563-9.1763,3.4308,2.6768,4.0091,6.9487,4.0525,9.1728A6.553,6.553,0,0,0,16,14Zm10,0a6.5439,6.5439,0,0,0-3.939,1.333,14.5164,14.5164,0,0,0-3.0456-8.9341,12.4411,12.4411,0,0,1,8.488,7.8145A5.4079,5.4079,0,0,0,26,14Z"
    })), children);
  });
  var Undefined32 = /*#__PURE__*/React__default['default'].forwardRef(function Undefined32(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path340$2 || (_path340$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 14H21V18H11z"
    })), _path341$2 || (_path341$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var Undefined24 = /*#__PURE__*/React__default['default'].forwardRef(function Undefined24(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path342$2 || (_path342$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 14H21V18H11z"
    })), _path343$2 || (_path343$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var Undefined20 = /*#__PURE__*/React__default['default'].forwardRef(function Undefined20(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344$2 || (_path344$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 14H21V18H11z"
    })), _path345$2 || (_path345$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var Undefined16 = /*#__PURE__*/React__default['default'].forwardRef(function Undefined16(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path346$2 || (_path346$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 14H21V18H11z"
    })), _path347$2 || (_path347$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var UndefinedGlyph = /*#__PURE__*/React__default['default'].forwardRef(function UndefinedGlyph(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path348$2 || (_path348$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2.4142,13.5858,8,8,13.5858,2.4142,8,8,2.4142M8,1,1,8l7,7,7-7L8,1Z"
    })), _path349$2 || (_path349$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,2.4142,13.5858,8,8,13.5858,2.4142,8,8,2.4142"
    })), children);
  });
  var UndefinedFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function UndefinedFilled32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350$2 || (_path350$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"
    })), _path351$2 || (_path351$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11 14H21V18H11z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var UndefinedFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function UndefinedFilled24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path352$2 || (_path352$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"
    })), _path353$2 || (_path353$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11 14H21V18H11z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var UndefinedFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function UndefinedFilled20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path354$2 || (_path354$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"
    })), _path355$2 || (_path355$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11 14H21V18H11z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var UndefinedFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function UndefinedFilled16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356$2 || (_path356$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"
    })), _path357$2 || (_path357$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M11 14H21V18H11z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var Undo32 = /*#__PURE__*/React__default['default'].forwardRef(function Undo32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path358$2 || (_path358$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,10H7.8149l3.5874-3.5859L10,5,4,11,10,17l1.4023-1.4146L7.8179,12H20a6,6,0,0,1,0,12H12v2h8a8,8,0,0,0,0-16Z"
    })), children);
  });
  var Undo24 = /*#__PURE__*/React__default['default'].forwardRef(function Undo24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$2 || (_path359$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.2,11.2c1.8,0,3.2,1.7,3.2,3.3c0,1.5-1.5,3.2-3.2,3.2H14v1.5h3.2c2.2,0,4.8-2.3,4.8-4.8s-2-4.8-4.8-4.8\tH4.8l3-3L6.8,5.7L2,10.5l4.8,4.8l1.1-1.1l-3-3H17.2z"
    })), children);
  });
  var Undo20 = /*#__PURE__*/React__default['default'].forwardRef(function Undo20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path360$2 || (_path360$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15,9.3c1.5,0,2.8,1.3,2.8,2.7c0,1.5-1.3,2.7-2.8,2.7h-4V16h4c2.3,0,4-1.7,4-4c0-2.2-1.8-4-4-4H3.4\tl2.5-2.5L5,4.6l-4,4l4,4l0.9-0.9L3.4,9.3H15z"
    })), children);
  });
  var Undo16 = /*#__PURE__*/React__default['default'].forwardRef(function Undo16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$2 || (_path361$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,8c1.2,0,2,0.8,2,2c0,1.2-0.8,2-2,2H9v1h3c1.7,0,3-1.2,3-3c0-1.7-1.3-3-3-3L2.9,7l2-2L4.2,4.3L1,7.5\tl3.2,3.2L4.9,10l-2-2L12,8z"
    })), children);
  });
  var UngroupObjects32 = /*#__PURE__*/React__default['default'].forwardRef(function UngroupObjects32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362$2 || (_path362$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14V10H26v2H20V6h2V2H18V4H6V2H2V6H4V18H2v4H6V20h6v6H10v4h4V28H26v2h4V26H28V14ZM6,6H18V18H6ZM26,26H14V20h4v2h4V18H20V14h6Z"
    })), children);
  });
  var UngroupObjects24 = /*#__PURE__*/React__default['default'].forwardRef(function UngroupObjects24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$2 || (_path363$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14V10H26v2H20V6h2V2H18V4H6V2H2V6H4V18H2v4H6V20h6v6H10v4h4V28H26v2h4V26H28V14ZM6,6H18V18H6ZM26,26H14V20h4v2h4V18H20V14h6Z"
    })), children);
  });
  var UngroupObjects20 = /*#__PURE__*/React__default['default'].forwardRef(function UngroupObjects20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path364$2 || (_path364$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14V10H26v2H20V6h2V2H18V4H6V2H2V6H4V18H2v4H6V20h6v6H10v4h4V28H26v2h4V26H28V14ZM6,6H18V18H6ZM26,26H14V20h4v2h4V18H20V14h6Z"
    })), children);
  });
  var UngroupObjects16 = /*#__PURE__*/React__default['default'].forwardRef(function UngroupObjects16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$2 || (_path365$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,14V10H26v2H20V6h2V2H18V4H6V2H2V6H4V18H2v4H6V20h6v6H10v4h4V28H26v2h4V26H28V14ZM6,6H18V18H6ZM26,26H14V20h4v2h4V18H20V14h6Z"
    })), children);
  });
  var Unknown32 = /*#__PURE__*/React__default['default'].forwardRef(function Unknown32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle$2 || (_circle$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22.5",
      r: "1.5"
    })), _path366$2 || (_path366$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path367$2 || (_path367$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var Unknown24 = /*#__PURE__*/React__default['default'].forwardRef(function Unknown24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle2$2 || (_circle2$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22.5",
      r: "1.5"
    })), _path368$2 || (_path368$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path369$2 || (_path369$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var Unknown20 = /*#__PURE__*/React__default['default'].forwardRef(function Unknown20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle3$2 || (_circle3$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22.5",
      r: "1.5"
    })), _path370$2 || (_path370$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path371$2 || (_path371$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var Unknown16 = /*#__PURE__*/React__default['default'].forwardRef(function Unknown16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle4$2 || (_circle4$2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "22.5",
      r: "1.5"
    })), _path372$2 || (_path372$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"
    })), _path373$2 || (_path373$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"
    })), children);
  });
  var UnknownFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function UnknownFilled32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path374$2 || (_path374$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"
    })), _path375$2 || (_path375$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var UnknownFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function UnknownFilled24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path376$2 || (_path376$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"
    })), _path377$2 || (_path377$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var UnknownFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function UnknownFilled20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378$2 || (_path378$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"
    })), _path379$2 || (_path379$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var UnknownFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function UnknownFilled16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$2 || (_path380$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"
    })), _path381$2 || (_path381$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var Unlink32 = /*#__PURE__*/React__default['default'].forwardRef(function Unlink32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$2 || (_path382$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 3.59H7V8.42H5z",
      transform: "rotate(-45.01 5.996 6.005)"
    })), _path383$2 || (_path383$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23.58H27V28.409999999999997H25z",
      transform: "rotate(-44.99 25.995 25.999)"
    })), _path384$2 || (_path384$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 11-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 00-.06 8.54A6 6 0 0010 28a6.07 6.07 0 004.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 115.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 00.06-8.54A6 6 0 0022 4a6.07 6.07 0 00-4.32 1.8L14 9.51z"
    })), children);
  });
  var Unlink24 = /*#__PURE__*/React__default['default'].forwardRef(function Unlink24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$2 || (_path385$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 3.59H7V8.42H5z",
      transform: "rotate(-45.01 5.996 6.005)"
    })), _path386$2 || (_path386$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23.58H27V28.409999999999997H25z",
      transform: "rotate(-44.99 25.995 25.999)"
    })), _path387$2 || (_path387$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 11-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 00-.06 8.54A6 6 0 0010 28a6.07 6.07 0 004.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 115.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 00.06-8.54A6 6 0 0022 4a6.07 6.07 0 00-4.32 1.8L14 9.51z"
    })), children);
  });
  var Unlink20 = /*#__PURE__*/React__default['default'].forwardRef(function Unlink20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388$2 || (_path388$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 3.59H7V8.42H5z",
      transform: "rotate(-45.01 5.996 6.005)"
    })), _path389$2 || (_path389$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23.58H27V28.409999999999997H25z",
      transform: "rotate(-44.99 25.995 25.999)"
    })), _path390$2 || (_path390$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 11-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 00-.06 8.54A6 6 0 0010 28a6.07 6.07 0 004.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 115.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 00.06-8.54A6 6 0 0022 4a6.07 6.07 0 00-4.32 1.8L14 9.51z"
    })), children);
  });
  var Unlink16 = /*#__PURE__*/React__default['default'].forwardRef(function Unlink16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391$2 || (_path391$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5 3.59H7V8.42H5z",
      transform: "rotate(-45.01 5.996 6.005)"
    })), _path392$2 || (_path392$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23.58H27V28.409999999999997H25z",
      transform: "rotate(-44.99 25.995 25.999)"
    })), _path393$2 || (_path393$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 11-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 00-.06 8.54A6 6 0 0010 28a6.07 6.07 0 004.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 115.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 00.06-8.54A6 6 0 0022 4a6.07 6.07 0 00-4.32 1.8L14 9.51z"
    })), children);
  });
  var Unlocked32 = /*#__PURE__*/React__default['default'].forwardRef(function Unlocked32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394$2 || (_path394$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H12V8a4,4,0,0,1,8,0h2A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14Zm0,14H8V16H24Z"
    })), children);
  });
  var Unlocked24 = /*#__PURE__*/React__default['default'].forwardRef(function Unlocked24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path395$2 || (_path395$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H12V8a4,4,0,0,1,8,0h2A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14Zm0,14H8V16H24Z"
    })), children);
  });
  var Unlocked20 = /*#__PURE__*/React__default['default'].forwardRef(function Unlocked20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path396$2 || (_path396$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,14H12V8a4,4,0,0,1,8,0h2A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14Zm0,14H8V16H24Z"
    })), children);
  });
  var Unlocked16 = /*#__PURE__*/React__default['default'].forwardRef(function Unlocked16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397$2 || (_path397$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,7H6V4c0-1.1,0.9-2,2-2s2,0.9,2,2h1c0-1.7-1.3-3-3-3S5,2.3,5,4v3H4C3.4,7,3,7.4,3,8v6c0,0.6,0.4,1,1,1h8c0.6,0,1-0.4,1-1\tV8C13,7.4,12.6,7,12,7z M12,14H4V8h8V14z"
    })), children);
  });
  var UpToTop32 = /*#__PURE__*/React__default['default'].forwardRef(function UpToTop32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path398$2 || (_path398$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var UpToTop24 = /*#__PURE__*/React__default['default'].forwardRef(function UpToTop24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path399$1 || (_path399$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var UpToTop20 = /*#__PURE__*/React__default['default'].forwardRef(function UpToTop20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path400$1 || (_path400$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var UpToTop16 = /*#__PURE__*/React__default['default'].forwardRef(function UpToTop16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path401$1 || (_path401$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 14L6 24 7.4 25.4 16 16.8 24.6 25.4 26 24zM4 8H28V10H4z"
    })), children);
  });
  var UpdateNow32 = /*#__PURE__*/React__default['default'].forwardRef(function UpdateNow32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path402$1 || (_path402$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25.586L25 23.586 25 21 23 21 23 24.414 25.586 27 27 25.586z"
    })), _path403$1 || (_path403$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 31a7 7 0 117-7A7.0078 7.0078 0 0124 31zm0-12a5 5 0 105 5A5.0055 5.0055 0 0024 19zM16 28A12.0134 12.0134 0 014 16H2A14.0158 14.0158 0 0016 30zM12 8H7.0784A11.9843 11.9843 0 0128 16h2A13.9778 13.9778 0 006 6.2344V2H4v8h8z"
    })), children);
  });
  var UpdateNow24 = /*#__PURE__*/React__default['default'].forwardRef(function UpdateNow24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path404$1 || (_path404$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25.586L25 23.586 25 21 23 21 23 24.414 25.586 27 27 25.586z"
    })), _path405$1 || (_path405$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 31a7 7 0 117-7A7.0078 7.0078 0 0124 31zm0-12a5 5 0 105 5A5.0055 5.0055 0 0024 19zM16 28A12.0134 12.0134 0 014 16H2A14.0158 14.0158 0 0016 30zM12 8H7.0784A11.9843 11.9843 0 0128 16h2A13.9778 13.9778 0 006 6.2344V2H4v8h8z"
    })), children);
  });
  var UpdateNow20 = /*#__PURE__*/React__default['default'].forwardRef(function UpdateNow20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path406$1 || (_path406$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25.586L25 23.586 25 21 23 21 23 24.414 25.586 27 27 25.586z"
    })), _path407$1 || (_path407$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 31a7 7 0 117-7A7.0078 7.0078 0 0124 31zm0-12a5 5 0 105 5A5.0055 5.0055 0 0024 19zM16 28A12.0134 12.0134 0 014 16H2A14.0158 14.0158 0 0016 30zM12 8H7.0784A11.9843 11.9843 0 0128 16h2A13.9778 13.9778 0 006 6.2344V2H4v8h8z"
    })), children);
  });
  var UpdateNow16 = /*#__PURE__*/React__default['default'].forwardRef(function UpdateNow16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path408$1 || (_path408$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 25.586L25 23.586 25 21 23 21 23 24.414 25.586 27 27 25.586z"
    })), _path409$1 || (_path409$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 31a7 7 0 117-7A7.0078 7.0078 0 0124 31zm0-12a5 5 0 105 5A5.0055 5.0055 0 0024 19zM16 28A12.0134 12.0134 0 014 16H2A14.0158 14.0158 0 0016 30zM12 8H7.0784A11.9843 11.9843 0 0128 16h2A13.9778 13.9778 0 006 6.2344V2H4v8h8z"
    })), children);
  });
  var Upgrade32 = /*#__PURE__*/React__default['default'].forwardRef(function Upgrade32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path410$1 || (_path410$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 24H11a2 2 0 00-2 2v2a2 2 0 002 2H21a2 2 0 002-2V26A2 2 0 0021 24zm0 4H11V26H21zM28.707 14.293l-12-12a.9994.9994 0 00-1.414 0l-12 12A1 1 0 004 16H9v4a2.0023 2.0023 0 002 2H21a2.0027 2.0027 0 002-2V16h5a1 1 0 00.707-1.707zM21 14v6H11V14H6.4141L16 4.4141 25.5859 14z"
    })), children);
  });
  var Upgrade24 = /*#__PURE__*/React__default['default'].forwardRef(function Upgrade24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path411$1 || (_path411$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 24H11a2 2 0 00-2 2v2a2 2 0 002 2H21a2 2 0 002-2V26A2 2 0 0021 24zm0 4H11V26H21zM28.707 14.293l-12-12a.9994.9994 0 00-1.414 0l-12 12A1 1 0 004 16H9v4a2.0023 2.0023 0 002 2H21a2.0027 2.0027 0 002-2V16h5a1 1 0 00.707-1.707zM21 14v6H11V14H6.4141L16 4.4141 25.5859 14z"
    })), children);
  });
  var Upgrade20 = /*#__PURE__*/React__default['default'].forwardRef(function Upgrade20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path412$1 || (_path412$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 24H11a2 2 0 00-2 2v2a2 2 0 002 2H21a2 2 0 002-2V26A2 2 0 0021 24zm0 4H11V26H21zM28.707 14.293l-12-12a.9994.9994 0 00-1.414 0l-12 12A1 1 0 004 16H9v4a2.0023 2.0023 0 002 2H21a2.0027 2.0027 0 002-2V16h5a1 1 0 00.707-1.707zM21 14v6H11V14H6.4141L16 4.4141 25.5859 14z"
    })), children);
  });
  var Upgrade16 = /*#__PURE__*/React__default['default'].forwardRef(function Upgrade16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path413$1 || (_path413$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 24H11a2 2 0 00-2 2v2a2 2 0 002 2H21a2 2 0 002-2V26A2 2 0 0021 24zm0 4H11V26H21zM28.707 14.293l-12-12a.9994.9994 0 00-1.414 0l-12 12A1 1 0 004 16H9v4a2.0023 2.0023 0 002 2H21a2.0027 2.0027 0 002-2V16h5a1 1 0 00.707-1.707zM21 14v6H11V14H6.4141L16 4.4141 25.5859 14z"
    })), children);
  });
  var Upload32 = /*#__PURE__*/React__default['default'].forwardRef(function Upload32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path414$1 || (_path414$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18L7.41 19.41 15 11.83 15 30 17 30 17 11.83 24.59 19.41 26 18 16 8 6 18zM6 8V4H26V8h2V4a2 2 0 00-2-2H6A2 2 0 004 4V8z"
    })), children);
  });
  var Upload24 = /*#__PURE__*/React__default['default'].forwardRef(function Upload24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415$1 || (_path415$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18L7.41 19.41 15 11.83 15 30 17 30 17 11.83 24.59 19.41 26 18 16 8 6 18zM6 8V4H26V8h2V4a2 2 0 00-2-2H6A2 2 0 004 4V8z"
    })), children);
  });

  var _path$2, _path2$2, _path3$2, _path4$2, _path5$2, _path6$2, _path7$2, _path8$2, _path9$2, _path10$2, _path11$2, _path12$2, _path13$2, _path14$2, _path15$2, _path16$2, _path17$2, _path18$2, _path19$2, _path20$2, _path21$2, _path22$2, _path23$2, _path24$2, _path25$2, _path26$2, _path27$2, _path28$2, _path29$2, _path30$2, _path31$2, _path32$2, _path33$2, _path34$2, _path35$2, _path36$2, _path37$2, _path38$2, _path39$2, _path40$2, _path41$2, _path42$2, _path43$2, _path44$2, _path45$2, _path46$2, _path47$2, _path48$2, _path49$2, _path50$2, _path51$2, _path52$2, _path53$2, _path54$2, _path55$2, _path56$2, _path57$2, _path58$2, _path59$2, _path60$2, _path61$2, _path62$2, _path63$2, _path64$2, _path65$2, _path66$2, _path67$2, _path68$2, _path69$2, _path70$2, _path71$2, _path72$2, _path73$2, _path74$2, _path75$2, _path76$2, _path77$2, _path78$2, _path79$2, _circle$1, _path80$2, _path81$2, _circle2$1, _path82$2, _path83$2, _circle3$1, _path84$2, _path85$2, _circle4$1, _path86$2, _path87$2, _path88$2, _path89$2, _path90$2, _path91$2, _path92$2, _path93$2, _path94$2, _path95$2, _path96$2, _path97$2, _path98$2, _path99$2, _path100$2, _path101$2, _path102$2, _circle5$1, _path103$2, _circle6$1, _path104$2, _circle7$1, _path105$2, _circle8$1, _path106$2, _path107$2, _path108$2, _path109$2, _path110$2, _path111$2, _path112$2, _path113$2, _path114$2, _path115$2, _path116$2, _path117$2, _path118$2, _path119$2, _path120$2, _path121$2, _path122$2, _path123$2, _path124$2, _path125$2, _path126$2, _path127$2, _path128$2, _path129$2, _path130$2, _path131$2, _path132$2, _path133$2, _path134$2, _path135$2, _path136$2, _path137$2, _path138$2, _path139$2, _path140$2, _path141$2, _path142$2, _path143$2, _path144$2, _path145$2, _path146$2, _path147$2, _path148$2, _path149$2, _path150$2, _path151$2, _path152$2, _path153$2, _path154$2, _path155$2, _path156$2, _path157$2, _path158$2, _path159$2, _path160$2, _path161$2, _path162$2, _path163$2, _path164$2, _path165$2, _path166$2, _path167$2, _path168$2, _path169$2, _path170$2, _path171$2, _path172$2, _path173$2, _path174$2, _path175$2, _path176$2, _path177$1, _path178$1, _path179$1, _path180$1, _path181$1, _path182$1, _path183$1, _path184$1, _path185$1, _path186$1, _path187$1, _path188$1, _path189$1, _path190$1, _path191$1, _path192$1, _path193$1, _path194$1, _path195$1, _path196$1, _path197$1, _path198$1, _path199$1, _path200$1, _path201$1, _path202$1, _path203$1, _path204$1, _path205$1, _path206$1, _circle9$1, _path207$1, _path208$1, _circle10$1, _path209$1, _path210$1, _circle11$1, _path211$1, _path212$1, _circle12$1, _path213$1, _path214$1, _path215$1, _path216$1, _path217$1, _path218$1, _path219$1, _path220$1, _path221$1, _path222$1, _path223$1, _path224$1, _path225$1, _path226$1, _path227$1, _path228$1, _path229$1, _path230$1, _path231$1, _path232$1, _path233$1, _path234$1, _path235$1, _path236$1, _path237$1, _path238$1, _path239$1, _path240$1, _path241$1, _path242$1, _path243$1, _path244$1, _path245$1, _path246$1, _path247$1, _path248$1, _path249$1, _path250$1, _path251$1, _path252$1, _path253$1, _path254$1, _path255$1, _path256$1, _path257$1, _path258$1, _path259$1, _path260$1, _path261$1, _path262$1, _path263$1, _path264$1, _path265$1, _path266$1, _path267$1, _path268$1, _path269$1, _path270$1, _path271$1, _path272$1, _path273$1, _path274$1, _path275$1, _path276$1, _path277$1, _path278$1, _path279$1, _path280$1, _path281$1, _path282$1, _path283$1, _path284$1, _path285$1, _path286$1, _path287$1, _path288$1, _path289$1, _path290$1, _circle13$1, _path291$1, _circle14$1, _path292$1, _circle15$1, _path293$1, _circle16$1, _path294$1, _path295$1, _path296$1, _path297$1, _path298$1, _path299$1, _path300$1, _path301$1, _path302$1, _path303$1, _path304$1, _path305$1, _path306$1, _path307$1, _path308$1, _path309$1, _path310$1, _path311$1, _path312$1, _path313$1, _path314$1, _path315$1, _path316$1, _path317$1, _path318$1, _path319$1, _path320$1, _path321$1, _path322$1, _path323$1, _path324$1, _path325$1, _path326$1, _path327$1, _path328$1, _path329$1, _path330$1, _path331$1, _path332$1, _path333$1, _path334$1, _circle17$1, _path335$1, _path336$1, _circle18$1, _path337$1, _path338$1, _circle19$1, _path339$1, _path340$1, _circle20$1, _path341$1, _path342$1, _path343$1, _path344$1, _path345$1, _path346$1, _path347$1, _path348$1, _path349$1, _path350$1, _path351$1, _path352$1, _path353$1, _path354$1, _path355$1, _path356$1, _path357$1, _path358$1, _path359$1, _path360$1, _path361$1, _path362$1, _path363$1, _path364$1, _path365$1, _path366$1, _path367$1, _path368$1, _path369$1, _path370$1, _path371$1, _path372$1, _path373$1, _path374$1, _circle21$1, _path375$1, _circle22$1, _path376$1, _circle23$1, _path377$1, _circle24$1, _path378$1, _path379$1, _path380$1, _path381$1, _path382$1, _path383$1, _circle25, _path384$1, _circle26, _path385$1, _circle27, _path386$1, _circle28, _circle29, _path387$1, _circle30, _path388$1, _path389$1, _circle31, _path390$1, _circle32, _path391$1, _path392$1, _circle33, _path393$1, _circle34, _path394$1, _path395$1, _circle35, _path396$1, _circle36, _path397$1, _path398$1;

  var _excluded$2 = ["children"],
      _excluded2$2 = ["children"],
      _excluded3$2 = ["children"],
      _excluded4$2 = ["children"],
      _excluded5$2 = ["children"],
      _excluded6$2 = ["children"],
      _excluded7$2 = ["children"],
      _excluded8$2 = ["children"],
      _excluded9$2 = ["children"],
      _excluded10$2 = ["children"],
      _excluded11$2 = ["children"],
      _excluded12$2 = ["children"],
      _excluded13$2 = ["children"],
      _excluded14$2 = ["children"],
      _excluded15$2 = ["children"],
      _excluded16$2 = ["children"],
      _excluded17$2 = ["children"],
      _excluded18$2 = ["children"],
      _excluded19$2 = ["children"],
      _excluded20$2 = ["children"],
      _excluded21$2 = ["children"],
      _excluded22$2 = ["children"],
      _excluded23$2 = ["children"],
      _excluded24$2 = ["children"],
      _excluded25$2 = ["children"],
      _excluded26$2 = ["children"],
      _excluded27$2 = ["children"],
      _excluded28$2 = ["children"],
      _excluded29$2 = ["children"],
      _excluded30$2 = ["children"],
      _excluded31$2 = ["children"],
      _excluded32$2 = ["children"],
      _excluded33$2 = ["children"],
      _excluded34$2 = ["children"],
      _excluded35$2 = ["children"],
      _excluded36$2 = ["children"],
      _excluded37$2 = ["children"],
      _excluded38$2 = ["children"],
      _excluded39$2 = ["children"],
      _excluded40$2 = ["children"],
      _excluded41$2 = ["children"],
      _excluded42$2 = ["children"],
      _excluded43$2 = ["children"],
      _excluded44$2 = ["children"],
      _excluded45$2 = ["children"],
      _excluded46$2 = ["children"],
      _excluded47$2 = ["children"],
      _excluded48$2 = ["children"],
      _excluded49$2 = ["children"],
      _excluded50$2 = ["children"],
      _excluded51$2 = ["children"],
      _excluded52$2 = ["children"],
      _excluded53$2 = ["children"],
      _excluded54$2 = ["children"],
      _excluded55$2 = ["children"],
      _excluded56$2 = ["children"],
      _excluded57$2 = ["children"],
      _excluded58$2 = ["children"],
      _excluded59$2 = ["children"],
      _excluded60$2 = ["children"],
      _excluded61$2 = ["children"],
      _excluded62$2 = ["children"],
      _excluded63$2 = ["children"],
      _excluded64$2 = ["children"],
      _excluded65$2 = ["children"],
      _excluded66$2 = ["children"],
      _excluded67$2 = ["children"],
      _excluded68$2 = ["children"],
      _excluded69$2 = ["children"],
      _excluded70$2 = ["children"],
      _excluded71$2 = ["children"],
      _excluded72$2 = ["children"],
      _excluded73$2 = ["children"],
      _excluded74$2 = ["children"],
      _excluded75$2 = ["children"],
      _excluded76$2 = ["children"],
      _excluded77$2 = ["children"],
      _excluded78$2 = ["children"],
      _excluded79$2 = ["children"],
      _excluded80$2 = ["children"],
      _excluded81$2 = ["children"],
      _excluded82$2 = ["children"],
      _excluded83$2 = ["children"],
      _excluded84$2 = ["children"],
      _excluded85$2 = ["children"],
      _excluded86$2 = ["children"],
      _excluded87$2 = ["children"],
      _excluded88$2 = ["children"],
      _excluded89$2 = ["children"],
      _excluded90$2 = ["children"],
      _excluded91$2 = ["children"],
      _excluded92$2 = ["children"],
      _excluded93$2 = ["children"],
      _excluded94$2 = ["children"],
      _excluded95$2 = ["children"],
      _excluded96$2 = ["children"],
      _excluded97$2 = ["children"],
      _excluded98$2 = ["children"],
      _excluded99$2 = ["children"],
      _excluded100$2 = ["children"],
      _excluded101$2 = ["children"],
      _excluded102$2 = ["children"],
      _excluded103$2 = ["children"],
      _excluded104$2 = ["children"],
      _excluded105$2 = ["children"],
      _excluded106$2 = ["children"],
      _excluded107$2 = ["children"],
      _excluded108$2 = ["children"],
      _excluded109$2 = ["children"],
      _excluded110$2 = ["children"],
      _excluded111$2 = ["children"],
      _excluded112$2 = ["children"],
      _excluded113$2 = ["children"],
      _excluded114$2 = ["children"],
      _excluded115$2 = ["children"],
      _excluded116$2 = ["children"],
      _excluded117$2 = ["children"],
      _excluded118$2 = ["children"],
      _excluded119$1 = ["children"],
      _excluded120$1 = ["children"],
      _excluded121$1 = ["children"],
      _excluded122$1 = ["children"],
      _excluded123$1 = ["children"],
      _excluded124$1 = ["children"],
      _excluded125$1 = ["children"],
      _excluded126$1 = ["children"],
      _excluded127$1 = ["children"],
      _excluded128$1 = ["children"],
      _excluded129$1 = ["children"],
      _excluded130$1 = ["children"],
      _excluded131$1 = ["children"],
      _excluded132$1 = ["children"],
      _excluded133$1 = ["children"],
      _excluded134$1 = ["children"],
      _excluded135$1 = ["children"],
      _excluded136$1 = ["children"],
      _excluded137$1 = ["children"],
      _excluded138$1 = ["children"],
      _excluded139$1 = ["children"],
      _excluded140$1 = ["children"],
      _excluded141$1 = ["children"],
      _excluded142$1 = ["children"],
      _excluded143$1 = ["children"],
      _excluded144$1 = ["children"],
      _excluded145$1 = ["children"],
      _excluded146$1 = ["children"],
      _excluded147$1 = ["children"],
      _excluded148$1 = ["children"],
      _excluded149$1 = ["children"],
      _excluded150$1 = ["children"],
      _excluded151$1 = ["children"],
      _excluded152$1 = ["children"],
      _excluded153$1 = ["children"],
      _excluded154$1 = ["children"],
      _excluded155$1 = ["children"],
      _excluded156$1 = ["children"],
      _excluded157$1 = ["children"],
      _excluded158$1 = ["children"],
      _excluded159$1 = ["children"],
      _excluded160$1 = ["children"],
      _excluded161$1 = ["children"],
      _excluded162$1 = ["children"],
      _excluded163$1 = ["children"],
      _excluded164$1 = ["children"],
      _excluded165$1 = ["children"],
      _excluded166$1 = ["children"],
      _excluded167$1 = ["children"],
      _excluded168$1 = ["children"],
      _excluded169$1 = ["children"],
      _excluded170$1 = ["children"],
      _excluded171$1 = ["children"],
      _excluded172$1 = ["children"],
      _excluded173$1 = ["children"],
      _excluded174$1 = ["children"],
      _excluded175$1 = ["children"],
      _excluded176$1 = ["children"],
      _excluded177$1 = ["children"],
      _excluded178$1 = ["children"],
      _excluded179$1 = ["children"],
      _excluded180$1 = ["children"],
      _excluded181$1 = ["children"],
      _excluded182$1 = ["children"],
      _excluded183$1 = ["children"],
      _excluded184$1 = ["children"],
      _excluded185$1 = ["children"],
      _excluded186$1 = ["children"],
      _excluded187$1 = ["children"],
      _excluded188$1 = ["children"],
      _excluded189$1 = ["children"],
      _excluded190$1 = ["children"],
      _excluded191$1 = ["children"],
      _excluded192$1 = ["children"],
      _excluded193$1 = ["children"],
      _excluded194$1 = ["children"],
      _excluded195$1 = ["children"],
      _excluded196$1 = ["children"],
      _excluded197$1 = ["children"],
      _excluded198$1 = ["children"],
      _excluded199$1 = ["children"],
      _excluded200$1 = ["children"],
      _excluded201$1 = ["children"],
      _excluded202$1 = ["children"],
      _excluded203$1 = ["children"],
      _excluded204$1 = ["children"],
      _excluded205$1 = ["children"],
      _excluded206$1 = ["children"],
      _excluded207$1 = ["children"],
      _excluded208$1 = ["children"],
      _excluded209$1 = ["children"],
      _excluded210$1 = ["children"],
      _excluded211$1 = ["children"],
      _excluded212$1 = ["children"],
      _excluded213$1 = ["children"],
      _excluded214$1 = ["children"],
      _excluded215$1 = ["children"],
      _excluded216$1 = ["children"],
      _excluded217$1 = ["children"],
      _excluded218$1 = ["children"],
      _excluded219$1 = ["children"],
      _excluded220$1 = ["children"],
      _excluded221$1 = ["children"],
      _excluded222$1 = ["children"],
      _excluded223$1 = ["children"],
      _excluded224$1 = ["children"],
      _excluded225$1 = ["children"],
      _excluded226$1 = ["children"],
      _excluded227$1 = ["children"],
      _excluded228$1 = ["children"],
      _excluded229$1 = ["children"],
      _excluded230$1 = ["children"],
      _excluded231$1 = ["children"],
      _excluded232$1 = ["children"],
      _excluded233$1 = ["children"],
      _excluded234$1 = ["children"],
      _excluded235$1 = ["children"],
      _excluded236$1 = ["children"],
      _excluded237$1 = ["children"],
      _excluded238$1 = ["children"],
      _excluded239$1 = ["children"],
      _excluded240$1 = ["children"],
      _excluded241$1 = ["children"],
      _excluded242$1 = ["children"],
      _excluded243$1 = ["children"],
      _excluded244$1 = ["children"],
      _excluded245$1 = ["children"],
      _excluded246$1 = ["children"],
      _excluded247$1 = ["children"],
      _excluded248$1 = ["children"],
      _excluded249$1 = ["children"],
      _excluded250$1 = ["children"];
  var Upload20 = /*#__PURE__*/React__default['default'].forwardRef(function Upload20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$2 || (_path$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 18L7.41 19.41 15 11.83 15 30 17 30 17 11.83 24.59 19.41 26 18 16 8 6 18zM6 8V4H26V8h2V4a2 2 0 00-2-2H6A2 2 0 004 4V8z"
    })), children);
  });
  var Upload16 = /*#__PURE__*/React__default['default'].forwardRef(function Upload16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path2$2 || (_path2$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M3 9L3.7 9.7 7.5 5.9 7.5 15 8.5 15 8.5 5.9 12.3 9.7 13 9 8 4zM3 4V2h10v2h1V2c0-.6-.4-1-1-1H3C2.4 1 2 1.4 2 2v2H3z"
    })), children);
  });
  var Usb32 = /*#__PURE__*/React__default['default'].forwardRef(function Usb32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3$2 || (_path3$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"
    })), _path4$2 || (_path4$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H15V12H12zM17 10H20V12H17z"
    })), children);
  });
  var Usb24 = /*#__PURE__*/React__default['default'].forwardRef(function Usb24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5$2 || (_path5$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"
    })), _path6$2 || (_path6$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H15V12H12zM17 10H20V12H17z"
    })), children);
  });
  var Usb20 = /*#__PURE__*/React__default['default'].forwardRef(function Usb20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$2 || (_path7$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"
    })), _path8$2 || (_path8$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H15V12H12zM17 10H20V12H17z"
    })), children);
  });
  var Usb16 = /*#__PURE__*/React__default['default'].forwardRef(function Usb16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path9$2 || (_path9$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"
    })), _path10$2 || (_path10$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 10H15V12H12zM17 10H20V12H17z"
    })), children);
  });
  var User32 = /*#__PURE__*/React__default['default'].forwardRef(function User32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11$2 || (_path11$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2zM26 30H24V25a5 5 0 00-5-5H13a5 5 0 00-5 5v5H6V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var User24 = /*#__PURE__*/React__default['default'].forwardRef(function User24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path12$2 || (_path12$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2zM26 30H24V25a5 5 0 00-5-5H13a5 5 0 00-5 5v5H6V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var User20 = /*#__PURE__*/React__default['default'].forwardRef(function User20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$2 || (_path13$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2zM26 30H24V25a5 5 0 00-5-5H13a5 5 0 00-5 5v5H6V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var User16 = /*#__PURE__*/React__default['default'].forwardRef(function User16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$2 || (_path14$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 2c1.4 0 2.5 1.1 2.5 2.5S9.4 7 8 7 5.5 5.9 5.5 4.5 6.6 2 8 2M8 1C6.1 1 4.5 2.6 4.5 4.5S6.1 8 8 8s3.5-1.6 3.5-3.5S9.9 1 8 1zM13 15h-1v-2.5c0-1.4-1.1-2.5-2.5-2.5h-3C5.1 10 4 11.1 4 12.5V15H3v-2.5C3 10.6 4.6 9 6.5 9h3c1.9 0 3.5 1.6 3.5 3.5V15z"
    })), children);
  });
  var UserAccess32 = /*#__PURE__*/React__default['default'].forwardRef(function UserAccess32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$2 || (_path15$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8zM30 12a1.9922 1.9922 0 00-.5117.0742L28.4331 11.019a3.8788 3.8788 0 000-4.038l1.0552-1.0552a2.0339 2.0339 0 10-1.4141-1.4141L27.019 5.5669a3.8788 3.8788 0 00-4.038 0L21.9258 4.5117a2.0339 2.0339 0 10-1.4141 1.4141L21.5669 6.981a3.8788 3.8788 0 000 4.038l-1.0552 1.0552a2.0339 2.0339 0 101.4141 1.4141l1.0552-1.0552a3.8788 3.8788 0 004.038 0l1.0552 1.0552A1.9957 1.9957 0 1030 12zM23 9a2 2 0 112 2A2.0025 2.0025 0 0123 9z"
    })), children);
  });
  var UserAccess24 = /*#__PURE__*/React__default['default'].forwardRef(function UserAccess24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$2 || (_path16$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8zM30 12a1.9922 1.9922 0 00-.5117.0742L28.4331 11.019a3.8788 3.8788 0 000-4.038l1.0552-1.0552a2.0339 2.0339 0 10-1.4141-1.4141L27.019 5.5669a3.8788 3.8788 0 00-4.038 0L21.9258 4.5117a2.0339 2.0339 0 10-1.4141 1.4141L21.5669 6.981a3.8788 3.8788 0 000 4.038l-1.0552 1.0552a2.0339 2.0339 0 101.4141 1.4141l1.0552-1.0552a3.8788 3.8788 0 004.038 0l1.0552 1.0552A1.9957 1.9957 0 1030 12zM23 9a2 2 0 112 2A2.0025 2.0025 0 0123 9z"
    })), children);
  });
  var UserAccess20 = /*#__PURE__*/React__default['default'].forwardRef(function UserAccess20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$2 || (_path17$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8zM30 12a1.9922 1.9922 0 00-.5117.0742L28.4331 11.019a3.8788 3.8788 0 000-4.038l1.0552-1.0552a2.0339 2.0339 0 10-1.4141-1.4141L27.019 5.5669a3.8788 3.8788 0 00-4.038 0L21.9258 4.5117a2.0339 2.0339 0 10-1.4141 1.4141L21.5669 6.981a3.8788 3.8788 0 000 4.038l-1.0552 1.0552a2.0339 2.0339 0 101.4141 1.4141l1.0552-1.0552a3.8788 3.8788 0 004.038 0l1.0552 1.0552A1.9957 1.9957 0 1030 12zM23 9a2 2 0 112 2A2.0025 2.0025 0 0123 9z"
    })), children);
  });
  var UserAccess16 = /*#__PURE__*/React__default['default'].forwardRef(function UserAccess16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path18$2 || (_path18$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8zM30 12a1.9922 1.9922 0 00-.5117.0742L28.4331 11.019a3.8788 3.8788 0 000-4.038l1.0552-1.0552a2.0339 2.0339 0 10-1.4141-1.4141L27.019 5.5669a3.8788 3.8788 0 00-4.038 0L21.9258 4.5117a2.0339 2.0339 0 10-1.4141 1.4141L21.5669 6.981a3.8788 3.8788 0 000 4.038l-1.0552 1.0552a2.0339 2.0339 0 101.4141 1.4141l1.0552-1.0552a3.8788 3.8788 0 004.038 0l1.0552 1.0552A1.9957 1.9957 0 1030 12zM23 9a2 2 0 112 2A2.0025 2.0025 0 0123 9z"
    })), children);
  });
  var UserActivity32 = /*#__PURE__*/React__default['default'].forwardRef(function UserActivity32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$2 || (_path19$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23h-.0215a1.0016 1.0016 0 01-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0118 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 011.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0128 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0125 23zM15 30H13V23a3.0033 3.0033 0 00-3-3H6a3.0033 3.0033 0 00-3 3v7H1V23a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM8 8a3 3 0 11-3 3A3 3 0 018 8M8 6a5 5 0 105 5A5 5 0 008 6z"
    })), children);
  });
  var UserActivity24 = /*#__PURE__*/React__default['default'].forwardRef(function UserActivity24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path20$2 || (_path20$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23h-.0215a1.0016 1.0016 0 01-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0118 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 011.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0128 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0125 23zM15 30H13V23a3.0033 3.0033 0 00-3-3H6a3.0033 3.0033 0 00-3 3v7H1V23a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM8 8a3 3 0 11-3 3A3 3 0 018 8M8 6a5 5 0 105 5A5 5 0 008 6z"
    })), children);
  });
  var UserActivity20 = /*#__PURE__*/React__default['default'].forwardRef(function UserActivity20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$2 || (_path21$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23h-.0215a1.0016 1.0016 0 01-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0118 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 011.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0128 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0125 23zM15 30H13V23a3.0033 3.0033 0 00-3-3H6a3.0033 3.0033 0 00-3 3v7H1V23a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM8 8a3 3 0 11-3 3A3 3 0 018 8M8 6a5 5 0 105 5A5 5 0 008 6z"
    })), children);
  });
  var UserActivity16 = /*#__PURE__*/React__default['default'].forwardRef(function UserActivity16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path22$2 || (_path22$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 23h-.0215a1.0016 1.0016 0 01-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0118 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 011.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0128 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0125 23zM15 30H13V23a3.0033 3.0033 0 00-3-3H6a3.0033 3.0033 0 00-3 3v7H1V23a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM8 8a3 3 0 11-3 3A3 3 0 018 8M8 6a5 5 0 105 5A5 5 0 008 6z"
    })), children);
  });
  var UserAdmin32 = /*#__PURE__*/React__default['default'].forwardRef(function UserAdmin32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$2 || (_path23$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"
    })), children);
  });
  var UserAdmin24 = /*#__PURE__*/React__default['default'].forwardRef(function UserAdmin24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path24$2 || (_path24$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"
    })), children);
  });
  var UserAdmin20 = /*#__PURE__*/React__default['default'].forwardRef(function UserAdmin20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$2 || (_path25$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"
    })), children);
  });
  var UserAdmin16 = /*#__PURE__*/React__default['default'].forwardRef(function UserAdmin16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$2 || (_path26$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"
    })), children);
  });
  var UserAvatar32 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatar32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$2 || (_path27$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Zm0,8a3,3,0,1,1,3-3A3.0034,3.0034,0,0,1,16,16Z"
    })), _path28$2 || (_path28$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM10,26.3765V25a3.0033,3.0033,0,0,1,3-3h6a3.0033,3.0033,0,0,1,3,3v1.3765a11.8989,11.8989,0,0,1-12,0Zm13.9925-1.4507A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserAvatar24 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatar24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$2 || (_path29$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Zm0,8a3,3,0,1,1,3-3A3.0034,3.0034,0,0,1,16,16Z"
    })), _path30$2 || (_path30$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM10,26.3765V25a3.0033,3.0033,0,0,1,3-3h6a3.0033,3.0033,0,0,1,3,3v1.3765a11.8989,11.8989,0,0,1-12,0Zm13.9925-1.4507A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserAvatar20 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatar20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$2 || (_path31$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Zm0,8a3,3,0,1,1,3-3A3.0034,3.0034,0,0,1,16,16Z"
    })), _path32$2 || (_path32$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM10,26.3765V25a3.0033,3.0033,0,0,1,3-3h6a3.0033,3.0033,0,0,1,3,3v1.3765a11.8989,11.8989,0,0,1-12,0Zm13.9925-1.4507A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserAvatar16 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatar16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$2 || (_path33$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M5,13.2v-1.5c0-0.9,0.6-1.6,1.5-1.7h3c0.9,0.1,1.5,0.8,1.5,1.7v1.5\tC9.1,14.3,6.9,14.3,5,13.2L5,13.2z M12,12l0-0.8c0-0.9-1.1-2.1-2.5-2.2h-3C5.1,9.1,4,10.3,4,11.7l0,0.5v0.3c-2.5-2.2-2.7-6-0.5-8.5\ts6-2.7,8.5-0.5s2.7,6,0.5,8.5c-0.1,0.2-0.3,0.3-0.5,0.5V12z"
    })), _path34$2 || (_path34$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,3C6.6,3,5.5,4.1,5.5,5.5S6.6,8,8,8s2.5-1.1,2.5-2.5S9.4,3,8,3z M8,7C7.2,7,6.5,6.3,6.5,5.5S7.2,4,8,4s1.5,0.7,1.5,1.5\tS8.8,7,8,7z"
    })), children);
  });
  var UserAvatarFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilled32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$2 || (_path35$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8.0071,24.93A4.9958,4.9958,0,0,1,13,20h6a4.9959,4.9959,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0ZM20.5,12.5A4.5,4.5,0,1,1,16,8,4.5,4.5,0,0,1,20.5,12.5Z"
    })), _path36$2 || (_path36$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.7489,24.93A13.9893,13.9893,0,1,0,2,16a13.899,13.899,0,0,0,3.2511,8.93l-.02.0166c.07.0845.15.1567.2222.2392.09.1036.1864.2.28.3008.28.3033.5674.5952.87.87.0915.0831.1864.1612.28.2417.32.2759.6484.5372.99.7813.0441.0312.0832.0693.1276.1006v-.0127a13.9011,13.9011,0,0,0,16,0V27.48c.0444-.0313.0835-.0694.1276-.1006.3412-.2441.67-.5054.99-.7813.0936-.08.1885-.1586.28-.2417.3025-.2749.59-.5668.87-.87.0933-.1006.1894-.1972.28-.3008.0719-.0825.1522-.1547.2222-.2392ZM16,8a4.5,4.5,0,1,1-4.5,4.5A4.5,4.5,0,0,1,16,8ZM8.0071,24.93A4.9957,4.9957,0,0,1,13,20h6a4.9958,4.9958,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0Z"
    })), children);
  });
  var UserAvatarFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilled24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$2 || (_path37$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8.0071,24.93A4.9958,4.9958,0,0,1,13,20h6a4.9959,4.9959,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0ZM20.5,12.5A4.5,4.5,0,1,1,16,8,4.5,4.5,0,0,1,20.5,12.5Z"
    })), _path38$2 || (_path38$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.7489,24.93A13.9893,13.9893,0,1,0,2,16a13.899,13.899,0,0,0,3.2511,8.93l-.02.0166c.07.0845.15.1567.2222.2392.09.1036.1864.2.28.3008.28.3033.5674.5952.87.87.0915.0831.1864.1612.28.2417.32.2759.6484.5372.99.7813.0441.0312.0832.0693.1276.1006v-.0127a13.9011,13.9011,0,0,0,16,0V27.48c.0444-.0313.0835-.0694.1276-.1006.3412-.2441.67-.5054.99-.7813.0936-.08.1885-.1586.28-.2417.3025-.2749.59-.5668.87-.87.0933-.1006.1894-.1972.28-.3008.0719-.0825.1522-.1547.2222-.2392ZM16,8a4.5,4.5,0,1,1-4.5,4.5A4.5,4.5,0,0,1,16,8ZM8.0071,24.93A4.9957,4.9957,0,0,1,13,20h6a4.9958,4.9958,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0Z"
    })), children);
  });
  var UserAvatarFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilled20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$2 || (_path39$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8.0071,24.93A4.9958,4.9958,0,0,1,13,20h6a4.9959,4.9959,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0ZM20.5,12.5A4.5,4.5,0,1,1,16,8,4.5,4.5,0,0,1,20.5,12.5Z"
    })), _path40$2 || (_path40$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.7489,24.93A13.9893,13.9893,0,1,0,2,16a13.899,13.899,0,0,0,3.2511,8.93l-.02.0166c.07.0845.15.1567.2222.2392.09.1036.1864.2.28.3008.28.3033.5674.5952.87.87.0915.0831.1864.1612.28.2417.32.2759.6484.5372.99.7813.0441.0312.0832.0693.1276.1006v-.0127a13.9011,13.9011,0,0,0,16,0V27.48c.0444-.0313.0835-.0694.1276-.1006.3412-.2441.67-.5054.99-.7813.0936-.08.1885-.1586.28-.2417.3025-.2749.59-.5668.87-.87.0933-.1006.1894-.1972.28-.3008.0719-.0825.1522-.1547.2222-.2392ZM16,8a4.5,4.5,0,1,1-4.5,4.5A4.5,4.5,0,0,1,16,8ZM8.0071,24.93A4.9957,4.9957,0,0,1,13,20h6a4.9958,4.9958,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0Z"
    })), children);
  });
  var UserAvatarFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilled16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$2 || (_path41$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M8.0071,24.93A4.9958,4.9958,0,0,1,13,20h6a4.9959,4.9959,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0ZM20.5,12.5A4.5,4.5,0,1,1,16,8,4.5,4.5,0,0,1,20.5,12.5Z"
    })), _path42$2 || (_path42$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.7489,24.93A13.9893,13.9893,0,1,0,2,16a13.899,13.899,0,0,0,3.2511,8.93l-.02.0166c.07.0845.15.1567.2222.2392.09.1036.1864.2.28.3008.28.3033.5674.5952.87.87.0915.0831.1864.1612.28.2417.32.2759.6484.5372.99.7813.0441.0312.0832.0693.1276.1006v-.0127a13.9011,13.9011,0,0,0,16,0V27.48c.0444-.0313.0835-.0694.1276-.1006.3412-.2441.67-.5054.99-.7813.0936-.08.1885-.1586.28-.2417.3025-.2749.59-.5668.87-.87.0933-.1006.1894-.1972.28-.3008.0719-.0825.1522-.1547.2222-.2392ZM16,8a4.5,4.5,0,1,1-4.5,4.5A4.5,4.5,0,0,1,16,8ZM8.0071,24.93A4.9957,4.9957,0,0,1,13,20h6a4.9958,4.9958,0,0,1,4.9929,4.93,11.94,11.94,0,0,1-15.9858,0Z"
    })), children);
  });
  var UserAvatarFilledAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilledAlt32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$2 || (_path43$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"
    })), _path44$2 || (_path44$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm7.9925,22.9258A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserAvatarFilledAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilledAlt24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$2 || (_path45$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"
    })), _path46$2 || (_path46$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm7.9925,22.9258A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserAvatarFilledAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilledAlt20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$2 || (_path47$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"
    })), _path48$2 || (_path48$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm7.9925,22.9258A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserAvatarFilledAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function UserAvatarFilledAlt16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$2 || (_path49$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"
    })), _path50$2 || (_path50$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm7.9925,22.9258A5.0016,5.0016,0,0,0,19,20H13a5.0016,5.0016,0,0,0-4.9925,4.9258,12,12,0,1,1,15.985,0Z"
    })), children);
  });
  var UserCertification32 = /*#__PURE__*/React__default['default'].forwardRef(function UserCertification32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$2 || (_path51$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserCertification24 = /*#__PURE__*/React__default['default'].forwardRef(function UserCertification24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$2 || (_path52$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserCertification20 = /*#__PURE__*/React__default['default'].forwardRef(function UserCertification20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$2 || (_path53$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserCertification16 = /*#__PURE__*/React__default['default'].forwardRef(function UserCertification16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$2 || (_path54$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserData32 = /*#__PURE__*/React__default['default'].forwardRef(function UserData32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$2 || (_path55$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v6H2V24a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 9a3 3 0 11-3 3A3 3 0 019 9M9 7a5 5 0 105 5A5 5 0 009 7z"
    })), children);
  });
  var UserData24 = /*#__PURE__*/React__default['default'].forwardRef(function UserData24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$2 || (_path56$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v6H2V24a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 9a3 3 0 11-3 3A3 3 0 019 9M9 7a5 5 0 105 5A5 5 0 009 7z"
    })), children);
  });
  var UserData20 = /*#__PURE__*/React__default['default'].forwardRef(function UserData20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$2 || (_path57$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v6H2V24a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 9a3 3 0 11-3 3A3 3 0 019 9M9 7a5 5 0 105 5A5 5 0 009 7z"
    })), children);
  });
  var UserData16 = /*#__PURE__*/React__default['default'].forwardRef(function UserData16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path58$2 || (_path58$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v6H2V24a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 9a3 3 0 11-3 3A3 3 0 019 9M9 7a5 5 0 105 5A5 5 0 009 7z"
    })), children);
  });
  var UserFavorite32 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavorite32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$2 || (_path59$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 12a2.6616 2.6616 0 00-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 12zM2 30H4V25a5.0059 5.0059 0 015-5h6a5.0059 5.0059 0 015 5v5h2V25a7.0082 7.0082 0 00-7-7H9a7.0082 7.0082 0 00-7 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserFavorite24 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavorite24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60$2 || (_path60$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 12a2.6616 2.6616 0 00-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 12zM2 30H4V25a5.0059 5.0059 0 015-5h6a5.0059 5.0059 0 015 5v5h2V25a7.0082 7.0082 0 00-7-7H9a7.0082 7.0082 0 00-7 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserFavorite20 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavorite20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$2 || (_path61$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 12a2.6616 2.6616 0 00-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 12zM2 30H4V25a5.0059 5.0059 0 015-5h6a5.0059 5.0059 0 015 5v5h2V25a7.0082 7.0082 0 00-7-7H9a7.0082 7.0082 0 00-7 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserFavorite16 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavorite16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path62$2 || (_path62$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.303 12a2.6616 2.6616 0 00-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 00-3.8157 0 2.7992 2.7992 0 000 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 000-3.8964A2.6616 2.6616 0 0027.303 12zM2 30H4V25a5.0059 5.0059 0 015-5h6a5.0059 5.0059 0 015 5v5h2V25a7.0082 7.0082 0 00-7-7H9a7.0082 7.0082 0 00-7 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserFavoriteAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAlt32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$2 || (_path63$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAlt24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path64$2 || (_path64$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAlt20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$2 || (_path65$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAlt16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66$2 || (_path66$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.7663 4.2558A4.2121 4.2121 0 0023 4.0321a4.2121 4.2121 0 00-5.7663.2237 4.319 4.319 0 000 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0028.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 010-3.2338 2.2639 2.2639 0 013.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 013.1561 0A2.3085 2.3085 0 0127.342 8.8948zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAltFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAltFilled32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$2 || (_path67$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4938 3a3.4735 3.4735 0 00-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 00-4.96 0 3.59 3.59 0 000 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 000-5.0251A3.4738 3.4738 0 0026.4938 3zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAltFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAltFilled24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path68$2 || (_path68$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4938 3a3.4735 3.4735 0 00-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 00-4.96 0 3.59 3.59 0 000 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 000-5.0251A3.4738 3.4738 0 0026.4938 3zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAltFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAltFilled20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$2 || (_path69$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4938 3a3.4735 3.4735 0 00-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 00-4.96 0 3.59 3.59 0 000 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 000-5.0251A3.4738 3.4738 0 0026.4938 3zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFavoriteAltFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function UserFavoriteAltFilled16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70$2 || (_path70$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.4938 3a3.4735 3.4735 0 00-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 00-4.96 0 3.59 3.59 0 000 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 000-5.0251A3.4738 3.4738 0 0026.4938 3zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function UserFilled32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$2 || (_path71$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 30H26V25a7.0082 7.0082 0 00-7-7H13a7.0082 7.0082 0 00-7 7zM9 9a7 7 0 107-7A7 7 0 009 9z"
    })), children);
  });
  var UserFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function UserFilled24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72$2 || (_path72$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 30H26V25a7.0082 7.0082 0 00-7-7H13a7.0082 7.0082 0 00-7 7zM9 9a7 7 0 107-7A7 7 0 009 9z"
    })), children);
  });
  var UserFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function UserFilled20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$2 || (_path73$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 30H26V25a7.0082 7.0082 0 00-7-7H13a7.0082 7.0082 0 00-7 7zM9 9a7 7 0 107-7A7 7 0 009 9z"
    })), children);
  });
  var UserFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function UserFilled16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$2 || (_path74$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 30H26V25a7.0082 7.0082 0 00-7-7H13a7.0082 7.0082 0 00-7 7zM9 9a7 7 0 107-7A7 7 0 009 9z"
    })), children);
  });
  var UserFollow32 = /*#__PURE__*/React__default['default'].forwardRef(function UserFollow32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$2 || (_path75$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var UserFollow24 = /*#__PURE__*/React__default['default'].forwardRef(function UserFollow24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$2 || (_path76$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var UserFollow20 = /*#__PURE__*/React__default['default'].forwardRef(function UserFollow20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$2 || (_path77$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var UserFollow16 = /*#__PURE__*/React__default['default'].forwardRef(function UserFollow16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path78$2 || (_path78$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7z"
    })), children);
  });
  var UserIdentification32 = /*#__PURE__*/React__default['default'].forwardRef(function UserIdentification32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$2 || (_path79$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"
    })), _circle$1 || (_circle$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "8",
      r: "2"
    })), _path80$2 || (_path80$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18H18a2.0023 2.0023 0 01-2-2V4a2.002 2.002 0 012-2H30a2.0023 2.0023 0 012 2V16A2.0027 2.0027 0 0130 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserIdentification24 = /*#__PURE__*/React__default['default'].forwardRef(function UserIdentification24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$2 || (_path81$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"
    })), _circle2$1 || (_circle2$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "8",
      r: "2"
    })), _path82$2 || (_path82$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18H18a2.0023 2.0023 0 01-2-2V4a2.002 2.002 0 012-2H30a2.0023 2.0023 0 012 2V16A2.0027 2.0027 0 0130 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserIdentification20 = /*#__PURE__*/React__default['default'].forwardRef(function UserIdentification20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$2 || (_path83$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"
    })), _circle3$1 || (_circle3$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "8",
      r: "2"
    })), _path84$2 || (_path84$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18H18a2.0023 2.0023 0 01-2-2V4a2.002 2.002 0 012-2H30a2.0023 2.0023 0 012 2V16A2.0027 2.0027 0 0130 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserIdentification16 = /*#__PURE__*/React__default['default'].forwardRef(function UserIdentification16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$2 || (_path85$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"
    })), _circle4$1 || (_circle4$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "8",
      r: "2"
    })), _path86$2 || (_path86$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 18H18a2.0023 2.0023 0 01-2-2V4a2.002 2.002 0 012-2H30a2.0023 2.0023 0 012 2V16A2.0027 2.0027 0 0130 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserMilitary32 = /*#__PURE__*/React__default['default'].forwardRef(function UserMilitary32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$2 || (_path87$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.407 16 20 16.414 22.5 18.667 22 22 25 20.125 28 22 27.5 18.667 30 16.414 26.5 16 25 13z"
    })), _path88$2 || (_path88$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 13.414L25 9.834 25 9.834 28.587 13.416 30 12 25 7 20 12 21.414 13.414z"
    })), _path89$2 || (_path89$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.414L25 4.834 25 4.834 28.587 8.416 30 7 25 2 20 7 21.414 8.414zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserMilitary24 = /*#__PURE__*/React__default['default'].forwardRef(function UserMilitary24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$2 || (_path90$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.407 16 20 16.414 22.5 18.667 22 22 25 20.125 28 22 27.5 18.667 30 16.414 26.5 16 25 13z"
    })), _path91$2 || (_path91$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 13.414L25 9.834 25 9.834 28.587 13.416 30 12 25 7 20 12 21.414 13.414z"
    })), _path92$2 || (_path92$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.414L25 4.834 25 4.834 28.587 8.416 30 7 25 2 20 7 21.414 8.414zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserMilitary20 = /*#__PURE__*/React__default['default'].forwardRef(function UserMilitary20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$2 || (_path93$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.407 16 20 16.414 22.5 18.667 22 22 25 20.125 28 22 27.5 18.667 30 16.414 26.5 16 25 13z"
    })), _path94$2 || (_path94$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 13.414L25 9.834 25 9.834 28.587 13.416 30 12 25 7 20 12 21.414 13.414z"
    })), _path95$2 || (_path95$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.414L25 4.834 25 4.834 28.587 8.416 30 7 25 2 20 7 21.414 8.414zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserMilitary16 = /*#__PURE__*/React__default['default'].forwardRef(function UserMilitary16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$2 || (_path96$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 13L23.407 16 20 16.414 22.5 18.667 22 22 25 20.125 28 22 27.5 18.667 30 16.414 26.5 16 25 13z"
    })), _path97$2 || (_path97$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 13.414L25 9.834 25 9.834 28.587 13.416 30 12 25 7 20 12 21.414 13.414z"
    })), _path98$2 || (_path98$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.414L25 4.834 25 4.834 28.587 8.416 30 7 25 2 20 7 21.414 8.414zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserMultiple32 = /*#__PURE__*/React__default['default'].forwardRef(function UserMultiple32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$2 || (_path99$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28V25a5.0057 5.0057 0 00-5-5V18a7.0078 7.0078 0 017 7zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM20 2V4a5 5 0 010 10v2A7 7 0 0020 2zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserMultiple24 = /*#__PURE__*/React__default['default'].forwardRef(function UserMultiple24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100$2 || (_path100$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28V25a5.0057 5.0057 0 00-5-5V18a7.0078 7.0078 0 017 7zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM20 2V4a5 5 0 010 10v2A7 7 0 0020 2zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserMultiple20 = /*#__PURE__*/React__default['default'].forwardRef(function UserMultiple20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$2 || (_path101$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28V25a5.0057 5.0057 0 00-5-5V18a7.0078 7.0078 0 017 7zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM20 2V4a5 5 0 010 10v2A7 7 0 0020 2zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserMultiple16 = /*#__PURE__*/React__default['default'].forwardRef(function UserMultiple16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102$2 || (_path102$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 30H28V25a5.0057 5.0057 0 00-5-5V18a7.0078 7.0078 0 017 7zM22 30H20V25a5.0059 5.0059 0 00-5-5H9a5.0059 5.0059 0 00-5 5v5H2V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM20 2V4a5 5 0 010 10v2A7 7 0 0020 2zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserOnline32 = /*#__PURE__*/React__default['default'].forwardRef(function UserOnline32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5$1 || (_circle5$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), _path103$2 || (_path103$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserOnline24 = /*#__PURE__*/React__default['default'].forwardRef(function UserOnline24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6$1 || (_circle6$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), _path104$2 || (_path104$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserOnline20 = /*#__PURE__*/React__default['default'].forwardRef(function UserOnline20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7$1 || (_circle7$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), _path105$2 || (_path105$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserOnline16 = /*#__PURE__*/React__default['default'].forwardRef(function UserOnline16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8$1 || (_circle8$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "26",
      cy: "16",
      r: "4"
    })), _path106$2 || (_path106$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserProfile32 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfile32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$2 || (_path107$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"
    })), children);
  });
  var UserProfile24 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfile24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108$2 || (_path108$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"
    })), children);
  });
  var UserProfile20 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfile20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$2 || (_path109$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"
    })), children);
  });
  var UserProfile16 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfile16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110$2 || (_path110$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"
    })), children);
  });
  var UserRole32 = /*#__PURE__*/React__default['default'].forwardRef(function UserRole32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$2 || (_path111$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserRole24 = /*#__PURE__*/React__default['default'].forwardRef(function UserRole24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112$2 || (_path112$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserRole20 = /*#__PURE__*/React__default['default'].forwardRef(function UserRole20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$2 || (_path113$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserRole16 = /*#__PURE__*/React__default['default'].forwardRef(function UserRole16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114$2 || (_path114$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 00-5-5H9a5 5 0 00-5 5v5H2V25a7 7 0 017-7h6a7 7 0 017 7zM12 4A5 5 0 117 9a5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0012 2z"
    })), children);
  });
  var UserServiceDesk32 = /*#__PURE__*/React__default['default'].forwardRef(function UserServiceDesk32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$2 || (_path115$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.334 11.95l1.2055-1.206a1.178 1.178 0 011.2593-.2584l1.4693.5868A1.1736 1.1736 0 0130 12.1489v2.692A1.1681 1.1681 0 0128.8229 16l-.05-.0015C18.4775 15.3578 16.4 6.6357 16.0073 3.2976a1.1681 1.1681 0 011.0315-1.29A1.1492 1.1492 0 0117.1751 2h2.5994a1.1626 1.1626 0 011.0764.7322l.5866 1.47a1.1635 1.1635 0 01-.2529 1.26L19.9791 6.668S20.6733 11.3682 25.334 11.95zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserServiceDesk24 = /*#__PURE__*/React__default['default'].forwardRef(function UserServiceDesk24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116$2 || (_path116$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.334 11.95l1.2055-1.206a1.178 1.178 0 011.2593-.2584l1.4693.5868A1.1736 1.1736 0 0130 12.1489v2.692A1.1681 1.1681 0 0128.8229 16l-.05-.0015C18.4775 15.3578 16.4 6.6357 16.0073 3.2976a1.1681 1.1681 0 011.0315-1.29A1.1492 1.1492 0 0117.1751 2h2.5994a1.1626 1.1626 0 011.0764.7322l.5866 1.47a1.1635 1.1635 0 01-.2529 1.26L19.9791 6.668S20.6733 11.3682 25.334 11.95zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserServiceDesk20 = /*#__PURE__*/React__default['default'].forwardRef(function UserServiceDesk20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$2 || (_path117$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.334 11.95l1.2055-1.206a1.178 1.178 0 011.2593-.2584l1.4693.5868A1.1736 1.1736 0 0130 12.1489v2.692A1.1681 1.1681 0 0128.8229 16l-.05-.0015C18.4775 15.3578 16.4 6.6357 16.0073 3.2976a1.1681 1.1681 0 011.0315-1.29A1.1492 1.1492 0 0117.1751 2h2.5994a1.1626 1.1626 0 011.0764.7322l.5866 1.47a1.1635 1.1635 0 01-.2529 1.26L19.9791 6.668S20.6733 11.3682 25.334 11.95zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserServiceDesk16 = /*#__PURE__*/React__default['default'].forwardRef(function UserServiceDesk16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118$2 || (_path118$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.334 11.95l1.2055-1.206a1.178 1.178 0 011.2593-.2584l1.4693.5868A1.1736 1.1736 0 0130 12.1489v2.692A1.1681 1.1681 0 0128.8229 16l-.05-.0015C18.4775 15.3578 16.4 6.6357 16.0073 3.2976a1.1681 1.1681 0 011.0315-1.29A1.1492 1.1492 0 0117.1751 2h2.5994a1.1626 1.1626 0 011.0764.7322l.5866 1.47a1.1635 1.1635 0 01-.2529 1.26L19.9791 6.668S20.6733 11.3682 25.334 11.95zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserSettings32 = /*#__PURE__*/React__default['default'].forwardRef(function UserSettings32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$2 || (_path119$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V8H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 4.1011V2H22V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 8H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 12zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserSettings24 = /*#__PURE__*/React__default['default'].forwardRef(function UserSettings24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120$2 || (_path120$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V8H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 4.1011V2H22V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 8H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 12zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserSettings20 = /*#__PURE__*/React__default['default'].forwardRef(function UserSettings20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$2 || (_path121$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V8H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 4.1011V2H22V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 8H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 12zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserSettings16 = /*#__PURE__*/React__default['default'].forwardRef(function UserSettings16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122$2 || (_path122$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 10V8H27.8989a4.9678 4.9678 0 00-.7319-1.7529l1.49-1.49-1.414-1.414-1.49 1.49A4.9678 4.9678 0 0024 4.1011V2H22V4.1011a4.9678 4.9678 0 00-1.7529.7319l-1.49-1.49-1.414 1.414 1.49 1.49A4.9678 4.9678 0 0018.1011 8H16v2h2.1011a4.9678 4.9678 0 00.7319 1.7529l-1.49 1.49 1.414 1.414 1.49-1.49A4.9678 4.9678 0 0022 13.8989V16h2V13.8989a4.9678 4.9678 0 001.7529-.7319l1.49 1.49 1.414-1.414-1.49-1.49A4.9678 4.9678 0 0027.8989 10zm-7 2a3 3 0 113-3A3.0033 3.0033 0 0123 12zM16 30H14V25a3.0033 3.0033 0 00-3-3H7a3.0033 3.0033 0 00-3 3v5H2V25a5.0059 5.0059 0 015-5h4a5.0059 5.0059 0 015 5zM9 10a3 3 0 11-3 3 3 3 0 013-3M9 8a5 5 0 105 5A5 5 0 009 8z"
    })), children);
  });
  var UserSimulation32 = /*#__PURE__*/React__default['default'].forwardRef(function UserSimulation32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$2 || (_path123$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 12.866H29.232V14.866H25.232z",
      transform: "rotate(30 27.232 13.866)"
    })), _path124$2 || (_path124$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8H30V10H26z"
    })), _path125$2 || (_path125$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 12.866H6.768V14.866H2.768z",
      transform: "rotate(150 4.768 13.866)"
    })), _path126$2 || (_path126$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V25a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v5H6V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2z"
    })), _path127$2 || (_path127$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 3.134H29.232V5.134H25.232z",
      transform: "rotate(-30 27.232 4.134)"
    })), _path128$2 || (_path128$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 8H6V10H2z"
    })), _path129$2 || (_path129$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 3.134H6.768V5.134H2.768z",
      transform: "rotate(-150 4.768 4.134)"
    })), children);
  });
  var UserSimulation24 = /*#__PURE__*/React__default['default'].forwardRef(function UserSimulation24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path130$2 || (_path130$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 12.866H29.232V14.866H25.232z",
      transform: "rotate(30 27.232 13.866)"
    })), _path131$2 || (_path131$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8H30V10H26z"
    })), _path132$2 || (_path132$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 12.866H6.768V14.866H2.768z",
      transform: "rotate(150 4.768 13.866)"
    })), _path133$2 || (_path133$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V25a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v5H6V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2z"
    })), _path134$2 || (_path134$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 3.134H29.232V5.134H25.232z",
      transform: "rotate(-30 27.232 4.134)"
    })), _path135$2 || (_path135$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 8H6V10H2z"
    })), _path136$2 || (_path136$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 3.134H6.768V5.134H2.768z",
      transform: "rotate(-150 4.768 4.134)"
    })), children);
  });
  var UserSimulation20 = /*#__PURE__*/React__default['default'].forwardRef(function UserSimulation20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137$2 || (_path137$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 12.866H29.232V14.866H25.232z",
      transform: "rotate(30 27.232 13.866)"
    })), _path138$2 || (_path138$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8H30V10H26z"
    })), _path139$2 || (_path139$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 12.866H6.768V14.866H2.768z",
      transform: "rotate(150 4.768 13.866)"
    })), _path140$2 || (_path140$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V25a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v5H6V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2z"
    })), _path141$2 || (_path141$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 3.134H29.232V5.134H25.232z",
      transform: "rotate(-30 27.232 4.134)"
    })), _path142$2 || (_path142$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 8H6V10H2z"
    })), _path143$2 || (_path143$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 3.134H6.768V5.134H2.768z",
      transform: "rotate(-150 4.768 4.134)"
    })), children);
  });
  var UserSimulation16 = /*#__PURE__*/React__default['default'].forwardRef(function UserSimulation16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path144$2 || (_path144$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 12.866H29.232V14.866H25.232z",
      transform: "rotate(30 27.232 13.866)"
    })), _path145$2 || (_path145$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 8H30V10H26z"
    })), _path146$2 || (_path146$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 12.866H6.768V14.866H2.768z",
      transform: "rotate(150 4.768 13.866)"
    })), _path147$2 || (_path147$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 30H24V25a5.0059 5.0059 0 00-5-5H13a5.0059 5.0059 0 00-5 5v5H6V25a7.0082 7.0082 0 017-7h6a7.0082 7.0082 0 017 7zM16 4a5 5 0 11-5 5 5 5 0 015-5m0-2a7 7 0 107 7A7 7 0 0016 2z"
    })), _path148$2 || (_path148$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.232 3.134H29.232V5.134H25.232z",
      transform: "rotate(-30 27.232 4.134)"
    })), _path149$2 || (_path149$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2 8H6V10H2z"
    })), _path150$2 || (_path150$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.768 3.134H6.768V5.134H2.768z",
      transform: "rotate(-150 4.768 4.134)"
    })), children);
  });
  var UserSpeaker32 = /*#__PURE__*/React__default['default'].forwardRef(function UserSpeaker32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151$2 || (_path151$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4146,19,27.7,17.2852A2.97,2.97,0,0,0,28,16a3,3,0,1,0-3,3,2.97,2.97,0,0,0,1.2864-.3L28,20.4141V28H22V25a7.0078,7.0078,0,0,0-7-7H9a7.008,7.008,0,0,0-7,7v5H30V20.4141A1.988,1.988,0,0,0,29.4146,19ZM4,25a5.006,5.006,0,0,1,5-5h6a5.0059,5.0059,0,0,1,5,5v3H4Z"
    })), _path152$2 || (_path152$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4A5,5,0,1,1,7,9a5,5,0,0,1,5-5m0-2a7,7,0,1,0,7,7A7,7,0,0,0,12,2Z"
    })), children);
  });
  var UserSpeaker24 = /*#__PURE__*/React__default['default'].forwardRef(function UserSpeaker24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153$2 || (_path153$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4146,19,27.7,17.2852A2.97,2.97,0,0,0,28,16a3,3,0,1,0-3,3,2.97,2.97,0,0,0,1.2864-.3L28,20.4141V28H22V25a7.0078,7.0078,0,0,0-7-7H9a7.008,7.008,0,0,0-7,7v5H30V20.4141A1.988,1.988,0,0,0,29.4146,19ZM4,25a5.006,5.006,0,0,1,5-5h6a5.0059,5.0059,0,0,1,5,5v3H4Z"
    })), _path154$2 || (_path154$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4A5,5,0,1,1,7,9a5,5,0,0,1,5-5m0-2a7,7,0,1,0,7,7A7,7,0,0,0,12,2Z"
    })), children);
  });
  var UserSpeaker20 = /*#__PURE__*/React__default['default'].forwardRef(function UserSpeaker20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$2 || (_path155$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4146,19,27.7,17.2852A2.97,2.97,0,0,0,28,16a3,3,0,1,0-3,3,2.97,2.97,0,0,0,1.2864-.3L28,20.4141V28H22V25a7.0078,7.0078,0,0,0-7-7H9a7.008,7.008,0,0,0-7,7v5H30V20.4141A1.988,1.988,0,0,0,29.4146,19ZM4,25a5.006,5.006,0,0,1,5-5h6a5.0059,5.0059,0,0,1,5,5v3H4Z"
    })), _path156$2 || (_path156$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4A5,5,0,1,1,7,9a5,5,0,0,1,5-5m0-2a7,7,0,1,0,7,7A7,7,0,0,0,12,2Z"
    })), children);
  });
  var UserSpeaker16 = /*#__PURE__*/React__default['default'].forwardRef(function UserSpeaker16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157$2 || (_path157$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.4146,19,27.7,17.2852A2.97,2.97,0,0,0,28,16a3,3,0,1,0-3,3,2.97,2.97,0,0,0,1.2864-.3L28,20.4141V28H22V25a7.0078,7.0078,0,0,0-7-7H9a7.008,7.008,0,0,0-7,7v5H30V20.4141A1.988,1.988,0,0,0,29.4146,19ZM4,25a5.006,5.006,0,0,1,5-5h6a5.0059,5.0059,0,0,1,5,5v3H4Z"
    })), _path158$2 || (_path158$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,4A5,5,0,1,1,7,9a5,5,0,0,1,5-5m0-2a7,7,0,1,0,7,7A7,7,0,0,0,12,2Z"
    })), children);
  });
  var UserXRay32 = /*#__PURE__*/React__default['default'].forwardRef(function UserXRay32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159$2 || (_path159$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"
    })), _path160$2 || (_path160$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 3H17a1 1 0 00-1 1V17a1 1 0 001 1H31a1 1 0 001-1V4A1 1 0 0031 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserXRay24 = /*#__PURE__*/React__default['default'].forwardRef(function UserXRay24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$2 || (_path161$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"
    })), _path162$2 || (_path162$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 3H17a1 1 0 00-1 1V17a1 1 0 001 1H31a1 1 0 001-1V4A1 1 0 0031 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserXRay20 = /*#__PURE__*/React__default['default'].forwardRef(function UserXRay20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$2 || (_path163$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"
    })), _path164$2 || (_path164$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 3H17a1 1 0 00-1 1V17a1 1 0 001 1H31a1 1 0 001-1V4A1 1 0 0031 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserXRay16 = /*#__PURE__*/React__default['default'].forwardRef(function UserXRay16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$2 || (_path165$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"
    })), _path166$2 || (_path166$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 3H17a1 1 0 00-1 1V17a1 1 0 001 1H31a1 1 0 001-1V4A1 1 0 0031 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 00-3-3H6a2.9465 2.9465 0 00-3 3v4H1V26a4.9514 4.9514 0 015-5h4a4.9514 4.9514 0 015 5zM8 11a3 3 0 010 6 3 3 0 010-6M8 9A5 5 0 008 19 5 5 0 008 9z"
    })), children);
  });
  var UserProfileAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfileAlt32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$2 || (_path167$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0111 30zM6 12a.9448.9448 0 00-1 1v6H7v9h4V19h2V13a.9448.9448 0 00-1-1zM9 9a4 4 0 114-4h0A4.0118 4.0118 0 019 9zM9 3a2 2 0 102 2h0A2.0059 2.0059 0 009 3z"
    })), children);
  });
  var UserProfileAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfileAlt24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path168$2 || (_path168$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0111 30zM6 12a.9448.9448 0 00-1 1v6H7v9h4V19h2V13a.9448.9448 0 00-1-1zM9 9a4 4 0 114-4h0A4.0118 4.0118 0 019 9zM9 3a2 2 0 102 2h0A2.0059 2.0059 0 009 3z"
    })), children);
  });
  var UserProfileAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfileAlt20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$2 || (_path169$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0111 30zM6 12a.9448.9448 0 00-1 1v6H7v9h4V19h2V13a.9448.9448 0 00-1-1zM9 9a4 4 0 114-4h0A4.0118 4.0118 0 019 9zM9 3a2 2 0 102 2h0A2.0059 2.0059 0 009 3z"
    })), children);
  });
  var UserProfileAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function UserProfileAlt16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170$2 || (_path170$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 01-2-2V21a2.0059 2.0059 0 01-2-2V13a2.9465 2.9465 0 013-3h6a2.9465 2.9465 0 013 3v6a2.0059 2.0059 0 01-2 2v7A2.0059 2.0059 0 0111 30zM6 12a.9448.9448 0 00-1 1v6H7v9h4V19h2V13a.9448.9448 0 00-1-1zM9 9a4 4 0 114-4h0A4.0118 4.0118 0 019 9zM9 3a2 2 0 102 2h0A2.0059 2.0059 0 009 3z"
    })), children);
  });
  var UvIndex32 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndex32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$2 || (_path171$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,5.9121l1.7444,2.9326.7822,1.315,1.4739-.4107,3.1206-.87L22.2512,12,21.84,13.4731l1.315.7823L26.0876,16l-2.9323,1.7441-1.315.7818L22.2512,20l.87,3.1211-3.1208-.87L18.5266,21.84l-.7822,1.315L16,26.0879l-1.7444-2.9326-.7822-1.315L12,22.251l-3.1208.87L9.7488,20l.4109-1.4741-1.315-.7818L5.9124,16l2.9323-1.7446,1.315-.7823L9.7488,12l-.87-3.1206L12,9.749l1.4739.4107.7822-1.315L16,5.9121M16,2,12.5366,7.8223,6,6l1.8223,6.5366L2,16l5.8223,3.4629L6,26l6.5366-1.8223L16,30l3.4634-5.8223L26,26l-1.8223-6.5371L30,16l-5.8223-3.4634L26,6,19.4634,7.8223,16,2Z"
    })), children);
  });
  var UvIndex24 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndex24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172$2 || (_path172$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,5.9121l1.7444,2.9326.7822,1.315,1.4739-.4107,3.1206-.87L22.2512,12,21.84,13.4731l1.315.7823L26.0876,16l-2.9323,1.7441-1.315.7818L22.2512,20l.87,3.1211-3.1208-.87L18.5266,21.84l-.7822,1.315L16,26.0879l-1.7444-2.9326-.7822-1.315L12,22.251l-3.1208.87L9.7488,20l.4109-1.4741-1.315-.7818L5.9124,16l2.9323-1.7446,1.315-.7823L9.7488,12l-.87-3.1206L12,9.749l1.4739.4107.7822-1.315L16,5.9121M16,2,12.5366,7.8223,6,6l1.8223,6.5366L2,16l5.8223,3.4629L6,26l6.5366-1.8223L16,30l3.4634-5.8223L26,26l-1.8223-6.5371L30,16l-5.8223-3.4634L26,6,19.4634,7.8223,16,2Z"
    })), children);
  });
  var UvIndex20 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndex20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$2 || (_path173$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,5.9121l1.7444,2.9326.7822,1.315,1.4739-.4107,3.1206-.87L22.2512,12,21.84,13.4731l1.315.7823L26.0876,16l-2.9323,1.7441-1.315.7818L22.2512,20l.87,3.1211-3.1208-.87L18.5266,21.84l-.7822,1.315L16,26.0879l-1.7444-2.9326-.7822-1.315L12,22.251l-3.1208.87L9.7488,20l.4109-1.4741-1.315-.7818L5.9124,16l2.9323-1.7446,1.315-.7823L9.7488,12l-.87-3.1206L12,9.749l1.4739.4107.7822-1.315L16,5.9121M16,2,12.5366,7.8223,6,6l1.8223,6.5366L2,16l5.8223,3.4629L6,26l6.5366-1.8223L16,30l3.4634-5.8223L26,26l-1.8223-6.5371L30,16l-5.8223-3.4634L26,6,19.4634,7.8223,16,2Z"
    })), children);
  });
  var UvIndex16 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndex16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174$2 || (_path174$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,5.9121l1.7444,2.9326.7822,1.315,1.4739-.4107,3.1206-.87L22.2512,12,21.84,13.4731l1.315.7823L26.0876,16l-2.9323,1.7441-1.315.7818L22.2512,20l.87,3.1211-3.1208-.87L18.5266,21.84l-.7822,1.315L16,26.0879l-1.7444-2.9326-.7822-1.315L12,22.251l-3.1208.87L9.7488,20l.4109-1.4741-1.315-.7818L5.9124,16l2.9323-1.7446,1.315-.7823L9.7488,12l-.87-3.1206L12,9.749l1.4739.4107.7822-1.315L16,5.9121M16,2,12.5366,7.8223,6,6l1.8223,6.5366L2,16l5.8223,3.4629L6,26l6.5366-1.8223L16,30l3.4634-5.8223L26,26l-1.8223-6.5371L30,16l-5.8223-3.4634L26,6,19.4634,7.8223,16,2Z"
    })), children);
  });
  var UvIndexAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexAlt32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$2 || (_path175$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 30H9a2.0027 2.0027 0 01-2-2V20H9v8h4V20h2v8A2.0027 2.0027 0 0113 30zM25 20L23.25 20 21 29.031 18.792 20 17 20 19.5 30 22.5 30 25 20zM15 2H17V7H15z"
    })), _path176$2 || (_path176$2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path177$1 || (_path177$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25zM2 15H7V17H2z"
    })), _path178$1 || (_path178$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path179$1 || (_path179$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17H20V16a4,4,0,0,0-8,0v1H10V16a6,6,0,0,1,12,0Z"
    })), children);
  });
  var UvIndexAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexAlt24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path180$1 || (_path180$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 30H9a2.0027 2.0027 0 01-2-2V20H9v8h4V20h2v8A2.0027 2.0027 0 0113 30zM25 20L23.25 20 21 29.031 18.792 20 17 20 19.5 30 22.5 30 25 20zM15 2H17V7H15z"
    })), _path181$1 || (_path181$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path182$1 || (_path182$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25zM2 15H7V17H2z"
    })), _path183$1 || (_path183$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path184$1 || (_path184$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17H20V16a4,4,0,0,0-8,0v1H10V16a6,6,0,0,1,12,0Z"
    })), children);
  });
  var UvIndexAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexAlt20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185$1 || (_path185$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 30H9a2.0027 2.0027 0 01-2-2V20H9v8h4V20h2v8A2.0027 2.0027 0 0113 30zM25 20L23.25 20 21 29.031 18.792 20 17 20 19.5 30 22.5 30 25 20zM15 2H17V7H15z"
    })), _path186$1 || (_path186$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path187$1 || (_path187$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25zM2 15H7V17H2z"
    })), _path188$1 || (_path188$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path189$1 || (_path189$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17H20V16a4,4,0,0,0-8,0v1H10V16a6,6,0,0,1,12,0Z"
    })), children);
  });
  var UvIndexAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexAlt16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path190$1 || (_path190$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13 30H9a2.0027 2.0027 0 01-2-2V20H9v8h4V20h2v8A2.0027 2.0027 0 0113 30zM25 20L23.25 20 21 29.031 18.792 20 17 20 19.5 30 22.5 30 25 20zM15 2H17V7H15z"
    })), _path191$1 || (_path191$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.668 6.854H26.625999999999998V8.854H21.668z",
      transform: "rotate(-45 24.147 7.853)"
    })), _path192$1 || (_path192$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 15H30V17H25zM2 15H7V17H2z"
    })), _path193$1 || (_path193$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.854 5.375H8.854V10.333H6.854z",
      transform: "rotate(-45 7.854 7.853)"
    })), _path194$1 || (_path194$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,17H20V16a4,4,0,0,0-8,0v1H10V16a6,6,0,0,1,12,0Z"
    })), children);
  });
  var UvIndexFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexFilled32(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195$1 || (_path195$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30l-3.4634-5.8223L6,26l1.8223-6.5369L2,16l5.8223-3.4631L6,6l6.5366,1.8223L16,2l3.4634,5.8223L26,6l-1.8223,6.5369L30,16l-5.8223,3.4631L26,26l-6.5366-1.8223Z"
    })), children);
  });
  var UvIndexFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexFilled24(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path196$1 || (_path196$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30l-3.4634-5.8223L6,26l1.8223-6.5369L2,16l5.8223-3.4631L6,6l6.5366,1.8223L16,2l3.4634,5.8223L26,6l-1.8223,6.5369L30,16l-5.8223,3.4631L26,26l-6.5366-1.8223Z"
    })), children);
  });
  var UvIndexFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexFilled20(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197$1 || (_path197$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30l-3.4634-5.8223L6,26l1.8223-6.5369L2,16l5.8223-3.4631L6,6l6.5366,1.8223L16,2l3.4634,5.8223L26,6l-1.8223,6.5369L30,16l-5.8223,3.4631L26,26l-6.5366-1.8223Z"
    })), children);
  });
  var UvIndexFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function UvIndexFilled16(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path198$1 || (_path198$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,30l-3.4634-5.8223L6,26l1.8223-6.5369L2,16l5.8223-3.4631L6,6l6.5366,1.8223L16,2l3.4634,5.8223L26,6l-1.8223,6.5369L30,16l-5.8223,3.4631L26,26l-6.5366-1.8223Z"
    })), children);
  });
  var ValueVariable32 = /*#__PURE__*/React__default['default'].forwardRef(function ValueVariable32(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199$1 || (_path199$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H22V26h4V6H22V4h4a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM20 11L18 11 16 14.897 14 11 12 11 14.905 16 12 21 14 21 16 17.201 18 21 20 21 17.098 16 20 11zM10 28H6a2.0021 2.0021 0 01-2-2V6A2.0021 2.0021 0 016 4h4V6H6V26h4z"
    })), children);
  });
  var ValueVariable24 = /*#__PURE__*/React__default['default'].forwardRef(function ValueVariable24(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path200$1 || (_path200$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H22V26h4V6H22V4h4a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM20 11L18 11 16 14.897 14 11 12 11 14.905 16 12 21 14 21 16 17.201 18 21 20 21 17.098 16 20 11zM10 28H6a2.0021 2.0021 0 01-2-2V6A2.0021 2.0021 0 016 4h4V6H6V26h4z"
    })), children);
  });
  var ValueVariable20 = /*#__PURE__*/React__default['default'].forwardRef(function ValueVariable20(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201$1 || (_path201$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H22V26h4V6H22V4h4a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM20 11L18 11 16 14.897 14 11 12 11 14.905 16 12 21 14 21 16 17.201 18 21 20 21 17.098 16 20 11zM10 28H6a2.0021 2.0021 0 01-2-2V6A2.0021 2.0021 0 016 4h4V6H6V26h4z"
    })), children);
  });
  var ValueVariable16 = /*#__PURE__*/React__default['default'].forwardRef(function ValueVariable16(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path202$1 || (_path202$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 28H22V26h4V6H22V4h4a2.0021 2.0021 0 012 2V26A2.0021 2.0021 0 0126 28zM20 11L18 11 16 14.897 14 11 12 11 14.905 16 12 21 14 21 16 17.201 18 21 20 21 17.098 16 20 11zM10 28H6a2.0021 2.0021 0 01-2-2V6A2.0021 2.0021 0 016 4h4V6H6V26h4z"
    })), children);
  });
  var Van32 = /*#__PURE__*/React__default['default'].forwardRef(function Van32(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203$1 || (_path203$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"
    })), children);
  });
  var Van24 = /*#__PURE__*/React__default['default'].forwardRef(function Van24(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path204$1 || (_path204$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"
    })), children);
  });
  var Van20 = /*#__PURE__*/React__default['default'].forwardRef(function Van20(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205$1 || (_path205$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"
    })), children);
  });
  var Van16 = /*#__PURE__*/React__default['default'].forwardRef(function Van16(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path206$1 || (_path206$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"
    })), children);
  });
  var VegetationAsset32 = /*#__PURE__*/React__default['default'].forwardRef(function VegetationAsset32(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9$1 || (_circle9$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "10.5",
      r: "1.5"
    })), _path207$1 || (_path207$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5 1a2.4518 2.4518 0 00-1.2061.3105L18.9834 5.6084l.0027.0054a5.497 5.497 0 107.3257 7.5444l.0031.0015 4.4-8.5A2.5 2.5 0 0028.5 1zm-7 13A3.5 3.5 0 1125 10.5 3.5042 3.5042 0 0121.5 14zM28.9414 3.7354L26.5571 8.3408A5.5279 5.5279 0 0023.658 5.4424l4.5949-2.377A.5165.5165 0 0129 3.5.4985.4985 0 0128.9414 3.7354zM19 20h7V18H17V28a2.0027 2.0027 0 002 2h3V28H19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path208$1 || (_path208$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.3079,2.2852A9.4882,9.4882,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4a7.499,7.499,0,0,1,1.731.2148Z"
    })), children);
  });
  var VegetationAsset24 = /*#__PURE__*/React__default['default'].forwardRef(function VegetationAsset24(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10$1 || (_circle10$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "10.5",
      r: "1.5"
    })), _path209$1 || (_path209$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5 1a2.4518 2.4518 0 00-1.2061.3105L18.9834 5.6084l.0027.0054a5.497 5.497 0 107.3257 7.5444l.0031.0015 4.4-8.5A2.5 2.5 0 0028.5 1zm-7 13A3.5 3.5 0 1125 10.5 3.5042 3.5042 0 0121.5 14zM28.9414 3.7354L26.5571 8.3408A5.5279 5.5279 0 0023.658 5.4424l4.5949-2.377A.5165.5165 0 0129 3.5.4985.4985 0 0128.9414 3.7354zM19 20h7V18H17V28a2.0027 2.0027 0 002 2h3V28H19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path210$1 || (_path210$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.3079,2.2852A9.4882,9.4882,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4a7.499,7.499,0,0,1,1.731.2148Z"
    })), children);
  });
  var VegetationAsset20 = /*#__PURE__*/React__default['default'].forwardRef(function VegetationAsset20(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11$1 || (_circle11$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "10.5",
      r: "1.5"
    })), _path211$1 || (_path211$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5 1a2.4518 2.4518 0 00-1.2061.3105L18.9834 5.6084l.0027.0054a5.497 5.497 0 107.3257 7.5444l.0031.0015 4.4-8.5A2.5 2.5 0 0028.5 1zm-7 13A3.5 3.5 0 1125 10.5 3.5042 3.5042 0 0121.5 14zM28.9414 3.7354L26.5571 8.3408A5.5279 5.5279 0 0023.658 5.4424l4.5949-2.377A.5165.5165 0 0129 3.5.4985.4985 0 0128.9414 3.7354zM19 20h7V18H17V28a2.0027 2.0027 0 002 2h3V28H19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path212$1 || (_path212$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.3079,2.2852A9.4882,9.4882,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4a7.499,7.499,0,0,1,1.731.2148Z"
    })), children);
  });
  var VegetationAsset16 = /*#__PURE__*/React__default['default'].forwardRef(function VegetationAsset16(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12$1 || (_circle12$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "21.5",
      cy: "10.5",
      r: "1.5"
    })), _path213$1 || (_path213$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.5 1a2.4518 2.4518 0 00-1.2061.3105L18.9834 5.6084l.0027.0054a5.497 5.497 0 107.3257 7.5444l.0031.0015 4.4-8.5A2.5 2.5 0 0028.5 1zm-7 13A3.5 3.5 0 1125 10.5 3.5042 3.5042 0 0121.5 14zM28.9414 3.7354L26.5571 8.3408A5.5279 5.5279 0 0023.658 5.4424l4.5949-2.377A.5165.5165 0 0129 3.5.4985.4985 0 0128.9414 3.7354zM19 20h7V18H17V28a2.0027 2.0027 0 002 2h3V28H19zM12 30H9V28h3V15.5664L8.4854 13.4575l1.0292-1.7148 3.5147 2.1084A2.0115 2.0115 0 0114 15.5664V28A2.0024 2.0024 0 0112 30z"
    })), _path214$1 || (_path214$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.3079,2.2852A9.4882,9.4882,0,0,0,15,2,8.0275,8.0275,0,0,0,8.0786,6.001C8.0525,6,8.0264,6,8,6A6,6,0,0,0,8,18V16A4,4,0,0,1,8,8a2.7009,2.7009,0,0,1,.387.0391l.863.1142.3086-.6675A6.0192,6.0192,0,0,1,15,4a7.499,7.499,0,0,1,1.731.2148Z"
    })), children);
  });
  var VehicleApi32 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleApi32(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215$1 || (_path215$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11a1.9907 1.9907 0 00-.8247.1821L24.8337 9.51A3.45 3.45 0 0025 8.5a3.45 3.45 0 00-.1663-1.01l2.3416-1.6723A1.9975 1.9975 0 1026 4c0 .064.0129.124.0188.1865L23.7273 5.8232A3.4652 3.4652 0 0021.5 5a3.5 3.5 0 000 7 3.4652 3.4652 0 002.2273-.8232l2.2915 1.6367C26.0129 12.876 26 12.936 26 13a2 2 0 102-2zm-6.5-1A1.5 1.5 0 1123 8.5 1.5017 1.5017 0 0121.5 10zM29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781z"
    })), children);
  });
  var VehicleApi24 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleApi24(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216$1 || (_path216$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11a1.9907 1.9907 0 00-.8247.1821L24.8337 9.51A3.45 3.45 0 0025 8.5a3.45 3.45 0 00-.1663-1.01l2.3416-1.6723A1.9975 1.9975 0 1026 4c0 .064.0129.124.0188.1865L23.7273 5.8232A3.4652 3.4652 0 0021.5 5a3.5 3.5 0 000 7 3.4652 3.4652 0 002.2273-.8232l2.2915 1.6367C26.0129 12.876 26 12.936 26 13a2 2 0 102-2zm-6.5-1A1.5 1.5 0 1123 8.5 1.5017 1.5017 0 0121.5 10zM29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781z"
    })), children);
  });
  var VehicleApi20 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleApi20(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217$1 || (_path217$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11a1.9907 1.9907 0 00-.8247.1821L24.8337 9.51A3.45 3.45 0 0025 8.5a3.45 3.45 0 00-.1663-1.01l2.3416-1.6723A1.9975 1.9975 0 1026 4c0 .064.0129.124.0188.1865L23.7273 5.8232A3.4652 3.4652 0 0021.5 5a3.5 3.5 0 000 7 3.4652 3.4652 0 002.2273-.8232l2.2915 1.6367C26.0129 12.876 26 12.936 26 13a2 2 0 102-2zm-6.5-1A1.5 1.5 0 1123 8.5 1.5017 1.5017 0 0121.5 10zM29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781z"
    })), children);
  });
  var VehicleApi16 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleApi16(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218$1 || (_path218$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 11a1.9907 1.9907 0 00-.8247.1821L24.8337 9.51A3.45 3.45 0 0025 8.5a3.45 3.45 0 00-.1663-1.01l2.3416-1.6723A1.9975 1.9975 0 1026 4c0 .064.0129.124.0188.1865L23.7273 5.8232A3.4652 3.4652 0 0021.5 5a3.5 3.5 0 000 7 3.4652 3.4652 0 002.2273-.8232l2.2915 1.6367C26.0129 12.876 26 12.936 26 13a2 2 0 102-2zm-6.5-1A1.5 1.5 0 1123 8.5 1.5017 1.5017 0 0121.5 10zM29.3379 19.9336l-7.7324-2.7783L18.374 13.0967A2.99 2.99 0 0016.0537 12H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 17.2949A4.9884 4.9884 0 002 20.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V20.875A1 1 0 0029.3379 19.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V20.1074A2.9977 2.9977 0 014.52 18.4189l2.711-3.9814A.9992.9992 0 018.0576 14h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 21.5781z"
    })), children);
  });
  var VehicleConnected32 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleConnected32(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219$1 || (_path219$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM25 11H23a2.0021 2.0021 0 00-2-2V7A4.0045 4.0045 0 0125 11z"
    })), _path220$1 || (_path220$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,11H27a6.0067,6.0067,0,0,0-6-6V3A8.0092,8.0092,0,0,1,29,11Z"
    })), children);
  });
  var VehicleConnected24 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleConnected24(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221$1 || (_path221$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM25 11H23a2.0021 2.0021 0 00-2-2V7A4.0045 4.0045 0 0125 11z"
    })), _path222$1 || (_path222$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,11H27a6.0067,6.0067,0,0,0-6-6V3A8.0092,8.0092,0,0,1,29,11Z"
    })), children);
  });
  var VehicleConnected20 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleConnected20(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path223$1 || (_path223$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM25 11H23a2.0021 2.0021 0 00-2-2V7A4.0045 4.0045 0 0125 11z"
    })), _path224$1 || (_path224$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,11H27a6.0067,6.0067,0,0,0-6-6V3A8.0092,8.0092,0,0,1,29,11Z"
    })), children);
  });
  var VehicleConnected16 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleConnected16(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path225$1 || (_path225$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM25 11H23a2.0021 2.0021 0 00-2-2V7A4.0045 4.0045 0 0125 11z"
    })), _path226$1 || (_path226$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,11H27a6.0067,6.0067,0,0,0-6-6V3A8.0092,8.0092,0,0,1,29,11Z"
    })), children);
  });
  var VehicleInsights32 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleInsights32(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227$1 || (_path227$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM28 2H30V9H28zM24 6H26V9H24zM20 4H22V9H20z"
    })), children);
  });
  var VehicleInsights24 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleInsights24(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path228$1 || (_path228$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM28 2H30V9H28zM24 6H26V9H24zM20 4H22V9H20z"
    })), children);
  });
  var VehicleInsights20 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleInsights20(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path229$1 || (_path229$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM28 2H30V9H28zM24 6H26V9H24zM20 4H22V9H20z"
    })), children);
  });
  var VehicleInsights16 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleInsights16(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230$1 || (_path230$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM28 2H30V9H28zM24 6H26V9H24zM20 4H22V9H20z"
    })), children);
  });
  var VehicleServices32 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleServices32(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path231$1 || (_path231$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM24.5547 6a2 2 0 012-2H30a3.9756 3.9756 0 00-7.304 1H16V7h6.696A3.9756 3.9756 0 0030 8H26.5547A2 2 0 0124.5547 6z"
    })), children);
  });
  var VehicleServices24 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleServices24(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path232$1 || (_path232$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM24.5547 6a2 2 0 012-2H30a3.9756 3.9756 0 00-7.304 1H16V7h6.696A3.9756 3.9756 0 0030 8H26.5547A2 2 0 0124.5547 6z"
    })), children);
  });
  var VehicleServices20 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleServices20(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233$1 || (_path233$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM24.5547 6a2 2 0 012-2H30a3.9756 3.9756 0 00-7.304 1H16V7h6.696A3.9756 3.9756 0 0030 8H26.5547A2 2 0 0124.5547 6z"
    })), children);
  });
  var VehicleServices16 = /*#__PURE__*/React__default['default'].forwardRef(function VehicleServices16(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path234$1 || (_path234$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3379 17.9336l-7.7324-2.7783L18.374 11.0967A2.99 2.99 0 0016.0537 10H8.0576a2.9982 2.9982 0 00-2.48 1.3115L2.8662 15.2949A4.9884 4.9884 0 002 18.1074V26a1 1 0 001 1H5.1421a3.9806 3.9806 0 007.7158 0h6.2842a3.9806 3.9806 0 007.7158 0H29a1 1 0 001-1V18.875A1 1 0 0029.3379 17.9336zM9 28a2 2 0 112-2A2.0027 2.0027 0 019 28zm14 0a2 2 0 112-2A2.0025 2.0025 0 0123 28zm5-3H26.8579a3.9806 3.9806 0 00-7.7158 0H12.8579a3.9806 3.9806 0 00-7.7158 0H4V18.1074A2.9977 2.9977 0 014.52 16.4189l2.711-3.9814A.9992.9992 0 018.0576 12h7.9961a.9928.9928 0 01.7647.3545l3.3994 4.2685a1.0007 1.0007 0 00.4443.3184L28 19.5781zM24.5547 6a2 2 0 012-2H30a3.9756 3.9756 0 00-7.304 1H16V7h6.696A3.9756 3.9756 0 0030 8H26.5547A2 2 0 0124.5547 6z"
    })), children);
  });
  var Version32 = /*#__PURE__*/React__default['default'].forwardRef(function Version32(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235$1 || (_path235$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2V4H26V19h2V4a2.0023,2.0023,0,0,0-2-2Z"
    })), _path236$1 || (_path236$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,7V9H21V24h2V9a2.0023,2.0023,0,0,0-2-2Z"
    })), _path237$1 || (_path237$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,12H16a2.0023,2.0023,0,0,1,2,2V28a2.0023,2.0023,0,0,1-2,2H6a2.0023,2.0023,0,0,1-2-2V14A2.0023,2.0023,0,0,1,6,12Zm10,2L6,13.9988V28H16Z"
    })), children);
  });
  var Version24 = /*#__PURE__*/React__default['default'].forwardRef(function Version24(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path238$1 || (_path238$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2V4H26V19h2V4a2.0023,2.0023,0,0,0-2-2Z"
    })), _path239$1 || (_path239$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,7V9H21V24h2V9a2.0023,2.0023,0,0,0-2-2Z"
    })), _path240$1 || (_path240$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,12H16a2.0023,2.0023,0,0,1,2,2V28a2.0023,2.0023,0,0,1-2,2H6a2.0023,2.0023,0,0,1-2-2V14A2.0023,2.0023,0,0,1,6,12Zm10,2L6,13.9988V28H16Z"
    })), children);
  });
  var Version20 = /*#__PURE__*/React__default['default'].forwardRef(function Version20(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241$1 || (_path241$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2V4H26V19h2V4a2.0023,2.0023,0,0,0-2-2Z"
    })), _path242$1 || (_path242$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,7V9H21V24h2V9a2.0023,2.0023,0,0,0-2-2Z"
    })), _path243$1 || (_path243$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,12H16a2.0023,2.0023,0,0,1,2,2V28a2.0023,2.0023,0,0,1-2,2H6a2.0023,2.0023,0,0,1-2-2V14A2.0023,2.0023,0,0,1,6,12Zm10,2L6,13.9988V28H16Z"
    })), children);
  });
  var Version16 = /*#__PURE__*/React__default['default'].forwardRef(function Version16(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path244$1 || (_path244$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2V4H26V19h2V4a2.0023,2.0023,0,0,0-2-2Z"
    })), _path245$1 || (_path245$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11,7V9H21V24h2V9a2.0023,2.0023,0,0,0-2-2Z"
    })), _path246$1 || (_path246$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,12H16a2.0023,2.0023,0,0,1,2,2V28a2.0023,2.0023,0,0,1-2,2H6a2.0023,2.0023,0,0,1-2-2V14A2.0023,2.0023,0,0,1,6,12Zm10,2L6,13.9988V28H16Z"
    })), children);
  });
  var VerticalView32 = /*#__PURE__*/React__default['default'].forwardRef(function VerticalView32(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247$1 || (_path247$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0112 30zM4 4V28h8V4zM28 30H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM20 4V28h8V4z"
    })), children);
  });
  var VerticalView24 = /*#__PURE__*/React__default['default'].forwardRef(function VerticalView24(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path248$1 || (_path248$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0112 30zM4 4V28h8V4zM28 30H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM20 4V28h8V4z"
    })), children);
  });
  var VerticalView20 = /*#__PURE__*/React__default['default'].forwardRef(function VerticalView20(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249$1 || (_path249$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0112 30zM4 4V28h8V4zM28 30H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM20 4V28h8V4z"
    })), children);
  });
  var VerticalView16 = /*#__PURE__*/React__default['default'].forwardRef(function VerticalView16(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250$1 || (_path250$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 30H4a2.0021 2.0021 0 01-2-2V4A2.0021 2.0021 0 014 2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0112 30zM4 4V28h8V4zM28 30H20a2.0021 2.0021 0 01-2-2V4a2.0021 2.0021 0 012-2h8a2.0021 2.0021 0 012 2V28A2.0021 2.0021 0 0128 30zM20 4V28h8V4z"
    })), children);
  });
  var Video32 = /*#__PURE__*/React__default['default'].forwardRef(function Video32(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251$1 || (_path251$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"
    })), children);
  });
  var Video24 = /*#__PURE__*/React__default['default'].forwardRef(function Video24(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252$1 || (_path252$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"
    })), children);
  });
  var Video20 = /*#__PURE__*/React__default['default'].forwardRef(function Video20(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253$1 || (_path253$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"
    })), children);
  });
  var Video16 = /*#__PURE__*/React__default['default'].forwardRef(function Video16(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254$1 || (_path254$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoAdd32 = /*#__PURE__*/React__default['default'].forwardRef(function VideoAdd32(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255$1 || (_path255$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"
    })), _path256$1 || (_path256$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoAdd24 = /*#__PURE__*/React__default['default'].forwardRef(function VideoAdd24(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257$1 || (_path257$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"
    })), _path258$1 || (_path258$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoAdd20 = /*#__PURE__*/React__default['default'].forwardRef(function VideoAdd20(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259$1 || (_path259$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"
    })), _path260$1 || (_path260$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoAdd16 = /*#__PURE__*/React__default['default'].forwardRef(function VideoAdd16(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261$1 || (_path261$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"
    })), _path262$1 || (_path262$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoChat32 = /*#__PURE__*/React__default['default'].forwardRef(function VideoChat32(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path263$1 || (_path263$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H17V14H8zM8 17H13V19H8z"
    })), _path264$1 || (_path264$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoChat24 = /*#__PURE__*/React__default['default'].forwardRef(function VideoChat24(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path265$1 || (_path265$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H17V14H8zM8 17H13V19H8z"
    })), _path266$1 || (_path266$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoChat20 = /*#__PURE__*/React__default['default'].forwardRef(function VideoChat20(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267$1 || (_path267$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H17V14H8zM8 17H13V19H8z"
    })), _path268$1 || (_path268$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoChat16 = /*#__PURE__*/React__default['default'].forwardRef(function VideoChat16(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path269$1 || (_path269$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H17V14H8zM8 17H13V19H8z"
    })), _path270$1 || (_path270$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"
    })), children);
  });
  var VideoFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function VideoFilled32(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path271$1 || (_path271$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"
    })), children);
  });
  var VideoFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function VideoFilled24(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path272$1 || (_path272$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"
    })), children);
  });
  var VideoFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function VideoFilled20(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273$1 || (_path273$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"
    })), children);
  });
  var VideoFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function VideoFilled16(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path274$1 || (_path274$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"
    })), children);
  });
  var VideoOff32 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOff32(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path275$1 || (_path275$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0021 18v6H9.44L21 12.44V14a1 1 0 001.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 002 8V24z"
    })), children);
  });
  var VideoOff24 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOff24(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276$1 || (_path276$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0021 18v6H9.44L21 12.44V14a1 1 0 001.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 002 8V24z"
    })), children);
  });
  var VideoOff20 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOff20(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path277$1 || (_path277$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0021 18v6H9.44L21 12.44V14a1 1 0 001.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 002 8V24z"
    })), children);
  });
  var VideoOff16 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOff16(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path278$1 || (_path278$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0021 18v6H9.44L21 12.44V14a1 1 0 001.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 002 8V24z"
    })), children);
  });
  var VideoOffFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOffFilled32(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279$1 || (_path279$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.31 6H4A2 2 0 002 8V24a2.85 2.85 0 000 .29zM29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11z"
    })), children);
  });
  var VideoOffFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOffFilled24(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path280$1 || (_path280$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.31 6H4A2 2 0 002 8V24a2.85 2.85 0 000 .29zM29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11z"
    })), children);
  });
  var VideoOffFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOffFilled20(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path281$1 || (_path281$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.31 6H4A2 2 0 002 8V24a2.85 2.85 0 000 .29zM29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11z"
    })), children);
  });
  var VideoOffFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function VideoOffFilled16(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282$1 || (_path282$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.31 6H4A2 2 0 002 8V24a2.85 2.85 0 000 .29zM29.46 8.11a1 1 0 00-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 002-2V19.94l5.42 3.87A1 1 0 0030 23V9A1 1 0 0029.46 8.11z"
    })), children);
  });
  var View32 = /*#__PURE__*/React__default['default'].forwardRef(function View32(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path283$1 || (_path283$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,25c-5.3,0-10.9-3.93-12.93-9C5.1,10.93,10.7,7,16,7s10.9,3.93,12.93,9C26.9,21.07,21.3,25,16,25Z"
    })), _path284$1 || (_path284$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var View24 = /*#__PURE__*/React__default['default'].forwardRef(function View24(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path285$1 || (_path285$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,25c-5.3,0-10.9-3.93-12.93-9C5.1,10.93,10.7,7,16,7s10.9,3.93,12.93,9C26.9,21.07,21.3,25,16,25Z"
    })), _path286$1 || (_path286$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var View20 = /*#__PURE__*/React__default['default'].forwardRef(function View20(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path287$1 || (_path287$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,25c-5.3,0-10.9-3.93-12.93-9C5.1,10.93,10.7,7,16,7s10.9,3.93,12.93,9C26.9,21.07,21.3,25,16,25Z"
    })), _path288$1 || (_path288$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"
    })), children);
  });
  var View16 = /*#__PURE__*/React__default['default'].forwardRef(function View16(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path289$1 || (_path289$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.5,7.8C14.3,4.7,11.3,2.6,8,2.5C4.7,2.6,1.7,4.7,0.5,7.8c0,0.1,0,0.2,0,0.3c1.2,3.1,4.1,5.2,7.5,5.3\tc3.3-0.1,6.3-2.2,7.5-5.3C15.5,8.1,15.5,7.9,15.5,7.8z M8,12.5c-2.7,0-5.4-2-6.5-4.5c1-2.5,3.8-4.5,6.5-4.5s5.4,2,6.5,4.5\tC13.4,10.5,10.6,12.5,8,12.5z"
    })), _path290$1 || (_path290$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z M8,10c-1.1,0-2-0.9-2-2s0.9-2,2-2s2,0.9,2,2S9.1,10,8,10z"
    })), children);
  });
  var ViewFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ViewFilled32(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle13$1 || (_circle13$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path291$1 || (_path291$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"
    })), children);
  });
  var ViewFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ViewFilled24(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle14$1 || (_circle14$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path292$1 || (_path292$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"
    })), children);
  });
  var ViewFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ViewFilled20(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle15$1 || (_circle15$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path293$1 || (_path293$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"
    })), children);
  });
  var ViewFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ViewFilled16(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle16$1 || (_circle16$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "16",
      r: "4"
    })), _path294$1 || (_path294$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"
    })), children);
  });
  var ViewMode_132 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_132(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295$1 || (_path295$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 004 6v6a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_124 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_124(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296$1 || (_path296$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 004 6v6a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_120 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_120(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path297$1 || (_path297$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 004 6v6a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_116 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_116(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path298$1 || (_path298$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 004 6v6a2 2 0 002 2H26a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_232 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_232(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path299$1 || (_path299$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_224 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_224(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path300$1 || (_path300$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_220 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_220(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path301$1 || (_path301$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewMode_216 = /*#__PURE__*/React__default['default'].forwardRef(function ViewMode_216(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path302$1 || (_path302$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 004 6v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 00-2 2v6a2 2 0 002 2h6a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var ViewOff32 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOff32(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path303$1 || (_path303$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.24,22.51l1.43-1.42A14.06,14.06,0,0,1,3.07,16C5.1,10.93,10.7,7,16,7a12.38,12.38,0,0,1,4,.72l1.55-1.56A14.72,14.72,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16,16,0,0,0,5.24,22.51Z"
    })), _path304$1 || (_path304$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.73a4 4 0 013.7-3.7l1.81-1.82a6 6 0 00-7.33 7.33zM30.94 15.66A16.4 16.4 0 0025.2 8.22L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.1A15.29 15.29 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM20 16a4 4 0 01-6 3.44L19.44 14A4 4 0 0120 16zm-4 9a13.05 13.05 0 01-6-1.58l2.54-2.54a6 6 0 008.35-8.35l2.87-2.87A14.54 14.54 0 0128.93 16C26.9 21.07 21.3 25 16 25z"
    })), children);
  });
  var ViewOff24 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOff24(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path305$1 || (_path305$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.24,22.51l1.43-1.42A14.06,14.06,0,0,1,3.07,16C5.1,10.93,10.7,7,16,7a12.38,12.38,0,0,1,4,.72l1.55-1.56A14.72,14.72,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16,16,0,0,0,5.24,22.51Z"
    })), _path306$1 || (_path306$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.73a4 4 0 013.7-3.7l1.81-1.82a6 6 0 00-7.33 7.33zM30.94 15.66A16.4 16.4 0 0025.2 8.22L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.1A15.29 15.29 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM20 16a4 4 0 01-6 3.44L19.44 14A4 4 0 0120 16zm-4 9a13.05 13.05 0 01-6-1.58l2.54-2.54a6 6 0 008.35-8.35l2.87-2.87A14.54 14.54 0 0128.93 16C26.9 21.07 21.3 25 16 25z"
    })), children);
  });
  var ViewOff20 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOff20(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path307$1 || (_path307$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.24,22.51l1.43-1.42A14.06,14.06,0,0,1,3.07,16C5.1,10.93,10.7,7,16,7a12.38,12.38,0,0,1,4,.72l1.55-1.56A14.72,14.72,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16,16,0,0,0,5.24,22.51Z"
    })), _path308$1 || (_path308$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12 15.73a4 4 0 013.7-3.7l1.81-1.82a6 6 0 00-7.33 7.33zM30.94 15.66A16.4 16.4 0 0025.2 8.22L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.1A15.29 15.29 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM20 16a4 4 0 01-6 3.44L19.44 14A4 4 0 0120 16zm-4 9a13.05 13.05 0 01-6-1.58l2.54-2.54a6 6 0 008.35-8.35l2.87-2.87A14.54 14.54 0 0128.93 16C26.9 21.07 21.3 25 16 25z"
    })), children);
  });
  var ViewOff16 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOff16(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309$1 || (_path309$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M2.6,11.3l0.7-0.7C2.6,9.8,1.9,9,1.5,8c1-2.5,3.8-4.5,6.5-4.5c0.7,0,1.4,0.1,2,0.4l0.8-0.8C9.9,2.7,9,2.5,8,2.5\tC4.7,2.6,1.7,4.7,0.5,7.8c0,0.1,0,0.2,0,0.3C1,9.3,1.7,10.4,2.6,11.3z"
    })), _path310$1 || (_path310$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6 7.9c.1-1 .9-1.8 1.8-1.8l.9-.9C7.2 4.7 5.5 5.6 5.1 7.2 5 7.7 5 8.3 5.1 8.8L6 7.9zM15.5 7.8c-.6-1.5-1.6-2.8-2.9-3.7L15 1.7 14.3 1 1 14.3 1.7 15l2.6-2.6c1.1.7 2.4 1 3.7 1.1 3.3-.1 6.3-2.2 7.5-5.3C15.5 8.1 15.5 7.9 15.5 7.8zM10 8c0 1.1-.9 2-2 2-.3 0-.7-.1-1-.3L9.7 7C9.9 7.3 10 7.6 10 8zM8 12.5c-1 0-2.1-.3-3-.8l1.3-1.3c1.4.9 3.2.6 4.2-.8.7-1 .7-2.4 0-3.4l1.4-1.4c1.1.8 2 1.9 2.6 3.2C13.4 10.5 10.6 12.5 8 12.5z"
    })), children);
  });
  var ViewOffFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOffFilled32(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path311$1 || (_path311$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94 15.66a16.4 16.4 0 00-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM16 22.5a6.46 6.46 0 01-3.83-1.26L14 19.43A4 4 0 0019.43 14l1.81-1.81A6.49 6.49 0 0116 22.5zM4.53 21.81l5-5A6.84 6.84 0 019.5 16 6.51 6.51 0 0116 9.5a6.84 6.84 0 01.79.05l3.78-3.77A14.39 14.39 0 0016 5 16.69 16.69 0 001.06 15.66a1 1 0 000 .68A15.86 15.86 0 004.53 21.81z"
    })), children);
  });
  var ViewOffFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOffFilled24(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312$1 || (_path312$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94 15.66a16.4 16.4 0 00-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM16 22.5a6.46 6.46 0 01-3.83-1.26L14 19.43A4 4 0 0019.43 14l1.81-1.81A6.49 6.49 0 0116 22.5zM4.53 21.81l5-5A6.84 6.84 0 019.5 16 6.51 6.51 0 0116 9.5a6.84 6.84 0 01.79.05l3.78-3.77A14.39 14.39 0 0016 5 16.69 16.69 0 001.06 15.66a1 1 0 000 .68A15.86 15.86 0 004.53 21.81z"
    })), children);
  });
  var ViewOffFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOffFilled20(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path313$1 || (_path313$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94 15.66a16.4 16.4 0 00-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM16 22.5a6.46 6.46 0 01-3.83-1.26L14 19.43A4 4 0 0019.43 14l1.81-1.81A6.49 6.49 0 0116 22.5zM4.53 21.81l5-5A6.84 6.84 0 019.5 16 6.51 6.51 0 0116 9.5a6.84 6.84 0 01.79.05l3.78-3.77A14.39 14.39 0 0016 5 16.69 16.69 0 001.06 15.66a1 1 0 000 .68A15.86 15.86 0 004.53 21.81z"
    })), children);
  });
  var ViewOffFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function ViewOffFilled16(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path314$1 || (_path314$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.94 15.66a16.4 16.4 0 00-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0016 27 16.69 16.69 0 0030.94 16.34 1 1 0 0030.94 15.66zM16 22.5a6.46 6.46 0 01-3.83-1.26L14 19.43A4 4 0 0019.43 14l1.81-1.81A6.49 6.49 0 0116 22.5zM4.53 21.81l5-5A6.84 6.84 0 019.5 16 6.51 6.51 0 0116 9.5a6.84 6.84 0 01.79.05l3.78-3.77A14.39 14.39 0 0016 5 16.69 16.69 0 001.06 15.66a1 1 0 000 .68A15.86 15.86 0 004.53 21.81z"
    })), children);
  });
  var ViewNext32 = /*#__PURE__*/React__default['default'].forwardRef(function ViewNext32(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315$1 || (_path315$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.587 22L15 16.41 15 7 16.998 7 16.998 15.582 22 20.587 20.587 22z"
    })), _path316$1 || (_path316$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var ViewNext24 = /*#__PURE__*/React__default['default'].forwardRef(function ViewNext24(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path317$1 || (_path317$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.587 22L15 16.41 15 7 16.998 7 16.998 15.582 22 20.587 20.587 22z"
    })), _path318$1 || (_path318$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var ViewNext20 = /*#__PURE__*/React__default['default'].forwardRef(function ViewNext20(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path319$1 || (_path319$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.587 22L15 16.41 15 7 16.998 7 16.998 15.582 22 20.587 20.587 22z"
    })), _path320$1 || (_path320$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var ViewNext16 = /*#__PURE__*/React__default['default'].forwardRef(function ViewNext16(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321$1 || (_path321$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20.587 22L15 16.41 15 7 16.998 7 16.998 15.582 22 20.587 20.587 22z"
    })), _path322$1 || (_path322$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A13.9158,13.9158,0,0,1,26,6.2343V2h2v8H20V8h4.9217A11.9818,11.9818,0,1,0,28,16h2A14,14,0,1,1,16,2Z"
    })), children);
  });
  var VirtualColumn32 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumn32(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323$1 || (_path323$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"
    })), _path324$1 || (_path324$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28H20a2.0023 2.0023 0 01-2-2V6a2.0023 2.0023 0 012-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28z"
    })), _path325$1 || (_path325$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"
    })), children);
  });
  var VirtualColumn24 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumn24(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path326$1 || (_path326$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"
    })), _path327$1 || (_path327$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28H20a2.0023 2.0023 0 01-2-2V6a2.0023 2.0023 0 012-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28z"
    })), _path328$1 || (_path328$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"
    })), children);
  });
  var VirtualColumn20 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumn20(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path329$1 || (_path329$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"
    })), _path330$1 || (_path330$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28H20a2.0023 2.0023 0 01-2-2V6a2.0023 2.0023 0 012-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28z"
    })), _path331$1 || (_path331$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"
    })), children);
  });
  var VirtualColumn16 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumn16(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path332$1 || (_path332$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"
    })), _path333$1 || (_path333$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 28H20a2.0023 2.0023 0 01-2-2V6a2.0023 2.0023 0 012-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 012 2V26A2.0023 2.0023 0 0112 28z"
    })), _path334$1 || (_path334$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"
    })), children);
  });
  var VirtualColumnKey32 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumnKey32(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle17$1 || (_circle17$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "9.5",
      r: "1.5"
    })), _path335$1 || (_path335$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"
    })), _path336$1 || (_path336$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"
    })), children);
  });
  var VirtualColumnKey24 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumnKey24(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle18$1 || (_circle18$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "9.5",
      r: "1.5"
    })), _path337$1 || (_path337$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"
    })), _path338$1 || (_path338$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"
    })), children);
  });
  var VirtualColumnKey20 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumnKey20(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle19$1 || (_circle19$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "9.5",
      r: "1.5"
    })), _path339$1 || (_path339$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"
    })), _path340$1 || (_path340$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"
    })), children);
  });
  var VirtualColumnKey16 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualColumnKey16(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle20$1 || (_circle20$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24.5",
      cy: "9.5",
      r: "1.5"
    })), _path341$1 || (_path341$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"
    })), _path342$1 || (_path342$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"
    })), children);
  });
  var VirtualDesktop32 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualDesktop32(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path343$1 || (_path343$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16H11a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h4v2H12v2h8V28H17V26h4a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,21,16ZM11,24V18H21l.0015,6Z"
    })), _path344$1 || (_path344$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9992,9.9992,0,0,0-19.6436,0A7.4914,7.4914,0,0,0,7,24.9746v-2a5.4945,5.4945,0,0,1,.123-10.9541l.8365-.0566.09-.834a7.9979,7.9979,0,0,1,15.9014,0l.09.834.8365.0566A5.4945,5.4945,0,0,1,25,22.9746v2a7.4914,7.4914,0,0,0,.8218-14.8506Z"
    })), children);
  });
  var VirtualDesktop24 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualDesktop24(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path345$1 || (_path345$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16H11a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h4v2H12v2h8V28H17V26h4a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,21,16ZM11,24V18H21l.0015,6Z"
    })), _path346$1 || (_path346$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9992,9.9992,0,0,0-19.6436,0A7.4914,7.4914,0,0,0,7,24.9746v-2a5.4945,5.4945,0,0,1,.123-10.9541l.8365-.0566.09-.834a7.9979,7.9979,0,0,1,15.9014,0l.09.834.8365.0566A5.4945,5.4945,0,0,1,25,22.9746v2a7.4914,7.4914,0,0,0,.8218-14.8506Z"
    })), children);
  });
  var VirtualDesktop20 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualDesktop20(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347$1 || (_path347$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16H11a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h4v2H12v2h8V28H17V26h4a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,21,16ZM11,24V18H21l.0015,6Z"
    })), _path348$1 || (_path348$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9992,9.9992,0,0,0-19.6436,0A7.4914,7.4914,0,0,0,7,24.9746v-2a5.4945,5.4945,0,0,1,.123-10.9541l.8365-.0566.09-.834a7.9979,7.9979,0,0,1,15.9014,0l.09.834.8365.0566A5.4945,5.4945,0,0,1,25,22.9746v2a7.4914,7.4914,0,0,0,.8218-14.8506Z"
    })), children);
  });
  var VirtualDesktop16 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualDesktop16(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path349$1 || (_path349$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,16H11a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2h4v2H12v2h8V28H17V26h4a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,21,16ZM11,24V18H21l.0015,6Z"
    })), _path350$1 || (_path350$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8218,10.124a9.9992,9.9992,0,0,0-19.6436,0A7.4914,7.4914,0,0,0,7,24.9746v-2a5.4945,5.4945,0,0,1,.123-10.9541l.8365-.0566.09-.834a7.9979,7.9979,0,0,1,15.9014,0l.09.834.8365.0566A5.4945,5.4945,0,0,1,25,22.9746v2a7.4914,7.4914,0,0,0,.8218-14.8506Z"
    })), children);
  });
  var VirtualMachine32 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualMachine32(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path351$1 || (_path351$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"
    })), _path352$1 || (_path352$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"
    })), children);
  });
  var VirtualMachine24 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualMachine24(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353$1 || (_path353$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"
    })), _path354$1 || (_path354$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"
    })), children);
  });
  var VirtualMachine20 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualMachine20(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path355$1 || (_path355$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"
    })), _path356$1 || (_path356$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"
    })), children);
  });
  var VirtualMachine16 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualMachine16(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path357$1 || (_path357$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"
    })), _path358$1 || (_path358$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"
    })), children);
  });
  var VirtualPrivateCloud32 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloud32(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359$1 || (_path359$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"
    })), _path360$1 || (_path360$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"
    })), children);
  });
  var VirtualPrivateCloud24 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloud24(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path361$1 || (_path361$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"
    })), _path362$1 || (_path362$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"
    })), children);
  });
  var VirtualPrivateCloud20 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloud20(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path363$1 || (_path363$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"
    })), _path364$1 || (_path364$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"
    })), children);
  });
  var VirtualPrivateCloud16 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloud16(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365$1 || (_path365$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"
    })), _path366$1 || (_path366$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"
    })), children);
  });
  var VirtualPrivateCloudAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloudAlt32(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367$1 || (_path367$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"
    })), _path368$1 || (_path368$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6a3.9915 3.9915 0 00-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0025 9.8579V19h2V9.8579A3.9962 3.9962 0 0030 6zM26 8a2 2 0 112-2A2.0023 2.0023 0 0126 8zM19 25H9.8579A3.9945 3.9945 0 007 22.1421V13H5v9.1421A3.9915 3.9915 0 109.8579 27H19zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var VirtualPrivateCloudAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloudAlt24(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369$1 || (_path369$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"
    })), _path370$1 || (_path370$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6a3.9915 3.9915 0 00-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0025 9.8579V19h2V9.8579A3.9962 3.9962 0 0030 6zM26 8a2 2 0 112-2A2.0023 2.0023 0 0126 8zM19 25H9.8579A3.9945 3.9945 0 007 22.1421V13H5v9.1421A3.9915 3.9915 0 109.8579 27H19zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var VirtualPrivateCloudAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloudAlt20(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path371$1 || (_path371$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"
    })), _path372$1 || (_path372$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6a3.9915 3.9915 0 00-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0025 9.8579V19h2V9.8579A3.9962 3.9962 0 0030 6zM26 8a2 2 0 112-2A2.0023 2.0023 0 0126 8zM19 25H9.8579A3.9945 3.9945 0 007 22.1421V13H5v9.1421A3.9915 3.9915 0 109.8579 27H19zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var VirtualPrivateCloudAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function VirtualPrivateCloudAlt16(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path373$1 || (_path373$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"
    })), _path374$1 || (_path374$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 6a3.9915 3.9915 0 00-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0025 9.8579V19h2V9.8579A3.9962 3.9962 0 0030 6zM26 8a2 2 0 112-2A2.0023 2.0023 0 0126 8zM19 25H9.8579A3.9945 3.9945 0 007 22.1421V13H5v9.1421A3.9915 3.9915 0 109.8579 27H19zM6 28a2 2 0 112-2A2.0023 2.0023 0 016 28z"
    })), children);
  });
  var VisualRecognition32 = /*#__PURE__*/React__default['default'].forwardRef(function VisualRecognition32(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21$1 || (_circle21$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path375$1 || (_path375$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"
    })), children);
  });
  var VisualRecognition24 = /*#__PURE__*/React__default['default'].forwardRef(function VisualRecognition24(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22$1 || (_circle22$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path376$1 || (_path376$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"
    })), children);
  });
  var VisualRecognition20 = /*#__PURE__*/React__default['default'].forwardRef(function VisualRecognition20(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle23$1 || (_circle23$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path377$1 || (_path377$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"
    })), children);
  });
  var VisualRecognition16 = /*#__PURE__*/React__default['default'].forwardRef(function VisualRecognition16(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle24$1 || (_circle24$1 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "23",
      cy: "12",
      r: "2"
    })), _path378$1 || (_path378$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"
    })), children);
  });
  var Vlan32 = /*#__PURE__*/React__default['default'].forwardRef(function Vlan32(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path379$1 || (_path379$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V15H17V11h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.0023,2.0023,0,0,0-2,2V9a2.0023,2.0023,0,0,0,2,2h2v4H2v2H8v4H6a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H10V17H22v4H20a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H24V17ZM13,4h6V9H13ZM12,28H6V23h6Zm14,0H20V23h6Z"
    })), children);
  });
  var Vlan24 = /*#__PURE__*/React__default['default'].forwardRef(function Vlan24(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path380$1 || (_path380$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V15H17V11h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.0023,2.0023,0,0,0-2,2V9a2.0023,2.0023,0,0,0,2,2h2v4H2v2H8v4H6a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H10V17H22v4H20a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H24V17ZM13,4h6V9H13ZM12,28H6V23h6Zm14,0H20V23h6Z"
    })), children);
  });
  var Vlan20 = /*#__PURE__*/React__default['default'].forwardRef(function Vlan20(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381$1 || (_path381$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V15H17V11h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.0023,2.0023,0,0,0-2,2V9a2.0023,2.0023,0,0,0,2,2h2v4H2v2H8v4H6a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H10V17H22v4H20a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H24V17ZM13,4h6V9H13ZM12,28H6V23h6Zm14,0H20V23h6Z"
    })), children);
  });
  var Vlan16 = /*#__PURE__*/React__default['default'].forwardRef(function Vlan16(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382$1 || (_path382$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,17V15H17V11h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.0023,2.0023,0,0,0-2,2V9a2.0023,2.0023,0,0,0,2,2h2v4H2v2H8v4H6a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H10V17H22v4H20a2.0023,2.0023,0,0,0-2,2v5a2.0023,2.0023,0,0,0,2,2h6a2.0023,2.0023,0,0,0,2-2V23a2.0023,2.0023,0,0,0-2-2H24V17ZM13,4h6V9H13ZM12,28H6V23h6Zm14,0H20V23h6Z"
    })), children);
  });
  var VlanIbm32 = /*#__PURE__*/React__default['default'].forwardRef(function VlanIbm32(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383$1 || (_path383$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 104 4A4.0045 4.0045 0 0016 22zm0 6a2 2 0 112-2A2.002 2.002 0 0116 28zM30 5a3 3 0 10-4 2.8154V15H17V9H15v6H6V7.8159a3.0007 3.0007 0 10-2 0V15a2.002 2.002 0 002 2h9v3h2V17h9a2.002 2.002 0 002-2V7.8159A2.9958 2.9958 0 0030 5zM5 4A1 1 0 114 5 1.0013 1.0013 0 015 4zM27 6a1 1 0 111-1A1.0013 1.0013 0 0127 6z"
    })), _circle25 || (_circle25 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "5",
      r: "2"
    })), children);
  });
  var VlanIbm24 = /*#__PURE__*/React__default['default'].forwardRef(function VlanIbm24(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384$1 || (_path384$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 104 4A4.0045 4.0045 0 0016 22zm0 6a2 2 0 112-2A2.002 2.002 0 0116 28zM30 5a3 3 0 10-4 2.8154V15H17V9H15v6H6V7.8159a3.0007 3.0007 0 10-2 0V15a2.002 2.002 0 002 2h9v3h2V17h9a2.002 2.002 0 002-2V7.8159A2.9958 2.9958 0 0030 5zM5 4A1 1 0 114 5 1.0013 1.0013 0 015 4zM27 6a1 1 0 111-1A1.0013 1.0013 0 0127 6z"
    })), _circle26 || (_circle26 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "5",
      r: "2"
    })), children);
  });
  var VlanIbm20 = /*#__PURE__*/React__default['default'].forwardRef(function VlanIbm20(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385$1 || (_path385$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 104 4A4.0045 4.0045 0 0016 22zm0 6a2 2 0 112-2A2.002 2.002 0 0116 28zM30 5a3 3 0 10-4 2.8154V15H17V9H15v6H6V7.8159a3.0007 3.0007 0 10-2 0V15a2.002 2.002 0 002 2h9v3h2V17h9a2.002 2.002 0 002-2V7.8159A2.9958 2.9958 0 0030 5zM5 4A1 1 0 114 5 1.0013 1.0013 0 015 4zM27 6a1 1 0 111-1A1.0013 1.0013 0 0127 6z"
    })), _circle27 || (_circle27 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "5",
      r: "2"
    })), children);
  });
  var VlanIbm16 = /*#__PURE__*/React__default['default'].forwardRef(function VlanIbm16(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path386$1 || (_path386$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 22a4 4 0 104 4A4.0045 4.0045 0 0016 22zm0 6a2 2 0 112-2A2.002 2.002 0 0116 28zM30 5a3 3 0 10-4 2.8154V15H17V9H15v6H6V7.8159a3.0007 3.0007 0 10-2 0V15a2.002 2.002 0 002 2h9v3h2V17h9a2.002 2.002 0 002-2V7.8159A2.9958 2.9958 0 0030 5zM5 4A1 1 0 114 5 1.0013 1.0013 0 015 4zM27 6a1 1 0 111-1A1.0013 1.0013 0 0127 6z"
    })), _circle28 || (_circle28 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "5",
      r: "2"
    })), children);
  });
  var VmdkDisk32 = /*#__PURE__*/React__default['default'].forwardRef(function VmdkDisk32(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle29 || (_circle29 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "24.5",
      r: "1.5"
    })), _path387$1 || (_path387$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5 14.964H21.5V20.035H19.5z",
      transform: "rotate(-45 20.5 17.5)"
    })), _circle30 || (_circle30 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "2"
    })), _path388$1 || (_path388$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"
    })), _path389$1 || (_path389$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"
    })), children);
  });
  var VmdkDisk24 = /*#__PURE__*/React__default['default'].forwardRef(function VmdkDisk24(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle31 || (_circle31 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "24.5",
      r: "1.5"
    })), _path390$1 || (_path390$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5 14.964H21.5V20.035H19.5z",
      transform: "rotate(-45 20.5 17.5)"
    })), _circle32 || (_circle32 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "2"
    })), _path391$1 || (_path391$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"
    })), _path392$1 || (_path392$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"
    })), children);
  });
  var VmdkDisk20 = /*#__PURE__*/React__default['default'].forwardRef(function VmdkDisk20(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle33 || (_circle33 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "24.5",
      r: "1.5"
    })), _path393$1 || (_path393$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5 14.964H21.5V20.035H19.5z",
      transform: "rotate(-45 20.5 17.5)"
    })), _circle34 || (_circle34 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "2"
    })), _path394$1 || (_path394$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"
    })), _path395$1 || (_path395$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"
    })), children);
  });
  var VmdkDisk16 = /*#__PURE__*/React__default['default'].forwardRef(function VmdkDisk16(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle35 || (_circle35 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "10.5",
      cy: "24.5",
      r: "1.5"
    })), _path396$1 || (_path396$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19.5 14.964H21.5V20.035H19.5z",
      transform: "rotate(-45 20.5 17.5)"
    })), _circle36 || (_circle36 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "13",
      r: "2"
    })), _path397$1 || (_path397$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"
    })), _path398$1 || (_path398$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"
    })), children);
  });

  var _path$1, _path2$1, _path3$1, _path4$1, _path5$1, _path6$1, _path7$1, _path8$1, _path9$1, _path10$1, _path11$1, _path12$1, _path13$1, _path14$1, _path15$1, _path16$1, _path17$1, _path18$1, _path19$1, _path20$1, _path21$1, _path22$1, _path23$1, _path24$1, _path25$1, _path26$1, _path27$1, _path28$1, _path29$1, _path30$1, _path31$1, _path32$1, _path33$1, _path34$1, _path35$1, _path36$1, _path37$1, _path38$1, _path39$1, _path40$1, _path41$1, _path42$1, _path43$1, _path44$1, _path45$1, _path46$1, _path47$1, _path48$1, _path49$1, _path50$1, _path51$1, _path52$1, _path53$1, _path54$1, _path55$1, _path56$1, _path57$1, _path58$1, _path59$1, _path60$1, _path61$1, _path62$1, _path63$1, _path64$1, _path65$1, _path66$1, _path67$1, _path68$1, _path69$1, _path70$1, _path71$1, _path72$1, _path73$1, _path74$1, _path75$1, _path76$1, _path77$1, _path78$1, _path79$1, _path80$1, _path81$1, _path82$1, _path83$1, _path84$1, _path85$1, _path86$1, _path87$1, _path88$1, _path89$1, _path90$1, _path91$1, _path92$1, _path93$1, _path94$1, _path95$1, _path96$1, _path97$1, _path98$1, _path99$1, _path100$1, _path101$1, _path102$1, _path103$1, _path104$1, _path105$1, _path106$1, _path107$1, _path108$1, _path109$1, _path110$1, _path111$1, _path112$1, _path113$1, _path114$1, _path115$1, _path116$1, _path117$1, _path118$1, _path119$1, _path120$1, _path121$1, _path122$1, _path123$1, _path124$1, _path125$1, _path126$1, _path127$1, _path128$1, _path129$1, _path130$1, _path131$1, _path132$1, _path133$1, _path134$1, _path135$1, _path136$1, _path137$1, _path138$1, _path139$1, _path140$1, _path141$1, _path142$1, _path143$1, _path144$1, _path145$1, _path146$1, _path147$1, _path148$1, _path149$1, _path150$1, _path151$1, _path152$1, _path153$1, _path154$1, _path155$1, _path156$1, _path157$1, _path158$1, _path159$1, _path160$1, _path161$1, _path162$1, _path163$1, _path164$1, _path165$1, _path166$1, _path167$1, _path168$1, _path169$1, _path170$1, _path171$1, _path172$1, _path173$1, _path174$1, _path175$1, _path176$1, _path177, _path178, _path179, _path180, _path181, _path182, _path183, _path184, _path185, _path186, _path187, _path188, _path189, _path190, _path191, _path192, _path193, _path194, _path195, _path196, _path197, _path198, _path199, _path200, _path201, _path202, _path203, _path204, _path205, _path206, _path207, _path208, _path209, _path210, _path211, _path212, _path213, _path214, _path215, _path216, _path217, _path218, _path219, _path220, _path221, _path222, _circle, _path223, _path224, _path225, _circle2, _path226, _path227, _path228, _circle3, _path229, _path230, _path231, _circle4, _path232, _path233, _path234, _path235, _path236, _path237, _path238, _path239, _path240, _path241, _path242, _path243, _path244, _path245, _path246, _path247, _path248, _path249, _path250, _path251, _path252, _path253, _path254, _path255, _path256, _path257, _path258, _path259, _path260, _path261, _path262, _path263, _path264, _path265, _path266, _path267, _path268, _path269, _path270, _path271, _path272, _path273, _path274, _path275, _path276, _path277, _path278, _path279, _path280, _path281, _path282, _path283, _path284, _circle5, _path285, _path286, _circle6, _path287, _path288, _circle7, _path289, _path290, _circle8, _path291, _path292, _path293, _path294, _path295, _path296, _circle9, _path297, _path298, _path299, _circle10, _path300, _path301, _path302, _circle11, _path303, _path304, _path305, _circle12, _path306, _path307, _path308, _path309, _circle13, _circle14, _path310, _path311, _path312, _circle15, _circle16, _path313, _path314, _path315, _circle17, _circle18, _path316, _path317, _path318, _circle19, _circle20, _path319, _path320, _path321, _path322, _path323, _path324, _path325, _path326, _path327, _path328, _circle21, _path329, _circle22, _path330, _circle23, _path331, _circle24, _path332, _path333, _path334, _path335, _path336, _path337, _path338, _path339, _path340, _path341, _path342, _path343, _path344, _path345, _path346, _path347, _path348, _path349, _path350, _path351, _path352, _path353, _path354, _path355, _path356, _path357, _path358, _path359, _path360, _path361, _path362, _path363, _path364, _path365, _path366, _path367, _path368, _path369, _path370, _path371, _path372, _path373, _path374, _path375, _path376, _path377, _path378, _path379, _path380, _path381, _path382, _path383, _path384, _path385, _path386, _path387, _path388, _path389, _path390, _path391, _path392, _path393, _path394, _path395, _path396, _path397, _path398, _path399, _path400, _path401, _path402, _path403, _path404, _path405, _path406, _path407, _path408, _path409, _path410, _path411, _path412, _path413, _path414, _path415, _path416, _path417, _path418, _path419, _path420, _path421, _path422, _path423, _path424, _path425, _path426, _path427, _path428, _path429, _path430, _path431, _path432, _path433, _path434, _path435, _path436, _path437, _path438, _path439, _path440, _path441, _path442, _path443, _path444, _path445, _path446, _path447, _path448, _path449, _path450, _path451, _path452, _path453, _path454, _path455, _path456, _path457, _path458, _path459, _path460, _path461, _path462, _path463, _path464, _path465, _path466, _path467, _path468, _path469, _path470, _path471, _path472, _path473, _path474, _path475, _path476, _path477, _path478, _path479, _path480, _path481, _path482, _path483, _path484, _path485, _path486, _path487, _path488, _path489, _path490, _path491, _path492, _path493, _path494, _path495, _path496, _path497, _path498, _path499, _path500, _path501, _path502, _path503, _path504, _path505, _path506, _path507, _path508, _path509, _path510, _path511, _path512, _path513, _path514, _path515, _path516, _path517, _path518, _path519, _path520, _path521, _path522, _path523, _path524, _path525, _path526, _path527, _path528, _path529, _path530, _path531, _path532, _path533, _path534, _path535, _path536, _path537, _path538, _path539, _path540;

  var _excluded$1 = ["children"],
      _excluded2$1 = ["children"],
      _excluded3$1 = ["children"],
      _excluded4$1 = ["children"],
      _excluded5$1 = ["children"],
      _excluded6$1 = ["children"],
      _excluded7$1 = ["children"],
      _excluded8$1 = ["children"],
      _excluded9$1 = ["children"],
      _excluded10$1 = ["children"],
      _excluded11$1 = ["children"],
      _excluded12$1 = ["children"],
      _excluded13$1 = ["children"],
      _excluded14$1 = ["children"],
      _excluded15$1 = ["children"],
      _excluded16$1 = ["children"],
      _excluded17$1 = ["children"],
      _excluded18$1 = ["children"],
      _excluded19$1 = ["children"],
      _excluded20$1 = ["children"],
      _excluded21$1 = ["children"],
      _excluded22$1 = ["children"],
      _excluded23$1 = ["children"],
      _excluded24$1 = ["children"],
      _excluded25$1 = ["children"],
      _excluded26$1 = ["children"],
      _excluded27$1 = ["children"],
      _excluded28$1 = ["children"],
      _excluded29$1 = ["children"],
      _excluded30$1 = ["children"],
      _excluded31$1 = ["children"],
      _excluded32$1 = ["children"],
      _excluded33$1 = ["children"],
      _excluded34$1 = ["children"],
      _excluded35$1 = ["children"],
      _excluded36$1 = ["children"],
      _excluded37$1 = ["children"],
      _excluded38$1 = ["children"],
      _excluded39$1 = ["children"],
      _excluded40$1 = ["children"],
      _excluded41$1 = ["children"],
      _excluded42$1 = ["children"],
      _excluded43$1 = ["children"],
      _excluded44$1 = ["children"],
      _excluded45$1 = ["children"],
      _excluded46$1 = ["children"],
      _excluded47$1 = ["children"],
      _excluded48$1 = ["children"],
      _excluded49$1 = ["children"],
      _excluded50$1 = ["children"],
      _excluded51$1 = ["children"],
      _excluded52$1 = ["children"],
      _excluded53$1 = ["children"],
      _excluded54$1 = ["children"],
      _excluded55$1 = ["children"],
      _excluded56$1 = ["children"],
      _excluded57$1 = ["children"],
      _excluded58$1 = ["children"],
      _excluded59$1 = ["children"],
      _excluded60$1 = ["children"],
      _excluded61$1 = ["children"],
      _excluded62$1 = ["children"],
      _excluded63$1 = ["children"],
      _excluded64$1 = ["children"],
      _excluded65$1 = ["children"],
      _excluded66$1 = ["children"],
      _excluded67$1 = ["children"],
      _excluded68$1 = ["children"],
      _excluded69$1 = ["children"],
      _excluded70$1 = ["children"],
      _excluded71$1 = ["children"],
      _excluded72$1 = ["children"],
      _excluded73$1 = ["children"],
      _excluded74$1 = ["children"],
      _excluded75$1 = ["children"],
      _excluded76$1 = ["children"],
      _excluded77$1 = ["children"],
      _excluded78$1 = ["children"],
      _excluded79$1 = ["children"],
      _excluded80$1 = ["children"],
      _excluded81$1 = ["children"],
      _excluded82$1 = ["children"],
      _excluded83$1 = ["children"],
      _excluded84$1 = ["children"],
      _excluded85$1 = ["children"],
      _excluded86$1 = ["children"],
      _excluded87$1 = ["children"],
      _excluded88$1 = ["children"],
      _excluded89$1 = ["children"],
      _excluded90$1 = ["children"],
      _excluded91$1 = ["children"],
      _excluded92$1 = ["children"],
      _excluded93$1 = ["children"],
      _excluded94$1 = ["children"],
      _excluded95$1 = ["children"],
      _excluded96$1 = ["children"],
      _excluded97$1 = ["children"],
      _excluded98$1 = ["children"],
      _excluded99$1 = ["children"],
      _excluded100$1 = ["children"],
      _excluded101$1 = ["children"],
      _excluded102$1 = ["children"],
      _excluded103$1 = ["children"],
      _excluded104$1 = ["children"],
      _excluded105$1 = ["children"],
      _excluded106$1 = ["children"],
      _excluded107$1 = ["children"],
      _excluded108$1 = ["children"],
      _excluded109$1 = ["children"],
      _excluded110$1 = ["children"],
      _excluded111$1 = ["children"],
      _excluded112$1 = ["children"],
      _excluded113$1 = ["children"],
      _excluded114$1 = ["children"],
      _excluded115$1 = ["children"],
      _excluded116$1 = ["children"],
      _excluded117$1 = ["children"],
      _excluded118$1 = ["children"],
      _excluded119 = ["children"],
      _excluded120 = ["children"],
      _excluded121 = ["children"],
      _excluded122 = ["children"],
      _excluded123 = ["children"],
      _excluded124 = ["children"],
      _excluded125 = ["children"],
      _excluded126 = ["children"],
      _excluded127 = ["children"],
      _excluded128 = ["children"],
      _excluded129 = ["children"],
      _excluded130 = ["children"],
      _excluded131 = ["children"],
      _excluded132 = ["children"],
      _excluded133 = ["children"],
      _excluded134 = ["children"],
      _excluded135 = ["children"],
      _excluded136 = ["children"],
      _excluded137 = ["children"],
      _excluded138 = ["children"],
      _excluded139 = ["children"],
      _excluded140 = ["children"],
      _excluded141 = ["children"],
      _excluded142 = ["children"],
      _excluded143 = ["children"],
      _excluded144 = ["children"],
      _excluded145 = ["children"],
      _excluded146 = ["children"],
      _excluded147 = ["children"],
      _excluded148 = ["children"],
      _excluded149 = ["children"],
      _excluded150 = ["children"],
      _excluded151 = ["children"],
      _excluded152 = ["children"],
      _excluded153 = ["children"],
      _excluded154 = ["children"],
      _excluded155 = ["children"],
      _excluded156 = ["children"],
      _excluded157 = ["children"],
      _excluded158 = ["children"],
      _excluded159 = ["children"],
      _excluded160 = ["children"],
      _excluded161 = ["children"],
      _excluded162 = ["children"],
      _excluded163 = ["children"],
      _excluded164 = ["children"],
      _excluded165 = ["children"],
      _excluded166 = ["children"],
      _excluded167 = ["children"],
      _excluded168 = ["children"],
      _excluded169 = ["children"],
      _excluded170 = ["children"],
      _excluded171 = ["children"],
      _excluded172 = ["children"],
      _excluded173 = ["children"],
      _excluded174 = ["children"],
      _excluded175 = ["children"],
      _excluded176 = ["children"],
      _excluded177 = ["children"],
      _excluded178 = ["children"],
      _excluded179 = ["children"],
      _excluded180 = ["children"],
      _excluded181 = ["children"],
      _excluded182 = ["children"],
      _excluded183 = ["children"],
      _excluded184 = ["children"],
      _excluded185 = ["children"],
      _excluded186 = ["children"],
      _excluded187 = ["children"],
      _excluded188 = ["children"],
      _excluded189 = ["children"],
      _excluded190 = ["children"],
      _excluded191 = ["children"],
      _excluded192 = ["children"],
      _excluded193 = ["children"],
      _excluded194 = ["children"],
      _excluded195 = ["children"],
      _excluded196 = ["children"],
      _excluded197 = ["children"],
      _excluded198 = ["children"],
      _excluded199 = ["children"],
      _excluded200 = ["children"],
      _excluded201 = ["children"],
      _excluded202 = ["children"],
      _excluded203 = ["children"],
      _excluded204 = ["children"],
      _excluded205 = ["children"],
      _excluded206 = ["children"],
      _excluded207 = ["children"],
      _excluded208 = ["children"],
      _excluded209 = ["children"],
      _excluded210 = ["children"],
      _excluded211 = ["children"],
      _excluded212 = ["children"],
      _excluded213 = ["children"],
      _excluded214 = ["children"],
      _excluded215 = ["children"],
      _excluded216 = ["children"],
      _excluded217 = ["children"],
      _excluded218 = ["children"],
      _excluded219 = ["children"],
      _excluded220 = ["children"],
      _excluded221 = ["children"],
      _excluded222 = ["children"],
      _excluded223 = ["children"],
      _excluded224 = ["children"],
      _excluded225 = ["children"],
      _excluded226 = ["children"],
      _excluded227 = ["children"],
      _excluded228 = ["children"],
      _excluded229 = ["children"],
      _excluded230 = ["children"],
      _excluded231 = ["children"],
      _excluded232 = ["children"],
      _excluded233 = ["children"],
      _excluded234 = ["children"],
      _excluded235 = ["children"],
      _excluded236 = ["children"],
      _excluded237 = ["children"],
      _excluded238 = ["children"],
      _excluded239 = ["children"],
      _excluded240 = ["children"],
      _excluded241 = ["children"],
      _excluded242 = ["children"],
      _excluded243 = ["children"],
      _excluded244 = ["children"],
      _excluded245 = ["children"],
      _excluded246 = ["children"],
      _excluded247 = ["children"],
      _excluded248 = ["children"],
      _excluded249 = ["children"],
      _excluded250 = ["children"];
  var VoiceActivate32 = /*#__PURE__*/React__default['default'].forwardRef(function VoiceActivate32(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path$1 || (_path$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _path2$1 || (_path2$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19zM9.3325 25.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537z"
    })), _path3$1 || (_path3$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994,28.8008a11.0019,11.0019,0,0,1,0-17.6006L7.6,12.8a9.0009,9.0009,0,0,0,0,14.4014Z"
    })), children);
  });
  var VoiceActivate24 = /*#__PURE__*/React__default['default'].forwardRef(function VoiceActivate24(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path4$1 || (_path4$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _path5$1 || (_path5$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19zM9.3325 25.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537z"
    })), _path6$1 || (_path6$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994,28.8008a11.0019,11.0019,0,0,1,0-17.6006L7.6,12.8a9.0009,9.0009,0,0,0,0,14.4014Z"
    })), children);
  });
  var VoiceActivate20 = /*#__PURE__*/React__default['default'].forwardRef(function VoiceActivate20(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path7$1 || (_path7$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _path8$1 || (_path8$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19zM9.3325 25.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537z"
    })), _path9$1 || (_path9$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994,28.8008a11.0019,11.0019,0,0,1,0-17.6006L7.6,12.8a9.0009,9.0009,0,0,0,0,14.4014Z"
    })), children);
  });
  var VoiceActivate16 = /*#__PURE__*/React__default['default'].forwardRef(function VoiceActivate16(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path10$1 || (_path10$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,30H24V27H20a5.0055,5.0055,0,0,1-5-5V20.7207l-2.3162-.772a1,1,0,0,1-.5412-1.4631L15,13.7229V11a9.01,9.01,0,0,1,9-9h5V4H24a7.0078,7.0078,0,0,0-7,7v3a.9991.9991,0,0,1-.1426.5144l-2.3586,3.9312,1.8174.6057A1,1,0,0,1,17,20v2a3.0033,3.0033,0,0,0,3,3h5a1,1,0,0,1,1,1Z"
    })), _path11$1 || (_path11$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M19 12H23V14H19zM9.3325 25.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537z"
    })), _path12$1 || (_path12$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994,28.8008a11.0019,11.0019,0,0,1,0-17.6006L7.6,12.8a9.0009,9.0009,0,0,0,0,14.4014Z"
    })), children);
  });
  var Voicemail32 = /*#__PURE__*/React__default['default'].forwardRef(function Voicemail32(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path13$1 || (_path13$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"
    })), children);
  });
  var Voicemail24 = /*#__PURE__*/React__default['default'].forwardRef(function Voicemail24(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14$1 || (_path14$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"
    })), children);
  });
  var Voicemail20 = /*#__PURE__*/React__default['default'].forwardRef(function Voicemail20(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path15$1 || (_path15$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"
    })), children);
  });
  var Voicemail16 = /*#__PURE__*/React__default['default'].forwardRef(function Voicemail16(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path16$1 || (_path16$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"
    })), children);
  });
  var VolumeBlockStorage32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeBlockStorage32(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17$1 || (_path17$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 21H10V14h7zm-5-2h3V16H12zM17 30H10V23h7zm-5-2h3V25H12zM26 21H19V14h7zm-5-2h3V16H21zM26 30H19V23h7zm-5-2h3V25H21z"
    })), _path18$1 || (_path18$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeBlockStorage24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeBlockStorage24(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19$1 || (_path19$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 21H10V14h7zm-5-2h3V16H12zM17 30H10V23h7zm-5-2h3V25H12zM26 21H19V14h7zm-5-2h3V16H21zM26 30H19V23h7zm-5-2h3V25H21z"
    })), _path20$1 || (_path20$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeBlockStorage20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeBlockStorage20(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21$1 || (_path21$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 21H10V14h7zm-5-2h3V16H12zM17 30H10V23h7zm-5-2h3V25H12zM26 21H19V14h7zm-5-2h3V16H21zM26 30H19V23h7zm-5-2h3V25H21z"
    })), _path22$1 || (_path22$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeBlockStorage16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeBlockStorage16(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23$1 || (_path23$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17 21H10V14h7zm-5-2h3V16H12zM17 30H10V23h7zm-5-2h3V25H12zM26 21H19V14h7zm-5-2h3V16H21zM26 30H19V23h7zm-5-2h3V25H21z"
    })), _path24$1 || (_path24$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeDown32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDown32(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25$1 || (_path25$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30zM6 20h6a1.17 1.17 0 01.79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0112 12H6z"
    })), children);
  });
  var VolumeDown24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDown24(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path26$1 || (_path26$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30zM6 20h6a1.17 1.17 0 01.79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0112 12H6z"
    })), children);
  });
  var VolumeDown20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDown20(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path27$1 || (_path27$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30zM6 20h6a1.17 1.17 0 01.79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0112 12H6z"
    })), children);
  });
  var VolumeDown16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDown16(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28$1 || (_path28$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30zM6 20h6a1.17 1.17 0 01.79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0112 12H6z"
    })), children);
  });
  var VolumeDownAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownAlt32(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path29$1 || (_path29$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeDownAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownAlt24(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path30$1 || (_path30$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeDownAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownAlt20(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31$1 || (_path31$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeDownAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownAlt16(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path32$1 || (_path32$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeDownFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilled32(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path33$1 || (_path33$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30z"
    })), children);
  });
  var VolumeDownFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilled24(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34$1 || (_path34$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30z"
    })), children);
  });
  var VolumeDownFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilled20(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path35$1 || (_path35$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30z"
    })), children);
  });
  var VolumeDownFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilled16(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path36$1 || (_path36$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.1 10.66L23.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM20 30a1 1 0 01-.71-.3L11.67 22H5a1 1 0 01-1-1H4V11a1 1 0 011-1h6.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0121 3V29A1 1 0 0120 30z"
    })), children);
  });
  var VolumeDownFilledAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilledAlt32(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37$1 || (_path37$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeDownFilledAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilledAlt24(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38$1 || (_path38$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeDownFilledAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilledAlt20(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39$1 || (_path39$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeDownFilledAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeDownFilledAlt16(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40$1 || (_path40$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 15H32V17H22zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeFileStorage32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeFileStorage32(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41$1 || (_path41$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,17.293l-5-5A1,1,0,0,0,20,12H14a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V18A1,1,0,0,0,25.707,17.293ZM23.5857,18H20V14.4141ZM14,28V14h4v4a2,2,0,0,0,2,2h4v8Z"
    })), _path42$1 || (_path42$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,27H4a2.0023,2.0023,0,0,1-2-2V5A2.0023,2.0023,0,0,1,4,3h7.5857A1.9865,1.9865,0,0,1,13,3.5859L16.4143,7H28a2.0023,2.0023,0,0,1,2,2v8H28V9H15.5857l-4-4H4V25H8Z"
    })), children);
  });
  var VolumeFileStorage24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeFileStorage24(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43$1 || (_path43$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,17.293l-5-5A1,1,0,0,0,20,12H14a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V18A1,1,0,0,0,25.707,17.293ZM23.5857,18H20V14.4141ZM14,28V14h4v4a2,2,0,0,0,2,2h4v8Z"
    })), _path44$1 || (_path44$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,27H4a2.0023,2.0023,0,0,1-2-2V5A2.0023,2.0023,0,0,1,4,3h7.5857A1.9865,1.9865,0,0,1,13,3.5859L16.4143,7H28a2.0023,2.0023,0,0,1,2,2v8H28V9H15.5857l-4-4H4V25H8Z"
    })), children);
  });
  var VolumeFileStorage20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeFileStorage20(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45$1 || (_path45$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,17.293l-5-5A1,1,0,0,0,20,12H14a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V18A1,1,0,0,0,25.707,17.293ZM23.5857,18H20V14.4141ZM14,28V14h4v4a2,2,0,0,0,2,2h4v8Z"
    })), _path46$1 || (_path46$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,27H4a2.0023,2.0023,0,0,1-2-2V5A2.0023,2.0023,0,0,1,4,3h7.5857A1.9865,1.9865,0,0,1,13,3.5859L16.4143,7H28a2.0023,2.0023,0,0,1,2,2v8H28V9H15.5857l-4-4H4V25H8Z"
    })), children);
  });
  var VolumeFileStorage16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeFileStorage16(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47$1 || (_path47$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25.707,17.293l-5-5A1,1,0,0,0,20,12H14a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V18A1,1,0,0,0,25.707,17.293ZM23.5857,18H20V14.4141ZM14,28V14h4v4a2,2,0,0,0,2,2h4v8Z"
    })), _path48$1 || (_path48$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,27H4a2.0023,2.0023,0,0,1-2-2V5A2.0023,2.0023,0,0,1,4,3h7.5857A1.9865,1.9865,0,0,1,13,3.5859L16.4143,7H28a2.0023,2.0023,0,0,1,2,2v8H28V9H15.5857l-4-4H4V25H8Z"
    })), children);
  });
  var VolumeMute32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMute32(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49$1 || (_path49$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6a1.17 1.17 0 01.79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0110 12H4z"
    })), children);
  });
  var VolumeMute24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMute24(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50$1 || (_path50$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6a1.17 1.17 0 01.79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0110 12H4z"
    })), children);
  });
  var VolumeMute20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMute20(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51$1 || (_path51$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6a1.17 1.17 0 01.79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0110 12H4z"
    })), children);
  });
  var VolumeMute16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMute16(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52$1 || (_path52$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6a1.17 1.17 0 01.79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0110 12H4z"
    })), children);
  });
  var VolumeMuteFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMuteFilled32(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53$1 || (_path53$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeMuteFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMuteFilled24(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54$1 || (_path54$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeMuteFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMuteFilled20(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55$1 || (_path55$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeMuteFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeMuteFilled16(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56$1 || (_path56$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeObjectStorage32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeObjectStorage32(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57$1 || (_path57$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24a2.98,2.98,0,0,0-2.0376.8115l-4.0037-2.4023a2.0478,2.0478,0,0,0,0-.8184l4.0037-2.4023a3.2463,3.2463,0,1,0-.9211-1.7793l-4.0037,2.4023a3,3,0,1,0,0,4.377l4.0037,2.4023A2.9729,2.9729,0,0,0,20,27a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0008,1.0008,0,0,1,23,16Zm-9,7a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,14,23Zm9,5a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,23,28Z"
    })), _path58$1 || (_path58$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeObjectStorage24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeObjectStorage24(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path59$1 || (_path59$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24a2.98,2.98,0,0,0-2.0376.8115l-4.0037-2.4023a2.0478,2.0478,0,0,0,0-.8184l4.0037-2.4023a3.2463,3.2463,0,1,0-.9211-1.7793l-4.0037,2.4023a3,3,0,1,0,0,4.377l4.0037,2.4023A2.9729,2.9729,0,0,0,20,27a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0008,1.0008,0,0,1,23,16Zm-9,7a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,14,23Zm9,5a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,23,28Z"
    })), _path60$1 || (_path60$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeObjectStorage20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeObjectStorage20(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path61$1 || (_path61$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24a2.98,2.98,0,0,0-2.0376.8115l-4.0037-2.4023a2.0478,2.0478,0,0,0,0-.8184l4.0037-2.4023a3.2463,3.2463,0,1,0-.9211-1.7793l-4.0037,2.4023a3,3,0,1,0,0,4.377l4.0037,2.4023A2.9729,2.9729,0,0,0,20,27a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0008,1.0008,0,0,1,23,16Zm-9,7a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,14,23Zm9,5a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,23,28Z"
    })), _path62$1 || (_path62$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeObjectStorage16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeObjectStorage16(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63$1 || (_path63$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,24a2.98,2.98,0,0,0-2.0376.8115l-4.0037-2.4023a2.0478,2.0478,0,0,0,0-.8184l4.0037-2.4023a3.2463,3.2463,0,1,0-.9211-1.7793l-4.0037,2.4023a3,3,0,1,0,0,4.377l4.0037,2.4023A2.9729,2.9729,0,0,0,20,27a3,3,0,1,0,3-3Zm0-8a1,1,0,1,1-1,1A1.0008,1.0008,0,0,1,23,16Zm-9,7a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,14,23Zm9,5a1,1,0,1,1,1-1A1.0008,1.0008,0,0,1,23,28Z"
    })), _path64$1 || (_path64$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,28H4a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,4,4h7.5857A1.9865,1.9865,0,0,1,13,4.5859L16.4143,8H28a2.0023,2.0023,0,0,1,2,2v8H28V10H15.5857l-4-4H4V26H8Z"
    })), children);
  });
  var VolumeUp32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUp32(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path65$1 || (_path65$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path66$1 || (_path66$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6.08a1 1 0 01.71.3L17 26.57V5.43L10.79 11.7a1 1 0 01-.71.3H4z"
    })), children);
  });
  var VolumeUp24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUp24(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path67$1 || (_path67$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path68$1 || (_path68$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6.08a1 1 0 01.71.3L17 26.57V5.43L10.79 11.7a1 1 0 01-.71.3H4z"
    })), children);
  });
  var VolumeUp20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUp20(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69$1 || (_path69$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path70$1 || (_path70$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6.08a1 1 0 01.71.3L17 26.57V5.43L10.79 11.7a1 1 0 01-.71.3H4z"
    })), children);
  });
  var VolumeUp16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUp16(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71$1 || (_path71$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path72$1 || (_path72$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30zM4 20h6.08a1 1 0 01.71.3L17 26.57V5.43L10.79 11.7a1 1 0 01-.71.3H4z"
    })), children);
  });
  var VolumeUpAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpAlt32(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73$1 || (_path73$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeUpAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpAlt24(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74$1 || (_path74$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeUpAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpAlt20(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75$1 || (_path75$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeUpAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpAlt16(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76$1 || (_path76$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30zM4 20h6a1.2008 1.2008 0 01.7939.2969L17 26.5684V5.4316l-6.2061 6.2715A1.2013 1.2013 0 0110 12H4z"
    })), children);
  });
  var VolumeUpFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilled32(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77$1 || (_path77$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path78$1 || (_path78$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeUpFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilled24(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79$1 || (_path79$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path80$1 || (_path80$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeUpFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilled20(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81$1 || (_path81$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path82$1 || (_path82$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeUpFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilled16(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83$1 || (_path83$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"
    })), _path84$1 || (_path84$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.58 12a6 6 0 01-.18 7.94l1.47 1.36a8 8 0 00.23-10.59zM18 30a1 1 0 01-.71-.3L9.67 22H3a1 1 0 01-1-1H2V11a1 1 0 011-1H9.67l7.62-7.7a1 1 0 011.41 0A1 1 0 0119 3V29A1 1 0 0118 30z"
    })), children);
  });
  var VolumeUpFilledAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilledAlt32(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85$1 || (_path85$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeUpFilledAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilledAlt24(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86$1 || (_path86$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeUpFilledAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilledAlt20(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87$1 || (_path87$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var VolumeUpFilledAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function VolumeUpFilledAlt16(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88$1 || (_path88$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M32 15L28 15 28 11 26 11 26 15 22 15 22 17 26 17 26 21 28 21 28 17 32 17 32 15zM18 30a.997.997 0 01-.7109-.2969L9.666 22H3a.9993.9993 0 01-1-.9988V11a.9993.9993 0 01.9988-1H9.666l7.623-7.7031A1 1 0 0119 3V29A1.0007 1.0007 0 0118 30z"
    })), children);
  });
  var Vpn32 = /*#__PURE__*/React__default['default'].forwardRef(function Vpn32(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89$1 || (_path89$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"
    })), children);
  });
  var Vpn24 = /*#__PURE__*/React__default['default'].forwardRef(function Vpn24(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90$1 || (_path90$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"
    })), children);
  });
  var Vpn20 = /*#__PURE__*/React__default['default'].forwardRef(function Vpn20(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91$1 || (_path91$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"
    })), children);
  });
  var Vpn16 = /*#__PURE__*/React__default['default'].forwardRef(function Vpn16(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92$1 || (_path92$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14 23H12V9h6a2 2 0 012 2v5a2 2 0 01-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"
    })), children);
  });
  var VpnConnection32 = /*#__PURE__*/React__default['default'].forwardRef(function VpnConnection32(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93$1 || (_path93$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7a1.9919,1.9919,0,0,0-1.7227,1H22A6,6,0,0,0,10,8H5.7227a2,2,0,1,0,0,2H10v4H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16a2,2,0,0,0-2-2H22V10h4.2773A1.9966,1.9966,0,1,0,28,7ZM12,8a4,4,0,0,1,8,0v6H12V10h5V8Zm12,8V28H8V16Z"
    })), children);
  });
  var VpnConnection24 = /*#__PURE__*/React__default['default'].forwardRef(function VpnConnection24(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94$1 || (_path94$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7a1.9919,1.9919,0,0,0-1.7227,1H22A6,6,0,0,0,10,8H5.7227a2,2,0,1,0,0,2H10v4H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16a2,2,0,0,0-2-2H22V10h4.2773A1.9966,1.9966,0,1,0,28,7ZM12,8a4,4,0,0,1,8,0v6H12V10h5V8Zm12,8V28H8V16Z"
    })), children);
  });
  var VpnConnection20 = /*#__PURE__*/React__default['default'].forwardRef(function VpnConnection20(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95$1 || (_path95$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7a1.9919,1.9919,0,0,0-1.7227,1H22A6,6,0,0,0,10,8H5.7227a2,2,0,1,0,0,2H10v4H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16a2,2,0,0,0-2-2H22V10h4.2773A1.9966,1.9966,0,1,0,28,7ZM12,8a4,4,0,0,1,8,0v6H12V10h5V8Zm12,8V28H8V16Z"
    })), children);
  });
  var VpnConnection16 = /*#__PURE__*/React__default['default'].forwardRef(function VpnConnection16(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96$1 || (_path96$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,7a1.9919,1.9919,0,0,0-1.7227,1H22A6,6,0,0,0,10,8H5.7227a2,2,0,1,0,0,2H10v4H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16a2,2,0,0,0-2-2H22V10h4.2773A1.9966,1.9966,0,1,0,28,7ZM12,8a4,4,0,0,1,8,0v6H12V10h5V8Zm12,8V28H8V16Z"
    })), children);
  });
  var VpnPolicy32 = /*#__PURE__*/React__default['default'].forwardRef(function VpnPolicy32(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97$1 || (_path97$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15A6,6,0,1,0,20,19.46V29l4-1.8838L28,29V19.46A5.98,5.98,0,0,0,30,15ZM26,25.8477l-2-.9415-2,.9415V20.65a5.8877,5.8877,0,0,0,4,0ZM24,19a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,19Z"
    })), _path98$1 || (_path98$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2A6.0066,6.0066,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H17V28H6V16h9V14H10V8a4,4,0,0,1,7.92-.8008l1.96-.3984A6.0167,6.0167,0,0,0,14,2Z"
    })), children);
  });
  var VpnPolicy24 = /*#__PURE__*/React__default['default'].forwardRef(function VpnPolicy24(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99$1 || (_path99$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15A6,6,0,1,0,20,19.46V29l4-1.8838L28,29V19.46A5.98,5.98,0,0,0,30,15ZM26,25.8477l-2-.9415-2,.9415V20.65a5.8877,5.8877,0,0,0,4,0ZM24,19a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,19Z"
    })), _path100$1 || (_path100$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2A6.0066,6.0066,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H17V28H6V16h9V14H10V8a4,4,0,0,1,7.92-.8008l1.96-.3984A6.0167,6.0167,0,0,0,14,2Z"
    })), children);
  });
  var VpnPolicy20 = /*#__PURE__*/React__default['default'].forwardRef(function VpnPolicy20(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101$1 || (_path101$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15A6,6,0,1,0,20,19.46V29l4-1.8838L28,29V19.46A5.98,5.98,0,0,0,30,15ZM26,25.8477l-2-.9415-2,.9415V20.65a5.8877,5.8877,0,0,0,4,0ZM24,19a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,19Z"
    })), _path102$1 || (_path102$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2A6.0066,6.0066,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H17V28H6V16h9V14H10V8a4,4,0,0,1,7.92-.8008l1.96-.3984A6.0167,6.0167,0,0,0,14,2Z"
    })), children);
  });
  var VpnPolicy16 = /*#__PURE__*/React__default['default'].forwardRef(function VpnPolicy16(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103$1 || (_path103$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,15A6,6,0,1,0,20,19.46V29l4-1.8838L28,29V19.46A5.98,5.98,0,0,0,30,15ZM26,25.8477l-2-.9415-2,.9415V20.65a5.8877,5.8877,0,0,0,4,0ZM24,19a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,24,19Z"
    })), _path104$1 || (_path104$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,2A6.0066,6.0066,0,0,0,8,8v6H6a2.0023,2.0023,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H17V28H6V16h9V14H10V8a4,4,0,0,1,7.92-.8008l1.96-.3984A6.0167,6.0167,0,0,0,14,2Z"
    })), children);
  });
  var Wallet32 = /*#__PURE__*/React__default['default'].forwardRef(function Wallet32(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105$1 || (_path105$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 17H24V19H22z"
    })), _path106$1 || (_path106$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"
    })), children);
  });
  var Wallet24 = /*#__PURE__*/React__default['default'].forwardRef(function Wallet24(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107$1 || (_path107$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 17H24V19H22z"
    })), _path108$1 || (_path108$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"
    })), children);
  });
  var Wallet20 = /*#__PURE__*/React__default['default'].forwardRef(function Wallet20(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109$1 || (_path109$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 17H24V19H22z"
    })), _path110$1 || (_path110$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"
    })), children);
  });
  var Wallet16 = /*#__PURE__*/React__default['default'].forwardRef(function Wallet16(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111$1 || (_path111$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 17H24V19H22z"
    })), _path112$1 || (_path112$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"
    })), children);
  });
  var Warning32 = /*#__PURE__*/React__default['default'].forwardRef(function Warning32(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113$1 || (_path113$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path114$1 || (_path114$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V19H15zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22z"
    })), children);
  });
  var Warning24 = /*#__PURE__*/React__default['default'].forwardRef(function Warning24(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115$1 || (_path115$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path116$1 || (_path116$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V19H15zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22z"
    })), children);
  });
  var Warning20 = /*#__PURE__*/React__default['default'].forwardRef(function Warning20(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117$1 || (_path117$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"
    })), _path118$1 || (_path118$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 8H17V19H15zM16 22a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 22z"
    })), children);
  });
  var Warning16 = /*#__PURE__*/React__default['default'].forwardRef(function Warning16(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119$1 || (_path119$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"
    })), _path120$1 || (_path120$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 4H8.5V9H7.5zM8 10.2c-.4 0-.8.3-.8.8s.3.8.8.8c.4 0 .8-.3.8-.8S8.4 10.2 8 10.2z"
    })), children);
  });
  var WarningAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAlt32(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121$1 || (_path121$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 23zM15 12H17V21H15z"
    })), _path122$1 || (_path122$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAlt24(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123$1 || (_path123$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 23zM15 12H17V21H15z"
    })), _path124$1 || (_path124$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAlt20(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125$1 || (_path125$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 23a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 23zM15 12H17V21H15z"
    })), _path126$1 || (_path126$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAlt16(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127$1 || (_path127$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14.5,14h-13c-0.2,0-0.3-0.1-0.4-0.2c-0.1-0.2-0.1-0.3,0-0.5l6.5-12C7.7,1,8,0.9,8.2,1.1c0.1,0,0.2,0.1,0.2,0.2l6.5,12\tc0.1,0.2,0.1,0.3,0,0.5C14.9,13.9,14.7,14,14.5,14z M2.3,13h11.3L8,2.5L2.3,13z"
    })), _path128$1 || (_path128$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5 6H8.5V9.5H7.5zM8 10.8c-.4 0-.8.3-.8.8s.3.8.8.8c.4 0 .8-.3.8-.8S8.4 10.8 8 10.8z"
    })), children);
  });
  var WarningAltFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltFilled32(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129$1 || (_path129$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Zm-1.125-5h2.25V12h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path130$1 || (_path130$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.002,6.1714h-.004L4.6487,27.9966,4.6506,28H27.3494l.0019-.0034ZM14.875,12h2.25v9h-2.25ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"
    })), _path131$1 || (_path131$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAltFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltFilled24(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path132$1 || (_path132$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Zm-1.125-5h2.25V12h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path133$1 || (_path133$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.002,6.1714h-.004L4.6487,27.9966,4.6506,28H27.3494l.0019-.0034ZM14.875,12h2.25v9h-2.25ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"
    })), _path134$1 || (_path134$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAltFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltFilled20(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135$1 || (_path135$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Zm-1.125-5h2.25V12h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path136$1 || (_path136$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.002,6.1714h-.004L4.6487,27.9966,4.6506,28H27.3494l.0019-.0034ZM14.875,12h2.25v9h-2.25ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"
    })), _path137$1 || (_path137$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAltFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltFilled16(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path138$1 || (_path138$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Zm-1.125-5h2.25V12h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path139$1 || (_path139$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16.002,6.1714h-.004L4.6487,27.9966,4.6506,28H27.3494l.0019-.0034ZM14.875,12h2.25v9h-2.25ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"
    })), _path140$1 || (_path140$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29,30H3a1,1,0,0,1-.8872-1.4614l13-25a1,1,0,0,1,1.7744,0l13,25A1,1,0,0,1,29,30ZM4.6507,28H27.3493l.002-.0033L16.002,6.1714h-.004L4.6487,27.9967Z"
    })), children);
  });
  var WarningAltInverted32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInverted32(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141$1 || (_path141$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 17zM15 6H17V15H15z"
    })), _path142$1 || (_path142$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInverted24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInverted24(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143$1 || (_path143$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 17zM15 6H17V15H15z"
    })), _path144$1 || (_path144$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInverted20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInverted20(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145$1 || (_path145$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 17zM15 6H17V15H15z"
    })), _path146$1 || (_path146$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInverted16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInverted16(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147$1 || (_path147$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 17zM15 6H17V15H15z"
    })), _path148$1 || (_path148$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInvertedFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInvertedFilled32(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149$1 || (_path149$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Zm-1.125-5h2.25V6h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path150$1 || (_path150$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3494,4H4.6506l-.0019.0034L15.998,25.8286h.004L27.3513,4.0034ZM14.875,6h2.25v9h-2.25ZM16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Z"
    })), _path151$1 || (_path151$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInvertedFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInvertedFilled24(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path152$1 || (_path152$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Zm-1.125-5h2.25V6h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path153$1 || (_path153$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3494,4H4.6506l-.0019.0034L15.998,25.8286h.004L27.3513,4.0034ZM14.875,6h2.25v9h-2.25ZM16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Z"
    })), _path154$1 || (_path154$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInvertedFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInvertedFilled20(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155$1 || (_path155$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Zm-1.125-5h2.25V6h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path156$1 || (_path156$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3494,4H4.6506l-.0019.0034L15.998,25.8286h.004L27.3513,4.0034ZM14.875,6h2.25v9h-2.25ZM16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Z"
    })), _path157$1 || (_path157$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningAltInvertedFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningAltInvertedFilled16(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path158$1 || (_path158$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Zm-1.125-5h2.25V6h-2.25Z",
      "data-icon-path": "inner-path"
    })), _path159$1 || (_path159$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.3494,4H4.6506l-.0019.0034L15.998,25.8286h.004L27.3513,4.0034ZM14.875,6h2.25v9h-2.25ZM16,20a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,20Z"
    })), _path160$1 || (_path160$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.855,2.481a1.001,1.001,0,0,1,.0322.98l-13,25a1,1,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1.0007,1.0007,0,0,1,29.855,2.481ZM4.6487,4.0033,15.998,25.8286h.004L27.3513,4.0033,27.3493,4H4.6507Z"
    })), children);
  });
  var WarningFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningFilled32(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161$1 || (_path161$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14C30,8.3,23.7,2,16,2z M14.9,8h2.2v11h-2.2V8z M16,25\tc-0.8,0-1.5-0.7-1.5-1.5S15.2,22,16,22c0.8,0,1.5,0.7,1.5,1.5S16.8,25,16,25z"
    })), _path162$1 || (_path162$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M17.5,23.5c0,0.8-0.7,1.5-1.5,1.5c-0.8,0-1.5-0.7-1.5-1.5S15.2,22,16,22\tC16.8,22,17.5,22.7,17.5,23.5z M17.1,8h-2.2v11h2.2V8z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var WarningFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningFilled24(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 24 24",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163$1 || (_path163$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M12,1C5.9,1,1,5.9,1,12s4.9,11,11,11s11-4.9,11-11C23,5.9,18.1,1,12,1z M11.1,6h1.8v8h-1.8V6z M12,19.2\tc-0.7,0-1.2-0.6-1.2-1.2s0.6-1.2,1.2-1.2s1.2,0.6,1.2,1.2S12.7,19.2,12,19.2z"
    })), _path164$1 || (_path164$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M13.2,18c0,0.7-0.6,1.2-1.2,1.2s-1.2-0.6-1.2-1.2s0.6-1.2,1.2-1.2S13.2,17.3,13.2,18z M12.9,6\th-1.8v8h1.8V6z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var WarningFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningFilled20(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 20 20",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165$1 || (_path165$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10,1c-5,0-9,4-9,9s4,9,9,9s9-4,9-9S15,1,10,1z M9.2,5h1.5v7H9.2V5z M10,16c-0.6,0-1-0.4-1-1s0.4-1,1-1\ts1,0.4,1,1S10.6,16,10,16z"
    })), _path166$1 || (_path166$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.2,5h1.5v7H9.2V5z M10,16c-0.6,0-1-0.4-1-1s0.4-1,1-1s1,0.4,1,1S10.6,16,10,16z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var WarningFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningFilled16(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167$1 || (_path167$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,1C4.2,1,1,4.2,1,8s3.2,7,7,7s7-3.1,7-7S11.9,1,8,1z M7.5,4h1v5h-1C7.5,9,7.5,4,7.5,4z M8,12.2\tc-0.4,0-0.8-0.4-0.8-0.8s0.3-0.8,0.8-0.8c0.4,0,0.8,0.4,0.8,0.8S8.4,12.2,8,12.2z"
    })), _path168$1 || (_path168$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.5,4h1v5h-1C7.5,9,7.5,4,7.5,4z M8,12.2c-0.4,0-0.8-0.4-0.8-0.8s0.3-0.8,0.8-0.8\tc0.4,0,0.8,0.4,0.8,0.8S8.4,12.2,8,12.2z",
      "data-icon-path": "inner-path",
      opacity: "0"
    })), children);
  });
  var WarningHex32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHex32(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169$1 || (_path169$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 21a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 21zM15 8H17V18H15z"
    })), _path170$1 || (_path170$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,29H9a1,1,0,0,1-.8638-.4961l-7-12a1,1,0,0,1,0-1.0078l7-12A1,1,0,0,1,9,3H23a1,1,0,0,1,.8638.4961l7,12a1,1,0,0,1,0,1.0078l-7,12A1,1,0,0,1,23,29ZM9.5742,27H22.4258l6.4165-11L22.4258,5H9.5742L3.1577,16Z"
    })), children);
  });
  var WarningHex24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHex24(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171$1 || (_path171$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 21a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 21zM15 8H17V18H15z"
    })), _path172$1 || (_path172$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,29H9a1,1,0,0,1-.8638-.4961l-7-12a1,1,0,0,1,0-1.0078l7-12A1,1,0,0,1,9,3H23a1,1,0,0,1,.8638.4961l7,12a1,1,0,0,1,0,1.0078l-7,12A1,1,0,0,1,23,29ZM9.5742,27H22.4258l6.4165-11L22.4258,5H9.5742L3.1577,16Z"
    })), children);
  });
  var WarningHex20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHex20(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173$1 || (_path173$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 21a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 21zM15 8H17V18H15z"
    })), _path174$1 || (_path174$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,29H9a1,1,0,0,1-.8638-.4961l-7-12a1,1,0,0,1,0-1.0078l7-12A1,1,0,0,1,9,3H23a1,1,0,0,1,.8638.4961l7,12a1,1,0,0,1,0,1.0078l-7,12A1,1,0,0,1,23,29ZM9.5742,27H22.4258l6.4165-11L22.4258,5H9.5742L3.1577,16Z"
    })), children);
  });
  var WarningHex16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHex16(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175$1 || (_path175$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 21a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 21zM15 8H17V18H15z"
    })), _path176$1 || (_path176$1 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,29H9a1,1,0,0,1-.8638-.4961l-7-12a1,1,0,0,1,0-1.0078l7-12A1,1,0,0,1,9,3H23a1,1,0,0,1,.8638.4961l7,12a1,1,0,0,1,0,1.0078l-7,12A1,1,0,0,1,23,29ZM9.5742,27H22.4258l6.4165-11L22.4258,5H9.5742L3.1577,16Z"
    })), children);
  });
  var WarningHexFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHexFilled32(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path177 || (_path177 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z",
      "data-icon-path": "inner-path"
    })), _path178 || (_path178 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8508,15.4487,23.8867,3.5322A1.0687,1.0687,0,0,0,22.9643,3H9.0357a1.0687,1.0687,0,0,0-.9224.5322L1.1492,15.4487a1.0933,1.0933,0,0,0,0,1.1026L8.1133,28.4678A1.0687,1.0687,0,0,0,9.0357,29H22.9643a1.0687,1.0687,0,0,0,.9224-.5322l6.9641-11.9165A1.0933,1.0933,0,0,0,30.8508,15.4487ZM14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z"
    })), children);
  });
  var WarningHexFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHexFilled24(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path179 || (_path179 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z",
      "data-icon-path": "inner-path"
    })), _path180 || (_path180 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8508,15.4487,23.8867,3.5322A1.0687,1.0687,0,0,0,22.9643,3H9.0357a1.0687,1.0687,0,0,0-.9224.5322L1.1492,15.4487a1.0933,1.0933,0,0,0,0,1.1026L8.1133,28.4678A1.0687,1.0687,0,0,0,9.0357,29H22.9643a1.0687,1.0687,0,0,0,.9224-.5322l6.9641-11.9165A1.0933,1.0933,0,0,0,30.8508,15.4487ZM14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z"
    })), children);
  });
  var WarningHexFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHexFilled20(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path181 || (_path181 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z",
      "data-icon-path": "inner-path"
    })), _path182 || (_path182 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8508,15.4487,23.8867,3.5322A1.0687,1.0687,0,0,0,22.9643,3H9.0357a1.0687,1.0687,0,0,0-.9224.5322L1.1492,15.4487a1.0933,1.0933,0,0,0,0,1.1026L8.1133,28.4678A1.0687,1.0687,0,0,0,9.0357,29H22.9643a1.0687,1.0687,0,0,0,.9224-.5322l6.9641-11.9165A1.0933,1.0933,0,0,0,30.8508,15.4487ZM14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z"
    })), children);
  });
  var WarningHexFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningHexFilled16(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path183 || (_path183 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z",
      "data-icon-path": "inner-path"
    })), _path184 || (_path184 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30.8508,15.4487,23.8867,3.5322A1.0687,1.0687,0,0,0,22.9643,3H9.0357a1.0687,1.0687,0,0,0-.9224.5322L1.1492,15.4487a1.0933,1.0933,0,0,0,0,1.1026L8.1133,28.4678A1.0687,1.0687,0,0,0,9.0357,29H22.9643a1.0687,1.0687,0,0,0,.9224-.5322l6.9641-11.9165A1.0933,1.0933,0,0,0,30.8508,15.4487ZM14.875,8h2.25V19h-2.25ZM16,25a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Z"
    })), children);
  });
  var WarningOther32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningOther32(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path185 || (_path185 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 20H30V22H18zM18 24H30V26H18zM18 28H30V30H18zM14 18a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0014 18zM13 7H15V16H13z"
    })), _path186 || (_path186 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4A10.0111,10.0111,0,0,1,24,14h2A12,12,0,1,0,14,26V24A10,10,0,0,1,14,4Z"
    })), children);
  });
  var WarningOther24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningOther24(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path187 || (_path187 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 20H30V22H18zM18 24H30V26H18zM18 28H30V30H18zM14 18a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0014 18zM13 7H15V16H13z"
    })), _path188 || (_path188 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4A10.0111,10.0111,0,0,1,24,14h2A12,12,0,1,0,14,26V24A10,10,0,0,1,14,4Z"
    })), children);
  });
  var WarningOther20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningOther20(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path189 || (_path189 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 20H30V22H18zM18 24H30V26H18zM18 28H30V30H18zM14 18a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0014 18zM13 7H15V16H13z"
    })), _path190 || (_path190 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4A10.0111,10.0111,0,0,1,24,14h2A12,12,0,1,0,14,26V24A10,10,0,0,1,14,4Z"
    })), children);
  });
  var WarningOther16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningOther16(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path191 || (_path191 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 20H30V22H18zM18 24H30V26H18zM18 28H30V30H18zM14 18a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0014 18zM13 7H15V16H13z"
    })), _path192 || (_path192 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M14,4A10.0111,10.0111,0,0,1,24,14h2A12,12,0,1,0,14,26V24A10,10,0,0,1,14,4Z"
    })), children);
  });
  var WarningSquare32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquare32(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path193 || (_path193 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 20zM15 9H17V18H15z"
    })), _path194 || (_path194 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WarningSquare24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquare24(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path195 || (_path195 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 20zM15 9H17V18H15z"
    })), _path196 || (_path196 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WarningSquare20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquare20(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path197 || (_path197 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 20zM15 9H17V18H15z"
    })), _path198 || (_path198 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WarningSquare16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquare16(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path199 || (_path199 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 20a1.5 1.5 0 101.5 1.5A1.5 1.5 0 0016 20zM15 9H17V18H15z"
    })), _path200 || (_path200 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"
    })), children);
  });
  var WarningSquareFilled32 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquareFilled32(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path201 || (_path201 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"
    })), _path202 || (_path202 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var WarningSquareFilled24 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquareFilled24(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118$1);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path203 || (_path203 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"
    })), _path204 || (_path204 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var WarningSquareFilled20 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquareFilled20(_ref119, ref) {
    var children = _ref119.children,
        rest = _objectWithoutProperties(_ref119, _excluded119);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path205 || (_path205 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"
    })), _path206 || (_path206 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var WarningSquareFilled16 = /*#__PURE__*/React__default['default'].forwardRef(function WarningSquareFilled16(_ref120, ref) {
    var children = _ref120.children,
        rest = _objectWithoutProperties(_ref120, _excluded120);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path207 || (_path207 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"
    })), _path208 || (_path208 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z",
      "data-icon-path": "inner-path"
    })), children);
  });
  var Watch32 = /*#__PURE__*/React__default['default'].forwardRef(function Watch32(_ref121, ref) {
    var children = _ref121.children,
        rest = _objectWithoutProperties(_ref121, _excluded121);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path209 || (_path209 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8H21V2H19V8H13V2H11V8H10a2 2 0 00-2 2V22a2 2 0 002 2h1v6h2V24h6v6h2V24h1a2 2 0 002-2V10A2 2 0 0022 8zM10 22V10H22V22zM25 14H27V18H25z"
    })), children);
  });
  var Watch24 = /*#__PURE__*/React__default['default'].forwardRef(function Watch24(_ref122, ref) {
    var children = _ref122.children,
        rest = _objectWithoutProperties(_ref122, _excluded122);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path210 || (_path210 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8H21V2H19V8H13V2H11V8H10a2 2 0 00-2 2V22a2 2 0 002 2h1v6h2V24h6v6h2V24h1a2 2 0 002-2V10A2 2 0 0022 8zM10 22V10H22V22zM25 14H27V18H25z"
    })), children);
  });
  var Watch20 = /*#__PURE__*/React__default['default'].forwardRef(function Watch20(_ref123, ref) {
    var children = _ref123.children,
        rest = _objectWithoutProperties(_ref123, _excluded123);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path211 || (_path211 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8H21V2H19V8H13V2H11V8H10a2 2 0 00-2 2V22a2 2 0 002 2h1v6h2V24h6v6h2V24h1a2 2 0 002-2V10A2 2 0 0022 8zM10 22V10H22V22zM25 14H27V18H25z"
    })), children);
  });
  var Watch16 = /*#__PURE__*/React__default['default'].forwardRef(function Watch16(_ref124, ref) {
    var children = _ref124.children,
        rest = _objectWithoutProperties(_ref124, _excluded124);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path212 || (_path212 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 8H21V2H19V8H13V2H11V8H10a2 2 0 00-2 2V22a2 2 0 002 2h1v6h2V24h6v6h2V24h1a2 2 0 002-2V10A2 2 0 0022 8zM10 22V10H22V22zM25 14H27V18H25z"
    })), children);
  });
  var Watson32 = /*#__PURE__*/React__default['default'].forwardRef(function Watson32(_ref125, ref) {
    var children = _ref125.children,
        rest = _objectWithoutProperties(_ref125, _excluded125);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path213 || (_path213 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.74 9.49h0A11.41 11.41 0 0016 8h0a.76.76 0 100 1.51 10.15 10.15 0 011.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 00-2 4.44A9.58 9.58 0 017 17.22a3.43 3.43 0 01.28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 00.74-.78.75.75 0 00-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 00-.44 3.79 12 12 0 003.2 5.22A11.36 11.36 0 008.52 26a10 10 0 01-2-3.48A.75.75 0 005.57 22a.76.76 0 00-.49 1 11.45 11.45 0 005.18 6.38h0A11.42 11.42 0 0016 30.92a11.74 11.74 0 003-.39 11.48 11.48 0 002.77-21zM18.58 29.06a9.9 9.9 0 01-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 002.48 1.72 13.92 13.92 0 006.93 2 11 11 0 002.42-.28A9.78 9.78 0 0118.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 01-2.89-2.12 21.08 21.08 0 012.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0124.64 24.4zM4.16 11.72L1.14 10a.76.76 0 10-.76 1.31L3.4 13a.86.86 0 00.38.1.77.77 0 00.66-.38A.76.76 0 004.16 11.72zM8.29 7.59A.74.74 0 008.94 8a.75.75 0 00.38-.1.76.76 0 00.28-1l-1.74-3a.76.76 0 00-1-.27.75.75 0 00-.28 1zM16 6.08a.76.76 0 00.76-.76V1.83a.76.76 0 00-1.52 0V5.32A.76.76 0 0016 6.08zM22.68 7.87a.75.75 0 001-.28l1.75-3a.75.75 0 00-.28-1 .76.76 0 00-1 .27l-1.74 3A.76.76 0 0022.68 7.87zM31.9 10.25a.76.76 0 00-1-.27l-3 1.74a.76.76 0 00-.28 1 .77.77 0 00.66.38.86.86 0 00.38-.1l3-1.75A.76.76 0 0031.9 10.25z"
    })), children);
  });
  var Watson24 = /*#__PURE__*/React__default['default'].forwardRef(function Watson24(_ref126, ref) {
    var children = _ref126.children,
        rest = _objectWithoutProperties(_ref126, _excluded126);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path214 || (_path214 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.74 9.49h0A11.41 11.41 0 0016 8h0a.76.76 0 100 1.51 10.15 10.15 0 011.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 00-2 4.44A9.58 9.58 0 017 17.22a3.43 3.43 0 01.28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 00.74-.78.75.75 0 00-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 00-.44 3.79 12 12 0 003.2 5.22A11.36 11.36 0 008.52 26a10 10 0 01-2-3.48A.75.75 0 005.57 22a.76.76 0 00-.49 1 11.45 11.45 0 005.18 6.38h0A11.42 11.42 0 0016 30.92a11.74 11.74 0 003-.39 11.48 11.48 0 002.77-21zM18.58 29.06a9.9 9.9 0 01-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 002.48 1.72 13.92 13.92 0 006.93 2 11 11 0 002.42-.28A9.78 9.78 0 0118.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 01-2.89-2.12 21.08 21.08 0 012.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0124.64 24.4zM4.16 11.72L1.14 10a.76.76 0 10-.76 1.31L3.4 13a.86.86 0 00.38.1.77.77 0 00.66-.38A.76.76 0 004.16 11.72zM8.29 7.59A.74.74 0 008.94 8a.75.75 0 00.38-.1.76.76 0 00.28-1l-1.74-3a.76.76 0 00-1-.27.75.75 0 00-.28 1zM16 6.08a.76.76 0 00.76-.76V1.83a.76.76 0 00-1.52 0V5.32A.76.76 0 0016 6.08zM22.68 7.87a.75.75 0 001-.28l1.75-3a.75.75 0 00-.28-1 .76.76 0 00-1 .27l-1.74 3A.76.76 0 0022.68 7.87zM31.9 10.25a.76.76 0 00-1-.27l-3 1.74a.76.76 0 00-.28 1 .77.77 0 00.66.38.86.86 0 00.38-.1l3-1.75A.76.76 0 0031.9 10.25z"
    })), children);
  });
  var Watson20 = /*#__PURE__*/React__default['default'].forwardRef(function Watson20(_ref127, ref) {
    var children = _ref127.children,
        rest = _objectWithoutProperties(_ref127, _excluded127);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path215 || (_path215 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.74 9.49h0A11.41 11.41 0 0016 8h0a.76.76 0 100 1.51 10.15 10.15 0 011.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 00-2 4.44A9.58 9.58 0 017 17.22a3.43 3.43 0 01.28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 00.74-.78.75.75 0 00-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 00-.44 3.79 12 12 0 003.2 5.22A11.36 11.36 0 008.52 26a10 10 0 01-2-3.48A.75.75 0 005.57 22a.76.76 0 00-.49 1 11.45 11.45 0 005.18 6.38h0A11.42 11.42 0 0016 30.92a11.74 11.74 0 003-.39 11.48 11.48 0 002.77-21zM18.58 29.06a9.9 9.9 0 01-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 002.48 1.72 13.92 13.92 0 006.93 2 11 11 0 002.42-.28A9.78 9.78 0 0118.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 01-2.89-2.12 21.08 21.08 0 012.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0124.64 24.4zM4.16 11.72L1.14 10a.76.76 0 10-.76 1.31L3.4 13a.86.86 0 00.38.1.77.77 0 00.66-.38A.76.76 0 004.16 11.72zM8.29 7.59A.74.74 0 008.94 8a.75.75 0 00.38-.1.76.76 0 00.28-1l-1.74-3a.76.76 0 00-1-.27.75.75 0 00-.28 1zM16 6.08a.76.76 0 00.76-.76V1.83a.76.76 0 00-1.52 0V5.32A.76.76 0 0016 6.08zM22.68 7.87a.75.75 0 001-.28l1.75-3a.75.75 0 00-.28-1 .76.76 0 00-1 .27l-1.74 3A.76.76 0 0022.68 7.87zM31.9 10.25a.76.76 0 00-1-.27l-3 1.74a.76.76 0 00-.28 1 .77.77 0 00.66.38.86.86 0 00.38-.1l3-1.75A.76.76 0 0031.9 10.25z"
    })), children);
  });
  var Watson16 = /*#__PURE__*/React__default['default'].forwardRef(function Watson16(_ref128, ref) {
    var children = _ref128.children,
        rest = _objectWithoutProperties(_ref128, _excluded128);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path216 || (_path216 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.74 9.49h0A11.41 11.41 0 0016 8h0a.76.76 0 100 1.51 10.15 10.15 0 011.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 00-2 4.44A9.58 9.58 0 017 17.22a3.43 3.43 0 01.28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 00.74-.78.75.75 0 00-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 00-.44 3.79 12 12 0 003.2 5.22A11.36 11.36 0 008.52 26a10 10 0 01-2-3.48A.75.75 0 005.57 22a.76.76 0 00-.49 1 11.45 11.45 0 005.18 6.38h0A11.42 11.42 0 0016 30.92a11.74 11.74 0 003-.39 11.48 11.48 0 002.77-21zM18.58 29.06a9.9 9.9 0 01-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 002.48 1.72 13.92 13.92 0 006.93 2 11 11 0 002.42-.28A9.78 9.78 0 0118.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 01-2.89-2.12 21.08 21.08 0 012.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0124.64 24.4zM4.16 11.72L1.14 10a.76.76 0 10-.76 1.31L3.4 13a.86.86 0 00.38.1.77.77 0 00.66-.38A.76.76 0 004.16 11.72zM8.29 7.59A.74.74 0 008.94 8a.75.75 0 00.38-.1.76.76 0 00.28-1l-1.74-3a.76.76 0 00-1-.27.75.75 0 00-.28 1zM16 6.08a.76.76 0 00.76-.76V1.83a.76.76 0 00-1.52 0V5.32A.76.76 0 0016 6.08zM22.68 7.87a.75.75 0 001-.28l1.75-3a.75.75 0 00-.28-1 .76.76 0 00-1 .27l-1.74 3A.76.76 0 0022.68 7.87zM31.9 10.25a.76.76 0 00-1-.27l-3 1.74a.76.76 0 00-.28 1 .77.77 0 00.66.38.86.86 0 00.38-.1l3-1.75A.76.76 0 0031.9 10.25z"
    })), children);
  });
  var WatsonMachineLearning32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonMachineLearning32(_ref129, ref) {
    var children = _ref129.children,
        rest = _objectWithoutProperties(_ref129, _excluded129);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path217 || (_path217 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H20V17.76l-3.23 3.88a1 1 0 01-1.54 0L12 17.76V26H10V15a1 1 0 01.66-.94 1 1 0 011.11.3L16 19.44l4.23-5.08a1 1 0 011.11-.3A1 1 0 0122 15zM4.16 14.65l-3-1.75a.76.76 0 10-.76 1.32L3.4 16a.76.76 0 10.76-1.31zM8.29 10.52a.73.73 0 001 .27.75.75 0 00.28-1l-1.74-3a.76.76 0 10-1.32.76zM16 9a.76.76 0 00.76-.76V4.76a.76.76 0 10-1.52 0V8.25A.76.76 0 0016 9zM22.68 10.79a.75.75 0 00.37.11.76.76 0 00.66-.38l1.75-3a.76.76 0 00-1.32-.76l-1.74 3A.75.75 0 0022.68 10.79zM31.9 13.18a.76.76 0 00-1-.28l-3 1.75A.76.76 0 0028.6 16l3-1.74A.77.77 0 0031.9 13.18z"
    })), children);
  });
  var WatsonMachineLearning24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonMachineLearning24(_ref130, ref) {
    var children = _ref130.children,
        rest = _objectWithoutProperties(_ref130, _excluded130);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path218 || (_path218 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H20V17.76l-3.23 3.88a1 1 0 01-1.54 0L12 17.76V26H10V15a1 1 0 01.66-.94 1 1 0 011.11.3L16 19.44l4.23-5.08a1 1 0 011.11-.3A1 1 0 0122 15zM4.16 14.65l-3-1.75a.76.76 0 10-.76 1.32L3.4 16a.76.76 0 10.76-1.31zM8.29 10.52a.73.73 0 001 .27.75.75 0 00.28-1l-1.74-3a.76.76 0 10-1.32.76zM16 9a.76.76 0 00.76-.76V4.76a.76.76 0 10-1.52 0V8.25A.76.76 0 0016 9zM22.68 10.79a.75.75 0 00.37.11.76.76 0 00.66-.38l1.75-3a.76.76 0 00-1.32-.76l-1.74 3A.75.75 0 0022.68 10.79zM31.9 13.18a.76.76 0 00-1-.28l-3 1.75A.76.76 0 0028.6 16l3-1.74A.77.77 0 0031.9 13.18z"
    })), children);
  });
  var WatsonMachineLearning20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonMachineLearning20(_ref131, ref) {
    var children = _ref131.children,
        rest = _objectWithoutProperties(_ref131, _excluded131);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path219 || (_path219 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H20V17.76l-3.23 3.88a1 1 0 01-1.54 0L12 17.76V26H10V15a1 1 0 01.66-.94 1 1 0 011.11.3L16 19.44l4.23-5.08a1 1 0 011.11-.3A1 1 0 0122 15zM4.16 14.65l-3-1.75a.76.76 0 10-.76 1.32L3.4 16a.76.76 0 10.76-1.31zM8.29 10.52a.73.73 0 001 .27.75.75 0 00.28-1l-1.74-3a.76.76 0 10-1.32.76zM16 9a.76.76 0 00.76-.76V4.76a.76.76 0 10-1.52 0V8.25A.76.76 0 0016 9zM22.68 10.79a.75.75 0 00.37.11.76.76 0 00.66-.38l1.75-3a.76.76 0 00-1.32-.76l-1.74 3A.75.75 0 0022.68 10.79zM31.9 13.18a.76.76 0 00-1-.28l-3 1.75A.76.76 0 0028.6 16l3-1.74A.77.77 0 0031.9 13.18z"
    })), children);
  });
  var WatsonMachineLearning16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonMachineLearning16(_ref132, ref) {
    var children = _ref132.children,
        rest = _objectWithoutProperties(_ref132, _excluded132);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path220 || (_path220 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 26H20V17.76l-3.23 3.88a1 1 0 01-1.54 0L12 17.76V26H10V15a1 1 0 01.66-.94 1 1 0 011.11.3L16 19.44l4.23-5.08a1 1 0 011.11-.3A1 1 0 0122 15zM4.16 14.65l-3-1.75a.76.76 0 10-.76 1.32L3.4 16a.76.76 0 10.76-1.31zM8.29 10.52a.73.73 0 001 .27.75.75 0 00.28-1l-1.74-3a.76.76 0 10-1.32.76zM16 9a.76.76 0 00.76-.76V4.76a.76.76 0 10-1.52 0V8.25A.76.76 0 0016 9zM22.68 10.79a.75.75 0 00.37.11.76.76 0 00.66-.38l1.75-3a.76.76 0 00-1.32-.76l-1.74 3A.75.75 0 0022.68 10.79zM31.9 13.18a.76.76 0 00-1-.28l-3 1.75A.76.76 0 0028.6 16l3-1.74A.77.77 0 0031.9 13.18z"
    })), children);
  });
  var WaveDirection32 = /*#__PURE__*/React__default['default'].forwardRef(function WaveDirection32(_ref133, ref) {
    var children = _ref133.children,
        rest = _objectWithoutProperties(_ref133, _excluded133);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path221 || (_path221 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H17a7.0078,7.0078,0,0,1-7-7,6.6832,6.6832,0,0,1,2.0244-4.6967A6.7126,6.7126,0,0,0,10.0093,18C5.0425,18.0466,4,24.5513,4,30H2C2,18.4907,6.3452,16.0342,9.9907,16a10.0962,10.0962,0,0,1,4.4785,1.117,1,1,0,0,1,.0616,1.73A4.8773,4.8773,0,0,0,17,28h5Z"
    })), _path222 || (_path222 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,24V22a8,8,0,1,0-8-8H8A10,10,0,1,1,18,24Z"
    })), _circle || (_circle = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "8",
      r: "1"
    })), _path223 || (_path223 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17.5859l-2.3-2.3007A2.9665,2.9665,0,0,0,21,14a3.0033,3.0033,0,0,0-3-3,2.9609,2.9609,0,0,0-1.2854.3008L14.4141,9,13,10.4141l2.3,2.3007A2.9665,2.9665,0,0,0,15,14a3.0033,3.0033,0,0,0,3,3,2.9609,2.9609,0,0,0,1.2854-.3008L21.5859,19ZM17,14a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,17,14Z"
    })), children);
  });
  var WaveDirection24 = /*#__PURE__*/React__default['default'].forwardRef(function WaveDirection24(_ref134, ref) {
    var children = _ref134.children,
        rest = _objectWithoutProperties(_ref134, _excluded134);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path224 || (_path224 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H17a7.0078,7.0078,0,0,1-7-7,6.6832,6.6832,0,0,1,2.0244-4.6967A6.7126,6.7126,0,0,0,10.0093,18C5.0425,18.0466,4,24.5513,4,30H2C2,18.4907,6.3452,16.0342,9.9907,16a10.0962,10.0962,0,0,1,4.4785,1.117,1,1,0,0,1,.0616,1.73A4.8773,4.8773,0,0,0,17,28h5Z"
    })), _path225 || (_path225 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,24V22a8,8,0,1,0-8-8H8A10,10,0,1,1,18,24Z"
    })), _circle2 || (_circle2 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "8",
      r: "1"
    })), _path226 || (_path226 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17.5859l-2.3-2.3007A2.9665,2.9665,0,0,0,21,14a3.0033,3.0033,0,0,0-3-3,2.9609,2.9609,0,0,0-1.2854.3008L14.4141,9,13,10.4141l2.3,2.3007A2.9665,2.9665,0,0,0,15,14a3.0033,3.0033,0,0,0,3,3,2.9609,2.9609,0,0,0,1.2854-.3008L21.5859,19ZM17,14a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,17,14Z"
    })), children);
  });
  var WaveDirection20 = /*#__PURE__*/React__default['default'].forwardRef(function WaveDirection20(_ref135, ref) {
    var children = _ref135.children,
        rest = _objectWithoutProperties(_ref135, _excluded135);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path227 || (_path227 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H17a7.0078,7.0078,0,0,1-7-7,6.6832,6.6832,0,0,1,2.0244-4.6967A6.7126,6.7126,0,0,0,10.0093,18C5.0425,18.0466,4,24.5513,4,30H2C2,18.4907,6.3452,16.0342,9.9907,16a10.0962,10.0962,0,0,1,4.4785,1.117,1,1,0,0,1,.0616,1.73A4.8773,4.8773,0,0,0,17,28h5Z"
    })), _path228 || (_path228 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,24V22a8,8,0,1,0-8-8H8A10,10,0,1,1,18,24Z"
    })), _circle3 || (_circle3 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "8",
      r: "1"
    })), _path229 || (_path229 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17.5859l-2.3-2.3007A2.9665,2.9665,0,0,0,21,14a3.0033,3.0033,0,0,0-3-3,2.9609,2.9609,0,0,0-1.2854.3008L14.4141,9,13,10.4141l2.3,2.3007A2.9665,2.9665,0,0,0,15,14a3.0033,3.0033,0,0,0,3,3,2.9609,2.9609,0,0,0,1.2854-.3008L21.5859,19ZM17,14a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,17,14Z"
    })), children);
  });
  var WaveDirection16 = /*#__PURE__*/React__default['default'].forwardRef(function WaveDirection16(_ref136, ref) {
    var children = _ref136.children,
        rest = _objectWithoutProperties(_ref136, _excluded136);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path230 || (_path230 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22,30H17a7.0078,7.0078,0,0,1-7-7,6.6832,6.6832,0,0,1,2.0244-4.6967A6.7126,6.7126,0,0,0,10.0093,18C5.0425,18.0466,4,24.5513,4,30H2C2,18.4907,6.3452,16.0342,9.9907,16a10.0962,10.0962,0,0,1,4.4785,1.117,1,1,0,0,1,.0616,1.73A4.8773,4.8773,0,0,0,17,28h5Z"
    })), _path231 || (_path231 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,24V22a8,8,0,1,0-8-8H8A10,10,0,1,1,18,24Z"
    })), _circle4 || (_circle4 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "18",
      cy: "8",
      r: "1"
    })), _path232 || (_path232 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,17.5859l-2.3-2.3007A2.9665,2.9665,0,0,0,21,14a3.0033,3.0033,0,0,0-3-3,2.9609,2.9609,0,0,0-1.2854.3008L14.4141,9,13,10.4141l2.3,2.3007A2.9665,2.9665,0,0,0,15,14a3.0033,3.0033,0,0,0,3,3,2.9609,2.9609,0,0,0,1.2854-.3008L21.5859,19ZM17,14a1,1,0,1,1,1,1A1.0009,1.0009,0,0,1,17,14Z"
    })), children);
  });
  var WaveHeight32 = /*#__PURE__*/React__default['default'].forwardRef(function WaveHeight32(_ref137, ref) {
    var children = _ref137.children,
        rest = _objectWithoutProperties(_ref137, _excluded137);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path233 || (_path233 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H30V4H24zM24 8H28V10H24zM24 14H30V16H24zM24 20H28V22H24z"
    })), _path234 || (_path234 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28H24a10.0349,10.0349,0,0,1-6.9268-17.2622A11.9629,11.9629,0,0,0,12.9937,10a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,16.4348,4,21.34,4,28H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,8h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,26h6Z"
    })), children);
  });
  var WaveHeight24 = /*#__PURE__*/React__default['default'].forwardRef(function WaveHeight24(_ref138, ref) {
    var children = _ref138.children,
        rest = _objectWithoutProperties(_ref138, _excluded138);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path235 || (_path235 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H30V4H24zM24 8H28V10H24zM24 14H30V16H24zM24 20H28V22H24z"
    })), _path236 || (_path236 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28H24a10.0349,10.0349,0,0,1-6.9268-17.2622A11.9629,11.9629,0,0,0,12.9937,10a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,16.4348,4,21.34,4,28H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,8h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,26h6Z"
    })), children);
  });
  var WaveHeight20 = /*#__PURE__*/React__default['default'].forwardRef(function WaveHeight20(_ref139, ref) {
    var children = _ref139.children,
        rest = _objectWithoutProperties(_ref139, _excluded139);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path237 || (_path237 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H30V4H24zM24 8H28V10H24zM24 14H30V16H24zM24 20H28V22H24z"
    })), _path238 || (_path238 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28H24a10.0349,10.0349,0,0,1-6.9268-17.2622A11.9629,11.9629,0,0,0,12.9937,10a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,16.4348,4,21.34,4,28H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,8h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,26h6Z"
    })), children);
  });
  var WaveHeight16 = /*#__PURE__*/React__default['default'].forwardRef(function WaveHeight16(_ref140, ref) {
    var children = _ref140.children,
        rest = _objectWithoutProperties(_ref140, _excluded140);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path239 || (_path239 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 2H30V4H24zM24 8H28V10H24zM24 14H30V16H24zM24 20H28V22H24z"
    })), _path240 || (_path240 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,28H24a10.0349,10.0349,0,0,1-6.9268-17.2622A11.9629,11.9629,0,0,0,12.9937,10a6.9027,6.9027,0,0,0-6.0308,3.42C4.9966,16.4348,4,21.34,4,28H2c0-7.0542,1.106-12.3274,3.2871-15.6726A8.906,8.906,0,0,1,12.9937,8h.0068a14.762,14.762,0,0,1,6.4619,1.592,1,1,0,0,1,.0869,1.7222A8.0249,8.0249,0,0,0,24,26h6Z"
    })), children);
  });
  var WavePeriod32 = /*#__PURE__*/React__default['default'].forwardRef(function WavePeriod32(_ref141, ref) {
    var children = _ref141.children,
        rest = _objectWithoutProperties(_ref141, _excluded141);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path241 || (_path241 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H17a7.0078 7.0078 0 01-7-7 6.6832 6.6832 0 012.0244-4.6967A6.7935 6.7935 0 0010.0093 18C5.0425 18.0466 4 24.5513 4 30H2C2 18.4907 6.3452 16.0342 9.9907 16a10.0717 10.0717 0 014.4785 1.117 1 1 0 01.0616 1.73A4.8773 4.8773 0 0017 28h5zM17 8H19V16H17z"
    })), _path242 || (_path242 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5.4141,26.5859,4,24.3242,6.2617A9.95,9.95,0,0,0,19,4.0508V2H17V4.0508A10.0132,10.0132,0,0,0,8,14h2a8,8,0,1,1,8,8v2A9.9928,9.9928,0,0,0,25.7383,7.6758Z"
    })), children);
  });
  var WavePeriod24 = /*#__PURE__*/React__default['default'].forwardRef(function WavePeriod24(_ref142, ref) {
    var children = _ref142.children,
        rest = _objectWithoutProperties(_ref142, _excluded142);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path243 || (_path243 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H17a7.0078 7.0078 0 01-7-7 6.6832 6.6832 0 012.0244-4.6967A6.7935 6.7935 0 0010.0093 18C5.0425 18.0466 4 24.5513 4 30H2C2 18.4907 6.3452 16.0342 9.9907 16a10.0717 10.0717 0 014.4785 1.117 1 1 0 01.0616 1.73A4.8773 4.8773 0 0017 28h5zM17 8H19V16H17z"
    })), _path244 || (_path244 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5.4141,26.5859,4,24.3242,6.2617A9.95,9.95,0,0,0,19,4.0508V2H17V4.0508A10.0132,10.0132,0,0,0,8,14h2a8,8,0,1,1,8,8v2A9.9928,9.9928,0,0,0,25.7383,7.6758Z"
    })), children);
  });
  var WavePeriod20 = /*#__PURE__*/React__default['default'].forwardRef(function WavePeriod20(_ref143, ref) {
    var children = _ref143.children,
        rest = _objectWithoutProperties(_ref143, _excluded143);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path245 || (_path245 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H17a7.0078 7.0078 0 01-7-7 6.6832 6.6832 0 012.0244-4.6967A6.7935 6.7935 0 0010.0093 18C5.0425 18.0466 4 24.5513 4 30H2C2 18.4907 6.3452 16.0342 9.9907 16a10.0717 10.0717 0 014.4785 1.117 1 1 0 01.0616 1.73A4.8773 4.8773 0 0017 28h5zM17 8H19V16H17z"
    })), _path246 || (_path246 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5.4141,26.5859,4,24.3242,6.2617A9.95,9.95,0,0,0,19,4.0508V2H17V4.0508A10.0132,10.0132,0,0,0,8,14h2a8,8,0,1,1,8,8v2A9.9928,9.9928,0,0,0,25.7383,7.6758Z"
    })), children);
  });
  var WavePeriod16 = /*#__PURE__*/React__default['default'].forwardRef(function WavePeriod16(_ref144, ref) {
    var children = _ref144.children,
        rest = _objectWithoutProperties(_ref144, _excluded144);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path247 || (_path247 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22 30H17a7.0078 7.0078 0 01-7-7 6.6832 6.6832 0 012.0244-4.6967A6.7935 6.7935 0 0010.0093 18C5.0425 18.0466 4 24.5513 4 30H2C2 18.4907 6.3452 16.0342 9.9907 16a10.0717 10.0717 0 014.4785 1.117 1 1 0 01.0616 1.73A4.8773 4.8773 0 0017 28h5zM17 8H19V16H17z"
    })), _path248 || (_path248 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,5.4141,26.5859,4,24.3242,6.2617A9.95,9.95,0,0,0,19,4.0508V2H17V4.0508A10.0132,10.0132,0,0,0,8,14h2a8,8,0,1,1,8,8v2A9.9928,9.9928,0,0,0,25.7383,7.6758Z"
    })), children);
  });
  var WeatherFrontCold32 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontCold32(_ref145, ref) {
    var children = _ref145.children,
        rest = _objectWithoutProperties(_ref145, _excluded145);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path249 || (_path249 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontCold24 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontCold24(_ref146, ref) {
    var children = _ref146.children,
        rest = _objectWithoutProperties(_ref146, _excluded146);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path250 || (_path250 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontCold20 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontCold20(_ref147, ref) {
    var children = _ref147.children,
        rest = _objectWithoutProperties(_ref147, _excluded147);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path251 || (_path251 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontCold16 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontCold16(_ref148, ref) {
    var children = _ref148.children,
        rest = _objectWithoutProperties(_ref148, _excluded148);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path252 || (_path252 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontStationary32 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontStationary32(_ref149, ref) {
    var children = _ref149.children,
        rest = _objectWithoutProperties(_ref149, _excluded149);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path253 || (_path253 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a12.9848 12.9848 0 00-8.4074 3.1065A3.9947 3.9947 0 1015.583 11.728l-1.1362 4.1665c-.0725.2657-.1579.5254-.2489.7818a3.9864 3.9864 0 00-5.1547 6.0054A10.9541 10.9541 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM17 6a1.98 1.98 0 011.3237.53A12.9413 12.9413 0 0016.24 9.8482 1.9988 1.9988 0 0117 6zM10 20a1.9879 1.9879 0 013.3374-1.4717 11.0157 11.0157 0 01-2.5959 3.0147A1.9975 1.9975 0 0110 20zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM22 22L22 24 26.586 24 22 28.586 23.414 30 28 25.414 28 30 30 30 30 22 22 22zM2 2L2 4 6.586 4 2 8.586 3.414 10 8 5.414 8 10 10 10 10 2 2 2z"
    })), children);
  });
  var WeatherFrontStationary24 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontStationary24(_ref150, ref) {
    var children = _ref150.children,
        rest = _objectWithoutProperties(_ref150, _excluded150);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path254 || (_path254 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a12.9848 12.9848 0 00-8.4074 3.1065A3.9947 3.9947 0 1015.583 11.728l-1.1362 4.1665c-.0725.2657-.1579.5254-.2489.7818a3.9864 3.9864 0 00-5.1547 6.0054A10.9541 10.9541 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM17 6a1.98 1.98 0 011.3237.53A12.9413 12.9413 0 0016.24 9.8482 1.9988 1.9988 0 0117 6zM10 20a1.9879 1.9879 0 013.3374-1.4717 11.0157 11.0157 0 01-2.5959 3.0147A1.9975 1.9975 0 0110 20zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM22 22L22 24 26.586 24 22 28.586 23.414 30 28 25.414 28 30 30 30 30 22 22 22zM2 2L2 4 6.586 4 2 8.586 3.414 10 8 5.414 8 10 10 10 10 2 2 2z"
    })), children);
  });
  var WeatherFrontStationary20 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontStationary20(_ref151, ref) {
    var children = _ref151.children,
        rest = _objectWithoutProperties(_ref151, _excluded151);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path255 || (_path255 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a12.9848 12.9848 0 00-8.4074 3.1065A3.9947 3.9947 0 1015.583 11.728l-1.1362 4.1665c-.0725.2657-.1579.5254-.2489.7818a3.9864 3.9864 0 00-5.1547 6.0054A10.9541 10.9541 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM17 6a1.98 1.98 0 011.3237.53A12.9413 12.9413 0 0016.24 9.8482 1.9988 1.9988 0 0117 6zM10 20a1.9879 1.9879 0 013.3374-1.4717 11.0157 11.0157 0 01-2.5959 3.0147A1.9975 1.9975 0 0110 20zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM22 22L22 24 26.586 24 22 28.586 23.414 30 28 25.414 28 30 30 30 30 22 22 22zM2 2L2 4 6.586 4 2 8.586 3.414 10 8 5.414 8 10 10 10 10 2 2 2z"
    })), children);
  });
  var WeatherFrontStationary16 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontStationary16(_ref152, ref) {
    var children = _ref152.children,
        rest = _objectWithoutProperties(_ref152, _excluded152);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path256 || (_path256 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a12.9848 12.9848 0 00-8.4074 3.1065A3.9947 3.9947 0 1015.583 11.728l-1.1362 4.1665c-.0725.2657-.1579.5254-.2489.7818a3.9864 3.9864 0 00-5.1547 6.0054A10.9541 10.9541 0 013.8345 24H2v2H3.8345c.2975 0 .5918-.0171.8853-.0371l7.9291 2.9736A1 1 0 0014 28V21.0923a12.9311 12.9311 0 00.9121-1.313l6.3628-1.8179a1 1 0 00.5059-1.5864L17.7843 11.38a10.9268 10.9268 0 011.1516-2.3472l5.7477 1.916A1 1 0 0026 10V4.2251A10.8956 10.8956 0 0128.1655 4H30V2zM17 6a1.98 1.98 0 011.3237.53A12.9413 12.9413 0 0016.24 9.8482 1.9988 1.9988 0 0117 6zM10 20a1.9879 1.9879 0 013.3374-1.4717 11.0157 11.0157 0 01-2.5959 3.0147A1.9975 1.9975 0 0110 20zM8.3354 25.1826A13.047 13.047 0 0012 23.0943v3.4624zm7.74-7.8154c.1107-.3105.2136-.625.3013-.9463l.732-2.6846L19.28 16.4512zM24 8.6123l-3.7411-1.247A11.0712 11.0712 0 0124 4.8306zM22 22L22 24 26.586 24 22 28.586 23.414 30 28 25.414 28 30 30 30 30 22 22 22zM2 2L2 4 6.586 4 2 8.586 3.414 10 8 5.414 8 10 10 10 10 2 2 2z"
    })), children);
  });
  var WeatherFrontWarm32 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontWarm32(_ref153, ref) {
    var children = _ref153.children,
        rest = _objectWithoutProperties(_ref153, _excluded153);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path257 || (_path257 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345a12.9139 12.9139 0 003.4687-.4819 3.9979 3.9979 0 106.5818-4.2866 12.9671 12.9671 0 001.6209-2.5269 3.9944 3.9944 0 102.3772-7.5991 10.95 10.95 0 011.7253-3.01 3.9825 3.9825 0 006.9058-3.9648A10.9435 10.9435 0 0128.1655 4H30V2zM11 26a1.9983 1.9983 0 01-1.8118-1.1655 13.0811 13.0811 0 003.2969-2.1426A1.9773 1.9773 0 0111 26zm8-11a1.9926 1.9926 0 01-2.759 1.8467c.0442-.1426.0959-.2813.1355-.4258L17.301 13.03A1.9976 1.9976 0 0119 15zm6-9a1.9942 1.9942 0 01-3.9011.5894 11.0511 11.0511 0 013.3623-1.9385A1.995 1.995 0 0125 6zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontWarm24 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontWarm24(_ref154, ref) {
    var children = _ref154.children,
        rest = _objectWithoutProperties(_ref154, _excluded154);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path258 || (_path258 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345a12.9139 12.9139 0 003.4687-.4819 3.9979 3.9979 0 106.5818-4.2866 12.9671 12.9671 0 001.6209-2.5269 3.9944 3.9944 0 102.3772-7.5991 10.95 10.95 0 011.7253-3.01 3.9825 3.9825 0 006.9058-3.9648A10.9435 10.9435 0 0128.1655 4H30V2zM11 26a1.9983 1.9983 0 01-1.8118-1.1655 13.0811 13.0811 0 003.2969-2.1426A1.9773 1.9773 0 0111 26zm8-11a1.9926 1.9926 0 01-2.759 1.8467c.0442-.1426.0959-.2813.1355-.4258L17.301 13.03A1.9976 1.9976 0 0119 15zm6-9a1.9942 1.9942 0 01-3.9011.5894 11.0511 11.0511 0 013.3623-1.9385A1.995 1.995 0 0125 6zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontWarm20 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontWarm20(_ref155, ref) {
    var children = _ref155.children,
        rest = _objectWithoutProperties(_ref155, _excluded155);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path259 || (_path259 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345a12.9139 12.9139 0 003.4687-.4819 3.9979 3.9979 0 106.5818-4.2866 12.9671 12.9671 0 001.6209-2.5269 3.9944 3.9944 0 102.3772-7.5991 10.95 10.95 0 011.7253-3.01 3.9825 3.9825 0 006.9058-3.9648A10.9435 10.9435 0 0128.1655 4H30V2zM11 26a1.9983 1.9983 0 01-1.8118-1.1655 13.0811 13.0811 0 003.2969-2.1426A1.9773 1.9773 0 0111 26zm8-11a1.9926 1.9926 0 01-2.759 1.8467c.0442-.1426.0959-.2813.1355-.4258L17.301 13.03A1.9976 1.9976 0 0119 15zm6-9a1.9942 1.9942 0 01-3.9011.5894 11.0511 11.0511 0 013.3623-1.9385A1.995 1.995 0 0125 6zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherFrontWarm16 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherFrontWarm16(_ref156, ref) {
    var children = _ref156.children,
        rest = _objectWithoutProperties(_ref156, _excluded156);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path260 || (_path260 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28.1655 2a13.0289 13.0289 0 00-12.542 9.5791l-1.1767 4.3154A11.0237 11.0237 0 013.8345 24H2v2H3.8345a12.9139 12.9139 0 003.4687-.4819 3.9979 3.9979 0 106.5818-4.2866 12.9671 12.9671 0 001.6209-2.5269 3.9944 3.9944 0 102.3772-7.5991 10.95 10.95 0 011.7253-3.01 3.9825 3.9825 0 006.9058-3.9648A10.9435 10.9435 0 0128.1655 4H30V2zM11 26a1.9983 1.9983 0 01-1.8118-1.1655 13.0811 13.0811 0 003.2969-2.1426A1.9773 1.9773 0 0111 26zm8-11a1.9926 1.9926 0 01-2.759 1.8467c.0442-.1426.0959-.2813.1355-.4258L17.301 13.03A1.9976 1.9976 0 0119 15zm6-9a1.9942 1.9942 0 01-3.9011.5894 11.0511 11.0511 0 013.3623-1.9385A1.995 1.995 0 0125 6zM10 4L10 8.586 3.414 2 2 3.414 8.586 10 4 10 4 12 12 12 12 4 10 4z"
    })), children);
  });
  var WeatherStation32 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherStation32(_ref157, ref) {
    var children = _ref157.children,
        rest = _objectWithoutProperties(_ref157, _excluded157);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path261 || (_path261 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V17h1a2.0023,2.0023,0,0,0,2-2V11a2.0023,2.0023,0,0,0-2-2H14a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h1V28H2v2H30V28ZM14,11h4l.0015,4H14Z"
    })), _path262 || (_path262 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.3325 18.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537zM22.667 18.2168l-1.334-1.49a4.9995 4.9995 0 000-7.4537l1.334-1.49a7 7 0 010 10.4341z"
    })), _path263 || (_path263 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994 21.8008a11.0019 11.0019 0 010-17.6006L7.6 5.8a9.0009 9.0009 0 000 14.4014zM25.6006 21.8008l-1.2012-1.6a9.001 9.001 0 000-14.4019l1.2012-1.6a11.002 11.002 0 010 17.6011z"
    })), children);
  });
  var WeatherStation24 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherStation24(_ref158, ref) {
    var children = _ref158.children,
        rest = _objectWithoutProperties(_ref158, _excluded158);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path264 || (_path264 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V17h1a2.0023,2.0023,0,0,0,2-2V11a2.0023,2.0023,0,0,0-2-2H14a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h1V28H2v2H30V28ZM14,11h4l.0015,4H14Z"
    })), _path265 || (_path265 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.3325 18.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537zM22.667 18.2168l-1.334-1.49a4.9995 4.9995 0 000-7.4537l1.334-1.49a7 7 0 010 10.4341z"
    })), _path266 || (_path266 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994 21.8008a11.0019 11.0019 0 010-17.6006L7.6 5.8a9.0009 9.0009 0 000 14.4014zM25.6006 21.8008l-1.2012-1.6a9.001 9.001 0 000-14.4019l1.2012-1.6a11.002 11.002 0 010 17.6011z"
    })), children);
  });
  var WeatherStation20 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherStation20(_ref159, ref) {
    var children = _ref159.children,
        rest = _objectWithoutProperties(_ref159, _excluded159);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path267 || (_path267 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V17h1a2.0023,2.0023,0,0,0,2-2V11a2.0023,2.0023,0,0,0-2-2H14a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h1V28H2v2H30V28ZM14,11h4l.0015,4H14Z"
    })), _path268 || (_path268 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.3325 18.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537zM22.667 18.2168l-1.334-1.49a4.9995 4.9995 0 000-7.4537l1.334-1.49a7 7 0 010 10.4341z"
    })), _path269 || (_path269 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994 21.8008a11.0019 11.0019 0 010-17.6006L7.6 5.8a9.0009 9.0009 0 000 14.4014zM25.6006 21.8008l-1.2012-1.6a9.001 9.001 0 000-14.4019l1.2012-1.6a11.002 11.002 0 010 17.6011z"
    })), children);
  });
  var WeatherStation16 = /*#__PURE__*/React__default['default'].forwardRef(function WeatherStation16(_ref160, ref) {
    var children = _ref160.children,
        rest = _objectWithoutProperties(_ref160, _excluded160);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path270 || (_path270 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V17h1a2.0023,2.0023,0,0,0,2-2V11a2.0023,2.0023,0,0,0-2-2H14a2.0023,2.0023,0,0,0-2,2v4a2.0023,2.0023,0,0,0,2,2h1V28H2v2H30V28ZM14,11h4l.0015,4H14Z"
    })), _path271 || (_path271 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9.3325 18.2168a7.0007 7.0007 0 010-10.4341l1.334 1.49a5 5 0 000 7.4537zM22.667 18.2168l-1.334-1.49a4.9995 4.9995 0 000-7.4537l1.334-1.49a7 7 0 010 10.4341z"
    })), _path272 || (_path272 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.3994 21.8008a11.0019 11.0019 0 010-17.6006L7.6 5.8a9.0009 9.0009 0 000 14.4014zM25.6006 21.8008l-1.2012-1.6a9.001 9.001 0 000-14.4019l1.2012-1.6a11.002 11.002 0 010 17.6011z"
    })), children);
  });
  var Webhook32 = /*#__PURE__*/React__default['default'].forwardRef(function Webhook32(_ref161, ref) {
    var children = _ref161.children,
        rest = _objectWithoutProperties(_ref161, _excluded161);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path273 || (_path273 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26a3,3,0,1,0-2.8164-4H13v1a5,5,0,1,1-5-5V16a7,7,0,1,0,6.9287,8h6.2549A2.9914,2.9914,0,0,0,24,26Z"
    })), _path274 || (_path274 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16a7.024,7.024,0,0,0-2.57.4873l-3.1656-5.5395a3.0469,3.0469,0,1,0-1.7326.9985l4.1189,7.2085.8686-.4976a5.0006,5.0006,0,1,1-1.851,6.8418L17.937,26.501A7.0005,7.0005,0,1,0,24,16Z"
    })), _path275 || (_path275 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.532,20.0537a3.03,3.03,0,1,0,1.7326.9985C11.74,18.47,13.86,14.7607,13.89,14.708l.4976-.8682-.8677-.497a5,5,0,1,1,6.812-1.8438l1.7315,1.002a7.0008,7.0008,0,1,0-10.3462,2.0356c-.457.7427-1.1021,1.8716-2.0737,3.5728Z"
    })), children);
  });
  var Webhook24 = /*#__PURE__*/React__default['default'].forwardRef(function Webhook24(_ref162, ref) {
    var children = _ref162.children,
        rest = _objectWithoutProperties(_ref162, _excluded162);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path276 || (_path276 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26a3,3,0,1,0-2.8164-4H13v1a5,5,0,1,1-5-5V16a7,7,0,1,0,6.9287,8h6.2549A2.9914,2.9914,0,0,0,24,26Z"
    })), _path277 || (_path277 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16a7.024,7.024,0,0,0-2.57.4873l-3.1656-5.5395a3.0469,3.0469,0,1,0-1.7326.9985l4.1189,7.2085.8686-.4976a5.0006,5.0006,0,1,1-1.851,6.8418L17.937,26.501A7.0005,7.0005,0,1,0,24,16Z"
    })), _path278 || (_path278 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.532,20.0537a3.03,3.03,0,1,0,1.7326.9985C11.74,18.47,13.86,14.7607,13.89,14.708l.4976-.8682-.8677-.497a5,5,0,1,1,6.812-1.8438l1.7315,1.002a7.0008,7.0008,0,1,0-10.3462,2.0356c-.457.7427-1.1021,1.8716-2.0737,3.5728Z"
    })), children);
  });
  var Webhook20 = /*#__PURE__*/React__default['default'].forwardRef(function Webhook20(_ref163, ref) {
    var children = _ref163.children,
        rest = _objectWithoutProperties(_ref163, _excluded163);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path279 || (_path279 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26a3,3,0,1,0-2.8164-4H13v1a5,5,0,1,1-5-5V16a7,7,0,1,0,6.9287,8h6.2549A2.9914,2.9914,0,0,0,24,26Z"
    })), _path280 || (_path280 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16a7.024,7.024,0,0,0-2.57.4873l-3.1656-5.5395a3.0469,3.0469,0,1,0-1.7326.9985l4.1189,7.2085.8686-.4976a5.0006,5.0006,0,1,1-1.851,6.8418L17.937,26.501A7.0005,7.0005,0,1,0,24,16Z"
    })), _path281 || (_path281 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.532,20.0537a3.03,3.03,0,1,0,1.7326.9985C11.74,18.47,13.86,14.7607,13.89,14.708l.4976-.8682-.8677-.497a5,5,0,1,1,6.812-1.8438l1.7315,1.002a7.0008,7.0008,0,1,0-10.3462,2.0356c-.457.7427-1.1021,1.8716-2.0737,3.5728Z"
    })), children);
  });
  var Webhook16 = /*#__PURE__*/React__default['default'].forwardRef(function Webhook16(_ref164, ref) {
    var children = _ref164.children,
        rest = _objectWithoutProperties(_ref164, _excluded164);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path282 || (_path282 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,26a3,3,0,1,0-2.8164-4H13v1a5,5,0,1,1-5-5V16a7,7,0,1,0,6.9287,8h6.2549A2.9914,2.9914,0,0,0,24,26Z"
    })), _path283 || (_path283 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,16a7.024,7.024,0,0,0-2.57.4873l-3.1656-5.5395a3.0469,3.0469,0,1,0-1.7326.9985l4.1189,7.2085.8686-.4976a5.0006,5.0006,0,1,1-1.851,6.8418L17.937,26.501A7.0005,7.0005,0,1,0,24,16Z"
    })), _path284 || (_path284 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.532,20.0537a3.03,3.03,0,1,0,1.7326.9985C11.74,18.47,13.86,14.7607,13.89,14.708l.4976-.8682-.8677-.497a5,5,0,1,1,6.812-1.8438l1.7315,1.002a7.0008,7.0008,0,1,0-10.3462,2.0356c-.457.7427-1.1021,1.8716-2.0737,3.5728Z"
    })), children);
  });
  var Websheet32 = /*#__PURE__*/React__default['default'].forwardRef(function Websheet32(_ref165, ref) {
    var children = _ref165.children,
        rest = _objectWithoutProperties(_ref165, _excluded165);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle5 || (_circle5 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "24",
      r: "2"
    })), _path285 || (_path285 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6,6,0,1,1,6-6A6.0069,6.0069,0,0,1,24,30Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,24,20Z"
    })), _path286 || (_path286 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Websheet24 = /*#__PURE__*/React__default['default'].forwardRef(function Websheet24(_ref166, ref) {
    var children = _ref166.children,
        rest = _objectWithoutProperties(_ref166, _excluded166);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle6 || (_circle6 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "24",
      r: "2"
    })), _path287 || (_path287 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6,6,0,1,1,6-6A6.0069,6.0069,0,0,1,24,30Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,24,20Z"
    })), _path288 || (_path288 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Websheet20 = /*#__PURE__*/React__default['default'].forwardRef(function Websheet20(_ref167, ref) {
    var children = _ref167.children,
        rest = _objectWithoutProperties(_ref167, _excluded167);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle7 || (_circle7 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "24",
      r: "2"
    })), _path289 || (_path289 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6,6,0,1,1,6-6A6.0069,6.0069,0,0,1,24,30Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,24,20Z"
    })), _path290 || (_path290 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Websheet16 = /*#__PURE__*/React__default['default'].forwardRef(function Websheet16(_ref168, ref) {
    var children = _ref168.children,
        rest = _objectWithoutProperties(_ref168, _excluded168);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle8 || (_circle8 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "24",
      cy: "24",
      r: "2"
    })), _path291 || (_path291 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24,30a6,6,0,1,1,6-6A6.0069,6.0069,0,0,1,24,30Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,24,20Z"
    })), _path292 || (_path292 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,28H8V4h8v6a2.0058,2.0058,0,0,0,2,2h6v3h2V10a.9092.9092,0,0,0-.3-.7l-7-7A.9087.9087,0,0,0,18,2H8A2.0058,2.0058,0,0,0,6,4V28a2.0058,2.0058,0,0,0,2,2h8ZM18,4.4,23.6,10H18Z"
    })), children);
  });
  var Wheat32 = /*#__PURE__*/React__default['default'].forwardRef(function Wheat32(_ref169, ref) {
    var children = _ref169.children,
        rest = _objectWithoutProperties(_ref169, _excluded169);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path293 || (_path293 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"
    })), children);
  });
  var Wheat24 = /*#__PURE__*/React__default['default'].forwardRef(function Wheat24(_ref170, ref) {
    var children = _ref170.children,
        rest = _objectWithoutProperties(_ref170, _excluded170);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path294 || (_path294 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"
    })), children);
  });
  var Wheat20 = /*#__PURE__*/React__default['default'].forwardRef(function Wheat20(_ref171, ref) {
    var children = _ref171.children,
        rest = _objectWithoutProperties(_ref171, _excluded171);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path295 || (_path295 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"
    })), children);
  });
  var Wheat16 = /*#__PURE__*/React__default['default'].forwardRef(function Wheat16(_ref172, ref) {
    var children = _ref172.children,
        rest = _objectWithoutProperties(_ref172, _excluded172);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path296 || (_path296 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"
    })), children);
  });
  var Wifi32 = /*#__PURE__*/React__default['default'].forwardRef(function Wifi32(_ref173, ref) {
    var children = _ref173.children,
        rest = _objectWithoutProperties(_ref173, _excluded173);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle9 || (_circle9 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path297 || (_path297 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"
    })), _path298 || (_path298 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"
    })), _path299 || (_path299 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"
    })), children);
  });
  var Wifi24 = /*#__PURE__*/React__default['default'].forwardRef(function Wifi24(_ref174, ref) {
    var children = _ref174.children,
        rest = _objectWithoutProperties(_ref174, _excluded174);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle10 || (_circle10 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path300 || (_path300 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"
    })), _path301 || (_path301 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"
    })), _path302 || (_path302 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"
    })), children);
  });
  var Wifi20 = /*#__PURE__*/React__default['default'].forwardRef(function Wifi20(_ref175, ref) {
    var children = _ref175.children,
        rest = _objectWithoutProperties(_ref175, _excluded175);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle11 || (_circle11 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path303 || (_path303 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"
    })), _path304 || (_path304 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"
    })), _path305 || (_path305 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"
    })), children);
  });
  var Wifi16 = /*#__PURE__*/React__default['default'].forwardRef(function Wifi16(_ref176, ref) {
    var children = _ref176.children,
        rest = _objectWithoutProperties(_ref176, _excluded176);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle12 || (_circle12 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path306 || (_path306 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"
    })), _path307 || (_path307 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"
    })), _path308 || (_path308 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"
    })), children);
  });
  var WifiController32 = /*#__PURE__*/React__default['default'].forwardRef(function WifiController32(_ref177, ref) {
    var children = _ref177.children,
        rest = _objectWithoutProperties(_ref177, _excluded177);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path309 || (_path309 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle13 || (_circle13 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _circle14 || (_circle14 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14.5",
      r: "1.5"
    })), _path310 || (_path310 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7832,10.3325a7.0007,7.0007,0,0,1,10.4341,0l-1.49,1.334a5,5,0,0,0-7.4537,0Z"
    })), _path311 || (_path311 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,7.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,8.6a9.0009,9.0009,0,0,0-14.4014.0005Z"
    })), children);
  });
  var WifiController24 = /*#__PURE__*/React__default['default'].forwardRef(function WifiController24(_ref178, ref) {
    var children = _ref178.children,
        rest = _objectWithoutProperties(_ref178, _excluded178);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path312 || (_path312 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle15 || (_circle15 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _circle16 || (_circle16 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14.5",
      r: "1.5"
    })), _path313 || (_path313 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7832,10.3325a7.0007,7.0007,0,0,1,10.4341,0l-1.49,1.334a5,5,0,0,0-7.4537,0Z"
    })), _path314 || (_path314 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,7.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,8.6a9.0009,9.0009,0,0,0-14.4014.0005Z"
    })), children);
  });
  var WifiController20 = /*#__PURE__*/React__default['default'].forwardRef(function WifiController20(_ref179, ref) {
    var children = _ref179.children,
        rest = _objectWithoutProperties(_ref179, _excluded179);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path315 || (_path315 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle17 || (_circle17 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _circle18 || (_circle18 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14.5",
      r: "1.5"
    })), _path316 || (_path316 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7832,10.3325a7.0007,7.0007,0,0,1,10.4341,0l-1.49,1.334a5,5,0,0,0-7.4537,0Z"
    })), _path317 || (_path317 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,7.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,8.6a9.0009,9.0009,0,0,0-14.4014.0005Z"
    })), children);
  });
  var WifiController16 = /*#__PURE__*/React__default['default'].forwardRef(function WifiController16(_ref180, ref) {
    var children = _ref180.children,
        rest = _objectWithoutProperties(_ref180, _excluded180);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path318 || (_path318 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6,30H26a2,2,0,0,0,2-2V22a2,2,0,0,0-2-2H6a2,2,0,0,0-2,2v6A2,2,0,0,0,6,30Zm0-8H26v6H6Z"
    })), _circle19 || (_circle19 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "9",
      cy: "25",
      r: "1"
    })), _circle20 || (_circle20 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "14.5",
      r: "1.5"
    })), _path319 || (_path319 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7832,10.3325a7.0007,7.0007,0,0,1,10.4341,0l-1.49,1.334a5,5,0,0,0-7.4537,0Z"
    })), _path320 || (_path320 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.1992,7.3994a11.0019,11.0019,0,0,1,17.6006,0L23.2,8.6a9.0009,9.0009,0,0,0-14.4014.0005Z"
    })), children);
  });
  var WifiNotSecure32 = /*#__PURE__*/React__default['default'].forwardRef(function WifiNotSecure32(_ref181, ref) {
    var children = _ref181.children,
        rest = _objectWithoutProperties(_ref181, _excluded181);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path321 || (_path321 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H14V17a2 2 0 014 0h2a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm0 8H12V22h8zM16 8a8.9709 8.9709 0 00-6.3608 2.6392l1.4133 1.4135a6.9887 6.9887 0 019.895 0l1.4135-1.4135A8.9717 8.9717 0 0016 8z"
    })), _path322 || (_path322 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.105,7.105,7.5188,8.5186a11.9808,11.9808,0,0,1,16.9624,0L25.8949,7.105a13.9782,13.9782,0,0,0-19.79,0Z"
    })), children);
  });
  var WifiNotSecure24 = /*#__PURE__*/React__default['default'].forwardRef(function WifiNotSecure24(_ref182, ref) {
    var children = _ref182.children,
        rest = _objectWithoutProperties(_ref182, _excluded182);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path323 || (_path323 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H14V17a2 2 0 014 0h2a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm0 8H12V22h8zM16 8a8.9709 8.9709 0 00-6.3608 2.6392l1.4133 1.4135a6.9887 6.9887 0 019.895 0l1.4135-1.4135A8.9717 8.9717 0 0016 8z"
    })), _path324 || (_path324 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.105,7.105,7.5188,8.5186a11.9808,11.9808,0,0,1,16.9624,0L25.8949,7.105a13.9782,13.9782,0,0,0-19.79,0Z"
    })), children);
  });
  var WifiNotSecure20 = /*#__PURE__*/React__default['default'].forwardRef(function WifiNotSecure20(_ref183, ref) {
    var children = _ref183.children,
        rest = _objectWithoutProperties(_ref183, _excluded183);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path325 || (_path325 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H14V17a2 2 0 014 0h2a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm0 8H12V22h8zM16 8a8.9709 8.9709 0 00-6.3608 2.6392l1.4133 1.4135a6.9887 6.9887 0 019.895 0l1.4135-1.4135A8.9717 8.9717 0 0016 8z"
    })), _path326 || (_path326 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.105,7.105,7.5188,8.5186a11.9808,11.9808,0,0,1,16.9624,0L25.8949,7.105a13.9782,13.9782,0,0,0-19.79,0Z"
    })), children);
  });
  var WifiNotSecure16 = /*#__PURE__*/React__default['default'].forwardRef(function WifiNotSecure16(_ref184, ref) {
    var children = _ref184.children,
        rest = _objectWithoutProperties(_ref184, _excluded184);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path327 || (_path327 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20H14V17a2 2 0 014 0h2a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm0 8H12V22h8zM16 8a8.9709 8.9709 0 00-6.3608 2.6392l1.4133 1.4135a6.9887 6.9887 0 019.895 0l1.4135-1.4135A8.9717 8.9717 0 0016 8z"
    })), _path328 || (_path328 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.105,7.105,7.5188,8.5186a11.9808,11.9808,0,0,1,16.9624,0L25.8949,7.105a13.9782,13.9782,0,0,0-19.79,0Z"
    })), children);
  });
  var WifiOff32 = /*#__PURE__*/React__default['default'].forwardRef(function WifiOff32(_ref185, ref) {
    var children = _ref185.children,
        rest = _objectWithoutProperties(_ref185, _excluded185);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle21 || (_circle21 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path329 || (_path329 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 016.01 1.3193L21.52 19.2236a7.9669 7.9669 0 00-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 014.5647 2.7647L25.76 14.9829A13.975 13.975 0 0021.334 12.08L24.3308 9.083a17.9364 17.9364 0 014.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 00-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 00-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0114.68 13.0776zM16 7a17.87 17.87 0 014.2324.5254L21.875 5.8828A19.9537 19.9537 0 002 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0116 7z"
    })), children);
  });
  var WifiOff24 = /*#__PURE__*/React__default['default'].forwardRef(function WifiOff24(_ref186, ref) {
    var children = _ref186.children,
        rest = _objectWithoutProperties(_ref186, _excluded186);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle22 || (_circle22 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path330 || (_path330 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 016.01 1.3193L21.52 19.2236a7.9669 7.9669 0 00-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 014.5647 2.7647L25.76 14.9829A13.975 13.975 0 0021.334 12.08L24.3308 9.083a17.9364 17.9364 0 014.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 00-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 00-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0114.68 13.0776zM16 7a17.87 17.87 0 014.2324.5254L21.875 5.8828A19.9537 19.9537 0 002 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0116 7z"
    })), children);
  });
  var WifiOff20 = /*#__PURE__*/React__default['default'].forwardRef(function WifiOff20(_ref187, ref) {
    var children = _ref187.children,
        rest = _objectWithoutProperties(_ref187, _excluded187);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle23 || (_circle23 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path331 || (_path331 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 016.01 1.3193L21.52 19.2236a7.9669 7.9669 0 00-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 014.5647 2.7647L25.76 14.9829A13.975 13.975 0 0021.334 12.08L24.3308 9.083a17.9364 17.9364 0 014.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 00-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 00-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0114.68 13.0776zM16 7a17.87 17.87 0 014.2324.5254L21.875 5.8828A19.9537 19.9537 0 002 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0116 7z"
    })), children);
  });
  var WifiOff16 = /*#__PURE__*/React__default['default'].forwardRef(function WifiOff16(_ref188, ref) {
    var children = _ref188.children,
        rest = _objectWithoutProperties(_ref188, _excluded188);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _circle24 || (_circle24 = /*#__PURE__*/React__default['default'].createElement("circle", {
      cx: "16",
      cy: "25",
      r: "2"
    })), _path332 || (_path332 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 016.01 1.3193L21.52 19.2236a7.9669 7.9669 0 00-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 014.5647 2.7647L25.76 14.9829A13.975 13.975 0 0021.334 12.08L24.3308 9.083a17.9364 17.9364 0 014.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 00-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 00-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0114.68 13.0776zM16 7a17.87 17.87 0 014.2324.5254L21.875 5.8828A19.9537 19.9537 0 002 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0116 7z"
    })), children);
  });
  var WifiSecure32 = /*#__PURE__*/React__default['default'].forwardRef(function WifiSecure32(_ref189, ref) {
    var children = _ref189.children,
        rest = _objectWithoutProperties(_ref189, _excluded189);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path333 || (_path333 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20V17a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm-6-3a2 2 0 014 0v3H14zM12 28V22h8v6zM6.105 7.105L7.5188 8.5186a11.9808 11.9808 0 0116.9624 0L25.8949 7.105a13.9782 13.9782 0 00-19.79 0z"
    })), _path334 || (_path334 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a8.9709,8.9709,0,0,0-6.3608,2.6392l1.4133,1.4135a6.9887,6.9887,0,0,1,9.895,0l1.4135-1.4135A8.9717,8.9717,0,0,0,16,8Z"
    })), children);
  });
  var WifiSecure24 = /*#__PURE__*/React__default['default'].forwardRef(function WifiSecure24(_ref190, ref) {
    var children = _ref190.children,
        rest = _objectWithoutProperties(_ref190, _excluded190);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path335 || (_path335 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20V17a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm-6-3a2 2 0 014 0v3H14zM12 28V22h8v6zM6.105 7.105L7.5188 8.5186a11.9808 11.9808 0 0116.9624 0L25.8949 7.105a13.9782 13.9782 0 00-19.79 0z"
    })), _path336 || (_path336 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a8.9709,8.9709,0,0,0-6.3608,2.6392l1.4133,1.4135a6.9887,6.9887,0,0,1,9.895,0l1.4135-1.4135A8.9717,8.9717,0,0,0,16,8Z"
    })), children);
  });
  var WifiSecure20 = /*#__PURE__*/React__default['default'].forwardRef(function WifiSecure20(_ref191, ref) {
    var children = _ref191.children,
        rest = _objectWithoutProperties(_ref191, _excluded191);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path337 || (_path337 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20V17a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm-6-3a2 2 0 014 0v3H14zM12 28V22h8v6zM6.105 7.105L7.5188 8.5186a11.9808 11.9808 0 0116.9624 0L25.8949 7.105a13.9782 13.9782 0 00-19.79 0z"
    })), _path338 || (_path338 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a8.9709,8.9709,0,0,0-6.3608,2.6392l1.4133,1.4135a6.9887,6.9887,0,0,1,9.895,0l1.4135-1.4135A8.9717,8.9717,0,0,0,16,8Z"
    })), children);
  });
  var WifiSecure16 = /*#__PURE__*/React__default['default'].forwardRef(function WifiSecure16(_ref192, ref) {
    var children = _ref192.children,
        rest = _objectWithoutProperties(_ref192, _excluded192);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path339 || (_path339 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 20V17a4 4 0 00-8 0v3a2.0025 2.0025 0 00-2 2v6a2.0025 2.0025 0 002 2h8a2.0025 2.0025 0 002-2V22A2.0025 2.0025 0 0020 20zm-6-3a2 2 0 014 0v3H14zM12 28V22h8v6zM6.105 7.105L7.5188 8.5186a11.9808 11.9808 0 0116.9624 0L25.8949 7.105a13.9782 13.9782 0 00-19.79 0z"
    })), _path340 || (_path340 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,8a8.9709,8.9709,0,0,0-6.3608,2.6392l1.4133,1.4135a6.9887,6.9887,0,0,1,9.895,0l1.4135-1.4135A8.9717,8.9717,0,0,0,16,8Z"
    })), children);
  });
  var WifiBridge32 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridge32(_ref193, ref) {
    var children = _ref193.children,
        rest = _objectWithoutProperties(_ref193, _excluded193);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path341 || (_path341 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9492,20.95l-1.414-1.4141a5,5,0,0,0,0-7.0715L6.9492,11.05a7,7,0,0,1,0,9.9Z"
    })), _path342 || (_path342 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.4854 24.4854L9.0713 23.0713a10.0011 10.0011 0 000-14.1426l1.4141-1.4141a12.0006 12.0006 0 010 16.9708zM25.0508 20.95a7 7 0 010-9.9l1.414 1.4146a5 5 0 000 7.0715z"
    })), _path343 || (_path343 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5146 24.4854a12.0006 12.0006 0 010-16.9708l1.4141 1.4141a10.0011 10.0011 0 000 14.1426zM3 15H2V4H0V28H2V17H3a1 1 0 000-2zM30 4V15H29a1 1 0 000 2h1V28h2V4z"
    })), children);
  });
  var WifiBridge24 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridge24(_ref194, ref) {
    var children = _ref194.children,
        rest = _objectWithoutProperties(_ref194, _excluded194);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path344 || (_path344 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9492,20.95l-1.414-1.4141a5,5,0,0,0,0-7.0715L6.9492,11.05a7,7,0,0,1,0,9.9Z"
    })), _path345 || (_path345 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.4854 24.4854L9.0713 23.0713a10.0011 10.0011 0 000-14.1426l1.4141-1.4141a12.0006 12.0006 0 010 16.9708zM25.0508 20.95a7 7 0 010-9.9l1.414 1.4146a5 5 0 000 7.0715z"
    })), _path346 || (_path346 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5146 24.4854a12.0006 12.0006 0 010-16.9708l1.4141 1.4141a10.0011 10.0011 0 000 14.1426zM3 15H2V4H0V28H2V17H3a1 1 0 000-2zM30 4V15H29a1 1 0 000 2h1V28h2V4z"
    })), children);
  });
  var WifiBridge20 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridge20(_ref195, ref) {
    var children = _ref195.children,
        rest = _objectWithoutProperties(_ref195, _excluded195);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path347 || (_path347 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9492,20.95l-1.414-1.4141a5,5,0,0,0,0-7.0715L6.9492,11.05a7,7,0,0,1,0,9.9Z"
    })), _path348 || (_path348 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.4854 24.4854L9.0713 23.0713a10.0011 10.0011 0 000-14.1426l1.4141-1.4141a12.0006 12.0006 0 010 16.9708zM25.0508 20.95a7 7 0 010-9.9l1.414 1.4146a5 5 0 000 7.0715z"
    })), _path349 || (_path349 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5146 24.4854a12.0006 12.0006 0 010-16.9708l1.4141 1.4141a10.0011 10.0011 0 000 14.1426zM3 15H2V4H0V28H2V17H3a1 1 0 000-2zM30 4V15H29a1 1 0 000 2h1V28h2V4z"
    })), children);
  });
  var WifiBridge16 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridge16(_ref196, ref) {
    var children = _ref196.children,
        rest = _objectWithoutProperties(_ref196, _excluded196);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path350 || (_path350 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.9492,20.95l-1.414-1.4141a5,5,0,0,0,0-7.0715L6.9492,11.05a7,7,0,0,1,0,9.9Z"
    })), _path351 || (_path351 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.4854 24.4854L9.0713 23.0713a10.0011 10.0011 0 000-14.1426l1.4141-1.4141a12.0006 12.0006 0 010 16.9708zM25.0508 20.95a7 7 0 010-9.9l1.414 1.4146a5 5 0 000 7.0715z"
    })), _path352 || (_path352 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5146 24.4854a12.0006 12.0006 0 010-16.9708l1.4141 1.4141a10.0011 10.0011 0 000 14.1426zM3 15H2V4H0V28H2V17H3a1 1 0 000-2zM30 4V15H29a1 1 0 000 2h1V28h2V4z"
    })), children);
  });
  var WifiBridgeAlt32 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridgeAlt32(_ref197, ref) {
    var children = _ref197.children,
        rest = _objectWithoutProperties(_ref197, _excluded197);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path353 || (_path353 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a5.0057,5.0057,0,0,0-5-5V19A7.0078,7.0078,0,0,1,13,26Z"
    })), _path354 || (_path354 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H16A10.0113 10.0113 0 006 16V14A12.0137 12.0137 0 0118 26zM26 13a7.0078 7.0078 0 01-7-7h2a5.0057 5.0057 0 005 5z"
    })), _path355 || (_path355 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18A12.0137 12.0137 0 0114 6h2A10.0113 10.0113 0 0026 16zM7.707 24.293a.9994.9994 0 00-1.414 0L2 28.5859 3.4143 30 7.707 25.707A.9994.9994 0 007.707 24.293zM28.5859 2L24.293 6.293a1 1 0 001.414 1.414L30 3.4141z"
    })), children);
  });
  var WifiBridgeAlt24 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridgeAlt24(_ref198, ref) {
    var children = _ref198.children,
        rest = _objectWithoutProperties(_ref198, _excluded198);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path356 || (_path356 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a5.0057,5.0057,0,0,0-5-5V19A7.0078,7.0078,0,0,1,13,26Z"
    })), _path357 || (_path357 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H16A10.0113 10.0113 0 006 16V14A12.0137 12.0137 0 0118 26zM26 13a7.0078 7.0078 0 01-7-7h2a5.0057 5.0057 0 005 5z"
    })), _path358 || (_path358 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18A12.0137 12.0137 0 0114 6h2A10.0113 10.0113 0 0026 16zM7.707 24.293a.9994.9994 0 00-1.414 0L2 28.5859 3.4143 30 7.707 25.707A.9994.9994 0 007.707 24.293zM28.5859 2L24.293 6.293a1 1 0 001.414 1.414L30 3.4141z"
    })), children);
  });
  var WifiBridgeAlt20 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridgeAlt20(_ref199, ref) {
    var children = _ref199.children,
        rest = _objectWithoutProperties(_ref199, _excluded199);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path359 || (_path359 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a5.0057,5.0057,0,0,0-5-5V19A7.0078,7.0078,0,0,1,13,26Z"
    })), _path360 || (_path360 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H16A10.0113 10.0113 0 006 16V14A12.0137 12.0137 0 0118 26zM26 13a7.0078 7.0078 0 01-7-7h2a5.0057 5.0057 0 005 5z"
    })), _path361 || (_path361 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18A12.0137 12.0137 0 0114 6h2A10.0113 10.0113 0 0026 16zM7.707 24.293a.9994.9994 0 00-1.414 0L2 28.5859 3.4143 30 7.707 25.707A.9994.9994 0 007.707 24.293zM28.5859 2L24.293 6.293a1 1 0 001.414 1.414L30 3.4141z"
    })), children);
  });
  var WifiBridgeAlt16 = /*#__PURE__*/React__default['default'].forwardRef(function WifiBridgeAlt16(_ref200, ref) {
    var children = _ref200.children,
        rest = _objectWithoutProperties(_ref200, _excluded200);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path362 || (_path362 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,26H11a5.0057,5.0057,0,0,0-5-5V19A7.0078,7.0078,0,0,1,13,26Z"
    })), _path363 || (_path363 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 26H16A10.0113 10.0113 0 006 16V14A12.0137 12.0137 0 0118 26zM26 13a7.0078 7.0078 0 01-7-7h2a5.0057 5.0057 0 005 5z"
    })), _path364 || (_path364 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 18A12.0137 12.0137 0 0114 6h2A10.0113 10.0113 0 0026 16zM7.707 24.293a.9994.9994 0 00-1.414 0L2 28.5859 3.4143 30 7.707 25.707A.9994.9994 0 007.707 24.293zM28.5859 2L24.293 6.293a1 1 0 001.414 1.414L30 3.4141z"
    })), children);
  });
  var Wikis32 = /*#__PURE__*/React__default['default'].forwardRef(function Wikis32(_ref201, ref) {
    var children = _ref201.children,
        rest = _objectWithoutProperties(_ref201, _excluded201);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path365 || (_path365 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"
    })), children);
  });
  var Wikis24 = /*#__PURE__*/React__default['default'].forwardRef(function Wikis24(_ref202, ref) {
    var children = _ref202.children,
        rest = _objectWithoutProperties(_ref202, _excluded202);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path366 || (_path366 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"
    })), children);
  });
  var Wikis20 = /*#__PURE__*/React__default['default'].forwardRef(function Wikis20(_ref203, ref) {
    var children = _ref203.children,
        rest = _objectWithoutProperties(_ref203, _excluded203);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path367 || (_path367 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"
    })), children);
  });
  var Wikis16 = /*#__PURE__*/React__default['default'].forwardRef(function Wikis16(_ref204, ref) {
    var children = _ref204.children,
        rest = _objectWithoutProperties(_ref204, _excluded204);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path368 || (_path368 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"
    })), children);
  });
  var WindGusts32 = /*#__PURE__*/React__default['default'].forwardRef(function WindGusts32(_ref205, ref) {
    var children = _ref205.children,
        rest = _objectWithoutProperties(_ref205, _excluded205);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path369 || (_path369 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3164,8.0513l-18-6A1,1,0,0,0,10.4,2.2L4,7V2H2V30H4V11l6.4,4.8a1,1,0,0,0,.9165.1489l18-6a1,1,0,0,0,0-1.8974ZM10,13,4.6665,9,10,5Zm4-.0542-2,.667V4.3872l2,.667Zm4-1.333-2,.6665V5.7207l2,.6665Zm2-.667V7.0542L25.8379,9Z"
    })), _path370 || (_path370 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22a4,4,0,0,0-8,0h2a2,2,0,1,1,2,2H8v2h8A4.0045,4.0045,0,0,0,20,22Z"
    })), _path371 || (_path371 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a4.0045,4.0045,0,0,0-4,4h2a2,2,0,1,1,2,2H12v2H26a4,4,0,0,0,0-8Z"
    })), children);
  });
  var WindGusts24 = /*#__PURE__*/React__default['default'].forwardRef(function WindGusts24(_ref206, ref) {
    var children = _ref206.children,
        rest = _objectWithoutProperties(_ref206, _excluded206);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path372 || (_path372 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3164,8.0513l-18-6A1,1,0,0,0,10.4,2.2L4,7V2H2V30H4V11l6.4,4.8a1,1,0,0,0,.9165.1489l18-6a1,1,0,0,0,0-1.8974ZM10,13,4.6665,9,10,5Zm4-.0542-2,.667V4.3872l2,.667Zm4-1.333-2,.6665V5.7207l2,.6665Zm2-.667V7.0542L25.8379,9Z"
    })), _path373 || (_path373 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22a4,4,0,0,0-8,0h2a2,2,0,1,1,2,2H8v2h8A4.0045,4.0045,0,0,0,20,22Z"
    })), _path374 || (_path374 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a4.0045,4.0045,0,0,0-4,4h2a2,2,0,1,1,2,2H12v2H26a4,4,0,0,0,0-8Z"
    })), children);
  });
  var WindGusts20 = /*#__PURE__*/React__default['default'].forwardRef(function WindGusts20(_ref207, ref) {
    var children = _ref207.children,
        rest = _objectWithoutProperties(_ref207, _excluded207);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path375 || (_path375 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3164,8.0513l-18-6A1,1,0,0,0,10.4,2.2L4,7V2H2V30H4V11l6.4,4.8a1,1,0,0,0,.9165.1489l18-6a1,1,0,0,0,0-1.8974ZM10,13,4.6665,9,10,5Zm4-.0542-2,.667V4.3872l2,.667Zm4-1.333-2,.6665V5.7207l2,.6665Zm2-.667V7.0542L25.8379,9Z"
    })), _path376 || (_path376 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22a4,4,0,0,0-8,0h2a2,2,0,1,1,2,2H8v2h8A4.0045,4.0045,0,0,0,20,22Z"
    })), _path377 || (_path377 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a4.0045,4.0045,0,0,0-4,4h2a2,2,0,1,1,2,2H12v2H26a4,4,0,0,0,0-8Z"
    })), children);
  });
  var WindGusts16 = /*#__PURE__*/React__default['default'].forwardRef(function WindGusts16(_ref208, ref) {
    var children = _ref208.children,
        rest = _objectWithoutProperties(_ref208, _excluded208);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path378 || (_path378 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.3164,8.0513l-18-6A1,1,0,0,0,10.4,2.2L4,7V2H2V30H4V11l6.4,4.8a1,1,0,0,0,.9165.1489l18-6a1,1,0,0,0,0-1.8974ZM10,13,4.6665,9,10,5Zm4-.0542-2,.667V4.3872l2,.667Zm4-1.333-2,.6665V5.7207l2,.6665Zm2-.667V7.0542L25.8379,9Z"
    })), _path379 || (_path379 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20,22a4,4,0,0,0-8,0h2a2,2,0,1,1,2,2H8v2h8A4.0045,4.0045,0,0,0,20,22Z"
    })), _path380 || (_path380 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26,22a4.0045,4.0045,0,0,0-4,4h2a2,2,0,1,1,2,2H12v2H26a4,4,0,0,0,0-8Z"
    })), children);
  });
  var WindPower32 = /*#__PURE__*/React__default['default'].forwardRef(function WindPower32(_ref209, ref) {
    var children = _ref209.children,
        rest = _objectWithoutProperties(_ref209, _excluded209);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path381 || (_path381 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V15.8159a3.0059,3.0059,0,0,0,1.47-1.1186L27.063,17l.5176-1.9321-8.6045-2.3052a2.985,2.985,0,0,0-2.63-2.7275L14.1938,2l-1.9316.5186,2.1318,7.956a2.9588,2.9588,0,0,0-1.093,3.8115L7,20.5859,8.415,22l6.3-6.3A2.8938,2.8938,0,0,0,15,15.8154V28H2v2H30V28Zm0-15a1,1,0,1,1-1-1A1.0008,1.0008,0,0,1,17,13Z"
    })), children);
  });
  var WindPower24 = /*#__PURE__*/React__default['default'].forwardRef(function WindPower24(_ref210, ref) {
    var children = _ref210.children,
        rest = _objectWithoutProperties(_ref210, _excluded210);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path382 || (_path382 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V15.8159a3.0059,3.0059,0,0,0,1.47-1.1186L27.063,17l.5176-1.9321-8.6045-2.3052a2.985,2.985,0,0,0-2.63-2.7275L14.1938,2l-1.9316.5186,2.1318,7.956a2.9588,2.9588,0,0,0-1.093,3.8115L7,20.5859,8.415,22l6.3-6.3A2.8938,2.8938,0,0,0,15,15.8154V28H2v2H30V28Zm0-15a1,1,0,1,1-1-1A1.0008,1.0008,0,0,1,17,13Z"
    })), children);
  });
  var WindPower20 = /*#__PURE__*/React__default['default'].forwardRef(function WindPower20(_ref211, ref) {
    var children = _ref211.children,
        rest = _objectWithoutProperties(_ref211, _excluded211);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path383 || (_path383 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V15.8159a3.0059,3.0059,0,0,0,1.47-1.1186L27.063,17l.5176-1.9321-8.6045-2.3052a2.985,2.985,0,0,0-2.63-2.7275L14.1938,2l-1.9316.5186,2.1318,7.956a2.9588,2.9588,0,0,0-1.093,3.8115L7,20.5859,8.415,22l6.3-6.3A2.8938,2.8938,0,0,0,15,15.8154V28H2v2H30V28Zm0-15a1,1,0,1,1-1-1A1.0008,1.0008,0,0,1,17,13Z"
    })), children);
  });
  var WindPower16 = /*#__PURE__*/React__default['default'].forwardRef(function WindPower16(_ref212, ref) {
    var children = _ref212.children,
        rest = _objectWithoutProperties(_ref212, _excluded212);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path384 || (_path384 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,28V15.8159a3.0059,3.0059,0,0,0,1.47-1.1186L27.063,17l.5176-1.9321-8.6045-2.3052a2.985,2.985,0,0,0-2.63-2.7275L14.1938,2l-1.9316.5186,2.1318,7.956a2.9588,2.9588,0,0,0-1.093,3.8115L7,20.5859,8.415,22l6.3-6.3A2.8938,2.8938,0,0,0,15,15.8154V28H2v2H30V28Zm0-15a1,1,0,1,1-1-1A1.0008,1.0008,0,0,1,17,13Z"
    })), children);
  });
  var WindStream32 = /*#__PURE__*/React__default['default'].forwardRef(function WindStream32(_ref213, ref) {
    var children = _ref213.children,
        rest = _objectWithoutProperties(_ref213, _excluded213);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path385 || (_path385 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2,23.5859,3.4141,26.1719,6h-5.09a16.93,16.93,0,0,0-6.3139,1.2158L10.4893,8.9272A14.93,14.93,0,0,1,4.9185,10H2v2H4.9185a16.93,16.93,0,0,0,6.3139-1.2158l4.2783-1.7114A14.93,14.93,0,0,1,21.0815,8h5.09l-2.586,2.5859L25,12l5-5Z"
    })), _path386 || (_path386 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,11l-1.4141,1.4141L22.1719,15H18.9014a16.9422,16.9422,0,0,0-5.9693,1.0825l-2.5664.9624A14.9456,14.9456,0,0,1,5.0986,18H2v2H5.0986a16.9422,16.9422,0,0,0,5.9693-1.0825l2.5664-.9624A14.9456,14.9456,0,0,1,18.9014,17h3.2705l-2.586,2.5859L21,21l5-5Z"
    })), _path387 || (_path387 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,20l-1.4141,1.4141L18.1719,24H16.5967a16.9879,16.9879,0,0,0-5.3765.8721l-1.0727.3584A14.9852,14.9852,0,0,1,5.4033,26H2v2H5.4033a16.9879,16.9879,0,0,0,5.3765-.8721l1.0727-.3584A14.9852,14.9852,0,0,1,16.5967,26h1.5752l-2.586,2.5859L17,30l5-5Z"
    })), children);
  });
  var WindStream24 = /*#__PURE__*/React__default['default'].forwardRef(function WindStream24(_ref214, ref) {
    var children = _ref214.children,
        rest = _objectWithoutProperties(_ref214, _excluded214);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path388 || (_path388 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2,23.5859,3.4141,26.1719,6h-5.09a16.93,16.93,0,0,0-6.3139,1.2158L10.4893,8.9272A14.93,14.93,0,0,1,4.9185,10H2v2H4.9185a16.93,16.93,0,0,0,6.3139-1.2158l4.2783-1.7114A14.93,14.93,0,0,1,21.0815,8h5.09l-2.586,2.5859L25,12l5-5Z"
    })), _path389 || (_path389 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,11l-1.4141,1.4141L22.1719,15H18.9014a16.9422,16.9422,0,0,0-5.9693,1.0825l-2.5664.9624A14.9456,14.9456,0,0,1,5.0986,18H2v2H5.0986a16.9422,16.9422,0,0,0,5.9693-1.0825l2.5664-.9624A14.9456,14.9456,0,0,1,18.9014,17h3.2705l-2.586,2.5859L21,21l5-5Z"
    })), _path390 || (_path390 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,20l-1.4141,1.4141L18.1719,24H16.5967a16.9879,16.9879,0,0,0-5.3765.8721l-1.0727.3584A14.9852,14.9852,0,0,1,5.4033,26H2v2H5.4033a16.9879,16.9879,0,0,0,5.3765-.8721l1.0727-.3584A14.9852,14.9852,0,0,1,16.5967,26h1.5752l-2.586,2.5859L17,30l5-5Z"
    })), children);
  });
  var WindStream20 = /*#__PURE__*/React__default['default'].forwardRef(function WindStream20(_ref215, ref) {
    var children = _ref215.children,
        rest = _objectWithoutProperties(_ref215, _excluded215);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path391 || (_path391 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2,23.5859,3.4141,26.1719,6h-5.09a16.93,16.93,0,0,0-6.3139,1.2158L10.4893,8.9272A14.93,14.93,0,0,1,4.9185,10H2v2H4.9185a16.93,16.93,0,0,0,6.3139-1.2158l4.2783-1.7114A14.93,14.93,0,0,1,21.0815,8h5.09l-2.586,2.5859L25,12l5-5Z"
    })), _path392 || (_path392 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,11l-1.4141,1.4141L22.1719,15H18.9014a16.9422,16.9422,0,0,0-5.9693,1.0825l-2.5664.9624A14.9456,14.9456,0,0,1,5.0986,18H2v2H5.0986a16.9422,16.9422,0,0,0,5.9693-1.0825l2.5664-.9624A14.9456,14.9456,0,0,1,18.9014,17h3.2705l-2.586,2.5859L21,21l5-5Z"
    })), _path393 || (_path393 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,20l-1.4141,1.4141L18.1719,24H16.5967a16.9879,16.9879,0,0,0-5.3765.8721l-1.0727.3584A14.9852,14.9852,0,0,1,5.4033,26H2v2H5.4033a16.9879,16.9879,0,0,0,5.3765-.8721l1.0727-.3584A14.9852,14.9852,0,0,1,16.5967,26h1.5752l-2.586,2.5859L17,30l5-5Z"
    })), children);
  });
  var WindStream16 = /*#__PURE__*/React__default['default'].forwardRef(function WindStream16(_ref216, ref) {
    var children = _ref216.children,
        rest = _objectWithoutProperties(_ref216, _excluded216);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path394 || (_path394 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25,2,23.5859,3.4141,26.1719,6h-5.09a16.93,16.93,0,0,0-6.3139,1.2158L10.4893,8.9272A14.93,14.93,0,0,1,4.9185,10H2v2H4.9185a16.93,16.93,0,0,0,6.3139-1.2158l4.2783-1.7114A14.93,14.93,0,0,1,21.0815,8h5.09l-2.586,2.5859L25,12l5-5Z"
    })), _path395 || (_path395 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21,11l-1.4141,1.4141L22.1719,15H18.9014a16.9422,16.9422,0,0,0-5.9693,1.0825l-2.5664.9624A14.9456,14.9456,0,0,1,5.0986,18H2v2H5.0986a16.9422,16.9422,0,0,0,5.9693-1.0825l2.5664-.9624A14.9456,14.9456,0,0,1,18.9014,17h3.2705l-2.586,2.5859L21,21l5-5Z"
    })), _path396 || (_path396 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,20l-1.4141,1.4141L18.1719,24H16.5967a16.9879,16.9879,0,0,0-5.3765.8721l-1.0727.3584A14.9852,14.9852,0,0,1,5.4033,26H2v2H5.4033a16.9879,16.9879,0,0,0,5.3765-.8721l1.0727-.3584A14.9852,14.9852,0,0,1,16.5967,26h1.5752l-2.586,2.5859L17,30l5-5Z"
    })), children);
  });
  var WatsonHealthWindowAuto32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowAuto32(_ref217, ref) {
    var children = _ref217.children,
        rest = _objectWithoutProperties(_ref217, _excluded217);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path397 || (_path397 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"
    })), _path398 || (_path398 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 7.04H9.55V10.04H7.55z",
      transform: "rotate(-45 8.55 8.548)"
    })), _path399 || (_path399 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 7.55H24.96V9.55H21.96z",
      transform: "rotate(-45 23.454 8.555)"
    })), _path400 || (_path400 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45 21.95H24.45V24.95H22.45z",
      transform: "rotate(-45 23.452 23.446)"
    })), _path401 || (_path401 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.05 22.45H10.05V24.45H7.05z",
      transform: "rotate(-45 8.544 23.451)"
    })), _path402 || (_path402 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 106 6A6 6 0 0016 10zm-4 6a4 4 0 014-4v8A4 4 0 0112 16z"
    })), children);
  });
  var WatsonHealthWindowAuto24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowAuto24(_ref218, ref) {
    var children = _ref218.children,
        rest = _objectWithoutProperties(_ref218, _excluded218);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path403 || (_path403 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"
    })), _path404 || (_path404 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 7.04H9.55V10.04H7.55z",
      transform: "rotate(-45 8.55 8.548)"
    })), _path405 || (_path405 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 7.55H24.96V9.55H21.96z",
      transform: "rotate(-45 23.454 8.555)"
    })), _path406 || (_path406 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45 21.95H24.45V24.95H22.45z",
      transform: "rotate(-45 23.452 23.446)"
    })), _path407 || (_path407 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.05 22.45H10.05V24.45H7.05z",
      transform: "rotate(-45 8.544 23.451)"
    })), _path408 || (_path408 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 106 6A6 6 0 0016 10zm-4 6a4 4 0 014-4v8A4 4 0 0112 16z"
    })), children);
  });
  var WatsonHealthWindowAuto20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowAuto20(_ref219, ref) {
    var children = _ref219.children,
        rest = _objectWithoutProperties(_ref219, _excluded219);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path409 || (_path409 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"
    })), _path410 || (_path410 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 7.04H9.55V10.04H7.55z",
      transform: "rotate(-45 8.55 8.548)"
    })), _path411 || (_path411 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 7.55H24.96V9.55H21.96z",
      transform: "rotate(-45 23.454 8.555)"
    })), _path412 || (_path412 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45 21.95H24.45V24.95H22.45z",
      transform: "rotate(-45 23.452 23.446)"
    })), _path413 || (_path413 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.05 22.45H10.05V24.45H7.05z",
      transform: "rotate(-45 8.544 23.451)"
    })), _path414 || (_path414 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 106 6A6 6 0 0016 10zm-4 6a4 4 0 014-4v8A4 4 0 0112 16z"
    })), children);
  });
  var WatsonHealthWindowAuto16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowAuto16(_ref220, ref) {
    var children = _ref220.children,
        rest = _objectWithoutProperties(_ref220, _excluded220);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path415 || (_path415 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"
    })), _path416 || (_path416 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 7.04H9.55V10.04H7.55z",
      transform: "rotate(-45 8.55 8.548)"
    })), _path417 || (_path417 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 7.55H24.96V9.55H21.96z",
      transform: "rotate(-45 23.454 8.555)"
    })), _path418 || (_path418 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.45 21.95H24.45V24.95H22.45z",
      transform: "rotate(-45 23.452 23.446)"
    })), _path419 || (_path419 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.05 22.45H10.05V24.45H7.05z",
      transform: "rotate(-45 8.544 23.451)"
    })), _path420 || (_path420 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 106 6A6 6 0 0016 10zm-4 6a4 4 0 014-4v8A4 4 0 0112 16z"
    })), children);
  });
  var WatsonHealthWindowBase32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBase32(_ref221, ref) {
    var children = _ref221.children,
        rest = _objectWithoutProperties(_ref221, _excluded221);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path421 || (_path421 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"
    })), _path422 || (_path422 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 5.03H9.55V8.030000000000001H7.55z",
      transform: "rotate(-45 8.56 6.544)"
    })), _path423 || (_path423 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 5.54H24.96V7.54H21.96z",
      transform: "rotate(-45 23.469 6.539)"
    })), _path424 || (_path424 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 19.94H24.46V22.94H22.46z",
      transform: "rotate(-45 23.462 21.442)"
    })), _path425 || (_path425 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 20.45H10.04V22.45H7.04z",
      transform: "rotate(-45 8.554 21.447)"
    })), _path426 || (_path426 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 28H28V30H4zM16 20a6 6 0 10-6-6A6 6 0 0016 20zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowBase24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBase24(_ref222, ref) {
    var children = _ref222.children,
        rest = _objectWithoutProperties(_ref222, _excluded222);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path427 || (_path427 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"
    })), _path428 || (_path428 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 5.03H9.55V8.030000000000001H7.55z",
      transform: "rotate(-45 8.56 6.544)"
    })), _path429 || (_path429 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 5.54H24.96V7.54H21.96z",
      transform: "rotate(-45 23.469 6.539)"
    })), _path430 || (_path430 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 19.94H24.46V22.94H22.46z",
      transform: "rotate(-45 23.462 21.442)"
    })), _path431 || (_path431 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 20.45H10.04V22.45H7.04z",
      transform: "rotate(-45 8.554 21.447)"
    })), _path432 || (_path432 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 28H28V30H4zM16 20a6 6 0 10-6-6A6 6 0 0016 20zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowBase20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBase20(_ref223, ref) {
    var children = _ref223.children,
        rest = _objectWithoutProperties(_ref223, _excluded223);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path433 || (_path433 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"
    })), _path434 || (_path434 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 5.03H9.55V8.030000000000001H7.55z",
      transform: "rotate(-45 8.56 6.544)"
    })), _path435 || (_path435 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 5.54H24.96V7.54H21.96z",
      transform: "rotate(-45 23.469 6.539)"
    })), _path436 || (_path436 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 19.94H24.46V22.94H22.46z",
      transform: "rotate(-45 23.462 21.442)"
    })), _path437 || (_path437 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 20.45H10.04V22.45H7.04z",
      transform: "rotate(-45 8.554 21.447)"
    })), _path438 || (_path438 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 28H28V30H4zM16 20a6 6 0 10-6-6A6 6 0 0016 20zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowBase16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBase16(_ref224, ref) {
    var children = _ref224.children,
        rest = _objectWithoutProperties(_ref224, _excluded224);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path439 || (_path439 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"
    })), _path440 || (_path440 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 5.03H9.55V8.030000000000001H7.55z",
      transform: "rotate(-45 8.56 6.544)"
    })), _path441 || (_path441 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 5.54H24.96V7.54H21.96z",
      transform: "rotate(-45 23.469 6.539)"
    })), _path442 || (_path442 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 19.94H24.46V22.94H22.46z",
      transform: "rotate(-45 23.462 21.442)"
    })), _path443 || (_path443 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 20.45H10.04V22.45H7.04z",
      transform: "rotate(-45 8.554 21.447)"
    })), _path444 || (_path444 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 28H28V30H4zM16 20a6 6 0 10-6-6A6 6 0 0016 20zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowBlackSaturation32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBlackSaturation32(_ref225, ref) {
    var children = _ref225.children,
        rest = _objectWithoutProperties(_ref225, _excluded225);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path445 || (_path445 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path446 || (_path446 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.225 5.729H8.228V8.732H6.225z",
      transform: "rotate(-45 7.227 7.23)"
    })), _path447 || (_path447 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.267 6.227H26.267V8.227H23.267z",
      transform: "rotate(-45 24.767 7.227)"
    })), _path448 || (_path448 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.769 23.269H25.770999999999997V26.270999999999997H23.769z",
      transform: "rotate(-44.999 24.77 24.77)"
    })), _path449 || (_path449 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.126L7.591 23 9 24.419 6.884 26.54 5.47 25.126zM15 13H17V15H15zM19 13H21V15H19zM17 11H19V13H17zM17 15H19V17H17zM17 19H19V21H17zM15 17H17V19H15zM19 17H21V19H19z"
    })), _path450 || (_path450 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,7ZM9,16a7.004,7.004,0,0,1,6-6.92V11h2V9.08a6.9231,6.9231,0,0,1,2,.605V11h1.89c.0374.0366.074.0732.11.11V13h1.3149a6.931,6.931,0,0,1,.6053,2H21v2h1.92a6.931,6.931,0,0,1-.6053,2H21v1.89c-.0364.0372-.073.0738-.11.11H19v1.3149a6.9231,6.9231,0,0,1-2,.605V21H15v1.92A7.004,7.004,0,0,1,9,16Z"
    })), children);
  });
  var WatsonHealthWindowBlackSaturation24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBlackSaturation24(_ref226, ref) {
    var children = _ref226.children,
        rest = _objectWithoutProperties(_ref226, _excluded226);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path451 || (_path451 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path452 || (_path452 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.225 5.729H8.228V8.732H6.225z",
      transform: "rotate(-45 7.227 7.23)"
    })), _path453 || (_path453 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.267 6.227H26.267V8.227H23.267z",
      transform: "rotate(-45 24.767 7.227)"
    })), _path454 || (_path454 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.769 23.269H25.770999999999997V26.270999999999997H23.769z",
      transform: "rotate(-44.999 24.77 24.77)"
    })), _path455 || (_path455 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.126L7.591 23 9 24.419 6.884 26.54 5.47 25.126zM15 13H17V15H15zM19 13H21V15H19zM17 11H19V13H17zM17 15H19V17H17zM17 19H19V21H17zM15 17H17V19H15zM19 17H21V19H19z"
    })), _path456 || (_path456 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,7ZM9,16a7.004,7.004,0,0,1,6-6.92V11h2V9.08a6.9231,6.9231,0,0,1,2,.605V11h1.89c.0374.0366.074.0732.11.11V13h1.3149a6.931,6.931,0,0,1,.6053,2H21v2h1.92a6.931,6.931,0,0,1-.6053,2H21v1.89c-.0364.0372-.073.0738-.11.11H19v1.3149a6.9231,6.9231,0,0,1-2,.605V21H15v1.92A7.004,7.004,0,0,1,9,16Z"
    })), children);
  });
  var WatsonHealthWindowBlackSaturation20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBlackSaturation20(_ref227, ref) {
    var children = _ref227.children,
        rest = _objectWithoutProperties(_ref227, _excluded227);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path457 || (_path457 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path458 || (_path458 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.225 5.729H8.228V8.732H6.225z",
      transform: "rotate(-45 7.227 7.23)"
    })), _path459 || (_path459 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.267 6.227H26.267V8.227H23.267z",
      transform: "rotate(-45 24.767 7.227)"
    })), _path460 || (_path460 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.769 23.269H25.770999999999997V26.270999999999997H23.769z",
      transform: "rotate(-44.999 24.77 24.77)"
    })), _path461 || (_path461 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.126L7.591 23 9 24.419 6.884 26.54 5.47 25.126zM15 13H17V15H15zM19 13H21V15H19zM17 11H19V13H17zM17 15H19V17H17zM17 19H19V21H17zM15 17H17V19H15zM19 17H21V19H19z"
    })), _path462 || (_path462 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,7ZM9,16a7.004,7.004,0,0,1,6-6.92V11h2V9.08a6.9231,6.9231,0,0,1,2,.605V11h1.89c.0374.0366.074.0732.11.11V13h1.3149a6.931,6.931,0,0,1,.6053,2H21v2h1.92a6.931,6.931,0,0,1-.6053,2H21v1.89c-.0364.0372-.073.0738-.11.11H19v1.3149a6.9231,6.9231,0,0,1-2,.605V21H15v1.92A7.004,7.004,0,0,1,9,16Z"
    })), children);
  });
  var WatsonHealthWindowBlackSaturation16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowBlackSaturation16(_ref228, ref) {
    var children = _ref228.children,
        rest = _objectWithoutProperties(_ref228, _excluded228);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path463 || (_path463 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"
    })), _path464 || (_path464 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M6.225 5.729H8.228V8.732H6.225z",
      transform: "rotate(-45 7.227 7.23)"
    })), _path465 || (_path465 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.267 6.227H26.267V8.227H23.267z",
      transform: "rotate(-45 24.767 7.227)"
    })), _path466 || (_path466 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23.769 23.269H25.770999999999997V26.270999999999997H23.769z",
      transform: "rotate(-44.999 24.77 24.77)"
    })), _path467 || (_path467 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M5.47 25.126L7.591 23 9 24.419 6.884 26.54 5.47 25.126zM15 13H17V15H15zM19 13H21V15H19zM17 11H19V13H17zM17 15H19V17H17zM17 19H19V21H17zM15 17H17V19H15zM19 17H21V19H19z"
    })), _path468 || (_path468 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,7ZM9,16a7.004,7.004,0,0,1,6-6.92V11h2V9.08a6.9231,6.9231,0,0,1,2,.605V11h1.89c.0374.0366.074.0732.11.11V13h1.3149a6.931,6.931,0,0,1,.6053,2H21v2h1.92a6.931,6.931,0,0,1-.6053,2H21v1.89c-.0364.0372-.073.0738-.11.11H19v1.3149a6.9231,6.9231,0,0,1-2,.605V21H15v1.92A7.004,7.004,0,0,1,9,16Z"
    })), children);
  });
  var WatsonHealthWindowOverlay32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowOverlay32(_ref229, ref) {
    var children = _ref229.children,
        rest = _objectWithoutProperties(_ref229, _excluded229);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path469 || (_path469 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"
    })), _path470 || (_path470 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 9.03H9.55V12.03H7.55z",
      transform: "rotate(-45 8.558 10.545)"
    })), _path471 || (_path471 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 9.54H24.96V11.54H21.96z",
      transform: "rotate(-45 23.466 10.54)"
    })), _path472 || (_path472 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 23.94H24.46V26.94H22.46z",
      transform: "rotate(-45 23.459 25.443)"
    })), _path473 || (_path473 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 24.45H10.04V26.45H7.04z",
      transform: "rotate(-45 8.55 25.448)"
    })), _path474 || (_path474 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2H28V4H4zM16 24a6 6 0 10-6-6A6 6 0 0016 24zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowOverlay24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowOverlay24(_ref230, ref) {
    var children = _ref230.children,
        rest = _objectWithoutProperties(_ref230, _excluded230);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path475 || (_path475 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"
    })), _path476 || (_path476 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 9.03H9.55V12.03H7.55z",
      transform: "rotate(-45 8.558 10.545)"
    })), _path477 || (_path477 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 9.54H24.96V11.54H21.96z",
      transform: "rotate(-45 23.466 10.54)"
    })), _path478 || (_path478 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 23.94H24.46V26.94H22.46z",
      transform: "rotate(-45 23.459 25.443)"
    })), _path479 || (_path479 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 24.45H10.04V26.45H7.04z",
      transform: "rotate(-45 8.55 25.448)"
    })), _path480 || (_path480 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2H28V4H4zM16 24a6 6 0 10-6-6A6 6 0 0016 24zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowOverlay20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowOverlay20(_ref231, ref) {
    var children = _ref231.children,
        rest = _objectWithoutProperties(_ref231, _excluded231);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path481 || (_path481 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"
    })), _path482 || (_path482 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 9.03H9.55V12.03H7.55z",
      transform: "rotate(-45 8.558 10.545)"
    })), _path483 || (_path483 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 9.54H24.96V11.54H21.96z",
      transform: "rotate(-45 23.466 10.54)"
    })), _path484 || (_path484 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 23.94H24.46V26.94H22.46z",
      transform: "rotate(-45 23.459 25.443)"
    })), _path485 || (_path485 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 24.45H10.04V26.45H7.04z",
      transform: "rotate(-45 8.55 25.448)"
    })), _path486 || (_path486 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2H28V4H4zM16 24a6 6 0 10-6-6A6 6 0 0016 24zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowOverlay16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowOverlay16(_ref232, ref) {
    var children = _ref232.children,
        rest = _objectWithoutProperties(_ref232, _excluded232);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path487 || (_path487 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"
    })), _path488 || (_path488 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.55 9.03H9.55V12.03H7.55z",
      transform: "rotate(-45 8.558 10.545)"
    })), _path489 || (_path489 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.96 9.54H24.96V11.54H21.96z",
      transform: "rotate(-45 23.466 10.54)"
    })), _path490 || (_path490 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.46 23.94H24.46V26.94H22.46z",
      transform: "rotate(-45 23.459 25.443)"
    })), _path491 || (_path491 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M7.04 24.45H10.04V26.45H7.04z",
      transform: "rotate(-45 8.55 25.448)"
    })), _path492 || (_path492 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 2H28V4H4zM16 24a6 6 0 10-6-6A6 6 0 0016 24zm0-10v8a4 4 0 010-8z"
    })), children);
  });
  var WatsonHealthWindowPreset32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowPreset32(_ref233, ref) {
    var children = _ref233.children,
        rest = _objectWithoutProperties(_ref233, _excluded233);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path493 || (_path493 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V8H15zM24 15H26V17H24zM15 24H17V26H15zM6 15H8V17H6z"
    })), _path494 || (_path494 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 8.586H10.586V10.586H8.586z",
      transform: "rotate(-45 9.586 9.586)"
    })), _path495 || (_path495 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.586H23.414V10.586H21.414z",
      transform: "rotate(-45 22.414 9.586)"
    })), _path496 || (_path496 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 21.414H23.414V23.414H21.414z",
      transform: "rotate(-45 22.414 22.414)"
    })), _path497 || (_path497 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 21.414H10.586V23.414H8.586z",
      transform: "rotate(-45 9.586 22.414)"
    })), _path498 || (_path498 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,0-6-6A6,6,0,0,0,16,22Zm0-10v8a4,4,0,0,1,0-8Z"
    })), _path499 || (_path499 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var WatsonHealthWindowPreset24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowPreset24(_ref234, ref) {
    var children = _ref234.children,
        rest = _objectWithoutProperties(_ref234, _excluded234);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path500 || (_path500 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V8H15zM24 15H26V17H24zM15 24H17V26H15zM6 15H8V17H6z"
    })), _path501 || (_path501 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 8.586H10.586V10.586H8.586z",
      transform: "rotate(-45 9.586 9.586)"
    })), _path502 || (_path502 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.586H23.414V10.586H21.414z",
      transform: "rotate(-45 22.414 9.586)"
    })), _path503 || (_path503 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 21.414H23.414V23.414H21.414z",
      transform: "rotate(-45 22.414 22.414)"
    })), _path504 || (_path504 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 21.414H10.586V23.414H8.586z",
      transform: "rotate(-45 9.586 22.414)"
    })), _path505 || (_path505 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,0-6-6A6,6,0,0,0,16,22Zm0-10v8a4,4,0,0,1,0-8Z"
    })), _path506 || (_path506 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var WatsonHealthWindowPreset20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowPreset20(_ref235, ref) {
    var children = _ref235.children,
        rest = _objectWithoutProperties(_ref235, _excluded235);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path507 || (_path507 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V8H15zM24 15H26V17H24zM15 24H17V26H15zM6 15H8V17H6z"
    })), _path508 || (_path508 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 8.586H10.586V10.586H8.586z",
      transform: "rotate(-45 9.586 9.586)"
    })), _path509 || (_path509 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.586H23.414V10.586H21.414z",
      transform: "rotate(-45 22.414 9.586)"
    })), _path510 || (_path510 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 21.414H23.414V23.414H21.414z",
      transform: "rotate(-45 22.414 22.414)"
    })), _path511 || (_path511 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 21.414H10.586V23.414H8.586z",
      transform: "rotate(-45 9.586 22.414)"
    })), _path512 || (_path512 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,0-6-6A6,6,0,0,0,16,22Zm0-10v8a4,4,0,0,1,0-8Z"
    })), _path513 || (_path513 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var WatsonHealthWindowPreset16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthWindowPreset16(_ref236, ref) {
    var children = _ref236.children,
        rest = _objectWithoutProperties(_ref236, _excluded236);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path514 || (_path514 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 6H17V8H15zM24 15H26V17H24zM15 24H17V26H15zM6 15H8V17H6z"
    })), _path515 || (_path515 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 8.586H10.586V10.586H8.586z",
      transform: "rotate(-45 9.586 9.586)"
    })), _path516 || (_path516 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 8.586H23.414V10.586H21.414z",
      transform: "rotate(-45 22.414 9.586)"
    })), _path517 || (_path517 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.414 21.414H23.414V23.414H21.414z",
      transform: "rotate(-45 22.414 22.414)"
    })), _path518 || (_path518 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8.586 21.414H10.586V23.414H8.586z",
      transform: "rotate(-45 9.586 22.414)"
    })), _path519 || (_path519 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,22a6,6,0,1,0-6-6A6,6,0,0,0,16,22Zm0-10v8a4,4,0,0,1,0-8Z"
    })), _path520 || (_path520 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28,30H4a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,4,2H28a2.0021,2.0021,0,0,1,2,2V28A2.0021,2.0021,0,0,1,28,30ZM4,4V28H28V4Z"
    })), children);
  });
  var Windy32 = /*#__PURE__*/React__default['default'].forwardRef(function Windy32(_ref237, ref) {
    var children = _ref237.children,
        rest = _objectWithoutProperties(_ref237, _excluded237);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path521 || (_path521 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15H8V13H21a3 3 0 10-3-3H16a5 5 0 115 5zM23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H4V18H23a5 5 0 010 10z"
    })), children);
  });
  var Windy24 = /*#__PURE__*/React__default['default'].forwardRef(function Windy24(_ref238, ref) {
    var children = _ref238.children,
        rest = _objectWithoutProperties(_ref238, _excluded238);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path522 || (_path522 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15H8V13H21a3 3 0 10-3-3H16a5 5 0 115 5zM23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H4V18H23a5 5 0 010 10z"
    })), children);
  });
  var Windy20 = /*#__PURE__*/React__default['default'].forwardRef(function Windy20(_ref239, ref) {
    var children = _ref239.children,
        rest = _objectWithoutProperties(_ref239, _excluded239);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path523 || (_path523 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15H8V13H21a3 3 0 10-3-3H16a5 5 0 115 5zM23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H4V18H23a5 5 0 010 10z"
    })), children);
  });
  var Windy16 = /*#__PURE__*/React__default['default'].forwardRef(function Windy16(_ref240, ref) {
    var children = _ref240.children,
        rest = _objectWithoutProperties(_ref240, _excluded240);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path524 || (_path524 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21 15H8V13H21a3 3 0 10-3-3H16a5 5 0 115 5zM23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H4V18H23a5 5 0 010 10z"
    })), children);
  });
  var WindyDust32 = /*#__PURE__*/React__default['default'].forwardRef(function WindyDust32(_ref241, ref) {
    var children = _ref241.children,
        rest = _objectWithoutProperties(_ref241, _excluded241);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path525 || (_path525 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H22V18h1a5 5 0 010 10zM16 18H20V20H16zM10 18H14V20H10zM4 18H8V20H4zM21 15H20V13h1a3 3 0 10-3-3H16a5 5 0 115 5zM14 13H18V15H14zM8 13H12V15H8z"
    })), children);
  });
  var WindyDust24 = /*#__PURE__*/React__default['default'].forwardRef(function WindyDust24(_ref242, ref) {
    var children = _ref242.children,
        rest = _objectWithoutProperties(_ref242, _excluded242);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path526 || (_path526 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H22V18h1a5 5 0 010 10zM16 18H20V20H16zM10 18H14V20H10zM4 18H8V20H4zM21 15H20V13h1a3 3 0 10-3-3H16a5 5 0 115 5zM14 13H18V15H14zM8 13H12V15H8z"
    })), children);
  });
  var WindyDust20 = /*#__PURE__*/React__default['default'].forwardRef(function WindyDust20(_ref243, ref) {
    var children = _ref243.children,
        rest = _objectWithoutProperties(_ref243, _excluded243);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path527 || (_path527 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H22V18h1a5 5 0 010 10zM16 18H20V20H16zM10 18H14V20H10zM4 18H8V20H4zM21 15H20V13h1a3 3 0 10-3-3H16a5 5 0 115 5zM14 13H18V15H14zM8 13H12V15H8z"
    })), children);
  });
  var WindyDust16 = /*#__PURE__*/React__default['default'].forwardRef(function WindyDust16(_ref244, ref) {
    var children = _ref244.children,
        rest = _objectWithoutProperties(_ref244, _excluded244);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path528 || (_path528 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H22V18h1a5 5 0 010 10zM16 18H20V20H16zM10 18H14V20H10zM4 18H8V20H4zM21 15H20V13h1a3 3 0 10-3-3H16a5 5 0 115 5zM14 13H18V15H14zM8 13H12V15H8z"
    })), children);
  });
  var WindySnow32 = /*#__PURE__*/React__default['default'].forwardRef(function WindySnow32(_ref245, ref) {
    var children = _ref245.children,
        rest = _objectWithoutProperties(_ref245, _excluded245);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path529 || (_path529 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H6V18H25a5 5 0 010 10zM23 15H10V13H23a3 3 0 10-3-3H18a5 5 0 115 5z"
    })), _path530 || (_path530 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23H13V25H11zM13 25H15V27H13zM15 27H17V29H15zM15 23H17V25H15zM11 27H13V29H11zM6 4H8V6H6zM8 6H10V8H8zM10 8H12V10H10zM10 4H12V6H10zM6 8H8V10H6zM2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2z"
    })), children);
  });
  var WindySnow24 = /*#__PURE__*/React__default['default'].forwardRef(function WindySnow24(_ref246, ref) {
    var children = _ref246.children,
        rest = _objectWithoutProperties(_ref246, _excluded246);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path531 || (_path531 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H6V18H25a5 5 0 010 10zM23 15H10V13H23a3 3 0 10-3-3H18a5 5 0 115 5z"
    })), _path532 || (_path532 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23H13V25H11zM13 25H15V27H13zM15 27H17V29H15zM15 23H17V25H15zM11 27H13V29H11zM6 4H8V6H6zM8 6H10V8H8zM10 8H12V10H10zM10 4H12V6H10zM6 8H8V10H6zM2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2z"
    })), children);
  });
  var WindySnow20 = /*#__PURE__*/React__default['default'].forwardRef(function WindySnow20(_ref247, ref) {
    var children = _ref247.children,
        rest = _objectWithoutProperties(_ref247, _excluded247);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path533 || (_path533 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H6V18H25a5 5 0 010 10zM23 15H10V13H23a3 3 0 10-3-3H18a5 5 0 115 5z"
    })), _path534 || (_path534 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23H13V25H11zM13 25H15V27H13zM15 27H17V29H15zM15 23H17V25H15zM11 27H13V29H11zM6 4H8V6H6zM8 6H10V8H8zM10 8H12V10H10zM10 4H12V6H10zM6 8H8V10H6zM2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2z"
    })), children);
  });
  var WindySnow16 = /*#__PURE__*/React__default['default'].forwardRef(function WindySnow16(_ref248, ref) {
    var children = _ref248.children,
        rest = _objectWithoutProperties(_ref248, _excluded248);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path535 || (_path535 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 28a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H6V18H25a5 5 0 010 10zM23 15H10V13H23a3 3 0 10-3-3H18a5 5 0 115 5z"
    })), _path536 || (_path536 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M11 23H13V25H11zM13 25H15V27H13zM15 27H17V29H15zM15 23H17V25H15zM11 27H13V29H11zM6 4H8V6H6zM8 6H10V8H8zM10 8H12V10H10zM10 4H12V6H10zM6 8H8V10H6zM2 26H4V28H2zM4 28H6V30H4zM6 30H8V32H6zM6 26H8V28H6zM2 30H4V32H2z"
    })), children);
  });
  var WindyStrong32 = /*#__PURE__*/React__default['default'].forwardRef(function WindyStrong32(_ref249, ref) {
    var children = _ref249.children,
        rest = _objectWithoutProperties(_ref249, _excluded249);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path537 || (_path537 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a5.0057,5.0057,0,0,1-5-5h2a3,3,0,1,0,3-3H4V20h9a5,5,0,0,1,0,10Z"
    })), _path538 || (_path538 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 25a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H2V15H25a5 5 0 010 10zM21 12H6V10H21a3 3 0 10-3-3H16a5 5 0 115 5z"
    })), children);
  });
  var WindyStrong24 = /*#__PURE__*/React__default['default'].forwardRef(function WindyStrong24(_ref250, ref) {
    var children = _ref250.children,
        rest = _objectWithoutProperties(_ref250, _excluded250);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path539 || (_path539 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a5.0057,5.0057,0,0,1-5-5h2a3,3,0,1,0,3-3H4V20h9a5,5,0,0,1,0,10Z"
    })), _path540 || (_path540 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 25a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H2V15H25a5 5 0 010 10zM21 12H6V10H21a3 3 0 10-3-3H16a5 5 0 115 5z"
    })), children);
  });

  var _path, _path2, _path3, _path4, _path5, _path6, _path7, _path8, _path9, _path10, _path11, _path12, _path13, _path14, _path15, _path16, _path17, _path18, _path19, _path20, _path21, _path22, _path23, _path24, _path25, _path26, _path27, _path28, _path29, _path30, _path31, _path32, _path33, _path34, _path35, _path36, _path37, _path38, _path39, _path40, _path41, _path42, _path43, _path44, _path45, _path46, _path47, _path48, _path49, _path50, _path51, _path52, _path53, _path54, _path55, _path56, _path57, _path58, _path59, _path60, _path61, _path62, _path63, _path64, _path65, _path66, _path67, _path68, _path69, _path70, _path71, _path72, _path73, _path74, _path75, _path76, _path77, _path78, _path79, _path80, _path81, _path82, _path83, _path84, _path85, _path86, _path87, _path88, _path89, _path90, _path91, _path92, _path93, _path94, _path95, _path96, _path97, _path98, _path99, _path100, _path101, _path102, _path103, _path104, _path105, _path106, _path107, _path108, _path109, _path110, _path111, _path112, _path113, _path114, _path115, _path116, _path117, _path118, _path119, _path120, _path121, _path122, _path123, _path124, _path125, _path126, _path127, _path128, _path129, _path130, _path131, _path132, _path133, _path134, _path135, _path136, _path137, _path138, _path139, _path140, _path141, _path142, _path143, _path144, _path145, _path146, _path147, _path148, _path149, _path150, _path151, _path152, _path153, _path154, _path155, _path156, _path157, _path158, _path159, _path160, _path161, _path162, _path163, _path164, _path165, _path166, _path167, _path168, _path169, _path170, _path171, _path172, _path173, _path174, _path175, _path176;

  var _excluded = ["children"],
      _excluded2 = ["children"],
      _excluded3 = ["children"],
      _excluded4 = ["children"],
      _excluded5 = ["children"],
      _excluded6 = ["children"],
      _excluded7 = ["children"],
      _excluded8 = ["children"],
      _excluded9 = ["children"],
      _excluded10 = ["children"],
      _excluded11 = ["children"],
      _excluded12 = ["children"],
      _excluded13 = ["children"],
      _excluded14 = ["children"],
      _excluded15 = ["children"],
      _excluded16 = ["children"],
      _excluded17 = ["children"],
      _excluded18 = ["children"],
      _excluded19 = ["children"],
      _excluded20 = ["children"],
      _excluded21 = ["children"],
      _excluded22 = ["children"],
      _excluded23 = ["children"],
      _excluded24 = ["children"],
      _excluded25 = ["children"],
      _excluded26 = ["children"],
      _excluded27 = ["children"],
      _excluded28 = ["children"],
      _excluded29 = ["children"],
      _excluded30 = ["children"],
      _excluded31 = ["children"],
      _excluded32 = ["children"],
      _excluded33 = ["children"],
      _excluded34 = ["children"],
      _excluded35 = ["children"],
      _excluded36 = ["children"],
      _excluded37 = ["children"],
      _excluded38 = ["children"],
      _excluded39 = ["children"],
      _excluded40 = ["children"],
      _excluded41 = ["children"],
      _excluded42 = ["children"],
      _excluded43 = ["children"],
      _excluded44 = ["children"],
      _excluded45 = ["children"],
      _excluded46 = ["children"],
      _excluded47 = ["children"],
      _excluded48 = ["children"],
      _excluded49 = ["children"],
      _excluded50 = ["children"],
      _excluded51 = ["children"],
      _excluded52 = ["children"],
      _excluded53 = ["children"],
      _excluded54 = ["children"],
      _excluded55 = ["children"],
      _excluded56 = ["children"],
      _excluded57 = ["children"],
      _excluded58 = ["children"],
      _excluded59 = ["children"],
      _excluded60 = ["children"],
      _excluded61 = ["children"],
      _excluded62 = ["children"],
      _excluded63 = ["children"],
      _excluded64 = ["children"],
      _excluded65 = ["children"],
      _excluded66 = ["children"],
      _excluded67 = ["children"],
      _excluded68 = ["children"],
      _excluded69 = ["children"],
      _excluded70 = ["children"],
      _excluded71 = ["children"],
      _excluded72 = ["children"],
      _excluded73 = ["children"],
      _excluded74 = ["children"],
      _excluded75 = ["children"],
      _excluded76 = ["children"],
      _excluded77 = ["children"],
      _excluded78 = ["children"],
      _excluded79 = ["children"],
      _excluded80 = ["children"],
      _excluded81 = ["children"],
      _excluded82 = ["children"],
      _excluded83 = ["children"],
      _excluded84 = ["children"],
      _excluded85 = ["children"],
      _excluded86 = ["children"],
      _excluded87 = ["children"],
      _excluded88 = ["children"],
      _excluded89 = ["children"],
      _excluded90 = ["children"],
      _excluded91 = ["children"],
      _excluded92 = ["children"],
      _excluded93 = ["children"],
      _excluded94 = ["children"],
      _excluded95 = ["children"],
      _excluded96 = ["children"],
      _excluded97 = ["children"],
      _excluded98 = ["children"],
      _excluded99 = ["children"],
      _excluded100 = ["children"],
      _excluded101 = ["children"],
      _excluded102 = ["children"],
      _excluded103 = ["children"],
      _excluded104 = ["children"],
      _excluded105 = ["children"],
      _excluded106 = ["children"],
      _excluded107 = ["children"],
      _excluded108 = ["children"],
      _excluded109 = ["children"],
      _excluded110 = ["children"],
      _excluded111 = ["children"],
      _excluded112 = ["children"],
      _excluded113 = ["children"],
      _excluded114 = ["children"],
      _excluded115 = ["children"],
      _excluded116 = ["children"],
      _excluded117 = ["children"],
      _excluded118 = ["children"];
  var WindyStrong20 = /*#__PURE__*/React__default['default'].forwardRef(function WindyStrong20(_ref, ref) {
    var children = _ref.children,
        rest = _objectWithoutProperties(_ref, _excluded);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path || (_path = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a5.0057,5.0057,0,0,1-5-5h2a3,3,0,1,0,3-3H4V20h9a5,5,0,0,1,0,10Z"
    })), _path2 || (_path2 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 25a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H2V15H25a5 5 0 010 10zM21 12H6V10H21a3 3 0 10-3-3H16a5 5 0 115 5z"
    })), children);
  });
  var WindyStrong16 = /*#__PURE__*/React__default['default'].forwardRef(function WindyStrong16(_ref2, ref) {
    var children = _ref2.children,
        rest = _objectWithoutProperties(_ref2, _excluded2);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path3 || (_path3 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M13,30a5.0057,5.0057,0,0,1-5-5h2a3,3,0,1,0,3-3H4V20h9a5,5,0,0,1,0,10Z"
    })), _path4 || (_path4 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M25 25a5.0057 5.0057 0 01-5-5h2a3 3 0 103-3H2V15H25a5 5 0 010 10zM21 12H6V10H21a3 3 0 10-3-3H16a5 5 0 115 5z"
    })), children);
  });
  var WinterWarning32 = /*#__PURE__*/React__default['default'].forwardRef(function WinterWarning32(_ref3, ref) {
    var children = _ref3.children,
        rest = _objectWithoutProperties(_ref3, _excluded3);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path5 || (_path5 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.684 19.051L19.167 19.891 13 15.486 13 7.369 15.555 5.665 14.445 4.001 12 5.631 9.555 4.001 8.445 5.665 11 7.369 11 14.057 6 10.486 6 8 4 8 4 10.279 1.684 11.051 2.316 12.949 4.833 12.11 10.28 16.001 4.833 19.891 2.316 19.051 1.684 20.949 4 21.721 4 24 6 24 6 21.515 11 17.944 11 24.631 8.445 26.335 9.555 27.999 12 26.368 14.445 27.999 15.555 26.335 13 24.631 13 17.943 18 21.515 18 24 20 24 20 21.721 22.316 20.949 21.684 19.051z"
    })), _path6 || (_path6 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path7 || (_path7 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var WinterWarning24 = /*#__PURE__*/React__default['default'].forwardRef(function WinterWarning24(_ref4, ref) {
    var children = _ref4.children,
        rest = _objectWithoutProperties(_ref4, _excluded4);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path8 || (_path8 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.684 19.051L19.167 19.891 13 15.486 13 7.369 15.555 5.665 14.445 4.001 12 5.631 9.555 4.001 8.445 5.665 11 7.369 11 14.057 6 10.486 6 8 4 8 4 10.279 1.684 11.051 2.316 12.949 4.833 12.11 10.28 16.001 4.833 19.891 2.316 19.051 1.684 20.949 4 21.721 4 24 6 24 6 21.515 11 17.944 11 24.631 8.445 26.335 9.555 27.999 12 26.368 14.445 27.999 15.555 26.335 13 24.631 13 17.943 18 21.515 18 24 20 24 20 21.721 22.316 20.949 21.684 19.051z"
    })), _path9 || (_path9 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path10 || (_path10 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var WinterWarning20 = /*#__PURE__*/React__default['default'].forwardRef(function WinterWarning20(_ref5, ref) {
    var children = _ref5.children,
        rest = _objectWithoutProperties(_ref5, _excluded5);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path11 || (_path11 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.684 19.051L19.167 19.891 13 15.486 13 7.369 15.555 5.665 14.445 4.001 12 5.631 9.555 4.001 8.445 5.665 11 7.369 11 14.057 6 10.486 6 8 4 8 4 10.279 1.684 11.051 2.316 12.949 4.833 12.11 10.28 16.001 4.833 19.891 2.316 19.051 1.684 20.949 4 21.721 4 24 6 24 6 21.515 11 17.944 11 24.631 8.445 26.335 9.555 27.999 12 26.368 14.445 27.999 15.555 26.335 13 24.631 13 17.943 18 21.515 18 24 20 24 20 21.721 22.316 20.949 21.684 19.051z"
    })), _path12 || (_path12 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path13 || (_path13 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var WinterWarning16 = /*#__PURE__*/React__default['default'].forwardRef(function WinterWarning16(_ref6, ref) {
    var children = _ref6.children,
        rest = _objectWithoutProperties(_ref6, _excluded6);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path14 || (_path14 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.684 19.051L19.167 19.891 13 15.486 13 7.369 15.555 5.665 14.445 4.001 12 5.631 9.555 4.001 8.445 5.665 11 7.369 11 14.057 6 10.486 6 8 4 8 4 10.279 1.684 11.051 2.316 12.949 4.833 12.11 10.28 16.001 4.833 19.891 2.316 19.051 1.684 20.949 4 21.721 4 24 6 24 6 21.515 11 17.944 11 24.631 8.445 26.335 9.555 27.999 12 26.368 14.445 27.999 15.555 26.335 13 24.631 13 17.943 18 21.515 18 24 20 24 20 21.721 22.316 20.949 21.684 19.051z"
    })), _path15 || (_path15 = /*#__PURE__*/React__default['default'].createElement("path", {
      fill: "none",
      d: "M23.75,10h-1.5V6h1.5ZM23,11a1,1,0,1,0,1,1A1,1,0,0,0,23,11Z"
    })), _path16 || (_path16 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29.9115,13.9355,23.6284,2.3706a.7181.7181,0,0,0-1.2568,0L16.0885,13.9355A.72.72,0,0,0,16.72,15H29.28A.72.72,0,0,0,29.9115,13.9355ZM22.25,6h1.5v4h-1.5ZM23,13a1,1,0,1,1,1-1A1,1,0,0,1,23,13Z"
    })), children);
  });
  var WintryMix32 = /*#__PURE__*/React__default['default'].forwardRef(function WintryMix32(_ref7, ref) {
    var children = _ref7.children,
        rest = _objectWithoutProperties(_ref7, _excluded7);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path17 || (_path17 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 26H17V28H15zM17 28H19V30H17zM19 30H21V32H19zM19 26H21V28H19zM15 30H17V32H15zM13 16H15V18H13zM15 18H17V20H15zM17 20H19V22H17zM17 16H19V18H17zM13 20H15V22H13zM10 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0110 30z"
    })), _path18 || (_path18 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5V22l1,2,1-2V20.18a6.4891,6.4891,0,0,0,3.4294,1.7246L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418.977.977,0,0,0-.489-.0894V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20h-.542v.0083A.9955.9955,0,0,0,22,21v3l1,2,1-2V21.9746a6.4473,6.4473,0,0,0,2-.4761V26l1,2,1-2V20.18A6.4876,6.4876,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var WintryMix24 = /*#__PURE__*/React__default['default'].forwardRef(function WintryMix24(_ref8, ref) {
    var children = _ref8.children,
        rest = _objectWithoutProperties(_ref8, _excluded8);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path19 || (_path19 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 26H17V28H15zM17 28H19V30H17zM19 30H21V32H19zM19 26H21V28H19zM15 30H17V32H15zM13 16H15V18H13zM15 18H17V20H15zM17 20H19V22H17zM17 16H19V18H17zM13 20H15V22H13zM10 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0110 30z"
    })), _path20 || (_path20 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5V22l1,2,1-2V20.18a6.4891,6.4891,0,0,0,3.4294,1.7246L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418.977.977,0,0,0-.489-.0894V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20h-.542v.0083A.9955.9955,0,0,0,22,21v3l1,2,1-2V21.9746a6.4473,6.4473,0,0,0,2-.4761V26l1,2,1-2V20.18A6.4876,6.4876,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var WintryMix20 = /*#__PURE__*/React__default['default'].forwardRef(function WintryMix20(_ref9, ref) {
    var children = _ref9.children,
        rest = _objectWithoutProperties(_ref9, _excluded9);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path21 || (_path21 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 26H17V28H15zM17 28H19V30H17zM19 30H21V32H19zM19 26H21V28H19zM15 30H17V32H15zM13 16H15V18H13zM15 18H17V20H15zM17 20H19V22H17zM17 16H19V18H17zM13 20H15V22H13zM10 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0110 30z"
    })), _path22 || (_path22 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5V22l1,2,1-2V20.18a6.4891,6.4891,0,0,0,3.4294,1.7246L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418.977.977,0,0,0-.489-.0894V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20h-.542v.0083A.9955.9955,0,0,0,22,21v3l1,2,1-2V21.9746a6.4473,6.4473,0,0,0,2-.4761V26l1,2,1-2V20.18A6.4876,6.4876,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var WintryMix16 = /*#__PURE__*/React__default['default'].forwardRef(function WintryMix16(_ref10, ref) {
    var children = _ref10.children,
        rest = _objectWithoutProperties(_ref10, _excluded10);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path23 || (_path23 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15 26H17V28H15zM17 28H19V30H17zM19 30H21V32H19zM19 26H21V28H19zM15 30H17V32H15zM13 16H15V18H13zM15 18H17V20H15zM17 20H19V22H17zM17 16H19V18H17zM13 20H15V22H13zM10 30a1 1 0 01-.8944-1.4474l2-4.0005a1 1 0 111.7888.8947l-2 4A.9981.9981 0 0110 30z"
    })), _path24 || (_path24 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.8008,9.1362a8.9943,8.9943,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5V22l1,2,1-2V20.18a6.4891,6.4891,0,0,0,3.4294,1.7246L6.106,24.5527a1,1,0,1,0,1.7885.8946l2-4a1,1,0,0,0-.447-1.3418.977.977,0,0,0-.489-.0894V20H8.5a4.4975,4.4975,0,0,1-.356-8.981l.8155-.0639.0991-.812a6.9938,6.9938,0,0,1,13.8838,0l.0986.812.8154.0639A4.4975,4.4975,0,0,1,23.5,20h-.542v.0083A.9955.9955,0,0,0,22,21v3l1,2,1-2V21.9746a6.4473,6.4473,0,0,0,2-.4761V26l1,2,1-2V20.18A6.4876,6.4876,0,0,0,24.8008,9.1362Z"
    })), children);
  });
  var WirelessCheckout32 = /*#__PURE__*/React__default['default'].forwardRef(function WirelessCheckout32(_ref11, ref) {
    var children = _ref11.children,
        rest = _objectWithoutProperties(_ref11, _excluded11);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path25 || (_path25 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"
    })), _path26 || (_path26 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"
    })), _path27 || (_path27 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"
    })), children);
  });
  var WirelessCheckout24 = /*#__PURE__*/React__default['default'].forwardRef(function WirelessCheckout24(_ref12, ref) {
    var children = _ref12.children,
        rest = _objectWithoutProperties(_ref12, _excluded12);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path28 || (_path28 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"
    })), _path29 || (_path29 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"
    })), _path30 || (_path30 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"
    })), children);
  });
  var WirelessCheckout20 = /*#__PURE__*/React__default['default'].forwardRef(function WirelessCheckout20(_ref13, ref) {
    var children = _ref13.children,
        rest = _objectWithoutProperties(_ref13, _excluded13);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path31 || (_path31 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"
    })), _path32 || (_path32 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"
    })), _path33 || (_path33 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"
    })), children);
  });
  var WirelessCheckout16 = /*#__PURE__*/React__default['default'].forwardRef(function WirelessCheckout16(_ref14, ref) {
    var children = _ref14.children,
        rest = _objectWithoutProperties(_ref14, _excluded14);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path34 || (_path34 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"
    })), _path35 || (_path35 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"
    })), _path36 || (_path36 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"
    })), children);
  });
  var Wmv32 = /*#__PURE__*/React__default['default'].forwardRef(function Wmv32(_ref15, ref) {
    var children = _ref15.children,
        rest = _objectWithoutProperties(_ref15, _excluded15);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path37 || (_path37 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"
    })), children);
  });
  var Wmv24 = /*#__PURE__*/React__default['default'].forwardRef(function Wmv24(_ref16, ref) {
    var children = _ref16.children,
        rest = _objectWithoutProperties(_ref16, _excluded16);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path38 || (_path38 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"
    })), children);
  });
  var Wmv20 = /*#__PURE__*/React__default['default'].forwardRef(function Wmv20(_ref17, ref) {
    var children = _ref17.children,
        rest = _objectWithoutProperties(_ref17, _excluded17);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path39 || (_path39 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"
    })), children);
  });
  var Wmv16 = /*#__PURE__*/React__default['default'].forwardRef(function Wmv16(_ref18, ref) {
    var children = _ref18.children,
        rest = _objectWithoutProperties(_ref18, _excluded18);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path40 || (_path40 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"
    })), children);
  });
  var WordCloud32 = /*#__PURE__*/React__default['default'].forwardRef(function WordCloud32(_ref19, ref) {
    var children = _ref19.children,
        rest = _objectWithoutProperties(_ref19, _excluded19);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path41 || (_path41 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 20H18V22H10z"
    })), _path42 || (_path42 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a8.0233,8.0233,0,0,1,7.8649,6.4935l.2591,1.346,1.3488.244A5.5019,5.5019,0,0,1,24.5076,26H7.4954a5.5019,5.5019,0,0,1-.9695-10.9165l1.3488-.244.2591-1.346A8.0256,8.0256,0,0,1,16,7m0-2a10.0244,10.0244,0,0,0-9.83,8.1155A7.5019,7.5019,0,0,0,7.4911,28H24.5076a7.5019,7.5019,0,0,0,1.3213-14.8845A10.0229,10.0229,0,0,0,15.9883,5Z"
    })), children);
  });
  var WordCloud24 = /*#__PURE__*/React__default['default'].forwardRef(function WordCloud24(_ref20, ref) {
    var children = _ref20.children,
        rest = _objectWithoutProperties(_ref20, _excluded20);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path43 || (_path43 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 20H18V22H10z"
    })), _path44 || (_path44 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a8.0233,8.0233,0,0,1,7.8649,6.4935l.2591,1.346,1.3488.244A5.5019,5.5019,0,0,1,24.5076,26H7.4954a5.5019,5.5019,0,0,1-.9695-10.9165l1.3488-.244.2591-1.346A8.0256,8.0256,0,0,1,16,7m0-2a10.0244,10.0244,0,0,0-9.83,8.1155A7.5019,7.5019,0,0,0,7.4911,28H24.5076a7.5019,7.5019,0,0,0,1.3213-14.8845A10.0229,10.0229,0,0,0,15.9883,5Z"
    })), children);
  });
  var WordCloud20 = /*#__PURE__*/React__default['default'].forwardRef(function WordCloud20(_ref21, ref) {
    var children = _ref21.children,
        rest = _objectWithoutProperties(_ref21, _excluded21);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path45 || (_path45 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 20H18V22H10z"
    })), _path46 || (_path46 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a8.0233,8.0233,0,0,1,7.8649,6.4935l.2591,1.346,1.3488.244A5.5019,5.5019,0,0,1,24.5076,26H7.4954a5.5019,5.5019,0,0,1-.9695-10.9165l1.3488-.244.2591-1.346A8.0256,8.0256,0,0,1,16,7m0-2a10.0244,10.0244,0,0,0-9.83,8.1155A7.5019,7.5019,0,0,0,7.4911,28H24.5076a7.5019,7.5019,0,0,0,1.3213-14.8845A10.0229,10.0229,0,0,0,15.9883,5Z"
    })), children);
  });
  var WordCloud16 = /*#__PURE__*/React__default['default'].forwardRef(function WordCloud16(_ref22, ref) {
    var children = _ref22.children,
        rest = _objectWithoutProperties(_ref22, _excluded22);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path47 || (_path47 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 16H22V18H10zM10 20H18V22H10z"
    })), _path48 || (_path48 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16,7h0a8.0233,8.0233,0,0,1,7.8649,6.4935l.2591,1.346,1.3488.244A5.5019,5.5019,0,0,1,24.5076,26H7.4954a5.5019,5.5019,0,0,1-.9695-10.9165l1.3488-.244.2591-1.346A8.0256,8.0256,0,0,1,16,7m0-2a10.0244,10.0244,0,0,0-9.83,8.1155A7.5019,7.5019,0,0,0,7.4911,28H24.5076a7.5019,7.5019,0,0,0,1.3213-14.8845A10.0229,10.0229,0,0,0,15.9883,5Z"
    })), children);
  });
  var Workspace32 = /*#__PURE__*/React__default['default'].forwardRef(function Workspace32(_ref23, ref) {
    var children = _ref23.children,
        rest = _objectWithoutProperties(_ref23, _excluded23);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path49 || (_path49 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17v8H6V17H16m0-2H6a2 2 0 00-2 2v8a2 2 0 002 2H16a2 2 0 002-2V17a2 2 0 00-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 00-2 2v5a2 2 0 002 2h5a2 2 0 002-2V17a2 2 0 00-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var Workspace24 = /*#__PURE__*/React__default['default'].forwardRef(function Workspace24(_ref24, ref) {
    var children = _ref24.children,
        rest = _objectWithoutProperties(_ref24, _excluded24);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path50 || (_path50 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17v8H6V17H16m0-2H6a2 2 0 00-2 2v8a2 2 0 002 2H16a2 2 0 002-2V17a2 2 0 00-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 00-2 2v5a2 2 0 002 2h5a2 2 0 002-2V17a2 2 0 00-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var Workspace20 = /*#__PURE__*/React__default['default'].forwardRef(function Workspace20(_ref25, ref) {
    var children = _ref25.children,
        rest = _objectWithoutProperties(_ref25, _excluded25);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path51 || (_path51 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17v8H6V17H16m0-2H6a2 2 0 00-2 2v8a2 2 0 002 2H16a2 2 0 002-2V17a2 2 0 00-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 00-2 2v5a2 2 0 002 2h5a2 2 0 002-2V17a2 2 0 00-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var Workspace16 = /*#__PURE__*/React__default['default'].forwardRef(function Workspace16(_ref26, ref) {
    var children = _ref26.children,
        rest = _objectWithoutProperties(_ref26, _excluded26);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path52 || (_path52 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 17v8H6V17H16m0-2H6a2 2 0 00-2 2v8a2 2 0 002 2H16a2 2 0 002-2V17a2 2 0 00-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 00-2 2v5a2 2 0 002 2h5a2 2 0 002-2V17a2 2 0 00-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var WorkspaceImport32 = /*#__PURE__*/React__default['default'].forwardRef(function WorkspaceImport32(_ref27, ref) {
    var children = _ref27.children,
        rest = _objectWithoutProperties(_ref27, _excluded27);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path53 || (_path53 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM12 25H6V17h6V15H6a2 2 0 00-2 2v8a2 2 0 002 2h6zM30 20L16.828 20 19.414 17.414 18 16 13 21 18 26 19.414 24.586 16.828 22 30 22 30 20zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var WorkspaceImport24 = /*#__PURE__*/React__default['default'].forwardRef(function WorkspaceImport24(_ref28, ref) {
    var children = _ref28.children,
        rest = _objectWithoutProperties(_ref28, _excluded28);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path54 || (_path54 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM12 25H6V17h6V15H6a2 2 0 00-2 2v8a2 2 0 002 2h6zM30 20L16.828 20 19.414 17.414 18 16 13 21 18 26 19.414 24.586 16.828 22 30 22 30 20zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var WorkspaceImport20 = /*#__PURE__*/React__default['default'].forwardRef(function WorkspaceImport20(_ref29, ref) {
    var children = _ref29.children,
        rest = _objectWithoutProperties(_ref29, _excluded29);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path55 || (_path55 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM12 25H6V17h6V15H6a2 2 0 00-2 2v8a2 2 0 002 2h6zM30 20L16.828 20 19.414 17.414 18 16 13 21 18 26 19.414 24.586 16.828 22 30 22 30 20zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var WorkspaceImport16 = /*#__PURE__*/React__default['default'].forwardRef(function WorkspaceImport16(_ref30, ref) {
    var children = _ref30.children,
        rest = _objectWithoutProperties(_ref30, _excluded30);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path56 || (_path56 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27 6v5H17V6H27m0-2H17a2 2 0 00-2 2v5a2 2 0 002 2H27a2 2 0 002-2V6a2 2 0 00-2-2zM12 25H6V17h6V15H6a2 2 0 00-2 2v8a2 2 0 002 2h6zM30 20L16.828 20 19.414 17.414 18 16 13 21 18 26 19.414 24.586 16.828 22 30 22 30 20zM11 6v5H6V6h5m0-2H6A2 2 0 004 6v5a2 2 0 002 2h5a2 2 0 002-2V6a2 2 0 00-2-2z"
    })), children);
  });
  var Worship32 = /*#__PURE__*/React__default['default'].forwardRef(function Worship32(_ref31, ref) {
    var children = _ref31.children,
        rest = _objectWithoutProperties(_ref31, _excluded31);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path57 || (_path57 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,17,22,21.5859v0h0l-5-5a2.002,2.002,0,0,0-2.8286,0L9.585,21.1709A2.0031,2.0031,0,0,0,9.585,24l4.0009,4H6v2H16a1,1,0,0,0,.707-1.707L11,22.585,15.5852,18l5.7078,5.707a.9995.9995,0,0,0,1.414,0L28,18.4141Z"
    })), _path58 || (_path58 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5,17A3.5,3.5,0,1,1,25,13.5,3.5042,3.5042,0,0,1,21.5,17Zm0-5A1.5,1.5,0,1,0,23,13.5,1.5017,1.5017,0,0,0,21.5,12Z"
    })), _path59 || (_path59 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,10.5977l12-6.462,12.5264,6.7452.9472-1.7618-13-7a1.0045,1.0045,0,0,0-.9472,0l-13,7A1,1,0,0,0,2,10V30H4Z"
    })), children);
  });
  var Worship24 = /*#__PURE__*/React__default['default'].forwardRef(function Worship24(_ref32, ref) {
    var children = _ref32.children,
        rest = _objectWithoutProperties(_ref32, _excluded32);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path60 || (_path60 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,17,22,21.5859v0h0l-5-5a2.002,2.002,0,0,0-2.8286,0L9.585,21.1709A2.0031,2.0031,0,0,0,9.585,24l4.0009,4H6v2H16a1,1,0,0,0,.707-1.707L11,22.585,15.5852,18l5.7078,5.707a.9995.9995,0,0,0,1.414,0L28,18.4141Z"
    })), _path61 || (_path61 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5,17A3.5,3.5,0,1,1,25,13.5,3.5042,3.5042,0,0,1,21.5,17Zm0-5A1.5,1.5,0,1,0,23,13.5,1.5017,1.5017,0,0,0,21.5,12Z"
    })), _path62 || (_path62 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,10.5977l12-6.462,12.5264,6.7452.9472-1.7618-13-7a1.0045,1.0045,0,0,0-.9472,0l-13,7A1,1,0,0,0,2,10V30H4Z"
    })), children);
  });
  var Worship20 = /*#__PURE__*/React__default['default'].forwardRef(function Worship20(_ref33, ref) {
    var children = _ref33.children,
        rest = _objectWithoutProperties(_ref33, _excluded33);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path63 || (_path63 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,17,22,21.5859v0h0l-5-5a2.002,2.002,0,0,0-2.8286,0L9.585,21.1709A2.0031,2.0031,0,0,0,9.585,24l4.0009,4H6v2H16a1,1,0,0,0,.707-1.707L11,22.585,15.5852,18l5.7078,5.707a.9995.9995,0,0,0,1.414,0L28,18.4141Z"
    })), _path64 || (_path64 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5,17A3.5,3.5,0,1,1,25,13.5,3.5042,3.5042,0,0,1,21.5,17Zm0-5A1.5,1.5,0,1,0,23,13.5,1.5017,1.5017,0,0,0,21.5,12Z"
    })), _path65 || (_path65 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,10.5977l12-6.462,12.5264,6.7452.9472-1.7618-13-7a1.0045,1.0045,0,0,0-.9472,0l-13,7A1,1,0,0,0,2,10V30H4Z"
    })), children);
  });
  var Worship16 = /*#__PURE__*/React__default['default'].forwardRef(function Worship16(_ref34, ref) {
    var children = _ref34.children,
        rest = _objectWithoutProperties(_ref34, _excluded34);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path66 || (_path66 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26.5859,17,22,21.5859v0h0l-5-5a2.002,2.002,0,0,0-2.8286,0L9.585,21.1709A2.0031,2.0031,0,0,0,9.585,24l4.0009,4H6v2H16a1,1,0,0,0,.707-1.707L11,22.585,15.5852,18l5.7078,5.707a.9995.9995,0,0,0,1.414,0L28,18.4141Z"
    })), _path67 || (_path67 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.5,17A3.5,3.5,0,1,1,25,13.5,3.5042,3.5042,0,0,1,21.5,17Zm0-5A1.5,1.5,0,1,0,23,13.5,1.5017,1.5017,0,0,0,21.5,12Z"
    })), _path68 || (_path68 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4,10.5977l12-6.462,12.5264,6.7452.9472-1.7618-13-7a1.0045,1.0045,0,0,0-.9472,0l-13,7A1,1,0,0,0,2,10V30H4Z"
    })), children);
  });
  var WorshipChristian32 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipChristian32(_ref35, ref) {
    var children = _ref35.children,
        rest = _objectWithoutProperties(_ref35, _excluded35);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path69 || (_path69 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H15a2.0021,2.0021,0,0,1-2-2V14H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8h5V4a2.0021,2.0021,0,0,1,2-2h2a2.0021,2.0021,0,0,1,2,2V8h5a2.0021,2.0021,0,0,1,2,2v2a2.0021,2.0021,0,0,1-2,2H19V28A2.0021,2.0021,0,0,1,17,30ZM8,10v2h7V28h2V12h7V10H17V4H15v6Z"
    })), children);
  });
  var WorshipChristian24 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipChristian24(_ref36, ref) {
    var children = _ref36.children,
        rest = _objectWithoutProperties(_ref36, _excluded36);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path70 || (_path70 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H15a2.0021,2.0021,0,0,1-2-2V14H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8h5V4a2.0021,2.0021,0,0,1,2-2h2a2.0021,2.0021,0,0,1,2,2V8h5a2.0021,2.0021,0,0,1,2,2v2a2.0021,2.0021,0,0,1-2,2H19V28A2.0021,2.0021,0,0,1,17,30ZM8,10v2h7V28h2V12h7V10H17V4H15v6Z"
    })), children);
  });
  var WorshipChristian20 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipChristian20(_ref37, ref) {
    var children = _ref37.children,
        rest = _objectWithoutProperties(_ref37, _excluded37);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path71 || (_path71 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H15a2.0021,2.0021,0,0,1-2-2V14H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8h5V4a2.0021,2.0021,0,0,1,2-2h2a2.0021,2.0021,0,0,1,2,2V8h5a2.0021,2.0021,0,0,1,2,2v2a2.0021,2.0021,0,0,1-2,2H19V28A2.0021,2.0021,0,0,1,17,30ZM8,10v2h7V28h2V12h7V10H17V4H15v6Z"
    })), children);
  });
  var WorshipChristian16 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipChristian16(_ref38, ref) {
    var children = _ref38.children,
        rest = _objectWithoutProperties(_ref38, _excluded38);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path72 || (_path72 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M17,30H15a2.0021,2.0021,0,0,1-2-2V14H8a2.0021,2.0021,0,0,1-2-2V10A2.0021,2.0021,0,0,1,8,8h5V4a2.0021,2.0021,0,0,1,2-2h2a2.0021,2.0021,0,0,1,2,2V8h5a2.0021,2.0021,0,0,1,2,2v2a2.0021,2.0021,0,0,1-2,2H19V28A2.0021,2.0021,0,0,1,17,30ZM8,10v2h7V28h2V12h7V10H17V4H15v6Z"
    })), children);
  });
  var WorshipJewish32 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipJewish32(_ref39, ref) {
    var children = _ref39.children,
        rest = _objectWithoutProperties(_ref39, _excluded39);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path73 || (_path73 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.291,16l3.585-6.5181A1,1,0,0,0,27,8H19.8911L16.876,2.5181a1,1,0,0,0-1.752,0L12.1089,8H5a1,1,0,0,0-.876,1.4819L7.709,16,4.124,22.5181A1,1,0,0,0,5,24h7.1089l3.0151,5.4819a1,1,0,0,0,1.752,0L19.8911,24H27a1,1,0,0,0,.876-1.4819Zm-5.5823,6L16,26.9248,13.2913,22h-6.6l3.3-6-3.3-6h6.6L16,5.0752,18.7087,10h6.6l-3.3,6,3.3,6Z"
    })), children);
  });
  var WorshipJewish24 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipJewish24(_ref40, ref) {
    var children = _ref40.children,
        rest = _objectWithoutProperties(_ref40, _excluded40);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path74 || (_path74 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.291,16l3.585-6.5181A1,1,0,0,0,27,8H19.8911L16.876,2.5181a1,1,0,0,0-1.752,0L12.1089,8H5a1,1,0,0,0-.876,1.4819L7.709,16,4.124,22.5181A1,1,0,0,0,5,24h7.1089l3.0151,5.4819a1,1,0,0,0,1.752,0L19.8911,24H27a1,1,0,0,0,.876-1.4819Zm-5.5823,6L16,26.9248,13.2913,22h-6.6l3.3-6-3.3-6h6.6L16,5.0752,18.7087,10h6.6l-3.3,6,3.3,6Z"
    })), children);
  });
  var WorshipJewish20 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipJewish20(_ref41, ref) {
    var children = _ref41.children,
        rest = _objectWithoutProperties(_ref41, _excluded41);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path75 || (_path75 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.291,16l3.585-6.5181A1,1,0,0,0,27,8H19.8911L16.876,2.5181a1,1,0,0,0-1.752,0L12.1089,8H5a1,1,0,0,0-.876,1.4819L7.709,16,4.124,22.5181A1,1,0,0,0,5,24h7.1089l3.0151,5.4819a1,1,0,0,0,1.752,0L19.8911,24H27a1,1,0,0,0,.876-1.4819Zm-5.5823,6L16,26.9248,13.2913,22h-6.6l3.3-6-3.3-6h6.6L16,5.0752,18.7087,10h6.6l-3.3,6,3.3,6Z"
    })), children);
  });
  var WorshipJewish16 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipJewish16(_ref42, ref) {
    var children = _ref42.children,
        rest = _objectWithoutProperties(_ref42, _excluded42);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path76 || (_path76 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24.291,16l3.585-6.5181A1,1,0,0,0,27,8H19.8911L16.876,2.5181a1,1,0,0,0-1.752,0L12.1089,8H5a1,1,0,0,0-.876,1.4819L7.709,16,4.124,22.5181A1,1,0,0,0,5,24h7.1089l3.0151,5.4819a1,1,0,0,0,1.752,0L19.8911,24H27a1,1,0,0,0,.876-1.4819Zm-5.5823,6L16,26.9248,13.2913,22h-6.6l3.3-6-3.3-6h6.6L16,5.0752,18.7087,10h6.6l-3.3,6,3.3,6Z"
    })), children);
  });
  var WorshipMuslim32 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipMuslim32(_ref43, ref) {
    var children = _ref43.children,
        rest = _objectWithoutProperties(_ref43, _excluded43);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path77 || (_path77 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18a.9986.9986,0,0,1-.5415-.1594L22,14.9688l-4.4585,2.8718a1,1,0,0,1-1.5088-1.095l1.35-5.1318L14.3105,8.69a1,1,0,0,1,.5508-1.7146l4.3745-.6128,1.8663-3.8032A1.0008,1.0008,0,0,1,21.9878,2a1.0171,1.0171,0,0,1,.8989.5378L24.88,6.3625l4.2622.6133A1,1,0,0,1,29.69,8.69l-3.0723,2.9239,1.35,5.1318A1,1,0,0,1,27,18Zm-5-5.2207a.999.999,0,0,1,.5415.1594l2.8369,1.8272-.8457-3.2149a1.0006,1.0006,0,0,1,.2778-.9787l2.0074-1.91-2.73-.3929a.9994.9994,0,0,1-.7441-.5275L22.0269,5.2151,20.7979,7.72a1.0008,1.0008,0,0,1-.7593.55L17.19,8.6687l2,1.9036a1.0006,1.0006,0,0,1,.2778.9787l-.8457,3.2149,2.8369-1.8272A.999.999,0,0,1,22,12.7793Z"
    })), _path78 || (_path78 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8169,30A13.8137,13.8137,0,0,1,9.0752,4.1277a1,1,0,0,1,1.3613,1.3611A11.8091,11.8091,0,0,0,26.5107,21.5635a1,1,0,0,1,1.3619,1.3611A13.8411,13.8411,0,0,1,15.8169,30ZM7.3271,7.9727a11.81,11.81,0,0,0,16.7,16.7,13.8086,13.8086,0,0,1-16.7-16.7Z"
    })), children);
  });
  var WorshipMuslim24 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipMuslim24(_ref44, ref) {
    var children = _ref44.children,
        rest = _objectWithoutProperties(_ref44, _excluded44);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path79 || (_path79 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18a.9986.9986,0,0,1-.5415-.1594L22,14.9688l-4.4585,2.8718a1,1,0,0,1-1.5088-1.095l1.35-5.1318L14.3105,8.69a1,1,0,0,1,.5508-1.7146l4.3745-.6128,1.8663-3.8032A1.0008,1.0008,0,0,1,21.9878,2a1.0171,1.0171,0,0,1,.8989.5378L24.88,6.3625l4.2622.6133A1,1,0,0,1,29.69,8.69l-3.0723,2.9239,1.35,5.1318A1,1,0,0,1,27,18Zm-5-5.2207a.999.999,0,0,1,.5415.1594l2.8369,1.8272-.8457-3.2149a1.0006,1.0006,0,0,1,.2778-.9787l2.0074-1.91-2.73-.3929a.9994.9994,0,0,1-.7441-.5275L22.0269,5.2151,20.7979,7.72a1.0008,1.0008,0,0,1-.7593.55L17.19,8.6687l2,1.9036a1.0006,1.0006,0,0,1,.2778.9787l-.8457,3.2149,2.8369-1.8272A.999.999,0,0,1,22,12.7793Z"
    })), _path80 || (_path80 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8169,30A13.8137,13.8137,0,0,1,9.0752,4.1277a1,1,0,0,1,1.3613,1.3611A11.8091,11.8091,0,0,0,26.5107,21.5635a1,1,0,0,1,1.3619,1.3611A13.8411,13.8411,0,0,1,15.8169,30ZM7.3271,7.9727a11.81,11.81,0,0,0,16.7,16.7,13.8086,13.8086,0,0,1-16.7-16.7Z"
    })), children);
  });
  var WorshipMuslim20 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipMuslim20(_ref45, ref) {
    var children = _ref45.children,
        rest = _objectWithoutProperties(_ref45, _excluded45);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path81 || (_path81 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18a.9986.9986,0,0,1-.5415-.1594L22,14.9688l-4.4585,2.8718a1,1,0,0,1-1.5088-1.095l1.35-5.1318L14.3105,8.69a1,1,0,0,1,.5508-1.7146l4.3745-.6128,1.8663-3.8032A1.0008,1.0008,0,0,1,21.9878,2a1.0171,1.0171,0,0,1,.8989.5378L24.88,6.3625l4.2622.6133A1,1,0,0,1,29.69,8.69l-3.0723,2.9239,1.35,5.1318A1,1,0,0,1,27,18Zm-5-5.2207a.999.999,0,0,1,.5415.1594l2.8369,1.8272-.8457-3.2149a1.0006,1.0006,0,0,1,.2778-.9787l2.0074-1.91-2.73-.3929a.9994.9994,0,0,1-.7441-.5275L22.0269,5.2151,20.7979,7.72a1.0008,1.0008,0,0,1-.7593.55L17.19,8.6687l2,1.9036a1.0006,1.0006,0,0,1,.2778.9787l-.8457,3.2149,2.8369-1.8272A.999.999,0,0,1,22,12.7793Z"
    })), _path82 || (_path82 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8169,30A13.8137,13.8137,0,0,1,9.0752,4.1277a1,1,0,0,1,1.3613,1.3611A11.8091,11.8091,0,0,0,26.5107,21.5635a1,1,0,0,1,1.3619,1.3611A13.8411,13.8411,0,0,1,15.8169,30ZM7.3271,7.9727a11.81,11.81,0,0,0,16.7,16.7,13.8086,13.8086,0,0,1-16.7-16.7Z"
    })), children);
  });
  var WorshipMuslim16 = /*#__PURE__*/React__default['default'].forwardRef(function WorshipMuslim16(_ref46, ref) {
    var children = _ref46.children,
        rest = _objectWithoutProperties(_ref46, _excluded46);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path83 || (_path83 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27,18a.9986.9986,0,0,1-.5415-.1594L22,14.9688l-4.4585,2.8718a1,1,0,0,1-1.5088-1.095l1.35-5.1318L14.3105,8.69a1,1,0,0,1,.5508-1.7146l4.3745-.6128,1.8663-3.8032A1.0008,1.0008,0,0,1,21.9878,2a1.0171,1.0171,0,0,1,.8989.5378L24.88,6.3625l4.2622.6133A1,1,0,0,1,29.69,8.69l-3.0723,2.9239,1.35,5.1318A1,1,0,0,1,27,18Zm-5-5.2207a.999.999,0,0,1,.5415.1594l2.8369,1.8272-.8457-3.2149a1.0006,1.0006,0,0,1,.2778-.9787l2.0074-1.91-2.73-.3929a.9994.9994,0,0,1-.7441-.5275L22.0269,5.2151,20.7979,7.72a1.0008,1.0008,0,0,1-.7593.55L17.19,8.6687l2,1.9036a1.0006,1.0006,0,0,1,.2778.9787l-.8457,3.2149,2.8369-1.8272A.999.999,0,0,1,22,12.7793Z"
    })), _path84 || (_path84 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M15.8169,30A13.8137,13.8137,0,0,1,9.0752,4.1277a1,1,0,0,1,1.3613,1.3611A11.8091,11.8091,0,0,0,26.5107,21.5635a1,1,0,0,1,1.3619,1.3611A13.8411,13.8411,0,0,1,15.8169,30ZM7.3271,7.9727a11.81,11.81,0,0,0,16.7,16.7,13.8086,13.8086,0,0,1-16.7-16.7Z"
    })), children);
  });
  var QX32 = /*#__PURE__*/React__default['default'].forwardRef(function QX32(_ref47, ref) {
    var children = _ref47.children,
        rest = _objectWithoutProperties(_ref47, _excluded47);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path85 || (_path85 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"
    })), children);
  });
  var QX24 = /*#__PURE__*/React__default['default'].forwardRef(function QX24(_ref48, ref) {
    var children = _ref48.children,
        rest = _objectWithoutProperties(_ref48, _excluded48);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path86 || (_path86 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"
    })), children);
  });
  var QX20 = /*#__PURE__*/React__default['default'].forwardRef(function QX20(_ref49, ref) {
    var children = _ref49.children,
        rest = _objectWithoutProperties(_ref49, _excluded49);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path87 || (_path87 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"
    })), children);
  });
  var QX16 = /*#__PURE__*/React__default['default'].forwardRef(function QX16(_ref50, ref) {
    var children = _ref50.children,
        rest = _objectWithoutProperties(_ref50, _excluded50);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path88 || (_path88 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"
    })), children);
  });
  var XAxis32 = /*#__PURE__*/React__default['default'].forwardRef(function XAxis32(_ref51, ref) {
    var children = _ref51.children,
        rest = _objectWithoutProperties(_ref51, _excluded51);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path89 || (_path89 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"
    })), children);
  });
  var XAxis24 = /*#__PURE__*/React__default['default'].forwardRef(function XAxis24(_ref52, ref) {
    var children = _ref52.children,
        rest = _objectWithoutProperties(_ref52, _excluded52);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path90 || (_path90 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"
    })), children);
  });
  var XAxis20 = /*#__PURE__*/React__default['default'].forwardRef(function XAxis20(_ref53, ref) {
    var children = _ref53.children,
        rest = _objectWithoutProperties(_ref53, _excluded53);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path91 || (_path91 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"
    })), children);
  });
  var XAxis16 = /*#__PURE__*/React__default['default'].forwardRef(function XAxis16(_ref54, ref) {
    var children = _ref54.children,
        rest = _objectWithoutProperties(_ref54, _excluded54);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path92 || (_path92 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"
    })), children);
  });
  var Xls32 = /*#__PURE__*/React__default['default'].forwardRef(function Xls32(_ref55, ref) {
    var children = _ref55.children,
        rest = _objectWithoutProperties(_ref55, _excluded55);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path93 || (_path93 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H22V21h6V17H24a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0128 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"
    })), children);
  });
  var Xls24 = /*#__PURE__*/React__default['default'].forwardRef(function Xls24(_ref56, ref) {
    var children = _ref56.children,
        rest = _objectWithoutProperties(_ref56, _excluded56);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path94 || (_path94 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H22V21h6V17H24a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0128 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"
    })), children);
  });
  var Xls20 = /*#__PURE__*/React__default['default'].forwardRef(function Xls20(_ref57, ref) {
    var children = _ref57.children,
        rest = _objectWithoutProperties(_ref57, _excluded57);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path95 || (_path95 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H22V21h6V17H24a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0128 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"
    })), children);
  });
  var Xls16 = /*#__PURE__*/React__default['default'].forwardRef(function Xls16(_ref58, ref) {
    var children = _ref58.children,
        rest = _objectWithoutProperties(_ref58, _excluded58);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path96 || (_path96 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 23H22V21h6V17H24a2.002 2.002 0 01-2-2V11a2.002 2.002 0 012-2h6v2H24v4h4a2.002 2.002 0 012 2v4A2.0023 2.0023 0 0128 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"
    })), children);
  });
  var Xml32 = /*#__PURE__*/React__default['default'].forwardRef(function Xml32(_ref59, ref) {
    var children = _ref59.children,
        rest = _objectWithoutProperties(_ref59, _excluded59);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path97 || (_path97 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"
    })), children);
  });
  var Xml24 = /*#__PURE__*/React__default['default'].forwardRef(function Xml24(_ref60, ref) {
    var children = _ref60.children,
        rest = _objectWithoutProperties(_ref60, _excluded60);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path98 || (_path98 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"
    })), children);
  });
  var Xml20 = /*#__PURE__*/React__default['default'].forwardRef(function Xml20(_ref61, ref) {
    var children = _ref61.children,
        rest = _objectWithoutProperties(_ref61, _excluded61);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path99 || (_path99 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"
    })), children);
  });
  var Xml16 = /*#__PURE__*/React__default['default'].forwardRef(function Xml16(_ref62, ref) {
    var children = _ref62.children,
        rest = _objectWithoutProperties(_ref62, _excluded62);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path100 || (_path100 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"
    })), children);
  });
  var QY32 = /*#__PURE__*/React__default['default'].forwardRef(function QY32(_ref63, ref) {
    var children = _ref63.children,
        rest = _objectWithoutProperties(_ref63, _excluded63);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path101 || (_path101 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"
    })), children);
  });
  var QY24 = /*#__PURE__*/React__default['default'].forwardRef(function QY24(_ref64, ref) {
    var children = _ref64.children,
        rest = _objectWithoutProperties(_ref64, _excluded64);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path102 || (_path102 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"
    })), children);
  });
  var QY20 = /*#__PURE__*/React__default['default'].forwardRef(function QY20(_ref65, ref) {
    var children = _ref65.children,
        rest = _objectWithoutProperties(_ref65, _excluded65);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path103 || (_path103 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"
    })), children);
  });
  var QY16 = /*#__PURE__*/React__default['default'].forwardRef(function QY16(_ref66, ref) {
    var children = _ref66.children,
        rest = _objectWithoutProperties(_ref66, _excluded66);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path104 || (_path104 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"
    })), children);
  });
  var YAxis32 = /*#__PURE__*/React__default['default'].forwardRef(function YAxis32(_ref67, ref) {
    var children = _ref67.children,
        rest = _objectWithoutProperties(_ref67, _excluded67);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path105 || (_path105 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"
    })), children);
  });
  var YAxis24 = /*#__PURE__*/React__default['default'].forwardRef(function YAxis24(_ref68, ref) {
    var children = _ref68.children,
        rest = _objectWithoutProperties(_ref68, _excluded68);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path106 || (_path106 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"
    })), children);
  });
  var YAxis20 = /*#__PURE__*/React__default['default'].forwardRef(function YAxis20(_ref69, ref) {
    var children = _ref69.children,
        rest = _objectWithoutProperties(_ref69, _excluded69);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path107 || (_path107 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"
    })), children);
  });
  var YAxis16 = /*#__PURE__*/React__default['default'].forwardRef(function YAxis16(_ref70, ref) {
    var children = _ref70.children,
        rest = _objectWithoutProperties(_ref70, _excluded70);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path108 || (_path108 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"
    })), children);
  });
  var QZ32 = /*#__PURE__*/React__default['default'].forwardRef(function QZ32(_ref71, ref) {
    var children = _ref71.children,
        rest = _objectWithoutProperties(_ref71, _excluded71);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path109 || (_path109 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), children);
  });
  var QZ24 = /*#__PURE__*/React__default['default'].forwardRef(function QZ24(_ref72, ref) {
    var children = _ref72.children,
        rest = _objectWithoutProperties(_ref72, _excluded72);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path110 || (_path110 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), children);
  });
  var QZ20 = /*#__PURE__*/React__default['default'].forwardRef(function QZ20(_ref73, ref) {
    var children = _ref73.children,
        rest = _objectWithoutProperties(_ref73, _excluded73);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path111 || (_path111 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), children);
  });
  var QZ16 = /*#__PURE__*/React__default['default'].forwardRef(function QZ16(_ref74, ref) {
    var children = _ref74.children,
        rest = _objectWithoutProperties(_ref74, _excluded74);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path112 || (_path112 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"
    })), children);
  });
  var ZAxis32 = /*#__PURE__*/React__default['default'].forwardRef(function ZAxis32(_ref75, ref) {
    var children = _ref75.children,
        rest = _objectWithoutProperties(_ref75, _excluded75);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path113 || (_path113 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"
    })), children);
  });
  var ZAxis24 = /*#__PURE__*/React__default['default'].forwardRef(function ZAxis24(_ref76, ref) {
    var children = _ref76.children,
        rest = _objectWithoutProperties(_ref76, _excluded76);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path114 || (_path114 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"
    })), children);
  });
  var ZAxis20 = /*#__PURE__*/React__default['default'].forwardRef(function ZAxis20(_ref77, ref) {
    var children = _ref77.children,
        rest = _objectWithoutProperties(_ref77, _excluded77);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path115 || (_path115 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"
    })), children);
  });
  var ZAxis16 = /*#__PURE__*/React__default['default'].forwardRef(function ZAxis16(_ref78, ref) {
    var children = _ref78.children,
        rest = _objectWithoutProperties(_ref78, _excluded78);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path116 || (_path116 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"
    })), children);
  });
  var Zip32 = /*#__PURE__*/React__default['default'].forwardRef(function Zip32(_ref79, ref) {
    var children = _ref79.children,
        rest = _objectWithoutProperties(_ref79, _excluded79);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path117 || (_path117 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22V23h2V18h4a2 2 0 002-2V11A2 2 0 0028 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"
    })), children);
  });
  var Zip24 = /*#__PURE__*/React__default['default'].forwardRef(function Zip24(_ref80, ref) {
    var children = _ref80.children,
        rest = _objectWithoutProperties(_ref80, _excluded80);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path118 || (_path118 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22V23h2V18h4a2 2 0 002-2V11A2 2 0 0028 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"
    })), children);
  });
  var Zip20 = /*#__PURE__*/React__default['default'].forwardRef(function Zip20(_ref81, ref) {
    var children = _ref81.children,
        rest = _objectWithoutProperties(_ref81, _excluded81);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path119 || (_path119 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22V23h2V18h4a2 2 0 002-2V11A2 2 0 0028 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"
    })), children);
  });
  var Zip16 = /*#__PURE__*/React__default['default'].forwardRef(function Zip16(_ref82, ref) {
    var children = _ref82.children,
        rest = _objectWithoutProperties(_ref82, _excluded82);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path120 || (_path120 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M28 9H22V23h2V18h4a2 2 0 002-2V11A2 2 0 0028 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"
    })), children);
  });
  var ZipReference32 = /*#__PURE__*/React__default['default'].forwardRef(function ZipReference32(_ref83, ref) {
    var children = _ref83.children,
        rest = _objectWithoutProperties(_ref83, _excluded83);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path121 || (_path121 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 2H22V16h2V11h4a2 2 0 002-2V4A2 2 0 0028 2zm0 7H24V4h4zM12 4L15 4 15 14 12 14 12 16 20 16 20 14 17 14 17 4 20 4 20 2 12 2 12 4zM2 4L8 4 2 14 2 16 10 16 10 14 4 14 10 4 10 2 2 2 2 4z"
    })), children);
  });
  var ZipReference24 = /*#__PURE__*/React__default['default'].forwardRef(function ZipReference24(_ref84, ref) {
    var children = _ref84.children,
        rest = _objectWithoutProperties(_ref84, _excluded84);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path122 || (_path122 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 2H22V16h2V11h4a2 2 0 002-2V4A2 2 0 0028 2zm0 7H24V4h4zM12 4L15 4 15 14 12 14 12 16 20 16 20 14 17 14 17 4 20 4 20 2 12 2 12 4zM2 4L8 4 2 14 2 16 10 16 10 14 4 14 10 4 10 2 2 2 2 4z"
    })), children);
  });
  var ZipReference20 = /*#__PURE__*/React__default['default'].forwardRef(function ZipReference20(_ref85, ref) {
    var children = _ref85.children,
        rest = _objectWithoutProperties(_ref85, _excluded85);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path123 || (_path123 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 2H22V16h2V11h4a2 2 0 002-2V4A2 2 0 0028 2zm0 7H24V4h4zM12 4L15 4 15 14 12 14 12 16 20 16 20 14 17 14 17 4 20 4 20 2 12 2 12 4zM2 4L8 4 2 14 2 16 10 16 10 14 4 14 10 4 10 2 2 2 2 4z"
    })), children);
  });
  var ZipReference16 = /*#__PURE__*/React__default['default'].forwardRef(function ZipReference16(_ref86, ref) {
    var children = _ref86.children,
        rest = _objectWithoutProperties(_ref86, _excluded86);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path124 || (_path124 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 20L4 22 8.586 22 2 28.586 3.414 30 10 23.414 10 28 12 28 12 20 4 20zM28 2H22V16h2V11h4a2 2 0 002-2V4A2 2 0 0028 2zm0 7H24V4h4zM12 4L15 4 15 14 12 14 12 16 20 16 20 14 17 14 17 4 20 4 20 2 12 2 12 4zM2 4L8 4 2 14 2 16 10 16 10 14 4 14 10 4 10 2 2 2 2 4z"
    })), children);
  });
  var ZoomArea32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomArea32(_ref87, ref) {
    var children = _ref87.children,
        rest = _objectWithoutProperties(_ref87, _excluded87);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path125 || (_path125 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4z"
    })), children);
  });
  var ZoomArea24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomArea24(_ref88, ref) {
    var children = _ref88.children,
        rest = _objectWithoutProperties(_ref88, _excluded88);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path126 || (_path126 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4z"
    })), children);
  });
  var ZoomArea20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomArea20(_ref89, ref) {
    var children = _ref89.children,
        rest = _objectWithoutProperties(_ref89, _excluded89);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path127 || (_path127 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4z"
    })), children);
  });
  var ZoomArea16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomArea16(_ref90, ref) {
    var children = _ref90.children,
        rest = _objectWithoutProperties(_ref90, _excluded90);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path128 || (_path128 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4z"
    })), children);
  });
  var ZoomFit32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomFit32(_ref91, ref) {
    var children = _ref91.children,
        rest = _objectWithoutProperties(_ref91, _excluded91);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path129 || (_path129 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), _path130 || (_path130 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H8V10a2.0023 2.0023 0 012-2h2v2H10zM18 12H16V10H14V8h2a2.0023 2.0023 0 012 2zM12 18H10a2.0023 2.0023 0 01-2-2V14h2v2h2zM16 18H14V16h2V14h2v2A2.0023 2.0023 0 0116 18z"
    })), children);
  });
  var ZoomFit24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomFit24(_ref92, ref) {
    var children = _ref92.children,
        rest = _objectWithoutProperties(_ref92, _excluded92);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path131 || (_path131 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), _path132 || (_path132 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H8V10a2.0023 2.0023 0 012-2h2v2H10zM18 12H16V10H14V8h2a2.0023 2.0023 0 012 2zM12 18H10a2.0023 2.0023 0 01-2-2V14h2v2h2zM16 18H14V16h2V14h2v2A2.0023 2.0023 0 0116 18z"
    })), children);
  });
  var ZoomFit20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomFit20(_ref93, ref) {
    var children = _ref93.children,
        rest = _objectWithoutProperties(_ref93, _excluded93);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path133 || (_path133 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), _path134 || (_path134 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H8V10a2.0023 2.0023 0 012-2h2v2H10zM18 12H16V10H14V8h2a2.0023 2.0023 0 012 2zM12 18H10a2.0023 2.0023 0 01-2-2V14h2v2h2zM16 18H14V16h2V14h2v2A2.0023 2.0023 0 0116 18z"
    })), children);
  });
  var ZoomFit16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomFit16(_ref94, ref) {
    var children = _ref94.children,
        rest = _objectWithoutProperties(_ref94, _excluded94);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path135 || (_path135 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), _path136 || (_path136 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10 12H8V10a2.0023 2.0023 0 012-2h2v2H10zM18 12H16V10H14V8h2a2.0023 2.0023 0 012 2zM12 18H10a2.0023 2.0023 0 01-2-2V14h2v2h2zM16 18H14V16h2V14h2v2A2.0023 2.0023 0 0116 18z"
    })), children);
  });
  var ZoomIn32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomIn32(_ref95, ref) {
    var children = _ref95.children,
        rest = _objectWithoutProperties(_ref95, _excluded95);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path137 || (_path137 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 12L14 12 14 8 12 8 12 12 8 12 8 14 12 14 12 18 14 18 14 14 18 14 18 12z"
    })), _path138 || (_path138 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), children);
  });
  var ZoomIn24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomIn24(_ref96, ref) {
    var children = _ref96.children,
        rest = _objectWithoutProperties(_ref96, _excluded96);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path139 || (_path139 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 12L14 12 14 8 12 8 12 12 8 12 8 14 12 14 12 18 14 18 14 14 18 14 18 12z"
    })), _path140 || (_path140 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), children);
  });
  var ZoomIn20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomIn20(_ref97, ref) {
    var children = _ref97.children,
        rest = _objectWithoutProperties(_ref97, _excluded97);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path141 || (_path141 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M18 12L14 12 14 8 12 8 12 12 8 12 8 14 12 14 12 18 14 18 14 14 18 14 18 12z"
    })), _path142 || (_path142 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), children);
  });
  var ZoomIn16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomIn16(_ref98, ref) {
    var children = _ref98.children,
        rest = _objectWithoutProperties(_ref98, _excluded98);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path143 || (_path143 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M9 6L7 6 7 4 6 4 6 6 4 6 4 7 6 7 6 9 7 9 7 7 9 7z"
    })), _path144 || (_path144 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7,10C11.5,9,12,7.8,12,6.5C12,3.5,9.5,1,6.5,1S1,3.5,1,6.5S3.5,12,6.5,12c1.3,0,2.5-0.5,3.5-1.3l3.8,3.8l0.7-0.7\tL10.7,10z M6.5,11C4,11,2,9,2,6.5S4,2,6.5,2S11,4,11,6.5S9,11,6.5,11L6.5,11z"
    })), children);
  });
  var ZoomInArea32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomInArea32(_ref99, ref) {
    var children = _ref99.children,
        rest = _objectWithoutProperties(_ref99, _excluded99);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path145 || (_path145 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 19L21 19 21 16 19 16 19 19 16 19 16 21 19 21 19 24 21 24 21 21 24 21 24 19z"
    })), _path146 || (_path146 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomInArea24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomInArea24(_ref100, ref) {
    var children = _ref100.children,
        rest = _objectWithoutProperties(_ref100, _excluded100);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path147 || (_path147 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 19L21 19 21 16 19 16 19 19 16 19 16 21 19 21 19 24 21 24 21 21 24 21 24 19z"
    })), _path148 || (_path148 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomInArea20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomInArea20(_ref101, ref) {
    var children = _ref101.children,
        rest = _objectWithoutProperties(_ref101, _excluded101);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path149 || (_path149 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 19L21 19 21 16 19 16 19 19 16 19 16 21 19 21 19 24 21 24 21 21 24 21 24 19z"
    })), _path150 || (_path150 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomInArea16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomInArea16(_ref102, ref) {
    var children = _ref102.children,
        rest = _objectWithoutProperties(_ref102, _excluded102);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path151 || (_path151 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M24 19L21 19 21 16 19 16 19 19 16 19 16 21 19 21 19 24 21 24 21 21 24 21 24 19z"
    })), _path152 || (_path152 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomOut32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOut32(_ref103, ref) {
    var children = _ref103.children,
        rest = _objectWithoutProperties(_ref103, _excluded103);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path153 || (_path153 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H18V14H8z"
    })), _path154 || (_path154 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), children);
  });
  var ZoomOut24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOut24(_ref104, ref) {
    var children = _ref104.children,
        rest = _objectWithoutProperties(_ref104, _excluded104);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path155 || (_path155 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H18V14H8z"
    })), _path156 || (_path156 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), children);
  });
  var ZoomOut20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOut20(_ref105, ref) {
    var children = _ref105.children,
        rest = _objectWithoutProperties(_ref105, _excluded105);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path157 || (_path157 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M8 12H18V14H8z"
    })), _path158 || (_path158 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M21.4479,20A10.856,10.856,0,0,0,24,13,11,11,0,1,0,13,24a10.856,10.856,0,0,0,7-2.5521L27.5859,29,29,27.5859ZM13,22a9,9,0,1,1,9-9A9.01,9.01,0,0,1,13,22Z"
    })), children);
  });
  var ZoomOut16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOut16(_ref106, ref) {
    var children = _ref106.children,
        rest = _objectWithoutProperties(_ref106, _excluded106);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 16 16",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path159 || (_path159 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M4 6H9V7H4z"
    })), _path160 || (_path160 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M10.7,10C11.5,9,12,7.8,12,6.5C12,3.5,9.5,1,6.5,1S1,3.5,1,6.5S3.5,12,6.5,12c1.3,0,2.5-0.5,3.5-1.3l3.8,3.8l0.7-0.7\tL10.7,10z M6.5,11C4,11,2,9,2,6.5S4,2,6.5,2S11,4,11,6.5S9,11,6.5,11L6.5,11z"
    })), children);
  });
  var ZoomOutArea32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOutArea32(_ref107, ref) {
    var children = _ref107.children,
        rest = _objectWithoutProperties(_ref107, _excluded107);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path161 || (_path161 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19H24V21H16z"
    })), _path162 || (_path162 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomOutArea24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOutArea24(_ref108, ref) {
    var children = _ref108.children,
        rest = _objectWithoutProperties(_ref108, _excluded108);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path163 || (_path163 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19H24V21H16z"
    })), _path164 || (_path164 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomOutArea20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOutArea20(_ref109, ref) {
    var children = _ref109.children,
        rest = _objectWithoutProperties(_ref109, _excluded109);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path165 || (_path165 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19H24V21H16z"
    })), _path166 || (_path166 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomOutArea16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomOutArea16(_ref110, ref) {
    var children = _ref110.children,
        rest = _objectWithoutProperties(_ref110, _excluded110);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path167 || (_path167 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M16 19H24V21H16z"
    })), _path168 || (_path168 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M31 29.5859l-4.6885-4.6884a8.028 8.028 0 10-1.414 1.414L29.5859 31zM20 26a6 6 0 116-6A6.0066 6.0066 0 0120 26zM4 8H2V4A2.0021 2.0021 0 014 2H8V4H4zM26 8H24V4H20V2h4a2.0021 2.0021 0 012 2zM12 2H16V4H12zM8 26H4a2.0021 2.0021 0 01-2-2V20H4v4H8zM2 12H4V16H2z"
    })), children);
  });
  var ZoomReset32 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomReset32(_ref111, ref) {
    var children = _ref111.children,
        rest = _objectWithoutProperties(_ref111, _excluded111);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path169 || (_path169 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"
    })), children);
  });
  var ZoomReset24 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomReset24(_ref112, ref) {
    var children = _ref112.children,
        rest = _objectWithoutProperties(_ref112, _excluded112);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path170 || (_path170 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"
    })), children);
  });
  var ZoomReset20 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomReset20(_ref113, ref) {
    var children = _ref113.children,
        rest = _objectWithoutProperties(_ref113, _excluded113);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path171 || (_path171 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"
    })), children);
  });
  var ZoomReset16 = /*#__PURE__*/React__default['default'].forwardRef(function ZoomReset16(_ref114, ref) {
    var children = _ref114.children,
        rest = _objectWithoutProperties(_ref114, _excluded114);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path172 || (_path172 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"
    })), children);
  });
  var WatsonHealthZoomPan32 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthZoomPan32(_ref115, ref) {
    var children = _ref115.children,
        rest = _objectWithoutProperties(_ref115, _excluded115);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 32,
      height: 32,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path173 || (_path173 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 10-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0022 16zm-6 4a4 4 0 114-4A4 4 0 0116 20z"
    })), children);
  });
  var WatsonHealthZoomPan24 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthZoomPan24(_ref116, ref) {
    var children = _ref116.children,
        rest = _objectWithoutProperties(_ref116, _excluded116);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 24,
      height: 24,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path174 || (_path174 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 10-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0022 16zm-6 4a4 4 0 114-4A4 4 0 0116 20z"
    })), children);
  });
  var WatsonHealthZoomPan20 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthZoomPan20(_ref117, ref) {
    var children = _ref117.children,
        rest = _objectWithoutProperties(_ref117, _excluded117);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 20,
      height: 20,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path175 || (_path175 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 10-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0022 16zm-6 4a4 4 0 114-4A4 4 0 0116 20z"
    })), children);
  });
  var WatsonHealthZoomPan16 = /*#__PURE__*/React__default['default'].forwardRef(function WatsonHealthZoomPan16(_ref118, ref) {
    var children = _ref118.children,
        rest = _objectWithoutProperties(_ref118, _excluded118);

    return /*#__PURE__*/React__default['default'].createElement(Icon, _extends({
      width: 16,
      height: 16,
      viewBox: "0 0 32 32",
      xmlns: "http://www.w3.org/2000/svg",
      fill: "currentColor",
      ref: ref
    }, rest), _path176 || (_path176 = /*#__PURE__*/React__default['default'].createElement("path", {
      d: "M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 10-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0022 16zm-6 4a4 4 0 114-4A4 4 0 0116 20z"
    })), children);
  });

  exports.Accessibility16 = Accessibility16;
  exports.Accessibility20 = Accessibility20;
  exports.Accessibility24 = Accessibility24;
  exports.Accessibility32 = Accessibility32;
  exports.AccessibilityAlt16 = AccessibilityAlt16;
  exports.AccessibilityAlt20 = AccessibilityAlt20;
  exports.AccessibilityAlt24 = AccessibilityAlt24;
  exports.AccessibilityAlt32 = AccessibilityAlt32;
  exports.AccessibilityColor16 = AccessibilityColor16;
  exports.AccessibilityColor20 = AccessibilityColor20;
  exports.AccessibilityColor24 = AccessibilityColor24;
  exports.AccessibilityColor32 = AccessibilityColor32;
  exports.AccessibilityColorFilled16 = AccessibilityColorFilled16;
  exports.AccessibilityColorFilled20 = AccessibilityColorFilled20;
  exports.AccessibilityColorFilled24 = AccessibilityColorFilled24;
  exports.AccessibilityColorFilled32 = AccessibilityColorFilled32;
  exports.Account16 = Account16;
  exports.Account20 = Account20;
  exports.Account24 = Account24;
  exports.Account32 = Account32;
  exports.AccumulationIce16 = AccumulationIce16;
  exports.AccumulationIce20 = AccumulationIce20;
  exports.AccumulationIce24 = AccumulationIce24;
  exports.AccumulationIce32 = AccumulationIce32;
  exports.AccumulationPrecipitation16 = AccumulationPrecipitation16;
  exports.AccumulationPrecipitation20 = AccumulationPrecipitation20;
  exports.AccumulationPrecipitation24 = AccumulationPrecipitation24;
  exports.AccumulationPrecipitation32 = AccumulationPrecipitation32;
  exports.AccumulationRain16 = AccumulationRain16;
  exports.AccumulationRain20 = AccumulationRain20;
  exports.AccumulationRain24 = AccumulationRain24;
  exports.AccumulationRain32 = AccumulationRain32;
  exports.AccumulationSnow16 = AccumulationSnow16;
  exports.AccumulationSnow20 = AccumulationSnow20;
  exports.AccumulationSnow24 = AccumulationSnow24;
  exports.AccumulationSnow32 = AccumulationSnow32;
  exports.Activity16 = Activity16;
  exports.Activity20 = Activity20;
  exports.Activity24 = Activity24;
  exports.Activity32 = Activity32;
  exports.Add16 = Add16;
  exports.Add20 = Add20;
  exports.Add24 = Add24;
  exports.Add32 = Add32;
  exports.AddAlt16 = AddAlt16;
  exports.AddAlt20 = AddAlt20;
  exports.AddAlt24 = AddAlt24;
  exports.AddAlt32 = AddAlt32;
  exports.AddComment16 = AddComment16;
  exports.AddComment20 = AddComment20;
  exports.AddComment24 = AddComment24;
  exports.AddComment32 = AddComment32;
  exports.AddFilled16 = AddFilled16;
  exports.AddFilled20 = AddFilled20;
  exports.AddFilled24 = AddFilled24;
  exports.AddFilled32 = AddFilled32;
  exports.AgricultureAnalytics16 = AgricultureAnalytics16;
  exports.AgricultureAnalytics20 = AgricultureAnalytics20;
  exports.AgricultureAnalytics24 = AgricultureAnalytics24;
  exports.AgricultureAnalytics32 = AgricultureAnalytics32;
  exports.AirlineDigitalGate16 = AirlineDigitalGate16;
  exports.AirlineDigitalGate20 = AirlineDigitalGate20;
  exports.AirlineDigitalGate24 = AirlineDigitalGate24;
  exports.AirlineDigitalGate32 = AirlineDigitalGate32;
  exports.AirlineManageGates16 = AirlineManageGates16;
  exports.AirlineManageGates20 = AirlineManageGates20;
  exports.AirlineManageGates24 = AirlineManageGates24;
  exports.AirlineManageGates32 = AirlineManageGates32;
  exports.AirlinePassengerCare16 = AirlinePassengerCare16;
  exports.AirlinePassengerCare20 = AirlinePassengerCare20;
  exports.AirlinePassengerCare24 = AirlinePassengerCare24;
  exports.AirlinePassengerCare32 = AirlinePassengerCare32;
  exports.AirlineRapidBoard16 = AirlineRapidBoard16;
  exports.AirlineRapidBoard20 = AirlineRapidBoard20;
  exports.AirlineRapidBoard24 = AirlineRapidBoard24;
  exports.AirlineRapidBoard32 = AirlineRapidBoard32;
  exports.Airplay16 = Airplay16;
  exports.Airplay20 = Airplay20;
  exports.Airplay24 = Airplay24;
  exports.Airplay32 = Airplay32;
  exports.AirplayFilled16 = AirplayFilled16;
  exports.AirplayFilled20 = AirplayFilled20;
  exports.AirplayFilled24 = AirplayFilled24;
  exports.AirplayFilled32 = AirplayFilled32;
  exports.AirportLocation16 = AirportLocation16;
  exports.AirportLocation20 = AirportLocation20;
  exports.AirportLocation24 = AirportLocation24;
  exports.AirportLocation32 = AirportLocation32;
  exports.Airport_0116 = Airport_0116;
  exports.Airport_0120 = Airport_0120;
  exports.Airport_0124 = Airport_0124;
  exports.Airport_0132 = Airport_0132;
  exports.Airport_0216 = Airport_0216;
  exports.Airport_0220 = Airport_0220;
  exports.Airport_0224 = Airport_0224;
  exports.Airport_0232 = Airport_0232;
  exports.Alarm16 = Alarm16;
  exports.Alarm20 = Alarm20;
  exports.Alarm24 = Alarm24;
  exports.Alarm32 = Alarm32;
  exports.AlarmAdd16 = AlarmAdd16;
  exports.AlarmAdd20 = AlarmAdd20;
  exports.AlarmAdd24 = AlarmAdd24;
  exports.AlarmAdd32 = AlarmAdd32;
  exports.AlarmSubtract16 = AlarmSubtract16;
  exports.AlarmSubtract20 = AlarmSubtract20;
  exports.AlarmSubtract24 = AlarmSubtract24;
  exports.AlarmSubtract32 = AlarmSubtract32;
  exports.AlignBoxBottomCenter16 = AlignBoxBottomCenter16;
  exports.AlignBoxBottomCenter20 = AlignBoxBottomCenter20;
  exports.AlignBoxBottomCenter24 = AlignBoxBottomCenter24;
  exports.AlignBoxBottomCenter32 = AlignBoxBottomCenter32;
  exports.AlignBoxBottomLeft16 = AlignBoxBottomLeft16;
  exports.AlignBoxBottomLeft20 = AlignBoxBottomLeft20;
  exports.AlignBoxBottomLeft24 = AlignBoxBottomLeft24;
  exports.AlignBoxBottomLeft32 = AlignBoxBottomLeft32;
  exports.AlignBoxBottomRight16 = AlignBoxBottomRight16;
  exports.AlignBoxBottomRight20 = AlignBoxBottomRight20;
  exports.AlignBoxBottomRight24 = AlignBoxBottomRight24;
  exports.AlignBoxBottomRight32 = AlignBoxBottomRight32;
  exports.AlignBoxMiddleCenter16 = AlignBoxMiddleCenter16;
  exports.AlignBoxMiddleCenter20 = AlignBoxMiddleCenter20;
  exports.AlignBoxMiddleCenter24 = AlignBoxMiddleCenter24;
  exports.AlignBoxMiddleCenter32 = AlignBoxMiddleCenter32;
  exports.AlignBoxMiddleLeft16 = AlignBoxMiddleLeft16;
  exports.AlignBoxMiddleLeft20 = AlignBoxMiddleLeft20;
  exports.AlignBoxMiddleLeft24 = AlignBoxMiddleLeft24;
  exports.AlignBoxMiddleLeft32 = AlignBoxMiddleLeft32;
  exports.AlignBoxMiddleRight16 = AlignBoxMiddleRight16;
  exports.AlignBoxMiddleRight20 = AlignBoxMiddleRight20;
  exports.AlignBoxMiddleRight24 = AlignBoxMiddleRight24;
  exports.AlignBoxMiddleRight32 = AlignBoxMiddleRight32;
  exports.AlignBoxTopCenter16 = AlignBoxTopCenter16;
  exports.AlignBoxTopCenter20 = AlignBoxTopCenter20;
  exports.AlignBoxTopCenter24 = AlignBoxTopCenter24;
  exports.AlignBoxTopCenter32 = AlignBoxTopCenter32;
  exports.AlignBoxTopLeft16 = AlignBoxTopLeft16;
  exports.AlignBoxTopLeft20 = AlignBoxTopLeft20;
  exports.AlignBoxTopLeft24 = AlignBoxTopLeft24;
  exports.AlignBoxTopLeft32 = AlignBoxTopLeft32;
  exports.AlignBoxTopRight16 = AlignBoxTopRight16;
  exports.AlignBoxTopRight20 = AlignBoxTopRight20;
  exports.AlignBoxTopRight24 = AlignBoxTopRight24;
  exports.AlignBoxTopRight32 = AlignBoxTopRight32;
  exports.AlignHorizontalCenter16 = AlignHorizontalCenter16;
  exports.AlignHorizontalCenter20 = AlignHorizontalCenter20;
  exports.AlignHorizontalCenter24 = AlignHorizontalCenter24;
  exports.AlignHorizontalCenter32 = AlignHorizontalCenter32;
  exports.AlignHorizontalLeft16 = AlignHorizontalLeft16;
  exports.AlignHorizontalLeft20 = AlignHorizontalLeft20;
  exports.AlignHorizontalLeft24 = AlignHorizontalLeft24;
  exports.AlignHorizontalLeft32 = AlignHorizontalLeft32;
  exports.AlignHorizontalRight16 = AlignHorizontalRight16;
  exports.AlignHorizontalRight20 = AlignHorizontalRight20;
  exports.AlignHorizontalRight24 = AlignHorizontalRight24;
  exports.AlignHorizontalRight32 = AlignHorizontalRight32;
  exports.AlignVerticalBottom16 = AlignVerticalBottom16;
  exports.AlignVerticalBottom20 = AlignVerticalBottom20;
  exports.AlignVerticalBottom24 = AlignVerticalBottom24;
  exports.AlignVerticalBottom32 = AlignVerticalBottom32;
  exports.AlignVerticalCenter16 = AlignVerticalCenter16;
  exports.AlignVerticalCenter20 = AlignVerticalCenter20;
  exports.AlignVerticalCenter24 = AlignVerticalCenter24;
  exports.AlignVerticalCenter32 = AlignVerticalCenter32;
  exports.AlignVerticalTop16 = AlignVerticalTop16;
  exports.AlignVerticalTop20 = AlignVerticalTop20;
  exports.AlignVerticalTop24 = AlignVerticalTop24;
  exports.AlignVerticalTop32 = AlignVerticalTop32;
  exports.Analytics16 = Analytics16;
  exports.Analytics20 = Analytics20;
  exports.Analytics24 = Analytics24;
  exports.Analytics32 = Analytics32;
  exports.AnalyticsReference16 = AnalyticsReference16;
  exports.AnalyticsReference20 = AnalyticsReference20;
  exports.AnalyticsReference24 = AnalyticsReference24;
  exports.AnalyticsReference32 = AnalyticsReference32;
  exports.Aperture16 = Aperture16;
  exports.Aperture20 = Aperture20;
  exports.Aperture24 = Aperture24;
  exports.Aperture32 = Aperture32;
  exports.Api16 = Api16;
  exports.Api20 = Api20;
  exports.Api24 = Api24;
  exports.Api32 = Api32;
  exports.Api_116 = Api_116;
  exports.Api_120 = Api_120;
  exports.Api_124 = Api_124;
  exports.Api_132 = Api_132;
  exports.App16 = App16;
  exports.App20 = App20;
  exports.App24 = App24;
  exports.App32 = App32;
  exports.AppConnectivity16 = AppConnectivity16;
  exports.AppConnectivity20 = AppConnectivity20;
  exports.AppConnectivity24 = AppConnectivity24;
  exports.AppConnectivity32 = AppConnectivity32;
  exports.AppSwitcher16 = AppSwitcher16;
  exports.AppSwitcher20 = AppSwitcher20;
  exports.AppSwitcher24 = AppSwitcher24;
  exports.AppSwitcher32 = AppSwitcher32;
  exports.Apple16 = Apple16;
  exports.Apple20 = Apple20;
  exports.Apple24 = Apple24;
  exports.Apple32 = Apple32;
  exports.Application16 = Application16;
  exports.Application20 = Application20;
  exports.Application24 = Application24;
  exports.Application32 = Application32;
  exports.ApplicationMobile16 = ApplicationMobile16;
  exports.ApplicationMobile20 = ApplicationMobile20;
  exports.ApplicationMobile24 = ApplicationMobile24;
  exports.ApplicationMobile32 = ApplicationMobile32;
  exports.ApplicationVirtual16 = ApplicationVirtual16;
  exports.ApplicationVirtual20 = ApplicationVirtual20;
  exports.ApplicationVirtual24 = ApplicationVirtual24;
  exports.ApplicationVirtual32 = ApplicationVirtual32;
  exports.ApplicationWeb16 = ApplicationWeb16;
  exports.ApplicationWeb20 = ApplicationWeb20;
  exports.ApplicationWeb24 = ApplicationWeb24;
  exports.ApplicationWeb32 = ApplicationWeb32;
  exports.Apps16 = Apps16;
  exports.Apps20 = Apps20;
  exports.Apps24 = Apps24;
  exports.Apps32 = Apps32;
  exports.Archive16 = Archive16;
  exports.Archive20 = Archive20;
  exports.Archive24 = Archive24;
  exports.Archive32 = Archive32;
  exports.Area16 = Area16;
  exports.Area20 = Area20;
  exports.Area24 = Area24;
  exports.Area32 = Area32;
  exports.AreaCustom16 = AreaCustom16;
  exports.AreaCustom20 = AreaCustom20;
  exports.AreaCustom24 = AreaCustom24;
  exports.AreaCustom32 = AreaCustom32;
  exports.Arrival16 = Arrival16;
  exports.Arrival20 = Arrival20;
  exports.Arrival24 = Arrival24;
  exports.Arrival32 = Arrival32;
  exports.ArrowDown16 = ArrowDown16;
  exports.ArrowDown20 = ArrowDown20;
  exports.ArrowDown24 = ArrowDown24;
  exports.ArrowDown32 = ArrowDown32;
  exports.ArrowDownLeft16 = ArrowDownLeft16;
  exports.ArrowDownLeft20 = ArrowDownLeft20;
  exports.ArrowDownLeft24 = ArrowDownLeft24;
  exports.ArrowDownLeft32 = ArrowDownLeft32;
  exports.ArrowDownRight16 = ArrowDownRight16;
  exports.ArrowDownRight20 = ArrowDownRight20;
  exports.ArrowDownRight24 = ArrowDownRight24;
  exports.ArrowDownRight32 = ArrowDownRight32;
  exports.ArrowLeft16 = ArrowLeft16;
  exports.ArrowLeft20 = ArrowLeft20;
  exports.ArrowLeft24 = ArrowLeft24;
  exports.ArrowLeft32 = ArrowLeft32;
  exports.ArrowRight16 = ArrowRight16;
  exports.ArrowRight20 = ArrowRight20;
  exports.ArrowRight24 = ArrowRight24;
  exports.ArrowRight32 = ArrowRight32;
  exports.ArrowShiftDown16 = ArrowShiftDown16;
  exports.ArrowShiftDown20 = ArrowShiftDown20;
  exports.ArrowShiftDown24 = ArrowShiftDown24;
  exports.ArrowShiftDown32 = ArrowShiftDown32;
  exports.ArrowUp16 = ArrowUp16;
  exports.ArrowUp20 = ArrowUp20;
  exports.ArrowUp24 = ArrowUp24;
  exports.ArrowUp32 = ArrowUp32;
  exports.ArrowUpLeft16 = ArrowUpLeft16;
  exports.ArrowUpLeft20 = ArrowUpLeft20;
  exports.ArrowUpLeft24 = ArrowUpLeft24;
  exports.ArrowUpLeft32 = ArrowUpLeft32;
  exports.ArrowUpRight16 = ArrowUpRight16;
  exports.ArrowUpRight20 = ArrowUpRight20;
  exports.ArrowUpRight24 = ArrowUpRight24;
  exports.ArrowUpRight32 = ArrowUpRight32;
  exports.Arrows16 = Arrows16;
  exports.Arrows20 = Arrows20;
  exports.Arrows24 = Arrows24;
  exports.Arrows32 = Arrows32;
  exports.ArrowsHorizontal16 = ArrowsHorizontal16;
  exports.ArrowsHorizontal20 = ArrowsHorizontal20;
  exports.ArrowsHorizontal24 = ArrowsHorizontal24;
  exports.ArrowsHorizontal32 = ArrowsHorizontal32;
  exports.ArrowsVertical16 = ArrowsVertical16;
  exports.ArrowsVertical20 = ArrowsVertical20;
  exports.ArrowsVertical24 = ArrowsVertical24;
  exports.ArrowsVertical32 = ArrowsVertical32;
  exports.Asleep16 = Asleep16;
  exports.Asleep20 = Asleep20;
  exports.Asleep24 = Asleep24;
  exports.Asleep32 = Asleep32;
  exports.AsleepFilled16 = AsleepFilled16;
  exports.AsleepFilled20 = AsleepFilled20;
  exports.AsleepFilled24 = AsleepFilled24;
  exports.AsleepFilled32 = AsleepFilled32;
  exports.Asset16 = Asset16;
  exports.Asset20 = Asset20;
  exports.Asset24 = Asset24;
  exports.Asset32 = Asset32;
  exports.AssetConfirm16 = AssetConfirm16;
  exports.AssetConfirm20 = AssetConfirm20;
  exports.AssetConfirm24 = AssetConfirm24;
  exports.AssetConfirm32 = AssetConfirm32;
  exports.AssetDigitalTwin16 = AssetDigitalTwin16;
  exports.AssetDigitalTwin20 = AssetDigitalTwin20;
  exports.AssetDigitalTwin24 = AssetDigitalTwin24;
  exports.AssetDigitalTwin32 = AssetDigitalTwin32;
  exports.AssetView16 = AssetView16;
  exports.AssetView20 = AssetView20;
  exports.AssetView24 = AssetView24;
  exports.AssetView32 = AssetView32;
  exports.Asterisk16 = Asterisk16;
  exports.Asterisk20 = Asterisk20;
  exports.Asterisk24 = Asterisk24;
  exports.Asterisk32 = Asterisk32;
  exports.At16 = At16;
  exports.At20 = At20;
  exports.At24 = At24;
  exports.At32 = At32;
  exports.Attachment16 = Attachment16;
  exports.Attachment20 = Attachment20;
  exports.Attachment24 = Attachment24;
  exports.Attachment32 = Attachment32;
  exports.AudioConsole16 = AudioConsole16;
  exports.AudioConsole20 = AudioConsole20;
  exports.AudioConsole24 = AudioConsole24;
  exports.AudioConsole32 = AudioConsole32;
  exports.AugmentedReality16 = AugmentedReality16;
  exports.AugmentedReality20 = AugmentedReality20;
  exports.AugmentedReality24 = AugmentedReality24;
  exports.AugmentedReality32 = AugmentedReality32;
  exports.Automatic16 = Automatic16;
  exports.Automatic20 = Automatic20;
  exports.Automatic24 = Automatic24;
  exports.Automatic32 = Automatic32;
  exports.Autoscaling16 = Autoscaling16;
  exports.Autoscaling20 = Autoscaling20;
  exports.Autoscaling24 = Autoscaling24;
  exports.Autoscaling32 = Autoscaling32;
  exports.Awake16 = Awake16;
  exports.Awake20 = Awake20;
  exports.Awake24 = Awake24;
  exports.Awake32 = Awake32;
  exports.BackToTop16 = BackToTop16;
  exports.BackToTop20 = BackToTop20;
  exports.BackToTop24 = BackToTop24;
  exports.BackToTop32 = BackToTop32;
  exports.Badge16 = Badge16;
  exports.Badge20 = Badge20;
  exports.Badge24 = Badge24;
  exports.Badge32 = Badge32;
  exports.BaggageClaim16 = BaggageClaim16;
  exports.BaggageClaim20 = BaggageClaim20;
  exports.BaggageClaim24 = BaggageClaim24;
  exports.BaggageClaim32 = BaggageClaim32;
  exports.Bar16 = Bar16;
  exports.Bar20 = Bar20;
  exports.Bar24 = Bar24;
  exports.Bar32 = Bar32;
  exports.Barcode16 = Barcode16;
  exports.Barcode20 = Barcode20;
  exports.Barcode24 = Barcode24;
  exports.Barcode32 = Barcode32;
  exports.BareMetalServer16 = BareMetalServer16;
  exports.BareMetalServer20 = BareMetalServer20;
  exports.BareMetalServer24 = BareMetalServer24;
  exports.BareMetalServer32 = BareMetalServer32;
  exports.BareMetalServer_0116 = BareMetalServer_0116;
  exports.BareMetalServer_0120 = BareMetalServer_0120;
  exports.BareMetalServer_0124 = BareMetalServer_0124;
  exports.BareMetalServer_0132 = BareMetalServer_0132;
  exports.BareMetalServer_0216 = BareMetalServer_0216;
  exports.BareMetalServer_0220 = BareMetalServer_0220;
  exports.BareMetalServer_0224 = BareMetalServer_0224;
  exports.BareMetalServer_0232 = BareMetalServer_0232;
  exports.Basketball16 = Basketball16;
  exports.Basketball20 = Basketball20;
  exports.Basketball24 = Basketball24;
  exports.Basketball32 = Basketball32;
  exports.BastionHost16 = BastionHost16;
  exports.BastionHost20 = BastionHost20;
  exports.BastionHost24 = BastionHost24;
  exports.BastionHost32 = BastionHost32;
  exports.Bat16 = Bat16;
  exports.Bat20 = Bat20;
  exports.Bat24 = Bat24;
  exports.Bat32 = Bat32;
  exports.BatteryCharging16 = BatteryCharging16;
  exports.BatteryCharging20 = BatteryCharging20;
  exports.BatteryCharging24 = BatteryCharging24;
  exports.BatteryCharging32 = BatteryCharging32;
  exports.BatteryEmpty16 = BatteryEmpty16;
  exports.BatteryEmpty20 = BatteryEmpty20;
  exports.BatteryEmpty24 = BatteryEmpty24;
  exports.BatteryEmpty32 = BatteryEmpty32;
  exports.BatteryFull16 = BatteryFull16;
  exports.BatteryFull20 = BatteryFull20;
  exports.BatteryFull24 = BatteryFull24;
  exports.BatteryFull32 = BatteryFull32;
  exports.BatteryHalf16 = BatteryHalf16;
  exports.BatteryHalf20 = BatteryHalf20;
  exports.BatteryHalf24 = BatteryHalf24;
  exports.BatteryHalf32 = BatteryHalf32;
  exports.BatteryLow16 = BatteryLow16;
  exports.BatteryLow20 = BatteryLow20;
  exports.BatteryLow24 = BatteryLow24;
  exports.BatteryLow32 = BatteryLow32;
  exports.BatteryQuarter16 = BatteryQuarter16;
  exports.BatteryQuarter20 = BatteryQuarter20;
  exports.BatteryQuarter24 = BatteryQuarter24;
  exports.BatteryQuarter32 = BatteryQuarter32;
  exports.Bee16 = Bee16;
  exports.Bee20 = Bee20;
  exports.Bee24 = Bee24;
  exports.Bee32 = Bee32;
  exports.BeeBat16 = BeeBat16;
  exports.BeeBat20 = BeeBat20;
  exports.BeeBat24 = BeeBat24;
  exports.BeeBat32 = BeeBat32;
  exports.Beta16 = Beta16;
  exports.Beta20 = Beta20;
  exports.Beta24 = Beta24;
  exports.Beta32 = Beta32;
  exports.Bicycle16 = Bicycle16;
  exports.Bicycle20 = Bicycle20;
  exports.Bicycle24 = Bicycle24;
  exports.Bicycle32 = Bicycle32;
  exports.Binoculars16 = Binoculars16;
  exports.Binoculars20 = Binoculars20;
  exports.Binoculars24 = Binoculars24;
  exports.Binoculars32 = Binoculars32;
  exports.BlockStorage16 = BlockStorage16;
  exports.BlockStorage20 = BlockStorage20;
  exports.BlockStorage24 = BlockStorage24;
  exports.BlockStorage32 = BlockStorage32;
  exports.BlockStorageAlt16 = BlockStorageAlt16;
  exports.BlockStorageAlt20 = BlockStorageAlt20;
  exports.BlockStorageAlt24 = BlockStorageAlt24;
  exports.BlockStorageAlt32 = BlockStorageAlt32;
  exports.Blockchain16 = Blockchain16;
  exports.Blockchain20 = Blockchain20;
  exports.Blockchain24 = Blockchain24;
  exports.Blockchain32 = Blockchain32;
  exports.Blog16 = Blog16;
  exports.Blog20 = Blog20;
  exports.Blog24 = Blog24;
  exports.Blog32 = Blog32;
  exports.Bluetooth16 = Bluetooth16;
  exports.Bluetooth20 = Bluetooth20;
  exports.Bluetooth24 = Bluetooth24;
  exports.Bluetooth32 = Bluetooth32;
  exports.BluetoothOff16 = BluetoothOff16;
  exports.BluetoothOff20 = BluetoothOff20;
  exports.BluetoothOff24 = BluetoothOff24;
  exports.BluetoothOff32 = BluetoothOff32;
  exports.Book16 = Book16;
  exports.Book20 = Book20;
  exports.Book24 = Book24;
  exports.Book32 = Book32;
  exports.Bookmark16 = Bookmark16;
  exports.Bookmark20 = Bookmark20;
  exports.Bookmark24 = Bookmark24;
  exports.Bookmark32 = Bookmark32;
  exports.BookmarkAdd16 = BookmarkAdd16;
  exports.BookmarkAdd20 = BookmarkAdd20;
  exports.BookmarkAdd24 = BookmarkAdd24;
  exports.BookmarkAdd32 = BookmarkAdd32;
  exports.BookmarkFilled16 = BookmarkFilled16;
  exports.BookmarkFilled20 = BookmarkFilled20;
  exports.BookmarkFilled24 = BookmarkFilled24;
  exports.BookmarkFilled32 = BookmarkFilled32;
  exports.Boolean16 = Boolean16;
  exports.Boolean20 = Boolean20;
  exports.Boolean24 = Boolean24;
  exports.Boolean32 = Boolean32;
  exports.Boot16 = Boot16;
  exports.Boot20 = Boot20;
  exports.Boot24 = Boot24;
  exports.Boot32 = Boot32;
  exports.BorderBottom16 = BorderBottom16;
  exports.BorderBottom20 = BorderBottom20;
  exports.BorderBottom24 = BorderBottom24;
  exports.BorderBottom32 = BorderBottom32;
  exports.BorderFull16 = BorderFull16;
  exports.BorderFull20 = BorderFull20;
  exports.BorderFull24 = BorderFull24;
  exports.BorderFull32 = BorderFull32;
  exports.BorderLeft16 = BorderLeft16;
  exports.BorderLeft20 = BorderLeft20;
  exports.BorderLeft24 = BorderLeft24;
  exports.BorderLeft32 = BorderLeft32;
  exports.BorderNone16 = BorderNone16;
  exports.BorderNone20 = BorderNone20;
  exports.BorderNone24 = BorderNone24;
  exports.BorderNone32 = BorderNone32;
  exports.BorderRight16 = BorderRight16;
  exports.BorderRight20 = BorderRight20;
  exports.BorderRight24 = BorderRight24;
  exports.BorderRight32 = BorderRight32;
  exports.BorderTop16 = BorderTop16;
  exports.BorderTop20 = BorderTop20;
  exports.BorderTop24 = BorderTop24;
  exports.BorderTop32 = BorderTop32;
  exports.Bot16 = Bot16;
  exports.Bot20 = Bot20;
  exports.Bot24 = Bot24;
  exports.Bot32 = Bot32;
  exports.Box16 = Box16;
  exports.Box20 = Box20;
  exports.Box24 = Box24;
  exports.Box32 = Box32;
  exports.BoxExtraLarge16 = BoxExtraLarge16;
  exports.BoxExtraLarge20 = BoxExtraLarge20;
  exports.BoxExtraLarge24 = BoxExtraLarge24;
  exports.BoxExtraLarge32 = BoxExtraLarge32;
  exports.BoxLarge16 = BoxLarge16;
  exports.BoxLarge20 = BoxLarge20;
  exports.BoxLarge24 = BoxLarge24;
  exports.BoxLarge32 = BoxLarge32;
  exports.BoxMedium16 = BoxMedium16;
  exports.BoxMedium20 = BoxMedium20;
  exports.BoxMedium24 = BoxMedium24;
  exports.BoxMedium32 = BoxMedium32;
  exports.BoxPlot16 = BoxPlot16;
  exports.BoxPlot20 = BoxPlot20;
  exports.BoxPlot24 = BoxPlot24;
  exports.BoxPlot32 = BoxPlot32;
  exports.BoxSmall16 = BoxSmall16;
  exports.BoxSmall20 = BoxSmall20;
  exports.BoxSmall24 = BoxSmall24;
  exports.BoxSmall32 = BoxSmall32;
  exports.Branch16 = Branch16;
  exports.Branch20 = Branch20;
  exports.Branch24 = Branch24;
  exports.Branch32 = Branch32;
  exports.BreakingChange16 = BreakingChange16;
  exports.BreakingChange20 = BreakingChange20;
  exports.BreakingChange24 = BreakingChange24;
  exports.BreakingChange32 = BreakingChange32;
  exports.BrightnessContrast16 = BrightnessContrast16;
  exports.BrightnessContrast20 = BrightnessContrast20;
  exports.BrightnessContrast24 = BrightnessContrast24;
  exports.BrightnessContrast32 = BrightnessContrast32;
  exports.BringForward16 = BringForward16;
  exports.BringForward20 = BringForward20;
  exports.BringForward24 = BringForward24;
  exports.BringForward32 = BringForward32;
  exports.BringToFront16 = BringToFront16;
  exports.BringToFront20 = BringToFront20;
  exports.BringToFront24 = BringToFront24;
  exports.BringToFront32 = BringToFront32;
  exports.Building16 = Building16;
  exports.Building20 = Building20;
  exports.Building24 = Building24;
  exports.Building32 = Building32;
  exports.BuildingInsights_116 = BuildingInsights_116;
  exports.BuildingInsights_120 = BuildingInsights_120;
  exports.BuildingInsights_124 = BuildingInsights_124;
  exports.BuildingInsights_132 = BuildingInsights_132;
  exports.BuildingInsights_216 = BuildingInsights_216;
  exports.BuildingInsights_220 = BuildingInsights_220;
  exports.BuildingInsights_224 = BuildingInsights_224;
  exports.BuildingInsights_232 = BuildingInsights_232;
  exports.BuildingInsights_316 = BuildingInsights_316;
  exports.BuildingInsights_320 = BuildingInsights_320;
  exports.BuildingInsights_324 = BuildingInsights_324;
  exports.BuildingInsights_332 = BuildingInsights_332;
  exports.Bullhorn16 = Bullhorn16;
  exports.Bullhorn20 = Bullhorn20;
  exports.Bullhorn24 = Bullhorn24;
  exports.Bullhorn32 = Bullhorn32;
  exports.Buoy16 = Buoy16;
  exports.Buoy20 = Buoy20;
  exports.Buoy24 = Buoy24;
  exports.Buoy32 = Buoy32;
  exports.Bus16 = Bus16;
  exports.Bus20 = Bus20;
  exports.Bus24 = Bus24;
  exports.Bus32 = Bus32;
  exports.CabinCare16 = CabinCare16;
  exports.CabinCare20 = CabinCare20;
  exports.CabinCare24 = CabinCare24;
  exports.CabinCare32 = CabinCare32;
  exports.CabinCareAlert16 = CabinCareAlert16;
  exports.CabinCareAlert20 = CabinCareAlert20;
  exports.CabinCareAlert24 = CabinCareAlert24;
  exports.CabinCareAlert32 = CabinCareAlert32;
  exports.CabinCareAlt16 = CabinCareAlt16;
  exports.CabinCareAlt20 = CabinCareAlt20;
  exports.CabinCareAlt24 = CabinCareAlt24;
  exports.CabinCareAlt32 = CabinCareAlt32;
  exports.Cad16 = Cad16;
  exports.Cad20 = Cad20;
  exports.Cad24 = Cad24;
  exports.Cad32 = Cad32;
  exports.Cafe16 = Cafe16;
  exports.Cafe20 = Cafe20;
  exports.Cafe24 = Cafe24;
  exports.Cafe32 = Cafe32;
  exports.Calculation16 = Calculation16;
  exports.Calculation20 = Calculation20;
  exports.Calculation24 = Calculation24;
  exports.Calculation32 = Calculation32;
  exports.CalculationAlt16 = CalculationAlt16;
  exports.CalculationAlt20 = CalculationAlt20;
  exports.CalculationAlt24 = CalculationAlt24;
  exports.CalculationAlt32 = CalculationAlt32;
  exports.Calculator16 = Calculator16;
  exports.Calculator20 = Calculator20;
  exports.Calculator24 = Calculator24;
  exports.Calculator32 = Calculator32;
  exports.CalculatorCheck16 = CalculatorCheck16;
  exports.CalculatorCheck20 = CalculatorCheck20;
  exports.CalculatorCheck24 = CalculatorCheck24;
  exports.CalculatorCheck32 = CalculatorCheck32;
  exports.Calendar16 = Calendar16;
  exports.Calendar20 = Calendar20;
  exports.Calendar24 = Calendar24;
  exports.Calendar32 = Calendar32;
  exports.CalendarHeatMap16 = CalendarHeatMap16;
  exports.CalendarHeatMap20 = CalendarHeatMap20;
  exports.CalendarHeatMap24 = CalendarHeatMap24;
  exports.CalendarHeatMap32 = CalendarHeatMap32;
  exports.CalendarSettings16 = CalendarSettings16;
  exports.CalendarSettings20 = CalendarSettings20;
  exports.CalendarSettings24 = CalendarSettings24;
  exports.CalendarSettings32 = CalendarSettings32;
  exports.CalendarTools16 = CalendarTools16;
  exports.CalendarTools20 = CalendarTools20;
  exports.CalendarTools24 = CalendarTools24;
  exports.CalendarTools32 = CalendarTools32;
  exports.Calibrate16 = Calibrate16;
  exports.Calibrate20 = Calibrate20;
  exports.Calibrate24 = Calibrate24;
  exports.Calibrate32 = Calibrate32;
  exports.Camera16 = Camera16;
  exports.Camera20 = Camera20;
  exports.Camera24 = Camera24;
  exports.Camera32 = Camera32;
  exports.CameraAction16 = CameraAction16;
  exports.CameraAction20 = CameraAction20;
  exports.CameraAction24 = CameraAction24;
  exports.CameraAction32 = CameraAction32;
  exports.Campsite16 = Campsite16;
  exports.Campsite20 = Campsite20;
  exports.Campsite24 = Campsite24;
  exports.Campsite32 = Campsite32;
  exports.Car16 = Car16;
  exports.Car20 = Car20;
  exports.Car24 = Car24;
  exports.Car32 = Car32;
  exports.CarFront16 = CarFront16;
  exports.CarFront20 = CarFront20;
  exports.CarFront24 = CarFront24;
  exports.CarFront32 = CarFront32;
  exports.Carbon16 = Carbon16;
  exports.Carbon20 = Carbon20;
  exports.Carbon24 = Carbon24;
  exports.Carbon32 = Carbon32;
  exports.CarbonAccounting16 = CarbonAccounting16;
  exports.CarbonAccounting20 = CarbonAccounting20;
  exports.CarbonAccounting24 = CarbonAccounting24;
  exports.CarbonAccounting32 = CarbonAccounting32;
  exports.CaretDown16 = CaretDown16;
  exports.CaretDown20 = CaretDown20;
  exports.CaretDown24 = CaretDown24;
  exports.CaretDown32 = CaretDown32;
  exports.CaretDownGlyph = CaretDownGlyph;
  exports.CaretLeft16 = CaretLeft16;
  exports.CaretLeft20 = CaretLeft20;
  exports.CaretLeft24 = CaretLeft24;
  exports.CaretLeft32 = CaretLeft32;
  exports.CaretLeftGlyph = CaretLeftGlyph;
  exports.CaretRight16 = CaretRight16;
  exports.CaretRight20 = CaretRight20;
  exports.CaretRight24 = CaretRight24;
  exports.CaretRight32 = CaretRight32;
  exports.CaretRightGlyph = CaretRightGlyph;
  exports.CaretSort16 = CaretSort16;
  exports.CaretSort20 = CaretSort20;
  exports.CaretSort24 = CaretSort24;
  exports.CaretSort32 = CaretSort32;
  exports.CaretSortDown16 = CaretSortDown16;
  exports.CaretSortDown20 = CaretSortDown20;
  exports.CaretSortDown24 = CaretSortDown24;
  exports.CaretSortDown32 = CaretSortDown32;
  exports.CaretSortUp16 = CaretSortUp16;
  exports.CaretSortUp20 = CaretSortUp20;
  exports.CaretSortUp24 = CaretSortUp24;
  exports.CaretSortUp32 = CaretSortUp32;
  exports.CaretUp16 = CaretUp16;
  exports.CaretUp20 = CaretUp20;
  exports.CaretUp24 = CaretUp24;
  exports.CaretUp32 = CaretUp32;
  exports.CaretUpGlyph = CaretUpGlyph;
  exports.CarouselHorizontal16 = CarouselHorizontal16;
  exports.CarouselHorizontal20 = CarouselHorizontal20;
  exports.CarouselHorizontal24 = CarouselHorizontal24;
  exports.CarouselHorizontal32 = CarouselHorizontal32;
  exports.CarouselVertical16 = CarouselVertical16;
  exports.CarouselVertical20 = CarouselVertical20;
  exports.CarouselVertical24 = CarouselVertical24;
  exports.CarouselVertical32 = CarouselVertical32;
  exports.Catalog16 = Catalog16;
  exports.Catalog20 = Catalog20;
  exports.Catalog24 = Catalog24;
  exports.Catalog32 = Catalog32;
  exports.Categories16 = Categories16;
  exports.Categories20 = Categories20;
  exports.Categories24 = Categories24;
  exports.Categories32 = Categories32;
  exports.Category16 = Category16;
  exports.Category20 = Category20;
  exports.Category24 = Category24;
  exports.Category32 = Category32;
  exports.CategoryAdd16 = CategoryAdd16;
  exports.CategoryAdd20 = CategoryAdd20;
  exports.CategoryAdd24 = CategoryAdd24;
  exports.CategoryAdd32 = CategoryAdd32;
  exports.CategoryAnd16 = CategoryAnd16;
  exports.CategoryAnd20 = CategoryAnd20;
  exports.CategoryAnd24 = CategoryAnd24;
  exports.CategoryAnd32 = CategoryAnd32;
  exports.CategoryNew16 = CategoryNew16;
  exports.CategoryNew20 = CategoryNew20;
  exports.CategoryNew24 = CategoryNew24;
  exports.CategoryNew32 = CategoryNew32;
  exports.CategoryNewEach16 = CategoryNewEach16;
  exports.CategoryNewEach20 = CategoryNewEach20;
  exports.CategoryNewEach24 = CategoryNewEach24;
  exports.CategoryNewEach32 = CategoryNewEach32;
  exports.CautionGlyph = CautionGlyph;
  exports.CautionInvertedGlyph = CautionInvertedGlyph;
  exports.Cda16 = Cda16;
  exports.Cda20 = Cda20;
  exports.Cda24 = Cda24;
  exports.Cda32 = Cda32;
  exports.CellTower16 = CellTower16;
  exports.CellTower20 = CellTower20;
  exports.CellTower24 = CellTower24;
  exports.CellTower32 = CellTower32;
  exports.CenterCircle16 = CenterCircle16;
  exports.CenterCircle20 = CenterCircle20;
  exports.CenterCircle24 = CenterCircle24;
  exports.CenterCircle32 = CenterCircle32;
  exports.CenterSquare16 = CenterSquare16;
  exports.CenterSquare20 = CenterSquare20;
  exports.CenterSquare24 = CenterSquare24;
  exports.CenterSquare32 = CenterSquare32;
  exports.CenterToFit16 = CenterToFit16;
  exports.CenterToFit20 = CenterToFit20;
  exports.CenterToFit24 = CenterToFit24;
  exports.CenterToFit32 = CenterToFit32;
  exports.Certificate16 = Certificate16;
  exports.Certificate20 = Certificate20;
  exports.Certificate24 = Certificate24;
  exports.Certificate32 = Certificate32;
  exports.CertificateCheck16 = CertificateCheck16;
  exports.CertificateCheck20 = CertificateCheck20;
  exports.CertificateCheck24 = CertificateCheck24;
  exports.CertificateCheck32 = CertificateCheck32;
  exports.ChangeCatalog16 = ChangeCatalog16;
  exports.ChangeCatalog20 = ChangeCatalog20;
  exports.ChangeCatalog24 = ChangeCatalog24;
  exports.ChangeCatalog32 = ChangeCatalog32;
  exports.CharacterPatterns16 = CharacterPatterns16;
  exports.CharacterPatterns20 = CharacterPatterns20;
  exports.CharacterPatterns24 = CharacterPatterns24;
  exports.CharacterPatterns32 = CharacterPatterns32;
  exports.ChargingStation16 = ChargingStation16;
  exports.ChargingStation20 = ChargingStation20;
  exports.ChargingStation24 = ChargingStation24;
  exports.ChargingStation32 = ChargingStation32;
  exports.ChargingStationFilled16 = ChargingStationFilled16;
  exports.ChargingStationFilled20 = ChargingStationFilled20;
  exports.ChargingStationFilled24 = ChargingStationFilled24;
  exports.ChargingStationFilled32 = ChargingStationFilled32;
  exports.ChartArea16 = ChartArea16;
  exports.ChartArea20 = ChartArea20;
  exports.ChartArea24 = ChartArea24;
  exports.ChartArea32 = ChartArea32;
  exports.ChartAreaSmooth16 = ChartAreaSmooth16;
  exports.ChartAreaSmooth20 = ChartAreaSmooth20;
  exports.ChartAreaSmooth24 = ChartAreaSmooth24;
  exports.ChartAreaSmooth32 = ChartAreaSmooth32;
  exports.ChartAreaStepper16 = ChartAreaStepper16;
  exports.ChartAreaStepper20 = ChartAreaStepper20;
  exports.ChartAreaStepper24 = ChartAreaStepper24;
  exports.ChartAreaStepper32 = ChartAreaStepper32;
  exports.ChartAverage16 = ChartAverage16;
  exports.ChartAverage20 = ChartAverage20;
  exports.ChartAverage24 = ChartAverage24;
  exports.ChartAverage32 = ChartAverage32;
  exports.ChartBar16 = ChartBar16;
  exports.ChartBar20 = ChartBar20;
  exports.ChartBar24 = ChartBar24;
  exports.ChartBar32 = ChartBar32;
  exports.ChartBarFloating16 = ChartBarFloating16;
  exports.ChartBarFloating20 = ChartBarFloating20;
  exports.ChartBarFloating24 = ChartBarFloating24;
  exports.ChartBarFloating32 = ChartBarFloating32;
  exports.ChartBarOverlay16 = ChartBarOverlay16;
  exports.ChartBarOverlay20 = ChartBarOverlay20;
  exports.ChartBarOverlay24 = ChartBarOverlay24;
  exports.ChartBarOverlay32 = ChartBarOverlay32;
  exports.ChartBarStacked16 = ChartBarStacked16;
  exports.ChartBarStacked20 = ChartBarStacked20;
  exports.ChartBarStacked24 = ChartBarStacked24;
  exports.ChartBarStacked32 = ChartBarStacked32;
  exports.ChartBarTarget16 = ChartBarTarget16;
  exports.ChartBarTarget20 = ChartBarTarget20;
  exports.ChartBarTarget24 = ChartBarTarget24;
  exports.ChartBarTarget32 = ChartBarTarget32;
  exports.ChartBubble16 = ChartBubble16;
  exports.ChartBubble20 = ChartBubble20;
  exports.ChartBubble24 = ChartBubble24;
  exports.ChartBubble32 = ChartBubble32;
  exports.ChartBubblePacked16 = ChartBubblePacked16;
  exports.ChartBubblePacked20 = ChartBubblePacked20;
  exports.ChartBubblePacked24 = ChartBubblePacked24;
  exports.ChartBubblePacked32 = ChartBubblePacked32;
  exports.ChartBullet16 = ChartBullet16;
  exports.ChartBullet20 = ChartBullet20;
  exports.ChartBullet24 = ChartBullet24;
  exports.ChartBullet32 = ChartBullet32;
  exports.ChartCandlestick16 = ChartCandlestick16;
  exports.ChartCandlestick20 = ChartCandlestick20;
  exports.ChartCandlestick24 = ChartCandlestick24;
  exports.ChartCandlestick32 = ChartCandlestick32;
  exports.ChartClusterBar16 = ChartClusterBar16;
  exports.ChartClusterBar20 = ChartClusterBar20;
  exports.ChartClusterBar24 = ChartClusterBar24;
  exports.ChartClusterBar32 = ChartClusterBar32;
  exports.ChartColumn16 = ChartColumn16;
  exports.ChartColumn20 = ChartColumn20;
  exports.ChartColumn24 = ChartColumn24;
  exports.ChartColumn32 = ChartColumn32;
  exports.ChartColumnFloating16 = ChartColumnFloating16;
  exports.ChartColumnFloating20 = ChartColumnFloating20;
  exports.ChartColumnFloating24 = ChartColumnFloating24;
  exports.ChartColumnFloating32 = ChartColumnFloating32;
  exports.ChartColumnTarget16 = ChartColumnTarget16;
  exports.ChartColumnTarget20 = ChartColumnTarget20;
  exports.ChartColumnTarget24 = ChartColumnTarget24;
  exports.ChartColumnTarget32 = ChartColumnTarget32;
  exports.ChartCombo16 = ChartCombo16;
  exports.ChartCombo20 = ChartCombo20;
  exports.ChartCombo24 = ChartCombo24;
  exports.ChartCombo32 = ChartCombo32;
  exports.ChartComboStacked16 = ChartComboStacked16;
  exports.ChartComboStacked20 = ChartComboStacked20;
  exports.ChartComboStacked24 = ChartComboStacked24;
  exports.ChartComboStacked32 = ChartComboStacked32;
  exports.ChartCustom16 = ChartCustom16;
  exports.ChartCustom20 = ChartCustom20;
  exports.ChartCustom24 = ChartCustom24;
  exports.ChartCustom32 = ChartCustom32;
  exports.ChartErrorBar16 = ChartErrorBar16;
  exports.ChartErrorBar20 = ChartErrorBar20;
  exports.ChartErrorBar24 = ChartErrorBar24;
  exports.ChartErrorBar32 = ChartErrorBar32;
  exports.ChartErrorBarAlt16 = ChartErrorBarAlt16;
  exports.ChartErrorBarAlt20 = ChartErrorBarAlt20;
  exports.ChartErrorBarAlt24 = ChartErrorBarAlt24;
  exports.ChartErrorBarAlt32 = ChartErrorBarAlt32;
  exports.ChartEvaluation16 = ChartEvaluation16;
  exports.ChartEvaluation20 = ChartEvaluation20;
  exports.ChartEvaluation24 = ChartEvaluation24;
  exports.ChartEvaluation32 = ChartEvaluation32;
  exports.ChartHighLow16 = ChartHighLow16;
  exports.ChartHighLow20 = ChartHighLow20;
  exports.ChartHighLow24 = ChartHighLow24;
  exports.ChartHighLow32 = ChartHighLow32;
  exports.ChartHistogram16 = ChartHistogram16;
  exports.ChartHistogram20 = ChartHistogram20;
  exports.ChartHistogram24 = ChartHistogram24;
  exports.ChartHistogram32 = ChartHistogram32;
  exports.ChartLine16 = ChartLine16;
  exports.ChartLine20 = ChartLine20;
  exports.ChartLine24 = ChartLine24;
  exports.ChartLine32 = ChartLine32;
  exports.ChartLineData16 = ChartLineData16;
  exports.ChartLineData20 = ChartLineData20;
  exports.ChartLineData24 = ChartLineData24;
  exports.ChartLineData32 = ChartLineData32;
  exports.ChartLineSmooth16 = ChartLineSmooth16;
  exports.ChartLineSmooth20 = ChartLineSmooth20;
  exports.ChartLineSmooth24 = ChartLineSmooth24;
  exports.ChartLineSmooth32 = ChartLineSmooth32;
  exports.ChartMarimekko16 = ChartMarimekko16;
  exports.ChartMarimekko20 = ChartMarimekko20;
  exports.ChartMarimekko24 = ChartMarimekko24;
  exports.ChartMarimekko32 = ChartMarimekko32;
  exports.ChartMaximum16 = ChartMaximum16;
  exports.ChartMaximum20 = ChartMaximum20;
  exports.ChartMaximum24 = ChartMaximum24;
  exports.ChartMaximum32 = ChartMaximum32;
  exports.ChartMedian16 = ChartMedian16;
  exports.ChartMedian20 = ChartMedian20;
  exports.ChartMedian24 = ChartMedian24;
  exports.ChartMedian32 = ChartMedian32;
  exports.ChartMinimum16 = ChartMinimum16;
  exports.ChartMinimum20 = ChartMinimum20;
  exports.ChartMinimum24 = ChartMinimum24;
  exports.ChartMinimum32 = ChartMinimum32;
  exports.ChartMultiLine16 = ChartMultiLine16;
  exports.ChartMultiLine20 = ChartMultiLine20;
  exports.ChartMultiLine24 = ChartMultiLine24;
  exports.ChartMultiLine32 = ChartMultiLine32;
  exports.ChartMultitype16 = ChartMultitype16;
  exports.ChartMultitype20 = ChartMultitype20;
  exports.ChartMultitype24 = ChartMultitype24;
  exports.ChartMultitype32 = ChartMultitype32;
  exports.ChartNetwork16 = ChartNetwork16;
  exports.ChartNetwork20 = ChartNetwork20;
  exports.ChartNetwork24 = ChartNetwork24;
  exports.ChartNetwork32 = ChartNetwork32;
  exports.ChartParallel16 = ChartParallel16;
  exports.ChartParallel20 = ChartParallel20;
  exports.ChartParallel24 = ChartParallel24;
  exports.ChartParallel32 = ChartParallel32;
  exports.ChartPie16 = ChartPie16;
  exports.ChartPie20 = ChartPie20;
  exports.ChartPie24 = ChartPie24;
  exports.ChartPie32 = ChartPie32;
  exports.ChartPoint16 = ChartPoint16;
  exports.ChartPoint20 = ChartPoint20;
  exports.ChartPoint24 = ChartPoint24;
  exports.ChartPoint32 = ChartPoint32;
  exports.ChartPopulation16 = ChartPopulation16;
  exports.ChartPopulation20 = ChartPopulation20;
  exports.ChartPopulation24 = ChartPopulation24;
  exports.ChartPopulation32 = ChartPopulation32;
  exports.ChartRadar16 = ChartRadar16;
  exports.ChartRadar20 = ChartRadar20;
  exports.ChartRadar24 = ChartRadar24;
  exports.ChartRadar32 = ChartRadar32;
  exports.ChartRadial16 = ChartRadial16;
  exports.ChartRadial20 = ChartRadial20;
  exports.ChartRadial24 = ChartRadial24;
  exports.ChartRadial32 = ChartRadial32;
  exports.ChartRelationship16 = ChartRelationship16;
  exports.ChartRelationship20 = ChartRelationship20;
  exports.ChartRelationship24 = ChartRelationship24;
  exports.ChartRelationship32 = ChartRelationship32;
  exports.ChartRing16 = ChartRing16;
  exports.ChartRing20 = ChartRing20;
  exports.ChartRing24 = ChartRing24;
  exports.ChartRing32 = ChartRing32;
  exports.ChartRiver16 = ChartRiver16;
  exports.ChartRiver20 = ChartRiver20;
  exports.ChartRiver24 = ChartRiver24;
  exports.ChartRiver32 = ChartRiver32;
  exports.ChartRose16 = ChartRose16;
  exports.ChartRose20 = ChartRose20;
  exports.ChartRose24 = ChartRose24;
  exports.ChartRose32 = ChartRose32;
  exports.ChartScatter16 = ChartScatter16;
  exports.ChartScatter20 = ChartScatter20;
  exports.ChartScatter24 = ChartScatter24;
  exports.ChartScatter32 = ChartScatter32;
  exports.ChartSpiral16 = ChartSpiral16;
  exports.ChartSpiral20 = ChartSpiral20;
  exports.ChartSpiral24 = ChartSpiral24;
  exports.ChartSpiral32 = ChartSpiral32;
  exports.ChartStacked16 = ChartStacked16;
  exports.ChartStacked20 = ChartStacked20;
  exports.ChartStacked24 = ChartStacked24;
  exports.ChartStacked32 = ChartStacked32;
  exports.ChartStepper16 = ChartStepper16;
  exports.ChartStepper20 = ChartStepper20;
  exports.ChartStepper24 = ChartStepper24;
  exports.ChartStepper32 = ChartStepper32;
  exports.ChartSunburst16 = ChartSunburst16;
  exports.ChartSunburst20 = ChartSunburst20;
  exports.ChartSunburst24 = ChartSunburst24;
  exports.ChartSunburst32 = ChartSunburst32;
  exports.ChartTSne16 = ChartTSne16;
  exports.ChartTSne20 = ChartTSne20;
  exports.ChartTSne24 = ChartTSne24;
  exports.ChartTSne32 = ChartTSne32;
  exports.ChartTreemap16 = ChartTreemap16;
  exports.ChartTreemap20 = ChartTreemap20;
  exports.ChartTreemap24 = ChartTreemap24;
  exports.ChartTreemap32 = ChartTreemap32;
  exports.ChartVennDiagram16 = ChartVennDiagram16;
  exports.ChartVennDiagram20 = ChartVennDiagram20;
  exports.ChartVennDiagram24 = ChartVennDiagram24;
  exports.ChartVennDiagram32 = ChartVennDiagram32;
  exports.ChartViolinPlot16 = ChartViolinPlot16;
  exports.ChartViolinPlot20 = ChartViolinPlot20;
  exports.ChartViolinPlot24 = ChartViolinPlot24;
  exports.ChartViolinPlot32 = ChartViolinPlot32;
  exports.ChartWaterfall16 = ChartWaterfall16;
  exports.ChartWaterfall20 = ChartWaterfall20;
  exports.ChartWaterfall24 = ChartWaterfall24;
  exports.ChartWaterfall32 = ChartWaterfall32;
  exports.ChartWinLoss16 = ChartWinLoss16;
  exports.ChartWinLoss20 = ChartWinLoss20;
  exports.ChartWinLoss24 = ChartWinLoss24;
  exports.ChartWinLoss32 = ChartWinLoss32;
  exports.Chart_3D16 = Chart_3D16;
  exports.Chart_3D20 = Chart_3D20;
  exports.Chart_3D24 = Chart_3D24;
  exports.Chart_3D32 = Chart_3D32;
  exports.Chat16 = Chat16;
  exports.Chat20 = Chat20;
  exports.Chat24 = Chat24;
  exports.Chat32 = Chat32;
  exports.ChatBot16 = ChatBot16;
  exports.ChatBot20 = ChatBot20;
  exports.ChatBot24 = ChatBot24;
  exports.ChatBot32 = ChatBot32;
  exports.ChatLaunch16 = ChatLaunch16;
  exports.ChatLaunch20 = ChatLaunch20;
  exports.ChatLaunch24 = ChatLaunch24;
  exports.ChatLaunch32 = ChatLaunch32;
  exports.ChatOff16 = ChatOff16;
  exports.ChatOff20 = ChatOff20;
  exports.ChatOff24 = ChatOff24;
  exports.ChatOff32 = ChatOff32;
  exports.ChatOperational16 = ChatOperational16;
  exports.ChatOperational20 = ChatOperational20;
  exports.ChatOperational24 = ChatOperational24;
  exports.ChatOperational32 = ChatOperational32;
  exports.Checkbox16 = Checkbox16;
  exports.Checkbox20 = Checkbox20;
  exports.Checkbox24 = Checkbox24;
  exports.Checkbox32 = Checkbox32;
  exports.CheckboxChecked16 = CheckboxChecked16;
  exports.CheckboxChecked20 = CheckboxChecked20;
  exports.CheckboxChecked24 = CheckboxChecked24;
  exports.CheckboxChecked32 = CheckboxChecked32;
  exports.CheckboxCheckedFilled16 = CheckboxCheckedFilled16;
  exports.CheckboxCheckedFilled20 = CheckboxCheckedFilled20;
  exports.CheckboxCheckedFilled24 = CheckboxCheckedFilled24;
  exports.CheckboxCheckedFilled32 = CheckboxCheckedFilled32;
  exports.CheckboxIndeterminate16 = CheckboxIndeterminate16;
  exports.CheckboxIndeterminate20 = CheckboxIndeterminate20;
  exports.CheckboxIndeterminate24 = CheckboxIndeterminate24;
  exports.CheckboxIndeterminate32 = CheckboxIndeterminate32;
  exports.CheckboxIndeterminateFilled16 = CheckboxIndeterminateFilled16;
  exports.CheckboxIndeterminateFilled20 = CheckboxIndeterminateFilled20;
  exports.CheckboxIndeterminateFilled24 = CheckboxIndeterminateFilled24;
  exports.CheckboxIndeterminateFilled32 = CheckboxIndeterminateFilled32;
  exports.CheckboxUndeterminate16 = CheckboxUndeterminate16;
  exports.CheckboxUndeterminate20 = CheckboxUndeterminate20;
  exports.CheckboxUndeterminate24 = CheckboxUndeterminate24;
  exports.CheckboxUndeterminate32 = CheckboxUndeterminate32;
  exports.CheckboxUndeterminateFilled16 = CheckboxUndeterminateFilled16;
  exports.CheckboxUndeterminateFilled20 = CheckboxUndeterminateFilled20;
  exports.CheckboxUndeterminateFilled24 = CheckboxUndeterminateFilled24;
  exports.CheckboxUndeterminateFilled32 = CheckboxUndeterminateFilled32;
  exports.Checkmark16 = Checkmark16;
  exports.Checkmark20 = Checkmark20;
  exports.Checkmark24 = Checkmark24;
  exports.Checkmark32 = Checkmark32;
  exports.CheckmarkFilled16 = CheckmarkFilled16;
  exports.CheckmarkFilled20 = CheckmarkFilled20;
  exports.CheckmarkFilled24 = CheckmarkFilled24;
  exports.CheckmarkFilled32 = CheckmarkFilled32;
  exports.CheckmarkFilledError16 = CheckmarkFilledError16;
  exports.CheckmarkFilledError20 = CheckmarkFilledError20;
  exports.CheckmarkFilledError24 = CheckmarkFilledError24;
  exports.CheckmarkFilledError32 = CheckmarkFilledError32;
  exports.CheckmarkFilledWarning16 = CheckmarkFilledWarning16;
  exports.CheckmarkFilledWarning20 = CheckmarkFilledWarning20;
  exports.CheckmarkFilledWarning24 = CheckmarkFilledWarning24;
  exports.CheckmarkFilledWarning32 = CheckmarkFilledWarning32;
  exports.CheckmarkOutline16 = CheckmarkOutline16;
  exports.CheckmarkOutline20 = CheckmarkOutline20;
  exports.CheckmarkOutline24 = CheckmarkOutline24;
  exports.CheckmarkOutline32 = CheckmarkOutline32;
  exports.CheckmarkOutlineError16 = CheckmarkOutlineError16;
  exports.CheckmarkOutlineError20 = CheckmarkOutlineError20;
  exports.CheckmarkOutlineError24 = CheckmarkOutlineError24;
  exports.CheckmarkOutlineError32 = CheckmarkOutlineError32;
  exports.CheckmarkOutlineWarning16 = CheckmarkOutlineWarning16;
  exports.CheckmarkOutlineWarning20 = CheckmarkOutlineWarning20;
  exports.CheckmarkOutlineWarning24 = CheckmarkOutlineWarning24;
  exports.CheckmarkOutlineWarning32 = CheckmarkOutlineWarning32;
  exports.Chemistry16 = Chemistry16;
  exports.Chemistry20 = Chemistry20;
  exports.Chemistry24 = Chemistry24;
  exports.Chemistry32 = Chemistry32;
  exports.ChemistryReference16 = ChemistryReference16;
  exports.ChemistryReference20 = ChemistryReference20;
  exports.ChemistryReference24 = ChemistryReference24;
  exports.ChemistryReference32 = ChemistryReference32;
  exports.ChevronDown16 = ChevronDown16;
  exports.ChevronDown20 = ChevronDown20;
  exports.ChevronDown24 = ChevronDown24;
  exports.ChevronDown32 = ChevronDown32;
  exports.ChevronDownGlyph = ChevronDownGlyph;
  exports.ChevronLeft16 = ChevronLeft16;
  exports.ChevronLeft20 = ChevronLeft20;
  exports.ChevronLeft24 = ChevronLeft24;
  exports.ChevronLeft32 = ChevronLeft32;
  exports.ChevronLeftGlyph = ChevronLeftGlyph;
  exports.ChevronMini16 = ChevronMini16;
  exports.ChevronMini20 = ChevronMini20;
  exports.ChevronMini24 = ChevronMini24;
  exports.ChevronMini32 = ChevronMini32;
  exports.ChevronRight16 = ChevronRight16;
  exports.ChevronRight20 = ChevronRight20;
  exports.ChevronRight24 = ChevronRight24;
  exports.ChevronRight32 = ChevronRight32;
  exports.ChevronRightGlyph = ChevronRightGlyph;
  exports.ChevronSort16 = ChevronSort16;
  exports.ChevronSort20 = ChevronSort20;
  exports.ChevronSort24 = ChevronSort24;
  exports.ChevronSort32 = ChevronSort32;
  exports.ChevronSortDown16 = ChevronSortDown16;
  exports.ChevronSortDown20 = ChevronSortDown20;
  exports.ChevronSortDown24 = ChevronSortDown24;
  exports.ChevronSortDown32 = ChevronSortDown32;
  exports.ChevronSortUp16 = ChevronSortUp16;
  exports.ChevronSortUp20 = ChevronSortUp20;
  exports.ChevronSortUp24 = ChevronSortUp24;
  exports.ChevronSortUp32 = ChevronSortUp32;
  exports.ChevronUp16 = ChevronUp16;
  exports.ChevronUp20 = ChevronUp20;
  exports.ChevronUp24 = ChevronUp24;
  exports.ChevronUp32 = ChevronUp32;
  exports.ChevronUpGlyph = ChevronUpGlyph;
  exports.Chip16 = Chip16;
  exports.Chip20 = Chip20;
  exports.Chip24 = Chip24;
  exports.Chip32 = Chip32;
  exports.Choices16 = Choices16;
  exports.Choices20 = Choices20;
  exports.Choices24 = Choices24;
  exports.Choices32 = Choices32;
  exports.ChooseItem16 = ChooseItem16;
  exports.ChooseItem20 = ChooseItem20;
  exports.ChooseItem24 = ChooseItem24;
  exports.ChooseItem32 = ChooseItem32;
  exports.ChoroplethMap16 = ChoroplethMap16;
  exports.ChoroplethMap20 = ChoroplethMap20;
  exports.ChoroplethMap24 = ChoroplethMap24;
  exports.ChoroplethMap32 = ChoroplethMap32;
  exports.CicsCmas16 = CicsCmas16;
  exports.CicsCmas20 = CicsCmas20;
  exports.CicsCmas24 = CicsCmas24;
  exports.CicsCmas32 = CicsCmas32;
  exports.CicsExplorer16 = CicsExplorer16;
  exports.CicsExplorer20 = CicsExplorer20;
  exports.CicsExplorer24 = CicsExplorer24;
  exports.CicsExplorer32 = CicsExplorer32;
  exports.CicsRegion16 = CicsRegion16;
  exports.CicsRegion20 = CicsRegion20;
  exports.CicsRegion24 = CicsRegion24;
  exports.CicsRegion32 = CicsRegion32;
  exports.CicsRegionRouting16 = CicsRegionRouting16;
  exports.CicsRegionRouting20 = CicsRegionRouting20;
  exports.CicsRegionRouting24 = CicsRegionRouting24;
  exports.CicsRegionRouting32 = CicsRegionRouting32;
  exports.CicsRegionTarget16 = CicsRegionTarget16;
  exports.CicsRegionTarget20 = CicsRegionTarget20;
  exports.CicsRegionTarget24 = CicsRegionTarget24;
  exports.CicsRegionTarget32 = CicsRegionTarget32;
  exports.CicsSystemGroup16 = CicsSystemGroup16;
  exports.CicsSystemGroup20 = CicsSystemGroup20;
  exports.CicsSystemGroup24 = CicsSystemGroup24;
  exports.CicsSystemGroup32 = CicsSystemGroup32;
  exports.CicsWuiRegion16 = CicsWuiRegion16;
  exports.CicsWuiRegion20 = CicsWuiRegion20;
  exports.CicsWuiRegion24 = CicsWuiRegion24;
  exports.CicsWuiRegion32 = CicsWuiRegion32;
  exports.Cicsplex16 = Cicsplex16;
  exports.Cicsplex20 = Cicsplex20;
  exports.Cicsplex24 = Cicsplex24;
  exports.Cicsplex32 = Cicsplex32;
  exports.CircleDash16 = CircleDash16;
  exports.CircleDash20 = CircleDash20;
  exports.CircleDash24 = CircleDash24;
  exports.CircleDash32 = CircleDash32;
  exports.CircleFillGlyph = CircleFillGlyph;
  exports.CircleFilled16 = CircleFilled16;
  exports.CircleFilled20 = CircleFilled20;
  exports.CircleFilled24 = CircleFilled24;
  exports.CircleFilled32 = CircleFilled32;
  exports.CirclePacking16 = CirclePacking16;
  exports.CirclePacking20 = CirclePacking20;
  exports.CirclePacking24 = CirclePacking24;
  exports.CirclePacking32 = CirclePacking32;
  exports.CircleSolid16 = CircleSolid16;
  exports.CircleSolid20 = CircleSolid20;
  exports.CircleSolid24 = CircleSolid24;
  exports.CircleSolid32 = CircleSolid32;
  exports.CircleStrokeGlyph = CircleStrokeGlyph;
  exports.Classification16 = Classification16;
  exports.Classification20 = Classification20;
  exports.Classification24 = Classification24;
  exports.Classification32 = Classification32;
  exports.ClassifierLanguage16 = ClassifierLanguage16;
  exports.ClassifierLanguage20 = ClassifierLanguage20;
  exports.ClassifierLanguage24 = ClassifierLanguage24;
  exports.ClassifierLanguage32 = ClassifierLanguage32;
  exports.Clean16 = Clean16;
  exports.Clean20 = Clean20;
  exports.Clean24 = Clean24;
  exports.Clean32 = Clean32;
  exports.Close16 = Close16;
  exports.Close20 = Close20;
  exports.Close24 = Close24;
  exports.Close32 = Close32;
  exports.CloseFilled16 = CloseFilled16;
  exports.CloseFilled20 = CloseFilled20;
  exports.CloseFilled24 = CloseFilled24;
  exports.CloseFilled32 = CloseFilled32;
  exports.CloseOutline16 = CloseOutline16;
  exports.CloseOutline20 = CloseOutline20;
  exports.CloseOutline24 = CloseOutline24;
  exports.CloseOutline32 = CloseOutline32;
  exports.ClosedCaption16 = ClosedCaption16;
  exports.ClosedCaption20 = ClosedCaption20;
  exports.ClosedCaption24 = ClosedCaption24;
  exports.ClosedCaption32 = ClosedCaption32;
  exports.ClosedCaptionAlt16 = ClosedCaptionAlt16;
  exports.ClosedCaptionAlt20 = ClosedCaptionAlt20;
  exports.ClosedCaptionAlt24 = ClosedCaptionAlt24;
  exports.ClosedCaptionAlt32 = ClosedCaptionAlt32;
  exports.ClosedCaptionFilled16 = ClosedCaptionFilled16;
  exports.ClosedCaptionFilled20 = ClosedCaptionFilled20;
  exports.ClosedCaptionFilled24 = ClosedCaptionFilled24;
  exports.ClosedCaptionFilled32 = ClosedCaptionFilled32;
  exports.Cloud16 = Cloud16;
  exports.Cloud20 = Cloud20;
  exports.Cloud24 = Cloud24;
  exports.Cloud32 = Cloud32;
  exports.CloudAlerting16 = CloudAlerting16;
  exports.CloudAlerting20 = CloudAlerting20;
  exports.CloudAlerting24 = CloudAlerting24;
  exports.CloudAlerting32 = CloudAlerting32;
  exports.CloudApp16 = CloudApp16;
  exports.CloudApp20 = CloudApp20;
  exports.CloudApp24 = CloudApp24;
  exports.CloudApp32 = CloudApp32;
  exports.CloudAuditing16 = CloudAuditing16;
  exports.CloudAuditing20 = CloudAuditing20;
  exports.CloudAuditing24 = CloudAuditing24;
  exports.CloudAuditing32 = CloudAuditing32;
  exports.CloudCeiling16 = CloudCeiling16;
  exports.CloudCeiling20 = CloudCeiling20;
  exports.CloudCeiling24 = CloudCeiling24;
  exports.CloudCeiling32 = CloudCeiling32;
  exports.CloudDataOps16 = CloudDataOps16;
  exports.CloudDataOps20 = CloudDataOps20;
  exports.CloudDataOps24 = CloudDataOps24;
  exports.CloudDataOps32 = CloudDataOps32;
  exports.CloudDownload16 = CloudDownload16;
  exports.CloudDownload20 = CloudDownload20;
  exports.CloudDownload24 = CloudDownload24;
  exports.CloudDownload32 = CloudDownload32;
  exports.CloudFoundry_116 = CloudFoundry_116;
  exports.CloudFoundry_120 = CloudFoundry_120;
  exports.CloudFoundry_124 = CloudFoundry_124;
  exports.CloudFoundry_132 = CloudFoundry_132;
  exports.CloudFoundry_216 = CloudFoundry_216;
  exports.CloudFoundry_220 = CloudFoundry_220;
  exports.CloudFoundry_224 = CloudFoundry_224;
  exports.CloudFoundry_232 = CloudFoundry_232;
  exports.CloudLightning16 = CloudLightning16;
  exports.CloudLightning20 = CloudLightning20;
  exports.CloudLightning24 = CloudLightning24;
  exports.CloudLightning32 = CloudLightning32;
  exports.CloudLogging16 = CloudLogging16;
  exports.CloudLogging20 = CloudLogging20;
  exports.CloudLogging24 = CloudLogging24;
  exports.CloudLogging32 = CloudLogging32;
  exports.CloudMonitoring16 = CloudMonitoring16;
  exports.CloudMonitoring20 = CloudMonitoring20;
  exports.CloudMonitoring24 = CloudMonitoring24;
  exports.CloudMonitoring32 = CloudMonitoring32;
  exports.CloudOffline16 = CloudOffline16;
  exports.CloudOffline20 = CloudOffline20;
  exports.CloudOffline24 = CloudOffline24;
  exports.CloudOffline32 = CloudOffline32;
  exports.CloudRain16 = CloudRain16;
  exports.CloudRain20 = CloudRain20;
  exports.CloudRain24 = CloudRain24;
  exports.CloudRain32 = CloudRain32;
  exports.CloudRegistry16 = CloudRegistry16;
  exports.CloudRegistry20 = CloudRegistry20;
  exports.CloudRegistry24 = CloudRegistry24;
  exports.CloudRegistry32 = CloudRegistry32;
  exports.CloudSatellite16 = CloudSatellite16;
  exports.CloudSatellite20 = CloudSatellite20;
  exports.CloudSatellite24 = CloudSatellite24;
  exports.CloudSatellite32 = CloudSatellite32;
  exports.CloudSatelliteConfig16 = CloudSatelliteConfig16;
  exports.CloudSatelliteConfig20 = CloudSatelliteConfig20;
  exports.CloudSatelliteConfig24 = CloudSatelliteConfig24;
  exports.CloudSatelliteConfig32 = CloudSatelliteConfig32;
  exports.CloudSatelliteLink16 = CloudSatelliteLink16;
  exports.CloudSatelliteLink20 = CloudSatelliteLink20;
  exports.CloudSatelliteLink24 = CloudSatelliteLink24;
  exports.CloudSatelliteLink32 = CloudSatelliteLink32;
  exports.CloudSatelliteServices16 = CloudSatelliteServices16;
  exports.CloudSatelliteServices20 = CloudSatelliteServices20;
  exports.CloudSatelliteServices24 = CloudSatelliteServices24;
  exports.CloudSatelliteServices32 = CloudSatelliteServices32;
  exports.CloudServiceManagement16 = CloudServiceManagement16;
  exports.CloudServiceManagement20 = CloudServiceManagement20;
  exports.CloudServiceManagement24 = CloudServiceManagement24;
  exports.CloudServiceManagement32 = CloudServiceManagement32;
  exports.CloudServices16 = CloudServices16;
  exports.CloudServices20 = CloudServices20;
  exports.CloudServices24 = CloudServices24;
  exports.CloudServices32 = CloudServices32;
  exports.CloudSnow16 = CloudSnow16;
  exports.CloudSnow20 = CloudSnow20;
  exports.CloudSnow24 = CloudSnow24;
  exports.CloudSnow32 = CloudSnow32;
  exports.CloudUpload16 = CloudUpload16;
  exports.CloudUpload20 = CloudUpload20;
  exports.CloudUpload24 = CloudUpload24;
  exports.CloudUpload32 = CloudUpload32;
  exports.Cloudy16 = Cloudy16;
  exports.Cloudy20 = Cloudy20;
  exports.Cloudy24 = Cloudy24;
  exports.Cloudy32 = Cloudy32;
  exports.Code16 = Code16;
  exports.Code20 = Code20;
  exports.Code24 = Code24;
  exports.Code32 = Code32;
  exports.CodeHide16 = CodeHide16;
  exports.CodeHide20 = CodeHide20;
  exports.CodeHide24 = CodeHide24;
  exports.CodeHide32 = CodeHide32;
  exports.CodeReference16 = CodeReference16;
  exports.CodeReference20 = CodeReference20;
  exports.CodeReference24 = CodeReference24;
  exports.CodeReference32 = CodeReference32;
  exports.CodeSigningService16 = CodeSigningService16;
  exports.CodeSigningService20 = CodeSigningService20;
  exports.CodeSigningService24 = CodeSigningService24;
  exports.CodeSigningService32 = CodeSigningService32;
  exports.Cognitive16 = Cognitive16;
  exports.Cognitive20 = Cognitive20;
  exports.Cognitive24 = Cognitive24;
  exports.Cognitive32 = Cognitive32;
  exports.Collaborate16 = Collaborate16;
  exports.Collaborate20 = Collaborate20;
  exports.Collaborate24 = Collaborate24;
  exports.Collaborate32 = Collaborate32;
  exports.CollapseAll16 = CollapseAll16;
  exports.CollapseAll20 = CollapseAll20;
  exports.CollapseAll24 = CollapseAll24;
  exports.CollapseAll32 = CollapseAll32;
  exports.CollapseCategories16 = CollapseCategories16;
  exports.CollapseCategories20 = CollapseCategories20;
  exports.CollapseCategories24 = CollapseCategories24;
  exports.CollapseCategories32 = CollapseCategories32;
  exports.ColorPalette16 = ColorPalette16;
  exports.ColorPalette20 = ColorPalette20;
  exports.ColorPalette24 = ColorPalette24;
  exports.ColorPalette32 = ColorPalette32;
  exports.ColorSwitch16 = ColorSwitch16;
  exports.ColorSwitch20 = ColorSwitch20;
  exports.ColorSwitch24 = ColorSwitch24;
  exports.ColorSwitch32 = ColorSwitch32;
  exports.Column16 = Column16;
  exports.Column20 = Column20;
  exports.Column24 = Column24;
  exports.Column32 = Column32;
  exports.ColumnDelete16 = ColumnDelete16;
  exports.ColumnDelete20 = ColumnDelete20;
  exports.ColumnDelete24 = ColumnDelete24;
  exports.ColumnDelete32 = ColumnDelete32;
  exports.ColumnDependency16 = ColumnDependency16;
  exports.ColumnDependency20 = ColumnDependency20;
  exports.ColumnDependency24 = ColumnDependency24;
  exports.ColumnDependency32 = ColumnDependency32;
  exports.ColumnInsert16 = ColumnInsert16;
  exports.ColumnInsert20 = ColumnInsert20;
  exports.ColumnInsert24 = ColumnInsert24;
  exports.ColumnInsert32 = ColumnInsert32;
  exports.Commit16 = Commit16;
  exports.Commit20 = Commit20;
  exports.Commit24 = Commit24;
  exports.Commit32 = Commit32;
  exports.CommunicationUnified16 = CommunicationUnified16;
  exports.CommunicationUnified20 = CommunicationUnified20;
  exports.CommunicationUnified24 = CommunicationUnified24;
  exports.CommunicationUnified32 = CommunicationUnified32;
  exports.Compare16 = Compare16;
  exports.Compare20 = Compare20;
  exports.Compare24 = Compare24;
  exports.Compare32 = Compare32;
  exports.Compass16 = Compass16;
  exports.Compass20 = Compass20;
  exports.Compass24 = Compass24;
  exports.Compass32 = Compass32;
  exports.Concept16 = Concept16;
  exports.Concept20 = Concept20;
  exports.Concept24 = Concept24;
  exports.Concept32 = Concept32;
  exports.ConditionPoint16 = ConditionPoint16;
  exports.ConditionPoint20 = ConditionPoint20;
  exports.ConditionPoint24 = ConditionPoint24;
  exports.ConditionPoint32 = ConditionPoint32;
  exports.ConditionWaitPoint16 = ConditionWaitPoint16;
  exports.ConditionWaitPoint20 = ConditionWaitPoint20;
  exports.ConditionWaitPoint24 = ConditionWaitPoint24;
  exports.ConditionWaitPoint32 = ConditionWaitPoint32;
  exports.Connect16 = Connect16;
  exports.Connect20 = Connect20;
  exports.Connect24 = Connect24;
  exports.Connect32 = Connect32;
  exports.ConnectRecursive16 = ConnectRecursive16;
  exports.ConnectRecursive20 = ConnectRecursive20;
  exports.ConnectRecursive24 = ConnectRecursive24;
  exports.ConnectRecursive32 = ConnectRecursive32;
  exports.ConnectSource16 = ConnectSource16;
  exports.ConnectSource20 = ConnectSource20;
  exports.ConnectSource24 = ConnectSource24;
  exports.ConnectSource32 = ConnectSource32;
  exports.ConnectTarget16 = ConnectTarget16;
  exports.ConnectTarget20 = ConnectTarget20;
  exports.ConnectTarget24 = ConnectTarget24;
  exports.ConnectTarget32 = ConnectTarget32;
  exports.ConnectionReceive16 = ConnectionReceive16;
  exports.ConnectionReceive20 = ConnectionReceive20;
  exports.ConnectionReceive24 = ConnectionReceive24;
  exports.ConnectionReceive32 = ConnectionReceive32;
  exports.ConnectionSend16 = ConnectionSend16;
  exports.ConnectionSend20 = ConnectionSend20;
  exports.ConnectionSend24 = ConnectionSend24;
  exports.ConnectionSend32 = ConnectionSend32;
  exports.ConnectionSignal16 = ConnectionSignal16;
  exports.ConnectionSignal20 = ConnectionSignal20;
  exports.ConnectionSignal24 = ConnectionSignal24;
  exports.ConnectionSignal32 = ConnectionSignal32;
  exports.ConnectionSignalOff16 = ConnectionSignalOff16;
  exports.ConnectionSignalOff20 = ConnectionSignalOff20;
  exports.ConnectionSignalOff24 = ConnectionSignalOff24;
  exports.ConnectionSignalOff32 = ConnectionSignalOff32;
  exports.ConnectionTwoWay16 = ConnectionTwoWay16;
  exports.ConnectionTwoWay20 = ConnectionTwoWay20;
  exports.ConnectionTwoWay24 = ConnectionTwoWay24;
  exports.ConnectionTwoWay32 = ConnectionTwoWay32;
  exports.Construction16 = Construction16;
  exports.Construction20 = Construction20;
  exports.Construction24 = Construction24;
  exports.Construction32 = Construction32;
  exports.ContainerRegistry16 = ContainerRegistry16;
  exports.ContainerRegistry20 = ContainerRegistry20;
  exports.ContainerRegistry24 = ContainerRegistry24;
  exports.ContainerRegistry32 = ContainerRegistry32;
  exports.ContainerServices16 = ContainerServices16;
  exports.ContainerServices20 = ContainerServices20;
  exports.ContainerServices24 = ContainerServices24;
  exports.ContainerServices32 = ContainerServices32;
  exports.ContainerSoftware16 = ContainerSoftware16;
  exports.ContainerSoftware20 = ContainerSoftware20;
  exports.ContainerSoftware24 = ContainerSoftware24;
  exports.ContainerSoftware32 = ContainerSoftware32;
  exports.ContentDeliveryNetwork16 = ContentDeliveryNetwork16;
  exports.ContentDeliveryNetwork20 = ContentDeliveryNetwork20;
  exports.ContentDeliveryNetwork24 = ContentDeliveryNetwork24;
  exports.ContentDeliveryNetwork32 = ContentDeliveryNetwork32;
  exports.ContentView16 = ContentView16;
  exports.ContentView20 = ContentView20;
  exports.ContentView24 = ContentView24;
  exports.ContentView32 = ContentView32;
  exports.Continue16 = Continue16;
  exports.Continue20 = Continue20;
  exports.Continue24 = Continue24;
  exports.Continue32 = Continue32;
  exports.ContinueFilled16 = ContinueFilled16;
  exports.ContinueFilled20 = ContinueFilled20;
  exports.ContinueFilled24 = ContinueFilled24;
  exports.ContinueFilled32 = ContinueFilled32;
  exports.Contrast16 = Contrast16;
  exports.Contrast20 = Contrast20;
  exports.Contrast24 = Contrast24;
  exports.Contrast32 = Contrast32;
  exports.ConvertToCloud16 = ConvertToCloud16;
  exports.ConvertToCloud20 = ConvertToCloud20;
  exports.ConvertToCloud24 = ConvertToCloud24;
  exports.ConvertToCloud32 = ConvertToCloud32;
  exports.Copy16 = Copy16;
  exports.Copy20 = Copy20;
  exports.Copy24 = Copy24;
  exports.Copy32 = Copy32;
  exports.CopyFile16 = CopyFile16;
  exports.CopyFile20 = CopyFile20;
  exports.CopyFile24 = CopyFile24;
  exports.CopyFile32 = CopyFile32;
  exports.CopyLink16 = CopyLink16;
  exports.CopyLink20 = CopyLink20;
  exports.CopyLink24 = CopyLink24;
  exports.CopyLink32 = CopyLink32;
  exports.Corn16 = Corn16;
  exports.Corn20 = Corn20;
  exports.Corn24 = Corn24;
  exports.Corn32 = Corn32;
  exports.Corner16 = Corner16;
  exports.Corner20 = Corner20;
  exports.Corner24 = Corner24;
  exports.Corner32 = Corner32;
  exports.Coronavirus16 = Coronavirus16;
  exports.Coronavirus20 = Coronavirus20;
  exports.Coronavirus24 = Coronavirus24;
  exports.Coronavirus32 = Coronavirus32;
  exports.Cost16 = Cost16;
  exports.Cost20 = Cost20;
  exports.Cost24 = Cost24;
  exports.Cost32 = Cost32;
  exports.CostTotal16 = CostTotal16;
  exports.CostTotal20 = CostTotal20;
  exports.CostTotal24 = CostTotal24;
  exports.CostTotal32 = CostTotal32;
  exports.Cough16 = Cough16;
  exports.Cough20 = Cough20;
  exports.Cough24 = Cough24;
  exports.Cough32 = Cough32;
  exports.Course16 = Course16;
  exports.Course20 = Course20;
  exports.Course24 = Course24;
  exports.Course32 = Course32;
  exports.Covariate16 = Covariate16;
  exports.Covariate20 = Covariate20;
  exports.Covariate24 = Covariate24;
  exports.Covariate32 = Covariate32;
  exports.Credentials16 = Credentials16;
  exports.Credentials20 = Credentials20;
  exports.Credentials24 = Credentials24;
  exports.Credentials32 = Credentials32;
  exports.CriticalGlyph = CriticalGlyph;
  exports.CriticalSeverityGlyph = CriticalSeverityGlyph;
  exports.Crop16 = Crop16;
  exports.Crop20 = Crop20;
  exports.Crop24 = Crop24;
  exports.Crop32 = Crop32;
  exports.CropGrowth16 = CropGrowth16;
  exports.CropGrowth20 = CropGrowth20;
  exports.CropGrowth24 = CropGrowth24;
  exports.CropGrowth32 = CropGrowth32;
  exports.CropHealth16 = CropHealth16;
  exports.CropHealth20 = CropHealth20;
  exports.CropHealth24 = CropHealth24;
  exports.CropHealth32 = CropHealth32;
  exports.CrossTab16 = CrossTab16;
  exports.CrossTab20 = CrossTab20;
  exports.CrossTab24 = CrossTab24;
  exports.CrossTab32 = CrossTab32;
  exports.Crossroads16 = Crossroads16;
  exports.Crossroads20 = Crossroads20;
  exports.Crossroads24 = Crossroads24;
  exports.Crossroads32 = Crossroads32;
  exports.CrowdReport16 = CrowdReport16;
  exports.CrowdReport20 = CrowdReport20;
  exports.CrowdReport24 = CrowdReport24;
  exports.CrowdReport32 = CrowdReport32;
  exports.CrowdReportFilled16 = CrowdReportFilled16;
  exports.CrowdReportFilled20 = CrowdReportFilled20;
  exports.CrowdReportFilled24 = CrowdReportFilled24;
  exports.CrowdReportFilled32 = CrowdReportFilled32;
  exports.Csv16 = Csv16;
  exports.Csv20 = Csv20;
  exports.Csv24 = Csv24;
  exports.Csv32 = Csv32;
  exports.Cube16 = Cube16;
  exports.Cube20 = Cube20;
  exports.Cube24 = Cube24;
  exports.Cube32 = Cube32;
  exports.CubeView16 = CubeView16;
  exports.CubeView20 = CubeView20;
  exports.CubeView24 = CubeView24;
  exports.CubeView32 = CubeView32;
  exports.Currency16 = Currency16;
  exports.Currency20 = Currency20;
  exports.Currency24 = Currency24;
  exports.Currency32 = Currency32;
  exports.CurrencyBaht16 = CurrencyBaht16;
  exports.CurrencyBaht20 = CurrencyBaht20;
  exports.CurrencyBaht24 = CurrencyBaht24;
  exports.CurrencyBaht32 = CurrencyBaht32;
  exports.CurrencyDollar16 = CurrencyDollar16;
  exports.CurrencyDollar20 = CurrencyDollar20;
  exports.CurrencyDollar24 = CurrencyDollar24;
  exports.CurrencyDollar32 = CurrencyDollar32;
  exports.CurrencyEuro16 = CurrencyEuro16;
  exports.CurrencyEuro20 = CurrencyEuro20;
  exports.CurrencyEuro24 = CurrencyEuro24;
  exports.CurrencyEuro32 = CurrencyEuro32;
  exports.CurrencyLira16 = CurrencyLira16;
  exports.CurrencyLira20 = CurrencyLira20;
  exports.CurrencyLira24 = CurrencyLira24;
  exports.CurrencyLira32 = CurrencyLira32;
  exports.CurrencyPound16 = CurrencyPound16;
  exports.CurrencyPound20 = CurrencyPound20;
  exports.CurrencyPound24 = CurrencyPound24;
  exports.CurrencyPound32 = CurrencyPound32;
  exports.CurrencyRuble16 = CurrencyRuble16;
  exports.CurrencyRuble20 = CurrencyRuble20;
  exports.CurrencyRuble24 = CurrencyRuble24;
  exports.CurrencyRuble32 = CurrencyRuble32;
  exports.CurrencyRupee16 = CurrencyRupee16;
  exports.CurrencyRupee20 = CurrencyRupee20;
  exports.CurrencyRupee24 = CurrencyRupee24;
  exports.CurrencyRupee32 = CurrencyRupee32;
  exports.CurrencyShekel16 = CurrencyShekel16;
  exports.CurrencyShekel20 = CurrencyShekel20;
  exports.CurrencyShekel24 = CurrencyShekel24;
  exports.CurrencyShekel32 = CurrencyShekel32;
  exports.CurrencyWon16 = CurrencyWon16;
  exports.CurrencyWon20 = CurrencyWon20;
  exports.CurrencyWon24 = CurrencyWon24;
  exports.CurrencyWon32 = CurrencyWon32;
  exports.CurrencyYen16 = CurrencyYen16;
  exports.CurrencyYen20 = CurrencyYen20;
  exports.CurrencyYen24 = CurrencyYen24;
  exports.CurrencyYen32 = CurrencyYen32;
  exports.Cursor_116 = Cursor_116;
  exports.Cursor_120 = Cursor_120;
  exports.Cursor_124 = Cursor_124;
  exports.Cursor_132 = Cursor_132;
  exports.Cursor_216 = Cursor_216;
  exports.Cursor_220 = Cursor_220;
  exports.Cursor_224 = Cursor_224;
  exports.Cursor_232 = Cursor_232;
  exports.Cut16 = Cut16;
  exports.Cut20 = Cut20;
  exports.Cut24 = Cut24;
  exports.Cut32 = Cut32;
  exports.CutOut16 = CutOut16;
  exports.CutOut20 = CutOut20;
  exports.CutOut24 = CutOut24;
  exports.CutOut32 = CutOut32;
  exports.Cyclist16 = Cyclist16;
  exports.Cyclist20 = Cyclist20;
  exports.Cyclist24 = Cyclist24;
  exports.Cyclist32 = Cyclist32;
  exports.Dashboard16 = Dashboard16;
  exports.Dashboard20 = Dashboard20;
  exports.Dashboard24 = Dashboard24;
  exports.Dashboard32 = Dashboard32;
  exports.DashboardReference16 = DashboardReference16;
  exports.DashboardReference20 = DashboardReference20;
  exports.DashboardReference24 = DashboardReference24;
  exports.DashboardReference32 = DashboardReference32;
  exports.DataAccessor16 = DataAccessor16;
  exports.DataAccessor20 = DataAccessor20;
  exports.DataAccessor24 = DataAccessor24;
  exports.DataAccessor32 = DataAccessor32;
  exports.DataBackup16 = DataBackup16;
  exports.DataBackup20 = DataBackup20;
  exports.DataBackup24 = DataBackup24;
  exports.DataBackup32 = DataBackup32;
  exports.DataBase16 = DataBase16;
  exports.DataBase20 = DataBase20;
  exports.DataBase24 = DataBase24;
  exports.DataBase32 = DataBase32;
  exports.DataBaseAlt16 = DataBaseAlt16;
  exports.DataBaseAlt20 = DataBaseAlt20;
  exports.DataBaseAlt24 = DataBaseAlt24;
  exports.DataBaseAlt32 = DataBaseAlt32;
  exports.DataBin16 = DataBin16;
  exports.DataBin20 = DataBin20;
  exports.DataBin24 = DataBin24;
  exports.DataBin32 = DataBin32;
  exports.DataBlob16 = DataBlob16;
  exports.DataBlob20 = DataBlob20;
  exports.DataBlob24 = DataBlob24;
  exports.DataBlob32 = DataBlob32;
  exports.DataCenter16 = DataCenter16;
  exports.DataCenter20 = DataCenter20;
  exports.DataCenter24 = DataCenter24;
  exports.DataCenter32 = DataCenter32;
  exports.DataCheck16 = DataCheck16;
  exports.DataCheck20 = DataCheck20;
  exports.DataCheck24 = DataCheck24;
  exports.DataCheck32 = DataCheck32;
  exports.DataClass16 = DataClass16;
  exports.DataClass20 = DataClass20;
  exports.DataClass24 = DataClass24;
  exports.DataClass32 = DataClass32;
  exports.DataCollection16 = DataCollection16;
  exports.DataCollection20 = DataCollection20;
  exports.DataCollection24 = DataCollection24;
  exports.DataCollection32 = DataCollection32;
  exports.DataConnected16 = DataConnected16;
  exports.DataConnected20 = DataConnected20;
  exports.DataConnected24 = DataConnected24;
  exports.DataConnected32 = DataConnected32;
  exports.DataDefinition16 = DataDefinition16;
  exports.DataDefinition20 = DataDefinition20;
  exports.DataDefinition24 = DataDefinition24;
  exports.DataDefinition32 = DataDefinition32;
  exports.DataDiode16 = DataDiode16;
  exports.DataDiode20 = DataDiode20;
  exports.DataDiode24 = DataDiode24;
  exports.DataDiode32 = DataDiode32;
  exports.DataError16 = DataError16;
  exports.DataError20 = DataError20;
  exports.DataError24 = DataError24;
  exports.DataError32 = DataError32;
  exports.DataFormat16 = DataFormat16;
  exports.DataFormat20 = DataFormat20;
  exports.DataFormat24 = DataFormat24;
  exports.DataFormat32 = DataFormat32;
  exports.DataPlayer16 = DataPlayer16;
  exports.DataPlayer20 = DataPlayer20;
  exports.DataPlayer24 = DataPlayer24;
  exports.DataPlayer32 = DataPlayer32;
  exports.DataReference16 = DataReference16;
  exports.DataReference20 = DataReference20;
  exports.DataReference24 = DataReference24;
  exports.DataReference32 = DataReference32;
  exports.DataRefinery16 = DataRefinery16;
  exports.DataRefinery20 = DataRefinery20;
  exports.DataRefinery24 = DataRefinery24;
  exports.DataRefinery32 = DataRefinery32;
  exports.DataRefineryReference16 = DataRefineryReference16;
  exports.DataRefineryReference20 = DataRefineryReference20;
  exports.DataRefineryReference24 = DataRefineryReference24;
  exports.DataRefineryReference32 = DataRefineryReference32;
  exports.DataSet16 = DataSet16;
  exports.DataSet20 = DataSet20;
  exports.DataSet24 = DataSet24;
  exports.DataSet32 = DataSet32;
  exports.DataShare16 = DataShare16;
  exports.DataShare20 = DataShare20;
  exports.DataShare24 = DataShare24;
  exports.DataShare32 = DataShare32;
  exports.DataStructured16 = DataStructured16;
  exports.DataStructured20 = DataStructured20;
  exports.DataStructured24 = DataStructured24;
  exports.DataStructured32 = DataStructured32;
  exports.DataTable16 = DataTable16;
  exports.DataTable20 = DataTable20;
  exports.DataTable24 = DataTable24;
  exports.DataTable32 = DataTable32;
  exports.DataTableReference16 = DataTableReference16;
  exports.DataTableReference20 = DataTableReference20;
  exports.DataTableReference24 = DataTableReference24;
  exports.DataTableReference32 = DataTableReference32;
  exports.DataUnstructured16 = DataUnstructured16;
  exports.DataUnstructured20 = DataUnstructured20;
  exports.DataUnstructured24 = DataUnstructured24;
  exports.DataUnstructured32 = DataUnstructured32;
  exports.DataView16 = DataView16;
  exports.DataView20 = DataView20;
  exports.DataView24 = DataView24;
  exports.DataView32 = DataView32;
  exports.DataViewAlt16 = DataViewAlt16;
  exports.DataViewAlt20 = DataViewAlt20;
  exports.DataViewAlt24 = DataViewAlt24;
  exports.DataViewAlt32 = DataViewAlt32;
  exports.DataVis_116 = DataVis_116;
  exports.DataVis_120 = DataVis_120;
  exports.DataVis_124 = DataVis_124;
  exports.DataVis_132 = DataVis_132;
  exports.DataVis_216 = DataVis_216;
  exports.DataVis_220 = DataVis_220;
  exports.DataVis_224 = DataVis_224;
  exports.DataVis_232 = DataVis_232;
  exports.DataVis_316 = DataVis_316;
  exports.DataVis_320 = DataVis_320;
  exports.DataVis_324 = DataVis_324;
  exports.DataVis_332 = DataVis_332;
  exports.DataVis_416 = DataVis_416;
  exports.DataVis_420 = DataVis_420;
  exports.DataVis_424 = DataVis_424;
  exports.DataVis_432 = DataVis_432;
  exports.Data_116 = Data_116;
  exports.Data_120 = Data_120;
  exports.Data_124 = Data_124;
  exports.Data_132 = Data_132;
  exports.Data_216 = Data_216;
  exports.Data_220 = Data_220;
  exports.Data_224 = Data_224;
  exports.Data_232 = Data_232;
  exports.DatabaseDatastax16 = DatabaseDatastax16;
  exports.DatabaseDatastax20 = DatabaseDatastax20;
  exports.DatabaseDatastax24 = DatabaseDatastax24;
  exports.DatabaseDatastax32 = DatabaseDatastax32;
  exports.DatabaseElastic16 = DatabaseElastic16;
  exports.DatabaseElastic20 = DatabaseElastic20;
  exports.DatabaseElastic24 = DatabaseElastic24;
  exports.DatabaseElastic32 = DatabaseElastic32;
  exports.DatabaseEnterpriseDb216 = DatabaseEnterpriseDb216;
  exports.DatabaseEnterpriseDb220 = DatabaseEnterpriseDb220;
  exports.DatabaseEnterpriseDb224 = DatabaseEnterpriseDb224;
  exports.DatabaseEnterpriseDb232 = DatabaseEnterpriseDb232;
  exports.DatabaseEtcd16 = DatabaseEtcd16;
  exports.DatabaseEtcd20 = DatabaseEtcd20;
  exports.DatabaseEtcd24 = DatabaseEtcd24;
  exports.DatabaseEtcd32 = DatabaseEtcd32;
  exports.DatabaseMongodb16 = DatabaseMongodb16;
  exports.DatabaseMongodb20 = DatabaseMongodb20;
  exports.DatabaseMongodb24 = DatabaseMongodb24;
  exports.DatabaseMongodb32 = DatabaseMongodb32;
  exports.DatabasePostgreSql16 = DatabasePostgreSql16;
  exports.DatabasePostgreSql20 = DatabasePostgreSql20;
  exports.DatabasePostgreSql24 = DatabasePostgreSql24;
  exports.DatabasePostgreSql32 = DatabasePostgreSql32;
  exports.DatabaseRabbit16 = DatabaseRabbit16;
  exports.DatabaseRabbit20 = DatabaseRabbit20;
  exports.DatabaseRabbit24 = DatabaseRabbit24;
  exports.DatabaseRabbit32 = DatabaseRabbit32;
  exports.DatabaseRedis16 = DatabaseRedis16;
  exports.DatabaseRedis20 = DatabaseRedis20;
  exports.DatabaseRedis24 = DatabaseRedis24;
  exports.DatabaseRedis32 = DatabaseRedis32;
  exports.Datastore16 = Datastore16;
  exports.Datastore20 = Datastore20;
  exports.Datastore24 = Datastore24;
  exports.Datastore32 = Datastore32;
  exports.Debug16 = Debug16;
  exports.Debug20 = Debug20;
  exports.Debug24 = Debug24;
  exports.Debug32 = Debug32;
  exports.DecisionTree16 = DecisionTree16;
  exports.DecisionTree20 = DecisionTree20;
  exports.DecisionTree24 = DecisionTree24;
  exports.DecisionTree32 = DecisionTree32;
  exports.Delete16 = Delete16;
  exports.Delete20 = Delete20;
  exports.Delete24 = Delete24;
  exports.Delete32 = Delete32;
  exports.Delivery16 = Delivery16;
  exports.Delivery20 = Delivery20;
  exports.Delivery24 = Delivery24;
  exports.Delivery32 = Delivery32;
  exports.DeliveryAdd16 = DeliveryAdd16;
  exports.DeliveryAdd20 = DeliveryAdd20;
  exports.DeliveryAdd24 = DeliveryAdd24;
  exports.DeliveryAdd32 = DeliveryAdd32;
  exports.DeliveryParcel16 = DeliveryParcel16;
  exports.DeliveryParcel20 = DeliveryParcel20;
  exports.DeliveryParcel24 = DeliveryParcel24;
  exports.DeliveryParcel32 = DeliveryParcel32;
  exports.DeliveryTruck16 = DeliveryTruck16;
  exports.DeliveryTruck20 = DeliveryTruck20;
  exports.DeliveryTruck24 = DeliveryTruck24;
  exports.DeliveryTruck32 = DeliveryTruck32;
  exports.Departure16 = Departure16;
  exports.Departure20 = Departure20;
  exports.Departure24 = Departure24;
  exports.Departure32 = Departure32;
  exports.Deploy16 = Deploy16;
  exports.Deploy20 = Deploy20;
  exports.Deploy24 = Deploy24;
  exports.Deploy32 = Deploy32;
  exports.DeployRules16 = DeployRules16;
  exports.DeployRules20 = DeployRules20;
  exports.DeployRules24 = DeployRules24;
  exports.DeployRules32 = DeployRules32;
  exports.DeploymentPattern16 = DeploymentPattern16;
  exports.DeploymentPattern20 = DeploymentPattern20;
  exports.DeploymentPattern24 = DeploymentPattern24;
  exports.DeploymentPattern32 = DeploymentPattern32;
  exports.DeploymentPolicy16 = DeploymentPolicy16;
  exports.DeploymentPolicy20 = DeploymentPolicy20;
  exports.DeploymentPolicy24 = DeploymentPolicy24;
  exports.DeploymentPolicy32 = DeploymentPolicy32;
  exports.DeploymentUnitData16 = DeploymentUnitData16;
  exports.DeploymentUnitData20 = DeploymentUnitData20;
  exports.DeploymentUnitData24 = DeploymentUnitData24;
  exports.DeploymentUnitData32 = DeploymentUnitData32;
  exports.DeploymentUnitExecution16 = DeploymentUnitExecution16;
  exports.DeploymentUnitExecution20 = DeploymentUnitExecution20;
  exports.DeploymentUnitExecution24 = DeploymentUnitExecution24;
  exports.DeploymentUnitExecution32 = DeploymentUnitExecution32;
  exports.DeploymentUnitInstallation16 = DeploymentUnitInstallation16;
  exports.DeploymentUnitInstallation20 = DeploymentUnitInstallation20;
  exports.DeploymentUnitInstallation24 = DeploymentUnitInstallation24;
  exports.DeploymentUnitInstallation32 = DeploymentUnitInstallation32;
  exports.DeploymentUnitPresentation16 = DeploymentUnitPresentation16;
  exports.DeploymentUnitPresentation20 = DeploymentUnitPresentation20;
  exports.DeploymentUnitPresentation24 = DeploymentUnitPresentation24;
  exports.DeploymentUnitPresentation32 = DeploymentUnitPresentation32;
  exports.DeploymentUnitTechnicalData16 = DeploymentUnitTechnicalData16;
  exports.DeploymentUnitTechnicalData20 = DeploymentUnitTechnicalData20;
  exports.DeploymentUnitTechnicalData24 = DeploymentUnitTechnicalData24;
  exports.DeploymentUnitTechnicalData32 = DeploymentUnitTechnicalData32;
  exports.DeploymentUnitTechnicalExecution16 = DeploymentUnitTechnicalExecution16;
  exports.DeploymentUnitTechnicalExecution20 = DeploymentUnitTechnicalExecution20;
  exports.DeploymentUnitTechnicalExecution24 = DeploymentUnitTechnicalExecution24;
  exports.DeploymentUnitTechnicalExecution32 = DeploymentUnitTechnicalExecution32;
  exports.DeploymentUnitTechnicalInstallation16 = DeploymentUnitTechnicalInstallation16;
  exports.DeploymentUnitTechnicalInstallation20 = DeploymentUnitTechnicalInstallation20;
  exports.DeploymentUnitTechnicalInstallation24 = DeploymentUnitTechnicalInstallation24;
  exports.DeploymentUnitTechnicalInstallation32 = DeploymentUnitTechnicalInstallation32;
  exports.DeploymentUnitTechnicalPresentation16 = DeploymentUnitTechnicalPresentation16;
  exports.DeploymentUnitTechnicalPresentation20 = DeploymentUnitTechnicalPresentation20;
  exports.DeploymentUnitTechnicalPresentation24 = DeploymentUnitTechnicalPresentation24;
  exports.DeploymentUnitTechnicalPresentation32 = DeploymentUnitTechnicalPresentation32;
  exports.DeskAdjustable16 = DeskAdjustable16;
  exports.DeskAdjustable20 = DeskAdjustable20;
  exports.DeskAdjustable24 = DeskAdjustable24;
  exports.DeskAdjustable32 = DeskAdjustable32;
  exports.Development16 = Development16;
  exports.Development20 = Development20;
  exports.Development24 = Development24;
  exports.Development32 = Development32;
  exports.Devices16 = Devices16;
  exports.Devices20 = Devices20;
  exports.Devices24 = Devices24;
  exports.Devices32 = Devices32;
  exports.DewPoint16 = DewPoint16;
  exports.DewPoint20 = DewPoint20;
  exports.DewPoint24 = DewPoint24;
  exports.DewPoint32 = DewPoint32;
  exports.DewPointFilled16 = DewPointFilled16;
  exports.DewPointFilled20 = DewPointFilled20;
  exports.DewPointFilled24 = DewPointFilled24;
  exports.DewPointFilled32 = DewPointFilled32;
  exports.Diagram16 = Diagram16;
  exports.Diagram20 = Diagram20;
  exports.Diagram24 = Diagram24;
  exports.Diagram32 = Diagram32;
  exports.DiagramReference16 = DiagramReference16;
  exports.DiagramReference20 = DiagramReference20;
  exports.DiagramReference24 = DiagramReference24;
  exports.DiagramReference32 = DiagramReference32;
  exports.DirectLink16 = DirectLink16;
  exports.DirectLink20 = DirectLink20;
  exports.DirectLink24 = DirectLink24;
  exports.DirectLink32 = DirectLink32;
  exports.DirectionBearRight_0116 = DirectionBearRight_0116;
  exports.DirectionBearRight_0120 = DirectionBearRight_0120;
  exports.DirectionBearRight_0124 = DirectionBearRight_0124;
  exports.DirectionBearRight_0132 = DirectionBearRight_0132;
  exports.DirectionBearRight_01Filled16 = DirectionBearRight_01Filled16;
  exports.DirectionBearRight_01Filled20 = DirectionBearRight_01Filled20;
  exports.DirectionBearRight_01Filled24 = DirectionBearRight_01Filled24;
  exports.DirectionBearRight_01Filled32 = DirectionBearRight_01Filled32;
  exports.DirectionBearRight_0216 = DirectionBearRight_0216;
  exports.DirectionBearRight_0220 = DirectionBearRight_0220;
  exports.DirectionBearRight_0224 = DirectionBearRight_0224;
  exports.DirectionBearRight_0232 = DirectionBearRight_0232;
  exports.DirectionBearRight_02Filled16 = DirectionBearRight_02Filled16;
  exports.DirectionBearRight_02Filled20 = DirectionBearRight_02Filled20;
  exports.DirectionBearRight_02Filled24 = DirectionBearRight_02Filled24;
  exports.DirectionBearRight_02Filled32 = DirectionBearRight_02Filled32;
  exports.DirectionCurve16 = DirectionCurve16;
  exports.DirectionCurve20 = DirectionCurve20;
  exports.DirectionCurve24 = DirectionCurve24;
  exports.DirectionCurve32 = DirectionCurve32;
  exports.DirectionCurveFilled16 = DirectionCurveFilled16;
  exports.DirectionCurveFilled20 = DirectionCurveFilled20;
  exports.DirectionCurveFilled24 = DirectionCurveFilled24;
  exports.DirectionCurveFilled32 = DirectionCurveFilled32;
  exports.DirectionFork16 = DirectionFork16;
  exports.DirectionFork20 = DirectionFork20;
  exports.DirectionFork24 = DirectionFork24;
  exports.DirectionFork32 = DirectionFork32;
  exports.DirectionForkFilled16 = DirectionForkFilled16;
  exports.DirectionForkFilled20 = DirectionForkFilled20;
  exports.DirectionForkFilled24 = DirectionForkFilled24;
  exports.DirectionForkFilled32 = DirectionForkFilled32;
  exports.DirectionLoopLeft16 = DirectionLoopLeft16;
  exports.DirectionLoopLeft20 = DirectionLoopLeft20;
  exports.DirectionLoopLeft24 = DirectionLoopLeft24;
  exports.DirectionLoopLeft32 = DirectionLoopLeft32;
  exports.DirectionLoopLeftFilled16 = DirectionLoopLeftFilled16;
  exports.DirectionLoopLeftFilled20 = DirectionLoopLeftFilled20;
  exports.DirectionLoopLeftFilled24 = DirectionLoopLeftFilled24;
  exports.DirectionLoopLeftFilled32 = DirectionLoopLeftFilled32;
  exports.DirectionLoopRight16 = DirectionLoopRight16;
  exports.DirectionLoopRight20 = DirectionLoopRight20;
  exports.DirectionLoopRight24 = DirectionLoopRight24;
  exports.DirectionLoopRight32 = DirectionLoopRight32;
  exports.DirectionLoopRightFilled16 = DirectionLoopRightFilled16;
  exports.DirectionLoopRightFilled20 = DirectionLoopRightFilled20;
  exports.DirectionLoopRightFilled24 = DirectionLoopRightFilled24;
  exports.DirectionLoopRightFilled32 = DirectionLoopRightFilled32;
  exports.DirectionMerge16 = DirectionMerge16;
  exports.DirectionMerge20 = DirectionMerge20;
  exports.DirectionMerge24 = DirectionMerge24;
  exports.DirectionMerge32 = DirectionMerge32;
  exports.DirectionMergeFilled16 = DirectionMergeFilled16;
  exports.DirectionMergeFilled20 = DirectionMergeFilled20;
  exports.DirectionMergeFilled24 = DirectionMergeFilled24;
  exports.DirectionMergeFilled32 = DirectionMergeFilled32;
  exports.DirectionRight_0116 = DirectionRight_0116;
  exports.DirectionRight_0120 = DirectionRight_0120;
  exports.DirectionRight_0124 = DirectionRight_0124;
  exports.DirectionRight_0132 = DirectionRight_0132;
  exports.DirectionRight_01Filled16 = DirectionRight_01Filled16;
  exports.DirectionRight_01Filled20 = DirectionRight_01Filled20;
  exports.DirectionRight_01Filled24 = DirectionRight_01Filled24;
  exports.DirectionRight_01Filled32 = DirectionRight_01Filled32;
  exports.DirectionRight_0216 = DirectionRight_0216;
  exports.DirectionRight_0220 = DirectionRight_0220;
  exports.DirectionRight_0224 = DirectionRight_0224;
  exports.DirectionRight_0232 = DirectionRight_0232;
  exports.DirectionRight_02Filled16 = DirectionRight_02Filled16;
  exports.DirectionRight_02Filled20 = DirectionRight_02Filled20;
  exports.DirectionRight_02Filled24 = DirectionRight_02Filled24;
  exports.DirectionRight_02Filled32 = DirectionRight_02Filled32;
  exports.DirectionRotaryFirstRight16 = DirectionRotaryFirstRight16;
  exports.DirectionRotaryFirstRight20 = DirectionRotaryFirstRight20;
  exports.DirectionRotaryFirstRight24 = DirectionRotaryFirstRight24;
  exports.DirectionRotaryFirstRight32 = DirectionRotaryFirstRight32;
  exports.DirectionRotaryFirstRightFilled16 = DirectionRotaryFirstRightFilled16;
  exports.DirectionRotaryFirstRightFilled20 = DirectionRotaryFirstRightFilled20;
  exports.DirectionRotaryFirstRightFilled24 = DirectionRotaryFirstRightFilled24;
  exports.DirectionRotaryFirstRightFilled32 = DirectionRotaryFirstRightFilled32;
  exports.DirectionRotaryRight16 = DirectionRotaryRight16;
  exports.DirectionRotaryRight20 = DirectionRotaryRight20;
  exports.DirectionRotaryRight24 = DirectionRotaryRight24;
  exports.DirectionRotaryRight32 = DirectionRotaryRight32;
  exports.DirectionRotaryRightFilled16 = DirectionRotaryRightFilled16;
  exports.DirectionRotaryRightFilled20 = DirectionRotaryRightFilled20;
  exports.DirectionRotaryRightFilled24 = DirectionRotaryRightFilled24;
  exports.DirectionRotaryRightFilled32 = DirectionRotaryRightFilled32;
  exports.DirectionRotaryStraight16 = DirectionRotaryStraight16;
  exports.DirectionRotaryStraight20 = DirectionRotaryStraight20;
  exports.DirectionRotaryStraight24 = DirectionRotaryStraight24;
  exports.DirectionRotaryStraight32 = DirectionRotaryStraight32;
  exports.DirectionRotaryStraightFilled16 = DirectionRotaryStraightFilled16;
  exports.DirectionRotaryStraightFilled20 = DirectionRotaryStraightFilled20;
  exports.DirectionRotaryStraightFilled24 = DirectionRotaryStraightFilled24;
  exports.DirectionRotaryStraightFilled32 = DirectionRotaryStraightFilled32;
  exports.DirectionSharpTurn16 = DirectionSharpTurn16;
  exports.DirectionSharpTurn20 = DirectionSharpTurn20;
  exports.DirectionSharpTurn24 = DirectionSharpTurn24;
  exports.DirectionSharpTurn32 = DirectionSharpTurn32;
  exports.DirectionSharpTurnFilled16 = DirectionSharpTurnFilled16;
  exports.DirectionSharpTurnFilled20 = DirectionSharpTurnFilled20;
  exports.DirectionSharpTurnFilled24 = DirectionSharpTurnFilled24;
  exports.DirectionSharpTurnFilled32 = DirectionSharpTurnFilled32;
  exports.DirectionStraight16 = DirectionStraight16;
  exports.DirectionStraight20 = DirectionStraight20;
  exports.DirectionStraight24 = DirectionStraight24;
  exports.DirectionStraight32 = DirectionStraight32;
  exports.DirectionStraightFilled16 = DirectionStraightFilled16;
  exports.DirectionStraightFilled20 = DirectionStraightFilled20;
  exports.DirectionStraightFilled24 = DirectionStraightFilled24;
  exports.DirectionStraightFilled32 = DirectionStraightFilled32;
  exports.DirectionStraightRight16 = DirectionStraightRight16;
  exports.DirectionStraightRight20 = DirectionStraightRight20;
  exports.DirectionStraightRight24 = DirectionStraightRight24;
  exports.DirectionStraightRight32 = DirectionStraightRight32;
  exports.DirectionStraightRightFilled16 = DirectionStraightRightFilled16;
  exports.DirectionStraightRightFilled20 = DirectionStraightRightFilled20;
  exports.DirectionStraightRightFilled24 = DirectionStraightRightFilled24;
  exports.DirectionStraightRightFilled32 = DirectionStraightRightFilled32;
  exports.DirectionUTurn16 = DirectionUTurn16;
  exports.DirectionUTurn20 = DirectionUTurn20;
  exports.DirectionUTurn24 = DirectionUTurn24;
  exports.DirectionUTurn32 = DirectionUTurn32;
  exports.DirectionUTurnFilled16 = DirectionUTurnFilled16;
  exports.DirectionUTurnFilled20 = DirectionUTurnFilled20;
  exports.DirectionUTurnFilled24 = DirectionUTurnFilled24;
  exports.DirectionUTurnFilled32 = DirectionUTurnFilled32;
  exports.DirectoryDomain16 = DirectoryDomain16;
  exports.DirectoryDomain20 = DirectoryDomain20;
  exports.DirectoryDomain24 = DirectoryDomain24;
  exports.DirectoryDomain32 = DirectoryDomain32;
  exports.DistributeHorizontalCenter16 = DistributeHorizontalCenter16;
  exports.DistributeHorizontalCenter20 = DistributeHorizontalCenter20;
  exports.DistributeHorizontalCenter24 = DistributeHorizontalCenter24;
  exports.DistributeHorizontalCenter32 = DistributeHorizontalCenter32;
  exports.DistributeHorizontalLeft16 = DistributeHorizontalLeft16;
  exports.DistributeHorizontalLeft20 = DistributeHorizontalLeft20;
  exports.DistributeHorizontalLeft24 = DistributeHorizontalLeft24;
  exports.DistributeHorizontalLeft32 = DistributeHorizontalLeft32;
  exports.DistributeHorizontalRight16 = DistributeHorizontalRight16;
  exports.DistributeHorizontalRight20 = DistributeHorizontalRight20;
  exports.DistributeHorizontalRight24 = DistributeHorizontalRight24;
  exports.DistributeHorizontalRight32 = DistributeHorizontalRight32;
  exports.DistributeVerticalBottom16 = DistributeVerticalBottom16;
  exports.DistributeVerticalBottom20 = DistributeVerticalBottom20;
  exports.DistributeVerticalBottom24 = DistributeVerticalBottom24;
  exports.DistributeVerticalBottom32 = DistributeVerticalBottom32;
  exports.DistributeVerticalCenter16 = DistributeVerticalCenter16;
  exports.DistributeVerticalCenter20 = DistributeVerticalCenter20;
  exports.DistributeVerticalCenter24 = DistributeVerticalCenter24;
  exports.DistributeVerticalCenter32 = DistributeVerticalCenter32;
  exports.DistributeVerticalTop16 = DistributeVerticalTop16;
  exports.DistributeVerticalTop20 = DistributeVerticalTop20;
  exports.DistributeVerticalTop24 = DistributeVerticalTop24;
  exports.DistributeVerticalTop32 = DistributeVerticalTop32;
  exports.DnsServices16 = DnsServices16;
  exports.DnsServices20 = DnsServices20;
  exports.DnsServices24 = DnsServices24;
  exports.DnsServices32 = DnsServices32;
  exports.Doc16 = Doc16;
  exports.Doc20 = Doc20;
  exports.Doc24 = Doc24;
  exports.Doc32 = Doc32;
  exports.Document16 = Document16;
  exports.Document20 = Document20;
  exports.Document24 = Document24;
  exports.Document32 = Document32;
  exports.DocumentAdd16 = DocumentAdd16;
  exports.DocumentAdd20 = DocumentAdd20;
  exports.DocumentAdd24 = DocumentAdd24;
  exports.DocumentAdd32 = DocumentAdd32;
  exports.DocumentAttachment16 = DocumentAttachment16;
  exports.DocumentAttachment20 = DocumentAttachment20;
  exports.DocumentAttachment24 = DocumentAttachment24;
  exports.DocumentAttachment32 = DocumentAttachment32;
  exports.DocumentAudio16 = DocumentAudio16;
  exports.DocumentAudio20 = DocumentAudio20;
  exports.DocumentAudio24 = DocumentAudio24;
  exports.DocumentAudio32 = DocumentAudio32;
  exports.DocumentBlank16 = DocumentBlank16;
  exports.DocumentBlank20 = DocumentBlank20;
  exports.DocumentBlank24 = DocumentBlank24;
  exports.DocumentBlank32 = DocumentBlank32;
  exports.DocumentDownload16 = DocumentDownload16;
  exports.DocumentDownload20 = DocumentDownload20;
  exports.DocumentDownload24 = DocumentDownload24;
  exports.DocumentDownload32 = DocumentDownload32;
  exports.DocumentEpdf16 = DocumentEpdf16;
  exports.DocumentEpdf20 = DocumentEpdf20;
  exports.DocumentEpdf24 = DocumentEpdf24;
  exports.DocumentEpdf32 = DocumentEpdf32;
  exports.DocumentExport16 = DocumentExport16;
  exports.DocumentExport20 = DocumentExport20;
  exports.DocumentExport24 = DocumentExport24;
  exports.DocumentExport32 = DocumentExport32;
  exports.DocumentHorizontal16 = DocumentHorizontal16;
  exports.DocumentHorizontal20 = DocumentHorizontal20;
  exports.DocumentHorizontal24 = DocumentHorizontal24;
  exports.DocumentHorizontal32 = DocumentHorizontal32;
  exports.DocumentImport16 = DocumentImport16;
  exports.DocumentImport20 = DocumentImport20;
  exports.DocumentImport24 = DocumentImport24;
  exports.DocumentImport32 = DocumentImport32;
  exports.DocumentPdf16 = DocumentPdf16;
  exports.DocumentPdf20 = DocumentPdf20;
  exports.DocumentPdf24 = DocumentPdf24;
  exports.DocumentPdf32 = DocumentPdf32;
  exports.DocumentPreliminary16 = DocumentPreliminary16;
  exports.DocumentPreliminary20 = DocumentPreliminary20;
  exports.DocumentPreliminary24 = DocumentPreliminary24;
  exports.DocumentPreliminary32 = DocumentPreliminary32;
  exports.DocumentProtected16 = DocumentProtected16;
  exports.DocumentProtected20 = DocumentProtected20;
  exports.DocumentProtected24 = DocumentProtected24;
  exports.DocumentProtected32 = DocumentProtected32;
  exports.DocumentSecurity16 = DocumentSecurity16;
  exports.DocumentSecurity20 = DocumentSecurity20;
  exports.DocumentSecurity24 = DocumentSecurity24;
  exports.DocumentSecurity32 = DocumentSecurity32;
  exports.DocumentSentiment16 = DocumentSentiment16;
  exports.DocumentSentiment20 = DocumentSentiment20;
  exports.DocumentSentiment24 = DocumentSentiment24;
  exports.DocumentSentiment32 = DocumentSentiment32;
  exports.DocumentSigned16 = DocumentSigned16;
  exports.DocumentSigned20 = DocumentSigned20;
  exports.DocumentSigned24 = DocumentSigned24;
  exports.DocumentSigned32 = DocumentSigned32;
  exports.DocumentSketch16 = DocumentSketch16;
  exports.DocumentSketch20 = DocumentSketch20;
  exports.DocumentSketch24 = DocumentSketch24;
  exports.DocumentSketch32 = DocumentSketch32;
  exports.DocumentSubtract16 = DocumentSubtract16;
  exports.DocumentSubtract20 = DocumentSubtract20;
  exports.DocumentSubtract24 = DocumentSubtract24;
  exports.DocumentSubtract32 = DocumentSubtract32;
  exports.DocumentTasks16 = DocumentTasks16;
  exports.DocumentTasks20 = DocumentTasks20;
  exports.DocumentTasks24 = DocumentTasks24;
  exports.DocumentTasks32 = DocumentTasks32;
  exports.DocumentUnknown16 = DocumentUnknown16;
  exports.DocumentUnknown20 = DocumentUnknown20;
  exports.DocumentUnknown24 = DocumentUnknown24;
  exports.DocumentUnknown32 = DocumentUnknown32;
  exports.DocumentUnprotected16 = DocumentUnprotected16;
  exports.DocumentUnprotected20 = DocumentUnprotected20;
  exports.DocumentUnprotected24 = DocumentUnprotected24;
  exports.DocumentUnprotected32 = DocumentUnprotected32;
  exports.DocumentVertical16 = DocumentVertical16;
  exports.DocumentVertical20 = DocumentVertical20;
  exports.DocumentVertical24 = DocumentVertical24;
  exports.DocumentVertical32 = DocumentVertical32;
  exports.DocumentVideo16 = DocumentVideo16;
  exports.DocumentVideo20 = DocumentVideo20;
  exports.DocumentVideo24 = DocumentVideo24;
  exports.DocumentVideo32 = DocumentVideo32;
  exports.DocumentView16 = DocumentView16;
  exports.DocumentView20 = DocumentView20;
  exports.DocumentView24 = DocumentView24;
  exports.DocumentView32 = DocumentView32;
  exports.DocumentWordProcessor16 = DocumentWordProcessor16;
  exports.DocumentWordProcessor20 = DocumentWordProcessor20;
  exports.DocumentWordProcessor24 = DocumentWordProcessor24;
  exports.DocumentWordProcessor32 = DocumentWordProcessor32;
  exports.DocumentWordProcessorReference16 = DocumentWordProcessorReference16;
  exports.DocumentWordProcessorReference20 = DocumentWordProcessorReference20;
  exports.DocumentWordProcessorReference24 = DocumentWordProcessorReference24;
  exports.DocumentWordProcessorReference32 = DocumentWordProcessorReference32;
  exports.DogWalker16 = DogWalker16;
  exports.DogWalker20 = DogWalker20;
  exports.DogWalker24 = DogWalker24;
  exports.DogWalker32 = DogWalker32;
  exports.DotMark16 = DotMark16;
  exports.DotMark20 = DotMark20;
  exports.DotMark24 = DotMark24;
  exports.DotMark32 = DotMark32;
  exports.DoubleInteger16 = DoubleInteger16;
  exports.DoubleInteger20 = DoubleInteger20;
  exports.DoubleInteger24 = DoubleInteger24;
  exports.DoubleInteger32 = DoubleInteger32;
  exports.DownToBottom16 = DownToBottom16;
  exports.DownToBottom20 = DownToBottom20;
  exports.DownToBottom24 = DownToBottom24;
  exports.DownToBottom32 = DownToBottom32;
  exports.Download16 = Download16;
  exports.Download20 = Download20;
  exports.Download24 = Download24;
  exports.Download32 = Download32;
  exports.DragHorizontal16 = DragHorizontal16;
  exports.DragHorizontal20 = DragHorizontal20;
  exports.DragHorizontal24 = DragHorizontal24;
  exports.DragHorizontal32 = DragHorizontal32;
  exports.DragVertical16 = DragVertical16;
  exports.DragVertical20 = DragVertical20;
  exports.DragVertical24 = DragVertical24;
  exports.DragVertical32 = DragVertical32;
  exports.Draggable16 = Draggable16;
  exports.Draggable20 = Draggable20;
  exports.Draggable24 = Draggable24;
  exports.Draggable32 = Draggable32;
  exports.Draw16 = Draw16;
  exports.Draw20 = Draw20;
  exports.Draw24 = Draw24;
  exports.Draw32 = Draw32;
  exports.DrillBack16 = DrillBack16;
  exports.DrillBack20 = DrillBack20;
  exports.DrillBack24 = DrillBack24;
  exports.DrillBack32 = DrillBack32;
  exports.DrillDown16 = DrillDown16;
  exports.DrillDown20 = DrillDown20;
  exports.DrillDown24 = DrillDown24;
  exports.DrillDown32 = DrillDown32;
  exports.DrillThrough16 = DrillThrough16;
  exports.DrillThrough20 = DrillThrough20;
  exports.DrillThrough24 = DrillThrough24;
  exports.DrillThrough32 = DrillThrough32;
  exports.DriverAnalysis16 = DriverAnalysis16;
  exports.DriverAnalysis20 = DriverAnalysis20;
  exports.DriverAnalysis24 = DriverAnalysis24;
  exports.DriverAnalysis32 = DriverAnalysis32;
  exports.Drone16 = Drone16;
  exports.Drone20 = Drone20;
  exports.Drone24 = Drone24;
  exports.Drone32 = Drone32;
  exports.DroneDelivery16 = DroneDelivery16;
  exports.DroneDelivery20 = DroneDelivery20;
  exports.DroneDelivery24 = DroneDelivery24;
  exports.DroneDelivery32 = DroneDelivery32;
  exports.DroneFront16 = DroneFront16;
  exports.DroneFront20 = DroneFront20;
  exports.DroneFront24 = DroneFront24;
  exports.DroneFront32 = DroneFront32;
  exports.DroneVideo16 = DroneVideo16;
  exports.DroneVideo20 = DroneVideo20;
  exports.DroneVideo24 = DroneVideo24;
  exports.DroneVideo32 = DroneVideo32;
  exports.DropPhoto16 = DropPhoto16;
  exports.DropPhoto20 = DropPhoto20;
  exports.DropPhoto24 = DropPhoto24;
  exports.DropPhoto32 = DropPhoto32;
  exports.DropPhotoFilled16 = DropPhotoFilled16;
  exports.DropPhotoFilled20 = DropPhotoFilled20;
  exports.DropPhotoFilled24 = DropPhotoFilled24;
  exports.DropPhotoFilled32 = DropPhotoFilled32;
  exports.Drought16 = Drought16;
  exports.Drought20 = Drought20;
  exports.Drought24 = Drought24;
  exports.Drought32 = Drought32;
  exports.Dvr16 = Dvr16;
  exports.Dvr20 = Dvr20;
  exports.Dvr24 = Dvr24;
  exports.Dvr32 = Dvr32;
  exports.Earth16 = Earth16;
  exports.Earth20 = Earth20;
  exports.Earth24 = Earth24;
  exports.Earth32 = Earth32;
  exports.EarthAmericas16 = EarthAmericas16;
  exports.EarthAmericas20 = EarthAmericas20;
  exports.EarthAmericas24 = EarthAmericas24;
  exports.EarthAmericas32 = EarthAmericas32;
  exports.EarthAmericasFilled16 = EarthAmericasFilled16;
  exports.EarthAmericasFilled20 = EarthAmericasFilled20;
  exports.EarthAmericasFilled24 = EarthAmericasFilled24;
  exports.EarthAmericasFilled32 = EarthAmericasFilled32;
  exports.EarthEuropeAfrica16 = EarthEuropeAfrica16;
  exports.EarthEuropeAfrica20 = EarthEuropeAfrica20;
  exports.EarthEuropeAfrica24 = EarthEuropeAfrica24;
  exports.EarthEuropeAfrica32 = EarthEuropeAfrica32;
  exports.EarthEuropeAfricaFilled16 = EarthEuropeAfricaFilled16;
  exports.EarthEuropeAfricaFilled20 = EarthEuropeAfricaFilled20;
  exports.EarthEuropeAfricaFilled24 = EarthEuropeAfricaFilled24;
  exports.EarthEuropeAfricaFilled32 = EarthEuropeAfricaFilled32;
  exports.EarthFilled16 = EarthFilled16;
  exports.EarthFilled20 = EarthFilled20;
  exports.EarthFilled24 = EarthFilled24;
  exports.EarthFilled32 = EarthFilled32;
  exports.EarthSoutheastAsia16 = EarthSoutheastAsia16;
  exports.EarthSoutheastAsia20 = EarthSoutheastAsia20;
  exports.EarthSoutheastAsia24 = EarthSoutheastAsia24;
  exports.EarthSoutheastAsia32 = EarthSoutheastAsia32;
  exports.EarthSoutheastAsiaFilled16 = EarthSoutheastAsiaFilled16;
  exports.EarthSoutheastAsiaFilled20 = EarthSoutheastAsiaFilled20;
  exports.EarthSoutheastAsiaFilled24 = EarthSoutheastAsiaFilled24;
  exports.EarthSoutheastAsiaFilled32 = EarthSoutheastAsiaFilled32;
  exports.Earthquake16 = Earthquake16;
  exports.Earthquake20 = Earthquake20;
  exports.Earthquake24 = Earthquake24;
  exports.Earthquake32 = Earthquake32;
  exports.EdgeCluster16 = EdgeCluster16;
  exports.EdgeCluster20 = EdgeCluster20;
  exports.EdgeCluster24 = EdgeCluster24;
  exports.EdgeCluster32 = EdgeCluster32;
  exports.EdgeDevice16 = EdgeDevice16;
  exports.EdgeDevice20 = EdgeDevice20;
  exports.EdgeDevice24 = EdgeDevice24;
  exports.EdgeDevice32 = EdgeDevice32;
  exports.EdgeNode16 = EdgeNode16;
  exports.EdgeNode20 = EdgeNode20;
  exports.EdgeNode24 = EdgeNode24;
  exports.EdgeNode32 = EdgeNode32;
  exports.EdgeNodeAlt16 = EdgeNodeAlt16;
  exports.EdgeNodeAlt20 = EdgeNodeAlt20;
  exports.EdgeNodeAlt24 = EdgeNodeAlt24;
  exports.EdgeNodeAlt32 = EdgeNodeAlt32;
  exports.EdgeService16 = EdgeService16;
  exports.EdgeService20 = EdgeService20;
  exports.EdgeService24 = EdgeService24;
  exports.EdgeService32 = EdgeService32;
  exports.Edit16 = Edit16;
  exports.Edit20 = Edit20;
  exports.Edit24 = Edit24;
  exports.Edit32 = Edit32;
  exports.EditOff16 = EditOff16;
  exports.EditOff20 = EditOff20;
  exports.EditOff24 = EditOff24;
  exports.EditOff32 = EditOff32;
  exports.EdtLoop16 = EdtLoop16;
  exports.EdtLoop20 = EdtLoop20;
  exports.EdtLoop24 = EdtLoop24;
  exports.EdtLoop32 = EdtLoop32;
  exports.Education16 = Education16;
  exports.Education20 = Education20;
  exports.Education24 = Education24;
  exports.Education32 = Education32;
  exports.Email16 = Email16;
  exports.Email20 = Email20;
  exports.Email24 = Email24;
  exports.Email32 = Email32;
  exports.EmailNew16 = EmailNew16;
  exports.EmailNew20 = EmailNew20;
  exports.EmailNew24 = EmailNew24;
  exports.EmailNew32 = EmailNew32;
  exports.Encryption16 = Encryption16;
  exports.Encryption20 = Encryption20;
  exports.Encryption24 = Encryption24;
  exports.Encryption32 = Encryption32;
  exports.EnergyRenewable16 = EnergyRenewable16;
  exports.EnergyRenewable20 = EnergyRenewable20;
  exports.EnergyRenewable24 = EnergyRenewable24;
  exports.EnergyRenewable32 = EnergyRenewable32;
  exports.Enterprise16 = Enterprise16;
  exports.Enterprise20 = Enterprise20;
  exports.Enterprise24 = Enterprise24;
  exports.Enterprise32 = Enterprise32;
  exports.Equalizer16 = Equalizer16;
  exports.Equalizer20 = Equalizer20;
  exports.Equalizer24 = Equalizer24;
  exports.Equalizer32 = Equalizer32;
  exports.Erase16 = Erase16;
  exports.Erase20 = Erase20;
  exports.Erase24 = Erase24;
  exports.Erase32 = Erase32;
  exports.Error16 = Error16;
  exports.Error20 = Error20;
  exports.Error24 = Error24;
  exports.Error32 = Error32;
  exports.ErrorFilled16 = ErrorFilled16;
  exports.ErrorFilled20 = ErrorFilled20;
  exports.ErrorFilled24 = ErrorFilled24;
  exports.ErrorFilled32 = ErrorFilled32;
  exports.ErrorOutline16 = ErrorOutline16;
  exports.ErrorOutline20 = ErrorOutline20;
  exports.ErrorOutline24 = ErrorOutline24;
  exports.ErrorOutline32 = ErrorOutline32;
  exports.Event16 = Event16;
  exports.Event20 = Event20;
  exports.Event24 = Event24;
  exports.Event32 = Event32;
  exports.EventSchedule16 = EventSchedule16;
  exports.EventSchedule20 = EventSchedule20;
  exports.EventSchedule24 = EventSchedule24;
  exports.EventSchedule32 = EventSchedule32;
  exports.Events16 = Events16;
  exports.Events20 = Events20;
  exports.Events24 = Events24;
  exports.Events32 = Events32;
  exports.EventsAlt16 = EventsAlt16;
  exports.EventsAlt20 = EventsAlt20;
  exports.EventsAlt24 = EventsAlt24;
  exports.EventsAlt32 = EventsAlt32;
  exports.ExamMode16 = ExamMode16;
  exports.ExamMode20 = ExamMode20;
  exports.ExamMode24 = ExamMode24;
  exports.ExamMode32 = ExamMode32;
  exports.Exit16 = Exit16;
  exports.Exit20 = Exit20;
  exports.Exit24 = Exit24;
  exports.Exit32 = Exit32;
  exports.ExpandAll16 = ExpandAll16;
  exports.ExpandAll20 = ExpandAll20;
  exports.ExpandAll24 = ExpandAll24;
  exports.ExpandAll32 = ExpandAll32;
  exports.ExpandCategories16 = ExpandCategories16;
  exports.ExpandCategories20 = ExpandCategories20;
  exports.ExpandCategories24 = ExpandCategories24;
  exports.ExpandCategories32 = ExpandCategories32;
  exports.Explore16 = Explore16;
  exports.Explore20 = Explore20;
  exports.Explore24 = Explore24;
  exports.Explore32 = Explore32;
  exports.Export16 = Export16;
  exports.Export20 = Export20;
  exports.Export24 = Export24;
  exports.Export32 = Export32;
  exports.Eyedropper16 = Eyedropper16;
  exports.Eyedropper20 = Eyedropper20;
  exports.Eyedropper24 = Eyedropper24;
  exports.Eyedropper32 = Eyedropper32;
  exports.FaceActivated16 = FaceActivated16;
  exports.FaceActivated20 = FaceActivated20;
  exports.FaceActivated24 = FaceActivated24;
  exports.FaceActivated32 = FaceActivated32;
  exports.FaceActivatedAdd16 = FaceActivatedAdd16;
  exports.FaceActivatedAdd20 = FaceActivatedAdd20;
  exports.FaceActivatedAdd24 = FaceActivatedAdd24;
  exports.FaceActivatedAdd32 = FaceActivatedAdd32;
  exports.FaceActivatedFilled16 = FaceActivatedFilled16;
  exports.FaceActivatedFilled20 = FaceActivatedFilled20;
  exports.FaceActivatedFilled24 = FaceActivatedFilled24;
  exports.FaceActivatedFilled32 = FaceActivatedFilled32;
  exports.FaceAdd16 = FaceAdd16;
  exports.FaceAdd20 = FaceAdd20;
  exports.FaceAdd24 = FaceAdd24;
  exports.FaceAdd32 = FaceAdd32;
  exports.FaceCool16 = FaceCool16;
  exports.FaceCool20 = FaceCool20;
  exports.FaceCool24 = FaceCool24;
  exports.FaceCool32 = FaceCool32;
  exports.FaceDissatisfied16 = FaceDissatisfied16;
  exports.FaceDissatisfied20 = FaceDissatisfied20;
  exports.FaceDissatisfied24 = FaceDissatisfied24;
  exports.FaceDissatisfied32 = FaceDissatisfied32;
  exports.FaceDissatisfiedFilled16 = FaceDissatisfiedFilled16;
  exports.FaceDissatisfiedFilled20 = FaceDissatisfiedFilled20;
  exports.FaceDissatisfiedFilled24 = FaceDissatisfiedFilled24;
  exports.FaceDissatisfiedFilled32 = FaceDissatisfiedFilled32;
  exports.FaceDizzy16 = FaceDizzy16;
  exports.FaceDizzy20 = FaceDizzy20;
  exports.FaceDizzy24 = FaceDizzy24;
  exports.FaceDizzy32 = FaceDizzy32;
  exports.FaceDizzyFilled16 = FaceDizzyFilled16;
  exports.FaceDizzyFilled20 = FaceDizzyFilled20;
  exports.FaceDizzyFilled24 = FaceDizzyFilled24;
  exports.FaceDizzyFilled32 = FaceDizzyFilled32;
  exports.FaceMask16 = FaceMask16;
  exports.FaceMask20 = FaceMask20;
  exports.FaceMask24 = FaceMask24;
  exports.FaceMask32 = FaceMask32;
  exports.FaceNeutral16 = FaceNeutral16;
  exports.FaceNeutral20 = FaceNeutral20;
  exports.FaceNeutral24 = FaceNeutral24;
  exports.FaceNeutral32 = FaceNeutral32;
  exports.FaceNeutralFilled16 = FaceNeutralFilled16;
  exports.FaceNeutralFilled20 = FaceNeutralFilled20;
  exports.FaceNeutralFilled24 = FaceNeutralFilled24;
  exports.FaceNeutralFilled32 = FaceNeutralFilled32;
  exports.FacePending16 = FacePending16;
  exports.FacePending20 = FacePending20;
  exports.FacePending24 = FacePending24;
  exports.FacePending32 = FacePending32;
  exports.FacePendingFilled16 = FacePendingFilled16;
  exports.FacePendingFilled20 = FacePendingFilled20;
  exports.FacePendingFilled24 = FacePendingFilled24;
  exports.FacePendingFilled32 = FacePendingFilled32;
  exports.FaceSatisfied16 = FaceSatisfied16;
  exports.FaceSatisfied20 = FaceSatisfied20;
  exports.FaceSatisfied24 = FaceSatisfied24;
  exports.FaceSatisfied32 = FaceSatisfied32;
  exports.FaceSatisfiedFilled16 = FaceSatisfiedFilled16;
  exports.FaceSatisfiedFilled20 = FaceSatisfiedFilled20;
  exports.FaceSatisfiedFilled24 = FaceSatisfiedFilled24;
  exports.FaceSatisfiedFilled32 = FaceSatisfiedFilled32;
  exports.FaceWink16 = FaceWink16;
  exports.FaceWink20 = FaceWink20;
  exports.FaceWink24 = FaceWink24;
  exports.FaceWink32 = FaceWink32;
  exports.FaceWinkFilled16 = FaceWinkFilled16;
  exports.FaceWinkFilled20 = FaceWinkFilled20;
  exports.FaceWinkFilled24 = FaceWinkFilled24;
  exports.FaceWinkFilled32 = FaceWinkFilled32;
  exports.Factor16 = Factor16;
  exports.Factor20 = Factor20;
  exports.Factor24 = Factor24;
  exports.Factor32 = Factor32;
  exports.Fade16 = Fade16;
  exports.Fade20 = Fade20;
  exports.Fade24 = Fade24;
  exports.Fade32 = Fade32;
  exports.Favorite16 = Favorite16;
  exports.Favorite20 = Favorite20;
  exports.Favorite24 = Favorite24;
  exports.Favorite32 = Favorite32;
  exports.FavoriteFilled16 = FavoriteFilled16;
  exports.FavoriteFilled20 = FavoriteFilled20;
  exports.FavoriteFilled24 = FavoriteFilled24;
  exports.FavoriteFilled32 = FavoriteFilled32;
  exports.FavoriteHalf16 = FavoriteHalf16;
  exports.FavoriteHalf20 = FavoriteHalf20;
  exports.FavoriteHalf24 = FavoriteHalf24;
  exports.FavoriteHalf32 = FavoriteHalf32;
  exports.FetchUpload16 = FetchUpload16;
  exports.FetchUpload20 = FetchUpload20;
  exports.FetchUpload24 = FetchUpload24;
  exports.FetchUpload32 = FetchUpload32;
  exports.FetchUploadCloud16 = FetchUploadCloud16;
  exports.FetchUploadCloud20 = FetchUploadCloud20;
  exports.FetchUploadCloud24 = FetchUploadCloud24;
  exports.FetchUploadCloud32 = FetchUploadCloud32;
  exports.FileStorage16 = FileStorage16;
  exports.FileStorage20 = FileStorage20;
  exports.FileStorage24 = FileStorage24;
  exports.FileStorage32 = FileStorage32;
  exports.Filter16 = Filter16;
  exports.Filter20 = Filter20;
  exports.Filter24 = Filter24;
  exports.Filter32 = Filter32;
  exports.FilterEdit16 = FilterEdit16;
  exports.FilterEdit20 = FilterEdit20;
  exports.FilterEdit24 = FilterEdit24;
  exports.FilterEdit32 = FilterEdit32;
  exports.FilterRemove16 = FilterRemove16;
  exports.FilterRemove20 = FilterRemove20;
  exports.FilterRemove24 = FilterRemove24;
  exports.FilterRemove32 = FilterRemove32;
  exports.FilterReset16 = FilterReset16;
  exports.FilterReset20 = FilterReset20;
  exports.FilterReset24 = FilterReset24;
  exports.FilterReset32 = FilterReset32;
  exports.Finance16 = Finance16;
  exports.Finance20 = Finance20;
  exports.Finance24 = Finance24;
  exports.Finance32 = Finance32;
  exports.FingerprintRecognition16 = FingerprintRecognition16;
  exports.FingerprintRecognition20 = FingerprintRecognition20;
  exports.FingerprintRecognition24 = FingerprintRecognition24;
  exports.FingerprintRecognition32 = FingerprintRecognition32;
  exports.Fire16 = Fire16;
  exports.Fire20 = Fire20;
  exports.Fire24 = Fire24;
  exports.Fire32 = Fire32;
  exports.Firewall16 = Firewall16;
  exports.Firewall20 = Firewall20;
  exports.Firewall24 = Firewall24;
  exports.Firewall32 = Firewall32;
  exports.FirewallClassic16 = FirewallClassic16;
  exports.FirewallClassic20 = FirewallClassic20;
  exports.FirewallClassic24 = FirewallClassic24;
  exports.FirewallClassic32 = FirewallClassic32;
  exports.Fish16 = Fish16;
  exports.Fish20 = Fish20;
  exports.Fish24 = Fish24;
  exports.Fish32 = Fish32;
  exports.FishMultiple16 = FishMultiple16;
  exports.FishMultiple20 = FishMultiple20;
  exports.FishMultiple24 = FishMultiple24;
  exports.FishMultiple32 = FishMultiple32;
  exports.FitToHeight16 = FitToHeight16;
  exports.FitToHeight20 = FitToHeight20;
  exports.FitToHeight24 = FitToHeight24;
  exports.FitToHeight32 = FitToHeight32;
  exports.FitToScreen16 = FitToScreen16;
  exports.FitToScreen20 = FitToScreen20;
  exports.FitToScreen24 = FitToScreen24;
  exports.FitToScreen32 = FitToScreen32;
  exports.FitToWidth16 = FitToWidth16;
  exports.FitToWidth20 = FitToWidth20;
  exports.FitToWidth24 = FitToWidth24;
  exports.FitToWidth32 = FitToWidth32;
  exports.Flag16 = Flag16;
  exports.Flag20 = Flag20;
  exports.Flag24 = Flag24;
  exports.Flag32 = Flag32;
  exports.FlagFilled16 = FlagFilled16;
  exports.FlagFilled20 = FlagFilled20;
  exports.FlagFilled24 = FlagFilled24;
  exports.FlagFilled32 = FlagFilled32;
  exports.FlaggingTaxi16 = FlaggingTaxi16;
  exports.FlaggingTaxi20 = FlaggingTaxi20;
  exports.FlaggingTaxi24 = FlaggingTaxi24;
  exports.FlaggingTaxi32 = FlaggingTaxi32;
  exports.Flash16 = Flash16;
  exports.Flash20 = Flash20;
  exports.Flash24 = Flash24;
  exports.Flash32 = Flash32;
  exports.FlashFilled16 = FlashFilled16;
  exports.FlashFilled20 = FlashFilled20;
  exports.FlashFilled24 = FlashFilled24;
  exports.FlashFilled32 = FlashFilled32;
  exports.FlashOff16 = FlashOff16;
  exports.FlashOff20 = FlashOff20;
  exports.FlashOff24 = FlashOff24;
  exports.FlashOff32 = FlashOff32;
  exports.FlashOffFilled16 = FlashOffFilled16;
  exports.FlashOffFilled20 = FlashOffFilled20;
  exports.FlashOffFilled24 = FlashOffFilled24;
  exports.FlashOffFilled32 = FlashOffFilled32;
  exports.FlightInternational16 = FlightInternational16;
  exports.FlightInternational20 = FlightInternational20;
  exports.FlightInternational24 = FlightInternational24;
  exports.FlightInternational32 = FlightInternational32;
  exports.FlightRoster16 = FlightRoster16;
  exports.FlightRoster20 = FlightRoster20;
  exports.FlightRoster24 = FlightRoster24;
  exports.FlightRoster32 = FlightRoster32;
  exports.FlightSchedule16 = FlightSchedule16;
  exports.FlightSchedule20 = FlightSchedule20;
  exports.FlightSchedule24 = FlightSchedule24;
  exports.FlightSchedule32 = FlightSchedule32;
  exports.FloatingIp16 = FloatingIp16;
  exports.FloatingIp20 = FloatingIp20;
  exports.FloatingIp24 = FloatingIp24;
  exports.FloatingIp32 = FloatingIp32;
  exports.Flood16 = Flood16;
  exports.Flood20 = Flood20;
  exports.Flood24 = Flood24;
  exports.Flood32 = Flood32;
  exports.FloodWarning16 = FloodWarning16;
  exports.FloodWarning20 = FloodWarning20;
  exports.FloodWarning24 = FloodWarning24;
  exports.FloodWarning32 = FloodWarning32;
  exports.Flow16 = Flow16;
  exports.Flow20 = Flow20;
  exports.Flow24 = Flow24;
  exports.Flow32 = Flow32;
  exports.FlowConnection16 = FlowConnection16;
  exports.FlowConnection20 = FlowConnection20;
  exports.FlowConnection24 = FlowConnection24;
  exports.FlowConnection32 = FlowConnection32;
  exports.FlowData16 = FlowData16;
  exports.FlowData20 = FlowData20;
  exports.FlowData24 = FlowData24;
  exports.FlowData32 = FlowData32;
  exports.FlowLogsVpc16 = FlowLogsVpc16;
  exports.FlowLogsVpc20 = FlowLogsVpc20;
  exports.FlowLogsVpc24 = FlowLogsVpc24;
  exports.FlowLogsVpc32 = FlowLogsVpc32;
  exports.FlowModeler16 = FlowModeler16;
  exports.FlowModeler20 = FlowModeler20;
  exports.FlowModeler24 = FlowModeler24;
  exports.FlowModeler32 = FlowModeler32;
  exports.FlowModelerReference16 = FlowModelerReference16;
  exports.FlowModelerReference20 = FlowModelerReference20;
  exports.FlowModelerReference24 = FlowModelerReference24;
  exports.FlowModelerReference32 = FlowModelerReference32;
  exports.FlowStream16 = FlowStream16;
  exports.FlowStream20 = FlowStream20;
  exports.FlowStream24 = FlowStream24;
  exports.FlowStream32 = FlowStream32;
  exports.FlowStreamReference16 = FlowStreamReference16;
  exports.FlowStreamReference20 = FlowStreamReference20;
  exports.FlowStreamReference24 = FlowStreamReference24;
  exports.FlowStreamReference32 = FlowStreamReference32;
  exports.Fog16 = Fog16;
  exports.Fog20 = Fog20;
  exports.Fog24 = Fog24;
  exports.Fog32 = Fog32;
  exports.Folder16 = Folder16;
  exports.Folder20 = Folder20;
  exports.Folder24 = Folder24;
  exports.Folder32 = Folder32;
  exports.FolderAdd16 = FolderAdd16;
  exports.FolderAdd20 = FolderAdd20;
  exports.FolderAdd24 = FolderAdd24;
  exports.FolderAdd32 = FolderAdd32;
  exports.FolderDetails16 = FolderDetails16;
  exports.FolderDetails20 = FolderDetails20;
  exports.FolderDetails24 = FolderDetails24;
  exports.FolderDetails32 = FolderDetails32;
  exports.FolderDetailsReference16 = FolderDetailsReference16;
  exports.FolderDetailsReference20 = FolderDetailsReference20;
  exports.FolderDetailsReference24 = FolderDetailsReference24;
  exports.FolderDetailsReference32 = FolderDetailsReference32;
  exports.FolderMoveTo16 = FolderMoveTo16;
  exports.FolderMoveTo20 = FolderMoveTo20;
  exports.FolderMoveTo24 = FolderMoveTo24;
  exports.FolderMoveTo32 = FolderMoveTo32;
  exports.FolderOff16 = FolderOff16;
  exports.FolderOff20 = FolderOff20;
  exports.FolderOff24 = FolderOff24;
  exports.FolderOff32 = FolderOff32;
  exports.FolderOpen16 = FolderOpen16;
  exports.FolderOpen20 = FolderOpen20;
  exports.FolderOpen24 = FolderOpen24;
  exports.FolderOpen32 = FolderOpen32;
  exports.FolderParent16 = FolderParent16;
  exports.FolderParent20 = FolderParent20;
  exports.FolderParent24 = FolderParent24;
  exports.FolderParent32 = FolderParent32;
  exports.FolderShared16 = FolderShared16;
  exports.FolderShared20 = FolderShared20;
  exports.FolderShared24 = FolderShared24;
  exports.FolderShared32 = FolderShared32;
  exports.Folders16 = Folders16;
  exports.Folders20 = Folders20;
  exports.Folders24 = Folders24;
  exports.Folders32 = Folders32;
  exports.ForecastHail16 = ForecastHail16;
  exports.ForecastHail20 = ForecastHail20;
  exports.ForecastHail24 = ForecastHail24;
  exports.ForecastHail32 = ForecastHail32;
  exports.ForecastHail_3016 = ForecastHail_3016;
  exports.ForecastHail_3020 = ForecastHail_3020;
  exports.ForecastHail_3024 = ForecastHail_3024;
  exports.ForecastHail_3032 = ForecastHail_3032;
  exports.ForecastLightning16 = ForecastLightning16;
  exports.ForecastLightning20 = ForecastLightning20;
  exports.ForecastLightning24 = ForecastLightning24;
  exports.ForecastLightning32 = ForecastLightning32;
  exports.ForecastLightning_3016 = ForecastLightning_3016;
  exports.ForecastLightning_3020 = ForecastLightning_3020;
  exports.ForecastLightning_3024 = ForecastLightning_3024;
  exports.ForecastLightning_3032 = ForecastLightning_3032;
  exports.Fork16 = Fork16;
  exports.Fork20 = Fork20;
  exports.Fork24 = Fork24;
  exports.Fork32 = Fork32;
  exports.Forum16 = Forum16;
  exports.Forum20 = Forum20;
  exports.Forum24 = Forum24;
  exports.Forum32 = Forum32;
  exports.Forward_1016 = Forward_1016;
  exports.Forward_1020 = Forward_1020;
  exports.Forward_1024 = Forward_1024;
  exports.Forward_1032 = Forward_1032;
  exports.Forward_3016 = Forward_3016;
  exports.Forward_3020 = Forward_3020;
  exports.Forward_3024 = Forward_3024;
  exports.Forward_3032 = Forward_3032;
  exports.Forward_516 = Forward_516;
  exports.Forward_520 = Forward_520;
  exports.Forward_524 = Forward_524;
  exports.Forward_532 = Forward_532;
  exports.Fragile16 = Fragile16;
  exports.Fragile20 = Fragile20;
  exports.Fragile24 = Fragile24;
  exports.Fragile32 = Fragile32;
  exports.Friendship16 = Friendship16;
  exports.Friendship20 = Friendship20;
  exports.Friendship24 = Friendship24;
  exports.Friendship32 = Friendship32;
  exports.FruitBowl16 = FruitBowl16;
  exports.FruitBowl20 = FruitBowl20;
  exports.FruitBowl24 = FruitBowl24;
  exports.FruitBowl32 = FruitBowl32;
  exports.Function16 = Function16;
  exports.Function20 = Function20;
  exports.Function24 = Function24;
  exports.Function32 = Function32;
  exports.FunctionMath16 = FunctionMath16;
  exports.FunctionMath20 = FunctionMath20;
  exports.FunctionMath24 = FunctionMath24;
  exports.FunctionMath32 = FunctionMath32;
  exports.GameConsole16 = GameConsole16;
  exports.GameConsole20 = GameConsole20;
  exports.GameConsole24 = GameConsole24;
  exports.GameConsole32 = GameConsole32;
  exports.GameWireless16 = GameWireless16;
  exports.GameWireless20 = GameWireless20;
  exports.GameWireless24 = GameWireless24;
  exports.GameWireless32 = GameWireless32;
  exports.Gamification16 = Gamification16;
  exports.Gamification20 = Gamification20;
  exports.Gamification24 = Gamification24;
  exports.Gamification32 = Gamification32;
  exports.GasStation16 = GasStation16;
  exports.GasStation20 = GasStation20;
  exports.GasStation24 = GasStation24;
  exports.GasStation32 = GasStation32;
  exports.GasStationFilled16 = GasStationFilled16;
  exports.GasStationFilled20 = GasStationFilled20;
  exports.GasStationFilled24 = GasStationFilled24;
  exports.GasStationFilled32 = GasStationFilled32;
  exports.Gateway16 = Gateway16;
  exports.Gateway20 = Gateway20;
  exports.Gateway24 = Gateway24;
  exports.Gateway32 = Gateway32;
  exports.GatewayApi16 = GatewayApi16;
  exports.GatewayApi20 = GatewayApi20;
  exports.GatewayApi24 = GatewayApi24;
  exports.GatewayApi32 = GatewayApi32;
  exports.GatewayMail16 = GatewayMail16;
  exports.GatewayMail20 = GatewayMail20;
  exports.GatewayMail24 = GatewayMail24;
  exports.GatewayMail32 = GatewayMail32;
  exports.GatewayPublic16 = GatewayPublic16;
  exports.GatewayPublic20 = GatewayPublic20;
  exports.GatewayPublic24 = GatewayPublic24;
  exports.GatewayPublic32 = GatewayPublic32;
  exports.GatewaySecurity16 = GatewaySecurity16;
  exports.GatewaySecurity20 = GatewaySecurity20;
  exports.GatewaySecurity24 = GatewaySecurity24;
  exports.GatewaySecurity32 = GatewaySecurity32;
  exports.GatewayUserAccess16 = GatewayUserAccess16;
  exports.GatewayUserAccess20 = GatewayUserAccess20;
  exports.GatewayUserAccess24 = GatewayUserAccess24;
  exports.GatewayUserAccess32 = GatewayUserAccess32;
  exports.GatewayVpn16 = GatewayVpn16;
  exports.GatewayVpn20 = GatewayVpn20;
  exports.GatewayVpn24 = GatewayVpn24;
  exports.GatewayVpn32 = GatewayVpn32;
  exports.GenderFemale16 = GenderFemale16;
  exports.GenderFemale20 = GenderFemale20;
  exports.GenderFemale24 = GenderFemale24;
  exports.GenderFemale32 = GenderFemale32;
  exports.GenderMale16 = GenderMale16;
  exports.GenderMale20 = GenderMale20;
  exports.GenderMale24 = GenderMale24;
  exports.GenderMale32 = GenderMale32;
  exports.GeneratePdf16 = GeneratePdf16;
  exports.GeneratePdf20 = GeneratePdf20;
  exports.GeneratePdf24 = GeneratePdf24;
  exports.GeneratePdf32 = GeneratePdf32;
  exports.Gif16 = Gif16;
  exports.Gif20 = Gif20;
  exports.Gif24 = Gif24;
  exports.Gif32 = Gif32;
  exports.Gift16 = Gift16;
  exports.Gift20 = Gift20;
  exports.Gift24 = Gift24;
  exports.Gift32 = Gift32;
  exports.Globe16 = Globe16;
  exports.Globe20 = Globe20;
  exports.Globe24 = Globe24;
  exports.Globe32 = Globe32;
  exports.GlyphCautionGlyph = GlyphCautionGlyph;
  exports.GlyphCautionInvertedGlyph = GlyphCautionInvertedGlyph;
  exports.GlyphCircleFillGlyph = GlyphCircleFillGlyph;
  exports.GlyphCircleStrokeGlyph = GlyphCircleStrokeGlyph;
  exports.GlyphCriticalGlyph = GlyphCriticalGlyph;
  exports.GlyphIncompleteGlyph = GlyphIncompleteGlyph;
  exports.GlyphSquareFillGlyph = GlyphSquareFillGlyph;
  exports.GlyphUndefinedGlyph = GlyphUndefinedGlyph;
  exports.Gradient16 = Gradient16;
  exports.Gradient20 = Gradient20;
  exports.Gradient24 = Gradient24;
  exports.Gradient32 = Gradient32;
  exports.GraphicalDataFlow16 = GraphicalDataFlow16;
  exports.GraphicalDataFlow20 = GraphicalDataFlow20;
  exports.GraphicalDataFlow24 = GraphicalDataFlow24;
  exports.GraphicalDataFlow32 = GraphicalDataFlow32;
  exports.Grid16 = Grid16;
  exports.Grid20 = Grid20;
  exports.Grid24 = Grid24;
  exports.Grid32 = Grid32;
  exports.Group16 = Group16;
  exports.Group20 = Group20;
  exports.Group24 = Group24;
  exports.Group32 = Group32;
  exports.GroupAccess16 = GroupAccess16;
  exports.GroupAccess20 = GroupAccess20;
  exports.GroupAccess24 = GroupAccess24;
  exports.GroupAccess32 = GroupAccess32;
  exports.GroupAccount16 = GroupAccount16;
  exports.GroupAccount20 = GroupAccount20;
  exports.GroupAccount24 = GroupAccount24;
  exports.GroupAccount32 = GroupAccount32;
  exports.GroupObjects16 = GroupObjects16;
  exports.GroupObjects20 = GroupObjects20;
  exports.GroupObjects24 = GroupObjects24;
  exports.GroupObjects32 = GroupObjects32;
  exports.GroupObjectsNew16 = GroupObjectsNew16;
  exports.GroupObjectsNew20 = GroupObjectsNew20;
  exports.GroupObjectsNew24 = GroupObjectsNew24;
  exports.GroupObjectsNew32 = GroupObjectsNew32;
  exports.GroupObjectsSave16 = GroupObjectsSave16;
  exports.GroupObjectsSave20 = GroupObjectsSave20;
  exports.GroupObjectsSave24 = GroupObjectsSave24;
  exports.GroupObjectsSave32 = GroupObjectsSave32;
  exports.GroupPresentation16 = GroupPresentation16;
  exports.GroupPresentation20 = GroupPresentation20;
  exports.GroupPresentation24 = GroupPresentation24;
  exports.GroupPresentation32 = GroupPresentation32;
  exports.GroupResource16 = GroupResource16;
  exports.GroupResource20 = GroupResource20;
  exports.GroupResource24 = GroupResource24;
  exports.GroupResource32 = GroupResource32;
  exports.GroupSecurity16 = GroupSecurity16;
  exports.GroupSecurity20 = GroupSecurity20;
  exports.GroupSecurity24 = GroupSecurity24;
  exports.GroupSecurity32 = GroupSecurity32;
  exports.Growth16 = Growth16;
  exports.Growth20 = Growth20;
  exports.Growth24 = Growth24;
  exports.Growth32 = Growth32;
  exports.Gui16 = Gui16;
  exports.Gui20 = Gui20;
  exports.Gui24 = Gui24;
  exports.Gui32 = Gui32;
  exports.GuiManagement16 = GuiManagement16;
  exports.GuiManagement20 = GuiManagement20;
  exports.GuiManagement24 = GuiManagement24;
  exports.GuiManagement32 = GuiManagement32;
  exports.Hail16 = Hail16;
  exports.Hail20 = Hail20;
  exports.Hail24 = Hail24;
  exports.Hail32 = Hail32;
  exports.Harbor16 = Harbor16;
  exports.Harbor20 = Harbor20;
  exports.Harbor24 = Harbor24;
  exports.Harbor32 = Harbor32;
  exports.HardwareSecurityModule16 = HardwareSecurityModule16;
  exports.HardwareSecurityModule20 = HardwareSecurityModule20;
  exports.HardwareSecurityModule24 = HardwareSecurityModule24;
  exports.HardwareSecurityModule32 = HardwareSecurityModule32;
  exports.Hashtag16 = Hashtag16;
  exports.Hashtag20 = Hashtag20;
  exports.Hashtag24 = Hashtag24;
  exports.Hashtag32 = Hashtag32;
  exports.Haze16 = Haze16;
  exports.Haze20 = Haze20;
  exports.Haze24 = Haze24;
  exports.Haze32 = Haze32;
  exports.HazeNight16 = HazeNight16;
  exports.HazeNight20 = HazeNight20;
  exports.HazeNight24 = HazeNight24;
  exports.HazeNight32 = HazeNight32;
  exports.Hd16 = Hd16;
  exports.Hd20 = Hd20;
  exports.Hd24 = Hd24;
  exports.Hd32 = Hd32;
  exports.HdFilled16 = HdFilled16;
  exports.HdFilled20 = HdFilled20;
  exports.HdFilled24 = HdFilled24;
  exports.HdFilled32 = HdFilled32;
  exports.Hdr16 = Hdr16;
  exports.Hdr20 = Hdr20;
  exports.Hdr24 = Hdr24;
  exports.Hdr32 = Hdr32;
  exports.Headphones16 = Headphones16;
  exports.Headphones20 = Headphones20;
  exports.Headphones24 = Headphones24;
  exports.Headphones32 = Headphones32;
  exports.Headset16 = Headset16;
  exports.Headset20 = Headset20;
  exports.Headset24 = Headset24;
  exports.Headset32 = Headset32;
  exports.HealthCross16 = HealthCross16;
  exports.HealthCross20 = HealthCross20;
  exports.HealthCross24 = HealthCross24;
  exports.HealthCross32 = HealthCross32;
  exports.Hearing16 = Hearing16;
  exports.Hearing20 = Hearing20;
  exports.Hearing24 = Hearing24;
  exports.Hearing32 = Hearing32;
  exports.HeatMap16 = HeatMap16;
  exports.HeatMap20 = HeatMap20;
  exports.HeatMap24 = HeatMap24;
  exports.HeatMap32 = HeatMap32;
  exports.HeatMapStocks16 = HeatMapStocks16;
  exports.HeatMapStocks20 = HeatMapStocks20;
  exports.HeatMapStocks24 = HeatMapStocks24;
  exports.HeatMapStocks32 = HeatMapStocks32;
  exports.HeatMap_0216 = HeatMap_0216;
  exports.HeatMap_0220 = HeatMap_0220;
  exports.HeatMap_0224 = HeatMap_0224;
  exports.HeatMap_0232 = HeatMap_0232;
  exports.HeatMap_0316 = HeatMap_0316;
  exports.HeatMap_0320 = HeatMap_0320;
  exports.HeatMap_0324 = HeatMap_0324;
  exports.HeatMap_0332 = HeatMap_0332;
  exports.Helicopter16 = Helicopter16;
  exports.Helicopter20 = Helicopter20;
  exports.Helicopter24 = Helicopter24;
  exports.Helicopter32 = Helicopter32;
  exports.Help16 = Help16;
  exports.Help20 = Help20;
  exports.Help24 = Help24;
  exports.Help32 = Help32;
  exports.HelpDesk16 = HelpDesk16;
  exports.HelpDesk20 = HelpDesk20;
  exports.HelpDesk24 = HelpDesk24;
  exports.HelpDesk32 = HelpDesk32;
  exports.HelpFilled16 = HelpFilled16;
  exports.HelpFilled20 = HelpFilled20;
  exports.HelpFilled24 = HelpFilled24;
  exports.HelpFilled32 = HelpFilled32;
  exports.Home16 = Home16;
  exports.Home20 = Home20;
  exports.Home24 = Home24;
  exports.Home32 = Home32;
  exports.HorizontalView16 = HorizontalView16;
  exports.HorizontalView20 = HorizontalView20;
  exports.HorizontalView24 = HorizontalView24;
  exports.HorizontalView32 = HorizontalView32;
  exports.Hospital16 = Hospital16;
  exports.Hospital20 = Hospital20;
  exports.Hospital24 = Hospital24;
  exports.Hospital32 = Hospital32;
  exports.HospitalBed16 = HospitalBed16;
  exports.HospitalBed20 = HospitalBed20;
  exports.HospitalBed24 = HospitalBed24;
  exports.HospitalBed32 = HospitalBed32;
  exports.Hotel16 = Hotel16;
  exports.Hotel20 = Hotel20;
  exports.Hotel24 = Hotel24;
  exports.Hotel32 = Hotel32;
  exports.Hourglass16 = Hourglass16;
  exports.Hourglass20 = Hourglass20;
  exports.Hourglass24 = Hourglass24;
  exports.Hourglass32 = Hourglass32;
  exports.Html16 = Html16;
  exports.Html20 = Html20;
  exports.Html24 = Html24;
  exports.Html32 = Html32;
  exports.HtmlReference16 = HtmlReference16;
  exports.HtmlReference20 = HtmlReference20;
  exports.HtmlReference24 = HtmlReference24;
  exports.HtmlReference32 = HtmlReference32;
  exports.Http16 = Http16;
  exports.Http20 = Http20;
  exports.Http24 = Http24;
  exports.Http32 = Http32;
  exports.Humidity16 = Humidity16;
  exports.Humidity20 = Humidity20;
  exports.Humidity24 = Humidity24;
  exports.Humidity32 = Humidity32;
  exports.HumidityAlt16 = HumidityAlt16;
  exports.HumidityAlt20 = HumidityAlt20;
  exports.HumidityAlt24 = HumidityAlt24;
  exports.HumidityAlt32 = HumidityAlt32;
  exports.Hurricane16 = Hurricane16;
  exports.Hurricane20 = Hurricane20;
  exports.Hurricane24 = Hurricane24;
  exports.Hurricane32 = Hurricane32;
  exports.HybridNetworking16 = HybridNetworking16;
  exports.HybridNetworking20 = HybridNetworking20;
  exports.HybridNetworking24 = HybridNetworking24;
  exports.HybridNetworking32 = HybridNetworking32;
  exports.HybridNetworkingAlt16 = HybridNetworkingAlt16;
  exports.HybridNetworkingAlt20 = HybridNetworkingAlt20;
  exports.HybridNetworkingAlt24 = HybridNetworkingAlt24;
  exports.HybridNetworkingAlt32 = HybridNetworkingAlt32;
  exports.IbmCloud16 = IbmCloud16;
  exports.IbmCloud20 = IbmCloud20;
  exports.IbmCloud24 = IbmCloud24;
  exports.IbmCloud32 = IbmCloud32;
  exports.IbmCloudDedicatedHost16 = IbmCloudDedicatedHost16;
  exports.IbmCloudDedicatedHost20 = IbmCloudDedicatedHost20;
  exports.IbmCloudDedicatedHost24 = IbmCloudDedicatedHost24;
  exports.IbmCloudDedicatedHost32 = IbmCloudDedicatedHost32;
  exports.IbmCloudInternetServices16 = IbmCloudInternetServices16;
  exports.IbmCloudInternetServices20 = IbmCloudInternetServices20;
  exports.IbmCloudInternetServices24 = IbmCloudInternetServices24;
  exports.IbmCloudInternetServices32 = IbmCloudInternetServices32;
  exports.IbmCloudPakApplications16 = IbmCloudPakApplications16;
  exports.IbmCloudPakApplications20 = IbmCloudPakApplications20;
  exports.IbmCloudPakApplications24 = IbmCloudPakApplications24;
  exports.IbmCloudPakApplications32 = IbmCloudPakApplications32;
  exports.IbmCloudPakData16 = IbmCloudPakData16;
  exports.IbmCloudPakData20 = IbmCloudPakData20;
  exports.IbmCloudPakData24 = IbmCloudPakData24;
  exports.IbmCloudPakData32 = IbmCloudPakData32;
  exports.IbmCloudPakIntegration16 = IbmCloudPakIntegration16;
  exports.IbmCloudPakIntegration20 = IbmCloudPakIntegration20;
  exports.IbmCloudPakIntegration24 = IbmCloudPakIntegration24;
  exports.IbmCloudPakIntegration32 = IbmCloudPakIntegration32;
  exports.IbmCloudPakMulticloudMgmt16 = IbmCloudPakMulticloudMgmt16;
  exports.IbmCloudPakMulticloudMgmt20 = IbmCloudPakMulticloudMgmt20;
  exports.IbmCloudPakMulticloudMgmt24 = IbmCloudPakMulticloudMgmt24;
  exports.IbmCloudPakMulticloudMgmt32 = IbmCloudPakMulticloudMgmt32;
  exports.IbmCloudPakNetworkAutomation16 = IbmCloudPakNetworkAutomation16;
  exports.IbmCloudPakNetworkAutomation20 = IbmCloudPakNetworkAutomation20;
  exports.IbmCloudPakNetworkAutomation24 = IbmCloudPakNetworkAutomation24;
  exports.IbmCloudPakNetworkAutomation32 = IbmCloudPakNetworkAutomation32;
  exports.IbmCloudPakSecurity16 = IbmCloudPakSecurity16;
  exports.IbmCloudPakSecurity20 = IbmCloudPakSecurity20;
  exports.IbmCloudPakSecurity24 = IbmCloudPakSecurity24;
  exports.IbmCloudPakSecurity32 = IbmCloudPakSecurity32;
  exports.IbmCloudPakSystem16 = IbmCloudPakSystem16;
  exports.IbmCloudPakSystem20 = IbmCloudPakSystem20;
  exports.IbmCloudPakSystem24 = IbmCloudPakSystem24;
  exports.IbmCloudPakSystem32 = IbmCloudPakSystem32;
  exports.IbmCloudPakWatsonAiops16 = IbmCloudPakWatsonAiops16;
  exports.IbmCloudPakWatsonAiops20 = IbmCloudPakWatsonAiops20;
  exports.IbmCloudPakWatsonAiops24 = IbmCloudPakWatsonAiops24;
  exports.IbmCloudPakWatsonAiops32 = IbmCloudPakWatsonAiops32;
  exports.IbmCloudSubnets16 = IbmCloudSubnets16;
  exports.IbmCloudSubnets20 = IbmCloudSubnets20;
  exports.IbmCloudSubnets24 = IbmCloudSubnets24;
  exports.IbmCloudSubnets32 = IbmCloudSubnets32;
  exports.IbmCloudTransitGateway16 = IbmCloudTransitGateway16;
  exports.IbmCloudTransitGateway20 = IbmCloudTransitGateway20;
  exports.IbmCloudTransitGateway24 = IbmCloudTransitGateway24;
  exports.IbmCloudTransitGateway32 = IbmCloudTransitGateway32;
  exports.IbmCloudVpcEndpoints16 = IbmCloudVpcEndpoints16;
  exports.IbmCloudVpcEndpoints20 = IbmCloudVpcEndpoints20;
  exports.IbmCloudVpcEndpoints24 = IbmCloudVpcEndpoints24;
  exports.IbmCloudVpcEndpoints32 = IbmCloudVpcEndpoints32;
  exports.IbmDataReplication16 = IbmDataReplication16;
  exports.IbmDataReplication20 = IbmDataReplication20;
  exports.IbmDataReplication24 = IbmDataReplication24;
  exports.IbmDataReplication32 = IbmDataReplication32;
  exports.IbmMatch_36016 = IbmMatch_36016;
  exports.IbmMatch_36020 = IbmMatch_36020;
  exports.IbmMatch_36024 = IbmMatch_36024;
  exports.IbmMatch_36032 = IbmMatch_36032;
  exports.IbmSecurity16 = IbmSecurity16;
  exports.IbmSecurity20 = IbmSecurity20;
  exports.IbmSecurity24 = IbmSecurity24;
  exports.IbmSecurity32 = IbmSecurity32;
  exports.IbmSecurityServices16 = IbmSecurityServices16;
  exports.IbmSecurityServices20 = IbmSecurityServices20;
  exports.IbmSecurityServices24 = IbmSecurityServices24;
  exports.IbmSecurityServices32 = IbmSecurityServices32;
  exports.IceAccretion16 = IceAccretion16;
  exports.IceAccretion20 = IceAccretion20;
  exports.IceAccretion24 = IceAccretion24;
  exports.IceAccretion32 = IceAccretion32;
  exports.IceVision16 = IceVision16;
  exports.IceVision20 = IceVision20;
  exports.IceVision24 = IceVision24;
  exports.IceVision32 = IceVision32;
  exports.Icon = Icon;
  exports.IdManagement16 = IdManagement16;
  exports.IdManagement20 = IdManagement20;
  exports.IdManagement24 = IdManagement24;
  exports.IdManagement32 = IdManagement32;
  exports.Idea16 = Idea16;
  exports.Idea20 = Idea20;
  exports.Idea24 = Idea24;
  exports.Idea32 = Idea32;
  exports.Identification16 = Identification16;
  exports.Identification20 = Identification20;
  exports.Identification24 = Identification24;
  exports.Identification32 = Identification32;
  exports.Image16 = Image16;
  exports.Image20 = Image20;
  exports.Image24 = Image24;
  exports.Image32 = Image32;
  exports.ImageCopy16 = ImageCopy16;
  exports.ImageCopy20 = ImageCopy20;
  exports.ImageCopy24 = ImageCopy24;
  exports.ImageCopy32 = ImageCopy32;
  exports.ImageMedical16 = ImageMedical16;
  exports.ImageMedical20 = ImageMedical20;
  exports.ImageMedical24 = ImageMedical24;
  exports.ImageMedical32 = ImageMedical32;
  exports.ImageReference16 = ImageReference16;
  exports.ImageReference20 = ImageReference20;
  exports.ImageReference24 = ImageReference24;
  exports.ImageReference32 = ImageReference32;
  exports.ImageSearch16 = ImageSearch16;
  exports.ImageSearch20 = ImageSearch20;
  exports.ImageSearch24 = ImageSearch24;
  exports.ImageSearch32 = ImageSearch32;
  exports.ImageSearchAlt16 = ImageSearchAlt16;
  exports.ImageSearchAlt20 = ImageSearchAlt20;
  exports.ImageSearchAlt24 = ImageSearchAlt24;
  exports.ImageSearchAlt32 = ImageSearchAlt32;
  exports.ImageService16 = ImageService16;
  exports.ImageService20 = ImageService20;
  exports.ImageService24 = ImageService24;
  exports.ImageService32 = ImageService32;
  exports.ImportExport16 = ImportExport16;
  exports.ImportExport20 = ImportExport20;
  exports.ImportExport24 = ImportExport24;
  exports.ImportExport32 = ImportExport32;
  exports.ImproveRelevance16 = ImproveRelevance16;
  exports.ImproveRelevance20 = ImproveRelevance20;
  exports.ImproveRelevance24 = ImproveRelevance24;
  exports.ImproveRelevance32 = ImproveRelevance32;
  exports.InProgress16 = InProgress16;
  exports.InProgress20 = InProgress20;
  exports.InProgress24 = InProgress24;
  exports.InProgress32 = InProgress32;
  exports.InProgressError16 = InProgressError16;
  exports.InProgressError20 = InProgressError20;
  exports.InProgressError24 = InProgressError24;
  exports.InProgressError32 = InProgressError32;
  exports.InProgressWarning16 = InProgressWarning16;
  exports.InProgressWarning20 = InProgressWarning20;
  exports.InProgressWarning24 = InProgressWarning24;
  exports.InProgressWarning32 = InProgressWarning32;
  exports.Incomplete16 = Incomplete16;
  exports.Incomplete20 = Incomplete20;
  exports.Incomplete24 = Incomplete24;
  exports.Incomplete32 = Incomplete32;
  exports.IncompleteCancel16 = IncompleteCancel16;
  exports.IncompleteCancel20 = IncompleteCancel20;
  exports.IncompleteCancel24 = IncompleteCancel24;
  exports.IncompleteCancel32 = IncompleteCancel32;
  exports.IncompleteError16 = IncompleteError16;
  exports.IncompleteError20 = IncompleteError20;
  exports.IncompleteError24 = IncompleteError24;
  exports.IncompleteError32 = IncompleteError32;
  exports.IncompleteGlyph = IncompleteGlyph;
  exports.IncompleteWarning16 = IncompleteWarning16;
  exports.IncompleteWarning20 = IncompleteWarning20;
  exports.IncompleteWarning24 = IncompleteWarning24;
  exports.IncompleteWarning32 = IncompleteWarning32;
  exports.IncreaseLevel16 = IncreaseLevel16;
  exports.IncreaseLevel20 = IncreaseLevel20;
  exports.IncreaseLevel24 = IncreaseLevel24;
  exports.IncreaseLevel32 = IncreaseLevel32;
  exports.Industry16 = Industry16;
  exports.Industry20 = Industry20;
  exports.Industry24 = Industry24;
  exports.Industry32 = Industry32;
  exports.Information16 = Information16;
  exports.Information20 = Information20;
  exports.Information24 = Information24;
  exports.Information32 = Information32;
  exports.InformationDisabled16 = InformationDisabled16;
  exports.InformationDisabled20 = InformationDisabled20;
  exports.InformationDisabled24 = InformationDisabled24;
  exports.InformationDisabled32 = InformationDisabled32;
  exports.InformationFilled16 = InformationFilled16;
  exports.InformationFilled20 = InformationFilled20;
  exports.InformationFilled24 = InformationFilled24;
  exports.InformationFilled32 = InformationFilled32;
  exports.InformationSquare16 = InformationSquare16;
  exports.InformationSquare20 = InformationSquare20;
  exports.InformationSquare24 = InformationSquare24;
  exports.InformationSquare32 = InformationSquare32;
  exports.InformationSquareFilled16 = InformationSquareFilled16;
  exports.InformationSquareFilled20 = InformationSquareFilled20;
  exports.InformationSquareFilled24 = InformationSquareFilled24;
  exports.InformationSquareFilled32 = InformationSquareFilled32;
  exports.InfrastructureClassic16 = InfrastructureClassic16;
  exports.InfrastructureClassic20 = InfrastructureClassic20;
  exports.InfrastructureClassic24 = InfrastructureClassic24;
  exports.InfrastructureClassic32 = InfrastructureClassic32;
  exports.Insert16 = Insert16;
  exports.Insert20 = Insert20;
  exports.Insert24 = Insert24;
  exports.Insert32 = Insert32;
  exports.InsertPage16 = InsertPage16;
  exports.InsertPage20 = InsertPage20;
  exports.InsertPage24 = InsertPage24;
  exports.InsertPage32 = InsertPage32;
  exports.InsertSyntax16 = InsertSyntax16;
  exports.InsertSyntax20 = InsertSyntax20;
  exports.InsertSyntax24 = InsertSyntax24;
  exports.InsertSyntax32 = InsertSyntax32;
  exports.Inspection16 = Inspection16;
  exports.Inspection20 = Inspection20;
  exports.Inspection24 = Inspection24;
  exports.Inspection32 = Inspection32;
  exports.InstanceBx16 = InstanceBx16;
  exports.InstanceBx20 = InstanceBx20;
  exports.InstanceBx24 = InstanceBx24;
  exports.InstanceBx32 = InstanceBx32;
  exports.InstanceClassic16 = InstanceClassic16;
  exports.InstanceClassic20 = InstanceClassic20;
  exports.InstanceClassic24 = InstanceClassic24;
  exports.InstanceClassic32 = InstanceClassic32;
  exports.InstanceCx16 = InstanceCx16;
  exports.InstanceCx20 = InstanceCx20;
  exports.InstanceCx24 = InstanceCx24;
  exports.InstanceCx32 = InstanceCx32;
  exports.InstanceMx16 = InstanceMx16;
  exports.InstanceMx20 = InstanceMx20;
  exports.InstanceMx24 = InstanceMx24;
  exports.InstanceMx32 = InstanceMx32;
  exports.InstanceVirtual16 = InstanceVirtual16;
  exports.InstanceVirtual20 = InstanceVirtual20;
  exports.InstanceVirtual24 = InstanceVirtual24;
  exports.InstanceVirtual32 = InstanceVirtual32;
  exports.Integration16 = Integration16;
  exports.Integration20 = Integration20;
  exports.Integration24 = Integration24;
  exports.Integration32 = Integration32;
  exports.Interactions16 = Interactions16;
  exports.Interactions20 = Interactions20;
  exports.Interactions24 = Interactions24;
  exports.Interactions32 = Interactions32;
  exports.Intersect16 = Intersect16;
  exports.Intersect20 = Intersect20;
  exports.Intersect24 = Intersect24;
  exports.Intersect32 = Intersect32;
  exports.IntrusionPrevention16 = IntrusionPrevention16;
  exports.IntrusionPrevention20 = IntrusionPrevention20;
  exports.IntrusionPrevention24 = IntrusionPrevention24;
  exports.IntrusionPrevention32 = IntrusionPrevention32;
  exports.InventoryManagement16 = InventoryManagement16;
  exports.InventoryManagement20 = InventoryManagement20;
  exports.InventoryManagement24 = InventoryManagement24;
  exports.InventoryManagement32 = InventoryManagement32;
  exports.IotConnect16 = IotConnect16;
  exports.IotConnect20 = IotConnect20;
  exports.IotConnect24 = IotConnect24;
  exports.IotConnect32 = IotConnect32;
  exports.IotPlatform16 = IotPlatform16;
  exports.IotPlatform20 = IotPlatform20;
  exports.IotPlatform24 = IotPlatform24;
  exports.IotPlatform32 = IotPlatform32;
  exports.Iso16 = Iso16;
  exports.Iso20 = Iso20;
  exports.Iso24 = Iso24;
  exports.Iso32 = Iso32;
  exports.IsoFilled16 = IsoFilled16;
  exports.IsoFilled20 = IsoFilled20;
  exports.IsoFilled24 = IsoFilled24;
  exports.IsoFilled32 = IsoFilled32;
  exports.IsoOutline16 = IsoOutline16;
  exports.IsoOutline20 = IsoOutline20;
  exports.IsoOutline24 = IsoOutline24;
  exports.IsoOutline32 = IsoOutline32;
  exports.JoinFull16 = JoinFull16;
  exports.JoinFull20 = JoinFull20;
  exports.JoinFull24 = JoinFull24;
  exports.JoinFull32 = JoinFull32;
  exports.JoinInner16 = JoinInner16;
  exports.JoinInner20 = JoinInner20;
  exports.JoinInner24 = JoinInner24;
  exports.JoinInner32 = JoinInner32;
  exports.JoinLeft16 = JoinLeft16;
  exports.JoinLeft20 = JoinLeft20;
  exports.JoinLeft24 = JoinLeft24;
  exports.JoinLeft32 = JoinLeft32;
  exports.JoinOuter16 = JoinOuter16;
  exports.JoinOuter20 = JoinOuter20;
  exports.JoinOuter24 = JoinOuter24;
  exports.JoinOuter32 = JoinOuter32;
  exports.JoinRight16 = JoinRight16;
  exports.JoinRight20 = JoinRight20;
  exports.JoinRight24 = JoinRight24;
  exports.JoinRight32 = JoinRight32;
  exports.Jpg16 = Jpg16;
  exports.Jpg20 = Jpg20;
  exports.Jpg24 = Jpg24;
  exports.Jpg32 = Jpg32;
  exports.Json16 = Json16;
  exports.Json20 = Json20;
  exports.Json24 = Json24;
  exports.Json32 = Json32;
  exports.JsonReference16 = JsonReference16;
  exports.JsonReference20 = JsonReference20;
  exports.JsonReference24 = JsonReference24;
  exports.JsonReference32 = JsonReference32;
  exports.JumpLink16 = JumpLink16;
  exports.JumpLink20 = JumpLink20;
  exports.JumpLink24 = JumpLink24;
  exports.JumpLink32 = JumpLink32;
  exports.KeepDry16 = KeepDry16;
  exports.KeepDry20 = KeepDry20;
  exports.KeepDry24 = KeepDry24;
  exports.KeepDry32 = KeepDry32;
  exports.Keyboard16 = Keyboard16;
  exports.Keyboard20 = Keyboard20;
  exports.Keyboard24 = Keyboard24;
  exports.Keyboard32 = Keyboard32;
  exports.Kubernetes16 = Kubernetes16;
  exports.Kubernetes20 = Kubernetes20;
  exports.Kubernetes24 = Kubernetes24;
  exports.Kubernetes32 = Kubernetes32;
  exports.Label16 = Label16;
  exports.Label20 = Label20;
  exports.Label24 = Label24;
  exports.Label32 = Label32;
  exports.Language16 = Language16;
  exports.Language20 = Language20;
  exports.Language24 = Language24;
  exports.Language32 = Language32;
  exports.Laptop16 = Laptop16;
  exports.Laptop20 = Laptop20;
  exports.Laptop24 = Laptop24;
  exports.Laptop32 = Laptop32;
  exports.Lasso16 = Lasso16;
  exports.Lasso20 = Lasso20;
  exports.Lasso24 = Lasso24;
  exports.Lasso32 = Lasso32;
  exports.LassoPolygon16 = LassoPolygon16;
  exports.LassoPolygon20 = LassoPolygon20;
  exports.LassoPolygon24 = LassoPolygon24;
  exports.LassoPolygon32 = LassoPolygon32;
  exports.Launch16 = Launch16;
  exports.Launch20 = Launch20;
  exports.Launch24 = Launch24;
  exports.Launch32 = Launch32;
  exports.Layers16 = Layers16;
  exports.Layers20 = Layers20;
  exports.Layers24 = Layers24;
  exports.Layers32 = Layers32;
  exports.Legend16 = Legend16;
  exports.Legend20 = Legend20;
  exports.Legend24 = Legend24;
  exports.Legend32 = Legend32;
  exports.LetterAa16 = LetterAa16;
  exports.LetterAa20 = LetterAa20;
  exports.LetterAa24 = LetterAa24;
  exports.LetterAa32 = LetterAa32;
  exports.LetterAaLarge16 = LetterAaLarge16;
  exports.LetterAaLarge20 = LetterAaLarge20;
  exports.LetterAaLarge24 = LetterAaLarge24;
  exports.LetterAaLarge32 = LetterAaLarge32;
  exports.LetterBb16 = LetterBb16;
  exports.LetterBb20 = LetterBb20;
  exports.LetterBb24 = LetterBb24;
  exports.LetterBb32 = LetterBb32;
  exports.LetterCc16 = LetterCc16;
  exports.LetterCc20 = LetterCc20;
  exports.LetterCc24 = LetterCc24;
  exports.LetterCc32 = LetterCc32;
  exports.LetterDd16 = LetterDd16;
  exports.LetterDd20 = LetterDd20;
  exports.LetterDd24 = LetterDd24;
  exports.LetterDd32 = LetterDd32;
  exports.LetterEe16 = LetterEe16;
  exports.LetterEe20 = LetterEe20;
  exports.LetterEe24 = LetterEe24;
  exports.LetterEe32 = LetterEe32;
  exports.LetterFf16 = LetterFf16;
  exports.LetterFf20 = LetterFf20;
  exports.LetterFf24 = LetterFf24;
  exports.LetterFf32 = LetterFf32;
  exports.LetterGg16 = LetterGg16;
  exports.LetterGg20 = LetterGg20;
  exports.LetterGg24 = LetterGg24;
  exports.LetterGg32 = LetterGg32;
  exports.LetterHh16 = LetterHh16;
  exports.LetterHh20 = LetterHh20;
  exports.LetterHh24 = LetterHh24;
  exports.LetterHh32 = LetterHh32;
  exports.LetterIi16 = LetterIi16;
  exports.LetterIi20 = LetterIi20;
  exports.LetterIi24 = LetterIi24;
  exports.LetterIi32 = LetterIi32;
  exports.LetterJj16 = LetterJj16;
  exports.LetterJj20 = LetterJj20;
  exports.LetterJj24 = LetterJj24;
  exports.LetterJj32 = LetterJj32;
  exports.LetterKk16 = LetterKk16;
  exports.LetterKk20 = LetterKk20;
  exports.LetterKk24 = LetterKk24;
  exports.LetterKk32 = LetterKk32;
  exports.LetterLl16 = LetterLl16;
  exports.LetterLl20 = LetterLl20;
  exports.LetterLl24 = LetterLl24;
  exports.LetterLl32 = LetterLl32;
  exports.LetterMm16 = LetterMm16;
  exports.LetterMm20 = LetterMm20;
  exports.LetterMm24 = LetterMm24;
  exports.LetterMm32 = LetterMm32;
  exports.LetterNn16 = LetterNn16;
  exports.LetterNn20 = LetterNn20;
  exports.LetterNn24 = LetterNn24;
  exports.LetterNn32 = LetterNn32;
  exports.LetterOo16 = LetterOo16;
  exports.LetterOo20 = LetterOo20;
  exports.LetterOo24 = LetterOo24;
  exports.LetterOo32 = LetterOo32;
  exports.LetterPp16 = LetterPp16;
  exports.LetterPp20 = LetterPp20;
  exports.LetterPp24 = LetterPp24;
  exports.LetterPp32 = LetterPp32;
  exports.LetterQq16 = LetterQq16;
  exports.LetterQq20 = LetterQq20;
  exports.LetterQq24 = LetterQq24;
  exports.LetterQq32 = LetterQq32;
  exports.LetterRr16 = LetterRr16;
  exports.LetterRr20 = LetterRr20;
  exports.LetterRr24 = LetterRr24;
  exports.LetterRr32 = LetterRr32;
  exports.LetterSs16 = LetterSs16;
  exports.LetterSs20 = LetterSs20;
  exports.LetterSs24 = LetterSs24;
  exports.LetterSs32 = LetterSs32;
  exports.LetterTt16 = LetterTt16;
  exports.LetterTt20 = LetterTt20;
  exports.LetterTt24 = LetterTt24;
  exports.LetterTt32 = LetterTt32;
  exports.LetterUu16 = LetterUu16;
  exports.LetterUu20 = LetterUu20;
  exports.LetterUu24 = LetterUu24;
  exports.LetterUu32 = LetterUu32;
  exports.LetterVv16 = LetterVv16;
  exports.LetterVv20 = LetterVv20;
  exports.LetterVv24 = LetterVv24;
  exports.LetterVv32 = LetterVv32;
  exports.LetterWw16 = LetterWw16;
  exports.LetterWw20 = LetterWw20;
  exports.LetterWw24 = LetterWw24;
  exports.LetterWw32 = LetterWw32;
  exports.LetterXx16 = LetterXx16;
  exports.LetterXx20 = LetterXx20;
  exports.LetterXx24 = LetterXx24;
  exports.LetterXx32 = LetterXx32;
  exports.LetterYy16 = LetterYy16;
  exports.LetterYy20 = LetterYy20;
  exports.LetterYy24 = LetterYy24;
  exports.LetterYy32 = LetterYy32;
  exports.LetterZz16 = LetterZz16;
  exports.LetterZz20 = LetterZz20;
  exports.LetterZz24 = LetterZz24;
  exports.LetterZz32 = LetterZz32;
  exports.License16 = License16;
  exports.License20 = License20;
  exports.License24 = License24;
  exports.License32 = License32;
  exports.LicenseDraft16 = LicenseDraft16;
  exports.LicenseDraft20 = LicenseDraft20;
  exports.LicenseDraft24 = LicenseDraft24;
  exports.LicenseDraft32 = LicenseDraft32;
  exports.LicenseGlobal16 = LicenseGlobal16;
  exports.LicenseGlobal20 = LicenseGlobal20;
  exports.LicenseGlobal24 = LicenseGlobal24;
  exports.LicenseGlobal32 = LicenseGlobal32;
  exports.LicenseMaintenance16 = LicenseMaintenance16;
  exports.LicenseMaintenance20 = LicenseMaintenance20;
  exports.LicenseMaintenance24 = LicenseMaintenance24;
  exports.LicenseMaintenance32 = LicenseMaintenance32;
  exports.LicenseMaintenanceDraft16 = LicenseMaintenanceDraft16;
  exports.LicenseMaintenanceDraft20 = LicenseMaintenanceDraft20;
  exports.LicenseMaintenanceDraft24 = LicenseMaintenanceDraft24;
  exports.LicenseMaintenanceDraft32 = LicenseMaintenanceDraft32;
  exports.LicenseThirdParty16 = LicenseThirdParty16;
  exports.LicenseThirdParty20 = LicenseThirdParty20;
  exports.LicenseThirdParty24 = LicenseThirdParty24;
  exports.LicenseThirdParty32 = LicenseThirdParty32;
  exports.LicenseThirdPartyDraft16 = LicenseThirdPartyDraft16;
  exports.LicenseThirdPartyDraft20 = LicenseThirdPartyDraft20;
  exports.LicenseThirdPartyDraft24 = LicenseThirdPartyDraft24;
  exports.LicenseThirdPartyDraft32 = LicenseThirdPartyDraft32;
  exports.Lifesaver16 = Lifesaver16;
  exports.Lifesaver20 = Lifesaver20;
  exports.Lifesaver24 = Lifesaver24;
  exports.Lifesaver32 = Lifesaver32;
  exports.Light16 = Light16;
  exports.Light20 = Light20;
  exports.Light24 = Light24;
  exports.Light32 = Light32;
  exports.LightFilled16 = LightFilled16;
  exports.LightFilled20 = LightFilled20;
  exports.LightFilled24 = LightFilled24;
  exports.LightFilled32 = LightFilled32;
  exports.Lightning16 = Lightning16;
  exports.Lightning20 = Lightning20;
  exports.Lightning24 = Lightning24;
  exports.Lightning32 = Lightning32;
  exports.Link16 = Link16;
  exports.Link20 = Link20;
  exports.Link24 = Link24;
  exports.Link32 = Link32;
  exports.Linux16 = Linux16;
  exports.Linux20 = Linux20;
  exports.Linux24 = Linux24;
  exports.Linux32 = Linux32;
  exports.LinuxAlt16 = LinuxAlt16;
  exports.LinuxAlt20 = LinuxAlt20;
  exports.LinuxAlt24 = LinuxAlt24;
  exports.LinuxAlt32 = LinuxAlt32;
  exports.List16 = List16;
  exports.List20 = List20;
  exports.List24 = List24;
  exports.List32 = List32;
  exports.ListBoxes16 = ListBoxes16;
  exports.ListBoxes20 = ListBoxes20;
  exports.ListBoxes24 = ListBoxes24;
  exports.ListBoxes32 = ListBoxes32;
  exports.ListBulleted16 = ListBulleted16;
  exports.ListBulleted20 = ListBulleted20;
  exports.ListBulleted24 = ListBulleted24;
  exports.ListBulleted32 = ListBulleted32;
  exports.ListChecked16 = ListChecked16;
  exports.ListChecked20 = ListChecked20;
  exports.ListChecked24 = ListChecked24;
  exports.ListChecked32 = ListChecked32;
  exports.ListDropdown16 = ListDropdown16;
  exports.ListDropdown20 = ListDropdown20;
  exports.ListDropdown24 = ListDropdown24;
  exports.ListDropdown32 = ListDropdown32;
  exports.ListNumbered16 = ListNumbered16;
  exports.ListNumbered20 = ListNumbered20;
  exports.ListNumbered24 = ListNumbered24;
  exports.ListNumbered32 = ListNumbered32;
  exports.LoadBalancerApplication16 = LoadBalancerApplication16;
  exports.LoadBalancerApplication20 = LoadBalancerApplication20;
  exports.LoadBalancerApplication24 = LoadBalancerApplication24;
  exports.LoadBalancerApplication32 = LoadBalancerApplication32;
  exports.LoadBalancerClassic16 = LoadBalancerClassic16;
  exports.LoadBalancerClassic20 = LoadBalancerClassic20;
  exports.LoadBalancerClassic24 = LoadBalancerClassic24;
  exports.LoadBalancerClassic32 = LoadBalancerClassic32;
  exports.LoadBalancerGlobal16 = LoadBalancerGlobal16;
  exports.LoadBalancerGlobal20 = LoadBalancerGlobal20;
  exports.LoadBalancerGlobal24 = LoadBalancerGlobal24;
  exports.LoadBalancerGlobal32 = LoadBalancerGlobal32;
  exports.LoadBalancerListener16 = LoadBalancerListener16;
  exports.LoadBalancerListener20 = LoadBalancerListener20;
  exports.LoadBalancerListener24 = LoadBalancerListener24;
  exports.LoadBalancerListener32 = LoadBalancerListener32;
  exports.LoadBalancerLocal16 = LoadBalancerLocal16;
  exports.LoadBalancerLocal20 = LoadBalancerLocal20;
  exports.LoadBalancerLocal24 = LoadBalancerLocal24;
  exports.LoadBalancerLocal32 = LoadBalancerLocal32;
  exports.LoadBalancerNetwork16 = LoadBalancerNetwork16;
  exports.LoadBalancerNetwork20 = LoadBalancerNetwork20;
  exports.LoadBalancerNetwork24 = LoadBalancerNetwork24;
  exports.LoadBalancerNetwork32 = LoadBalancerNetwork32;
  exports.LoadBalancerPool16 = LoadBalancerPool16;
  exports.LoadBalancerPool20 = LoadBalancerPool20;
  exports.LoadBalancerPool24 = LoadBalancerPool24;
  exports.LoadBalancerPool32 = LoadBalancerPool32;
  exports.LoadBalancerVpc16 = LoadBalancerVpc16;
  exports.LoadBalancerVpc20 = LoadBalancerVpc20;
  exports.LoadBalancerVpc24 = LoadBalancerVpc24;
  exports.LoadBalancerVpc32 = LoadBalancerVpc32;
  exports.Location16 = Location16;
  exports.Location20 = Location20;
  exports.Location24 = Location24;
  exports.Location32 = Location32;
  exports.LocationCompany16 = LocationCompany16;
  exports.LocationCompany20 = LocationCompany20;
  exports.LocationCompany24 = LocationCompany24;
  exports.LocationCompany32 = LocationCompany32;
  exports.LocationCompanyFilled16 = LocationCompanyFilled16;
  exports.LocationCompanyFilled20 = LocationCompanyFilled20;
  exports.LocationCompanyFilled24 = LocationCompanyFilled24;
  exports.LocationCompanyFilled32 = LocationCompanyFilled32;
  exports.LocationCurrent16 = LocationCurrent16;
  exports.LocationCurrent20 = LocationCurrent20;
  exports.LocationCurrent24 = LocationCurrent24;
  exports.LocationCurrent32 = LocationCurrent32;
  exports.LocationFilled16 = LocationFilled16;
  exports.LocationFilled20 = LocationFilled20;
  exports.LocationFilled24 = LocationFilled24;
  exports.LocationFilled32 = LocationFilled32;
  exports.LocationHazard16 = LocationHazard16;
  exports.LocationHazard20 = LocationHazard20;
  exports.LocationHazard24 = LocationHazard24;
  exports.LocationHazard32 = LocationHazard32;
  exports.LocationHazardFilled16 = LocationHazardFilled16;
  exports.LocationHazardFilled20 = LocationHazardFilled20;
  exports.LocationHazardFilled24 = LocationHazardFilled24;
  exports.LocationHazardFilled32 = LocationHazardFilled32;
  exports.LocationHeart16 = LocationHeart16;
  exports.LocationHeart20 = LocationHeart20;
  exports.LocationHeart24 = LocationHeart24;
  exports.LocationHeart32 = LocationHeart32;
  exports.LocationHeartFilled16 = LocationHeartFilled16;
  exports.LocationHeartFilled20 = LocationHeartFilled20;
  exports.LocationHeartFilled24 = LocationHeartFilled24;
  exports.LocationHeartFilled32 = LocationHeartFilled32;
  exports.LocationPerson16 = LocationPerson16;
  exports.LocationPerson20 = LocationPerson20;
  exports.LocationPerson24 = LocationPerson24;
  exports.LocationPerson32 = LocationPerson32;
  exports.LocationPersonFilled16 = LocationPersonFilled16;
  exports.LocationPersonFilled20 = LocationPersonFilled20;
  exports.LocationPersonFilled24 = LocationPersonFilled24;
  exports.LocationPersonFilled32 = LocationPersonFilled32;
  exports.LocationSave16 = LocationSave16;
  exports.LocationSave20 = LocationSave20;
  exports.LocationSave24 = LocationSave24;
  exports.LocationSave32 = LocationSave32;
  exports.LocationStar16 = LocationStar16;
  exports.LocationStar20 = LocationStar20;
  exports.LocationStar24 = LocationStar24;
  exports.LocationStar32 = LocationStar32;
  exports.LocationStarFilled16 = LocationStarFilled16;
  exports.LocationStarFilled20 = LocationStarFilled20;
  exports.LocationStarFilled24 = LocationStarFilled24;
  exports.LocationStarFilled32 = LocationStarFilled32;
  exports.Locked16 = Locked16;
  exports.Locked20 = Locked20;
  exports.Locked24 = Locked24;
  exports.Locked32 = Locked32;
  exports.LogicalPartition16 = LogicalPartition16;
  exports.LogicalPartition20 = LogicalPartition20;
  exports.LogicalPartition24 = LogicalPartition24;
  exports.LogicalPartition32 = LogicalPartition32;
  exports.Login16 = Login16;
  exports.Login20 = Login20;
  exports.Login24 = Login24;
  exports.Login32 = Login32;
  exports.LogoDelicious16 = LogoDelicious16;
  exports.LogoDelicious20 = LogoDelicious20;
  exports.LogoDelicious24 = LogoDelicious24;
  exports.LogoDelicious32 = LogoDelicious32;
  exports.LogoDigg16 = LogoDigg16;
  exports.LogoDigg20 = LogoDigg20;
  exports.LogoDigg24 = LogoDigg24;
  exports.LogoDigg32 = LogoDigg32;
  exports.LogoDiscord16 = LogoDiscord16;
  exports.LogoDiscord20 = LogoDiscord20;
  exports.LogoDiscord24 = LogoDiscord24;
  exports.LogoDiscord32 = LogoDiscord32;
  exports.LogoFacebook16 = LogoFacebook16;
  exports.LogoFacebook20 = LogoFacebook20;
  exports.LogoFacebook24 = LogoFacebook24;
  exports.LogoFacebook32 = LogoFacebook32;
  exports.LogoFlickr16 = LogoFlickr16;
  exports.LogoFlickr20 = LogoFlickr20;
  exports.LogoFlickr24 = LogoFlickr24;
  exports.LogoFlickr32 = LogoFlickr32;
  exports.LogoGithub16 = LogoGithub16;
  exports.LogoGithub20 = LogoGithub20;
  exports.LogoGithub24 = LogoGithub24;
  exports.LogoGithub32 = LogoGithub32;
  exports.LogoGlassdoor16 = LogoGlassdoor16;
  exports.LogoGlassdoor20 = LogoGlassdoor20;
  exports.LogoGlassdoor24 = LogoGlassdoor24;
  exports.LogoGlassdoor32 = LogoGlassdoor32;
  exports.LogoGoogle16 = LogoGoogle16;
  exports.LogoGoogle20 = LogoGoogle20;
  exports.LogoGoogle24 = LogoGoogle24;
  exports.LogoGoogle32 = LogoGoogle32;
  exports.LogoInstagram16 = LogoInstagram16;
  exports.LogoInstagram20 = LogoInstagram20;
  exports.LogoInstagram24 = LogoInstagram24;
  exports.LogoInstagram32 = LogoInstagram32;
  exports.LogoJupyter16 = LogoJupyter16;
  exports.LogoJupyter20 = LogoJupyter20;
  exports.LogoJupyter24 = LogoJupyter24;
  exports.LogoJupyter32 = LogoJupyter32;
  exports.LogoKeybase16 = LogoKeybase16;
  exports.LogoKeybase20 = LogoKeybase20;
  exports.LogoKeybase24 = LogoKeybase24;
  exports.LogoKeybase32 = LogoKeybase32;
  exports.LogoLinkedin16 = LogoLinkedin16;
  exports.LogoLinkedin20 = LogoLinkedin20;
  exports.LogoLinkedin24 = LogoLinkedin24;
  exports.LogoLinkedin32 = LogoLinkedin32;
  exports.LogoLivestream16 = LogoLivestream16;
  exports.LogoLivestream20 = LogoLivestream20;
  exports.LogoLivestream24 = LogoLivestream24;
  exports.LogoLivestream32 = LogoLivestream32;
  exports.LogoMedium16 = LogoMedium16;
  exports.LogoMedium20 = LogoMedium20;
  exports.LogoMedium24 = LogoMedium24;
  exports.LogoMedium32 = LogoMedium32;
  exports.LogoOpenshift16 = LogoOpenshift16;
  exports.LogoOpenshift20 = LogoOpenshift20;
  exports.LogoOpenshift24 = LogoOpenshift24;
  exports.LogoOpenshift32 = LogoOpenshift32;
  exports.LogoPinterest16 = LogoPinterest16;
  exports.LogoPinterest20 = LogoPinterest20;
  exports.LogoPinterest24 = LogoPinterest24;
  exports.LogoPinterest32 = LogoPinterest32;
  exports.LogoPython16 = LogoPython16;
  exports.LogoPython20 = LogoPython20;
  exports.LogoPython24 = LogoPython24;
  exports.LogoPython32 = LogoPython32;
  exports.LogoQuora16 = LogoQuora16;
  exports.LogoQuora20 = LogoQuora20;
  exports.LogoQuora24 = LogoQuora24;
  exports.LogoQuora32 = LogoQuora32;
  exports.LogoRScript16 = LogoRScript16;
  exports.LogoRScript20 = LogoRScript20;
  exports.LogoRScript24 = LogoRScript24;
  exports.LogoRScript32 = LogoRScript32;
  exports.LogoSkype16 = LogoSkype16;
  exports.LogoSkype20 = LogoSkype20;
  exports.LogoSkype24 = LogoSkype24;
  exports.LogoSkype32 = LogoSkype32;
  exports.LogoSlack16 = LogoSlack16;
  exports.LogoSlack20 = LogoSlack20;
  exports.LogoSlack24 = LogoSlack24;
  exports.LogoSlack32 = LogoSlack32;
  exports.LogoSnapchat16 = LogoSnapchat16;
  exports.LogoSnapchat20 = LogoSnapchat20;
  exports.LogoSnapchat24 = LogoSnapchat24;
  exports.LogoSnapchat32 = LogoSnapchat32;
  exports.LogoStumbleupon16 = LogoStumbleupon16;
  exports.LogoStumbleupon20 = LogoStumbleupon20;
  exports.LogoStumbleupon24 = LogoStumbleupon24;
  exports.LogoStumbleupon32 = LogoStumbleupon32;
  exports.LogoTumblr16 = LogoTumblr16;
  exports.LogoTumblr20 = LogoTumblr20;
  exports.LogoTumblr24 = LogoTumblr24;
  exports.LogoTumblr32 = LogoTumblr32;
  exports.LogoTwitter16 = LogoTwitter16;
  exports.LogoTwitter20 = LogoTwitter20;
  exports.LogoTwitter24 = LogoTwitter24;
  exports.LogoTwitter32 = LogoTwitter32;
  exports.LogoVmware16 = LogoVmware16;
  exports.LogoVmware20 = LogoVmware20;
  exports.LogoVmware24 = LogoVmware24;
  exports.LogoVmware32 = LogoVmware32;
  exports.LogoWechat16 = LogoWechat16;
  exports.LogoWechat20 = LogoWechat20;
  exports.LogoWechat24 = LogoWechat24;
  exports.LogoWechat32 = LogoWechat32;
  exports.LogoXing16 = LogoXing16;
  exports.LogoXing20 = LogoXing20;
  exports.LogoXing24 = LogoXing24;
  exports.LogoXing32 = LogoXing32;
  exports.LogoYelp16 = LogoYelp16;
  exports.LogoYelp20 = LogoYelp20;
  exports.LogoYelp24 = LogoYelp24;
  exports.LogoYelp32 = LogoYelp32;
  exports.LogoYoutube16 = LogoYoutube16;
  exports.LogoYoutube20 = LogoYoutube20;
  exports.LogoYoutube24 = LogoYoutube24;
  exports.LogoYoutube32 = LogoYoutube32;
  exports.Logout16 = Logout16;
  exports.Logout20 = Logout20;
  exports.Logout24 = Logout24;
  exports.Logout32 = Logout32;
  exports.Loop16 = Loop16;
  exports.Loop20 = Loop20;
  exports.Loop24 = Loop24;
  exports.Loop32 = Loop32;
  exports.LowSeverityGlyph = LowSeverityGlyph;
  exports.MacCommand16 = MacCommand16;
  exports.MacCommand20 = MacCommand20;
  exports.MacCommand24 = MacCommand24;
  exports.MacCommand32 = MacCommand32;
  exports.MacOption16 = MacOption16;
  exports.MacOption20 = MacOption20;
  exports.MacOption24 = MacOption24;
  exports.MacOption32 = MacOption32;
  exports.MacShift16 = MacShift16;
  exports.MacShift20 = MacShift20;
  exports.MacShift24 = MacShift24;
  exports.MacShift32 = MacShift32;
  exports.MachineLearning16 = MachineLearning16;
  exports.MachineLearning20 = MachineLearning20;
  exports.MachineLearning24 = MachineLearning24;
  exports.MachineLearning32 = MachineLearning32;
  exports.MachineLearningModel16 = MachineLearningModel16;
  exports.MachineLearningModel20 = MachineLearningModel20;
  exports.MachineLearningModel24 = MachineLearningModel24;
  exports.MachineLearningModel32 = MachineLearningModel32;
  exports.MagicWand16 = MagicWand16;
  exports.MagicWand20 = MagicWand20;
  exports.MagicWand24 = MagicWand24;
  exports.MagicWand32 = MagicWand32;
  exports.MagicWandFilled16 = MagicWandFilled16;
  exports.MagicWandFilled20 = MagicWandFilled20;
  exports.MagicWandFilled24 = MagicWandFilled24;
  exports.MagicWandFilled32 = MagicWandFilled32;
  exports.MailAll16 = MailAll16;
  exports.MailAll20 = MailAll20;
  exports.MailAll24 = MailAll24;
  exports.MailAll32 = MailAll32;
  exports.MailReply16 = MailReply16;
  exports.MailReply20 = MailReply20;
  exports.MailReply24 = MailReply24;
  exports.MailReply32 = MailReply32;
  exports.MammogramStacked16 = MammogramStacked16;
  exports.MammogramStacked20 = MammogramStacked20;
  exports.MammogramStacked24 = MammogramStacked24;
  exports.MammogramStacked32 = MammogramStacked32;
  exports.ManageProtection16 = ManageProtection16;
  exports.ManageProtection20 = ManageProtection20;
  exports.ManageProtection24 = ManageProtection24;
  exports.ManageProtection32 = ManageProtection32;
  exports.ManagedSolutions16 = ManagedSolutions16;
  exports.ManagedSolutions20 = ManagedSolutions20;
  exports.ManagedSolutions24 = ManagedSolutions24;
  exports.ManagedSolutions32 = ManagedSolutions32;
  exports.Map16 = Map16;
  exports.Map20 = Map20;
  exports.Map24 = Map24;
  exports.Map32 = Map32;
  exports.MapBoundary16 = MapBoundary16;
  exports.MapBoundary20 = MapBoundary20;
  exports.MapBoundary24 = MapBoundary24;
  exports.MapBoundary32 = MapBoundary32;
  exports.MapBoundaryVegetation16 = MapBoundaryVegetation16;
  exports.MapBoundaryVegetation20 = MapBoundaryVegetation20;
  exports.MapBoundaryVegetation24 = MapBoundaryVegetation24;
  exports.MapBoundaryVegetation32 = MapBoundaryVegetation32;
  exports.MapCenter16 = MapCenter16;
  exports.MapCenter20 = MapCenter20;
  exports.MapCenter24 = MapCenter24;
  exports.MapCenter32 = MapCenter32;
  exports.MapIdentify16 = MapIdentify16;
  exports.MapIdentify20 = MapIdentify20;
  exports.MapIdentify24 = MapIdentify24;
  exports.MapIdentify32 = MapIdentify32;
  exports.MarineWarning16 = MarineWarning16;
  exports.MarineWarning20 = MarineWarning20;
  exports.MarineWarning24 = MarineWarning24;
  exports.MarineWarning32 = MarineWarning32;
  exports.MathCurve16 = MathCurve16;
  exports.MathCurve20 = MathCurve20;
  exports.MathCurve24 = MathCurve24;
  exports.MathCurve32 = MathCurve32;
  exports.Maximize16 = Maximize16;
  exports.Maximize20 = Maximize20;
  exports.Maximize24 = Maximize24;
  exports.Maximize32 = Maximize32;
  exports.MediaCast16 = MediaCast16;
  exports.MediaCast20 = MediaCast20;
  exports.MediaCast24 = MediaCast24;
  exports.MediaCast32 = MediaCast32;
  exports.MediaLibrary16 = MediaLibrary16;
  exports.MediaLibrary20 = MediaLibrary20;
  exports.MediaLibrary24 = MediaLibrary24;
  exports.MediaLibrary32 = MediaLibrary32;
  exports.MediaLibraryFilled16 = MediaLibraryFilled16;
  exports.MediaLibraryFilled20 = MediaLibraryFilled20;
  exports.MediaLibraryFilled24 = MediaLibraryFilled24;
  exports.MediaLibraryFilled32 = MediaLibraryFilled32;
  exports.Medication16 = Medication16;
  exports.Medication20 = Medication20;
  exports.Medication24 = Medication24;
  exports.Medication32 = Medication32;
  exports.MedicationAlert16 = MedicationAlert16;
  exports.MedicationAlert20 = MedicationAlert20;
  exports.MedicationAlert24 = MedicationAlert24;
  exports.MedicationAlert32 = MedicationAlert32;
  exports.MedicationReminder16 = MedicationReminder16;
  exports.MedicationReminder20 = MedicationReminder20;
  exports.MedicationReminder24 = MedicationReminder24;
  exports.MedicationReminder32 = MedicationReminder32;
  exports.Menu16 = Menu16;
  exports.Menu20 = Menu20;
  exports.Menu24 = Menu24;
  exports.Menu32 = Menu32;
  exports.MessageQueue16 = MessageQueue16;
  exports.MessageQueue20 = MessageQueue20;
  exports.MessageQueue24 = MessageQueue24;
  exports.MessageQueue32 = MessageQueue32;
  exports.Meter16 = Meter16;
  exports.Meter20 = Meter20;
  exports.Meter24 = Meter24;
  exports.Meter32 = Meter32;
  exports.MeterAlt16 = MeterAlt16;
  exports.MeterAlt20 = MeterAlt20;
  exports.MeterAlt24 = MeterAlt24;
  exports.MeterAlt32 = MeterAlt32;
  exports.Microphone16 = Microphone16;
  exports.Microphone20 = Microphone20;
  exports.Microphone24 = Microphone24;
  exports.Microphone32 = Microphone32;
  exports.MicrophoneFilled16 = MicrophoneFilled16;
  exports.MicrophoneFilled20 = MicrophoneFilled20;
  exports.MicrophoneFilled24 = MicrophoneFilled24;
  exports.MicrophoneFilled32 = MicrophoneFilled32;
  exports.MicrophoneOff16 = MicrophoneOff16;
  exports.MicrophoneOff20 = MicrophoneOff20;
  exports.MicrophoneOff24 = MicrophoneOff24;
  exports.MicrophoneOff32 = MicrophoneOff32;
  exports.MicrophoneOffFilled16 = MicrophoneOffFilled16;
  exports.MicrophoneOffFilled20 = MicrophoneOffFilled20;
  exports.MicrophoneOffFilled24 = MicrophoneOffFilled24;
  exports.MicrophoneOffFilled32 = MicrophoneOffFilled32;
  exports.Microscope16 = Microscope16;
  exports.Microscope20 = Microscope20;
  exports.Microscope24 = Microscope24;
  exports.Microscope32 = Microscope32;
  exports.Migrate16 = Migrate16;
  exports.Migrate20 = Migrate20;
  exports.Migrate24 = Migrate24;
  exports.Migrate32 = Migrate32;
  exports.MigrateAlt16 = MigrateAlt16;
  exports.MigrateAlt20 = MigrateAlt20;
  exports.MigrateAlt24 = MigrateAlt24;
  exports.MigrateAlt32 = MigrateAlt32;
  exports.Milestone16 = Milestone16;
  exports.Milestone20 = Milestone20;
  exports.Milestone24 = Milestone24;
  exports.Milestone32 = Milestone32;
  exports.MilitaryCamp16 = MilitaryCamp16;
  exports.MilitaryCamp20 = MilitaryCamp20;
  exports.MilitaryCamp24 = MilitaryCamp24;
  exports.MilitaryCamp32 = MilitaryCamp32;
  exports.Minimize16 = Minimize16;
  exports.Minimize20 = Minimize20;
  exports.Minimize24 = Minimize24;
  exports.Minimize32 = Minimize32;
  exports.Misuse16 = Misuse16;
  exports.Misuse20 = Misuse20;
  exports.Misuse24 = Misuse24;
  exports.Misuse32 = Misuse32;
  exports.MisuseAlt16 = MisuseAlt16;
  exports.MisuseAlt20 = MisuseAlt20;
  exports.MisuseAlt24 = MisuseAlt24;
  exports.MisuseAlt32 = MisuseAlt32;
  exports.MisuseOutline16 = MisuseOutline16;
  exports.MisuseOutline20 = MisuseOutline20;
  exports.MisuseOutline24 = MisuseOutline24;
  exports.MisuseOutline32 = MisuseOutline32;
  exports.MixedRainHail16 = MixedRainHail16;
  exports.MixedRainHail20 = MixedRainHail20;
  exports.MixedRainHail24 = MixedRainHail24;
  exports.MixedRainHail32 = MixedRainHail32;
  exports.Mobile16 = Mobile16;
  exports.Mobile20 = Mobile20;
  exports.Mobile24 = Mobile24;
  exports.Mobile32 = Mobile32;
  exports.MobileAdd16 = MobileAdd16;
  exports.MobileAdd20 = MobileAdd20;
  exports.MobileAdd24 = MobileAdd24;
  exports.MobileAdd32 = MobileAdd32;
  exports.MobileAudio16 = MobileAudio16;
  exports.MobileAudio20 = MobileAudio20;
  exports.MobileAudio24 = MobileAudio24;
  exports.MobileAudio32 = MobileAudio32;
  exports.MobileCheck16 = MobileCheck16;
  exports.MobileCheck20 = MobileCheck20;
  exports.MobileCheck24 = MobileCheck24;
  exports.MobileCheck32 = MobileCheck32;
  exports.MobileDownload16 = MobileDownload16;
  exports.MobileDownload20 = MobileDownload20;
  exports.MobileDownload24 = MobileDownload24;
  exports.MobileDownload32 = MobileDownload32;
  exports.MobileLandscape16 = MobileLandscape16;
  exports.MobileLandscape20 = MobileLandscape20;
  exports.MobileLandscape24 = MobileLandscape24;
  exports.MobileLandscape32 = MobileLandscape32;
  exports.MobilityServices16 = MobilityServices16;
  exports.MobilityServices20 = MobilityServices20;
  exports.MobilityServices24 = MobilityServices24;
  exports.MobilityServices32 = MobilityServices32;
  exports.Model16 = Model16;
  exports.Model20 = Model20;
  exports.Model24 = Model24;
  exports.Model32 = Model32;
  exports.ModelAlt16 = ModelAlt16;
  exports.ModelAlt20 = ModelAlt20;
  exports.ModelAlt24 = ModelAlt24;
  exports.ModelAlt32 = ModelAlt32;
  exports.ModelBuilder16 = ModelBuilder16;
  exports.ModelBuilder20 = ModelBuilder20;
  exports.ModelBuilder24 = ModelBuilder24;
  exports.ModelBuilder32 = ModelBuilder32;
  exports.ModelBuilderReference16 = ModelBuilderReference16;
  exports.ModelBuilderReference20 = ModelBuilderReference20;
  exports.ModelBuilderReference24 = ModelBuilderReference24;
  exports.ModelBuilderReference32 = ModelBuilderReference32;
  exports.ModelReference16 = ModelReference16;
  exports.ModelReference20 = ModelReference20;
  exports.ModelReference24 = ModelReference24;
  exports.ModelReference32 = ModelReference32;
  exports.Money16 = Money16;
  exports.Money20 = Money20;
  exports.Money24 = Money24;
  exports.Money32 = Money32;
  exports.Monster16 = Monster16;
  exports.Monster20 = Monster20;
  exports.Monster24 = Monster24;
  exports.Monster32 = Monster32;
  exports.Monument16 = Monument16;
  exports.Monument20 = Monument20;
  exports.Monument24 = Monument24;
  exports.Monument32 = Monument32;
  exports.Moon16 = Moon16;
  exports.Moon20 = Moon20;
  exports.Moon24 = Moon24;
  exports.Moon32 = Moon32;
  exports.Moonrise16 = Moonrise16;
  exports.Moonrise20 = Moonrise20;
  exports.Moonrise24 = Moonrise24;
  exports.Moonrise32 = Moonrise32;
  exports.Moonset16 = Moonset16;
  exports.Moonset20 = Moonset20;
  exports.Moonset24 = Moonset24;
  exports.Moonset32 = Moonset32;
  exports.MostlyCloudy16 = MostlyCloudy16;
  exports.MostlyCloudy20 = MostlyCloudy20;
  exports.MostlyCloudy24 = MostlyCloudy24;
  exports.MostlyCloudy32 = MostlyCloudy32;
  exports.MostlyCloudyNight16 = MostlyCloudyNight16;
  exports.MostlyCloudyNight20 = MostlyCloudyNight20;
  exports.MostlyCloudyNight24 = MostlyCloudyNight24;
  exports.MostlyCloudyNight32 = MostlyCloudyNight32;
  exports.Mountain16 = Mountain16;
  exports.Mountain20 = Mountain20;
  exports.Mountain24 = Mountain24;
  exports.Mountain32 = Mountain32;
  exports.Mov16 = Mov16;
  exports.Mov20 = Mov20;
  exports.Mov24 = Mov24;
  exports.Mov32 = Mov32;
  exports.Move16 = Move16;
  exports.Move20 = Move20;
  exports.Move24 = Move24;
  exports.Move32 = Move32;
  exports.Movement16 = Movement16;
  exports.Movement20 = Movement20;
  exports.Movement24 = Movement24;
  exports.Movement32 = Movement32;
  exports.Mp316 = Mp316;
  exports.Mp320 = Mp320;
  exports.Mp324 = Mp324;
  exports.Mp332 = Mp332;
  exports.Mp416 = Mp416;
  exports.Mp420 = Mp420;
  exports.Mp424 = Mp424;
  exports.Mp432 = Mp432;
  exports.Mpeg16 = Mpeg16;
  exports.Mpeg20 = Mpeg20;
  exports.Mpeg24 = Mpeg24;
  exports.Mpeg32 = Mpeg32;
  exports.Mpg216 = Mpg216;
  exports.Mpg220 = Mpg220;
  exports.Mpg224 = Mpg224;
  exports.Mpg232 = Mpg232;
  exports.Music16 = Music16;
  exports.Music20 = Music20;
  exports.Music24 = Music24;
  exports.Music32 = Music32;
  exports.MusicAdd16 = MusicAdd16;
  exports.MusicAdd20 = MusicAdd20;
  exports.MusicAdd24 = MusicAdd24;
  exports.MusicAdd32 = MusicAdd32;
  exports.MusicRemove16 = MusicRemove16;
  exports.MusicRemove20 = MusicRemove20;
  exports.MusicRemove24 = MusicRemove24;
  exports.MusicRemove32 = MusicRemove32;
  exports.NameSpace16 = NameSpace16;
  exports.NameSpace20 = NameSpace20;
  exports.NameSpace24 = NameSpace24;
  exports.NameSpace32 = NameSpace32;
  exports.NavaidCivil16 = NavaidCivil16;
  exports.NavaidCivil20 = NavaidCivil20;
  exports.NavaidCivil24 = NavaidCivil24;
  exports.NavaidCivil32 = NavaidCivil32;
  exports.NavaidDme16 = NavaidDme16;
  exports.NavaidDme20 = NavaidDme20;
  exports.NavaidDme24 = NavaidDme24;
  exports.NavaidDme32 = NavaidDme32;
  exports.NavaidHelipad16 = NavaidHelipad16;
  exports.NavaidHelipad20 = NavaidHelipad20;
  exports.NavaidHelipad24 = NavaidHelipad24;
  exports.NavaidHelipad32 = NavaidHelipad32;
  exports.NavaidMilitary16 = NavaidMilitary16;
  exports.NavaidMilitary20 = NavaidMilitary20;
  exports.NavaidMilitary24 = NavaidMilitary24;
  exports.NavaidMilitary32 = NavaidMilitary32;
  exports.NavaidMilitaryCivil16 = NavaidMilitaryCivil16;
  exports.NavaidMilitaryCivil20 = NavaidMilitaryCivil20;
  exports.NavaidMilitaryCivil24 = NavaidMilitaryCivil24;
  exports.NavaidMilitaryCivil32 = NavaidMilitaryCivil32;
  exports.NavaidNdb16 = NavaidNdb16;
  exports.NavaidNdb20 = NavaidNdb20;
  exports.NavaidNdb24 = NavaidNdb24;
  exports.NavaidNdb32 = NavaidNdb32;
  exports.NavaidNdbDme16 = NavaidNdbDme16;
  exports.NavaidNdbDme20 = NavaidNdbDme20;
  exports.NavaidNdbDme24 = NavaidNdbDme24;
  exports.NavaidNdbDme32 = NavaidNdbDme32;
  exports.NavaidPrivate16 = NavaidPrivate16;
  exports.NavaidPrivate20 = NavaidPrivate20;
  exports.NavaidPrivate24 = NavaidPrivate24;
  exports.NavaidPrivate32 = NavaidPrivate32;
  exports.NavaidSeaplane16 = NavaidSeaplane16;
  exports.NavaidSeaplane20 = NavaidSeaplane20;
  exports.NavaidSeaplane24 = NavaidSeaplane24;
  exports.NavaidSeaplane32 = NavaidSeaplane32;
  exports.NavaidTacan16 = NavaidTacan16;
  exports.NavaidTacan20 = NavaidTacan20;
  exports.NavaidTacan24 = NavaidTacan24;
  exports.NavaidTacan32 = NavaidTacan32;
  exports.NavaidVhfor16 = NavaidVhfor16;
  exports.NavaidVhfor20 = NavaidVhfor20;
  exports.NavaidVhfor24 = NavaidVhfor24;
  exports.NavaidVhfor32 = NavaidVhfor32;
  exports.NavaidVor16 = NavaidVor16;
  exports.NavaidVor20 = NavaidVor20;
  exports.NavaidVor24 = NavaidVor24;
  exports.NavaidVor32 = NavaidVor32;
  exports.NavaidVordme16 = NavaidVordme16;
  exports.NavaidVordme20 = NavaidVordme20;
  exports.NavaidVordme24 = NavaidVordme24;
  exports.NavaidVordme32 = NavaidVordme32;
  exports.NavaidVortac16 = NavaidVortac16;
  exports.NavaidVortac20 = NavaidVortac20;
  exports.NavaidVortac24 = NavaidVortac24;
  exports.NavaidVortac32 = NavaidVortac32;
  exports.Need16 = Need16;
  exports.Need20 = Need20;
  exports.Need24 = Need24;
  exports.Need32 = Need32;
  exports.NetworkAdminControl16 = NetworkAdminControl16;
  exports.NetworkAdminControl20 = NetworkAdminControl20;
  exports.NetworkAdminControl24 = NetworkAdminControl24;
  exports.NetworkAdminControl32 = NetworkAdminControl32;
  exports.NetworkEnterprise16 = NetworkEnterprise16;
  exports.NetworkEnterprise20 = NetworkEnterprise20;
  exports.NetworkEnterprise24 = NetworkEnterprise24;
  exports.NetworkEnterprise32 = NetworkEnterprise32;
  exports.NetworkOverlay16 = NetworkOverlay16;
  exports.NetworkOverlay20 = NetworkOverlay20;
  exports.NetworkOverlay24 = NetworkOverlay24;
  exports.NetworkOverlay32 = NetworkOverlay32;
  exports.NetworkPublic16 = NetworkPublic16;
  exports.NetworkPublic20 = NetworkPublic20;
  exports.NetworkPublic24 = NetworkPublic24;
  exports.NetworkPublic32 = NetworkPublic32;
  exports.Network_116 = Network_116;
  exports.Network_120 = Network_120;
  exports.Network_124 = Network_124;
  exports.Network_132 = Network_132;
  exports.Network_216 = Network_216;
  exports.Network_220 = Network_220;
  exports.Network_224 = Network_224;
  exports.Network_232 = Network_232;
  exports.Network_316 = Network_316;
  exports.Network_320 = Network_320;
  exports.Network_324 = Network_324;
  exports.Network_332 = Network_332;
  exports.Network_3Reference16 = Network_3Reference16;
  exports.Network_3Reference20 = Network_3Reference20;
  exports.Network_3Reference24 = Network_3Reference24;
  exports.Network_3Reference32 = Network_3Reference32;
  exports.Network_416 = Network_416;
  exports.Network_420 = Network_420;
  exports.Network_424 = Network_424;
  exports.Network_432 = Network_432;
  exports.Network_4Reference16 = Network_4Reference16;
  exports.Network_4Reference20 = Network_4Reference20;
  exports.Network_4Reference24 = Network_4Reference24;
  exports.Network_4Reference32 = Network_4Reference32;
  exports.NewTab16 = NewTab16;
  exports.NewTab20 = NewTab20;
  exports.NewTab24 = NewTab24;
  exports.NewTab32 = NewTab32;
  exports.NextFilled16 = NextFilled16;
  exports.NextFilled20 = NextFilled20;
  exports.NextFilled24 = NextFilled24;
  exports.NextFilled32 = NextFilled32;
  exports.NextOutline16 = NextOutline16;
  exports.NextOutline20 = NextOutline20;
  exports.NextOutline24 = NextOutline24;
  exports.NextOutline32 = NextOutline32;
  exports.NoImage16 = NoImage16;
  exports.NoImage20 = NoImage20;
  exports.NoImage24 = NoImage24;
  exports.NoImage32 = NoImage32;
  exports.NoTicket16 = NoTicket16;
  exports.NoTicket20 = NoTicket20;
  exports.NoTicket24 = NoTicket24;
  exports.NoTicket32 = NoTicket32;
  exports.Nominal16 = Nominal16;
  exports.Nominal20 = Nominal20;
  exports.Nominal24 = Nominal24;
  exports.Nominal32 = Nominal32;
  exports.NonCertified16 = NonCertified16;
  exports.NonCertified20 = NonCertified20;
  exports.NonCertified24 = NonCertified24;
  exports.NonCertified32 = NonCertified32;
  exports.NoodleBowl16 = NoodleBowl16;
  exports.NoodleBowl20 = NoodleBowl20;
  exports.NoodleBowl24 = NoodleBowl24;
  exports.NoodleBowl32 = NoodleBowl32;
  exports.NotAvailable16 = NotAvailable16;
  exports.NotAvailable20 = NotAvailable20;
  exports.NotAvailable24 = NotAvailable24;
  exports.NotAvailable32 = NotAvailable32;
  exports.NotSent16 = NotSent16;
  exports.NotSent20 = NotSent20;
  exports.NotSent24 = NotSent24;
  exports.NotSent32 = NotSent32;
  exports.NotSentFilled16 = NotSentFilled16;
  exports.NotSentFilled20 = NotSentFilled20;
  exports.NotSentFilled24 = NotSentFilled24;
  exports.NotSentFilled32 = NotSentFilled32;
  exports.Notebook16 = Notebook16;
  exports.Notebook20 = Notebook20;
  exports.Notebook24 = Notebook24;
  exports.Notebook32 = Notebook32;
  exports.NotebookReference16 = NotebookReference16;
  exports.NotebookReference20 = NotebookReference20;
  exports.NotebookReference24 = NotebookReference24;
  exports.NotebookReference32 = NotebookReference32;
  exports.Notification16 = Notification16;
  exports.Notification20 = Notification20;
  exports.Notification24 = Notification24;
  exports.Notification32 = Notification32;
  exports.NotificationFilled16 = NotificationFilled16;
  exports.NotificationFilled20 = NotificationFilled20;
  exports.NotificationFilled24 = NotificationFilled24;
  exports.NotificationFilled32 = NotificationFilled32;
  exports.NotificationNew16 = NotificationNew16;
  exports.NotificationNew20 = NotificationNew20;
  exports.NotificationNew24 = NotificationNew24;
  exports.NotificationNew32 = NotificationNew32;
  exports.NotificationOff16 = NotificationOff16;
  exports.NotificationOff20 = NotificationOff20;
  exports.NotificationOff24 = NotificationOff24;
  exports.NotificationOff32 = NotificationOff32;
  exports.NotificationOffFilled16 = NotificationOffFilled16;
  exports.NotificationOffFilled20 = NotificationOffFilled20;
  exports.NotificationOffFilled24 = NotificationOffFilled24;
  exports.NotificationOffFilled32 = NotificationOffFilled32;
  exports.NumberSmall_016 = NumberSmall_016;
  exports.NumberSmall_020 = NumberSmall_020;
  exports.NumberSmall_024 = NumberSmall_024;
  exports.NumberSmall_032 = NumberSmall_032;
  exports.NumberSmall_116 = NumberSmall_116;
  exports.NumberSmall_120 = NumberSmall_120;
  exports.NumberSmall_124 = NumberSmall_124;
  exports.NumberSmall_132 = NumberSmall_132;
  exports.NumberSmall_216 = NumberSmall_216;
  exports.NumberSmall_220 = NumberSmall_220;
  exports.NumberSmall_224 = NumberSmall_224;
  exports.NumberSmall_232 = NumberSmall_232;
  exports.NumberSmall_316 = NumberSmall_316;
  exports.NumberSmall_320 = NumberSmall_320;
  exports.NumberSmall_324 = NumberSmall_324;
  exports.NumberSmall_332 = NumberSmall_332;
  exports.NumberSmall_416 = NumberSmall_416;
  exports.NumberSmall_420 = NumberSmall_420;
  exports.NumberSmall_424 = NumberSmall_424;
  exports.NumberSmall_432 = NumberSmall_432;
  exports.NumberSmall_516 = NumberSmall_516;
  exports.NumberSmall_520 = NumberSmall_520;
  exports.NumberSmall_524 = NumberSmall_524;
  exports.NumberSmall_532 = NumberSmall_532;
  exports.NumberSmall_616 = NumberSmall_616;
  exports.NumberSmall_620 = NumberSmall_620;
  exports.NumberSmall_624 = NumberSmall_624;
  exports.NumberSmall_632 = NumberSmall_632;
  exports.NumberSmall_716 = NumberSmall_716;
  exports.NumberSmall_720 = NumberSmall_720;
  exports.NumberSmall_724 = NumberSmall_724;
  exports.NumberSmall_732 = NumberSmall_732;
  exports.NumberSmall_816 = NumberSmall_816;
  exports.NumberSmall_820 = NumberSmall_820;
  exports.NumberSmall_824 = NumberSmall_824;
  exports.NumberSmall_832 = NumberSmall_832;
  exports.NumberSmall_916 = NumberSmall_916;
  exports.NumberSmall_920 = NumberSmall_920;
  exports.NumberSmall_924 = NumberSmall_924;
  exports.NumberSmall_932 = NumberSmall_932;
  exports.Number_016 = Number_016;
  exports.Number_020 = Number_020;
  exports.Number_024 = Number_024;
  exports.Number_032 = Number_032;
  exports.Number_116 = Number_116;
  exports.Number_120 = Number_120;
  exports.Number_124 = Number_124;
  exports.Number_132 = Number_132;
  exports.Number_216 = Number_216;
  exports.Number_220 = Number_220;
  exports.Number_224 = Number_224;
  exports.Number_232 = Number_232;
  exports.Number_316 = Number_316;
  exports.Number_320 = Number_320;
  exports.Number_324 = Number_324;
  exports.Number_332 = Number_332;
  exports.Number_416 = Number_416;
  exports.Number_420 = Number_420;
  exports.Number_424 = Number_424;
  exports.Number_432 = Number_432;
  exports.Number_516 = Number_516;
  exports.Number_520 = Number_520;
  exports.Number_524 = Number_524;
  exports.Number_532 = Number_532;
  exports.Number_616 = Number_616;
  exports.Number_620 = Number_620;
  exports.Number_624 = Number_624;
  exports.Number_632 = Number_632;
  exports.Number_716 = Number_716;
  exports.Number_720 = Number_720;
  exports.Number_724 = Number_724;
  exports.Number_732 = Number_732;
  exports.Number_816 = Number_816;
  exports.Number_820 = Number_820;
  exports.Number_824 = Number_824;
  exports.Number_832 = Number_832;
  exports.Number_916 = Number_916;
  exports.Number_920 = Number_920;
  exports.Number_924 = Number_924;
  exports.Number_932 = Number_932;
  exports.ObjectStorage16 = ObjectStorage16;
  exports.ObjectStorage20 = ObjectStorage20;
  exports.ObjectStorage24 = ObjectStorage24;
  exports.ObjectStorage32 = ObjectStorage32;
  exports.ObjectStorageAlt16 = ObjectStorageAlt16;
  exports.ObjectStorageAlt20 = ObjectStorageAlt20;
  exports.ObjectStorageAlt24 = ObjectStorageAlt24;
  exports.ObjectStorageAlt32 = ObjectStorageAlt32;
  exports.ObservedHail16 = ObservedHail16;
  exports.ObservedHail20 = ObservedHail20;
  exports.ObservedHail24 = ObservedHail24;
  exports.ObservedHail32 = ObservedHail32;
  exports.ObservedLightning16 = ObservedLightning16;
  exports.ObservedLightning20 = ObservedLightning20;
  exports.ObservedLightning24 = ObservedLightning24;
  exports.ObservedLightning32 = ObservedLightning32;
  exports.Omega16 = Omega16;
  exports.Omega20 = Omega20;
  exports.Omega24 = Omega24;
  exports.Omega32 = Omega32;
  exports.Opacity16 = Opacity16;
  exports.Opacity20 = Opacity20;
  exports.Opacity24 = Opacity24;
  exports.Opacity32 = Opacity32;
  exports.OpenPanelBottom16 = OpenPanelBottom16;
  exports.OpenPanelBottom20 = OpenPanelBottom20;
  exports.OpenPanelBottom24 = OpenPanelBottom24;
  exports.OpenPanelBottom32 = OpenPanelBottom32;
  exports.OpenPanelFilledBottom16 = OpenPanelFilledBottom16;
  exports.OpenPanelFilledBottom20 = OpenPanelFilledBottom20;
  exports.OpenPanelFilledBottom24 = OpenPanelFilledBottom24;
  exports.OpenPanelFilledBottom32 = OpenPanelFilledBottom32;
  exports.OpenPanelFilledLeft16 = OpenPanelFilledLeft16;
  exports.OpenPanelFilledLeft20 = OpenPanelFilledLeft20;
  exports.OpenPanelFilledLeft24 = OpenPanelFilledLeft24;
  exports.OpenPanelFilledLeft32 = OpenPanelFilledLeft32;
  exports.OpenPanelFilledRight16 = OpenPanelFilledRight16;
  exports.OpenPanelFilledRight20 = OpenPanelFilledRight20;
  exports.OpenPanelFilledRight24 = OpenPanelFilledRight24;
  exports.OpenPanelFilledRight32 = OpenPanelFilledRight32;
  exports.OpenPanelFilledTop16 = OpenPanelFilledTop16;
  exports.OpenPanelFilledTop20 = OpenPanelFilledTop20;
  exports.OpenPanelFilledTop24 = OpenPanelFilledTop24;
  exports.OpenPanelFilledTop32 = OpenPanelFilledTop32;
  exports.OpenPanelLeft16 = OpenPanelLeft16;
  exports.OpenPanelLeft20 = OpenPanelLeft20;
  exports.OpenPanelLeft24 = OpenPanelLeft24;
  exports.OpenPanelLeft32 = OpenPanelLeft32;
  exports.OpenPanelRight16 = OpenPanelRight16;
  exports.OpenPanelRight20 = OpenPanelRight20;
  exports.OpenPanelRight24 = OpenPanelRight24;
  exports.OpenPanelRight32 = OpenPanelRight32;
  exports.OpenPanelTop16 = OpenPanelTop16;
  exports.OpenPanelTop20 = OpenPanelTop20;
  exports.OpenPanelTop24 = OpenPanelTop24;
  exports.OpenPanelTop32 = OpenPanelTop32;
  exports.OperationsField16 = OperationsField16;
  exports.OperationsField20 = OperationsField20;
  exports.OperationsField24 = OperationsField24;
  exports.OperationsField32 = OperationsField32;
  exports.OperationsRecord16 = OperationsRecord16;
  exports.OperationsRecord20 = OperationsRecord20;
  exports.OperationsRecord24 = OperationsRecord24;
  exports.OperationsRecord32 = OperationsRecord32;
  exports.OrderDetails16 = OrderDetails16;
  exports.OrderDetails20 = OrderDetails20;
  exports.OrderDetails24 = OrderDetails24;
  exports.OrderDetails32 = OrderDetails32;
  exports.Ordinal16 = Ordinal16;
  exports.Ordinal20 = Ordinal20;
  exports.Ordinal24 = Ordinal24;
  exports.Ordinal32 = Ordinal32;
  exports.Outage16 = Outage16;
  exports.Outage20 = Outage20;
  exports.Outage24 = Outage24;
  exports.Outage32 = Outage32;
  exports.OutlookSevere16 = OutlookSevere16;
  exports.OutlookSevere20 = OutlookSevere20;
  exports.OutlookSevere24 = OutlookSevere24;
  exports.OutlookSevere32 = OutlookSevere32;
  exports.OverflowMenuHorizontal16 = OverflowMenuHorizontal16;
  exports.OverflowMenuHorizontal20 = OverflowMenuHorizontal20;
  exports.OverflowMenuHorizontal24 = OverflowMenuHorizontal24;
  exports.OverflowMenuHorizontal32 = OverflowMenuHorizontal32;
  exports.OverflowMenuVertical16 = OverflowMenuVertical16;
  exports.OverflowMenuVertical20 = OverflowMenuVertical20;
  exports.OverflowMenuVertical24 = OverflowMenuVertical24;
  exports.OverflowMenuVertical32 = OverflowMenuVertical32;
  exports.Overlay16 = Overlay16;
  exports.Overlay20 = Overlay20;
  exports.Overlay24 = Overlay24;
  exports.Overlay32 = Overlay32;
  exports.Package16 = Package16;
  exports.Package20 = Package20;
  exports.Package24 = Package24;
  exports.Package32 = Package32;
  exports.PageBreak16 = PageBreak16;
  exports.PageBreak20 = PageBreak20;
  exports.PageBreak24 = PageBreak24;
  exports.PageBreak32 = PageBreak32;
  exports.PageFirst16 = PageFirst16;
  exports.PageFirst20 = PageFirst20;
  exports.PageFirst24 = PageFirst24;
  exports.PageFirst32 = PageFirst32;
  exports.PageLast16 = PageLast16;
  exports.PageLast20 = PageLast20;
  exports.PageLast24 = PageLast24;
  exports.PageLast32 = PageLast32;
  exports.PageNumber16 = PageNumber16;
  exports.PageNumber20 = PageNumber20;
  exports.PageNumber24 = PageNumber24;
  exports.PageNumber32 = PageNumber32;
  exports.PaintBrush16 = PaintBrush16;
  exports.PaintBrush20 = PaintBrush20;
  exports.PaintBrush24 = PaintBrush24;
  exports.PaintBrush32 = PaintBrush32;
  exports.PaintBrushAlt16 = PaintBrushAlt16;
  exports.PaintBrushAlt20 = PaintBrushAlt20;
  exports.PaintBrushAlt24 = PaintBrushAlt24;
  exports.PaintBrushAlt32 = PaintBrushAlt32;
  exports.PalmTree16 = PalmTree16;
  exports.PalmTree20 = PalmTree20;
  exports.PalmTree24 = PalmTree24;
  exports.PalmTree32 = PalmTree32;
  exports.PanHorizontal16 = PanHorizontal16;
  exports.PanHorizontal20 = PanHorizontal20;
  exports.PanHorizontal24 = PanHorizontal24;
  exports.PanHorizontal32 = PanHorizontal32;
  exports.PanVertical16 = PanVertical16;
  exports.PanVertical20 = PanVertical20;
  exports.PanVertical24 = PanVertical24;
  exports.PanVertical32 = PanVertical32;
  exports.PanelExpansion16 = PanelExpansion16;
  exports.PanelExpansion20 = PanelExpansion20;
  exports.PanelExpansion24 = PanelExpansion24;
  exports.PanelExpansion32 = PanelExpansion32;
  exports.Paragraph16 = Paragraph16;
  exports.Paragraph20 = Paragraph20;
  exports.Paragraph24 = Paragraph24;
  exports.Paragraph32 = Paragraph32;
  exports.Parameter16 = Parameter16;
  exports.Parameter20 = Parameter20;
  exports.Parameter24 = Parameter24;
  exports.Parameter32 = Parameter32;
  exports.ParentChild16 = ParentChild16;
  exports.ParentChild20 = ParentChild20;
  exports.ParentChild24 = ParentChild24;
  exports.ParentChild32 = ParentChild32;
  exports.PartlyCloudy16 = PartlyCloudy16;
  exports.PartlyCloudy20 = PartlyCloudy20;
  exports.PartlyCloudy24 = PartlyCloudy24;
  exports.PartlyCloudy32 = PartlyCloudy32;
  exports.PartlyCloudyNight16 = PartlyCloudyNight16;
  exports.PartlyCloudyNight20 = PartlyCloudyNight20;
  exports.PartlyCloudyNight24 = PartlyCloudyNight24;
  exports.PartlyCloudyNight32 = PartlyCloudyNight32;
  exports.Partnership16 = Partnership16;
  exports.Partnership20 = Partnership20;
  exports.Partnership24 = Partnership24;
  exports.Partnership32 = Partnership32;
  exports.PassengerDrinks16 = PassengerDrinks16;
  exports.PassengerDrinks20 = PassengerDrinks20;
  exports.PassengerDrinks24 = PassengerDrinks24;
  exports.PassengerDrinks32 = PassengerDrinks32;
  exports.PassengerPlus16 = PassengerPlus16;
  exports.PassengerPlus20 = PassengerPlus20;
  exports.PassengerPlus24 = PassengerPlus24;
  exports.PassengerPlus32 = PassengerPlus32;
  exports.Password16 = Password16;
  exports.Password20 = Password20;
  exports.Password24 = Password24;
  exports.Password32 = Password32;
  exports.Paste16 = Paste16;
  exports.Paste20 = Paste20;
  exports.Paste24 = Paste24;
  exports.Paste32 = Paste32;
  exports.Pause16 = Pause16;
  exports.Pause20 = Pause20;
  exports.Pause24 = Pause24;
  exports.Pause32 = Pause32;
  exports.PauseFilled16 = PauseFilled16;
  exports.PauseFilled20 = PauseFilled20;
  exports.PauseFilled24 = PauseFilled24;
  exports.PauseFilled32 = PauseFilled32;
  exports.PauseFuture16 = PauseFuture16;
  exports.PauseFuture20 = PauseFuture20;
  exports.PauseFuture24 = PauseFuture24;
  exports.PauseFuture32 = PauseFuture32;
  exports.PauseOutline16 = PauseOutline16;
  exports.PauseOutline20 = PauseOutline20;
  exports.PauseOutline24 = PauseOutline24;
  exports.PauseOutline32 = PauseOutline32;
  exports.PauseOutlineFilled16 = PauseOutlineFilled16;
  exports.PauseOutlineFilled20 = PauseOutlineFilled20;
  exports.PauseOutlineFilled24 = PauseOutlineFilled24;
  exports.PauseOutlineFilled32 = PauseOutlineFilled32;
  exports.PausePast16 = PausePast16;
  exports.PausePast20 = PausePast20;
  exports.PausePast24 = PausePast24;
  exports.PausePast32 = PausePast32;
  exports.PcnENode16 = PcnENode16;
  exports.PcnENode20 = PcnENode20;
  exports.PcnENode24 = PcnENode24;
  exports.PcnENode32 = PcnENode32;
  exports.PcnMilitary16 = PcnMilitary16;
  exports.PcnMilitary20 = PcnMilitary20;
  exports.PcnMilitary24 = PcnMilitary24;
  exports.PcnMilitary32 = PcnMilitary32;
  exports.PcnPNode16 = PcnPNode16;
  exports.PcnPNode20 = PcnPNode20;
  exports.PcnPNode24 = PcnPNode24;
  exports.PcnPNode32 = PcnPNode32;
  exports.PcnZNode16 = PcnZNode16;
  exports.PcnZNode20 = PcnZNode20;
  exports.PcnZNode24 = PcnZNode24;
  exports.PcnZNode32 = PcnZNode32;
  exports.Pdf16 = Pdf16;
  exports.Pdf20 = Pdf20;
  exports.Pdf24 = Pdf24;
  exports.Pdf32 = Pdf32;
  exports.PdfReference16 = PdfReference16;
  exports.PdfReference20 = PdfReference20;
  exports.PdfReference24 = PdfReference24;
  exports.PdfReference32 = PdfReference32;
  exports.Pedestrian16 = Pedestrian16;
  exports.Pedestrian20 = Pedestrian20;
  exports.Pedestrian24 = Pedestrian24;
  exports.Pedestrian32 = Pedestrian32;
  exports.PedestrianChild16 = PedestrianChild16;
  exports.PedestrianChild20 = PedestrianChild20;
  exports.PedestrianChild24 = PedestrianChild24;
  exports.PedestrianChild32 = PedestrianChild32;
  exports.PedestrianFamily16 = PedestrianFamily16;
  exports.PedestrianFamily20 = PedestrianFamily20;
  exports.PedestrianFamily24 = PedestrianFamily24;
  exports.PedestrianFamily32 = PedestrianFamily32;
  exports.Pen16 = Pen16;
  exports.Pen20 = Pen20;
  exports.Pen24 = Pen24;
  exports.Pen32 = Pen32;
  exports.PenFountain16 = PenFountain16;
  exports.PenFountain20 = PenFountain20;
  exports.PenFountain24 = PenFountain24;
  exports.PenFountain32 = PenFountain32;
  exports.Pending16 = Pending16;
  exports.Pending20 = Pending20;
  exports.Pending24 = Pending24;
  exports.Pending32 = Pending32;
  exports.PendingFilled16 = PendingFilled16;
  exports.PendingFilled20 = PendingFilled20;
  exports.PendingFilled24 = PendingFilled24;
  exports.PendingFilled32 = PendingFilled32;
  exports.Percentage16 = Percentage16;
  exports.Percentage20 = Percentage20;
  exports.Percentage24 = Percentage24;
  exports.Percentage32 = Percentage32;
  exports.PercentageFilled16 = PercentageFilled16;
  exports.PercentageFilled20 = PercentageFilled20;
  exports.PercentageFilled24 = PercentageFilled24;
  exports.PercentageFilled32 = PercentageFilled32;
  exports.Person16 = Person16;
  exports.Person20 = Person20;
  exports.Person24 = Person24;
  exports.Person32 = Person32;
  exports.PersonFavorite16 = PersonFavorite16;
  exports.PersonFavorite20 = PersonFavorite20;
  exports.PersonFavorite24 = PersonFavorite24;
  exports.PersonFavorite32 = PersonFavorite32;
  exports.Pest16 = Pest16;
  exports.Pest20 = Pest20;
  exports.Pest24 = Pest24;
  exports.Pest32 = Pest32;
  exports.Phone16 = Phone16;
  exports.Phone20 = Phone20;
  exports.Phone24 = Phone24;
  exports.Phone32 = Phone32;
  exports.PhoneApplication16 = PhoneApplication16;
  exports.PhoneApplication20 = PhoneApplication20;
  exports.PhoneApplication24 = PhoneApplication24;
  exports.PhoneApplication32 = PhoneApplication32;
  exports.PhoneBlock16 = PhoneBlock16;
  exports.PhoneBlock20 = PhoneBlock20;
  exports.PhoneBlock24 = PhoneBlock24;
  exports.PhoneBlock32 = PhoneBlock32;
  exports.PhoneBlockFilled16 = PhoneBlockFilled16;
  exports.PhoneBlockFilled20 = PhoneBlockFilled20;
  exports.PhoneBlockFilled24 = PhoneBlockFilled24;
  exports.PhoneBlockFilled32 = PhoneBlockFilled32;
  exports.PhoneFilled16 = PhoneFilled16;
  exports.PhoneFilled20 = PhoneFilled20;
  exports.PhoneFilled24 = PhoneFilled24;
  exports.PhoneFilled32 = PhoneFilled32;
  exports.PhoneIncoming16 = PhoneIncoming16;
  exports.PhoneIncoming20 = PhoneIncoming20;
  exports.PhoneIncoming24 = PhoneIncoming24;
  exports.PhoneIncoming32 = PhoneIncoming32;
  exports.PhoneIncomingFilled16 = PhoneIncomingFilled16;
  exports.PhoneIncomingFilled20 = PhoneIncomingFilled20;
  exports.PhoneIncomingFilled24 = PhoneIncomingFilled24;
  exports.PhoneIncomingFilled32 = PhoneIncomingFilled32;
  exports.PhoneIp16 = PhoneIp16;
  exports.PhoneIp20 = PhoneIp20;
  exports.PhoneIp24 = PhoneIp24;
  exports.PhoneIp32 = PhoneIp32;
  exports.PhoneOff16 = PhoneOff16;
  exports.PhoneOff20 = PhoneOff20;
  exports.PhoneOff24 = PhoneOff24;
  exports.PhoneOff32 = PhoneOff32;
  exports.PhoneOffFilled16 = PhoneOffFilled16;
  exports.PhoneOffFilled20 = PhoneOffFilled20;
  exports.PhoneOffFilled24 = PhoneOffFilled24;
  exports.PhoneOffFilled32 = PhoneOffFilled32;
  exports.PhoneOutgoing16 = PhoneOutgoing16;
  exports.PhoneOutgoing20 = PhoneOutgoing20;
  exports.PhoneOutgoing24 = PhoneOutgoing24;
  exports.PhoneOutgoing32 = PhoneOutgoing32;
  exports.PhoneOutgoingFilled16 = PhoneOutgoingFilled16;
  exports.PhoneOutgoingFilled20 = PhoneOutgoingFilled20;
  exports.PhoneOutgoingFilled24 = PhoneOutgoingFilled24;
  exports.PhoneOutgoingFilled32 = PhoneOutgoingFilled32;
  exports.PhoneSettings16 = PhoneSettings16;
  exports.PhoneSettings20 = PhoneSettings20;
  exports.PhoneSettings24 = PhoneSettings24;
  exports.PhoneSettings32 = PhoneSettings32;
  exports.PhoneVoice16 = PhoneVoice16;
  exports.PhoneVoice20 = PhoneVoice20;
  exports.PhoneVoice24 = PhoneVoice24;
  exports.PhoneVoice32 = PhoneVoice32;
  exports.PhoneVoiceFilled16 = PhoneVoiceFilled16;
  exports.PhoneVoiceFilled20 = PhoneVoiceFilled20;
  exports.PhoneVoiceFilled24 = PhoneVoiceFilled24;
  exports.PhoneVoiceFilled32 = PhoneVoiceFilled32;
  exports.PhraseSentiment16 = PhraseSentiment16;
  exports.PhraseSentiment20 = PhraseSentiment20;
  exports.PhraseSentiment24 = PhraseSentiment24;
  exports.PhraseSentiment32 = PhraseSentiment32;
  exports.PicnicArea16 = PicnicArea16;
  exports.PicnicArea20 = PicnicArea20;
  exports.PicnicArea24 = PicnicArea24;
  exports.PicnicArea32 = PicnicArea32;
  exports.PiggyBank16 = PiggyBank16;
  exports.PiggyBank20 = PiggyBank20;
  exports.PiggyBank24 = PiggyBank24;
  exports.PiggyBank32 = PiggyBank32;
  exports.PiggyBankSlot16 = PiggyBankSlot16;
  exports.PiggyBankSlot20 = PiggyBankSlot20;
  exports.PiggyBankSlot24 = PiggyBankSlot24;
  exports.PiggyBankSlot32 = PiggyBankSlot32;
  exports.Pills16 = Pills16;
  exports.Pills20 = Pills20;
  exports.Pills24 = Pills24;
  exports.Pills32 = Pills32;
  exports.PillsAdd16 = PillsAdd16;
  exports.PillsAdd20 = PillsAdd20;
  exports.PillsAdd24 = PillsAdd24;
  exports.PillsAdd32 = PillsAdd32;
  exports.PillsSubtract16 = PillsSubtract16;
  exports.PillsSubtract20 = PillsSubtract20;
  exports.PillsSubtract24 = PillsSubtract24;
  exports.PillsSubtract32 = PillsSubtract32;
  exports.Pin16 = Pin16;
  exports.Pin20 = Pin20;
  exports.Pin24 = Pin24;
  exports.Pin32 = Pin32;
  exports.PinFilled16 = PinFilled16;
  exports.PinFilled20 = PinFilled20;
  exports.PinFilled24 = PinFilled24;
  exports.PinFilled32 = PinFilled32;
  exports.Plane16 = Plane16;
  exports.Plane20 = Plane20;
  exports.Plane24 = Plane24;
  exports.Plane32 = Plane32;
  exports.PlanePrivate16 = PlanePrivate16;
  exports.PlanePrivate20 = PlanePrivate20;
  exports.PlanePrivate24 = PlanePrivate24;
  exports.PlanePrivate32 = PlanePrivate32;
  exports.PlaneSea16 = PlaneSea16;
  exports.PlaneSea20 = PlaneSea20;
  exports.PlaneSea24 = PlaneSea24;
  exports.PlaneSea32 = PlaneSea32;
  exports.Play16 = Play16;
  exports.Play20 = Play20;
  exports.Play24 = Play24;
  exports.Play32 = Play32;
  exports.PlayFilled16 = PlayFilled16;
  exports.PlayFilled20 = PlayFilled20;
  exports.PlayFilled24 = PlayFilled24;
  exports.PlayFilled32 = PlayFilled32;
  exports.PlayFilledAlt16 = PlayFilledAlt16;
  exports.PlayFilledAlt20 = PlayFilledAlt20;
  exports.PlayFilledAlt24 = PlayFilledAlt24;
  exports.PlayFilledAlt32 = PlayFilledAlt32;
  exports.PlayOutline16 = PlayOutline16;
  exports.PlayOutline20 = PlayOutline20;
  exports.PlayOutline24 = PlayOutline24;
  exports.PlayOutline32 = PlayOutline32;
  exports.PlayOutlineFilled16 = PlayOutlineFilled16;
  exports.PlayOutlineFilled20 = PlayOutlineFilled20;
  exports.PlayOutlineFilled24 = PlayOutlineFilled24;
  exports.PlayOutlineFilled32 = PlayOutlineFilled32;
  exports.Playlist16 = Playlist16;
  exports.Playlist20 = Playlist20;
  exports.Playlist24 = Playlist24;
  exports.Playlist32 = Playlist32;
  exports.Plug16 = Plug16;
  exports.Plug20 = Plug20;
  exports.Plug24 = Plug24;
  exports.Plug32 = Plug32;
  exports.PlugFilled16 = PlugFilled16;
  exports.PlugFilled20 = PlugFilled20;
  exports.PlugFilled24 = PlugFilled24;
  exports.PlugFilled32 = PlugFilled32;
  exports.Png16 = Png16;
  exports.Png20 = Png20;
  exports.Png24 = Png24;
  exports.Png32 = Png32;
  exports.PointOfPresence16 = PointOfPresence16;
  exports.PointOfPresence20 = PointOfPresence20;
  exports.PointOfPresence24 = PointOfPresence24;
  exports.PointOfPresence32 = PointOfPresence32;
  exports.Police16 = Police16;
  exports.Police20 = Police20;
  exports.Police24 = Police24;
  exports.Police32 = Police32;
  exports.Policy16 = Policy16;
  exports.Policy20 = Policy20;
  exports.Policy24 = Policy24;
  exports.Policy32 = Policy32;
  exports.Popup16 = Popup16;
  exports.Popup20 = Popup20;
  exports.Popup24 = Popup24;
  exports.Popup32 = Popup32;
  exports.Portfolio16 = Portfolio16;
  exports.Portfolio20 = Portfolio20;
  exports.Portfolio24 = Portfolio24;
  exports.Portfolio32 = Portfolio32;
  exports.Power16 = Power16;
  exports.Power20 = Power20;
  exports.Power24 = Power24;
  exports.Power32 = Power32;
  exports.Ppt16 = Ppt16;
  exports.Ppt20 = Ppt20;
  exports.Ppt24 = Ppt24;
  exports.Ppt32 = Ppt32;
  exports.PresentationFile16 = PresentationFile16;
  exports.PresentationFile20 = PresentationFile20;
  exports.PresentationFile24 = PresentationFile24;
  exports.PresentationFile32 = PresentationFile32;
  exports.Pressure16 = Pressure16;
  exports.Pressure20 = Pressure20;
  exports.Pressure24 = Pressure24;
  exports.Pressure32 = Pressure32;
  exports.PressureFilled16 = PressureFilled16;
  exports.PressureFilled20 = PressureFilled20;
  exports.PressureFilled24 = PressureFilled24;
  exports.PressureFilled32 = PressureFilled32;
  exports.PreviousFilled16 = PreviousFilled16;
  exports.PreviousFilled20 = PreviousFilled20;
  exports.PreviousFilled24 = PreviousFilled24;
  exports.PreviousFilled32 = PreviousFilled32;
  exports.PreviousOutline16 = PreviousOutline16;
  exports.PreviousOutline20 = PreviousOutline20;
  exports.PreviousOutline24 = PreviousOutline24;
  exports.PreviousOutline32 = PreviousOutline32;
  exports.Printer16 = Printer16;
  exports.Printer20 = Printer20;
  exports.Printer24 = Printer24;
  exports.Printer32 = Printer32;
  exports.Product16 = Product16;
  exports.Product20 = Product20;
  exports.Product24 = Product24;
  exports.Product32 = Product32;
  exports.ProgressBar16 = ProgressBar16;
  exports.ProgressBar20 = ProgressBar20;
  exports.ProgressBar24 = ProgressBar24;
  exports.ProgressBar32 = ProgressBar32;
  exports.ProgressBarRound16 = ProgressBarRound16;
  exports.ProgressBarRound20 = ProgressBarRound20;
  exports.ProgressBarRound24 = ProgressBarRound24;
  exports.ProgressBarRound32 = ProgressBarRound32;
  exports.Purchase16 = Purchase16;
  exports.Purchase20 = Purchase20;
  exports.Purchase24 = Purchase24;
  exports.Purchase32 = Purchase32;
  exports.QBarrier16 = QBarrier16;
  exports.QBarrier20 = QBarrier20;
  exports.QBarrier24 = QBarrier24;
  exports.QBarrier32 = QBarrier32;
  exports.QBlochSphere16 = QBlochSphere16;
  exports.QBlochSphere20 = QBlochSphere20;
  exports.QBlochSphere24 = QBlochSphere24;
  exports.QBlochSphere32 = QBlochSphere32;
  exports.QCU116 = QCU116;
  exports.QCU120 = QCU120;
  exports.QCU124 = QCU124;
  exports.QCU132 = QCU132;
  exports.QCU316 = QCU316;
  exports.QCU320 = QCU320;
  exports.QCU324 = QCU324;
  exports.QCU332 = QCU332;
  exports.QCY16 = QCY16;
  exports.QCY20 = QCY20;
  exports.QCY24 = QCY24;
  exports.QCY32 = QCY32;
  exports.QCZ16 = QCZ16;
  exports.QCZ20 = QCZ20;
  exports.QCZ24 = QCZ24;
  exports.QCZ32 = QCZ32;
  exports.QCcX16 = QCcX16;
  exports.QCcX20 = QCcX20;
  exports.QCcX24 = QCcX24;
  exports.QCcX32 = QCcX32;
  exports.QCircuitComposer16 = QCircuitComposer16;
  exports.QCircuitComposer20 = QCircuitComposer20;
  exports.QCircuitComposer24 = QCircuitComposer24;
  exports.QCircuitComposer32 = QCircuitComposer32;
  exports.QComposerEdit16 = QComposerEdit16;
  exports.QComposerEdit20 = QComposerEdit20;
  exports.QComposerEdit24 = QComposerEdit24;
  exports.QComposerEdit32 = QComposerEdit32;
  exports.QH16 = QH16;
  exports.QH20 = QH20;
  exports.QH24 = QH24;
  exports.QH32 = QH32;
  exports.QHintonPlot16 = QHintonPlot16;
  exports.QHintonPlot20 = QHintonPlot20;
  exports.QHintonPlot24 = QHintonPlot24;
  exports.QHintonPlot32 = QHintonPlot32;
  exports.QID16 = QID16;
  exports.QID20 = QID20;
  exports.QID24 = QID24;
  exports.QID32 = QID32;
  exports.QMatrix16 = QMatrix16;
  exports.QMatrix20 = QMatrix20;
  exports.QMatrix24 = QMatrix24;
  exports.QMatrix32 = QMatrix32;
  exports.QOperation16 = QOperation16;
  exports.QOperation20 = QOperation20;
  exports.QOperation24 = QOperation24;
  exports.QOperation32 = QOperation32;
  exports.QOperationGauge16 = QOperationGauge16;
  exports.QOperationGauge20 = QOperationGauge20;
  exports.QOperationGauge24 = QOperationGauge24;
  exports.QOperationGauge32 = QOperationGauge32;
  exports.QOperationIf16 = QOperationIf16;
  exports.QOperationIf20 = QOperationIf20;
  exports.QOperationIf24 = QOperationIf24;
  exports.QOperationIf32 = QOperationIf32;
  exports.QS16 = QS16;
  exports.QS20 = QS20;
  exports.QS24 = QS24;
  exports.QS32 = QS32;
  exports.QSAlt16 = QSAlt16;
  exports.QSAlt20 = QSAlt20;
  exports.QSAlt24 = QSAlt24;
  exports.QSAlt32 = QSAlt32;
  exports.QT16 = QT16;
  exports.QT20 = QT20;
  exports.QT24 = QT24;
  exports.QT32 = QT32;
  exports.QTAlt16 = QTAlt16;
  exports.QTAlt20 = QTAlt20;
  exports.QTAlt24 = QTAlt24;
  exports.QTAlt32 = QTAlt32;
  exports.QU116 = QU116;
  exports.QU120 = QU120;
  exports.QU124 = QU124;
  exports.QU132 = QU132;
  exports.QU216 = QU216;
  exports.QU220 = QU220;
  exports.QU224 = QU224;
  exports.QU232 = QU232;
  exports.QU316 = QU316;
  exports.QU320 = QU320;
  exports.QU324 = QU324;
  exports.QU332 = QU332;
  exports.QX16 = QX16;
  exports.QX20 = QX20;
  exports.QX24 = QX24;
  exports.QX32 = QX32;
  exports.QY16 = QY16;
  exports.QY20 = QY20;
  exports.QY24 = QY24;
  exports.QY32 = QY32;
  exports.QZ16 = QZ16;
  exports.QZ20 = QZ20;
  exports.QZ24 = QZ24;
  exports.QZ32 = QZ32;
  exports.QqPlot16 = QqPlot16;
  exports.QqPlot20 = QqPlot20;
  exports.QqPlot24 = QqPlot24;
  exports.QqPlot32 = QqPlot32;
  exports.QrCode16 = QrCode16;
  exports.QrCode20 = QrCode20;
  exports.QrCode24 = QrCode24;
  exports.QrCode32 = QrCode32;
  exports.QuadrantPlot16 = QuadrantPlot16;
  exports.QuadrantPlot20 = QuadrantPlot20;
  exports.QuadrantPlot24 = QuadrantPlot24;
  exports.QuadrantPlot32 = QuadrantPlot32;
  exports.Query16 = Query16;
  exports.Query20 = Query20;
  exports.Query24 = Query24;
  exports.Query32 = Query32;
  exports.QueryQueue16 = QueryQueue16;
  exports.QueryQueue20 = QueryQueue20;
  exports.QueryQueue24 = QueryQueue24;
  exports.QueryQueue32 = QueryQueue32;
  exports.Queued16 = Queued16;
  exports.Queued20 = Queued20;
  exports.Queued24 = Queued24;
  exports.Queued32 = Queued32;
  exports.Quotes16 = Quotes16;
  exports.Quotes20 = Quotes20;
  exports.Quotes24 = Quotes24;
  exports.Quotes32 = Quotes32;
  exports.Radar16 = Radar16;
  exports.Radar20 = Radar20;
  exports.Radar24 = Radar24;
  exports.Radar32 = Radar32;
  exports.RadarEnhanced16 = RadarEnhanced16;
  exports.RadarEnhanced20 = RadarEnhanced20;
  exports.RadarEnhanced24 = RadarEnhanced24;
  exports.RadarEnhanced32 = RadarEnhanced32;
  exports.RadarWeather16 = RadarWeather16;
  exports.RadarWeather20 = RadarWeather20;
  exports.RadarWeather24 = RadarWeather24;
  exports.RadarWeather32 = RadarWeather32;
  exports.Radio16 = Radio16;
  exports.Radio20 = Radio20;
  exports.Radio24 = Radio24;
  exports.Radio32 = Radio32;
  exports.RadioButton16 = RadioButton16;
  exports.RadioButton20 = RadioButton20;
  exports.RadioButton24 = RadioButton24;
  exports.RadioButton32 = RadioButton32;
  exports.RadioButtonChecked16 = RadioButtonChecked16;
  exports.RadioButtonChecked20 = RadioButtonChecked20;
  exports.RadioButtonChecked24 = RadioButtonChecked24;
  exports.RadioButtonChecked32 = RadioButtonChecked32;
  exports.RadioCombat16 = RadioCombat16;
  exports.RadioCombat20 = RadioCombat20;
  exports.RadioCombat24 = RadioCombat24;
  exports.RadioCombat32 = RadioCombat32;
  exports.RadioPushToTalk16 = RadioPushToTalk16;
  exports.RadioPushToTalk20 = RadioPushToTalk20;
  exports.RadioPushToTalk24 = RadioPushToTalk24;
  exports.RadioPushToTalk32 = RadioPushToTalk32;
  exports.Rain16 = Rain16;
  exports.Rain20 = Rain20;
  exports.Rain24 = Rain24;
  exports.Rain32 = Rain32;
  exports.RainDrizzle16 = RainDrizzle16;
  exports.RainDrizzle20 = RainDrizzle20;
  exports.RainDrizzle24 = RainDrizzle24;
  exports.RainDrizzle32 = RainDrizzle32;
  exports.RainDrop16 = RainDrop16;
  exports.RainDrop20 = RainDrop20;
  exports.RainDrop24 = RainDrop24;
  exports.RainDrop32 = RainDrop32;
  exports.RainHeavy16 = RainHeavy16;
  exports.RainHeavy20 = RainHeavy20;
  exports.RainHeavy24 = RainHeavy24;
  exports.RainHeavy32 = RainHeavy32;
  exports.RainScattered16 = RainScattered16;
  exports.RainScattered20 = RainScattered20;
  exports.RainScattered24 = RainScattered24;
  exports.RainScattered32 = RainScattered32;
  exports.RainScatteredNight16 = RainScatteredNight16;
  exports.RainScatteredNight20 = RainScatteredNight20;
  exports.RainScatteredNight24 = RainScatteredNight24;
  exports.RainScatteredNight32 = RainScatteredNight32;
  exports.Raw16 = Raw16;
  exports.Raw20 = Raw20;
  exports.Raw24 = Raw24;
  exports.Raw32 = Raw32;
  exports.Receipt16 = Receipt16;
  exports.Receipt20 = Receipt20;
  exports.Receipt24 = Receipt24;
  exports.Receipt32 = Receipt32;
  exports.RecentlyViewed16 = RecentlyViewed16;
  exports.RecentlyViewed20 = RecentlyViewed20;
  exports.RecentlyViewed24 = RecentlyViewed24;
  exports.RecentlyViewed32 = RecentlyViewed32;
  exports.Recommend16 = Recommend16;
  exports.Recommend20 = Recommend20;
  exports.Recommend24 = Recommend24;
  exports.Recommend32 = Recommend32;
  exports.Recording16 = Recording16;
  exports.Recording20 = Recording20;
  exports.Recording24 = Recording24;
  exports.Recording32 = Recording32;
  exports.RecordingFilled16 = RecordingFilled16;
  exports.RecordingFilled20 = RecordingFilled20;
  exports.RecordingFilled24 = RecordingFilled24;
  exports.RecordingFilled32 = RecordingFilled32;
  exports.RecordingFilledAlt16 = RecordingFilledAlt16;
  exports.RecordingFilledAlt20 = RecordingFilledAlt20;
  exports.RecordingFilledAlt24 = RecordingFilledAlt24;
  exports.RecordingFilledAlt32 = RecordingFilledAlt32;
  exports.Redo16 = Redo16;
  exports.Redo20 = Redo20;
  exports.Redo24 = Redo24;
  exports.Redo32 = Redo32;
  exports.RefEvapotranspiration16 = RefEvapotranspiration16;
  exports.RefEvapotranspiration20 = RefEvapotranspiration20;
  exports.RefEvapotranspiration24 = RefEvapotranspiration24;
  exports.RefEvapotranspiration32 = RefEvapotranspiration32;
  exports.ReflectHorizontal16 = ReflectHorizontal16;
  exports.ReflectHorizontal20 = ReflectHorizontal20;
  exports.ReflectHorizontal24 = ReflectHorizontal24;
  exports.ReflectHorizontal32 = ReflectHorizontal32;
  exports.ReflectVertical16 = ReflectVertical16;
  exports.ReflectVertical20 = ReflectVertical20;
  exports.ReflectVertical24 = ReflectVertical24;
  exports.ReflectVertical32 = ReflectVertical32;
  exports.Reminder16 = Reminder16;
  exports.Reminder20 = Reminder20;
  exports.Reminder24 = Reminder24;
  exports.Reminder32 = Reminder32;
  exports.ReminderMedical16 = ReminderMedical16;
  exports.ReminderMedical20 = ReminderMedical20;
  exports.ReminderMedical24 = ReminderMedical24;
  exports.ReminderMedical32 = ReminderMedical32;
  exports.Renew16 = Renew16;
  exports.Renew20 = Renew20;
  exports.Renew24 = Renew24;
  exports.Renew32 = Renew32;
  exports.Repeat16 = Repeat16;
  exports.Repeat20 = Repeat20;
  exports.Repeat24 = Repeat24;
  exports.Repeat32 = Repeat32;
  exports.RepeatOne16 = RepeatOne16;
  exports.RepeatOne20 = RepeatOne20;
  exports.RepeatOne24 = RepeatOne24;
  exports.RepeatOne32 = RepeatOne32;
  exports.Replicate16 = Replicate16;
  exports.Replicate20 = Replicate20;
  exports.Replicate24 = Replicate24;
  exports.Replicate32 = Replicate32;
  exports.Reply16 = Reply16;
  exports.Reply20 = Reply20;
  exports.Reply24 = Reply24;
  exports.Reply32 = Reply32;
  exports.ReplyAll16 = ReplyAll16;
  exports.ReplyAll20 = ReplyAll20;
  exports.ReplyAll24 = ReplyAll24;
  exports.ReplyAll32 = ReplyAll32;
  exports.Report16 = Report16;
  exports.Report20 = Report20;
  exports.Report24 = Report24;
  exports.Report32 = Report32;
  exports.ReportData16 = ReportData16;
  exports.ReportData20 = ReportData20;
  exports.ReportData24 = ReportData24;
  exports.ReportData32 = ReportData32;
  exports.RequestQuote16 = RequestQuote16;
  exports.RequestQuote20 = RequestQuote20;
  exports.RequestQuote24 = RequestQuote24;
  exports.RequestQuote32 = RequestQuote32;
  exports.ResearchBlochSphere16 = ResearchBlochSphere16;
  exports.ResearchBlochSphere20 = ResearchBlochSphere20;
  exports.ResearchBlochSphere24 = ResearchBlochSphere24;
  exports.ResearchBlochSphere32 = ResearchBlochSphere32;
  exports.ResearchHintonPlot16 = ResearchHintonPlot16;
  exports.ResearchHintonPlot20 = ResearchHintonPlot20;
  exports.ResearchHintonPlot24 = ResearchHintonPlot24;
  exports.ResearchHintonPlot32 = ResearchHintonPlot32;
  exports.ResearchMatrix16 = ResearchMatrix16;
  exports.ResearchMatrix20 = ResearchMatrix20;
  exports.ResearchMatrix24 = ResearchMatrix24;
  exports.ResearchMatrix32 = ResearchMatrix32;
  exports.Reset16 = Reset16;
  exports.Reset20 = Reset20;
  exports.Reset24 = Reset24;
  exports.Reset32 = Reset32;
  exports.ResetAlt16 = ResetAlt16;
  exports.ResetAlt20 = ResetAlt20;
  exports.ResetAlt24 = ResetAlt24;
  exports.ResetAlt32 = ResetAlt32;
  exports.Restart16 = Restart16;
  exports.Restart20 = Restart20;
  exports.Restart24 = Restart24;
  exports.Restart32 = Restart32;
  exports.Restaurant16 = Restaurant16;
  exports.Restaurant20 = Restaurant20;
  exports.Restaurant24 = Restaurant24;
  exports.Restaurant32 = Restaurant32;
  exports.RestaurantFine16 = RestaurantFine16;
  exports.RestaurantFine20 = RestaurantFine20;
  exports.RestaurantFine24 = RestaurantFine24;
  exports.RestaurantFine32 = RestaurantFine32;
  exports.Result16 = Result16;
  exports.Result20 = Result20;
  exports.Result24 = Result24;
  exports.Result32 = Result32;
  exports.ResultNew16 = ResultNew16;
  exports.ResultNew20 = ResultNew20;
  exports.ResultNew24 = ResultNew24;
  exports.ResultNew32 = ResultNew32;
  exports.ResultOld16 = ResultOld16;
  exports.ResultOld20 = ResultOld20;
  exports.ResultOld24 = ResultOld24;
  exports.ResultOld32 = ResultOld32;
  exports.RetryFailed16 = RetryFailed16;
  exports.RetryFailed20 = RetryFailed20;
  exports.RetryFailed24 = RetryFailed24;
  exports.RetryFailed32 = RetryFailed32;
  exports.Review16 = Review16;
  exports.Review20 = Review20;
  exports.Review24 = Review24;
  exports.Review32 = Review32;
  exports.Rewind_1016 = Rewind_1016;
  exports.Rewind_1020 = Rewind_1020;
  exports.Rewind_1024 = Rewind_1024;
  exports.Rewind_1032 = Rewind_1032;
  exports.Rewind_3016 = Rewind_3016;
  exports.Rewind_3020 = Rewind_3020;
  exports.Rewind_3024 = Rewind_3024;
  exports.Rewind_3032 = Rewind_3032;
  exports.Rewind_516 = Rewind_516;
  exports.Rewind_520 = Rewind_520;
  exports.Rewind_524 = Rewind_524;
  exports.Rewind_532 = Rewind_532;
  exports.Road16 = Road16;
  exports.Road20 = Road20;
  exports.Road24 = Road24;
  exports.Road32 = Road32;
  exports.RoadWeather16 = RoadWeather16;
  exports.RoadWeather20 = RoadWeather20;
  exports.RoadWeather24 = RoadWeather24;
  exports.RoadWeather32 = RoadWeather32;
  exports.Roadmap16 = Roadmap16;
  exports.Roadmap20 = Roadmap20;
  exports.Roadmap24 = Roadmap24;
  exports.Roadmap32 = Roadmap32;
  exports.Rocket16 = Rocket16;
  exports.Rocket20 = Rocket20;
  exports.Rocket24 = Rocket24;
  exports.Rocket32 = Rocket32;
  exports.Rotate16 = Rotate16;
  exports.Rotate20 = Rotate20;
  exports.Rotate24 = Rotate24;
  exports.Rotate32 = Rotate32;
  exports.RotateClockwise16 = RotateClockwise16;
  exports.RotateClockwise20 = RotateClockwise20;
  exports.RotateClockwise24 = RotateClockwise24;
  exports.RotateClockwise32 = RotateClockwise32;
  exports.RotateClockwiseAlt16 = RotateClockwiseAlt16;
  exports.RotateClockwiseAlt20 = RotateClockwiseAlt20;
  exports.RotateClockwiseAlt24 = RotateClockwiseAlt24;
  exports.RotateClockwiseAlt32 = RotateClockwiseAlt32;
  exports.RotateClockwiseAltFilled16 = RotateClockwiseAltFilled16;
  exports.RotateClockwiseAltFilled20 = RotateClockwiseAltFilled20;
  exports.RotateClockwiseAltFilled24 = RotateClockwiseAltFilled24;
  exports.RotateClockwiseAltFilled32 = RotateClockwiseAltFilled32;
  exports.RotateClockwiseFilled16 = RotateClockwiseFilled16;
  exports.RotateClockwiseFilled20 = RotateClockwiseFilled20;
  exports.RotateClockwiseFilled24 = RotateClockwiseFilled24;
  exports.RotateClockwiseFilled32 = RotateClockwiseFilled32;
  exports.RotateCounterclockwise16 = RotateCounterclockwise16;
  exports.RotateCounterclockwise20 = RotateCounterclockwise20;
  exports.RotateCounterclockwise24 = RotateCounterclockwise24;
  exports.RotateCounterclockwise32 = RotateCounterclockwise32;
  exports.RotateCounterclockwiseAlt16 = RotateCounterclockwiseAlt16;
  exports.RotateCounterclockwiseAlt20 = RotateCounterclockwiseAlt20;
  exports.RotateCounterclockwiseAlt24 = RotateCounterclockwiseAlt24;
  exports.RotateCounterclockwiseAlt32 = RotateCounterclockwiseAlt32;
  exports.RotateCounterclockwiseAltFilled16 = RotateCounterclockwiseAltFilled16;
  exports.RotateCounterclockwiseAltFilled20 = RotateCounterclockwiseAltFilled20;
  exports.RotateCounterclockwiseAltFilled24 = RotateCounterclockwiseAltFilled24;
  exports.RotateCounterclockwiseAltFilled32 = RotateCounterclockwiseAltFilled32;
  exports.RotateCounterclockwiseFilled16 = RotateCounterclockwiseFilled16;
  exports.RotateCounterclockwiseFilled20 = RotateCounterclockwiseFilled20;
  exports.RotateCounterclockwiseFilled24 = RotateCounterclockwiseFilled24;
  exports.RotateCounterclockwiseFilled32 = RotateCounterclockwiseFilled32;
  exports.Router16 = Router16;
  exports.Router20 = Router20;
  exports.Router24 = Router24;
  exports.Router32 = Router32;
  exports.RouterVoice16 = RouterVoice16;
  exports.RouterVoice20 = RouterVoice20;
  exports.RouterVoice24 = RouterVoice24;
  exports.RouterVoice32 = RouterVoice32;
  exports.RouterWifi16 = RouterWifi16;
  exports.RouterWifi20 = RouterWifi20;
  exports.RouterWifi24 = RouterWifi24;
  exports.RouterWifi32 = RouterWifi32;
  exports.Row16 = Row16;
  exports.Row20 = Row20;
  exports.Row24 = Row24;
  exports.Row32 = Row32;
  exports.RowCollapse16 = RowCollapse16;
  exports.RowCollapse20 = RowCollapse20;
  exports.RowCollapse24 = RowCollapse24;
  exports.RowCollapse32 = RowCollapse32;
  exports.RowDelete16 = RowDelete16;
  exports.RowDelete20 = RowDelete20;
  exports.RowDelete24 = RowDelete24;
  exports.RowDelete32 = RowDelete32;
  exports.RowExpand16 = RowExpand16;
  exports.RowExpand20 = RowExpand20;
  exports.RowExpand24 = RowExpand24;
  exports.RowExpand32 = RowExpand32;
  exports.RowInsert16 = RowInsert16;
  exports.RowInsert20 = RowInsert20;
  exports.RowInsert24 = RowInsert24;
  exports.RowInsert32 = RowInsert32;
  exports.Rss16 = Rss16;
  exports.Rss20 = Rss20;
  exports.Rss24 = Rss24;
  exports.Rss32 = Rss32;
  exports.Rule16 = Rule16;
  exports.Rule20 = Rule20;
  exports.Rule24 = Rule24;
  exports.Rule32 = Rule32;
  exports.RuleCancelled16 = RuleCancelled16;
  exports.RuleCancelled20 = RuleCancelled20;
  exports.RuleCancelled24 = RuleCancelled24;
  exports.RuleCancelled32 = RuleCancelled32;
  exports.RuleDraft16 = RuleDraft16;
  exports.RuleDraft20 = RuleDraft20;
  exports.RuleDraft24 = RuleDraft24;
  exports.RuleDraft32 = RuleDraft32;
  exports.RuleFilled16 = RuleFilled16;
  exports.RuleFilled20 = RuleFilled20;
  exports.RuleFilled24 = RuleFilled24;
  exports.RuleFilled32 = RuleFilled32;
  exports.RuleTest16 = RuleTest16;
  exports.RuleTest20 = RuleTest20;
  exports.RuleTest24 = RuleTest24;
  exports.RuleTest32 = RuleTest32;
  exports.Ruler16 = Ruler16;
  exports.Ruler20 = Ruler20;
  exports.Ruler24 = Ruler24;
  exports.Ruler32 = Ruler32;
  exports.RulerAlt16 = RulerAlt16;
  exports.RulerAlt20 = RulerAlt20;
  exports.RulerAlt24 = RulerAlt24;
  exports.RulerAlt32 = RulerAlt32;
  exports.Run16 = Run16;
  exports.Run20 = Run20;
  exports.Run24 = Run24;
  exports.Run32 = Run32;
  exports.SailboatCoastal16 = SailboatCoastal16;
  exports.SailboatCoastal20 = SailboatCoastal20;
  exports.SailboatCoastal24 = SailboatCoastal24;
  exports.SailboatCoastal32 = SailboatCoastal32;
  exports.SailboatOffshore16 = SailboatOffshore16;
  exports.SailboatOffshore20 = SailboatOffshore20;
  exports.SailboatOffshore24 = SailboatOffshore24;
  exports.SailboatOffshore32 = SailboatOffshore32;
  exports.SankeyDiagram16 = SankeyDiagram16;
  exports.SankeyDiagram20 = SankeyDiagram20;
  exports.SankeyDiagram24 = SankeyDiagram24;
  exports.SankeyDiagram32 = SankeyDiagram32;
  exports.SankeyDiagramAlt16 = SankeyDiagramAlt16;
  exports.SankeyDiagramAlt20 = SankeyDiagramAlt20;
  exports.SankeyDiagramAlt24 = SankeyDiagramAlt24;
  exports.SankeyDiagramAlt32 = SankeyDiagramAlt32;
  exports.Satellite16 = Satellite16;
  exports.Satellite20 = Satellite20;
  exports.Satellite24 = Satellite24;
  exports.Satellite32 = Satellite32;
  exports.SatelliteRadar16 = SatelliteRadar16;
  exports.SatelliteRadar20 = SatelliteRadar20;
  exports.SatelliteRadar24 = SatelliteRadar24;
  exports.SatelliteRadar32 = SatelliteRadar32;
  exports.SatelliteWeather16 = SatelliteWeather16;
  exports.SatelliteWeather20 = SatelliteWeather20;
  exports.SatelliteWeather24 = SatelliteWeather24;
  exports.SatelliteWeather32 = SatelliteWeather32;
  exports.Save16 = Save16;
  exports.Save20 = Save20;
  exports.Save24 = Save24;
  exports.Save32 = Save32;
  exports.SaveModel16 = SaveModel16;
  exports.SaveModel20 = SaveModel20;
  exports.SaveModel24 = SaveModel24;
  exports.SaveModel32 = SaveModel32;
  exports.Scale16 = Scale16;
  exports.Scale20 = Scale20;
  exports.Scale24 = Scale24;
  exports.Scale32 = Scale32;
  exports.Scales16 = Scales16;
  exports.Scales20 = Scales20;
  exports.Scales24 = Scales24;
  exports.Scales32 = Scales32;
  exports.ScalesTipped16 = ScalesTipped16;
  exports.ScalesTipped20 = ScalesTipped20;
  exports.ScalesTipped24 = ScalesTipped24;
  exports.ScalesTipped32 = ScalesTipped32;
  exports.Scalpel16 = Scalpel16;
  exports.Scalpel20 = Scalpel20;
  exports.Scalpel24 = Scalpel24;
  exports.Scalpel32 = Scalpel32;
  exports.Scan16 = Scan16;
  exports.Scan20 = Scan20;
  exports.Scan24 = Scan24;
  exports.Scan32 = Scan32;
  exports.ScanAlt16 = ScanAlt16;
  exports.ScanAlt20 = ScanAlt20;
  exports.ScanAlt24 = ScanAlt24;
  exports.ScanAlt32 = ScanAlt32;
  exports.ScanDisabled16 = ScanDisabled16;
  exports.ScanDisabled20 = ScanDisabled20;
  exports.ScanDisabled24 = ScanDisabled24;
  exports.ScanDisabled32 = ScanDisabled32;
  exports.ScatterMatrix16 = ScatterMatrix16;
  exports.ScatterMatrix20 = ScatterMatrix20;
  exports.ScatterMatrix24 = ScatterMatrix24;
  exports.ScatterMatrix32 = ScatterMatrix32;
  exports.Schematics16 = Schematics16;
  exports.Schematics20 = Schematics20;
  exports.Schematics24 = Schematics24;
  exports.Schematics32 = Schematics32;
  exports.Scooter16 = Scooter16;
  exports.Scooter20 = Scooter20;
  exports.Scooter24 = Scooter24;
  exports.Scooter32 = Scooter32;
  exports.ScooterFront16 = ScooterFront16;
  exports.ScooterFront20 = ScooterFront20;
  exports.ScooterFront24 = ScooterFront24;
  exports.ScooterFront32 = ScooterFront32;
  exports.Screen16 = Screen16;
  exports.Screen20 = Screen20;
  exports.Screen24 = Screen24;
  exports.Screen32 = Screen32;
  exports.ScreenOff16 = ScreenOff16;
  exports.ScreenOff20 = ScreenOff20;
  exports.ScreenOff24 = ScreenOff24;
  exports.ScreenOff32 = ScreenOff32;
  exports.Script16 = Script16;
  exports.Script20 = Script20;
  exports.Script24 = Script24;
  exports.Script32 = Script32;
  exports.ScriptReference16 = ScriptReference16;
  exports.ScriptReference20 = ScriptReference20;
  exports.ScriptReference24 = ScriptReference24;
  exports.ScriptReference32 = ScriptReference32;
  exports.Sdk16 = Sdk16;
  exports.Sdk20 = Sdk20;
  exports.Sdk24 = Sdk24;
  exports.Sdk32 = Sdk32;
  exports.Search16 = Search16;
  exports.Search20 = Search20;
  exports.Search24 = Search24;
  exports.Search32 = Search32;
  exports.SearchAdvanced16 = SearchAdvanced16;
  exports.SearchAdvanced20 = SearchAdvanced20;
  exports.SearchAdvanced24 = SearchAdvanced24;
  exports.SearchAdvanced32 = SearchAdvanced32;
  exports.SearchLocate16 = SearchLocate16;
  exports.SearchLocate20 = SearchLocate20;
  exports.SearchLocate24 = SearchLocate24;
  exports.SearchLocate32 = SearchLocate32;
  exports.Security16 = Security16;
  exports.Security20 = Security20;
  exports.Security24 = Security24;
  exports.Security32 = Security32;
  exports.SecurityServices16 = SecurityServices16;
  exports.SecurityServices20 = SecurityServices20;
  exports.SecurityServices24 = SecurityServices24;
  exports.SecurityServices32 = SecurityServices32;
  exports.SelectWindow16 = SelectWindow16;
  exports.SelectWindow20 = SelectWindow20;
  exports.SelectWindow24 = SelectWindow24;
  exports.SelectWindow32 = SelectWindow32;
  exports.Select_0116 = Select_0116;
  exports.Select_0120 = Select_0120;
  exports.Select_0124 = Select_0124;
  exports.Select_0132 = Select_0132;
  exports.Select_0216 = Select_0216;
  exports.Select_0220 = Select_0220;
  exports.Select_0224 = Select_0224;
  exports.Select_0232 = Select_0232;
  exports.Send16 = Send16;
  exports.Send20 = Send20;
  exports.Send24 = Send24;
  exports.Send32 = Send32;
  exports.SendAlt16 = SendAlt16;
  exports.SendAlt20 = SendAlt20;
  exports.SendAlt24 = SendAlt24;
  exports.SendAlt32 = SendAlt32;
  exports.SendAltFilled16 = SendAltFilled16;
  exports.SendAltFilled20 = SendAltFilled20;
  exports.SendAltFilled24 = SendAltFilled24;
  exports.SendAltFilled32 = SendAltFilled32;
  exports.SendBackward16 = SendBackward16;
  exports.SendBackward20 = SendBackward20;
  exports.SendBackward24 = SendBackward24;
  exports.SendBackward32 = SendBackward32;
  exports.SendFilled16 = SendFilled16;
  exports.SendFilled20 = SendFilled20;
  exports.SendFilled24 = SendFilled24;
  exports.SendFilled32 = SendFilled32;
  exports.SendToBack16 = SendToBack16;
  exports.SendToBack20 = SendToBack20;
  exports.SendToBack24 = SendToBack24;
  exports.SendToBack32 = SendToBack32;
  exports.ServerDns16 = ServerDns16;
  exports.ServerDns20 = ServerDns20;
  exports.ServerDns24 = ServerDns24;
  exports.ServerDns32 = ServerDns32;
  exports.ServerProxy16 = ServerProxy16;
  exports.ServerProxy20 = ServerProxy20;
  exports.ServerProxy24 = ServerProxy24;
  exports.ServerProxy32 = ServerProxy32;
  exports.ServerTime16 = ServerTime16;
  exports.ServerTime20 = ServerTime20;
  exports.ServerTime24 = ServerTime24;
  exports.ServerTime32 = ServerTime32;
  exports.ServiceDesk16 = ServiceDesk16;
  exports.ServiceDesk20 = ServiceDesk20;
  exports.ServiceDesk24 = ServiceDesk24;
  exports.ServiceDesk32 = ServiceDesk32;
  exports.SessionBorderControl16 = SessionBorderControl16;
  exports.SessionBorderControl20 = SessionBorderControl20;
  exports.SessionBorderControl24 = SessionBorderControl24;
  exports.SessionBorderControl32 = SessionBorderControl32;
  exports.Settings16 = Settings16;
  exports.Settings20 = Settings20;
  exports.Settings24 = Settings24;
  exports.Settings32 = Settings32;
  exports.SettingsAdjust16 = SettingsAdjust16;
  exports.SettingsAdjust20 = SettingsAdjust20;
  exports.SettingsAdjust24 = SettingsAdjust24;
  exports.SettingsAdjust32 = SettingsAdjust32;
  exports.SettingsCheck16 = SettingsCheck16;
  exports.SettingsCheck20 = SettingsCheck20;
  exports.SettingsCheck24 = SettingsCheck24;
  exports.SettingsCheck32 = SettingsCheck32;
  exports.SettingsServices16 = SettingsServices16;
  exports.SettingsServices20 = SettingsServices20;
  exports.SettingsServices24 = SettingsServices24;
  exports.SettingsServices32 = SettingsServices32;
  exports.SettingsView16 = SettingsView16;
  exports.SettingsView20 = SettingsView20;
  exports.SettingsView24 = SettingsView24;
  exports.SettingsView32 = SettingsView32;
  exports.ShapeExcept16 = ShapeExcept16;
  exports.ShapeExcept20 = ShapeExcept20;
  exports.ShapeExcept24 = ShapeExcept24;
  exports.ShapeExcept32 = ShapeExcept32;
  exports.ShapeExclude16 = ShapeExclude16;
  exports.ShapeExclude20 = ShapeExclude20;
  exports.ShapeExclude24 = ShapeExclude24;
  exports.ShapeExclude32 = ShapeExclude32;
  exports.ShapeIntersect16 = ShapeIntersect16;
  exports.ShapeIntersect20 = ShapeIntersect20;
  exports.ShapeIntersect24 = ShapeIntersect24;
  exports.ShapeIntersect32 = ShapeIntersect32;
  exports.ShapeJoin16 = ShapeJoin16;
  exports.ShapeJoin20 = ShapeJoin20;
  exports.ShapeJoin24 = ShapeJoin24;
  exports.ShapeJoin32 = ShapeJoin32;
  exports.ShapeUnite16 = ShapeUnite16;
  exports.ShapeUnite20 = ShapeUnite20;
  exports.ShapeUnite24 = ShapeUnite24;
  exports.ShapeUnite32 = ShapeUnite32;
  exports.Share16 = Share16;
  exports.Share20 = Share20;
  exports.Share24 = Share24;
  exports.Share32 = Share32;
  exports.ShareKnowledge16 = ShareKnowledge16;
  exports.ShareKnowledge20 = ShareKnowledge20;
  exports.ShareKnowledge24 = ShareKnowledge24;
  exports.ShareKnowledge32 = ShareKnowledge32;
  exports.ShoppingBag16 = ShoppingBag16;
  exports.ShoppingBag20 = ShoppingBag20;
  exports.ShoppingBag24 = ShoppingBag24;
  exports.ShoppingBag32 = ShoppingBag32;
  exports.ShoppingCart16 = ShoppingCart16;
  exports.ShoppingCart20 = ShoppingCart20;
  exports.ShoppingCart24 = ShoppingCart24;
  exports.ShoppingCart32 = ShoppingCart32;
  exports.ShoppingCartArrowDown16 = ShoppingCartArrowDown16;
  exports.ShoppingCartArrowDown20 = ShoppingCartArrowDown20;
  exports.ShoppingCartArrowDown24 = ShoppingCartArrowDown24;
  exports.ShoppingCartArrowDown32 = ShoppingCartArrowDown32;
  exports.ShoppingCartArrowUp16 = ShoppingCartArrowUp16;
  exports.ShoppingCartArrowUp20 = ShoppingCartArrowUp20;
  exports.ShoppingCartArrowUp24 = ShoppingCartArrowUp24;
  exports.ShoppingCartArrowUp32 = ShoppingCartArrowUp32;
  exports.ShoppingCartClear16 = ShoppingCartClear16;
  exports.ShoppingCartClear20 = ShoppingCartClear20;
  exports.ShoppingCartClear24 = ShoppingCartClear24;
  exports.ShoppingCartClear32 = ShoppingCartClear32;
  exports.ShoppingCartError16 = ShoppingCartError16;
  exports.ShoppingCartError20 = ShoppingCartError20;
  exports.ShoppingCartError24 = ShoppingCartError24;
  exports.ShoppingCartError32 = ShoppingCartError32;
  exports.ShoppingCartMinus16 = ShoppingCartMinus16;
  exports.ShoppingCartMinus20 = ShoppingCartMinus20;
  exports.ShoppingCartMinus24 = ShoppingCartMinus24;
  exports.ShoppingCartMinus32 = ShoppingCartMinus32;
  exports.ShoppingCartPlus16 = ShoppingCartPlus16;
  exports.ShoppingCartPlus20 = ShoppingCartPlus20;
  exports.ShoppingCartPlus24 = ShoppingCartPlus24;
  exports.ShoppingCartPlus32 = ShoppingCartPlus32;
  exports.ShoppingCatalog16 = ShoppingCatalog16;
  exports.ShoppingCatalog20 = ShoppingCatalog20;
  exports.ShoppingCatalog24 = ShoppingCatalog24;
  exports.ShoppingCatalog32 = ShoppingCatalog32;
  exports.ShowDataCards16 = ShowDataCards16;
  exports.ShowDataCards20 = ShowDataCards20;
  exports.ShowDataCards24 = ShowDataCards24;
  exports.ShowDataCards32 = ShowDataCards32;
  exports.ShrinkScreen16 = ShrinkScreen16;
  exports.ShrinkScreen20 = ShrinkScreen20;
  exports.ShrinkScreen24 = ShrinkScreen24;
  exports.ShrinkScreen32 = ShrinkScreen32;
  exports.ShrinkScreenFilled16 = ShrinkScreenFilled16;
  exports.ShrinkScreenFilled20 = ShrinkScreenFilled20;
  exports.ShrinkScreenFilled24 = ShrinkScreenFilled24;
  exports.ShrinkScreenFilled32 = ShrinkScreenFilled32;
  exports.Shuffle16 = Shuffle16;
  exports.Shuffle20 = Shuffle20;
  exports.Shuffle24 = Shuffle24;
  exports.Shuffle32 = Shuffle32;
  exports.Shuttle16 = Shuttle16;
  exports.Shuttle20 = Shuttle20;
  exports.Shuttle24 = Shuttle24;
  exports.Shuttle32 = Shuttle32;
  exports.Sight16 = Sight16;
  exports.Sight20 = Sight20;
  exports.Sight24 = Sight24;
  exports.Sight32 = Sight32;
  exports.Sigma16 = Sigma16;
  exports.Sigma20 = Sigma20;
  exports.Sigma24 = Sigma24;
  exports.Sigma32 = Sigma32;
  exports.SignalStrength16 = SignalStrength16;
  exports.SignalStrength20 = SignalStrength20;
  exports.SignalStrength24 = SignalStrength24;
  exports.SignalStrength32 = SignalStrength32;
  exports.SimCard16 = SimCard16;
  exports.SimCard20 = SimCard20;
  exports.SimCard24 = SimCard24;
  exports.SimCard32 = SimCard32;
  exports.SkillLevel16 = SkillLevel16;
  exports.SkillLevel20 = SkillLevel20;
  exports.SkillLevel24 = SkillLevel24;
  exports.SkillLevel32 = SkillLevel32;
  exports.SkillLevelAdvanced16 = SkillLevelAdvanced16;
  exports.SkillLevelAdvanced20 = SkillLevelAdvanced20;
  exports.SkillLevelAdvanced24 = SkillLevelAdvanced24;
  exports.SkillLevelAdvanced32 = SkillLevelAdvanced32;
  exports.SkillLevelBasic16 = SkillLevelBasic16;
  exports.SkillLevelBasic20 = SkillLevelBasic20;
  exports.SkillLevelBasic24 = SkillLevelBasic24;
  exports.SkillLevelBasic32 = SkillLevelBasic32;
  exports.SkillLevelIntermediate16 = SkillLevelIntermediate16;
  exports.SkillLevelIntermediate20 = SkillLevelIntermediate20;
  exports.SkillLevelIntermediate24 = SkillLevelIntermediate24;
  exports.SkillLevelIntermediate32 = SkillLevelIntermediate32;
  exports.SkipBack16 = SkipBack16;
  exports.SkipBack20 = SkipBack20;
  exports.SkipBack24 = SkipBack24;
  exports.SkipBack32 = SkipBack32;
  exports.SkipBackFilled16 = SkipBackFilled16;
  exports.SkipBackFilled20 = SkipBackFilled20;
  exports.SkipBackFilled24 = SkipBackFilled24;
  exports.SkipBackFilled32 = SkipBackFilled32;
  exports.SkipBackOutline16 = SkipBackOutline16;
  exports.SkipBackOutline20 = SkipBackOutline20;
  exports.SkipBackOutline24 = SkipBackOutline24;
  exports.SkipBackOutline32 = SkipBackOutline32;
  exports.SkipBackOutlineFilled16 = SkipBackOutlineFilled16;
  exports.SkipBackOutlineFilled20 = SkipBackOutlineFilled20;
  exports.SkipBackOutlineFilled24 = SkipBackOutlineFilled24;
  exports.SkipBackOutlineFilled32 = SkipBackOutlineFilled32;
  exports.SkipBackOutlineSolid16 = SkipBackOutlineSolid16;
  exports.SkipBackOutlineSolid20 = SkipBackOutlineSolid20;
  exports.SkipBackOutlineSolid24 = SkipBackOutlineSolid24;
  exports.SkipBackOutlineSolid32 = SkipBackOutlineSolid32;
  exports.SkipBackSolidFilled16 = SkipBackSolidFilled16;
  exports.SkipBackSolidFilled20 = SkipBackSolidFilled20;
  exports.SkipBackSolidFilled24 = SkipBackSolidFilled24;
  exports.SkipBackSolidFilled32 = SkipBackSolidFilled32;
  exports.SkipForward16 = SkipForward16;
  exports.SkipForward20 = SkipForward20;
  exports.SkipForward24 = SkipForward24;
  exports.SkipForward32 = SkipForward32;
  exports.SkipForwardFilled16 = SkipForwardFilled16;
  exports.SkipForwardFilled20 = SkipForwardFilled20;
  exports.SkipForwardFilled24 = SkipForwardFilled24;
  exports.SkipForwardFilled32 = SkipForwardFilled32;
  exports.SkipForwardOutline16 = SkipForwardOutline16;
  exports.SkipForwardOutline20 = SkipForwardOutline20;
  exports.SkipForwardOutline24 = SkipForwardOutline24;
  exports.SkipForwardOutline32 = SkipForwardOutline32;
  exports.SkipForwardOutlineFilled16 = SkipForwardOutlineFilled16;
  exports.SkipForwardOutlineFilled20 = SkipForwardOutlineFilled20;
  exports.SkipForwardOutlineFilled24 = SkipForwardOutlineFilled24;
  exports.SkipForwardOutlineFilled32 = SkipForwardOutlineFilled32;
  exports.SkipForwardOutlineSolid16 = SkipForwardOutlineSolid16;
  exports.SkipForwardOutlineSolid20 = SkipForwardOutlineSolid20;
  exports.SkipForwardOutlineSolid24 = SkipForwardOutlineSolid24;
  exports.SkipForwardOutlineSolid32 = SkipForwardOutlineSolid32;
  exports.SkipForwardSolidFilled16 = SkipForwardSolidFilled16;
  exports.SkipForwardSolidFilled20 = SkipForwardSolidFilled20;
  exports.SkipForwardSolidFilled24 = SkipForwardSolidFilled24;
  exports.SkipForwardSolidFilled32 = SkipForwardSolidFilled32;
  exports.Sleet16 = Sleet16;
  exports.Sleet20 = Sleet20;
  exports.Sleet24 = Sleet24;
  exports.Sleet32 = Sleet32;
  exports.Slisor16 = Slisor16;
  exports.Slisor20 = Slisor20;
  exports.Slisor24 = Slisor24;
  exports.Slisor32 = Slisor32;
  exports.Smell16 = Smell16;
  exports.Smell20 = Smell20;
  exports.Smell24 = Smell24;
  exports.Smell32 = Smell32;
  exports.Smoke16 = Smoke16;
  exports.Smoke20 = Smoke20;
  exports.Smoke24 = Smoke24;
  exports.Smoke32 = Smoke32;
  exports.Snooze16 = Snooze16;
  exports.Snooze20 = Snooze20;
  exports.Snooze24 = Snooze24;
  exports.Snooze32 = Snooze32;
  exports.Snow16 = Snow16;
  exports.Snow20 = Snow20;
  exports.Snow24 = Snow24;
  exports.Snow32 = Snow32;
  exports.SnowBlizzard16 = SnowBlizzard16;
  exports.SnowBlizzard20 = SnowBlizzard20;
  exports.SnowBlizzard24 = SnowBlizzard24;
  exports.SnowBlizzard32 = SnowBlizzard32;
  exports.SnowDensity16 = SnowDensity16;
  exports.SnowDensity20 = SnowDensity20;
  exports.SnowDensity24 = SnowDensity24;
  exports.SnowDensity32 = SnowDensity32;
  exports.SnowHeavy16 = SnowHeavy16;
  exports.SnowHeavy20 = SnowHeavy20;
  exports.SnowHeavy24 = SnowHeavy24;
  exports.SnowHeavy32 = SnowHeavy32;
  exports.SnowScattered16 = SnowScattered16;
  exports.SnowScattered20 = SnowScattered20;
  exports.SnowScattered24 = SnowScattered24;
  exports.SnowScattered32 = SnowScattered32;
  exports.SnowScatteredNight16 = SnowScatteredNight16;
  exports.SnowScatteredNight20 = SnowScatteredNight20;
  exports.SnowScatteredNight24 = SnowScatteredNight24;
  exports.SnowScatteredNight32 = SnowScatteredNight32;
  exports.Snowflake16 = Snowflake16;
  exports.Snowflake20 = Snowflake20;
  exports.Snowflake24 = Snowflake24;
  exports.Snowflake32 = Snowflake32;
  exports.Soccer16 = Soccer16;
  exports.Soccer20 = Soccer20;
  exports.Soccer24 = Soccer24;
  exports.Soccer32 = Soccer32;
  exports.SoilMoisture16 = SoilMoisture16;
  exports.SoilMoisture20 = SoilMoisture20;
  exports.SoilMoisture24 = SoilMoisture24;
  exports.SoilMoisture32 = SoilMoisture32;
  exports.SoilMoistureField16 = SoilMoistureField16;
  exports.SoilMoistureField20 = SoilMoistureField20;
  exports.SoilMoistureField24 = SoilMoistureField24;
  exports.SoilMoistureField32 = SoilMoistureField32;
  exports.SoilMoistureGlobal16 = SoilMoistureGlobal16;
  exports.SoilMoistureGlobal20 = SoilMoistureGlobal20;
  exports.SoilMoistureGlobal24 = SoilMoistureGlobal24;
  exports.SoilMoistureGlobal32 = SoilMoistureGlobal32;
  exports.SoilTemperature16 = SoilTemperature16;
  exports.SoilTemperature20 = SoilTemperature20;
  exports.SoilTemperature24 = SoilTemperature24;
  exports.SoilTemperature32 = SoilTemperature32;
  exports.SoilTemperatureField16 = SoilTemperatureField16;
  exports.SoilTemperatureField20 = SoilTemperatureField20;
  exports.SoilTemperatureField24 = SoilTemperatureField24;
  exports.SoilTemperatureField32 = SoilTemperatureField32;
  exports.SoilTemperatureGlobal16 = SoilTemperatureGlobal16;
  exports.SoilTemperatureGlobal20 = SoilTemperatureGlobal20;
  exports.SoilTemperatureGlobal24 = SoilTemperatureGlobal24;
  exports.SoilTemperatureGlobal32 = SoilTemperatureGlobal32;
  exports.SolarPanel16 = SolarPanel16;
  exports.SolarPanel20 = SolarPanel20;
  exports.SolarPanel24 = SolarPanel24;
  exports.SolarPanel32 = SolarPanel32;
  exports.SortAscending16 = SortAscending16;
  exports.SortAscending20 = SortAscending20;
  exports.SortAscending24 = SortAscending24;
  exports.SortAscending32 = SortAscending32;
  exports.SortDescending16 = SortDescending16;
  exports.SortDescending20 = SortDescending20;
  exports.SortDescending24 = SortDescending24;
  exports.SortDescending32 = SortDescending32;
  exports.SpellCheck16 = SpellCheck16;
  exports.SpellCheck20 = SpellCheck20;
  exports.SpellCheck24 = SpellCheck24;
  exports.SpellCheck32 = SpellCheck32;
  exports.Split16 = Split16;
  exports.Split20 = Split20;
  exports.Split24 = Split24;
  exports.Split32 = Split32;
  exports.SplitScreen16 = SplitScreen16;
  exports.SplitScreen20 = SplitScreen20;
  exports.SplitScreen24 = SplitScreen24;
  exports.SplitScreen32 = SplitScreen32;
  exports.SprayPaint16 = SprayPaint16;
  exports.SprayPaint20 = SprayPaint20;
  exports.SprayPaint24 = SprayPaint24;
  exports.SprayPaint32 = SprayPaint32;
  exports.Sprout16 = Sprout16;
  exports.Sprout20 = Sprout20;
  exports.Sprout24 = Sprout24;
  exports.Sprout32 = Sprout32;
  exports.Sql16 = Sql16;
  exports.Sql20 = Sql20;
  exports.Sql24 = Sql24;
  exports.Sql32 = Sql32;
  exports.SquareFillGlyph = SquareFillGlyph;
  exports.StackLimitation16 = StackLimitation16;
  exports.StackLimitation20 = StackLimitation20;
  exports.StackLimitation24 = StackLimitation24;
  exports.StackLimitation32 = StackLimitation32;
  exports.Stamp16 = Stamp16;
  exports.Stamp20 = Stamp20;
  exports.Stamp24 = Stamp24;
  exports.Stamp32 = Stamp32;
  exports.Star16 = Star16;
  exports.Star20 = Star20;
  exports.Star24 = Star24;
  exports.Star32 = Star32;
  exports.StarFilled16 = StarFilled16;
  exports.StarFilled20 = StarFilled20;
  exports.StarFilled24 = StarFilled24;
  exports.StarFilled32 = StarFilled32;
  exports.StarHalf16 = StarHalf16;
  exports.StarHalf20 = StarHalf20;
  exports.StarHalf24 = StarHalf24;
  exports.StarHalf32 = StarHalf32;
  exports.StarReview16 = StarReview16;
  exports.StarReview20 = StarReview20;
  exports.StarReview24 = StarReview24;
  exports.StarReview32 = StarReview32;
  exports.StayInside16 = StayInside16;
  exports.StayInside20 = StayInside20;
  exports.StayInside24 = StayInside24;
  exports.StayInside32 = StayInside32;
  exports.StemLeafPlot16 = StemLeafPlot16;
  exports.StemLeafPlot20 = StemLeafPlot20;
  exports.StemLeafPlot24 = StemLeafPlot24;
  exports.StemLeafPlot32 = StemLeafPlot32;
  exports.Stethoscope16 = Stethoscope16;
  exports.Stethoscope20 = Stethoscope20;
  exports.Stethoscope24 = Stethoscope24;
  exports.Stethoscope32 = Stethoscope32;
  exports.Stop16 = Stop16;
  exports.Stop20 = Stop20;
  exports.Stop24 = Stop24;
  exports.Stop32 = Stop32;
  exports.StopFilled16 = StopFilled16;
  exports.StopFilled20 = StopFilled20;
  exports.StopFilled24 = StopFilled24;
  exports.StopFilled32 = StopFilled32;
  exports.StopFilledAlt16 = StopFilledAlt16;
  exports.StopFilledAlt20 = StopFilledAlt20;
  exports.StopFilledAlt24 = StopFilledAlt24;
  exports.StopFilledAlt32 = StopFilledAlt32;
  exports.StopOutline16 = StopOutline16;
  exports.StopOutline20 = StopOutline20;
  exports.StopOutline24 = StopOutline24;
  exports.StopOutline32 = StopOutline32;
  exports.StopOutlineFilled16 = StopOutlineFilled16;
  exports.StopOutlineFilled20 = StopOutlineFilled20;
  exports.StopOutlineFilled24 = StopOutlineFilled24;
  exports.StopOutlineFilled32 = StopOutlineFilled32;
  exports.StopSign16 = StopSign16;
  exports.StopSign20 = StopSign20;
  exports.StopSign24 = StopSign24;
  exports.StopSign32 = StopSign32;
  exports.StopSignFilled16 = StopSignFilled16;
  exports.StopSignFilled20 = StopSignFilled20;
  exports.StopSignFilled24 = StopSignFilled24;
  exports.StopSignFilled32 = StopSignFilled32;
  exports.StoragePool16 = StoragePool16;
  exports.StoragePool20 = StoragePool20;
  exports.StoragePool24 = StoragePool24;
  exports.StoragePool32 = StoragePool32;
  exports.StorageRequest16 = StorageRequest16;
  exports.StorageRequest20 = StorageRequest20;
  exports.StorageRequest24 = StorageRequest24;
  exports.StorageRequest32 = StorageRequest32;
  exports.Store16 = Store16;
  exports.Store20 = Store20;
  exports.Store24 = Store24;
  exports.Store32 = Store32;
  exports.StormTracker16 = StormTracker16;
  exports.StormTracker20 = StormTracker20;
  exports.StormTracker24 = StormTracker24;
  exports.StormTracker32 = StormTracker32;
  exports.Strawberry16 = Strawberry16;
  exports.Strawberry20 = Strawberry20;
  exports.Strawberry24 = Strawberry24;
  exports.Strawberry32 = Strawberry32;
  exports.StringInteger16 = StringInteger16;
  exports.StringInteger20 = StringInteger20;
  exports.StringInteger24 = StringInteger24;
  exports.StringInteger32 = StringInteger32;
  exports.StringText16 = StringText16;
  exports.StringText20 = StringText20;
  exports.StringText24 = StringText24;
  exports.StringText32 = StringText32;
  exports.Subflow16 = Subflow16;
  exports.Subflow20 = Subflow20;
  exports.Subflow24 = Subflow24;
  exports.Subflow32 = Subflow32;
  exports.SubflowLocal16 = SubflowLocal16;
  exports.SubflowLocal20 = SubflowLocal20;
  exports.SubflowLocal24 = SubflowLocal24;
  exports.SubflowLocal32 = SubflowLocal32;
  exports.SubnetAclRules16 = SubnetAclRules16;
  exports.SubnetAclRules20 = SubnetAclRules20;
  exports.SubnetAclRules24 = SubnetAclRules24;
  exports.SubnetAclRules32 = SubnetAclRules32;
  exports.Subtract16 = Subtract16;
  exports.Subtract20 = Subtract20;
  exports.Subtract24 = Subtract24;
  exports.Subtract32 = Subtract32;
  exports.SubtractAlt16 = SubtractAlt16;
  exports.SubtractAlt20 = SubtractAlt20;
  exports.SubtractAlt24 = SubtractAlt24;
  exports.SubtractAlt32 = SubtractAlt32;
  exports.SummaryKpi16 = SummaryKpi16;
  exports.SummaryKpi20 = SummaryKpi20;
  exports.SummaryKpi24 = SummaryKpi24;
  exports.SummaryKpi32 = SummaryKpi32;
  exports.Sun16 = Sun16;
  exports.Sun20 = Sun20;
  exports.Sun24 = Sun24;
  exports.Sun32 = Sun32;
  exports.Sunny16 = Sunny16;
  exports.Sunny20 = Sunny20;
  exports.Sunny24 = Sunny24;
  exports.Sunny32 = Sunny32;
  exports.Sunrise16 = Sunrise16;
  exports.Sunrise20 = Sunrise20;
  exports.Sunrise24 = Sunrise24;
  exports.Sunrise32 = Sunrise32;
  exports.Sunset16 = Sunset16;
  exports.Sunset20 = Sunset20;
  exports.Sunset24 = Sunset24;
  exports.Sunset32 = Sunset32;
  exports.Svg16 = Svg16;
  exports.Svg20 = Svg20;
  exports.Svg24 = Svg24;
  exports.Svg32 = Svg32;
  exports.Swim16 = Swim16;
  exports.Swim20 = Swim20;
  exports.Swim24 = Swim24;
  exports.Swim32 = Swim32;
  exports.SwitchLayer_216 = SwitchLayer_216;
  exports.SwitchLayer_220 = SwitchLayer_220;
  exports.SwitchLayer_224 = SwitchLayer_224;
  exports.SwitchLayer_232 = SwitchLayer_232;
  exports.SwitchLayer_316 = SwitchLayer_316;
  exports.SwitchLayer_320 = SwitchLayer_320;
  exports.SwitchLayer_324 = SwitchLayer_324;
  exports.SwitchLayer_332 = SwitchLayer_332;
  exports.Switcher16 = Switcher16;
  exports.Switcher20 = Switcher20;
  exports.Switcher24 = Switcher24;
  exports.Switcher32 = Switcher32;
  exports.SysProvision16 = SysProvision16;
  exports.SysProvision20 = SysProvision20;
  exports.SysProvision24 = SysProvision24;
  exports.SysProvision32 = SysProvision32;
  exports.Table16 = Table16;
  exports.Table20 = Table20;
  exports.Table24 = Table24;
  exports.Table32 = Table32;
  exports.TableAlias16 = TableAlias16;
  exports.TableAlias20 = TableAlias20;
  exports.TableAlias24 = TableAlias24;
  exports.TableAlias32 = TableAlias32;
  exports.TableBuilt16 = TableBuilt16;
  exports.TableBuilt20 = TableBuilt20;
  exports.TableBuilt24 = TableBuilt24;
  exports.TableBuilt32 = TableBuilt32;
  exports.TableOfContents16 = TableOfContents16;
  exports.TableOfContents20 = TableOfContents20;
  exports.TableOfContents24 = TableOfContents24;
  exports.TableOfContents32 = TableOfContents32;
  exports.TableShortcut16 = TableShortcut16;
  exports.TableShortcut20 = TableShortcut20;
  exports.TableShortcut24 = TableShortcut24;
  exports.TableShortcut32 = TableShortcut32;
  exports.TableSplit16 = TableSplit16;
  exports.TableSplit20 = TableSplit20;
  exports.TableSplit24 = TableSplit24;
  exports.TableSplit32 = TableSplit32;
  exports.Tablet16 = Tablet16;
  exports.Tablet20 = Tablet20;
  exports.Tablet24 = Tablet24;
  exports.Tablet32 = Tablet32;
  exports.TabletLandscape16 = TabletLandscape16;
  exports.TabletLandscape20 = TabletLandscape20;
  exports.TabletLandscape24 = TabletLandscape24;
  exports.TabletLandscape32 = TabletLandscape32;
  exports.Tag16 = Tag16;
  exports.Tag20 = Tag20;
  exports.Tag24 = Tag24;
  exports.Tag32 = Tag32;
  exports.TagEdit16 = TagEdit16;
  exports.TagEdit20 = TagEdit20;
  exports.TagEdit24 = TagEdit24;
  exports.TagEdit32 = TagEdit32;
  exports.TagExport16 = TagExport16;
  exports.TagExport20 = TagExport20;
  exports.TagExport24 = TagExport24;
  exports.TagExport32 = TagExport32;
  exports.TagGroup16 = TagGroup16;
  exports.TagGroup20 = TagGroup20;
  exports.TagGroup24 = TagGroup24;
  exports.TagGroup32 = TagGroup32;
  exports.TagImport16 = TagImport16;
  exports.TagImport20 = TagImport20;
  exports.TagImport24 = TagImport24;
  exports.TagImport32 = TagImport32;
  exports.TagNone16 = TagNone16;
  exports.TagNone20 = TagNone20;
  exports.TagNone24 = TagNone24;
  exports.TagNone32 = TagNone32;
  exports.Tank16 = Tank16;
  exports.Tank20 = Tank20;
  exports.Tank24 = Tank24;
  exports.Tank32 = Tank32;
  exports.Task16 = Task16;
  exports.Task20 = Task20;
  exports.Task24 = Task24;
  exports.Task32 = Task32;
  exports.TaskAdd16 = TaskAdd16;
  exports.TaskAdd20 = TaskAdd20;
  exports.TaskAdd24 = TaskAdd24;
  exports.TaskAdd32 = TaskAdd32;
  exports.TaskApproved16 = TaskApproved16;
  exports.TaskApproved20 = TaskApproved20;
  exports.TaskApproved24 = TaskApproved24;
  exports.TaskApproved32 = TaskApproved32;
  exports.TaskAssetView16 = TaskAssetView16;
  exports.TaskAssetView20 = TaskAssetView20;
  exports.TaskAssetView24 = TaskAssetView24;
  exports.TaskAssetView32 = TaskAssetView32;
  exports.TaskComplete16 = TaskComplete16;
  exports.TaskComplete20 = TaskComplete20;
  exports.TaskComplete24 = TaskComplete24;
  exports.TaskComplete32 = TaskComplete32;
  exports.TaskLocation16 = TaskLocation16;
  exports.TaskLocation20 = TaskLocation20;
  exports.TaskLocation24 = TaskLocation24;
  exports.TaskLocation32 = TaskLocation32;
  exports.TaskRemove16 = TaskRemove16;
  exports.TaskRemove20 = TaskRemove20;
  exports.TaskRemove24 = TaskRemove24;
  exports.TaskRemove32 = TaskRemove32;
  exports.TaskSettings16 = TaskSettings16;
  exports.TaskSettings20 = TaskSettings20;
  exports.TaskSettings24 = TaskSettings24;
  exports.TaskSettings32 = TaskSettings32;
  exports.TaskStar16 = TaskStar16;
  exports.TaskStar20 = TaskStar20;
  exports.TaskStar24 = TaskStar24;
  exports.TaskStar32 = TaskStar32;
  exports.TaskTools16 = TaskTools16;
  exports.TaskTools20 = TaskTools20;
  exports.TaskTools24 = TaskTools24;
  exports.TaskTools32 = TaskTools32;
  exports.TaskView16 = TaskView16;
  exports.TaskView20 = TaskView20;
  exports.TaskView24 = TaskView24;
  exports.TaskView32 = TaskView32;
  exports.Taste16 = Taste16;
  exports.Taste20 = Taste20;
  exports.Taste24 = Taste24;
  exports.Taste32 = Taste32;
  exports.Taxi16 = Taxi16;
  exports.Taxi20 = Taxi20;
  exports.Taxi24 = Taxi24;
  exports.Taxi32 = Taxi32;
  exports.Temperature16 = Temperature16;
  exports.Temperature20 = Temperature20;
  exports.Temperature24 = Temperature24;
  exports.Temperature32 = Temperature32;
  exports.TemperatureCelsius16 = TemperatureCelsius16;
  exports.TemperatureCelsius20 = TemperatureCelsius20;
  exports.TemperatureCelsius24 = TemperatureCelsius24;
  exports.TemperatureCelsius32 = TemperatureCelsius32;
  exports.TemperatureCelsiusAlt16 = TemperatureCelsiusAlt16;
  exports.TemperatureCelsiusAlt20 = TemperatureCelsiusAlt20;
  exports.TemperatureCelsiusAlt24 = TemperatureCelsiusAlt24;
  exports.TemperatureCelsiusAlt32 = TemperatureCelsiusAlt32;
  exports.TemperatureFahrenheit16 = TemperatureFahrenheit16;
  exports.TemperatureFahrenheit20 = TemperatureFahrenheit20;
  exports.TemperatureFahrenheit24 = TemperatureFahrenheit24;
  exports.TemperatureFahrenheit32 = TemperatureFahrenheit32;
  exports.TemperatureFahrenheitAlt16 = TemperatureFahrenheitAlt16;
  exports.TemperatureFahrenheitAlt20 = TemperatureFahrenheitAlt20;
  exports.TemperatureFahrenheitAlt24 = TemperatureFahrenheitAlt24;
  exports.TemperatureFahrenheitAlt32 = TemperatureFahrenheitAlt32;
  exports.TemperatureFeelsLike16 = TemperatureFeelsLike16;
  exports.TemperatureFeelsLike20 = TemperatureFeelsLike20;
  exports.TemperatureFeelsLike24 = TemperatureFeelsLike24;
  exports.TemperatureFeelsLike32 = TemperatureFeelsLike32;
  exports.TemperatureFrigid16 = TemperatureFrigid16;
  exports.TemperatureFrigid20 = TemperatureFrigid20;
  exports.TemperatureFrigid24 = TemperatureFrigid24;
  exports.TemperatureFrigid32 = TemperatureFrigid32;
  exports.TemperatureHot16 = TemperatureHot16;
  exports.TemperatureHot20 = TemperatureHot20;
  exports.TemperatureHot24 = TemperatureHot24;
  exports.TemperatureHot32 = TemperatureHot32;
  exports.TemperatureInversion16 = TemperatureInversion16;
  exports.TemperatureInversion20 = TemperatureInversion20;
  exports.TemperatureInversion24 = TemperatureInversion24;
  exports.TemperatureInversion32 = TemperatureInversion32;
  exports.TemperatureMax16 = TemperatureMax16;
  exports.TemperatureMax20 = TemperatureMax20;
  exports.TemperatureMax24 = TemperatureMax24;
  exports.TemperatureMax32 = TemperatureMax32;
  exports.TemperatureMin16 = TemperatureMin16;
  exports.TemperatureMin20 = TemperatureMin20;
  exports.TemperatureMin24 = TemperatureMin24;
  exports.TemperatureMin32 = TemperatureMin32;
  exports.TemperatureWater16 = TemperatureWater16;
  exports.TemperatureWater20 = TemperatureWater20;
  exports.TemperatureWater24 = TemperatureWater24;
  exports.TemperatureWater32 = TemperatureWater32;
  exports.Template16 = Template16;
  exports.Template20 = Template20;
  exports.Template24 = Template24;
  exports.Template32 = Template32;
  exports.Tennis16 = Tennis16;
  exports.Tennis20 = Tennis20;
  exports.Tennis24 = Tennis24;
  exports.Tennis32 = Tennis32;
  exports.TennisBall16 = TennisBall16;
  exports.TennisBall20 = TennisBall20;
  exports.TennisBall24 = TennisBall24;
  exports.TennisBall32 = TennisBall32;
  exports.Term16 = Term16;
  exports.Term20 = Term20;
  exports.Term24 = Term24;
  exports.Term32 = Term32;
  exports.Terminal16 = Terminal16;
  exports.Terminal20 = Terminal20;
  exports.Terminal24 = Terminal24;
  exports.Terminal32 = Terminal32;
  exports.Terminal_327016 = Terminal_327016;
  exports.Terminal_327020 = Terminal_327020;
  exports.Terminal_327024 = Terminal_327024;
  exports.Terminal_327032 = Terminal_327032;
  exports.TextAlignCenter16 = TextAlignCenter16;
  exports.TextAlignCenter20 = TextAlignCenter20;
  exports.TextAlignCenter24 = TextAlignCenter24;
  exports.TextAlignCenter32 = TextAlignCenter32;
  exports.TextAlignJustify16 = TextAlignJustify16;
  exports.TextAlignJustify20 = TextAlignJustify20;
  exports.TextAlignJustify24 = TextAlignJustify24;
  exports.TextAlignJustify32 = TextAlignJustify32;
  exports.TextAlignLeft16 = TextAlignLeft16;
  exports.TextAlignLeft20 = TextAlignLeft20;
  exports.TextAlignLeft24 = TextAlignLeft24;
  exports.TextAlignLeft32 = TextAlignLeft32;
  exports.TextAlignMixed16 = TextAlignMixed16;
  exports.TextAlignMixed20 = TextAlignMixed20;
  exports.TextAlignMixed24 = TextAlignMixed24;
  exports.TextAlignMixed32 = TextAlignMixed32;
  exports.TextAlignRight16 = TextAlignRight16;
  exports.TextAlignRight20 = TextAlignRight20;
  exports.TextAlignRight24 = TextAlignRight24;
  exports.TextAlignRight32 = TextAlignRight32;
  exports.TextAllCaps16 = TextAllCaps16;
  exports.TextAllCaps20 = TextAllCaps20;
  exports.TextAllCaps24 = TextAllCaps24;
  exports.TextAllCaps32 = TextAllCaps32;
  exports.TextBold16 = TextBold16;
  exports.TextBold20 = TextBold20;
  exports.TextBold24 = TextBold24;
  exports.TextBold32 = TextBold32;
  exports.TextClearFormat16 = TextClearFormat16;
  exports.TextClearFormat20 = TextClearFormat20;
  exports.TextClearFormat24 = TextClearFormat24;
  exports.TextClearFormat32 = TextClearFormat32;
  exports.TextColor16 = TextColor16;
  exports.TextColor20 = TextColor20;
  exports.TextColor24 = TextColor24;
  exports.TextColor32 = TextColor32;
  exports.TextCreation16 = TextCreation16;
  exports.TextCreation20 = TextCreation20;
  exports.TextCreation24 = TextCreation24;
  exports.TextCreation32 = TextCreation32;
  exports.TextFill16 = TextFill16;
  exports.TextFill20 = TextFill20;
  exports.TextFill24 = TextFill24;
  exports.TextFill32 = TextFill32;
  exports.TextFont16 = TextFont16;
  exports.TextFont20 = TextFont20;
  exports.TextFont24 = TextFont24;
  exports.TextFont32 = TextFont32;
  exports.TextFootnote16 = TextFootnote16;
  exports.TextFootnote20 = TextFootnote20;
  exports.TextFootnote24 = TextFootnote24;
  exports.TextFootnote32 = TextFootnote32;
  exports.TextHighlight16 = TextHighlight16;
  exports.TextHighlight20 = TextHighlight20;
  exports.TextHighlight24 = TextHighlight24;
  exports.TextHighlight32 = TextHighlight32;
  exports.TextIndent16 = TextIndent16;
  exports.TextIndent20 = TextIndent20;
  exports.TextIndent24 = TextIndent24;
  exports.TextIndent32 = TextIndent32;
  exports.TextIndentLess16 = TextIndentLess16;
  exports.TextIndentLess20 = TextIndentLess20;
  exports.TextIndentLess24 = TextIndentLess24;
  exports.TextIndentLess32 = TextIndentLess32;
  exports.TextIndentMore16 = TextIndentMore16;
  exports.TextIndentMore20 = TextIndentMore20;
  exports.TextIndentMore24 = TextIndentMore24;
  exports.TextIndentMore32 = TextIndentMore32;
  exports.TextItalic16 = TextItalic16;
  exports.TextItalic20 = TextItalic20;
  exports.TextItalic24 = TextItalic24;
  exports.TextItalic32 = TextItalic32;
  exports.TextKerning16 = TextKerning16;
  exports.TextKerning20 = TextKerning20;
  exports.TextKerning24 = TextKerning24;
  exports.TextKerning32 = TextKerning32;
  exports.TextLeading16 = TextLeading16;
  exports.TextLeading20 = TextLeading20;
  exports.TextLeading24 = TextLeading24;
  exports.TextLeading32 = TextLeading32;
  exports.TextLineSpacing16 = TextLineSpacing16;
  exports.TextLineSpacing20 = TextLineSpacing20;
  exports.TextLineSpacing24 = TextLineSpacing24;
  exports.TextLineSpacing32 = TextLineSpacing32;
  exports.TextLink16 = TextLink16;
  exports.TextLink20 = TextLink20;
  exports.TextLink24 = TextLink24;
  exports.TextLink32 = TextLink32;
  exports.TextLinkAnalysis16 = TextLinkAnalysis16;
  exports.TextLinkAnalysis20 = TextLinkAnalysis20;
  exports.TextLinkAnalysis24 = TextLinkAnalysis24;
  exports.TextLinkAnalysis32 = TextLinkAnalysis32;
  exports.TextMining16 = TextMining16;
  exports.TextMining20 = TextMining20;
  exports.TextMining24 = TextMining24;
  exports.TextMining32 = TextMining32;
  exports.TextMiningApplier16 = TextMiningApplier16;
  exports.TextMiningApplier20 = TextMiningApplier20;
  exports.TextMiningApplier24 = TextMiningApplier24;
  exports.TextMiningApplier32 = TextMiningApplier32;
  exports.TextNewLine16 = TextNewLine16;
  exports.TextNewLine20 = TextNewLine20;
  exports.TextNewLine24 = TextNewLine24;
  exports.TextNewLine32 = TextNewLine32;
  exports.TextScale16 = TextScale16;
  exports.TextScale20 = TextScale20;
  exports.TextScale24 = TextScale24;
  exports.TextScale32 = TextScale32;
  exports.TextSelection16 = TextSelection16;
  exports.TextSelection20 = TextSelection20;
  exports.TextSelection24 = TextSelection24;
  exports.TextSelection32 = TextSelection32;
  exports.TextSmallCaps16 = TextSmallCaps16;
  exports.TextSmallCaps20 = TextSmallCaps20;
  exports.TextSmallCaps24 = TextSmallCaps24;
  exports.TextSmallCaps32 = TextSmallCaps32;
  exports.TextStrikethrough16 = TextStrikethrough16;
  exports.TextStrikethrough20 = TextStrikethrough20;
  exports.TextStrikethrough24 = TextStrikethrough24;
  exports.TextStrikethrough32 = TextStrikethrough32;
  exports.TextSubscript16 = TextSubscript16;
  exports.TextSubscript20 = TextSubscript20;
  exports.TextSubscript24 = TextSubscript24;
  exports.TextSubscript32 = TextSubscript32;
  exports.TextSuperscript16 = TextSuperscript16;
  exports.TextSuperscript20 = TextSuperscript20;
  exports.TextSuperscript24 = TextSuperscript24;
  exports.TextSuperscript32 = TextSuperscript32;
  exports.TextTracking16 = TextTracking16;
  exports.TextTracking20 = TextTracking20;
  exports.TextTracking24 = TextTracking24;
  exports.TextTracking32 = TextTracking32;
  exports.TextUnderline16 = TextUnderline16;
  exports.TextUnderline20 = TextUnderline20;
  exports.TextUnderline24 = TextUnderline24;
  exports.TextUnderline32 = TextUnderline32;
  exports.TextVerticalAlignment16 = TextVerticalAlignment16;
  exports.TextVerticalAlignment20 = TextVerticalAlignment20;
  exports.TextVerticalAlignment24 = TextVerticalAlignment24;
  exports.TextVerticalAlignment32 = TextVerticalAlignment32;
  exports.TextWrap16 = TextWrap16;
  exports.TextWrap20 = TextWrap20;
  exports.TextWrap24 = TextWrap24;
  exports.TextWrap32 = TextWrap32;
  exports.Theater16 = Theater16;
  exports.Theater20 = Theater20;
  exports.Theater24 = Theater24;
  exports.Theater32 = Theater32;
  exports.ThisSideUp16 = ThisSideUp16;
  exports.ThisSideUp20 = ThisSideUp20;
  exports.ThisSideUp24 = ThisSideUp24;
  exports.ThisSideUp32 = ThisSideUp32;
  exports.Thumbnail_116 = Thumbnail_116;
  exports.Thumbnail_120 = Thumbnail_120;
  exports.Thumbnail_124 = Thumbnail_124;
  exports.Thumbnail_132 = Thumbnail_132;
  exports.Thumbnail_216 = Thumbnail_216;
  exports.Thumbnail_220 = Thumbnail_220;
  exports.Thumbnail_224 = Thumbnail_224;
  exports.Thumbnail_232 = Thumbnail_232;
  exports.ThumbsDown16 = ThumbsDown16;
  exports.ThumbsDown20 = ThumbsDown20;
  exports.ThumbsDown24 = ThumbsDown24;
  exports.ThumbsDown32 = ThumbsDown32;
  exports.ThumbsDownFilled16 = ThumbsDownFilled16;
  exports.ThumbsDownFilled20 = ThumbsDownFilled20;
  exports.ThumbsDownFilled24 = ThumbsDownFilled24;
  exports.ThumbsDownFilled32 = ThumbsDownFilled32;
  exports.ThumbsUp16 = ThumbsUp16;
  exports.ThumbsUp20 = ThumbsUp20;
  exports.ThumbsUp24 = ThumbsUp24;
  exports.ThumbsUp32 = ThumbsUp32;
  exports.ThumbsUpFilled16 = ThumbsUpFilled16;
  exports.ThumbsUpFilled20 = ThumbsUpFilled20;
  exports.ThumbsUpFilled24 = ThumbsUpFilled24;
  exports.ThumbsUpFilled32 = ThumbsUpFilled32;
  exports.Thunderstorm16 = Thunderstorm16;
  exports.Thunderstorm20 = Thunderstorm20;
  exports.Thunderstorm24 = Thunderstorm24;
  exports.Thunderstorm32 = Thunderstorm32;
  exports.ThunderstormScattered16 = ThunderstormScattered16;
  exports.ThunderstormScattered20 = ThunderstormScattered20;
  exports.ThunderstormScattered24 = ThunderstormScattered24;
  exports.ThunderstormScattered32 = ThunderstormScattered32;
  exports.ThunderstormScatteredNight16 = ThunderstormScatteredNight16;
  exports.ThunderstormScatteredNight20 = ThunderstormScatteredNight20;
  exports.ThunderstormScatteredNight24 = ThunderstormScatteredNight24;
  exports.ThunderstormScatteredNight32 = ThunderstormScatteredNight32;
  exports.ThunderstormSevere16 = ThunderstormSevere16;
  exports.ThunderstormSevere20 = ThunderstormSevere20;
  exports.ThunderstormSevere24 = ThunderstormSevere24;
  exports.ThunderstormSevere32 = ThunderstormSevere32;
  exports.ThunderstormStrong16 = ThunderstormStrong16;
  exports.ThunderstormStrong20 = ThunderstormStrong20;
  exports.ThunderstormStrong24 = ThunderstormStrong24;
  exports.ThunderstormStrong32 = ThunderstormStrong32;
  exports.Ticket16 = Ticket16;
  exports.Ticket20 = Ticket20;
  exports.Ticket24 = Ticket24;
  exports.Ticket32 = Ticket32;
  exports.Tides16 = Tides16;
  exports.Tides20 = Tides20;
  exports.Tides24 = Tides24;
  exports.Tides32 = Tides32;
  exports.Tif16 = Tif16;
  exports.Tif20 = Tif20;
  exports.Tif24 = Tif24;
  exports.Tif32 = Tif32;
  exports.Time16 = Time16;
  exports.Time20 = Time20;
  exports.Time24 = Time24;
  exports.Time32 = Time32;
  exports.TimePlot16 = TimePlot16;
  exports.TimePlot20 = TimePlot20;
  exports.TimePlot24 = TimePlot24;
  exports.TimePlot32 = TimePlot32;
  exports.Timer16 = Timer16;
  exports.Timer20 = Timer20;
  exports.Timer24 = Timer24;
  exports.Timer32 = Timer32;
  exports.ToolBox16 = ToolBox16;
  exports.ToolBox20 = ToolBox20;
  exports.ToolBox24 = ToolBox24;
  exports.ToolBox32 = ToolBox32;
  exports.ToolKit16 = ToolKit16;
  exports.ToolKit20 = ToolKit20;
  exports.ToolKit24 = ToolKit24;
  exports.ToolKit32 = ToolKit32;
  exports.Tools16 = Tools16;
  exports.Tools20 = Tools20;
  exports.Tools24 = Tools24;
  exports.Tools32 = Tools32;
  exports.ToolsAlt16 = ToolsAlt16;
  exports.ToolsAlt20 = ToolsAlt20;
  exports.ToolsAlt24 = ToolsAlt24;
  exports.ToolsAlt32 = ToolsAlt32;
  exports.Tornado16 = Tornado16;
  exports.Tornado20 = Tornado20;
  exports.Tornado24 = Tornado24;
  exports.Tornado32 = Tornado32;
  exports.TornadoWarning16 = TornadoWarning16;
  exports.TornadoWarning20 = TornadoWarning20;
  exports.TornadoWarning24 = TornadoWarning24;
  exports.TornadoWarning32 = TornadoWarning32;
  exports.TouchInteraction16 = TouchInteraction16;
  exports.TouchInteraction20 = TouchInteraction20;
  exports.TouchInteraction24 = TouchInteraction24;
  exports.TouchInteraction32 = TouchInteraction32;
  exports.Touch_116 = Touch_116;
  exports.Touch_120 = Touch_120;
  exports.Touch_124 = Touch_124;
  exports.Touch_132 = Touch_132;
  exports.Touch_1Down16 = Touch_1Down16;
  exports.Touch_1Down20 = Touch_1Down20;
  exports.Touch_1Down24 = Touch_1Down24;
  exports.Touch_1Down32 = Touch_1Down32;
  exports.Touch_1DownFilled16 = Touch_1DownFilled16;
  exports.Touch_1DownFilled20 = Touch_1DownFilled20;
  exports.Touch_1DownFilled24 = Touch_1DownFilled24;
  exports.Touch_1DownFilled32 = Touch_1DownFilled32;
  exports.Touch_1Filled16 = Touch_1Filled16;
  exports.Touch_1Filled20 = Touch_1Filled20;
  exports.Touch_1Filled24 = Touch_1Filled24;
  exports.Touch_1Filled32 = Touch_1Filled32;
  exports.Touch_216 = Touch_216;
  exports.Touch_220 = Touch_220;
  exports.Touch_224 = Touch_224;
  exports.Touch_232 = Touch_232;
  exports.Touch_2Filled16 = Touch_2Filled16;
  exports.Touch_2Filled20 = Touch_2Filled20;
  exports.Touch_2Filled24 = Touch_2Filled24;
  exports.Touch_2Filled32 = Touch_2Filled32;
  exports.TrafficCone16 = TrafficCone16;
  exports.TrafficCone20 = TrafficCone20;
  exports.TrafficCone24 = TrafficCone24;
  exports.TrafficCone32 = TrafficCone32;
  exports.TrafficEvent16 = TrafficEvent16;
  exports.TrafficEvent20 = TrafficEvent20;
  exports.TrafficEvent24 = TrafficEvent24;
  exports.TrafficEvent32 = TrafficEvent32;
  exports.TrafficFlow16 = TrafficFlow16;
  exports.TrafficFlow20 = TrafficFlow20;
  exports.TrafficFlow24 = TrafficFlow24;
  exports.TrafficFlow32 = TrafficFlow32;
  exports.TrafficFlowIncident16 = TrafficFlowIncident16;
  exports.TrafficFlowIncident20 = TrafficFlowIncident20;
  exports.TrafficFlowIncident24 = TrafficFlowIncident24;
  exports.TrafficFlowIncident32 = TrafficFlowIncident32;
  exports.TrafficIncident16 = TrafficIncident16;
  exports.TrafficIncident20 = TrafficIncident20;
  exports.TrafficIncident24 = TrafficIncident24;
  exports.TrafficIncident32 = TrafficIncident32;
  exports.TrafficWeatherIncident16 = TrafficWeatherIncident16;
  exports.TrafficWeatherIncident20 = TrafficWeatherIncident20;
  exports.TrafficWeatherIncident24 = TrafficWeatherIncident24;
  exports.TrafficWeatherIncident32 = TrafficWeatherIncident32;
  exports.Train16 = Train16;
  exports.Train20 = Train20;
  exports.Train24 = Train24;
  exports.Train32 = Train32;
  exports.TrainHeart16 = TrainHeart16;
  exports.TrainHeart20 = TrainHeart20;
  exports.TrainHeart24 = TrainHeart24;
  exports.TrainHeart32 = TrainHeart32;
  exports.TrainProfile16 = TrainProfile16;
  exports.TrainProfile20 = TrainProfile20;
  exports.TrainProfile24 = TrainProfile24;
  exports.TrainProfile32 = TrainProfile32;
  exports.TrainSpeed16 = TrainSpeed16;
  exports.TrainSpeed20 = TrainSpeed20;
  exports.TrainSpeed24 = TrainSpeed24;
  exports.TrainSpeed32 = TrainSpeed32;
  exports.TrainTicket16 = TrainTicket16;
  exports.TrainTicket20 = TrainTicket20;
  exports.TrainTicket24 = TrainTicket24;
  exports.TrainTicket32 = TrainTicket32;
  exports.TrainTime16 = TrainTime16;
  exports.TrainTime20 = TrainTime20;
  exports.TrainTime24 = TrainTime24;
  exports.TrainTime32 = TrainTime32;
  exports.Tram16 = Tram16;
  exports.Tram20 = Tram20;
  exports.Tram24 = Tram24;
  exports.Tram32 = Tram32;
  exports.Transgender16 = Transgender16;
  exports.Transgender20 = Transgender20;
  exports.Transgender24 = Transgender24;
  exports.Transgender32 = Transgender32;
  exports.Translate16 = Translate16;
  exports.Translate20 = Translate20;
  exports.Translate24 = Translate24;
  exports.Translate32 = Translate32;
  exports.TransmissionLte16 = TransmissionLte16;
  exports.TransmissionLte20 = TransmissionLte20;
  exports.TransmissionLte24 = TransmissionLte24;
  exports.TransmissionLte32 = TransmissionLte32;
  exports.Transpose16 = Transpose16;
  exports.Transpose20 = Transpose20;
  exports.Transpose24 = Transpose24;
  exports.Transpose32 = Transpose32;
  exports.TrashCan16 = TrashCan16;
  exports.TrashCan20 = TrashCan20;
  exports.TrashCan24 = TrashCan24;
  exports.TrashCan32 = TrashCan32;
  exports.Tree16 = Tree16;
  exports.Tree20 = Tree20;
  exports.Tree24 = Tree24;
  exports.Tree32 = Tree32;
  exports.TreeFallRisk16 = TreeFallRisk16;
  exports.TreeFallRisk20 = TreeFallRisk20;
  exports.TreeFallRisk24 = TreeFallRisk24;
  exports.TreeFallRisk32 = TreeFallRisk32;
  exports.TreeView16 = TreeView16;
  exports.TreeView20 = TreeView20;
  exports.TreeView24 = TreeView24;
  exports.TreeView32 = TreeView32;
  exports.TreeViewAlt16 = TreeViewAlt16;
  exports.TreeViewAlt20 = TreeViewAlt20;
  exports.TreeViewAlt24 = TreeViewAlt24;
  exports.TreeViewAlt32 = TreeViewAlt32;
  exports.Trophy16 = Trophy16;
  exports.Trophy20 = Trophy20;
  exports.Trophy24 = Trophy24;
  exports.Trophy32 = Trophy32;
  exports.TrophyFilled16 = TrophyFilled16;
  exports.TrophyFilled20 = TrophyFilled20;
  exports.TrophyFilled24 = TrophyFilled24;
  exports.TrophyFilled32 = TrophyFilled32;
  exports.TropicalStorm16 = TropicalStorm16;
  exports.TropicalStorm20 = TropicalStorm20;
  exports.TropicalStorm24 = TropicalStorm24;
  exports.TropicalStorm32 = TropicalStorm32;
  exports.TropicalStormModelTracks16 = TropicalStormModelTracks16;
  exports.TropicalStormModelTracks20 = TropicalStormModelTracks20;
  exports.TropicalStormModelTracks24 = TropicalStormModelTracks24;
  exports.TropicalStormModelTracks32 = TropicalStormModelTracks32;
  exports.TropicalStormTracks16 = TropicalStormTracks16;
  exports.TropicalStormTracks20 = TropicalStormTracks20;
  exports.TropicalStormTracks24 = TropicalStormTracks24;
  exports.TropicalStormTracks32 = TropicalStormTracks32;
  exports.TropicalWarning16 = TropicalWarning16;
  exports.TropicalWarning20 = TropicalWarning20;
  exports.TropicalWarning24 = TropicalWarning24;
  exports.TropicalWarning32 = TropicalWarning32;
  exports.Tsunami16 = Tsunami16;
  exports.Tsunami20 = Tsunami20;
  exports.Tsunami24 = Tsunami24;
  exports.Tsunami32 = Tsunami32;
  exports.Tsv16 = Tsv16;
  exports.Tsv20 = Tsv20;
  exports.Tsv24 = Tsv24;
  exports.Tsv32 = Tsv32;
  exports.TwoFactorAuthentication16 = TwoFactorAuthentication16;
  exports.TwoFactorAuthentication20 = TwoFactorAuthentication20;
  exports.TwoFactorAuthentication24 = TwoFactorAuthentication24;
  exports.TwoFactorAuthentication32 = TwoFactorAuthentication32;
  exports.TwoPersonLift16 = TwoPersonLift16;
  exports.TwoPersonLift20 = TwoPersonLift20;
  exports.TwoPersonLift24 = TwoPersonLift24;
  exports.TwoPersonLift32 = TwoPersonLift32;
  exports.Txt16 = Txt16;
  exports.Txt20 = Txt20;
  exports.Txt24 = Txt24;
  exports.Txt32 = Txt32;
  exports.TxtReference16 = TxtReference16;
  exports.TxtReference20 = TxtReference20;
  exports.TxtReference24 = TxtReference24;
  exports.TxtReference32 = TxtReference32;
  exports.TypePattern16 = TypePattern16;
  exports.TypePattern20 = TypePattern20;
  exports.TypePattern24 = TypePattern24;
  exports.TypePattern32 = TypePattern32;
  exports.Types16 = Types16;
  exports.Types20 = Types20;
  exports.Types24 = Types24;
  exports.Types32 = Types32;
  exports.Umbrella16 = Umbrella16;
  exports.Umbrella20 = Umbrella20;
  exports.Umbrella24 = Umbrella24;
  exports.Umbrella32 = Umbrella32;
  exports.Undefined16 = Undefined16;
  exports.Undefined20 = Undefined20;
  exports.Undefined24 = Undefined24;
  exports.Undefined32 = Undefined32;
  exports.UndefinedFilled16 = UndefinedFilled16;
  exports.UndefinedFilled20 = UndefinedFilled20;
  exports.UndefinedFilled24 = UndefinedFilled24;
  exports.UndefinedFilled32 = UndefinedFilled32;
  exports.UndefinedGlyph = UndefinedGlyph;
  exports.Undo16 = Undo16;
  exports.Undo20 = Undo20;
  exports.Undo24 = Undo24;
  exports.Undo32 = Undo32;
  exports.UngroupObjects16 = UngroupObjects16;
  exports.UngroupObjects20 = UngroupObjects20;
  exports.UngroupObjects24 = UngroupObjects24;
  exports.UngroupObjects32 = UngroupObjects32;
  exports.Unknown16 = Unknown16;
  exports.Unknown20 = Unknown20;
  exports.Unknown24 = Unknown24;
  exports.Unknown32 = Unknown32;
  exports.UnknownFilled16 = UnknownFilled16;
  exports.UnknownFilled20 = UnknownFilled20;
  exports.UnknownFilled24 = UnknownFilled24;
  exports.UnknownFilled32 = UnknownFilled32;
  exports.Unlink16 = Unlink16;
  exports.Unlink20 = Unlink20;
  exports.Unlink24 = Unlink24;
  exports.Unlink32 = Unlink32;
  exports.Unlocked16 = Unlocked16;
  exports.Unlocked20 = Unlocked20;
  exports.Unlocked24 = Unlocked24;
  exports.Unlocked32 = Unlocked32;
  exports.UpToTop16 = UpToTop16;
  exports.UpToTop20 = UpToTop20;
  exports.UpToTop24 = UpToTop24;
  exports.UpToTop32 = UpToTop32;
  exports.UpdateNow16 = UpdateNow16;
  exports.UpdateNow20 = UpdateNow20;
  exports.UpdateNow24 = UpdateNow24;
  exports.UpdateNow32 = UpdateNow32;
  exports.Upgrade16 = Upgrade16;
  exports.Upgrade20 = Upgrade20;
  exports.Upgrade24 = Upgrade24;
  exports.Upgrade32 = Upgrade32;
  exports.Upload16 = Upload16;
  exports.Upload20 = Upload20;
  exports.Upload24 = Upload24;
  exports.Upload32 = Upload32;
  exports.Usb16 = Usb16;
  exports.Usb20 = Usb20;
  exports.Usb24 = Usb24;
  exports.Usb32 = Usb32;
  exports.User16 = User16;
  exports.User20 = User20;
  exports.User24 = User24;
  exports.User32 = User32;
  exports.UserAccess16 = UserAccess16;
  exports.UserAccess20 = UserAccess20;
  exports.UserAccess24 = UserAccess24;
  exports.UserAccess32 = UserAccess32;
  exports.UserActivity16 = UserActivity16;
  exports.UserActivity20 = UserActivity20;
  exports.UserActivity24 = UserActivity24;
  exports.UserActivity32 = UserActivity32;
  exports.UserAdmin16 = UserAdmin16;
  exports.UserAdmin20 = UserAdmin20;
  exports.UserAdmin24 = UserAdmin24;
  exports.UserAdmin32 = UserAdmin32;
  exports.UserAvatar16 = UserAvatar16;
  exports.UserAvatar20 = UserAvatar20;
  exports.UserAvatar24 = UserAvatar24;
  exports.UserAvatar32 = UserAvatar32;
  exports.UserAvatarFilled16 = UserAvatarFilled16;
  exports.UserAvatarFilled20 = UserAvatarFilled20;
  exports.UserAvatarFilled24 = UserAvatarFilled24;
  exports.UserAvatarFilled32 = UserAvatarFilled32;
  exports.UserAvatarFilledAlt16 = UserAvatarFilledAlt16;
  exports.UserAvatarFilledAlt20 = UserAvatarFilledAlt20;
  exports.UserAvatarFilledAlt24 = UserAvatarFilledAlt24;
  exports.UserAvatarFilledAlt32 = UserAvatarFilledAlt32;
  exports.UserCertification16 = UserCertification16;
  exports.UserCertification20 = UserCertification20;
  exports.UserCertification24 = UserCertification24;
  exports.UserCertification32 = UserCertification32;
  exports.UserData16 = UserData16;
  exports.UserData20 = UserData20;
  exports.UserData24 = UserData24;
  exports.UserData32 = UserData32;
  exports.UserFavorite16 = UserFavorite16;
  exports.UserFavorite20 = UserFavorite20;
  exports.UserFavorite24 = UserFavorite24;
  exports.UserFavorite32 = UserFavorite32;
  exports.UserFavoriteAlt16 = UserFavoriteAlt16;
  exports.UserFavoriteAlt20 = UserFavoriteAlt20;
  exports.UserFavoriteAlt24 = UserFavoriteAlt24;
  exports.UserFavoriteAlt32 = UserFavoriteAlt32;
  exports.UserFavoriteAltFilled16 = UserFavoriteAltFilled16;
  exports.UserFavoriteAltFilled20 = UserFavoriteAltFilled20;
  exports.UserFavoriteAltFilled24 = UserFavoriteAltFilled24;
  exports.UserFavoriteAltFilled32 = UserFavoriteAltFilled32;
  exports.UserFilled16 = UserFilled16;
  exports.UserFilled20 = UserFilled20;
  exports.UserFilled24 = UserFilled24;
  exports.UserFilled32 = UserFilled32;
  exports.UserFollow16 = UserFollow16;
  exports.UserFollow20 = UserFollow20;
  exports.UserFollow24 = UserFollow24;
  exports.UserFollow32 = UserFollow32;
  exports.UserIdentification16 = UserIdentification16;
  exports.UserIdentification20 = UserIdentification20;
  exports.UserIdentification24 = UserIdentification24;
  exports.UserIdentification32 = UserIdentification32;
  exports.UserMilitary16 = UserMilitary16;
  exports.UserMilitary20 = UserMilitary20;
  exports.UserMilitary24 = UserMilitary24;
  exports.UserMilitary32 = UserMilitary32;
  exports.UserMultiple16 = UserMultiple16;
  exports.UserMultiple20 = UserMultiple20;
  exports.UserMultiple24 = UserMultiple24;
  exports.UserMultiple32 = UserMultiple32;
  exports.UserOnline16 = UserOnline16;
  exports.UserOnline20 = UserOnline20;
  exports.UserOnline24 = UserOnline24;
  exports.UserOnline32 = UserOnline32;
  exports.UserProfile16 = UserProfile16;
  exports.UserProfile20 = UserProfile20;
  exports.UserProfile24 = UserProfile24;
  exports.UserProfile32 = UserProfile32;
  exports.UserProfileAlt16 = UserProfileAlt16;
  exports.UserProfileAlt20 = UserProfileAlt20;
  exports.UserProfileAlt24 = UserProfileAlt24;
  exports.UserProfileAlt32 = UserProfileAlt32;
  exports.UserRole16 = UserRole16;
  exports.UserRole20 = UserRole20;
  exports.UserRole24 = UserRole24;
  exports.UserRole32 = UserRole32;
  exports.UserServiceDesk16 = UserServiceDesk16;
  exports.UserServiceDesk20 = UserServiceDesk20;
  exports.UserServiceDesk24 = UserServiceDesk24;
  exports.UserServiceDesk32 = UserServiceDesk32;
  exports.UserSettings16 = UserSettings16;
  exports.UserSettings20 = UserSettings20;
  exports.UserSettings24 = UserSettings24;
  exports.UserSettings32 = UserSettings32;
  exports.UserSimulation16 = UserSimulation16;
  exports.UserSimulation20 = UserSimulation20;
  exports.UserSimulation24 = UserSimulation24;
  exports.UserSimulation32 = UserSimulation32;
  exports.UserSpeaker16 = UserSpeaker16;
  exports.UserSpeaker20 = UserSpeaker20;
  exports.UserSpeaker24 = UserSpeaker24;
  exports.UserSpeaker32 = UserSpeaker32;
  exports.UserXRay16 = UserXRay16;
  exports.UserXRay20 = UserXRay20;
  exports.UserXRay24 = UserXRay24;
  exports.UserXRay32 = UserXRay32;
  exports.UvIndex16 = UvIndex16;
  exports.UvIndex20 = UvIndex20;
  exports.UvIndex24 = UvIndex24;
  exports.UvIndex32 = UvIndex32;
  exports.UvIndexAlt16 = UvIndexAlt16;
  exports.UvIndexAlt20 = UvIndexAlt20;
  exports.UvIndexAlt24 = UvIndexAlt24;
  exports.UvIndexAlt32 = UvIndexAlt32;
  exports.UvIndexFilled16 = UvIndexFilled16;
  exports.UvIndexFilled20 = UvIndexFilled20;
  exports.UvIndexFilled24 = UvIndexFilled24;
  exports.UvIndexFilled32 = UvIndexFilled32;
  exports.ValueVariable16 = ValueVariable16;
  exports.ValueVariable20 = ValueVariable20;
  exports.ValueVariable24 = ValueVariable24;
  exports.ValueVariable32 = ValueVariable32;
  exports.Van16 = Van16;
  exports.Van20 = Van20;
  exports.Van24 = Van24;
  exports.Van32 = Van32;
  exports.VegetationAsset16 = VegetationAsset16;
  exports.VegetationAsset20 = VegetationAsset20;
  exports.VegetationAsset24 = VegetationAsset24;
  exports.VegetationAsset32 = VegetationAsset32;
  exports.VehicleApi16 = VehicleApi16;
  exports.VehicleApi20 = VehicleApi20;
  exports.VehicleApi24 = VehicleApi24;
  exports.VehicleApi32 = VehicleApi32;
  exports.VehicleConnected16 = VehicleConnected16;
  exports.VehicleConnected20 = VehicleConnected20;
  exports.VehicleConnected24 = VehicleConnected24;
  exports.VehicleConnected32 = VehicleConnected32;
  exports.VehicleInsights16 = VehicleInsights16;
  exports.VehicleInsights20 = VehicleInsights20;
  exports.VehicleInsights24 = VehicleInsights24;
  exports.VehicleInsights32 = VehicleInsights32;
  exports.VehicleServices16 = VehicleServices16;
  exports.VehicleServices20 = VehicleServices20;
  exports.VehicleServices24 = VehicleServices24;
  exports.VehicleServices32 = VehicleServices32;
  exports.Version16 = Version16;
  exports.Version20 = Version20;
  exports.Version24 = Version24;
  exports.Version32 = Version32;
  exports.VerticalView16 = VerticalView16;
  exports.VerticalView20 = VerticalView20;
  exports.VerticalView24 = VerticalView24;
  exports.VerticalView32 = VerticalView32;
  exports.Video16 = Video16;
  exports.Video20 = Video20;
  exports.Video24 = Video24;
  exports.Video32 = Video32;
  exports.VideoAdd16 = VideoAdd16;
  exports.VideoAdd20 = VideoAdd20;
  exports.VideoAdd24 = VideoAdd24;
  exports.VideoAdd32 = VideoAdd32;
  exports.VideoChat16 = VideoChat16;
  exports.VideoChat20 = VideoChat20;
  exports.VideoChat24 = VideoChat24;
  exports.VideoChat32 = VideoChat32;
  exports.VideoFilled16 = VideoFilled16;
  exports.VideoFilled20 = VideoFilled20;
  exports.VideoFilled24 = VideoFilled24;
  exports.VideoFilled32 = VideoFilled32;
  exports.VideoOff16 = VideoOff16;
  exports.VideoOff20 = VideoOff20;
  exports.VideoOff24 = VideoOff24;
  exports.VideoOff32 = VideoOff32;
  exports.VideoOffFilled16 = VideoOffFilled16;
  exports.VideoOffFilled20 = VideoOffFilled20;
  exports.VideoOffFilled24 = VideoOffFilled24;
  exports.VideoOffFilled32 = VideoOffFilled32;
  exports.View16 = View16;
  exports.View20 = View20;
  exports.View24 = View24;
  exports.View32 = View32;
  exports.ViewFilled16 = ViewFilled16;
  exports.ViewFilled20 = ViewFilled20;
  exports.ViewFilled24 = ViewFilled24;
  exports.ViewFilled32 = ViewFilled32;
  exports.ViewMode_116 = ViewMode_116;
  exports.ViewMode_120 = ViewMode_120;
  exports.ViewMode_124 = ViewMode_124;
  exports.ViewMode_132 = ViewMode_132;
  exports.ViewMode_216 = ViewMode_216;
  exports.ViewMode_220 = ViewMode_220;
  exports.ViewMode_224 = ViewMode_224;
  exports.ViewMode_232 = ViewMode_232;
  exports.ViewNext16 = ViewNext16;
  exports.ViewNext20 = ViewNext20;
  exports.ViewNext24 = ViewNext24;
  exports.ViewNext32 = ViewNext32;
  exports.ViewOff16 = ViewOff16;
  exports.ViewOff20 = ViewOff20;
  exports.ViewOff24 = ViewOff24;
  exports.ViewOff32 = ViewOff32;
  exports.ViewOffFilled16 = ViewOffFilled16;
  exports.ViewOffFilled20 = ViewOffFilled20;
  exports.ViewOffFilled24 = ViewOffFilled24;
  exports.ViewOffFilled32 = ViewOffFilled32;
  exports.VirtualColumn16 = VirtualColumn16;
  exports.VirtualColumn20 = VirtualColumn20;
  exports.VirtualColumn24 = VirtualColumn24;
  exports.VirtualColumn32 = VirtualColumn32;
  exports.VirtualColumnKey16 = VirtualColumnKey16;
  exports.VirtualColumnKey20 = VirtualColumnKey20;
  exports.VirtualColumnKey24 = VirtualColumnKey24;
  exports.VirtualColumnKey32 = VirtualColumnKey32;
  exports.VirtualDesktop16 = VirtualDesktop16;
  exports.VirtualDesktop20 = VirtualDesktop20;
  exports.VirtualDesktop24 = VirtualDesktop24;
  exports.VirtualDesktop32 = VirtualDesktop32;
  exports.VirtualMachine16 = VirtualMachine16;
  exports.VirtualMachine20 = VirtualMachine20;
  exports.VirtualMachine24 = VirtualMachine24;
  exports.VirtualMachine32 = VirtualMachine32;
  exports.VirtualPrivateCloud16 = VirtualPrivateCloud16;
  exports.VirtualPrivateCloud20 = VirtualPrivateCloud20;
  exports.VirtualPrivateCloud24 = VirtualPrivateCloud24;
  exports.VirtualPrivateCloud32 = VirtualPrivateCloud32;
  exports.VirtualPrivateCloudAlt16 = VirtualPrivateCloudAlt16;
  exports.VirtualPrivateCloudAlt20 = VirtualPrivateCloudAlt20;
  exports.VirtualPrivateCloudAlt24 = VirtualPrivateCloudAlt24;
  exports.VirtualPrivateCloudAlt32 = VirtualPrivateCloudAlt32;
  exports.VisualRecognition16 = VisualRecognition16;
  exports.VisualRecognition20 = VisualRecognition20;
  exports.VisualRecognition24 = VisualRecognition24;
  exports.VisualRecognition32 = VisualRecognition32;
  exports.Vlan16 = Vlan16;
  exports.Vlan20 = Vlan20;
  exports.Vlan24 = Vlan24;
  exports.Vlan32 = Vlan32;
  exports.VlanIbm16 = VlanIbm16;
  exports.VlanIbm20 = VlanIbm20;
  exports.VlanIbm24 = VlanIbm24;
  exports.VlanIbm32 = VlanIbm32;
  exports.VmdkDisk16 = VmdkDisk16;
  exports.VmdkDisk20 = VmdkDisk20;
  exports.VmdkDisk24 = VmdkDisk24;
  exports.VmdkDisk32 = VmdkDisk32;
  exports.VoiceActivate16 = VoiceActivate16;
  exports.VoiceActivate20 = VoiceActivate20;
  exports.VoiceActivate24 = VoiceActivate24;
  exports.VoiceActivate32 = VoiceActivate32;
  exports.Voicemail16 = Voicemail16;
  exports.Voicemail20 = Voicemail20;
  exports.Voicemail24 = Voicemail24;
  exports.Voicemail32 = Voicemail32;
  exports.VolumeBlockStorage16 = VolumeBlockStorage16;
  exports.VolumeBlockStorage20 = VolumeBlockStorage20;
  exports.VolumeBlockStorage24 = VolumeBlockStorage24;
  exports.VolumeBlockStorage32 = VolumeBlockStorage32;
  exports.VolumeDown16 = VolumeDown16;
  exports.VolumeDown20 = VolumeDown20;
  exports.VolumeDown24 = VolumeDown24;
  exports.VolumeDown32 = VolumeDown32;
  exports.VolumeDownAlt16 = VolumeDownAlt16;
  exports.VolumeDownAlt20 = VolumeDownAlt20;
  exports.VolumeDownAlt24 = VolumeDownAlt24;
  exports.VolumeDownAlt32 = VolumeDownAlt32;
  exports.VolumeDownFilled16 = VolumeDownFilled16;
  exports.VolumeDownFilled20 = VolumeDownFilled20;
  exports.VolumeDownFilled24 = VolumeDownFilled24;
  exports.VolumeDownFilled32 = VolumeDownFilled32;
  exports.VolumeDownFilledAlt16 = VolumeDownFilledAlt16;
  exports.VolumeDownFilledAlt20 = VolumeDownFilledAlt20;
  exports.VolumeDownFilledAlt24 = VolumeDownFilledAlt24;
  exports.VolumeDownFilledAlt32 = VolumeDownFilledAlt32;
  exports.VolumeFileStorage16 = VolumeFileStorage16;
  exports.VolumeFileStorage20 = VolumeFileStorage20;
  exports.VolumeFileStorage24 = VolumeFileStorage24;
  exports.VolumeFileStorage32 = VolumeFileStorage32;
  exports.VolumeMute16 = VolumeMute16;
  exports.VolumeMute20 = VolumeMute20;
  exports.VolumeMute24 = VolumeMute24;
  exports.VolumeMute32 = VolumeMute32;
  exports.VolumeMuteFilled16 = VolumeMuteFilled16;
  exports.VolumeMuteFilled20 = VolumeMuteFilled20;
  exports.VolumeMuteFilled24 = VolumeMuteFilled24;
  exports.VolumeMuteFilled32 = VolumeMuteFilled32;
  exports.VolumeObjectStorage16 = VolumeObjectStorage16;
  exports.VolumeObjectStorage20 = VolumeObjectStorage20;
  exports.VolumeObjectStorage24 = VolumeObjectStorage24;
  exports.VolumeObjectStorage32 = VolumeObjectStorage32;
  exports.VolumeUp16 = VolumeUp16;
  exports.VolumeUp20 = VolumeUp20;
  exports.VolumeUp24 = VolumeUp24;
  exports.VolumeUp32 = VolumeUp32;
  exports.VolumeUpAlt16 = VolumeUpAlt16;
  exports.VolumeUpAlt20 = VolumeUpAlt20;
  exports.VolumeUpAlt24 = VolumeUpAlt24;
  exports.VolumeUpAlt32 = VolumeUpAlt32;
  exports.VolumeUpFilled16 = VolumeUpFilled16;
  exports.VolumeUpFilled20 = VolumeUpFilled20;
  exports.VolumeUpFilled24 = VolumeUpFilled24;
  exports.VolumeUpFilled32 = VolumeUpFilled32;
  exports.VolumeUpFilledAlt16 = VolumeUpFilledAlt16;
  exports.VolumeUpFilledAlt20 = VolumeUpFilledAlt20;
  exports.VolumeUpFilledAlt24 = VolumeUpFilledAlt24;
  exports.VolumeUpFilledAlt32 = VolumeUpFilledAlt32;
  exports.Vpn16 = Vpn16;
  exports.Vpn20 = Vpn20;
  exports.Vpn24 = Vpn24;
  exports.Vpn32 = Vpn32;
  exports.VpnConnection16 = VpnConnection16;
  exports.VpnConnection20 = VpnConnection20;
  exports.VpnConnection24 = VpnConnection24;
  exports.VpnConnection32 = VpnConnection32;
  exports.VpnPolicy16 = VpnPolicy16;
  exports.VpnPolicy20 = VpnPolicy20;
  exports.VpnPolicy24 = VpnPolicy24;
  exports.VpnPolicy32 = VpnPolicy32;
  exports.Wallet16 = Wallet16;
  exports.Wallet20 = Wallet20;
  exports.Wallet24 = Wallet24;
  exports.Wallet32 = Wallet32;
  exports.Warning16 = Warning16;
  exports.Warning20 = Warning20;
  exports.Warning24 = Warning24;
  exports.Warning32 = Warning32;
  exports.WarningAlt16 = WarningAlt16;
  exports.WarningAlt20 = WarningAlt20;
  exports.WarningAlt24 = WarningAlt24;
  exports.WarningAlt32 = WarningAlt32;
  exports.WarningAltFilled16 = WarningAltFilled16;
  exports.WarningAltFilled20 = WarningAltFilled20;
  exports.WarningAltFilled24 = WarningAltFilled24;
  exports.WarningAltFilled32 = WarningAltFilled32;
  exports.WarningAltInverted16 = WarningAltInverted16;
  exports.WarningAltInverted20 = WarningAltInverted20;
  exports.WarningAltInverted24 = WarningAltInverted24;
  exports.WarningAltInverted32 = WarningAltInverted32;
  exports.WarningAltInvertedFilled16 = WarningAltInvertedFilled16;
  exports.WarningAltInvertedFilled20 = WarningAltInvertedFilled20;
  exports.WarningAltInvertedFilled24 = WarningAltInvertedFilled24;
  exports.WarningAltInvertedFilled32 = WarningAltInvertedFilled32;
  exports.WarningFilled16 = WarningFilled16;
  exports.WarningFilled20 = WarningFilled20;
  exports.WarningFilled24 = WarningFilled24;
  exports.WarningFilled32 = WarningFilled32;
  exports.WarningHex16 = WarningHex16;
  exports.WarningHex20 = WarningHex20;
  exports.WarningHex24 = WarningHex24;
  exports.WarningHex32 = WarningHex32;
  exports.WarningHexFilled16 = WarningHexFilled16;
  exports.WarningHexFilled20 = WarningHexFilled20;
  exports.WarningHexFilled24 = WarningHexFilled24;
  exports.WarningHexFilled32 = WarningHexFilled32;
  exports.WarningOther16 = WarningOther16;
  exports.WarningOther20 = WarningOther20;
  exports.WarningOther24 = WarningOther24;
  exports.WarningOther32 = WarningOther32;
  exports.WarningSquare16 = WarningSquare16;
  exports.WarningSquare20 = WarningSquare20;
  exports.WarningSquare24 = WarningSquare24;
  exports.WarningSquare32 = WarningSquare32;
  exports.WarningSquareFilled16 = WarningSquareFilled16;
  exports.WarningSquareFilled20 = WarningSquareFilled20;
  exports.WarningSquareFilled24 = WarningSquareFilled24;
  exports.WarningSquareFilled32 = WarningSquareFilled32;
  exports.Watch16 = Watch16;
  exports.Watch20 = Watch20;
  exports.Watch24 = Watch24;
  exports.Watch32 = Watch32;
  exports.Watson16 = Watson16;
  exports.Watson20 = Watson20;
  exports.Watson24 = Watson24;
  exports.Watson32 = Watson32;
  exports.WatsonHealth3DCursor16 = WatsonHealth3DCursor16;
  exports.WatsonHealth3DCursor20 = WatsonHealth3DCursor20;
  exports.WatsonHealth3DCursor24 = WatsonHealth3DCursor24;
  exports.WatsonHealth3DCursor32 = WatsonHealth3DCursor32;
  exports.WatsonHealth3DCursorAlt16 = WatsonHealth3DCursorAlt16;
  exports.WatsonHealth3DCursorAlt20 = WatsonHealth3DCursorAlt20;
  exports.WatsonHealth3DCursorAlt24 = WatsonHealth3DCursorAlt24;
  exports.WatsonHealth3DCursorAlt32 = WatsonHealth3DCursorAlt32;
  exports.WatsonHealth3DCurveAutoColon16 = WatsonHealth3DCurveAutoColon16;
  exports.WatsonHealth3DCurveAutoColon20 = WatsonHealth3DCurveAutoColon20;
  exports.WatsonHealth3DCurveAutoColon24 = WatsonHealth3DCurveAutoColon24;
  exports.WatsonHealth3DCurveAutoColon32 = WatsonHealth3DCurveAutoColon32;
  exports.WatsonHealth3DCurveAutoVessels16 = WatsonHealth3DCurveAutoVessels16;
  exports.WatsonHealth3DCurveAutoVessels20 = WatsonHealth3DCurveAutoVessels20;
  exports.WatsonHealth3DCurveAutoVessels24 = WatsonHealth3DCurveAutoVessels24;
  exports.WatsonHealth3DCurveAutoVessels32 = WatsonHealth3DCurveAutoVessels32;
  exports.WatsonHealth3DCurveManual16 = WatsonHealth3DCurveManual16;
  exports.WatsonHealth3DCurveManual20 = WatsonHealth3DCurveManual20;
  exports.WatsonHealth3DCurveManual24 = WatsonHealth3DCurveManual24;
  exports.WatsonHealth3DCurveManual32 = WatsonHealth3DCurveManual32;
  exports.WatsonHealth3DICa16 = WatsonHealth3DICa16;
  exports.WatsonHealth3DICa20 = WatsonHealth3DICa20;
  exports.WatsonHealth3DICa24 = WatsonHealth3DICa24;
  exports.WatsonHealth3DICa32 = WatsonHealth3DICa32;
  exports.WatsonHealth3DMprToggle16 = WatsonHealth3DMprToggle16;
  exports.WatsonHealth3DMprToggle20 = WatsonHealth3DMprToggle20;
  exports.WatsonHealth3DMprToggle24 = WatsonHealth3DMprToggle24;
  exports.WatsonHealth3DMprToggle32 = WatsonHealth3DMprToggle32;
  exports.WatsonHealth3DPrintMesh16 = WatsonHealth3DPrintMesh16;
  exports.WatsonHealth3DPrintMesh20 = WatsonHealth3DPrintMesh20;
  exports.WatsonHealth3DPrintMesh24 = WatsonHealth3DPrintMesh24;
  exports.WatsonHealth3DPrintMesh32 = WatsonHealth3DPrintMesh32;
  exports.WatsonHealth3DSoftware16 = WatsonHealth3DSoftware16;
  exports.WatsonHealth3DSoftware20 = WatsonHealth3DSoftware20;
  exports.WatsonHealth3DSoftware24 = WatsonHealth3DSoftware24;
  exports.WatsonHealth3DSoftware32 = WatsonHealth3DSoftware32;
  exports.WatsonHealth3rdPartyConnected16 = WatsonHealth3rdPartyConnected16;
  exports.WatsonHealth3rdPartyConnected20 = WatsonHealth3rdPartyConnected20;
  exports.WatsonHealth3rdPartyConnected24 = WatsonHealth3rdPartyConnected24;
  exports.WatsonHealth3rdPartyConnected32 = WatsonHealth3rdPartyConnected32;
  exports.WatsonHealthAiResults16 = WatsonHealthAiResults16;
  exports.WatsonHealthAiResults20 = WatsonHealthAiResults20;
  exports.WatsonHealthAiResults24 = WatsonHealthAiResults24;
  exports.WatsonHealthAiResults32 = WatsonHealthAiResults32;
  exports.WatsonHealthAiResultsHigh16 = WatsonHealthAiResultsHigh16;
  exports.WatsonHealthAiResultsHigh20 = WatsonHealthAiResultsHigh20;
  exports.WatsonHealthAiResultsHigh24 = WatsonHealthAiResultsHigh24;
  exports.WatsonHealthAiResultsHigh32 = WatsonHealthAiResultsHigh32;
  exports.WatsonHealthAiResultsLow16 = WatsonHealthAiResultsLow16;
  exports.WatsonHealthAiResultsLow20 = WatsonHealthAiResultsLow20;
  exports.WatsonHealthAiResultsLow24 = WatsonHealthAiResultsLow24;
  exports.WatsonHealthAiResultsLow32 = WatsonHealthAiResultsLow32;
  exports.WatsonHealthAiResultsMedium16 = WatsonHealthAiResultsMedium16;
  exports.WatsonHealthAiResultsMedium20 = WatsonHealthAiResultsMedium20;
  exports.WatsonHealthAiResultsMedium24 = WatsonHealthAiResultsMedium24;
  exports.WatsonHealthAiResultsMedium32 = WatsonHealthAiResultsMedium32;
  exports.WatsonHealthAiResultsUrgent16 = WatsonHealthAiResultsUrgent16;
  exports.WatsonHealthAiResultsUrgent20 = WatsonHealthAiResultsUrgent20;
  exports.WatsonHealthAiResultsUrgent24 = WatsonHealthAiResultsUrgent24;
  exports.WatsonHealthAiResultsUrgent32 = WatsonHealthAiResultsUrgent32;
  exports.WatsonHealthAiResultsVeryHigh16 = WatsonHealthAiResultsVeryHigh16;
  exports.WatsonHealthAiResultsVeryHigh20 = WatsonHealthAiResultsVeryHigh20;
  exports.WatsonHealthAiResultsVeryHigh24 = WatsonHealthAiResultsVeryHigh24;
  exports.WatsonHealthAiResultsVeryHigh32 = WatsonHealthAiResultsVeryHigh32;
  exports.WatsonHealthAiStatus16 = WatsonHealthAiStatus16;
  exports.WatsonHealthAiStatus20 = WatsonHealthAiStatus20;
  exports.WatsonHealthAiStatus24 = WatsonHealthAiStatus24;
  exports.WatsonHealthAiStatus32 = WatsonHealthAiStatus32;
  exports.WatsonHealthAiStatusComplete16 = WatsonHealthAiStatusComplete16;
  exports.WatsonHealthAiStatusComplete20 = WatsonHealthAiStatusComplete20;
  exports.WatsonHealthAiStatusComplete24 = WatsonHealthAiStatusComplete24;
  exports.WatsonHealthAiStatusComplete32 = WatsonHealthAiStatusComplete32;
  exports.WatsonHealthAiStatusFailed16 = WatsonHealthAiStatusFailed16;
  exports.WatsonHealthAiStatusFailed20 = WatsonHealthAiStatusFailed20;
  exports.WatsonHealthAiStatusFailed24 = WatsonHealthAiStatusFailed24;
  exports.WatsonHealthAiStatusFailed32 = WatsonHealthAiStatusFailed32;
  exports.WatsonHealthAiStatusInProgress16 = WatsonHealthAiStatusInProgress16;
  exports.WatsonHealthAiStatusInProgress20 = WatsonHealthAiStatusInProgress20;
  exports.WatsonHealthAiStatusInProgress24 = WatsonHealthAiStatusInProgress24;
  exports.WatsonHealthAiStatusInProgress32 = WatsonHealthAiStatusInProgress32;
  exports.WatsonHealthAiStatusQueued16 = WatsonHealthAiStatusQueued16;
  exports.WatsonHealthAiStatusQueued20 = WatsonHealthAiStatusQueued20;
  exports.WatsonHealthAiStatusQueued24 = WatsonHealthAiStatusQueued24;
  exports.WatsonHealthAiStatusQueued32 = WatsonHealthAiStatusQueued32;
  exports.WatsonHealthAiStatusRejected16 = WatsonHealthAiStatusRejected16;
  exports.WatsonHealthAiStatusRejected20 = WatsonHealthAiStatusRejected20;
  exports.WatsonHealthAiStatusRejected24 = WatsonHealthAiStatusRejected24;
  exports.WatsonHealthAiStatusRejected32 = WatsonHealthAiStatusRejected32;
  exports.WatsonHealthAngle16 = WatsonHealthAngle16;
  exports.WatsonHealthAngle20 = WatsonHealthAngle20;
  exports.WatsonHealthAngle24 = WatsonHealthAngle24;
  exports.WatsonHealthAngle32 = WatsonHealthAngle32;
  exports.WatsonHealthAnnotationVisibility16 = WatsonHealthAnnotationVisibility16;
  exports.WatsonHealthAnnotationVisibility20 = WatsonHealthAnnotationVisibility20;
  exports.WatsonHealthAnnotationVisibility24 = WatsonHealthAnnotationVisibility24;
  exports.WatsonHealthAnnotationVisibility32 = WatsonHealthAnnotationVisibility32;
  exports.WatsonHealthArrowAnnotation16 = WatsonHealthArrowAnnotation16;
  exports.WatsonHealthArrowAnnotation20 = WatsonHealthArrowAnnotation20;
  exports.WatsonHealthArrowAnnotation24 = WatsonHealthArrowAnnotation24;
  exports.WatsonHealthArrowAnnotation32 = WatsonHealthArrowAnnotation32;
  exports.WatsonHealthAutoScroll16 = WatsonHealthAutoScroll16;
  exports.WatsonHealthAutoScroll20 = WatsonHealthAutoScroll20;
  exports.WatsonHealthAutoScroll24 = WatsonHealthAutoScroll24;
  exports.WatsonHealthAutoScroll32 = WatsonHealthAutoScroll32;
  exports.WatsonHealthBrushFreehand16 = WatsonHealthBrushFreehand16;
  exports.WatsonHealthBrushFreehand20 = WatsonHealthBrushFreehand20;
  exports.WatsonHealthBrushFreehand24 = WatsonHealthBrushFreehand24;
  exports.WatsonHealthBrushFreehand32 = WatsonHealthBrushFreehand32;
  exports.WatsonHealthBrushPolygon16 = WatsonHealthBrushPolygon16;
  exports.WatsonHealthBrushPolygon20 = WatsonHealthBrushPolygon20;
  exports.WatsonHealthBrushPolygon24 = WatsonHealthBrushPolygon24;
  exports.WatsonHealthBrushPolygon32 = WatsonHealthBrushPolygon32;
  exports.WatsonHealthCdArchive16 = WatsonHealthCdArchive16;
  exports.WatsonHealthCdArchive20 = WatsonHealthCdArchive20;
  exports.WatsonHealthCdArchive24 = WatsonHealthCdArchive24;
  exports.WatsonHealthCdArchive32 = WatsonHealthCdArchive32;
  exports.WatsonHealthCdCreateArchive16 = WatsonHealthCdCreateArchive16;
  exports.WatsonHealthCdCreateArchive20 = WatsonHealthCdCreateArchive20;
  exports.WatsonHealthCdCreateArchive24 = WatsonHealthCdCreateArchive24;
  exports.WatsonHealthCdCreateArchive32 = WatsonHealthCdCreateArchive32;
  exports.WatsonHealthCdCreateExchange16 = WatsonHealthCdCreateExchange16;
  exports.WatsonHealthCdCreateExchange20 = WatsonHealthCdCreateExchange20;
  exports.WatsonHealthCdCreateExchange24 = WatsonHealthCdCreateExchange24;
  exports.WatsonHealthCdCreateExchange32 = WatsonHealthCdCreateExchange32;
  exports.WatsonHealthCircleMeasurement16 = WatsonHealthCircleMeasurement16;
  exports.WatsonHealthCircleMeasurement20 = WatsonHealthCircleMeasurement20;
  exports.WatsonHealthCircleMeasurement24 = WatsonHealthCircleMeasurement24;
  exports.WatsonHealthCircleMeasurement32 = WatsonHealthCircleMeasurement32;
  exports.WatsonHealthCobbAngle16 = WatsonHealthCobbAngle16;
  exports.WatsonHealthCobbAngle20 = WatsonHealthCobbAngle20;
  exports.WatsonHealthCobbAngle24 = WatsonHealthCobbAngle24;
  exports.WatsonHealthCobbAngle32 = WatsonHealthCobbAngle32;
  exports.WatsonHealthContourDraw16 = WatsonHealthContourDraw16;
  exports.WatsonHealthContourDraw20 = WatsonHealthContourDraw20;
  exports.WatsonHealthContourDraw24 = WatsonHealthContourDraw24;
  exports.WatsonHealthContourDraw32 = WatsonHealthContourDraw32;
  exports.WatsonHealthContourEdit16 = WatsonHealthContourEdit16;
  exports.WatsonHealthContourEdit20 = WatsonHealthContourEdit20;
  exports.WatsonHealthContourEdit24 = WatsonHealthContourEdit24;
  exports.WatsonHealthContourEdit32 = WatsonHealthContourEdit32;
  exports.WatsonHealthContourFinding16 = WatsonHealthContourFinding16;
  exports.WatsonHealthContourFinding20 = WatsonHealthContourFinding20;
  exports.WatsonHealthContourFinding24 = WatsonHealthContourFinding24;
  exports.WatsonHealthContourFinding32 = WatsonHealthContourFinding32;
  exports.WatsonHealthCrossReference16 = WatsonHealthCrossReference16;
  exports.WatsonHealthCrossReference20 = WatsonHealthCrossReference20;
  exports.WatsonHealthCrossReference24 = WatsonHealthCrossReference24;
  exports.WatsonHealthCrossReference32 = WatsonHealthCrossReference32;
  exports.WatsonHealthCutInHalf16 = WatsonHealthCutInHalf16;
  exports.WatsonHealthCutInHalf20 = WatsonHealthCutInHalf20;
  exports.WatsonHealthCutInHalf24 = WatsonHealthCutInHalf24;
  exports.WatsonHealthCutInHalf32 = WatsonHealthCutInHalf32;
  exports.WatsonHealthDenominate16 = WatsonHealthDenominate16;
  exports.WatsonHealthDenominate20 = WatsonHealthDenominate20;
  exports.WatsonHealthDenominate24 = WatsonHealthDenominate24;
  exports.WatsonHealthDenominate32 = WatsonHealthDenominate32;
  exports.WatsonHealthDicomOverlay16 = WatsonHealthDicomOverlay16;
  exports.WatsonHealthDicomOverlay20 = WatsonHealthDicomOverlay20;
  exports.WatsonHealthDicomOverlay24 = WatsonHealthDicomOverlay24;
  exports.WatsonHealthDicomOverlay32 = WatsonHealthDicomOverlay32;
  exports.WatsonHealthDicom_600016 = WatsonHealthDicom_600016;
  exports.WatsonHealthDicom_600020 = WatsonHealthDicom_600020;
  exports.WatsonHealthDicom_600024 = WatsonHealthDicom_600024;
  exports.WatsonHealthDicom_600032 = WatsonHealthDicom_600032;
  exports.WatsonHealthDna16 = WatsonHealthDna16;
  exports.WatsonHealthDna20 = WatsonHealthDna20;
  exports.WatsonHealthDna24 = WatsonHealthDna24;
  exports.WatsonHealthDna32 = WatsonHealthDna32;
  exports.WatsonHealthDownloadStudy16 = WatsonHealthDownloadStudy16;
  exports.WatsonHealthDownloadStudy20 = WatsonHealthDownloadStudy20;
  exports.WatsonHealthDownloadStudy24 = WatsonHealthDownloadStudy24;
  exports.WatsonHealthDownloadStudy32 = WatsonHealthDownloadStudy32;
  exports.WatsonHealthEdgeEnhancement16 = WatsonHealthEdgeEnhancement16;
  exports.WatsonHealthEdgeEnhancement20 = WatsonHealthEdgeEnhancement20;
  exports.WatsonHealthEdgeEnhancement24 = WatsonHealthEdgeEnhancement24;
  exports.WatsonHealthEdgeEnhancement32 = WatsonHealthEdgeEnhancement32;
  exports.WatsonHealthEdgeEnhancement_0116 = WatsonHealthEdgeEnhancement_0116;
  exports.WatsonHealthEdgeEnhancement_0120 = WatsonHealthEdgeEnhancement_0120;
  exports.WatsonHealthEdgeEnhancement_0124 = WatsonHealthEdgeEnhancement_0124;
  exports.WatsonHealthEdgeEnhancement_0132 = WatsonHealthEdgeEnhancement_0132;
  exports.WatsonHealthEdgeEnhancement_0216 = WatsonHealthEdgeEnhancement_0216;
  exports.WatsonHealthEdgeEnhancement_0220 = WatsonHealthEdgeEnhancement_0220;
  exports.WatsonHealthEdgeEnhancement_0224 = WatsonHealthEdgeEnhancement_0224;
  exports.WatsonHealthEdgeEnhancement_0232 = WatsonHealthEdgeEnhancement_0232;
  exports.WatsonHealthEdgeEnhancement_0316 = WatsonHealthEdgeEnhancement_0316;
  exports.WatsonHealthEdgeEnhancement_0320 = WatsonHealthEdgeEnhancement_0320;
  exports.WatsonHealthEdgeEnhancement_0324 = WatsonHealthEdgeEnhancement_0324;
  exports.WatsonHealthEdgeEnhancement_0332 = WatsonHealthEdgeEnhancement_0332;
  exports.WatsonHealthEditFilter16 = WatsonHealthEditFilter16;
  exports.WatsonHealthEditFilter20 = WatsonHealthEditFilter20;
  exports.WatsonHealthEditFilter24 = WatsonHealthEditFilter24;
  exports.WatsonHealthEditFilter32 = WatsonHealthEditFilter32;
  exports.WatsonHealthErase_3D16 = WatsonHealthErase_3D16;
  exports.WatsonHealthErase_3D20 = WatsonHealthErase_3D20;
  exports.WatsonHealthErase_3D24 = WatsonHealthErase_3D24;
  exports.WatsonHealthErase_3D32 = WatsonHealthErase_3D32;
  exports.WatsonHealthFusionBlender16 = WatsonHealthFusionBlender16;
  exports.WatsonHealthFusionBlender20 = WatsonHealthFusionBlender20;
  exports.WatsonHealthFusionBlender24 = WatsonHealthFusionBlender24;
  exports.WatsonHealthFusionBlender32 = WatsonHealthFusionBlender32;
  exports.WatsonHealthHangingProtocol16 = WatsonHealthHangingProtocol16;
  exports.WatsonHealthHangingProtocol20 = WatsonHealthHangingProtocol20;
  exports.WatsonHealthHangingProtocol24 = WatsonHealthHangingProtocol24;
  exports.WatsonHealthHangingProtocol32 = WatsonHealthHangingProtocol32;
  exports.WatsonHealthHl7Attributes16 = WatsonHealthHl7Attributes16;
  exports.WatsonHealthHl7Attributes20 = WatsonHealthHl7Attributes20;
  exports.WatsonHealthHl7Attributes24 = WatsonHealthHl7Attributes24;
  exports.WatsonHealthHl7Attributes32 = WatsonHealthHl7Attributes32;
  exports.WatsonHealthHoleFilling16 = WatsonHealthHoleFilling16;
  exports.WatsonHealthHoleFilling20 = WatsonHealthHoleFilling20;
  exports.WatsonHealthHoleFilling24 = WatsonHealthHoleFilling24;
  exports.WatsonHealthHoleFilling32 = WatsonHealthHoleFilling32;
  exports.WatsonHealthHoleFillingCursor16 = WatsonHealthHoleFillingCursor16;
  exports.WatsonHealthHoleFillingCursor20 = WatsonHealthHoleFillingCursor20;
  exports.WatsonHealthHoleFillingCursor24 = WatsonHealthHoleFillingCursor24;
  exports.WatsonHealthHoleFillingCursor32 = WatsonHealthHoleFillingCursor32;
  exports.WatsonHealthICa_2D16 = WatsonHealthICa_2D16;
  exports.WatsonHealthICa_2D20 = WatsonHealthICa_2D20;
  exports.WatsonHealthICa_2D24 = WatsonHealthICa_2D24;
  exports.WatsonHealthICa_2D32 = WatsonHealthICa_2D32;
  exports.WatsonHealthInteractiveSegmentationCursor16 = WatsonHealthInteractiveSegmentationCursor16;
  exports.WatsonHealthInteractiveSegmentationCursor20 = WatsonHealthInteractiveSegmentationCursor20;
  exports.WatsonHealthInteractiveSegmentationCursor24 = WatsonHealthInteractiveSegmentationCursor24;
  exports.WatsonHealthInteractiveSegmentationCursor32 = WatsonHealthInteractiveSegmentationCursor32;
  exports.WatsonHealthLaunchStudy_116 = WatsonHealthLaunchStudy_116;
  exports.WatsonHealthLaunchStudy_120 = WatsonHealthLaunchStudy_120;
  exports.WatsonHealthLaunchStudy_124 = WatsonHealthLaunchStudy_124;
  exports.WatsonHealthLaunchStudy_132 = WatsonHealthLaunchStudy_132;
  exports.WatsonHealthLaunchStudy_216 = WatsonHealthLaunchStudy_216;
  exports.WatsonHealthLaunchStudy_220 = WatsonHealthLaunchStudy_220;
  exports.WatsonHealthLaunchStudy_224 = WatsonHealthLaunchStudy_224;
  exports.WatsonHealthLaunchStudy_232 = WatsonHealthLaunchStudy_232;
  exports.WatsonHealthLaunchStudy_316 = WatsonHealthLaunchStudy_316;
  exports.WatsonHealthLaunchStudy_320 = WatsonHealthLaunchStudy_320;
  exports.WatsonHealthLaunchStudy_324 = WatsonHealthLaunchStudy_324;
  exports.WatsonHealthLaunchStudy_332 = WatsonHealthLaunchStudy_332;
  exports.WatsonHealthMagnify16 = WatsonHealthMagnify16;
  exports.WatsonHealthMagnify20 = WatsonHealthMagnify20;
  exports.WatsonHealthMagnify24 = WatsonHealthMagnify24;
  exports.WatsonHealthMagnify32 = WatsonHealthMagnify32;
  exports.WatsonHealthMammogram16 = WatsonHealthMammogram16;
  exports.WatsonHealthMammogram20 = WatsonHealthMammogram20;
  exports.WatsonHealthMammogram24 = WatsonHealthMammogram24;
  exports.WatsonHealthMammogram32 = WatsonHealthMammogram32;
  exports.WatsonHealthNominate16 = WatsonHealthNominate16;
  exports.WatsonHealthNominate20 = WatsonHealthNominate20;
  exports.WatsonHealthNominate24 = WatsonHealthNominate24;
  exports.WatsonHealthNominate32 = WatsonHealthNominate32;
  exports.WatsonHealthPageScroll16 = WatsonHealthPageScroll16;
  exports.WatsonHealthPageScroll20 = WatsonHealthPageScroll20;
  exports.WatsonHealthPageScroll24 = WatsonHealthPageScroll24;
  exports.WatsonHealthPageScroll32 = WatsonHealthPageScroll32;
  exports.WatsonHealthPetImageB16 = WatsonHealthPetImageB16;
  exports.WatsonHealthPetImageB20 = WatsonHealthPetImageB20;
  exports.WatsonHealthPetImageB24 = WatsonHealthPetImageB24;
  exports.WatsonHealthPetImageB32 = WatsonHealthPetImageB32;
  exports.WatsonHealthPetImageO16 = WatsonHealthPetImageO16;
  exports.WatsonHealthPetImageO20 = WatsonHealthPetImageO20;
  exports.WatsonHealthPetImageO24 = WatsonHealthPetImageO24;
  exports.WatsonHealthPetImageO32 = WatsonHealthPetImageO32;
  exports.WatsonHealthPointerText16 = WatsonHealthPointerText16;
  exports.WatsonHealthPointerText20 = WatsonHealthPointerText20;
  exports.WatsonHealthPointerText24 = WatsonHealthPointerText24;
  exports.WatsonHealthPointerText32 = WatsonHealthPointerText32;
  exports.WatsonHealthQcLaunch16 = WatsonHealthQcLaunch16;
  exports.WatsonHealthQcLaunch20 = WatsonHealthQcLaunch20;
  exports.WatsonHealthQcLaunch24 = WatsonHealthQcLaunch24;
  exports.WatsonHealthQcLaunch32 = WatsonHealthQcLaunch32;
  exports.WatsonHealthRegionAnalysisArea16 = WatsonHealthRegionAnalysisArea16;
  exports.WatsonHealthRegionAnalysisArea20 = WatsonHealthRegionAnalysisArea20;
  exports.WatsonHealthRegionAnalysisArea24 = WatsonHealthRegionAnalysisArea24;
  exports.WatsonHealthRegionAnalysisArea32 = WatsonHealthRegionAnalysisArea32;
  exports.WatsonHealthRegionAnalysisVolume16 = WatsonHealthRegionAnalysisVolume16;
  exports.WatsonHealthRegionAnalysisVolume20 = WatsonHealthRegionAnalysisVolume20;
  exports.WatsonHealthRegionAnalysisVolume24 = WatsonHealthRegionAnalysisVolume24;
  exports.WatsonHealthRegionAnalysisVolume32 = WatsonHealthRegionAnalysisVolume32;
  exports.WatsonHealthRegistration16 = WatsonHealthRegistration16;
  exports.WatsonHealthRegistration20 = WatsonHealthRegistration20;
  exports.WatsonHealthRegistration24 = WatsonHealthRegistration24;
  exports.WatsonHealthRegistration32 = WatsonHealthRegistration32;
  exports.WatsonHealthRotate_18016 = WatsonHealthRotate_18016;
  exports.WatsonHealthRotate_18020 = WatsonHealthRotate_18020;
  exports.WatsonHealthRotate_18024 = WatsonHealthRotate_18024;
  exports.WatsonHealthRotate_18032 = WatsonHealthRotate_18032;
  exports.WatsonHealthRotate_36016 = WatsonHealthRotate_36016;
  exports.WatsonHealthRotate_36020 = WatsonHealthRotate_36020;
  exports.WatsonHealthRotate_36024 = WatsonHealthRotate_36024;
  exports.WatsonHealthRotate_36032 = WatsonHealthRotate_36032;
  exports.WatsonHealthSaveAnnotation16 = WatsonHealthSaveAnnotation16;
  exports.WatsonHealthSaveAnnotation20 = WatsonHealthSaveAnnotation20;
  exports.WatsonHealthSaveAnnotation24 = WatsonHealthSaveAnnotation24;
  exports.WatsonHealthSaveAnnotation32 = WatsonHealthSaveAnnotation32;
  exports.WatsonHealthSaveImage16 = WatsonHealthSaveImage16;
  exports.WatsonHealthSaveImage20 = WatsonHealthSaveImage20;
  exports.WatsonHealthSaveImage24 = WatsonHealthSaveImage24;
  exports.WatsonHealthSaveImage32 = WatsonHealthSaveImage32;
  exports.WatsonHealthSaveSeries16 = WatsonHealthSaveSeries16;
  exports.WatsonHealthSaveSeries20 = WatsonHealthSaveSeries20;
  exports.WatsonHealthSaveSeries24 = WatsonHealthSaveSeries24;
  exports.WatsonHealthSaveSeries32 = WatsonHealthSaveSeries32;
  exports.WatsonHealthScalpelCursor16 = WatsonHealthScalpelCursor16;
  exports.WatsonHealthScalpelCursor20 = WatsonHealthScalpelCursor20;
  exports.WatsonHealthScalpelCursor24 = WatsonHealthScalpelCursor24;
  exports.WatsonHealthScalpelCursor32 = WatsonHealthScalpelCursor32;
  exports.WatsonHealthScalpelLasso16 = WatsonHealthScalpelLasso16;
  exports.WatsonHealthScalpelLasso20 = WatsonHealthScalpelLasso20;
  exports.WatsonHealthScalpelLasso24 = WatsonHealthScalpelLasso24;
  exports.WatsonHealthScalpelLasso32 = WatsonHealthScalpelLasso32;
  exports.WatsonHealthScalpelSelect16 = WatsonHealthScalpelSelect16;
  exports.WatsonHealthScalpelSelect20 = WatsonHealthScalpelSelect20;
  exports.WatsonHealthScalpelSelect24 = WatsonHealthScalpelSelect24;
  exports.WatsonHealthScalpelSelect32 = WatsonHealthScalpelSelect32;
  exports.WatsonHealthSmoothing16 = WatsonHealthSmoothing16;
  exports.WatsonHealthSmoothing20 = WatsonHealthSmoothing20;
  exports.WatsonHealthSmoothing24 = WatsonHealthSmoothing24;
  exports.WatsonHealthSmoothing32 = WatsonHealthSmoothing32;
  exports.WatsonHealthSmoothingCursor16 = WatsonHealthSmoothingCursor16;
  exports.WatsonHealthSmoothingCursor20 = WatsonHealthSmoothingCursor20;
  exports.WatsonHealthSmoothingCursor24 = WatsonHealthSmoothingCursor24;
  exports.WatsonHealthSmoothingCursor32 = WatsonHealthSmoothingCursor32;
  exports.WatsonHealthSpineLabel16 = WatsonHealthSpineLabel16;
  exports.WatsonHealthSpineLabel20 = WatsonHealthSpineLabel20;
  exports.WatsonHealthSpineLabel24 = WatsonHealthSpineLabel24;
  exports.WatsonHealthSpineLabel32 = WatsonHealthSpineLabel32;
  exports.WatsonHealthSplitDiscard16 = WatsonHealthSplitDiscard16;
  exports.WatsonHealthSplitDiscard20 = WatsonHealthSplitDiscard20;
  exports.WatsonHealthSplitDiscard24 = WatsonHealthSplitDiscard24;
  exports.WatsonHealthSplitDiscard32 = WatsonHealthSplitDiscard32;
  exports.WatsonHealthStackedMove16 = WatsonHealthStackedMove16;
  exports.WatsonHealthStackedMove20 = WatsonHealthStackedMove20;
  exports.WatsonHealthStackedMove24 = WatsonHealthStackedMove24;
  exports.WatsonHealthStackedMove32 = WatsonHealthStackedMove32;
  exports.WatsonHealthStackedScrolling_116 = WatsonHealthStackedScrolling_116;
  exports.WatsonHealthStackedScrolling_120 = WatsonHealthStackedScrolling_120;
  exports.WatsonHealthStackedScrolling_124 = WatsonHealthStackedScrolling_124;
  exports.WatsonHealthStackedScrolling_132 = WatsonHealthStackedScrolling_132;
  exports.WatsonHealthStackedScrolling_216 = WatsonHealthStackedScrolling_216;
  exports.WatsonHealthStackedScrolling_220 = WatsonHealthStackedScrolling_220;
  exports.WatsonHealthStackedScrolling_224 = WatsonHealthStackedScrolling_224;
  exports.WatsonHealthStackedScrolling_232 = WatsonHealthStackedScrolling_232;
  exports.WatsonHealthStatusAcknowledge16 = WatsonHealthStatusAcknowledge16;
  exports.WatsonHealthStatusAcknowledge20 = WatsonHealthStatusAcknowledge20;
  exports.WatsonHealthStatusAcknowledge24 = WatsonHealthStatusAcknowledge24;
  exports.WatsonHealthStatusAcknowledge32 = WatsonHealthStatusAcknowledge32;
  exports.WatsonHealthStatusChange16 = WatsonHealthStatusChange16;
  exports.WatsonHealthStatusChange20 = WatsonHealthStatusChange20;
  exports.WatsonHealthStatusChange24 = WatsonHealthStatusChange24;
  exports.WatsonHealthStatusChange32 = WatsonHealthStatusChange32;
  exports.WatsonHealthStatusPartialFail16 = WatsonHealthStatusPartialFail16;
  exports.WatsonHealthStatusPartialFail20 = WatsonHealthStatusPartialFail20;
  exports.WatsonHealthStatusPartialFail24 = WatsonHealthStatusPartialFail24;
  exports.WatsonHealthStatusPartialFail32 = WatsonHealthStatusPartialFail32;
  exports.WatsonHealthStatusResolved16 = WatsonHealthStatusResolved16;
  exports.WatsonHealthStatusResolved20 = WatsonHealthStatusResolved20;
  exports.WatsonHealthStatusResolved24 = WatsonHealthStatusResolved24;
  exports.WatsonHealthStatusResolved32 = WatsonHealthStatusResolved32;
  exports.WatsonHealthStressBreathEditor16 = WatsonHealthStressBreathEditor16;
  exports.WatsonHealthStressBreathEditor20 = WatsonHealthStressBreathEditor20;
  exports.WatsonHealthStressBreathEditor24 = WatsonHealthStressBreathEditor24;
  exports.WatsonHealthStressBreathEditor32 = WatsonHealthStressBreathEditor32;
  exports.WatsonHealthStudyNext16 = WatsonHealthStudyNext16;
  exports.WatsonHealthStudyNext20 = WatsonHealthStudyNext20;
  exports.WatsonHealthStudyNext24 = WatsonHealthStudyNext24;
  exports.WatsonHealthStudyNext32 = WatsonHealthStudyNext32;
  exports.WatsonHealthStudyPrevious16 = WatsonHealthStudyPrevious16;
  exports.WatsonHealthStudyPrevious20 = WatsonHealthStudyPrevious20;
  exports.WatsonHealthStudyPrevious24 = WatsonHealthStudyPrevious24;
  exports.WatsonHealthStudyPrevious32 = WatsonHealthStudyPrevious32;
  exports.WatsonHealthStudyRead16 = WatsonHealthStudyRead16;
  exports.WatsonHealthStudyRead20 = WatsonHealthStudyRead20;
  exports.WatsonHealthStudyRead24 = WatsonHealthStudyRead24;
  exports.WatsonHealthStudyRead32 = WatsonHealthStudyRead32;
  exports.WatsonHealthStudySkip16 = WatsonHealthStudySkip16;
  exports.WatsonHealthStudySkip20 = WatsonHealthStudySkip20;
  exports.WatsonHealthStudySkip24 = WatsonHealthStudySkip24;
  exports.WatsonHealthStudySkip32 = WatsonHealthStudySkip32;
  exports.WatsonHealthStudyTransfer16 = WatsonHealthStudyTransfer16;
  exports.WatsonHealthStudyTransfer20 = WatsonHealthStudyTransfer20;
  exports.WatsonHealthStudyTransfer24 = WatsonHealthStudyTransfer24;
  exports.WatsonHealthStudyTransfer32 = WatsonHealthStudyTransfer32;
  exports.WatsonHealthStudyUnread16 = WatsonHealthStudyUnread16;
  exports.WatsonHealthStudyUnread20 = WatsonHealthStudyUnread20;
  exports.WatsonHealthStudyUnread24 = WatsonHealthStudyUnread24;
  exports.WatsonHealthStudyUnread32 = WatsonHealthStudyUnread32;
  exports.WatsonHealthStudyView16 = WatsonHealthStudyView16;
  exports.WatsonHealthStudyView20 = WatsonHealthStudyView20;
  exports.WatsonHealthStudyView24 = WatsonHealthStudyView24;
  exports.WatsonHealthStudyView32 = WatsonHealthStudyView32;
  exports.WatsonHealthSubVolume16 = WatsonHealthSubVolume16;
  exports.WatsonHealthSubVolume20 = WatsonHealthSubVolume20;
  exports.WatsonHealthSubVolume24 = WatsonHealthSubVolume24;
  exports.WatsonHealthSubVolume32 = WatsonHealthSubVolume32;
  exports.WatsonHealthTextAnnotationToggle16 = WatsonHealthTextAnnotationToggle16;
  exports.WatsonHealthTextAnnotationToggle20 = WatsonHealthTextAnnotationToggle20;
  exports.WatsonHealthTextAnnotationToggle24 = WatsonHealthTextAnnotationToggle24;
  exports.WatsonHealthTextAnnotationToggle32 = WatsonHealthTextAnnotationToggle32;
  exports.WatsonHealthThreshold16 = WatsonHealthThreshold16;
  exports.WatsonHealthThreshold20 = WatsonHealthThreshold20;
  exports.WatsonHealthThreshold24 = WatsonHealthThreshold24;
  exports.WatsonHealthThreshold32 = WatsonHealthThreshold32;
  exports.WatsonHealthThumbnailPreview16 = WatsonHealthThumbnailPreview16;
  exports.WatsonHealthThumbnailPreview20 = WatsonHealthThumbnailPreview20;
  exports.WatsonHealthThumbnailPreview24 = WatsonHealthThumbnailPreview24;
  exports.WatsonHealthThumbnailPreview32 = WatsonHealthThumbnailPreview32;
  exports.WatsonHealthWindowAuto16 = WatsonHealthWindowAuto16;
  exports.WatsonHealthWindowAuto20 = WatsonHealthWindowAuto20;
  exports.WatsonHealthWindowAuto24 = WatsonHealthWindowAuto24;
  exports.WatsonHealthWindowAuto32 = WatsonHealthWindowAuto32;
  exports.WatsonHealthWindowBase16 = WatsonHealthWindowBase16;
  exports.WatsonHealthWindowBase20 = WatsonHealthWindowBase20;
  exports.WatsonHealthWindowBase24 = WatsonHealthWindowBase24;
  exports.WatsonHealthWindowBase32 = WatsonHealthWindowBase32;
  exports.WatsonHealthWindowBlackSaturation16 = WatsonHealthWindowBlackSaturation16;
  exports.WatsonHealthWindowBlackSaturation20 = WatsonHealthWindowBlackSaturation20;
  exports.WatsonHealthWindowBlackSaturation24 = WatsonHealthWindowBlackSaturation24;
  exports.WatsonHealthWindowBlackSaturation32 = WatsonHealthWindowBlackSaturation32;
  exports.WatsonHealthWindowOverlay16 = WatsonHealthWindowOverlay16;
  exports.WatsonHealthWindowOverlay20 = WatsonHealthWindowOverlay20;
  exports.WatsonHealthWindowOverlay24 = WatsonHealthWindowOverlay24;
  exports.WatsonHealthWindowOverlay32 = WatsonHealthWindowOverlay32;
  exports.WatsonHealthWindowPreset16 = WatsonHealthWindowPreset16;
  exports.WatsonHealthWindowPreset20 = WatsonHealthWindowPreset20;
  exports.WatsonHealthWindowPreset24 = WatsonHealthWindowPreset24;
  exports.WatsonHealthWindowPreset32 = WatsonHealthWindowPreset32;
  exports.WatsonHealthZoomPan16 = WatsonHealthZoomPan16;
  exports.WatsonHealthZoomPan20 = WatsonHealthZoomPan20;
  exports.WatsonHealthZoomPan24 = WatsonHealthZoomPan24;
  exports.WatsonHealthZoomPan32 = WatsonHealthZoomPan32;
  exports.WatsonMachineLearning16 = WatsonMachineLearning16;
  exports.WatsonMachineLearning20 = WatsonMachineLearning20;
  exports.WatsonMachineLearning24 = WatsonMachineLearning24;
  exports.WatsonMachineLearning32 = WatsonMachineLearning32;
  exports.WaveDirection16 = WaveDirection16;
  exports.WaveDirection20 = WaveDirection20;
  exports.WaveDirection24 = WaveDirection24;
  exports.WaveDirection32 = WaveDirection32;
  exports.WaveHeight16 = WaveHeight16;
  exports.WaveHeight20 = WaveHeight20;
  exports.WaveHeight24 = WaveHeight24;
  exports.WaveHeight32 = WaveHeight32;
  exports.WavePeriod16 = WavePeriod16;
  exports.WavePeriod20 = WavePeriod20;
  exports.WavePeriod24 = WavePeriod24;
  exports.WavePeriod32 = WavePeriod32;
  exports.WeatherFrontCold16 = WeatherFrontCold16;
  exports.WeatherFrontCold20 = WeatherFrontCold20;
  exports.WeatherFrontCold24 = WeatherFrontCold24;
  exports.WeatherFrontCold32 = WeatherFrontCold32;
  exports.WeatherFrontStationary16 = WeatherFrontStationary16;
  exports.WeatherFrontStationary20 = WeatherFrontStationary20;
  exports.WeatherFrontStationary24 = WeatherFrontStationary24;
  exports.WeatherFrontStationary32 = WeatherFrontStationary32;
  exports.WeatherFrontWarm16 = WeatherFrontWarm16;
  exports.WeatherFrontWarm20 = WeatherFrontWarm20;
  exports.WeatherFrontWarm24 = WeatherFrontWarm24;
  exports.WeatherFrontWarm32 = WeatherFrontWarm32;
  exports.WeatherStation16 = WeatherStation16;
  exports.WeatherStation20 = WeatherStation20;
  exports.WeatherStation24 = WeatherStation24;
  exports.WeatherStation32 = WeatherStation32;
  exports.Webhook16 = Webhook16;
  exports.Webhook20 = Webhook20;
  exports.Webhook24 = Webhook24;
  exports.Webhook32 = Webhook32;
  exports.Websheet16 = Websheet16;
  exports.Websheet20 = Websheet20;
  exports.Websheet24 = Websheet24;
  exports.Websheet32 = Websheet32;
  exports.Wheat16 = Wheat16;
  exports.Wheat20 = Wheat20;
  exports.Wheat24 = Wheat24;
  exports.Wheat32 = Wheat32;
  exports.Wifi16 = Wifi16;
  exports.Wifi20 = Wifi20;
  exports.Wifi24 = Wifi24;
  exports.Wifi32 = Wifi32;
  exports.WifiBridge16 = WifiBridge16;
  exports.WifiBridge20 = WifiBridge20;
  exports.WifiBridge24 = WifiBridge24;
  exports.WifiBridge32 = WifiBridge32;
  exports.WifiBridgeAlt16 = WifiBridgeAlt16;
  exports.WifiBridgeAlt20 = WifiBridgeAlt20;
  exports.WifiBridgeAlt24 = WifiBridgeAlt24;
  exports.WifiBridgeAlt32 = WifiBridgeAlt32;
  exports.WifiController16 = WifiController16;
  exports.WifiController20 = WifiController20;
  exports.WifiController24 = WifiController24;
  exports.WifiController32 = WifiController32;
  exports.WifiNotSecure16 = WifiNotSecure16;
  exports.WifiNotSecure20 = WifiNotSecure20;
  exports.WifiNotSecure24 = WifiNotSecure24;
  exports.WifiNotSecure32 = WifiNotSecure32;
  exports.WifiOff16 = WifiOff16;
  exports.WifiOff20 = WifiOff20;
  exports.WifiOff24 = WifiOff24;
  exports.WifiOff32 = WifiOff32;
  exports.WifiSecure16 = WifiSecure16;
  exports.WifiSecure20 = WifiSecure20;
  exports.WifiSecure24 = WifiSecure24;
  exports.WifiSecure32 = WifiSecure32;
  exports.Wikis16 = Wikis16;
  exports.Wikis20 = Wikis20;
  exports.Wikis24 = Wikis24;
  exports.Wikis32 = Wikis32;
  exports.WindGusts16 = WindGusts16;
  exports.WindGusts20 = WindGusts20;
  exports.WindGusts24 = WindGusts24;
  exports.WindGusts32 = WindGusts32;
  exports.WindPower16 = WindPower16;
  exports.WindPower20 = WindPower20;
  exports.WindPower24 = WindPower24;
  exports.WindPower32 = WindPower32;
  exports.WindStream16 = WindStream16;
  exports.WindStream20 = WindStream20;
  exports.WindStream24 = WindStream24;
  exports.WindStream32 = WindStream32;
  exports.Windy16 = Windy16;
  exports.Windy20 = Windy20;
  exports.Windy24 = Windy24;
  exports.Windy32 = Windy32;
  exports.WindyDust16 = WindyDust16;
  exports.WindyDust20 = WindyDust20;
  exports.WindyDust24 = WindyDust24;
  exports.WindyDust32 = WindyDust32;
  exports.WindySnow16 = WindySnow16;
  exports.WindySnow20 = WindySnow20;
  exports.WindySnow24 = WindySnow24;
  exports.WindySnow32 = WindySnow32;
  exports.WindyStrong16 = WindyStrong16;
  exports.WindyStrong20 = WindyStrong20;
  exports.WindyStrong24 = WindyStrong24;
  exports.WindyStrong32 = WindyStrong32;
  exports.WinterWarning16 = WinterWarning16;
  exports.WinterWarning20 = WinterWarning20;
  exports.WinterWarning24 = WinterWarning24;
  exports.WinterWarning32 = WinterWarning32;
  exports.WintryMix16 = WintryMix16;
  exports.WintryMix20 = WintryMix20;
  exports.WintryMix24 = WintryMix24;
  exports.WintryMix32 = WintryMix32;
  exports.WirelessCheckout16 = WirelessCheckout16;
  exports.WirelessCheckout20 = WirelessCheckout20;
  exports.WirelessCheckout24 = WirelessCheckout24;
  exports.WirelessCheckout32 = WirelessCheckout32;
  exports.Wmv16 = Wmv16;
  exports.Wmv20 = Wmv20;
  exports.Wmv24 = Wmv24;
  exports.Wmv32 = Wmv32;
  exports.WordCloud16 = WordCloud16;
  exports.WordCloud20 = WordCloud20;
  exports.WordCloud24 = WordCloud24;
  exports.WordCloud32 = WordCloud32;
  exports.Workspace16 = Workspace16;
  exports.Workspace20 = Workspace20;
  exports.Workspace24 = Workspace24;
  exports.Workspace32 = Workspace32;
  exports.WorkspaceImport16 = WorkspaceImport16;
  exports.WorkspaceImport20 = WorkspaceImport20;
  exports.WorkspaceImport24 = WorkspaceImport24;
  exports.WorkspaceImport32 = WorkspaceImport32;
  exports.Worship16 = Worship16;
  exports.Worship20 = Worship20;
  exports.Worship24 = Worship24;
  exports.Worship32 = Worship32;
  exports.WorshipChristian16 = WorshipChristian16;
  exports.WorshipChristian20 = WorshipChristian20;
  exports.WorshipChristian24 = WorshipChristian24;
  exports.WorshipChristian32 = WorshipChristian32;
  exports.WorshipJewish16 = WorshipJewish16;
  exports.WorshipJewish20 = WorshipJewish20;
  exports.WorshipJewish24 = WorshipJewish24;
  exports.WorshipJewish32 = WorshipJewish32;
  exports.WorshipMuslim16 = WorshipMuslim16;
  exports.WorshipMuslim20 = WorshipMuslim20;
  exports.WorshipMuslim24 = WorshipMuslim24;
  exports.WorshipMuslim32 = WorshipMuslim32;
  exports.XAxis16 = XAxis16;
  exports.XAxis20 = XAxis20;
  exports.XAxis24 = XAxis24;
  exports.XAxis32 = XAxis32;
  exports.Xls16 = Xls16;
  exports.Xls20 = Xls20;
  exports.Xls24 = Xls24;
  exports.Xls32 = Xls32;
  exports.Xml16 = Xml16;
  exports.Xml20 = Xml20;
  exports.Xml24 = Xml24;
  exports.Xml32 = Xml32;
  exports.YAxis16 = YAxis16;
  exports.YAxis20 = YAxis20;
  exports.YAxis24 = YAxis24;
  exports.YAxis32 = YAxis32;
  exports.ZAxis16 = ZAxis16;
  exports.ZAxis20 = ZAxis20;
  exports.ZAxis24 = ZAxis24;
  exports.ZAxis32 = ZAxis32;
  exports.Zip16 = Zip16;
  exports.Zip20 = Zip20;
  exports.Zip24 = Zip24;
  exports.Zip32 = Zip32;
  exports.ZipReference16 = ZipReference16;
  exports.ZipReference20 = ZipReference20;
  exports.ZipReference24 = ZipReference24;
  exports.ZipReference32 = ZipReference32;
  exports.ZoomArea16 = ZoomArea16;
  exports.ZoomArea20 = ZoomArea20;
  exports.ZoomArea24 = ZoomArea24;
  exports.ZoomArea32 = ZoomArea32;
  exports.ZoomFit16 = ZoomFit16;
  exports.ZoomFit20 = ZoomFit20;
  exports.ZoomFit24 = ZoomFit24;
  exports.ZoomFit32 = ZoomFit32;
  exports.ZoomIn16 = ZoomIn16;
  exports.ZoomIn20 = ZoomIn20;
  exports.ZoomIn24 = ZoomIn24;
  exports.ZoomIn32 = ZoomIn32;
  exports.ZoomInArea16 = ZoomInArea16;
  exports.ZoomInArea20 = ZoomInArea20;
  exports.ZoomInArea24 = ZoomInArea24;
  exports.ZoomInArea32 = ZoomInArea32;
  exports.ZoomOut16 = ZoomOut16;
  exports.ZoomOut20 = ZoomOut20;
  exports.ZoomOut24 = ZoomOut24;
  exports.ZoomOut32 = ZoomOut32;
  exports.ZoomOutArea16 = ZoomOutArea16;
  exports.ZoomOutArea20 = ZoomOutArea20;
  exports.ZoomOutArea24 = ZoomOutArea24;
  exports.ZoomOutArea32 = ZoomOutArea32;
  exports.ZoomReset16 = ZoomReset16;
  exports.ZoomReset20 = ZoomReset20;
  exports.ZoomReset24 = ZoomReset24;
  exports.ZoomReset32 = ZoomReset32;
  exports._4K16 = _4K16;
  exports._4K20 = _4K20;
  exports._4K24 = _4K24;
  exports._4K32 = _4K32;
  exports._4KFilled16 = _4KFilled16;
  exports._4KFilled20 = _4KFilled20;
  exports._4KFilled24 = _4KFilled24;
  exports._4KFilled32 = _4KFilled32;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
